%------------------------------------------------------------------------------
% File     : VBT00019_4 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Definitions 00707_032605
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0063_VEBT_Definitions_00707_032605 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 12345 (4453 unt;1972 typ;   0 def)
%            Number of atoms       : 18274 (8347 equ)
%            Maximal formula atoms :   39 (   1 avg)
%            Number of connectives : 18742 (1698   ~; 310   |;2264   &)
%                                         (2148 <=>;12322  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   35 (   6 avg)
%            Maximal term depth    :   31 (   2 avg)
%            Number of FOOLs       :  825 ( 441 fml; 384 var)
%            Number of X terms     :  538 (   0  []; 475 ite;  63 let)
%            Number of types       :   12 (  11 usr)
%            Number of type conns  : 1683 (1515   >; 168   *;   0   +;   0  <<)
%            Number of predicates  :  227 ( 224 usr;   2 prp; 0-7 aty)
%            Number of functors    : 1752 (1752 usr;  52 con; 0-7 aty)
%            Number of variables   : 35670 (31577   !; 779   ?;35670   :)
%                                         (3314  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TX1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 18:00:35.882
%------------------------------------------------------------------------------
% Could-be-implicit typings (18)
tff(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

tff(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

tff(ty_t_Product__Type_Oprod,type,
    product_prod: ( $tType * $tType ) > $tType ).

tff(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

tff(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

tff(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

tff(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

tff(ty_t_String_Ochar,type,
    char: $tType ).

tff(ty_t_Real_Oreal,type,
    real: $tType ).

tff(ty_t_List_Olist,type,
    list: $tType > $tType ).

tff(ty_t_Set_Oset,type,
    set: $tType > $tType ).

tff(ty_t_Rat_Orat,type,
    rat: $tType ).

tff(ty_t_Num_Onum,type,
    num: $tType ).

tff(ty_t_Nat_Onat,type,
    nat: $tType ).

tff(ty_t_Int_Oint,type,
    int: $tType ).

tff(ty_t_itself,type,
    itself: $tType > $tType ).

tff(ty_t_fun,type,
    fun: ( $tType * $tType ) > $tType ).

tff(ty_tf_a,type,
    a: $tType ).

% Explicit typings (1954)
tff(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OInf,type,
    complete_Inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OSup,type,
    complete_Sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot1__space,type,
    topological_t1_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Oopen__uniformity,type,
    topolo569519726778239578ormity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Odiscrete__topology,type,
    topolo8865339358273720382pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__boolean__algebra,type,
    comple489889107523837845lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

tff(sy_c_ATP_058Lamp__a____,type,
    aTP_Lamp_a: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aa____,type,
    aTP_Lamp_aa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aaa____,type,
    aTP_Lamp_aaa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aab____,type,
    aTP_Lamp_aab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aac____,type,
    aTP_Lamp_aac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aad____,type,
    aTP_Lamp_aad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aae____,type,
    aTP_Lamp_aae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaf____,type,
    aTP_Lamp_aaf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aag____,type,
    aTP_Lamp_aag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aah____,type,
    aTP_Lamp_aah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aai____,type,
    aTP_Lamp_aai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaj____,type,
    aTP_Lamp_aaj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aak____,type,
    aTP_Lamp_aak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aal____,type,
    aTP_Lamp_aal: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aam____,type,
    aTP_Lamp_aam: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aan____,type,
    aTP_Lamp_aan: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aao____,type,
    aTP_Lamp_aao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aap____,type,
    aTP_Lamp_aap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaq____,type,
    aTP_Lamp_aaq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aar____,type,
    aTP_Lamp_aar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aas____,type,
    aTP_Lamp_aas: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aat____,type,
    aTP_Lamp_aat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aau____,type,
    aTP_Lamp_aau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aav____,type,
    aTP_Lamp_aav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaw____,type,
    aTP_Lamp_aaw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aax____,type,
    aTP_Lamp_aax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aay____,type,
    aTP_Lamp_aay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaz____,type,
    aTP_Lamp_aaz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ab____,type,
    aTP_Lamp_ab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aba____,type,
    aTP_Lamp_aba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abb____,type,
    aTP_Lamp_abb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abc____,type,
    aTP_Lamp_abc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abd____,type,
    aTP_Lamp_abd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abe____,type,
    aTP_Lamp_abe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abf____,type,
    aTP_Lamp_abf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abg____,type,
    aTP_Lamp_abg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abh____,type,
    aTP_Lamp_abh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abi____,type,
    aTP_Lamp_abi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abj____,type,
    aTP_Lamp_abj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abk____,type,
    aTP_Lamp_abk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abl____,type,
    aTP_Lamp_abl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abm____,type,
    aTP_Lamp_abm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abn____,type,
    aTP_Lamp_abn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abo____,type,
    aTP_Lamp_abo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abp____,type,
    aTP_Lamp_abp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abq____,type,
    aTP_Lamp_abq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abr____,type,
    aTP_Lamp_abr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abs____,type,
    aTP_Lamp_abs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abt____,type,
    aTP_Lamp_abt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abu____,type,
    aTP_Lamp_abu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abv____,type,
    aTP_Lamp_abv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abw____,type,
    aTP_Lamp_abw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abx____,type,
    aTP_Lamp_abx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aby____,type,
    aTP_Lamp_aby: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abz____,type,
    aTP_Lamp_abz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ac____,type,
    aTP_Lamp_ac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aca____,type,
    aTP_Lamp_aca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acb____,type,
    aTP_Lamp_acb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acc____,type,
    aTP_Lamp_acc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acd____,type,
    aTP_Lamp_acd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ace____,type,
    aTP_Lamp_ace: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acf____,type,
    aTP_Lamp_acf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acg____,type,
    aTP_Lamp_acg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ach____,type,
    aTP_Lamp_ach: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aci____,type,
    aTP_Lamp_aci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acj____,type,
    aTP_Lamp_acj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ack____,type,
    aTP_Lamp_ack: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acl____,type,
    aTP_Lamp_acl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acm____,type,
    aTP_Lamp_acm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acn____,type,
    aTP_Lamp_acn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aco____,type,
    aTP_Lamp_aco: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acp____,type,
    aTP_Lamp_acp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acq____,type,
    aTP_Lamp_acq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acr____,type,
    aTP_Lamp_acr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acs____,type,
    aTP_Lamp_acs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__act____,type,
    aTP_Lamp_act: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acu____,type,
    aTP_Lamp_acu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acv____,type,
    aTP_Lamp_acv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acw____,type,
    aTP_Lamp_acw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acx____,type,
    aTP_Lamp_acx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acy____,type,
    aTP_Lamp_acy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acz____,type,
    aTP_Lamp_acz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ad____,type,
    aTP_Lamp_ad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ada____,type,
    aTP_Lamp_ada: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adb____,type,
    aTP_Lamp_adb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adc____,type,
    aTP_Lamp_adc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__add____,type,
    aTP_Lamp_add: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ade____,type,
    aTP_Lamp_ade: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adf____,type,
    aTP_Lamp_adf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adg____,type,
    aTP_Lamp_adg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adh____,type,
    aTP_Lamp_adh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adi____,type,
    aTP_Lamp_adi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adj____,type,
    aTP_Lamp_adj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adk____,type,
    aTP_Lamp_adk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adl____,type,
    aTP_Lamp_adl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adm____,type,
    aTP_Lamp_adm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adn____,type,
    aTP_Lamp_adn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ado____,type,
    aTP_Lamp_ado: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adp____,type,
    aTP_Lamp_adp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adq____,type,
    aTP_Lamp_adq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adr____,type,
    aTP_Lamp_adr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ads____,type,
    aTP_Lamp_ads: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adt____,type,
    aTP_Lamp_adt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adu____,type,
    aTP_Lamp_adu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adv____,type,
    aTP_Lamp_adv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adw____,type,
    aTP_Lamp_adw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adx____,type,
    aTP_Lamp_adx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ady____,type,
    aTP_Lamp_ady: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adz____,type,
    aTP_Lamp_adz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ae____,type,
    aTP_Lamp_ae: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aea____,type,
    aTP_Lamp_aea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeb____,type,
    aTP_Lamp_aeb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aec____,type,
    aTP_Lamp_aec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aed____,type,
    aTP_Lamp_aed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aee____,type,
    aTP_Lamp_aee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aef____,type,
    aTP_Lamp_aef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeg____,type,
    aTP_Lamp_aeg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeh____,type,
    aTP_Lamp_aeh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aei____,type,
    aTP_Lamp_aei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aej____,type,
    aTP_Lamp_aej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aek____,type,
    aTP_Lamp_aek: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ael____,type,
    aTP_Lamp_ael: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aem____,type,
    aTP_Lamp_aem: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aen____,type,
    aTP_Lamp_aen: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeo____,type,
    aTP_Lamp_aeo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aep____,type,
    aTP_Lamp_aep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeq____,type,
    aTP_Lamp_aeq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aer____,type,
    aTP_Lamp_aer: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aes____,type,
    aTP_Lamp_aes: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aet____,type,
    aTP_Lamp_aet: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeu____,type,
    aTP_Lamp_aeu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aev____,type,
    aTP_Lamp_aev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aew____,type,
    aTP_Lamp_aew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aex____,type,
    aTP_Lamp_aex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aey____,type,
    aTP_Lamp_aey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aez____,type,
    aTP_Lamp_aez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__af____,type,
    aTP_Lamp_af: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afa____,type,
    aTP_Lamp_afa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afb____,type,
    aTP_Lamp_afb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afc____,type,
    aTP_Lamp_afc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afd____,type,
    aTP_Lamp_afd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afe____,type,
    aTP_Lamp_afe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aff____,type,
    aTP_Lamp_aff: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afg____,type,
    aTP_Lamp_afg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afh____,type,
    aTP_Lamp_afh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afi____,type,
    aTP_Lamp_afi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afj____,type,
    aTP_Lamp_afj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afk____,type,
    aTP_Lamp_afk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afl____,type,
    aTP_Lamp_afl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afm____,type,
    aTP_Lamp_afm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afn____,type,
    aTP_Lamp_afn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afo____,type,
    aTP_Lamp_afo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afp____,type,
    aTP_Lamp_afp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afq____,type,
    aTP_Lamp_afq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afr____,type,
    aTP_Lamp_afr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afs____,type,
    aTP_Lamp_afs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aft____,type,
    aTP_Lamp_aft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afu____,type,
    aTP_Lamp_afu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afv____,type,
    aTP_Lamp_afv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afw____,type,
    aTP_Lamp_afw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afx____,type,
    aTP_Lamp_afx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afy____,type,
    aTP_Lamp_afy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afz____,type,
    aTP_Lamp_afz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ag____,type,
    aTP_Lamp_ag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aga____,type,
    aTP_Lamp_aga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agb____,type,
    aTP_Lamp_agb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agc____,type,
    aTP_Lamp_agc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agd____,type,
    aTP_Lamp_agd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__age____,type,
    aTP_Lamp_age: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agf____,type,
    aTP_Lamp_agf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agg____,type,
    aTP_Lamp_agg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agh____,type,
    aTP_Lamp_agh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agi____,type,
    aTP_Lamp_agi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agj____,type,
    aTP_Lamp_agj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agk____,type,
    aTP_Lamp_agk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agl____,type,
    aTP_Lamp_agl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agm____,type,
    aTP_Lamp_agm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agn____,type,
    aTP_Lamp_agn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ago____,type,
    aTP_Lamp_ago: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agp____,type,
    aTP_Lamp_agp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agq____,type,
    aTP_Lamp_agq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agr____,type,
    aTP_Lamp_agr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ags____,type,
    aTP_Lamp_ags: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agt____,type,
    aTP_Lamp_agt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agu____,type,
    aTP_Lamp_agu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agv____,type,
    aTP_Lamp_agv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agw____,type,
    aTP_Lamp_agw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agx____,type,
    aTP_Lamp_agx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agy____,type,
    aTP_Lamp_agy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agz____,type,
    aTP_Lamp_agz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ah____,type,
    aTP_Lamp_ah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aha____,type,
    aTP_Lamp_aha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahb____,type,
    aTP_Lamp_ahb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahc____,type,
    aTP_Lamp_ahc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahd____,type,
    aTP_Lamp_ahd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahe____,type,
    aTP_Lamp_ahe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahf____,type,
    aTP_Lamp_ahf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahg____,type,
    aTP_Lamp_ahg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahh____,type,
    aTP_Lamp_ahh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahi____,type,
    aTP_Lamp_ahi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahj____,type,
    aTP_Lamp_ahj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahk____,type,
    aTP_Lamp_ahk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahl____,type,
    aTP_Lamp_ahl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahm____,type,
    aTP_Lamp_ahm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahn____,type,
    aTP_Lamp_ahn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aho____,type,
    aTP_Lamp_aho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahp____,type,
    aTP_Lamp_ahp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahq____,type,
    aTP_Lamp_ahq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahr____,type,
    aTP_Lamp_ahr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahs____,type,
    aTP_Lamp_ahs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aht____,type,
    aTP_Lamp_aht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahu____,type,
    aTP_Lamp_ahu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahv____,type,
    aTP_Lamp_ahv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahw____,type,
    aTP_Lamp_ahw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahx____,type,
    aTP_Lamp_ahx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahy____,type,
    aTP_Lamp_ahy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahz____,type,
    aTP_Lamp_ahz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ai____,type,
    aTP_Lamp_ai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aia____,type,
    aTP_Lamp_aia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aib____,type,
    aTP_Lamp_aib: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aic____,type,
    aTP_Lamp_aic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aid____,type,
    aTP_Lamp_aid: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aie____,type,
    aTP_Lamp_aie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aif____,type,
    aTP_Lamp_aif: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aig____,type,
    aTP_Lamp_aig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aih____,type,
    aTP_Lamp_aih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aii____,type,
    aTP_Lamp_aii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aij____,type,
    aTP_Lamp_aij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aik____,type,
    aTP_Lamp_aik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ail____,type,
    aTP_Lamp_ail: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aim____,type,
    aTP_Lamp_aim: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ain____,type,
    aTP_Lamp_ain: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aio____,type,
    aTP_Lamp_aio: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aip____,type,
    aTP_Lamp_aip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiq____,type,
    aTP_Lamp_aiq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__air____,type,
    aTP_Lamp_air: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ais____,type,
    aTP_Lamp_ais: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ait____,type,
    aTP_Lamp_ait: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiu____,type,
    aTP_Lamp_aiu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiv____,type,
    aTP_Lamp_aiv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiw____,type,
    aTP_Lamp_aiw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aix____,type,
    aTP_Lamp_aix: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiy____,type,
    aTP_Lamp_aiy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiz____,type,
    aTP_Lamp_aiz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aj____,type,
    aTP_Lamp_aj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aja____,type,
    aTP_Lamp_aja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajb____,type,
    aTP_Lamp_ajb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajc____,type,
    aTP_Lamp_ajc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajd____,type,
    aTP_Lamp_ajd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aje____,type,
    aTP_Lamp_aje: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajf____,type,
    aTP_Lamp_ajf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajg____,type,
    aTP_Lamp_ajg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajh____,type,
    aTP_Lamp_ajh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aji____,type,
    aTP_Lamp_aji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajj____,type,
    aTP_Lamp_ajj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajk____,type,
    aTP_Lamp_ajk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajl____,type,
    aTP_Lamp_ajl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajm____,type,
    aTP_Lamp_ajm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajn____,type,
    aTP_Lamp_ajn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajo____,type,
    aTP_Lamp_ajo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajp____,type,
    aTP_Lamp_ajp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajq____,type,
    aTP_Lamp_ajq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajr____,type,
    aTP_Lamp_ajr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajs____,type,
    aTP_Lamp_ajs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajt____,type,
    aTP_Lamp_ajt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aju____,type,
    aTP_Lamp_aju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajv____,type,
    aTP_Lamp_ajv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajw____,type,
    aTP_Lamp_ajw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajx____,type,
    aTP_Lamp_ajx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajy____,type,
    aTP_Lamp_ajy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajz____,type,
    aTP_Lamp_ajz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ak____,type,
    aTP_Lamp_ak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aka____,type,
    aTP_Lamp_aka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akb____,type,
    aTP_Lamp_akb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akc____,type,
    aTP_Lamp_akc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akd____,type,
    aTP_Lamp_akd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ake____,type,
    aTP_Lamp_ake: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akf____,type,
    aTP_Lamp_akf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akg____,type,
    aTP_Lamp_akg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akh____,type,
    aTP_Lamp_akh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aki____,type,
    aTP_Lamp_aki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akj____,type,
    aTP_Lamp_akj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akk____,type,
    aTP_Lamp_akk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akl____,type,
    aTP_Lamp_akl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akm____,type,
    aTP_Lamp_akm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akn____,type,
    aTP_Lamp_akn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ako____,type,
    aTP_Lamp_ako: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akp____,type,
    aTP_Lamp_akp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akq____,type,
    aTP_Lamp_akq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akr____,type,
    aTP_Lamp_akr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aks____,type,
    aTP_Lamp_aks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akt____,type,
    aTP_Lamp_akt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aku____,type,
    aTP_Lamp_aku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akv____,type,
    aTP_Lamp_akv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akw____,type,
    aTP_Lamp_akw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akx____,type,
    aTP_Lamp_akx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aky____,type,
    aTP_Lamp_aky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akz____,type,
    aTP_Lamp_akz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__al____,type,
    aTP_Lamp_al: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ala____,type,
    aTP_Lamp_ala: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alb____,type,
    aTP_Lamp_alb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alc____,type,
    aTP_Lamp_alc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ald____,type,
    aTP_Lamp_ald: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ale____,type,
    aTP_Lamp_ale: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alf____,type,
    aTP_Lamp_alf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alg____,type,
    aTP_Lamp_alg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alh____,type,
    aTP_Lamp_alh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ali____,type,
    aTP_Lamp_ali: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alj____,type,
    aTP_Lamp_alj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alk____,type,
    aTP_Lamp_alk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__all____,type,
    aTP_Lamp_all: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alm____,type,
    aTP_Lamp_alm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aln____,type,
    aTP_Lamp_aln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alo____,type,
    aTP_Lamp_alo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alp____,type,
    aTP_Lamp_alp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alq____,type,
    aTP_Lamp_alq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alr____,type,
    aTP_Lamp_alr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__als____,type,
    aTP_Lamp_als: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alt____,type,
    aTP_Lamp_alt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alu____,type,
    aTP_Lamp_alu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alv____,type,
    aTP_Lamp_alv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alw____,type,
    aTP_Lamp_alw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alx____,type,
    aTP_Lamp_alx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aly____,type,
    aTP_Lamp_aly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alz____,type,
    aTP_Lamp_alz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__am____,type,
    aTP_Lamp_am: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ama____,type,
    aTP_Lamp_ama: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amb____,type,
    aTP_Lamp_amb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amc____,type,
    aTP_Lamp_amc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amd____,type,
    aTP_Lamp_amd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ame____,type,
    aTP_Lamp_ame: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amf____,type,
    aTP_Lamp_amf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amg____,type,
    aTP_Lamp_amg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amh____,type,
    aTP_Lamp_amh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ami____,type,
    aTP_Lamp_ami: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amj____,type,
    aTP_Lamp_amj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amk____,type,
    aTP_Lamp_amk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aml____,type,
    aTP_Lamp_aml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amm____,type,
    aTP_Lamp_amm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amn____,type,
    aTP_Lamp_amn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amo____,type,
    aTP_Lamp_amo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amp____,type,
    aTP_Lamp_amp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amq____,type,
    aTP_Lamp_amq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amr____,type,
    aTP_Lamp_amr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ams____,type,
    aTP_Lamp_ams: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amt____,type,
    aTP_Lamp_amt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amu____,type,
    aTP_Lamp_amu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__amv____,type,
    aTP_Lamp_amv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amw____,type,
    aTP_Lamp_amw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amx____,type,
    aTP_Lamp_amx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amy____,type,
    aTP_Lamp_amy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__amz____,type,
    aTP_Lamp_amz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__an____,type,
    aTP_Lamp_an: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ana____,type,
    aTP_Lamp_ana: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anb____,type,
    aTP_Lamp_anb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anc____,type,
    aTP_Lamp_anc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__and____,type,
    aTP_Lamp_and: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ane____,type,
    aTP_Lamp_ane: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anf____,type,
    aTP_Lamp_anf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ang____,type,
    aTP_Lamp_ang: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__anh____,type,
    aTP_Lamp_anh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ani____,type,
    aTP_Lamp_ani: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anj____,type,
    aTP_Lamp_anj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ank____,type,
    aTP_Lamp_ank: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anl____,type,
    aTP_Lamp_anl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__anm____,type,
    aTP_Lamp_anm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ann____,type,
    aTP_Lamp_ann: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ano____,type,
    aTP_Lamp_ano: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anp____,type,
    aTP_Lamp_anp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anq____,type,
    aTP_Lamp_anq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anr____,type,
    aTP_Lamp_anr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ans____,type,
    aTP_Lamp_ans: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ant____,type,
    aTP_Lamp_ant: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anu____,type,
    aTP_Lamp_anu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anv____,type,
    aTP_Lamp_anv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anw____,type,
    aTP_Lamp_anw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anx____,type,
    aTP_Lamp_anx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__any____,type,
    aTP_Lamp_any: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__anz____,type,
    aTP_Lamp_anz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ao____,type,
    aTP_Lamp_ao: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aoa____,type,
    aTP_Lamp_aoa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aob____,type,
    aTP_Lamp_aob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoc____,type,
    aTP_Lamp_aoc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aod____,type,
    aTP_Lamp_aod: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoe____,type,
    aTP_Lamp_aoe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aof____,type,
    aTP_Lamp_aof: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aog____,type,
    aTP_Lamp_aog: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoh____,type,
    aTP_Lamp_aoh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoi____,type,
    aTP_Lamp_aoi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoj____,type,
    aTP_Lamp_aoj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aok____,type,
    aTP_Lamp_aok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aol____,type,
    aTP_Lamp_aol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aom____,type,
    aTP_Lamp_aom: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aon____,type,
    aTP_Lamp_aon: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoo____,type,
    aTP_Lamp_aoo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aop____,type,
    aTP_Lamp_aop: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoq____,type,
    aTP_Lamp_aoq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aor____,type,
    aTP_Lamp_aor: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aos____,type,
    aTP_Lamp_aos: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aot____,type,
    aTP_Lamp_aot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aou____,type,
    aTP_Lamp_aou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aov____,type,
    aTP_Lamp_aov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aow____,type,
    aTP_Lamp_aow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aox____,type,
    aTP_Lamp_aox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoy____,type,
    aTP_Lamp_aoy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aoz____,type,
    aTP_Lamp_aoz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ap____,type,
    aTP_Lamp_ap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apa____,type,
    aTP_Lamp_apa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apb____,type,
    aTP_Lamp_apb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apc____,type,
    aTP_Lamp_apc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apd____,type,
    aTP_Lamp_apd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ape____,type,
    aTP_Lamp_ape: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apf____,type,
    aTP_Lamp_apf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apg____,type,
    aTP_Lamp_apg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aph____,type,
    aTP_Lamp_aph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__api____,type,
    aTP_Lamp_api: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apj____,type,
    aTP_Lamp_apj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apk____,type,
    aTP_Lamp_apk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apl____,type,
    aTP_Lamp_apl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apm____,type,
    aTP_Lamp_apm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apn____,type,
    aTP_Lamp_apn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apo____,type,
    aTP_Lamp_apo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__app____,type,
    aTP_Lamp_app: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apq____,type,
    aTP_Lamp_apq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apr____,type,
    aTP_Lamp_apr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aps____,type,
    aTP_Lamp_aps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apt____,type,
    aTP_Lamp_apt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apu____,type,
    aTP_Lamp_apu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apv____,type,
    aTP_Lamp_apv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apw____,type,
    aTP_Lamp_apw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apx____,type,
    aTP_Lamp_apx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apy____,type,
    aTP_Lamp_apy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__apz____,type,
    aTP_Lamp_apz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aq____,type,
    aTP_Lamp_aq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aqa____,type,
    aTP_Lamp_aqa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqb____,type,
    aTP_Lamp_aqb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqc____,type,
    aTP_Lamp_aqc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqd____,type,
    aTP_Lamp_aqd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqe____,type,
    aTP_Lamp_aqe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqf____,type,
    aTP_Lamp_aqf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqg____,type,
    aTP_Lamp_aqg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqh____,type,
    aTP_Lamp_aqh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqi____,type,
    aTP_Lamp_aqi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqj____,type,
    aTP_Lamp_aqj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqk____,type,
    aTP_Lamp_aqk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aql____,type,
    aTP_Lamp_aql: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqm____,type,
    aTP_Lamp_aqm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqn____,type,
    aTP_Lamp_aqn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqo____,type,
    aTP_Lamp_aqo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqp____,type,
    aTP_Lamp_aqp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqq____,type,
    aTP_Lamp_aqq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqr____,type,
    aTP_Lamp_aqr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqs____,type,
    aTP_Lamp_aqs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqt____,type,
    aTP_Lamp_aqt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqu____,type,
    aTP_Lamp_aqu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqv____,type,
    aTP_Lamp_aqv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqw____,type,
    aTP_Lamp_aqw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqx____,type,
    aTP_Lamp_aqx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqy____,type,
    aTP_Lamp_aqy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aqz____,type,
    aTP_Lamp_aqz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ar____,type,
    aTP_Lamp_ar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ara____,type,
    aTP_Lamp_ara: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arb____,type,
    aTP_Lamp_arb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arc____,type,
    aTP_Lamp_arc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ard____,type,
    aTP_Lamp_ard: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__are____,type,
    aTP_Lamp_are: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arf____,type,
    aTP_Lamp_arf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arg____,type,
    aTP_Lamp_arg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arh____,type,
    aTP_Lamp_arh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ari____,type,
    aTP_Lamp_ari: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arj____,type,
    aTP_Lamp_arj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ark____,type,
    aTP_Lamp_ark: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arl____,type,
    aTP_Lamp_arl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arm____,type,
    aTP_Lamp_arm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arn____,type,
    aTP_Lamp_arn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aro____,type,
    aTP_Lamp_aro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arp____,type,
    aTP_Lamp_arp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arq____,type,
    aTP_Lamp_arq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arr____,type,
    aTP_Lamp_arr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ars____,type,
    aTP_Lamp_ars: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__art____,type,
    aTP_Lamp_art: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aru____,type,
    aTP_Lamp_aru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arv____,type,
    aTP_Lamp_arv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arw____,type,
    aTP_Lamp_arw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arx____,type,
    aTP_Lamp_arx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ary____,type,
    aTP_Lamp_ary: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__arz____,type,
    aTP_Lamp_arz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__as____,type,
    aTP_Lamp_as: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asa____,type,
    aTP_Lamp_asa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asb____,type,
    aTP_Lamp_asb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__asc____,type,
    aTP_Lamp_asc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asd____,type,
    aTP_Lamp_asd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ase____,type,
    aTP_Lamp_ase: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asf____,type,
    aTP_Lamp_asf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asg____,type,
    aTP_Lamp_asg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ash____,type,
    aTP_Lamp_ash: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asi____,type,
    aTP_Lamp_asi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asj____,type,
    aTP_Lamp_asj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ask____,type,
    aTP_Lamp_ask: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__asl____,type,
    aTP_Lamp_asl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__asm____,type,
    aTP_Lamp_asm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asn____,type,
    aTP_Lamp_asn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aso____,type,
    aTP_Lamp_aso: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asp____,type,
    aTP_Lamp_asp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asq____,type,
    aTP_Lamp_asq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asr____,type,
    aTP_Lamp_asr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ass____,type,
    aTP_Lamp_ass: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ast____,type,
    aTP_Lamp_ast: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asu____,type,
    aTP_Lamp_asu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asv____,type,
    aTP_Lamp_asv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asw____,type,
    aTP_Lamp_asw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asx____,type,
    aTP_Lamp_asx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asy____,type,
    aTP_Lamp_asy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__asz____,type,
    aTP_Lamp_asz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__at____,type,
    aTP_Lamp_at: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ata____,type,
    aTP_Lamp_ata: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atb____,type,
    aTP_Lamp_atb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atc____,type,
    aTP_Lamp_atc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atd____,type,
    aTP_Lamp_atd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ate____,type,
    aTP_Lamp_ate: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atf____,type,
    aTP_Lamp_atf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atg____,type,
    aTP_Lamp_atg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ath____,type,
    aTP_Lamp_ath: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ati____,type,
    aTP_Lamp_ati: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atj____,type,
    aTP_Lamp_atj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atk____,type,
    aTP_Lamp_atk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atl____,type,
    aTP_Lamp_atl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atm____,type,
    aTP_Lamp_atm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atn____,type,
    aTP_Lamp_atn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ato____,type,
    aTP_Lamp_ato: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atp____,type,
    aTP_Lamp_atp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atq____,type,
    aTP_Lamp_atq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atr____,type,
    aTP_Lamp_atr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ats____,type,
    aTP_Lamp_ats: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__att____,type,
    aTP_Lamp_att: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atu____,type,
    aTP_Lamp_atu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atv____,type,
    aTP_Lamp_atv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atw____,type,
    aTP_Lamp_atw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atx____,type,
    aTP_Lamp_atx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aty____,type,
    aTP_Lamp_aty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__atz____,type,
    aTP_Lamp_atz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__au____,type,
    aTP_Lamp_au: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aua____,type,
    aTP_Lamp_aua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aub____,type,
    aTP_Lamp_aub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auc____,type,
    aTP_Lamp_auc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aud____,type,
    aTP_Lamp_aud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aue____,type,
    aTP_Lamp_aue: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auf____,type,
    aTP_Lamp_auf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aug____,type,
    aTP_Lamp_aug: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auh____,type,
    aTP_Lamp_auh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aui____,type,
    aTP_Lamp_aui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auj____,type,
    aTP_Lamp_auj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auk____,type,
    aTP_Lamp_auk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aul____,type,
    aTP_Lamp_aul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aum____,type,
    aTP_Lamp_aum: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aun____,type,
    aTP_Lamp_aun: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auo____,type,
    aTP_Lamp_auo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aup____,type,
    aTP_Lamp_aup: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auq____,type,
    aTP_Lamp_auq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aur____,type,
    aTP_Lamp_aur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aus____,type,
    aTP_Lamp_aus: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aut____,type,
    aTP_Lamp_aut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auu____,type,
    aTP_Lamp_auu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auv____,type,
    aTP_Lamp_auv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auw____,type,
    aTP_Lamp_auw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aux____,type,
    aTP_Lamp_aux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auy____,type,
    aTP_Lamp_auy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__auz____,type,
    aTP_Lamp_auz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__av____,type,
    aTP_Lamp_av: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ava____,type,
    aTP_Lamp_ava: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avb____,type,
    aTP_Lamp_avb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avc____,type,
    aTP_Lamp_avc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avd____,type,
    aTP_Lamp_avd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ave____,type,
    aTP_Lamp_ave: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avf____,type,
    aTP_Lamp_avf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avg____,type,
    aTP_Lamp_avg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avh____,type,
    aTP_Lamp_avh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avi____,type,
    aTP_Lamp_avi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avj____,type,
    aTP_Lamp_avj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avk____,type,
    aTP_Lamp_avk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avl____,type,
    aTP_Lamp_avl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avm____,type,
    aTP_Lamp_avm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avn____,type,
    aTP_Lamp_avn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avo____,type,
    aTP_Lamp_avo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avp____,type,
    aTP_Lamp_avp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avq____,type,
    aTP_Lamp_avq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avr____,type,
    aTP_Lamp_avr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avs____,type,
    aTP_Lamp_avs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avt____,type,
    aTP_Lamp_avt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avu____,type,
    aTP_Lamp_avu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avv____,type,
    aTP_Lamp_avv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avw____,type,
    aTP_Lamp_avw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avx____,type,
    aTP_Lamp_avx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avy____,type,
    aTP_Lamp_avy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__avz____,type,
    aTP_Lamp_avz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aw____,type,
    aTP_Lamp_aw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awa____,type,
    aTP_Lamp_awa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awb____,type,
    aTP_Lamp_awb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awc____,type,
    aTP_Lamp_awc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awd____,type,
    aTP_Lamp_awd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awe____,type,
    aTP_Lamp_awe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awf____,type,
    aTP_Lamp_awf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awg____,type,
    aTP_Lamp_awg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awh____,type,
    aTP_Lamp_awh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awi____,type,
    aTP_Lamp_awi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awj____,type,
    aTP_Lamp_awj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awk____,type,
    aTP_Lamp_awk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awl____,type,
    aTP_Lamp_awl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awm____,type,
    aTP_Lamp_awm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awn____,type,
    aTP_Lamp_awn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awo____,type,
    aTP_Lamp_awo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awp____,type,
    aTP_Lamp_awp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awq____,type,
    aTP_Lamp_awq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awr____,type,
    aTP_Lamp_awr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aws____,type,
    aTP_Lamp_aws: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awt____,type,
    aTP_Lamp_awt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awu____,type,
    aTP_Lamp_awu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awv____,type,
    aTP_Lamp_awv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aww____,type,
    aTP_Lamp_aww: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awx____,type,
    aTP_Lamp_awx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__awy____,type,
    aTP_Lamp_awy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__awz____,type,
    aTP_Lamp_awz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ax____,type,
    aTP_Lamp_ax: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axa____,type,
    aTP_Lamp_axa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axb____,type,
    aTP_Lamp_axb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axc____,type,
    aTP_Lamp_axc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axd____,type,
    aTP_Lamp_axd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axe____,type,
    aTP_Lamp_axe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axf____,type,
    aTP_Lamp_axf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axg____,type,
    aTP_Lamp_axg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axh____,type,
    aTP_Lamp_axh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axi____,type,
    aTP_Lamp_axi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axj____,type,
    aTP_Lamp_axj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axk____,type,
    aTP_Lamp_axk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axl____,type,
    aTP_Lamp_axl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axm____,type,
    aTP_Lamp_axm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axn____,type,
    aTP_Lamp_axn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axo____,type,
    aTP_Lamp_axo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axp____,type,
    aTP_Lamp_axp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axq____,type,
    aTP_Lamp_axq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axr____,type,
    aTP_Lamp_axr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axs____,type,
    aTP_Lamp_axs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__axt____,type,
    aTP_Lamp_axt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axu____,type,
    aTP_Lamp_axu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axv____,type,
    aTP_Lamp_axv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axw____,type,
    aTP_Lamp_axw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axx____,type,
    aTP_Lamp_axx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axy____,type,
    aTP_Lamp_axy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__axz____,type,
    aTP_Lamp_axz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ay____,type,
    aTP_Lamp_ay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aya____,type,
    aTP_Lamp_aya: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayb____,type,
    aTP_Lamp_ayb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayc____,type,
    aTP_Lamp_ayc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayd____,type,
    aTP_Lamp_ayd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aye____,type,
    aTP_Lamp_aye: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayf____,type,
    aTP_Lamp_ayf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayg____,type,
    aTP_Lamp_ayg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayh____,type,
    aTP_Lamp_ayh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayi____,type,
    aTP_Lamp_ayi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayj____,type,
    aTP_Lamp_ayj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayk____,type,
    aTP_Lamp_ayk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayl____,type,
    aTP_Lamp_ayl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aym____,type,
    aTP_Lamp_aym: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayn____,type,
    aTP_Lamp_ayn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayo____,type,
    aTP_Lamp_ayo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayp____,type,
    aTP_Lamp_ayp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayq____,type,
    aTP_Lamp_ayq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayr____,type,
    aTP_Lamp_ayr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ays____,type,
    aTP_Lamp_ays: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayt____,type,
    aTP_Lamp_ayt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayu____,type,
    aTP_Lamp_ayu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayv____,type,
    aTP_Lamp_ayv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ayw____,type,
    aTP_Lamp_ayw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayx____,type,
    aTP_Lamp_ayx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayy____,type,
    aTP_Lamp_ayy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ayz____,type,
    aTP_Lamp_ayz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__az____,type,
    aTP_Lamp_az: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aza____,type,
    aTP_Lamp_aza: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azb____,type,
    aTP_Lamp_azb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azc____,type,
    aTP_Lamp_azc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azd____,type,
    aTP_Lamp_azd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aze____,type,
    aTP_Lamp_aze: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azf____,type,
    aTP_Lamp_azf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azg____,type,
    aTP_Lamp_azg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azh____,type,
    aTP_Lamp_azh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azi____,type,
    aTP_Lamp_azi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azj____,type,
    aTP_Lamp_azj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azk____,type,
    aTP_Lamp_azk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azl____,type,
    aTP_Lamp_azl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azm____,type,
    aTP_Lamp_azm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azn____,type,
    aTP_Lamp_azn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azo____,type,
    aTP_Lamp_azo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azp____,type,
    aTP_Lamp_azp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__azq____,type,
    aTP_Lamp_azq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azr____,type,
    aTP_Lamp_azr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azs____,type,
    aTP_Lamp_azs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azt____,type,
    aTP_Lamp_azt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azu____,type,
    aTP_Lamp_azu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azv____,type,
    aTP_Lamp_azv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azw____,type,
    aTP_Lamp_azw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azx____,type,
    aTP_Lamp_azx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azy____,type,
    aTP_Lamp_azy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__azz____,type,
    aTP_Lamp_azz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ba____,type,
    aTP_Lamp_ba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baa____,type,
    aTP_Lamp_baa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bab____,type,
    aTP_Lamp_bab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bac____,type,
    aTP_Lamp_bac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bad____,type,
    aTP_Lamp_bad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bae____,type,
    aTP_Lamp_bae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baf____,type,
    aTP_Lamp_baf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bag____,type,
    aTP_Lamp_bag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bah____,type,
    aTP_Lamp_bah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bai____,type,
    aTP_Lamp_bai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baj____,type,
    aTP_Lamp_baj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bak____,type,
    aTP_Lamp_bak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bal____,type,
    aTP_Lamp_bal: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bam____,type,
    aTP_Lamp_bam: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ban____,type,
    aTP_Lamp_ban: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bao____,type,
    aTP_Lamp_bao: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bap____,type,
    aTP_Lamp_bap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baq____,type,
    aTP_Lamp_baq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bar____,type,
    aTP_Lamp_bar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bas____,type,
    aTP_Lamp_bas: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bat____,type,
    aTP_Lamp_bat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bau____,type,
    aTP_Lamp_bau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bav____,type,
    aTP_Lamp_bav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baw____,type,
    aTP_Lamp_baw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bax____,type,
    aTP_Lamp_bax: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bay____,type,
    aTP_Lamp_bay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__baz____,type,
    aTP_Lamp_baz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bb____,type,
    aTP_Lamp_bb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bba____,type,
    aTP_Lamp_bba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbb____,type,
    aTP_Lamp_bbb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbc____,type,
    aTP_Lamp_bbc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bbd____,type,
    aTP_Lamp_bbd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbe____,type,
    aTP_Lamp_bbe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbf____,type,
    aTP_Lamp_bbf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbg____,type,
    aTP_Lamp_bbg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbh____,type,
    aTP_Lamp_bbh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bbi____,type,
    aTP_Lamp_bbi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bbj____,type,
    aTP_Lamp_bbj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbk____,type,
    aTP_Lamp_bbk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbl____,type,
    aTP_Lamp_bbl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbm____,type,
    aTP_Lamp_bbm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbn____,type,
    aTP_Lamp_bbn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbo____,type,
    aTP_Lamp_bbo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbp____,type,
    aTP_Lamp_bbp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbq____,type,
    aTP_Lamp_bbq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bbr____,type,
    aTP_Lamp_bbr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bbs____,type,
    aTP_Lamp_bbs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bc____,type,
    aTP_Lamp_bc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bd____,type,
    aTP_Lamp_bd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__be____,type,
    aTP_Lamp_be: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bf____,type,
    aTP_Lamp_bf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bg____,type,
    aTP_Lamp_bg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bh____,type,
    aTP_Lamp_bh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bi____,type,
    aTP_Lamp_bi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bj____,type,
    aTP_Lamp_bj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bk____,type,
    aTP_Lamp_bk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bl____,type,
    aTP_Lamp_bl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bm____,type,
    aTP_Lamp_bm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bn____,type,
    aTP_Lamp_bn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bo____,type,
    aTP_Lamp_bo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bp____,type,
    aTP_Lamp_bp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bq____,type,
    aTP_Lamp_bq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__br____,type,
    aTP_Lamp_br: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bs____,type,
    aTP_Lamp_bs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bt____,type,
    aTP_Lamp_bt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bu____,type,
    aTP_Lamp_bu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bv____,type,
    aTP_Lamp_bv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bw____,type,
    aTP_Lamp_bw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bx____,type,
    aTP_Lamp_bx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__by____,type,
    aTP_Lamp_by: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bz____,type,
    aTP_Lamp_bz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ca____,type,
    aTP_Lamp_ca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cb____,type,
    aTP_Lamp_cb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cc____,type,
    aTP_Lamp_cc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cd____,type,
    aTP_Lamp_cd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ce____,type,
    aTP_Lamp_ce: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cf____,type,
    aTP_Lamp_cf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cg____,type,
    aTP_Lamp_cg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ch____,type,
    aTP_Lamp_ch: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ci____,type,
    aTP_Lamp_ci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cj____,type,
    aTP_Lamp_cj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ck____,type,
    aTP_Lamp_ck: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cl____,type,
    aTP_Lamp_cl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cm____,type,
    aTP_Lamp_cm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cn____,type,
    aTP_Lamp_cn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__co____,type,
    aTP_Lamp_co: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cp____,type,
    aTP_Lamp_cp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cq____,type,
    aTP_Lamp_cq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cr____,type,
    aTP_Lamp_cr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cs____,type,
    aTP_Lamp_cs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ct____,type,
    aTP_Lamp_ct: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cu____,type,
    aTP_Lamp_cu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cv____,type,
    aTP_Lamp_cv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cw____,type,
    aTP_Lamp_cw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cx____,type,
    aTP_Lamp_cx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cy____,type,
    aTP_Lamp_cy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cz____,type,
    aTP_Lamp_cz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__da____,type,
    aTP_Lamp_da: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__db____,type,
    aTP_Lamp_db: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dc____,type,
    aTP_Lamp_dc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dd____,type,
    aTP_Lamp_dd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__de____,type,
    aTP_Lamp_de: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__df____,type,
    aTP_Lamp_df: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dg____,type,
    aTP_Lamp_dg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dh____,type,
    aTP_Lamp_dh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__di____,type,
    aTP_Lamp_di: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dj____,type,
    aTP_Lamp_dj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dk____,type,
    aTP_Lamp_dk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dl____,type,
    aTP_Lamp_dl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dm____,type,
    aTP_Lamp_dm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dn____,type,
    aTP_Lamp_dn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__do____,type,
    aTP_Lamp_do: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dp____,type,
    aTP_Lamp_dp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dq____,type,
    aTP_Lamp_dq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dr____,type,
    aTP_Lamp_dr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ds____,type,
    aTP_Lamp_ds: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dt____,type,
    aTP_Lamp_dt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__du____,type,
    aTP_Lamp_du: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dv____,type,
    aTP_Lamp_dv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dw____,type,
    aTP_Lamp_dw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dx____,type,
    aTP_Lamp_dx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dy____,type,
    aTP_Lamp_dy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dz____,type,
    aTP_Lamp_dz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ea____,type,
    aTP_Lamp_ea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eb____,type,
    aTP_Lamp_eb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ec____,type,
    aTP_Lamp_ec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ed____,type,
    aTP_Lamp_ed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ee____,type,
    aTP_Lamp_ee: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ef____,type,
    aTP_Lamp_ef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eg____,type,
    aTP_Lamp_eg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__eh____,type,
    aTP_Lamp_eh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ei____,type,
    aTP_Lamp_ei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ej____,type,
    aTP_Lamp_ej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ek____,type,
    aTP_Lamp_ek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__el____,type,
    aTP_Lamp_el: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__em____,type,
    aTP_Lamp_em: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__en____,type,
    aTP_Lamp_en: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eo____,type,
    aTP_Lamp_eo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ep____,type,
    aTP_Lamp_ep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eq____,type,
    aTP_Lamp_eq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__er____,type,
    aTP_Lamp_er: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__es____,type,
    aTP_Lamp_es: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__et____,type,
    aTP_Lamp_et: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eu____,type,
    aTP_Lamp_eu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ev____,type,
    aTP_Lamp_ev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ew____,type,
    aTP_Lamp_ew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ex____,type,
    aTP_Lamp_ex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ey____,type,
    aTP_Lamp_ey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ez____,type,
    aTP_Lamp_ez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fa____,type,
    aTP_Lamp_fa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fb____,type,
    aTP_Lamp_fb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fc____,type,
    aTP_Lamp_fc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fd____,type,
    aTP_Lamp_fd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fe____,type,
    aTP_Lamp_fe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ff____,type,
    aTP_Lamp_ff: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fg____,type,
    aTP_Lamp_fg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fh____,type,
    aTP_Lamp_fh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fi____,type,
    aTP_Lamp_fi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fj____,type,
    aTP_Lamp_fj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fk____,type,
    aTP_Lamp_fk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fl____,type,
    aTP_Lamp_fl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fm____,type,
    aTP_Lamp_fm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fn____,type,
    aTP_Lamp_fn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fo____,type,
    aTP_Lamp_fo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fp____,type,
    aTP_Lamp_fp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fq____,type,
    aTP_Lamp_fq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fr____,type,
    aTP_Lamp_fr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fs____,type,
    aTP_Lamp_fs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ft____,type,
    aTP_Lamp_ft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fu____,type,
    aTP_Lamp_fu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fv____,type,
    aTP_Lamp_fv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fw____,type,
    aTP_Lamp_fw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fx____,type,
    aTP_Lamp_fx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fy____,type,
    aTP_Lamp_fy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fz____,type,
    aTP_Lamp_fz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ga____,type,
    aTP_Lamp_ga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gb____,type,
    aTP_Lamp_gb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gc____,type,
    aTP_Lamp_gc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gd____,type,
    aTP_Lamp_gd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ge____,type,
    aTP_Lamp_ge: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gf____,type,
    aTP_Lamp_gf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gg____,type,
    aTP_Lamp_gg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gh____,type,
    aTP_Lamp_gh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gi____,type,
    aTP_Lamp_gi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gj____,type,
    aTP_Lamp_gj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gk____,type,
    aTP_Lamp_gk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gl____,type,
    aTP_Lamp_gl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gm____,type,
    aTP_Lamp_gm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gn____,type,
    aTP_Lamp_gn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__go____,type,
    aTP_Lamp_go: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gp____,type,
    aTP_Lamp_gp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gq____,type,
    aTP_Lamp_gq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gr____,type,
    aTP_Lamp_gr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gs____,type,
    aTP_Lamp_gs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gt____,type,
    aTP_Lamp_gt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gu____,type,
    aTP_Lamp_gu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gv____,type,
    aTP_Lamp_gv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gw____,type,
    aTP_Lamp_gw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gx____,type,
    aTP_Lamp_gx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gy____,type,
    aTP_Lamp_gy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gz____,type,
    aTP_Lamp_gz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ha____,type,
    aTP_Lamp_ha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hb____,type,
    aTP_Lamp_hb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hc____,type,
    aTP_Lamp_hc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hd____,type,
    aTP_Lamp_hd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__he____,type,
    aTP_Lamp_he: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hf____,type,
    aTP_Lamp_hf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hg____,type,
    aTP_Lamp_hg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hh____,type,
    aTP_Lamp_hh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hi____,type,
    aTP_Lamp_hi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hj____,type,
    aTP_Lamp_hj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hk____,type,
    aTP_Lamp_hk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hl____,type,
    aTP_Lamp_hl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hm____,type,
    aTP_Lamp_hm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hn____,type,
    aTP_Lamp_hn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ho____,type,
    aTP_Lamp_ho: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hp____,type,
    aTP_Lamp_hp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hq____,type,
    aTP_Lamp_hq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hr____,type,
    aTP_Lamp_hr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hs____,type,
    aTP_Lamp_hs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ht____,type,
    aTP_Lamp_ht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hu____,type,
    aTP_Lamp_hu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hv____,type,
    aTP_Lamp_hv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hw____,type,
    aTP_Lamp_hw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hx____,type,
    aTP_Lamp_hx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hy____,type,
    aTP_Lamp_hy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hz____,type,
    aTP_Lamp_hz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ia____,type,
    aTP_Lamp_ia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ib____,type,
    aTP_Lamp_ib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ic____,type,
    aTP_Lamp_ic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__id____,type,
    aTP_Lamp_id: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ie____,type,
    aTP_Lamp_ie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__if____,type,
    aTP_Lamp_if: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ig____,type,
    aTP_Lamp_ig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ih____,type,
    aTP_Lamp_ih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ii____,type,
    aTP_Lamp_ii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ij____,type,
    aTP_Lamp_ij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ik____,type,
    aTP_Lamp_ik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__il____,type,
    aTP_Lamp_il: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__im____,type,
    aTP_Lamp_im: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__in____,type,
    aTP_Lamp_in: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__io____,type,
    aTP_Lamp_io: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ip____,type,
    aTP_Lamp_ip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iq____,type,
    aTP_Lamp_iq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ir____,type,
    aTP_Lamp_ir: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__is____,type,
    aTP_Lamp_is: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__it____,type,
    aTP_Lamp_it: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iu____,type,
    aTP_Lamp_iu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iv____,type,
    aTP_Lamp_iv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iw____,type,
    aTP_Lamp_iw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ix____,type,
    aTP_Lamp_ix: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iy____,type,
    aTP_Lamp_iy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iz____,type,
    aTP_Lamp_iz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ja____,type,
    aTP_Lamp_ja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jb____,type,
    aTP_Lamp_jb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jc____,type,
    aTP_Lamp_jc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jd____,type,
    aTP_Lamp_jd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__je____,type,
    aTP_Lamp_je: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jf____,type,
    aTP_Lamp_jf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jg____,type,
    aTP_Lamp_jg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jh____,type,
    aTP_Lamp_jh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ji____,type,
    aTP_Lamp_ji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jj____,type,
    aTP_Lamp_jj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jk____,type,
    aTP_Lamp_jk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jl____,type,
    aTP_Lamp_jl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jm____,type,
    aTP_Lamp_jm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jn____,type,
    aTP_Lamp_jn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jo____,type,
    aTP_Lamp_jo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jp____,type,
    aTP_Lamp_jp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jq____,type,
    aTP_Lamp_jq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jr____,type,
    aTP_Lamp_jr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__js____,type,
    aTP_Lamp_js: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jt____,type,
    aTP_Lamp_jt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ju____,type,
    aTP_Lamp_ju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jv____,type,
    aTP_Lamp_jv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jw____,type,
    aTP_Lamp_jw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jx____,type,
    aTP_Lamp_jx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jy____,type,
    aTP_Lamp_jy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jz____,type,
    aTP_Lamp_jz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ka____,type,
    aTP_Lamp_ka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kb____,type,
    aTP_Lamp_kb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kc____,type,
    aTP_Lamp_kc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kd____,type,
    aTP_Lamp_kd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ke____,type,
    aTP_Lamp_ke: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kf____,type,
    aTP_Lamp_kf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kg____,type,
    aTP_Lamp_kg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kh____,type,
    aTP_Lamp_kh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ki____,type,
    aTP_Lamp_ki: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__kj____,type,
    aTP_Lamp_kj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__kk____,type,
    aTP_Lamp_kk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kl____,type,
    aTP_Lamp_kl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__km____,type,
    aTP_Lamp_km: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kn____,type,
    aTP_Lamp_kn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ko____,type,
    aTP_Lamp_ko: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kp____,type,
    aTP_Lamp_kp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kq____,type,
    aTP_Lamp_kq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kr____,type,
    aTP_Lamp_kr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ks____,type,
    aTP_Lamp_ks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kt____,type,
    aTP_Lamp_kt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ku____,type,
    aTP_Lamp_ku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kv____,type,
    aTP_Lamp_kv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kw____,type,
    aTP_Lamp_kw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kx____,type,
    aTP_Lamp_kx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ky____,type,
    aTP_Lamp_ky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kz____,type,
    aTP_Lamp_kz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__la____,type,
    aTP_Lamp_la: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lb____,type,
    aTP_Lamp_lb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lc____,type,
    aTP_Lamp_lc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ld____,type,
    aTP_Lamp_ld: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__le____,type,
    aTP_Lamp_le: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lf____,type,
    aTP_Lamp_lf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lg____,type,
    aTP_Lamp_lg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lh____,type,
    aTP_Lamp_lh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__li____,type,
    aTP_Lamp_li: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lj____,type,
    aTP_Lamp_lj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lk____,type,
    aTP_Lamp_lk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ll____,type,
    aTP_Lamp_ll: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lm____,type,
    aTP_Lamp_lm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ln____,type,
    aTP_Lamp_ln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lo____,type,
    aTP_Lamp_lo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lp____,type,
    aTP_Lamp_lp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lq____,type,
    aTP_Lamp_lq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lr____,type,
    aTP_Lamp_lr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ls____,type,
    aTP_Lamp_ls: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lt____,type,
    aTP_Lamp_lt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lu____,type,
    aTP_Lamp_lu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lv____,type,
    aTP_Lamp_lv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lw____,type,
    aTP_Lamp_lw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lx____,type,
    aTP_Lamp_lx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ly____,type,
    aTP_Lamp_ly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lz____,type,
    aTP_Lamp_lz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ma____,type,
    aTP_Lamp_ma: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mb____,type,
    aTP_Lamp_mb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mc____,type,
    aTP_Lamp_mc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__md____,type,
    aTP_Lamp_md: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__me____,type,
    aTP_Lamp_me: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mf____,type,
    aTP_Lamp_mf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mg____,type,
    aTP_Lamp_mg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mh____,type,
    aTP_Lamp_mh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mi____,type,
    aTP_Lamp_mi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mj____,type,
    aTP_Lamp_mj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mk____,type,
    aTP_Lamp_mk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ml____,type,
    aTP_Lamp_ml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mm____,type,
    aTP_Lamp_mm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mn____,type,
    aTP_Lamp_mn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mo____,type,
    aTP_Lamp_mo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mp____,type,
    aTP_Lamp_mp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mq____,type,
    aTP_Lamp_mq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mr____,type,
    aTP_Lamp_mr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ms____,type,
    aTP_Lamp_ms: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mt____,type,
    aTP_Lamp_mt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mu____,type,
    aTP_Lamp_mu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mv____,type,
    aTP_Lamp_mv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mw____,type,
    aTP_Lamp_mw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mx____,type,
    aTP_Lamp_mx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__my____,type,
    aTP_Lamp_my: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mz____,type,
    aTP_Lamp_mz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__na____,type,
    aTP_Lamp_na: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nb____,type,
    aTP_Lamp_nb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nc____,type,
    aTP_Lamp_nc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nd____,type,
    aTP_Lamp_nd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ne____,type,
    aTP_Lamp_ne: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nf____,type,
    aTP_Lamp_nf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ng____,type,
    aTP_Lamp_ng: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nh____,type,
    aTP_Lamp_nh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ni____,type,
    aTP_Lamp_ni: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nj____,type,
    aTP_Lamp_nj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nk____,type,
    aTP_Lamp_nk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nl____,type,
    aTP_Lamp_nl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nm____,type,
    aTP_Lamp_nm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nn____,type,
    aTP_Lamp_nn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__no____,type,
    aTP_Lamp_no: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__np____,type,
    aTP_Lamp_np: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nq____,type,
    aTP_Lamp_nq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nr____,type,
    aTP_Lamp_nr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ns____,type,
    aTP_Lamp_ns: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nt____,type,
    aTP_Lamp_nt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nu____,type,
    aTP_Lamp_nu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nv____,type,
    aTP_Lamp_nv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nw____,type,
    aTP_Lamp_nw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nx____,type,
    aTP_Lamp_nx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ny____,type,
    aTP_Lamp_ny: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nz____,type,
    aTP_Lamp_nz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oa____,type,
    aTP_Lamp_oa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ob____,type,
    aTP_Lamp_ob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oc____,type,
    aTP_Lamp_oc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__od____,type,
    aTP_Lamp_od: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oe____,type,
    aTP_Lamp_oe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__of____,type,
    aTP_Lamp_of: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__og____,type,
    aTP_Lamp_og: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oh____,type,
    aTP_Lamp_oh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oi____,type,
    aTP_Lamp_oi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oj____,type,
    aTP_Lamp_oj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ok____,type,
    aTP_Lamp_ok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ol____,type,
    aTP_Lamp_ol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__om____,type,
    aTP_Lamp_om: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__on____,type,
    aTP_Lamp_on: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oo____,type,
    aTP_Lamp_oo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__op____,type,
    aTP_Lamp_op: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oq____,type,
    aTP_Lamp_oq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__or____,type,
    aTP_Lamp_or: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__os____,type,
    aTP_Lamp_os: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ot____,type,
    aTP_Lamp_ot: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ou____,type,
    aTP_Lamp_ou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ov____,type,
    aTP_Lamp_ov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ow____,type,
    aTP_Lamp_ow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ox____,type,
    aTP_Lamp_ox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oy____,type,
    aTP_Lamp_oy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oz____,type,
    aTP_Lamp_oz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pa____,type,
    aTP_Lamp_pa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pb____,type,
    aTP_Lamp_pb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pc____,type,
    aTP_Lamp_pc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pd____,type,
    aTP_Lamp_pd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pe____,type,
    aTP_Lamp_pe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pf____,type,
    aTP_Lamp_pf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pg____,type,
    aTP_Lamp_pg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ph____,type,
    aTP_Lamp_ph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pi____,type,
    aTP_Lamp_pi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pj____,type,
    aTP_Lamp_pj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pk____,type,
    aTP_Lamp_pk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pl____,type,
    aTP_Lamp_pl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pm____,type,
    aTP_Lamp_pm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pn____,type,
    aTP_Lamp_pn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__po____,type,
    aTP_Lamp_po: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pp____,type,
    aTP_Lamp_pp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pq____,type,
    aTP_Lamp_pq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pr____,type,
    aTP_Lamp_pr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ps____,type,
    aTP_Lamp_ps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pt____,type,
    aTP_Lamp_pt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pu____,type,
    aTP_Lamp_pu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pv____,type,
    aTP_Lamp_pv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pw____,type,
    aTP_Lamp_pw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__px____,type,
    aTP_Lamp_px: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__py____,type,
    aTP_Lamp_py: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pz____,type,
    aTP_Lamp_pz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qa____,type,
    aTP_Lamp_qa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qb____,type,
    aTP_Lamp_qb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qc____,type,
    aTP_Lamp_qc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qd____,type,
    aTP_Lamp_qd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qe____,type,
    aTP_Lamp_qe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qf____,type,
    aTP_Lamp_qf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qg____,type,
    aTP_Lamp_qg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qh____,type,
    aTP_Lamp_qh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qi____,type,
    aTP_Lamp_qi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qj____,type,
    aTP_Lamp_qj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qk____,type,
    aTP_Lamp_qk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ql____,type,
    aTP_Lamp_ql: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qm____,type,
    aTP_Lamp_qm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qn____,type,
    aTP_Lamp_qn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qo____,type,
    aTP_Lamp_qo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qp____,type,
    aTP_Lamp_qp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qq____,type,
    aTP_Lamp_qq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qr____,type,
    aTP_Lamp_qr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qs____,type,
    aTP_Lamp_qs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qt____,type,
    aTP_Lamp_qt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qu____,type,
    aTP_Lamp_qu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qv____,type,
    aTP_Lamp_qv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qw____,type,
    aTP_Lamp_qw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qx____,type,
    aTP_Lamp_qx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qy____,type,
    aTP_Lamp_qy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qz____,type,
    aTP_Lamp_qz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ra____,type,
    aTP_Lamp_ra: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rb____,type,
    aTP_Lamp_rb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rc____,type,
    aTP_Lamp_rc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rd____,type,
    aTP_Lamp_rd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__re____,type,
    aTP_Lamp_re: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rf____,type,
    aTP_Lamp_rf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rg____,type,
    aTP_Lamp_rg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rh____,type,
    aTP_Lamp_rh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ri____,type,
    aTP_Lamp_ri: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rj____,type,
    aTP_Lamp_rj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rk____,type,
    aTP_Lamp_rk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rl____,type,
    aTP_Lamp_rl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rm____,type,
    aTP_Lamp_rm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rn____,type,
    aTP_Lamp_rn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ro____,type,
    aTP_Lamp_ro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rp____,type,
    aTP_Lamp_rp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rq____,type,
    aTP_Lamp_rq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rr____,type,
    aTP_Lamp_rr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rs____,type,
    aTP_Lamp_rs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rt____,type,
    aTP_Lamp_rt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ru____,type,
    aTP_Lamp_ru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rv____,type,
    aTP_Lamp_rv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rw____,type,
    aTP_Lamp_rw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rx____,type,
    aTP_Lamp_rx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ry____,type,
    aTP_Lamp_ry: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rz____,type,
    aTP_Lamp_rz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sa____,type,
    aTP_Lamp_sa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sb____,type,
    aTP_Lamp_sb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sc____,type,
    aTP_Lamp_sc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sd____,type,
    aTP_Lamp_sd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__se____,type,
    aTP_Lamp_se: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sf____,type,
    aTP_Lamp_sf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sg____,type,
    aTP_Lamp_sg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sh____,type,
    aTP_Lamp_sh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__si____,type,
    aTP_Lamp_si: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sj____,type,
    aTP_Lamp_sj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sk____,type,
    aTP_Lamp_sk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sl____,type,
    aTP_Lamp_sl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sm____,type,
    aTP_Lamp_sm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sn____,type,
    aTP_Lamp_sn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__so____,type,
    aTP_Lamp_so: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sp____,type,
    aTP_Lamp_sp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sq____,type,
    aTP_Lamp_sq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sr____,type,
    aTP_Lamp_sr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ss____,type,
    aTP_Lamp_ss: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__st____,type,
    aTP_Lamp_st: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__su____,type,
    aTP_Lamp_su: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sv____,type,
    aTP_Lamp_sv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sw____,type,
    aTP_Lamp_sw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sx____,type,
    aTP_Lamp_sx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sy____,type,
    aTP_Lamp_sy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sz____,type,
    aTP_Lamp_sz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ta____,type,
    aTP_Lamp_ta: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tb____,type,
    aTP_Lamp_tb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tc____,type,
    aTP_Lamp_tc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__td____,type,
    aTP_Lamp_td: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__te____,type,
    aTP_Lamp_te: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tf____,type,
    aTP_Lamp_tf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tg____,type,
    aTP_Lamp_tg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__th____,type,
    aTP_Lamp_th: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ti____,type,
    aTP_Lamp_ti: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tj____,type,
    aTP_Lamp_tj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tk____,type,
    aTP_Lamp_tk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tl____,type,
    aTP_Lamp_tl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tm____,type,
    aTP_Lamp_tm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tn____,type,
    aTP_Lamp_tn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__to____,type,
    aTP_Lamp_to: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tp____,type,
    aTP_Lamp_tp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tq____,type,
    aTP_Lamp_tq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tr____,type,
    aTP_Lamp_tr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ts____,type,
    aTP_Lamp_ts: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tt____,type,
    aTP_Lamp_tt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tu____,type,
    aTP_Lamp_tu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tv____,type,
    aTP_Lamp_tv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tw____,type,
    aTP_Lamp_tw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tx____,type,
    aTP_Lamp_tx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ty____,type,
    aTP_Lamp_ty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tz____,type,
    aTP_Lamp_tz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ua____,type,
    aTP_Lamp_ua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ub____,type,
    aTP_Lamp_ub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uc____,type,
    aTP_Lamp_uc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ud____,type,
    aTP_Lamp_ud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ue____,type,
    aTP_Lamp_ue: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uf____,type,
    aTP_Lamp_uf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ug____,type,
    aTP_Lamp_ug: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uh____,type,
    aTP_Lamp_uh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ui____,type,
    aTP_Lamp_ui: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uj____,type,
    aTP_Lamp_uj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uk____,type,
    aTP_Lamp_uk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ul____,type,
    aTP_Lamp_ul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__um____,type,
    aTP_Lamp_um: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__un____,type,
    aTP_Lamp_un: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uo____,type,
    aTP_Lamp_uo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__up____,type,
    aTP_Lamp_up: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uq____,type,
    aTP_Lamp_uq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ur____,type,
    aTP_Lamp_ur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__us____,type,
    aTP_Lamp_us: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ut____,type,
    aTP_Lamp_ut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uu____,type,
    aTP_Lamp_uu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uv____,type,
    aTP_Lamp_uv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uw____,type,
    aTP_Lamp_uw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ux____,type,
    aTP_Lamp_ux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uy____,type,
    aTP_Lamp_uy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uz____,type,
    aTP_Lamp_uz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__va____,type,
    aTP_Lamp_va: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vb____,type,
    aTP_Lamp_vb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vc____,type,
    aTP_Lamp_vc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vd____,type,
    aTP_Lamp_vd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ve____,type,
    aTP_Lamp_ve: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vf____,type,
    aTP_Lamp_vf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vg____,type,
    aTP_Lamp_vg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vh____,type,
    aTP_Lamp_vh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vi____,type,
    aTP_Lamp_vi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vj____,type,
    aTP_Lamp_vj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vk____,type,
    aTP_Lamp_vk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vl____,type,
    aTP_Lamp_vl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vm____,type,
    aTP_Lamp_vm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vn____,type,
    aTP_Lamp_vn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vo____,type,
    aTP_Lamp_vo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vp____,type,
    aTP_Lamp_vp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vq____,type,
    aTP_Lamp_vq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vr____,type,
    aTP_Lamp_vr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vs____,type,
    aTP_Lamp_vs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vt____,type,
    aTP_Lamp_vt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vu____,type,
    aTP_Lamp_vu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vv____,type,
    aTP_Lamp_vv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vw____,type,
    aTP_Lamp_vw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vx____,type,
    aTP_Lamp_vx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vy____,type,
    aTP_Lamp_vy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vz____,type,
    aTP_Lamp_vz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wa____,type,
    aTP_Lamp_wa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wb____,type,
    aTP_Lamp_wb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wc____,type,
    aTP_Lamp_wc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wd____,type,
    aTP_Lamp_wd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__we____,type,
    aTP_Lamp_we: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wf____,type,
    aTP_Lamp_wf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wg____,type,
    aTP_Lamp_wg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wh____,type,
    aTP_Lamp_wh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wi____,type,
    aTP_Lamp_wi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wj____,type,
    aTP_Lamp_wj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wk____,type,
    aTP_Lamp_wk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wl____,type,
    aTP_Lamp_wl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wm____,type,
    aTP_Lamp_wm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wn____,type,
    aTP_Lamp_wn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wo____,type,
    aTP_Lamp_wo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wp____,type,
    aTP_Lamp_wp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wq____,type,
    aTP_Lamp_wq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wr____,type,
    aTP_Lamp_wr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ws____,type,
    aTP_Lamp_ws: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wt____,type,
    aTP_Lamp_wt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wu____,type,
    aTP_Lamp_wu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wv____,type,
    aTP_Lamp_wv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ww____,type,
    aTP_Lamp_ww: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wx____,type,
    aTP_Lamp_wx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wy____,type,
    aTP_Lamp_wy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wz____,type,
    aTP_Lamp_wz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xa____,type,
    aTP_Lamp_xa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xb____,type,
    aTP_Lamp_xb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xc____,type,
    aTP_Lamp_xc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xd____,type,
    aTP_Lamp_xd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xe____,type,
    aTP_Lamp_xe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xf____,type,
    aTP_Lamp_xf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xg____,type,
    aTP_Lamp_xg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xh____,type,
    aTP_Lamp_xh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xi____,type,
    aTP_Lamp_xi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xj____,type,
    aTP_Lamp_xj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xk____,type,
    aTP_Lamp_xk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xl____,type,
    aTP_Lamp_xl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xm____,type,
    aTP_Lamp_xm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xn____,type,
    aTP_Lamp_xn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xo____,type,
    aTP_Lamp_xo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xp____,type,
    aTP_Lamp_xp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xq____,type,
    aTP_Lamp_xq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xr____,type,
    aTP_Lamp_xr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xs____,type,
    aTP_Lamp_xs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xt____,type,
    aTP_Lamp_xt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xu____,type,
    aTP_Lamp_xu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xv____,type,
    aTP_Lamp_xv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xw____,type,
    aTP_Lamp_xw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xx____,type,
    aTP_Lamp_xx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xy____,type,
    aTP_Lamp_xy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xz____,type,
    aTP_Lamp_xz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ya____,type,
    aTP_Lamp_ya: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yb____,type,
    aTP_Lamp_yb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yc____,type,
    aTP_Lamp_yc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yd____,type,
    aTP_Lamp_yd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ye____,type,
    aTP_Lamp_ye: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yf____,type,
    aTP_Lamp_yf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yg____,type,
    aTP_Lamp_yg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yh____,type,
    aTP_Lamp_yh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yi____,type,
    aTP_Lamp_yi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yj____,type,
    aTP_Lamp_yj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yk____,type,
    aTP_Lamp_yk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yl____,type,
    aTP_Lamp_yl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ym____,type,
    aTP_Lamp_ym: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yn____,type,
    aTP_Lamp_yn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yo____,type,
    aTP_Lamp_yo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yp____,type,
    aTP_Lamp_yp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yq____,type,
    aTP_Lamp_yq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yr____,type,
    aTP_Lamp_yr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ys____,type,
    aTP_Lamp_ys: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yt____,type,
    aTP_Lamp_yt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yu____,type,
    aTP_Lamp_yu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yv____,type,
    aTP_Lamp_yv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yw____,type,
    aTP_Lamp_yw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yx____,type,
    aTP_Lamp_yx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yy____,type,
    aTP_Lamp_yy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yz____,type,
    aTP_Lamp_yz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__za____,type,
    aTP_Lamp_za: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zb____,type,
    aTP_Lamp_zb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zc____,type,
    aTP_Lamp_zc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zd____,type,
    aTP_Lamp_zd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ze____,type,
    aTP_Lamp_ze: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zf____,type,
    aTP_Lamp_zf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zg____,type,
    aTP_Lamp_zg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zh____,type,
    aTP_Lamp_zh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zi____,type,
    aTP_Lamp_zi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zj____,type,
    aTP_Lamp_zj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zk____,type,
    aTP_Lamp_zk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zl____,type,
    aTP_Lamp_zl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zm____,type,
    aTP_Lamp_zm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zn____,type,
    aTP_Lamp_zn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zo____,type,
    aTP_Lamp_zo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zp____,type,
    aTP_Lamp_zp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zq____,type,
    aTP_Lamp_zq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zr____,type,
    aTP_Lamp_zr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zs____,type,
    aTP_Lamp_zs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zt____,type,
    aTP_Lamp_zt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zu____,type,
    aTP_Lamp_zu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zv____,type,
    aTP_Lamp_zv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zw____,type,
    aTP_Lamp_zw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zx____,type,
    aTP_Lamp_zx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zy____,type,
    aTP_Lamp_zy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zz____,type,
    aTP_Lamp_zz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OSucc,type,
    bNF_Greatest_Succ: 
      !>[A: $tType] : ( ( set(list(A)) * list(A) ) > set(A) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set(C) * fun(C,A) * fun(C,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(fun(A,B)) ) ).

tff(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,nat) * fun(B,nat) * product_prod(A,B) ) > nat ) ).

tff(sy_c_Binomial_Obinomial,type,
    binomial: nat > fun(nat,nat) ).

tff(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: ( nat * int ) > fun(int,int) ).

tff(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: ( num * num ) > num ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > fun(nat,$o) ) ).

tff(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: ( nat * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: fun(num,fun(num,option(num))) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: fun(num,fun(num,option(num))) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: fun(num,fun(num,option(num))) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: fun(num,fun(num,option(num))) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > product_prod(code_integer,$o) ).

tff(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

tff(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

tff(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

tff(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

tff(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

tff(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: fun(num,int) ).

tff(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: fun(num,int) ).

tff(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complex_OArg,type,
    arg: complex > real ).

tff(sy_c_Complex_Ocis,type,
    cis: real > complex ).

tff(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

tff(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: ( real * real ) > complex ).

tff(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

tff(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

tff(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

tff(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( fun(A,A) * A * filter(A) ) > $o ) ).

tff(sy_c_Divides_Oadjust__div,type,
    adjust_div: product_prod(int,int) > int ).

tff(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: ( int * int ) > int ).

tff(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: ( int * int * product_prod(int,int) ) > $o ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( product_prod(A,A) > $o ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( ( num * num ) > product_prod(A,A) ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( ( num * product_prod(A,A) ) > product_prod(A,A) ) ).

tff(sy_c_Extended__Nat_Oenat,type,
    extended_enat2: nat > extended_enat ).

tff(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : ( ( fun(nat,T) * T * extended_enat ) > T ) ).

tff(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,
    extend4730790105801354508finity: 
      !>[A: $tType] : A ).

tff(sy_c_Extended__Nat_Othe__enat,type,
    extended_the_enat: extended_enat > nat ).

tff(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( ( A * nat ) > A ) ).

tff(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( fun(A,$o) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : fun(set(A),filter(A)) ).

tff(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * filter(B) ) > filter(product_prod(A,B)) ) ).

tff(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( set(B) > nat ) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofinite,type,
    finite_finite2: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * set(B) ) > $o ) ).

tff(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( fun(B,C) > fun(fun(A,B),fun(A,C)) ) ).

tff(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A * B ) > fun(A,B) ) ).

tff(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( fun(C,A) * fun(B,D) ) > fun(fun(A,B),fun(C,D)) ) ).

tff(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * B ) > A ) ).

tff(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_Obezw,type,
    bezw: ( nat * nat ) > product_prod(int,int) ).

tff(sy_c_GCD_Obezw__rel,type,
    bezw_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( itself(A) > nat ) ).

tff(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

tff(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * A * list(B) ) > A ) ).

tff(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Int_OAbs__Integ,type,
    abs_Integ: fun(product_prod(nat,nat),int) ).

tff(sy_c_Int_ORep__Integ,type,
    rep_Integ: fun(int,product_prod(nat,nat)) ).

tff(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Onat,type,
    nat2: fun(int,nat) ).

tff(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

tff(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : fun(list(A),fun(list(A),list(A))) ).

tff(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list(A) * fun(A,list(B)) ) > list(B) ) ).

tff(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( list(list(A)) > list(A) ) ).

tff(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( list(A) > fun(A,nat) ) ).

tff(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( list(A) > $o ) ).

tff(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(product_prod(nat,A)) ) ).

tff(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > option(product_prod(list(A),product_prod(A,list(A)))) ) ).

tff(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( fun(A,$o) > fun(list(A),list(A)) ) ).

tff(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > option(A) ) ).

tff(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * set(B) * fun(B,A) ) > $o ) ).

tff(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(nat,set(product_prod(list(A),list(A)))) ) ).

tff(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(A,$o)) > fun(fun(B,A),fun(B,fun(list(B),list(B)))) ) ).

tff(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(A,$o)) > fun(fun(B,A),fun(set(B),list(B))) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(B,fun(list(B),list(B))) ) ).

tff(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( fun(B,A) > fun(set(B),list(B)) ) ).

tff(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : fun(set(A),list(A)) ).

tff(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : list(A) ).

tff(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,fun(list(A),B)) ) > fun(list(A),B) ) ).

tff(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(list(A),list(Aa)) ) ).

tff(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : fun(list(A),set(A)) ).

tff(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( fun(A,nat) > fun(list(A),nat) ) ).

tff(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list(A) * nat * A ) > list(A) ) ).

tff(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( list(set(A)) > set(list(A)) ) ).

tff(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) ) > list(B) ) ).

tff(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(list(A)) ) ).

tff(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( list(A) > fun(nat,A) ) ).

tff(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : fun(list(A),fun(list(A),$o)) ).

tff(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( ( nat * A ) > list(A) ) ).

tff(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set(A) * set(list(A)) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > set(list(A)) ) ).

tff(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) ) > $o ) ).

tff(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( list(A) > list(list(A)) ) ).

tff(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : fun(list(list(A)),fun(list(list(A)),$o)) ).

tff(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oupt,type,
    upt: ( nat * nat ) > list(nat) ).

tff(sy_c_List_Oupto,type,
    upto: ( int * int ) > list(int) ).

tff(sy_c_List_Oupto__aux,type,
    upto_aux: ( int * int * list(int) ) > list(int) ).

tff(sy_c_List_Oupto__rel,type,
    upto_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( list(product_prod(A,B)) > fun(A,option(B)) ) ).

tff(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) * list(B) ) > fun(A,option(B)) ) ).

tff(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(B) ) ).

tff(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * set(A) ) > fun(A,option(B)) ) ).

tff(sy_c_Nat_OSuc,type,
    suc: fun(nat,nat) ).

tff(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : fun(nat,fun(fun(A,A),fun(A,A))) ).

tff(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( ( A * fun(nat,A) * nat ) > A ) ).

tff(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

tff(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) ) > fun(nat,T) ) ).

tff(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) * nat ) > fun(T,$o) ) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( fun(A,A) * nat * A ) > A ) ).

tff(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > set(nat) ).

tff(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: fun(set(nat),nat) ).

tff(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

tff(sy_c_NthRoot_Oroot,type,
    root: nat > fun(real,real) ).

tff(sy_c_NthRoot_Osqrt,type,
    sqrt: fun(real,real) ).

tff(sy_c_Num_OBitM,type,
    bitM: num > num ).

tff(sy_c_Num_Oinc,type,
    inc: num > num ).

tff(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( ( num * num ) > A ) ).

tff(sy_c_Num_Onum_OBit0,type,
    bit0: fun(num,num) ).

tff(sy_c_Num_Onum_OBit1,type,
    bit1: fun(num,num) ).

tff(sy_c_Num_Onum_OOne,type,
    one2: num ).

tff(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( ( A * fun(num,A) * fun(num,A) * num ) > A ) ).

tff(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

tff(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

tff(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : fun(num,A) ).

tff(sy_c_Num_Opow,type,
    pow: ( num * num ) > num ).

tff(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

tff(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Osqr,type,
    sqr: num > num ).

tff(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : option(A) ).

tff(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : fun(A,option(A)) ).

tff(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,B) * option(A) ) > B ) ).

tff(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(option(A),option(Aa)) ) ).

tff(sy_c_Option_Ooption_Orec__option,type,
    rec_option: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,C) ) > fun(option(A),C) ) ).

tff(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( fun(A,nat) > fun(option(A),nat) ) ).

tff(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : fun(option(A),A) ).

tff(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( set(option(A)) > set(A) ) ).

tff(sy_c_Order__Continuity_Ocountable__complete__lattice__class_Occlfp,type,
    order_532582986084564980_cclfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

tff(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,$o) ) > A ) ).

tff(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

tff(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : fun(A,fun(B,product_prod(A,B))) ).

tff(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(product_prod(A,B),product_prod(A,C))) ).

tff(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : fun(fun(A,fun(B,C)),fun(product_prod(A,B),C)) ).

tff(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),A) ).

tff(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),B) ).

tff(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Rat_OFrct,type,
    frct: product_prod(int,int) > rat ).

tff(sy_c_Rat_Onormalize,type,
    normalize: product_prod(int,int) > product_prod(int,int) ).

tff(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > product_prod(int,int) ).

tff(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( ( A * A ) > real ) ).

tff(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

tff(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : fun(real,A) ).

tff(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > fun(A,A) ) ).

tff(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,B)) * set(product_prod(B,C)) ) > set(product_prod(A,C)) ) ).

tff(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : fun($o,A) ).

tff(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( fun(nat,A) > A ) ).

tff(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( fun(nat,A) > fun(A,$o) ) ).

tff(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : fun(set(A),fun(fun(A,$o),$o)) ).

tff(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : fun(fun(A,$o),set(A)) ).

tff(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Set_Ofilter,type,
    filter3: 
      !>[A: $tType] : ( ( fun(A,$o) * set(A) ) > set(A) ) ).

tff(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(set(A),set(B)) ) ).

tff(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > fun(set(A),set(A)) ) ).

tff(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( fun(nat,fun(A,A)) * nat * nat * A ) > A ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

tff(sy_c_String_Ochar_OChar,type,
    char2: ( $o * $o * $o * $o * $o * $o * $o ) > fun($o,char) ).

tff(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

tff(sy_c_String_Ochar__of__integer,type,
    char_of_integer: code_integer > char ).

tff(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : fun(char,A) ).

tff(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

tff(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : fun(A,char) ).

tff(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Topological__Spaces_Ogenerate__topology,type,
    topolo8378437560675496660pology: 
      !>[A: $tType] : ( set(set(A)) > fun(set(A),$o) ) ).

tff(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : fun(set(A),$o) ).

tff(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter(F) * fun(F,A) ) > A ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( ( A * set(A) ) > filter(A) ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > filter(A) ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( filter(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : filter(product_prod(A,A)) ).

tff(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Transcendental_Oarccos,type,
    arccos: fun(real,real) ).

tff(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oarcsin,type,
    arcsin: fun(real,real) ).

tff(sy_c_Transcendental_Oarctan,type,
    arctan: fun(real,real) ).

tff(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

tff(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( fun(nat,A) > fun(nat,A) ) ).

tff(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Olog,type,
    log: real > fun(real,real) ).

tff(sy_c_Transcendental_Opi,type,
    pi: real ).

tff(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

tff(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( ( nat * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: ( $o * $o ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option(product_prod(nat,nat)) * nat * list(vEBT_VEBT) * vEBT_VEBT ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_Ocase__VEBT,type,
    vEBT_case_VEBT: 
      !>[A: $tType] : ( ( fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A)))) * fun($o,fun($o,A)) * vEBT_VEBT ) > A ) ).

tff(sy_c_VEBT__Definitions_OVEBT_Odeg,type,
    vEBT_deg: vEBT_VEBT > nat ).

tff(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: fun(vEBT_VEBT,nat) ).

tff(sy_c_VEBT__Definitions_OVEBT_Osummary,type,
    vEBT_summary: vEBT_VEBT > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_OtreeList,type,
    vEBT_treeList: vEBT_VEBT > list(vEBT_VEBT) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > fun(nat,$o) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead,type,
    vEBT_VEBT_elim_dead: ( vEBT_VEBT * extended_enat ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead__rel,type,
    vEBT_V312737461966249ad_rel: fun(product_prod(vEBT_VEBT,extended_enat),fun(product_prod(vEBT_VEBT,extended_enat),$o)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: ( nat * nat ) > nat ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: ( nat * list(vEBT_VEBT) * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: ( nat * nat ) > nat ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > set(nat) ).

tff(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: fun(nat,fun(nat,$o)) ).

tff(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > $o ) ).

tff(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : set(product_prod(set(A),set(A))) ).

tff(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( fun(A,nat) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( fun(A,nat) * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( fun(A,$o) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_aa,type,
    aa: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A ) > B ) ).

tff(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_fNot,type,
    fNot: fun($o,$o) ).

tff(sy_c_fequal,type,
    fequal: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > fun(set(A),$o) ) ).

tff(sy_v_dega____,type,
    dega: nat ).

tff(sy_v_m____,type,
    m: nat ).

tff(sy_v_na____,type,
    na: nat ).

tff(sy_v_summarya____,type,
    summarya: vEBT_VEBT ).

tff(sy_v_treeLista____,type,
    treeLista: list(vEBT_VEBT) ).

% Relevant facts (9579)
tff(fact_0__C3_OIH_C_I2_J,axiom,
    vEBT_VEBT_elim_dead(summarya,extend4730790105801354508finity(extended_enat)) = summarya ).

% "3.IH"(2)
tff(fact_1__092_060open_062deg_Adiv_A2_A_061_An_092_060close_062,axiom,
    aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),dega),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = na ).

% \<open>deg div 2 = n\<close>
tff(fact_2_VEBT_Oinject_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT,Y11: option(product_prod(nat,nat)),Y12: nat,Y13: list(vEBT_VEBT),Y14: vEBT_VEBT] :
      ( ( vEBT_Node(X11,X12,X13,X14) = vEBT_Node(Y11,Y12,Y13,Y14) )
    <=> ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
tff(fact_3__C3_Ohyps_C_I5_J,axiom,
    ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(summarya),X_1) ).

% "3.hyps"(5)
tff(fact_4__C3_Ohyps_C_I1_J,axiom,
    vEBT_invar_vebt(summarya,m) ).

% "3.hyps"(1)
tff(fact_5__092_060open_062elim__dead_A_INode_ANone_Adeg_AtreeList_Asummary_J_A_092_060infinity_062_A_061_ANode_ANone_Adeg_A_Imap_A_I_092_060lambda_062t_O_Aelim__dead_At_A_Ienat_A_I2_A_094_A_Ideg_Adiv_A2_J_J_J_J_AtreeList_J_A_Ielim__dead_Asummary_A_092_060infinity_062_J_092_060close_062,axiom,
    vEBT_VEBT_elim_dead(vEBT_Node(none(product_prod(nat,nat)),dega,treeLista,summarya),extend4730790105801354508finity(extended_enat)) = vEBT_Node(none(product_prod(nat,nat)),dega,aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_a(vEBT_VEBT,vEBT_VEBT)),treeLista),vEBT_VEBT_elim_dead(summarya,extend4730790105801354508finity(extended_enat))) ).

% \<open>elim_dead (Node None deg treeList summary) \<infinity> = Node None deg (map (\<lambda>t. elim_dead t (enat (2 ^ (deg div 2)))) treeList) (elim_dead summary \<infinity>)\<close>
tff(fact_6__C3_OIH_C_I1_J,axiom,
    ! [X: vEBT_VEBT] :
      ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),treeLista))
     => ( vEBT_invar_vebt(X,na)
        & ( vEBT_VEBT_elim_dead(X,extend4730790105801354508finity(extended_enat)) = X ) ) ) ).

% "3.IH"(1)
tff(fact_7__C3_Ohyps_C_I4_J,axiom,
    dega = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),na),m) ).

% "3.hyps"(4)
tff(fact_8_not__enat__eq,axiom,
    ! [X2: extended_enat] :
      ( ! [Y: nat] : ( X2 != extended_enat2(Y) )
    <=> ( X2 = extend4730790105801354508finity(extended_enat) ) ) ).

% not_enat_eq
tff(fact_9_not__infinity__eq,axiom,
    ! [X2: extended_enat] :
      ( ( X2 != extend4730790105801354508finity(extended_enat) )
    <=> ? [I: nat] : ( X2 = extended_enat2(I) ) ) ).

% not_infinity_eq
tff(fact_10__C3_Ohyps_C_I6_J,axiom,
    ! [X: vEBT_VEBT] :
      ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),treeLista))
     => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_1) ) ).

% "3.hyps"(6)
tff(fact_11_VEBT_Osimps_I5_J,axiom,
    ! [A: $tType,F1: fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A)))),F2: fun($o,fun($o,A)),X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( vEBT_case_VEBT(A,F1,F2,vEBT_Node(X11,X12,X13,X14)) = aa(vEBT_VEBT,A,aa(list(vEBT_VEBT),fun(vEBT_VEBT,A),aa(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A)),aa(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A))),F1,X11),X12),X13),X14) ) ).

% VEBT.simps(5)
tff(fact_12_VEBT_Osel_I4_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( vEBT_summary(vEBT_Node(X11,X12,X13,X14)) = X14 ) ).

% VEBT.sel(4)
tff(fact_13_VEBT_Osel_I3_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( vEBT_treeList(vEBT_Node(X11,X12,X13,X14)) = X13 ) ).

% VEBT.sel(3)
tff(fact_14_VEBT_Osel_I2_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( vEBT_deg(vEBT_Node(X11,X12,X13,X14)) = X12 ) ).

% VEBT.sel(2)
tff(fact_15_b,axiom,
    aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_aa(vEBT_VEBT,vEBT_VEBT)),treeLista) = treeLista ).

% b
tff(fact_16_enat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( extended_enat2(Nat) = extended_enat2(Nat2) )
    <=> ( Nat = Nat2 ) ) ).

% enat.inject
tff(fact_17_pow__sum,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A2)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2) ) ).

% pow_sum
tff(fact_18__092_060open_062take_A_I2_A_094_Adeg_Adiv_A2_A_094_A_Ideg_Adiv_A2_J_J_A_Imap_A_I_092_060lambda_062t_O_Aelim__dead_At_A_Ienat_A_I2_A_094_An_J_J_J_AtreeList_J_A_061_AtreeList_092_060close_062,axiom,
    take(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),dega)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),dega),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_aa(vEBT_VEBT,vEBT_VEBT)),treeLista)) = treeLista ).

% \<open>take (2 ^ deg div 2 ^ (deg div 2)) (map (\<lambda>t. elim_dead t (enat (2 ^ n))) treeList) = treeList\<close>
tff(fact_19_elimnum,axiom,
    ! [Infoa: option(product_prod(nat,nat)),Degb: nat,TreeListb: list(vEBT_VEBT),Summaryb: vEBT_VEBT,Nb: nat] :
      ( vEBT_invar_vebt(vEBT_Node(Infoa,Degb,TreeListb,Summaryb),Nb)
     => ( vEBT_VEBT_elim_dead(vEBT_Node(Infoa,Degb,TreeListb,Summaryb),extended_enat2(aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) = vEBT_Node(Infoa,Degb,TreeListb,Summaryb) ) ) ).

% elimnum
tff(fact_20__092_060open_0622_A_094_Am_A_061_A2_A_094_Adeg_Adiv_A2_A_094_A_Ideg_Adiv_A2_J_092_060close_062,axiom,
    aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),dega)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),dega),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ).

% \<open>2 ^ m = 2 ^ deg div 2 ^ (deg div 2)\<close>
tff(fact_21__C3_Ohyps_C_I3_J,axiom,
    m = aa(nat,nat,suc,na) ).

% "3.hyps"(3)
tff(fact_22__C3_Ohyps_C_I2_J,axiom,
    aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),treeLista) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) ).

% "3.hyps"(2)
tff(fact_23_VEBT_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: fun(B,A),F1: fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,B)))),F2: fun($o,fun($o,B)),VEBT: vEBT_VEBT] : ( aa(B,A,H,vEBT_case_VEBT(B,F1,F2,VEBT)) = vEBT_case_VEBT(A,aa(fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,B)))),fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A)))),aTP_Lamp_ab(fun(B,A),fun(fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,B)))),fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A))))),H),F1),aa(fun($o,fun($o,B)),fun($o,fun($o,A)),aTP_Lamp_ac(fun(B,A),fun(fun($o,fun($o,B)),fun($o,fun($o,A))),H),F2),VEBT) ) ).

% VEBT.case_distrib
tff(fact_24_VEBT__internal_Oelim__dead_Osimps_I2_J,axiom,
    ! [Infoa: option(product_prod(nat,nat)),Degb: nat,TreeListb: list(vEBT_VEBT),Summaryb: vEBT_VEBT] : ( vEBT_VEBT_elim_dead(vEBT_Node(Infoa,Degb,TreeListb,Summaryb),extend4730790105801354508finity(extended_enat)) = vEBT_Node(Infoa,Degb,aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ad(nat,fun(vEBT_VEBT,vEBT_VEBT),Degb)),TreeListb),vEBT_VEBT_elim_dead(Summaryb,extend4730790105801354508finity(extended_enat))) ) ).

% VEBT_internal.elim_dead.simps(2)
tff(fact_25_enat__ex__split,axiom,
    ! [P: fun(extended_enat,$o)] :
      ( ? [X_12: extended_enat] : aa(extended_enat,$o,P,X_12)
    <=> ( aa(extended_enat,$o,P,extend4730790105801354508finity(extended_enat))
        | ? [X3: nat] : aa(extended_enat,$o,P,extended_enat2(X3)) ) ) ).

% enat_ex_split
tff(fact_26_enat3__cases,axiom,
    ! [Y2: extended_enat,Ya: extended_enat,Yb: extended_enat] :
      ( ( ? [Nat3: nat] : ( Y2 = extended_enat2(Nat3) )
       => ( ? [Nata: nat] : ( Ya = extended_enat2(Nata) )
         => ! [Natb: nat] : ( Yb != extended_enat2(Natb) ) ) )
     => ( ( ? [Nat3: nat] : ( Y2 = extended_enat2(Nat3) )
         => ( ? [Nata: nat] : ( Ya = extended_enat2(Nata) )
           => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
       => ( ( ? [Nat3: nat] : ( Y2 = extended_enat2(Nat3) )
           => ( ( Ya = extend4730790105801354508finity(extended_enat) )
             => ! [Nata: nat] : ( Yb != extended_enat2(Nata) ) ) )
         => ( ( ? [Nat3: nat] : ( Y2 = extended_enat2(Nat3) )
             => ( ( Ya = extend4730790105801354508finity(extended_enat) )
               => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
           => ( ( ( Y2 = extend4730790105801354508finity(extended_enat) )
               => ( ? [Nat3: nat] : ( Ya = extended_enat2(Nat3) )
                 => ! [Nata: nat] : ( Yb != extended_enat2(Nata) ) ) )
             => ( ( ( Y2 = extend4730790105801354508finity(extended_enat) )
                 => ( ? [Nat3: nat] : ( Ya = extended_enat2(Nat3) )
                   => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
               => ( ( ( Y2 = extend4730790105801354508finity(extended_enat) )
                   => ( ( Ya = extend4730790105801354508finity(extended_enat) )
                     => ! [Nat3: nat] : ( Yb != extended_enat2(Nat3) ) ) )
                 => ~ ( ( Y2 = extend4730790105801354508finity(extended_enat) )
                     => ( ( Ya = extend4730790105801354508finity(extended_enat) )
                       => ( Yb != extend4730790105801354508finity(extended_enat) ) ) ) ) ) ) ) ) ) ) ).

% enat3_cases
tff(fact_27_enat2__cases,axiom,
    ! [Y2: extended_enat,Ya: extended_enat] :
      ( ( ? [Nat3: nat] : ( Y2 = extended_enat2(Nat3) )
       => ! [Nata: nat] : ( Ya != extended_enat2(Nata) ) )
     => ( ( ? [Nat3: nat] : ( Y2 = extended_enat2(Nat3) )
         => ( Ya != extend4730790105801354508finity(extended_enat) ) )
       => ( ( ( Y2 = extend4730790105801354508finity(extended_enat) )
           => ! [Nat3: nat] : ( Ya != extended_enat2(Nat3) ) )
         => ~ ( ( Y2 = extend4730790105801354508finity(extended_enat) )
             => ( Ya != extend4730790105801354508finity(extended_enat) ) ) ) ) ) ).

% enat2_cases
tff(fact_28_enat_Oexhaust,axiom,
    ! [Y2: extended_enat] :
      ( ! [Nat3: nat] : ( Y2 != extended_enat2(Nat3) )
     => ( Y2 = extend4730790105801354508finity(extended_enat) ) ) ).

% enat.exhaust
tff(fact_29_enat_Odistinct_I1_J,axiom,
    ! [Nat: nat] : ( extended_enat2(Nat) != extend4730790105801354508finity(extended_enat) ) ).

% enat.distinct(1)
tff(fact_30_enat_Odistinct_I2_J,axiom,
    ! [Nat: nat] : ( extend4730790105801354508finity(extended_enat) != extended_enat2(Nat) ) ).

% enat.distinct(2)
tff(fact_31_add__self__div__2,axiom,
    ! [Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Ma)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = Ma ) ).

% add_self_div_2
tff(fact_32_VEBT__internal_Oelim__dead_Osimps_I3_J,axiom,
    ! [Infoa: option(product_prod(nat,nat)),Degb: nat,TreeListb: list(vEBT_VEBT),Summaryb: vEBT_VEBT,L: nat] : ( vEBT_VEBT_elim_dead(vEBT_Node(Infoa,Degb,TreeListb,Summaryb),extended_enat2(L)) = vEBT_Node(Infoa,Degb,take(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ad(nat,fun(vEBT_VEBT,vEBT_VEBT),Degb)),TreeListb)),vEBT_VEBT_elim_dead(Summaryb,extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))) ) ).

% VEBT_internal.elim_dead.simps(3)
tff(fact_33_div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Ma: nat,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb))) ) ) ).

% div_exp_eq
tff(fact_34_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B),G: fun(B,A)] :
      ( ( aa(list(B),list(A),map(B,A,F3),Xs) = aa(list(B),list(A),map(B,A,G),Xs) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),aa(list(B),set(B),set2(B),Xs))
         => ( aa(B,A,F3,X3) = aa(B,A,G,X3) ) ) ) ).

% map_eq_conv
tff(fact_35_semiring__norm_I85_J,axiom,
    ! [Ma: num] : ( aa(num,num,bit0,Ma) != one2 ) ).

% semiring_norm(85)
tff(fact_36_semiring__norm_I83_J,axiom,
    ! [Nb: num] : ( one2 != aa(num,num,bit0,Nb) ) ).

% semiring_norm(83)
tff(fact_37_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = X2 ) ) ).

% field_sum_of_halves
tff(fact_38_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb)) ) ) ).

% numeral_plus_numeral
tff(fact_39_add__numeral__left,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [V: num,W: num,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),W)),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),W))),Z) ) ) ).

% add_numeral_left
tff(fact_40_high__def,axiom,
    ! [X2: nat,Nb: nat] : ( vEBT_VEBT_high(X2,Nb) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ).

% high_def
tff(fact_41_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(num,A,numeral_numeral(A),Nb) ) ) ).

% numeral_Bit0_div_2
tff(fact_42_map__ident,axiom,
    ! [A: $tType,X: list(A)] : ( aa(list(A),list(A),map(A,A,aTP_Lamp_ae(A,A)),X) = X ) ).

% map_ident
tff(fact_43_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: fun(A,$o)] :
      ( aa(set(A),$o,member(A,A2),aa(fun(A,$o),set(A),collect(A),P))
    <=> aa(A,$o,P,A2) ) ).

% mem_Collect_eq
tff(fact_44_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(fun(A,$o),set(A),collect(A),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3)) = A3 ) ).

% Collect_mem_eq
tff(fact_45_Collect__cong,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ! [X4: A] :
          ( aa(A,$o,P,X4)
        <=> aa(A,$o,Q,X4) )
     => ( aa(fun(A,$o),set(A),collect(A),P) = aa(fun(A,$o),set(A),collect(A),Q) ) ) ).

% Collect_cong
tff(fact_46_ext,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),G: fun(A,B)] :
      ( ! [X4: A] : ( aa(A,B,F3,X4) = aa(A,B,G,X4) )
     => ( F3 = G ) ) ).

% ext
tff(fact_47_even__odd__cases,axiom,
    ! [X2: nat] :
      ( ! [N: nat] : ( X2 != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N) )
     => ~ ! [N: nat] : ( X2 != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,suc,N)) ) ) ).

% even_odd_cases
tff(fact_48_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Ma: num,Nb: num] :
          ( ( aa(num,A,numeral_numeral(A),Ma) = aa(num,A,numeral_numeral(A),Nb) )
        <=> ( Ma = Nb ) ) ) ).

% numeral_eq_iff
tff(fact_49_semiring__norm_I87_J,axiom,
    ! [Ma: num,Nb: num] :
      ( ( aa(num,num,bit0,Ma) = aa(num,num,bit0,Nb) )
    <=> ( Ma = Nb ) ) ).

% semiring_norm(87)
tff(fact_50_plus__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ).

% plus_enat_simps(3)
tff(fact_51_plus__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),extend4730790105801354508finity(extended_enat)),Q2) = extend4730790105801354508finity(extended_enat) ) ).

% plus_enat_simps(2)
tff(fact_52_length__map,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_size(list(A)),aa(list(B),list(A),map(B,A,F3),Xs)) = aa(list(B),nat,size_size(list(B)),Xs) ) ).

% length_map
tff(fact_53_plus__enat__simps_I1_J,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),extended_enat2(Ma)),extended_enat2(Nb)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) ) ).

% plus_enat_simps(1)
tff(fact_54_semiring__norm_I6_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit0,Ma)),aa(num,num,bit0,Nb)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb)) ) ).

% semiring_norm(6)
tff(fact_55_semiring__norm_I2_J,axiom,
    aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),one2) = aa(num,num,bit0,one2) ).

% semiring_norm(2)
tff(fact_56_Suc__numeral,axiom,
    ! [Nb: num] : ( aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),Nb)) = aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),Nb),one2)) ) ).

% Suc_numeral
tff(fact_57_add__2__eq__Suc_H,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,suc,aa(nat,nat,suc,Nb)) ) ).

% add_2_eq_Suc'
tff(fact_58_add__2__eq__Suc,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) = aa(nat,nat,suc,aa(nat,nat,suc,Nb)) ) ).

% add_2_eq_Suc
tff(fact_59_div2__Suc__Suc,axiom,
    ! [Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Ma))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% div2_Suc_Suc
tff(fact_60_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) != aa(list(A),nat,size_size(list(A)),Ys) )
     => ( Xs != Ys ) ) ).

% neq_if_length_neq
tff(fact_61_Ex__list__of__length,axiom,
    ! [A: $tType,Nb: nat] :
    ? [Xs2: list(A)] : ( aa(list(A),nat,size_size(list(A)),Xs2) = Nb ) ).

% Ex_list_of_length
tff(fact_62_take__equalityI,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ! [I2: nat] : ( take(A,I2,Xs) = take(A,I2,Ys) )
     => ( Xs = Ys ) ) ).

% take_equalityI
tff(fact_63_add__One__commute,axiom,
    ! [Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Nb) = aa(num,num,aa(num,fun(num,num),plus_plus(num),Nb),one2) ) ).

% add_One_commute
tff(fact_64_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: fun(B,A),Xs: list(B),G: fun(C,A),Ys: list(C)] :
      ( ( aa(list(B),list(A),map(B,A,F3),Xs) = aa(list(C),list(A),map(C,A,G),Ys) )
     => ( aa(list(B),nat,size_size(list(B)),Xs) = aa(list(C),nat,size_size(list(C)),Ys) ) ) ).

% map_eq_imp_length_eq
tff(fact_65_Suc__nat__number__of__add,axiom,
    ! [V: num,Nb: nat] : ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),one2))),Nb) ) ).

% Suc_nat_number_of_add
tff(fact_66_enat__add__left__cancel,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),B2) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),C2) )
    <=> ( ( A2 = extend4730790105801354508finity(extended_enat) )
        | ( B2 = C2 ) ) ) ).

% enat_add_left_cancel
tff(fact_67_plus__eq__infty__iff__enat,axiom,
    ! [Ma: extended_enat,Nb: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Ma),Nb) = extend4730790105801354508finity(extended_enat) )
    <=> ( ( Ma = extend4730790105801354508finity(extended_enat) )
        | ( Nb = extend4730790105801354508finity(extended_enat) ) ) ) ).

% plus_eq_infty_iff_enat
tff(fact_68_numeral__ne__infinity,axiom,
    ! [K: num] : ( aa(num,extended_enat,numeral_numeral(extended_enat),K) != extend4730790105801354508finity(extended_enat) ) ).

% numeral_ne_infinity
tff(fact_69_in__set__takeD,axiom,
    ! [A: $tType,X2: A,Nb: nat,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),take(A,Nb,Xs)))
     => aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs)) ) ).

% in_set_takeD
tff(fact_70_take__map,axiom,
    ! [A: $tType,B: $tType,Nb: nat,F3: fun(B,A),Xs: list(B)] : ( take(A,Nb,aa(list(B),list(A),map(B,A,F3),Xs)) = aa(list(B),list(A),map(B,A,F3),take(B,Nb,Xs)) ) ).

% take_map
tff(fact_71_numeral__eq__enat,axiom,
    ! [K: num] : ( aa(num,extended_enat,numeral_numeral(extended_enat),K) = extended_enat2(aa(num,nat,numeral_numeral(nat),K)) ) ).

% numeral_eq_enat
tff(fact_72_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% is_num_normalize(1)
tff(fact_73_list_Omap__ident,axiom,
    ! [A: $tType,T2: list(A)] : ( aa(list(A),list(A),map(A,A,aTP_Lamp_ae(A,A)),T2) = T2 ) ).

% list.map_ident
tff(fact_74_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeListb: list(vEBT_VEBT),Nb: nat,Summaryb: vEBT_VEBT,Ma: nat,Degb: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
         => vEBT_invar_vebt(X4,Nb) )
     => ( vEBT_invar_vebt(Summaryb,Ma)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma) )
         => ( ( Ma = aa(nat,nat,suc,Nb) )
           => ( ( Degb = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma) )
             => ( ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summaryb),X_13)
               => ( ! [X4: vEBT_VEBT] :
                      ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
                     => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_13) )
                 => vEBT_invar_vebt(vEBT_Node(none(product_prod(nat,nat)),Degb,TreeListb,Summaryb),Degb) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
tff(fact_75_ex__map__conv,axiom,
    ! [B: $tType,A: $tType,Ys: list(B),F3: fun(A,B)] :
      ( ? [Xs3: list(A)] : ( Ys = aa(list(A),list(B),map(A,B,F3),Xs3) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),aa(list(B),set(B),set2(B),Ys))
         => ? [Xa: A] : ( X3 = aa(A,B,F3,Xa) ) ) ) ).

% ex_map_conv
tff(fact_76_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(A),F3: fun(A,B),G: fun(A,B)] :
      ( ( Xs = Ys )
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Ys))
           => ( aa(A,B,F3,X4) = aa(A,B,G,X4) ) )
       => ( aa(list(A),list(B),map(A,B,F3),Xs) = aa(list(A),list(B),map(A,B,G),Ys) ) ) ) ).

% map_cong
tff(fact_77_map__idI,axiom,
    ! [A: $tType,Xs: list(A),F3: fun(A,A)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => ( aa(A,A,F3,X4) = X4 ) )
     => ( aa(list(A),list(A),map(A,A,F3),Xs) = Xs ) ) ).

% map_idI
tff(fact_78_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F3: fun(A,B),G: fun(A,B)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => ( aa(A,B,F3,X4) = aa(A,B,G,X4) ) )
     => ( aa(list(A),list(B),map(A,B,F3),Xs) = aa(list(A),list(B),map(A,B,G),Xs) ) ) ).

% map_ext
tff(fact_79_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X2: list(A),Xa2: list(A),F3: fun(A,B),Fa: fun(A,B)] :
      ( ! [Z2: A,Za: A] :
          ( aa(set(A),$o,member(A,Z2),aa(list(A),set(A),set2(A),X2))
         => ( aa(set(A),$o,member(A,Za),aa(list(A),set(A),set2(A),Xa2))
           => ( ( aa(A,B,F3,Z2) = aa(A,B,Fa,Za) )
             => ( Z2 = Za ) ) ) )
     => ( ( aa(list(A),list(B),map(A,B,F3),X2) = aa(list(A),list(B),map(A,B,Fa),Xa2) )
       => ( X2 = Xa2 ) ) ) ).

% list.inj_map_strong
tff(fact_80_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X2: list(A),F3: fun(A,B),G: fun(A,B)] :
      ( ! [Z2: A] :
          ( aa(set(A),$o,member(A,Z2),aa(list(A),set(A),set2(A),X2))
         => ( aa(A,B,F3,Z2) = aa(A,B,G,Z2) ) )
     => ( aa(list(A),list(B),map(A,B,F3),X2) = aa(list(A),list(B),map(A,B,G),X2) ) ) ).

% list.map_cong0
tff(fact_81_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X2: list(A),Ya: list(A),F3: fun(A,B),G: fun(A,B)] :
      ( ( X2 = Ya )
     => ( ! [Z2: A] :
            ( aa(set(A),$o,member(A,Z2),aa(list(A),set(A),set2(A),Ya))
           => ( aa(A,B,F3,Z2) = aa(A,B,G,Z2) ) )
       => ( aa(list(A),list(B),map(A,B,F3),X2) = aa(list(A),list(B),map(A,B,G),Ya) ) ) ) ).

% list.map_cong
tff(fact_82_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Nb: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Nb)),aa(num,A,numeral_numeral(A),Nb)) ) ) ).

% numeral_Bit0
tff(fact_83_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),one2)) = A2 ) ) ).

% divide_numeral_1
tff(fact_84_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeListb: list(vEBT_VEBT),Nb: nat,Summaryb: vEBT_VEBT,Ma: nat,Degb: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
         => vEBT_invar_vebt(X4,Nb) )
     => ( vEBT_invar_vebt(Summaryb,Ma)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma) )
         => ( ( Ma = Nb )
           => ( ( Degb = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma) )
             => ( ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summaryb),X_13)
               => ( ! [X4: vEBT_VEBT] :
                      ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
                     => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_13) )
                 => vEBT_invar_vebt(vEBT_Node(none(product_prod(nat,nat)),Degb,TreeListb,Summaryb),Degb) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
tff(fact_85_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Nb: num] :
          ( aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb))
          = $let(
              m2: A,
              m2 := aa(num,A,numeral_numeral(A),Nb),
              aa(A,A,aa(A,fun(A,A),plus_plus(A),m2),m2) ) ) ) ).

% numeral_code(2)
tff(fact_86_high__bound__aux,axiom,
    ! [Ma: nat,Nb: nat,Mb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Mb)))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),vEBT_VEBT_high(Ma,Nb)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Mb)) ) ).

% high_bound_aux
tff(fact_87_add__Suc__right,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),aa(nat,nat,suc,Nb)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) ) ).

% add_Suc_right
tff(fact_88_VEBT__internal_Oelim__dead_Oelims,axiom,
    ! [X2: vEBT_VEBT,Xa2: extended_enat,Y2: vEBT_VEBT] :
      ( ( vEBT_VEBT_elim_dead(X2,Xa2) = Y2 )
     => ( ! [A4: $o,B3: $o] :
            ( ( X2 = vEBT_Leaf(A4,B3) )
           => ( Y2 != vEBT_Leaf(A4,B3) ) )
       => ( ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
              ( ( X2 = vEBT_Node(Info,Deg,TreeList,Summary) )
             => ( ( Xa2 = extend4730790105801354508finity(extended_enat) )
               => ( Y2 != vEBT_Node(Info,Deg,aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ad(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg)),TreeList),vEBT_VEBT_elim_dead(Summary,extend4730790105801354508finity(extended_enat))) ) ) )
         => ~ ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(Info,Deg,TreeList,Summary) )
               => ! [L2: nat] :
                    ( ( Xa2 = extended_enat2(L2) )
                   => ( Y2 != vEBT_Node(Info,Deg,take(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ad(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg)),TreeList)),vEBT_VEBT_elim_dead(Summary,extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.elims
tff(fact_89_set__vebt__def,axiom,
    ! [T2: vEBT_VEBT] : ( vEBT_set_vebt(T2) = aa(fun(nat,$o),set(nat),collect(nat),vEBT_V8194947554948674370ptions(T2)) ) ).

% set_vebt_def
tff(fact_90_a,axiom,
    ! [I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m))
     => ( vEBT_VEBT_elim_dead(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,treeLista),I3),extended_enat2(aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),na))) = aa(nat,vEBT_VEBT,nth(vEBT_VEBT,treeLista),I3) ) ) ).

% a
tff(fact_91_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( aa(nat,nat,suc,Nat) = aa(nat,nat,suc,Nat2) )
    <=> ( Nat = Nat2 ) ) ).

% old.nat.inject
tff(fact_92_nat_Oinject,axiom,
    ! [X22: nat,Y22: nat] :
      ( ( aa(nat,nat,suc,X22) = aa(nat,nat,suc,Y22) )
    <=> ( X22 = Y22 ) ) ).

% nat.inject
tff(fact_93_the__enat_Osimps,axiom,
    ! [Nb: nat] : ( extended_the_enat(extended_enat2(Nb)) = Nb ) ).

% the_enat.simps
tff(fact_94_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_VEBT_valid(T2,D2)
     => vEBT_invar_vebt(T2,D2) ) ).

% valid_eq2
tff(fact_95_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_invar_vebt(T2,D2)
     => vEBT_VEBT_valid(T2,D2) ) ).

% valid_eq1
tff(fact_96_valid__eq,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_VEBT_valid(T2,D2)
    <=> vEBT_invar_vebt(T2,D2) ) ).

% valid_eq
tff(fact_97_inthall,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o),Nb: nat] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X4) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
       => aa(A,$o,P,aa(nat,A,nth(A,Xs),Nb)) ) ) ).

% inthall
tff(fact_98_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( vEBT_Leaf(X21,X222) = vEBT_Leaf(Y21,Y222) )
    <=> ( ( (X21)
        <=> (Y21) )
        & ( (X222)
        <=> (Y222) ) ) ) ).

% VEBT.inject(2)
tff(fact_99_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Ma: num,Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),Nb) ) ) ).

% numeral_less_iff
tff(fact_100_lessI,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,suc,Nb)) ).

% lessI
tff(fact_101_Suc__mono,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Ma)),aa(nat,nat,suc,Nb)) ) ).

% Suc_mono
tff(fact_102_Suc__less__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Ma)),aa(nat,nat,suc,Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% Suc_less_eq
tff(fact_103_nat__add__left__cancel__less,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% nat_add_left_cancel_less
tff(fact_104_nth__take,axiom,
    ! [A: $tType,I3: nat,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),Nb)
     => ( aa(nat,A,nth(A,take(A,Nb,Xs)),I3) = aa(nat,A,nth(A,Xs),I3) ) ) ).

% nth_take
tff(fact_105_nth__map,axiom,
    ! [B: $tType,A: $tType,Nb: nat,Xs: list(A),F3: fun(A,B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,B,nth(B,aa(list(A),list(B),map(A,B,F3),Xs)),Nb) = aa(A,B,F3,aa(nat,A,nth(A,Xs),Nb)) ) ) ).

% nth_map
tff(fact_106_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),Nb: nat,Ma: nat] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,N)),aa(nat,A,F3,aa(nat,nat,suc,N)))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,Nb)),aa(nat,A,F3,Ma))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma) ) ) ) ).

% lift_Suc_mono_less_iff
tff(fact_107_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),Nb: nat,N2: nat] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,N)),aa(nat,A,F3,aa(nat,nat,suc,N)))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),N2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,Nb)),aa(nat,A,F3,N2)) ) ) ) ).

% lift_Suc_mono_less
tff(fact_108_nat__neq__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( Ma != Nb )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma) ) ) ).

% nat_neq_iff
tff(fact_109_less__not__refl,axiom,
    ! [Nb: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Nb) ).

% less_not_refl
tff(fact_110_less__not__refl2,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
     => ( Ma != Nb ) ) ).

% less_not_refl2
tff(fact_111_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),S),T2)
     => ( S != T2 ) ) ).

% less_not_refl3
tff(fact_112_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( wellorder(B)
     => ! [F3: fun(A,B),P: fun(A,$o),A2: A] :
          ( ! [X4: A] :
              ( ! [Y3: A] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,Y3)),aa(A,B,F3,X4))
                 => aa(A,$o,P,Y3) )
             => aa(A,$o,P,X4) )
         => aa(A,$o,P,A2) ) ) ).

% measure_induct
tff(fact_113_less__irrefl__nat,axiom,
    ! [Nb: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Nb) ).

% less_irrefl_nat
tff(fact_114_nat__less__induct,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( ! [N: nat] :
          ( ! [M: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
             => aa(nat,$o,P,M) )
         => aa(nat,$o,P,N) )
     => aa(nat,$o,P,Nb) ) ).

% nat_less_induct
tff(fact_115_infinite__descent,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( ! [N: nat] :
          ( ~ aa(nat,$o,P,N)
         => ? [M: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
              & ~ aa(nat,$o,P,M) ) )
     => aa(nat,$o,P,Nb) ) ).

% infinite_descent
tff(fact_116_linorder__neqE__nat,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( X2 != Y2 )
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),Y2)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y2),X2) ) ) ).

% linorder_neqE_nat
tff(fact_117_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( wellorder(B)
     => ! [F3: fun(A,B),P: fun(A,$o),A2: A] :
          ( ! [X4: A] :
              ( ! [Y3: A] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,Y3)),aa(A,B,F3,X4))
                 => aa(A,$o,P,Y3) )
             => aa(A,$o,P,X4) )
         => aa(A,$o,P,A2) ) ) ).

% measure_induct_rule
tff(fact_118_infinite__descent__measure,axiom,
    ! [A: $tType,P: fun(A,$o),V2: fun(A,nat),X2: A] :
      ( ! [X4: A] :
          ( ~ aa(A,$o,P,X4)
         => ? [Y3: A] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,V2,Y3)),aa(A,nat,V2,X4))
              & ~ aa(A,$o,P,Y3) ) )
     => aa(A,$o,P,X2) ) ).

% infinite_descent_measure
tff(fact_119_nth__equalityI,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
     => ( ! [I2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,nth(A,Ys),I2) ) )
       => ( Xs = Ys ) ) ) ).

% nth_equalityI
tff(fact_120_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: fun(nat,fun(A,$o))] :
      ( ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),K)
         => ? [X_12: A] : aa(A,$o,aa(nat,fun(A,$o),P,I),X_12) )
    <=> ? [Xs3: list(A)] :
          ( ( aa(list(A),nat,size_size(list(A)),Xs3) = K )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),K)
             => aa(A,$o,aa(nat,fun(A,$o),P,I),aa(nat,A,nth(A,Xs3),I)) ) ) ) ).

% Skolem_list_nth
tff(fact_121_list__eq__iff__nth__eq,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs = Ys )
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,A,nth(A,Xs),I) = aa(nat,A,nth(A,Ys),I) ) ) ) ) ).

% list_eq_iff_nth_eq
tff(fact_122_Nat_OlessE,axiom,
    ! [I3: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),K)
     => ( ( K != aa(nat,nat,suc,I3) )
       => ~ ! [J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J)
             => ( K != aa(nat,nat,suc,J) ) ) ) ) ).

% Nat.lessE
tff(fact_123_Suc__lessD,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Ma)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% Suc_lessD
tff(fact_124_Suc__lessE,axiom,
    ! [I3: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I3)),K)
     => ~ ! [J: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J)
           => ( K != aa(nat,nat,suc,J) ) ) ) ).

% Suc_lessE
tff(fact_125_Suc__lessI,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ( ( aa(nat,nat,suc,Ma) != Nb )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Ma)),Nb) ) ) ).

% Suc_lessI
tff(fact_126_less__SucE,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,suc,Nb))
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
       => ( Ma = Nb ) ) ) ).

% less_SucE
tff(fact_127_less__SucI,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,suc,Nb)) ) ).

% less_SucI
tff(fact_128_Ex__less__Suc,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,Nb))
          & aa(nat,$o,P,I) )
    <=> ( aa(nat,$o,P,Nb)
        | ? [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Nb)
            & aa(nat,$o,P,I) ) ) ) ).

% Ex_less_Suc
tff(fact_129_less__Suc__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,suc,Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
        | ( Ma = Nb ) ) ) ).

% less_Suc_eq
tff(fact_130_not__less__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,suc,Ma)) ) ).

% not_less_eq
tff(fact_131_All__less__Suc,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,Nb))
         => aa(nat,$o,P,I) )
    <=> ( aa(nat,$o,P,Nb)
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Nb)
           => aa(nat,$o,P,I) ) ) ) ).

% All_less_Suc
tff(fact_132_Suc__less__eq2,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Nb)),Ma)
    <=> ? [M2: nat] :
          ( ( Ma = aa(nat,nat,suc,M2) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),M2) ) ) ).

% Suc_less_eq2
tff(fact_133_less__antisym,axiom,
    ! [Nb: nat,Ma: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,suc,Ma))
       => ( Ma = Nb ) ) ) ).

% less_antisym
tff(fact_134_Suc__less__SucD,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Ma)),aa(nat,nat,suc,Nb))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% Suc_less_SucD
tff(fact_135_less__trans__Suc,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I3)),K) ) ) ).

% less_trans_Suc
tff(fact_136_less__Suc__induct,axiom,
    ! [I3: nat,J2: nat,P: fun(nat,fun(nat,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ( ! [I2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,I2),aa(nat,nat,suc,I2))
       => ( ! [I2: nat,J: nat,K2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),K2)
               => ( aa(nat,$o,aa(nat,fun(nat,$o),P,I2),J)
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),P,J),K2)
                   => aa(nat,$o,aa(nat,fun(nat,$o),P,I2),K2) ) ) ) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,I3),J2) ) ) ) ).

% less_Suc_induct
tff(fact_137_strict__inc__induct,axiom,
    ! [I3: nat,J2: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ( ! [I2: nat] :
            ( ( J2 = aa(nat,nat,suc,I2) )
           => aa(nat,$o,P,I2) )
       => ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
             => ( aa(nat,$o,P,aa(nat,nat,suc,I2))
               => aa(nat,$o,P,I2) ) )
         => aa(nat,$o,P,I3) ) ) ) ).

% strict_inc_induct
tff(fact_138_not__less__less__Suc__eq,axiom,
    ! [Nb: nat,Ma: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,suc,Ma))
      <=> ( Nb = Ma ) ) ) ).

% not_less_less_Suc_eq
tff(fact_139_add__lessD1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),J2)),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),K) ) ).

% add_lessD1
tff(fact_140_add__less__mono,axiom,
    ! [I3: nat,J2: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),L)) ) ) ).

% add_less_mono
tff(fact_141_not__add__less1,axiom,
    ! [I3: nat,J2: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),J2)),I3) ).

% not_add_less1
tff(fact_142_not__add__less2,axiom,
    ! [J2: nat,I3: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),I3)),I3) ).

% not_add_less2
tff(fact_143_add__less__mono1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) ) ).

% add_less_mono1
tff(fact_144_trans__less__add1,axiom,
    ! [I3: nat,J2: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),Ma)) ) ).

% trans_less_add1
tff(fact_145_trans__less__add2,axiom,
    ! [I3: nat,J2: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),J2)) ) ).

% trans_less_add2
tff(fact_146_less__add__eq__less,axiom,
    ! [K: nat,L: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),L)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),L) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Nb) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ).

% less_add_eq_less
tff(fact_147_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X3) )
    <=> ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
         => aa(A,$o,P,aa(nat,A,nth(A,Xs),I)) ) ) ).

% all_set_conv_all_nth
tff(fact_148_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o),X2: A] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
         => aa(A,$o,P,aa(nat,A,nth(A,Xs),I2)) )
     => ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
       => aa(A,$o,P,X2) ) ) ).

% all_nth_imp_all_set
tff(fact_149_in__set__conv__nth,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
    <=> ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
          & ( aa(nat,A,nth(A,Xs),I) = X2 ) ) ) ).

% in_set_conv_nth
tff(fact_150_list__ball__nth,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),P: fun(A,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
           => aa(A,$o,P,X4) )
       => aa(A,$o,P,aa(nat,A,nth(A,Xs),Nb)) ) ) ).

% list_ball_nth
tff(fact_151_nth__mem,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => aa(set(A),$o,member(A,aa(nat,A,nth(A,Xs),Nb)),aa(list(A),set(A),set2(A),Xs)) ) ).

% nth_mem
tff(fact_152_VEBT_Oexhaust,axiom,
    ! [Y2: vEBT_VEBT] :
      ( ! [X112: option(product_prod(nat,nat)),X122: nat,X132: list(vEBT_VEBT),X142: vEBT_VEBT] : ( Y2 != vEBT_Node(X112,X122,X132,X142) )
     => ~ ! [X212: $o,X223: $o] : ( Y2 != vEBT_Leaf(X212,X223) ) ) ).

% VEBT.exhaust
tff(fact_153_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT,X21: $o,X222: $o] : ( vEBT_Node(X11,X12,X13,X14) != vEBT_Leaf(X21,X222) ) ).

% VEBT.distinct(1)
tff(fact_154_length__induct,axiom,
    ! [A: $tType,P: fun(list(A),$o),Xs: list(A)] :
      ( ! [Xs2: list(A)] :
          ( ! [Ys2: list(A)] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),Ys2)),aa(list(A),nat,size_size(list(A)),Xs2))
             => aa(list(A),$o,P,Ys2) )
         => aa(list(A),$o,P,Xs2) )
     => aa(list(A),$o,P,Xs) ) ).

% length_induct
tff(fact_155_VEBT__internal_Oelim__dead_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,Uu: extended_enat] : ( vEBT_VEBT_elim_dead(vEBT_Leaf(A2,B2),Uu) = vEBT_Leaf(A2,B2) ) ).

% VEBT_internal.elim_dead.simps(1)
tff(fact_156_less__imp__Suc__add,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ? [K2: nat] : ( Nb = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K2)) ) ) ).

% less_imp_Suc_add
tff(fact_157_less__iff__Suc__add,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
    <=> ? [K3: nat] : ( Nb = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K3)) ) ) ).

% less_iff_Suc_add
tff(fact_158_less__add__Suc2,axiom,
    ! [I3: nat,Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),I3))) ).

% less_add_Suc2
tff(fact_159_less__add__Suc1,axiom,
    ! [I3: nat,Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),Ma))) ).

% less_add_Suc1
tff(fact_160_less__natE,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ~ ! [Q3: nat] : ( Nb != aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Q3)) ) ) ).

% less_natE
tff(fact_161_VEBT_Osimps_I6_J,axiom,
    ! [A: $tType,F1: fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A)))),F2: fun($o,fun($o,A)),X21: $o,X222: $o] : ( vEBT_case_VEBT(A,F1,F2,vEBT_Leaf(X21,X222)) = aa($o,A,aa($o,fun($o,A),F2,X21),X222) ) ).

% VEBT.simps(6)
tff(fact_162_Suc__inject,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( aa(nat,nat,suc,X2) = aa(nat,nat,suc,Y2) )
     => ( X2 = Y2 ) ) ).

% Suc_inject
tff(fact_163_n__not__Suc__n,axiom,
    ! [Nb: nat] : ( Nb != aa(nat,nat,suc,Nb) ) ).

% n_not_Suc_n
tff(fact_164_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( size(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(A,nat,size_size(A),X2) != aa(A,nat,size_size(A),Y2) )
         => ( X2 != Y2 ) ) ) ).

% size_neq_size_imp_neq
tff(fact_165_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% field_less_half_sum
tff(fact_166_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),A2) )
     => ( aa(nat,nat,suc,A3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,suc,A2)) ) ) ).

% nat_arith.suc1
tff(fact_167_add__Suc,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,Ma)),Nb) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) ) ).

% add_Suc
tff(fact_168_add__Suc__shift,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,Ma)),Nb) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),aa(nat,nat,suc,Nb)) ) ).

% add_Suc_shift
tff(fact_169_both__member__options__ding,axiom,
    ! [Infoa: option(product_prod(nat,nat)),Degb: nat,TreeListb: list(vEBT_VEBT),Summaryb: vEBT_VEBT,Nb: nat,X2: nat] :
      ( vEBT_invar_vebt(vEBT_Node(Infoa,Degb,TreeListb,Summaryb),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Degb))
       => ( aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),vEBT_VEBT_high(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),vEBT_VEBT_low(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))
         => aa(nat,$o,vEBT_V8194947554948674370ptions(vEBT_Node(Infoa,Degb,TreeListb,Summaryb)),X2) ) ) ) ).

% both_member_options_ding
tff(fact_170_high__inv,axiom,
    ! [X2: nat,Nb: nat,Y2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))
     => ( vEBT_VEBT_high(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Y2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))),X2),Nb) = Y2 ) ) ).

% high_inv
tff(fact_171_less__exp,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ).

% less_exp
tff(fact_172_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_cancel_left
tff(fact_173_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_cancel_right
tff(fact_174_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y22: num] :
      ( ( aa(num,num,bit0,X22) = aa(num,num,bit0,Y22) )
    <=> ( X22 = Y22 ) ) ).

% verit_eq_simplify(8)
tff(fact_175_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,V))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),W)) ) ).

% zdiv_numeral_Bit0
tff(fact_176_add__left__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add_left_cancel
tff(fact_177_add__right__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
        <=> ( B2 = C2 ) ) ) ).

% add_right_cancel
tff(fact_178_plus__enat__def,axiom,
    ! [Ma: extended_enat,Nb: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Ma),Nb) = extended_case_enat(extended_enat,aTP_Lamp_ah(extended_enat,fun(nat,extended_enat),Nb),extend4730790105801354508finity(extended_enat),Ma) ) ).

% plus_enat_def
tff(fact_179_length__subseqs,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(list(A)),nat,size_size(list(list(A))),subseqs(A,Xs)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_subseqs
tff(fact_180_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,Nb: nat] :
      ( vEBT_invar_vebt(T2,Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ).

% deg_not_0
tff(fact_181_enat__ord__simps_I6_J,axiom,
    ! [Q2: extended_enat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extend4730790105801354508finity(extended_enat)),Q2) ).

% enat_ord_simps(6)
tff(fact_182_enat__ord__simps_I4_J,axiom,
    ! [Q2: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Q2),extend4730790105801354508finity(extended_enat))
    <=> ( Q2 != extend4730790105801354508finity(extended_enat) ) ) ).

% enat_ord_simps(4)
tff(fact_183_not__gr__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Nb: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Nb)
        <=> ( Nb = zero_zero(A) ) ) ) ).

% not_gr_zero
tff(fact_184_add__0,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% add_0
tff(fact_185_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X2: A,Y2: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2) )
        <=> ( ( X2 = zero_zero(A) )
            & ( Y2 = zero_zero(A) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
tff(fact_186_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2) = zero_zero(A) )
        <=> ( ( X2 = zero_zero(A) )
            & ( Y2 = zero_zero(A) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
tff(fact_187_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_right
tff(fact_188_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_left
tff(fact_189_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = A2 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_right
tff(fact_190_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = A2 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_left
tff(fact_191_double__zero__sym,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% double_zero_sym
tff(fact_192_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% add.right_neutral
tff(fact_193_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),Ma),Nb)) ) ) ).

% numeral_times_numeral
tff(fact_194_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [V: num,W: num,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W))),Z) ) ) ).

% mult_numeral_left_semiring_numeral
tff(fact_195_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% bits_div_by_0
tff(fact_196_bits__div__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% bits_div_0
tff(fact_197_low__inv,axiom,
    ! [X2: nat,Nb: nat,Y2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))
     => ( vEBT_VEBT_low(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Y2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))),X2),Nb) = X2 ) ) ).

% low_inv
tff(fact_198_less__nat__zero__code,axiom,
    ! [Nb: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),zero_zero(nat)) ).

% less_nat_zero_code
tff(fact_199_neq0__conv,axiom,
    ! [Nb: nat] :
      ( ( Nb != zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ).

% neq0_conv
tff(fact_200_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( A2 != zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),A2) ) ).

% bot_nat_0.not_eq_extremum
tff(fact_201_Nat_Oadd__0__right,axiom,
    ! [Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),zero_zero(nat)) = Ma ) ).

% Nat.add_0_right
tff(fact_202_add__is__0,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb) = zero_zero(nat) )
    <=> ( ( Ma = zero_zero(nat) )
        & ( Nb = zero_zero(nat) ) ) ) ).

% add_is_0
tff(fact_203_mult__is__0,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb) = zero_zero(nat) )
    <=> ( ( Ma = zero_zero(nat) )
        | ( Nb = zero_zero(nat) ) ) ) ).

% mult_is_0
tff(fact_204_mult__0__right,axiom,
    ! [Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),zero_zero(nat)) = zero_zero(nat) ) ).

% mult_0_right
tff(fact_205_mult__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb) )
    <=> ( ( Ma = Nb )
        | ( K = zero_zero(nat) ) ) ) ).

% mult_cancel1
tff(fact_206_mult__cancel2,axiom,
    ! [Ma: nat,K: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),K) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K) )
    <=> ( ( Ma = Nb )
        | ( K = zero_zero(nat) ) ) ) ).

% mult_cancel2
tff(fact_207_enat__ord__simps_I2_J,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(Ma)),extended_enat2(Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% enat_ord_simps(2)
tff(fact_208_semiring__norm_I78_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit0,Ma)),aa(num,num,bit0,Nb))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),Nb) ) ).

% semiring_norm(78)
tff(fact_209_semiring__norm_I75_J,axiom,
    ! [Ma: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),one2) ).

% semiring_norm(75)
tff(fact_210_enat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: fun(nat,A),F2: A,Nat: nat] : ( extended_case_enat(A,F1,F2,extended_enat2(Nat)) = aa(nat,A,F1,Nat) ) ).

% enat.simps(4)
tff(fact_211_enat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: fun(nat,A),F2: A] : ( extended_case_enat(A,F1,F2,extend4730790105801354508finity(extended_enat)) = F2 ) ).

% enat.simps(5)
tff(fact_212_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
tff(fact_213_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
tff(fact_214_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ).

% less_add_same_cancel2
tff(fact_215_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ).

% less_add_same_cancel1
tff(fact_216_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% add_less_same_cancel2
tff(fact_217_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% add_less_same_cancel1
tff(fact_218_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Y2)) = zero_zero(A) )
        <=> ( ( X2 = zero_zero(A) )
            & ( Y2 = zero_zero(A) ) ) ) ) ).

% sum_squares_eq_zero_iff
tff(fact_219_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% div_mult_mult1
tff(fact_220_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% div_mult_mult2
tff(fact_221_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          = $ite(C2 = zero_zero(A),zero_zero(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ).

% div_mult_mult1_if
tff(fact_222_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [A2: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% distrib_right_numeral
tff(fact_223_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% distrib_left_numeral
tff(fact_224_power__0__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: nat] : ( aa(nat,A,power_power(A,zero_zero(A)),aa(nat,nat,suc,Nb)) = zero_zero(A) ) ) ).

% power_0_Suc
tff(fact_225_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(nat,A,power_power(A,zero_zero(A)),aa(num,nat,numeral_numeral(nat),K)) = zero_zero(A) ) ) ).

% power_zero_numeral
tff(fact_226_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,power_power(A,A2),aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% power_Suc0_right
tff(fact_227_less__Suc0,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))
    <=> ( Nb = zero_zero(nat) ) ) ).

% less_Suc0
tff(fact_228_zero__less__Suc,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,suc,Nb)) ).

% zero_less_Suc
tff(fact_229_add__gr__0,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ) ).

% add_gr_0
tff(fact_230_mult__eq__1__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( Ma = aa(nat,nat,suc,zero_zero(nat)) )
        & ( Nb = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% mult_eq_1_iff
tff(fact_231_one__eq__mult__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,suc,zero_zero(nat)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb) )
    <=> ( ( Ma = aa(nat,nat,suc,zero_zero(nat)) )
        & ( Nb = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% one_eq_mult_iff
tff(fact_232_nat__0__less__mult__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ) ).

% nat_0_less_mult_iff
tff(fact_233_mult__less__cancel2,axiom,
    ! [Ma: nat,K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ).

% mult_less_cancel2
tff(fact_234_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ).

% nat_mult_less_cancel_disj
tff(fact_235_mult__Suc__right,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),aa(nat,nat,suc,Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)) ) ).

% mult_Suc_right
tff(fact_236_div__by__Suc__0,axiom,
    ! [Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(nat,nat,suc,zero_zero(nat))) = Ma ) ).

% div_by_Suc_0
tff(fact_237_power__Suc__0,axiom,
    ! [Nb: nat] : ( aa(nat,nat,power_power(nat,aa(nat,nat,suc,zero_zero(nat))),Nb) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% power_Suc_0
tff(fact_238_nat__power__eq__Suc__0__iff,axiom,
    ! [X2: nat,Ma: nat] :
      ( ( aa(nat,nat,power_power(nat,X2),Ma) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( Ma = zero_zero(nat) )
        | ( X2 = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% nat_power_eq_Suc_0_iff
tff(fact_239_div__less,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb) = zero_zero(nat) ) ) ).

% div_less
tff(fact_240_nat__zero__less__power__iff,axiom,
    ! [X2: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,power_power(nat,X2),Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),X2)
        | ( Nb = zero_zero(nat) ) ) ) ).

% nat_zero_less_power_iff
tff(fact_241_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))
      = $ite(K = zero_zero(nat),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)) ) ).

% nat_mult_div_cancel_disj
tff(fact_242_semiring__norm_I76_J,axiom,
    ! [Nb: num] : aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),aa(num,num,bit0,Nb)) ).

% semiring_norm(76)
tff(fact_243_enat__ord__number_I2_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),Ma)),aa(num,extended_enat,numeral_numeral(extended_enat),Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),Ma)),aa(num,nat,numeral_numeral(nat),Nb)) ) ).

% enat_ord_number(2)
tff(fact_244_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,W: num] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)) )
        <=> $ite(aa(num,A,numeral_numeral(A),W) != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W)) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral1(1)
tff(fact_245_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W: num,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)) = A2 )
        <=> $ite(aa(num,A,numeral_numeral(A),W) != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W)),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral1(1)
tff(fact_246_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))),B2) ) ) ).

% less_divide_eq_numeral1(1)
tff(fact_247_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) ) ) ).

% divide_less_eq_numeral1(1)
tff(fact_248_div__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_mult_self4
tff(fact_249_div__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_mult_self3
tff(fact_250_div__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_mult_self2
tff(fact_251_div__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_mult_self1
tff(fact_252_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A,Nb: nat] :
          ( ( aa(nat,A,power_power(A,A2),Nb) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ) ) ).

% power_eq_0_iff
tff(fact_253_div__mult__self1__is__m,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Ma)),Nb) = Ma ) ) ).

% div_mult_self1_is_m
tff(fact_254_div__mult__self__is__m,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)),Nb) = Ma ) ) ).

% div_mult_self_is_m
tff(fact_255_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Ma: num,Nb: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),Ma))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),Nb))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb)))),B2) ) ) ).

% power_add_numeral2
tff(fact_256_power__add__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),Ma))),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),Nb))) = aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb))) ) ) ).

% power_add_numeral
tff(fact_257_numeral__less__enat__iff,axiom,
    ! [Ma: num,Nb: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),Ma)),extended_enat2(Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),Ma)),Nb) ) ).

% numeral_less_enat_iff
tff(fact_258_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A] :
          ( ( aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% zero_eq_power2
tff(fact_259_zero__less__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% zero_less_power2
tff(fact_260_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = zero_zero(A) )
        <=> ( ( X2 = zero_zero(A) )
            & ( Y2 = zero_zero(A) ) ) ) ) ).

% sum_power2_eq_zero_iff
tff(fact_261_option_Osize__neq,axiom,
    ! [A: $tType,X2: option(A)] : ( aa(option(A),nat,size_size(option(A)),X2) != zero_zero(nat) ) ).

% option.size_neq
tff(fact_262_mult__0,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),zero_zero(nat)),Nb) = zero_zero(nat) ) ).

% mult_0
tff(fact_263_zero__reorient,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [X2: A] :
          ( ( zero_zero(A) = X2 )
        <=> ( X2 = zero_zero(A) ) ) ) ).

% zero_reorient
tff(fact_264_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.left_commute
tff(fact_265_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2) ) ) ).

% mult.commute
tff(fact_266_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_mult(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.assoc
tff(fact_267_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
tff(fact_268_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb) )
    <=> ( ( K = zero_zero(nat) )
        | ( Ma = Nb ) ) ) ).

% nat_mult_eq_cancel_disj
tff(fact_269_subseqs__refl,axiom,
    ! [A: $tType,Xs: list(A)] : aa(set(list(A)),$o,member(list(A),Xs),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs))) ).

% subseqs_refl
tff(fact_270_mult__less__mono2,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),I3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),J2)) ) ) ).

% mult_less_mono2
tff(fact_271_mult__less__mono1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),K)) ) ) ).

% mult_less_mono1
tff(fact_272_nat__mult__eq__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb) )
      <=> ( Ma = Nb ) ) ) ).

% nat_mult_eq_cancel1
tff(fact_273_nat__mult__less__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ).

% nat_mult_less_cancel1
tff(fact_274_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X2: A,Y2: A,Nb: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2) = aa(A,A,aa(A,fun(A,A),times_times(A),Y2),X2) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),Nb)),Y2) = aa(A,A,aa(A,fun(A,A),times_times(A),Y2),aa(nat,A,power_power(A,X2),Nb)) ) ) ) ).

% power_commuting_commutes
tff(fact_275_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),Nb) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb)) ) ) ).

% power_mult_distrib
tff(fact_276_power__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),Nb)),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% power_commutes
tff(fact_277_power__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Ma: nat,Nb: nat] : ( aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)) = aa(nat,A,power_power(A,aa(nat,A,power_power(A,A2),Ma)),Nb) ) ) ).

% power_mult
tff(fact_278_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Nb: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Nb)
        <=> ( Nb != zero_zero(A) ) ) ) ).

% zero_less_iff_neq_zero
tff(fact_279_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Ma: A,Nb: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Ma),Nb)
         => ( Nb != zero_zero(A) ) ) ) ).

% gr_implies_not_zero
tff(fact_280_not__less__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Nb: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Nb),zero_zero(A)) ) ).

% not_less_zero
tff(fact_281_gr__zeroI,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Nb: A] :
          ( ( Nb != zero_zero(A) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Nb) ) ) ).

% gr_zeroI
tff(fact_282_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% verit_sum_simplify
tff(fact_283_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% add.group_left_neutral
tff(fact_284_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% add.comm_neutral
tff(fact_285_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% comm_monoid_add_class.add_0
tff(fact_286_power__not__zero,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A,Nb: nat] :
          ( ( A2 != zero_zero(A) )
         => ( aa(nat,A,power_power(A,A2),Nb) != zero_zero(A) ) ) ) ).

% power_not_zero
tff(fact_287_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Y2)))
        <=> ( ( X2 != zero_zero(A) )
            | ( Y2 != zero_zero(A) ) ) ) ) ).

% sum_squares_gt_zero_iff
tff(fact_288_zero__power,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( aa(nat,A,power_power(A,zero_zero(A)),Nb) = zero_zero(A) ) ) ) ).

% zero_power
tff(fact_289_num_Osize_I4_J,axiom,
    aa(num,nat,size_size(num),one2) = zero_zero(nat) ).

% num.size(4)
tff(fact_290_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] : ( aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),vEBT_Leaf(X21,X222)) = zero_zero(nat) ) ).

% VEBT.size(4)
tff(fact_291_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num,B2: A,C2: A] :
          ( ( aa(num,A,numeral_numeral(A),W) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2) = B2,aa(num,A,numeral_numeral(A),W) = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral(1)
tff(fact_292_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W: num] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = aa(num,A,numeral_numeral(A),W) )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2),aa(num,A,numeral_numeral(A),W) = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral(1)
tff(fact_293_one__less__mult,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Ma)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)) ) ) ).

% one_less_mult
tff(fact_294_n__less__m__mult__n,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Ma)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)) ) ) ).

% n_less_m_mult_n
tff(fact_295_n__less__n__mult__m,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Ma)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Ma)) ) ) ).

% n_less_n_mult_m
tff(fact_296_div__less__iff__less__mult,axiom,
    ! [Q2: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Q2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Q2)),Nb)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q2)) ) ) ).

% div_less_iff_less_mult
tff(fact_297_nat__mult__div__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb) ) ) ).

% nat_mult_div_cancel1
tff(fact_298_Suc__mult__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Ma) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Nb) )
    <=> ( Ma = Nb ) ) ).

% Suc_mult_cancel1
tff(fact_299_left__add__mult__distrib,axiom,
    ! [I3: nat,U: nat,J2: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),J2)),U)),K) ) ).

% left_add_mult_distrib
tff(fact_300_add__mult__distrib2,axiom,
    ! [K: nat,Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb)) ) ).

% add_mult_distrib2
tff(fact_301_add__mult__distrib,axiom,
    ! [Ma: nat,Nb: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K)) ) ).

% add_mult_distrib
tff(fact_302_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),zero_zero(A)) ) ).

% less_numeral_extra(3)
tff(fact_303_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D1: A,D22: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D1)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D22)
           => ? [E: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),E),D1)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),E),D22) ) ) ) ) ).

% field_lbound_gt_zero
tff(fact_304_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: num] : ( zero_zero(A) != aa(num,A,numeral_numeral(A),Nb) ) ) ).

% zero_neq_numeral
tff(fact_305_div__mult2__eq,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),Q2) ) ).

% div_mult2_eq
tff(fact_306_vebt__buildup_Ocases,axiom,
    ! [X2: nat] :
      ( ( X2 != zero_zero(nat) )
     => ( ( X2 != aa(nat,nat,suc,zero_zero(nat)) )
       => ~ ! [Va: nat] : ( X2 != aa(nat,nat,suc,aa(nat,nat,suc,Va)) ) ) ) ).

% vebt_buildup.cases
tff(fact_307_not0__implies__Suc,axiom,
    ! [Nb: nat] :
      ( ( Nb != zero_zero(nat) )
     => ? [M3: nat] : ( Nb = aa(nat,nat,suc,M3) ) ) ).

% not0_implies_Suc
tff(fact_308_Zero__not__Suc,axiom,
    ! [Ma: nat] : ( zero_zero(nat) != aa(nat,nat,suc,Ma) ) ).

% Zero_not_Suc
tff(fact_309_Zero__neq__Suc,axiom,
    ! [Ma: nat] : ( zero_zero(nat) != aa(nat,nat,suc,Ma) ) ).

% Zero_neq_Suc
tff(fact_310_Suc__neq__Zero,axiom,
    ! [Ma: nat] : ( aa(nat,nat,suc,Ma) != zero_zero(nat) ) ).

% Suc_neq_Zero
tff(fact_311_zero__induct,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [N: nat] :
            ( aa(nat,$o,P,aa(nat,nat,suc,N))
           => aa(nat,$o,P,N) )
       => aa(nat,$o,P,zero_zero(nat)) ) ) ).

% zero_induct
tff(fact_312_diff__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),Ma: nat,Nb: nat] :
      ( ! [X4: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,X4),zero_zero(nat))
     => ( ! [Y4: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,zero_zero(nat)),aa(nat,nat,suc,Y4))
       => ( ! [X4: nat,Y4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),P,X4),Y4)
             => aa(nat,$o,aa(nat,fun(nat,$o),P,aa(nat,nat,suc,X4)),aa(nat,nat,suc,Y4)) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,Ma),Nb) ) ) ) ).

% diff_induct
tff(fact_313_nat__induct,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N: nat] :
            ( aa(nat,$o,P,N)
           => aa(nat,$o,P,aa(nat,nat,suc,N)) )
       => aa(nat,$o,P,Nb) ) ) ).

% nat_induct
tff(fact_314_old_Onat_Oexhaust,axiom,
    ! [Y2: nat] :
      ( ( Y2 != zero_zero(nat) )
     => ~ ! [Nat3: nat] : ( Y2 != aa(nat,nat,suc,Nat3) ) ) ).

% old.nat.exhaust
tff(fact_315_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat = aa(nat,nat,suc,X22) )
     => ( Nat != zero_zero(nat) ) ) ).

% nat.discI
tff(fact_316_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] : ( zero_zero(nat) != aa(nat,nat,suc,Nat2) ) ).

% old.nat.distinct(1)
tff(fact_317_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat2: nat] : ( aa(nat,nat,suc,Nat2) != zero_zero(nat) ) ).

% old.nat.distinct(2)
tff(fact_318_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] : ( zero_zero(nat) != aa(nat,nat,suc,X22) ) ).

% nat.distinct(1)
tff(fact_319_enat__iless,axiom,
    ! [Nb: extended_enat,Ma: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Nb),extended_enat2(Ma))
     => ? [K2: nat] : ( Nb = extended_enat2(K2) ) ) ).

% enat_iless
tff(fact_320_chain__incr,axiom,
    ! [A: $tType,Y5: fun(A,extended_enat),K: nat] :
      ( ! [I2: A] :
        ? [J3: A] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(A,extended_enat,Y5,I2)),aa(A,extended_enat,Y5,J3))
     => ? [J: A] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(K)),aa(A,extended_enat,Y5,J)) ) ).

% chain_incr
tff(fact_321_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: fun(A,nat),P: fun(A,$o),X2: A] :
      ( ! [X4: A] :
          ( ( aa(A,nat,V2,X4) = zero_zero(nat) )
         => aa(A,$o,P,X4) )
     => ( ! [X4: A] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,V2,X4))
           => ( ~ aa(A,$o,P,X4)
             => ? [Y3: A] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,V2,Y3)),aa(A,nat,V2,X4))
                  & ~ aa(A,$o,P,Y3) ) ) )
       => aa(A,$o,P,X2) ) ) ).

% infinite_descent0_measure
tff(fact_322_infinite__descent0,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( ~ aa(nat,$o,P,N)
             => ? [M: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
                  & ~ aa(nat,$o,P,M) ) ) )
       => aa(nat,$o,P,Nb) ) ) ).

% infinite_descent0
tff(fact_323_gr__implies__not0,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ( Nb != zero_zero(nat) ) ) ).

% gr_implies_not0
tff(fact_324_less__zeroE,axiom,
    ! [Nb: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),zero_zero(nat)) ).

% less_zeroE
tff(fact_325_not__less0,axiom,
    ! [Nb: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),zero_zero(nat)) ).

% not_less0
tff(fact_326_not__gr0,axiom,
    ! [Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
    <=> ( Nb = zero_zero(nat) ) ) ).

% not_gr0
tff(fact_327_gr0I,axiom,
    ! [Nb: nat] :
      ( ( Nb != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ).

% gr0I
tff(fact_328_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),zero_zero(nat)) ).

% bot_nat_0.extremum_strict
tff(fact_329_add__eq__self__zero,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb) = Ma )
     => ( Nb = zero_zero(nat) ) ) ).

% add_eq_self_zero
tff(fact_330_plus__nat_Oadd__0,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),zero_zero(nat)),Nb) = Nb ) ).

% plus_nat.add_0
tff(fact_331_power__Suc,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A2: A,Nb: nat] : ( aa(nat,A,power_power(A,A2),aa(nat,nat,suc,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% power_Suc
tff(fact_332_power__Suc2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Nb: nat] : ( aa(nat,A,power_power(A,A2),aa(nat,nat,suc,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),Nb)),A2) ) ) ).

% power_Suc2
tff(fact_333_power__add,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Ma: nat,Nb: nat] : ( aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),Ma)),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% power_add
tff(fact_334_pos__add__strict,axiom,
    ! [A: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% pos_add_strict
tff(fact_335_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ ! [C3: A] :
                ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C3) )
               => ( C3 = zero_zero(A) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
tff(fact_336_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_pos_pos
tff(fact_337_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_neg_neg
tff(fact_338_zero__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% zero_less_power
tff(fact_339_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),W)),zero_zero(A))) ) ) ) ).

% less_divide_eq_numeral(1)
tff(fact_340_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(num,A,numeral_numeral(A),W))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W))) ) ) ) ).

% divide_less_eq_numeral(1)
tff(fact_341_nat__power__less__imp__less,axiom,
    ! [I3: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),I3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,power_power(nat,I3),Ma)),aa(nat,nat,power_power(nat,I3),Nb))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ).

% nat_power_less_imp_less
tff(fact_342_option_Osize_I3_J,axiom,
    ! [A: $tType] : ( aa(option(A),nat,size_size(option(A)),none(A)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size(3)
tff(fact_343_dividend__less__times__div,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)))) ) ).

% dividend_less_times_div
tff(fact_344_dividend__less__div__times,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),Nb))) ) ).

% dividend_less_div_times
tff(fact_345_split__div,axiom,
    ! [P: fun(nat,$o),Ma: nat,Nb: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb))
    <=> ( ( ( Nb = zero_zero(nat) )
         => aa(nat,$o,P,zero_zero(nat)) )
        & ( ( Nb != zero_zero(nat) )
         => ! [I: nat,J4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),Nb)
             => ( ( Ma = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),I)),J4) )
               => aa(nat,$o,P,I) ) ) ) ) ) ).

% split_div
tff(fact_346_power__odd__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Nb: nat] : ( aa(nat,A,power_power(A,A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,aa(nat,A,power_power(A,A2),Nb)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% power_odd_eq
tff(fact_347_num_Osize_I5_J,axiom,
    ! [X22: num] : ( aa(num,nat,size_size(num),aa(num,num,bit0,X22)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,size_size(num),X22)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size(5)
tff(fact_348_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),one2)) = A2 ) ) ).

% mult_numeral_1_right
tff(fact_349_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),one2)),A2) = A2 ) ) ).

% mult_numeral_1
tff(fact_350_Suc__mult__less__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% Suc_mult_less_cancel1
tff(fact_351_mult__Suc,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Ma)),Nb) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)) ) ).

% mult_Suc
tff(fact_352_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),Nb)) ) ).

% zero_less_numeral
tff(fact_353_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Nb)),zero_zero(A)) ) ).

% not_numeral_less_zero
tff(fact_354_less__mult__imp__div__less,axiom,
    ! [Ma: nat,I3: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),Nb))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),I3) ) ).

% less_mult_imp_div_less
tff(fact_355_less__enatE,axiom,
    ! [Nb: extended_enat,Ma: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Nb),extended_enat2(Ma))
     => ~ ! [K2: nat] :
            ( ( Nb = extended_enat2(K2) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K2),Ma) ) ) ).

% less_enatE
tff(fact_356_power__gt__expt,axiom,
    ! [Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,power_power(nat,Nb),K)) ) ).

% power_gt_expt
tff(fact_357_Ex__less__Suc2,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,Nb))
          & aa(nat,$o,P,I) )
    <=> ( aa(nat,$o,P,zero_zero(nat))
        | ? [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Nb)
            & aa(nat,$o,P,aa(nat,nat,suc,I)) ) ) ) ).

% Ex_less_Suc2
tff(fact_358_gr0__conv__Suc,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
    <=> ? [M4: nat] : ( Nb = aa(nat,nat,suc,M4) ) ) ).

% gr0_conv_Suc
tff(fact_359_All__less__Suc2,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,Nb))
         => aa(nat,$o,P,I) )
    <=> ( aa(nat,$o,P,zero_zero(nat))
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Nb)
           => aa(nat,$o,P,aa(nat,nat,suc,I)) ) ) ) ).

% All_less_Suc2
tff(fact_360_gr0__implies__Suc,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ? [M3: nat] : ( Nb = aa(nat,nat,suc,M3) ) ) ).

% gr0_implies_Suc
tff(fact_361_less__Suc__eq__0__disj,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,suc,Nb))
    <=> ( ( Ma = zero_zero(nat) )
        | ? [J4: nat] :
            ( ( Ma = aa(nat,nat,suc,J4) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),Nb) ) ) ) ).

% less_Suc_eq_0_disj
tff(fact_362_add__is__1,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( ( Ma = aa(nat,nat,suc,zero_zero(nat)) )
          & ( Nb = zero_zero(nat) ) )
        | ( ( Ma = zero_zero(nat) )
          & ( Nb = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ) ).

% add_is_1
tff(fact_363_one__is__add,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,suc,zero_zero(nat)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb) )
    <=> ( ( ( Ma = aa(nat,nat,suc,zero_zero(nat)) )
          & ( Nb = zero_zero(nat) ) )
        | ( ( Ma = zero_zero(nat) )
          & ( Nb = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ) ).

% one_is_add
tff(fact_364_less__imp__add__positive,axiom,
    ! [I3: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ? [K2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K2)
          & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K2) = J2 ) ) ) ).

% less_imp_add_positive
tff(fact_365_enat__ord__code_I4_J,axiom,
    ! [Ma: nat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(Ma)),extend4730790105801354508finity(extended_enat)) ).

% enat_ord_code(4)
tff(fact_366_less__infinityE,axiom,
    ! [Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Nb),extend4730790105801354508finity(extended_enat))
     => ~ ! [K2: nat] : ( Nb != extended_enat2(K2) ) ) ).

% less_infinityE
tff(fact_367_infinity__ilessE,axiom,
    ! [Ma: nat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(Ma)) ).

% infinity_ilessE
tff(fact_368_power__numeral__even,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z: A,W: num] :
          ( aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,W)))
          = $let(
              w: A,
              w := aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),W)),
              aa(A,A,aa(A,fun(A,A),times_times(A),w),w) ) ) ) ).

% power_numeral_even
tff(fact_369_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb) = zero_zero(nat) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
        | ( Nb = zero_zero(nat) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
tff(fact_370_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))),zero_zero(A)) ) ) ).

% odd_power_less_zero
tff(fact_371_enat__add__left__cancel__less,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),B2)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),C2))
    <=> ( ( A2 != extend4730790105801354508finity(extended_enat) )
        & aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),B2),C2) ) ) ).

% enat_add_left_cancel_less
tff(fact_372_nat__bit__induct,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N: nat] :
            ( aa(nat,$o,P,N)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) ) )
       => ( ! [N: nat] :
              ( aa(nat,$o,P,N)
             => aa(nat,$o,P,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) )
         => aa(nat,$o,P,Nb) ) ) ) ).

% nat_bit_induct
tff(fact_373_power2__eq__square,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) ) ) ).

% power2_eq_square
tff(fact_374_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X2: A] : ( aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),X2)),X2) ) ) ).

% power4_eq_xxxx
tff(fact_375_power__even__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Nb: nat] : ( aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) = aa(nat,A,power_power(A,aa(nat,A,power_power(A,A2),Nb)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% power_even_eq
tff(fact_376_zero__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,power_power(A,zero_zero(A)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% zero_power2
tff(fact_377_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X2: nat,Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),vEBT_VEBT_low(X2,Nb)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
tff(fact_378_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),A2) ) ).

% verit_comp_simplify1(1)
tff(fact_379_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
tff(fact_380_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
tff(fact_381_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.left_commute
tff(fact_382_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) ) ) ).

% add.commute
tff(fact_383_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
        <=> ( B2 = C2 ) ) ) ).

% add.right_cancel
tff(fact_384_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add.left_cancel
tff(fact_385_add_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.assoc
tff(fact_386_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [B4: A,K: A,B2: A,A2: A] :
          ( ( B4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% group_cancel.add2
tff(fact_387_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% group_cancel.add1
tff(fact_388_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & ( K = L ) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
tff(fact_389_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% ab_semigroup_add_class.add_ac(1)
tff(fact_390_numeral__1__eq__Suc__0,axiom,
    aa(num,nat,numeral_numeral(nat),one2) = aa(nat,nat,suc,zero_zero(nat)) ).

% numeral_1_eq_Suc_0
tff(fact_391_length__pos__if__in__set,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_pos_if_in_set
tff(fact_392_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : vEBT_invar_vebt(vEBT_Leaf(A2,B2),aa(nat,nat,suc,zero_zero(nat))) ).

% invar_vebt.intros(1)
tff(fact_393_power2__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),zero_zero(A)) ) ).

% power2_less_0
tff(fact_394_left__add__twice,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)),B2) ) ) ).

% left_add_twice
tff(fact_395_mult__2__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Z) ) ) ).

% mult_2_right
tff(fact_396_mult__2,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Z) ) ) ).

% mult_2
tff(fact_397_power2__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X2: A,Y2: A] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)),Y2)) ) ) ).

% power2_sum
tff(fact_398_numeral__2__eq__2,axiom,
    aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) = aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))) ).

% numeral_2_eq_2
tff(fact_399_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))
        <=> ( ( X2 != zero_zero(A) )
            | ( Y2 != zero_zero(A) ) ) ) ) ).

% sum_power2_gt_zero_iff
tff(fact_400_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),zero_zero(A)) ) ).

% not_sum_power2_lt_zero
tff(fact_401_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% half_gt_zero_iff
tff(fact_402_half__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% half_gt_zero
tff(fact_403_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Ma: nat,Nb: nat] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) != zero_zero(A) )
         => ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) != zero_zero(A) ) ) ) ).

% exp_add_not_zero_imp_right
tff(fact_404_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Ma: nat,Nb: nat] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) != zero_zero(A) )
         => ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma) != zero_zero(A) ) ) ) ).

% exp_add_not_zero_imp_left
tff(fact_405_less__2__cases__iff,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))
    <=> ( ( Nb = zero_zero(nat) )
        | ( Nb = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% less_2_cases_iff
tff(fact_406_less__2__cases,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))
     => ( ( Nb = zero_zero(nat) )
        | ( Nb = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% less_2_cases
tff(fact_407_Suc__n__div__2__gt__zero,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,Nb)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% Suc_n_div_2_gt_zero
tff(fact_408_div__2__gt__zero,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% div_2_gt_zero
tff(fact_409_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_imp_less_right
tff(fact_410_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_imp_less_left
tff(fact_411_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add_strict_right_mono
tff(fact_412_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% add_strict_left_mono
tff(fact_413_add__strict__mono,axiom,
    ! [A: $tType] :
      ( strict9044650504122735259up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_strict_mono
tff(fact_414_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I3),J2)
            & ( K = L ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(1)
tff(fact_415_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(2)
tff(fact_416_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I3),J2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(5)
tff(fact_417_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] : ( one2 != aa(num,num,bit0,X22) ) ).

% verit_eq_simplify(10)
tff(fact_418_power__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),Nb) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb)) ) ) ).

% power_divide
tff(fact_419_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X2: nat,Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),vEBT_VEBT_high(X2,Nb)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma)) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
tff(fact_420_in__children__def,axiom,
    ! [Nb: nat,TreeListb: list(vEBT_VEBT),X2: nat] :
      ( vEBT_V5917875025757280293ildren(Nb,TreeListb,X2)
    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),vEBT_VEBT_high(X2,Nb))),vEBT_VEBT_low(X2,Nb)) ) ).

% in_children_def
tff(fact_421_buildup__gives__valid,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => vEBT_invar_vebt(vEBT_vebt_buildup(Nb),Nb) ) ).

% buildup_gives_valid
tff(fact_422_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
tff(fact_423_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),B2) = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
tff(fact_424_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
tff(fact_425_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
tff(fact_426_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),A2) = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
tff(fact_427_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
tff(fact_428_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          = $ite(C2 = zero_zero(A),zero_zero(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ).

% mult_divide_mult_cancel_left_if
tff(fact_429_double__not__eq__Suc__double,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma) != aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ).

% double_not_eq_Suc_double
tff(fact_430_Suc__double__not__eq__double,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma)) != aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) ) ).

% Suc_double_not_eq_double
tff(fact_431_times__enat__simps_I2_J,axiom,
    aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ).

% times_enat_simps(2)
tff(fact_432_i0__less,axiom,
    ! [Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Nb)
    <=> ( Nb != zero_zero(extended_enat) ) ) ).

% i0_less
tff(fact_433_mult__zero__left,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% mult_zero_left
tff(fact_434_mult__zero__right,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% mult_zero_right
tff(fact_435_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% mult_eq_0_iff
tff(fact_436_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
tff(fact_437_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
tff(fact_438_div__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% div_0
tff(fact_439_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divide_eq_0_iff
tff(fact_440_div__by__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% div_by_0
tff(fact_441_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
tff(fact_442_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
tff(fact_443_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% division_ring_divide_zero
tff(fact_444_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,C2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),C2) ) ) ).

% times_divide_eq_left
tff(fact_445_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% divide_divide_eq_left
tff(fact_446_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ).

% divide_divide_eq_right
tff(fact_447_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) ) ) ).

% times_divide_eq_right
tff(fact_448_times__enat__simps_I1_J,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(Ma)),extended_enat2(Nb)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)) ) ).

% times_enat_simps(1)
tff(fact_449_semiring__norm_I13_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit0,Ma)),aa(num,num,bit0,Nb)) = aa(num,num,bit0,aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),times_times(num),Ma),Nb))) ) ).

% semiring_norm(13)
tff(fact_450_semiring__norm_I12_J,axiom,
    ! [Nb: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),one2),Nb) = Nb ) ).

% semiring_norm(12)
tff(fact_451_semiring__norm_I11_J,axiom,
    ! [Ma: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),Ma),one2) = Ma ) ).

% semiring_norm(11)
tff(fact_452_num__double,axiom,
    ! [Nb: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit0,one2)),Nb) = aa(num,num,bit0,Nb) ) ).

% num_double
tff(fact_453_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Ma: num,Nb: num] : ( aa(nat,A,power_power(A,aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),Ma))),aa(num,nat,numeral_numeral(nat),Nb)) = aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),times_times(num),Ma),Nb))) ) ) ).

% power_mult_numeral
tff(fact_454_times__enat__simps_I4_J,axiom,
    ! [Ma: nat] :
      ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(Ma)),extend4730790105801354508finity(extended_enat))
      = $ite(Ma = zero_zero(nat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)) ) ).

% times_enat_simps(4)
tff(fact_455_times__enat__simps_I3_J,axiom,
    ! [Nb: nat] :
      ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(Nb))
      = $ite(Nb = zero_zero(nat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)) ) ).

% times_enat_simps(3)
tff(fact_456_half__negative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% half_negative_int_iff
tff(fact_457_enat__0__less__mult__iff,axiom,
    ! [Ma: extended_enat,Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),Ma),Nb))
    <=> ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Ma)
        & aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Nb) ) ) ).

% enat_0_less_mult_iff
tff(fact_458_enat__less__induct,axiom,
    ! [P: fun(extended_enat,$o),Nb: extended_enat] :
      ( ! [N: extended_enat] :
          ( ! [M: extended_enat] :
              ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),M),N)
             => aa(extended_enat,$o,P,M) )
         => aa(extended_enat,$o,P,N) )
     => aa(extended_enat,$o,P,Nb) ) ).

% enat_less_induct
tff(fact_459_not__iless0,axiom,
    ! [Nb: extended_enat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Nb),zero_zero(extended_enat)) ).

% not_iless0
tff(fact_460_imult__is__infinity,axiom,
    ! [A2: extended_enat,B2: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),A2),B2) = extend4730790105801354508finity(extended_enat) )
    <=> ( ( ( A2 = extend4730790105801354508finity(extended_enat) )
          & ( B2 != zero_zero(extended_enat) ) )
        | ( ( B2 = extend4730790105801354508finity(extended_enat) )
          & ( A2 != zero_zero(extended_enat) ) ) ) ) ).

% imult_is_infinity
tff(fact_461_imult__infinity,axiom,
    ! [Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Nb)
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),Nb) = extend4730790105801354508finity(extended_enat) ) ) ).

% imult_infinity
tff(fact_462_imult__infinity__right,axiom,
    ! [Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Nb)
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),Nb),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ) ).

% imult_infinity_right
tff(fact_463_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int)) ) ) ).

% pos_imp_zdiv_neg_iff
tff(fact_464_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),A2) ) ) ).

% neg_imp_zdiv_neg_iff
tff(fact_465_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int)) ) ) ).

% div_neg_pos_less0
tff(fact_466_infinity__ne__i0,axiom,
    extend4730790105801354508finity(extended_enat) != zero_zero(extended_enat) ).

% infinity_ne_i0
tff(fact_467_iadd__is__0,axiom,
    ! [Ma: extended_enat,Nb: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Ma),Nb) = zero_zero(extended_enat) )
    <=> ( ( Ma = zero_zero(extended_enat) )
        & ( Nb = zero_zero(extended_enat) ) ) ) ).

% iadd_is_0
tff(fact_468_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,K: num,L: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),L)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),K),L))) ) ) ).

% div_mult2_numeral_eq
tff(fact_469_enat__0__iff_I2_J,axiom,
    ! [X2: nat] :
      ( ( zero_zero(extended_enat) = extended_enat2(X2) )
    <=> ( X2 = zero_zero(nat) ) ) ).

% enat_0_iff(2)
tff(fact_470_enat__0__iff_I1_J,axiom,
    ! [X2: nat] :
      ( ( extended_enat2(X2) = zero_zero(extended_enat) )
    <=> ( X2 = zero_zero(nat) ) ) ).

% enat_0_iff(1)
tff(fact_471_zero__enat__def,axiom,
    zero_zero(extended_enat) = extended_enat2(zero_zero(nat)) ).

% zero_enat_def
tff(fact_472_less__enat__def,axiom,
    ! [Ma: extended_enat,Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Ma),Nb)
    <=> extended_case_enat($o,aTP_Lamp_ai(extended_enat,fun(nat,$o),Nb),$false,Ma) ) ).

% less_enat_def
tff(fact_473_times__enat__def,axiom,
    ! [Ma: extended_enat,Nb: extended_enat] :
      ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),Ma),Nb)
      = extended_case_enat(extended_enat,aTP_Lamp_ak(extended_enat,fun(nat,extended_enat),Nb),$ite(Nb = zero_zero(extended_enat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)),Ma) ) ).

% times_enat_def
tff(fact_474_vebt__buildup_Osimps_I1_J,axiom,
    vEBT_vebt_buildup(zero_zero(nat)) = vEBT_Leaf($false,$false) ).

% vebt_buildup.simps(1)
tff(fact_475_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
        ? [Y4: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y4),X) ) ).

% linordered_field_no_lb
tff(fact_476_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
        ? [X_13: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),X_13) ) ).

% linordered_field_no_ub
tff(fact_477_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ) ).

% linorder_neqE_linordered_idom
tff(fact_478_vebt__buildup_Osimps_I2_J,axiom,
    vEBT_vebt_buildup(aa(nat,nat,suc,zero_zero(nat))) = vEBT_Leaf($false,$false) ).

% vebt_buildup.simps(2)
tff(fact_479_mult__not__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) != zero_zero(A) )
         => ( ( A2 != zero_zero(A) )
            & ( B2 != zero_zero(A) ) ) ) ) ).

% mult_not_zero
tff(fact_480_divisors__zero,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = zero_zero(A) )
         => ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divisors_zero
tff(fact_481_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) != zero_zero(A) ) ) ) ) ).

% no_zero_divisors
tff(fact_482_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
          <=> ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
tff(fact_483_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
          <=> ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
tff(fact_484_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ring_class.ring_distribs(2)
tff(fact_485_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% ring_class.ring_distribs(1)
tff(fact_486_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( comm_semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% comm_semiring_class.distrib
tff(fact_487_distrib__left,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% distrib_left
tff(fact_488_distrib__right,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% distrib_right
tff(fact_489_combine__common__factor,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,E2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),E2)),C2) ) ) ).

% combine_common_factor
tff(fact_490_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,Y2: A,Z: A,W: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Z),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),W)) ) ) ).

% times_divide_times_eq
tff(fact_491_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,Y2: A,Z: A,W: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Z),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),W)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z)) ) ) ).

% divide_divide_times_eq
tff(fact_492_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% divide_divide_eq_left'
tff(fact_493_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ).

% add_divide_distrib
tff(fact_494_lambda__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ( aTP_Lamp_al(A,A) = aa(A,fun(A,A),times_times(A),zero_zero(A)) ) ) ).

% lambda_zero
tff(fact_495_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord2810124833399127020strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
tff(fact_496_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_right_disj
tff(fact_497_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_strict_right_mono
tff(fact_498_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_strict_right_mono_neg
tff(fact_499_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_left_disj
tff(fact_500_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_strict_left_mono
tff(fact_501_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_strict_left_mono_neg
tff(fact_502_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_less_cancel_left_pos
tff(fact_503_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% mult_less_cancel_left_neg
tff(fact_504_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ).

% zero_less_mult_pos2
tff(fact_505_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ).

% zero_less_mult_pos
tff(fact_506_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_less_mult_iff
tff(fact_507_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),zero_zero(A)) ) ) ) ).

% mult_pos_neg2
tff(fact_508_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_pos_pos
tff(fact_509_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_pos_neg
tff(fact_510_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_neg_pos
tff(fact_511_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ) ).

% mult_less_0_iff
tff(fact_512_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)),zero_zero(A)) ) ).

% not_square_less_zero
tff(fact_513_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_neg_neg
tff(fact_514_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),zero_zero(A)) ) ) ) ).

% add_less_zeroD
tff(fact_515_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% divide_neg_neg
tff(fact_516_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),zero_zero(A)) ) ) ) ).

% divide_neg_pos
tff(fact_517_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),zero_zero(A)) ) ) ) ).

% divide_pos_neg
tff(fact_518_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% divide_pos_pos
tff(fact_519_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ) ).

% divide_less_0_iff
tff(fact_520_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            & ( C2 != zero_zero(A) ) ) ) ) ).

% divide_less_cancel
tff(fact_521_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_less_divide_iff
tff(fact_522_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% divide_strict_right_mono
tff(fact_523_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% divide_strict_right_mono_neg
tff(fact_524_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z) )
            <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z) = aa(A,A,aa(A,fun(A,A),times_times(A),W),Y2) ) ) ) ) ) ).

% frac_eq_eq
tff(fact_525_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A2 )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq
tff(fact_526_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq
tff(fact_527_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A2 ) ) ) ) ).

% divide_eq_imp
tff(fact_528_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2 )
           => ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) ) ) ) ) ).

% eq_divide_imp
tff(fact_529_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A2 )
          <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) ) ) ) ) ).

% nonzero_divide_eq_eq
tff(fact_530_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
tff(fact_531_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X2: A,Y2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Y2))),zero_zero(A)) ) ).

% not_sum_squares_lt_zero
tff(fact_532_divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)) ) ) ) ).

% divide_less_eq
tff(fact_533_less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))) ) ) ) ).

% less_divide_eq
tff(fact_534_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% neg_divide_less_eq
tff(fact_535_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_less_divide_eq
tff(fact_536_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_divide_less_eq
tff(fact_537_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% pos_less_divide_eq
tff(fact_538_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y2: A,X2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),Z) ) ) ) ).

% mult_imp_div_pos_less
tff(fact_539_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y2: A,Z: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y2)),X2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% mult_imp_less_div_pos
tff(fact_540_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)) ) ) ) ) ).

% divide_strict_left_mono
tff(fact_541_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)) ) ) ) ) ).

% divide_strict_left_mono_neg
tff(fact_542_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Z)),B2)
          = $ite(Z = zero_zero(A),B2,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z)) ) ) ).

% add_divide_eq_if_simps(2)
tff(fact_543_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,Z: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Z))
          = $ite(Z = zero_zero(A),A2,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),Z)),B2)),Z)) ) ) ).

% add_divide_eq_if_simps(1)
tff(fact_544_add__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z)) ) ) ) ) ).

% add_frac_eq
tff(fact_545_add__frac__num,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y2: A,X2: A,Z: A] :
          ( ( Y2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y2))),Y2) ) ) ) ).

% add_frac_num
tff(fact_546_add__num__frac,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y2: A,Z: A,X2: A] :
          ( ( Y2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y2))),Y2) ) ) ) ).

% add_num_frac
tff(fact_547_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),Y2)),Z) ) ) ) ).

% add_divide_eq_iff
tff(fact_548_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z)),Y2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z))),Z) ) ) ) ).

% divide_add_eq_iff
tff(fact_549_pos2,axiom,
    aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ).

% pos2
tff(fact_550_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option(product_prod(nat,nat)),V: nat,TreeListb: list(vEBT_VEBT),S: vEBT_VEBT,X2: nat] :
      ( vEBT_V5719532721284313246member(vEBT_Node(Uy,aa(nat,nat,suc,V),TreeListb,S),X2)
    <=> $let(
          pos: nat,
          pos := vEBT_VEBT_high(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),pos),vEBT_VEBT_low(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ).

% VEBT_internal.naive_member.simps(3)
tff(fact_551_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% double_eq_0_iff
tff(fact_552_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeListb: list(vEBT_VEBT),Vd: vEBT_VEBT,X2: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V),TreeListb,Vd),X2)
    <=> $let(
          pos: nat,
          pos := vEBT_VEBT_high(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),pos),vEBT_VEBT_low(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ).

% VEBT_internal.membermima.simps(5)
tff(fact_553_buildup__nothing__in__leaf,axiom,
    ! [Nb: nat,X2: nat] : ~ vEBT_V5719532721284313246member(vEBT_vebt_buildup(Nb),X2) ).

% buildup_nothing_in_leaf
tff(fact_554_unset__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),zero_zero(nat)),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% unset_bit_0
tff(fact_555_length__mul__elem,axiom,
    ! [A: $tType,Xs: list(list(A)),Nb: nat] :
      ( ! [X4: list(A)] :
          ( aa(set(list(A)),$o,member(list(A),X4),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
         => ( aa(list(A),nat,size_size(list(A)),X4) = Nb ) )
     => ( aa(list(A),nat,size_size(list(A)),concat(A,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(list(A)),nat,size_size(list(list(A))),Xs)),Nb) ) ) ).

% length_mul_elem
tff(fact_556_low__def,axiom,
    ! [X2: nat,Nb: nat] : ( vEBT_VEBT_low(X2,Nb) = modulo_modulo(nat,X2,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ).

% low_def
tff(fact_557_four__x__squared,axiom,
    ! [X2: real] : ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% four_x_squared
tff(fact_558_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [R: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R != zero_zero(A) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),R),C2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),R),D2)) ) ) ) ) ).

% add_scale_eq_noteq
tff(fact_559_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2) ) ) ) ).

% mult_less_iff1
tff(fact_560_buildup__nothing__in__min__max,axiom,
    ! [Nb: nat,X2: nat] : ~ vEBT_VEBT_membermima(vEBT_vebt_buildup(Nb),X2) ).

% buildup_nothing_in_min_max
tff(fact_561_both__member__options__def,axiom,
    ! [T2: vEBT_VEBT,X2: nat] :
      ( aa(nat,$o,vEBT_V8194947554948674370ptions(T2),X2)
    <=> ( vEBT_V5719532721284313246member(T2,X2)
        | vEBT_VEBT_membermima(T2,X2) ) ) ).

% both_member_options_def
tff(fact_562_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,modulo_modulo(A,A2,B2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mod_trivial
tff(fact_563_not__real__square__gt__zero,axiom,
    ! [X2: real] :
      ( ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),times_times(real),X2),X2))
    <=> ( X2 = zero_zero(real) ) ) ).

% not_real_square_gt_zero
tff(fact_564_real__divide__square__eq,axiom,
    ! [R: real,A2: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),R),A2)),aa(real,real,aa(real,fun(real,real),times_times(real),R),R)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),A2),R) ) ).

% real_divide_square_eq
tff(fact_565_bits__mod__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( modulo_modulo(A,zero_zero(A),A2) = zero_zero(A) ) ) ).

% bits_mod_0
tff(fact_566_mod__self,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,A2) = zero_zero(A) ) ) ).

% mod_self
tff(fact_567_mod__by__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,zero_zero(A)) = A2 ) ) ).

% mod_by_0
tff(fact_568_mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,zero_zero(A),A2) = zero_zero(A) ) ) ).

% mod_0
tff(fact_569_mod__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_add_self2
tff(fact_570_mod__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_add_self1
tff(fact_571_unset__bit__negative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Nb),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% unset_bit_negative_int_iff
tff(fact_572_mod__less,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ( modulo_modulo(nat,Ma,Nb) = Ma ) ) ).

% mod_less
tff(fact_573_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2),B2) = zero_zero(A) ) ) ).

% mod_mult_self1_is_0
tff(fact_574_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),B2) = zero_zero(A) ) ) ).

% mod_mult_self2_is_0
tff(fact_575_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A2,B2)),B2) = zero_zero(A) ) ) ).

% bits_mod_div_trivial
tff(fact_576_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A2,B2)),B2) = zero_zero(A) ) ) ).

% mod_div_trivial
tff(fact_577_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self1
tff(fact_578_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self2
tff(fact_579_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self3
tff(fact_580_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self4
tff(fact_581_mod__by__Suc__0,axiom,
    ! [Ma: nat] : ( modulo_modulo(nat,Ma,aa(nat,nat,suc,zero_zero(nat))) = zero_zero(nat) ) ).

% mod_by_Suc_0
tff(fact_582_Suc__mod__mult__self1,axiom,
    ! [Ma: nat,K: nat,Nb: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))),Nb) = modulo_modulo(nat,aa(nat,nat,suc,Ma),Nb) ) ).

% Suc_mod_mult_self1
tff(fact_583_Suc__mod__mult__self2,axiom,
    ! [Ma: nat,Nb: nat,K: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K))),Nb) = modulo_modulo(nat,aa(nat,nat,suc,Ma),Nb) ) ).

% Suc_mod_mult_self2
tff(fact_584_Suc__mod__mult__self3,axiom,
    ! [K: nat,Nb: nat,Ma: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb)),Ma)),Nb) = modulo_modulo(nat,aa(nat,nat,suc,Ma),Nb) ) ).

% Suc_mod_mult_self3
tff(fact_585_Suc__mod__mult__self4,axiom,
    ! [Nb: nat,K: nat,Ma: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K)),Ma)),Nb) = modulo_modulo(nat,aa(nat,nat,suc,Ma),Nb) ) ).

% Suc_mod_mult_self4
tff(fact_586_mod2__Suc__Suc,axiom,
    ! [Ma: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,Ma)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% mod2_Suc_Suc
tff(fact_587_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [Nb: nat] :
      ( ( modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) != aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = zero_zero(nat) ) ) ).

% not_mod2_eq_Suc_0_eq_0
tff(fact_588_add__self__mod__2,axiom,
    ! [Ma: nat] : ( modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = zero_zero(nat) ) ).

% add_self_mod_2
tff(fact_589_plus__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),zero_zero(int)),L) = L ) ).

% plus_int_code(2)
tff(fact_590_plus__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),K),zero_zero(int)) = K ) ).

% plus_int_code(1)
tff(fact_591_less__int__code_I1_J,axiom,
    ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),zero_zero(int)) ).

% less_int_code(1)
tff(fact_592_zmult__zless__mono2,axiom,
    ! [I3: int,J2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I3),J2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I3)),aa(int,int,aa(int,fun(int,int),times_times(int),K),J2)) ) ) ).

% zmult_zless_mono2
tff(fact_593_imult__is__0,axiom,
    ! [Ma: extended_enat,Nb: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),Ma),Nb) = zero_zero(extended_enat) )
    <=> ( ( Ma = zero_zero(extended_enat) )
        | ( Nb = zero_zero(extended_enat) ) ) ) ).

% imult_is_0
tff(fact_594_times__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),K),zero_zero(int)) = zero_zero(int) ) ).

% times_int_code(1)
tff(fact_595_times__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),zero_zero(int)),L) = zero_zero(int) ) ).

% times_int_code(2)
tff(fact_596_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_eq
tff(fact_597_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A5),B5),C2) ) ) ) ) ).

% mod_mult_cong
tff(fact_598_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,B2)),C2) ) ) ).

% mod_mult_mult2
tff(fact_599_mult__mod__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),modulo_modulo(A,A2,B2)) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% mult_mod_right
tff(fact_600_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_left_eq
tff(fact_601_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_right_eq
tff(fact_602_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_right_eq
tff(fact_603_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_left_eq
tff(fact_604_mod__add__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A5),B5),C2) ) ) ) ) ).

% mod_add_cong
tff(fact_605_mod__add__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_eq
tff(fact_606_power__mod,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,Nb: nat] : ( modulo_modulo(A,aa(nat,A,power_power(A,modulo_modulo(A,A2,B2)),Nb),B2) = modulo_modulo(A,aa(nat,A,power_power(A,A2),Nb),B2) ) ) ).

% power_mod
tff(fact_607_mod__Suc__Suc__eq,axiom,
    ! [Ma: nat,Nb: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,modulo_modulo(nat,Ma,Nb))),Nb) = modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,Ma)),Nb) ) ).

% mod_Suc_Suc_eq
tff(fact_608_mod__Suc__eq,axiom,
    ! [Ma: nat,Nb: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,modulo_modulo(nat,Ma,Nb)),Nb) = modulo_modulo(nat,aa(nat,nat,suc,Ma),Nb) ) ).

% mod_Suc_eq
tff(fact_609_map__concat,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(list(B))] : ( aa(list(B),list(A),map(B,A,F3),concat(B,Xs)) = concat(A,aa(list(list(B)),list(list(A)),map(list(B),list(A),map(B,A,F3)),Xs)) ) ).

% map_concat
tff(fact_610_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] : ~ vEBT_VEBT_membermima(vEBT_Leaf(Uu,Uv),Uw) ).

% VEBT_internal.membermima.simps(1)
tff(fact_611_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,B2)),B2) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
tff(fact_612_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = A2 )
        <=> ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) ) ) ) ).

% mod_eq_self_iff_div_eq_0
tff(fact_613_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Q2: num,Nb: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Ma)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Ma),aa(num,A,numeral_numeral(A),Q2)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),Nb),aa(num,A,numeral_numeral(A),Q2)) ) ) ) ).

% cong_exp_iff_simps(9)
tff(fact_614_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Ma),aa(num,A,numeral_numeral(A),one2)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),Nb),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% cong_exp_iff_simps(4)
tff(fact_615_mod__eqE,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,B2,C2) )
         => ~ ! [D3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D3)) ) ) ) ).

% mod_eqE
tff(fact_616_div__add1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2))),C2)) ) ) ).

% div_add1_eq
tff(fact_617_mod__Suc,axiom,
    ! [Ma: nat,Nb: nat] :
      ( modulo_modulo(nat,aa(nat,nat,suc,Ma),Nb)
      = $ite(aa(nat,nat,suc,modulo_modulo(nat,Ma,Nb)) = Nb,zero_zero(nat),aa(nat,nat,suc,modulo_modulo(nat,Ma,Nb))) ) ).

% mod_Suc
tff(fact_618_mod__induct,axiom,
    ! [P: fun(nat,$o),Nb: nat,P2: nat,Ma: nat] :
      ( aa(nat,$o,P,Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),P2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),P2)
         => ( ! [N: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),P2)
               => ( aa(nat,$o,P,N)
                 => aa(nat,$o,P,modulo_modulo(nat,aa(nat,nat,suc,N),P2)) ) )
           => aa(nat,$o,P,Ma) ) ) ) ) ).

% mod_induct
tff(fact_619_mod__less__divisor,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),modulo_modulo(nat,Ma,Nb)),Nb) ) ).

% mod_less_divisor
tff(fact_620_mod__eq__0D,axiom,
    ! [Ma: nat,D2: nat] :
      ( ( modulo_modulo(nat,Ma,D2) = zero_zero(nat) )
     => ? [Q3: nat] : ( Ma = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),D2),Q3) ) ) ).

% mod_eq_0D
tff(fact_621_nat__mod__eq__iff,axiom,
    ! [X2: nat,Nb: nat,Y2: nat] :
      ( ( modulo_modulo(nat,X2,Nb) = modulo_modulo(nat,Y2,Nb) )
    <=> ? [Q1: nat,Q22: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q1)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Y2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q22)) ) ) ).

% nat_mod_eq_iff
tff(fact_622_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Nb: num,Q2: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) = zero_zero(A) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Nb),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(2)
tff(fact_623_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Nb: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Nb),aa(num,A,numeral_numeral(A),one2)) = zero_zero(A) ) ) ).

% cong_exp_iff_simps(1)
tff(fact_624_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q2: num,Nb: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) ) ) ).

% cong_exp_iff_simps(6)
tff(fact_625_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Q2: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Ma)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) ) ) ).

% cong_exp_iff_simps(8)
tff(fact_626_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),modulo_modulo(A,B2,C2))),C2)) ) ) ).

% div_mult1_eq
tff(fact_627_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [B2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))),modulo_modulo(A,A2,B2)) = A2 ) ) ).

% mult_div_mod_eq
tff(fact_628_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))) = A2 ) ) ).

% mod_mult_div_eq
tff(fact_629_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)) = A2 ) ) ).

% mod_div_mult_eq
tff(fact_630_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)),modulo_modulo(A,A2,B2)) = A2 ) ) ).

% div_mult_mod_eq
tff(fact_631_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)),modulo_modulo(A,A2,B2)) ) ) ).

% mod_div_decomp
tff(fact_632_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)),modulo_modulo(A,A2,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) ) ) ).

% cancel_div_mod_rules(1)
tff(fact_633_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))),modulo_modulo(A,A2,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) ) ) ).

% cancel_div_mod_rules(2)
tff(fact_634_div__less__mono,axiom,
    ! [A3: nat,B4: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A3),B4)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ( ( modulo_modulo(nat,A3,Nb) = zero_zero(nat) )
         => ( ( modulo_modulo(nat,B4,Nb) = zero_zero(nat) )
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A3),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),B4),Nb)) ) ) ) ) ).

% div_less_mono
tff(fact_635_div__mod__decomp,axiom,
    ! [A3: nat,Nb: nat] : ( A3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A3),Nb)),Nb)),modulo_modulo(nat,A3,Nb)) ) ).

% div_mod_decomp
tff(fact_636_mod__mult2__eq,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] : ( modulo_modulo(nat,Ma,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb),Q2))),modulo_modulo(nat,Ma,Nb)) ) ).

% mod_mult2_eq
tff(fact_637_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option(product_prod(nat,nat)),Uv: list(vEBT_VEBT),Uw: vEBT_VEBT,Ux: nat] : ~ vEBT_V5719532721284313246member(vEBT_Node(Uu,zero_zero(nat),Uv,Uw),Ux) ).

% VEBT_internal.naive_member.simps(2)
tff(fact_638_realpow__pos__nth2,axiom,
    ! [A2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ? [R2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
          & ( aa(nat,real,power_power(real,R2),aa(nat,nat,suc,Nb)) = A2 ) ) ) ).

% realpow_pos_nth2
tff(fact_639_split__mod,axiom,
    ! [P: fun(nat,$o),Ma: nat,Nb: nat] :
      ( aa(nat,$o,P,modulo_modulo(nat,Ma,Nb))
    <=> ( ( ( Nb = zero_zero(nat) )
         => aa(nat,$o,P,Ma) )
        & ( ( Nb != zero_zero(nat) )
         => ! [I: nat,J4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),Nb)
             => ( ( Ma = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),I)),J4) )
               => aa(nat,$o,P,J4) ) ) ) ) ) ).

% split_mod
tff(fact_640_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),aa(nat,nat,suc,Nb)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),Nb),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% unset_bit_Suc
tff(fact_641_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list(vEBT_VEBT),Uy: vEBT_VEBT,Uz: nat] : ~ vEBT_VEBT_membermima(vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux,Uy),Uz) ).

% VEBT_internal.membermima.simps(2)
tff(fact_642_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2)
           => ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)) = modulo_modulo(A,A2,B2) ) ) ) ) ).

% divmod_digit_0(2)
tff(fact_643_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = zero_zero(A) ) ) ) ).

% bits_stable_imp_add_self
tff(fact_644_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat,Ma: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A2,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) ) ) ).

% div_exp_mod_exp_eq
tff(fact_645_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ) ).

% divmod_digit_0(1)
tff(fact_646_add__0__iff,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [B2: A,A2: A] :
          ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% add_0_iff
tff(fact_647_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),D2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% crossproduct_noteq
tff(fact_648_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [W: A,Y2: A,X2: A,Z: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y2)),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2)) )
        <=> ( ( W = X2 )
            | ( Y2 = Z ) ) ) ) ).

% crossproduct_eq
tff(fact_649_realpow__pos__nth,axiom,
    ! [Nb: nat,A2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ? [R2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
            & ( aa(nat,real,power_power(real,R2),Nb) = A2 ) ) ) ) ).

% realpow_pos_nth
tff(fact_650_realpow__pos__nth__unique,axiom,
    ! [Nb: nat,A2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ? [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X4)
            & ( aa(nat,real,power_power(real,X4),Nb) = A2 )
            & ! [Y3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y3)
                  & ( aa(nat,real,power_power(real,Y3),Nb) = A2 ) )
               => ( Y3 = X4 ) ) ) ) ) ).

% realpow_pos_nth_unique
tff(fact_651_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( vEBT_V5719532721284313246member(X2,Xa2)
      <=> (Y2) )
     => ( ! [A4: $o,B3: $o] :
            ( ( X2 = vEBT_Leaf(A4,B3) )
           => ( (Y2)
            <=> ~ $ite(
                    Xa2 = zero_zero(nat),
                    (A4),
                    $ite(Xa2 = one_one(nat),(B3),$false) ) ) )
       => ( ( ? [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] : ( X2 = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
           => (Y2) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList: list(vEBT_VEBT)] :
                ( ? [S2: vEBT_VEBT] : ( X2 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2) )
               => ( (Y2)
                <=> ~ $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
tff(fact_652_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( vEBT_V5719532721284313246member(X2,Xa2)
     => ( ! [A4: $o,B3: $o] :
            ( ( X2 = vEBT_Leaf(A4,B3) )
           => ~ $ite(
                  Xa2 = zero_zero(nat),
                  (A4),
                  $ite(Xa2 = one_one(nat),(B3),$false) ) )
       => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList: list(vEBT_VEBT)] :
              ( ? [S2: vEBT_VEBT] : ( X2 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2) )
             => ~ $let(
                    pos: nat,
                    pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                    $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
tff(fact_653_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ vEBT_V5719532721284313246member(X2,Xa2)
     => ( ! [A4: $o,B3: $o] :
            ( ( X2 = vEBT_Leaf(A4,B3) )
           => $ite(
                Xa2 = zero_zero(nat),
                (A4),
                $ite(Xa2 = one_one(nat),(B3),$false) ) )
       => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] : ( X2 != vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList: list(vEBT_VEBT)] :
                ( ? [S2: vEBT_VEBT] : ( X2 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2) )
               => $let(
                    pos: nat,
                    pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                    $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
tff(fact_654_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se8732182000553998342ip_bit(A,aa(nat,nat,suc,Nb),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se8732182000553998342ip_bit(A,Nb,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% flip_bit_Suc
tff(fact_655_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),aa(nat,nat,suc,Nb)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),Nb),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% set_bit_Suc
tff(fact_656_gcd__nat__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),Ma: nat,Nb: nat] :
      ( ! [M3: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,M3),zero_zero(nat))
     => ( ! [M3: nat,N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),P,N),modulo_modulo(nat,M3,N))
             => aa(nat,$o,aa(nat,fun(nat,$o),P,M3),N) ) )
       => aa(nat,$o,aa(nat,fun(nat,$o),P,Ma),Nb) ) ) ).

% gcd_nat_induct
tff(fact_657_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,Nb)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% signed_take_bit_Suc
tff(fact_658_num_Osize__gen_I2_J,axiom,
    ! [X22: num] : ( size_num(aa(num,num,bit0,X22)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_num(X22)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size_gen(2)
tff(fact_659_power__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,L: num] : ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),K)),aa(num,nat,numeral_numeral(nat),L)) = aa(num,A,numeral_numeral(A),pow(K,L)) ) ) ).

% power_numeral
tff(fact_660_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,X2: A,Y2: A] :
          ( ( aa(nat,A,power_power(A,U),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ) ) ).

% arith_geo_mean
tff(fact_661_semiring__norm_I71_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit0,Ma)),aa(num,num,bit0,Nb))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Ma),Nb) ) ).

% semiring_norm(71)
tff(fact_662_semiring__norm_I68_J,axiom,
    ! [Nb: num] : aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),one2),Nb) ).

% semiring_norm(68)
tff(fact_663_Suc__le__mono,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Nb)),aa(nat,nat,suc,Ma))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma) ) ).

% Suc_le_mono
tff(fact_664_le0,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),Nb) ).

% le0
tff(fact_665_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),A2) ).

% bot_nat_0.extremum
tff(fact_666_set__bit__nonnegative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Nb),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% set_bit_nonnegative_int_iff
tff(fact_667_flip__bit__nonnegative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se8732182000553998342ip_bit(int,Nb,K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% flip_bit_nonnegative_int_iff
tff(fact_668_nat__add__left__cancel__le,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% nat_add_left_cancel_le
tff(fact_669_enat__ord__simps_I1_J,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extended_enat2(Ma)),extended_enat2(Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% enat_ord_simps(1)
tff(fact_670_enat__ord__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),Q2)
    <=> ( Q2 = extend4730790105801354508finity(extended_enat) ) ) ).

% enat_ord_simps(5)
tff(fact_671_enat__ord__code_I3_J,axiom,
    ! [Q2: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) ).

% enat_ord_code(3)
tff(fact_672_le__zero__eq,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Nb: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Nb),zero_zero(A))
        <=> ( Nb = zero_zero(A) ) ) ) ).

% le_zero_eq
tff(fact_673_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Ma: num,Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Ma),Nb) ) ) ).

% numeral_le_iff
tff(fact_674_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_cancel_left
tff(fact_675_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_cancel_right
tff(fact_676_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),one_one(A)) = A2 ) ) ).

% mult.right_neutral
tff(fact_677_mult__1,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A2) = A2 ) ) ).

% mult_1
tff(fact_678_semiring__norm_I69_J,axiom,
    ! [Ma: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit0,Ma)),one2) ).

% semiring_norm(69)
tff(fact_679_div__by__1,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),one_one(A)) = A2 ) ) ).

% div_by_1
tff(fact_680_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),one_one(A)) = A2 ) ) ).

% bits_div_by_1
tff(fact_681_power__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Nb: nat] : ( aa(nat,A,power_power(A,one_one(A)),Nb) = one_one(A) ) ) ).

% power_one
tff(fact_682_power__one__right,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,power_power(A,A2),one_one(nat)) = A2 ) ) ).

% power_one_right
tff(fact_683_set__n__deg__not__0,axiom,
    ! [TreeListb: list(vEBT_VEBT),Nb: nat,Ma: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
         => vEBT_invar_vebt(X4,Nb) )
     => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Nb) ) ) ).

% set_n_deg_not_0
tff(fact_684_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),K)
       => ( modulo_modulo(int,K,L) = K ) ) ) ).

% mod_neg_neg_trivial
tff(fact_685_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),L)
       => ( modulo_modulo(int,K,L) = K ) ) ) ).

% mod_pos_pos_trivial
tff(fact_686_set__bit__negative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Nb),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% set_bit_negative_int_iff
tff(fact_687_flip__bit__negative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se8732182000553998342ip_bit(int,Nb,K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% flip_bit_negative_int_iff
tff(fact_688_nat__mult__eq__1__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb) = one_one(nat) )
    <=> ( ( Ma = one_one(nat) )
        & ( Nb = one_one(nat) ) ) ) ).

% nat_mult_eq_1_iff
tff(fact_689_nat__1__eq__mult__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( one_one(nat) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb) )
    <=> ( ( Ma = one_one(nat) )
        & ( Nb = one_one(nat) ) ) ) ).

% nat_1_eq_mult_iff
tff(fact_690_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),zero_zero(A)) = zero_zero(A) ) ) ).

% signed_take_bit_of_0
tff(fact_691_take__all,axiom,
    ! [A: $tType,Xs: list(A),Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb)
     => ( take(A,Nb,Xs) = Xs ) ) ).

% take_all
tff(fact_692_take__all__iff,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( ( take(A,Nb,Xs) = Xs )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb) ) ).

% take_all_iff
tff(fact_693_unset__bit__nonnegative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Nb),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% unset_bit_nonnegative_int_iff
tff(fact_694_enat__ord__number_I1_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),Ma)),aa(num,extended_enat,numeral_numeral(extended_enat),Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Ma)),aa(num,nat,numeral_numeral(nat),Nb)) ) ).

% enat_ord_number(1)
tff(fact_695_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
tff(fact_696_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
tff(fact_697_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ).

% le_add_same_cancel2
tff(fact_698_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ).

% le_add_same_cancel1
tff(fact_699_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% add_le_same_cancel2
tff(fact_700_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% add_le_same_cancel1
tff(fact_701_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_left1
tff(fact_702_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = one_one(A) ) ) ) ) ).

% mult_cancel_left2
tff(fact_703_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_right1
tff(fact_704_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = one_one(A) ) ) ) ) ).

% mult_cancel_right2
tff(fact_705_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = one_one(A) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
tff(fact_706_div__self,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),A2) = one_one(A) ) ) ) ).

% div_self
tff(fact_707_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( one_one(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
tff(fact_708_divide__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),A2) = one_one(A) ) ) ) ).

% divide_self
tff(fact_709_divide__self__if,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),A2)
          = $ite(A2 = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% divide_self_if
tff(fact_710_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) = one_one(A) )
        <=> ( ( A2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
tff(fact_711_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( one_one(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) )
        <=> ( ( A2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
tff(fact_712_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% one_divide_eq_0_iff
tff(fact_713_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% zero_eq_1_divide_iff
tff(fact_714_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: num] :
          ( ( aa(num,A,numeral_numeral(A),Nb) = one_one(A) )
        <=> ( Nb = one2 ) ) ) ).

% numeral_eq_one_iff
tff(fact_715_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),Nb) )
        <=> ( one2 = Nb ) ) ) ).

% one_eq_numeral_iff
tff(fact_716_power__inject__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( ( aa(nat,A,power_power(A,A2),Ma) = aa(nat,A,power_power(A,A2),Nb) )
          <=> ( Ma = Nb ) ) ) ) ).

% power_inject_exp
tff(fact_717_mod__by__1,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,one_one(A)) = zero_zero(A) ) ) ).

% mod_by_1
tff(fact_718_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,one_one(A)) = zero_zero(A) ) ) ).

% bits_mod_by_1
tff(fact_719_one__le__mult__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),Ma)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),Nb) ) ) ).

% one_le_mult_iff
tff(fact_720_mult__le__cancel2,axiom,
    ! [Ma: nat,K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ).

% mult_le_cancel2
tff(fact_721_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ).

% nat_mult_le_cancel_disj
tff(fact_722_less__one,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),one_one(nat))
    <=> ( Nb = zero_zero(nat) ) ) ).

% less_one
tff(fact_723_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,Nb)),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_Suc_1
tff(fact_724_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(num,nat,numeral_numeral(nat),K)),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_numeral_of_1
tff(fact_725_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),L)
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = zero_zero(int) ) ) ) ).

% div_pos_pos_trivial
tff(fact_726_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),K)
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = zero_zero(int) ) ) ) ).

% div_neg_neg_trivial
tff(fact_727_numeral__le__enat__iff,axiom,
    ! [Ma: num,Nb: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),Ma)),extended_enat2(Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Ma)),Nb) ) ).

% numeral_le_enat_iff
tff(fact_728_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% divide_le_0_1_iff
tff(fact_729_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% zero_le_divide_1_iff
tff(fact_730_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Nb)),one_one(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Nb),one2) ) ) ).

% numeral_le_one_iff
tff(fact_731_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% divide_less_0_1_iff
tff(fact_732_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% divide_less_eq_1_neg
tff(fact_733_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% divide_less_eq_1_pos
tff(fact_734_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% less_divide_eq_1_neg
tff(fact_735_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% less_divide_eq_1_pos
tff(fact_736_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% zero_less_divide_1_iff
tff(fact_737_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) ) ) ).

% divide_le_eq_numeral1(1)
tff(fact_738_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))),B2) ) ) ).

% le_divide_eq_numeral1(1)
tff(fact_739_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,X2: nat,Y2: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,B2),X2)),aa(nat,A,power_power(A,B2),Y2))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X2),Y2) ) ) ) ).

% power_increasing_iff
tff(fact_740_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ).

% nonzero_divide_mult_cancel_left
tff(fact_741_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) ) ) ) ).

% nonzero_divide_mult_cancel_right
tff(fact_742_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,X2: nat,Y2: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,B2),X2)),aa(nat,A,power_power(A,B2),Y2))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),Y2) ) ) ) ).

% power_strict_increasing_iff
tff(fact_743_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,V)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),modulo_modulo(int,aa(num,int,numeral_numeral(int),V),aa(num,int,numeral_numeral(int),W))) ) ).

% zmod_numeral_Bit0
tff(fact_744_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% divide_le_eq_1_neg
tff(fact_745_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% divide_le_eq_1_pos
tff(fact_746_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% le_divide_eq_1_neg
tff(fact_747_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% le_divide_eq_1_pos
tff(fact_748_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,B2),Ma)),aa(nat,A,power_power(A,B2),Nb))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma) ) ) ) ) ).

% power_decreasing_iff
tff(fact_749_one__add__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% one_add_one
tff(fact_750_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,B2),Ma)),aa(nat,A,power_power(A,B2),Nb))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma) ) ) ) ) ).

% power_strict_decreasing_iff
tff(fact_751_power__mono__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb))
              <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ) ) ).

% power_mono_iff
tff(fact_752_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% bits_one_mod_two_eq_one
tff(fact_753_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% one_mod_two_eq_one
tff(fact_754_Suc__1,axiom,
    aa(nat,nat,suc,one_one(nat)) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) ).

% Suc_1
tff(fact_755_signed__take__bit__Suc__bit0,axiom,
    ! [Nb: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,Nb)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% signed_take_bit_Suc_bit0
tff(fact_756_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Nb)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Nb),one2)) ) ) ).

% numeral_plus_one
tff(fact_757_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),Nb)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Nb)) ) ) ).

% one_plus_numeral
tff(fact_758_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% half_nonnegative_int_iff
tff(fact_759_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(num,A,numeral_numeral(A),Nb))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),Nb) ) ) ).

% one_less_numeral_iff
tff(fact_760_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,Nb: nat] :
      ( ( aa(num,nat,numeral_numeral(nat),K) != one_one(nat) )
     => ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),K)),Nb)),aa(num,nat,numeral_numeral(nat),K)) = one_one(nat) ) ) ).

% Suc_times_numeral_mod_eq
tff(fact_761_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% bits_1_div_2
tff(fact_762_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% one_div_two_eq_zero
tff(fact_763_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),zero_zero(A))
        <=> ( A2 = zero_zero(A) ) ) ) ).

% power2_less_eq_zero_iff
tff(fact_764_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
           => ( ( aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
            <=> ( X2 = Y2 ) ) ) ) ) ).

% power2_eq_iff_nonneg
tff(fact_765_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != zero_zero(A) )
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ).

% not_mod_2_eq_0_eq_1
tff(fact_766_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != one_one(A) )
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ) ).

% not_mod_2_eq_1_eq_0
tff(fact_767_mod2__gr__0,axiom,
    ! [Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
    <=> ( modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(nat) ) ) ).

% mod2_gr_0
tff(fact_768_set__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),zero_zero(nat)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% set_bit_0
tff(fact_769_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z1),Z22)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z1)),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z22)) ) ).

% int_distrib(2)
tff(fact_770_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z1),Z22)),W) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Z1),W)),aa(int,int,aa(int,fun(int,int),times_times(int),Z22),W)) ) ).

% int_distrib(1)
tff(fact_771_less__eq__real__def,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
        | ( X2 = Y2 ) ) ) ).

% less_eq_real_def
tff(fact_772_signed__take__bit__mult,axiom,
    ! [Nb: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),times_times(int),K),L)) ) ).

% signed_take_bit_mult
tff(fact_773_unset__bit__less__eq,axiom,
    ! [Nb: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Nb),K)),K) ).

% unset_bit_less_eq
tff(fact_774_power__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat,N3: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,A2),N3)) ) ) ) ).

% power_increasing
tff(fact_775_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
          | ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% verit_la_disequality
tff(fact_776_one__reorient,axiom,
    ! [A: $tType] :
      ( one(A)
     => ! [X2: A] :
          ( ( one_one(A) = X2 )
        <=> ( X2 = one_one(A) ) ) ) ).

% one_reorient
tff(fact_777_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),A2) ) ).

% verit_comp_simplify1(2)
tff(fact_778_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),one_one(A)) ) ).

% le_numeral_extra(4)
tff(fact_779_signed__take__bit__add,axiom,
    ! [Nb: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% signed_take_bit_add
tff(fact_780_zmod__le__nonneg__dividend,axiom,
    ! [Ma: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Ma)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,Ma,K)),Ma) ) ).

% zmod_le_nonneg_dividend
tff(fact_781_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),zero_zero(A)) ) ).

% not_one_le_zero
tff(fact_782_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),one_one(A)) ) ).

% linordered_nonzero_semiring_class.zero_le_one
tff(fact_783_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),one_one(A)) ) ).

% zero_less_one_class.zero_le_one
tff(fact_784_one__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(num,A,numeral_numeral(A),Nb)) ) ).

% one_le_numeral
tff(fact_785_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),Nb: nat,N2: nat] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,aa(nat,nat,suc,N))),aa(nat,A,F3,N))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),N2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N2)),aa(nat,A,F3,Nb)) ) ) ) ).

% lift_Suc_antimono_le
tff(fact_786_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),Nb: nat,N2: nat] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N)),aa(nat,A,F3,aa(nat,nat,suc,N)))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),N2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,Nb)),aa(nat,A,F3,N2)) ) ) ) ).

% lift_Suc_mono_le
tff(fact_787_one__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% one_le_power
tff(fact_788_power__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat,N3: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),N3)),aa(nat,A,power_power(A,A2),Nb)) ) ) ) ) ).

% power_decreasing
tff(fact_789_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),Ma)),aa(nat,A,power_power(A,A2),Nb))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ) ).

% power_le_imp_le_exp
tff(fact_790_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),X2)),X2) ) ) ) ) ).

% mult_left_le_one_le
tff(fact_791_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2)),X2) ) ) ) ) ).

% mult_right_le_one_le
tff(fact_792_mult__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A)) ) ) ) ) ).

% mult_le_one
tff(fact_793_mult__left__le,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),A2) ) ) ) ).

% mult_left_le
tff(fact_794_discrete,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),B2) ) ) ).

% discrete
tff(fact_795_power__le__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),Nb)),one_one(A)) ) ) ) ).

% power_le_one
tff(fact_796_zmod__trivial__iff,axiom,
    ! [I3: int,K: int] :
      ( ( modulo_modulo(int,I3,K) = I3 )
    <=> ( ( K = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I3)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),I3),K) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I3) ) ) ) ).

% zmod_trivial_iff
tff(fact_797_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,A2,B2))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),modulo_modulo(int,A2,B2)),B2) ) ) ).

% pos_mod_conj
tff(fact_798_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,A2,B2)),zero_zero(int))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),modulo_modulo(int,A2,B2)) ) ) ).

% neg_mod_conj
tff(fact_799_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,K,L)),zero_zero(int)) ) ).

% neg_mod_sign
tff(fact_800_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,K,L)) ) ).

% Euclidean_Division.pos_mod_sign
tff(fact_801_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)),zero_zero(int))
       => ( modulo_modulo(int,K,L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L) ) ) ) ).

% mod_pos_neg_trivial
tff(fact_802_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),B2)
         => ( modulo_modulo(int,A2,B2) = R ) ) ) ) ).

% int_mod_pos_eq
tff(fact_803_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R)
         => ( modulo_modulo(int,A2,B2) = R ) ) ) ) ).

% int_mod_neg_eq
tff(fact_804_split__zmod,axiom,
    ! [P: fun(int,$o),Nb: int,K: int] :
      ( aa(int,$o,P,modulo_modulo(int,Nb,K))
    <=> ( ( ( K = zero_zero(int) )
         => aa(int,$o,P,Nb) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
         => ! [I: int,J4: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J4)
                & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J4),K)
                & ( Nb = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J4) ) )
             => aa(int,$o,P,J4) ) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
         => ! [I: int,J4: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J4)
                & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J4),zero_zero(int))
                & ( Nb = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J4) ) )
             => aa(int,$o,P,J4) ) ) ) ) ).

% split_zmod
tff(fact_805_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),C2)
     => ( modulo_modulo(int,A2,aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2),C2))),modulo_modulo(int,A2,B2)) ) ) ).

% zmod_zmult2_eq
tff(fact_806_less__eq__enat__def,axiom,
    ! [Ma: extended_enat,Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Ma),Nb)
    <=> extended_case_enat($o,aTP_Lamp_an(extended_enat,fun(nat,$o),Ma),$true,Nb) ) ).

% less_eq_enat_def
tff(fact_807_set__take__subset__set__take,axiom,
    ! [A: $tType,Ma: nat,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),take(A,Ma,Xs))),aa(list(A),set(A),set2(A),take(A,Nb,Xs))) ) ).

% set_take_subset_set_take
tff(fact_808_zmod__eq__0D,axiom,
    ! [Ma: int,D2: int] :
      ( ( modulo_modulo(int,Ma,D2) = zero_zero(int) )
     => ? [Q3: int] : ( Ma = aa(int,int,aa(int,fun(int,int),times_times(int),D2),Q3) ) ) ).

% zmod_eq_0D
tff(fact_809_zmod__eq__0__iff,axiom,
    ! [Ma: int,D2: int] :
      ( ( modulo_modulo(int,Ma,D2) = zero_zero(int) )
    <=> ? [Q4: int] : ( Ma = aa(int,int,aa(int,fun(int,int),times_times(int),D2),Q4) ) ) ).

% zmod_eq_0_iff
tff(fact_810_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),zero_zero(A)) ) ).

% le_numeral_extra(3)
tff(fact_811_zero__le,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2) ) ).

% zero_le
tff(fact_812_verit__comp__simplify1_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B5: A,A5: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B5),A5)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A5),B5) ) ) ).

% verit_comp_simplify1(3)
tff(fact_813_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I3),J2)
            & ( K = L ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(3)
tff(fact_814_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( ( I3 = J2 )
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(2)
tff(fact_815_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I3),J2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(1)
tff(fact_816_add__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_mono
tff(fact_817_add__left__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% add_left_mono
tff(fact_818_less__eqE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ~ ! [C3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C3) ) ) ) ).

% less_eqE
tff(fact_819_add__right__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add_right_mono
tff(fact_820_le__iff__add,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ? [C4: A] : ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C4) ) ) ) ).

% le_iff_add
tff(fact_821_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_imp_le_left
tff(fact_822_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_imp_le_right
tff(fact_823_le__num__One__iff,axiom,
    ! [X2: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),X2),one2)
    <=> ( X2 = one2 ) ) ).

% le_num_One_iff
tff(fact_824_zero__neq__one,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( zero_zero(A) != one_one(A) ) ) ).

% zero_neq_one
tff(fact_825_div__mod__decomp__int,axiom,
    ! [A3: int,Nb: int] : ( A3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),Nb)),Nb)),modulo_modulo(int,A3,Nb)) ) ).

% div_mod_decomp_int
tff(fact_826_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),one_one(A)) ) ).

% less_numeral_extra(4)
tff(fact_827_Suc__leD,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Ma)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% Suc_leD
tff(fact_828_le__SucE,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,suc,Nb))
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
       => ( Ma = aa(nat,nat,suc,Nb) ) ) ) ).

% le_SucE
tff(fact_829_le__SucI,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,suc,Nb)) ) ).

% le_SucI
tff(fact_830_Suc__le__D,axiom,
    ! [Nb: nat,M5: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Nb)),M5)
     => ? [M3: nat] : ( M5 = aa(nat,nat,suc,M3) ) ) ).

% Suc_le_D
tff(fact_831_le__Suc__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,suc,Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
        | ( Ma = aa(nat,nat,suc,Nb) ) ) ) ).

% le_Suc_eq
tff(fact_832_Suc__n__not__le__n,axiom,
    ! [Nb: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Nb)),Nb) ).

% Suc_n_not_le_n
tff(fact_833_not__less__eq__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Nb)),Ma) ) ).

% not_less_eq_eq
tff(fact_834_full__nat__induct,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( ! [N: nat] :
          ( ! [M: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),N)
             => aa(nat,$o,P,M) )
         => aa(nat,$o,P,N) )
     => aa(nat,$o,P,Nb) ) ).

% full_nat_induct
tff(fact_835_nat__induct__at__least,axiom,
    ! [Ma: nat,Nb: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( aa(nat,$o,P,Ma)
       => ( ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),N)
             => ( aa(nat,$o,P,N)
               => aa(nat,$o,P,aa(nat,nat,suc,N)) ) )
         => aa(nat,$o,P,Nb) ) ) ) ).

% nat_induct_at_least
tff(fact_836_transitive__stepwise__le,axiom,
    ! [Ma: nat,Nb: nat,R3: fun(nat,fun(nat,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( ! [X4: nat] : aa(nat,$o,aa(nat,fun(nat,$o),R3,X4),X4)
       => ( ! [X4: nat,Y4: nat,Z2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),R3,X4),Y4)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),R3,Y4),Z2)
               => aa(nat,$o,aa(nat,fun(nat,$o),R3,X4),Z2) ) )
         => ( ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),R3,N),aa(nat,nat,suc,N))
           => aa(nat,$o,aa(nat,fun(nat,$o),R3,Ma),Nb) ) ) ) ) ).

% transitive_stepwise_le
tff(fact_837_le__0__eq,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),zero_zero(nat))
    <=> ( Nb = zero_zero(nat) ) ) ).

% le_0_eq
tff(fact_838_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),zero_zero(nat))
     => ( A2 = zero_zero(nat) ) ) ).

% bot_nat_0.extremum_uniqueI
tff(fact_839_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),zero_zero(nat))
    <=> ( A2 = zero_zero(nat) ) ) ).

% bot_nat_0.extremum_unique
tff(fact_840_less__eq__nat_Osimps_I1_J,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),Nb) ).

% less_eq_nat.simps(1)
tff(fact_841_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A2) = A2 ) ) ).

% comm_monoid_mult_class.mult_1
tff(fact_842_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),one_one(A)) = A2 ) ) ).

% mult.comm_neutral
tff(fact_843_nat__less__le,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
        & ( Ma != Nb ) ) ) ).

% nat_less_le
tff(fact_844_less__imp__le__nat,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% less_imp_le_nat
tff(fact_845_le__eq__less__or__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
        | ( Ma = Nb ) ) ) ).

% le_eq_less_or_eq
tff(fact_846_less__or__eq__imp__le,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
        | ( Ma = Nb ) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% less_or_eq_imp_le
tff(fact_847_le__neq__implies__less,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( ( Ma != Nb )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ).

% le_neq_implies_less
tff(fact_848_less__mono__imp__le__mono,axiom,
    ! [F3: fun(nat,nat),I3: nat,J2: nat] :
      ( ! [I2: nat,J: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,F3,I2)),aa(nat,nat,F3,J)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,F3,I3)),aa(nat,nat,F3,J2)) ) ) ).

% less_mono_imp_le_mono
tff(fact_849_less__eq__int__code_I1_J,axiom,
    aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),zero_zero(int)) ).

% less_eq_int_code(1)
tff(fact_850_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),B4)
    <=> ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
         => aa(set(A),$o,member(A,X3),B4) ) ) ).

% subset_code(1)
tff(fact_851_add__leE,axiom,
    ! [Ma: nat,K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K)),Nb)
     => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb) ) ) ).

% add_leE
tff(fact_852_le__add1,axiom,
    ! [Nb: nat,Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)) ).

% le_add1
tff(fact_853_le__add2,axiom,
    ! [Nb: nat,Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) ).

% le_add2
tff(fact_854_add__leD1,axiom,
    ! [Ma: nat,K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% add_leD1
tff(fact_855_add__leD2,axiom,
    ! [Ma: nat,K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb) ) ).

% add_leD2
tff(fact_856_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
     => ? [N: nat] : ( L = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N) ) ) ).

% le_Suc_ex
tff(fact_857_add__le__mono,axiom,
    ! [I3: nat,J2: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),L)) ) ) ).

% add_le_mono
tff(fact_858_add__le__mono1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) ) ).

% add_le_mono1
tff(fact_859_trans__le__add1,axiom,
    ! [I3: nat,J2: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),Ma)) ) ).

% trans_le_add1
tff(fact_860_trans__le__add2,axiom,
    ! [I3: nat,J2: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),J2)) ) ).

% trans_le_add2
tff(fact_861_nat__le__iff__add,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
    <=> ? [K3: nat] : ( Nb = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K3) ) ) ).

% nat_le_iff_add
tff(fact_862_mult__le__mono2,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),I3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),J2)) ) ).

% mult_le_mono2
tff(fact_863_mult__le__mono1,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),K)) ) ).

% mult_le_mono1
tff(fact_864_mult__le__mono,axiom,
    ! [I3: nat,J2: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),L)) ) ) ).

% mult_le_mono
tff(fact_865_le__square,axiom,
    ! [Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Ma)) ).

% le_square
tff(fact_866_le__cube,axiom,
    ! [Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Ma))) ).

% le_cube
tff(fact_867_div__le__mono,axiom,
    ! [Ma: nat,Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),K)) ) ).

% div_le_mono
tff(fact_868_div__le__dividend,axiom,
    ! [Ma: nat,Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),Ma) ).

% div_le_dividend
tff(fact_869_nat__mult__1__right,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),one_one(nat)) = Nb ) ).

% nat_mult_1_right
tff(fact_870_nat__mult__1,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),one_one(nat)),Nb) = Nb ) ).

% nat_mult_1
tff(fact_871_enat__ile,axiom,
    ! [Nb: extended_enat,Ma: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Nb),extended_enat2(Ma))
     => ? [K2: nat] : ( Nb = extended_enat2(K2) ) ) ).

% enat_ile
tff(fact_872_mod__less__eq__dividend,axiom,
    ! [Ma: nat,Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,Ma,Nb)),Ma) ).

% mod_less_eq_dividend
tff(fact_873_enat__ord__simps_I3_J,axiom,
    ! [Q2: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) ).

% enat_ord_simps(3)
tff(fact_874_ile0__eq,axiom,
    ! [Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Nb),zero_zero(extended_enat))
    <=> ( Nb = zero_zero(extended_enat) ) ) ).

% ile0_eq
tff(fact_875_i0__lb,axiom,
    ! [Nb: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),zero_zero(extended_enat)),Nb) ).

% i0_lb
tff(fact_876_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( ! [Z2: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),one_one(A))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),X2)),Y2) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2) ) ) ).

% field_le_mult_one_interval
tff(fact_877_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2) ) ) ) ) ).

% mult_less_cancel_right2
tff(fact_878_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A)) ) ) ) ) ).

% mult_less_cancel_right1
tff(fact_879_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2) ) ) ) ) ).

% mult_less_cancel_left2
tff(fact_880_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A)) ) ) ) ) ).

% mult_less_cancel_left1
tff(fact_881_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2) ) ) ) ) ).

% mult_le_cancel_right2
tff(fact_882_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A)) ) ) ) ) ).

% mult_le_cancel_right1
tff(fact_883_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2) ) ) ) ) ).

% mult_le_cancel_left2
tff(fact_884_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A)) ) ) ) ) ).

% mult_le_cancel_left1
tff(fact_885_convex__bound__le,axiom,
    ! [A: $tType] :
      ( linord6961819062388156250ring_1(A)
     => ! [X2: A,A2: A,Y2: A,U: A,V: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),U)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),V)
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y2))),A2) ) ) ) ) ) ) ).

% convex_bound_le
tff(fact_886_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            | ( A2 = zero_zero(A) ) ) ) ) ).

% divide_le_eq_1
tff(fact_887_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% le_divide_eq_1
tff(fact_888_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),aa(nat,nat,suc,Nb))),A2) ) ) ) ).

% power_Suc_le_self
tff(fact_889_self__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(nat,A,power_power(A,A2),Nb)) ) ) ) ).

% self_le_power
tff(fact_890_split__neg__lemma,axiom,
    ! [K: int,P: fun(int,fun(int,$o)),Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),Nb),K)),modulo_modulo(int,Nb,K))
      <=> ! [I: int,J4: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J4)
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J4),zero_zero(int))
              & ( Nb = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J4) ) )
           => aa(int,$o,aa(int,fun(int,$o),P,I),J4) ) ) ) ).

% split_neg_lemma
tff(fact_891_split__pos__lemma,axiom,
    ! [K: int,P: fun(int,fun(int,$o)),Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),Nb),K)),modulo_modulo(int,Nb,K))
      <=> ! [I: int,J4: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J4)
              & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J4),K)
              & ( Nb = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J4) ) )
           => aa(int,$o,aa(int,fun(int,$o),P,I),J4) ) ) ) ).

% split_pos_lemma
tff(fact_892_lambda__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aTP_Lamp_ao(A,A) = aa(A,fun(A,A),times_times(A),one_one(A)) ) ) ).

% lambda_one
tff(fact_893_iadd__le__enat__iff,axiom,
    ! [X2: extended_enat,Y2: extended_enat,Nb: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X2),Y2)),extended_enat2(Nb))
    <=> ? [Y6: nat,X5: nat] :
          ( ( X2 = extended_enat2(X5) )
          & ( Y2 = extended_enat2(Y6) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X5),Y6)),Nb) ) ) ).

% iadd_le_enat_iff
tff(fact_894_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ).

% signed_take_bit_int_greater_eq_self_iff
tff(fact_895_signed__take__bit__int__less__self__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),K) ) ).

% signed_take_bit_int_less_self_iff
tff(fact_896_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( linord715952674999750819strict(A)
     => ! [X2: A,A2: A,Y2: A,U: A,V: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),U)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),V)
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y2))),A2) ) ) ) ) ) ) ).

% convex_bound_lt
tff(fact_897_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),modulo_modulo(int,K,L)) ) ).

% neg_mod_bound
tff(fact_898_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),modulo_modulo(int,K,L)),L) ) ).

% Euclidean_Division.pos_mod_bound
tff(fact_899_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Nb)),zero_zero(A)) ) ).

% not_numeral_le_zero
tff(fact_900_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),Nb)) ) ).

% zero_le_numeral
tff(fact_901_mult__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_mono
tff(fact_902_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_mono'
tff(fact_903_zero__le__square,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)) ) ).

% zero_le_square
tff(fact_904_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% split_mult_pos_le
tff(fact_905_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_left_mono_neg
tff(fact_906_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_nonpos_nonpos
tff(fact_907_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_left_mono
tff(fact_908_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_right_mono_neg
tff(fact_909_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_right_mono
tff(fact_910_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ) ) ).

% mult_le_0_iff
tff(fact_911_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ).

% split_mult_neg_le
tff(fact_912_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_nonneg_nonneg
tff(fact_913_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_nonneg_nonpos
tff(fact_914_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_nonpos_nonneg
tff(fact_915_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),zero_zero(A)) ) ) ) ).

% mult_nonneg_nonpos2
tff(fact_916_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_le_mult_iff
tff(fact_917_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordere2520102378445227354miring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
tff(fact_918_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),zero_zero(A))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2) = zero_zero(A) )
            <=> ( ( X2 = zero_zero(A) )
                & ( Y2 = zero_zero(A) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
tff(fact_919_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2) = zero_zero(A) )
            <=> ( ( X2 = zero_zero(A) )
                & ( Y2 = zero_zero(A) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
tff(fact_920_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_nonpos_nonpos
tff(fact_921_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_nonneg_nonneg
tff(fact_922_add__increasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_increasing2
tff(fact_923_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ) ).

% add_decreasing2
tff(fact_924_add__increasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_increasing
tff(fact_925_add__decreasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ) ).

% add_decreasing
tff(fact_926_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I3),J2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(4)
tff(fact_927_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I3: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I3),J2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(3)
tff(fact_928_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_le_less_mono
tff(fact_929_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_less_le_mono
tff(fact_930_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ) ) ).

% divide_le_0_iff
tff(fact_931_divide__right__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% divide_right_mono
tff(fact_932_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_le_divide_iff
tff(fact_933_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% divide_nonneg_nonneg
tff(fact_934_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),zero_zero(A)) ) ) ) ).

% divide_nonneg_nonpos
tff(fact_935_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),zero_zero(A)) ) ) ) ).

% divide_nonpos_nonneg
tff(fact_936_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% divide_nonpos_nonpos
tff(fact_937_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)) ) ) ) ).

% divide_right_mono_neg
tff(fact_938_power__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb)) ) ) ) ).

% power_mono
tff(fact_939_zero__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% zero_le_power
tff(fact_940_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),modulo_modulo(A,A2,B2)),A2) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
tff(fact_941_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),zero_zero(A)) ) ).

% not_one_less_zero
tff(fact_942_zero__less__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),one_one(A)) ) ).

% zero_less_one
tff(fact_943_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),one_one(A)) ) ).

% less_numeral_extra(1)
tff(fact_944_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Nb)),one_one(A)) ) ).

% not_numeral_less_one
tff(fact_945_less__1__mult,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Ma: A,Nb: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),Nb)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),Nb)) ) ) ) ).

% less_1_mult
tff(fact_946_less__add__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))) ) ).

% less_add_one
tff(fact_947_add__mono1,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),one_one(A))) ) ) ).

% add_mono1
tff(fact_948_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = one_one(A) )
          <=> ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
tff(fact_949_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),X2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X2)),one_one(A)) ) ) ).

% one_plus_numeral_commute
tff(fact_950_le__imp__less__Suc,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,suc,Nb)) ) ).

% le_imp_less_Suc
tff(fact_951_less__eq__Suc__le,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Nb)),Ma) ) ).

% less_eq_Suc_le
tff(fact_952_less__Suc__eq__le,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,suc,Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% less_Suc_eq_le
tff(fact_953_le__less__Suc__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,suc,Ma))
      <=> ( Nb = Ma ) ) ) ).

% le_less_Suc_eq
tff(fact_954_Suc__le__lessD,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Ma)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% Suc_le_lessD
tff(fact_955_inc__induct,axiom,
    ! [I3: nat,J2: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( aa(nat,$o,P,J2)
       => ( ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),N)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),J2)
               => ( aa(nat,$o,P,aa(nat,nat,suc,N))
                 => aa(nat,$o,P,N) ) ) )
         => aa(nat,$o,P,I3) ) ) ) ).

% inc_induct
tff(fact_956_dec__induct,axiom,
    ! [I3: nat,J2: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( aa(nat,$o,P,I3)
       => ( ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),N)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),J2)
               => ( aa(nat,$o,P,N)
                 => aa(nat,$o,P,aa(nat,nat,suc,N)) ) ) )
         => aa(nat,$o,P,J2) ) ) ) ).

% dec_induct
tff(fact_957_Suc__le__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Ma)),Nb)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% Suc_le_eq
tff(fact_958_Suc__leI,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Ma)),Nb) ) ).

% Suc_leI
tff(fact_959_numeral__One,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(num,A,numeral_numeral(A),one2) = one_one(A) ) ) ).

% numeral_One
tff(fact_960_ex__least__nat__le,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( aa(nat,$o,P,Nb)
     => ( ~ aa(nat,$o,P,zero_zero(nat))
       => ? [K2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),Nb)
            & ! [I4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),K2)
               => ~ aa(nat,$o,P,I4) )
            & aa(nat,$o,P,K2) ) ) ) ).

% ex_least_nat_le
tff(fact_961_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X2: A,Y2: A,Nb: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2) = one_one(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),Nb)),aa(nat,A,power_power(A,Y2),Nb)) = one_one(A) ) ) ) ).

% left_right_inverse_power
tff(fact_962_mono__nat__linear__lb,axiom,
    ! [F3: fun(nat,nat),Ma: nat,K: nat] :
      ( ! [M3: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,F3,M3)),aa(nat,nat,F3,N)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,F3,Ma)),K)),aa(nat,nat,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K))) ) ).

% mono_nat_linear_lb
tff(fact_963_Suc__mult__le__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% Suc_mult_le_cancel1
tff(fact_964_power__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)),Nb) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% power_one_over
tff(fact_965_power__0,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A2: A] : ( aa(nat,A,power_power(A,A2),zero_zero(nat)) = one_one(A) ) ) ).

% power_0
tff(fact_966_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R4: int,Q2: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q5)),R4)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R4)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q2),Q5) ) ) ) ) ).

% unique_quotient_lemma_neg
tff(fact_967_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R4: int,Q2: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q5)),R4)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R4)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R4),B2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q5),Q2) ) ) ) ) ).

% unique_quotient_lemma
tff(fact_968_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B5: int,Q5: int,R4: int] :
      ( ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R4) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R4)),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),B2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R4)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
               => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q5),Q2) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
tff(fact_969_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B5: int,Q5: int,R4: int] :
      ( ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R4) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R4))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R4),B5)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
               => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q2),Q5) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
tff(fact_970_q__pos__lemma,axiom,
    ! [B5: int,Q5: int,R4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R4))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R4),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Q5) ) ) ) ).

% q_pos_lemma
tff(fact_971_numerals_I1_J,axiom,
    aa(num,nat,numeral_numeral(nat),one2) = one_one(nat) ).

% numerals(1)
tff(fact_972_Suc__div__le__mono,axiom,
    ! [Ma: nat,Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,Ma)),Nb)) ).

% Suc_div_le_mono
tff(fact_973_One__nat__def,axiom,
    one_one(nat) = aa(nat,nat,suc,zero_zero(nat)) ).

% One_nat_def
tff(fact_974_Suc__eq__plus1__left,axiom,
    ! [Nb: nat] : ( aa(nat,nat,suc,Nb) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),Nb) ) ).

% Suc_eq_plus1_left
tff(fact_975_plus__1__eq__Suc,axiom,
    aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)) = suc ).

% plus_1_eq_Suc
tff(fact_976_Suc__eq__plus1,axiom,
    ! [Nb: nat] : ( aa(nat,nat,suc,Nb) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)) ) ).

% Suc_eq_plus1
tff(fact_977_mod__Suc__le__divisor,axiom,
    ! [Ma: nat,Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,Ma,aa(nat,nat,suc,Nb))),Nb) ).

% mod_Suc_le_divisor
tff(fact_978_times__div__less__eq__dividend,axiom,
    ! [Nb: nat,Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb))),Ma) ).

% times_div_less_eq_dividend
tff(fact_979_div__times__less__eq__dividend,axiom,
    ! [Ma: nat,Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),Nb)),Ma) ).

% div_times_less_eq_dividend
tff(fact_980_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),C2)
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),C2) ) ) ).

% zdiv_zmult2_eq
tff(fact_981_mult__eq__self__implies__10,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( Ma = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb) )
     => ( ( Nb = one_one(nat) )
        | ( Ma = zero_zero(nat) ) ) ) ).

% mult_eq_self_implies_10
tff(fact_982_set__take__subset,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),take(A,Nb,Xs))),aa(list(A),set(A),set2(A),Xs)) ).

% set_take_subset
tff(fact_983_infinity__ileE,axiom,
    ! [Ma: nat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(Ma)) ).

% infinity_ileE
tff(fact_984_enat__ord__code_I5_J,axiom,
    ! [Nb: nat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(Nb)) ).

% enat_ord_code(5)
tff(fact_985_pow_Osimps_I1_J,axiom,
    ! [X2: num] : ( pow(X2,one2) = X2 ) ).

% pow.simps(1)
tff(fact_986_enat__add__left__cancel__le,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),B2)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),C2))
    <=> ( ( A2 = extend4730790105801354508finity(extended_enat) )
        | aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),B2),C2) ) ) ).

% enat_add_left_cancel_le
tff(fact_987_verit__le__mono__div,axiom,
    ! [A3: nat,B4: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A3),B4)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => aa(nat,$o,
            aa(nat,fun(nat,$o),ord_less_eq(nat),
              aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A3),Nb)),$ite(modulo_modulo(nat,B4,Nb) = zero_zero(nat),one_one(nat),zero_zero(nat)))),
            aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),B4),Nb)) ) ) ).

% verit_le_mono_div
tff(fact_988_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D2: nat] :
      ( vEBT_VEBT_valid(vEBT_Leaf(Uu,Uv),D2)
    <=> ( D2 = one_one(nat) ) ) ).

% VEBT_internal.valid'.simps(1)
tff(fact_989_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_less_le_imp_less
tff(fact_990_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_le_less_imp_less
tff(fact_991_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_right_le_imp_le
tff(fact_992_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_left_le_imp_le
tff(fact_993_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_le_cancel_left_pos
tff(fact_994_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% mult_le_cancel_left_neg
tff(fact_995_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_right
tff(fact_996_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_strict_mono'
tff(fact_997_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_right_less_imp_less
tff(fact_998_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_left
tff(fact_999_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_strict_mono
tff(fact_1000_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_left_less_imp_less
tff(fact_1001_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% mult_le_cancel_right
tff(fact_1002_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% mult_le_cancel_left
tff(fact_1003_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2) ) ) ) ).

% mult_le_cancel_iff2
tff(fact_1004_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2) ) ) ) ).

% mult_le_cancel_iff1
tff(fact_1005_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( ! [E: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y2),E)) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2) ) ) ).

% field_le_epsilon
tff(fact_1006_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_neg_nonpos
tff(fact_1007_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_nonneg_pos
tff(fact_1008_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_nonpos_neg
tff(fact_1009_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_pos_nonneg
tff(fact_1010_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_strict_increasing
tff(fact_1011_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_strict_increasing2
tff(fact_1012_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),K)
       => ? [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,B2),N)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))) ) ) ) ).

% ex_power_ivl1
tff(fact_1013_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
       => ? [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,power_power(nat,B2),N)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))) ) ) ) ).

% ex_power_ivl2
tff(fact_1014_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X2: A,Y2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Y2))) ) ).

% sum_squares_ge_zero
tff(fact_1015_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Y2))),zero_zero(A))
        <=> ( ( X2 = zero_zero(A) )
            & ( Y2 = zero_zero(A) ) ) ) ) ).

% sum_squares_le_zero_iff
tff(fact_1016_frac__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y2: A,X2: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),W)) ) ) ) ) ) ).

% frac_le
tff(fact_1017_frac__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),W)) ) ) ) ) ) ).

% frac_less
tff(fact_1018_frac__less2,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),W)) ) ) ) ) ) ).

% frac_less2
tff(fact_1019_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% divide_le_cancel
tff(fact_1020_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),zero_zero(A)) ) ) ) ).

% divide_nonneg_neg
tff(fact_1021_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% divide_nonneg_pos
tff(fact_1022_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% divide_nonpos_neg
tff(fact_1023_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),zero_zero(A)) ) ) ) ).

% divide_nonpos_pos
tff(fact_1024_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
tff(fact_1025_div__positive,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_positive
tff(fact_1026_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% power_less_imp_less_base
tff(fact_1027_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
tff(fact_1028_zdiv__mono__strict,axiom,
    ! [A3: int,B4: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A3),B4)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Nb)
       => ( ( modulo_modulo(int,A3,Nb) = zero_zero(int) )
         => ( ( modulo_modulo(int,B4,Nb) = zero_zero(int) )
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),Nb)),aa(int,int,aa(int,fun(int,int),divide_divide(int),B4),Nb)) ) ) ) ) ).

% zdiv_mono_strict
tff(fact_1029_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),aa(nat,nat,suc,Nb))),aa(nat,A,power_power(A,B2),aa(nat,nat,suc,Nb)))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% power_le_imp_le_base
tff(fact_1030_power__inject__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat,B2: A] :
          ( ( aa(nat,A,power_power(A,A2),aa(nat,nat,suc,Nb)) = aa(nat,A,power_power(A,B2),aa(nat,nat,suc,Nb)) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
tff(fact_1031_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),modulo_modulo(A,A2,B2)) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
tff(fact_1032_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( modulo_modulo(A,A2,B2) = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
tff(fact_1033_zero__less__two,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A))) ) ).

% zero_less_two
tff(fact_1034_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( A2 = zero_zero(A) ) ) ) ) ).

% divide_less_eq_1
tff(fact_1035_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% less_divide_eq_1
tff(fact_1036_div__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),one_one(A)) ) ) ) ).

% div_add_self1
tff(fact_1037_div__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),one_one(A)) ) ) ) ).

% div_add_self2
tff(fact_1038_ex__least__nat__less,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( aa(nat,$o,P,Nb)
     => ( ~ aa(nat,$o,P,zero_zero(nat))
       => ? [K2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K2),Nb)
            & ! [I4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I4),K2)
               => ~ aa(nat,$o,P,I4) )
            & aa(nat,$o,P,aa(nat,nat,suc,K2)) ) ) ) ).

% ex_least_nat_less
tff(fact_1039_gt__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))),B2) ) ) ).

% gt_half_sum
tff(fact_1040_less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))) ) ) ).

% less_half_sum
tff(fact_1041_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,A2),Nb))) ) ) ).

% power_gt1_lemma
tff(fact_1042_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),Nb)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,A2),Nb))) ) ) ).

% power_less_power_Suc
tff(fact_1043_power__0__left,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: nat] :
          ( aa(nat,A,power_power(A,zero_zero(A)),Nb)
          = $ite(Nb = zero_zero(nat),one_one(A),zero_zero(A)) ) ) ).

% power_0_left
tff(fact_1044_power__gt1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(nat,A,power_power(A,A2),aa(nat,nat,suc,Nb))) ) ) ).

% power_gt1
tff(fact_1045_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),Ma)),aa(nat,A,power_power(A,A2),Nb))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ) ).

% power_less_imp_less_exp
tff(fact_1046_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat,N3: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,A2),N3)) ) ) ) ).

% power_strict_increasing
tff(fact_1047_nat__mult__le__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ).

% nat_mult_le_cancel1
tff(fact_1048_nat__one__le__power,axiom,
    ! [I3: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),I3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,power_power(nat,I3),Nb)) ) ).

% nat_one_le_power
tff(fact_1049_div__le__mono2,axiom,
    ! [Ma: nat,Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),K),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),K),Ma)) ) ) ).

% div_le_mono2
tff(fact_1050_div__greater__zero__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ) ).

% div_greater_zero_iff
tff(fact_1051_nat__induct__non__zero,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,P,one_one(nat))
       => ( ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => ( aa(nat,$o,P,N)
               => aa(nat,$o,P,aa(nat,nat,suc,N)) ) )
         => aa(nat,$o,P,Nb) ) ) ) ).

% nat_induct_non_zero
tff(fact_1052_mod__le__divisor,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,Ma,Nb)),Nb) ) ).

% mod_le_divisor
tff(fact_1053_split__zdiv,axiom,
    ! [P: fun(int,$o),Nb: int,K: int] :
      ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),divide_divide(int),Nb),K))
    <=> ( ( ( K = zero_zero(int) )
         => aa(int,$o,P,zero_zero(int)) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
         => ! [I: int,J4: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J4)
                & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J4),K)
                & ( Nb = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J4) ) )
             => aa(int,$o,P,I) ) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
         => ! [I: int,J4: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J4)
                & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J4),zero_zero(int))
                & ( Nb = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J4) ) )
             => aa(int,$o,P,I) ) ) ) ) ).

% split_zdiv
tff(fact_1054_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R)
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2) = Q2 ) ) ) ) ).

% int_div_neg_eq
tff(fact_1055_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),B2)
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2) = Q2 ) ) ) ) ).

% int_div_pos_eq
tff(fact_1056_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))
      <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B2),A2)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
tff(fact_1057_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2) ) ) ).

% pos_imp_zdiv_nonneg_iff
tff(fact_1058_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int)) ) ) ).

% neg_imp_zdiv_nonneg_iff
tff(fact_1059_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I3: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),I3),K))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I3) ) ) ).

% pos_imp_zdiv_pos_iff
tff(fact_1060_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int)) ) ) ).

% div_nonpos_pos_le0
tff(fact_1061_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int)) ) ) ).

% div_nonneg_neg_le0
tff(fact_1062_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L)) ) ) ).

% div_positive_int
tff(fact_1063_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L))
    <=> ( ( K = zero_zero(int) )
        | ( L = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
          & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ) ).

% div_int_pos_iff
tff(fact_1064_zdiv__mono2__neg,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B5)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)) ) ) ) ).

% zdiv_mono2_neg
tff(fact_1065_zdiv__mono1__neg,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),A5)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A5),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)) ) ) ).

% zdiv_mono1_neg
tff(fact_1066_zdiv__eq__0__iff,axiom,
    ! [I3: int,K: int] :
      ( ( aa(int,int,aa(int,fun(int,int),divide_divide(int),I3),K) = zero_zero(int) )
    <=> ( ( K = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I3)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),I3),K) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I3) ) ) ) ).

% zdiv_eq_0_iff
tff(fact_1067_zdiv__mono2,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B5)) ) ) ) ).

% zdiv_mono2
tff(fact_1068_zdiv__mono1,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),A5)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A5),B2)) ) ) ).

% zdiv_mono1
tff(fact_1069_nat__mod__eq__lemma,axiom,
    ! [X2: nat,Nb: nat,Y2: nat] :
      ( ( modulo_modulo(nat,X2,Nb) = modulo_modulo(nat,Y2,Nb) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y2),X2)
       => ? [Q3: nat] : ( X2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Y2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q3)) ) ) ) ).

% nat_mod_eq_lemma
tff(fact_1070_mod__eq__nat2E,axiom,
    ! [Ma: nat,Q2: nat,Nb: nat] :
      ( ( modulo_modulo(nat,Ma,Q2) = modulo_modulo(nat,Nb,Q2) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
       => ~ ! [S2: nat] : ( Nb != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Q2),S2)) ) ) ) ).

% mod_eq_nat2E
tff(fact_1071_mod__eq__nat1E,axiom,
    ! [Ma: nat,Q2: nat,Nb: nat] :
      ( ( modulo_modulo(nat,Ma,Q2) = modulo_modulo(nat,Nb,Q2) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
       => ~ ! [S2: nat] : ( Ma != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Q2),S2)) ) ) ) ).

% mod_eq_nat1E
tff(fact_1072_div__less__dividend,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),Ma) ) ) ).

% div_less_dividend
tff(fact_1073_div__eq__dividend__iff,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb) = Ma )
      <=> ( Nb = one_one(nat) ) ) ) ).

% div_eq_dividend_iff
tff(fact_1074_Suc__ile__eq,axiom,
    ! [Ma: nat,Nb: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extended_enat2(aa(nat,nat,suc,Ma))),Nb)
    <=> aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(Ma)),Nb) ) ).

% Suc_ile_eq
tff(fact_1075_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X2: nat] :
      ( vEBT_V5719532721284313246member(vEBT_Leaf(A2,B2),X2)
    <=> $ite(
          X2 = zero_zero(nat),
          (A2),
          $ite(X2 = one_one(nat),(B2),$false) ) ) ).

% VEBT_internal.naive_member.simps(1)
tff(fact_1076_signed__take__bit__int__less__exp,axiom,
    ! [Nb: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ).

% signed_take_bit_int_less_exp
tff(fact_1077_divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)) ) ) ) ).

% divide_le_eq
tff(fact_1078_le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))) ) ) ) ).

% le_divide_eq
tff(fact_1079_divide__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)) ) ) ) ) ).

% divide_left_mono
tff(fact_1080_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% neg_divide_le_eq
tff(fact_1081_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_le_divide_eq
tff(fact_1082_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_divide_le_eq
tff(fact_1083_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% pos_le_divide_eq
tff(fact_1084_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y2: A,X2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),Z) ) ) ) ).

% mult_imp_div_pos_le
tff(fact_1085_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y2: A,Z: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y2)),X2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% mult_imp_le_div_pos
tff(fact_1086_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)) ) ) ) ) ).

% divide_left_mono_neg
tff(fact_1087_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( ( aa(nat,A,power_power(A,A2),Nb) = aa(nat,A,power_power(A,B2),Nb) )
              <=> ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
tff(fact_1088_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat,B2: A] :
          ( ( aa(nat,A,power_power(A,A2),Nb) = aa(nat,A,power_power(A,B2),Nb) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
tff(fact_1089_power__Suc__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,A2),Nb))),aa(nat,A,power_power(A,A2),Nb)) ) ) ) ).

% power_Suc_less
tff(fact_1090_not__exp__less__eq__0__int,axiom,
    ! [Nb: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),zero_zero(int)) ).

% not_exp_less_eq_0_int
tff(fact_1091_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),aa(nat,nat,suc,Nb))),one_one(A)) ) ) ) ).

% power_Suc_less_one
tff(fact_1092_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat,N3: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),N3)),aa(nat,A,power_power(A,A2),Nb)) ) ) ) ) ).

% power_strict_decreasing
tff(fact_1093_self__le__ge2__pow,axiom,
    ! [K: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,power_power(nat,K),Ma)) ) ).

% self_le_ge2_pow
tff(fact_1094_power2__nat__le__eq__le,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,power_power(nat,Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% power2_nat_le_eq_le
tff(fact_1095_power2__nat__le__imp__le,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% power2_nat_le_imp_le
tff(fact_1096_one__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,power_power(A,one_one(A)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% one_power2
tff(fact_1097_one__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(nat,A,power_power(A,A2),Nb)) ) ) ) ).

% one_less_power
tff(fact_1098_div__nat__eqI,axiom,
    ! [Nb: nat,Q2: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q2)),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,suc,Q2)))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb) = Q2 ) ) ) ).

% div_nat_eqI
tff(fact_1099_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Q2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),Q2))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Q2)),Nb) ) ) ).

% less_eq_div_iff_mult_less_eq
tff(fact_1100_nat__1__add__1,axiom,
    aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),one_one(nat)) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) ).

% nat_1_add_1
tff(fact_1101_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list(A),Ys: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Ys))
       => ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),K)
             => ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,nth(A,Ys),I2) ) )
         => ( take(A,K,Xs) = take(A,K,Ys) ) ) ) ) ).

% nth_take_lemma
tff(fact_1102_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)))
             => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)))),one_one(A)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ) ) ).

% divmod_digit_1(1)
tff(fact_1103_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),W)),zero_zero(A))) ) ) ) ).

% le_divide_eq_numeral(1)
tff(fact_1104_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(num,A,numeral_numeral(A),W))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W))) ) ) ) ).

% divide_le_eq_numeral(1)
tff(fact_1105_zero__le__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% zero_le_power2
tff(fact_1106_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
             => ( X2 = Y2 ) ) ) ) ) ).

% power2_eq_imp_eq
tff(fact_1107_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2) ) ) ) ).

% power2_le_imp_le
tff(fact_1108_power__strict__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb)) ) ) ) ) ).

% power_strict_mono
tff(fact_1109_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2),C2))),modulo_modulo(A,A2,B2)) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
tff(fact_1110_num_Osize__gen_I1_J,axiom,
    size_num(one2) = zero_zero(nat) ).

% num.size_gen(1)
tff(fact_1111_split__div_H,axiom,
    ! [P: fun(nat,$o),Ma: nat,Nb: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb))
    <=> ( ( ( Nb = zero_zero(nat) )
          & aa(nat,$o,P,zero_zero(nat)) )
        | ? [Q4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q4)),Ma)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,suc,Q4)))
            & aa(nat,$o,P,Q4) ) ) ) ).

% split_div'
tff(fact_1112_nat__induct2,axiom,
    ! [P: fun(nat,$o),Nb: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( aa(nat,$o,P,one_one(nat))
       => ( ! [N: nat] :
              ( aa(nat,$o,P,N)
             => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) )
         => aa(nat,$o,P,Nb) ) ) ) ).

% nat_induct2
tff(fact_1113_Suc__times__mod__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Ma)
     => ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)),Ma) = one_one(nat) ) ) ).

% Suc_times_mod_eq
tff(fact_1114_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2) ) ) ) ).

% power2_less_imp_less
tff(fact_1115_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% sum_power2_ge_zero
tff(fact_1116_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),zero_zero(A))
        <=> ( ( X2 = zero_zero(A) )
            & ( Y2 = zero_zero(A) ) ) ) ) ).

% sum_power2_le_zero_iff
tff(fact_1117_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) ) ).

% zero_le_even_power'
tff(fact_1118_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,aa(real,fun(real,real),times_times(real),A2),C2))),aa(real,real,aa(real,fun(real,real),times_times(real),B2),D2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,D2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,C2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% L2_set_mult_ineq_lemma
tff(fact_1119_Euclid__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),A2: nat,B2: nat] :
      ( ! [A4: nat,B3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),P,A4),B3)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),P,B3),A4) )
     => ( ! [A4: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,A4),zero_zero(nat))
       => ( ! [A4: nat,B3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),P,A4),B3)
             => aa(nat,$o,aa(nat,fun(nat,$o),P,A4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),B3)) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,A2),B2) ) ) ) ).

% Euclid_induct
tff(fact_1120_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)),Y2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% sum_squares_bound
tff(fact_1121_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% odd_0_le_power_imp_0_le
tff(fact_1122_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
           => ( ( modulo_modulo(A,X2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)) = modulo_modulo(A,X2,Ma) )
              | ( modulo_modulo(A,X2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,X2,Ma)),Ma) ) ) ) ) ) ).

% mod_double_modulus
tff(fact_1123_incr__mult__lemma,axiom,
    ! [D2: int,P: fun(int,$o),K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X4: int] :
            ( aa(int,$o,P,X4)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D2)) )
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
         => ! [X: int] :
              ( aa(int,$o,P,X)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K),D2))) ) ) ) ) ).

% incr_mult_lemma
tff(fact_1124_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% dbl_simps(3)
tff(fact_1125_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),modulo_modulo(A,A2,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb))) ) ) ) ) ).

% even_succ_mod_exp
tff(fact_1126_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) ) ) ) ) ).

% even_succ_div_exp
tff(fact_1127_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),W))),zero_zero(A))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(num,nat,numeral_numeral(nat),W))
            & ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
              | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
                & ( A2 = zero_zero(A) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
tff(fact_1128_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( vEBT_invar_vebt(A1,A22)
     => ( ( ? [A4: $o,B3: $o] : ( A1 = vEBT_Leaf(A4,B3) )
         => ( A22 != aa(nat,nat,suc,zero_zero(nat)) ) )
       => ( ! [TreeList: list(vEBT_VEBT),N: nat,Summary: vEBT_VEBT,M3: nat,Deg: nat] :
              ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),Deg,TreeList,Summary) )
             => ( ( A22 = Deg )
               => ( ! [X: vEBT_VEBT] :
                      ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                     => vEBT_invar_vebt(X,N) )
                 => ( vEBT_invar_vebt(Summary,M3)
                   => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M3) )
                     => ( ( M3 = N )
                       => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M3) )
                         => ( ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X_1)
                           => ~ ! [X: vEBT_VEBT] :
                                  ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                 => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_1) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList: list(vEBT_VEBT),N: nat,Summary: vEBT_VEBT,M3: nat,Deg: nat] :
                ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),Deg,TreeList,Summary) )
               => ( ( A22 = Deg )
                 => ( ! [X: vEBT_VEBT] :
                        ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                       => vEBT_invar_vebt(X,N) )
                   => ( vEBT_invar_vebt(Summary,M3)
                     => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M3) )
                       => ( ( M3 = aa(nat,nat,suc,N) )
                         => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M3) )
                           => ( ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X_1)
                             => ~ ! [X: vEBT_VEBT] :
                                    ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                   => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_1) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList: list(vEBT_VEBT),N: nat,Summary: vEBT_VEBT,M3: nat,Deg: nat,Mi: nat,Ma2: nat] :
                  ( ( A1 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),Deg,TreeList,Summary) )
                 => ( ( A22 = Deg )
                   => ( ! [X: vEBT_VEBT] :
                          ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                         => vEBT_invar_vebt(X,N) )
                     => ( vEBT_invar_vebt(Summary,M3)
                       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M3) )
                         => ( ( M3 = N )
                           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M3) )
                             => ( ! [I4: nat] :
                                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M3))
                                   => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),X_12)
                                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),I4) ) )
                               => ( ( ( Mi = Ma2 )
                                   => ! [X: vEBT_VEBT] :
                                        ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                       => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_1) ) )
                                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi),Ma2)
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Deg))
                                     => ~ ( ( Mi != Ma2 )
                                         => ! [I4: nat] :
                                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M3))
                                             => ( ( ( vEBT_VEBT_high(Ma2,N) = I4 )
                                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),vEBT_VEBT_low(Ma2,N)) )
                                                & ! [X: nat] :
                                                    ( ( ( vEBT_VEBT_high(X,N) = I4 )
                                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),vEBT_VEBT_low(X,N)) )
                                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi),X)
                                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Ma2) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList: list(vEBT_VEBT),N: nat,Summary: vEBT_VEBT,M3: nat,Deg: nat,Mi: nat,Ma2: nat] :
                    ( ( A1 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),Deg,TreeList,Summary) )
                   => ( ( A22 = Deg )
                     => ( ! [X: vEBT_VEBT] :
                            ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                           => vEBT_invar_vebt(X,N) )
                       => ( vEBT_invar_vebt(Summary,M3)
                         => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M3) )
                           => ( ( M3 = aa(nat,nat,suc,N) )
                             => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M3) )
                               => ( ! [I4: nat] :
                                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M3))
                                     => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),X_12)
                                      <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),I4) ) )
                                 => ( ( ( Mi = Ma2 )
                                     => ! [X: vEBT_VEBT] :
                                          ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                         => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_1) ) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi),Ma2)
                                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Deg))
                                       => ~ ( ( Mi != Ma2 )
                                           => ! [I4: nat] :
                                                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M3))
                                               => ( ( ( vEBT_VEBT_high(Ma2,N) = I4 )
                                                   => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),vEBT_VEBT_low(Ma2,N)) )
                                                  & ! [X: nat] :
                                                      ( ( ( vEBT_VEBT_high(X,N) = I4 )
                                                        & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),vEBT_VEBT_low(X,N)) )
                                                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi),X)
                                                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Ma2) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
tff(fact_1129_invar__vebt_Osimps,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( vEBT_invar_vebt(A1,A22)
    <=> ( ( ? [A6: $o,B6: $o] : ( A1 = vEBT_Leaf(A6,B6) )
          & ( A22 = aa(nat,nat,suc,zero_zero(nat)) ) )
        | ? [TreeList2: list(vEBT_VEBT),N4: nat,Summary2: vEBT_VEBT] :
            ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),A22,TreeList2,Summary2) )
            & ! [X3: vEBT_VEBT] :
                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
               => vEBT_invar_vebt(X3,N4) )
            & vEBT_invar_vebt(Summary2,N4)
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),N4) )
            & ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X_12)
            & ! [X3: vEBT_VEBT] :
                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
               => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_12) ) )
        | ? [TreeList2: list(vEBT_VEBT),N4: nat,Summary2: vEBT_VEBT] :
            ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),A22,TreeList2,Summary2) )
            & ! [X3: vEBT_VEBT] :
                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
               => vEBT_invar_vebt(X3,N4) )
            & vEBT_invar_vebt(Summary2,aa(nat,nat,suc,N4))
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,N4)) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),aa(nat,nat,suc,N4)) )
            & ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X_12)
            & ! [X3: vEBT_VEBT] :
                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
               => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_12) ) )
        | ? [TreeList2: list(vEBT_VEBT),N4: nat,Summary2: vEBT_VEBT,Mi2: nat,Ma3: nat] :
            ( ( A1 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi2),Ma3)),A22,TreeList2,Summary2) )
            & ! [X3: vEBT_VEBT] :
                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
               => vEBT_invar_vebt(X3,N4) )
            & vEBT_invar_vebt(Summary2,N4)
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),N4) )
            & ! [I: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4))
               => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I)),X_12)
                <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),I) ) )
            & ( ( Mi2 = Ma3 )
             => ! [X3: vEBT_VEBT] :
                  ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                 => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_12) ) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi2),Ma3)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A22))
            & ( ( Mi2 != Ma3 )
             => ! [I: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4))
                 => ( ( ( vEBT_VEBT_high(Ma3,N4) = I )
                     => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I)),vEBT_VEBT_low(Ma3,N4)) )
                    & ! [X3: nat] :
                        ( ( ( vEBT_VEBT_high(X3,N4) = I )
                          & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I)),vEBT_VEBT_low(X3,N4)) )
                       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi2),X3)
                          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Ma3) ) ) ) ) ) )
        | ? [TreeList2: list(vEBT_VEBT),N4: nat,Summary2: vEBT_VEBT,Mi2: nat,Ma3: nat] :
            ( ( A1 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi2),Ma3)),A22,TreeList2,Summary2) )
            & ! [X3: vEBT_VEBT] :
                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
               => vEBT_invar_vebt(X3,N4) )
            & vEBT_invar_vebt(Summary2,aa(nat,nat,suc,N4))
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,N4)) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),aa(nat,nat,suc,N4)) )
            & ! [I: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,N4)))
               => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I)),X_12)
                <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),I) ) )
            & ( ( Mi2 = Ma3 )
             => ! [X3: vEBT_VEBT] :
                  ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                 => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_12) ) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi2),Ma3)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A22))
            & ( ( Mi2 != Ma3 )
             => ! [I: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,N4)))
                 => ( ( ( vEBT_VEBT_high(Ma3,N4) = I )
                     => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I)),vEBT_VEBT_low(Ma3,N4)) )
                    & ! [X3: nat] :
                        ( ( ( vEBT_VEBT_high(X3,N4) = I )
                          & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I)),vEBT_VEBT_low(X3,N4)) )
                       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi2),X3)
                          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Ma3) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
tff(fact_1130_concat__bit__Suc,axiom,
    ! [Nb: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(aa(nat,nat,suc,Nb),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,bit_concat_bit(Nb,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),L))) ) ).

% concat_bit_Suc
tff(fact_1131_option_Oinject,axiom,
    ! [A: $tType,X22: A,Y22: A] :
      ( ( aa(A,option(A),some(A),X22) = aa(A,option(A),some(A),Y22) )
    <=> ( X22 = Y22 ) ) ).

% option.inject
tff(fact_1132_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),A2)
        <=> ( A2 = zero_zero(A) ) ) ) ).

% dvd_0_left_iff
tff(fact_1133_dvd__0__right,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),zero_zero(A)) ) ).

% dvd_0_right
tff(fact_1134_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_triv_right_iff
tff(fact_1135_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_triv_left_iff
tff(fact_1136_div__dvd__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ) ).

% div_dvd_div
tff(fact_1137_nat__dvd__1__iff__1,axiom,
    ! [Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),one_one(nat))
    <=> ( Ma = one_one(nat) ) ) ).

% nat_dvd_1_iff_1
tff(fact_1138_not__None__eq,axiom,
    ! [A: $tType,X2: option(A)] :
      ( ( X2 != none(A) )
    <=> ? [Y: A] : ( X2 = aa(A,option(A),some(A),Y) ) ) ).

% not_None_eq
tff(fact_1139_not__Some__eq,axiom,
    ! [A: $tType,X2: option(A)] :
      ( ! [Y: A] : ( X2 != aa(A,option(A),some(A),Y) )
    <=> ( X2 = none(A) ) ) ).

% not_Some_eq
tff(fact_1140_concat__bit__0,axiom,
    ! [K: int,L: int] : ( aa(int,int,bit_concat_bit(zero_zero(nat),K),L) = L ) ).

% concat_bit_0
tff(fact_1141_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,zero_zero(A)) = zero_zero(A) ) ) ).

% dbl_simps(2)
tff(fact_1142_mi__ma__2__deg,axiom,
    ! [Mi3: nat,Ma: nat,Degb: nat,TreeListb: list(vEBT_VEBT),Summaryb: vEBT_VEBT,Nb: nat] :
      ( vEBT_invar_vebt(vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi3),Ma)),Degb,TreeListb,Summaryb),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi3),Ma)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Degb)) ) ) ).

% mi_ma_2_deg
tff(fact_1143_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% dvd_times_right_cancel_iff
tff(fact_1144_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% dvd_times_left_cancel_iff
tff(fact_1145_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( C2 = zero_zero(A) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_mult_cancel_right
tff(fact_1146_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( C2 = zero_zero(A) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_mult_cancel_left
tff(fact_1147_unit__prod,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A)) ) ) ) ).

% unit_prod
tff(fact_1148_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_times_triv_left_iff
tff(fact_1149_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_times_triv_right_iff
tff(fact_1150_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)) = B2 ) ) ) ).

% dvd_mult_div_cancel
tff(fact_1151_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),A2) = B2 ) ) ) ).

% dvd_div_mult_self
tff(fact_1152_unit__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),one_one(A)) ) ) ) ).

% unit_div
tff(fact_1153_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)),one_one(A)) ) ) ).

% unit_div_1_unit
tff(fact_1154_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)) = A2 ) ) ) ).

% unit_div_1_div_1
tff(fact_1155_div__add,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ) ).

% div_add
tff(fact_1156_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( modulo_modulo(A,B2,A2) = zero_zero(A) ) ) ) ).

% dvd_imp_mod_0
tff(fact_1157_dvd__1__left,axiom,
    ! [K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,suc,zero_zero(nat))),K) ).

% dvd_1_left
tff(fact_1158_dvd__1__iff__1,axiom,
    ! [Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),aa(nat,nat,suc,zero_zero(nat)))
    <=> ( Ma = aa(nat,nat,suc,zero_zero(nat)) ) ) ).

% dvd_1_iff_1
tff(fact_1159_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))
    <=> ( ( K = zero_zero(nat) )
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),Nb) ) ) ).

% nat_mult_dvd_cancel_disj
tff(fact_1160_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),one_one(int)))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z) ) ).

% zle_add1_eq_le
tff(fact_1161_concat__bit__nonnegative__iff,axiom,
    ! [Nb: nat,K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_concat_bit(Nb,K),L))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ).

% concat_bit_nonnegative_iff
tff(fact_1162_concat__bit__negative__iff,axiom,
    ! [Nb: nat,K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_concat_bit(Nb,K),L)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ).

% concat_bit_negative_iff
tff(fact_1163_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,K)) ) ) ).

% dbl_simps(5)
tff(fact_1164_both__member__options__from__complete__tree__to__child,axiom,
    ! [Degb: nat,Mi3: nat,Ma: nat,TreeListb: list(vEBT_VEBT),Summaryb: vEBT_VEBT,X2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Degb)
     => ( aa(nat,$o,vEBT_V8194947554948674370ptions(vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi3),Ma)),Degb,TreeListb,Summaryb)),X2)
       => ( aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),vEBT_VEBT_high(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),vEBT_VEBT_low(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))
          | ( X2 = Mi3 )
          | ( X2 = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
tff(fact_1165_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),A2) = B2 ) ) ) ).

% unit_div_mult_self
tff(fact_1166_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) ) ) ) ).

% unit_mult_div_div
tff(fact_1167_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Nb: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% pow_divides_pow_iff
tff(fact_1168_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X2: nat,Degb: nat,TreeListb: list(vEBT_VEBT),Mi3: nat,Ma: nat,Summaryb: vEBT_VEBT] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),vEBT_VEBT_high(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Degb)
       => ( aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),vEBT_VEBT_high(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),vEBT_VEBT_low(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))
         => aa(nat,$o,vEBT_V8194947554948674370ptions(vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi3),Ma)),Degb,TreeListb,Summaryb)),X2) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
tff(fact_1169_even__mult__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_mult_iff
tff(fact_1170_even__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_add
tff(fact_1171_odd__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> ~ ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% odd_add
tff(fact_1172_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_mod_2_iff
tff(fact_1173_even__Suc__Suc__iff,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,Nb)))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) ) ).

% even_Suc_Suc_iff
tff(fact_1174_even__Suc,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,Nb))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) ) ).

% even_Suc
tff(fact_1175_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_plus_one_iff
tff(fact_1176_even__Suc__div__two,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,Nb)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% even_Suc_div_two
tff(fact_1177_odd__Suc__div__two,axiom,
    ! [Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,Nb)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% odd_Suc_div_two
tff(fact_1178_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_2
tff(fact_1179_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_two
tff(fact_1180_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ) ).

% odd_succ_div_two
tff(fact_1181_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),W)))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_le_power_eq_numeral
tff(fact_1182_even__power,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,power_power(A,A2),Nb))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ) ) ).

% even_power
tff(fact_1183_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),W))),zero_zero(A))
        <=> ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% power_less_zero_eq_numeral
tff(fact_1184_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,A2),Nb)),zero_zero(A))
        <=> ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% power_less_zero_eq
tff(fact_1185_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),one_one(A)) = A2 ) ) ) ).

% odd_two_times_div_two_succ
tff(fact_1186_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),W)))
        <=> ( ( aa(num,nat,numeral_numeral(nat),W) = zero_zero(nat) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
              & ( A2 != zero_zero(A) ) )
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_less_power_eq_numeral
tff(fact_1187_verit__la__generic,axiom,
    ! [A2: int,X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),X2)
      | ( A2 = X2 )
      | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X2),A2) ) ).

% verit_la_generic
tff(fact_1188_set__bit__greater__eq,axiom,
    ! [K: int,Nb: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Nb),K)) ).

% set_bit_greater_eq
tff(fact_1189_complete__real,axiom,
    ! [S3: set(real)] :
      ( ? [X: real] : aa(set(real),$o,member(real,X),S3)
     => ( ? [Z3: real] :
          ! [X4: real] :
            ( aa(set(real),$o,member(real,X4),S3)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),Z3) )
       => ? [Y4: real] :
            ( ! [X: real] :
                ( aa(set(real),$o,member(real,X),S3)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y4) )
            & ! [Z3: real] :
                ( ! [X4: real] :
                    ( aa(set(real),$o,member(real,X4),S3)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),Z3) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),Z3) ) ) ) ) ).

% complete_real
tff(fact_1190_Nat_Oex__has__greatest__nat,axiom,
    ! [P: fun(nat,$o),K: nat,B2: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [Y4: nat] :
            ( aa(nat,$o,P,Y4)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y4),B2) )
       => ? [X4: nat] :
            ( aa(nat,$o,P,X4)
            & ! [Y3: nat] :
                ( aa(nat,$o,P,Y3)
               => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y3),X4) ) ) ) ) ).

% Nat.ex_has_greatest_nat
tff(fact_1191_nat__le__linear,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
      | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma) ) ).

% nat_le_linear
tff(fact_1192_le__antisym,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
       => ( Ma = Nb ) ) ) ).

% le_antisym
tff(fact_1193_eq__imp__le,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( Ma = Nb )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% eq_imp_le
tff(fact_1194_le__trans,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),K) ) ) ).

% le_trans
tff(fact_1195_le__refl,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Nb) ).

% le_refl
tff(fact_1196_dvd__refl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),A2) ) ).

% dvd_refl
tff(fact_1197_dvd__trans,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_trans
tff(fact_1198_dvd__antisym,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Nb),Ma)
       => ( Ma = Nb ) ) ) ).

% dvd_antisym
tff(fact_1199_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ap(A,fun(A,$o),A2))),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ap(A,fun(A,$o),B2)))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
            & ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ) ).

% strict_subset_divisors_dvd
tff(fact_1200_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ap(A,fun(A,$o),A2))),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ap(A,fun(A,$o),B2)))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% subset_divisors_dvd
tff(fact_1201_dvd__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),A2)
         => ( A2 = zero_zero(A) ) ) ) ).

% dvd_0_left
tff(fact_1202_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
        <=> ( ( A2 = zero_zero(A) )
           => ( B2 = zero_zero(A) ) ) ) ) ).

% dvd_field_iff
tff(fact_1203_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)) ) ).

% dvd_triv_right
tff(fact_1204_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ).

% dvd_mult_right
tff(fact_1205_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ).

% mult_dvd_mono
tff(fact_1206_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ).

% dvd_triv_left
tff(fact_1207_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ).

% dvd_mult_left
tff(fact_1208_dvd__mult2,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% dvd_mult2
tff(fact_1209_dvd__mult,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% dvd_mult
tff(fact_1210_dvd__def,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
        <=> ? [K3: A] : ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K3) ) ) ) ).

% dvd_def
tff(fact_1211_dvdI,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [A2: A,B2: A,K: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% dvdI
tff(fact_1212_dvdE,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ~ ! [K2: A] : ( A2 != aa(A,A,aa(A,fun(A,A),times_times(A),B2),K2) ) ) ) ).

% dvdE
tff(fact_1213_division__decomp,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ? [B7: A,C5: A] :
              ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B7),C5) )
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B7),B2)
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C5),C2) ) ) ) ).

% division_decomp
tff(fact_1214_dvd__productE,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [P2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
         => ~ ! [X4: A,Y4: A] :
                ( ( P2 = aa(A,A,aa(A,fun(A,A),times_times(A),X4),Y4) )
               => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X4),A2)
                 => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Y4),B2) ) ) ) ) ).

% dvd_productE
tff(fact_1215_option_Odistinct_I1_J,axiom,
    ! [A: $tType,X22: A] : ( none(A) != aa(A,option(A),some(A),X22) ) ).

% option.distinct(1)
tff(fact_1216_option_OdiscI,axiom,
    ! [A: $tType,Option: option(A),X22: A] :
      ( ( Option = aa(A,option(A),some(A),X22) )
     => ( Option != none(A) ) ) ).

% option.discI
tff(fact_1217_option_Oexhaust,axiom,
    ! [A: $tType,Y2: option(A)] :
      ( ( Y2 != none(A) )
     => ~ ! [X23: A] : ( Y2 != aa(A,option(A),some(A),X23) ) ) ).

% option.exhaust
tff(fact_1218_split__option__ex,axiom,
    ! [A: $tType,P: fun(option(A),$o)] :
      ( ? [X_12: option(A)] : aa(option(A),$o,P,X_12)
    <=> ( aa(option(A),$o,P,none(A))
        | ? [X3: A] : aa(option(A),$o,P,aa(A,option(A),some(A),X3)) ) ) ).

% split_option_ex
tff(fact_1219_split__option__all,axiom,
    ! [A: $tType,P: fun(option(A),$o)] :
      ( ! [X_12: option(A)] : aa(option(A),$o,P,X_12)
    <=> ( aa(option(A),$o,P,none(A))
        & ! [X3: A] : aa(option(A),$o,P,aa(A,option(A),some(A),X3)) ) ) ).

% split_option_all
tff(fact_1220_combine__options__cases,axiom,
    ! [A: $tType,B: $tType,X2: option(A),P: fun(option(A),fun(option(B),$o)),Y2: option(B)] :
      ( ( ( X2 = none(A) )
       => aa(option(B),$o,aa(option(A),fun(option(B),$o),P,X2),Y2) )
     => ( ( ( Y2 = none(B) )
         => aa(option(B),$o,aa(option(A),fun(option(B),$o),P,X2),Y2) )
       => ( ! [A4: A,B3: B] :
              ( ( X2 = aa(A,option(A),some(A),A4) )
             => ( ( Y2 = aa(B,option(B),some(B),B3) )
               => aa(option(B),$o,aa(option(A),fun(option(B),$o),P,X2),Y2) ) )
         => aa(option(B),$o,aa(option(A),fun(option(B),$o),P,X2),Y2) ) ) ) ).

% combine_options_cases
tff(fact_1221_one__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),one_one(A)),A2) ) ).

% one_dvd
tff(fact_1222_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% unit_imp_dvd
tff(fact_1223_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ) ).

% dvd_unit_imp_unit
tff(fact_1224_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_add_right_iff
tff(fact_1225_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_add_left_iff
tff(fact_1226_dvd__add,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ) ).

% dvd_add
tff(fact_1227_div__div__div__same,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [D2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),D2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),D2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ) ).

% div_div_div_same
tff(fact_1228_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
tff(fact_1229_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
            <=> ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
tff(fact_1230_dvd__power__same,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X2: A,Y2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),Y2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,X2),Nb)),aa(nat,A,power_power(A,Y2),Nb)) ) ) ).

% dvd_power_same
tff(fact_1231_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Ma: nat,Nb: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,A2),Ma)),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% le_imp_power_dvd
tff(fact_1232_power__le__dvd,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Nb: nat,B2: A,Ma: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,A2),Nb)),B2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,A2),Ma)),B2) ) ) ) ).

% power_le_dvd
tff(fact_1233_dvd__power__le,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X2: A,Y2: A,Nb: nat,Ma: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),Y2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,X2),Nb)),aa(nat,A,power_power(A,Y2),Ma)) ) ) ) ).

% dvd_power_le
tff(fact_1234_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
     => ( A2 = zero_zero(nat) ) ) ).

% gcd_nat.extremum_uniqueI
tff(fact_1235_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( A2 != zero_zero(nat) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),zero_zero(nat))
        & ( A2 != zero_zero(nat) ) ) ) ).

% gcd_nat.not_eq_extremum
tff(fact_1236_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
    <=> ( A2 = zero_zero(nat) ) ) ).

% gcd_nat.extremum_unique
tff(fact_1237_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
        & ( zero_zero(nat) != A2 ) ) ).

% gcd_nat.extremum_strict
tff(fact_1238_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),zero_zero(nat)) ).

% gcd_nat.extremum
tff(fact_1239_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),modulo_modulo(A,A2,B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2) ) ) ) ).

% dvd_mod_iff
tff(fact_1240_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),modulo_modulo(A,A2,B2))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2) ) ) ) ).

% dvd_mod_imp_dvd
tff(fact_1241_dvd__mod,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [K: A,Ma: A,Nb: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),K),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),K),Nb)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),K),modulo_modulo(A,Ma,Nb)) ) ) ) ).

% dvd_mod
tff(fact_1242_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( modulo_modulo(A,modulo_modulo(A,A2,B2),C2) = modulo_modulo(A,A2,C2) ) ) ) ).

% mod_mod_cancel
tff(fact_1243_zdvd__antisym__nonneg,axiom,
    ! [Ma: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Ma)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Nb)
       => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Ma),Nb)
         => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Nb),Ma)
           => ( Ma = Nb ) ) ) ) ) ).

% zdvd_antisym_nonneg
tff(fact_1244_pinf_I9_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),S))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),S)) ) ) ) ).

% pinf(9)
tff(fact_1245_pinf_I10_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),S))
          <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),S)) ) ) ) ).

% pinf(10)
tff(fact_1246_minf_I9_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),S))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),S)) ) ) ) ).

% minf(9)
tff(fact_1247_minf_I10_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),S))
          <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),S)) ) ) ) ).

% minf(10)
tff(fact_1248_infinity__ne__i1,axiom,
    extend4730790105801354508finity(extended_enat) != one_one(extended_enat) ).

% infinity_ne_i1
tff(fact_1249_zdvd__mono,axiom,
    ! [K: int,Ma: int,T2: int] :
      ( ( K != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Ma),T2)
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),Ma)),aa(int,int,aa(int,fun(int,int),times_times(int),K),T2)) ) ) ).

% zdvd_mono
tff(fact_1250_zero__one__enat__neq_I1_J,axiom,
    zero_zero(extended_enat) != one_one(extended_enat) ).

% zero_one_enat_neq(1)
tff(fact_1251_concat__bit__assoc,axiom,
    ! [Nb: nat,K: int,Ma: nat,L: int,R: int] : ( aa(int,int,bit_concat_bit(Nb,K),aa(int,int,bit_concat_bit(Ma,L),R)) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb),aa(int,int,bit_concat_bit(Nb,K),L)),R) ) ).

% concat_bit_assoc
tff(fact_1252_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi3: nat,Ma: nat,Va2: list(vEBT_VEBT),Vb: vEBT_VEBT,X2: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi3),Ma)),zero_zero(nat),Va2,Vb),X2)
    <=> ( ( X2 = Mi3 )
        | ( X2 = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
tff(fact_1253_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( dvd(A)
        & semiring_0(A) )
     => ! [P: fun(A,$o),L: A] :
          ( ? [X3: A] : aa(A,$o,P,aa(A,A,aa(A,fun(A,A),times_times(A),L),X3))
        <=> ? [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),L),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),zero_zero(A)))
              & aa(A,$o,P,X3) ) ) ) ).

% unity_coeff_ex
tff(fact_1254_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),one_one(A)) ) ).

% not_is_unit_0
tff(fact_1255_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% dvd_div_eq_0_iff
tff(fact_1256_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A)) ) ) ) ).

% is_unit_mult_iff
tff(fact_1257_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_mult_unit_iff
tff(fact_1258_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% mult_unit_dvd_iff
tff(fact_1259_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_mult_unit_iff'
tff(fact_1260_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% mult_unit_dvd_iff'
tff(fact_1261_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
tff(fact_1262_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
tff(fact_1263_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),C2)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),D2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ).

% div_mult_div_if_dvd
tff(fact_1264_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ).

% dvd_mult_imp_div
tff(fact_1265_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ).

% dvd_div_mult2_eq
tff(fact_1266_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ) ).

% div_div_eq_right
tff(fact_1267_div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) ) ) ) ).

% div_mult_swap
tff(fact_1268_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),C2) ) ) ) ).

% dvd_div_mult
tff(fact_1269_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
tff(fact_1270_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% div_unit_dvd_iff
tff(fact_1271_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_div_unit_iff
tff(fact_1272_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% div_plus_div_distrib_dvd_right
tff(fact_1273_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% div_plus_div_distrib_dvd_left
tff(fact_1274_div__power,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),Nb) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb)) ) ) ) ).

% div_power
tff(fact_1275_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = zero_zero(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% mod_eq_0_iff_dvd
tff(fact_1276_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
        <=> ( modulo_modulo(A,B2,A2) = zero_zero(A) ) ) ) ).

% dvd_eq_mod_eq_0
tff(fact_1277_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = zero_zero(A) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% mod_0_imp_dvd
tff(fact_1278_nat__dvd__not__less,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
       => ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Nb),Ma) ) ) ).

% nat_dvd_not_less
tff(fact_1279_dvd__pos__nat,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),Nb)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma) ) ) ).

% dvd_pos_nat
tff(fact_1280_dvd__imp__le,axiom,
    ! [K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb) ) ) ).

% dvd_imp_le
tff(fact_1281_zdvd__not__zless,axiom,
    ! [Ma: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Ma)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Ma),Nb)
       => ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Nb),Ma) ) ) ).

% zdvd_not_zless
tff(fact_1282_zdvd__imp__le,axiom,
    ! [Z: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Z),Nb)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Nb)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),Nb) ) ) ).

% zdvd_imp_le
tff(fact_1283_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,K,L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( ( L = zero_zero(int) )
          & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) )
        | aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L) ) ) ).

% mod_int_pos_iff
tff(fact_1284_zdvd__mult__cancel,axiom,
    ! [K: int,Ma: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),Ma)),aa(int,int,aa(int,fun(int,int),times_times(int),K),Nb))
     => ( ( K != zero_zero(int) )
       => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Ma),Nb) ) ) ).

% zdvd_mult_cancel
tff(fact_1285_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D3: nat,X4: nat,Y4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D3),A2)
      & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D3),B2)
      & ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),D3) )
        | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)),D3) ) ) ) ).

% bezout_add_nat
tff(fact_1286_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X2: nat,Y2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),A2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),B2)
       => ( ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y2)),D2) )
            | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y2)),D2) ) )
         => ? [X4: nat,Y4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),A2)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))
              & ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),Y4)),D2) )
                | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),X4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)),D2) ) ) ) ) ) ) ).

% bezout_lemma_nat
tff(fact_1287_dbl__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X2: A] : ( neg_numeral_dbl(A,X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),X2) ) ) ).

% dbl_def
tff(fact_1288_zdvd__reduce,axiom,
    ! [K: int,Nb: int,Ma: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),aa(int,int,aa(int,fun(int,int),plus_plus(int),Nb),aa(int,int,aa(int,fun(int,int),times_times(int),K),Ma)))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),Nb) ) ).

% zdvd_reduce
tff(fact_1289_zdvd__period,axiom,
    ! [A2: int,D2: int,X2: int,T2: int,C2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),D2)
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),T2))
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),aa(int,int,aa(int,fun(int,int),times_times(int),C2),D2))),T2)) ) ) ).

% zdvd_period
tff(fact_1290_real__arch__pow,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => ? [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(nat,real,power_power(real,X2),N)) ) ).

% real_arch_pow
tff(fact_1291_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),Z)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ).

% int_one_le_iff_zero_less
tff(fact_1292_odd__nonzero,axiom,
    ! [Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)),Z) != zero_zero(int) ) ).

% odd_nonzero
tff(fact_1293_int__gr__induct,axiom,
    ! [K: int,I3: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I3)
     => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int)))
       => ( ! [I2: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I2)
             => ( aa(int,$o,P,I2)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int))) ) )
         => aa(int,$o,P,I3) ) ) ) ).

% int_gr_induct
tff(fact_1294_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),one_one(int)))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
        | ( W = Z ) ) ) ).

% zless_add1_eq
tff(fact_1295_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),one_one(int))),Z)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ).

% add1_zle_eq
tff(fact_1296_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),one_one(int))),Z) ) ).

% zless_imp_add1_zle
tff(fact_1297_one__enat__def,axiom,
    one_one(extended_enat) = extended_enat2(one_one(nat)) ).

% one_enat_def
tff(fact_1298_enat__1__iff_I1_J,axiom,
    ! [X2: nat] :
      ( ( extended_enat2(X2) = one_one(extended_enat) )
    <=> ( X2 = one_one(nat) ) ) ).

% enat_1_iff(1)
tff(fact_1299_enat__1__iff_I2_J,axiom,
    ! [X2: nat] :
      ( ( one_one(extended_enat) = extended_enat2(X2) )
    <=> ( X2 = one_one(nat) ) ) ).

% enat_1_iff(2)
tff(fact_1300_even__even__mod__4__iff,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2))))) ) ).

% even_even_mod_4_iff
tff(fact_1301_unit__dvdE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ~ ( ( A2 != zero_zero(A) )
             => ! [C3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),times_times(A),A2),C3) ) ) ) ) ).

% unit_dvdE
tff(fact_1302_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( C2 != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),D2)
               => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),D2),C2) )
                <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),D2) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
tff(fact_1303_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ) ).

% dvd_div_iff_mult
tff(fact_1304_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2)
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ) ).

% div_dvd_iff_mult
tff(fact_1305_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) ) ) ) ) ) ).

% dvd_div_eq_mult
tff(fact_1306_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% unit_div_eq_0_iff
tff(fact_1307_even__numeral,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Nb: num] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb))) ) ).

% even_numeral
tff(fact_1308_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [X2: A,Ma: nat,Nb: nat] :
          ( ( X2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,X2),Ma)),aa(nat,A,power_power(A,X2),Nb))
          <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),one_one(A))
              | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ) ) ).

% dvd_power_iff
tff(fact_1309_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ) ).

% is_unit_div_mult2_eq
tff(fact_1310_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) ) ) ) ).

% unit_div_mult_swap
tff(fact_1311_unit__div__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% unit_div_commute
tff(fact_1312_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ) ).

% div_mult_unit2
tff(fact_1313_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = C2 ) ) ) ) ).

% unit_eq_div2
tff(fact_1314_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = C2 )
          <=> ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% unit_eq_div1
tff(fact_1315_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( modulo_modulo(A,A2,B2) = zero_zero(A) ) ) ) ).

% unit_imp_mod_eq_0
tff(fact_1316_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,A2),Nb)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
            | ( Nb = zero_zero(nat) ) ) ) ) ).

% is_unit_power_iff
tff(fact_1317_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),Nb) ) ) ).

% nat_mult_dvd_cancel1
tff(fact_1318_dvd__mult__cancel,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),Nb) ) ) ).

% dvd_mult_cancel
tff(fact_1319_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => ? [D3: nat,X4: nat,Y4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D3),A2)
          & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D3),B2)
          & ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),D3) ) ) ) ).

% bezout_add_strong_nat
tff(fact_1320_mod__greater__zero__iff__not__dvd,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),modulo_modulo(nat,Ma,Nb))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Nb),Ma) ) ).

% mod_greater_zero_iff_not_dvd
tff(fact_1321_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o),P3: fun(A,$o),Q: fun(A,$o),Q6: fun(A,$o)] :
          ( ? [Z3: A] :
            ! [X4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z3),X4)
             => ( aa(A,$o,P,X4)
              <=> aa(A,$o,P3,X4) ) )
         => ( ? [Z3: A] :
              ! [X4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z3),X4)
               => ( aa(A,$o,Q,X4)
                <=> aa(A,$o,Q6,X4) ) )
           => ? [Z2: A] :
              ! [X: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
               => ( ( aa(A,$o,P,X)
                    & aa(A,$o,Q,X) )
                <=> ( aa(A,$o,P3,X)
                    & aa(A,$o,Q6,X) ) ) ) ) ) ) ).

% pinf(1)
tff(fact_1322_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o),P3: fun(A,$o),Q: fun(A,$o),Q6: fun(A,$o)] :
          ( ? [Z3: A] :
            ! [X4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z3),X4)
             => ( aa(A,$o,P,X4)
              <=> aa(A,$o,P3,X4) ) )
         => ( ? [Z3: A] :
              ! [X4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z3),X4)
               => ( aa(A,$o,Q,X4)
                <=> aa(A,$o,Q6,X4) ) )
           => ? [Z2: A] :
              ! [X: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
               => ( ( aa(A,$o,P,X)
                    | aa(A,$o,Q,X) )
                <=> ( aa(A,$o,P3,X)
                    | aa(A,$o,Q6,X) ) ) ) ) ) ) ).

% pinf(2)
tff(fact_1323_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => ( X != T2 ) ) ) ).

% pinf(3)
tff(fact_1324_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => ( X != T2 ) ) ) ).

% pinf(4)
tff(fact_1325_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),T2) ) ) ).

% pinf(5)
tff(fact_1326_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),T2),X) ) ) ).

% pinf(7)
tff(fact_1327_pinf_I11_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ord(A)
     => ! [F4: B] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => ( F4 = F4 ) ) ) ).

% pinf(11)
tff(fact_1328_minf_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o),P3: fun(A,$o),Q: fun(A,$o),Q6: fun(A,$o)] :
          ( ? [Z3: A] :
            ! [X4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z3)
             => ( aa(A,$o,P,X4)
              <=> aa(A,$o,P3,X4) ) )
         => ( ? [Z3: A] :
              ! [X4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z3)
               => ( aa(A,$o,Q,X4)
                <=> aa(A,$o,Q6,X4) ) )
           => ? [Z2: A] :
              ! [X: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
               => ( ( aa(A,$o,P,X)
                    & aa(A,$o,Q,X) )
                <=> ( aa(A,$o,P3,X)
                    & aa(A,$o,Q6,X) ) ) ) ) ) ) ).

% minf(1)
tff(fact_1329_minf_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o),P3: fun(A,$o),Q: fun(A,$o),Q6: fun(A,$o)] :
          ( ? [Z3: A] :
            ! [X4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z3)
             => ( aa(A,$o,P,X4)
              <=> aa(A,$o,P3,X4) ) )
         => ( ? [Z3: A] :
              ! [X4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z3)
               => ( aa(A,$o,Q,X4)
                <=> aa(A,$o,Q6,X4) ) )
           => ? [Z2: A] :
              ! [X: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
               => ( ( aa(A,$o,P,X)
                    | aa(A,$o,Q,X) )
                <=> ( aa(A,$o,P3,X)
                    | aa(A,$o,Q6,X) ) ) ) ) ) ) ).

% minf(2)
tff(fact_1330_minf_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => ( X != T2 ) ) ) ).

% minf(3)
tff(fact_1331_minf_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => ( X != T2 ) ) ) ).

% minf(4)
tff(fact_1332_minf_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),T2) ) ) ).

% minf(5)
tff(fact_1333_minf_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),T2),X) ) ) ).

% minf(7)
tff(fact_1334_minf_I11_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ord(A)
     => ! [F4: B] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => ( F4 = F4 ) ) ) ).

% minf(11)
tff(fact_1335_power__dvd__imp__le,axiom,
    ! [I3: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,power_power(nat,I3),Ma)),aa(nat,nat,power_power(nat,I3),Nb))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),I3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ).

% power_dvd_imp_le
tff(fact_1336_real__arch__pow__inv,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => ? [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,power_power(real,X2),N)),Y2) ) ) ).

% real_arch_pow_inv
tff(fact_1337_conj__le__cong,axiom,
    ! [X2: int,X6: int,P: $o,P3: $o] :
      ( ( X2 = X6 )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X6)
         => ( (P)
          <=> (P3) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
            & (P) )
        <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X6)
            & (P3) ) ) ) ) ).

% conj_le_cong
tff(fact_1338_imp__le__cong,axiom,
    ! [X2: int,X6: int,P: $o,P3: $o] :
      ( ( X2 = X6 )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X6)
         => ( (P)
          <=> (P3) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
           => (P) )
        <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X6)
           => (P3) ) ) ) ) ).

% imp_le_cong
tff(fact_1339_pos__zmult__eq__1__iff,axiom,
    ! [Ma: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Ma)
     => ( ( aa(int,int,aa(int,fun(int,int),times_times(int),Ma),Nb) = one_one(int) )
      <=> ( ( Ma = one_one(int) )
          & ( Nb = one_one(int) ) ) ) ) ).

% pos_zmult_eq_1_iff
tff(fact_1340_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)),Z)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),zero_zero(int)) ) ).

% odd_less_0_iff
tff(fact_1341_le__imp__0__less,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)) ) ).

% le_imp_0_less
tff(fact_1342_int__div__less__self,axiom,
    ! [X2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),X2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),K)),X2) ) ) ).

% int_div_less_self
tff(fact_1343_option_Osize_I4_J,axiom,
    ! [A: $tType,X22: A] : ( aa(option(A),nat,size_size(option(A)),aa(A,option(A),some(A),X22)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size(4)
tff(fact_1344_even__zero,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),zero_zero(A)) ) ).

% even_zero
tff(fact_1345_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_right
tff(fact_1346_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_left
tff(fact_1347_is__unitE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ~ ( ( A2 != zero_zero(A) )
             => ! [B3: A] :
                  ( ( B3 != zero_zero(A) )
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B3),one_one(A))
                   => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) = B3 )
                     => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B3) = A2 )
                       => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B3) = one_one(A) )
                         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2) != aa(A,A,aa(A,fun(A,A),times_times(A),C2),B3) ) ) ) ) ) ) ) ) ) ).

% is_unitE
tff(fact_1348_evenE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ~ ! [B3: A] : ( A2 != aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3) ) ) ) ).

% evenE
tff(fact_1349_odd__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),one_one(A)) ) ).

% odd_one
tff(fact_1350_odd__even__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% odd_even_add
tff(fact_1351_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) )
            & ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ) ).

% bit_eq_rec
tff(fact_1352_dvd__power,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Nb: nat,X2: A] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
            | ( X2 = one_one(A) ) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),aa(nat,A,power_power(A,X2),Nb)) ) ) ).

% dvd_power
tff(fact_1353_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Ma: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,Ma),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_signed_take_bit_iff
tff(fact_1354_dvd__power__iff__le,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,power_power(nat,K),Ma)),aa(nat,nat,power_power(nat,K),Nb))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ).

% dvd_power_iff_le
tff(fact_1355_dvd__mult__cancel1,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)),Ma)
      <=> ( Nb = one_one(nat) ) ) ) ).

% dvd_mult_cancel1
tff(fact_1356_dvd__mult__cancel2,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Ma)),Ma)
      <=> ( Nb = one_one(nat) ) ) ) ).

% dvd_mult_cancel2
tff(fact_1357_two__realpow__ge__one,axiom,
    ! [Nb: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),Nb)) ).

% two_realpow_ge_one
tff(fact_1358_verit__le__mono__div__int,axiom,
    ! [A3: int,B4: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A3),B4)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Nb)
       => aa(int,$o,
            aa(int,fun(int,$o),ord_less_eq(int),
              aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),Nb)),$ite(modulo_modulo(int,B4,Nb) = zero_zero(int),one_one(int),zero_zero(int)))),
            aa(int,int,aa(int,fun(int,int),divide_divide(int),B4),Nb)) ) ) ).

% verit_le_mono_div_int
tff(fact_1359_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = A2 ) ) ) ).

% even_two_times_div_two
tff(fact_1360_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ) ).

% even_iff_mod_2_eq_zero
tff(fact_1361_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ).

% odd_iff_mod_2_eq_one
tff(fact_1362_power__mono__odd,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat,A2: A,B2: A] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb)) ) ) ) ).

% power_mono_odd
tff(fact_1363_odd__pos,axiom,
    ! [Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ).

% odd_pos
tff(fact_1364_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),Ma),A2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            | ( Ma = zero_zero(nat) ) ) ) ) ).

% even_unset_bit_iff
tff(fact_1365_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),Ma),A2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            & ( Ma != zero_zero(nat) ) ) ) ) ).

% even_set_bit_iff
tff(fact_1366_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se8732182000553998342ip_bit(A,Ma,A2))
        <=> ~ ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            <=> ( Ma = zero_zero(nat) ) ) ) ) ).

% even_flip_bit_iff
tff(fact_1367_oddE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ~ ! [B3: A] : ( A2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B3)),one_one(A)) ) ) ) ).

% oddE
tff(fact_1368_parity__cases,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
           => ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != zero_zero(A) ) )
         => ~ ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
             => ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != one_one(A) ) ) ) ) ).

% parity_cases
tff(fact_1369_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2),zero_zero(A),one_one(A)) ) ) ).

% mod2_eq_if
tff(fact_1370_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% zero_le_even_power
tff(fact_1371_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat,A2: A] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A2),Nb))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ).

% zero_le_odd_power
tff(fact_1372_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,A2),Nb))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_le_power_eq
tff(fact_1373_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi3: nat,Ma: nat,V: nat,TreeListb: list(vEBT_VEBT),Vc: vEBT_VEBT,X2: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi3),Ma)),aa(nat,nat,suc,V),TreeListb,Vc),X2)
    <=> ( ( X2 = Mi3 )
        | ( X2 = Ma )
        | $let(
            pos: nat,
            pos := vEBT_VEBT_high(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),pos),vEBT_VEBT_low(X2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ).

% VEBT_internal.membermima.simps(4)
tff(fact_1374_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),modulo_modulo(int,B2,A2))) ) ) ).

% pos_zmod_mult_2
tff(fact_1375_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),T2) ) ) ).

% pinf(6)
tff(fact_1376_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),X) ) ) ).

% pinf(8)
tff(fact_1377_minf_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),T2) ) ) ).

% minf(6)
tff(fact_1378_minf_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),X) ) ) ).

% minf(8)
tff(fact_1379_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,A2),Nb))
        <=> ( ( Nb = zero_zero(nat) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
              & ( A2 != zero_zero(A) ) )
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_less_power_eq
tff(fact_1380_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeListb: list(vEBT_VEBT),Nb: nat,Summaryb: vEBT_VEBT,Ma: nat,Degb: nat,Mi3: nat,Maa: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
         => vEBT_invar_vebt(X4,Nb) )
     => ( vEBT_invar_vebt(Summaryb,Ma)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma) )
         => ( ( Ma = Nb )
           => ( ( Degb = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma) )
             => ( ! [I2: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma))
                   => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),I2)),X_12)
                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summaryb),I2) ) )
               => ( ( ( Mi3 = Maa )
                   => ! [X4: vEBT_VEBT] :
                        ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
                       => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_13) ) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi3),Maa)
                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Maa),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Degb))
                     => ( ( ( Mi3 != Maa )
                         => ! [I2: nat] :
                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma))
                             => ( ( ( vEBT_VEBT_high(Maa,Nb) = I2 )
                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),I2)),vEBT_VEBT_low(Maa,Nb)) )
                                & ! [X4: nat] :
                                    ( ( ( vEBT_VEBT_high(X4,Nb) = I2 )
                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),I2)),vEBT_VEBT_low(X4,Nb)) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi3),X4)
                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Maa) ) ) ) ) )
                       => vEBT_invar_vebt(vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi3),Maa)),Degb,TreeListb,Summaryb),Degb) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
tff(fact_1381_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( vEBT_VEBT_membermima(X2,Xa2)
     => ( ! [Mi: nat,Ma2: nat] :
            ( ? [Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
           => ~ ( ( Xa2 = Mi )
                | ( Xa2 = Ma2 ) ) )
       => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList: list(vEBT_VEBT)] :
              ( ? [Vc2: vEBT_VEBT] : ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2) )
             => ~ ( ( Xa2 = Mi )
                  | ( Xa2 = Ma2 )
                  | $let(
                      pos: nat,
                      pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                      $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) )
         => ~ ! [V3: nat,TreeList: list(vEBT_VEBT)] :
                ( ? [Vd2: vEBT_VEBT] : ( X2 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2) )
               => ~ $let(
                      pos: nat,
                      pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                      $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
tff(fact_1382_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),B2),one_one(int))),A2) ) ) ).

% neg_zdiv_mult_2
tff(fact_1383_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),B2),A2) ) ) ).

% pos_zdiv_mult_2
tff(fact_1384_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeListb: list(vEBT_VEBT),Nb: nat,Summaryb: vEBT_VEBT,Ma: nat,Degb: nat,Mi3: nat,Maa: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
         => vEBT_invar_vebt(X4,Nb) )
     => ( vEBT_invar_vebt(Summaryb,Ma)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma) )
         => ( ( Ma = aa(nat,nat,suc,Nb) )
           => ( ( Degb = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma) )
             => ( ! [I2: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma))
                   => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),I2)),X_12)
                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summaryb),I2) ) )
               => ( ( ( Mi3 = Maa )
                   => ! [X4: vEBT_VEBT] :
                        ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X4),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
                       => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_13) ) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi3),Maa)
                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Maa),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Degb))
                     => ( ( ( Mi3 != Maa )
                         => ! [I2: nat] :
                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma))
                             => ( ( ( vEBT_VEBT_high(Maa,Nb) = I2 )
                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),I2)),vEBT_VEBT_low(Maa,Nb)) )
                                & ! [X4: nat] :
                                    ( ( ( vEBT_VEBT_high(X4,Nb) = I2 )
                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeListb),I2)),vEBT_VEBT_low(X4,Nb)) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi3),X4)
                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Maa) ) ) ) ) )
                       => vEBT_invar_vebt(vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi3),Maa)),Degb,TreeListb,Summaryb),Degb) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
tff(fact_1385_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),Nb)),zero_zero(A))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
            & ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
              | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
                & ( A2 = zero_zero(A) ) ) ) ) ) ) ).

% power_le_zero_eq
tff(fact_1386_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( vEBT_VEBT_membermima(X2,Xa2)
      <=> (Y2) )
     => ( ( ? [Uu2: $o,Uv2: $o] : ( X2 = vEBT_Leaf(Uu2,Uv2) )
         => (Y2) )
       => ( ( ? [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] : ( X2 = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
           => (Y2) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
               => ( (Y2)
                <=> ~ ( ( Xa2 = Mi )
                      | ( Xa2 = Ma2 ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList: list(vEBT_VEBT)] :
                  ( ? [Vc2: vEBT_VEBT] : ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2) )
                 => ( (Y2)
                  <=> ~ ( ( Xa2 = Mi )
                        | ( Xa2 = Ma2 )
                        | $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) )
             => ~ ! [V3: nat,TreeList: list(vEBT_VEBT)] :
                    ( ? [Vd2: vEBT_VEBT] : ( X2 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2) )
                   => ( (Y2)
                    <=> ~ $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
tff(fact_1387_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ vEBT_VEBT_membermima(X2,Xa2)
     => ( ! [Uu2: $o,Uv2: $o] : ( X2 != vEBT_Leaf(Uu2,Uv2) )
       => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] : ( X2 != vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
               => ( ( Xa2 = Mi )
                  | ( Xa2 = Ma2 ) ) )
           => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList: list(vEBT_VEBT)] :
                  ( ? [Vc2: vEBT_VEBT] : ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2) )
                 => ( ( Xa2 = Mi )
                    | ( Xa2 = Ma2 )
                    | $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) )
             => ~ ! [V3: nat,TreeList: list(vEBT_VEBT)] :
                    ( ? [Vd2: vEBT_VEBT] : ( X2 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2) )
                   => $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
tff(fact_1388_div2__even__ext__nat,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),X2)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Y2) )
       => ( X2 = Y2 ) ) ) ).

% div2_even_ext_nat
tff(fact_1389_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q2: A,R: A] :
          ( unique5940410009612947441es_aux(A,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q2),R))
        <=> ( R = zero_zero(A) ) ) ) ).

% divides_aux_eq
tff(fact_1390_product__nth,axiom,
    ! [A: $tType,B: $tType,Nb: nat,Xs: list(A),Ys: list(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)))
     => ( aa(nat,product_prod(A,B),nth(product_prod(A,B),product(A,B,Xs,Ys)),Nb) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(list(B),nat,size_size(list(B)),Ys)))),aa(nat,B,nth(B,Ys),modulo_modulo(nat,Nb,aa(list(B),nat,size_size(list(B)),Ys)))) ) ) ).

% product_nth
tff(fact_1391_vebt__buildup_Oelims,axiom,
    ! [X2: nat,Y2: vEBT_VEBT] :
      ( ( vEBT_vebt_buildup(X2) = Y2 )
     => ( ( ( X2 = zero_zero(nat) )
         => ( Y2 != vEBT_Leaf($false,$false) ) )
       => ( ( ( X2 = aa(nat,nat,suc,zero_zero(nat)) )
           => ( Y2 != vEBT_Leaf($false,$false) ) )
         => ~ ! [Va: nat] :
                ( ( X2 = aa(nat,nat,suc,aa(nat,nat,suc,Va)) )
               => ( Y2
                 != $ite(
                      aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va))),
                      $let(
                        half: nat,
                        half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                        vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),half),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(half)) ),
                      $let(
                        half: nat,
                        half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                        vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,half)),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(aa(nat,nat,suc,half))) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
tff(fact_1392_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va2: nat] :
      ( vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,suc,Va2)))
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),
          $let(
            half: nat,
            half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
            vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va2)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),half),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(half)) ),
          $let(
            half: nat,
            half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va2))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
            vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va2)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,half)),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(aa(nat,nat,suc,half))) ) ) ) ).

% vebt_buildup.simps(3)
tff(fact_1393_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: fun(A,$o),K: A,F3: fun(A,nat),Nb: nat] :
      ( aa(A,$o,P,K)
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
           => ? [Y3: A] :
                ( aa(A,$o,P,Y3)
                & ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F3,Y3)),aa(A,nat,F3,X4)) ) )
       => ? [Y4: A] :
            ( aa(A,$o,P,Y4)
            & ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F3,Y4)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F3,K)),Nb)) ) ) ) ).

% ex_has_greatest_nat_lemma
tff(fact_1394_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: fun(A,nat),X22: A] : ( aa(option(A),nat,size_option(A,X2),aa(A,option(A),some(A),X22)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,X2,X22)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% option.size_gen(2)
tff(fact_1395_flip__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( bit_se8732182000553998342ip_bit(A,zero_zero(nat),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% flip_bit_0
tff(fact_1396_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
            | ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) = zero_zero(A) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)))) ) ) ) ) ).

% even_mult_exp_div_exp_iff
tff(fact_1397_intind,axiom,
    ! [A: $tType,I3: nat,Nb: nat,P: fun(A,$o),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),Nb)
     => ( aa(A,$o,P,X2)
       => aa(A,$o,P,aa(nat,A,nth(A,replicate(A,Nb,X2)),I3)) ) ) ).

% intind
tff(fact_1398_diff__self,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),A2) = zero_zero(A) ) ) ).

% diff_self
tff(fact_1399_diff__0__right,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),zero_zero(A)) = A2 ) ) ).

% diff_0_right
tff(fact_1400_zero__diff,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% zero_diff
tff(fact_1401_diff__zero,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),zero_zero(A)) = A2 ) ) ).

% diff_zero
tff(fact_1402_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),A2) = zero_zero(A) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
tff(fact_1403_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2) = A2 ) ) ).

% add_diff_cancel
tff(fact_1404_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),B2) = A2 ) ) ).

% diff_add_cancel
tff(fact_1405_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ).

% add_diff_cancel_left
tff(fact_1406_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),A2) = B2 ) ) ).

% add_diff_cancel_left'
tff(fact_1407_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ).

% add_diff_cancel_right
tff(fact_1408_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2) = A2 ) ) ).

% add_diff_cancel_right'
tff(fact_1409_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% minus_mod_self2
tff(fact_1410_diff__Suc__Suc,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Ma)),aa(nat,nat,suc,Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb) ) ).

% diff_Suc_Suc
tff(fact_1411_Suc__diff__diff,axiom,
    ! [Ma: nat,Nb: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Ma)),Nb)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),K) ) ).

% Suc_diff_diff
tff(fact_1412_diff__self__eq__0,axiom,
    ! [Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Ma) = zero_zero(nat) ) ).

% diff_self_eq_0
tff(fact_1413_diff__0__eq__0,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),zero_zero(nat)),Nb) = zero_zero(nat) ) ).

% diff_0_eq_0
tff(fact_1414_diff__diff__cancel,axiom,
    ! [I3: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),I3)) = I3 ) ) ).

% diff_diff_cancel
tff(fact_1415_diff__diff__left,axiom,
    ! [I3: nat,J2: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),J2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) ) ).

% diff_diff_left
tff(fact_1416_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: $o,Q: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q))
        <=> ( (P)
           => (Q) ) ) ) ).

% of_bool_less_eq_iff
tff(fact_1417_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa($o,A,zero_neq_one_of_bool(A),$false) = zero_zero(A) ) ) ).

% of_bool_eq(1)
tff(fact_1418_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P) = zero_zero(A) )
        <=> ~ (P) ) ) ).

% of_bool_eq_0_iff
tff(fact_1419_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: $o,Q: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q))
        <=> ( ~ (P)
            & (Q) ) ) ) ).

% of_bool_less_iff
tff(fact_1420_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P) = one_one(A) )
        <=> (P) ) ) ).

% of_bool_eq_1_iff
tff(fact_1421_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa($o,A,zero_neq_one_of_bool(A),$true) = one_one(A) ) ) ).

% of_bool_eq(2)
tff(fact_1422_replicate__eq__replicate,axiom,
    ! [A: $tType,Ma: nat,X2: A,Nb: nat,Y2: A] :
      ( ( replicate(A,Ma,X2) = replicate(A,Nb,Y2) )
    <=> ( ( Ma = Nb )
        & ( ( Ma != zero_zero(nat) )
         => ( X2 = Y2 ) ) ) ) ).

% replicate_eq_replicate
tff(fact_1423_length__replicate,axiom,
    ! [A: $tType,Nb: nat,X2: A] : ( aa(list(A),nat,size_size(list(A)),replicate(A,Nb,X2)) = Nb ) ).

% length_replicate
tff(fact_1424_map__replicate,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Nb: nat,X2: B] : ( aa(list(B),list(A),map(B,A,F3),replicate(B,Nb,X2)) = replicate(A,Nb,aa(B,A,F3,X2)) ) ).

% map_replicate
tff(fact_1425_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% diff_ge_0_iff_ge
tff(fact_1426_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% diff_gt_0_iff_gt
tff(fact_1427_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),B2) = A2 ) ) ) ).

% le_add_diff_inverse2
tff(fact_1428_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = A2 ) ) ) ).

% le_add_diff_inverse
tff(fact_1429_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),one_one(A)) = zero_zero(A) ) ) ).

% diff_numeral_special(9)
tff(fact_1430_diff__add__zero,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = zero_zero(A) ) ) ).

% diff_add_zero
tff(fact_1431_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% right_diff_distrib_numeral
tff(fact_1432_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [A2: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% left_diff_distrib_numeral
tff(fact_1433_div__diff,axiom,
    ! [A: $tType] :
      ( idom_modulo(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ) ).

% div_diff
tff(fact_1434_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa($o,A,zero_neq_one_of_bool(A),P))
        <=> (P) ) ) ).

% zero_less_of_bool_iff
tff(fact_1435_zero__less__diff,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ).

% zero_less_diff
tff(fact_1436_diff__is__0__eq_H,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb) = zero_zero(nat) ) ) ).

% diff_is_0_eq'
tff(fact_1437_diff__is__0__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb) = zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% diff_is_0_eq
tff(fact_1438_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa($o,A,zero_neq_one_of_bool(A),P)),one_one(A))
        <=> ~ (P) ) ) ).

% of_bool_less_one_iff
tff(fact_1439_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: $o] : ( aa($o,A,zero_neq_one_of_bool(A),~ (P)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa($o,A,zero_neq_one_of_bool(A),P)) ) ) ).

% of_bool_not_iff
tff(fact_1440_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),J2)),K) ) ) ).

% Nat.add_diff_assoc
tff(fact_1441_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)),I3) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),I3)),K) ) ) ).

% Nat.add_diff_assoc2
tff(fact_1442_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),J2) ) ) ).

% Nat.diff_diff_right
tff(fact_1443_diff__Suc__1,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Nb)),one_one(nat)) = Nb ) ).

% diff_Suc_1
tff(fact_1444_Suc__0__mod__eq,axiom,
    ! [Nb: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,zero_zero(nat)),Nb) = aa($o,nat,zero_neq_one_of_bool(nat),( Nb != aa(nat,nat,suc,zero_zero(nat)) )) ) ).

% Suc_0_mod_eq
tff(fact_1445_Ball__set__replicate,axiom,
    ! [A: $tType,Nb: nat,A2: A,P: fun(A,$o)] :
      ( ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),replicate(A,Nb,A2)))
         => aa(A,$o,P,X3) )
    <=> ( aa(A,$o,P,A2)
        | ( Nb = zero_zero(nat) ) ) ) ).

% Ball_set_replicate
tff(fact_1446_Bex__set__replicate,axiom,
    ! [A: $tType,Nb: nat,A2: A,P: fun(A,$o)] :
      ( ? [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),replicate(A,Nb,A2)))
          & aa(A,$o,P,X3) )
    <=> ( aa(A,$o,P,A2)
        & ( Nb != zero_zero(nat) ) ) ) ).

% Bex_set_replicate
tff(fact_1447_in__set__replicate,axiom,
    ! [A: $tType,X2: A,Nb: nat,Y2: A] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),replicate(A,Nb,Y2)))
    <=> ( ( X2 = Y2 )
        & ( Nb != zero_zero(nat) ) ) ) ).

% in_set_replicate
tff(fact_1448_nth__replicate,axiom,
    ! [A: $tType,I3: nat,Nb: nat,X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),Nb)
     => ( aa(nat,A,nth(A,replicate(A,Nb,X2)),I3) = X2 ) ) ).

% nth_replicate
tff(fact_1449_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] : ( aa(list(product_prod(A,B)),nat,size_size(list(product_prod(A,B))),product(A,B,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)) ) ).

% length_product
tff(fact_1450_Suc__pred,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))) = Nb ) ) ).

% Suc_pred
tff(fact_1451_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K))),I3) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,J2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),I3)) ) ) ).

% diff_Suc_diff_eq2
tff(fact_1452_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),aa(nat,nat,suc,J2)) ) ) ).

% diff_Suc_diff_eq1
tff(fact_1453_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [P2: $o] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa($o,A,zero_neq_one_of_bool(A),P2))
        <=> (P2) ) ) ).

% odd_of_bool_self
tff(fact_1454_Suc__diff__1,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))) = Nb ) ) ).

% Suc_diff_1
tff(fact_1455_even__diff,axiom,
    ! [A: $tType] :
      ( ring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ).

% even_diff
tff(fact_1456_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [B2: $o] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa($o,A,zero_neq_one_of_bool(A),B2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% of_bool_half_eq_0
tff(fact_1457_odd__Suc__minus__one,axiom,
    ! [Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))) = Nb ) ) ).

% odd_Suc_minus_one
tff(fact_1458_even__diff__nat,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) ) ) ).

% even_diff_nat
tff(fact_1459_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),one_one(A)))
        <=> ( Nb = zero_zero(nat) ) ) ) ).

% semiring_parity_class.even_mask_iff
tff(fact_1460_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Nb: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa($o,A,zero_neq_one_of_bool(A),( Nb = zero_zero(nat) )) ) ) ).

% bits_1_div_exp
tff(fact_1461_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Nb: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa($o,A,zero_neq_one_of_bool(A),( Nb = zero_zero(nat) )) ) ) ).

% one_div_2_pow_eq
tff(fact_1462_odd__two__times__div__two__nat,axiom,
    ! [Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)) ) ) ).

% odd_two_times_div_two_nat
tff(fact_1463_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Nb: nat] : ( modulo_modulo(A,one_one(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)) ) ) ).

% one_mod_2_pow_eq
tff(fact_1464_diff__right__commute,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) ) ) ).

% diff_right_commute
tff(fact_1465_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( ( A2 = B2 )
          <=> ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
tff(fact_1466_diff__commute,axiom,
    ! [I3: nat,J2: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),J2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),K)),J2) ) ).

% diff_commute
tff(fact_1467_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P2: $o,Q2: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P2) = aa($o,A,zero_neq_one_of_bool(A),Q2) )
        <=> ( (P2)
          <=> (Q2) ) ) ) ).

% of_bool_eq_iff
tff(fact_1468_of__bool__conj,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: $o,Q: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),
              (P)
            & (Q))
          = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_conj
tff(fact_1469_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2) ) ) ) ).

% diff_eq_diff_less_eq
tff(fact_1470_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% diff_right_mono
tff(fact_1471_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)) ) ) ).

% diff_left_mono
tff(fact_1472_diff__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ) ).

% diff_mono
tff(fact_1473_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = zero_zero(A) ) ) ) ).

% eq_iff_diff_eq_0
tff(fact_1474_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),D2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ) ).

% diff_strict_mono
tff(fact_1475_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2) ) ) ) ).

% diff_eq_diff_less
tff(fact_1476_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)) ) ) ).

% diff_strict_left_mono
tff(fact_1477_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% diff_strict_right_mono
tff(fact_1478_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% left_diff_distrib
tff(fact_1479_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% right_diff_distrib
tff(fact_1480_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [B2: A,C2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) ) ) ).

% left_diff_distrib'
tff(fact_1481_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% right_diff_distrib'
tff(fact_1482_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,$o),D4: A,Q: fun(A,$o)] :
          ( ! [X4: A,K2: A] :
              ( aa(A,$o,P,X4)
            <=> aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4))) )
         => ( ! [X4: A,K2: A] :
                ( aa(A,$o,Q,X4)
              <=> aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4))) )
           => ! [X: A,K4: A] :
                ( ( aa(A,$o,P,X)
                  | aa(A,$o,Q,X) )
              <=> ( aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4)))
                  | aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4))) ) ) ) ) ) ).

% inf_period(2)
tff(fact_1483_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,$o),D4: A,Q: fun(A,$o)] :
          ( ! [X4: A,K2: A] :
              ( aa(A,$o,P,X4)
            <=> aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4))) )
         => ( ! [X4: A,K2: A] :
                ( aa(A,$o,Q,X4)
              <=> aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4))) )
           => ! [X: A,K4: A] :
                ( ( aa(A,$o,P,X)
                  & aa(A,$o,Q,X) )
              <=> ( aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4)))
                  & aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4))) ) ) ) ) ) ).

% inf_period(1)
tff(fact_1484_add__diff__add,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,C2: A,B2: A,D2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2)) ) ) ).

% add_diff_add
tff(fact_1485_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% group_cancel.sub1
tff(fact_1486_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = C2 )
        <=> ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) ) ) ) ).

% diff_eq_eq
tff(fact_1487_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = C2 ) ) ) ).

% eq_diff_eq
tff(fact_1488_add__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% add_diff_eq
tff(fact_1489_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ).

% diff_diff_eq2
tff(fact_1490_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ).

% diff_add_eq
tff(fact_1491_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),B2) ) ) ).

% diff_add_eq_diff_diff_swap
tff(fact_1492_add__implies__diff,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) = A2 )
         => ( C2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ) ).

% add_implies_diff
tff(fact_1493_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% diff_diff_eq
tff(fact_1494_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ).

% diff_divide_distrib
tff(fact_1495_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( euclid5891614535332579305n_ring(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% dvd_diff_commute
tff(fact_1496_dvd__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),Z)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y2),Z)) ) ) ) ).

% dvd_diff
tff(fact_1497_zero__induct__lemma,axiom,
    ! [P: fun(nat,$o),K: nat,I3: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [N: nat] :
            ( aa(nat,$o,P,aa(nat,nat,suc,N))
           => aa(nat,$o,P,N) )
       => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),I3)) ) ) ).

% zero_induct_lemma
tff(fact_1498_diffs0__imp__equal,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb) = zero_zero(nat) )
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma) = zero_zero(nat) )
       => ( Ma = Nb ) ) ) ).

% diffs0_imp_equal
tff(fact_1499_minus__nat_Odiff__0,axiom,
    ! [Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),zero_zero(nat)) = Ma ) ).

% minus_nat.diff_0
tff(fact_1500_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_right_eq
tff(fact_1501_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_left_eq
tff(fact_1502_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A5),B5),C2) ) ) ) ) ).

% mod_diff_cong
tff(fact_1503_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_eq
tff(fact_1504_diff__less__mono2,axiom,
    ! [Ma: nat,Nb: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),Ma)) ) ) ).

% diff_less_mono2
tff(fact_1505_less__imp__diff__less,axiom,
    ! [J2: nat,K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),Nb)),K) ) ).

% less_imp_diff_less
tff(fact_1506_eq__diff__iff,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
       => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K) )
        <=> ( Ma = Nb ) ) ) ) ).

% eq_diff_iff
tff(fact_1507_le__diff__iff,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ) ).

% le_diff_iff
tff(fact_1508_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb) ) ) ) ).

% Nat.diff_diff_eq
tff(fact_1509_diff__le__mono,axiom,
    ! [Ma: nat,Nb: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),L)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),L)) ) ).

% diff_le_mono
tff(fact_1510_diff__le__self,axiom,
    ! [Ma: nat,Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),Ma) ).

% diff_le_self
tff(fact_1511_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),C2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),B2),C2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),C2),A2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),C2),B2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),B2),A2) ) ) ) ).

% le_diff_iff'
tff(fact_1512_diff__le__mono2,axiom,
    ! [Ma: nat,Nb: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),Ma)) ) ).

% diff_le_mono2
tff(fact_1513_Nat_Odiff__cancel,axiom,
    ! [K: nat,Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb) ) ).

% Nat.diff_cancel
tff(fact_1514_diff__cancel2,axiom,
    ! [Ma: nat,K: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb) ) ).

% diff_cancel2
tff(fact_1515_diff__add__inverse,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)),Nb) = Ma ) ).

% diff_add_inverse
tff(fact_1516_diff__add__inverse2,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)),Nb) = Ma ) ).

% diff_add_inverse2
tff(fact_1517_diff__mult__distrib2,axiom,
    ! [K: nat,Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb)) ) ).

% diff_mult_distrib2
tff(fact_1518_diff__mult__distrib,axiom,
    ! [Ma: nat,Nb: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K)) ) ).

% diff_mult_distrib
tff(fact_1519_dvd__diff__nat,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Nb)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)) ) ) ).

% dvd_diff_nat
tff(fact_1520_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa($o,A,zero_neq_one_of_bool(A),P)) ) ).

% zero_less_eq_of_bool
tff(fact_1521_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa($o,A,zero_neq_one_of_bool(A),P)),one_one(A)) ) ).

% of_bool_less_eq_one
tff(fact_1522_of__bool__def,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P2: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),P2)
          = $ite((P2),one_one(A),zero_zero(A)) ) ) ).

% of_bool_def
tff(fact_1523_split__of__bool,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,$o),P2: $o] :
          ( aa(A,$o,P,aa($o,A,zero_neq_one_of_bool(A),P2))
        <=> ( ( (P2)
             => aa(A,$o,P,one_one(A)) )
            & ( ~ (P2)
             => aa(A,$o,P,zero_zero(A)) ) ) ) ) ).

% split_of_bool
tff(fact_1524_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,$o),P2: $o] :
          ( aa(A,$o,P,aa($o,A,zero_neq_one_of_bool(A),P2))
        <=> ~ ( ( (P2)
                & ~ aa(A,$o,P,one_one(A)) )
              | ( ~ (P2)
                & ~ aa(A,$o,P,zero_zero(A)) ) ) ) ) ).

% split_of_bool_asm
tff(fact_1525_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),zero_zero(A)) ) ) ).

% le_iff_diff_le_0
tff(fact_1526_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),zero_zero(A)) ) ) ).

% less_iff_diff_less_0
tff(fact_1527_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% diff_le_eq
tff(fact_1528_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% le_diff_eq
tff(fact_1529_diff__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),A2) = B2 ) ) ) ).

% diff_add
tff(fact_1530_le__add__diff,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2)) ) ) ).

% le_add_diff
tff(fact_1531_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),B2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
tff(fact_1532_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
tff(fact_1533_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
tff(fact_1534_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
tff(fact_1535_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),C2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
tff(fact_1536_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),B2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
tff(fact_1537_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
tff(fact_1538_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
tff(fact_1539_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I3: A,K: A,Nb: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),Nb)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I3),aa(A,A,aa(A,fun(A,A),minus_minus(A),Nb),K)) ) ) ).

% add_le_imp_le_diff
tff(fact_1540_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I3: A,K: A,Nb: A,J2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),Nb)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Nb),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K)),Nb)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Nb),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Nb),K)),J2) ) ) ) ) ) ).

% add_le_add_imp_diff_le
tff(fact_1541_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
tff(fact_1542_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% diff_less_eq
tff(fact_1543_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% less_diff_eq
tff(fact_1544_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( comm_ring(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Y2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) ) ) ).

% square_diff_square_factored
tff(fact_1545_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2) )
        <=> ( C2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E2)),D2) ) ) ) ).

% eq_add_iff2
tff(fact_1546_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E2)),C2) = D2 ) ) ) ).

% eq_add_iff1
tff(fact_1547_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [X2: A,Y2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y2),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A2)),B2)) ) ) ).

% mult_diff_mult
tff(fact_1548_replicate__length__same,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => ( X4 = X2 ) )
     => ( replicate(A,aa(list(A),nat,size_size(list(A)),Xs),X2) = Xs ) ) ).

% replicate_length_same
tff(fact_1549_replicate__eqI,axiom,
    ! [A: $tType,Xs: list(A),Nb: nat,X2: A] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = Nb )
     => ( ! [Y4: A] :
            ( aa(set(A),$o,member(A,Y4),aa(list(A),set(A),set2(A),Xs))
           => ( Y4 = X2 ) )
       => ( Xs = replicate(A,Nb,X2) ) ) ) ).

% replicate_eqI
tff(fact_1550_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2))) ) ).

% dvd_minus_mod
tff(fact_1551_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,B2,C2) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ).

% mod_eq_dvd_iff
tff(fact_1552_diff__less__Suc,axiom,
    ! [Ma: nat,Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),aa(nat,nat,suc,Ma)) ).

% diff_less_Suc
tff(fact_1553_Suc__diff__Suc,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),aa(nat,nat,suc,Nb))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb) ) ) ).

% Suc_diff_Suc
tff(fact_1554_diff__less,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),Ma) ) ) ).

% diff_less
tff(fact_1555_Suc__diff__le,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Ma)),Nb) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)) ) ) ).

% Suc_diff_le
tff(fact_1556_less__diff__iff,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ) ).

% less_diff_iff
tff(fact_1557_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),C2),A2)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),C2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),B2),C2)) ) ) ).

% diff_less_mono
tff(fact_1558_diff__add__0,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)) = zero_zero(nat) ) ).

% diff_add_0
tff(fact_1559_less__diff__conv,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),J2) ) ).

% less_diff_conv
tff(fact_1560_add__diff__inverse__nat,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)) = Ma ) ) ).

% add_diff_inverse_nat
tff(fact_1561_le__diff__conv,axiom,
    ! [J2: nat,K: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)),I3)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)) ) ).

% le_diff_conv
tff(fact_1562_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),J2) ) ) ).

% Nat.le_diff_conv2
tff(fact_1563_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),J2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)) ) ) ).

% Nat.diff_add_assoc
tff(fact_1564_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),I3)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)),I3) ) ) ).

% Nat.diff_add_assoc2
tff(fact_1565_Nat_Ole__imp__diff__is__add,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I3) = K )
      <=> ( J2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),I3) ) ) ) ).

% Nat.le_imp_diff_is_add
tff(fact_1566_diff__Suc__eq__diff__pred,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),aa(nat,nat,suc,Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),one_one(nat))),Nb) ) ).

% diff_Suc_eq_diff_pred
tff(fact_1567_dvd__minus__self,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),Nb) ) ) ).

% dvd_minus_self
tff(fact_1568_dvd__diffD,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Nb)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Ma) ) ) ) ).

% dvd_diffD
tff(fact_1569_dvd__diffD1,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Ma)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Nb) ) ) ) ).

% dvd_diffD1
tff(fact_1570_less__eq__dvd__minus,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),Nb)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)) ) ) ).

% less_eq_dvd_minus
tff(fact_1571_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D3: nat,X4: nat,Y4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D3),A2)
      & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D3),B2)
      & ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)) = D3 )
        | ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)) = D3 ) ) ) ).

% bezout1_nat
tff(fact_1572_mod__if,axiom,
    ! [Ma: nat,Nb: nat] :
      ( modulo_modulo(nat,Ma,Nb)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb),Ma,modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb),Nb)) ) ).

% mod_if
tff(fact_1573_mod__geq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
     => ( modulo_modulo(nat,Ma,Nb) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb),Nb) ) ) ).

% mod_geq
tff(fact_1574_le__mod__geq,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
     => ( modulo_modulo(nat,Ma,Nb) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb),Nb) ) ) ).

% le_mod_geq
tff(fact_1575_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X2: product_prod(vEBT_VEBT,nat)] :
      ( ! [Uu2: $o,Uv2: $o,D3: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(Uu2,Uv2)),D3) )
     => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,Deg2: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Mima,Deg,TreeList,Summary)),Deg2) ) ) ).

% VEBT_internal.valid'.cases
tff(fact_1576_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list(B)] : ( aa(list(B),list(A),map(B,A,aa(A,fun(B,A),aTP_Lamp_aq(A,fun(B,A)),K)),Lst) = replicate(A,aa(list(B),nat,size_size(list(B)),Lst),K) ) ).

% map_replicate_const
tff(fact_1577_product__concat__map,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( product(A,B,Xs,Ys) = concat(product_prod(A,B),aa(list(A),list(list(product_prod(A,B))),map(A,list(product_prod(A,B)),aTP_Lamp_ar(list(B),fun(A,list(product_prod(A,B))),Ys)),Xs)) ) ).

% product_concat_map
tff(fact_1578_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E2)),D2)) ) ) ).

% ordered_ring_class.le_add_iff2
tff(fact_1579_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E2)),C2)),D2) ) ) ).

% ordered_ring_class.le_add_iff1
tff(fact_1580_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E2)),C2)),D2) ) ) ).

% less_add_iff1
tff(fact_1581_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E2)),D2)) ) ) ).

% less_add_iff2
tff(fact_1582_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,Z: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Z))
          = $ite(Z = zero_zero(A),A2,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),Z)),B2)),Z)) ) ) ).

% add_divide_eq_if_simps(4)
tff(fact_1583_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z)) ) ) ) ) ).

% diff_frac_eq
tff(fact_1584_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),Y2)),Z) ) ) ) ).

% diff_divide_eq_iff
tff(fact_1585_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z)),Y2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z))),Z) ) ) ) ).

% divide_diff_eq_iff
tff(fact_1586_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),one_one(A))) ) ) ).

% square_diff_one_factored
tff(fact_1587_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D4: A,T2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),D4)
         => ! [X: A,K4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),T2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4))),T2)) ) ) ) ).

% inf_period(3)
tff(fact_1588_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D4: A,T2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),D4)
         => ! [X: A,K4: A] :
              ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),T2))
            <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D4))),T2)) ) ) ) ).

% inf_period(4)
tff(fact_1589_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)) = modulo_modulo(A,A2,B2) ) ) ).

% minus_div_mult_eq_mod
tff(fact_1590_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2) ) ) ).

% minus_mod_eq_div_mult
tff(fact_1591_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ).

% minus_mod_eq_mult_div
tff(fact_1592_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))) = modulo_modulo(A,A2,B2) ) ) ).

% minus_mult_div_eq_mod
tff(fact_1593_diff__Suc__less,axiom,
    ! [Nb: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,I3))),Nb) ) ).

% diff_Suc_less
tff(fact_1594_nat__diff__split,axiom,
    ! [P: fun(nat,$o),A2: nat,B2: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
         => aa(nat,$o,P,zero_zero(nat)) )
        & ! [D5: nat] :
            ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B2),D5) )
           => aa(nat,$o,P,D5) ) ) ) ).

% nat_diff_split
tff(fact_1595_nat__diff__split__asm,axiom,
    ! [P: fun(nat,$o),A2: nat,B2: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
    <=> ~ ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
            & ~ aa(nat,$o,P,zero_zero(nat)) )
          | ? [D5: nat] :
              ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B2),D5) )
              & ~ aa(nat,$o,P,D5) ) ) ) ).

% nat_diff_split_asm
tff(fact_1596_less__diff__conv2,axiom,
    ! [K: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)),I3)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)) ) ) ).

% less_diff_conv2
tff(fact_1597_nat__diff__add__eq2,axiom,
    ! [I3: nat,J2: nat,U: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I3)),U)),Nb)) ) ) ).

% nat_diff_add_eq2
tff(fact_1598_nat__diff__add__eq1,axiom,
    ! [J2: nat,I3: nat,U: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I3)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),J2)),U)),Ma)),Nb) ) ) ).

% nat_diff_add_eq1
tff(fact_1599_nat__le__add__iff2,axiom,
    ! [I3: nat,J2: nat,U: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Nb))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I3)),U)),Nb)) ) ) ).

% nat_le_add_iff2
tff(fact_1600_nat__le__add__iff1,axiom,
    ! [J2: nat,I3: nat,U: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Nb))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),J2)),U)),Ma)),Nb) ) ) ).

% nat_le_add_iff1
tff(fact_1601_nat__eq__add__iff2,axiom,
    ! [I3: nat,J2: nat,U: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),Ma) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Nb) )
      <=> ( Ma = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I3)),U)),Nb) ) ) ) ).

% nat_eq_add_iff2
tff(fact_1602_nat__eq__add__iff1,axiom,
    ! [J2: nat,I3: nat,U: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I3)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),Ma) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Nb) )
      <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),J2)),U)),Ma) = Nb ) ) ) ).

% nat_eq_add_iff1
tff(fact_1603_mod__eq__dvd__iff__nat,axiom,
    ! [Nb: nat,Ma: nat,Q2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
     => ( ( modulo_modulo(nat,Ma,Q2) = modulo_modulo(nat,Nb,Q2) )
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Q2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)) ) ) ).

% mod_eq_dvd_iff_nat
tff(fact_1604_modulo__nat__def,axiom,
    ! [Ma: nat,Nb: nat] : ( modulo_modulo(nat,Ma,Nb) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),Nb)) ) ).

% modulo_nat_def
tff(fact_1605_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb))
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),
                aa($o,A,zero_neq_one_of_bool(A),
                  ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma) != zero_zero(A) )
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma))),
              aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb))) ) ) ).

% exp_div_exp_eq
tff(fact_1606_frac__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z))),zero_zero(A)) ) ) ) ) ).

% frac_le_eq
tff(fact_1607_frac__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2 != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z))),zero_zero(A)) ) ) ) ) ).

% frac_less_eq
tff(fact_1608_power2__commute,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y2: A] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y2),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% power2_commute
tff(fact_1609_power__diff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,Nb: nat,Ma: nat] :
          ( ( A2 != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
           => ( aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A2),Ma)),aa(nat,A,power_power(A,A2),Nb)) ) ) ) ) ).

% power_diff
tff(fact_1610_Suc__diff__eq__diff__pred,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Ma)),Nb) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))) ) ) ).

% Suc_diff_eq_diff_pred
tff(fact_1611_Suc__pred_H,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( Nb = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))) ) ) ).

% Suc_pred'
tff(fact_1612_div__if,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)
      = $ite(
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
          | ( Nb = zero_zero(nat) ) ),
          zero_zero(nat),
          aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),Nb)) ) ) ).

% div_if
tff(fact_1613_div__geq,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),Nb)) ) ) ) ).

% div_geq
tff(fact_1614_add__eq__if,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)
      = $ite(Ma = zero_zero(nat),Nb,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),one_one(nat))),Nb))) ) ).

% add_eq_if
tff(fact_1615_nat__less__add__iff1,axiom,
    ! [J2: nat,I3: nat,U: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Nb))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I3),J2)),U)),Ma)),Nb) ) ) ).

% nat_less_add_iff1
tff(fact_1616_nat__less__add__iff2,axiom,
    ! [I3: nat,J2: nat,U: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I3),U)),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Nb))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I3)),U)),Nb)) ) ) ).

% nat_less_add_iff2
tff(fact_1617_mult__eq__if,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)
      = $ite(Ma = zero_zero(nat),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),one_one(nat))),Nb))) ) ).

% mult_eq_if
tff(fact_1618_dvd__minus__add,axiom,
    ! [Q2: nat,Nb: nat,R: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Q2),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Q2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),R),Ma))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Q2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),R),Ma)),Q2))) ) ) ) ).

% dvd_minus_add
tff(fact_1619_mod__nat__eqI,axiom,
    ! [R: nat,Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),R),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R),Ma)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),R))
         => ( modulo_modulo(nat,Ma,Nb) = R ) ) ) ) ).

% mod_nat_eqI
tff(fact_1620_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X2: product_prod(vEBT_VEBT,nat)] :
      ( ! [A4: $o,B3: $o,X4: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(A4,B3)),X4) )
     => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT,Ux2: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Ux2) )
       => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList: list(vEBT_VEBT),S2: vEBT_VEBT,X4: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2)),X4) ) ) ) ).

% VEBT_internal.naive_member.cases
tff(fact_1621_VEBT__internal_Oelim__dead_Ocases,axiom,
    ! [X2: product_prod(vEBT_VEBT,extended_enat)] :
      ( ! [A4: $o,B3: $o,Uu2: extended_enat] : ( X2 != aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),aa(vEBT_VEBT,fun(extended_enat,product_prod(vEBT_VEBT,extended_enat)),product_Pair(vEBT_VEBT,extended_enat),vEBT_Leaf(A4,B3)),Uu2) )
     => ( ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] : ( X2 != aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),aa(vEBT_VEBT,fun(extended_enat,product_prod(vEBT_VEBT,extended_enat)),product_Pair(vEBT_VEBT,extended_enat),vEBT_Node(Info,Deg,TreeList,Summary)),extend4730790105801354508finity(extended_enat)) )
       => ~ ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,L2: nat] : ( X2 != aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),aa(vEBT_VEBT,fun(extended_enat,product_prod(vEBT_VEBT,extended_enat)),product_Pair(vEBT_VEBT,extended_enat),vEBT_Node(Info,Deg,TreeList,Summary)),extended_enat2(L2)) ) ) ) ).

% VEBT_internal.elim_dead.cases
tff(fact_1622_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] : ( aa($o,A,zero_neq_one_of_bool(A),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% of_bool_odd_eq_mod_2
tff(fact_1623_scaling__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,V: A,R: A,S: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),V)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),R)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),R),S)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),U),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),R),aa(A,A,aa(A,fun(A,A),minus_minus(A),V),U))),S))),V) ) ) ) ) ).

% scaling_mono
tff(fact_1624_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Nb: nat,Ma: nat] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) != zero_zero(A) )
         => ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)) != zero_zero(A) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
tff(fact_1625_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,Ma: nat,Nb: nat] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,power_power(A,A2),Ma)),aa(nat,A,power_power(A,A2),Nb))
            = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma),aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)))) ) ) ) ).

% power_diff_power_eq
tff(fact_1626_power__eq__if,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [P2: A,Ma: nat] :
          ( aa(nat,A,power_power(A,P2),Ma)
          = $ite(Ma = zero_zero(nat),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(nat,A,power_power(A,P2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),one_one(nat))))) ) ) ).

% power_eq_if
tff(fact_1627_power__minus__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Nb: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))),A2) = aa(nat,A,power_power(A,A2),Nb) ) ) ) ).

% power_minus_mult
tff(fact_1628_diff__le__diff__pow,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,K),Ma)),aa(nat,nat,power_power(nat,K),Nb))) ) ).

% diff_le_diff_pow
tff(fact_1629_le__div__geq,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),Nb)) ) ) ) ).

% le_div_geq
tff(fact_1630_bits__induct,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [P: fun(A,$o),A2: A] :
          ( ! [A4: A] :
              ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A4 )
             => aa(A,$o,P,A4) )
         => ( ! [A4: A,B3: $o] :
                ( aa(A,$o,P,A4)
               => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A4 )
                 => aa(A,$o,P,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),B3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))) ) )
           => aa(A,$o,P,A2) ) ) ) ).

% bits_induct
tff(fact_1631_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Ma: nat,Nb: nat] : ( modulo_modulo(A,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)) ) ) ).

% exp_mod_exp
tff(fact_1632_list__decode_Ocases,axiom,
    ! [X2: nat] :
      ( ( X2 != zero_zero(nat) )
     => ~ ! [N: nat] : ( X2 != aa(nat,nat,suc,N) ) ) ).

% list_decode.cases
tff(fact_1633_power2__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y2: A] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)),Y2)) ) ) ).

% power2_diff
tff(fact_1634_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: fun(A,$o),K: A,F3: fun(A,nat),B2: nat] :
      ( aa(A,$o,P,K)
     => ( ! [Y4: A] :
            ( aa(A,$o,P,Y4)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F3,Y4)),B2) )
       => ? [X4: A] :
            ( aa(A,$o,P,X4)
            & ! [Y3: A] :
                ( aa(A,$o,P,Y3)
               => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F3,Y3)),aa(A,nat,F3,X4)) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
tff(fact_1635_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Ma: nat,Nb: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)) ) ) ) ).

% mult_exp_mod_exp_eq
tff(fact_1636_int__power__div__base,axiom,
    ! [Ma: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,power_power(int,K),Ma)),K) = aa(nat,int,power_power(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),aa(nat,nat,suc,zero_zero(nat)))) ) ) ) ).

% int_power_div_base
tff(fact_1637_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)))
             => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2) = modulo_modulo(A,A2,B2) ) ) ) ) ) ).

% divmod_digit_1(2)
tff(fact_1638_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X2: product_prod(vEBT_VEBT,nat)] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(Uu2,Uv2)),Uw2) )
     => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT,Uz2: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Uz2) )
       => ( ! [Mi: nat,Ma2: nat,Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT,X4: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2)),X4) )
         => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList: list(vEBT_VEBT),Vc2: vEBT_VEBT,X4: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2)),X4) )
           => ~ ! [V3: nat,TreeList: list(vEBT_VEBT),Vd2: vEBT_VEBT,X4: nat] : ( X2 != aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2)),X4) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
tff(fact_1639_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)),one_one(A))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ).

% even_mask_div_iff'
tff(fact_1640_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X2: fun(A,nat)] : ( aa(option(A),nat,size_option(A,X2),none(A)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size_gen(1)
tff(fact_1641_even__mod__4__div__2,axiom,
    ! [Nb: nat] :
      ( ( modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(nat,nat,suc,zero_zero(nat)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% even_mod_4_div_2
tff(fact_1642_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)),one_one(A))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)))
        <=> ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) = zero_zero(A) )
            | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ) ).

% even_mask_div_iff
tff(fact_1643_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Q2: A,R: A] :
          ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q2),R))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Q2)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),R),aa(num,A,numeral_numeral(A),L))),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Q2)),R)) ) ) ).

% divmod_step_eq
tff(fact_1644_psubsetI,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
     => ( ( A3 != B4 )
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4) ) ) ).

% psubsetI
tff(fact_1645_Suc__if__eq,axiom,
    ! [A: $tType,F3: fun(nat,A),H: fun(nat,A),G: A,Nb: nat] :
      ( ! [N: nat] : ( aa(nat,A,F3,aa(nat,nat,suc,N)) = aa(nat,A,H,N) )
     => ( ( aa(nat,A,F3,zero_zero(nat)) = G )
       => ( aa(nat,A,F3,Nb)
          = $ite(Nb = zero_zero(nat),G,aa(nat,A,H,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))) ) ) ) ).

% Suc_if_eq
tff(fact_1646_triangle__def,axiom,
    ! [Nb: nat] : ( nat_triangle(Nb) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,suc,Nb))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% triangle_def
tff(fact_1647_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),B2)
     => ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),R)))) ) ) ).

% pos_eucl_rel_int_mult_2
tff(fact_1648_VEBT__internal_Oelim__dead_Opelims,axiom,
    ! [X2: vEBT_VEBT,Xa2: extended_enat,Y2: vEBT_VEBT] :
      ( ( vEBT_VEBT_elim_dead(X2,Xa2) = Y2 )
     => ( accp(product_prod(vEBT_VEBT,extended_enat),vEBT_V312737461966249ad_rel,aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),aa(vEBT_VEBT,fun(extended_enat,product_prod(vEBT_VEBT,extended_enat)),product_Pair(vEBT_VEBT,extended_enat),X2),Xa2))
       => ( ! [A4: $o,B3: $o] :
              ( ( X2 = vEBT_Leaf(A4,B3) )
             => ( ( Y2 = vEBT_Leaf(A4,B3) )
               => ~ accp(product_prod(vEBT_VEBT,extended_enat),vEBT_V312737461966249ad_rel,aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),aa(vEBT_VEBT,fun(extended_enat,product_prod(vEBT_VEBT,extended_enat)),product_Pair(vEBT_VEBT,extended_enat),vEBT_Leaf(A4,B3)),Xa2)) ) )
         => ( ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(Info,Deg,TreeList,Summary) )
               => ( ( Xa2 = extend4730790105801354508finity(extended_enat) )
                 => ( ( Y2 = vEBT_Node(Info,Deg,aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ad(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg)),TreeList),vEBT_VEBT_elim_dead(Summary,extend4730790105801354508finity(extended_enat))) )
                   => ~ accp(product_prod(vEBT_VEBT,extended_enat),vEBT_V312737461966249ad_rel,aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),aa(vEBT_VEBT,fun(extended_enat,product_prod(vEBT_VEBT,extended_enat)),product_Pair(vEBT_VEBT,extended_enat),vEBT_Node(Info,Deg,TreeList,Summary)),extend4730790105801354508finity(extended_enat))) ) ) )
           => ~ ! [Info: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                  ( ( X2 = vEBT_Node(Info,Deg,TreeList,Summary) )
                 => ! [L2: nat] :
                      ( ( Xa2 = extended_enat2(L2) )
                     => ( ( Y2 = vEBT_Node(Info,Deg,take(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(list(vEBT_VEBT),list(vEBT_VEBT),map(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ad(nat,fun(vEBT_VEBT,vEBT_VEBT),Deg)),TreeList)),vEBT_VEBT_elim_dead(Summary,extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),L2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))) )
                       => ~ accp(product_prod(vEBT_VEBT,extended_enat),vEBT_V312737461966249ad_rel,aa(extended_enat,product_prod(vEBT_VEBT,extended_enat),aa(vEBT_VEBT,fun(extended_enat,product_prod(vEBT_VEBT,extended_enat)),product_Pair(vEBT_VEBT,extended_enat),vEBT_Node(Info,Deg,TreeList,Summary)),extended_enat2(L2))) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.pelims
tff(fact_1649_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),A2)
          = $ite(Nb = zero_zero(nat),aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))))) ) ) ).

% signed_take_bit_rec
tff(fact_1650_verit__minus__simplify_I4_J,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),B2)) = B2 ) ) ).

% verit_minus_simplify(4)
tff(fact_1651_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),A2)) = A2 ) ) ).

% add.inverse_inverse
tff(fact_1652_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,uminus_uminus(A),B2) )
        <=> ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
tff(fact_1653_idiff__infinity,axiom,
    ! [Nb: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extend4730790105801354508finity(extended_enat)),Nb) = extend4730790105801354508finity(extended_enat) ) ).

% idiff_infinity
tff(fact_1654_idiff__0,axiom,
    ! [Nb: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),zero_zero(extended_enat)),Nb) = zero_zero(extended_enat) ) ).

% idiff_0
tff(fact_1655_idiff__0__right,axiom,
    ! [Nb: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Nb),zero_zero(extended_enat)) = Nb ) ).

% idiff_0_right
tff(fact_1656_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% neg_le_iff_le
tff(fact_1657_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = A2 )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% neg_equal_zero
tff(fact_1658_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% equal_neg_zero
tff(fact_1659_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% neg_equal_0_iff_equal
tff(fact_1660_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),A2) )
        <=> ( zero_zero(A) = A2 ) ) ) ).

% neg_0_equal_iff_equal
tff(fact_1661_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ( aa(A,A,uminus_uminus(A),zero_zero(A)) = zero_zero(A) ) ) ).

% add.inverse_neutral
tff(fact_1662_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% neg_less_iff_less
tff(fact_1663_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Ma: num,Nb: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)) )
        <=> ( Ma = Nb ) ) ) ).

% neg_numeral_eq_iff
tff(fact_1664_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% mult_minus_right
tff(fact_1665_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) ) ) ).

% minus_mult_minus
tff(fact_1666_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% mult_minus_left
tff(fact_1667_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_add_distrib
tff(fact_1668_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = B2 ) ) ).

% minus_add_cancel
tff(fact_1669_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),B2)) = B2 ) ) ).

% add_minus_cancel
tff(fact_1670_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) ) ) ).

% minus_diff_eq
tff(fact_1671_div__minus__minus,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ).

% div_minus_minus
tff(fact_1672_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),aa(A,A,uminus_uminus(A),Y2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),Y2) ) ) ).

% dvd_minus_iff
tff(fact_1673_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,uminus_uminus(A),X2)),Y2)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X2),Y2) ) ) ).

% minus_dvd_iff
tff(fact_1674_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,B2)) ) ) ).

% mod_minus_minus
tff(fact_1675_real__add__minus__iff,axiom,
    ! [X2: real,A2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,uminus_uminus(real),A2)) = zero_zero(real) )
    <=> ( X2 = A2 ) ) ).

% real_add_minus_iff
tff(fact_1676_idiff__enat__0__right,axiom,
    ! [Nb: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Nb),extended_enat2(zero_zero(nat))) = Nb ) ).

% idiff_enat_0_right
tff(fact_1677_idiff__enat__0,axiom,
    ! [Nb: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(zero_zero(nat))),Nb) = extended_enat2(zero_zero(nat)) ) ).

% idiff_enat_0
tff(fact_1678_idiff__enat__enat,axiom,
    ! [A2: nat,B2: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(A2)),extended_enat2(B2)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2)) ) ).

% idiff_enat_enat
tff(fact_1679_idiff__self,axiom,
    ! [Nb: extended_enat] :
      ( ( Nb != extend4730790105801354508finity(extended_enat) )
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Nb),Nb) = zero_zero(extended_enat) ) ) ).

% idiff_self
tff(fact_1680_add__diff__cancel__enat,axiom,
    ! [X2: extended_enat,Y2: extended_enat] :
      ( ( X2 != extend4730790105801354508finity(extended_enat) )
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X2),Y2)),X2) = Y2 ) ) ).

% add_diff_cancel_enat
tff(fact_1681_triangle__0,axiom,
    nat_triangle(zero_zero(nat)) = zero_zero(nat) ).

% triangle_0
tff(fact_1682_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% neg_less_eq_nonneg
tff(fact_1683_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% less_eq_neg_nonpos
tff(fact_1684_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% neg_le_0_iff_le
tff(fact_1685_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% neg_0_le_iff_le
tff(fact_1686_less__neg__neg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% less_neg_neg
tff(fact_1687_neg__less__pos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% neg_less_pos
tff(fact_1688_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% neg_0_less_iff_less
tff(fact_1689_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% neg_less_0_iff_less
tff(fact_1690_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),A2)) = zero_zero(A) ) ) ).

% add.right_inverse
tff(fact_1691_ab__left__minus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),A2) = zero_zero(A) ) ) ).

% ab_left_minus
tff(fact_1692_verit__minus__simplify_I3_J,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),B2) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% verit_minus_simplify(3)
tff(fact_1693_diff__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ).

% diff_0
tff(fact_1694_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb))) ) ) ).

% add_neg_numeral_simps(3)
tff(fact_1695_mult__minus1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),one_one(A))),Z) = aa(A,A,uminus_uminus(A),Z) ) ) ).

% mult_minus1
tff(fact_1696_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),Z) ) ) ).

% mult_minus1_right
tff(fact_1697_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) ) ) ).

% uminus_add_conv_diff
tff(fact_1698_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) ) ) ).

% diff_minus_eq_add
tff(fact_1699_div__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),A2) ) ) ).

% div_minus1_right
tff(fact_1700_divide__minus1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),X2) ) ) ).

% divide_minus1
tff(fact_1701_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2) ) ) ).

% minus_mod_self1
tff(fact_1702_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% signed_take_bit_of_minus_1
tff(fact_1703_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),one_one(int)))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ).

% zle_diff1_eq
tff(fact_1704_idiff__infinity__right,axiom,
    ! [A2: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(A2)),extend4730790105801354508finity(extended_enat)) = zero_zero(extended_enat) ) ).

% idiff_infinity_right
tff(fact_1705_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_simps(1)
tff(fact_1706_triangle__Suc,axiom,
    ! [Nb: nat] : ( nat_triangle(aa(nat,nat,suc,Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(Nb)),aa(nat,nat,suc,Nb)) ) ).

% triangle_Suc
tff(fact_1707_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = zero_zero(A) ) ) ).

% add_neg_numeral_special(8)
tff(fact_1708_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% add_neg_numeral_special(7)
tff(fact_1709_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% diff_numeral_special(12)
tff(fact_1710_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Nb: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( Nb = one2 ) ) ) ).

% numeral_eq_neg_one_iff
tff(fact_1711_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Nb: num] :
          ( ( aa(A,A,uminus_uminus(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)) )
        <=> ( Nb = one2 ) ) ) ).

% neg_one_eq_numeral_iff
tff(fact_1712_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)),A2)) = A2 ) ) ).

% left_minus_one_mult_self
tff(fact_1713_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)) = one_one(A) ) ) ).

% minus_one_mult_self
tff(fact_1714_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% mod_minus1_right
tff(fact_1715_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),W)))),Y2) ) ) ).

% semiring_norm(168)
tff(fact_1716_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(num,A,numeral_numeral(A),Nb)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb))) ) ) ).

% diff_numeral_simps(3)
tff(fact_1717_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb)) ) ) ).

% diff_numeral_simps(2)
tff(fact_1718_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W))),Y2) ) ) ).

% semiring_norm(172)
tff(fact_1719_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W)))),Y2) ) ) ).

% semiring_norm(171)
tff(fact_1720_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Y2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W)))),Y2) ) ) ).

% semiring_norm(170)
tff(fact_1721_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),Ma),Nb))) ) ) ).

% mult_neg_numeral_simps(3)
tff(fact_1722_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(num,A,numeral_numeral(A),Nb)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),Ma),Nb))) ) ) ).

% mult_neg_numeral_simps(2)
tff(fact_1723_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),Ma),Nb)) ) ) ).

% mult_neg_numeral_simps(1)
tff(fact_1724_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num,Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Nb),Ma) ) ) ).

% neg_numeral_le_iff
tff(fact_1725_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num,Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Nb),Ma) ) ) ).

% neg_numeral_less_iff
tff(fact_1726_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma)))
        <=> ( Ma != one2 ) ) ) ).

% not_neg_one_le_neg_numeral_iff
tff(fact_1727_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ).

% le_divide_eq_numeral1(2)
tff(fact_1728_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),B2) ) ) ).

% divide_le_eq_numeral1(2)
tff(fact_1729_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,W: num] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) )
        <=> $ite(aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral1(2)
tff(fact_1730_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W: num,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = A2 )
        <=> $ite(aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral1(2)
tff(fact_1731_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),one_one(A)))
        <=> ( Ma != one2 ) ) ) ).

% neg_numeral_less_neg_one_iff
tff(fact_1732_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ).

% less_divide_eq_numeral1(2)
tff(fact_1733_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),B2) ) ) ).

% divide_less_eq_numeral1(2)
tff(fact_1734_power2__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% power2_minus
tff(fact_1735_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% add_neg_numeral_special(9)
tff(fact_1736_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% diff_numeral_special(10)
tff(fact_1737_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% diff_numeral_special(11)
tff(fact_1738_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% minus_1_div_2_eq
tff(fact_1739_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% bits_minus_1_mod_2_eq
tff(fact_1740_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% minus_1_mod_2_eq
tff(fact_1741_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) = aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ) ).

% Power.ring_1_class.power_minus_even
tff(fact_1742_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),Nb) = aa(nat,A,power_power(A,A2),Nb) ) ) ) ).

% Parity.ring_1_class.power_minus_even
tff(fact_1743_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: nat,A2: A] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),Nb) = aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,A2),Nb)) ) ) ) ).

% power_minus_odd
tff(fact_1744_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),one2))) ) ) ).

% diff_numeral_special(4)
tff(fact_1745_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Nb)) ) ) ).

% diff_numeral_special(3)
tff(fact_1746_signed__take__bit__Suc__minus__bit0,axiom,
    ! [Nb: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,Nb)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% signed_take_bit_Suc_minus_bit0
tff(fact_1747_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% dbl_simps(4)
tff(fact_1748_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) = one_one(A) ) ) ).

% power_minus1_even
tff(fact_1749_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb) = one_one(A) ) ) ) ).

% neg_one_even_power
tff(fact_1750_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: nat] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% neg_one_odd_power
tff(fact_1751_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,zero_zero(nat)),A2) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% signed_take_bit_0
tff(fact_1752_minus__real__def,axiom,
    ! [X2: real,Y2: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,uminus_uminus(real),Y2)) ) ).

% minus_real_def
tff(fact_1753_unique__quotient,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R4: int] :
      ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R))
     => ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q5),R4))
       => ( Q2 = Q5 ) ) ) ).

% unique_quotient
tff(fact_1754_unique__remainder,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R4: int] :
      ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R))
     => ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q5),R4))
       => ( R = R4 ) ) ) ).

% unique_remainder
tff(fact_1755_minus__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),zero_zero(int)),L) = aa(int,int,uminus_uminus(int),L) ) ).

% minus_int_code(2)
tff(fact_1756_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
     => ? [B3: A] : aa(set(A),$o,member(A,B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B4),A3)) ) ).

% psubset_imp_ex_mem
tff(fact_1757_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
         => ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,uminus_uminus(A),B2) ) ) ) ).

% verit_negate_coefficient(3)
tff(fact_1758_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% equation_minus_iff
tff(fact_1759_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = B2 )
        <=> ( aa(A,A,uminus_uminus(A),B2) = A2 ) ) ) ).

% minus_equation_iff
tff(fact_1760_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R))
     => ( ( B2 != zero_zero(int) )
       => eucl_rel_int(aa(int,int,uminus_uminus(int),A2),B2,
            aa(int,product_prod(int,int),
              aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),$ite(R = zero_zero(int),aa(int,int,uminus_uminus(int),Q2),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),Q2)),one_one(int)))),
              $ite(R = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),R)))) ) ) ).

% zminus1_lemma
tff(fact_1761_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( modulo_modulo(int,A2,aa(int,int,uminus_uminus(int),B2))
      = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),modulo_modulo(int,A2,B2)),B2)) ) ).

% zmod_zminus2_eq_if
tff(fact_1762_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( modulo_modulo(int,aa(int,int,uminus_uminus(int),A2),B2)
      = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),modulo_modulo(int,A2,B2))) ) ).

% zmod_zminus1_eq_if
tff(fact_1763_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% le_minus_iff
tff(fact_1764_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),A2) ) ) ).

% minus_le_iff
tff(fact_1765_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% le_imp_neg_le
tff(fact_1766_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),A2) ) ) ).

% minus_less_iff
tff(fact_1767_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% less_minus_iff
tff(fact_1768_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% verit_negate_coefficient(2)
tff(fact_1769_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Ma: num,Nb: num] : ( aa(num,A,numeral_numeral(A),Ma) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)) ) ) ).

% numeral_neq_neg_numeral
tff(fact_1770_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma)) != aa(num,A,numeral_numeral(A),Nb) ) ) ).

% neg_numeral_neq_numeral
tff(fact_1771_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_mult_commute
tff(fact_1772_square__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),B2) )
        <=> ( ( A2 = B2 )
            | ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% square_eq_iff
tff(fact_1773_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( one_one(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% one_neq_neg_one
tff(fact_1774_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% add.inverse_distrib_swap
tff(fact_1775_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,K: A,A2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,uminus_uminus(A),A2)) ) ) ) ).

% group_cancel.neg1
tff(fact_1776_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% is_num_normalize(8)
tff(fact_1777_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ).

% minus_diff_minus
tff(fact_1778_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),B2)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% minus_diff_commute
tff(fact_1779_div__minus__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% div_minus_right
tff(fact_1780_minus__divide__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% minus_divide_left
tff(fact_1781_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ).

% minus_divide_divide
tff(fact_1782_minus__divide__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_divide_right
tff(fact_1783_minus__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),K),zero_zero(int)) = K ) ).

% minus_int_code(1)
tff(fact_1784_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,B2)),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2) ) ) ).

% mod_minus_eq
tff(fact_1785_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A,A5: A] :
          ( ( modulo_modulo(A,A2,B2) = modulo_modulo(A,A5,B2) )
         => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A5),B2) ) ) ) ).

% mod_minus_cong
tff(fact_1786_mod__minus__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,A2,aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2)) ) ) ).

% mod_minus_right
tff(fact_1787_uminus__int__code_I1_J,axiom,
    aa(int,int,uminus_uminus(int),zero_zero(int)) = zero_zero(int) ).

% uminus_int_code(1)
tff(fact_1788_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),W),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z1),Z22)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z1)),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z22)) ) ).

% int_distrib(4)
tff(fact_1789_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z1),Z22)),W) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Z1),W)),aa(int,int,aa(int,fun(int,int),times_times(int),Z22),W)) ) ).

% int_distrib(3)
tff(fact_1790_signed__take__bit__diff,axiom,
    ! [Nb: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)) ) ).

% signed_take_bit_diff
tff(fact_1791_signed__take__bit__minus,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,uminus_uminus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,uminus_uminus(int),K)) ) ).

% signed_take_bit_minus
tff(fact_1792_eucl__rel__int__by0,axiom,
    ! [K: int] : eucl_rel_int(K,zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),K)) ).

% eucl_rel_int_by0
tff(fact_1793_div__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = Q2 ) ) ).

% div_int_unique
tff(fact_1794_mod__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R))
     => ( modulo_modulo(int,K,L) = R ) ) ).

% mod_int_unique
tff(fact_1795_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L)
     => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),K),L) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),L),one_one(int))),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)),L)) ) ) ).

% minus_mod_int_eq
tff(fact_1796_zmod__minus1,axiom,
    ! [B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),one_one(int)),B2) = aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),one_one(int)) ) ) ).

% zmod_minus1
tff(fact_1797_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num,Nb: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) ) ).

% not_numeral_le_neg_numeral
tff(fact_1798_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num,Nb: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(num,A,numeral_numeral(A),Nb)) ) ).

% neg_numeral_le_numeral
tff(fact_1799_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Nb: num] : ( zero_zero(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)) ) ) ).

% zero_neq_neg_numeral
tff(fact_1800_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num,Nb: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(num,A,numeral_numeral(A),Nb)) ) ).

% neg_numeral_less_numeral
tff(fact_1801_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num,Nb: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) ) ).

% not_numeral_less_neg_numeral
tff(fact_1802_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% le_minus_one_simps(4)
tff(fact_1803_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) ) ).

% le_minus_one_simps(2)
tff(fact_1804_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( zero_zero(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% zero_neq_neg_one
tff(fact_1805_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% add_eq_0_iff
tff(fact_1806_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),A2) = zero_zero(A) ) ) ).

% ab_group_add_class.ab_left_minus
tff(fact_1807_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),A2) = B2 ) ) ) ).

% add.inverse_unique
tff(fact_1808_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) ) ) ) ).

% eq_neg_iff_add_eq_0
tff(fact_1809_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) ) ) ) ).

% neg_eq_iff_add_eq_0
tff(fact_1810_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% less_minus_one_simps(4)
tff(fact_1811_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) ) ).

% less_minus_one_simps(2)
tff(fact_1812_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [W: num,X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,uminus_uminus(A),X2)) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) ) ).

% numeral_times_minus_swap
tff(fact_1813_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_minus_divide_divide
tff(fact_1814_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% nonzero_minus_divide_right
tff(fact_1815_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Nb: num] : ( aa(num,A,numeral_numeral(A),Nb) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% numeral_neq_neg_one
tff(fact_1816_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Nb: num] : ( one_one(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)) ) ) ).

% one_neq_neg_numeral
tff(fact_1817_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [X2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),X2) = one_one(A) )
        <=> ( ( X2 = one_one(A) )
            | ( X2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% square_eq_1_iff
tff(fact_1818_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2 != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),A2)),B2)
        = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))),one_one(int))) ) ) ).

% zdiv_zminus1_eq_if
tff(fact_1819_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2 != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),aa(int,int,uminus_uminus(int),B2))
        = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))),one_one(int))) ) ) ).

% zdiv_zminus2_eq_if
tff(fact_1820_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
tff(fact_1821_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% diff_conv_add_uminus
tff(fact_1822_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B4: A,K: A,B2: A,A2: A] :
          ( ( B4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% group_cancel.sub2
tff(fact_1823_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% dvd_div_neg
tff(fact_1824_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% dvd_neg_div
tff(fact_1825_real__minus__mult__self__le,axiom,
    ! [U: real,X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),U),U))),aa(real,real,aa(real,fun(real,real),times_times(real),X2),X2)) ).

% real_minus_mult_self_le
tff(fact_1826_int__less__induct,axiom,
    ! [I3: int,K: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I3),K)
     => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)))
       => ( ! [I2: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),K)
             => ( aa(int,$o,P,I2)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I2),one_one(int))) ) )
         => aa(int,$o,P,I3) ) ) ) ).

% int_less_induct
tff(fact_1827_zmult__eq__1__iff,axiom,
    ! [Ma: int,Nb: int] :
      ( ( aa(int,int,aa(int,fun(int,int),times_times(int),Ma),Nb) = one_one(int) )
    <=> ( ( ( Ma = one_one(int) )
          & ( Nb = one_one(int) ) )
        | ( ( Ma = aa(int,int,uminus_uminus(int),one_one(int)) )
          & ( Nb = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ) ).

% zmult_eq_1_iff
tff(fact_1828_pos__zmult__eq__1__iff__lemma,axiom,
    ! [Ma: int,Nb: int] :
      ( ( aa(int,int,aa(int,fun(int,int),times_times(int),Ma),Nb) = one_one(int) )
     => ( ( Ma = one_one(int) )
        | ( Ma = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
tff(fact_1829_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo(int,K,aa(int,int,uminus_uminus(int),L)) != zero_zero(int) )
     => ( modulo_modulo(int,K,L) != zero_zero(int) ) ) ).

% zmod_zminus2_not_zero
tff(fact_1830_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo(int,aa(int,int,uminus_uminus(int),K),L) != zero_zero(int) )
     => ( modulo_modulo(int,K,L) != zero_zero(int) ) ) ).

% zmod_zminus1_not_zero
tff(fact_1831_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y2: extended_enat,X2: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Z),Y2)
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X2),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Y2),Z)) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X2),Y2)),Z) ) ) ).

% add_diff_assoc_enat
tff(fact_1832_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))),zero_zero(A)) ) ).

% neg_numeral_le_zero
tff(fact_1833_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) ) ).

% not_zero_le_neg_numeral
tff(fact_1834_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) ) ).

% not_zero_less_neg_numeral
tff(fact_1835_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))),zero_zero(A)) ) ).

% neg_numeral_less_zero
tff(fact_1836_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A)) ) ).

% le_minus_one_simps(1)
tff(fact_1837_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% le_minus_one_simps(3)
tff(fact_1838_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A)) ) ).

% less_minus_one_simps(1)
tff(fact_1839_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% less_minus_one_simps(3)
tff(fact_1840_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),one_one(A)) ) ).

% neg_numeral_le_one
tff(fact_1841_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),Ma)) ) ).

% neg_one_le_numeral
tff(fact_1842_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% neg_numeral_le_neg_one
tff(fact_1843_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_numeral_le_neg_one
tff(fact_1844_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))) ) ).

% not_one_le_neg_numeral
tff(fact_1845_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))) ) ).

% not_neg_one_less_neg_numeral
tff(fact_1846_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))) ) ).

% not_one_less_neg_numeral
tff(fact_1847_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_numeral_less_neg_one
tff(fact_1848_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),Ma)) ) ).

% neg_one_less_numeral
tff(fact_1849_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),one_one(A)) ) ).

% neg_numeral_less_one
tff(fact_1850_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( C2 = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
tff(fact_1851_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = C2 )
          <=> ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
tff(fact_1852_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = A2 )
        <=> $ite(C2 != zero_zero(A),aa(A,A,uminus_uminus(A),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),A2 = zero_zero(A)) ) ) ).

% minus_divide_eq_eq
tff(fact_1853_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,uminus_uminus(A),B2),A2 = zero_zero(A)) ) ) ).

% eq_minus_divide_eq
tff(fact_1854_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% divide_eq_minus_1_iff
tff(fact_1855_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))),B2) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(1)
tff(fact_1856_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(2)
tff(fact_1857_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% uminus_numeral_One
tff(fact_1858_power__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),Nb) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% power_minus
tff(fact_1859_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: A,K: num] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,K))) = aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,K))) ) ) ).

% power_minus_Bit0
tff(fact_1860_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q2: int] :
      ( ( L != zero_zero(int) )
     => ( ( K = aa(int,int,aa(int,fun(int,int),times_times(int),Q2),L) )
       => eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),zero_zero(int))) ) ) ).

% eucl_rel_int_dividesI
tff(fact_1861_real__add__less__0__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,uminus_uminus(real),X2)) ) ).

% real_add_less_0_iff
tff(fact_1862_real__0__less__add__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),X2)),Y2) ) ).

% real_0_less_add_iff
tff(fact_1863_real__add__le__0__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,uminus_uminus(real),X2)) ) ).

% real_add_le_0_iff
tff(fact_1864_real__0__le__add__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),X2)),Y2) ) ).

% real_0_le_add_iff
tff(fact_1865_plusinfinity,axiom,
    ! [D2: int,P3: fun(int,$o),P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X4: int,K2: int] :
            ( aa(int,$o,P3,X4)
          <=> aa(int,$o,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2))) )
       => ( ? [Z3: int] :
            ! [X4: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z3),X4)
             => ( aa(int,$o,P,X4)
              <=> aa(int,$o,P3,X4) ) )
         => ( ? [X_1: int] : aa(int,$o,P3,X_1)
           => ? [X_13: int] : aa(int,$o,P,X_13) ) ) ) ) ).

% plusinfinity
tff(fact_1866_minusinfinity,axiom,
    ! [D2: int,P1: fun(int,$o),P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X4: int,K2: int] :
            ( aa(int,$o,P1,X4)
          <=> aa(int,$o,P1,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2))) )
       => ( ? [Z3: int] :
            ! [X4: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X4),Z3)
             => ( aa(int,$o,P,X4)
              <=> aa(int,$o,P1,X4) ) )
         => ( ? [X_1: int] : aa(int,$o,P1,X_1)
           => ? [X_13: int] : aa(int,$o,P,X_13) ) ) ) ) ).

% minusinfinity
tff(fact_1867_eucl__rel__int,axiom,
    ! [K: int,L: int] : eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L)),modulo_modulo(int,K,L))) ).

% eucl_rel_int
tff(fact_1868_psubsetD,axiom,
    ! [A: $tType,A3: set(A),B4: set(A),C2: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
     => ( aa(set(A),$o,member(A,C2),A3)
       => aa(set(A),$o,member(A,C2),B4) ) ) ).

% psubsetD
tff(fact_1869_psubset__trans,axiom,
    ! [A: $tType,A3: set(A),B4: set(A),C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),B4),C6)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),C6) ) ) ).

% psubset_trans
tff(fact_1870_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_minus_divide_less_eq
tff(fact_1871_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_less_minus_divide_eq
tff(fact_1872_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divide_less_eq
tff(fact_1873_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_less_minus_divide_eq
tff(fact_1874_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)) ) ) ) ).

% minus_divide_less_eq
tff(fact_1875_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))) ) ) ) ).

% less_minus_divide_eq
tff(fact_1876_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num,B2: A,C2: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2) = B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral(2)
tff(fact_1877_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W: num] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral(2)
tff(fact_1878_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z))),Y2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z))),Z) ) ) ) ).

% minus_divide_add_eq_iff
tff(fact_1879_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Z))),B2)
          = $ite(Z = zero_zero(A),B2,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z)) ) ) ).

% add_divide_eq_if_simps(3)
tff(fact_1880_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Z))),Y2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),Z))),Z) ) ) ) ).

% minus_divide_diff_eq_iff
tff(fact_1881_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Z)),B2)
          = $ite(Z = zero_zero(A),aa(A,A,uminus_uminus(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z)) ) ) ).

% add_divide_eq_if_simps(5)
tff(fact_1882_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Z))),B2)
          = $ite(Z = zero_zero(A),aa(A,A,uminus_uminus(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z)) ) ) ).

% add_divide_eq_if_simps(6)
tff(fact_1883_even__minus,axiom,
    ! [A: $tType] :
      ( ring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_minus
tff(fact_1884_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
        <=> ( ( X2 = Y2 )
            | ( X2 = aa(A,A,uminus_uminus(A),Y2) ) ) ) ) ).

% power2_eq_iff
tff(fact_1885_decr__mult__lemma,axiom,
    ! [D2: int,P: fun(int,$o),K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X4: int] :
            ( aa(int,$o,P,X4)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D2)) )
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
         => ! [X: int] :
              ( aa(int,$o,P,X)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K),D2))) ) ) ) ) ).

% decr_mult_lemma
tff(fact_1886_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
       => ( modulo_modulo(int,K,L) = modulo_modulo(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L),L) ) ) ) ).

% mod_pos_geq
tff(fact_1887_verit__less__mono__div__int2,axiom,
    ! [A3: int,B4: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A3),B4)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,uminus_uminus(int),Nb))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),B4),Nb)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),Nb)) ) ) ).

% verit_less_mono_div_int2
tff(fact_1888_div__eq__minus1,axiom,
    ! [B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),B2) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ).

% div_eq_minus1
tff(fact_1889_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B2),zero_zero(int))
     => ( eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),A2),one_one(int)),B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),R)),one_one(int)))) ) ) ).

% neg_eucl_rel_int_mult_2
tff(fact_1890_less__eq__set__def,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
    <=> aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),B4)) ) ).

% less_eq_set_def
tff(fact_1891_Collect__subset,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))),A3) ).

% Collect_subset
tff(fact_1892_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))) ) ) ) ).

% le_minus_divide_eq
tff(fact_1893_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)) ) ) ) ).

% minus_divide_le_eq
tff(fact_1894_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_le_minus_divide_eq
tff(fact_1895_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divide_le_eq
tff(fact_1896_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_le_minus_divide_eq
tff(fact_1897_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_minus_divide_le_eq
tff(fact_1898_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ) ).

% divide_less_eq_numeral(2)
tff(fact_1899_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),zero_zero(A))) ) ) ) ).

% less_divide_eq_numeral(2)
tff(fact_1900_less__set__def,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
    <=> aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),B4)) ) ).

% less_set_def
tff(fact_1901_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A2: A] :
          ( ( aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
        <=> ( ( A2 = one_one(A) )
            | ( A2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% power2_eq_1_iff
tff(fact_1902_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),Nb)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb),aa(nat,A,power_power(A,A2),Nb),aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,A2),Nb))) ) ) ).

% uminus_power_if
tff(fact_1903_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K)) = aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
tff(fact_1904_realpow__square__minus__le,axiom,
    ! [U: real,X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(nat,real,power_power(real,U),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ).

% realpow_square_minus_le
tff(fact_1905_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_diff_iff
tff(fact_1906_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),zero_zero(A))) ) ) ) ).

% le_divide_eq_numeral(2)
tff(fact_1907_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ) ).

% divide_le_eq_numeral(2)
tff(fact_1908_square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)) ) ) ) ).

% square_le_1
tff(fact_1909_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A2: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),Nb)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),Nb)) = aa(nat,A,power_power(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ) ).

% minus_power_mult_self
tff(fact_1910_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: nat] :
          ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb),one_one(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ).

% minus_one_power_iff
tff(fact_1911_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)),L)),one_one(int)) ) ) ) ).

% div_pos_geq
tff(fact_1912_diff__enat__def,axiom,
    ! [A2: extended_enat,B2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),A2),B2) = extended_case_enat(extended_enat,aTP_Lamp_au(extended_enat,fun(nat,extended_enat),B2),extend4730790105801354508finity(extended_enat),A2) ) ).

% diff_enat_def
tff(fact_1913_minus__1__div__exp__eq__int,axiom,
    ! [Nb: nat] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) = aa(int,int,uminus_uminus(int),one_one(int)) ) ).

% minus_1_div_exp_eq_int
tff(fact_1914_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)),zero_zero(int))
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ).

% div_pos_neg_trivial
tff(fact_1915_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))),K) ) ).

% signed_take_bit_int_less_eq_self_iff
tff(fact_1916_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [Nb: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)) ).

% signed_take_bit_int_greater_eq_minus_exp
tff(fact_1917_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))) ) ).

% signed_take_bit_int_greater_self_iff
tff(fact_1918_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% power_minus1_odd
tff(fact_1919_psubsetE,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
     => ~ ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),A3) ) ) ).

% psubsetE
tff(fact_1920_psubset__eq,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
        & ( A3 != B4 ) ) ) ).

% psubset_eq
tff(fact_1921_psubset__imp__subset,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4) ) ).

% psubset_imp_subset
tff(fact_1922_psubset__subset__trans,axiom,
    ! [A: $tType,A3: set(A),B4: set(A),C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),C6)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),C6) ) ) ).

% psubset_subset_trans
tff(fact_1923_subset__not__subset__eq,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
        & ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),A3) ) ) ).

% subset_not_subset_eq
tff(fact_1924_subset__psubset__trans,axiom,
    ! [A: $tType,A3: set(A),B4: set(A),C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),B4),C6)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),C6) ) ) ).

% subset_psubset_trans
tff(fact_1925_subset__iff__psubset__eq,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
        | ( A3 = B4 ) ) ) ).

% subset_iff_psubset_eq
tff(fact_1926_int__bit__induct,axiom,
    ! [P: fun(int,$o),K: int] :
      ( aa(int,$o,P,zero_zero(int))
     => ( aa(int,$o,P,aa(int,int,uminus_uminus(int),one_one(int)))
       => ( ! [K2: int] :
              ( aa(int,$o,P,K2)
             => ( ( K2 != zero_zero(int) )
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),times_times(int),K2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))) ) )
         => ( ! [K2: int] :
                ( aa(int,$o,P,K2)
               => ( ( K2 != aa(int,int,uminus_uminus(int),one_one(int)) )
                 => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),K2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))) ) )
           => aa(int,$o,P,K) ) ) ) ) ).

% int_bit_induct
tff(fact_1927_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R))
    <=> ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),Q2)),R) )
        & $ite(
            aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L),
            ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R)
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),L) ),
            $ite(
              aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)),
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),R)
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R),zero_zero(int)) ),
              Q2 = zero_zero(int) ) ) ) ) ).

% eucl_rel_int_iff
tff(fact_1928_signed__take__bit__int__less__eq,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),K)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(nat,nat,suc,Nb)))) ) ).

% signed_take_bit_int_less_eq
tff(fact_1929_signed__take__bit__int__eq__self__iff,axiom,
    ! [Nb: nat,K: int] :
      ( ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K) = K )
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ) ).

% signed_take_bit_int_eq_self_iff
tff(fact_1930_signed__take__bit__int__eq__self,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))
       => ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K) = K ) ) ) ).

% signed_take_bit_int_eq_self
tff(fact_1931_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),B2),one_one(int)),A2))),one_one(int)) ) ) ).

% neg_zmod_mult_2
tff(fact_1932_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(nat,nat,suc,Nb)))),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)) ) ).

% signed_take_bit_int_greater_eq
tff(fact_1933_real__average__minus__first,axiom,
    ! [A2: real,B2: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),A2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ).

% real_average_minus_first
tff(fact_1934_real__average__minus__second,axiom,
    ! [B2: real,A2: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),B2),A2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),A2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ).

% real_average_minus_second
tff(fact_1935_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( product_product(A,B,aa(list(A),set(A),set2(A),Xs),aa(list(B),set(B),set2(B),Ys)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),concat(product_prod(A,B),aa(list(A),list(list(product_prod(A,B))),map(A,list(product_prod(A,B)),aTP_Lamp_ar(list(B),fun(A,list(product_prod(A,B))),Ys)),Xs))) ) ).

% product_code
tff(fact_1936_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ).

% compl_less_compl_iff
tff(fact_1937_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ vEBT_VEBT_membermima(X2,Xa2)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2 = vEBT_Leaf(Uu2,Uv2) )
             => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(Uu2,Uv2)),Xa2)) )
         => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Xa2)) )
           => ( ! [Mi: nat,Ma2: nat,Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
                  ( ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
                 => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2)),Xa2))
                   => ( ( Xa2 = Mi )
                      | ( Xa2 = Ma2 ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList: list(vEBT_VEBT),Vc2: vEBT_VEBT] :
                    ( ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2) )
                   => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2)),Xa2))
                     => ( ( Xa2 = Mi )
                        | ( Xa2 = Ma2 )
                        | $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) )
               => ~ ! [V3: nat,TreeList: list(vEBT_VEBT),Vd2: vEBT_VEBT] :
                      ( ( X2 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2) )
                     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2)),Xa2))
                       => $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
tff(fact_1938_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( vEBT_VEBT_membermima(X2,Xa2)
      <=> (Y2) )
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2 = vEBT_Leaf(Uu2,Uv2) )
             => ( ~ (Y2)
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(Uu2,Uv2)),Xa2)) ) )
         => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
               => ( ~ (Y2)
                 => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Xa2)) ) )
           => ( ! [Mi: nat,Ma2: nat,Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
                  ( ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
                 => ( ( (Y2)
                    <=> ( ( Xa2 = Mi )
                        | ( Xa2 = Ma2 ) ) )
                   => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2)),Xa2)) ) )
             => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList: list(vEBT_VEBT),Vc2: vEBT_VEBT] :
                    ( ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2) )
                   => ( ( (Y2)
                      <=> ( ( Xa2 = Mi )
                          | ( Xa2 = Ma2 )
                          | $let(
                              pos: nat,
                              pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                              $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) )
                     => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2)),Xa2)) ) )
               => ~ ! [V3: nat,TreeList: list(vEBT_VEBT),Vd2: vEBT_VEBT] :
                      ( ( X2 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2) )
                     => ( ( (Y2)
                        <=> $let(
                              pos: nat,
                              pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                              $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) )
                       => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2)),Xa2)) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
tff(fact_1939_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R: int] : ( adjust_div(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Q2),aa($o,int,zero_neq_one_of_bool(int),( R != zero_zero(int) ))) ) ).

% Divides.adjust_div_eq
tff(fact_1940_minus__set__def,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4) = aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aa(fun(A,$o),fun(fun(A,$o),fun(A,$o)),minus_minus(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),B4))) ) ).

% minus_set_def
tff(fact_1941_set__diff__eq,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4) = aa(fun(A,$o),set(A),collect(A),aa(set(A),fun(A,$o),aTP_Lamp_av(set(A),fun(set(A),fun(A,$o)),A3),B4)) ) ).

% set_diff_eq
tff(fact_1942_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [C2: A] : ( aTP_Lamp_aw(A,fun(A,A),C2) = aa(A,fun(A,A),times_times(A),C2) ) ) ).

% mult_commute_abs
tff(fact_1943_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),aa(A,A,uminus_uminus(A),X2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,uminus_uminus(A),Y2)) ) ) ).

% compl_less_swap1
tff(fact_1944_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),Y2)),X2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),X2)),Y2) ) ) ).

% compl_less_swap2
tff(fact_1945_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( vEBT_VEBT_membermima(X2,Xa2)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [Mi: nat,Ma2: nat,Va3: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
              ( ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),zero_zero(nat),Va3,Vb2)),Xa2))
               => ~ ( ( Xa2 = Mi )
                    | ( Xa2 = Ma2 ) ) ) )
         => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList: list(vEBT_VEBT),Vc2: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2) )
               => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(aa(product_prod(nat,nat),option(product_prod(nat,nat)),some(product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Mi),Ma2)),aa(nat,nat,suc,V3),TreeList,Vc2)),Xa2))
                 => ~ ( ( Xa2 = Mi )
                      | ( Xa2 = Ma2 )
                      | $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) )
           => ~ ! [V3: nat,TreeList: list(vEBT_VEBT),Vd2: vEBT_VEBT] :
                  ( ( X2 = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2) )
                 => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V3),TreeList,Vd2)),Xa2))
                   => ~ $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
tff(fact_1946_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( vEBT_V5719532721284313246member(X2,Xa2)
      <=> (Y2) )
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [A4: $o,B3: $o] :
              ( ( X2 = vEBT_Leaf(A4,B3) )
             => ( ( (Y2)
                <=> $ite(
                      Xa2 = zero_zero(nat),
                      (A4),
                      $ite(Xa2 = one_one(nat),(B3),$false) ) )
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(A4,B3)),Xa2)) ) )
         => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
               => ( ~ (Y2)
                 => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Xa2)) ) )
           => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList: list(vEBT_VEBT),S2: vEBT_VEBT] :
                  ( ( X2 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2) )
                 => ( ( (Y2)
                    <=> $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) )
                   => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2)),Xa2)) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
tff(fact_1947_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( vEBT_V5719532721284313246member(X2,Xa2)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [A4: $o,B3: $o] :
              ( ( X2 = vEBT_Leaf(A4,B3) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(A4,B3)),Xa2))
               => ~ $ite(
                      Xa2 = zero_zero(nat),
                      (A4),
                      $ite(Xa2 = one_one(nat),(B3),$false) ) ) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList: list(vEBT_VEBT),S2: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2) )
               => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2)),Xa2))
                 => ~ $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
tff(fact_1948_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ vEBT_V5719532721284313246member(X2,Xa2)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [A4: $o,B3: $o] :
              ( ( X2 = vEBT_Leaf(A4,B3) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(A4,B3)),Xa2))
               => $ite(
                    Xa2 = zero_zero(nat),
                    (A4),
                    $ite(Xa2 = one_one(nat),(B3),$false) ) ) )
         => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Xa2)) )
           => ~ ! [Uy2: option(product_prod(nat,nat)),V3: nat,TreeList: list(vEBT_VEBT),S2: vEBT_VEBT] :
                  ( ( X2 = vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2) )
                 => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Uy2,aa(nat,nat,suc,V3),TreeList,S2)),Xa2))
                   => $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xa2,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
tff(fact_1949_Bolzano,axiom,
    ! [A2: real,B2: real,P: fun(real,fun(real,$o))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [A4: real,B3: real,C3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),P,A4),B3)
           => ( aa(real,$o,aa(real,fun(real,$o),P,B3),C3)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A4),B3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B3),C3)
                 => aa(real,$o,aa(real,fun(real,$o),P,A4),C3) ) ) ) )
       => ( ! [X4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2)
               => ? [D6: real] :
                    ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                    & ! [A4: real,B3: real] :
                        ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A4),X4)
                          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B3)
                          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B3),A4)),D6) )
                       => aa(real,$o,aa(real,fun(real,$o),P,A4),B3) ) ) ) )
         => aa(real,$o,aa(real,fun(real,$o),P,A2),B2) ) ) ) ).

% Bolzano
tff(fact_1950_signed__take__bit__Suc__minus__bit1,axiom,
    ! [Nb: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,Nb)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% signed_take_bit_Suc_minus_bit1
tff(fact_1951_semiring__norm_I90_J,axiom,
    ! [Ma: num,Nb: num] :
      ( ( aa(num,num,bit1,Ma) = aa(num,num,bit1,Nb) )
    <=> ( Ma = Nb ) ) ).

% semiring_norm(90)
tff(fact_1952_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( aa(num,num,bit1,X32) = aa(num,num,bit1,Y32) )
    <=> ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
tff(fact_1953_semiring__norm_I88_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,bit0,Ma) != aa(num,num,bit1,Nb) ) ).

% semiring_norm(88)
tff(fact_1954_semiring__norm_I89_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,bit1,Ma) != aa(num,num,bit0,Nb) ) ).

% semiring_norm(89)
tff(fact_1955_semiring__norm_I84_J,axiom,
    ! [Nb: num] : ( one2 != aa(num,num,bit1,Nb) ) ).

% semiring_norm(84)
tff(fact_1956_semiring__norm_I86_J,axiom,
    ! [Ma: num] : ( aa(num,num,bit1,Ma) != one2 ) ).

% semiring_norm(86)
tff(fact_1957_semiring__norm_I73_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,Ma)),aa(num,num,bit1,Nb))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Ma),Nb) ) ).

% semiring_norm(73)
tff(fact_1958_semiring__norm_I80_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit1,Ma)),aa(num,num,bit1,Nb))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),Nb) ) ).

% semiring_norm(80)
tff(fact_1959_semiring__norm_I9_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,Ma)),aa(num,num,bit0,Nb)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb)) ) ).

% semiring_norm(9)
tff(fact_1960_semiring__norm_I7_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit0,Ma)),aa(num,num,bit1,Nb)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb)) ) ).

% semiring_norm(7)
tff(fact_1961_semiring__norm_I15_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,Ma)),aa(num,num,bit0,Nb)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,Ma)),Nb)) ) ).

% semiring_norm(15)
tff(fact_1962_semiring__norm_I14_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit0,Ma)),aa(num,num,bit1,Nb)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),times_times(num),Ma),aa(num,num,bit1,Nb))) ) ).

% semiring_norm(14)
tff(fact_1963_semiring__norm_I72_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit0,Ma)),aa(num,num,bit1,Nb))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Ma),Nb) ) ).

% semiring_norm(72)
tff(fact_1964_semiring__norm_I81_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit1,Ma)),aa(num,num,bit0,Nb))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),Nb) ) ).

% semiring_norm(81)
tff(fact_1965_semiring__norm_I70_J,axiom,
    ! [Ma: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,Ma)),one2) ).

% semiring_norm(70)
tff(fact_1966_semiring__norm_I77_J,axiom,
    ! [Nb: num] : aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),aa(num,num,bit1,Nb)) ).

% semiring_norm(77)
tff(fact_1967_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,V))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),W)) ) ).

% zdiv_numeral_Bit1
tff(fact_1968_semiring__norm_I3_J,axiom,
    ! [Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),aa(num,num,bit0,Nb)) = aa(num,num,bit1,Nb) ) ).

% semiring_norm(3)
tff(fact_1969_semiring__norm_I4_J,axiom,
    ! [Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),aa(num,num,bit1,Nb)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),Nb),one2)) ) ).

% semiring_norm(4)
tff(fact_1970_semiring__norm_I5_J,axiom,
    ! [Ma: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit0,Ma)),one2) = aa(num,num,bit1,Ma) ) ).

% semiring_norm(5)
tff(fact_1971_semiring__norm_I8_J,axiom,
    ! [Ma: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,Ma)),one2) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),one2)) ) ).

% semiring_norm(8)
tff(fact_1972_semiring__norm_I10_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,Ma)),aa(num,num,bit1,Nb)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb)),one2)) ) ).

% semiring_norm(10)
tff(fact_1973_semiring__norm_I16_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,Ma)),aa(num,num,bit1,Nb)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),Ma),Nb)),aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),times_times(num),Ma),Nb)))) ) ).

% semiring_norm(16)
tff(fact_1974_semiring__norm_I79_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit0,Ma)),aa(num,num,bit1,Nb))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Ma),Nb) ) ).

% semiring_norm(79)
tff(fact_1975_semiring__norm_I74_J,axiom,
    ! [Ma: num,Nb: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,Ma)),aa(num,num,bit0,Nb))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),Nb) ) ).

% semiring_norm(74)
tff(fact_1976_Suc__div__eq__add3__div__numeral,axiom,
    ! [Ma: nat,V: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Ma)))),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Ma)),aa(num,nat,numeral_numeral(nat),V)) ) ).

% Suc_div_eq_add3_div_numeral
tff(fact_1977_div__Suc__eq__div__add3,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Nb)))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Nb)) ) ).

% div_Suc_eq_div_add3
tff(fact_1978_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [Ma: nat,V: num] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Ma))),aa(num,nat,numeral_numeral(nat),V)) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Ma),aa(num,nat,numeral_numeral(nat),V)) ) ).

% Suc_mod_eq_add3_mod_numeral
tff(fact_1979_mod__Suc__eq__mod__add3,axiom,
    ! [Ma: nat,Nb: nat] : ( modulo_modulo(nat,Ma,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Nb)))) = modulo_modulo(nat,Ma,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Nb)) ) ).

% mod_Suc_eq_mod_add3
tff(fact_1980_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),aa(num,num,bit1,V)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),modulo_modulo(int,aa(num,int,numeral_numeral(int),V),aa(num,int,numeral_numeral(int),W)))),one_one(int)) ) ).

% zmod_numeral_Bit1
tff(fact_1981_signed__take__bit__Suc__bit1,axiom,
    ! [Nb: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,Nb)),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% signed_take_bit_Suc_bit1
tff(fact_1982_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] : ( aa(num,num,bit0,X22) != aa(num,num,bit1,X32) ) ).

% verit_eq_simplify(14)
tff(fact_1983_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] : ( one2 != aa(num,num,bit1,X32) ) ).

% verit_eq_simplify(12)
tff(fact_1984_num_Oexhaust,axiom,
    ! [Y2: num] :
      ( ( Y2 != one2 )
     => ( ! [X23: num] : ( Y2 != aa(num,num,bit0,X23) )
       => ~ ! [X33: num] : ( Y2 != aa(num,num,bit1,X33) ) ) ) ).

% num.exhaust
tff(fact_1985_xor__num_Ocases,axiom,
    ! [X2: product_prod(num,num)] :
      ( ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2) )
     => ( ! [N: num] : ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N)) )
       => ( ! [N: num] : ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N)) )
         => ( ! [M3: num] : ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),one2) )
           => ( ! [M3: num,N: num] : ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit0,N)) )
             => ( ! [M3: num,N: num] : ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M3)),aa(num,num,bit1,N)) )
               => ( ! [M3: num] : ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),one2) )
                 => ( ! [M3: num,N: num] : ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit0,N)) )
                   => ~ ! [M3: num,N: num] : ( X2 != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M3)),aa(num,num,bit1,N)) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
tff(fact_1986_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Nb: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Nb)),aa(num,A,numeral_numeral(A),Nb))),one_one(A)) ) ) ).

% numeral_Bit1
tff(fact_1987_eval__nat__numeral_I3_J,axiom,
    ! [Nb: num] : ( aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Nb)) = aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Nb))) ) ).

% eval_nat_numeral(3)
tff(fact_1988_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Q2: num,Nb: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Ma)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) ) ) ).

% cong_exp_iff_simps(10)
tff(fact_1989_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Q2: num,Nb: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Ma)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) ) ) ).

% cong_exp_iff_simps(12)
tff(fact_1990_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Q2: num,Nb: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Ma)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Ma),aa(num,A,numeral_numeral(A),Q2)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),Nb),aa(num,A,numeral_numeral(A),Q2)) ) ) ) ).

% cong_exp_iff_simps(13)
tff(fact_1991_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: A,K: num] : ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,K))) = aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,K)))) ) ) ).

% power_minus_Bit1
tff(fact_1992_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Nb: num] :
          ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb))
          = $let(
              m2: A,
              m2 := aa(num,A,numeral_numeral(A),Nb),
              aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),m2),m2)),one_one(A)) ) ) ) ).

% numeral_code(3)
tff(fact_1993_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z: A,W: num] :
          ( aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,W)))
          = $let(
              w: A,
              w := aa(nat,A,power_power(A,Z),aa(num,nat,numeral_numeral(nat),W)),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),w)),w) ) ) ) ).

% power_numeral_odd
tff(fact_1994_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(num,A,numeral_numeral(A),Nb) ) ) ).

% numeral_Bit1_div_2
tff(fact_1995_odd__numeral,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Nb: num] : ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb))) ) ).

% odd_numeral
tff(fact_1996_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Nb: num,Q2: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) != zero_zero(A) ) ) ).

% cong_exp_iff_simps(3)
tff(fact_1997_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)),A2) ) ) ).

% power3_eq_cube
tff(fact_1998_numeral__3__eq__3,axiom,
    aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) = aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))) ).

% numeral_3_eq_3
tff(fact_1999_Suc3__eq__add__3,axiom,
    ! [Nb: nat] : ( aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Nb))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Nb) ) ).

% Suc3_eq_add_3
tff(fact_2000_num_Osize_I6_J,axiom,
    ! [X32: num] : ( aa(num,nat,size_size(num),aa(num,num,bit1,X32)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,size_size(num),X32)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size(6)
tff(fact_2001_num_Osize__gen_I3_J,axiom,
    ! [X32: num] : ( size_num(aa(num,num,bit1,X32)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_num(X32)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size_gen(3)
tff(fact_2002_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q2: num,Nb: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Nb),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(7)
tff(fact_2003_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Q2: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Ma)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Ma),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(11)
tff(fact_2004_Suc__div__eq__add3__div,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Ma)))),Nb) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Ma)),Nb) ) ).

% Suc_div_eq_add3_div
tff(fact_2005_Suc__mod__eq__add3__mod,axiom,
    ! [Ma: nat,Nb: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Ma))),Nb) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Ma),Nb) ) ).

% Suc_mod_eq_add3_mod
tff(fact_2006_odd__mod__4__div__2,axiom,
    ! [Nb: nat] :
      ( ( modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
     => ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% odd_mod_4_div_2
tff(fact_2007_mod__exhaust__less__4,axiom,
    ! [Ma: nat] :
      ( ( modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = zero_zero(nat) )
      | ( modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = one_one(nat) )
      | ( modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
      | ( modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) ) ) ).

% mod_exhaust_less_4
tff(fact_2008_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% signed_take_bit_numeral_minus_bit1
tff(fact_2009_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))) ) ) ).

% dbl_dec_simps(4)
tff(fact_2010_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] :
          ( unique8689654367752047608divmod(A,aa(num,num,bit0,Ma),aa(num,num,bit1,Nb))
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Ma),Nb),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Ma))),unique1321980374590559556d_step(A,aa(num,num,bit1,Nb),unique8689654367752047608divmod(A,aa(num,num,bit0,Ma),aa(num,num,bit0,aa(num,num,bit1,Nb))))) ) ) ).

% divmod_algorithm_code(7)
tff(fact_2011_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] :
          ( unique8689654367752047608divmod(A,aa(num,num,bit1,Ma),aa(num,num,bit1,Nb))
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),Nb),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Ma))),unique1321980374590559556d_step(A,aa(num,num,bit1,Nb),unique8689654367752047608divmod(A,aa(num,num,bit1,Ma),aa(num,num,bit0,aa(num,num,bit1,Nb))))) ) ) ).

% divmod_algorithm_code(8)
tff(fact_2012_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% signed_take_bit_numeral_bit1
tff(fact_2013_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2)) ) ) ).

% dbl_inc_simps(3)
tff(fact_2014_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,one_one(A)) = one_one(A) ) ) ).

% dbl_dec_simps(3)
tff(fact_2015_pred__numeral__simps_I1_J,axiom,
    pred_numeral(one2) = zero_zero(nat) ).

% pred_numeral_simps(1)
tff(fact_2016_eq__numeral__Suc,axiom,
    ! [K: num,Nb: nat] :
      ( ( aa(num,nat,numeral_numeral(nat),K) = aa(nat,nat,suc,Nb) )
    <=> ( pred_numeral(K) = Nb ) ) ).

% eq_numeral_Suc
tff(fact_2017_Suc__eq__numeral,axiom,
    ! [Nb: nat,K: num] :
      ( ( aa(nat,nat,suc,Nb) = aa(num,nat,numeral_numeral(nat),K) )
    <=> ( Nb = pred_numeral(K) ) ) ).

% Suc_eq_numeral
tff(fact_2018_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,zero_zero(A)) = one_one(A) ) ) ).

% dbl_inc_simps(2)
tff(fact_2019_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_inc_simps(4)
tff(fact_2020_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_inc(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,K)) ) ) ).

% dbl_inc_simps(5)
tff(fact_2021_pred__numeral__simps_I3_J,axiom,
    ! [K: num] : ( pred_numeral(aa(num,num,bit1,K)) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,K)) ) ).

% pred_numeral_simps(3)
tff(fact_2022_less__numeral__Suc,axiom,
    ! [K: num,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pred_numeral(K)),Nb) ) ).

% less_numeral_Suc
tff(fact_2023_less__Suc__numeral,axiom,
    ! [Nb: nat,K: num] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Nb)),aa(num,nat,numeral_numeral(nat),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),pred_numeral(K)) ) ).

% less_Suc_numeral
tff(fact_2024_le__numeral__Suc,axiom,
    ! [K: num,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),pred_numeral(K)),Nb) ) ).

% le_numeral_Suc
tff(fact_2025_le__Suc__numeral,axiom,
    ! [Nb: nat,K: num] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Nb)),aa(num,nat,numeral_numeral(nat),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),pred_numeral(K)) ) ).

% le_Suc_numeral
tff(fact_2026_diff__numeral__Suc,axiom,
    ! [K: num,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),pred_numeral(K)),Nb) ) ).

% diff_numeral_Suc
tff(fact_2027_diff__Suc__numeral,axiom,
    ! [Nb: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Nb)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),pred_numeral(K)) ) ).

% diff_Suc_numeral
tff(fact_2028_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_dec_simps(2)
tff(fact_2029_numeral__div__minus__numeral,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,Ma,Nb))) ) ).

% numeral_div_minus_numeral
tff(fact_2030_minus__numeral__div__numeral,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),aa(num,int,numeral_numeral(int),Nb)) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,Ma,Nb))) ) ).

% minus_numeral_div_numeral
tff(fact_2031_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl_inc(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_dec_simps(1)
tff(fact_2032_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl_dec(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_inc_simps(1)
tff(fact_2033_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb))
        <=> unique5940410009612947441es_aux(A,unique8689654367752047608divmod(A,Nb,Ma)) ) ) ).

% dvd_numeral_simp
tff(fact_2034_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num] : ( unique8689654367752047608divmod(A,Ma,one2) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(num,A,numeral_numeral(A),Ma)),zero_zero(A)) ) ) ).

% divmod_algorithm_code(2)
tff(fact_2035_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Nb: num] : ( unique8689654367752047608divmod(A,one2,aa(num,num,bit0,Nb)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(3)
tff(fact_2036_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Nb: num] : ( unique8689654367752047608divmod(A,one2,aa(num,num,bit1,Nb)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(4)
tff(fact_2037_one__div__minus__numeral,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,one2,Nb))) ) ).

% one_div_minus_numeral
tff(fact_2038_minus__one__div__numeral,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(num,int,numeral_numeral(int),Nb)) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,one2,Nb))) ) ).

% minus_one_div_numeral
tff(fact_2039_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% signed_take_bit_numeral_bit0
tff(fact_2040_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% signed_take_bit_numeral_minus_bit0
tff(fact_2041_numeral__eq__Suc,axiom,
    ! [K: num] : ( aa(num,nat,numeral_numeral(nat),K) = aa(nat,nat,suc,pred_numeral(K)) ) ).

% numeral_eq_Suc
tff(fact_2042_pred__numeral__def,axiom,
    ! [K: num] : ( pred_numeral(K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),K)),one_one(nat)) ) ).

% pred_numeral_def
tff(fact_2043_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X2: A] : ( neg_numeral_dbl_inc(A,X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),X2)),one_one(A)) ) ) ).

% dbl_inc_def
tff(fact_2044_divmod__int__def,axiom,
    ! [Ma: num,Nb: num] : ( unique8689654367752047608divmod(int,Ma,Nb) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),Ma)),aa(num,int,numeral_numeral(int),Nb))),modulo_modulo(int,aa(num,int,numeral_numeral(int),Ma),aa(num,int,numeral_numeral(int),Nb))) ) ).

% divmod_int_def
tff(fact_2045_divmod__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] : ( unique8689654367752047608divmod(A,Ma,Nb) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb))),modulo_modulo(A,aa(num,A,numeral_numeral(A),Ma),aa(num,A,numeral_numeral(A),Nb))) ) ) ).

% divmod_def
tff(fact_2046_divmod_H__nat__def,axiom,
    ! [Ma: num,Nb: num] : ( unique8689654367752047608divmod(nat,Ma,Nb) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(num,nat,numeral_numeral(nat),Ma)),aa(num,nat,numeral_numeral(nat),Nb))),modulo_modulo(nat,aa(num,nat,numeral_numeral(nat),Ma),aa(num,nat,numeral_numeral(nat),Nb))) ) ).

% divmod'_nat_def
tff(fact_2047_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X2: A] : ( neg_numeral_dbl_dec(A,X2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),X2)),one_one(A)) ) ) ).

% dbl_dec_def
tff(fact_2048_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] :
          ( unique8689654367752047608divmod(A,Ma,Nb)
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),Nb),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),Ma)),unique1321980374590559556d_step(A,Nb,unique8689654367752047608divmod(A,Ma,aa(num,num,bit0,Nb)))) ) ) ).

% divmod_divmod_step
tff(fact_2049_vebt__buildup_Opelims,axiom,
    ! [X2: nat,Y2: vEBT_VEBT] :
      ( ( vEBT_vebt_buildup(X2) = Y2 )
     => ( accp(nat,vEBT_v4011308405150292612up_rel,X2)
       => ( ( ( X2 = zero_zero(nat) )
           => ( ( Y2 = vEBT_Leaf($false,$false) )
             => ~ accp(nat,vEBT_v4011308405150292612up_rel,zero_zero(nat)) ) )
         => ( ( ( X2 = aa(nat,nat,suc,zero_zero(nat)) )
             => ( ( Y2 = vEBT_Leaf($false,$false) )
               => ~ accp(nat,vEBT_v4011308405150292612up_rel,aa(nat,nat,suc,zero_zero(nat))) ) )
           => ~ ! [Va: nat] :
                  ( ( X2 = aa(nat,nat,suc,aa(nat,nat,suc,Va)) )
                 => ( ( Y2
                      = $ite(
                          aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va))),
                          $let(
                            half: nat,
                            half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                            vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),half),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(half)) ),
                          $let(
                            half: nat,
                            half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                            vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,half)),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(aa(nat,nat,suc,half))) ) ) )
                   => ~ accp(nat,vEBT_v4011308405150292612up_rel,aa(nat,nat,suc,aa(nat,nat,suc,Va))) ) ) ) ) ) ) ).

% vebt_buildup.pelims
tff(fact_2050_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: int] :
          ( ring_1_of_int(A,K)
          = $ite(
              K = zero_zero(int),
              zero_zero(A),
              $ite(
                aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),
                aa(A,A,uminus_uminus(A),ring_1_of_int(A,aa(int,int,uminus_uminus(int),K))),
                $let(
                  l: A,
                  l := aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),
                  $ite(modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = zero_zero(int),l,aa(A,A,aa(A,fun(A,A),plus_plus(A),l),one_one(A))) ) ) ) ) ) ).

% of_int_code_if
tff(fact_2051_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit1,Ma),aa(num,num,bit0,Nb)) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_ax(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,Ma,Nb)) ) ) ).

% divmod_algorithm_code(6)
tff(fact_2052_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less(fun(A,B)),F3),G)
        <=> ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),F3),G)
            & ~ aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),G),F3) ) ) ) ).

% less_fun_def
tff(fact_2053_set__decode__Suc,axiom,
    ! [Nb: nat,X2: nat] :
      ( aa(set(nat),$o,member(nat,aa(nat,nat,suc,Nb)),nat_set_decode(X2))
    <=> aa(set(nat),$o,member(nat,Nb),nat_set_decode(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% set_decode_Suc
tff(fact_2054_set__decode__0,axiom,
    ! [X2: nat] :
      ( aa(set(nat),$o,member(nat,zero_zero(nat)),nat_set_decode(X2))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),X2) ) ).

% set_decode_0
tff(fact_2055_set__decode__def,axiom,
    ! [X2: nat] : ( nat_set_decode(X2) = aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_ay(nat,fun(nat,$o),X2)) ) ).

% set_decode_def
tff(fact_2056_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( ring_1_of_int(A,Z) = zero_zero(A) )
        <=> ( Z = zero_zero(int) ) ) ) ).

% of_int_eq_0_iff
tff(fact_2057_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( zero_zero(A) = ring_1_of_int(A,Z) )
        <=> ( Z = zero_zero(int) ) ) ) ).

% of_int_0_eq_iff
tff(fact_2058_of__int__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( ring_1_of_int(A,zero_zero(int)) = zero_zero(A) ) ) ).

% of_int_0
tff(fact_2059_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int,Nb: num] :
          ( ( ring_1_of_int(A,Z) = aa(num,A,numeral_numeral(A),Nb) )
        <=> ( Z = aa(num,int,numeral_numeral(int),Nb) ) ) ) ).

% of_int_eq_numeral_iff
tff(fact_2060_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: num] : ( ring_1_of_int(A,aa(num,int,numeral_numeral(int),K)) = aa(num,A,numeral_numeral(A),K) ) ) ).

% of_int_numeral
tff(fact_2061_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: int,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,W)),ring_1_of_int(A,Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% of_int_less_iff
tff(fact_2062_of__int__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),times_times(int),W),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),ring_1_of_int(A,W)),ring_1_of_int(A,Z)) ) ) ).

% of_int_mult
tff(fact_2063_of__int__add,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),plus_plus(int),W),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,W)),ring_1_of_int(A,Z)) ) ) ).

% of_int_add
tff(fact_2064_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X2: int,B2: int,W: nat] :
          ( ( ring_1_of_int(A,X2) = aa(nat,A,power_power(A,ring_1_of_int(A,B2)),W) )
        <=> ( X2 = aa(nat,int,power_power(int,B2),W) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
tff(fact_2065_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [B2: int,W: nat,X2: int] :
          ( ( aa(nat,A,power_power(A,ring_1_of_int(A,B2)),W) = ring_1_of_int(A,X2) )
        <=> ( aa(nat,int,power_power(int,B2),W) = X2 ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
tff(fact_2066_of__int__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int,Nb: nat] : ( ring_1_of_int(A,aa(nat,int,power_power(int,Z),Nb)) = aa(nat,A,power_power(A,ring_1_of_int(A,Z)),Nb) ) ) ).

% of_int_power
tff(fact_2067_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,Z)),zero_zero(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int)) ) ) ).

% of_int_le_0_iff
tff(fact_2068_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),ring_1_of_int(A,Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) ) ) ).

% of_int_0_le_iff
tff(fact_2069_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),ring_1_of_int(A,Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ) ).

% of_int_0_less_iff
tff(fact_2070_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,Z)),zero_zero(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),zero_zero(int)) ) ) ).

% of_int_less_0_iff
tff(fact_2071_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Nb)),ring_1_of_int(A,Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Nb)),Z) ) ) ).

% of_int_numeral_le_iff
tff(fact_2072_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int,Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,Z)),aa(num,A,numeral_numeral(A),Nb))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),aa(num,int,numeral_numeral(int),Nb)) ) ) ).

% of_int_le_numeral_iff
tff(fact_2073_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Nb)),ring_1_of_int(A,Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),Nb)),Z) ) ) ).

% of_int_numeral_less_iff
tff(fact_2074_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int,Nb: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,Z)),aa(num,A,numeral_numeral(A),Nb))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),aa(num,int,numeral_numeral(int),Nb)) ) ) ).

% of_int_less_numeral_iff
tff(fact_2075_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),ring_1_of_int(A,Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),Z) ) ) ).

% of_int_1_less_iff
tff(fact_2076_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,Z)),one_one(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),one_one(int)) ) ) ).

% of_int_less_1_iff
tff(fact_2077_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: int,W: nat,X2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,ring_1_of_int(A,B2)),W)),ring_1_of_int(A,X2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,B2),W)),X2) ) ) ).

% of_int_le_of_int_power_cancel_iff
tff(fact_2078_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: int,B2: int,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,X2)),aa(nat,A,power_power(A,ring_1_of_int(A,B2)),W))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X2),aa(nat,int,power_power(int,B2),W)) ) ) ).

% of_int_power_le_of_int_cancel_iff
tff(fact_2079_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Y2: int,X2: num,Nb: nat] :
          ( ( ring_1_of_int(A,Y2) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb) )
        <=> ( Y2 = aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
tff(fact_2080_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X2: num,Nb: nat,Y2: int] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb) = ring_1_of_int(A,Y2) )
        <=> ( aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb) = Y2 ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
tff(fact_2081_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: int,B2: int,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,X2)),aa(nat,A,power_power(A,ring_1_of_int(A,B2)),W))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),X2),aa(nat,int,power_power(int,B2),W)) ) ) ).

% of_int_power_less_of_int_cancel_iff
tff(fact_2082_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: int,W: nat,X2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,ring_1_of_int(A,B2)),W)),ring_1_of_int(A,X2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,power_power(int,B2),W)),X2) ) ) ).

% of_int_less_of_int_power_cancel_iff
tff(fact_2083_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,X2: num,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,A2)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb)) ) ) ).

% of_int_le_numeral_power_cancel_iff
tff(fact_2084_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: num,Nb: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb)),ring_1_of_int(A,A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb)),A2) ) ) ).

% numeral_power_le_of_int_cancel_iff
tff(fact_2085_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,X2: num,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,A2)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb)) ) ) ).

% of_int_less_numeral_power_cancel_iff
tff(fact_2086_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: num,Nb: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb)),ring_1_of_int(A,A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb)),A2) ) ) ).

% numeral_power_less_of_int_cancel_iff
tff(fact_2087_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Y2: int,X2: num,Nb: nat] :
          ( ( ring_1_of_int(A,Y2) = aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2))),Nb) )
        <=> ( Y2 = aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X2))),Nb) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
tff(fact_2088_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X2: num,Nb: nat,Y2: int] :
          ( ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2))),Nb) = ring_1_of_int(A,Y2) )
        <=> ( aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X2))),Nb) = Y2 ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
tff(fact_2089_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit0,Ma),aa(num,num,bit0,Nb)) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_az(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,Ma,Nb)) ) ) ).

% divmod_algorithm_code(5)
tff(fact_2090_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,X2: num,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,A2)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2))),Nb))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X2))),Nb)) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
tff(fact_2091_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: num,Nb: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2))),Nb)),ring_1_of_int(A,A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X2))),Nb)),A2) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
tff(fact_2092_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,X2: num,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,A2)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2))),Nb))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X2))),Nb)) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
tff(fact_2093_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: num,Nb: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2))),Nb)),ring_1_of_int(A,A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X2))),Nb)),A2) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
tff(fact_2094_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: int,Y2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),ring_1_of_int(A,X2)),Y2) = aa(A,A,aa(A,fun(A,A),times_times(A),Y2),ring_1_of_int(A,X2)) ) ) ).

% mult_of_int_commute
tff(fact_2095_real__of__int__div4,axiom,
    ! [Nb: int,X2: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),divide_divide(int),Nb),X2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,Nb)),ring_1_of_int(real,X2))) ).

% real_of_int_div4
tff(fact_2096_real__of__int__div,axiom,
    ! [D2: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),Nb)
     => ( ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),divide_divide(int),Nb),D2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,Nb)),ring_1_of_int(real,D2)) ) ) ).

% real_of_int_div
tff(fact_2097_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ).

% order_less_imp_not_less
tff(fact_2098_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( Y2 != X2 ) ) ) ).

% order_less_imp_not_eq2
tff(fact_2099_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( X2 != Y2 ) ) ) ).

% order_less_imp_not_eq
tff(fact_2100_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
          | ( X2 = Y2 )
          | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ).

% linorder_less_linear
tff(fact_2101_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A,P: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
           => (P) ) ) ) ).

% order_less_imp_triv
tff(fact_2102_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ).

% order_less_not_sym
tff(fact_2103_order__less__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F3: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,B2)),C2)
           => ( ! [X4: A,Y4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X4)),aa(A,B,F3,Y4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,A2)),C2) ) ) ) ) ).

% order_less_subst2
tff(fact_2104_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F3: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B2),C2)
           => ( ! [X4: B,Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),Y4)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,X4)),aa(B,A,F3,Y4)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,C2)) ) ) ) ) ).

% order_less_subst1
tff(fact_2105_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),X2) ) ).

% order_less_irrefl
tff(fact_2106_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A2: A,B2: A,F3: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( ( aa(A,B,F3,B2) = C2 )
           => ( ! [X4: A,Y4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X4)),aa(A,B,F3,Y4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,A2)),C2) ) ) ) ) ).

% ord_less_eq_subst
tff(fact_2107_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A2: A,F3: fun(B,A),B2: B,C2: B] :
          ( ( A2 = aa(B,A,F3,B2) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B2),C2)
           => ( ! [X4: B,Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),Y4)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,X4)),aa(B,A,F3,Y4)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,C2)) ) ) ) ) ).

% ord_eq_less_subst
tff(fact_2108_order__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Z) ) ) ) ).

% order_less_trans
tff(fact_2109_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% order_less_asym'
tff(fact_2110_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ) ).

% linorder_neq_iff
tff(fact_2111_order__less__asym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ).

% order_less_asym
tff(fact_2112_linorder__neqE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ) ).

% linorder_neqE
tff(fact_2113_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
tff(fact_2114_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
tff(fact_2115_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% dual_order.strict_trans
tff(fact_2116_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
            | ( X2 = Y2 ) ) ) ) ).

% not_less_iff_gr_or_eq
tff(fact_2117_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% order.strict_trans
tff(fact_2118_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,$o)),A2: A,B2: A] :
          ( ! [A4: A,B3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A4),B3)
             => aa(A,$o,aa(A,fun(A,$o),P,A4),B3) )
         => ( ! [A4: A] : aa(A,$o,aa(A,fun(A,$o),P,A4),A4)
           => ( ! [A4: A,B3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),P,B3),A4)
                 => aa(A,$o,aa(A,fun(A,$o),P,A4),B3) )
             => aa(A,$o,aa(A,fun(A,$o),P,A2),B2) ) ) ) ) ).

% linorder_less_wlog
tff(fact_2119_exists__least__iff,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,$o)] :
          ( ? [X_12: A] : aa(A,$o,P,X_12)
        <=> ? [N4: A] :
              ( aa(A,$o,P,N4)
              & ! [M4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M4),N4)
                 => ~ aa(A,$o,P,M4) ) ) ) ) ).

% exists_least_iff
tff(fact_2120_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),A2) ) ).

% dual_order.irrefl
tff(fact_2121_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% dual_order.asym
tff(fact_2122_linorder__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( ( X2 != Y2 )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ) ).

% linorder_cases
tff(fact_2123_antisym__conv3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y2: A,X2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
          <=> ( X2 = Y2 ) ) ) ) ).

% antisym_conv3
tff(fact_2124_less__induct,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,$o),A2: A] :
          ( ! [X4: A] :
              ( ! [Y3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y3),X4)
                 => aa(A,$o,P,Y3) )
             => aa(A,$o,P,X4) )
         => aa(A,$o,P,A2) ) ) ).

% less_induct
tff(fact_2125_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( ( B2 = C2 )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% ord_less_eq_trans
tff(fact_2126_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% ord_eq_less_trans
tff(fact_2127_order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% order.asym
tff(fact_2128_less__imp__neq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( X2 != Y2 ) ) ) ).

% less_imp_neq
tff(fact_2129_dense,axiom,
    ! [A: $tType] :
      ( dense_order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ? [Z2: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Z2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),Y2) ) ) ) ).

% dense
tff(fact_2130_gt__ex,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [X2: A] :
        ? [X_13: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),X_13) ) ).

% gt_ex
tff(fact_2131_lt__ex,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [X2: A] :
        ? [Y4: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y4),X2) ) ).

% lt_ex
tff(fact_2132_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),ring_1_of_int(A,Z)) ) ) ).

% of_int_nonneg
tff(fact_2133_of__int__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),ring_1_of_int(A,Z)) ) ) ).

% of_int_pos
tff(fact_2134_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: num] : ( ring_1_of_int(A,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K)) ) ) ).

% of_int_neg_numeral
tff(fact_2135_int__le__real__less,axiom,
    ! [Nb: int,Ma: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Nb),Ma)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),ring_1_of_int(real,Nb)),aa(real,real,aa(real,fun(real,real),plus_plus(real),ring_1_of_int(real,Ma)),one_one(real))) ) ).

% int_le_real_less
tff(fact_2136_int__less__real__le,axiom,
    ! [Nb: int,Ma: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Nb),Ma)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),ring_1_of_int(real,Nb)),one_one(real))),ring_1_of_int(real,Ma)) ) ).

% int_less_real_le
tff(fact_2137_real__of__int__div__aux,axiom,
    ! [X2: int,D2: int] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,X2)),ring_1_of_int(real,D2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),D2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,modulo_modulo(int,X2,D2))),ring_1_of_int(real,D2))) ) ).

% real_of_int_div_aux
tff(fact_2138_real__of__int__div2,axiom,
    ! [Nb: int,X2: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,Nb)),ring_1_of_int(real,X2))),ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),divide_divide(int),Nb),X2)))) ).

% real_of_int_div2
tff(fact_2139_real__of__int__div3,axiom,
    ! [Nb: int,X2: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,Nb)),ring_1_of_int(real,X2))),ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),divide_divide(int),Nb),X2)))),one_one(real)) ).

% real_of_int_div3
tff(fact_2140_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),ring_1_of_int(A,K))
        <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K) ) ) ).

% even_of_int_iff
tff(fact_2141_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
            | ( X2 = Y2 ) ) ) ) ).

% order_le_imp_less_or_eq
tff(fact_2142_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
          | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ).

% linorder_le_less_linear
tff(fact_2143_order__less__le__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F3: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,B2)),C2)
           => ( ! [X4: A,Y4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X4)),aa(A,B,F3,Y4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,A2)),C2) ) ) ) ) ).

% order_less_le_subst2
tff(fact_2144_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F3: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B2),C2)
           => ( ! [X4: B,Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Y4)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,X4)),aa(B,A,F3,Y4)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,C2)) ) ) ) ) ).

% order_less_le_subst1
tff(fact_2145_order__le__less__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F3: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,B2)),C2)
           => ( ! [X4: A,Y4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,F3,Y4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,A2)),C2) ) ) ) ) ).

% order_le_less_subst2
tff(fact_2146_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F3: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(B,A,F3,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B2),C2)
           => ( ! [X4: B,Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),Y4)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,X4)),aa(B,A,F3,Y4)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,C2)) ) ) ) ) ).

% order_le_less_subst1
tff(fact_2147_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Z) ) ) ) ).

% order_less_le_trans
tff(fact_2148_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Z) ) ) ) ).

% order_le_less_trans
tff(fact_2149_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% order_neq_le_trans
tff(fact_2150_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( ( A2 != B2 )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% order_le_neq_trans
tff(fact_2151_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2) ) ) ).

% order_less_imp_le
tff(fact_2152_linorder__not__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),X2) ) ) ).

% linorder_not_less
tff(fact_2153_linorder__not__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2) ) ) ).

% linorder_not_le
tff(fact_2154_order__less__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
            & ( X2 != Y2 ) ) ) ) ).

% order_less_le
tff(fact_2155_order__le__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
            | ( X2 = Y2 ) ) ) ) ).

% order_le_less
tff(fact_2156_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% dual_order.strict_implies_order
tff(fact_2157_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% order.strict_implies_order
tff(fact_2158_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% dual_order.strict_iff_not
tff(fact_2159_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% dual_order.strict_trans2
tff(fact_2160_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% dual_order.strict_trans1
tff(fact_2161_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & ( A2 != B2 ) ) ) ) ).

% dual_order.strict_iff_order
tff(fact_2162_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
            | ( A2 = B2 ) ) ) ) ).

% dual_order.order_iff_strict
tff(fact_2163_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [X2: A,Y2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( ! [W2: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),W2)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W2),Y2)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W2),Z) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),Z) ) ) ) ).

% dense_le_bounded
tff(fact_2164_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X2)
         => ( ! [W2: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),W2)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W2),X2)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),W2) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),Z) ) ) ) ).

% dense_ge_bounded
tff(fact_2165_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% order.strict_iff_not
tff(fact_2166_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% order.strict_trans2
tff(fact_2167_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% order.strict_trans1
tff(fact_2168_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & ( A2 != B2 ) ) ) ) ).

% order.strict_iff_order
tff(fact_2169_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
            | ( A2 = B2 ) ) ) ) ).

% order.order_iff_strict
tff(fact_2170_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y2: A,X2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),X2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2) ) ) ).

% not_le_imp_less
tff(fact_2171_less__le__not__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),X2) ) ) ) ).

% less_le_not_le
tff(fact_2172_dense__le,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Y2: A,Z: A] :
          ( ! [X4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Y2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Z) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),Z) ) ) ).

% dense_le
tff(fact_2173_dense__ge,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z: A,Y2: A] :
          ( ! [X4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X4)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),X4) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),Z) ) ) ).

% dense_ge
tff(fact_2174_antisym__conv2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
          <=> ( X2 = Y2 ) ) ) ) ).

% antisym_conv2
tff(fact_2175_antisym__conv1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
          <=> ( X2 = Y2 ) ) ) ) ).

% antisym_conv1
tff(fact_2176_nless__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            | ( A2 = B2 ) ) ) ) ).

% nless_le
tff(fact_2177_leI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),X2) ) ) ).

% leI
tff(fact_2178_leD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y2),X2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2) ) ) ).

% leD
tff(fact_2179_divmod__step__nat__def,axiom,
    ! [L: num,Qr: product_prod(nat,nat)] : ( unique1321980374590559556d_step(nat,L,Qr) = aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_ba(num,fun(nat,fun(nat,product_prod(nat,nat))),L)),Qr) ) ).

% divmod_step_nat_def
tff(fact_2180_divmod__step__int__def,axiom,
    ! [L: num,Qr: product_prod(int,int)] : ( unique1321980374590559556d_step(int,L,Qr) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_bb(num,fun(int,fun(int,product_prod(int,int))),L)),Qr) ) ).

% divmod_step_int_def
tff(fact_2181_divmod__step__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Qr: product_prod(A,A)] : ( unique1321980374590559556d_step(A,L,Qr) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_bc(num,fun(A,fun(A,product_prod(A,A))),L)),Qr) ) ) ).

% divmod_step_def
tff(fact_2182_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: fun(B,fun(C,A)),A2: B,B2: C] : ( aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),F3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A2),B2)) = aa(C,A,aa(B,fun(C,A),F3,A2),B2) ) ).

% case_prod_conv
tff(fact_2183_floor__exists1,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A] :
        ? [X4: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,X4)),X2)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),one_one(int))))
          & ! [Y3: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,Y3)),X2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),plus_plus(int),Y3),one_one(int)))) )
             => ( Y3 = X4 ) ) ) ) ).

% floor_exists1
tff(fact_2184_floor__exists,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A] :
        ? [Z2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,Z2)),X2)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),plus_plus(int),Z2),one_one(int)))) ) ) ).

% floor_exists
tff(fact_2185_divmod__nat__if,axiom,
    ! [Ma: nat,Nb: nat] :
      ( divmod_nat(Ma,Nb)
      = $ite(
          ( ( Nb = zero_zero(nat) )
          | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ),
          aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),Ma),
          aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_bd(nat,fun(nat,product_prod(nat,nat)))),divmod_nat(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb),Nb)) ) ) ).

% divmod_nat_if
tff(fact_2186_divmod__BitM__2__eq,axiom,
    ! [Ma: num] : ( unique8689654367752047608divmod(int,bitM(Ma),aa(num,num,bit0,one2)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Ma)),one_one(int))),one_one(int)) ) ).

% divmod_BitM_2_eq
tff(fact_2187_mask__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: num] : ( bit_se2239418461657761734s_mask(A,aa(num,nat,numeral_numeral(nat),Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,pred_numeral(Nb)))) ) ) ).

% mask_numeral
tff(fact_2188_take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)
          = $ite(Nb = zero_zero(nat),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% take_bit_rec
tff(fact_2189_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P2: product_prod(A,B),C2: fun(A,fun(B,$o))] :
      ( ! [A4: A,B3: B] :
          ( ( P2 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3) )
         => aa(B,$o,aa(A,fun(B,$o),C2,A4),B3) )
     => aa(product_prod(A,B),$o,aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),C2),P2) ) ).

% case_prodI2
tff(fact_2190_case__prodI,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,fun(B,$o)),A2: A,B2: B] :
      ( aa(B,$o,aa(A,fun(B,$o),F3,A2),B2)
     => aa(product_prod(A,B),$o,aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),F3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A2),B2)) ) ).

% case_prodI
tff(fact_2191_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P2: product_prod(A,B),Z: C,C2: fun(A,fun(B,set(C)))] :
      ( ! [A4: A,B3: B] :
          ( ( P2 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3) )
         => aa(set(C),$o,member(C,Z),aa(B,set(C),aa(A,fun(B,set(C)),C2,A4),B3)) )
     => aa(set(C),$o,member(C,Z),aa(product_prod(A,B),set(C),aa(fun(A,fun(B,set(C))),fun(product_prod(A,B),set(C)),product_case_prod(A,B,set(C)),C2),P2)) ) ).

% mem_case_prodI2
tff(fact_2192_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z: A,C2: fun(B,fun(C,set(A))),A2: B,B2: C] :
      ( aa(set(A),$o,member(A,Z),aa(C,set(A),aa(B,fun(C,set(A)),C2,A2),B2))
     => aa(set(A),$o,member(A,Z),aa(product_prod(B,C),set(A),aa(fun(B,fun(C,set(A))),fun(product_prod(B,C),set(A)),product_case_prod(B,C,set(A)),C2),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A2),B2))) ) ).

% mem_case_prodI
tff(fact_2193_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P2: product_prod(A,B),C2: fun(A,fun(B,fun(C,$o))),X2: C] :
      ( ! [A4: A,B3: B] :
          ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3) = P2 )
         => aa(C,$o,aa(B,fun(C,$o),aa(A,fun(B,fun(C,$o)),C2,A4),B3),X2) )
     => aa(C,$o,aa(product_prod(A,B),fun(C,$o),aa(fun(A,fun(B,fun(C,$o))),fun(product_prod(A,B),fun(C,$o)),product_case_prod(A,B,fun(C,$o)),C2),P2),X2) ) ).

% case_prodI2'
tff(fact_2194_mask__nat__positive__iff,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),bit_se2239418461657761734s_mask(nat,Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ).

% mask_nat_positive_iff
tff(fact_2195_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),zero_zero(A)) = zero_zero(A) ) ) ).

% take_bit_of_0
tff(fact_2196_concat__bit__of__zero__2,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,bit_concat_bit(Nb,K),zero_zero(int)) = aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) ) ).

% concat_bit_of_zero_2
tff(fact_2197_take__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,zero_zero(nat)),A2) = zero_zero(A) ) ) ).

% take_bit_0
tff(fact_2198_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Nb)),one_one(A)) = one_one(A) ) ) ).

% take_bit_Suc_1
tff(fact_2199_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),one_one(A)) = one_one(A) ) ) ).

% take_bit_numeral_1
tff(fact_2200_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] :
          ( ( bit_se2239418461657761734s_mask(A,Nb) = zero_zero(A) )
        <=> ( Nb = zero_zero(nat) ) ) ) ).

% mask_eq_0_iff
tff(fact_2201_mask__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,zero_zero(nat)) = zero_zero(A) ) ) ).

% mask_0
tff(fact_2202_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_dec(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),bitM(K)) ) ) ).

% dbl_dec_simps(5)
tff(fact_2203_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),one_one(A)) = zero_zero(A) )
        <=> ( Nb = zero_zero(nat) ) ) ) ).

% take_bit_of_1_eq_0_iff
tff(fact_2204_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% mask_Suc_0
tff(fact_2205_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,uminus_uminus(A),one_one(A))) = bit_se2239418461657761734s_mask(A,Nb) ) ) ).

% take_bit_minus_one_eq_mask
tff(fact_2206_take__bit__of__Suc__0,axiom,
    ! [Nb: nat] : ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),aa(nat,nat,suc,zero_zero(nat))) = aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)) ) ).

% take_bit_of_Suc_0
tff(fact_2207_pred__numeral__simps_I2_J,axiom,
    ! [K: num] : ( pred_numeral(aa(num,num,bit0,K)) = aa(num,nat,numeral_numeral(nat),bitM(K)) ) ).

% pred_numeral_simps(2)
tff(fact_2208_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),one_one(A)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)) ) ) ).

% take_bit_of_1
tff(fact_2209_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2))
        <=> ( ( Nb = zero_zero(nat) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ) ).

% even_take_bit_eq
tff(fact_2210_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,zero_zero(nat))),A2) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_Suc_0
tff(fact_2211_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: nat,Nb: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma))),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) ) ) ).

% take_bit_of_exp
tff(fact_2212_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_of_2
tff(fact_2213_case__prodD,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,fun(B,$o)),A2: A,B2: B] :
      ( aa(product_prod(A,B),$o,aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),F3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A2),B2))
     => aa(B,$o,aa(A,fun(B,$o),F3,A2),B2) ) ).

% case_prodD
tff(fact_2214_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: fun(A,fun(B,$o)),P2: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),C2),P2)
     => ~ ! [X4: A,Y4: B] :
            ( ( P2 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y4) )
           => ~ aa(B,$o,aa(A,fun(B,$o),C2,X4),Y4) ) ) ).

% case_prodE
tff(fact_2215_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat] : ( ring_1_of_int(A,bit_se2239418461657761734s_mask(int,Nb)) = bit_se2239418461657761734s_mask(A,Nb) ) ) ).

% of_int_mask_eq
tff(fact_2216_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,K: int] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),ring_1_of_int(A,K)) = ring_1_of_int(A,aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) ) ) ).

% take_bit_of_int
tff(fact_2217_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: fun(A,fun(B,fun(C,$o))),P2: product_prod(A,B),Z: C] :
      ( aa(C,$o,aa(product_prod(A,B),fun(C,$o),aa(fun(A,fun(B,fun(C,$o))),fun(product_prod(A,B),fun(C,$o)),product_case_prod(A,B,fun(C,$o)),C2),P2),Z)
     => ~ ! [X4: A,Y4: B] :
            ( ( P2 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y4) )
           => ~ aa(C,$o,aa(B,fun(C,$o),aa(A,fun(B,fun(C,$o)),C2,X4),Y4),Z) ) ) ).

% case_prodE'
tff(fact_2218_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R3: fun(A,fun(B,fun(C,$o))),A2: A,B2: B,C2: C] :
      ( aa(C,$o,aa(product_prod(A,B),fun(C,$o),aa(fun(A,fun(B,fun(C,$o))),fun(product_prod(A,B),fun(C,$o)),product_case_prod(A,B,fun(C,$o)),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A2),B2)),C2)
     => aa(C,$o,aa(B,fun(C,$o),aa(A,fun(B,fun(C,$o)),R3,A2),B2),C2) ) ).

% case_prodD'
tff(fact_2219_take__bit__add,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),B2))) = aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ).

% take_bit_add
tff(fact_2220_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A,Ma: nat] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),B2) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),B2) ) ) ) ) ).

% take_bit_tightened
tff(fact_2221_take__bit__nat__less__eq__self,axiom,
    ! [Nb: nat,Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),Ma)),Ma) ).

% take_bit_nat_less_eq_self
tff(fact_2222_take__bit__tightened__less__eq__nat,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Ma),Q2)),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),Q2)) ) ).

% take_bit_tightened_less_eq_nat
tff(fact_2223_take__bit__minus,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,uminus_uminus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K))) = aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,uminus_uminus(int),K)) ) ).

% take_bit_minus
tff(fact_2224_take__bit__mult,axiom,
    ! [Nb: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),L))) = aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),times_times(int),K),L)) ) ).

% take_bit_mult
tff(fact_2225_take__bit__diff,axiom,
    ! [Nb: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),L))) = aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)) ) ).

% take_bit_diff
tff(fact_2226_concat__bit__take__bit__eq,axiom,
    ! [Nb: nat,B2: int] : ( bit_concat_bit(Nb,aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),B2)) = bit_concat_bit(Nb,B2) ) ).

% concat_bit_take_bit_eq
tff(fact_2227_concat__bit__eq__iff,axiom,
    ! [Nb: nat,K: int,L: int,R: int,S: int] :
      ( ( aa(int,int,bit_concat_bit(Nb,K),L) = aa(int,int,bit_concat_bit(Nb,R),S) )
    <=> ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) = aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),R) )
        & ( L = S ) ) ) ).

% concat_bit_eq_iff
tff(fact_2228_less__eq__mask,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),bit_se2239418461657761734s_mask(nat,Nb)) ).

% less_eq_mask
tff(fact_2229_semiring__norm_I26_J,axiom,
    bitM(one2) = one2 ).

% semiring_norm(26)
tff(fact_2230_take__bit__eq__mask__iff,axiom,
    ! [Nb: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) = bit_se2239418461657761734s_mask(int,Nb) )
    <=> ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) = zero_zero(int) ) ) ).

% take_bit_eq_mask_iff
tff(fact_2231_take__bit__tightened__less__eq__int,axiom,
    ! [Ma: nat,Nb: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Ma),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) ) ).

% take_bit_tightened_less_eq_int
tff(fact_2232_take__bit__nonnegative,axiom,
    ! [Nb: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) ).

% take_bit_nonnegative
tff(fact_2233_take__bit__int__less__eq__self__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% take_bit_int_less_eq_self_iff
tff(fact_2234_not__take__bit__negative,axiom,
    ! [Nb: nat,K: int] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),zero_zero(int)) ).

% not_take_bit_negative
tff(fact_2235_take__bit__int__greater__self__iff,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% take_bit_int_greater_self_iff
tff(fact_2236_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A,B2: A] :
          ( ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),A2) = aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),B2) )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Nb)),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Nb)),B2) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
tff(fact_2237_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Ma),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2))
          = aa(A,A,$ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma),bit_se2584673776208193580ke_bit(A,Nb),bit_ri4674362597316999326ke_bit(A,Ma)),A2) ) ) ).

% signed_take_bit_take_bit
tff(fact_2238_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,Ma: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),Ma),A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),Ma),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2))) ) ) ).

% take_bit_unset_bit_eq
tff(fact_2239_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,Ma: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),Ma),A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),Ma),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2))) ) ) ).

% take_bit_set_bit_eq
tff(fact_2240_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,Ma: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),bit_se8732182000553998342ip_bit(A,Ma,A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2),bit_se8732182000553998342ip_bit(A,Ma,aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2))) ) ) ).

% take_bit_flip_bit_eq
tff(fact_2241_mask__nonnegative__int,axiom,
    ! [Nb: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se2239418461657761734s_mask(int,Nb)) ).

% mask_nonnegative_int
tff(fact_2242_not__mask__negative__int,axiom,
    ! [Nb: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se2239418461657761734s_mask(int,Nb)),zero_zero(int)) ).

% not_mask_negative_int
tff(fact_2243_semiring__norm_I28_J,axiom,
    ! [Nb: num] : ( bitM(aa(num,num,bit1,Nb)) = aa(num,num,bit1,aa(num,num,bit0,Nb)) ) ).

% semiring_norm(28)
tff(fact_2244_semiring__norm_I27_J,axiom,
    ! [Nb: num] : ( bitM(aa(num,num,bit0,Nb)) = aa(num,num,bit1,bitM(Nb)) ) ).

% semiring_norm(27)
tff(fact_2245_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,suc,Nb))
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),A2) ) ) ) ).

% take_bit_signed_take_bit
tff(fact_2246_take__bit__decr__eq,axiom,
    ! [Nb: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) != zero_zero(int) )
     => ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),one_one(int)) ) ) ).

% take_bit_decr_eq
tff(fact_2247_less__mask,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),bit_se2239418461657761734s_mask(nat,Nb)) ) ).

% less_mask
tff(fact_2248_eval__nat__numeral_I2_J,axiom,
    ! [Nb: num] : ( aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Nb)) = aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),bitM(Nb))) ) ).

% eval_nat_numeral(2)
tff(fact_2249_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [Nb: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) = bit_se2239418461657761734s_mask(int,Nb) )
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) ) ).

% take_bit_eq_mask_iff_exp_dvd
tff(fact_2250_BitM__plus__one,axiom,
    ! [Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bitM(Nb)),one2) = aa(num,num,bit0,Nb) ) ).

% BitM_plus_one
tff(fact_2251_one__plus__BitM,axiom,
    ! [Nb: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),bitM(Nb)) = aa(num,num,bit0,Nb) ) ).

% one_plus_BitM
tff(fact_2252_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_Suc_bit0
tff(fact_2253_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) = modulo_modulo(A,A2,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) ) ) ).

% take_bit_eq_mod
tff(fact_2254_numeral__BitM,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Nb: num] : ( aa(num,A,numeral_numeral(A),bitM(Nb)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb))),one_one(A)) ) ) ).

% numeral_BitM
tff(fact_2255_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [W: num] : ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,A,numeral_numeral(A),bitM(W))) ) ).

% odd_numeral_BitM
tff(fact_2256_take__bit__nat__eq__self,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))
     => ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),Ma) = Ma ) ) ).

% take_bit_nat_eq_self
tff(fact_2257_take__bit__nat__less__exp,axiom,
    ! [Nb: nat,Ma: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),Ma)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ).

% take_bit_nat_less_exp
tff(fact_2258_take__bit__nat__eq__self__iff,axiom,
    ! [Nb: nat,Ma: nat] :
      ( ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),Ma) = Ma )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ).

% take_bit_nat_eq_self_iff
tff(fact_2259_take__bit__nat__def,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),Ma) = modulo_modulo(nat,Ma,aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ).

% take_bit_nat_def
tff(fact_2260_prod_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,H: fun(B,A),F3: fun(C,fun(D,B)),Prod: product_prod(C,D)] : ( aa(B,A,H,aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),F3),Prod)) = aa(product_prod(C,D),A,aa(fun(C,fun(D,A)),fun(product_prod(C,D),A),product_case_prod(C,D,A),aa(fun(C,fun(D,B)),fun(C,fun(D,A)),aTP_Lamp_be(fun(B,A),fun(fun(C,fun(D,B)),fun(C,fun(D,A))),H),F3)),Prod) ) ).

% prod.case_distrib
tff(fact_2261_take__bit__int__less__exp,axiom,
    ! [Nb: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ).

% take_bit_int_less_exp
tff(fact_2262_take__bit__int__def,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) = modulo_modulo(int,K,aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ).

% take_bit_int_def
tff(fact_2263_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) = zero_zero(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),A2) ) ) ).

% take_bit_eq_0_iff
tff(fact_2264_Divides_Oadjust__div__def,axiom,
    ! [Qr: product_prod(int,int)] : ( adjust_div(Qr) = aa(product_prod(int,int),int,aa(fun(int,fun(int,int)),fun(product_prod(int,int),int),product_case_prod(int,int,int),aTP_Lamp_bf(int,fun(int,int))),Qr) ) ).

% Divides.adjust_div_def
tff(fact_2265_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_numeral_bit0
tff(fact_2266_take__bit__nat__less__self__iff,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),Ma)),Ma)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),Ma) ) ).

% take_bit_nat_less_self_iff
tff(fact_2267_Suc__mask__eq__exp,axiom,
    ! [Nb: nat] : ( aa(nat,nat,suc,bit_se2239418461657761734s_mask(nat,Nb)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) ) ).

% Suc_mask_eq_exp
tff(fact_2268_mask__nat__less__exp,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),bit_se2239418461657761734s_mask(nat,Nb)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ).

% mask_nat_less_exp
tff(fact_2269_take__bit__Suc__minus__bit0,axiom,
    ! [Nb: nat,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Nb)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% take_bit_Suc_minus_bit0
tff(fact_2270_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ).

% take_bit_int_greater_eq_self_iff
tff(fact_2271_take__bit__int__less__self__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),K) ) ).

% take_bit_int_less_self_iff
tff(fact_2272_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,Nb))
        <=> ( Nb = zero_zero(nat) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
tff(fact_2273_take__bit__int__eq__self__iff,axiom,
    ! [Nb: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) = K )
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ) ).

% take_bit_int_eq_self_iff
tff(fact_2274_take__bit__int__eq__self,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))
       => ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) = K ) ) ) ).

% take_bit_int_eq_self
tff(fact_2275_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% take_bit_numeral_minus_bit0
tff(fact_2276_mask__nat__def,axiom,
    ! [Nb: nat] : ( bit_se2239418461657761734s_mask(nat,Nb) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),one_one(nat)) ) ).

% mask_nat_def
tff(fact_2277_mask__half__int,axiom,
    ! [Nb: nat] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),bit_se2239418461657761734s_mask(int,Nb)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = bit_se2239418461657761734s_mask(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))) ) ).

% mask_half_int
tff(fact_2278_take__bit__incr__eq,axiom,
    ! [Nb: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K) != aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),one_one(int)) )
     => ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) ) ) ).

% take_bit_incr_eq
tff(fact_2279_exists__least__lemma,axiom,
    ! [P: fun(nat,$o)] :
      ( ~ aa(nat,$o,P,zero_zero(nat))
     => ( ? [X_1: nat] : aa(nat,$o,P,X_1)
       => ? [N: nat] :
            ( ~ aa(nat,$o,P,N)
            & aa(nat,$o,P,aa(nat,nat,suc,N)) ) ) ) ).

% exists_least_lemma
tff(fact_2280_mask__int__def,axiom,
    ! [Nb: nat] : ( bit_se2239418461657761734s_mask(int,Nb) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),one_one(int)) ) ).

% mask_int_def
tff(fact_2281_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A] :
        ? [Z2: int] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,Z2)),X2) ) ).

% ex_of_int_less
tff(fact_2282_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A] :
        ? [Z2: int] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),ring_1_of_int(A,Z2)) ) ).

% ex_less_of_int
tff(fact_2283_divmod__nat__def,axiom,
    ! [Ma: nat,Nb: nat] : ( divmod_nat(Ma,Nb) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),modulo_modulo(nat,Ma,Nb)) ) ).

% divmod_nat_def
tff(fact_2284_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Nb)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,suc,Nb))),one_one(A)) ) ) ).

% take_bit_Suc_minus_1_eq
tff(fact_2285_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Nb)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% take_bit_Suc_bit1
tff(fact_2286_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),K)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),K))),one_one(A)) ) ) ).

% take_bit_numeral_minus_1_eq
tff(fact_2287_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Nb)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% take_bit_Suc
tff(fact_2288_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( bit_se2239418461657761734s_mask(A,Nb) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),one_one(A)) ) ) ).

% mask_eq_exp_minus_1
tff(fact_2289_take__bit__int__less__eq,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))) ) ) ).

% take_bit_int_less_eq
tff(fact_2290_take__bit__int__greater__eq,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) ) ).

% take_bit_int_greater_eq
tff(fact_2291_signed__take__bit__eq__take__bit__shift,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Nb)),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)))),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ).

% signed_take_bit_eq_take_bit_shift
tff(fact_2292_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Nb: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)
            = $ite(aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2),zero_zero(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),one_one(A))) ) ) ) ).

% stable_imp_take_bit_eq
tff(fact_2293_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% take_bit_numeral_bit1
tff(fact_2294_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: fun(A,fun(B,C)),G: fun(product_prod(A,B),C)] :
      ( ! [X4: A,Y4: B] : ( aa(B,C,aa(A,fun(B,C),F3,X4),Y4) = aa(product_prod(A,B),C,G,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y4)) )
     => ( aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F3) = G ) ) ).

% cond_case_prod_eta
tff(fact_2295_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: fun(product_prod(A,B),C)] : ( aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),aTP_Lamp_bg(fun(product_prod(A,B),C),fun(A,fun(B,C)),F3)) = F3 ) ).

% case_prod_eta
tff(fact_2296_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: fun(A,$o),P: fun(B,fun(C,A)),Z: product_prod(B,C)] :
      ( aa(A,$o,Q,aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),P),Z))
     => ~ ! [X4: B,Y4: C] :
            ( ( Z = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Y4) )
           => ~ aa(A,$o,Q,aa(C,A,aa(B,fun(C,A),P,X4),Y4)) ) ) ).

% case_prodE2
tff(fact_2297_take__bit__minus__small__eq,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))
       => ( aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,uminus_uminus(int),K)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),K) ) ) ) ).

% take_bit_minus_small_eq
tff(fact_2298_round__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),ring_1_of_int(A,Y2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,Y2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))
           => ( archimedean_round(A,X2) = Y2 ) ) ) ) ).

% round_unique
tff(fact_2299_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K))))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% take_bit_numeral_minus_bit1
tff(fact_2300_take__bit__Suc__minus__bit1,axiom,
    ! [Nb: nat,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Nb)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K))))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% take_bit_Suc_minus_bit1
tff(fact_2301_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),ring_1_of_int(A,archimedean_round(A,X2))) ) ).

% of_int_round_gt
tff(fact_2302_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),ring_1_of_int(A,archimedean_round(A,X2))) ) ).

% of_int_round_ge
tff(fact_2303_of__int__round__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,archimedean_round(A,X2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ).

% of_int_round_le
tff(fact_2304_int__ge__less__than__def,axiom,
    ! [D2: int] : ( int_ge_less_than(D2) = aa(fun(product_prod(int,int),$o),set(product_prod(int,int)),collect(product_prod(int,int)),aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aTP_Lamp_bh(int,fun(int,fun(int,$o)),D2))) ) ).

% int_ge_less_than_def
tff(fact_2305_split__part,axiom,
    ! [B: $tType,A: $tType,P: $o,Q: fun(A,fun(B,$o)),X: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aTP_Lamp_bi($o,fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),P),Q)),X)
    <=> ( (P)
        & aa(product_prod(A,B),$o,aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),Q),X) ) ) ).

% split_part
tff(fact_2306_round__0,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_round(A,zero_zero(A)) = zero_zero(int) ) ) ).

% round_0
tff(fact_2307_round__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Nb: num] : ( archimedean_round(A,aa(num,A,numeral_numeral(A),Nb)) = aa(num,int,numeral_numeral(int),Nb) ) ) ).

% round_numeral
tff(fact_2308_pred__numeral__inc,axiom,
    ! [K: num] : ( pred_numeral(inc(K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% pred_numeral_inc
tff(fact_2309_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(Nb))) ) ) ).

% add_neg_numeral_special(5)
tff(fact_2310_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(Ma))) ) ) ).

% add_neg_numeral_special(6)
tff(fact_2311_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),inc(Ma)) ) ) ).

% diff_numeral_special(6)
tff(fact_2312_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),Nb)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(Nb))) ) ) ).

% diff_numeral_special(5)
tff(fact_2313_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Nb: num] : ( archimedean_round(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb)) ) ) ).

% round_neg_numeral
tff(fact_2314_prod_Odisc__eq__case,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod(A,B)] : aa(product_prod(A,B),$o,aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aTP_Lamp_bj(A,fun(B,$o))),Prod) ).

% prod.disc_eq_case
tff(fact_2315_num__induct,axiom,
    ! [P: fun(num,$o),X2: num] :
      ( aa(num,$o,P,one2)
     => ( ! [X4: num] :
            ( aa(num,$o,P,X4)
           => aa(num,$o,P,inc(X4)) )
       => aa(num,$o,P,X2) ) ) ).

% num_induct
tff(fact_2316_add__inc,axiom,
    ! [X2: num,Y2: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),X2),inc(Y2)) = inc(aa(num,num,aa(num,fun(num,num),plus_plus(num),X2),Y2)) ) ).

% add_inc
tff(fact_2317_inc_Osimps_I1_J,axiom,
    inc(one2) = aa(num,num,bit0,one2) ).

% inc.simps(1)
tff(fact_2318_inc_Osimps_I2_J,axiom,
    ! [X2: num] : ( inc(aa(num,num,bit0,X2)) = aa(num,num,bit1,X2) ) ).

% inc.simps(2)
tff(fact_2319_inc_Osimps_I3_J,axiom,
    ! [X2: num] : ( inc(aa(num,num,bit1,X2)) = aa(num,num,bit0,inc(X2)) ) ).

% inc.simps(3)
tff(fact_2320_add__One,axiom,
    ! [X2: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),X2),one2) = inc(X2) ) ).

% add_One
tff(fact_2321_inc__BitM__eq,axiom,
    ! [Nb: num] : ( inc(bitM(Nb)) = aa(num,num,bit0,Nb) ) ).

% inc_BitM_eq
tff(fact_2322_BitM__inc__eq,axiom,
    ! [Nb: num] : ( bitM(inc(Nb)) = aa(num,num,bit1,Nb) ) ).

% BitM_inc_eq
tff(fact_2323_mult__inc,axiom,
    ! [X2: num,Y2: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),X2),inc(Y2)) = aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),times_times(num),X2),Y2)),X2) ) ).

% mult_inc
tff(fact_2324_numeral__inc,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X2: num] : ( aa(num,A,numeral_numeral(A),inc(X2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X2)),one_one(A)) ) ) ).

% numeral_inc
tff(fact_2325_int__ge__less__than2__def,axiom,
    ! [D2: int] : ( int_ge_less_than2(D2) = aa(fun(product_prod(int,int),$o),set(product_prod(int,int)),collect(product_prod(int,int)),aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aTP_Lamp_bk(int,fun(int,fun(int,$o)),D2))) ) ).

% int_ge_less_than2_def
tff(fact_2326_signed__take__bit__eq__take__bit__minus,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Nb)),K)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(nat,nat,suc,Nb))),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb)))) ) ).

% signed_take_bit_eq_take_bit_minus
tff(fact_2327_and__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = $ite(
          ( ( K = zero_zero(int) )
          | ( L = zero_zero(int) ) ),
          zero_zero(int),
          $ite(
            K = aa(int,int,uminus_uminus(int),one_one(int)),
            L,
            $ite(L = aa(int,int,uminus_uminus(int),one_one(int)),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))))) ) ) ) ).

% and_int_unfold
tff(fact_2328_exp__lower__Taylor__quadratic,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,exp(real),X2)) ) ).

% exp_lower_Taylor_quadratic
tff(fact_2329_sqrt__sum__squares__half__less,axiom,
    ! [X2: real,U: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),U) ) ) ) ) ).

% sqrt_sum_squares_half_less
tff(fact_2330_set__n__lists,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(list(A)),set(list(A)),set2(list(A)),n_lists(A,Nb,Xs)) = aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(list(A),fun(list(A),$o),aTP_Lamp_bl(nat,fun(list(A),fun(list(A),$o)),Nb),Xs)) ) ).

% set_n_lists
tff(fact_2331_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) ) ) ).

% and.right_idem
tff(fact_2332_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) ) ) ).

% and.left_idem
tff(fact_2333_and_Oidem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),A2) = A2 ) ) ).

% and.idem
tff(fact_2334_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),zero_zero(A)) = zero_zero(A) ) ) ).

% bit.conj_zero_right
tff(fact_2335_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),zero_zero(A)),X2) = zero_zero(A) ) ) ).

% bit.conj_zero_left
tff(fact_2336_zero__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% zero_and_eq
tff(fact_2337_and__zero__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% and_zero_eq
tff(fact_2338_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X2: real] :
      ( ( aa(real,real,sqrt,X2) = zero_zero(real) )
    <=> ( X2 = zero_zero(real) ) ) ).

% real_sqrt_eq_zero_cancel_iff
tff(fact_2339_real__sqrt__zero,axiom,
    aa(real,real,sqrt,zero_zero(real)) = zero_zero(real) ).

% real_sqrt_zero
tff(fact_2340_real__sqrt__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X2)),aa(real,real,sqrt,Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ).

% real_sqrt_less_iff
tff(fact_2341_take__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),B2)) ) ) ).

% take_bit_and
tff(fact_2342_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))),A2) = A2 ) ) ).

% and.left_neutral
tff(fact_2343_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,uminus_uminus(A),one_one(A))) = A2 ) ) ).

% and.right_neutral
tff(fact_2344_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) = X2 ) ) ).

% bit.conj_one_right
tff(fact_2345_real__sqrt__gt__0__iff,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sqrt,Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2) ) ).

% real_sqrt_gt_0_iff
tff(fact_2346_real__sqrt__lt__0__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real)) ) ).

% real_sqrt_lt_0_iff
tff(fact_2347_real__sqrt__le__0__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real)) ) ).

% real_sqrt_le_0_iff
tff(fact_2348_real__sqrt__ge__0__iff,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2) ) ).

% real_sqrt_ge_0_iff
tff(fact_2349_real__sqrt__gt__1__iff,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,sqrt,Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Y2) ) ).

% real_sqrt_gt_1_iff
tff(fact_2350_real__sqrt__lt__1__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X2)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real)) ) ).

% real_sqrt_lt_1_iff
tff(fact_2351_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% and_nonnegative_int_iff
tff(fact_2352_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),zero_zero(int))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% and_negative_int_iff
tff(fact_2353_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Ma))),aa(nat,nat,suc,Nb))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),Ma)),Nb) ) ) ).

% bit_numeral_Bit0_Suc_iff
tff(fact_2354_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = one_one(A) ) ) ).

% and_numerals(2)
tff(fact_2355_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),one_one(A)) = one_one(A) ) ) ).

% and_numerals(8)
tff(fact_2356_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Ma))),aa(nat,nat,suc,Nb))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),Ma)),Nb) ) ) ).

% bit_numeral_Bit1_Suc_iff
tff(fact_2357_real__sqrt__four,axiom,
    aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)) ).

% real_sqrt_four
tff(fact_2358_signed__take__bit__nonnegative__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K))
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb) ) ).

% signed_take_bit_nonnegative_iff
tff(fact_2359_signed__take__bit__negative__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K)),zero_zero(int))
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb) ) ).

% signed_take_bit_negative_iff
tff(fact_2360_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),one_one(A)) = zero_zero(A) ) ) ).

% and_numerals(5)
tff(fact_2361_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = zero_zero(A) ) ) ).

% and_numerals(1)
tff(fact_2362_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2))) ) ) ).

% and_numerals(3)
tff(fact_2363_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,Nb: num] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,W))),aa(num,nat,numeral_numeral(nat),Nb))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),pred_numeral(Nb)) ) ) ).

% bit_numeral_simps(2)
tff(fact_2364_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W)))),aa(nat,nat,suc,Nb))
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),Nb) ) ).

% bit_minus_numeral_Bit0_Suc_iff
tff(fact_2365_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,Nb: num] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,W))),aa(num,nat,numeral_numeral(nat),Nb))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),pred_numeral(Nb)) ) ) ).

% bit_numeral_simps(3)
tff(fact_2366_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,W)))),aa(nat,nat,suc,Nb))
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(num,int,numeral_numeral(int),W)),Nb) ) ).

% bit_minus_numeral_Bit1_Suc_iff
tff(fact_2367_and__minus__numerals_I6_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))),one_one(int)) = one_one(int) ) ).

% and_minus_numerals(6)
tff(fact_2368_and__minus__numerals_I2_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = one_one(int) ) ).

% and_minus_numerals(2)
tff(fact_2369_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2))) ) ) ).

% and_numerals(6)
tff(fact_2370_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2))) ) ) ).

% and_numerals(4)
tff(fact_2371_bit__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),zero_zero(nat))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% bit_0
tff(fact_2372_and__minus__numerals_I1_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = zero_zero(int) ) ).

% and_minus_numerals(1)
tff(fact_2373_and__minus__numerals_I5_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))),one_one(int)) = zero_zero(int) ) ).

% and_minus_numerals(5)
tff(fact_2374_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,Nb: num] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W)))),aa(num,nat,numeral_numeral(nat),Nb))
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),pred_numeral(Nb)) ) ).

% bit_minus_numeral_int(1)
tff(fact_2375_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,Nb: num] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,W)))),aa(num,nat,numeral_numeral(nat),Nb))
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(num,int,numeral_numeral(int),W)),pred_numeral(Nb)) ) ).

% bit_minus_numeral_int(2)
tff(fact_2376_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),Nb)
        <=> ( ( Nb = zero_zero(nat) )
            & ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ) ).

% bit_mod_2_iff
tff(fact_2377_real__sqrt__pow2,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(nat,real,power_power(real,aa(real,real,sqrt,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = X2 ) ) ).

% real_sqrt_pow2
tff(fact_2378_real__sqrt__pow2__iff,axiom,
    ! [X2: real] :
      ( ( aa(nat,real,power_power(real,aa(real,real,sqrt,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = X2 )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2) ) ).

% real_sqrt_pow2_iff
tff(fact_2379_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X2: real,Y2: real,Xa2: real,Ya: real] : ( aa(nat,real,power_power(real,aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,Xa2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Ya),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,Xa2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Ya),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% real_sqrt_sum_squares_mult_squared_eq
tff(fact_2380_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2)))) ) ) ).

% and_numerals(7)
tff(fact_2381_bit__and__int__iff,axiom,
    ! [K: int,L: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),Nb)
    <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),Nb) ) ) ).

% bit_and_int_iff
tff(fact_2382_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),C2)) ) ) ).

% and.left_commute
tff(fact_2383_bit__and__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)),Nb)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),Nb) ) ) ) ).

% bit_and_iff
tff(fact_2384_and_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),A2) ) ) ).

% and.commute
tff(fact_2385_and_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),C2)) ) ) ).

% and.assoc
tff(fact_2386_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),Ma)),Nb)
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(num,nat,numeral_numeral(nat),Ma)),Nb) ) ) ).

% bit_numeral_iff
tff(fact_2387_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),ring_1_of_int(A,K)),ring_1_of_int(A,L)) ) ) ).

% of_int_and_eq
tff(fact_2388_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A,Nb: nat] :
          ( ! [N: nat] :
              ( ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
              | ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N) )
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),Nb)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
              | aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),Nb) ) ) ) ) ).

% bit_disjunctive_add_iff
tff(fact_2389_real__sqrt__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X2)),aa(real,real,sqrt,Y2)) ) ).

% real_sqrt_less_mono
tff(fact_2390_real__sqrt__mult,axiom,
    ! [X2: real,Y2: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X2),Y2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,X2)),aa(real,real,sqrt,Y2)) ) ).

% real_sqrt_mult
tff(fact_2391_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),Ma),A2)),Nb)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
            & ( Ma != Nb ) ) ) ) ).

% bit_unset_bit_iff
tff(fact_2392_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( A2 = aa(A,A,uminus_uminus(A),one_one(A)) )
            & ( B2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% and_eq_minus_1_iff
tff(fact_2393_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(nat,nat,suc,Nb)) ) ).

% not_bit_1_Suc
tff(fact_2394_bit__1__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),Nb)
        <=> ( Nb = zero_zero(nat) ) ) ) ).

% bit_1_iff
tff(fact_2395_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: num] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(num,nat,numeral_numeral(nat),Nb)) ) ).

% bit_numeral_simps(1)
tff(fact_2396_real__sqrt__gt__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sqrt,X2)) ) ).

% real_sqrt_gt_zero
tff(fact_2397_real__sqrt__eq__zero__cancel,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( ( aa(real,real,sqrt,X2) = zero_zero(real) )
       => ( X2 = zero_zero(real) ) ) ) ).

% real_sqrt_eq_zero_cancel
tff(fact_2398_real__sqrt__ge__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,X2)) ) ).

% real_sqrt_ge_zero
tff(fact_2399_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),A2)),Nb)
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb) ) ) ) ).

% bit_take_bit_iff
tff(fact_2400_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [B2: $o,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa($o,A,zero_neq_one_of_bool(A),B2)),Nb)
        <=> ( (B2)
            & ( Nb = zero_zero(nat) ) ) ) ) ).

% bit_of_bool_iff
tff(fact_2401_AND__lower,axiom,
    ! [X2: int,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Y2)) ) ).

% AND_lower
tff(fact_2402_AND__upper1,axiom,
    ! [X2: int,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Y2)),X2) ) ).

% AND_upper1
tff(fact_2403_AND__upper2,axiom,
    ! [Y2: int,X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Y2)),Y2) ) ).

% AND_upper2
tff(fact_2404_AND__upper1_H,axiom,
    ! [Y2: int,Z: int,Ya: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y2),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Y2),Ya)),Z) ) ) ).

% AND_upper1'
tff(fact_2405_AND__upper2_H,axiom,
    ! [Y2: int,Z: int,X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y2),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Y2)),Z) ) ) ).

% AND_upper2'
tff(fact_2406_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),bit_se2239418461657761734s_mask(A,Nb)) ) ) ).

% take_bit_eq_mask
tff(fact_2407_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Nb: nat] :
          ( ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
         => ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) ) ) ) ).

% signed_take_bit_eq_if_positive
tff(fact_2408_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Nb: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = zero_zero(A) )
        <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb) ) ) ).

% and_exp_eq_0_iff_not_bit
tff(fact_2409_real__div__sqrt,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),aa(real,real,sqrt,X2)) = aa(real,real,sqrt,X2) ) ) ).

% real_div_sqrt
tff(fact_2410_sqrt__add__le__add__sqrt,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,sqrt,X2)),aa(real,real,sqrt,Y2))) ) ) ).

% sqrt_add_le_add_sqrt
tff(fact_2411_le__real__sqrt__sumsq,axiom,
    ! [X2: real,Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),X2),X2)),aa(real,real,aa(real,fun(real,real),times_times(real),Y2),Y2)))) ).

% le_real_sqrt_sumsq
tff(fact_2412_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),K) ) ).

% and_less_eq
tff(fact_2413_AND__upper1_H_H,axiom,
    ! [Y2: int,Z: int,Ya: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y2),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Y2),Ya)),Z) ) ) ).

% AND_upper1''
tff(fact_2414_AND__upper2_H_H,axiom,
    ! [Y2: int,Z: int,X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y2),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Y2)),Z) ) ) ).

% AND_upper2''
tff(fact_2415_bit__not__int__iff_H,axiom,
    ! [K: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),K)),one_one(int))),Nb)
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb) ) ).

% bit_not_int_iff'
tff(fact_2416_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( bit_se8732182000553998342ip_bit(A,Nb,A2)
          = aa(A,A,
              aa(nat,fun(A,A),$ite(aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb),bit_se2638667681897837118et_bit(A),bit_se5668285175392031749et_bit(A)),Nb),
              A2) ) ) ).

% flip_bit_eq_if
tff(fact_2417_even__and__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_and_iff
tff(fact_2418_sqrt2__less__2,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% sqrt2_less_2
tff(fact_2419_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
        | aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L) ) ) ).

% even_and_iff_int
tff(fact_2420_bit__imp__take__bit__positive,axiom,
    ! [Nb: nat,Ma: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
     => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,Ma),K)) ) ) ).

% bit_imp_take_bit_positive
tff(fact_2421_bit__concat__bit__iff,axiom,
    ! [Ma: nat,K: int,L: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_concat_bit(Ma,K),L)),Nb)
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
          & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb) )
        | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
          & aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)) ) ) ) ).

% bit_concat_bit_iff
tff(fact_2422_signed__take__bit__eq__concat__bit,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Nb),K) = aa(int,int,bit_concat_bit(Nb,K),aa(int,int,uminus_uminus(int),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb)))) ) ).

% signed_take_bit_eq_concat_bit
tff(fact_2423_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Nb: nat,A2: A] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) = zero_zero(A) )
         => ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb) ) ) ).

% exp_eq_0_imp_not_bit
tff(fact_2424_bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,suc,Nb))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),Nb) ) ) ).

% bit_Suc
tff(fact_2425_and__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),one_one(A)) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% and_one_eq
tff(fact_2426_one__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),A2) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% one_and_eq
tff(fact_2427_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( ! [N: nat] :
              ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
            <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 ) ) ) ).

% bit_iff_idd_imp_stable
tff(fact_2428_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 )
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
          <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ) ).

% stable_imp_bit_iff_odd
tff(fact_2429_real__less__rsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Y2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,sqrt,Y2)) ) ).

% real_less_rsqrt
tff(fact_2430_sqrt__le__D,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X2)),Y2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% sqrt_le_D
tff(fact_2431_real__le__rsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Y2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,sqrt,Y2)) ) ).

% real_le_rsqrt
tff(fact_2432_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list(A),Nb: nat,Xs: list(A)] :
      ( aa(set(list(A)),$o,member(list(A),Ys),aa(list(list(A)),set(list(A)),set2(list(A)),n_lists(A,Nb,Xs)))
     => ( aa(list(A),nat,size_size(list(A)),Ys) = Nb ) ) ).

% length_n_lists_elem
tff(fact_2433_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N: nat] :
          ( ! [M: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
             => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),M)
              <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) ) )
         => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))
              <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) ) ) ) ).

% int_bit_bound
tff(fact_2434_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb))) ) ) ).

% bit_iff_odd
tff(fact_2435_real__le__lsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X2)),Y2) ) ) ) ).

% real_le_lsqrt
tff(fact_2436_real__sqrt__unique,axiom,
    ! [Y2: real,X2: real] :
      ( ( aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = X2 )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( aa(real,real,sqrt,X2) = Y2 ) ) ) ).

% real_sqrt_unique
tff(fact_2437_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),U)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),U) ) ).

% lemma_real_divide_sqrt_less
tff(fact_2438_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X2: real,Y2: real] :
      ( ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) = X2 )
     => ( Y2 = zero_zero(real) ) ) ).

% real_sqrt_sum_squares_eq_cancel
tff(fact_2439_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X2: real,Y2: real] :
      ( ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) = Y2 )
     => ( X2 = zero_zero(real) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
tff(fact_2440_real__sqrt__sum__squares__ge1,axiom,
    ! [X2: real,Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% real_sqrt_sum_squares_ge1
tff(fact_2441_real__sqrt__sum__squares__ge2,axiom,
    ! [Y2: real,X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% real_sqrt_sum_squares_ge2
tff(fact_2442_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),C2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),B2),D2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,C2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,D2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ).

% real_sqrt_sum_squares_triangle_ineq
tff(fact_2443_bit__int__def,axiom,
    ! [K: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb)
    <=> ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))) ) ).

% bit_int_def
tff(fact_2444_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),Nb)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
              | ( Nb = zero_zero(nat) ) ) ) ) ) ).

% even_bit_succ_iff
tff(fact_2445_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),Nb)
              | ( Nb = zero_zero(nat) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
tff(fact_2446_real__less__lsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X2)),Y2) ) ) ) ).

% real_less_lsqrt
tff(fact_2447_sqrt__sum__squares__le__sum,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2)) ) ) ).

% sqrt_sum_squares_le_sum
tff(fact_2448_sqrt__even__pow2,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(real,real,sqrt,aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),Nb)) = aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% sqrt_even_pow2
tff(fact_2449_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,Nb: nat] :
          ( ! [J: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,suc,J))
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),Nb)
          <=> $ite(Nb = zero_zero(nat),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2),aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)),Nb)) ) ) ) ).

% bit_sum_mult_2_cases
tff(fact_2450_bit__rec,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
        <=> $ite(Nb = zero_zero(nat),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2),aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))) ) ) ).

% bit_rec
tff(fact_2451_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X2: real,Y2: real,Xa2: real,Ya: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,Xa2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Ya),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ).

% real_sqrt_sum_squares_mult_ge_zero
tff(fact_2452_real__sqrt__power__even,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
       => ( aa(nat,real,power_power(real,aa(real,real,sqrt,X2)),Nb) = aa(nat,real,power_power(real,X2),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ) ).

% real_sqrt_power_even
tff(fact_2453_arith__geo__mean__sqrt,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X2),Y2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ).

% arith_geo_mean_sqrt
tff(fact_2454_and__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
            & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ).

% and_int_rec
tff(fact_2455_set__bit__eq,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Nb),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(int,int,aa(int,fun(int,int),times_times(int),aa($o,int,zero_neq_one_of_bool(int),~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb))),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))) ) ).

% set_bit_eq
tff(fact_2456_unset__bit__eq,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Nb),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(int,int,aa(int,fun(int,int),times_times(int),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb))),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))) ) ).

% unset_bit_eq
tff(fact_2457_take__bit__Suc__from__most,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Nb)),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb)))),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) ) ).

% take_bit_Suc_from_most
tff(fact_2458_exp__le__one__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),X2)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real)) ) ).

% exp_le_one_iff
tff(fact_2459_one__le__exp__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,exp(real),X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2) ) ).

% one_le_exp_iff
tff(fact_2460_exp__less__one__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X2)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real)) ) ).

% exp_less_one_iff
tff(fact_2461_one__less__exp__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,exp(real),X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2) ) ).

% one_less_exp_iff
tff(fact_2462_real__exp__bound__lemma,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),X2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X2))) ) ) ).

% real_exp_bound_lemma
tff(fact_2463_exp__bound,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),X2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% exp_bound
tff(fact_2464_exp__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X2)),aa(real,real,exp(real),Y2)) ) ).

% exp_less_mono
tff(fact_2465_exp__less__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X2)),aa(real,real,exp(real),Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ).

% exp_less_cancel_iff
tff(fact_2466_exp__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,exp(A),zero_zero(A)) = one_one(A) ) ) ).

% exp_zero
tff(fact_2467_exp__eq__one__iff,axiom,
    ! [X2: real] :
      ( ( aa(real,real,exp(real),X2) = one_one(real) )
    <=> ( X2 = zero_zero(real) ) ) ).

% exp_eq_one_iff
tff(fact_2468_and__nat__numerals_I1_J,axiom,
    ! [Y2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Y2))) = zero_zero(nat) ) ).

% and_nat_numerals(1)
tff(fact_2469_and__nat__numerals_I3_J,axiom,
    ! [X2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,X2))),aa(nat,nat,suc,zero_zero(nat))) = zero_zero(nat) ) ).

% and_nat_numerals(3)
tff(fact_2470_and__nat__numerals_I4_J,axiom,
    ! [X2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X2))),aa(nat,nat,suc,zero_zero(nat))) = one_one(nat) ) ).

% and_nat_numerals(4)
tff(fact_2471_and__nat__numerals_I2_J,axiom,
    ! [Y2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y2))) = one_one(nat) ) ).

% and_nat_numerals(2)
tff(fact_2472_and__Suc__0__eq,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),Nb),aa(nat,nat,suc,zero_zero(nat))) = modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% and_Suc_0_eq
tff(fact_2473_Suc__0__and__eq,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),Nb) = modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Suc_0_and_eq
tff(fact_2474_not__bit__Suc__0__Suc,axiom,
    ! [Nb: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,suc,Nb)) ).

% not_bit_Suc_0_Suc
tff(fact_2475_bit__Suc__0__iff,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),Nb)
    <=> ( Nb = zero_zero(nat) ) ) ).

% bit_Suc_0_iff
tff(fact_2476_not__bit__Suc__0__numeral,axiom,
    ! [Nb: num] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),Nb)) ).

% not_bit_Suc_0_numeral
tff(fact_2477_bit__nat__def,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,Ma),Nb)
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) ) ).

% bit_nat_def
tff(fact_2478_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : ( aa(A,A,exp(A),X2) != zero_zero(A) ) ) ).

% exp_not_eq_zero
tff(fact_2479_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),A3)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,exp(A),A3)) ) ) ).

% exp_times_arg_commute
tff(fact_2480_exp__less__cancel,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X2)),aa(real,real,exp(real),Y2))
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ).

% exp_less_cancel
tff(fact_2481_and__nat__unfold,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),Ma),Nb)
      = $ite(
          ( ( Ma = zero_zero(nat) )
          | ( Nb = zero_zero(nat) ) ),
          zero_zero(nat),
          aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% and_nat_unfold
tff(fact_2482_and__nat__rec,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),Ma),Nb)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma)
            & ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% and_nat_rec
tff(fact_2483_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X2)),aa(A,A,exp(A),Y2)) = aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) ) ) ).

% mult_exp_exp
tff(fact_2484_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A,Y2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2) = aa(A,A,aa(A,fun(A,A),times_times(A),Y2),X2) )
         => ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X2)),aa(A,A,exp(A),Y2)) ) ) ) ).

% exp_add_commuting
tff(fact_2485_exp__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,exp(A),X2)),aa(A,A,exp(A),Y2)) ) ) ).

% exp_diff
tff(fact_2486_not__exp__less__zero,axiom,
    ! [X2: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X2)),zero_zero(real)) ).

% not_exp_less_zero
tff(fact_2487_exp__gt__zero,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,exp(real),X2)) ).

% exp_gt_zero
tff(fact_2488_exp__total,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
     => ? [X4: real] : ( aa(real,real,exp(real),X4) = Y2 ) ) ).

% exp_total
tff(fact_2489_exp__ge__zero,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,exp(real),X2)) ).

% exp_ge_zero
tff(fact_2490_not__exp__le__zero,axiom,
    ! [X2: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),X2)),zero_zero(real)) ).

% not_exp_le_zero
tff(fact_2491_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X2)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X2))) = one_one(A) ) ) ).

% exp_minus_inverse
tff(fact_2492_exp__gt__one,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,exp(real),X2)) ) ).

% exp_gt_one
tff(fact_2493_exp__ge__add__one__self__aux,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2)),aa(real,real,exp(real),X2)) ) ).

% exp_ge_add_one_self_aux
tff(fact_2494_lemma__exp__total,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Y2)
     => ? [X4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X4)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),aa(real,real,aa(real,fun(real,real),minus_minus(real),Y2),one_one(real)))
          & ( aa(real,real,exp(real),X4) = Y2 ) ) ) ).

% lemma_exp_total
tff(fact_2495_exp__le,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),one_one(real))),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))) ).

% exp_le
tff(fact_2496_exp__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z)) = aa(nat,A,power_power(A,aa(A,A,exp(A),Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% exp_double
tff(fact_2497_exp__half__le2,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% exp_half_le2
tff(fact_2498_arsinh__real__aux,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))))) ).

% arsinh_real_aux
tff(fact_2499_arcosh__1,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,arcosh(A),one_one(A)) = zero_zero(A) ) ) ).

% arcosh_1
tff(fact_2500_length__n__lists,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(list(A)),nat,size_size(list(list(A))),n_lists(A,Nb,Xs)) = aa(nat,nat,power_power(nat,aa(list(A),nat,size_size(list(A)),Xs)),Nb) ) ).

% length_n_lists
tff(fact_2501_artanh__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ( aa(A,A,artanh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% artanh_0
tff(fact_2502_arsinh__0,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,arsinh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% arsinh_0
tff(fact_2503_tanh__real__altdef,axiom,
    ! [X2: real] : ( aa(real,real,tanh(real),X2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X2)))) ) ).

% tanh_real_altdef
tff(fact_2504_ln__one__minus__pos__lower__bound,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,uminus_uminus(real),X2)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),X2))) ) ) ).

% ln_one_minus_pos_lower_bound
tff(fact_2505_tanh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,tanh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% tanh_0
tff(fact_2506_tanh__real__zero__iff,axiom,
    ! [X2: real] :
      ( ( aa(real,real,tanh(real),X2) = zero_zero(real) )
    <=> ( X2 = zero_zero(real) ) ) ).

% tanh_real_zero_iff
tff(fact_2507_tanh__real__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),X2)),aa(real,real,tanh(real),Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ).

% tanh_real_less_iff
tff(fact_2508_ln__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,ln_ln(A),one_one(A)) = zero_zero(A) ) ) ).

% ln_one
tff(fact_2509_ln__inj__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
       => ( ( aa(real,real,ln_ln(real),X2) = aa(real,real,ln_ln(real),Y2) )
        <=> ( X2 = Y2 ) ) ) ) ).

% ln_inj_iff
tff(fact_2510_ln__less__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),X2)),aa(real,real,ln_ln(real),Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ) ) ).

% ln_less_cancel_iff
tff(fact_2511_tanh__real__neg__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real)) ) ).

% tanh_real_neg_iff
tff(fact_2512_tanh__real__pos__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,tanh(real),X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2) ) ).

% tanh_real_pos_iff
tff(fact_2513_tanh__real__nonpos__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tanh(real),X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real)) ) ).

% tanh_real_nonpos_iff
tff(fact_2514_tanh__real__nonneg__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,tanh(real),X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2) ) ).

% tanh_real_nonneg_iff
tff(fact_2515_ln__le__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X2)),aa(real,real,ln_ln(real),Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2) ) ) ) ).

% ln_le_cancel_iff
tff(fact_2516_ln__eq__zero__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( ( aa(real,real,ln_ln(real),X2) = zero_zero(real) )
      <=> ( X2 = one_one(real) ) ) ) ).

% ln_eq_zero_iff
tff(fact_2517_ln__gt__zero__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2) ) ) ).

% ln_gt_zero_iff
tff(fact_2518_ln__less__zero__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),X2)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real)) ) ) ).

% ln_less_zero_iff
tff(fact_2519_exp__ln__iff,axiom,
    ! [X2: real] :
      ( ( aa(real,real,exp(real),aa(real,real,ln_ln(real),X2)) = X2 )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2) ) ).

% exp_ln_iff
tff(fact_2520_exp__ln,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,real,exp(real),aa(real,real,ln_ln(real),X2)) = X2 ) ) ).

% exp_ln
tff(fact_2521_ln__ge__zero__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2) ) ) ).

% ln_ge_zero_iff
tff(fact_2522_ln__le__zero__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X2)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real)) ) ) ).

% ln_le_zero_iff
tff(fact_2523_ln__less__self,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),X2)),X2) ) ).

% ln_less_self
tff(fact_2524_tanh__real__lt__1,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),X2)),one_one(real)) ).

% tanh_real_lt_1
tff(fact_2525_ln__bound,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X2)),X2) ) ).

% ln_bound
tff(fact_2526_ln__gt__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X2)) ) ).

% ln_gt_zero
tff(fact_2527_ln__less__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),X2)),zero_zero(real)) ) ) ).

% ln_less_zero
tff(fact_2528_ln__gt__zero__imp__gt__one,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2) ) ) ).

% ln_gt_zero_imp_gt_one
tff(fact_2529_ln__ge__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X2)) ) ).

% ln_ge_zero
tff(fact_2530_tanh__real__gt__neg1,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(real,real,tanh(real),X2)) ).

% tanh_real_gt_neg1
tff(fact_2531_ln__ge__zero__imp__ge__one,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2) ) ) ).

% ln_ge_zero_imp_ge_one
tff(fact_2532_ln__add__one__self__le__self,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2))),X2) ) ).

% ln_add_one_self_le_self
tff(fact_2533_ln__mult,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
       => ( aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),times_times(real),X2),Y2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,ln_ln(real),X2)),aa(real,real,ln_ln(real),Y2)) ) ) ) ).

% ln_mult
tff(fact_2534_ln__eq__minus__one,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( ( aa(real,real,ln_ln(real),X2) = aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),one_one(real)) )
       => ( X2 = one_one(real) ) ) ) ).

% ln_eq_minus_one
tff(fact_2535_ln__div,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
       => ( aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),Y2)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),X2)),aa(real,real,ln_ln(real),Y2)) ) ) ) ).

% ln_div
tff(fact_2536_ln__ge__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,ln_ln(real),X2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),Y2)),X2) ) ) ).

% ln_ge_iff
tff(fact_2537_arsinh__real__def,axiom,
    ! [X2: real] : ( aa(real,real,arsinh(real),X2) = aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))))) ) ).

% arsinh_real_def
tff(fact_2538_ln__2__less__1,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),one_one(real)) ).

% ln_2_less_1
tff(fact_2539_ln__le__minus__one,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X2)),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),one_one(real))) ) ).

% ln_le_minus_one
tff(fact_2540_ln__diff__le,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),X2)),aa(real,real,ln_ln(real),Y2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y2)),Y2)) ) ) ).

% ln_diff_le
tff(fact_2541_ln__add__one__self__le__self2,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2))),X2) ) ).

% ln_add_one_self_le_self2
tff(fact_2542_tanh__ln__real,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,real,tanh(real),aa(real,real,ln_ln(real),X2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))) ) ) ).

% tanh_ln_real
tff(fact_2543_arcosh__real__def,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2)
     => ( aa(real,real,arcosh(real),X2) = aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))))) ) ) ).

% arcosh_real_def
tff(fact_2544_ln__one__minus__pos__upper__bound,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),X2))),aa(real,real,uminus_uminus(real),X2)) ) ) ).

% ln_one_minus_pos_upper_bound
tff(fact_2545_ln__sqrt,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,real,ln_ln(real),aa(real,real,sqrt,X2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),X2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ).

% ln_sqrt
tff(fact_2546_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(A,A,tanh(A),X2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),X2)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),X2)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X2)))) ) ) ).

% tanh_altdef
tff(fact_2547_ln__one__plus__pos__lower__bound,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2))) ) ) ).

% ln_one_plus_pos_lower_bound
tff(fact_2548_artanh__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X2: A] : ( aa(A,A,artanh(A),X2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),X2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% artanh_def
tff(fact_2549_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2))),X2))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
tff(fact_2550_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2))),X2))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% abs_ln_one_plus_x_minus_x_bound
tff(fact_2551_arctan__half,axiom,
    ! [X2: real] : ( aa(real,real,arctan,X2) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))))) ) ).

% arctan_half
tff(fact_2552_log__base__10__eq1,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,one2))))),X2) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),aa(real,real,exp(real),one_one(real)))),aa(real,real,ln_ln(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,one2))))))),aa(real,real,ln_ln(real),X2)) ) ) ).

% log_base_10_eq1
tff(fact_2553_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2))),X2))),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
tff(fact_2554_log__base__10__eq2,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,one2))))),X2) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,one2))))),aa(real,real,exp(real),one_one(real)))),aa(real,real,ln_ln(real),X2)) ) ) ).

% log_base_10_eq2
tff(fact_2555_abs__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_abs
tff(fact_2556_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_idempotent
tff(fact_2557_abs__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_zero
tff(fact_2558_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_eq_0
tff(fact_2559_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,abs_abs(A),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_0_eq
tff(fact_2560_abs__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_0
tff(fact_2561_abs__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num] : ( aa(A,A,abs_abs(A),aa(num,A,numeral_numeral(A),Nb)) = aa(num,A,numeral_numeral(A),Nb) ) ) ).

% abs_numeral
tff(fact_2562_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),A2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) ) ) ).

% abs_mult_self_eq
tff(fact_2563_abs__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_1
tff(fact_2564_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_add_abs
tff(fact_2565_abs__divide,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_divide
tff(fact_2566_abs__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_minus
tff(fact_2567_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_minus_cancel
tff(fact_2568_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: A,K: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,abs_abs(A),Ma)),K)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Ma),K) ) ) ).

% abs_dvd_iff
tff(fact_2569_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Ma: A,K: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Ma),aa(A,A,abs_abs(A),K))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Ma),K) ) ) ).

% dvd_abs_iff
tff(fact_2570_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: $o] : ( aa(A,A,abs_abs(A),aa($o,A,zero_neq_one_of_bool(A),P)) = aa($o,A,zero_neq_one_of_bool(A),P) ) ) ).

% abs_bool_eq
tff(fact_2571_arctan__eq__zero__iff,axiom,
    ! [X2: real] :
      ( ( aa(real,real,arctan,X2) = zero_zero(real) )
    <=> ( X2 = zero_zero(real) ) ) ).

% arctan_eq_zero_iff
tff(fact_2572_arctan__zero__zero,axiom,
    aa(real,real,arctan,zero_zero(real)) = zero_zero(real) ).

% arctan_zero_zero
tff(fact_2573_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),zero_zero(A))
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_le_zero_iff
tff(fact_2574_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% abs_le_self_iff
tff(fact_2575_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,A,abs_abs(A),A2) = A2 ) ) ) ).

% abs_of_nonneg
tff(fact_2576_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,abs_abs(A),A2))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% zero_less_abs_iff
tff(fact_2577_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(num,A,numeral_numeral(A),Nb) ) ) ).

% abs_neg_numeral
tff(fact_2578_abs__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),one_one(A))) = one_one(A) ) ) ).

% abs_neg_one
tff(fact_2579_abs__power__minus,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),A2)),Nb)) = aa(A,A,abs_abs(A),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% abs_power_minus
tff(fact_2580_log__one,axiom,
    ! [A2: real] : ( aa(real,real,log(A2),one_one(real)) = zero_zero(real) ) ).

% log_one
tff(fact_2581_zero__less__arctan__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,arctan,X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2) ) ).

% zero_less_arctan_iff
tff(fact_2582_arctan__less__zero__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real)) ) ).

% arctan_less_zero_iff
tff(fact_2583_arctan__le__zero__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arctan,X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real)) ) ).

% arctan_le_zero_iff
tff(fact_2584_zero__le__arctan__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arctan,X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2) ) ).

% zero_le_arctan_iff
tff(fact_2585_real__sqrt__abs2,axiom,
    ! [X2: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X2),X2)) = aa(real,real,abs_abs(real),X2) ) ).

% real_sqrt_abs2
tff(fact_2586_real__sqrt__mult__self,axiom,
    ! [A2: real] : ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,A2)),aa(real,real,sqrt,A2)) = aa(real,real,abs_abs(real),A2) ) ).

% real_sqrt_mult_self
tff(fact_2587_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,abs_abs(A),B2)))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            | ( B2 = zero_zero(A) ) ) ) ) ).

% zero_le_divide_abs_iff
tff(fact_2588_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,abs_abs(A),B2))),zero_zero(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divide_le_0_abs_iff
tff(fact_2589_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,A,abs_abs(A),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% abs_of_nonpos
tff(fact_2590_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,log(A2),X2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2) ) ) ) ).

% zero_less_log_cancel_iff
tff(fact_2591_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),X2)),zero_zero(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real)) ) ) ) ).

% log_less_zero_cancel_iff
tff(fact_2592_one__less__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,log(A2),X2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X2) ) ) ) ).

% one_less_log_cancel_iff
tff(fact_2593_log__less__one__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),X2)),one_one(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),A2) ) ) ) ).

% log_less_one_cancel_iff
tff(fact_2594_log__less__cancel__iff,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),X2)),aa(real,real,log(A2),Y2))
          <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ) ) ) ).

% log_less_cancel_iff
tff(fact_2595_log__eq__one,axiom,
    ! [A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),A2) = one_one(real) ) ) ) ).

% log_eq_one
tff(fact_2596_artanh__minus__real,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => ( aa(real,real,artanh(real),aa(real,real,uminus_uminus(real),X2)) = aa(real,real,uminus_uminus(real),aa(real,real,artanh(real),X2)) ) ) ).

% artanh_minus_real
tff(fact_2597_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A2)),Nb))
        <=> ( ( A2 != zero_zero(A) )
            | ( Nb = zero_zero(nat) ) ) ) ) ).

% zero_less_power_abs_iff
tff(fact_2598_power2__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% power2_abs
tff(fact_2599_abs__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% abs_power2
tff(fact_2600_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,log(A2),X2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2) ) ) ) ).

% zero_le_log_cancel_iff
tff(fact_2601_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),X2)),zero_zero(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real)) ) ) ) ).

% log_le_zero_cancel_iff
tff(fact_2602_one__le__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,log(A2),X2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X2) ) ) ) ).

% one_le_log_cancel_iff
tff(fact_2603_log__le__one__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),X2)),one_one(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),A2) ) ) ) ).

% log_le_one_cancel_iff
tff(fact_2604_log__le__cancel__iff,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),X2)),aa(real,real,log(A2),Y2))
          <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2) ) ) ) ) ).

% log_le_cancel_iff
tff(fact_2605_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: num,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
         => ( aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A2)),aa(num,nat,numeral_numeral(nat),W)) = aa(nat,A,power_power(A,A2),aa(num,nat,numeral_numeral(nat),W)) ) ) ) ).

% power_even_abs_numeral
tff(fact_2606_real__sqrt__abs,axiom,
    ! [X2: real] : ( aa(real,real,sqrt,aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(real,real,abs_abs(real),X2) ) ).

% real_sqrt_abs
tff(fact_2607_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% abs_le_D1
tff(fact_2608_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_self
tff(fact_2609_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_eq_0_iff
tff(fact_2610_abs__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_mult
tff(fact_2611_abs__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_one
tff(fact_2612_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) ) ) ).

% abs_minus_commute
tff(fact_2613_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(A,A,abs_abs(A),X2) = aa(A,A,abs_abs(A),Y2) )
        <=> ( ( X2 = Y2 )
            | ( X2 = aa(A,A,uminus_uminus(A),Y2) ) ) ) ) ).

% abs_eq_iff
tff(fact_2614_power__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,power_power(A,A2),Nb)) = aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A2)),Nb) ) ) ).

% power_abs
tff(fact_2615_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [L: A,K: A] :
          ( ( aa(A,A,abs_abs(A),L) = aa(A,A,abs_abs(A),K) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),L),K) ) ) ).

% dvd_if_abs_eq
tff(fact_2616_arctan__monotone,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,X2)),aa(real,real,arctan,Y2)) ) ).

% arctan_monotone
tff(fact_2617_arctan__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,X2)),aa(real,real,arctan,Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ).

% arctan_less_iff
tff(fact_2618_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_zero
tff(fact_2619_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,A,abs_abs(A),A2) = A2 ) ) ) ).

% abs_of_pos
tff(fact_2620_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),zero_zero(A)) ) ).

% abs_not_less_zero
tff(fact_2621_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) ) ).

% abs_triangle_ineq
tff(fact_2622_abs__mult__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),B2)),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2)) ) ) ) ).

% abs_mult_less
tff(fact_2623_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% abs_triangle_ineq2
tff(fact_2624_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% abs_triangle_ineq3
tff(fact_2625_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))) ) ).

% abs_triangle_ineq2_sym
tff(fact_2626_abs__leI,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2) ) ) ) ).

% abs_leI
tff(fact_2627_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% abs_le_D2
tff(fact_2628_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ) ).

% abs_le_iff
tff(fact_2629_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_minus_self
tff(fact_2630_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% nonzero_abs_divide
tff(fact_2631_abs__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ) ).

% abs_less_iff
tff(fact_2632_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs(A)
        & dense_linorder(A) )
     => ! [X2: A] :
          ( ! [E: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),E) )
         => ( X2 = zero_zero(A) ) ) ) ).

% dense_eq0_I
tff(fact_2633_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ordered_ring_abs(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
              | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% abs_eq_mult
tff(fact_2634_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),Y2)),X2) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),X2)) ) ) ) ).

% abs_mult_pos
tff(fact_2635_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = B2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
            & ( ( A2 = B2 )
              | ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ) ).

% abs_eq_iff'
tff(fact_2636_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,abs_abs(A),B2) )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            & ( ( B2 = A2 )
              | ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ) ) ).

% eq_abs_iff'
tff(fact_2637_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,abs_abs(A),A2))),zero_zero(A)) ) ).

% abs_minus_le_zero
tff(fact_2638_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A2)),Nb)) ) ).

% zero_le_power_abs
tff(fact_2639_abs__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),X2)),Y2) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2)) ) ) ) ).

% abs_div_pos
tff(fact_2640_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,A,abs_abs(A),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% abs_of_neg
tff(fact_2641_abs__if__raw,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [X: A] :
          ( aa(A,A,abs_abs(A),X)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),zero_zero(A)),aa(A,A,uminus_uminus(A),X),X) ) ) ).

% abs_if_raw
tff(fact_2642_abs__if,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [A2: A] :
          ( aa(A,A,abs_abs(A),A2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)),aa(A,A,uminus_uminus(A),A2),A2) ) ) ).

% abs_if
tff(fact_2643_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,A2: A,R: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A2))),R)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),R)),X2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),R)) ) ) ) ).

% abs_diff_le_iff
tff(fact_2644_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A,C2: A,D2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)))) ) ).

% abs_diff_triangle_ineq
tff(fact_2645_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) ) ).

% abs_triangle_ineq4
tff(fact_2646_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,A2: A,R: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A2))),R)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),R)),X2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),R)) ) ) ) ).

% abs_diff_less_iff
tff(fact_2647_abs__real__def,axiom,
    ! [A2: real] :
      ( aa(real,real,abs_abs(real),A2)
      = $ite(aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real)),aa(real,real,uminus_uminus(real),A2),A2) ) ).

% abs_real_def
tff(fact_2648_lemma__interval__lt,axiom,
    ! [A2: real,X2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),B2)
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [Y3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y3))),D3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Y3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),B2) ) ) ) ) ) ).

% lemma_interval_lt
tff(fact_2649_arctan__add,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Y2)),one_one(real))
       => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,arctan,X2)),aa(real,real,arctan,Y2)) = aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),X2),Y2)))) ) ) ) ).

% arctan_add
tff(fact_2650_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,abs_abs(A),X2))) ) ).

% abs_add_one_gt_zero
tff(fact_2651_log__base__change,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(B2),X2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A2),X2)),aa(real,real,log(A2),B2)) ) ) ) ).

% log_base_change
tff(fact_2652_of__int__leD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: int,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),ring_1_of_int(A,Nb))),X2)
         => ( ( Nb = zero_zero(int) )
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),X2) ) ) ) ).

% of_int_leD
tff(fact_2653_of__int__lessD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: int,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),ring_1_of_int(A,Nb))),X2)
         => ( ( Nb = zero_zero(int) )
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),X2) ) ) ) ).

% of_int_lessD
tff(fact_2654_lemma__interval,axiom,
    ! [A2: real,X2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),B2)
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [Y3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y3))),D3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Y3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),B2) ) ) ) ) ) ).

% lemma_interval
tff(fact_2655_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),aa(A,A,abs_abs(A),Y2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% abs_le_square_iff
tff(fact_2656_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( ( aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
        <=> ( aa(A,A,abs_abs(A),X2) = one_one(A) ) ) ) ).

% abs_square_eq_1
tff(fact_2657_power__even__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => ( aa(nat,A,power_power(A,aa(A,A,abs_abs(A),A2)),Nb) = aa(nat,A,power_power(A,A2),Nb) ) ) ) ).

% power_even_abs
tff(fact_2658_log__mult,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
           => ( aa(real,real,log(A2),aa(real,real,aa(real,fun(real,real),times_times(real),X2),Y2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,log(A2),X2)),aa(real,real,log(A2),Y2)) ) ) ) ) ) ).

% log_mult
tff(fact_2659_log__divide,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
           => ( aa(real,real,log(A2),aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),Y2)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,log(A2),X2)),aa(real,real,log(A2),Y2)) ) ) ) ) ) ).

% log_divide
tff(fact_2660_arctan__double,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,arctan,X2)) = aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X2)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% arctan_double
tff(fact_2661_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),Y2) ) ) ) ).

% power2_le_iff_abs_le
tff(fact_2662_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),one_one(A)) ) ) ).

% abs_square_le_1
tff(fact_2663_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),X2)),one_one(A)) ) ) ).

% abs_square_less_1
tff(fact_2664_power__mono__even,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb)) ) ) ) ).

% power_mono_even
tff(fact_2665_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
         => ( ( B2 != one_one(real) )
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
             => ( aa(real,real,log(A2),X2) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),B2)),aa(real,real,ln_ln(real),A2))),aa(real,real,log(B2),X2)) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
tff(fact_2666_sqrt__ge__absD,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),aa(real,real,sqrt,Y2))
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Y2) ) ).

% sqrt_ge_absD
tff(fact_2667_real__sqrt__ge__abs1,axiom,
    ! [X2: real,Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% real_sqrt_ge_abs1
tff(fact_2668_real__sqrt__ge__abs2,axiom,
    ! [Y2: real,X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y2)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% real_sqrt_ge_abs2
tff(fact_2669_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X2: real,Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),X2)),aa(real,real,abs_abs(real),Y2))) ).

% sqrt_sum_squares_le_sum_abs
tff(fact_2670_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,archimedean_round(A,X2))),X2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ).

% of_int_round_abs_le
tff(fact_2671_round__unique_H,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Nb: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),ring_1_of_int(A,Nb)))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))
         => ( archimedean_round(A,X2) = Nb ) ) ) ).

% round_unique'
tff(fact_2672_cos__x__y__le__one,axiom,
    ! [X2: real,Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))),one_one(real)) ).

% cos_x_y_le_one
tff(fact_2673_real__sqrt__sum__squares__less,axiom,
    ! [X2: real,U: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),U) ) ) ).

% real_sqrt_sum_squares_less
tff(fact_2674_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: fun(A,fun(A,$o)),X2: A] :
          ( ! [X4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X4)
             => aa(A,$o,aa(A,fun(A,$o),P,X4),aa(nat,A,power_power(A,X4),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) )
         => aa(A,$o,aa(A,fun(A,$o),P,aa(A,A,abs_abs(A),X2)),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% abs_sqrt_wlog
tff(fact_2675_log2__of__power__le,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Ma))),aa(nat,real,semiring_1_of_nat(real),Nb)) ) ) ).

% log2_of_power_le
tff(fact_2676_machin,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit0,one2))))))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))) ).

% machin
tff(fact_2677_machin__Euler,axiom,
    aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit0,one2)))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,one2))))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) ).

% machin_Euler
tff(fact_2678_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(nat,real,semiring_1_of_nat(real),Nb))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),aa(nat,real,semiring_1_of_nat(real),Nb)))),Nb)),aa(real,real,exp(real),aa(real,real,uminus_uminus(real),X2))) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
tff(fact_2679_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(nat,real,semiring_1_of_nat(real),Nb))),X2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),aa(nat,real,semiring_1_of_nat(real),Nb)))),Nb)),aa(real,real,exp(real),X2)) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
tff(fact_2680_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Ma: nat,Nb: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Ma) = aa(nat,A,semiring_1_of_nat(A),Nb) )
        <=> ( Ma = Nb ) ) ) ).

% of_nat_eq_iff
tff(fact_2681_abs__of__nat,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,semiring_1_of_nat(A),Nb)) = aa(nat,A,semiring_1_of_nat(A),Nb) ) ) ).

% abs_of_nat
tff(fact_2682_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Ma: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Ma) = zero_zero(A) )
        <=> ( Ma = zero_zero(nat) ) ) ) ).

% of_nat_eq_0_iff
tff(fact_2683_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] :
          ( ( zero_zero(A) = aa(nat,A,semiring_1_of_nat(A),Nb) )
        <=> ( zero_zero(nat) = Nb ) ) ) ).

% of_nat_0_eq_iff
tff(fact_2684_of__nat__0,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),zero_zero(nat)) = zero_zero(A) ) ) ).

% of_nat_0
tff(fact_2685_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ).

% of_nat_less_iff
tff(fact_2686_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ) ).

% of_nat_le_iff
tff(fact_2687_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: num] : ( aa(nat,A,semiring_1_of_nat(A),aa(num,nat,numeral_numeral(nat),Nb)) = aa(num,A,numeral_numeral(A),Nb) ) ) ).

% of_nat_numeral
tff(fact_2688_of__nat__add,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% of_nat_add
tff(fact_2689_of__nat__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% of_nat_mult
tff(fact_2690_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Nb) = one_one(A) )
        <=> ( Nb = one_one(nat) ) ) ) ).

% of_nat_eq_1_iff
tff(fact_2691_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] :
          ( ( one_one(A) = aa(nat,A,semiring_1_of_nat(A),Nb) )
        <=> ( Nb = one_one(nat) ) ) ) ).

% of_nat_1_eq_iff
tff(fact_2692_of__nat__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),one_one(nat)) = one_one(A) ) ) ).

% of_nat_1
tff(fact_2693_of__nat__power,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,power_power(nat,Ma),Nb)) = aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),Ma)),Nb) ) ) ).

% of_nat_power
tff(fact_2694_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W) = aa(nat,A,semiring_1_of_nat(A),X2) )
        <=> ( aa(nat,nat,power_power(nat,B2),W) = X2 ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
tff(fact_2695_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),X2) = aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W) )
        <=> ( X2 = aa(nat,nat,power_power(nat,B2),W) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
tff(fact_2696_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),Z)),one_one(int))
    <=> ( Z = zero_zero(int) ) ) ).

% zabs_less_one_iff
tff(fact_2697_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: $o] : ( aa(nat,A,semiring_1_of_nat(A),aa($o,nat,zero_neq_one_of_bool(nat),P)) = aa($o,A,zero_neq_one_of_bool(A),P) ) ) ).

% of_nat_of_bool
tff(fact_2698_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Ma: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),Ma)),zero_zero(A))
        <=> ( Ma = zero_zero(nat) ) ) ) ).

% of_nat_le_0_iff
tff(fact_2699_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Ma: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Ma)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Ma)) ) ) ).

% of_nat_Suc
tff(fact_2700_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,semiring_1_of_nat(A),Nb))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ) ).

% of_nat_0_less_iff
tff(fact_2701_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: nat,W: nat,X2: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W)),aa(nat,A,semiring_1_of_nat(A),X2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,power_power(nat,B2),W)),X2) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
tff(fact_2702_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: nat,B2: nat,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),X2)),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),aa(nat,nat,power_power(nat,B2),W)) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
tff(fact_2703_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: nat,W: nat,X2: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W)),aa(nat,A,semiring_1_of_nat(A),X2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,B2),W)),X2) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
tff(fact_2704_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: nat,B2: nat,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),X2)),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),B2)),W))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X2),aa(nat,nat,power_power(nat,B2),W)) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
tff(fact_2705_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [X2: num,Nb: nat,Y2: nat] :
          ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb) = aa(nat,A,semiring_1_of_nat(A),Y2) )
        <=> ( aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X2)),Nb) = Y2 ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
tff(fact_2706_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Y2: nat,X2: num,Nb: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Y2) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb) )
        <=> ( Y2 = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X2)),Nb) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
tff(fact_2707_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(num,real,numeral_numeral(real),W)),aa(nat,real,semiring_1_of_nat(real),Nb))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),W)),Nb) ) ).

% numeral_less_real_of_nat_iff
tff(fact_2708_real__of__nat__less__numeral__iff,axiom,
    ! [Nb: nat,W: num] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(num,real,numeral_numeral(real),W))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(num,nat,numeral_numeral(nat),W)) ) ).

% real_of_nat_less_numeral_iff
tff(fact_2709_numeral__le__real__of__nat__iff,axiom,
    ! [Nb: num,Ma: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),Nb)),aa(nat,real,semiring_1_of_nat(real),Ma))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Nb)),Ma) ) ).

% numeral_le_real_of_nat_iff
tff(fact_2710_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,power_power(A,aa(nat,A,semiring_1_of_nat(A),X2)),Nb))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),X2)
            | ( Nb = zero_zero(nat) ) ) ) ) ).

% of_nat_zero_less_power_iff
tff(fact_2711_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),aa(nat,real,power_power(real,A2),B2)) = aa(nat,real,semiring_1_of_nat(real),B2) ) ) ) ).

% log_pow_cancel
tff(fact_2712_even__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,semiring_1_of_nat(A),Nb))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) ) ) ).

% even_of_nat
tff(fact_2713_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I3: num,Nb: nat,X2: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),I3)),Nb)),aa(nat,A,semiring_1_of_nat(A),X2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),I3)),Nb)),X2) ) ) ).

% numeral_power_less_of_nat_cancel_iff
tff(fact_2714_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: nat,I3: num,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),X2)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),I3)),Nb))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),I3)),Nb)) ) ) ).

% of_nat_less_numeral_power_cancel_iff
tff(fact_2715_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I3: num,Nb: nat,X2: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),I3)),Nb)),aa(nat,A,semiring_1_of_nat(A),X2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),I3)),Nb)),X2) ) ) ).

% numeral_power_le_of_nat_cancel_iff
tff(fact_2716_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: nat,I3: num,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),X2)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),I3)),Nb))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X2),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),I3)),Nb)) ) ) ).

% of_nat_le_numeral_power_cancel_iff
tff(fact_2717_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A] :
        ? [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(nat,A,semiring_1_of_nat(A),N)) ) ).

% reals_Archimedean2
tff(fact_2718_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X2: nat,Y2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),X2)),Y2) = aa(A,A,aa(A,fun(A,A),times_times(A),Y2),aa(nat,A,semiring_1_of_nat(A),X2)) ) ) ).

% mult_of_nat_commute
tff(fact_2719_pi__neq__zero,axiom,
    pi != zero_zero(real) ).

% pi_neq_zero
tff(fact_2720_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat,X2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Nb)),ring_1_of_int(A,X2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),Nb)),X2) ) ) ).

% of_nat_less_of_int_iff
tff(fact_2721_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Nb: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ).

% of_nat_0_le_iff
tff(fact_2722_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Ma: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Ma)),zero_zero(A)) ) ).

% of_nat_less_0_iff
tff(fact_2723_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Nb)) != zero_zero(A) ) ) ).

% of_nat_neq_0
tff(fact_2724_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,Ma: nat,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,semiring_1_of_nat(A),Ma))),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% div_mult2_eq'
tff(fact_2725_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% less_imp_of_nat_less
tff(fact_2726_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb) ) ) ).

% of_nat_less_imp_less
tff(fact_2727_of__nat__mono,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [I3: nat,J2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),I3)),aa(nat,A,semiring_1_of_nat(A),J2)) ) ) ).

% of_nat_mono
tff(fact_2728_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
tff(fact_2729_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Ma),Nb) ) ) ).

% of_nat_dvd_iff
tff(fact_2730_abs__zmult__eq__1,axiom,
    ! [Ma: int,Nb: int] :
      ( ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),times_times(int),Ma),Nb)) = one_one(int) )
     => ( aa(int,int,abs_abs(int),Ma) = one_one(int) ) ) ).

% abs_zmult_eq_1
tff(fact_2731_pi__gt__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),pi) ).

% pi_gt_zero
tff(fact_2732_pi__not__less__zero,axiom,
    ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),zero_zero(real)) ).

% pi_not_less_zero
tff(fact_2733_pi__ge__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),pi) ).

% pi_ge_zero
tff(fact_2734_of__nat__mod,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),modulo_modulo(nat,Ma,Nb)) = modulo_modulo(A,aa(nat,A,semiring_1_of_nat(A),Ma),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% of_nat_mod
tff(fact_2735_abs__div,axiom,
    ! [Y2: int,X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Y2),X2)
     => ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),Y2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),X2)),aa(int,int,abs_abs(int),Y2)) ) ) ).

% abs_div
tff(fact_2736_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,Ma: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(nat,A,semiring_1_of_nat(A),Ma)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),Ma)) ) ) ).

% take_bit_of_nat
tff(fact_2737_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% of_nat_and_eq
tff(fact_2738_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(nat,A,semiring_1_of_nat(A),Ma)),Nb)
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(nat,Ma),Nb) ) ) ).

% bit_of_nat_iff_bit
tff(fact_2739_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),bit_se2239418461657761734s_mask(nat,Nb)) = bit_se2239418461657761734s_mask(A,Nb) ) ) ).

% of_nat_mask_eq
tff(fact_2740_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
         => ? [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),X2)) ) ) ).

% ex_less_of_nat_mult
tff(fact_2741_of__nat__diff,axiom,
    ! [A: $tType] :
      ( semiring_1_cancel(A)
     => ! [Nb: nat,Ma: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ) ).

% of_nat_diff
tff(fact_2742_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Nb: nat] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(nat,A,semiring_1_of_nat(A),Nb))) = aa(nat,A,power_power(A,aa(A,A,exp(A),X2)),Nb) ) ) ).

% exp_of_nat2_mult
tff(fact_2743_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Nb: nat,X2: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),X2)) = aa(nat,A,power_power(A,aa(A,A,exp(A),X2)),Nb) ) ) ).

% exp_of_nat_mult
tff(fact_2744_zabs__def,axiom,
    ! [I3: int] :
      ( aa(int,int,abs_abs(int),I3)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),I3),zero_zero(int)),aa(int,int,uminus_uminus(int),I3),I3) ) ).

% zabs_def
tff(fact_2745_reals__Archimedean3,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ! [Y3: real] :
        ? [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),X2)) ) ).

% reals_Archimedean3
tff(fact_2746_dvd__imp__le__int,axiom,
    ! [I3: int,D2: int] :
      ( ( I3 != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),I3)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),D2)),aa(int,int,abs_abs(int),I3)) ) ) ).

% dvd_imp_le_int
tff(fact_2747_real__of__nat__div4,axiom,
    ! [Nb: nat,X2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),X2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,semiring_1_of_nat(real),X2))) ).

% real_of_nat_div4
tff(fact_2748_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),modulo_modulo(int,K,L))),aa(int,int,abs_abs(int),L)) ) ).

% abs_mod_less
tff(fact_2749_real__of__nat__div,axiom,
    ! [D2: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),Nb)
     => ( aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),D2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,semiring_1_of_nat(real),D2)) ) ) ).

% real_of_nat_div
tff(fact_2750_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,Ma: nat,Nb: nat] : ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Ma)),modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)))),modulo_modulo(A,A2,aa(nat,A,semiring_1_of_nat(A),Ma))) ) ) ).

% mod_mult2_eq'
tff(fact_2751_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),modulo_modulo(nat,Ma,Nb)))),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% field_char_0_class.of_nat_div
tff(fact_2752_pi__less__4,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) ).

% pi_less_4
tff(fact_2753_nat__less__real__le,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),Nb)),one_one(real))),aa(nat,real,semiring_1_of_nat(real),Ma)) ) ).

% nat_less_real_le
tff(fact_2754_nat__le__real__less,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),Ma)),one_one(real))) ) ).

% nat_le_real_less
tff(fact_2755_pi__ge__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi) ).

% pi_ge_two
tff(fact_2756_zdvd__mult__cancel1,axiom,
    ! [Ma: int,Nb: int] :
      ( ( Ma != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),Ma),Nb)),Ma)
      <=> ( aa(int,int,abs_abs(int),Nb) = one_one(int) ) ) ) ).

% zdvd_mult_cancel1
tff(fact_2757_pi__half__neq__two,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) != aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)) ).

% pi_half_neq_two
tff(fact_2758_less__log__of__power,axiom,
    ! [B2: real,Nb: nat,Ma: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,power_power(real,B2),Nb)),Ma)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(real,real,log(B2),Ma)) ) ) ).

% less_log_of_power
tff(fact_2759_log__of__power__eq,axiom,
    ! [Ma: nat,B2: real,Nb: nat] :
      ( ( aa(nat,real,semiring_1_of_nat(real),Ma) = aa(nat,real,power_power(real,B2),Nb) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,real,semiring_1_of_nat(real),Nb) = aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),Ma)) ) ) ) ).

% log_of_power_eq
tff(fact_2760_real__of__nat__div__aux,axiom,
    ! [X2: nat,D2: nat] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),X2)),aa(nat,real,semiring_1_of_nat(real),D2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X2),D2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),modulo_modulo(nat,X2,D2))),aa(nat,real,semiring_1_of_nat(real),D2))) ) ).

% real_of_nat_div_aux
tff(fact_2761_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [E2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E2)
         => ~ ! [N: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N)))),E2) ) ) ).

% nat_approx_posE
tff(fact_2762_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) ) ).

% of_nat_less_two_power
tff(fact_2763_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Nb: nat,Ma: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
         => ( ( Nb != zero_zero(nat) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Ma))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Nb))) ) ) ) ).

% inverse_of_nat_le
tff(fact_2764_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Nb: nat,X2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( aa(nat,A,power_power(A,aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),aa(nat,A,semiring_1_of_nat(A),Nb)))),Nb) = aa(A,A,exp(A),X2) ) ) ) ).

% exp_divide_power_eq
tff(fact_2765_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(int,int,abs_abs(int),L)))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_add_abs_iff
tff(fact_2766_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),K)),L))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_abs_add_iff
tff(fact_2767_real__archimedian__rdiv__eq__0,axiom,
    ! [X2: real,C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),C2)
       => ( ! [M3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M3)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M3)),X2)),C2) )
         => ( X2 = zero_zero(real) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
tff(fact_2768_pi__half__neq__zero,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) != zero_zero(real) ).

% pi_half_neq_zero
tff(fact_2769_pi__half__less__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% pi_half_less_two
tff(fact_2770_pi__half__le__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% pi_half_le_two
tff(fact_2771_real__of__nat__div2,axiom,
    ! [Nb: nat,X2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,semiring_1_of_nat(real),X2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),X2)))) ).

% real_of_nat_div2
tff(fact_2772_le__log__of__power,axiom,
    ! [B2: real,Nb: nat,Ma: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,power_power(real,B2),Nb)),Ma)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(real,real,log(B2),Ma)) ) ) ).

% le_log_of_power
tff(fact_2773_log__base__pow,axiom,
    ! [A2: real,Nb: nat,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( aa(real,real,log(aa(nat,real,power_power(real,A2),Nb)),X2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A2),X2)),aa(nat,real,semiring_1_of_nat(real),Nb)) ) ) ).

% log_base_pow
tff(fact_2774_ln__realpow,axiom,
    ! [X2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,real,ln_ln(real),aa(nat,real,power_power(real,X2),Nb)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(real,real,ln_ln(real),X2)) ) ) ).

% ln_realpow
tff(fact_2775_log__nat__power,axiom,
    ! [X2: real,B2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,real,log(B2),aa(nat,real,power_power(real,X2),Nb)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(real,real,log(B2),X2)) ) ) ).

% log_nat_power
tff(fact_2776_real__of__nat__div3,axiom,
    ! [Nb: nat,X2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,semiring_1_of_nat(real),X2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),X2)))),one_one(real)) ).

% real_of_nat_div3
tff(fact_2777_nat__intermed__int__val,axiom,
    ! [Ma: nat,Nb: nat,F3: fun(nat,int),K: int] :
      ( ! [I2: nat] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),I2)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),Nb) )
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F3,aa(nat,nat,suc,I2))),aa(nat,int,F3,I2)))),one_one(int)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F3,Ma)),K)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F3,Nb))
           => ? [I2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),I2)
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),Nb)
                & ( aa(nat,int,F3,I2) = K ) ) ) ) ) ) ).

% nat_intermed_int_val
tff(fact_2778_decr__lemma,axiom,
    ! [D2: int,X2: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),Z))),one_one(int))),D2))),Z) ) ).

% decr_lemma
tff(fact_2779_incr__lemma,axiom,
    ! [D2: int,Z: int,X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),Z))),one_one(int))),D2))) ) ).

% incr_lemma
tff(fact_2780_pi__half__gt__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ).

% pi_half_gt_zero
tff(fact_2781_linear__plus__1__le__power,axiom,
    ! [X2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),X2)),one_one(real))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),one_one(real))),Nb)) ) ).

% linear_plus_1_le_power
tff(fact_2782_pi__half__ge__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ).

% pi_half_ge_zero
tff(fact_2783_log2__of__power__eq,axiom,
    ! [Ma: nat,Nb: nat] :
      ( ( Ma = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) )
     => ( aa(nat,real,semiring_1_of_nat(real),Nb) = aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Ma)) ) ) ).

% log2_of_power_eq
tff(fact_2784_log__of__power__less,axiom,
    ! [Ma: nat,B2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Ma)),aa(nat,real,power_power(real,B2),Nb))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),Ma))),aa(nat,real,semiring_1_of_nat(real),Nb)) ) ) ) ).

% log_of_power_less
tff(fact_2785_Bernoulli__inequality,axiom,
    ! [X2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),X2))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2)),Nb)) ) ).

% Bernoulli_inequality
tff(fact_2786_m2pi__less__pi,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))),pi) ).

% m2pi_less_pi
tff(fact_2787_arctan__ubound,axiom,
    ! [Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ).

% arctan_ubound
tff(fact_2788_arctan__one,axiom,
    aa(real,real,arctan,one_one(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) ).

% arctan_one
tff(fact_2789_nat__ivt__aux,axiom,
    ! [Nb: nat,F3: fun(nat,int),K: int] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),Nb)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F3,aa(nat,nat,suc,I2))),aa(nat,int,F3,I2)))),one_one(int)) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F3,zero_zero(nat))),K)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F3,Nb))
         => ? [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),Nb)
              & ( aa(nat,int,F3,I2) = K ) ) ) ) ) ).

% nat_ivt_aux
tff(fact_2790_log__of__power__le,axiom,
    ! [Ma: nat,B2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),Ma)),aa(nat,real,power_power(real,B2),Nb))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),Ma))),aa(nat,real,semiring_1_of_nat(real),Nb)) ) ) ) ).

% log_of_power_le
tff(fact_2791_minus__pi__half__less__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),zero_zero(real)) ).

% minus_pi_half_less_zero
tff(fact_2792_arctan__bounded,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arctan,Y2))
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ).

% arctan_bounded
tff(fact_2793_arctan__lbound,axiom,
    ! [Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arctan,Y2)) ).

% arctan_lbound
tff(fact_2794_nat0__intermed__int__val,axiom,
    ! [Nb: nat,F3: fun(nat,int),K: int] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),Nb)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),one_one(nat)))),aa(nat,int,F3,I2)))),one_one(int)) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F3,zero_zero(nat))),K)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F3,Nb))
         => ? [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),Nb)
              & ( aa(nat,int,F3,I2) = K ) ) ) ) ) ).

% nat0_intermed_int_val
tff(fact_2795_less__log2__of__power,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),Ma)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Ma))) ) ).

% less_log2_of_power
tff(fact_2796_le__log2__of__power,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),Ma)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Ma))) ) ).

% le_log2_of_power
tff(fact_2797_Bernoulli__inequality__even,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),X2))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X2)),Nb)) ) ).

% Bernoulli_inequality_even
tff(fact_2798_log2__of__power__less,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Ma))),aa(nat,real,semiring_1_of_nat(real),Nb)) ) ) ).

% log2_of_power_less
tff(fact_2799_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: nat] :
          ( aa(nat,A,semiring_1_of_nat(A),Nb)
          = $ite(Nb = zero_zero(nat),zero_zero(A),aa(product_prod(nat,nat),A,aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_bm(nat,fun(nat,A))),divmod_nat(Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% of_nat_code_if
tff(fact_2800_monoseq__arctan__series,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => topological_monoseq(real,aTP_Lamp_bn(real,fun(nat,real),X2)) ) ).

% monoseq_arctan_series
tff(fact_2801_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [H: A,Z: A,K5: real,Nb: nat] :
          ( ( H != zero_zero(A) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),K5)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H))),K5)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H)),Nb)),aa(nat,A,power_power(A,Z),Nb))),H)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(nat,A,power_power(A,Z),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))),aa(nat,real,power_power(real,K5),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),real_V7770717601297561774m_norm(A,H))) ) ) ) ) ).

% lemma_termdiff3
tff(fact_2802_sin__cos__npi,axiom,
    ! [Nb: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Nb) ) ).

% sin_cos_npi
tff(fact_2803_ln__series,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
       => ( aa(real,real,ln_ln(real),X2) = suminf(real,aTP_Lamp_bo(real,fun(nat,real),X2)) ) ) ) ).

% ln_series
tff(fact_2804_arctan__series,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => ( aa(real,real,arctan,X2) = suminf(real,aTP_Lamp_bp(real,fun(nat,real),X2)) ) ) ).

% arctan_series
tff(fact_2805_sin__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,zero_zero(A)) = zero_zero(A) ) ) ).

% sin_zero
tff(fact_2806_int__eq__iff__numeral,axiom,
    ! [Ma: nat,V: num] :
      ( ( aa(nat,int,semiring_1_of_nat(int),Ma) = aa(num,int,numeral_numeral(int),V) )
    <=> ( Ma = aa(num,nat,numeral_numeral(nat),V) ) ) ).

% int_eq_iff_numeral
tff(fact_2807_negative__eq__positive,axiom,
    ! [Nb: nat,Ma: nat] :
      ( ( aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Nb)) = aa(nat,int,semiring_1_of_nat(int),Ma) )
    <=> ( ( Nb = zero_zero(nat) )
        & ( Ma = zero_zero(nat) ) ) ) ).

% negative_eq_positive
tff(fact_2808_sin__pi,axiom,
    sin(real,pi) = zero_zero(real) ).

% sin_pi
tff(fact_2809_negative__zless,axiom,
    ! [Nb: nat,Ma: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,Nb)))),aa(nat,int,semiring_1_of_nat(int),Ma)) ).

% negative_zless
tff(fact_2810_sin__npi,axiom,
    ! [Nb: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),pi)) = zero_zero(real) ) ).

% sin_npi
tff(fact_2811_sin__npi2,axiom,
    ! [Nb: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),Nb))) = zero_zero(real) ) ).

% sin_npi2
tff(fact_2812_sin__npi__int,axiom,
    ! [Nb: int] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),ring_1_of_int(real,Nb))) = zero_zero(real) ) ).

% sin_npi_int
tff(fact_2813_powser__zero,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [F3: fun(nat,A)] : ( suminf(A,aTP_Lamp_bq(fun(nat,A),fun(nat,A),F3)) = aa(nat,A,F3,zero_zero(nat)) ) ) ).

% powser_zero
tff(fact_2814_sin__two__pi,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)) = zero_zero(real) ).

% sin_two_pi
tff(fact_2815_sin__pi__half,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = one_one(real) ).

% sin_pi_half
tff(fact_2816_sin__periodic,axiom,
    ! [X2: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) = sin(real,X2) ) ).

% sin_periodic
tff(fact_2817_sin__2npi,axiom,
    ! [Nb: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)) = zero_zero(real) ) ).

% sin_2npi
tff(fact_2818_sin__2pi__minus,axiom,
    ! [X2: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),X2)) = aa(real,real,uminus_uminus(real),sin(real,X2)) ) ).

% sin_2pi_minus
tff(fact_2819_sin__int__2pin,axiom,
    ! [Nb: int] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),ring_1_of_int(real,Nb))) = zero_zero(real) ) ).

% sin_int_2pin
tff(fact_2820_sin__3over2__pi,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi)) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% sin_3over2_pi
tff(fact_2821_int__if,axiom,
    ! [P: $o,A2: nat,B2: nat] :
      ( aa(nat,int,semiring_1_of_nat(int),$ite((P),A2,B2))
      = $ite((P),aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_if
tff(fact_2822_nat__int__comparison_I1_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 = B2 )
    <=> ( aa(nat,int,semiring_1_of_nat(int),A2) = aa(nat,int,semiring_1_of_nat(int),B2) ) ) ).

% nat_int_comparison(1)
tff(fact_2823_of__nat__eq__enat,axiom,
    ! [Nb: nat] : ( aa(nat,extended_enat,semiring_1_of_nat(extended_enat),Nb) = extended_enat2(Nb) ) ).

% of_nat_eq_enat
tff(fact_2824_sin__x__le__x,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,X2)),X2) ) ).

% sin_x_le_x
tff(fact_2825_int__ops_I1_J,axiom,
    aa(nat,int,semiring_1_of_nat(int),zero_zero(nat)) = zero_zero(int) ).

% int_ops(1)
tff(fact_2826_int__ops_I3_J,axiom,
    ! [Nb: num] : ( aa(nat,int,semiring_1_of_nat(int),aa(num,nat,numeral_numeral(nat),Nb)) = aa(num,int,numeral_numeral(int),Nb) ) ).

% int_ops(3)
tff(fact_2827_nat__int__comparison_I2_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% nat_int_comparison(2)
tff(fact_2828_int__of__nat__induct,axiom,
    ! [P: fun(int,$o),Z: int] :
      ( ! [N: nat] : aa(int,$o,P,aa(nat,int,semiring_1_of_nat(int),N))
     => ( ! [N: nat] : aa(int,$o,P,aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N))))
       => aa(int,$o,P,Z) ) ) ).

% int_of_nat_induct
tff(fact_2829_int__cases,axiom,
    ! [Z: int] :
      ( ! [N: nat] : ( Z != aa(nat,int,semiring_1_of_nat(int),N) )
     => ~ ! [N: nat] : ( Z != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N))) ) ) ).

% int_cases
tff(fact_2830_nat__int__comparison_I3_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% nat_int_comparison(3)
tff(fact_2831_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ? [N: nat] : ( K = aa(nat,int,semiring_1_of_nat(int),N) ) ) ).

% zero_le_imp_eq_int
tff(fact_2832_nonneg__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ~ ! [N: nat] : ( K != aa(nat,int,semiring_1_of_nat(int),N) ) ) ).

% nonneg_int_cases
tff(fact_2833_zadd__int__left,axiom,
    ! [Ma: nat,Nb: nat,Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Ma)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Nb)),Z)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb))),Z) ) ).

% zadd_int_left
tff(fact_2834_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_ops(5)
tff(fact_2835_int__plus,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Nb)),aa(nat,int,semiring_1_of_nat(int),Ma)) ) ).

% int_plus
tff(fact_2836_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),B2)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_ops(7)
tff(fact_2837_int__ops_I2_J,axiom,
    aa(nat,int,semiring_1_of_nat(int),one_one(nat)) = one_one(int) ).

% int_ops(2)
tff(fact_2838_not__int__zless__negative,axiom,
    ! [Nb: nat,Ma: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),Nb)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Ma))) ).

% not_int_zless_negative
tff(fact_2839_zdiv__int,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A2),B2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% zdiv_int
tff(fact_2840_zmod__int,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,A2,B2)) = modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% zmod_int
tff(fact_2841_nat__less__as__int,axiom,
    ! [X: nat,Xa3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Xa3)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa3)) ) ).

% nat_less_as_int
tff(fact_2842_nat__leq__as__int,axiom,
    ! [X: nat,Xa3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Xa3)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa3)) ) ).

% nat_leq_as_int
tff(fact_2843_sin__gt__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),pi)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sin(real,X2)) ) ) ).

% sin_gt_zero
tff(fact_2844_sin__x__ge__neg__x,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),X2)),sin(real,X2)) ) ).

% sin_x_ge_neg_x
tff(fact_2845_sin__ge__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),pi)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),sin(real,X2)) ) ) ).

% sin_ge_zero
tff(fact_2846_int__cases4,axiom,
    ! [Ma: int] :
      ( ! [N: nat] : ( Ma != aa(nat,int,semiring_1_of_nat(int),N) )
     => ~ ! [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( Ma != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) ) ) ) ).

% int_cases4
tff(fact_2847_int__zle__neg,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),Nb)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Ma)))
    <=> ( ( Nb = zero_zero(nat) )
        & ( Ma = zero_zero(nat) ) ) ) ).

% int_zle_neg
tff(fact_2848_int__ops_I4_J,axiom,
    ! [A2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,A2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),one_one(int)) ) ).

% int_ops(4)
tff(fact_2849_int__Suc,axiom,
    ! [Nb: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,Nb)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Nb)),one_one(int)) ) ).

% int_Suc
tff(fact_2850_zless__iff__Suc__zadd,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
    <=> ? [N4: nat] : ( Z = aa(int,int,aa(int,fun(int,int),plus_plus(int),W),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N4))) ) ) ).

% zless_iff_Suc_zadd
tff(fact_2851_nonpos__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ~ ! [N: nat] : ( K != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) ) ) ).

% nonpos_int_cases
tff(fact_2852_negative__zle__0,axiom,
    ! [Nb: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Nb))),zero_zero(int)) ).

% negative_zle_0
tff(fact_2853_sin__eq__0__pi,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),pi)
       => ( ( sin(real,X2) = zero_zero(real) )
         => ( X2 = zero_zero(real) ) ) ) ) ).

% sin_eq_0_pi
tff(fact_2854_sin__zero__pi__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),pi)
     => ( ( sin(real,X2) = zero_zero(real) )
      <=> ( X2 = zero_zero(real) ) ) ) ).

% sin_zero_pi_iff
tff(fact_2855_sin__zero__iff__int2,axiom,
    ! [X2: real] :
      ( ( sin(real,X2) = zero_zero(real) )
    <=> ? [I: int] : ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,I)),pi) ) ) ).

% sin_zero_iff_int2
tff(fact_2856_pos__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ~ ! [N: nat] :
            ( ( K = aa(nat,int,semiring_1_of_nat(int),N) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ).

% pos_int_cases
tff(fact_2857_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ? [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
          & ( K = aa(nat,int,semiring_1_of_nat(int),N) ) ) ) ).

% zero_less_imp_eq_int
tff(fact_2858_int__cases3,axiom,
    ! [K: int] :
      ( ( K != zero_zero(int) )
     => ( ! [N: nat] :
            ( ( K = aa(nat,int,semiring_1_of_nat(int),N) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) )
       => ~ ! [N: nat] :
              ( ( K = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) )
             => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ) ).

% int_cases3
tff(fact_2859_zmult__zless__mono2__lemma,axiom,
    ! [I3: int,J2: int,K: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I3),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),K)),I3)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),K)),J2)) ) ) ).

% zmult_zless_mono2_lemma
tff(fact_2860_not__zle__0__negative,axiom,
    ! [Nb: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,Nb)))) ).

% not_zle_0_negative
tff(fact_2861_negative__zless__0,axiom,
    ! [Nb: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,Nb)))),zero_zero(int)) ).

% negative_zless_0
tff(fact_2862_negD,axiom,
    ! [X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X2),zero_zero(int))
     => ? [N: nat] : ( X2 = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N))) ) ) ).

% negD
tff(fact_2863_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2))) ) ).

% int_ops(6)
tff(fact_2864_sin__gt__zero__02,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sin(real,X2)) ) ) ).

% sin_gt_zero_02
tff(fact_2865_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [X7: fun(A,B)] :
          ( ? [K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & ! [N4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N4))),K6) )
        <=> ? [N5: nat] :
            ! [N4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N4))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N5))) ) ) ).

% lemma_NBseq_def
tff(fact_2866_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [X7: fun(A,B)] :
          ( ? [K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & ! [N4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N4))),K6) )
        <=> ? [N5: nat] :
            ! [N4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N4))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N5))) ) ) ).

% lemma_NBseq_def2
tff(fact_2867_neg__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => ~ ! [N: nat] :
            ( ( K = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ).

% neg_int_cases
tff(fact_2868_zdiff__int__split,axiom,
    ! [P: fun(int,$o),X2: nat,Y2: nat] :
      ( aa(int,$o,P,aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X2),Y2)))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y2),X2)
         => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X2)),aa(nat,int,semiring_1_of_nat(int),Y2))) )
        & ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),Y2)
         => aa(int,$o,P,zero_zero(int)) ) ) ) ).

% zdiff_int_split
tff(fact_2869_monoseq__realpow,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => topological_monoseq(real,power_power(real,X2)) ) ) ).

% monoseq_realpow
tff(fact_2870_sin__pi__divide__n__ge__0,axiom,
    ! [Nb: nat] :
      ( ( Nb != zero_zero(nat) )
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(nat,real,semiring_1_of_nat(real),Nb)))) ) ).

% sin_pi_divide_n_ge_0
tff(fact_2871_sin__45,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% sin_45
tff(fact_2872_sin__gt__zero2,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sin(real,X2)) ) ) ).

% sin_gt_zero2
tff(fact_2873_sin__lt__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),sin(real,X2)),zero_zero(real)) ) ) ).

% sin_lt_zero
tff(fact_2874_sin__30,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% sin_30
tff(fact_2875_sin__monotone__2pi__le,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,Y2)),sin(real,X2)) ) ) ) ).

% sin_monotone_2pi_le
tff(fact_2876_sin__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,X2)),sin(real,Y2))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2) ) ) ) ) ) ).

% sin_mono_le_eq
tff(fact_2877_sin__inj__pi,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( ( sin(real,X2) = sin(real,Y2) )
             => ( X2 = Y2 ) ) ) ) ) ) ).

% sin_inj_pi
tff(fact_2878_sin__60,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% sin_60
tff(fact_2879_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ).

% exp_bound_half
tff(fact_2880_sin__le__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),pi),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,X2)),zero_zero(real)) ) ) ).

% sin_le_zero
tff(fact_2881_sin__less__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),sin(real,X2)),zero_zero(real)) ) ) ).

% sin_less_zero
tff(fact_2882_sin__mono__less__eq,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),sin(real,X2)),sin(real,Y2))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ) ) ) ) ).

% sin_mono_less_eq
tff(fact_2883_sin__monotone__2pi,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),sin(real,Y2)),sin(real,X2)) ) ) ) ).

% sin_monotone_2pi
tff(fact_2884_sin__total,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => ? [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
            & ( sin(real,X4) = Y2 )
            & ! [Y3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
                  & ( sin(real,Y3) = Y2 ) )
               => ( Y3 = X4 ) ) ) ) ) ).

% sin_total
tff(fact_2885_sin__pi__divide__n__gt__0,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(nat,real,semiring_1_of_nat(real),Nb)))) ) ).

% sin_pi_divide_n_gt_0
tff(fact_2886_sin__arctan,axiom,
    ! [X2: real] : ( sin(real,aa(real,real,arctan,X2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% sin_arctan
tff(fact_2887_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),real_V7770717601297561774m_norm(A,Z)))) ) ) ).

% exp_bound_lemma
tff(fact_2888_sin__zero__iff__int,axiom,
    ! [X2: real] :
      ( ( sin(real,X2) = zero_zero(real) )
    <=> ? [I: int] :
          ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),I)
          & ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,I)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ).

% sin_zero_iff_int
tff(fact_2889_sin__zero__lemma,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( ( sin(real,X2) = zero_zero(real) )
       => ? [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)
            & ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ) ).

% sin_zero_lemma
tff(fact_2890_sin__zero__iff,axiom,
    ! [X2: real] :
      ( ( sin(real,X2) = zero_zero(real) )
    <=> ( ? [N4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4)
            & ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) )
        | ? [N4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4)
            & ( X2 = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ) ) ) ) ).

% sin_zero_iff
tff(fact_2891_pi__series,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) = suminf(real,aTP_Lamp_br(nat,real)) ).

% pi_series
tff(fact_2892_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A,W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),W))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A2)),aa(num,real,numeral_numeral(real),W)) ) ) ).

% norm_divide_numeral
tff(fact_2893_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [W: num,A2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),W)),real_V7770717601297561774m_norm(A,A2)) ) ) ).

% norm_mult_numeral1
tff(fact_2894_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A,W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A2)),aa(num,real,numeral_numeral(real),W)) ) ) ).

% norm_mult_numeral2
tff(fact_2895_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = aa(num,real,numeral_numeral(real),W) ) ) ).

% norm_neg_numeral
tff(fact_2896_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,X2)),zero_zero(real))
        <=> ( X2 = zero_zero(A) ) ) ) ).

% norm_le_zero_iff
tff(fact_2897_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V7770717601297561774m_norm(A,X2))
        <=> ( X2 != zero_zero(A) ) ) ) ).

% zero_less_norm_iff
tff(fact_2898_norm__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( real_V7770717601297561774m_norm(A,zero_zero(A)) = zero_zero(real) ) ) ).

% norm_zero
tff(fact_2899_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] :
          ( ( real_V7770717601297561774m_norm(A,X2) = zero_zero(real) )
        <=> ( X2 = zero_zero(A) ) ) ) ).

% norm_eq_zero
tff(fact_2900_norm__numeral,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [W: num] : ( real_V7770717601297561774m_norm(A,aa(num,A,numeral_numeral(A),W)) = aa(num,real,numeral_numeral(real),W) ) ) ).

% norm_numeral
tff(fact_2901_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),zero_zero(real)) ) ).

% norm_not_less_zero
tff(fact_2902_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),real_V7770717601297561774m_norm(A,X2)) ) ).

% norm_ge_zero
tff(fact_2903_norm__mult,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X2: A,Y2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2)) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,Y2)) ) ) ).

% norm_mult
tff(fact_2904_norm__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A,B2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2)) ) ) ).

% norm_divide
tff(fact_2905_norm__power,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X2: A,Nb: nat] : ( real_V7770717601297561774m_norm(A,aa(nat,A,power_power(A,X2),Nb)) = aa(nat,real,power_power(real,real_V7770717601297561774m_norm(A,X2)),Nb) ) ) ).

% norm_power
tff(fact_2906_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A,Y2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),X2)),Y2)) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) ) ) ).

% norm_uminus_minus
tff(fact_2907_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2)) ) ) ) ).

% nonzero_norm_divide
tff(fact_2908_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [W: A,Nb: nat,Z: A] :
          ( ( aa(nat,A,power_power(A,W),Nb) = aa(nat,A,power_power(A,Z),Nb) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
           => ( real_V7770717601297561774m_norm(A,W) = real_V7770717601297561774m_norm(A,Z) ) ) ) ) ).

% power_eq_imp_eq_norm
tff(fact_2909_norm__mult__less,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [X2: A,R: real,Y2: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),R)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Y2)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),R),S)) ) ) ) ).

% norm_mult_less
tff(fact_2910_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [X2: A,Y2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,Y2))) ) ).

% norm_mult_ineq
tff(fact_2911_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A,Y2: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,Y2))),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))),E2) ) ) ).

% norm_triangle_lt
tff(fact_2912_norm__add__less,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A,R: real,Y2: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),R)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Y2)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),R),S)) ) ) ) ).

% norm_add_less
tff(fact_2913_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,R: real,B2: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,A2)),R)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,B2)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),R),S)) ) ) ) ).

% norm_triangle_mono
tff(fact_2914_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A,Y2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,Y2))) ) ).

% norm_triangle_ineq
tff(fact_2915_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A,Y2: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,Y2))),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))),E2) ) ) ).

% norm_triangle_le
tff(fact_2916_norm__add__leD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),C2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,B2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,A2)),C2)) ) ) ).

% norm_add_leD
tff(fact_2917_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X2: A,Nb: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,power_power(A,X2),Nb))),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(A,X2)),Nb)) ) ).

% norm_power_ineq
tff(fact_2918_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A,Y2: A,E1: real,Z: A,E22: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2))),E1)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y2),Z))),E22)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22)) ) ) ) ).

% norm_diff_triangle_less
tff(fact_2919_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))) ) ).

% norm_diff_ineq
tff(fact_2920_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [W: A,Nb: nat] :
          ( ( aa(nat,A,power_power(A,W),Nb) = one_one(A) )
         => ( ( real_V7770717601297561774m_norm(A,W) = one_one(real) )
            | ( Nb = zero_zero(nat) ) ) ) ) ).

% power_eq_1_iff
tff(fact_2921_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: A,D2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)))) ) ).

% norm_diff_triangle_ineq
tff(fact_2922_square__norm__one,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X2: A] :
          ( ( aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
         => ( real_V7770717601297561774m_norm(A,X2) = one_one(real) ) ) ) ).

% square_norm_one
tff(fact_2923_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A,W: A,Ma: nat] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),one_one(real))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,W)),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,Z),Ma)),aa(nat,A,power_power(A,W),Ma)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Ma)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),W)))) ) ) ) ).

% norm_power_diff
tff(fact_2924_suminf__geometric,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => ( suminf(A,power_power(A,C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),C2)) ) ) ) ).

% suminf_geometric
tff(fact_2925_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ( suminf(A,aTP_Lamp_bs(nat,A)) = zero_zero(A) ) ) ).

% suminf_zero
tff(fact_2926_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( ( archimedean_ceiling(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Nb)),one_one(int)) )
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,power_power(nat,B2),Nb)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)))) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
tff(fact_2927_summable__arctan__series,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => summable(real,aTP_Lamp_bp(real,fun(nat,real),X2)) ) ).

% summable_arctan_series
tff(fact_2928_cos__pi__eq__zero,axiom,
    ! [Ma: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma))))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = zero_zero(real) ) ).

% cos_pi_eq_zero
tff(fact_2929_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( ( ring_1_of_int(A,archimedean_ceiling(A,X2)) = X2 )
        <=> ? [N4: int] : ( X2 = ring_1_of_int(A,N4) ) ) ) ).

% of_int_ceiling_cancel
tff(fact_2930_summable__single,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [I3: nat,F3: fun(nat,A)] : summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bt(nat,fun(fun(nat,A),fun(nat,A)),I3),F3)) ) ).

% summable_single
tff(fact_2931_summable__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => summable(A,aTP_Lamp_bu(nat,A)) ) ).

% summable_zero
tff(fact_2932_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( summable(A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),F3),K))
        <=> summable(A,F3) ) ) ).

% summable_iff_shift
tff(fact_2933_cos__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cos(A,zero_zero(A)) = one_one(A) ) ) ).

% cos_zero
tff(fact_2934_ceiling__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_ceiling(A,zero_zero(A)) = zero_zero(int) ) ) ).

% ceiling_zero
tff(fact_2935_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archimedean_ceiling(A,aa(num,A,numeral_numeral(A),V)) = aa(num,int,numeral_numeral(int),V) ) ) ).

% ceiling_numeral
tff(fact_2936_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F3: fun(nat,A)] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bw(A,fun(fun(nat,A),fun(nat,A)),C2),F3))
        <=> ( ( C2 = zero_zero(A) )
            | summable(A,F3) ) ) ) ).

% summable_cmult_iff
tff(fact_2937_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bx(fun(nat,A),fun(A,fun(nat,A)),F3),C2))
        <=> ( ( C2 = zero_zero(A) )
            | summable(A,F3) ) ) ) ).

% summable_divide_iff
tff(fact_2938_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Z: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),ring_1_of_int(A,Z))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X2)),Z) ) ) ).

% ceiling_add_of_int
tff(fact_2939_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X2)),cos(A,X2))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X2)),sin(A,X2))) = one_one(A) ) ) ).

% sin_cos_squared_add3
tff(fact_2940_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X2)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A)) ) ) ).

% ceiling_le_zero
tff(fact_2941_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2) ) ) ).

% zero_less_ceiling
tff(fact_2942_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X2)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(num,A,numeral_numeral(A),V)) ) ) ).

% ceiling_le_numeral
tff(fact_2943_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X2)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A)) ) ) ).

% ceiling_less_one
tff(fact_2944_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2) ) ) ).

% one_le_ceiling
tff(fact_2945_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),V)),X2) ) ) ).

% numeral_less_ceiling
tff(fact_2946_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),X2) ) ) ).

% one_less_ceiling
tff(fact_2947_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X2)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_add_numeral
tff(fact_2948_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archimedean_ceiling(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_neg_numeral
tff(fact_2949_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),one_one(A))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X2)),one_one(int)) ) ) ).

% ceiling_add_one
tff(fact_2950_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X2)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_diff_numeral
tff(fact_2951_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: num,Nb: nat] : ( archimedean_ceiling(A,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb)) = aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb) ) ) ).

% ceiling_numeral_power
tff(fact_2952_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( summable(A,power_power(A,C2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real)) ) ) ).

% summable_geometric_iff
tff(fact_2953_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X2)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ).

% ceiling_less_zero
tff(fact_2954_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),X2) ) ) ).

% zero_le_ceiling
tff(fact_2955_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] : ( archimedean_ceiling(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A2)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),A2))),aa(num,int,numeral_numeral(int),B2))) ) ).

% ceiling_divide_eq_div_numeral
tff(fact_2956_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X2)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))) ) ) ).

% ceiling_less_numeral
tff(fact_2957_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X2) ) ) ).

% numeral_le_ceiling
tff(fact_2958_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% ceiling_le_neg_numeral
tff(fact_2959_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),X2) ) ) ).

% neg_numeral_less_ceiling
tff(fact_2960_cos__pi__half,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = zero_zero(real) ).

% cos_pi_half
tff(fact_2961_cos__two__pi,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)) = one_one(real) ).

% cos_two_pi
tff(fact_2962_cos__periodic,axiom,
    ! [X2: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) = cos(real,X2) ) ).

% cos_periodic
tff(fact_2963_cos__2pi__minus,axiom,
    ! [X2: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),X2)) = cos(real,X2) ) ).

% cos_2pi_minus
tff(fact_2964_cos__npi2,axiom,
    ! [Nb: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),Nb))) = aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Nb) ) ).

% cos_npi2
tff(fact_2965_cos__npi,axiom,
    ! [Nb: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),pi)) = aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Nb) ) ).

% cos_npi
tff(fact_2966_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] : ( archimedean_ceiling(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A2)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),A2)),aa(num,int,numeral_numeral(int),B2))) ) ).

% ceiling_minus_divide_eq_div_numeral
tff(fact_2967_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,cos(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,sin(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(A) ) ) ).

% sin_cos_squared_add2
tff(fact_2968_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,sin(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,cos(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(A) ) ) ).

% sin_cos_squared_add
tff(fact_2969_cos__2npi,axiom,
    ! [Nb: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)) = one_one(real) ) ).

% cos_2npi
tff(fact_2970_cos__int__2pin,axiom,
    ! [Nb: int] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),ring_1_of_int(real,Nb))) = one_one(real) ) ).

% cos_int_2pin
tff(fact_2971_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))) ) ) ).

% ceiling_less_neg_numeral
tff(fact_2972_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X2) ) ) ).

% neg_numeral_le_ceiling
tff(fact_2973_cos__3over2__pi,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi)) = zero_zero(real) ).

% cos_3over2_pi
tff(fact_2974_cos__npi__int,axiom,
    ! [Nb: int] :
      ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),ring_1_of_int(real,Nb)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb),one_one(real),aa(real,real,uminus_uminus(real),one_one(real))) ) ).

% cos_npi_int
tff(fact_2975_summable__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_by(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) ) ) ).

% summable_mult2
tff(fact_2976_summable__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_bz(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) ) ) ).

% summable_mult
tff(fact_2977_summable__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F3)
         => ( summable(A,G)
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)) ) ) ) ).

% summable_add
tff(fact_2978_summable__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_bx(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) ) ) ).

% summable_divide
tff(fact_2979_summable__minus__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,aTP_Lamp_cb(fun(nat,A),fun(nat,A),F3))
        <=> summable(A,F3) ) ) ).

% summable_minus_iff
tff(fact_2980_summable__minus,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => summable(A,aTP_Lamp_cb(fun(nat,A),fun(nat,A),F3)) ) ) ).

% summable_minus
tff(fact_2981_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,aTP_Lamp_cc(fun(nat,A),fun(nat,A),F3))
        <=> summable(A,F3) ) ) ).

% summable_Suc_iff
tff(fact_2982_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( summable(A,F3)
         => summable(A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),F3),K)) ) ) ).

% summable_ignore_initial_segment
tff(fact_2983_summable__const__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [C2: A] :
          ( summable(A,aTP_Lamp_cd(A,fun(nat,A),C2))
        <=> ( C2 = zero_zero(A) ) ) ) ).

% summable_const_iff
tff(fact_2984_summable__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F3)
         => ( summable(A,G)
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ce(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)) ) ) ) ).

% summable_diff
tff(fact_2985_summable__norm__cancel,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A)] :
          ( summable(real,aTP_Lamp_cf(fun(nat,A),fun(nat,real),F3))
         => summable(A,F3) ) ) ).

% summable_norm_cancel
tff(fact_2986_summable__rabs__cancel,axiom,
    ! [F3: fun(nat,real)] :
      ( summable(real,aTP_Lamp_cg(fun(nat,real),fun(nat,real),F3))
     => summable(real,F3) ) ).

% summable_rabs_cancel
tff(fact_2987_summable__mult__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F3: fun(nat,A)] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bw(A,fun(fun(nat,A),fun(nat,A)),C2),F3))
         => ( ( C2 != zero_zero(A) )
           => summable(A,F3) ) ) ) ).

% summable_mult_D
tff(fact_2988_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1(A)
        & topolo4958980785337419405_space(A) )
     => summable(A,power_power(A,zero_zero(A))) ) ).

% summable_zero_power
tff(fact_2989_suminf__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_bz(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),suminf(A,F3)) ) ) ) ).

% suminf_mult
tff(fact_2990_suminf__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,F3)),C2) = suminf(A,aa(A,fun(nat,A),aTP_Lamp_by(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) ) ) ) ).

% suminf_mult2
tff(fact_2991_suminf__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F3)
         => ( summable(A,G)
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),suminf(A,F3)),suminf(A,G)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)) ) ) ) ) ).

% suminf_add
tff(fact_2992_suminf__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F3)
         => ( summable(A,G)
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F3)),suminf(A,G)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ce(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)) ) ) ) ) ).

% suminf_diff
tff(fact_2993_suminf__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_bx(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),suminf(A,F3)),C2) ) ) ) ).

% suminf_divide
tff(fact_2994_suminf__minus,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( suminf(A,aTP_Lamp_cb(fun(nat,A),fun(nat,A),F3)) = aa(A,A,uminus_uminus(A),suminf(A,F3)) ) ) ) ).

% suminf_minus
tff(fact_2995_powser__insidea,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,A),X2: A,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),F3),X2))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),real_V7770717601297561774m_norm(A,X2))
           => summable(real,aa(A,fun(nat,real),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,real)),F3),Z)) ) ) ) ).

% powser_insidea
tff(fact_2996_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N))
           => ( ( suminf(A,F3) = zero_zero(A) )
            <=> ! [N4: nat] : ( aa(nat,A,F3,N4) = zero_zero(A) ) ) ) ) ) ).

% suminf_eq_zero_iff
tff(fact_2997_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),suminf(A,F3)) ) ) ) ).

% suminf_nonneg
tff(fact_2998_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,N))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F3)) ) ) ) ).

% suminf_pos
tff(fact_2999_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X2)),archimedean_ceiling(A,Y2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2) ) ) ).

% ceiling_less_cancel
tff(fact_3000_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A)] : summable(A,aTP_Lamp_cj(fun(nat,A),fun(nat,A),F3)) ) ).

% summable_zero_power'
tff(fact_3001_summable__0__powser,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,A)] : summable(A,aTP_Lamp_ck(fun(nat,A),fun(nat,A),F3)) ) ).

% summable_0_powser
tff(fact_3002_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,A)),F3),Z))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_cm(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) ) ) ).

% powser_split_head(3)
tff(fact_3003_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cn(fun(nat,A),fun(A,fun(nat,A)),F3),Z))
        <=> summable(A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) ) ) ).

% summable_powser_split_head
tff(fact_3004_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,A),Ma: nat,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_co(fun(nat,A),fun(nat,fun(A,fun(nat,A))),F3),Ma),Z))
        <=> summable(A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) ) ) ).

% summable_powser_ignore_initial_segment
tff(fact_3005_polar__Ex,axiom,
    ! [X2: real,Y2: real] :
    ? [R2: real,A4: real] :
      ( ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),R2),cos(real,A4)) )
      & ( Y2 = aa(real,real,aa(real,fun(real,real),times_times(real),R2),sin(real,A4)) ) ) ).

% polar_Ex
tff(fact_3006_cos__arctan__not__zero,axiom,
    ! [X2: real] : ( cos(real,aa(real,real,arctan,X2)) != zero_zero(real) ) ).

% cos_arctan_not_zero
tff(fact_3007_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( ? [N6: nat] :
            ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N))),aa(nat,real,G,N)) )
         => ( summable(real,G)
           => summable(real,aTP_Lamp_cp(fun(nat,A),fun(nat,real),F3)) ) ) ) ).

% summable_norm_comparison_test
tff(fact_3008_summable__rabs__comparison__test,axiom,
    ! [F3: fun(nat,real),G: fun(nat,real)] :
      ( ? [N6: nat] :
        ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(nat,real,F3,N))),aa(nat,real,G,N)) )
     => ( summable(real,G)
       => summable(real,aTP_Lamp_cg(fun(nat,real),fun(nat,real),F3)) ) ) ).

% summable_rabs_comparison_test
tff(fact_3009_summable__rabs,axiom,
    ! [F3: fun(nat,real)] :
      ( summable(real,aTP_Lamp_cg(fun(nat,real),fun(nat,real),F3))
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),suminf(real,F3))),suminf(real,aTP_Lamp_cg(fun(nat,real),fun(nat,real),F3))) ) ).

% summable_rabs
tff(fact_3010_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),I3: nat] :
          ( summable(A,F3)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,I3))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F3)) ) ) ) ) ).

% suminf_pos2
tff(fact_3011_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F3))
            <=> ? [I: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,I)) ) ) ) ) ).

% suminf_pos_iff
tff(fact_3012_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( cos(A,X2) = one_one(A) )
         => ( sin(A,X2) = zero_zero(A) ) ) ) ).

% cos_one_sin_zero
tff(fact_3013_sin__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X2)),cos(A,Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X2)),sin(A,Y2))) ) ) ).

% sin_add
tff(fact_3014_sin__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X2)),cos(A,Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X2)),sin(A,Y2))) ) ) ).

% sin_diff
tff(fact_3015_summable__geometric,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => summable(A,power_power(A,C2)) ) ) ).

% summable_geometric
tff(fact_3016_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),one_one(real))
         => summable(A,power_power(A,X2)) ) ) ).

% complete_algebra_summable_geometric
tff(fact_3017_suminf__split__head,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( suminf(A,aTP_Lamp_cc(fun(nat,A),fun(nat,A),F3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F3)),aa(nat,A,F3,zero_zero(nat))) ) ) ) ).

% suminf_split_head
tff(fact_3018_ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),ring_1_of_int(A,A2))
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X2)),A2) ) ) ).

% ceiling_le
tff(fact_3019_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,Z)),X2) ) ) ).

% less_ceiling_iff
tff(fact_3020_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y2: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X2)),archimedean_ceiling(A,Y2))) ) ).

% ceiling_add_le
tff(fact_3021_cos__monotone__0__pi__le,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),pi)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,X2)),cos(real,Y2)) ) ) ) ).

% cos_monotone_0_pi_le
tff(fact_3022_cos__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),pi)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,X2)),cos(real,Y2))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),X2) ) ) ) ) ) ).

% cos_mono_le_eq
tff(fact_3023_cos__inj__pi,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),pi)
           => ( ( cos(real,X2) = cos(real,Y2) )
             => ( X2 = Y2 ) ) ) ) ) ) ).

% cos_inj_pi
tff(fact_3024_summable__norm,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A)] :
          ( summable(real,aTP_Lamp_cf(fun(nat,A),fun(nat,real),F3))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,suminf(A,F3))),suminf(real,aTP_Lamp_cf(fun(nat,A),fun(nat,real),F3))) ) ) ).

% summable_norm
tff(fact_3025_cos__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X2)),cos(A,Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X2)),sin(A,Y2))) ) ) ).

% cos_diff
tff(fact_3026_cos__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X2)),cos(A,Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X2)),sin(A,Y2))) ) ) ).

% cos_add
tff(fact_3027_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( sin(A,X2) = zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,cos(A,X2)) = one_one(real) ) ) ) ).

% sin_zero_norm_cos_one
tff(fact_3028_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,archimedean_ceiling(A,R))),aa(A,A,aa(A,fun(A,A),plus_plus(A),R),one_one(A))) ) ).

% of_int_ceiling_le_add_one
tff(fact_3029_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,archimedean_ceiling(A,R))),one_one(A))),R) ) ).

% of_int_ceiling_diff_one_le
tff(fact_3030_cos__two__neq__zero,axiom,
    cos(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) != zero_zero(real) ).

% cos_two_neq_zero
tff(fact_3031_powser__inside,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(nat,A),X2: A,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,A)),F3),X2))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),real_V7770717601297561774m_norm(A,X2))
           => summable(A,aa(A,fun(nat,A),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) ) ) ) ).

% powser_inside
tff(fact_3032_cos__monotone__0__pi,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),pi)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,X2)),cos(real,Y2)) ) ) ) ).

% cos_monotone_0_pi
tff(fact_3033_cos__mono__less__eq,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),pi)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,X2)),cos(real,Y2))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),X2) ) ) ) ) ) ).

% cos_mono_less_eq
tff(fact_3034_cos__monotone__minus__pi__0_H,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,Y2)),cos(real,X2)) ) ) ) ).

% cos_monotone_minus_pi_0'
tff(fact_3035_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: int,B2: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),ring_1_of_int(A,A2)),ring_1_of_int(A,B2))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),A2)),B2)) ) ) ).

% ceiling_divide_eq_div
tff(fact_3036_sin__zero__abs__cos__one,axiom,
    ! [X2: real] :
      ( ( sin(real,X2) = zero_zero(real) )
     => ( aa(real,real,abs_abs(real),cos(real,X2)) = one_one(real) ) ) ).

% sin_zero_abs_cos_one
tff(fact_3037_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,A)),F3),Z))
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,F3,zero_zero(nat))),aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cm(fun(nat,A),fun(A,fun(nat,A)),F3),Z))),Z)) ) ) ) ).

% powser_split_head(1)
tff(fact_3038_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,A)),F3),Z))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cm(fun(nat,A),fun(A,fun(nat,A)),F3),Z))),Z) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,A)),F3),Z))),aa(nat,A,F3,zero_zero(nat))) ) ) ) ).

% powser_split_head(2)
tff(fact_3039_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R: real,F3: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
         => ( summable(A,F3)
           => ? [N7: nat] :
              ! [N8: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N8)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,suminf(A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),F3),N8)))),R) ) ) ) ) ).

% suminf_exist_split
tff(fact_3040_summable__power__series,axiom,
    ! [F3: fun(nat,real),Z: real] :
      ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,I2)),one_one(real))
     => ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,I2))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Z)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z),one_one(real))
           => summable(real,aa(real,fun(nat,real),aTP_Lamp_cq(fun(nat,real),fun(real,fun(nat,real)),F3),Z)) ) ) ) ) ).

% summable_power_series
tff(fact_3041_Abel__lemma,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R: real,R0: real,A2: fun(nat,A),M6: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),R)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),R),R0)
           => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,aa(nat,A,A2,N))),aa(nat,real,power_power(real,R0),N))),M6)
             => summable(real,aa(fun(nat,A),fun(nat,real),aTP_Lamp_cr(real,fun(fun(nat,A),fun(nat,real)),R),A2)) ) ) ) ) ).

% Abel_lemma
tff(fact_3042_sin__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sin(A,X2))),cos(A,X2)) ) ) ).

% sin_double
tff(fact_3043_ceiling__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,archimedean_ceiling(A,X2))),one_one(A))),X2)
          & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),ring_1_of_int(A,archimedean_ceiling(A,X2))) ) ) ).

% ceiling_correct
tff(fact_3044_ceiling__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,Z)),one_one(A))),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),ring_1_of_int(A,Z))
           => ( archimedean_ceiling(A,X2) = Z ) ) ) ) ).

% ceiling_unique
tff(fact_3045_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,A2: int] :
          ( ( archimedean_ceiling(A,X2) = A2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,A2)),one_one(A))),X2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),ring_1_of_int(A,A2)) ) ) ) ).

% ceiling_eq_iff
tff(fact_3046_ceiling__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,$o),T2: A] :
          ( aa(int,$o,P,archimedean_ceiling(A,T2))
        <=> ! [I: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,I)),one_one(A))),T2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),ring_1_of_int(A,I)) )
             => aa(int,$o,P,I) ) ) ) ).

% ceiling_split
tff(fact_3047_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [C2: real,N3: nat,F3: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),one_one(real))
         => ( ! [N: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N3),N)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,aa(nat,nat,suc,N)))),aa(real,real,aa(real,fun(real,real),times_times(real),C2),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N)))) )
           => summable(A,F3) ) ) ) ).

% summable_ratio_test
tff(fact_3048_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A2)),archimedean_ceiling(A,B2))) ) ) ) ).

% mult_ceiling_le
tff(fact_3049_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X2)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,Z)),one_one(A))) ) ) ).

% ceiling_less_iff
tff(fact_3050_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),archimedean_ceiling(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,Z)),one_one(A))),X2) ) ) ).

% le_ceiling_iff
tff(fact_3051_cos__two__less__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),zero_zero(real)) ).

% cos_two_less_zero
tff(fact_3052_cos__two__le__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),zero_zero(real)) ).

% cos_two_le_zero
tff(fact_3053_cos__is__zero,axiom,
    ? [X4: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X4)
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
      & ( cos(real,X4) = zero_zero(real) )
      & ! [Y3: real] :
          ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
            & ( cos(real,Y3) = zero_zero(real) ) )
         => ( Y3 = X4 ) ) ) ).

% cos_is_zero
tff(fact_3054_cos__monotone__minus__pi__0,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,Y2)),cos(real,X2)) ) ) ) ).

% cos_monotone_minus_pi_0
tff(fact_3055_cos__total,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => ? [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),pi)
            & ( cos(real,X4) = Y2 )
            & ! [Y3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),pi)
                  & ( cos(real,Y3) = Y2 ) )
               => ( Y3 = X4 ) ) ) ) ) ).

% cos_total
tff(fact_3056_sincos__principal__value,axiom,
    ! [X2: real] :
    ? [Y4: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Y4)
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),pi)
      & ( sin(real,Y4) = sin(real,X2) )
      & ( cos(real,Y4) = cos(real,X2) ) ) ).

% sincos_principal_value
tff(fact_3057_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),ring_1_of_int(A,archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P2),Q2)))),Q2)) ) ) ).

% ceiling_divide_upper
tff(fact_3058_cos__45,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% cos_45
tff(fact_3059_sin__cos__le1,axiom,
    ! [X2: real,Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),sin(real,X2)),sin(real,Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),cos(real,X2)),cos(real,Y2))))),one_one(real)) ).

% sin_cos_le1
tff(fact_3060_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% cos_times_cos
tff(fact_3061_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% cos_plus_cos
tff(fact_3062_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(nat,A,power_power(A,sin(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,cos(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% sin_squared_eq
tff(fact_3063_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(nat,A,power_power(A,cos(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,sin(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% cos_squared_eq
tff(fact_3064_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),ring_1_of_int(A,archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P2),Q2)))),one_one(A))),Q2)),P2) ) ) ).

% ceiling_divide_lower
tff(fact_3065_ceiling__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Nb: int,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),ring_1_of_int(A,Nb)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,Nb)),one_one(A)))
           => ( archimedean_ceiling(A,X2) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Nb),one_one(int)) ) ) ) ) ).

% ceiling_eq
tff(fact_3066_cos__double__less__one,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X2))),one_one(real)) ) ) ).

% cos_double_less_one
tff(fact_3067_cos__gt__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),cos(real,X2)) ) ) ).

% cos_gt_zero
tff(fact_3068_cos__60,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% cos_60
tff(fact_3069_cos__30,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% cos_30
tff(fact_3070_cos__one__2pi__int,axiom,
    ! [X2: real] :
      ( ( cos(real,X2) = one_one(real) )
    <=> ? [X3: int] : ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,X3)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi) ) ) ).

% cos_one_2pi_int
tff(fact_3071_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),W)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,power_power(A,cos(A,W)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),one_one(A)) ) ) ).

% cos_double_cos
tff(fact_3072_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))),X2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,cos(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))),cos(A,X2))) ) ) ).

% cos_treble_cos
tff(fact_3073_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% sin_times_sin
tff(fact_3074_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% sin_times_cos
tff(fact_3075_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% cos_times_sin
tff(fact_3076_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% sin_plus_sin
tff(fact_3077_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% sin_diff_sin
tff(fact_3078_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),W)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% cos_diff_cos
tff(fact_3079_cos__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,cos(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,sin(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% cos_double
tff(fact_3080_cos__gt__zero__pi,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),cos(real,X2)) ) ) ).

% cos_gt_zero_pi
tff(fact_3081_cos__ge__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),cos(real,X2)) ) ) ).

% cos_ge_zero
tff(fact_3082_cos__one__2pi,axiom,
    ! [X2: real] :
      ( ( cos(real,X2) = one_one(real) )
    <=> ( ? [X3: nat] : ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),X3)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi) )
        | ? [X3: nat] : ( X2 = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),X3)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi)) ) ) ) ).

% cos_one_2pi
tff(fact_3083_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),W)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,power_power(A,sin(A,W)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% cos_double_sin
tff(fact_3084_cos__arctan,axiom,
    ! [X2: real] : ( cos(real,aa(real,real,arctan,X2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% cos_arctan
tff(fact_3085_sincos__total__pi,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
     => ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) )
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),pi)
            & ( X2 = cos(real,T3) )
            & ( Y2 = sin(real,T3) ) ) ) ) ).

% sincos_total_pi
tff(fact_3086_sin__cos__sqrt,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),sin(real,X2))
     => ( sin(real,X2) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,cos(real,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% sin_cos_sqrt
tff(fact_3087_sin__expansion__lemma,axiom,
    ! [X2: real,Ma: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Ma))),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) = cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Ma)),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ) ).

% sin_expansion_lemma
tff(fact_3088_cos__zero__iff__int,axiom,
    ! [X2: real] :
      ( ( cos(real,X2) = zero_zero(real) )
    <=> ? [I: int] :
          ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),I)
          & ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,I)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ).

% cos_zero_iff_int
tff(fact_3089_cos__zero__lemma,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( ( cos(real,X2) = zero_zero(real) )
       => ? [N: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)
            & ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ) ).

% cos_zero_lemma
tff(fact_3090_cos__zero__iff,axiom,
    ! [X2: real] :
      ( ( cos(real,X2) = zero_zero(real) )
    <=> ( ? [N4: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4)
            & ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) )
        | ? [N4: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4)
            & ( X2 = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ) ) ) ) ).

% cos_zero_iff
tff(fact_3091_cos__expansion__lemma,axiom,
    ! [X2: real,Ma: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Ma))),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) = aa(real,real,uminus_uminus(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Ma)),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))) ) ).

% cos_expansion_lemma
tff(fact_3092_sincos__total__pi__half,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) )
         => ? [T3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
              & ( X2 = cos(real,T3) )
              & ( Y2 = sin(real,T3) ) ) ) ) ) ).

% sincos_total_pi_half
tff(fact_3093_sincos__total__2pi__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) )
     => ? [T3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
          & ( X2 = cos(real,T3) )
          & ( Y2 = sin(real,T3) ) ) ) ).

% sincos_total_2pi_le
tff(fact_3094_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,power_power(nat,B2),Nb)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat))))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
         => ( archimedean_ceiling(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Nb)),one_one(int)) ) ) ) ) ).

% ceiling_log_nat_eq_if
tff(fact_3095_ceiling__log2__div2,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( archimedean_ceiling(real,aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Nb))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(real,aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat)))))),one_one(int)) ) ) ).

% ceiling_log2_div2
tff(fact_3096_sincos__total__2pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) )
     => ~ ! [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
             => ( ( X2 = cos(real,T3) )
               => ( Y2 != sin(real,T3) ) ) ) ) ) ).

% sincos_total_2pi
tff(fact_3097_tan__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( cos(A,X2) != zero_zero(A) )
         => ( ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)) != zero_zero(A) )
           => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,tan(A),X2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,aa(A,A,tan(A),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ) ).

% tan_double
tff(fact_3098_sin__tan,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
     => ( sin(real,X2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,tan(real),X2)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,aa(real,real,tan(real),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% sin_tan
tff(fact_3099_cos__tan,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
     => ( cos(real,X2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,aa(real,real,tan(real),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% cos_tan
tff(fact_3100_ceiling__log__eq__powr__iff,axiom,
    ! [X2: real,B2: real,K: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( ( archimedean_ceiling(real,aa(real,real,log(B2),X2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),K)),one_one(int)) )
        <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,B2,aa(nat,real,semiring_1_of_nat(real),K))),X2)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),powr(real,B2,aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))))) ) ) ) ) ).

% ceiling_log_eq_powr_iff
tff(fact_3101_cos__arcsin,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => ( cos(real,aa(real,real,arcsin,X2)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% cos_arcsin
tff(fact_3102_powr__0,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [Z: A] : ( powr(A,zero_zero(A),Z) = zero_zero(A) ) ) ).

% powr_0
tff(fact_3103_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [W: A,Z: A] :
          ( ( powr(A,W,Z) = zero_zero(A) )
        <=> ( W = zero_zero(A) ) ) ) ).

% powr_eq_0_iff
tff(fact_3104_tan__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,tan(A),zero_zero(A)) = zero_zero(A) ) ) ).

% tan_zero
tff(fact_3105_arcsin__0,axiom,
    aa(real,real,arcsin,zero_zero(real)) = zero_zero(real) ).

% arcsin_0
tff(fact_3106_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X2: A] :
          ( powr(A,X2,zero_zero(A))
          = $ite(X2 = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% powr_zero_eq_one
tff(fact_3107_powr__gt__zero,axiom,
    ! [X2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),powr(real,X2,A2))
    <=> ( X2 != zero_zero(real) ) ) ).

% powr_gt_zero
tff(fact_3108_powr__nonneg__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,A2,X2)),zero_zero(real))
    <=> ( A2 = zero_zero(real) ) ) ).

% powr_nonneg_iff
tff(fact_3109_powr__less__cancel__iff,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,X2,A2)),powr(real,X2,B2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2) ) ) ).

% powr_less_cancel_iff
tff(fact_3110_tan__pi,axiom,
    aa(real,real,tan(real),pi) = zero_zero(real) ).

% tan_pi
tff(fact_3111_powr__eq__one__iff,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( ( powr(real,A2,X2) = one_one(real) )
      <=> ( X2 = zero_zero(real) ) ) ) ).

% powr_eq_one_iff
tff(fact_3112_powr__one,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( powr(real,X2,one_one(real)) = X2 ) ) ).

% powr_one
tff(fact_3113_powr__one__gt__zero__iff,axiom,
    ! [X2: real] :
      ( ( powr(real,X2,one_one(real)) = X2 )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2) ) ).

% powr_one_gt_zero_iff
tff(fact_3114_powr__le__cancel__iff,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X2,A2)),powr(real,X2,B2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2) ) ) ).

% powr_le_cancel_iff
tff(fact_3115_numeral__powr__numeral__real,axiom,
    ! [Ma: num,Nb: num] : ( powr(real,aa(num,real,numeral_numeral(real),Ma),aa(num,real,numeral_numeral(real),Nb)) = aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),Ma)),aa(num,nat,numeral_numeral(nat),Nb)) ) ).

% numeral_powr_numeral_real
tff(fact_3116_powr__log__cancel,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( powr(real,A2,aa(real,real,log(A2),X2)) = X2 ) ) ) ) ).

% powr_log_cancel
tff(fact_3117_log__powr__cancel,axiom,
    ! [A2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),powr(real,A2,Y2)) = Y2 ) ) ) ).

% log_powr_cancel
tff(fact_3118_tan__npi,axiom,
    ! [Nb: nat] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),pi)) = zero_zero(real) ) ).

% tan_npi
tff(fact_3119_tan__periodic__n,axiom,
    ! [X2: real,Nb: num] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),Nb)),pi))) = aa(real,real,tan(real),X2) ) ).

% tan_periodic_n
tff(fact_3120_tan__periodic__nat,axiom,
    ! [X2: real,Nb: nat] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),pi))) = aa(real,real,tan(real),X2) ) ).

% tan_periodic_nat
tff(fact_3121_tan__periodic__int,axiom,
    ! [X2: real,I3: int] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,I3)),pi))) = aa(real,real,tan(real),X2) ) ).

% tan_periodic_int
tff(fact_3122_powr__numeral,axiom,
    ! [X2: real,Nb: num] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( powr(real,X2,aa(num,real,numeral_numeral(real),Nb)) = aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),Nb)) ) ) ).

% powr_numeral
tff(fact_3123_arcsin__1,axiom,
    aa(real,real,arcsin,one_one(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% arcsin_1
tff(fact_3124_tan__periodic,axiom,
    ! [X2: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) = aa(real,real,tan(real),X2) ) ).

% tan_periodic
tff(fact_3125_arcsin__minus__1,axiom,
    aa(real,real,arcsin,aa(real,real,uminus_uminus(real),one_one(real))) = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ).

% arcsin_minus_1
tff(fact_3126_square__powr__half,axiom,
    ! [X2: real] : ( powr(real,aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = aa(real,real,abs_abs(real),X2) ) ).

% square_powr_half
tff(fact_3127_powr__powr,axiom,
    ! [X2: real,A2: real,B2: real] : ( powr(real,powr(real,X2,A2),B2) = powr(real,X2,aa(real,real,aa(real,fun(real,real),times_times(real),A2),B2)) ) ).

% powr_powr
tff(fact_3128_powr__non__neg,axiom,
    ! [A2: real,X2: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,A2,X2)),zero_zero(real)) ).

% powr_non_neg
tff(fact_3129_powr__less__mono2__neg,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,Y2,A2)),powr(real,X2,A2)) ) ) ) ).

% powr_less_mono2_neg
tff(fact_3130_powr__ge__pzero,axiom,
    ! [X2: real,Y2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),powr(real,X2,Y2)) ).

% powr_ge_pzero
tff(fact_3131_powr__mono2,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X2,A2)),powr(real,Y2,A2)) ) ) ) ).

% powr_mono2
tff(fact_3132_powr__less__mono,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,X2,A2)),powr(real,X2,B2)) ) ) ).

% powr_less_mono
tff(fact_3133_powr__less__cancel,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,X2,A2)),powr(real,X2,B2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2) ) ) ).

% powr_less_cancel
tff(fact_3134_powr__mono2_H,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,Y2,A2)),powr(real,X2,A2)) ) ) ) ).

% powr_mono2'
tff(fact_3135_powr__less__mono2,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,X2,A2)),powr(real,Y2,A2)) ) ) ) ).

% powr_less_mono2
tff(fact_3136_powr__inj,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( ( powr(real,A2,X2) = powr(real,A2,Y2) )
        <=> ( X2 = Y2 ) ) ) ) ).

% powr_inj
tff(fact_3137_gr__one__powr,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),powr(real,X2,Y2)) ) ) ).

% gr_one_powr
tff(fact_3138_powr__le1,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X2,A2)),one_one(real)) ) ) ) ).

% powr_le1
tff(fact_3139_powr__mono__both,axiom,
    ! [A2: real,B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X2,A2)),powr(real,Y2,B2)) ) ) ) ) ).

% powr_mono_both
tff(fact_3140_ge__one__powr__ge__zero,axiom,
    ! [X2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),powr(real,X2,A2)) ) ) ).

% ge_one_powr_ge_zero
tff(fact_3141_powr__divide,axiom,
    ! [X2: real,Y2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( powr(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),Y2),A2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,X2,A2)),powr(real,Y2,A2)) ) ) ) ).

% powr_divide
tff(fact_3142_powr__mult,axiom,
    ! [X2: real,Y2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( powr(real,aa(real,real,aa(real,fun(real,real),times_times(real),X2),Y2),A2) = aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,X2,A2)),powr(real,Y2,A2)) ) ) ) ).

% powr_mult
tff(fact_3143_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),A2),powr(real,B2,C2)) = aa(real,real,aa(real,fun(real,real),times_times(real),A2),powr(real,B2,aa(real,real,uminus_uminus(real),C2))) ) ).

% divide_powr_uminus
tff(fact_3144_log__base__powr,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( A2 != zero_zero(real) )
     => ( aa(real,real,log(powr(real,A2,B2)),X2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A2),X2)),B2) ) ) ).

% log_base_powr
tff(fact_3145_ln__powr,axiom,
    ! [X2: real,Y2: real] :
      ( ( X2 != zero_zero(real) )
     => ( aa(real,real,ln_ln(real),powr(real,X2,Y2)) = aa(real,real,aa(real,fun(real,real),times_times(real),Y2),aa(real,real,ln_ln(real),X2)) ) ) ).

% ln_powr
tff(fact_3146_log__powr,axiom,
    ! [X2: real,B2: real,Y2: real] :
      ( ( X2 != zero_zero(real) )
     => ( aa(real,real,log(B2),powr(real,X2,Y2)) = aa(real,real,aa(real,fun(real,real),times_times(real),Y2),aa(real,real,log(B2),X2)) ) ) ).

% log_powr
tff(fact_3147_powr__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X2: A,A2: A,B2: A] : ( powr(A,X2,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),powr(A,X2,A2)),powr(A,X2,B2)) ) ) ).

% powr_add
tff(fact_3148_powr__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [W: A,Z1: A,Z22: A] : ( powr(A,W,aa(A,A,aa(A,fun(A,A),minus_minus(A),Z1),Z22)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),powr(A,W,Z1)),powr(A,W,Z22)) ) ) ).

% powr_diff
tff(fact_3149_tan__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,tan(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,X)),cos(A,X)) ) ) ).

% tan_def
tff(fact_3150_powr__realpow,axiom,
    ! [X2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( powr(real,X2,aa(nat,real,semiring_1_of_nat(real),Nb)) = aa(nat,real,power_power(real,X2),Nb) ) ) ).

% powr_realpow
tff(fact_3151_less__log__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,log(B2),X2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,B2,Y2)),X2) ) ) ) ).

% less_log_iff
tff(fact_3152_log__less__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),X2)),Y2)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),powr(real,B2,Y2)) ) ) ) ).

% log_less_iff
tff(fact_3153_less__powr__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),powr(real,B2,Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),X2)),Y2) ) ) ) ).

% less_powr_iff
tff(fact_3154_powr__less__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,B2,Y2)),X2)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,log(B2),X2)) ) ) ) ).

% powr_less_iff
tff(fact_3155_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X2: A,A2: A] : ( powr(A,X2,aa(A,A,uminus_uminus(A),A2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),powr(A,X2,A2)) ) ) ).

% powr_minus_divide
tff(fact_3156_powr__neg__one,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( powr(real,X2,aa(real,real,uminus_uminus(real),one_one(real))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X2) ) ) ).

% powr_neg_one
tff(fact_3157_arcsin__less__arcsin,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,X2)),aa(real,real,arcsin,Y2)) ) ) ) ).

% arcsin_less_arcsin
tff(fact_3158_powr__mult__base,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),X2),powr(real,X2,Y2)) = powr(real,X2,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Y2)) ) ) ).

% powr_mult_base
tff(fact_3159_arcsin__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y2)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,X2)),aa(real,real,arcsin,Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ) ) ).

% arcsin_less_mono
tff(fact_3160_powr__le__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,B2,Y2)),X2)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,log(B2),X2)) ) ) ) ).

% powr_le_iff
tff(fact_3161_le__powr__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),powr(real,B2,Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),X2)),Y2) ) ) ) ).

% le_powr_iff
tff(fact_3162_log__le__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),X2)),Y2)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),powr(real,B2,Y2)) ) ) ) ).

% log_le_iff
tff(fact_3163_le__log__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,log(B2),X2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,B2,Y2)),X2) ) ) ) ).

% le_log_iff
tff(fact_3164_ln__powr__bound,axiom,
    ! [X2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,X2,A2)),A2)) ) ) ).

% ln_powr_bound
tff(fact_3165_ln__powr__bound2,axiom,
    ! [X2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,aa(real,real,ln_ln(real),X2),A2)),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,A2,A2)),X2)) ) ) ).

% ln_powr_bound2
tff(fact_3166_tan__45,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2))))) = one_one(real) ).

% tan_45
tff(fact_3167_add__log__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),Y2),aa(real,real,log(B2),X2)) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,B2,Y2)),X2)) ) ) ) ) ).

% add_log_eq_powr
tff(fact_3168_log__add__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,log(B2),X2)),Y2) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),X2),powr(real,B2,Y2))) ) ) ) ) ).

% log_add_eq_powr
tff(fact_3169_minus__log__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),Y2),aa(real,real,log(B2),X2)) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,B2,Y2)),X2)) ) ) ) ) ).

% minus_log_eq_powr
tff(fact_3170_tan__60,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))) ).

% tan_60
tff(fact_3171_cos__arcsin__nonzero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => ( cos(real,aa(real,real,arcsin,X2)) != zero_zero(real) ) ) ) ).

% cos_arcsin_nonzero
tff(fact_3172_powr__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X2: A,A2: A] :
          ( powr(A,X2,A2)
          = $ite(X2 = zero_zero(A),zero_zero(A),aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,ln_ln(A),X2)))) ) ) ).

% powr_def
tff(fact_3173_tan__gt__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,tan(real),X2)) ) ) ).

% tan_gt_zero
tff(fact_3174_lemma__tan__total,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2)
     => ? [X4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X4)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,tan(real),X4)) ) ) ).

% lemma_tan_total
tff(fact_3175_lemma__tan__total1,axiom,
    ! [Y2: real] :
    ? [X4: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X4)
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
      & ( aa(real,real,tan(real),X4) = Y2 ) ) ).

% lemma_tan_total1
tff(fact_3176_tan__mono__lt__eq,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),X2)),aa(real,real,tan(real),Y2))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ) ) ) ) ).

% tan_mono_lt_eq
tff(fact_3177_tan__monotone_H,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),X2)
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),Y2)),aa(real,real,tan(real),X2)) ) ) ) ) ) ).

% tan_monotone'
tff(fact_3178_tan__monotone,axiom,
    ! [Y2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),Y2)),aa(real,real,tan(real),X2)) ) ) ) ).

% tan_monotone
tff(fact_3179_tan__total,axiom,
    ! [Y2: real] :
    ? [X4: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X4)
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
      & ( aa(real,real,tan(real),X4) = Y2 )
      & ! [Y3: real] :
          ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
            & ( aa(real,real,tan(real),Y3) = Y2 ) )
         => ( Y3 = X4 ) ) ) ).

% tan_total
tff(fact_3180_tan__minus__45,axiom,
    aa(real,real,tan(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))))) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% tan_minus_45
tff(fact_3181_tan__inverse,axiom,
    ! [Y2: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,tan(real),Y2)) = aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),Y2)) ) ).

% tan_inverse
tff(fact_3182_log__minus__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,log(B2),X2)),Y2) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),X2),powr(real,B2,aa(real,real,uminus_uminus(real),Y2)))) ) ) ) ) ).

% log_minus_eq_powr
tff(fact_3183_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] :
          ( ( cos(A,X2) != zero_zero(A) )
         => ( ( cos(A,Y2) != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tan(A),X2)),aa(A,A,tan(A),Y2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X2)),cos(A,Y2))) ) ) ) ) ).

% add_tan_eq
tff(fact_3184_powr__half__sqrt,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( powr(real,X2,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = aa(real,real,sqrt,X2) ) ) ).

% powr_half_sqrt
tff(fact_3185_powr__neg__numeral,axiom,
    ! [X2: real,Nb: num] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( powr(real,X2,aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),Nb))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),Nb))) ) ) ).

% powr_neg_numeral
tff(fact_3186_tan__pos__pi2__le,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,tan(real),X2)) ) ) ).

% tan_pos_pi2_le
tff(fact_3187_tan__total__pos,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
     => ? [X4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X4)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
          & ( aa(real,real,tan(real),X4) = Y2 ) ) ) ).

% tan_total_pos
tff(fact_3188_tan__less__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),X2)),zero_zero(real)) ) ) ).

% tan_less_zero
tff(fact_3189_tan__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tan(real),X2)),aa(real,real,tan(real),Y2))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2) ) ) ) ) ) ).

% tan_mono_le_eq
tff(fact_3190_tan__mono__le,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tan(real),X2)),aa(real,real,tan(real),Y2)) ) ) ) ).

% tan_mono_le
tff(fact_3191_tan__bound__pi2,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))))
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,tan(real),X2))),one_one(real)) ) ).

% tan_bound_pi2
tff(fact_3192_tan__30,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) ).

% tan_30
tff(fact_3193_arctan__unique,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( ( aa(real,real,tan(real),X2) = Y2 )
         => ( aa(real,real,arctan,Y2) = X2 ) ) ) ) ).

% arctan_unique
tff(fact_3194_arctan__tan,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,real,arctan,aa(real,real,tan(real),X2)) = X2 ) ) ) ).

% arctan_tan
tff(fact_3195_arctan,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arctan,Y2))
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
      & ( aa(real,real,tan(real),aa(real,real,arctan,Y2)) = Y2 ) ) ).

% arctan
tff(fact_3196_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] :
          ( ( cos(A,X2) != zero_zero(A) )
         => ( ( cos(A,Y2) != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X2)),aa(A,A,tan(A),Y2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X2)),cos(A,Y2))) ) ) ) ) ).

% lemma_tan_add1
tff(fact_3197_tan__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] :
          ( ( cos(A,X2) != zero_zero(A) )
         => ( ( cos(A,Y2) != zero_zero(A) )
           => ( ( cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) != zero_zero(A) )
             => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,tan(A),X2)),aa(A,A,tan(A),Y2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X2)),aa(A,A,tan(A),Y2)))) ) ) ) ) ) ).

% tan_diff
tff(fact_3198_tan__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] :
          ( ( cos(A,X2) != zero_zero(A) )
         => ( ( cos(A,Y2) != zero_zero(A) )
           => ( ( cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) != zero_zero(A) )
             => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tan(A),X2)),aa(A,A,tan(A),Y2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X2)),aa(A,A,tan(A),Y2)))) ) ) ) ) ) ).

% tan_add
tff(fact_3199_tan__total__pi4,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => ? [Z2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))))),Z2)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))))
          & ( aa(real,real,tan(real),Z2) = X2 ) ) ) ).

% tan_total_pi4
tff(fact_3200_arcsin__lt__bounded,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y2))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ).

% arcsin_lt_bounded
tff(fact_3201_arcsin__bounded,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y2))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ).

% arcsin_bounded
tff(fact_3202_arcsin__ubound,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ).

% arcsin_ubound
tff(fact_3203_arcsin__lbound,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y2)) ) ) ).

% arcsin_lbound
tff(fact_3204_arcsin__sin,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,real,arcsin,sin(real,X2)) = X2 ) ) ) ).

% arcsin_sin
tff(fact_3205_tan__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(A,A,tan(A),X2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2))),one_one(A))) ) ) ).

% tan_half
tff(fact_3206_le__arcsin__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,arcsin,X2))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,Y2)),X2) ) ) ) ) ) ).

% le_arcsin_iff
tff(fact_3207_arcsin__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,X2)),Y2)
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),sin(real,Y2)) ) ) ) ) ) ).

% arcsin_le_iff
tff(fact_3208_arcsin__pi,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y2))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y2)),pi)
          & ( sin(real,aa(real,real,arcsin,Y2)) = Y2 ) ) ) ) ).

% arcsin_pi
tff(fact_3209_arcsin,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y2))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
          & ( sin(real,aa(real,real,arcsin,Y2)) = Y2 ) ) ) ) ).

% arcsin
tff(fact_3210_arcosh__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X2: A] : ( aa(A,A,arcosh(A),X2) = aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),powr(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)),aa(real,A,real_Vector_of_real(A),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))))) ) ) ).

% arcosh_def
tff(fact_3211_sin__arccos__abs,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y2)),one_one(real))
     => ( sin(real,aa(real,real,arccos,Y2)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% sin_arccos_abs
tff(fact_3212_sin__arccos,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => ( sin(real,aa(real,real,arccos,X2)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% sin_arccos
tff(fact_3213_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),one_one(real))
         => aa(A,$o,sums(A,aTP_Lamp_cs(A,fun(nat,A),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% geometric_deriv_sums
tff(fact_3214_arsinh__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X2: A] : ( aa(A,A,arsinh(A),X2) = aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),powr(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)),aa(real,A,real_Vector_of_real(A),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))))) ) ) ).

% arsinh_def
tff(fact_3215_summable__complex__of__real,axiom,
    ! [F3: fun(nat,real)] :
      ( summable(complex,aTP_Lamp_ct(fun(nat,real),fun(nat,complex),F3))
    <=> summable(real,F3) ) ).

% summable_complex_of_real
tff(fact_3216_sums__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => aa(A,$o,sums(A,aTP_Lamp_bu(nat,A)),zero_zero(A)) ) ).

% sums_zero
tff(fact_3217_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X2: real] :
          ( ( aa(real,A,real_Vector_of_real(A),X2) = zero_zero(A) )
        <=> ( X2 = zero_zero(real) ) ) ) ).

% of_real_eq_0_iff
tff(fact_3218_of__real__0,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ( aa(real,A,real_Vector_of_real(A),zero_zero(real)) = zero_zero(A) ) ) ).

% of_real_0
tff(fact_3219_of__real__mult,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X2: real,Y2: real] : ( aa(real,A,real_Vector_of_real(A),aa(real,real,aa(real,fun(real,real),times_times(real),X2),Y2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(real,A,real_Vector_of_real(A),X2)),aa(real,A,real_Vector_of_real(A),Y2)) ) ) ).

% of_real_mult
tff(fact_3220_of__real__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : ( aa(real,A,real_Vector_of_real(A),aa(num,real,numeral_numeral(real),W)) = aa(num,A,numeral_numeral(A),W) ) ) ).

% of_real_numeral
tff(fact_3221_of__real__divide,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [X2: real,Y2: real] : ( aa(real,A,real_Vector_of_real(A),aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),Y2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(real,A,real_Vector_of_real(A),X2)),aa(real,A,real_Vector_of_real(A),Y2)) ) ) ).

% of_real_divide
tff(fact_3222_of__real__add,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X2: real,Y2: real] : ( aa(real,A,real_Vector_of_real(A),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(real,A,real_Vector_of_real(A),X2)),aa(real,A,real_Vector_of_real(A),Y2)) ) ) ).

% of_real_add
tff(fact_3223_of__real__power,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X2: real,Nb: nat] : ( aa(real,A,real_Vector_of_real(A),aa(nat,real,power_power(real,X2),Nb)) = aa(nat,A,power_power(A,aa(real,A,real_Vector_of_real(A),X2)),Nb) ) ) ).

% of_real_power
tff(fact_3224_arccos__1,axiom,
    aa(real,real,arccos,one_one(real)) = zero_zero(real) ).

% arccos_1
tff(fact_3225_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,aa(real,A,real_Vector_of_real(A),pi)) = zero_zero(A) ) ) ).

% sin_of_real_pi
tff(fact_3226_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : ( aa(real,A,real_Vector_of_real(A),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),W))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) ) ) ).

% of_real_neg_numeral
tff(fact_3227_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: fun(nat,A),X2: A] :
          ( aa(A,$o,sums(A,aTP_Lamp_ck(fun(nat,A),fun(nat,A),A2)),X2)
        <=> ( aa(nat,A,A2,zero_zero(nat)) = X2 ) ) ) ).

% powser_sums_zero_iff
tff(fact_3228_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X2: real] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(real,A,real_Vector_of_real(A),X2)),one_one(A))) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),one_one(real))) ) ) ).

% norm_of_real_add1
tff(fact_3229_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X2: real,B2: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(real,A,real_Vector_of_real(A),X2)),aa(num,A,numeral_numeral(A),B2))) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(num,real,numeral_numeral(real),B2))) ) ) ).

% norm_of_real_addn
tff(fact_3230_arccos__0,axiom,
    aa(real,real,arccos,zero_zero(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% arccos_0
tff(fact_3231_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V7773925162809079976_field(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(real,A,real_Vector_of_real(A),pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = zero_zero(A) ) ) ).

% cos_of_real_pi_half
tff(fact_3232_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V7773925162809079976_field(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(real,A,real_Vector_of_real(A),pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = one_one(A) ) ) ).

% sin_of_real_pi_half
tff(fact_3233_sums__of__real__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,real),C2: real] :
          ( aa(A,$o,sums(A,aTP_Lamp_cu(fun(nat,real),fun(nat,A),F3)),aa(real,A,real_Vector_of_real(A),C2))
        <=> aa(real,$o,sums(real,F3),C2) ) ) ).

% sums_of_real_iff
tff(fact_3234_sums__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1(A)
        & real_V822414075346904944vector(A) )
     => ! [X7: fun(nat,real),A2: real] :
          ( aa(real,$o,sums(real,X7),A2)
         => aa(A,$o,sums(A,aTP_Lamp_cv(fun(nat,real),fun(nat,A),X7)),aa(real,A,real_Vector_of_real(A),A2)) ) ) ).

% sums_of_real
tff(fact_3235_sums__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A)] :
          ( ! [N: nat] : ( aa(nat,A,F3,N) = zero_zero(A) )
         => aa(A,$o,sums(A,F3),zero_zero(A)) ) ) ).

% sums_0
tff(fact_3236_sums__single,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [I3: nat,F3: fun(nat,A)] : aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bt(nat,fun(fun(nat,A),fun(nat,A)),I3),F3)),aa(nat,A,F3,I3)) ) ).

% sums_single
tff(fact_3237_sums__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),A2: A,C2: A] :
          ( aa(A,$o,sums(A,F3),A2)
         => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_by(fun(nat,A),fun(A,fun(nat,A)),F3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% sums_mult2
tff(fact_3238_sums__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),A2: A,C2: A] :
          ( aa(A,$o,sums(A,F3),A2)
         => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_bz(fun(nat,A),fun(A,fun(nat,A)),F3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) ) ) ).

% sums_mult
tff(fact_3239_sums__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A),A2: A,G: fun(nat,A),B2: A] :
          ( aa(A,$o,sums(A,F3),A2)
         => ( aa(A,$o,sums(A,G),B2)
           => aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% sums_add
tff(fact_3240_sums__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),A2: A,G: fun(nat,A),B2: A] :
          ( aa(A,$o,sums(A,F3),A2)
         => ( aa(A,$o,sums(A,G),B2)
           => aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ce(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% sums_diff
tff(fact_3241_sums__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(nat,A),A2: A,C2: A] :
          ( aa(A,$o,sums(A,F3),A2)
         => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_bx(fun(nat,A),fun(A,fun(nat,A)),F3),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)) ) ) ).

% sums_divide
tff(fact_3242_sums__minus,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),A2: A] :
          ( aa(A,$o,sums(A,F3),A2)
         => aa(A,$o,sums(A,aTP_Lamp_cb(fun(nat,A),fun(nat,A),F3)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% sums_minus
tff(fact_3243_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [C2: A,F3: fun(nat,A),D2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cw(A,fun(fun(nat,A),fun(nat,A)),C2),F3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2))
          <=> aa(A,$o,sums(A,F3),D2) ) ) ) ).

% sums_mult_iff
tff(fact_3244_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [C2: A,F3: fun(nat,A),D2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cx(A,fun(fun(nat,A),fun(nat,A)),C2),F3)),aa(A,A,aa(A,fun(A,A),times_times(A),D2),C2))
          <=> aa(A,$o,sums(A,F3),D2) ) ) ) ).

% sums_mult2_iff
tff(fact_3245_summable__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1(A)
        & real_V822414075346904944vector(A) )
     => ! [X7: fun(nat,real)] :
          ( summable(real,X7)
         => summable(A,aTP_Lamp_cv(fun(nat,real),fun(nat,A),X7)) ) ) ).

% summable_of_real
tff(fact_3246_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [Y2: real,X2: real] :
          ( ( Y2 != zero_zero(real) )
         => ( aa(real,A,real_Vector_of_real(A),aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),Y2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(real,A,real_Vector_of_real(A),X2)),aa(real,A,real_Vector_of_real(A),Y2)) ) ) ) ).

% nonzero_of_real_divide
tff(fact_3247_sums__mult__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F3: fun(nat,A),A2: A] :
          ( aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bw(A,fun(fun(nat,A),fun(nat,A)),C2),F3)),A2)
         => ( ( C2 != zero_zero(A) )
           => aa(A,$o,sums(A,F3),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)) ) ) ) ).

% sums_mult_D
tff(fact_3248_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),S: A] :
          ( ( aa(nat,A,F3,zero_zero(nat)) = zero_zero(A) )
         => ( aa(A,$o,sums(A,aTP_Lamp_cc(fun(nat,A),fun(nat,A),F3)),S)
           => aa(A,$o,sums(A,F3),S) ) ) ) ).

% sums_Suc_imp
tff(fact_3249_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A),L: A] :
          ( aa(A,$o,sums(A,aTP_Lamp_cy(fun(nat,A),fun(nat,A),F3)),L)
         => aa(A,$o,sums(A,F3),aa(A,A,aa(A,fun(A,A),plus_plus(A),L),aa(nat,A,F3,zero_zero(nat)))) ) ) ).

% sums_Suc
tff(fact_3250_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),S: A] :
          ( aa(A,$o,sums(A,aTP_Lamp_cc(fun(nat,A),fun(nat,A),F3)),S)
        <=> aa(A,$o,sums(A,F3),aa(A,A,aa(A,fun(A,A),plus_plus(A),S),aa(nat,A,F3,zero_zero(nat)))) ) ) ).

% sums_Suc_iff
tff(fact_3251_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Nb: nat,F3: fun(nat,A),S: A] :
          ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),Nb)
             => ( aa(nat,A,F3,I2) = zero_zero(A) ) )
         => ( aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cz(nat,fun(fun(nat,A),fun(nat,A)),Nb),F3)),S)
          <=> aa(A,$o,sums(A,F3),S) ) ) ) ).

% sums_zero_iff_shift
tff(fact_3252_suminf__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1(A)
        & real_V822414075346904944vector(A) )
     => ! [X7: fun(nat,real)] :
          ( summable(real,X7)
         => ( aa(real,A,real_Vector_of_real(A),suminf(real,X7)) = suminf(A,aTP_Lamp_cv(fun(nat,real),fun(nat,A),X7)) ) ) ) ).

% suminf_of_real
tff(fact_3253_norm__less__p1,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(real,A,real_Vector_of_real(A),real_V7770717601297561774m_norm(A,X2))),one_one(A)))) ) ).

% norm_less_p1
tff(fact_3254_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Ma: nat,Z: A] : aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_da(nat,fun(A,fun(nat,A)),Ma),Z)),aa(nat,A,power_power(A,Z),Ma)) ) ).

% powser_sums_if
tff(fact_3255_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: fun(nat,A)] : aa(A,$o,sums(A,aTP_Lamp_ck(fun(nat,A),fun(nat,A),A2)),aa(nat,A,A2,zero_zero(nat))) ) ).

% powser_sums_zero
tff(fact_3256_arccos__lbound,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y2)) ) ) ).

% arccos_lbound
tff(fact_3257_arccos__less__arccos,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,Y2)),aa(real,real,arccos,X2)) ) ) ) ).

% arccos_less_arccos
tff(fact_3258_arccos__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y2)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,X2)),aa(real,real,arccos,Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),X2) ) ) ) ).

% arccos_less_mono
tff(fact_3259_arccos__cos,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),pi)
       => ( aa(real,real,arccos,cos(real,X2)) = X2 ) ) ) ).

% arccos_cos
tff(fact_3260_arccos__lt__bounded,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,arccos,Y2))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,Y2)),pi) ) ) ) ).

% arccos_lt_bounded
tff(fact_3261_arccos__bounded,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y2))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y2)),pi) ) ) ) ).

% arccos_bounded
tff(fact_3262_sin__arccos__nonzero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => ( sin(real,aa(real,real,arccos,X2)) != zero_zero(real) ) ) ) ).

% sin_arccos_nonzero
tff(fact_3263_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Ma: int,X2: real] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),ring_1_of_int(A,Ma)),aa(real,A,real_Vector_of_real(A),X2))) = aa(real,A,real_Vector_of_real(A),cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,Ma)),X2))) ) ) ).

% cos_int_times_real
tff(fact_3264_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Ma: int,X2: real] : ( sin(A,aa(A,A,aa(A,fun(A,A),times_times(A),ring_1_of_int(A,Ma)),aa(real,A,real_Vector_of_real(A),X2))) = aa(real,A,real_Vector_of_real(A),sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,Ma)),X2))) ) ) ).

% sin_int_times_real
tff(fact_3265_arccos__cos2,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),X2)
       => ( aa(real,real,arccos,cos(real,X2)) = aa(real,real,uminus_uminus(real),X2) ) ) ) ).

% arccos_cos2
tff(fact_3266_geometric__sums,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => aa(A,$o,sums(A,power_power(A,C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),C2))) ) ) ).

% geometric_sums
tff(fact_3267_power__half__series,axiom,
    aa(real,$o,sums(real,aTP_Lamp_db(nat,real)),one_one(real)) ).

% power_half_series
tff(fact_3268_arccos,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y2))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y2)),pi)
          & ( cos(real,aa(real,real,arccos,Y2)) = Y2 ) ) ) ) ).

% arccos
tff(fact_3269_sums__if_H,axiom,
    ! [G: fun(nat,real),X2: real] :
      ( aa(real,$o,sums(real,G),X2)
     => aa(real,$o,sums(real,aTP_Lamp_dc(fun(nat,real),fun(nat,real),G)),X2) ) ).

% sums_if'
tff(fact_3270_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( sin(A,X2) = cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(real,A,real_Vector_of_real(A),pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),X2)) ) ) ).

% sin_cos_eq
tff(fact_3271_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( cos(A,X2) = sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(real,A,real_Vector_of_real(A),pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),X2)) ) ) ).

% cos_sin_eq
tff(fact_3272_sums__if,axiom,
    ! [G: fun(nat,real),X2: real,F3: fun(nat,real),Y2: real] :
      ( aa(real,$o,sums(real,G),X2)
     => ( aa(real,$o,sums(real,F3),Y2)
       => aa(real,$o,sums(real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_dd(fun(nat,real),fun(fun(nat,real),fun(nat,real)),G),F3)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2)) ) ) ).

% sums_if
tff(fact_3273_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(A,A,uminus_uminus(A),sin(A,X2)) = cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(real,A,real_Vector_of_real(A),pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% minus_sin_cos_eq
tff(fact_3274_arccos__le__pi2,axiom,
    ! [Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ).

% arccos_le_pi2
tff(fact_3275_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] : ( aa(real,real,arccos,cos(real,Theta)) != aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Theta),aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,K2)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)))) ) ).

% arccos_cos_eq_abs_2pi
tff(fact_3276_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [C2: fun(nat,A),X2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_de(fun(nat,A),fun(A,fun(nat,A)),C2),X2))
         => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_df(fun(nat,A),fun(A,fun(nat,A)),C2),X2)),suminf(A,aa(A,fun(nat,A),aTP_Lamp_de(fun(nat,A),fun(A,fun(nat,A)),C2),X2))) ) ) ).

% diffs_equiv
tff(fact_3277_sin__paired,axiom,
    ! [X2: real] : aa(real,$o,sums(real,aTP_Lamp_dg(real,fun(nat,real),X2)),sin(real,X2)) ).

% sin_paired
tff(fact_3278_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( ( archim6421214686448440834_floor(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(nat,int,semiring_1_of_nat(int),Nb) )
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,B2),Nb)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)))) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
tff(fact_3279_pochhammer__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))),comm_s3205402744901411588hammer(A,Z,Nb))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),Nb)) ) ) ).

% pochhammer_double
tff(fact_3280_mono__SucI1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,N)),aa(nat,A,X7,aa(nat,nat,suc,N)))
         => topological_monoseq(A,X7) ) ) ).

% mono_SucI1
tff(fact_3281_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( ( ring_1_of_int(A,archim6421214686448440834_floor(A,X2)) = X2 )
        <=> ? [N4: int] : ( X2 = ring_1_of_int(A,N4) ) ) ) ).

% of_int_floor_cancel
tff(fact_3282_fact__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,zero_zero(nat)) = one_one(A) ) ) ).

% fact_0
tff(fact_3283_floor__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archim6421214686448440834_floor(A,zero_zero(A)) = zero_zero(int) ) ) ).

% floor_zero
tff(fact_3284_floor__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archim6421214686448440834_floor(A,aa(num,A,numeral_numeral(A),V)) = aa(num,int,numeral_numeral(int),V) ) ) ).

% floor_numeral
tff(fact_3285_pochhammer__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : ( comm_s3205402744901411588hammer(A,A2,zero_zero(nat)) = one_one(A) ) ) ).

% pochhammer_0
tff(fact_3286_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% pochhammer_Suc0
tff(fact_3287_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% fact_Suc_0
tff(fact_3288_fact__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] : ( semiring_char_0_fact(A,aa(nat,nat,suc,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Nb))),semiring_char_0_fact(A,Nb)) ) ) ).

% fact_Suc
tff(fact_3289_fact__2,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% fact_2
tff(fact_3290_zero__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),archim6421214686448440834_floor(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2) ) ) ).

% zero_le_floor
tff(fact_3291_floor__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X2)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),zero_zero(A)) ) ) ).

% floor_less_zero
tff(fact_3292_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),V)),X2) ) ) ).

% numeral_le_floor
tff(fact_3293_zero__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),archim6421214686448440834_floor(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),X2) ) ) ).

% zero_less_floor
tff(fact_3294_floor__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),one_one(A)) ) ) ).

% floor_le_zero
tff(fact_3295_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X2)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(num,A,numeral_numeral(A),V)) ) ) ).

% floor_less_numeral
tff(fact_3296_floor__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X2)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),one_one(A)) ) ) ).

% floor_less_one
tff(fact_3297_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archim6421214686448440834_floor(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)) ) ) ).

% floor_neg_numeral
tff(fact_3298_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,X2)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% floor_diff_numeral
tff(fact_3299_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: num,Nb: nat] : ( archim6421214686448440834_floor(A,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),X2)),Nb)) = aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb) ) ) ).

% floor_numeral_power
tff(fact_3300_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A2)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),A2)),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_divide_eq_div_numeral
tff(fact_3301_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X2) ) ) ).

% numeral_less_floor
tff(fact_3302_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))) ) ) ).

% floor_le_numeral
tff(fact_3303_one__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),archim6421214686448440834_floor(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2) ) ) ).

% one_less_floor
tff(fact_3304_floor__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% floor_le_one
tff(fact_3305_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),X2) ) ) ).

% neg_numeral_le_floor
tff(fact_3306_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% floor_less_neg_numeral
tff(fact_3307_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),one_one(int)),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_one_divide_eq_div_numeral
tff(fact_3308_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A2)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),A2))),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_minus_divide_eq_div_numeral
tff(fact_3309_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X2) ) ) ).

% neg_numeral_less_floor
tff(fact_3310_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))) ) ) ).

% floor_le_neg_numeral
tff(fact_3311_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_minus_one_divide_eq_div_numeral
tff(fact_3312_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A4: complex,R2: real] : ( Z = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),R2)),aa(complex,complex,exp(complex),A4)) ) ).

% complex_exp_exists
tff(fact_3313_diffs__of__real,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [F3: fun(nat,real),X: nat] : ( aa(nat,A,diffs(A,aTP_Lamp_dh(fun(nat,real),fun(nat,A),F3)),X) = aa(real,A,real_Vector_of_real(A),aa(nat,real,diffs(real,F3),X)) ) ) ).

% diffs_of_real
tff(fact_3314_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semiri3467727345109120633visors(A) )
     => ! [Nb: nat] : ( semiring_char_0_fact(A,Nb) != zero_zero(A) ) ) ).

% fact_nonzero
tff(fact_3315_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X2)),archim6421214686448440834_floor(A,Y2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2) ) ) ).

% floor_less_cancel
tff(fact_3316_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),semiring_char_0_fact(A,Nb)) ) ).

% fact_ge_zero
tff(fact_3317_fact__not__neg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),semiring_char_0_fact(A,Nb)),zero_zero(A)) ) ).

% fact_not_neg
tff(fact_3318_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),semiring_char_0_fact(A,Nb)) ) ).

% fact_gt_zero
tff(fact_3319_diffs__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [C2: fun(nat,A),X: nat] : ( aa(nat,A,diffs(A,aTP_Lamp_di(fun(nat,A),fun(nat,A),C2)),X) = aa(A,A,uminus_uminus(A),aa(nat,A,diffs(A,C2),X)) ) ) ).

% diffs_minus
tff(fact_3320_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),comm_s3205402744901411588hammer(A,X2,Nb)) ) ) ).

% pochhammer_pos
tff(fact_3321_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Nb: nat,Ma: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,Nb) = zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
           => ( comm_s3205402744901411588hammer(A,A2,Ma) = zero_zero(A) ) ) ) ) ).

% pochhammer_eq_0_mono
tff(fact_3322_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Ma: nat,Nb: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,Ma) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
           => ( comm_s3205402744901411588hammer(A,A2,Nb) != zero_zero(A) ) ) ) ) ).

% pochhammer_neq_0_mono
tff(fact_3323_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_ring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [Nb: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),Nb) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)),semiring_char_0_fact(A,Nb)) ) ) ).

% pochhammer_same
tff(fact_3324_floor__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X2)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),ring_1_of_int(A,Z)) ) ) ).

% floor_less_iff
tff(fact_3325_le__floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y2: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),archim6421214686448440834_floor(A,Y2))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))) ) ).

% le_floor_add
tff(fact_3326_floor__add__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),Z) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),ring_1_of_int(A,Z))) ) ) ).

% floor_add_int
tff(fact_3327_int__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X2: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),archim6421214686448440834_floor(A,X2)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,Z)),X2)) ) ) ).

% int_add_floor
tff(fact_3328_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [K: int,L: int] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),ring_1_of_int(A,K)),ring_1_of_int(A,L))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) ) ) ).

% floor_divide_of_int_eq
tff(fact_3329_floor__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Nb: nat] :
          ( ( X2 = ring_1_of_int(A,archim6421214686448440834_floor(A,X2)) )
         => ( archim6421214686448440834_floor(A,aa(nat,A,power_power(A,X2),Nb)) = aa(nat,int,power_power(int,archim6421214686448440834_floor(A,X2)),Nb) ) ) ) ).

% floor_power
tff(fact_3330_fact__less__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),semiring_char_0_fact(A,Ma)),semiring_char_0_fact(A,Nb)) ) ) ) ).

% fact_less_mono
tff(fact_3331_fact__mod,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom(A)
        & semidom_modulo(A) )
     => ! [Ma: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( modulo_modulo(A,semiring_char_0_fact(A,Nb),semiring_char_0_fact(A,Ma)) = zero_zero(A) ) ) ) ).

% fact_mod
tff(fact_3332_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X2: A,Nb: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),comm_s3205402744901411588hammer(A,X2,Nb)) ) ) ).

% pochhammer_nonneg
tff(fact_3333_fact__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),semiring_char_0_fact(A,Nb)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,power_power(nat,Nb),Nb))) ) ).

% fact_le_power
tff(fact_3334_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Nb: nat] :
          ( comm_s3205402744901411588hammer(A,zero_zero(A),Nb)
          = $ite(Nb = zero_zero(nat),one_one(A),zero_zero(A)) ) ) ).

% pochhammer_0_left
tff(fact_3335_one__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),one_one(int)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),one_one(A))) ) ) ).

% one_add_floor
tff(fact_3336_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Ma: nat,Nb: nat] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb))) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)) ) ) ).

% floor_divide_of_nat_eq
tff(fact_3337_real__of__int__floor__add__one__gt,axiom,
    ! [R: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),R),aa(real,real,aa(real,fun(real,real),plus_plus(real),ring_1_of_int(real,archim6421214686448440834_floor(real,R))),one_one(real))) ).

% real_of_int_floor_add_one_gt
tff(fact_3338_floor__eq,axiom,
    ! [Nb: int,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),ring_1_of_int(real,Nb)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),plus_plus(real),ring_1_of_int(real,Nb)),one_one(real)))
       => ( archim6421214686448440834_floor(real,X2) = Nb ) ) ) ).

% floor_eq
tff(fact_3339_real__of__int__floor__add__one__ge,axiom,
    ! [R: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),R),aa(real,real,aa(real,fun(real,real),plus_plus(real),ring_1_of_int(real,archim6421214686448440834_floor(real,R))),one_one(real))) ).

% real_of_int_floor_add_one_ge
tff(fact_3340_real__of__int__floor__gt__diff__one,axiom,
    ! [R: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),R),one_one(real))),ring_1_of_int(real,archim6421214686448440834_floor(real,R))) ).

% real_of_int_floor_gt_diff_one
tff(fact_3341_real__of__int__floor__ge__diff__one,axiom,
    ! [R: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),R),one_one(real))),ring_1_of_int(real,archim6421214686448440834_floor(real,R))) ).

% real_of_int_floor_ge_diff_one
tff(fact_3342_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),Nb)) ) ) ).

% pochhammer_rec
tff(fact_3343_diffs__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [C2: fun(nat,A),X: nat] : ( aa(nat,A,diffs(A,C2),X) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,X))),aa(nat,A,C2,aa(nat,nat,suc,X))) ) ) ).

% diffs_def
tff(fact_3344_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,Z,aa(nat,nat,suc,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),Nb))),comm_s3205402744901411588hammer(A,Z,Nb)) ) ) ).

% pochhammer_rec'
tff(fact_3345_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,A2,Nb)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),Nb))) ) ) ).

% pochhammer_Suc
tff(fact_3346_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Nb: nat,K: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),K)
         => ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),K) = zero_zero(A) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
tff(fact_3347_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0(A)
        & idom(A) )
     => ! [Nb: nat,K: nat] :
          ( ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),K) = zero_zero(A) )
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),K) ) ) ).

% pochhammer_of_nat_eq_0_iff
tff(fact_3348_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Nb: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,Nb) = zero_zero(A) )
        <=> ? [K3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K3),Nb)
              & ( A2 = aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K3)) ) ) ) ) ).

% pochhammer_eq_0_iff
tff(fact_3349_fact__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: num] : ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),semiring_char_0_fact(A,pred_numeral(K))) ) ) ).

% fact_numeral
tff(fact_3350_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ring_char_0(A)
        & idom(A) )
     => ! [K: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
         => ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),K) != zero_zero(A) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
tff(fact_3351_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z: A,Nb: nat,Ma: nat] : ( comm_s3205402744901411588hammer(A,Z,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,Nb)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),Nb)),Ma)) ) ) ).

% pochhammer_product'
tff(fact_3352_fact__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Nb: nat] : ( semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb))),semiring_char_0_fact(A,Nb)) ) ) ).

% fact_double
tff(fact_3353_floor__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,$o),T2: A] :
          ( aa(int,$o,P,archim6421214686448440834_floor(A,T2))
        <=> ! [I: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,I)),T2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),T2),aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,I)),one_one(A))) )
             => aa(int,$o,P,I) ) ) ) ).

% floor_split
tff(fact_3354_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,A2: int] :
          ( ( archim6421214686448440834_floor(A,X2) = A2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,A2)),X2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,A2)),one_one(A))) ) ) ) ).

% floor_eq_iff
tff(fact_3355_floor__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,Z)),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,Z)),one_one(A)))
           => ( archim6421214686448440834_floor(A,X2) = Z ) ) ) ) ).

% floor_unique
tff(fact_3356_le__mult__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A2)),archim6421214686448440834_floor(A,B2))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))) ) ) ) ).

% le_mult_floor
tff(fact_3357_less__floor__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),archim6421214686448440834_floor(A,X2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,Z)),one_one(A))),X2) ) ) ).

% less_floor_iff
tff(fact_3358_floor__le__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X2)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,Z)),one_one(A))) ) ) ).

% floor_le_iff
tff(fact_3359_floor__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ring_1_of_int(A,archim6421214686448440834_floor(A,X2))),X2)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),one_one(int)))) ) ) ).

% floor_correct
tff(fact_3360_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X2: A] :
          ( ! [X4: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),X4))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),X2)) ) ) ).

% termdiff_converges_all
tff(fact_3361_floor__eq2,axiom,
    ! [Nb: int,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),ring_1_of_int(real,Nb)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),plus_plus(real),ring_1_of_int(real,Nb)),one_one(real)))
       => ( archim6421214686448440834_floor(real,X2) = Nb ) ) ) ).

% floor_eq2
tff(fact_3362_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),B2)
     => ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),A2),ring_1_of_int(real,B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),archim6421214686448440834_floor(real,A2)),B2) ) ) ).

% floor_divide_real_eq_div
tff(fact_3363_pochhammer__product,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Ma: nat,Nb: nat,Z: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( comm_s3205402744901411588hammer(A,Z,Nb) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,Ma)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma))) ) ) ) ).

% pochhammer_product
tff(fact_3364_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),ring_1_of_int(A,archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P2),Q2)))),Q2)),P2) ) ) ).

% floor_divide_lower
tff(fact_3365_square__fact__le__2__fact,axiom,
    ! [Nb: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),semiring_char_0_fact(real,Nb)),semiring_char_0_fact(real,Nb))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) ).

% square_fact_le_2_fact
tff(fact_3366_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Ma: nat] :
          ( semiring_char_0_fact(A,Ma)
          = $ite(Ma = zero_zero(nat),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Ma)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),one_one(nat))))) ) ) ).

% fact_num_eq_if
tff(fact_3367_fact__reduce,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( semiring_char_0_fact(A,Nb) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))) ) ) ) ).

% fact_reduce
tff(fact_3368_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [R: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),R),aa(nat,A,semiring_1_of_nat(A),K))),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),R),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),R),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),R)),one_one(A)),K)) ) ) ).

% pochhammer_absorb_comp
tff(fact_3369_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),ring_1_of_int(A,archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P2),Q2)))),one_one(A))),Q2)) ) ) ).

% floor_divide_upper
tff(fact_3370_round__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( archimedean_round(A,X2) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% round_def
tff(fact_3371_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)) ) ) ).

% pochhammer_minus
tff(fact_3372_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K)) ) ) ).

% pochhammer_minus'
tff(fact_3373_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,K5: real,C2: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),K5)
         => ( ! [X4: A] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X4)),K5)
               => summable(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),X4)) )
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_dl(A,fun(fun(nat,A),fun(nat,A)),X2),C2)) ) ) ) ).

% termdiff_converges
tff(fact_3374_floor__log__eq__powr__iff,axiom,
    ! [X2: real,B2: real,K: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( ( archim6421214686448440834_floor(real,aa(real,real,log(B2),X2)) = K )
        <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,B2,ring_1_of_int(real,K))),X2)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),powr(real,B2,ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))))) ) ) ) ) ).

% floor_log_eq_powr_iff
tff(fact_3375_monoseq__minus,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: fun(nat,A)] :
          ( topological_monoseq(A,A2)
         => topological_monoseq(A,aTP_Lamp_dm(fun(nat,A),fun(nat,A),A2)) ) ) ).

% monoseq_minus
tff(fact_3376_floor__log2__div2,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( archim6421214686448440834_floor(real,aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Nb))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(real,aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))),one_one(int)) ) ) ).

% floor_log2_div2
tff(fact_3377_cos__paired,axiom,
    ! [X2: real] : aa(real,$o,sums(real,aTP_Lamp_dn(real,fun(nat,real),X2)),cos(real,X2)) ).

% cos_paired
tff(fact_3378_floor__log__nat__eq__if,axiom,
    ! [B2: nat,Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,B2),Nb)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,power_power(nat,B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat))))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
         => ( archim6421214686448440834_floor(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(nat,int,semiring_1_of_nat(int),Nb) ) ) ) ) ).

% floor_log_nat_eq_if
tff(fact_3379_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( topological_monoseq(A,X7)
        <=> ( ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,N4)),aa(nat,A,X7,aa(nat,nat,suc,N4)))
            | ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N4))),aa(nat,A,X7,N4)) ) ) ) ).

% monoseq_Suc
tff(fact_3380_mono__SucI2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N))),aa(nat,A,X7,N))
         => topological_monoseq(A,X7) ) ) ).

% mono_SucI2
tff(fact_3381_sin__coeff__def,axiom,
    ! [X: nat] :
      ( sin_coeff(X)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),X),zero_zero(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),semiring_char_0_fact(real,X))) ) ).

% sin_coeff_def
tff(fact_3382_choose__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)))),semiring_char_0_fact(A,Nb)) ) ) ).

% choose_dvd
tff(fact_3383_cos__coeff__def,axiom,
    ! [X: nat] :
      ( cos_coeff(X)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),semiring_char_0_fact(real,X)),zero_zero(real)) ) ).

% cos_coeff_def
tff(fact_3384_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,Nb: nat] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,Nb))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Nb))) ) ).

% fact_fact_dvd_fact
tff(fact_3385_pochhammer__code,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Nb: nat] :
          ( comm_s3205402744901411588hammer(A,A2,Nb)
          = $ite(Nb = zero_zero(nat),one_one(A),set_fo6178422350223883121st_nat(A,aTP_Lamp_do(A,fun(nat,fun(A,A)),A2),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)),one_one(A))) ) ) ).

% pochhammer_code
tff(fact_3386_sin__coeff__0,axiom,
    sin_coeff(zero_zero(nat)) = zero_zero(real) ).

% sin_coeff_0
tff(fact_3387_cos__coeff__0,axiom,
    cos_coeff(zero_zero(nat)) = one_one(real) ).

% cos_coeff_0
tff(fact_3388_fact__less__mono__nat,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),semiring_char_0_fact(nat,Ma)),semiring_char_0_fact(nat,Nb)) ) ) ).

% fact_less_mono_nat
tff(fact_3389_sin__coeff__Suc,axiom,
    ! [Nb: nat] : ( sin_coeff(aa(nat,nat,suc,Nb)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),cos_coeff(Nb)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Nb))) ) ).

% sin_coeff_Suc
tff(fact_3390_fact__ge__Suc__0__nat,axiom,
    ! [Nb: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),semiring_char_0_fact(nat,Nb)) ).

% fact_ge_Suc_0_nat
tff(fact_3391_cos__coeff__Suc,axiom,
    ! [Nb: nat] : ( cos_coeff(aa(nat,nat,suc,Nb)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),sin_coeff(Nb))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Nb))) ) ).

% cos_coeff_Suc
tff(fact_3392_fact__diff__Suc,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,suc,Ma))
     => ( semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Ma)),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Ma)),Nb)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb))) ) ) ).

% fact_diff_Suc
tff(fact_3393_fact__div__fact__le__pow,axiom,
    ! [R: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,Nb)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),R)))),aa(nat,nat,power_power(nat,Nb),R)) ) ).

% fact_div_fact_le_pow
tff(fact_3394_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType,F3: fun(nat,fun(A,A)),A2: nat,B2: nat,Acc: A] :
      ( set_fo6178422350223883121st_nat(A,F3,A2,B2,Acc)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),B2),A2),Acc,set_fo6178422350223883121st_nat(A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),one_one(nat)),B2,aa(A,A,aa(nat,fun(A,A),F3,A2),Acc))) ) ).

% fold_atLeastAtMost_nat.simps
tff(fact_3395_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X2: fun(nat,fun(A,A)),Xa2: nat,Xb: nat,Xc: A,Y2: A] :
      ( ( set_fo6178422350223883121st_nat(A,X2,Xa2,Xb,Xc) = Y2 )
     => ( Y2
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xb),Xa2),Xc,set_fo6178422350223883121st_nat(A,X2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xa2),one_one(nat)),Xb,aa(A,A,aa(nat,fun(A,A),X2,Xa2),Xc))) ) ) ).

% fold_atLeastAtMost_nat.elims
tff(fact_3396_fact__code,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] : ( semiring_char_0_fact(A,Nb) = aa(nat,A,semiring_1_of_nat(A),set_fo6178422350223883121st_nat(nat,times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),Nb,one_one(nat))) ) ) ).

% fact_code
tff(fact_3397_round__altdef,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( archimedean_round(A,X2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),archimedean_frac(A,X2)),archimedean_ceiling(A,X2),archim6421214686448440834_floor(A,X2)) ) ) ).

% round_altdef
tff(fact_3398_of__nat__code,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),Nb) = semiri8178284476397505188at_aux(A,aTP_Lamp_dp(A,A),Nb,zero_zero(A)) ) ) ).

% of_nat_code
tff(fact_3399_central__binomial__lower__bound,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))),Nb)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Nb)))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),Nb))) ) ).

% central_binomial_lower_bound
tff(fact_3400_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm(complex,Z) = one_one(real) )
     => ~ ! [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
             => ( Z != complex2(cos(real,T3),sin(real,T3)) ) ) ) ) ).

% complex_unimodular_polar
tff(fact_3401_cot__less__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cot(real),X2)),zero_zero(real)) ) ) ).

% cot_less_zero
tff(fact_3402_binomial__Suc__n,axiom,
    ! [Nb: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,Nb)),Nb) = aa(nat,nat,suc,Nb) ) ).

% binomial_Suc_n
tff(fact_3403_cot__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,cot(A),zero_zero(A)) = zero_zero(A) ) ) ).

% cot_zero
tff(fact_3404_binomial__0__Suc,axiom,
    ! [K: nat] : ( aa(nat,nat,binomial(zero_zero(nat)),aa(nat,nat,suc,K)) = zero_zero(nat) ) ).

% binomial_0_Suc
tff(fact_3405_binomial__1,axiom,
    ! [Nb: nat] : ( aa(nat,nat,binomial(Nb),aa(nat,nat,suc,zero_zero(nat))) = Nb ) ).

% binomial_1
tff(fact_3406_binomial__eq__0__iff,axiom,
    ! [Nb: nat,K: nat] :
      ( ( aa(nat,nat,binomial(Nb),K) = zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),K) ) ).

% binomial_eq_0_iff
tff(fact_3407_binomial__Suc__Suc,axiom,
    ! [Nb: nat,K: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,Nb)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(Nb),K)),aa(nat,nat,binomial(Nb),aa(nat,nat,suc,K))) ) ).

% binomial_Suc_Suc
tff(fact_3408_binomial__n__0,axiom,
    ! [Nb: nat] : ( aa(nat,nat,binomial(Nb),zero_zero(nat)) = one_one(nat) ) ).

% binomial_n_0
tff(fact_3409_frac__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int] : ( archimedean_frac(A,ring_1_of_int(A,Z)) = zero_zero(A) ) ) ).

% frac_of_int
tff(fact_3410_cot__pi,axiom,
    aa(real,real,cot(real),pi) = zero_zero(real) ).

% cot_pi
tff(fact_3411_zero__less__binomial__iff,axiom,
    ! [Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,binomial(Nb),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb) ) ).

% zero_less_binomial_iff
tff(fact_3412_cot__npi,axiom,
    ! [Nb: nat] : ( aa(real,real,cot(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),pi)) = zero_zero(real) ) ).

% cot_npi
tff(fact_3413_cot__periodic,axiom,
    ! [X2: real] : ( aa(real,real,cot(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) = aa(real,real,cot(real),X2) ) ).

% cot_periodic
tff(fact_3414_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = zero_zero(complex) )
    <=> ( ( A2 = zero_zero(real) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_0
tff(fact_3415_zero__complex_Ocode,axiom,
    zero_zero(complex) = complex2(zero_zero(real),zero_zero(real)) ).

% zero_complex.code
tff(fact_3416_binomial__eq__0,axiom,
    ! [Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),K)
     => ( aa(nat,nat,binomial(Nb),K) = zero_zero(nat) ) ) ).

% binomial_eq_0
tff(fact_3417_Suc__times__binomial__eq,axiom,
    ! [Nb: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Nb)),aa(nat,nat,binomial(Nb),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,suc,Nb)),aa(nat,nat,suc,K))),aa(nat,nat,suc,K)) ) ).

% Suc_times_binomial_eq
tff(fact_3418_Suc__times__binomial,axiom,
    ! [K: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),aa(nat,nat,binomial(aa(nat,nat,suc,Nb)),aa(nat,nat,suc,K))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Nb)),aa(nat,nat,binomial(Nb),K)) ) ).

% Suc_times_binomial
tff(fact_3419_choose__mult__lemma,axiom,
    ! [Ma: nat,R: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),R)),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K)),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),R)),K)),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),R)),Ma)) ) ).

% choose_mult_lemma
tff(fact_3420_binomial__le__pow,axiom,
    ! [R: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Nb),R)),aa(nat,nat,power_power(nat,Nb),R)) ) ).

% binomial_le_pow
tff(fact_3421_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = one_one(complex) )
    <=> ( ( A2 = one_one(real) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_1
tff(fact_3422_one__complex_Ocode,axiom,
    one_one(complex) = complex2(one_one(real),zero_zero(real)) ).

% one_complex.code
tff(fact_3423_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( complex2(A2,B2) = aa(num,complex,numeral_numeral(complex),W) )
    <=> ( ( A2 = aa(num,real,numeral_numeral(real),W) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_numeral
tff(fact_3424_complex__of__real__def,axiom,
    ! [R: real] : ( aa(real,complex,real_Vector_of_real(complex),R) = complex2(R,zero_zero(real)) ) ).

% complex_of_real_def
tff(fact_3425_complex__of__real__code,axiom,
    ! [X: real] : ( aa(real,complex,real_Vector_of_real(complex),X) = complex2(X,zero_zero(real)) ) ).

% complex_of_real_code
tff(fact_3426_complex__eq__cancel__iff2,axiom,
    ! [X2: real,Y2: real,Xa2: real] :
      ( ( complex2(X2,Y2) = aa(real,complex,real_Vector_of_real(complex),Xa2) )
    <=> ( ( X2 = Xa2 )
        & ( Y2 = zero_zero(real) ) ) ) ).

% complex_eq_cancel_iff2
tff(fact_3427_frac__ge__0,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),archimedean_frac(A,X2)) ) ).

% frac_ge_0
tff(fact_3428_frac__lt__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),archimedean_frac(A,X2)),one_one(A)) ) ).

% frac_lt_1
tff(fact_3429_frac__1__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] : ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),one_one(A))) = archimedean_frac(A,X2) ) ) ).

% frac_1_eq
tff(fact_3430_zero__less__binomial,axiom,
    ! [K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,binomial(Nb),K)) ) ).

% zero_less_binomial
tff(fact_3431_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,A2)),aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))),aa(nat,nat,suc,A2))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,B2)),aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))),A2)) ) ).

% Suc_times_binomial_add
tff(fact_3432_choose__mult,axiom,
    ! [K: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Nb),Ma)),aa(nat,nat,binomial(Ma),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Nb),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),K))) ) ) ) ).

% choose_mult
tff(fact_3433_binomial__fact__lemma,axiom,
    ! [K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,K)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)))),aa(nat,nat,binomial(Nb),K)) = semiring_char_0_fact(nat,Nb) ) ) ).

% binomial_fact_lemma
tff(fact_3434_binomial__Suc__Suc__eq__times,axiom,
    ! [Nb: nat,K: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,Nb)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Nb)),aa(nat,nat,binomial(Nb),K))),aa(nat,nat,suc,K)) ) ).

% binomial_Suc_Suc_eq_times
tff(fact_3435_binomial__absorb__comp,axiom,
    ! [Nb: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)),aa(nat,nat,binomial(Nb),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),K)) ) ).

% binomial_absorb_comp
tff(fact_3436_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) )
    <=> ( ( A2 = aa(real,real,uminus_uminus(real),one_one(real)) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_neg_1
tff(fact_3437_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( complex2(A2,B2) = aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W)) )
    <=> ( ( A2 = aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),W)) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_neg_numeral
tff(fact_3438_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Inc: fun(A,A),Nb: nat,I3: A] : ( semiri8178284476397505188at_aux(A,Inc,aa(nat,nat,suc,Nb),I3) = semiri8178284476397505188at_aux(A,Inc,Nb,aa(A,A,Inc,I3)) ) ) ).

% of_nat_aux.simps(2)
tff(fact_3439_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Inc: fun(A,A),I3: A] : ( semiri8178284476397505188at_aux(A,Inc,zero_zero(nat),I3) = I3 ) ) ).

% of_nat_aux.simps(1)
tff(fact_3440_Complex__mult__complex__of__real,axiom,
    ! [X2: real,Y2: real,R: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(X2,Y2)),aa(real,complex,real_Vector_of_real(complex),R)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),X2),R),aa(real,real,aa(real,fun(real,real),times_times(real),Y2),R)) ) ).

% Complex_mult_complex_of_real
tff(fact_3441_complex__of__real__mult__Complex,axiom,
    ! [R: real,X2: real,Y2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),R)),complex2(X2,Y2)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R),X2),aa(real,real,aa(real,fun(real,real),times_times(real),R),Y2)) ) ).

% complex_of_real_mult_Complex
tff(fact_3442_binomial__absorption,axiom,
    ! [K: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),aa(nat,nat,binomial(Nb),aa(nat,nat,suc,K))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),K)) ) ).

% binomial_absorption
tff(fact_3443_binomial__altdef__nat,axiom,
    ! [K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
     => ( aa(nat,nat,binomial(Nb),K) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,Nb)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,K)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)))) ) ) ).

% binomial_altdef_nat
tff(fact_3444_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(A2,B2)),complex2(C2,D2)) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),A2),C2)),aa(real,real,aa(real,fun(real,real),times_times(real),B2),D2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),A2),D2)),aa(real,real,aa(real,fun(real,real),times_times(real),B2),C2))) ) ).

% complex_mult
tff(fact_3445_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [K: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(nat,A,semiring_1_of_nat(A),K))),K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Nb),K))) ) ) ).

% binomial_ge_n_over_k_pow_k
tff(fact_3446_binomial__mono,axiom,
    ! [K: nat,K7: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),K7)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K7)),Nb)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Nb),K)),aa(nat,nat,binomial(Nb),K7)) ) ) ).

% binomial_mono
tff(fact_3447_binomial__maximum_H,axiom,
    ! [Nb: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),Nb)) ).

% binomial_maximum'
tff(fact_3448_binomial__maximum,axiom,
    ! [Nb: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Nb),K)),aa(nat,nat,binomial(Nb),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ).

% binomial_maximum
tff(fact_3449_binomial__antimono,axiom,
    ! [K: nat,K7: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),K7)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),K)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K7),Nb)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Nb),K7)),aa(nat,nat,binomial(Nb),K)) ) ) ) ).

% binomial_antimono
tff(fact_3450_binomial__le__pow2,axiom,
    ! [Nb: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Nb),K)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ).

% binomial_le_pow2
tff(fact_3451_choose__reduce__nat,axiom,
    ! [Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( aa(nat,nat,binomial(Nb),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),K)) ) ) ) ).

% choose_reduce_nat
tff(fact_3452_times__binomial__minus1__eq,axiom,
    ! [K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,binomial(Nb),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ).

% times_binomial_minus1_eq
tff(fact_3453_cot__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,cot(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),cos(A,X)),sin(A,X)) ) ) ).

% cot_def
tff(fact_3454_frac__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( ( archimedean_frac(A,X2) = X2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),one_one(A)) ) ) ) ).

% frac_eq
tff(fact_3455_frac__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y2: A] :
          ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y2))),one_one(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y2))),one_one(A))) ) ) ).

% frac_add
tff(fact_3456_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),K7)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K7)),Nb)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(Nb),K)),aa(nat,nat,binomial(Nb),K7)) ) ) ).

% binomial_strict_mono
tff(fact_3457_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),K7)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K7),Nb)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(Nb),K7)),aa(nat,nat,binomial(Nb),K)) ) ) ) ).

% binomial_strict_antimono
tff(fact_3458_binomial__less__binomial__Suc,axiom,
    ! [K: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(Nb),K)),aa(nat,nat,binomial(Nb),aa(nat,nat,suc,K))) ) ).

% binomial_less_binomial_Suc
tff(fact_3459_central__binomial__odd,axiom,
    ! [Nb: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(nat,nat,binomial(Nb),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) = aa(nat,nat,binomial(Nb),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% central_binomial_odd
tff(fact_3460_binomial__addition__formula,axiom,
    ! [Nb: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,nat,binomial(Nb),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),aa(nat,nat,suc,K))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))),K)) ) ) ).

% binomial_addition_formula
tff(fact_3461_binomial__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Nb),K)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),semiring_char_0_fact(A,Nb)),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)))) ) ) ) ).

% binomial_fact
tff(fact_3462_fact__binomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Nb),K))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),semiring_char_0_fact(A,Nb)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K))) ) ) ) ).

% fact_binomial
tff(fact_3463_complex__norm,axiom,
    ! [X2: real,Y2: real] : ( real_V7770717601297561774m_norm(complex,complex2(X2,Y2)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,Y2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% complex_norm
tff(fact_3464_choose__two,axiom,
    ! [Nb: nat] : ( aa(nat,nat,binomial(Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% choose_two
tff(fact_3465_floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y2: A] :
          ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X2)),archimedean_frac(A,Y2))),one_one(A)),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),archim6421214686448440834_floor(A,Y2)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),archim6421214686448440834_floor(A,Y2))),one_one(int))) ) ) ).

% floor_add
tff(fact_3466_binomial__code,axiom,
    ! [Nb: nat,K: nat] :
      ( aa(nat,nat,binomial(Nb),K)
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),K),
          zero_zero(nat),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)),aa(nat,nat,binomial(Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),set_fo6178422350223883121st_nat(nat,times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)),one_one(nat)),Nb,one_one(nat))),semiring_char_0_fact(nat,K))) ) ) ).

% binomial_code
tff(fact_3467_cot__gt__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,cot(real),X2)) ) ) ).

% cot_gt_zero
tff(fact_3468_tan__cot_H,axiom,
    ! [X2: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X2)) = aa(real,real,cot(real),X2) ) ).

% tan_cot'
tff(fact_3469_gbinomial__code,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] :
          ( aa(nat,A,gbinomial(A,A2),K)
          = $ite(K = zero_zero(nat),one_one(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),set_fo6178422350223883121st_nat(A,aTP_Lamp_dq(A,fun(nat,fun(A,A)),A2),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)),one_one(A))),semiring_char_0_fact(A,K))) ) ) ).

% gbinomial_code
tff(fact_3470_arctan__def,axiom,
    ! [Y2: real] : ( aa(real,real,arctan,Y2) = the(real,aTP_Lamp_dr(real,fun(real,$o),Y2)) ) ).

% arctan_def
tff(fact_3471_arcsin__def,axiom,
    ! [Y2: real] : ( aa(real,real,arcsin,Y2) = the(real,aTP_Lamp_ds(real,fun(real,$o),Y2)) ) ).

% arcsin_def
tff(fact_3472_modulo__int__unfold,axiom,
    ! [K: int,Ma: nat,L: int,Nb: nat] :
      ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),Ma)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),Nb)))
      = $ite(
          ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
          | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
          | ( Nb = zero_zero(nat) ) ),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),Ma)),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,Ma,Nb))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Nb),Ma))))),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,Ma,Nb))))) ) ) ).

% modulo_int_unfold
tff(fact_3473_powr__int,axiom,
    ! [X2: real,I3: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( powr(real,X2,ring_1_of_int(real,I3))
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I3),aa(nat,real,power_power(real,X2),aa(int,nat,nat2,I3)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),I3))))) ) ) ).

% powr_int
tff(fact_3474_sgn__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,sgn_sgn(A),A2)) = aa(A,A,sgn_sgn(A),A2) ) ) ).

% sgn_sgn
tff(fact_3475_sgn__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_0
tff(fact_3476_sgn__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_zero
tff(fact_3477_sgn__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),one_one(A)) = one_one(A) ) ) ).

% sgn_1
tff(fact_3478_sgn__divide,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% sgn_divide
tff(fact_3479_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),A2)) ) ) ).

% idom_abs_sgn_class.sgn_minus
tff(fact_3480_power__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Nb: nat] : ( aa(A,A,sgn_sgn(A),aa(nat,A,power_power(A,A2),Nb)) = aa(nat,A,power_power(A,aa(A,A,sgn_sgn(A),A2)),Nb) ) ) ).

% power_sgn
tff(fact_3481_sgn__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,sgn_sgn(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% sgn_less
tff(fact_3482_sgn__greater,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,sgn_sgn(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% sgn_greater
tff(fact_3483_divide__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,sgn_sgn(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% divide_sgn
tff(fact_3484_gbinomial__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [K: nat] : ( aa(nat,A,gbinomial(A,zero_zero(A)),aa(nat,nat,suc,K)) = zero_zero(A) ) ) ).

% gbinomial_0(2)
tff(fact_3485_nat__numeral,axiom,
    ! [K: num] : ( aa(int,nat,nat2,aa(num,int,numeral_numeral(int),K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% nat_numeral
tff(fact_3486_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A] : ( aa(nat,A,gbinomial(A,A2),zero_zero(nat)) = one_one(A) ) ) ).

% gbinomial_0(1)
tff(fact_3487_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% gbinomial_Suc0
tff(fact_3488_sgn__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,A,sgn_sgn(A),A2) = one_one(A) ) ) ) ).

% sgn_pos
tff(fact_3489_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2)) = one_one(A) ) ) ) ).

% abs_sgn_eq_1
tff(fact_3490_nat__1,axiom,
    aa(int,nat,nat2,one_one(int)) = aa(nat,nat,suc,zero_zero(nat)) ).

% nat_1
tff(fact_3491_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,sgn_sgn(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% sgn_mult_self_eq
tff(fact_3492_nat__0__iff,axiom,
    ! [I3: int] :
      ( ( aa(int,nat,nat2,I3) = zero_zero(nat) )
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),zero_zero(int)) ) ).

% nat_0_iff
tff(fact_3493_nat__le__0,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int))
     => ( aa(int,nat,nat2,Z) = zero_zero(nat) ) ) ).

% nat_le_0
tff(fact_3494_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% zless_nat_conj
tff(fact_3495_nat__neg__numeral,axiom,
    ! [K: num] : ( aa(int,nat,nat2,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) = zero_zero(nat) ) ).

% nat_neg_numeral
tff(fact_3496_sgn__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% sgn_abs
tff(fact_3497_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,abs_abs(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% idom_abs_sgn_class.abs_sgn
tff(fact_3498_nat__zminus__int,axiom,
    ! [Nb: nat] : ( aa(int,nat,nat2,aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Nb))) = zero_zero(nat) ) ).

% nat_zminus_int
tff(fact_3499_int__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z),Z,zero_zero(int)) ) ).

% int_nat_eq
tff(fact_3500_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: nat,K: int] : ( aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K))) = ring_1_of_int(A,aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) ) ) ).

% of_nat_nat_take_bit_eq
tff(fact_3501_sgn__mult__dvd__iff,axiom,
    ! [R: int,L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),R)),L)),K)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        & ( ( R = zero_zero(int) )
         => ( K = zero_zero(int) ) ) ) ) ).

% sgn_mult_dvd_iff
tff(fact_3502_mult__sgn__dvd__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),aa(int,int,sgn_sgn(int),R))),K)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        & ( ( R = zero_zero(int) )
         => ( K = zero_zero(int) ) ) ) ) ).

% mult_sgn_dvd_iff
tff(fact_3503_dvd__sgn__mult__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),R)),K))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( R = zero_zero(int) ) ) ) ).

% dvd_sgn_mult_iff
tff(fact_3504_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),K),aa(int,int,sgn_sgn(int),R)))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( R = zero_zero(int) ) ) ) ).

% dvd_mult_sgn_iff
tff(fact_3505_sgn__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% sgn_neg
tff(fact_3506_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ).

% zero_less_nat_eq
tff(fact_3507_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,Z)) = ring_1_of_int(A,Z) ) ) ) ).

% of_nat_nat
tff(fact_3508_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat] : ( aa(A,A,sgn_sgn(A),aa(nat,A,semiring_1_of_nat(A),Nb)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)) ) ) ).

% sgn_of_nat
tff(fact_3509_diff__nat__numeral,axiom,
    ! [V: num,V4: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),aa(num,nat,numeral_numeral(nat),V4)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),V4))) ) ).

% diff_nat_numeral
tff(fact_3510_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X2: num,Nb: nat,Y2: int] :
      ( ( aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X2)),Nb) = aa(int,nat,nat2,Y2) )
    <=> ( aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb) = Y2 ) ) ).

% numeral_power_eq_nat_cancel_iff
tff(fact_3511_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y2: int,X2: num,Nb: nat] :
      ( ( aa(int,nat,nat2,Y2) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X2)),Nb) )
    <=> ( Y2 = aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb) ) ) ).

% nat_eq_numeral_power_cancel_iff
tff(fact_3512_nat__ceiling__le__eq,axiom,
    ! [X2: real,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,archimedean_ceiling(real,X2))),A2)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(nat,real,semiring_1_of_nat(real),A2)) ) ).

% nat_ceiling_le_eq
tff(fact_3513_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),Z) ) ).

% one_less_nat_eq
tff(fact_3514_nat__numeral__diff__1,axiom,
    ! [V: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),V)),one_one(int))) ) ).

% nat_numeral_diff_1
tff(fact_3515_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X2: num,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,A2)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X2)),Nb))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb)) ) ).

% nat_less_numeral_power_cancel_iff
tff(fact_3516_numeral__power__less__nat__cancel__iff,axiom,
    ! [X2: num,Nb: nat,A2: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X2)),Nb)),aa(int,nat,nat2,A2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb)),A2) ) ).

% numeral_power_less_nat_cancel_iff
tff(fact_3517_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X2: num,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,A2)),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X2)),Nb))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb)) ) ).

% nat_le_numeral_power_cancel_iff
tff(fact_3518_numeral__power__le__nat__cancel__iff,axiom,
    ! [X2: num,Nb: nat,A2: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),X2)),Nb)),aa(int,nat,nat2,A2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),X2)),Nb)),A2) ) ).

% numeral_power_le_nat_cancel_iff
tff(fact_3519_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] :
          ( ( aa(A,A,sgn_sgn(A),X2) = zero_zero(A) )
        <=> ( X2 = zero_zero(A) ) ) ) ).

% sgn_zero_iff
tff(fact_3520_sgn__0__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% sgn_0_0
tff(fact_3521_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% sgn_eq_0_iff
tff(fact_3522_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) = aa(A,A,sgn_sgn(A),A2) )
         => ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,sgn_sgn(A),A2) ) ) ) ).

% same_sgn_sgn_add
tff(fact_3523_sgn__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% sgn_mult
tff(fact_3524_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),X2)),aa(A,A,sgn_sgn(A),Y2)) ) ) ).

% Real_Vector_Spaces.sgn_mult
tff(fact_3525_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) != aa(A,A,sgn_sgn(A),A2) )
         => ( ( aa(A,A,sgn_sgn(A),A2) != zero_zero(A) )
           => ( ( aa(A,A,sgn_sgn(A),B2) != zero_zero(A) )
             => ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),B2)) ) ) ) ) ) ).

% sgn_not_eq_imp
tff(fact_3526_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% sgn_minus_1
tff(fact_3527_nat__zero__as__int,axiom,
    zero_zero(nat) = aa(int,nat,nat2,zero_zero(int)) ).

% nat_zero_as_int
tff(fact_3528_nat__numeral__as__int,axiom,
    ! [X: num] : ( aa(num,nat,numeral_numeral(nat),X) = aa(int,nat,nat2,aa(num,int,numeral_numeral(int),X)) ) ).

% nat_numeral_as_int
tff(fact_3529_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),X2)),aa(A,A,abs_abs(A),X2)) = X2 ) ) ).

% mult_sgn_abs
tff(fact_3530_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,abs_abs(A),A2)) = A2 ) ) ).

% sgn_mult_abs
tff(fact_3531_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,sgn_sgn(A),A2)) = A2 ) ) ).

% abs_mult_sgn
tff(fact_3532_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [K: A] : ( aa(A,A,abs_abs(A),K) = aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,sgn_sgn(A),K)) ) ) ).

% linordered_idom_class.abs_sgn
tff(fact_3533_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N: nat,L2: int] : ( K != aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L2)),aa(nat,int,semiring_1_of_nat(int),N)) ) ).

% int_sgnE
tff(fact_3534_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) = aa(A,A,sgn_sgn(A),A2) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% same_sgn_abs_add
tff(fact_3535_ex__nat,axiom,
    ! [P: fun(nat,$o)] :
      ( ? [X_12: nat] : aa(nat,$o,P,X_12)
    <=> ? [X3: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X3)
          & aa(nat,$o,P,aa(int,nat,nat2,X3)) ) ) ).

% ex_nat
tff(fact_3536_all__nat,axiom,
    ! [P: fun(nat,$o)] :
      ( ! [X_12: nat] : aa(nat,$o,P,X_12)
    <=> ! [X3: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X3)
         => aa(nat,$o,P,aa(int,nat,nat2,X3)) ) ) ).

% all_nat
tff(fact_3537_eq__nat__nat__iff,axiom,
    ! [Z: int,Z4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z4)
       => ( ( aa(int,nat,nat2,Z) = aa(int,nat,nat2,Z4) )
        <=> ( Z = Z4 ) ) ) ) ).

% eq_nat_nat_iff
tff(fact_3538_nat__one__as__int,axiom,
    one_one(nat) = aa(int,nat,nat2,one_one(int)) ).

% nat_one_as_int
tff(fact_3539_div__eq__sgn__abs,axiom,
    ! [K: int,L: int] :
      ( ( aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) ) ) ).

% div_eq_sgn_abs
tff(fact_3540_unset__bit__nat__def,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se2638667681897837118et_bit(nat),Ma),Nb) = aa(int,nat,nat2,aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Ma),aa(nat,int,semiring_1_of_nat(int),Nb))) ) ).

% unset_bit_nat_def
tff(fact_3541_nat__mask__eq,axiom,
    ! [Nb: nat] : ( aa(int,nat,nat2,bit_se2239418461657761734s_mask(int,Nb)) = bit_se2239418461657761734s_mask(nat,Nb) ) ).

% nat_mask_eq
tff(fact_3542_ln__real__def,axiom,
    ! [X2: real] : ( aa(real,real,ln_ln(real),X2) = the(real,aTP_Lamp_dt(real,fun(real,$o),X2)) ) ).

% ln_real_def
tff(fact_3543_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = one_one(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% sgn_1_pos
tff(fact_3544_suminf__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A)] : ( suminf(A,F3) = the(A,sums(A,F3)) ) ) ).

% suminf_def
tff(fact_3545_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2))
          = $ite(A2 = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% abs_sgn_eq
tff(fact_3546_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% nat_mono_iff
tff(fact_3547_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,A2),K)),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc_Suc
tff(fact_3548_zless__nat__eq__int__zless,axiom,
    ! [Ma: nat,Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),Ma)),Z) ) ).

% zless_nat_eq_int_zless
tff(fact_3549_int__eq__iff,axiom,
    ! [Ma: nat,Z: int] :
      ( ( aa(nat,int,semiring_1_of_nat(int),Ma) = Z )
    <=> ( ( Ma = aa(int,nat,nat2,Z) )
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) ) ) ).

% int_eq_iff
tff(fact_3550_nat__0__le,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z)) = Z ) ) ).

% nat_0_le
tff(fact_3551_nat__int__add,axiom,
    ! [A2: nat,B2: nat] : ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2) ) ).

% nat_int_add
tff(fact_3552_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
       => ( aa(int,int,sgn_sgn(int),modulo_modulo(int,K,L)) = aa(int,int,sgn_sgn(int),L) ) ) ) ).

% sgn_mod
tff(fact_3553_int__minus,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)) = aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),Nb)),aa(nat,int,semiring_1_of_nat(int),Ma)))) ) ).

% int_minus
tff(fact_3554_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] : ( aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),W))),aa(int,nat,nat2,aa(int,int,abs_abs(int),Z))) ) ).

% nat_abs_mult_distrib
tff(fact_3555_and__nat__def,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),Ma),Nb) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(nat,int,semiring_1_of_nat(int),Ma)),aa(nat,int,semiring_1_of_nat(int),Nb))) ) ).

% and_nat_def
tff(fact_3556_nat__plus__as__int,axiom,
    ! [X: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_plus_as_int
tff(fact_3557_nat__times__as__int,axiom,
    ! [X: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),X),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_times_as_int
tff(fact_3558_real__nat__ceiling__ge,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(nat,real,semiring_1_of_nat(real),aa(int,nat,nat2,archimedean_ceiling(real,X2)))) ).

% real_nat_ceiling_ge
tff(fact_3559_nat__minus__as__int,axiom,
    ! [X: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_minus_as_int
tff(fact_3560_nat__div__as__int,axiom,
    ! [X: nat,Xa3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),Xa3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_div_as_int
tff(fact_3561_nat__mod__as__int,axiom,
    ! [X: nat,Xa3: nat] : ( modulo_modulo(nat,X,Xa3) = aa(int,nat,nat2,modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),X),aa(nat,int,semiring_1_of_nat(int),Xa3))) ) ).

% nat_mod_as_int
tff(fact_3562_ln__neg__is__const,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real))
     => ( aa(real,real,ln_ln(real),X2) = the(real,aTP_Lamp_du(real,$o)) ) ) ).

% ln_neg_is_const
tff(fact_3563_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% sgn_1_neg
tff(fact_3564_sgn__if,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( aa(A,A,sgn_sgn(A),X2)
          = $ite(
              X2 = zero_zero(A),
              zero_zero(A),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2),one_one(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ) ).

% sgn_if
tff(fact_3565_of__nat__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),R)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,archim6421214686448440834_floor(A,R)))),R) ) ) ).

% of_nat_floor
tff(fact_3566_zsgn__def,axiom,
    ! [I3: int] :
      ( aa(int,int,sgn_sgn(int),I3)
      = $ite(
          I3 = zero_zero(int),
          zero_zero(int),
          $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),I3),one_one(int),aa(int,int,uminus_uminus(int),one_one(int))) ) ) ).

% zsgn_def
tff(fact_3567_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_addition_formula
tff(fact_3568_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,A2),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_absorb_comp
tff(fact_3569_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% nat_less_eq_zless
tff(fact_3570_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [K: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),K)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),K)),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% gbinomial_ge_n_over_k_pow_k
tff(fact_3571_norm__sgn,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] :
          ( real_V7770717601297561774m_norm(A,aa(A,A,sgn_sgn(A),X2))
          = $ite(X2 = zero_zero(A),zero_zero(real),one_one(real)) ) ) ).

% norm_sgn
tff(fact_3572_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),W)
        | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z) ) ) ).

% nat_le_eq_zle
tff(fact_3573_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A2),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1'
tff(fact_3574_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,A2),K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A2),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1
tff(fact_3575_nat__eq__iff2,axiom,
    ! [Ma: nat,W: int] :
      ( ( Ma = aa(int,nat,nat2,W) )
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W),W = aa(nat,int,semiring_1_of_nat(int),Ma),Ma = zero_zero(nat)) ) ).

% nat_eq_iff2
tff(fact_3576_nat__eq__iff,axiom,
    ! [W: int,Ma: nat] :
      ( ( aa(int,nat,nat2,W) = Ma )
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W),W = aa(nat,int,semiring_1_of_nat(int),Ma),Ma = zero_zero(nat)) ) ).

% nat_eq_iff
tff(fact_3577_split__nat,axiom,
    ! [P: fun(nat,$o),I3: int] :
      ( aa(nat,$o,P,aa(int,nat,nat2,I3))
    <=> ( ! [N4: nat] :
            ( ( I3 = aa(nat,int,semiring_1_of_nat(int),N4) )
           => aa(nat,$o,P,N4) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I3),zero_zero(int))
         => aa(nat,$o,P,zero_zero(nat)) ) ) ) ).

% split_nat
tff(fact_3578_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,archim6421214686448440834_floor(A,A2))),aa(int,nat,nat2,archim6421214686448440834_floor(A,B2)))),aa(int,nat,nat2,archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))) ) ).

% le_mult_nat_floor
tff(fact_3579_le__nat__iff,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),aa(int,nat,nat2,K))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),Nb)),K) ) ) ).

% le_nat_iff
tff(fact_3580_nat__add__distrib,axiom,
    ! [Z: int,Z4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z4)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),Z4)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z4)) ) ) ) ).

% nat_add_distrib
tff(fact_3581_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),V)),aa(int,int,abs_abs(int),K))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),V)),aa(int,int,abs_abs(int),L))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) ) ) ).

% div_sgn_abs_cancel
tff(fact_3582_nat__mult__distrib,axiom,
    ! [Z: int,Z4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),Z),Z4)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z4)) ) ) ).

% nat_mult_distrib
tff(fact_3583_Suc__as__int,axiom,
    ! [X: nat] : ( aa(nat,nat,suc,X) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X)),one_one(int))) ) ).

% Suc_as_int
tff(fact_3584_nat__diff__distrib,axiom,
    ! [Z4: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z4)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z4),Z)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z4)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z4)) ) ) ) ).

% nat_diff_distrib
tff(fact_3585_nat__diff__distrib_H,axiom,
    ! [X2: int,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),X2),Y2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,X2)),aa(int,nat,nat2,Y2)) ) ) ) ).

% nat_diff_distrib'
tff(fact_3586_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ).

% nat_abs_triangle_ineq
tff(fact_3587_nat__div__distrib_H,axiom,
    ! [Y2: int,X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),Y2)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,X2)),aa(int,nat,nat2,Y2)) ) ) ).

% nat_div_distrib'
tff(fact_3588_nat__div__distrib,axiom,
    ! [X2: int,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),Y2)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,X2)),aa(int,nat,nat2,Y2)) ) ) ).

% nat_div_distrib
tff(fact_3589_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(int,int,sgn_sgn(int),L))),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L))) ) ) ).

% div_dvd_sgn_abs
tff(fact_3590_nat__floor__neg,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real))
     => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X2)) = zero_zero(nat) ) ) ).

% nat_floor_neg
tff(fact_3591_nat__power__eq,axiom,
    ! [Z: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,nat,nat2,aa(nat,int,power_power(int,Z),Nb)) = aa(nat,nat,power_power(nat,aa(int,nat,nat2,Z)),Nb) ) ) ).

% nat_power_eq
tff(fact_3592_nat__mod__distrib,axiom,
    ! [X2: int,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
       => ( aa(int,nat,nat2,modulo_modulo(int,X2,Y2)) = modulo_modulo(nat,aa(int,nat,nat2,X2),aa(int,nat,nat2,Y2)) ) ) ) ).

% nat_mod_distrib
tff(fact_3593_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) ).

% div_abs_eq_div_nat
tff(fact_3594_floor__eq3,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Nb)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Nb)))
       => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X2)) = Nb ) ) ) ).

% floor_eq3
tff(fact_3595_le__nat__floor,axiom,
    ! [X2: nat,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),X2)),A2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X2),aa(int,nat,nat2,archim6421214686448440834_floor(real,A2))) ) ).

% le_nat_floor
tff(fact_3596_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] : ( modulo_modulo(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L)) = aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) ).

% mod_abs_eq_div_nat
tff(fact_3597_take__bit__nat__eq,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),aa(int,nat,nat2,K)) = aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) ) ) ).

% take_bit_nat_eq
tff(fact_3598_nat__take__bit__eq,axiom,
    ! [K: int,Nb: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)) = aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),aa(int,nat,nat2,K)) ) ) ).

% nat_take_bit_eq
tff(fact_3599_bit__nat__iff,axiom,
    ! [K: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(int,nat,nat2,K)),Nb)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb) ) ) ).

% bit_nat_iff
tff(fact_3600_divide__int__def,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L)
      = $ite(
          L = zero_zero(int),
          zero_zero(int),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)))))) ) ) ).

% divide_int_def
tff(fact_3601_modulo__int__def,axiom,
    ! [K: int,L: int] :
      ( modulo_modulo(int,K,L)
      = $ite(
          L = zero_zero(int),
          K,
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),L)),aa($o,int,zero_neq_one_of_bool(int),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)))),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L))))))) ) ) ).

% modulo_int_def
tff(fact_3602_nat__2,axiom,
    aa(int,nat,nat2,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))) ).

% nat_2
tff(fact_3603_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% Suc_times_gbinomial
tff(fact_3604_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_absorption
tff(fact_3605_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(nat,nat,suc,aa(int,nat,nat2,Z)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)) ) ) ).

% Suc_nat_eq_nat_zadd1
tff(fact_3606_nat__less__iff,axiom,
    ! [W: int,Ma: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),Ma)
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(nat,int,semiring_1_of_nat(int),Ma)) ) ) ).

% nat_less_iff
tff(fact_3607_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int))
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),Z),Z4)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Z))),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Z4))) ) ) ).

% nat_mult_distrib_neg
tff(fact_3608_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Ma: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Ma)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),Ma)),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Ma)),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),K))) ) ) ) ).

% gbinomial_trinomial_revision
tff(fact_3609_floor__eq4,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),Nb)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Nb)))
       => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X2)) = Nb ) ) ) ).

% floor_eq4
tff(fact_3610_diff__nat__eq__if,axiom,
    ! [Z: int,Z4: int] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z4))
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z4),zero_zero(int)),
          aa(int,nat,nat2,Z),
          $let(
            d: int,
            d := aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z4),
            $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),d),zero_zero(int)),zero_zero(nat),aa(int,nat,nat2,d)) ) ) ) ).

% diff_nat_eq_if
tff(fact_3611_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_rec
tff(fact_3612_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% gbinomial_factors
tff(fact_3613_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Nb))),one_one(A))),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),Nb)) ) ) ).

% gbinomial_index_swap
tff(fact_3614_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),K)),A2)),one_one(A))),K)) ) ) ).

% gbinomial_negated_upper
tff(fact_3615_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: int] :
          ( ring_1_of_int(A,K)
          = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),K)))),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,K))) ) ) ).

% of_int_of_nat
tff(fact_3616_nat__dvd__iff,axiom,
    ! [Z: int,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(int,nat,nat2,Z)),Ma)
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z),aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Z),aa(nat,int,semiring_1_of_nat(int),Ma)),Ma = zero_zero(nat)) ) ).

% nat_dvd_iff
tff(fact_3617_arccos__def,axiom,
    ! [Y2: real] : ( aa(real,real,arccos,Y2) = the(real,aTP_Lamp_dv(real,fun(real,$o),Y2)) ) ).

% arccos_def
tff(fact_3618_eucl__rel__int__remainderI,axiom,
    ! [R: int,L: int,K: int,Q2: int] :
      ( ( aa(int,int,sgn_sgn(int),R) = aa(int,int,sgn_sgn(int),L) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R)),aa(int,int,abs_abs(int),L))
       => ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q2),L)),R) )
         => eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R)) ) ) ) ).

% eucl_rel_int_remainderI
tff(fact_3619_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),A2)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),K)) ) ) ).

% gbinomial_minus
tff(fact_3620_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ) ).

% gbinomial_reduce_nat
tff(fact_3621_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),A2),K))),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer
tff(fact_3622_eucl__rel__int_Osimps,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
    <=> ( ? [K3: int] :
            ( ( A1 = K3 )
            & ( A22 = zero_zero(int) )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),K3) ) )
        | ? [L3: int,K3: int,Q4: int] :
            ( ( A1 = K3 )
            & ( A22 = L3 )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q4),zero_zero(int)) )
            & ( L3 != zero_zero(int) )
            & ( K3 = aa(int,int,aa(int,fun(int,int),times_times(int),Q4),L3) ) )
        | ? [R5: int,L3: int,K3: int,Q4: int] :
            ( ( A1 = K3 )
            & ( A22 = L3 )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q4),R5) )
            & ( aa(int,int,sgn_sgn(int),R5) = aa(int,int,sgn_sgn(int),L3) )
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R5)),aa(int,int,abs_abs(int),L3))
            & ( K3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q4),L3)),R5) ) ) ) ) ).

% eucl_rel_int.simps
tff(fact_3623_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
     => ( ( ( A22 = zero_zero(int) )
         => ( A32 != aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),A1) ) )
       => ( ! [Q3: int] :
              ( ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),zero_zero(int)) )
             => ( ( A22 != zero_zero(int) )
               => ( A1 != aa(int,int,aa(int,fun(int,int),times_times(int),Q3),A22) ) ) )
         => ~ ! [R2: int,Q3: int] :
                ( ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R2) )
               => ( ( aa(int,int,sgn_sgn(int),R2) = aa(int,int,sgn_sgn(int),A22) )
                 => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R2)),aa(int,int,abs_abs(int),A22))
                   => ( A1 != aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q3),A22)),R2) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
tff(fact_3624_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer'
tff(fact_3625_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => ( ( aa(int,int,sgn_sgn(int),K) != aa(int,int,sgn_sgn(int),L) )
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)))),aa($o,int,zero_neq_one_of_bool(int),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K))) ) ) ) ).

% div_noneq_sgn_abs
tff(fact_3626_even__nat__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(int,nat,nat2,K))
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K) ) ) ).

% even_nat_iff
tff(fact_3627_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ) ).

% gbinomial_absorption'
tff(fact_3628_pi__half,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) = the(real,aTP_Lamp_dw(real,$o)) ).

% pi_half
tff(fact_3629_pi__def,axiom,
    pi = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),the(real,aTP_Lamp_dw(real,$o))) ).

% pi_def
tff(fact_3630_divide__int__unfold,axiom,
    ! [K: int,Ma: nat,L: int,Nb: nat] :
      ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),Ma))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),Nb)))
      = $ite(
          ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
          | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
          | ( Nb = zero_zero(nat) ) ),
          zero_zero(int),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Nb),Ma)))))) ) ) ).

% divide_int_unfold
tff(fact_3631_the__equality,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A] :
      ( aa(A,$o,P,A2)
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
           => ( X4 = A2 ) )
       => ( the(A,P) = A2 ) ) ) ).

% the_equality
tff(fact_3632_the__eq__trivial,axiom,
    ! [A: $tType,A2: A] : ( the(A,aTP_Lamp_dx(A,fun(A,$o),A2)) = A2 ) ).

% the_eq_trivial
tff(fact_3633_the__sym__eq__trivial,axiom,
    ! [A: $tType,X2: A] : ( the(A,aa(A,fun(A,$o),fequal(A),X2)) = X2 ) ).

% the_sym_eq_trivial
tff(fact_3634_exp__two__pi__i,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(num,complex,numeral_numeral(complex),aa(num,num,bit0,one2))),aa(real,complex,real_Vector_of_real(complex),pi))),imaginary_unit)) = one_one(complex) ).

% exp_two_pi_i
tff(fact_3635_exp__two__pi__i_H,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),pi)),aa(num,complex,numeral_numeral(complex),aa(num,num,bit0,one2))))) = one_one(complex) ).

% exp_two_pi_i'
tff(fact_3636_zero__le__sgn__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sgn_sgn(real),X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2) ) ).

% zero_le_sgn_iff
tff(fact_3637_sgn__le__0__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sgn_sgn(real),X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real)) ) ).

% sgn_le_0_iff
tff(fact_3638_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X2: A,Y2: B] : ( the(product_prod(A,B),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aa(B,fun(A,fun(B,$o)),aTP_Lamp_dy(A,fun(B,fun(A,fun(B,$o))),X2),Y2))) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2) ) ).

% The_split_eq
tff(fact_3639_complex__i__mult__minus,axiom,
    ! [X2: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),X2)) = aa(complex,complex,uminus_uminus(complex),X2) ) ).

% complex_i_mult_minus
tff(fact_3640_divide__i,axiom,
    ! [X2: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X2),imaginary_unit) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,uminus_uminus(complex),imaginary_unit)),X2) ) ).

% divide_i
tff(fact_3641_i__squared,axiom,
    aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),imaginary_unit) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% i_squared
tff(fact_3642_divide__numeral__i,axiom,
    ! [Z: complex,Nb: num] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(num,complex,numeral_numeral(complex),Nb)),imaginary_unit)) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,uminus_uminus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z))),aa(num,complex,numeral_numeral(complex),Nb)) ) ).

% divide_numeral_i
tff(fact_3643_power2__i,axiom,
    aa(nat,complex,power_power(complex,imaginary_unit),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% power2_i
tff(fact_3644_i__even__power,axiom,
    ! [Nb: nat] : ( aa(nat,complex,power_power(complex,imaginary_unit),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,complex,power_power(complex,aa(complex,complex,uminus_uminus(complex),one_one(complex))),Nb) ) ).

% i_even_power
tff(fact_3645_exp__pi__i_H,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),pi))) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% exp_pi_i'
tff(fact_3646_exp__pi__i,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),pi)),imaginary_unit)) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% exp_pi_i
tff(fact_3647_complex__i__not__zero,axiom,
    imaginary_unit != zero_zero(complex) ).

% complex_i_not_zero
tff(fact_3648_i__times__eq__iff,axiom,
    ! [W: complex,Z: complex] :
      ( ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),W) = Z )
    <=> ( W = aa(complex,complex,uminus_uminus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) ) ) ).

% i_times_eq_iff
tff(fact_3649_Complex__eq__i,axiom,
    ! [X2: real,Y2: real] :
      ( ( complex2(X2,Y2) = imaginary_unit )
    <=> ( ( X2 = zero_zero(real) )
        & ( Y2 = one_one(real) ) ) ) ).

% Complex_eq_i
tff(fact_3650_imaginary__unit_Ocode,axiom,
    imaginary_unit = complex2(zero_zero(real),one_one(real)) ).

% imaginary_unit.code
tff(fact_3651_Complex__mult__i,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(A2,B2)),imaginary_unit) = complex2(aa(real,real,uminus_uminus(real),B2),A2) ) ).

% Complex_mult_i
tff(fact_3652_i__mult__Complex,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),complex2(A2,B2)) = complex2(aa(real,real,uminus_uminus(real),B2),A2) ) ).

% i_mult_Complex
tff(fact_3653_sgn__real__def,axiom,
    ! [A2: real] :
      ( aa(real,real,sgn_sgn(real),A2)
      = $ite(
          A2 = zero_zero(real),
          zero_zero(real),
          $ite(aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2),one_one(real),aa(real,real,uminus_uminus(real),one_one(real))) ) ) ).

% sgn_real_def
tff(fact_3654_Complex__eq,axiom,
    ! [A2: real,B2: real] : ( complex2(A2,B2) = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(real,complex,real_Vector_of_real(complex),A2)),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),B2))) ) ).

% Complex_eq
tff(fact_3655_sgn__power__injE,axiom,
    ! [A2: real,Nb: nat,X2: real,B2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),A2)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),A2)),Nb)) = X2 )
     => ( ( X2 = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),B2)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),B2)),Nb)) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
tff(fact_3656_i__complex__of__real,axiom,
    ! [R: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),R)) = complex2(zero_zero(real),R) ) ).

% i_complex_of_real
tff(fact_3657_complex__of__real__i,axiom,
    ! [R: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),R)),imaginary_unit) = complex2(zero_zero(real),R) ) ).

% complex_of_real_i
tff(fact_3658_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R2: real,A4: real] : ( Z = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),R2)),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(real,complex,real_Vector_of_real(complex),cos(real,A4))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),sin(real,A4))))) ) ).

% complex_split_polar
tff(fact_3659_the1__equality,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A] :
      ( ? [X: A] :
          ( aa(A,$o,P,X)
          & ! [Y4: A] :
              ( aa(A,$o,P,Y4)
             => ( Y4 = X ) ) )
     => ( aa(A,$o,P,A2)
       => ( the(A,P) = A2 ) ) ) ).

% the1_equality
tff(fact_3660_the1I2,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(A,$o,P,X)
          & ! [Y4: A] :
              ( aa(A,$o,P,Y4)
             => ( Y4 = X ) ) )
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
           => aa(A,$o,Q,X4) )
       => aa(A,$o,Q,the(A,P)) ) ) ).

% the1I2
tff(fact_3661_If__def,axiom,
    ! [A: $tType,P: $o,X2: A,Y2: A] :
      ( $ite((P),X2,Y2)
      = the(A,aa(A,fun(A,$o),aa(A,fun(A,fun(A,$o)),aTP_Lamp_dz($o,fun(A,fun(A,fun(A,$o))),P),X2),Y2)) ) ).

% If_def
tff(fact_3662_theI2,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A,Q: fun(A,$o)] :
      ( aa(A,$o,P,A2)
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
           => ( X4 = A2 ) )
       => ( ! [X4: A] :
              ( aa(A,$o,P,X4)
             => aa(A,$o,Q,X4) )
         => aa(A,$o,Q,the(A,P)) ) ) ) ).

% theI2
tff(fact_3663_theI_H,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(A,$o,P,X)
          & ! [Y4: A] :
              ( aa(A,$o,P,Y4)
             => ( Y4 = X ) ) )
     => aa(A,$o,P,the(A,P)) ) ).

% theI'
tff(fact_3664_theI,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A] :
      ( aa(A,$o,P,A2)
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
           => ( X4 = A2 ) )
       => aa(A,$o,P,the(A,P)) ) ) ).

% theI
tff(fact_3665_floor__real__def,axiom,
    ! [X2: real] : ( archim6421214686448440834_floor(real,X2) = the(int,aTP_Lamp_ea(real,fun(int,$o),X2)) ) ).

% floor_real_def
tff(fact_3666_cmod__unit__one,axiom,
    ! [A2: real] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(real,complex,real_Vector_of_real(complex),cos(real,A2))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),sin(real,A2))))) = one_one(real) ) ).

% cmod_unit_one
tff(fact_3667_cmod__complex__polar,axiom,
    ! [R: real,A2: real] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),R)),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(real,complex,real_Vector_of_real(complex),cos(real,A2))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),sin(real,A2)))))) = aa(real,real,abs_abs(real),R) ) ).

% cmod_complex_polar
tff(fact_3668_arctan__inverse,axiom,
    ! [X2: real] :
      ( ( X2 != zero_zero(real) )
     => ( aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X2)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),X2)),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(real,real,arctan,X2)) ) ) ).

% arctan_inverse
tff(fact_3669_Arg__minus__ii,axiom,
    arg(aa(complex,complex,uminus_uminus(complex),imaginary_unit)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% Arg_minus_ii
tff(fact_3670_csqrt__ii,axiom,
    csqrt(imaginary_unit) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),one_one(complex)),imaginary_unit)),aa(real,complex,real_Vector_of_real(complex),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ).

% csqrt_ii
tff(fact_3671_Arg__ii,axiom,
    arg(imaginary_unit) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% Arg_ii
tff(fact_3672_cis__minus__pi__half,axiom,
    cis(aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) = aa(complex,complex,uminus_uminus(complex),imaginary_unit) ).

% cis_minus_pi_half
tff(fact_3673_csqrt__0,axiom,
    csqrt(zero_zero(complex)) = zero_zero(complex) ).

% csqrt_0
tff(fact_3674_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( csqrt(Z) = zero_zero(complex) )
    <=> ( Z = zero_zero(complex) ) ) ).

% csqrt_eq_0
tff(fact_3675_cis__zero,axiom,
    cis(zero_zero(real)) = one_one(complex) ).

% cis_zero
tff(fact_3676_power2__csqrt,axiom,
    ! [Z: complex] : ( aa(nat,complex,power_power(complex,csqrt(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = Z ) ).

% power2_csqrt
tff(fact_3677_cis__pi__half,axiom,
    cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = imaginary_unit ).

% cis_pi_half
tff(fact_3678_cis__2pi,axiom,
    cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)) = one_one(complex) ).

% cis_2pi
tff(fact_3679_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( cis(arg(Z)) = aa(complex,complex,sgn_sgn(complex),Z) ) ) ).

% cis_Arg
tff(fact_3680_cis__neq__zero,axiom,
    ! [A2: real] : ( cis(A2) != zero_zero(complex) ) ).

% cis_neq_zero
tff(fact_3681_DeMoivre,axiom,
    ! [A2: real,Nb: nat] : ( aa(nat,complex,power_power(complex,cis(A2)),Nb) = cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),A2)) ) ).

% DeMoivre
tff(fact_3682_cis__Arg__unique,axiom,
    ! [Z: complex,X2: real] :
      ( ( aa(complex,complex,sgn_sgn(complex),Z) = cis(X2) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),X2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),pi)
         => ( arg(Z) = X2 ) ) ) ) ).

% cis_Arg_unique
tff(fact_3683_cis__mult,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cis(A2)),cis(B2)) = cis(aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)) ) ).

% cis_mult
tff(fact_3684_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( ( aa(complex,complex,sgn_sgn(complex),Z) = cis(arg(Z)) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),arg(Z))
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),arg(Z)),pi) ) ) ).

% Arg_correct
tff(fact_3685_Arg__zero,axiom,
    arg(zero_zero(complex)) = zero_zero(real) ).

% Arg_zero
tff(fact_3686_cis__conv__exp,axiom,
    ! [B2: real] : ( cis(B2) = aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),B2))) ) ).

% cis_conv_exp
tff(fact_3687_of__real__sqrt,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,complex,real_Vector_of_real(complex),aa(real,real,sqrt,X2)) = csqrt(aa(real,complex,real_Vector_of_real(complex),X2)) ) ) ).

% of_real_sqrt
tff(fact_3688_Arg__bounded,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),arg(Z))
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),arg(Z)),pi) ) ).

% Arg_bounded
tff(fact_3689_floor__rat__def,axiom,
    ! [X2: rat] : ( archim6421214686448440834_floor(rat,X2) = the(int,aTP_Lamp_eb(rat,fun(int,$o),X2)) ) ).

% floor_rat_def
tff(fact_3690_Arg__def,axiom,
    ! [Z: complex] :
      ( arg(Z)
      = $ite(Z = zero_zero(complex),zero_zero(real),fChoice(real,aTP_Lamp_ec(complex,fun(real,$o),Z))) ) ).

% Arg_def
tff(fact_3691_cis__multiple__2pi,axiom,
    ! [Nb: real] :
      ( aa(set(real),$o,member(real,Nb),ring_1_Ints(real))
     => ( cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),Nb)) = one_one(complex) ) ) ).

% cis_multiple_2pi
tff(fact_3692_pred__subset__eq,axiom,
    ! [A: $tType,R3: set(A),S3: set(A)] :
      ( aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),R3)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),S3))
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),R3),S3) ) ).

% pred_subset_eq
tff(fact_3693_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( ( archimedean_frac(A,X2) = zero_zero(A) )
        <=> aa(set(A),$o,member(A,X2),ring_1_Ints(A)) ) ) ).

% frac_eq_0_iff
tff(fact_3694_floor__add2,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(set(A),$o,member(A,X2),ring_1_Ints(A))
            | aa(set(A),$o,member(A,Y2),ring_1_Ints(A)) )
         => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X2)),archim6421214686448440834_floor(A,Y2)) ) ) ) ).

% floor_add2
tff(fact_3695_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),archimedean_frac(A,X2))
        <=> ~ aa(set(A),$o,member(A,X2),ring_1_Ints(A)) ) ) ).

% frac_gt_0_iff
tff(fact_3696_sgn__rat__def,axiom,
    ! [A2: rat] :
      ( aa(rat,rat,sgn_sgn(rat),A2)
      = $ite(
          A2 = zero_zero(rat),
          zero_zero(rat),
          $ite(aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),A2),one_one(rat),aa(rat,rat,uminus_uminus(rat),one_one(rat))) ) ) ).

% sgn_rat_def
tff(fact_3697_Ints__add,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,member(A,A2),ring_1_Ints(A))
         => ( aa(set(A),$o,member(A,B2),ring_1_Ints(A))
           => aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),ring_1_Ints(A)) ) ) ) ).

% Ints_add
tff(fact_3698_Ints__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,Nb: nat] :
          ( aa(set(A),$o,member(A,A2),ring_1_Ints(A))
         => aa(set(A),$o,member(A,aa(nat,A,power_power(A,A2),Nb)),ring_1_Ints(A)) ) ) ).

% Ints_power
tff(fact_3699_obtain__pos__sum,axiom,
    ! [R: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R)
     => ~ ! [S2: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),S2)
           => ! [T3: rat] :
                ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),T3)
               => ( R != aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),S2),T3) ) ) ) ) ).

% obtain_pos_sum
tff(fact_3700_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Nb: num] : aa(set(A),$o,member(A,aa(num,A,numeral_numeral(A),Nb)),ring_1_Ints(A)) ) ).

% Ints_numeral
tff(fact_3701_abs__rat__def,axiom,
    ! [A2: rat] :
      ( aa(rat,rat,abs_abs(rat),A2)
      = $ite(aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),A2),zero_zero(rat)),aa(rat,rat,uminus_uminus(rat),A2),A2) ) ).

% abs_rat_def
tff(fact_3702_Ints__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => aa(set(A),$o,member(A,zero_zero(A)),ring_1_Ints(A)) ) ).

% Ints_0
tff(fact_3703_Ints__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,member(A,A2),ring_1_Ints(A))
         => ( aa(set(A),$o,member(A,B2),ring_1_Ints(A))
           => aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),ring_1_Ints(A)) ) ) ) ).

% Ints_mult
tff(fact_3704_less__eq__rat__def,axiom,
    ! [X2: rat,Y2: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),X2),Y2)
    <=> ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),X2),Y2)
        | ( X2 = Y2 ) ) ) ).

% less_eq_rat_def
tff(fact_3705_verit__sko__ex_H,axiom,
    ! [A: $tType,P: fun(A,$o),A3: $o] :
      ( ( aa(A,$o,P,fChoice(A,P))
      <=> (A3) )
     => ( ? [X_12: A] : aa(A,$o,P,X_12)
      <=> (A3) ) ) ).

% verit_sko_ex'
tff(fact_3706_verit__sko__forall,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( ! [X_12: A] : aa(A,$o,P,X_12)
    <=> aa(A,$o,P,fChoice(A,aTP_Lamp_ed(fun(A,$o),fun(A,$o),P))) ) ).

% verit_sko_forall
tff(fact_3707_verit__sko__forall_H,axiom,
    ! [A: $tType,P: fun(A,$o),A3: $o] :
      ( ( aa(A,$o,P,fChoice(A,aTP_Lamp_ed(fun(A,$o),fun(A,$o),P)))
      <=> (A3) )
     => ( ! [X_12: A] : aa(A,$o,P,X_12)
      <=> (A3) ) ) ).

% verit_sko_forall'
tff(fact_3708_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B4: A,A3: A,P: fun(A,$o)] :
      ( ( B4 = A3 )
     => ( ( fChoice(A,P) = A3 )
      <=> ( fChoice(A,P) = B4 ) ) ) ).

% verit_sko_forall''
tff(fact_3709_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X2: A,P: fun(A,$o)] :
      ( ( X2 = fChoice(A,P) )
     => ( ? [X_12: A] : aa(A,$o,P,X_12)
      <=> aa(A,$o,P,X2) ) ) ).

% verit_sko_ex_indirect
tff(fact_3710_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X2: A,P: fun(A,$o),P3: fun(A,$o)] :
      ( ( X2 = fChoice(A,P) )
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
          <=> aa(A,$o,P3,X4) )
       => ( ? [X_12: A] : aa(A,$o,P3,X_12)
        <=> aa(A,$o,P,X2) ) ) ) ).

% verit_sko_ex_indirect2
tff(fact_3711_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X2: A,P: fun(A,$o)] :
      ( ( X2 = fChoice(A,aTP_Lamp_ed(fun(A,$o),fun(A,$o),P)) )
     => ( ! [X_12: A] : aa(A,$o,P,X_12)
      <=> aa(A,$o,P,X2) ) ) ).

% verit_sko_forall_indirect
tff(fact_3712_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X2: A,P: fun(A,$o),P3: fun(A,$o)] :
      ( ( X2 = fChoice(A,aTP_Lamp_ed(fun(A,$o),fun(A,$o),P)) )
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
          <=> aa(A,$o,P3,X4) )
       => ( ! [X_12: A] : aa(A,$o,P3,X_12)
        <=> aa(A,$o,P,X2) ) ) ) ).

% verit_sko_forall_indirect2
tff(fact_3713_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A2: A] :
          ( aa(set(A),$o,member(A,A2),ring_1_Ints(A))
         => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% Ints_double_eq_0_iff
tff(fact_3714_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A2: A] :
          ( aa(set(A),$o,member(A,A2),ring_1_Ints(A))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),A2) != zero_zero(A) ) ) ) ).

% Ints_odd_nonzero
tff(fact_3715_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: int,A2: int] :
          ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),B2),A2)
         => aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),ring_1_of_int(A,A2)),ring_1_of_int(A,B2))),ring_1_Ints(A)) ) ) ).

% of_int_divide_in_Ints
tff(fact_3716_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(set(A),$o,member(A,A2),ring_1_Ints(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),A2)),zero_zero(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% Ints_odd_less_0
tff(fact_3717_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( aa(set(A),$o,member(A,X2),ring_1_Ints(A))
         => ( ( X2 != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,abs_abs(A),X2)) ) ) ) ).

% Ints_nonzero_abs_ge1
tff(fact_3718_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A] :
          ( aa(set(A),$o,member(A,X2),ring_1_Ints(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),X2)),one_one(A))
           => ( X2 = zero_zero(A) ) ) ) ) ).

% Ints_nonzero_abs_less1
tff(fact_3719_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A] :
          ( aa(set(A),$o,member(A,X2),ring_1_Ints(A))
         => ( aa(set(A),$o,member(A,Y2),ring_1_Ints(A))
           => ( ( X2 = Y2 )
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2))),one_one(A)) ) ) ) ) ).

% Ints_eq_abs_less1
tff(fact_3720_sin__times__pi__eq__0,axiom,
    ! [X2: real] :
      ( ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),X2),pi)) = zero_zero(real) )
    <=> aa(set(real),$o,member(real,X2),ring_1_Ints(real)) ) ).

% sin_times_pi_eq_0
tff(fact_3721_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),S3: set(product_prod(A,B))] :
      ( ! [X3: A,Xa: B] :
          ( aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa)),R3)
        <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa)),S3) )
    <=> ( R3 = S3 ) ) ).

% pred_equals_eq2
tff(fact_3722_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),S3: set(product_prod(A,B))] :
      ( aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),aa(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o))),R3)),aa(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o))),S3))
    <=> aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),R3),S3) ) ).

% pred_subset_eq2
tff(fact_3723_frac__neg,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A] :
          ( archimedean_frac(A,aa(A,A,uminus_uminus(A),X2))
          = $ite(aa(set(A),$o,member(A,X2),ring_1_Ints(A)),zero_zero(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),archimedean_frac(A,X2))) ) ) ).

% frac_neg
tff(fact_3724_le__mult__floor__Ints,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & linordered_idom(B) )
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(set(A),$o,member(A,A2),ring_1_Ints(A))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),ring_1_of_int(B,aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A2)),archim6421214686448440834_floor(A,B2)))),ring_1_of_int(B,archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))) ) ) ) ).

% le_mult_floor_Ints
tff(fact_3725_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X2: A,A2: A] :
          ( ( archimedean_frac(A,X2) = A2 )
        <=> ( aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),A2)),ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) ) ) ) ).

% frac_unique_iff
tff(fact_3726_mult__ceiling__le__Ints,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & linordered_idom(B) )
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(set(A),$o,member(A,A2),ring_1_Ints(A))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),ring_1_of_int(B,archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))),ring_1_of_int(B,aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A2)),archimedean_ceiling(A,B2)))) ) ) ) ).

% mult_ceiling_le_Ints
tff(fact_3727_sin__integer__2pi,axiom,
    ! [Nb: real] :
      ( aa(set(real),$o,member(real,Nb),ring_1_Ints(real))
     => ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),Nb)) = zero_zero(real) ) ) ).

% sin_integer_2pi
tff(fact_3728_cos__integer__2pi,axiom,
    ! [Nb: real] :
      ( aa(set(real),$o,member(real,Nb),ring_1_Ints(real))
     => ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),Nb)) = one_one(real) ) ) ).

% cos_integer_2pi
tff(fact_3729_some__sym__eq__trivial,axiom,
    ! [A: $tType,X2: A] : ( fChoice(A,aa(A,fun(A,$o),fequal(A),X2)) = X2 ) ).

% some_sym_eq_trivial
tff(fact_3730_some__eq__trivial,axiom,
    ! [A: $tType,X2: A] : ( fChoice(A,aTP_Lamp_dx(A,fun(A,$o),X2)) = X2 ) ).

% some_eq_trivial
tff(fact_3731_some__equality,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A] :
      ( aa(A,$o,P,A2)
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
           => ( X4 = A2 ) )
       => ( fChoice(A,P) = A2 ) ) ) ).

% some_equality
tff(fact_3732_powr__real__of__int,axiom,
    ! [X2: real,Nb: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( powr(real,X2,ring_1_of_int(real,Nb))
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Nb),aa(nat,real,power_power(real,X2),aa(int,nat,nat2,Nb)),aa(real,real,inverse_inverse(real),aa(nat,real,power_power(real,X2),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Nb))))) ) ) ).

% powr_real_of_int
tff(fact_3733_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,inverse_inverse(A),B2) )
        <=> ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
tff(fact_3734_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,inverse_inverse(A),A2)) = A2 ) ) ).

% inverse_inverse_eq
tff(fact_3735_inverse__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),zero_zero(A)) = zero_zero(A) ) ) ).

% inverse_zero
tff(fact_3736_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% inverse_nonzero_iff_nonzero
tff(fact_3737_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% inverse_mult_distrib
tff(fact_3738_inverse__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),one_one(A)) = one_one(A) ) ) ).

% inverse_1
tff(fact_3739_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A] :
          ( ( aa(A,A,inverse_inverse(A),X2) = one_one(A) )
        <=> ( X2 = one_one(A) ) ) ) ).

% inverse_eq_1_iff
tff(fact_3740_inverse__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) ) ) ).

% inverse_divide
tff(fact_3741_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),A2)) ) ) ).

% inverse_minus_eq
tff(fact_3742_abs__inverse,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,inverse_inverse(A),A2)) = aa(A,A,inverse_inverse(A),aa(A,A,abs_abs(A),A2)) ) ) ).

% abs_inverse
tff(fact_3743_sgn__inverse,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,inverse_inverse(A),A2)) = aa(A,A,inverse_inverse(A),aa(A,A,sgn_sgn(A),A2)) ) ) ).

% sgn_inverse
tff(fact_3744_inverse__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,sgn_sgn(A),A2)) = aa(A,A,sgn_sgn(A),A2) ) ) ).

% inverse_sgn
tff(fact_3745_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,X2: A,Y2: B] : ( fChoice(product_prod(A,B),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aa(B,fun(A,fun(B,$o)),aTP_Lamp_dy(A,fun(B,fun(A,fun(B,$o))),X2),Y2))) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2) ) ).

% Eps_case_prod_eq
tff(fact_3746_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% inverse_nonnegative_iff_nonnegative
tff(fact_3747_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% inverse_nonpositive_iff_nonpositive
tff(fact_3748_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% inverse_less_iff_less
tff(fact_3749_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% inverse_less_iff_less_neg
tff(fact_3750_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% inverse_negative_iff_negative
tff(fact_3751_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% inverse_positive_iff_positive
tff(fact_3752_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% inverse_le_iff_le
tff(fact_3753_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% inverse_le_iff_le_neg
tff(fact_3754_right__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),A2)) = one_one(A) ) ) ) ).

% right_inverse
tff(fact_3755_left__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),A2) = one_one(A) ) ) ) ).

% left_inverse
tff(fact_3756_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num] : ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),W)) ) ) ).

% inverse_eq_divide_numeral
tff(fact_3757_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) ) ).

% inverse_eq_divide_neg_numeral
tff(fact_3758_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,inverse_inverse(A),B2) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
tff(fact_3759_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Y2: A,X2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Y2),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Y2)),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,inverse_inverse(A),Y2)) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
tff(fact_3760_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A2) != zero_zero(A) ) ) ) ).

% nonzero_imp_inverse_nonzero
tff(fact_3761_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),aa(A,A,inverse_inverse(A),A2)) = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
tff(fact_3762_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,inverse_inverse(A),B2) )
         => ( ( A2 != zero_zero(A) )
           => ( ( B2 != zero_zero(A) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
tff(fact_3763_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = zero_zero(A) )
         => ( A2 = zero_zero(A) ) ) ) ).

% inverse_zero_imp_zero
tff(fact_3764_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( field(A)
     => ( aa(A,A,inverse_inverse(A),zero_zero(A)) = zero_zero(A) ) ) ).

% field_class.field_inverse_zero
tff(fact_3765_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [X2: real] :
          ( ( X2 != zero_zero(real) )
         => ( aa(real,A,real_Vector_of_real(A),aa(real,real,inverse_inverse(real),X2)) = aa(A,A,inverse_inverse(A),aa(real,A,real_Vector_of_real(A),X2)) ) ) ) ).

% nonzero_of_real_inverse
tff(fact_3766_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,aa(A,A,inverse_inverse(A),A2)) = aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,A2)) ) ) ) ).

% nonzero_norm_inverse
tff(fact_3767_power__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),A2)),Nb) = aa(A,A,inverse_inverse(A),aa(nat,A,power_power(A,A2),Nb)) ) ) ).

% power_inverse
tff(fact_3768_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType,P: fun(product_prod(A,B),$o)] : ( fChoice(product_prod(A,B),P) = fChoice(product_prod(A,B),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aTP_Lamp_ef(fun(product_prod(A,B),$o),fun(A,fun(B,$o)),P))) ) ).

% split_paired_Eps
tff(fact_3769_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [R: real,X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),R),real_V7770717601297561774m_norm(A,X2))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,inverse_inverse(A),X2))),aa(real,real,inverse_inverse(real),R)) ) ) ) ).

% norm_inverse_le_norm
tff(fact_3770_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% inverse_less_imp_less
tff(fact_3771_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% less_imp_inverse_less
tff(fact_3772_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% inverse_less_imp_less_neg
tff(fact_3773_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% less_imp_inverse_less_neg
tff(fact_3774_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
         => ( ( A2 != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% inverse_negative_imp_negative
tff(fact_3775_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
         => ( ( A2 != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ).

% inverse_positive_imp_positive
tff(fact_3776_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A)) ) ) ).

% negative_imp_inverse_negative
tff(fact_3777_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ).

% positive_imp_inverse_positive
tff(fact_3778_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ) ).

% nonzero_inverse_mult_distrib
tff(fact_3779_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% nonzero_inverse_minus_eq
tff(fact_3780_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),one2)) = aa(num,A,numeral_numeral(A),one2) ) ) ).

% inverse_numeral_1
tff(fact_3781_inverse__unique,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = one_one(A) )
         => ( aa(A,A,inverse_inverse(A),A2) = B2 ) ) ) ).

% inverse_unique
tff(fact_3782_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),A2) ) ) ).

% divide_inverse_commute
tff(fact_3783_divide__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% divide_inverse
tff(fact_3784_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% field_class.field_divide_inverse
tff(fact_3785_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) ) ) ).

% inverse_eq_divide
tff(fact_3786_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,Ma: nat,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),Ma)),aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X2)),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X2)),Nb)),aa(nat,A,power_power(A,X2),Ma)) ) ) ).

% power_mult_power_inverse_commute
tff(fact_3787_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,Ma: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),Ma)),aa(A,A,inverse_inverse(A),X2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),X2)),aa(nat,A,power_power(A,X2),Ma)) ) ) ).

% power_mult_inverse_distrib
tff(fact_3788_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa2: nat,X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa2))),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa2))) ) ) ).

% mult_inverse_of_nat_commute
tff(fact_3789_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,inverse_inverse(A),A2)) = aa(A,A,inverse_inverse(A),aa(A,A,abs_abs(A),A2)) ) ) ) ).

% nonzero_abs_inverse
tff(fact_3790_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa2: int,X2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),ring_1_of_int(A,Xa2))),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,inverse_inverse(A),ring_1_of_int(A,Xa2))) ) ) ).

% mult_inverse_of_int_commute
tff(fact_3791_divide__real__def,axiom,
    ! [X2: real,Y2: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),X2),Y2) = aa(real,real,aa(real,fun(real,real),times_times(real),X2),aa(real,real,inverse_inverse(real),Y2)) ) ).

% divide_real_def
tff(fact_3792_exp__fdiffs,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: nat] : ( aa(nat,A,diffs(A,aTP_Lamp_eg(nat,A)),X) = aa(A,A,inverse_inverse(A),semiring_char_0_fact(A,X)) ) ) ).

% exp_fdiffs
tff(fact_3793_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% inverse_le_imp_le
tff(fact_3794_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% le_imp_inverse_le
tff(fact_3795_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% inverse_le_imp_le_neg
tff(fact_3796_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% le_imp_inverse_le_neg
tff(fact_3797_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),X2)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),X2) ) ) ) ).

% inverse_le_1_iff
tff(fact_3798_one__less__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% one_less_inverse
tff(fact_3799_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),X2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),one_one(A)) ) ) ) ).

% one_less_inverse_iff
tff(fact_3800_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),A2) = one_one(A) ) ) ) ).

% field_class.field_inverse
tff(fact_3801_inverse__add,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,inverse_inverse(A),A2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% inverse_add
tff(fact_3802_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_add
tff(fact_3803_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_diff
tff(fact_3804_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) ) ) ) ).

% nonzero_inverse_eq_divide
tff(fact_3805_inverse__powr,axiom,
    ! [Y2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
     => ( powr(real,aa(real,real,inverse_inverse(real),Y2),A2) = aa(real,real,inverse_inverse(real),powr(real,Y2,A2)) ) ) ).

% inverse_powr
tff(fact_3806_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ) ).

% inverse_le_iff
tff(fact_3807_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ) ).

% inverse_less_iff
tff(fact_3808_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),X2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),one_one(A)) ) ) ) ).

% one_le_inverse_iff
tff(fact_3809_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),X2)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),X2) ) ) ) ).

% inverse_less_1_iff
tff(fact_3810_one__le__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% one_le_inverse
tff(fact_3811_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))),aa(A,A,inverse_inverse(A),B2))) ) ) ) ) ).

% inverse_diff_inverse
tff(fact_3812_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
         => ? [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N)))),X2) ) ) ).

% reals_Archimedean
tff(fact_3813_forall__pos__mono__1,axiom,
    ! [P: fun(real,$o),E2: real] :
      ( ! [D3: real,E: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),D3),E)
         => ( aa(real,$o,P,D3)
           => aa(real,$o,P,E) ) )
     => ( ! [N: nat] : aa(real,$o,P,aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
         => aa(real,$o,P,E2) ) ) ) ).

% forall_pos_mono_1
tff(fact_3814_real__arch__inverse,axiom,
    ! [E2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
    <=> ? [N4: nat] :
          ( ( N4 != zero_zero(nat) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N4)))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N4))),E2) ) ) ).

% real_arch_inverse
tff(fact_3815_forall__pos__mono,axiom,
    ! [P: fun(real,$o),E2: real] :
      ( ! [D3: real,E: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),D3),E)
         => ( aa(real,$o,P,D3)
           => aa(real,$o,P,E) ) )
     => ( ! [N: nat] :
            ( ( N != zero_zero(nat) )
           => aa(real,$o,P,aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N))) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
         => aa(real,$o,P,E2) ) ) ) ).

% forall_pos_mono
tff(fact_3816_sqrt__divide__self__eq,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,X2)),X2) = aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X2)) ) ) ).

% sqrt_divide_self_eq
tff(fact_3817_ln__inverse,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(real,real,ln_ln(real),aa(real,real,inverse_inverse(real),X2)) = aa(real,real,uminus_uminus(real),aa(real,real,ln_ln(real),X2)) ) ) ).

% ln_inverse
tff(fact_3818_summable__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : summable(A,aTP_Lamp_eh(A,fun(nat,A),X2)) ) ).

% summable_exp
tff(fact_3819_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X2)
         => ? [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),N))),X2) ) ) ) ).

% ex_inverse_of_nat_less
tff(fact_3820_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X2: A,Ma: nat,Nb: nat] :
          ( ( X2 != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
           => ( aa(nat,A,power_power(A,X2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),Nb)),aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X2)),Ma)) ) ) ) ) ).

% power_diff_conv_inverse
tff(fact_3821_log__inverse,axiom,
    ! [A2: real,X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( aa(real,real,log(A2),aa(real,real,inverse_inverse(real),X2)) = aa(real,real,uminus_uminus(real),aa(real,real,log(A2),X2)) ) ) ) ) ).

% log_inverse
tff(fact_3822_someI2,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A,Q: fun(A,$o)] :
      ( aa(A,$o,P,A2)
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
           => aa(A,$o,Q,X4) )
       => aa(A,$o,Q,fChoice(A,P)) ) ) ).

% someI2
tff(fact_3823_someI__ex,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( ? [X_1: A] : aa(A,$o,P,X_1)
     => aa(A,$o,P,fChoice(A,P)) ) ).

% someI_ex
tff(fact_3824_someI2__ex,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ? [X_1: A] : aa(A,$o,P,X_1)
     => ( ! [X4: A] :
            ( aa(A,$o,P,X4)
           => aa(A,$o,Q,X4) )
       => aa(A,$o,Q,fChoice(A,P)) ) ) ).

% someI2_ex
tff(fact_3825_someI2__bex,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(set(A),$o,member(A,X),A3)
          & aa(A,$o,P,X) )
     => ( ! [X4: A] :
            ( ( aa(set(A),$o,member(A,X4),A3)
              & aa(A,$o,P,X4) )
           => aa(A,$o,Q,X4) )
       => aa(A,$o,Q,fChoice(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) ) ) ).

% someI2_bex
tff(fact_3826_some__eq__ex,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( aa(A,$o,P,fChoice(A,P))
    <=> ? [X_12: A] : aa(A,$o,P,X_12) ) ).

% some_eq_ex
tff(fact_3827_some1__equality,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A] :
      ( ? [X: A] :
          ( aa(A,$o,P,X)
          & ! [Y4: A] :
              ( aa(A,$o,P,Y4)
             => ( Y4 = X ) ) )
     => ( aa(A,$o,P,A2)
       => ( fChoice(A,P) = A2 ) ) ) ).

% some1_equality
tff(fact_3828_exp__plus__inverse__exp,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,exp(real),X2)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X2)))) ).

% exp_plus_inverse_exp
tff(fact_3829_plus__inverse__ge__2,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,inverse_inverse(real),X2))) ) ).

% plus_inverse_ge_2
tff(fact_3830_real__inv__sqrt__pow2,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(nat,real,power_power(real,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X2))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(real,real,inverse_inverse(real),X2) ) ) ).

% real_inv_sqrt_pow2
tff(fact_3831_dependent__nat__choice,axiom,
    ! [A: $tType,P: fun(nat,fun(A,$o)),Q: fun(nat,fun(A,fun(A,$o)))] :
      ( ? [X_1: A] : aa(A,$o,aa(nat,fun(A,$o),P,zero_zero(nat)),X_1)
     => ( ! [X4: A,N: nat] :
            ( aa(A,$o,aa(nat,fun(A,$o),P,N),X4)
           => ? [Y3: A] :
                ( aa(A,$o,aa(nat,fun(A,$o),P,aa(nat,nat,suc,N)),Y3)
                & aa(A,$o,aa(A,fun(A,$o),aa(nat,fun(A,fun(A,$o)),Q,N),X4),Y3) ) )
       => ? [F5: fun(nat,A)] :
          ! [N8: nat] :
            ( aa(A,$o,aa(nat,fun(A,$o),P,N8),aa(nat,A,F5,N8))
            & aa(A,$o,aa(A,fun(A,$o),aa(nat,fun(A,fun(A,$o)),Q,N8),aa(nat,A,F5,N8)),aa(nat,A,F5,aa(nat,nat,suc,N8))) ) ) ) ).

% dependent_nat_choice
tff(fact_3832_tan__cot,axiom,
    ! [X2: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X2)) = aa(real,real,inverse_inverse(real),aa(real,real,tan(real),X2)) ) ).

% tan_cot
tff(fact_3833_real__le__x__sinh,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,exp(real),X2)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ).

% real_le_x_sinh
tff(fact_3834_real__le__abs__sinh,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,exp(real),X2)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ).

% real_le_abs_sinh
tff(fact_3835_tan__sec,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( cos(A,X2) != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,power_power(A,aa(A,A,tan(A),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),cos(A,X2))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ) ).

% tan_sec
tff(fact_3836_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : ( aa(A,A,exp(A),X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),X2)),suminf(A,aTP_Lamp_ei(A,fun(nat,A),X2))) ) ) ).

% exp_first_two_terms
tff(fact_3837_sinh__ln__real,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( sinh(real,aa(real,real,ln_ln(real),X2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),aa(real,real,inverse_inverse(real),X2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ).

% sinh_ln_real
tff(fact_3838_cosh__ln__real,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( cosh(real,aa(real,real,ln_ln(real),X2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),aa(real,real,inverse_inverse(real),X2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ).

% cosh_ln_real
tff(fact_3839_case__prod__app,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F3: fun(B,fun(C,fun(D,A))),X2: product_prod(B,C),Y2: D] : ( aa(D,A,aa(product_prod(B,C),fun(D,A),aa(fun(B,fun(C,fun(D,A))),fun(product_prod(B,C),fun(D,A)),product_case_prod(B,C,fun(D,A)),F3),X2),Y2) = aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),aa(D,fun(B,fun(C,A)),aTP_Lamp_ej(fun(B,fun(C,fun(D,A))),fun(D,fun(B,fun(C,A))),F3),Y2)),X2) ) ).

% case_prod_app
tff(fact_3840_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X2: A,B2: real] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X2) = aa(A,A,real_V8093663219630862766scaleR(A,B2),X2) )
        <=> ( ( A2 = B2 )
            | ( X2 = zero_zero(A) ) ) ) ) ).

% scaleR_cancel_right
tff(fact_3841_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),zero_zero(A)) = zero_zero(A) ) ) ).

% scaleR_zero_right
tff(fact_3842_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( real_V6157519004096292374lgebra(A)
     => ! [A2: real,X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),Y2) = aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2)) ) ) ).

% mult_scaleR_left
tff(fact_3843_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V6157519004096292374lgebra(A)
     => ! [X2: A,A2: real,Y2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y2)) = aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2)) ) ) ).

% mult_scaleR_right
tff(fact_3844_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X2: A,Y2: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X2) = aa(A,A,real_V8093663219630862766scaleR(A,A2),Y2) )
        <=> ( ( X2 = Y2 )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% scaleR_cancel_left
tff(fact_3845_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,B2: real,X2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,real_V8093663219630862766scaleR(A,B2),X2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),times_times(real),A2),B2)),X2) ) ) ).

% scaleR_scaleR
tff(fact_3846_sinh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sinh(A,zero_zero(A)) = zero_zero(A) ) ) ).

% sinh_0
tff(fact_3847_sinh__real__zero__iff,axiom,
    ! [X2: real] :
      ( ( sinh(real,X2) = zero_zero(real) )
    <=> ( X2 = zero_zero(real) ) ) ).

% sinh_real_zero_iff
tff(fact_3848_sinh__real__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),sinh(real,X2)),sinh(real,Y2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ).

% sinh_real_less_iff
tff(fact_3849_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X2: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(real) )
            | ( X2 = zero_zero(A) ) ) ) ) ).

% scaleR_eq_0_iff
tff(fact_3850_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,zero_zero(real)),X2) = zero_zero(A) ) ) ).

% scaleR_zero_left
tff(fact_3851_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: A,U: real,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,U),B2)) )
        <=> ( ( A2 = B2 )
            | ( U = one_one(real) ) ) ) ) ).

% scaleR_eq_iff
tff(fact_3852_cosh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cosh(A,zero_zero(A)) = one_one(A) ) ) ).

% cosh_0
tff(fact_3853_scaleR__power,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X2: real,Y2: A,Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,real_V8093663219630862766scaleR(A,X2),Y2)),Nb) = aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,power_power(real,X2),Nb)),aa(nat,A,power_power(A,Y2),Nb)) ) ) ).

% scaleR_power
tff(fact_3854_sinh__real__neg__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),sinh(real,X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real)) ) ).

% sinh_real_neg_iff
tff(fact_3855_sinh__real__pos__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sinh(real,X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2) ) ).

% sinh_real_pos_iff
tff(fact_3856_sinh__real__nonpos__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sinh(real,X2)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real)) ) ).

% sinh_real_nonpos_iff
tff(fact_3857_sinh__real__nonneg__iff,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),sinh(real,X2))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2) ) ).

% sinh_real_nonneg_iff
tff(fact_3858_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [U: real,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),U)),A2)),aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) = A2 ) ) ).

% scaleR_collapse
tff(fact_3859_norm__scaleR,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: real,X2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,abs_abs(real),A2)),real_V7770717601297561774m_norm(A,X2)) ) ) ).

% norm_scaleR
tff(fact_3860_scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [U: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(num,real,numeral_numeral(real),U)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),W))),A2) ) ) ).

% scaleR_times
tff(fact_3861_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [V: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),W)),aa(num,real,numeral_numeral(real),V))),A2) ) ) ).

% inverse_scaleR_times
tff(fact_3862_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [U: num,V: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),W))),aa(num,real,numeral_numeral(real),V))),A2) ) ) ).

% fraction_scaleR_times
tff(fact_3863_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)) = A2 ) ) ).

% scaleR_half_double
tff(fact_3864_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: A,A2: real,B2: real] :
          ( ( X2 != zero_zero(A) )
         => ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X2) = aa(A,A,real_V8093663219630862766scaleR(A,B2),X2) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
tff(fact_3865_cosh__real__nonzero,axiom,
    ! [X2: real] : ( cosh(real,X2) != zero_zero(real) ) ).

% cosh_real_nonzero
tff(fact_3866_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X2: A,Y2: A] :
          ( ( A2 != zero_zero(real) )
         => ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X2) = aa(A,A,real_V8093663219630862766scaleR(A,A2),Y2) )
           => ( X2 = Y2 ) ) ) ) ).

% scaleR_left_imp_eq
tff(fact_3867_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),cosh(A,X2)),sinh(A,X2)) = aa(A,A,exp(A),X2) ) ) ).

% cosh_plus_sinh
tff(fact_3868_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),sinh(A,X2)),cosh(A,X2)) = aa(A,A,exp(A),X2) ) ) ).

% sinh_plus_cosh
tff(fact_3869_cosh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X2)),cosh(A,Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X2)),sinh(A,Y2))) ) ) ).

% cosh_add
tff(fact_3870_sinh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X2)),cosh(A,Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X2)),sinh(A,Y2))) ) ) ).

% sinh_add
tff(fact_3871_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X2: A,Y2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y2)) ) ) ).

% scaleR_right_distrib
tff(fact_3872_tanh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(A,A,tanh(A),X2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sinh(A,X2)),cosh(A,X2)) ) ) ).

% tanh_def
tff(fact_3873_real__scaleR__def,axiom,
    ! [A2: real,X2: real] : ( aa(real,real,real_V8093663219630862766scaleR(real,A2),X2) = aa(real,real,aa(real,fun(real,real),times_times(real),A2),X2) ) ).

% real_scaleR_def
tff(fact_3874_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X2)),cosh(A,Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X2)),sinh(A,Y2))) ) ) ).

% sinh_diff
tff(fact_3875_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X2)),cosh(A,Y2))),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X2)),sinh(A,Y2))) ) ) ).

% cosh_diff
tff(fact_3876_sinh__less__cosh__real,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),sinh(real,X2)),cosh(real,X2)) ).

% sinh_less_cosh_real
tff(fact_3877_summable__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),R: real] :
          ( summable(A,X7)
         => summable(A,aa(real,fun(nat,A),aTP_Lamp_ek(fun(nat,A),fun(real,fun(nat,A)),X7),R)) ) ) ).

% summable_scaleR_right
tff(fact_3878_sums__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),A2: A,R: real] :
          ( aa(A,$o,sums(A,X7),A2)
         => aa(A,$o,sums(A,aa(real,fun(nat,A),aTP_Lamp_ek(fun(nat,A),fun(real,fun(nat,A)),X7),R)),aa(A,A,real_V8093663219630862766scaleR(A,R),A2)) ) ) ).

% sums_scaleR_right
tff(fact_3879_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: real,Y2: real,Xa2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),Y2)),Xa2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,X2),Xa2)),aa(A,A,real_V8093663219630862766scaleR(A,Y2),Xa2)) ) ) ).

% scaleR_left.add
tff(fact_3880_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,B2: real,X2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X2)) ) ) ).

% scaleR_left_distrib
tff(fact_3881_cosh__real__pos,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),cosh(real,X2)) ).

% cosh_real_pos
tff(fact_3882_cosh__real__nonpos__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),zero_zero(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cosh(real,X2)),cosh(real,Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),X2) ) ) ) ).

% cosh_real_nonpos_le_iff
tff(fact_3883_cosh__real__nonneg__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cosh(real,X2)),cosh(real,Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2) ) ) ) ).

% cosh_real_nonneg_le_iff
tff(fact_3884_cosh__real__nonneg,axiom,
    ! [X2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),cosh(real,X2)) ).

% cosh_real_nonneg
tff(fact_3885_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [R: real,X2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,R),X2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(real,A,real_Vector_of_real(A),R)),X2) ) ) ).

% scaleR_conv_of_real
tff(fact_3886_sinh__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sinh(A,X2))),cosh(A,X2)) ) ) ).

% sinh_double
tff(fact_3887_complex__scaleR,axiom,
    ! [R: real,A2: real,B2: real] : ( aa(complex,complex,real_V8093663219630862766scaleR(complex,R),complex2(A2,B2)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R),A2),aa(real,real,aa(real,fun(real,real),times_times(real),R),B2)) ) ).

% complex_scaleR
tff(fact_3888_divide__complex__def,axiom,
    ! [X2: complex,Y2: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X2),Y2) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X2),aa(complex,complex,inverse_inverse(complex),Y2)) ) ).

% divide_complex_def
tff(fact_3889_suminf__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),R: real] :
          ( summable(A,X7)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,R),suminf(A,X7)) = suminf(A,aa(real,fun(nat,A),aTP_Lamp_ek(fun(nat,A),fun(real,fun(nat,A)),X7),R)) ) ) ) ).

% suminf_scaleR_right
tff(fact_3890_summable__scaleR__left,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,real),X2: A] :
          ( summable(real,X7)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_el(fun(nat,real),fun(A,fun(nat,A)),X7),X2)) ) ) ).

% summable_scaleR_left
tff(fact_3891_sums__scaleR__left,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,real),A2: real,X2: A] :
          ( aa(real,$o,sums(real,X7),A2)
         => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_el(fun(nat,real),fun(A,fun(nat,A)),X7),X2)),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)) ) ) ).

% sums_scaleR_left
tff(fact_3892_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [B2: real,A2: real,C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),C2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),C2)) ) ) ) ).

% scaleR_right_mono_neg
tff(fact_3893_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X2)) ) ) ) ).

% scaleR_right_mono
tff(fact_3894_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% scaleR_le_cancel_left
tff(fact_3895_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% scaleR_le_cancel_left_neg
tff(fact_3896_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% scaleR_le_cancel_left_pos
tff(fact_3897_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [B2: A,A2: A,C2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),zero_zero(real))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2)) ) ) ) ).

% scaleR_left_mono_neg
tff(fact_3898_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [X2: A,Y2: A,A2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y2)) ) ) ) ).

% scaleR_left_mono
tff(fact_3899_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: A,U: real,V: real,A2: A] :
          ( ( X2 = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),U),V)),A2) )
        <=> $ite(V = zero_zero(real),X2 = zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,V),X2) = aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) ) ) ).

% eq_vector_fraction_iff
tff(fact_3900_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [U: real,V: real,A2: A,X2: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),U),V)),A2) = X2 )
        <=> $ite(V = zero_zero(real),X2 = zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,U),A2) = aa(A,A,real_V8093663219630862766scaleR(A,V),X2)) ) ) ).

% vector_fraction_eq_iff
tff(fact_3901_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)),E2)),C2)),D2) ) ) ).

% Real_Vector_Spaces.le_add_iff1
tff(fact_3902_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),E2)),D2)) ) ) ).

% Real_Vector_Spaces.le_add_iff2
tff(fact_3903_cosh__real__strict__mono,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),cosh(real,X2)),cosh(real,Y2)) ) ) ).

% cosh_real_strict_mono
tff(fact_3904_cosh__real__nonneg__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),cosh(real,X2)),cosh(real,Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ) ) ).

% cosh_real_nonneg_less_iff
tff(fact_3905_cosh__real__nonpos__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y2),zero_zero(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),cosh(real,X2)),cosh(real,Y2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y2),X2) ) ) ) ).

% cosh_real_nonpos_less_iff
tff(fact_3906_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(nat,A,power_power(A,cosh(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,sinh(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% cosh_square_eq
tff(fact_3907_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(nat,A,power_power(A,sinh(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,cosh(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% sinh_square_eq
tff(fact_3908_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,cosh(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,sinh(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(A) ) ) ).

% hyperbolic_pythagoras
tff(fact_3909_arcosh__cosh__real,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,real,arcosh(real),cosh(real,X2)) = X2 ) ) ).

% arcosh_cosh_real
tff(fact_3910_cosh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : ( cosh(A,X2) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),X2)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X2)))) ) ) ).

% cosh_def
tff(fact_3911_sinh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : ( sinh(A,X2) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),X2)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X2)))) ) ) ).

% sinh_def
tff(fact_3912_cosh__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,power_power(A,cosh(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,power_power(A,sinh(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% cosh_double
tff(fact_3913_suminf__scaleR__left,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,real),X2: A] :
          ( summable(real,X7)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,suminf(real,X7)),X2) = suminf(A,aa(A,fun(nat,A),aTP_Lamp_el(fun(nat,real),fun(A,fun(nat,A)),X7),X2)) ) ) ) ).

% suminf_scaleR_left
tff(fact_3914_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)),zero_zero(A))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% scaleR_le_0_iff
tff(fact_3915_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% zero_le_scaleR_iff
tff(fact_3916_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)) ) ) ) ).

% scaleR_nonpos_nonpos
tff(fact_3917_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),zero_zero(A)) ) ) ) ).

% scaleR_nonpos_nonneg
tff(fact_3918_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),zero_zero(A)) ) ) ) ).

% scaleR_nonneg_nonpos
tff(fact_3919_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)) ) ) ) ).

% scaleR_nonneg_nonneg
tff(fact_3920_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)) ) ) ).

% split_scaleR_pos_le
tff(fact_3921_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,X2: A] :
          ( ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),zero_zero(A)) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),zero_zero(A)) ) ) ).

% split_scaleR_neg_le
tff(fact_3922_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),C2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),D2)) ) ) ) ) ) ).

% scaleR_mono'
tff(fact_3923_scaleR__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,X2: A,Y2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Y2)) ) ) ) ) ) ).

% scaleR_mono
tff(fact_3924_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [X2: A,A2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),one_one(real))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),X2) ) ) ) ).

% scaleR_left_le_one_le
tff(fact_3925_scaleR__2,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),X2) ) ) ).

% scaleR_2
tff(fact_3926_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Ma: real,Y2: A,X2: A,C2: A] :
          ( ( Ma != zero_zero(real) )
         => ( ( Y2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,Ma),X2)),C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),Ma)),Y2)),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),Ma)),C2)) = X2 ) ) ) ) ).

% real_vector_eq_affinity
tff(fact_3927_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Ma: real,X2: A,C2: A,Y2: A] :
          ( ( Ma != zero_zero(real) )
         => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,Ma),X2)),C2) = Y2 )
          <=> ( X2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),Ma)),Y2)),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),Ma)),C2)) ) ) ) ) ).

% real_vector_affinity_eq
tff(fact_3928_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_le_divideR_eq
tff(fact_3929_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% neg_divideR_le_eq
tff(fact_3930_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% pos_le_divideR_eq
tff(fact_3931_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_divideR_le_eq
tff(fact_3932_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_less_divideR_eq
tff(fact_3933_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% neg_divideR_less_eq
tff(fact_3934_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% pos_less_divideR_eq
tff(fact_3935_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_divideR_less_eq
tff(fact_3936_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [A2: real,X2: A] :
          ( ( A2 != zero_zero(real) )
         => ( ( X2 != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),A2)),aa(A,A,inverse_inverse(A),X2)) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
tff(fact_3937_fun__cong__unused__0,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( zero(B)
     => ! [F3: fun(fun(A,B),C),G: C] :
          ( ! [X4: fun(A,B)] : ( aa(fun(A,B),C,F3,X4) = G )
         => ( aa(fun(A,B),C,F3,aTP_Lamp_em(A,B)) = G ) ) ) ).

% fun_cong_unused_0
tff(fact_3938_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : summable(A,aTP_Lamp_en(A,fun(nat,A),X2)) ) ).

% summable_exp_generic
tff(fact_3939_sin__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : aa(A,$o,sums(A,aTP_Lamp_eo(A,fun(nat,A),X2)),sin(A,X2)) ) ).

% sin_converges
tff(fact_3940_sin__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( sin(A,X) = suminf(A,aTP_Lamp_eo(A,fun(nat,A),X)) ) ) ).

% sin_def
tff(fact_3941_cos__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : aa(A,$o,sums(A,aTP_Lamp_ep(A,fun(nat,A),X2)),cos(A,X2)) ) ).

% cos_converges
tff(fact_3942_cos__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( cos(A,X) = suminf(A,aTP_Lamp_ep(A,fun(nat,A),X)) ) ) ).

% cos_def
tff(fact_3943_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : summable(real,aTP_Lamp_eq(A,fun(nat,real),X2)) ) ).

% summable_norm_sin
tff(fact_3944_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : summable(real,aTP_Lamp_er(A,fun(nat,real),X2)) ) ).

% summable_norm_cos
tff(fact_3945_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : aa(A,$o,sums(A,aTP_Lamp_es(A,fun(nat,A),X2)),cosh(A,X2)) ) ).

% cosh_converges
tff(fact_3946_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divideR_le_eq
tff(fact_3947_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_le_minus_divideR_eq
tff(fact_3948_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_minus_divideR_le_eq
tff(fact_3949_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_le_minus_divideR_eq
tff(fact_3950_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divideR_less_eq
tff(fact_3951_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_less_minus_divideR_eq
tff(fact_3952_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_minus_divideR_less_eq
tff(fact_3953_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_less_minus_divideR_eq
tff(fact_3954_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : aa(A,$o,sums(A,aTP_Lamp_et(A,fun(nat,A),X2)),sinh(A,X2)) ) ).

% sinh_converges
tff(fact_3955_eq__subset,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o))] : aa(fun(A,fun(A,$o)),$o,aa(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),$o),ord_less_eq(fun(A,fun(A,$o))),fequal(A)),aTP_Lamp_eu(fun(A,fun(A,$o)),fun(A,fun(A,$o)),P)) ).

% eq_subset
tff(fact_3956_exp__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : aa(A,$o,sums(A,aTP_Lamp_en(A,fun(nat,A),X2)),aa(A,A,exp(A),X2)) ) ).

% exp_converges
tff(fact_3957_exp__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,exp(A),X) = suminf(A,aTP_Lamp_en(A,fun(nat,A),X)) ) ) ).

% exp_def
tff(fact_3958_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : summable(real,aTP_Lamp_ev(A,fun(nat,real),X2)) ) ).

% summable_norm_exp
tff(fact_3959_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : aa(A,$o,sums(A,aTP_Lamp_ew(A,fun(nat,A),X2)),sin(A,X2)) ) ).

% sin_minus_converges
tff(fact_3960_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : aa(A,$o,sums(A,aTP_Lamp_ex(A,fun(nat,A),X2)),cos(A,X2)) ) ).

% cos_minus_converges
tff(fact_3961_tanh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] :
          ( ( cosh(A,X2) != zero_zero(A) )
         => ( ( cosh(A,Y2) != zero_zero(A) )
           => ( aa(A,A,tanh(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tanh(A),X2)),aa(A,A,tanh(A),Y2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tanh(A),X2)),aa(A,A,tanh(A),Y2)))) ) ) ) ) ).

% tanh_add
tff(fact_3962_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] : ( cosh(A,Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),Z)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% cosh_field_def
tff(fact_3963_complex__inverse,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,inverse_inverse(complex),complex2(A2,B2)) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),A2),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),B2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% complex_inverse
tff(fact_3964_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] : ( sinh(A,Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Z)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% sinh_field_def
tff(fact_3965_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A] : ( aa(A,A,exp(A),X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),suminf(A,aTP_Lamp_ey(A,fun(nat,A),X2))) ) ) ).

% exp_first_term
tff(fact_3966_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P2: product_prod(A,B)] : ( aa(product_prod(A,B),product_prod(A,B),aa(fun(A,fun(B,product_prod(A,B))),fun(product_prod(A,B),product_prod(A,B)),product_case_prod(A,B,product_prod(A,B)),product_Pair(A,B)),P2) = P2 ) ).

% case_prod_Pair_iden
tff(fact_3967_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( cosh(A,X2) = zero_zero(A) )
        <=> ( aa(nat,A,power_power(A,aa(A,A,exp(A),X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% cosh_zero_iff
tff(fact_3968_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_fa(A,fun(A,fun(nat,A)),X2),Y2)),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X2)),sin(A,Y2))) ) ).

% sin_x_sin_y
tff(fact_3969_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_fc(A,fun(A,fun(nat,A)),X2),Y2)),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2))) ) ).

% sums_cos_x_plus_y
tff(fact_3970_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,Y2: A] : aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_fe(A,fun(A,fun(nat,A)),X2),Y2)),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X2)),cos(A,Y2))) ) ).

% cos_x_cos_y
tff(fact_3971_rat__inverse__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,inverse_inverse(rat),P2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_ff(int,fun(int,product_prod(int,int)))),quotient_of(P2)) ) ).

% rat_inverse_code
tff(fact_3972_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [F3: fun(B,nat),A3: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_fg(fun(B,nat),fun(B,A),F3)),A3) ) ) ).

% of_nat_sum
tff(fact_3973_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [F3: fun(B,int),A3: set(B)] : ( ring_1_of_int(A,aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7311177749621191930dd_sum(B,int),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_fh(fun(B,int),fun(B,A),F3)),A3) ) ) ).

% of_int_sum
tff(fact_3974_of__real__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [F3: fun(B,real),S: set(B)] : ( aa(real,A,real_Vector_of_real(A),aa(set(B),real,aa(fun(B,real),fun(set(B),real),groups7311177749621191930dd_sum(B,real),F3),S)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_fi(fun(B,real),fun(B,A),F3)),S) ) ) ).

% of_real_sum
tff(fact_3975_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),Nb))),aa(nat,A,G,aa(nat,nat,suc,Nb))) ) ) ).

% sum.atMost_Suc
tff(fact_3976_quotient__of__number_I3_J,axiom,
    ! [K: num] : ( quotient_of(aa(num,rat,numeral_numeral(rat),K)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% quotient_of_number(3)
tff(fact_3977_rat__zero__code,axiom,
    quotient_of(zero_zero(rat)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)) ).

% rat_zero_code
tff(fact_3978_quotient__of__number_I5_J,axiom,
    ! [K: num] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K))) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)) ) ).

% quotient_of_number(5)
tff(fact_3979_divide__rat__def,axiom,
    ! [Q2: rat,R: rat] : ( aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),Q2),R) = aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),Q2),aa(rat,rat,inverse_inverse(rat),R)) ) ).

% divide_rat_def
tff(fact_3980_scaleR__left_Osum,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [G: fun(B,real),A3: set(B),X2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(set(B),real,aa(fun(B,real),fun(set(B),real),groups7311177749621191930dd_sum(B,real),G),A3)),X2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_fj(fun(B,real),fun(A,fun(B,A)),G),X2)),A3) ) ) ).

% scaleR_left.sum
tff(fact_3981_scaleR__sum__left,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [F3: fun(B,real),A3: set(B),X2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(set(B),real,aa(fun(B,real),fun(set(B),real),groups7311177749621191930dd_sum(B,real),F3),A3)),X2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_fj(fun(B,real),fun(A,fun(B,A)),F3),X2)),A3) ) ) ).

% scaleR_sum_left
tff(fact_3982_sum__choose__upper,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_fk(nat,fun(nat,nat),Ma)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(nat,nat,binomial(aa(nat,nat,suc,Nb)),aa(nat,nat,suc,Ma)) ) ).

% sum_choose_upper
tff(fact_3983_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(B,A),A3: set(B)] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3))),aa(set(B),real,aa(fun(B,real),fun(set(B),real),groups7311177749621191930dd_sum(B,real),aTP_Lamp_fl(fun(B,A),fun(B,real),F3)),A3)) ) ).

% norm_sum
tff(fact_3984_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [F3: fun(B,A),A2: A,A3: set(B)] : ( modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_fm(fun(B,A),fun(A,fun(B,A)),F3),A2)),A3),A2) = modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3),A2) ) ) ).

% mod_sum_eq
tff(fact_3985_scaleR__sum__right,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,F3: fun(B,A),A3: set(B)] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_fn(real,fun(fun(B,A),fun(B,A)),A2),F3)),A3) ) ) ).

% scaleR_sum_right
tff(fact_3986_scaleR__right_Osum,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,G: fun(B,A),A3: set(B)] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_fn(real,fun(fun(B,A),fun(B,A)),A2),G)),A3) ) ) ).

% scaleR_right.sum
tff(fact_3987_summable__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add(B)
        & topological_t2_space(B) )
     => ! [I5: set(A),F3: fun(A,fun(nat,B))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => summable(B,aa(A,fun(nat,B),F3,I2)) )
         => summable(B,aa(fun(A,fun(nat,B)),fun(nat,B),aTP_Lamp_fp(set(A),fun(fun(A,fun(nat,B)),fun(nat,B)),I5),F3)) ) ) ).

% summable_sum
tff(fact_3988_sums__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add(B)
        & topological_t2_space(B) )
     => ! [I5: set(A),F3: fun(A,fun(nat,B)),X2: fun(A,B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => aa(B,$o,sums(B,aa(A,fun(nat,B),F3,I2)),aa(A,B,X2,I2)) )
         => aa(B,$o,sums(B,aa(fun(A,fun(nat,B)),fun(nat,B),aTP_Lamp_fp(set(A),fun(fun(A,fun(nat,B)),fun(nat,B)),I5),F3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),X2),I5)) ) ) ).

% sums_sum
tff(fact_3989_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fq(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) ) ) ).

% sum.atMost_Suc_shift
tff(fact_3990_sum__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(nat,A),I3: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fr(fun(nat,A),fun(nat,A),F3)),aa(nat,set(nat),set_ord_atMost(nat),I3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,zero_zero(nat))),aa(nat,A,F3,aa(nat,nat,suc,I3))) ) ) ).

% sum_telescope
tff(fact_3991_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),Nb: nat,D2: fun(nat,A)] :
          ( ! [X3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fs(fun(nat,A),fun(A,fun(nat,A)),C2),X3)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fs(fun(nat,A),fun(A,fun(nat,A)),D2),X3)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) )
        <=> ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),Nb)
             => ( aa(nat,A,C2,I) = aa(nat,A,D2,I) ) ) ) ) ).

% polyfun_eq_coeffs
tff(fact_3992_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linord2810124833399127020strict(A)
        & topolo1944317154257567458pology(A) )
     => ! [A2: fun(nat,A),B4: A] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,A2,N))
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),A2),aa(nat,set(nat),set_ord_atMost(nat),N))),B4)
           => summable(A,A2) ) ) ) ).

% bounded_imp_summable
tff(fact_3993_atMost__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [U: A] : ( aa(A,set(A),set_ord_atMost(A),U) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ft(A,fun(A,$o),U)) ) ) ).

% atMost_def
tff(fact_3994_sum__choose__lower,axiom,
    ! [R: nat,Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_fu(nat,fun(nat,nat),R)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),R),Nb))),Nb) ) ).

% sum_choose_lower
tff(fact_3995_choose__rising__sum_I2_J,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_fv(nat,fun(nat,nat),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)),one_one(nat))),Ma) ) ).

% choose_rising_sum(2)
tff(fact_3996_choose__rising__sum_I1_J,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_fv(nat,fun(nat,nat),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat))) ) ).

% choose_rising_sum(1)
tff(fact_3997_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [C2: fun(nat,A),Nb: nat,K: nat] :
          ( ! [W2: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fw(fun(nat,A),fun(A,fun(nat,A)),C2),W2)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
           => ( aa(nat,A,C2,K) = zero_zero(A) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
tff(fact_3998_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),Nb: nat] :
          ( ! [X3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fs(fun(nat,A),fun(A,fun(nat,A)),C2),X3)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = zero_zero(A) )
        <=> ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),Nb)
             => ( aa(nat,A,C2,I) = zero_zero(A) ) ) ) ) ).

% polyfun_eq_0
tff(fact_3999_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fx(A,fun(nat,A),A2)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),Nb))),one_one(A))),Nb) ) ) ).

% gbinomial_parallel_sum
tff(fact_4000_sum__choose__diagonal,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_fy(nat,fun(nat,fun(nat,nat)),Ma),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(nat,nat,binomial(aa(nat,nat,suc,Nb)),Ma) ) ) ).

% sum_choose_diagonal
tff(fact_4001_vandermonde,axiom,
    ! [Ma: nat,Nb: nat,R: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_fz(nat,fun(nat,fun(nat,fun(nat,nat))),Ma),Nb),R)),aa(nat,set(nat),set_ord_atMost(nat),R)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)),R) ) ).

% vandermonde
tff(fact_4002_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X2),aa(nat,nat,suc,Nb))) ) ) ).

% sum_gp_basic
tff(fact_4003_suminf__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add(B)
        & topological_t2_space(B) )
     => ! [I5: set(A),F3: fun(A,fun(nat,B))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => summable(B,aa(A,fun(nat,B),F3,I2)) )
         => ( suminf(B,aa(fun(A,fun(nat,B)),fun(nat,B),aTP_Lamp_fp(set(A),fun(fun(A,fun(nat,B)),fun(nat,B)),I5),F3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_ga(fun(A,fun(nat,B)),fun(A,B),F3)),I5) ) ) ) ).

% suminf_sum
tff(fact_4004_choose__row__sum,axiom,
    ! [Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) ) ).

% choose_row_sum
tff(fact_4005_binomial,axiom,
    ! [A2: nat,B2: nat,Nb: nat] : ( aa(nat,nat,power_power(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),Nb) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_gb(nat,fun(nat,fun(nat,fun(nat,nat))),A2),B2),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ).

% binomial
tff(fact_4006_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_gc(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_gc(fun(nat,A),fun(nat,real),B2))
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ge(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)) ) ) ) ).

% summable_Cauchy_product
tff(fact_4007_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_gc(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_gc(fun(nat,A),fun(nat,real),B2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,A2)),suminf(A,B2)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ge(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)) ) ) ) ) ).

% Cauchy_product
tff(fact_4008_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gf(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ) ).

% sum.in_pairs_0
tff(fact_4009_polynomial__product,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Ma: nat,A2: fun(nat,A),Nb: nat,B2: fun(nat,A),X2: A] :
          ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),I2)
             => ( aa(nat,A,A2,I2) = zero_zero(A) ) )
         => ( ! [J: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),J)
               => ( aa(nat,A,B2,J) = zero_zero(A) ) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),A2),X2)),aa(nat,set(nat),set_ord_atMost(nat),Ma))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),B2),X2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(fun(nat,A),fun(A,fun(nat,A)),aTP_Lamp_gi(fun(nat,A),fun(fun(nat,A),fun(A,fun(nat,A))),A2),B2),X2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb))) ) ) ) ) ).

% polynomial_product
tff(fact_4010_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gj(A,fun(nat,A),A2)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Ma)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),Ma)) ) ) ).

% gbinomial_sum_lower_neg
tff(fact_4011_binomial__ring,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,B2: A,Nb: nat] : ( aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),Nb) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gk(A,fun(A,fun(nat,fun(nat,A))),A2),B2),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ) ).

% binomial_ring
tff(fact_4012_polynomial__product__nat,axiom,
    ! [Ma: nat,A2: fun(nat,nat),Nb: nat,B2: fun(nat,nat),X2: nat] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),I2)
         => ( aa(nat,nat,A2,I2) = zero_zero(nat) ) )
     => ( ! [J: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),J)
           => ( aa(nat,nat,B2,J) = zero_zero(nat) ) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_gl(fun(nat,nat),fun(nat,fun(nat,nat)),A2),X2)),aa(nat,set(nat),set_ord_atMost(nat),Ma))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_gl(fun(nat,nat),fun(nat,fun(nat,nat)),B2),X2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_gn(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),A2),B2),X2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb))) ) ) ) ).

% polynomial_product_nat
tff(fact_4013_choose__square__sum,axiom,
    ! [Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_go(nat,fun(nat,nat),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),Nb) ) ).

% choose_square_sum
tff(fact_4014_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A2: A,B2: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),Nb) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gp(A,fun(A,fun(nat,fun(nat,A))),A2),B2),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ) ).

% pochhammer_binomial_sum
tff(fact_4015_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_gc(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_gc(fun(nat,A),fun(nat,real),B2))
           => aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ge(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,A2)),suminf(A,B2))) ) ) ) ).

% Cauchy_product_sums
tff(fact_4016_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,Ma: nat,I5: set(nat)] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_gq(A,fun(nat,fun(nat,A)),X2),Ma)),I5) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),Ma)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),I5)) ) ) ).

% sum_power_add
tff(fact_4017_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [P2: nat,K: nat,G: fun(nat,A),H: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P2)
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gr(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),aa(nat,set(nat),set_ord_atMost(nat),P2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gs(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P2),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% sum.zero_middle
tff(fact_4018_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Ma: nat,A2: A,X2: A,Y2: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gt(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Ma),A2),X2),Y2)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gu(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Ma),A2),X2),Y2)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) ) ) ).

% gbinomial_partial_sum_poly
tff(fact_4019_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A,Y2: A,Nb: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2) = aa(A,A,aa(A,fun(A,A),times_times(A),Y2),X2) )
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Nb))),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)),Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gv(A,fun(A,fun(nat,fun(nat,A))),X2),Y2),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ) ) ).

% exp_series_add_commuting
tff(fact_4020_quotient__of__denom__pos,axiom,
    ! [R: rat,P2: int,Q2: int] :
      ( ( quotient_of(R) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q2) ) ).

% quotient_of_denom_pos
tff(fact_4021_root__polyfun,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Nb: nat,Z: A,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Nb)
         => ( ( aa(nat,A,power_power(A,Z),Nb) = A2 )
          <=> ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_gw(nat,fun(A,fun(A,fun(nat,A))),Nb),Z),A2)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = zero_zero(A) ) ) ) ) ).

% root_polyfun
tff(fact_4022_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X2: A,Nb: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))
          = $ite(X2 = one_one(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X2),aa(nat,nat,suc,Nb)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2))) ) ) ).

% sum_gp0
tff(fact_4023_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Nb: nat] :
          ( ( Nb != one_one(nat) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gx(nat,fun(nat,A),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = zero_zero(A) ) ) ) ).

% choose_alternating_linear_sum
tff(fact_4024_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gy(nat,fun(nat,A),Ma)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma) ) ) ).

% gbinomial_sum_nat_pow2
tff(fact_4025_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Ma: nat,A2: A,X2: A,Y2: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gt(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Ma),A2),X2),Y2)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gz(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Ma),A2),X2),Y2)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) ) ) ).

% gbinomial_partial_sum_poly_xpos
tff(fact_4026_binomial__r__part__sum,axiom,
    ! [Ma: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma)),one_one(nat)))),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma)) ) ).

% binomial_r_part_sum
tff(fact_4027_choose__linear__sum,axiom,
    ! [Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ha(nat,fun(nat,nat),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))) ) ).

% choose_linear_sum
tff(fact_4028_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_hb(nat,fun(nat,A),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = zero_zero(A) ) ) ) ).

% choose_alternating_sum
tff(fact_4029_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [E2: real,C2: fun(nat,A),Nb: nat] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
         => ? [M7: real] :
            ! [Z3: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),M7),real_V7770717601297561774m_norm(A,Z3))
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),aa(nat,set(nat),set_ord_atMost(nat),Nb)))),aa(real,real,aa(real,fun(real,real),times_times(real),E2),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(A,Z3)),aa(nat,nat,suc,Nb)))) ) ) ) ).

% polyfun_extremal_lemma
tff(fact_4030_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,semiring_1_of_nat(A),Ma))),one_one(A)))),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma)) ) ) ).

% gbinomial_r_part_sum
tff(fact_4031_choose__even__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_hc(nat,fun(nat,A),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) ) ) ) ).

% choose_even_sum
tff(fact_4032_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_hd(nat,fun(nat,A),Nb)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) ) ) ) ).

% choose_odd_sum
tff(fact_4033_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_he(A,fun(nat,A),A2)),aa(nat,set(nat),set_ord_atMost(nat),Ma)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Ma)),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),one_one(nat)))) ) ) ).

% gbinomial_partial_row_sum
tff(fact_4034_rat__uminus__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),P2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_hf(int,fun(int,product_prod(int,int)))),quotient_of(P2)) ) ).

% rat_uminus_code
tff(fact_4035_rat__less__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),P2),Q2)
    <=> aa(product_prod(int,int),$o,aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aTP_Lamp_hh(rat,fun(int,fun(int,$o)),Q2)),quotient_of(P2)) ) ).

% rat_less_code
tff(fact_4036_rat__floor__code,axiom,
    ! [P2: rat] : ( archim6421214686448440834_floor(rat,P2) = aa(product_prod(int,int),int,aa(fun(int,fun(int,int)),fun(product_prod(int,int),int),product_case_prod(int,int,int),divide_divide(int)),quotient_of(P2)) ) ).

% rat_floor_code
tff(fact_4037_rat__abs__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,abs_abs(rat),P2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_hi(int,fun(int,product_prod(int,int)))),quotient_of(P2)) ) ).

% rat_abs_code
tff(fact_4038_rat__less__eq__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),P2),Q2)
    <=> aa(product_prod(int,int),$o,aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aTP_Lamp_hk(rat,fun(int,fun(int,$o)),Q2)),quotient_of(P2)) ) ).

% rat_less_eq_code
tff(fact_4039_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Nb: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),one_one(A)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),Nb))) ) ) ).

% mask_eq_sum_exp
tff(fact_4040_mask__eq__sum__exp__nat,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),aa(nat,nat,suc,zero_zero(nat))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),Nb))) ) ).

% mask_eq_sum_exp_nat
tff(fact_4041_sum__abs__ge__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [F3: fun(B,A),A3: set(B)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_hm(fun(B,A),fun(B,A),F3)),A3)) ) ).

% sum_abs_ge_zero
tff(fact_4042_sum__abs,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [F3: fun(B,A),A3: set(B)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_hm(fun(B,A),fun(B,A),F3)),A3)) ) ).

% sum_abs
tff(fact_4043_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),X2: fun(A,B),A2: fun(A,B),B2: B,Delta: B] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,X2,I2)) )
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),X2),I5) = one_one(B) )
           => ( ! [I2: A] :
                  ( aa(set(A),$o,member(A,I2),I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A2,I2)),B2))),Delta) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_hn(fun(A,B),fun(fun(A,B),fun(A,B)),X2),A2)),I5)),B2))),Delta) ) ) ) ) ).

% convex_sum_bound_le
tff(fact_4044_abs__sum__abs,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [F3: fun(B,A),A3: set(B)] : ( aa(A,A,abs_abs(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_hm(fun(B,A),fun(B,A),F3)),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_hm(fun(B,A),fun(B,A),F3)),A3) ) ) ).

% abs_sum_abs
tff(fact_4045_of__nat__id,axiom,
    ! [Nb: nat] : ( aa(nat,nat,semiring_1_of_nat(nat),Nb) = Nb ) ).

% of_nat_id
tff(fact_4046_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_ho(B,A)),A3) = zero_zero(A) ) ) ).

% sum.neutral_const
tff(fact_4047_int__sum,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)) = aa(set(A),int,aa(fun(A,int),fun(set(A),int),groups7311177749621191930dd_sum(A,int),aTP_Lamp_hp(fun(A,nat),fun(A,int),F3)),A3) ) ).

% int_sum
tff(fact_4048_Complex__sum_H,axiom,
    ! [A: $tType,F3: fun(A,real),S: set(A)] : ( aa(set(A),complex,aa(fun(A,complex),fun(set(A),complex),groups7311177749621191930dd_sum(A,complex),aTP_Lamp_hq(fun(A,real),fun(A,complex),F3)),S) = complex2(aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),F3),S),zero_zero(real)) ) ).

% Complex_sum'
tff(fact_4049_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set(A),G: fun(A,nat),F3: fun(A,nat)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,G,X4)),aa(A,nat,F3,X4)) )
     => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_hr(fun(A,nat),fun(fun(A,nat),fun(A,nat)),G),F3)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),G),A3)) ) ) ).

% sum_subtractf_nat
tff(fact_4050_sum__SucD,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A),Nb: nat] :
      ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3) = aa(nat,nat,suc,Nb) )
     => ? [X4: A] :
          ( aa(set(A),$o,member(A,X4),A3)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,F3,X4)) ) ) ).

% sum_SucD
tff(fact_4051_sum__nth__roots,axiom,
    ! [Nb: nat,C2: complex] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),Nb)
     => ( aa(set(complex),complex,aa(fun(complex,complex),fun(set(complex),complex),groups7311177749621191930dd_sum(complex,complex),aTP_Lamp_hs(complex,complex)),aa(fun(complex,$o),set(complex),collect(complex),aa(complex,fun(complex,$o),aTP_Lamp_ht(nat,fun(complex,fun(complex,$o)),Nb),C2))) = zero_zero(complex) ) ) ).

% sum_nth_roots
tff(fact_4052_sum_Oswap,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,fun(C,A)),B4: set(C),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(set(C),fun(B,A),aTP_Lamp_hu(fun(B,fun(C,A)),fun(set(C),fun(B,A)),G),B4)),A3) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(set(B),fun(C,A),aTP_Lamp_hw(fun(B,fun(C,A)),fun(set(B),fun(C,A)),G),A3)),B4) ) ) ).

% sum.swap
tff(fact_4053_sum__roots__unity,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),Nb)
     => ( aa(set(complex),complex,aa(fun(complex,complex),fun(set(complex),complex),groups7311177749621191930dd_sum(complex,complex),aTP_Lamp_hs(complex,complex)),aa(fun(complex,$o),set(complex),collect(complex),aTP_Lamp_hx(nat,fun(complex,$o),Nb))) = zero_zero(complex) ) ) ).

% sum_roots_unity
tff(fact_4054_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),Nb: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_hy(nat,fun(nat,fun(nat,$o)),Nb)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ia(fun(nat,fun(nat,A)),fun(nat,A),G)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ) ).

% sum.triangle_reindex_eq
tff(fact_4055_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A3: set(B)] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) != zero_zero(A) )
         => ~ ! [A4: B] :
                ( aa(set(B),$o,member(B,A4),A3)
               => ( aa(B,A,G,A4) = zero_zero(A) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
tff(fact_4056_sum_Oneutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => ( aa(A,B,G,X4) = zero_zero(B) ) )
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = zero_zero(B) ) ) ) ).

% sum.neutral
tff(fact_4057_sum__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [K5: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),K5)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),aa(A,B,G,I2)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),K5)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),K5)) ) ) ).

% sum_mono
tff(fact_4058_sum__product,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F3: fun(B,A),A3: set(B),G: fun(C,A),B4: set(C)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)),aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),B4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_ic(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F3),G),B4)),A3) ) ) ).

% sum_product
tff(fact_4059_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F3: fun(B,A),A3: set(B),R: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)),R) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_id(fun(B,A),fun(A,fun(B,A)),F3),R)),A3) ) ) ).

% sum_distrib_right
tff(fact_4060_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [R: A,F3: fun(B,A),A3: set(B)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),R),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_ie(A,fun(fun(B,A),fun(B,A)),R),F3)),A3) ) ) ).

% sum_distrib_left
tff(fact_4061_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),H: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_if(fun(B,A),fun(fun(B,A),fun(B,A)),G),H)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),A3)) ) ) ).

% sum.distrib
tff(fact_4062_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(B,A),G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_ig(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)) ) ) ).

% sum_subtractf
tff(fact_4063_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F3: fun(B,A),A3: set(B),R: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)),R) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_ih(fun(B,A),fun(A,fun(B,A)),F3),R)),A3) ) ) ).

% sum_divide_distrib
tff(fact_4064_sum__negf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_ii(fun(B,A),fun(B,A),F3)),A3) = aa(A,A,uminus_uminus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)) ) ) ).

% sum_negf
tff(fact_4065_sum__nonpos,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),zero_zero(B)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),zero_zero(B)) ) ) ).

% sum_nonpos
tff(fact_4066_sum__nonneg,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X4)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)) ) ) ).

% sum_nonneg
tff(fact_4067_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(nat),F3: fun(nat,A),G: fun(nat,A)] :
          ( ~ aa(set(nat),$o,member(nat,zero_zero(nat)),A3)
         => ( ! [X4: nat] :
                ( aa(set(nat),$o,member(nat,aa(nat,nat,suc,X4)),A3)
               => ( aa(nat,A,F3,aa(nat,nat,suc,X4)) = aa(nat,A,G,aa(nat,nat,suc,X4)) ) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),A3) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),A3) ) ) ) ) ).

% sum_cong_Suc
tff(fact_4068_Maclaurin__minus__cos__expansion,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real))
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),zero_zero(real))
            & ( cos(real,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ij(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)))),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
tff(fact_4069_Maclaurin__cos__expansion2,axiom,
    ! [X2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),X2)
            & ( cos(real,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ij(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)))),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ) ).

% Maclaurin_cos_expansion2
tff(fact_4070_Maclaurin__sin__expansion3,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),X2)
            & ( sin(real,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ik(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)))),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ) ).

% Maclaurin_sin_expansion3
tff(fact_4071_Maclaurin__sin__expansion4,axiom,
    ! [X2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => ? [T3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),X2)
          & ( sin(real,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ik(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)))),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ).

% Maclaurin_sin_expansion4
tff(fact_4072_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I3: A,K: A] :
          ( aa(set(A),$o,member(A,I3),aa(A,set(A),set_ord_lessThan(A),K))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),I3),K) ) ) ).

% lessThan_iff
tff(fact_4073_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(nat,A,G,Nb)) ) ) ).

% sum.lessThan_Suc
tff(fact_4074_sumr__cos__zero__one,axiom,
    ! [Nb: nat] : ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_il(nat,real)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,Nb))) = one_one(real) ) ).

% sumr_cos_zero_one
tff(fact_4075_lessThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [U: A] : ( aa(A,set(A),set_ord_lessThan(A),U) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_im(A,fun(A,$o),U)) ) ) ).

% lessThan_def
tff(fact_4076_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Ma: A,Nb: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),aa(A,set(A),set_ord_lessThan(A),Ma)),aa(A,set(A),set_ord_lessThan(A),Nb))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Ma),Nb) ) ) ).

% lessThan_strict_subset_iff
tff(fact_4077_lessThan__Suc__atMost,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,K)) = aa(nat,set(nat),set_ord_atMost(nat),K) ) ).

% lessThan_Suc_atMost
tff(fact_4078_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(A,set(A),set_ord_atMost(A),A2)),aa(A,set(A),set_ord_lessThan(A),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% Iic_subset_Iio_iff
tff(fact_4079_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_in(fun(nat,A),fun(nat,fun(nat,A)),G),Nb)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% sum.nat_diff_reindex
tff(fact_4080_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Q: fun(A,nat),P: fun(A,nat),Nb: A] :
          ( ! [X4: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,Q,X4)),aa(A,nat,P,X4))
         => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),P),aa(A,set(A),set_ord_lessThan(A),Nb))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),Q),aa(A,set(A),set_ord_lessThan(A),Nb))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_io(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Q),P)),aa(A,set(A),set_ord_lessThan(A),Nb)) ) ) ) ).

% sum_diff_distrib
tff(fact_4081_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [F3: fun(nat,A),Nb: nat,R: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),R)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ip(fun(nat,A),fun(A,fun(nat,A)),F3),R)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% sumr_diff_mult_const2
tff(fact_4082_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fq(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ).

% sum.lessThan_Suc_shift
tff(fact_4083_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(nat,A),Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_iq(fun(nat,A),fun(nat,A),F3)),aa(nat,set(nat),set_ord_lessThan(nat),Ma)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,Ma)),aa(nat,A,F3,zero_zero(nat))) ) ) ).

% sum_lessThan_telescope
tff(fact_4084_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(nat,A),Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fr(fun(nat,A),fun(nat,A),F3)),aa(nat,set(nat),set_ord_lessThan(nat),Ma)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,zero_zero(nat))),aa(nat,A,F3,Ma)) ) ) ).

% sum_lessThan_telescope'
tff(fact_4085_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),X2: A] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N))
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),N))),X2)
           => summable(A,F3) ) ) ) ).

% summableI_nonneg_bounded
tff(fact_4086_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),Nb: nat,S: A] :
          ( aa(A,$o,sums(A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),F3),Nb)),S)
        <=> aa(A,$o,sums(A,F3),aa(A,A,aa(A,fun(A,A),plus_plus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),Nb)))) ) ) ).

% sums_iff_shift
tff(fact_4087_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),S: A,Nb: nat] :
          ( aa(A,$o,sums(A,F3),S)
         => aa(A,$o,sums(A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),F3),Nb)),aa(A,A,aa(A,fun(A,A),minus_minus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),Nb)))) ) ) ).

% sums_split_initial_segment
tff(fact_4088_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),Nb: nat,S: A] :
          ( aa(A,$o,sums(A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),F3),Nb)),aa(A,A,aa(A,fun(A,A),minus_minus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),Nb))))
        <=> aa(A,$o,sums(A,F3),S) ) ) ).

% sums_iff_shift'
tff(fact_4089_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X2),Nb)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),one_one(A))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ).

% power_diff_1_eq
tff(fact_4090_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X2),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ).

% one_diff_power_eq
tff(fact_4091_geometric__sum,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X2: A,Nb: nat] :
          ( ( X2 != one_one(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X2),Nb)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),one_one(A))) ) ) ) ).

% geometric_sum
tff(fact_4092_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fq(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ).

% sum.atMost_shift
tff(fact_4093_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( summable(A,F3)
         => ( suminf(A,F3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),suminf(A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),F3),K))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),K))) ) ) ) ).

% suminf_split_initial_segment
tff(fact_4094_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( summable(A,F3)
         => ( suminf(A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),F3),K)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),K))) ) ) ) ).

% suminf_minus_initial_segment
tff(fact_4095_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),Nb: nat] :
          ( summable(A,F3)
         => ( ! [M3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),M3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,M3)) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),suminf(A,F3)) ) ) ) ).

% sum_less_suminf
tff(fact_4096_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X2: A,Nb: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))
          = $ite(X2 = one_one(A),aa(nat,A,semiring_1_of_nat(A),Nb),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X2),Nb))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2))) ) ) ).

% sum_gp_strict
tff(fact_4097_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Z: A,H: A,Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ir(A,fun(A,fun(nat,fun(nat,A))),Z),H),Ma)),aa(nat,set(nat),set_ord_lessThan(nat),Ma)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_is(A,fun(A,fun(nat,fun(nat,A))),Z),H),Ma)),aa(nat,set(nat),set_ord_lessThan(nat),Ma)) ) ) ).

% lemma_termdiff1
tff(fact_4098_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,Nb: nat,Y2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X2),aa(nat,nat,suc,Nb))),aa(nat,A,power_power(A,Y2),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_it(A,fun(nat,fun(A,fun(nat,A))),X2),Nb),Y2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,Nb)))) ) ) ).

% diff_power_eq_sum
tff(fact_4099_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,Nb: nat,Y2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X2),Nb)),aa(nat,A,power_power(A,Y2),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_iu(A,fun(nat,fun(A,fun(nat,A))),X2),Nb),Y2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ).

% power_diff_sumr2
tff(fact_4100_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: fun(nat,A),A2: A,Nb: nat] :
          ( ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),C2),A2)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = zero_zero(A) )
         => ~ ! [B3: fun(nat,A)] :
                ~ ! [Z3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z3),A2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),B3),Z3)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ) ).

% polyfun_linear_factor_root
tff(fact_4101_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: fun(nat,A),Nb: nat,A2: A] :
        ? [B3: fun(nat,A)] :
        ! [Z3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z3),A2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),B3),Z3)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),C2),A2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) ) ) ).

% polyfun_linear_factor
tff(fact_4102_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),Nb: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G)),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_iv(nat,fun(nat,fun(nat,$o)),Nb)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ia(fun(nat,fun(nat,A)),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% sum.triangle_reindex
tff(fact_4103_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Nb: nat,F3: fun(nat,A),K5: A,K: nat] :
          ( ! [P4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),P4),Nb)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,P4)),K5) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),K5)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),K5)) ) ) ) ).

% real_sum_nat_ivl_bounded2
tff(fact_4104_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),Nb: nat,I3: nat] :
          ( summable(A,F3)
         => ( ! [M3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),M3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,M3)) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),I3)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,I3))
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),suminf(A,F3)) ) ) ) ) ) ).

% sum_less_suminf2
tff(fact_4105_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X2: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X2),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_iw(A,fun(nat,fun(nat,A)),X2),Nb)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ).

% one_diff_power_eq'
tff(fact_4106_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [X2: real,Nb: nat,Diff: fun(nat,fun(A,real))] :
          ( ( X2 = zero_zero(real) )
         => ( ( Nb != zero_zero(nat) )
           => ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(A,real)),fun(nat,real),aTP_Lamp_ix(real,fun(fun(nat,fun(A,real)),fun(nat,real)),X2),Diff)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) = aa(A,real,aa(nat,fun(A,real),Diff,zero_zero(nat)),zero_zero(A)) ) ) ) ) ).

% Maclaurin_zero
tff(fact_4107_Maclaurin__lemma,axiom,
    ! [H: real,F3: fun(real,real),J2: fun(nat,real),Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ? [B8: real] : ( aa(real,real,F3,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,real),fun(nat,real),aTP_Lamp_iy(real,fun(fun(nat,real),fun(nat,real)),H),J2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),B8),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,H),Nb)),semiring_char_0_fact(real,Nb)))) ) ) ).

% Maclaurin_lemma
tff(fact_4108_sum__split__even__odd,axiom,
    ! [F3: fun(nat,real),G: fun(nat,real),Nb: nat] : ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,real),fun(nat,real),aTP_Lamp_iz(fun(nat,real),fun(fun(nat,real),fun(nat,real)),F3),G)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ja(fun(nat,real),fun(nat,real),F3)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_jb(fun(nat,real),fun(nat,real),G)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ).

% sum_split_even_odd
tff(fact_4109_Maclaurin__exp__le,axiom,
    ! [X2: real,Nb: nat] :
    ? [T3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2))
      & ( aa(real,real,exp(real),X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_jc(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,exp(real),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ).

% Maclaurin_exp_le
tff(fact_4110_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Nb: nat,A2: fun(nat,A),X2: A,Y2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Nb)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),A2),X2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),A2),Y2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_je(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Nb),A2),X2),Y2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ) ).

% polyfun_diff_alt
tff(fact_4111_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X2: A,K: nat] : ( aa(A,A,exp(A),X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_en(A,fun(nat,A),X2)),aa(nat,set(nat),set_ord_lessThan(nat),K))),suminf(A,aa(nat,fun(nat,A),aTP_Lamp_jf(A,fun(nat,fun(nat,A)),X2),K))) ) ) ).

% exp_first_terms
tff(fact_4112_Maclaurin__sin__bound,axiom,
    ! [X2: real,Nb: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),sin(real,X2)),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ik(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),X2)),Nb))) ).

% Maclaurin_sin_bound
tff(fact_4113_sum__pos__lt__pair,axiom,
    ! [F3: fun(nat,real),K: nat] :
      ( summable(real,F3)
     => ( ! [D3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))),D3)))),aa(nat,real,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))),D3)),one_one(nat))))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),F3),aa(nat,set(nat),set_ord_lessThan(nat),K))),suminf(real,F3)) ) ) ).

% sum_pos_lt_pair
tff(fact_4114_Maclaurin__exp__lt,axiom,
    ! [X2: real,Nb: nat] :
      ( ( X2 != zero_zero(real) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,abs_abs(real),T3))
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2))
            & ( aa(real,real,exp(real),X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_jc(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,exp(real),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ) ).

% Maclaurin_exp_lt
tff(fact_4115_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [H: A,Z: A,Nb: nat] :
          ( ( H != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H)),Nb)),aa(nat,A,power_power(A,Z),Nb))),H)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(nat,A,power_power(A,Z),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),times_times(A),H),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_jh(A,fun(A,fun(nat,fun(nat,A))),H),Z),Nb)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ) ).

% lemma_termdiff2
tff(fact_4116_Maclaurin__sin__expansion,axiom,
    ! [X2: real,Nb: nat] :
    ? [T3: real] : ( sin(real,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ik(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)))),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ).

% Maclaurin_sin_expansion
tff(fact_4117_Maclaurin__sin__expansion2,axiom,
    ! [X2: real,Nb: nat] :
    ? [T3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2))
      & ( sin(real,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ik(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)))),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ).

% Maclaurin_sin_expansion2
tff(fact_4118_Maclaurin__cos__expansion,axiom,
    ! [X2: real,Nb: nat] :
    ? [T3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2))
      & ( cos(real,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ij(real,fun(nat,real),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Nb))),pi)))),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ).

% Maclaurin_cos_expansion
tff(fact_4119_bij__betw__roots__unity,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => bij_betw(nat,complex,aTP_Lamp_ji(nat,fun(nat,complex),Nb),aa(nat,set(nat),set_ord_lessThan(nat),Nb),aa(fun(complex,$o),set(complex),collect(complex),aTP_Lamp_hx(nat,fun(complex,$o),Nb))) ) ).

% bij_betw_roots_unity
tff(fact_4120_sum__gp,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X2: A,Ma: nat,Nb: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),set_or1337092689740270186AtMost(nat,Ma,Nb))
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma),
              zero_zero(A),
              $ite(X2 = one_one(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat))),Ma)),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X2),Ma)),aa(nat,A,power_power(A,X2),aa(nat,nat,suc,Nb)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2))) ) ) ) ).

% sum_gp
tff(fact_4121_Frct__code__post_I5_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),aa(num,int,numeral_numeral(int),K))) = aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),one_one(rat)),aa(num,rat,numeral_numeral(rat),K)) ) ).

% Frct_code_post(5)
tff(fact_4122_rat__plus__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_jk(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_plus_code
tff(fact_4123_normalize__denom__zero,axiom,
    ! [P2: int] : ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),zero_zero(int))) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)) ) ).

% normalize_denom_zero
tff(fact_4124_normalize__negative,axiom,
    ! [Q2: int,P2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Q2),zero_zero(int))
     => ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2)) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),P2)),aa(int,int,uminus_uminus(int),Q2))) ) ) ).

% normalize_negative
tff(fact_4125_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,aa(nat,nat,suc,Nb)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Nb)),Ma),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb))),aa(nat,A,G,aa(nat,nat,suc,Nb)))) ) ) ).

% sum.cl_ivl_Suc
tff(fact_4126_sum_Oreindex__bij__betw,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [H: fun(A,B),S3: set(A),T4: set(B),G: fun(B,C)] :
          ( bij_betw(A,B,H,S3,T4)
         => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_jl(fun(A,B),fun(fun(B,C),fun(A,C)),H),G)),S3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),T4) ) ) ) ).

% sum.reindex_bij_betw
tff(fact_4127_ex__nat__less,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( ? [M4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),Nb)
          & aa(nat,$o,P,M4) )
    <=> ? [X3: nat] :
          ( aa(set(nat),$o,member(nat,X3),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))
          & aa(nat,$o,P,X3) ) ) ).

% ex_nat_less
tff(fact_4128_all__nat__less,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( ! [M4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),Nb)
         => aa(nat,$o,P,M4) )
    <=> ! [X3: nat] :
          ( aa(set(nat),$o,member(nat,X3),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))
         => aa(nat,$o,P,X3) ) ) ).

% all_nat_less
tff(fact_4129_atMost__atLeast0,axiom,
    ! [Nb: nat] : ( aa(nat,set(nat),set_ord_atMost(nat),Nb) = set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb) ) ).

% atMost_atLeast0
tff(fact_4130_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fq(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
tff(fact_4131_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,K: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_jm(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% sum.shift_bounds_cl_nat_ivl
tff(fact_4132_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
              | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2)
                & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2)
                  | aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) )
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2) ) ) ) ).

% atLeastatMost_psubset_iff
tff(fact_4133_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat,Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Nb,Ma)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_jn(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Nb),Ma)),set_or1337092689740270186AtMost(nat,Nb,Ma)) ) ) ).

% sum.atLeastAtMost_rev
tff(fact_4134_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( ( aa(nat,A,F3,zero_zero(nat)) = zero_zero(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,zero_zero(nat),K)) ) ) ) ).

% sum_shift_lb_Suc0_0
tff(fact_4135_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))),aa(nat,A,G,aa(nat,nat,suc,Nb))) ) ) ).

% sum.atLeast0_atMost_Suc
tff(fact_4136_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,Ma)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),Nb))) ) ) ) ).

% sum.atLeast_Suc_atMost
tff(fact_4137_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,suc,Nb))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,aa(nat,nat,suc,Nb))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb))) ) ) ) ).

% sum.nat_ivl_Suc'
tff(fact_4138_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb))),aa(nat,A,G,aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,Ma)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fq(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,Ma,Nb))) ) ) ) ).

% sum.Suc_reindex_ivl
tff(fact_4139_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Ma: nat,Nb: nat,F3: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,suc,Nb))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_iq(fun(nat,A),fun(nat,A),F3)),set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,aa(nat,nat,suc,Nb))),aa(nat,A,F3,Ma)) ) ) ) ).

% sum_Suc_diff
tff(fact_4140_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fq(fun(nat,A),fun(nat,A),G)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% sum.atLeast1_atMost_eq
tff(fact_4141_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),Mm: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fq(fun(nat,A),fun(nat,A),F3)),aa(nat,set(nat),set_ord_lessThan(nat),Mm)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,one_one(nat),Mm)) ) ) ).

% sum_bounds_lt_plus1
tff(fact_4142_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: fun(nat,fun(nat,A)),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_jo(fun(nat,fun(nat,A)),fun(nat,A),A2)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_jq(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),Nb)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% sum.nested_swap'
tff(fact_4143_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),A2: nat,B2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,A2,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_jr(fun(nat,A),fun(nat,fun(A,A)),F3),A2,B2,zero_zero(A)) ) ) ).

% sum_atLeastAtMost_code
tff(fact_4144_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A),P2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),P2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),P2)))) ) ) ) ).

% sum.ub_add_nat
tff(fact_4145_normalize__denom__pos,axiom,
    ! [R: product_prod(int,int),P2: int,Q2: int] :
      ( ( normalize(R) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q2) ) ).

% normalize_denom_pos
tff(fact_4146_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P2: int,R: int] :
      ( ( Q2 != zero_zero(int) )
     => ( ( S != zero_zero(int) )
       => ( ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2)) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),R),S)) )
         => ( aa(int,int,aa(int,fun(int,int),times_times(int),P2),S) = aa(int,int,aa(int,fun(int,int),times_times(int),R),Q2) ) ) ) ) ).

% normalize_crossproduct
tff(fact_4147_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(nat,set(nat),set_ord_atMost(nat),Ma))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)))) ) ) ).

% sum_up_index_split
tff(fact_4148_Frct__code__post_I1_J,axiom,
    ! [A2: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),A2)) = zero_zero(rat) ) ).

% Frct_code_post(1)
tff(fact_4149_Frct__code__post_I2_J,axiom,
    ! [A2: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A2),zero_zero(int))) = zero_zero(rat) ) ).

% Frct_code_post(2)
tff(fact_4150_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(nat,A),Ma: nat,Nb: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_js(fun(nat,A),fun(nat,A),F3)),set_or1337092689740270186AtMost(nat,Ma,Nb))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,Ma)),aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)))),zero_zero(A)) ) ) ).

% sum_natinterval_diff
tff(fact_4151_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Ma: nat,Nb: nat,F3: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_jt(fun(nat,A),fun(nat,A),F3)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),Nb)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,Nb)),aa(nat,A,F3,Ma)) ) ) ) ).

% sum_telescope''
tff(fact_4152_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Ma: nat,Nb: nat,X2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),Ma)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)))) ) ) ) ).

% sum_power_shift
tff(fact_4153_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),E2: real] :
          ( summable(A,F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
           => ~ ! [N7: nat] :
                  ~ ! [M: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),M)
                     => ! [N8: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,M,N8)))),E2) ) ) ) ) ).

% summable_partial_sum_bound
tff(fact_4154_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Ma: nat,Nb: nat,X2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),set_or1337092689740270186AtMost(nat,Ma,Nb))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,X2),Ma)),aa(nat,A,power_power(A,X2),aa(nat,nat,suc,Nb))) ) ) ) ).

% sum_gp_multiplied
tff(fact_4155_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gf(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% sum.in_pairs
tff(fact_4156_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),Nb: nat,K: A] :
          ( ! [X3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fs(fun(nat,A),fun(A,fun(nat,A)),C2),X3)),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = K )
        <=> ( ( aa(nat,A,C2,zero_zero(nat)) = K )
            & ! [X3: nat] :
                ( aa(set(nat),$o,member(nat,X3),set_or1337092689740270186AtMost(nat,one_one(nat),Nb))
               => ( aa(nat,A,C2,X3) = zero_zero(A) ) ) ) ) ) ).

% polyfun_eq_const
tff(fact_4157_Frct__code__post_I4_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),one_one(int))) = aa(num,rat,numeral_numeral(rat),K) ) ).

% Frct_code_post(4)
tff(fact_4158_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),aa(num,int,numeral_numeral(int),L))) = aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),aa(num,rat,numeral_numeral(rat),K)),aa(num,rat,numeral_numeral(rat),L)) ) ).

% Frct_code_post(6)
tff(fact_4159_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ju(nat,fun(nat,A),K)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))) ) ) ).

% gbinomial_sum_up_index
tff(fact_4160_gauss__sum__nat,axiom,
    ! [Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_jv(nat,nat)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,suc,Nb))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% gauss_sum_nat
tff(fact_4161_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),one_one(A))) ) ) ).

% double_gauss_sum
tff(fact_4162_double__arith__series,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,D2: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_jw(A,fun(A,fun(nat,A)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),D2))) ) ) ).

% double_arith_series
tff(fact_4163_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_jx(nat,fun(nat,fun(nat,nat)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Nb)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),D2)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% arith_series_nat
tff(fact_4164_Sum__Icc__nat,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_jv(nat,nat)),set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),one_one(nat))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Sum_Icc_nat
tff(fact_4165_rat__minus__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_jz(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_minus_code
tff(fact_4166_rat__times__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_kb(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_times_code
tff(fact_4167_gauss__sum,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),one_one(A)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum
tff(fact_4168_arith__series,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,D2: A,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_kc(A,fun(A,fun(nat,A)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),D2)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% arith_series
tff(fact_4169_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),one_one(A))) ) ) ).

% double_gauss_sum_from_Suc_0
tff(fact_4170_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X2: A,Ma: nat,Nb: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),power_power(A,X2)),set_or1337092689740270186AtMost(nat,Ma,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)))
          = $ite(X2 = one_one(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),Ma)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,X2),aa(nat,nat,suc,Nb))))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X2))) ) ) ).

% sum_gp_offset
tff(fact_4171_rat__divide__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_ke(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_divide_code
tff(fact_4172_polyfun__diff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Nb: nat,A2: fun(nat,A),X2: A,Y2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Nb)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),A2),X2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),A2),Y2)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_kg(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Nb),A2),X2),Y2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ) ).

% polyfun_diff
tff(fact_4173_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Nb)),one_one(A)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum_from_Suc_0
tff(fact_4174_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [R: A,Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_he(A,fun(nat,A),R)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Ma)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Ma))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,gbinomial(A,R),aa(nat,nat,suc,Ma))) ) ) ).

% gchoose_row_sum_weighted
tff(fact_4175_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,aa(nat,nat,suc,Nb))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,nat,suc,Nb))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_kh(A,fun(nat,A),Z),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),one_one(nat)))) ) ) ).

% pochhammer_times_pochhammer_half
tff(fact_4176_Sum__Icc__int,axiom,
    ! [Ma: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Ma),Nb)
     => ( aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7311177749621191930dd_sum(int,int),aTP_Lamp_ki(int,int)),set_or1337092689740270186AtMost(int,Ma,Nb)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Nb),aa(int,int,aa(int,fun(int,int),plus_plus(int),Nb),one_one(int)))),aa(int,int,aa(int,fun(int,int),times_times(int),Ma),aa(int,int,aa(int,fun(int,int),minus_minus(int),Ma),one_one(int))))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ) ).

% Sum_Icc_int
tff(fact_4177_Suc__0__xor__eq,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),Nb) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) ) ).

% Suc_0_xor_eq
tff(fact_4178_xor__Suc__0__eq,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),Nb),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) ) ).

% xor_Suc_0_eq
tff(fact_4179_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),Y2)) = Y2 ) ) ).

% bit.xor_left_self
tff(fact_4180_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),zero_zero(A)) = A2 ) ) ).

% xor.right_neutral
tff(fact_4181_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),zero_zero(A)),A2) = A2 ) ) ).

% xor.left_neutral
tff(fact_4182_xor__self__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),A2) = zero_zero(A) ) ) ).

% xor_self_eq
tff(fact_4183_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),X2) = zero_zero(A) ) ) ).

% bit.xor_self
tff(fact_4184_take__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),B2)) ) ) ).

% take_bit_xor
tff(fact_4185_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B)] : ( groups7121269368397514597t_prod(B,A,aTP_Lamp_kj(B,A),A3) = one_one(A) ) ) ).

% prod.neutral_const
tff(fact_4186_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F3: fun(B,nat),A3: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(B,nat,F3,A3)) = groups7121269368397514597t_prod(B,A,aTP_Lamp_kk(fun(B,nat),fun(B,A),F3),A3) ) ) ).

% of_nat_prod
tff(fact_4187_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [F3: fun(B,int),A3: set(B)] : ( ring_1_of_int(A,groups7121269368397514597t_prod(B,int,F3,A3)) = groups7121269368397514597t_prod(B,A,aTP_Lamp_kl(fun(B,int),fun(B,A),F3),A3) ) ) ).

% of_int_prod
tff(fact_4188_of__real__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2191834092415804123ebra_1(A) )
     => ! [F3: fun(B,real),S: set(B)] : ( aa(real,A,real_Vector_of_real(A),groups7121269368397514597t_prod(B,real,F3,S)) = groups7121269368397514597t_prod(B,A,aTP_Lamp_km(fun(B,real),fun(B,A),F3),S) ) ) ).

% of_real_prod
tff(fact_4189_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(nat,A,G,Nb)) ) ) ).

% prod.lessThan_Suc
tff(fact_4190_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_atMost(nat),Nb))),aa(nat,A,G,aa(nat,nat,suc,Nb))) ) ) ).

% prod.atMost_Suc
tff(fact_4191_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2))) ) ) ).

% xor_numerals(3)
tff(fact_4192_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2)) ) ) ).

% xor_numerals(1)
tff(fact_4193_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2)) ) ) ).

% xor_numerals(2)
tff(fact_4194_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2)) ) ) ).

% xor_numerals(5)
tff(fact_4195_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2)) ) ) ).

% xor_numerals(8)
tff(fact_4196_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2))) ) ) ).

% xor_numerals(7)
tff(fact_4197_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] :
          ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,aa(nat,nat,suc,Nb)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Nb)),Ma),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb))),aa(nat,A,G,aa(nat,nat,suc,Nb)))) ) ) ).

% prod.cl_ivl_Suc
tff(fact_4198_xor__nat__numerals_I4_J,axiom,
    ! [X2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X2))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,X2)) ) ).

% xor_nat_numerals(4)
tff(fact_4199_xor__nat__numerals_I3_J,axiom,
    ! [X2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,X2))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X2)) ) ).

% xor_nat_numerals(3)
tff(fact_4200_xor__nat__numerals_I2_J,axiom,
    ! [Y2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y2))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Y2)) ) ).

% xor_nat_numerals(2)
tff(fact_4201_xor__nat__numerals_I1_J,axiom,
    ! [Y2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Y2))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y2)) ) ).

% xor_nat_numerals(1)
tff(fact_4202_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2)))) ) ) ).

% xor_numerals(4)
tff(fact_4203_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2)))) ) ) ).

% xor_numerals(6)
tff(fact_4204_prod_Oreindex__bij__betw,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [H: fun(A,B),S3: set(A),T4: set(B),G: fun(B,C)] :
          ( bij_betw(A,B,H,S3,T4)
         => ( groups7121269368397514597t_prod(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_kn(fun(A,B),fun(fun(B,C),fun(A,C)),H),G),S3) = groups7121269368397514597t_prod(B,C,G,T4) ) ) ) ).

% prod.reindex_bij_betw
tff(fact_4205_abs__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_field(A)
     => ! [F3: fun(B,A),A3: set(B)] : ( aa(A,A,abs_abs(A),groups7121269368397514597t_prod(B,A,F3,A3)) = groups7121269368397514597t_prod(B,A,aTP_Lamp_ko(fun(B,A),fun(B,A),F3),A3) ) ) ).

% abs_prod
tff(fact_4206_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F3: fun(B,A),G: fun(B,A),A3: set(B)] : ( groups7121269368397514597t_prod(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kp(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),groups7121269368397514597t_prod(B,A,F3,A3)),groups7121269368397514597t_prod(B,A,G,A3)) ) ) ).

% prod_dividef
tff(fact_4207_prod__power__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F3: fun(B,A),A3: set(B),Nb: nat] : ( aa(nat,A,power_power(A,groups7121269368397514597t_prod(B,A,F3,A3)),Nb) = groups7121269368397514597t_prod(B,A,aa(nat,fun(B,A),aTP_Lamp_kq(fun(B,A),fun(nat,fun(B,A)),F3),Nb),A3) ) ) ).

% prod_power_distrib
tff(fact_4208_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),H: fun(B,A),A3: set(B)] : ( groups7121269368397514597t_prod(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kr(fun(B,A),fun(fun(B,A),fun(B,A)),G),H),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(B,A,G,A3)),groups7121269368397514597t_prod(B,A,H,A3)) ) ) ).

% prod.distrib
tff(fact_4209_prod_Oswap,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,fun(C,A)),B4: set(C),A3: set(B)] : ( groups7121269368397514597t_prod(B,A,aa(set(C),fun(B,A),aTP_Lamp_ks(fun(B,fun(C,A)),fun(set(C),fun(B,A)),G),B4),A3) = groups7121269368397514597t_prod(C,A,aa(set(B),fun(C,A),aTP_Lamp_ku(fun(B,fun(C,A)),fun(set(B),fun(C,A)),G),A3),B4) ) ) ).

% prod.swap
tff(fact_4210_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% of_nat_xor_eq
tff(fact_4211_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [F3: fun(B,A),A2: A,A3: set(B)] : ( modulo_modulo(A,groups7121269368397514597t_prod(B,A,aa(A,fun(B,A),aTP_Lamp_fm(fun(B,A),fun(A,fun(B,A)),F3),A2),A3),A2) = modulo_modulo(A,groups7121269368397514597t_prod(B,A,F3,A3),A2) ) ) ).

% mod_prod_eq
tff(fact_4212_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),ring_1_of_int(A,K)),ring_1_of_int(A,L)) ) ) ).

% of_int_xor_eq
tff(fact_4213_prod__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & comm_semiring_1(B) )
     => ! [F3: fun(A,B),A3: set(A)] : ( groups7121269368397514597t_prod(A,real,aTP_Lamp_kv(fun(A,B),fun(A,real),F3),A3) = real_V7770717601297561774m_norm(B,groups7121269368397514597t_prod(A,B,F3,A3)) ) ) ).

% prod_norm
tff(fact_4214_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),C2)) ) ) ).

% xor.assoc
tff(fact_4215_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),A2) ) ) ).

% xor.commute
tff(fact_4216_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),C2)) ) ) ).

% xor.left_commute
tff(fact_4217_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)),Nb)
        <=> ~ ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
            <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),Nb) ) ) ) ).

% bit_xor_iff
tff(fact_4218_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y2: A,Z: A,X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Y2),Z)),X2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y2),X2)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Z),X2)) ) ) ).

% bit.conj_xor_distrib2
tff(fact_4219_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Y2),Z)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),Z)) ) ) ).

% bit.conj_xor_distrib
tff(fact_4220_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [F3: fun(B,A),A3: set(B)] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,groups7121269368397514597t_prod(B,A,F3,A3))),groups7121269368397514597t_prod(B,real,aTP_Lamp_kw(fun(B,A),fun(B,real),F3),A3)) ) ).

% norm_prod_le
tff(fact_4221_prod__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),aa(A,B,G,I2)) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),groups7121269368397514597t_prod(A,B,F3,A3)),groups7121269368397514597t_prod(A,B,G,A3)) ) ) ).

% prod_mono
tff(fact_4222_prod__nonneg,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X4)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),groups7121269368397514597t_prod(A,B,F3,A3)) ) ) ).

% prod_nonneg
tff(fact_4223_prod__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F3,X4)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),groups7121269368397514597t_prod(A,B,F3,A3)) ) ) ).

% prod_pos
tff(fact_4224_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_kx(fun(nat,A),fun(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
tff(fact_4225_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C2: A,F3: fun(B,nat),A3: set(B)] : ( aa(nat,A,power_power(A,C2),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F3),A3)) = groups7121269368397514597t_prod(B,A,aa(fun(B,nat),fun(B,A),aTP_Lamp_ky(A,fun(fun(B,nat),fun(B,A)),C2),F3),A3) ) ) ).

% power_sum
tff(fact_4226_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,K: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K))) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_kz(fun(nat,A),fun(nat,fun(nat,A)),G),K),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% prod.shift_bounds_cl_nat_ivl
tff(fact_4227_prod__le__1,axiom,
    ! [A: $tType,B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X4))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),one_one(B)) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),groups7121269368397514597t_prod(A,B,F3,A3)),one_one(B)) ) ) ).

% prod_le_1
tff(fact_4228_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_la(fun(nat,A),fun(nat,fun(nat,A)),G),Nb),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) = groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% prod.nat_diff_reindex
tff(fact_4229_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat,Ma: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Nb,Ma)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_lb(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Nb),Ma),set_or1337092689740270186AtMost(nat,Nb,Ma)) ) ) ).

% prod.atLeastAtMost_rev
tff(fact_4230_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))),aa(nat,A,G,aa(nat,nat,suc,Nb))) ) ) ).

% prod.atLeast0_atMost_Suc
tff(fact_4231_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,Ma)),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),Nb))) ) ) ) ).

% prod.atLeast_Suc_atMost
tff(fact_4232_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,suc,Nb))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,aa(nat,nat,suc,Nb))),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb))) ) ) ) ).

% prod.nat_ivl_Suc'
tff(fact_4233_even__xor__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_xor_iff
tff(fact_4234_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aTP_Lamp_kx(fun(nat,A),fun(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ).

% prod.lessThan_Suc_shift
tff(fact_4235_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb))),aa(nat,A,G,aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,Ma)),groups7121269368397514597t_prod(nat,A,aTP_Lamp_kx(fun(nat,A),fun(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb))) ) ) ) ).

% prod.Suc_reindex_ivl
tff(fact_4236_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aTP_Lamp_kx(fun(nat,A),fun(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),Nb))) ) ) ).

% prod.atMost_Suc_shift
tff(fact_4237_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Nb)) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_kx(fun(nat,A),fun(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% prod.atLeast1_atMost_eq
tff(fact_4238_fact__prod,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] : ( semiring_char_0_fact(A,Nb) = aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(nat,nat,aTP_Lamp_jv(nat,nat),set_or1337092689740270186AtMost(nat,one_one(nat),Nb))) ) ) ).

% fact_prod
tff(fact_4239_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: fun(nat,fun(nat,A)),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,aTP_Lamp_lc(fun(nat,fun(nat,A)),fun(nat,A),A2),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_le(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),Nb),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% prod.nested_swap'
tff(fact_4240_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [F3: fun(nat,A),A2: nat,B2: nat] : ( groups7121269368397514597t_prod(nat,A,F3,set_or1337092689740270186AtMost(nat,A2,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_lf(fun(nat,A),fun(nat,fun(A,A)),F3),A2,B2,one_one(A)) ) ) ).

% prod_atLeastAtMost_code
tff(fact_4241_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A),P2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)))
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),P2))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb))),groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),P2)))) ) ) ) ).

% prod.ub_add_nat
tff(fact_4242_periodic__finite__ex,axiom,
    ! [D2: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X4: int,K2: int] :
            ( aa(int,$o,P,X4)
          <=> aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2))) )
       => ( ? [X_12: int] : aa(int,$o,P,X_12)
        <=> ? [X3: int] :
              ( aa(set(int),$o,member(int,X3),set_or1337092689740270186AtMost(int,one_one(int),D2))
              & aa(int,$o,P,X3) ) ) ) ) ).

% periodic_finite_ex
tff(fact_4243_bset_I3_J,axiom,
    ! [D4: int,T2: int,B4: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( aa(set(int),$o,member(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),T2),one_one(int))),B4)
       => ! [X: int] :
            ( ! [Xa4: int] :
                ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
               => ! [Xb2: int] :
                    ( aa(set(int),$o,member(int,Xb2),B4)
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa4) ) ) )
           => ( ( X = T2 )
             => ( aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4) = T2 ) ) ) ) ) ).

% bset(3)
tff(fact_4244_bset_I4_J,axiom,
    ! [D4: int,T2: int,B4: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( aa(set(int),$o,member(int,T2),B4)
       => ! [X: int] :
            ( ! [Xa4: int] :
                ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
               => ! [Xb2: int] :
                    ( aa(set(int),$o,member(int,Xb2),B4)
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa4) ) ) )
           => ( ( X != T2 )
             => ( aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4) != T2 ) ) ) ) ) ).

% bset(4)
tff(fact_4245_bset_I5_J,axiom,
    ! [D4: int,B4: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ! [X: int] :
          ( ! [Xa4: int] :
              ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
             => ! [Xb2: int] :
                  ( aa(set(int),$o,member(int,Xb2),B4)
                 => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),T2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4)),T2) ) ) ) ).

% bset(5)
tff(fact_4246_bset_I7_J,axiom,
    ! [D4: int,T2: int,B4: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( aa(set(int),$o,member(int,T2),B4)
       => ! [X: int] :
            ( ! [Xa4: int] :
                ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
               => ! [Xb2: int] :
                    ( aa(set(int),$o,member(int,Xb2),B4)
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa4) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),X)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4)) ) ) ) ) ).

% bset(7)
tff(fact_4247_aset_I3_J,axiom,
    ! [D4: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( aa(set(int),$o,member(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),T2),one_one(int))),A3)
       => ! [X: int] :
            ( ! [Xa4: int] :
                ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
               => ! [Xb2: int] :
                    ( aa(set(int),$o,member(int,Xb2),A3)
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa4) ) ) )
           => ( ( X = T2 )
             => ( aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4) = T2 ) ) ) ) ) ).

% aset(3)
tff(fact_4248_aset_I4_J,axiom,
    ! [D4: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( aa(set(int),$o,member(int,T2),A3)
       => ! [X: int] :
            ( ! [Xa4: int] :
                ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
               => ! [Xb2: int] :
                    ( aa(set(int),$o,member(int,Xb2),A3)
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa4) ) ) )
           => ( ( X != T2 )
             => ( aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4) != T2 ) ) ) ) ) ).

% aset(4)
tff(fact_4249_aset_I5_J,axiom,
    ! [D4: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( aa(set(int),$o,member(int,T2),A3)
       => ! [X: int] :
            ( ! [Xa4: int] :
                ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
               => ! [Xb2: int] :
                    ( aa(set(int),$o,member(int,Xb2),A3)
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa4) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),T2)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4)),T2) ) ) ) ) ).

% aset(5)
tff(fact_4250_aset_I7_J,axiom,
    ! [D4: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ! [X: int] :
          ( ! [Xa4: int] :
              ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
             => ! [Xb2: int] :
                  ( aa(set(int),$o,member(int,Xb2),A3)
                 => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),X)
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4)) ) ) ) ).

% aset(7)
tff(fact_4251_norm__prod__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [I5: set(A),Z: fun(A,B),W: fun(A,B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,Z,I2))),one_one(real)) )
         => ( ! [I2: A] :
                ( aa(set(A),$o,member(A,I2),I5)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,W,I2))),one_one(real)) )
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),groups7121269368397514597t_prod(A,B,Z,I5)),groups7121269368397514597t_prod(A,B,W,I5)))),aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aa(fun(A,B),fun(A,real),aTP_Lamp_lg(fun(A,B),fun(fun(A,B),fun(A,real)),Z),W)),I5)) ) ) ) ).

% norm_prod_diff
tff(fact_4252_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_atMost(nat),Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aTP_Lamp_kx(fun(nat,A),fun(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ) ).

% prod.atMost_shift
tff(fact_4253_fact__eq__fact__times,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
     => ( semiring_char_0_fact(nat,Ma) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,Nb)),groups7121269368397514597t_prod(nat,nat,aTP_Lamp_jv(nat,nat),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Nb),Ma))) ) ) ).

% fact_eq_fact_times
tff(fact_4254_bset_I6_J,axiom,
    ! [D4: int,B4: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ! [X: int] :
          ( ! [Xa4: int] :
              ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
             => ! [Xb2: int] :
                  ( aa(set(int),$o,member(int,Xb2),B4)
                 => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),T2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4)),T2) ) ) ) ).

% bset(6)
tff(fact_4255_bset_I8_J,axiom,
    ! [D4: int,T2: int,B4: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( aa(set(int),$o,member(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),T2),one_one(int))),B4)
       => ! [X: int] :
            ( ! [Xa4: int] :
                ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
               => ! [Xb2: int] :
                    ( aa(set(int),$o,member(int,Xb2),B4)
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa4) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),X)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D4)) ) ) ) ) ).

% bset(8)
tff(fact_4256_aset_I6_J,axiom,
    ! [D4: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( aa(set(int),$o,member(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),T2),one_one(int))),A3)
       => ! [X: int] :
            ( ! [Xa4: int] :
                ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
               => ! [Xb2: int] :
                    ( aa(set(int),$o,member(int,Xb2),A3)
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa4) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),T2)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4)),T2) ) ) ) ) ).

% aset(6)
tff(fact_4257_aset_I8_J,axiom,
    ! [D4: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ! [X: int] :
          ( ! [Xa4: int] :
              ( aa(set(int),$o,member(int,Xa4),set_or1337092689740270186AtMost(int,one_one(int),D4))
             => ! [Xb2: int] :
                  ( aa(set(int),$o,member(int,Xb2),A3)
                 => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),X)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D4)) ) ) ) ).

% aset(8)
tff(fact_4258_cppi,axiom,
    ! [D4: int,P: fun(int,$o),P3: fun(int,$o),A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( ? [Z3: int] :
          ! [X4: int] :
            ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z3),X4)
           => ( aa(int,$o,P,X4)
            <=> aa(int,$o,P3,X4) ) )
       => ( ! [X4: int] :
              ( ! [Xa3: int] :
                  ( aa(set(int),$o,member(int,Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4))
                 => ! [Xb3: int] :
                      ( aa(set(int),$o,member(int,Xb3),A3)
                     => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
             => ( aa(int,$o,P,X4)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D4)) ) )
         => ( ! [X4: int,K2: int] :
                ( aa(int,$o,P3,X4)
              <=> aa(int,$o,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D4))) )
           => ( ? [X_12: int] : aa(int,$o,P,X_12)
            <=> ( ? [X3: int] :
                    ( aa(set(int),$o,member(int,X3),set_or1337092689740270186AtMost(int,one_one(int),D4))
                    & aa(int,$o,P3,X3) )
                | ? [X3: int] :
                    ( aa(set(int),$o,member(int,X3),set_or1337092689740270186AtMost(int,one_one(int),D4))
                    & ? [Xa: int] :
                        ( aa(set(int),$o,member(int,Xa),A3)
                        & aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa),X3)) ) ) ) ) ) ) ) ) ).

% cppi
tff(fact_4259_cpmi,axiom,
    ! [D4: int,P: fun(int,$o),P3: fun(int,$o),B4: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D4)
     => ( ? [Z3: int] :
          ! [X4: int] :
            ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X4),Z3)
           => ( aa(int,$o,P,X4)
            <=> aa(int,$o,P3,X4) ) )
       => ( ! [X4: int] :
              ( ! [Xa3: int] :
                  ( aa(set(int),$o,member(int,Xa3),set_or1337092689740270186AtMost(int,one_one(int),D4))
                 => ! [Xb3: int] :
                      ( aa(set(int),$o,member(int,Xb3),B4)
                     => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
             => ( aa(int,$o,P,X4)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D4)) ) )
         => ( ! [X4: int,K2: int] :
                ( aa(int,$o,P3,X4)
              <=> aa(int,$o,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D4))) )
           => ( ? [X_12: int] : aa(int,$o,P,X_12)
            <=> ( ? [X3: int] :
                    ( aa(set(int),$o,member(int,X3),set_or1337092689740270186AtMost(int,one_one(int),D4))
                    & aa(int,$o,P3,X3) )
                | ? [X3: int] :
                    ( aa(set(int),$o,member(int,X3),set_or1337092689740270186AtMost(int,one_one(int),D4))
                    & ? [Xa: int] :
                        ( aa(set(int),$o,member(int,Xa),B4)
                        & aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa),X3)) ) ) ) ) ) ) ) ) ).

% cpmi
tff(fact_4260_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,Nb)) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_lh(A,fun(nat,A),A2),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) ) ) ).

% pochhammer_Suc_prod
tff(fact_4261_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,A2,Nb) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_li(A,fun(nat,fun(nat,A)),A2),Nb),set_or1337092689740270186AtMost(nat,one_one(nat),Nb)) ) ) ).

% pochhammer_prod_rev
tff(fact_4262_fact__div__fact,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,Ma)),semiring_char_0_fact(nat,Nb)) = groups7121269368397514597t_prod(nat,nat,aTP_Lamp_jv(nat,nat),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)),Ma)) ) ) ).

% fact_div_fact
tff(fact_4263_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_lj(fun(nat,A),fun(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% prod.in_pairs
tff(fact_4264_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_lj(fun(nat,A),fun(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ) ).

% prod.in_pairs_0
tff(fact_4265_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,Nb)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_li(A,fun(nat,fun(nat,A)),A2),Nb),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) ) ) ).

% pochhammer_Suc_prod_rev
tff(fact_4266_xor__nat__unfold,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),Ma),Nb)
      = $ite(
          Ma = zero_zero(nat),
          Nb,
          $ite(Nb = zero_zero(nat),Ma,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ) ) ).

% xor_nat_unfold
tff(fact_4267_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P2: nat,K: nat,G: fun(nat,A),H: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P2)
           => ( groups7121269368397514597t_prod(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_lk(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H),aa(nat,set(nat),set_ord_atMost(nat),P2)) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_ll(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P2),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% prod.zero_middle
tff(fact_4268_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),groups7121269368397514597t_prod(nat,A,aTP_Lamp_lm(A,fun(nat,A),A2),set_or1337092689740270186AtMost(nat,zero_zero(nat),K))),semiring_char_0_fact(A,aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc
tff(fact_4269_xor__nat__rec,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),Ma),Nb)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma) )
             != ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) ) ))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% xor_nat_rec
tff(fact_4270_xor__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),one_one(A)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)))),aa($o,A,zero_neq_one_of_bool(A),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))) ) ) ).

% xor_one_eq
tff(fact_4271_one__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)))),aa($o,A,zero_neq_one_of_bool(A),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))) ) ) ).

% one_xor_eq
tff(fact_4272_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,Nb: nat] :
      ( ( C2 != zero_zero(complex) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => bij_betw(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),aa(real,real,root(Nb),real_V7770717601297561774m_norm(complex,C2)))),cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),arg(C2)),aa(nat,real,semiring_1_of_nat(real),Nb))))),aa(fun(complex,$o),set(complex),collect(complex),aTP_Lamp_hx(nat,fun(complex,$o),Nb)),aa(fun(complex,$o),set(complex),collect(complex),aa(nat,fun(complex,$o),aTP_Lamp_ln(complex,fun(nat,fun(complex,$o)),C2),Nb))) ) ) ).

% bij_betw_nth_root_unity
tff(fact_4273_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list($o)] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),groups4207007520872428315er_sum($o,int,zero_neq_one_of_bool(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Bs)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(list($o),nat,size_size(list($o)),Bs))) ).

% horner_sum_of_bool_2_less
tff(fact_4274_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: num] : ( bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),Nb),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),Nb))) ) ) ).

% push_bit_numeral_minus_1
tff(fact_4275_set__encode__def,axiom,
    nat_set_encode = aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ).

% set_encode_def
tff(fact_4276_push__bit__nonnegative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se4730199178511100633sh_bit(int,Nb,K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% push_bit_nonnegative_int_iff
tff(fact_4277_push__bit__negative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se4730199178511100633sh_bit(int,Nb,K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% push_bit_negative_int_iff
tff(fact_4278_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( bit_se4730199178511100633sh_bit(A,Nb,zero_zero(A)) = zero_zero(A) ) ) ).

% push_bit_of_0
tff(fact_4279_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit(A,Nb,A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% push_bit_eq_0_iff
tff(fact_4280_real__root__zero,axiom,
    ! [Nb: nat] : ( aa(real,real,root(Nb),zero_zero(real)) = zero_zero(real) ) ).

% real_root_zero
tff(fact_4281_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] : ( bit_se4730199178511100633sh_bit(A,Ma,bit_se4730199178511100633sh_bit(A,Nb,A2)) = bit_se4730199178511100633sh_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb),A2) ) ) ).

% push_bit_push_bit
tff(fact_4282_push__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se4730199178511100633sh_bit(A,Nb,A2)),bit_se4730199178511100633sh_bit(A,Nb,B2)) ) ) ).

% push_bit_and
tff(fact_4283_push__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),bit_se4730199178511100633sh_bit(A,Nb,A2)),bit_se4730199178511100633sh_bit(A,Nb,B2)) ) ) ).

% push_bit_xor
tff(fact_4284_concat__bit__of__zero__1,axiom,
    ! [Nb: nat,L: int] : ( aa(int,int,bit_concat_bit(Nb,zero_zero(int)),L) = bit_se4730199178511100633sh_bit(int,Nb,L) ) ).

% concat_bit_of_zero_1
tff(fact_4285_real__root__Suc__0,axiom,
    ! [X2: real] : ( aa(real,real,root(aa(nat,nat,suc,zero_zero(nat))),X2) = X2 ) ).

% real_root_Suc_0
tff(fact_4286_root__0,axiom,
    ! [X2: real] : ( aa(real,real,root(zero_zero(nat)),X2) = zero_zero(real) ) ).

% root_0
tff(fact_4287_real__root__eq__iff,axiom,
    ! [Nb: nat,X2: real,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( ( aa(real,real,root(Nb),X2) = aa(real,real,root(Nb),Y2) )
      <=> ( X2 = Y2 ) ) ) ).

% real_root_eq_iff
tff(fact_4288_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% xor_nonnegative_int_iff
tff(fact_4289_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)),zero_zero(int))
    <=> ~ ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% xor_negative_int_iff
tff(fact_4290_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,K: num] : ( bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,Nb),aa(num,A,numeral_numeral(A),K)) = bit_se4730199178511100633sh_bit(A,Nb,aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) ) ) ).

% push_bit_Suc_numeral
tff(fact_4291_real__root__eq__0__iff,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( ( aa(real,real,root(Nb),X2) = zero_zero(real) )
      <=> ( X2 = zero_zero(real) ) ) ) ).

% real_root_eq_0_iff
tff(fact_4292_real__root__less__iff,axiom,
    ! [Nb: nat,X2: real,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Nb),X2)),aa(real,real,root(Nb),Y2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2) ) ) ).

% real_root_less_iff
tff(fact_4293_real__root__le__iff,axiom,
    ! [Nb: nat,X2: real,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Nb),X2)),aa(real,real,root(Nb),Y2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2) ) ) ).

% real_root_le_iff
tff(fact_4294_real__root__eq__1__iff,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( ( aa(real,real,root(Nb),X2) = one_one(real) )
      <=> ( X2 = one_one(real) ) ) ) ).

% real_root_eq_1_iff
tff(fact_4295_real__root__one,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,real,root(Nb),one_one(real)) = one_one(real) ) ) ).

% real_root_one
tff(fact_4296_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,K: num] : ( bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,Nb),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K)))) ) ) ).

% push_bit_Suc_minus_numeral
tff(fact_4297_real__root__lt__0__iff,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Nb),X2)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real)) ) ) ).

% real_root_lt_0_iff
tff(fact_4298_real__root__gt__0__iff,axiom,
    ! [Nb: nat,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,root(Nb),Y2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y2) ) ) ).

% real_root_gt_0_iff
tff(fact_4299_real__root__le__0__iff,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Nb),X2)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),zero_zero(real)) ) ) ).

% real_root_le_0_iff
tff(fact_4300_real__root__ge__0__iff,axiom,
    ! [Nb: nat,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(Nb),Y2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2) ) ) ).

% real_root_ge_0_iff
tff(fact_4301_real__root__lt__1__iff,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Nb),X2)),one_one(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real)) ) ) ).

% real_root_lt_1_iff
tff(fact_4302_real__root__gt__1__iff,axiom,
    ! [Nb: nat,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,root(Nb),Y2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Y2) ) ) ).

% real_root_gt_1_iff
tff(fact_4303_real__root__ge__1__iff,axiom,
    ! [Nb: nat,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,root(Nb),Y2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Y2) ) ) ).

% real_root_ge_1_iff
tff(fact_4304_real__root__le__1__iff,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Nb),X2)),one_one(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real)) ) ) ).

% real_root_le_1_iff
tff(fact_4305_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [L: num,K: num] : ( bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),L),aa(num,A,numeral_numeral(A),K)) = bit_se4730199178511100633sh_bit(A,pred_numeral(L),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) ) ) ).

% push_bit_numeral
tff(fact_4306_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,Nb),A2) = bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% push_bit_Suc
tff(fact_4307_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( bit_se4730199178511100633sh_bit(A,Nb,one_one(A)) = aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) ) ) ).

% push_bit_of_1
tff(fact_4308_push__bit__of__Suc__0,axiom,
    ! [Nb: nat] : ( bit_se4730199178511100633sh_bit(nat,Nb,aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb) ) ).

% push_bit_of_Suc_0
tff(fact_4309_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se4730199178511100633sh_bit(A,Nb,A2))
        <=> ( ( Nb != zero_zero(nat) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ) ).

% even_push_bit_iff
tff(fact_4310_real__root__pow__pos2,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
       => ( aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),Nb) = X2 ) ) ) ).

% real_root_pow_pos2
tff(fact_4311_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [L: num,K: num] : ( bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),L),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = bit_se4730199178511100633sh_bit(A,pred_numeral(L),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K)))) ) ) ).

% push_bit_minus_numeral
tff(fact_4312_int__prod,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A)] : ( aa(nat,int,semiring_1_of_nat(int),groups7121269368397514597t_prod(A,nat,F3,A3)) = groups7121269368397514597t_prod(A,int,aTP_Lamp_hp(fun(A,nat),fun(A,int),F3),A3) ) ).

% int_prod
tff(fact_4313_bit__xor__int__iff,axiom,
    ! [K: int,L: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)),Nb)
    <=> ~ ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb)
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),Nb) ) ) ).

% bit_xor_int_iff
tff(fact_4314_flip__bit__int__def,axiom,
    ! [Nb: nat,K: int] : ( bit_se8732182000553998342ip_bit(int,Nb,K) = aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),bit_se4730199178511100633sh_bit(int,Nb,one_one(int))) ) ).

% flip_bit_int_def
tff(fact_4315_push__bit__minus,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),bit_se4730199178511100633sh_bit(A,Nb,A2)) ) ) ).

% push_bit_minus
tff(fact_4316_push__bit__add,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),bit_se4730199178511100633sh_bit(A,Nb,A2)),bit_se4730199178511100633sh_bit(A,Nb,B2)) ) ) ).

% push_bit_add
tff(fact_4317_push__bit__nat__eq,axiom,
    ! [Nb: nat,K: int] : ( bit_se4730199178511100633sh_bit(nat,Nb,aa(int,nat,nat2,K)) = aa(int,nat,nat2,bit_se4730199178511100633sh_bit(int,Nb,K)) ) ).

% push_bit_nat_eq
tff(fact_4318_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,K: int] : ( bit_se4730199178511100633sh_bit(A,Nb,ring_1_of_int(A,K)) = ring_1_of_int(A,bit_se4730199178511100633sh_bit(int,Nb,K)) ) ) ).

% push_bit_of_int
tff(fact_4319_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,Ma: nat] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(nat,A,semiring_1_of_nat(A),Ma)) = aa(nat,A,semiring_1_of_nat(A),bit_se4730199178511100633sh_bit(nat,Nb,Ma)) ) ) ).

% push_bit_of_nat
tff(fact_4320_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),bit_se4730199178511100633sh_bit(nat,Ma,Nb)) = bit_se4730199178511100633sh_bit(A,Ma,aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% of_nat_push_bit
tff(fact_4321_real__root__mult,axiom,
    ! [Nb: nat,X2: real,Y2: real] : ( aa(real,real,root(Nb),aa(real,real,aa(real,fun(real,real),times_times(real),X2),Y2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,root(Nb),X2)),aa(real,real,root(Nb),Y2)) ) ).

% real_root_mult
tff(fact_4322_real__root__mult__exp,axiom,
    ! [Ma: nat,Nb: nat,X2: real] : ( aa(real,real,root(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)),X2) = aa(real,real,root(Ma),aa(real,real,root(Nb),X2)) ) ).

% real_root_mult_exp
tff(fact_4323_real__root__pos__pos__le,axiom,
    ! [X2: real,Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(Nb),X2)) ) ).

% real_root_pos_pos_le
tff(fact_4324_XOR__lower,axiom,
    ! [X2: int,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),X2),Y2)) ) ) ).

% XOR_lower
tff(fact_4325_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] : ( bit_se4730199178511100633sh_bit(A,Ma,aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)),bit_se4730199178511100633sh_bit(A,Ma,A2)) ) ) ).

% push_bit_take_bit
tff(fact_4326_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),bit_se4730199178511100633sh_bit(A,Nb,A2)) = bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),A2)) ) ) ).

% take_bit_push_bit
tff(fact_4327_flip__bit__nat__def,axiom,
    ! [Ma: nat,Nb: nat] : ( bit_se8732182000553998342ip_bit(nat,Ma,Nb) = aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),Nb),bit_se4730199178511100633sh_bit(nat,Ma,one_one(nat))) ) ).

% flip_bit_nat_def
tff(fact_4328_real__root__less__mono,axiom,
    ! [Nb: nat,X2: real,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),Y2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Nb),X2)),aa(real,real,root(Nb),Y2)) ) ) ).

% real_root_less_mono
tff(fact_4329_real__root__le__mono,axiom,
    ! [Nb: nat,X2: real,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),Y2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Nb),X2)),aa(real,real,root(Nb),Y2)) ) ) ).

% real_root_le_mono
tff(fact_4330_real__root__power,axiom,
    ! [Nb: nat,X2: real,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,real,root(Nb),aa(nat,real,power_power(real,X2),K)) = aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),K) ) ) ).

% real_root_power
tff(fact_4331_real__root__abs,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,real,root(Nb),aa(real,real,abs_abs(real),X2)) = aa(real,real,abs_abs(real),aa(real,real,root(Nb),X2)) ) ) ).

% real_root_abs
tff(fact_4332_sgn__root,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,real,sgn_sgn(real),aa(real,real,root(Nb),X2)) = aa(real,real,sgn_sgn(real),X2) ) ) ).

% sgn_root
tff(fact_4333_bit__push__bit__iff__int,axiom,
    ! [Ma: nat,K: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,bit_se4730199178511100633sh_bit(int,Ma,K)),Nb)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)) ) ) ).

% bit_push_bit_iff_int
tff(fact_4334_xor__nat__def,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),Ma),Nb) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(nat,int,semiring_1_of_nat(int),Ma)),aa(nat,int,semiring_1_of_nat(int),Nb))) ) ).

% xor_nat_def
tff(fact_4335_prod__int__eq,axiom,
    ! [I3: nat,J2: nat] : ( groups7121269368397514597t_prod(nat,int,semiring_1_of_nat(int),set_or1337092689740270186AtMost(nat,I3,J2)) = groups7121269368397514597t_prod(int,int,aTP_Lamp_ki(int,int),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I3),aa(nat,int,semiring_1_of_nat(int),J2))) ) ).

% prod_int_eq
tff(fact_4336_bit__push__bit__iff__nat,axiom,
    ! [Ma: nat,Q2: nat,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,bit_se4730199178511100633sh_bit(nat,Ma,Q2)),Nb)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(nat,Q2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)) ) ) ).

% bit_push_bit_iff_nat
tff(fact_4337_concat__bit__eq,axiom,
    ! [Nb: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(Nb,K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),bit_se4730199178511100633sh_bit(int,Nb,L)) ) ).

% concat_bit_eq
tff(fact_4338_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se8732182000553998342ip_bit(A,Nb,A2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),bit_se4730199178511100633sh_bit(A,Nb,one_one(A))) ) ) ).

% flip_bit_eq_xor
tff(fact_4339_real__root__gt__zero,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,root(Nb),X2)) ) ) ).

% real_root_gt_zero
tff(fact_4340_real__root__strict__decreasing,axiom,
    ! [Nb: nat,N3: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),N3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(N3),X2)),aa(real,real,root(Nb),X2)) ) ) ) ).

% real_root_strict_decreasing
tff(fact_4341_sqrt__def,axiom,
    sqrt = root(aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ).

% sqrt_def
tff(fact_4342_root__abs__power,axiom,
    ! [Nb: nat,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,real,abs_abs(real),aa(real,real,root(Nb),aa(nat,real,power_power(real,Y2),Nb))) = aa(real,real,abs_abs(real),Y2) ) ) ).

% root_abs_power
tff(fact_4343_push__bit__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),bit_se4730199178511100633sh_bit(A,Nb,A2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% push_bit_double
tff(fact_4344_prod__int__plus__eq,axiom,
    ! [I3: nat,J2: nat] : ( groups7121269368397514597t_prod(nat,int,semiring_1_of_nat(int),set_or1337092689740270186AtMost(nat,I3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),J2))) = groups7121269368397514597t_prod(int,int,aTP_Lamp_ki(int,int),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I3),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),J2)))) ) ).

% prod_int_plus_eq
tff(fact_4345_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),bit_se4730199178511100633sh_bit(A,Nb,one_one(A))) != zero_zero(A) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
tff(fact_4346_real__root__pos__pos,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(Nb),X2)) ) ) ).

% real_root_pos_pos
tff(fact_4347_real__root__strict__increasing,axiom,
    ! [Nb: nat,N3: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),N3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Nb),X2)),aa(real,real,root(N3),X2)) ) ) ) ) ).

% real_root_strict_increasing
tff(fact_4348_real__root__decreasing,axiom,
    ! [Nb: nat,N3: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),N3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(N3),X2)),aa(real,real,root(Nb),X2)) ) ) ) ).

% real_root_decreasing
tff(fact_4349_real__root__pow__pos,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),Nb) = X2 ) ) ) ).

% real_root_pow_pos
tff(fact_4350_real__root__power__cancel,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
       => ( aa(real,real,root(Nb),aa(nat,real,power_power(real,X2),Nb)) = X2 ) ) ) ).

% real_root_power_cancel
tff(fact_4351_real__root__pos__unique,axiom,
    ! [Nb: nat,Y2: real,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y2)
       => ( ( aa(nat,real,power_power(real,Y2),Nb) = X2 )
         => ( aa(real,real,root(Nb),X2) = Y2 ) ) ) ) ).

% real_root_pos_unique
tff(fact_4352_odd__real__root__pow,axiom,
    ! [Nb: nat,X2: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),Nb) = X2 ) ) ).

% odd_real_root_pow
tff(fact_4353_odd__real__root__unique,axiom,
    ! [Nb: nat,Y2: real,X2: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( ( aa(nat,real,power_power(real,Y2),Nb) = X2 )
       => ( aa(real,real,root(Nb),X2) = Y2 ) ) ) ).

% odd_real_root_unique
tff(fact_4354_odd__real__root__power__cancel,axiom,
    ! [Nb: nat,X2: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( aa(real,real,root(Nb),aa(nat,real,power_power(real,X2),Nb)) = X2 ) ) ).

% odd_real_root_power_cancel
tff(fact_4355_push__bit__int__def,axiom,
    ! [Nb: nat,K: int] : ( bit_se4730199178511100633sh_bit(int,Nb,K) = aa(int,int,aa(int,fun(int,int),times_times(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ).

% push_bit_int_def
tff(fact_4356_push__bit__nat__def,axiom,
    ! [Nb: nat,Ma: nat] : ( bit_se4730199178511100633sh_bit(nat,Nb,Ma) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ).

% push_bit_nat_def
tff(fact_4357_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se4730199178511100633sh_bit(A,Nb,A2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) ) ) ).

% push_bit_eq_mult
tff(fact_4358_exp__dvdE,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),A2)
         => ~ ! [B3: A] : ( A2 != bit_se4730199178511100633sh_bit(A,Nb,B3) ) ) ) ).

% exp_dvdE
tff(fact_4359_real__root__increasing,axiom,
    ! [Nb: nat,N3: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),N3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Nb),X2)),aa(real,real,root(N3),X2)) ) ) ) ) ).

% real_root_increasing
tff(fact_4360_sgn__power__root,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),aa(real,real,root(Nb),X2))),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),aa(real,real,root(Nb),X2))),Nb)) = X2 ) ) ).

% sgn_power_root
tff(fact_4361_root__sgn__power,axiom,
    ! [Nb: nat,Y2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,real,root(Nb),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Y2)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),Y2)),Nb))) = Y2 ) ) ).

% root_sgn_power
tff(fact_4362_push__bit__minus__one,axiom,
    ! [Nb: nat] : ( bit_se4730199178511100633sh_bit(int,Nb,aa(int,int,uminus_uminus(int),one_one(int))) = aa(int,int,uminus_uminus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ).

% push_bit_minus_one
tff(fact_4363_ln__root,axiom,
    ! [Nb: nat,B2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
       => ( aa(real,real,ln_ln(real),aa(real,real,root(Nb),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),B2)),aa(nat,real,semiring_1_of_nat(real),Nb)) ) ) ) ).

% ln_root
tff(fact_4364_log__root,axiom,
    ! [Nb: nat,A2: real,B2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ( aa(real,real,log(B2),aa(real,real,root(Nb),A2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(B2),A2)),aa(nat,real,semiring_1_of_nat(real),Nb)) ) ) ) ).

% log_root
tff(fact_4365_log__base__root,axiom,
    ! [Nb: nat,B2: real,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
       => ( aa(real,real,log(aa(real,real,root(Nb),B2)),X2) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(real,real,log(B2),X2)) ) ) ) ).

% log_base_root
tff(fact_4366_XOR__upper,axiom,
    ! [X2: int,Nb: nat,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X2),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y2),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))
         => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),X2),Y2)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ) ) ).

% XOR_upper
tff(fact_4367_split__root,axiom,
    ! [P: fun(real,$o),Nb: nat,X2: real] :
      ( aa(real,$o,P,aa(real,real,root(Nb),X2))
    <=> ( ( ( Nb = zero_zero(nat) )
         => aa(real,$o,P,zero_zero(real)) )
        & ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
         => ! [Y: real] :
              ( ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Y)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),Y)),Nb)) = X2 )
             => aa(real,$o,P,Y) ) ) ) ) ).

% split_root
tff(fact_4368_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),Nb: nat] : ( groups7121269368397514597t_prod(product_prod(nat,nat),A,aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_hy(nat,fun(nat,fun(nat,$o)),Nb)))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_lp(fun(nat,fun(nat,A)),fun(nat,A),G),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ) ).

% prod.triangle_reindex_eq
tff(fact_4369_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,Bs: list($o)] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),groups4207007520872428315er_sum($o,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),Bs)) = groups4207007520872428315er_sum($o,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),take($o,Nb,Bs)) ) ) ).

% take_bit_horner_sum_bit_eq
tff(fact_4370_root__powr__inverse,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => ( aa(real,real,root(Nb),X2) = powr(real,X2,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),Nb))) ) ) ) ).

% root_powr_inverse
tff(fact_4371_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),A2)
          = $let(
              l: A,
              l := aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Nb)),A2),
              $ite(aa(nat,$o,bit_se5641148757651400278ts_bit(A,l),Nb),aa(A,A,aa(A,fun(A,A),plus_plus(A),l),bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,Nb),aa(A,A,uminus_uminus(A),one_one(A)))),l) ) ) ) ).

% signed_take_bit_code
tff(fact_4372_xor__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ( ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K) )
             != ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L) ) ))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ).

% xor_int_rec
tff(fact_4373_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),Nb: nat] : ( groups7121269368397514597t_prod(product_prod(nat,nat),A,aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),G),aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_iv(nat,fun(nat,fun(nat,$o)),Nb)))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_lp(fun(nat,fun(nat,A)),fun(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) ) ) ).

% prod.triangle_reindex
tff(fact_4374_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Bs: list($o),Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,groups4207007520872428315er_sum($o,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),Bs)),Nb)
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list($o),nat,size_size(list($o)),Bs))
            & aa(nat,$o,nth($o,Bs),Nb) ) ) ) ).

% bit_horner_sum_bit_iff
tff(fact_4375_xor__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)
      = $ite(
          K = aa(int,int,uminus_uminus(int),one_one(int)),
          aa(int,int,bit_ri4277139882892585799ns_not(int),L),
          $ite(
            L = aa(int,int,uminus_uminus(int),one_one(int)),
            aa(int,int,bit_ri4277139882892585799ns_not(int),K),
            $ite(
              K = zero_zero(int),
              L,
              $ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))))) ) ) ) ) ).

% xor_int_unfold
tff(fact_4376_VEBT_Osize_I3_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),vEBT_Node(X11,X12,X13,X14)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(vEBT_VEBT),nat,size_list(vEBT_VEBT,size_size(vEBT_VEBT)),X13)),aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),X14))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% VEBT.size(3)
tff(fact_4377_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Nb: nat] : ( groups4207007520872428315er_sum($o,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),aa(list(nat),list($o),map(nat,$o,bit_se5641148757651400278ts_bit(A,A2)),upt(zero_zero(nat),Nb))) = aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) ) ) ).

% horner_sum_bit_eq_take_bit
tff(fact_4378_Sum__Ico__nat,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_jv(nat,nat)),set_or7035219750837199246ssThan(nat,Ma,Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),one_one(nat))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Sum_Ico_nat
tff(fact_4379_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)) = X2 ) ) ).

% bit.double_compl
tff(fact_4380_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(A,A,bit_ri4277139882892585799ns_not(A),X2) = aa(A,A,bit_ri4277139882892585799ns_not(A),Y2) )
        <=> ( X2 = Y2 ) ) ) ).

% bit.compl_eq_compl_iff
tff(fact_4381_length__upt,axiom,
    ! [I3: nat,J2: nat] : ( aa(list(nat),nat,size_size(list(nat)),upt(I3,J2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I3) ) ).

% length_upt
tff(fact_4382_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),Y2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),Y2)) ) ) ).

% bit.xor_compl_left
tff(fact_4383_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),aa(A,A,bit_ri4277139882892585799ns_not(A),Y2)) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),Y2)) ) ) ).

% bit.xor_compl_right
tff(fact_4384_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I3: A,L: A,U: A] :
          ( aa(set(A),$o,member(A,I3),set_or7035219750837199246ssThan(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),I3)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),I3),U) ) ) ) ).

% atLeastLessThan_iff
tff(fact_4385_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),X2) = zero_zero(A) ) ) ).

% bit.conj_cancel_left
tff(fact_4386_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)) = zero_zero(A) ) ) ).

% bit.conj_cancel_right
tff(fact_4387_nth__upt,axiom,
    ! [I3: nat,K: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K)),J2)
     => ( aa(nat,nat,nth(nat,upt(I3,J2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),K) ) ) ).

% nth_upt
tff(fact_4388_take__upt,axiom,
    ! [I3: nat,Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),Ma)),Nb)
     => ( take(nat,Ma,upt(I3,Nb)) = upt(I3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),Ma)) ) ) ).

% take_upt
tff(fact_4389_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.compl_zero
tff(fact_4390_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% bit.compl_one
tff(fact_4391_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,uminus_uminus(A),one_one(A))),X2) = aa(A,A,bit_ri4277139882892585799ns_not(A),X2) ) ) ).

% bit.xor_one_left
tff(fact_4392_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),X2) ) ) ).

% bit.xor_one_right
tff(fact_4393_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),X2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_left
tff(fact_4394_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_right
tff(fact_4395_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% not_nonnegative_int_iff
tff(fact_4396_not__negative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% not_negative_int_iff
tff(fact_4397_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: num] : ( aa(A,A,uminus_uminus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),Nb))) = aa(num,A,numeral_numeral(A),inc(Nb)) ) ) ).

% minus_not_numeral_eq
tff(fact_4398_even__not__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_ri4277139882892585799ns_not(A),A2))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_not_iff
tff(fact_4399_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Nb)) ) ) ).

% push_bit_minus_one_eq_not_mask
tff(fact_4400_not__one__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% not_one_eq
tff(fact_4401_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,aa(nat,nat,suc,Nb)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,Nb))),aa(nat,A,G,Nb))) ) ) ).

% sum.op_ivl_Suc
tff(fact_4402_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] :
          ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,aa(nat,nat,suc,Nb)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,Nb))),aa(nat,A,G,Nb))) ) ) ).

% prod.op_ivl_Suc
tff(fact_4403_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( ring_1_of_int(A,aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),K))) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),K)) ) ) ).

% of_int_not_numeral
tff(fact_4404_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int] : ( ring_1_of_int(A,aa(int,int,bit_ri4277139882892585799ns_not(int),K)) = aa(A,A,bit_ri4277139882892585799ns_not(A),ring_1_of_int(A,K)) ) ) ).

% of_int_not_eq
tff(fact_4405_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( ( set_or7035219750837199246ssThan(A,A2,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
            <=> ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
tff(fact_4406_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( set_or7035219750837199246ssThan(A,A2,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
tff(fact_4407_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( set_or7035219750837199246ssThan(A,A2,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
tff(fact_4408_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2))) = aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)) ) ) ).

% take_bit_not_take_bit
tff(fact_4409_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A,B2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,bit_ri4277139882892585799ns_not(A),B2)) )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),B2) ) ) ) ).

% take_bit_not_iff
tff(fact_4410_map__Suc__upt,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(list(nat),list(nat),map(nat,nat,suc),upt(Ma,Nb)) = upt(aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb)) ) ).

% map_Suc_upt
tff(fact_4411_atLeastLessThan__upt,axiom,
    ! [I3: nat,J2: nat] : ( set_or7035219750837199246ssThan(nat,I3,J2) = aa(list(nat),set(nat),set2(nat),upt(I3,J2)) ) ).

% atLeastLessThan_upt
tff(fact_4412_bit__not__int__iff,axiom,
    ! [K: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_ri4277139882892585799ns_not(int),K)),Nb)
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb) ) ).

% bit_not_int_iff
tff(fact_4413_ex__nat__less__eq,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( ? [M4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Nb)
          & aa(nat,$o,P,M4) )
    <=> ? [X3: nat] :
          ( aa(set(nat),$o,member(nat,X3),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))
          & aa(nat,$o,P,X3) ) ) ).

% ex_nat_less_eq
tff(fact_4414_all__nat__less__eq,axiom,
    ! [Nb: nat,P: fun(nat,$o)] :
      ( ! [M4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Nb)
         => aa(nat,$o,P,M4) )
    <=> ! [X3: nat] :
          ( aa(set(nat),$o,member(nat,X3),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))
         => aa(nat,$o,P,X3) ) ) ).

% all_nat_less_eq
tff(fact_4415_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),B2) ) ) ).

% not_diff_distrib
tff(fact_4416_not__add__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),B2) ) ) ).

% not_add_distrib
tff(fact_4417_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L: nat,U: nat] : ( set_or7035219750837199246ssThan(nat,L,aa(nat,nat,suc,U)) = set_or1337092689740270186AtMost(nat,L,U) ) ).

% atLeastLessThanSuc_atLeastAtMost
tff(fact_4418_lessThan__atLeast0,axiom,
    ! [Nb: nat] : ( aa(nat,set(nat),set_ord_lessThan(nat),Nb) = set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb) ) ).

% lessThan_atLeast0
tff(fact_4419_atLeastAtMost__upt,axiom,
    ! [Nb: nat,Ma: nat] : ( set_or1337092689740270186AtMost(nat,Nb,Ma) = aa(list(nat),set(nat),set2(nat),upt(Nb,aa(nat,nat,suc,Ma))) ) ).

% atLeastAtMost_upt
tff(fact_4420_atLeast__upt,axiom,
    ! [Nb: nat] : ( aa(nat,set(nat),set_ord_lessThan(nat),Nb) = aa(list(nat),set(nat),set2(nat),upt(zero_zero(nat),Nb)) ) ).

% atLeast_upt
tff(fact_4421_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fq(fun(nat,A),fun(nat,A),G)),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% sum.shift_bounds_Suc_ivl
tff(fact_4422_map__add__upt,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_lq(nat,fun(nat,nat),Nb)),upt(zero_zero(nat),Ma)) = upt(Nb,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) ) ).

% map_add_upt
tff(fact_4423_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,K: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_jm(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% sum.shift_bounds_nat_ivl
tff(fact_4424_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_kx(fun(nat,A),fun(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% prod.shift_bounds_Suc_ivl
tff(fact_4425_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,K: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K))) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_kz(fun(nat,A),fun(nat,fun(nat,A)),G),K),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% prod.shift_bounds_nat_ivl
tff(fact_4426_map__replicate__trivial,axiom,
    ! [A: $tType,X2: A,I3: nat] : ( aa(list(nat),list(A),map(nat,A,aTP_Lamp_lr(A,fun(nat,A),X2)),upt(zero_zero(nat),I3)) = replicate(A,I3,X2) ) ).

% map_replicate_trivial
tff(fact_4427_sum_Oivl__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & comm_monoid_add(B) )
     => ! [A2: A,C2: A,B2: A,D2: A,G: fun(A,B),H: fun(A,B)] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),X4)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),D2)
                   => ( aa(A,B,G,X4) = aa(A,B,H,X4) ) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),set_or7035219750837199246ssThan(A,A2,B2)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),set_or7035219750837199246ssThan(A,C2,D2)) ) ) ) ) ) ).

% sum.ivl_cong
tff(fact_4428_prod_Oivl__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & comm_monoid_mult(B) )
     => ! [A2: A,C2: A,B2: A,D2: A,G: fun(A,B),H: fun(A,B)] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),X4)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),D2)
                   => ( aa(A,B,G,X4) = aa(A,B,H,X4) ) ) )
             => ( groups7121269368397514597t_prod(A,B,G,set_or7035219750837199246ssThan(A,A2,B2)) = groups7121269368397514597t_prod(A,B,H,set_or7035219750837199246ssThan(A,C2,D2)) ) ) ) ) ) ).

% prod.ivl_cong
tff(fact_4429_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),one_one(A)) ) ) ).

% minus_eq_not_plus_1
tff(fact_4430_not__eq__complement,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),one_one(A)) ) ) ).

% not_eq_complement
tff(fact_4431_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))) ) ) ).

% minus_eq_not_minus_1
tff(fact_4432_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,P2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),P2)
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,Nb))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Nb,P2))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,P2)) ) ) ) ) ).

% sum.atLeastLessThan_concat
tff(fact_4433_not__int__def,axiom,
    ! [K: int] : ( aa(int,int,bit_ri4277139882892585799ns_not(int),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),K)),one_one(int)) ) ).

% not_int_def
tff(fact_4434_size__list__estimation,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Y2: nat,F3: fun(A,nat)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y2),aa(A,nat,F3,X2))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y2),aa(list(A),nat,size_list(A,F3),Xs)) ) ) ).

% size_list_estimation
tff(fact_4435_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list(A),F3: fun(A,nat),G: fun(A,nat)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F3,X4)),aa(A,nat,G,X4)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_list(A,F3),Xs)),aa(list(A),nat,size_list(A,G),Xs)) ) ).

% size_list_pointwise
tff(fact_4436_size__list__estimation_H,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Y2: nat,F3: fun(A,nat)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y2),aa(A,nat,F3,X2))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y2),aa(list(A),nat,size_list(A,F3),Xs)) ) ) ).

% size_list_estimation'
tff(fact_4437_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,P2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),P2)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,Nb))),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Nb,P2))) = groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,P2)) ) ) ) ) ).

% prod.atLeastLessThan_concat
tff(fact_4438_and__not__numerals_I1_J,axiom,
    aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = zero_zero(int) ).

% and_not_numerals(1)
tff(fact_4439_atMost__upto,axiom,
    ! [Nb: nat] : ( aa(nat,set(nat),set_ord_atMost(nat),Nb) = aa(list(nat),set(nat),set2(nat),upt(zero_zero(nat),aa(nat,nat,suc,Nb))) ) ).

% atMost_upto
tff(fact_4440_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [B2: A,A2: A] :
          ( ! [N: nat] :
              ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N)
             => aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,bit_ri4277139882892585799ns_not(A),B2)) ) ) ) ).

% disjunctive_diff
tff(fact_4441_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),bit_se2239418461657761734s_mask(A,Nb)),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)) ) ) ).

% take_bit_not_eq_mask_diff
tff(fact_4442_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(Nb))) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),Nb)) ) ) ).

% minus_numeral_inc_eq
tff(fact_4443_unset__bit__int__def,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Nb),K) = aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),aa(int,int,bit_ri4277139882892585799ns_not(int),bit_se4730199178511100633sh_bit(int,Nb,one_one(int)))) ) ).

% unset_bit_int_def
tff(fact_4444_map__decr__upt,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(list(nat),list(nat),map(nat,nat,aTP_Lamp_ls(nat,nat)),upt(aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = upt(Ma,Nb) ) ).

% map_decr_upt
tff(fact_4445_map__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(nat),list(A),map(nat,A,nth(A,Xs)),upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = Xs ) ).

% map_nth
tff(fact_4446_not__int__div__2,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))) ) ).

% not_int_div_2
tff(fact_4447_even__not__iff__int,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,bit_ri4277139882892585799ns_not(int),K))
    <=> ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K) ) ).

% even_not_iff_int
tff(fact_4448_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
tff(fact_4449_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
tff(fact_4450_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( ( aa(nat,A,F3,zero_zero(nat)) = zero_zero(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
tff(fact_4451_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))),aa(nat,A,G,Nb)) ) ) ).

% sum.atLeast0_lessThan_Suc
tff(fact_4452_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,Ma)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,Ma),Nb))) ) ) ) ).

% sum.atLeast_Suc_lessThan
tff(fact_4453_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: nat,B2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,A2,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,A2,B2))),aa(nat,A,G,B2)) ) ) ) ).

% sum.atLeastLessThan_Suc
tff(fact_4454_and__not__numerals_I4_J,axiom,
    ! [Ma: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(num,int,numeral_numeral(int),aa(num,num,bit0,Ma)) ) ).

% and_not_numerals(4)
tff(fact_4455_and__not__numerals_I2_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = one_one(int) ) ).

% and_not_numerals(2)
tff(fact_4456_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Nb))) ) ) ).

% not_numeral_Bit0_eq
tff(fact_4457_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))),aa(nat,A,G,Nb)) ) ) ).

% prod.atLeast0_lessThan_Suc
tff(fact_4458_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),Nb)
         => ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,Ma)),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,Ma),Nb))) ) ) ) ).

% prod.atLeast_Suc_lessThan
tff(fact_4459_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: nat,B2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
         => ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,A2,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,A2,B2))),aa(nat,A,G,B2)) ) ) ) ).

% prod.atLeastLessThan_Suc
tff(fact_4460_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,Nb)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,Nb))) ) ) ) ).

% sum.last_plus
tff(fact_4461_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,Nb)),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,Nb))) ) ) ) ).

% prod.last_plus
tff(fact_4462_nth__map__upt,axiom,
    ! [A: $tType,I3: nat,Nb: nat,Ma: nat,F3: fun(nat,A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma))
     => ( aa(nat,A,nth(A,aa(list(nat),list(A),map(nat,A,F3),upt(Ma,Nb))),I3) = aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),I3)) ) ) ).

% nth_map_upt
tff(fact_4463_bit__minus__int__iff,axiom,
    ! [K: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),K)),Nb)
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)))),Nb) ) ).

% bit_minus_int_iff
tff(fact_4464_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),bitM(Nb))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Nb))) ) ) ).

% not_numeral_BitM_eq
tff(fact_4465_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Ma: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Nb))) = zero_zero(A) ) ) ) ).

% take_bit_not_mask_eq_0
tff(fact_4466_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Ma: nat,Nb: nat,F3: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_iq(fun(nat,A),fun(nat,A),F3)),set_or7035219750837199246ssThan(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,Nb)),aa(nat,A,F3,Ma)) ) ) ) ).

% sum_Suc_diff'
tff(fact_4467_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Ma: nat,Nb: nat] : ( bit_se4730199178511100633sh_bit(A,Ma,bit_se2239418461657761734s_mask(A,Nb)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Ma))) ) ) ).

% push_bit_mask_eq
tff(fact_4468_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),Nb),A2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se4730199178511100633sh_bit(A,Nb,one_one(A)))) ) ) ).

% unset_bit_eq_and_not
tff(fact_4469_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat,Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Nb,Ma)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_lt(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Nb),Ma)),set_or7035219750837199246ssThan(nat,Nb,Ma)) ) ) ).

% sum.atLeastLessThan_rev
tff(fact_4470_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: fun(nat,fun(nat,A)),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_lu(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_jq(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),Nb)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)) ) ) ).

% sum.nested_swap
tff(fact_4471_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat,Ma: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Nb,Ma)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_lv(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Nb),Ma),set_or7035219750837199246ssThan(nat,Nb,Ma)) ) ) ).

% prod.atLeastLessThan_rev
tff(fact_4472_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: fun(nat,fun(nat,A)),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,aTP_Lamp_lw(fun(nat,fun(nat,A)),fun(nat,A),A2),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_le(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),Nb),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)) ) ) ).

% prod.nested_swap
tff(fact_4473_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),K: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_lx(fun(nat,A),fun(nat,fun(nat,A)),G),K)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K))) ) ) ).

% sum.nat_group
tff(fact_4474_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),K: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ly(fun(nat,A),fun(nat,fun(nat,A)),G),K),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) = groups7121269368397514597t_prod(nat,A,G,aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),K))) ) ) ).

% prod.nat_group
tff(fact_4475_prod__Suc__fact,axiom,
    ! [Nb: nat] : ( groups7121269368397514597t_prod(nat,nat,suc,set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)) = semiring_char_0_fact(nat,Nb) ) ).

% prod_Suc_fact
tff(fact_4476_prod__Suc__Suc__fact,axiom,
    ! [Nb: nat] : ( groups7121269368397514597t_prod(nat,nat,suc,set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),Nb)) = semiring_char_0_fact(nat,Nb) ) ).

% prod_Suc_Suc_fact
tff(fact_4477_and__not__numerals_I5_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb)))) ) ).

% and_not_numerals(5)
tff(fact_4478_and__not__numerals_I7_J,axiom,
    ! [Ma: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(num,int,numeral_numeral(int),aa(num,num,bit0,Ma)) ) ).

% and_not_numerals(7)
tff(fact_4479_and__not__numerals_I3_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = zero_zero(int) ) ).

% and_not_numerals(3)
tff(fact_4480_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,Nb))),aa(nat,A,G,Nb))) ) ) ).

% sum.head_if
tff(fact_4481_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] :
          ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,Nb))),aa(nat,A,G,Nb))) ) ) ).

% prod.head_if
tff(fact_4482_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list(A),Nb: nat,Ma: nat,F3: fun(nat,A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma) )
     => ( ! [I2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),I2)) ) )
       => ( aa(list(nat),list(A),map(nat,A,F3),upt(Ma,Nb)) = Xs ) ) ) ).

% map_upt_eqI
tff(fact_4483_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] : ( semiring_char_0_fact(A,Nb) = aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(nat,nat,suc,set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))) ) ) ).

% fact_prod_Suc
tff(fact_4484_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat,Ma: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Nb,Ma)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_jn(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Nb),Ma)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Nb),Ma)) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_4485_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat,Ma: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Nb,Ma)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_lb(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Nb),Ma),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Nb),Ma)) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_4486_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Nb: nat] : ( comm_s3205402744901411588hammer(A,A2,Nb) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_lh(A,fun(nat,A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)) ) ) ).

% pochhammer_prod
tff(fact_4487_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Nb: nat] : ( semiring_char_0_fact(A,Nb) = aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))) ) ) ).

% fact_prod_rev
tff(fact_4488_and__not__numerals_I9_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb)))) ) ).

% and_not_numerals(9)
tff(fact_4489_and__not__numerals_I6_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb)))) ) ).

% and_not_numerals(6)
tff(fact_4490_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),Nb)
        <=> ( ( aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb) != zero_zero(A) )
            & ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb) ) ) ) ).

% bit_not_iff_eq
tff(fact_4491_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [N5: nat] :
                ! [M4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N5),M4)
                 => ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,M4,N4)))),E3) ) ) ) ) ).

% summable_Cauchy
tff(fact_4492_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat] : ( aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Nb)) ) ) ).

% minus_exp_eq_not_mask
tff(fact_4493_sums__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A),S: A,K: nat] :
          ( aa(A,$o,sums(A,F3),S)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
           => aa(A,$o,sums(A,aa(nat,fun(nat,A),aTP_Lamp_lz(fun(nat,A),fun(nat,fun(nat,A)),F3),K)),S) ) ) ) ).

% sums_group
tff(fact_4494_take__bit__sum,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ma(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)) ) ) ).

% take_bit_sum
tff(fact_4495_fact__split,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
         => ( semiring_char_0_fact(A,Nb) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),groups7121269368397514597t_prod(nat,nat,suc,set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K),Nb)))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),K))) ) ) ) ).

% fact_split
tff(fact_4496_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Nb),K)) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_mb(nat,fun(nat,fun(nat,A)),K),Nb),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% binomial_altdef_of_nat
tff(fact_4497_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_mc(A,fun(nat,fun(nat,A)),A2),K),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_altdef_of_nat
tff(fact_4498_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),semiring_char_0_fact(A,K)) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_md(A,fun(nat,A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact'
tff(fact_4499_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,gbinomial(A,A2),K)) = groups7121269368397514597t_prod(nat,A,aTP_Lamp_md(A,fun(nat,A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact
tff(fact_4500_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),groups7121269368397514597t_prod(nat,A,aTP_Lamp_lm(A,fun(nat,A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),K))),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_prod_rev
tff(fact_4501_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F3: fun(B,A),A2: A,Xs: list(B)] : ( groups4207007520872428315er_sum(B,A,F3,A2,Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_me(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F3),A2),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum
tff(fact_4502_and__not__numerals_I8_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb))))) ) ).

% and_not_numerals(8)
tff(fact_4503_not__int__rec,axiom,
    ! [K: int] : ( aa(int,int,bit_ri4277139882892585799ns_not(int),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa($o,int,zero_neq_one_of_bool(int),aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ).

% not_int_rec
tff(fact_4504_sum__power2,axiom,
    ! [K: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)),one_one(nat)) ) ).

% sum_power2
tff(fact_4505_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: nat,A2: fun(nat,A),B2: fun(nat,A)] :
          ( ! [I2: nat,J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),Nb)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A2,I2)),aa(nat,A,A2,J)) ) )
         => ( ! [I2: nat,J: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J)
               => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),Nb)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,B2,J)),aa(nat,A,B2,I2)) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_mf(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)))) ) ) ) ).

% Chebyshev_sum_upper
tff(fact_4506_Chebyshev__sum__upper__nat,axiom,
    ! [Nb: nat,A2: fun(nat,nat),B2: fun(nat,nat)] :
      ( ! [I2: nat,J: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),Nb)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,A2,I2)),aa(nat,nat,A2,J)) ) )
     => ( ! [I2: nat,J: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),Nb)
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,B2,J)),aa(nat,nat,B2,I2)) ) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(fun(nat,nat),fun(nat,nat),aTP_Lamp_mg(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),A2),B2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)))) ) ) ).

% Chebyshev_sum_upper_nat
tff(fact_4507_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( aa(vEBT_VEBT,nat,vEBT_size_VEBT,vEBT_Node(X11,X12,X13,X14)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(vEBT_VEBT),nat,size_list(vEBT_VEBT,vEBT_size_VEBT),X13)),aa(vEBT_VEBT,nat,vEBT_size_VEBT,X14))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% VEBT.size_gen(1)
tff(fact_4508_Cauchy__iff2,axiom,
    ! [X7: fun(nat,real)] :
      ( topolo3814608138187158403Cauchy(real,X7)
    <=> ! [J4: nat] :
        ? [M8: nat] :
        ! [M4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M4)
         => ! [N4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N4)
             => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,X7,M4)),aa(nat,real,X7,N4)))),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,J4)))) ) ) ) ).

% Cauchy_iff2
tff(fact_4509_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M8: nat] :
                ! [M4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M4)
                 => ! [N4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N4)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M4)),aa(nat,A,X7,N4)))),E3) ) ) ) ) ) ).

% Cauchy_iff
tff(fact_4510_CauchyI,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M3)
                 => ! [N: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),N)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M3)),aa(nat,A,X7,N)))),E) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% CauchyI
tff(fact_4511_CauchyD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),E2: real] :
          ( topolo3814608138187158403Cauchy(A,X7)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
           => ? [M7: nat] :
              ! [M: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M)
               => ! [N8: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),N8)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M)),aa(nat,A,X7,N8)))),E2) ) ) ) ) ) ).

% CauchyD
tff(fact_4512_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] : ( aa(vEBT_VEBT,nat,vEBT_size_VEBT,vEBT_Leaf(X21,X222)) = zero_zero(nat) ) ).

% VEBT.size_gen(2)
tff(fact_4513_Code__Target__Int_Opositive__def,axiom,
    code_Target_positive = numeral_numeral(int) ).

% Code_Target_Int.positive_def
tff(fact_4514_divmod__step__integer__def,axiom,
    ! [L: num,Qr: product_prod(code_integer,code_integer)] : ( unique1321980374590559556d_step(code_integer,L,Qr) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_mh(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),Qr) ) ).

% divmod_step_integer_def
tff(fact_4515_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] : ( re(csqrt(Z)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ).

% csqrt.simps(1)
tff(fact_4516_complex__div__cnj,axiom,
    ! [A2: complex,B2: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2))),aa(real,complex,real_Vector_of_real(complex),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,B2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% complex_div_cnj
tff(fact_4517_cnj__prod,axiom,
    ! [A: $tType,F3: fun(A,complex),S: set(A)] : ( cnj(groups7121269368397514597t_prod(A,complex,F3,S)) = groups7121269368397514597t_prod(A,complex,aTP_Lamp_mi(fun(A,complex),fun(A,complex),F3),S) ) ).

% cnj_prod
tff(fact_4518_complex__cnj__mult,axiom,
    ! [X2: complex,Y2: complex] : ( cnj(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X2),Y2)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cnj(X2)),cnj(Y2)) ) ).

% complex_cnj_mult
tff(fact_4519_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( cnj(Z) = zero_zero(complex) )
    <=> ( Z = zero_zero(complex) ) ) ).

% complex_cnj_zero_iff
tff(fact_4520_complex__cnj__zero,axiom,
    cnj(zero_zero(complex)) = zero_zero(complex) ).

% complex_cnj_zero
tff(fact_4521_cnj__sum,axiom,
    ! [A: $tType,F3: fun(A,complex),S: set(A)] : ( cnj(aa(set(A),complex,aa(fun(A,complex),fun(set(A),complex),groups7311177749621191930dd_sum(A,complex),F3),S)) = aa(set(A),complex,aa(fun(A,complex),fun(set(A),complex),groups7311177749621191930dd_sum(A,complex),aTP_Lamp_mi(fun(A,complex),fun(A,complex),F3)),S) ) ).

% cnj_sum
tff(fact_4522_Re__sum,axiom,
    ! [A: $tType,F3: fun(A,complex),S: set(A)] : ( re(aa(set(A),complex,aa(fun(A,complex),fun(set(A),complex),groups7311177749621191930dd_sum(A,complex),F3),S)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_mj(fun(A,complex),fun(A,real),F3)),S) ) ).

% Re_sum
tff(fact_4523_cos__Arg__i__mult__zero,axiom,
    ! [Y2: complex] :
      ( ( Y2 != zero_zero(complex) )
     => ( ( re(Y2) = zero_zero(real) )
       => ( cos(real,arg(Y2)) = zero_zero(real) ) ) ) ).

% cos_Arg_i_mult_zero
tff(fact_4524_Cauchy__Re,axiom,
    ! [X7: fun(nat,complex)] :
      ( topolo3814608138187158403Cauchy(complex,X7)
     => topolo3814608138187158403Cauchy(real,aTP_Lamp_mk(fun(nat,complex),fun(nat,real),X7)) ) ).

% Cauchy_Re
tff(fact_4525_complex__mod__sqrt__Re__mult__cnj,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,sqrt,re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)))) ) ).

% complex_mod_sqrt_Re_mult_cnj
tff(fact_4526_times__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),K),zero_zero(code_integer)) = zero_zero(code_integer) ) ).

% times_integer_code(1)
tff(fact_4527_times__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),zero_zero(code_integer)),L) = zero_zero(code_integer) ) ).

% times_integer_code(2)
tff(fact_4528_sums__cnj,axiom,
    ! [F3: fun(nat,complex),L: complex] :
      ( aa(complex,$o,sums(complex,aTP_Lamp_ml(fun(nat,complex),fun(nat,complex),F3)),cnj(L))
    <=> aa(complex,$o,sums(complex,F3),L) ) ).

% sums_cnj
tff(fact_4529_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),zero_zero(code_integer)),L) = L ) ).

% plus_integer_code(2)
tff(fact_4530_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),K),zero_zero(code_integer)) = K ) ).

% plus_integer_code(1)
tff(fact_4531_less__eq__integer__code_I1_J,axiom,
    aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ).

% less_eq_integer_code(1)
tff(fact_4532_sgn__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,code_integer,sgn_sgn(code_integer),K)
      = $ite(
          K = zero_zero(code_integer),
          zero_zero(code_integer),
          $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),aa(code_integer,code_integer,uminus_uminus(code_integer),one_one(code_integer)),one_one(code_integer)) ) ) ).

% sgn_integer_code
tff(fact_4533_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)) = zero_zero(real) )
    <=> ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2))) = zero_zero(real) ) ) ).

% Re_complex_div_eq_0
tff(fact_4534_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),zero_zero(code_integer)),L) = aa(code_integer,code_integer,uminus_uminus(code_integer),L) ) ).

% minus_integer_code(2)
tff(fact_4535_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),K),zero_zero(code_integer)) = K ) ).

% minus_integer_code(1)
tff(fact_4536_sums__Re,axiom,
    ! [X7: fun(nat,complex),A2: complex] :
      ( aa(complex,$o,sums(complex,X7),A2)
     => aa(real,$o,sums(real,aTP_Lamp_mk(fun(nat,complex),fun(nat,real),X7)),re(A2)) ) ).

% sums_Re
tff(fact_4537_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Re_complex_div_lt_0
tff(fact_4538_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Re_complex_div_gt_0
tff(fact_4539_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Re_complex_div_le_0
tff(fact_4540_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Re_complex_div_ge_0
tff(fact_4541_imaginary__unit_Osimps_I1_J,axiom,
    re(imaginary_unit) = zero_zero(real) ).

% imaginary_unit.simps(1)
tff(fact_4542_zero__complex_Osimps_I1_J,axiom,
    re(zero_zero(complex)) = zero_zero(real) ).

% zero_complex.simps(1)
tff(fact_4543_scaleR__complex_Osimps_I1_J,axiom,
    ! [R: real,X2: complex] : ( re(aa(complex,complex,real_V8093663219630862766scaleR(complex,R),X2)) = aa(real,real,aa(real,fun(real,real),times_times(real),R),re(X2)) ) ).

% scaleR_complex.simps(1)
tff(fact_4544_complex__add__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),Z),cnj(Z)) = aa(real,complex,real_Vector_of_real(complex),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),re(Z))) ) ).

% complex_add_cnj
tff(fact_4545_summable__Re,axiom,
    ! [F3: fun(nat,complex)] :
      ( summable(complex,F3)
     => summable(real,aTP_Lamp_mk(fun(nat,complex),fun(nat,real),F3)) ) ).

% summable_Re
tff(fact_4546_Re__csqrt,axiom,
    ! [Z: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(csqrt(Z))) ).

% Re_csqrt
tff(fact_4547_zero__natural_Orsp,axiom,
    zero_zero(nat) = zero_zero(nat) ).

% zero_natural.rsp
tff(fact_4548_zero__integer_Orsp,axiom,
    zero_zero(int) = zero_zero(int) ).

% zero_integer.rsp
tff(fact_4549_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(W))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cnj(Z)),W)) = aa(real,complex,real_Vector_of_real(complex),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(W))))) ) ).

% cnj_add_mult_eq_Re
tff(fact_4550_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),zero_zero(real))
    <=> ( re(Z) = aa(real,real,uminus_uminus(real),real_V7770717601297561774m_norm(complex,Z)) ) ) ).

% cmod_plus_Re_le_0_iff
tff(fact_4551_cos__n__Re__cis__pow__n,axiom,
    ! [Nb: nat,A2: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),A2)) = re(aa(nat,complex,power_power(complex,cis(A2)),Nb)) ) ).

% cos_n_Re_cis_pow_n
tff(fact_4552_complex__mod__mult__cnj,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z))) = aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% complex_mod_mult_cnj
tff(fact_4553_complex__norm__square,axiom,
    ! [Z: complex] : ( aa(real,complex,real_Vector_of_real(complex),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)) ) ).

% complex_norm_square
tff(fact_4554_csqrt_Ocode,axiom,
    ! [Z: complex] :
      ( csqrt(Z)
      = complex2(aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),
          aa(real,real,
            aa(real,fun(real,real),times_times(real),$ite(im(Z) = zero_zero(real),one_one(real),aa(real,real,sgn_sgn(real),im(Z)))),
            aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))) ) ).

% csqrt.code
tff(fact_4555_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( im(csqrt(Z))
      = aa(real,real,
          aa(real,fun(real,real),times_times(real),$ite(im(Z) = zero_zero(real),one_one(real),aa(real,real,sgn_sgn(real),im(Z)))),
          aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ) ).

% csqrt.simps(2)
tff(fact_4556_integer__of__int__code,axiom,
    ! [K: int] :
      ( code_integer_of_int(K)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),
          aa(code_integer,code_integer,uminus_uminus(code_integer),code_integer_of_int(aa(int,int,uminus_uminus(int),K))),
          $ite(
            K = zero_zero(int),
            zero_zero(code_integer),
            $let(
              l: code_integer,
              l := aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),code_integer_of_int(aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),
              $ite(modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = zero_zero(int),l,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),l),one_one(code_integer))) ) ) ) ) ).

% integer_of_int_code
tff(fact_4557_csqrt__of__real__nonpos,axiom,
    ! [X2: complex] :
      ( ( im(X2) = zero_zero(real) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(X2)),zero_zero(real))
       => ( csqrt(X2) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),aa(real,real,sqrt,aa(real,real,abs_abs(real),re(X2))))) ) ) ) ).

% csqrt_of_real_nonpos
tff(fact_4558_complex__Im__of__int,axiom,
    ! [Z: int] : ( im(ring_1_of_int(complex,Z)) = zero_zero(real) ) ).

% complex_Im_of_int
tff(fact_4559_complex__Im__fact,axiom,
    ! [Nb: nat] : ( im(semiring_char_0_fact(complex,Nb)) = zero_zero(real) ) ).

% complex_Im_fact
tff(fact_4560_complex__Im__of__nat,axiom,
    ! [Nb: nat] : ( im(aa(nat,complex,semiring_1_of_nat(complex),Nb)) = zero_zero(real) ) ).

% complex_Im_of_nat
tff(fact_4561_Im__complex__of__real,axiom,
    ! [Z: real] : ( im(aa(real,complex,real_Vector_of_real(complex),Z)) = zero_zero(real) ) ).

% Im_complex_of_real
tff(fact_4562_Im__power__real,axiom,
    ! [X2: complex,Nb: nat] :
      ( ( im(X2) = zero_zero(real) )
     => ( im(aa(nat,complex,power_power(complex,X2),Nb)) = zero_zero(real) ) ) ).

% Im_power_real
tff(fact_4563_complex__Im__numeral,axiom,
    ! [V: num] : ( im(aa(num,complex,numeral_numeral(complex),V)) = zero_zero(real) ) ).

% complex_Im_numeral
tff(fact_4564_Im__sum,axiom,
    ! [A: $tType,F3: fun(A,complex),S: set(A)] : ( im(aa(set(A),complex,aa(fun(A,complex),fun(set(A),complex),groups7311177749621191930dd_sum(A,complex),F3),S)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_mm(fun(A,complex),fun(A,real),F3)),S) ) ).

% Im_sum
tff(fact_4565_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z))) = zero_zero(real) ) ).

% complex_In_mult_cnj_zero
tff(fact_4566_Im__i__times,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) = re(Z) ) ).

% Im_i_times
tff(fact_4567_Re__power__real,axiom,
    ! [X2: complex,Nb: nat] :
      ( ( im(X2) = zero_zero(real) )
     => ( re(aa(nat,complex,power_power(complex,X2),Nb)) = aa(nat,real,power_power(real,re(X2)),Nb) ) ) ).

% Re_power_real
tff(fact_4568_Re__i__times,axiom,
    ! [Z: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) = aa(real,real,uminus_uminus(real),im(Z)) ) ).

% Re_i_times
tff(fact_4569_csqrt__of__real__nonneg,axiom,
    ! [X2: complex] :
      ( ( im(X2) = zero_zero(real) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(X2))
       => ( csqrt(X2) = aa(real,complex,real_Vector_of_real(complex),aa(real,real,sqrt,re(X2))) ) ) ) ).

% csqrt_of_real_nonneg
tff(fact_4570_csqrt__minus,axiom,
    ! [X2: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(X2)),zero_zero(real))
        | ( ( im(X2) = zero_zero(real) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(X2)) ) )
     => ( csqrt(aa(complex,complex,uminus_uminus(complex),X2)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),csqrt(X2)) ) ) ).

% csqrt_minus
tff(fact_4571_divide__integer_Oabs__eq,axiom,
    ! [Xa2: int,X2: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),code_integer_of_int(Xa2)),code_integer_of_int(X2)) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa2),X2)) ) ).

% divide_integer.abs_eq
tff(fact_4572_less__integer_Oabs__eq,axiom,
    ! [Xa2: int,X2: int] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),code_integer_of_int(Xa2)),code_integer_of_int(X2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Xa2),X2) ) ).

% less_integer.abs_eq
tff(fact_4573_uminus__integer__code_I1_J,axiom,
    aa(code_integer,code_integer,uminus_uminus(code_integer),zero_zero(code_integer)) = zero_zero(code_integer) ).

% uminus_integer_code(1)
tff(fact_4574_zero__integer__def,axiom,
    zero_zero(code_integer) = code_integer_of_int(zero_zero(int)) ).

% zero_integer_def
tff(fact_4575_abs__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,code_integer,abs_abs(code_integer),K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),aa(code_integer,code_integer,uminus_uminus(code_integer),K),K) ) ).

% abs_integer_code
tff(fact_4576_less__integer__code_I1_J,axiom,
    ~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ).

% less_integer_code(1)
tff(fact_4577_sums__Im,axiom,
    ! [X7: fun(nat,complex),A2: complex] :
      ( aa(complex,$o,sums(complex,X7),A2)
     => aa(real,$o,sums(real,aTP_Lamp_mn(fun(nat,complex),fun(nat,real),X7)),im(A2)) ) ).

% sums_Im
tff(fact_4578_Cauchy__Im,axiom,
    ! [X7: fun(nat,complex)] :
      ( topolo3814608138187158403Cauchy(complex,X7)
     => topolo3814608138187158403Cauchy(real,aTP_Lamp_mn(fun(nat,complex),fun(nat,real),X7)) ) ).

% Cauchy_Im
tff(fact_4579_zero__complex_Osimps_I2_J,axiom,
    im(zero_zero(complex)) = zero_zero(real) ).

% zero_complex.simps(2)
tff(fact_4580_one__complex_Osimps_I2_J,axiom,
    im(one_one(complex)) = zero_zero(real) ).

% one_complex.simps(2)
tff(fact_4581_times__integer_Oabs__eq,axiom,
    ! [Xa2: int,X2: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),code_integer_of_int(Xa2)),code_integer_of_int(X2)) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),times_times(int),Xa2),X2)) ) ).

% times_integer.abs_eq
tff(fact_4582_scaleR__complex_Osimps_I2_J,axiom,
    ! [R: real,X2: complex] : ( im(aa(complex,complex,real_V8093663219630862766scaleR(complex,R),X2)) = aa(real,real,aa(real,fun(real,real),times_times(real),R),im(X2)) ) ).

% scaleR_complex.simps(2)
tff(fact_4583_sums__complex__iff,axiom,
    ! [F3: fun(nat,complex),X2: complex] :
      ( aa(complex,$o,sums(complex,F3),X2)
    <=> ( aa(real,$o,sums(real,aTP_Lamp_mk(fun(nat,complex),fun(nat,real),F3)),re(X2))
        & aa(real,$o,sums(real,aTP_Lamp_mn(fun(nat,complex),fun(nat,real),F3)),im(X2)) ) ) ).

% sums_complex_iff
tff(fact_4584_summable__Im,axiom,
    ! [F3: fun(nat,complex)] :
      ( summable(complex,F3)
     => summable(real,aTP_Lamp_mn(fun(nat,complex),fun(nat,real),F3)) ) ).

% summable_Im
tff(fact_4585_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( aa(set(complex),$o,member(complex,Z),ring_1_Ints(complex))
    <=> ( ( im(Z) = zero_zero(real) )
        & ? [I: int] : ( re(Z) = ring_1_of_int(real,I) ) ) ) ).

% complex_is_Int_iff
tff(fact_4586_summable__complex__iff,axiom,
    ! [F3: fun(nat,complex)] :
      ( summable(complex,F3)
    <=> ( summable(real,aTP_Lamp_mk(fun(nat,complex),fun(nat,real),F3))
        & summable(real,aTP_Lamp_mn(fun(nat,complex),fun(nat,real),F3)) ) ) ).

% summable_complex_iff
tff(fact_4587_times__complex_Osimps_I2_J,axiom,
    ! [X2: complex,Y2: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X2),Y2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X2)),im(Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X2)),re(Y2))) ) ).

% times_complex.simps(2)
tff(fact_4588_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( aa(real,real,abs_abs(real),re(Z)) = real_V7770717601297561774m_norm(complex,Z) )
     => ( im(Z) = zero_zero(real) ) ) ).

% Im_eq_0
tff(fact_4589_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( re(Z) = zero_zero(real) )
     => ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,abs_abs(real),im(Z)) ) ) ).

% cmod_eq_Im
tff(fact_4590_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( im(Z) = zero_zero(real) )
     => ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,abs_abs(real),re(Z)) ) ) ).

% cmod_eq_Re
tff(fact_4591_times__complex_Osimps_I1_J,axiom,
    ! [X2: complex,Y2: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X2),Y2)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X2)),re(Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X2)),im(Y2))) ) ).

% times_complex.simps(1)
tff(fact_4592_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)) = zero_zero(real) )
    <=> ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2))) = zero_zero(real) ) ) ).

% Im_complex_div_eq_0
tff(fact_4593_scaleR__complex_Ocode,axiom,
    ! [R: real,X2: complex] : ( aa(complex,complex,real_V8093663219630862766scaleR(complex,R),X2) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R),re(X2)),aa(real,real,aa(real,fun(real,real),times_times(real),R),im(X2))) ) ).

% scaleR_complex.code
tff(fact_4594_csqrt__principal,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(csqrt(Z)))
      | ( ( re(csqrt(Z)) = zero_zero(real) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(csqrt(Z))) ) ) ).

% csqrt_principal
tff(fact_4595_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Im_complex_div_gt_0
tff(fact_4596_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Im_complex_div_lt_0
tff(fact_4597_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Im_complex_div_ge_0
tff(fact_4598_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Im_complex_div_le_0
tff(fact_4599_sin__n__Im__cis__pow__n,axiom,
    ! [Nb: nat,A2: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),A2)) = im(aa(nat,complex,power_power(complex,cis(A2)),Nb)) ) ).

% sin_n_Im_cis_pow_n
tff(fact_4600_Re__exp,axiom,
    ! [Z: complex] : ( re(aa(complex,complex,exp(complex),Z)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,exp(real),re(Z))),cos(real,im(Z))) ) ).

% Re_exp
tff(fact_4601_Im__exp,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,exp(complex),Z)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,exp(real),re(Z))),sin(real,im(Z))) ) ).

% Im_exp
tff(fact_4602_complex__eq,axiom,
    ! [A2: complex] : ( A2 = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(real,complex,real_Vector_of_real(complex),re(A2))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),im(A2)))) ) ).

% complex_eq
tff(fact_4603_fun__complex__eq,axiom,
    ! [A: $tType,F3: fun(A,complex),X: A] : ( aa(A,complex,F3,X) = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(real,complex,real_Vector_of_real(complex),re(aa(A,complex,F3,X)))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(real,complex,real_Vector_of_real(complex),im(aa(A,complex,F3,X))))) ) ).

% fun_complex_eq
tff(fact_4604_times__complex_Ocode,axiom,
    ! [X2: complex,Y2: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X2),Y2) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X2)),re(Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X2)),im(Y2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X2)),im(Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X2)),re(Y2)))) ) ).

% times_complex.code
tff(fact_4605_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) )
      & ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ) ).

% complex_div_gt_0
tff(fact_4606_exp__eq__polar,axiom,
    ! [Z: complex] : ( aa(complex,complex,exp(complex),Z) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),aa(real,real,exp(real),re(Z)))),cis(im(Z))) ) ).

% exp_eq_polar
tff(fact_4607_cmod__power2,axiom,
    ! [Z: complex] : ( aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% cmod_power2
tff(fact_4608_Im__power2,axiom,
    ! [X2: complex] : ( im(aa(nat,complex,power_power(complex,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),re(X2))),im(X2)) ) ).

% Im_power2
tff(fact_4609_Re__power2,axiom,
    ! [X2: complex] : ( re(aa(nat,complex,power_power(complex,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,power_power(real,re(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% Re_power2
tff(fact_4610_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z = zero_zero(complex) )
    <=> ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = zero_zero(real) ) ) ).

% complex_eq_0
tff(fact_4611_norm__complex__def,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% norm_complex_def
tff(fact_4612_inverse__complex_Osimps_I1_J,axiom,
    ! [X2: complex] : ( re(aa(complex,complex,inverse_inverse(complex),X2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(X2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% inverse_complex.simps(1)
tff(fact_4613_complex__diff__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Z),cnj(Z)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(real,complex,real_Vector_of_real(complex),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),im(Z)))),imaginary_unit) ) ).

% complex_diff_cnj
tff(fact_4614_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% complex_neq_0
tff(fact_4615_Re__divide,axiom,
    ! [X2: complex,Y2: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X2),Y2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X2)),re(Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X2)),im(Y2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% Re_divide
tff(fact_4616_complex__mult__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)) = aa(real,complex,real_Vector_of_real(complex),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% complex_mult_cnj
tff(fact_4617_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(B2))
        | ( ( re(B2) = zero_zero(real) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(B2)) ) )
     => ( csqrt(aa(nat,complex,power_power(complex,B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = B2 ) ) ).

% csqrt_square
tff(fact_4618_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( aa(nat,complex,power_power(complex,W),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = Z )
     => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(W))
          | ( ( re(W) = zero_zero(real) )
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(W)) ) )
       => ( csqrt(Z) = W ) ) ) ).

% csqrt_unique
tff(fact_4619_inverse__complex_Osimps_I2_J,axiom,
    ! [X2: complex] : ( im(aa(complex,complex,inverse_inverse(complex),X2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),im(X2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% inverse_complex.simps(2)
tff(fact_4620_Im__divide,axiom,
    ! [X2: complex,Y2: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X2),Y2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),im(X2)),re(Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),re(X2)),im(Y2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% Im_divide
tff(fact_4621_complex__abs__le__norm,axiom,
    ! [Z: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),re(Z))),aa(real,real,abs_abs(real),im(Z)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),real_V7770717601297561774m_norm(complex,Z))) ).

% complex_abs_le_norm
tff(fact_4622_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),real_V7770717601297561774m_norm(complex,Z))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),real_V7770717601297561774m_norm(complex,Z))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) ) ) ).

% complex_unit_circle
tff(fact_4623_inverse__complex_Ocode,axiom,
    ! [X2: complex] : ( aa(complex,complex,inverse_inverse(complex),X2) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),re(X2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),im(X2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% inverse_complex.code
tff(fact_4624_Complex__divide,axiom,
    ! [X2: complex,Y2: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X2),Y2) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X2)),re(Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X2)),im(Y2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),im(X2)),re(Y2))),aa(real,real,aa(real,fun(real,real),times_times(real),re(X2)),im(Y2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,re(Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,power_power(real,im(Y2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% Complex_divide
tff(fact_4625_Im__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( aa(set(complex),$o,member(complex,R),real_Vector_Reals(complex))
     => ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),R),Z)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),re(R))),im(Z))),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% Im_Reals_divide
tff(fact_4626_Re__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( aa(set(complex),$o,member(complex,R),real_Vector_Reals(complex))
     => ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),R),Z)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(R)),re(Z))),aa(nat,real,power_power(real,real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% Re_Reals_divide
tff(fact_4627_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [G: fun(nat,complex),N3: nat,F3: fun(nat,A)] :
          ( summable(complex,G)
         => ( ! [N: nat] : aa(set(complex),$o,member(complex,aa(nat,complex,G,N)),real_Vector_Reals(complex))
           => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(aa(nat,complex,G,N)))
             => ( ! [N: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N3),N)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N))),real_V7770717601297561774m_norm(complex,aa(nat,complex,G,N))) )
               => summable(A,F3) ) ) ) ) ) ).

% series_comparison_complex
tff(fact_4628_integer__of__num_I3_J,axiom,
    ! [Nb: num] :
      ( code_integer_of_num(aa(num,num,bit1,Nb))
      = $let(
          k: code_integer,
          k := code_integer_of_num(Nb),
          aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),k),k)),one_one(code_integer)) ) ) ).

% integer_of_num(3)
tff(fact_4629_real__eq__imaginary__iff,axiom,
    ! [Y2: complex,X2: complex] :
      ( aa(set(complex),$o,member(complex,Y2),real_Vector_Reals(complex))
     => ( aa(set(complex),$o,member(complex,X2),real_Vector_Reals(complex))
       => ( ( X2 = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Y2) )
        <=> ( ( X2 = zero_zero(complex) )
            & ( Y2 = zero_zero(complex) ) ) ) ) ) ).

% real_eq_imaginary_iff
tff(fact_4630_imaginary__eq__real__iff,axiom,
    ! [Y2: complex,X2: complex] :
      ( aa(set(complex),$o,member(complex,Y2),real_Vector_Reals(complex))
     => ( aa(set(complex),$o,member(complex,X2),real_Vector_Reals(complex))
       => ( ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Y2) = X2 )
        <=> ( ( X2 = zero_zero(complex) )
            & ( Y2 = zero_zero(complex) ) ) ) ) ) ).

% imaginary_eq_real_iff
tff(fact_4631_Reals__0,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => aa(set(A),$o,member(A,zero_zero(A)),real_Vector_Reals(A)) ) ).

% Reals_0
tff(fact_4632_Reals__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,member(A,A2),real_Vector_Reals(A))
         => ( aa(set(A),$o,member(A,B2),real_Vector_Reals(A))
           => aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),real_Vector_Reals(A)) ) ) ) ).

% Reals_divide
tff(fact_4633_Reals__power,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,Nb: nat] :
          ( aa(set(A),$o,member(A,A2),real_Vector_Reals(A))
         => aa(set(A),$o,member(A,aa(nat,A,power_power(A,A2),Nb)),real_Vector_Reals(A)) ) ) ).

% Reals_power
tff(fact_4634_Reals__add,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,member(A,A2),real_Vector_Reals(A))
         => ( aa(set(A),$o,member(A,B2),real_Vector_Reals(A))
           => aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),real_Vector_Reals(A)) ) ) ) ).

% Reals_add
tff(fact_4635_Reals__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : aa(set(A),$o,member(A,aa(num,A,numeral_numeral(A),W)),real_Vector_Reals(A)) ) ).

% Reals_numeral
tff(fact_4636_Reals__mult,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,member(A,A2),real_Vector_Reals(A))
         => ( aa(set(A),$o,member(A,B2),real_Vector_Reals(A))
           => aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),real_Vector_Reals(A)) ) ) ) ).

% Reals_mult
tff(fact_4637_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( aa(set(complex),$o,member(complex,Z),real_Vector_Reals(complex))
    <=> ( im(Z) = zero_zero(real) ) ) ).

% complex_is_Real_iff
tff(fact_4638_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,member(A,A2),real_Vector_Reals(A))
         => ( aa(set(A),$o,member(A,B2),real_Vector_Reals(A))
           => ( ( B2 != zero_zero(A) )
             => aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),real_Vector_Reals(A)) ) ) ) ) ).

% nonzero_Reals_divide
tff(fact_4639_Complex__in__Reals,axiom,
    ! [X2: real] : aa(set(complex),$o,member(complex,complex2(X2,zero_zero(real))),real_Vector_Reals(complex)) ).

% Complex_in_Reals
tff(fact_4640_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [A2: A] :
          ( aa(set(A),$o,member(A,A2),real_Vector_Reals(A))
         => ( ( A2 != zero_zero(A) )
           => aa(set(A),$o,member(A,aa(A,A,inverse_inverse(A),A2)),real_Vector_Reals(A)) ) ) ) ).

% nonzero_Reals_inverse
tff(fact_4641_integer__of__num__triv_I1_J,axiom,
    code_integer_of_num(one2) = one_one(code_integer) ).

% integer_of_num_triv(1)
tff(fact_4642_Re__prod__Reals,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,complex)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),A3)
         => aa(set(complex),$o,member(complex,aa(A,complex,F3,X4)),real_Vector_Reals(complex)) )
     => ( re(groups7121269368397514597t_prod(A,complex,F3,A3)) = groups7121269368397514597t_prod(A,real,aTP_Lamp_mj(fun(A,complex),fun(A,real),F3),A3) ) ) ).

% Re_prod_Reals
tff(fact_4643_integer__of__num_I2_J,axiom,
    ! [Nb: num] :
      ( code_integer_of_num(aa(num,num,bit0,Nb))
      = $let(
          k: code_integer,
          k := code_integer_of_num(Nb),
          aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),k),k) ) ) ).

% integer_of_num(2)
tff(fact_4644_integer__of__num__triv_I2_J,axiom,
    code_integer_of_num(aa(num,num,bit0,one2)) = aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)) ).

% integer_of_num_triv(2)
tff(fact_4645_int__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_int_of_integer(K)
      = $ite(
          aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),
          aa(int,int,uminus_uminus(int),code_int_of_integer(aa(code_integer,code_integer,uminus_uminus(code_integer),K))),
          $ite(K = zero_zero(code_integer),zero_zero(int),aa(product_prod(code_integer,code_integer),int,aa(fun(code_integer,fun(code_integer,int)),fun(product_prod(code_integer,code_integer),int),product_case_prod(code_integer,code_integer,int),aTP_Lamp_mo(code_integer,fun(code_integer,int))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ) ).

% int_of_integer_code
tff(fact_4646_bit__cut__integer__def,axiom,
    ! [K: code_integer] : ( code_bit_cut_integer(K) = aa($o,product_prod(code_integer,$o),aa(code_integer,fun($o,product_prod(code_integer,$o)),product_Pair(code_integer,$o),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),K),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),dvd_dvd(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),K)) ) ).

% bit_cut_integer_def
tff(fact_4647_num__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_num_of_integer(K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),one_one(code_integer)),one2,aa(product_prod(code_integer,code_integer),num,aa(fun(code_integer,fun(code_integer,num)),fun(product_prod(code_integer,code_integer),num),product_case_prod(code_integer,code_integer,num),aTP_Lamp_mp(code_integer,fun(code_integer,num))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% num_of_integer_code
tff(fact_4648_zero__integer_Orep__eq,axiom,
    code_int_of_integer(zero_zero(code_integer)) = zero_zero(int) ).

% zero_integer.rep_eq
tff(fact_4649_int__of__integer__numeral,axiom,
    ! [K: num] : ( code_int_of_integer(aa(num,code_integer,numeral_numeral(code_integer),K)) = aa(num,int,numeral_numeral(int),K) ) ).

% int_of_integer_numeral
tff(fact_4650_times__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa2: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),X2),Xa2)) = aa(int,int,aa(int,fun(int,int),times_times(int),code_int_of_integer(X2)),code_int_of_integer(Xa2)) ) ).

% times_integer.rep_eq
tff(fact_4651_divide__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa2: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),X2),Xa2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),code_int_of_integer(X2)),code_int_of_integer(Xa2)) ) ).

% divide_integer.rep_eq
tff(fact_4652_integer__less__iff,axiom,
    ! [K: code_integer,L: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),L)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),code_int_of_integer(K)),code_int_of_integer(L)) ) ).

% integer_less_iff
tff(fact_4653_less__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa2: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),X2),Xa2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),code_int_of_integer(X2)),code_int_of_integer(Xa2)) ) ).

% less_integer.rep_eq
tff(fact_4654_bit__cut__integer__code,axiom,
    ! [K: code_integer] :
      ( code_bit_cut_integer(K)
      = $ite(K = zero_zero(code_integer),aa($o,product_prod(code_integer,$o),aa(code_integer,fun($o,product_prod(code_integer,$o)),product_Pair(code_integer,$o),zero_zero(code_integer)),$false),aa(product_prod(code_integer,code_integer),product_prod(code_integer,$o),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,$o)),product_case_prod(code_integer,code_integer,product_prod(code_integer,$o)),aTP_Lamp_mq(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),K)),code_divmod_abs(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% bit_cut_integer_code
tff(fact_4655_nat__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_nat_of_integer(K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),zero_zero(code_integer)),zero_zero(nat),aa(product_prod(code_integer,code_integer),nat,aa(fun(code_integer,fun(code_integer,nat)),fun(product_prod(code_integer,code_integer),nat),product_case_prod(code_integer,code_integer,nat),aTP_Lamp_mr(code_integer,fun(code_integer,nat))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% nat_of_integer_code
tff(fact_4656_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F3: fun(nat,fun(A,A)),V: num,Nb: nat] :
      ( aa(nat,A,rec_nat(A,A2,F3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),Nb))
      = $let(
          pv: nat,
          pv := pred_numeral(V),
          aa(A,A,aa(nat,fun(A,A),F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pv),Nb)),aa(nat,A,rec_nat(A,A2,F3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pv),Nb))) ) ) ).

% rec_nat_add_eq_if
tff(fact_4657_old_Onat_Osimps_I7_J,axiom,
    ! [A: $tType,F1: A,F2: fun(nat,fun(A,A)),Nat: nat] : ( aa(nat,A,rec_nat(A,F1,F2),aa(nat,nat,suc,Nat)) = aa(A,A,aa(nat,fun(A,A),F2,Nat),aa(nat,A,rec_nat(A,F1,F2),Nat)) ) ).

% old.nat.simps(7)
tff(fact_4658_old_Onat_Osimps_I6_J,axiom,
    ! [A: $tType,F1: A,F2: fun(nat,fun(A,A))] : ( aa(nat,A,rec_nat(A,F1,F2),zero_zero(nat)) = F1 ) ).

% old.nat.simps(6)
tff(fact_4659_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F3: fun(nat,fun(A,A)),V: num] :
      ( aa(nat,A,rec_nat(A,A2,F3),aa(num,nat,numeral_numeral(nat),V))
      = $let(
          pv: nat,
          pv := pred_numeral(V),
          aa(A,A,aa(nat,fun(A,A),F3,pv),aa(nat,A,rec_nat(A,A2,F3),pv)) ) ) ).

% rec_nat_numeral
tff(fact_4660_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),zero_zero(code_integer))
     => ( code_nat_of_integer(K) = zero_zero(nat) ) ) ).

% nat_of_integer_non_positive
tff(fact_4661_nat__of__integer__code__post_I1_J,axiom,
    code_nat_of_integer(zero_zero(code_integer)) = zero_zero(nat) ).

% nat_of_integer_code_post(1)
tff(fact_4662_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] : ( code_nat_of_integer(aa(num,code_integer,numeral_numeral(code_integer),K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% nat_of_integer_code_post(3)
tff(fact_4663_divmod__abs__code_I6_J,axiom,
    ! [J2: code_integer] : ( code_divmod_abs(zero_zero(code_integer),J2) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ) ).

% divmod_abs_code(6)
tff(fact_4664_divmod__abs__code_I5_J,axiom,
    ! [J2: code_integer] : ( code_divmod_abs(J2,zero_zero(code_integer)) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),aa(code_integer,code_integer,abs_abs(code_integer),J2)) ) ).

% divmod_abs_code(5)
tff(fact_4665_old_Orec__nat__def,axiom,
    ! [A: $tType,X: A,Xa3: fun(nat,fun(A,A)),Xb3: nat] : ( aa(nat,A,rec_nat(A,X,Xa3),Xb3) = the(A,rec_set_nat(A,X,Xa3,Xb3)) ) ).

% old.rec_nat_def
tff(fact_4666_divmod__integer__code,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),L),
            $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),K),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_ms(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L))),
            $ite(
              L = zero_zero(code_integer),
              aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K),
              aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_apsnd(code_integer,code_integer,code_integer),uminus_uminus(code_integer)),$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_mt(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ).

% divmod_integer_code
tff(fact_4667_rec__nat__0__imp,axiom,
    ! [A: $tType,F3: fun(nat,A),F1: A,F2: fun(nat,fun(A,A))] :
      ( ( F3 = rec_nat(A,F1,F2) )
     => ( aa(nat,A,F3,zero_zero(nat)) = F1 ) ) ).

% rec_nat_0_imp
tff(fact_4668_subset__CollectI,axiom,
    ! [A: $tType,B4: set(A),A3: set(A),Q: fun(A,$o),P: fun(A,$o)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),A3)
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),B4)
           => ( aa(A,$o,Q,X4)
             => aa(A,$o,P,X4) ) )
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),B4),Q))),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) ) ) ).

% subset_CollectI
tff(fact_4669_subset__Collect__iff,axiom,
    ! [A: $tType,B4: set(A),A3: set(A),P: fun(A,$o)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),A3),P)))
      <=> ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),B4)
           => aa(A,$o,P,X3) ) ) ) ).

% subset_Collect_iff
tff(fact_4670_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F3: fun(nat,A),F1: A,F2: fun(nat,fun(A,A)),Nb: nat] :
      ( ( F3 = rec_nat(A,F1,F2) )
     => ( aa(nat,A,F3,aa(nat,nat,suc,Nb)) = aa(A,A,aa(nat,fun(A,A),F2,Nb),aa(nat,A,F3,Nb)) ) ) ).

% rec_nat_Suc_imp
tff(fact_4671_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F3: fun(nat,A),V: num,Nb: nat] : ( case_nat(A,A2,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),Nb)) = aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),Nb)) ) ).

% case_nat_add_eq_if
tff(fact_4672_or__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
            | ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ).

% or_int_rec
tff(fact_4673_prod__decode__aux_Oelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: product_prod(nat,nat)] :
      ( ( nat_prod_decode_aux(X2,Xa2) = Y2 )
     => ( Y2
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa2),X2),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Xa2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X2),Xa2)),nat_prod_decode_aux(aa(nat,nat,suc,X2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa2),aa(nat,nat,suc,X2)))) ) ) ).

% prod_decode_aux.elims
tff(fact_4674_or_Oidem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),A2) = A2 ) ) ).

% or.idem
tff(fact_4675_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) ) ) ).

% or.left_idem
tff(fact_4676_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) ) ) ).

% or.right_idem
tff(fact_4677_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),zero_zero(A)) = A2 ) ) ).

% or.right_neutral
tff(fact_4678_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),zero_zero(A)),A2) = A2 ) ) ).

% or.left_neutral
tff(fact_4679_take__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),B2)) ) ) ).

% take_bit_or
tff(fact_4680_push__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),bit_se4730199178511100633sh_bit(A,Nb,A2)),bit_se4730199178511100633sh_bit(A,Nb,B2)) ) ) ).

% push_bit_or
tff(fact_4681_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,uminus_uminus(A),one_one(A))),X2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_left
tff(fact_4682_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_right
tff(fact_4683_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% or_nonnegative_int_iff
tff(fact_4684_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)),zero_zero(int))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        | aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% or_negative_int_iff
tff(fact_4685_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y2)) ) ) ).

% bit.de_Morgan_disj
tff(fact_4686_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y2)) ) ) ).

% bit.de_Morgan_conj
tff(fact_4687_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F3: fun(nat,A),V: num] : ( case_nat(A,A2,F3,aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,F3,pred_numeral(V)) ) ).

% case_nat_numeral
tff(fact_4688_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2)) ) ) ).

% or_numerals(8)
tff(fact_4689_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2)) ) ) ).

% or_numerals(2)
tff(fact_4690_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),X2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_left
tff(fact_4691_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_right
tff(fact_4692_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2))) ) ) ).

% or_numerals(3)
tff(fact_4693_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2)) ) ) ).

% or_numerals(1)
tff(fact_4694_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2)) ) ) ).

% or_numerals(5)
tff(fact_4695_or__minus__numerals_I2_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb))) ) ).

% or_minus_numerals(2)
tff(fact_4696_or__minus__numerals_I6_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))),one_one(int)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb))) ) ).

% or_minus_numerals(6)
tff(fact_4697_or__minus__minus__numerals,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Ma)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Nb)),one_one(int)))) ) ).

% or_minus_minus_numerals
tff(fact_4698_and__minus__minus__numerals,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Ma)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Nb)),one_one(int)))) ) ).

% and_minus_minus_numerals
tff(fact_4699_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2)))) ) ) ).

% or_numerals(4)
tff(fact_4700_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2)))) ) ) ).

% or_numerals(6)
tff(fact_4701_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X2: num,Y2: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X2)),aa(num,A,numeral_numeral(A),Y2)))) ) ) ).

% or_numerals(7)
tff(fact_4702_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: fun(B,A),F1: B,F2: fun(nat,B),Nat: nat] : ( aa(B,A,H,case_nat(B,F1,F2,Nat)) = case_nat(A,aa(B,A,H,F1),aa(fun(nat,B),fun(nat,A),aTP_Lamp_mu(fun(B,A),fun(fun(nat,B),fun(nat,A)),H),F2),Nat) ) ).

% nat.case_distrib
tff(fact_4703_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & ( B2 = zero_zero(A) ) ) ) ) ).

% or_eq_0_iff
tff(fact_4704_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),zero_zero(A)) = X2 ) ) ).

% bit.disj_zero_right
tff(fact_4705_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y2: A,Z: A,X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y2),Z)),X2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y2),X2)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Z),X2)) ) ) ).

% bit.disj_conj_distrib2
tff(fact_4706_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y2: A,Z: A,X2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y2),Z)),X2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y2),X2)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Z),X2)) ) ) ).

% bit.conj_disj_distrib2
tff(fact_4707_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y2),Z)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),Z)) ) ) ).

% bit.disj_conj_distrib
tff(fact_4708_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y2),Z)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),Z)) ) ) ).

% bit.conj_disj_distrib
tff(fact_4709_bit__or__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)),Nb)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
            | aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),Nb) ) ) ) ).

% bit_or_iff
tff(fact_4710_or_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),C2)) ) ) ).

% or.assoc
tff(fact_4711_or_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),A2) ) ) ).

% or.commute
tff(fact_4712_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),C2)) ) ) ).

% or.left_commute
tff(fact_4713_bit__or__int__iff,axiom,
    ! [K: int,L: int,Nb: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)),Nb)
    <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Nb)
        | aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),Nb) ) ) ).

% bit_or_int_iff
tff(fact_4714_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( ring_1_of_int(A,aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),ring_1_of_int(A,K)),ring_1_of_int(A,L)) ) ) ).

% of_int_or_eq
tff(fact_4715_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(nat,A,semiring_1_of_nat(A),Ma)),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% of_nat_or_eq
tff(fact_4716_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F2: fun(nat,A),X22: nat] : ( case_nat(A,F1,F2,aa(nat,nat,suc,X22)) = aa(nat,A,F2,X22) ) ).

% old.nat.simps(5)
tff(fact_4717_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F2: fun(nat,A)] : ( case_nat(A,F1,F2,zero_zero(nat)) = F1 ) ).

% old.nat.simps(4)
tff(fact_4718_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)) ) ).

% or_greater_eq
tff(fact_4719_OR__lower,axiom,
    ! [X2: int,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X2),Y2)) ) ) ).

% OR_lower
tff(fact_4720_disjunctive__add,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( ! [N: nat] :
              ( ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
              | ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) ) ) ) ).

% disjunctive_add
tff(fact_4721_plus__and__or,axiom,
    ! [X2: int,Y2: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Y2)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X2),Y2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),Y2) ) ).

% plus_and_or
tff(fact_4722_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),aa(A,A,bit_ri4277139882892585799ns_not(A),B2))) ) ) ).

% or_eq_not_not_and
tff(fact_4723_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),aa(A,A,bit_ri4277139882892585799ns_not(A),B2))) ) ) ).

% and_eq_not_not_or
tff(fact_4724_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat = zero_zero(nat) )
    <=> case_nat($o,$true,aTP_Lamp_mv(nat,$o),Nat) ) ).

% nat.disc_eq_case(1)
tff(fact_4725_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( Nat != zero_zero(nat) )
    <=> case_nat($o,$false,aTP_Lamp_mw(nat,$o),Nat) ) ).

% nat.disc_eq_case(2)
tff(fact_4726_or__int__def,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),aa(int,int,bit_ri4277139882892585799ns_not(int),L))) ) ).

% or_int_def
tff(fact_4727_or__not__numerals_I1_J,axiom,
    aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),zero_zero(int)) ).

% or_not_numerals(1)
tff(fact_4728_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),Y2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y2))) ) ) ).

% bit.xor_def2
tff(fact_4729_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X2),Y2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),aa(A,A,bit_ri4277139882892585799ns_not(A),Y2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X2)),Y2)) ) ) ).

% bit.xor_def
tff(fact_4730_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),Nb),A2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),bit_se4730199178511100633sh_bit(A,Nb,one_one(A))) ) ) ).

% set_bit_eq_or
tff(fact_4731_xor__int__def,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),aa(int,int,bit_ri4277139882892585799ns_not(int),L))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),L)) ) ).

% xor_int_def
tff(fact_4732_concat__bit__def,axiom,
    ! [Nb: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(Nb,K),L) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Nb),K)),bit_se4730199178511100633sh_bit(int,Nb,L)) ) ).

% concat_bit_def
tff(fact_4733_set__bit__int__def,axiom,
    ! [Nb: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Nb),K) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),bit_se4730199178511100633sh_bit(int,Nb,one_one(int))) ) ).

% set_bit_int_def
tff(fact_4734_less__eq__nat_Osimps_I2_J,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Ma)),Nb)
    <=> case_nat($o,$false,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb) ) ).

% less_eq_nat.simps(2)
tff(fact_4735_even__or__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_or_iff
tff(fact_4736_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,X2: A,Y2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),X2) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),X2) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),Y2) = zero_zero(A) )
             => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),Y2) = aa(A,A,uminus_uminus(A),one_one(A)) )
               => ( X2 = Y2 ) ) ) ) ) ) ).

% bit.complement_unique
tff(fact_4737_or__not__numerals_I4_J,axiom,
    ! [Ma: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int)) ) ).

% or_not_numerals(4)
tff(fact_4738_or__not__numerals_I2_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb))) ) ).

% or_not_numerals(2)
tff(fact_4739_diff__Suc,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),aa(nat,nat,suc,Nb)) = case_nat(nat,zero_zero(nat),aTP_Lamp_jv(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)) ) ).

% diff_Suc
tff(fact_4740_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X2: A,Y2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X2),Y2) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X2),Y2) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( aa(A,A,bit_ri4277139882892585799ns_not(A),X2) = Y2 ) ) ) ) ).

% bit.compl_unique
tff(fact_4741_or__not__numerals_I3_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb))) ) ).

% or_not_numerals(3)
tff(fact_4742_or__not__numerals_I7_J,axiom,
    ! [Ma: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),zero_zero(int)) ) ).

% or_not_numerals(7)
tff(fact_4743_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,W))),Nb)
        <=> case_nat($o,$false,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),Nb) ) ) ).

% bit_numeral_rec(1)
tff(fact_4744_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,W))),Nb)
        <=> case_nat($o,$true,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),Nb) ) ) ).

% bit_numeral_rec(2)
tff(fact_4745_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType,X2: A,F3: fun(nat,A),Nb: nat] :
      ( case_nat(A,X2,F3,Nb)
      = $ite(Nb = zero_zero(nat),X2,aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))) ) ).

% Nitpick.case_nat_unfold
tff(fact_4746_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
         => ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),A2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Nb))) ) ) ) ).

% signed_take_bit_eq_if_negative
tff(fact_4747_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,Nb)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),bit_se2239418461657761734s_mask(A,Nb)) ) ) ).

% mask_Suc_exp
tff(fact_4748_or__not__numerals_I6_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb)))) ) ).

% or_not_numerals(6)
tff(fact_4749_or__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),one_one(A)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))) ) ) ).

% or_one_eq
tff(fact_4750_one__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))) ) ) ).

% one_or_eq
tff(fact_4751_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,Nb)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,Nb))) ) ) ).

% mask_Suc_double
tff(fact_4752_OR__upper,axiom,
    ! [X2: int,Nb: nat,Y2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X2),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y2),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb))
         => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X2),Y2)),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ) ) ).

% OR_upper
tff(fact_4753_or__not__numerals_I5_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb))))) ) ).

% or_not_numerals(5)
tff(fact_4754_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),A2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Nb)))) ) ) ).

% signed_take_bit_def
tff(fact_4755_or__not__numerals_I9_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb))))) ) ).

% or_not_numerals(9)
tff(fact_4756_or__not__numerals_I8_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Ma))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb))))) ) ).

% or_not_numerals(8)
tff(fact_4757_prod__decode__aux_Osimps,axiom,
    ! [K: nat,Ma: nat] :
      ( nat_prod_decode_aux(K,Ma)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),K),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),Ma)),nat_prod_decode_aux(aa(nat,nat,suc,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),aa(nat,nat,suc,K)))) ) ).

% prod_decode_aux.simps
tff(fact_4758_or__minus__numerals_I5_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))),one_one(int)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(one2,bitM(Nb)))) ) ).

% or_minus_numerals(5)
tff(fact_4759_or__minus__numerals_I1_J,axiom,
    ! [Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(one2,bitM(Nb)))) ) ).

% or_minus_numerals(1)
tff(fact_4760_or__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)
      = $ite(
          ( ( K = aa(int,int,uminus_uminus(int),one_one(int)) )
          | ( L = aa(int,int,uminus_uminus(int),one_one(int)) ) ),
          aa(int,int,uminus_uminus(int),one_one(int)),
          $ite(
            K = zero_zero(int),
            L,
            $ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),ord_max(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))))) ) ) ) ).

% or_int_unfold
tff(fact_4761_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o,Q: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),
              (P)
            | (Q))
          = aa(A,A,aa(A,fun(A,A),ord_max(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_or_iff
tff(fact_4762_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),V),aa(num,A,numeral_numeral(A),U)) ) ) ).

% max_number_of(1)
tff(fact_4763_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),aa(num,A,numeral_numeral(A),X2)) = aa(num,A,numeral_numeral(A),X2) ) ) ).

% max_0_1(3)
tff(fact_4764_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),X2)),zero_zero(A)) = aa(num,A,numeral_numeral(A),X2) ) ) ).

% max_0_1(4)
tff(fact_4765_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),one_one(A)) = one_one(A) ) ) ).

% max_0_1(1)
tff(fact_4766_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),zero_zero(A)) = one_one(A) ) ) ).

% max_0_1(2)
tff(fact_4767_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),aa(num,A,numeral_numeral(A),X2)) = aa(num,A,numeral_numeral(A),X2) ) ) ).

% max_0_1(5)
tff(fact_4768_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),X2)),one_one(A)) = aa(num,A,numeral_numeral(A),X2) ) ) ).

% max_0_1(6)
tff(fact_4769_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),U)) ) ) ).

% max_number_of(2)
tff(fact_4770_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),V),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))) ) ) ).

% max_number_of(3)
tff(fact_4771_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))) ) ) ).

% max_number_of(4)
tff(fact_4772_or__nat__numerals_I2_J,axiom,
    ! [Y2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y2))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y2)) ) ).

% or_nat_numerals(2)
tff(fact_4773_or__nat__numerals_I4_J,axiom,
    ! [X2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X2))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X2)) ) ).

% or_nat_numerals(4)
tff(fact_4774_or__nat__numerals_I1_J,axiom,
    ! [Y2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Y2))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y2)) ) ).

% or_nat_numerals(1)
tff(fact_4775_or__nat__numerals_I3_J,axiom,
    ! [X2: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,X2))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X2)) ) ).

% or_nat_numerals(3)
tff(fact_4776_or__minus__numerals_I8_J,axiom,
    ! [Nb: num,Ma: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))),aa(num,int,numeral_numeral(int),Ma)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(Ma,aa(num,num,bit0,Nb)))) ) ).

% or_minus_numerals(8)
tff(fact_4777_or__minus__numerals_I4_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(Ma,aa(num,num,bit0,Nb)))) ) ).

% or_minus_numerals(4)
tff(fact_4778_or__minus__numerals_I7_J,axiom,
    ! [Nb: num,Ma: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))),aa(num,int,numeral_numeral(int),Ma)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(Ma,bitM(Nb)))) ) ).

% or_minus_numerals(7)
tff(fact_4779_or__minus__numerals_I3_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(Ma,bitM(Nb)))) ) ).

% or_minus_numerals(3)
tff(fact_4780_of__nat__max,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: nat,Y2: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),X2),Y2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(nat,A,semiring_1_of_nat(A),X2)),aa(nat,A,semiring_1_of_nat(A),Y2)) ) ) ).

% of_nat_max
tff(fact_4781_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2)),Z) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Z)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y2),Z)) ) ) ).

% max_diff_distrib_left
tff(fact_4782_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2)),Z) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y2),Z)) ) ) ).

% max_add_distrib_left
tff(fact_4783_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),ord_max(A),Y2),Z)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z)) ) ) ).

% max_add_distrib_right
tff(fact_4784_or__not__num__neg_Osimps_I1_J,axiom,
    bit_or_not_num_neg(one2,one2) = one2 ).

% or_not_num_neg.simps(1)
tff(fact_4785_max__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Xa3: A] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),X),Xa3)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Xa3),Xa3,X) ) ) ).

% max_def_raw
tff(fact_4786_set__bit__nat__def,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5668285175392031749et_bit(nat),Ma),Nb) = aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),Nb),bit_se4730199178511100633sh_bit(nat,Ma,one_one(nat))) ) ).

% set_bit_nat_def
tff(fact_4787_or__not__num__neg_Osimps_I4_J,axiom,
    ! [Nb: num] : ( bit_or_not_num_neg(aa(num,num,bit0,Nb),one2) = aa(num,num,bit0,one2) ) ).

% or_not_num_neg.simps(4)
tff(fact_4788_or__not__num__neg_Osimps_I6_J,axiom,
    ! [Nb: num,Ma: num] : ( bit_or_not_num_neg(aa(num,num,bit0,Nb),aa(num,num,bit1,Ma)) = aa(num,num,bit0,bit_or_not_num_neg(Nb,Ma)) ) ).

% or_not_num_neg.simps(6)
tff(fact_4789_or__not__num__neg_Osimps_I7_J,axiom,
    ! [Nb: num] : ( bit_or_not_num_neg(aa(num,num,bit1,Nb),one2) = one2 ) ).

% or_not_num_neg.simps(7)
tff(fact_4790_or__not__num__neg_Osimps_I3_J,axiom,
    ! [Ma: num] : ( bit_or_not_num_neg(one2,aa(num,num,bit1,Ma)) = aa(num,num,bit1,Ma) ) ).

% or_not_num_neg.simps(3)
tff(fact_4791_or__not__num__neg_Osimps_I5_J,axiom,
    ! [Nb: num,Ma: num] : ( bit_or_not_num_neg(aa(num,num,bit0,Nb),aa(num,num,bit0,Ma)) = bitM(bit_or_not_num_neg(Nb,Ma)) ) ).

% or_not_num_neg.simps(5)
tff(fact_4792_or__not__num__neg_Osimps_I9_J,axiom,
    ! [Nb: num,Ma: num] : ( bit_or_not_num_neg(aa(num,num,bit1,Nb),aa(num,num,bit1,Ma)) = bitM(bit_or_not_num_neg(Nb,Ma)) ) ).

% or_not_num_neg.simps(9)
tff(fact_4793_or__nat__def,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),Ma),Nb) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(nat,int,semiring_1_of_nat(int),Ma)),aa(nat,int,semiring_1_of_nat(int),Nb))) ) ).

% or_nat_def
tff(fact_4794_or__not__num__neg_Osimps_I2_J,axiom,
    ! [Ma: num] : ( bit_or_not_num_neg(one2,aa(num,num,bit0,Ma)) = aa(num,num,bit1,Ma) ) ).

% or_not_num_neg.simps(2)
tff(fact_4795_or__not__num__neg_Osimps_I8_J,axiom,
    ! [Nb: num,Ma: num] : ( bit_or_not_num_neg(aa(num,num,bit1,Nb),aa(num,num,bit0,Ma)) = bitM(bit_or_not_num_neg(Nb,Ma)) ) ).

% or_not_num_neg.simps(8)
tff(fact_4796_or__not__num__neg_Oelims,axiom,
    ! [X2: num,Xa2: num,Y2: num] :
      ( ( bit_or_not_num_neg(X2,Xa2) = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2 != one2 ) ) )
       => ( ( ( X2 = one2 )
           => ! [M3: num] :
                ( ( Xa2 = aa(num,num,bit0,M3) )
               => ( Y2 != aa(num,num,bit1,M3) ) ) )
         => ( ( ( X2 = one2 )
             => ! [M3: num] :
                  ( ( Xa2 = aa(num,num,bit1,M3) )
                 => ( Y2 != aa(num,num,bit1,M3) ) ) )
           => ( ( ? [N: num] : ( X2 = aa(num,num,bit0,N) )
               => ( ( Xa2 = one2 )
                 => ( Y2 != aa(num,num,bit0,one2) ) ) )
             => ( ! [N: num] :
                    ( ( X2 = aa(num,num,bit0,N) )
                   => ! [M3: num] :
                        ( ( Xa2 = aa(num,num,bit0,M3) )
                       => ( Y2 != bitM(bit_or_not_num_neg(N,M3)) ) ) )
               => ( ! [N: num] :
                      ( ( X2 = aa(num,num,bit0,N) )
                     => ! [M3: num] :
                          ( ( Xa2 = aa(num,num,bit1,M3) )
                         => ( Y2 != aa(num,num,bit0,bit_or_not_num_neg(N,M3)) ) ) )
                 => ( ( ? [N: num] : ( X2 = aa(num,num,bit1,N) )
                     => ( ( Xa2 = one2 )
                       => ( Y2 != one2 ) ) )
                   => ( ! [N: num] :
                          ( ( X2 = aa(num,num,bit1,N) )
                         => ! [M3: num] :
                              ( ( Xa2 = aa(num,num,bit0,M3) )
                             => ( Y2 != bitM(bit_or_not_num_neg(N,M3)) ) ) )
                     => ~ ! [N: num] :
                            ( ( X2 = aa(num,num,bit1,N) )
                           => ! [M3: num] :
                                ( ( Xa2 = aa(num,num,bit1,M3) )
                               => ( Y2 != bitM(bit_or_not_num_neg(N,M3)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
tff(fact_4797_int__numeral__or__not__num__neg,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(Ma,Nb))) ) ).

% int_numeral_or_not_num_neg
tff(fact_4798_int__numeral__not__or__num__neg,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Ma))),aa(num,int,numeral_numeral(int),Nb)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(Nb,Ma))) ) ).

% int_numeral_not_or_num_neg
tff(fact_4799_numeral__or__not__num__eq,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,int,numeral_numeral(int),bit_or_not_num_neg(Ma,Nb)) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb)))) ) ).

% numeral_or_not_num_eq
tff(fact_4800_Suc__0__or__eq,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),Nb) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) ) ).

% Suc_0_or_eq
tff(fact_4801_or__Suc__0__eq,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),Nb),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))) ) ).

% or_Suc_0_eq
tff(fact_4802_or__nat__rec,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),Ma),Nb)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Ma)
            | ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% or_nat_rec
tff(fact_4803_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) = A2 ) ) ) ).

% max.absorb3
tff(fact_4804_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) = B2 ) ) ) ).

% max.absorb4
tff(fact_4805_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2)),Z)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Z)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),Z) ) ) ) ).

% max_less_iff_conj
tff(fact_4806_max__enat__simps_I5_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),extend4730790105801354508finity(extended_enat)),Q2) = extend4730790105801354508finity(extended_enat) ) ).

% max_enat_simps(5)
tff(fact_4807_max__enat__simps_I4_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ).

% max_enat_simps(4)
tff(fact_4808_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),Q2),zero_zero(extended_enat)) = Q2 ) ).

% max_enat_simps(2)
tff(fact_4809_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),zero_zero(extended_enat)),Q2) = Q2 ) ).

% max_enat_simps(3)
tff(fact_4810_max__Suc__Suc,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,Ma)),aa(nat,nat,suc,Nb)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Ma),Nb)) ) ).

% max_Suc_Suc
tff(fact_4811_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),B2) = zero_zero(nat) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% max_nat.eq_neutr_iff
tff(fact_4812_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),zero_zero(nat)),A2) = A2 ) ).

% max_nat.left_neutral
tff(fact_4813_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( zero_zero(nat) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),B2) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% max_nat.neutr_eq_iff
tff(fact_4814_max__nat_Oright__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),zero_zero(nat)) = A2 ) ).

% max_nat.right_neutral
tff(fact_4815_max__0L,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),zero_zero(nat)),Nb) = Nb ) ).

% max_0L
tff(fact_4816_max__0R,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Nb),zero_zero(nat)) = Nb ) ).

% max_0R
tff(fact_4817_max__enat__simps_I1_J,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),extended_enat2(Ma)),extended_enat2(Nb)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Ma),Nb)) ) ).

% max_enat_simps(1)
tff(fact_4818_of__nat__of__integer,axiom,
    ! [K: code_integer] : ( aa(nat,code_integer,semiring_1_of_nat(code_integer),code_nat_of_integer(K)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),ord_max(code_integer),zero_zero(code_integer)),K) ) ).

% of_nat_of_integer
tff(fact_4819_max__Suc__numeral,axiom,
    ! [Nb: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,Nb)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Nb),pred_numeral(K))) ) ).

% max_Suc_numeral
tff(fact_4820_max__numeral__Suc,axiom,
    ! [K: num,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Nb)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),pred_numeral(K)),Nb)) ) ).

% max_numeral_Suc
tff(fact_4821_nat__mult__max__right,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Nb),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Q2)) ) ).

% nat_mult_max_right
tff(fact_4822_nat__mult__max__left,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Ma),Nb)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q2)) ) ).

% nat_mult_max_left
tff(fact_4823_nat__add__max__left,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Ma),Nb)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Q2)) ) ).

% nat_add_max_left
tff(fact_4824_nat__add__max__right,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Nb),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Q2)) ) ).

% nat_add_max_right
tff(fact_4825_nat__minus__add__max,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)),Ma) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Nb),Ma) ) ).

% nat_minus_add_max
tff(fact_4826_max__Suc2,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Ma),aa(nat,nat,suc,Nb)) = case_nat(nat,aa(nat,nat,suc,Nb),aTP_Lamp_mx(nat,fun(nat,nat),Nb),Ma) ) ).

% max_Suc2
tff(fact_4827_max__Suc1,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,Nb)),Ma) = case_nat(nat,aa(nat,nat,suc,Nb),aTP_Lamp_my(nat,fun(nat,nat),Nb),Ma) ) ).

% max_Suc1
tff(fact_4828_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ) ).

% max.strict_coboundedI2
tff(fact_4829_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ) ).

% max.strict_coboundedI1
tff(fact_4830_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( ( A2 = aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) )
            & ( A2 != B2 ) ) ) ) ).

% max.strict_order_iff
tff(fact_4831_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A2)
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% max.strict_boundedE
tff(fact_4832_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X2)
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),Y2) ) ) ) ).

% less_max_iff_disj
tff(fact_4833_or__nat__unfold,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),Ma),Nb)
      = $ite(
          Ma = zero_zero(nat),
          Nb,
          $ite(Nb = zero_zero(nat),Ma,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),modulo_modulo(nat,Ma,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),modulo_modulo(nat,Nb,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ) ) ).

% or_nat_unfold
tff(fact_4834_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea3799213064322606851m_diff(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A)),bit_se5824344971392196577ns_xor(A)) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
tff(fact_4835_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: fun(A,$o),F1: A,F2: fun(nat,A),Nat: nat] :
      ( aa(A,$o,P,case_nat(A,F1,F2,Nat))
    <=> ~ ( ( ( Nat = zero_zero(nat) )
            & ~ aa(A,$o,P,F1) )
          | ( ( Nat = aa(nat,nat,suc,pred(Nat)) )
            & ~ aa(A,$o,P,aa(nat,A,F2,pred(Nat))) ) ) ) ).

% nat.split_sels(2)
tff(fact_4836_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: fun(A,$o),F1: A,F2: fun(nat,A),Nat: nat] :
      ( aa(A,$o,P,case_nat(A,F1,F2,Nat))
    <=> ( ( ( Nat = zero_zero(nat) )
         => aa(A,$o,P,F1) )
        & ( ( Nat = aa(nat,nat,suc,pred(Nat)) )
         => aa(A,$o,P,aa(nat,A,F2,pred(Nat))) ) ) ) ).

% nat.split_sels(1)
tff(fact_4837_pred__def,axiom,
    ! [Nat: nat] : ( pred(Nat) = case_nat(nat,zero_zero(nat),aTP_Lamp_jv(nat,nat),Nat) ) ).

% pred_def
tff(fact_4838_bezw__0,axiom,
    ! [X2: nat] : ( bezw(X2,zero_zero(nat)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)) ) ).

% bezw_0
tff(fact_4839_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: fun(nat,A),D2: fun(nat,A),A3: set(nat)] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_mz(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D2)),A3)
          = $ite(
              ( finite_finite2(nat,A3)
              & aa(set(nat),$o,member(nat,zero_zero(nat)),A3) ),
              aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,C2,zero_zero(nat))),aa(nat,A,D2,zero_zero(nat))),
              zero_zero(A) ) ) ) ).

% sum_zero_power'
tff(fact_4840_Suc__0__div__numeral,axiom,
    ! [K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),K)) = aa(product_prod(nat,nat),nat,product_fst(nat,nat),unique8689654367752047608divmod(nat,one2,K)) ) ).

% Suc_0_div_numeral
tff(fact_4841_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list(A)] : finite_finite2(A,aa(list(A),set(A),set2(A),Xs)) ).

% List.finite_set
tff(fact_4842_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [F4: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,F4)
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),F4) = zero_zero(B) )
          <=> ! [X3: A] :
                ( aa(set(A),$o,member(A,X3),F4)
               => ( aa(A,B,F3,X3) = zero_zero(B) ) ) ) ) ) ).

% sum_eq_0_iff
tff(fact_4843_sum_Oinfinite,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ~ finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = zero_zero(B) ) ) ) ).

% sum.infinite
tff(fact_4844_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( semidom(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( ( groups7121269368397514597t_prod(A,B,F3,A3) = zero_zero(B) )
          <=> ? [X3: A] :
                ( aa(set(A),$o,member(A,X3),A3)
                & ( aa(A,B,F3,X3) = zero_zero(B) ) ) ) ) ) ).

% prod_zero_iff
tff(fact_4845_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ finite_finite2(A,set_or1337092689740270186AtMost(A,A2,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% infinite_Icc_iff
tff(fact_4846_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ finite_finite2(A,set_or7035219750837199246ssThan(A,A2,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% infinite_Ico_iff
tff(fact_4847_sum_Odelta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B)] :
          ( finite_finite2(A,S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_na(A,fun(fun(A,B),fun(A,B)),A2),B2)),S3)
            = $ite(aa(set(A),$o,member(A,A2),S3),aa(A,B,B2,A2),zero_zero(B)) ) ) ) ).

% sum.delta'
tff(fact_4848_sum_Odelta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B)] :
          ( finite_finite2(A,S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_nb(A,fun(fun(A,B),fun(A,B)),A2),B2)),S3)
            = $ite(aa(set(A),$o,member(A,A2),S3),aa(A,B,B2,A2),zero_zero(B)) ) ) ) ).

% sum.delta
tff(fact_4849_prod_Odelta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B)] :
          ( finite_finite2(A,S3)
         => ( groups7121269368397514597t_prod(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_nc(A,fun(fun(A,B),fun(A,B)),A2),B2),S3)
            = $ite(aa(set(A),$o,member(A,A2),S3),aa(A,B,B2,A2),one_one(B)) ) ) ) ).

% prod.delta
tff(fact_4850_prod_Odelta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B)] :
          ( finite_finite2(A,S3)
         => ( groups7121269368397514597t_prod(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_nd(A,fun(fun(A,B),fun(A,B)),A2),B2),S3)
            = $ite(aa(set(A),$o,member(A,A2),S3),aa(A,B,B2,A2),one_one(B)) ) ) ) ).

% prod.delta'
tff(fact_4851_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [P: fun(nat,$o),F3: fun(nat,A)] :
          ( finite_finite2(nat,aa(fun(nat,$o),set(nat),collect(nat),P))
         => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ne(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),P),F3)) ) ) ).

% summable_If_finite
tff(fact_4852_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [A3: set(nat),F3: fun(nat,A)] :
          ( finite_finite2(nat,A3)
         => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_nf(set(nat),fun(fun(nat,A),fun(nat,A)),A3),F3)) ) ) ).

% summable_If_finite_set
tff(fact_4853_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [K: num,L: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),L)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,K,L)) ) ) ).

% numeral_div_numeral
tff(fact_4854_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( finite_finite2(A,A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),groups7121269368397514597t_prod(A,nat,F3,A3))
      <=> ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),A3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,F3,X3)) ) ) ) ).

% prod_pos_nat_iff
tff(fact_4855_fst__divmod__nat,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(product_prod(nat,nat),nat,product_fst(nat,nat),divmod_nat(Ma,Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb) ) ).

% fst_divmod_nat
tff(fact_4856_one__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),Nb)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,one2,Nb)) ) ) ).

% one_div_numeral
tff(fact_4857_sum__zero__power,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: fun(nat,A),A3: set(nat)] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ng(fun(nat,A),fun(nat,A),C2)),A3)
          = $ite(
              ( finite_finite2(nat,A3)
              & aa(set(nat),$o,member(nat,zero_zero(nat)),A3) ),
              aa(nat,A,C2,zero_zero(nat)),
              zero_zero(A) ) ) ) ).

% sum_zero_power
tff(fact_4858_fst__def,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod(A,B)] : ( aa(product_prod(A,B),A,product_fst(A,B),Prod) = aa(product_prod(A,B),A,aa(fun(A,fun(B,A)),fun(product_prod(A,B),A),product_case_prod(A,B,A),aTP_Lamp_aq(A,fun(B,A))),Prod) ) ).

% fst_def
tff(fact_4859_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set(A),Nb: nat] :
      ( finite_finite2(A,A3)
     => finite_finite2(list(A),aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(nat,fun(list(A),$o),aTP_Lamp_nh(set(A),fun(nat,fun(list(A),$o)),A3),Nb))) ) ).

% finite_lists_length_eq
tff(fact_4860_finite__less__ub,axiom,
    ! [F3: fun(nat,nat),U: nat] :
      ( ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(nat,nat,F3,N))
     => finite_finite2(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_ni(fun(nat,nat),fun(nat,fun(nat,$o)),F3),U))) ) ).

% finite_less_ub
tff(fact_4861_sum_Oswap__restrict,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(A),B4: set(B),G: fun(A,fun(B,C)),R3: fun(A,fun(B,$o))] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(B,B4)
           => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(A,fun(B,$o)),fun(A,C),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(A,C)),aTP_Lamp_nk(set(B),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(A,C))),B4),G),R3)),A3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(A,fun(B,$o)),fun(B,C),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(B,C)),aTP_Lamp_nn(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(B,C))),A3),G),R3)),B4) ) ) ) ) ).

% sum.swap_restrict
tff(fact_4862_prod_Oswap__restrict,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(A),B4: set(B),G: fun(A,fun(B,C)),R3: fun(A,fun(B,$o))] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(B,B4)
           => ( groups7121269368397514597t_prod(A,C,aa(fun(A,fun(B,$o)),fun(A,C),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(A,C)),aTP_Lamp_no(set(B),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(A,C))),B4),G),R3),A3) = groups7121269368397514597t_prod(B,C,aa(fun(A,fun(B,$o)),fun(B,C),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(B,C)),aTP_Lamp_nq(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(B,C))),A3),G),R3),B4) ) ) ) ) ).

% prod.swap_restrict
tff(fact_4863_finite__M__bounded__by__nat,axiom,
    ! [P: fun(nat,$o),I3: nat] : finite_finite2(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_nr(fun(nat,$o),fun(nat,fun(nat,$o)),P),I3))) ).

% finite_M_bounded_by_nat
tff(fact_4864_bounded__nat__set__is__finite,axiom,
    ! [N3: set(nat),Nb: nat] :
      ( ! [X4: nat] :
          ( aa(set(nat),$o,member(nat,X4),N3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),Nb) )
     => finite_finite2(nat,N3) ) ).

% bounded_nat_set_is_finite
tff(fact_4865_finite__nat__set__iff__bounded,axiom,
    ! [N3: set(nat)] :
      ( finite_finite2(nat,N3)
    <=> ? [M4: nat] :
        ! [X3: nat] :
          ( aa(set(nat),$o,member(nat,X3),N3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),M4) ) ) ).

% finite_nat_set_iff_bounded
tff(fact_4866_finite__list,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ? [Xs2: list(A)] : ( aa(list(A),set(A),set2(A),Xs2) = A3 ) ) ).

% finite_list
tff(fact_4867_prod__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( ? [X: A] :
                ( aa(set(A),$o,member(A,X),A3)
                & ( aa(A,B,F3,X) = zero_zero(B) ) )
           => ( groups7121269368397514597t_prod(A,B,F3,A3) = zero_zero(B) ) ) ) ) ).

% prod_zero
tff(fact_4868_infinite__Icc,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ finite_finite2(A,set_or1337092689740270186AtMost(A,A2,B2)) ) ) ).

% infinite_Icc
tff(fact_4869_infinite__Ico,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ finite_finite2(A,set_or7035219750837199246ssThan(A,A2,B2)) ) ) ).

% infinite_Ico
tff(fact_4870_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set(A),Nb: nat] :
      ( finite_finite2(A,A3)
     => finite_finite2(list(A),aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(nat,fun(list(A),$o),aTP_Lamp_ns(set(A),fun(nat,fun(list(A),$o)),A3),Nb))) ) ).

% finite_lists_length_le
tff(fact_4871_summable__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [N3: set(nat),F3: fun(nat,A)] :
          ( finite_finite2(nat,N3)
         => ( ! [N: nat] :
                ( ~ aa(set(nat),$o,member(nat,N),N3)
               => ( aa(nat,A,F3,N) = zero_zero(A) ) )
           => summable(A,F3) ) ) ) ).

% summable_finite
tff(fact_4872_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N3: set(nat),Nb: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N3),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))
     => finite_finite2(nat,N3) ) ).

% subset_eq_atLeast0_atMost_finite
tff(fact_4873_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N3: set(nat),Nb: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N3),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))
     => finite_finite2(nat,N3) ) ).

% subset_eq_atLeast0_lessThan_finite
tff(fact_4874_sum_Ofinite__Collect__op,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),X2: fun(A,B),Y2: fun(A,B)] :
          ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nt(set(A),fun(fun(A,B),fun(A,$o)),I5),X2)))
         => ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nt(set(A),fun(fun(A,B),fun(A,$o)),I5),Y2)))
           => finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_nu(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),I5),X2),Y2))) ) ) ) ).

% sum.finite_Collect_op
tff(fact_4875_prod_Ofinite__Collect__op,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),X2: fun(A,B),Y2: fun(A,B)] :
          ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nv(set(A),fun(fun(A,B),fun(A,$o)),I5),X2)))
         => ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nv(set(A),fun(fun(A,B),fun(A,$o)),I5),Y2)))
           => finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_nw(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),I5),X2),Y2))) ) ) ) ).

% prod.finite_Collect_op
tff(fact_4876_sum_Ointer__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),P: fun(A,$o)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,$o),fun(A,B),aTP_Lamp_nx(fun(A,B),fun(fun(A,$o),fun(A,B)),G),P)),A3) ) ) ) ).

% sum.inter_filter
tff(fact_4877_set__encode__inf,axiom,
    ! [A3: set(nat)] :
      ( ~ finite_finite2(nat,A3)
     => ( aa(set(nat),nat,nat_set_encode,A3) = zero_zero(nat) ) ) ).

% set_encode_inf
tff(fact_4878_prod_Ointer__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),P: fun(A,$o)] :
          ( finite_finite2(A,A3)
         => ( groups7121269368397514597t_prod(A,B,G,aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) = groups7121269368397514597t_prod(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_ny(fun(A,B),fun(fun(A,$o),fun(A,B)),G),P),A3) ) ) ) ).

% prod.inter_filter
tff(fact_4879_finite__int__segment,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] : finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(A,fun(A,$o),aTP_Lamp_nz(A,fun(A,fun(A,$o)),A2),B2))) ) ).

% finite_int_segment
tff(fact_4880_fst__divmod,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] : ( aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) ) ) ).

% fst_divmod
tff(fact_4881_sum__le__included,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [S: set(A),T2: set(B),G: fun(B,C),I3: fun(B,A),F3: fun(A,C)] :
          ( finite_finite2(A,S)
         => ( finite_finite2(B,T2)
           => ( ! [X4: B] :
                  ( aa(set(B),$o,member(B,X4),T2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,G,X4)) )
             => ( ! [X4: A] :
                    ( aa(set(A),$o,member(A,X4),S)
                   => ? [Xa3: B] :
                        ( aa(set(B),$o,member(B,Xa3),T2)
                        & ( aa(B,A,I3,Xa3) = X4 )
                        & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F3,X4)),aa(B,C,G,Xa3)) ) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),F3),S)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),T2)) ) ) ) ) ) ).

% sum_le_included
tff(fact_4882_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X4)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3) = zero_zero(B) )
            <=> ! [X3: A] :
                  ( aa(set(A),$o,member(A,X3),A3)
                 => ( aa(A,B,F3,X3) = zero_zero(B) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
tff(fact_4883_sum__strict__mono__ex1,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,G,X4)) )
           => ( ? [X: A] :
                  ( aa(set(A),$o,member(A,X),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)) ) ) ) ) ).

% sum_strict_mono_ex1
tff(fact_4884_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [R3: fun(A,fun(A,$o)),S3: set(B),H: fun(B,A),G: fun(B,A)] :
          ( aa(A,$o,aa(A,fun(A,$o),R3,zero_zero(A)),zero_zero(A))
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( aa(A,$o,aa(A,fun(A,$o),R3,X1),X23)
                  & aa(A,$o,aa(A,fun(A,$o),R3,Y1),Y23) )
               => aa(A,$o,aa(A,fun(A,$o),R3,aa(A,A,aa(A,fun(A,A),plus_plus(A),X1),Y1)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X23),Y23)) )
           => ( finite_finite2(B,S3)
             => ( ! [X4: B] :
                    ( aa(set(B),$o,member(B,X4),S3)
                   => aa(A,$o,aa(A,fun(A,$o),R3,aa(B,A,H,X4)),aa(B,A,G,X4)) )
               => aa(A,$o,aa(A,fun(A,$o),R3,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),S3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S3)) ) ) ) ) ) ).

% sum.related
tff(fact_4885_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [R3: fun(A,fun(A,$o)),S3: set(B),H: fun(B,A),G: fun(B,A)] :
          ( aa(A,$o,aa(A,fun(A,$o),R3,one_one(A)),one_one(A))
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( aa(A,$o,aa(A,fun(A,$o),R3,X1),X23)
                  & aa(A,$o,aa(A,fun(A,$o),R3,Y1),Y23) )
               => aa(A,$o,aa(A,fun(A,$o),R3,aa(A,A,aa(A,fun(A,A),times_times(A),X1),Y1)),aa(A,A,aa(A,fun(A,A),times_times(A),X23),Y23)) )
           => ( finite_finite2(B,S3)
             => ( ! [X4: B] :
                    ( aa(set(B),$o,member(B,X4),S3)
                   => aa(A,$o,aa(A,fun(A,$o),R3,aa(B,A,H,X4)),aa(B,A,G,X4)) )
               => aa(A,$o,aa(A,fun(A,$o),R3,groups7121269368397514597t_prod(B,A,H,S3)),groups7121269368397514597t_prod(B,A,G,S3)) ) ) ) ) ) ).

% prod.related
tff(fact_4886_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S4: set(A),T5: set(B),S3: set(A),I3: fun(B,A),J2: fun(A,B),T4: set(B),G: fun(A,C),H: fun(B,C)] :
          ( finite_finite2(A,S4)
         => ( finite_finite2(B,T5)
           => ( ! [A4: A] :
                  ( aa(set(A),$o,member(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4))
                 => ( aa(B,A,I3,aa(A,B,J2,A4)) = A4 ) )
             => ( ! [A4: A] :
                    ( aa(set(A),$o,member(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4))
                   => aa(set(B),$o,member(B,aa(A,B,J2,A4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T4),T5)) )
               => ( ! [B3: B] :
                      ( aa(set(B),$o,member(B,B3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T4),T5))
                     => ( aa(A,B,J2,aa(B,A,I3,B3)) = B3 ) )
                 => ( ! [B3: B] :
                        ( aa(set(B),$o,member(B,B3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T4),T5))
                       => aa(set(A),$o,member(A,aa(B,A,I3,B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4)) )
                   => ( ! [A4: A] :
                          ( aa(set(A),$o,member(A,A4),S4)
                         => ( aa(A,C,G,A4) = zero_zero(C) ) )
                     => ( ! [B3: B] :
                            ( aa(set(B),$o,member(B,B3),T5)
                           => ( aa(B,C,H,B3) = zero_zero(C) ) )
                       => ( ! [A4: A] :
                              ( aa(set(A),$o,member(A,A4),S3)
                             => ( aa(B,C,H,aa(A,B,J2,A4)) = aa(A,C,G,A4) ) )
                         => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),G),S3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),H),T4) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
tff(fact_4887_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( finite_finite2(A,A3)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3) = aa(nat,nat,suc,zero_zero(nat)) )
      <=> ? [X3: A] :
            ( aa(set(A),$o,member(A,X3),A3)
            & ( aa(A,nat,F3,X3) = aa(nat,nat,suc,zero_zero(nat)) )
            & ! [Xa: A] :
                ( aa(set(A),$o,member(A,Xa),A3)
               => ( ( X3 != Xa )
                 => ( aa(A,nat,F3,Xa) = zero_zero(nat) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
tff(fact_4888_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( finite_finite2(A,A3)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3) = one_one(nat) )
      <=> ? [X3: A] :
            ( aa(set(A),$o,member(A,X3),A3)
            & ( aa(A,nat,F3,X3) = one_one(nat) )
            & ! [Xa: A] :
                ( aa(set(A),$o,member(A,Xa),A3)
               => ( ( X3 != Xa )
                 => ( aa(A,nat,F3,Xa) = zero_zero(nat) ) ) ) ) ) ) ).

% sum_eq_1_iff
tff(fact_4889_sum__nonneg__0,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [S: set(A),F3: fun(A,B),I3: A] :
          ( finite_finite2(A,S)
         => ( ! [I2: A] :
                ( aa(set(A),$o,member(A,I2),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),S) = zero_zero(B) )
             => ( aa(set(A),$o,member(A,I3),S)
               => ( aa(A,B,F3,I3) = zero_zero(B) ) ) ) ) ) ) ).

% sum_nonneg_0
tff(fact_4890_sum__nonneg__leq__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [S: set(A),F3: fun(A,B),B4: B,I3: A] :
          ( finite_finite2(A,S)
         => ( ! [I2: A] :
                ( aa(set(A),$o,member(A,I2),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),S) = B4 )
             => ( aa(set(A),$o,member(A,I3),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I3)),B4) ) ) ) ) ) ).

% sum_nonneg_leq_bound
tff(fact_4891_sum_Osetdiff__irrelevant,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_oa(fun(A,B),fun(A,$o),G)))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) ) ) ) ).

% sum.setdiff_irrelevant
tff(fact_4892_prod_Osetdiff__irrelevant,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ob(fun(A,B),fun(A,$o),G)))) = groups7121269368397514597t_prod(A,B,G,A3) ) ) ) ).

% prod.setdiff_irrelevant
tff(fact_4893_finite__divisors__nat,axiom,
    ! [Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => finite_finite2(nat,aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_oc(nat,fun(nat,$o),Ma))) ) ).

% finite_divisors_nat
tff(fact_4894_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [A3: set(nat),F3: fun(nat,A)] :
          ( finite_finite2(nat,A3)
         => aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_nf(set(nat),fun(fun(nat,A),fun(nat,A)),A3),F3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),A3)) ) ) ).

% sums_If_finite_set
tff(fact_4895_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [P: fun(nat,$o),F3: fun(nat,A)] :
          ( finite_finite2(nat,aa(fun(nat,$o),set(nat),collect(nat),P))
         => aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ne(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),P),F3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(fun(nat,$o),set(nat),collect(nat),P))) ) ) ).

% sums_If_finite
tff(fact_4896_sums__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [N3: set(nat),F3: fun(nat,A)] :
          ( finite_finite2(nat,N3)
         => ( ! [N: nat] :
                ( ~ aa(set(nat),$o,member(nat,N),N3)
               => ( aa(nat,A,F3,N) = zero_zero(A) ) )
           => aa(A,$o,sums(A,F3),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),N3)) ) ) ) ).

% sums_finite
tff(fact_4897_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [N3: set(nat),F3: fun(nat,A)] :
          ( finite_finite2(nat,N3)
         => ( ! [N: nat] :
                ( ~ aa(set(nat),$o,member(nat,N),N3)
               => ( aa(nat,A,F3,N) = zero_zero(A) ) )
           => ( suminf(A,F3) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),N3) ) ) ) ) ).

% suminf_finite
tff(fact_4898_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A] : finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aTP_Lamp_od(A,fun(A,$o),A2))) ) ).

% finite_abs_int_segment
tff(fact_4899_exp__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_Vector_banach(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [I5: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,I5)
         => ( aa(B,B,exp(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),I5)) = groups7121269368397514597t_prod(A,B,aTP_Lamp_oe(fun(A,B),fun(A,B),F3),I5) ) ) ) ).

% exp_sum
tff(fact_4900_sum__pos2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),I3: A,F3: fun(A,B)] :
          ( finite_finite2(A,I5)
         => ( aa(set(A),$o,member(A,I3),I5)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F3,I3))
             => ( ! [I2: A] :
                    ( aa(set(A),$o,member(A,I2),I5)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),I5)) ) ) ) ) ) ).

% sum_pos2
tff(fact_4901_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),I3: A,F3: fun(A,B)] :
          ( finite_finite2(A,I5)
         => ( aa(set(A),$o,member(A,I3),I5)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(A,B,F3,I3))
             => ( ! [I2: A] :
                    ( aa(set(A),$o,member(A,I2),I5)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(A,B,F3,I2)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),groups7121269368397514597t_prod(A,B,F3,I5)) ) ) ) ) ) ).

% less_1_prod2
tff(fact_4902_sum_Osame__carrier,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [C6: set(A),A3: set(A),B4: set(A),G: fun(A,B),H: fun(A,B)] :
          ( finite_finite2(A,C6)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C6)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),C6)
             => ( ! [A4: A] :
                    ( aa(set(A),$o,member(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),A3))
                   => ( aa(A,B,G,A4) = zero_zero(B) ) )
               => ( ! [B3: A] :
                      ( aa(set(A),$o,member(A,B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),B4))
                     => ( aa(A,B,H,B3) = zero_zero(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),B4) )
                  <=> ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),C6) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),C6) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
tff(fact_4903_sum_Osame__carrierI,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [C6: set(A),A3: set(A),B4: set(A),G: fun(A,B),H: fun(A,B)] :
          ( finite_finite2(A,C6)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C6)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),C6)
             => ( ! [A4: A] :
                    ( aa(set(A),$o,member(A,A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),A3))
                   => ( aa(A,B,G,A4) = zero_zero(B) ) )
               => ( ! [B3: A] :
                      ( aa(set(A),$o,member(A,B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),B4))
                     => ( aa(A,B,H,B3) = zero_zero(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),C6) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),C6) )
                   => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),B4) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
tff(fact_4904_sum_Omono__neutral__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T4: set(A),S3: set(A),G: fun(A,B)] :
          ( finite_finite2(A,T4)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T4)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
                 => ( aa(A,B,G,X4) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T4) ) ) ) ) ) ).

% sum.mono_neutral_left
tff(fact_4905_sum_Omono__neutral__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T4: set(A),S3: set(A),G: fun(A,B)] :
          ( finite_finite2(A,T4)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T4)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
                 => ( aa(A,B,G,X4) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T4) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S3) ) ) ) ) ) ).

% sum.mono_neutral_right
tff(fact_4906_sum_Omono__neutral__cong__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T4: set(A),S3: set(A),H: fun(A,B),G: fun(A,B)] :
          ( finite_finite2(A,T4)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T4)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
                 => ( aa(A,B,H,X4) = zero_zero(B) ) )
             => ( ! [X4: A] :
                    ( aa(set(A),$o,member(A,X4),S3)
                   => ( aa(A,B,G,X4) = aa(A,B,H,X4) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),T4) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
tff(fact_4907_sum_Omono__neutral__cong__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T4: set(A),S3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( finite_finite2(A,T4)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T4)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
                 => ( aa(A,B,G,X4) = zero_zero(B) ) )
             => ( ! [X4: A] :
                    ( aa(set(A),$o,member(A,X4),S3)
                   => ( aa(A,B,G,X4) = aa(A,B,H,X4) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T4) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),S3) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
tff(fact_4908_sum_Osubset__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [B4: set(A),A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),A3)
         => ( finite_finite2(A,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B4)) ) ) ) ) ).

% sum.subset_diff
tff(fact_4909_prod_Osubset__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [B4: set(A),A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),A3)
         => ( finite_finite2(A,A3)
           => ( groups7121269368397514597t_prod(A,B,G,A3) = aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4))),groups7121269368397514597t_prod(A,B,G,B4)) ) ) ) ) ).

% prod.subset_diff
tff(fact_4910_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Nb)
         => finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aTP_Lamp_of(nat,fun(A,$o),Nb))) ) ) ).

% finite_roots_unity
tff(fact_4911_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S4: set(A),T5: set(B),H: fun(A,B),S3: set(A),T4: set(B),G: fun(B,C)] :
          ( finite_finite2(A,S4)
         => ( finite_finite2(B,T5)
           => ( bij_betw(A,B,H,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T4),T5))
             => ( ! [A4: A] :
                    ( aa(set(A),$o,member(A,A4),S4)
                   => ( aa(B,C,G,aa(A,B,H,A4)) = zero_zero(C) ) )
               => ( ! [B3: B] :
                      ( aa(set(B),$o,member(B,B3),T5)
                     => ( aa(B,C,G,B3) = zero_zero(C) ) )
                 => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_jl(fun(A,B),fun(fun(B,C),fun(A,C)),H),G)),S3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),T4) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
tff(fact_4912_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [G: fun(nat,A),S3: A,A3: set(nat),S4: A,F3: fun(nat,A)] :
          ( aa(A,$o,sums(A,G),S3)
         => ( finite_finite2(nat,A3)
           => ( ( S4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),S3),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_og(fun(nat,A),fun(fun(nat,A),fun(nat,A)),G),F3)),A3)) )
             => aa(A,$o,sums(A,aa(fun(nat,A),fun(nat,A),aa(set(nat),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_oh(fun(nat,A),fun(set(nat),fun(fun(nat,A),fun(nat,A))),G),A3),F3)),S4) ) ) ) ) ).

% sums_If_finite_set'
tff(fact_4913_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S4: set(A),T5: set(B),H: fun(A,B),S3: set(A),T4: set(B),G: fun(B,C)] :
          ( finite_finite2(A,S4)
         => ( finite_finite2(B,T5)
           => ( bij_betw(A,B,H,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T4),T5))
             => ( ! [A4: A] :
                    ( aa(set(A),$o,member(A,A4),S4)
                   => ( aa(B,C,G,aa(A,B,H,A4)) = one_one(C) ) )
               => ( ! [B3: B] :
                      ( aa(set(B),$o,member(B,B3),T5)
                     => ( aa(B,C,G,B3) = one_one(C) ) )
                 => ( groups7121269368397514597t_prod(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_kn(fun(A,B),fun(fun(B,C),fun(A,C)),H),G),S3) = groups7121269368397514597t_prod(B,C,G,T4) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
tff(fact_4914_sum__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [B4: set(A),A3: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,B4)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
           => ( ! [B3: A] :
                  ( aa(set(A),$o,member(A,B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B4),A3))
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,B3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),B4)) ) ) ) ) ).

% sum_mono2
tff(fact_4915_even__prod__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_parity(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),groups7121269368397514597t_prod(A,B,F3,A3))
          <=> ? [X3: A] :
                ( aa(set(A),$o,member(A,X3),A3)
                & aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(A,B,F3,X3)) ) ) ) ) ).

% even_prod_iff
tff(fact_4916_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),I5: set(nat)] :
          ( summable(A,F3)
         => ( finite_finite2(nat,I5)
           => ( ! [N: nat] :
                  ( aa(set(nat),$o,member(nat,N),aa(set(nat),set(nat),uminus_uminus(set(nat)),I5))
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),I5)),suminf(A,F3)) ) ) ) ) ).

% sum_le_suminf
tff(fact_4917_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [B4: set(A),A3: set(A),B2: A,F3: fun(A,B)] :
          ( finite_finite2(A,B4)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
           => ( aa(set(A),$o,member(A,B2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B4),A3))
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F3,B2))
               => ( ! [X4: A] :
                      ( aa(set(A),$o,member(A,X4),B4)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X4)) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),B4)) ) ) ) ) ) ) ).

% sum_strict_mono2
tff(fact_4918_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [B4: set(A),A3: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,B4)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
           => ( ! [B3: A] :
                  ( aa(set(A),$o,member(A,B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B4),A3))
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(A,B,F3,B3)) )
             => ( ! [A4: A] :
                    ( aa(set(A),$o,member(A,A4),A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,A4)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),groups7121269368397514597t_prod(A,B,F3,A3)),groups7121269368397514597t_prod(A,B,F3,B4)) ) ) ) ) ) ).

% prod_mono2
tff(fact_4919_ln__prod,axiom,
    ! [A: $tType,I5: set(A),F3: fun(A,real)] :
      ( finite_finite2(A,I5)
     => ( ! [I2: A] :
            ( aa(set(A),$o,member(A,I2),I5)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,I2)) )
       => ( aa(real,real,ln_ln(real),groups7121269368397514597t_prod(A,real,F3,I5)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_oi(fun(A,real),fun(A,real),F3)),I5) ) ) ) ).

% ln_prod
tff(fact_4920_even__set__encode__iff,axiom,
    ! [A3: set(nat)] :
      ( finite_finite2(nat,A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(nat),nat,nat_set_encode,A3))
      <=> ~ aa(set(nat),$o,member(nat,zero_zero(nat)),A3) ) ) ).

% even_set_encode_iff
tff(fact_4921_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,Nb: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
           => finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(nat,fun(A,$o),aTP_Lamp_oj(fun(nat,A),fun(nat,fun(A,$o)),C2),Nb))) ) ) ) ).

% polyfun_roots_finite
tff(fact_4922_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),Nb: nat] :
          ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(nat,fun(A,$o),aTP_Lamp_oj(fun(nat,A),fun(nat,fun(A,$o)),C2),Nb)))
        <=> ? [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),Nb)
              & ( aa(nat,A,C2,I) != zero_zero(A) ) ) ) ) ).

% polyfun_finite_roots
tff(fact_4923_finite__Collect__le__nat,axiom,
    ! [K: nat] : finite_finite2(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_am(nat,fun(nat,$o)),K))) ).

% finite_Collect_le_nat
tff(fact_4924_finite__Collect__less__nat,axiom,
    ! [K: nat] : finite_finite2(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),K))) ).

% finite_Collect_less_nat
tff(fact_4925_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => finite_finite2(set(A),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_ok(set(A),fun(set(A),$o),A3))) ) ).

% finite_Collect_subsets
tff(fact_4926_finite__Collect__conjI,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),P))
        | finite_finite2(A,aa(fun(A,$o),set(A),collect(A),Q)) )
     => finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_ol(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q))) ) ).

% finite_Collect_conjI
tff(fact_4927_finite__Collect__disjI,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_om(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q)))
    <=> ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),P))
        & finite_finite2(A,aa(fun(A,$o),set(A),collect(A),Q)) ) ) ).

% finite_Collect_disjI
tff(fact_4928_finite__interval__int1,axiom,
    ! [A2: int,B2: int] : finite_finite2(int,aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_on(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int1
tff(fact_4929_finite__interval__int4,axiom,
    ! [A2: int,B2: int] : finite_finite2(int,aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_oo(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int4
tff(fact_4930_finite__interval__int2,axiom,
    ! [A2: int,B2: int] : finite_finite2(int,aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_op(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int2
tff(fact_4931_finite__interval__int3,axiom,
    ! [A2: int,B2: int] : finite_finite2(int,aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_oq(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int3
tff(fact_4932_finite__nth__roots,axiom,
    ! [Nb: nat,C2: complex] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => finite_finite2(complex,aa(fun(complex,$o),set(complex),collect(complex),aa(complex,fun(complex,$o),aTP_Lamp_ht(nat,fun(complex,fun(complex,$o)),Nb),C2))) ) ).

% finite_nth_roots
tff(fact_4933_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : finite_finite2(int,set_or7035219750837199246ssThan(int,zero_zero(int),U)) ).

% finite_atLeastZeroLessThan_int
tff(fact_4934_uminus__set__def,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),A3) = aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),uminus_uminus(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3))) ) ).

% uminus_set_def
tff(fact_4935_Collect__neg__eq,axiom,
    ! [A: $tType,P: fun(A,$o)] : ( aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ed(fun(A,$o),fun(A,$o),P)) = aa(set(A),set(A),uminus_uminus(set(A)),aa(fun(A,$o),set(A),collect(A),P)) ) ).

% Collect_neg_eq
tff(fact_4936_Compl__eq,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),A3) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_or(set(A),fun(A,$o),A3)) ) ).

% Compl_eq
tff(fact_4937_finite__maxlen,axiom,
    ! [A: $tType,M6: set(list(A))] :
      ( finite_finite2(list(A),M6)
     => ? [N: nat] :
        ! [X: list(A)] :
          ( aa(set(list(A)),$o,member(list(A),X),M6)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),X)),N) ) ) ).

% finite_maxlen
tff(fact_4938_finite__enat__bounded,axiom,
    ! [A3: set(extended_enat),Nb: nat] :
      ( ! [Y4: extended_enat] :
          ( aa(set(extended_enat),$o,member(extended_enat,Y4),A3)
         => aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Y4),extended_enat2(Nb)) )
     => finite_finite2(extended_enat,A3) ) ).

% finite_enat_bounded
tff(fact_4939_finite__divisors__int,axiom,
    ! [I3: int] :
      ( ( I3 != zero_zero(int) )
     => finite_finite2(int,aa(fun(int,$o),set(int),collect(int),aTP_Lamp_os(int,fun(int,$o),I3))) ) ).

% finite_divisors_int
tff(fact_4940_not__finite__existsD,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( ~ finite_finite2(A,aa(fun(A,$o),set(A),collect(A),P))
     => ? [X_13: A] : aa(A,$o,P,X_13) ) ).

% not_finite_existsD
tff(fact_4941_pigeonhole__infinite__rel,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: set(B),R3: fun(A,fun(B,$o))] :
      ( ~ finite_finite2(A,A3)
     => ( finite_finite2(B,B4)
       => ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => ? [Xa3: B] :
                  ( aa(set(B),$o,member(B,Xa3),B4)
                  & aa(B,$o,aa(A,fun(B,$o),R3,X4),Xa3) ) )
         => ? [X4: B] :
              ( aa(set(B),$o,member(B,X4),B4)
              & ~ finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aa(fun(A,fun(B,$o)),fun(B,fun(A,$o)),aTP_Lamp_nm(set(A),fun(fun(A,fun(B,$o)),fun(B,fun(A,$o))),A3),R3),X4))) ) ) ) ) ).

% pigeonhole_infinite_rel
tff(fact_4942_finite__psubset__induct,axiom,
    ! [A: $tType,A3: set(A),P: fun(set(A),$o)] :
      ( finite_finite2(A,A3)
     => ( ! [A7: set(A)] :
            ( finite_finite2(A,A7)
           => ( ! [B9: set(A)] :
                  ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),B9),A7)
                 => aa(set(A),$o,P,B9) )
             => aa(set(A),$o,P,A7) ) )
       => aa(set(A),$o,P,A3) ) ) ).

% finite_psubset_induct
tff(fact_4943_bezw_Osimps,axiom,
    ! [X2: nat,Y2: nat] :
      ( bezw(X2,Y2)
      = $ite(Y2 = zero_zero(nat),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y2,modulo_modulo(nat,X2,Y2)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y2,modulo_modulo(nat,X2,Y2)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y2,modulo_modulo(nat,X2,Y2)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X2),Y2)))))) ) ).

% bezw.simps
tff(fact_4944_bezw_Oelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: product_prod(int,int)] :
      ( ( bezw(X2,Xa2) = Y2 )
     => ( Y2
        = $ite(Xa2 = zero_zero(nat),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa2,modulo_modulo(nat,X2,Xa2)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa2,modulo_modulo(nat,X2,Xa2)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa2,modulo_modulo(nat,X2,Xa2)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X2),Xa2)))))) ) ) ).

% bezw.elims
tff(fact_4945_sum__count__set,axiom,
    ! [A: $tType,Xs: list(A),X7: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),X7)
     => ( finite_finite2(A,X7)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),count_list(A,Xs)),X7) = aa(list(A),nat,size_size(list(A)),Xs) ) ) ) ).

% sum_count_set
tff(fact_4946_count__notin,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( aa(A,nat,count_list(A,Xs),X2) = zero_zero(nat) ) ) ).

% count_notin
tff(fact_4947_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [K: num,L: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),K),aa(num,A,numeral_numeral(A),L)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,K,L)) ) ) ).

% numeral_mod_numeral
tff(fact_4948_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Nb: num] : ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),Nb)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,one2,Nb)) ) ) ).

% one_mod_numeral
tff(fact_4949_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(A,B)),Ys: list(product_prod(A,B))] :
      ( ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs) = aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Ys) )
     => ( ( aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),Xs) = aa(list(product_prod(A,B)),list(B),map(product_prod(A,B),B,product_snd(A,B)),Ys) )
       => ( Xs = Ys ) ) ) ).

% pair_list_eqI
tff(fact_4950_snd__def,axiom,
    ! [A: $tType,B: $tType,Prod: product_prod(B,A)] : ( aa(product_prod(B,A),A,product_snd(B,A),Prod) = aa(product_prod(B,A),A,aa(fun(B,fun(A,A)),fun(product_prod(B,A),A),product_case_prod(B,A,A),aTP_Lamp_ot(B,fun(A,A))),Prod) ) ).

% snd_def
tff(fact_4951_split__comp__eq,axiom,
    ! [B: $tType,C: $tType,D: $tType,A: $tType,F3: fun(D,fun(B,C)),G: fun(A,D)] : ( aa(fun(A,D),fun(product_prod(A,B),C),aTP_Lamp_ou(fun(D,fun(B,C)),fun(fun(A,D),fun(product_prod(A,B),C)),F3),G) = aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),aa(fun(A,D),fun(A,fun(B,C)),aTP_Lamp_ov(fun(D,fun(B,C)),fun(fun(A,D),fun(A,fun(B,C))),F3),G)) ) ).

% split_comp_eq
tff(fact_4952_case__prod__beta_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: fun(A,fun(B,C)),X: product_prod(A,B)] : ( aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F3),X) = aa(B,C,aa(A,fun(B,C),F3,aa(product_prod(A,B),A,product_fst(A,B),X)),aa(product_prod(A,B),B,product_snd(A,B),X)) ) ).

% case_prod_beta'
tff(fact_4953_case__prod__unfold,axiom,
    ! [C: $tType,B: $tType,A: $tType,X: fun(A,fun(B,C)),Xa3: product_prod(A,B)] : ( aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),X),Xa3) = aa(B,C,aa(A,fun(B,C),X,aa(product_prod(A,B),A,product_fst(A,B),Xa3)),aa(product_prod(A,B),B,product_snd(A,B),Xa3)) ) ).

% case_prod_unfold
tff(fact_4954_divides__aux__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Qr: product_prod(A,A)] :
          ( unique5940410009612947441es_aux(A,Qr)
        <=> ( aa(product_prod(A,A),A,product_snd(A,A),Qr) = zero_zero(A) ) ) ) ).

% divides_aux_def
tff(fact_4955_snd__divmod,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Ma: num,Nb: num] : ( aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,Ma,Nb)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),Ma),aa(num,A,numeral_numeral(A),Nb)) ) ) ).

% snd_divmod
tff(fact_4956_quotient__of__denom__pos_H,axiom,
    ! [R: rat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),quotient_of(R))) ).

% quotient_of_denom_pos'
tff(fact_4957_Eps__case__prod,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,$o))] : ( fChoice(product_prod(A,B),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),P)) = fChoice(product_prod(A,B),aTP_Lamp_ow(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),P)) ) ).

% Eps_case_prod
tff(fact_4958_The__case__prod,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,$o))] : ( the(product_prod(A,B),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),P)) = the(product_prod(A,B),aTP_Lamp_ow(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),P)) ) ).

% The_case_prod
tff(fact_4959_count__le__length,axiom,
    ! [A: $tType,Xs: list(A),X2: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,count_list(A,Xs),X2)),aa(list(A),nat,size_size(list(A)),Xs)) ).

% count_le_length
tff(fact_4960_bezw__non__0,axiom,
    ! [Y2: nat,X2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Y2)
     => ( bezw(X2,Y2) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y2,modulo_modulo(nat,X2,Y2)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y2,modulo_modulo(nat,X2,Y2)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y2,modulo_modulo(nat,X2,Y2)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X2),Y2))))) ) ) ).

% bezw_non_0
tff(fact_4961_one__mod__minus__numeral,axiom,
    ! [Nb: num] : ( modulo_modulo(int,one_one(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,uminus_uminus(int),adjust_mod(aa(num,int,numeral_numeral(int),Nb),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,one2,Nb)))) ) ).

% one_mod_minus_numeral
tff(fact_4962_minus__one__mod__numeral,axiom,
    ! [Nb: num] : ( modulo_modulo(int,aa(int,int,uminus_uminus(int),one_one(int)),aa(num,int,numeral_numeral(int),Nb)) = adjust_mod(aa(num,int,numeral_numeral(int),Nb),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,one2,Nb))) ) ).

% minus_one_mod_numeral
tff(fact_4963_minus__numeral__mod__numeral,axiom,
    ! [Ma: num,Nb: num] : ( modulo_modulo(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma)),aa(num,int,numeral_numeral(int),Nb)) = adjust_mod(aa(num,int,numeral_numeral(int),Nb),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,Ma,Nb))) ) ).

% minus_numeral_mod_numeral
tff(fact_4964_snd__divmod__nat,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(product_prod(nat,nat),nat,product_snd(nat,nat),divmod_nat(Ma,Nb)) = modulo_modulo(nat,Ma,Nb) ) ).

% snd_divmod_nat
tff(fact_4965_Suc__0__mod__numeral,axiom,
    ! [K: num] : ( modulo_modulo(nat,aa(nat,nat,suc,zero_zero(nat)),aa(num,nat,numeral_numeral(nat),K)) = aa(product_prod(nat,nat),nat,product_snd(nat,nat),unique8689654367752047608divmod(nat,one2,K)) ) ).

% Suc_0_mod_numeral
tff(fact_4966_numeral__mod__minus__numeral,axiom,
    ! [Ma: num,Nb: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),Ma),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,uminus_uminus(int),adjust_mod(aa(num,int,numeral_numeral(int),Nb),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,Ma,Nb)))) ) ).

% numeral_mod_minus_numeral
tff(fact_4967_Divides_Oadjust__mod__def,axiom,
    ! [L: int,R: int] :
      ( adjust_mod(L,R)
      = $ite(R = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),L),R)) ) ).

% Divides.adjust_mod_def
tff(fact_4968_exE__realizer,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: fun(A,fun(B,$o)),P2: product_prod(B,A),Q: fun(C,$o),F3: fun(B,fun(A,C))] :
      ( aa(B,$o,aa(A,fun(B,$o),P,aa(product_prod(B,A),A,product_snd(B,A),P2)),aa(product_prod(B,A),B,product_fst(B,A),P2))
     => ( ! [X4: B,Y4: A] :
            ( aa(B,$o,aa(A,fun(B,$o),P,Y4),X4)
           => aa(C,$o,Q,aa(A,C,aa(B,fun(A,C),F3,X4),Y4)) )
       => aa(C,$o,Q,aa(product_prod(B,A),C,aa(fun(B,fun(A,C)),fun(product_prod(B,A),C),product_case_prod(B,A,C),F3),P2)) ) ) ).

% exE_realizer
tff(fact_4969_infinite__int__iff__unbounded,axiom,
    ! [S3: set(int)] :
      ( ~ finite_finite2(int,S3)
    <=> ! [M4: int] :
        ? [N4: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),M4),aa(int,int,abs_abs(int),N4))
          & aa(set(int),$o,member(int,N4),S3) ) ) ).

% infinite_int_iff_unbounded
tff(fact_4970_bezw_Opelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: product_prod(int,int)] :
      ( ( bezw(X2,Xa2) = Y2 )
     => ( accp(product_prod(nat,nat),bezw_rel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),Xa2))
       => ~ ( ( Y2
              = $ite(Xa2 = zero_zero(nat),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa2,modulo_modulo(nat,X2,Xa2)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa2,modulo_modulo(nat,X2,Xa2)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa2,modulo_modulo(nat,X2,Xa2)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X2),Xa2)))))) )
           => ~ accp(product_prod(nat,nat),bezw_rel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),Xa2)) ) ) ) ).

% bezw.pelims
tff(fact_4971_infinite__nat__iff__unbounded,axiom,
    ! [S3: set(nat)] :
      ( ~ finite_finite2(nat,S3)
    <=> ! [M4: nat] :
        ? [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N4)
          & aa(set(nat),$o,member(nat,N4),S3) ) ) ).

% infinite_nat_iff_unbounded
tff(fact_4972_unbounded__k__infinite,axiom,
    ! [K: nat,S3: set(nat)] :
      ( ! [M3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),M3)
         => ? [N8: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N8)
              & aa(set(nat),$o,member(nat,N8),S3) ) )
     => ~ finite_finite2(nat,S3) ) ).

% unbounded_k_infinite
tff(fact_4973_prod__decode__aux_Opelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: product_prod(nat,nat)] :
      ( ( nat_prod_decode_aux(X2,Xa2) = Y2 )
     => ( accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),Xa2))
       => ~ ( ( Y2
              = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa2),X2),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Xa2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X2),Xa2)),nat_prod_decode_aux(aa(nat,nat,suc,X2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa2),aa(nat,nat,suc,X2)))) )
           => ~ accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),Xa2)) ) ) ) ).

% prod_decode_aux.pelims
tff(fact_4974_in__set__enumerate__eq,axiom,
    ! [A: $tType,P2: product_prod(nat,A),Nb: nat,Xs: list(A)] :
      ( aa(set(product_prod(nat,A)),$o,member(product_prod(nat,A),P2),aa(list(product_prod(nat,A)),set(product_prod(nat,A)),set2(product_prod(nat,A)),enumerate(A,Nb,Xs)))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),aa(product_prod(nat,A),nat,product_fst(nat,A),P2))
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(product_prod(nat,A),nat,product_fst(nat,A),P2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb))
        & ( aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(product_prod(nat,A),nat,product_fst(nat,A),P2)),Nb)) = aa(product_prod(nat,A),A,product_snd(nat,A),P2) ) ) ) ).

% in_set_enumerate_eq
tff(fact_4975_normalize__def,axiom,
    ! [P2: product_prod(int,int)] :
      ( normalize(P2)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P2)),
          $let(
            a2: int,
            a2 := aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2)),
            aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),a2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P2)),a2)) ),
          $ite(
            aa(product_prod(int,int),int,product_snd(int,int),P2) = zero_zero(int),
            aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),
            $let(
              a2: int,
              a2 := aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2))),
              aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),a2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P2)),a2)) ) ) ) ) ).

% normalize_def
tff(fact_4976_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & ( B2 = zero_zero(A) ) ) ) ) ).

% gcd_eq_0_iff
tff(fact_4977_gcd__add1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Ma: A,Nb: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Ma),Nb)),Nb) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),Ma),Nb) ) ) ).

% gcd_add1
tff(fact_4978_gcd__add2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Ma: A,Nb: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),Ma),aa(A,A,aa(A,fun(A,A),plus_plus(A),Ma),Nb)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),Ma),Nb) ) ) ).

% gcd_add2
tff(fact_4979_gcd__exp,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A2: A,Nb: nat,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(nat,A,power_power(A,A2),Nb)),aa(nat,A,power_power(A,B2),Nb)) = aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),Nb) ) ) ).

% gcd_exp
tff(fact_4980_length__enumerate,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(product_prod(nat,A)),nat,size_size(list(product_prod(nat,A))),enumerate(A,Nb,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_enumerate
tff(fact_4981_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [Nb: num,A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))),A2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(num,A,numeral_numeral(A),Nb)),A2) ) ) ).

% gcd_neg_numeral_1
tff(fact_4982_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,Nb: num] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(num,A,numeral_numeral(A),Nb)) ) ) ).

% gcd_neg_numeral_2
tff(fact_4983_map__snd__enumerate,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(product_prod(nat,A)),list(A),map(product_prod(nat,A),A,product_snd(nat,A)),enumerate(A,Nb,Xs)) = Xs ) ).

% map_snd_enumerate
tff(fact_4984_gcd__pos__int,axiom,
    ! [Ma: int,Nb: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Ma),Nb))
    <=> ( ( Ma != zero_zero(int) )
        | ( Nb != zero_zero(int) ) ) ) ).

% gcd_pos_int
tff(fact_4985_gcd__neg__numeral__1__int,axiom,
    ! [Nb: num,X2: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))),X2) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(num,int,numeral_numeral(int),Nb)),X2) ) ).

% gcd_neg_numeral_1_int
tff(fact_4986_gcd__neg__numeral__2__int,axiom,
    ! [X2: int,Nb: num] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),aa(num,int,numeral_numeral(int),Nb)) ) ).

% gcd_neg_numeral_2_int
tff(fact_4987_gcd__0__left__int,axiom,
    ! [X2: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),zero_zero(int)),X2) = aa(int,int,abs_abs(int),X2) ) ).

% gcd_0_left_int
tff(fact_4988_gcd__0__int,axiom,
    ! [X2: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),zero_zero(int)) = aa(int,int,abs_abs(int),X2) ) ).

% gcd_0_int
tff(fact_4989_map__fst__enumerate,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(product_prod(nat,A)),list(nat),map(product_prod(nat,A),nat,product_fst(nat,A)),enumerate(A,Nb,Xs)) = upt(Nb,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))) ) ).

% map_fst_enumerate
tff(fact_4990_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Ma: A,K: A,Nb: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),Ma),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),Ma)),Nb)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),Ma),Nb) ) ) ).

% gcd_add_mult
tff(fact_4991_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,K: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B2)) ) ).

% gcd_dvd_prod
tff(fact_4992_gcd__ge__0__int,axiom,
    ! [X2: int,Y2: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),Y2)) ).

% gcd_ge_0_int
tff(fact_4993_bezout__int,axiom,
    ! [X2: int,Y2: int] :
    ? [U2: int,V3: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),U2),X2)),aa(int,int,aa(int,fun(int,int),times_times(int),V3),Y2)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),Y2) ) ).

% bezout_int
tff(fact_4994_gcd__mult__distrib__int,axiom,
    ! [K: int,Ma: int,Nb: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),K)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Ma),Nb)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),Ma)),aa(int,int,aa(int,fun(int,int),times_times(int),K),Nb)) ) ).

% gcd_mult_distrib_int
tff(fact_4995_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit2
tff(fact_4996_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit1
tff(fact_4997_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit2
tff(fact_4998_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit1
tff(fact_4999_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2)),B2) ) ).

% gcd_le2_int
tff(fact_5000_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),A2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2)),A2) ) ).

% gcd_le1_int
tff(fact_5001_gcd__cases__int,axiom,
    ! [X2: int,Y2: int,P: fun(int,$o)] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
         => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),Y2)) ) )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y2),zero_zero(int))
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),aa(int,int,uminus_uminus(int),Y2))) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X2),zero_zero(int))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y2)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),X2)),Y2)) ) )
         => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X2),zero_zero(int))
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y2),zero_zero(int))
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),X2)),aa(int,int,uminus_uminus(int),Y2))) ) )
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),Y2)) ) ) ) ) ).

% gcd_cases_int
tff(fact_5002_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),D2)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),A2)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),B2)
        & ! [E3: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),A2)
              & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),B2) )
           => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),D2) ) )
    <=> ( D2 = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2) ) ) ).

% gcd_unique_int
tff(fact_5003_gcd__non__0__int,axiom,
    ! [Y2: int,X2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Y2)
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X2),Y2) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Y2),modulo_modulo(int,X2,Y2)) ) ) ).

% gcd_non_0_int
tff(fact_5004_gcd__code__int,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),K),L)
      = aa(int,int,abs_abs(int),$ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),L),modulo_modulo(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L))))) ) ).

% gcd_code_int
tff(fact_5005_enumerate__map__upt,axiom,
    ! [A: $tType,Nb: nat,F3: fun(nat,A),Ma: nat] : ( enumerate(A,Nb,aa(list(nat),list(A),map(nat,A,F3),upt(Nb,Ma))) = aa(list(nat),list(product_prod(nat,A)),map(nat,product_prod(nat,A),aTP_Lamp_ox(fun(nat,A),fun(nat,product_prod(nat,A)),F3)),upt(Nb,Ma)) ) ).

% enumerate_map_upt
tff(fact_5006_enumerate__replicate__eq,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,A2: A] : ( enumerate(A,Nb,replicate(A,Ma,A2)) = aa(list(nat),list(product_prod(nat,A)),map(nat,product_prod(nat,A),aTP_Lamp_oy(A,fun(nat,product_prod(nat,A)),A2)),upt(Nb,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma))) ) ).

% enumerate_replicate_eq
tff(fact_5007_nth__enumerate__eq,axiom,
    ! [A: $tType,Ma: nat,Xs: list(A),Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,product_prod(nat,A),nth(product_prod(nat,A),enumerate(A,Nb,Xs)),Ma) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma)),aa(nat,A,nth(A,Xs),Ma)) ) ) ).

% nth_enumerate_eq
tff(fact_5008_set__encode__insert,axiom,
    ! [A3: set(nat),Nb: nat] :
      ( finite_finite2(nat,A3)
     => ( ~ aa(set(nat),$o,member(nat,Nb),A3)
       => ( aa(set(nat),nat,nat_set_encode,aa(set(nat),set(nat),insert(nat,Nb),A3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),aa(set(nat),nat,nat_set_encode,A3)) ) ) ) ).

% set_encode_insert
tff(fact_5009_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list(A),X7: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),X7)
     => ( finite_finite2(A,X7)
       => ( groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F3),Xs)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_oz(list(A),fun(fun(A,nat),fun(A,nat)),Xs),F3)),X7) ) ) ) ).

% sum_list_map_eq_sum_count2
tff(fact_5010_even__sum__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_parity(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),finite_card(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_pa(set(A),fun(fun(A,B),fun(A,$o)),A3),F3)))) ) ) ) ).

% even_sum_iff
tff(fact_5011_gcd__0__left__nat,axiom,
    ! [X2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),zero_zero(nat)),X2) = X2 ) ).

% gcd_0_left_nat
tff(fact_5012_gcd__0__nat,axiom,
    ! [X2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X2),zero_zero(nat)) = X2 ) ).

% gcd_0_nat
tff(fact_5013_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),zero_zero(nat)) = A2 ) ).

% gcd_nat.right_neutral
tff(fact_5014_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( zero_zero(nat) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% gcd_nat.neutr_eq_iff
tff(fact_5015_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),zero_zero(nat)),A2) = A2 ) ).

% gcd_nat.left_neutral
tff(fact_5016_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = zero_zero(nat) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% gcd_nat.eq_neutr_iff
tff(fact_5017_card__Collect__less__nat,axiom,
    ! [Nb: nat] : ( finite_card(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),Nb))) = Nb ) ).

% card_Collect_less_nat
tff(fact_5018_gcd__Suc__0,axiom,
    ! [Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Ma),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% gcd_Suc_0
tff(fact_5019_gcd__pos__nat,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Ma),Nb))
    <=> ( ( Ma != zero_zero(nat) )
        | ( Nb != zero_zero(nat) ) ) ) ).

% gcd_pos_nat
tff(fact_5020_card__atMost,axiom,
    ! [U: nat] : ( finite_card(nat,aa(nat,set(nat),set_ord_atMost(nat),U)) = aa(nat,nat,suc,U) ) ).

% card_atMost
tff(fact_5021_card__Collect__le__nat,axiom,
    ! [Nb: nat] : ( finite_card(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_am(nat,fun(nat,$o)),Nb))) = aa(nat,nat,suc,Nb) ) ).

% card_Collect_le_nat
tff(fact_5022_card_Oinfinite,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ~ finite_finite2(A,A3)
     => ( finite_card(A,A3) = zero_zero(nat) ) ) ).

% card.infinite
tff(fact_5023_card__atLeastAtMost,axiom,
    ! [L: nat,U: nat] : ( finite_card(nat,set_or1337092689740270186AtMost(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,U)),L) ) ).

% card_atLeastAtMost
tff(fact_5024_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Ns: list(A)] :
          ( ( groups8242544230860333062m_list(A,Ns) = zero_zero(A) )
        <=> ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Ns))
             => ( X3 = zero_zero(A) ) ) ) ) ).

% sum_list_eq_0_iff
tff(fact_5025_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Y2: A,A3: set(B)] : ( groups7121269368397514597t_prod(B,A,aTP_Lamp_pb(A,fun(B,A),Y2),A3) = aa(nat,A,power_power(A,Y2),finite_card(B,A3)) ) ) ).

% prod_constant
tff(fact_5026_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aTP_Lamp_pc(B,A)),Xs)) = zero_zero(A) ) ) ).

% sum_list_0
tff(fact_5027_sum_Oinsert,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),X2: A,G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( ~ aa(set(A),$o,member(A,X2),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,X2),A3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,X2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)) ) ) ) ) ).

% sum.insert
tff(fact_5028_prod_Oinsert,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),X2: A,G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( ~ aa(set(A),$o,member(A,X2),A3)
           => ( groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),insert(A,X2),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,X2)),groups7121269368397514597t_prod(A,B,G,A3)) ) ) ) ) ).

% prod.insert
tff(fact_5029_card__insert__disjoint,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( finite_finite2(A,A3)
     => ( ~ aa(set(A),$o,member(A,X2),A3)
       => ( finite_card(A,aa(set(A),set(A),insert(A,X2),A3)) = aa(nat,nat,suc,finite_card(A,A3)) ) ) ) ).

% card_insert_disjoint
tff(fact_5030_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Y2: A,A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_pd(A,fun(B,A),Y2)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),finite_card(B,A3))),Y2) ) ) ).

% sum_constant
tff(fact_5031_sum__list__upt,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( groups8242544230860333062m_list(nat,upt(Ma,Nb)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_jv(nat,nat)),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% sum_list_upt
tff(fact_5032_gcd__mult__distrib__nat,axiom,
    ! [K: nat,Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Ma),Nb)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Ma)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Nb)) ) ).

% gcd_mult_distrib_nat
tff(fact_5033_insert__compr,axiom,
    ! [A: $tType,A2: A,B4: set(A)] : ( aa(set(A),set(A),insert(A,A2),B4) = aa(fun(A,$o),set(A),collect(A),aa(set(A),fun(A,$o),aTP_Lamp_pe(A,fun(set(A),fun(A,$o)),A2),B4)) ) ).

% insert_compr
tff(fact_5034_insert__Collect,axiom,
    ! [A: $tType,A2: A,P: fun(A,$o)] : ( aa(set(A),set(A),insert(A,A2),aa(fun(A,$o),set(A),collect(A),P)) = aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_pf(A,fun(fun(A,$o),fun(A,$o)),A2),P)) ) ).

% insert_Collect
tff(fact_5035_card__le__Suc__iff,axiom,
    ! [A: $tType,Nb: nat,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Nb)),finite_card(A,A3))
    <=> ? [A6: A,B10: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,A6),B10) )
          & ~ aa(set(A),$o,member(A,A6),B10)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),finite_card(A,B10))
          & finite_finite2(A,B10) ) ) ).

% card_le_Suc_iff
tff(fact_5036_card__Suc__eq__finite,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( finite_card(A,A3) = aa(nat,nat,suc,K) )
    <=> ? [B6: A,B10: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B6),B10) )
          & ~ aa(set(A),$o,member(A,B6),B10)
          & ( finite_card(A,B10) = K )
          & finite_finite2(A,B10) ) ) ).

% card_Suc_eq_finite
tff(fact_5037_card__insert__if,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( finite_finite2(A,A3)
     => ( finite_card(A,aa(set(A),set(A),insert(A,X2),A3))
        = $ite(aa(set(A),$o,member(A,X2),A3),finite_card(A,A3),aa(nat,nat,suc,finite_card(A,A3))) ) ) ).

% card_insert_if
tff(fact_5038_n__subsets,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( finite_finite2(A,A3)
     => ( finite_card(set(A),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aa(nat,fun(set(A),$o),aTP_Lamp_pg(set(A),fun(nat,fun(set(A),$o)),A3),K))) = aa(nat,nat,binomial(finite_card(A,A3)),K) ) ) ).

% n_subsets
tff(fact_5039_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),A2) ) ).

% gcd_le1_nat
tff(fact_5040_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2 != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),B2) ) ).

% gcd_le2_nat
tff(fact_5041_gcd__non__0__nat,axiom,
    ! [Y2: nat,X2: nat] :
      ( ( Y2 != zero_zero(nat) )
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X2),Y2) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y2),modulo_modulo(nat,X2,Y2)) ) ) ).

% gcd_non_0_nat
tff(fact_5042_gcd__nat_Osimps,axiom,
    ! [X2: nat,Y2: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X2),Y2)
      = $ite(Y2 = zero_zero(nat),X2,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y2),modulo_modulo(nat,X2,Y2))) ) ).

% gcd_nat.simps
tff(fact_5043_gcd__nat_Oelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X2),Xa2) = Y2 )
     => ( Y2
        = $ite(Xa2 = zero_zero(nat),X2,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa2),modulo_modulo(nat,X2,Xa2))) ) ) ).

% gcd_nat.elims
tff(fact_5044_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X2: A,Xs: list(A)] :
          ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),groups8242544230860333062m_list(A,Xs)) ) ) ).

% member_le_sum_list
tff(fact_5045_lessThan__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),insert(nat,K),aa(nat,set(nat),set_ord_lessThan(nat),K)) ) ).

% lessThan_Suc
tff(fact_5046_atMost__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,K)),aa(nat,set(nat),set_ord_atMost(nat),K)) ) ).

% atMost_Suc
tff(fact_5047_length__concat,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),concat(A,Xss)) = groups8242544230860333062m_list(nat,aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xss)) ) ).

% length_concat
tff(fact_5048_gcd__code__integer,axiom,
    ! [K: code_integer,L: code_integer] :
      ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),K),L)
      = aa(code_integer,code_integer,abs_abs(code_integer),$ite(L = zero_zero(code_integer),K,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),L),modulo_modulo(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))))) ) ).

% gcd_code_integer
tff(fact_5049_card__insert__le__m1,axiom,
    ! [A: $tType,Nb: nat,Y2: set(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,Y2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,aa(set(A),set(A),insert(A,X2),Y2))),Nb) ) ) ).

% card_insert_le_m1
tff(fact_5050_sum__multicount__gen,axiom,
    ! [A: $tType,B: $tType,S: set(A),T2: set(B),R3: fun(A,fun(B,$o)),K: fun(B,nat)] :
      ( finite_finite2(A,S)
     => ( finite_finite2(B,T2)
       => ( ! [X4: B] :
              ( aa(set(B),$o,member(B,X4),T2)
             => ( finite_card(A,aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aa(fun(A,fun(B,$o)),fun(B,fun(A,$o)),aTP_Lamp_nm(set(A),fun(fun(A,fun(B,$o)),fun(B,fun(A,$o))),S),R3),X4))) = aa(B,nat,K,X4) ) )
         => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,fun(B,$o)),fun(A,nat),aTP_Lamp_ph(set(B),fun(fun(A,fun(B,$o)),fun(A,nat)),T2),R3)),S) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),K),T2) ) ) ) ) ).

% sum_multicount_gen
tff(fact_5051_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set(A),Nb: nat] :
      ( finite_finite2(A,A3)
     => ( finite_card(list(A),aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(nat,fun(list(A),$o),aTP_Lamp_nh(set(A),fun(nat,fun(list(A),$o)),A3),Nb))) = aa(nat,nat,power_power(nat,finite_card(A,A3)),Nb) ) ) ).

% card_lists_length_eq
tff(fact_5052_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [F3: fun(B,A),C2: A,Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(A,fun(B,A),aTP_Lamp_id(fun(B,A),fun(A,fun(B,A)),F3),C2)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F3),Xs))),C2) ) ) ).

% sum_list_mult_const
tff(fact_5053_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [C2: A,F3: fun(B,A),Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ie(A,fun(fun(B,A),fun(B,A)),C2),F3)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F3),Xs))) ) ) ).

% sum_list_const_mult
tff(fact_5054_card__eq__sum,axiom,
    ! [A: $tType,A3: set(A)] : ( finite_card(A,A3) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_pi(A,nat)),A3) ) ).

% card_eq_sum
tff(fact_5055_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(B,A),G: fun(B,A),Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_if(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G)),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F3),Xs))),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,G),Xs))) ) ) ).

% sum_list_addf
tff(fact_5056_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(B,A),G: fun(B,A),Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ig(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G)),Xs)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F3),Xs))),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,G),Xs))) ) ) ).

% sum_list_subtractf
tff(fact_5057_card__length__sum__list__rec,axiom,
    ! [Ma: nat,N3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Ma)
     => ( finite_card(list(nat),aa(fun(list(nat),$o),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),$o),aTP_Lamp_pj(nat,fun(nat,fun(list(nat),$o)),Ma),N3))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(list(nat),aa(fun(list(nat),$o),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),$o),aTP_Lamp_pk(nat,fun(nat,fun(list(nat),$o)),Ma),N3)))),finite_card(list(nat),aa(fun(list(nat),$o),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),$o),aTP_Lamp_pl(nat,fun(nat,fun(list(nat),$o)),Ma),N3)))) ) ) ).

% card_length_sum_list_rec
tff(fact_5058_card__length__sum__list,axiom,
    ! [Ma: nat,N3: nat] : ( finite_card(list(nat),aa(fun(list(nat),$o),set(list(nat)),collect(list(nat)),aa(nat,fun(list(nat),$o),aTP_Lamp_pj(nat,fun(nat,fun(list(nat),$o)),Ma),N3))) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),Ma)),one_one(nat))),N3) ) ).

% card_length_sum_list
tff(fact_5059_card__2__iff_H,axiom,
    ! [A: $tType,S3: set(A)] :
      ( ( finite_card(A,S3) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ? [X3: A] :
          ( aa(set(A),$o,member(A,X3),S3)
          & ? [Xa: A] :
              ( aa(set(A),$o,member(A,Xa),S3)
              & ( X3 != Xa )
              & ! [Xb4: A] :
                  ( aa(set(A),$o,member(A,Xb4),S3)
                 => ( ( Xb4 = X3 )
                    | ( Xb4 = Xa ) ) ) ) ) ) ).

% card_2_iff'
tff(fact_5060_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),finite_card(A,A3))
     => finite_finite2(A,A3) ) ).

% card_ge_0_finite
tff(fact_5061_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => ? [X4: nat,Y4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X4) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)) ) ) ).

% bezout_nat
tff(fact_5062_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X4: nat,Y4: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X4))
        & ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) )
      | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X4))
        & ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ) ).

% bezout_gcd_nat'
tff(fact_5063_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( finite_finite2(A,A3)
     => ( finite_finite2(A,B4)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(A,A3)),finite_card(A,B4))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4))),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B4),A3))) ) ) ) ).

% card_less_sym_Diff
tff(fact_5064_card__length,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,aa(list(A),set(A),set2(A),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% card_length
tff(fact_5065_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M6: set(A)] :
      ( finite_finite2(A,M6)
     => ? [H2: fun(A,nat)] : bij_betw(A,nat,H2,M6,set_or7035219750837199246ssThan(nat,zero_zero(nat),finite_card(A,M6))) ) ).

% ex_bij_betw_finite_nat
tff(fact_5066_psubset__card__mono,axiom,
    ! [A: $tType,B4: set(A),A3: set(A)] :
      ( finite_finite2(A,B4)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(A,A3)),finite_card(A,B4)) ) ) ).

% psubset_card_mono
tff(fact_5067_sum_Oinsert__if,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),X2: A] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,X2),A3))
            = $ite(aa(set(A),$o,member(A,X2),A3),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,X2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3))) ) ) ) ).

% sum.insert_if
tff(fact_5068_prod_Oinsert__if,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),X2: A] :
          ( finite_finite2(A,A3)
         => ( groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),insert(A,X2),A3))
            = $ite(aa(set(A),$o,member(A,X2),A3),groups7121269368397514597t_prod(A,B,G,A3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,X2)),groups7121269368397514597t_prod(A,B,G,A3))) ) ) ) ).

% prod.insert_if
tff(fact_5069_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X4) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),groups8242544230860333062m_list(A,Xs)) ) ) ).

% Groups_List.sum_list_nonneg
tff(fact_5070_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X4) )
         => ( ( groups8242544230860333062m_list(A,Xs) = zero_zero(A) )
          <=> ! [X3: A] :
                ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
               => ( X3 = zero_zero(A) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
tff(fact_5071_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),zero_zero(A)) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),groups8242544230860333062m_list(A,Xs)),zero_zero(A)) ) ) ).

% sum_list_nonpos
tff(fact_5072_atLeast0__atMost__Suc,axiom,
    ! [Nb: nat] : ( set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Nb)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,Nb)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb)) ) ).

% atLeast0_atMost_Suc
tff(fact_5073_atLeast0__lessThan__Suc,axiom,
    ! [Nb: nat] : ( set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Nb)) = aa(set(nat),set(nat),insert(nat,Nb),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)) ) ).

% atLeast0_lessThan_Suc
tff(fact_5074_Icc__eq__insert__lb__nat,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( set_or1337092689740270186AtMost(nat,Ma,Nb) = aa(set(nat),set(nat),insert(nat,Ma),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),Nb)) ) ) ).

% Icc_eq_insert_lb_nat
tff(fact_5075_atLeastAtMostSuc__conv,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),aa(nat,nat,suc,Nb))
     => ( set_or1337092689740270186AtMost(nat,Ma,aa(nat,nat,suc,Nb)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,Nb)),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% atLeastAtMostSuc_conv
tff(fact_5076_atLeastAtMost__insertL,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( aa(set(nat),set(nat),insert(nat,Ma),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),Nb)) = set_or1337092689740270186AtMost(nat,Ma,Nb) ) ) ).

% atLeastAtMost_insertL
tff(fact_5077_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [Xs: list(A)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),groups8242544230860333062m_list(A,Xs))),groups8242544230860333062m_list(A,aa(list(A),list(A),map(A,A,abs_abs(A)),Xs))) ) ).

% sum_list_abs
tff(fact_5078_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: nat,C2: A] : ( groups8242544230860333062m_list(A,replicate(A,Nb,C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),C2) ) ) ).

% sum_list_replicate
tff(fact_5079_lessThan__nat__numeral,axiom,
    ! [K: num] : ( aa(nat,set(nat),set_ord_lessThan(nat),aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert(nat,pred_numeral(K)),aa(nat,set(nat),set_ord_lessThan(nat),pred_numeral(K))) ) ).

% lessThan_nat_numeral
tff(fact_5080_card__less__Suc2,axiom,
    ! [M6: set(nat),I3: nat] :
      ( ~ aa(set(nat),$o,member(nat,zero_zero(nat)),M6)
     => ( finite_card(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_pm(set(nat),fun(nat,fun(nat,$o)),M6),I3))) = finite_card(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_pn(set(nat),fun(nat,fun(nat,$o)),M6),I3))) ) ) ).

% card_less_Suc2
tff(fact_5081_card__less__Suc,axiom,
    ! [M6: set(nat),I3: nat] :
      ( aa(set(nat),$o,member(nat,zero_zero(nat)),M6)
     => ( aa(nat,nat,suc,finite_card(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_pm(set(nat),fun(nat,fun(nat,$o)),M6),I3)))) = finite_card(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_pn(set(nat),fun(nat,fun(nat,$o)),M6),I3))) ) ) ).

% card_less_Suc
tff(fact_5082_card__less,axiom,
    ! [M6: set(nat),I3: nat] :
      ( aa(set(nat),$o,member(nat,zero_zero(nat)),M6)
     => ( finite_card(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_pn(set(nat),fun(nat,fun(nat,$o)),M6),I3))) != zero_zero(nat) ) ) ).

% card_less
tff(fact_5083_atMost__nat__numeral,axiom,
    ! [K: num] : ( aa(nat,set(nat),set_ord_atMost(nat),aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert(nat,aa(num,nat,numeral_numeral(nat),K)),aa(nat,set(nat),set_ord_atMost(nat),pred_numeral(K))) ) ).

% atMost_nat_numeral
tff(fact_5084_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_card(int,set_or7035219750837199246ssThan(int,zero_zero(int),U)) = aa(int,nat,nat2,U) ) ).

% card_atLeastZeroLessThan_int
tff(fact_5085_sum__constant__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Y2: A,A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_po(A,fun(B,A),Y2)),A3) = aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,semiring_1_of_nat(real),finite_card(B,A3))),Y2) ) ) ).

% sum_constant_scaleR
tff(fact_5086_sum__Suc,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A)] : ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_pp(fun(A,nat),fun(A,nat),F3)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),finite_card(A,A3)) ) ).

% sum_Suc
tff(fact_5087_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S3: set(A),T4: set(B),R3: fun(A,fun(B,$o)),K: nat] :
      ( finite_finite2(A,S3)
     => ( finite_finite2(B,T4)
       => ( ! [X4: B] :
              ( aa(set(B),$o,member(B,X4),T4)
             => ( finite_card(A,aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aa(fun(A,fun(B,$o)),fun(B,fun(A,$o)),aTP_Lamp_nm(set(A),fun(fun(A,fun(B,$o)),fun(B,fun(A,$o))),S3),R3),X4))) = K ) )
         => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,fun(B,$o)),fun(A,nat),aTP_Lamp_ph(set(B),fun(fun(A,fun(B,$o)),fun(A,nat)),T4),R3)),S3) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),finite_card(B,T4)) ) ) ) ) ).

% sum_multicount
tff(fact_5088_subset__card__intvl__is__intvl,axiom,
    ! [A3: set(nat),K: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),A3),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),finite_card(nat,A3))))
     => ( A3 = set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),finite_card(nat,A3))) ) ) ).

% subset_card_intvl_is_intvl
tff(fact_5089_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add(B)
        & ordere6658533253407199908up_add(B) )
     => ! [Xs: list(A),F3: fun(A,B),G: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,G,X4)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F3),Xs))),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,G),Xs))) ) ) ).

% sum_list_mono
tff(fact_5090_real__of__card,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(nat,real,semiring_1_of_nat(real),finite_card(A,A3)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_pq(A,real)),A3) ) ).

% real_of_card
tff(fact_5091_sum__bounded__above,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [A3: set(A),F3: fun(A,B),K5: B] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),K5) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),finite_card(A,A3))),K5)) ) ) ).

% sum_bounded_above
tff(fact_5092_sum__bounded__below,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [A3: set(A),K5: B,F3: fun(A,B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),K5),aa(A,B,F3,I2)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),finite_card(A,A3))),K5)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)) ) ) ).

% sum_bounded_below
tff(fact_5093_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,A3)),aa(nat,nat,suc,zero_zero(nat)))
      <=> ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),A3)
           => ! [Xa: A] :
                ( aa(set(A),$o,member(A,Xa),A3)
               => ( X3 = Xa ) ) ) ) ) ).

% card_le_Suc0_iff_eq
tff(fact_5094_card__psubset,axiom,
    ! [A: $tType,B4: set(A),A3: set(A)] :
      ( finite_finite2(A,B4)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(A,A3)),finite_card(A,B4))
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4) ) ) ) ).

% card_psubset
tff(fact_5095_card__lists__length__le,axiom,
    ! [A: $tType,A3: set(A),Nb: nat] :
      ( finite_finite2(A,A3)
     => ( finite_card(list(A),aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(nat,fun(list(A),$o),aTP_Lamp_ns(set(A),fun(nat,fun(list(A),$o)),A3),Nb))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),power_power(nat,finite_card(A,A3))),aa(nat,set(nat),set_ord_atMost(nat),Nb)) ) ) ).

% card_lists_length_le
tff(fact_5096_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M6: set(A)] :
      ( finite_finite2(A,M6)
     => ? [H2: fun(nat,A)] : bij_betw(nat,A,H2,set_or7035219750837199246ssThan(nat,zero_zero(nat),finite_card(A,M6)),M6) ) ).

% ex_bij_betw_nat_finite
tff(fact_5097_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [K: nat,Ns: list(A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Ns))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Ns),K)),groups8242544230860333062m_list(A,Ns)) ) ) ).

% elem_le_sum_list
tff(fact_5098_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Nb: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Nb)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,aa(fun(A,$o),set(A),collect(A),aTP_Lamp_of(nat,fun(A,$o),Nb)))),Nb) ) ) ).

% card_roots_unity
tff(fact_5099_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N3: set(nat),Nb: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N3),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(nat,N3)),Nb) ) ).

% subset_eq_atLeast0_lessThan_card
tff(fact_5100_size__list__conv__sum__list,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A)] : ( aa(list(A),nat,size_list(A,F3),Xs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F3),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% size_list_conv_sum_list
tff(fact_5101_card__sum__le__nat__sum,axiom,
    ! [S3: set(nat)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_jv(nat,nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),finite_card(nat,S3)))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_jv(nat,nat)),S3)) ).

% card_sum_le_nat_sum
tff(fact_5102_sum__list__triv,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [R: A,Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aTP_Lamp_pd(A,fun(B,A),R)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(list(B),nat,size_size(list(B)),Xs))),R) ) ) ).

% sum_list_triv
tff(fact_5103_sum__list__Suc,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A)] : ( groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,aTP_Lamp_pp(fun(A,nat),fun(A,nat),F3)),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F3),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% sum_list_Suc
tff(fact_5104_card__nth__roots,axiom,
    ! [C2: complex,Nb: nat] :
      ( ( C2 != zero_zero(complex) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ( finite_card(complex,aa(fun(complex,$o),set(complex),collect(complex),aa(nat,fun(complex,$o),aTP_Lamp_ln(complex,fun(nat,fun(complex,$o)),C2),Nb))) = Nb ) ) ) ).

% card_nth_roots
tff(fact_5105_card__roots__unity__eq,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( finite_card(complex,aa(fun(complex,$o),set(complex),collect(complex),aTP_Lamp_hx(nat,fun(complex,$o),Nb))) = Nb ) ) ).

% card_roots_unity_eq
tff(fact_5106_sum__norm__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [S3: set(A),F3: fun(A,B),K5: real] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),S3)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X4))),K5) )
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),S3))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),finite_card(A,S3))),K5)) ) ) ).

% sum_norm_bound
tff(fact_5107_interv__sum__list__conv__sum__set__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),Ma: nat,Nb: nat] : ( groups8242544230860333062m_list(A,aa(list(nat),list(A),map(nat,A,F3),upt(Ma,Nb))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(list(nat),set(nat),set2(nat),upt(Ma,Nb))) ) ) ).

% interv_sum_list_conv_sum_set_nat
tff(fact_5108_sum__set__upt__conv__sum__list__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),aa(list(nat),set(nat),set2(nat),upt(Ma,Nb))) = groups8242544230860333062m_list(A,aa(list(nat),list(A),map(nat,A,F3),upt(Ma,Nb))) ) ) ).

% sum_set_upt_conv_sum_list_nat
tff(fact_5109_prod__le__power,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B),Nb: B,K: nat] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),Nb) ) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,A3)),K)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),Nb)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),groups7121269368397514597t_prod(A,B,F3,A3)),aa(nat,B,power_power(B,Nb),K)) ) ) ) ) ).

% prod_le_power
tff(fact_5110_sum__bounded__above__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere8940638589300402666id_add(B)
        & semiring_1(B) )
     => ! [A3: set(A),F3: fun(A,B),K5: B] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,I2)),K5) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),finite_card(A,A3))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),finite_card(A,A3))),K5)) ) ) ) ).

% sum_bounded_above_strict
tff(fact_5111_sum__list__sum__nth,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(A)] : ( groups8242544230860333062m_list(A,Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),nth(A,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% sum_list_sum_nth
tff(fact_5112_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A)] : ( groups8242544230860333062m_list(nat,aa(list(A),list(nat),map(A,nat,F3),Xs)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(list(A),fun(A,nat),aTP_Lamp_pr(fun(A,nat),fun(list(A),fun(A,nat)),F3),Xs)),aa(list(A),set(A),set2(A),Xs)) ) ).

% sum_list_map_eq_sum_count
tff(fact_5113_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,Nb: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,aa(fun(A,$o),set(A),collect(A),aa(nat,fun(A,$o),aTP_Lamp_oj(fun(nat,A),fun(nat,fun(A,$o)),C2),Nb)))),Nb) ) ) ) ).

% polyfun_roots_card
tff(fact_5114_prod__gen__delta,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B),C2: B] :
          ( finite_finite2(A,S3)
         => ( groups7121269368397514597t_prod(A,B,aa(B,fun(A,B),aa(fun(A,B),fun(B,fun(A,B)),aTP_Lamp_ps(A,fun(fun(A,B),fun(B,fun(A,B))),A2),B2),C2),S3)
            = $ite(aa(set(A),$o,member(A,A2),S3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,B2,A2)),aa(nat,B,power_power(B,C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(A,S3)),one_one(nat)))),aa(nat,B,power_power(B,C2),finite_card(A,S3))) ) ) ) ).

% prod_gen_delta
tff(fact_5115_set__decode__plus__power__2,axiom,
    ! [Nb: nat,Z: nat] :
      ( ~ aa(set(nat),$o,member(nat,Nb),nat_set_decode(Z))
     => ( nat_set_decode(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),Z)) = aa(set(nat),set(nat),insert(nat,Nb),nat_set_decode(Z)) ) ) ).

% set_decode_plus_power_2
tff(fact_5116_bezw__aux,axiom,
    ! [X2: nat,Y2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X2),Y2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(X2,Y2))),aa(nat,int,semiring_1_of_nat(int),X2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(X2,Y2))),aa(nat,int,semiring_1_of_nat(int),Y2))) ) ).

% bezw_aux
tff(fact_5117_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,Nb: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
           => ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(nat,fun(A,$o),aTP_Lamp_oj(fun(nat,A),fun(nat,fun(A,$o)),C2),Nb)))
              & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,aa(fun(A,$o),set(A),collect(A),aa(nat,fun(A,$o),aTP_Lamp_oj(fun(nat,A),fun(nat,fun(A,$o)),C2),Nb)))),Nb) ) ) ) ) ).

% polyfun_rootbound
tff(fact_5118_gcd__nat_Opelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X2),Xa2) = Y2 )
     => ( accp(product_prod(nat,nat),gcd_nat_rel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),Xa2))
       => ~ ( ( Y2
              = $ite(Xa2 = zero_zero(nat),X2,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa2),modulo_modulo(nat,X2,Xa2))) )
           => ~ accp(product_prod(nat,nat),gcd_nat_rel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),Xa2)) ) ) ) ).

% gcd_nat.pelims
tff(fact_5119_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( finite_finite2(A,A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),finite_card(A,A3))
       => ( finite_card(list(A),aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(nat,fun(list(A),$o),aTP_Lamp_pt(set(A),fun(nat,fun(list(A),$o)),A3),K))) = groups7121269368397514597t_prod(nat,nat,aTP_Lamp_jv(nat,nat),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(A,A3)),K)),one_one(nat)),finite_card(A,A3))) ) ) ) ).

% card_lists_distinct_length_eq
tff(fact_5120_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),finite_card(A,A3))
     => ( finite_card(list(A),aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(set(A),fun(list(A),$o),aTP_Lamp_pu(nat,fun(set(A),fun(list(A),$o)),K),A3))) = groups7121269368397514597t_prod(nat,nat,aTP_Lamp_jv(nat,nat),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(A,A3)),K)),one_one(nat)),finite_card(A,A3))) ) ) ).

% card_lists_distinct_length_eq'
tff(fact_5121_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set(A),Nb: nat] :
      ( finite_finite2(A,A3)
     => finite_finite2(list(A),aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(nat,fun(list(A),$o),aTP_Lamp_pt(set(A),fun(nat,fun(list(A),$o)),A3),Nb))) ) ).

% finite_lists_distinct_length_eq
tff(fact_5122_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => distinct(set(A),aa(list(list(A)),list(set(A)),map(list(A),set(A),set2(A)),subseqs(A,Xs))) ) ).

% distinct_set_subseqs
tff(fact_5123_distinct__upt,axiom,
    ! [I3: nat,J2: nat] : distinct(nat,upt(I3,J2)) ).

% distinct_upt
tff(fact_5124_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( distinct(A,Xs)
         => distinct(A,Xs) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
tff(fact_5125_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] :
      ( distinct(A,Xs)
     => ( distinct(B,Ys)
       => distinct(product_prod(A,B),product(A,B,Xs,Ys)) ) ) ).

% distinct_product
tff(fact_5126_distinct__take,axiom,
    ! [A: $tType,Xs: list(A),I3: nat] :
      ( distinct(A,Xs)
     => distinct(A,take(A,I3,Xs)) ) ).

% distinct_take
tff(fact_5127_distinct__enumerate,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : distinct(product_prod(nat,A),enumerate(A,Nb,Xs)) ).

% distinct_enumerate
tff(fact_5128_finite__distinct__list,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ? [Xs2: list(A)] :
          ( ( aa(list(A),set(A),set2(A),Xs2) = A3 )
          & distinct(A,Xs2) ) ) ).

% finite_distinct_list
tff(fact_5129_subseqs__distinctD,axiom,
    ! [A: $tType,Ys: list(A),Xs: list(A)] :
      ( aa(set(list(A)),$o,member(list(A),Ys),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs)))
     => ( distinct(A,Xs)
       => distinct(A,Ys) ) ) ).

% subseqs_distinctD
tff(fact_5130_distinct__card,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => ( finite_card(A,aa(list(A),set(A),set2(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ) ).

% distinct_card
tff(fact_5131_card__distinct,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( finite_card(A,aa(list(A),set(A),set2(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) )
     => distinct(A,Xs) ) ).

% card_distinct
tff(fact_5132_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list(A),I3: nat,J2: nat] :
      ( distinct(A,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
         => ( ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,nth(A,Xs),J2) )
          <=> ( I3 = J2 ) ) ) ) ) ).

% nth_eq_iff_index_eq
tff(fact_5133_distinct__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
    <=> ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
         => ! [J4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs))
             => ( ( I != J4 )
               => ( aa(nat,A,nth(A,Xs),I) != aa(nat,A,nth(A,Xs),J4) ) ) ) ) ) ).

% distinct_conv_nth
tff(fact_5134_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(A)] :
          ( distinct(A,Xs)
         => ( groups8242544230860333062m_list(A,Xs) = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_pv(A,A)),aa(list(A),set(A),set2(A),Xs)) ) ) ) ).

% distinct_sum_list_conv_Sum
tff(fact_5135_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
       => ? [X4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),aa(list(A),nat,size_size(list(A)),Xs))
            & ( aa(nat,A,nth(A,Xs),X4) = X2 )
            & ! [Y3: nat] :
                ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y3),aa(list(A),nat,size_size(list(A)),Xs))
                  & ( aa(nat,A,nth(A,Xs),Y3) = X2 ) )
               => ( Y3 = X4 ) ) ) ) ) ).

% distinct_Ex1
tff(fact_5136_sum__list__distinct__conv__sum__set,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Xs: list(A),F3: fun(A,B)] :
          ( distinct(A,Xs)
         => ( groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F3),Xs)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(list(A),set(A),set2(A),Xs)) ) ) ) ).

% sum_list_distinct_conv_sum_set
tff(fact_5137_sum_Odistinct__set__conv__list,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Xs: list(A),G: fun(A,B)] :
          ( distinct(A,Xs)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(list(A),set(A),set2(A),Xs)) = groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,G),Xs)) ) ) ) ).

% sum.distinct_set_conv_list
tff(fact_5138_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list(A),A3: set(nat),B4: set(A)] :
      ( distinct(A,Xs)
     => ( ( A3 = aa(nat,set(nat),set_ord_lessThan(nat),aa(list(A),nat,size_size(list(A)),Xs)) )
       => ( ( B4 = aa(list(A),set(A),set2(A),Xs) )
         => bij_betw(nat,A,nth(A,Xs),A3,B4) ) ) ) ).

% bij_betw_nth
tff(fact_5139_eq__key__imp__eq__value,axiom,
    ! [A: $tType,B: $tType,Xs: list(product_prod(A,B)),K: A,V1: B,V22: B] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))
     => ( aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V1)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs))
       => ( aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V22)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs))
         => ( V1 = V22 ) ) ) ) ).

% eq_key_imp_eq_value
tff(fact_5140_and__int_Osimps,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = $ite(
          ( aa(set(int),$o,member(int,K),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
          & aa(set(int),$o,member(int,L),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
          aa(int,int,uminus_uminus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
            & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
          aa(int,int,
            aa(int,fun(int,int),plus_plus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
            aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ).

% and_int.simps
tff(fact_5141_and__int_Oelims,axiom,
    ! [X2: int,Xa2: int,Y2: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Xa2) = Y2 )
     => ( Y2
        = $ite(
            ( aa(set(int),$o,member(int,X2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & aa(set(int),$o,member(int,Xa2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa2))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)
                & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa2))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.elims
tff(fact_5142_singleton__conv,axiom,
    ! [A: $tType,A2: A] : ( aa(fun(A,$o),set(A),collect(A),aTP_Lamp_dx(A,fun(A,$o),A2)) = aa(set(A),set(A),insert(A,A2),bot_bot(set(A))) ) ).

% singleton_conv
tff(fact_5143_singleton__conv2,axiom,
    ! [A: $tType,A2: A] : ( aa(fun(A,$o),set(A),collect(A),aa(A,fun(A,$o),fequal(A),A2)) = aa(set(A),set(A),insert(A,A2),bot_bot(set(A))) ) ).

% singleton_conv2
tff(fact_5144_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty
tff(fact_5145_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)) ) ) ) ).

% atLeastatMost_empty
tff(fact_5146_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or7035219750837199246ssThan(A,A2,B2) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% atLeastLessThan_empty_iff2
tff(fact_5147_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( ( set_or7035219750837199246ssThan(A,A2,B2) = bot_bot(set(A)) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% atLeastLessThan_empty_iff
tff(fact_5148_card_Oempty,axiom,
    ! [A: $tType] : ( finite_card(A,bot_bot(set(A))) = zero_zero(nat) ) ).

% card.empty
tff(fact_5149_card__0__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ( ( finite_card(A,A3) = zero_zero(nat) )
      <=> ( A3 = bot_bot(set(A)) ) ) ) ).

% card_0_eq
tff(fact_5150_set__replicate,axiom,
    ! [A: $tType,Nb: nat,X2: A] :
      ( ( Nb != zero_zero(nat) )
     => ( aa(list(A),set(A),set2(A),replicate(A,Nb,X2)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ) ).

% set_replicate
tff(fact_5151_Collect__conv__if,axiom,
    ! [A: $tType,A2: A,P: fun(A,$o)] :
      ( aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_pw(A,fun(fun(A,$o),fun(A,$o)),A2),P))
      = $ite(aa(A,$o,P,A2),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))),bot_bot(set(A))) ) ).

% Collect_conv_if
tff(fact_5152_Collect__conv__if2,axiom,
    ! [A: $tType,A2: A,P: fun(A,$o)] :
      ( aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_px(A,fun(fun(A,$o),fun(A,$o)),A2),P))
      = $ite(aa(A,$o,P,A2),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))),bot_bot(set(A))) ) ).

% Collect_conv_if2
tff(fact_5153_some__in__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,member(A,fChoice(A,aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3))),A3)
    <=> ( A3 != bot_bot(set(A)) ) ) ).

% some_in_eq
tff(fact_5154_empty__def,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_py(A,$o)) ) ).

% empty_def
tff(fact_5155_not__psubset__empty,axiom,
    ! [A: $tType,A3: set(A)] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),bot_bot(set(A))) ).

% not_psubset_empty
tff(fact_5156_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A2: A] :
          ( ( A2 != bot_bot(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),bot_bot(A)),A2) ) ) ).

% bot.not_eq_extremum
tff(fact_5157_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),bot_bot(A)) ) ).

% bot.extremum_strict
tff(fact_5158_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [S3: set(A)] :
          ( finite_finite2(A,S3)
         => ( ( S3 != bot_bot(set(A)) )
           => ? [X4: A] :
                ( aa(set(A),$o,member(A,X4),S3)
                & ~ ? [Xa3: A] :
                      ( aa(set(A),$o,member(A,Xa3),S3)
                      & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa3),X4) ) ) ) ) ) ).

% ex_min_if_finite
tff(fact_5159_infinite__growing,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X7: set(A)] :
          ( ( X7 != bot_bot(set(A)) )
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),X7)
               => ? [Xa3: A] :
                    ( aa(set(A),$o,member(A,Xa3),X7)
                    & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Xa3) ) )
           => ~ finite_finite2(A,X7) ) ) ) ).

% infinite_growing
tff(fact_5160_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),P: fun(set(A),$o)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),$o,P,bot_bot(set(A)))
           => ( ! [B3: A,A7: set(A)] :
                  ( finite_finite2(A,A7)
                 => ( ! [X: A] :
                        ( aa(set(A),$o,member(A,X),A7)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),B3) )
                   => ( aa(set(A),$o,P,A7)
                     => aa(set(A),$o,P,aa(set(A),set(A),insert(A,B3),A7)) ) ) )
             => aa(set(A),$o,P,A3) ) ) ) ) ).

% finite_linorder_max_induct
tff(fact_5161_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),P: fun(set(A),$o)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),$o,P,bot_bot(set(A)))
           => ( ! [B3: A,A7: set(A)] :
                  ( finite_finite2(A,A7)
                 => ( ! [X: A] :
                        ( aa(set(A),$o,member(A,X),A7)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B3),X) )
                   => ( aa(set(A),$o,P,A7)
                     => aa(set(A),$o,P,aa(set(A),set(A),insert(A,B3),A7)) ) ) )
             => aa(set(A),$o,P,A3) ) ) ) ) ).

% finite_linorder_min_induct
tff(fact_5162_sum__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( strict7427464778891057005id_add(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X4)),aa(A,B,G,X4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)) ) ) ) ) ).

% sum_strict_mono
tff(fact_5163_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( finite_card(A,A3) = zero_zero(nat) )
    <=> ( ( A3 = bot_bot(set(A)) )
        | ~ finite_finite2(A,A3) ) ) ).

% card_eq_0_iff
tff(fact_5164_sum__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,I5)
         => ( ( I5 != bot_bot(set(A)) )
           => ( ! [I2: A] :
                  ( aa(set(A),$o,member(A,I2),I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F3,I2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),I5)) ) ) ) ) ).

% sum_pos
tff(fact_5165_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,I5)
         => ( ( I5 != bot_bot(set(A)) )
           => ( ! [I2: A] :
                  ( aa(set(A),$o,member(A,I2),I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(A,B,F3,I2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),groups7121269368397514597t_prod(A,B,F3,I5)) ) ) ) ) ).

% less_1_prod
tff(fact_5166_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),finite_card(A,A3))
    <=> ( ( A3 != bot_bot(set(A)) )
        & finite_finite2(A,A3) ) ) ).

% card_gt_0_iff
tff(fact_5167_card__Suc__eq,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( finite_card(A,A3) = aa(nat,nat,suc,K) )
    <=> ? [B6: A,B10: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B6),B10) )
          & ~ aa(set(A),$o,member(A,B6),B10)
          & ( finite_card(A,B10) = K )
          & ( ( K = zero_zero(nat) )
           => ( B10 = bot_bot(set(A)) ) ) ) ) ).

% card_Suc_eq
tff(fact_5168_card__eq__SucD,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( finite_card(A,A3) = aa(nat,nat,suc,K) )
     => ? [B3: A,B8: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B3),B8) )
          & ~ aa(set(A),$o,member(A,B3),B8)
          & ( finite_card(A,B8) = K )
          & ( ( K = zero_zero(nat) )
           => ( B8 = bot_bot(set(A)) ) ) ) ) ).

% card_eq_SucD
tff(fact_5169_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( finite_card(A,A3) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ? [X3: A] : ( A3 = aa(set(A),set(A),insert(A,X3),bot_bot(set(A))) ) ) ).

% card_1_singleton_iff
tff(fact_5170_finite__induct__select,axiom,
    ! [A: $tType,S3: set(A),P: fun(set(A),$o)] :
      ( finite_finite2(A,S3)
     => ( aa(set(A),$o,P,bot_bot(set(A)))
       => ( ! [T6: set(A)] :
              ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),T6),S3)
             => ( aa(set(A),$o,P,T6)
               => ? [X: A] :
                    ( aa(set(A),$o,member(A,X),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),T6))
                    & aa(set(A),$o,P,aa(set(A),set(A),insert(A,X),T6)) ) ) )
         => aa(set(A),$o,P,S3) ) ) ) ).

% finite_induct_select
tff(fact_5171_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set(A),X2: A,B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),aa(set(A),set(A),insert(A,X2),B4))
    <=> $ite(
          aa(set(A),$o,member(A,X2),B4),
          aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4),
          $ite(aa(set(A),$o,member(A,X2),A3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),B4),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)) ) ) ).

% psubset_insert_iff
tff(fact_5172_set__replicate__Suc,axiom,
    ! [A: $tType,Nb: nat,X2: A] : ( aa(list(A),set(A),set2(A),replicate(A,aa(nat,nat,suc,Nb),X2)) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ).

% set_replicate_Suc
tff(fact_5173_set__replicate__conv__if,axiom,
    ! [A: $tType,Nb: nat,X2: A] :
      ( aa(list(A),set(A),set2(A),replicate(A,Nb,X2))
      = $ite(Nb = zero_zero(nat),bot_bot(set(A)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) ).

% set_replicate_conv_if
tff(fact_5174_simp__from__to,axiom,
    ! [I3: int,J2: int] :
      ( set_or1337092689740270186AtMost(int,I3,J2)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I3),bot_bot(set(int)),aa(set(int),set(int),insert(int,I3),set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)),J2))) ) ).

% simp_from_to
tff(fact_5175_prod__mono__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( ! [I2: A] :
                ( aa(set(A),$o,member(A,I2),A3)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2))
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,I2)),aa(A,B,G,I2)) ) )
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),groups7121269368397514597t_prod(A,B,F3,A3)),groups7121269368397514597t_prod(A,B,G,A3)) ) ) ) ) ).

% prod_mono_strict
tff(fact_5176_card__2__iff,axiom,
    ! [A: $tType,S3: set(A)] :
      ( ( finite_card(A,S3) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ? [X3: A,Y: A] :
          ( ( S3 = aa(set(A),set(A),insert(A,X3),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))) )
          & ( X3 != Y ) ) ) ).

% card_2_iff
tff(fact_5177_sum_Oremove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),X2: A,G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),$o,member(A,X2),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,X2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ).

% sum.remove
tff(fact_5178_sum_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),X2: A] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,X2),A3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,X2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ).

% sum.insert_remove
tff(fact_5179_card__3__iff,axiom,
    ! [A: $tType,S3: set(A)] :
      ( ( finite_card(A,S3) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
    <=> ? [X3: A,Y: A,Z5: A] :
          ( ( S3 = aa(set(A),set(A),insert(A,X3),aa(set(A),set(A),insert(A,Y),aa(set(A),set(A),insert(A,Z5),bot_bot(set(A))))) )
          & ( X3 != Y )
          & ( Y != Z5 )
          & ( X3 != Z5 ) ) ) ).

% card_3_iff
tff(fact_5180_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),finite_card(A,A3))
     => ( A3 != bot_bot(set(A)) ) ) ).

% odd_card_imp_not_empty
tff(fact_5181_prod_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),X2: A] :
          ( finite_finite2(A,A3)
         => ( groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),insert(A,X2),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,X2)),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ).

% prod.insert_remove
tff(fact_5182_prod_Oremove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),X2: A,G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),$o,member(A,X2),A3)
           => ( groups7121269368397514597t_prod(A,B,G,A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,X2)),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ).

% prod.remove
tff(fact_5183_card_Oremove,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( finite_finite2(A,A3)
     => ( aa(set(A),$o,member(A,X2),A3)
       => ( finite_card(A,A3) = aa(nat,nat,suc,finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ).

% card.remove
tff(fact_5184_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( finite_finite2(A,A3)
     => ( finite_card(A,aa(set(A),set(A),insert(A,X2),A3)) = aa(nat,nat,suc,finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ).

% card.insert_remove
tff(fact_5185_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( finite_finite2(A,A3)
     => ( aa(set(A),$o,member(A,X2),A3)
       => ( aa(nat,nat,suc,finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) = finite_card(A,A3) ) ) ) ).

% card_Suc_Diff1
tff(fact_5186_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))),finite_card(A,A3))
    <=> ( finite_finite2(A,A3)
        & aa(set(A),$o,member(A,X2),A3) ) ) ).

% card_Diff1_less_iff
tff(fact_5187_card__Diff2__less,axiom,
    ! [A: $tType,A3: set(A),X2: A,Y2: A] :
      ( finite_finite2(A,A3)
     => ( aa(set(A),$o,member(A,X2),A3)
       => ( aa(set(A),$o,member(A,Y2),A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A)))))),finite_card(A,A3)) ) ) ) ).

% card_Diff2_less
tff(fact_5188_card__Diff1__less,axiom,
    ! [A: $tType,A3: set(A),X2: A] :
      ( finite_finite2(A,A3)
     => ( aa(set(A),$o,member(A,X2),A3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))),finite_card(A,A3)) ) ) ).

% card_Diff1_less
tff(fact_5189_sum_Odelta__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B),C2: fun(A,B)] :
          ( finite_finite2(A,S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_pz(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A2),B2),C2)),S3)
            = $ite(aa(set(A),$o,member(A,A2),S3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,B2,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% sum.delta_remove
tff(fact_5190_prod_Odelta__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B),C2: fun(A,B)] :
          ( finite_finite2(A,S3)
         => ( groups7121269368397514597t_prod(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_qa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A2),B2),C2),S3)
            = $ite(aa(set(A),$o,member(A,A2),S3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,B2,A2)),groups7121269368397514597t_prod(A,B,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))),groups7121269368397514597t_prod(A,B,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% prod.delta_remove
tff(fact_5191_member__le__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [I3: A,A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,member(A,I3),A3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,I3),bot_bot(set(A)))))
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X4)) )
           => ( finite_finite2(A,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)) ) ) ) ) ).

% member_le_sum
tff(fact_5192_sum__bounded__above__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_field(B)
     => ! [A3: set(A),F3: fun(A,B),K5: B] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),aa(B,B,aa(B,fun(B,B),divide_divide(B),K5),aa(nat,B,semiring_1_of_nat(B),finite_card(A,A3)))) )
         => ( finite_finite2(A,A3)
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),K5) ) ) ) ) ).

% sum_bounded_above_divide
tff(fact_5193_prod__diff1,axiom,
    ! [B: $tType,A: $tType] :
      ( semidom_divide(B)
     => ! [A3: set(A),F3: fun(A,B),A2: A] :
          ( finite_finite2(A,A3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => ( groups7121269368397514597t_prod(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))
              = $ite(aa(set(A),$o,member(A,A2),A3),aa(B,B,aa(B,fun(B,B),divide_divide(B),groups7121269368397514597t_prod(A,B,F3,A3)),aa(A,B,F3,A2)),groups7121269368397514597t_prod(A,B,F3,A3)) ) ) ) ) ).

% prod_diff1
tff(fact_5194_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( sinh(A,X2) = zero_zero(A) )
        <=> aa(set(A),$o,member(A,aa(A,A,exp(A),X2)),aa(set(A),set(A),insert(A,one_one(A)),aa(set(A),set(A),insert(A,aa(A,A,uminus_uminus(A),one_one(A))),bot_bot(set(A))))) ) ) ).

% sinh_zero_iff
tff(fact_5195_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K),L))
     => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
        = $ite(
            ( aa(set(int),$o,member(int,K),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & aa(set(int),$o,member(int,L),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
                & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.psimps
tff(fact_5196_and__int_Opelims,axiom,
    ! [X2: int,Xa2: int,Y2: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X2),Xa2) = Y2 )
     => ( accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X2),Xa2))
       => ~ ( ( Y2
              = $ite(
                  ( aa(set(int),$o,member(int,X2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                  & aa(set(int),$o,member(int,Xa2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
                  aa(int,int,uminus_uminus(int),
                    aa($o,int,zero_neq_one_of_bool(int),
                      ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)
                    & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa2))),
                  aa(int,int,
                    aa(int,fun(int,int),plus_plus(int),
                      aa($o,int,zero_neq_one_of_bool(int),
                        ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X2)
                      & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa2))),
                    aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) )
           => ~ accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X2),Xa2)) ) ) ) ).

% and_int.pelims
tff(fact_5197_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [F3: fun(nat,A),Ns: list(nat)] :
          ( ! [X4: nat,Y4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Y4)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,X4)),aa(nat,A,F3,Y4)) )
         => ( sorted_wrt(nat,ord_less(nat),Ns)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(nat),nat,size_size(list(nat)),Ns)))),groups8242544230860333062m_list(A,aa(list(nat),list(A),map(nat,A,F3),Ns))) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
tff(fact_5198_bit__0__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( bit_se5641148757651400278ts_bit(A,zero_zero(A)) = bot_bot(fun(nat,$o)) ) ) ).

% bit_0_eq
tff(fact_5199_lessThan__0,axiom,
    aa(nat,set(nat),set_ord_lessThan(nat),zero_zero(nat)) = bot_bot(set(nat)) ).

% lessThan_0
tff(fact_5200_set__decode__zero,axiom,
    nat_set_decode(zero_zero(nat)) = bot_bot(set(nat)) ).

% set_decode_zero
tff(fact_5201_set__encode__empty,axiom,
    aa(set(nat),nat,nat_set_encode,bot_bot(set(nat))) = zero_zero(nat) ).

% set_encode_empty
tff(fact_5202_atLeastLessThan__singleton,axiom,
    ! [Ma: nat] : ( set_or7035219750837199246ssThan(nat,Ma,aa(nat,nat,suc,Ma)) = aa(set(nat),set(nat),insert(nat,Ma),bot_bot(set(nat))) ) ).

% atLeastLessThan_singleton
tff(fact_5203_atMost__0,axiom,
    aa(nat,set(nat),set_ord_atMost(nat),zero_zero(nat)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))) ).

% atMost_0
tff(fact_5204_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R3: fun(A,fun(A,$o)),F3: fun(B,A),Xs: list(B)] :
      ( sorted_wrt(A,R3,aa(list(B),list(A),map(B,A,F3),Xs))
    <=> sorted_wrt(B,aa(fun(B,A),fun(B,fun(B,$o)),aTP_Lamp_qb(fun(A,fun(A,$o)),fun(fun(B,A),fun(B,fun(B,$o))),R3),F3),Xs) ) ).

% sorted_wrt_map
tff(fact_5205_bot__enat__def,axiom,
    bot_bot(extended_enat) = zero_zero(extended_enat) ).

% bot_enat_def
tff(fact_5206_bot__nat__def,axiom,
    bot_bot(nat) = zero_zero(nat) ).

% bot_nat_def
tff(fact_5207_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType,X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),bot_bot(fun(A,fun(B,$o))),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),bot_bot(set(product_prod(A,B)))) ) ).

% bot_empty_eq2
tff(fact_5208_sorted__take,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Nb: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),take(A,Nb,Xs)) ) ) ).

% sorted_take
tff(fact_5209_sorted__wrt__take,axiom,
    ! [A: $tType,F3: fun(A,fun(A,$o)),Xs: list(A),Nb: nat] :
      ( sorted_wrt(A,F3,Xs)
     => sorted_wrt(A,F3,take(A,Nb,Xs)) ) ).

% sorted_wrt_take
tff(fact_5210_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list(A)] : sorted_wrt(A,aTP_Lamp_qc(A,fun(A,$o)),Xs) ).

% sorted_wrt_true
tff(fact_5211_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% strict_sorted_imp_sorted
tff(fact_5212_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( sorted_wrt(A,ord_less(A),Xs)
         => ( sorted_wrt(A,ord_less(A),Ys)
           => ( ( aa(list(A),set(A),set2(A),Ys) = aa(list(A),set(A),set2(A),Xs) )
             => ( Ys = Xs ) ) ) ) ) ).

% strict_sorted_equal
tff(fact_5213_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,fun(A,$o)),Q: fun(A,fun(A,$o))] :
      ( ! [X4: A,Y4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => ( aa(set(A),$o,member(A,Y4),aa(list(A),set(A),set2(A),Xs))
           => ( aa(A,$o,aa(A,fun(A,$o),P,X4),Y4)
             => aa(A,$o,aa(A,fun(A,$o),Q,X4),Y4) ) ) )
     => ( sorted_wrt(A,P,Xs)
       => sorted_wrt(A,Q,Xs) ) ) ).

% sorted_wrt_mono_rel
tff(fact_5214_sorted__replicate,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Nb: nat,X2: A] : sorted_wrt(A,ord_less_eq(A),replicate(A,Nb,X2)) ) ).

% sorted_replicate
tff(fact_5215_sorted__wrt__upt,axiom,
    ! [Ma: nat,Nb: nat] : sorted_wrt(nat,ord_less(nat),upt(Ma,Nb)) ).

% sorted_wrt_upt
tff(fact_5216_sorted__upt,axiom,
    ! [Ma: nat,Nb: nat] : sorted_wrt(nat,ord_less_eq(nat),upt(Ma,Nb)) ).

% sorted_upt
tff(fact_5217_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),Xs))
        <=> sorted_wrt(B,aTP_Lamp_qd(fun(B,A),fun(B,fun(B,$o)),F3),Xs) ) ) ).

% sorted_map
tff(fact_5218_atLeastLessThan0,axiom,
    ! [Ma: nat] : ( set_or7035219750837199246ssThan(nat,Ma,zero_zero(nat)) = bot_bot(set(nat)) ) ).

% atLeastLessThan0
tff(fact_5219_lessThan__empty__iff,axiom,
    ! [Nb: nat] :
      ( ( aa(nat,set(nat),set_ord_lessThan(nat),Nb) = bot_bot(set(nat)) )
    <=> ( Nb = zero_zero(nat) ) ) ).

% lessThan_empty_iff
tff(fact_5220_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: list(A)] :
          ( sorted_wrt(A,ord_less(A),L)
        <=> ( sorted_wrt(A,ord_less_eq(A),L)
            & distinct(A,L) ) ) ) ).

% strict_sorted_iff
tff(fact_5221_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( distinct(A,Xs)
           => ( sorted_wrt(A,ord_less_eq(A),Ys)
             => ( distinct(A,Ys)
               => ( ( aa(list(A),set(A),set2(A),Xs) = aa(list(A),set(A),set2(A),Ys) )
                 => ( Xs = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
tff(fact_5222_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,fun(A,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
     => sorted_wrt(A,P,Xs) ) ).

% sorted_wrt01
tff(fact_5223_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xs: list(A)] :
      ( sorted_wrt(A,P,Xs)
    <=> ! [I: nat,J4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J4)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs))
           => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J4)) ) ) ) ).

% sorted_wrt_iff_nth_less
tff(fact_5224_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xs: list(A),I3: nat,J2: nat] :
      ( sorted_wrt(A,P,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
         => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,nth(A,Xs),I3)),aa(nat,A,nth(A,Xs),J2)) ) ) ) ).

% sorted_wrt_nth_less
tff(fact_5225_sorted01,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
         => sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% sorted01
tff(fact_5226_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I: nat,J4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J4)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J4)) ) ) ) ) ).

% sorted_iff_nth_mono_less
tff(fact_5227_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( finite_finite2(A,A3)
         => ? [X4: list(A)] :
              ( ( aa(list(A),set(A),set2(A),X4) = A3 )
              & sorted_wrt(A,ord_less_eq(A),X4)
              & distinct(A,X4)
              & ! [Y3: list(A)] :
                  ( ( ( aa(list(A),set(A),set2(A),Y3) = A3 )
                    & sorted_wrt(A,ord_less_eq(A),Y3)
                    & distinct(A,Y3) )
                 => ( Y3 = X4 ) ) ) ) ) ).

% finite_sorted_distinct_unique
tff(fact_5228_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I))) ) ) ) ).

% sorted_iff_nth_Suc
tff(fact_5229_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( finite_finite2(A,A3)
         => ~ ! [L2: list(A)] :
                ( sorted_wrt(A,ord_less(A),L2)
               => ( ( aa(list(A),set(A),set2(A),L2) = A3 )
                 => ( aa(list(A),nat,size_size(list(A)),L2) != finite_card(A,A3) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
tff(fact_5230_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I: nat,J4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J4)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J4)) ) ) ) ) ).

% sorted_iff_nth_mono
tff(fact_5231_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I3: nat,J2: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I3)),aa(nat,A,nth(A,Xs),J2)) ) ) ) ) ).

% sorted_nth_mono
tff(fact_5232_atLeastLessThanSuc,axiom,
    ! [Ma: nat,Nb: nat] :
      ( set_or7035219750837199246ssThan(nat,Ma,aa(nat,nat,suc,Nb))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb),aa(set(nat),set(nat),insert(nat,Nb),set_or7035219750837199246ssThan(nat,Ma,Nb)),bot_bot(set(nat))) ) ).

% atLeastLessThanSuc
tff(fact_5233_sorted__wrt__less__idx,axiom,
    ! [Ns: list(nat),I3: nat] :
      ( sorted_wrt(nat,ord_less(nat),Ns)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(nat),nat,size_size(list(nat)),Ns))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),aa(nat,nat,nth(nat,Ns),I3)) ) ) ).

% sorted_wrt_less_idx
tff(fact_5234_sorted__enumerate,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : sorted_wrt(nat,ord_less_eq(nat),aa(list(product_prod(nat,A)),list(nat),map(product_prod(nat,A),nat,product_fst(nat,A)),enumerate(A,Nb,Xs))) ).

% sorted_enumerate
tff(fact_5235_atLeast1__lessThan__eq__remove0,axiom,
    ! [Nb: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),Nb) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_lessThan(nat),Nb)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_lessThan_eq_remove0
tff(fact_5236_atLeast1__atMost__eq__remove0,axiom,
    ! [Nb: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Nb) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_atMost(nat),Nb)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_atMost_eq_remove0
tff(fact_5237_atLeastLessThan__nat__numeral,axiom,
    ! [Ma: nat,K: num] :
      ( set_or7035219750837199246ssThan(nat,Ma,aa(num,nat,numeral_numeral(nat),K))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),pred_numeral(K)),aa(set(nat),set(nat),insert(nat,pred_numeral(K)),set_or7035219750837199246ssThan(nat,Ma,pred_numeral(K))),bot_bot(set(nat))) ) ).

% atLeastLessThan_nat_numeral
tff(fact_5238_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,$o))] :
      ( accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A0),A1))
     => ( ! [K2: int,L2: int] :
            ( accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K2),L2))
           => ( ( ~ ( aa(set(int),$o,member(int,K2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                    & aa(set(int),$o,member(int,L2),aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) )
               => aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),K2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))) )
             => aa(int,$o,aa(int,fun(int,$o),P,K2),L2) ) )
       => aa(int,$o,aa(int,fun(int,$o),P,A0),A1) ) ) ).

% and_int.pinduct
tff(fact_5239_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,$o))] :
      ( accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A0),A1))
     => ( ! [I2: int,J: int] :
            ( accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),I2),J))
           => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J)
               => aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int))),J) )
             => aa(int,$o,aa(int,fun(int,$o),P,I2),J) ) )
       => aa(int,$o,aa(int,fun(int,$o),P,A0),A1) ) ) ).

% upto.pinduct
tff(fact_5240_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( finite_finite2(B,A3)
         => ~ ! [L2: list(B)] :
                ( sorted_wrt(A,Less,aa(list(B),list(A),map(B,A,F3),L2))
               => ( ( aa(list(B),set(B),set2(B),L2) = A3 )
                 => ( aa(list(B),nat,size_size(list(B)),L2) != finite_card(B,A3) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
tff(fact_5241_the__elem__def,axiom,
    ! [A: $tType,X7: set(A)] : ( the_elem(A,X7) = the(A,aTP_Lamp_qe(set(A),fun(A,$o),X7)) ) ).

% the_elem_def
tff(fact_5242_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),Xs: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( distinct(A,aa(list(B),list(A),map(B,A,F3),Xs))
       => distinct(B,Xs) ) ) ).

% folding_insort_key.distinct_if_distinct_map
tff(fact_5243_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B),L: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( finite_finite2(B,A3)
         => ( ( sorted_wrt(A,Less,aa(list(B),list(A),map(B,A,F3),L))
              & ( aa(list(B),set(B),set2(B),L) = A3 )
              & ( aa(list(B),nat,size_size(list(B)),L) = finite_card(B,A3) ) )
          <=> ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3) = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
tff(fact_5244_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),Xs: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Xs)),S3)
       => ( sorted_wrt(A,Less_eq,aa(list(B),list(A),map(B,A,F3),Xs))
         => ( distinct(B,Xs)
           => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),aa(list(B),set(B),set2(B),Xs)) = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
tff(fact_5245_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [F4: set(A),I5: set(A),F3: fun(A,B),I3: A] :
          ( finite_finite2(A,F4)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_qf(set(A),fun(fun(A,B),fun(A,$o)),I5),F3))),F4)
           => ( groups1027152243600224163dd_sum(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert(A,I3),bot_bot(set(A)))))
              = $ite(aa(set(A),$o,member(A,I3),I5),aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F3,I5)),aa(A,B,F3,I3)),groups1027152243600224163dd_sum(A,B,F3,I5)) ) ) ) ) ).

% sum_diff1'_aux
tff(fact_5246_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P2: fun(B,A)] : ( groups1027152243600224163dd_sum(B,A,P2,bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty'
tff(fact_5247_sum_Oinsert_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),P2: fun(A,B),I3: A] :
          ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nt(set(A),fun(fun(A,B),fun(A,$o)),I5),P2)))
         => ( groups1027152243600224163dd_sum(A,B,P2,aa(set(A),set(A),insert(A,I3),I5))
            = $ite(aa(set(A),$o,member(A,I3),I5),groups1027152243600224163dd_sum(A,B,P2,I5),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,P2,I3)),groups1027152243600224163dd_sum(A,B,P2,I5))) ) ) ) ).

% sum.insert'
tff(fact_5248_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(B,fun(B,$o))] : ( sorted8670434370408473282of_set(B,A,Less_eq) = sorted8670434370408473282of_set(B,A,Less_eq) ) ).

% linorder.sorted_key_list_of_set.cong
tff(fact_5249_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),I5: set(B)] : ( groups1027152243600224163dd_sum(B,A,G,aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_qg(fun(B,A),fun(set(B),fun(B,$o)),G),I5))) = groups1027152243600224163dd_sum(B,A,G,I5) ) ) ).

% sum.non_neutral'
tff(fact_5250_sum_Odistrib__triv_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( finite_finite2(A,I5)
         => ( groups1027152243600224163dd_sum(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qh(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),plus_plus(B),groups1027152243600224163dd_sum(A,B,G,I5)),groups1027152243600224163dd_sum(A,B,H,I5)) ) ) ) ).

% sum.distrib_triv'
tff(fact_5251_sum_Omono__neutral__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),T4: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T4)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
               => ( aa(A,B,G,X4) = zero_zero(B) ) )
           => ( groups1027152243600224163dd_sum(A,B,G,S3) = groups1027152243600224163dd_sum(A,B,G,T4) ) ) ) ) ).

% sum.mono_neutral_left'
tff(fact_5252_sum_Omono__neutral__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),T4: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T4)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
               => ( aa(A,B,G,X4) = zero_zero(B) ) )
           => ( groups1027152243600224163dd_sum(A,B,G,T4) = groups1027152243600224163dd_sum(A,B,G,S3) ) ) ) ) ).

% sum.mono_neutral_right'
tff(fact_5253_sum_Omono__neutral__cong__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),T4: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T4)
         => ( ! [I2: A] :
                ( aa(set(A),$o,member(A,I2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
               => ( aa(A,B,H,I2) = zero_zero(B) ) )
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),S3)
                 => ( aa(A,B,G,X4) = aa(A,B,H,X4) ) )
             => ( groups1027152243600224163dd_sum(A,B,G,S3) = groups1027152243600224163dd_sum(A,B,H,T4) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
tff(fact_5254_sum_Omono__neutral__cong__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),T4: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T4)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
               => ( aa(A,B,G,X4) = zero_zero(B) ) )
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),S3)
                 => ( aa(A,B,G,X4) = aa(A,B,H,X4) ) )
             => ( groups1027152243600224163dd_sum(A,B,G,T4) = groups1027152243600224163dd_sum(A,B,H,S3) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
tff(fact_5255_sum_Odistrib_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nt(set(A),fun(fun(A,B),fun(A,$o)),I5),G)))
         => ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nt(set(A),fun(fun(A,B),fun(A,$o)),I5),H)))
           => ( groups1027152243600224163dd_sum(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qh(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),plus_plus(B),groups1027152243600224163dd_sum(A,B,G,I5)),groups1027152243600224163dd_sum(A,B,H,I5)) ) ) ) ) ).

% sum.distrib'
tff(fact_5256_sum_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P2: fun(B,A),I5: set(B)] :
          ( groups1027152243600224163dd_sum(B,A,P2,I5)
          = $ite(finite_finite2(B,aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_qg(fun(B,A),fun(set(B),fun(B,$o)),P2),I5))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),P2),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_qg(fun(B,A),fun(set(B),fun(B,$o)),P2),I5))),zero_zero(A)) ) ) ).

% sum.G_def
tff(fact_5257_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B),B4: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B4),S3)
         => ( ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3) = aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),B4) )
           => ( finite_finite2(B,A3)
             => ( finite_finite2(B,B4)
               => ( A3 = B4 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
tff(fact_5258_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( finite_finite2(B,A3)
         => ( aa(list(B),set(B),set2(B),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3)) = A3 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
tff(fact_5259_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( aa(list(B),nat,size_size(list(B)),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3)) = finite_card(B,A3) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
tff(fact_5260_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => distinct(A,aa(list(B),list(A),map(B,A,F3),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3))) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
tff(fact_5261_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => sorted_wrt(A,Less_eq,aa(list(B),list(A),map(B,A,F3),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3))) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
tff(fact_5262_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => sorted_wrt(A,Less,aa(list(B),list(A),map(B,A,F3),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3))) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
tff(fact_5263_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [I5: set(A),F3: fun(A,B),I3: A] :
          ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_qf(set(A),fun(fun(A,B),fun(A,$o)),I5),F3)))
         => ( groups1027152243600224163dd_sum(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert(A,I3),bot_bot(set(A)))))
            = $ite(aa(set(A),$o,member(A,I3),I5),aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F3,I5)),aa(A,B,F3,I3)),groups1027152243600224163dd_sum(A,B,F3,I5)) ) ) ) ).

% sum_diff1'
tff(fact_5264_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),X2: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),A3)),S3)
       => ( finite_finite2(B,A3)
         => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),aa(set(B),set(B),insert(B,X2),A3)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F3),X2),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B)))))) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
tff(fact_5265_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),X2: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),A3)),S3)
       => ( finite_finite2(B,A3)
         => ( ~ aa(set(B),$o,member(B,X2),A3)
           => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),aa(set(B),set(B),insert(B,X2),A3)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F3),X2),aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
tff(fact_5266_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),X2: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X2),A3)),S3)
       => ( finite_finite2(B,A3)
         => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X2),bot_bot(set(B))))) = remove1(B,X2,aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3)) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
tff(fact_5267_in__set__remove1,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list(A)] :
      ( ( A2 != B2 )
     => ( aa(set(A),$o,member(A,A2),aa(list(A),set(A),set2(A),remove1(A,B2,Xs)))
      <=> aa(set(A),$o,member(A,A2),aa(list(A),set(A),set2(A),Xs)) ) ) ).

% in_set_remove1
tff(fact_5268_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( aa(list(A),set(A),set2(A),remove1(A,X2,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) ) ).

% set_remove1_eq
tff(fact_5269_remove1__idem,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( remove1(A,X2,Xs) = Xs ) ) ).

% remove1_idem
tff(fact_5270_notin__set__remove1,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Y2: A] :
      ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),remove1(A,Y2,Xs))) ) ).

% notin_set_remove1
tff(fact_5271_linorder_Oinsort__key_Ocong,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(B,fun(B,$o))] : ( insort_key(B,A,Less_eq) = insort_key(B,A,Less_eq) ) ).

% linorder.insort_key.cong
tff(fact_5272_remove1__commute,axiom,
    ! [A: $tType,X2: A,Y2: A,Zs: list(A)] : ( remove1(A,X2,remove1(A,Y2,Zs)) = remove1(A,Y2,remove1(A,X2,Zs)) ) ).

% remove1_commute
tff(fact_5273_distinct__remove1,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => distinct(A,remove1(A,X2,Xs)) ) ).

% distinct_remove1
tff(fact_5274_set__remove1__subset,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),remove1(A,X2,Xs))),aa(list(A),set(A),set2(A),Xs)) ).

% set_remove1_subset
tff(fact_5275_sorted__remove1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),A2: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),remove1(A,A2,Xs)) ) ) ).

% sorted_remove1
tff(fact_5276_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),X2: B] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),Xs))
         => sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),remove1(B,X2,Xs))) ) ) ).

% sorted_map_remove1
tff(fact_5277_length__remove1,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(list(A),nat,size_size(list(A)),remove1(A,X2,Xs))
      = $ite(aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_remove1
tff(fact_5278_sum__list__map__remove1,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [X2: A,Xs: list(A),F3: fun(A,B)] :
          ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
         => ( groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F3),Xs)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,X2)),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F3),remove1(A,X2,Xs)))) ) ) ) ).

% sum_list_map_remove1
tff(fact_5279_distinct__union,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( distinct(A,union(A,Xs,Ys))
    <=> distinct(A,Ys) ) ).

% distinct_union
tff(fact_5280_set__update__distinct,axiom,
    ! [A: $tType,Xs: list(A),Nb: nat,X2: A] :
      ( distinct(A,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
       => ( aa(list(A),set(A),set2(A),list_update(A,Xs,Nb,X2)) = aa(set(A),set(A),insert(A,X2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,aa(nat,A,nth(A,Xs),Nb)),bot_bot(set(A))))) ) ) ) ).

% set_update_distinct
tff(fact_5281_map__of__eq__Some__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list(product_prod(A,B)),X2: A,Y2: B] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xys))
     => ( ( aa(A,option(B),map_of(A,B,Xys),X2) = aa(B,option(B),some(B),Y2) )
      <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xys)) ) ) ).

% map_of_eq_Some_iff
tff(fact_5282_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list(A),I3: nat,X2: A,Y2: A] : ( list_update(A,list_update(A,Xs,I3,X2),I3,Y2) = list_update(A,Xs,I3,Y2) ) ).

% list_update_overwrite
tff(fact_5283_length__list__update,axiom,
    ! [A: $tType,Xs: list(A),I3: nat,X2: A] : ( aa(list(A),nat,size_size(list(A)),list_update(A,Xs,I3,X2)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_list_update
tff(fact_5284_nth__list__update__neq,axiom,
    ! [A: $tType,I3: nat,J2: nat,Xs: list(A),X2: A] :
      ( ( I3 != J2 )
     => ( aa(nat,A,nth(A,list_update(A,Xs,I3,X2)),J2) = aa(nat,A,nth(A,Xs),J2) ) ) ).

% nth_list_update_neq
tff(fact_5285_list__update__id,axiom,
    ! [A: $tType,Xs: list(A),I3: nat] : ( list_update(A,Xs,I3,aa(nat,A,nth(A,Xs),I3)) = Xs ) ).

% list_update_id
tff(fact_5286_list__update__beyond,axiom,
    ! [A: $tType,Xs: list(A),I3: nat,X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),I3)
     => ( list_update(A,Xs,I3,X2) = Xs ) ) ).

% list_update_beyond
tff(fact_5287_take__update__cancel,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,Xs: list(A),Y2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
     => ( take(A,Nb,list_update(A,Xs,Ma,Y2)) = take(A,Nb,Xs) ) ) ).

% take_update_cancel
tff(fact_5288_nth__list__update__eq,axiom,
    ! [A: $tType,I3: nat,Xs: list(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,list_update(A,Xs,I3,X2)),I3) = X2 ) ) ).

% nth_list_update_eq
tff(fact_5289_set__swap,axiom,
    ! [A: $tType,I3: nat,Xs: list(A),J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
       => ( aa(list(A),set(A),set2(A),list_update(A,list_update(A,Xs,I3,aa(nat,A,nth(A,Xs),J2)),J2,aa(nat,A,nth(A,Xs),I3))) = aa(list(A),set(A),set2(A),Xs) ) ) ) ).

% set_swap
tff(fact_5290_distinct__swap,axiom,
    ! [A: $tType,I3: nat,Xs: list(A),J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
       => ( distinct(A,list_update(A,list_update(A,Xs,I3,aa(nat,A,nth(A,Xs),J2)),J2,aa(nat,A,nth(A,Xs),I3)))
        <=> distinct(A,Xs) ) ) ) ).

% distinct_swap
tff(fact_5291_map__of__is__SomeI,axiom,
    ! [A: $tType,B: $tType,Xys: list(product_prod(A,B)),X2: A,Y2: B] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xys))
     => ( aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xys))
       => ( aa(A,option(B),map_of(A,B,Xys),X2) = aa(B,option(B),some(B),Y2) ) ) ) ).

% map_of_is_SomeI
tff(fact_5292_Some__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list(product_prod(A,B)),Y2: B,X2: A] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xys))
     => ( ( aa(B,option(B),some(B),Y2) = aa(A,option(B),map_of(A,B,Xys),X2) )
      <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xys)) ) ) ).

% Some_eq_map_of_iff
tff(fact_5293_map__update,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B),K: nat,Y2: B] : ( aa(list(B),list(A),map(B,A,F3),list_update(B,Xs,K,Y2)) = list_update(A,aa(list(B),list(A),map(B,A,F3),Xs),K,aa(B,A,F3,Y2)) ) ).

% map_update
tff(fact_5294_list__update__swap,axiom,
    ! [A: $tType,I3: nat,I6: nat,Xs: list(A),X2: A,X6: A] :
      ( ( I3 != I6 )
     => ( list_update(A,list_update(A,Xs,I3,X2),I6,X6) = list_update(A,list_update(A,Xs,I6,X6),I3,X2) ) ) ).

% list_update_swap
tff(fact_5295_take__update__swap,axiom,
    ! [A: $tType,Ma: nat,Xs: list(A),Nb: nat,X2: A] : ( take(A,Ma,list_update(A,Xs,Nb,X2)) = list_update(A,take(A,Ma,Xs),Nb,X2) ) ).

% take_update_swap
tff(fact_5296_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list(A),A3: set(A),X2: A,I3: nat] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),A3)
     => ( aa(set(A),$o,member(A,X2),A3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),list_update(A,Xs,I3,X2))),A3) ) ) ).

% set_update_subsetI
tff(fact_5297_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list(A),I3: nat,X2: A] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),list_update(A,Xs,I3,X2))),aa(set(A),set(A),insert(A,X2),aa(list(A),set(A),set2(A),Xs))) ).

% set_update_subset_insert
tff(fact_5298_set__update__memI,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),list_update(A,Xs,Nb,X2))) ) ).

% set_update_memI
tff(fact_5299_list__update__same__conv,axiom,
    ! [A: $tType,I3: nat,Xs: list(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( ( list_update(A,Xs,I3,X2) = Xs )
      <=> ( aa(nat,A,nth(A,Xs),I3) = X2 ) ) ) ).

% list_update_same_conv
tff(fact_5300_nth__list__update,axiom,
    ! [A: $tType,I3: nat,Xs: list(A),X2: A,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,list_update(A,Xs,I3,X2)),J2)
        = $ite(I3 = J2,X2,aa(nat,A,nth(A,Xs),J2)) ) ) ).

% nth_list_update
tff(fact_5301_weak__map__of__SomeI,axiom,
    ! [A: $tType,B: $tType,K: A,X2: B,L: list(product_prod(A,B))] :
      ( aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),X2)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),L))
     => ? [X4: B] : ( aa(A,option(B),map_of(A,B,L),K) = aa(B,option(B),some(B),X4) ) ) ).

% weak_map_of_SomeI
tff(fact_5302_map__of__SomeD,axiom,
    ! [A: $tType,B: $tType,Xs: list(product_prod(B,A)),K: B,Y2: A] :
      ( ( aa(B,option(A),map_of(B,A,Xs),K) = aa(A,option(A),some(A),Y2) )
     => aa(set(product_prod(B,A)),$o,member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),K),Y2)),aa(list(product_prod(B,A)),set(product_prod(B,A)),set2(product_prod(B,A)),Xs)) ) ).

% map_of_SomeD
tff(fact_5303_map__of__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(A,B)),Ys: list(product_prod(A,B))] :
      ( ( aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs)) = aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Ys)) )
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs)))
           => ( aa(A,option(B),map_of(A,B,Xs),X4) = aa(A,option(B),map_of(A,B,Ys),X4) ) )
       => ( map_of(A,B,Xs) = map_of(A,B,Ys) ) ) ) ).

% map_of_eqI
tff(fact_5304_map__of__inject__set,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(A,B)),Ys: list(product_prod(A,B))] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))
     => ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Ys))
       => ( ( map_of(A,B,Xs) = map_of(A,B,Ys) )
        <=> ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Ys) ) ) ) ) ).

% map_of_inject_set
tff(fact_5305_sum__list__update,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [K: nat,Xs: list(A),X2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
         => ( groups8242544230860333062m_list(A,list_update(A,Xs,K,X2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),groups8242544230860333062m_list(A,Xs)),X2)),aa(nat,A,nth(A,Xs),K)) ) ) ) ).

% sum_list_update
tff(fact_5306_distinct__list__update,axiom,
    ! [A: $tType,Xs: list(A),A2: A,I3: nat] :
      ( distinct(A,Xs)
     => ( ~ aa(set(A),$o,member(A,A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,aa(nat,A,nth(A,Xs),I3)),bot_bot(set(A)))))
       => distinct(A,list_update(A,Xs,I3,A2)) ) ) ).

% distinct_list_update
tff(fact_5307_set__map__of__compr,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(A,B))] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))
     => ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs) = aa(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aTP_Lamp_qi(list(product_prod(A,B)),fun(A,fun(B,$o)),Xs))) ) ) ).

% set_map_of_compr
tff(fact_5308_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),L: list(A)] :
          ( finite_finite2(A,A3)
         => ( ( sorted_wrt(A,ord_less(A),L)
              & ( aa(list(A),set(A),set2(A),L) = A3 )
              & ( aa(list(A),nat,size_size(list(A)),L) = finite_card(A,A3) ) )
          <=> ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
tff(fact_5309_card__Pow,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ( finite_card(set(A),pow2(A,A3)) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),finite_card(A,A3)) ) ) ).

% card_Pow
tff(fact_5310_size__prod__simp,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,nat),G: fun(B,nat),P2: product_prod(A,B)] : ( basic_BNF_size_prod(A,B,F3,G,P2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F3,aa(product_prod(A,B),A,product_fst(A,B),P2))),aa(B,nat,G,aa(product_prod(A,B),B,product_snd(A,B),P2)))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% size_prod_simp
tff(fact_5311_sorted__list__of__set__range,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or7035219750837199246ssThan(nat,Ma,Nb)) = upt(Ma,Nb) ) ).

% sorted_list_of_set_range
tff(fact_5312_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( finite_finite2(A,A3)
         => ( aa(list(A),set(A),set2(A),aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) = A3 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
tff(fact_5313_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : ( aa(list(A),nat,size_size(list(A)),aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) = finite_card(A,A3) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
tff(fact_5314_Pow__def,axiom,
    ! [A: $tType,A3: set(A)] : ( pow2(A,A3) = aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_ok(set(A),fun(set(A),$o),A3)) ) ).

% Pow_def
tff(fact_5315_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B4: set(A)] :
          ( ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = aa(set(A),list(A),linord4507533701916653071of_set(A),B4) )
         => ( finite_finite2(A,A3)
           => ( finite_finite2(A,B4)
             => ( A3 = B4 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
tff(fact_5316_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : distinct(A,aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
tff(fact_5317_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : sorted_wrt(A,ord_less_eq(A),aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
tff(fact_5318_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : sorted_wrt(A,ord_less(A),aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
tff(fact_5319_binomial__def,axiom,
    ! [Nb: nat,K: nat] : ( aa(nat,nat,binomial(Nb),K) = finite_card(set(nat),aa(fun(set(nat),$o),set(set(nat)),collect(set(nat)),aa(nat,fun(set(nat),$o),aTP_Lamp_qj(nat,fun(nat,fun(set(nat),$o)),Nb),K))) ) ).

% binomial_def
tff(fact_5320_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( distinct(A,Xs)
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(list(A),set(A),set2(A),Xs)) = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
tff(fact_5321_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) = remove1(A,X2,aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
tff(fact_5322_nat__descend__induct,axiom,
    ! [Nb: nat,P: fun(nat,$o),Ma: nat] :
      ( ! [K2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),K2)
         => aa(nat,$o,P,K2) )
     => ( ! [K2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),Nb)
           => ( ! [I4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K2),I4)
                 => aa(nat,$o,P,I4) )
             => aa(nat,$o,P,K2) ) )
       => aa(nat,$o,P,Ma) ) ) ).

% nat_descend_induct
tff(fact_5323_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( bit_se4197421643247451524op_bit(int,aa(num,nat,numeral_numeral(nat),L),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = bit_se4197421643247451524op_bit(int,pred_numeral(L),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K)))) ) ).

% drop_bit_numeral_minus_bit1
tff(fact_5324_finite__enumerate,axiom,
    ! [S3: set(nat)] :
      ( finite_finite2(nat,S3)
     => ? [R2: fun(nat,nat)] :
          ( strict_mono_on(nat,nat,R2,aa(nat,set(nat),set_ord_lessThan(nat),finite_card(nat,S3)))
          & ! [N8: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N8),finite_card(nat,S3))
             => aa(set(nat),$o,member(nat,aa(nat,nat,R2,N8)),S3) ) ) ) ).

% finite_enumerate
tff(fact_5325_divmod__integer__eq__cases,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            L = zero_zero(code_integer),
            aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K),
            aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),aa(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,aa(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,product_apsnd(code_integer,code_integer,code_integer)),times_times(code_integer))),sgn_sgn(code_integer)),L),$ite(aa(code_integer,code_integer,sgn_sgn(code_integer),K) = aa(code_integer,code_integer,sgn_sgn(code_integer),L),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_qk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ).

% divmod_integer_eq_cases
tff(fact_5326_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: fun(C,B),G: fun(A,C)] : ( aa(fun(list(A),list(C)),fun(list(A),list(B)),comp(list(C),list(B),list(A),map(C,B,F3)),map(A,C,G)) = map(A,B,aa(fun(A,C),fun(A,B),comp(C,B,A,F3),G)) ) ).

% map_comp_map
tff(fact_5327_List_Omap_Ocomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: fun(C,B),G: fun(A,C)] : ( aa(fun(list(A),list(C)),fun(list(A),list(B)),comp(list(C),list(B),list(A),map(C,B,F3)),map(A,C,G)) = map(A,B,aa(fun(A,C),fun(A,B),comp(C,B,A,F3),G)) ) ).

% List.map.comp
tff(fact_5328_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: fun(B,A),G: fun(C,B),Xs: list(C)] : ( aa(list(B),list(A),map(B,A,F3),aa(list(C),list(B),map(C,B,G),Xs)) = aa(list(C),list(A),map(C,A,aa(fun(C,B),fun(C,A),comp(B,A,C,F3),G)),Xs) ) ).

% map_map
tff(fact_5329_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: fun(B,A),G: fun(C,B),List: list(C)] : ( aa(list(B),list(A),map(B,A,F3),aa(list(C),list(B),map(C,B,G),List)) = aa(list(C),list(A),map(C,A,aa(fun(C,B),fun(C,A),comp(B,A,C,F3),G)),List) ) ).

% List.map.compositionality
tff(fact_5330_list_Omap__comp,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: fun(B,A),F3: fun(C,B),V: list(C)] : ( aa(list(B),list(A),map(B,A,G),aa(list(C),list(B),map(C,B,F3),V)) = aa(list(C),list(A),map(C,A,aa(fun(C,B),fun(C,A),comp(B,A,C,G),F3)),V) ) ).

% list.map_comp
tff(fact_5331_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( bit_se4197421643247451524op_bit(A,Nb,zero_zero(A)) = zero_zero(A) ) ) ).

% drop_bit_of_0
tff(fact_5332_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] : ( bit_se4197421643247451524op_bit(A,Ma,bit_se4197421643247451524op_bit(A,Nb,A2)) = bit_se4197421643247451524op_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb),A2) ) ) ).

% drop_bit_drop_bit
tff(fact_5333_drop__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( bit_se4197421643247451524op_bit(A,Nb,aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se4197421643247451524op_bit(A,Nb,A2)),bit_se4197421643247451524op_bit(A,Nb,B2)) ) ) ).

% drop_bit_and
tff(fact_5334_drop__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( bit_se4197421643247451524op_bit(A,Nb,aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),bit_se4197421643247451524op_bit(A,Nb,A2)),bit_se4197421643247451524op_bit(A,Nb,B2)) ) ) ).

% drop_bit_or
tff(fact_5335_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A,B2: A] : ( bit_se4197421643247451524op_bit(A,Nb,aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),bit_se4197421643247451524op_bit(A,Nb,A2)),bit_se4197421643247451524op_bit(A,Nb,B2)) ) ) ).

% drop_bit_xor
tff(fact_5336_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,B2: $o] :
          ( bit_se4197421643247451524op_bit(A,Nb,aa($o,A,zero_neq_one_of_bool(A),B2))
          = aa($o,A,zero_neq_one_of_bool(A),
              ( Nb = zero_zero(nat) )
            & (B2)) ) ) ).

% drop_bit_of_bool
tff(fact_5337_drop__bit__nonnegative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se4197421643247451524op_bit(int,Nb,K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% drop_bit_nonnegative_int_iff
tff(fact_5338_drop__bit__negative__int__iff,axiom,
    ! [Nb: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se4197421643247451524op_bit(int,Nb,K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% drop_bit_negative_int_iff
tff(fact_5339_drop__bit__minus__one,axiom,
    ! [Nb: nat] : ( bit_se4197421643247451524op_bit(int,Nb,aa(int,int,uminus_uminus(int),one_one(int))) = aa(int,int,uminus_uminus(int),one_one(int)) ) ).

% drop_bit_minus_one
tff(fact_5340_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,K: num] : ( bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,Nb),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = bit_se4197421643247451524op_bit(A,Nb,aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_Suc_bit0
tff(fact_5341_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,K: num] : ( bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,Nb),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = bit_se4197421643247451524op_bit(A,Nb,aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_Suc_bit1
tff(fact_5342_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat] : ( bit_se4197421643247451524op_bit(A,Nb,one_one(A)) = aa($o,A,zero_neq_one_of_bool(A),( Nb = zero_zero(nat) )) ) ) ).

% drop_bit_of_1
tff(fact_5343_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( bit_se4197421643247451524op_bit(A,aa(num,nat,numeral_numeral(nat),L),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = bit_se4197421643247451524op_bit(A,pred_numeral(L),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_numeral_bit0
tff(fact_5344_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( bit_se4197421643247451524op_bit(A,aa(num,nat,numeral_numeral(nat),L),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = bit_se4197421643247451524op_bit(A,pred_numeral(L),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_numeral_bit1
tff(fact_5345_drop__bit__Suc__minus__bit0,axiom,
    ! [Nb: nat,K: num] : ( bit_se4197421643247451524op_bit(int,aa(nat,nat,suc,Nb),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = bit_se4197421643247451524op_bit(int,Nb,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) ) ).

% drop_bit_Suc_minus_bit0
tff(fact_5346_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( bit_se4197421643247451524op_bit(int,aa(num,nat,numeral_numeral(nat),L),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = bit_se4197421643247451524op_bit(int,pred_numeral(L),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) ) ).

% drop_bit_numeral_minus_bit0
tff(fact_5347_drop__bit__Suc__minus__bit1,axiom,
    ! [Nb: nat,K: num] : ( bit_se4197421643247451524op_bit(int,aa(nat,nat,suc,Nb),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = bit_se4197421643247451524op_bit(int,Nb,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K)))) ) ).

% drop_bit_Suc_minus_bit1
tff(fact_5348_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: nat,Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),bit_se4197421643247451524op_bit(nat,Ma,Nb)) = bit_se4197421643247451524op_bit(A,Ma,aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% of_nat_drop_bit
tff(fact_5349_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,Ma: nat] : ( bit_se4197421643247451524op_bit(A,Nb,aa(nat,A,semiring_1_of_nat(A),Ma)) = aa(nat,A,semiring_1_of_nat(A),bit_se4197421643247451524op_bit(nat,Nb,Ma)) ) ) ).

% drop_bit_of_nat
tff(fact_5350_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2) = A2 )
        <=> ( bit_se4197421643247451524op_bit(A,Nb,A2) = zero_zero(A) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
tff(fact_5351_drop__bit__push__bit__int,axiom,
    ! [Ma: nat,Nb: nat,K: int] : ( bit_se4197421643247451524op_bit(int,Ma,bit_se4730199178511100633sh_bit(int,Nb,K)) = bit_se4197421643247451524op_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb),bit_se4730199178511100633sh_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma),K)) ) ).

% drop_bit_push_bit_int
tff(fact_5352_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),bit_se4197421643247451524op_bit(A,Nb,A2)) = bit_se4197421643247451524op_bit(A,Nb,aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)),A2)) ) ) ).

% take_bit_drop_bit
tff(fact_5353_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] : ( bit_se4197421643247451524op_bit(A,Ma,aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma)),bit_se4197421643247451524op_bit(A,Ma,A2)) ) ) ).

% drop_bit_take_bit
tff(fact_5354_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add(B)
        & comm_monoid_add(A) )
     => ! [H: fun(B,A),G: fun(C,B),A3: set(C)] :
          ( ( aa(B,A,H,zero_zero(B)) = zero_zero(A) )
         => ( ! [X4: B,Y4: B] : ( aa(B,A,H,aa(B,B,aa(B,fun(B,B),plus_plus(B),X4),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,H,X4)),aa(B,A,H,Y4)) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(C,B),fun(C,A),comp(B,A,C,H),G)),A3) = aa(B,A,H,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),A3)) ) ) ) ) ).

% sum_comp_morphism
tff(fact_5355_uminus__sum__list__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(B,A),Xs: list(B)] : ( aa(A,A,uminus_uminus(A),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F3),Xs))) = groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),comp(A,A,B,uminus_uminus(A)),F3)),Xs)) ) ) ).

% uminus_sum_list_map
tff(fact_5356_case__prod__comp,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F3: fun(D,fun(C,A)),G: fun(B,D),X2: product_prod(B,C)] : ( aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),aa(fun(B,D),fun(B,fun(C,A)),comp(D,fun(C,A),B,F3),G)),X2) = aa(C,A,aa(D,fun(C,A),F3,aa(B,D,G,aa(product_prod(B,C),B,product_fst(B,C),X2))),aa(product_prod(B,C),C,product_snd(B,C),X2)) ) ).

% case_prod_comp
tff(fact_5357_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Nb: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),bit_se4730199178511100633sh_bit(A,Nb,one_one(A))) = bit_se4197421643247451524op_bit(A,Nb,A2) ) ) ).

% div_push_bit_of_1_eq_drop_bit
tff(fact_5358_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se4197421643247451524op_bit(A,Nb,A2)),one_one(A)) = one_one(A) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
tff(fact_5359_bits__ident,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),bit_se4730199178511100633sh_bit(A,Nb,bit_se4197421643247451524op_bit(A,Nb,A2))),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)) = A2 ) ) ).

% bits_ident
tff(fact_5360_drop__bit__half,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se4197421643247451524op_bit(A,Nb,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),bit_se4197421643247451524op_bit(A,Nb,A2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% drop_bit_half
tff(fact_5361_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Nb: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 )
         => ( bit_se4197421643247451524op_bit(A,Nb,A2) = A2 ) ) ) ).

% stable_imp_drop_bit_eq
tff(fact_5362_drop__bit__int__def,axiom,
    ! [Nb: nat,K: int] : ( bit_se4197421643247451524op_bit(int,Nb,K) = aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Nb)) ) ).

% drop_bit_int_def
tff(fact_5363_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se4197421643247451524op_bit(A,Nb,A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) ) ) ).

% drop_bit_eq_div
tff(fact_5364_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,Nb),A2) = bit_se4197421643247451524op_bit(A,Nb,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% drop_bit_Suc
tff(fact_5365_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Nb: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb)
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se4197421643247451524op_bit(A,Nb,A2)) ) ) ).

% bit_iff_odd_drop_bit
tff(fact_5366_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se4197421643247451524op_bit(A,Nb,A2))
        <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Nb) ) ) ).

% even_drop_bit_iff_not_bit
tff(fact_5367_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: nat,Ma: nat,A2: A] : ( bit_se4730199178511100633sh_bit(A,Nb,aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),bit_se4197421643247451524op_bit(A,Nb,A2))) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Nb)))) ) ) ).

% slice_eq_mask
tff(fact_5368_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] :
          ( bit_se4197421643247451524op_bit(A,Nb,A2)
          = $ite(Nb = zero_zero(nat),A2,bit_se4197421643247451524op_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% drop_bit_rec
tff(fact_5369_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( strict_mono_on(A,B,F3,A3)
        <=> ! [R5: A,S5: A] :
              ( ( aa(set(A),$o,member(A,R5),A3)
                & aa(set(A),$o,member(A,S5),A3)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),R5),S5) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,R5)),aa(A,B,F3,S5)) ) ) ) ).

% strict_mono_on_def
tff(fact_5370_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [R2: A,S2: A] :
              ( aa(set(A),$o,member(A,R2),A3)
             => ( aa(set(A),$o,member(A,S2),A3)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),R2),S2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,R2)),aa(A,B,F3,S2)) ) ) )
         => strict_mono_on(A,B,F3,A3) ) ) ).

% strict_mono_onI
tff(fact_5371_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [F3: fun(A,B),A3: set(A),R: A,S: A] :
          ( strict_mono_on(A,B,F3,A3)
         => ( aa(set(A),$o,member(A,R),A3)
           => ( aa(set(A),$o,member(A,S),A3)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),R),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,R)),aa(A,B,F3,S)) ) ) ) ) ) ).

% strict_mono_onD
tff(fact_5372_size__list__map,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,nat),G: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_list(A,F3),aa(list(B),list(A),map(B,A,G),Xs)) = aa(list(B),nat,size_list(B,aa(fun(B,A),fun(B,nat),comp(A,nat,B,F3),G)),Xs) ) ).

% size_list_map
tff(fact_5373_drop__bit__of__Suc__0,axiom,
    ! [Nb: nat] : ( bit_se4197421643247451524op_bit(nat,Nb,aa(nat,nat,suc,zero_zero(nat))) = aa($o,nat,zero_neq_one_of_bool(nat),( Nb = zero_zero(nat) )) ) ).

% drop_bit_of_Suc_0
tff(fact_5374_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,nat),G: fun(A,B)] : ( aa(fun(list(A),list(B)),fun(list(A),nat),comp(list(B),nat,list(A),size_list(B,F3)),map(A,B,G)) = size_list(A,aa(fun(A,B),fun(A,nat),comp(B,nat,A,F3),G)) ) ).

% list.size_gen_o_map
tff(fact_5375_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(A,A)),fun(product_prod(A,B),A),comp(product_prod(A,A),A,product_prod(A,B),product_snd(A,A)),aa(fun(product_prod(A,B),A),fun(product_prod(A,B),product_prod(A,A)),comp(A,product_prod(A,A),product_prod(A,B),aTP_Lamp_ql(A,product_prod(A,A))),product_fst(A,B))) = product_fst(A,B) ) ).

% snd_diag_fst
tff(fact_5376_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(B,B)),fun(product_prod(A,B),B),comp(product_prod(B,B),B,product_prod(A,B),product_fst(B,B)),aa(fun(product_prod(A,B),B),fun(product_prod(A,B),product_prod(B,B)),comp(B,product_prod(B,B),product_prod(A,B),aTP_Lamp_qm(B,product_prod(B,B))),product_snd(A,B))) = product_snd(A,B) ) ).

% fst_diag_snd
tff(fact_5377_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(B,B)),fun(product_prod(A,B),B),comp(product_prod(B,B),B,product_prod(A,B),product_snd(B,B)),aa(fun(product_prod(A,B),B),fun(product_prod(A,B),product_prod(B,B)),comp(B,product_prod(B,B),product_prod(A,B),aTP_Lamp_qm(B,product_prod(B,B))),product_snd(A,B))) = product_snd(A,B) ) ).

% snd_diag_snd
tff(fact_5378_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(A,A)),fun(product_prod(A,B),A),comp(product_prod(A,A),A,product_prod(A,B),product_fst(A,A)),aa(fun(product_prod(A,B),A),fun(product_prod(A,B),product_prod(A,A)),comp(A,product_prod(A,A),product_prod(A,B),aTP_Lamp_ql(A,product_prod(A,A))),product_fst(A,B))) = product_fst(A,B) ) ).

% fst_diag_fst
tff(fact_5379_card_Ocomp__fun__commute__on,axiom,
    aa(fun(nat,nat),fun(nat,nat),comp(nat,nat,nat,suc),suc) = aa(fun(nat,nat),fun(nat,nat),comp(nat,nat,nat,suc),suc) ).

% card.comp_fun_commute_on
tff(fact_5380_drop__bit__nat__eq,axiom,
    ! [Nb: nat,K: int] : ( bit_se4197421643247451524op_bit(nat,Nb,aa(int,nat,nat2,K)) = aa(int,nat,nat2,bit_se4197421643247451524op_bit(int,Nb,K)) ) ).

% drop_bit_nat_eq
tff(fact_5381_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),X2: B,Y2: B] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,member(B,X2),S3)
       => ( aa(set(B),$o,member(B,Y2),S3)
         => ( aa(fun(list(B),list(B)),fun(list(B),list(B)),comp(list(B),list(B),list(B),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F3),Y2)),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F3),X2)) = aa(fun(list(B),list(B)),fun(list(B),list(B)),comp(list(B),list(B),list(B),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F3),X2)),aa(B,fun(list(B),list(B)),aa(fun(B,A),fun(B,fun(list(B),list(B))),insort_key(A,B,Less_eq),F3),Y2)) ) ) ) ) ).

% folding_insort_key.insort_key_commute
tff(fact_5382_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
tff(fact_5383_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
tff(fact_5384_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,K: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% sum.atLeastAtMost_shift_bounds
tff(fact_5385_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,K: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% sum.atLeastLessThan_shift_bounds
tff(fact_5386_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
tff(fact_5387_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
tff(fact_5388_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,K: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K))) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K)),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% prod.atLeastAtMost_shift_bounds
tff(fact_5389_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,K: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K))) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K)),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% prod.atLeastLessThan_shift_bounds
tff(fact_5390_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Nb: nat,A2: A] : ( bit_se5641148757651400278ts_bit(A,bit_se4197421643247451524op_bit(A,Nb,A2)) = aa(fun(nat,nat),fun(nat,$o),comp(nat,$o,nat,bit_se5641148757651400278ts_bit(A,A2)),aa(nat,fun(nat,nat),plus_plus(nat),Nb)) ) ) ).

% bit_drop_bit_eq
tff(fact_5391_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),comp(A,A,nat,inverse_inverse(A)),F3))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_qn(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) ) ) ).

% summable_inverse_divide
tff(fact_5392_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))) ) ) ).

% sum.atLeast0_atMost_Suc_shift
tff(fact_5393_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
tff(fact_5394_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))) ) ) ).

% prod.atLeast0_atMost_Suc_shift
tff(fact_5395_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
tff(fact_5396_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),Ma))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma))) ) ) ).

% sum.atLeastLessThan_shift_0
tff(fact_5397_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,Nb)) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),Ma)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma))) ) ) ).

% prod.atLeastLessThan_shift_0
tff(fact_5398_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ls(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% sum.atLeast_atMost_pred_shift
tff(fact_5399_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ls(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% sum.atLeast_lessThan_pred_shift
tff(fact_5400_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ls(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb)) ) ) ).

% prod.atLeast_atMost_pred_shift
tff(fact_5401_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Ma: nat,Nb: nat] : ( groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ls(nat,nat)),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,Ma),aa(nat,nat,suc,Nb))) = groups7121269368397514597t_prod(nat,A,G,set_or7035219750837199246ssThan(nat,Ma,Nb)) ) ) ).

% prod.atLeast_lessThan_pred_shift
tff(fact_5402_drop__bit__nat__def,axiom,
    ! [Nb: nat,Ma: nat] : ( bit_se4197421643247451524op_bit(nat,Nb,Ma) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)) ) ).

% drop_bit_nat_def
tff(fact_5403_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),Ma))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma))) ) ) ) ).

% sum.atLeastAtMost_shift_0
tff(fact_5404_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb)) = groups7121269368397514597t_prod(nat,A,aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),Ma)),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma))) ) ) ) ).

% prod.atLeastAtMost_shift_0
tff(fact_5405_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType,Xy: product_prod(A,B)] : ( aa(product_prod(A,B),A,product_fst(A,B),Xy) = aa(product_prod(A,B),A,aa(fun(product_prod(A,B),product_prod(B,A)),fun(product_prod(A,B),A),comp(product_prod(B,A),A,product_prod(A,B),product_snd(B,A)),aa(fun(A,fun(B,product_prod(B,A))),fun(product_prod(A,B),product_prod(B,A)),product_case_prod(A,B,product_prod(B,A)),aTP_Lamp_qo(A,fun(B,product_prod(B,A))))),Xy) ) ).

% fst_snd_flip
tff(fact_5406_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType,Xy: product_prod(B,A)] : ( aa(product_prod(B,A),A,product_snd(B,A),Xy) = aa(product_prod(B,A),A,aa(fun(product_prod(B,A),product_prod(A,B)),fun(product_prod(B,A),A),comp(product_prod(A,B),A,product_prod(B,A),product_fst(A,B)),aa(fun(B,fun(A,product_prod(A,B))),fun(product_prod(B,A),product_prod(A,B)),product_case_prod(B,A,product_prod(A,B)),aTP_Lamp_qp(B,fun(A,product_prod(A,B))))),Xy) ) ).

% snd_fst_flip
tff(fact_5407_Code__Target__Int_Onegative__def,axiom,
    code_Target_negative = aa(fun(num,int),fun(num,int),comp(int,int,num,uminus_uminus(int)),numeral_numeral(int)) ).

% Code_Target_Int.negative_def
tff(fact_5408_nth__rotate1,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,rotate1(A,Xs)),Nb) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,aa(nat,nat,suc,Nb),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% nth_rotate1
tff(fact_5409_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [Nb: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),aa(nat,nat,suc,I3)))
     => ( aa(nat,nat,nth(nat,aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or5935395276787703475ssThan(nat,I3,J2))),Nb) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),Nb)) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
tff(fact_5410_xor__minus__numerals_I1_J,axiom,
    ! [Nb: num,K: int] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))),K) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),neg_numeral_sub(int,Nb,one2)),K)) ) ).

% xor_minus_numerals(1)
tff(fact_5411_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I3: A,L: A,U: A] :
          ( aa(set(A),$o,member(A,I3),set_or5935395276787703475ssThan(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),I3)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),I3),U) ) ) ) ).

% greaterThanLessThan_iff
tff(fact_5412_set__rotate1,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),rotate1(A,Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% set_rotate1
tff(fact_5413_length__rotate1,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),rotate1(A,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_rotate1
tff(fact_5414_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,rotate1(A,Xs))
    <=> distinct(A,Xs) ) ).

% distinct1_rotate
tff(fact_5415_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ finite_finite2(A,set_or5935395276787703475ssThan(A,A2,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% infinite_Ioo_iff
tff(fact_5416_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_sub(A,one2,one2) = zero_zero(A) ) ) ).

% sub_num_simps(1)
tff(fact_5417_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = neg_numeral_sub(A,Ma,Nb) ) ) ).

% diff_numeral_simps(1)
tff(fact_5418_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit0,K),aa(num,num,bit0,L)) = neg_numeral_dbl(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(6)
tff(fact_5419_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),aa(num,num,bit1,L)) = neg_numeral_dbl(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(9)
tff(fact_5420_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = neg_numeral_sub(A,Ma,Nb) ) ) ).

% add_neg_numeral_simps(1)
tff(fact_5421_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(num,A,numeral_numeral(A),Nb)) = neg_numeral_sub(A,Nb,Ma) ) ) ).

% add_neg_numeral_simps(2)
tff(fact_5422_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),neg_numeral_sub(A,V,W)),Y2) ) ) ).

% semiring_norm(166)
tff(fact_5423_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),W)),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),neg_numeral_sub(A,W,V)),Y2) ) ) ).

% semiring_norm(167)
tff(fact_5424_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = neg_numeral_sub(A,Nb,Ma) ) ) ).

% diff_numeral_simps(4)
tff(fact_5425_rotate1__length01,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
     => ( rotate1(A,Xs) = Xs ) ) ).

% rotate1_length01
tff(fact_5426_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit0,K),aa(num,num,bit1,L)) = neg_numeral_dbl_dec(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(7)
tff(fact_5427_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),aa(num,num,bit0,L)) = neg_numeral_dbl_inc(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(8)
tff(fact_5428_card__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] : ( finite_card(nat,set_or5935395276787703475ssThan(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),U),aa(nat,nat,suc,L)) ) ).

% card_greaterThanLessThan
tff(fact_5429_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(num,A,numeral_numeral(A),Nb)) = neg_numeral_sub(A,one2,Nb) ) ) ).

% diff_numeral_special(1)
tff(fact_5430_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),Ma)),one_one(A)) = neg_numeral_sub(A,Ma,one2) ) ) ).

% diff_numeral_special(2)
tff(fact_5431_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),one2) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,K)) ) ) ).

% sub_num_simps(5)
tff(fact_5432_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = neg_numeral_sub(A,Nb,one2) ) ) ).

% not_minus_numeral_eq
tff(fact_5433_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_sub(A,aa(num,num,bit0,K),one2) = aa(num,A,numeral_numeral(A),bitM(K)) ) ) ).

% sub_num_simps(4)
tff(fact_5434_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))) = neg_numeral_sub(A,one2,Ma) ) ) ).

% add_neg_numeral_special(1)
tff(fact_5435_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),one_one(A)) = neg_numeral_sub(A,one2,Ma) ) ) ).

% add_neg_numeral_special(2)
tff(fact_5436_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Ma)),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,Ma,one2) ) ) ).

% add_neg_numeral_special(3)
tff(fact_5437_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),Nb)) = neg_numeral_sub(A,Nb,one2) ) ) ).

% add_neg_numeral_special(4)
tff(fact_5438_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma))),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,one2,Ma) ) ) ).

% diff_numeral_special(8)
tff(fact_5439_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Nb: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb))) = neg_numeral_sub(A,Nb,one2) ) ) ).

% diff_numeral_special(7)
tff(fact_5440_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Ma: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),neg_numeral_sub(A,Ma,one2))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Ma)) ) ) ).

% minus_sub_one_diff_one
tff(fact_5441_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [L: num] : ( neg_numeral_sub(A,one2,aa(num,num,bit1,L)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,L))) ) ) ).

% sub_num_simps(3)
tff(fact_5442_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [L: num] : ( neg_numeral_sub(A,one2,aa(num,num,bit0,L)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bitM(L))) ) ) ).

% sub_num_simps(2)
tff(fact_5443_xor__minus__numerals_I2_J,axiom,
    ! [K: int,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),neg_numeral_sub(int,Nb,one2))) ) ).

% xor_minus_numerals(2)
tff(fact_5444_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] : ( rotate1(A,aa(list(B),list(A),map(B,A,F3),Xs)) = aa(list(B),list(A),map(B,A,F3),rotate1(B,Xs)) ) ).

% rotate1_map
tff(fact_5445_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ finite_finite2(A,set_or5935395276787703475ssThan(A,A2,B2)) ) ) ).

% infinite_Ioo
tff(fact_5446_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,L),U) = set_or5935395276787703475ssThan(nat,L,U) ) ).

% atLeastSucLessThan_greaterThanLessThan
tff(fact_5447_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,K,L) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),L)) ) ) ).

% neg_numeral_class.sub_def
tff(fact_5448_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or5935395276787703475ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
tff(fact_5449_sub__non__positive,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num,Ma: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),neg_numeral_sub(A,Nb,Ma)),zero_zero(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Nb),Ma) ) ) ).

% sub_non_positive
tff(fact_5450_sub__non__negative,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num,Ma: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),neg_numeral_sub(A,Nb,Ma))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Ma),Nb) ) ) ).

% sub_non_negative
tff(fact_5451_sub__negative,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num,Ma: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),neg_numeral_sub(A,Nb,Ma)),zero_zero(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Nb),Ma) ) ) ).

% sub_negative
tff(fact_5452_sub__positive,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Nb: num,Ma: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),neg_numeral_sub(A,Nb,Ma))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Ma),Nb) ) ) ).

% sub_positive
tff(fact_5453_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Nb: num] : ( neg_numeral_sub(A,inc(Nb),one2) = aa(num,A,numeral_numeral(A),Nb) ) ) ).

% sub_inc_One_eq
tff(fact_5454_greaterThanLessThan__upt,axiom,
    ! [Nb: nat,Ma: nat] : ( set_or5935395276787703475ssThan(nat,Nb,Ma) = aa(list(nat),set(nat),set2(nat),upt(aa(nat,nat,suc,Nb),Ma)) ) ).

% greaterThanLessThan_upt
tff(fact_5455_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
tff(fact_5456_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
tff(fact_5457_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Nb: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Nb)) = aa(A,A,bit_ri4277139882892585799ns_not(A),neg_numeral_sub(A,Nb,one2)) ) ) ).

% minus_numeral_eq_not_sub_one
tff(fact_5458_sub__BitM__One__eq,axiom,
    ! [Nb: num] : ( neg_numeral_sub(int,bitM(Nb),one2) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),neg_numeral_sub(int,Nb,one2)) ) ).

% sub_BitM_One_eq
tff(fact_5459_div__add__self2__no__field,axiom,
    ! [A: $tType,B: $tType] :
      ( ( euclid4440199948858584721cancel(B)
        & field(A) )
     => ! [X2: A,B2: B,A2: B] :
          ( nO_MATCH(A,B,X2,B2)
         => ( ( B2 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2)),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A2),B2)),one_one(B)) ) ) ) ) ).

% div_add_self2_no_field
tff(fact_5460_div__add__self1__no__field,axiom,
    ! [A: $tType,B: $tType] :
      ( ( euclid4440199948858584721cancel(B)
        & field(A) )
     => ! [X2: A,B2: B,A2: B] :
          ( nO_MATCH(A,B,X2,B2)
         => ( ( B2 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),B2),A2)),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A2),B2)),one_one(B)) ) ) ) ) ).

% div_add_self1_no_field
tff(fact_5461_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( ? [K8: real] :
            ! [X4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X4))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X4)),K8))
         => real_V4916620083959148203axioms(A,B,F3) ) ) ).

% bounded_linear_axioms.intro
tff(fact_5462_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: A,Y2: A,A2: real] :
          ( nO_MATCH(A,real,aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2),A2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y2)) ) ) ) ).

% scale_right_distrib_NO_MATCH
tff(fact_5463_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: A,Y2: A,A2: real] :
          ( nO_MATCH(A,real,aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2),A2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y2)) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
tff(fact_5464_distrib__left__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring(B)
     => ! [X2: A,Y2: A,A2: B,B2: B,C2: B] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2),A2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A2),aa(B,B,aa(B,fun(B,B),plus_plus(B),B2),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),B2)),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)) ) ) ) ).

% distrib_left_NO_MATCH
tff(fact_5465_distrib__right__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring(B)
     => ! [X2: A,Y2: A,C2: B,A2: B,B2: B] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2),C2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),B2),C2)) ) ) ) ).

% distrib_right_NO_MATCH
tff(fact_5466_left__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( ring(B)
     => ! [X2: A,Y2: A,C2: B,A2: B,B2: B] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2),C2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A2),B2)),C2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),B2),C2)) ) ) ) ).

% left_diff_distrib_NO_MATCH
tff(fact_5467_right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( ring(B)
     => ! [X2: A,Y2: A,A2: B,B2: B,C2: B] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2),A2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A2),aa(B,B,aa(B,fun(B,B),minus_minus(B),B2),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),B2)),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)) ) ) ) ).

% right_diff_distrib_NO_MATCH
tff(fact_5468_power__minus_H,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: A,Nb: nat] :
          ( nO_MATCH(A,A,one_one(A),X2)
         => ( aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),X2)),Nb) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Nb)),aa(nat,A,power_power(A,X2),Nb)) ) ) ) ).

% power_minus'
tff(fact_5469_scale__left__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: A,Y2: A,C2: B,A2: real,B2: real] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2),C2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),X2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X2)) ) ) ) ).

% scale_left_distrib_NO_MATCH
tff(fact_5470_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X2: A,Y2: A,C2: B,A2: real,B2: real] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),Y2),C2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)),X2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X2)) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
tff(fact_5471_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V4916620083959148203axioms(A,B,F3)
        <=> ? [K6: real] :
            ! [X3: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X3))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X3)),K6)) ) ) ).

% bounded_linear_axioms_def
tff(fact_5472_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F3: fun(B,A),A2: A,Xs: list(B)] : ( groups4207007520872428315er_sum(B,A,F3,A2,Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_qq(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F3),A2),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum_funpow
tff(fact_5473_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),X2),aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
tff(fact_5474_max__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,ord_max(nat),zero_zero(nat),aTP_Lamp_am(nat,fun(nat,$o)),aTP_Lamp_hl(nat,fun(nat,$o))) ).

% max_nat.semilattice_neutr_order_axioms
tff(fact_5475_Suc__funpow,axiom,
    ! [Nb: nat] : ( aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),compow(fun(nat,nat)),Nb),suc) = aa(nat,fun(nat,nat),plus_plus(nat),Nb) ) ).

% Suc_funpow
tff(fact_5476_funpow__0,axiom,
    ! [A: $tType,F3: fun(A,A),X2: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),zero_zero(nat)),F3),X2) = X2 ) ).

% funpow_0
tff(fact_5477_remove1__insort__key,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X2: A,F3: fun(A,B),Xs: list(A)] : ( remove1(A,X2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),X2),Xs)) = Xs ) ) ).

% remove1_insort_key
tff(fact_5478_length__insort,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),X2: A,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),X2),Xs)) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% length_insort
tff(fact_5479_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( finite_finite2(A,A3)
         => ( ~ aa(set(A),$o,member(A,X2),A3)
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),insert(A,X2),A3)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),X2),aa(set(A),list(A),linord4507533701916653071of_set(A),A3)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
tff(fact_5480_comp__funpow,axiom,
    ! [A: $tType,B: $tType,Nb: nat,F3: fun(B,B)] : ( aa(fun(fun(A,B),fun(A,B)),fun(fun(A,B),fun(A,B)),aa(nat,fun(fun(fun(A,B),fun(A,B)),fun(fun(A,B),fun(A,B))),compow(fun(fun(A,B),fun(A,B))),Nb),comp(B,B,A,F3)) = comp(B,B,A,aa(fun(B,B),fun(B,B),aa(nat,fun(fun(B,B),fun(B,B)),compow(fun(B,B)),Nb),F3)) ) ).

% comp_funpow
tff(fact_5481_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,Nb: nat,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,Nb)),F3) = aa(fun(A,A),fun(A,A),comp(A,A,A,F3),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3)) ) ).

% funpow.simps(2)
tff(fact_5482_funpow__Suc__right,axiom,
    ! [A: $tType,Nb: nat,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,Nb)),F3) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3)),F3) ) ).

% funpow_Suc_right
tff(fact_5483_funpow__add,axiom,
    ! [A: $tType,Ma: nat,Nb: nat,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)),F3) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Ma),F3)),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3)) ) ).

% funpow_add
tff(fact_5484_funpow__mod__eq,axiom,
    ! [A: $tType,Nb: nat,F3: fun(A,A),X2: A,Ma: nat] :
      ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),X2) = X2 )
     => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),modulo_modulo(nat,Ma,Nb)),F3),X2) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Ma),F3),X2) ) ) ).

% funpow_mod_eq
tff(fact_5485_bij__betw__funpow,axiom,
    ! [A: $tType,F3: fun(A,A),S3: set(A),Nb: nat] :
      ( bij_betw(A,A,F3,S3,S3)
     => bij_betw(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),S3,S3) ) ).

% bij_betw_funpow
tff(fact_5486_insort__left__comm,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A,Xs: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),Y2),Xs)) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),Y2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),X2),Xs)) ) ) ).

% insort_left_comm
tff(fact_5487_funpow__swap1,axiom,
    ! [A: $tType,F3: fun(A,A),Nb: nat,X2: A] : ( aa(A,A,F3,aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),X2)) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),aa(A,A,F3,X2)) ) ).

% funpow_swap1
tff(fact_5488_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),X2: B,Y2: B,Xs: list(B)] :
          ( ( aa(B,A,F3,X2) != aa(B,A,F3,Y2) )
         => ( aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F3),Y2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F3),X2),Xs)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F3),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F3),Y2),Xs)) ) ) ) ).

% insort_key_left_comm
tff(fact_5489_funpow__mult,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Ma),F3)) = aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)),F3) ) ).

% funpow_mult
tff(fact_5490_funpow__times__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [F3: fun(A,nat),X2: A] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(A,nat,F3,X2)),aa(A,fun(A,A),times_times(A),X2)) = aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,X2),aa(A,nat,F3,X2))) ) ) ).

% funpow_times_power
tff(fact_5491_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y2: A,X2: A] : ( aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),Y2)),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),X2)) = aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),X2)),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),Y2)) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
tff(fact_5492_set__insort__key,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),X2: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),X2),Xs)) = aa(set(A),set(A),insert(A,X2),aa(list(A),set(A),set2(A),Xs)) ) ) ).

% set_insort_key
tff(fact_5493_distinct__insort,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),X2: A,Xs: list(A)] :
          ( distinct(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),X2),Xs))
        <=> ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
            & distinct(A,Xs) ) ) ) ).

% distinct_insort
tff(fact_5494_sorted__insort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),X2),Xs))
        <=> sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% sorted_insort
tff(fact_5495_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),X2: B,Xs: list(B)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F3),X2),Xs)))
        <=> sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),Xs)) ) ) ).

% sorted_insort_key
tff(fact_5496_of__nat__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: nat] : ( aa(nat,A,semiring_1_of_nat(A),Nb) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% of_nat_def
tff(fact_5497_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),K)),A2) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(num,nat,numeral_numeral(nat),K)),aa(A,fun(A,A),plus_plus(A),one_one(A))),A2) ) ) ).

% numeral_add_unfold_funpow
tff(fact_5498_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),K) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(num,nat,numeral_numeral(nat),K)),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% numeral_unfold_funpow
tff(fact_5499_insort__remove1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,Xs: list(A)] :
          ( aa(set(A),$o,member(A,A2),aa(list(A),set(A),set2(A),Xs))
         => ( sorted_wrt(A,ord_less_eq(A),Xs)
           => ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),A2),remove1(A,A2,Xs)) = Xs ) ) ) ) ).

% insort_remove1
tff(fact_5500_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,gcd_gcd(nat),zero_zero(nat),dvd_dvd(nat),aTP_Lamp_qs(nat,fun(nat,$o))) ).

% gcd_nat.semilattice_neutr_order_axioms
tff(fact_5501_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),$o,member(A,X2),A3)
           => ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),X2),aa(set(A),list(A),linord4507533701916653071of_set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
tff(fact_5502_relpowp__bot,axiom,
    ! [A: $tType,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),bot_bot(fun(A,fun(A,$o)))) = bot_bot(fun(A,fun(A,$o))) ) ) ).

% relpowp_bot
tff(fact_5503_relpowp__fun__conv,axiom,
    ! [A: $tType,Nb: nat,P: fun(A,fun(A,$o)),X2: A,Y2: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),P),X2),Y2)
    <=> ? [F6: fun(nat,A)] :
          ( ( aa(nat,A,F6,zero_zero(nat)) = X2 )
          & ( aa(nat,A,F6,Nb) = Y2 )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Nb)
             => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,F6,I)),aa(nat,A,F6,aa(nat,nat,suc,I))) ) ) ) ).

% relpowp_fun_conv
tff(fact_5504_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] : ( funpow(A) = compow(fun(A,A)) ) ).

% Nat.funpow_code_def
tff(fact_5505_relpowp__Suc__I2,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),X2: A,Y2: A,Nb: nat,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),P,X2),Y2)
     => ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),P),Y2),Z)
       => aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Nb)),P),X2),Z) ) ) ).

% relpowp_Suc_I2
tff(fact_5506_relpowp__Suc__E2,axiom,
    ! [A: $tType,Nb: nat,P: fun(A,fun(A,$o)),X2: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Nb)),P),X2),Z)
     => ~ ! [Y4: A] :
            ( aa(A,$o,aa(A,fun(A,$o),P,X2),Y4)
           => ~ aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),P),Y4),Z) ) ) ).

% relpowp_Suc_E2
tff(fact_5507_relpowp__Suc__D2,axiom,
    ! [A: $tType,Nb: nat,P: fun(A,fun(A,$o)),X2: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Nb)),P),X2),Z)
     => ? [Y4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),P,X2),Y4)
          & aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),P),Y4),Z) ) ) ).

% relpowp_Suc_D2
tff(fact_5508_relpowp__Suc__I,axiom,
    ! [A: $tType,Nb: nat,P: fun(A,fun(A,$o)),X2: A,Y2: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),P),X2),Y2)
     => ( aa(A,$o,aa(A,fun(A,$o),P,Y2),Z)
       => aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Nb)),P),X2),Z) ) ) ).

% relpowp_Suc_I
tff(fact_5509_relpowp__Suc__E,axiom,
    ! [A: $tType,Nb: nat,P: fun(A,fun(A,$o)),X2: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Nb)),P),X2),Z)
     => ~ ! [Y4: A] :
            ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),P),X2),Y4)
           => ~ aa(A,$o,aa(A,fun(A,$o),P,Y4),Z) ) ) ).

% relpowp_Suc_E
tff(fact_5510_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R3: fun(A,fun(A,$o))] : ( aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),R3) = fequal(A) ) ).

% relpowp.simps(1)
tff(fact_5511_relpowp__0__E,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),X2: A,Y2: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),P),X2),Y2)
     => ( X2 = Y2 ) ) ).

% relpowp_0_E
tff(fact_5512_relpowp__0__I,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),X2: A] : aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),P),X2),X2) ).

% relpowp_0_I
tff(fact_5513_relpowp__E2,axiom,
    ! [A: $tType,Nb: nat,P: fun(A,fun(A,$o)),X2: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),P),X2),Z)
     => ( ( ( Nb = zero_zero(nat) )
         => ( X2 != Z ) )
       => ~ ! [Y4: A,M3: nat] :
              ( ( Nb = aa(nat,nat,suc,M3) )
             => ( aa(A,$o,aa(A,fun(A,$o),P,X2),Y4)
               => ~ aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),M3),P),Y4),Z) ) ) ) ) ).

% relpowp_E2
tff(fact_5514_relpowp__E,axiom,
    ! [A: $tType,Nb: nat,P: fun(A,fun(A,$o)),X2: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),P),X2),Z)
     => ( ( ( Nb = zero_zero(nat) )
         => ( X2 != Z ) )
       => ~ ! [Y4: A,M3: nat] :
              ( ( Nb = aa(nat,nat,suc,M3) )
             => ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),M3),P),X2),Y4)
               => ~ aa(A,$o,aa(A,fun(A,$o),P,Y4),Z) ) ) ) ) ).

% relpowp_E
tff(fact_5515_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [Nb: nat,J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I3))
     => ( aa(nat,nat,nth(nat,aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or3652927894154168847AtMost(nat,I3,J2))),Nb) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),Nb)) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
tff(fact_5516_set__removeAll,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),removeAll(A,X2),Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))) ) ).

% set_removeAll
tff(fact_5517_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea2506097494486148201lgebra(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% bit.abstract_boolean_algebra_axioms
tff(fact_5518_removeAll__id,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( aa(list(A),list(A),removeAll(A,X2),Xs) = Xs ) ) ).

% removeAll_id
tff(fact_5519_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I3: A,L: A,U: A] :
          ( aa(set(A),$o,member(A,I3),set_or3652927894154168847AtMost(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),I3)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I3),U) ) ) ) ).

% greaterThanAtMost_iff
tff(fact_5520_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) ) ) ).

% greaterThanAtMost_empty_iff
tff(fact_5521_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( bot_bot(set(A)) = set_or3652927894154168847AtMost(A,K,L) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) ) ) ).

% greaterThanAtMost_empty_iff2
tff(fact_5522_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ finite_finite2(A,set_or3652927894154168847AtMost(A,A2,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% infinite_Ioc_iff
tff(fact_5523_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => distinct(A,aa(list(A),list(A),removeAll(A,X2),Xs)) ) ).

% distinct_removeAll
tff(fact_5524_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,L),U) = set_or3652927894154168847AtMost(nat,L,U) ) ).

% atLeastSucAtMost_greaterThanAtMost
tff(fact_5525_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ finite_finite2(A,set_or3652927894154168847AtMost(A,A2,B2)) ) ) ).

% infinite_Ioc
tff(fact_5526_length__removeAll__less__eq,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),removeAll(A,X2),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_removeAll_less_eq
tff(fact_5527_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( remove1(A,X2,Xs) = aa(list(A),list(A),removeAll(A,X2),Xs) ) ) ).

% distinct_remove1_removeAll
tff(fact_5528_greaterThanAtMost__upt,axiom,
    ! [Nb: nat,Ma: nat] : ( set_or3652927894154168847AtMost(nat,Nb,Ma) = aa(list(nat),set(nat),set2(nat),upt(aa(nat,nat,suc,Nb),aa(nat,nat,suc,Ma))) ) ).

% greaterThanAtMost_upt
tff(fact_5529_sum_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,Ma)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or3652927894154168847AtMost(nat,Ma,Nb))) ) ) ) ).

% sum.head
tff(fact_5530_prod_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Ma: nat,Nb: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( groups7121269368397514597t_prod(nat,A,G,set_or1337092689740270186AtMost(nat,Ma,Nb)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,Ma)),groups7121269368397514597t_prod(nat,A,G,set_or3652927894154168847AtMost(nat,Ma,Nb))) ) ) ) ).

% prod.head
tff(fact_5531_length__removeAll__less,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),removeAll(A,X2),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_removeAll_less
tff(fact_5532_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
tff(fact_5533_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
tff(fact_5534_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or3652927894154168847AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
tff(fact_5535_times__int_Oabs__eq,axiom,
    ! [Xa2: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(nat,nat),int,abs_Integ,Xa2)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_qu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa2),X2)) ) ).

% times_int.abs_eq
tff(fact_5536_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S3: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,S3)
         => ( ( S3 != bot_bot(set(A)) )
           => ~ ? [X: A] :
                  ( aa(set(A),$o,member(A,X),S3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X)),aa(A,B,F3,lattic7623131987881927897min_on(A,B,F3,S3))) ) ) ) ) ).

% arg_min_if_finite(2)
tff(fact_5537_Gcd__remove0__nat,axiom,
    ! [M6: set(nat)] :
      ( finite_finite2(nat,M6)
     => ( gcd_Gcd(nat,M6) = gcd_Gcd(nat,aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),M6),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))))) ) ) ).

% Gcd_remove0_nat
tff(fact_5538_Gcd__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_empty
tff(fact_5539_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( gcd_Gcd(A,A3) = zero_zero(A) )
        <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A)))) ) ) ).

% Gcd_0_iff
tff(fact_5540_zero__int__def,axiom,
    zero_zero(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat))) ).

% zero_int_def
tff(fact_5541_int__def,axiom,
    ! [Nb: nat] : ( aa(nat,int,semiring_1_of_nat(int),Nb) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Nb),zero_zero(nat))) ) ).

% int_def
tff(fact_5542_uminus__int_Oabs__eq,axiom,
    ! [X2: product_prod(nat,nat)] : ( aa(int,int,uminus_uminus(int),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_qv(nat,fun(nat,product_prod(nat,nat)))),X2)) ) ).

% uminus_int.abs_eq
tff(fact_5543_one__int__def,axiom,
    one_one(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat))) ).

% one_int_def
tff(fact_5544_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: product_prod(nat,nat)] : ( ring_1_of_int(A,aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),A,aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_qw(nat,fun(nat,A))),X2) ) ) ).

% of_int.abs_eq
tff(fact_5545_less__int_Oabs__eq,axiom,
    ! [Xa2: product_prod(nat,nat),X2: product_prod(nat,nat)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(product_prod(nat,nat),int,abs_Integ,Xa2)),aa(product_prod(nat,nat),int,abs_Integ,X2))
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_qy(nat,fun(nat,fun(product_prod(nat,nat),$o)))),Xa2),X2) ) ).

% less_int.abs_eq
tff(fact_5546_less__eq__int_Oabs__eq,axiom,
    ! [Xa2: product_prod(nat,nat),X2: product_prod(nat,nat)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(product_prod(nat,nat),int,abs_Integ,Xa2)),aa(product_prod(nat,nat),int,abs_Integ,X2))
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_ra(nat,fun(nat,fun(product_prod(nat,nat),$o)))),Xa2),X2) ) ).

% less_eq_int.abs_eq
tff(fact_5547_plus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa2)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_rc(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa2),X2)) ) ).

% plus_int.abs_eq
tff(fact_5548_minus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod(nat,nat),X2: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa2)),aa(product_prod(nat,nat),int,abs_Integ,X2)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_re(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa2),X2)) ) ).

% minus_int.abs_eq
tff(fact_5549_semiring__char__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: itself(A)] : ( semiri4206861660011772517g_char(A,Uu) = gcd_Gcd(nat,aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_rf(nat,$o))) ) ) ).

% semiring_char_def
tff(fact_5550_graph__map__of__if__distinct__dom,axiom,
    ! [B: $tType,A: $tType,Al: list(product_prod(A,B))] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Al))
     => ( graph(A,B,map_of(A,B,Al)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Al) ) ) ).

% graph_map_of_if_distinct_dom
tff(fact_5551_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),L),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(set(nat),set(A),image(nat,A,nth(A,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),L)) = aa(list(A),set(A),set2(A),take(A,L,Xs)) ) ) ).

% nth_image
tff(fact_5552_bij__betw__Suc,axiom,
    ! [M6: set(nat),N3: set(nat)] :
      ( bij_betw(nat,nat,suc,M6,N3)
    <=> ( aa(set(nat),set(nat),image(nat,nat,suc),M6) = N3 ) ) ).

% bij_betw_Suc
tff(fact_5553_image__ident,axiom,
    ! [A: $tType,Y5: set(A)] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_ae(A,A)),Y5) = Y5 ) ).

% image_ident
tff(fact_5554_image__Suc__atLeastAtMost,axiom,
    ! [I3: nat,J2: nat] : ( aa(set(nat),set(nat),image(nat,nat,suc),set_or1337092689740270186AtMost(nat,I3,J2)) = set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,I3),aa(nat,nat,suc,J2)) ) ).

% image_Suc_atLeastAtMost
tff(fact_5555_image__Suc__atLeastLessThan,axiom,
    ! [I3: nat,J2: nat] : ( aa(set(nat),set(nat),image(nat,nat,suc),set_or7035219750837199246ssThan(nat,I3,J2)) = set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,I3),aa(nat,nat,suc,J2)) ) ).

% image_Suc_atLeastLessThan
tff(fact_5556_Gcd__int__eq,axiom,
    ! [N3: set(nat)] : ( gcd_Gcd(int,aa(set(nat),set(int),image(nat,int,semiring_1_of_nat(int)),N3)) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,N3)) ) ).

% Gcd_int_eq
tff(fact_5557_image__add__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [S3: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A))),S3) = S3 ) ) ).

% image_add_0
tff(fact_5558_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I3: A,J2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),K)),set_or1337092689740270186AtMost(A,I3,J2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastAtMost
tff(fact_5559_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I3: A,J2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),K)),set_or7035219750837199246ssThan(A,I3,J2)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastLessThan
tff(fact_5560_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [C2: A,A2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),C2)),aa(A,set(A),set_ord_atMost(A),A2)) = aa(A,set(A),set_ord_atMost(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)) ) ) ).

% image_add_atMost
tff(fact_5561_bij__betw__add,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A),B4: set(A)] :
          ( bij_betw(A,A,aa(A,fun(A,A),plus_plus(A),A2),A3,B4)
        <=> ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),A3) = B4 ) ) ) ).

% bij_betw_add
tff(fact_5562_list_Oset__map,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),V: list(B)] : ( aa(list(A),set(A),set2(A),aa(list(B),list(A),map(B,A,F3),V)) = aa(set(B),set(A),image(B,A,F3),aa(list(B),set(B),set2(B),V)) ) ).

% list.set_map
tff(fact_5563_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),C2)),set_or3652927894154168847AtMost(A,A2,B2)) = set_or3652927894154168847AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% image_add_greaterThanAtMost
tff(fact_5564_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I3: A,J2: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_rg(A,fun(A,A),K)),set_or1337092689740270186AtMost(A,I3,J2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastAtMost'
tff(fact_5565_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [D2: A,A2: A,B2: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_rh(A,fun(A,A),D2)),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ).

% image_minus_const_atLeastAtMost'
tff(fact_5566_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I3: A,J2: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_rg(A,fun(A,A),K)),set_or7035219750837199246ssThan(A,I3,J2)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I3),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastLessThan'
tff(fact_5567_graph__empty,axiom,
    ! [B: $tType,A: $tType] : ( graph(A,B,aTP_Lamp_ri(A,option(B))) = bot_bot(set(product_prod(A,B))) ) ).

% graph_empty
tff(fact_5568_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D2)
         => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),times_times(A),D2)),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),D2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),D2),B2)) ) ) ) ).

% image_mult_atLeastAtMost
tff(fact_5569_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D2)
         => ( aa(set(A),set(A),image(A,A,aTP_Lamp_rj(A,fun(A,A),D2)),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),D2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),D2)) ) ) ) ).

% image_divide_atLeastAtMost
tff(fact_5570_image__set,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] : ( aa(set(B),set(A),image(B,A,F3),aa(list(B),set(B),set2(B),Xs)) = aa(list(A),set(A),set2(A),aa(list(B),list(A),map(B,A,F3),Xs)) ) ).

% image_set
tff(fact_5571_zero__notin__Suc__image,axiom,
    ! [A3: set(nat)] : ~ aa(set(nat),$o,member(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),A3)) ).

% zero_notin_Suc_image
tff(fact_5572_translation__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),S)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),T2)) ) ) ).

% translation_diff
tff(fact_5573_imageE,axiom,
    ! [A: $tType,B: $tType,B2: A,F3: fun(B,A),A3: set(B)] :
      ( aa(set(A),$o,member(A,B2),aa(set(B),set(A),image(B,A,F3),A3))
     => ~ ! [X4: B] :
            ( ( B2 = aa(B,A,F3,X4) )
           => ~ aa(set(B),$o,member(B,X4),A3) ) ) ).

% imageE
tff(fact_5574_image__image,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: fun(B,A),G: fun(C,B),A3: set(C)] : ( aa(set(B),set(A),image(B,A,F3),aa(set(C),set(B),image(C,B,G),A3)) = aa(set(C),set(A),image(C,A,aa(fun(C,B),fun(C,A),aTP_Lamp_rk(fun(B,A),fun(fun(C,B),fun(C,A)),F3),G)),A3) ) ).

% image_image
tff(fact_5575_Compr__image__eq,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),A3: set(B),P: fun(A,$o)] : ( aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aa(set(B),fun(fun(A,$o),fun(A,$o)),aTP_Lamp_rl(fun(B,A),fun(set(B),fun(fun(A,$o),fun(A,$o))),F3),A3),P)) = aa(set(B),set(A),image(B,A,F3),aa(fun(B,$o),set(B),collect(B),aa(fun(A,$o),fun(B,$o),aa(set(B),fun(fun(A,$o),fun(B,$o)),aTP_Lamp_rm(fun(B,A),fun(set(B),fun(fun(A,$o),fun(B,$o))),F3),A3),P))) ) ).

% Compr_image_eq
tff(fact_5576_pigeonhole__infinite,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F3: fun(A,B)] :
      ( ~ finite_finite2(A,A3)
     => ( finite_finite2(B,aa(set(A),set(B),image(A,B,F3),A3))
       => ? [X4: A] :
            ( aa(set(A),$o,member(A,X4),A3)
            & ~ finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(A,fun(A,$o),aa(fun(A,B),fun(A,fun(A,$o)),aTP_Lamp_rn(set(A),fun(fun(A,B),fun(A,fun(A,$o))),A3),F3),X4))) ) ) ) ).

% pigeonhole_infinite
tff(fact_5577_translation__Compl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),aa(set(A),set(A),uminus_uminus(set(A)),T2)) = aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),T2)) ) ) ).

% translation_Compl
tff(fact_5578_finite__conv__nat__seg__image,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
    <=> ? [N4: nat,F6: fun(nat,A)] : ( A3 = aa(set(nat),set(A),image(nat,A,F6),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),N4))) ) ) ).

% finite_conv_nat_seg_image
tff(fact_5579_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set(A),F3: fun(nat,A),Nb: nat] :
      ( ( A3 = aa(set(nat),set(A),image(nat,A,F3),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),Nb))) )
     => finite_finite2(A,A3) ) ).

% nat_seg_image_imp_finite
tff(fact_5580_image__constant,axiom,
    ! [A: $tType,B: $tType,X2: A,A3: set(A),C2: B] :
      ( aa(set(A),$o,member(A,X2),A3)
     => ( aa(set(A),set(B),image(A,B,aTP_Lamp_ro(B,fun(A,B),C2)),A3) = aa(set(B),set(B),insert(B,C2),bot_bot(set(B))) ) ) ).

% image_constant
tff(fact_5581_image__constant__conv,axiom,
    ! [B: $tType,A: $tType,C2: A,A3: set(B)] :
      ( aa(set(B),set(A),image(B,A,aa(A,fun(B,A),aTP_Lamp_aq(A,fun(B,A)),C2)),A3)
      = $ite(A3 = bot_bot(set(B)),bot_bot(set(A)),aa(set(A),set(A),insert(A,C2),bot_bot(set(A)))) ) ).

% image_constant_conv
tff(fact_5582_sum_Oimage__gen,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),H: fun(A,B),G: fun(A,C)] :
          ( finite_finite2(A,S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),S3) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(fun(A,C),fun(C,B),aa(fun(A,B),fun(fun(A,C),fun(C,B)),aTP_Lamp_rq(set(A),fun(fun(A,B),fun(fun(A,C),fun(C,B))),S3),H),G)),aa(set(A),set(C),image(A,C,G),S3)) ) ) ) ).

% sum.image_gen
tff(fact_5583_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),S)),aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),T2)) ) ) ).

% translation_subtract_diff
tff(fact_5584_prod_Oimage__gen,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),H: fun(A,B),G: fun(A,C)] :
          ( finite_finite2(A,S3)
         => ( groups7121269368397514597t_prod(A,B,H,S3) = groups7121269368397514597t_prod(C,B,aa(fun(A,C),fun(C,B),aa(fun(A,B),fun(fun(A,C),fun(C,B)),aTP_Lamp_rs(set(A),fun(fun(A,B),fun(fun(A,C),fun(C,B))),S3),H),G),aa(set(A),set(C),image(A,C,G),S3)) ) ) ) ).

% prod.image_gen
tff(fact_5585_Gcd__int__greater__eq__0,axiom,
    ! [K5: set(int)] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),gcd_Gcd(int,K5)) ).

% Gcd_int_greater_eq_0
tff(fact_5586_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,T2: set(A)] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),aa(set(A),set(A),uminus_uminus(set(A)),T2)) = aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),T2)) ) ) ).

% translation_subtract_Compl
tff(fact_5587_Gcd__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(A,B,F3,X4)),aa(A,B,G,X4)) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),gcd_Gcd(B,aa(set(A),set(B),image(A,B,F3),A3))),gcd_Gcd(B,aa(set(A),set(B),image(A,B,G),A3))) ) ) ).

% Gcd_mono
tff(fact_5588_sum_Ogroup,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [S3: set(A),T4: set(B),G: fun(A,B),H: fun(A,C)] :
          ( finite_finite2(A,S3)
         => ( finite_finite2(B,T4)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,G),S3)),T4)
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(A,C),fun(B,C),aa(fun(A,B),fun(fun(A,C),fun(B,C)),aTP_Lamp_ru(set(A),fun(fun(A,B),fun(fun(A,C),fun(B,C))),S3),G),H)),T4) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),H),S3) ) ) ) ) ) ).

% sum.group
tff(fact_5589_prod_Ogroup,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [S3: set(A),T4: set(B),G: fun(A,B),H: fun(A,C)] :
          ( finite_finite2(A,S3)
         => ( finite_finite2(B,T4)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,G),S3)),T4)
             => ( groups7121269368397514597t_prod(B,C,aa(fun(A,C),fun(B,C),aa(fun(A,B),fun(fun(A,C),fun(B,C)),aTP_Lamp_rv(set(A),fun(fun(A,B),fun(fun(A,C),fun(B,C))),S3),G),H),T4) = groups7121269368397514597t_prod(A,C,H,S3) ) ) ) ) ) ).

% prod.group
tff(fact_5590_sum_Oreindex__nontrivial,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(A),H: fun(A,B),G: fun(B,C)] :
          ( finite_finite2(A,A3)
         => ( ! [X4: A,Y4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => ( aa(set(A),$o,member(A,Y4),A3)
                 => ( ( X4 != Y4 )
                   => ( ( aa(A,B,H,X4) = aa(A,B,H,Y4) )
                     => ( aa(B,C,G,aa(A,B,H,X4)) = zero_zero(C) ) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(A),set(B),image(A,B,H),A3)) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(A,B),fun(A,C),comp(B,C,A,G),H)),A3) ) ) ) ) ).

% sum.reindex_nontrivial
tff(fact_5591_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,X2: A,Y2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(set(A),set(A),image(A,A,real_V8093663219630862766scaleR(A,C2)),set_or1337092689740270186AtMost(A,X2,Y2)) = set_or1337092689740270186AtMost(A,aa(A,A,real_V8093663219630862766scaleR(A,C2),X2),aa(A,A,real_V8093663219630862766scaleR(A,C2),Y2)) ) ) ) ).

% scaleR_image_atLeastAtMost
tff(fact_5592_image__Suc__lessThan,axiom,
    ! [Nb: nat] : ( aa(set(nat),set(nat),image(nat,nat,suc),aa(nat,set(nat),set_ord_lessThan(nat),Nb)) = set_or1337092689740270186AtMost(nat,one_one(nat),Nb) ) ).

% image_Suc_lessThan
tff(fact_5593_image__Suc__atMost,axiom,
    ! [Nb: nat] : ( aa(set(nat),set(nat),image(nat,nat,suc),aa(nat,set(nat),set_ord_atMost(nat),Nb)) = set_or1337092689740270186AtMost(nat,one_one(nat),aa(nat,nat,suc,Nb)) ) ).

% image_Suc_atMost
tff(fact_5594_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [Nb: nat] : ( set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Nb)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_or1337092689740270186AtMost(nat,zero_zero(nat),Nb))) ) ).

% atLeast0_atMost_Suc_eq_insert_0
tff(fact_5595_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [Nb: nat] : ( set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Nb)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb))) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
tff(fact_5596_lessThan__Suc__eq__insert__0,axiom,
    ! [Nb: nat] : ( aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,Nb)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) ) ).

% lessThan_Suc_eq_insert_0
tff(fact_5597_atMost__Suc__eq__insert__0,axiom,
    ! [Nb: nat] : ( aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,Nb)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),aa(nat,set(nat),set_ord_atMost(nat),Nb))) ) ).

% atMost_Suc_eq_insert_0
tff(fact_5598_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),X2: B,Xs: list(B)] :
          ( distinct(A,aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F3),X2),Xs)))
        <=> ( ~ aa(set(A),$o,member(A,aa(B,A,F3,X2)),aa(set(B),set(A),image(B,A,F3),aa(list(B),set(B),set2(B),Xs)))
            & distinct(A,aa(list(B),list(A),map(B,A,F3),Xs)) ) ) ) ).

% distinct_insort_key
tff(fact_5599_sum__image__le,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),G: fun(C,B),F3: fun(A,C)] :
          ( finite_finite2(A,I5)
         => ( ! [I2: A] :
                ( aa(set(A),$o,member(A,I2),I5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(C,B,G,aa(A,C,F3,I2))) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),aa(set(A),set(C),image(A,C,F3),I5))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,C),fun(A,B),comp(C,B,A,G),F3)),I5)) ) ) ) ).

% sum_image_le
tff(fact_5600_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,X2: A,Y2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X2,Y2))
          = $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),X2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),X2)),bot_bot(set(A))) ) ) ) ).

% image_mult_atLeastAtMost_if
tff(fact_5601_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,X2: A,Y2: A] :
          ( aa(set(A),set(A),image(A,A,aTP_Lamp_rw(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X2,Y2))
          = $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),X2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),Y2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),X2),C2))),
              bot_bot(set(A)) ) ) ) ).

% image_mult_atLeastAtMost_if'
tff(fact_5602_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Ma: A,C2: A,A2: A,B2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_rx(A,fun(A,fun(A,A)),Ma),C2)),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Ma),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),A2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),B2)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),B2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),A2)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost
tff(fact_5603_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Ma: A,C2: A,A2: A,B2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_ry(A,fun(A,fun(A,A)),Ma),C2)),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Ma),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),A2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),B2)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),B2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Ma),A2)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_diff
tff(fact_5604_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Ma: A,C2: A,A2: A,B2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_rz(A,fun(A,fun(A,A)),Ma),C2)),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Ma),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Ma)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Ma)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Ma)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Ma)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_div
tff(fact_5605_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Ma: A,C2: A,A2: A,B2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_sa(A,fun(A,fun(A,A)),Ma),C2)),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Ma),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Ma)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Ma)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Ma)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Ma)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
tff(fact_5606_sum__fun__comp,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [S3: set(A),R3: set(B),G: fun(A,B),F3: fun(B,C)] :
          ( finite_finite2(A,S3)
         => ( finite_finite2(B,R3)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,G),S3)),R3)
             => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_sb(fun(A,B),fun(fun(B,C),fun(A,C)),G),F3)),S3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_sc(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),S3),G),F3)),R3) ) ) ) ) ) ).

% sum_fun_comp
tff(fact_5607_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),U)
     => ( set_or7035219750837199246ssThan(int,zero_zero(int),U) = aa(set(nat),set(int),image(nat,int,semiring_1_of_nat(int)),aa(nat,set(nat),set_ord_lessThan(nat),aa(int,nat,nat2,U))) ) ) ).

% image_atLeastZeroLessThan_int
tff(fact_5608_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,X2: nat,Y2: nat] :
      ( aa(set(nat),set(nat),image(nat,nat,aTP_Lamp_sd(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X2,Y2))
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),C2),Y2),
          set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X2),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Y2),C2)),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),Y2),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))),bot_bot(set(nat))) ) ) ).

% image_minus_const_atLeastLessThan_nat
tff(fact_5609_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F3: fun(A,B),B4: set(B)] :
      ( ! [X4: A] :
          ( aa(A,$o,P,X4)
         => aa(set(B),$o,member(B,aa(A,B,F3,X4)),B4) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),aa(fun(A,$o),set(A),collect(A),P))),B4) ) ).

% image_Collect_subsetI
tff(fact_5610_empty__natural,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F3: fun(A,C),G: fun(D,B)] : ( aa(fun(A,C),fun(A,set(B)),comp(C,set(B),A,aTP_Lamp_se(C,set(B))),F3) = aa(fun(A,set(D)),fun(A,set(B)),comp(set(D),set(B),A,image(D,B,G)),aTP_Lamp_sf(A,set(D))) ) ).

% empty_natural
tff(fact_5611_less__eq__int_Orep__eq,axiom,
    ! [X2: int,Xa2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X2),Xa2)
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_ra(nat,fun(nat,fun(product_prod(nat,nat),$o)))),aa(int,product_prod(nat,nat),rep_Integ,X2)),aa(int,product_prod(nat,nat),rep_Integ,Xa2)) ) ).

% less_eq_int.rep_eq
tff(fact_5612_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A2: A,B2: B,A3: set(product_prod(A,B)),F3: fun(A,fun(B,C))] :
      ( aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A2),B2)),A3)
     => aa(set(C),$o,member(C,aa(B,C,aa(A,fun(B,C),F3,A2),B2)),aa(set(product_prod(A,B)),set(C),image(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F3)),A3)) ) ).

% pair_imageI
tff(fact_5613_Gcd__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(int,aa(set(int),set(int),image(int,int,abs_abs(int)),K5)) = gcd_Gcd(int,K5) ) ).

% Gcd_abs_eq
tff(fact_5614_Gcd__nat__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(nat,aa(set(int),set(nat),image(int,nat,aTP_Lamp_sg(int,nat)),K5)) = aa(int,nat,nat2,gcd_Gcd(int,K5)) ) ).

% Gcd_nat_abs_eq
tff(fact_5615_None__notin__image__Some,axiom,
    ! [A: $tType,A3: set(A)] : ~ aa(set(option(A)),$o,member(option(A),none(A)),aa(set(A),set(option(A)),image(A,option(A),some(A)),A3)) ).

% None_notin_image_Some
tff(fact_5616_map__of__eq__dom,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(A,B)),Ys: list(product_prod(A,B))] :
      ( ( map_of(A,B,Xs) = map_of(A,B,Ys) )
     => ( aa(set(product_prod(A,B)),set(A),image(product_prod(A,B),A,product_fst(A,B)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs)) = aa(set(product_prod(A,B)),set(A),image(product_prod(A,B),A,product_fst(A,B)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Ys)) ) ) ).

% map_of_eq_dom
tff(fact_5617_map__of__eq__None__iff,axiom,
    ! [A: $tType,B: $tType,Xys: list(product_prod(B,A)),X2: B] :
      ( ( aa(B,option(A),map_of(B,A,Xys),X2) = none(A) )
    <=> ~ aa(set(B),$o,member(B,X2),aa(set(product_prod(B,A)),set(B),image(product_prod(B,A),B,product_fst(B,A)),aa(list(product_prod(B,A)),set(product_prod(B,A)),set2(product_prod(B,A)),Xys))) ) ).

% map_of_eq_None_iff
tff(fact_5618_subset__subseqs,axiom,
    ! [A: $tType,X7: set(A),Xs: list(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X7),aa(list(A),set(A),set2(A),Xs))
     => aa(set(set(A)),$o,member(set(A),X7),aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs)))) ) ).

% subset_subseqs
tff(fact_5619_subseqs__powset,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs))) = pow2(A,aa(list(A),set(A),set2(A),Xs)) ) ).

% subseqs_powset
tff(fact_5620_conj__subset__def,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_ol(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q)))
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(fun(A,$o),set(A),collect(A),P))
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(fun(A,$o),set(A),collect(A),Q)) ) ) ).

% conj_subset_def
tff(fact_5621_prop__restrict,axiom,
    ! [A: $tType,X2: A,Z6: set(A),X7: set(A),P: fun(A,$o)] :
      ( aa(set(A),$o,member(A,X2),Z6)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Z6),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),X7),P)))
       => aa(A,$o,P,X2) ) ) ).

% prop_restrict
tff(fact_5622_Collect__restrict,axiom,
    ! [A: $tType,X7: set(A),P: fun(A,$o)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),X7),P))),X7) ).

% Collect_restrict
tff(fact_5623_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] : ( aa(set(int),set(int),image(int,int,aTP_Lamp_sh(int,fun(int,int),L)),set_or7035219750837199246ssThan(int,zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L))) = set_or7035219750837199246ssThan(int,L,U) ) ).

% image_add_int_atLeastLessThan
tff(fact_5624_Gcd__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,aa(set(int),set(nat),image(int,nat,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int))),K5))) ) ).

% Gcd_int_def
tff(fact_5625_conj__comp__iff,axiom,
    ! [B: $tType,A: $tType,P: fun(B,$o),Q: fun(B,$o),G: fun(A,B),X: A] :
      ( aa(A,$o,aa(fun(A,B),fun(A,$o),comp(B,$o,A,aa(fun(B,$o),fun(B,$o),aTP_Lamp_si(fun(B,$o),fun(fun(B,$o),fun(B,$o)),P),Q)),G),X)
    <=> ( aa(A,$o,aa(fun(A,B),fun(A,$o),comp(B,$o,A,P),G),X)
        & aa(A,$o,aa(fun(A,B),fun(A,$o),comp(B,$o,A,Q),G),X) ) ) ).

% conj_comp_iff
tff(fact_5626_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: int] : ( ring_1_of_int(A,X2) = aa(product_prod(nat,nat),A,aa(fun(nat,fun(nat,A)),fun(product_prod(nat,nat),A),product_case_prod(nat,nat,A),aTP_Lamp_qw(nat,fun(nat,A))),aa(int,product_prod(nat,nat),rep_Integ,X2)) ) ) ).

% of_int.rep_eq
tff(fact_5627_less__int_Orep__eq,axiom,
    ! [X2: int,Xa2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X2),Xa2)
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),$o))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_qy(nat,fun(nat,fun(product_prod(nat,nat),$o)))),aa(int,product_prod(nat,nat),rep_Integ,X2)),aa(int,product_prod(nat,nat),rep_Integ,Xa2)) ) ).

% less_int.rep_eq
tff(fact_5628_ran__distinct,axiom,
    ! [B: $tType,A: $tType,Al: list(product_prod(A,B))] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Al))
     => ( ran(A,B,map_of(A,B,Al)) = aa(set(product_prod(A,B)),set(B),image(product_prod(A,B),B,product_snd(A,B)),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Al)) ) ) ).

% ran_distinct
tff(fact_5629_uminus__int__def,axiom,
    uminus_uminus(int) = aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_qv(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int_def
tff(fact_5630_lex__take__index,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lex(A,R))
     => ~ ! [I2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Ys))
             => ( ( take(A,I2,Xs) = take(A,I2,Ys) )
               => ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(nat,A,nth(A,Xs),I2)),aa(nat,A,nth(A,Ys),I2))),R) ) ) ) ) ).

% lex_take_index
tff(fact_5631_ran__empty,axiom,
    ! [B: $tType,A: $tType] : ( ran(B,A,aTP_Lamp_sj(B,option(A))) = bot_bot(set(A)) ) ).

% ran_empty
tff(fact_5632_times__int__def,axiom,
    times_times(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_qu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int_def
tff(fact_5633_minus__int__def,axiom,
    minus_minus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_re(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int_def
tff(fact_5634_plus__int__def,axiom,
    plus_plus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_rc(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int_def
tff(fact_5635_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,R))
    <=> ? [Y: A,N4: nat] :
          ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(nat,A,nth(A,Xs),N4)),Y)),R)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N4),aa(list(A),nat,size_size(list(A)),Xs))
          & ( Ys = list_update(A,Xs,N4,Y) ) ) ) ).

% listrel1_iff_update
tff(fact_5636_num__of__nat_Osimps_I2_J,axiom,
    ! [Nb: nat] :
      ( num_of_nat(aa(nat,nat,suc,Nb))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb),inc(num_of_nat(Nb)),one2) ) ).

% num_of_nat.simps(2)
tff(fact_5637_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2)) = one_one(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X2),one2))) ) ) ).

% eq_numeral_iff_iszero(7)
tff(fact_5638_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] : ( num_of_nat(aa(num,nat,numeral_numeral(nat),Q2)) = Q2 ) ).

% num_of_nat_numeral_eq
tff(fact_5639_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: num] :
          ( ring_1_iszero(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),W)) ) ) ).

% iszero_neg_numeral
tff(fact_5640_listrel1__mono,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),R),S)
     => aa(set(product_prod(list(A),list(A))),$o,aa(set(product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),$o),ord_less_eq(set(product_prod(list(A),list(A)))),listrel1(A,R)),listrel1(A,S)) ) ).

% listrel1_mono
tff(fact_5641_iszero__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ring_1_iszero(A,zero_zero(A)) ) ).

% iszero_0
tff(fact_5642_iszero__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] :
          ( ring_1_iszero(A,Z)
        <=> ( Z = zero_zero(A) ) ) ) ).

% iszero_def
tff(fact_5643_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [W: num] : ~ ring_1_iszero(A,aa(num,A,numeral_numeral(A),W)) ) ).

% not_iszero_numeral
tff(fact_5644_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,one_one(A)) ) ).

% not_iszero_1
tff(fact_5645_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: A,Y2: A] :
          ( ( X2 = Y2 )
        <=> ring_1_iszero(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Y2)) ) ) ).

% eq_iff_iszero_diff
tff(fact_5646_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,R))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) ) ) ).

% listrel1_eq_len
tff(fact_5647_num__of__nat_Osimps_I1_J,axiom,
    num_of_nat(zero_zero(nat)) = one2 ).

% num_of_nat.simps(1)
tff(fact_5648_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y2: num] :
          ( ( zero_zero(A) = aa(num,A,numeral_numeral(A),Y2) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Y2)) ) ) ).

% eq_numeral_iff_iszero(10)
tff(fact_5649_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num] :
          ( ( aa(num,A,numeral_numeral(A),X2) = zero_zero(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),X2)) ) ) ).

% eq_numeral_iff_iszero(9)
tff(fact_5650_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(num,A,numeral_numeral(A),one2)) ) ).

% not_iszero_Numeral1
tff(fact_5651_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_iszero_neg_1
tff(fact_5652_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num,Y2: num] :
          ( ( aa(num,A,numeral_numeral(A),X2) = aa(num,A,numeral_numeral(A),Y2) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,X2,Y2)) ) ) ).

% eq_numeral_iff_iszero(1)
tff(fact_5653_numeral__num__of__nat,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(num,nat,numeral_numeral(nat),num_of_nat(Nb)) = Nb ) ) ).

% numeral_num_of_nat
tff(fact_5654_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y2: num] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y2)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Y2)) ) ) ).

% eq_numeral_iff_iszero(12)
tff(fact_5655_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2)) = zero_zero(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),X2)) ) ) ).

% eq_numeral_iff_iszero(11)
tff(fact_5656_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) ) ).

% not_iszero_neg_Numeral1
tff(fact_5657_num__of__nat__One,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),one_one(nat))
     => ( num_of_nat(Nb) = one2 ) ) ).

% num_of_nat_One
tff(fact_5658_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num,Y2: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2)) = aa(num,A,numeral_numeral(A),Y2) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X2),Y2))) ) ) ).

% eq_numeral_iff_iszero(3)
tff(fact_5659_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num,Y2: num] :
          ( ( aa(num,A,numeral_numeral(A),X2) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y2)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X2),Y2))) ) ) ).

% eq_numeral_iff_iszero(2)
tff(fact_5660_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num,Y2: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X2)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y2)) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,Y2,X2)) ) ) ).

% eq_numeral_iff_iszero(4)
tff(fact_5661_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Nb: nat] :
          ( aa(num,A,numeral_numeral(A),num_of_nat(Nb))
          = $ite(Nb = zero_zero(nat),one_one(A),aa(nat,A,semiring_1_of_nat(A),Nb)) ) ) ).

% numeral_num_of_nat_unfold
tff(fact_5662_num__of__nat__double,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( num_of_nat(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Nb)) = aa(num,num,bit0,num_of_nat(Nb)) ) ) ).

% num_of_nat_double
tff(fact_5663_num__of__nat__plus__distrib,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Ma)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ( num_of_nat(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)) = aa(num,num,aa(num,fun(num,num),plus_plus(num),num_of_nat(Ma)),num_of_nat(Nb)) ) ) ) ).

% num_of_nat_plus_distrib
tff(fact_5664_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y2: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),Y2) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,one2,Y2)) ) ) ).

% eq_numeral_iff_iszero(6)
tff(fact_5665_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X2: num] :
          ( ( aa(num,A,numeral_numeral(A),X2) = one_one(A) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,X2,one2)) ) ) ).

% eq_numeral_iff_iszero(5)
tff(fact_5666_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y2: num] :
          ( ( one_one(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y2)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Y2))) ) ) ).

% eq_numeral_iff_iszero(8)
tff(fact_5667_listrel1p__def,axiom,
    ! [A: $tType,R: fun(A,fun(A,$o)),Xs: list(A),Ys: list(A)] :
      ( listrel1p(A,R,Xs,Ys)
    <=> aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),R)))) ) ).

% listrel1p_def
tff(fact_5668_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),Ks: list(A)] : ( map_of(A,B,aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aTP_Lamp_sk(fun(A,B),fun(A,product_prod(A,B)),F3)),Ks)) = restrict_map(A,B,aa(fun(A,B),fun(A,option(B)),comp(B,option(B),A,some(B)),F3),aa(list(A),set(A),set2(A),Ks)) ) ).

% map_of_map_restrict
tff(fact_5669_prod_Oinsert_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),P2: fun(A,B),I3: A] :
          ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nv(set(A),fun(fun(A,B),fun(A,$o)),I5),P2)))
         => ( groups1962203154675924110t_prod(A,B,P2,aa(set(A),set(A),insert(A,I3),I5))
            = $ite(aa(set(A),$o,member(A,I3),I5),groups1962203154675924110t_prod(A,B,P2,I5),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,P2,I3)),groups1962203154675924110t_prod(A,B,P2,I5))) ) ) ) ).

% prod.insert'
tff(fact_5670_restrict__out,axiom,
    ! [A: $tType,B: $tType,X2: A,A3: set(A),Ma: fun(A,option(B))] :
      ( ~ aa(set(A),$o,member(A,X2),A3)
     => ( aa(A,option(B),restrict_map(A,B,Ma,A3),X2) = none(B) ) ) ).

% restrict_out
tff(fact_5671_restrict__map__empty,axiom,
    ! [A: $tType,B: $tType,D4: set(A),X: A] : ( aa(A,option(B),restrict_map(A,B,aTP_Lamp_ri(A,option(B)),D4),X) = none(B) ) ).

% restrict_map_empty
tff(fact_5672_restrict__map__to__empty,axiom,
    ! [A: $tType,B: $tType,Ma: fun(A,option(B)),X: A] : ( aa(A,option(B),restrict_map(A,B,Ma,bot_bot(set(A))),X) = none(B) ) ).

% restrict_map_to_empty
tff(fact_5673_restrict__map__def,axiom,
    ! [A: $tType,B: $tType,Ma: fun(A,option(B)),A3: set(A),X: A] :
      ( aa(A,option(B),restrict_map(A,B,Ma,A3),X)
      = $ite(aa(set(A),$o,member(A,X),A3),aa(A,option(B),Ma,X),none(B)) ) ).

% restrict_map_def
tff(fact_5674_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),I5: set(B)] : ( groups1962203154675924110t_prod(B,A,G,aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_sl(fun(B,A),fun(set(B),fun(B,$o)),G),I5))) = groups1962203154675924110t_prod(B,A,G,I5) ) ) ).

% prod.non_neutral'
tff(fact_5675_prod_Odistrib__triv_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( finite_finite2(A,I5)
         => ( groups1962203154675924110t_prod(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sm(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),times_times(B),groups1962203154675924110t_prod(A,B,G,I5)),groups1962203154675924110t_prod(A,B,H,I5)) ) ) ) ).

% prod.distrib_triv'
tff(fact_5676_prod_Odistrib_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nv(set(A),fun(fun(A,B),fun(A,$o)),I5),G)))
         => ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_nv(set(A),fun(fun(A,B),fun(A,$o)),I5),H)))
           => ( groups1962203154675924110t_prod(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sm(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),times_times(B),groups1962203154675924110t_prod(A,B,G,I5)),groups1962203154675924110t_prod(A,B,H,I5)) ) ) ) ) ).

% prod.distrib'
tff(fact_5677_prod_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P2: fun(B,A),I5: set(B)] :
          ( groups1962203154675924110t_prod(B,A,P2,I5)
          = $ite(finite_finite2(B,aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_sl(fun(B,A),fun(set(B),fun(B,$o)),P2),I5))),groups7121269368397514597t_prod(B,A,P2,aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_sl(fun(B,A),fun(set(B),fun(B,$o)),P2),I5))),one_one(A)) ) ) ).

% prod.G_def
tff(fact_5678_restrict__map__upds,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),D4: set(A),Ma: fun(A,option(B))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),D4)
       => ( restrict_map(A,B,map_upds(A,B,Ma,Xs,Ys),D4) = map_upds(A,B,restrict_map(A,B,Ma,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D4),aa(list(A),set(A),set2(A),Xs))),Xs,Ys) ) ) ) ).

% restrict_map_upds
tff(fact_5679_pow_Osimps_I3_J,axiom,
    ! [X2: num,Y2: num] : ( pow(X2,aa(num,num,bit1,Y2)) = aa(num,num,aa(num,fun(num,num),times_times(num),sqr(pow(X2,Y2))),X2) ) ).

% pow.simps(3)
tff(fact_5680_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list(A),Xss: list(list(A))] :
      ( aa(set(list(A)),$o,member(list(A),Xs),aa(list(list(A)),set(list(A)),set2(list(A)),product_lists(A,Xss)))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Xss) ) ) ).

% in_set_product_lists_length
tff(fact_5681_map__upds__apply__nontin,axiom,
    ! [B: $tType,A: $tType,X2: A,Xs: list(A),F3: fun(A,option(B)),Ys: list(B)] :
      ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( aa(A,option(B),map_upds(A,B,F3,Xs,Ys),X2) = aa(A,option(B),F3,X2) ) ) ).

% map_upds_apply_nontin
tff(fact_5682_map__upds__list__update2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),I3: nat,Ma: fun(A,option(B)),Ys: list(B),Y2: B] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),I3)
     => ( map_upds(A,B,Ma,Xs,list_update(B,Ys,I3,Y2)) = map_upds(A,B,Ma,Xs,Ys) ) ) ).

% map_upds_list_update2_drop
tff(fact_5683_sqr_Osimps_I1_J,axiom,
    sqr(one2) = one2 ).

% sqr.simps(1)
tff(fact_5684_sqr_Osimps_I2_J,axiom,
    ! [Nb: num] : ( sqr(aa(num,num,bit0,Nb)) = aa(num,num,bit0,aa(num,num,bit0,sqr(Nb))) ) ).

% sqr.simps(2)
tff(fact_5685_sqr__conv__mult,axiom,
    ! [X2: num] : ( sqr(X2) = aa(num,num,aa(num,fun(num,num),times_times(num),X2),X2) ) ).

% sqr_conv_mult
tff(fact_5686_numeral__sqr,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),sqr(K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% numeral_sqr
tff(fact_5687_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list(list(A))] :
      ( ! [X4: list(A)] :
          ( aa(set(list(A)),$o,member(list(A),X4),aa(list(list(A)),set(list(A)),set2(list(A)),Xss))
         => distinct(A,X4) )
     => distinct(list(A),product_lists(A,Xss)) ) ).

% distinct_product_lists
tff(fact_5688_pow_Osimps_I2_J,axiom,
    ! [X2: num,Y2: num] : ( pow(X2,aa(num,num,bit0,Y2)) = sqr(pow(X2,Y2)) ) ).

% pow.simps(2)
tff(fact_5689_sqr_Osimps_I3_J,axiom,
    ! [Nb: num] : ( sqr(aa(num,num,bit1,Nb)) = aa(num,num,bit1,aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),sqr(Nb)),Nb))) ) ).

% sqr.simps(3)
tff(fact_5690_length__product__lists,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(list(A)),nat,size_size(list(list(A))),product_lists(A,Xss)) = aa(nat,nat,foldr(nat,nat,times_times(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xss)),one_one(nat)) ) ).

% length_product_lists
tff(fact_5691_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( linord4507533701916653071of_set(A) = linord144544945434240204of_set(A,A,aTP_Lamp_qr(A,A)) ) ) ).

% sorted_list_of_set_def
tff(fact_5692_lenlex__conv,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( lenlex(A,R) = aa(fun(product_prod(list(A),list(A)),$o),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),$o)),fun(product_prod(list(A),list(A)),$o),product_case_prod(list(A),list(A),$o),aTP_Lamp_sn(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),R))) ) ).

% lenlex_conv
tff(fact_5693_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,fun(A,A)),Nb: nat,X2: B] : ( foldr(B,A,F3,replicate(B,Nb,X2)) = aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),aa(B,fun(A,A),F3,X2)) ) ).

% foldr_replicate
tff(fact_5694_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,L: list(B),K: list(B),F3: fun(B,fun(A,A)),G: fun(B,fun(A,A))] :
      ( ( A2 = B2 )
     => ( ( L = K )
       => ( ! [A4: A,X4: B] :
              ( aa(set(B),$o,member(B,X4),aa(list(B),set(B),set2(B),L))
             => ( aa(A,A,aa(B,fun(A,A),F3,X4),A4) = aa(A,A,aa(B,fun(A,A),G,X4),A4) ) )
         => ( aa(A,A,foldr(B,A,F3,L),A2) = aa(A,A,foldr(B,A,G,K),B2) ) ) ) ) ).

% foldr_cong
tff(fact_5695_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: fun(B,fun(A,A)),F3: fun(C,B),Xs: list(C),A2: A] : ( aa(A,A,foldr(B,A,G,aa(list(C),list(B),map(C,B,F3),Xs)),A2) = aa(A,A,foldr(C,A,aa(fun(C,B),fun(C,fun(A,A)),comp(B,fun(A,A),C,G),F3),Xs),A2) ) ).

% foldr_map
tff(fact_5696_lenlex__irreflexive,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Xs: list(A)] :
      ( ! [X4: A] : ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4)),R)
     => ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Xs)),lenlex(A,R)) ) ).

% lenlex_irreflexive
tff(fact_5697_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A)] : ( groups8242544230860333062m_list(A,Xs) = aa(A,A,foldr(A,A,plus_plus(A),Xs),zero_zero(A)) ) ) ).

% sum_list.eq_foldr
tff(fact_5698_lenlex__length,axiom,
    ! [A: $tType,Ms: list(A),Ns: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ms),Ns)),lenlex(A,R))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Ms)),aa(list(A),nat,size_size(list(A)),Ns)) ) ).

% lenlex_length
tff(fact_5699_horner__sum__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F3: fun(B,A),A2: A,Xs: list(B)] : ( groups4207007520872428315er_sum(B,A,F3,A2,Xs) = aa(A,A,foldr(B,A,aa(A,fun(B,fun(A,A)),aTP_Lamp_so(fun(B,A),fun(A,fun(B,fun(A,A))),F3),A2),Xs),zero_zero(A)) ) ) ).

% horner_sum_foldr
tff(fact_5700_distinct__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(list(A),Xs)
     => ( ! [Ys3: list(A)] :
            ( aa(set(list(A)),$o,member(list(A),Ys3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
           => distinct(A,Ys3) )
       => ( ! [Ys3: list(A),Zs2: list(A)] :
              ( aa(set(list(A)),$o,member(list(A),Ys3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
             => ( aa(set(list(A)),$o,member(list(A),Zs2),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
               => ( ( Ys3 != Zs2 )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys3)),aa(list(A),set(A),set2(A),Zs2)) = bot_bot(set(A)) ) ) ) )
         => distinct(A,concat(A,Xs)) ) ) ) ).

% distinct_concat
tff(fact_5701_Some__image__these__eq,axiom,
    ! [A: $tType,A3: set(option(A))] : ( aa(set(A),set(option(A)),image(A,option(A),some(A)),these(A,A3)) = aa(fun(option(A),$o),set(option(A)),collect(option(A)),aTP_Lamp_sp(set(option(A)),fun(option(A),$o),A3)) ) ).

% Some_image_these_eq
tff(fact_5702_sum__of__bool__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [A3: set(A),P: fun(A,$o)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_sq(fun(A,$o),fun(A,B),P)),A3) = aa(nat,B,semiring_1_of_nat(B),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),P)))) ) ) ) ) ).

% sum_of_bool_eq
tff(fact_5703_these__empty,axiom,
    ! [A: $tType] : ( these(A,bot_bot(set(option(A)))) = bot_bot(set(A)) ) ).

% these_empty
tff(fact_5704_these__insert__None,axiom,
    ! [A: $tType,A3: set(option(A))] : ( these(A,aa(set(option(A)),set(option(A)),insert(option(A),none(A)),A3)) = these(A,A3) ) ).

% these_insert_None
tff(fact_5705_these__insert__Some,axiom,
    ! [A: $tType,X2: A,A3: set(option(A))] : ( these(A,aa(set(option(A)),set(option(A)),insert(option(A),aa(A,option(A),some(A),X2)),A3)) = aa(set(A),set(A),insert(A,X2),these(A,A3)) ) ).

% these_insert_Some
tff(fact_5706_these__image__Some__eq,axiom,
    ! [A: $tType,A3: set(A)] : ( these(A,aa(set(A),set(option(A)),image(A,option(A),some(A)),A3)) = A3 ) ).

% these_image_Some_eq
tff(fact_5707_sum__of__bool__mult__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [A3: set(A),P: fun(A,$o),F3: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_sr(fun(A,$o),fun(fun(A,B),fun(A,B)),P),F3)),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),P))) ) ) ) ).

% sum_of_bool_mult_eq
tff(fact_5708_sum__mult__of__bool__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [A3: set(A),F3: fun(A,B),P: fun(A,$o)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,$o),fun(A,B),aTP_Lamp_ss(fun(A,B),fun(fun(A,$o),fun(A,B)),F3),P)),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),P))) ) ) ) ).

% sum_mult_of_bool_eq
tff(fact_5709_Int__def,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4) = aa(fun(A,$o),set(A),collect(A),aa(set(A),fun(A,$o),aTP_Lamp_st(set(A),fun(set(A),fun(A,$o)),A3),B4)) ) ).

% Int_def
tff(fact_5710_Int__Collect,axiom,
    ! [A: $tType,X2: A,A3: set(A),P: fun(A,$o)] :
      ( aa(set(A),$o,member(A,X2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),P)))
    <=> ( aa(set(A),$o,member(A,X2),A3)
        & aa(A,$o,P,X2) ) ) ).

% Int_Collect
tff(fact_5711_Collect__conj__eq,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] : ( aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_ol(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(fun(A,$o),set(A),collect(A),P)),aa(fun(A,$o),set(A),collect(A),Q)) ) ).

% Collect_conj_eq
tff(fact_5712_less__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,X2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),X2) ) ) ).

% less_infI1
tff(fact_5713_less__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,X2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),X2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),X2) ) ) ).

% less_infI2
tff(fact_5714_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) = A2 ) ) ) ).

% inf.absorb3
tff(fact_5715_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) = B2 ) ) ) ).

% inf.absorb4
tff(fact_5716_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2))
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% inf.strict_boundedE
tff(fact_5717_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( ( A2 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) )
            & ( A2 != B2 ) ) ) ) ).

% inf.strict_order_iff
tff(fact_5718_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),C2) ) ) ).

% inf.strict_coboundedI1
tff(fact_5719_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),C2) ) ) ).

% inf.strict_coboundedI2
tff(fact_5720_translation__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),S)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),T2)) ) ) ).

% translation_Int
tff(fact_5721_in__these__eq,axiom,
    ! [A: $tType,X2: A,A3: set(option(A))] :
      ( aa(set(A),$o,member(A,X2),these(A,A3))
    <=> aa(set(option(A)),$o,member(option(A),aa(A,option(A),some(A),X2)),A3) ) ).

% in_these_eq
tff(fact_5722_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),S)),aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),T2)) ) ) ).

% translation_subtract_Int
tff(fact_5723_sum_Ointer__restrict,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),B4: set(A)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(set(A),fun(A,B),aTP_Lamp_su(fun(A,B),fun(set(A),fun(A,B)),G),B4)),A3) ) ) ) ).

% sum.inter_restrict
tff(fact_5724_prod_Ointer__restrict,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),B4: set(A)] :
          ( finite_finite2(A,A3)
         => ( groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4)) = groups7121269368397514597t_prod(A,B,aa(set(A),fun(A,B),aTP_Lamp_sv(fun(A,B),fun(set(A),fun(A,B)),G),B4),A3) ) ) ) ).

% prod.inter_restrict
tff(fact_5725_these__empty__eq,axiom,
    ! [A: $tType,B4: set(option(A))] :
      ( ( these(A,B4) = bot_bot(set(A)) )
    <=> ( ( B4 = bot_bot(set(option(A))) )
        | ( B4 = aa(set(option(A)),set(option(A)),insert(option(A),none(A)),bot_bot(set(option(A)))) ) ) ) ).

% these_empty_eq
tff(fact_5726_these__not__empty__eq,axiom,
    ! [A: $tType,B4: set(option(A))] :
      ( ( these(A,B4) != bot_bot(set(A)) )
    <=> ( ( B4 != bot_bot(set(option(A))) )
        & ( B4 != aa(set(option(A)),set(option(A)),insert(option(A),none(A)),bot_bot(set(option(A)))) ) ) ) ).

% these_not_empty_eq
tff(fact_5727_sum_Omono__neutral__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T4: set(A),S3: set(A),H: fun(A,B),G: fun(A,B)] :
          ( finite_finite2(A,T4)
         => ( finite_finite2(A,S3)
           => ( ! [I2: A] :
                  ( aa(set(A),$o,member(A,I2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T4),S3))
                 => ( aa(A,B,H,I2) = zero_zero(B) ) )
             => ( ! [I2: A] :
                    ( aa(set(A),$o,member(A,I2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),T4))
                   => ( aa(A,B,G,I2) = zero_zero(B) ) )
               => ( ! [X4: A] :
                      ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S3),T4))
                     => ( aa(A,B,G,X4) = aa(A,B,H,X4) ) )
                 => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),T4) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
tff(fact_5728_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [K: A,X2: A] :
          ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_lessThan(A),K)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),K),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))),bot_bot(set(A))) ) ) ).

% Iio_Int_singleton
tff(fact_5729_sum_OInt__Diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),B4: set(A)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4))) ) ) ) ).

% sum.Int_Diff
tff(fact_5730_prod_OInt__Diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),B4: set(A)] :
          ( finite_finite2(A,A3)
         => ( groups7121269368397514597t_prod(A,B,G,A3) = aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4))) ) ) ) ).

% prod.Int_Diff
tff(fact_5731_sum_OIf__cases,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),P: fun(A,$o),H: fun(A,B),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_sw(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),P),H),G)),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),P)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),aa(fun(A,$o),set(A),collect(A),P))))) ) ) ) ).

% sum.If_cases
tff(fact_5732_prod_OIf__cases,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),P: fun(A,$o),H: fun(A,B),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( groups7121269368397514597t_prod(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_sx(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),P),H),G),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,H,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),P)))),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),aa(fun(A,$o),set(A),collect(A),P))))) ) ) ) ).

% prod.If_cases
tff(fact_5733_sum__div__partition,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: set(A),F3: fun(A,B),B2: B] :
          ( finite_finite2(A,A3)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(B,fun(A,B),aTP_Lamp_sy(fun(A,B),fun(B,fun(A,B)),F3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aTP_Lamp_sz(fun(A,B),fun(B,fun(A,$o)),F3),B2))))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aTP_Lamp_ta(fun(A,B),fun(B,fun(A,$o)),F3),B2))))),B2)) ) ) ) ).

% sum_div_partition
tff(fact_5734_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(A,concat(A,Xs))
    <=> ( distinct(list(A),aa(list(list(A)),list(list(A)),removeAll(list(A),nil(A)),Xs))
        & ! [Ys4: list(A)] :
            ( aa(set(list(A)),$o,member(list(A),Ys4),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
           => distinct(A,Ys4) )
        & ! [Ys4: list(A),Zs3: list(A)] :
            ( ( aa(set(list(A)),$o,member(list(A),Ys4),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
              & aa(set(list(A)),$o,member(list(A),Zs3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
              & ( Ys4 != Zs3 ) )
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys4)),aa(list(A),set(A),set2(A),Zs3)) = bot_bot(set(A)) ) ) ) ) ).

% distinct_concat_iff
tff(fact_5735_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( finite_card(list(A),shuffles(A,Xs,Ys)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys))),aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% card_disjoint_shuffles
tff(fact_5736_card__partition,axiom,
    ! [A: $tType,C6: set(set(A)),K: nat] :
      ( finite_finite2(set(A),C6)
     => ( finite_finite2(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C6))
       => ( ! [C3: set(A)] :
              ( aa(set(set(A)),$o,member(set(A),C3),C6)
             => ( finite_card(A,C3) = K ) )
         => ( ! [C1: set(A),C22: set(A)] :
                ( aa(set(set(A)),$o,member(set(A),C1),C6)
               => ( aa(set(set(A)),$o,member(set(A),C22),C6)
                 => ( ( C1 != C22 )
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C1),C22) = bot_bot(set(A)) ) ) ) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),finite_card(set(A),C6)) = finite_card(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C6)) ) ) ) ) ) ).

% card_partition
tff(fact_5737_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] :
      ( ( aa(list(B),list(A),map(B,A,F3),Xs) = nil(A) )
    <=> ( Xs = nil(B) ) ) ).

% map_is_Nil_conv
tff(fact_5738_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] :
      ( ( nil(A) = aa(list(B),list(A),map(B,A,F3),Xs) )
    <=> ( Xs = nil(B) ) ) ).

% Nil_is_map_conv
tff(fact_5739_list_Omap__disc__iff,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A2: list(B)] :
      ( ( aa(list(B),list(A),map(B,A,F3),A2) = nil(A) )
    <=> ( A2 = nil(B) ) ) ).

% list.map_disc_iff
tff(fact_5740_upt__conv__Nil,axiom,
    ! [J2: nat,I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I3)
     => ( upt(I3,J2) = nil(nat) ) ) ).

% upt_conv_Nil
tff(fact_5741_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list(A),K: nat,X2: A] :
      ( ( list_update(A,Xs,K,X2) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% list_update_nonempty
tff(fact_5742_concat__replicate__trivial,axiom,
    ! [A: $tType,I3: nat] : ( concat(A,replicate(list(A),I3,nil(A))) = nil(A) ) ).

% concat_replicate_trivial
tff(fact_5743_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( aa(set(list(A)),$o,member(list(A),nil(A)),shuffles(A,Xs,Ys))
    <=> ( ( Xs = nil(A) )
        & ( Ys = nil(A) ) ) ) ).

% Nil_in_shuffles
tff(fact_5744_map__of__eq__empty__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list(product_prod(A,B))] :
      ( ! [X3: A] : ( aa(A,option(B),map_of(A,B,Xys),X3) = none(B) )
    <=> ( Xys = nil(product_prod(A,B)) ) ) ).

% map_of_eq_empty_iff
tff(fact_5745_enumerate__simps_I1_J,axiom,
    ! [A: $tType,Nb: nat] : ( enumerate(A,Nb,nil(A)) = nil(product_prod(nat,A)) ) ).

% enumerate_simps(1)
tff(fact_5746_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( rotate1(A,Xs) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% rotate1_is_Nil_conv
tff(fact_5747_empty__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list(product_prod(A,B))] :
      ( ( aTP_Lamp_ri(A,option(B)) = map_of(A,B,Xys) )
    <=> ( Xys = nil(product_prod(A,B)) ) ) ).

% empty_eq_map_of_iff
tff(fact_5748_finite__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : finite_finite2(list(A),shuffles(A,Xs,Ys)) ).

% finite_shuffles
tff(fact_5749_set__empty2,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( bot_bot(set(A)) = aa(list(A),set(A),set2(A),Xs) )
    <=> ( Xs = nil(A) ) ) ).

% set_empty2
tff(fact_5750_set__empty,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),set(A),set2(A),Xs) = bot_bot(set(A)) )
    <=> ( Xs = nil(A) ) ) ).

% set_empty
tff(fact_5751_length__0__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = zero_zero(nat) )
    <=> ( Xs = nil(A) ) ) ).

% length_0_conv
tff(fact_5752_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or7035219750837199246ssThan(A,X2,Y2)) = Y2 ) ) ) ).

% Sup_atLeastLessThan
tff(fact_5753_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ( groups8242544230860333062m_list(A,nil(A)) = zero_zero(A) ) ) ).

% sum_list.Nil
tff(fact_5754_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or5935395276787703475ssThan(A,X2,Y2)) = Y2 ) ) ) ).

% Sup_greaterThanLessThan
tff(fact_5755_take0,axiom,
    ! [A: $tType,X: list(A)] : ( take(A,zero_zero(nat),X) = nil(A) ) ).

% take0
tff(fact_5756_take__eq__Nil,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( ( take(A,Nb,Xs) = nil(A) )
    <=> ( ( Nb = zero_zero(nat) )
        | ( Xs = nil(A) ) ) ) ).

% take_eq_Nil
tff(fact_5757_take__eq__Nil2,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( ( nil(A) = take(A,Nb,Xs) )
    <=> ( ( Nb = zero_zero(nat) )
        | ( Xs = nil(A) ) ) ) ).

% take_eq_Nil2
tff(fact_5758_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or3652927894154168847AtMost(A,X2,Y2)) = Y2 ) ) ) ).

% Sup_greaterThanAtMost
tff(fact_5759_empty__replicate,axiom,
    ! [A: $tType,Nb: nat,X2: A] :
      ( ( nil(A) = replicate(A,Nb,X2) )
    <=> ( Nb = zero_zero(nat) ) ) ).

% empty_replicate
tff(fact_5760_replicate__empty,axiom,
    ! [A: $tType,Nb: nat,X2: A] :
      ( ( replicate(A,Nb,X2) = nil(A) )
    <=> ( Nb = zero_zero(nat) ) ) ).

% replicate_empty
tff(fact_5761_upt__eq__Nil__conv,axiom,
    ! [I3: nat,J2: nat] :
      ( ( upt(I3,J2) = nil(nat) )
    <=> ( ( J2 = zero_zero(nat) )
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I3) ) ) ).

% upt_eq_Nil_conv
tff(fact_5762_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( aa(set(A),list(A),linord4507533701916653071of_set(A),bot_bot(set(A))) = nil(A) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
tff(fact_5763_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( ~ finite_finite2(A,A3)
         => ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = nil(A) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
tff(fact_5764_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F3: fun(B,A),A2: A] : ( groups4207007520872428315er_sum(B,A,F3,A2,nil(B)) = zero_zero(A) ) ) ).

% horner_sum_simps(1)
tff(fact_5765_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ns)),lenlex(A,R))
    <=> ( Ns != nil(A) ) ) ).

% Nil_lenlex_iff1
tff(fact_5766_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list(list(A))] :
      ( ( nil(A) = concat(A,Xss) )
    <=> ! [X3: list(A)] :
          ( aa(set(list(A)),$o,member(list(A),X3),aa(list(list(A)),set(list(A)),set2(list(A)),Xss))
         => ( X3 = nil(A) ) ) ) ).

% Nil_eq_concat_conv
tff(fact_5767_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list(list(A))] :
      ( ( concat(A,Xss) = nil(A) )
    <=> ! [X3: list(A)] :
          ( aa(set(list(A)),$o,member(list(A),X3),aa(list(list(A)),set(list(A)),set2(list(A)),Xss))
         => ( X3 = nil(A) ) ) ) ).

% concat_eq_Nil_conv
tff(fact_5768_finite__UN__I,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B4: fun(A,set(B))] :
      ( finite_finite2(A,A3)
     => ( ! [A4: A] :
            ( aa(set(A),$o,member(A,A4),A3)
           => finite_finite2(B,aa(A,set(B),B4,A4)) )
       => finite_finite2(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ) ).

% finite_UN_I
tff(fact_5769_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(list(A),nat,size_size(list(A)),Xs))
    <=> ( Xs != nil(A) ) ) ).

% length_greater_0_conv
tff(fact_5770_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( finite_finite2(A,A3)
         => ( ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = nil(A) )
          <=> ( A3 = bot_bot(set(A)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
tff(fact_5771_set__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(A),set(A),set2(A),concat(A,Xs)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))) ) ).

% set_concat
tff(fact_5772_inf__set__def,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4) = aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aa(fun(A,$o),fun(fun(A,$o),fun(A,$o)),inf_inf(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),B4))) ) ).

% inf_set_def
tff(fact_5773_inf__Int__eq,axiom,
    ! [A: $tType,R3: set(A),S3: set(A),X: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aa(fun(A,$o),fun(fun(A,$o),fun(A,$o)),inf_inf(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),R3)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),S3)),X)
    <=> aa(set(A),$o,member(A,X),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),R3),S3)) ) ).

% inf_Int_eq
tff(fact_5774_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),S3: set(product_prod(A,B)),X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),inf_inf(fun(A,fun(B,$o))),aa(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o))),R3)),aa(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o))),S3)),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),R3),S3)) ) ).

% inf_Int_eq2
tff(fact_5775_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X2: A] : ( aa(list(A),list(A),removeAll(A,X2),nil(A)) = nil(A) ) ).

% removeAll.simps(1)
tff(fact_5776_insort__not__Nil,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),A2: A,Xs: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),A2),Xs) != nil(A) ) ) ).

% insort_not_Nil
tff(fact_5777_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] : ( rotate1(A,nil(A)) = nil(A) ) ).

% rotate1.simps(1)
tff(fact_5778_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X2: A] : ( remove1(A,X2,nil(A)) = nil(A) ) ).

% remove1.simps(1)
tff(fact_5779_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] : ( shuffles(A,Xs,nil(A)) = aa(set(list(A)),set(list(A)),insert(list(A),Xs),bot_bot(set(list(A)))) ) ).

% shuffles.simps(2)
tff(fact_5780_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list(A)] : ( shuffles(A,nil(A),Ys) = aa(set(list(A)),set(list(A)),insert(list(A),Ys),bot_bot(set(list(A)))) ) ).

% shuffles.simps(1)
tff(fact_5781_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o))] : sorted_wrt(A,P,nil(A)) ).

% sorted_wrt.simps(1)
tff(fact_5782_list_Osimps_I8_J,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A)] : ( aa(list(B),list(A),map(B,A,F3),nil(B)) = nil(A) ) ).

% list.simps(8)
tff(fact_5783_concat_Osimps_I1_J,axiom,
    ! [A: $tType] : ( concat(A,nil(list(A))) = nil(A) ) ).

% concat.simps(1)
tff(fact_5784_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu: list(B)] : ( product(A,B,nil(A),Uu) = nil(product_prod(A,B)) ) ).

% product.simps(1)
tff(fact_5785_shuffles__commutes,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( shuffles(A,Xs,Ys) = shuffles(A,Ys,Xs) ) ).

% shuffles_commutes
tff(fact_5786_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs = nil(A) )
     => ( ( Ys = nil(A) )
       => aa(set(list(A)),$o,member(list(A),nil(A)),shuffles(A,Xs,Ys)) ) ) ).

% Nil_in_shufflesI
tff(fact_5787_take__Nil,axiom,
    ! [A: $tType,Nb: nat] : ( take(A,Nb,nil(A)) = nil(A) ) ).

% take_Nil
tff(fact_5788_list__update__code_I1_J,axiom,
    ! [A: $tType,I3: nat,Y2: A] : ( list_update(A,nil(A),I3,Y2) = nil(A) ) ).

% list_update_code(1)
tff(fact_5789_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I3: nat,V: A] : ( list_update(A,nil(A),I3,V) = nil(A) ) ).

% list_update.simps(1)
tff(fact_5790_in__Union__o__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,X2: A,Gset: fun(B,set(set(A))),Gmap: fun(C,B),A3: C] :
      ( aa(set(A),$o,member(A,X2),aa(C,set(A),aa(fun(C,B),fun(C,set(A)),comp(B,set(A),C,aa(fun(B,set(set(A))),fun(B,set(A)),comp(set(set(A)),set(A),B,complete_Sup_Sup(set(A))),Gset)),Gmap),A3))
     => aa(set(A),$o,member(A,X2),aa(C,set(A),aa(fun(C,set(set(A))),fun(C,set(A)),comp(set(set(A)),set(A),C,complete_Sup_Sup(set(A))),aa(fun(C,B),fun(C,set(set(A))),comp(B,set(set(A)),C,Gset),Gmap)),A3)) ) ).

% in_Union_o_assoc
tff(fact_5791_Union__natural,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B)] : ( aa(fun(set(set(A)),set(set(B))),fun(set(set(A)),set(B)),comp(set(set(B)),set(B),set(set(A)),complete_Sup_Sup(set(B))),image(set(A),set(B),image(A,B,F3))) = aa(fun(set(set(A)),set(A)),fun(set(set(A)),set(B)),comp(set(A),set(B),set(set(A)),image(A,B,F3)),complete_Sup_Sup(set(A))) ) ).

% Union_natural
tff(fact_5792_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : distinct(A,nil(A)) ).

% distinct.simps(1)
tff(fact_5793_empty__set,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(list(A),set(A),set2(A),nil(A)) ) ).

% empty_set
tff(fact_5794_list_Osize_I3_J,axiom,
    ! [A: $tType] : ( aa(list(A),nat,size_size(list(A)),nil(A)) = zero_zero(nat) ) ).

% list.size(3)
tff(fact_5795_sorted0,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => sorted_wrt(A,ord_less_eq(A),nil(A)) ) ).

% sorted0
tff(fact_5796_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => sorted_wrt(A,ord_less(A),nil(A)) ) ).

% strict_sorted_simps(1)
tff(fact_5797_length__shuffles,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys: list(A)] :
      ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
     => ( aa(list(A),nat,size_size(list(A)),Zs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys)) ) ) ).

% length_shuffles
tff(fact_5798_take__0,axiom,
    ! [A: $tType,Xs: list(A)] : ( take(A,zero_zero(nat),Xs) = nil(A) ) ).

% take_0
tff(fact_5799_replicate__0,axiom,
    ! [A: $tType,X2: A] : ( replicate(A,zero_zero(nat),X2) = nil(A) ) ).

% replicate_0
tff(fact_5800_upt__0,axiom,
    ! [I3: nat] : ( upt(I3,zero_zero(nat)) = nil(nat) ) ).

% upt_0
tff(fact_5801_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F3: fun(B,A),B4: set(B),A2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),B4))),A2) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(A,fun(B,A),aTP_Lamp_tb(fun(B,A),fun(A,fun(B,A)),F3),A2)),B4)) ) ) ).

% SUP_inf
tff(fact_5802_Sup__inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B4: set(A),A2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),B4)),A2) = aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image(A,A,aTP_Lamp_tc(A,fun(A,A),A2)),B4)) ) ) ).

% Sup_inf
tff(fact_5803_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A2: A,F3: fun(B,A),B4: set(B)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),B4))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_td(A,fun(fun(B,A),fun(B,A)),A2),F3)),B4)) ) ) ).

% inf_SUP
tff(fact_5804_SUP__inf__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F3: fun(B,A),A3: set(B),G: fun(C,A),B4: set(C)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,G),B4))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_tf(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F3),G),B4)),A3)) ) ) ).

% SUP_inf_distrib2
tff(fact_5805_map__of_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType,X: A] : ( aa(A,option(B),map_of(A,B,nil(product_prod(A,B))),X) = none(B) ) ).

% map_of.simps(1)
tff(fact_5806_map__of__Cons__code_I1_J,axiom,
    ! [B: $tType,A: $tType,K: B] : ( aa(B,option(A),map_of(B,A,nil(product_prod(B,A))),K) = none(A) ) ).

% map_of_Cons_code(1)
tff(fact_5807_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list(A),R: set(product_prod(A,A))] : ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),nil(A))),listrel1(A,R)) ).

% not_listrel1_Nil
tff(fact_5808_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list(A),R: set(product_prod(A,A))] : ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xs)),listrel1(A,R)) ).

% not_Nil_listrel1
tff(fact_5809_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X2: fun(A,nat)] : ( aa(list(A),nat,size_list(A,X2),nil(A)) = zero_zero(nat) ) ).

% list.size_gen(1)
tff(fact_5810_UN__image__subset,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: fun(B,set(A)),G: fun(C,set(B)),X2: C,X7: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),aa(C,set(B),G,X2)))),X7)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(C,set(B),G,X2)),aa(fun(B,$o),set(B),collect(B),aa(set(A),fun(B,$o),aTP_Lamp_tg(fun(B,set(A)),fun(set(A),fun(B,$o)),F3),X7))) ) ).

% UN_image_subset
tff(fact_5811_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list(A),R: set(product_prod(A,A))] : ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys)),lex(A,R)) ).

% Nil_notin_lex
tff(fact_5812_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list(A),R: set(product_prod(A,A))] : ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),nil(A))),lex(A,R)) ).

% Nil2_notin_lex
tff(fact_5813_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list(A),R: set(product_prod(A,A))] : ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ns),nil(A))),lenlex(A,R)) ).

% Nil_lenlex_iff2
tff(fact_5814_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y2: A] : ( aa(A,nat,count_list(A,nil(A)),Y2) = zero_zero(nat) ) ).

% count_list.simps(1)
tff(fact_5815_sum_OUnion__comp,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [B4: set(set(A)),G: fun(A,B)] :
          ( ! [X4: set(A)] :
              ( aa(set(set(A)),$o,member(set(A),X4),B4)
             => finite_finite2(A,X4) )
         => ( ! [A12: set(A)] :
                ( aa(set(set(A)),$o,member(set(A),A12),B4)
               => ! [A23: set(A)] :
                    ( aa(set(set(A)),$o,member(set(A),A23),B4)
                   => ( ( A12 != A23 )
                     => ! [X4: A] :
                          ( aa(set(A),$o,member(A,X4),A12)
                         => ( aa(set(A),$o,member(A,X4),A23)
                           => ( aa(A,B,G,X4) = zero_zero(B) ) ) ) ) ) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B4)) = aa(set(set(A)),B,aa(fun(A,B),fun(set(set(A)),B),aa(fun(fun(A,B),fun(set(A),B)),fun(fun(A,B),fun(set(set(A)),B)),comp(fun(set(A),B),fun(set(set(A)),B),fun(A,B),groups7311177749621191930dd_sum(set(A),B)),groups7311177749621191930dd_sum(A,B)),G),B4) ) ) ) ) ).

% sum.Union_comp
tff(fact_5816_Pow__set_I1_J,axiom,
    ! [A: $tType] : ( pow2(A,aa(list(A),set(A),set2(A),nil(A))) = aa(set(set(A)),set(set(A)),insert(set(A),bot_bot(set(A))),bot_bot(set(set(A)))) ) ).

% Pow_set(1)
tff(fact_5817_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M6: fun(nat,set(A)),K: nat,Nb: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_th(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M6),K)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M6),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K)))) ) ).

% UN_le_add_shift_strict
tff(fact_5818_UN__le__add__shift,axiom,
    ! [A: $tType,M6: fun(nat,set(A)),K: nat,Nb: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_th(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M6),K)),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M6),set_or1337092689740270186AtMost(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),K)))) ) ).

% UN_le_add_shift
tff(fact_5819_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),bot_bot(set(B))) = nil(B) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
tff(fact_5820_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add(B)
        & strict9044650504122735259up_add(B) )
     => ! [Xs: list(A),F3: fun(A,B),G: fun(A,B)] :
          ( ( Xs != nil(A) )
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X4)),aa(A,B,G,X4)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F3),Xs))),groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,G),Xs))) ) ) ) ).

% sum_list_strict_mono
tff(fact_5821_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( distinct(A,Xs)
     => ( distinct(A,Ys)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
         => ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
           => distinct(A,Zs) ) ) ) ) ).

% distinct_disjoint_shuffles
tff(fact_5822_sum_OUNION__disjoint,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [I5: set(A),A3: fun(A,set(B)),G: fun(B,C)] :
          ( finite_finite2(A,I5)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),I5)
               => finite_finite2(B,aa(A,set(B),A3,X4)) )
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),I5)
                 => ! [Xa4: A] :
                      ( aa(set(A),$o,member(A,Xa4),I5)
                     => ( ( X4 != Xa4 )
                       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),A3,X4)),aa(A,set(B),A3,Xa4)) = bot_bot(set(B)) ) ) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_ti(fun(A,set(B)),fun(fun(B,C),fun(A,C)),A3),G)),I5) ) ) ) ) ) ).

% sum.UNION_disjoint
tff(fact_5823_prod_OUNION__disjoint,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [I5: set(A),A3: fun(A,set(B)),G: fun(B,C)] :
          ( finite_finite2(A,I5)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),I5)
               => finite_finite2(B,aa(A,set(B),A3,X4)) )
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),I5)
                 => ! [Xa4: A] :
                      ( aa(set(A),$o,member(A,Xa4),I5)
                     => ( ( X4 != Xa4 )
                       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),A3,X4)),aa(A,set(B),A3,Xa4)) = bot_bot(set(B)) ) ) ) )
             => ( groups7121269368397514597t_prod(B,C,G,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) = groups7121269368397514597t_prod(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tj(fun(A,set(B)),fun(fun(B,C),fun(A,C)),A3),G),I5) ) ) ) ) ) ).

% prod.UNION_disjoint
tff(fact_5824_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set(A),A3: fun(A,set(B))] :
      ( finite_finite2(A,I5)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5)))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_tk(fun(A,set(B)),fun(A,nat),A3)),I5)) ) ).

% card_UN_le
tff(fact_5825_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( finite_finite2(B,A3)
         => ( ( aa(set(B),list(B),aa(fun(B,A),fun(set(B),list(B)),sorted8670434370408473282of_set(A,B,Less_eq),F3),A3) = nil(B) )
          <=> ( A3 = bot_bot(set(B)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
tff(fact_5826_card__UN__disjoint,axiom,
    ! [B: $tType,A: $tType,I5: set(A),A3: fun(A,set(B))] :
      ( finite_finite2(A,I5)
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),I5)
           => finite_finite2(B,aa(A,set(B),A3,X4)) )
       => ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),I5)
             => ! [Xa4: A] :
                  ( aa(set(A),$o,member(A,Xa4),I5)
                 => ( ( X4 != Xa4 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),A3,X4)),aa(A,set(B),A3,Xa4)) = bot_bot(set(B)) ) ) ) )
         => ( finite_card(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_tk(fun(A,set(B)),fun(A,nat),A3)),I5) ) ) ) ) ).

% card_UN_disjoint
tff(fact_5827_UN__singleton,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(A),set(set(A)),image(A,set(A),aTP_Lamp_tl(A,set(A))),A3)) = A3 ) ).

% UN_singleton
tff(fact_5828_UN__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,A2: A,B4: fun(B,set(A)),C6: set(B)] :
      ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_tm(A,fun(fun(B,set(A)),fun(B,set(A))),A2),B4)),C6))
      = $ite(C6 = bot_bot(set(B)),bot_bot(set(A)),aa(set(A),set(A),insert(A,A2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6)))) ) ).

% UN_simps(1)
tff(fact_5829_ccSUP__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [F3: fun(B,A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),bot_bot(set(B)))) = bot_bot(A) ) ) ).

% ccSUP_empty
tff(fact_5830_Sup__apply,axiom,
    ! [A: $tType,B: $tType] :
      ( complete_Sup(A)
     => ! [A3: set(fun(B,A)),X2: B] : ( aa(B,A,aa(set(fun(B,A)),fun(B,A),complete_Sup_Sup(fun(B,A)),A3),X2) = aa(set(A),A,complete_Sup_Sup(A),aa(set(fun(B,A)),set(A),image(fun(B,A),A,aTP_Lamp_tn(B,fun(fun(B,A),A),X2)),A3)) ) ) ).

% Sup_apply
tff(fact_5831_SUP__identity__eq,axiom,
    ! [A: $tType] :
      ( complete_Sup(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image(A,A,aTP_Lamp_to(A,A)),A3)) = aa(set(A),A,complete_Sup_Sup(A),A3) ) ) ).

% SUP_identity_eq
tff(fact_5832_SUP__apply,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( complete_Sup(A)
     => ! [F3: fun(C,fun(B,A)),A3: set(C),X2: B] : ( aa(B,A,aa(set(fun(B,A)),fun(B,A),complete_Sup_Sup(fun(B,A)),aa(set(C),set(fun(B,A)),image(C,fun(B,A),F3),A3)),X2) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aTP_Lamp_tp(fun(C,fun(B,A)),fun(B,fun(C,A)),F3),X2)),A3)) ) ) ).

% SUP_apply
tff(fact_5833_UN__I,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set(A),B2: B,B4: fun(A,set(B))] :
      ( aa(set(A),$o,member(A,A2),A3)
     => ( aa(set(B),$o,member(B,B2),aa(A,set(B),B4,A2))
       => aa(set(B),$o,member(B,B2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ) ).

% UN_I
tff(fact_5834_UN__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,B4: fun(B,set(A)),A3: set(B)] :
      ( aa(set(A),$o,member(A,B2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)))
    <=> ? [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
          & aa(set(A),$o,member(A,B2),aa(B,set(A),B4,X3)) ) ) ).

% UN_iff
tff(fact_5835_ccSUP__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aTP_Lamp_tq(B,A)),A3)) = bot_bot(A) ) ) ).

% ccSUP_bot
tff(fact_5836_SUP__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aTP_Lamp_tr(B,A)),A3)) = bot_bot(A) ) ) ).

% SUP_bot
tff(fact_5837_SUP__bot__conv_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B4: fun(B,A),A3: set(B)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,B4),A3)) = bot_bot(A) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => ( aa(B,A,B4,X3) = bot_bot(A) ) ) ) ) ).

% SUP_bot_conv(1)
tff(fact_5838_SUP__bot__conv_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B4: fun(B,A),A3: set(B)] :
          ( ( bot_bot(A) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,B4),A3)) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => ( aa(B,A,B4,X3) = bot_bot(A) ) ) ) ) ).

% SUP_bot_conv(2)
tff(fact_5839_ccSUP__const,axiom,
    ! [A: $tType,B: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),F3: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,aTP_Lamp_ts(B,fun(A,B),F3)),A3)) = F3 ) ) ) ).

% ccSUP_const
tff(fact_5840_SUP__const,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),F3: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,aTP_Lamp_tt(B,fun(A,B),F3)),A3)) = F3 ) ) ) ).

% SUP_const
tff(fact_5841_UN__constant,axiom,
    ! [B: $tType,A: $tType,C2: set(A),A3: set(B)] :
      ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_tu(set(A),fun(B,set(A)),C2)),A3))
      = $ite(A3 = bot_bot(set(B)),bot_bot(set(A)),C2) ) ).

% UN_constant
tff(fact_5842_Sup__set__def,axiom,
    ! [A: $tType,A3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_tv(set(set(A)),fun(A,$o),A3)) ) ).

% Sup_set_def
tff(fact_5843_SUP__Sup__eq,axiom,
    ! [A: $tType,S3: set(set(A)),X: A] :
      ( aa(A,$o,aa(set(fun(A,$o)),fun(A,$o),complete_Sup_Sup(fun(A,$o)),aa(set(set(A)),set(fun(A,$o)),image(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o))),S3)),X)
    <=> aa(set(A),$o,member(A,X),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),S3)) ) ).

% SUP_Sup_eq
tff(fact_5844_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set(set(product_prod(A,B))),X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Sup_Sup(fun(A,fun(B,$o))),aa(set(set(product_prod(A,B))),set(fun(A,fun(B,$o))),image(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o)))),S3)),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),S3)) ) ).

% SUP_Sup_eq2
tff(fact_5845_SUP__UN__eq2,axiom,
    ! [A: $tType,B: $tType,C: $tType,R: fun(C,set(product_prod(A,B))),S3: set(C),X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Sup_Sup(fun(A,fun(B,$o))),aa(set(C),set(fun(A,fun(B,$o))),image(C,fun(A,fun(B,$o)),aTP_Lamp_tw(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,$o))),R)),S3)),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(C),set(set(product_prod(A,B))),image(C,set(product_prod(A,B)),R),S3))) ) ).

% SUP_UN_eq2
tff(fact_5846_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set(fun(A,fun(B,$o))),X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Sup_Sup(fun(A,fun(B,$o))),S3),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(fun(product_prod(A,B),$o)),set(set(product_prod(A,B))),image(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B))),aa(set(fun(A,fun(B,$o))),set(fun(product_prod(A,B),$o)),image(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o)),S3)))) ) ).

% Sup_SUP_eq2
tff(fact_5847_SUP__UN__eq,axiom,
    ! [A: $tType,B: $tType,R: fun(B,set(A)),S3: set(B),X: A] :
      ( aa(A,$o,aa(set(fun(A,$o)),fun(A,$o),complete_Sup_Sup(fun(A,$o)),aa(set(B),set(fun(A,$o)),image(B,fun(A,$o),aTP_Lamp_tx(fun(B,set(A)),fun(B,fun(A,$o)),R)),S3)),X)
    <=> aa(set(A),$o,member(A,X),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),R),S3))) ) ).

% SUP_UN_eq
tff(fact_5848_Sup_OSUP__identity__eq,axiom,
    ! [A: $tType,Sup: fun(set(A),A),A3: set(A)] : ( aa(set(A),A,Sup,aa(set(A),set(A),image(A,A,aTP_Lamp_ae(A,A)),A3)) = aa(set(A),A,Sup,A3) ) ).

% Sup.SUP_identity_eq
tff(fact_5849_Inf_OINF__identity__eq,axiom,
    ! [A: $tType,Inf: fun(set(A),A),A3: set(A)] : ( aa(set(A),A,Inf,aa(set(A),set(A),image(A,A,aTP_Lamp_ae(A,A)),A3)) = aa(set(A),A,Inf,A3) ) ).

% Inf.INF_identity_eq
tff(fact_5850_Sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Sup(B)
     => ! [A3: set(fun(A,B)),X: A] : ( aa(A,B,aa(set(fun(A,B)),fun(A,B),complete_Sup_Sup(fun(A,B)),A3),X) = aa(set(B),B,complete_Sup_Sup(B),aa(set(fun(A,B)),set(B),image(fun(A,B),B,aTP_Lamp_ty(A,fun(fun(A,B),B),X)),A3)) ) ) ).

% Sup_fun_def
tff(fact_5851_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A2: A,S3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(set(A),A,complete_Sup_Sup(A),S3))
        <=> ? [X3: A] :
              ( aa(set(A),$o,member(A,X3),S3)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X3) ) ) ) ).

% less_Sup_iff
tff(fact_5852_SUP__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,fun(C,A)),B4: set(C),A3: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(set(C),fun(B,A),aTP_Lamp_tz(fun(B,fun(C,A)),fun(set(C),fun(B,A)),F3),B4)),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,aa(set(B),fun(C,A),aTP_Lamp_ub(fun(B,fun(C,A)),fun(set(B),fun(C,A)),F3),A3)),B4)) ) ) ).

% SUP_commute
tff(fact_5853_image__Union,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S3: set(set(B))] : ( aa(set(B),set(A),image(B,A,F3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),S3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(B)),set(set(A)),image(set(B),set(A),image(B,A,F3)),S3)) ) ).

% image_Union
tff(fact_5854_Int__Union2,axiom,
    ! [A: $tType,B4: set(set(A)),A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B4)),A3) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),image(set(A),set(A),aTP_Lamp_uc(set(A),fun(set(A),set(A)),A3)),B4)) ) ).

% Int_Union2
tff(fact_5855_Int__Union,axiom,
    ! [A: $tType,A3: set(A),B4: set(set(A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B4)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),image(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3)),B4)) ) ).

% Int_Union
tff(fact_5856_UN__extend__simps_I9_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,C6: fun(C,set(A)),B4: fun(B,set(C)),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(C)),fun(B,set(A)),aTP_Lamp_ud(fun(C,set(A)),fun(fun(B,set(C)),fun(B,set(A))),C6),B4)),A3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image(C,set(A),C6),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image(B,set(C),B4),A3)))) ) ).

% UN_extend_simps(9)
tff(fact_5857_UN__extend__simps_I8_J,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A3: set(set(B))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(B)),set(set(A)),image(set(B),set(A),aTP_Lamp_ue(fun(B,set(A)),fun(set(B),set(A)),B4)),A3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3))) ) ).

% UN_extend_simps(8)
tff(fact_5858_UN__E,axiom,
    ! [A: $tType,B: $tType,B2: A,B4: fun(B,set(A)),A3: set(B)] :
      ( aa(set(A),$o,member(A,B2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)))
     => ~ ! [X4: B] :
            ( aa(set(B),$o,member(B,X4),A3)
           => ~ aa(set(A),$o,member(A,B2),aa(B,set(A),B4,X4)) ) ) ).

% UN_E
tff(fact_5859_UN__UN__flatten,axiom,
    ! [B: $tType,A: $tType,C: $tType,C6: fun(B,set(A)),B4: fun(C,set(B)),A3: set(C)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),C6),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image(C,set(B),B4),A3)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_uf(fun(B,set(A)),fun(fun(C,set(B)),fun(C,set(A))),C6),B4)),A3)) ) ).

% UN_UN_flatten
tff(fact_5860_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [X2: A,A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(set(A),A,complete_Sup_Sup(A),A3))
        <=> ! [Y: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X2)
             => ? [X3: A] :
                  ( aa(set(A),$o,member(A,X3),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X3) ) ) ) ) ).

% le_Sup_iff
tff(fact_5861_SUP__upper2,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I3: A,A3: set(A),U: B,F3: fun(A,B)] :
          ( aa(set(A),$o,member(A,I3),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(A,B,F3,I3))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ).

% SUP_upper2
tff(fact_5862_SUP__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A),A3: set(B),U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))),U)
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,X3)),U) ) ) ) ).

% SUP_le_iff
tff(fact_5863_SUP__upper,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I3: A,A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,member(A,I3),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I3)),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ).

% SUP_upper
tff(fact_5864_SUP__mono_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F3: fun(A,B),G: fun(A,B),A3: set(A)] :
          ( ! [X4: A] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,G,X4))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,G),A3))) ) ) ).

% SUP_mono'
tff(fact_5865_SUP__least,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),F3: fun(A,B),U: B] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),U) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),U) ) ) ).

% SUP_least
tff(fact_5866_SUP__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(A),B4: set(B),F3: fun(A,C),G: fun(B,C)] :
          ( ! [N: A] :
              ( aa(set(A),$o,member(A,N),A3)
             => ? [X: B] :
                  ( aa(set(B),$o,member(B,X),B4)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F3,N)),aa(B,C,G,X)) ) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(A),set(C),image(A,C,F3),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image(B,C,G),B4))) ) ) ).

% SUP_mono
tff(fact_5867_SUP__eqI,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),F3: fun(A,B),X2: B] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),X2) )
         => ( ! [Y4: B] :
                ( ! [I4: A] :
                    ( aa(set(A),$o,member(A,I4),A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I4)),Y4) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y4) )
           => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3)) = X2 ) ) ) ) ).

% SUP_eqI
tff(fact_5868_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A),A3: set(B),Y2: A,I3: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))),Y2)
         => ( aa(set(B),$o,member(B,I3),A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,I3)),Y2) ) ) ) ).

% SUP_lessD
tff(fact_5869_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A2: A,F3: fun(B,A),A3: set(B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3)))
        <=> ? [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,X3)) ) ) ) ).

% less_SUP_iff
tff(fact_5870_UN__extend__simps_I10_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,B4: fun(C,set(A)),F3: fun(B,C),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,C),fun(B,set(A)),aTP_Lamp_ug(fun(C,set(A)),fun(fun(B,C),fun(B,set(A))),B4),F3)),A3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image(C,set(A),B4),aa(set(B),set(C),image(B,C,F3),A3))) ) ).

% UN_extend_simps(10)
tff(fact_5871_image__UN,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: fun(B,A),B4: fun(C,set(B)),A3: set(C)] : ( aa(set(B),set(A),image(B,A,F3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image(C,set(B),B4),A3))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_uh(fun(B,A),fun(fun(C,set(B)),fun(C,set(A))),F3),B4)),A3)) ) ).

% image_UN
tff(fact_5872_UN__empty2,axiom,
    ! [B: $tType,A: $tType,A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_ui(B,set(A))),A3)) = bot_bot(set(A)) ) ).

% UN_empty2
tff(fact_5873_UN__empty,axiom,
    ! [B: $tType,A: $tType,B4: fun(B,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),bot_bot(set(B)))) = bot_bot(set(A)) ) ).

% UN_empty
tff(fact_5874_UNION__empty__conv_I1_J,axiom,
    ! [B: $tType,A: $tType,B4: fun(B,set(A)),A3: set(B)] :
      ( ( bot_bot(set(A)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
         => ( aa(B,set(A),B4,X3) = bot_bot(set(A)) ) ) ) ).

% UNION_empty_conv(1)
tff(fact_5875_UNION__empty__conv_I2_J,axiom,
    ! [B: $tType,A: $tType,B4: fun(B,set(A)),A3: set(B)] :
      ( ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)) = bot_bot(set(A)) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
         => ( aa(B,set(A),B4,X3) = bot_bot(set(A)) ) ) ) ).

% UNION_empty_conv(2)
tff(fact_5876_UN__subset__iff,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),I5: set(B),B4: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))),B4)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),I5)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(B,set(A),A3,X3)),B4) ) ) ).

% UN_subset_iff
tff(fact_5877_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set(A),B4: fun(A,set(B))] :
      ( aa(set(A),$o,member(A,A2),A3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),B4,A2)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ).

% UN_upper
tff(fact_5878_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(A,set(B)),C6: set(B)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),A3)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),B4,X4)),C6) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))),C6) ) ).

% UN_least
tff(fact_5879_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B4: set(A),F3: fun(A,set(B)),G: fun(A,set(B))] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),A3)
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F3,X4)),aa(A,set(B),G,X4)) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),F3),A3))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),G),B4))) ) ) ).

% UN_mono
tff(fact_5880_UN__insert__distrib,axiom,
    ! [B: $tType,A: $tType,U: A,A3: set(A),A2: B,B4: fun(A,set(B))] :
      ( aa(set(A),$o,member(A,U),A3)
     => ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_uj(B,fun(fun(A,set(B)),fun(A,set(B))),A2),B4)),A3)) = aa(set(B),set(B),insert(B,A2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ) ).

% UN_insert_distrib
tff(fact_5881_Int__UN__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType,A3: fun(B,set(A)),I5: set(B),B4: fun(C,set(A)),J5: set(C)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image(C,set(A),B4),J5))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_ul(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),A3),B4),J5)),I5)) ) ).

% Int_UN_distrib2
tff(fact_5882_Int__UN__distrib,axiom,
    ! [A: $tType,B: $tType,B4: set(A),A3: fun(B,set(A)),I5: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_um(set(A),fun(fun(B,set(A)),fun(B,set(A))),B4),A3)),I5)) ) ).

% Int_UN_distrib
tff(fact_5883_UN__extend__simps_I4_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C6: set(B),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_un(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6)) ) ).

% UN_extend_simps(4)
tff(fact_5884_UN__extend__simps_I5_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_um(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6)) ) ).

% UN_extend_simps(5)
tff(fact_5885_UN__extend__simps_I6_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C6: set(B),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_uo(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6)) ) ).

% UN_extend_simps(6)
tff(fact_5886_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A3: set(B)] : aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),aa(set(set(set(A))),set(set(A)),complete_Sup_Sup(set(set(A))),aa(set(B),set(set(set(A))),image(B,set(set(A)),aTP_Lamp_up(fun(B,set(A)),fun(B,set(set(A))),B4)),A3))),pow2(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)))) ).

% UN_Pow_subset
tff(fact_5887_le__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [X2: A,F3: fun(B,A),A3: set(B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3)))
        <=> ! [Y: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X2)
             => ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),aa(B,A,F3,X3)) ) ) ) ) ).

% le_SUP_iff
tff(fact_5888_SUP__subset__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),B4: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,G,X4)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,G),B4))) ) ) ) ).

% SUP_subset_mono
tff(fact_5889_SUP__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),bot_bot(set(B)))) = bot_bot(A) ) ) ).

% SUP_empty
tff(fact_5890_SUP__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [C2: A,A3: set(B)] :
          ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aTP_Lamp_uq(A,fun(B,A),C2)),A3))
          = $ite(A3 = bot_bot(set(B)),bot_bot(A),C2) ) ) ).

% SUP_constant
tff(fact_5891_SUP__UNION,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A),G: fun(C,set(B)),A3: set(C)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image(C,set(B),G),A3)))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,aa(fun(C,set(B)),fun(C,A),aTP_Lamp_ur(fun(B,A),fun(fun(C,set(B)),fun(C,A)),F3),G)),A3)) ) ) ).

% SUP_UNION
tff(fact_5892_UN__extend__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,A2: A,B4: fun(B,set(A)),C6: set(B)] :
      ( aa(set(A),set(A),insert(A,A2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6)))
      = $ite(C6 = bot_bot(set(B)),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_tm(A,fun(fun(B,set(A)),fun(B,set(A))),A2),B4)),C6))) ) ).

% UN_extend_simps(1)
tff(fact_5893_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I5: set(A),A3: fun(A,set(B)),F3: fun(B,C),A8: fun(A,set(C))] :
      ( ! [I2: A,J: A] :
          ( aa(set(A),$o,member(A,I2),I5)
         => ( aa(set(A),$o,member(A,J),I5)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),A3,I2)),aa(A,set(B),A3,J))
              | aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),A3,J)),aa(A,set(B),A3,I2)) ) ) )
     => ( ! [I2: A] :
            ( aa(set(A),$o,member(A,I2),I5)
           => bij_betw(B,C,F3,aa(A,set(B),A3,I2),aa(A,set(C),A8,I2)) )
       => bij_betw(B,C,F3,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image(A,set(C),A8),I5))) ) ) ).

% bij_betw_UNION_chain
tff(fact_5894_UNION__singleton__eq__range,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_us(fun(B,A),fun(B,set(A)),F3)),A3)) = aa(set(B),set(A),image(B,A,F3),A3) ) ).

% UNION_singleton_eq_range
tff(fact_5895_cSUP__const,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),C2: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,aTP_Lamp_ut(B,fun(A,B),C2)),A3)) = C2 ) ) ) ).

% cSUP_const
tff(fact_5896_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or3652927894154168847AtMost(A,Y2,X2)) = X2 ) ) ) ).

% cSup_greaterThanAtMost
tff(fact_5897_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or5935395276787703475ssThan(A,Y2,X2)) = X2 ) ) ) ).

% cSup_greaterThanLessThan
tff(fact_5898_Sup__nat__empty,axiom,
    aa(set(nat),nat,complete_Sup_Sup(nat),bot_bot(set(nat))) = zero_zero(nat) ).

% Sup_nat_empty
tff(fact_5899_SUP2__I,axiom,
    ! [B: $tType,A: $tType,C: $tType,A2: A,A3: set(A),B4: fun(A,fun(B,fun(C,$o))),B2: B,C2: C] :
      ( aa(set(A),$o,member(A,A2),A3)
     => ( aa(C,$o,aa(B,fun(C,$o),aa(A,fun(B,fun(C,$o)),B4,A2),B2),C2)
       => aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),aa(set(A),set(fun(B,fun(C,$o))),image(A,fun(B,fun(C,$o)),B4),A3)),B2),C2) ) ) ).

% SUP2_I
tff(fact_5900_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or7035219750837199246ssThan(A,Y2,X2)) = X2 ) ) ) ).

% cSup_atLeastLessThan
tff(fact_5901_SUP1__I,axiom,
    ! [A: $tType,B: $tType,A2: A,A3: set(A),B4: fun(A,fun(B,$o)),B2: B] :
      ( aa(set(A),$o,member(A,A2),A3)
     => ( aa(B,$o,aa(A,fun(B,$o),B4,A2),B2)
       => aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Sup_Sup(fun(B,$o)),aa(set(A),set(fun(B,$o)),image(A,fun(B,$o),B4),A3)),B2) ) ) ).

% SUP1_I
tff(fact_5902_SUP2__E,axiom,
    ! [A: $tType,C: $tType,B: $tType,B4: fun(C,fun(A,fun(B,$o))),A3: set(C),B2: A,C2: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Sup_Sup(fun(A,fun(B,$o))),aa(set(C),set(fun(A,fun(B,$o))),image(C,fun(A,fun(B,$o)),B4),A3)),B2),C2)
     => ~ ! [X4: C] :
            ( aa(set(C),$o,member(C,X4),A3)
           => ~ aa(B,$o,aa(A,fun(B,$o),aa(C,fun(A,fun(B,$o)),B4,X4),B2),C2) ) ) ).

% SUP2_E
tff(fact_5903_SUP1__E,axiom,
    ! [B: $tType,A: $tType,B4: fun(B,fun(A,$o)),A3: set(B),B2: A] :
      ( aa(A,$o,aa(set(fun(A,$o)),fun(A,$o),complete_Sup_Sup(fun(A,$o)),aa(set(B),set(fun(A,$o)),image(B,fun(A,$o),B4),A3)),B2)
     => ~ ! [X4: B] :
            ( aa(set(B),$o,member(B,X4),A3)
           => ~ aa(A,$o,aa(B,fun(A,$o),B4,X4),B2) ) ) ).

% SUP1_E
tff(fact_5904_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( condit5016429287641298734tinuum(A)
     => ! [A2: A] :
        ? [B3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B3)
          | aa(A,$o,aa(A,fun(A,$o),ord_less(A),B3),A2) ) ) ).

% ex_gt_or_lt
tff(fact_5905_complete__interval,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,P,A2)
           => ( ~ aa(A,$o,P,B2)
             => ? [C3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C3),B2)
                  & ! [X: A] :
                      ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X)
                        & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),C3) )
                     => aa(A,$o,P,X) )
                  & ! [D6: A] :
                      ( ! [X4: A] :
                          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X4)
                            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),D6) )
                         => aa(A,$o,P,X4) )
                     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D6),C3) ) ) ) ) ) ) ).

% complete_interval
tff(fact_5906_less__cSupE,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [Y2: A,X7: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),aa(set(A),A,complete_Sup_Sup(A),X7))
         => ( ( X7 != bot_bot(set(A)) )
           => ~ ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),X7)
                 => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X4) ) ) ) ) ).

% less_cSupE
tff(fact_5907_less__cSupD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Z: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),aa(set(A),A,complete_Sup_Sup(A),X7))
           => ? [X4: A] :
                ( aa(set(A),$o,member(A,X4),X7)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X4) ) ) ) ) ).

% less_cSupD
tff(fact_5908_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),X2: A,A2: A] :
          ( finite_finite2(A,X7)
         => ( aa(set(A),$o,member(A,X2),X7)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),X7)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),A2) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),X7)),A2) ) ) ) ) ).

% finite_imp_Sup_less
tff(fact_5909_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),A2: A] :
          ( finite_finite2(A,X7)
         => ( ( X7 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),X7)),A2)
            <=> ! [X3: A] :
                  ( aa(set(A),$o,member(A,X3),X7)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),A2) ) ) ) ) ) ).

% finite_Sup_less_iff
tff(fact_5910_card__UNION,axiom,
    ! [A: $tType,A3: set(set(A))] :
      ( finite_finite2(set(A),A3)
     => ( ! [X4: set(A)] :
            ( aa(set(set(A)),$o,member(set(A),X4),A3)
           => finite_finite2(A,X4) )
       => ( finite_card(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)) = aa(int,nat,nat2,aa(set(set(set(A))),int,aa(fun(set(set(A)),int),fun(set(set(set(A))),int),groups7311177749621191930dd_sum(set(set(A)),int),aTP_Lamp_uu(set(set(A)),int)),aa(fun(set(set(A)),$o),set(set(set(A))),collect(set(set(A))),aTP_Lamp_uv(set(set(A)),fun(set(set(A)),$o),A3)))) ) ) ) ).

% card_UNION
tff(fact_5911_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list(list(A)),Nb: nat] :
      ( ( ( Xs = nil(list(A)) )
       => ( Nb = zero_zero(nat) ) )
     => ( ! [I2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
           => ( aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I2)) = Nb ) )
       => ( transpose(A,Xs) = aa(list(nat),list(list(A)),map(nat,list(A),aTP_Lamp_ux(list(list(A)),fun(nat,list(A)),Xs)),upt(zero_zero(nat),Nb)) ) ) ) ).

% transpose_rectangle
tff(fact_5912_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),remdups(A,concat(A,Xss))) = finite_card(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),Xss)))) ) ).

% length_remdups_concat
tff(fact_5913_remdups__upt,axiom,
    ! [Ma: nat,Nb: nat] : ( remdups(nat,upt(Ma,Nb)) = upt(Ma,Nb) ) ).

% remdups_upt
tff(fact_5914_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X2: list(A)] :
      ( ( remdups(A,X2) = nil(A) )
    <=> ( X2 = nil(A) ) ) ).

% remdups_eq_nil_iff
tff(fact_5915_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X2: list(A)] :
      ( ( nil(A) = remdups(A,X2) )
    <=> ( X2 = nil(A) ) ) ).

% remdups_eq_nil_right_iff
tff(fact_5916_set__remdups,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),remdups(A,Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% set_remdups
tff(fact_5917_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),remdups(A,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) )
    <=> ( remdups(A,Xs) = Xs ) ) ).

% length_remdups_eq
tff(fact_5918_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( remdups(A,Xs) = Xs )
    <=> distinct(A,Xs) ) ).

% remdups_id_iff_distinct
tff(fact_5919_distinct__remdups,axiom,
    ! [A: $tType,Xs: list(A)] : distinct(A,remdups(A,Xs)) ).

% distinct_remdups
tff(fact_5920_INF__identity__eq,axiom,
    ! [A: $tType] :
      ( complete_Inf(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),image(A,A,aTP_Lamp_uy(A,A)),A3)) = aa(set(A),A,complete_Inf_Inf(A),A3) ) ) ).

% INF_identity_eq
tff(fact_5921_INT__I,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B2: B,B4: fun(A,set(B))] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),A3)
         => aa(set(B),$o,member(B,B2),aa(A,set(B),B4,X4)) )
     => aa(set(B),$o,member(B,B2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ).

% INT_I
tff(fact_5922_INT__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,B4: fun(B,set(A)),A3: set(B)] :
      ( aa(set(A),$o,member(A,B2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)))
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
         => aa(set(A),$o,member(A,B2),aa(B,set(A),B4,X3)) ) ) ).

% INT_iff
tff(fact_5923_Inf__apply,axiom,
    ! [A: $tType,B: $tType] :
      ( complete_Inf(A)
     => ! [A3: set(fun(B,A)),X2: B] : ( aa(B,A,aa(set(fun(B,A)),fun(B,A),complete_Inf_Inf(fun(B,A)),A3),X2) = aa(set(A),A,complete_Inf_Inf(A),aa(set(fun(B,A)),set(A),image(fun(B,A),A,aTP_Lamp_uz(B,fun(fun(B,A),A),X2)),A3)) ) ) ).

% Inf_apply
tff(fact_5924_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),A3) = bot_bot(A) )
        <=> ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),bot_bot(A)),X3)
             => ? [Xa: A] :
                  ( aa(set(A),$o,member(A,Xa),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),X3) ) ) ) ) ).

% Inf_eq_bot_iff
tff(fact_5925_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or7035219750837199246ssThan(A,X2,Y2)) = X2 ) ) ) ).

% Inf_atLeastLessThan
tff(fact_5926_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or7035219750837199246ssThan(A,Y2,X2)) = Y2 ) ) ) ).

% cInf_atLeastLessThan
tff(fact_5927_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or5935395276787703475ssThan(A,X2,Y2)) = X2 ) ) ) ).

% Inf_greaterThanLessThan
tff(fact_5928_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or5935395276787703475ssThan(A,Y2,X2)) = Y2 ) ) ) ).

% cInf_greaterThanLessThan
tff(fact_5929_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or3652927894154168847AtMost(A,X2,Y2)) = X2 ) ) ) ).

% Inf_greaterThanAtMost
tff(fact_5930_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or3652927894154168847AtMost(A,Y2,X2)) = Y2 ) ) ) ).

% cInf_greaterThanAtMost
tff(fact_5931_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),remdups(A,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_remdups_leq
tff(fact_5932_INF__const,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),F3: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,aTP_Lamp_tt(B,fun(A,B),F3)),A3)) = F3 ) ) ) ).

% INF_const
tff(fact_5933_ccINF__const,axiom,
    ! [A: $tType,B: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),F3: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,aTP_Lamp_ts(B,fun(A,B),F3)),A3)) = F3 ) ) ) ).

% ccINF_const
tff(fact_5934_cINF__const,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),C2: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,aTP_Lamp_ut(B,fun(A,B),C2)),A3)) = C2 ) ) ) ).

% cINF_const
tff(fact_5935_finite__INT,axiom,
    ! [B: $tType,A: $tType,I5: set(A),A3: fun(A,set(B))] :
      ( ? [X: A] :
          ( aa(set(A),$o,member(A,X),I5)
          & finite_finite2(B,aa(A,set(B),A3,X)) )
     => finite_finite2(B,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) ) ).

% finite_INT
tff(fact_5936_INF__apply,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( complete_Inf(A)
     => ! [F3: fun(C,fun(B,A)),A3: set(C),X2: B] : ( aa(B,A,aa(set(fun(B,A)),fun(B,A),complete_Inf_Inf(fun(B,A)),aa(set(C),set(fun(B,A)),image(C,fun(B,A),F3),A3)),X2) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aTP_Lamp_va(fun(C,fun(B,A)),fun(B,fun(C,A)),F3),X2)),A3)) ) ) ).

% INF_apply
tff(fact_5937_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F3: fun(B,A),A3: set(B)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3)) = bot_bot(A) )
        <=> ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),bot_bot(A)),X3)
             => ? [Xa: B] :
                  ( aa(set(B),$o,member(B,Xa),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,Xa)),X3) ) ) ) ) ).

% INF_eq_bot_iff
tff(fact_5938_INT__insert,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A2: B,A3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),aa(set(B),set(B),insert(B,A2),A3))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),B4,A2)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3))) ) ).

% INT_insert
tff(fact_5939_Compl__INT,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A3: set(B)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_vb(fun(B,set(A)),fun(B,set(A)),B4)),A3)) ) ).

% Compl_INT
tff(fact_5940_Compl__UN,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A3: set(B)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_vb(fun(B,set(A)),fun(B,set(A)),B4)),A3)) ) ).

% Compl_UN
tff(fact_5941_cInf__lessD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Z: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),X7)),Z)
           => ? [X4: A] :
                ( aa(set(A),$o,member(A,X4),X7)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z) ) ) ) ) ).

% cInf_lessD
tff(fact_5942_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A),X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),X2)
        <=> ! [Y: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y)
             => ? [X3: A] :
                  ( aa(set(A),$o,member(A,X3),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y) ) ) ) ) ).

% Inf_le_iff
tff(fact_5943_INF__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,fun(C,A)),B4: set(C),A3: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(set(C),fun(B,A),aTP_Lamp_vc(fun(B,fun(C,A)),fun(set(C),fun(B,A)),F3),B4)),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,aa(set(B),fun(C,A),aTP_Lamp_vd(fun(B,fun(C,A)),fun(set(B),fun(C,A)),F3),A3)),B4)) ) ) ).

% INF_commute
tff(fact_5944_INT__D,axiom,
    ! [A: $tType,B: $tType,B2: A,B4: fun(B,set(A)),A3: set(B),A2: B] :
      ( aa(set(A),$o,member(A,B2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)))
     => ( aa(set(B),$o,member(B,A2),A3)
       => aa(set(A),$o,member(A,B2),aa(B,set(A),B4,A2)) ) ) ).

% INT_D
tff(fact_5945_INT__E,axiom,
    ! [A: $tType,B: $tType,B2: A,B4: fun(B,set(A)),A3: set(B),A2: B] :
      ( aa(set(A),$o,member(A,B2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)))
     => ( ~ aa(set(A),$o,member(A,B2),aa(B,set(A),B4,A2))
       => ~ aa(set(B),$o,member(B,A2),A3) ) ) ).

% INT_E
tff(fact_5946_Inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Inf(B)
     => ! [A3: set(fun(A,B)),X: A] : ( aa(A,B,aa(set(fun(A,B)),fun(A,B),complete_Inf_Inf(fun(A,B)),A3),X) = aa(set(B),B,complete_Inf_Inf(B),aa(set(fun(A,B)),set(B),image(fun(A,B),B,aTP_Lamp_ve(A,fun(fun(A,B),B),X)),A3)) ) ) ).

% Inf_fun_def
tff(fact_5947_Pow__INT__eq,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A3: set(B)] : ( pow2(A,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3))) = aa(set(set(set(A))),set(set(A)),complete_Inf_Inf(set(set(A))),aa(set(B),set(set(set(A))),image(B,set(set(A)),aTP_Lamp_up(fun(B,set(A)),fun(B,set(set(A))),B4)),A3)) ) ).

% Pow_INT_eq
tff(fact_5948_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),X2: A,A2: A] :
          ( finite_finite2(A,X7)
         => ( aa(set(A),$o,member(A,X2),X7)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),X7)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X4) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(set(A),A,complete_Inf_Inf(A),X7)) ) ) ) ) ).

% finite_imp_less_Inf
tff(fact_5949_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => ( remdups(A,Xs) = Xs ) ) ).

% distinct_remdups_id
tff(fact_5950_remdups__remdups,axiom,
    ! [A: $tType,Xs: list(A)] : ( remdups(A,remdups(A,Xs)) = remdups(A,Xs) ) ).

% remdups_remdups
tff(fact_5951_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] : ( remdups(A,aa(list(B),list(A),map(B,A,F3),remdups(B,Xs))) = remdups(A,aa(list(B),list(A),map(B,A,F3),Xs)) ) ).

% remdups_map_remdups
tff(fact_5952_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [S3: set(A),A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),S3)),A2)
        <=> ? [X3: A] :
              ( aa(set(A),$o,member(A,X3),S3)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),A2) ) ) ) ).

% Inf_less_iff
tff(fact_5953_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] : ( remdups(A,nil(A)) = nil(A) ) ).

% remdups.simps(1)
tff(fact_5954_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] : ( transpose(A,nil(list(A))) = nil(list(A)) ) ).

% transpose.simps(1)
tff(fact_5955_INF__greatest,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),U: B,F3: fun(A,B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(A,B,F3,I2)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ).

% INF_greatest
tff(fact_5956_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [U: A,F3: fun(B,A),A3: set(B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3)))
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(B,A,F3,X3)) ) ) ) ).

% le_INF_iff
tff(fact_5957_INF__lower2,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I3: A,A3: set(A),F3: fun(A,B),U: B] :
          ( aa(set(A),$o,member(A,I3),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I3)),U)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),U) ) ) ) ).

% INF_lower2
tff(fact_5958_INF__mono_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F3: fun(A,B),G: fun(A,B),A3: set(A)] :
          ( ! [X4: A] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,G,X4))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,G),A3))) ) ) ).

% INF_mono'
tff(fact_5959_INF__lower,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I3: A,A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,member(A,I3),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(A,B,F3,I3)) ) ) ).

% INF_lower
tff(fact_5960_INF__mono,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [B4: set(A),A3: set(B),F3: fun(B,C),G: fun(A,C)] :
          ( ! [M3: A] :
              ( aa(set(A),$o,member(A,M3),B4)
             => ? [X: B] :
                  ( aa(set(B),$o,member(B,X),A3)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F3,X)),aa(A,C,G,M3)) ) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image(B,C,F3),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(A),set(C),image(A,C,G),B4))) ) ) ).

% INF_mono
tff(fact_5961_INF__eqI,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),X2: B,F3: fun(A,B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(A,B,F3,I2)) )
         => ( ! [Y4: B] :
                ( ! [I4: A] :
                    ( aa(set(A),$o,member(A,I4),A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y4),aa(A,B,F3,I4)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y4),X2) )
           => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3)) = X2 ) ) ) ) ).

% INF_eqI
tff(fact_5962_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Y2: A,F3: fun(B,A),A3: set(B),I3: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3)))
         => ( aa(set(B),$o,member(B,I3),A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),aa(B,A,F3,I3)) ) ) ) ).

% less_INF_D
tff(fact_5963_INF__less__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F3: fun(B,A),A3: set(B),A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))),A2)
        <=> ? [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,X3)),A2) ) ) ) ).

% INF_less_iff
tff(fact_5964_INF__absorb,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [K: A,I5: set(A),A3: fun(A,B)] :
          ( aa(set(A),$o,member(A,K),I5)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,A3,K)),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,A3),I5))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,A3),I5)) ) ) ) ).

% INF_absorb
tff(fact_5965_INF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A),A3: set(B),G: fun(B,A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,G),A3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vf(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G)),A3)) ) ) ).

% INF_inf_distrib
tff(fact_5966_INT__extend__simps_I10_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,B4: fun(C,set(A)),F3: fun(B,C),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,C),fun(B,set(A)),aTP_Lamp_ug(fun(C,set(A)),fun(fun(B,C),fun(B,set(A))),B4),F3)),A3)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),B4),aa(set(B),set(C),image(B,C,F3),A3))) ) ).

% INT_extend_simps(10)
tff(fact_5967_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B4: set(A),A3: fun(B,set(A)),I5: set(B)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5)))
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),I5)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),aa(B,set(A),A3,X3)) ) ) ).

% INT_subset_iff
tff(fact_5968_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B4: set(A),F3: fun(A,set(B)),G: fun(A,set(B))] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B4)
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),A3)
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F3,X4)),aa(A,set(B),G,X4)) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),F3),B4))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),G),A3))) ) ) ).

% INT_anti_mono
tff(fact_5969_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set(A),C6: set(B),B4: fun(A,set(B))] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),A3)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C6),aa(A,set(B),B4,X4)) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C6),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ).

% INT_greatest
tff(fact_5970_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set(A),B4: fun(A,set(B))] :
      ( aa(set(A),$o,member(A,A2),A3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))),aa(A,set(B),B4,A2)) ) ).

% INT_lower
tff(fact_5971_INT__extend__simps_I5_J,axiom,
    ! [A: $tType,B: $tType,A2: A,B4: fun(B,set(A)),C6: set(B)] : ( aa(set(A),set(A),insert(A,A2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_tm(A,fun(fun(B,set(A)),fun(B,set(A))),A2),B4)),C6)) ) ).

% INT_extend_simps(5)
tff(fact_5972_INT__insert__distrib,axiom,
    ! [B: $tType,A: $tType,U: A,A3: set(A),A2: B,B4: fun(A,set(B))] :
      ( aa(set(A),$o,member(A,U),A3)
     => ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_uj(B,fun(fun(A,set(B)),fun(A,set(B))),A2),B4)),A3)) = aa(set(B),set(B),insert(B,A2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ) ).

% INT_insert_distrib
tff(fact_5973_sorted__remdups,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),remdups(A,Xs)) ) ) ).

% sorted_remdups
tff(fact_5974_INT__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I5: set(A),A3: fun(A,set(B))] :
      ( aa(set(A),$o,member(A,K),I5)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),A3,K)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5)) ) ) ).

% INT_absorb
tff(fact_5975_INT__Int__distrib,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),B4: fun(B,set(A)),I5: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_vg(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),I5)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),I5))) ) ).

% INT_Int_distrib
tff(fact_5976_Int__Inter__image,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),B4: fun(B,set(A)),C6: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_vg(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6))) ) ).

% Int_Inter_image
tff(fact_5977_INT__extend__simps_I9_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,C6: fun(C,set(A)),B4: fun(B,set(C)),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(C)),fun(B,set(A)),aTP_Lamp_vh(fun(C,set(A)),fun(fun(B,set(C)),fun(B,set(A))),C6),B4)),A3)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),C6),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image(B,set(C),B4),A3)))) ) ).

% INT_extend_simps(9)
tff(fact_5978_remove1__remdups,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( remove1(A,X2,remdups(A,Xs)) = remdups(A,remove1(A,X2,Xs)) ) ) ).

% remove1_remdups
tff(fact_5979_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F3: fun(B,A),A3: set(B),X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))),X2)
        <=> ! [Y: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y)
             => ? [X3: B] :
                  ( aa(set(B),$o,member(B,X3),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,X3)),Y) ) ) ) ) ).

% INF_le_iff
tff(fact_5980_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),A2: A] :
          ( finite_finite2(A,X7)
         => ( ( X7 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(set(A),A,complete_Inf_Inf(A),X7))
            <=> ! [X3: A] :
                  ( aa(set(A),$o,member(A,X3),X7)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X3) ) ) ) ) ) ).

% finite_less_Inf_iff
tff(fact_5981_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(list(B))] : ( transpose(A,aa(list(list(B)),list(list(A)),map(list(B),list(A),map(B,A,F3)),Xs)) = aa(list(list(B)),list(list(A)),map(list(B),list(A),map(B,A,F3)),transpose(B,Xs)) ) ).

% transpose_map_map
tff(fact_5982_INF__superset__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [B4: set(A),A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B4),A3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),B4)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,G,X4)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,G),B4))) ) ) ) ).

% INF_superset_mono
tff(fact_5983_uminus__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple489889107523837845lgebra(A)
     => ! [B4: fun(B,A),A3: set(B)] : ( aa(A,A,uminus_uminus(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,B4),A3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aTP_Lamp_vi(fun(B,A),fun(B,A),B4)),A3)) ) ) ).

% uminus_SUP
tff(fact_5984_uminus__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( comple489889107523837845lgebra(A)
     => ! [B4: fun(B,A),A3: set(B)] : ( aa(A,A,uminus_uminus(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,B4),A3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aTP_Lamp_vi(fun(B,A),fun(B,A),B4)),A3)) ) ) ).

% uminus_INF
tff(fact_5985_INF__inf__const2,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I5: set(A),F3: fun(A,B),X2: B] :
          ( ( I5 != bot_bot(set(A)) )
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,aa(B,fun(A,B),aTP_Lamp_vj(fun(A,B),fun(B,fun(A,B)),F3),X2)),I5)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),I5))),X2) ) ) ) ).

% INF_inf_const2
tff(fact_5986_INF__inf__const1,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I5: set(A),X2: B,F3: fun(A,B)] :
          ( ( I5 != bot_bot(set(A)) )
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vk(B,fun(fun(A,B),fun(A,B)),X2),F3)),I5)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),I5))) ) ) ) ).

% INF_inf_const1
tff(fact_5987_INF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A),A2: B,A3: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),aa(set(B),set(B),insert(B,A2),A3))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,F3,A2)),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))) ) ) ).

% INF_insert
tff(fact_5988_INT__extend__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C6: set(B),B4: set(A)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4)
      = $ite(C6 = bot_bot(set(B)),B4,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_un(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6))) ) ).

% INT_extend_simps(1)
tff(fact_5989_INT__extend__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6)))
      = $ite(C6 = bot_bot(set(B)),A3,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_um(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6))) ) ).

% INT_extend_simps(2)
tff(fact_5990_UN__extend__simps_I7_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_vl(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6)) ) ).

% UN_extend_simps(7)
tff(fact_5991_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),remdups(A,Xs)) = finite_card(A,aa(list(A),set(A),set2(A),Xs)) ) ).

% length_remdups_card_conv
tff(fact_5992_INT__extend__simps_I8_J,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A3: set(set(B))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(B)),set(set(A)),image(set(B),set(A),aTP_Lamp_vm(fun(B,set(A)),fun(set(B),set(A)),B4)),A3)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A3))) ) ).

% INT_extend_simps(8)
tff(fact_5993_Int__Inter__eq_I1_J,axiom,
    ! [A: $tType,A3: set(A),B11: set(set(A))] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B11))
      = $ite(B11 = bot_bot(set(set(A))),A3,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),image(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3)),B11))) ) ).

% Int_Inter_eq(1)
tff(fact_5994_Int__Inter__eq_I2_J,axiom,
    ! [A: $tType,B11: set(set(A)),A3: set(A)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B11)),A3)
      = $ite(B11 = bot_bot(set(set(A))),A3,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),image(set(A),set(A),aTP_Lamp_uc(set(A),fun(set(A),set(A)),A3)),B11))) ) ).

% Int_Inter_eq(2)
tff(fact_5995_transpose__empty,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( ( transpose(A,Xs) = nil(list(A)) )
    <=> ! [X3: list(A)] :
          ( aa(set(list(A)),$o,member(list(A),X3),aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
         => ( X3 = nil(A) ) ) ) ).

% transpose_empty
tff(fact_5996_INT__extend__simps_I4_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6)))
      = $ite(C6 = bot_bot(set(B)),A3,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_vl(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6))) ) ).

% INT_extend_simps(4)
tff(fact_5997_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),Xs: list(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(list(B),set(B),set2(B),Xs)) = groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,G),remdups(B,Xs))) ) ) ).

% sum_code
tff(fact_5998_length__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)) = aa(nat,nat,foldr(list(A),nat,aTP_Lamp_vn(list(A),fun(nat,nat)),Xs),zero_zero(nat)) ) ).

% length_transpose
tff(fact_5999_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: A,B4: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Inf_Inf(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_vo(A,fun(nat,A),B4)),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B4) ) ) ).

% INF_nat_binary
tff(fact_6000_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs))
        = $ite(Xs = nil(list(A)),zero_zero(nat),aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),zero_zero(nat)))) ) ) ).

% length_transpose_sorted
tff(fact_6001_UN__UN__split__split__eq,axiom,
    ! [D: $tType,E4: $tType,A: $tType,C: $tType,B: $tType,A3: fun(B,fun(C,fun(D,fun(E4,set(A))))),Y5: set(product_prod(D,E4)),X7: set(product_prod(B,C))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(B,C)),set(set(A)),image(product_prod(B,C),set(A),aa(fun(B,fun(C,set(A))),fun(product_prod(B,C),set(A)),product_case_prod(B,C,set(A)),aa(set(product_prod(D,E4)),fun(B,fun(C,set(A))),aTP_Lamp_vp(fun(B,fun(C,fun(D,fun(E4,set(A))))),fun(set(product_prod(D,E4)),fun(B,fun(C,set(A)))),A3),Y5))),X7)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(B,C)),set(set(A)),image(product_prod(B,C),set(A),aa(set(product_prod(D,E4)),fun(product_prod(B,C),set(A)),aTP_Lamp_vs(fun(B,fun(C,fun(D,fun(E4,set(A))))),fun(set(product_prod(D,E4)),fun(product_prod(B,C),set(A))),A3),Y5)),X7)) ) ).

% UN_UN_split_split_eq
tff(fact_6002_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),list(A),rev(A),Xs) = aa(list(A),list(A),rev(A),Ys) )
    <=> ( Xs = Ys ) ) ).

% rev_is_rev_conv
tff(fact_6003_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),list(A),rev(A),aa(list(A),list(A),rev(A),Xs)) = Xs ) ).

% rev_rev_ident
tff(fact_6004_INF2__I,axiom,
    ! [B: $tType,A: $tType,C: $tType,A3: set(A),B4: fun(A,fun(B,fun(C,$o))),B2: B,C2: C] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),A3)
         => aa(C,$o,aa(B,fun(C,$o),aa(A,fun(B,fun(C,$o)),B4,X4),B2),C2) )
     => aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),aa(set(A),set(fun(B,fun(C,$o))),image(A,fun(B,fun(C,$o)),B4),A3)),B2),C2) ) ).

% INF2_I
tff(fact_6005_INF1__I,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(A,fun(B,$o)),B2: B] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),A3)
         => aa(B,$o,aa(A,fun(B,$o),B4,X4),B2) )
     => aa(B,$o,aa(set(fun(B,$o)),fun(B,$o),complete_Inf_Inf(fun(B,$o)),aa(set(A),set(fun(B,$o)),image(A,fun(B,$o),B4),A3)),B2) ) ).

% INF1_I
tff(fact_6006_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),list(A),rev(A),Xs) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% rev_is_Nil_conv
tff(fact_6007_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( nil(A) = aa(list(A),list(A),rev(A),Xs) )
    <=> ( Xs = nil(A) ) ) ).

% Nil_is_rev_conv
tff(fact_6008_set__rev,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% set_rev
tff(fact_6009_length__rev,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_rev
tff(fact_6010_distinct__rev,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,aa(list(A),list(A),rev(A),Xs))
    <=> distinct(A,Xs) ) ).

% distinct_rev
tff(fact_6011_rev__replicate,axiom,
    ! [A: $tType,Nb: nat,X2: A] : ( aa(list(A),list(A),rev(A),replicate(A,Nb,X2)) = replicate(A,Nb,X2) ) ).

% rev_replicate
tff(fact_6012_Inf__real__def,axiom,
    ! [X7: set(real)] : ( aa(set(real),real,complete_Inf_Inf(real),X7) = aa(real,real,uminus_uminus(real),aa(set(real),real,complete_Sup_Sup(real),aa(set(real),set(real),image(real,real,uminus_uminus(real)),X7))) ) ).

% Inf_real_def
tff(fact_6013_INF1__D,axiom,
    ! [B: $tType,A: $tType,B4: fun(B,fun(A,$o)),A3: set(B),B2: A,A2: B] :
      ( aa(A,$o,aa(set(fun(A,$o)),fun(A,$o),complete_Inf_Inf(fun(A,$o)),aa(set(B),set(fun(A,$o)),image(B,fun(A,$o),B4),A3)),B2)
     => ( aa(set(B),$o,member(B,A2),A3)
       => aa(A,$o,aa(B,fun(A,$o),B4,A2),B2) ) ) ).

% INF1_D
tff(fact_6014_INF1__E,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,fun(A,$o)),A3: set(B),B2: A,A2: B] :
      ( aa(A,$o,aa(set(fun(A,$o)),fun(A,$o),complete_Inf_Inf(fun(A,$o)),aa(set(B),set(fun(A,$o)),image(B,fun(A,$o),B4),A3)),B2)
     => ( ~ aa(A,$o,aa(B,fun(A,$o),B4,A2),B2)
       => ~ aa(set(B),$o,member(B,A2),A3) ) ) ).

% INF1_E
tff(fact_6015_INF2__D,axiom,
    ! [A: $tType,C: $tType,B: $tType,B4: fun(C,fun(A,fun(B,$o))),A3: set(C),B2: A,C2: B,A2: C] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Inf_Inf(fun(A,fun(B,$o))),aa(set(C),set(fun(A,fun(B,$o))),image(C,fun(A,fun(B,$o)),B4),A3)),B2),C2)
     => ( aa(set(C),$o,member(C,A2),A3)
       => aa(B,$o,aa(A,fun(B,$o),aa(C,fun(A,fun(B,$o)),B4,A2),B2),C2) ) ) ).

% INF2_D
tff(fact_6016_INF2__E,axiom,
    ! [B: $tType,A: $tType,C: $tType,B4: fun(C,fun(A,fun(B,$o))),A3: set(C),B2: A,C2: B,A2: C] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Inf_Inf(fun(A,fun(B,$o))),aa(set(C),set(fun(A,fun(B,$o))),image(C,fun(A,fun(B,$o)),B4),A3)),B2),C2)
     => ( ~ aa(B,$o,aa(A,fun(B,$o),aa(C,fun(A,fun(B,$o)),B4,A2),B2),C2)
       => ~ aa(set(C),$o,member(C,A2),A3) ) ) ).

% INF2_E
tff(fact_6017_rev__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(A),list(A),rev(A),concat(A,Xs)) = concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),rev(A)),aa(list(list(A)),list(list(A)),rev(list(A)),Xs))) ) ).

% rev_concat
tff(fact_6018_rev__map,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] : ( aa(list(A),list(A),rev(A),aa(list(B),list(A),map(B,A,F3),Xs)) = aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),rev(B),Xs)) ) ).

% rev_map
tff(fact_6019_rev_Osimps_I1_J,axiom,
    ! [A: $tType] : ( aa(list(A),list(A),rev(A),nil(A)) = nil(A) ) ).

% rev.simps(1)
tff(fact_6020_sorted__wrt__rev,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xs: list(A)] :
      ( sorted_wrt(A,P,aa(list(A),list(A),rev(A),Xs))
    <=> sorted_wrt(A,aTP_Lamp_vt(fun(A,fun(A,$o)),fun(A,fun(A,$o)),P),Xs) ) ).

% sorted_wrt_rev
tff(fact_6021_rev__swap,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),list(A),rev(A),Xs) = Ys )
    <=> ( Xs = aa(list(A),list(A),rev(A),Ys) ) ) ).

% rev_swap
tff(fact_6022_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set(set(product_prod(A,B))),X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Inf_Inf(fun(A,fun(B,$o))),aa(set(set(product_prod(A,B))),set(fun(A,fun(B,$o))),image(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o)))),S3)),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),S3)) ) ).

% INF_Int_eq2
tff(fact_6023_INF__Int__eq,axiom,
    ! [A: $tType,S3: set(set(A)),X: A] :
      ( aa(A,$o,aa(set(fun(A,$o)),fun(A,$o),complete_Inf_Inf(fun(A,$o)),aa(set(set(A)),set(fun(A,$o)),image(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o))),S3)),X)
    <=> aa(set(A),$o,member(A,X),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),S3)) ) ).

% INF_Int_eq
tff(fact_6024_INF__INT__eq,axiom,
    ! [A: $tType,B: $tType,R: fun(B,set(A)),S3: set(B),X: A] :
      ( aa(A,$o,aa(set(fun(A,$o)),fun(A,$o),complete_Inf_Inf(fun(A,$o)),aa(set(B),set(fun(A,$o)),image(B,fun(A,$o),aTP_Lamp_tx(fun(B,set(A)),fun(B,fun(A,$o)),R)),S3)),X)
    <=> aa(set(A),$o,member(A,X),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),R),S3))) ) ).

% INF_INT_eq
tff(fact_6025_Inf__set__def,axiom,
    ! [A: $tType,A3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_vu(set(set(A)),fun(A,$o),A3)) ) ).

% Inf_set_def
tff(fact_6026_INF__INT__eq2,axiom,
    ! [A: $tType,B: $tType,C: $tType,R: fun(C,set(product_prod(A,B))),S3: set(C),X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Inf_Inf(fun(A,fun(B,$o))),aa(set(C),set(fun(A,fun(B,$o))),image(C,fun(A,fun(B,$o)),aTP_Lamp_tw(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,$o))),R)),S3)),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),aa(set(C),set(set(product_prod(A,B))),image(C,set(product_prod(A,B)),R),S3))) ) ).

% INF_INT_eq2
tff(fact_6027_rev__nth,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),rev(A),Xs)),Nb) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,nat,suc,Nb))) ) ) ).

% rev_nth
tff(fact_6028_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list(A),Y2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),list(A),rev(A),list_update(A,Xs,K,Y2)) = list_update(A,aa(list(A),list(A),rev(A),Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),K)),one_one(nat)),Y2) ) ) ).

% rev_update
tff(fact_6029_sorted__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),transpose(A,Xs)))) ).

% sorted_transpose
tff(fact_6030_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),Xs))
        <=> ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I))),aa(nat,A,nth(A,Xs),I)) ) ) ) ).

% sorted_rev_iff_nth_Suc
tff(fact_6031_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),Xs))
        <=> ! [I: nat,J4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J4)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),J4)),aa(nat,A,nth(A,Xs),I)) ) ) ) ) ).

% sorted_rev_iff_nth_mono
tff(fact_6032_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I3: nat,J2: nat] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),Xs))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),J2)),aa(nat,A,nth(A,Xs),I3)) ) ) ) ) ).

% sorted_rev_nth_mono
tff(fact_6033_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set(fun(A,fun(B,$o))),X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(fun(A,fun(B,$o))),fun(A,fun(B,$o)),complete_Inf_Inf(fun(A,fun(B,$o))),S3),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),aa(set(fun(product_prod(A,B),$o)),set(set(product_prod(A,B))),image(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B))),aa(set(fun(A,fun(B,$o))),set(fun(product_prod(A,B),$o)),image(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o)),S3)))) ) ).

% Inf_INT_eq2
tff(fact_6034_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Y2: A] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),Xs))
         => ( aa(A,A,foldr(A,A,ord_max(A),Xs),Y2)
            = $ite(Xs = nil(A),Y2,aa(A,A,aa(A,fun(A,A),ord_max(A),aa(nat,A,nth(A,Xs),zero_zero(nat))),Y2)) ) ) ) ).

% foldr_max_sorted
tff(fact_6035_UN__constant__eq,axiom,
    ! [A: $tType,B: $tType,A2: A,A3: set(A),F3: fun(A,set(B)),C2: set(B)] :
      ( aa(set(A),$o,member(A,A2),A3)
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),A3)
           => ( aa(A,set(B),F3,X4) = C2 ) )
       => ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),F3),A3)) = C2 ) ) ) ).

% UN_constant_eq
tff(fact_6036_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A)),I3: nat,J2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_vv(nat,fun(list(A),$o),I3)),Xs)))
         => ( aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),transpose(A,Xs)),I3)),J2) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Xs),J2)),I3) ) ) ) ) ).

% nth_nth_transpose_sorted
tff(fact_6037_transpose__column,axiom,
    ! [A: $tType,Xs: list(list(A)),I3: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
       => ( aa(list(list(A)),list(A),map(list(A),A,aTP_Lamp_vw(nat,fun(list(A),A),I3)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_vv(nat,fun(list(A),$o),I3)),transpose(A,Xs))) = aa(nat,list(A),nth(list(A),Xs),I3) ) ) ) ).

% transpose_column
tff(fact_6038_filter__filter,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o),Xs: list(A)] : ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),filter2(A,Q),Xs)) = aa(list(A),list(A),filter2(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_vx(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q)),Xs) ) ).

% filter_filter
tff(fact_6039_filter__True,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X4) )
     => ( aa(list(A),list(A),filter2(A,P),Xs) = Xs ) ) ).

% filter_True
tff(fact_6040_remove1__filter__not,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A)] :
      ( ~ aa(A,$o,P,X2)
     => ( remove1(A,X2,aa(list(A),list(A),filter2(A,P),Xs)) = aa(list(A),list(A),filter2(A,P),Xs) ) ) ).

% remove1_filter_not
tff(fact_6041_removeAll__filter__not,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A)] :
      ( ~ aa(A,$o,P,X2)
     => ( aa(list(A),list(A),removeAll(A,X2),aa(list(A),list(A),filter2(A,P),Xs)) = aa(list(A),list(A),filter2(A,P),Xs) ) ) ).

% removeAll_filter_not
tff(fact_6042_set__filter,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,P),Xs)) = aa(fun(A,$o),set(A),collect(A),aa(list(A),fun(A,$o),aTP_Lamp_vy(fun(A,$o),fun(list(A),fun(A,$o)),P),Xs)) ) ).

% set_filter
tff(fact_6043_filter__False,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => ~ aa(A,$o,P,X4) )
     => ( aa(list(A),list(A),filter2(A,P),Xs) = nil(A) ) ) ).

% filter_False
tff(fact_6044_length__concat__rev,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),concat(A,aa(list(list(A)),list(list(A)),rev(list(A)),Xs))) = aa(list(A),nat,size_size(list(A)),concat(A,Xs)) ) ).

% length_concat_rev
tff(fact_6045_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F3: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),aa(list(B),list(A),map(B,A,F3),Xs))) = aa(list(B),nat,size_size(list(B)),aa(list(B),list(B),filter2(B,aa(fun(B,A),fun(B,$o),comp(A,$o,B,P),F3)),Xs)) ) ).

% length_filter_map
tff(fact_6046_remdups__filter,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( remdups(A,aa(list(A),list(A),filter2(A,P),Xs)) = aa(list(A),list(A),filter2(A,P),remdups(A,Xs)) ) ).

% remdups_filter
tff(fact_6047_rev__filter,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( aa(list(A),list(A),rev(A),aa(list(A),list(A),filter2(A,P),Xs)) = aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),rev(A),Xs)) ) ).

% rev_filter
tff(fact_6048_filter__shuffles,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Ys: list(A)] : ( aa(set(list(A)),set(list(A)),image(list(A),list(A),filter2(A,P)),shuffles(A,Xs,Ys)) = shuffles(A,aa(list(A),list(A),filter2(A,P),Xs),aa(list(A),list(A),filter2(A,P),Ys)) ) ).

% filter_shuffles
tff(fact_6049_replicate__length__filter,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( replicate(A,aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aa(A,fun(A,$o),fequal(A),X2)),Xs)),X2) = aa(list(A),list(A),filter2(A,aa(A,fun(A,$o),fequal(A),X2)),Xs) ) ).

% replicate_length_filter
tff(fact_6050_sorted__same,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [G: fun(list(A),A),Xs: list(A)] : sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),filter2(A,aa(list(A),fun(A,$o),aTP_Lamp_vz(fun(list(A),A),fun(list(A),fun(A,$o)),G),Xs)),Xs)) ) ).

% sorted_same
tff(fact_6051_filter__is__subset,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),set(A),set2(A),Xs)) ).

% filter_is_subset
tff(fact_6052_length__filter__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_filter_le
tff(fact_6053_removeAll__filter__not__eq,axiom,
    ! [A: $tType,X2: A] : ( removeAll(A,X2) = filter2(A,aa(A,fun(A,$o),aTP_Lamp_wa(A,fun(A,$o)),X2)) ) ).

% removeAll_filter_not_eq
tff(fact_6054_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] : aa(set(list(A)),$o,member(list(A),Xs),shuffles(A,aa(list(A),list(A),filter2(A,P),Xs),aa(list(A),list(A),filter2(A,aTP_Lamp_ed(fun(A,$o),fun(A,$o),P)),Xs))) ).

% partition_in_shuffles
tff(fact_6055_distinct__filter,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( distinct(A,Xs)
     => distinct(A,aa(list(A),list(A),filter2(A,P),Xs)) ) ).

% distinct_filter
tff(fact_6056_filter__cong,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( ( Xs = Ys )
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Ys))
           => ( aa(A,$o,P,X4)
            <=> aa(A,$o,Q,X4) ) )
       => ( aa(list(A),list(A),filter2(A,P),Xs) = aa(list(A),list(A),filter2(A,Q),Ys) ) ) ) ).

% filter_cong
tff(fact_6057_filter__id__conv,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( aa(list(A),list(A),filter2(A,P),Xs) = Xs )
    <=> ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X3) ) ) ).

% filter_id_conv
tff(fact_6058_sorted__wrt__filter,axiom,
    ! [A: $tType,F3: fun(A,fun(A,$o)),Xs: list(A),P: fun(A,$o)] :
      ( sorted_wrt(A,F3,Xs)
     => sorted_wrt(A,F3,aa(list(A),list(A),filter2(A,P),Xs)) ) ).

% sorted_wrt_filter
tff(fact_6059_filter__remove1,axiom,
    ! [A: $tType,Q: fun(A,$o),X2: A,Xs: list(A)] : ( aa(list(A),list(A),filter2(A,Q),remove1(A,X2,Xs)) = remove1(A,X2,aa(list(A),list(A),filter2(A,Q),Xs)) ) ).

% filter_remove1
tff(fact_6060_filter__insort__triv,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [P: fun(A,$o),X2: A,F3: fun(A,B),Xs: list(A)] :
          ( ~ aa(A,$o,P,X2)
         => ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),X2),Xs)) = aa(list(A),list(A),filter2(A,P),Xs) ) ) ) ).

% filter_insort_triv
tff(fact_6061_inter__set__filter,axiom,
    ! [A: $tType,A3: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3)),Xs)) ) ).

% inter_set_filter
tff(fact_6062_sum__length__filter__compl,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,aTP_Lamp_ed(fun(A,$o),fun(A,$o),P)),Xs))) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% sum_length_filter_compl
tff(fact_6063_empty__filter__conv,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( nil(A) = aa(list(A),list(A),filter2(A,P),Xs) )
    <=> ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
         => ~ aa(A,$o,P,X3) ) ) ).

% empty_filter_conv
tff(fact_6064_filter__empty__conv,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( aa(list(A),list(A),filter2(A,P),Xs) = nil(A) )
    <=> ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
         => ~ aa(A,$o,P,X3) ) ) ).

% filter_empty_conv
tff(fact_6065_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,$o)] : ( aa(list(A),list(A),filter2(A,P),nil(A)) = nil(A) ) ).

% filter.simps(1)
tff(fact_6066_filter__replicate,axiom,
    ! [A: $tType,P: fun(A,$o),Nb: nat,X2: A] :
      ( aa(list(A),list(A),filter2(A,P),replicate(A,Nb,X2))
      = $ite(aa(A,$o,P,X2),replicate(A,Nb,X2),nil(A)) ) ).

% filter_replicate
tff(fact_6067_filter__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F3: fun(B,A),Xs: list(B)] : ( aa(list(A),list(A),filter2(A,P),aa(list(B),list(A),map(B,A,F3),Xs)) = aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),filter2(B,aa(fun(B,A),fun(B,$o),comp(A,$o,B,P),F3)),Xs)) ) ).

% filter_map
tff(fact_6068_filter__concat,axiom,
    ! [A: $tType,P2: fun(A,$o),Xs: list(list(A))] : ( aa(list(A),list(A),filter2(A,P2),concat(A,Xs)) = concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),filter2(A,P2)),Xs)) ) ).

% filter_concat
tff(fact_6069_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B),P: fun(B,$o)] :
      ( distinct(A,aa(list(B),list(A),map(B,A,F3),Xs))
     => distinct(A,aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),filter2(B,P),Xs))) ) ).

% distinct_map_filter
tff(fact_6070_length__filter__less,axiom,
    ! [A: $tType,X2: A,Xs: list(A),P: fun(A,$o)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( ~ aa(A,$o,P,X2)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% length_filter_less
tff(fact_6071_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),P: fun(B,$o)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),Xs))
         => sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),filter2(B,P),Xs))) ) ) ).

% sorted_filter
tff(fact_6072_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),G: fun(list(B),A),Xs: list(B)] : sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),filter2(B,aa(list(B),fun(B,$o),aa(fun(list(B),A),fun(list(B),fun(B,$o)),aTP_Lamp_wb(fun(B,A),fun(fun(list(B),A),fun(list(B),fun(B,$o))),F3),G),Xs)),Xs))) ) ).

% sorted_map_same
tff(fact_6073_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( monoid_add(A)
     => ! [F3: fun(B,A),P: fun(B,$o),Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),filter2(B,P),Xs))) = groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,$o),fun(B,A),aTP_Lamp_wc(fun(B,A),fun(fun(B,$o),fun(B,A)),F3),P)),Xs)) ) ) ).

% sum_list_map_filter'
tff(fact_6074_sum__list__map__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(B)
     => ! [Xs: list(A),P: fun(A,$o),F3: fun(A,B)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
             => ( ~ aa(A,$o,P,X4)
               => ( aa(A,B,F3,X4) = zero_zero(B) ) ) )
         => ( groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F3),aa(list(A),list(A),filter2(A,P),Xs))) = groups8242544230860333062m_list(B,aa(list(A),list(B),map(A,B,F3),Xs)) ) ) ) ).

% sum_list_map_filter
tff(fact_6075_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),P: fun(B,$o),X2: B] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(B),list(A),map(B,A,F3),Xs))
         => ( aa(B,$o,P,X2)
           => ( aa(list(B),list(B),filter2(B,P),aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F3),X2),Xs)) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),linorder_insort_key(B,A,F3),X2),aa(list(B),list(B),filter2(B,P),Xs)) ) ) ) ) ).

% filter_insort
tff(fact_6076_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list(A),Y2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,Y2),bot_bot(set(A)))) = aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,aTP_Lamp_wd(A,fun(A,$o),Y2)),Xs)) ) ).

% set_minus_filter_out
tff(fact_6077_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_we(list(A),fun(A,$o),Xs)),Zs) = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
tff(fact_6078_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_wf(list(A),fun(A,$o),Xs)),Zs) = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
tff(fact_6079_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_we(list(A),fun(A,$o),Ys)),Zs) = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
tff(fact_6080_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
       => ( aa(list(A),list(A),filter2(A,aTP_Lamp_wf(list(A),fun(A,$o),Ys)),Zs) = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
tff(fact_6081_length__filter__conv__card,axiom,
    ! [A: $tType,P2: fun(A,$o),Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P2),Xs)) = finite_card(nat,aa(fun(nat,$o),set(nat),collect(nat),aa(list(A),fun(nat,$o),aTP_Lamp_wg(fun(A,$o),fun(list(A),fun(nat,$o)),P2),Xs))) ) ).

% length_filter_conv_card
tff(fact_6082_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( distinct(A,Xs)
     => ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),filter2(A,P),Xs)) = finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(fun(A,$o),set(A),collect(A),P)),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% distinct_length_filter
tff(fact_6083_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Xss: list(list(B))] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs))),aa(nat,nat,foldr(list(B),nat,aTP_Lamp_wh(list(B),fun(nat,nat)),Xss),zero_zero(nat))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,nat,foldr(list(B),nat,aTP_Lamp_wi(list(B),fun(nat,nat)),aa(list(list(B)),list(list(B)),filter2(list(B),aTP_Lamp_wj(list(B),$o)),Xss)),zero_zero(nat)))) ) ).

% transpose_aux_max
tff(fact_6084_nth__transpose,axiom,
    ! [A: $tType,I3: nat,Xs: list(list(A))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)))
     => ( aa(nat,list(A),nth(list(A),transpose(A,Xs)),I3) = aa(list(list(A)),list(A),map(list(A),A,aTP_Lamp_vw(nat,fun(list(A),A),I3)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_vv(nat,fun(list(A),$o),I3)),Xs)) ) ) ).

% nth_transpose
tff(fact_6085_transpose__max__length,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(nat,nat,foldr(list(A),nat,aTP_Lamp_vn(list(A),fun(nat,nat)),transpose(A,Xs)),zero_zero(nat)) = aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_wk(list(A),$o)),Xs)) ) ).

% transpose_max_length
tff(fact_6086_transpose__column__length,axiom,
    ! [A: $tType,Xs: list(list(A)),I3: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
       => ( aa(list(list(A)),nat,size_size(list(list(A))),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_vv(nat,fun(list(A),$o),I3)),transpose(A,Xs))) = aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I3)) ) ) ) ).

% transpose_column_length
tff(fact_6087_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),P: fun(B,$o),Xs: list(B)] : ( aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),filter2(B,P),Xs)) = map_filter(B,A,aa(fun(B,$o),fun(B,option(A)),aTP_Lamp_wl(fun(B,A),fun(fun(B,$o),fun(B,option(A))),F3),P),Xs) ) ).

% map_filter_map_filter
tff(fact_6088_suminf__eq__SUP__real,axiom,
    ! [X7: fun(nat,real)] :
      ( summable(real,X7)
     => ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,X7,I2))
       => ( suminf(real,X7) = aa(set(real),real,complete_Sup_Sup(real),aa(set(nat),set(real),image(nat,real,aTP_Lamp_wm(fun(nat,real),fun(nat,real),X7)),top_top(set(nat)))) ) ) ) ).

% suminf_eq_SUP_real
tff(fact_6089_finite__option__UNIV,axiom,
    ! [A: $tType] :
      ( finite_finite2(option(A),top_top(set(option(A))))
    <=> finite_finite2(A,top_top(set(A))) ) ).

% finite_option_UNIV
tff(fact_6090_Collect__const,axiom,
    ! [A: $tType,P: $o] :
      ( aa(fun(A,$o),set(A),collect(A),aTP_Lamp_wn($o,fun(A,$o),P))
      = $ite((P),top_top(set(A)),bot_bot(set(A))) ) ).

% Collect_const
tff(fact_6091_finite__Collect__not,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),P))
     => ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ed(fun(A,$o),fun(A,$o),P)))
      <=> finite_finite2(A,top_top(set(A))) ) ) ).

% finite_Collect_not
tff(fact_6092_surj__plus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_plus
tff(fact_6093_range__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),top_top(set(A))) = top_top(set(A)) ) ) ).

% range_add
tff(fact_6094_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),A3) = top_top(A) )
        <=> ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),top_top(A))
             => ? [Xa: A] :
                  ( aa(set(A),$o,member(A,Xa),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Xa) ) ) ) ) ).

% Sup_eq_top_iff
tff(fact_6095_surj__fn,axiom,
    ! [A: $tType,F3: fun(A,A),Nb: nat] :
      ( ( aa(set(A),set(A),image(A,A,F3),top_top(set(A))) = top_top(set(A)) )
     => ( aa(set(A),set(A),image(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_fn
tff(fact_6096_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_rr(A,fun(A,A),A2)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_diff_right
tff(fact_6097_ccINF__top,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aTP_Lamp_wo(B,A)),A3)) = top_top(A) ) ) ).

% ccINF_top
tff(fact_6098_INF__top,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aTP_Lamp_wp(B,A)),A3)) = top_top(A) ) ) ).

% INF_top
tff(fact_6099_INF__top__conv_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B4: fun(B,A),A3: set(B)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,B4),A3)) = top_top(A) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => ( aa(B,A,B4,X3) = top_top(A) ) ) ) ) ).

% INF_top_conv(1)
tff(fact_6100_INF__top__conv_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B4: fun(B,A),A3: set(B)] :
          ( ( top_top(A) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,B4),A3)) )
        <=> ! [X3: B] :
              ( aa(set(B),$o,member(B,X3),A3)
             => ( aa(B,A,B4,X3) = top_top(A) ) ) ) ) ).

% INF_top_conv(2)
tff(fact_6101_SUP__eq__top__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F3: fun(B,A),A3: set(B)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3)) = top_top(A) )
        <=> ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),top_top(A))
             => ? [Xa: B] :
                  ( aa(set(B),$o,member(B,Xa),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),aa(B,A,F3,Xa)) ) ) ) ) ).

% SUP_eq_top_iff
tff(fact_6102_range__constant,axiom,
    ! [B: $tType,A: $tType,X2: A] : ( aa(set(B),set(A),image(B,A,aa(A,fun(B,A),aTP_Lamp_aq(A,fun(B,A)),X2)),top_top(set(B))) = aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) ) ).

% range_constant
tff(fact_6103_ccINF__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [F3: fun(B,A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),bot_bot(set(B)))) = top_top(A) ) ) ).

% ccINF_empty
tff(fact_6104_INT__constant,axiom,
    ! [B: $tType,A: $tType,C2: set(A),A3: set(B)] :
      ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_tu(set(A),fun(B,set(A)),C2)),A3))
      = $ite(A3 = bot_bot(set(B)),top_top(set(A)),C2) ) ).

% INT_constant
tff(fact_6105_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),top_top(A)),X2)
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(A,set(A),set_ord_lessThan(A),X2)) = bot_bot(A) ) ) ) ).

% Inf_atMostLessThan
tff(fact_6106_INT__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] :
      ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_um(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6))
      = $ite(C6 = bot_bot(set(B)),top_top(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6)))) ) ).

% INT_simps(2)
tff(fact_6107_INT__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),B4: set(A),C6: set(B)] :
      ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_un(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6))
      = $ite(C6 = bot_bot(set(B)),top_top(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4)) ) ).

% INT_simps(1)
tff(fact_6108_INT__simps_I3_J,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),B4: set(A),C6: set(B)] :
      ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_uo(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6))
      = $ite(C6 = bot_bot(set(B)),top_top(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4)) ) ).

% INT_simps(3)
tff(fact_6109_INT__simps_I4_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] :
      ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_vl(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6))
      = $ite(C6 = bot_bot(set(B)),top_top(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6)))) ) ).

% INT_simps(4)
tff(fact_6110_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] : aa(A,$o,sums(A,F3),aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_wq(fun(nat,A),fun(nat,A),F3)),top_top(set(nat))))) ) ).

% sums_SUP
tff(fact_6111_UN__atMost__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Sup_Sup(set(nat)),aa(set(nat),set(set(nat)),image(nat,set(nat),set_ord_atMost(nat)),top_top(set(nat)))) = top_top(set(nat)) ).

% UN_atMost_UNIV
tff(fact_6112_UN__lessThan__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Sup_Sup(set(nat)),aa(set(nat),set(set(nat)),image(nat,set(nat),set_ord_lessThan(nat)),top_top(set(nat)))) = top_top(set(nat)) ).

% UN_lessThan_UNIV
tff(fact_6113_rangeE,axiom,
    ! [A: $tType,B: $tType,B2: A,F3: fun(B,A)] :
      ( aa(set(A),$o,member(A,B2),aa(set(B),set(A),image(B,A,F3),top_top(set(B))))
     => ~ ! [X4: B] : ( B2 != aa(B,A,F3,X4) ) ) ).

% rangeE
tff(fact_6114_range__composition,axiom,
    ! [A: $tType,C: $tType,B: $tType,F3: fun(C,A),G: fun(B,C)] : ( aa(set(B),set(A),image(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_wr(fun(C,A),fun(fun(B,C),fun(B,A)),F3),G)),top_top(set(B))) = aa(set(C),set(A),image(C,A,F3),aa(set(B),set(C),image(B,C,G),top_top(set(B)))) ) ).

% range_composition
tff(fact_6115_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),top_top(A)),A2) ) ).

% top.extremum_strict
tff(fact_6116_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A2: A] :
          ( ( A2 != top_top(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),top_top(A)) ) ) ).

% top.not_eq_extremum
tff(fact_6117_UNIV__def,axiom,
    ! [A: $tType] : ( top_top(set(A)) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ws(A,$o)) ) ).

% UNIV_def
tff(fact_6118_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( finite_finite2(fun(A,B),top_top(set(fun(A,B))))
     => ( ( finite_card(B,top_top(set(B))) != aa(nat,nat,suc,zero_zero(nat)) )
       => finite_finite2(A,top_top(set(A))) ) ) ).

% finite_fun_UNIVD1
tff(fact_6119_bij__fn,axiom,
    ! [A: $tType,F3: fun(A,A),Nb: nat] :
      ( bij_betw(A,A,F3,top_top(set(A)),top_top(set(A)))
     => bij_betw(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),top_top(set(A)),top_top(set(A))) ) ).

% bij_fn
tff(fact_6120_SUP__INF,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [P: fun(C,fun(B,A))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aTP_Lamp_wu(fun(C,fun(B,A)),fun(B,A),P)),top_top(set(B)))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(fun(B,C)),set(A),image(fun(B,C),A,aTP_Lamp_ww(fun(C,fun(B,A)),fun(fun(B,C),A),P)),top_top(set(fun(B,C))))) ) ) ).

% SUP_INF
tff(fact_6121_INF__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [P: fun(C,fun(B,A))] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aTP_Lamp_wx(fun(C,fun(B,A)),fun(B,A),P)),top_top(set(B)))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(fun(B,C)),set(A),image(fun(B,C),A,aTP_Lamp_wy(fun(C,fun(B,A)),fun(fun(B,C),A),P)),top_top(set(fun(B,C))))) ) ) ).

% INF_SUP
tff(fact_6122_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,option(A))] : ( map_filter(B,A,F3,nil(B)) = nil(A) ) ).

% map_filter_simps(2)
tff(fact_6123_UNIV__option__conv,axiom,
    ! [A: $tType] : ( top_top(set(option(A))) = aa(set(option(A)),set(option(A)),insert(option(A),none(A)),aa(set(A),set(option(A)),image(A,option(A),some(A)),top_top(set(A)))) ) ).

% UNIV_option_conv
tff(fact_6124_finite__range__imageI,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: fun(B,A),F3: fun(A,C)] :
      ( finite_finite2(A,aa(set(B),set(A),image(B,A,G),top_top(set(B))))
     => finite_finite2(C,aa(set(B),set(C),image(B,C,aa(fun(A,C),fun(B,C),aTP_Lamp_wz(fun(B,A),fun(fun(A,C),fun(B,C)),G),F3)),top_top(set(B)))) ) ).

% finite_range_imageI
tff(fact_6125_INTER__UNIV__conv_I1_J,axiom,
    ! [B: $tType,A: $tType,B4: fun(B,set(A)),A3: set(B)] :
      ( ( top_top(set(A)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
         => ( aa(B,set(A),B4,X3) = top_top(set(A)) ) ) ) ).

% INTER_UNIV_conv(1)
tff(fact_6126_INTER__UNIV__conv_I2_J,axiom,
    ! [B: $tType,A: $tType,B4: fun(B,set(A)),A3: set(B)] :
      ( ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)) = top_top(set(A)) )
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),A3)
         => ( aa(B,set(A),B4,X3) = top_top(set(A)) ) ) ) ).

% INTER_UNIV_conv(2)
tff(fact_6127_INF__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [C2: A,A3: set(B)] :
          ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aTP_Lamp_uq(A,fun(B,A),C2)),A3))
          = $ite(A3 = bot_bot(set(B)),top_top(A),C2) ) ) ).

% INF_constant
tff(fact_6128_INF__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),bot_bot(set(B)))) = top_top(A) ) ) ).

% INF_empty
tff(fact_6129_finite__range__Some,axiom,
    ! [A: $tType] :
      ( finite_finite2(option(A),aa(set(A),set(option(A)),image(A,option(A),some(A)),top_top(set(A))))
    <=> finite_finite2(A,top_top(set(A))) ) ).

% finite_range_Some
tff(fact_6130_notin__range__Some,axiom,
    ! [A: $tType,X2: option(A)] :
      ( ~ aa(set(option(A)),$o,member(option(A),X2),aa(set(A),set(option(A)),image(A,option(A),some(A)),top_top(set(A))))
    <=> ( X2 = none(A) ) ) ).

% notin_range_Some
tff(fact_6131_INT__empty,axiom,
    ! [B: $tType,A: $tType,B4: fun(B,set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),bot_bot(set(B)))) = top_top(set(A)) ) ).

% INT_empty
tff(fact_6132_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => folding_insort_key(A,A,ord_less_eq(A),ord_less(A),top_top(set(A)),aTP_Lamp_qr(A,A)) ) ).

% sorted_list_of_set.folding_insort_key_axioms
tff(fact_6133_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => semila1105856199041335345_order(A,inf_inf(A),top_top(A),ord_less_eq(A),ord_less(A)) ) ).

% inf_top.semilattice_neutr_order_axioms
tff(fact_6134_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( finite_finite2(A,top_top(set(A)))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),finite_card(A,top_top(set(A)))) ) ).

% finite_UNIV_card_ge_0
tff(fact_6135_UNIV__nat__eq,axiom,
    top_top(set(nat)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),top_top(set(nat)))) ).

% UNIV_nat_eq
tff(fact_6136_INT__extend__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C6: set(B),B4: set(A)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4)
      = $ite(C6 = bot_bot(set(B)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),B4),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_uo(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6))) ) ).

% INT_extend_simps(3)
tff(fact_6137_bij__image__INT,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: fun(A,B),B4: fun(C,set(A)),A3: set(C)] :
      ( bij_betw(A,B,F3,top_top(set(A)),top_top(set(B)))
     => ( aa(set(A),set(B),image(A,B,F3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),B4),A3))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_xa(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),F3),B4)),A3)) ) ) ).

% bij_image_INT
tff(fact_6138_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: fun(nat,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aTP_Lamp_xb(fun(nat,set(A)),fun(nat,set(A)),A3)),top_top(set(nat)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),top_top(set(nat)))) ) ).

% UN_UN_finite_eq
tff(fact_6139_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A)] :
      ( finite_finite2(A,aa(set(B),set(A),image(B,A,F3),top_top(set(B))))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),finite_card(A,aa(set(B),set(A),image(B,A,F3),top_top(set(B))))) ) ).

% card_range_greater_zero
tff(fact_6140_UN__finite__subset,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),C6: set(A)] :
      ( ! [N: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))),C6)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),top_top(set(nat))))),C6) ) ).

% UN_finite_subset
tff(fact_6141_UN__finite2__eq,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),B4: fun(nat,set(A)),K: nat] :
      ( ! [N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B4),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) )
     => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),top_top(set(nat)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B4),top_top(set(nat)))) ) ) ).

% UN_finite2_eq
tff(fact_6142_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] : ( suminf(A,F3) = aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_wq(fun(nat,A),fun(nat,A),F3)),top_top(set(nat)))) ) ) ).

% suminf_eq_SUP
tff(fact_6143_range__mod,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(set(nat),set(nat),image(nat,nat,aTP_Lamp_xc(nat,fun(nat,nat),Nb)),top_top(set(nat))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb) ) ) ).

% range_mod
tff(fact_6144_UN__finite2__subset,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),B4: fun(nat,set(A)),K: nat] :
      ( ! [N: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B4),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))))
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),top_top(set(nat))))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B4),top_top(set(nat))))) ) ).

% UN_finite2_subset
tff(fact_6145_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F3: fun(nat,set(A)),S3: set(A)] :
      ( ! [I2: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),F3,I2)),S3)
     => ( finite_finite2(A,S3)
       => ( ? [N6: nat] :
              ( ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N6)
                 => ! [M3: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M3),N6)
                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N)
                       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),aa(nat,set(A),F3,M3)),aa(nat,set(A),F3,N)) ) ) )
              & ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N)
                 => ( aa(nat,set(A),F3,N6) = aa(nat,set(A),F3,N) ) ) )
         => ( aa(nat,set(A),F3,finite_card(A,S3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),F3),top_top(set(nat)))) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
tff(fact_6146_cclfp__def,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [F3: fun(A,A)] : ( order_532582986084564980_cclfp(A,F3) = aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_xd(fun(A,A),fun(nat,A),F3)),top_top(set(nat)))) ) ) ).

% cclfp_def
tff(fact_6147_transpose__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),aa(list(nat),list(nat),rev(nat),aa(list(list(A)),list(nat),map(list(A),nat,size_size(list(A))),Xs)))
     => ( transpose(A,transpose(A,Xs)) = takeWhile(list(A),aTP_Lamp_wk(list(A),$o),Xs) ) ) ).

% transpose_transpose
tff(fact_6148_takeWhile__idem,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( takeWhile(A,P,takeWhile(A,P,Xs)) = takeWhile(A,P,Xs) ) ).

% takeWhile_idem
tff(fact_6149_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( takeWhile(A,P,Xs) = Xs )
    <=> ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X3) ) ) ).

% takeWhile_eq_all_conv
tff(fact_6150_Collect__const__case__prod,axiom,
    ! [B: $tType,A: $tType,P: $o] :
      ( aa(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aTP_Lamp_xe($o,fun(A,fun(B,$o)),P)))
      = $ite((P),top_top(set(product_prod(A,B))),bot_bot(set(product_prod(A,B)))) ) ).

% Collect_const_case_prod
tff(fact_6151_card__UNIV__bool,axiom,
    finite_card($o,top_top(set($o))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) ).

% card_UNIV_bool
tff(fact_6152_takeWhile__replicate,axiom,
    ! [A: $tType,P: fun(A,$o),Nb: nat,X2: A] :
      ( takeWhile(A,P,replicate(A,Nb,X2))
      = $ite(aa(A,$o,P,X2),replicate(A,Nb,X2),nil(A)) ) ).

% takeWhile_replicate
tff(fact_6153_range__mult,axiom,
    ! [A2: real] :
      ( aa(set(real),set(real),image(real,real,aa(real,fun(real,real),times_times(real),A2)),top_top(set(real)))
      = $ite(A2 = zero_zero(real),aa(set(real),set(real),insert(real,zero_zero(real)),bot_bot(set(real))),top_top(set(real))) ) ).

% range_mult
tff(fact_6154_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType,X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),top_top(fun(A,fun(B,$o))),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),top_top(set(product_prod(A,B)))) ) ).

% top_empty_eq2
tff(fact_6155_top__enat__def,axiom,
    top_top(extended_enat) = extend4730790105801354508finity(extended_enat) ).

% top_enat_def
tff(fact_6156_infinite__UNIV__listI,axiom,
    ! [A: $tType] : ~ finite_finite2(list(A),top_top(set(list(A)))) ).

% infinite_UNIV_listI
tff(fact_6157_length__takeWhile__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_takeWhile_le
tff(fact_6158_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,$o)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),takeWhile(A,P,Xs)) ) ) ).

% sorted_takeWhile
tff(fact_6159_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( distinct(A,Xs)
     => distinct(A,takeWhile(A,P,Xs)) ) ).

% distinct_takeWhile
tff(fact_6160_set__takeWhileD,axiom,
    ! [A: $tType,X2: A,P: fun(A,$o),Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),takeWhile(A,P,Xs)))
     => ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
        & aa(A,$o,P,X2) ) ) ).

% set_takeWhileD
tff(fact_6161_takeWhile__cong,axiom,
    ! [A: $tType,L: list(A),K: list(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( ( L = K )
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),L))
           => ( aa(A,$o,P,X4)
            <=> aa(A,$o,Q,X4) ) )
       => ( takeWhile(A,P,L) = takeWhile(A,Q,K) ) ) ) ).

% takeWhile_cong
tff(fact_6162_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,$o)] : ( takeWhile(A,P,nil(A)) = nil(A) ) ).

% takeWhile.simps(1)
tff(fact_6163_takeWhile__eq__take,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( takeWhile(A,P,Xs) = take(A,aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)),Xs) ) ).

% takeWhile_eq_take
tff(fact_6164_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F3: fun(B,A),Xs: list(B)] : ( takeWhile(A,P,aa(list(B),list(A),map(B,A,F3),Xs)) = aa(list(B),list(A),map(B,A,F3),takeWhile(B,aa(fun(B,A),fun(B,$o),comp(A,$o,B,P),F3),Xs)) ) ).

% takeWhile_map
tff(fact_6165_INF__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: fun($o,A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set($o),set(A),image($o,A,A3),top_top(set($o)))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa($o,A,A3,$true)),aa($o,A,A3,$false)) ) ) ).

% INF_UNIV_bool_expand
tff(fact_6166_INT__bool__eq,axiom,
    ! [A: $tType,A3: fun($o,set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set($o),set(set(A)),image($o,set(A),A3),top_top(set($o)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa($o,set(A),A3,$true)),aa($o,set(A),A3,$false)) ) ).

% INT_bool_eq
tff(fact_6167_takeWhile__nth,axiom,
    ! [A: $tType,J2: nat,P: fun(A,$o),Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))
     => ( aa(nat,A,nth(A,takeWhile(A,P,Xs)),J2) = aa(nat,A,nth(A,Xs),J2) ) ) ).

% takeWhile_nth
tff(fact_6168_nth__length__takeWhile,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs))
     => ~ aa(A,$o,P,aa(nat,A,nth(A,Xs),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))) ) ).

% nth_length_takeWhile
tff(fact_6169_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J2: nat,P: fun(A,$o),Xs: list(A)] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
         => aa(A,$o,P,aa(nat,A,nth(A,Xs),I2)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))) ) ) ).

% length_takeWhile_less_P_nth
tff(fact_6170_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),P: fun(A,$o)] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),Nb)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
           => aa(A,$o,P,aa(nat,A,nth(A,Xs),I2)) ) )
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
         => ~ aa(A,$o,P,aa(nat,A,nth(A,Xs),Nb)) )
       => ( takeWhile(A,P,Xs) = take(A,Nb,Xs) ) ) ) ).

% takeWhile_eq_take_P_nth
tff(fact_6171_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),T2: A] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),rev(A),aa(list(B),list(A),map(B,A,F3),Xs)))
         => ( aa(list(B),list(B),filter2(B,aa(A,fun(B,$o),aTP_Lamp_xf(fun(B,A),fun(A,fun(B,$o)),F3),T2)),Xs) = takeWhile(B,aa(A,fun(B,$o),aTP_Lamp_xf(fun(B,A),fun(A,fun(B,$o)),F3),T2),Xs) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
tff(fact_6172_root__def,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(real,real,root(Nb),X2)
      = $ite(Nb = zero_zero(nat),zero_zero(real),the_inv_into(real,real,top_top(set(real)),aTP_Lamp_xg(nat,fun(real,real),Nb),X2)) ) ).

% root_def
tff(fact_6173_card__UNIV__char,axiom,
    finite_card(char,top_top(set(char))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))))))) ).

% card_UNIV_char
tff(fact_6174_the__inv__into__def,axiom,
    ! [B: $tType,A: $tType,A3: set(B),F3: fun(B,A),X: A] : ( the_inv_into(B,A,A3,F3,X) = the(B,aa(A,fun(B,$o),aa(fun(B,A),fun(A,fun(B,$o)),aTP_Lamp_xh(set(B),fun(fun(B,A),fun(A,fun(B,$o))),A3),F3),X)) ) ).

% the_inv_into_def
tff(fact_6175_UNIV__char__of__nat,axiom,
    top_top(set(char)) = aa(set(nat),set(char),image(nat,char,unique5772411509450598832har_of(nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))) ).

% UNIV_char_of_nat
tff(fact_6176_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: A] : ( aa(A,char,unique5772411509450598832har_of(A),modulo_modulo(A,Nb,aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))) = aa(A,char,unique5772411509450598832har_of(A),Nb) ) ) ).

% char_of_mod_256
tff(fact_6177_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: A,Nb: A] :
          ( ( aa(A,char,unique5772411509450598832har_of(A),Ma) = aa(A,char,unique5772411509450598832har_of(A),Nb) )
        <=> ( modulo_modulo(A,Ma,aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) = modulo_modulo(A,Nb,aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) ) ) ) ).

% char_of_quasi_inj
tff(fact_6178_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: nat,Ma: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))),Nb)
         => ( aa(A,char,unique5772411509450598832har_of(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),Ma)) = aa(A,char,unique5772411509450598832har_of(A),Ma) ) ) ) ).

% char_of_take_bit_eq
tff(fact_6179_of__char__of,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [A2: A] : ( aa(char,A,comm_s6883823935334413003f_char(A),aa(A,char,unique5772411509450598832har_of(A),A2)) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) ) ) ).

% of_char_of
tff(fact_6180_char__of__def,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: A] : ( aa(A,char,unique5772411509450598832har_of(A),Nb) = aa($o,char,char2(~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Nb),one_one(nat)),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,aa(num,num,bit0,one2)))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit1,one2))))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Nb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,aa(num,num,bit1,one2))))) ) ) ).

% char_of_def
tff(fact_6181_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [C2: char] : ( modulo_modulo(A,aa(char,A,comm_s6883823935334413003f_char(A),C2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) = aa(char,A,comm_s6883823935334413003f_char(A),C2) ) ) ).

% of_char_mod_256
tff(fact_6182_char_Osize_I2_J,axiom,
    ! [X15: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X8: $o] : ( aa(char,nat,size_size(char),aa($o,char,char2(X15,X22,X32,X42,X52,X62,X72),X8)) = zero_zero(nat) ) ).

% char.size(2)
tff(fact_6183_nat__of__char__less__256,axiom,
    ! [C2: char] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(char,nat,comm_s6883823935334413003f_char(nat),C2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) ).

% nat_of_char_less_256
tff(fact_6184_range__nat__of__char,axiom,
    aa(set(char),set(nat),image(char,nat,comm_s6883823935334413003f_char(nat)),top_top(set(char))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) ).

% range_nat_of_char
tff(fact_6185_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Nb: A,C2: char] :
          ( ( aa(A,char,unique5772411509450598832har_of(A),Nb) = C2 )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))),Nb) = aa(char,A,comm_s6883823935334413003f_char(A),C2) ) ) ) ).

% char_of_eq_iff
tff(fact_6186_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] : ( integer_of_char(aa($o,char,char2(B0,B1,B22,B32,B42,B52,B62),B72)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B72)),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B62))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B52))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B42))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B32))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B22))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B1))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B0)) ) ).

% integer_of_char_code
tff(fact_6187_char_Osize__gen,axiom,
    ! [X15: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X8: $o] : ( size_char(aa($o,char,char2(X15,X22,X32,X42,X52,X62,X72),X8)) = zero_zero(nat) ) ).

% char.size_gen
tff(fact_6188_char__of__integer__code,axiom,
    ! [K: code_integer] : ( char_of_integer(K) = aa(product_prod(code_integer,$o),char,aa(fun(code_integer,fun($o,char)),fun(product_prod(code_integer,$o),char),product_case_prod(code_integer,$o,char),aTP_Lamp_xp(code_integer,fun($o,char))),code_bit_cut_integer(K)) ) ).

% char_of_integer_code
tff(fact_6189_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] : ( aa(char,nat,comm_s6883823935334413003f_char(nat),ascii_of(C2)) = aa(nat,nat,bit_se2584673776208193580ke_bit(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,aa(num,num,bit1,one2)))),aa(char,nat,comm_s6883823935334413003f_char(nat),C2)) ) ).

% String.char_of_ascii_of
tff(fact_6190_of__char__Char,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] : ( aa(char,A,comm_s6883823935334413003f_char(A),aa($o,char,char2(B0,B1,B22,B32,B42,B52,B62),B72)) = groups4207007520872428315er_sum($o,A,zero_neq_one_of_bool(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),aa(list($o),list($o),cons($o,B0),aa(list($o),list($o),cons($o,B1),aa(list($o),list($o),cons($o,B22),aa(list($o),list($o),cons($o,B32),aa(list($o),list($o),cons($o,B42),aa(list($o),list($o),cons($o,B52),aa(list($o),list($o),cons($o,B62),aa(list($o),list($o),cons($o,B72),nil($o)))))))))) ) ) ).

% of_char_Char
tff(fact_6191_listset_Osimps_I1_J,axiom,
    ! [A: $tType] : ( listset(A,nil(set(A))) = aa(set(list(A)),set(list(A)),insert(list(A),nil(A)),bot_bot(set(list(A)))) ) ).

% listset.simps(1)
tff(fact_6192_list_Oinject,axiom,
    ! [A: $tType,X21: A,X222: list(A),Y21: A,Y222: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X21),X222) = aa(list(A),list(A),cons(A,Y21),Y222) )
    <=> ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% list.inject
tff(fact_6193_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X21),X222)) = aa(set(A),set(A),insert(A,X21),aa(list(A),set(A),set2(A),X222)) ) ).

% list.simps(15)
tff(fact_6194_nth__Cons__Suc,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Nb: nat] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X2),Xs)),aa(nat,nat,suc,Nb)) = aa(nat,A,nth(A,Xs),Nb) ) ).

% nth_Cons_Suc
tff(fact_6195_nth__Cons__0,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X2),Xs)),zero_zero(nat)) = X2 ) ).

% nth_Cons_0
tff(fact_6196_take__Suc__Cons,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] : ( take(A,aa(nat,nat,suc,Nb),aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(A),list(A),cons(A,X2),take(A,Nb,Xs)) ) ).

% take_Suc_Cons
tff(fact_6197_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [X2: A,Xs: list(A)] : ( groups8242544230860333062m_list(A,aa(list(A),list(A),cons(A,X2),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),groups8242544230860333062m_list(A,Xs)) ) ) ).

% sum_list.Cons
tff(fact_6198_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( ( aa(list(A),list(A),rev(A),Xs) = aa(list(A),list(A),cons(A,X2),nil(A)) )
    <=> ( Xs = aa(list(A),list(A),cons(A,X2),nil(A)) ) ) ).

% rev_singleton_conv
tff(fact_6199_singleton__rev__conv,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X2),nil(A)) = aa(list(A),list(A),rev(A),Xs) )
    <=> ( aa(list(A),list(A),cons(A,X2),nil(A)) = Xs ) ) ).

% singleton_rev_conv
tff(fact_6200_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Y2: A,Ys: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X2),Xs)),aa(list(A),list(A),cons(A,Y2),Ys))),listrel1(A,R))
    <=> ( ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),R)
          & ( Xs = Ys ) )
        | ( ( X2 = Y2 )
          & aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,R)) ) ) ) ).

% Cons_listrel1_Cons
tff(fact_6201_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F3: fun(B,A),A2: A,X2: B,Xs: list(B)] : ( groups4207007520872428315er_sum(B,A,F3,A2,aa(list(B),list(B),cons(B,X2),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,F3,X2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),groups4207007520872428315er_sum(B,A,F3,A2,Xs))) ) ) ).

% horner_sum_simps(2)
tff(fact_6202_enumerate__simps_I2_J,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] : ( enumerate(A,Nb,aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(product_prod(nat,A)),list(product_prod(nat,A)),cons(product_prod(nat,A),aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Nb),X2)),enumerate(A,aa(nat,nat,suc,Nb),Xs)) ) ).

% enumerate_simps(2)
tff(fact_6203_nth__Cons__numeral,axiom,
    ! [A: $tType,X2: A,Xs: list(A),V: num] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X2),Xs)),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat))) ) ).

% nth_Cons_numeral
tff(fact_6204_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X2: A,Xs: list(A)] : ( take(A,aa(num,nat,numeral_numeral(nat),V),aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(A),list(A),cons(A,X2),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)),Xs)) ) ).

% take_Cons_numeral
tff(fact_6205_Cons__in__lex,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Y2: A,Ys: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X2),Xs)),aa(list(A),list(A),cons(A,Y2),Ys))),lex(A,R))
    <=> ( ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),R)
          & ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) ) )
        | ( ( X2 = Y2 )
          & aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lex(A,R)) ) ) ) ).

% Cons_in_lex
tff(fact_6206_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] : ( concat(A,aa(list(B),list(list(A)),map(B,list(A),aTP_Lamp_xq(fun(B,A),fun(B,list(A)),F3)),Xs)) = aa(list(B),list(A),map(B,A,F3),Xs) ) ).

% concat_map_singleton
tff(fact_6207_nth__Cons__pos,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X2),Xs)),Nb) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))) ) ) ).

% nth_Cons_pos
tff(fact_6208_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A)] :
      ( takeWhile(A,P,aa(list(A),list(A),cons(A,X2),Xs))
      = $ite(aa(A,$o,P,X2),aa(list(A),list(A),cons(A,X2),takeWhile(A,P,Xs)),nil(A)) ) ).

% takeWhile.simps(2)
tff(fact_6209_listrel1I2,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A)),X2: A] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,R))
     => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X2),Xs)),aa(list(A),list(A),cons(A,X2),Ys))),listrel1(A,R)) ) ).

% listrel1I2
tff(fact_6210_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A)] :
      ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),cons(A,X2),Xs))
      = $ite(aa(A,$o,P,X2),aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),filter2(A,P),Xs)),aa(list(A),list(A),filter2(A,P),Xs)) ) ).

% filter.simps(2)
tff(fact_6211_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( remdups(A,aa(list(A),list(A),cons(A,X2),Xs))
      = $ite(aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs)),remdups(A,Xs),aa(list(A),list(A),cons(A,X2),remdups(A,Xs))) ) ).

% remdups.simps(2)
tff(fact_6212_list__update__code_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),I3: nat,Y2: A] : ( list_update(A,aa(list(A),list(A),cons(A,X2),Xs),aa(nat,nat,suc,I3),Y2) = aa(list(A),list(A),cons(A,X2),list_update(A,Xs,I3,Y2)) ) ).

% list_update_code(3)
tff(fact_6213_insort__key_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),X2: A,Y2: A,Ys: list(A)] :
          ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),X2),aa(list(A),list(A),cons(A,Y2),Ys))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X2)),aa(A,B,F3,Y2)),aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Ys)),aa(list(A),list(A),cons(A,Y2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),X2),Ys))) ) ) ).

% insort_key.simps(2)
tff(fact_6214_list__update__code_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Y2: A] : ( list_update(A,aa(list(A),list(A),cons(A,X2),Xs),zero_zero(nat),Y2) = aa(list(A),list(A),cons(A,Y2),Xs) ) ).

% list_update_code(2)
tff(fact_6215_shufflesE,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys: list(A)] :
      ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
     => ( ( ( Zs = Xs )
         => ( Ys != nil(A) ) )
       => ( ( ( Zs = Ys )
           => ( Xs != nil(A) ) )
         => ( ! [X4: A,Xs4: list(A)] :
                ( ( Xs = aa(list(A),list(A),cons(A,X4),Xs4) )
               => ! [Z2: A,Zs4: list(A)] :
                    ( ( Zs = aa(list(A),list(A),cons(A,Z2),Zs4) )
                   => ( ( X4 = Z2 )
                     => ~ aa(set(list(A)),$o,member(list(A),Zs4),shuffles(A,Xs4,Ys)) ) ) )
           => ~ ! [Y4: A,Ys5: list(A)] :
                  ( ( Ys = aa(list(A),list(A),cons(A,Y4),Ys5) )
                 => ! [Z2: A,Zs4: list(A)] :
                      ( ( Zs = aa(list(A),list(A),cons(A,Z2),Zs4) )
                     => ( ( Y4 = Z2 )
                       => ~ aa(set(list(A)),$o,member(list(A),Zs4),shuffles(A,Xs,Ys5)) ) ) ) ) ) ) ) ).

% shufflesE
tff(fact_6216_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list(A),X2: A] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X2),Xs))) ).

% set_subset_Cons
tff(fact_6217_sorted2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A,Zs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Zs)))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
            & sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,Y2),Zs)) ) ) ) ).

% sorted2
tff(fact_6218_distinct__singleton,axiom,
    ! [A: $tType,X2: A] : distinct(A,aa(list(A),list(A),cons(A,X2),nil(A))) ).

% distinct_singleton
tff(fact_6219_sorted__wrt1,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),X2: A] : sorted_wrt(A,P,aa(list(A),list(A),cons(A,X2),nil(A))) ).

% sorted_wrt1
tff(fact_6220_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( distinct(A,aa(list(A),list(A),cons(A,X2),Xs))
    <=> ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
        & distinct(A,Xs) ) ) ).

% distinct.simps(2)
tff(fact_6221_replicate__Suc,axiom,
    ! [A: $tType,Nb: nat,X2: A] : ( replicate(A,aa(nat,nat,suc,Nb),X2) = aa(list(A),list(A),cons(A,X2),replicate(A,Nb,X2)) ) ).

% replicate_Suc
tff(fact_6222_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list(A)] :
      ( aa(list(A),list(A),removeAll(A,X2),aa(list(A),list(A),cons(A,Y2),Xs))
      = $ite(X2 = Y2,aa(list(A),list(A),removeAll(A,X2),Xs),aa(list(A),list(A),cons(A,Y2),aa(list(A),list(A),removeAll(A,X2),Xs))) ) ).

% removeAll.simps(2)
tff(fact_6223_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys: list(A),Z: A] :
      ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
     => aa(set(list(A)),$o,member(list(A),aa(list(A),list(A),cons(A,Z),Zs)),shuffles(A,Xs,aa(list(A),list(A),cons(A,Z),Ys))) ) ).

% Cons_in_shuffles_rightI
tff(fact_6224_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys: list(A),Z: A] :
      ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
     => aa(set(list(A)),$o,member(list(A),aa(list(A),list(A),cons(A,Z),Zs)),shuffles(A,aa(list(A),list(A),cons(A,Z),Xs),Ys)) ) ).

% Cons_in_shuffles_leftI
tff(fact_6225_distinct__length__2__or__more,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list(A)] :
      ( distinct(A,aa(list(A),list(A),cons(A,A2),aa(list(A),list(A),cons(A,B2),Xs)))
    <=> ( ( A2 != B2 )
        & distinct(A,aa(list(A),list(A),cons(A,A2),Xs))
        & distinct(A,aa(list(A),list(A),cons(A,B2),Xs)) ) ) ).

% distinct_length_2_or_more
tff(fact_6226_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),I3: nat,V: A] : ( list_update(A,aa(list(A),list(A),cons(A,X2),Xs),I3,V) = case_nat(list(A),aa(list(A),list(A),cons(A,V),Xs),aa(A,fun(nat,list(A)),aa(list(A),fun(A,fun(nat,list(A))),aTP_Lamp_xr(A,fun(list(A),fun(A,fun(nat,list(A)))),X2),Xs),V),I3) ) ).

% list_update.simps(2)
tff(fact_6227_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y2: A,X222: list(A),X21: A] :
      ( aa(set(A),$o,member(A,Y2),aa(list(A),set(A),set2(A),X222))
     => aa(set(A),$o,member(A,Y2),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X21),X222))) ) ).

% list.set_intros(2)
tff(fact_6228_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : aa(set(A),$o,member(A,X21),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X21),X222))) ).

% list.set_intros(1)
tff(fact_6229_list_Oset__cases,axiom,
    ! [A: $tType,E2: A,A2: list(A)] :
      ( aa(set(A),$o,member(A,E2),aa(list(A),set(A),set2(A),A2))
     => ( ! [Z23: list(A)] : ( A2 != aa(list(A),list(A),cons(A,E2),Z23) )
       => ~ ! [Z12: A,Z23: list(A)] :
              ( ( A2 = aa(list(A),list(A),cons(A,Z12),Z23) )
             => ~ aa(set(A),$o,member(A,E2),aa(list(A),set(A),set2(A),Z23)) ) ) ) ).

% list.set_cases
tff(fact_6230_set__ConsD,axiom,
    ! [A: $tType,Y2: A,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,Y2),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X2),Xs)))
     => ( ( Y2 = X2 )
        | aa(set(A),$o,member(A,Y2),aa(list(A),set(A),set2(A),Xs)) ) ) ).

% set_ConsD
tff(fact_6231_not__Cons__self2,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( aa(list(A),list(A),cons(A,X2),Xs) != Xs ) ).

% not_Cons_self2
tff(fact_6232_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list(A)] :
      ( remove1(A,X2,aa(list(A),list(A),cons(A,Y2),Xs))
      = $ite(X2 = Y2,Xs,aa(list(A),list(A),cons(A,Y2),remove1(A,X2,Xs))) ) ).

% remove1.simps(2)
tff(fact_6233_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X2: product_prod(fun(A,B),product_prod(list(A),list(B)))] :
      ( ! [F5: fun(A,B),Bs2: list(B)] : ( X2 != aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),aa(fun(A,B),fun(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B)))),product_Pair(fun(A,B),product_prod(list(A),list(B))),F5),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),Bs2)) )
     => ~ ! [F5: fun(A,B),A4: A,As: list(A),Bs2: list(B)] : ( X2 != aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),aa(fun(A,B),fun(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B)))),product_Pair(fun(A,B),product_prod(list(A),list(B))),F5),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),cons(A,A4),As)),Bs2)) ) ) ).

% map_tailrec_rev.cases
tff(fact_6234_shuffles_Ocases,axiom,
    ! [A: $tType,X2: product_prod(list(A),list(A))] :
      ( ! [Ys3: list(A)] : ( X2 != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys3) )
     => ( ! [Xs2: list(A)] : ( X2 != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs2),nil(A)) )
       => ~ ! [X4: A,Xs2: list(A),Y4: A,Ys3: list(A)] : ( X2 != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X4),Xs2)),aa(list(A),list(A),cons(A,Y4),Ys3)) ) ) ) ).

% shuffles.cases
tff(fact_6235_splice_Ocases,axiom,
    ! [A: $tType,X2: product_prod(list(A),list(A))] :
      ( ! [Ys3: list(A)] : ( X2 != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys3) )
     => ~ ! [X4: A,Xs2: list(A),Ys3: list(A)] : ( X2 != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X4),Xs2)),Ys3) ) ) ).

% splice.cases
tff(fact_6236_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( nil(A) != aa(list(A),list(A),cons(A,X21),X222) ) ).

% list.distinct(1)
tff(fact_6237_list_OdiscI,axiom,
    ! [A: $tType,List: list(A),X21: A,X222: list(A)] :
      ( ( List = aa(list(A),list(A),cons(A,X21),X222) )
     => ( List != nil(A) ) ) ).

% list.discI
tff(fact_6238_list_Oexhaust,axiom,
    ! [A: $tType,Y2: list(A)] :
      ( ( Y2 != nil(A) )
     => ~ ! [X212: A,X223: list(A)] : ( Y2 != aa(list(A),list(A),cons(A,X212),X223) ) ) ).

% list.exhaust
tff(fact_6239_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X2: list(A)] :
          ( ! [X4: A,Xs2: list(A)] : ( X2 != aa(list(A),list(A),cons(A,X4),Xs2) )
         => ( X2 = nil(A) ) ) ) ).

% min_list.cases
tff(fact_6240_transpose_Ocases,axiom,
    ! [A: $tType,X2: list(list(A))] :
      ( ( X2 != nil(list(A)) )
     => ( ! [Xss2: list(list(A))] : ( X2 != aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2) )
       => ~ ! [X4: A,Xs2: list(A),Xss2: list(list(A))] : ( X2 != aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X4),Xs2)),Xss2) ) ) ) ).

% transpose.cases
tff(fact_6241_remdups__adj_Ocases,axiom,
    ! [A: $tType,X2: list(A)] :
      ( ( X2 != nil(A) )
     => ( ! [X4: A] : ( X2 != aa(list(A),list(A),cons(A,X4),nil(A)) )
       => ~ ! [X4: A,Y4: A,Xs2: list(A)] : ( X2 != aa(list(A),list(A),cons(A,X4),aa(list(A),list(A),cons(A,Y4),Xs2)) ) ) ) ).

% remdups_adj.cases
tff(fact_6242_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
    <=> ? [Y: A,Ys4: list(A)] : ( Xs = aa(list(A),list(A),cons(A,Y),Ys4) ) ) ).

% neq_Nil_conv
tff(fact_6243_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P: fun(list(A),fun(list(B),$o)),Xs: list(A),Ys: list(B)] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),P,nil(A)),nil(B))
     => ( ! [X4: A,Xs2: list(A)] : aa(list(B),$o,aa(list(A),fun(list(B),$o),P,aa(list(A),list(A),cons(A,X4),Xs2)),nil(B))
       => ( ! [Y4: B,Ys3: list(B)] : aa(list(B),$o,aa(list(A),fun(list(B),$o),P,nil(A)),aa(list(B),list(B),cons(B,Y4),Ys3))
         => ( ! [X4: A,Xs2: list(A),Y4: B,Ys3: list(B)] :
                ( aa(list(B),$o,aa(list(A),fun(list(B),$o),P,Xs2),Ys3)
               => aa(list(B),$o,aa(list(A),fun(list(B),$o),P,aa(list(A),list(A),cons(A,X4),Xs2)),aa(list(B),list(B),cons(B,Y4),Ys3)) )
           => aa(list(B),$o,aa(list(A),fun(list(B),$o),P,Xs),Ys) ) ) ) ) ).

% list_induct2'
tff(fact_6244_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list(A),P: fun(list(A),$o)] :
      ( ( Xs != nil(A) )
     => ( ! [X4: A] : aa(list(A),$o,P,aa(list(A),list(A),cons(A,X4),nil(A)))
       => ( ! [X4: A,Xs2: list(A)] :
              ( ( Xs2 != nil(A) )
             => ( aa(list(A),$o,P,Xs2)
               => aa(list(A),$o,P,aa(list(A),list(A),cons(A,X4),Xs2)) ) )
         => aa(list(A),$o,P,Xs) ) ) ) ).

% list_nonempty_induct
tff(fact_6245_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X2: product_prod(fun(A,fun(A,$o)),list(A))] :
      ( ! [P5: fun(A,fun(A,$o))] : ( X2 != aa(list(A),product_prod(fun(A,fun(A,$o)),list(A)),aa(fun(A,fun(A,$o)),fun(list(A),product_prod(fun(A,fun(A,$o)),list(A))),product_Pair(fun(A,fun(A,$o)),list(A)),P5),nil(A)) )
     => ~ ! [P5: fun(A,fun(A,$o)),X4: A,Ys3: list(A)] : ( X2 != aa(list(A),product_prod(fun(A,fun(A,$o)),list(A)),aa(fun(A,fun(A,$o)),fun(list(A),product_prod(fun(A,fun(A,$o)),list(A))),product_Pair(fun(A,fun(A,$o)),list(A)),P5),aa(list(A),list(A),cons(A,X4),Ys3)) ) ) ).

% sorted_wrt.cases
tff(fact_6246_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X2: product_prod(fun(A,B),list(A))] :
          ( ! [F5: fun(A,B),X4: A] : ( X2 != aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),F5),aa(list(A),list(A),cons(A,X4),nil(A))) )
         => ( ! [F5: fun(A,B),X4: A,Y4: A,Zs2: list(A)] : ( X2 != aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),F5),aa(list(A),list(A),cons(A,X4),aa(list(A),list(A),cons(A,Y4),Zs2))) )
           => ~ ! [A4: fun(A,B)] : ( X2 != aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),A4),nil(A)) ) ) ) ) ).

% arg_min_list.cases
tff(fact_6247_successively_Ocases,axiom,
    ! [A: $tType,X2: product_prod(fun(A,fun(A,$o)),list(A))] :
      ( ! [P5: fun(A,fun(A,$o))] : ( X2 != aa(list(A),product_prod(fun(A,fun(A,$o)),list(A)),aa(fun(A,fun(A,$o)),fun(list(A),product_prod(fun(A,fun(A,$o)),list(A))),product_Pair(fun(A,fun(A,$o)),list(A)),P5),nil(A)) )
     => ( ! [P5: fun(A,fun(A,$o)),X4: A] : ( X2 != aa(list(A),product_prod(fun(A,fun(A,$o)),list(A)),aa(fun(A,fun(A,$o)),fun(list(A),product_prod(fun(A,fun(A,$o)),list(A))),product_Pair(fun(A,fun(A,$o)),list(A)),P5),aa(list(A),list(A),cons(A,X4),nil(A))) )
       => ~ ! [P5: fun(A,fun(A,$o)),X4: A,Y4: A,Xs2: list(A)] : ( X2 != aa(list(A),product_prod(fun(A,fun(A,$o)),list(A)),aa(fun(A,fun(A,$o)),fun(list(A),product_prod(fun(A,fun(A,$o)),list(A))),product_Pair(fun(A,fun(A,$o)),list(A)),P5),aa(list(A),list(A),cons(A,X4),aa(list(A),list(A),cons(A,Y4),Xs2))) ) ) ) ).

% successively.cases
tff(fact_6248_insort__key_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),X2: A] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),X2),nil(A)) = aa(list(A),list(A),cons(A,X2),nil(A)) ) ) ).

% insort_key.simps(1)
tff(fact_6249_list_Osimps_I9_J,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),X21: B,X222: list(B)] : ( aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),cons(B,X21),X222)) = aa(list(A),list(A),cons(A,aa(B,A,F3,X21)),aa(list(B),list(A),map(B,A,F3),X222)) ) ).

% list.simps(9)
tff(fact_6250_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list(A),F3: fun(B,A),Ys: list(B)] :
      ( ( aa(list(A),list(A),cons(A,X2),Xs) = aa(list(B),list(A),map(B,A,F3),Ys) )
     => ? [Z2: B,Zs2: list(B)] :
          ( ( Ys = aa(list(B),list(B),cons(B,Z2),Zs2) )
          & ( X2 = aa(B,A,F3,Z2) )
          & ( Xs = aa(list(B),list(A),map(B,A,F3),Zs2) ) ) ) ).

% Cons_eq_map_D
tff(fact_6251_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),Xs: list(B),Y2: A,Ys: list(A)] :
      ( ( aa(list(B),list(A),map(B,A,F3),Xs) = aa(list(A),list(A),cons(A,Y2),Ys) )
     => ? [Z2: B,Zs2: list(B)] :
          ( ( Xs = aa(list(B),list(B),cons(B,Z2),Zs2) )
          & ( aa(B,A,F3,Z2) = Y2 )
          & ( aa(list(B),list(A),map(B,A,F3),Zs2) = Ys ) ) ) ).

% map_eq_Cons_D
tff(fact_6252_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list(A),F3: fun(B,A),Ys: list(B)] :
      ( ( aa(list(A),list(A),cons(A,X2),Xs) = aa(list(B),list(A),map(B,A,F3),Ys) )
    <=> ? [Z5: B,Zs3: list(B)] :
          ( ( Ys = aa(list(B),list(B),cons(B,Z5),Zs3) )
          & ( X2 = aa(B,A,F3,Z5) )
          & ( Xs = aa(list(B),list(A),map(B,A,F3),Zs3) ) ) ) ).

% Cons_eq_map_conv
tff(fact_6253_map__eq__Cons__conv,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),Xs: list(B),Y2: A,Ys: list(A)] :
      ( ( aa(list(B),list(A),map(B,A,F3),Xs) = aa(list(A),list(A),cons(A,Y2),Ys) )
    <=> ? [Z5: B,Zs3: list(B)] :
          ( ( Xs = aa(list(B),list(B),cons(B,Z5),Zs3) )
          & ( aa(B,A,F3,Z5) = Y2 )
          & ( aa(list(B),list(A),map(B,A,F3),Zs3) = Ys ) ) ) ).

% map_eq_Cons_conv
tff(fact_6254_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Xss: list(list(A))] : ( product_lists(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs),Xss)) = concat(list(A),aa(list(A),list(list(list(A))),map(A,list(list(A)),aTP_Lamp_xs(list(list(A)),fun(A,list(list(A))),Xss)),Xs)) ) ).

% product_lists.simps(2)
tff(fact_6255_foldr__Cons,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,fun(A,A)),X2: B,Xs: list(B)] : ( foldr(B,A,F3,aa(list(B),list(B),cons(B,X2),Xs)) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(B,fun(A,A),F3,X2)),foldr(B,A,F3,Xs)) ) ).

% foldr_Cons
tff(fact_6256_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list(A),Ys: list(B),Zs: list(C),Ws: list(D),P: fun(list(A),fun(list(B),fun(list(C),fun(list(D),$o))))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( ( aa(list(B),nat,size_size(list(B)),Ys) = aa(list(C),nat,size_size(list(C)),Zs) )
       => ( ( aa(list(C),nat,size_size(list(C)),Zs) = aa(list(D),nat,size_size(list(D)),Ws) )
         => ( aa(list(D),$o,aa(list(C),fun(list(D),$o),aa(list(B),fun(list(C),fun(list(D),$o)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),$o))),P,nil(A)),nil(B)),nil(C)),nil(D))
           => ( ! [X4: A,Xs2: list(A),Y4: B,Ys3: list(B),Z2: C,Zs2: list(C),W2: D,Ws2: list(D)] :
                  ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys3) )
                 => ( ( aa(list(B),nat,size_size(list(B)),Ys3) = aa(list(C),nat,size_size(list(C)),Zs2) )
                   => ( ( aa(list(C),nat,size_size(list(C)),Zs2) = aa(list(D),nat,size_size(list(D)),Ws2) )
                     => ( aa(list(D),$o,aa(list(C),fun(list(D),$o),aa(list(B),fun(list(C),fun(list(D),$o)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),$o))),P,Xs2),Ys3),Zs2),Ws2)
                       => aa(list(D),$o,aa(list(C),fun(list(D),$o),aa(list(B),fun(list(C),fun(list(D),$o)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),$o))),P,aa(list(A),list(A),cons(A,X4),Xs2)),aa(list(B),list(B),cons(B,Y4),Ys3)),aa(list(C),list(C),cons(C,Z2),Zs2)),aa(list(D),list(D),cons(D,W2),Ws2)) ) ) ) )
             => aa(list(D),$o,aa(list(C),fun(list(D),$o),aa(list(B),fun(list(C),fun(list(D),$o)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),$o))),P,Xs),Ys),Zs),Ws) ) ) ) ) ) ).

% list_induct4
tff(fact_6257_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys: list(B),Zs: list(C),P: fun(list(A),fun(list(B),fun(list(C),$o)))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( ( aa(list(B),nat,size_size(list(B)),Ys) = aa(list(C),nat,size_size(list(C)),Zs) )
       => ( aa(list(C),$o,aa(list(B),fun(list(C),$o),aa(list(A),fun(list(B),fun(list(C),$o)),P,nil(A)),nil(B)),nil(C))
         => ( ! [X4: A,Xs2: list(A),Y4: B,Ys3: list(B),Z2: C,Zs2: list(C)] :
                ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys3) )
               => ( ( aa(list(B),nat,size_size(list(B)),Ys3) = aa(list(C),nat,size_size(list(C)),Zs2) )
                 => ( aa(list(C),$o,aa(list(B),fun(list(C),$o),aa(list(A),fun(list(B),fun(list(C),$o)),P,Xs2),Ys3),Zs2)
                   => aa(list(C),$o,aa(list(B),fun(list(C),$o),aa(list(A),fun(list(B),fun(list(C),$o)),P,aa(list(A),list(A),cons(A,X4),Xs2)),aa(list(B),list(B),cons(B,Y4),Ys3)),aa(list(C),list(C),cons(C,Z2),Zs2)) ) ) )
           => aa(list(C),$o,aa(list(B),fun(list(C),$o),aa(list(A),fun(list(B),fun(list(C),$o)),P,Xs),Ys),Zs) ) ) ) ) ).

% list_induct3
tff(fact_6258_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),P: fun(list(A),fun(list(B),$o))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( aa(list(B),$o,aa(list(A),fun(list(B),$o),P,nil(A)),nil(B))
       => ( ! [X4: A,Xs2: list(A),Y4: B,Ys3: list(B)] :
              ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys3) )
             => ( aa(list(B),$o,aa(list(A),fun(list(B),$o),P,Xs2),Ys3)
               => aa(list(B),$o,aa(list(A),fun(list(B),$o),P,aa(list(A),list(A),cons(A,X4),Xs2)),aa(list(B),list(B),cons(B,Y4),Ys3)) ) )
         => aa(list(B),$o,aa(list(A),fun(list(B),$o),P,Xs),Ys) ) ) ) ).

% list_induct2
tff(fact_6259_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list(A),Nb: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,Nb) )
    <=> ? [Y: A,Ys4: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,Y),Ys4) )
          & ( aa(list(A),nat,size_size(list(A)),Ys4) = Nb ) ) ) ).

% length_Suc_conv
tff(fact_6260_Suc__length__conv,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( ( aa(nat,nat,suc,Nb) = aa(list(A),nat,size_size(list(A)),Xs) )
    <=> ? [Y: A,Ys4: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,Y),Ys4) )
          & ( aa(list(A),nat,size_size(list(A)),Ys4) = Nb ) ) ) ).

% Suc_length_conv
tff(fact_6261_length__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),cons(A,X2),Xs)) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_Cons
tff(fact_6262_impossible__Cons,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys))
     => ( Xs != aa(list(A),list(A),cons(A,X2),Ys) ) ) ).

% impossible_Cons
tff(fact_6263_take__Cons,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] : ( take(A,Nb,aa(list(A),list(A),cons(A,X2),Xs)) = case_nat(list(A),nil(A),aa(list(A),fun(nat,list(A)),aTP_Lamp_xt(A,fun(list(A),fun(nat,list(A))),X2),Xs),Nb) ) ).

% take_Cons
tff(fact_6264_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y2: A,Xs: list(A),Ys: list(A)] : aa(set(list(A)),$o,aa(set(list(A)),fun(set(list(A)),$o),ord_less_eq(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y2)),shuffles(A,Xs,Ys))),shuffles(A,Xs,aa(list(A),list(A),cons(A,Y2),Ys))) ).

% Cons_shuffles_subset2
tff(fact_6265_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Ys: list(A)] : aa(set(list(A)),$o,aa(set(list(A)),fun(set(list(A)),$o),ord_less_eq(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,X2)),shuffles(A,Xs,Ys))),shuffles(A,aa(list(A),list(A),cons(A,X2),Xs),Ys)) ).

% Cons_shuffles_subset1
tff(fact_6266_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y2: A,Ys: list(A),Xs: list(A)] :
      ( aa(set(list(A)),$o,member(list(A),aa(list(A),list(A),cons(A,Y2),Ys)),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs)))
     => aa(set(list(A)),$o,member(list(A),Ys),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs))) ) ).

% Cons_in_subseqsD
tff(fact_6267_nth__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Nb: nat] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X2),Xs)),Nb) = case_nat(A,X2,nth(A,Xs),Nb) ) ).

% nth_Cons
tff(fact_6268_Suc__le__length__iff,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Nb)),aa(list(A),nat,size_size(list(A)),Xs))
    <=> ? [X3: A,Ys4: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,X3),Ys4) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),aa(list(A),nat,size_size(list(A)),Ys4)) ) ) ).

% Suc_le_length_iff
tff(fact_6269_sorted1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A] : sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,X2),nil(A))) ) ).

% sorted1
tff(fact_6270_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Ys: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,X2),Ys))
        <=> ( ! [X3: A] :
                ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Ys))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),X3) )
            & sorted_wrt(A,ord_less_eq(A),Ys) ) ) ) ).

% sorted_simps(2)
tff(fact_6271_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Ys: list(A)] :
          ( sorted_wrt(A,ord_less(A),aa(list(A),list(A),cons(A,X2),Ys))
        <=> ( ! [X3: A] :
                ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Ys))
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),X3) )
            & sorted_wrt(A,ord_less(A),Ys) ) ) ) ).

% strict_sorted_simps(2)
tff(fact_6272_insort__is__Cons,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Xs: list(A),F3: fun(A,B),A2: A] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,A2)),aa(A,B,F3,X4)) )
         => ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),A2),Xs) = aa(list(A),list(A),cons(A,A2),Xs) ) ) ) ).

% insort_is_Cons
tff(fact_6273_listrel1I1,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set(product_prod(A,A)),Xs: list(A)] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),R)
     => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X2),Xs)),aa(list(A),list(A),cons(A,Y2),Xs))),listrel1(A,R)) ) ).

% listrel1I1
tff(fact_6274_Cons__listrel1E1,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Ys: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X2),Xs)),Ys)),listrel1(A,R))
     => ( ! [Y4: A] :
            ( ( Ys = aa(list(A),list(A),cons(A,Y4),Xs) )
           => ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y4)),R) )
       => ~ ! [Zs2: list(A)] :
              ( ( Ys = aa(list(A),list(A),cons(A,X2),Zs2) )
             => ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Zs2)),listrel1(A,R)) ) ) ) ).

% Cons_listrel1E1
tff(fact_6275_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list(A),Y2: A,Ys: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),aa(list(A),list(A),cons(A,Y2),Ys))),listrel1(A,R))
     => ( ! [X4: A] :
            ( ( Xs = aa(list(A),list(A),cons(A,X4),Ys) )
           => ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y2)),R) )
       => ~ ! [Zs2: list(A)] :
              ( ( Xs = aa(list(A),list(A),cons(A,Y2),Zs2) )
             => ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Zs2),Ys)),listrel1(A,R)) ) ) ) ).

% Cons_listrel1E2
tff(fact_6276_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Y2: A] :
      ( aa(A,nat,count_list(A,aa(list(A),list(A),cons(A,X2),Xs)),Y2)
      = $ite(X2 = Y2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,count_list(A,Xs),Y2)),one_one(nat)),aa(A,nat,count_list(A,Xs),Y2)) ) ).

% count_list.simps(2)
tff(fact_6277_the__elem__set,axiom,
    ! [A: $tType,X2: A] : ( the_elem(A,aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X2),nil(A)))) = X2 ) ).

% the_elem_set
tff(fact_6278_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),cons(A,X21),X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),X222)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size(4)
tff(fact_6279_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( n_lists(A,aa(nat,nat,suc,Nb),Xs) = concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),aTP_Lamp_xv(list(A),fun(list(A),list(list(A))),Xs)),n_lists(A,Nb,Xs))) ) ).

% n_lists.simps(2)
tff(fact_6280_nth__Cons_H,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Nb: nat] :
      ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X2),Xs)),Nb)
      = $ite(Nb = zero_zero(nat),X2,aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)))) ) ).

% nth_Cons'
tff(fact_6281_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: fun(A,nat),X21: A,X222: list(A)] : ( aa(list(A),nat,size_list(A,X2),aa(list(A),list(A),cons(A,X21),X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,X2,X21)),aa(list(A),nat,size_list(A,X2),X222))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size_gen(2)
tff(fact_6282_map__upt__Suc,axiom,
    ! [A: $tType,F3: fun(nat,A),Nb: nat] : ( aa(list(nat),list(A),map(nat,A,F3),upt(zero_zero(nat),aa(nat,nat,suc,Nb))) = aa(list(A),list(A),cons(A,aa(nat,A,F3,zero_zero(nat))),aa(list(nat),list(A),map(nat,A,aTP_Lamp_xw(fun(nat,A),fun(nat,A),F3)),upt(zero_zero(nat),Nb))) ) ).

% map_upt_Suc
tff(fact_6283_nth__equal__first__eq,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Nb: nat] :
      ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
       => ( ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X2),Xs)),Nb) = X2 )
        <=> ( Nb = zero_zero(nat) ) ) ) ) ).

% nth_equal_first_eq
tff(fact_6284_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list(A),Nb: nat] :
      ( ( X2 != Y2 )
     => ( ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,X2),Xs)),Nb) = Y2 )
      <=> ( ( aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))) = Y2 )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb) ) ) ) ).

% nth_non_equal_first_eq
tff(fact_6285_take__Cons_H,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] :
      ( take(A,Nb,aa(list(A),list(A),cons(A,X2),Xs))
      = $ite(Nb = zero_zero(nat),nil(A),aa(list(A),list(A),cons(A,X2),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)),Xs))) ) ).

% take_Cons'
tff(fact_6286_Cons__replicate__eq,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Nb: nat,Y2: A] :
      ( ( aa(list(A),list(A),cons(A,X2),Xs) = replicate(A,Nb,Y2) )
    <=> ( ( X2 = Y2 )
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
        & ( Xs = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)),X2) ) ) ) ).

% Cons_replicate_eq
tff(fact_6287_Cons__lenlex__iff,axiom,
    ! [A: $tType,Ma: A,Ms: list(A),Nb: A,Ns: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,Ma),Ms)),aa(list(A),list(A),cons(A,Nb),Ns))),lenlex(A,R))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),Ms)),aa(list(A),nat,size_size(list(A)),Ns))
        | ( ( aa(list(A),nat,size_size(list(A)),Ms) = aa(list(A),nat,size_size(list(A)),Ns) )
          & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Ma),Nb)),R) )
        | ( ( Ma = Nb )
          & aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ms),Ns)),lenlex(A,R)) ) ) ) ).

% Cons_lenlex_iff
tff(fact_6288_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A3: set(A)] : ( set_Cons(A,A3,aa(set(list(A)),set(list(A)),insert(list(A),nil(A)),bot_bot(set(list(A))))) = aa(set(A),set(list(A)),image(A,list(A),aTP_Lamp_xx(A,list(A))),A3) ) ).

% set_Cons_sing_Nil
tff(fact_6289_concat__inth,axiom,
    ! [A: $tType,Xs: list(A),X2: A,Ys: list(A)] : ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,X2),nil(A))),Ys))),aa(list(A),nat,size_size(list(A)),Xs)) = X2 ) ).

% concat_inth
tff(fact_6290_same__append__eq,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs) )
    <=> ( Ys = Zs ) ) ).

% same_append_eq
tff(fact_6291_append__same__eq,axiom,
    ! [A: $tType,Ys: list(A),Xs: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Zs),Xs) )
    <=> ( Ys = Zs ) ) ).

% append_same_eq
tff(fact_6292_append__assoc,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),Zs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Zs)) ) ).

% append_assoc
tff(fact_6293_append_Oassoc,axiom,
    ! [A: $tType,A2: list(A),B2: list(A),C2: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),A2),B2)),C2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),A2),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),B2),C2)) ) ).

% append.assoc
tff(fact_6294_append_Oright__neutral,axiom,
    ! [A: $tType,A2: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),A2),nil(A)) = A2 ) ).

% append.right_neutral
tff(fact_6295_append__Nil2,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),nil(A)) = Xs ) ).

% append_Nil2
tff(fact_6296_append__self__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = Xs )
    <=> ( Ys = nil(A) ) ) ).

% append_self_conv
tff(fact_6297_self__append__conv,axiom,
    ! [A: $tType,Y2: list(A),Ys: list(A)] :
      ( ( Y2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Y2),Ys) )
    <=> ( Ys = nil(A) ) ) ).

% self_append_conv
tff(fact_6298_append__self__conv2,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = Ys )
    <=> ( Xs = nil(A) ) ) ).

% append_self_conv2
tff(fact_6299_self__append__conv2,axiom,
    ! [A: $tType,Y2: list(A),Xs: list(A)] :
      ( ( Y2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Y2) )
    <=> ( Xs = nil(A) ) ) ).

% self_append_conv2
tff(fact_6300_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( nil(A) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) )
    <=> ( ( Xs = nil(A) )
        & ( Ys = nil(A) ) ) ) ).

% Nil_is_append_conv
tff(fact_6301_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = nil(A) )
    <=> ( ( Xs = nil(A) )
        & ( Ys = nil(A) ) ) ) ).

% append_is_Nil_conv
tff(fact_6302_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Us: list(A),Vs: list(A)] :
      ( ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
        | ( aa(list(A),nat,size_size(list(A)),Us) = aa(list(A),nat,size_size(list(A)),Vs) ) )
     => ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Vs) )
      <=> ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
tff(fact_6303_map__append,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B),Ys: list(B)] : ( aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(B),list(A),map(B,A,F3),Xs)),aa(list(B),list(A),map(B,A,F3),Ys)) ) ).

% map_append
tff(fact_6304_filter__append,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Ys: list(A)] : ( aa(list(A),list(A),filter2(A,P),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),filter2(A,P),Xs)),aa(list(A),list(A),filter2(A,P),Ys)) ) ).

% filter_append
tff(fact_6305_rev__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),list(A),rev(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),rev(A),Ys)),aa(list(A),list(A),rev(A),Xs)) ) ).

% rev_append
tff(fact_6306_concat__append,axiom,
    ! [A: $tType,Xs: list(list(A)),Ys: list(list(A))] : ( concat(A,aa(list(list(A)),list(list(A)),aa(list(list(A)),fun(list(list(A)),list(list(A))),append(list(A)),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),concat(A,Xs)),concat(A,Ys)) ) ).

% concat_append
tff(fact_6307_foldr__append,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,fun(A,A)),Xs: list(B),Ys: list(B),A2: A] : ( aa(A,A,foldr(B,A,F3,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)),A2) = aa(A,A,foldr(B,A,F3,Xs),aa(A,A,foldr(B,A,F3,Ys),A2)) ) ).

% foldr_append
tff(fact_6308_removeAll__append,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Ys: list(A)] : ( aa(list(A),list(A),removeAll(A,X2),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),removeAll(A,X2),Xs)),aa(list(A),list(A),removeAll(A,X2),Ys)) ) ).

% removeAll_append
tff(fact_6309_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list(A),X2: A,Ys: list(A),Y2: A] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),nil(A))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),aa(list(A),list(A),cons(A,Y2),nil(A))) )
    <=> ( ( Xs = Ys )
        & ( X2 = Y2 ) ) ) ).

% append1_eq_conv
tff(fact_6310_length__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys)) ) ).

% length_append
tff(fact_6311_sum__list__append,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A),Ys: list(A)] : ( groups8242544230860333062m_list(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups8242544230860333062m_list(A,Xs)),groups8242544230860333062m_list(A,Ys)) ) ) ).

% sum_list_append
tff(fact_6312_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o),Ys: list(A)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X4) )
     => ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),takeWhile(A,P,Ys)) ) ) ).

% takeWhile_append2
tff(fact_6313_takeWhile__append1,axiom,
    ! [A: $tType,X2: A,Xs: list(A),P: fun(A,$o),Ys: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( ~ aa(A,$o,P,X2)
       => ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = takeWhile(A,P,Xs) ) ) ) ).

% takeWhile_append1
tff(fact_6314_fun__upds__append2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),Ma: fun(A,option(B)),Zs: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( map_upds(A,B,Ma,Xs,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Ys),Zs)) = map_upds(A,B,Ma,Xs,Ys) ) ) ).

% fun_upds_append2_drop
tff(fact_6315_fun__upds__append__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),Ma: fun(A,option(B)),Zs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( map_upds(A,B,Ma,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs),Ys) = map_upds(A,B,Ma,Xs,Ys) ) ) ).

% fun_upds_append_drop
tff(fact_6316_size__list__append,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A),Ys: list(A)] : ( aa(list(A),nat,size_list(A,F3),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_list(A,F3),Xs)),aa(list(A),nat,size_list(A,F3),Ys)) ) ).

% size_list_append
tff(fact_6317_nth__append__length,axiom,
    ! [A: $tType,Xs: list(A),X2: A,Ys: list(A)] : ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),Ys))),aa(list(A),nat,size_size(list(A)),Xs)) = X2 ) ).

% nth_append_length
tff(fact_6318_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Nb: nat] : ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb)) = aa(nat,A,nth(A,Ys),Nb) ) ).

% nth_append_length_plus
tff(fact_6319_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list(A),Y2: A,Ys: list(A)] :
      ( ( aa(list(A),list(A),rev(A),Xs) = aa(list(A),list(A),cons(A,Y2),Ys) )
    <=> ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),rev(A),Ys)),aa(list(A),list(A),cons(A,Y2),nil(A))) ) ) ).

% rev_eq_Cons_iff
tff(fact_6320_take__append,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),Ys: list(A)] : ( take(A,Nb,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,Nb,Xs)),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% take_append
tff(fact_6321_list__update__length,axiom,
    ! [A: $tType,Xs: list(A),X2: A,Ys: list(A),Y2: A] : ( list_update(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),Ys)),aa(list(A),nat,size_size(list(A)),Xs),Y2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,Y2),Ys)) ) ).

% list_update_length
tff(fact_6322_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] : ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,suc,K))) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),aa(set(nat),list(nat),linord4507533701916653071of_set(nat),aa(nat,set(nat),set_ord_lessThan(nat),K))),aa(list(nat),list(nat),cons(nat,K),nil(nat))) ) ).

% sorted_list_of_set_lessThan_Suc
tff(fact_6323_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] : ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),aa(nat,set(nat),set_ord_atMost(nat),aa(nat,nat,suc,K))) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),aa(set(nat),list(nat),linord4507533701916653071of_set(nat),aa(nat,set(nat),set_ord_atMost(nat),K))),aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,K)),nil(nat))) ) ).

% sorted_list_of_set_atMost_Suc
tff(fact_6324_distinct__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( distinct(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))
    <=> ( distinct(A,Xs)
        & distinct(A,Ys)
        & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) ) ) ) ).

% distinct_append
tff(fact_6325_upt__rec__numeral,axiom,
    ! [Ma: num,Nb: num] :
      ( upt(aa(num,nat,numeral_numeral(nat),Ma),aa(num,nat,numeral_numeral(nat),Nb))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),Ma)),aa(num,nat,numeral_numeral(nat),Nb)),aa(list(nat),list(nat),cons(nat,aa(num,nat,numeral_numeral(nat),Ma)),upt(aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),Ma)),aa(num,nat,numeral_numeral(nat),Nb))),nil(nat)) ) ).

% upt_rec_numeral
tff(fact_6326_n__lists__Nil,axiom,
    ! [A: $tType,Nb: nat] :
      ( n_lists(A,Nb,nil(A))
      = $ite(Nb = zero_zero(nat),aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))),nil(list(A))) ) ).

% n_lists_Nil
tff(fact_6327_takeWhile__tail,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A),L: list(A)] :
      ( ~ aa(A,$o,P,X2)
     => ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),L))) = takeWhile(A,P,Xs) ) ) ).

% takeWhile_tail
tff(fact_6328_concat__conv__foldr,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( concat(A,Xss) = aa(list(A),list(A),foldr(list(A),list(A),append(A),Xss),nil(A)) ) ).

% concat_conv_foldr
tff(fact_6329_upt__Suc__append,axiom,
    ! [I3: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( upt(I3,aa(nat,nat,suc,J2)) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),upt(I3,J2)),aa(list(nat),list(nat),cons(nat,J2),nil(nat))) ) ) ).

% upt_Suc_append
tff(fact_6330_upt__Suc,axiom,
    ! [I3: nat,J2: nat] :
      ( upt(I3,aa(nat,nat,suc,J2))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2),aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),upt(I3,J2)),aa(list(nat),list(nat),cons(nat,J2),nil(nat))),nil(nat)) ) ).

% upt_Suc
tff(fact_6331_split__list,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ? [Ys3: list(A),Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) ) ) ).

% split_list
tff(fact_6332_split__list__last,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ? [Ys3: list(A),Zs2: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) )
          & ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Zs2)) ) ) ).

% split_list_last
tff(fact_6333_split__list__prop,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Xs))
          & aa(A,$o,P,X) )
     => ? [Ys3: list(A),X4: A] :
          ( ? [Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X4),Zs2)) )
          & aa(A,$o,P,X4) ) ) ).

% split_list_prop
tff(fact_6334_split__list__first,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ? [Ys3: list(A),Zs2: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X2),Zs2)) )
          & ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Ys3)) ) ) ).

% split_list_first
tff(fact_6335_split__list__propE,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Xs))
          & aa(A,$o,P,X) )
     => ~ ! [Ys3: list(A),X4: A] :
            ( ? [Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X4),Zs2)) )
           => ~ aa(A,$o,P,X4) ) ) ).

% split_list_propE
tff(fact_6336_append__Cons__eq__iff,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Ys: list(A),Xs5: list(A),Ys6: list(A)] :
      ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Ys))
       => ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs5),aa(list(A),list(A),cons(A,X2),Ys6)) )
        <=> ( ( Xs = Xs5 )
            & ( Ys = Ys6 ) ) ) ) ) ).

% append_Cons_eq_iff
tff(fact_6337_in__set__conv__decomp,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
    <=> ? [Ys4: list(A),Zs3: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X2),Zs3)) ) ) ).

% in_set_conv_decomp
tff(fact_6338_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Xs))
          & aa(A,$o,P,X) )
     => ? [Ys3: list(A),X4: A,Zs2: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X4),Zs2)) )
          & aa(A,$o,P,X4)
          & ! [Xa3: A] :
              ( aa(set(A),$o,member(A,Xa3),aa(list(A),set(A),set2(A),Zs2))
             => ~ aa(A,$o,P,Xa3) ) ) ) ).

% split_list_last_prop
tff(fact_6339_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Xs))
          & aa(A,$o,P,X) )
     => ? [Ys3: list(A),X4: A] :
          ( ? [Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X4),Zs2)) )
          & aa(A,$o,P,X4)
          & ! [Xa3: A] :
              ( aa(set(A),$o,member(A,Xa3),aa(list(A),set(A),set2(A),Ys3))
             => ~ aa(A,$o,P,Xa3) ) ) ) ).

% split_list_first_prop
tff(fact_6340_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Xs))
          & aa(A,$o,P,X) )
     => ~ ! [Ys3: list(A),X4: A,Zs2: list(A)] :
            ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X4),Zs2)) )
           => ( aa(A,$o,P,X4)
             => ~ ! [Xa3: A] :
                    ( aa(set(A),$o,member(A,Xa3),aa(list(A),set(A),set2(A),Zs2))
                   => ~ aa(A,$o,P,Xa3) ) ) ) ) ).

% split_list_last_propE
tff(fact_6341_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ? [X: A] :
          ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Xs))
          & aa(A,$o,P,X) )
     => ~ ! [Ys3: list(A),X4: A] :
            ( ? [Zs2: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,X4),Zs2)) )
           => ( aa(A,$o,P,X4)
             => ~ ! [Xa3: A] :
                    ( aa(set(A),$o,member(A,Xa3),aa(list(A),set(A),set2(A),Ys3))
                   => ~ aa(A,$o,P,Xa3) ) ) ) ) ).

% split_list_first_propE
tff(fact_6342_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
    <=> ? [Ys4: list(A),Zs3: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X2),Zs3)) )
          & ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Zs3)) ) ) ).

% in_set_conv_decomp_last
tff(fact_6343_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
    <=> ? [Ys4: list(A),Zs3: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X2),Zs3)) )
          & ~ aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Ys4)) ) ) ).

% in_set_conv_decomp_first
tff(fact_6344_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ? [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
          & aa(A,$o,P,X3) )
    <=> ? [Ys4: list(A),X3: A,Zs3: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X3),Zs3)) )
          & aa(A,$o,P,X3)
          & ! [Xa: A] :
              ( aa(set(A),$o,member(A,Xa),aa(list(A),set(A),set2(A),Zs3))
             => ~ aa(A,$o,P,Xa) ) ) ) ).

% split_list_last_prop_iff
tff(fact_6345_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ? [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
          & aa(A,$o,P,X3) )
    <=> ? [Ys4: list(A),X3: A] :
          ( ? [Zs3: list(A)] : ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,X3),Zs3)) )
          & aa(A,$o,P,X3)
          & ! [Xa: A] :
              ( aa(set(A),$o,member(A,Xa),aa(list(A),set(A),set2(A),Ys4))
             => ~ aa(A,$o,P,Xa) ) ) ) ).

% split_list_first_prop_iff
tff(fact_6346_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A3: set(A),As2: list(set(A))] : ( listset(A,aa(list(set(A)),list(set(A)),cons(set(A),A3),As2)) = set_Cons(A,A3,listset(A,As2)) ) ).

% listset.simps(2)
tff(fact_6347_append__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Ys: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,X2),Xs)),Ys) = aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) ) ).

% append_Cons
tff(fact_6348_Cons__eq__appendI,axiom,
    ! [A: $tType,X2: A,Xs1: list(A),Ys: list(A),Xs: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X2),Xs1) = Ys )
     => ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs1),Zs) )
       => ( aa(list(A),list(A),cons(A,X2),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Zs) ) ) ) ).

% Cons_eq_appendI
tff(fact_6349_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X2: list(A),Xs: list(list(A))] : ( concat(A,aa(list(list(A)),list(list(A)),cons(list(A),X2),Xs)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X2),concat(A,Xs)) ) ).

% concat.simps(2)
tff(fact_6350_replicate__app__Cons__same,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,Nb,X2)),aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,Nb,X2)),Xs)) ) ).

% replicate_app_Cons_same
tff(fact_6351_append__Nil,axiom,
    ! [A: $tType,Ys: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),nil(A)),Ys) = Ys ) ).

% append_Nil
tff(fact_6352_append_Oleft__neutral,axiom,
    ! [A: $tType,A2: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),nil(A)),A2) = A2 ) ).

% append.left_neutral
tff(fact_6353_rev__induct,axiom,
    ! [A: $tType,P: fun(list(A),$o),Xs: list(A)] :
      ( aa(list(A),$o,P,nil(A))
     => ( ! [X4: A,Xs2: list(A)] :
            ( aa(list(A),$o,P,Xs2)
           => aa(list(A),$o,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs2),aa(list(A),list(A),cons(A,X4),nil(A)))) )
       => aa(list(A),$o,P,Xs) ) ) ).

% rev_induct
tff(fact_6354_rev__exhaust,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ~ ! [Ys3: list(A),Y4: A] : ( Xs != aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),cons(A,Y4),nil(A))) ) ) ).

% rev_exhaust
tff(fact_6355_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs = Ys )
     => ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),nil(A)),Ys) ) ) ).

% eq_Nil_appendI
tff(fact_6356_Cons__eq__append__conv,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X2),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Zs) )
    <=> ( ( ( Ys = nil(A) )
          & ( aa(list(A),list(A),cons(A,X2),Xs) = Zs ) )
        | ? [Ys7: list(A)] :
            ( ( aa(list(A),list(A),cons(A,X2),Ys7) = Ys )
            & ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys7),Zs) ) ) ) ) ).

% Cons_eq_append_conv
tff(fact_6357_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys: list(A),Zs: list(A),X2: A,Xs: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Zs) = aa(list(A),list(A),cons(A,X2),Xs) )
    <=> ( ( ( Ys = nil(A) )
          & ( Zs = aa(list(A),list(A),cons(A,X2),Xs) ) )
        | ? [Ys7: list(A)] :
            ( ( Ys = aa(list(A),list(A),cons(A,X2),Ys7) )
            & ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys7),Zs) = Xs ) ) ) ) ).

% append_eq_Cons_conv
tff(fact_6358_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list(A),P: fun(list(A),$o)] :
      ( ( Xs != nil(A) )
     => ( ! [X4: A] : aa(list(A),$o,P,aa(list(A),list(A),cons(A,X4),nil(A)))
       => ( ! [X4: A,Xs2: list(A)] :
              ( ( Xs2 != nil(A) )
             => ( aa(list(A),$o,P,Xs2)
               => aa(list(A),$o,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs2),aa(list(A),list(A),cons(A,X4),nil(A)))) ) )
         => aa(list(A),$o,P,Xs) ) ) ) ).

% rev_nonempty_induct
tff(fact_6359_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list(list(A)),Ys: list(A),Zs: list(A)] :
      ( ( concat(A,Xss) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Zs) )
     => ( ( Xss != nil(list(A)) )
       => ? [Xss1: list(list(A)),Xs2: list(A),Xs4: list(A),Xss22: list(list(A))] :
            ( ( Xss = aa(list(list(A)),list(list(A)),aa(list(list(A)),fun(list(list(A)),list(list(A))),append(list(A)),Xss1),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs2),Xs4)),Xss22)) )
            & ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),concat(A,Xss1)),Xs2) )
            & ( Zs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs4),concat(A,Xss22)) ) ) ) ) ).

% concat_eq_appendD
tff(fact_6360_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list(list(A)),Ys: list(A),Zs: list(A)] :
      ( ( concat(A,Xss) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Zs) )
    <=> $ite(
          Xss = nil(list(A)),
          ( ( Ys = nil(A) )
          & ( Zs = nil(A) ) ),
          ? [Xss12: list(list(A)),Xs3: list(A),Xs6: list(A),Xss23: list(list(A))] :
            ( ( Xss = aa(list(list(A)),list(list(A)),aa(list(list(A)),fun(list(list(A)),list(list(A))),append(list(A)),Xss12),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs3),Xs6)),Xss23)) )
            & ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),concat(A,Xss12)),Xs3) )
            & ( Zs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs6),concat(A,Xss23)) ) ) ) ) ).

% concat_eq_append_conv
tff(fact_6361_upt__conv__Cons__Cons,axiom,
    ! [Ma: nat,Nb: nat,Ns: list(nat),Q2: nat] :
      ( ( aa(list(nat),list(nat),cons(nat,Ma),aa(list(nat),list(nat),cons(nat,Nb),Ns)) = upt(Ma,Q2) )
    <=> ( aa(list(nat),list(nat),cons(nat,Nb),Ns) = upt(aa(nat,nat,suc,Ma),Q2) ) ) ).

% upt_conv_Cons_Cons
tff(fact_6362_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss)) = transpose(A,Xss) ) ).

% transpose.simps(2)
tff(fact_6363_enumerate__append__eq,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),Ys: list(A)] : ( enumerate(A,Nb,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(product_prod(nat,A)),list(product_prod(nat,A)),aa(list(product_prod(nat,A)),fun(list(product_prod(nat,A)),list(product_prod(nat,A))),append(product_prod(nat,A)),enumerate(A,Nb,Xs)),enumerate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% enumerate_append_eq
tff(fact_6364_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list(A),Zs: list(A),R: set(product_prod(A,A)),Xs: list(A)] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs)),lex(A,R))
     => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lex(A,R)) ) ).

% lex_append_leftI
tff(fact_6365_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B),Ys: list(A),Zs: list(A)] :
      ( ( aa(list(B),list(A),map(B,A,F3),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Zs) )
    <=> ? [Us2: list(B),Vs2: list(B)] :
          ( ( Xs = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us2),Vs2) )
          & ( Ys = aa(list(B),list(A),map(B,A,F3),Us2) )
          & ( Zs = aa(list(B),list(A),map(B,A,F3),Vs2) ) ) ) ).

% map_eq_append_conv
tff(fact_6366_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list(A),Zs: list(A),F3: fun(B,A),Xs: list(B)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Zs) = aa(list(B),list(A),map(B,A,F3),Xs) )
    <=> ? [Us2: list(B),Vs2: list(B)] :
          ( ( Xs = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us2),Vs2) )
          & ( Ys = aa(list(B),list(A),map(B,A,F3),Us2) )
          & ( Zs = aa(list(B),list(A),map(B,A,F3),Vs2) ) ) ) ).

% append_eq_map_conv
tff(fact_6367_append__replicate__commute,axiom,
    ! [A: $tType,Nb: nat,X2: A,K: nat] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,Nb,X2)),replicate(A,K,X2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,K,X2)),replicate(A,Nb,X2)) ) ).

% append_replicate_commute
tff(fact_6368_replicate__add,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,X2: A] : ( replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma),X2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,Nb,X2)),replicate(A,Ma,X2)) ) ).

% replicate_add
tff(fact_6369_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A),Ts: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Zs),Ts) )
    <=> ? [Us2: list(A)] :
          ( ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Zs),Us2) )
            & ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),Ys) = Ts ) )
          | ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us2) = Zs )
            & ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),Ts) ) ) ) ) ).

% append_eq_append_conv2
tff(fact_6370_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list(A),Xs1: list(A),Zs: list(A),Ys: list(A),Us: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Xs1) = Zs )
     => ( ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs1),Us) )
       => ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Zs),Us) ) ) ) ).

% append_eq_appendI
tff(fact_6371_sorted__wrt__append,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xs: list(A),Ys: list(A)] :
      ( sorted_wrt(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))
    <=> ( sorted_wrt(A,P,Xs)
        & sorted_wrt(A,P,Ys)
        & ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
           => ! [Xa: A] :
                ( aa(set(A),$o,member(A,Xa),aa(list(A),set(A),set2(A),Ys))
               => aa(A,$o,aa(A,fun(A,$o),P,X3),Xa) ) ) ) ) ).

% sorted_wrt_append
tff(fact_6372_append__listrel1I,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A)),Us: list(A),Vs: list(A)] :
      ( ( ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,R))
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Us),Vs)),listrel1(A,R)) ) )
     => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Vs))),listrel1(A,R)) ) ).

% append_listrel1I
tff(fact_6373_remove1__append,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Ys: list(A)] :
      ( remove1(A,X2,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))
      = $ite(aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),remove1(A,X2,Xs)),Ys),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),remove1(A,X2,Ys))) ) ).

% remove1_append
tff(fact_6374_remdups__append2,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( remdups(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),remdups(A,Ys))) = remdups(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) ) ).

% remdups_append2
tff(fact_6375_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Xs) )
     => ? [M3: nat,N: nat,Zs2: list(A)] :
          ( ( concat(A,replicate(list(A),M3,Zs2)) = Xs )
          & ( concat(A,replicate(list(A),N,Zs2)) = Ys ) ) ) ).

% comm_append_are_replicate
tff(fact_6376_same__length__different,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs != Ys )
     => ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
       => ? [Pre: list(A),X4: A,Xs4: list(A),Y4: A,Ys5: list(A)] :
            ( ( X4 != Y4 )
            & ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Pre),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,X4),nil(A))),Xs4)) )
            & ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Pre),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,Y4),nil(A))),Ys5)) ) ) ) ) ).

% same_length_different
tff(fact_6377_sorted__append,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))
        <=> ( sorted_wrt(A,ord_less_eq(A),Xs)
            & sorted_wrt(A,ord_less_eq(A),Ys)
            & ! [X3: A] :
                ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
               => ! [Xa: A] :
                    ( aa(set(A),$o,member(A,Xa),aa(list(A),set(A),set2(A),Ys))
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Xa) ) ) ) ) ) ).

% sorted_append
tff(fact_6378_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list(A)] :
      ( ~ distinct(A,Ws)
     => ? [Xs2: list(A),Ys3: list(A),Zs2: list(A),Y4: A] : ( Ws = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs2),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,Y4),nil(A))),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys3),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,Y4),nil(A))),Zs2)))) ) ) ).

% not_distinct_decomp
tff(fact_6379_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As3: list(A)] :
      ( ~ distinct(A,As3)
    <=> ? [Xs3: list(A),Y: A,Ys4: list(A)] :
          ( aa(set(A),$o,member(A,Y),aa(list(A),set(A),set2(A),Xs3))
          & distinct(A,Xs3)
          & ( As3 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs3),aa(list(A),list(A),cons(A,Y),Ys4)) ) ) ) ).

% not_distinct_conv_prefix
tff(fact_6380_Cons__eq__filterD,axiom,
    ! [A: $tType,X2: A,Xs: list(A),P: fun(A,$o),Ys: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X2),Xs) = aa(list(A),list(A),filter2(A,P),Ys) )
     => ? [Us3: list(A),Vs3: list(A)] :
          ( ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),cons(A,X2),Vs3)) )
          & ! [X: A] :
              ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Us3))
             => ~ aa(A,$o,P,X) )
          & aa(A,$o,P,X2)
          & ( Xs = aa(list(A),list(A),filter2(A,P),Vs3) ) ) ) ).

% Cons_eq_filterD
tff(fact_6381_filter__eq__ConsD,axiom,
    ! [A: $tType,P: fun(A,$o),Ys: list(A),X2: A,Xs: list(A)] :
      ( ( aa(list(A),list(A),filter2(A,P),Ys) = aa(list(A),list(A),cons(A,X2),Xs) )
     => ? [Us3: list(A),Vs3: list(A)] :
          ( ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),cons(A,X2),Vs3)) )
          & ! [X: A] :
              ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Us3))
             => ~ aa(A,$o,P,X) )
          & aa(A,$o,P,X2)
          & ( Xs = aa(list(A),list(A),filter2(A,P),Vs3) ) ) ) ).

% filter_eq_ConsD
tff(fact_6382_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X2: A,Xs: list(A),P: fun(A,$o),Ys: list(A)] :
      ( ( aa(list(A),list(A),cons(A,X2),Xs) = aa(list(A),list(A),filter2(A,P),Ys) )
    <=> ? [Us2: list(A),Vs2: list(A)] :
          ( ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),cons(A,X2),Vs2)) )
          & ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Us2))
             => ~ aa(A,$o,P,X3) )
          & aa(A,$o,P,X2)
          & ( Xs = aa(list(A),list(A),filter2(A,P),Vs2) ) ) ) ).

% Cons_eq_filter_iff
tff(fact_6383_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Ys: list(A),X2: A,Xs: list(A)] :
      ( ( aa(list(A),list(A),filter2(A,P),Ys) = aa(list(A),list(A),cons(A,X2),Xs) )
    <=> ? [Us2: list(A),Vs2: list(A)] :
          ( ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),cons(A,X2),Vs2)) )
          & ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Us2))
             => ~ aa(A,$o,P,X3) )
          & aa(A,$o,P,X2)
          & ( Xs = aa(list(A),list(A),filter2(A,P),Vs2) ) ) ) ).

% filter_eq_Cons_iff
tff(fact_6384_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( aa(list(A),list(A),rev(A),aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),rev(A),Xs)),aa(list(A),list(A),cons(A,X2),nil(A))) ) ).

% rev.simps(2)
tff(fact_6385_replicate__append__same,axiom,
    ! [A: $tType,I3: nat,X2: A] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),replicate(A,I3,X2)),aa(list(A),list(A),cons(A,X2),nil(A))) = aa(list(A),list(A),cons(A,X2),replicate(A,I3,X2)) ) ).

% replicate_append_same
tff(fact_6386_upt__add__eq__append,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( upt(I3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) = aa(list(nat),list(nat),aa(list(nat),fun(list(nat),list(nat)),append(nat),upt(I3,J2)),upt(J2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K))) ) ) ).

% upt_add_eq_append
tff(fact_6387_list__update__append1,axiom,
    ! [A: $tType,I3: nat,Xs: list(A),Ys: list(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( list_update(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys),I3,X2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),list_update(A,Xs,I3,X2)),Ys) ) ) ).

% list_update_append1
tff(fact_6388_remove1__split,axiom,
    ! [A: $tType,A2: A,Xs: list(A),Ys: list(A)] :
      ( aa(set(A),$o,member(A,A2),aa(list(A),set(A),set2(A),Xs))
     => ( ( remove1(A,A2,Xs) = Ys )
      <=> ? [Ls: list(A),Rs: list(A)] :
            ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ls),aa(list(A),list(A),cons(A,A2),Rs)) )
            & ~ aa(set(A),$o,member(A,A2),aa(list(A),set(A),set2(A),Ls))
            & ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ls),Rs) ) ) ) ) ).

% remove1_split
tff(fact_6389_upt__conv__Cons,axiom,
    ! [I3: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ( upt(I3,J2) = aa(list(nat),list(nat),cons(nat,I3),upt(aa(nat,nat,suc,I3),J2)) ) ) ).

% upt_conv_Cons
tff(fact_6390_lex__append__leftD,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ! [X4: A] : ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4)),R)
     => ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lex(A,R))
       => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs)),lex(A,R)) ) ) ).

% lex_append_leftD
tff(fact_6391_lex__append__left__iff,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ! [X4: A] : ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4)),R)
     => ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lex(A,R))
      <=> aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs)),lex(A,R)) ) ) ).

% lex_append_left_iff
tff(fact_6392_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( rotate1(A,aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),nil(A))) ) ).

% rotate1.simps(2)
tff(fact_6393_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A)),Vs: list(A),Us: list(A)] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lex(A,R))
     => ( ( aa(list(A),nat,size_size(list(A)),Vs) = aa(list(A),nat,size_size(list(A)),Us) )
       => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Vs))),lex(A,R)) ) ) ).

% lex_append_rightI
tff(fact_6394_lenlex__append1,axiom,
    ! [A: $tType,Us: list(A),Xs: list(A),R3: set(product_prod(A,A)),Vs: list(A),Ys: list(A)] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Us),Xs)),lenlex(A,R3))
     => ( ( aa(list(A),nat,size_size(list(A)),Vs) = aa(list(A),nat,size_size(list(A)),Ys) )
       => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Vs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))),lenlex(A,R3)) ) ) ).

% lenlex_append1
tff(fact_6395_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] : ( subseqs(A,nil(A)) = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))) ) ).

% subseqs.simps(1)
tff(fact_6396_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] : ( product_lists(A,nil(list(A))) = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))) ) ).

% product_lists.simps(1)
tff(fact_6397_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list(A),Nb: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,Nb) )
    <=> ? [Y: A,Ys4: list(A)] :
          ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys4),aa(list(A),list(A),cons(A,Y),nil(A))) )
          & ( aa(list(A),nat,size_size(list(A)),Ys4) = Nb ) ) ) ).

% length_Suc_conv_rev
tff(fact_6398_length__append__singleton,axiom,
    ! [A: $tType,Xs: list(A),X2: A] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),nil(A)))) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_append_singleton
tff(fact_6399_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( subseqs(A,aa(list(A),list(A),cons(A,X2),Xs))
      = $let(
          xss: list(list(A)),
          xss := subseqs(A,Xs),
          aa(list(list(A)),list(list(A)),aa(list(list(A)),fun(list(list(A)),list(list(A))),append(list(A)),aa(list(list(A)),list(list(A)),map(list(A),list(A),cons(A,X2)),xss)),xss) ) ) ).

% subseqs.simps(2)
tff(fact_6400_nth__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Nb: nat] :
      ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),Nb)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,A,nth(A,Xs),Nb),aa(nat,A,nth(A,Ys),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs)))) ) ).

% nth_append
tff(fact_6401_list__update__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Nb: nat,X2: A] :
      ( list_update(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys),Nb,X2)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),list_update(A,Xs,Nb,X2)),Ys),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),list_update(A,Ys,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs)),X2))) ) ).

% list_update_append
tff(fact_6402_listrel1E,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,R))
     => ~ ! [X4: A,Y4: A] :
            ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y4)),R)
           => ! [Us3: list(A),Vs3: list(A)] :
                ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),cons(A,X4),Vs3)) )
               => ( Ys != aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),cons(A,Y4),Vs3)) ) ) ) ) ).

% listrel1E
tff(fact_6403_listrel1I,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set(product_prod(A,A)),Xs: list(A),Us: list(A),Vs: list(A),Ys: list(A)] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),R)
     => ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),aa(list(A),list(A),cons(A,X2),Vs)) )
       => ( ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),aa(list(A),list(A),cons(A,Y2),Vs)) )
         => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,R)) ) ) ) ).

% listrel1I
tff(fact_6404_upt__eq__Cons__conv,axiom,
    ! [I3: nat,J2: nat,X2: nat,Xs: list(nat)] :
      ( ( upt(I3,J2) = aa(list(nat),list(nat),cons(nat,X2),Xs) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
        & ( I3 = X2 )
        & ( upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),one_one(nat)),J2) = Xs ) ) ) ).

% upt_eq_Cons_conv
tff(fact_6405_upt__rec,axiom,
    ! [I3: nat,J2: nat] :
      ( upt(I3,J2)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2),aa(list(nat),list(nat),cons(nat,I3),upt(aa(nat,nat,suc,I3),J2)),nil(nat)) ) ).

% upt_rec
tff(fact_6406_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list(A),Ys: list(B)] : ( product(A,B,aa(list(A),list(A),cons(A,X2),Xs),Ys) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2)),Ys)),product(A,B,Xs,Ys)) ) ).

% product.simps(2)
tff(fact_6407_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list(A)] : ( n_lists(A,zero_zero(nat),Xs) = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))) ) ).

% n_lists.simps(1)
tff(fact_6408_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I3: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,I3)),J2)
     => ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or3652927894154168847AtMost(nat,I3,J2)) = aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,I3)),aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or3652927894154168847AtMost(nat,aa(nat,nat,suc,I3),J2))) ) ) ).

% sorted_list_of_set_greaterThanAtMost
tff(fact_6409_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I3: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I3)),J2)
     => ( aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or5935395276787703475ssThan(nat,I3,J2)) = aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,I3)),aa(set(nat),list(nat),linord4507533701916653071of_set(nat),set_or5935395276787703475ssThan(nat,aa(nat,nat,suc,I3),J2))) ) ) ).

% sorted_list_of_set_greaterThanLessThan
tff(fact_6410_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list(A),X2: A,Ys: list(A),Y2: A,R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),nil(A)))),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),aa(list(A),list(A),cons(A,Y2),nil(A))))),listrel1(A,R))
    <=> ( ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),listrel1(A,R))
          & ( X2 = Y2 ) )
        | ( ( Xs = Ys )
          & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),R) ) ) ) ).

% snoc_listrel1_snoc_iff
tff(fact_6411_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F3: fun(B,A),A2: A,Xs: list(B),Ys: list(B)] : ( groups4207007520872428315er_sum(B,A,F3,A2,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),groups4207007520872428315er_sum(B,A,F3,A2,Xs)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,A2),aa(list(B),nat,size_size(list(B)),Xs))),groups4207007520872428315er_sum(B,A,F3,A2,Ys))) ) ) ).

% horner_sum_append
tff(fact_6412_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs != nil(A) )
     => ( ( Ys != nil(A) )
       => ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Xs) )
         => ? [N: nat,Zs2: list(A)] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),N)
              & ( concat(A,replicate(list(A),N,Zs2)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) ) ) ) ) ) ).

% comm_append_is_replicate
tff(fact_6413_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),A2: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),A2) )
           => ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),A2),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,A2),nil(A))) ) ) ) ) ).

% sorted_insort_is_snoc
tff(fact_6414_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I3: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( take(A,aa(nat,nat,suc,I3),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,I3,Xs)),aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I3)),nil(A))) ) ) ).

% take_Suc_conv_app_nth
tff(fact_6415_nth__repl,axiom,
    ! [A: $tType,Ma: nat,Xs: list(A),Nb: nat,X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
       => ( ( Ma != Nb )
         => ( aa(nat,A,nth(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,Nb,Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,X2),nil(A))),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),one_one(nat)),Xs)))),Ma) = aa(nat,A,nth(A,Xs),Ma) ) ) ) ) ).

% nth_repl
tff(fact_6416_pos__n__replace,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),Y2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,Nb,Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),cons(A,Y2),nil(A))),drop(A,aa(nat,nat,suc,Nb),Xs)))) ) ) ).

% pos_n_replace
tff(fact_6417_drop0,axiom,
    ! [A: $tType,X: list(A)] : ( drop(A,zero_zero(nat),X) = X ) ).

% drop0
tff(fact_6418_drop__drop,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,Xs: list(A)] : ( drop(A,Nb,drop(A,Ma,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma),Xs) ) ).

% drop_drop
tff(fact_6419_drop__upt,axiom,
    ! [Ma: nat,I3: nat,J2: nat] : ( drop(nat,Ma,upt(I3,J2)) = upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),Ma),J2) ) ).

% drop_upt
tff(fact_6420_drop__Suc__Cons,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] : ( drop(A,aa(nat,nat,suc,Nb),aa(list(A),list(A),cons(A,X2),Xs)) = drop(A,Nb,Xs) ) ).

% drop_Suc_Cons
tff(fact_6421_length__drop,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),drop(A,Nb,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb) ) ).

% length_drop
tff(fact_6422_append__take__drop__id,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,Nb,Xs)),drop(A,Nb,Xs)) = Xs ) ).

% append_take_drop_id
tff(fact_6423_drop__update__cancel,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,Xs: list(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),Ma)
     => ( drop(A,Ma,list_update(A,Xs,Nb,X2)) = drop(A,Ma,Xs) ) ) ).

% drop_update_cancel
tff(fact_6424_drop__replicate,axiom,
    ! [A: $tType,I3: nat,K: nat,X2: A] : ( drop(A,I3,replicate(A,K,X2)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),I3),X2) ) ).

% drop_replicate
tff(fact_6425_drop__all,axiom,
    ! [A: $tType,Xs: list(A),Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb)
     => ( drop(A,Nb,Xs) = nil(A) ) ) ).

% drop_all
tff(fact_6426_drop__eq__Nil,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( ( drop(A,Nb,Xs) = nil(A) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb) ) ).

% drop_eq_Nil
tff(fact_6427_drop__eq__Nil2,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( ( nil(A) = drop(A,Nb,Xs) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb) ) ).

% drop_eq_Nil2
tff(fact_6428_drop__append,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),Ys: list(A)] : ( drop(A,Nb,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),drop(A,Nb,Xs)),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% drop_append
tff(fact_6429_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X2: A,Xs: list(A)] : ( drop(A,aa(num,nat,numeral_numeral(nat),V),aa(list(A),list(A),cons(A,X2),Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)),Xs) ) ).

% drop_Cons_numeral
tff(fact_6430_nth__drop,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),I3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,drop(A,Nb,Xs)),I3) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),I3)) ) ) ).

% nth_drop
tff(fact_6431_nth__via__drop,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A),Y2: A,Ys: list(A)] :
      ( ( drop(A,Nb,Xs) = aa(list(A),list(A),cons(A,Y2),Ys) )
     => ( aa(nat,A,nth(A,Xs),Nb) = Y2 ) ) ).

% nth_via_drop
tff(fact_6432_drop__map,axiom,
    ! [A: $tType,B: $tType,Nb: nat,F3: fun(B,A),Xs: list(B)] : ( drop(A,Nb,aa(list(B),list(A),map(B,A,F3),Xs)) = aa(list(B),list(A),map(B,A,F3),drop(B,Nb,Xs)) ) ).

% drop_map
tff(fact_6433_sorted__drop,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Nb: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),drop(A,Nb,Xs)) ) ) ).

% sorted_drop
tff(fact_6434_set__drop__subset,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),drop(A,Nb,Xs))),aa(list(A),set(A),set2(A),Xs)) ).

% set_drop_subset
tff(fact_6435_distinct__drop,axiom,
    ! [A: $tType,Xs: list(A),I3: nat] :
      ( distinct(A,Xs)
     => distinct(A,drop(A,I3,Xs)) ) ).

% distinct_drop
tff(fact_6436_drop__take,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,Xs: list(A)] : ( drop(A,Nb,take(A,Ma,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb),drop(A,Nb,Xs)) ) ).

% drop_take
tff(fact_6437_take__drop,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,Xs: list(A)] : ( take(A,Nb,drop(A,Ma,Xs)) = drop(A,Ma,take(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Nb),Ma),Xs)) ) ).

% take_drop
tff(fact_6438_in__set__dropD,axiom,
    ! [A: $tType,X2: A,Nb: nat,Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),drop(A,Nb,Xs)))
     => aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs)) ) ).

% in_set_dropD
tff(fact_6439_drop__0,axiom,
    ! [A: $tType,Xs: list(A)] : ( drop(A,zero_zero(nat),Xs) = Xs ) ).

% drop_0
tff(fact_6440_sorted__wrt__drop,axiom,
    ! [A: $tType,F3: fun(A,fun(A,$o)),Xs: list(A),Nb: nat] :
      ( sorted_wrt(A,F3,Xs)
     => sorted_wrt(A,F3,drop(A,Nb,Xs)) ) ).

% sorted_wrt_drop
tff(fact_6441_drop__Nil,axiom,
    ! [A: $tType,Nb: nat] : ( drop(A,Nb,nil(A)) = nil(A) ) ).

% drop_Nil
tff(fact_6442_set__drop__subset__set__drop,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Nb),Ma)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),drop(A,Ma,Xs))),aa(list(A),set(A),set2(A),drop(A,Nb,Xs))) ) ).

% set_drop_subset_set_drop
tff(fact_6443_take__add,axiom,
    ! [A: $tType,I3: nat,J2: nat,Xs: list(A)] : ( take(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),J2),Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,I3,Xs)),take(A,J2,drop(A,I3,Xs))) ) ).

% take_add
tff(fact_6444_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys) = Zs )
    <=> ( ( Xs = take(A,aa(list(A),nat,size_size(list(A)),Xs),Zs) )
        & ( Ys = drop(A,aa(list(A),nat,size_size(list(A)),Xs),Zs) ) ) ) ).

% append_eq_conv_conj
tff(fact_6445_drop__update__swap,axiom,
    ! [A: $tType,Ma: nat,Nb: nat,Xs: list(A),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
     => ( drop(A,Ma,list_update(A,Xs,Nb,X2)) = list_update(A,drop(A,Ma,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),Ma),X2) ) ) ).

% drop_update_swap
tff(fact_6446_drop__Cons,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] : ( drop(A,Nb,aa(list(A),list(A),cons(A,X2),Xs)) = case_nat(list(A),aa(list(A),list(A),cons(A,X2),Xs),aTP_Lamp_xy(list(A),fun(nat,list(A)),Xs),Nb) ) ).

% drop_Cons
tff(fact_6447_drop__Cons_H,axiom,
    ! [A: $tType,Nb: nat,X2: A,Xs: list(A)] :
      ( drop(A,Nb,aa(list(A),list(A),cons(A,X2),Xs))
      = $ite(Nb = zero_zero(nat),aa(list(A),list(A),cons(A,X2),Xs),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)),Xs)) ) ).

% drop_Cons'
tff(fact_6448_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list(A),Xs_2: list(A),Ys_1: list(A),Ys_2: list(A)] :
      ( ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs_1),Xs_2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys_1),Ys_2) )
    <=> $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs_1)),aa(list(A),nat,size_size(list(A)),Ys_1)),
          ( ( Xs_1 = take(A,aa(list(A),nat,size_size(list(A)),Xs_1),Ys_1) )
          & ( Xs_2 = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),drop(A,aa(list(A),nat,size_size(list(A)),Xs_1),Ys_1)),Ys_2) ) ),
          ( ( take(A,aa(list(A),nat,size_size(list(A)),Ys_1),Xs_1) = Ys_1 )
          & ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),drop(A,aa(list(A),nat,size_size(list(A)),Ys_1),Xs_1)),Xs_2) = Ys_2 ) ) ) ) ).

% append_eq_append_conv_if
tff(fact_6449_take__rev,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( take(A,Nb,aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb),Xs)) ) ).

% take_rev
tff(fact_6450_rev__take,axiom,
    ! [A: $tType,I3: nat,Xs: list(A)] : ( aa(list(A),list(A),rev(A),take(A,I3,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),I3),aa(list(A),list(A),rev(A),Xs)) ) ).

% rev_take
tff(fact_6451_rev__drop,axiom,
    ! [A: $tType,I3: nat,Xs: list(A)] : ( aa(list(A),list(A),rev(A),drop(A,I3,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),I3),aa(list(A),list(A),rev(A),Xs)) ) ).

% rev_drop
tff(fact_6452_drop__rev,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( drop(A,Nb,aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb),Xs)) ) ).

% drop_rev
tff(fact_6453_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I3: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I3)),drop(A,aa(nat,nat,suc,I3),Xs)) = drop(A,I3,Xs) ) ) ).

% Cons_nth_drop_Suc
tff(fact_6454_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list(A),I3: nat,J2: nat] :
      ( distinct(A,Vs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),take(A,I3,Vs))),aa(list(A),set(A),set2(A),drop(A,J2,Vs))) = bot_bot(set(A)) ) ) ) ).

% set_take_disj_set_drop_if_distinct
tff(fact_6455_id__take__nth__drop,axiom,
    ! [A: $tType,I3: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,I3,Xs)),aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I3)),drop(A,aa(nat,nat,suc,I3),Xs))) ) ) ).

% id_take_nth_drop
tff(fact_6456_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I3: nat,Xs: list(A),A2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
     => ( list_update(A,Xs,I3,A2) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,I3,Xs)),aa(list(A),list(A),cons(A,A2),drop(A,aa(nat,nat,suc,I3),Xs))) ) ) ).

% upd_conv_take_nth_drop
tff(fact_6457_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B),Ma: fun(A,option(B)),X2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys))
     => ( map_upds(A,B,Ma,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),nil(A))),Ys) = fun_upd(A,option(B),map_upds(A,B,Ma,Xs,Ys),X2,aa(B,option(B),some(B),aa(nat,B,nth(B,Ys),aa(list(A),nat,size_size(list(A)),Xs)))) ) ) ).

% map_upds_append1
tff(fact_6458_empty__upd__none,axiom,
    ! [A: $tType,B: $tType,X2: A,X: A] : ( aa(A,option(B),fun_upd(A,option(B),aTP_Lamp_ri(A,option(B)),X2,none(B)),X) = none(B) ) ).

% empty_upd_none
tff(fact_6459_map__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y2: A,Xs: list(A),F3: fun(A,B),V: B] :
      ( ~ aa(set(A),$o,member(A,Y2),aa(list(A),set(A),set2(A),Xs))
     => ( aa(list(A),list(B),map(A,B,fun_upd(A,B,F3,Y2,V)),Xs) = aa(list(A),list(B),map(A,B,F3),Xs) ) ) ).

% map_fun_upd
tff(fact_6460_map__upds__twist,axiom,
    ! [A: $tType,B: $tType,A2: A,As3: list(A),Ma: fun(A,option(B)),B2: B,Bs: list(B)] :
      ( ~ aa(set(A),$o,member(A,A2),aa(list(A),set(A),set2(A),As3))
     => ( map_upds(A,B,fun_upd(A,option(B),Ma,A2,aa(B,option(B),some(B),B2)),As3,Bs) = fun_upd(A,option(B),map_upds(A,B,Ma,As3,Bs),A2,aa(B,option(B),some(B),B2)) ) ) ).

% map_upds_twist
tff(fact_6461_graph__map__upd,axiom,
    ! [A: $tType,B: $tType,Ma: fun(A,option(B)),K: A,V: B] : ( graph(A,B,fun_upd(A,option(B),Ma,K,aa(B,option(B),some(B),V))) = aa(set(product_prod(A,B)),set(product_prod(A,B)),insert(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V)),graph(A,B,fun_upd(A,option(B),Ma,K,none(B)))) ) ).

% graph_map_upd
tff(fact_6462_ran__map__upd,axiom,
    ! [A: $tType,B: $tType,Ma: fun(B,option(A)),A2: B,B2: A] :
      ( ( aa(B,option(A),Ma,A2) = none(A) )
     => ( ran(B,A,fun_upd(B,option(A),Ma,A2,aa(A,option(A),some(A),B2))) = aa(set(A),set(A),insert(A,B2),ran(B,A,Ma)) ) ) ).

% ran_map_upd
tff(fact_6463_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,Ma: fun(A,option(B)),D4: set(A),X2: A] :
      ( fun_upd(A,option(B),restrict_map(A,B,Ma,D4),X2,none(B))
      = $ite(aa(set(A),$o,member(A,X2),D4),restrict_map(A,B,Ma,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D4),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))),restrict_map(A,B,Ma,D4)) ) ).

% fun_upd_None_restrict
tff(fact_6464_list_Osimps_I5_J,axiom,
    ! [A: $tType,B: $tType,F1: A,F2: fun(B,fun(list(B),A)),X21: B,X222: list(B)] : ( aa(list(B),A,case_list(A,B,F1,F2),aa(list(B),list(B),cons(B,X21),X222)) = aa(list(B),A,aa(B,fun(list(B),A),F2,X21),X222) ) ).

% list.simps(5)
tff(fact_6465_list_Osimps_I4_J,axiom,
    ! [B: $tType,A: $tType,F1: A,F2: fun(B,fun(list(B),A))] : ( aa(list(B),A,case_list(A,B,F1,F2),nil(B)) = F1 ) ).

% list.simps(4)
tff(fact_6466_finite__update__induct,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),C2: B,P: fun(fun(A,B),$o)] :
      ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aTP_Lamp_xz(fun(A,B),fun(B,fun(A,$o)),F3),C2)))
     => ( aa(fun(A,B),$o,P,aTP_Lamp_ro(B,fun(A,B),C2))
       => ( ! [A4: A,B3: B,F5: fun(A,B)] :
              ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_ya(B,fun(fun(A,B),fun(A,$o)),C2),F5)))
             => ( ( aa(A,B,F5,A4) = C2 )
               => ( ( B3 != C2 )
                 => ( aa(fun(A,B),$o,P,F5)
                   => aa(fun(A,B),$o,P,fun_upd(A,B,F5,A4,B3)) ) ) ) )
         => aa(fun(A,B),$o,P,F3) ) ) ) ).

% finite_update_induct
tff(fact_6467_list_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,C: $tType,H: fun(B,A),F1: B,F2: fun(C,fun(list(C),B)),List: list(C)] : ( aa(B,A,H,aa(list(C),B,case_list(B,C,F1,F2),List)) = aa(list(C),A,case_list(A,C,aa(B,A,H,F1),aa(fun(C,fun(list(C),B)),fun(C,fun(list(C),A)),aTP_Lamp_yb(fun(B,A),fun(fun(C,fun(list(C),B)),fun(C,fun(list(C),A))),H),F2)),List) ) ).

% list.case_distrib
tff(fact_6468_map__upd__nonempty,axiom,
    ! [A: $tType,B: $tType,T2: fun(A,option(B)),K: A,X2: B] :
      ~ ! [X4: A] : ( aa(A,option(B),fun_upd(A,option(B),T2,K,aa(B,option(B),some(B),X2)),X4) = none(B) ) ).

% map_upd_nonempty
tff(fact_6469_graph__fun__upd__None,axiom,
    ! [B: $tType,A: $tType,Ma: fun(A,option(B)),K: A] : ( graph(A,B,fun_upd(A,option(B),Ma,K,none(B))) = aa(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B)),aa(A,fun(product_prod(A,B),$o),aTP_Lamp_yc(fun(A,option(B)),fun(A,fun(product_prod(A,B),$o)),Ma),K)) ) ).

% graph_fun_upd_None
tff(fact_6470_restrict__complement__singleton__eq,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,option(B)),X2: A] : ( restrict_map(A,B,F3,aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,X2),bot_bot(set(A))))) = fun_upd(A,option(B),F3,X2,none(B)) ) ).

% restrict_complement_singleton_eq
tff(fact_6471_map__upd__upds__conv__if,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,option(B)),X2: A,Y2: B,Xs: list(A),Ys: list(B)] :
      ( map_upds(A,B,fun_upd(A,option(B),F3,X2,aa(B,option(B),some(B),Y2)),Xs,Ys)
      = $ite(aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),take(A,aa(list(B),nat,size_size(list(B)),Ys),Xs))),map_upds(A,B,F3,Xs,Ys),fun_upd(A,option(B),map_upds(A,B,F3,Xs,Ys),X2,aa(B,option(B),some(B),Y2))) ) ).

% map_upd_upds_conv_if
tff(fact_6472_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Xss: list(list(A))] : ( transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs)),Xss)) = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_yd(A,fun(list(A),list(A))))),Xss)))),transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_ye(A,fun(list(A),list(list(A)))))),Xss))))) ) ).

% transpose.simps(3)
tff(fact_6473_transpose_Oelims,axiom,
    ! [A: $tType,X2: list(list(A)),Y2: list(list(A))] :
      ( ( transpose(A,X2) = Y2 )
     => ( ( ( X2 = nil(list(A)) )
         => ( Y2 != nil(list(A)) ) )
       => ( ! [Xss2: list(list(A))] :
              ( ( X2 = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2) )
             => ( Y2 != transpose(A,Xss2) ) )
         => ~ ! [X4: A,Xs2: list(A),Xss2: list(list(A))] :
                ( ( X2 = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X4),Xs2)),Xss2) )
               => ( Y2 != aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X4),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_yd(A,fun(list(A),list(A))))),Xss2)))),transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_ye(A,fun(list(A),list(list(A)))))),Xss2))))) ) ) ) ) ) ).

% transpose.elims
tff(fact_6474_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_ye(A,fun(list(A),list(list(A)))))),Xss)) = aa(list(list(A)),list(list(A)),map(list(A),list(A),tl(A)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_wk(list(A),$o)),Xss)) ) ).

% transpose_aux_filter_tail
tff(fact_6475_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_yd(A,fun(list(A),list(A))))),Xss)) = aa(list(list(A)),list(A),map(list(A),A,hd(A)),aa(list(list(A)),list(list(A)),filter2(list(A),aTP_Lamp_wk(list(A),$o)),Xss)) ) ).

% transpose_aux_filter_head
tff(fact_6476_tl__upt,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(list(nat),list(nat),tl(nat),upt(Ma,Nb)) = upt(aa(nat,nat,suc,Ma),Nb) ) ).

% tl_upt
tff(fact_6477_hd__upt,axiom,
    ! [I3: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
     => ( aa(list(nat),nat,hd(nat),upt(I3,J2)) = I3 ) ) ).

% hd_upt
tff(fact_6478_hd__append2,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),A,hd(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),A,hd(A),Xs) ) ) ).

% hd_append2
tff(fact_6479_tl__append2,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),list(A),tl(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),tl(A),Xs)),Ys) ) ) ).

% tl_append2
tff(fact_6480_hd__replicate,axiom,
    ! [A: $tType,Nb: nat,X2: A] :
      ( ( Nb != zero_zero(nat) )
     => ( aa(list(A),A,hd(A),replicate(A,Nb,X2)) = X2 ) ) ).

% hd_replicate
tff(fact_6481_hd__take,axiom,
    ! [A: $tType,J2: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),J2)
     => ( aa(list(A),A,hd(A),take(A,J2,Xs)) = aa(list(A),A,hd(A),Xs) ) ) ).

% hd_take
tff(fact_6482_length__tl,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),tl(A),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)) ) ).

% length_tl
tff(fact_6483_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),Xs)),aa(list(A),list(A),tl(A),Xs)) = Xs ) ) ).

% hd_Cons_tl
tff(fact_6484_list_Ocollapse,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List != nil(A) )
     => ( aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)) = List ) ) ).

% list.collapse
tff(fact_6485_tl__replicate,axiom,
    ! [A: $tType,Nb: nat,X2: A] : ( aa(list(A),list(A),tl(A),replicate(A,Nb,X2)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)),X2) ) ).

% tl_replicate
tff(fact_6486_list_Osplit__sel,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F1: A,F2: fun(B,fun(list(B),A)),List: list(B)] :
      ( aa(A,$o,P,aa(list(B),A,case_list(A,B,F1,F2),List))
    <=> ( ( ( List = nil(B) )
         => aa(A,$o,P,F1) )
        & ( ( List = aa(list(B),list(B),cons(B,aa(list(B),B,hd(B),List)),aa(list(B),list(B),tl(B),List)) )
         => aa(A,$o,P,aa(list(B),A,aa(B,fun(list(B),A),F2,aa(list(B),B,hd(B),List)),aa(list(B),list(B),tl(B),List))) ) ) ) ).

% list.split_sel
tff(fact_6487_list_Osplit__sel__asm,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F1: A,F2: fun(B,fun(list(B),A)),List: list(B)] :
      ( aa(A,$o,P,aa(list(B),A,case_list(A,B,F1,F2),List))
    <=> ~ ( ( ( List = nil(B) )
            & ~ aa(A,$o,P,F1) )
          | ( ( List = aa(list(B),list(B),cons(B,aa(list(B),B,hd(B),List)),aa(list(B),list(B),tl(B),List)) )
            & ~ aa(A,$o,P,aa(list(B),A,aa(B,fun(list(B),A),F2,aa(list(B),B,hd(B),List)),aa(list(B),list(B),tl(B),List))) ) ) ) ).

% list.split_sel_asm
tff(fact_6488_tl__drop,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(A),list(A),tl(A),drop(A,Nb,Xs)) = drop(A,Nb,aa(list(A),list(A),tl(A),Xs)) ) ).

% tl_drop
tff(fact_6489_drop__Suc,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( drop(A,aa(nat,nat,suc,Nb),Xs) = drop(A,Nb,aa(list(A),list(A),tl(A),Xs)) ) ).

% drop_Suc
tff(fact_6490_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List = nil(A) )
    <=> aa(list(A),$o,case_list($o,A,$true,aTP_Lamp_yf(A,fun(list(A),$o))),List) ) ).

% list.disc_eq_case(1)
tff(fact_6491_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List != nil(A) )
    <=> aa(list(A),$o,case_list($o,A,$false,aTP_Lamp_yg(A,fun(list(A),$o))),List) ) ).

% list.disc_eq_case(2)
tff(fact_6492_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType,F1: A,F2: fun(B,fun(list(B),A)),List: list(B)] :
      ( aa(list(B),A,case_list(A,B,F1,F2),List)
      = $ite(List = nil(B),F1,aa(list(B),A,aa(B,fun(list(B),A),F2,aa(list(B),B,hd(B),List)),aa(list(B),list(B),tl(B),List))) ) ).

% list.case_eq_if
tff(fact_6493_hd__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( ( Xs != nil(list(A)) )
     => ( ( aa(list(list(A)),list(A),hd(list(A)),Xs) != nil(A) )
       => ( aa(list(A),A,hd(A),concat(A,Xs)) = aa(list(A),A,hd(A),aa(list(list(A)),list(A),hd(list(A)),Xs)) ) ) ) ).

% hd_concat
tff(fact_6494_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A2: list(A),F3: fun(A,B)] :
      ( ( A2 != nil(A) )
     => ( aa(list(B),list(B),tl(B),aa(list(A),list(B),map(A,B,F3),A2)) = aa(list(A),list(B),map(A,B,F3),aa(list(A),list(A),tl(A),A2)) ) ) ).

% list.map_sel(2)
tff(fact_6495_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F3: fun(A,B)] :
      ( ( Xs != nil(A) )
     => ( aa(list(B),B,hd(B),aa(list(A),list(B),map(A,B,F3),Xs)) = aa(A,B,F3,aa(list(A),A,hd(A),Xs)) ) ) ).

% hd_map
tff(fact_6496_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A2: list(A),F3: fun(A,B)] :
      ( ( A2 != nil(A) )
     => ( aa(list(B),B,hd(B),aa(list(A),list(B),map(A,B,F3),A2)) = aa(A,B,F3,aa(list(A),A,hd(A),A2)) ) ) ).

% list.map_sel(1)
tff(fact_6497_map__tl,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] : ( aa(list(B),list(A),map(B,A,F3),aa(list(B),list(B),tl(B),Xs)) = aa(list(A),list(A),tl(A),aa(list(B),list(A),map(B,A,F3),Xs)) ) ).

% map_tl
tff(fact_6498_sorted__tl,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),tl(A),Xs)) ) ) ).

% sorted_tl
tff(fact_6499_take__tl,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( take(A,Nb,aa(list(A),list(A),tl(A),Xs)) = aa(list(A),list(A),tl(A),take(A,aa(nat,nat,suc,Nb),Xs)) ) ).

% take_tl
tff(fact_6500_distinct__tl,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => distinct(A,aa(list(A),list(A),tl(A),Xs)) ) ).

% distinct_tl
tff(fact_6501_list_Oexpand,axiom,
    ! [A: $tType,List: list(A),List2: list(A)] :
      ( ( ( List = nil(A) )
      <=> ( List2 = nil(A) ) )
     => ( ( ( List != nil(A) )
         => ( ( List2 != nil(A) )
           => ( ( aa(list(A),A,hd(A),List) = aa(list(A),A,hd(A),List2) )
              & ( aa(list(A),list(A),tl(A),List) = aa(list(A),list(A),tl(A),List2) ) ) ) )
       => ( List = List2 ) ) ) ).

% list.expand
tff(fact_6502_list_Osel_I2_J,axiom,
    ! [A: $tType] : ( aa(list(A),list(A),tl(A),nil(A)) = nil(A) ) ).

% list.sel(2)
tff(fact_6503_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A2: list(A)] :
      ( ( A2 != nil(A) )
     => aa(set(A),$o,member(A,aa(list(A),A,hd(A),A2)),aa(list(A),set(A),set2(A),A2)) ) ).

% list.set_sel(1)
tff(fact_6504_hd__in__set,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => aa(set(A),$o,member(A,aa(list(A),A,hd(A),Xs)),aa(list(A),set(A),set2(A),Xs)) ) ).

% hd_in_set
tff(fact_6505_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A2: list(A),X2: A] :
      ( ( A2 != nil(A) )
     => ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),aa(list(A),list(A),tl(A),A2)))
       => aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),A2)) ) ) ).

% list.set_sel(2)
tff(fact_6506_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( takeWhile(A,P,Xs) = nil(A) )
    <=> ( ( Xs = nil(A) )
        | ~ aa(A,$o,P,aa(list(A),A,hd(A),Xs)) ) ) ).

% takeWhile_eq_Nil_iff
tff(fact_6507_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( rotate1(A,Xs) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(list(A),list(A),tl(A),Xs)),aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),Xs)),nil(A))) ) ) ).

% rotate1_hd_tl
tff(fact_6508_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
    ? [Ps: list(A),Xs4: list(A),Ys5: list(A)] :
      ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ps),Xs4) )
      & ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ps),Ys5) )
      & ( ( Xs4 = nil(A) )
        | ( Ys5 = nil(A) )
        | ( aa(list(A),A,hd(A),Xs4) != aa(list(A),A,hd(A),Ys5) ) ) ) ).

% longest_common_prefix
tff(fact_6509_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z: A,Zs: list(A),Xs: list(A),Ys: list(A)] :
      ( aa(set(list(A)),$o,member(list(A),aa(list(A),list(A),cons(A,Z),Zs)),shuffles(A,Xs,Ys))
    <=> ( ( ( Xs != nil(A) )
          & ( aa(list(A),A,hd(A),Xs) = Z )
          & aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,aa(list(A),list(A),tl(A),Xs),Ys)) )
        | ( ( Ys != nil(A) )
          & ( aa(list(A),A,hd(A),Ys) = Z )
          & aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,aa(list(A),list(A),tl(A),Ys))) ) ) ) ).

% Cons_in_shuffles_iff
tff(fact_6510_hd__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( aa(list(A),A,hd(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))
      = $ite(Xs = nil(A),aa(list(A),A,hd(A),Ys),aa(list(A),A,hd(A),Xs)) ) ).

% hd_append
tff(fact_6511_tl__Nil,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),list(A),tl(A),Xs) = nil(A) )
    <=> ( ( Xs = nil(A) )
        | ? [X3: A] : ( Xs = aa(list(A),list(A),cons(A,X3),nil(A)) ) ) ) ).

% tl_Nil
tff(fact_6512_Nil__tl,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( nil(A) = aa(list(A),list(A),tl(A),Xs) )
    <=> ( ( Xs = nil(A) )
        | ? [X3: A] : ( Xs = aa(list(A),list(A),cons(A,X3),nil(A)) ) ) ) ).

% Nil_tl
tff(fact_6513_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list(A)] :
      ( ( List != nil(A) )
     => ( List = aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),List)),aa(list(A),list(A),tl(A),List)) ) ) ).

% list.exhaust_sel
tff(fact_6514_take__Suc,axiom,
    ! [A: $tType,Xs: list(A),Nb: nat] :
      ( ( Xs != nil(A) )
     => ( take(A,aa(nat,nat,suc,Nb),Xs) = aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),Xs)),take(A,Nb,aa(list(A),list(A),tl(A),Xs))) ) ) ).

% take_Suc
tff(fact_6515_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),A,hd(A),aa(list(A),list(A),cons(A,X21),X222)) = X21 ) ).

% list.sel(1)
tff(fact_6516_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),list(A),tl(A),aa(list(A),list(A),cons(A,X21),X222)) = X222 ) ).

% list.sel(3)
tff(fact_6517_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A)] :
      ( aa(list(A),nat,size_list(A,F3),Xs)
      = $ite(Xs = nil(A),zero_zero(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F3,aa(list(A),A,hd(A),Xs))),aa(list(A),nat,size_list(A,F3),aa(list(A),list(A),tl(A),Xs))))) ) ).

% Nitpick.size_list_simp(1)
tff(fact_6518_tl__def,axiom,
    ! [A: $tType,List: list(A)] : ( aa(list(A),list(A),tl(A),List) = aa(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_yh(A,fun(list(A),list(A)))),List) ) ).

% tl_def
tff(fact_6519_tl__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),list(A),tl(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),case_list(list(A),A,aa(list(A),list(A),tl(A),Ys),aTP_Lamp_yi(list(A),fun(A,fun(list(A),list(A))),Ys)),Xs) ) ).

% tl_append
tff(fact_6520_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( aa(list(A),A,hd(A),Xs) = aa(nat,A,nth(A,Xs),zero_zero(nat)) ) ) ).

% hd_conv_nth
tff(fact_6521_tl__take,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(A),list(A),tl(A),take(A,Nb,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat)),aa(list(A),list(A),tl(A),Xs)) ) ).

% tl_take
tff(fact_6522_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(list(A),nat,size_size(list(A)),Xs)
      = $ite(Xs = nil(A),zero_zero(nat),aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),tl(A),Xs)))) ) ).

% Nitpick.size_list_simp(2)
tff(fact_6523_nth__tl,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),tl(A),Xs)))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),tl(A),Xs)),Nb) = aa(nat,A,nth(A,Xs),aa(nat,nat,suc,Nb)) ) ) ).

% nth_tl
tff(fact_6524_hd__drop__conv__nth,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),A,hd(A),drop(A,Nb,Xs)) = aa(nat,A,nth(A,Xs),Nb) ) ) ).

% hd_drop_conv_nth
tff(fact_6525_insort__key__remove1,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [A2: A,Xs: list(A),F3: fun(A,B)] :
          ( aa(set(A),$o,member(A,A2),aa(list(A),set(A),set2(A),Xs))
         => ( sorted_wrt(B,ord_less_eq(B),aa(list(A),list(B),map(A,B,F3),Xs))
           => ( ( aa(list(A),A,hd(A),aa(list(A),list(A),filter2(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_yj(A,fun(fun(A,B),fun(A,$o)),A2),F3)),Xs)) = A2 )
             => ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),linorder_insort_key(A,B,F3),A2),remove1(A,A2,Xs)) = Xs ) ) ) ) ) ).

% insort_key_remove1
tff(fact_6526_take__hd__drop,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Nb),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,Nb,Xs)),aa(list(A),list(A),cons(A,aa(list(A),A,hd(A),drop(A,Nb,Xs))),nil(A))) = take(A,aa(nat,nat,suc,Nb),Xs) ) ) ).

% take_hd_drop
tff(fact_6527_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Xss: list(list(A))] :
      ( accp(list(list(A)),transpose_rel(A),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs)),Xss))
     => ( transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),Xs)),Xss)) = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X2),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_yd(A,fun(list(A),list(A))))),Xss)))),transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_ye(A,fun(list(A),list(list(A)))))),Xss))))) ) ) ).

% transpose.psimps(3)
tff(fact_6528_transpose_Opelims,axiom,
    ! [A: $tType,X2: list(list(A)),Y2: list(list(A))] :
      ( ( transpose(A,X2) = Y2 )
     => ( accp(list(list(A)),transpose_rel(A),X2)
       => ( ( ( X2 = nil(list(A)) )
           => ( ( Y2 = nil(list(A)) )
             => ~ accp(list(list(A)),transpose_rel(A),nil(list(A))) ) )
         => ( ! [Xss2: list(list(A))] :
                ( ( X2 = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2) )
               => ( ( Y2 = transpose(A,Xss2) )
                 => ~ accp(list(list(A)),transpose_rel(A),aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2)) ) )
           => ~ ! [X4: A,Xs2: list(A),Xss2: list(list(A))] :
                  ( ( X2 = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X4),Xs2)),Xss2) )
                 => ( ( Y2 = aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X4),concat(A,aa(list(list(A)),list(list(A)),map(list(A),list(A),case_list(list(A),A,nil(A),aTP_Lamp_yd(A,fun(list(A),list(A))))),Xss2)))),transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_ye(A,fun(list(A),list(list(A)))))),Xss2))))) )
                   => ~ accp(list(list(A)),transpose_rel(A),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X4),Xs2)),Xss2)) ) ) ) ) ) ) ).

% transpose.pelims
tff(fact_6529_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list(list(A))] :
      ( accp(list(list(A)),transpose_rel(A),aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss))
     => ( transpose(A,aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss)) = transpose(A,Xss) ) ) ).

% transpose.psimps(2)
tff(fact_6530_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( accp(list(list(A)),transpose_rel(A),nil(list(A)))
     => ( transpose(A,nil(list(A))) = nil(list(A)) ) ) ).

% transpose.psimps(1)
tff(fact_6531_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list(list(A)),P: fun(list(list(A)),$o)] :
      ( accp(list(list(A)),transpose_rel(A),A0)
     => ( ( accp(list(list(A)),transpose_rel(A),nil(list(A)))
         => aa(list(list(A)),$o,P,nil(list(A))) )
       => ( ! [Xss2: list(list(A))] :
              ( accp(list(list(A)),transpose_rel(A),aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2))
             => ( aa(list(list(A)),$o,P,Xss2)
               => aa(list(list(A)),$o,P,aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),Xss2)) ) )
         => ( ! [X4: A,Xs2: list(A),Xss2: list(list(A))] :
                ( accp(list(list(A)),transpose_rel(A),aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X4),Xs2)),Xss2))
               => ( aa(list(list(A)),$o,P,aa(list(list(A)),list(list(A)),cons(list(A),Xs2),concat(list(A),aa(list(list(A)),list(list(list(A))),map(list(A),list(list(A)),case_list(list(list(A)),A,nil(list(A)),aTP_Lamp_ye(A,fun(list(A),list(list(A)))))),Xss2))))
                 => aa(list(list(A)),$o,P,aa(list(list(A)),list(list(A)),cons(list(A),aa(list(A),list(A),cons(A,X4),Xs2)),Xss2)) ) )
           => aa(list(list(A)),$o,P,A0) ) ) ) ) ).

% transpose.pinduct
tff(fact_6532_upto__aux__rec,axiom,
    ! [I3: int,J2: int,Js: list(int)] :
      ( upto_aux(I3,J2,Js)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I3),Js,upto_aux(I3,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)),aa(list(int),list(int),cons(int,J2),Js))) ) ).

% upto_aux_rec
tff(fact_6533_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys: list(product_prod(A,C)),Yzs: list(product_prod(C,B))] : ( relcomp(A,C,B,aa(list(product_prod(A,C)),set(product_prod(A,C)),set2(product_prod(A,C)),Xys),aa(list(product_prod(C,B)),set(product_prod(C,B)),set2(product_prod(C,B)),Yzs)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),concat(product_prod(A,B),aa(list(product_prod(A,C)),list(list(product_prod(A,B))),map(product_prod(A,C),list(product_prod(A,B)),aTP_Lamp_yl(list(product_prod(C,B)),fun(product_prod(A,C),list(product_prod(A,B))),Yzs)),Xys))) ) ).

% set_relcomp
tff(fact_6534_relcomp__UNION__distrib2,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,R: fun(D,set(product_prod(A,C))),I5: set(D),S: set(product_prod(C,B))] : ( relcomp(A,C,B,aa(set(set(product_prod(A,C))),set(product_prod(A,C)),complete_Sup_Sup(set(product_prod(A,C))),aa(set(D),set(set(product_prod(A,C))),image(D,set(product_prod(A,C)),R),I5)),S) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(D),set(set(product_prod(A,B))),image(D,set(product_prod(A,B)),aa(set(product_prod(C,B)),fun(D,set(product_prod(A,B))),aTP_Lamp_ym(fun(D,set(product_prod(A,C))),fun(set(product_prod(C,B)),fun(D,set(product_prod(A,B)))),R),S)),I5)) ) ).

% relcomp_UNION_distrib2
tff(fact_6535_relcomp__UNION__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,S: set(product_prod(A,C)),R: fun(D,set(product_prod(C,B))),I5: set(D)] : ( relcomp(A,C,B,S,aa(set(set(product_prod(C,B))),set(product_prod(C,B)),complete_Sup_Sup(set(product_prod(C,B))),aa(set(D),set(set(product_prod(C,B))),image(D,set(product_prod(C,B)),R),I5))) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(D),set(set(product_prod(A,B))),image(D,set(product_prod(A,B)),aa(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(A,B))),aTP_Lamp_yn(set(product_prod(A,C)),fun(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(A,B)))),S),R)),I5)) ) ).

% relcomp_UNION_distrib
tff(fact_6536_upto_Opelims,axiom,
    ! [X2: int,Xa2: int,Y2: list(int)] :
      ( ( upto(X2,Xa2) = Y2 )
     => ( accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X2),Xa2))
       => ~ ( ( Y2
              = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X2),Xa2),aa(list(int),list(int),cons(int,X2),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),one_one(int)),Xa2)),nil(int)) )
           => ~ accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X2),Xa2)) ) ) ) ).

% upto.pelims
tff(fact_6537_upto_Opsimps,axiom,
    ! [I3: int,J2: int] :
      ( accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),I3),J2))
     => ( upto(I3,J2)
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J2),aa(list(int),list(int),cons(int,I3),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)),J2)),nil(int)) ) ) ).

% upto.psimps
tff(fact_6538_upto__empty,axiom,
    ! [J2: int,I3: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I3)
     => ( upto(I3,J2) = nil(int) ) ) ).

% upto_empty
tff(fact_6539_upto__Nil2,axiom,
    ! [I3: int,J2: int] :
      ( ( nil(int) = upto(I3,J2) )
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I3) ) ).

% upto_Nil2
tff(fact_6540_upto__Nil,axiom,
    ! [I3: int,J2: int] :
      ( ( upto(I3,J2) = nil(int) )
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I3) ) ).

% upto_Nil
tff(fact_6541_upto__single,axiom,
    ! [I3: int] : ( upto(I3,I3) = aa(list(int),list(int),cons(int,I3),nil(int)) ) ).

% upto_single
tff(fact_6542_nth__upto,axiom,
    ! [I3: int,K: nat,J2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),aa(nat,int,semiring_1_of_nat(int),K))),J2)
     => ( aa(nat,int,nth(int,upto(I3,J2)),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),aa(nat,int,semiring_1_of_nat(int),K)) ) ) ).

% nth_upto
tff(fact_6543_length__upto,axiom,
    ! [I3: int,J2: int] : ( aa(list(int),nat,size_size(list(int)),upto(I3,J2)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),I3)),one_one(int))) ) ).

% length_upto
tff(fact_6544_upto__rec__numeral_I1_J,axiom,
    ! [Ma: num,Nb: num] :
      ( upto(aa(num,int,numeral_numeral(int),Ma),aa(num,int,numeral_numeral(int),Nb))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Ma)),aa(num,int,numeral_numeral(int),Nb)),aa(list(int),list(int),cons(int,aa(num,int,numeral_numeral(int),Ma)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(num,int,numeral_numeral(int),Ma)),one_one(int)),aa(num,int,numeral_numeral(int),Nb))),nil(int)) ) ).

% upto_rec_numeral(1)
tff(fact_6545_upto__rec__numeral_I2_J,axiom,
    ! [Ma: num,Nb: num] :
      ( upto(aa(num,int,numeral_numeral(int),Ma),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))),aa(list(int),list(int),cons(int,aa(num,int,numeral_numeral(int),Ma)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(num,int,numeral_numeral(int),Ma)),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb)))),nil(int)) ) ).

% upto_rec_numeral(2)
tff(fact_6546_upto__rec__numeral_I3_J,axiom,
    ! [Ma: num,Nb: num] :
      ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma)),aa(num,int,numeral_numeral(int),Nb))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),aa(num,int,numeral_numeral(int),Nb)),aa(list(int),list(int),cons(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),one_one(int)),aa(num,int,numeral_numeral(int),Nb))),nil(int)) ) ).

% upto_rec_numeral(3)
tff(fact_6547_upto__rec__numeral_I4_J,axiom,
    ! [Ma: num,Nb: num] :
      ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))),aa(list(int),list(int),cons(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Ma))),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb)))),nil(int)) ) ).

% upto_rec_numeral(4)
tff(fact_6548_upto__code,axiom,
    ! [I3: int,J2: int] : ( upto(I3,J2) = upto_aux(I3,J2,nil(int)) ) ).

% upto_code
tff(fact_6549_upto__aux__def,axiom,
    ! [I3: int,J2: int,Js: list(int)] : ( upto_aux(I3,J2,Js) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I3,J2)),Js) ) ).

% upto_aux_def
tff(fact_6550_sorted__wrt__upto,axiom,
    ! [I3: int,J2: int] : sorted_wrt(int,ord_less(int),upto(I3,J2)) ).

% sorted_wrt_upto
tff(fact_6551_atLeastAtMost__upto,axiom,
    ! [I3: int,J2: int] : ( set_or1337092689740270186AtMost(int,I3,J2) = aa(list(int),set(int),set2(int),upto(I3,J2)) ) ).

% atLeastAtMost_upto
tff(fact_6552_distinct__upto,axiom,
    ! [I3: int,J2: int] : distinct(int,upto(I3,J2)) ).

% distinct_upto
tff(fact_6553_greaterThanAtMost__upto,axiom,
    ! [I3: int,J2: int] : ( set_or3652927894154168847AtMost(int,I3,J2) = aa(list(int),set(int),set2(int),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)),J2)) ) ).

% greaterThanAtMost_upto
tff(fact_6554_sorted__upto,axiom,
    ! [Ma: int,Nb: int] : sorted_wrt(int,ord_less_eq(int),upto(Ma,Nb)) ).

% sorted_upto
tff(fact_6555_sum__set__upto__conv__sum__list__int,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(int,A),I3: int,J2: int] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7311177749621191930dd_sum(int,A),F3),aa(list(int),set(int),set2(int),upto(I3,J2))) = groups8242544230860333062m_list(A,aa(list(int),list(A),map(int,A,F3),upto(I3,J2))) ) ) ).

% sum_set_upto_conv_sum_list_int
tff(fact_6556_interv__sum__list__conv__sum__set__int,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(int,A),K: int,L: int] : ( groups8242544230860333062m_list(A,aa(list(int),list(A),map(int,A,F3),upto(K,L))) = aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7311177749621191930dd_sum(int,A),F3),aa(list(int),set(int),set2(int),upto(K,L))) ) ) ).

% interv_sum_list_conv_sum_set_int
tff(fact_6557_upto__split2,axiom,
    ! [I3: int,J2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J2),K)
       => ( upto(I3,K) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I3,J2)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),J2),one_one(int)),K)) ) ) ) ).

% upto_split2
tff(fact_6558_upto__split1,axiom,
    ! [I3: int,J2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J2),K)
       => ( upto(I3,K) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I3,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)))),upto(J2,K)) ) ) ) ).

% upto_split1
tff(fact_6559_greaterThanLessThan__upto,axiom,
    ! [I3: int,J2: int] : ( set_or5935395276787703475ssThan(int,I3,J2) = aa(list(int),set(int),set2(int),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)),aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)))) ) ).

% greaterThanLessThan_upto
tff(fact_6560_atLeastLessThan__upto,axiom,
    ! [I3: int,J2: int] : ( set_or7035219750837199246ssThan(int,I3,J2) = aa(list(int),set(int),set2(int),upto(I3,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)))) ) ).

% atLeastLessThan_upto
tff(fact_6561_upto_Oelims,axiom,
    ! [X2: int,Xa2: int,Y2: list(int)] :
      ( ( upto(X2,Xa2) = Y2 )
     => ( Y2
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X2),Xa2),aa(list(int),list(int),cons(int,X2),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),X2),one_one(int)),Xa2)),nil(int)) ) ) ).

% upto.elims
tff(fact_6562_upto_Osimps,axiom,
    ! [I3: int,J2: int] :
      ( upto(I3,J2)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J2),aa(list(int),list(int),cons(int,I3),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)),J2)),nil(int)) ) ).

% upto.simps
tff(fact_6563_upto__rec1,axiom,
    ! [I3: int,J2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J2)
     => ( upto(I3,J2) = aa(list(int),list(int),cons(int,I3),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int)),J2)) ) ) ).

% upto_rec1
tff(fact_6564_upto__rec2,axiom,
    ! [I3: int,J2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J2)
     => ( upto(I3,J2) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I3,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)))),aa(list(int),list(int),cons(int,J2),nil(int))) ) ) ).

% upto_rec2
tff(fact_6565_upto__split3,axiom,
    ! [I3: int,J2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J2),K)
       => ( upto(I3,K) = aa(list(int),list(int),aa(list(int),fun(list(int),list(int)),append(int),upto(I3,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)))),aa(list(int),list(int),cons(int,J2),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),J2),one_one(int)),K))) ) ) ) ).

% upto_split3
tff(fact_6566_extract__Some__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Ys: list(A),Y2: A,Zs: list(A)] :
      ( ( extract(A,P,Xs) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),Ys),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Y2),Zs))) )
    <=> ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),aa(list(A),list(A),cons(A,Y2),Zs)) )
        & aa(A,$o,P,Y2)
        & ~ ? [X3: A] :
              ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Ys))
              & aa(A,$o,P,X3) ) ) ) ).

% extract_Some_iff
tff(fact_6567_extract__SomeE,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Ys: list(A),Y2: A,Zs: list(A)] :
      ( ( extract(A,P,Xs) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),Ys),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Y2),Zs))) )
     => ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),aa(list(A),list(A),cons(A,Y2),Zs)) )
        & aa(A,$o,P,Y2)
        & ~ ? [X: A] :
              ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Ys))
              & aa(A,$o,P,X) ) ) ) ).

% extract_SomeE
tff(fact_6568_extract__Nil__code,axiom,
    ! [A: $tType,P: fun(A,$o)] : ( extract(A,P,nil(A)) = none(product_prod(list(A),product_prod(A,list(A)))) ) ).

% extract_Nil_code
tff(fact_6569_extract__None__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( extract(A,P,Xs) = none(product_prod(list(A),product_prod(A,list(A)))) )
    <=> ~ ? [X3: A] :
            ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
            & aa(A,$o,P,X3) ) ) ).

% extract_None_iff
tff(fact_6570_extract__Cons__code,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A)] :
      ( extract(A,P,aa(list(A),list(A),cons(A,X2),Xs))
      = $ite(aa(A,$o,P,X2),aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),nil(A)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),X2),Xs))),case_option(option(product_prod(list(A),product_prod(A,list(A)))),product_prod(list(A),product_prod(A,list(A))),none(product_prod(list(A),product_prod(A,list(A)))),aa(fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),fun(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A))))),product_case_prod(list(A),product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),aTP_Lamp_yp(A,fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),X2)),extract(A,P,Xs))) ) ).

% extract_Cons_code
tff(fact_6571_INF__filter__not__bot,axiom,
    ! [A: $tType,B: $tType,B4: set(A),F4: fun(A,filter(B))] :
      ( ! [X9: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X9),B4)
         => ( finite_finite2(A,X9)
           => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F4),X9)) != bot_bot(filter(B)) ) ) )
     => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F4),B4)) != bot_bot(filter(B)) ) ) ).

% INF_filter_not_bot
tff(fact_6572_option_Osimps_I5_J,axiom,
    ! [A: $tType,B: $tType,F1: A,F2: fun(B,A),X22: B] : ( case_option(A,B,F1,F2,aa(B,option(B),some(B),X22)) = aa(B,A,F2,X22) ) ).

% option.simps(5)
tff(fact_6573_disjE__realizer2,axiom,
    ! [B: $tType,A: $tType,P: $o,Q: fun(A,$o),X2: option(A),R3: fun(B,$o),F3: B,G: fun(A,B)] :
      ( case_option($o,A,P,Q,X2)
     => ( ( (P)
         => aa(B,$o,R3,F3) )
       => ( ! [Q3: A] :
              ( aa(A,$o,Q,Q3)
             => aa(B,$o,R3,aa(A,B,G,Q3)) )
         => aa(B,$o,R3,case_option(B,A,F3,G,X2)) ) ) ) ).

% disjE_realizer2
tff(fact_6574_option_Osimps_I4_J,axiom,
    ! [B: $tType,A: $tType,F1: A,F2: fun(B,A)] : ( case_option(A,B,F1,F2,none(B)) = F1 ) ).

% option.simps(4)
tff(fact_6575_option_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,C: $tType,H: fun(B,A),F1: B,F2: fun(C,B),Option: option(C)] : ( aa(B,A,H,case_option(B,C,F1,F2,Option)) = case_option(A,C,aa(B,A,H,F1),aa(fun(C,B),fun(C,A),aTP_Lamp_rk(fun(B,A),fun(fun(C,B),fun(C,A)),H),F2),Option) ) ).

% option.case_distrib
tff(fact_6576_INF__filter__bot__base,axiom,
    ! [A: $tType,B: $tType,I5: set(A),F4: fun(A,filter(B))] :
      ( ! [I2: A] :
          ( aa(set(A),$o,member(A,I2),I5)
         => ! [J: A] :
              ( aa(set(A),$o,member(A,J),I5)
             => ? [X: A] :
                  ( aa(set(A),$o,member(A,X),I5)
                  & aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),aa(A,filter(B),F4,X)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F4,I2)),aa(A,filter(B),F4,J))) ) ) )
     => ( ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F4),I5)) = bot_bot(filter(B)) )
      <=> ? [X3: A] :
            ( aa(set(A),$o,member(A,X3),I5)
            & ( aa(A,filter(B),F4,X3) = bot_bot(filter(B)) ) ) ) ) ).

% INF_filter_bot_base
tff(fact_6577_extract__def,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( extract(A,P,Xs) = aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),case_list(option(product_prod(list(A),product_prod(A,list(A)))),A,none(product_prod(list(A),product_prod(A,list(A)))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_yq(fun(A,$o),fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),P),Xs)),dropWhile(A,aa(fun(A,$o),fun(A,$o),comp($o,$o,A,fNot),P),Xs)) ) ).

% extract_def
tff(fact_6578_Id__on__def,axiom,
    ! [A: $tType,A3: set(A)] : ( id_on(A,A3) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(A),set(set(product_prod(A,A))),image(A,set(product_prod(A,A)),aTP_Lamp_yr(A,set(product_prod(A,A)))),A3)) ) ).

% Id_on_def
tff(fact_6579_dropWhile__idem,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( dropWhile(A,P,dropWhile(A,P,Xs)) = dropWhile(A,P,Xs) ) ).

% dropWhile_idem
tff(fact_6580_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( dropWhile(A,P,Xs) = nil(A) )
    <=> ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X3) ) ) ).

% dropWhile_eq_Nil_conv
tff(fact_6581_dropWhile__append1,axiom,
    ! [A: $tType,X2: A,Xs: list(A),P: fun(A,$o),Ys: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
     => ( ~ aa(A,$o,P,X2)
       => ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),dropWhile(A,P,Xs)),Ys) ) ) ) ).

% dropWhile_append1
tff(fact_6582_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o),Ys: list(A)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X4) )
     => ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = dropWhile(A,P,Ys) ) ) ).

% dropWhile_append2
tff(fact_6583_dropWhile__replicate,axiom,
    ! [A: $tType,P: fun(A,$o),Nb: nat,X2: A] :
      ( dropWhile(A,P,replicate(A,Nb,X2))
      = $ite(aa(A,$o,P,X2),nil(A),replicate(A,Nb,X2)) ) ).

% dropWhile_replicate
tff(fact_6584_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),takeWhile(A,P,Xs)),dropWhile(A,P,Xs)) = Xs ) ).

% takeWhile_dropWhile_id
tff(fact_6585_option_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,Option: option(A)] :
      ( ( Option = none(A) )
    <=> case_option($o,A,$true,aTP_Lamp_py(A,$o),Option) ) ).

% option.disc_eq_case(1)
tff(fact_6586_option_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,Option: option(A)] :
      ( ( Option != none(A) )
    <=> case_option($o,A,$false,aTP_Lamp_ws(A,$o),Option) ) ).

% option.disc_eq_case(2)
tff(fact_6587_Id__on__def_H,axiom,
    ! [A: $tType,A3: fun(A,$o)] : ( id_on(A,aa(fun(A,$o),set(A),collect(A),A3)) = aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aTP_Lamp_ys(fun(A,$o),fun(A,fun(A,$o)),A3))) ) ).

% Id_on_def'
tff(fact_6588_less__filter__def,axiom,
    ! [A: $tType,F4: filter(A),F7: filter(A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less(filter(A)),F4),F7)
    <=> ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F4),F7)
        & ~ aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F7),F4) ) ) ).

% less_filter_def
tff(fact_6589_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,$o)] : ( dropWhile(A,P,nil(A)) = nil(A) ) ).

% dropWhile.simps(1)
tff(fact_6590_hd__dropWhile,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( dropWhile(A,P,Xs) != nil(A) )
     => ~ aa(A,$o,P,aa(list(A),A,hd(A),dropWhile(A,P,Xs))) ) ).

% hd_dropWhile
tff(fact_6591_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( dropWhile(A,P,Xs) = Xs )
    <=> ( ( Xs = nil(A) )
        | ~ aa(A,$o,P,aa(list(A),A,hd(A),Xs)) ) ) ).

% dropWhile_eq_self_iff
tff(fact_6592_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A)] :
      ( dropWhile(A,P,aa(list(A),list(A),cons(A,X2),Xs))
      = $ite(aa(A,$o,P,X2),dropWhile(A,P,Xs),aa(list(A),list(A),cons(A,X2),Xs)) ) ).

% dropWhile.simps(2)
tff(fact_6593_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F3: fun(B,A),Xs: list(B)] : ( dropWhile(A,P,aa(list(B),list(A),map(B,A,F3),Xs)) = aa(list(B),list(A),map(B,A,F3),dropWhile(B,aa(fun(B,A),fun(B,$o),comp(A,$o,B,P),F3),Xs)) ) ).

% dropWhile_map
tff(fact_6594_dropWhile__append3,axiom,
    ! [A: $tType,P: fun(A,$o),Y2: A,Xs: list(A),Ys: list(A)] :
      ( ~ aa(A,$o,P,Y2)
     => ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,Y2),Ys))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),dropWhile(A,P,Xs)),aa(list(A),list(A),cons(A,Y2),Ys)) ) ) ).

% dropWhile_append3
tff(fact_6595_set__dropWhileD,axiom,
    ! [A: $tType,X2: A,P: fun(A,$o),Xs: list(A)] :
      ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),dropWhile(A,P,Xs)))
     => aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs)) ) ).

% set_dropWhileD
tff(fact_6596_dropWhile__cong,axiom,
    ! [A: $tType,L: list(A),K: list(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( ( L = K )
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),L))
           => ( aa(A,$o,P,X4)
            <=> aa(A,$o,Q,X4) ) )
       => ( dropWhile(A,P,L) = dropWhile(A,Q,K) ) ) ) ).

% dropWhile_cong
tff(fact_6597_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( distinct(A,Xs)
     => distinct(A,dropWhile(A,P,Xs)) ) ).

% distinct_dropWhile
tff(fact_6598_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,$o)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),dropWhile(A,P,Xs)) ) ) ).

% sorted_dropWhile
tff(fact_6599_length__dropWhile__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),dropWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_dropWhile_le
tff(fact_6600_case__optionE,axiom,
    ! [A: $tType,P: $o,Q: fun(A,$o),X2: option(A)] :
      ( case_option($o,A,P,Q,X2)
     => ( ( ( X2 = none(A) )
         => ~ (P) )
       => ~ ! [Y4: A] :
              ( ( X2 = aa(A,option(A),some(A),Y4) )
             => ~ aa(A,$o,Q,Y4) ) ) ) ).

% case_optionE
tff(fact_6601_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Y2: A,Ys: list(A)] :
      ( ( dropWhile(A,P,Xs) = aa(list(A),list(A),cons(A,Y2),Ys) )
    <=> ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),takeWhile(A,P,Xs)),aa(list(A),list(A),cons(A,Y2),Ys)) )
        & ~ aa(A,$o,P,Y2) ) ) ).

% dropWhile_eq_Cons_conv
tff(fact_6602_takeWhile__eq__filter,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ! [X4: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),dropWhile(A,P,Xs)))
         => ~ aa(A,$o,P,X4) )
     => ( takeWhile(A,P,Xs) = aa(list(A),list(A),filter2(A,P),Xs) ) ) ).

% takeWhile_eq_filter
tff(fact_6603_dropWhile__eq__drop,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( dropWhile(A,P,Xs) = drop(A,aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)),Xs) ) ).

% dropWhile_eq_drop
tff(fact_6604_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,option(A)),X2: B,Xs: list(B)] : ( map_filter(B,A,F3,aa(list(B),list(B),cons(B,X2),Xs)) = case_option(list(A),A,map_filter(B,A,F3,Xs),aa(list(B),fun(A,list(A)),aTP_Lamp_yt(fun(B,option(A)),fun(list(B),fun(A,list(A))),F3),Xs),aa(B,option(A),F3,X2)) ) ).

% map_filter_simps(1)
tff(fact_6605_dropWhile__nth,axiom,
    ! [A: $tType,J2: nat,P: fun(A,$o),Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),dropWhile(A,P,Xs)))
     => ( aa(nat,A,nth(A,dropWhile(A,P,Xs)),J2) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))) ) ) ).

% dropWhile_nth
tff(fact_6606_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
       => ( dropWhile(A,aTP_Lamp_wd(A,fun(A,$o),X2),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),rev(A),takeWhile(A,aTP_Lamp_wd(A,fun(A,$o),X2),Xs))) ) ) ) ).

% dropWhile_neq_rev
tff(fact_6607_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( distinct(A,Xs)
     => ( aa(set(A),$o,member(A,X2),aa(list(A),set(A),set2(A),Xs))
       => ( takeWhile(A,aTP_Lamp_wd(A,fun(A,$o),X2),aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),aa(list(A),list(A),tl(A),dropWhile(A,aTP_Lamp_wd(A,fun(A,$o),X2),Xs))) ) ) ) ).

% takeWhile_neq_rev
tff(fact_6608_Id__on__set,axiom,
    ! [A: $tType,Xs: list(A)] : ( id_on(A,aa(list(A),set(A),set2(A),Xs)) = aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),aa(list(A),list(product_prod(A,A)),map(A,product_prod(A,A),aTP_Lamp_ql(A,product_prod(A,A))),Xs)) ) ).

% Id_on_set
tff(fact_6609_take__bit__numeral__minus__numeral__int,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),Ma)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Nb))) = case_option(int,num,zero_zero(int),aTP_Lamp_yu(num,fun(num,int),Ma),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),Ma),Nb)) ) ).

% take_bit_numeral_minus_numeral_int
tff(fact_6610_find__dropWhile,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( find(A,P,Xs) = aa(list(A),option(A),case_list(option(A),A,none(A),aTP_Lamp_yv(A,fun(list(A),option(A)))),dropWhile(A,aa(fun(A,$o),fun(A,$o),comp($o,$o,A,fNot),P),Xs)) ) ).

% find_dropWhile
tff(fact_6611_take__bit__num__simps_I1_J,axiom,
    ! [Ma: num] : ( bit_take_bit_num(zero_zero(nat),Ma) = none(num) ) ).

% take_bit_num_simps(1)
tff(fact_6612_take__bit__num__simps_I2_J,axiom,
    ! [Nb: nat] : ( bit_take_bit_num(aa(nat,nat,suc,Nb),one2) = aa(num,option(num),some(num),one2) ) ).

% take_bit_num_simps(2)
tff(fact_6613_take__bit__num__simps_I5_J,axiom,
    ! [R: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R),one2) = aa(num,option(num),some(num),one2) ) ).

% take_bit_num_simps(5)
tff(fact_6614_take__bit__num__simps_I3_J,axiom,
    ! [Nb: nat,Ma: num] : ( bit_take_bit_num(aa(nat,nat,suc,Nb),aa(num,num,bit0,Ma)) = case_option(option(num),num,none(num),aTP_Lamp_yw(num,option(num)),bit_take_bit_num(Nb,Ma)) ) ).

% take_bit_num_simps(3)
tff(fact_6615_take__bit__num__simps_I4_J,axiom,
    ! [Nb: nat,Ma: num] : ( bit_take_bit_num(aa(nat,nat,suc,Nb),aa(num,num,bit1,Ma)) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(Nb,Ma))) ) ).

% take_bit_num_simps(4)
tff(fact_6616_take__bit__num__simps_I6_J,axiom,
    ! [R: num,Ma: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R),aa(num,num,bit0,Ma)) = case_option(option(num),num,none(num),aTP_Lamp_yw(num,option(num)),bit_take_bit_num(pred_numeral(R),Ma)) ) ).

% take_bit_num_simps(6)
tff(fact_6617_take__bit__num__simps_I7_J,axiom,
    ! [R: num,Ma: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R),aa(num,num,bit1,Ma)) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(pred_numeral(R),Ma))) ) ).

% take_bit_num_simps(7)
tff(fact_6618_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),Ma)),aa(num,A,numeral_numeral(A),Nb)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),Ma),Nb)) ) ) ).

% take_bit_numeral_numeral
tff(fact_6619_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [Nb: nat,Ma: num] : ( bit_take_bit_num(Nb,aa(num,num,bit0,Ma)) = case_nat(option(num),none(num),aTP_Lamp_yx(num,fun(nat,option(num)),Ma),Nb) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
tff(fact_6620_find__cong,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( ( Xs = Ys )
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Ys))
           => ( aa(A,$o,P,X4)
            <=> aa(A,$o,Q,X4) ) )
       => ( find(A,P,Xs) = find(A,Q,Ys) ) ) ) ).

% find_cong
tff(fact_6621_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [Nb: nat] : ( bit_take_bit_num(Nb,one2) = case_nat(option(num),none(num),aTP_Lamp_yy(nat,option(num)),Nb) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
tff(fact_6622_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: num,Q2: num] :
          ( ( bit_take_bit_num(Ma,Nb) = aa(num,option(num),some(num),Q2) )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),aa(num,A,numeral_numeral(A),Nb)) = aa(num,A,numeral_numeral(A),Q2) ) ) ) ).

% take_bit_num_eq_Some_imp
tff(fact_6623_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [Nb: nat,Ma: num] : ( bit_take_bit_num(Nb,aa(num,num,bit1,Ma)) = case_nat(option(num),none(num),aTP_Lamp_yz(num,fun(nat,option(num)),Ma),Nb) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
tff(fact_6624_find_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A)] :
      ( find(A,P,aa(list(A),list(A),cons(A,X2),Xs))
      = $ite(aa(A,$o,P,X2),aa(A,option(A),some(A),X2),find(A,P,Xs)) ) ).

% find.simps(2)
tff(fact_6625_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: fun(A,$o)] : ( find(A,Uu,nil(A)) = none(A) ) ).

% find.simps(1)
tff(fact_6626_find__None__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( find(A,P,Xs) = none(A) )
    <=> ~ ? [X3: A] :
            ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
            & aa(A,$o,P,X3) ) ) ).

% find_None_iff
tff(fact_6627_find__None__iff2,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( ( none(A) = find(A,P,Xs) )
    <=> ~ ? [X3: A] :
            ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
            & aa(A,$o,P,X3) ) ) ).

% find_None_iff2
tff(fact_6628_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: num] :
          ( ( bit_take_bit_num(Ma,Nb) = none(num) )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),aa(num,A,numeral_numeral(A),Nb)) = zero_zero(A) ) ) ) ).

% take_bit_num_eq_None_imp
tff(fact_6629_take__bit__num__def,axiom,
    ! [Nb: nat,Ma: num] :
      ( bit_take_bit_num(Nb,Ma)
      = $ite(aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),aa(num,nat,numeral_numeral(nat),Ma)) = zero_zero(nat),none(num),aa(num,option(num),some(num),num_of_nat(aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Nb),aa(num,nat,numeral_numeral(nat),Ma))))) ) ).

% take_bit_num_def
tff(fact_6630_find__Some__iff2,axiom,
    ! [A: $tType,X2: A,P: fun(A,$o),Xs: list(A)] :
      ( ( aa(A,option(A),some(A),X2) = find(A,P,Xs) )
    <=> ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
          & aa(A,$o,P,aa(nat,A,nth(A,Xs),I))
          & ( X2 = aa(nat,A,nth(A,Xs),I) )
          & ! [J4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),I)
             => ~ aa(A,$o,P,aa(nat,A,nth(A,Xs),J4)) ) ) ) ).

% find_Some_iff2
tff(fact_6631_find__Some__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),X2: A] :
      ( ( find(A,P,Xs) = aa(A,option(A),some(A),X2) )
    <=> ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
          & aa(A,$o,P,aa(nat,A,nth(A,Xs),I))
          & ( X2 = aa(nat,A,nth(A,Xs),I) )
          & ! [J4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J4),I)
             => ~ aa(A,$o,P,aa(nat,A,nth(A,Xs),J4)) ) ) ) ).

% find_Some_iff
tff(fact_6632_and__minus__numerals_I7_J,axiom,
    ! [Nb: num,Ma: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))),aa(num,int,numeral_numeral(int),Ma)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(Ma,bitM(Nb))) ) ).

% and_minus_numerals(7)
tff(fact_6633_and__minus__numerals_I3_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Nb)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(Ma,bitM(Nb))) ) ).

% and_minus_numerals(3)
tff(fact_6634_and__minus__numerals_I4_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(Ma,aa(num,num,bit0,Nb))) ) ).

% and_minus_numerals(4)
tff(fact_6635_and__minus__numerals_I8_J,axiom,
    ! [Nb: num,Ma: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Nb)))),aa(num,int,numeral_numeral(int),Ma)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(Ma,aa(num,num,bit0,Nb))) ) ).

% and_minus_numerals(8)
tff(fact_6636_and__not__num_Osimps_I3_J,axiom,
    ! [Nb: num] : ( bit_and_not_num(one2,aa(num,num,bit1,Nb)) = none(num) ) ).

% and_not_num.simps(3)
tff(fact_6637_and__not__num_Osimps_I1_J,axiom,
    bit_and_not_num(one2,one2) = none(num) ).

% and_not_num.simps(1)
tff(fact_6638_and__not__num_Osimps_I2_J,axiom,
    ! [Nb: num] : ( bit_and_not_num(one2,aa(num,num,bit0,Nb)) = aa(num,option(num),some(num),one2) ) ).

% and_not_num.simps(2)
tff(fact_6639_and__not__num_Osimps_I4_J,axiom,
    ! [Ma: num] : ( bit_and_not_num(aa(num,num,bit0,Ma),one2) = aa(num,option(num),some(num),aa(num,num,bit0,Ma)) ) ).

% and_not_num.simps(4)
tff(fact_6640_and__not__num_Osimps_I7_J,axiom,
    ! [Ma: num] : ( bit_and_not_num(aa(num,num,bit1,Ma),one2) = aa(num,option(num),some(num),aa(num,num,bit0,Ma)) ) ).

% and_not_num.simps(7)
tff(fact_6641_and__not__num__eq__Some__iff,axiom,
    ! [Ma: num,Nb: num,Q2: num] :
      ( ( bit_and_not_num(Ma,Nb) = aa(num,option(num),some(num),Q2) )
    <=> ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb))) = aa(num,int,numeral_numeral(int),Q2) ) ) ).

% and_not_num_eq_Some_iff
tff(fact_6642_and__not__num_Osimps_I8_J,axiom,
    ! [Ma: num,Nb: num] : ( bit_and_not_num(aa(num,num,bit1,Ma),aa(num,num,bit0,Nb)) = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_za(num,option(num)),bit_and_not_num(Ma,Nb)) ) ).

% and_not_num.simps(8)
tff(fact_6643_and__not__num__eq__None__iff,axiom,
    ! [Ma: num,Nb: num] :
      ( ( bit_and_not_num(Ma,Nb) = none(num) )
    <=> ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb))) = zero_zero(int) ) ) ).

% and_not_num_eq_None_iff
tff(fact_6644_int__numeral__not__and__num,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Ma))),aa(num,int,numeral_numeral(int),Nb)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(Nb,Ma)) ) ).

% int_numeral_not_and_num
tff(fact_6645_int__numeral__and__not__num,axiom,
    ! [Ma: num,Nb: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),Ma)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Nb))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(Ma,Nb)) ) ).

% int_numeral_and_not_num
tff(fact_6646_Bit__Operations_Otake__bit__num__code,axiom,
    ! [Nb: nat,Ma: num] : ( bit_take_bit_num(Nb,Ma) = aa(product_prod(nat,num),option(num),aa(fun(nat,fun(num,option(num))),fun(product_prod(nat,num),option(num)),product_case_prod(nat,num,option(num)),aTP_Lamp_ze(nat,fun(num,option(num)))),aa(num,product_prod(nat,num),aa(nat,fun(num,product_prod(nat,num)),product_Pair(nat,num),Nb),Ma)) ) ).

% Bit_Operations.take_bit_num_code
tff(fact_6647_partition__filter__conv,axiom,
    ! [A: $tType,F3: fun(A,$o),Xs: list(A)] : ( partition(A,F3,Xs) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),filter2(A,F3),Xs)),aa(list(A),list(A),filter2(A,aa(fun(A,$o),fun(A,$o),comp($o,$o,A,fNot),F3)),Xs)) ) ).

% partition_filter_conv
tff(fact_6648_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,A),F32: fun(num,A)] : ( case_num(A,F1,F2,F32,one2) = F1 ) ).

% verit_eq_simplify(16)
tff(fact_6649_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: fun(B,A),F1: B,F2: fun(num,B),F32: fun(num,B),Num: num] : ( aa(B,A,H,case_num(B,F1,F2,F32,Num)) = case_num(A,aa(B,A,H,F1),aa(fun(num,B),fun(num,A),aTP_Lamp_zf(fun(B,A),fun(fun(num,B),fun(num,A)),H),F2),aa(fun(num,B),fun(num,A),aTP_Lamp_zf(fun(B,A),fun(fun(num,B),fun(num,A)),H),F32),Num) ) ).

% num.case_distrib
tff(fact_6650_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,A),F32: fun(num,A),X22: num] : ( case_num(A,F1,F2,F32,aa(num,num,bit0,X22)) = aa(num,A,F2,X22) ) ).

% verit_eq_simplify(17)
tff(fact_6651_partition__filter1,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),partition(A,P,Xs)) = aa(list(A),list(A),filter2(A,P),Xs) ) ).

% partition_filter1
tff(fact_6652_verit__eq__simplify_I18_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,A),F32: fun(num,A),X32: num] : ( case_num(A,F1,F2,F32,aa(num,num,bit1,X32)) = aa(num,A,F32,X32) ) ).

% verit_eq_simplify(18)
tff(fact_6653_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,$o)] : ( partition(A,P,nil(A)) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)) ) ).

% partition.simps(1)
tff(fact_6654_partition__P,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Yes: list(A),No: list(A)] :
      ( ( partition(A,P,Xs) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No) )
     => ( ! [X: A] :
            ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),Yes))
           => aa(A,$o,P,X) )
        & ! [X: A] :
            ( aa(set(A),$o,member(A,X),aa(list(A),set(A),set2(A),No))
           => ~ aa(A,$o,P,X) ) ) ) ).

% partition_P
tff(fact_6655_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,$o),X2: A,Xs: list(A)] : ( partition(A,P,aa(list(A),list(A),cons(A,X2),Xs)) = aa(product_prod(list(A),list(A)),product_prod(list(A),list(A)),aa(fun(list(A),fun(list(A),product_prod(list(A),list(A)))),fun(product_prod(list(A),list(A)),product_prod(list(A),list(A))),product_case_prod(list(A),list(A),product_prod(list(A),list(A))),aa(A,fun(list(A),fun(list(A),product_prod(list(A),list(A)))),aTP_Lamp_zg(fun(A,$o),fun(A,fun(list(A),fun(list(A),product_prod(list(A),list(A))))),P),X2)),partition(A,P,Xs)) ) ).

% partition.simps(2)
tff(fact_6656_partition__filter2,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),partition(A,P,Xs)) = aa(list(A),list(A),filter2(A,aa(fun(A,$o),fun(A,$o),comp($o,$o,A,fNot),P)),Xs) ) ).

% partition_filter2
tff(fact_6657_DERIV__real__root__generic,axiom,
    ! [Nb: nat,X2: real,D4: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( ( X2 != zero_zero(real) )
       => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
             => ( D4 = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))) ) ) )
         => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real))
               => ( D4 = aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat))))))) ) ) )
           => ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
               => ( D4 = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))) ) )
             => has_field_derivative(real,root(Nb),D4,topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ) ) ) ).

% DERIV_real_root_generic
tff(fact_6658_DERIV__even__real__root,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real))
         => has_field_derivative(real,root(Nb),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(nat,real,semiring_1_of_nat(real),Nb))),aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ) ).

% DERIV_even_real_root
tff(fact_6659_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F3,Y3,topolo174197925503356063within(real,X4,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),zero_zero(real)) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) ) ) ).

% DERIV_neg_imp_decreasing
tff(fact_6660_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F3,Y3,topolo174197925503356063within(real,X4,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y3) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,A2)),aa(real,real,F3,B2)) ) ) ).

% DERIV_pos_imp_increasing
tff(fact_6661_MVT2,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),F8: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2)
             => has_field_derivative(real,F3,aa(real,real,F8,X4),topolo174197925503356063within(real,X4,top_top(set(real)))) ) )
       => ? [Z2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
            & ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),aa(real,real,F8,Z2)) ) ) ) ) ).

% MVT2
tff(fact_6662_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X2: real,Y2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( aa(set(real),$o,member(real,X2),set_or5935395276787703475ssThan(real,A2,B2))
       => ( aa(set(real),$o,member(real,Y2),set_or5935395276787703475ssThan(real,A2,B2))
         => ( ! [X4: real] :
                ( aa(set(real),$o,member(real,X4),set_or5935395276787703475ssThan(real,A2,B2))
               => has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,X4,top_top(set(real)))) )
           => ( aa(real,real,F3,X2) = aa(real,real,F3,Y2) ) ) ) ) ) ).

% DERIV_isconst3
tff(fact_6663_has__real__derivative__pos__inc__left,axiom,
    ! [F3: fun(real,real),L: real,X2: real,S3: set(real)] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,S3))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(set(real),$o,member(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),H3)),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D3)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),H3))),aa(real,real,F3,X2)) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
tff(fact_6664_has__real__derivative__neg__dec__left,axiom,
    ! [F3: fun(real,real),L: real,X2: real,S3: set(real)] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,S3))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(set(real),$o,member(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),H3)),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D3)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,X2)),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),H3))) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
tff(fact_6665_has__real__derivative__pos__inc__right,axiom,
    ! [F3: fun(real,real),L: real,X2: real,S3: set(real)] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,S3))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(set(real),$o,member(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),H3)),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D3)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,X2)),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),H3))) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
tff(fact_6666_has__real__derivative__neg__dec__right,axiom,
    ! [F3: fun(real,real),L: real,X2: real,S3: set(real)] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,S3))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(set(real),$o,member(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),H3)),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D3)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),H3))),aa(real,real,F3,X2)) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
tff(fact_6667_DERIV__neg__dec__right,axiom,
    ! [F3: fun(real,real),L: real,X2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D3)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),H3))),aa(real,real,F3,X2)) ) ) ) ) ) ).

% DERIV_neg_dec_right
tff(fact_6668_DERIV__pos__inc__right,axiom,
    ! [F3: fun(real,real),L: real,X2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D3)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,X2)),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),plus_plus(real),X2),H3))) ) ) ) ) ) ).

% DERIV_pos_inc_right
tff(fact_6669_DERIV__pos__inc__left,axiom,
    ! [F3: fun(real,real),L: real,X2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D3)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),H3))),aa(real,real,F3,X2)) ) ) ) ) ) ).

% DERIV_pos_inc_left
tff(fact_6670_DERIV__neg__dec__left,axiom,
    ! [F3: fun(real,real),L: real,X2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D3)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,X2)),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),H3))) ) ) ) ) ) ).

% DERIV_neg_dec_left
tff(fact_6671_DERIV__ln,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => has_field_derivative(real,ln_ln(real),aa(real,real,inverse_inverse(real),X2),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ).

% DERIV_ln
tff(fact_6672_DERIV__local__const,axiom,
    ! [F3: fun(real,real),L: real,X2: real,D2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y4))),D2)
             => ( aa(real,real,F3,X2) = aa(real,real,F3,Y4) ) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_const
tff(fact_6673_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Y2: A,Z: A,X2: A,S3: set(A)] :
          ( has_field_derivative(A,F3,Y2,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),X2),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),Z)),S3)))
        <=> has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_zh(fun(A,A),fun(A,fun(A,A)),F3),Z),Y2,topolo174197925503356063within(A,X2,S3)) ) ) ).

% DERIV_at_within_shift
tff(fact_6674_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),K: real] :
      ( ( A2 != B2 )
     => ( ! [X4: real] : has_field_derivative(real,F3,K,topolo174197925503356063within(real,X4,top_top(set(real))))
       => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),K) ) ) ) ).

% DERIV_const_ratio_const
tff(fact_6675_DERIV__mirror,axiom,
    ! [F3: fun(real,real),Y2: real,X2: real] :
      ( has_field_derivative(real,F3,Y2,topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),X2),top_top(set(real))))
    <=> has_field_derivative(real,aTP_Lamp_zi(fun(real,real),fun(real,real),F3),aa(real,real,uminus_uminus(real),Y2),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ).

% DERIV_mirror
tff(fact_6676_DERIV__isconst__all,axiom,
    ! [F3: fun(real,real),X2: real,Y2: real] :
      ( ! [X4: real] : has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,X4,top_top(set(real))))
     => ( aa(real,real,F3,X2) = aa(real,real,F3,Y2) ) ) ).

% DERIV_isconst_all
tff(fact_6677_DERIV__shift,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Y2: A,X2: A,Z: A] :
          ( has_field_derivative(A,F3,Y2,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z),top_top(set(A))))
        <=> has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_zj(fun(A,A),fun(A,fun(A,A)),F3),Z),Y2,topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ).

% DERIV_shift
tff(fact_6678_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),G: fun(A,A),E5: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => ( has_field_derivative(A,G,E5,topolo174197925503356063within(A,aa(A,A,F3,X2),top_top(set(A))))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zk(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),times_times(A),E5),D4),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_chain'
tff(fact_6679_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Da: A,G: fun(A,A),X2: A,Db: A,S: set(A)] :
          ( has_field_derivative(A,F3,Da,topolo174197925503356063within(A,aa(A,A,G,X2),top_top(set(A))))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X2,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zl(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_chain2
tff(fact_6680_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [G: fun(A,A),G2: fun(A,A),F3: fun(A,A),F8: A,X2: A] :
          ( ! [X4: A] : has_field_derivative(A,G,aa(A,A,G2,X4),topolo174197925503356063within(A,X4,top_top(set(A))))
         => ( has_field_derivative(A,F3,F8,topolo174197925503356063within(A,X2,top_top(set(A))))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zl(fun(A,A),fun(fun(A,A),fun(A,A)),G),F3),aa(A,A,aa(A,fun(A,A),times_times(A),F8),aa(A,A,G2,aa(A,A,F3,X2))),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ) ).

% DERIV_chain3
tff(fact_6681_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [S: set(A),G: fun(A,A),G2: fun(A,A),F3: fun(A,A),F8: A,X2: A] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),S)
             => has_field_derivative(A,G,aa(A,A,G2,X4),topolo174197925503356063within(A,X4,top_top(set(A)))) )
         => ( has_field_derivative(A,F3,F8,topolo174197925503356063within(A,X2,top_top(set(A))))
           => ( aa(set(A),$o,member(A,aa(A,A,F3,X2)),S)
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zl(fun(A,A),fun(fun(A,A),fun(A,A)),G),F3),aa(A,A,aa(A,fun(A,A),times_times(A),F8),aa(A,A,G2,aa(A,A,F3,X2))),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ) ) ).

% DERIV_chain_s
tff(fact_6682_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Ma: A,X2: A] :
          ( has_field_derivative(A,G,Ma,topolo174197925503356063within(A,X2,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_zm(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),aa(A,A,G,X2))),Ma),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ).

% DERIV_fun_exp
tff(fact_6683_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Ma: A,X2: A] :
          ( has_field_derivative(A,G,Ma,topolo174197925503356063within(A,X2,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_zn(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,aa(A,A,G,X2))),Ma),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ).

% DERIV_fun_sin
tff(fact_6684_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_zo(fun(A,A),fun(A,fun(A,A)),F3),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),D4),C2),topolo174197925503356063within(A,X2,S)) ) ) ).

% DERIV_cdivide
tff(fact_6685_has__field__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,X2: A,S: set(A)] :
          ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X2,S))
         => has_field_derivative(A,aTP_Lamp_zp(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,aa(A,A,G,X2))),Db),topolo174197925503356063within(A,X2,S)) ) ) ).

% has_field_derivative_sinh
tff(fact_6686_has__field__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,X2: A,S: set(A)] :
          ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X2,S))
         => has_field_derivative(A,aTP_Lamp_zq(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,aa(A,A,G,X2))),Db),topolo174197925503356063within(A,X2,S)) ) ) ).

% has_field_derivative_cosh
tff(fact_6687_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),G: fun(A,A),E5: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => ( has_field_derivative(A,G,E5,topolo174197925503356063within(A,X2,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zr(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,F3,X2)),E5)),aa(A,A,aa(A,fun(A,A),times_times(A),D4),aa(A,A,G,X2))),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_mult'
tff(fact_6688_DERIV__mult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Da: A,X2: A,S: set(A),G: fun(A,A),Db: A] :
          ( has_field_derivative(A,F3,Da,topolo174197925503356063within(A,X2,S))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X2,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zr(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Da),aa(A,A,G,X2))),aa(A,A,aa(A,fun(A,A),times_times(A),Db),aa(A,A,F3,X2))),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_mult
tff(fact_6689_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_zs(fun(A,A),fun(A,fun(A,A)),F3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),D4),C2),topolo174197925503356063within(A,X2,S)) ) ) ).

% DERIV_cmult_right
tff(fact_6690_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_zt(fun(A,A),fun(A,fun(A,A)),F3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D4),topolo174197925503356063within(A,X2,S)) ) ) ).

% DERIV_cmult
tff(fact_6691_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),F8: A,F4: filter(A),G: fun(A,A),G2: A] :
          ( has_field_derivative(A,F3,F8,F4)
         => ( has_field_derivative(A,G,G2,F4)
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zu(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),F8),G2),F4) ) ) ) ).

% field_differentiable_add
tff(fact_6692_DERIV__add,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),G: fun(A,A),E5: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => ( has_field_derivative(A,G,E5,topolo174197925503356063within(A,X2,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zu(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),D4),E5),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_add
tff(fact_6693_DERIV__ident,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F4: filter(A)] : has_field_derivative(A,aTP_Lamp_zv(A,A),one_one(A),F4) ) ).

% DERIV_ident
tff(fact_6694_has__field__derivative__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,F4: filter(A),C2: real] :
          ( has_field_derivative(A,F3,D4,F4)
         => has_field_derivative(A,aa(real,fun(A,A),aTP_Lamp_zw(fun(A,A),fun(real,fun(A,A)),F3),C2),aa(A,A,real_V8093663219630862766scaleR(A,C2),D4),F4) ) ) ).

% has_field_derivative_scaleR_right
tff(fact_6695_DERIV__const,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [K: A,F4: filter(A)] : has_field_derivative(A,aTP_Lamp_zx(A,fun(A,A),K),zero_zero(A),F4) ) ).

% DERIV_const
tff(fact_6696_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,X2: A,S: set(A)] : has_field_derivative(A,aa(A,fun(A,A),times_times(A),C2),C2,topolo174197925503356063within(A,X2,S)) ) ).

% DERIV_cmult_Id
tff(fact_6697_DERIV__minus,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A)] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => has_field_derivative(A,aTP_Lamp_zy(fun(A,A),fun(A,A),F3),aa(A,A,uminus_uminus(A),D4),topolo174197925503356063within(A,X2,S)) ) ) ).

% DERIV_minus
tff(fact_6698_field__differentiable__minus,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),F8: A,F4: filter(A)] :
          ( has_field_derivative(A,F3,F8,F4)
         => has_field_derivative(A,aTP_Lamp_zy(fun(A,A),fun(A,A),F3),aa(A,A,uminus_uminus(A),F8),F4) ) ) ).

% field_differentiable_minus
tff(fact_6699_DERIV__diff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),G: fun(A,A),E5: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => ( has_field_derivative(A,G,E5,topolo174197925503356063within(A,X2,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zz(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),D4),E5),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_diff
tff(fact_6700_field__differentiable__diff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),F8: A,F4: filter(A),G: fun(A,A),G2: A] :
          ( has_field_derivative(A,F3,F8,F4)
         => ( has_field_derivative(A,G,G2,F4)
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_zz(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),F8),G2),F4) ) ) ) ).

% field_differentiable_diff
tff(fact_6701_DERIV__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),G: fun(A,A),E5: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => ( has_field_derivative(A,G,E5,topolo174197925503356063within(A,X2,S))
           => ( ( aa(A,A,G,X2) != zero_zero(A) )
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_aaa(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D4),aa(A,A,G,X2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,F3,X2)),E5))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,G,X2)),aa(A,A,G,X2))),topolo174197925503356063within(A,X2,S)) ) ) ) ) ).

% DERIV_divide
tff(fact_6702_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A)] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => ( ( aa(A,A,F3,X2) != zero_zero(A) )
           => has_field_derivative(A,aTP_Lamp_aab(fun(A,A),fun(A,A),F3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(A,A,F3,X2))),D4)),aa(A,A,inverse_inverse(A),aa(A,A,F3,X2)))),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_inverse'
tff(fact_6703_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K: A,Xa2: A] : has_field_derivative(A,aTP_Lamp_aac(A,fun(A,A),K),aa(A,A,uminus_uminus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa2),K))),topolo174197925503356063within(A,Xa2,top_top(set(A)))) ) ).

% DERIV_cos_add
tff(fact_6704_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Ma: A,X2: A] :
          ( has_field_derivative(A,G,Ma,topolo174197925503356063within(A,X2,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_aad(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),sin(A,aa(A,A,G,X2)))),Ma),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ).

% DERIV_fun_cos
tff(fact_6705_DERIV__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [S3: set(A),F3: fun(B,fun(A,B)),F8: fun(C,fun(A,B)),X2: C,F4: filter(B)] :
          ( ! [N: A] :
              ( aa(set(A),$o,member(A,N),S3)
             => has_field_derivative(B,aa(A,fun(B,B),aTP_Lamp_aae(fun(B,fun(A,B)),fun(A,fun(B,B)),F3),N),aa(A,B,aa(C,fun(A,B),F8,X2),N),F4) )
         => has_field_derivative(B,aa(fun(B,fun(A,B)),fun(B,B),aTP_Lamp_aaf(set(A),fun(fun(B,fun(A,B)),fun(B,B)),S3),F3),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(C,fun(A,B),F8,X2)),S3),F4) ) ) ).

% DERIV_sum
tff(fact_6706_DERIV__chain,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Da: A,G: fun(A,A),X2: A,Db: A,S: set(A)] :
          ( has_field_derivative(A,F3,Da,topolo174197925503356063within(A,aa(A,A,G,X2),top_top(set(A))))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X2,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F3),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_chain
tff(fact_6707_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F3,Y3,topolo174197925503356063within(real,X4,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),zero_zero(real)) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) ) ) ).

% DERIV_nonpos_imp_nonincreasing
tff(fact_6708_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F3,Y3,topolo174197925503356063within(real,X4,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y3) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,A2)),aa(real,real,F3,B2)) ) ) ).

% DERIV_nonneg_imp_nondecreasing
tff(fact_6709_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: fun(real,real),G2: fun(real,real)] :
      ( ! [X4: real] :
          ( aa(set(real),$o,member(real,X4),set_or1337092689740270186AtMost(real,A2,B2))
         => has_field_derivative(real,G,aa(real,real,G2,X4),topolo174197925503356063within(real,X4,top_top(set(real)))) )
     => ( ! [X4: real] :
            ( aa(set(real),$o,member(real,X4),set_or1337092689740270186AtMost(real,A2,B2))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,G2,X4)) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,G,A2)),aa(real,real,G,B2)) ) ) ) ).

% deriv_nonneg_imp_mono
tff(fact_6710_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Da: A,G: fun(A,A),X2: A,S: set(A),Db: A] :
          ( has_field_derivative(A,F3,Da,topolo174197925503356063within(A,aa(A,A,G,X2),aa(set(A),set(A),image(A,A,G),S)))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X2,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F3),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_image_chain
tff(fact_6711_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Y2: A,Z: A,X2: A,S3: set(A)] :
          ( has_field_derivative(A,F3,Y2,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),X2),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),Z)),S3)))
         => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F3),aa(A,fun(A,A),plus_plus(A),Z)),Y2,topolo174197925503356063within(A,X2,S3)) ) ) ).

% DERIV_at_within_shift_lemma
tff(fact_6712_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),Nb: nat] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => has_field_derivative(A,aa(nat,fun(A,A),aTP_Lamp_aag(fun(A,A),fun(nat,fun(A,A)),F3),Nb),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Nb))),aa(A,A,aa(A,fun(A,A),times_times(A),D4),aa(nat,A,power_power(A,aa(A,A,F3,X2)),Nb))),topolo174197925503356063within(A,X2,S)) ) ) ).

% DERIV_power_Suc
tff(fact_6713_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V: fun(real,real),K: real] :
      ( ( A2 != B2 )
     => ( ! [X4: real] : has_field_derivative(real,V,K,topolo174197925503356063within(real,X4,top_top(set(real))))
       => ( aa(real,real,V,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,V,A2)),aa(real,real,V,B2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ) ).

% DERIV_const_average
tff(fact_6714_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [X2: A,S: set(A)] :
          ( ( X2 != zero_zero(A) )
         => has_field_derivative(A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(nat,A,power_power(A,aa(A,A,inverse_inverse(A),X2)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(A,X2,S)) ) ) ).

% DERIV_inverse
tff(fact_6715_DERIV__power,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S: set(A),Nb: nat] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S))
         => has_field_derivative(A,aa(nat,fun(A,A),aTP_Lamp_aah(fun(A,A),fun(nat,fun(A,A)),F3),Nb),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Nb)),aa(A,A,aa(A,fun(A,A),times_times(A),D4),aa(nat,A,power_power(A,aa(A,A,F3,X2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(A,X2,S)) ) ) ).

% DERIV_power
tff(fact_6716_DERIV__local__min,axiom,
    ! [F3: fun(real,real),L: real,X2: real,D2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y4))),D2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,X2)),aa(real,real,F3,Y4)) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_min
tff(fact_6717_DERIV__local__max,axiom,
    ! [F3: fun(real,real),L: real,X2: real,D2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y4))),D2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,Y4)),aa(real,real,F3,X2)) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_max
tff(fact_6718_DERIV__ln__divide,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => has_field_derivative(real,ln_ln(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X2),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ).

% DERIV_ln_divide
tff(fact_6719_DERIV__pow,axiom,
    ! [Nb: nat,X2: real,S: set(real)] : has_field_derivative(real,aTP_Lamp_aai(nat,fun(real,real),Nb),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,power_power(real,X2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(real,X2,S)) ).

% DERIV_pow
tff(fact_6720_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X2: A] :
          ( ! [Y4: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),Y4))
         => has_field_derivative(A,aTP_Lamp_aaj(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),X2)),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ).

% termdiffs_strong_converges_everywhere
tff(fact_6721_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,X2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),B2)
           => ( topolo174197925503356063within(A,X2,set_or1337092689740270186AtMost(A,A2,B2)) = topolo174197925503356063within(A,X2,top_top(set(A))) ) ) ) ) ).

% at_within_Icc_at
tff(fact_6722_DERIV__fun__pow,axiom,
    ! [G: fun(real,real),Ma: real,X2: real,Nb: nat] :
      ( has_field_derivative(real,G,Ma,topolo174197925503356063within(real,X2,top_top(set(real))))
     => has_field_derivative(real,aa(nat,fun(real,real),aTP_Lamp_aak(fun(real,real),fun(nat,fun(real,real)),G),Nb),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,power_power(real,aa(real,real,G,X2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),one_one(nat))))),Ma),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ).

% DERIV_fun_pow
tff(fact_6723_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( topolo174197925503356063within(A,B2,set_or1337092689740270186AtMost(A,A2,B2)) = topolo174197925503356063within(A,B2,aa(A,set(A),set_ord_lessThan(A),B2)) ) ) ) ).

% at_within_Icc_at_left
tff(fact_6724_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D2: A,X2: A,S: set(A),G: fun(A,A),E2: A] :
          ( has_field_derivative(A,F3,D2,topolo174197925503356063within(A,X2,S))
         => ( has_field_derivative(A,G,E2,topolo174197925503356063within(A,X2,S))
           => ( ( aa(A,A,G,X2) != zero_zero(A) )
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_aaa(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D2),aa(A,A,G,X2))),aa(A,A,aa(A,fun(A,A),times_times(A),E2),aa(A,A,F3,X2)))),aa(nat,A,power_power(A,aa(A,A,G,X2)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(A,X2,S)) ) ) ) ) ).

% DERIV_quotient
tff(fact_6725_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D2: A,X2: A,S: set(A)] :
          ( has_field_derivative(A,F3,D2,topolo174197925503356063within(A,X2,S))
         => ( ( aa(A,A,F3,X2) != zero_zero(A) )
           => has_field_derivative(A,aTP_Lamp_aab(fun(A,A),fun(A,A),F3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D2),aa(A,A,inverse_inverse(A),aa(nat,A,power_power(A,aa(A,A,F3,X2)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))))),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_inverse_fun
tff(fact_6726_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K5: real,C2: fun(nat,A),F3: fun(A,A),F8: A,Z: A] :
          ( ! [Z2: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z2)),K5)
             => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),Z2)),aa(A,A,F3,Z2)) )
         => ( has_field_derivative(A,F3,F8,topolo174197925503356063within(A,Z,top_top(set(A))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),K5)
             => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),Z)),F8) ) ) ) ) ).

% termdiffs_sums_strong
tff(fact_6727_has__real__derivative__powr,axiom,
    ! [Z: real,R: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Z)
     => has_field_derivative(real,aTP_Lamp_aal(real,fun(real,real),R),aa(real,real,aa(real,fun(real,real),times_times(real),R),powr(real,Z,aa(real,real,aa(real,fun(real,real),minus_minus(real),R),one_one(real)))),topolo174197925503356063within(real,Z,top_top(set(real)))) ) ).

% has_real_derivative_powr
tff(fact_6728_DERIV__series_H,axiom,
    ! [F3: fun(real,fun(nat,real)),F8: fun(real,fun(nat,real)),X0: real,A2: real,B2: real,L4: fun(nat,real)] :
      ( ! [N: nat] : has_field_derivative(real,aa(nat,fun(real,real),aTP_Lamp_aam(fun(real,fun(nat,real)),fun(nat,fun(real,real)),F3),N),aa(nat,real,aa(real,fun(nat,real),F8,X0),N),topolo174197925503356063within(real,X0,top_top(set(real))))
     => ( ! [X4: real] :
            ( aa(set(real),$o,member(real,X4),set_or5935395276787703475ssThan(real,A2,B2))
           => summable(real,aa(real,fun(nat,real),F3,X4)) )
       => ( aa(set(real),$o,member(real,X0),set_or5935395276787703475ssThan(real,A2,B2))
         => ( summable(real,aa(real,fun(nat,real),F8,X0))
           => ( summable(real,L4)
             => ( ! [N: nat,X4: real,Y4: real] :
                    ( aa(set(real),$o,member(real,X4),set_or5935395276787703475ssThan(real,A2,B2))
                   => ( aa(set(real),$o,member(real,Y4),set_or5935395276787703475ssThan(real,A2,B2))
                     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),F3,X4),N)),aa(nat,real,aa(real,fun(nat,real),F3,Y4),N)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,L4,N)),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X4),Y4)))) ) )
               => has_field_derivative(real,aTP_Lamp_aan(fun(real,fun(nat,real)),fun(real,real),F3),suminf(real,aa(real,fun(nat,real),F8,X0)),topolo174197925503356063within(real,X0,top_top(set(real)))) ) ) ) ) ) ) ).

% DERIV_series'
tff(fact_6729_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K5: real,C2: fun(nat,A),Z: A] :
          ( ! [Z2: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z2)),K5)
             => summable(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),Z2)) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),K5)
           => has_field_derivative(A,aTP_Lamp_aaj(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),Z)),topolo174197925503356063within(A,Z,top_top(set(A)))) ) ) ) ).

% termdiffs_strong'
tff(fact_6730_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,K5))
           => has_field_derivative(A,aTP_Lamp_aaj(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),X2)),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ) ).

% termdiffs_strong
tff(fact_6731_termdiffs,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( summable(A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
           => ( summable(A,aa(A,fun(nat,A),aTP_Lamp_aao(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,K5))
               => has_field_derivative(A,aTP_Lamp_aaj(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),X2)),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ) ) ) ).

% termdiffs
tff(fact_6732_DERIV__log,axiom,
    ! [X2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => has_field_derivative(real,log(B2),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,ln_ln(real),B2)),X2)),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ).

% DERIV_log
tff(fact_6733_DERIV__fun__powr,axiom,
    ! [G: fun(real,real),Ma: real,X2: real,R: real] :
      ( has_field_derivative(real,G,Ma,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,G,X2))
       => has_field_derivative(real,aa(real,fun(real,real),aTP_Lamp_aap(fun(real,real),fun(real,fun(real,real)),G),R),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),R),powr(real,aa(real,real,G,X2),aa(real,real,aa(real,fun(real,real),minus_minus(real),R),aa(nat,real,semiring_1_of_nat(real),one_one(nat)))))),Ma),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ).

% DERIV_fun_powr
tff(fact_6734_DERIV__powr,axiom,
    ! [G: fun(real,real),Ma: real,X2: real,F3: fun(real,real),R: real] :
      ( has_field_derivative(real,G,Ma,topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,G,X2))
       => ( has_field_derivative(real,F3,R,topolo174197925503356063within(real,X2,top_top(set(real))))
         => has_field_derivative(real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaq(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,aa(real,real,G,X2),aa(real,real,F3,X2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),R),aa(real,real,ln_ln(real),aa(real,real,G,X2)))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),Ma),aa(real,real,F3,X2))),aa(real,real,G,X2)))),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ) ).

% DERIV_powr
tff(fact_6735_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( cos(A,X2) != zero_zero(A) )
         => has_field_derivative(A,tan(A),aa(A,A,inverse_inverse(A),aa(nat,A,power_power(A,cos(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ).

% DERIV_tan
tff(fact_6736_DERIV__real__sqrt,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
     => has_field_derivative(real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ).

% DERIV_real_sqrt
tff(fact_6737_DERIV__arctan,axiom,
    ! [X2: real] : has_field_derivative(real,arctan,aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),topolo174197925503356063within(real,X2,top_top(set(real)))) ).

% DERIV_arctan
tff(fact_6738_arsinh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set(real)] : has_field_derivative(real,arsinh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real)))),topolo174197925503356063within(real,X2,A3)) ).

% arsinh_real_has_field_derivative
tff(fact_6739_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( sin(A,X2) != zero_zero(A) )
         => has_field_derivative(A,cot(A),aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),aa(nat,A,power_power(A,sin(A,X2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ).

% DERIV_cot
tff(fact_6740_has__field__derivative__tanh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),X2: A,Db: A,S: set(A)] :
          ( ( cosh(A,aa(A,A,G,X2)) != zero_zero(A) )
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X2,S))
           => has_field_derivative(A,aTP_Lamp_aar(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,power_power(A,aa(A,A,tanh(A),aa(A,A,G,X2))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),Db),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_field_derivative_tanh
tff(fact_6741_DERIV__real__sqrt__generic,axiom,
    ! [X2: real,D4: real] :
      ( ( X2 != zero_zero(real) )
     => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
         => ( D4 = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) )
       => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),zero_zero(real))
           => ( D4 = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) )
         => has_field_derivative(real,sqrt,D4,topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ) ).

% DERIV_real_sqrt_generic
tff(fact_6742_arcosh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set(real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => has_field_derivative(real,arcosh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real)))),topolo174197925503356063within(real,X2,A3)) ) ).

% arcosh_real_has_field_derivative
tff(fact_6743_artanh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set(real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => has_field_derivative(real,artanh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),topolo174197925503356063within(real,X2,A3)) ) ).

% artanh_real_has_field_derivative
tff(fact_6744_DERIV__power__series_H,axiom,
    ! [R3: real,F3: fun(nat,real),X0: real] :
      ( ! [X4: real] :
          ( aa(set(real),$o,member(real,X4),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),R3),R3))
         => summable(real,aa(real,fun(nat,real),aTP_Lamp_aas(fun(nat,real),fun(real,fun(nat,real)),F3),X4)) )
     => ( aa(set(real),$o,member(real,X0),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),R3),R3))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R3)
         => has_field_derivative(real,aTP_Lamp_aau(fun(nat,real),fun(real,real),F3),suminf(real,aa(real,fun(nat,real),aTP_Lamp_aas(fun(nat,real),fun(real,fun(nat,real)),F3),X0)),topolo174197925503356063within(real,X0,top_top(set(real)))) ) ) ) ).

% DERIV_power_series'
tff(fact_6745_DERIV__real__root,axiom,
    ! [Nb: nat,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X2)
       => has_field_derivative(real,root(Nb),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ).

% DERIV_real_root
tff(fact_6746_DERIV__arccos,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => has_field_derivative(real,arccos,aa(real,real,inverse_inverse(real),aa(real,real,uminus_uminus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ).

% DERIV_arccos
tff(fact_6747_DERIV__arcsin,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => has_field_derivative(real,arcsin,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,X2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ).

% DERIV_arcsin
tff(fact_6748_Maclaurin__all__le__objl,axiom,
    ! [Diff: fun(nat,fun(real,real)),F3: fun(real,real),X2: real,Nb: nat] :
      ( ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
        & ! [M3: nat,X4: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),X4),topolo174197925503356063within(real,X4,top_top(set(real)))) )
     => ? [T3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2))
          & ( aa(real,real,F3,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_aav(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ).

% Maclaurin_all_le_objl
tff(fact_6749_Maclaurin__all__le,axiom,
    ! [Diff: fun(nat,fun(real,real)),F3: fun(real,real),X2: real,Nb: nat] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
     => ( ! [M3: nat,X4: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),X4),topolo174197925503356063within(real,X4,top_top(set(real))))
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2))
            & ( aa(real,real,F3,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_aav(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ) ).

% Maclaurin_all_le
tff(fact_6750_DERIV__odd__real__root,axiom,
    ! [Nb: nat,X2: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
     => ( ( X2 != zero_zero(real) )
       => has_field_derivative(real,root(Nb),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Nb)),aa(nat,real,power_power(real,aa(real,real,root(Nb),X2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ).

% DERIV_odd_real_root
tff(fact_6751_Maclaurin,axiom,
    ! [H: real,Nb: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
         => ( ! [M3: nat,T3: real] :
                ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),H) )
               => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
           => ? [T3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),H)
                & ( aa(real,real,F3,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_aaw(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,H),Nb))) ) ) ) ) ) ) ).

% Maclaurin
tff(fact_6752_Maclaurin2,axiom,
    ! [H: real,Diff: fun(nat,fun(real,real)),F3: fun(real,real),Nb: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
       => ( ! [M3: nat,T3: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),H) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ? [T3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),H)
              & ( aa(real,real,F3,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_aaw(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,H),Nb))) ) ) ) ) ) ).

% Maclaurin2
tff(fact_6753_Maclaurin__minus,axiom,
    ! [H: real,Nb: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H),zero_zero(real))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
         => ( ! [M3: nat,T3: real] :
                ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),H),T3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),zero_zero(real)) )
               => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
           => ? [T3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),zero_zero(real))
                & ( aa(real,real,F3,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_aaw(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,H),Nb))) ) ) ) ) ) ) ).

% Maclaurin_minus
tff(fact_6754_Maclaurin__all__lt,axiom,
    ! [Diff: fun(nat,fun(real,real)),F3: fun(real,real),Nb: nat,X2: real] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => ( ( X2 != zero_zero(real) )
         => ( ! [M3: nat,X4: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),X4),topolo174197925503356063within(real,X4,top_top(set(real))))
           => ? [T3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,abs_abs(real),T3))
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2))
                & ( aa(real,real,F3,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_aav(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ) ) ) ).

% Maclaurin_all_lt
tff(fact_6755_Maclaurin__bi__le,axiom,
    ! [Diff: fun(nat,fun(real,real)),F3: fun(real,real),Nb: nat,X2: real] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
     => ( ! [M3: nat,T3: real] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2)) )
           => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X2))
            & ( aa(real,real,F3,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_aav(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,X2),Nb))) ) ) ) ) ).

% Maclaurin_bi_le
tff(fact_6756_Taylor__down,axiom,
    ! [Nb: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real),A2: real,B2: real,C2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
       => ( ! [M3: nat,T3: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),B2)
             => ? [T3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),T3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),C2)
                  & ( aa(real,real,F3,A2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_aax(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),A2),C2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),C2)),Nb))) ) ) ) ) ) ) ) ).

% Taylor_down
tff(fact_6757_Taylor__up,axiom,
    ! [Nb: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real),A2: real,B2: real,C2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
       => ( ! [M3: nat,T3: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),B2)
             => ? [T3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),T3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),B2)
                  & ( aa(real,real,F3,B2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_aax(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),B2),C2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),C2)),Nb))) ) ) ) ) ) ) ) ).

% Taylor_up
tff(fact_6758_Taylor,axiom,
    ! [Nb: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real),A2: real,B2: real,C2: real,X2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
       => ( ! [M3: nat,T3: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),B2)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X2)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),B2)
                 => ( ( X2 != C2 )
                   => ? [T3: real] :
                        ( $ite(
                            aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),C2),
                            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),T3)
                            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),C2) ),
                            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),T3)
                            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),X2) ) )
                        & ( aa(real,real,F3,X2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_aay(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),C2),X2)),aa(nat,set(nat),set_ord_lessThan(nat),Nb))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Nb),T3)),semiring_char_0_fact(real,Nb))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),C2)),Nb))) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
tff(fact_6759_Maclaurin__lemma2,axiom,
    ! [Nb: nat,H: real,Diff: fun(nat,fun(real,real)),K: nat,B4: real] :
      ( ! [M3: nat,T3: real] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),H) )
         => has_field_derivative(real,aa(nat,fun(real,real),Diff,M3),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
     => ( ( Nb = aa(nat,nat,suc,K) )
       => ! [M: nat,T7: real] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Nb)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T7)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T7),H) )
           => has_field_derivative(real,aa(nat,fun(real,real),aa(real,fun(nat,fun(real,real)),aa(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real))),aTP_Lamp_aba(nat,fun(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real)))),Nb),Diff),B4),M),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M)),T7)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_abb(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Diff),M),T7)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,M))))),aa(real,real,aa(real,fun(real,real),times_times(real),B4),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,T7),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,M)))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),aa(nat,nat,suc,M))))))),topolo174197925503356063within(real,T7,top_top(set(real)))) ) ) ) ).

% Maclaurin_lemma2
tff(fact_6760_DERIV__arctan__series,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => has_field_derivative(real,aTP_Lamp_abc(real,real),suminf(real,aTP_Lamp_abd(real,fun(nat,real),X2)),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ).

% DERIV_arctan_series
tff(fact_6761_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X2: A,G2: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,G,X2))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,G,X2)),one_one(real))
           => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
             => has_derivative(A,real,aTP_Lamp_abe(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_abf(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X2),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ) ).

% has_derivative_arcsin
tff(fact_6762_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X2: A,G2: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,G,X2))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,G,X2)),one_one(real))
           => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
             => has_derivative(A,real,aTP_Lamp_abg(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_abh(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X2),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ) ).

% has_derivative_arccos
tff(fact_6763_has__derivative__in__compose,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S: set(A),G: fun(B,C),G2: fun(B,C)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S))
         => ( has_derivative(B,C,G,G2,topolo174197925503356063within(B,aa(A,B,F3,X2),aa(set(A),set(B),image(A,B,F3),S)))
           => has_derivative(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_abi(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),aa(fun(B,C),fun(A,C),aTP_Lamp_abi(fun(A,B),fun(fun(B,C),fun(A,C)),F8),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_in_compose
tff(fact_6764_has__derivative__compose,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S: set(A),G: fun(B,C),G2: fun(B,C)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S))
         => ( has_derivative(B,C,G,G2,topolo174197925503356063within(B,aa(A,B,F3,X2),top_top(set(B))))
           => has_derivative(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_abi(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),aa(fun(B,C),fun(A,C),aTP_Lamp_abi(fun(A,B),fun(fun(B,C),fun(A,C)),F8),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_compose
tff(fact_6765_has__derivative__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,real),F8: fun(A,real),X2: A,S: set(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,real,F3,F8,topolo174197925503356063within(A,X2,S))
         => ( has_derivative(A,B,G,G2,topolo174197925503356063within(A,X2,S))
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abj(fun(A,real),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_abk(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F3),F8),X2),G),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_scaleR
tff(fact_6766_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,F4: filter(A)] :
          ( has_field_derivative(A,F3,D4,F4)
         => has_derivative(A,A,F3,aa(A,fun(A,A),times_times(A),D4),F4) ) ) ).

% has_field_derivative_imp_has_derivative
tff(fact_6767_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: fun(A,A),F4: filter(A),D7: A] :
          ( has_derivative(A,A,F3,D4,F4)
         => ( ! [X4: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),X4),D7) = aa(A,A,D4,X4) )
           => has_field_derivative(A,F3,D7,F4) ) ) ) ).

% has_derivative_imp_has_field_derivative
tff(fact_6768_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,F4: filter(A)] :
          ( has_field_derivative(A,F3,D4,F4)
        <=> has_derivative(A,A,F3,aa(A,fun(A,A),times_times(A),D4),F4) ) ) ).

% has_field_derivative_def
tff(fact_6769_has__derivative__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [I5: set(A),F3: fun(A,fun(B,C)),F8: fun(A,fun(B,C)),F4: filter(B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => has_derivative(B,C,aa(A,fun(B,C),F3,I2),aa(A,fun(B,C),F8,I2),F4) )
         => has_derivative(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_abm(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3),aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_abm(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F8),F4) ) ) ).

% has_derivative_sum
tff(fact_6770_has__derivative__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),F4: filter(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F3,F8,F4)
         => ( has_derivative(A,B,G,G2,F4)
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abn(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aTP_Lamp_abn(fun(A,B),fun(fun(A,B),fun(A,B)),F8),G2),F4) ) ) ) ).

% has_derivative_diff
tff(fact_6771_has__derivative__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),F4: filter(A)] :
          ( has_derivative(A,B,F3,F8,F4)
         => has_derivative(A,B,aTP_Lamp_abo(fun(A,B),fun(A,B),F3),aTP_Lamp_abo(fun(A,B),fun(A,B),F8),F4) ) ) ).

% has_derivative_minus
tff(fact_6772_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [C2: B,F4: filter(A)] : has_derivative(A,B,aTP_Lamp_abp(B,fun(A,B),C2),aTP_Lamp_abq(A,B),F4) ) ).

% has_derivative_const
tff(fact_6773_has__derivative__of__real,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [G: fun(A,real),G2: fun(A,real),F4: filter(A)] :
          ( has_derivative(A,real,G,G2,F4)
         => has_derivative(A,B,aTP_Lamp_abr(fun(A,real),fun(A,B),G),aTP_Lamp_abr(fun(A,real),fun(A,B),G2),F4) ) ) ).

% has_derivative_of_real
tff(fact_6774_has__derivative__ident,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F4: filter(A)] : has_derivative(A,A,aTP_Lamp_abs(A,A),aTP_Lamp_abs(A,A),F4) ) ).

% has_derivative_ident
tff(fact_6775_has__derivative__scaleR__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [G: fun(A,B),G2: fun(A,B),F4: filter(A),R: real] :
          ( has_derivative(A,B,G,G2,F4)
         => has_derivative(A,B,aa(real,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(real,fun(A,B)),G),R),aa(real,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(real,fun(A,B)),G2),R),F4) ) ) ).

% has_derivative_scaleR_right
tff(fact_6776_has__derivative__scaleR__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [G: fun(A,real),G2: fun(A,real),F4: filter(A),X2: B] :
          ( has_derivative(A,real,G,G2,F4)
         => has_derivative(A,B,aa(B,fun(A,B),aTP_Lamp_abu(fun(A,real),fun(B,fun(A,B)),G),X2),aa(B,fun(A,B),aTP_Lamp_abu(fun(A,real),fun(B,fun(A,B)),G2),X2),F4) ) ) ).

% has_derivative_scaleR_left
tff(fact_6777_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),F4: filter(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F3,F8,F4)
         => ( has_derivative(A,B,G,G2,F4)
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abv(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aTP_Lamp_abv(fun(A,B),fun(fun(A,B),fun(A,B)),F8),G2),F4) ) ) ) ).

% has_derivative_add
tff(fact_6778_has__derivative__mult__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [G: fun(A,B),G2: fun(A,B),F4: filter(A),X2: B] :
          ( has_derivative(A,B,G,G2,F4)
         => has_derivative(A,B,aa(B,fun(A,B),aTP_Lamp_abw(fun(A,B),fun(B,fun(A,B)),G),X2),aa(B,fun(A,B),aTP_Lamp_abw(fun(A,B),fun(B,fun(A,B)),G2),X2),F4) ) ) ).

% has_derivative_mult_right
tff(fact_6779_has__derivative__mult__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [G: fun(A,B),G2: fun(A,B),F4: filter(A),Y2: B] :
          ( has_derivative(A,B,G,G2,F4)
         => has_derivative(A,B,aa(B,fun(A,B),aTP_Lamp_abx(fun(A,B),fun(B,fun(A,B)),G),Y2),aa(B,fun(A,B),aTP_Lamp_abx(fun(A,B),fun(B,fun(A,B)),G2),Y2),F4) ) ) ).

% has_derivative_mult_left
tff(fact_6780_has__derivative__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S: set(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S))
         => ( has_derivative(A,B,G,G2,topolo174197925503356063within(A,X2,S))
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aby(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_abz(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F3),F8),X2),G),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_mult
tff(fact_6781_has__derivative__zero__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [F4: fun(A,B),X2: A] :
          ( has_derivative(A,B,aTP_Lamp_abq(A,B),F4,topolo174197925503356063within(A,X2,top_top(set(A))))
         => ! [X: A] : ( aa(A,B,F4,X) = zero_zero(B) ) ) ) ).

% has_derivative_zero_unique
tff(fact_6782_has__derivative__in__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [T2: set(A),G: fun(A,B),G2: fun(A,fun(A,B)),F3: fun(C,A),S: set(C),X2: C,F8: fun(C,A)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),T2)
             => has_derivative(A,B,G,aa(A,fun(A,B),G2,X4),topolo174197925503356063within(A,X4,T2)) )
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,F3),S)),T2)
           => ( aa(set(C),$o,member(C,X2),S)
             => ( has_derivative(C,A,F3,F8,topolo174197925503356063within(C,X2,S))
               => has_derivative(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aca(fun(A,B),fun(fun(C,A),fun(C,B)),G),F3),aa(fun(C,A),fun(C,B),aa(C,fun(fun(C,A),fun(C,B)),aa(fun(C,A),fun(C,fun(fun(C,A),fun(C,B))),aTP_Lamp_acb(fun(A,fun(A,B)),fun(fun(C,A),fun(C,fun(fun(C,A),fun(C,B)))),G2),F3),X2),F8),topolo174197925503356063within(C,X2,S)) ) ) ) ) ) ).

% has_derivative_in_compose2
tff(fact_6783_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G2: fun(A,real),X2: A,S: set(A)] :
          ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
         => has_derivative(A,real,aTP_Lamp_acc(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_acd(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G2),X2),topolo174197925503356063within(A,X2,S)) ) ) ).

% has_derivative_exp
tff(fact_6784_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G2: fun(A,real),X2: A,S: set(A)] :
          ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
         => has_derivative(A,real,aTP_Lamp_ace(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_acf(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G2),X2),topolo174197925503356063within(A,X2,S)) ) ) ).

% has_derivative_sin
tff(fact_6785_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,X2: A,S: set(A)] :
          ( has_derivative(A,A,G,aa(A,fun(A,A),times_times(A),Db),topolo174197925503356063within(A,X2,S))
         => has_derivative(A,A,aTP_Lamp_zq(fun(A,A),fun(A,A),G),aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,aa(A,A,G,X2))),Db)),topolo174197925503356063within(A,X2,S)) ) ) ).

% has_derivative_cosh
tff(fact_6786_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,X2: A,S: set(A)] :
          ( has_derivative(A,A,G,aa(A,fun(A,A),times_times(A),Db),topolo174197925503356063within(A,X2,S))
         => has_derivative(A,A,aTP_Lamp_zp(fun(A,A),fun(A,A),G),aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,aa(A,A,G,X2))),Db)),topolo174197925503356063within(A,X2,S)) ) ) ).

% has_derivative_sinh
tff(fact_6787_has__derivative__divide_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S3: set(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S3))
         => ( has_derivative(A,B,G,G2,topolo174197925503356063within(A,X2,S3))
           => ( ( aa(A,B,G,X2) != zero_zero(B) )
             => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acg(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_ach(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F3),F8),X2),G),G2),topolo174197925503356063within(A,X2,S3)) ) ) ) ) ).

% has_derivative_divide'
tff(fact_6788_has__derivative__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(B,A),X2: B,F8: fun(B,A),S3: set(B)] :
          ( ( aa(B,A,F3,X2) != zero_zero(A) )
         => ( has_derivative(B,A,F3,F8,topolo174197925503356063within(B,X2,S3))
           => has_derivative(B,A,aTP_Lamp_aci(fun(B,A),fun(B,A),F3),aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_acj(fun(B,A),fun(B,fun(fun(B,A),fun(B,A))),F3),X2),F8),topolo174197925503356063within(B,X2,S3)) ) ) ) ).

% has_derivative_inverse
tff(fact_6789_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X2: A,S3: set(A)] :
          ( ( X2 != zero_zero(A) )
         => has_derivative(A,A,inverse_inverse(A),aTP_Lamp_ack(A,fun(A,A),X2),topolo174197925503356063within(A,X2,S3)) ) ) ).

% has_derivative_inverse'
tff(fact_6790_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(real,real),F8: real,G: fun(A,real),X2: A,G2: fun(A,real),S: set(A)] :
          ( has_field_derivative(real,F3,F8,topolo174197925503356063within(real,aa(A,real,G,X2),top_top(set(real))))
         => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
           => has_derivative(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_acl(fun(real,real),fun(fun(A,real),fun(A,real)),F3),G),aa(fun(A,real),fun(A,real),aTP_Lamp_acm(real,fun(fun(A,real),fun(A,real)),F8),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% DERIV_compose_FDERIV
tff(fact_6791_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G2: fun(A,real),X2: A,S: set(A)] :
          ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
         => has_derivative(A,real,aTP_Lamp_acn(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_aco(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G2),X2),topolo174197925503356063within(A,X2,S)) ) ) ).

% has_derivative_cos
tff(fact_6792_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S3: set(A),Nb: nat] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S3))
         => has_derivative(A,B,aa(nat,fun(A,B),aTP_Lamp_acp(fun(A,B),fun(nat,fun(A,B)),F3),Nb),aa(nat,fun(A,B),aa(A,fun(nat,fun(A,B)),aa(fun(A,B),fun(A,fun(nat,fun(A,B))),aTP_Lamp_acq(fun(A,B),fun(fun(A,B),fun(A,fun(nat,fun(A,B)))),F3),F8),X2),Nb),topolo174197925503356063within(A,X2,S3)) ) ) ).

% has_derivative_power
tff(fact_6793_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X2: A,G2: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X2))
         => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
           => has_derivative(A,real,aTP_Lamp_acr(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_acs(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X2),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_ln
tff(fact_6794_has__derivative__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S3: set(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S3))
         => ( has_derivative(A,B,G,G2,topolo174197925503356063within(A,X2,S3))
           => ( ( aa(A,B,G,X2) != zero_zero(B) )
             => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_act(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_acu(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F3),F8),X2),G),G2),topolo174197925503356063within(A,X2,S3)) ) ) ) ) ).

% has_derivative_divide
tff(fact_6795_has__derivative__prod,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(C) )
     => ! [I5: set(A),F3: fun(A,fun(B,C)),F8: fun(A,fun(B,C)),X2: B,S3: set(B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => has_derivative(B,C,aa(A,fun(B,C),F3,I2),aa(A,fun(B,C),F8,I2),topolo174197925503356063within(B,X2,S3)) )
         => has_derivative(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_acw(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3),aa(B,fun(B,C),aa(fun(A,fun(B,C)),fun(B,fun(B,C)),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C))),aTP_Lamp_acy(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C)))),I5),F3),F8),X2),topolo174197925503356063within(B,X2,S3)) ) ) ).

% has_derivative_prod
tff(fact_6796_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G2: fun(A,real),X2: A,X7: set(A),F3: fun(A,real),F8: fun(A,real)] :
          ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,X7))
         => ( has_derivative(A,real,F3,F8,topolo174197925503356063within(A,X2,X7))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X2))
             => ( aa(set(A),$o,member(A,X2),X7)
               => has_derivative(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_acz(fun(A,real),fun(fun(A,real),fun(A,real)),G),F3),aa(fun(A,real),fun(A,real),aa(fun(A,real),fun(fun(A,real),fun(A,real)),aa(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))),aa(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real)))),aTP_Lamp_ada(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))))),G),G2),X2),F3),F8),topolo174197925503356063within(A,X2,X7)) ) ) ) ) ) ).

% has_derivative_powr
tff(fact_6797_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X2: A,G2: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X2))
         => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
           => has_derivative(A,real,aTP_Lamp_adb(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_adc(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X2),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_real_sqrt
tff(fact_6798_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G2: fun(A,real),X2: A,S: set(A)] :
          ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
         => has_derivative(A,real,aTP_Lamp_add(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_ade(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G2),X2),topolo174197925503356063within(A,X2,S)) ) ) ).

% has_derivative_arctan
tff(fact_6799_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X2: A,G2: fun(A,real),S: set(A)] :
          ( ( cos(real,aa(A,real,G,X2)) != zero_zero(real) )
         => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X2,S))
           => has_derivative(A,real,aTP_Lamp_adf(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_adg(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X2),G2),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_tan
tff(fact_6800_has__derivative__floor,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [G: fun(B,real),X2: B,F3: fun(real,A),G2: fun(B,real),S: set(B)] :
          ( topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,aa(B,real,G,X2),top_top(set(real))),F3)
         => ( ~ aa(set(A),$o,member(A,aa(real,A,F3,aa(B,real,G,X2))),ring_1_Ints(A))
           => ( has_derivative(B,real,G,G2,topolo174197925503356063within(B,X2,S))
             => has_derivative(B,real,aa(fun(real,A),fun(B,real),aTP_Lamp_adh(fun(B,real),fun(fun(real,A),fun(B,real)),G),F3),aTP_Lamp_adi(fun(B,real),fun(B,real),G2),topolo174197925503356063within(B,X2,S)) ) ) ) ) ).

% has_derivative_floor
tff(fact_6801_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_aao(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,K5))
           => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_adk(fun(nat,A),fun(A,fun(A,A)),C2),X2),topolo7230453075368039082e_nhds(A,zero_zero(A)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% termdiffs_aux
tff(fact_6802_tendsto__const,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [K: B,F4: filter(A)] : filterlim(A,B,aTP_Lamp_adl(B,fun(A,B),K),topolo7230453075368039082e_nhds(B,K),F4) ) ).

% tendsto_const
tff(fact_6803_tendsto__ident__at,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [A2: A,S: set(A)] : filterlim(A,A,aTP_Lamp_adm(A,A),topolo7230453075368039082e_nhds(A,A2),topolo174197925503356063within(A,A2,S)) ) ).

% tendsto_ident_at
tff(fact_6804_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F3: fun(B,A),L: A,F4: filter(B)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_adn(A,fun(fun(B,A),fun(B,A)),C2),F3),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),L)),F4)
          <=> filterlim(B,A,F3,topolo7230453075368039082e_nhds(A,L),F4) ) ) ) ).

% tendsto_mult_left_iff
tff(fact_6805_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F3: fun(B,A),L: A,F4: filter(B)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ado(A,fun(fun(B,A),fun(B,A)),C2),F3),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),L),C2)),F4)
          <=> filterlim(B,A,F3,topolo7230453075368039082e_nhds(A,L),F4) ) ) ) ).

% tendsto_mult_right_iff
tff(fact_6806_power__tendsto__0__iff,axiom,
    ! [A: $tType,Nb: nat,F3: fun(A,real),F4: filter(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_adp(nat,fun(fun(A,real),fun(A,real)),Nb),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
      <=> filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ) ).

% power_tendsto_0_iff
tff(fact_6807_isCont__Pair,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,C)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,C,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,product_prod(B,C),topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_adq(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),F3),G)) ) ) ) ).

% isCont_Pair
tff(fact_6808_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A2: A,F3: fun(A,B),G: fun(B,C),L: C] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(B,aa(A,B,F3,A2),top_top(set(B))))
           => ( ? [D6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),A2))),D6) )
                     => ( aa(A,B,F3,X4) != aa(A,B,F3,A2) ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_adr(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% isCont_LIM_compose2
tff(fact_6809_continuous__within__compose2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topological_t2_space(B)
        & topolo4958980785337419405_space(C)
        & topological_t2_space(A) )
     => ! [X2: A,S: set(A),F3: fun(A,B),G: fun(B,C)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X2,S),F3)
         => ( topolo3448309680560233919inuous(B,C,topolo174197925503356063within(B,aa(A,B,F3,X2),aa(set(A),set(B),image(A,B,F3),S)),G)
           => topolo3448309680560233919inuous(A,C,topolo174197925503356063within(A,X2,S),aa(fun(B,C),fun(A,C),aTP_Lamp_ads(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G)) ) ) ) ).

% continuous_within_compose2
tff(fact_6810_LIM__offset__zero__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C)
        & zero(A) )
     => ! [A2: B,F3: fun(B,C),L4: C] :
          ( nO_MATCH(A,B,zero_zero(A),A2)
         => ( filterlim(B,C,F3,topolo7230453075368039082e_nhds(C,L4),topolo174197925503356063within(B,A2,top_top(set(B))))
          <=> filterlim(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_adt(B,fun(fun(B,C),fun(B,C)),A2),F3),topolo7230453075368039082e_nhds(C,L4),topolo174197925503356063within(B,zero_zero(B),top_top(set(B)))) ) ) ) ).

% LIM_offset_zero_iff
tff(fact_6811_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),L4: B,A2: A,K: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_adu(fun(A,B),fun(A,fun(A,B)),F3),K),topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),K),top_top(set(A)))) ) ) ).

% LIM_offset
tff(fact_6812_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),A2: A,L4: B] :
          ( filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_adv(fun(A,B),fun(A,fun(A,B)),F3),A2),topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% LIM_offset_zero_cancel
tff(fact_6813_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),L4: B,A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_adv(fun(A,B),fun(A,fun(A,B)),F3),A2),topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% LIM_offset_zero
tff(fact_6814_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,F3,A2)),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_adv(fun(A,B),fun(A,fun(A,B)),F3),A2),topolo7230453075368039082e_nhds(B,aa(A,B,F3,A2)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% LIM_isCont_iff
tff(fact_6815_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [X2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X2,top_top(set(A))),F3)
        <=> filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_adw(A,fun(fun(A,B),fun(A,B)),X2),F3),topolo7230453075368039082e_nhds(B,aa(A,B,F3,X2)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% isCont_iff
tff(fact_6816_LIM__not__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo8386298272705272623_space(B)
        & zero(A)
        & topological_t2_space(A) )
     => ! [K: A,A2: B] :
          ( ( K != zero_zero(A) )
         => ~ filterlim(B,A,aTP_Lamp_adx(A,fun(B,A),K),topolo7230453075368039082e_nhds(A,zero_zero(A)),topolo174197925503356063within(B,A2,top_top(set(B)))) ) ) ).

% LIM_not_zero
tff(fact_6817_isCont__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_ady(fun(A,B),fun(A,real),F3)) ) ) ).

% isCont_norm
tff(fact_6818_isCont__of__real,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),G)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_adz(fun(A,real),fun(A,B),G)) ) ) ).

% isCont_of_real
tff(fact_6819_continuous__within__compose3,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B)
        & topological_t2_space(C) )
     => ! [F3: fun(C,A),X2: C,G: fun(A,B),S: set(C)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,aa(C,A,F3,X2),top_top(set(A))),G)
         => ( topolo3448309680560233919inuous(C,A,topolo174197925503356063within(C,X2,S),F3)
           => topolo3448309680560233919inuous(C,B,topolo174197925503356063within(C,X2,S),aa(fun(A,B),fun(C,B),aTP_Lamp_aea(fun(C,A),fun(fun(A,B),fun(C,B)),F3),G)) ) ) ) ).

% continuous_within_compose3
tff(fact_6820_isCont__tendsto__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topological_t2_space(A) )
     => ! [L: A,G: fun(A,B),F3: fun(C,A),F4: filter(C)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,L,top_top(set(A))),G)
         => ( filterlim(C,A,F3,topolo7230453075368039082e_nhds(A,L),F4)
           => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aeb(fun(A,B),fun(fun(C,A),fun(C,B)),G),F3),topolo7230453075368039082e_nhds(B,aa(A,B,G,L)),F4) ) ) ) ).

% isCont_tendsto_compose
tff(fact_6821_LIM__const__not__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo8386298272705272623_space(B)
        & topological_t2_space(A) )
     => ! [K: A,L4: A,A2: B] :
          ( ( K != L4 )
         => ~ filterlim(B,A,aTP_Lamp_aec(A,fun(B,A),K),topolo7230453075368039082e_nhds(A,L4),topolo174197925503356063within(B,A2,top_top(set(B)))) ) ) ).

% LIM_const_not_eq
tff(fact_6822_tendsto__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(A) )
     => ! [G: fun(A,B),L: A,F3: fun(C,A),F4: filter(C)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,aa(A,B,G,L)),topolo174197925503356063within(A,L,top_top(set(A))))
         => ( filterlim(C,A,F3,topolo7230453075368039082e_nhds(A,L),F4)
           => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aed(fun(A,B),fun(fun(C,A),fun(C,B)),G),F3),topolo7230453075368039082e_nhds(B,aa(A,B,G,L)),F4) ) ) ) ).

% tendsto_compose
tff(fact_6823_LIM__const__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topological_t2_space(B)
        & topolo8386298272705272623_space(A) )
     => ! [K: B,L4: B,A2: A] :
          ( filterlim(A,B,aTP_Lamp_aee(B,fun(A,B),K),topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( K = L4 ) ) ) ).

% LIM_const_eq
tff(fact_6824_isCont__o2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topological_t2_space(B)
        & topolo4958980785337419405_space(C)
        & topological_t2_space(A) )
     => ! [A2: A,F3: fun(A,B),G: fun(B,C)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(B,C,topolo174197925503356063within(B,aa(A,B,F3,A2),top_top(set(B))),G)
           => topolo3448309680560233919inuous(A,C,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(B,C),fun(A,C),aTP_Lamp_ads(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G)) ) ) ) ).

% isCont_o2
tff(fact_6825_filterlim__at__If,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(A,B),G3: filter(B),X2: A,P: fun(A,$o),G: fun(A,B)] :
          ( filterlim(A,B,F3,G3,topolo174197925503356063within(A,X2,aa(fun(A,$o),set(A),collect(A),P)))
         => ( filterlim(A,B,G,G3,topolo174197925503356063within(A,X2,aa(fun(A,$o),set(A),collect(A),aTP_Lamp_aef(fun(A,$o),fun(A,$o),P))))
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,$o),fun(fun(A,B),fun(A,B)),aTP_Lamp_aeg(fun(A,B),fun(fun(A,$o),fun(fun(A,B),fun(A,B))),F3),P),G),G3,topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ) ).

% filterlim_at_If
tff(fact_6826_isCont__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,real),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_aeh(fun(A,real),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% isCont_scaleR
tff(fact_6827_isCont__fst,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A2: A,F3: fun(A,product_prod(B,C))] :
          ( topolo3448309680560233919inuous(A,product_prod(B,C),topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_aei(fun(A,product_prod(B,C)),fun(A,B),F3)) ) ) ).

% isCont_fst
tff(fact_6828_isCont__snd,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A2: A,F3: fun(A,product_prod(B,C))] :
          ( topolo3448309680560233919inuous(A,product_prod(B,C),topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,C,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_aej(fun(A,product_prod(B,C)),fun(A,C),F3)) ) ) ).

% isCont_snd
tff(fact_6829_continuous__ident,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X2: A,S3: set(A)] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,S3),aTP_Lamp_aek(A,A)) ) ).

% continuous_ident
tff(fact_6830_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S3: set(A)] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S3))
         => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_ael(fun(A,A),fun(A,fun(A,A)),F3),X2),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,X2,S3)) ) ) ).

% has_field_derivativeD
tff(fact_6831_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A,S3: set(A)] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,S3))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_ael(fun(A,A),fun(A,fun(A,A)),F3),X2),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,X2,S3)) ) ) ).

% has_field_derivative_iff
tff(fact_6832_filterlim__at__within__If,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(A,B),G3: filter(B),X2: A,A3: set(A),P: fun(A,$o),G: fun(A,B)] :
          ( filterlim(A,B,F3,G3,topolo174197925503356063within(A,X2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),P))))
         => ( filterlim(A,B,G,G3,topolo174197925503356063within(A,X2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_aef(fun(A,$o),fun(A,$o),P)))))
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,$o),fun(fun(A,B),fun(A,B)),aTP_Lamp_aeg(fun(A,B),fun(fun(A,$o),fun(fun(A,B),fun(A,B))),F3),P),G),G3,topolo174197925503356063within(A,X2,A3)) ) ) ) ).

% filterlim_at_within_If
tff(fact_6833_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(A,real),A2: A,G: fun(A,real)] :
          ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( ! [X4: A] :
                ( ( X4 != A2 )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,G,X4)) )
           => ( ! [X4: A] :
                  ( ( X4 != A2 )
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,G,X4)),aa(A,real,F3,X4)) )
             => filterlim(A,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% real_LIM_sandwich_zero
tff(fact_6834_has__derivative__Im,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,complex),G2: fun(A,complex),F4: filter(A)] :
          ( has_derivative(A,complex,G,G2,F4)
         => has_derivative(A,real,aTP_Lamp_aem(fun(A,complex),fun(A,real),G),aTP_Lamp_aem(fun(A,complex),fun(A,real),G2),F4) ) ) ).

% has_derivative_Im
tff(fact_6835_has__derivative__Re,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,complex),G2: fun(A,complex),F4: filter(A)] :
          ( has_derivative(A,complex,G,G2,F4)
         => has_derivative(A,real,aTP_Lamp_aen(fun(A,complex),fun(A,real),G),aTP_Lamp_aen(fun(A,complex),fun(A,real),G2),F4) ) ) ).

% has_derivative_Re
tff(fact_6836_has__derivative__cnj,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,complex),G2: fun(A,complex),F4: filter(A)] :
          ( has_derivative(A,complex,G,G2,F4)
         => has_derivative(A,complex,aTP_Lamp_aeo(fun(A,complex),fun(A,complex),G),aTP_Lamp_aeo(fun(A,complex),fun(A,complex),G2),F4) ) ) ).

% has_derivative_cnj
tff(fact_6837_continuous__Pair,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,C)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,C,F4,G)
           => topolo3448309680560233919inuous(A,product_prod(B,C),F4,aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_adq(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),F3),G)) ) ) ) ).

% continuous_Pair
tff(fact_6838_tendsto__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A),G: fun(A,C),B2: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( filterlim(A,C,G,topolo7230453075368039082e_nhds(C,B2),F4)
           => filterlim(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_aep(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),F3),G),topolo7230453075368039082e_nhds(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A2),B2)),F4) ) ) ) ).

% tendsto_Pair
tff(fact_6839_tendsto__log,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F4)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
         => ( ( A2 != one_one(real) )
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
             => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_aeq(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,aa(real,real,log(A2),B2)),F4) ) ) ) ) ) ).

% tendsto_log
tff(fact_6840_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [F3: fun(A,B),F4: filter(A),Nb: nat] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
           => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_aer(fun(A,B),fun(nat,fun(A,B)),F3),Nb),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ) ).

% tendsto_null_power
tff(fact_6841_tendsto__arcosh,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
       => filterlim(A,real,aTP_Lamp_aes(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,arcosh(real),A2)),F4) ) ) ).

% tendsto_arcosh
tff(fact_6842_tendsto__artanh,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),one_one(real))
         => filterlim(A,real,aTP_Lamp_aet(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,artanh(real),A2)),F4) ) ) ) ).

% tendsto_artanh
tff(fact_6843_filterlim__INF,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: fun(A,B),G3: fun(C,filter(B)),B4: set(C),F4: filter(A)] :
      ( filterlim(A,B,F3,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(C),set(filter(B)),image(C,filter(B),G3),B4)),F4)
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),B4)
         => filterlim(A,B,F3,aa(C,filter(B),G3,X3),F4) ) ) ).

% filterlim_INF
tff(fact_6844_filterlim__INF_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,X2: A,A3: set(A),F3: fun(B,C),F4: filter(C),G3: fun(A,filter(B))] :
      ( aa(set(A),$o,member(A,X2),A3)
     => ( filterlim(B,C,F3,F4,aa(A,filter(B),G3,X2))
       => filterlim(B,C,F3,F4,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),G3),A3))) ) ) ).

% filterlim_INF'
tff(fact_6845_filterlim__ident,axiom,
    ! [A: $tType,F4: filter(A)] : filterlim(A,A,aTP_Lamp_ae(A,A),F4,F4) ).

% filterlim_ident
tff(fact_6846_filterlim__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: fun(A,B),F33: filter(B),F22: filter(A),F3: fun(C,A),F12: filter(C)] :
      ( filterlim(A,B,G,F33,F22)
     => ( filterlim(C,A,F3,F22,F12)
       => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aeu(fun(A,B),fun(fun(C,A),fun(C,B)),G),F3),F33,F12) ) ) ).

% filterlim_compose
tff(fact_6847_tendsto__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( topological_t2_space(B)
     => ! [F4: filter(A),A2: B,B2: B] :
          ( ( F4 != bot_bot(filter(A)) )
         => ( filterlim(A,B,aTP_Lamp_aev(B,fun(A,B),A2),topolo7230453075368039082e_nhds(B,B2),F4)
          <=> ( A2 = B2 ) ) ) ) ).

% tendsto_const_iff
tff(fact_6848_continuous__max,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,B),fun(A,B),aTP_Lamp_aew(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_max
tff(fact_6849_tendsto__max,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [X7: fun(A,B),X2: B,Net: filter(A),Y5: fun(A,B),Y2: B] :
          ( filterlim(A,B,X7,topolo7230453075368039082e_nhds(B,X2),Net)
         => ( filterlim(A,B,Y5,topolo7230453075368039082e_nhds(B,Y2),Net)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aex(fun(A,B),fun(fun(A,B),fun(A,B)),X7),Y5),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y2)),Net) ) ) ) ).

% tendsto_max
tff(fact_6850_tendsto__of__int__ceiling,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ring_1(C)
        & topolo4958980785337419405_space(C)
        & archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( ~ aa(set(B),$o,member(B,L),ring_1_Ints(B))
           => filterlim(A,C,aTP_Lamp_aey(fun(A,B),fun(A,C),F3),topolo7230453075368039082e_nhds(C,ring_1_of_int(C,archimedean_ceiling(B,L))),F4) ) ) ) ).

% tendsto_of_int_ceiling
tff(fact_6851_tendsto__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( ( cosh(B,A2) != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_aez(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,tanh(B),A2)),F4) ) ) ) ).

% tendsto_tanh
tff(fact_6852_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,aTP_Lamp_afa(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
     => filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ).

% tendsto_rabs_zero_cancel
tff(fact_6853_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,aTP_Lamp_afa(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
    <=> filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ).

% tendsto_rabs_zero_iff
tff(fact_6854_tendsto__rabs__zero,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
     => filterlim(A,real,aTP_Lamp_afa(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ).

% tendsto_rabs_zero
tff(fact_6855_tendsto__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F4)
           => ( ( B2 != zero_zero(B) )
             => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afb(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),A2),B2)),F4) ) ) ) ) ).

% tendsto_divide
tff(fact_6856_tendsto__divide__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F3: fun(A,B),F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_afc(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ).

% tendsto_divide_zero
tff(fact_6857_tendsto__rabs,axiom,
    ! [A: $tType,F3: fun(A,real),L: real,F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,L),F4)
     => filterlim(A,real,aTP_Lamp_afa(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,abs_abs(real),L)),F4) ) ).

% tendsto_rabs
tff(fact_6858_tendsto__of__int__floor,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ring_1(C)
        & topolo4958980785337419405_space(C)
        & archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( ~ aa(set(B),$o,member(B,L),ring_1_Ints(B))
           => filterlim(A,C,aTP_Lamp_afd(fun(A,B),fun(A,C),F3),topolo7230453075368039082e_nhds(C,ring_1_of_int(C,archim6421214686448440834_floor(B,L))),F4) ) ) ) ).

% tendsto_of_int_floor
tff(fact_6859_tendsto__mult__one,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [F3: fun(A,B),F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,one_one(B)),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,one_one(B)),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afe(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,one_one(B)),F4) ) ) ) ).

% tendsto_mult_one
tff(fact_6860_tendsto__mult__right,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_aff(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),times_times(B),L),C2)),F4) ) ) ).

% tendsto_mult_right
tff(fact_6861_tendsto__mult__left,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_afg(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),L)),F4) ) ) ).

% tendsto_mult_left
tff(fact_6862_tendsto__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afh(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),times_times(B),A2),B2)),F4) ) ) ) ).

% tendsto_mult
tff(fact_6863_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [F4: filter(A),F3: fun(A,B),C2: B] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aa(B,fun(A,B),aTP_Lamp_afi(fun(A,B),fun(B,fun(A,B)),F3),C2)) ) ) ).

% continuous_mult_right
tff(fact_6864_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [F4: filter(A),F3: fun(A,B),C2: B] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aa(B,fun(A,B),aTP_Lamp_afj(fun(A,B),fun(B,fun(A,B)),F3),C2)) ) ) ).

% continuous_mult_left
tff(fact_6865_continuous__mult_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4211221413907600880p_mult(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,B),fun(A,B),aTP_Lamp_afk(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_mult'
tff(fact_6866_continuous__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,B),fun(A,B),aTP_Lamp_afl(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_mult
tff(fact_6867_tendsto__cnj,axiom,
    ! [A: $tType,G: fun(A,complex),A2: complex,F4: filter(A)] :
      ( filterlim(A,complex,G,topolo7230453075368039082e_nhds(complex,A2),F4)
     => filterlim(A,complex,aTP_Lamp_mi(fun(A,complex),fun(A,complex),G),topolo7230453075368039082e_nhds(complex,cnj(A2)),F4) ) ).

% tendsto_cnj
tff(fact_6868_tendsto__Re,axiom,
    ! [A: $tType,G: fun(A,complex),A2: complex,F4: filter(A)] :
      ( filterlim(A,complex,G,topolo7230453075368039082e_nhds(complex,A2),F4)
     => filterlim(A,real,aTP_Lamp_mj(fun(A,complex),fun(A,real),G),topolo7230453075368039082e_nhds(real,re(A2)),F4) ) ).

% tendsto_Re
tff(fact_6869_lim__cnj,axiom,
    ! [A: $tType,F3: fun(A,complex),L: complex,F4: filter(A)] :
      ( filterlim(A,complex,aTP_Lamp_mi(fun(A,complex),fun(A,complex),F3),topolo7230453075368039082e_nhds(complex,cnj(L)),F4)
    <=> filterlim(A,complex,F3,topolo7230453075368039082e_nhds(complex,L),F4) ) ).

% lim_cnj
tff(fact_6870_tendsto__add__const__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [C2: B,F3: fun(A,B),D2: B,F4: filter(A)] :
          ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afm(B,fun(fun(A,B),fun(A,B)),C2),F3),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),D2)),F4)
        <=> filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,D2),F4) ) ) ).

% tendsto_add_const_iff
tff(fact_6871_tendsto__add,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afn(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2)),F4) ) ) ) ).

% tendsto_add
tff(fact_6872_continuous__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,B),fun(A,B),aTP_Lamp_afo(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_add
tff(fact_6873_continuous__sinh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_afp(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_sinh
tff(fact_6874_tendsto__cosh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => filterlim(A,B,aTP_Lamp_afq(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,cosh(B,A2)),F4) ) ) ).

% tendsto_cosh
tff(fact_6875_tendsto__sinh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => filterlim(A,B,aTP_Lamp_afr(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,sinh(B,A2)),F4) ) ) ).

% tendsto_sinh
tff(fact_6876_tendsto__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,real),A2: real,F4: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afs(fun(A,real),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(B,B,real_V8093663219630862766scaleR(B,A2),B2)),F4) ) ) ) ).

% tendsto_scaleR
tff(fact_6877_continuous__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [F4: filter(A),F3: fun(A,real),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,B),fun(A,B),aTP_Lamp_aeh(fun(A,real),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_scaleR
tff(fact_6878_continuous__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_aft(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_cos
tff(fact_6879_continuous__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_afu(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_sin
tff(fact_6880_continuous__exp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_afv(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_exp
tff(fact_6881_continuous__power,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [F4: filter(A),F3: fun(A,B),Nb: nat] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aa(nat,fun(A,B),aTP_Lamp_afw(fun(A,B),fun(nat,fun(A,B)),F3),Nb)) ) ) ).

% continuous_power
tff(fact_6882_continuous__power_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1898628316856586783d_mult(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,nat)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,nat,F4,G)
           => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,nat),fun(A,B),aTP_Lamp_afx(fun(A,B),fun(fun(A,nat),fun(A,B)),F3),G)) ) ) ) ).

% continuous_power'
tff(fact_6883_tendsto__power__strong,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A),G: fun(A,nat),B2: nat] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( filterlim(A,nat,G,topolo7230453075368039082e_nhds(nat,B2),F4)
           => filterlim(A,B,aa(fun(A,nat),fun(A,B),aTP_Lamp_afy(fun(A,B),fun(fun(A,nat),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(nat,B,power_power(B,A2),B2)),F4) ) ) ) ).

% tendsto_power_strong
tff(fact_6884_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A),Nb: nat] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_afz(fun(A,B),fun(nat,fun(A,B)),F3),Nb),topolo7230453075368039082e_nhds(B,aa(nat,B,power_power(B,A2),Nb)),F4) ) ) ).

% tendsto_power
tff(fact_6885_tendsto__exp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => filterlim(A,B,aTP_Lamp_aga(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,exp(B),A2)),F4) ) ) ).

% tendsto_exp
tff(fact_6886_tendsto__arsinh,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => filterlim(A,real,aTP_Lamp_agb(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,arsinh(real),A2)),F4) ) ).

% tendsto_arsinh
tff(fact_6887_tendsto__arctan,axiom,
    ! [A: $tType,F3: fun(A,real),X2: real,F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,X2),F4)
     => filterlim(A,real,aTP_Lamp_agc(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,arctan,X2)),F4) ) ).

% tendsto_arctan
tff(fact_6888_tendsto__real__sqrt,axiom,
    ! [A: $tType,F3: fun(A,real),X2: real,F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,X2),F4)
     => filterlim(A,real,aTP_Lamp_agd(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,sqrt,X2)),F4) ) ).

% tendsto_real_sqrt
tff(fact_6889_tendsto__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => filterlim(A,B,aTP_Lamp_afu(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,sin(B,A2)),F4) ) ) ).

% tendsto_sin
tff(fact_6890_tendsto__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => filterlim(A,B,aTP_Lamp_aft(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,cos(B,A2)),F4) ) ) ).

% tendsto_cos
tff(fact_6891_continuous__const,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topological_t2_space(A) )
     => ! [F4: filter(A),C2: B] : topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_age(B,fun(A,B),C2)) ) ).

% continuous_const
tff(fact_6892_tendsto__of__real,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [G: fun(A,real),A2: real,F4: filter(A)] :
          ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,A2),F4)
         => filterlim(A,B,aTP_Lamp_agf(fun(A,real),fun(A,B),G),topolo7230453075368039082e_nhds(B,aa(real,B,real_Vector_of_real(B),A2)),F4) ) ) ).

% tendsto_of_real
tff(fact_6893_continuous__of__real,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [F4: filter(A),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,G)
         => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_adz(fun(A,real),fun(A,B),G)) ) ) ).

% continuous_of_real
tff(fact_6894_tendsto__of__real__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,real),C2: real,F4: filter(A)] :
          ( filterlim(A,B,aTP_Lamp_agg(fun(A,real),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(real,B,real_Vector_of_real(B),C2)),F4)
        <=> filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F4) ) ) ).

% tendsto_of_real_iff
tff(fact_6895_tendsto__Complex,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F4)
       => filterlim(A,complex,aa(fun(A,real),fun(A,complex),aTP_Lamp_agh(fun(A,real),fun(fun(A,real),fun(A,complex)),F3),G),topolo7230453075368039082e_nhds(complex,complex2(A2,B2)),F4) ) ) ).

% tendsto_Complex
tff(fact_6896_tendsto__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => filterlim(A,real,aTP_Lamp_agi(fun(A,B),fun(A,real),F3),topolo7230453075368039082e_nhds(real,real_V7770717601297561774m_norm(B,A2)),F4) ) ) ).

% tendsto_norm
tff(fact_6897_continuous__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_ady(fun(A,B),fun(A,real),F3)) ) ) ).

% continuous_norm
tff(fact_6898_continuous__cosh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_agj(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_cosh
tff(fact_6899_tendsto__real__root,axiom,
    ! [A: $tType,F3: fun(A,real),X2: real,F4: filter(A),Nb: nat] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,X2),F4)
     => filterlim(A,real,aa(nat,fun(A,real),aTP_Lamp_agk(fun(A,real),fun(nat,fun(A,real)),F3),Nb),topolo7230453075368039082e_nhds(real,aa(real,real,root(Nb),X2)),F4) ) ).

% tendsto_real_root
tff(fact_6900_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: fun(A,A),A2: A,F4: filter(A)] :
          ( filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,A2),F4)
         => ( ( cos(A,A2) != zero_zero(A) )
           => filterlim(A,A,aTP_Lamp_agl(fun(A,A),fun(A,A),F3),topolo7230453075368039082e_nhds(A,aa(A,A,tan(A),A2)),F4) ) ) ) ).

% tendsto_tan
tff(fact_6901_tendsto__Im,axiom,
    ! [A: $tType,G: fun(A,complex),A2: complex,F4: filter(A)] :
      ( filterlim(A,complex,G,topolo7230453075368039082e_nhds(complex,A2),F4)
     => filterlim(A,real,aTP_Lamp_mm(fun(A,complex),fun(A,real),G),topolo7230453075368039082e_nhds(real,im(A2)),F4) ) ).

% tendsto_Im
tff(fact_6902_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_agi(fun(A,B),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ).

% tendsto_norm_zero_cancel
tff(fact_6903_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_agi(fun(A,B),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
        <=> filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ).

% tendsto_norm_zero_iff
tff(fact_6904_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => filterlim(A,real,aTP_Lamp_agi(fun(A,B),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ) ).

% tendsto_norm_zero
tff(fact_6905_tendsto__ln,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( ( A2 != zero_zero(real) )
       => filterlim(A,real,aTP_Lamp_oi(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,ln_ln(real),A2)),F4) ) ) ).

% tendsto_ln
tff(fact_6906_tendsto__powr,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F4)
       => ( ( A2 != zero_zero(real) )
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_agm(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,powr(real,A2,B2)),F4) ) ) ) ).

% tendsto_powr
tff(fact_6907_tendsto__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( ( L != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_agn(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,sgn_sgn(B),L)),F4) ) ) ) ).

% tendsto_sgn
tff(fact_6908_tendsto__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( ( A2 != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_ago(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,inverse_inverse(B),A2)),F4) ) ) ) ).

% tendsto_inverse
tff(fact_6909_tendsto__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(C)
        & comm_ring_1(C) )
     => ! [S3: set(A),F3: fun(A,fun(B,C)),L4: fun(A,C),F4: filter(B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),S3)
             => filterlim(B,C,aa(A,fun(B,C),F3,I2),topolo7230453075368039082e_nhds(C,aa(A,C,L4,I2)),F4) )
         => filterlim(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_agq(set(A),fun(fun(A,fun(B,C)),fun(B,C)),S3),F3),topolo7230453075368039082e_nhds(C,groups7121269368397514597t_prod(A,C,L4,S3)),F4) ) ) ).

% tendsto_prod
tff(fact_6910_tendsto__prod_H,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [I5: set(A),F3: fun(A,fun(B,C)),A2: fun(A,C),F4: filter(B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => filterlim(B,C,aa(A,fun(B,C),F3,I2),topolo7230453075368039082e_nhds(C,aa(A,C,A2,I2)),F4) )
         => filterlim(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_ags(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3),topolo7230453075368039082e_nhds(C,groups7121269368397514597t_prod(A,C,A2,I5)),F4) ) ) ).

% tendsto_prod'
tff(fact_6911_continuous__prod,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(B)
        & real_V4412858255891104859lgebra(C)
        & comm_ring_1(C) )
     => ! [S3: set(A),F4: filter(B),F3: fun(A,fun(B,C))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),S3)
             => topolo3448309680560233919inuous(B,C,F4,aa(A,fun(B,C),F3,I2)) )
         => topolo3448309680560233919inuous(B,C,F4,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_agu(set(A),fun(fun(A,fun(B,C)),fun(B,C)),S3),F3)) ) ) ).

% continuous_prod
tff(fact_6912_continuous__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(B)
        & topolo4987421752381908075d_mult(C) )
     => ! [I5: set(A),F4: filter(B),F3: fun(A,fun(B,C))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => topolo3448309680560233919inuous(B,C,F4,aa(A,fun(B,C),F3,I2)) )
         => topolo3448309680560233919inuous(B,C,F4,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_agw(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3)) ) ) ).

% continuous_prod'
tff(fact_6913_tendsto__one__prod_H,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [I5: set(A),F3: fun(B,fun(A,C)),F4: filter(B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => filterlim(B,C,aa(A,fun(B,C),aTP_Lamp_agx(fun(B,fun(A,C)),fun(A,fun(B,C)),F3),I2),topolo7230453075368039082e_nhds(C,one_one(C)),F4) )
         => filterlim(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_agy(set(A),fun(fun(B,fun(A,C)),fun(B,C)),I5),F3),topolo7230453075368039082e_nhds(C,one_one(C)),F4) ) ) ).

% tendsto_one_prod'
tff(fact_6914_tendsto__add__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [F3: fun(A,B),F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afn(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ) ).

% tendsto_add_zero
tff(fact_6915_tendsto__complex__iff,axiom,
    ! [A: $tType,F3: fun(A,complex),X2: complex,F4: filter(A)] :
      ( filterlim(A,complex,F3,topolo7230453075368039082e_nhds(complex,X2),F4)
    <=> ( filterlim(A,real,aTP_Lamp_mj(fun(A,complex),fun(A,real),F3),topolo7230453075368039082e_nhds(real,re(X2)),F4)
        & filterlim(A,real,aTP_Lamp_mm(fun(A,complex),fun(A,real),F3),topolo7230453075368039082e_nhds(real,im(X2)),F4) ) ) ).

% tendsto_complex_iff
tff(fact_6916_tendsto__mult__right__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F3: fun(A,B),F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_agz(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ).

% tendsto_mult_right_zero
tff(fact_6917_tendsto__mult__left__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F3: fun(A,B),F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_aha(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ).

% tendsto_mult_left_zero
tff(fact_6918_tendsto__mult__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F3: fun(A,B),F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahb(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ) ).

% tendsto_mult_zero
tff(fact_6919_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: fun(A,A),A2: A,F4: filter(A)] :
          ( filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,A2),F4)
         => ( ( sin(A,A2) != zero_zero(A) )
           => filterlim(A,A,aTP_Lamp_ahc(fun(A,A),fun(A,A),F3),topolo7230453075368039082e_nhds(A,aa(A,A,cot(A),A2)),F4) ) ) ) ).

% tendsto_cot
tff(fact_6920_continuous__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_ahd(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_minus
tff(fact_6921_tendsto__minus__cancel__left,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [F3: fun(A,B),Y2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(B,B,uminus_uminus(B),Y2)),F4)
        <=> filterlim(A,B,aTP_Lamp_ahe(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,Y2),F4) ) ) ).

% tendsto_minus_cancel_left
tff(fact_6922_tendsto__minus__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,aTP_Lamp_ahe(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,uminus_uminus(B),A2)),F4)
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4) ) ) ).

% tendsto_minus_cancel
tff(fact_6923_tendsto__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => filterlim(A,B,aTP_Lamp_ahe(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,uminus_uminus(B),A2)),F4) ) ) ).

% tendsto_minus
tff(fact_6924_continuous__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,B),fun(A,B),aTP_Lamp_ahf(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_diff
tff(fact_6925_tendsto__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahg(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A2),B2)),F4) ) ) ) ).

% tendsto_diff
tff(fact_6926_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_ahh(fun(A,B),fun(B,fun(A,B)),F3),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ).

% LIM_zero
tff(fact_6927_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_ahh(fun(A,B),fun(B,fun(A,B)),F3),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
        <=> filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4) ) ) ).

% LIM_zero_iff
tff(fact_6928_Lim__transform,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [G: fun(A,B),A2: B,F4: filter(A),F3: fun(A,B)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahi(fun(A,B),fun(fun(A,B),fun(A,B)),G),F3),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4) ) ) ) ).

% Lim_transform
tff(fact_6929_Lim__transform2,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahj(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
           => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F4) ) ) ) ).

% Lim_transform2
tff(fact_6930_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_ahh(fun(A,B),fun(B,fun(A,B)),F3),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4) ) ) ).

% LIM_zero_cancel
tff(fact_6931_Lim__transform__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),G: fun(A,B),F4: filter(A),A2: B] :
          ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahj(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
          <=> filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F4) ) ) ) ).

% Lim_transform_eq
tff(fact_6932_tendsto__null__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [I5: set(A),F3: fun(B,fun(A,C)),F4: filter(B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => filterlim(B,C,aa(A,fun(B,C),aTP_Lamp_ahk(fun(B,fun(A,C)),fun(A,fun(B,C)),F3),I2),topolo7230453075368039082e_nhds(C,zero_zero(C)),F4) )
         => filterlim(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_ahl(set(A),fun(fun(B,fun(A,C)),fun(B,C)),I5),F3),topolo7230453075368039082e_nhds(C,zero_zero(C)),F4) ) ) ).

% tendsto_null_sum
tff(fact_6933_continuous__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(B)
        & topolo5987344860129210374id_add(C) )
     => ! [I5: set(A),F4: filter(B),F3: fun(A,fun(B,C))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => topolo3448309680560233919inuous(B,C,F4,aa(A,fun(B,C),F3,I2)) )
         => topolo3448309680560233919inuous(B,C,F4,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_ahn(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3)) ) ) ).

% continuous_sum
tff(fact_6934_tendsto__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [I5: set(A),F3: fun(A,fun(B,C)),A2: fun(A,C),F4: filter(B)] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => filterlim(B,C,aa(A,fun(B,C),F3,I2),topolo7230453075368039082e_nhds(C,aa(A,C,A2,I2)),F4) )
         => filterlim(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_ahp(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3),topolo7230453075368039082e_nhds(C,aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),A2),I5)),F4) ) ) ).

% tendsto_sum
tff(fact_6935_filterlim__inf,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),F22: filter(B),F33: filter(B),F12: filter(A)] :
      ( filterlim(A,B,F3,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F22),F33),F12)
    <=> ( filterlim(A,B,F3,F22,F12)
        & filterlim(A,B,F3,F33,F12) ) ) ).

% filterlim_inf
tff(fact_6936_continuous__fst,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F4: filter(A),F3: fun(A,product_prod(B,C))] :
          ( topolo3448309680560233919inuous(A,product_prod(B,C),F4,F3)
         => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_aei(fun(A,product_prod(B,C)),fun(A,B),F3)) ) ) ).

% continuous_fst
tff(fact_6937_tendsto__fst,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,product_prod(B,C)),A2: product_prod(B,C),F4: filter(A)] :
          ( filterlim(A,product_prod(B,C),F3,topolo7230453075368039082e_nhds(product_prod(B,C),A2),F4)
         => filterlim(A,B,aTP_Lamp_ahq(fun(A,product_prod(B,C)),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(product_prod(B,C),B,product_fst(B,C),A2)),F4) ) ) ).

% tendsto_fst
tff(fact_6938_continuous__snd,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F4: filter(A),F3: fun(A,product_prod(B,C))] :
          ( topolo3448309680560233919inuous(A,product_prod(B,C),F4,F3)
         => topolo3448309680560233919inuous(A,C,F4,aTP_Lamp_aej(fun(A,product_prod(B,C)),fun(A,C),F3)) ) ) ).

% continuous_snd
tff(fact_6939_tendsto__snd,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,product_prod(B,C)),A2: product_prod(B,C),F4: filter(A)] :
          ( filterlim(A,product_prod(B,C),F3,topolo7230453075368039082e_nhds(product_prod(B,C),A2),F4)
         => filterlim(A,C,aTP_Lamp_ahr(fun(A,product_prod(B,C)),fun(A,C),F3),topolo7230453075368039082e_nhds(C,aa(product_prod(B,C),C,product_snd(B,C),A2)),F4) ) ) ).

% tendsto_snd
tff(fact_6940_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [R3: real,A2: A,F3: fun(A,B),G: fun(A,B),L: B] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R3)
         => ( ! [X4: A] :
                ( ( X4 != A2 )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),A2))),R3)
                 => ( aa(A,B,F3,X4) = aa(A,B,G,X4) ) ) )
           => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
             => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% LIM_equal2
tff(fact_6941_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),L4: B,A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S5)
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A2))),S5) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,X3)),L4))),R5) ) ) ) ) ) ).

% LIM_eq
tff(fact_6942_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,B),L4: B] :
          ( ! [R2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
             => ? [S6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S6)
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),A2))),S6) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,X4)),L4))),R2) ) ) )
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% LIM_I
tff(fact_6943_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),L4: B,A2: A,R: real] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => ? [S2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S2)
                & ! [X: A] :
                    ( ( ( X != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2))),S2) )
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,X)),L4))),R) ) ) ) ) ) ).

% LIM_D
tff(fact_6944_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(A,A),A2: A,D4: A] :
          ( filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_ahs(fun(A,A),fun(A,fun(A,A)),F3),A2),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_aht(fun(A,A),fun(A,fun(A,A)),F3),A2),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% DERIV_LIM_iff
tff(fact_6945_LIM__fun__gt__zero,axiom,
    ! [F3: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [R2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
            & ! [X: real] :
                ( ( ( X != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X))),R2) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,F3,X)) ) ) ) ) ).

% LIM_fun_gt_zero
tff(fact_6946_LIM__fun__not__zero,axiom,
    ! [F3: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( ( L != zero_zero(real) )
       => ? [R2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
            & ! [X: real] :
                ( ( ( X != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X))),R2) )
               => ( aa(real,real,F3,X) != zero_zero(real) ) ) ) ) ) ).

% LIM_fun_not_zero
tff(fact_6947_LIM__fun__less__zero,axiom,
    ! [F3: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [R2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
            & ! [X: real] :
                ( ( ( X != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X))),R2) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,X)),zero_zero(real)) ) ) ) ) ).

% LIM_fun_less_zero
tff(fact_6948_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F3: fun(A,B),B2: B,A2: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( ? [D6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),A2))),D6) )
                     => ( aa(A,B,F3,X4) != B2 ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_adr(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% LIM_compose2
tff(fact_6949_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),G)
           => ( ( aa(A,B,G,A2) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aa(fun(A,B),fun(A,B),aTP_Lamp_ahu(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ) ).

% continuous_at_within_divide
tff(fact_6950_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_afl(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% isCont_mult
tff(fact_6951_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_afo(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% isCont_add
tff(fact_6952_isCont__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_ahv(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% isCont_diff
tff(fact_6953_isCont__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_ahw(fun(A,B),fun(A,B),F3)) ) ) ).

% isCont_minus
tff(fact_6954_isCont__power,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [A2: A,F3: fun(A,B),Nb: nat] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(nat,fun(A,B),aTP_Lamp_afw(fun(A,B),fun(nat,fun(A,B)),F3),Nb)) ) ) ).

% isCont_power
tff(fact_6955_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [A2: A,S: set(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aTP_Lamp_ahx(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_at_within_inverse
tff(fact_6956_isCont__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(B)
        & topolo5987344860129210374id_add(C) )
     => ! [A3: set(A),A2: B,F3: fun(A,fun(B,C))] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => topolo3448309680560233919inuous(B,C,topolo174197925503356063within(B,A2,top_top(set(B))),aa(A,fun(B,C),F3,X4)) )
         => topolo3448309680560233919inuous(B,C,topolo174197925503356063within(B,A2,top_top(set(B))),aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_ahn(set(A),fun(fun(A,fun(B,C)),fun(B,C)),A3),F3)) ) ) ).

% isCont_sum
tff(fact_6957_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,S: set(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aTP_Lamp_ahy(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_at_within_sgn
tff(fact_6958_isCont__cos_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_aft(fun(A,B),fun(A,B),F3)) ) ) ).

% isCont_cos'
tff(fact_6959_isCont__sin_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_afu(fun(A,B),fun(A,B),F3)) ) ) ).

% isCont_sin'
tff(fact_6960_isCont__exp_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_afv(fun(A,B),fun(A,B),F3)) ) ) ).

% isCont_exp'
tff(fact_6961_isCont__pochhammer,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Z: A,Nb: nat] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Z,top_top(set(A))),aTP_Lamp_ahz(nat,fun(A,A),Nb)) ) ).

% isCont_pochhammer
tff(fact_6962_DERIV__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,top_top(set(A))))
         => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_aia(fun(A,A),fun(A,fun(A,A)),F3),X2),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% DERIV_D
tff(fact_6963_DERIV__def,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A] :
          ( has_field_derivative(A,F3,D4,topolo174197925503356063within(A,X2,top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_aia(fun(A,A),fun(A,fun(A,A)),F3),X2),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% DERIV_def
tff(fact_6964_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => filterlim(A,A,aTP_Lamp_aib(A,A),topolo7230453075368039082e_nhds(A,one_one(A)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ).

% lim_exp_minus_1
tff(fact_6965_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [K: real,F3: fun(A,B),K5: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K)
         => ( ! [H2: A] :
                ( ( H2 != zero_zero(A) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,H2)),K)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,H2))),aa(real,real,aa(real,fun(real,real),times_times(real),K5),real_V7770717601297561774m_norm(A,H2))) ) )
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% lemma_termdiff4
tff(fact_6966_isCont__inverse__function2,axiom,
    ! [A2: real,X2: real,B2: real,G: fun(real,real),F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),B2)
       => ( ! [Z2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z2)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z2),B2)
               => ( aa(real,real,G,aa(real,real,F3,Z2)) = Z2 ) ) )
         => ( ! [Z2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z2)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z2),B2)
                 => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z2,top_top(set(real))),F3) ) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,aa(real,real,F3,X2),top_top(set(real))),G) ) ) ) ) ).

% isCont_inverse_function2
tff(fact_6967_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D4: A,X2: A] :
          ( has_derivative(A,A,F3,aa(A,fun(A,A),times_times(A),D4),topolo174197925503356063within(A,X2,top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_aia(fun(A,A),fun(A,fun(A,A)),F3),X2),topolo7230453075368039082e_nhds(A,D4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% field_has_derivative_at
tff(fact_6968_isCont__ln,axiom,
    ! [X2: real] :
      ( ( X2 != zero_zero(real) )
     => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),ln_ln(real)) ) ).

% isCont_ln
tff(fact_6969_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( ( aa(A,B,G,A2) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_ahu(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ) ).

% isCont_divide
tff(fact_6970_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_ahy(fun(A,B),fun(A,B),F3)) ) ) ) ).

% isCont_sgn
tff(fact_6971_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(A,B),F4: filter(B),A2: A] :
          ( filterlim(A,B,F3,F4,topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_aic(fun(A,B),fun(A,fun(A,B)),F3),A2),F4,topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% filterlim_at_to_0
tff(fact_6972_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,S: set(A),F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,S),F3)
         => ( ( cos(A,aa(A,A,F3,X2)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,S),aTP_Lamp_agl(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_within_tan
tff(fact_6973_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A,S: set(A),F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,S),F3)
         => ( ( sin(A,aa(A,A,F3,X2)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,S),aTP_Lamp_ahc(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_within_cot
tff(fact_6974_continuous__at__within__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [X2: A,A3: set(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X2,A3),F3)
         => ( ( cosh(B,aa(A,B,F3,X2)) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X2,A3),aTP_Lamp_aid(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_at_within_tanh
tff(fact_6975_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),L: A,X2: A] :
          ( has_field_derivative(A,F3,L,topolo174197925503356063within(A,X2,top_top(set(A))))
        <=> ? [G4: fun(A,A)] :
              ( ! [Z5: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,F3,Z5)),aa(A,A,F3,X2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,G4,Z5)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z5),X2)) )
              & topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,top_top(set(A))),G4)
              & ( aa(A,A,G4,X2) = L ) ) ) ) ).

% CARAT_DERIV
tff(fact_6976_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A2: real,B2: real,F3: fun(real,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( ! [X4: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X4,top_top(set(real))),F3) )
           => ? [M7: A] :
                ( ! [X: real] :
                    ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2) )
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(real,A,F3,X)),M7) )
                & ! [N6: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),N6),M7)
                   => ? [X4: real] :
                        ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
                        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2)
                        & aa(A,$o,aa(A,fun(A,$o),ord_less(A),N6),aa(real,A,F3,X4)) ) ) ) ) ) ) ).

% isCont_has_Ub
tff(fact_6977_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( cos(A,X2) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,top_top(set(A))),tan(A)) ) ) ).

% isCont_tan
tff(fact_6978_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(A,B),D2: A,F4: filter(B),A2: A] :
          ( filterlim(A,B,aa(fun(A,A),fun(A,B),comp(A,B,A,F3),aa(A,fun(A,A),plus_plus(A),D2)),F4,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),top_top(set(A))))
        <=> filterlim(A,B,F3,F4,topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% filterlim_shift_iff
tff(fact_6979_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(A,B),F4: filter(B),A2: A,D2: A] :
          ( filterlim(A,B,F3,F4,topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(fun(A,A),fun(A,B),comp(A,B,A,F3),aa(A,fun(A,A),plus_plus(A),D2)),F4,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),top_top(set(A)))) ) ) ).

% filterlim_shift
tff(fact_6980_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( sin(A,X2) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,top_top(set(A))),cot(A)) ) ) ).

% isCont_cot
tff(fact_6981_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( ( cosh(A,X2) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,top_top(set(A))),tanh(A)) ) ) ).

% isCont_tanh
tff(fact_6982_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: real,A2: fun(nat,A),F3: fun(A,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S)
         => ( ! [X4: A] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X4)),S)
               => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),A2),X4)),aa(A,A,F3,X4)) )
           => filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,aa(nat,A,A2,zero_zero(nat))),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% powser_limit_0
tff(fact_6983_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: real,A2: fun(nat,A),F3: fun(A,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S)
         => ( ! [X4: A] :
                ( ( X4 != zero_zero(A) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X4)),S)
                 => aa(A,$o,sums(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),A2),X4)),aa(A,A,F3,X4)) ) )
           => filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,aa(nat,A,A2,zero_zero(nat))),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% powser_limit_0_strong
tff(fact_6984_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_Vector_banach(B) )
     => ! [K: real,F3: fun(nat,real),G: fun(A,fun(nat,B))] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K)
         => ( summable(real,F3)
           => ( ! [H2: A,N: nat] :
                  ( ( H2 != zero_zero(A) )
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,H2)),K)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(nat,B,aa(A,fun(nat,B),G,H2),N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,F3,N)),real_V7770717601297561774m_norm(A,H2))) ) )
             => filterlim(A,B,aTP_Lamp_aie(fun(A,fun(nat,B)),fun(A,B),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ).

% lemma_termdiff5
tff(fact_6985_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A2: A,F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( ( cos(A,aa(A,A,F3,A2)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_agl(fun(A,A),fun(A,A),F3)) ) ) ) ).

% isCont_tan'
tff(fact_6986_isCont__arcosh,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),arcosh(real)) ) ).

% isCont_arcosh
tff(fact_6987_LIM__cos__div__sin,axiom,
    filterlim(real,real,aTP_Lamp_aif(real,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),top_top(set(real)))) ).

% LIM_cos_div_sin
tff(fact_6988_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A2: A,F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( ( sin(A,aa(A,A,F3,A2)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_ahc(fun(A,A),fun(A,A),F3)) ) ) ) ).

% isCont_cot'
tff(fact_6989_DERIV__inverse__function,axiom,
    ! [F3: fun(real,real),D4: real,G: fun(real,real),X2: real,A2: real,B2: real] :
      ( has_field_derivative(real,F3,D4,topolo174197925503356063within(real,aa(real,real,G,X2),top_top(set(real))))
     => ( ( D4 != zero_zero(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),B2)
           => ( ! [Y4: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Y4)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y4),B2)
                   => ( aa(real,real,F3,aa(real,real,G,Y4)) = Y4 ) ) )
             => ( topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),G)
               => has_field_derivative(real,G,aa(real,real,inverse_inverse(real),D4),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ) ) ) ) ).

% DERIV_inverse_function
tff(fact_6990_isCont__polynom,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: A,C2: fun(nat,A),Nb: nat] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aa(nat,fun(A,A),aTP_Lamp_aig(fun(nat,A),fun(nat,fun(A,A)),C2),Nb)) ) ).

% isCont_polynom
tff(fact_6991_isCont__arccos,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),arccos) ) ) ).

% isCont_arccos
tff(fact_6992_isCont__arcsin,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),arcsin) ) ) ).

% isCont_arcsin
tff(fact_6993_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X2: A] :
          ( ! [Y4: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),Y4))
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,top_top(set(A))),aTP_Lamp_aaj(fun(nat,A),fun(A,A),C2)) ) ) ).

% isCont_powser_converges_everywhere
tff(fact_6994_LIM__less__bound,axiom,
    ! [B2: real,X2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),B2),X2)
     => ( ! [X4: real] :
            ( aa(set(real),$o,member(real,X4),set_or5935395276787703475ssThan(real,B2,X2))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,F3,X4)) )
       => ( topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),F3)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,F3,X2)) ) ) ) ).

% LIM_less_bound
tff(fact_6995_isCont__artanh,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X2,top_top(set(real))),artanh(real)) ) ) ).

% isCont_artanh
tff(fact_6996_isCont__inverse__function,axiom,
    ! [D2: real,X2: real,G: fun(real,real),F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
     => ( ! [Z2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Z2),X2))),D2)
           => ( aa(real,real,G,aa(real,real,F3,Z2)) = Z2 ) )
       => ( ! [Z2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Z2),X2))),D2)
             => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z2,top_top(set(real))),F3) )
         => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,aa(real,real,F3,X2),top_top(set(real))),G) ) ) ) ).

% isCont_inverse_function
tff(fact_6997_GMVT_H,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),G: fun(real,real),G2: fun(real,real),F8: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [Z2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z2),B2)
             => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z2,top_top(set(real))),F3) ) )
       => ( ! [Z2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z2)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z2),B2)
               => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z2,top_top(set(real))),G) ) )
         => ( ! [Z2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
                 => has_field_derivative(real,G,aa(real,real,G2,Z2),topolo174197925503356063within(real,Z2,top_top(set(real)))) ) )
           => ( ! [Z2: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
                   => has_field_derivative(real,F3,aa(real,real,F8,Z2),topolo174197925503356063within(real,Z2,top_top(set(real)))) ) )
             => ? [C3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),C3),B2)
                  & ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2))),aa(real,real,G2,C3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,G,B2)),aa(real,real,G,A2))),aa(real,real,F8,C3)) ) ) ) ) ) ) ) ).

% GMVT'
tff(fact_6998_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [X2: real,F3: fun(real,A)] :
          ( topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X2,top_top(set(real))),F3)
         => ( ~ aa(set(A),$o,member(A,aa(real,A,F3,X2)),ring_1_Ints(A))
           => has_field_derivative(real,aTP_Lamp_aih(fun(real,A),fun(real,real),F3),zero_zero(real),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ) ).

% floor_has_real_derivative
tff(fact_6999_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),real_V7770717601297561774m_norm(A,K5))
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X2,top_top(set(A))),aTP_Lamp_aaj(fun(nat,A),fun(A,A),C2)) ) ) ) ).

% isCont_powser
tff(fact_7000_isCont__powser_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B)
        & topological_t2_space(A) )
     => ! [A2: A,F3: fun(A,B),C2: fun(nat,B),K5: B] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( summable(B,aa(B,fun(nat,B),aTP_Lamp_aii(fun(nat,B),fun(B,fun(nat,B)),C2),K5))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,A2))),real_V7770717601297561774m_norm(B,K5))
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(nat,B),fun(A,B),aTP_Lamp_aik(fun(A,B),fun(fun(nat,B),fun(A,B)),F3),C2)) ) ) ) ) ).

% isCont_powser'
tff(fact_7001_summable__Leibniz_I3_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,A2,zero_zero(nat))),zero_zero(real))
         => ! [N8: nat] : aa(set(real),$o,member(real,suminf(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2))),set_or1337092689740270186AtMost(real,aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N8)),one_one(nat)))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N8))))) ) ) ) ).

% summable_Leibniz(3)
tff(fact_7002_summable__Leibniz_I2_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(nat,real,A2,zero_zero(nat)))
         => ! [N8: nat] : aa(set(real),$o,member(real,suminf(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2))),set_or1337092689740270186AtMost(real,aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N8))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N8)),one_one(nat)))))) ) ) ) ).

% summable_Leibniz(2)
tff(fact_7003_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aim(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_mult_left_iff
tff(fact_7004_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ain(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_mult_right_iff
tff(fact_7005_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aio(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_divide_iff
tff(fact_7006_isCont__Im,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,G: fun(A,complex)] :
          ( topolo3448309680560233919inuous(A,complex,topolo174197925503356063within(A,A2,top_top(set(A))),G)
         => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_aip(fun(A,complex),fun(A,real),G)) ) ) ).

% isCont_Im
tff(fact_7007_isCont__Re,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,G: fun(A,complex)] :
          ( topolo3448309680560233919inuous(A,complex,topolo174197925503356063within(A,A2,top_top(set(A))),G)
         => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_aiq(fun(A,complex),fun(A,real),G)) ) ) ).

% isCont_Re
tff(fact_7008_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( dense_linorder(A)
        & topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ? [U2: fun(nat,A)] :
              ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,U2,N8)),X2)
              & filterlim(nat,A,U2,topolo7230453075368039082e_nhds(A,X2),at_top(nat)) ) ) ) ).

% approx_from_below_dense_linorder
tff(fact_7009_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( dense_linorder(A)
        & topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ? [U2: fun(nat,A)] :
              ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(nat,A,U2,N8))
              & filterlim(nat,A,U2,topolo7230453075368039082e_nhds(A,X2),at_top(nat)) ) ) ) ).

% approx_from_above_dense_linorder
tff(fact_7010_filterlim__Suc,axiom,
    filterlim(nat,nat,suc,at_top(nat),at_top(nat)) ).

% filterlim_Suc
tff(fact_7011_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F3: fun(nat,A),F4: filter(A)] :
      ( filterlim(nat,A,aTP_Lamp_xw(fun(nat,A),fun(nat,A),F3),F4,at_top(nat))
    <=> filterlim(nat,A,F3,F4,at_top(nat)) ) ).

% filterlim_sequentially_Suc
tff(fact_7012_continuous__rabs,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_air(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_rabs
tff(fact_7013_continuous__cnj,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),G: fun(A,complex)] :
          ( topolo3448309680560233919inuous(A,complex,F4,G)
         => topolo3448309680560233919inuous(A,complex,F4,aTP_Lamp_ais(fun(A,complex),fun(A,complex),G)) ) ) ).

% continuous_cnj
tff(fact_7014_continuous__Re,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),G: fun(A,complex)] :
          ( topolo3448309680560233919inuous(A,complex,F4,G)
         => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_aiq(fun(A,complex),fun(A,real),G)) ) ) ).

% continuous_Re
tff(fact_7015_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),A2: A,K: nat] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
         => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ait(fun(nat,A),fun(nat,fun(nat,A)),F3),K),topolo7230453075368039082e_nhds(A,A2),at_top(nat)) ) ) ).

% LIMSEQ_ignore_initial_segment
tff(fact_7016_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),K: nat,A2: A] :
          ( filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ait(fun(nat,A),fun(nat,fun(nat,A)),F3),K),topolo7230453075368039082e_nhds(A,A2),at_top(nat))
         => filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) ) ) ).

% LIMSEQ_offset
tff(fact_7017_LIMSEQ__const__iff,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [K: A,L: A] :
          ( filterlim(nat,A,aTP_Lamp_aiu(A,fun(nat,A),K),topolo7230453075368039082e_nhds(A,L),at_top(nat))
        <=> ( K = L ) ) ) ).

% LIMSEQ_const_iff
tff(fact_7018_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),L: A] :
          ( filterlim(nat,A,aTP_Lamp_aiv(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% LIMSEQ_imp_Suc
tff(fact_7019_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),L: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,aTP_Lamp_aiv(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% LIMSEQ_Suc
tff(fact_7020_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_aiw(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_real_sqrt
tff(fact_7021_continuous__arctan,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_aix(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_arctan
tff(fact_7022_continuous__real__root,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real),Nb: nat] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => topolo3448309680560233919inuous(A,real,F4,aa(nat,fun(A,real),aTP_Lamp_aiy(fun(A,real),fun(nat,fun(A,real)),F3),Nb)) ) ) ).

% continuous_real_root
tff(fact_7023_continuous__Im,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),G: fun(A,complex)] :
          ( topolo3448309680560233919inuous(A,complex,F4,G)
         => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_aip(fun(A,complex),fun(A,real),G)) ) ) ).

% continuous_Im
tff(fact_7024_continuous__complex__iff,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,complex)] :
          ( topolo3448309680560233919inuous(A,complex,F4,F3)
        <=> ( topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_aiq(fun(A,complex),fun(A,real),F3))
            & topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_aip(fun(A,complex),fun(A,real),F3)) ) ) ) ).

% continuous_complex_iff
tff(fact_7025_continuous__arsinh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_aiz(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_arsinh
tff(fact_7026_seq__offset__neg,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),L: A,K: nat] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_aja(fun(nat,A),fun(nat,fun(nat,A)),F3),K),topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% seq_offset_neg
tff(fact_7027_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% summable_LIMSEQ_zero
tff(fact_7028_isCont__rabs,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_air(fun(A,real),fun(A,real),F3)) ) ) ).

% isCont_rabs
tff(fact_7029_isCont__cnj,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,G: fun(A,complex)] :
          ( topolo3448309680560233919inuous(A,complex,topolo174197925503356063within(A,A2,top_top(set(A))),G)
         => topolo3448309680560233919inuous(A,complex,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_ais(fun(A,complex),fun(A,complex),G)) ) ) ).

% isCont_cnj
tff(fact_7030_continuous__at__within__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),F3)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),G)
           => ( ( aa(A,real,F3,A2) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),aa(fun(A,real),fun(A,real),aTP_Lamp_ajb(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% continuous_at_within_powr
tff(fact_7031_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X2: A,S: set(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X2,S),F3)
         => ( ( aa(A,real,F3,X2) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X2,S),aTP_Lamp_ajc(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_within_ln
tff(fact_7032_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),C2)
     => filterlim(nat,nat,aTP_Lamp_ajd(nat,fun(nat,nat),C2),at_top(nat),at_top(nat)) ) ).

% mult_nat_right_at_top
tff(fact_7033_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),C2)
     => filterlim(nat,nat,aa(nat,fun(nat,nat),times_times(nat),C2),at_top(nat),at_top(nat)) ) ).

% mult_nat_left_at_top
tff(fact_7034_LIMSEQ__lessThan__iff__atMost,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(set(nat),A),X2: A] :
          ( filterlim(nat,A,aTP_Lamp_aje(fun(set(nat),A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,X2),at_top(nat))
        <=> filterlim(nat,A,aTP_Lamp_ajf(fun(set(nat),A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,X2),at_top(nat)) ) ) ).

% LIMSEQ_lessThan_iff_atMost
tff(fact_7035_LIMSEQ__root,axiom,
    filterlim(nat,real,aTP_Lamp_ajg(nat,real),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat)) ).

% LIMSEQ_root
tff(fact_7036_isCont__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( ( aa(A,real,F3,A2) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,real),fun(A,real),aTP_Lamp_ajb(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% isCont_powr
tff(fact_7037_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X2: A,F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X2,top_top(set(A))),F3)
         => ( ( aa(A,real,F3,X2) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X2,top_top(set(A))),aTP_Lamp_ajc(fun(A,real),fun(A,real),F3)) ) ) ) ).

% isCont_ln'
tff(fact_7038_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A] : filterlim(nat,A,aTP_Lamp_ajh(A,fun(nat,A),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_const_over_n
tff(fact_7039_LIMSEQ__SEQ__conv,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,X7: fun(A,B),L4: B] :
          ( ! [S7: fun(nat,A)] :
              ( ( ! [N4: nat] : ( aa(nat,A,S7,N4) != A2 )
                & filterlim(nat,A,S7,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) )
             => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_aji(fun(A,B),fun(fun(nat,A),fun(nat,B)),X7),S7),topolo7230453075368039082e_nhds(B,L4),at_top(nat)) )
        <=> filterlim(A,B,X7,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% LIMSEQ_SEQ_conv
tff(fact_7040_LIMSEQ__SEQ__conv1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),L: B,A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ! [S8: fun(nat,A)] :
              ( ( ! [N: nat] : ( aa(nat,A,S8,N) != A2 )
                & filterlim(nat,A,S8,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) )
             => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_ajj(fun(A,B),fun(fun(nat,A),fun(nat,B)),F3),S8),topolo7230453075368039082e_nhds(B,L),at_top(nat)) ) ) ) ).

% LIMSEQ_SEQ_conv1
tff(fact_7041_LIMSEQ__SEQ__conv2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,F3: fun(A,B),L: B] :
          ( ! [S9: fun(nat,A)] :
              ( ( ! [N8: nat] : ( aa(nat,A,S9,N8) != A2 )
                & filterlim(nat,A,S9,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) )
             => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_aji(fun(A,B),fun(fun(nat,A),fun(nat,B)),F3),S9),topolo7230453075368039082e_nhds(B,L),at_top(nat)) )
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% LIMSEQ_SEQ_conv2
tff(fact_7042_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_ajk(nat,A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_inverse_n
tff(fact_7043_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [X7: fun(nat,A),X2: A,L: nat] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,X2),at_top(nat))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),L)
           => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ajl(fun(nat,A),fun(nat,fun(nat,A)),X7),L),topolo7230453075368039082e_nhds(A,X2),at_top(nat)) ) ) ) ).

% LIMSEQ_linear
tff(fact_7044_telescope__summable,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => summable(A,aTP_Lamp_ajm(fun(nat,A),fun(nat,A),F3)) ) ) ).

% telescope_summable
tff(fact_7045_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => summable(A,aTP_Lamp_ajn(fun(nat,A),fun(nat,A),F3)) ) ) ).

% telescope_summable'
tff(fact_7046_nested__sequence__unique,axiom,
    ! [F3: fun(nat,real),G: fun(nat,real)] :
      ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N)),aa(nat,real,F3,aa(nat,nat,suc,N)))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,G,aa(nat,nat,suc,N))),aa(nat,real,G,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N)),aa(nat,real,G,N))
         => ( filterlim(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_ajo(fun(nat,real),fun(fun(nat,real),fun(nat,real)),F3),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => ? [L2: real] :
                ( ! [N8: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N8)),L2)
                & filterlim(nat,real,F3,topolo7230453075368039082e_nhds(real,L2),at_top(nat))
                & ! [N8: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L2),aa(nat,real,G,N8))
                & filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,L2),at_top(nat)) ) ) ) ) ) ).

% nested_sequence_unique
tff(fact_7047_LIMSEQ__inverse__zero,axiom,
    ! [X7: fun(nat,real)] :
      ( ! [R2: real] :
        ? [N6: nat] :
        ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),R2),aa(nat,real,X7,N)) )
     => filterlim(nat,real,aTP_Lamp_ajp(fun(nat,real),fun(nat,real),X7),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_inverse_zero
tff(fact_7048_lim__inverse__n_H,axiom,
    filterlim(nat,real,aTP_Lamp_ajq(nat,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ).

% lim_inverse_n'
tff(fact_7049_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
     => filterlim(nat,real,aTP_Lamp_ajr(real,fun(nat,real),C2),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat)) ) ).

% LIMSEQ_root_const
tff(fact_7050_LIMSEQ__inverse__real__of__nat,axiom,
    filterlim(nat,real,aTP_Lamp_ajs(nat,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat
tff(fact_7051_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R: real] : filterlim(nat,real,aTP_Lamp_ajt(real,fun(nat,real),R),topolo7230453075368039082e_nhds(real,R),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add
tff(fact_7052_sums__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A),S: A] :
          ( aa(A,$o,sums(A,F3),S)
        <=> filterlim(nat,A,aTP_Lamp_aju(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,S),at_top(nat)) ) ) ).

% sums_def
tff(fact_7053_sums__def__le,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A),S: A] :
          ( aa(A,$o,sums(A,F3),S)
        <=> filterlim(nat,A,aTP_Lamp_ajv(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,S),at_top(nat)) ) ) ).

% sums_def_le
tff(fact_7054_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),F3)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,A2))
             => ( ( aa(A,real,F3,A2) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,A2))
                 => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),aa(fun(A,real),fun(A,real),aTP_Lamp_ajw(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ) ) ).

% continuous_at_within_log
tff(fact_7055_increasing__LIMSEQ,axiom,
    ! [F3: fun(nat,real),L: real] :
      ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N)),aa(nat,real,F3,aa(nat,nat,suc,N)))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N)),L)
       => ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => ? [N8: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,F3,N8)),E)) )
         => filterlim(nat,real,F3,topolo7230453075368039082e_nhds(real,L),at_top(nat)) ) ) ) ).

% increasing_LIMSEQ
tff(fact_7056_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_ajx(nat,A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_1_over_n
tff(fact_7057_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_ajy(nat,A),topolo7230453075368039082e_nhds(A,one_one(A)),at_top(nat)) ) ).

% LIMSEQ_Suc_n_over_n
tff(fact_7058_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_ajz(nat,A),topolo7230453075368039082e_nhds(A,one_one(A)),at_top(nat)) ) ).

% LIMSEQ_n_over_Suc_n
tff(fact_7059_LIMSEQ__realpow__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
       => filterlim(nat,real,power_power(real,X2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ) ).

% LIMSEQ_realpow_zero
tff(fact_7060_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => aa(A,$o,sums(A,aTP_Lamp_ajn(fun(nat,A),fun(nat,A),F3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,zero_zero(nat))),C2)) ) ) ).

% telescope_sums'
tff(fact_7061_telescope__sums,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => aa(A,$o,sums(A,aTP_Lamp_ajm(fun(nat,A),fun(nat,A),F3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(nat,A,F3,zero_zero(nat)))) ) ) ).

% telescope_sums
tff(fact_7062_LIMSEQ__divide__realpow__zero,axiom,
    ! [X2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => filterlim(nat,real,aa(real,fun(nat,real),aTP_Lamp_aka(real,fun(real,fun(nat,real)),X2),A2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_divide_realpow_zero
tff(fact_7063_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),C2)),one_one(real))
     => filterlim(nat,real,power_power(real,C2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_abs_realpow_zero2
tff(fact_7064_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),C2)),one_one(real))
     => filterlim(nat,real,power_power(real,aa(real,real,abs_abs(real),C2)),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_abs_realpow_zero
tff(fact_7065_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X2)
     => filterlim(nat,real,aTP_Lamp_akb(real,fun(nat,real),X2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_inverse_realpow_zero
tff(fact_7066_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A),S: A] :
          ( aa(A,$o,sums(A,F3),S)
        <=> filterlim(nat,A,aTP_Lamp_akc(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,S),at_top(nat)) ) ) ).

% sums_def'
tff(fact_7067_root__test__convergence,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),X2: real] :
          ( filterlim(nat,real,aTP_Lamp_akd(fun(nat,A),fun(nat,real),F3),topolo7230453075368039082e_nhds(real,X2),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X2),one_one(real))
           => summable(A,F3) ) ) ) ).

% root_test_convergence
tff(fact_7068_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R: real] : filterlim(nat,real,aTP_Lamp_ake(real,fun(nat,real),R),topolo7230453075368039082e_nhds(real,R),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add_minus
tff(fact_7069_summable__LIMSEQ,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => filterlim(nat,A,aTP_Lamp_akf(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,suminf(A,F3)),at_top(nat)) ) ) ).

% summable_LIMSEQ
tff(fact_7070_summable__LIMSEQ_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => filterlim(nat,A,aTP_Lamp_akg(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,suminf(A,F3)),at_top(nat)) ) ) ).

% summable_LIMSEQ'
tff(fact_7071_isCont__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,A2))
             => ( ( aa(A,real,F3,A2) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,A2))
                 => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,real),fun(A,real),aTP_Lamp_ajw(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ) ) ).

% isCont_log
tff(fact_7072_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L4: A,R: real] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => ? [No2: nat] :
              ! [N8: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No2),N8)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N8)),L4))),R) ) ) ) ) ).

% LIMSEQ_D
tff(fact_7073_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( ! [R2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
             => ? [No3: nat] :
                ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No3),N)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N)),L4))),R2) ) )
         => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat)) ) ) ).

% LIMSEQ_I
tff(fact_7074_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No4: nat] :
                ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No4),N4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N4)),L4))),R5) ) ) ) ) ).

% LIMSEQ_iff
tff(fact_7075_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),one_one(real))
         => filterlim(nat,A,power_power(A,X2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% LIMSEQ_power_zero
tff(fact_7076_tendsto__exp__limit__sequentially,axiom,
    ! [X2: real] : filterlim(nat,real,aTP_Lamp_akh(real,fun(nat,real),X2),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X2)),at_top(nat)) ).

% tendsto_exp_limit_sequentially
tff(fact_7077_tendsto__power__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [F3: fun(A,nat),F4: filter(A),X2: B] :
          ( filterlim(A,nat,F3,at_top(nat),F4)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,X2)),one_one(real))
           => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_aki(fun(A,nat),fun(B,fun(A,B)),F3),X2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ) ).

% tendsto_power_zero
tff(fact_7078_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R: real] : filterlim(nat,real,aTP_Lamp_akj(real,fun(nat,real),R),topolo7230453075368039082e_nhds(real,R),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
tff(fact_7079_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N))),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))))
         => filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% LIMSEQ_norm_0
tff(fact_7080_summable__Leibniz_I1_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => summable(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)) ) ) ).

% summable_Leibniz(1)
tff(fact_7081_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Df: A,Z: A,S: fun(nat,A),A2: A] :
          ( has_field_derivative(A,F3,Df,topolo174197925503356063within(A,Z,top_top(set(A))))
         => ( filterlim(nat,A,S,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
           => ( ! [N: nat] : ( aa(nat,A,S,N) != zero_zero(A) )
             => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),aTP_Lamp_akk(fun(A,A),fun(A,fun(fun(nat,A),fun(nat,A))),F3),Z),S),topolo7230453075368039082e_nhds(A,A2),at_top(nat))
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
tff(fact_7082_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X2)),one_one(real))
         => filterlim(nat,A,aTP_Lamp_akl(A,fun(nat,A),X2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% powser_times_n_limit_0
tff(fact_7083_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),real_V7770717601297561774m_norm(A,X2))
         => filterlim(nat,A,aTP_Lamp_akm(A,fun(nat,A),X2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% lim_n_over_pown
tff(fact_7084_summable,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => summable(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)) ) ) ) ).

% summable
tff(fact_7085_cos__diff__limit__1,axiom,
    ! [Theta: fun(nat,real),Theta2: real] :
      ( filterlim(nat,real,aa(real,fun(nat,real),aTP_Lamp_akn(fun(nat,real),fun(real,fun(nat,real)),Theta),Theta2),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat))
     => ~ ! [K2: fun(nat,int)] : ~ filterlim(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_ako(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Theta),K2),topolo7230453075368039082e_nhds(real,Theta2),at_top(nat)) ) ).

% cos_diff_limit_1
tff(fact_7086_cos__limit__1,axiom,
    ! [Theta: fun(nat,real)] :
      ( filterlim(nat,real,aTP_Lamp_akp(fun(nat,real),fun(nat,real),Theta),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat))
     => ? [K2: fun(nat,int)] : filterlim(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_ako(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Theta),K2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% cos_limit_1
tff(fact_7087_summable__Leibniz_I4_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => filterlim(nat,real,aTP_Lamp_akq(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ).

% summable_Leibniz(4)
tff(fact_7088_zeroseq__arctan__series,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X2)),one_one(real))
     => filterlim(nat,real,aTP_Lamp_bn(real,fun(nat,real),X2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% zeroseq_arctan_series
tff(fact_7089_summable__Leibniz_H_I2_J,axiom,
    ! [A2: fun(nat,real),Nb: nat] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)))),suminf(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2))) ) ) ) ).

% summable_Leibniz'(2)
tff(fact_7090_summable__Leibniz_H_I3_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => filterlim(nat,real,aTP_Lamp_akq(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ) ).

% summable_Leibniz'(3)
tff(fact_7091_sums__alternating__upper__lower,axiom,
    ! [A2: fun(nat,real)] :
      ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
         => ? [L2: real] :
              ( ! [N8: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N8)))),L2)
              & filterlim(nat,real,aTP_Lamp_akq(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,L2),at_top(nat))
              & ! [N8: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L2),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N8)),one_one(nat)))))
              & filterlim(nat,real,aTP_Lamp_akr(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,L2),at_top(nat)) ) ) ) ) ).

% sums_alternating_upper_lower
tff(fact_7092_summable__Leibniz_I5_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => filterlim(nat,real,aTP_Lamp_akr(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ).

% summable_Leibniz(5)
tff(fact_7093_summable__Leibniz_H_I4_J,axiom,
    ! [A2: fun(nat,real),Nb: nat] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),suminf(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)),one_one(nat))))) ) ) ) ).

% summable_Leibniz'(4)
tff(fact_7094_summable__Leibniz_H_I5_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => filterlim(nat,real,aTP_Lamp_akr(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ) ).

% summable_Leibniz'(5)
tff(fact_7095_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_aks(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F3),F8),X2),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X2,top_top(set(A)))) ) ) ) ).

% has_derivative_at2
tff(fact_7096_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),D4: fun(A,B),X2: A] :
          ( has_derivative(A,B,F3,D4,topolo174197925503356063within(A,X2,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,D4)
            & filterlim(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_akt(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),F3),D4),X2),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% has_derivative_at
tff(fact_7097_bounded__linear_Ohas__derivative,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(A,B),G: fun(C,A),G2: fun(C,A),F4: filter(C)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( has_derivative(C,A,G,G2,F4)
           => has_derivative(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aca(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G),aa(fun(C,A),fun(C,B),aTP_Lamp_aca(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G2),F4) ) ) ) ).

% bounded_linear.has_derivative
tff(fact_7098_bounded__linear_Otendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(A,B),G: fun(C,A),A2: A,F4: filter(C)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( filterlim(C,A,G,topolo7230453075368039082e_nhds(A,A2),F4)
           => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aku(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(A,B,F3,A2)),F4) ) ) ) ).

% bounded_linear.tendsto
tff(fact_7099_bounded__linear_Ocontinuous,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F4: filter(C),G: fun(C,A)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( topolo3448309680560233919inuous(C,A,F4,G)
           => topolo3448309680560233919inuous(C,B,F4,aa(fun(C,A),fun(C,B),aTP_Lamp_akv(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G)) ) ) ) ).

% bounded_linear.continuous
tff(fact_7100_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Y2: A] : real_V3181309239436604168linear(A,A,aTP_Lamp_akw(A,fun(A,A),Y2)) ) ).

% bounded_linear_divide
tff(fact_7101_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [X2: A] : real_V3181309239436604168linear(A,A,aa(A,fun(A,A),times_times(A),X2)) ) ).

% bounded_linear_mult_right
tff(fact_7102_bounded__linear__mult__const,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & real_V822414075346904944vector(A) )
     => ! [G: fun(A,B),Y2: B] :
          ( real_V3181309239436604168linear(A,B,G)
         => real_V3181309239436604168linear(A,B,aa(B,fun(A,B),aTP_Lamp_abx(fun(A,B),fun(B,fun(A,B)),G),Y2)) ) ) ).

% bounded_linear_mult_const
tff(fact_7103_bounded__linear__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & real_V822414075346904944vector(A) )
     => ! [G: fun(A,B),X2: B] :
          ( real_V3181309239436604168linear(A,B,G)
         => real_V3181309239436604168linear(A,B,aa(B,fun(A,B),aTP_Lamp_abw(fun(A,B),fun(B,fun(A,B)),G),X2)) ) ) ).

% bounded_linear_const_mult
tff(fact_7104_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Y2: A] : real_V3181309239436604168linear(A,A,aTP_Lamp_akx(A,fun(A,A),Y2)) ) ).

% bounded_linear_mult_left
tff(fact_7105_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( real_V3181309239436604168linear(A,B,G)
           => real_V3181309239436604168linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abv(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% bounded_linear_add
tff(fact_7106_bounded__linear_Osummable,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),X7: fun(nat,A)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( summable(A,X7)
           => summable(B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_aky(fun(A,B),fun(fun(nat,A),fun(nat,B)),F3),X7)) ) ) ) ).

% bounded_linear.summable
tff(fact_7107_bounded__linear__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R: real] : real_V3181309239436604168linear(A,A,real_V8093663219630862766scaleR(A,R)) ) ).

% bounded_linear_scaleR_right
tff(fact_7108_bounded__linear__const__scaleR,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [G: fun(A,B),R: real] :
          ( real_V3181309239436604168linear(A,B,G)
         => real_V3181309239436604168linear(A,B,aa(real,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(real,fun(A,B)),G),R)) ) ) ).

% bounded_linear_const_scaleR
tff(fact_7109_bounded__linear__scaleR__const,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [G: fun(A,real),X2: B] :
          ( real_V3181309239436604168linear(A,real,G)
         => real_V3181309239436604168linear(A,B,aa(B,fun(A,B),aTP_Lamp_abu(fun(A,real),fun(B,fun(A,B)),G),X2)) ) ) ).

% bounded_linear_scaleR_const
tff(fact_7110_bounded__linear__ident,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => real_V3181309239436604168linear(A,A,aTP_Lamp_abs(A,A)) ) ).

% bounded_linear_ident
tff(fact_7111_bounded__linear__compose,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),G: fun(C,A)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( real_V3181309239436604168linear(C,A,G)
           => real_V3181309239436604168linear(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aca(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G)) ) ) ) ).

% bounded_linear_compose
tff(fact_7112_bounded__linear__scaleR__left,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] : real_V3181309239436604168linear(real,A,aTP_Lamp_akz(A,fun(real,A),X2)) ) ).

% bounded_linear_scaleR_left
tff(fact_7113_bounded__linear__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1(A)
        & real_V822414075346904944vector(A) )
     => real_V3181309239436604168linear(real,A,real_Vector_of_real(A)) ) ).

% bounded_linear_of_real
tff(fact_7114_bounded__linear_Osums,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),X7: fun(nat,A),A2: A] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( aa(A,$o,sums(A,X7),A2)
           => aa(B,$o,sums(B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_aky(fun(A,B),fun(fun(nat,A),fun(nat,B)),F3),X7)),aa(A,B,F3,A2)) ) ) ) ).

% bounded_linear.sums
tff(fact_7115_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => real_V3181309239436604168linear(A,B,aTP_Lamp_abq(A,B)) ) ).

% bounded_linear_zero
tff(fact_7116_bounded__linear_OCauchy,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),X7: fun(nat,A)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( topolo3814608138187158403Cauchy(A,X7)
           => topolo3814608138187158403Cauchy(B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_aky(fun(A,B),fun(fun(nat,A),fun(nat,B)),F3),X7)) ) ) ) ).

% bounded_linear.Cauchy
tff(fact_7117_real__bounded__linear,axiom,
    ! [F3: fun(real,real)] :
      ( real_V3181309239436604168linear(real,real,F3)
    <=> ? [C4: real] :
        ! [X3: real] : ( aa(real,real,F3,X3) = aa(real,real,aa(real,fun(real,real),times_times(real),X3),C4) ) ) ).

% real_bounded_linear
tff(fact_7118_bounded__linear__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => real_V3181309239436604168linear(A,B,aTP_Lamp_abo(fun(A,B),fun(A,B),F3)) ) ) ).

% bounded_linear_minus
tff(fact_7119_bounded__linear__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( real_V3181309239436604168linear(A,B,G)
           => real_V3181309239436604168linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abn(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% bounded_linear_sub
tff(fact_7120_bounded__linear_Osuminf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),X7: fun(nat,A)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( summable(A,X7)
           => ( aa(A,B,F3,suminf(A,X7)) = suminf(B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_aky(fun(A,B),fun(fun(nat,A),fun(nat,B)),F3),X7)) ) ) ) ) ).

% bounded_linear.suminf
tff(fact_7121_bounded__linear__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [I5: set(A),F3: fun(A,fun(B,C))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => real_V3181309239436604168linear(B,C,aa(A,fun(B,C),F3,I2)) )
         => real_V3181309239436604168linear(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_abm(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3)) ) ) ).

% bounded_linear_sum
tff(fact_7122_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ? [K9: real] :
            ! [X: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X)),K9)) ) ) ).

% bounded_linear.bounded
tff(fact_7123_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),G: fun(C,A),F4: filter(C)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( filterlim(C,A,G,topolo7230453075368039082e_nhds(A,zero_zero(A)),F4)
           => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aku(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ) ).

% bounded_linear.tendsto_zero
tff(fact_7124_bounded__linear_OisCont,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),A2: C,G: fun(C,A)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( topolo3448309680560233919inuous(C,A,topolo174197925503356063within(C,A2,top_top(set(C))),G)
           => topolo3448309680560233919inuous(C,B,topolo174197925503356063within(C,A2,top_top(set(C))),aa(fun(C,A),fun(C,B),aTP_Lamp_akv(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G)) ) ) ) ).

% bounded_linear.isCont
tff(fact_7125_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ? [K9: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),K9)
              & ! [X: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X)),K9)) ) ) ) ).

% bounded_linear.nonneg_bounded
tff(fact_7126_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ? [K9: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K9)
              & ! [X: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X)),K9)) ) ) ) ).

% bounded_linear.pos_bounded
tff(fact_7127_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),K5: real] :
          ( ! [X4: A,Y4: A] : ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),Y4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,X4)),aa(A,B,F3,Y4)) )
         => ( ! [R2: real,X4: A] : ( aa(A,B,F3,aa(A,A,real_V8093663219630862766scaleR(A,R2),X4)) = aa(B,B,real_V8093663219630862766scaleR(B,R2),aa(A,B,F3,X4)) )
           => ( ! [X4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X4))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X4)),K5))
             => real_V3181309239436604168linear(A,B,F3) ) ) ) ) ).

% bounded_linear_intro
tff(fact_7128_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S: set(A)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_ala(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),F3),F8),X2),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_iff_norm
tff(fact_7129_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F8: fun(A,B),X2: A,F3: fun(A,B),S: set(A)] :
          ( real_V3181309239436604168linear(A,B,F8)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aa(A,fun(fun(A,B),fun(A,B)),aTP_Lamp_alb(fun(A,B),fun(A,fun(fun(A,B),fun(A,B))),F8),X2),F3),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X2,S))
           => has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivativeI
tff(fact_7130_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S: set(A)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_alc(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F3),F8),X2),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_at_within
tff(fact_7131_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & ? [E3: fun(A,B)] :
                ( ! [H4: A] : ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),H4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,X2)),aa(A,B,F8,H4))),aa(A,B,E3,H4)) )
                & filterlim(A,real,aTP_Lamp_ald(fun(A,B),fun(A,real),E3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ).

% has_derivative_iff_Ex
tff(fact_7132_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S: set(A)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S))
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_aks(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F3),F8),X2),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% has_derivative_within
tff(fact_7133_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),F4: filter(A)] :
          ( has_derivative(A,B,F3,F8,F4)
        <=> ( real_V3181309239436604168linear(A,B,F8)
            & filterlim(A,B,aa(filter(A),fun(A,B),aa(fun(A,B),fun(filter(A),fun(A,B)),aTP_Lamp_ale(fun(A,B),fun(fun(A,B),fun(filter(A),fun(A,B))),F3),F8),F4),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ) ).

% has_derivative_def
tff(fact_7134_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [X2: A,S3: set(A),F3: fun(A,B),F8: fun(A,B)] :
          ( aa(set(A),$o,member(A,X2),S3)
         => ( aa(set(A),$o,topolo1002775350975398744n_open(A),S3)
           => ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S3))
            <=> ( real_V3181309239436604168linear(A,B,F8)
                & ? [E3: fun(A,B)] :
                    ( ! [H4: A] :
                        ( aa(set(A),$o,member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),H4)),S3)
                       => ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),H4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,X2)),aa(A,B,F8,H4))),aa(A,B,E3,H4)) ) )
                    & filterlim(A,real,aTP_Lamp_ald(fun(A,B),fun(A,real),E3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
tff(fact_7135_lim__const,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A] : ( topolo3827282254853284352ce_Lim(nat,A,at_top(nat),aTP_Lamp_aiu(A,fun(nat,A),A2)) = A2 ) ) ).

% lim_const
tff(fact_7136_open__UN,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [A3: set(A),B4: fun(A,set(B))] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => aa(set(B),$o,topolo1002775350975398744n_open(B),aa(A,set(B),B4,X4)) )
         => aa(set(B),$o,topolo1002775350975398744n_open(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ) ).

% open_UN
tff(fact_7137_open__INT,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [A3: set(A),B4: fun(A,set(B))] :
          ( finite_finite2(A,A3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => aa(set(B),$o,topolo1002775350975398744n_open(B),aa(A,set(B),B4,X4)) )
           => aa(set(B),$o,topolo1002775350975398744n_open(B),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ) ) ).

% open_INT
tff(fact_7138_open__right,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S3: set(A),X2: A,Y2: A] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),S3)
         => ( aa(set(A),$o,member(A,X2),S3)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
             => ? [B3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),B3)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,X2,B3)),S3) ) ) ) ) ) ).

% open_right
tff(fact_7139_open__Collect__const,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: $o] : aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_alf($o,fun(A,$o),P))) ) ).

% open_Collect_const
tff(fact_7140_open__Collect__disj,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o),Q: fun(A,$o)] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),P))
         => ( aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),Q))
           => aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_alg(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q))) ) ) ) ).

% open_Collect_disj
tff(fact_7141_open__Collect__conj,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o),Q: fun(A,$o)] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),P))
         => ( aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),Q))
           => aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_alh(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q))) ) ) ) ).

% open_Collect_conj
tff(fact_7142_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( topolo8458572112393995274pology(A)
     => ! [A3: set(A),X2: A] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),A3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),X4) )
           => ~ aa(set(A),$o,member(A,aa(set(A),A,complete_Inf_Inf(A),A3)),A3) ) ) ) ).

% Inf_notin_open
tff(fact_7143_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( topolo8458572112393995274pology(A)
     => ! [A3: set(A),X2: A] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),A3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),X2) )
           => ~ aa(set(A),$o,member(A,aa(set(A),A,complete_Sup_Sup(A),A3)),A3) ) ) ) ).

% Sup_notin_open
tff(fact_7144_open__left,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S3: set(A),X2: A,Y2: A] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),S3)
         => ( aa(set(A),$o,member(A,X2),S3)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
             => ? [B3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B3),X2)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,B3,X2)),S3) ) ) ) ) ) ).

% open_left
tff(fact_7145_Lim__ident__at,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X2: A,S: set(A)] :
          ( ( topolo174197925503356063within(A,X2,S) != bot_bot(filter(A)) )
         => ( topolo3827282254853284352ce_Lim(A,A,topolo174197925503356063within(A,X2,S),aTP_Lamp_aek(A,A)) = X2 ) ) ) ).

% Lim_ident_at
tff(fact_7146_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => ( ( aa(A,B,G,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,B),fun(A,B),aTP_Lamp_ahu(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ) ).

% continuous_divide
tff(fact_7147_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( ( aa(A,B,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_ahx(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_inverse
tff(fact_7148_continuous__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
        <=> filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A)))),F4) ) ) ).

% continuous_def
tff(fact_7149_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( ( aa(A,B,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_ahy(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_sgn
tff(fact_7150_t2__space__class_OLim__def,axiom,
    ! [A: $tType,B: $tType] :
      ( topological_t2_space(A)
     => ! [A3: filter(B),F3: fun(B,A)] : ( topolo3827282254853284352ce_Lim(B,A,A3,F3) = the(A,aa(fun(B,A),fun(A,$o),aTP_Lamp_ali(filter(B),fun(fun(B,A),fun(A,$o)),A3),F3)) ) ) ).

% t2_space_class.Lim_def
tff(fact_7151_continuous__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => ( topolo3448309680560233919inuous(A,real,F4,G)
           => ( ( aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,F4,aa(fun(A,real),fun(A,real),aTP_Lamp_ajb(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% continuous_powr
tff(fact_7152_continuous__ln,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => ( ( aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_ajc(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_ln
tff(fact_7153_suminf__eq__lim,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A)] : ( suminf(A,F3) = topolo3827282254853284352ce_Lim(nat,A,at_top(nat),aTP_Lamp_akf(fun(nat,A),fun(nat,A),F3)) ) ) ).

% suminf_eq_lim
tff(fact_7154_lim__def,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X7: fun(nat,A)] : ( topolo3827282254853284352ce_Lim(nat,A,at_top(nat),X7) = the(A,aTP_Lamp_alj(fun(nat,A),fun(A,$o),X7)) ) ) ).

% lim_def
tff(fact_7155_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F4: filter(A),F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,F4,F3)
         => ( ( cos(A,aa(A,A,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_alk(A,A)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,F4,aTP_Lamp_agl(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_tan
tff(fact_7156_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F4: filter(A),F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,F4,F3)
         => ( ( sin(A,aa(A,A,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_alk(A,A)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,F4,aTP_Lamp_ahc(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_cot
tff(fact_7157_continuous__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F4: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( ( cosh(B,aa(A,B,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A)))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F4,aTP_Lamp_aid(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_tanh
tff(fact_7158_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))))
           => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_all(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_arcosh
tff(fact_7159_tendsto__offset__zero__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C)
        & zero(A) )
     => ! [A2: B,S3: set(B),F3: fun(B,C),L4: C] :
          ( nO_MATCH(A,B,zero_zero(A),A2)
         => ( aa(set(B),$o,member(B,A2),S3)
           => ( aa(set(B),$o,topolo1002775350975398744n_open(B),S3)
             => ( filterlim(B,C,F3,topolo7230453075368039082e_nhds(C,L4),topolo174197925503356063within(B,A2,S3))
              <=> filterlim(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_adt(B,fun(fun(B,C),fun(B,C)),A2),F3),topolo7230453075368039082e_nhds(C,L4),topolo174197925503356063within(B,zero_zero(B),top_top(set(B)))) ) ) ) ) ) ).

% tendsto_offset_zero_iff
tff(fact_7160_continuous__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => ( topolo3448309680560233919inuous(A,real,F4,G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))))
             => ( ( aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A))))
                 => topolo3448309680560233919inuous(A,real,F4,aa(fun(A,real),fun(A,real),aTP_Lamp_ajw(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ) ) ).

% continuous_log
tff(fact_7161_continuous__artanh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => ( aa(set(real),$o,member(real,aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F4,aTP_Lamp_aek(A,A)))),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)))
           => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_alm(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_artanh
tff(fact_7162_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [E2: real,F8: fun(A,B),S: set(A),X2: A,F3: fun(A,B),H5: fun(A,real)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
         => ( real_V3181309239436604168linear(A,B,F8)
           => ( ! [Y4: A] :
                  ( aa(set(A),$o,member(A,Y4),S)
                 => ( ( Y4 != X2 )
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y4,X2)),E2)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,Y4)),aa(A,B,F3,X2))),aa(A,B,F8,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),X2))))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),X2)))),aa(A,real,H5,Y4)) ) ) )
             => ( filterlim(A,real,H5,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,X2,S))
               => has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S)) ) ) ) ) ) ).

% has_derivativeI_sandwich
tff(fact_7163_tendsto__exp__limit__at__right,axiom,
    ! [X2: real] : filterlim(real,real,aTP_Lamp_aln(real,fun(real,real),X2),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X2)),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ).

% tendsto_exp_limit_at_right
tff(fact_7164_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I3: A,K: A] :
          ( aa(set(A),$o,member(A,I3),aa(A,set(A),set_ord_greaterThan(A),K))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),I3) ) ) ).

% greaterThan_iff
tff(fact_7165_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) = real_V557655796197034286t_dist(A,B2,C2) ) ) ).

% dist_add_cancel
tff(fact_7166_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [B2: A,A2: A,C2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)) = real_V557655796197034286t_dist(A,B2,C2) ) ) ).

% dist_add_cancel2
tff(fact_7167_dist__self,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A] : ( real_V557655796197034286t_dist(A,X2,X2) = zero_zero(real) ) ) ).

% dist_self
tff(fact_7168_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A,Y2: A] :
          ( ( real_V557655796197034286t_dist(A,X2,Y2) = zero_zero(real) )
        <=> ( X2 = Y2 ) ) ) ).

% dist_eq_0_iff
tff(fact_7169_dist__0__norm,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] : ( real_V557655796197034286t_dist(A,zero_zero(A),X2) = real_V7770717601297561774m_norm(A,X2) ) ) ).

% dist_0_norm
tff(fact_7170_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A,Y2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X2,Y2))
        <=> ( X2 != Y2 ) ) ) ).

% zero_less_dist_iff
tff(fact_7171_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A,Y2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,X2,Y2)),zero_zero(real))
        <=> ( X2 = Y2 ) ) ) ).

% dist_le_zero_iff
tff(fact_7172_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),top_top(A))
         => ( aa(set(A),A,complete_Sup_Sup(A),aa(A,set(A),set_ord_greaterThan(A),X2)) = top_top(A) ) ) ) ).

% Sup_greaterThanAtLeast
tff(fact_7173_dist__scaleR,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: real,A2: A,Y2: real] : ( real_V557655796197034286t_dist(A,aa(A,A,real_V8093663219630862766scaleR(A,X2),A2),aa(A,A,real_V8093663219630862766scaleR(A,Y2),A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X2),Y2))),real_V7770717601297561774m_norm(A,A2)) ) ) ).

% dist_scaleR
tff(fact_7174_open__ball,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A,D2: real] : aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),aa(real,fun(A,$o),aTP_Lamp_alo(A,fun(real,fun(A,$o)),X2),D2))) ) ).

% open_ball
tff(fact_7175_open__dist,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S3: set(A)] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),S3)
        <=> ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),S3)
             => ? [E3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
                  & ! [Y: A] :
                      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y,X3)),E3)
                     => aa(set(A),$o,member(A,Y),S3) ) ) ) ) ) ).

% open_dist
tff(fact_7176_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Y2: A,X2: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y2,X2)),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X2,Y2)),E2) ) ) ).

% dist_commute_lessI
tff(fact_7177_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A] : ( aa(A,set(A),set_ord_greaterThan(A),L) = aa(fun(A,$o),set(A),collect(A),aa(A,fun(A,$o),ord_less(A),L)) ) ) ).

% greaterThan_def
tff(fact_7178_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A,Y2: A] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X2,Y2)),zero_zero(real)) ) ).

% dist_not_less_zero
tff(fact_7179_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X2,Y2)) ) ) ).

% dist_pos_lt
tff(fact_7180_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,Y2: A,E1: real,X22: A,E22: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,Y2)),E1)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X22,Y2)),E22)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X22)),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22)) ) ) ) ).

% dist_triangle_less_add
tff(fact_7181_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A,Z: A,Y2: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,X2,Z)),real_V557655796197034286t_dist(A,Y2,Z))),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X2,Y2)),E2) ) ) ).

% dist_triangle_lt
tff(fact_7182_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X2: A] : ( real_V7770717601297561774m_norm(A,X2) = real_V557655796197034286t_dist(A,X2,zero_zero(A)) ) ) ).

% norm_conv_dist
tff(fact_7183_zero__le__dist,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A,Y2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),real_V557655796197034286t_dist(A,X2,Y2)) ) ).

% zero_le_dist
tff(fact_7184_continuous__dist,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => topolo3448309680560233919inuous(A,real,F4,aa(fun(A,B),fun(A,real),aTP_Lamp_alp(fun(A,B),fun(fun(A,B),fun(A,real)),F3),G)) ) ) ) ).

% continuous_dist
tff(fact_7185_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( topolo174197925503356063within(A,A2,set_or1337092689740270186AtMost(A,A2,B2)) = topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2)) ) ) ) ).

% at_within_Icc_at_right
tff(fact_7186_filterlim__at__left__to__right,axiom,
    ! [A: $tType,F3: fun(real,A),F4: filter(A),A2: real] :
      ( filterlim(real,A,F3,F4,topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
    <=> filterlim(real,A,aTP_Lamp_alq(fun(real,A),fun(real,A),F3),F4,topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),A2),aa(real,set(real),set_ord_greaterThan(real),aa(real,real,uminus_uminus(real),A2)))) ) ).

% filterlim_at_left_to_right
tff(fact_7187_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),F8: A,A2: A,S3: set(A),D2: real,G: fun(A,A)] :
          ( has_field_derivative(A,F3,F8,topolo174197925503356063within(A,A2,S3))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( aa(set(A),$o,member(A,A2),S3)
             => ( ! [X4: A] :
                    ( aa(set(A),$o,member(A,X4),S3)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),D2)
                     => ( aa(A,A,F3,X4) = aa(A,A,G,X4) ) ) )
               => has_field_derivative(A,G,F8,topolo174197925503356063within(A,A2,S3)) ) ) ) ) ) ).

% has_field_derivative_transform_within
tff(fact_7188_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S: set(A),D2: real,G: fun(A,B)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( aa(set(A),$o,member(A,X2),S)
             => ( ! [X10: A] :
                    ( aa(set(A),$o,member(A,X10),S)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X10,X2)),D2)
                     => ( aa(A,B,F3,X10) = aa(A,B,G,X10) ) ) )
               => has_derivative(A,B,G,F8,topolo174197925503356063within(A,X2,S)) ) ) ) ) ) ).

% has_derivative_transform_within
tff(fact_7189_Cauchy__def,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M8: nat] :
                ! [M4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M4)
                 => ! [N4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N4)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M4),aa(nat,A,X7,N4))),E3) ) ) ) ) ) ).

% Cauchy_def
tff(fact_7190_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,S)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [N5: nat] :
                ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N5),N4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,S,N4),aa(nat,A,S,N5))),E3) ) ) ) ) ).

% Cauchy_altdef2
tff(fact_7191_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),E2: real] :
          ( topolo3814608138187158403Cauchy(A,X7)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
           => ? [M7: nat] :
              ! [M: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M)
               => ! [N8: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),N8)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M),aa(nat,A,X7,N8))),E2) ) ) ) ) ) ).

% metric_CauchyD
tff(fact_7192_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M3)
                 => ! [N: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),N)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M3),aa(nat,A,X7,N))),E) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% metric_CauchyI
tff(fact_7193_less__separate,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ? [A4: A,B3: A] :
              ( aa(set(A),$o,member(A,X2),aa(A,set(A),set_ord_lessThan(A),A4))
              & aa(set(A),$o,member(A,Y2),aa(A,set(A),set_ord_greaterThan(A),B3))
              & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_lessThan(A),A4)),aa(A,set(A),set_ord_greaterThan(A),B3)) = bot_bot(set(A)) ) ) ) ) ).

% less_separate
tff(fact_7194_tendsto__dist,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A),G: fun(A,B),Ma: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,Ma),F4)
           => filterlim(A,real,aa(fun(A,B),fun(A,real),aTP_Lamp_alr(fun(A,B),fun(fun(A,B),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,real_V557655796197034286t_dist(B,L,Ma)),F4) ) ) ) ).

% tendsto_dist
tff(fact_7195_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F3: fun(real,A),F4: filter(A),A2: real] :
      ( filterlim(real,A,F3,F4,topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
    <=> filterlim(real,A,aa(real,fun(real,A),aTP_Lamp_als(fun(real,A),fun(real,fun(real,A)),F3),A2),F4,topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ) ).

% filterlim_at_right_to_0
tff(fact_7196_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),L: B,X2: A,S3: set(A),D2: real,G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,X2,S3))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( ! [X10: A] :
                  ( aa(set(A),$o,member(A,X10),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X10,X2))
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X10,X2)),D2)
                     => ( aa(A,B,F3,X10) = aa(A,B,G,X10) ) ) ) )
             => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,X2,S3)) ) ) ) ) ).

% Lim_transform_within
tff(fact_7197_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,Y2: A,E2: real,X22: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X22,Y2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X22)),E2) ) ) ) ).

% dist_triangle_half_l
tff(fact_7198_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Y2: A,X15: A,E2: real,X22: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y2,X15)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y2,X22)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X22)),E2) ) ) ) ).

% dist_triangle_half_r
tff(fact_7199_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,X22: A,E2: real,X32: A,X42: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X22)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X22,X32)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X32,X42)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))))
             => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X42)),E2) ) ) ) ) ).

% dist_triangle_third
tff(fact_7200_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [G: fun(A,B),G3: filter(B),X2: A,S3: set(A),F4: filter(B),D2: real,F3: fun(A,B)] :
          ( filterlim(A,B,G,G3,topolo174197925503356063within(A,X2,S3))
         => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),G3),F4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
             => ( ! [X10: A] :
                    ( aa(set(A),$o,member(A,X10),S3)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X10,X2))
                     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X10,X2)),D2)
                       => ( aa(A,B,F3,X10) = aa(A,B,G,X10) ) ) ) )
               => filterlim(A,B,F3,F4,topolo174197925503356063within(A,X2,S3)) ) ) ) ) ) ).

% filterlim_transform_within
tff(fact_7201_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [F3: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,F3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M8: nat] :
                ! [M4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M4)
                 => ! [N4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N4)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,F3,M4),aa(nat,A,F3,N4))),E3) ) ) ) ) ) ).

% Cauchy_altdef
tff(fact_7202_CauchyI_H,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M3)
                 => ! [N: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M3),aa(nat,A,X7,N))),E) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% CauchyI'
tff(fact_7203_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
        <=> filterlim(A,real,aa(B,fun(A,real),aTP_Lamp_alt(fun(A,B),fun(B,fun(A,real)),F3),L),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ) ).

% tendsto_dist_iff
tff(fact_7204_filterlim__times__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field(B)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),P2: B,F12: filter(A),C2: B,L: B] :
          ( filterlim(A,B,F3,topolo174197925503356063within(B,P2,aa(B,set(B),set_ord_greaterThan(B),P2)),F12)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => ( ( L = aa(B,B,aa(B,fun(B,B),times_times(B),C2),P2) )
             => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_alu(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo174197925503356063within(B,L,aa(B,set(B),set_ord_greaterThan(B),L)),F12) ) ) ) ) ).

% filterlim_times_pos
tff(fact_7205_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F3: fun(A,B),L4: B,A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S5)
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),S5) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,X3),L4)),R5) ) ) ) ) ) ).

% LIM_def
tff(fact_7206_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F3: fun(A,B),L4: B,A2: A,R: real] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => ? [S2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S2)
                & ! [X: A] :
                    ( ( ( X != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,A2)),S2) )
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,X),L4)),R) ) ) ) ) ) ).

% metric_LIM_D
tff(fact_7207_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [A2: A,F3: fun(A,B),L4: B] :
          ( ! [R2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
             => ? [S6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S6)
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),S6) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,X4),L4)),R2) ) ) )
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% metric_LIM_I
tff(fact_7208_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [G: fun(A,B),L: B,A2: A,R3: real,F3: fun(A,B)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R3)
           => ( ! [X4: A] :
                  ( ( X4 != A2 )
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),R3)
                   => ( aa(A,B,F3,X4) = aa(A,B,G,X4) ) ) )
             => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_LIM_equal2
tff(fact_7209_lim__sequentially,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No4: nat] :
                ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No4),N4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N4),L4)),R5) ) ) ) ) ).

% lim_sequentially
tff(fact_7210_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( ! [R2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
             => ? [No3: nat] :
                ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No3),N)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N),L4)),R2) ) )
         => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat)) ) ) ).

% metric_LIMSEQ_I
tff(fact_7211_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L4: A,R: real] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => ? [No2: nat] :
              ! [N8: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No2),N8)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N8),L4)),R) ) ) ) ) ).

% metric_LIMSEQ_D
tff(fact_7212_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [J4: nat] :
            ? [M8: nat] :
            ! [M4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M4)
             => ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M4),aa(nat,A,X7,N4))),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,J4)))) ) ) ) ) ).

% metric_Cauchy_iff2
tff(fact_7213_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F3: fun(A,B),B2: B,A2: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( ? [D6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),D6) )
                     => ( aa(A,B,F3,X4) != B2 ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_alv(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_LIM_compose2
tff(fact_7214_tendsto__arcosh__at__left__1,axiom,
    filterlim(real,real,arcosh(real),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,one_one(real),aa(real,set(real),set_ord_greaterThan(real),one_one(real)))) ).

% tendsto_arcosh_at_left_1
tff(fact_7215_metric__isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A2: A,F3: fun(A,B),G: fun(B,C),L: C] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(B,aa(A,B,F3,A2),top_top(set(B))))
           => ( ? [D6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),D6) )
                     => ( aa(A,B,F3,X4) != aa(A,B,F3,A2) ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_alv(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_isCont_LIM_compose2
tff(fact_7216_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,G: fun(A,B),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_lessThan(A),A2)),G)
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,G,A2)),topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2)))
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_alw(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A2),G),F3)) ) ) ) ).

% isCont_If_ge
tff(fact_7217_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),No4)
                  & ! [N4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No4),N4)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N4),L4)),R5) ) ) ) ) ) ).

% LIMSEQ_iff_nz
tff(fact_7218_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S3: set(A)] :
          ( topolo6688025880775521714ounded(A,S3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [K3: set(A)] :
                  ( finite_finite2(A,K3)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(A),set(set(A)),image(A,set(A),aTP_Lamp_aly(real,fun(A,set(A)),E3)),K3))) ) ) ) ) ).

% totally_bounded_metric
tff(fact_7219_at__within__order,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X2: A,S: set(A)] :
          ( ( top_top(set(A)) != aa(set(A),set(A),insert(A,X2),bot_bot(set(A))) )
         => ( topolo174197925503356063within(A,X2,S) = aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_alz(A,fun(set(A),fun(A,filter(A))),X2),S)),aa(A,set(A),set_ord_greaterThan(A),X2)))),aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_ama(A,fun(set(A),fun(A,filter(A))),X2),S)),aa(A,set(A),set_ord_lessThan(A),X2)))) ) ) ) ).

% at_within_order
tff(fact_7220_SUP__principal,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),I5: set(B)] : ( aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),aa(set(B),set(filter(A)),image(B,filter(A),aTP_Lamp_amb(fun(B,set(A)),fun(B,filter(A)),A3)),I5)) = aa(set(A),filter(A),principal(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))) ) ).

% SUP_principal
tff(fact_7221_filterlim__If,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),G3: filter(B),F4: filter(A),P: fun(A,$o),G: fun(A,B)] :
      ( filterlim(A,B,F3,G3,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F4),aa(set(A),filter(A),principal(A),aa(fun(A,$o),set(A),collect(A),P))))
     => ( filterlim(A,B,G,G3,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F4),aa(set(A),filter(A),principal(A),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ed(fun(A,$o),fun(A,$o),P)))))
       => filterlim(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,$o),fun(fun(A,B),fun(A,B)),aTP_Lamp_amc(fun(A,B),fun(fun(A,$o),fun(fun(A,B),fun(A,B))),F3),P),G),G3,F4) ) ) ).

% filterlim_If
tff(fact_7222_nhds__def,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [A2: A] : ( topolo7230453075368039082e_nhds(A,A2) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(set(A)),set(filter(A)),image(set(A),filter(A),principal(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_amd(A,fun(set(A),$o),A2)))) ) ) ).

% nhds_def
tff(fact_7223_filterlim__base,axiom,
    ! [B: $tType,A: $tType,E4: $tType,D: $tType,C: $tType,J5: set(A),I3: fun(A,C),I5: set(C),F4: fun(C,set(D)),F3: fun(D,E4),G3: fun(A,set(E4))] :
      ( ! [M3: A,X4: B] :
          ( aa(set(A),$o,member(A,M3),J5)
         => aa(set(C),$o,member(C,aa(A,C,I3,M3)),I5) )
     => ( ! [M3: A,X4: D] :
            ( aa(set(A),$o,member(A,M3),J5)
           => ( aa(set(D),$o,member(D,X4),aa(C,set(D),F4,aa(A,C,I3,M3)))
             => aa(set(E4),$o,member(E4,aa(D,E4,F3,X4)),aa(A,set(E4),G3,M3)) ) )
       => filterlim(D,E4,F3,aa(set(filter(E4)),filter(E4),complete_Inf_Inf(filter(E4)),aa(set(A),set(filter(E4)),image(A,filter(E4),aTP_Lamp_ame(fun(A,set(E4)),fun(A,filter(E4)),G3)),J5)),aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(C),set(filter(D)),image(C,filter(D),aTP_Lamp_amf(fun(C,set(D)),fun(C,filter(D)),F4)),I5))) ) ) ).

% filterlim_base
tff(fact_7224_INT__greaterThan__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image(nat,set(nat),set_ord_greaterThan(nat)),top_top(set(nat)))) = bot_bot(set(nat)) ).

% INT_greaterThan_UNIV
tff(fact_7225_greaterThan__0,axiom,
    aa(nat,set(nat),set_ord_greaterThan(nat),zero_zero(nat)) = aa(set(nat),set(nat),image(nat,nat,suc),top_top(set(nat))) ).

% greaterThan_0
tff(fact_7226_greaterThan__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_greaterThan(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_greaterThan(nat),K)),aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,K)),bot_bot(set(nat)))) ) ).

% greaterThan_Suc
tff(fact_7227_filterlim__base__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,I5: set(A),F4: fun(A,set(B)),F3: fun(B,C),G3: fun(D,set(C)),J5: set(D)] :
      ( ( I5 != bot_bot(set(A)) )
     => ( ! [I2: A] :
            ( aa(set(A),$o,member(A,I2),I5)
           => ! [J: A] :
                ( aa(set(A),$o,member(A,J),I5)
               => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F4,I2)),aa(A,set(B),F4,J))
                  | aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F4,J)),aa(A,set(B),F4,I2)) ) ) )
       => ( filterlim(B,C,F3,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(D),set(filter(C)),image(D,filter(C),aTP_Lamp_amg(fun(D,set(C)),fun(D,filter(C)),G3)),J5)),aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),aTP_Lamp_amh(fun(A,set(B)),fun(A,filter(B)),F4)),I5)))
        <=> ! [X3: D] :
              ( aa(set(D),$o,member(D,X3),J5)
             => ? [Xa: A] :
                  ( aa(set(A),$o,member(A,Xa),I5)
                  & ! [Xb4: B] :
                      ( aa(set(B),$o,member(B,Xb4),aa(A,set(B),F4,Xa))
                     => aa(set(C),$o,member(C,aa(B,C,F3,Xb4)),aa(D,set(C),G3,X3)) ) ) ) ) ) ) ).

% filterlim_base_iff
tff(fact_7228_INF__principal__finite,axiom,
    ! [B: $tType,A: $tType,X7: set(A),F3: fun(A,set(B))] :
      ( finite_finite2(A,X7)
     => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),aTP_Lamp_amh(fun(A,set(B)),fun(A,filter(B)),F3)),X7)) = aa(set(B),filter(B),principal(B),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),F3),X7))) ) ) ).

% INF_principal_finite
tff(fact_7229_nhds__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X2: A] : ( topolo7230453075368039082e_nhds(A,X2) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(real),set(filter(A)),image(real,filter(A),aTP_Lamp_amj(A,fun(real,filter(A)),X2)),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ) ) ).

% nhds_metric
tff(fact_7230_at__left__eq,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Y2: A,X2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( topolo174197925503356063within(A,X2,aa(A,set(A),set_ord_lessThan(A),X2)) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aTP_Lamp_amk(A,fun(A,filter(A)),X2)),aa(A,set(A),set_ord_lessThan(A),X2))) ) ) ) ).

% at_left_eq
tff(fact_7231_at__right__eq,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( topolo174197925503356063within(A,X2,aa(A,set(A),set_ord_greaterThan(A),X2)) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aTP_Lamp_aml(A,fun(A,filter(A)),X2)),aa(A,set(A),set_ord_greaterThan(A),X2))) ) ) ) ).

% at_right_eq
tff(fact_7232_nhds__order,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [X2: A] : ( topolo7230453075368039082e_nhds(A,X2) = aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aTP_Lamp_amm(A,filter(A))),aa(A,set(A),set_ord_greaterThan(A),X2)))),aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aTP_Lamp_amn(A,filter(A))),aa(A,set(A),set_ord_lessThan(A),X2)))) ) ) ).

% nhds_order
tff(fact_7233_at__within__eq,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [X2: A,S: set(A)] : ( topolo174197925503356063within(A,X2,S) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(set(A)),set(filter(A)),image(set(A),filter(A),aa(set(A),fun(set(A),filter(A)),aTP_Lamp_amo(A,fun(set(A),fun(set(A),filter(A))),X2),S)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_amd(A,fun(set(A),$o),X2)))) ) ) ).

% at_within_eq
tff(fact_7234_filterlim__tan__at__right,axiom,
    filterlim(real,real,tan(real),at_bot(real),topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(real,set(real),set_ord_greaterThan(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))))) ).

% filterlim_tan_at_right
tff(fact_7235_tendsto__arctan__at__bot,axiom,
    filterlim(real,real,arctan,topolo7230453075368039082e_nhds(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),at_bot(real)) ).

% tendsto_arctan_at_bot
tff(fact_7236_exp__at__bot,axiom,
    filterlim(real,real,exp(real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_bot(real)) ).

% exp_at_bot
tff(fact_7237_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F4)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_bot(real),F4)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amp(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_bot(real),F4) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
tff(fact_7238_ln__at__0,axiom,
    filterlim(real,real,ln_ln(real),at_bot(real),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ).

% ln_at_0
tff(fact_7239_tendsto__at__botI__sequentially,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [F3: fun(real,A),Y2: A] :
          ( ! [X9: fun(nat,real)] :
              ( filterlim(nat,real,X9,at_bot(real),at_top(nat))
             => filterlim(nat,A,aa(fun(nat,real),fun(nat,A),aTP_Lamp_amq(fun(real,A),fun(fun(nat,real),fun(nat,A)),F3),X9),topolo7230453075368039082e_nhds(A,Y2),at_top(nat)) )
         => filterlim(real,A,F3,topolo7230453075368039082e_nhds(A,Y2),at_bot(real)) ) ) ).

% tendsto_at_botI_sequentially
tff(fact_7240_filterlim__inverse__at__bot__neg,axiom,
    filterlim(real,real,inverse_inverse(real),at_bot(real),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_lessThan(real),zero_zero(real)))) ).

% filterlim_inverse_at_bot_neg
tff(fact_7241_at__bot__sub,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : ( at_bot(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aTP_Lamp_amr(A,filter(A))),aa(A,set(A),set_ord_atMost(A),C2))) ) ) ).

% at_bot_sub
tff(fact_7242_at__bot__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ( at_bot(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aTP_Lamp_ams(A,filter(A))),top_top(set(A)))) ) ) ).

% at_bot_def
tff(fact_7243_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F3: fun(real,real),Flim: real] :
      ( ! [X4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2)
         => ? [Y3: real] :
              ( has_field_derivative(real,F3,Y3,topolo174197925503356063within(real,X4,top_top(set(real))))
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y3) ) )
     => ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,Flim),at_bot(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),Flim),aa(real,real,F3,B2)) ) ) ).

% DERIV_pos_imp_increasing_at_bot
tff(fact_7244_filterlim__pow__at__bot__odd,axiom,
    ! [Nb: nat,F3: fun(real,real),F4: filter(real)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( filterlim(real,real,F3,at_bot(real),F4)
       => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_amt(nat,fun(fun(real,real),fun(real,real)),Nb),F3),at_bot(real),F4) ) ) ) ).

% filterlim_pow_at_bot_odd
tff(fact_7245_Gcd__eq__Max,axiom,
    ! [M6: set(nat)] :
      ( finite_finite2(nat,M6)
     => ( ( M6 != bot_bot(set(nat)) )
       => ( ~ aa(set(nat),$o,member(nat,zero_zero(nat)),M6)
         => ( gcd_Gcd(nat,M6) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image(nat,set(nat),aTP_Lamp_amu(nat,set(nat))),M6))) ) ) ) ) ).

% Gcd_eq_Max
tff(fact_7246_filterlim__pow__at__bot__even,axiom,
    ! [Nb: nat,F3: fun(real,real),F4: filter(real)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( filterlim(real,real,F3,at_bot(real),F4)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Nb)
         => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_amt(nat,fun(fun(real,real),fun(real,real)),Nb),F3),at_top(real),F4) ) ) ) ).

% filterlim_pow_at_bot_even
tff(fact_7247_Max__divisors__self__nat,axiom,
    ! [Nb: nat] :
      ( ( Nb != zero_zero(nat) )
     => ( aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_oc(nat,fun(nat,$o),Nb))) = Nb ) ) ).

% Max_divisors_self_nat
tff(fact_7248_Max__less__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( finite_finite2(A,A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),X2)
            <=> ! [X3: A] :
                  ( aa(set(A),$o,member(A,X3),A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),X2) ) ) ) ) ) ).

% Max_less_iff
tff(fact_7249_Max__const,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(B)
     => ! [A3: set(A),C2: B] :
          ( finite_finite2(A,A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(A),set(B),image(A,B,aTP_Lamp_amv(B,fun(A,B),C2)),A3)) = C2 ) ) ) ) ).

% Max_const
tff(fact_7250_sqrt__at__top,axiom,
    filterlim(real,real,sqrt,at_top(real),at_top(real)) ).

% sqrt_at_top
tff(fact_7251_ln__at__top,axiom,
    filterlim(real,real,ln_ln(real),at_top(real),at_top(real)) ).

% ln_at_top
tff(fact_7252_exp__at__top,axiom,
    filterlim(real,real,exp(real),at_top(real),at_top(real)) ).

% exp_at_top
tff(fact_7253_filterlim__at__top__add__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,at_top(real),F4)
     => ( filterlim(A,real,G,at_top(real),F4)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amw(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F4) ) ) ).

% filterlim_at_top_add_at_top
tff(fact_7254_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,at_top(real),F4)
     => ( filterlim(A,real,G,at_top(real),F4)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amp(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F4) ) ) ).

% filterlim_at_top_mult_at_top
tff(fact_7255_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X2: A] :
          ( finite_finite2(A,A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(set(A),A,lattic643756798349783984er_Max(A),A3))
            <=> ? [X3: A] :
                  ( aa(set(A),$o,member(A,X3),A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),X3) ) ) ) ) ) ).

% Max_gr_iff
tff(fact_7256_filterlim__tendsto__add__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F4)
     => ( filterlim(A,real,G,at_top(real),F4)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amw(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F4) ) ) ).

% filterlim_tendsto_add_at_top
tff(fact_7257_filterlim__real__sequentially,axiom,
    filterlim(nat,real,semiring_1_of_nat(real),at_top(real),at_top(nat)) ).

% filterlim_real_sequentially
tff(fact_7258_filterlim__uminus__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,F3,at_bot(real),F4)
    <=> filterlim(A,real,aTP_Lamp_amx(fun(A,real),fun(A,real),F3),at_top(real),F4) ) ).

% filterlim_uminus_at_bot
tff(fact_7259_filterlim__uminus__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,F3,at_top(real),F4)
    <=> filterlim(A,real,aTP_Lamp_amx(fun(A,real),fun(A,real),F3),at_bot(real),F4) ) ).

% filterlim_uminus_at_top
tff(fact_7260_filterlim__at__bot__mirror,axiom,
    ! [A: $tType,F3: fun(real,A),F4: filter(A)] :
      ( filterlim(real,A,F3,F4,at_bot(real))
    <=> filterlim(real,A,aTP_Lamp_alq(fun(real,A),fun(real,A),F3),F4,at_top(real)) ) ).

% filterlim_at_bot_mirror
tff(fact_7261_filterlim__at__top__mirror,axiom,
    ! [A: $tType,F3: fun(real,A),F4: filter(A)] :
      ( filterlim(real,A,F3,F4,at_top(real))
    <=> filterlim(real,A,aTP_Lamp_alq(fun(real,A),fun(real,A),F3),F4,at_bot(real)) ) ).

% filterlim_at_top_mirror
tff(fact_7262_filterlim__uminus__at__bot__at__top,axiom,
    filterlim(real,real,uminus_uminus(real),at_bot(real),at_top(real)) ).

% filterlim_uminus_at_bot_at_top
tff(fact_7263_filterlim__uminus__at__top__at__bot,axiom,
    filterlim(real,real,uminus_uminus(real),at_top(real),at_bot(real)) ).

% filterlim_uminus_at_top_at_bot
tff(fact_7264_filterlim__pow__at__top,axiom,
    ! [A: $tType,Nb: nat,F3: fun(A,real),F4: filter(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( filterlim(A,real,F3,at_top(real),F4)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_adp(nat,fun(fun(A,real),fun(A,real)),Nb),F3),at_top(real),F4) ) ) ).

% filterlim_pow_at_top
tff(fact_7265_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F4)
     => ( filterlim(A,real,G,at_top(real),F4)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amy(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ) ).

% real_tendsto_divide_at_top
tff(fact_7266_card__le__Suc__Max,axiom,
    ! [S3: set(nat)] :
      ( finite_finite2(nat,S3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(nat,S3)),aa(nat,nat,suc,aa(set(nat),nat,lattic643756798349783984er_Max(nat),S3))) ) ).

% card_le_Suc_Max
tff(fact_7267_Sup__nat__def,axiom,
    ! [X7: set(nat)] :
      ( aa(set(nat),nat,complete_Sup_Sup(nat),X7)
      = $ite(X7 = bot_bot(set(nat)),zero_zero(nat),aa(set(nat),nat,lattic643756798349783984er_Max(nat),X7)) ) ).

% Sup_nat_def
tff(fact_7268_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,F3,at_top(real),F4)
     => filterlim(A,real,aTP_Lamp_amz(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ).

% tendsto_inverse_0_at_top
tff(fact_7269_divide__nat__def,axiom,
    ! [Ma: nat,Nb: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Ma),Nb)
      = $ite(Nb = zero_zero(nat),zero_zero(nat),aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_ana(nat,fun(nat,fun(nat,$o)),Ma),Nb)))) ) ).

% divide_nat_def
tff(fact_7270_Max__add__commute,axiom,
    ! [A: $tType,B: $tType] :
      ( linord4140545234300271783up_add(B)
     => ! [S3: set(A),F3: fun(A,B),K: B] :
          ( finite_finite2(A,S3)
         => ( ( S3 != bot_bot(set(A)) )
           => ( aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(A),set(B),image(A,B,aa(B,fun(A,B),aTP_Lamp_anb(fun(A,B),fun(B,fun(A,B)),F3),K)),S3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(A),set(B),image(A,B,F3),S3))),K) ) ) ) ) ).

% Max_add_commute
tff(fact_7271_gcd__is__Max__divisors__nat,axiom,
    ! [Nb: nat,Ma: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Ma),Nb) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_anc(nat,fun(nat,fun(nat,$o)),Nb),Ma))) ) ) ).

% gcd_is_Max_divisors_nat
tff(fact_7272_filterlim__sequentially__iff__filterlim__real,axiom,
    ! [A: $tType,F3: fun(A,nat),F4: filter(A)] :
      ( filterlim(A,nat,F3,at_top(nat),F4)
    <=> filterlim(A,real,aTP_Lamp_and(fun(A,nat),fun(A,real),F3),at_top(real),F4) ) ).

% filterlim_sequentially_iff_filterlim_real
tff(fact_7273_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F4)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_top(real),F4)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ane(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F4) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
tff(fact_7274_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F4)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_top(real),F4)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amp(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F4) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
tff(fact_7275_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F3: fun(A,real),F4: filter(A)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),S),zero_zero(real))
     => ( filterlim(A,real,F3,at_top(real),F4)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_anf(real,fun(fun(A,real),fun(A,real)),S),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ) ).

% tendsto_neg_powr
tff(fact_7276_ln__x__over__x__tendsto__0,axiom,
    filterlim(real,real,aTP_Lamp_ang(real,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(real)) ).

% ln_x_over_x_tendsto_0
tff(fact_7277_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F3: fun(real,A),F4: filter(A)] :
      ( filterlim(real,A,F3,F4,at_top(real))
    <=> filterlim(real,A,aTP_Lamp_anh(fun(real,A),fun(real,A),F3),F4,topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ) ).

% filterlim_at_top_to_right
tff(fact_7278_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F3: fun(real,A),F4: filter(A)] :
      ( filterlim(real,A,F3,F4,topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
    <=> filterlim(real,A,aTP_Lamp_anh(fun(real,A),fun(real,A),F3),F4,at_top(real)) ) ).

% filterlim_at_right_to_top
tff(fact_7279_filterlim__inverse__at__top__right,axiom,
    filterlim(real,real,inverse_inverse(real),at_top(real),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ).

% filterlim_inverse_at_top_right
tff(fact_7280_filterlim__inverse__at__right__top,axiom,
    filterlim(real,real,inverse_inverse(real),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))),at_top(real)) ).

% filterlim_inverse_at_right_top
tff(fact_7281_tendsto__at__topI__sequentially,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [F3: fun(real,A),Y2: A] :
          ( ! [X9: fun(nat,real)] :
              ( filterlim(nat,real,X9,at_top(real),at_top(nat))
             => filterlim(nat,A,aa(fun(nat,real),fun(nat,A),aTP_Lamp_amq(fun(real,A),fun(fun(nat,real),fun(nat,A)),F3),X9),topolo7230453075368039082e_nhds(A,Y2),at_top(nat)) )
         => filterlim(real,A,F3,topolo7230453075368039082e_nhds(A,Y2),at_top(real)) ) ) ).

% tendsto_at_topI_sequentially
tff(fact_7282_sum__le__card__Max,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( finite_finite2(A,A3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),finite_card(A,A3)),aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(set(A),set(nat),image(A,nat,F3),A3)))) ) ).

% sum_le_card_Max
tff(fact_7283_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F4)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
       => ( filterlim(A,real,G,at_top(real),F4)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amp(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_bot(real),F4) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
tff(fact_7284_tendsto__power__div__exp__0,axiom,
    ! [K: nat] : filterlim(real,real,aTP_Lamp_ani(nat,fun(real,real),K),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(real)) ).

% tendsto_power_div_exp_0
tff(fact_7285_tendsto__exp__limit__at__top,axiom,
    ! [X2: real] : filterlim(real,real,aTP_Lamp_anj(real,fun(real,real),X2),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X2)),at_top(real)) ).

% tendsto_exp_limit_at_top
tff(fact_7286_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F3: fun(real,real),Flim: real] :
      ( ! [X4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B2),X4)
         => ? [Y3: real] :
              ( has_field_derivative(real,F3,Y3,topolo174197925503356063within(real,X4,top_top(set(real))))
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),zero_zero(real)) ) )
     => ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,Flim),at_top(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),Flim),aa(real,real,F3,B2)) ) ) ).

% DERIV_neg_imp_decreasing_at_top
tff(fact_7287_tendsto__arctan__at__top,axiom,
    filterlim(real,real,arctan,topolo7230453075368039082e_nhds(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),at_top(real)) ).

% tendsto_arctan_at_top
tff(fact_7288_filterlim__tan__at__left,axiom,
    filterlim(real,real,tan(real),at_top(real),topolo174197925503356063within(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,set(real),set_ord_lessThan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))) ).

% filterlim_tan_at_left
tff(fact_7289_at__infinity__def,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( at_infinity(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(real),set(filter(A)),image(real,filter(A),aTP_Lamp_anl(real,filter(A))),top_top(set(real)))) ) ) ).

% at_infinity_def
tff(fact_7290_lhopital__left__at__top,axiom,
    ! [G: fun(real,real),X2: real,G2: fun(real,real),F3: fun(real,real),F8: fun(real,real),Y2: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
     => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),topolo7230453075368039082e_nhds(real,Y2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,Y2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2))) ) ) ) ) ) ).

% lhopital_left_at_top
tff(fact_7291_eventually__const,axiom,
    ! [A: $tType,F4: filter(A),P: $o] :
      ( ( F4 != bot_bot(filter(A)) )
     => ( eventually(A,aTP_Lamp_wn($o,fun(A,$o),P),F4)
      <=> (P) ) ) ).

% eventually_const
tff(fact_7292_Max__divisors__self__int,axiom,
    ! [Nb: int] :
      ( ( Nb != zero_zero(int) )
     => ( aa(set(int),int,lattic643756798349783984er_Max(int),aa(fun(int,$o),set(int),collect(int),aTP_Lamp_os(int,fun(int,$o),Nb))) = aa(int,int,abs_abs(int),Nb) ) ) ).

% Max_divisors_self_int
tff(fact_7293_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,F3,at_infinity(real),F4)
     => ( eventually(A,aTP_Lamp_anp(fun(A,real),fun(A,$o),F3),F4)
       => filterlim(A,real,F3,at_bot(real),F4) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
tff(fact_7294_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( unboun7993243217541854897norder(A)
     => ! [C2: A] : eventually(A,aTP_Lamp_anq(A,fun(A,$o),C2),at_bot(A)) ) ).

% eventually_gt_at_bot
tff(fact_7295_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_bot(A) )
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_bot(A))
        <=> ? [N5: A] :
            ! [N4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),N4),N5)
             => aa(A,$o,P,N4) ) ) ) ).

% eventually_at_bot_dense
tff(fact_7296_eventually__at__bot__not__equal,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_bot(A) )
     => ! [C2: A] : eventually(A,aTP_Lamp_anr(A,fun(A,$o),C2),at_bot(A)) ) ).

% eventually_at_bot_not_equal
tff(fact_7297_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : eventually(A,aa(A,fun(A,$o),aTP_Lamp_ans(A,fun(A,$o)),C2),at_bot(A)) ) ).

% eventually_le_at_bot
tff(fact_7298_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [C2: A] : eventually(A,aa(A,fun(A,$o),ord_less(A),C2),at_top(A)) ) ).

% eventually_gt_at_top
tff(fact_7299_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_top(A))
        <=> ? [N5: A] :
            ! [N4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),N5),N4)
             => aa(A,$o,P,N4) ) ) ) ).

% eventually_at_top_dense
tff(fact_7300_eventually__at__top__not__equal,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [C2: A] : eventually(A,aTP_Lamp_ant(A,fun(A,$o),C2),at_top(A)) ) ).

% eventually_at_top_not_equal
tff(fact_7301_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : eventually(A,aa(A,fun(A,$o),ord_less_eq(A),C2),at_top(A)) ) ).

% eventually_ge_at_top
tff(fact_7302_sequentially__imp__eventually__nhds__within,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [S: set(A),A2: A,P: fun(A,$o)] :
          ( ! [F5: fun(nat,A)] :
              ( ( ! [N8: nat] : aa(set(A),$o,member(A,aa(nat,A,F5,N8)),S)
                & filterlim(nat,A,F5,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) )
             => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_anu(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F5),at_top(nat)) )
         => eventually(A,P,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),topolo7230453075368039082e_nhds(A,A2)),aa(set(A),filter(A),principal(A),S))) ) ) ).

% sequentially_imp_eventually_nhds_within
tff(fact_7303_eventually__nhds__within__iff__sequentially,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [P: fun(A,$o),A2: A,S: set(A)] :
          ( eventually(A,P,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),topolo7230453075368039082e_nhds(A,A2)),aa(set(A),filter(A),principal(A),S)))
        <=> ! [F6: fun(nat,A)] :
              ( ( ! [N4: nat] : aa(set(A),$o,member(A,aa(nat,A,F6,N4)),S)
                & filterlim(nat,A,F6,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) )
             => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_anu(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F6),at_top(nat)) ) ) ) ).

% eventually_nhds_within_iff_sequentially
tff(fact_7304_eventually__nhds__iff__sequentially,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [P: fun(A,$o),A2: A] :
          ( eventually(A,P,topolo7230453075368039082e_nhds(A,A2))
        <=> ! [F6: fun(nat,A)] :
              ( filterlim(nat,A,F6,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
             => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_anu(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F6),at_top(nat)) ) ) ) ).

% eventually_nhds_iff_sequentially
tff(fact_7305_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,F3,at_infinity(real),F4)
     => ( eventually(A,aTP_Lamp_anv(fun(A,real),fun(A,$o),F3),F4)
       => filterlim(A,real,F3,at_top(real),F4) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
tff(fact_7306_sequentially__imp__eventually__within,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [S: set(A),A2: A,P: fun(A,$o)] :
          ( ! [F5: fun(nat,A)] :
              ( ( ! [N8: nat] :
                    ( aa(set(A),$o,member(A,aa(nat,A,F5,N8)),S)
                    & ( aa(nat,A,F5,N8) != A2 ) )
                & filterlim(nat,A,F5,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) )
             => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_anu(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F5),at_top(nat)) )
         => eventually(A,P,topolo174197925503356063within(A,A2,S)) ) ) ).

% sequentially_imp_eventually_within
tff(fact_7307_sequentially__imp__eventually__at,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [A2: A,P: fun(A,$o)] :
          ( ! [F5: fun(nat,A)] :
              ( ( ! [N8: nat] : ( aa(nat,A,F5,N8) != A2 )
                & filterlim(nat,A,F5,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) )
             => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_anu(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F5),at_top(nat)) )
         => eventually(A,P,topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% sequentially_imp_eventually_at
tff(fact_7308_filterlim__at__within__not__equal,axiom,
    ! [B: $tType,A: $tType] :
      ( topological_t2_space(B)
     => ! [F3: fun(A,B),A2: B,S: set(B),F4: filter(A),B2: B] :
          ( filterlim(A,B,F3,topolo174197925503356063within(B,A2,S),F4)
         => eventually(A,aa(B,fun(A,$o),aa(set(B),fun(B,fun(A,$o)),aTP_Lamp_anw(fun(A,B),fun(set(B),fun(B,fun(A,$o))),F3),S),B2),F4) ) ) ).

% filterlim_at_within_not_equal
tff(fact_7309_filterlim__iff,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),F22: filter(B),F12: filter(A)] :
      ( filterlim(A,B,F3,F22,F12)
    <=> ! [P6: fun(B,$o)] :
          ( eventually(B,P6,F22)
         => eventually(A,aa(fun(B,$o),fun(A,$o),aTP_Lamp_anx(fun(A,B),fun(fun(B,$o),fun(A,$o)),F3),P6),F12) ) ) ).

% filterlim_iff
tff(fact_7310_filterlim__cong,axiom,
    ! [A: $tType,B: $tType,F12: filter(A),F13: filter(A),F22: filter(B),F23: filter(B),F3: fun(B,A),G: fun(B,A)] :
      ( ( F12 = F13 )
     => ( ( F22 = F23 )
       => ( eventually(B,aa(fun(B,A),fun(B,$o),aTP_Lamp_any(fun(B,A),fun(fun(B,A),fun(B,$o)),F3),G),F22)
         => ( filterlim(B,A,F3,F12,F22)
          <=> filterlim(B,A,G,F13,F23) ) ) ) ) ).

% filterlim_cong
tff(fact_7311_filterlim__principal,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),S3: set(B),F4: filter(A)] :
      ( filterlim(A,B,F3,aa(set(B),filter(B),principal(B),S3),F4)
    <=> eventually(A,aa(set(B),fun(A,$o),aTP_Lamp_anz(fun(A,B),fun(set(B),fun(A,$o)),F3),S3),F4) ) ).

% filterlim_principal
tff(fact_7312_eventually__compose__filterlim,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F4: filter(A),F3: fun(B,A),G3: filter(B)] :
      ( eventually(A,P,F4)
     => ( filterlim(B,A,F3,F4,G3)
       => eventually(B,aa(fun(B,A),fun(B,$o),aTP_Lamp_aoa(fun(A,$o),fun(fun(B,A),fun(B,$o)),P),F3),G3) ) ) ).

% eventually_compose_filterlim
tff(fact_7313_Lim__transform__eventually,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aob(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),F4)
           => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),F4) ) ) ) ).

% Lim_transform_eventually
tff(fact_7314_filterlim__at__infinity__imp__eventually__ne,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_infinity(B),F4)
         => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aoc(fun(A,B),fun(B,fun(A,$o)),F3),C2),F4) ) ) ).

% filterlim_at_infinity_imp_eventually_ne
tff(fact_7315_tendsto__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),G: fun(A,B),F4: filter(A),C2: B] :
          ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aob(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),F4)
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F4)
          <=> filterlim(A,B,G,topolo7230453075368039082e_nhds(B,C2),F4) ) ) ) ).

% tendsto_cong
tff(fact_7316_tendsto__discrete,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo8865339358273720382pology(B)
     => ! [F3: fun(A,B),Y2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,Y2),F4)
        <=> eventually(A,aa(B,fun(A,$o),aTP_Lamp_aod(fun(A,B),fun(B,fun(A,$o)),F3),Y2),F4) ) ) ).

% tendsto_discrete
tff(fact_7317_tendsto__imp__eventually__ne,axiom,
    ! [B: $tType,A: $tType] :
      ( topological_t1_space(B)
     => ! [F3: fun(A,B),C2: B,F4: filter(A),C7: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F4)
         => ( ( C2 != C7 )
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aoe(fun(A,B),fun(B,fun(A,$o)),F3),C7),F4) ) ) ) ).

% tendsto_imp_eventually_ne
tff(fact_7318_tendsto__eventually,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),L: B,Net: filter(A)] :
          ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_aof(fun(A,B),fun(B,fun(A,$o)),F3),L),Net)
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),Net) ) ) ).

% tendsto_eventually
tff(fact_7319_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),F4: filter(B),G3: filter(A),F7: filter(B),G5: filter(A),F8: fun(A,B)] :
      ( filterlim(A,B,F3,F4,G3)
     => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),F4),F7)
       => ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),G5),G3)
         => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aog(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),F8),G5)
           => filterlim(A,B,F8,F7,G5) ) ) ) ) ).

% filterlim_mono_eventually
tff(fact_7320_filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [C2: real,F3: fun(A,B),F4: filter(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),C2)
         => ( filterlim(A,B,F3,at_infinity(B),F4)
          <=> ! [R5: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),R5)
               => eventually(A,aa(real,fun(A,$o),aTP_Lamp_aoh(fun(A,B),fun(real,fun(A,$o)),F3),R5),F4) ) ) ) ) ).

% filterlim_at_infinity
tff(fact_7321_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [P: fun(A,$o),X2: A] :
          ( eventually(A,P,topolo174197925503356063within(A,X2,aa(A,set(A),set_ord_lessThan(A),X2)))
        <=> ? [B6: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B6),X2)
              & ! [Y: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B6),Y)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X2)
                   => aa(A,$o,P,Y) ) ) ) ) ) ).

% eventually_at_left_field
tff(fact_7322_eventually__at__left,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Y2: A,X2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X2)
         => ( eventually(A,P,topolo174197925503356063within(A,X2,aa(A,set(A),set_ord_lessThan(A),X2)))
          <=> ? [B6: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B6),X2)
                & ! [Y: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B6),Y)
                   => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X2)
                     => aa(A,$o,P,Y) ) ) ) ) ) ) ).

% eventually_at_left
tff(fact_7323_eventually__inf__principal,axiom,
    ! [A: $tType,P: fun(A,$o),F4: filter(A),S: set(A)] :
      ( eventually(A,P,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F4),aa(set(A),filter(A),principal(A),S)))
    <=> eventually(A,aa(set(A),fun(A,$o),aTP_Lamp_aoi(fun(A,$o),fun(set(A),fun(A,$o)),P),S),F4) ) ).

% eventually_inf_principal
tff(fact_7324_le__principal,axiom,
    ! [A: $tType,F4: filter(A),A3: set(A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F4),aa(set(A),filter(A),principal(A),A3))
    <=> eventually(A,aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3),F4) ) ).

% le_principal
tff(fact_7325_eventually__nhds__in__open,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),X2: A] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),S)
         => ( aa(set(A),$o,member(A,X2),S)
           => eventually(A,aTP_Lamp_aoj(set(A),fun(A,$o),S),topolo7230453075368039082e_nhds(A,X2)) ) ) ) ).

% eventually_nhds_in_open
tff(fact_7326_has__derivative__transform__eventually,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F8: fun(A,B),X2: A,S: set(A),G: fun(A,B)] :
          ( has_derivative(A,B,F3,F8,topolo174197925503356063within(A,X2,S))
         => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aok(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),topolo174197925503356063within(A,X2,S))
           => ( ( aa(A,B,F3,X2) = aa(A,B,G,X2) )
             => ( aa(set(A),$o,member(A,X2),S)
               => has_derivative(A,B,G,F8,topolo174197925503356063within(A,X2,S)) ) ) ) ) ) ).

% has_derivative_transform_eventually
tff(fact_7327_eventually__at__filter,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o),A2: A,S: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,S))
        <=> eventually(A,aa(set(A),fun(A,$o),aa(A,fun(set(A),fun(A,$o)),aTP_Lamp_aol(fun(A,$o),fun(A,fun(set(A),fun(A,$o))),P),A2),S),topolo7230453075368039082e_nhds(A,A2)) ) ) ).

% eventually_at_filter
tff(fact_7328_t1__space__nhds,axiom,
    ! [A: $tType] :
      ( topological_t1_space(A)
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => eventually(A,aTP_Lamp_aom(A,fun(A,$o),Y2),topolo7230453075368039082e_nhds(A,X2)) ) ) ).

% t1_space_nhds
tff(fact_7329_eventually__eventually,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o),X2: A] :
          ( eventually(A,aTP_Lamp_aon(fun(A,$o),fun(A,$o),P),topolo7230453075368039082e_nhds(A,X2))
        <=> eventually(A,P,topolo7230453075368039082e_nhds(A,X2)) ) ) ).

% eventually_eventually
tff(fact_7330_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( order_top(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),top_top(A))
         => ( eventually(A,P,topolo7230453075368039082e_nhds(A,top_top(A)))
          <=> ? [B6: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B6),top_top(A))
                & ! [Z5: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B6),Z5)
                   => aa(A,$o,P,Z5) ) ) ) ) ) ).

% eventually_nhds_top
tff(fact_7331_has__field__derivative__cong__eventually,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),G: fun(A,A),X2: A,S3: set(A),U: A] :
          ( eventually(A,aa(fun(A,A),fun(A,$o),aTP_Lamp_aoo(fun(A,A),fun(fun(A,A),fun(A,$o)),F3),G),topolo174197925503356063within(A,X2,S3))
         => ( ( aa(A,A,F3,X2) = aa(A,A,G,X2) )
           => ( has_field_derivative(A,F3,U,topolo174197925503356063within(A,X2,S3))
            <=> has_field_derivative(A,G,U,topolo174197925503356063within(A,X2,S3)) ) ) ) ) ).

% has_field_derivative_cong_eventually
tff(fact_7332_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P2: fun(A,$o)] :
          ( eventually(A,P2,at_infinity(A))
        <=> ? [B6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B6)
              & ! [X3: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B6),real_V7770717601297561774m_norm(A,X3))
                 => aa(A,$o,P2,X3) ) ) ) ) ).

% eventually_at_infinity_pos
tff(fact_7333_eventually__frequently__const__simps_I6_J,axiom,
    ! [A: $tType,C6: $o,P: fun(A,$o),F4: filter(A)] :
      ( eventually(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aop($o,fun(fun(A,$o),fun(A,$o)),C6),P),F4)
    <=> ( (C6)
       => eventually(A,P,F4) ) ) ).

% eventually_frequently_const_simps(6)
tff(fact_7334_eventually__frequently__const__simps_I4_J,axiom,
    ! [A: $tType,C6: $o,P: fun(A,$o),F4: filter(A)] :
      ( eventually(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aoq($o,fun(fun(A,$o),fun(A,$o)),C6),P),F4)
    <=> ( (C6)
        | eventually(A,P,F4) ) ) ).

% eventually_frequently_const_simps(4)
tff(fact_7335_eventually__frequently__const__simps_I3_J,axiom,
    ! [A: $tType,P: fun(A,$o),C6: $o,F4: filter(A)] :
      ( eventually(A,aa($o,fun(A,$o),aTP_Lamp_aor(fun(A,$o),fun($o,fun(A,$o)),P),C6),F4)
    <=> ( eventually(A,P,F4)
        | (C6) ) ) ).

% eventually_frequently_const_simps(3)
tff(fact_7336_eventually__mp,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o),F4: filter(A)] :
      ( eventually(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aos(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q),F4)
     => ( eventually(A,P,F4)
       => eventually(A,Q,F4) ) ) ).

% eventually_mp
tff(fact_7337_eventually__True,axiom,
    ! [A: $tType,F4: filter(A)] : eventually(A,aTP_Lamp_ws(A,$o),F4) ).

% eventually_True
tff(fact_7338_eventually__conj,axiom,
    ! [A: $tType,P: fun(A,$o),F4: filter(A),Q: fun(A,$o)] :
      ( eventually(A,P,F4)
     => ( eventually(A,Q,F4)
       => eventually(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ol(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q),F4) ) ) ).

% eventually_conj
tff(fact_7339_eventually__elim2,axiom,
    ! [A: $tType,P: fun(A,$o),F4: filter(A),Q: fun(A,$o),R3: fun(A,$o)] :
      ( eventually(A,P,F4)
     => ( eventually(A,Q,F4)
       => ( ! [I2: A] :
              ( aa(A,$o,P,I2)
             => ( aa(A,$o,Q,I2)
               => aa(A,$o,R3,I2) ) )
         => eventually(A,R3,F4) ) ) ) ).

% eventually_elim2
tff(fact_7340_eventually__subst,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o),F4: filter(A)] :
      ( eventually(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aot(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q),F4)
     => ( eventually(A,P,F4)
      <=> eventually(A,Q,F4) ) ) ).

% eventually_subst
tff(fact_7341_eventually__rev__mp,axiom,
    ! [A: $tType,P: fun(A,$o),F4: filter(A),Q: fun(A,$o)] :
      ( eventually(A,P,F4)
     => ( eventually(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aos(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q),F4)
       => eventually(A,Q,F4) ) ) ).

% eventually_rev_mp
tff(fact_7342_eventually__conj__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o),F4: filter(A)] :
      ( eventually(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ol(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q),F4)
    <=> ( eventually(A,P,F4)
        & eventually(A,Q,F4) ) ) ).

% eventually_conj_iff
tff(fact_7343_not__eventually__impI,axiom,
    ! [A: $tType,P: fun(A,$o),F4: filter(A),Q: fun(A,$o)] :
      ( eventually(A,P,F4)
     => ( ~ eventually(A,Q,F4)
       => ~ eventually(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aos(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q),F4) ) ) ).

% not_eventually_impI
tff(fact_7344_trivial__limit__def,axiom,
    ! [A: $tType,F4: filter(A)] :
      ( ( F4 = bot_bot(filter(A)) )
    <=> eventually(A,aTP_Lamp_py(A,$o),F4) ) ).

% trivial_limit_def
tff(fact_7345_eventually__const__iff,axiom,
    ! [A: $tType,P: $o,F4: filter(A)] :
      ( eventually(A,aTP_Lamp_wn($o,fun(A,$o),P),F4)
    <=> ( (P)
        | ( F4 = bot_bot(filter(A)) ) ) ) ).

% eventually_const_iff
tff(fact_7346_False__imp__not__eventually,axiom,
    ! [A: $tType,P: fun(A,$o),Net: filter(A)] :
      ( ! [X4: A] : ~ aa(A,$o,P,X4)
     => ( ( Net != bot_bot(filter(A)) )
       => ~ eventually(A,P,Net) ) ) ).

% False_imp_not_eventually
tff(fact_7347_eventually__not__equal__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A] : eventually(A,aTP_Lamp_aou(A,fun(A,$o),A2),at_infinity(A)) ) ).

% eventually_not_equal_at_infinity
tff(fact_7348_eventually__Lim__ident__at,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [P: fun(A,fun(A,$o)),X2: A,X7: set(A)] :
          ( eventually(A,aa(A,fun(A,$o),P,topolo3827282254853284352ce_Lim(A,A,topolo174197925503356063within(A,X2,X7),aTP_Lamp_aek(A,A))),topolo174197925503356063within(A,X2,X7))
        <=> eventually(A,aa(A,fun(A,$o),P,X2),topolo174197925503356063within(A,X2,X7)) ) ) ).

% eventually_Lim_ident_at
tff(fact_7349_eventually__INF1,axiom,
    ! [B: $tType,A: $tType,I3: A,I5: set(A),P: fun(B,$o),F4: fun(A,filter(B))] :
      ( aa(set(A),$o,member(A,I3),I5)
     => ( eventually(B,P,aa(A,filter(B),F4,I3))
       => eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F4),I5))) ) ) ).

% eventually_INF1
tff(fact_7350_eventually__at__right,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X2: A,Y2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2)
         => ( eventually(A,P,topolo174197925503356063within(A,X2,aa(A,set(A),set_ord_greaterThan(A),X2)))
          <=> ? [B6: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),B6)
                & ! [Y: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y)
                   => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),B6)
                     => aa(A,$o,P,Y) ) ) ) ) ) ) ).

% eventually_at_right
tff(fact_7351_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [P: fun(A,$o),X2: A] :
          ( eventually(A,P,topolo174197925503356063within(A,X2,aa(A,set(A),set_ord_greaterThan(A),X2)))
        <=> ? [B6: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),B6)
              & ! [Y: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),B6)
                   => aa(A,$o,P,Y) ) ) ) ) ) ).

% eventually_at_right_field
tff(fact_7352_tendsto__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),G: fun(A,B),Net: filter(A),H: fun(A,B),C2: B] :
          ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aov(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),Net)
         => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aov(fun(A,B),fun(fun(A,B),fun(A,$o)),G),H),Net)
           => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),Net)
             => ( filterlim(A,B,H,topolo7230453075368039082e_nhds(B,C2),Net)
               => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,C2),Net) ) ) ) ) ) ).

% tendsto_sandwich
tff(fact_7353_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),X2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,X2),F4)
        <=> ( ! [L3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L3),X2)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aow(fun(A,B),fun(B,fun(A,$o)),F3),L3),F4) )
            & ! [U3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),U3)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aox(fun(A,B),fun(B,fun(A,$o)),F3),U3),F4) ) ) ) ) ).

% order_tendsto_iff
tff(fact_7354_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Y2: A,F3: fun(B,A),F4: filter(B)] :
          ( ! [A4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A4),Y2)
             => eventually(B,aa(A,fun(B,$o),aTP_Lamp_aoy(fun(B,A),fun(A,fun(B,$o)),F3),A4),F4) )
         => ( ! [A4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),A4)
               => eventually(B,aa(A,fun(B,$o),aTP_Lamp_aoz(fun(B,A),fun(A,fun(B,$o)),F3),A4),F4) )
           => filterlim(B,A,F3,topolo7230453075368039082e_nhds(A,Y2),F4) ) ) ) ).

% order_tendstoI
tff(fact_7355_order__tendstoD_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),Y2: B,F4: filter(A),A2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,Y2),F4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A2),Y2)
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aow(fun(A,B),fun(B,fun(A,$o)),F3),A2),F4) ) ) ) ).

% order_tendstoD(1)
tff(fact_7356_order__tendstoD_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),Y2: B,F4: filter(A),A2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,Y2),F4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y2),A2)
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aox(fun(A,B),fun(B,fun(A,$o)),F3),A2),F4) ) ) ) ).

% order_tendstoD(2)
tff(fact_7357_filterlim__at__top__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,at_top(B),F4)
         => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_apa(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),F4)
           => filterlim(A,B,G,at_top(B),F4) ) ) ) ).

% filterlim_at_top_mono
tff(fact_7358_filterlim__at__top__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_top(B),F4)
        <=> ! [Z7: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),Z7)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_apb(fun(A,B),fun(B,fun(A,$o)),F3),Z7),F4) ) ) ) ).

% filterlim_at_top_ge
tff(fact_7359_filterlim__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,B,F3,at_top(B),F4)
        <=> ! [Z7: B] : eventually(A,aa(B,fun(A,$o),aTP_Lamp_apb(fun(A,B),fun(B,fun(A,$o)),F3),Z7),F4) ) ) ).

% filterlim_at_top
tff(fact_7360_filterlim__at__top__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,B,F3,at_top(B),F4)
        <=> ! [Z7: B] : eventually(A,aa(B,fun(A,$o),aTP_Lamp_apc(fun(A,B),fun(B,fun(A,$o)),F3),Z7),F4) ) ) ).

% filterlim_at_top_dense
tff(fact_7361_filterlim__at,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),B2: B,S: set(B),F4: filter(A)] :
          ( filterlim(A,B,F3,topolo174197925503356063within(B,B2,S),F4)
        <=> ( eventually(A,aa(set(B),fun(A,$o),aa(B,fun(set(B),fun(A,$o)),aTP_Lamp_apd(fun(A,B),fun(B,fun(set(B),fun(A,$o))),F3),B2),S),F4)
            & filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,B2),F4) ) ) ) ).

% filterlim_at
tff(fact_7362_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( no_top(A)
        & topolo1944317154257567458pology(A) )
     => ! [X2: A] : eventually(A,aa(A,fun(A,$o),ord_less(A),X2),topolo174197925503356063within(A,X2,aa(A,set(A),set_ord_greaterThan(A),X2))) ) ).

% eventually_at_right_less
tff(fact_7363_has__field__derivative__cong__ev,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [X2: A,Y2: A,S3: set(A),F3: fun(A,A),G: fun(A,A),U: A,V: A,T2: set(A)] :
          ( ( X2 = Y2 )
         => ( eventually(A,aa(fun(A,A),fun(A,$o),aa(fun(A,A),fun(fun(A,A),fun(A,$o)),aTP_Lamp_ape(set(A),fun(fun(A,A),fun(fun(A,A),fun(A,$o))),S3),F3),G),topolo7230453075368039082e_nhds(A,X2))
           => ( ( U = V )
             => ( ( S3 = T2 )
               => ( aa(set(A),$o,member(A,X2),S3)
                 => ( has_field_derivative(A,F3,U,topolo174197925503356063within(A,X2,S3))
                  <=> has_field_derivative(A,G,V,topolo174197925503356063within(A,Y2,T2)) ) ) ) ) ) ) ) ).

% has_field_derivative_cong_ev
tff(fact_7364_topological__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [L: A,F3: fun(B,A),F4: filter(B)] :
          ( ! [S9: set(A)] :
              ( aa(set(A),$o,topolo1002775350975398744n_open(A),S9)
             => ( aa(set(A),$o,member(A,L),S9)
               => eventually(B,aa(set(A),fun(B,$o),aTP_Lamp_apf(fun(B,A),fun(set(A),fun(B,$o)),F3),S9),F4) ) )
         => filterlim(B,A,F3,topolo7230453075368039082e_nhds(A,L),F4) ) ) ).

% topological_tendstoI
tff(fact_7365_topological__tendstoD,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A),S3: set(B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( aa(set(B),$o,topolo1002775350975398744n_open(B),S3)
           => ( aa(set(B),$o,member(B,L),S3)
             => eventually(A,aa(set(B),fun(A,$o),aTP_Lamp_apg(fun(A,B),fun(set(B),fun(A,$o)),F3),S3),F4) ) ) ) ) ).

% topological_tendstoD
tff(fact_7366_tendsto__def,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
        <=> ! [S7: set(B)] :
              ( aa(set(B),$o,topolo1002775350975398744n_open(B),S7)
             => ( aa(set(B),$o,member(B,L),S7)
               => eventually(A,aa(set(B),fun(A,$o),aTP_Lamp_apg(fun(A,B),fun(set(B),fun(A,$o)),F3),S7),F4) ) ) ) ) ).

% tendsto_def
tff(fact_7367_filterlim__at__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,B,F3,at_bot(B),F4)
        <=> ! [Z7: B] : eventually(A,aa(B,fun(A,$o),aTP_Lamp_aph(fun(A,B),fun(B,fun(A,$o)),F3),Z7),F4) ) ) ).

% filterlim_at_bot
tff(fact_7368_filterlim__at__bot__le,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_bot(B),F4)
        <=> ! [Z7: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z7),C2)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aph(fun(A,B),fun(B,fun(A,$o)),F3),Z7),F4) ) ) ) ).

% filterlim_at_bot_le
tff(fact_7369_filterlim__at__bot__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dense_linorder(B)
        & no_bot(B) )
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,B,F3,at_bot(B),F4)
        <=> ! [Z7: B] : eventually(A,aa(B,fun(A,$o),aTP_Lamp_api(fun(A,B),fun(B,fun(A,$o)),F3),Z7),F4) ) ) ).

% filterlim_at_bot_dense
tff(fact_7370_real__tendsto__sandwich,axiom,
    ! [A: $tType,F3: fun(A,real),G: fun(A,real),Net: filter(A),H: fun(A,real),C2: real] :
      ( eventually(A,aa(fun(A,real),fun(A,$o),aTP_Lamp_apj(fun(A,real),fun(fun(A,real),fun(A,$o)),F3),G),Net)
     => ( eventually(A,aa(fun(A,real),fun(A,$o),aTP_Lamp_apj(fun(A,real),fun(fun(A,real),fun(A,$o)),G),H),Net)
       => ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),Net)
         => ( filterlim(A,real,H,topolo7230453075368039082e_nhds(real,C2),Net)
           => filterlim(A,real,G,topolo7230453075368039082e_nhds(real,C2),Net) ) ) ) ) ).

% real_tendsto_sandwich
tff(fact_7371_eventually__INF__finite,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(B,$o),F4: fun(A,filter(B))] :
      ( finite_finite2(A,A3)
     => ( eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F4),A3)))
      <=> ? [Q7: fun(A,fun(B,$o))] :
            ( ! [X3: A] :
                ( aa(set(A),$o,member(A,X3),A3)
               => eventually(B,aa(A,fun(B,$o),Q7,X3),aa(A,filter(B),F4,X3)) )
            & ! [Y: B] :
                ( ! [X3: A] :
                    ( aa(set(A),$o,member(A,X3),A3)
                   => aa(B,$o,aa(A,fun(B,$o),Q7,X3),Y) )
               => aa(B,$o,P,Y) ) ) ) ) ).

% eventually_INF_finite
tff(fact_7372_eventually__at,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A,S3: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,S3))
        <=> ? [D5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
              & ! [X3: A] :
                  ( aa(set(A),$o,member(A,X3),S3)
                 => ( ( ( X3 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),D5) )
                   => aa(A,$o,P,X3) ) ) ) ) ) ).

% eventually_at
tff(fact_7373_gcd__is__Max__divisors__int,axiom,
    ! [Nb: int,Ma: int] :
      ( ( Nb != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Ma),Nb) = aa(set(int),int,lattic643756798349783984er_Max(int),aa(fun(int,$o),set(int),collect(int),aa(int,fun(int,$o),aTP_Lamp_apk(int,fun(int,fun(int,$o)),Nb),Ma))) ) ) ).

% gcd_is_Max_divisors_int
tff(fact_7374_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A] :
          ( eventually(A,P,topolo7230453075368039082e_nhds(A,A2))
        <=> ? [D5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
              & ! [X3: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),D5)
                 => aa(A,$o,P,X3) ) ) ) ) ).

% eventually_nhds_metric
tff(fact_7375_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),set_or5935395276787703475ssThan(A,A2,B2))
             => aa(A,$o,P,X4) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => eventually(A,P,topolo174197925503356063within(A,B2,aa(A,set(A),set_ord_lessThan(A),B2))) ) ) ) ).

% eventually_at_leftI
tff(fact_7376_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),set_or5935395276787703475ssThan(A,A2,B2))
             => aa(A,$o,P,X4) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => eventually(A,P,topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2))) ) ) ) ).

% eventually_at_rightI
tff(fact_7377_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P: fun(A,$o),A2: A] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> eventually(A,aa(A,fun(A,$o),aTP_Lamp_apl(fun(A,$o),fun(A,fun(A,$o)),P),A2),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% eventually_at_to_0
tff(fact_7378_increasing__tendsto,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_apm(fun(A,B),fun(B,fun(A,$o)),F3),L),F4)
         => ( ! [X4: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),L)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aow(fun(A,B),fun(B,fun(A,$o)),F3),X4),F4) )
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4) ) ) ) ).

% increasing_tendsto
tff(fact_7379_decreasing__tendsto,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [L: B,F3: fun(A,B),F4: filter(A)] :
          ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_apn(B,fun(fun(A,B),fun(A,$o)),L),F3),F4)
         => ( ! [X4: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L),X4)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aox(fun(A,B),fun(B,fun(A,$o)),F3),X4),F4) )
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4) ) ) ) ).

% decreasing_tendsto
tff(fact_7380_filterlim__at__top__gt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F3: fun(A,B),F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_top(B),F4)
        <=> ! [Z7: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),Z7)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_apo(fun(A,B),fun(B,fun(A,$o)),F3),Z7),F4) ) ) ) ).

% filterlim_at_top_gt
tff(fact_7381_tendsto__compose__eventually,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [G: fun(A,B),Ma: B,L: A,F3: fun(C,A),F4: filter(C)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,Ma),topolo174197925503356063within(A,L,top_top(set(A))))
         => ( filterlim(C,A,F3,topolo7230453075368039082e_nhds(A,L),F4)
           => ( eventually(C,aa(fun(C,A),fun(C,$o),aTP_Lamp_app(A,fun(fun(C,A),fun(C,$o)),L),F3),F4)
             => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aed(fun(A,B),fun(fun(C,A),fun(C,B)),G),F3),topolo7230453075368039082e_nhds(B,Ma),F4) ) ) ) ) ).

% tendsto_compose_eventually
tff(fact_7382_LIM__compose__eventually,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F3: fun(A,B),B2: B,A2: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_apq(fun(A,B),fun(B,fun(A,$o)),F3),B2),topolo174197925503356063within(A,A2,top_top(set(A))))
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_apr(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% LIM_compose_eventually
tff(fact_7383_filterlim__atI,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),C2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F4)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_aps(fun(A,B),fun(B,fun(A,$o)),F3),C2),F4)
           => filterlim(A,B,F3,topolo174197925503356063within(B,C2,top_top(set(B))),F4) ) ) ) ).

% filterlim_atI
tff(fact_7384_isCont__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),G: fun(A,B),X2: A] :
          ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_apt(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),topolo7230453075368039082e_nhds(A,X2))
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X2,top_top(set(A))),F3)
          <=> topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X2,top_top(set(A))),G) ) ) ) ).

% isCont_cong
tff(fact_7385_DERIV__cong__ev,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [X2: A,Y2: A,F3: fun(A,A),G: fun(A,A),U: A,V: A] :
          ( ( X2 = Y2 )
         => ( eventually(A,aa(fun(A,A),fun(A,$o),aTP_Lamp_aoo(fun(A,A),fun(fun(A,A),fun(A,$o)),F3),G),topolo7230453075368039082e_nhds(A,X2))
           => ( ( U = V )
             => ( has_field_derivative(A,F3,U,topolo174197925503356063within(A,X2,top_top(set(A))))
              <=> has_field_derivative(A,G,V,topolo174197925503356063within(A,Y2,top_top(set(A)))) ) ) ) ) ) ).

% DERIV_cong_ev
tff(fact_7386_filterlim__at__bot__lt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F3: fun(A,B),F4: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_bot(B),F4)
        <=> ! [Z7: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z7),C2)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_apu(fun(A,B),fun(B,fun(A,$o)),F3),Z7),F4) ) ) ) ).

% filterlim_at_bot_lt
tff(fact_7387_tendsto__upperbound,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [F3: fun(A,B),X2: B,F4: filter(A),A2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,X2),F4)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_apv(fun(A,B),fun(B,fun(A,$o)),F3),A2),F4)
           => ( ( F4 != bot_bot(filter(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A2) ) ) ) ) ).

% tendsto_upperbound
tff(fact_7388_tendsto__lowerbound,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [F3: fun(A,B),X2: B,F4: filter(A),A2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,X2),F4)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_apw(fun(A,B),fun(B,fun(A,$o)),F3),A2),F4)
           => ( ( F4 != bot_bot(filter(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),X2) ) ) ) ) ).

% tendsto_lowerbound
tff(fact_7389_tendsto__le,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [F4: filter(A),F3: fun(A,B),X2: B,G: fun(A,B),Y2: B] :
          ( ( F4 != bot_bot(filter(A)) )
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,X2),F4)
           => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,Y2),F4)
             => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_apx(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),F4)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X2) ) ) ) ) ) ).

% tendsto_le
tff(fact_7390_metric__tendsto__imp__tendsto,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(C)
        & real_V7819770556892013058_space(B) )
     => ! [F3: fun(A,B),A2: B,F4: filter(A),G: fun(A,C),B2: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( eventually(A,aa(C,fun(A,$o),aa(fun(A,C),fun(C,fun(A,$o)),aa(B,fun(fun(A,C),fun(C,fun(A,$o))),aTP_Lamp_apy(fun(A,B),fun(B,fun(fun(A,C),fun(C,fun(A,$o)))),F3),A2),G),B2),F4)
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,B2),F4) ) ) ) ).

% metric_tendsto_imp_tendsto
tff(fact_7391_eventually__floor__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( ~ aa(set(B),$o,member(B,L),ring_1_Ints(B))
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_apz(fun(A,B),fun(B,fun(A,$o)),F3),L),F4) ) ) ) ).

% eventually_floor_eq
tff(fact_7392_eventually__ceiling__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( ~ aa(set(B),$o,member(B,L),ring_1_Ints(B))
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aqa(fun(A,B),fun(B,fun(A,$o)),F3),L),F4) ) ) ) ).

% eventually_ceiling_eq
tff(fact_7393_eventually__at__right__to__0,axiom,
    ! [P: fun(real,$o),A2: real] :
      ( eventually(real,P,topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
    <=> eventually(real,aa(real,fun(real,$o),aTP_Lamp_aqb(fun(real,$o),fun(real,fun(real,$o)),P),A2),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ) ).

% eventually_at_right_to_0
tff(fact_7394_Sup__enat__def,axiom,
    ! [A3: set(extended_enat)] :
      ( aa(set(extended_enat),extended_enat,complete_Sup_Sup(extended_enat),A3)
      = $ite(
          A3 = bot_bot(set(extended_enat)),
          zero_zero(extended_enat),
          $ite(finite_finite2(extended_enat,A3),aa(set(extended_enat),extended_enat,lattic643756798349783984er_Max(extended_enat),A3),extend4730790105801354508finity(extended_enat)) ) ) ).

% Sup_enat_def
tff(fact_7395_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F4: fun(B,filter(A)),B4: set(B)] :
      ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(B),set(filter(A)),image(B,filter(A),F4),B4)))
    <=> ? [X16: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X16),B4)
          & finite_finite2(B,X16)
          & eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(B),set(filter(A)),image(B,filter(A),F4),X16))) ) ) ).

% eventually_INF
tff(fact_7396_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A),G: fun(A,B),C2: B] :
          ( filterlim(A,B,F3,at_infinity(B),F4)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,C2),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aqc(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),at_infinity(B),F4) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
tff(fact_7397_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),C2: B,F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F4)
         => ( filterlim(A,B,G,at_infinity(B),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aqc(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),at_infinity(B),F4) ) ) ) ).

% tendsto_add_filterlim_at_infinity
tff(fact_7398_eventually__at__left__to__right,axiom,
    ! [P: fun(real,$o),A2: real] :
      ( eventually(real,P,topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
    <=> eventually(real,aTP_Lamp_aqd(fun(real,$o),fun(real,$o),P),topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),A2),aa(real,set(real),set_ord_greaterThan(real),aa(real,real,uminus_uminus(real),A2)))) ) ).

% eventually_at_left_to_right
tff(fact_7399_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F4: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F4,F3)
         => ( eventually(A,aTP_Lamp_aqe(fun(A,real),fun(A,$o),F3),F4)
           => topolo3448309680560233919inuous(A,real,F4,aTP_Lamp_all(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_arcosh_strong
tff(fact_7400_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => eventually(real,aa(real,fun(real,$o),aTP_Lamp_aqf(real,fun(real,fun(real,$o)),A2),B2),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2))) ) ).

% eventually_at_right_real
tff(fact_7401_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),B2),A2)
     => eventually(real,aa(real,fun(real,$o),aTP_Lamp_aqf(real,fun(real,fun(real,$o)),B2),A2),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2))) ) ).

% eventually_at_left_real
tff(fact_7402_eventually__at__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A,S3: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,S3))
        <=> ? [D5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
              & ! [X3: A] :
                  ( aa(set(A),$o,member(A,X3),S3)
                 => ( ( ( X3 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,X3,A2)),D5) )
                   => aa(A,$o,P,X3) ) ) ) ) ) ).

% eventually_at_le
tff(fact_7403_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [C2: fun(nat,A),K: nat,Nb: nat,B4: real] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),K)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Nb)
             => eventually(A,aa(real,fun(A,$o),aa(nat,fun(real,fun(A,$o)),aTP_Lamp_aqg(fun(nat,A),fun(nat,fun(real,fun(A,$o))),C2),Nb),B4),at_infinity(A)) ) ) ) ) ).

% polyfun_extremal
tff(fact_7404_tendsto__compose__at,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F3: fun(A,B),Y2: B,F4: filter(A),G: fun(B,C),Z: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,Y2),F4)
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,Z),topolo174197925503356063within(B,Y2,top_top(set(B))))
           => ( eventually(A,aa(C,fun(A,$o),aa(fun(B,C),fun(C,fun(A,$o)),aa(B,fun(fun(B,C),fun(C,fun(A,$o))),aTP_Lamp_aqh(fun(A,B),fun(B,fun(fun(B,C),fun(C,fun(A,$o)))),F3),Y2),G),Z),F4)
             => filterlim(A,C,aa(fun(A,B),fun(A,C),comp(B,C,A,G),F3),topolo7230453075368039082e_nhds(C,Z),F4) ) ) ) ) ).

% tendsto_compose_at
tff(fact_7405_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),L4: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),F4)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_aox(fun(A,B),fun(B,fun(A,$o)),F3),L4),F4)
           => filterlim(A,B,F3,topolo174197925503356063within(B,L4,aa(B,set(B),set_ord_lessThan(B),L4)),F4) ) ) ) ).

% tendsto_imp_filterlim_at_left
tff(fact_7406_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),L4: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L4),F4)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_aow(fun(A,B),fun(B,fun(A,$o)),F3),L4),F4)
           => filterlim(A,B,F3,topolo174197925503356063within(B,L4,aa(B,set(B),set_ord_greaterThan(B),L4)),F4) ) ) ) ).

% tendsto_imp_filterlim_at_right
tff(fact_7407_tendstoD,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A),E2: real] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
           => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aqi(fun(A,B),fun(B,fun(real,fun(A,$o))),F3),L),E2),F4) ) ) ) ).

% tendstoD
tff(fact_7408_tendstoI,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aqi(fun(A,B),fun(B,fun(real,fun(A,$o))),F3),L),E),F4) )
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4) ) ) ).

% tendstoI
tff(fact_7409_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aqi(fun(A,B),fun(B,fun(real,fun(A,$o))),F3),L),E3),F4) ) ) ) ).

% tendsto_iff
tff(fact_7410_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => filterlim(A,A,inverse_inverse(A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_infinity(A)) ) ).

% tendsto_inverse_0
tff(fact_7411_eventually__at__top__to__right,axiom,
    ! [P: fun(real,$o)] :
      ( eventually(real,P,at_top(real))
    <=> eventually(real,aTP_Lamp_aqj(fun(real,$o),fun(real,$o),P),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ) ).

% eventually_at_top_to_right
tff(fact_7412_eventually__at__right__to__top,axiom,
    ! [P: fun(real,$o)] :
      ( eventually(real,P,topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
    <=> eventually(real,aTP_Lamp_aqj(fun(real,$o),fun(real,$o),P),at_top(real)) ) ).

% eventually_at_right_to_top
tff(fact_7413_tendsto__arcosh__strong,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),A2)
       => ( eventually(A,aTP_Lamp_aqk(fun(A,real),fun(A,$o),F3),F4)
         => filterlim(A,real,aTP_Lamp_aes(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,arcosh(real),A2)),F4) ) ) ) ).

% tendsto_arcosh_strong
tff(fact_7414_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & linorder(B) )
     => ! [Q: fun(A,$o),F3: fun(A,B),P: fun(B,$o),G: fun(B,A),A2: A] :
          ( ! [X4: A,Y4: A] :
              ( aa(A,$o,Q,X4)
             => ( aa(A,$o,Q,Y4)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,F3,Y4)) ) ) )
         => ( ! [X4: B] :
                ( aa(B,$o,P,X4)
               => ( aa(A,B,F3,aa(B,A,G,X4)) = X4 ) )
           => ( ! [X4: B] :
                  ( aa(B,$o,P,X4)
                 => aa(A,$o,Q,aa(B,A,G,X4)) )
             => ( eventually(A,Q,topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_lessThan(A),A2)))
               => ( ! [B3: A] :
                      ( aa(A,$o,Q,B3)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B3),A2) )
                 => ( eventually(B,P,at_top(B))
                   => filterlim(A,B,F3,at_top(B),topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_lessThan(A),A2))) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
tff(fact_7415_tendsto__mult__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F3: fun(A,B),C2: B,F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F4)
         => ( ( C2 != zero_zero(B) )
           => ( filterlim(A,B,G,at_infinity(B),F4)
             => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aql(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),at_infinity(B),F4) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
tff(fact_7416_tendsto__divide__0,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),C2: B,F4: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F4)
         => ( filterlim(A,B,G,at_infinity(B),F4)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aqm(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F4) ) ) ) ).

% tendsto_divide_0
tff(fact_7417_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),F4: filter(A),Nb: nat] :
          ( filterlim(A,B,F3,at_infinity(B),F4)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
           => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_aqn(fun(A,B),fun(nat,fun(A,B)),F3),Nb),at_infinity(B),F4) ) ) ) ).

% filterlim_power_at_infinity
tff(fact_7418_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B4: set(A),F4: fun(A,filter(B)),P: fun(B,$o)] :
      ( ( B4 != bot_bot(set(A)) )
     => ( ! [A4: A] :
            ( aa(set(A),$o,member(A,A4),B4)
           => ! [B3: A] :
                ( aa(set(A),$o,member(A,B3),B4)
               => ? [X: A] :
                    ( aa(set(A),$o,member(A,X),B4)
                    & aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),aa(A,filter(B),F4,X)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F4,A4)),aa(A,filter(B),F4,B3))) ) ) )
       => ( eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F4),B4)))
        <=> ? [X3: A] :
              ( aa(set(A),$o,member(A,X3),B4)
              & eventually(B,P,aa(A,filter(B),F4,X3)) ) ) ) ) ).

% eventually_INF_base
tff(fact_7419_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & linorder(B) )
     => ! [Q: fun(A,$o),F3: fun(A,B),P: fun(B,$o),G: fun(B,A),A2: A] :
          ( ! [X4: A,Y4: A] :
              ( aa(A,$o,Q,X4)
             => ( aa(A,$o,Q,Y4)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,F3,Y4)) ) ) )
         => ( ! [X4: B] :
                ( aa(B,$o,P,X4)
               => ( aa(A,B,F3,aa(B,A,G,X4)) = X4 ) )
           => ( ! [X4: B] :
                  ( aa(B,$o,P,X4)
                 => aa(A,$o,Q,aa(B,A,G,X4)) )
             => ( eventually(A,Q,topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2)))
               => ( ! [B3: A] :
                      ( aa(A,$o,Q,B3)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B3) )
                 => ( eventually(B,P,at_bot(B))
                   => filterlim(A,B,F3,at_bot(B),topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2))) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
tff(fact_7420_filterlim__at__infinity__imp__norm__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,B,F3,at_infinity(B),F4)
         => filterlim(A,real,aTP_Lamp_agi(fun(A,B),fun(A,real),F3),at_top(real),F4) ) ) ).

% filterlim_at_infinity_imp_norm_at_top
tff(fact_7421_filterlim__norm__at__top__imp__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_agi(fun(A,B),fun(A,real),F3),at_top(real),F4)
         => filterlim(A,B,F3,at_infinity(B),F4) ) ) ).

% filterlim_norm_at_top_imp_at_infinity
tff(fact_7422_filterlim__at__infinity__conv__norm__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),G3: filter(A)] :
          ( filterlim(A,B,F3,at_infinity(B),G3)
        <=> filterlim(A,real,aTP_Lamp_agi(fun(A,B),fun(A,real),F3),at_top(real),G3) ) ) ).

% filterlim_at_infinity_conv_norm_at_top
tff(fact_7423_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F4: filter(A),G: fun(A,C),K5: real] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F4)
         => ( eventually(A,aa(real,fun(A,$o),aa(fun(A,C),fun(real,fun(A,$o)),aTP_Lamp_aqo(fun(A,B),fun(fun(A,C),fun(real,fun(A,$o))),F3),G),K5),F4)
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,zero_zero(C)),F4) ) ) ) ).

% tendsto_0_le
tff(fact_7424_filterlim__at__withinI,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),C2: B,F4: filter(A),A3: set(B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F4)
         => ( eventually(A,aa(set(B),fun(A,$o),aa(B,fun(set(B),fun(A,$o)),aTP_Lamp_aqp(fun(A,B),fun(B,fun(set(B),fun(A,$o))),F3),C2),A3),F4)
           => filterlim(A,B,F3,topolo174197925503356063within(B,C2,A3),F4) ) ) ) ).

% filterlim_at_withinI
tff(fact_7425_tendsto__powr_H,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F4)
       => ( ( ( A2 != zero_zero(real) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
              & eventually(A,aTP_Lamp_aqq(fun(A,real),fun(A,$o),F3),F4) ) )
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_agm(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,powr(real,A2,B2)),F4) ) ) ) ).

% tendsto_powr'
tff(fact_7426_tendsto__powr2,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F4)
       => ( eventually(A,aTP_Lamp_aqq(fun(A,real),fun(A,$o),F3),F4)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_agm(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,powr(real,A2,B2)),F4) ) ) ) ) ).

% tendsto_powr2
tff(fact_7427_tendsto__zero__powrI,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F4)
       => ( eventually(A,aTP_Lamp_aqq(fun(A,real),fun(A,$o),F3),F4)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_agm(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ) ) ) ).

% tendsto_zero_powrI
tff(fact_7428_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( ~ aa(set(B),$o,member(B,L),ring_1_Ints(B))
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aqr(fun(A,B),fun(B,fun(A,$o)),F3),L),F4) ) ) ) ).

% eventually_floor_less
tff(fact_7429_LIM__at__top__divide,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F4: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F4)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
         => ( eventually(A,aTP_Lamp_anv(fun(A,real),fun(A,$o),G),F4)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amy(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F4) ) ) ) ) ).

% LIM_at_top_divide
tff(fact_7430_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
         => ( ~ aa(set(B),$o,member(B,L),ring_1_Ints(B))
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aqs(fun(A,B),fun(B,fun(A,$o)),F3),L),F4) ) ) ) ).

% eventually_less_ceiling
tff(fact_7431_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( eventually(A,aTP_Lamp_anv(fun(A,real),fun(A,$o),F3),F4)
     => ( filterlim(A,real,F3,at_top(real),F4)
      <=> filterlim(A,real,aa(fun(A,real),fun(A,real),comp(real,real,A,inverse_inverse(real)),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ) ).

% filterlim_at_top_iff_inverse_0
tff(fact_7432_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( eventually(A,aTP_Lamp_anv(fun(A,real),fun(A,$o),F3),F4)
     => ( filterlim(A,real,aTP_Lamp_amz(fun(A,real),fun(A,real),F3),at_top(real),F4)
      <=> filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4) ) ) ).

% filterlim_inverse_at_top_iff
tff(fact_7433_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
     => ( eventually(A,aTP_Lamp_anv(fun(A,real),fun(A,$o),F3),F4)
       => filterlim(A,real,aTP_Lamp_amz(fun(A,real),fun(A,real),F3),at_top(real),F4) ) ) ).

% filterlim_inverse_at_top
tff(fact_7434_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),F4: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F4)
     => ( eventually(A,aTP_Lamp_anp(fun(A,real),fun(A,$o),F3),F4)
       => filterlim(A,real,aTP_Lamp_amz(fun(A,real),fun(A,real),F3),at_bot(real),F4) ) ) ).

% filterlim_inverse_at_bot
tff(fact_7435_lhopital__at__top__at__top,axiom,
    ! [F3: fun(real,real),A2: real,G: fun(real,real),F8: fun(real,real),G2: fun(real,real)] :
      ( filterlim(real,real,F3,at_top(real),topolo174197925503356063within(real,A2,top_top(set(real))))
     => ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,A2,top_top(set(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,A2,top_top(set(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,A2,top_top(set(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G2),at_top(real),topolo174197925503356063within(real,A2,top_top(set(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),at_top(real),topolo174197925503356063within(real,A2,top_top(set(real)))) ) ) ) ) ) ).

% lhopital_at_top_at_top
tff(fact_7436_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => filterlim(A,A,inverse_inverse(A),at_infinity(A),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ).

% filterlim_inverse_at_infinity
tff(fact_7437_lim__infinity__imp__sequentially,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(real,A),L: A] :
          ( filterlim(real,A,F3,topolo7230453075368039082e_nhds(A,L),at_infinity(real))
         => filterlim(nat,A,aTP_Lamp_aqu(fun(real,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% lim_infinity_imp_sequentially
tff(fact_7438_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [G: fun(A,B),F4: filter(A)] :
          ( filterlim(A,B,aTP_Lamp_ago(fun(A,B),fun(A,B),G),topolo174197925503356063within(B,zero_zero(B),top_top(set(B))),F4)
        <=> filterlim(A,B,G,at_infinity(B),F4) ) ) ).

% filterlim_inverse_at_iff
tff(fact_7439_lhopital,axiom,
    ! [F3: fun(real,real),X2: real,G: fun(real,real),G2: fun(real,real),F8: fun(real,real),F4: filter(real)] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X2,top_top(set(real))))
       => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,X2,top_top(set(real))))
         => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X2,top_top(set(real))))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,X2,top_top(set(real))))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X2,top_top(set(real))))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),F4,topolo174197925503356063within(real,X2,top_top(set(real))))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),F4,topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ) ) ) ) ) ).

% lhopital
tff(fact_7440_lhopital__right__at__top__at__top,axiom,
    ! [F3: fun(real,real),A2: real,G: fun(real,real),F8: fun(real,real),G2: fun(real,real)] :
      ( filterlim(real,real,F3,at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
     => ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G2),at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2))) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
tff(fact_7441_lhopital__at__top__at__bot,axiom,
    ! [F3: fun(real,real),A2: real,G: fun(real,real),F8: fun(real,real),G2: fun(real,real)] :
      ( filterlim(real,real,F3,at_top(real),topolo174197925503356063within(real,A2,top_top(set(real))))
     => ( filterlim(real,real,G,at_bot(real),topolo174197925503356063within(real,A2,top_top(set(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,A2,top_top(set(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,A2,top_top(set(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G2),at_bot(real),topolo174197925503356063within(real,A2,top_top(set(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),at_bot(real),topolo174197925503356063within(real,A2,top_top(set(real)))) ) ) ) ) ) ).

% lhopital_at_top_at_bot
tff(fact_7442_lhopital__left__at__top__at__top,axiom,
    ! [F3: fun(real,real),A2: real,G: fun(real,real),F8: fun(real,real),G2: fun(real,real)] :
      ( filterlim(real,real,F3,at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
     => ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G2),at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2))) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
tff(fact_7443_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),C2: A,F4: filter(A),G: fun(A,A)] :
          ( filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,C2),F4)
         => ( filterlim(A,A,G,topolo174197925503356063within(A,zero_zero(A),top_top(set(A))),F4)
           => ( ( C2 != zero_zero(A) )
             => filterlim(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_aaa(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),at_infinity(A),F4) ) ) ) ) ).

% filterlim_divide_at_infinity
tff(fact_7444_lhospital__at__top__at__top,axiom,
    ! [G: fun(real,real),G2: fun(real,real),F3: fun(real,real),F8: fun(real,real),X2: real] :
      ( filterlim(real,real,G,at_top(real),at_top(real))
     => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),at_top(real))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),at_top(real))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),at_top(real))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),topolo7230453075368039082e_nhds(real,X2),at_top(real))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,X2),at_top(real)) ) ) ) ) ) ).

% lhospital_at_top_at_top
tff(fact_7445_lhopital__at__top,axiom,
    ! [G: fun(real,real),X2: real,G2: fun(real,real),F3: fun(real,real),F8: fun(real,real),Y2: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X2,top_top(set(real))))
     => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X2,top_top(set(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,X2,top_top(set(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X2,top_top(set(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),topolo7230453075368039082e_nhds(real,Y2),topolo174197925503356063within(real,X2,top_top(set(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,Y2),topolo174197925503356063within(real,X2,top_top(set(real)))) ) ) ) ) ) ).

% lhopital_at_top
tff(fact_7446_lhopital__right__0,axiom,
    ! [F0: fun(real,real),G0: fun(real,real),G2: fun(real,real),F8: fun(real,real),F4: filter(real)] :
      ( filterlim(real,real,F0,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
     => ( filterlim(real,real,G0,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
       => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G0),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
         => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F0),F8),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G0),G2),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),F4,topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F0),G0),F4,topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ) ) ) ) ) ) ) ).

% lhopital_right_0
tff(fact_7447_lhopital__right,axiom,
    ! [F3: fun(real,real),X2: real,G: fun(real,real),G2: fun(real,real),F8: fun(real,real),F4: filter(real)] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
       => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
         => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),F4,topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),F4,topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2))) ) ) ) ) ) ) ) ).

% lhopital_right
tff(fact_7448_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),real_V7770717601297561774m_norm(A,X2))
         => filterlim(nat,A,power_power(A,X2),at_infinity(A),at_top(nat)) ) ) ).

% filterlim_realpow_sequentially_gt1
tff(fact_7449_lhopital__left,axiom,
    ! [F3: fun(real,real),X2: real,G: fun(real,real),G2: fun(real,real),F8: fun(real,real),F4: filter(real)] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
       => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
         => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),F4,topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2)))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),F4,topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_lessThan(real),X2))) ) ) ) ) ) ) ) ).

% lhopital_left
tff(fact_7450_lhopital__right__at__top__at__bot,axiom,
    ! [F3: fun(real,real),A2: real,G: fun(real,real),F8: fun(real,real),G2: fun(real,real)] :
      ( filterlim(real,real,F3,at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
     => ( filterlim(real,real,G,at_bot(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G2),at_bot(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),at_bot(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_greaterThan(real),A2))) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
tff(fact_7451_lhopital__left__at__top__at__bot,axiom,
    ! [F3: fun(real,real),A2: real,G: fun(real,real),F8: fun(real,real),G2: fun(real,real)] :
      ( filterlim(real,real,F3,at_top(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
     => ( filterlim(real,real,G,at_bot(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F8),G2),at_bot(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),at_bot(real),topolo174197925503356063within(real,A2,aa(real,set(real),set_ord_lessThan(real),A2))) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
tff(fact_7452_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),L: A] :
          ( filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,L),at_infinity(A))
        <=> filterlim(A,A,aa(fun(A,A),fun(A,A),comp(A,A,A,F3),inverse_inverse(A)),topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% lim_at_infinity_0
tff(fact_7453_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),L: A] :
          ( filterlim(A,A,aTP_Lamp_aqv(fun(A,A),fun(A,A),F3),topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
         => filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,L),at_infinity(A)) ) ) ).

% lim_zero_infinity
tff(fact_7454_lhopital__right__0__at__top,axiom,
    ! [G: fun(real,real),G2: fun(real,real),F3: fun(real,real),F8: fun(real,real),X2: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
     => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),topolo7230453075368039082e_nhds(real,X2),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,X2),topolo174197925503356063within(real,zero_zero(real),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ) ) ) ) ) ).

% lhopital_right_0_at_top
tff(fact_7455_lhopital__right__at__top,axiom,
    ! [G: fun(real,real),X2: real,G2: fun(real,real),F3: fun(real,real),F8: fun(real,real),Y2: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
     => ( eventually(real,aTP_Lamp_anm(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F8),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F8),topolo7230453075368039082e_nhds(real,Y2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,Y2),topolo174197925503356063within(real,X2,aa(real,set(real),set_ord_greaterThan(real),X2))) ) ) ) ) ) ).

% lhopital_right_at_top
tff(fact_7456_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( bfun(A,B,F3,F4)
        <=> ? [Y: B,K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aqw(fun(A,B),fun(B,fun(real,fun(A,$o))),F3),Y),K6),F4) ) ) ) ).

% Bfun_metric_def
tff(fact_7457_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( bfun(A,B,F3,F4)
        <=> ? [K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & eventually(A,aa(real,fun(A,$o),aTP_Lamp_aqx(fun(A,B),fun(real,fun(A,$o)),F3),K6),F4) ) ) ) ).

% Bfun_def
tff(fact_7458_eventually__sequentially__Suc,axiom,
    ! [P: fun(nat,$o)] :
      ( eventually(nat,aTP_Lamp_aqy(fun(nat,$o),fun(nat,$o),P),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_Suc
tff(fact_7459_eventually__sequentially__seg,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( eventually(nat,aa(nat,fun(nat,$o),aTP_Lamp_aqz(fun(nat,$o),fun(nat,fun(nat,$o)),P),K),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_seg
tff(fact_7460_eventually__False__sequentially,axiom,
    ~ eventually(nat,aTP_Lamp_mv(nat,$o),at_top(nat)) ).

% eventually_False_sequentially
tff(fact_7461_sequentially__offset,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( eventually(nat,P,at_top(nat))
     => eventually(nat,aa(nat,fun(nat,$o),aTP_Lamp_aqz(fun(nat,$o),fun(nat,fun(nat,$o)),P),K),at_top(nat)) ) ).

% sequentially_offset
tff(fact_7462_summable__cong,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_ara(fun(nat,A),fun(fun(nat,A),fun(nat,$o)),F3),G),at_top(nat))
         => ( summable(A,F3)
          <=> summable(A,G) ) ) ) ).

% summable_cong
tff(fact_7463_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(nat,A),G: fun(nat,B)] :
          ( eventually(nat,aa(fun(nat,B),fun(nat,$o),aTP_Lamp_arb(fun(nat,A),fun(fun(nat,B),fun(nat,$o)),F3),G),at_top(nat))
         => ( bfun(nat,B,G,at_top(nat))
           => bfun(nat,A,F3,at_top(nat)) ) ) ) ).

% Bseq_eventually_mono
tff(fact_7464_le__sequentially,axiom,
    ! [F4: filter(nat)] :
      ( aa(filter(nat),$o,aa(filter(nat),fun(filter(nat),$o),ord_less_eq(filter(nat)),F4),at_top(nat))
    <=> ! [N5: nat] : eventually(nat,aa(nat,fun(nat,$o),ord_less_eq(nat),N5),F4) ) ).

% le_sequentially
tff(fact_7465_Bfun__const,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [C2: B,F4: filter(A)] : bfun(A,B,aTP_Lamp_arc(B,fun(A,B),C2),F4) ) ).

% Bfun_const
tff(fact_7466_Bseq__minus__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,aTP_Lamp_cb(fun(nat,A),fun(nat,A),X7),at_top(nat))
        <=> bfun(nat,A,X7,at_top(nat)) ) ) ).

% Bseq_minus_iff
tff(fact_7467_Bseq__subseq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,nat)] :
          ( bfun(nat,A,F3,at_top(nat))
         => bfun(nat,A,aa(fun(nat,nat),fun(nat,A),aTP_Lamp_ard(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),F3),G),at_top(nat)) ) ) ).

% Bseq_subseq
tff(fact_7468_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( bfun(nat,A,aTP_Lamp_cc(fun(nat,A),fun(nat,A),F3),at_top(nat))
        <=> bfun(nat,A,F3,at_top(nat)) ) ) ).

% Bseq_Suc_iff
tff(fact_7469_Bseq__offset,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),K: nat] :
          ( bfun(nat,A,aa(nat,fun(nat,A),aTP_Lamp_are(fun(nat,A),fun(nat,fun(nat,A)),X7),K),at_top(nat))
         => bfun(nat,A,X7,at_top(nat)) ) ) ).

% Bseq_offset
tff(fact_7470_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),K: nat] :
          ( bfun(nat,A,X7,at_top(nat))
         => bfun(nat,A,aa(nat,fun(nat,A),aTP_Lamp_are(fun(nat,A),fun(nat,fun(nat,A)),X7),K),at_top(nat)) ) ) ).

% Bseq_ignore_initial_segment
tff(fact_7471_Bseq__add,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( bfun(nat,A,F3,at_top(nat))
         => bfun(nat,A,aa(A,fun(nat,A),aTP_Lamp_arf(fun(nat,A),fun(A,fun(nat,A)),F3),C2),at_top(nat)) ) ) ).

% Bseq_add
tff(fact_7472_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( bfun(nat,A,aa(A,fun(nat,A),aTP_Lamp_arf(fun(nat,A),fun(A,fun(nat,A)),F3),C2),at_top(nat))
        <=> bfun(nat,A,F3,at_top(nat)) ) ) ).

% Bseq_add_iff
tff(fact_7473_Bseq__mult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( bfun(nat,A,F3,at_top(nat))
         => ( bfun(nat,A,G,at_top(nat))
           => bfun(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_arg(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G),at_top(nat)) ) ) ) ).

% Bseq_mult
tff(fact_7474_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [X2: A] :
          ~ ! [A7: fun(nat,set(A))] :
              ( ! [I4: nat] : aa(set(A),$o,topolo1002775350975398744n_open(A),aa(nat,set(A),A7,I4))
             => ( ! [I4: nat] : aa(set(A),$o,member(A,X2),aa(nat,set(A),A7,I4))
               => ~ ! [S8: set(A)] :
                      ( aa(set(A),$o,topolo1002775350975398744n_open(A),S8)
                     => ( aa(set(A),$o,member(A,X2),S8)
                       => eventually(nat,aa(set(A),fun(nat,$o),aTP_Lamp_arh(fun(nat,set(A)),fun(set(A),fun(nat,$o)),A7),S8),at_top(nat)) ) ) ) ) ) ).

% countable_basis_at_decseq
tff(fact_7475_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F3: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( bfun(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bw(A,fun(fun(nat,A),fun(nat,A)),C2),F3),at_top(nat))
          <=> bfun(nat,A,F3,at_top(nat)) ) ) ) ).

% Bseq_cmult_iff
tff(fact_7476_filterlim__int__of__nat__at__topD,axiom,
    ! [A: $tType,F3: fun(int,A),F4: filter(A)] :
      ( filterlim(nat,A,aTP_Lamp_ari(fun(int,A),fun(nat,A),F3),F4,at_top(nat))
     => filterlim(int,A,F3,F4,at_top(int)) ) ).

% filterlim_int_of_nat_at_topD
tff(fact_7477_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_arj(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),F3),G),at_top(nat))
         => ( summable(real,G)
           => summable(A,F3) ) ) ) ).

% summable_comparison_test_ev
tff(fact_7478_BseqD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
         => ? [K9: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K9)
              & ! [N8: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N8))),K9) ) ) ) ).

% BseqD
tff(fact_7479_BseqE,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
         => ~ ! [K9: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K9)
               => ~ ! [N8: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N8))),K9) ) ) ) ).

% BseqE
tff(fact_7480_BseqI,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [K5: real,X7: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K5)
         => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N))),K5)
           => bfun(nat,A,X7,at_top(nat)) ) ) ) ).

% BseqI
tff(fact_7481_Bseq__def,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N4))),K6) ) ) ) ).

% Bseq_def
tff(fact_7482_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [N5: nat] :
            ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N4))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N5))) ) ) ).

% Bseq_iff1a
tff(fact_7483_Bseq__realpow,axiom,
    ! [X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),one_one(real))
       => bfun(nat,real,power_power(real,X2),at_top(nat)) ) ) ).

% Bseq_realpow
tff(fact_7484_Bseq__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [N5: nat] :
            ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N4))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N5))) ) ) ).

% Bseq_iff
tff(fact_7485_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),K5: real,F4: filter(A)] :
          ( eventually(A,aa(real,fun(A,$o),aTP_Lamp_aqx(fun(A,B),fun(real,fun(A,$o)),F3),K5),F4)
         => bfun(A,B,F3,F4) ) ) ).

% BfunI
tff(fact_7486_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K3)
              & ? [N5: nat] :
                ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,X7,N4)),aa(A,A,uminus_uminus(A),aa(nat,A,X7,N5))))),K3) ) ) ) ).

% Bseq_iff3
tff(fact_7487_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K3)
              & ? [X3: A] :
                ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,X7,N4)),aa(A,A,uminus_uminus(A),X3)))),K3) ) ) ) ).

% Bseq_iff2
tff(fact_7488_Bfun__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),A2: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F4)
         => ( ( A2 != zero_zero(B) )
           => bfun(A,B,aTP_Lamp_ago(fun(A,B),fun(A,B),F3),F4) ) ) ) ).

% Bfun_inverse
tff(fact_7489_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( bfun(A,B,F3,F4)
         => ~ ! [B8: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B8)
               => ~ eventually(A,aa(real,fun(A,$o),aTP_Lamp_aqx(fun(A,B),fun(real,fun(A,$o)),F3),B8),F4) ) ) ) ).

% BfunE
tff(fact_7490_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( real_V8037385150606011577_space(A)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_ark(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),F3),G),at_top(nat))
         => ( filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => summable(A,F3) ) ) ) ).

% summable_bounded_partials
tff(fact_7491_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_arl(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),F3),G),at_top(nat))
         => ( filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => summable(A,F3) ) ) ) ).

% summable_Cauchy'
tff(fact_7492_eventually__all__finite,axiom,
    ! [A: $tType,B: $tType] :
      ( finite_finite(A)
     => ! [P: fun(B,fun(A,$o)),Net: filter(B)] :
          ( ! [Y4: A] : eventually(B,aa(A,fun(B,$o),aTP_Lamp_arm(fun(B,fun(A,$o)),fun(A,fun(B,$o)),P),Y4),Net)
         => eventually(B,aTP_Lamp_arn(fun(B,fun(A,$o)),fun(B,$o),P),Net) ) ) ).

% eventually_all_finite
tff(fact_7493_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_top(A))
         => eventually(A,aTP_Lamp_aro(fun(A,$o),fun(A,$o),P),at_top(A)) ) ) ).

% eventually_all_ge_at_top
tff(fact_7494_Collect__all__eq,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o))] : ( aa(fun(A,$o),set(A),collect(A),aTP_Lamp_arp(fun(A,fun(B,$o)),fun(A,$o),P)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_arr(fun(A,fun(B,$o)),fun(B,set(A)),P)),top_top(set(B)))) ) ).

% Collect_all_eq
tff(fact_7495_finite__set__of__finite__funs,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: set(B),D2: B] :
      ( finite_finite2(A,A3)
     => ( finite_finite2(B,B4)
       => finite_finite2(fun(A,B),aa(fun(fun(A,B),$o),set(fun(A,B)),collect(fun(A,B)),aa(B,fun(fun(A,B),$o),aa(set(B),fun(B,fun(fun(A,B),$o)),aTP_Lamp_ars(set(A),fun(set(B),fun(B,fun(fun(A,B),$o))),A3),B4),D2))) ) ) ).

% finite_set_of_finite_funs
tff(fact_7496_Greatest__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,$o)] : ( order_Greatest(A,P) = the(A,aTP_Lamp_art(fun(A,$o),fun(A,$o),P)) ) ) ).

% Greatest_def
tff(fact_7497_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( ! [F5: fun(nat,A)] :
                ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(nat,A,F5,N8))
               => ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F5,N8)),B2)
                 => ( order_antimono(nat,A,F5)
                   => ( filterlim(nat,A,F5,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
                     => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_aru(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F5),at_top(nat)) ) ) ) )
           => eventually(A,P,topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2))) ) ) ) ).

% sequentially_imp_eventually_at_right
tff(fact_7498_decseq__const,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [K: A] : order_antimono(nat,A,aTP_Lamp_arv(A,fun(nat,A),K)) ) ).

% decseq_const
tff(fact_7499_GreatestI__nat,axiom,
    ! [P: fun(nat,$o),K: nat,B2: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [Y4: nat] :
            ( aa(nat,$o,P,Y4)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y4),B2) )
       => aa(nat,$o,P,order_Greatest(nat,P)) ) ) ).

% GreatestI_nat
tff(fact_7500_Greatest__le__nat,axiom,
    ! [P: fun(nat,$o),K: nat,B2: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [Y4: nat] :
            ( aa(nat,$o,P,Y4)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y4),B2) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),order_Greatest(nat,P)) ) ) ).

% Greatest_le_nat
tff(fact_7501_GreatestI__ex__nat,axiom,
    ! [P: fun(nat,$o),B2: nat] :
      ( ? [X_1: nat] : aa(nat,$o,P,X_1)
     => ( ! [Y4: nat] :
            ( aa(nat,$o,P,Y4)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y4),B2) )
       => aa(nat,$o,P,order_Greatest(nat,P)) ) ) ).

% GreatestI_ex_nat
tff(fact_7502_decseq__SucD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: fun(nat,A),I3: nat] :
          ( order_antimono(nat,A,A3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A3,aa(nat,nat,suc,I3))),aa(nat,A,A3,I3)) ) ) ).

% decseq_SucD
tff(fact_7503_decseq__SucI,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N))),aa(nat,A,X7,N))
         => order_antimono(nat,A,X7) ) ) ).

% decseq_SucI
tff(fact_7504_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A)] :
          ( order_antimono(nat,A,F3)
        <=> ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,aa(nat,nat,suc,N4))),aa(nat,A,F3,N4)) ) ) ).

% decseq_Suc_iff
tff(fact_7505_nhds__countable,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [X2: A] :
          ~ ! [X9: fun(nat,set(A))] :
              ( order_antimono(nat,set(A),X9)
             => ( ! [N8: nat] : aa(set(A),$o,topolo1002775350975398744n_open(A),aa(nat,set(A),X9,N8))
               => ( ! [N8: nat] : aa(set(A),$o,member(A,X2),aa(nat,set(A),X9,N8))
                 => ( topolo7230453075368039082e_nhds(A,X2) != aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(nat),set(filter(A)),image(nat,filter(A),aTP_Lamp_arw(fun(nat,set(A)),fun(nat,filter(A)),X9)),top_top(set(nat)))) ) ) ) ) ) ).

% nhds_countable
tff(fact_7506_LIMSEQ__INF,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [X7: fun(nat,A)] :
          ( order_antimono(nat,A,X7)
         => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,aa(set(A),A,complete_Inf_Inf(A),aa(set(nat),set(A),image(nat,A,X7),top_top(set(nat))))),at_top(nat)) ) ) ).

% LIMSEQ_INF
tff(fact_7507_INF__Lim,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [X7: fun(nat,A),L: A] :
          ( order_antimono(nat,A,X7)
         => ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L),at_top(nat))
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(nat),set(A),image(nat,A,X7),top_top(set(nat)))) = L ) ) ) ) ).

% INF_Lim
tff(fact_7508_tendsto__at__right__sequentially,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,B2: A,X7: fun(A,B),L4: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( ! [S9: fun(nat,A)] :
                ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(nat,A,S9,N8))
               => ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,S9,N8)),B2)
                 => ( order_antimono(nat,A,S9)
                   => ( filterlim(nat,A,S9,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
                     => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_arx(fun(A,B),fun(fun(nat,A),fun(nat,B)),X7),S9),topolo7230453075368039082e_nhds(B,L4),at_top(nat)) ) ) ) )
           => filterlim(A,B,X7,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2))) ) ) ) ).

% tendsto_at_right_sequentially
tff(fact_7509_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ vEBT_VEBT_valid(X2,Xa2)
     => ( ( ? [Uu2: $o,Uv2: $o] : ( X2 = vEBT_Leaf(Uu2,Uv2) )
         => ( Xa2 = one_one(nat) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
              ( ( X2 = vEBT_Node(Mima,Deg,TreeList,Summary) )
             => ( ( Deg = Xa2 )
                & $let(
                    n: nat,
                    n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                    $let(
                      m2: nat,
                      m2 := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                      ( ! [X3: vEBT_VEBT] :
                          ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                         => vEBT_VEBT_valid(X3,n) )
                      & vEBT_VEBT_valid(Summary,m2)
                      & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m2) )
                      & case_option($o,product_prod(nat,nat),
                          ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X16)
                        & ! [X3: vEBT_VEBT] :
                            ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                           => ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X16) ),
                          aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ary(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m2)),Mima) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
tff(fact_7510_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( vEBT_VEBT_valid(X2,Xa2)
     => ( ( ? [Uu2: $o,Uv2: $o] : ( X2 = vEBT_Leaf(Uu2,Uv2) )
         => ( Xa2 != one_one(nat) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
              ( ( X2 = vEBT_Node(Mima,Deg,TreeList,Summary) )
             => ~ ( ( Deg = Xa2 )
                  & $let(
                      n: nat,
                      n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                      $let(
                        m2: nat,
                        m2 := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                        ( ! [X3: vEBT_VEBT] :
                            ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                           => vEBT_VEBT_valid(X3,n) )
                        & vEBT_VEBT_valid(Summary,m2)
                        & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m2) )
                        & case_option($o,product_prod(nat,nat),
                            ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X16)
                          & ! [X3: vEBT_VEBT] :
                              ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                             => ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X16) ),
                            aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ary(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m2)),Mima) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
tff(fact_7511_finite__Collect__bounded__ex,axiom,
    ! [B: $tType,A: $tType,P: fun(A,$o),Q: fun(B,fun(A,$o))] :
      ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),P))
     => ( finite_finite2(B,aa(fun(B,$o),set(B),collect(B),aa(fun(B,fun(A,$o)),fun(B,$o),aTP_Lamp_arz(fun(A,$o),fun(fun(B,fun(A,$o)),fun(B,$o)),P),Q)))
      <=> ! [Y: A] :
            ( aa(A,$o,P,Y)
           => finite_finite2(B,aa(fun(B,$o),set(B),collect(B),aa(A,fun(B,$o),aTP_Lamp_asa(fun(B,fun(A,$o)),fun(A,fun(B,$o)),Q),Y))) ) ) ) ).

% finite_Collect_bounded_ex
tff(fact_7512_INF__bool__eq,axiom,
    ! [A: $tType] : ( aTP_Lamp_asb(set(A),fun(fun(A,$o),$o)) = ball(A) ) ).

% INF_bool_eq
tff(fact_7513_eventually__ball__finite,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(B,fun(A,$o)),Net: filter(B)] :
      ( finite_finite2(A,A3)
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),A3)
           => eventually(B,aa(A,fun(B,$o),aTP_Lamp_asa(fun(B,fun(A,$o)),fun(A,fun(B,$o)),P),X4),Net) )
       => eventually(B,aa(fun(B,fun(A,$o)),fun(B,$o),aTP_Lamp_asc(set(A),fun(fun(B,fun(A,$o)),fun(B,$o)),A3),P),Net) ) ) ).

% eventually_ball_finite
tff(fact_7514_eventually__ball__finite__distrib,axiom,
    ! [A: $tType,B: $tType,A3: set(A),P: fun(B,fun(A,$o)),Net: filter(B)] :
      ( finite_finite2(A,A3)
     => ( eventually(B,aa(fun(B,fun(A,$o)),fun(B,$o),aTP_Lamp_asc(set(A),fun(fun(B,fun(A,$o)),fun(B,$o)),A3),P),Net)
      <=> ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),A3)
           => eventually(B,aa(A,fun(B,$o),aTP_Lamp_asa(fun(B,fun(A,$o)),fun(A,fun(B,$o)),P),X3),Net) ) ) ) ).

% eventually_ball_finite_distrib
tff(fact_7515_eventually__ex,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,$o)),F4: filter(A)] :
      ( eventually(A,aTP_Lamp_asd(fun(A,fun(B,$o)),fun(A,$o),P),F4)
    <=> ? [Y7: fun(A,B)] : eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ase(fun(A,fun(B,$o)),fun(fun(A,B),fun(A,$o)),P),Y7),F4) ) ).

% eventually_ex
tff(fact_7516_Union__SetCompr__eq,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,set(A)),P: fun(B,$o)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aa(fun(B,$o),fun(set(A),$o),aTP_Lamp_asf(fun(B,set(A)),fun(fun(B,$o),fun(set(A),$o)),F3),P))) = aa(fun(A,$o),set(A),collect(A),aa(fun(B,$o),fun(A,$o),aTP_Lamp_asg(fun(B,set(A)),fun(fun(B,$o),fun(A,$o)),F3),P)) ) ).

% Union_SetCompr_eq
tff(fact_7517_Ball__comp__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: fun(B,set(C)),F3: fun(C,$o),G: fun(A,B),X: A] :
      ( aa(A,$o,aa(fun(A,B),fun(A,$o),comp(B,$o,A,aa(fun(C,$o),fun(B,$o),aTP_Lamp_ash(fun(B,set(C)),fun(fun(C,$o),fun(B,$o)),A3),F3)),G),X)
    <=> ! [Xa: C] :
          ( aa(set(C),$o,member(C,Xa),aa(A,set(C),aa(fun(A,B),fun(A,set(C)),comp(B,set(C),A,A3),G),X))
         => aa(C,$o,F3,Xa) ) ) ).

% Ball_comp_iff
tff(fact_7518_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X2: fun(A,fun(A,$o)),Xa2: list(A)] :
      ( ~ sorted_wrt(A,X2,Xa2)
     => ~ ! [X4: A,Ys3: list(A)] :
            ( ( Xa2 = aa(list(A),list(A),cons(A,X4),Ys3) )
           => ( ! [Xa4: A] :
                  ( aa(set(A),$o,member(A,Xa4),aa(list(A),set(A),set2(A),Ys3))
                 => aa(A,$o,aa(A,fun(A,$o),X2,X4),Xa4) )
              & sorted_wrt(A,X2,Ys3) ) ) ) ).

% sorted_wrt.elims(3)
tff(fact_7519_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),X2: A,Ys: list(A)] :
      ( sorted_wrt(A,P,aa(list(A),list(A),cons(A,X2),Ys))
    <=> ( ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Ys))
           => aa(A,$o,aa(A,fun(A,$o),P,X2),X3) )
        & sorted_wrt(A,P,Ys) ) ) ).

% sorted_wrt.simps(2)
tff(fact_7520_open__Collect__ex,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [P: fun(A,fun(B,$o))] :
          ( ! [I2: A] : aa(set(B),$o,topolo1002775350975398744n_open(B),aa(fun(B,$o),set(B),collect(B),aa(A,fun(B,$o),P,I2)))
         => aa(set(B),$o,topolo1002775350975398744n_open(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_asi(fun(A,fun(B,$o)),fun(B,$o),P))) ) ) ).

% open_Collect_ex
tff(fact_7521_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => aa(set(product_prod(A,A)),$o,topolo1002775350975398744n_open(product_prod(A,A)),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_asj(product_prod(A,A),$o))) ) ).

% open_superdiagonal
tff(fact_7522_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => aa(set(product_prod(A,A)),$o,topolo1002775350975398744n_open(product_prod(A,A)),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_ask(product_prod(A,A),$o))) ) ).

% open_subdiagonal
tff(fact_7523_open__diagonal__complement,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => aa(set(product_prod(A,A)),$o,topolo1002775350975398744n_open(product_prod(A,A)),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_asl(product_prod(A,A),$o))) ) ).

% open_diagonal_complement
tff(fact_7524_listrel1__def,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( listrel1(A,R) = aa(fun(product_prod(list(A),list(A)),$o),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),$o)),fun(product_prod(list(A),list(A)),$o),product_case_prod(list(A),list(A),$o),aTP_Lamp_asm(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),R))) ) ).

% listrel1_def
tff(fact_7525_ran__def,axiom,
    ! [A: $tType,B: $tType,Ma: fun(B,option(A))] : ( ran(B,A,Ma) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_asn(fun(B,option(A)),fun(A,$o),Ma)) ) ).

% ran_def
tff(fact_7526_finite__image__set2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: fun(A,$o),Q: fun(B,$o),F3: fun(A,fun(B,C))] :
      ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),P))
     => ( finite_finite2(B,aa(fun(B,$o),set(B),collect(B),Q))
       => finite_finite2(C,aa(fun(C,$o),set(C),collect(C),aa(fun(A,fun(B,C)),fun(C,$o),aa(fun(B,$o),fun(fun(A,fun(B,C)),fun(C,$o)),aTP_Lamp_aso(fun(A,$o),fun(fun(B,$o),fun(fun(A,fun(B,C)),fun(C,$o))),P),Q),F3))) ) ) ).

% finite_image_set2
tff(fact_7527_finite__image__set,axiom,
    ! [B: $tType,A: $tType,P: fun(A,$o),F3: fun(A,B)] :
      ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),P))
     => finite_finite2(B,aa(fun(B,$o),set(B),collect(B),aa(fun(A,B),fun(B,$o),aTP_Lamp_asp(fun(A,$o),fun(fun(A,B),fun(B,$o)),P),F3))) ) ).

% finite_image_set
tff(fact_7528_set__Cons__def,axiom,
    ! [A: $tType,A3: set(A),XS: set(list(A))] : ( set_Cons(A,A3,XS) = aa(fun(list(A),$o),set(list(A)),collect(list(A)),aa(set(list(A)),fun(list(A),$o),aTP_Lamp_asq(set(A),fun(set(list(A)),fun(list(A),$o)),A3),XS)) ) ).

% set_Cons_def
tff(fact_7529_INTER__eq,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3)) = aa(fun(A,$o),set(A),collect(A),aa(set(B),fun(A,$o),aTP_Lamp_asr(fun(B,set(A)),fun(set(B),fun(A,$o)),B4),A3)) ) ).

% INTER_eq
tff(fact_7530_Collect__ball__eq,axiom,
    ! [A: $tType,B: $tType,A3: set(B),P: fun(A,fun(B,$o))] : ( aa(fun(A,$o),set(A),collect(A),aa(fun(A,fun(B,$o)),fun(A,$o),aTP_Lamp_ass(set(B),fun(fun(A,fun(B,$o)),fun(A,$o)),A3),P)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_arr(fun(A,fun(B,$o)),fun(B,set(A)),P)),A3)) ) ).

% Collect_ball_eq
tff(fact_7531_full__SetCompr__eq,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A)] : ( aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ast(fun(B,A),fun(A,$o),F3)) = aa(set(B),set(A),image(B,A,F3),top_top(set(B))) ) ).

% full_SetCompr_eq
tff(fact_7532_Setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B)] : ( aa(fun(A,$o),set(A),collect(A),aa(set(B),fun(A,$o),aTP_Lamp_asu(fun(B,A),fun(set(B),fun(A,$o)),F3),A3)) = aa(set(B),set(A),image(B,A,F3),A3) ) ).

% Setcompr_eq_image
tff(fact_7533_setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),P: fun(B,$o)] : ( aa(fun(A,$o),set(A),collect(A),aa(fun(B,$o),fun(A,$o),aTP_Lamp_asv(fun(B,A),fun(fun(B,$o),fun(A,$o)),F3),P)) = aa(set(B),set(A),image(B,A,F3),aa(fun(B,$o),set(B),collect(B),P)) ) ).

% setcompr_eq_image
tff(fact_7534_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),A3) = aa(set(A),A,complete_Inf_Inf(A),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_asw(set(A),fun(A,$o),A3))) ) ) ).

% Sup_eq_Inf
tff(fact_7535_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),A3) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_asx(set(A),fun(A,$o),A3))) ) ) ).

% Inf_eq_Sup
tff(fact_7536_lex__conv,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( lex(A,R) = aa(fun(product_prod(list(A),list(A)),$o),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),$o)),fun(product_prod(list(A),list(A)),$o),product_case_prod(list(A),list(A),$o),aTP_Lamp_asy(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),R))) ) ).

% lex_conv
tff(fact_7537_Collect__ex__eq,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o))] : ( aa(fun(A,$o),set(A),collect(A),aTP_Lamp_asd(fun(A,fun(B,$o)),fun(A,$o),P)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_arr(fun(A,fun(B,$o)),fun(B,set(A)),P)),top_top(set(B)))) ) ).

% Collect_ex_eq
tff(fact_7538_relcomp__unfold,axiom,
    ! [A: $tType,B: $tType,C: $tType,R: set(product_prod(A,C)),S: set(product_prod(C,B))] : ( relcomp(A,C,B,R,S) = aa(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aa(set(product_prod(C,B)),fun(A,fun(B,$o)),aTP_Lamp_asz(set(product_prod(A,C)),fun(set(product_prod(C,B)),fun(A,fun(B,$o))),R),S))) ) ).

% relcomp_unfold
tff(fact_7539_takeWhile__append,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Ys: list(A)] :
      ( takeWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))
      = $ite(
          ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
           => aa(A,$o,P,X3) ),
          aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),takeWhile(A,P,Ys)),
          takeWhile(A,P,Xs) ) ) ).

% takeWhile_append
tff(fact_7540_dropWhile__append,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Ys: list(A)] :
      ( dropWhile(A,P,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))
      = $ite(
          ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
           => aa(A,$o,P,X3) ),
          dropWhile(A,P,Ys),
          aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),dropWhile(A,P,Xs)),Ys) ) ) ).

% dropWhile_append
tff(fact_7541_graph__def,axiom,
    ! [B: $tType,A: $tType,Ma: fun(A,option(B))] : ( graph(A,B,Ma) = aa(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B)),aTP_Lamp_ata(fun(A,option(B)),fun(product_prod(A,B),$o),Ma)) ) ).

% graph_def
tff(fact_7542_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X2: fun(A,fun(A,$o)),Xa2: list(A),Y2: $o] :
      ( ( sorted_wrt(A,X2,Xa2)
      <=> (Y2) )
     => ( ( ( Xa2 = nil(A) )
         => ~ (Y2) )
       => ~ ! [X4: A,Ys3: list(A)] :
              ( ( Xa2 = aa(list(A),list(A),cons(A,X4),Ys3) )
             => ( (Y2)
              <=> ~ ( ! [Xa: A] :
                        ( aa(set(A),$o,member(A,Xa),aa(list(A),set(A),set2(A),Ys3))
                       => aa(A,$o,aa(A,fun(A,$o),X2,X4),Xa) )
                    & sorted_wrt(A,X2,Ys3) ) ) ) ) ) ).

% sorted_wrt.elims(1)
tff(fact_7543_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X2: fun(A,fun(A,$o)),Xa2: list(A)] :
      ( sorted_wrt(A,X2,Xa2)
     => ( ( Xa2 != nil(A) )
       => ~ ! [X4: A,Ys3: list(A)] :
              ( ( Xa2 = aa(list(A),list(A),cons(A,X4),Ys3) )
             => ~ ( ! [Xa3: A] :
                      ( aa(set(A),$o,member(A,Xa3),aa(list(A),set(A),set2(A),Ys3))
                     => aa(A,$o,aa(A,fun(A,$o),X2,X4),Xa3) )
                  & sorted_wrt(A,X2,Ys3) ) ) ) ) ).

% sorted_wrt.elims(2)
tff(fact_7544_set__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),Xs) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_atb(list(A),fun(A,$o),Xs)) ) ).

% set_conv_nth
tff(fact_7545_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option(product_prod(nat,nat)),Degb: nat,TreeListb: list(vEBT_VEBT),Summaryb: vEBT_VEBT,Deg3: nat] :
      ( vEBT_VEBT_valid(vEBT_Node(Mima2,Degb,TreeListb,Summaryb),Deg3)
    <=> ( ( Degb = Deg3 )
        & $let(
            n: nat,
            n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Degb),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
            $let(
              m2: nat,
              m2 := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Degb),n),
              ( ! [X3: vEBT_VEBT] :
                  ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
                 => vEBT_VEBT_valid(X3,n) )
              & vEBT_VEBT_valid(Summaryb,m2)
              & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeListb) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m2) )
              & case_option($o,product_prod(nat,nat),
                  ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summaryb),X16)
                & ! [X3: vEBT_VEBT] :
                    ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeListb))
                   => ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X16) ),
                  aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ary(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Degb),TreeListb),Summaryb),n),m2)),Mima2) ) ) ) ) ) ).

% VEBT_internal.valid'.simps(2)
tff(fact_7546_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( vEBT_VEBT_valid(X2,Xa2)
      <=> (Y2) )
     => ( ( ? [Uu2: $o,Uv2: $o] : ( X2 = vEBT_Leaf(Uu2,Uv2) )
         => ( (Y2)
          <=> ( Xa2 != one_one(nat) ) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
              ( ( X2 = vEBT_Node(Mima,Deg,TreeList,Summary) )
             => ( (Y2)
              <=> ~ ( ( Deg = Xa2 )
                    & $let(
                        n: nat,
                        n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                        $let(
                          m2: nat,
                          m2 := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                          ( ! [X3: vEBT_VEBT] :
                              ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                             => vEBT_VEBT_valid(X3,n) )
                          & vEBT_VEBT_valid(Summary,m2)
                          & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m2) )
                          & case_option($o,product_prod(nat,nat),
                              ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X16)
                            & ! [X3: vEBT_VEBT] :
                                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                               => ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X16) ),
                              aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ary(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m2)),Mima) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
tff(fact_7547_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ vEBT_VEBT_valid(X2,Xa2)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2 = vEBT_Leaf(Uu2,Uv2) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(Uu2,Uv2)),Xa2))
               => ( Xa2 = one_one(nat) ) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(Mima,Deg,TreeList,Summary) )
               => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Mima,Deg,TreeList,Summary)),Xa2))
                 => ( ( Deg = Xa2 )
                    & $let(
                        n: nat,
                        n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                        $let(
                          m2: nat,
                          m2 := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                          ( ! [X3: vEBT_VEBT] :
                              ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                             => vEBT_VEBT_valid(X3,n) )
                          & vEBT_VEBT_valid(Summary,m2)
                          & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m2) )
                          & case_option($o,product_prod(nat,nat),
                              ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X16)
                            & ! [X3: vEBT_VEBT] :
                                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                               => ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X16) ),
                              aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ary(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m2)),Mima) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
tff(fact_7548_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( vEBT_VEBT_valid(X2,Xa2)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2 = vEBT_Leaf(Uu2,Uv2) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(Uu2,Uv2)),Xa2))
               => ( Xa2 != one_one(nat) ) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(Mima,Deg,TreeList,Summary) )
               => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Mima,Deg,TreeList,Summary)),Xa2))
                 => ~ ( ( Deg = Xa2 )
                      & $let(
                          n: nat,
                          n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                          $let(
                            m2: nat,
                            m2 := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                            ( ! [X3: vEBT_VEBT] :
                                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                               => vEBT_VEBT_valid(X3,n) )
                            & vEBT_VEBT_valid(Summary,m2)
                            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m2) )
                            & case_option($o,product_prod(nat,nat),
                                ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X16)
                              & ! [X3: vEBT_VEBT] :
                                  ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                 => ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X16) ),
                                aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ary(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m2)),Mima) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
tff(fact_7549_Inf__Sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(A))] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_atc(set(set(A)),fun(set(A),$o),A3)))) ) ) ).

% Inf_Sup
tff(fact_7550_SUP__INF__set,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [G: fun(B,A),A3: set(set(B))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(set(B)),set(A),image(set(B),A,aTP_Lamp_atd(fun(B,A),fun(set(B),A),G)),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(set(B)),set(A),image(set(B),A,aTP_Lamp_ate(fun(B,A),fun(set(B),A),G)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_atf(set(set(B)),fun(set(B),$o),A3)))) ) ) ).

% SUP_INF_set
tff(fact_7551_INF__SUP__set,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [G: fun(B,A),A3: set(set(B))] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(set(B)),set(A),image(set(B),A,aTP_Lamp_ate(fun(B,A),fun(set(B),A),G)),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(set(B)),set(A),image(set(B),A,aTP_Lamp_atd(fun(B,A),fun(set(B),A),G)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_atf(set(set(B)),fun(set(B),$o),A3)))) ) ) ).

% INF_SUP_set
tff(fact_7552_Sup__Inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(A))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_atc(set(set(A)),fun(set(A),$o),A3)))) ) ) ).

% Sup_Inf
tff(fact_7553_Pow__Compl,axiom,
    ! [A: $tType,A3: set(A)] : ( pow2(A,aa(set(A),set(A),uminus_uminus(set(A)),A3)) = aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_atg(set(A),fun(set(A),$o),A3)) ) ).

% Pow_Compl
tff(fact_7554_Inter__eq,axiom,
    ! [A: $tType,A3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3) = aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ath(set(set(A)),fun(A,$o),A3)) ) ).

% Inter_eq
tff(fact_7555_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(A))] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_atc(set(set(A)),fun(set(A),$o),A3))))) ) ).

% Inf_Sup_le
tff(fact_7556_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(set(A))] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_ati(set(set(A)),fun(set(A),$o),A3))))),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A3))) ) ).

% Sup_Inf_le
tff(fact_7557_Sup__int__def,axiom,
    ! [X7: set(int)] : ( aa(set(int),int,complete_Sup_Sup(int),X7) = the(int,aTP_Lamp_atj(set(int),fun(int,$o),X7)) ) ).

% Sup_int_def
tff(fact_7558_Union__maximal__sets,axiom,
    ! [A: $tType,F9: set(set(A))] :
      ( finite_finite2(set(A),F9)
     => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_atk(set(set(A)),fun(set(A),$o),F9))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),F9) ) ) ).

% Union_maximal_sets
tff(fact_7559_Inf__filter__def,axiom,
    ! [A: $tType,S3: set(filter(A))] : ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),S3) = aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),aa(fun(filter(A),$o),set(filter(A)),collect(filter(A)),aTP_Lamp_atl(set(filter(A)),fun(filter(A),$o),S3))) ) ).

% Inf_filter_def
tff(fact_7560_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( vEBT_VEBT_valid(X2,Xa2)
      <=> (Y2) )
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),X2),Xa2))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X2 = vEBT_Leaf(Uu2,Uv2) )
             => ( ( (Y2)
                <=> ( Xa2 = one_one(nat) ) )
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Leaf(Uu2,Uv2)),Xa2)) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                ( ( X2 = vEBT_Node(Mima,Deg,TreeList,Summary) )
               => ( ( (Y2)
                  <=> ( ( Deg = Xa2 )
                      & $let(
                          n: nat,
                          n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                          $let(
                            m2: nat,
                            m2 := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                            ( ! [X3: vEBT_VEBT] :
                                ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                               => vEBT_VEBT_valid(X3,n) )
                            & vEBT_VEBT_valid(Summary,m2)
                            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m2) )
                            & case_option($o,product_prod(nat,nat),
                                ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X16)
                              & ! [X3: vEBT_VEBT] :
                                  ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                 => ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X16) ),
                                aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ary(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m2)),Mima) ) ) ) ) )
                 => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),aa(vEBT_VEBT,fun(nat,product_prod(vEBT_VEBT,nat)),product_Pair(vEBT_VEBT,nat),vEBT_Node(Mima,Deg,TreeList,Summary)),Xa2)) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
tff(fact_7561_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [A3: set(set(A))] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aTP_Lamp_atm(set(set(A)),fun(set(A),$o),A3))))) ) ).

% finite_Inf_Sup
tff(fact_7562_lexn__conv,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Nb: nat] : ( aa(nat,set(product_prod(list(A),list(A))),lexn(A,R),Nb) = aa(fun(product_prod(list(A),list(A)),$o),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),$o)),fun(product_prod(list(A),list(A)),$o),product_case_prod(list(A),list(A),$o),aa(nat,fun(list(A),fun(list(A),$o)),aTP_Lamp_atn(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),$o))),R),Nb))) ) ).

% lexn_conv
tff(fact_7563_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( aa(nat,set(product_prod(list(A),list(A))),lexn(A,R),zero_zero(nat)) = bot_bot(set(product_prod(list(A),list(A)))) ) ).

% lexn.simps(1)
tff(fact_7564_lexn__length,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A)),Nb: nat] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),aa(nat,set(product_prod(list(A),list(A))),lexn(A,R),Nb))
     => ( ( aa(list(A),nat,size_size(list(A)),Xs) = Nb )
        & ( aa(list(A),nat,size_size(list(A)),Ys) = Nb ) ) ) ).

% lexn_length
tff(fact_7565_lex__def,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( lex(A,R) = aa(set(set(product_prod(list(A),list(A)))),set(product_prod(list(A),list(A))),complete_Sup_Sup(set(product_prod(list(A),list(A)))),aa(set(nat),set(set(product_prod(list(A),list(A)))),image(nat,set(product_prod(list(A),list(A))),lexn(A,R)),top_top(set(nat)))) ) ).

% lex_def
tff(fact_7566_finite__inf__Sup,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [A2: A,A3: set(A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),aa(set(A),A,complete_Sup_Sup(A),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,$o),set(A),collect(A),aa(set(A),fun(A,$o),aTP_Lamp_ato(A,fun(set(A),fun(A,$o)),A2),A3))) ) ) ).

% finite_inf_Sup
tff(fact_7567_mlex__eq,axiom,
    ! [A: $tType,F3: fun(A,nat),R3: set(product_prod(A,A))] : ( mlex_prod(A,F3,R3) = aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aTP_Lamp_atp(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,$o))),F3),R3))) ) ).

% mlex_eq
tff(fact_7568_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: fun(B,A),Y5: set(B),X7: set(A),F4: filter(B),F3: fun(A,C)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G),Y5)),X7)
     => ( eventually(B,aTP_Lamp_atq(set(B),fun(B,$o),Y5),F4)
       => ( map_filter_on(A,C,X7,F3,map_filter_on(B,A,Y5,G,F4)) = map_filter_on(B,C,Y5,aa(fun(B,A),fun(B,C),comp(A,C,B,F3),G),F4) ) ) ) ).

% map_filter_on_comp
tff(fact_7569_eventually__map__filter__on,axiom,
    ! [B: $tType,A: $tType,X7: set(A),F4: filter(A),P: fun(B,$o),F3: fun(A,B)] :
      ( eventually(A,aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),X7),F4)
     => ( eventually(B,P,map_filter_on(A,B,X7,F3,F4))
      <=> eventually(A,aa(fun(A,B),fun(A,$o),aa(fun(B,$o),fun(fun(A,B),fun(A,$o)),aTP_Lamp_atr(set(A),fun(fun(B,$o),fun(fun(A,B),fun(A,$o))),X7),P),F3),F4) ) ) ).

% eventually_map_filter_on
tff(fact_7570_mlex__iff,axiom,
    ! [A: $tType,X2: A,Y2: A,F3: fun(A,nat),R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),mlex_prod(A,F3,R3))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F3,X2)),aa(A,nat,F3,Y2))
        | ( ( aa(A,nat,F3,X2) = aa(A,nat,F3,Y2) )
          & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),R3) ) ) ) ).

% mlex_iff
tff(fact_7571_mlex__less,axiom,
    ! [A: $tType,F3: fun(A,nat),X2: A,Y2: A,R3: set(product_prod(A,A))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F3,X2)),aa(A,nat,F3,Y2))
     => aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),mlex_prod(A,F3,R3)) ) ).

% mlex_less
tff(fact_7572_in__measure,axiom,
    ! [A: $tType,X2: A,Y2: A,F3: fun(A,nat)] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),measure(A,F3))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F3,X2)),aa(A,nat,F3,Y2)) ) ).

% in_measure
tff(fact_7573_in__finite__psubset,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( aa(set(product_prod(set(A),set(A))),$o,member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),A3),B4)),finite_psubset(A))
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
        & finite_finite2(A,B4) ) ) ).

% in_finite_psubset
tff(fact_7574_finite__psubset__def,axiom,
    ! [A: $tType] : ( finite_psubset(A) = aa(fun(product_prod(set(A),set(A)),$o),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),$o)),fun(product_prod(set(A),set(A)),$o),product_case_prod(set(A),set(A),$o),aTP_Lamp_ats(set(A),fun(set(A),$o)))) ) ).

% finite_psubset_def
tff(fact_7575_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist(A)
        & topolo7287701948861334536_space(A) )
     => ! [F4: filter(A)] :
          ( topolo6773858410816713723filter(A,F4)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [P6: fun(A,$o)] :
                  ( eventually(A,P6,F4)
                  & ! [X3: A,Y: A] :
                      ( ( aa(A,$o,P6,X3)
                        & aa(A,$o,P6,Y) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,Y)),E3) ) ) ) ) ) ).

% cauchy_filter_metric
tff(fact_7576_GMVT,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),G: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X4: real] :
            ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X4,top_top(set(real))),F3) )
       => ( ! [X4: real] :
              ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2) )
             => differentiable(real,real,F3,topolo174197925503356063within(real,X4,top_top(set(real)))) )
         => ( ! [X4: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2) )
               => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X4,top_top(set(real))),G) )
           => ( ! [X4: real] :
                  ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
                    & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2) )
                 => differentiable(real,real,G,topolo174197925503356063within(real,X4,top_top(set(real)))) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( has_field_derivative(real,G,G_c,topolo174197925503356063within(real,C3,top_top(set(real))))
                  & has_field_derivative(real,F3,F_c,topolo174197925503356063within(real,C3,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),C3),B2)
                  & ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2))),G_c) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,G,B2)),aa(real,real,G,A2))),F_c) ) ) ) ) ) ) ) ).

% GMVT
tff(fact_7577_differentiable__cmult__left__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [C2: B,Q2: fun(A,B),T2: A] :
          ( differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_att(B,fun(fun(A,B),fun(A,B)),C2),Q2),topolo174197925503356063within(A,T2,top_top(set(A))))
        <=> ( ( C2 = zero_zero(B) )
            | differentiable(A,B,Q2,topolo174197925503356063within(A,T2,top_top(set(A)))) ) ) ) ).

% differentiable_cmult_left_iff
tff(fact_7578_differentiable__cmult__right__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Q2: fun(A,B),C2: B,T2: A] :
          ( differentiable(A,B,aa(B,fun(A,B),aTP_Lamp_atu(fun(A,B),fun(B,fun(A,B)),Q2),C2),topolo174197925503356063within(A,T2,top_top(set(A))))
        <=> ( ( C2 = zero_zero(B) )
            | differentiable(A,B,Q2,topolo174197925503356063within(A,T2,top_top(set(A)))) ) ) ) ).

% differentiable_cmult_right_iff
tff(fact_7579_differentiable__in__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(A,B),G: fun(C,A),X2: C,S: set(C)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,aa(C,A,G,X2),aa(set(C),set(A),image(C,A,G),S)))
         => ( differentiable(C,A,G,topolo174197925503356063within(C,X2,S))
           => differentiable(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aca(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G),topolo174197925503356063within(C,X2,S)) ) ) ) ).

% differentiable_in_compose
tff(fact_7580_differentiable__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,real),X2: A,S: set(A),G: fun(A,B)] :
          ( differentiable(A,real,F3,topolo174197925503356063within(A,X2,S))
         => ( differentiable(A,B,G,topolo174197925503356063within(A,X2,S))
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abj(fun(A,real),fun(fun(A,B),fun(A,B)),F3),G),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% differentiable_scaleR
tff(fact_7581_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [F3: fun(A,B),X2: A,S: set(A),G: fun(A,B)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,X2,S))
         => ( differentiable(A,B,G,topolo174197925503356063within(A,X2,S))
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aby(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% differentiable_mult
tff(fact_7582_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F4: filter(A),G: fun(A,B)] :
          ( differentiable(A,B,F3,F4)
         => ( differentiable(A,B,G,F4)
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abv(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),F4) ) ) ) ).

% differentiable_add
tff(fact_7583_differentiable__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: B,F4: filter(A)] : differentiable(A,B,aTP_Lamp_abp(B,fun(A,B),A2),F4) ) ).

% differentiable_const
tff(fact_7584_differentiable__ident,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F4: filter(A)] : differentiable(A,A,aTP_Lamp_abs(A,A),F4) ) ).

% differentiable_ident
tff(fact_7585_differentiable__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F4: filter(A)] :
          ( differentiable(A,B,F3,F4)
         => differentiable(A,B,aTP_Lamp_abo(fun(A,B),fun(A,B),F3),F4) ) ) ).

% differentiable_minus
tff(fact_7586_differentiable__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F4: filter(A),G: fun(A,B)] :
          ( differentiable(A,B,F3,F4)
         => ( differentiable(A,B,G,F4)
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abn(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),F4) ) ) ) ).

% differentiable_diff
tff(fact_7587_differentiable__sum,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [S: set(A),F3: fun(A,fun(B,C)),Net: filter(B)] :
          ( finite_finite2(A,S)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),S)
               => differentiable(B,C,aa(A,fun(B,C),F3,X4),Net) )
           => differentiable(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_abm(set(A),fun(fun(A,fun(B,C)),fun(B,C)),S),F3),Net) ) ) ) ).

% differentiable_sum
tff(fact_7588_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),X2: A,S: set(A),Nb: nat] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,X2,S))
         => differentiable(A,B,aa(nat,fun(A,B),aTP_Lamp_acp(fun(A,B),fun(nat,fun(A,B)),F3),Nb),topolo174197925503356063within(A,X2,S)) ) ) ).

% differentiable_power
tff(fact_7589_differentiable__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(A,B),G: fun(C,A),X2: C,S: set(C)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,aa(C,A,G,X2),top_top(set(A))))
         => ( differentiable(C,A,G,topolo174197925503356063within(C,X2,S))
           => differentiable(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aca(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G),topolo174197925503356063within(C,X2,S)) ) ) ) ).

% differentiable_compose
tff(fact_7590_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),X2: A,S: set(A),G: fun(A,B)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,X2,S))
         => ( differentiable(A,B,G,topolo174197925503356063within(A,X2,S))
           => ( ( aa(A,B,G,X2) != zero_zero(B) )
             => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acg(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo174197925503356063within(A,X2,S)) ) ) ) ) ).

% differentiable_divide
tff(fact_7591_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),X2: A,S: set(A)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,X2,S))
         => ( ( aa(A,B,F3,X2) != zero_zero(B) )
           => differentiable(A,B,aTP_Lamp_atv(fun(A,B),fun(A,B),F3),topolo174197925503356063within(A,X2,S)) ) ) ) ).

% differentiable_inverse
tff(fact_7592_nhds__generated__topology,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [T4: set(set(A)),X2: A] :
          ( ( topolo1002775350975398744n_open(A) = topolo8378437560675496660pology(A,T4) )
         => ( topolo7230453075368039082e_nhds(A,X2) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(set(A)),set(filter(A)),image(set(A),filter(A),principal(A)),aa(fun(set(A),$o),set(set(A)),collect(set(A)),aa(A,fun(set(A),$o),aTP_Lamp_atw(set(set(A)),fun(A,fun(set(A),$o)),T4),X2)))) ) ) ) ).

% nhds_generated_topology
tff(fact_7593_continuous__at__Sup__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & topolo1944317154257567458pology(A)
        & condit6923001295902523014norder(B)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),S3: set(A)] :
          ( order_antimono(A,B,F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,aa(set(A),A,complete_Sup_Sup(A),S3),aa(A,set(A),set_ord_lessThan(A),aa(set(A),A,complete_Sup_Sup(A),S3))),F3)
           => ( ( S3 != bot_bot(set(A)) )
             => ( condit941137186595557371_above(A,S3)
               => ( aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),S3)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),S3)) ) ) ) ) ) ) ).

% continuous_at_Sup_antimono
tff(fact_7594_bdd__above__UN,axiom,
    ! [B: $tType,A: $tType] :
      ( lattice(B)
     => ! [I5: set(A),A3: fun(A,set(B))] :
          ( finite_finite2(A,I5)
         => ( condit941137186595557371_above(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5)))
          <=> ! [X3: A] :
                ( aa(set(A),$o,member(A,X3),I5)
               => condit941137186595557371_above(B,aa(A,set(B),A3,X3)) ) ) ) ) ).

% bdd_above_UN
tff(fact_7595_differentiable__cnj__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(A,complex),X2: A,A3: set(A)] :
          ( differentiable(A,complex,aTP_Lamp_aeo(fun(A,complex),fun(A,complex),F3),topolo174197925503356063within(A,X2,A3))
        <=> differentiable(A,complex,F3,topolo174197925503356063within(A,X2,A3)) ) ) ).

% differentiable_cnj_iff
tff(fact_7596_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Y2: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,X7)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),aa(set(A),A,complete_Sup_Sup(A),X7))
            <=> ? [X3: A] :
                  ( aa(set(A),$o,member(A,X3),X7)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),X3) ) ) ) ) ) ).

% less_cSup_iff
tff(fact_7597_cSUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F3: fun(B,A),A3: set(B),Y2: A,I3: B] :
          ( condit941137186595557371_above(A,aa(set(B),set(A),image(B,A,F3),A3))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))),Y2)
           => ( aa(set(B),$o,member(B,I3),A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,I3)),Y2) ) ) ) ) ).

% cSUP_lessD
tff(fact_7598_generate__topology__Union,axiom,
    ! [B: $tType,A: $tType,I5: set(A),S3: set(set(B)),K5: fun(A,set(B))] :
      ( ! [K2: A] :
          ( aa(set(A),$o,member(A,K2),I5)
         => aa(set(B),$o,topolo8378437560675496660pology(B,S3),aa(A,set(B),K5,K2)) )
     => aa(set(B),$o,topolo8378437560675496660pology(B,S3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),K5),I5))) ) ).

% generate_topology_Union
tff(fact_7599_less__cSUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [A3: set(A),F3: fun(A,B),A2: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(B,aa(set(A),set(B),image(A,B,F3),A3))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A2),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3)))
            <=> ? [X3: A] :
                  ( aa(set(A),$o,member(A,X3),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A2),aa(A,B,F3,X3)) ) ) ) ) ) ).

% less_cSUP_iff
tff(fact_7600_cSup__cInf,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S3: set(A)] :
          ( ( S3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,S3)
           => ( aa(set(A),A,complete_Sup_Sup(A),S3) = aa(set(A),A,complete_Inf_Inf(A),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_atx(set(A),fun(A,$o),S3))) ) ) ) ) ).

% cSup_cInf
tff(fact_7601_cSUP__UNION,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(A),B4: fun(A,set(B)),F3: fun(B,C)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => ( aa(A,set(B),B4,X4) != bot_bot(set(B)) ) )
           => ( condit941137186595557371_above(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image(A,set(C),aa(fun(B,C),fun(A,set(C)),aTP_Lamp_aty(fun(A,set(B)),fun(fun(B,C),fun(A,set(C))),B4),F3)),A3)))
             => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image(B,C,F3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3)))) = aa(set(C),C,complete_Sup_Sup(C),aa(set(A),set(C),image(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_atz(fun(A,set(B)),fun(fun(B,C),fun(A,C)),B4),F3)),A3)) ) ) ) ) ) ).

% cSUP_UNION
tff(fact_7602_Bseq__bdd__above_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
         => condit941137186595557371_above(real,aa(set(nat),set(real),image(nat,real,aTP_Lamp_cp(fun(nat,A),fun(nat,real),X7)),top_top(set(nat)))) ) ) ).

% Bseq_bdd_above'
tff(fact_7603_continuous__at__Inf__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & topolo1944317154257567458pology(A)
        & condit6923001295902523014norder(B)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),S3: set(A)] :
          ( order_antimono(A,B,F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,aa(set(A),A,complete_Inf_Inf(A),S3),aa(A,set(A),set_ord_greaterThan(A),aa(set(A),A,complete_Inf_Inf(A),S3))),F3)
           => ( ( S3 != bot_bot(set(A)) )
             => ( condit1013018076250108175_below(A,S3)
               => ( aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),S3)) = aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),S3)) ) ) ) ) ) ) ).

% continuous_at_Inf_antimono
tff(fact_7604_MVT,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ( ! [X4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2)
               => differentiable(real,real,F3,topolo174197925503356063within(real,X4,top_top(set(real)))) ) )
         => ? [L2: real,Z2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
              & has_field_derivative(real,F3,L2,topolo174197925503356063within(real,Z2,top_top(set(real))))
              & ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),L2) ) ) ) ) ) ).

% MVT
tff(fact_7605_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [F3: fun(B,A),G: fun(B,A),A3: set(B)] :
          ( condit1013018076250108175_below(A,aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_aua(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G)),A3))
        <=> ( condit1013018076250108175_below(A,aa(set(B),set(A),image(B,A,F3),A3))
            & condit1013018076250108175_below(A,aa(set(B),set(A),image(B,A,G),A3)) ) ) ) ).

% bdd_below_image_inf
tff(fact_7606_bdd__below__UN,axiom,
    ! [B: $tType,A: $tType] :
      ( lattice(B)
     => ! [I5: set(A),A3: fun(A,set(B))] :
          ( finite_finite2(A,I5)
         => ( condit1013018076250108175_below(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5)))
          <=> ! [X3: A] :
                ( aa(set(A),$o,member(A,X3),I5)
               => condit1013018076250108175_below(B,aa(A,set(B),A3,X3)) ) ) ) ) ).

% bdd_below_UN
tff(fact_7607_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: set(A),F3: fun(A,A)] :
          ( topolo81223032696312382ous_on(A,A,S,F3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),S)
               => ( cos(A,aa(A,A,F3,X4)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(A,A,S,aTP_Lamp_agl(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_on_tan
tff(fact_7608_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ? [A7: set(A)] :
                ( aa(set(A),$o,topolo1002775350975398744n_open(A),A7)
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A7),S) = aa(fun(A,$o),set(A),collect(A),aa(fun(A,real),fun(A,$o),aa(fun(A,real),fun(fun(A,real),fun(A,$o)),aTP_Lamp_aub(set(A),fun(fun(A,real),fun(fun(A,real),fun(A,$o))),S),F3),G)) ) ) ) ) ) ).

% open_Collect_less_Int
tff(fact_7609_continuous__on__open__UN,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [S3: set(A),A3: fun(A,set(B)),F3: fun(B,C)] :
          ( ! [S2: A] :
              ( aa(set(A),$o,member(A,S2),S3)
             => aa(set(B),$o,topolo1002775350975398744n_open(B),aa(A,set(B),A3,S2)) )
         => ( ! [S2: A] :
                ( aa(set(A),$o,member(A,S2),S3)
               => topolo81223032696312382ous_on(B,C,aa(A,set(B),A3,S2),F3) )
           => topolo81223032696312382ous_on(B,C,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),S3)),F3) ) ) ) ).

% continuous_on_open_UN
tff(fact_7610_continuous__on__Pair,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,C)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,C,S,G)
           => topolo81223032696312382ous_on(A,product_prod(B,C),S,aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_auc(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),F3),G)) ) ) ) ).

% continuous_on_Pair
tff(fact_7611_continuous__on__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [T2: set(A),G: fun(A,B),S: set(C),F3: fun(C,A)] :
          ( topolo81223032696312382ous_on(A,B,T2,G)
         => ( topolo81223032696312382ous_on(C,A,S,F3)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,F3),S)),T2)
             => topolo81223032696312382ous_on(C,B,S,aa(fun(C,A),fun(C,B),aTP_Lamp_aud(fun(A,B),fun(fun(C,A),fun(C,B)),G),F3)) ) ) ) ) ).

% continuous_on_compose2
tff(fact_7612_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Y2: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,X7)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),X7)),Y2)
            <=> ? [X3: A] :
                  ( aa(set(A),$o,member(A,X3),X7)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y2) ) ) ) ) ) ).

% cInf_less_iff
tff(fact_7613_open__Collect__neq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topological_t2_space(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,top_top(set(A)),F3)
         => ( topolo81223032696312382ous_on(A,B,top_top(set(A)),G)
           => aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_aue(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G))) ) ) ) ).

% open_Collect_neq
tff(fact_7614_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,top_top(set(A)),F3)
         => ( topolo81223032696312382ous_on(A,B,top_top(set(A)),G)
           => aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_auf(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G))) ) ) ) ).

% open_Collect_less
tff(fact_7615_bounded__linear_Ocontinuous__on,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),S: set(C),G: fun(C,A)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( topolo81223032696312382ous_on(C,A,S,G)
           => topolo81223032696312382ous_on(C,B,S,aa(fun(C,A),fun(C,B),aTP_Lamp_aug(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G)) ) ) ) ).

% bounded_linear.continuous_on
tff(fact_7616_continuous__on__powr,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),S)
                 => ( aa(A,real,F3,X4) != zero_zero(real) ) )
             => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_auh(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% continuous_on_powr
tff(fact_7617_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),S)
               => ( aa(A,real,F3,X4) != zero_zero(real) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_aui(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_on_ln
tff(fact_7618_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),S)
               => ( aa(A,B,F3,X4) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_auj(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_on_sgn
tff(fact_7619_continuous__on__max,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => ( topolo81223032696312382ous_on(A,B,A3,G)
           => topolo81223032696312382ous_on(A,B,A3,aa(fun(A,B),fun(A,B),aTP_Lamp_auk(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_max
tff(fact_7620_continuous__on__rabs,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_aul(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_on_rabs
tff(fact_7621_continuous__on__arsinh_H,axiom,
    ! [A3: set(real),F3: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A3,F3)
     => topolo81223032696312382ous_on(real,real,A3,aTP_Lamp_aum(fun(real,real),fun(real,real),F3)) ) ).

% continuous_on_arsinh'
tff(fact_7622_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),C2: B] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aa(B,fun(A,B),aTP_Lamp_aun(fun(A,B),fun(B,fun(A,B)),F3),C2)) ) ) ).

% continuous_on_mult_right
tff(fact_7623_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),C2: B] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aa(B,fun(A,B),aTP_Lamp_auo(fun(A,B),fun(B,fun(A,B)),F3),C2)) ) ) ).

% continuous_on_mult_left
tff(fact_7624_continuous__on__mult_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4211221413907600880p_mult(B) )
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => ( topolo81223032696312382ous_on(A,B,A3,G)
           => topolo81223032696312382ous_on(A,B,A3,aa(fun(A,B),fun(A,B),aTP_Lamp_aup(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_mult'
tff(fact_7625_continuous__on__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_auq(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_mult
tff(fact_7626_continuous__on__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_aur(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_add
tff(fact_7627_continuous__on__arctan,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_aus(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_on_arctan
tff(fact_7628_continuous__on__pochhammer_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),Nb: nat] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aa(nat,fun(A,B),aTP_Lamp_aut(fun(A,B),fun(nat,fun(A,B)),F3),Nb)) ) ) ).

% continuous_on_pochhammer'
tff(fact_7629_continuous__on__pochhammer,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A3: set(A),Nb: nat] : topolo81223032696312382ous_on(A,A,A3,aTP_Lamp_ahz(nat,fun(A,A),Nb)) ) ).

% continuous_on_pochhammer
tff(fact_7630_continuous__on__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [S: set(A),F3: fun(A,real),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_auu(fun(A,real),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_scaleR
tff(fact_7631_continuous__on__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_aft(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_cos
tff(fact_7632_continuous__on__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_afu(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_sin
tff(fact_7633_continuous__on__exp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_auv(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_exp
tff(fact_7634_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_auw(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_on_real_sqrt
tff(fact_7635_continuous__on__power_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1898628316856586783d_mult(B) )
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,nat)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => ( topolo81223032696312382ous_on(A,nat,A3,G)
           => topolo81223032696312382ous_on(A,B,A3,aa(fun(A,nat),fun(A,B),aTP_Lamp_aux(fun(A,B),fun(fun(A,nat),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_power'
tff(fact_7636_continuous__on__power,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),Nb: nat] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aa(nat,fun(A,B),aTP_Lamp_auy(fun(A,B),fun(nat,fun(A,B)),F3),Nb)) ) ) ).

% continuous_on_power
tff(fact_7637_continuous__on__id,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A)] : topolo81223032696312382ous_on(A,A,S,aTP_Lamp_adm(A,A)) ) ).

% continuous_on_id
tff(fact_7638_continuous__on__const,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),C2: B] : topolo81223032696312382ous_on(A,B,S,aTP_Lamp_auz(B,fun(A,B),C2)) ) ).

% continuous_on_const
tff(fact_7639_continuous__on__of__real,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [S: set(A),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,G)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_ava(fun(A,real),fun(A,B),G)) ) ) ).

% continuous_on_of_real
tff(fact_7640_continuous__on__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_avb(fun(A,B),fun(A,real),F3)) ) ) ).

% continuous_on_norm
tff(fact_7641_continuous__on__cosh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A3: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => topolo81223032696312382ous_on(A,B,A3,aTP_Lamp_avc(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_cosh
tff(fact_7642_continuous__on__sinh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A3: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => topolo81223032696312382ous_on(A,B,A3,aTP_Lamp_avd(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_sinh
tff(fact_7643_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real),Nb: nat] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => topolo81223032696312382ous_on(A,real,S,aa(nat,fun(A,real),aTP_Lamp_ave(fun(A,real),fun(nat,fun(A,real)),F3),Nb)) ) ) ).

% continuous_on_real_root
tff(fact_7644_continuous__on__prod,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & real_V4412858255891104859lgebra(C)
        & comm_ring_1(C) )
     => ! [S3: set(A),S: set(B),F3: fun(A,fun(B,C))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),S3)
             => topolo81223032696312382ous_on(B,C,S,aa(A,fun(B,C),F3,I2)) )
         => topolo81223032696312382ous_on(B,C,S,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_avg(set(A),fun(fun(A,fun(B,C)),fun(B,C)),S3),F3)) ) ) ).

% continuous_on_prod
tff(fact_7645_continuous__on__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4987421752381908075d_mult(C) )
     => ! [I5: set(A),S3: set(B),F3: fun(A,fun(B,C))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => topolo81223032696312382ous_on(B,C,S3,aa(A,fun(B,C),F3,I2)) )
         => topolo81223032696312382ous_on(B,C,S3,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_avi(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3)) ) ) ).

% continuous_on_prod'
tff(fact_7646_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [S: set(A),C2: A] : topolo81223032696312382ous_on(A,A,S,aa(A,fun(A,A),times_times(A),C2)) ) ).

% continuous_on_mult_const
tff(fact_7647_continuous__on__minus,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_avj(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_minus
tff(fact_7648_continuous__on__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_avk(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_diff
tff(fact_7649_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),S)
                 => ( aa(A,B,G,X4) != zero_zero(B) ) )
             => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_avl(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ) ).

% continuous_on_divide
tff(fact_7650_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),S)
               => ( aa(A,B,F3,X4) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_avm(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_on_inverse
tff(fact_7651_continuous__on__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo5987344860129210374id_add(C) )
     => ! [I5: set(A),S3: set(B),F3: fun(A,fun(B,C))] :
          ( ! [I2: A] :
              ( aa(set(A),$o,member(A,I2),I5)
             => topolo81223032696312382ous_on(B,C,S3,aa(A,fun(B,C),F3,I2)) )
         => topolo81223032696312382ous_on(B,C,S3,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_avo(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3)) ) ) ).

% continuous_on_sum
tff(fact_7652_continuous__on__fst,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [S: set(A),F3: fun(A,product_prod(B,C))] :
          ( topolo81223032696312382ous_on(A,product_prod(B,C),S,F3)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_avp(fun(A,product_prod(B,C)),fun(A,B),F3)) ) ) ).

% continuous_on_fst
tff(fact_7653_continuous__on__snd,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [S: set(A),F3: fun(A,product_prod(B,C))] :
          ( topolo81223032696312382ous_on(A,product_prod(B,C),S,F3)
         => topolo81223032696312382ous_on(A,C,S,aTP_Lamp_avq(fun(A,product_prod(B,C)),fun(A,C),F3)) ) ) ).

% continuous_on_snd
tff(fact_7654_continuous__on__dist,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,real,S,aa(fun(A,B),fun(A,real),aTP_Lamp_avr(fun(A,B),fun(fun(A,B),fun(A,real)),F3),G)) ) ) ) ).

% continuous_on_dist
tff(fact_7655_continuous__on__tendsto__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),G: fun(C,A),L: A,F4: filter(C)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( filterlim(C,A,G,topolo7230453075368039082e_nhds(A,L),F4)
           => ( aa(set(A),$o,member(A,L),S)
             => ( eventually(C,aa(fun(C,A),fun(C,$o),aTP_Lamp_avs(set(A),fun(fun(C,A),fun(C,$o)),S),G),F4)
               => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aed(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(A,B,F3,L)),F4) ) ) ) ) ) ).

% continuous_on_tendsto_compose
tff(fact_7656_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: set(A),F3: fun(A,A)] :
          ( topolo81223032696312382ous_on(A,A,S,F3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),S)
               => ( sin(A,aa(A,A,F3,X4)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(A,A,S,aTP_Lamp_ahc(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_on_cot
tff(fact_7657_continuous__on__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A3: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => ( cosh(B,aa(A,B,F3,X4)) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,A3,aTP_Lamp_avt(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_on_tanh
tff(fact_7658_less__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F3: fun(B,A),A3: set(B),Y2: A,I3: B] :
          ( condit1013018076250108175_below(A,aa(set(B),set(A),image(B,A,F3),A3))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3)))
           => ( aa(set(B),$o,member(B,I3),A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),aa(B,A,F3,I3)) ) ) ) ) ).

% less_cINF_D
tff(fact_7659_continuous__on__arcosh_H,axiom,
    ! [A3: set(real),F3: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A3,F3)
     => ( ! [X4: real] :
            ( aa(set(real),$o,member(real,X4),A3)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,F3,X4)) )
       => topolo81223032696312382ous_on(real,real,A3,aTP_Lamp_avu(fun(real,real),fun(real,real),F3)) ) ) ).

% continuous_on_arcosh'
tff(fact_7660_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ? [A7: set(A)] :
              ( aa(set(A),$o,topolo1002775350975398744n_open(A),A7)
              & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A7),S) = aa(fun(A,$o),set(A),collect(A),aa(fun(A,real),fun(A,$o),aTP_Lamp_avv(set(A),fun(fun(A,real),fun(A,$o)),S),F3)) ) ) ) ) ).

% open_Collect_positive
tff(fact_7661_continuous__on__powr_H,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),S)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,F3,X4))
                    & ( ( aa(A,real,F3,X4) = zero_zero(real) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X4)) ) ) )
             => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_auh(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% continuous_on_powr'
tff(fact_7662_continuous__on__log,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),S)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,X4)) )
             => ( ! [X4: A] :
                    ( aa(set(A),$o,member(A,X4),S)
                   => ( aa(A,real,F3,X4) != one_one(real) ) )
               => ( ! [X4: A] :
                      ( aa(set(A),$o,member(A,X4),S)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X4)) )
                 => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_avw(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ) ) ).

% continuous_on_log
tff(fact_7663_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),S)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,F3,X4))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,F3,X4)),one_one(real)) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_avx(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_on_arccos
tff(fact_7664_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),S)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,F3,X4))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,F3,X4)),one_one(real)) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_avy(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_on_arcsin
tff(fact_7665_cINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [A3: set(A),F3: fun(A,B),A2: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(B,aa(set(A),set(B),image(A,B,F3),A3))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),A2)
            <=> ? [X3: A] :
                  ( aa(set(A),$o,member(A,X3),A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X3)),A2) ) ) ) ) ) ).

% cINF_less_iff
tff(fact_7666_cINF__inf__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(B,aa(set(A),set(B),image(A,B,F3),A3))
           => ( condit1013018076250108175_below(B,aa(set(A),set(B),image(A,B,G),A3))
             => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,G),A3))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_avz(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)),A3)) ) ) ) ) ) ).

% cINF_inf_distrib
tff(fact_7667_cSUP__eq__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F3: fun(B,A),A3: set(B),A2: B] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image(B,A,F3),A3))
           => ( condit1013018076250108175_below(A,aa(set(B),set(A),image(B,A,F3),A3))
             => ( aa(set(B),$o,member(B,A2),A3)
               => ( aa(B,A,F3,A2) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3)) ) ) ) ) ) ) ).

% cSUP_eq_cINF_D
tff(fact_7668_continuous__on__artanh_H,axiom,
    ! [A3: set(real),F3: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A3,F3)
     => ( ! [X4: real] :
            ( aa(set(real),$o,member(real,X4),A3)
           => aa(set(real),$o,member(real,aa(real,real,F3,X4)),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real))) )
       => topolo81223032696312382ous_on(real,real,A3,aTP_Lamp_awa(fun(real,real),fun(real,real),F3)) ) ) ).

% continuous_on_artanh'
tff(fact_7669_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),F8: fun(real,fun(real,real))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ( aa(real,real,F3,A2) = aa(real,real,F3,B2) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
         => ( ! [X4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2)
                 => has_derivative(real,real,F3,aa(real,fun(real,real),F8,X4),topolo174197925503356063within(real,X4,top_top(set(real)))) ) )
           => ? [Z2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
                & ! [X: real] : ( aa(real,real,aa(real,fun(real,real),F8,Z2),X) = zero_zero(real) ) ) ) ) ) ) ).

% Rolle_deriv
tff(fact_7670_mvt,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),F8: fun(real,fun(real,real))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ( ! [X4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2)
               => has_derivative(real,real,F3,aa(real,fun(real,real),F8,X4),topolo174197925503356063within(real,X4,top_top(set(real)))) ) )
         => ~ ! [Xi: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Xi)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xi),B2)
                 => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) != aa(real,real,aa(real,fun(real,real),F8,Xi),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)) ) ) ) ) ) ) ).

% mvt
tff(fact_7671_continuous__on__of__int__floor,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => topolo81223032696312382ous_on(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),ring_1_Ints(A)),aTP_Lamp_awb(A,B)) ) ).

% continuous_on_of_int_floor
tff(fact_7672_continuous__on__of__int__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => topolo81223032696312382ous_on(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),ring_1_Ints(A)),aTP_Lamp_awc(A,B)) ) ).

% continuous_on_of_int_ceiling
tff(fact_7673_cInf__cSup,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S3: set(A)] :
          ( ( S3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,S3)
           => ( aa(set(A),A,complete_Inf_Inf(A),S3) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_awd(set(A),fun(A,$o),S3))) ) ) ) ) ).

% cInf_cSup
tff(fact_7674_cINF__UNION,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A3: set(A),B4: fun(A,set(B)),F3: fun(B,C)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => ( aa(A,set(B),B4,X4) != bot_bot(set(B)) ) )
           => ( condit1013018076250108175_below(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image(A,set(C),aa(fun(B,C),fun(A,set(C)),aTP_Lamp_aty(fun(A,set(B)),fun(fun(B,C),fun(A,set(C))),B4),F3)),A3)))
             => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image(B,C,F3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3)))) = aa(set(C),C,complete_Inf_Inf(C),aa(set(A),set(C),image(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_awe(fun(A,set(B)),fun(fun(B,C),fun(A,C)),B4),F3)),A3)) ) ) ) ) ) ).

% cINF_UNION
tff(fact_7675_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,B2: A,F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A2,B2),F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,F3,B2)),topolo174197925503356063within(A,B2,aa(A,set(A),set_ord_lessThan(A),B2))) ) ) ) ).

% continuous_on_Icc_at_leftD
tff(fact_7676_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,B2: A,F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A2,B2),F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,F3,A2)),topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2))) ) ) ) ).

% continuous_on_Icc_at_rightD
tff(fact_7677_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F3,Y3,topolo174197925503356063within(real,X4,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y3) ) ) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,A2)),aa(real,real,F3,B2)) ) ) ) ).

% DERIV_pos_imp_increasing_open
tff(fact_7678_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F3,Y3,topolo174197925503356063within(real,X4,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),zero_zero(real)) ) ) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) ) ) ) ).

% DERIV_neg_imp_decreasing_open
tff(fact_7679_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ( ! [X4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2)
               => has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,X4,top_top(set(real)))) ) )
         => ( aa(real,real,F3,B2) = aa(real,real,F3,A2) ) ) ) ) ).

% DERIV_isconst_end
tff(fact_7680_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),X2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ( ! [X4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2)
               => has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,X4,top_top(set(real)))) ) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X2),B2)
             => ( aa(real,real,F3,X2) = aa(real,real,F3,A2) ) ) ) ) ) ) ).

% DERIV_isconst2
tff(fact_7681_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),A2: A,B2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,F3,A2)),topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_greaterThan(A),A2)))
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,F3,B2)),topolo174197925503356063within(A,B2,aa(A,set(A),set_ord_lessThan(A),B2)))
           => ( ! [X4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X4)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),B2)
                   => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,F3,X4)),topolo174197925503356063within(A,X4,top_top(set(A)))) ) )
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
               => topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A2,B2),F3) ) ) ) ) ) ).

% continuous_on_IccI
tff(fact_7682_Rolle,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ( aa(real,real,F3,A2) = aa(real,real,F3,B2) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
         => ( ! [X4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X4),B2)
                 => differentiable(real,real,F3,topolo174197925503356063within(real,X4,top_top(set(real)))) ) )
           => ? [Z2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
                & has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,Z2,top_top(set(real)))) ) ) ) ) ) ).

% Rolle
tff(fact_7683_LIMSEQ__decseq__INF,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [X7: fun(nat,A)] :
          ( condit1013018076250108175_below(A,aa(set(nat),set(A),image(nat,A,X7),top_top(set(nat))))
         => ( order_antimono(nat,A,X7)
           => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,aa(set(A),A,complete_Inf_Inf(A),aa(set(nat),set(A),image(nat,A,X7),top_top(set(nat))))),at_top(nat)) ) ) ) ).

% LIMSEQ_decseq_INF
tff(fact_7684_ord_OLeast__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,$o)),P: fun(A,$o)] : ( least(A,Less_eq,P) = the(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_awf(fun(A,fun(A,$o)),fun(fun(A,$o),fun(A,$o)),Less_eq),P)) ) ).

% ord.Least_def
tff(fact_7685_lexord__def,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( lexord(A,R) = aa(fun(product_prod(list(A),list(A)),$o),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),$o)),fun(product_prod(list(A),list(A)),$o),product_case_prod(list(A),list(A),$o),aTP_Lamp_awg(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),R))) ) ).

% lexord_def
tff(fact_7686_continuous__on__of__real__o__iff,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S3: set(A),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,complex,S3,aTP_Lamp_awh(fun(A,real),fun(A,complex),G))
        <=> topolo81223032696312382ous_on(A,real,S3,G) ) ) ).

% continuous_on_of_real_o_iff
tff(fact_7687_lexord__cons__cons,axiom,
    ! [A: $tType,A2: A,X2: list(A),B2: A,Y2: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,A2),X2)),aa(list(A),list(A),cons(A,B2),Y2))),lexord(A,R))
    <=> ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A2),B2)),R)
        | ( ( A2 = B2 )
          & aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),Y2)),lexord(A,R)) ) ) ) ).

% lexord_cons_cons
tff(fact_7688_lexord__Nil__left,axiom,
    ! [A: $tType,Y2: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Y2)),lexord(A,R))
    <=> ? [A6: A,X3: list(A)] : ( Y2 = aa(list(A),list(A),cons(A,A6),X3) ) ) ).

% lexord_Nil_left
tff(fact_7689_continuous__on__cnj,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),G: fun(A,complex)] :
          ( topolo81223032696312382ous_on(A,complex,S,G)
         => topolo81223032696312382ous_on(A,complex,S,aTP_Lamp_awi(fun(A,complex),fun(A,complex),G)) ) ) ).

% continuous_on_cnj
tff(fact_7690_continuous__on__Re,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),G: fun(A,complex)] :
          ( topolo81223032696312382ous_on(A,complex,S,G)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_awj(fun(A,complex),fun(A,real),G)) ) ) ).

% continuous_on_Re
tff(fact_7691_continuous__on__cis,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [A3: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,A3,F3)
         => topolo81223032696312382ous_on(A,complex,A3,aTP_Lamp_awk(fun(A,real),fun(A,complex),F3)) ) ) ).

% continuous_on_cis
tff(fact_7692_continuous__on__Im,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),G: fun(A,complex)] :
          ( topolo81223032696312382ous_on(A,complex,S,G)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_awl(fun(A,complex),fun(A,real),G)) ) ) ).

% continuous_on_Im
tff(fact_7693_lexord__Nil__right,axiom,
    ! [A: $tType,X2: list(A),R: set(product_prod(A,A))] : ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),nil(A))),lexord(A,R)) ).

% lexord_Nil_right
tff(fact_7694_lexord__irreflexive,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Xs: list(A)] :
      ( ! [X4: A] : ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4)),R)
     => ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Xs)),lexord(A,R)) ) ).

% lexord_irreflexive
tff(fact_7695_lexord__linear,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),X2: list(A),Y2: list(A)] :
      ( ! [A4: A,B3: A] :
          ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),B3)),R)
          | ( A4 = B3 )
          | aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B3),A4)),R) )
     => ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),Y2)),lexord(A,R))
        | ( X2 = Y2 )
        | aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Y2),X2)),lexord(A,R)) ) ) ).

% lexord_linear
tff(fact_7696_lexord__append__leftI,axiom,
    ! [A: $tType,U: list(A),V: list(A),R: set(product_prod(A,A)),X2: list(A)] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),U),V)),lexord(A,R))
     => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X2),U)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X2),V))),lexord(A,R)) ) ).

% lexord_append_leftI
tff(fact_7697_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list(A),R: set(product_prod(A,A)),Ys: list(A),Zs: list(A)] :
      ( ! [X4: A,Y4: A,Z2: A] :
          ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
         => ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y4)),R)
           => ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z2)),R)
             => aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Z2)),R) ) ) )
     => ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lexord(A,R))
       => ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs)),lexord(A,R))
         => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Zs)),lexord(A,R)) ) ) ) ).

% lexord_partial_trans
tff(fact_7698_lexord__append__leftD,axiom,
    ! [A: $tType,X2: list(A),U: list(A),V: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X2),U)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X2),V))),lexord(A,R))
     => ( ! [A4: A] : ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A4),A4)),R)
       => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),U),V)),lexord(A,R)) ) ) ).

% lexord_append_leftD
tff(fact_7699_lexord__append__rightI,axiom,
    ! [A: $tType,Y2: list(A),X2: list(A),R: set(product_prod(A,A))] :
      ( ? [B12: A,Z3: list(A)] : ( Y2 = aa(list(A),list(A),cons(A,B12),Z3) )
     => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X2),Y2))),lexord(A,R)) ) ).

% lexord_append_rightI
tff(fact_7700_lexord__sufE,axiom,
    ! [A: $tType,Xs: list(A),Zs: list(A),Ys: list(A),Qs: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Qs))),lexord(A,R))
     => ( ( Xs != Ys )
       => ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
         => ( ( aa(list(A),nat,size_size(list(A)),Zs) = aa(list(A),nat,size_size(list(A)),Qs) )
           => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lexord(A,R)) ) ) ) ) ).

% lexord_sufE
tff(fact_7701_lexord__lex,axiom,
    ! [A: $tType,X2: list(A),Y2: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),Y2)),lex(A,R))
    <=> ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),Y2)),lexord(A,R))
        & ( aa(list(A),nat,size_size(list(A)),X2) = aa(list(A),nat,size_size(list(A)),Y2) ) ) ) ).

% lexord_lex
tff(fact_7702_lexord__append__left__rightI,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),U: list(A),X2: list(A),Y2: list(A)] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A2),B2)),R)
     => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),aa(list(A),list(A),cons(A,A2),X2))),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),aa(list(A),list(A),cons(A,B2),Y2)))),lexord(A,R)) ) ).

% lexord_append_left_rightI
tff(fact_7703_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lexord(A,R))
    <=> ( ? [X3: A] :
            ( aa(set(A),$o,member(A,X3),aa(list(A),set(A),set2(A),Xs))
            & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),X3)),R) )
        | aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs)),lexord(A,R)) ) ) ).

% lexord_same_pref_iff
tff(fact_7704_lexord__sufI,axiom,
    ! [A: $tType,U: list(A),W: list(A),R: set(product_prod(A,A)),V: list(A),Z: list(A)] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),U),W)),lexord(A,R))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),W)),aa(list(A),nat,size_size(list(A)),U))
       => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),V)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),W),Z))),lexord(A,R)) ) ) ).

% lexord_sufI
tff(fact_7705_List_Olexordp__def,axiom,
    ! [A: $tType,R: fun(A,fun(A,$o)),Xs: list(A),Ys: list(A)] :
      ( lexordp(A,R,Xs,Ys)
    <=> aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lexord(A,aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),R)))) ) ).

% List.lexordp_def
tff(fact_7706_lex__prod__def,axiom,
    ! [A: $tType,B: $tType,Ra: set(product_prod(A,A)),Rb: set(product_prod(B,B))] : ( lex_prod(A,B,Ra,Rb) = aa(fun(product_prod(product_prod(A,B),product_prod(A,B)),$o),set(product_prod(product_prod(A,B),product_prod(A,B))),collect(product_prod(product_prod(A,B),product_prod(A,B))),aa(fun(product_prod(A,B),fun(product_prod(A,B),$o)),fun(product_prod(product_prod(A,B),product_prod(A,B)),$o),product_case_prod(product_prod(A,B),product_prod(A,B),$o),aa(fun(A,fun(B,fun(product_prod(A,B),$o))),fun(product_prod(A,B),fun(product_prod(A,B),$o)),product_case_prod(A,B,fun(product_prod(A,B),$o)),aa(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),$o))),aTP_Lamp_awn(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),$o)))),Ra),Rb)))) ) ).

% lex_prod_def
tff(fact_7707_same__fst__def,axiom,
    ! [B: $tType,A: $tType,P: fun(A,$o),R3: fun(A,set(product_prod(B,B)))] : ( same_fst(A,B,P,R3) = aa(fun(product_prod(product_prod(A,B),product_prod(A,B)),$o),set(product_prod(product_prod(A,B),product_prod(A,B))),collect(product_prod(product_prod(A,B),product_prod(A,B))),aa(fun(product_prod(A,B),fun(product_prod(A,B),$o)),fun(product_prod(product_prod(A,B),product_prod(A,B)),$o),product_case_prod(product_prod(A,B),product_prod(A,B),$o),aa(fun(A,fun(B,fun(product_prod(A,B),$o))),fun(product_prod(A,B),fun(product_prod(A,B),$o)),product_case_prod(A,B,fun(product_prod(A,B),$o)),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),$o))),aTP_Lamp_awp(fun(A,$o),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),$o)))),P),R3)))) ) ).

% same_fst_def
tff(fact_7708_dual__Min,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( lattices_Min(A,aTP_Lamp_ans(A,fun(A,$o))) = lattic643756798349783984er_Max(A) ) ) ).

% dual_Min
tff(fact_7709_Succ__def,axiom,
    ! [A: $tType,Kl: set(list(A)),Kl2: list(A)] : ( bNF_Greatest_Succ(A,Kl,Kl2) = aa(fun(A,$o),set(A),collect(A),aa(list(A),fun(A,$o),aTP_Lamp_awq(set(list(A)),fun(list(A),fun(A,$o)),Kl),Kl2)) ) ).

% Succ_def
tff(fact_7710_uniformity__dist,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ( topolo7806501430040627800ormity(A) = aa(set(filter(product_prod(A,A))),filter(product_prod(A,A)),complete_Inf_Inf(filter(product_prod(A,A))),aa(set(real),set(filter(product_prod(A,A))),image(real,filter(product_prod(A,A)),aTP_Lamp_aws(real,filter(product_prod(A,A)))),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ) ) ).

% uniformity_dist
tff(fact_7711_uniformity__sym,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [E5: fun(product_prod(A,A),$o)] :
          ( eventually(product_prod(A,A),E5,topolo7806501430040627800ormity(A))
         => eventually(product_prod(A,A),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aTP_Lamp_awt(fun(product_prod(A,A),$o),fun(A,fun(A,$o)),E5)),topolo7806501430040627800ormity(A)) ) ) ).

% uniformity_sym
tff(fact_7712_open__uniformity,axiom,
    ! [A: $tType] :
      ( topolo569519726778239578ormity(A)
     => ! [U4: set(A)] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),U4)
        <=> ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),U4)
             => eventually(product_prod(A,A),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aa(A,fun(A,fun(A,$o)),aTP_Lamp_awu(set(A),fun(A,fun(A,fun(A,$o))),U4),X3)),topolo7806501430040627800ormity(A)) ) ) ) ).

% open_uniformity
tff(fact_7713_uniformity__real__def,axiom,
    topolo7806501430040627800ormity(real) = aa(set(filter(product_prod(real,real))),filter(product_prod(real,real)),complete_Inf_Inf(filter(product_prod(real,real))),aa(set(real),set(filter(product_prod(real,real))),image(real,filter(product_prod(real,real)),aTP_Lamp_aww(real,filter(product_prod(real,real)))),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ).

% uniformity_real_def
tff(fact_7714_uniformity__complex__def,axiom,
    topolo7806501430040627800ormity(complex) = aa(set(filter(product_prod(complex,complex))),filter(product_prod(complex,complex)),complete_Inf_Inf(filter(product_prod(complex,complex))),aa(set(real),set(filter(product_prod(complex,complex))),image(real,filter(product_prod(complex,complex)),aTP_Lamp_awy(real,filter(product_prod(complex,complex)))),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real)))) ).

% uniformity_complex_def
tff(fact_7715_eventually__nhds__uniformity,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [P: fun(A,$o),X2: A] :
          ( eventually(A,P,topolo7230453075368039082e_nhds(A,X2))
        <=> eventually(product_prod(A,A),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aa(A,fun(A,fun(A,$o)),aTP_Lamp_awz(fun(A,$o),fun(A,fun(A,fun(A,$o))),P),X2)),topolo7806501430040627800ormity(A)) ) ) ).

% eventually_nhds_uniformity
tff(fact_7716_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [P: fun(product_prod(A,A),$o)] :
          ( eventually(product_prod(A,A),P,topolo7806501430040627800ormity(A))
        <=> ? [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
              & ! [X3: A,Y: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,Y)),E3)
                 => aa(product_prod(A,A),$o,P,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y)) ) ) ) ) ).

% eventually_uniformity_metric
tff(fact_7717_tendsto__iff__uniformity,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo7287701948861334536_space(B)
     => ! [F3: fun(A,B),L: B,F4: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F4)
        <=> ! [E6: fun(product_prod(B,B),$o)] :
              ( eventually(product_prod(B,B),E6,topolo7806501430040627800ormity(B))
             => eventually(A,aa(fun(product_prod(B,B),$o),fun(A,$o),aa(B,fun(fun(product_prod(B,B),$o),fun(A,$o)),aTP_Lamp_axa(fun(A,B),fun(B,fun(fun(product_prod(B,B),$o),fun(A,$o))),F3),L),E6),F4) ) ) ) ).

% tendsto_iff_uniformity
tff(fact_7718_relpow__finite__bounded1,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),K: nat] :
      ( finite_finite2(product_prod(A,A),R3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),K),R3)),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_axb(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_axc(set(product_prod(A,A)),fun(nat,$o),R3))))) ) ) ).

% relpow_finite_bounded1
tff(fact_7719_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S3: set(A),C6: set(B),F3: fun(B,set(A))] :
          ( topolo2193935891317330818ompact(A,S3)
         => ( ! [T6: B] :
                ( aa(set(B),$o,member(B,T6),C6)
               => aa(set(A),$o,topolo1002775350975398744n_open(A),aa(B,set(A),F3,T6)) )
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),C6)))
             => ~ ! [C8: set(B)] :
                    ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C8),C6)
                   => ( finite_finite2(B,C8)
                     => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),C8))) ) ) ) ) ) ) ).

% compactE_image
tff(fact_7720_finite__relpow,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Nb: nat] :
      ( finite_finite2(product_prod(A,A),R3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
       => finite_finite2(product_prod(A,A),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3)) ) ) ).

% finite_relpow
tff(fact_7721_open__complex__def,axiom,
    ! [U4: set(complex)] :
      ( aa(set(complex),$o,topolo1002775350975398744n_open(complex),U4)
    <=> ! [X3: complex] :
          ( aa(set(complex),$o,member(complex,X3),U4)
         => eventually(product_prod(complex,complex),aa(fun(complex,fun(complex,$o)),fun(product_prod(complex,complex),$o),product_case_prod(complex,complex,$o),aa(complex,fun(complex,fun(complex,$o)),aTP_Lamp_axd(set(complex),fun(complex,fun(complex,fun(complex,$o))),U4),X3)),topolo7806501430040627800ormity(complex)) ) ) ).

% open_complex_def
tff(fact_7722_open__real__def,axiom,
    ! [U4: set(real)] :
      ( aa(set(real),$o,topolo1002775350975398744n_open(real),U4)
    <=> ! [X3: real] :
          ( aa(set(real),$o,member(real,X3),U4)
         => eventually(product_prod(real,real),aa(fun(real,fun(real,$o)),fun(product_prod(real,real),$o),product_case_prod(real,real,$o),aa(real,fun(real,fun(real,$o)),aTP_Lamp_axe(set(real),fun(real,fun(real,fun(real,$o))),U4),X3)),topolo7806501430040627800ormity(real)) ) ) ).

% open_real_def
tff(fact_7723_relpow_Osimps_I2_J,axiom,
    ! [A: $tType,Nb: nat,R3: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Nb)),R3) = relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3),R3) ) ).

% relpow.simps(2)
tff(fact_7724_relpow__add,axiom,
    ! [A: $tType,Ma: nat,Nb: nat,R3: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Ma),Nb)),R3) = relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Ma),R3),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3)) ) ).

% relpow_add
tff(fact_7725_relpow__0__I,axiom,
    ! [A: $tType,X2: A,R3: set(product_prod(A,A))] : aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),zero_zero(nat)),R3)) ).

% relpow_0_I
tff(fact_7726_relpow__0__E,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),zero_zero(nat)),R3))
     => ( X2 = Y2 ) ) ).

% relpow_0_E
tff(fact_7727_relpow__Suc__I2,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set(product_prod(A,A)),Z: A,Nb: nat] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),R3)
     => ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3))
       => aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Nb)),R3)) ) ) ).

% relpow_Suc_I2
tff(fact_7728_relpow__Suc__E2,axiom,
    ! [A: $tType,X2: A,Z: A,Nb: nat,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Nb)),R3))
     => ~ ! [Y4: A] :
            ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y4)),R3)
           => ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3)) ) ) ).

% relpow_Suc_E2
tff(fact_7729_relpow__Suc__D2,axiom,
    ! [A: $tType,X2: A,Z: A,Nb: nat,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Nb)),R3))
     => ? [Y4: A] :
          ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y4)),R3)
          & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3)) ) ) ).

% relpow_Suc_D2
tff(fact_7730_relpow__Suc__I,axiom,
    ! [A: $tType,X2: A,Y2: A,Nb: nat,R3: set(product_prod(A,A)),Z: A] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3))
     => ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z)),R3)
       => aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Nb)),R3)) ) ) ).

% relpow_Suc_I
tff(fact_7731_relpow__Suc__E,axiom,
    ! [A: $tType,X2: A,Z: A,Nb: nat,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Nb)),R3))
     => ~ ! [Y4: A] :
            ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y4)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3))
           => ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z)),R3) ) ) ).

% relpow_Suc_E
tff(fact_7732_relpowp__relpow__eq,axiom,
    ! [A: $tType,Nb: nat,R3: set(product_prod(A,A)),X: A,Xa3: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Nb),aTP_Lamp_axf(set(product_prod(A,A)),fun(A,fun(A,$o)),R3)),X),Xa3)
    <=> aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Xa3)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3)) ) ).

% relpowp_relpow_eq
tff(fact_7733_relpow__E2,axiom,
    ! [A: $tType,X2: A,Z: A,Nb: nat,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3))
     => ( ( ( Nb = zero_zero(nat) )
         => ( X2 != Z ) )
       => ~ ! [Y4: A,M3: nat] :
              ( ( Nb = aa(nat,nat,suc,M3) )
             => ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y4)),R3)
               => ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M3),R3)) ) ) ) ) ).

% relpow_E2
tff(fact_7734_relpow__E,axiom,
    ! [A: $tType,X2: A,Z: A,Nb: nat,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3))
     => ( ( ( Nb = zero_zero(nat) )
         => ( X2 != Z ) )
       => ~ ! [Y4: A,M3: nat] :
              ( ( Nb = aa(nat,nat,suc,M3) )
             => ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y4)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M3),R3))
               => ~ aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z)),R3) ) ) ) ) ).

% relpow_E
tff(fact_7735_relpow__empty,axiom,
    ! [A: $tType,Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ) ).

% relpow_empty
tff(fact_7736_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,Nb: nat,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A2),B2)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Nb),R3))
    <=> ? [F6: fun(nat,A)] :
          ( ( aa(nat,A,F6,zero_zero(nat)) = A2 )
          & ( aa(nat,A,F6,Nb) = B2 )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Nb)
             => aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(nat,A,F6,I)),aa(nat,A,F6,aa(nat,nat,suc,I)))),R3) ) ) ) ).

% relpow_fun_conv
tff(fact_7737_relpow__finite__bounded,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),K: nat] :
      ( finite_finite2(product_prod(A,A),R3)
     => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),K),R3)),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_axb(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_axg(set(product_prod(A,A)),fun(nat,$o),R3))))) ) ).

% relpow_finite_bounded
tff(fact_7738_ntrancl__def,axiom,
    ! [A: $tType,Nb: nat,R3: set(product_prod(A,A))] : ( transitive_ntrancl(A,Nb,R3) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_axb(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_axh(nat,fun(nat,$o),Nb)))) ) ).

% ntrancl_def
tff(fact_7739_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( finite_finite2(product_prod(A,A),R3)
     => ( transitive_trancl(A,R3) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_axb(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_axc(set(product_prod(A,A)),fun(nat,$o),R3)))) ) ) ).

% trancl_finite_eq_relpow
tff(fact_7740_ntrancl__Zero,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( transitive_ntrancl(A,zero_zero(nat),R3) = R3 ) ).

% ntrancl_Zero
tff(fact_7741_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list(product_prod(A,A))] : ( transitive_trancl(A,aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs)) = transitive_ntrancl(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(product_prod(A,A),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs))),one_one(nat)),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs)) ) ).

% trancl_set_ntrancl
tff(fact_7742_trancl__power,axiom,
    ! [A: $tType,P2: product_prod(A,A),R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),P2),transitive_trancl(A,R3))
    <=> ? [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N4)
          & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),P2),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N4),R3)) ) ) ).

% trancl_power
tff(fact_7743_uniformity__trans_H,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [E5: fun(product_prod(A,A),$o)] :
          ( eventually(product_prod(A,A),E5,topolo7806501430040627800ormity(A))
         => eventually(product_prod(product_prod(A,A),product_prod(A,A)),aa(fun(product_prod(A,A),fun(product_prod(A,A),$o)),fun(product_prod(product_prod(A,A),product_prod(A,A)),$o),product_case_prod(product_prod(A,A),product_prod(A,A),$o),aa(fun(A,fun(A,fun(product_prod(A,A),$o))),fun(product_prod(A,A),fun(product_prod(A,A),$o)),product_case_prod(A,A,fun(product_prod(A,A),$o)),aTP_Lamp_axj(fun(product_prod(A,A),$o),fun(A,fun(A,fun(product_prod(A,A),$o))),E5))),prod_filter(product_prod(A,A),product_prod(A,A),topolo7806501430040627800ormity(A),topolo7806501430040627800ormity(A))) ) ) ).

% uniformity_trans'
tff(fact_7744_prod__filter__INF2,axiom,
    ! [C: $tType,B: $tType,A: $tType,J5: set(A),A3: filter(B),B4: fun(A,filter(C))] :
      ( ( J5 != bot_bot(set(A)) )
     => ( prod_filter(B,C,A3,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(A),set(filter(C)),image(A,filter(C),B4),J5))) = aa(set(filter(product_prod(B,C))),filter(product_prod(B,C)),complete_Inf_Inf(filter(product_prod(B,C))),aa(set(A),set(filter(product_prod(B,C))),image(A,filter(product_prod(B,C)),aa(fun(A,filter(C)),fun(A,filter(product_prod(B,C))),aTP_Lamp_axk(filter(B),fun(fun(A,filter(C)),fun(A,filter(product_prod(B,C)))),A3),B4)),J5)) ) ) ).

% prod_filter_INF2
tff(fact_7745_filterlim__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: fun(A,B),G3: filter(B),F4: filter(A),G: fun(A,C),H5: filter(C)] :
      ( filterlim(A,B,F3,G3,F4)
     => ( filterlim(A,C,G,H5,F4)
       => filterlim(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_axl(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),F3),G),prod_filter(B,C,G3,H5),F4) ) ) ).

% filterlim_Pair
tff(fact_7746_tendsto__mult__Pair,axiom,
    ! [A: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [A2: A,B2: A] : filterlim(product_prod(A,A),A,aTP_Lamp_axm(product_prod(A,A),A),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),prod_filter(A,A,topolo7230453075368039082e_nhds(A,A2),topolo7230453075368039082e_nhds(A,B2))) ) ).

% tendsto_mult_Pair
tff(fact_7747_tendsto__add__Pair,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [A2: A,B2: A] : filterlim(product_prod(A,A),A,aTP_Lamp_axn(product_prod(A,A),A),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),prod_filter(A,A,topolo7230453075368039082e_nhds(A,A2),topolo7230453075368039082e_nhds(A,B2))) ) ).

% tendsto_add_Pair
tff(fact_7748_eventually__prodI,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F4: filter(A),Q: fun(B,$o),G3: filter(B)] :
      ( eventually(A,P,F4)
     => ( eventually(B,Q,G3)
       => eventually(product_prod(A,B),aa(fun(B,$o),fun(product_prod(A,B),$o),aTP_Lamp_axo(fun(A,$o),fun(fun(B,$o),fun(product_prod(A,B),$o)),P),Q),prod_filter(A,B,F4,G3)) ) ) ).

% eventually_prodI
tff(fact_7749_eventually__prod1,axiom,
    ! [A: $tType,B: $tType,B4: filter(A),P: fun(B,$o),A3: filter(B)] :
      ( ( B4 != bot_bot(filter(A)) )
     => ( eventually(product_prod(B,A),aa(fun(B,fun(A,$o)),fun(product_prod(B,A),$o),product_case_prod(B,A,$o),aTP_Lamp_axp(fun(B,$o),fun(B,fun(A,$o)),P)),prod_filter(B,A,A3,B4))
      <=> eventually(B,P,A3) ) ) ).

% eventually_prod1
tff(fact_7750_eventually__prod2,axiom,
    ! [A: $tType,B: $tType,A3: filter(A),P: fun(B,$o),B4: filter(B)] :
      ( ( A3 != bot_bot(filter(A)) )
     => ( eventually(product_prod(A,B),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aTP_Lamp_axq(fun(B,$o),fun(A,fun(B,$o)),P)),prod_filter(A,B,A3,B4))
      <=> eventually(B,P,B4) ) ) ).

% eventually_prod2
tff(fact_7751_prod__filter__def,axiom,
    ! [A: $tType,B: $tType,F4: filter(A),G3: filter(B)] : ( prod_filter(A,B,F4,G3) = aa(set(filter(product_prod(A,B))),filter(product_prod(A,B)),complete_Inf_Inf(filter(product_prod(A,B))),aa(set(product_prod(fun(A,$o),fun(B,$o))),set(filter(product_prod(A,B))),image(product_prod(fun(A,$o),fun(B,$o)),filter(product_prod(A,B)),aa(fun(fun(A,$o),fun(fun(B,$o),filter(product_prod(A,B)))),fun(product_prod(fun(A,$o),fun(B,$o)),filter(product_prod(A,B))),product_case_prod(fun(A,$o),fun(B,$o),filter(product_prod(A,B))),aTP_Lamp_axs(fun(A,$o),fun(fun(B,$o),filter(product_prod(A,B)))))),aa(fun(product_prod(fun(A,$o),fun(B,$o)),$o),set(product_prod(fun(A,$o),fun(B,$o))),collect(product_prod(fun(A,$o),fun(B,$o))),aa(fun(fun(A,$o),fun(fun(B,$o),$o)),fun(product_prod(fun(A,$o),fun(B,$o)),$o),product_case_prod(fun(A,$o),fun(B,$o),$o),aa(filter(B),fun(fun(A,$o),fun(fun(B,$o),$o)),aTP_Lamp_axt(filter(A),fun(filter(B),fun(fun(A,$o),fun(fun(B,$o),$o))),F4),G3))))) ) ).

% prod_filter_def
tff(fact_7752_prod__filter__INF,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType,I5: set(A),J5: set(B),A3: fun(A,filter(C)),B4: fun(B,filter(D))] :
      ( ( I5 != bot_bot(set(A)) )
     => ( ( J5 != bot_bot(set(B)) )
       => ( prod_filter(C,D,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(A),set(filter(C)),image(A,filter(C),A3),I5)),aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image(B,filter(D),B4),J5))) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(A),set(filter(product_prod(C,D))),image(A,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(A,filter(product_prod(C,D))),aa(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D)))),aTP_Lamp_axv(set(B),fun(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D))))),J5),A3),B4)),I5)) ) ) ) ).

% prod_filter_INF
tff(fact_7753_prod__filter__INF1,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set(A),A3: fun(A,filter(B)),B4: filter(C)] :
      ( ( I5 != bot_bot(set(A)) )
     => ( prod_filter(B,C,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),A3),I5)),B4) = aa(set(filter(product_prod(B,C))),filter(product_prod(B,C)),complete_Inf_Inf(filter(product_prod(B,C))),aa(set(A),set(filter(product_prod(B,C))),image(A,filter(product_prod(B,C)),aa(filter(C),fun(A,filter(product_prod(B,C))),aTP_Lamp_axw(fun(A,filter(B)),fun(filter(C),fun(A,filter(product_prod(B,C)))),A3),B4)),I5)) ) ) ).

% prod_filter_INF1
tff(fact_7754_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: A,A2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( ! [F5: fun(nat,A)] :
                ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(nat,A,F5,N8))
               => ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F5,N8)),A2)
                 => ( order_mono(nat,A,F5)
                   => ( filterlim(nat,A,F5,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
                     => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_aru(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F5),at_top(nat)) ) ) ) )
           => eventually(A,P,topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_lessThan(A),A2))) ) ) ) ).

% sequentially_imp_eventually_at_left
tff(fact_7755_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: set(C),F3: fun(C,A),G: fun(C,B)] : ( bNF_Greatest_image2(C,A,B,A3,F3,G) = aa(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(C,B),fun(product_prod(A,B),$o),aa(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),$o)),aTP_Lamp_axx(set(C),fun(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),$o))),A3),F3),G)) ) ).

% image2_def
tff(fact_7756_incseq__const,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [K: A] : order_mono(nat,A,aTP_Lamp_arv(A,fun(nat,A),K)) ) ).

% incseq_const
tff(fact_7757_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ).

% mono_Sup
tff(fact_7758_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F3: fun(A,B),A3: fun(C,A),I5: set(C)] :
          ( order_mono(A,B,F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_axy(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,A3),I5)))) ) ) ).

% mono_SUP
tff(fact_7759_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ).

% mono_Inf
tff(fact_7760_mono__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(A) )
     => ! [F3: fun(A,B),A3: fun(C,A),I5: set(C)] :
          ( order_mono(A,B,F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,A3),I5)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_axy(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))) ) ) ).

% mono_INF
tff(fact_7761_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [F3: fun(A,B),Ma: A,Nb: A,M5: B,N2: B] :
          ( order_mono(A,B,F3)
         => ( ( aa(set(A),set(B),image(A,B,F3),set_or7035219750837199246ssThan(A,Ma,Nb)) = set_or7035219750837199246ssThan(B,M5,N2) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Ma),Nb)
             => ( aa(A,B,F3,Ma) = M5 ) ) ) ) ) ).

% mono_image_least
tff(fact_7762_funpow__mono,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(A,A),A3: A,B4: A,Nb: nat] :
          ( order_mono(A,A,F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A3),B4)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),A3)),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),B4)) ) ) ) ).

% funpow_mono
tff(fact_7763_funpow__mono2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(A,A),I3: nat,J2: nat,X2: A,Y2: A] :
          ( order_mono(A,A,F3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),aa(A,A,F3,X2))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),I3),F3),X2)),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),J2),F3),Y2)) ) ) ) ) ) ).

% funpow_mono2
tff(fact_7764_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [F3: fun(A,A),P2: A,K: nat] :
          ( order_mono(A,A,F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P2),aa(A,A,F3,P2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P2),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F3),top_top(A))) ) ) ) ).

% Kleene_iter_gpfp
tff(fact_7765_mono__pow,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(A,A),Nb: nat] :
          ( order_mono(A,A,F3)
         => order_mono(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3)) ) ) ).

% mono_pow
tff(fact_7766_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_mono(nat,A,aTP_Lamp_axz(fun(A,A),fun(nat,A),Q)) ) ) ).

% mono_funpow
tff(fact_7767_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [F3: fun(A,A),P2: A,K: nat] :
          ( order_mono(A,A,F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,F3,P2)),P2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F3),bot_bot(A))),P2) ) ) ) ).

% Kleene_iter_lpfp
tff(fact_7768_decseq__eq__incseq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X7: fun(nat,A)] :
          ( order_antimono(nat,A,X7)
        <=> order_mono(nat,A,aTP_Lamp_dm(fun(nat,A),fun(nat,A),X7)) ) ) ).

% decseq_eq_incseq
tff(fact_7769_mono__times__nat,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => order_mono(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb)) ) ).

% mono_times_nat
tff(fact_7770_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F3: fun(A,B),X2: A,Y2: A] :
          ( order_mono(A,B,F3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X2)),aa(A,B,F3,Y2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Y2) ) ) ) ).

% mono_strict_invE
tff(fact_7771_mono__Suc,axiom,
    order_mono(nat,nat,suc) ).

% mono_Suc
tff(fact_7772_mono__add,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A] : order_mono(A,A,aa(A,fun(A,A),plus_plus(A),A2)) ) ).

% mono_add
tff(fact_7773_incseq__SucD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: fun(nat,A),I3: nat] :
          ( order_mono(nat,A,A3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A3,I3)),aa(nat,A,A3,aa(nat,nat,suc,I3))) ) ) ).

% incseq_SucD
tff(fact_7774_incseq__SucI,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,N)),aa(nat,A,X7,aa(nat,nat,suc,N)))
         => order_mono(nat,A,X7) ) ) ).

% incseq_SucI
tff(fact_7775_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A)] :
          ( order_mono(nat,A,F3)
        <=> ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N4)),aa(nat,A,F3,aa(nat,nat,suc,N4))) ) ) ).

% incseq_Suc_iff
tff(fact_7776_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F3: fun(A,B),X2: A,Y2: A] :
          ( order_mono(A,B,F3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X2)),aa(A,B,F3,Y2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X2),Y2) ) ) ) ).

% mono_invE
tff(fact_7777_mono__mult,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => order_mono(A,A,aa(A,fun(A,A),times_times(A),A2)) ) ) ).

% mono_mult
tff(fact_7778_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_antimono(nat,A,aTP_Lamp_aya(fun(A,A),fun(nat,A),Q)) ) ) ).

% antimono_funpow
tff(fact_7779_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Ma: nat,Nb: nat,F3: fun(A,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( order_mono(A,A,F3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),top_top(A))),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Ma),F3),top_top(A))) ) ) ) ).

% funpow_increasing
tff(fact_7780_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Ma: nat,Nb: nat,F3: fun(A,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ma),Nb)
         => ( order_mono(A,A,F3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Ma),F3),bot_bot(A))),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),bot_bot(A))) ) ) ) ).

% funpow_decreasing
tff(fact_7781_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F3: fun(A,B),A3: fun(C,A),I5: set(C)] :
          ( order_mono(A,B,F3)
         => ( condit941137186595557371_above(A,aa(set(C),set(A),image(C,A,A3),I5))
           => ( ( I5 != bot_bot(set(C)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ayb(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,A3),I5)))) ) ) ) ) ).

% mono_cSUP
tff(fact_7782_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F3)
         => ( condit941137186595557371_above(A,A3)
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ) ) ).

% mono_cSup
tff(fact_7783_mono__cINF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(A) )
     => ! [F3: fun(A,B),A3: fun(C,A),I5: set(C)] :
          ( order_mono(A,B,F3)
         => ( condit1013018076250108175_below(A,aa(set(C),set(A),image(C,A,A3),I5))
           => ( ( I5 != bot_bot(set(C)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,A3),I5)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ayb(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))) ) ) ) ) ).

% mono_cINF
tff(fact_7784_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( order_mono(A,B,F3)
         => ( condit1013018076250108175_below(A,A3)
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ) ).

% mono_cInf
tff(fact_7785_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => order_mono(nat,nat,aTP_Lamp_ayc(nat,fun(nat,nat),K)) ) ).

% mono_ge2_power_minus_self
tff(fact_7786_LIMSEQ__SUP,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [X7: fun(nat,A)] :
          ( order_mono(nat,A,X7)
         => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,X7),top_top(set(nat))))),at_top(nat)) ) ) ).

% LIMSEQ_SUP
tff(fact_7787_SUP__Lim,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [X7: fun(nat,A),L: A] :
          ( order_mono(nat,A,X7)
         => ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L),at_top(nat))
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,X7),top_top(set(nat)))) = L ) ) ) ) ).

% SUP_Lim
tff(fact_7788_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A)] :
          ( finite_finite2(A,aa(set(nat),set(A),image(nat,A,F3),top_top(set(nat))))
         => ( order_mono(nat,A,F3)
           => ( ! [N: nat] :
                  ( ( aa(nat,A,F3,N) = aa(nat,A,F3,aa(nat,nat,suc,N)) )
                 => ( aa(nat,A,F3,aa(nat,nat,suc,N)) = aa(nat,A,F3,aa(nat,nat,suc,aa(nat,nat,suc,N))) ) )
             => ? [N7: nat] :
                  ( ! [N8: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N7)
                     => ! [M: nat] :
                          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N7)
                         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N8)
                           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,M)),aa(nat,A,F3,N8)) ) ) )
                  & ! [N8: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N8)
                     => ( aa(nat,A,F3,N7) = aa(nat,A,F3,N8) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
tff(fact_7789_tendsto__at__left__sequentially,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [B2: A,A2: A,X7: fun(A,B),L4: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( ! [S9: fun(nat,A)] :
                ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,S9,N8)),A2)
               => ( ! [N8: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(nat,A,S9,N8))
                 => ( order_mono(nat,A,S9)
                   => ( filterlim(nat,A,S9,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
                     => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_arx(fun(A,B),fun(fun(nat,A),fun(nat,B)),X7),S9),topolo7230453075368039082e_nhds(B,L4),at_top(nat)) ) ) ) )
           => filterlim(A,B,X7,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,aa(A,set(A),set_ord_lessThan(A),A2))) ) ) ) ).

% tendsto_at_left_sequentially
tff(fact_7790_LIMSEQ__incseq__SUP,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [X7: fun(nat,A)] :
          ( condit941137186595557371_above(A,aa(set(nat),set(A),image(nat,A,X7),top_top(set(nat))))
         => ( order_mono(nat,A,X7)
           => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,X7),top_top(set(nat))))),at_top(nat)) ) ) ) ).

% LIMSEQ_incseq_SUP
tff(fact_7791_continuous__at__Sup__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & topolo1944317154257567458pology(A)
        & condit6923001295902523014norder(B)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),S3: set(A)] :
          ( order_mono(A,B,F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,aa(set(A),A,complete_Sup_Sup(A),S3),aa(A,set(A),set_ord_lessThan(A),aa(set(A),A,complete_Sup_Sup(A),S3))),F3)
           => ( ( S3 != bot_bot(set(A)) )
             => ( condit941137186595557371_above(A,S3)
               => ( aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),S3)) = aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),S3)) ) ) ) ) ) ) ).

% continuous_at_Sup_mono
tff(fact_7792_continuous__at__Inf__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & topolo1944317154257567458pology(A)
        & condit6923001295902523014norder(B)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),S3: set(A)] :
          ( order_mono(A,B,F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,aa(set(A),A,complete_Inf_Inf(A),S3),aa(A,set(A),set_ord_greaterThan(A),aa(set(A),A,complete_Inf_Inf(A),S3))),F3)
           => ( ( S3 != bot_bot(set(A)) )
             => ( condit1013018076250108175_below(A,S3)
               => ( aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),S3)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),S3)) ) ) ) ) ) ) ).

% continuous_at_Inf_mono
tff(fact_7793_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( remdups_adj(A,Xs) = Ys )
    <=> ? [F6: fun(nat,nat)] :
          ( order_mono(nat,nat,F6)
          & ( aa(set(nat),set(nat),image(nat,nat,F6),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Ys)) )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
             => ( aa(nat,A,nth(A,Xs),I) = aa(nat,A,nth(A,Ys),aa(nat,nat,F6,I)) ) )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),one_one(nat))),aa(list(A),nat,size_size(list(A)),Xs))
             => ( ( aa(nat,A,nth(A,Xs),I) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),one_one(nat))) )
              <=> ( aa(nat,nat,F6,I) = aa(nat,nat,F6,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),one_one(nat))) ) ) ) ) ) ).

% remdups_adj_altdef
tff(fact_7794_and__not__num_Oelims,axiom,
    ! [X2: num,Xa2: num,Y2: option(num)] :
      ( ( bit_and_not_num(X2,Xa2) = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2 != none(num) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N: num] : ( Xa2 = aa(num,num,bit0,N) )
             => ( Y2 != aa(num,option(num),some(num),one2) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N: num] : ( Xa2 = aa(num,num,bit1,N) )
               => ( Y2 != none(num) ) ) )
           => ( ! [M3: num] :
                  ( ( X2 = aa(num,num,bit0,M3) )
                 => ( ( Xa2 = one2 )
                   => ( Y2 != aa(num,option(num),some(num),aa(num,num,bit0,M3)) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ! [N: num] :
                        ( ( Xa2 = aa(num,num,bit0,N) )
                       => ( Y2 != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N: num] :
                          ( ( Xa2 = aa(num,num,bit1,N) )
                         => ( Y2 != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N)) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2 = aa(num,num,bit1,M3) )
                       => ( ( Xa2 = one2 )
                         => ( Y2 != aa(num,option(num),some(num),aa(num,num,bit0,M3)) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ! [N: num] :
                              ( ( Xa2 = aa(num,num,bit0,N) )
                             => ( Y2 != case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_za(num,option(num)),bit_and_not_num(M3,N)) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N: num] :
                                ( ( Xa2 = aa(num,num,bit1,N) )
                               => ( Y2 != aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M3,N)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
tff(fact_7795_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( remdups_adj(A,Xs) = nil(A) )
    <=> ( Xs = nil(A) ) ) ).

% remdups_adj_Nil_iff
tff(fact_7796_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),remdups_adj(A,Xs)) = aa(list(A),set(A),set2(A),Xs) ) ).

% remdups_adj_set
tff(fact_7797_option_Omap__disc__iff,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A2: option(B)] :
      ( ( aa(option(B),option(A),map_option(B,A,F3),A2) = none(A) )
    <=> ( A2 = none(B) ) ) ).

% option.map_disc_iff
tff(fact_7798_map__option__is__None,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Opt: option(B)] :
      ( ( aa(option(B),option(A),map_option(B,A,F3),Opt) = none(A) )
    <=> ( Opt = none(B) ) ) ).

% map_option_is_None
tff(fact_7799_None__eq__map__option__iff,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),X2: option(B)] :
      ( ( none(A) = aa(option(B),option(A),map_option(B,A,F3),X2) )
    <=> ( X2 = none(B) ) ) ).

% None_eq_map_option_iff
tff(fact_7800_map__option__eq__Some,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),Xo: option(B),Y2: A] :
      ( ( aa(option(B),option(A),map_option(B,A,F3),Xo) = aa(A,option(A),some(A),Y2) )
    <=> ? [Z5: B] :
          ( ( Xo = aa(B,option(B),some(B),Z5) )
          & ( aa(B,A,F3,Z5) = Y2 ) ) ) ).

% map_option_eq_Some
tff(fact_7801_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list(A)] : ( remdups_adj(A,aa(list(A),list(A),rev(A),Xs)) = aa(list(A),list(A),rev(A),remdups_adj(A,Xs)) ) ).

% remdups_adj_rev
tff(fact_7802_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),A,hd(A),remdups_adj(A,Xs)) = aa(list(A),A,hd(A),Xs) ) ).

% hd_remdups_adj
tff(fact_7803_map__option__o__empty,axiom,
    ! [A: $tType,C: $tType,B: $tType,F3: fun(C,B),X: A] : ( aa(A,option(B),aa(fun(A,option(C)),fun(A,option(B)),comp(option(C),option(B),A,map_option(C,B,F3)),aTP_Lamp_ayd(A,option(C))),X) = none(B) ) ).

% map_option_o_empty
tff(fact_7804_case__map__option,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: A,H: fun(B,A),F3: fun(C,B),X2: option(C)] : ( case_option(A,B,G,H,aa(option(C),option(B),map_option(C,B,F3),X2)) = case_option(A,C,G,aa(fun(C,B),fun(C,A),comp(B,A,C,H),F3),X2) ) ).

% case_map_option
tff(fact_7805_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),tl(A),remdups_adj(A,aa(list(A),list(A),cons(A,X2),Xs)))) = remdups_adj(A,aa(list(A),list(A),cons(A,X2),Xs)) ) ).

% remdups_adj_Cons_alt
tff(fact_7806_ran__map__option,axiom,
    ! [A: $tType,C: $tType,B: $tType,F3: fun(C,A),Ma: fun(B,option(C))] : ( ran(B,A,aa(fun(B,option(C)),fun(B,option(A)),aTP_Lamp_aye(fun(C,A),fun(fun(B,option(C)),fun(B,option(A))),F3),Ma)) = aa(set(C),set(A),image(C,A,F3),ran(B,C,Ma)) ) ).

% ran_map_option
tff(fact_7807_rtranclp_Omono,axiom,
    ! [A: $tType,R: fun(A,fun(A,$o))] : order_mono(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aTP_Lamp_ayf(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),R)) ).

% rtranclp.mono
tff(fact_7808_tranclp_Omono,axiom,
    ! [A: $tType,R: fun(A,fun(A,$o))] : order_mono(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aTP_Lamp_ayg(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),R)) ).

% tranclp.mono
tff(fact_7809_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% remdups_adj_length
tff(fact_7810_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),remdups_adj(A,Xs)) ) ) ).

% sorted_remdups_adj
tff(fact_7811_and__not__num_Osimps_I9_J,axiom,
    ! [Ma: num,Nb: num] : ( bit_and_not_num(aa(num,num,bit1,Ma),aa(num,num,bit1,Nb)) = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(Ma,Nb)) ) ).

% and_not_num.simps(9)
tff(fact_7812_and__not__num_Osimps_I6_J,axiom,
    ! [Ma: num,Nb: num] : ( bit_and_not_num(aa(num,num,bit0,Ma),aa(num,num,bit1,Nb)) = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(Ma,Nb)) ) ).

% and_not_num.simps(6)
tff(fact_7813_option_Osimps_I8_J,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A)] : ( aa(option(B),option(A),map_option(B,A,F3),none(B)) = none(A) ) ).

% option.simps(8)
tff(fact_7814_and__not__num_Osimps_I5_J,axiom,
    ! [Ma: num,Nb: num] : ( bit_and_not_num(aa(num,num,bit0,Ma),aa(num,num,bit0,Nb)) = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(Ma,Nb)) ) ).

% and_not_num.simps(5)
tff(fact_7815_option_Osimps_I9_J,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),X22: B] : ( aa(option(B),option(A),map_option(B,A,F3),aa(B,option(B),some(B),X22)) = aa(A,option(A),some(A),aa(B,A,F3,X22)) ) ).

% option.simps(9)
tff(fact_7816_map__option__cong,axiom,
    ! [B: $tType,A: $tType,X2: option(A),Y2: option(A),F3: fun(A,B),G: fun(A,B)] :
      ( ( X2 = Y2 )
     => ( ! [A4: A] :
            ( ( Y2 = aa(A,option(A),some(A),A4) )
           => ( aa(A,B,F3,A4) = aa(A,B,G,A4) ) )
       => ( aa(option(A),option(B),map_option(A,B,F3),X2) = aa(option(A),option(B),map_option(A,B,G),Y2) ) ) ) ).

% map_option_cong
tff(fact_7817_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => ( remdups_adj(A,Xs) = Xs ) ) ).

% remdups_adj_distinct
tff(fact_7818_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list(A)] :
      ( remdups_adj(A,aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),Xs)))
      = $ite(X2 = Y2,remdups_adj(A,aa(list(A),list(A),cons(A,X2),Xs)),aa(list(A),list(A),cons(A,X2),remdups_adj(A,aa(list(A),list(A),cons(A,Y2),Xs)))) ) ).

% remdups_adj.simps(3)
tff(fact_7819_option_Omap__ident,axiom,
    ! [A: $tType,T2: option(A)] : ( aa(option(A),option(A),map_option(A,A,aTP_Lamp_ae(A,A)),T2) = T2 ) ).

% option.map_ident
tff(fact_7820_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] : ( remdups_adj(A,nil(A)) = nil(A) ) ).

% remdups_adj.simps(1)
tff(fact_7821_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A] : ( remdups_adj(A,aa(list(A),list(A),cons(A,X2),nil(A))) = aa(list(A),list(A),cons(A,X2),nil(A)) ) ).

% remdups_adj.simps(2)
tff(fact_7822_remdups__adj_Oelims,axiom,
    ! [A: $tType,X2: list(A),Y2: list(A)] :
      ( ( remdups_adj(A,X2) = Y2 )
     => ( ( ( X2 = nil(A) )
         => ( Y2 != nil(A) ) )
       => ( ! [X4: A] :
              ( ( X2 = aa(list(A),list(A),cons(A,X4),nil(A)) )
             => ( Y2 != aa(list(A),list(A),cons(A,X4),nil(A)) ) )
         => ~ ! [X4: A,Y4: A,Xs2: list(A)] :
                ( ( X2 = aa(list(A),list(A),cons(A,X4),aa(list(A),list(A),cons(A,Y4),Xs2)) )
               => ( Y2
                 != $ite(X4 = Y4,remdups_adj(A,aa(list(A),list(A),cons(A,X4),Xs2)),aa(list(A),list(A),cons(A,X4),remdups_adj(A,aa(list(A),list(A),cons(A,Y4),Xs2)))) ) ) ) ) ) ).

% remdups_adj.elims
tff(fact_7823_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( remdups_adj(A,aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(A),list(A),cons(A,X2),remdups_adj(A,dropWhile(A,aTP_Lamp_dx(A,fun(A,$o),X2),Xs))) ) ).

% remdups_adj_Cons'
tff(fact_7824_option_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,nat),G: fun(A,B)] : ( aa(fun(option(A),option(B)),fun(option(A),nat),comp(option(B),nat,option(A),size_option(B,F3)),map_option(A,B,G)) = size_option(A,aa(fun(A,B),fun(A,nat),comp(B,nat,A,F3),G)) ) ).

% option.size_gen_o_map
tff(fact_7825_map__option_Ocomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: fun(C,B),G: fun(A,C)] : ( aa(fun(option(A),option(C)),fun(option(A),option(B)),comp(option(C),option(B),option(A),map_option(C,B,F3)),map_option(A,C,G)) = map_option(A,B,aa(fun(A,C),fun(A,B),comp(C,B,A,F3),G)) ) ).

% map_option.comp
tff(fact_7826_option_Omap__comp,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: fun(B,A),F3: fun(C,B),V: option(C)] : ( aa(option(B),option(A),map_option(B,A,G),aa(option(C),option(B),map_option(C,B,F3),V)) = aa(option(C),option(A),map_option(C,A,aa(fun(C,B),fun(C,A),comp(B,A,C,G),F3)),V) ) ).

% option.map_comp
tff(fact_7827_map__option_Ocompositionality,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: fun(B,A),G: fun(C,B),Option: option(C)] : ( aa(option(B),option(A),map_option(B,A,F3),aa(option(C),option(B),map_option(C,B,G),Option)) = aa(option(C),option(A),map_option(C,A,aa(fun(C,B),fun(C,A),comp(B,A,C,F3),G)),Option) ) ).

% map_option.compositionality
tff(fact_7828_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list(A),X2: A,Y2: A] :
      ( remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),aa(list(A),list(A),cons(A,Y2),nil(A)))))
      = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,X2),nil(A))))),$ite(X2 = Y2,nil(A),aa(list(A),list(A),cons(A,Y2),nil(A)))) ) ).

% remdups_adj_append_two
tff(fact_7829_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: fun(C,B),Xs: list(product_prod(A,C))] : ( map_of(A,B,aa(list(product_prod(A,C)),list(product_prod(A,B)),map(product_prod(A,C),product_prod(A,B),aa(fun(A,fun(C,product_prod(A,B))),fun(product_prod(A,C),product_prod(A,B)),product_case_prod(A,C,product_prod(A,B)),aTP_Lamp_ayh(fun(C,B),fun(A,fun(C,product_prod(A,B))),F3))),Xs)) = aa(fun(A,option(C)),fun(A,option(B)),comp(option(C),option(B),A,map_option(C,B,F3)),map_of(A,C,Xs)) ) ).

% map_of_map
tff(fact_7830_map__option__case,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Y2: option(B)] : ( aa(option(B),option(A),map_option(B,A,F3),Y2) = case_option(option(A),B,none(A),aTP_Lamp_ayi(fun(B,A),fun(B,option(A)),F3),Y2) ) ).

% map_option_case
tff(fact_7831_remdups__adj__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] : ( remdups_adj(A,aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(A),list(A),case_list(list(A),A,aa(list(A),list(A),cons(A,X2),nil(A)),aTP_Lamp_ayj(A,fun(A,fun(list(A),list(A))),X2)),remdups_adj(A,Xs)) ) ).

% remdups_adj_Cons
tff(fact_7832_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: fun(A,fun(A,$o))] : order_mono(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)),aTP_Lamp_ayk(fun(A,fun(A,$o)),fun(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o))),Less)) ).

% ord.lexordp.mono
tff(fact_7833_finite_Omono,axiom,
    ! [A: $tType] : order_mono(fun(set(A),$o),fun(set(A),$o),aTP_Lamp_ayl(fun(set(A),$o),fun(set(A),$o))) ).

% finite.mono
tff(fact_7834_remdups__adj__adjacent,axiom,
    ! [A: $tType,I3: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I3)),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs)))
     => ( aa(nat,A,nth(A,remdups_adj(A,Xs)),I3) != aa(nat,A,nth(A,remdups_adj(A,Xs)),aa(nat,nat,suc,I3)) ) ) ).

% remdups_adj_adjacent
tff(fact_7835_remdups__adj__replicate,axiom,
    ! [A: $tType,Nb: nat,X2: A] :
      ( remdups_adj(A,replicate(A,Nb,X2))
      = $ite(Nb = zero_zero(nat),nil(A),aa(list(A),list(A),cons(A,X2),nil(A))) ) ).

% remdups_adj_replicate
tff(fact_7836_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list(A),X2: A] :
      ( ( remdups_adj(A,Xs) = aa(list(A),list(A),cons(A,X2),nil(A)) )
     => ( Xs = replicate(A,aa(list(A),nat,size_size(list(A)),Xs),X2) ) ) ).

% remdups_adj_singleton
tff(fact_7837_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list(A),X2: A,Xs_2: list(A)] : ( remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs_1),aa(list(A),list(A),cons(A,X2),Xs_2))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs_1),aa(list(A),list(A),cons(A,X2),nil(A))))),aa(list(A),list(A),tl(A),remdups_adj(A,aa(list(A),list(A),cons(A,X2),Xs_2)))) ) ).

% remdups_adj_append
tff(fact_7838_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list(A),Y2: A,Ys: list(A)] : ( remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,Y2),Ys))) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),remdups_adj(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),cons(A,Y2),nil(A))))),remdups_adj(A,dropWhile(A,aTP_Lamp_dx(A,fun(A,$o),Y2),Ys))) ) ).

% remdups_adj_append_dropWhile
tff(fact_7839_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ord(A)
     => order_mono(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)),aTP_Lamp_aym(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)))) ) ).

% lexordp.mono
tff(fact_7840_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list(A)] :
      ( ( Ys != nil(A) )
     => ( aa(list(A),list(A),tl(A),remdups_adj(A,Ys)) = remdups_adj(A,dropWhile(A,aTP_Lamp_ayn(list(A),fun(A,$o),Ys),aa(list(A),list(A),tl(A),Ys))) ) ) ).

% tl_remdups_adj
tff(fact_7841_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs))) ) ).

% remdups_adj_length_ge1
tff(fact_7842_tendsto__at__topI__sequentially__real,axiom,
    ! [F3: fun(real,real),Y2: real] :
      ( order_mono(real,real,F3)
     => ( filterlim(nat,real,aTP_Lamp_ayo(fun(real,real),fun(nat,real),F3),topolo7230453075368039082e_nhds(real,Y2),at_top(nat))
       => filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,Y2),at_top(real)) ) ) ).

% tendsto_at_topI_sequentially_real
tff(fact_7843_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs)) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( Xs != nil(A) )
        & ( Xs = replicate(A,aa(list(A),nat,size_size(list(A)),Xs),aa(list(A),A,hd(A),Xs)) ) ) ) ).

% remdups_adj_singleton_iff
tff(fact_7844_remdups__adj_Opelims,axiom,
    ! [A: $tType,X2: list(A),Y2: list(A)] :
      ( ( remdups_adj(A,X2) = Y2 )
     => ( accp(list(A),remdups_adj_rel(A),X2)
       => ( ( ( X2 = nil(A) )
           => ( ( Y2 = nil(A) )
             => ~ accp(list(A),remdups_adj_rel(A),nil(A)) ) )
         => ( ! [X4: A] :
                ( ( X2 = aa(list(A),list(A),cons(A,X4),nil(A)) )
               => ( ( Y2 = aa(list(A),list(A),cons(A,X4),nil(A)) )
                 => ~ accp(list(A),remdups_adj_rel(A),aa(list(A),list(A),cons(A,X4),nil(A))) ) )
           => ~ ! [X4: A,Y4: A,Xs2: list(A)] :
                  ( ( X2 = aa(list(A),list(A),cons(A,X4),aa(list(A),list(A),cons(A,Y4),Xs2)) )
                 => ( ( Y2
                      = $ite(X4 = Y4,remdups_adj(A,aa(list(A),list(A),cons(A,X4),Xs2)),aa(list(A),list(A),cons(A,X4),remdups_adj(A,aa(list(A),list(A),cons(A,Y4),Xs2)))) )
                   => ~ accp(list(A),remdups_adj_rel(A),aa(list(A),list(A),cons(A,X4),aa(list(A),list(A),cons(A,Y4),Xs2))) ) ) ) ) ) ) ).

% remdups_adj.pelims
tff(fact_7845_and__num_Oelims,axiom,
    ! [X2: num,Xa2: num,Y2: option(num)] :
      ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,X2),Xa2) = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2 != aa(num,option(num),some(num),one2) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N: num] : ( Xa2 = aa(num,num,bit0,N) )
             => ( Y2 != none(num) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N: num] : ( Xa2 = aa(num,num,bit1,N) )
               => ( Y2 != aa(num,option(num),some(num),one2) ) ) )
           => ( ( ? [M3: num] : ( X2 = aa(num,num,bit0,M3) )
               => ( ( Xa2 = one2 )
                 => ( Y2 != none(num) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ! [N: num] :
                        ( ( Xa2 = aa(num,num,bit0,N) )
                       => ( Y2 != aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M3),N)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N: num] :
                          ( ( Xa2 = aa(num,num,bit1,N) )
                         => ( Y2 != aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M3),N)) ) ) )
                 => ( ( ? [M3: num] : ( X2 = aa(num,num,bit1,M3) )
                     => ( ( Xa2 = one2 )
                       => ( Y2 != aa(num,option(num),some(num),one2) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ! [N: num] :
                              ( ( Xa2 = aa(num,num,bit0,N) )
                             => ( Y2 != aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M3),N)) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N: num] :
                                ( ( Xa2 = aa(num,num,bit1,N) )
                               => ( Y2 != case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_za(num,option(num)),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M3),N)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
tff(fact_7846_mono__compose,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [Q: fun(A,fun(B,C)),F3: fun(D,B)] :
          ( order_mono(A,fun(B,C),Q)
         => order_mono(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_ayp(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Q),F3)) ) ) ).

% mono_compose
tff(fact_7847_and__num_Osimps_I5_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit0,Ma)),aa(num,num,bit0,Nb)) = aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,Ma),Nb)) ) ).

% and_num.simps(5)
tff(fact_7848_and__num_Osimps_I1_J,axiom,
    aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,one2),one2) = aa(num,option(num),some(num),one2) ).

% and_num.simps(1)
tff(fact_7849_and__num_Osimps_I3_J,axiom,
    ! [Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,one2),aa(num,num,bit1,Nb)) = aa(num,option(num),some(num),one2) ) ).

% and_num.simps(3)
tff(fact_7850_and__num_Osimps_I7_J,axiom,
    ! [Ma: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit1,Ma)),one2) = aa(num,option(num),some(num),one2) ) ).

% and_num.simps(7)
tff(fact_7851_and__num_Osimps_I2_J,axiom,
    ! [Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,one2),aa(num,num,bit0,Nb)) = none(num) ) ).

% and_num.simps(2)
tff(fact_7852_and__num_Osimps_I4_J,axiom,
    ! [Ma: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit0,Ma)),one2) = none(num) ) ).

% and_num.simps(4)
tff(fact_7853_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: num,Q2: num] :
          ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,Ma),Nb) = aa(num,option(num),some(num),Q2) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = aa(num,A,numeral_numeral(A),Q2) ) ) ) ).

% and_num_eq_Some_iff
tff(fact_7854_and__num_Osimps_I8_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit1,Ma)),aa(num,num,bit0,Nb)) = aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,Ma),Nb)) ) ).

% and_num.simps(8)
tff(fact_7855_and__num_Osimps_I6_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit0,Ma)),aa(num,num,bit1,Nb)) = aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,Ma),Nb)) ) ).

% and_num.simps(6)
tff(fact_7856_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: num] :
          ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,Ma),Nb) = none(num) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = zero_zero(A) ) ) ) ).

% and_num_eq_None_iff
tff(fact_7857_numeral__and__num,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = case_option(A,num,zero_zero(A),numeral_numeral(A),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,Ma),Nb)) ) ) ).

% numeral_and_num
tff(fact_7858_and__num_Osimps_I9_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit1,Ma)),aa(num,num,bit1,Nb)) = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_za(num,option(num)),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,Ma),Nb)) ) ).

% and_num.simps(9)
tff(fact_7859_xor__num_Oelims,axiom,
    ! [X2: num,Xa2: num,Y2: option(num)] :
      ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,X2),Xa2) = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2 != none(num) ) ) )
       => ( ( ( X2 = one2 )
           => ! [N: num] :
                ( ( Xa2 = aa(num,num,bit0,N) )
               => ( Y2 != aa(num,option(num),some(num),aa(num,num,bit1,N)) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N: num] :
                  ( ( Xa2 = aa(num,num,bit1,N) )
                 => ( Y2 != aa(num,option(num),some(num),aa(num,num,bit0,N)) ) ) )
           => ( ! [M3: num] :
                  ( ( X2 = aa(num,num,bit0,M3) )
                 => ( ( Xa2 = one2 )
                   => ( Y2 != aa(num,option(num),some(num),aa(num,num,bit1,M3)) ) ) )
             => ( ! [M3: num] :
                    ( ( X2 = aa(num,num,bit0,M3) )
                   => ! [N: num] :
                        ( ( Xa2 = aa(num,num,bit0,N) )
                       => ( Y2 != aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M3),N)) ) ) )
               => ( ! [M3: num] :
                      ( ( X2 = aa(num,num,bit0,M3) )
                     => ! [N: num] :
                          ( ( Xa2 = aa(num,num,bit1,N) )
                         => ( Y2 != aa(num,option(num),some(num),case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M3),N))) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2 = aa(num,num,bit1,M3) )
                       => ( ( Xa2 = one2 )
                         => ( Y2 != aa(num,option(num),some(num),aa(num,num,bit0,M3)) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2 = aa(num,num,bit1,M3) )
                         => ! [N: num] :
                              ( ( Xa2 = aa(num,num,bit0,N) )
                             => ( Y2 != aa(num,option(num),some(num),case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M3),N))) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2 = aa(num,num,bit1,M3) )
                           => ! [N: num] :
                                ( ( Xa2 = aa(num,num,bit1,N) )
                               => ( Y2 != aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M3),N)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
tff(fact_7860_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
tff(fact_7861_xor__num_Osimps_I5_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit0,Ma)),aa(num,num,bit0,Nb)) = aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,Ma),Nb)) ) ).

% xor_num.simps(5)
tff(fact_7862_xor__num_Osimps_I1_J,axiom,
    aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,one2),one2) = none(num) ).

% xor_num.simps(1)
tff(fact_7863_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: num,Q2: num] :
          ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,Ma),Nb) = aa(num,option(num),some(num),Q2) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = aa(num,A,numeral_numeral(A),Q2) ) ) ) ).

% xor_num_eq_Some_iff
tff(fact_7864_xor__num_Osimps_I9_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit1,Ma)),aa(num,num,bit1,Nb)) = aa(option(num),option(num),map_option(num,num,bit0),aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,Ma),Nb)) ) ).

% xor_num.simps(9)
tff(fact_7865_xor__num_Osimps_I2_J,axiom,
    ! [Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,one2),aa(num,num,bit0,Nb)) = aa(num,option(num),some(num),aa(num,num,bit1,Nb)) ) ).

% xor_num.simps(2)
tff(fact_7866_xor__num_Osimps_I3_J,axiom,
    ! [Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,one2),aa(num,num,bit1,Nb)) = aa(num,option(num),some(num),aa(num,num,bit0,Nb)) ) ).

% xor_num.simps(3)
tff(fact_7867_xor__num_Osimps_I4_J,axiom,
    ! [Ma: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit0,Ma)),one2) = aa(num,option(num),some(num),aa(num,num,bit1,Ma)) ) ).

% xor_num.simps(4)
tff(fact_7868_xor__num_Osimps_I7_J,axiom,
    ! [Ma: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit1,Ma)),one2) = aa(num,option(num),some(num),aa(num,num,bit0,Ma)) ) ).

% xor_num.simps(7)
tff(fact_7869_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: num] :
          ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,Ma),Nb) = none(num) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = zero_zero(A) ) ) ) ).

% xor_num_eq_None_iff
tff(fact_7870_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Ma: num,Nb: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),Ma)),aa(num,A,numeral_numeral(A),Nb)) = case_option(A,num,zero_zero(A),numeral_numeral(A),aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,Ma),Nb)) ) ) ).

% numeral_xor_num
tff(fact_7871_xor__num_Osimps_I6_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit0,Ma)),aa(num,num,bit1,Nb)) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,Ma),Nb))) ) ).

% xor_num.simps(6)
tff(fact_7872_xor__num_Osimps_I8_J,axiom,
    ! [Ma: num,Nb: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit1,Ma)),aa(num,num,bit0,Nb)) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,Ma),Nb))) ) ).

% xor_num.simps(8)
tff(fact_7873_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
tff(fact_7874_map__filter__def,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,option(A)),Xs: list(B)] : ( map_filter(B,A,F3,Xs) = aa(list(B),list(A),map(B,A,aa(fun(B,option(A)),fun(B,A),comp(option(A),A,B,the2(A)),F3)),aa(list(B),list(B),filter2(B,aTP_Lamp_ayq(fun(B,option(A)),fun(B,$o),F3)),Xs)) ) ).

% map_filter_def
tff(fact_7875_option_Ocollapse,axiom,
    ! [A: $tType,Option: option(A)] :
      ( ( Option != none(A) )
     => ( aa(A,option(A),some(A),aa(option(A),A,the2(A),Option)) = Option ) ) ).

% option.collapse
tff(fact_7876_option_Osel,axiom,
    ! [A: $tType,X22: A] : ( aa(option(A),A,the2(A),aa(A,option(A),some(A),X22)) = X22 ) ).

% option.sel
tff(fact_7877_option_Oexpand,axiom,
    ! [A: $tType,Option: option(A),Option2: option(A)] :
      ( ( ( Option = none(A) )
      <=> ( Option2 = none(A) ) )
     => ( ( ( Option != none(A) )
         => ( ( Option2 != none(A) )
           => ( aa(option(A),A,the2(A),Option) = aa(option(A),A,the2(A),Option2) ) ) )
       => ( Option = Option2 ) ) ) ).

% option.expand
tff(fact_7878_option_Oexhaust__sel,axiom,
    ! [A: $tType,Option: option(A)] :
      ( ( Option != none(A) )
     => ( Option = aa(A,option(A),some(A),aa(option(A),A,the2(A),Option)) ) ) ).

% option.exhaust_sel
tff(fact_7879_Option_Othese__def,axiom,
    ! [A: $tType,A3: set(option(A))] : ( these(A,A3) = aa(set(option(A)),set(A),image(option(A),A,the2(A)),aa(fun(option(A),$o),set(option(A)),collect(option(A)),aTP_Lamp_sp(set(option(A)),fun(option(A),$o),A3))) ) ).

% Option.these_def
tff(fact_7880_option_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType,F1: A,F2: fun(B,A),Option: option(B)] :
      ( case_option(A,B,F1,F2,Option)
      = $ite(Option = none(B),F1,aa(B,A,F2,aa(option(B),B,the2(B),Option))) ) ).

% option.case_eq_if
tff(fact_7881_option_Omap__sel,axiom,
    ! [B: $tType,A: $tType,A2: option(A),F3: fun(A,B)] :
      ( ( A2 != none(A) )
     => ( aa(option(B),B,the2(B),aa(option(A),option(B),map_option(A,B,F3),A2)) = aa(A,B,F3,aa(option(A),A,the2(A),A2)) ) ) ).

% option.map_sel
tff(fact_7882_Max_Oinfinite,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( ~ finite_finite2(A,A3)
         => ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = aa(option(A),A,the2(A),none(A)) ) ) ) ).

% Max.infinite
tff(fact_7883_option_Osplit__sel,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F1: A,F2: fun(B,A),Option: option(B)] :
      ( aa(A,$o,P,case_option(A,B,F1,F2,Option))
    <=> ( ( ( Option = none(B) )
         => aa(A,$o,P,F1) )
        & ( ( Option = aa(B,option(B),some(B),aa(option(B),B,the2(B),Option)) )
         => aa(A,$o,P,aa(B,A,F2,aa(option(B),B,the2(B),Option))) ) ) ) ).

% option.split_sel
tff(fact_7884_option_Osplit__sel__asm,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F1: A,F2: fun(B,A),Option: option(B)] :
      ( aa(A,$o,P,case_option(A,B,F1,F2,Option))
    <=> ~ ( ( ( Option = none(B) )
            & ~ aa(A,$o,P,F1) )
          | ( ( Option = aa(B,option(B),some(B),aa(option(B),B,the2(B),Option)) )
            & ~ aa(A,$o,P,aa(B,A,F2,aa(option(B),B,the2(B),Option))) ) ) ) ).

% option.split_sel_asm
tff(fact_7885_option_Orec__o__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B,Ga: fun(C,B),F3: fun(A,C)] : ( aa(fun(option(A),option(C)),fun(option(A),B),comp(option(C),B,option(A),rec_option(B,C,G,Ga)),map_option(A,C,F3)) = rec_option(B,A,G,aa(fun(A,C),fun(A,B),aTP_Lamp_ayr(fun(C,B),fun(fun(A,C),fun(A,B)),Ga),F3)) ) ).

% option.rec_o_map
tff(fact_7886_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),I5: set(B),F3: fun(B,set(A))] :
          ( topolo2193935891317330818ompact(A,S)
         => ( ! [I2: B] :
                ( aa(set(B),$o,member(B,I2),I5)
               => topolo7761053866217962861closed(A,aa(B,set(A),F3,I2)) )
           => ( ! [I7: set(B)] :
                  ( finite_finite2(B,I7)
                 => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),I7),I5)
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),I7))) != bot_bot(set(A)) ) ) )
             => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),I5))) != bot_bot(set(A)) ) ) ) ) ) ).

% compact_imp_fip_image
tff(fact_7887_closed__INT,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [A3: set(A),B4: fun(A,set(B))] :
          ( ! [X4: A] :
              ( aa(set(A),$o,member(A,X4),A3)
             => topolo7761053866217962861closed(B,aa(A,set(B),B4,X4)) )
         => topolo7761053866217962861closed(B,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ) ).

% closed_INT
tff(fact_7888_closed__UN,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [A3: set(A),B4: fun(A,set(B))] :
          ( finite_finite2(A,A3)
         => ( ! [X4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => topolo7761053866217962861closed(B,aa(A,set(B),B4,X4)) )
           => topolo7761053866217962861closed(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B4),A3))) ) ) ) ).

% closed_UN
tff(fact_7889_open__Collect__imp,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o),Q: fun(A,$o)] :
          ( topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),P))
         => ( aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),Q))
           => aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_ays(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q))) ) ) ) ).

% open_Collect_imp
tff(fact_7890_open__Collect__neg,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o)] :
          ( topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),P))
         => aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_aef(fun(A,$o),fun(A,$o),P))) ) ) ).

% open_Collect_neg
tff(fact_7891_closed__Collect__imp,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o),Q: fun(A,$o)] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),P))
         => ( topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),Q))
           => topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_ays(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q))) ) ) ) ).

% closed_Collect_imp
tff(fact_7892_closed__Collect__neg,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o)] :
          ( aa(set(A),$o,topolo1002775350975398744n_open(A),aa(fun(A,$o),set(A),collect(A),P))
         => topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),aTP_Lamp_aef(fun(A,$o),fun(A,$o),P))) ) ) ).

% closed_Collect_neg
tff(fact_7893_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,top_top(set(A)),F3)
         => ( topolo81223032696312382ous_on(A,B,top_top(set(A)),G)
           => topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_ayt(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G))) ) ) ) ).

% closed_Collect_le
tff(fact_7894_closed__Collect__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topological_t2_space(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,top_top(set(A)),F3)
         => ( topolo81223032696312382ous_on(A,B,top_top(set(A)),G)
           => topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,B),fun(A,$o),aTP_Lamp_ayu(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G))) ) ) ) ).

% closed_Collect_eq
tff(fact_7895_closed__Collect__const,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: $o] : topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),aTP_Lamp_alf($o,fun(A,$o),P))) ) ).

% closed_Collect_const
tff(fact_7896_closed__Collect__disj,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o),Q: fun(A,$o)] :
          ( topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),P))
         => ( topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),Q))
           => topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_alg(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q))) ) ) ) ).

% closed_Collect_disj
tff(fact_7897_closed__Collect__conj,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [P: fun(A,$o),Q: fun(A,$o)] :
          ( topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),P))
         => ( topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),Q))
           => topolo7761053866217962861closed(A,aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_alh(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q))) ) ) ) ).

% closed_Collect_conj
tff(fact_7898_option_Osimps_I7_J,axiom,
    ! [A: $tType,B: $tType,F1: A,F2: fun(B,A),X22: B] : ( aa(option(B),A,rec_option(A,B,F1,F2),aa(B,option(B),some(B),X22)) = aa(B,A,F2,X22) ) ).

% option.simps(7)
tff(fact_7899_option_Osimps_I6_J,axiom,
    ! [B: $tType,A: $tType,F1: A,F2: fun(B,A)] : ( aa(option(B),A,rec_option(A,B,F1,F2),none(B)) = F1 ) ).

% option.simps(6)
tff(fact_7900_closed__Collect__all,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [P: fun(A,fun(B,$o))] :
          ( ! [I2: A] : topolo7761053866217962861closed(B,aa(fun(B,$o),set(B),collect(B),aa(A,fun(B,$o),P,I2)))
         => topolo7761053866217962861closed(B,aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ayv(fun(A,fun(B,$o)),fun(B,$o),P))) ) ) ).

% closed_Collect_all
tff(fact_7901_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo7761053866217962861closed(product_prod(A,A),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_ayw(product_prod(A,A),$o))) ) ).

% closed_subdiagonal
tff(fact_7902_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo7761053866217962861closed(product_prod(A,A),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_ayx(product_prod(A,A),$o))) ) ).

% closed_superdiagonal
tff(fact_7903_closed__diagonal,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => topolo7761053866217962861closed(product_prod(A,A),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_ayy(product_prod(A,A),$o))) ) ).

% closed_diagonal
tff(fact_7904_nhds__closed,axiom,
    ! [A: $tType] :
      ( topological_t3_space(A)
     => ! [X2: A,A3: set(A)] :
          ( aa(set(A),$o,member(A,X2),A3)
         => ( aa(set(A),$o,topolo1002775350975398744n_open(A),A3)
           => ? [A9: set(A)] :
                ( aa(set(A),$o,member(A,X2),A9)
                & topolo7761053866217962861closed(A,A9)
                & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A9),A3)
                & eventually(A,aTP_Lamp_ayz(set(A),fun(A,$o),A9),topolo7230453075368039082e_nhds(A,X2)) ) ) ) ) ).

% nhds_closed
tff(fact_7905_continuous__on__closed__Union,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [I5: set(A),U4: fun(A,set(B)),F3: fun(B,C)] :
          ( finite_finite2(A,I5)
         => ( ! [I2: A] :
                ( aa(set(A),$o,member(A,I2),I5)
               => topolo7761053866217962861closed(B,aa(A,set(B),U4,I2)) )
           => ( ! [I2: A] :
                  ( aa(set(A),$o,member(A,I2),I5)
                 => topolo81223032696312382ous_on(B,C,aa(A,set(B),U4,I2),F3) )
             => topolo81223032696312382ous_on(B,C,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),U4),I5)),F3) ) ) ) ) ).

% continuous_on_closed_Union
tff(fact_7906_Lim__in__closed__set,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S3: set(A),F3: fun(B,A),F4: filter(B),L: A] :
          ( topolo7761053866217962861closed(A,S3)
         => ( eventually(B,aa(fun(B,A),fun(B,$o),aTP_Lamp_aza(set(A),fun(fun(B,A),fun(B,$o)),S3),F3),F4)
           => ( ( F4 != bot_bot(filter(B)) )
             => ( filterlim(B,A,F3,topolo7230453075368039082e_nhds(A,L),F4)
               => aa(set(A),$o,member(A,L),S3) ) ) ) ) ) ).

% Lim_in_closed_set
tff(fact_7907_lenlex__append2,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Us: list(A),Xs: list(A),Ys: list(A)] :
      ( irrefl(A,R3)
     => ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Ys))),lenlex(A,R3))
      <=> aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),lenlex(A,R3)) ) ) ).

% lenlex_append2
tff(fact_7908_inj__sgn__power,axiom,
    ! [Nb: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Nb)
     => inj_on(real,real,aTP_Lamp_xg(nat,fun(real,real),Nb),top_top(set(real))) ) ).

% inj_sgn_power
tff(fact_7909_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),Xs: list(A),Ys: list(A)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( ( aa(list(A),list(B),map(A,B,F3),Xs) = aa(list(A),list(B),map(A,B,F3),Ys) )
      <=> ( Xs = Ys ) ) ) ).

% inj_map_eq_map
tff(fact_7910_inj__mult__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A] :
          ( inj_on(A,A,aa(A,fun(A,A),times_times(A),A2),top_top(set(A)))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% inj_mult_left
tff(fact_7911_inj__divide__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] :
          ( inj_on(A,A,aTP_Lamp_azb(A,fun(A,A),A2),top_top(set(A)))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% inj_divide_right
tff(fact_7912_inj__map,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B)] :
      ( inj_on(list(A),list(B),map(A,B,F3),top_top(set(list(A))))
    <=> inj_on(A,B,F3,top_top(set(A))) ) ).

% inj_map
tff(fact_7913_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => inj_on(list(A),list(B),map(A,B,F3),top_top(set(list(A)))) ) ).

% inj_mapI
tff(fact_7914_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Xs: list(A),Ys: list(A),Zs: list(A)] :
      ( irrefl(A,R)
     => ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs))),lexord(A,R))
      <=> aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs)),lexord(A,R)) ) ) ).

% lexord_same_pref_if_irrefl
tff(fact_7915_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(list(A))] :
      ( inj_on(A,B,F3,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),A3)))
     => inj_on(list(A),list(B),map(A,B,F3),A3) ) ).

% inj_on_mapI
tff(fact_7916_inj__on__INTER,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set(A),F3: fun(B,C),A3: fun(A,set(B))] :
      ( ( I5 != bot_bot(set(A)) )
     => ( ! [I2: A] :
            ( aa(set(A),$o,member(A,I2),I5)
           => inj_on(B,C,F3,aa(A,set(B),A3,I2)) )
       => inj_on(B,C,F3,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) ) ) ).

% inj_on_INTER
tff(fact_7917_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(A,aa(set(B),set(A),image(B,A,F3),A3))),finite_card(B,A3))
     => ~ inj_on(B,A,F3,A3) ) ).

% pigeonhole
tff(fact_7918_prod_Oimage__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [G: fun(A,B),A3: set(A)] :
          ( inj_on(A,B,G,A3)
         => ( groups7121269368397514597t_prod(B,B,aTP_Lamp_azc(B,B),aa(set(A),set(B),image(A,B,G),A3)) = groups7121269368397514597t_prod(A,B,G,A3) ) ) ) ).

% prod.image_eq
tff(fact_7919_sum_Oimage__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [G: fun(A,B),A3: set(A)] :
          ( inj_on(A,B,G,A3)
         => ( aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7311177749621191930dd_sum(B,B),aTP_Lamp_azd(B,B)),aa(set(A),set(B),image(A,B,G),A3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) ) ) ) ).

% sum.image_eq
tff(fact_7920_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),B4: set(A),A3: set(A)] :
      ( inj_on(A,B,F3,B4)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B4)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),aa(set(A),set(B),image(A,B,F3),B4)) ) ) ).

% inj_on_strict_subset
tff(fact_7921_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set(A),A3: fun(A,set(B)),F3: fun(B,C)] :
      ( ! [I2: A,J: A] :
          ( aa(set(A),$o,member(A,I2),I5)
         => ( aa(set(A),$o,member(A,J),I5)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),A3,I2)),aa(A,set(B),A3,J))
              | aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),A3,J)),aa(A,set(B),A3,I2)) ) ) )
     => ( ! [I2: A] :
            ( aa(set(A),$o,member(A,I2),I5)
           => inj_on(B,C,F3,aa(A,set(B),A3,I2)) )
       => inj_on(B,C,F3,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) ) ) ).

% inj_on_UNION_chain
tff(fact_7922_finite__inverse__image__gen,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F3: fun(B,A),D4: set(B)] :
      ( finite_finite2(A,A3)
     => ( inj_on(B,A,F3,D4)
       => finite_finite2(B,aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aa(fun(B,A),fun(set(B),fun(B,$o)),aTP_Lamp_aze(set(A),fun(fun(B,A),fun(set(B),fun(B,$o))),A3),F3),D4))) ) ) ).

% finite_inverse_image_gen
tff(fact_7923_inj__fn,axiom,
    ! [A: $tType,F3: fun(A,A),Nb: nat] :
      ( inj_on(A,A,F3,top_top(set(A)))
     => inj_on(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),top_top(set(A))) ) ).

% inj_fn
tff(fact_7924_finite__inverse__image,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F3: fun(B,A)] :
      ( finite_finite2(A,A3)
     => ( inj_on(B,A,F3,top_top(set(B)))
       => finite_finite2(B,aa(fun(B,$o),set(B),collect(B),aa(fun(B,A),fun(B,$o),aTP_Lamp_azf(set(A),fun(fun(B,A),fun(B,$o)),A3),F3))) ) ) ).

% finite_inverse_image
tff(fact_7925_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),Y2: A,Xs: list(A)] :
      ( inj_on(A,B,F3,aa(set(A),set(A),insert(A,Y2),aa(list(A),set(A),set2(A),Xs)))
     => ( aa(list(A),list(A),filter2(A,aa(A,fun(A,$o),aTP_Lamp_azg(fun(A,B),fun(A,fun(A,$o)),F3),Y2)),Xs) = aa(list(A),list(A),filter2(A,aa(A,fun(A,$o),fequal(A),Y2)),Xs) ) ) ).

% inj_on_filter_key_eq
tff(fact_7926_lexord__irrefl,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( irrefl(A,R3)
     => irrefl(list(A),lexord(A,R3)) ) ).

% lexord_irrefl
tff(fact_7927_injective__scaleR,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [C2: real] :
          ( ( C2 != zero_zero(real) )
         => inj_on(A,A,real_V8093663219630862766scaleR(A,C2),top_top(set(A))) ) ) ).

% injective_scaleR
tff(fact_7928_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [F3: fun(A,B)] :
          ( ! [X4: A,Y4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Y4)
             => ( aa(A,B,F3,X4) != aa(A,B,F3,Y4) ) )
         => inj_on(A,B,F3,top_top(set(A))) ) ) ).

% linorder_injI
tff(fact_7929_inj__fun,axiom,
    ! [B: $tType,C: $tType,A: $tType,F3: fun(A,B)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => inj_on(A,fun(C,B),aTP_Lamp_azh(fun(A,B),fun(A,fun(C,B)),F3),top_top(set(A))) ) ).

% inj_fun
tff(fact_7930_inj__add__left,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A] : inj_on(A,A,aa(A,fun(A,A),plus_plus(A),A2),top_top(set(A))) ) ).

% inj_add_left
tff(fact_7931_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : inj_on(A,A,aTP_Lamp_rr(A,fun(A,A),A2),top_top(set(A))) ) ).

% inj_diff_right
tff(fact_7932_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => inj_on(A,A,aTP_Lamp_qr(A,A),top_top(set(A))) ) ).

% sorted_list_of_set.inj_on
tff(fact_7933_inj__on__mult,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,A3: set(A)] :
          ( ( A2 != zero_zero(A) )
         => inj_on(A,A,aa(A,fun(A,A),times_times(A),A2),A3) ) ) ).

% inj_on_mult
tff(fact_7934_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F3: fun(B,A)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F3)
     => inj_on(B,A,F3,S3) ) ).

% folding_insort_key.inj_on
tff(fact_7935_inj__on__add,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A)] : inj_on(A,A,aa(A,fun(A,A),plus_plus(A),A2),A3) ) ).

% inj_on_add
tff(fact_7936_inj__on__id2,axiom,
    ! [A: $tType,A3: set(A)] : inj_on(A,A,aTP_Lamp_ae(A,A),A3) ).

% inj_on_id2
tff(fact_7937_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A)] : inj_on(A,A,aTP_Lamp_azi(A,fun(A,A),A2),A3) ) ).

% inj_on_add'
tff(fact_7938_irrefl__lex,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( irrefl(A,R)
     => irrefl(list(A),lex(A,R)) ) ).

% irrefl_lex
tff(fact_7939_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( order(A)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X4: A,Y4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Y4)
             => ( aa(set(A),$o,member(A,X4),A3)
               => ( aa(set(A),$o,member(A,Y4),A3)
                 => ( aa(A,B,F3,X4) != aa(A,B,F3,Y4) ) ) ) )
         => ( ! [X4: A,Y4: A] :
                ( aa(set(A),$o,member(A,X4),A3)
               => ( aa(set(A),$o,member(A,Y4),A3)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Y4)
                    | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y4),X4) ) ) )
           => inj_on(A,B,F3,A3) ) ) ) ).

% linorder_inj_onI
tff(fact_7940_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo8458572112393995274pology(A)
        & topolo1944317154257567458pology(B) )
     => ! [A2: A,X2: A,B2: A,F3: fun(A,B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),B2)
           => ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A2,B2),F3)
             => ( inj_on(A,B,F3,set_or1337092689740270186AtMost(A,A2,B2))
               => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,A2)),aa(A,B,F3,X2))
                    & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X2)),aa(A,B,F3,B2)) )
                  | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,B2)),aa(A,B,F3,X2))
                    & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X2)),aa(A,B,F3,A2)) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
tff(fact_7941_irrefl__distinct,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( irrefl(A,R)
    <=> ! [X3: product_prod(A,A)] :
          ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),X3),R)
         => aa(product_prod(A,A),$o,aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aTP_Lamp_wa(A,fun(A,$o))),X3) ) ) ).

% irrefl_distinct
tff(fact_7942_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B)] :
      ( inj_on(list(A),list(B),map(A,B,F3),top_top(set(list(A))))
     => inj_on(A,B,F3,top_top(set(A))) ) ).

% inj_mapD
tff(fact_7943_map__injective,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B),Ys: list(B)] :
      ( ( aa(list(B),list(A),map(B,A,F3),Xs) = aa(list(B),list(A),map(B,A,F3),Ys) )
     => ( inj_on(B,A,F3,top_top(set(B)))
       => ( Xs = Ys ) ) ) ).

% map_injective
tff(fact_7944_distinct__map,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B)] :
      ( distinct(A,aa(list(B),list(A),map(B,A,F3),Xs))
    <=> ( distinct(B,Xs)
        & inj_on(B,A,F3,aa(list(B),set(B),set2(B),Xs)) ) ) ).

% distinct_map
tff(fact_7945_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),X2: A,Xs: list(A)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( aa(list(A),list(B),map(A,B,F3),aa(list(A),list(A),removeAll(A,X2),Xs)) = aa(list(B),list(B),removeAll(B,aa(A,B,F3,X2)),aa(list(A),list(B),map(A,B,F3),Xs)) ) ) ).

% map_removeAll_inj
tff(fact_7946_option_Oinj__map,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => inj_on(option(A),option(B),map_option(A,B,F3),top_top(set(option(A)))) ) ).

% option.inj_map
tff(fact_7947_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),Xs: list(A)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( remdups_adj(B,aa(list(A),list(B),map(A,B,F3),Xs)) = aa(list(A),list(B),map(A,B,F3),remdups_adj(A,Xs)) ) ) ).

% remdups_adj_map_injective
tff(fact_7948_lexl__not__refl,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),X2: list(A)] :
      ( irrefl(A,R)
     => ~ aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),X2)),lex(A,R)) ) ).

% lexl_not_refl
tff(fact_7949_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),X2: A,Xs: list(A)] :
      ( inj_on(A,B,F3,aa(set(A),set(A),insert(A,X2),aa(list(A),set(A),set2(A),Xs)))
     => ( aa(list(A),list(B),map(A,B,F3),aa(list(A),list(A),removeAll(A,X2),Xs)) = aa(list(B),list(B),removeAll(B,aa(A,B,F3,X2)),aa(list(A),list(B),map(A,B,F3),Xs)) ) ) ).

% map_removeAll_inj_on
tff(fact_7950_image__INT,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: fun(A,B),C6: set(A),A3: set(C),B4: fun(C,set(A)),J2: C] :
      ( inj_on(A,B,F3,C6)
     => ( ! [X4: C] :
            ( aa(set(C),$o,member(C,X4),A3)
           => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(C,set(A),B4,X4)),C6) )
       => ( aa(set(C),$o,member(C,J2),A3)
         => ( aa(set(A),set(B),image(A,B,F3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),B4),A3))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_xa(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),F3),B4)),A3)) ) ) ) ) ).

% image_INT
tff(fact_7951_log__inj,axiom,
    ! [B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => inj_on(real,real,log(B2),aa(real,set(real),set_ord_greaterThan(real),zero_zero(real))) ) ).

% log_inj
tff(fact_7952_funpow__inj__finite,axiom,
    ! [A: $tType,P2: fun(A,A),X2: A] :
      ( inj_on(A,A,P2,top_top(set(A)))
     => ( finite_finite2(A,aa(fun(A,$o),set(A),collect(A),aa(A,fun(A,$o),aTP_Lamp_azj(fun(A,A),fun(A,fun(A,$o)),P2),X2)))
       => ~ ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),P2),X2) != X2 ) ) ) ) ).

% funpow_inj_finite
tff(fact_7953_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: fun(A,B),T2: list(product_prod(A,C)),K: A,X2: C] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( ( aa(A,option(C),map_of(A,C,T2),K) = aa(C,option(C),some(C),X2) )
       => ( aa(B,option(C),map_of(B,C,aa(list(product_prod(A,C)),list(product_prod(B,C)),map(product_prod(A,C),product_prod(B,C),aa(fun(A,fun(C,product_prod(B,C))),fun(product_prod(A,C),product_prod(B,C)),product_case_prod(A,C,product_prod(B,C)),aTP_Lamp_azk(fun(A,B),fun(A,fun(C,product_prod(B,C))),F3))),T2)),aa(A,B,F3,K)) = aa(C,option(C),some(C),X2) ) ) ) ).

% map_of_mapk_SomeI
tff(fact_7954_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( finite_finite2(product_prod(A,A),R3)
     => ( transitive_rtrancl(A,R3) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_axb(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3)),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_axg(set(product_prod(A,A)),fun(nat,$o),R3)))) ) ) ).

% rtrancl_finite_eq_relpow
tff(fact_7955_uniformly__continuous__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo7287701948861334536_space(A)
        & topolo7287701948861334536_space(B) )
     => ! [S: set(A),F3: fun(A,B),E5: fun(product_prod(B,B),$o)] :
          ( topolo6026614971017936543ous_on(A,B,S,F3)
         => ( eventually(product_prod(B,B),E5,topolo7806501430040627800ormity(B))
           => eventually(product_prod(A,A),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aa(fun(product_prod(B,B),$o),fun(A,fun(A,$o)),aa(fun(A,B),fun(fun(product_prod(B,B),$o),fun(A,fun(A,$o))),aTP_Lamp_azl(set(A),fun(fun(A,B),fun(fun(product_prod(B,B),$o),fun(A,fun(A,$o)))),S),F3),E5)),topolo7806501430040627800ormity(A)) ) ) ) ).

% uniformly_continuous_onD
tff(fact_7956_inj__on__rev,axiom,
    ! [A: $tType,A3: set(list(A))] : inj_on(list(A),list(A),rev(A),A3) ).

% inj_on_rev
tff(fact_7957_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ? [F5: fun(A,nat),N: nat] :
          ( ( aa(set(A),set(nat),image(A,nat,F5),A3) = aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),N)) )
          & inj_on(A,nat,F5,A3) ) ) ).

% finite_imp_inj_to_nat_seg
tff(fact_7958_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ? [N: nat,F5: fun(nat,A)] :
          ( ( A3 = aa(set(nat),set(A),image(nat,A,F5),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),N))) )
          & inj_on(nat,A,F5,aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),N))) ) ) ).

% finite_imp_nat_seg_image_inj_on
tff(fact_7959_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),X7: set(A)] : inj_on(A,product_prod(A,B),aTP_Lamp_sk(fun(A,B),fun(A,product_prod(A,B)),F3),X7) ).

% inj_on_convol_ident
tff(fact_7960_inj__singleton,axiom,
    ! [A: $tType,A3: set(A)] : inj_on(A,set(A),aTP_Lamp_tl(A,set(A)),A3) ).

% inj_singleton
tff(fact_7961_inj__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => inj_on(nat,A,semiring_1_of_nat(A),top_top(set(nat))) ) ).

% inj_of_nat
tff(fact_7962_inj__Suc,axiom,
    ! [N3: set(nat)] : inj_on(nat,nat,suc,N3) ).

% inj_Suc
tff(fact_7963_inj__on__Cons1,axiom,
    ! [A: $tType,X2: A,A3: set(list(A))] : inj_on(list(A),list(A),cons(A,X2),A3) ).

% inj_on_Cons1
tff(fact_7964_inj__Some,axiom,
    ! [A: $tType,A3: set(A)] : inj_on(A,option(A),some(A),A3) ).

% inj_Some
tff(fact_7965_inj__on__diff__nat,axiom,
    ! [N3: set(nat),K: nat] :
      ( ! [N: nat] :
          ( aa(set(nat),$o,member(nat,N),N3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N) )
     => inj_on(nat,nat,aTP_Lamp_sd(nat,fun(nat,nat),K),N3) ) ).

% inj_on_diff_nat
tff(fact_7966_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A3: set(product_prod(A,B))] : inj_on(product_prod(A,B),product_prod(B,A),aa(fun(A,fun(B,product_prod(B,A))),fun(product_prod(A,B),product_prod(B,A)),product_case_prod(A,B,product_prod(B,A)),aTP_Lamp_qo(A,fun(B,product_prod(B,A)))),A3) ).

% swap_inj_on
tff(fact_7967_inj__graph,axiom,
    ! [B: $tType,A: $tType] : inj_on(fun(A,B),set(product_prod(A,B)),aTP_Lamp_azn(fun(A,B),set(product_prod(A,B))),top_top(set(fun(A,B)))) ).

% inj_graph
tff(fact_7968_inj__split__Cons,axiom,
    ! [A: $tType,X7: set(product_prod(list(A),A))] : inj_on(product_prod(list(A),A),list(A),aa(fun(list(A),fun(A,list(A))),fun(product_prod(list(A),A),list(A)),product_case_prod(list(A),A,list(A)),aTP_Lamp_xu(list(A),fun(A,list(A)))),X7) ).

% inj_split_Cons
tff(fact_7969_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : aa(set(product_prod(list(A),list(A))),$o,aa(set(product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),$o),ord_less_eq(set(product_prod(list(A),list(A)))),listrel1(A,transitive_rtrancl(A,R))),transitive_rtrancl(list(A),listrel1(A,R))) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
tff(fact_7970_uniformly__continuous__on__const,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo7287701948861334536_space(B)
        & topolo7287701948861334536_space(A) )
     => ! [S: set(A),C2: B] : topolo6026614971017936543ous_on(A,B,S,aTP_Lamp_azo(B,fun(A,B),C2)) ) ).

% uniformly_continuous_on_const
tff(fact_7971_uniformly__continuous__on__id,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [S: set(A)] : topolo6026614971017936543ous_on(A,A,S,aTP_Lamp_azp(A,A)) ) ).

% uniformly_continuous_on_id
tff(fact_7972_uniformly__continuous__on__Cauchy,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [S3: set(A),F3: fun(A,B),X7: fun(nat,A)] :
          ( topolo6026614971017936543ous_on(A,B,S3,F3)
         => ( topolo3814608138187158403Cauchy(A,X7)
           => ( ! [N: nat] : aa(set(A),$o,member(A,aa(nat,A,X7,N)),S3)
             => topolo3814608138187158403Cauchy(B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_azq(fun(A,B),fun(fun(nat,A),fun(nat,B)),F3),X7)) ) ) ) ) ).

% uniformly_continuous_on_Cauchy
tff(fact_7973_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R: set(product_prod(A,A)),X2: A] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),transitive_rtrancl(list(A),listrel1(A,R)))
     => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X2),Xs)),aa(list(A),list(A),cons(A,X2),Ys))),transitive_rtrancl(list(A),listrel1(A,R))) ) ).

% rtrancl_listrel1_ConsI1
tff(fact_7974_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set(product_prod(A,A)),Xs: list(A),Ys: list(A)] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2)),transitive_rtrancl(A,R))
     => ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),transitive_rtrancl(list(A),listrel1(A,R)))
       => aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,X2),Xs)),aa(list(A),list(A),cons(A,Y2),Ys))),transitive_rtrancl(list(A),listrel1(A,R))) ) ) ).

% rtrancl_listrel1_ConsI2
tff(fact_7975_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X2: list(A),Y2: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),Y2)),transitive_rtrancl(list(A),listrel1(A,R)))
     => ( aa(list(A),nat,size_size(list(A)),X2) = aa(list(A),nat,size_size(list(A)),Y2) ) ) ).

% rtrancl_listrel1_eq_len
tff(fact_7976_uniformly__continuous__on__compose,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo7287701948861334536_space(B)
        & topolo7287701948861334536_space(C)
        & topolo7287701948861334536_space(A) )
     => ! [S: set(A),G: fun(A,B),F3: fun(B,C)] :
          ( topolo6026614971017936543ous_on(A,B,S,G)
         => ( topolo6026614971017936543ous_on(B,C,aa(set(A),set(B),image(A,B,G),S),F3)
           => topolo6026614971017936543ous_on(A,C,S,aa(fun(B,C),fun(A,C),aTP_Lamp_azr(fun(A,B),fun(fun(B,C),fun(A,C)),G),F3)) ) ) ) ).

% uniformly_continuous_on_compose
tff(fact_7977_inj__on__nth,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] :
      ( distinct(A,Xs)
     => ( ! [X4: nat] :
            ( aa(set(nat),$o,member(nat,X4),I5)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),aa(list(A),nat,size_size(list(A)),Xs)) )
       => inj_on(nat,A,nth(A,Xs),I5) ) ) ).

% inj_on_nth
tff(fact_7978_isUCont__Cauchy,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F3: fun(A,B),X7: fun(nat,A)] :
          ( topolo6026614971017936543ous_on(A,B,top_top(set(A)),F3)
         => ( topolo3814608138187158403Cauchy(A,X7)
           => topolo3814608138187158403Cauchy(B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_azq(fun(A,B),fun(fun(nat,A),fun(nat,B)),F3),X7)) ) ) ) ).

% isUCont_Cauchy
tff(fact_7979_summable__reindex,axiom,
    ! [F3: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F3)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,X4))
         => summable(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F3),G)) ) ) ) ).

% summable_reindex
tff(fact_7980_inj__on__funpow__least,axiom,
    ! [A: $tType,Nb: nat,F3: fun(A,A),S: A] :
      ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Nb),F3),S) = S )
     => ( ! [M3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M3)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Nb)
             => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M3),F3),S) != S ) ) )
       => inj_on(nat,A,aa(A,fun(nat,A),aTP_Lamp_azs(fun(A,A),fun(A,fun(nat,A)),F3),S),set_or7035219750837199246ssThan(nat,zero_zero(nat),Nb)) ) ) ).

% inj_on_funpow_least
tff(fact_7981_uniformly__continuous__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(A) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo6026614971017936543ous_on(A,B,S,F3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [D5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
                  & ! [X3: A] :
                      ( aa(set(A),$o,member(A,X3),S)
                     => ! [Xa: A] :
                          ( aa(set(A),$o,member(A,Xa),S)
                         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Xa,X3)),D5)
                           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,Xa),aa(A,B,F3,X3))),E3) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
tff(fact_7982_rtrancl__is__UN__relpow,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( transitive_rtrancl(A,R3) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_axb(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3)),top_top(set(nat)))) ) ).

% rtrancl_is_UN_relpow
tff(fact_7983_rtrancl__imp__UN__relpow,axiom,
    ! [A: $tType,P2: product_prod(A,A),R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),P2),transitive_rtrancl(A,R3))
     => aa(set(product_prod(A,A)),$o,member(product_prod(A,A),P2),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_axb(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3)),top_top(set(nat))))) ) ).

% rtrancl_imp_UN_relpow
tff(fact_7984_suminf__reindex__mono,axiom,
    ! [F3: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F3)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,X4))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),suminf(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F3),G))),suminf(real,F3)) ) ) ) ).

% suminf_reindex_mono
tff(fact_7985_isUCont__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(A) )
     => ! [F3: fun(A,B)] :
          ( topolo6026614971017936543ous_on(A,B,top_top(set(A)),F3)
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S5)
                  & ! [X3: A,Y: A] :
                      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,Y)),S5)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,X3),aa(A,B,F3,Y))),R5) ) ) ) ) ) ).

% isUCont_def
tff(fact_7986_inj__on__char__of__nat,axiom,
    inj_on(nat,char,unique5772411509450598832har_of(nat),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))) ).

% inj_on_char_of_nat
tff(fact_7987_suminf__reindex,axiom,
    ! [F3: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F3)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,X4))
         => ( ! [X4: nat] :
                ( ~ aa(set(nat),$o,member(nat,X4),aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat))))
               => ( aa(nat,real,F3,X4) = zero_zero(real) ) )
           => ( suminf(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F3),G)) = suminf(real,F3) ) ) ) ) ) ).

% suminf_reindex
tff(fact_7988_shuffles_Oelims,axiom,
    ! [A: $tType,X2: list(A),Xa2: list(A),Y2: set(list(A))] :
      ( ( shuffles(A,X2,Xa2) = Y2 )
     => ( ( ( X2 = nil(A) )
         => ( Y2 != aa(set(list(A)),set(list(A)),insert(list(A),Xa2),bot_bot(set(list(A)))) ) )
       => ( ( ( Xa2 = nil(A) )
           => ( Y2 != aa(set(list(A)),set(list(A)),insert(list(A),X2),bot_bot(set(list(A)))) ) )
         => ~ ! [X4: A,Xs2: list(A)] :
                ( ( X2 = aa(list(A),list(A),cons(A,X4),Xs2) )
               => ! [Y4: A,Ys3: list(A)] :
                    ( ( Xa2 = aa(list(A),list(A),cons(A,Y4),Ys3) )
                   => ( Y2 != aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,X4)),shuffles(A,Xs2,aa(list(A),list(A),cons(A,Y4),Ys3)))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y4)),shuffles(A,aa(list(A),list(A),cons(A,X4),Xs2),Ys3))) ) ) ) ) ) ) ).

% shuffles.elims
tff(fact_7989_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list(B),F3: fun(B,list(A))] : ( aa(list(A),set(A),set2(A),bind(B,A,Xs,F3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aTP_Lamp_azt(fun(B,list(A)),fun(B,set(A)),F3)),aa(list(B),set(B),set2(B),Xs))) ) ).

% set_list_bind
tff(fact_7990_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,list(A))] : ( bind(B,A,nil(B),F3) = nil(A) ) ).

% bind_simps(1)
tff(fact_7991_set__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),set(A),set2(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) ) ).

% set_append
tff(fact_7992_if__image__distrib,axiom,
    ! [A: $tType,B: $tType,P: fun(B,$o),F3: fun(B,A),G: fun(B,A),S3: set(B)] : ( aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_azu(fun(B,$o),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),F3),G)),S3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(B),set(A),image(B,A,F3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S3),aa(fun(B,$o),set(B),collect(B),P)))),aa(set(B),set(A),image(B,A,G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S3),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_azv(fun(B,$o),fun(B,$o),P))))) ) ).

% if_image_distrib
tff(fact_7993_UN__Un,axiom,
    ! [A: $tType,B: $tType,M6: fun(B,set(A)),A3: set(B),B4: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),M6),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B4))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),M6),A3))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),M6),B4))) ) ).

% UN_Un
tff(fact_7994_bdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [F3: fun(B,A),G: fun(B,A),A3: set(B)] :
          ( condit941137186595557371_above(A,aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_azw(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G)),A3))
        <=> ( condit941137186595557371_above(A,aa(set(B),set(A),image(B,A,F3),A3))
            & condit941137186595557371_above(A,aa(set(B),set(A),image(B,A,G),A3)) ) ) ) ).

% bdd_above_image_sup
tff(fact_7995_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X2: B,Xs: list(B),F3: fun(B,list(A))] : ( bind(B,A,aa(list(B),list(B),cons(B,X2),Xs),F3) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),aa(B,list(A),F3,X2)),bind(B,A,Xs,F3)) ) ).

% bind_simps(2)
tff(fact_7996_set__union,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),set(A),set2(A),union(A,Xs,Ys)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) ) ).

% set_union
tff(fact_7997_UN__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),B4: set(A),C6: set(B)] :
      ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_azx(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6))
      = $ite(C6 = bot_bot(set(B)),bot_bot(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4)) ) ).

% UN_simps(2)
tff(fact_7998_UN__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] :
      ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_azy(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6))
      = $ite(C6 = bot_bot(set(B)),bot_bot(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6)))) ) ).

% UN_simps(3)
tff(fact_7999_UN__insert,axiom,
    ! [A: $tType,B: $tType,B4: fun(B,set(A)),A2: B,A3: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),aa(set(B),set(B),insert(B,A2),A3))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(B,set(A),B4,A2)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),A3))) ) ).

% UN_insert
tff(fact_8000_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),Xs: list(A),Ys: list(A)] :
      ( inj_on(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)))
     => ( ( aa(list(A),list(B),map(A,B,F3),Xs) = aa(list(A),list(B),map(A,B,F3),Ys) )
      <=> ( Xs = Ys ) ) ) ).

% inj_on_map_eq_map
tff(fact_8001_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xs: list(B),Ys: list(B)] :
      ( ( aa(list(B),list(A),map(B,A,F3),Xs) = aa(list(B),list(A),map(B,A,F3),Ys) )
     => ( inj_on(B,A,F3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)))
       => ( Xs = Ys ) ) ) ).

% map_inj_on
tff(fact_8002_INF__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F3: fun(B,A),B4: set(B),A2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),B4))),A2) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(A,fun(B,A),aTP_Lamp_azz(fun(B,A),fun(A,fun(B,A)),F3),A2)),B4)) ) ) ).

% INF_sup
tff(fact_8003_Inf__sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B4: set(A),A2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),B4)),A2) = aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),image(A,A,aTP_Lamp_baa(A,fun(A,A),A2)),B4)) ) ) ).

% Inf_sup
tff(fact_8004_sup__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A2: A,F3: fun(B,A),B4: set(B)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),B4))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bab(A,fun(fun(B,A),fun(B,A)),A2),F3)),B4)) ) ) ).

% sup_INF
tff(fact_8005_INF__sup__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F3: fun(B,A),A3: set(B),G: fun(C,A),B4: set(C)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,G),B4))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_bad(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F3),G),B4)),A3)) ) ) ).

% INF_sup_distrib2
tff(fact_8006_Un__INT__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType,A3: fun(B,set(A)),I5: set(B),B4: fun(C,set(A)),J5: set(C)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),B4),J5))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_baf(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),A3),B4),J5)),I5)) ) ).

% Un_INT_distrib2
tff(fact_8007_Un__INT__distrib,axiom,
    ! [A: $tType,B: $tType,B4: set(A),A3: fun(B,set(A)),I5: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B4),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_azy(set(A),fun(fun(B,set(A)),fun(B,set(A))),B4),A3)),I5)) ) ).

% Un_INT_distrib
tff(fact_8008_INT__extend__simps_I6_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C6: set(B),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_azx(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6)) ) ).

% INT_extend_simps(6)
tff(fact_8009_INT__extend__simps_I7_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_azy(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6)) ) ).

% INT_extend_simps(7)
tff(fact_8010_Un__Inter,axiom,
    ! [A: $tType,A3: set(A),B4: set(set(A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B4)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),image(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3)),B4)) ) ).

% Un_Inter
tff(fact_8011_Un__Union__image,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),B4: fun(B,set(A)),C6: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_bag(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6))) ) ).

% Un_Union_image
tff(fact_8012_UN__Un__distrib,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),B4: fun(B,set(A)),I5: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_bag(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),I5)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),I5))) ) ).

% UN_Un_distrib
tff(fact_8013_UN__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I5: set(A),A3: fun(A,set(B))] :
      ( aa(set(A),$o,member(A,K),I5)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(A,set(B),A3,K)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5)) ) ) ).

% UN_absorb
tff(fact_8014_SUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [M6: fun(B,A),A3: set(B),B4: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,M6),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B4))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,M6),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,M6),B4))) ) ) ).

% SUP_union
tff(fact_8015_SUP__absorb,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [K: A,I5: set(A),A3: fun(A,B)] :
          ( aa(set(A),$o,member(A,K),I5)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,A3,K)),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,A3),I5))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,A3),I5)) ) ) ) ).

% SUP_absorb
tff(fact_8016_complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A),A3: set(B),G: fun(B,A)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,G),A3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bah(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G)),A3)) ) ) ).

% complete_lattice_class.SUP_sup_distrib
tff(fact_8017_SUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A),A2: B,A3: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),aa(set(B),set(B),insert(B,A2),A3))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,F3,A2)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))) ) ) ).

% SUP_insert
tff(fact_8018_card__Un__le,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(A,A3)),finite_card(A,B4))) ).

% card_Un_le
tff(fact_8019_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% sup.strict_coboundedI2
tff(fact_8020_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% sup.strict_coboundedI1
tff(fact_8021_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( ( A2 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) )
            & ( A2 != B2 ) ) ) ) ).

% sup.strict_order_iff
tff(fact_8022_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A2)
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% sup.strict_boundedE
tff(fact_8023_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) = B2 ) ) ) ).

% sup.absorb4
tff(fact_8024_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) = A2 ) ) ) ).

% sup.absorb3
tff(fact_8025_less__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% less_supI2
tff(fact_8026_less__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% less_supI1
tff(fact_8027_Un__def,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4) = aa(fun(A,$o),set(A),collect(A),aa(set(A),fun(A,$o),aTP_Lamp_bai(set(A),fun(set(A),fun(A,$o)),A3),B4)) ) ).

% Un_def
tff(fact_8028_Collect__disj__eq,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] : ( aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_om(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(fun(A,$o),set(A),collect(A),P)),aa(fun(A,$o),set(A),collect(A),Q)) ) ).

% Collect_disj_eq
tff(fact_8029_Collect__imp__eq,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] : ( aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aTP_Lamp_aos(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),aa(fun(A,$o),set(A),collect(A),P))),aa(fun(A,$o),set(A),collect(A),Q)) ) ).

% Collect_imp_eq
tff(fact_8030_insert__def,axiom,
    ! [A: $tType,A2: A,B4: set(A)] : ( aa(set(A),set(A),insert(A,A2),B4) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_dx(A,fun(A,$o),A2))),B4) ) ).

% insert_def
tff(fact_8031_set__shuffles,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys: list(A)] :
      ( aa(set(list(A)),$o,member(list(A),Zs),shuffles(A,Xs,Ys))
     => ( aa(list(A),set(A),set2(A),Zs) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) ) ) ).

% set_shuffles
tff(fact_8032_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(A),F3: fun(A,list(B)),G: fun(A,list(B))] :
      ( ( Xs = Ys )
     => ( ! [X4: A] :
            ( aa(set(A),$o,member(A,X4),aa(list(A),set(A),set2(A),Xs))
           => ( aa(A,list(B),F3,X4) = aa(A,list(B),G,X4) ) )
       => ( bind(A,B,Xs,F3) = bind(A,B,Ys,G) ) ) ) ).

% list_bind_cong
tff(fact_8033_continuous__on__cases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S: set(A),T2: set(A),F3: fun(A,B),G: fun(A,B),P: fun(A,$o)] :
          ( topolo7761053866217962861closed(A,S)
         => ( topolo7761053866217962861closed(A,T2)
           => ( topolo81223032696312382ous_on(A,B,S,F3)
             => ( topolo81223032696312382ous_on(A,B,T2,G)
               => ( ! [X4: A] :
                      ( ( ( aa(set(A),$o,member(A,X4),S)
                          & ~ aa(A,$o,P,X4) )
                        | ( aa(set(A),$o,member(A,X4),T2)
                          & aa(A,$o,P,X4) ) )
                     => ( aa(A,B,F3,X4) = aa(A,B,G,X4) ) )
                 => topolo81223032696312382ous_on(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S),T2),aa(fun(A,$o),fun(A,B),aa(fun(A,B),fun(fun(A,$o),fun(A,B)),aTP_Lamp_baj(fun(A,B),fun(fun(A,B),fun(fun(A,$o),fun(A,B))),F3),G),P)) ) ) ) ) ) ) ).

% continuous_on_cases
tff(fact_8034_continuous__on__If,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S: set(A),T2: set(A),F3: fun(A,B),G: fun(A,B),P: fun(A,$o)] :
          ( topolo7761053866217962861closed(A,S)
         => ( topolo7761053866217962861closed(A,T2)
           => ( topolo81223032696312382ous_on(A,B,S,F3)
             => ( topolo81223032696312382ous_on(A,B,T2,G)
               => ( ! [X4: A] :
                      ( aa(set(A),$o,member(A,X4),S)
                     => ( ~ aa(A,$o,P,X4)
                       => ( aa(A,B,F3,X4) = aa(A,B,G,X4) ) ) )
                 => ( ! [X4: A] :
                        ( aa(set(A),$o,member(A,X4),T2)
                       => ( aa(A,$o,P,X4)
                         => ( aa(A,B,F3,X4) = aa(A,B,G,X4) ) ) )
                   => topolo81223032696312382ous_on(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S),T2),aa(fun(A,$o),fun(A,B),aa(fun(A,B),fun(fun(A,$o),fun(A,B)),aTP_Lamp_baj(fun(A,B),fun(fun(A,B),fun(fun(A,$o),fun(A,B))),F3),G),P)) ) ) ) ) ) ) ) ).

% continuous_on_If
tff(fact_8035_INF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [M6: fun(B,A),A3: set(B),B4: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,M6),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B4))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,M6),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,M6),B4))) ) ) ).

% INF_union
tff(fact_8036_UN__extend__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C6: set(B),B4: set(A)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C6))),B4)
      = $ite(C6 = bot_bot(set(B)),B4,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_azx(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B4)),C6))) ) ).

% UN_extend_simps(2)
tff(fact_8037_UN__extend__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B4: fun(B,set(A)),C6: set(B)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B4),C6)))
      = $ite(C6 = bot_bot(set(B)),A3,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_azy(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B4)),C6))) ) ).

% UN_extend_simps(3)
tff(fact_8038_bij__betw__disjoint__Un,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(A),C6: set(B),G: fun(A,B),B4: set(A),D4: set(B)] :
      ( bij_betw(A,B,F3,A3,C6)
     => ( bij_betw(A,B,G,B4,D4)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4) = bot_bot(set(A)) )
         => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C6),D4) = bot_bot(set(B)) )
           => bij_betw(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_bak(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),F3),A3),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),C6),D4)) ) ) ) ) ).

% bij_betw_disjoint_Un
tff(fact_8039_partition__set,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),Yes: list(A),No: list(A)] :
      ( ( partition(A,P,Xs) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Yes)),aa(list(A),set(A),set2(A),No)) = aa(list(A),set(A),set2(A),Xs) ) ) ).

% partition_set
tff(fact_8040_INT__Un,axiom,
    ! [A: $tType,B: $tType,M6: fun(B,set(A)),A3: set(B),B4: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),M6),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A3),B4))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),M6),A3))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),M6),B4))) ) ).

% INT_Un
tff(fact_8041_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A),Y2: A,Ys: list(A)] : ( shuffles(A,aa(list(A),list(A),cons(A,X2),Xs),aa(list(A),list(A),cons(A,Y2),Ys)) = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,X2)),shuffles(A,Xs,aa(list(A),list(A),cons(A,Y2),Ys)))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y2)),shuffles(A,aa(list(A),list(A),cons(A,X2),Xs),Ys))) ) ).

% shuffles.simps(3)
tff(fact_8042_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,Ma: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Ma),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,Ma)),set_or7035219750837199246ssThan(A,Ma,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
tff(fact_8043_sum_Ounion__inter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B4: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B4)) ) ) ) ) ).

% sum.union_inter
tff(fact_8044_prod_Ounion__inter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B4: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4))),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) = aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,G,A3)),groups7121269368397514597t_prod(A,B,G,B4)) ) ) ) ) ).

% prod.union_inter
tff(fact_8045_card__Un__Int,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( finite_finite2(A,A3)
     => ( finite_finite2(A,B4)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(A,A3)),finite_card(A,B4)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4))),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) ) ) ) ).

% card_Un_Int
tff(fact_8046_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,Ma: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Ma),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,Ma)),set_or1337092689740270186AtMost(A,Ma,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
tff(fact_8047_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,Ma: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Ma),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,Ma)),set_or7035219750837199246ssThan(A,Ma,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(1)
tff(fact_8048_SUP__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: fun($o,A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set($o),set(A),image($o,A,A3),top_top(set($o)))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa($o,A,A3,$true)),aa($o,A,A3,$false)) ) ) ).

% SUP_UNIV_bool_expand
tff(fact_8049_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,Ma: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Ma),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,Ma)),set_or5935395276787703475ssThan(A,Ma,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(2)
tff(fact_8050_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(A,set(A),set_ord_atMost(A),L)),set_or5935395276787703475ssThan(A,L,U)) = aa(A,set(A),set_ord_lessThan(A),U) ) ) ) ).

% ivl_disj_un_one(1)
tff(fact_8051_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,Ma: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Ma),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,Ma)),set_or7035219750837199246ssThan(A,Ma,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
tff(fact_8052_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: A,B4: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_vo(A,fun(nat,A),B4)),aa(fun(nat,$o),set(nat),collect(nat),aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B4) ) ) ).

% SUP_nat_binary
tff(fact_8053_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(B,aa(set(A),set(B),image(A,B,F3),A3))
           => ( condit941137186595557371_above(B,aa(set(A),set(B),image(A,B,G),A3))
             => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,G),A3))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_bal(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)),A3)) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
tff(fact_8054_inj__on__disjoint__Un,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A),G: fun(A,B),B4: set(A)] :
      ( inj_on(A,B,F3,A3)
     => ( inj_on(A,B,G,B4)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),aa(set(A),set(B),image(A,B,G),B4)) = bot_bot(set(B)) )
         => inj_on(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_bak(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),F3),A3),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) ) ) ) ).

% inj_on_disjoint_Un
tff(fact_8055_Un__eq__UN,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set($o),set(set(A)),image($o,set(A),aa(set(A),fun($o,set(A)),aTP_Lamp_bam(set(A),fun(set(A),fun($o,set(A))),A3),B4)),top_top(set($o)))) ) ).

% Un_eq_UN
tff(fact_8056_UN__bool__eq,axiom,
    ! [A: $tType,A3: fun($o,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set($o),set(set(A)),image($o,set(A),A3),top_top(set($o)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa($o,set(A),A3,$true)),aa($o,set(A),A3,$false)) ) ).

% UN_bool_eq
tff(fact_8057_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => semila1105856199041335345_order(A,sup_sup(A),bot_bot(A),aTP_Lamp_ban(A,fun(A,$o)),aTP_Lamp_bao(A,fun(A,$o))) ) ).

% sup_bot.semilattice_neutr_order_axioms
tff(fact_8058_List_Obind__def,axiom,
    ! [A: $tType,B: $tType,Xs: list(B),F3: fun(B,list(A))] : ( bind(B,A,Xs,F3) = concat(A,aa(list(B),list(list(A)),map(B,list(A),F3),Xs)) ) ).

% List.bind_def
tff(fact_8059_sum_Ounion__inter__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B4: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))
                 => ( aa(A,B,G,X4) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B4)) ) ) ) ) ) ).

% sum.union_inter_neutral
tff(fact_8060_sum__Un,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [A3: set(A),B4: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),B4))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) ) ) ) ) ).

% sum_Un
tff(fact_8061_sum_Ounion__disjoint,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B4: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4) = bot_bot(set(A)) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B4)) ) ) ) ) ) ).

% sum.union_disjoint
tff(fact_8062_prod_Ounion__inter__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B4: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))
                 => ( aa(A,B,G,X4) = one_one(B) ) )
             => ( groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,G,A3)),groups7121269368397514597t_prod(A,B,G,B4)) ) ) ) ) ) ).

% prod.union_inter_neutral
tff(fact_8063_prod_Ounion__disjoint,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B4: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4) = bot_bot(set(A)) )
             => ( groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,G,A3)),groups7121269368397514597t_prod(A,B,G,B4)) ) ) ) ) ) ).

% prod.union_disjoint
tff(fact_8064_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B4: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4))
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B4),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) ) ) ) ).

% sum_Un2
tff(fact_8065_sum_Ounion__diff2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B4: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B4),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) ) ) ) ) ).

% sum.union_diff2
tff(fact_8066_prod_Ounion__diff2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B4: set(A),G: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B4))),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B4),A3)))),groups7121269368397514597t_prod(A,B,G,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) ) ) ) ) ).

% prod.union_diff2
tff(fact_8067_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] :
      ( finite_finite2(A,A3)
     => ( finite_finite2(A,B4)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4) = bot_bot(set(A)) )
         => ( finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(A,A3)),finite_card(A,B4)) ) ) ) ) ).

% card_Un_disjoint
tff(fact_8068_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,Ma: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Ma),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,Ma)),set_or5935395276787703475ssThan(A,Ma,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(4)
tff(fact_8069_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,L),bot_bot(set(A)))),set_or5935395276787703475ssThan(A,L,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(3)
tff(fact_8070_sum__Un__nat,axiom,
    ! [A: $tType,A3: set(A),B4: set(A),F3: fun(A,nat)] :
      ( finite_finite2(A,A3)
     => ( finite_finite2(A,B4)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),B4))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) ) ) ) ).

% sum_Un_nat
tff(fact_8071_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,Ma: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),Ma)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Ma),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,Ma)),set_or1337092689740270186AtMost(A,Ma,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(5)
tff(fact_8072_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,U)),aa(set(A),set(A),insert(A,U),bot_bot(set(A)))) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(4)
tff(fact_8073_prod__Un,axiom,
    ! [B: $tType,A: $tType] :
      ( field(B)
     => ! [A3: set(A),B4: set(A),F3: fun(A,B)] :
          ( finite_finite2(A,A3)
         => ( finite_finite2(A,B4)
           => ( ! [X4: A] :
                  ( aa(set(A),$o,member(A,X4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))
                 => ( aa(A,B,F3,X4) != zero_zero(B) ) )
             => ( groups7121269368397514597t_prod(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),groups7121269368397514597t_prod(A,B,F3,A3)),groups7121269368397514597t_prod(A,B,F3,B4))),groups7121269368397514597t_prod(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4))) ) ) ) ) ) ).

% prod_Un
tff(fact_8074_map__sorted__distinct__set__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),Xs: list(A),Ys: list(A)] :
          ( inj_on(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)))
         => ( sorted_wrt(B,ord_less_eq(B),aa(list(A),list(B),map(A,B,F3),Xs))
           => ( distinct(B,aa(list(A),list(B),map(A,B,F3),Xs))
             => ( sorted_wrt(B,ord_less_eq(B),aa(list(A),list(B),map(A,B,F3),Ys))
               => ( distinct(B,aa(list(A),list(B),map(A,B,F3),Ys))
                 => ( ( aa(list(A),set(A),set2(A),Xs) = aa(list(A),set(A),set2(A),Ys) )
                   => ( Xs = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
tff(fact_8075_UN__le__eq__Un0,axiom,
    ! [A: $tType,M6: fun(nat,set(A)),Nb: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M6),aa(nat,set(nat),set_ord_atMost(nat),Nb))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M6),set_or1337092689740270186AtMost(nat,one_one(nat),Nb)))),aa(nat,set(A),M6,zero_zero(nat))) ) ).

% UN_le_eq_Un0
tff(fact_8076_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: fun(A,B),C6: set(A),B4: set(A),X2: A] :
      ( inj_on(A,B,G,C6)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C6),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B4),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))
       => aa(set(fun(B,A)),$o,member(fun(B,A),aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_bap(fun(A,B),fun(set(A),fun(A,fun(B,A))),G),C6),X2)),bNF_Wellorder_Func(B,A,top_top(set(B)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B4),aa(set(A),set(A),insert(A,X2),bot_bot(set(A)))))) ) ) ).

% If_the_inv_into_in_Func
tff(fact_8077_lexord__take__index__conv,axiom,
    ! [A: $tType,X2: list(A),Y2: list(A),R: set(product_prod(A,A))] :
      ( aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X2),Y2)),lexord(A,R))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),X2)),aa(list(A),nat,size_size(list(A)),Y2))
          & ( take(A,aa(list(A),nat,size_size(list(A)),X2),Y2) = X2 ) )
        | ? [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),X2)),aa(list(A),nat,size_size(list(A)),Y2)))
            & ( take(A,I,X2) = take(A,I,Y2) )
            & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(nat,A,nth(A,X2),I)),aa(nat,A,nth(A,Y2),I))),R) ) ) ) ).

% lexord_take_index_conv
tff(fact_8078_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) = A2 ) ) ) ).

% min.absorb3
tff(fact_8079_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) = B2 ) ) ) ).

% min.absorb4
tff(fact_8080_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z: A,X2: A,Y2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),Y2) ) ) ) ).

% min_less_iff_conj
tff(fact_8081_min__Suc__Suc,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,Ma)),aa(nat,nat,suc,Nb)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb)) ) ).

% min_Suc_Suc
tff(fact_8082_min__0L,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),zero_zero(nat)),Nb) = zero_zero(nat) ) ).

% min_0L
tff(fact_8083_min__0R,axiom,
    ! [Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Nb),zero_zero(nat)) = zero_zero(nat) ) ).

% min_0R
tff(fact_8084_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),aa(A,A,bit_se2584673776208193580ke_bit(A,Nb),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb)),A2) ) ) ).

% take_bit_take_bit
tff(fact_8085_take__take,axiom,
    ! [A: $tType,Nb: nat,Ma: nat,Xs: list(A)] : ( take(A,Nb,take(A,Ma,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Nb),Ma),Xs) ) ).

% take_take
tff(fact_8086_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Ma: nat,Nb: nat,A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Ma),aa(A,A,bit_ri4674362597316999326ke_bit(A,Nb),A2)) = aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb)),A2) ) ) ).

% signed_take_bit_signed_take_bit
tff(fact_8087_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),U),aa(num,A,numeral_numeral(A),V)) ) ) ).

% min_number_of(1)
tff(fact_8088_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),X2)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(4)
tff(fact_8089_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),aa(num,A,numeral_numeral(A),X2)) = zero_zero(A) ) ) ).

% min_0_1(3)
tff(fact_8090_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(2)
tff(fact_8091_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),one_one(A)) = zero_zero(A) ) ) ).

% min_0_1(1)
tff(fact_8092_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),X2)),one_one(A)) = one_one(A) ) ) ).

% min_0_1(6)
tff(fact_8093_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),aa(num,A,numeral_numeral(A),X2)) = one_one(A) ) ) ).

% min_0_1(5)
tff(fact_8094_length__take,axiom,
    ! [A: $tType,Nb: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),take(A,Nb,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),Nb) ) ).

% length_take
tff(fact_8095_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Ma: nat,Nb: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Ma),bit_se2239418461657761734s_mask(A,Nb)) = bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb)) ) ) ).

% take_bit_of_mask
tff(fact_8096_take__replicate,axiom,
    ! [A: $tType,I3: nat,K: nat,X2: A] : ( take(A,I3,replicate(A,K,X2)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),I3),K),X2) ) ).

% take_replicate
tff(fact_8097_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% min_number_of(4)
tff(fact_8098_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)) ) ) ).

% min_number_of(3)
tff(fact_8099_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(num,A,numeral_numeral(A),U),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% min_number_of(2)
tff(fact_8100_min__numeral__Suc,axiom,
    ! [K: num,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Nb)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),pred_numeral(K)),Nb)) ) ).

% min_numeral_Suc
tff(fact_8101_min__Suc__numeral,axiom,
    ! [Nb: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,Nb)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Nb),pred_numeral(K))) ) ).

% min_Suc_numeral
tff(fact_8102_open__bool__def,axiom,
    topolo1002775350975398744n_open($o) = topolo8378437560675496660pology($o,aa(set(set($o)),set(set($o)),aa(set(set($o)),fun(set(set($o)),set(set($o))),sup_sup(set(set($o))),aa(set($o),set(set($o)),image($o,set($o),set_ord_lessThan($o)),top_top(set($o)))),aa(set($o),set(set($o)),image($o,set($o),set_ord_greaterThan($o)),top_top(set($o))))) ).

% open_bool_def
tff(fact_8103_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),S3: set(product_prod(A,B)),X: A,Xa3: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),sup_sup(fun(A,fun(B,$o))),aa(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o))),R3)),aa(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o))),S3)),X),Xa3)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Xa3)),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),R3),S3)) ) ).

% sup_Un_eq2
tff(fact_8104_atLeastLessThan__add__Un,axiom,
    ! [I3: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J2)
     => ( set_or7035219750837199246ssThan(nat,I3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),set_or7035219750837199246ssThan(nat,I3,J2)),set_or7035219750837199246ssThan(nat,J2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K))) ) ) ).

% atLeastLessThan_add_Un
tff(fact_8105_sup__enat__def,axiom,
    sup_sup(extended_enat) = ord_max(extended_enat) ).

% sup_enat_def
tff(fact_8106_sup__nat__def,axiom,
    sup_sup(nat) = ord_max(nat) ).

% sup_nat_def
tff(fact_8107_sup__set__def,axiom,
    ! [A: $tType,A3: set(A),B4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B4) = aa(fun(A,$o),set(A),collect(A),aa(fun(A,$o),fun(A,$o),aa(fun(A,$o),fun(fun(A,$o),fun(A,$o)),sup_sup(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),B4))) ) ).

% sup_set_def
tff(fact_8108_sup__Un__eq,axiom,
    ! [A: $tType,R3: set(A),S3: set(A),X: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aa(fun(A,$o),fun(fun(A,$o),fun(A,$o)),sup_sup(fun(A,$o)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),R3)),aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),S3)),X)
    <=> aa(set(A),$o,member(A,X),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),R3),S3)) ) ).

% sup_Un_eq
tff(fact_8109_tendsto__min,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [X7: fun(A,B),X2: B,Net: filter(A),Y5: fun(A,B),Y2: B] :
          ( filterlim(A,B,X7,topolo7230453075368039082e_nhds(B,X2),Net)
         => ( filterlim(A,B,Y5,topolo7230453075368039082e_nhds(B,Y2),Net)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_baq(fun(A,B),fun(fun(A,B),fun(A,B)),X7),Y5),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y2)),Net) ) ) ) ).

% tendsto_min
tff(fact_8110_continuous__on__min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => ( topolo81223032696312382ous_on(A,B,A3,G)
           => topolo81223032696312382ous_on(A,B,A3,aa(fun(A,B),fun(A,B),aTP_Lamp_bar(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_min
tff(fact_8111_min__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Xa3: A] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),X),Xa3)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Xa3),X,Xa3) ) ) ).

% min_def_raw
tff(fact_8112_continuous__min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [F4: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F4,F3)
         => ( topolo3448309680560233919inuous(A,B,F4,G)
           => topolo3448309680560233919inuous(A,B,F4,aa(fun(A,B),fun(A,B),aTP_Lamp_bas(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_min
tff(fact_8113_inf__nat__def,axiom,
    inf_inf(nat) = ord_min(nat) ).

% inf_nat_def
tff(fact_8114_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y2)) ) ) ).

% minus_min_eq_max
tff(fact_8115_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X2: A,Y2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),X2)),aa(A,A,uminus_uminus(A),Y2)) ) ) ).

% minus_max_eq_min
tff(fact_8116_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2)),Z) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),Z)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y2),Z)) ) ) ).

% min_diff_distrib_left
tff(fact_8117_min__diff,axiom,
    ! [Ma: nat,I3: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),I3)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Nb),I3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb)),I3) ) ).

% min_diff
tff(fact_8118_nat__mult__min__right,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Nb),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Nb)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Q2)) ) ).

% nat_mult_min_right
tff(fact_8119_nat__mult__min__left,axiom,
    ! [Ma: nat,Nb: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Ma),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Nb),Q2)) ) ).

% nat_mult_min_left
tff(fact_8120_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2)),Z) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y2),Z)) ) ) ).

% min_add_distrib_left
tff(fact_8121_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X2: A,Y2: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),aa(A,A,aa(A,fun(A,A),ord_min(A),Y2),Z)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Z)) ) ) ).

% min_add_distrib_right
tff(fact_8122_of__nat__min,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X2: nat,Y2: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),X2),Y2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(nat,A,semiring_1_of_nat(A),X2)),aa(nat,A,semiring_1_of_nat(A),Y2)) ) ) ).

% of_nat_min
tff(fact_8123_concat__bit__assoc__sym,axiom,
    ! [Ma: nat,Nb: nat,K: int,L: int,R: int] : ( aa(int,int,bit_concat_bit(Ma,aa(int,int,bit_concat_bit(Nb,K),L)),R) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb),K),aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb),L),R)) ) ).

% concat_bit_assoc_sym
tff(fact_8124_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X2: A,Y2: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2)),Z)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X2),Z)
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y2),Z) ) ) ) ).

% min_less_iff_disj
tff(fact_8125_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2))
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% min.strict_boundedE
tff(fact_8126_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( ( A2 = aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) )
            & ( A2 != B2 ) ) ) ) ).

% min.strict_order_iff
tff(fact_8127_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),C2) ) ) ).

% min.strict_coboundedI1
tff(fact_8128_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),C2) ) ) ).

% min.strict_coboundedI2
tff(fact_8129_take__bit__concat__bit__eq,axiom,
    ! [Ma: nat,Nb: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Ma),aa(int,int,bit_concat_bit(Nb,K),L)) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb),K),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Ma),Nb)),L)) ) ).

% take_bit_concat_bit_eq
tff(fact_8130_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A,P2: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2)),P2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),P2)),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),P2))) ) ) ).

% min_mult_distrib_right
tff(fact_8131_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X2: A,Y2: A,P2: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2)),P2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),P2)),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X2),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y2),P2))) ) ) ).

% max_mult_distrib_right
tff(fact_8132_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P2: A,X2: A,Y2: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y2)),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y2))) ) ) ).

% min_mult_distrib_left
tff(fact_8133_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P2: A,X2: A,Y2: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y2)),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),X2)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y2))) ) ) ).

% max_mult_distrib_left
tff(fact_8134_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A,P2: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2)),P2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),P2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),P2)),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),P2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),P2))) ) ) ).

% min_divide_distrib_right
tff(fact_8135_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X2: A,Y2: A,P2: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2)),P2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),P2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),P2)),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X2),P2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y2),P2))) ) ) ).

% max_divide_distrib_right
tff(fact_8136_min__Suc1,axiom,
    ! [Nb: nat,Ma: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,Nb)),Ma) = case_nat(nat,zero_zero(nat),aTP_Lamp_bat(nat,fun(nat,nat),Nb),Ma) ) ).

% min_Suc1
tff(fact_8137_min__Suc2,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),aa(nat,nat,suc,Nb)) = case_nat(nat,zero_zero(nat),aTP_Lamp_bau(nat,fun(nat,nat),Nb),Ma) ) ).

% min_Suc2
tff(fact_8138_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Ma: nat,Nb: nat] : ( modulo_modulo(A,modulo_modulo(A,A2,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)) = modulo_modulo(A,A2,aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb))) ) ) ).

% mod_exp_eq
tff(fact_8139_rtrancl__insert,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A))] : ( transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A2),B2)),R)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_rtrancl(A,R)),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_bav(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),A2),B2),R)))) ) ).

% rtrancl_insert
tff(fact_8140_trancl__insert2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A))] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A2),B2)),R)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_trancl(A,R)),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_baw(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),A2),B2),R)))) ) ).

% trancl_insert2
tff(fact_8141_open__nat__def,axiom,
    topolo1002775350975398744n_open(nat) = topolo8378437560675496660pology(nat,aa(set(set(nat)),set(set(nat)),aa(set(set(nat)),fun(set(set(nat)),set(set(nat))),sup_sup(set(set(nat))),aa(set(nat),set(set(nat)),image(nat,set(nat),set_ord_lessThan(nat)),top_top(set(nat)))),aa(set(nat),set(set(nat)),image(nat,set(nat),set_ord_greaterThan(nat)),top_top(set(nat))))) ).

% open_nat_def
tff(fact_8142_Pow__set_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list(A)] :
      ( pow2(A,aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,X2),Xs)))
      = $let(
          a3: set(set(A)),
          a3 := pow2(A,aa(list(A),set(A),set2(A),Xs)),
          aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),a3),aa(set(set(A)),set(set(A)),image(set(A),set(A),insert(A,X2)),a3)) ) ) ).

% Pow_set(2)
tff(fact_8143_trancl__insert,axiom,
    ! [A: $tType,Y2: A,X2: A,R: set(product_prod(A,A))] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),X2)),R)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_trancl(A,R)),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_bav(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),Y2),X2),R)))) ) ).

% trancl_insert
tff(fact_8144_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Nb: nat,Ma: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Nb)),one_one(A)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Ma)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb))),one_one(A)) ) ) ).

% mask_mod_exp
tff(fact_8145_open__generated__order,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ( topolo1002775350975398744n_open(A) = topolo8378437560675496660pology(A,aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),aa(set(A),set(set(A)),image(A,set(A),set_ord_lessThan(A)),top_top(set(A)))),aa(set(A),set(set(A)),image(A,set(A),set_ord_greaterThan(A)),top_top(set(A))))) ) ) ).

% open_generated_order
tff(fact_8146_Pow__fold,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ( pow2(A,A3) = finite_fold(A,set(set(A)),aTP_Lamp_bax(A,fun(set(set(A)),set(set(A)))),aa(set(set(A)),set(set(A)),insert(set(A),bot_bot(set(A))),bot_bot(set(set(A)))),A3) ) ) ).

% Pow_fold
tff(fact_8147_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X2: A,Xs: list(A)] : ( min_list(A,aa(list(A),list(A),cons(A,X2),Xs)) = aa(list(A),A,case_list(A,A,X2,aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_bay(A,fun(list(A),fun(A,fun(list(A),A))),X2),Xs)),Xs) ) ) ).

% min_list.simps
tff(fact_8148_min__enat__simps_I5_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),extend4730790105801354508finity(extended_enat)),Q2) = Q2 ) ).

% min_enat_simps(5)
tff(fact_8149_min__enat__simps_I4_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) = Q2 ) ).

% min_enat_simps(4)
tff(fact_8150_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),Q2),zero_zero(extended_enat)) = zero_zero(extended_enat) ) ).

% min_enat_simps(2)
tff(fact_8151_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),zero_zero(extended_enat)),Q2) = zero_zero(extended_enat) ) ).

% min_enat_simps(3)
tff(fact_8152_min__enat__simps_I1_J,axiom,
    ! [Ma: nat,Nb: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),extended_enat2(Ma)),extended_enat2(Nb)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Ma),Nb)) ) ).

% min_enat_simps(1)
tff(fact_8153_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,plus_plus(A)),G),zero_zero(A),A3) ) ) ).

% sum.eq_fold
tff(fact_8154_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A3: set(B)] : ( groups7121269368397514597t_prod(B,A,G,A3) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,times_times(A)),G),one_one(A),A3) ) ) ).

% prod.eq_fold
tff(fact_8155_image__fold__insert,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F3: fun(A,B)] :
      ( finite_finite2(A,A3)
     => ( aa(set(A),set(B),image(A,B,F3),A3) = finite_fold(A,set(B),aTP_Lamp_baz(fun(A,B),fun(A,fun(set(B),set(B))),F3),bot_bot(set(B)),A3) ) ) ).

% image_fold_insert
tff(fact_8156_Set__filter__fold,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o)] :
      ( finite_finite2(A,A3)
     => ( filter3(A,P,A3) = finite_fold(A,set(A),aTP_Lamp_bba(fun(A,$o),fun(A,fun(set(A),set(A))),P),bot_bot(set(A)),A3) ) ) ).

% Set_filter_fold
tff(fact_8157_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set(product_prod(A,B)),X2: product_prod(C,A),X7: set(product_prod(C,B))] :
      ( finite_finite2(product_prod(A,B),S3)
     => ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),sup_sup(set(product_prod(C,B))),relcomp(C,A,B,aa(set(product_prod(C,A)),set(product_prod(C,A)),insert(product_prod(C,A),X2),bot_bot(set(product_prod(C,A)))),S3)),X7) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_bbb(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),X2)),X7,S3) ) ) ).

% insert_relcomp_union_fold
tff(fact_8158_inf__enat__def,axiom,
    inf_inf(extended_enat) = ord_min(extended_enat) ).

% inf_enat_def
tff(fact_8159_card_Oeq__fold,axiom,
    ! [A: $tType,A3: set(A)] : ( finite_card(A,A3) = finite_fold(A,nat,aTP_Lamp_bbc(A,fun(nat,nat)),zero_zero(nat),A3) ) ).

% card.eq_fold
tff(fact_8160_Ball__fold,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o)] :
      ( finite_finite2(A,A3)
     => ( ! [X3: A] :
            ( aa(set(A),$o,member(A,X3),A3)
           => aa(A,$o,P,X3) )
      <=> finite_fold(A,$o,aTP_Lamp_bbd(fun(A,$o),fun(A,fun($o,$o)),P),$true,A3) ) ) ).

% Ball_fold
tff(fact_8161_Set_Ofilter__def,axiom,
    ! [A: $tType,P: fun(A,$o),A3: set(A)] : ( filter3(A,P,A3) = aa(fun(A,$o),set(A),collect(A),aa(set(A),fun(A,$o),aTP_Lamp_bbe(fun(A,$o),fun(set(A),fun(A,$o)),P),A3)) ) ).

% Set.filter_def
tff(fact_8162_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : ( aa(set(A),list(A),linord4507533701916653071of_set(A),A3) = finite_fold(A,list(A),linorder_insort_key(A,A,aTP_Lamp_qr(A,A)),nil(A),A3) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
tff(fact_8163_filter__set,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( filter3(A,P,aa(list(A),set(A),set2(A),Xs)) = aa(list(A),set(A),set2(A),aa(list(A),list(A),filter2(A,P),Xs)) ) ).

% filter_set
tff(fact_8164_inter__Set__filter,axiom,
    ! [A: $tType,B4: set(A),A3: set(A)] :
      ( finite_finite2(A,B4)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B4) = filter3(A,aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),A3),B4) ) ) ).

% inter_Set_filter
tff(fact_8165_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,B)),S3: set(product_prod(B,C))] :
      ( finite_finite2(product_prod(A,B),R3)
     => ( finite_finite2(product_prod(B,C),S3)
       => ( relcomp(A,B,C,R3,S3) = finite_fold(product_prod(A,B),set(product_prod(A,C)),aa(fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),fun(product_prod(A,B),fun(set(product_prod(A,C)),set(product_prod(A,C)))),product_case_prod(A,B,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aTP_Lamp_bbg(set(product_prod(B,C)),fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),S3)),bot_bot(set(product_prod(A,C))),R3) ) ) ) ).

% relcomp_fold
tff(fact_8166_Id__on__fold,axiom,
    ! [A: $tType,A3: set(A)] :
      ( finite_finite2(A,A3)
     => ( id_on(A,A3) = finite_fold(A,set(product_prod(A,A)),aTP_Lamp_bbh(A,fun(set(product_prod(A,A)),set(product_prod(A,A)))),bot_bot(set(product_prod(A,A))),A3) ) ) ).

% Id_on_fold
tff(fact_8167_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set(product_prod(A,B)),X2: product_prod(C,A),R3: set(product_prod(C,A))] :
      ( finite_finite2(product_prod(A,B),S3)
     => ( relcomp(C,A,B,aa(set(product_prod(C,A)),set(product_prod(C,A)),insert(product_prod(C,A),X2),R3),S3) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_bbb(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),X2)),relcomp(C,A,B,R3,S3),S3) ) ) ).

% insert_relcomp_fold
tff(fact_8168_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_bbi(A,fun(option(A),option(A))),none(A),A3)) ) ) ).

% Max.eq_fold'
tff(fact_8169_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B4: set(A),X2: B,A3: set(product_prod(B,A))] :
      ( finite_finite2(A,B4)
     => ( aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),set(product_prod(B,A))),sup_sup(set(product_prod(B,A))),aa(set(set(product_prod(B,A))),set(product_prod(B,A)),complete_Sup_Sup(set(product_prod(B,A))),aa(set(A),set(set(product_prod(B,A))),image(A,set(product_prod(B,A)),aTP_Lamp_bbj(B,fun(A,set(product_prod(B,A))),X2)),B4))),A3) = finite_fold(A,set(product_prod(B,A)),aTP_Lamp_bbk(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),X2),A3,B4) ) ) ).

% fold_union_pair
tff(fact_8170_comp__fun__commute__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set(product_prod(A,B))] :
      ( finite_finite2(product_prod(A,B),S3)
     => finite6289374366891150609ommute(product_prod(C,A),set(product_prod(C,B)),aa(fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(C,A),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(C,A,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_bbm(set(product_prod(A,B)),fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),S3))) ) ).

% comp_fun_commute_relcomp_fold
tff(fact_8171_comp__fun__commute__product__fold,axiom,
    ! [B: $tType,A: $tType,B4: set(A)] :
      ( finite_finite2(A,B4)
     => finite6289374366891150609ommute(B,set(product_prod(B,A)),aTP_Lamp_bbn(set(A),fun(B,fun(set(product_prod(B,A)),set(product_prod(B,A)))),B4)) ) ).

% comp_fun_commute_product_fold
tff(fact_8172_comp__fun__commute_Ocomp__fun__commute__funpow,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,fun(B,B)),G: fun(A,nat)] :
      ( finite6289374366891150609ommute(A,B,F3)
     => finite6289374366891150609ommute(A,B,aa(fun(A,nat),fun(A,fun(B,B)),aTP_Lamp_bbo(fun(A,fun(B,B)),fun(fun(A,nat),fun(A,fun(B,B))),F3),G)) ) ).

% comp_fun_commute.comp_fun_commute_funpow
tff(fact_8173_comp__fun__commute__const,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,B)] : finite6289374366891150609ommute(A,B,aTP_Lamp_bbp(fun(B,B),fun(A,fun(B,B)),F3)) ).

% comp_fun_commute_const
tff(fact_8174_comp__fun__commute__filter__fold,axiom,
    ! [A: $tType,P: fun(A,$o)] : finite6289374366891150609ommute(A,set(A),aTP_Lamp_bba(fun(A,$o),fun(A,fun(set(A),set(A))),P)) ).

% comp_fun_commute_filter_fold
tff(fact_8175_comp__fun__commute__Image__fold,axiom,
    ! [B: $tType,A: $tType,S3: set(A)] : finite6289374366891150609ommute(product_prod(A,B),set(B),aa(fun(A,fun(B,fun(set(B),set(B)))),fun(product_prod(A,B),fun(set(B),set(B))),product_case_prod(A,B,fun(set(B),set(B))),aTP_Lamp_bbq(set(A),fun(A,fun(B,fun(set(B),set(B)))),S3))) ).

% comp_fun_commute_Image_fold
tff(fact_8176_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A)] : ( lattic5882676163264333800up_fin(A,A3) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_bbr(A,fun(option(A),option(A))),none(A),A3)) ) ) ).

% Sup_fin.eq_fold'
tff(fact_8177_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A)] : ( lattic7752659483105999362nf_fin(A,A3) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_bbs(A,fun(option(A),option(A))),none(A),A3)) ) ) ).

% Inf_fin.eq_fold'
tff(fact_8178_comp__fun__commute__insort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => finite6289374366891150609ommute(A,list(A),linorder_insort_key(A,A,aTP_Lamp_qr(A,A))) ) ).

% comp_fun_commute_insort
tff(fact_8179_Sup__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A)] :
          ( ~ finite_finite2(A,A3)
         => ( lattic5882676163264333800up_fin(A,A3) = aa(option(A),A,the2(A),none(A)) ) ) ) ).

% Sup_fin.infinite
tff(fact_8180_Inf__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A)] :
          ( ~ finite_finite2(A,A3)
         => ( lattic7752659483105999362nf_fin(A,A3) = aa(option(A),A,the2(A),none(A)) ) ) ) ).

% Inf_fin.infinite
tff(fact_8181_ATP_Olambda__1,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_br(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uu)),one_one(real))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat)))) ) ).

% ATP.lambda_1
tff(fact_8182_ATP_Olambda__2,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_aib(A,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Uu)),one_one(A))),Uu) ) ) ).

% ATP.lambda_2
tff(fact_8183_ATP_Olambda__3,axiom,
    ! [A: $tType,Uu: set(set(A))] : ( aa(set(set(A)),int,aTP_Lamp_uu(set(set(A)),int),Uu) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(set(A),Uu)),one_one(nat)))),aa(nat,int,semiring_1_of_nat(int),finite_card(A,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),Uu)))) ) ).

% ATP.lambda_3
tff(fact_8184_ATP_Olambda__4,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,set(product_prod(A,A)),aTP_Lamp_yr(A,set(product_prod(A,A))),Uu) = aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu)),bot_bot(set(product_prod(A,A)))) ) ).

% ATP.lambda_4
tff(fact_8185_ATP_Olambda__5,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_db(nat,real),Uu) = aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_5
tff(fact_8186_ATP_Olambda__6,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_dw(real,$o),Uu)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Uu)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uu),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
        & ( cos(real,Uu) = zero_zero(real) ) ) ) ).

% ATP.lambda_6
tff(fact_8187_ATP_Olambda__7,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ajy(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uu))),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_7
tff(fact_8188_ATP_Olambda__8,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_il(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),times_times(real),cos_coeff(Uu)),aa(nat,real,power_power(real,zero_zero(real)),Uu)) ) ).

% ATP.lambda_8
tff(fact_8189_ATP_Olambda__9,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ajz(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uu))) ) ) ).

% ATP.lambda_9
tff(fact_8190_ATP_Olambda__10,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_aif(real,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,Uu)),sin(real,Uu)) ) ).

% ATP.lambda_10
tff(fact_8191_ATP_Olambda__11,axiom,
    ! [A: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [Uu: product_prod(A,A)] : ( aa(product_prod(A,A),A,aTP_Lamp_axm(product_prod(A,A),A),Uu) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(product_prod(A,A),A,product_fst(A,A),Uu)),aa(product_prod(A,A),A,product_snd(A,A),Uu)) ) ) ).

% ATP.lambda_11
tff(fact_8192_ATP_Olambda__12,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [Uu: product_prod(A,A)] : ( aa(product_prod(A,A),A,aTP_Lamp_axn(product_prod(A,A),A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(product_prod(A,A),A,product_fst(A,A),Uu)),aa(product_prod(A,A),A,product_snd(A,A),Uu)) ) ) ).

% ATP.lambda_12
tff(fact_8193_ATP_Olambda__13,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_ang(real,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),Uu)),Uu) ) ).

% ATP.lambda_13
tff(fact_8194_ATP_Olambda__14,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: nat] :
          ( aa(nat,$o,aTP_Lamp_rf(nat,$o),Uu)
        <=> ( aa(nat,A,semiring_1_of_nat(A),Uu) = zero_zero(A) ) ) ) ).

% ATP.lambda_14
tff(fact_8195_ATP_Olambda__15,axiom,
    ! [Uu: vEBT_VEBT] : ( aa(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_a(vEBT_VEBT,vEBT_VEBT),Uu) = vEBT_VEBT_elim_dead(Uu,extended_enat2(aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),dega),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% ATP.lambda_15
tff(fact_8196_ATP_Olambda__16,axiom,
    ! [Uu: vEBT_VEBT] : ( aa(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_aa(vEBT_VEBT,vEBT_VEBT),Uu) = vEBT_VEBT_elim_dead(Uu,extended_enat2(aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),na))) ) ).

% ATP.lambda_16
tff(fact_8197_ATP_Olambda__17,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_ajg(nat,real),Uu) = aa(real,real,root(Uu),aa(nat,real,semiring_1_of_nat(real),Uu)) ) ).

% ATP.lambda_17
tff(fact_8198_ATP_Olambda__18,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_ls(nat,nat),Uu) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,suc,zero_zero(nat))) ) ).

% ATP.lambda_18
tff(fact_8199_ATP_Olambda__19,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,product_prod(B,B),aTP_Lamp_qm(B,product_prod(B,B)),Uu) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu) ) ).

% ATP.lambda_19
tff(fact_8200_ATP_Olambda__20,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,product_prod(A,A),aTP_Lamp_ql(A,product_prod(A,A)),Uu) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu) ) ).

% ATP.lambda_20
tff(fact_8201_ATP_Olambda__21,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_dp(A,A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),one_one(A)) ) ) ).

% ATP.lambda_21
tff(fact_8202_ATP_Olambda__22,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,list(A),aTP_Lamp_xx(A,list(A)),Uu) = aa(list(A),list(A),cons(A,Uu),nil(A)) ) ).

% ATP.lambda_22
tff(fact_8203_ATP_Olambda__23,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,set(A),aTP_Lamp_tl(A,set(A)),Uu) = aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))) ) ).

% ATP.lambda_23
tff(fact_8204_ATP_Olambda__24,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_ajq(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),Uu)) ) ).

% ATP.lambda_24
tff(fact_8205_ATP_Olambda__25,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ajx(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_25
tff(fact_8206_ATP_Olambda__26,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_wi(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(B),nat,size_size(list(B)),Uu)),aa(nat,nat,suc,zero_zero(nat)))) ) ).

% ATP.lambda_26
tff(fact_8207_ATP_Olambda__27,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,fun(set(product_prod(A,A)),set(product_prod(A,A))),aTP_Lamp_bbh(A,fun(set(product_prod(A,A)),set(product_prod(A,A)))),Uu) = insert(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu)) ) ).

% ATP.lambda_27
tff(fact_8208_ATP_Olambda__28,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_wj(list(B),$o),Uu)
    <=> ( Uu != nil(B) ) ) ).

% ATP.lambda_28
tff(fact_8209_ATP_Olambda__29,axiom,
    ! [A: $tType,Uu: list(A)] :
      ( aa(list(A),$o,aTP_Lamp_wk(list(A),$o),Uu)
    <=> ( Uu != nil(A) ) ) ).

% ATP.lambda_29
tff(fact_8210_ATP_Olambda__30,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_abc(real,real),Uu) = suminf(real,aTP_Lamp_bp(real,fun(nat,real),Uu)) ) ).

% ATP.lambda_30
tff(fact_8211_ATP_Olambda__31,axiom,
    ! [Uu: nat] : ( aa(nat,set(nat),aTP_Lamp_amu(nat,set(nat)),Uu) = aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_oc(nat,fun(nat,$o),Uu)) ) ).

% ATP.lambda_31
tff(fact_8212_ATP_Olambda__32,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real] : ( aa(real,filter(A),aTP_Lamp_anl(real,filter(A)),Uu) = aa(set(A),filter(A),principal(A),aa(fun(A,$o),set(A),collect(A),aTP_Lamp_ank(real,fun(A,$o),Uu))) ) ) ).

% ATP.lambda_32
tff(fact_8213_ATP_Olambda__33,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B)] : ( aa(fun(A,B),set(product_prod(A,B)),aTP_Lamp_azn(fun(A,B),set(product_prod(A,B))),Uu) = aa(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aTP_Lamp_azm(fun(A,B),fun(A,fun(B,$o)),Uu))) ) ).

% ATP.lambda_33
tff(fact_8214_ATP_Olambda__34,axiom,
    ! [Uu: real] : ( aa(real,filter(product_prod(complex,complex)),aTP_Lamp_awy(real,filter(product_prod(complex,complex))),Uu) = aa(set(product_prod(complex,complex)),filter(product_prod(complex,complex)),principal(product_prod(complex,complex)),aa(fun(product_prod(complex,complex),$o),set(product_prod(complex,complex)),collect(product_prod(complex,complex)),aa(fun(complex,fun(complex,$o)),fun(product_prod(complex,complex),$o),product_case_prod(complex,complex,$o),aTP_Lamp_awx(real,fun(complex,fun(complex,$o)),Uu)))) ) ).

% ATP.lambda_34
tff(fact_8215_ATP_Olambda__35,axiom,
    ! [Uu: real] : ( aa(real,filter(product_prod(real,real)),aTP_Lamp_aww(real,filter(product_prod(real,real))),Uu) = aa(set(product_prod(real,real)),filter(product_prod(real,real)),principal(product_prod(real,real)),aa(fun(product_prod(real,real),$o),set(product_prod(real,real)),collect(product_prod(real,real)),aa(fun(real,fun(real,$o)),fun(product_prod(real,real),$o),product_case_prod(real,real,$o),aTP_Lamp_awv(real,fun(real,fun(real,$o)),Uu)))) ) ).

% ATP.lambda_35
tff(fact_8216_ATP_Olambda__36,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [Uu: real] : ( aa(real,filter(product_prod(A,A)),aTP_Lamp_aws(real,filter(product_prod(A,A))),Uu) = aa(set(product_prod(A,A)),filter(product_prod(A,A)),principal(product_prod(A,A)),aa(fun(product_prod(A,A),$o),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aTP_Lamp_awr(real,fun(A,fun(A,$o)),Uu)))) ) ) ).

% ATP.lambda_36
tff(fact_8217_ATP_Olambda__37,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_ajs(nat,real),Uu) = aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uu))) ) ).

% ATP.lambda_37
tff(fact_8218_ATP_Olambda__38,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_eg(nat,A),Uu) = aa(A,A,inverse_inverse(A),semiring_char_0_fact(A,Uu)) ) ) ).

% ATP.lambda_38
tff(fact_8219_ATP_Olambda__39,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ajk(nat,A),Uu) = aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_39
tff(fact_8220_ATP_Olambda__40,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_wh(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(B),nat,size_size(list(B)),Uu)) ) ).

% ATP.lambda_40
tff(fact_8221_ATP_Olambda__41,axiom,
    ! [A: $tType,Uu: list(A)] : ( aa(list(A),fun(nat,nat),aTP_Lamp_vn(list(A),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Uu)) ) ).

% ATP.lambda_41
tff(fact_8222_ATP_Olambda__42,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_awb(A,B),Uu) = ring_1_of_int(B,archim6421214686448440834_floor(A,Uu)) ) ) ).

% ATP.lambda_42
tff(fact_8223_ATP_Olambda__43,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_awc(A,B),Uu) = ring_1_of_int(B,archimedean_ceiling(A,Uu)) ) ) ).

% ATP.lambda_43
tff(fact_8224_ATP_Olambda__44,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_za(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit1,Uu)) ) ).

% ATP.lambda_44
tff(fact_8225_ATP_Olambda__45,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_yw(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit0,Uu)) ) ).

% ATP.lambda_45
tff(fact_8226_ATP_Olambda__46,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_hf(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),Uu)) ) ).

% ATP.lambda_46
tff(fact_8227_ATP_Olambda__47,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_hi(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_47
tff(fact_8228_ATP_Olambda__48,axiom,
    ! [Uu: nat] : ( aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_bd(nat,fun(nat,product_prod(nat,nat))),Uu) = aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_48
tff(fact_8229_ATP_Olambda__49,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: A] : ( aa(A,filter(A),aTP_Lamp_amn(A,filter(A)),Uu) = aa(set(A),filter(A),principal(A),aa(A,set(A),set_ord_greaterThan(A),Uu)) ) ) ).

% ATP.lambda_49
tff(fact_8230_ATP_Olambda__50,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: A] : ( aa(A,filter(A),aTP_Lamp_amm(A,filter(A)),Uu) = aa(set(A),filter(A),principal(A),aa(A,set(A),set_ord_lessThan(A),Uu)) ) ) ).

% ATP.lambda_50
tff(fact_8231_ATP_Olambda__51,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,filter(A),aTP_Lamp_amr(A,filter(A)),Uu) = aa(set(A),filter(A),principal(A),aa(A,set(A),set_ord_atMost(A),Uu)) ) ) ).

% ATP.lambda_51
tff(fact_8232_ATP_Olambda__52,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: A] : ( aa(A,filter(A),aTP_Lamp_ams(A,filter(A)),Uu) = aa(set(A),filter(A),principal(A),aa(A,set(A),set_ord_atMost(A),Uu)) ) ) ).

% ATP.lambda_52
tff(fact_8233_ATP_Olambda__53,axiom,
    ! [Uu: int] : ( aa(int,nat,aTP_Lamp_sg(int,nat),Uu) = aa(int,nat,nat2,aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_53
tff(fact_8234_ATP_Olambda__54,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_ayy(product_prod(A,A),$o),Uu)
        <=> ? [X3: A] : ( Uu = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),X3) ) ) ) ).

% ATP.lambda_54
tff(fact_8235_ATP_Olambda__55,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_ayw(product_prod(A,A),$o),Uu)
        <=> ? [X3: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y) )
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y) ) ) ) ).

% ATP.lambda_55
tff(fact_8236_ATP_Olambda__56,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_ayx(product_prod(A,A),$o),Uu)
        <=> ? [X3: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y) )
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),X3) ) ) ) ).

% ATP.lambda_56
tff(fact_8237_ATP_Olambda__57,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_ask(product_prod(A,A),$o),Uu)
        <=> ? [X3: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y) )
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y) ) ) ) ).

% ATP.lambda_57
tff(fact_8238_ATP_Olambda__58,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_asj(product_prod(A,A),$o),Uu)
        <=> ? [X3: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y) )
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X3) ) ) ) ).

% ATP.lambda_58
tff(fact_8239_ATP_Olambda__59,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_asl(product_prod(A,A),$o),Uu)
        <=> ? [X3: A,Y: A] :
              ( ( Uu = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y) )
              & ( X3 != Y ) ) ) ) ).

% ATP.lambda_59
tff(fact_8240_ATP_Olambda__60,axiom,
    ! [Uu: nat] : ( aa(nat,option(num),aTP_Lamp_yy(nat,option(num)),Uu) = aa(num,option(num),some(num),one2) ) ).

% ATP.lambda_60
tff(fact_8241_ATP_Olambda__61,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_zd(num,fun(nat,option(num)),Uu),Uua) = case_num(option(num),aa(num,option(num),some(num),one2),aTP_Lamp_zb(nat,fun(num,option(num)),Uua),aTP_Lamp_zc(nat,fun(num,option(num)),Uua),Uu) ) ).

% ATP.lambda_61
tff(fact_8242_ATP_Olambda__62,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_es(A,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,power_power(A,Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_62
tff(fact_8243_ATP_Olambda__63,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_hc(nat,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_63
tff(fact_8244_ATP_Olambda__64,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_et(A,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,power_power(A,Uu),Uua))) ) ) ).

% ATP.lambda_64
tff(fact_8245_ATP_Olambda__65,axiom,
    ! [Uu: fun(nat,real),Uua: nat] :
      ( aa(nat,real,aTP_Lamp_dc(fun(nat,real),fun(nat,real),Uu),Uua)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),zero_zero(real),aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% ATP.lambda_65
tff(fact_8246_ATP_Olambda__66,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: product_prod(A,C),Uua: product_prod(C,B)] :
      ( aa(product_prod(C,B),list(product_prod(A,B)),aTP_Lamp_yk(product_prod(A,C),fun(product_prod(C,B),list(product_prod(A,B))),Uu),Uua)
      = $ite(aa(product_prod(A,C),C,product_snd(A,C),Uu) = aa(product_prod(C,B),C,product_fst(C,B),Uua),aa(list(product_prod(A,B)),list(product_prod(A,B)),cons(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,C),A,product_fst(A,C),Uu)),aa(product_prod(C,B),B,product_snd(C,B),Uua))),nil(product_prod(A,B))),nil(product_prod(A,B))) ) ).

% ATP.lambda_66
tff(fact_8247_ATP_Olambda__67,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ff(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uu = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),Uu)),Uua)),aa(int,int,abs_abs(int),Uu))) ) ).

% ATP.lambda_67
tff(fact_8248_ATP_Olambda__68,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( aa(nat,extended_enat,aTP_Lamp_ak(extended_enat,fun(nat,extended_enat),Uu),Uua)
      = extended_case_enat(extended_enat,aTP_Lamp_aj(nat,fun(nat,extended_enat),Uua),$ite(Uua = zero_zero(nat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)),Uu) ) ).

% ATP.lambda_68
tff(fact_8249_ATP_Olambda__69,axiom,
    ! [Uu: extended_enat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_au(extended_enat,fun(nat,extended_enat),Uu),Uua) = extended_case_enat(extended_enat,aTP_Lamp_at(nat,fun(nat,extended_enat),Uua),zero_zero(extended_enat),Uu) ) ).

% ATP.lambda_69
tff(fact_8250_ATP_Olambda__70,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_an(extended_enat,fun(nat,$o),Uu),Uua)
    <=> extended_case_enat($o,aa(nat,fun(nat,$o),aTP_Lamp_am(nat,fun(nat,$o)),Uua),$false,Uu) ) ).

% ATP.lambda_70
tff(fact_8251_ATP_Olambda__71,axiom,
    ! [Uu: extended_enat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_ah(extended_enat,fun(nat,extended_enat),Uu),Uua) = extended_case_enat(extended_enat,aTP_Lamp_ag(nat,fun(nat,extended_enat),Uua),extend4730790105801354508finity(extended_enat),Uu) ) ).

% ATP.lambda_71
tff(fact_8252_ATP_Olambda__72,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_hd(nat,fun(nat,A),Uu),Uua)
          = $ite(~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_72
tff(fact_8253_ATP_Olambda__73,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_ai(extended_enat,fun(nat,$o),Uu),Uua)
    <=> extended_case_enat($o,aa(nat,fun(nat,$o),ord_less(nat),Uua),$true,Uu) ) ).

% ATP.lambda_73
tff(fact_8254_ATP_Olambda__74,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(nat,A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_alj(fun(nat,A),fun(A,$o),Uu),Uua)
        <=> filterlim(nat,A,Uu,topolo7230453075368039082e_nhds(A,Uua),at_top(nat)) ) ) ).

% ATP.lambda_74
tff(fact_8255_ATP_Olambda__75,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_aya(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),top_top(A)) ) ) ).

% ATP.lambda_75
tff(fact_8256_ATP_Olambda__76,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_xd(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),bot_bot(A)) ) ) ).

% ATP.lambda_76
tff(fact_8257_ATP_Olambda__77,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_axz(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),bot_bot(A)) ) ) ).

% ATP.lambda_77
tff(fact_8258_ATP_Olambda__78,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aa(nat,fun(num,option(num)),aTP_Lamp_ze(nat,fun(num,option(num))),Uu),Uua) = case_nat(option(num),none(num),aTP_Lamp_zd(num,fun(nat,option(num)),Uua),Uu) ) ).

% ATP.lambda_78
tff(fact_8259_ATP_Olambda__79,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_zb(nat,fun(num,option(num)),Uu),Uua) = case_option(option(num),num,none(num),aTP_Lamp_yw(num,option(num)),bit_take_bit_num(Uu,Uua)) ) ).

% ATP.lambda_79
tff(fact_8260_ATP_Olambda__80,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_yx(num,fun(nat,option(num)),Uu),Uua) = case_option(option(num),num,none(num),aTP_Lamp_yw(num,option(num)),bit_take_bit_num(Uua,Uu)) ) ).

% ATP.lambda_80
tff(fact_8261_ATP_Olambda__81,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,$o)),Uua: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aTP_Lamp_ow(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),Uu),Uua)
    <=> aa(B,$o,aa(A,fun(B,$o),Uu,aa(product_prod(A,B),A,product_fst(A,B),Uua)),aa(product_prod(A,B),B,product_snd(A,B),Uua)) ) ).

% ATP.lambda_81
tff(fact_8262_ATP_Olambda__82,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat] : ( aa(nat,list(A),aTP_Lamp_ux(list(list(A)),fun(nat,list(A)),Uu),Uua) = aa(list(nat),list(A),map(nat,A,aa(nat,fun(nat,A),aTP_Lamp_uw(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua)),upt(zero_zero(nat),aa(list(list(A)),nat,size_size(list(list(A))),Uu))) ) ).

% ATP.lambda_82
tff(fact_8263_ATP_Olambda__83,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_lp(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_lo(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_83
tff(fact_8264_ATP_Olambda__84,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_ia(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hz(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua)),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_84
tff(fact_8265_ATP_Olambda__85,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_bo(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Uu),one_one(real))),aa(nat,nat,suc,Uua))) ) ).

% ATP.lambda_85
tff(fact_8266_ATP_Olambda__86,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_dg(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))))),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat)))) ) ).

% ATP.lambda_86
tff(fact_8267_ATP_Olambda__87,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_dn(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))) ) ).

% ATP.lambda_87
tff(fact_8268_ATP_Olambda__88,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_gx(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),Uua))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_88
tff(fact_8269_ATP_Olambda__89,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_gy(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uua)),aa(nat,A,power_power(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_89
tff(fact_8270_ATP_Olambda__90,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_ds(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
        & ( sin(real,Uua) = Uu ) ) ) ).

% ATP.lambda_90
tff(fact_8271_ATP_Olambda__91,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_dr(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Uua),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
        & ( aa(real,real,tan(real),Uua) = Uu ) ) ) ).

% ATP.lambda_91
tff(fact_8272_ATP_Olambda__92,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,int,aa(code_integer,fun(code_integer,int),aTP_Lamp_mo(code_integer,fun(code_integer,int)),Uu),Uua)
      = $let(
          l2: int,
          l2 := aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),code_int_of_integer(Uu)),
          $ite(Uua = zero_zero(code_integer),l2,aa(int,int,aa(int,fun(int,int),plus_plus(int),l2),one_one(int))) ) ) ).

% ATP.lambda_92
tff(fact_8273_ATP_Olambda__93,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,a,aa(nat,fun(nat,a),aTP_Lamp_bm(nat,fun(nat,a)),Uu),Uua)
      = $let(
          m3: a,
          m3 := aa(a,a,aa(a,fun(a,a),times_times(a),aa(num,a,numeral_numeral(a),aa(num,num,bit0,one2))),aa(nat,a,semiring_1_of_nat(a),Uu)),
          $ite(Uua = zero_zero(nat),m3,aa(a,a,aa(a,fun(a,a),plus_plus(a),m3),one_one(a))) ) ) ).

% ATP.lambda_93
tff(fact_8274_ATP_Olambda__94,axiom,
    ! [Uu: complex,Uua: real] :
      ( aa(real,$o,aTP_Lamp_ec(complex,fun(real,$o),Uu),Uua)
    <=> ( ( aa(complex,complex,sgn_sgn(complex),Uu) = cis(Uua) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),pi) ) ) ).

% ATP.lambda_94
tff(fact_8275_ATP_Olambda__95,axiom,
    ! [Uu: real,Uua: int] :
      ( aa(int,$o,aTP_Lamp_ea(real,fun(int,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),ring_1_of_int(real,Uua)),Uu)
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Uu),ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int)))) ) ) ).

% ATP.lambda_95
tff(fact_8276_ATP_Olambda__96,axiom,
    ! [Uu: rat,Uua: int] :
      ( aa(int,$o,aTP_Lamp_eb(rat,fun(int,$o),Uu),Uua)
    <=> ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),ring_1_of_int(rat,Uua)),Uu)
        & aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),Uu),ring_1_of_int(rat,aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int)))) ) ) ).

% ATP.lambda_96
tff(fact_8277_ATP_Olambda__97,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_bp(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat))))),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat))))) ) ).

% ATP.lambda_97
tff(fact_8278_ATP_Olambda__98,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_abd(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% ATP.lambda_98
tff(fact_8279_ATP_Olambda__99,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_ail(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,power_power(real,aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_99
tff(fact_8280_ATP_Olambda__100,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_hb(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_100
tff(fact_8281_ATP_Olambda__101,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_fx(A,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))),Uua) ) ) ).

% ATP.lambda_101
tff(fact_8282_ATP_Olambda__102,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_he(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uu),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_102
tff(fact_8283_ATP_Olambda__103,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_gj(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),one_one(A))),Uua)) ) ) ).

% ATP.lambda_103
tff(fact_8284_ATP_Olambda__104,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_qs(nat,fun(nat,$o)),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uu),Uua)
        & ( Uu != Uua ) ) ) ).

% ATP.lambda_104
tff(fact_8285_ATP_Olambda__105,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(set(A))] :
      ( aa(set(set(A)),$o,aTP_Lamp_uv(set(set(A)),fun(set(set(A)),$o),Uu),Uua)
    <=> ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),Uua),Uu)
        & ( Uua != bot_bot(set(set(A))) ) ) ) ).

% ATP.lambda_105
tff(fact_8286_ATP_Olambda__106,axiom,
    ! [A: $tType,Uu: set(option(A)),Uua: option(A)] :
      ( aa(option(A),$o,aTP_Lamp_sp(set(option(A)),fun(option(A),$o),Uu),Uua)
    <=> ( aa(set(option(A)),$o,member(option(A),Uua),Uu)
        & ( Uua != none(A) ) ) ) ).

% ATP.lambda_106
tff(fact_8287_ATP_Olambda__107,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_go(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,power_power(nat,aa(nat,nat,binomial(Uu),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% ATP.lambda_107
tff(fact_8288_ATP_Olambda__108,axiom,
    ! [Uu: set(int),Uua: int] :
      ( aa(int,$o,aTP_Lamp_atj(set(int),fun(int,$o),Uu),Uua)
    <=> ( aa(set(int),$o,member(int,Uua),Uu)
        & ! [X3: int] :
            ( aa(set(int),$o,member(int,X3),Uu)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X3),Uua) ) ) ) ).

% ATP.lambda_108
tff(fact_8289_ATP_Olambda__109,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(A)] :
      ( aa(set(A),$o,aTP_Lamp_atk(set(set(A)),fun(set(A),$o),Uu),Uua)
    <=> ( aa(set(set(A)),$o,member(set(A),Uua),Uu)
        & ! [X3: set(A)] :
            ( aa(set(set(A)),$o,member(set(A),X3),Uu)
           => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),Uua),X3) ) ) ) ).

% ATP.lambda_109
tff(fact_8290_ATP_Olambda__110,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_jc(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,Uu),Uua)),semiring_char_0_fact(real,Uua)) ) ).

% ATP.lambda_110
tff(fact_8291_ATP_Olambda__111,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_ani(nat,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,Uua),Uu)),aa(real,real,exp(real),Uua)) ) ).

% ATP.lambda_111
tff(fact_8292_ATP_Olambda__112,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),aTP_Lamp_ats(set(A),fun(set(A),$o)),Uu),Uua)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),Uu),Uua)
        & finite_finite2(A,Uua) ) ) ).

% ATP.lambda_112
tff(fact_8293_ATP_Olambda__113,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ayc(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,power_power(nat,Uu),Uua)),Uua) ) ).

% ATP.lambda_113
tff(fact_8294_ATP_Olambda__114,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_fv(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uu) ) ).

% ATP.lambda_114
tff(fact_8295_ATP_Olambda__115,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_fu(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_115
tff(fact_8296_ATP_Olambda__116,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,set(product_prod(B,A)),aTP_Lamp_bbj(B,fun(A,set(product_prod(B,A))),Uu),Uua) = aa(set(product_prod(B,A)),set(product_prod(B,A)),insert(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uu),Uua)),bot_bot(set(product_prod(B,A)))) ) ).

% ATP.lambda_116
tff(fact_8297_ATP_Olambda__117,axiom,
    ! [Uu: nat,Uua: complex] :
      ( aa(complex,$o,aTP_Lamp_hx(nat,fun(complex,$o),Uu),Uua)
    <=> ( aa(nat,complex,power_power(complex,Uua),Uu) = one_one(complex) ) ) ).

% ATP.lambda_117
tff(fact_8298_ATP_Olambda__118,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: nat,Uua: A] :
          ( aa(A,$o,aTP_Lamp_of(nat,fun(A,$o),Uu),Uua)
        <=> ( aa(nat,A,power_power(A,Uua),Uu) = one_one(A) ) ) ) ).

% ATP.lambda_118
tff(fact_8299_ATP_Olambda__119,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_od(A,fun(A,$o),Uu),Uua)
        <=> ( aa(set(A),$o,member(A,Uua),ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),Uua)),Uu) ) ) ) ).

% ATP.lambda_119
tff(fact_8300_ATP_Olambda__120,axiom,
    ! [A: $tType,Uu: fun(set(A),$o),Uua: set(A)] :
      ( aa(set(A),$o,aa(fun(set(A),$o),fun(set(A),$o),aTP_Lamp_ayl(fun(set(A),$o),fun(set(A),$o)),Uu),Uua)
    <=> ( ( Uua = bot_bot(set(A)) )
        | ? [A10: set(A),A6: A] :
            ( ( Uua = aa(set(A),set(A),insert(A,A6),A10) )
            & aa(set(A),$o,Uu,A10) ) ) ) ).

% ATP.lambda_120
tff(fact_8301_ATP_Olambda__121,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_akh(real,fun(nat,real),Uu),Uua) = aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),Uu),aa(nat,real,semiring_1_of_nat(real),Uua)))),Uua) ) ).

% ATP.lambda_121
tff(fact_8302_ATP_Olambda__122,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_aln(real,fun(real,real),Uu),Uua) = powr(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),Uu),Uua)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),Uua)) ) ).

% ATP.lambda_122
tff(fact_8303_ATP_Olambda__123,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_anj(real,fun(real,real),Uu),Uua) = powr(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),Uu),Uua)),Uua) ) ).

% ATP.lambda_123
tff(fact_8304_ATP_Olambda__124,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_bn(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat))))),aa(nat,real,power_power(real,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat)))) ) ).

% ATP.lambda_124
tff(fact_8305_ATP_Olambda__125,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_dv(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),pi)
        & ( cos(real,Uua) = Uu ) ) ) ).

% ATP.lambda_125
tff(fact_8306_ATP_Olambda__126,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_axc(set(product_prod(A,A)),fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),finite_card(product_prod(A,A),Uu)) ) ) ).

% ATP.lambda_126
tff(fact_8307_ATP_Olambda__127,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_axh(nat,fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(nat,nat,suc,Uu)) ) ) ).

% ATP.lambda_127
tff(fact_8308_ATP_Olambda__128,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_lj(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_128
tff(fact_8309_ATP_Olambda__129,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_gf(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_129
tff(fact_8310_ATP_Olambda__130,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ajm(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_130
tff(fact_8311_ATP_Olambda__131,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_iq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_131
tff(fact_8312_ATP_Olambda__132,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_lw(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),Uu,Uua),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_132
tff(fact_8313_ATP_Olambda__133,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_lu(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_133
tff(fact_8314_ATP_Olambda__134,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ck(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,power_power(A,zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_134
tff(fact_8315_ATP_Olambda__135,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,power_power(A,zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_135
tff(fact_8316_ATP_Olambda__136,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ng(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,power_power(A,zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_136
tff(fact_8317_ATP_Olambda__137,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cj(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,power_power(A,zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_137
tff(fact_8318_ATP_Olambda__138,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_jt(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_138
tff(fact_8319_ATP_Olambda__139,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_js(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_139
tff(fact_8320_ATP_Olambda__140,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ajn(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_140
tff(fact_8321_ATP_Olambda__141,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_fr(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_141
tff(fact_8322_ATP_Olambda__142,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: fun(A,$o),Uua: A] :
          ( aa(A,$o,aTP_Lamp_art(fun(A,$o),fun(A,$o),Uu),Uua)
        <=> ( aa(A,$o,Uu,Uua)
            & ! [Y: A] :
                ( aa(A,$o,Uu,Y)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Uua) ) ) ) ) ).

% ATP.lambda_142
tff(fact_8323_ATP_Olambda__143,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_lc(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),Uu,Uua),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_143
tff(fact_8324_ATP_Olambda__144,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_jo(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_144
tff(fact_8325_ATP_Olambda__145,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_anp(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,Uu,Uua)),zero_zero(real)) ) ).

% ATP.lambda_145
tff(fact_8326_ATP_Olambda__146,axiom,
    ! [B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(B,real),Uua: B] : ( aa(B,real,aTP_Lamp_adi(fun(B,real),fun(B,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(B,real,Uu,Uua)),zero_zero(real)) ) ) ).

% ATP.lambda_146
tff(fact_8327_ATP_Olambda__147,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,complex,aTP_Lamp_hq(fun(A,real),fun(A,complex),Uu),Uua) = complex2(aa(A,real,Uu,Uua),zero_zero(real)) ) ).

% ATP.lambda_147
tff(fact_8328_ATP_Olambda__148,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,list(A),aTP_Lamp_xq(fun(B,A),fun(B,list(A)),Uu),Uua) = aa(list(A),list(A),cons(A,aa(B,A,Uu,Uua)),nil(A)) ) ).

% ATP.lambda_148
tff(fact_8329_ATP_Olambda__149,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,set(A),aTP_Lamp_us(fun(B,A),fun(B,set(A)),Uu),Uua) = aa(set(A),set(A),insert(A,aa(B,A,Uu,Uua)),bot_bot(set(A))) ) ).

% ATP.lambda_149
tff(fact_8330_ATP_Olambda__150,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: A] :
          ( aa(A,$o,aTP_Lamp_oa(fun(A,B),fun(A,$o),Uu),Uua)
        <=> ( aa(A,B,Uu,Uua) = zero_zero(B) ) ) ) ).

% ATP.lambda_150
tff(fact_8331_ATP_Olambda__151,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: A] :
          ( aa(A,$o,aTP_Lamp_ob(fun(A,B),fun(A,$o),Uu),Uua)
        <=> ( aa(A,B,Uu,Uua) = one_one(B) ) ) ) ).

% ATP.lambda_151
tff(fact_8332_ATP_Olambda__152,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_akr(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),Uu)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat)))) ) ).

% ATP.lambda_152
tff(fact_8333_ATP_Olambda__153,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_akq(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ail(fun(nat,real),fun(nat,real),Uu)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))) ) ).

% ATP.lambda_153
tff(fact_8334_ATP_Olambda__154,axiom,
    ! [Uu: code_integer,Uua: $o] : ( aa($o,char,aa(code_integer,fun($o,char),aTP_Lamp_xp(code_integer,fun($o,char)),Uu),Uua) = aa(product_prod(code_integer,$o),char,aa(fun(code_integer,fun($o,char)),fun(product_prod(code_integer,$o),char),product_case_prod(code_integer,$o,char),aTP_Lamp_xo($o,fun(code_integer,fun($o,char)),Uua)),code_bit_cut_integer(Uu)) ) ).

% ATP.lambda_154
tff(fact_8335_ATP_Olambda__155,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] : ( aa(list(A),list(list(A)),aTP_Lamp_xv(list(A),fun(list(A),list(list(A))),Uu),Uua) = aa(list(A),list(list(A)),map(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_xu(list(A),fun(A,list(A))),Uua)),Uu) ) ).

% ATP.lambda_155
tff(fact_8336_ATP_Olambda__156,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_ald(fun(A,B),fun(A,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua))),real_V7770717601297561774m_norm(A,Uua)) ) ) ).

% ATP.lambda_156
tff(fact_8337_ATP_Olambda__157,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ei(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% ATP.lambda_157
tff(fact_8338_ATP_Olambda__158,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ey(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,suc,Uua)))),aa(nat,A,power_power(A,Uu),aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_158
tff(fact_8339_ATP_Olambda__159,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_en(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_159
tff(fact_8340_ATP_Olambda__160,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_eh(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),semiring_char_0_fact(A,Uua))),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_160
tff(fact_8341_ATP_Olambda__161,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cs(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uua))),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_161
tff(fact_8342_ATP_Olambda__162,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aTP_Lamp_yu(num,fun(num,int),Uu),Uua) = aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),Uu)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,power_power(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),Uu))),aa(num,int,numeral_numeral(int),Uua))) ) ).

% ATP.lambda_162
tff(fact_8343_ATP_Olambda__163,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ex(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),Uu)),Uua)) ) ) ).

% ATP.lambda_163
tff(fact_8344_ATP_Olambda__164,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_xg(nat,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Uua)),aa(nat,real,power_power(real,aa(real,real,abs_abs(real),Uua)),Uu)) ) ).

% ATP.lambda_164
tff(fact_8345_ATP_Olambda__165,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_eo(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_165
tff(fact_8346_ATP_Olambda__166,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ep(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_166
tff(fact_8347_ATP_Olambda__167,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_akm(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_167
tff(fact_8348_ATP_Olambda__168,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_akl(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(nat,A,power_power(A,Uu),Uua)) ) ) ).

% ATP.lambda_168
tff(fact_8349_ATP_Olambda__169,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ik(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),sin_coeff(Uua)),aa(nat,real,power_power(real,Uu),Uua)) ) ).

% ATP.lambda_169
tff(fact_8350_ATP_Olambda__170,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ij(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),cos_coeff(Uua)),aa(nat,real,power_power(real,Uu),Uua)) ) ).

% ATP.lambda_170
tff(fact_8351_ATP_Olambda__171,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: A,Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_amd(A,fun(set(A),$o),Uu),Uua)
        <=> ( aa(set(A),$o,topolo1002775350975398744n_open(A),Uua)
            & aa(set(A),$o,member(A,Uu),Uua) ) ) ) ).

% ATP.lambda_171
tff(fact_8352_ATP_Olambda__172,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_qw(nat,fun(nat,A)),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_172
tff(fact_8353_ATP_Olambda__173,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: A] : ( aa(A,list(list(A)),aTP_Lamp_xs(list(list(A)),fun(A,list(list(A))),Uu),Uua) = aa(list(list(A)),list(list(A)),map(list(A),list(A),cons(A,Uua)),product_lists(A,Uu)) ) ).

% ATP.lambda_173
tff(fact_8354_ATP_Olambda__174,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,num,aa(code_integer,fun(code_integer,num),aTP_Lamp_mp(code_integer,fun(code_integer,num)),Uu),Uua)
      = $let(
          l2: num,
          l2 := code_num_of_integer(Uu),
          $let(
            l3: num,
            l3 := aa(num,num,aa(num,fun(num,num),plus_plus(num),l2),l2),
            $ite(Uua = zero_zero(code_integer),l3,aa(num,num,aa(num,fun(num,num),plus_plus(num),l3),one2)) ) ) ) ).

% ATP.lambda_174
tff(fact_8355_ATP_Olambda__175,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,nat,aa(code_integer,fun(code_integer,nat),aTP_Lamp_mr(code_integer,fun(code_integer,nat)),Uu),Uua)
      = $let(
          l2: nat,
          l2 := code_nat_of_integer(Uu),
          $let(
            l3: nat,
            l3 := aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),l2),l2),
            $ite(Uua = zero_zero(code_integer),l3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),l3),one_one(nat))) ) ) ) ).

% ATP.lambda_175
tff(fact_8356_ATP_Olambda__176,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_ju(nat,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Uua)),Uu) ) ) ).

% ATP.lambda_176
tff(fact_8357_ATP_Olambda__177,axiom,
    ! [A: $tType,B: $tType,Uu: list(B),Uua: A] : ( aa(A,list(product_prod(A,B)),aTP_Lamp_ar(list(B),fun(A,list(product_prod(A,B))),Uu),Uua) = aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua)),Uu) ) ).

% ATP.lambda_177
tff(fact_8358_ATP_Olambda__178,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_dt(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,real,exp(real),Uua) = Uu ) ) ).

% ATP.lambda_178
tff(fact_8359_ATP_Olambda__179,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_ax(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),one_one(A))) ) ) ).

% ATP.lambda_179
tff(fact_8360_ATP_Olambda__180,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_az(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_180
tff(fact_8361_ATP_Olambda__181,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_kh(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_181
tff(fact_8362_ATP_Olambda__182,axiom,
    ! [A: $tType,Uu: A,Uua: set(set(A))] : ( aa(set(set(A)),set(set(A)),aa(A,fun(set(set(A)),set(set(A))),aTP_Lamp_bax(A,fun(set(set(A)),set(set(A)))),Uu),Uua) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),Uua),aa(set(set(A)),set(set(A)),image(set(A),set(A),insert(A,Uu)),Uua)) ) ).

% ATP.lambda_182
tff(fact_8363_ATP_Olambda__183,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ha(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(nat,nat,binomial(Uu),Uua)) ) ).

% ATP.lambda_183
tff(fact_8364_ATP_Olambda__184,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_qe(set(A),fun(A,$o),Uu),Uua)
    <=> ( Uu = aa(set(A),set(A),insert(A,Uua),bot_bot(set(A))) ) ) ).

% ATP.lambda_184
tff(fact_8365_ATP_Olambda__185,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_akj(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),Uu),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua)))))) ) ).

% ATP.lambda_185
tff(fact_8366_ATP_Olambda__186,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_akc(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or1337092689740270186AtMost(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_186
tff(fact_8367_ATP_Olambda__187,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_ox(fun(nat,A),fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Uua),aa(nat,A,Uu,Uua)) ) ).

% ATP.lambda_187
tff(fact_8368_ATP_Olambda__188,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,product_prod(A,B),aTP_Lamp_sk(fun(A,B),fun(A,product_prod(A,B)),Uu),Uua) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_188
tff(fact_8369_ATP_Olambda__189,axiom,
    ! [Uu: nat,Uua: vEBT_VEBT] : ( aa(vEBT_VEBT,vEBT_VEBT,aTP_Lamp_ad(nat,fun(vEBT_VEBT,vEBT_VEBT),Uu),Uua) = vEBT_VEBT_elim_dead(Uua,extended_enat2(aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% ATP.lambda_189
tff(fact_8370_ATP_Olambda__190,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ma(A,fun(nat,A),Uu),Uua) = bit_se4730199178511100633sh_bit(A,Uua,aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Uu),Uua))) ) ) ).

% ATP.lambda_190
tff(fact_8371_ATP_Olambda__191,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_akd(fun(nat,A),fun(nat,real),Uu),Uua) = aa(real,real,root(Uua),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua))) ) ) ).

% ATP.lambda_191
tff(fact_8372_ATP_Olambda__192,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aa(int,fun(int,int),aTP_Lamp_bf(int,fun(int,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),aa($o,int,zero_neq_one_of_bool(int),( Uua != zero_zero(int) ))) ) ).

% ATP.lambda_192
tff(fact_8373_ATP_Olambda__193,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ake(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Uu),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua))))) ) ).

% ATP.lambda_193
tff(fact_8374_ATP_Olambda__194,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ajt(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Uu),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua)))) ) ).

% ATP.lambda_194
tff(fact_8375_ATP_Olambda__195,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_wm(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),Uu),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ).

% ATP.lambda_195
tff(fact_8376_ATP_Olambda__196,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_wq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_196
tff(fact_8377_ATP_Olambda__197,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_aju(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_197
tff(fact_8378_ATP_Olambda__198,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_akf(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_198
tff(fact_8379_ATP_Olambda__199,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ajv(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_199
tff(fact_8380_ATP_Olambda__200,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_akg(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_200
tff(fact_8381_ATP_Olambda__201,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: A] :
          ( aa(A,$o,aTP_Lamp_ank(real,fun(A,$o),Uu),Uua)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uu),real_V7770717601297561774m_norm(A,Uua)) ) ) ).

% ATP.lambda_201
tff(fact_8382_ATP_Olambda__202,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_axg(set(product_prod(A,A)),fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),finite_card(product_prod(A,A),Uu)) ) ).

% ATP.lambda_202
tff(fact_8383_ATP_Olambda__203,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ajh(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_203
tff(fact_8384_ATP_Olambda__204,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( aa(list(A),$o,aTP_Lamp_vv(nat,fun(list(A),$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uu),aa(list(A),nat,size_size(list(A)),Uua)) ) ).

% ATP.lambda_204
tff(fact_8385_ATP_Olambda__205,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_lm(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_205
tff(fact_8386_ATP_Olambda__206,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_md(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_206
tff(fact_8387_ATP_Olambda__207,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_lh(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_207
tff(fact_8388_ATP_Olambda__208,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,$o),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aon(fun(A,$o),fun(A,$o),Uu),Uua)
        <=> eventually(A,Uu,topolo7230453075368039082e_nhds(A,Uua)) ) ) ).

% ATP.lambda_208
tff(fact_8389_ATP_Olambda__209,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_wf(list(A),fun(A,$o),Uu),Uua)
    <=> aa(set(A),$o,member(A,Uua),aa(list(A),set(A),set2(A),Uu)) ) ).

% ATP.lambda_209
tff(fact_8390_ATP_Olambda__210,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_ayn(list(A),fun(A,$o),Uu),Uua)
    <=> ( Uua = aa(list(A),A,hd(A),Uu) ) ) ).

% ATP.lambda_210
tff(fact_8391_ATP_Olambda__211,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat,Uua: A] : ( aa(A,A,aTP_Lamp_ahz(nat,fun(A,A),Uu),Uua) = comm_s3205402744901411588hammer(A,Uua,Uu) ) ) ).

% ATP.lambda_211
tff(fact_8392_ATP_Olambda__212,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: real] : ( aa(real,A,aTP_Lamp_akz(A,fun(real,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,Uua),Uu) ) ) ).

% ATP.lambda_212
tff(fact_8393_ATP_Olambda__213,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( aa(set(A),$o,aTP_Lamp_ok(set(A),fun(set(A),$o),Uu),Uua)
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uua),Uu) ) ).

% ATP.lambda_213
tff(fact_8394_ATP_Olambda__214,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_am(nat,fun(nat,$o)),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),Uu) ) ).

% ATP.lambda_214
tff(fact_8395_ATP_Olambda__215,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ban(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_215
tff(fact_8396_ATP_Olambda__216,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ans(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_216
tff(fact_8397_ATP_Olambda__217,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_ft(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_217
tff(fact_8398_ATP_Olambda__218,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_xc(nat,fun(nat,nat),Uu),Uua) = modulo_modulo(nat,Uua,Uu) ) ).

% ATP.lambda_218
tff(fact_8399_ATP_Olambda__219,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_akw(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_219
tff(fact_8400_ATP_Olambda__220,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_rj(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_220
tff(fact_8401_ATP_Olambda__221,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_azb(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_221
tff(fact_8402_ATP_Olambda__222,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_hl(nat,fun(nat,$o)),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),Uu) ) ).

% ATP.lambda_222
tff(fact_8403_ATP_Olambda__223,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_bao(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_223
tff(fact_8404_ATP_Olambda__224,axiom,
    ! [A: $tType] :
      ( unboun7993243217541854897norder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_anq(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_224
tff(fact_8405_ATP_Olambda__225,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_im(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_225
tff(fact_8406_ATP_Olambda__226,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ajd(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uu) ) ).

% ATP.lambda_226
tff(fact_8407_ATP_Olambda__227,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_akx(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_227
tff(fact_8408_ATP_Olambda__228,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_aw(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_228
tff(fact_8409_ATP_Olambda__229,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_rw(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_229
tff(fact_8410_ATP_Olambda__230,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_sd(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uu) ) ).

% ATP.lambda_230
tff(fact_8411_ATP_Olambda__231,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_rh(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_231
tff(fact_8412_ATP_Olambda__232,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_rr(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_232
tff(fact_8413_ATP_Olambda__233,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_aai(nat,fun(real,real),Uu),Uua) = aa(nat,real,power_power(real,Uua),Uu) ) ).

% ATP.lambda_233
tff(fact_8414_ATP_Olambda__234,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_baa(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uua),Uu) ) ) ).

% ATP.lambda_234
tff(fact_8415_ATP_Olambda__235,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] : ( aa(set(A),set(A),aTP_Lamp_uc(set(A),fun(set(A),set(A)),Uu),Uua) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uua),Uu) ) ).

% ATP.lambda_235
tff(fact_8416_ATP_Olambda__236,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_tc(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uua),Uu) ) ) ).

% ATP.lambda_236
tff(fact_8417_ATP_Olambda__237,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_lq(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uu) ) ).

% ATP.lambda_237
tff(fact_8418_ATP_Olambda__238,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aTP_Lamp_sh(int,fun(int,int),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),Uu) ) ).

% ATP.lambda_238
tff(fact_8419_ATP_Olambda__239,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_azi(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_239
tff(fact_8420_ATP_Olambda__240,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_rg(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_240
tff(fact_8421_ATP_Olambda__241,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_aal(real,fun(real,real),Uu),Uua) = powr(real,Uua,Uu) ) ).

% ATP.lambda_241
tff(fact_8422_ATP_Olambda__242,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_oc(nat,fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uua),Uu) ) ).

% ATP.lambda_242
tff(fact_8423_ATP_Olambda__243,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,$o,aTP_Lamp_os(int,fun(int,$o),Uu),Uua)
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uua),Uu) ) ).

% ATP.lambda_243
tff(fact_8424_ATP_Olambda__244,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_ap(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Uua),Uu) ) ) ).

% ATP.lambda_244
tff(fact_8425_ATP_Olambda__245,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_qv(nat,fun(nat,product_prod(nat,nat))),Uu),Uua) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uua),Uu) ) ).

% ATP.lambda_245
tff(fact_8426_ATP_Olambda__246,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_qp(B,fun(A,product_prod(A,B))),Uu),Uua) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uu) ) ).

% ATP.lambda_246
tff(fact_8427_ATP_Olambda__247,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_oy(A,fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Uua),Uu) ) ).

% ATP.lambda_247
tff(fact_8428_ATP_Olambda__248,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,product_prod(B,A),aa(A,fun(B,product_prod(B,A)),aTP_Lamp_qo(A,fun(B,product_prod(B,A))),Uu),Uua) = aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uua),Uu) ) ).

% ATP.lambda_248
tff(fact_8429_ATP_Olambda__249,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_fk(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(Uua),Uu) ) ).

% ATP.lambda_249
tff(fact_8430_ATP_Olambda__250,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] : ( aa(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_xu(list(A),fun(A,list(A))),Uu),Uua) = aa(list(A),list(A),cons(A,Uua),Uu) ) ).

% ATP.lambda_250
tff(fact_8431_ATP_Olambda__251,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ajr(real,fun(nat,real),Uu),Uua) = aa(real,real,root(Uua),Uu) ) ).

% ATP.lambda_251
tff(fact_8432_ATP_Olambda__252,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_atq(set(B),fun(B,$o),Uu),Uua)
    <=> aa(set(B),$o,member(B,Uua),Uu) ) ).

% ATP.lambda_252
tff(fact_8433_ATP_Olambda__253,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aoj(set(A),fun(A,$o),Uu),Uua)
        <=> aa(set(A),$o,member(A,Uua),Uu) ) ) ).

% ATP.lambda_253
tff(fact_8434_ATP_Olambda__254,axiom,
    ! [A: $tType] :
      ( topological_t3_space(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_ayz(set(A),fun(A,$o),Uu),Uua)
        <=> aa(set(A),$o,member(A,Uua),Uu) ) ) ).

% ATP.lambda_254
tff(fact_8435_ATP_Olambda__255,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_af(set(A),fun(A,$o)),Uu),Uua)
    <=> aa(set(A),$o,member(A,Uua),Uu) ) ).

% ATP.lambda_255
tff(fact_8436_ATP_Olambda__256,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] : ( aa(nat,set(product_prod(A,A)),aTP_Lamp_axb(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),Uu),Uua) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Uua),Uu) ) ).

% ATP.lambda_256
tff(fact_8437_ATP_Olambda__257,axiom,
    ! [A: $tType,Uu: list(A),Uua: nat] : ( aa(nat,list(A),aTP_Lamp_xy(list(A),fun(nat,list(A)),Uu),Uua) = drop(A,Uua,Uu) ) ).

% ATP.lambda_257
tff(fact_8438_ATP_Olambda__258,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] : ( aa(list(A),A,aTP_Lamp_vw(nat,fun(list(A),A),Uu),Uua) = aa(nat,A,nth(A,Uua),Uu) ) ).

% ATP.lambda_258
tff(fact_8439_ATP_Olambda__259,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( aa(A,$o,aTP_Lamp_dx(A,fun(A,$o),Uu),Uua)
    <=> ( Uua = Uu ) ) ).

% ATP.lambda_259
tff(fact_8440_ATP_Olambda__260,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_yd(A,fun(list(A),list(A))),Uu),Uua) = aa(list(A),list(A),cons(A,Uu),nil(A)) ) ).

% ATP.lambda_260
tff(fact_8441_ATP_Olambda__261,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(list(A)),aa(A,fun(list(A),list(list(A))),aTP_Lamp_ye(A,fun(list(A),list(list(A)))),Uu),Uua) = aa(list(list(A)),list(list(A)),cons(list(A),Uua),nil(list(A))) ) ).

% ATP.lambda_261
tff(fact_8442_ATP_Olambda__262,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_aqq(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_262
tff(fact_8443_ATP_Olambda__263,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aqe(fun(A,real),fun(A,$o),Uu),Uua)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_263
tff(fact_8444_ATP_Olambda__264,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_aqk(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_264
tff(fact_8445_ATP_Olambda__265,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_anv(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_265
tff(fact_8446_ATP_Olambda__266,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_jb(fun(nat,real),fun(nat,real),Uu),Uua) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))) ) ).

% ATP.lambda_266
tff(fact_8447_ATP_Olambda__267,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_ja(fun(nat,real),fun(nat,real),Uu),Uua) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)) ) ).

% ATP.lambda_267
tff(fact_8448_ATP_Olambda__268,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_aqv(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),Uua)) ) ) ).

% ATP.lambda_268
tff(fact_8449_ATP_Olambda__269,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(set(nat),A),Uua: nat] : ( aa(nat,A,aTP_Lamp_aje(fun(set(nat),A),fun(nat,A),Uu),Uua) = aa(set(nat),A,Uu,aa(nat,set(nat),set_ord_lessThan(nat),Uua)) ) ) ).

% ATP.lambda_269
tff(fact_8450_ATP_Olambda__270,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(set(nat),A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ajf(fun(set(nat),A),fun(nat,A),Uu),Uua) = aa(set(nat),A,Uu,aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_270
tff(fact_8451_ATP_Olambda__271,axiom,
    ! [Uu: fun(real,$o),Uua: real] :
      ( aa(real,$o,aTP_Lamp_aqj(fun(real,$o),fun(real,$o),Uu),Uua)
    <=> aa(real,$o,Uu,aa(real,real,inverse_inverse(real),Uua)) ) ).

% ATP.lambda_271
tff(fact_8452_ATP_Olambda__272,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real] : ( aa(real,A,aTP_Lamp_anh(fun(real,A),fun(real,A),Uu),Uua) = aa(real,A,Uu,aa(real,real,inverse_inverse(real),Uua)) ) ).

% ATP.lambda_272
tff(fact_8453_ATP_Olambda__273,axiom,
    ! [Uu: fun(real,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_ayo(fun(real,real),fun(nat,real),Uu),Uua) = aa(real,real,Uu,aa(nat,real,semiring_1_of_nat(real),Uua)) ) ).

% ATP.lambda_273
tff(fact_8454_ATP_Olambda__274,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(real,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_aqu(fun(real,A),fun(nat,A),Uu),Uua) = aa(real,A,Uu,aa(nat,real,semiring_1_of_nat(real),Uua)) ) ) ).

% ATP.lambda_274
tff(fact_8455_ATP_Olambda__275,axiom,
    ! [A: $tType,Uu: fun(int,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ari(fun(int,A),fun(nat,A),Uu),Uua) = aa(int,A,Uu,aa(nat,int,semiring_1_of_nat(int),Uua)) ) ).

% ATP.lambda_275
tff(fact_8456_ATP_Olambda__276,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_zi(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,Uu,aa(real,real,uminus_uminus(real),Uua)) ) ).

% ATP.lambda_276
tff(fact_8457_ATP_Olambda__277,axiom,
    ! [Uu: fun(real,$o),Uua: real] :
      ( aa(real,$o,aTP_Lamp_aqd(fun(real,$o),fun(real,$o),Uu),Uua)
    <=> aa(real,$o,Uu,aa(real,real,uminus_uminus(real),Uua)) ) ).

% ATP.lambda_277
tff(fact_8458_ATP_Olambda__278,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real] : ( aa(real,A,aTP_Lamp_alq(fun(real,A),fun(real,A),Uu),Uua) = aa(real,A,Uu,aa(real,real,uminus_uminus(real),Uua)) ) ).

% ATP.lambda_278
tff(fact_8459_ATP_Olambda__279,axiom,
    ! [Uu: fun(nat,$o),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aqy(fun(nat,$o),fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_279
tff(fact_8460_ATP_Olambda__280,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cc(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_280
tff(fact_8461_ATP_Olambda__281,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_aiv(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_281
tff(fact_8462_ATP_Olambda__282,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cy(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_282
tff(fact_8463_ATP_Olambda__283,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_kx(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_283
tff(fact_8464_ATP_Olambda__284,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_fq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_284
tff(fact_8465_ATP_Olambda__285,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_xw(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_285
tff(fact_8466_ATP_Olambda__286,axiom,
    ! [A: $tType,B: $tType] :
      ( complete_Sup(A)
     => ! [Uu: B,Uua: fun(B,A)] : ( aa(fun(B,A),A,aTP_Lamp_tn(B,fun(fun(B,A),A),Uu),Uua) = aa(B,A,Uua,Uu) ) ) ).

% ATP.lambda_286
tff(fact_8467_ATP_Olambda__287,axiom,
    ! [A: $tType,B: $tType] :
      ( complete_Inf(A)
     => ! [Uu: B,Uua: fun(B,A)] : ( aa(fun(B,A),A,aTP_Lamp_uz(B,fun(fun(B,A),A),Uu),Uua) = aa(B,A,Uua,Uu) ) ) ).

% ATP.lambda_287
tff(fact_8468_ATP_Olambda__288,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Sup(B)
     => ! [Uu: A,Uua: fun(A,B)] : ( aa(fun(A,B),B,aTP_Lamp_ty(A,fun(fun(A,B),B),Uu),Uua) = aa(A,B,Uua,Uu) ) ) ).

% ATP.lambda_288
tff(fact_8469_ATP_Olambda__289,axiom,
    ! [B: $tType,A: $tType] :
      ( complete_Inf(B)
     => ! [Uu: A,Uua: fun(A,B)] : ( aa(fun(A,B),B,aTP_Lamp_ve(A,fun(fun(A,B),B),Uu),Uua) = aa(A,B,Uua,Uu) ) ) ).

% ATP.lambda_289
tff(fact_8470_ATP_Olambda__290,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_bbi(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),ord_max(A),Uu),Uua)) ) ) ).

% ATP.lambda_290
tff(fact_8471_ATP_Olambda__291,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_bbr(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),sup_sup(A),Uu),Uua)) ) ) ).

% ATP.lambda_291
tff(fact_8472_ATP_Olambda__292,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_bbs(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),inf_inf(A),Uu),Uua)) ) ) ).

% ATP.lambda_292
tff(fact_8473_ATP_Olambda__293,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_zc(nat,fun(num,option(num)),Uu),Uua) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(Uu,Uua))) ) ).

% ATP.lambda_293
tff(fact_8474_ATP_Olambda__294,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_yz(num,fun(nat,option(num)),Uu),Uua) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(Uua,Uu))) ) ).

% ATP.lambda_294
tff(fact_8475_ATP_Olambda__295,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),aTP_Lamp_yp(A,fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),Uu),Uua) = aa(fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),product_case_prod(A,list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_yo(A,fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua)) ) ).

% ATP.lambda_295
tff(fact_8476_ATP_Olambda__296,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_re(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_rd(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_296
tff(fact_8477_ATP_Olambda__297,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_rc(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_rb(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_297
tff(fact_8478_ATP_Olambda__298,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_ra(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_qz(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_298
tff(fact_8479_ATP_Olambda__299,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_qy(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_qx(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_299
tff(fact_8480_ATP_Olambda__300,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_qu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_qt(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_300
tff(fact_8481_ATP_Olambda__301,axiom,
    ! [Uu: fun(nat,real),Uua: real] : ( aa(real,real,aTP_Lamp_aau(fun(nat,real),fun(real,real),Uu),Uua) = suminf(real,aa(real,fun(nat,real),aTP_Lamp_aat(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua)) ) ).

% ATP.lambda_301
tff(fact_8482_ATP_Olambda__302,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A] : ( aa(A,A,aTP_Lamp_aaj(fun(nat,A),fun(A,A),Uu),Uua) = suminf(A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua)) ) ) ).

% ATP.lambda_302
tff(fact_8483_ATP_Olambda__303,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,$o)),Uua: B] : ( aa(B,set(A),aTP_Lamp_arr(fun(A,fun(B,$o)),fun(B,set(A)),Uu),Uua) = aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aTP_Lamp_arq(fun(A,fun(B,$o)),fun(B,fun(A,$o)),Uu),Uua)) ) ).

% ATP.lambda_303
tff(fact_8484_ATP_Olambda__304,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: real,Uua: A] : ( aa(A,set(A),aTP_Lamp_aly(real,fun(A,set(A)),Uu),Uua) = aa(fun(A,$o),set(A),collect(A),aa(A,fun(A,$o),aTP_Lamp_alx(real,fun(A,fun(A,$o)),Uu),Uua)) ) ) ).

% ATP.lambda_304
tff(fact_8485_ATP_Olambda__305,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C)] : ( aa(fun(B,C),A,aTP_Lamp_ww(fun(C,fun(B,A)),fun(fun(B,C),A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_wv(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua)),top_top(set(B)))) ) ) ).

% ATP.lambda_305
tff(fact_8486_ATP_Olambda__306,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B] : ( aa(B,A,aTP_Lamp_wx(fun(C,fun(B,A)),fun(B,A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aTP_Lamp_wt(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua)),top_top(set(C)))) ) ) ).

% ATP.lambda_306
tff(fact_8487_ATP_Olambda__307,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C)] : ( aa(fun(B,C),A,aTP_Lamp_wy(fun(C,fun(B,A)),fun(fun(B,C),A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_wv(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua)),top_top(set(B)))) ) ) ).

% ATP.lambda_307
tff(fact_8488_ATP_Olambda__308,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B] : ( aa(B,A,aTP_Lamp_wu(fun(C,fun(B,A)),fun(B,A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aTP_Lamp_wt(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua)),top_top(set(C)))) ) ) ).

% ATP.lambda_308
tff(fact_8489_ATP_Olambda__309,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,complex,aTP_Lamp_ji(nat,fun(nat,complex),Uu),Uua) = cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),aa(nat,real,semiring_1_of_nat(real),Uua))),aa(nat,real,semiring_1_of_nat(real),Uu))) ) ).

% ATP.lambda_309
tff(fact_8490_ATP_Olambda__310,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ack(A,fun(A,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Uu)),Uua)),aa(A,A,inverse_inverse(A),Uu))) ) ) ).

% ATP.lambda_310
tff(fact_8491_ATP_Olambda__311,axiom,
    ! [Uu: fun(real,real),Uua: real] :
      ( aa(real,$o,aTP_Lamp_anm(fun(real,real),fun(real,$o),Uu),Uua)
    <=> ( aa(real,real,Uu,Uua) != zero_zero(real) ) ) ).

% ATP.lambda_311
tff(fact_8492_ATP_Olambda__312,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,option(A)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_ayq(fun(B,option(A)),fun(B,$o),Uu),Uua)
    <=> ( aa(B,option(A),Uu,Uua) != none(A) ) ) ).

% ATP.lambda_312
tff(fact_8493_ATP_Olambda__313,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: list(product_prod(C,B)),Uua: product_prod(A,C)] : ( aa(product_prod(A,C),list(product_prod(A,B)),aTP_Lamp_yl(list(product_prod(C,B)),fun(product_prod(A,C),list(product_prod(A,B))),Uu),Uua) = concat(product_prod(A,B),aa(list(product_prod(C,B)),list(list(product_prod(A,B))),map(product_prod(C,B),list(product_prod(A,B)),aTP_Lamp_yk(product_prod(A,C),fun(product_prod(C,B),list(product_prod(A,B))),Uua)),Uu)) ) ).

% ATP.lambda_313
tff(fact_8494_ATP_Olambda__314,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_ev(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,power_power(A,Uu),Uua))) ) ) ).

% ATP.lambda_314
tff(fact_8495_ATP_Olambda__315,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_ay(nat,fun(nat,$o),Uu),Uua)
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))) ) ).

% ATP.lambda_315
tff(fact_8496_ATP_Olambda__316,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ew(A,fun(nat,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),Uu)),Uua))) ) ) ).

% ATP.lambda_316
tff(fact_8497_ATP_Olambda__317,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_eq(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,power_power(A,Uu),Uua))) ) ) ).

% ATP.lambda_317
tff(fact_8498_ATP_Olambda__318,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_er(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,power_power(A,Uu),Uua))) ) ) ).

% ATP.lambda_318
tff(fact_8499_ATP_Olambda__319,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: A] :
      ( aa(A,$o,aTP_Lamp_tv(set(set(A)),fun(A,$o),Uu),Uua)
    <=> aa(set($o),$o,complete_Sup_Sup($o),aa(set(set(A)),set($o),image(set(A),$o,member(A,Uua)),Uu)) ) ).

% ATP.lambda_319
tff(fact_8500_ATP_Olambda__320,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: A] :
      ( aa(A,$o,aTP_Lamp_vu(set(set(A)),fun(A,$o),Uu),Uua)
    <=> aa(set($o),$o,complete_Inf_Inf($o),aa(set(set(A)),set($o),image(set(A),$o,member(A,Uua)),Uu)) ) ).

% ATP.lambda_320
tff(fact_8501_ATP_Olambda__321,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat] : ( aa(nat,set(A),aTP_Lamp_xb(fun(nat,set(A)),fun(nat,set(A)),Uu),Uua) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),Uu),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua))) ) ).

% ATP.lambda_321
tff(fact_8502_ATP_Olambda__322,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_dq(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_322
tff(fact_8503_ATP_Olambda__323,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_do(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_323
tff(fact_8504_ATP_Olambda__324,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_we(list(A),fun(A,$o),Uu),Uua)
    <=> ~ aa(set(A),$o,member(A,Uua),aa(list(A),set(A),set2(A),Uu)) ) ).

% ATP.lambda_324
tff(fact_8505_ATP_Olambda__325,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: set(B)] : ( aa(set(B),set(A),aTP_Lamp_ue(fun(B,set(A)),fun(set(B),set(A)),Uu),Uua) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),Uu),Uua)) ) ).

% ATP.lambda_325
tff(fact_8506_ATP_Olambda__326,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: set(B)] : ( aa(set(B),A,aTP_Lamp_ate(fun(B,A),fun(set(B),A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,Uu),Uua)) ) ) ).

% ATP.lambda_326
tff(fact_8507_ATP_Olambda__327,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: set(B)] : ( aa(set(B),set(A),aTP_Lamp_vm(fun(B,set(A)),fun(set(B),set(A)),Uu),Uua) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),Uu),Uua)) ) ).

% ATP.lambda_327
tff(fact_8508_ATP_Olambda__328,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: set(B)] : ( aa(set(B),A,aTP_Lamp_atd(fun(B,A),fun(set(B),A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,Uu),Uua)) ) ) ).

% ATP.lambda_328
tff(fact_8509_ATP_Olambda__329,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,$o)] :
      ( aa(fun(A,$o),$o,aa(set(A),fun(fun(A,$o),$o),aTP_Lamp_asb(set(A),fun(fun(A,$o),$o)),Uu),Uua)
    <=> aa(set($o),$o,complete_Inf_Inf($o),aa(set(A),set($o),image(A,$o,Uua),Uu)) ) ).

% ATP.lambda_329
tff(fact_8510_ATP_Olambda__330,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_akb(real,fun(nat,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(nat,real,power_power(real,Uu),Uua)) ) ).

% ATP.lambda_330
tff(fact_8511_ATP_Olambda__331,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_aac(A,fun(A,A),Uu),Uua) = cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu)) ) ) ).

% ATP.lambda_331
tff(fact_8512_ATP_Olambda__332,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_aj(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uua)) ) ).

% ATP.lambda_332
tff(fact_8513_ATP_Olambda__333,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_at(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uua)) ) ).

% ATP.lambda_333
tff(fact_8514_ATP_Olambda__334,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_ag(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)) ) ).

% ATP.lambda_334
tff(fact_8515_ATP_Olambda__335,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: A] : ( aa(A,filter(A),aTP_Lamp_aml(A,fun(A,filter(A)),Uu),Uua) = aa(set(A),filter(A),principal(A),set_or5935395276787703475ssThan(A,Uu,Uua)) ) ) ).

% ATP.lambda_335
tff(fact_8516_ATP_Olambda__336,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: A] : ( aa(A,filter(A),aTP_Lamp_amk(A,fun(A,filter(A)),Uu),Uua) = aa(set(A),filter(A),principal(A),set_or5935395276787703475ssThan(A,Uua,Uu)) ) ) ).

% ATP.lambda_336
tff(fact_8517_ATP_Olambda__337,axiom,
    ! [B: $tType,A: $tType,Uu: B,Uua: A] : ( aa(A,fun(set(product_prod(B,A)),set(product_prod(B,A))),aTP_Lamp_bbk(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uu),Uua) = insert(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uu),Uua)) ) ).

% ATP.lambda_337
tff(fact_8518_ATP_Olambda__338,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_bat(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uu),Uua)) ) ).

% ATP.lambda_338
tff(fact_8519_ATP_Olambda__339,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_bau(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uua),Uu)) ) ).

% ATP.lambda_339
tff(fact_8520_ATP_Olambda__340,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_my(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uu),Uua)) ) ).

% ATP.lambda_340
tff(fact_8521_ATP_Olambda__341,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_mx(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uua),Uu)) ) ).

% ATP.lambda_341
tff(fact_8522_ATP_Olambda__342,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_or(set(A),fun(A,$o),Uu),Uua)
    <=> ~ aa(set(A),$o,member(A,Uua),Uu) ) ).

% ATP.lambda_342
tff(fact_8523_ATP_Olambda__343,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_wa(A,fun(A,$o)),Uu),Uua)
    <=> ( Uu != Uua ) ) ).

% ATP.lambda_343
tff(fact_8524_ATP_Olambda__344,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_aou(A,fun(A,$o),Uu),Uua)
        <=> ( Uua != Uu ) ) ) ).

% ATP.lambda_344
tff(fact_8525_ATP_Olambda__345,axiom,
    ! [A: $tType] :
      ( topological_t1_space(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_aom(A,fun(A,$o),Uu),Uua)
        <=> ( Uua != Uu ) ) ) ).

% ATP.lambda_345
tff(fact_8526_ATP_Olambda__346,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_ant(A,fun(A,$o),Uu),Uua)
        <=> ( Uua != Uu ) ) ) ).

% ATP.lambda_346
tff(fact_8527_ATP_Olambda__347,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_bot(A) )
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_anr(A,fun(A,$o),Uu),Uua)
        <=> ( Uua != Uu ) ) ) ).

% ATP.lambda_347
tff(fact_8528_ATP_Olambda__348,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( aa(A,$o,aTP_Lamp_wd(A,fun(A,$o),Uu),Uua)
    <=> ( Uua != Uu ) ) ).

% ATP.lambda_348
tff(fact_8529_ATP_Olambda__349,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_cp(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_349
tff(fact_8530_ATP_Olambda__350,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_gc(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_350
tff(fact_8531_ATP_Olambda__351,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_cf(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_351
tff(fact_8532_ATP_Olambda__352,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,real,aTP_Lamp_fl(fun(B,A),fun(B,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_352
tff(fact_8533_ATP_Olambda__353,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,real,aTP_Lamp_kw(fun(B,A),fun(B,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_353
tff(fact_8534_ATP_Olambda__354,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_avb(fun(A,B),fun(A,real),Uu),Uua) = real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_354
tff(fact_8535_ATP_Olambda__355,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_ady(fun(A,B),fun(A,real),Uu),Uua) = real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_355
tff(fact_8536_ATP_Olambda__356,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & comm_semiring_1(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_kv(fun(A,B),fun(A,real),Uu),Uua) = real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_356
tff(fact_8537_ATP_Olambda__357,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_agi(fun(A,B),fun(A,real),Uu),Uua) = real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_357
tff(fact_8538_ATP_Olambda__358,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [Uu: fun(A,$o),Uua: A] : ( aa(A,B,aTP_Lamp_sq(fun(A,$o),fun(A,B),Uu),Uua) = aa($o,B,zero_neq_one_of_bool(B),aa(A,$o,Uu,Uua)) ) ) ).

% ATP.lambda_358
tff(fact_8539_ATP_Olambda__359,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_ajp(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_359
tff(fact_8540_ATP_Olambda__360,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_aci(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_360
tff(fact_8541_ATP_Olambda__361,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_atv(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_361
tff(fact_8542_ATP_Olambda__362,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_avm(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_362
tff(fact_8543_ATP_Olambda__363,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_aab(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_363
tff(fact_8544_ATP_Olambda__364,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ahx(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_364
tff(fact_8545_ATP_Olambda__365,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_amz(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_365
tff(fact_8546_ATP_Olambda__366,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ago(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_366
tff(fact_8547_ATP_Olambda__367,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_kk(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_367
tff(fact_8548_ATP_Olambda__368,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_fg(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_368
tff(fact_8549_ATP_Olambda__369,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,real,aTP_Lamp_and(fun(A,nat),fun(A,real),Uu),Uua) = aa(nat,real,semiring_1_of_nat(real),aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_369
tff(fact_8550_ATP_Olambda__370,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,int,aTP_Lamp_hp(fun(A,nat),fun(A,int),Uu),Uua) = aa(nat,int,semiring_1_of_nat(int),aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_370
tff(fact_8551_ATP_Olambda__371,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_acr(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_371
tff(fact_8552_ATP_Olambda__372,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_aui(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_372
tff(fact_8553_ATP_Olambda__373,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ajc(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_373
tff(fact_8554_ATP_Olambda__374,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_oi(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_374
tff(fact_8555_ATP_Olambda__375,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,complex,aTP_Lamp_ct(fun(nat,real),fun(nat,complex),Uu),Uua) = aa(real,complex,real_Vector_of_real(complex),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_375
tff(fact_8556_ATP_Olambda__376,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,A,aTP_Lamp_cu(fun(nat,real),fun(nat,A),Uu),Uua) = aa(real,A,real_Vector_of_real(A),aa(nat,real,Uu,Uua)) ) ) ).

% ATP.lambda_376
tff(fact_8557_ATP_Olambda__377,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,A,aTP_Lamp_cv(fun(nat,real),fun(nat,A),Uu),Uua) = aa(real,A,real_Vector_of_real(A),aa(nat,real,Uu,Uua)) ) ) ).

% ATP.lambda_377
tff(fact_8558_ATP_Olambda__378,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,A,aTP_Lamp_dh(fun(nat,real),fun(nat,A),Uu),Uua) = aa(real,A,real_Vector_of_real(A),aa(nat,real,Uu,Uua)) ) ) ).

% ATP.lambda_378
tff(fact_8559_ATP_Olambda__379,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Uu: fun(B,real),Uua: B] : ( aa(B,A,aTP_Lamp_fi(fun(B,real),fun(B,A),Uu),Uua) = aa(real,A,real_Vector_of_real(A),aa(B,real,Uu,Uua)) ) ) ).

% ATP.lambda_379
tff(fact_8560_ATP_Olambda__380,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2191834092415804123ebra_1(A) )
     => ! [Uu: fun(B,real),Uua: B] : ( aa(B,A,aTP_Lamp_km(fun(B,real),fun(B,A),Uu),Uua) = aa(real,A,real_Vector_of_real(A),aa(B,real,Uu,Uua)) ) ) ).

% ATP.lambda_380
tff(fact_8561_ATP_Olambda__381,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,B,aTP_Lamp_abr(fun(A,real),fun(A,B),Uu),Uua) = aa(real,B,real_Vector_of_real(B),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_381
tff(fact_8562_ATP_Olambda__382,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,complex,aTP_Lamp_awh(fun(A,real),fun(A,complex),Uu),Uua) = aa(real,complex,real_Vector_of_real(complex),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_382
tff(fact_8563_ATP_Olambda__383,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,B,aTP_Lamp_ava(fun(A,real),fun(A,B),Uu),Uua) = aa(real,B,real_Vector_of_real(B),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_383
tff(fact_8564_ATP_Olambda__384,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,B,aTP_Lamp_adz(fun(A,real),fun(A,B),Uu),Uua) = aa(real,B,real_Vector_of_real(B),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_384
tff(fact_8565_ATP_Olambda__385,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,B,aTP_Lamp_agg(fun(A,real),fun(A,B),Uu),Uua) = aa(real,B,real_Vector_of_real(B),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_385
tff(fact_8566_ATP_Olambda__386,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2191834092415804123ebra_1(B)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,B,aTP_Lamp_agf(fun(A,real),fun(A,B),Uu),Uua) = aa(real,B,real_Vector_of_real(B),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_386
tff(fact_8567_ATP_Olambda__387,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cb(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_387
tff(fact_8568_ATP_Olambda__388,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_dm(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_388
tff(fact_8569_ATP_Olambda__389,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_di(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_389
tff(fact_8570_ATP_Olambda__390,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_vb(fun(B,set(A)),fun(B,set(A)),Uu),Uua) = aa(set(A),set(A),uminus_uminus(set(A)),aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_390
tff(fact_8571_ATP_Olambda__391,axiom,
    ! [A: $tType,B: $tType] :
      ( comple489889107523837845lgebra(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_vi(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_391
tff(fact_8572_ATP_Olambda__392,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_ii(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_392
tff(fact_8573_ATP_Olambda__393,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_abo(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,uminus_uminus(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_393
tff(fact_8574_ATP_Olambda__394,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_avj(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,uminus_uminus(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_394
tff(fact_8575_ATP_Olambda__395,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_zy(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_395
tff(fact_8576_ATP_Olambda__396,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ahw(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,uminus_uminus(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_396
tff(fact_8577_ATP_Olambda__397,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ahd(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,uminus_uminus(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_397
tff(fact_8578_ATP_Olambda__398,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_amx(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,uminus_uminus(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_398
tff(fact_8579_ATP_Olambda__399,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ahe(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,uminus_uminus(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_399
tff(fact_8580_ATP_Olambda__400,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_lf(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_400
tff(fact_8581_ATP_Olambda__401,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_kl(fun(B,int),fun(B,A),Uu),Uua) = ring_1_of_int(A,aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_401
tff(fact_8582_ATP_Olambda__402,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_fh(fun(B,int),fun(B,A),Uu),Uua) = ring_1_of_int(A,aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_402
tff(fact_8583_ATP_Olambda__403,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_jr(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_403
tff(fact_8584_ATP_Olambda__404,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_awa(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,artanh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_404
tff(fact_8585_ATP_Olambda__405,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_alm(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,artanh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_405
tff(fact_8586_ATP_Olambda__406,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_aet(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,artanh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_406
tff(fact_8587_ATP_Olambda__407,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_aum(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,arsinh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_407
tff(fact_8588_ATP_Olambda__408,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_aiz(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arsinh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_408
tff(fact_8589_ATP_Olambda__409,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_agb(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arsinh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_409
tff(fact_8590_ATP_Olambda__410,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_add(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_410
tff(fact_8591_ATP_Olambda__411,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_aus(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_411
tff(fact_8592_ATP_Olambda__412,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_aix(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_412
tff(fact_8593_ATP_Olambda__413,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_agc(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_413
tff(fact_8594_ATP_Olambda__414,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_abe(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcsin,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_414
tff(fact_8595_ATP_Olambda__415,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_avy(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcsin,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_415
tff(fact_8596_ATP_Olambda__416,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_avu(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,arcosh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_416
tff(fact_8597_ATP_Olambda__417,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_all(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcosh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_417
tff(fact_8598_ATP_Olambda__418,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_aes(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcosh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_418
tff(fact_8599_ATP_Olambda__419,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_abg(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arccos,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_419
tff(fact_8600_ATP_Olambda__420,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_avx(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arccos,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_420
tff(fact_8601_ATP_Olambda__421,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,product_prod(B,C)),Uua: A] : ( aa(A,C,aTP_Lamp_avq(fun(A,product_prod(B,C)),fun(A,C),Uu),Uua) = aa(product_prod(B,C),C,product_snd(B,C),aa(A,product_prod(B,C),Uu,Uua)) ) ) ).

% ATP.lambda_421
tff(fact_8602_ATP_Olambda__422,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,product_prod(B,C)),Uua: A] : ( aa(A,C,aTP_Lamp_aej(fun(A,product_prod(B,C)),fun(A,C),Uu),Uua) = aa(product_prod(B,C),C,product_snd(B,C),aa(A,product_prod(B,C),Uu,Uua)) ) ) ).

% ATP.lambda_422
tff(fact_8603_ATP_Olambda__423,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,product_prod(B,C)),Uua: A] : ( aa(A,C,aTP_Lamp_ahr(fun(A,product_prod(B,C)),fun(A,C),Uu),Uua) = aa(product_prod(B,C),C,product_snd(B,C),aa(A,product_prod(B,C),Uu,Uua)) ) ) ).

% ATP.lambda_423
tff(fact_8604_ATP_Olambda__424,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,product_prod(B,C)),Uua: A] : ( aa(A,B,aTP_Lamp_avp(fun(A,product_prod(B,C)),fun(A,B),Uu),Uua) = aa(product_prod(B,C),B,product_fst(B,C),aa(A,product_prod(B,C),Uu,Uua)) ) ) ).

% ATP.lambda_424
tff(fact_8605_ATP_Olambda__425,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,product_prod(B,C)),Uua: A] : ( aa(A,B,aTP_Lamp_aei(fun(A,product_prod(B,C)),fun(A,B),Uu),Uua) = aa(product_prod(B,C),B,product_fst(B,C),aa(A,product_prod(B,C),Uu,Uua)) ) ) ).

% ATP.lambda_425
tff(fact_8606_ATP_Olambda__426,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,product_prod(B,C)),Uua: A] : ( aa(A,B,aTP_Lamp_ahq(fun(A,product_prod(B,C)),fun(A,B),Uu),Uua) = aa(product_prod(B,C),B,product_fst(B,C),aa(A,product_prod(B,C),Uu,Uua)) ) ) ).

% ATP.lambda_426
tff(fact_8607_ATP_Olambda__427,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_auj(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_427
tff(fact_8608_ATP_Olambda__428,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ahy(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_428
tff(fact_8609_ATP_Olambda__429,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_agn(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_429
tff(fact_8610_ATP_Olambda__430,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_cg(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_430
tff(fact_8611_ATP_Olambda__431,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_hm(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,abs_abs(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_431
tff(fact_8612_ATP_Olambda__432,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_field(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_ko(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,abs_abs(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_432
tff(fact_8613_ATP_Olambda__433,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_aul(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_433
tff(fact_8614_ATP_Olambda__434,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_air(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_434
tff(fact_8615_ATP_Olambda__435,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_afa(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_435
tff(fact_8616_ATP_Olambda__436,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_avt(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_436
tff(fact_8617_ATP_Olambda__437,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_aid(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_437
tff(fact_8618_ATP_Olambda__438,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_aar(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,tanh(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_438
tff(fact_8619_ATP_Olambda__439,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_aez(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_439
tff(fact_8620_ATP_Olambda__440,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_avd(fun(A,B),fun(A,B),Uu),Uua) = sinh(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_440
tff(fact_8621_ATP_Olambda__441,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_afp(fun(A,B),fun(A,B),Uu),Uua) = sinh(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_441
tff(fact_8622_ATP_Olambda__442,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_zp(fun(A,A),fun(A,A),Uu),Uua) = sinh(A,aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_442
tff(fact_8623_ATP_Olambda__443,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_afr(fun(A,B),fun(A,B),Uu),Uua) = sinh(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_443
tff(fact_8624_ATP_Olambda__444,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_avc(fun(A,B),fun(A,B),Uu),Uua) = cosh(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_444
tff(fact_8625_ATP_Olambda__445,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_agj(fun(A,B),fun(A,B),Uu),Uua) = cosh(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_445
tff(fact_8626_ATP_Olambda__446,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_zq(fun(A,A),fun(A,A),Uu),Uua) = cosh(A,aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_446
tff(fact_8627_ATP_Olambda__447,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_afq(fun(A,B),fun(A,B),Uu),Uua) = cosh(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_447
tff(fact_8628_ATP_Olambda__448,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_adf(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,tan(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_448
tff(fact_8629_ATP_Olambda__449,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_agl(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,tan(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_449
tff(fact_8630_ATP_Olambda__450,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ace(fun(A,real),fun(A,real),Uu),Uua) = sin(real,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_450
tff(fact_8631_ATP_Olambda__451,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_afu(fun(A,B),fun(A,B),Uu),Uua) = sin(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_451
tff(fact_8632_ATP_Olambda__452,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_zn(fun(A,A),fun(A,A),Uu),Uua) = sin(A,aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_452
tff(fact_8633_ATP_Olambda__453,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_acc(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,exp(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_453
tff(fact_8634_ATP_Olambda__454,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_auv(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,exp(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_454
tff(fact_8635_ATP_Olambda__455,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_afv(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,exp(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_455
tff(fact_8636_ATP_Olambda__456,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_zm(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,exp(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_456
tff(fact_8637_ATP_Olambda__457,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_aga(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,exp(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_457
tff(fact_8638_ATP_Olambda__458,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_Vector_banach(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_oe(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,exp(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_458
tff(fact_8639_ATP_Olambda__459,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_ahc(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,cot(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_459
tff(fact_8640_ATP_Olambda__460,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_akp(fun(nat,real),fun(nat,real),Uu),Uua) = cos(real,aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_460
tff(fact_8641_ATP_Olambda__461,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_acn(fun(A,real),fun(A,real),Uu),Uua) = cos(real,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_461
tff(fact_8642_ATP_Olambda__462,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_aft(fun(A,B),fun(A,B),Uu),Uua) = cos(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_462
tff(fact_8643_ATP_Olambda__463,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_aad(fun(A,A),fun(A,A),Uu),Uua) = cos(A,aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_463
tff(fact_8644_ATP_Olambda__464,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,option(A),aTP_Lamp_ayi(fun(B,A),fun(B,option(A)),Uu),Uua) = aa(A,option(A),some(A),aa(B,A,Uu,Uua)) ) ).

% ATP.lambda_464
tff(fact_8645_ATP_Olambda__465,axiom,
    ! [Uu: fun(nat,complex),Uua: nat] : ( aa(nat,real,aTP_Lamp_mk(fun(nat,complex),fun(nat,real),Uu),Uua) = re(aa(nat,complex,Uu,Uua)) ) ).

% ATP.lambda_465
tff(fact_8646_ATP_Olambda__466,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,real,aTP_Lamp_aen(fun(A,complex),fun(A,real),Uu),Uua) = re(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_466
tff(fact_8647_ATP_Olambda__467,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,real,aTP_Lamp_awj(fun(A,complex),fun(A,real),Uu),Uua) = re(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_467
tff(fact_8648_ATP_Olambda__468,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,real,aTP_Lamp_aiq(fun(A,complex),fun(A,real),Uu),Uua) = re(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_468
tff(fact_8649_ATP_Olambda__469,axiom,
    ! [A: $tType,Uu: fun(A,complex),Uua: A] : ( aa(A,real,aTP_Lamp_mj(fun(A,complex),fun(A,real),Uu),Uua) = re(aa(A,complex,Uu,Uua)) ) ).

% ATP.lambda_469
tff(fact_8650_ATP_Olambda__470,axiom,
    ! [Uu: fun(nat,complex),Uua: nat] : ( aa(nat,real,aTP_Lamp_mn(fun(nat,complex),fun(nat,real),Uu),Uua) = im(aa(nat,complex,Uu,Uua)) ) ).

% ATP.lambda_470
tff(fact_8651_ATP_Olambda__471,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,real,aTP_Lamp_aem(fun(A,complex),fun(A,real),Uu),Uua) = im(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_471
tff(fact_8652_ATP_Olambda__472,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,real,aTP_Lamp_awl(fun(A,complex),fun(A,real),Uu),Uua) = im(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_472
tff(fact_8653_ATP_Olambda__473,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,real,aTP_Lamp_aip(fun(A,complex),fun(A,real),Uu),Uua) = im(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_473
tff(fact_8654_ATP_Olambda__474,axiom,
    ! [A: $tType,Uu: fun(A,complex),Uua: A] : ( aa(A,real,aTP_Lamp_mm(fun(A,complex),fun(A,real),Uu),Uua) = im(aa(A,complex,Uu,Uua)) ) ).

% ATP.lambda_474
tff(fact_8655_ATP_Olambda__475,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,fun(C,product_prod(B,C)),aTP_Lamp_azk(fun(A,B),fun(A,fun(C,product_prod(B,C))),Uu),Uua) = aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_475
tff(fact_8656_ATP_Olambda__476,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [Uu: fun(nat,set(A)),Uua: nat] : ( aa(nat,filter(A),aTP_Lamp_arw(fun(nat,set(A)),fun(nat,filter(A)),Uu),Uua) = aa(set(A),filter(A),principal(A),aa(nat,set(A),Uu,Uua)) ) ) ).

% ATP.lambda_476
tff(fact_8657_ATP_Olambda__477,axiom,
    ! [C: $tType,D: $tType,Uu: fun(D,set(C)),Uua: D] : ( aa(D,filter(C),aTP_Lamp_amg(fun(D,set(C)),fun(D,filter(C)),Uu),Uua) = aa(set(C),filter(C),principal(C),aa(D,set(C),Uu,Uua)) ) ).

% ATP.lambda_477
tff(fact_8658_ATP_Olambda__478,axiom,
    ! [D: $tType,C: $tType,Uu: fun(C,set(D)),Uua: C] : ( aa(C,filter(D),aTP_Lamp_amf(fun(C,set(D)),fun(C,filter(D)),Uu),Uua) = aa(set(D),filter(D),principal(D),aa(C,set(D),Uu,Uua)) ) ).

% ATP.lambda_478
tff(fact_8659_ATP_Olambda__479,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B] : ( aa(B,filter(A),aTP_Lamp_amb(fun(B,set(A)),fun(B,filter(A)),Uu),Uua) = aa(set(A),filter(A),principal(A),aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_479
tff(fact_8660_ATP_Olambda__480,axiom,
    ! [E4: $tType,A: $tType,Uu: fun(A,set(E4)),Uua: A] : ( aa(A,filter(E4),aTP_Lamp_ame(fun(A,set(E4)),fun(A,filter(E4)),Uu),Uua) = aa(set(E4),filter(E4),principal(E4),aa(A,set(E4),Uu,Uua)) ) ).

% ATP.lambda_480
tff(fact_8661_ATP_Olambda__481,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,filter(B),aTP_Lamp_amh(fun(A,set(B)),fun(A,filter(B)),Uu),Uua) = aa(set(B),filter(B),principal(B),aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_481
tff(fact_8662_ATP_Olambda__482,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,nat,aTP_Lamp_tk(fun(A,set(B)),fun(A,nat),Uu),Uua) = finite_card(B,aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_482
tff(fact_8663_ATP_Olambda__483,axiom,
    ! [Uu: fun(real,fun(nat,real)),Uua: real] : ( aa(real,real,aTP_Lamp_aan(fun(real,fun(nat,real)),fun(real,real),Uu),Uua) = suminf(real,aa(real,fun(nat,real),Uu,Uua)) ) ).

% ATP.lambda_483
tff(fact_8664_ATP_Olambda__484,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_Vector_banach(B) )
     => ! [Uu: fun(A,fun(nat,B)),Uua: A] : ( aa(A,B,aTP_Lamp_aie(fun(A,fun(nat,B)),fun(A,B),Uu),Uua) = suminf(B,aa(A,fun(nat,B),Uu,Uua)) ) ) ).

% ATP.lambda_484
tff(fact_8665_ATP_Olambda__485,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add(B)
        & topological_t2_space(B) )
     => ! [Uu: fun(A,fun(nat,B)),Uua: A] : ( aa(A,B,aTP_Lamp_ga(fun(A,fun(nat,B)),fun(A,B),Uu),Uua) = suminf(B,aa(A,fun(nat,B),Uu,Uua)) ) ) ).

% ATP.lambda_485
tff(fact_8666_ATP_Olambda__486,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,list(A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_azt(fun(B,list(A)),fun(B,set(A)),Uu),Uua) = aa(list(A),set(A),set2(A),aa(B,list(A),Uu,Uua)) ) ).

% ATP.lambda_486
tff(fact_8667_ATP_Olambda__487,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_adb(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_487
tff(fact_8668_ATP_Olambda__488,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_auw(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_488
tff(fact_8669_ATP_Olambda__489,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_aiw(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_489
tff(fact_8670_ATP_Olambda__490,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_agd(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_490
tff(fact_8671_ATP_Olambda__491,axiom,
    ! [Uu: fun(nat,complex),Uua: nat] : ( aa(nat,complex,aTP_Lamp_ml(fun(nat,complex),fun(nat,complex),Uu),Uua) = cnj(aa(nat,complex,Uu,Uua)) ) ).

% ATP.lambda_491
tff(fact_8672_ATP_Olambda__492,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,complex,aTP_Lamp_aeo(fun(A,complex),fun(A,complex),Uu),Uua) = cnj(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_492
tff(fact_8673_ATP_Olambda__493,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,complex,aTP_Lamp_awi(fun(A,complex),fun(A,complex),Uu),Uua) = cnj(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_493
tff(fact_8674_ATP_Olambda__494,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,complex),Uua: A] : ( aa(A,complex,aTP_Lamp_ais(fun(A,complex),fun(A,complex),Uu),Uua) = cnj(aa(A,complex,Uu,Uua)) ) ) ).

% ATP.lambda_494
tff(fact_8675_ATP_Olambda__495,axiom,
    ! [A: $tType,Uu: fun(A,complex),Uua: A] : ( aa(A,complex,aTP_Lamp_mi(fun(A,complex),fun(A,complex),Uu),Uua) = cnj(aa(A,complex,Uu,Uua)) ) ).

% ATP.lambda_495
tff(fact_8676_ATP_Olambda__496,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,complex,aTP_Lamp_awk(fun(A,real),fun(A,complex),Uu),Uua) = cis(aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_496
tff(fact_8677_ATP_Olambda__497,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,fun(set(B),set(B)),aTP_Lamp_baz(fun(A,B),fun(A,fun(set(B),set(B))),Uu),Uua) = insert(B,aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_497
tff(fact_8678_ATP_Olambda__498,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B] : ( aa(B,set(set(A)),aTP_Lamp_up(fun(B,set(A)),fun(B,set(set(A))),Uu),Uua) = pow2(A,aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_498
tff(fact_8679_ATP_Olambda__499,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,nat,aTP_Lamp_pp(fun(A,nat),fun(A,nat),Uu),Uua) = aa(nat,nat,suc,aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_499
tff(fact_8680_ATP_Olambda__500,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B] :
      ( aa(B,$o,aTP_Lamp_azv(fun(B,$o),fun(B,$o),Uu),Uua)
    <=> ~ aa(B,$o,Uu,Uua) ) ).

% ATP.lambda_500
tff(fact_8681_ATP_Olambda__501,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,$o),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aef(fun(A,$o),fun(A,$o),Uu),Uua)
        <=> ~ aa(A,$o,Uu,Uua) ) ) ).

% ATP.lambda_501
tff(fact_8682_ATP_Olambda__502,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: A] :
      ( aa(A,$o,aTP_Lamp_ed(fun(A,$o),fun(A,$o),Uu),Uua)
    <=> ~ aa(A,$o,Uu,Uua) ) ).

% ATP.lambda_502
tff(fact_8683_ATP_Olambda__503,axiom,
    ! [B: $tType,A: $tType] :
      ( finite_finite(A)
     => ! [Uu: fun(B,fun(A,$o)),Uua: B] :
          ( aa(B,$o,aTP_Lamp_arn(fun(B,fun(A,$o)),fun(B,$o),Uu),Uua)
        <=> ! [X_12: A] : aa(A,$o,aa(B,fun(A,$o),Uu,Uua),X_12) ) ) ).

% ATP.lambda_503
tff(fact_8684_ATP_Olambda__504,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,$o)),Uua: A] :
      ( aa(A,$o,aTP_Lamp_arp(fun(A,fun(B,$o)),fun(A,$o),Uu),Uua)
    <=> ! [X_12: B] : aa(B,$o,aa(A,fun(B,$o),Uu,Uua),X_12) ) ).

% ATP.lambda_504
tff(fact_8685_ATP_Olambda__505,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,$o)),Uua: A] :
      ( aa(A,$o,aTP_Lamp_asd(fun(A,fun(B,$o)),fun(A,$o),Uu),Uua)
    <=> ? [X_12: B] : aa(B,$o,aa(A,fun(B,$o),Uu,Uua),X_12) ) ).

% ATP.lambda_505
tff(fact_8686_ATP_Olambda__506,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real] : ( aa(real,filter(A),aTP_Lamp_amj(A,fun(real,filter(A)),Uu),Uua) = aa(set(A),filter(A),principal(A),aa(fun(A,$o),set(A),collect(A),aa(real,fun(A,$o),aTP_Lamp_ami(A,fun(real,fun(A,$o)),Uu),Uua))) ) ) ).

% ATP.lambda_506
tff(fact_8687_ATP_Olambda__507,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [Uu: fun(real,A),Uua: real] : ( aa(real,real,aTP_Lamp_aih(fun(real,A),fun(real,real),Uu),Uua) = ring_1_of_int(real,archim6421214686448440834_floor(A,aa(real,A,Uu,Uua))) ) ) ).

% ATP.lambda_507
tff(fact_8688_ATP_Olambda__508,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B)
        & ring_1(C)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,C,aTP_Lamp_afd(fun(A,B),fun(A,C),Uu),Uua) = ring_1_of_int(C,archim6421214686448440834_floor(B,aa(A,B,Uu,Uua))) ) ) ).

% ATP.lambda_508
tff(fact_8689_ATP_Olambda__509,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B)
        & ring_1(C)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,C,aTP_Lamp_aey(fun(A,B),fun(A,C),Uu),Uua) = ring_1_of_int(C,archimedean_ceiling(B,aa(A,B,Uu,Uua))) ) ) ).

% ATP.lambda_509
tff(fact_8690_ATP_Olambda__510,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,$o),Uua: fun(B,$o)] : ( aa(fun(B,$o),filter(product_prod(A,B)),aa(fun(A,$o),fun(fun(B,$o),filter(product_prod(A,B))),aTP_Lamp_axs(fun(A,$o),fun(fun(B,$o),filter(product_prod(A,B)))),Uu),Uua) = aa(set(product_prod(A,B)),filter(product_prod(A,B)),principal(product_prod(A,B)),aa(fun(product_prod(A,B),$o),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aa(fun(B,$o),fun(A,fun(B,$o)),aTP_Lamp_axr(fun(A,$o),fun(fun(B,$o),fun(A,fun(B,$o))),Uu),Uua)))) ) ).

% ATP.lambda_510
tff(fact_8691_ATP_Olambda__511,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,fun(B,$o)),Uua: B] :
          ( aa(B,$o,aTP_Lamp_ayv(fun(A,fun(B,$o)),fun(B,$o),Uu),Uua)
        <=> ! [I: A] : aa(B,$o,aa(A,fun(B,$o),Uu,I),Uua) ) ) ).

% ATP.lambda_511
tff(fact_8692_ATP_Olambda__512,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,fun(B,$o)),Uua: B] :
          ( aa(B,$o,aTP_Lamp_asi(fun(A,fun(B,$o)),fun(B,$o),Uu),Uua)
        <=> ? [I: A] : aa(B,$o,aa(A,fun(B,$o),Uu,I),Uua) ) ) ).

% ATP.lambda_512
tff(fact_8693_ATP_Olambda__513,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_atb(list(A),fun(A,$o),Uu),Uua)
    <=> ? [I: nat] :
          ( ( Uua = aa(nat,A,nth(A,Uu),I) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Uu)) ) ) ).

% ATP.lambda_513
tff(fact_8694_ATP_Olambda__514,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_atf(set(set(B)),fun(set(B),$o),Uu),Uua)
    <=> ? [F6: fun(set(B),B)] :
          ( ( Uua = aa(set(set(B)),set(B),image(set(B),B,F6),Uu) )
          & ! [X3: set(B)] :
              ( aa(set(set(B)),$o,member(set(B),X3),Uu)
             => aa(set(B),$o,member(B,aa(set(B),B,F6,X3)),X3) ) ) ) ).

% ATP.lambda_514
tff(fact_8695_ATP_Olambda__515,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_atc(set(set(A)),fun(set(A),$o),Uu),Uua)
        <=> ? [F6: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F6),Uu) )
              & ! [X3: set(A)] :
                  ( aa(set(set(A)),$o,member(set(A),X3),Uu)
                 => aa(set(A),$o,member(A,aa(set(A),A,F6,X3)),X3) ) ) ) ) ).

% ATP.lambda_515
tff(fact_8696_ATP_Olambda__516,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_ati(set(set(A)),fun(set(A),$o),Uu),Uua)
        <=> ? [F6: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F6),Uu) )
              & ! [X3: set(A)] :
                  ( aa(set(set(A)),$o,member(set(A),X3),Uu)
                 => aa(set(A),$o,member(A,aa(set(A),A,F6,X3)),X3) ) ) ) ) ).

% ATP.lambda_516
tff(fact_8697_ATP_Olambda__517,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_atm(set(set(A)),fun(set(A),$o),Uu),Uua)
        <=> ? [F6: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F6),Uu) )
              & ! [X3: set(A)] :
                  ( aa(set(set(A)),$o,member(set(A),X3),Uu)
                 => aa(set(A),$o,member(A,aa(set(A),A,F6,X3)),X3) ) ) ) ) ).

% ATP.lambda_517
tff(fact_8698_ATP_Olambda__518,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( aa(set(A),$o,aTP_Lamp_atg(set(A),fun(set(A),$o),Uu),Uua)
    <=> ? [B10: set(A)] :
          ( ( Uua = aa(set(A),set(A),uminus_uminus(set(A)),B10) )
          & aa(set(set(A)),$o,member(set(A),Uu),pow2(A,B10)) ) ) ).

% ATP.lambda_518
tff(fact_8699_ATP_Olambda__519,axiom,
    ! [A: $tType,Uu: set(filter(A)),Uua: filter(A)] :
      ( aa(filter(A),$o,aTP_Lamp_atl(set(filter(A)),fun(filter(A),$o),Uu),Uua)
    <=> ! [X3: filter(A)] :
          ( aa(set(filter(A)),$o,member(filter(A),X3),Uu)
         => aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),Uua),X3) ) ) ).

% ATP.lambda_519
tff(fact_8700_ATP_Olambda__520,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_awd(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),Uu)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),X3) ) ) ) ).

% ATP.lambda_520
tff(fact_8701_ATP_Olambda__521,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_asx(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),Uu)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),X3) ) ) ) ).

% ATP.lambda_521
tff(fact_8702_ATP_Olambda__522,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_atx(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),Uu)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Uua) ) ) ) ).

% ATP.lambda_522
tff(fact_8703_ATP_Olambda__523,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_asw(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X3: A] :
              ( aa(set(A),$o,member(A,X3),Uu)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Uua) ) ) ) ).

% ATP.lambda_523
tff(fact_8704_ATP_Olambda__524,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: A] :
      ( aa(A,$o,aTP_Lamp_ath(set(set(A)),fun(A,$o),Uu),Uua)
    <=> ! [X3: set(A)] :
          ( aa(set(set(A)),$o,member(set(A),X3),Uu)
         => aa(set(A),$o,member(A,Uua),X3) ) ) ).

% ATP.lambda_524
tff(fact_8705_ATP_Olambda__525,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(A,$o),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aro(fun(A,$o),fun(A,$o),Uu),Uua)
        <=> ! [Y: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Y)
             => aa(A,$o,Uu,Y) ) ) ) ).

% ATP.lambda_525
tff(fact_8706_ATP_Olambda__526,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,option(A)),Uua: A] :
      ( aa(A,$o,aTP_Lamp_asn(fun(B,option(A)),fun(A,$o),Uu),Uua)
    <=> ? [A6: B] : ( aa(B,option(A),Uu,A6) = aa(A,option(A),some(A),Uua) ) ) ).

% ATP.lambda_526
tff(fact_8707_ATP_Olambda__527,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_ast(fun(B,A),fun(A,$o),Uu),Uua)
    <=> ? [X3: B] : ( Uua = aa(B,A,Uu,X3) ) ) ).

% ATP.lambda_527
tff(fact_8708_ATP_Olambda__528,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aTP_Lamp_ata(fun(A,option(B)),fun(product_prod(A,B),$o),Uu),Uua)
    <=> ? [A6: A,B6: B] :
          ( ( Uua = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),B6) )
          & ( aa(A,option(B),Uu,A6) = aa(B,option(B),some(B),B6) ) ) ) ).

% ATP.lambda_528
tff(fact_8709_ATP_Olambda__529,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),option(A),aa(A,fun(list(A),option(A)),aTP_Lamp_yv(A,fun(list(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),Uu) ) ).

% ATP.lambda_529
tff(fact_8710_ATP_Olambda__530,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] :
      ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_dd(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub),aa(nat,real,Uua,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),one_one(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% ATP.lambda_530
tff(fact_8711_ATP_Olambda__531,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] :
      ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_iz(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub),aa(nat,real,Uu,Uub),aa(nat,real,Uua,Uub)) ) ).

% ATP.lambda_531
tff(fact_8712_ATP_Olambda__532,axiom,
    ! [Uu: num,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_mh(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),aa(num,code_integer,numeral_numeral(code_integer),Uu)),Uub),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uub),aa(num,code_integer,numeral_numeral(code_integer),Uu))),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_532
tff(fact_8713_ATP_Olambda__533,axiom,
    ! [Uu: num,Uua: nat,Uub: nat] :
      ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_ba(num,fun(nat,fun(nat,product_prod(nat,nat))),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Uu)),Uub),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),Uu))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_533
tff(fact_8714_ATP_Olambda__534,axiom,
    ! [Uu: num,Uua: int,Uub: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_bb(num,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Uu)),Uub),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uub),aa(num,int,numeral_numeral(int),Uu))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_534
tff(fact_8715_ATP_Olambda__535,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: num,Uua: A,Uub: A] :
          ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_bc(num,fun(A,fun(A,product_prod(A,A))),Uu),Uua),Uub)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Uu)),Uub),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),aa(num,A,numeral_numeral(A),Uu))),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),Uub)) ) ) ).

% ATP.lambda_535
tff(fact_8716_ATP_Olambda__536,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: list(A)] :
      ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_ayj(A,fun(A,fun(list(A),list(A))),Uu),Uua),Uub)
      = $ite(Uu = Uua,aa(list(A),list(A),cons(A,Uua),Uub),aa(list(A),list(A),cons(A,Uu),aa(list(A),list(A),cons(A,Uua),Uub))) ) ).

% ATP.lambda_536
tff(fact_8717_ATP_Olambda__537,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: set(nat),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_nf(set(nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(aa(set(nat),$o,member(nat,Uub),Uu),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_537
tff(fact_8718_ATP_Olambda__538,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: set(A),Uub: A] :
          ( aa(A,B,aa(set(A),fun(A,B),aTP_Lamp_su(fun(A,B),fun(set(A),fun(A,B)),Uu),Uua),Uub)
          = $ite(aa(set(A),$o,member(A,Uub),Uua),aa(A,B,Uu,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_538
tff(fact_8719_ATP_Olambda__539,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: set(A),Uub: A] :
          ( aa(A,B,aa(set(A),fun(A,B),aTP_Lamp_sv(fun(A,B),fun(set(A),fun(A,B)),Uu),Uua),Uub)
          = $ite(aa(set(A),$o,member(A,Uub),Uua),aa(A,B,Uu,Uub),one_one(B)) ) ) ).

% ATP.lambda_539
tff(fact_8720_ATP_Olambda__540,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_na(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(A,B,Uua,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_540
tff(fact_8721_ATP_Olambda__541,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_nd(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(A,B,Uua,Uub),one_one(B)) ) ) ).

% ATP.lambda_541
tff(fact_8722_ATP_Olambda__542,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat,Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bt(nat,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_542
tff(fact_8723_ATP_Olambda__543,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_nb(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(A,B,Uua,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_543
tff(fact_8724_ATP_Olambda__544,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_nc(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(A,B,Uua,Uub),one_one(B)) ) ) ).

% ATP.lambda_544
tff(fact_8725_ATP_Olambda__545,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_mt(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_545
tff(fact_8726_ATP_Olambda__546,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_qk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_546
tff(fact_8727_ATP_Olambda__547,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_ms(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uu),Uub))) ) ).

% ATP.lambda_547
tff(fact_8728_ATP_Olambda__548,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: A,Uub: set(A)] :
      ( aa(set(A),set(A),aa(A,fun(set(A),set(A)),aTP_Lamp_bba(fun(A,$o),fun(A,fun(set(A),set(A))),Uu),Uua),Uub)
      = $ite(aa(A,$o,Uu,Uua),aa(set(A),set(A),insert(A,Uua),Uub),Uub) ) ).

% ATP.lambda_548
tff(fact_8729_ATP_Olambda__549,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,$o),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ne(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(aa(nat,$o,Uu,Uub),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_549
tff(fact_8730_ATP_Olambda__550,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,$o),Uub: B] :
          ( aa(B,A,aa(fun(B,$o),fun(B,A),aTP_Lamp_wc(fun(B,A),fun(fun(B,$o),fun(B,A)),Uu),Uua),Uub)
          = $ite(aa(B,$o,Uua,Uub),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_550
tff(fact_8731_ATP_Olambda__551,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: A] :
          ( aa(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_nx(fun(A,B),fun(fun(A,$o),fun(A,B)),Uu),Uua),Uub)
          = $ite(aa(A,$o,Uua,Uub),aa(A,B,Uu,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_551
tff(fact_8732_ATP_Olambda__552,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: A] :
          ( aa(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_ny(fun(A,B),fun(fun(A,$o),fun(A,B)),Uu),Uua),Uub)
          = $ite(aa(A,$o,Uua,Uub),aa(A,B,Uu,Uub),one_one(B)) ) ) ).

% ATP.lambda_552
tff(fact_8733_ATP_Olambda__553,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: fun(B,$o),Uub: B] :
      ( aa(B,option(A),aa(fun(B,$o),fun(B,option(A)),aTP_Lamp_wl(fun(B,A),fun(fun(B,$o),fun(B,option(A))),Uu),Uua),Uub)
      = $ite(aa(B,$o,Uua,Uub),aa(A,option(A),some(A),aa(B,A,Uu,Uub)),none(A)) ) ).

% ATP.lambda_553
tff(fact_8734_ATP_Olambda__554,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: B,Uub: set(product_prod(B,A))] : ( aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(B,fun(set(product_prod(B,A)),set(product_prod(B,A))),aTP_Lamp_bbn(set(A),fun(B,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uu),Uua),Uub) = finite_fold(A,set(product_prod(B,A)),aTP_Lamp_bbk(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uua),Uub,Uu) ) ).

% ATP.lambda_554
tff(fact_8735_ATP_Olambda__555,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] :
      ( aa(real,$o,aa(fun(real,real),fun(real,$o),aTP_Lamp_ann(fun(real,real),fun(fun(real,real),fun(real,$o)),Uu),Uua),Uub)
    <=> has_field_derivative(real,Uu,aa(real,real,Uua,Uub),topolo174197925503356063within(real,Uub,top_top(set(real)))) ) ).

% ATP.lambda_555
tff(fact_8736_ATP_Olambda__556,axiom,
    ! [A: $tType,B: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: filter(B),Uua: fun(B,A),Uub: A] :
          ( aa(A,$o,aa(fun(B,A),fun(A,$o),aTP_Lamp_ali(filter(B),fun(fun(B,A),fun(A,$o)),Uu),Uua),Uub)
        <=> filterlim(B,A,Uua,topolo7230453075368039082e_nhds(A,Uub),Uu) ) ) ).

% ATP.lambda_556
tff(fact_8737_ATP_Olambda__557,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_azs(fun(A,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uub),Uu),Uua) ) ).

% ATP.lambda_557
tff(fact_8738_ATP_Olambda__558,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: $o] :
      ( aa($o,set(A),aa(set(A),fun($o,set(A)),aTP_Lamp_bam(set(A),fun(set(A),fun($o,set(A))),Uu),Uua),Uub)
      = $ite((Uub),Uu,Uua) ) ).

% ATP.lambda_558
tff(fact_8739_ATP_Olambda__559,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Uu: fun(D,fun(B,C)),Uua: fun(A,D),Uub: product_prod(A,B)] : ( aa(product_prod(A,B),C,aa(fun(A,D),fun(product_prod(A,B),C),aTP_Lamp_ou(fun(D,fun(B,C)),fun(fun(A,D),fun(product_prod(A,B),C)),Uu),Uua),Uub) = aa(B,C,aa(D,fun(B,C),Uu,aa(A,D,Uua,aa(product_prod(A,B),A,product_fst(A,B),Uub))),aa(product_prod(A,B),B,product_snd(A,B),Uub)) ) ).

% ATP.lambda_559
tff(fact_8740_ATP_Olambda__560,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C),Uub: B] : ( aa(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_wv(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,aa(B,C,Uua,Uub)),Uub) ) ) ).

% ATP.lambda_560
tff(fact_8741_ATP_Olambda__561,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_lo(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_561
tff(fact_8742_ATP_Olambda__562,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hz(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_562
tff(fact_8743_ATP_Olambda__563,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,$o)),Uua: fun(A,B),Uub: A] :
      ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_ase(fun(A,fun(B,$o)),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,aa(A,fun(B,$o),Uu,Uub),aa(A,B,Uua,Uub)) ) ).

% ATP.lambda_563
tff(fact_8744_ATP_Olambda__564,axiom,
    ! [Uu: fun(real,fun(nat,real)),Uua: nat,Uub: real] : ( aa(real,real,aa(nat,fun(real,real),aTP_Lamp_aam(fun(real,fun(nat,real)),fun(nat,fun(real,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),Uu,Uub),Uua) ) ).

% ATP.lambda_564
tff(fact_8745_ATP_Olambda__565,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ld(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_565
tff(fact_8746_ATP_Olambda__566,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jp(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_566
tff(fact_8747_ATP_Olambda__567,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B,Uub: C] : ( aa(C,A,aa(B,fun(C,A),aTP_Lamp_wt(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_567
tff(fact_8748_ATP_Olambda__568,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( complete_Sup(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B,Uub: C] : ( aa(C,A,aa(B,fun(C,A),aTP_Lamp_tp(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_568
tff(fact_8749_ATP_Olambda__569,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( complete_Inf(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B,Uub: C] : ( aa(C,A,aa(B,fun(C,A),aTP_Lamp_va(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_569
tff(fact_8750_ATP_Olambda__570,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(B,fun(A,B)),Uua: A,Uub: B] : ( aa(B,B,aa(A,fun(B,B),aTP_Lamp_aae(fun(B,fun(A,B)),fun(A,fun(B,B)),Uu),Uua),Uub) = aa(A,B,aa(B,fun(A,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_570
tff(fact_8751_ATP_Olambda__571,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: C,Uub: B] : ( aa(B,A,aa(C,fun(B,A),aTP_Lamp_ua(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uua),Uub) = aa(C,A,aa(B,fun(C,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_571
tff(fact_8752_ATP_Olambda__572,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: C,Uub: B] : ( aa(B,A,aa(C,fun(B,A),aTP_Lamp_kt(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uua),Uub) = aa(C,A,aa(B,fun(C,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_572
tff(fact_8753_ATP_Olambda__573,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: C,Uub: B] : ( aa(B,A,aa(C,fun(B,A),aTP_Lamp_hv(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uua),Uub) = aa(C,A,aa(B,fun(C,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_573
tff(fact_8754_ATP_Olambda__574,axiom,
    ! [B: $tType,A: $tType] :
      ( finite_finite(A)
     => ! [Uu: fun(B,fun(A,$o)),Uua: A,Uub: B] :
          ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_arm(fun(B,fun(A,$o)),fun(A,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(B,fun(A,$o),Uu,Uub),Uua) ) ) ).

% ATP.lambda_574
tff(fact_8755_ATP_Olambda__575,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,fun(A,$o)),Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_asa(fun(B,fun(A,$o)),fun(A,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(A,$o,aa(B,fun(A,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_575
tff(fact_8756_ATP_Olambda__576,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [Uu: fun(B,fun(A,C)),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_agx(fun(B,fun(A,C)),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(A,C,aa(B,fun(A,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_576
tff(fact_8757_ATP_Olambda__577,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: fun(B,fun(A,C)),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_ahk(fun(B,fun(A,C)),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(A,C,aa(B,fun(A,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_577
tff(fact_8758_ATP_Olambda__578,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo5987344860129210374id_add(B)
        & topological_t2_space(B) )
     => ! [Uu: fun(A,fun(nat,B)),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_fo(fun(A,fun(nat,B)),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(A,fun(nat,B),Uu,Uub),Uua) ) ) ).

% ATP.lambda_578
tff(fact_8759_ATP_Olambda__579,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_abl(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_579
tff(fact_8760_ATP_Olambda__580,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_acv(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_580
tff(fact_8761_ATP_Olambda__581,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & real_V4412858255891104859lgebra(C)
        & comm_ring_1(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_avf(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_581
tff(fact_8762_ATP_Olambda__582,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4987421752381908075d_mult(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_avh(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_582
tff(fact_8763_ATP_Olambda__583,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo5987344860129210374id_add(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_avn(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_583
tff(fact_8764_ATP_Olambda__584,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topological_t2_space(B)
        & real_V4412858255891104859lgebra(C)
        & comm_ring_1(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_agt(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_584
tff(fact_8765_ATP_Olambda__585,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topological_t2_space(B)
        & topolo4987421752381908075d_mult(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_agv(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_585
tff(fact_8766_ATP_Olambda__586,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( topological_t2_space(B)
        & topolo5987344860129210374id_add(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_ahm(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_586
tff(fact_8767_ATP_Olambda__587,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,$o)),Uua: B,Uub: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_arq(fun(A,fun(B,$o)),fun(B,fun(A,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,aa(A,fun(B,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_587
tff(fact_8768_ATP_Olambda__588,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(C)
        & comm_ring_1(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_agp(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_588
tff(fact_8769_ATP_Olambda__589,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_agr(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_589
tff(fact_8770_ATP_Olambda__590,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_aho(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_590
tff(fact_8771_ATP_Olambda__591,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_np(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_591
tff(fact_8772_ATP_Olambda__592,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_nl(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_592
tff(fact_8773_ATP_Olambda__593,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,$o)),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_vt(fun(A,fun(A,$o)),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> aa(A,$o,aa(A,fun(A,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_593
tff(fact_8774_ATP_Olambda__594,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ge(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_gd(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub)),aa(nat,set(nat),set_ord_atMost(nat),Uub)) ) ) ).

% ATP.lambda_594
tff(fact_8775_ATP_Olambda__595,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_fe(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fd(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),aa(nat,set(nat),set_ord_atMost(nat),Uub)) ) ) ).

% ATP.lambda_595
tff(fact_8776_ATP_Olambda__596,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_fc(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fb(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),aa(nat,set(nat),set_ord_atMost(nat),Uub)) ) ) ).

% ATP.lambda_596
tff(fact_8777_ATP_Olambda__597,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_fa(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ez(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),aa(nat,set(nat),set_ord_atMost(nat),Uub)) ) ) ).

% ATP.lambda_597
tff(fact_8778_ATP_Olambda__598,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat,Uua: A,Uub: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_da(nat,fun(A,fun(nat,A)),Uu),Uua),Uub)
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),$ite(Uub = Uu,one_one(A),zero_zero(A))),
              aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_598
tff(fact_8779_ATP_Olambda__599,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,$o),aa(code_integer,fun(code_integer,product_prod(code_integer,$o)),aTP_Lamp_mq(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),Uu),Uua),Uub)
      = aa($o,product_prod(code_integer,$o),
          aa(code_integer,fun($o,product_prod(code_integer,$o)),product_Pair(code_integer,$o),$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),Uu),Uua,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),Uub))),
          ( Uub = one_one(code_integer) )) ) ).

% ATP.lambda_599
tff(fact_8780_ATP_Olambda__600,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,$o)),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_eu(fun(A,fun(A,$o)),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,aa(A,fun(A,$o),Uu,Uua),Uub)
        | ( Uua = Uub ) ) ) ).

% ATP.lambda_600
tff(fact_8781_ATP_Olambda__601,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_le(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = groups7121269368397514597t_prod(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ld(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_601
tff(fact_8782_ATP_Olambda__602,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jq(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_jp(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_602
tff(fact_8783_ATP_Olambda__603,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_aig(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),Uu),Uub)),aa(nat,set(nat),set_ord_atMost(nat),Uua)) ) ) ).

% ATP.lambda_603
tff(fact_8784_ATP_Olambda__604,axiom,
    ! [Uu: $o,Uua: code_integer,Uub: $o] : ( aa($o,char,aa(code_integer,fun($o,char),aTP_Lamp_xo($o,fun(code_integer,fun($o,char)),Uu),Uua),Uub) = aa(product_prod(code_integer,$o),char,aa(fun(code_integer,fun($o,char)),fun(product_prod(code_integer,$o),char),product_case_prod(code_integer,$o,char),aa($o,fun(code_integer,fun($o,char)),aTP_Lamp_xn($o,fun($o,fun(code_integer,fun($o,char))),Uu),Uub)),code_bit_cut_integer(Uua)) ) ).

% ATP.lambda_604
tff(fact_8785_ATP_Olambda__605,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ke(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kd(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_605
tff(fact_8786_ATP_Olambda__606,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_kb(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_ka(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_606
tff(fact_8787_ATP_Olambda__607,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_jz(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_jy(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_607
tff(fact_8788_ATP_Olambda__608,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_jk(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_jj(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_608
tff(fact_8789_ATP_Olambda__609,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_hk(rat,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(int,int),$o,aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_hj(int,fun(int,fun(int,fun(int,$o))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_609
tff(fact_8790_ATP_Olambda__610,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_hh(rat,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(int,int),$o,aa(fun(int,fun(int,$o)),fun(product_prod(int,int),$o),product_case_prod(int,int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_hg(int,fun(int,fun(int,fun(int,$o))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_610
tff(fact_8791_ATP_Olambda__611,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_avi(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_avh(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub),Uu) ) ) ).

% ATP.lambda_611
tff(fact_8792_ATP_Olambda__612,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(C)
        & comm_ring_1(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_avg(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_avf(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub),Uu) ) ) ).

% ATP.lambda_612
tff(fact_8793_ATP_Olambda__613,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult(C)
        & topological_t2_space(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_agw(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_agv(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub),Uu) ) ) ).

% ATP.lambda_613
tff(fact_8794_ATP_Olambda__614,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(C)
        & comm_ring_1(C)
        & topological_t2_space(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_agu(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_agt(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub),Uu) ) ) ).

% ATP.lambda_614
tff(fact_8795_ATP_Olambda__615,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_ags(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_agr(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub),Uu) ) ) ).

% ATP.lambda_615
tff(fact_8796_ATP_Olambda__616,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V4412858255891104859lgebra(C)
        & comm_ring_1(C) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_agq(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_agp(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub),Uu) ) ) ).

% ATP.lambda_616
tff(fact_8797_ATP_Olambda__617,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_acw(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_acv(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub),Uu) ) ) ).

% ATP.lambda_617
tff(fact_8798_ATP_Olambda__618,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(B),Uub: C] : ( aa(C,A,aa(set(B),fun(C,A),aTP_Lamp_ku(fun(B,fun(C,A)),fun(set(B),fun(C,A)),Uu),Uua),Uub) = groups7121269368397514597t_prod(B,A,aa(C,fun(B,A),aTP_Lamp_kt(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub),Uua) ) ) ).

% ATP.lambda_618
tff(fact_8799_ATP_Olambda__619,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_avo(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),aTP_Lamp_avn(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub)),Uu) ) ) ).

% ATP.lambda_619
tff(fact_8800_ATP_Olambda__620,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_ahp(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),aTP_Lamp_aho(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub)),Uu) ) ) ).

% ATP.lambda_620
tff(fact_8801_ATP_Olambda__621,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add(C)
        & topological_t2_space(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_ahn(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),aTP_Lamp_ahm(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub)),Uu) ) ) ).

% ATP.lambda_621
tff(fact_8802_ATP_Olambda__622,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_abm(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),aTP_Lamp_abl(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub)),Uu) ) ) ).

% ATP.lambda_622
tff(fact_8803_ATP_Olambda__623,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(B),Uub: C] : ( aa(C,A,aa(set(B),fun(C,A),aTP_Lamp_hw(fun(B,fun(C,A)),fun(set(B),fun(C,A)),Uu),Uua),Uub) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(C,fun(B,A),aTP_Lamp_hv(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_623
tff(fact_8804_ATP_Olambda__624,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add(B)
        & topological_t2_space(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(nat,B)),Uub: nat] : ( aa(nat,B,aa(fun(A,fun(nat,B)),fun(nat,B),aTP_Lamp_fp(set(A),fun(fun(A,fun(nat,B)),fun(nat,B)),Uu),Uua),Uub) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(nat,fun(A,B),aTP_Lamp_fo(fun(A,fun(nat,B)),fun(nat,fun(A,B)),Uua),Uub)),Uu) ) ) ).

% ATP.lambda_624
tff(fact_8805_ATP_Olambda__625,axiom,
    ! [D: $tType,E4: $tType,A: $tType,C: $tType,B: $tType,Uu: fun(B,fun(C,fun(D,fun(E4,set(A))))),Uua: product_prod(B,C),Uub: product_prod(D,E4)] : ( aa(product_prod(D,E4),set(A),aa(product_prod(B,C),fun(product_prod(D,E4),set(A)),aTP_Lamp_vr(fun(B,fun(C,fun(D,fun(E4,set(A))))),fun(product_prod(B,C),fun(product_prod(D,E4),set(A))),Uu),Uua),Uub) = aa(product_prod(B,C),set(A),aa(fun(B,fun(C,set(A))),fun(product_prod(B,C),set(A)),product_case_prod(B,C,set(A)),aa(product_prod(D,E4),fun(B,fun(C,set(A))),aTP_Lamp_vq(fun(B,fun(C,fun(D,fun(E4,set(A))))),fun(product_prod(D,E4),fun(B,fun(C,set(A)))),Uu),Uub)),Uua) ) ).

% ATP.lambda_625
tff(fact_8806_ATP_Olambda__626,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_aav(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uub),zero_zero(real))),semiring_char_0_fact(real,Uub))),aa(nat,real,power_power(real,Uua),Uub)) ) ).

% ATP.lambda_626
tff(fact_8807_ATP_Olambda__627,axiom,
    ! [Uu: real,Uua: fun(nat,fun(real,real)),Uub: nat] : ( aa(nat,real,aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_aaw(real,fun(fun(nat,fun(real,real)),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uua,Uub),zero_zero(real))),semiring_char_0_fact(real,Uub))),aa(nat,real,power_power(real,Uu),Uub)) ) ).

% ATP.lambda_627
tff(fact_8808_ATP_Olambda__628,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [Uu: real,Uua: fun(nat,fun(A,real)),Uub: nat] : ( aa(nat,real,aa(fun(nat,fun(A,real)),fun(nat,real),aTP_Lamp_ix(real,fun(fun(nat,fun(A,real)),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(A,real,aa(nat,fun(A,real),Uua,Uub),zero_zero(A))),semiring_char_0_fact(real,Uub))),aa(nat,real,power_power(real,Uu),Uub)) ) ) ).

% ATP.lambda_628
tff(fact_8809_ATP_Olambda__629,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A] :
          ( aa(A,$o,aa(nat,fun(A,$o),aTP_Lamp_oj(fun(nat,A),fun(nat,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fs(fun(nat,A),fun(A,fun(nat,A)),Uu),Uub)),aa(nat,set(nat),set_ord_atMost(nat),Uua)) = zero_zero(A) ) ) ) ).

% ATP.lambda_629
tff(fact_8810_ATP_Olambda__630,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_aia(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub))),aa(A,A,Uu,Uua))),Uub) ) ) ).

% ATP.lambda_630
tff(fact_8811_ATP_Olambda__631,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_ahs(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub))),aa(A,A,Uu,Uua))),Uub) ) ) ).

% ATP.lambda_631
tff(fact_8812_ATP_Olambda__632,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_mz(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,zero_zero(A)),Uub))),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_632
tff(fact_8813_ATP_Olambda__633,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_ael(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uu,Uua))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),Uua)) ) ) ).

% ATP.lambda_633
tff(fact_8814_ATP_Olambda__634,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_aht(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uu,Uua))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),Uua)) ) ) ).

% ATP.lambda_634
tff(fact_8815_ATP_Olambda__635,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_aas(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uub)))),aa(nat,real,power_power(real,Uua),Uub)) ) ).

% ATP.lambda_635
tff(fact_8816_ATP_Olambda__636,axiom,
    ! [Uu: real,Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_iy(real,fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,Uua,Uub)),semiring_char_0_fact(real,Uub))),aa(nat,real,power_power(real,Uu),Uub)) ) ).

% ATP.lambda_636
tff(fact_8817_ATP_Olambda__637,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_pk(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),one_one(nat)) )
        & ( groups8242544230860333062m_list(nat,Uub) = Uua ) ) ) ).

% ATP.lambda_637
tff(fact_8818_ATP_Olambda__638,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_df(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),aa(nat,A,Uu,Uub))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(nat,nat,suc,zero_zero(nat))))) ) ) ).

% ATP.lambda_638
tff(fact_8819_ATP_Olambda__639,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_sn(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),Uua)),aa(list(A),nat,size_size(list(A)),Uub))
        | ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(list(A),nat,size_size(list(A)),Uub) )
          & aa(set(product_prod(list(A),list(A))),$o,member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Uua),Uub)),lex(A,Uu)) ) ) ) ).

% ATP.lambda_639
tff(fact_8820_ATP_Olambda__640,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_asy(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(list(A),nat,size_size(list(A)),Uub) )
        & ? [Xys2: list(A),X3: A,Y: A,Xs6: list(A),Ys7: list(A)] :
            ( ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),cons(A,X3),Xs6)) )
            & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),cons(A,Y),Ys7)) )
            & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y)),Uu) ) ) ) ).

% ATP.lambda_640
tff(fact_8821_ATP_Olambda__641,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_pl(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),groups8242544230860333062m_list(nat,Uub)),one_one(nat)) = Uua ) ) ) ).

% ATP.lambda_641
tff(fact_8822_ATP_Olambda__642,axiom,
    ! [A: $tType,Uu: nat,Uua: set(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(set(A),fun(list(A),$o),aTP_Lamp_pu(nat,fun(set(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & distinct(A,Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uua) ) ) ).

% ATP.lambda_642
tff(fact_8823_ATP_Olambda__643,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_pt(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & distinct(A,Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu) ) ) ).

% ATP.lambda_643
tff(fact_8824_ATP_Olambda__644,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_bl(nat,fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),aa(list(A),set(A),set2(A),Uua)) ) ) ).

% ATP.lambda_644
tff(fact_8825_ATP_Olambda__645,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_ns(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Uub)),Uua) ) ) ).

% ATP.lambda_645
tff(fact_8826_ATP_Olambda__646,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_nh(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)
        & ( aa(list(A),nat,size_size(list(A)),Uub) = Uua ) ) ) ).

% ATP.lambda_646
tff(fact_8827_ATP_Olambda__647,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_pj(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( groups8242544230860333062m_list(nat,Uub) = Uua ) ) ) ).

% ATP.lambda_647
tff(fact_8828_ATP_Olambda__648,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_aao(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,diffs(A,Uu)),Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_648
tff(fact_8829_ATP_Olambda__649,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_pm(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(set(nat),$o,member(nat,aa(nat,nat,suc,Uub)),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uua) ) ) ).

% ATP.lambda_649
tff(fact_8830_ATP_Olambda__650,axiom,
    ! [A: $tType,Uu: set(list(A)),Uua: list(A),Uub: A] :
      ( aa(A,$o,aa(list(A),fun(A,$o),aTP_Lamp_awq(set(list(A)),fun(list(A),fun(A,$o)),Uu),Uua),Uub)
    <=> aa(set(list(A)),$o,member(list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Uua),aa(list(A),list(A),cons(A,Uub),nil(A)))),Uu) ) ).

% ATP.lambda_650
tff(fact_8831_ATP_Olambda__651,axiom,
    ! [Uu: nat,Uua: nat,Uub: set(nat)] :
      ( aa(set(nat),$o,aa(nat,fun(set(nat),$o),aTP_Lamp_qj(nat,fun(nat,fun(set(nat),$o)),Uu),Uua),Uub)
    <=> ( aa(set(set(nat)),$o,member(set(nat),Uub),pow2(nat,set_or7035219750837199246ssThan(nat,zero_zero(nat),Uu)))
        & ( finite_card(nat,Uub) = Uua ) ) ) ).

% ATP.lambda_651
tff(fact_8832_ATP_Olambda__652,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: list(A),Uub: nat] :
      ( aa(nat,$o,aa(list(A),fun(nat,$o),aTP_Lamp_wg(fun(A,$o),fun(list(A),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(list(A),nat,size_size(list(A)),Uua))
        & aa(A,$o,Uu,aa(nat,A,nth(A,Uua),Uub)) ) ) ).

% ATP.lambda_652
tff(fact_8833_ATP_Olambda__653,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: list(A),Uub: A] :
      ( aa(A,$o,aa(list(A),fun(A,$o),aTP_Lamp_vy(fun(A,$o),fun(list(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,member(A,Uub),aa(list(A),set(A),set2(A),Uua))
        & aa(A,$o,Uu,Uub) ) ) ).

% ATP.lambda_653
tff(fact_8834_ATP_Olambda__654,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: A,Uub: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aa(A,fun(product_prod(A,B),$o),aTP_Lamp_yc(fun(A,option(B)),fun(A,fun(product_prod(A,B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(product_prod(A,B)),$o,member(product_prod(A,B),Uub),graph(A,B,Uu))
        & ( aa(product_prod(A,B),A,product_fst(A,B),Uub) != Uua ) ) ) ).

% ATP.lambda_654
tff(fact_8835_ATP_Olambda__655,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_mc(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uub))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_655
tff(fact_8836_ATP_Olambda__656,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: set(A)] :
      ( aa(set(A),$o,aa(nat,fun(set(A),$o),aTP_Lamp_pg(set(A),fun(nat,fun(set(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uub),Uu)
        & ( finite_card(A,Uub) = Uua ) ) ) ).

% ATP.lambda_656
tff(fact_8837_ATP_Olambda__657,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_pn(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(set(nat),$o,member(nat,Uub),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_657
tff(fact_8838_ATP_Olambda__658,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_de(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uu),Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_658
tff(fact_8839_ATP_Olambda__659,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uu),Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_659
tff(fact_8840_ATP_Olambda__660,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_dl(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uua),Uub)),aa(nat,A,power_power(A,Uu),Uub)) ) ) ).

% ATP.lambda_660
tff(fact_8841_ATP_Olambda__661,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_fy(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub)) ) ).

% ATP.lambda_661
tff(fact_8842_ATP_Olambda__662,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_bai(set(A),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,member(A,Uub),Uu)
        | aa(set(A),$o,member(A,Uub),Uua) ) ) ).

% ATP.lambda_662
tff(fact_8843_ATP_Olambda__663,axiom,
    ! [A: $tType,Uu: A,Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_pe(A,fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( ( Uub = Uu )
        | aa(set(A),$o,member(A,Uub),Uua) ) ) ).

% ATP.lambda_663
tff(fact_8844_ATP_Olambda__664,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_bh(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uua)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uua),Uub) ) ) ).

% ATP.lambda_664
tff(fact_8845_ATP_Olambda__665,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_on(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uub),Uua) ) ) ).

% ATP.lambda_665
tff(fact_8846_ATP_Olambda__666,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_bk(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uua),Uub) ) ) ).

% ATP.lambda_666
tff(fact_8847_ATP_Olambda__667,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_op(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uub),Uua) ) ) ).

% ATP.lambda_667
tff(fact_8848_ATP_Olambda__668,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_oq(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uub),Uua) ) ) ).

% ATP.lambda_668
tff(fact_8849_ATP_Olambda__669,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_oo(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uub),Uua) ) ) ).

% ATP.lambda_669
tff(fact_8850_ATP_Olambda__670,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_anc(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uub),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uub),Uu) ) ) ).

% ATP.lambda_670
tff(fact_8851_ATP_Olambda__671,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_apk(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uub),Uua)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uub),Uu) ) ) ).

% ATP.lambda_671
tff(fact_8852_ATP_Olambda__672,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(set(A)),Uua: A,Uub: set(A)] :
          ( aa(set(A),$o,aa(A,fun(set(A),$o),aTP_Lamp_atw(set(set(A)),fun(A,fun(set(A),$o)),Uu),Uua),Uub)
        <=> ( aa(set(set(A)),$o,member(set(A),Uub),Uu)
            & aa(set(A),$o,member(A,Uua),Uub) ) ) ) ).

% ATP.lambda_672
tff(fact_8853_ATP_Olambda__673,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_st(set(A),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,member(A,Uub),Uu)
        & aa(set(A),$o,member(A,Uub),Uua) ) ) ).

% ATP.lambda_673
tff(fact_8854_ATP_Olambda__674,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(A,real),Uub: A] :
          ( aa(A,$o,aa(fun(A,real),fun(A,$o),aTP_Lamp_avv(set(A),fun(fun(A,real),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(A),$o,member(A,Uub),Uu)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,Uua,Uub)) ) ) ) ).

% ATP.lambda_674
tff(fact_8855_ATP_Olambda__675,axiom,
    ! [A: $tType,Uu: list(A),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_oz(list(A),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,count_list(A,Uu),Uub)),aa(A,nat,Uua,Uub)) ) ).

% ATP.lambda_675
tff(fact_8856_ATP_Olambda__676,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: list(A),Uub: A] : ( aa(A,nat,aa(list(A),fun(A,nat),aTP_Lamp_pr(fun(A,nat),fun(list(A),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,count_list(A,Uua),Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_676
tff(fact_8857_ATP_Olambda__677,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_aoi(fun(A,$o),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,member(A,Uub),Uua)
       => aa(A,$o,Uu,Uub) ) ) ).

% ATP.lambda_677
tff(fact_8858_ATP_Olambda__678,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_as(set(A),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,member(A,Uub),Uu)
        & aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_678
tff(fact_8859_ATP_Olambda__679,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_bbe(fun(A,$o),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,member(A,Uub),Uua)
        & aa(A,$o,Uu,Uub) ) ) ).

% ATP.lambda_679
tff(fact_8860_ATP_Olambda__680,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_px(A,fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( ( Uu = Uub )
        & aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_680
tff(fact_8861_ATP_Olambda__681,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ys(fun(A,$o),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> ( ( Uua = Uub )
        & aa(A,$o,Uu,Uua) ) ) ).

% ATP.lambda_681
tff(fact_8862_ATP_Olambda__682,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_pw(A,fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( ( Uub = Uu )
        & aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_682
tff(fact_8863_ATP_Olambda__683,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_nt(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(A),$o,member(A,Uub),Uu)
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_683
tff(fact_8864_ATP_Olambda__684,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_qf(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(A),$o,member(A,Uub),Uu)
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_684
tff(fact_8865_ATP_Olambda__685,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_nv(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(A),$o,member(A,Uub),Uu)
            & ( aa(A,B,Uua,Uub) != one_one(B) ) ) ) ) ).

% ATP.lambda_685
tff(fact_8866_ATP_Olambda__686,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_qg(fun(B,A),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uua)
            & ( aa(B,A,Uu,Uub) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_686
tff(fact_8867_ATP_Olambda__687,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_sl(fun(B,A),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(set(B),$o,member(B,Uub),Uua)
            & ( aa(B,A,Uu,Uub) != one_one(A) ) ) ) ) ).

% ATP.lambda_687
tff(fact_8868_ATP_Olambda__688,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_parity(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_pa(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(A),$o,member(A,Uub),Uu)
            & ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(A,B,Uua,Uub)) ) ) ) ).

% ATP.lambda_688
tff(fact_8869_ATP_Olambda__689,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_av(set(A),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,member(A,Uub),Uu)
        & ~ aa(set(A),$o,member(A,Uub),Uua) ) ) ).

% ATP.lambda_689
tff(fact_8870_ATP_Olambda__690,axiom,
    ! [A: $tType,B: $tType,Uu: list(product_prod(A,B)),Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_qi(list(product_prod(A,B)),fun(A,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(A,option(B),map_of(A,B,Uu),Uua) = aa(B,option(B),some(B),Uub) ) ) ).

% ATP.lambda_690
tff(fact_8871_ATP_Olambda__691,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ana(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uu) ) ).

% ATP.lambda_691
tff(fact_8872_ATP_Olambda__692,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_hy(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu) ) ).

% ATP.lambda_692
tff(fact_8873_ATP_Olambda__693,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_alo(A,fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_693
tff(fact_8874_ATP_Olambda__694,axiom,
    ! [Uu: real,Uua: complex,Uub: complex] :
      ( aa(complex,$o,aa(complex,fun(complex,$o),aTP_Lamp_awx(real,fun(complex,fun(complex,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(complex,Uua,Uub)),Uu) ) ).

% ATP.lambda_694
tff(fact_8875_ATP_Olambda__695,axiom,
    ! [Uu: real,Uua: real,Uub: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aTP_Lamp_awv(real,fun(real,fun(real,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(real,Uua,Uub)),Uu) ) ).

% ATP.lambda_695
tff(fact_8876_ATP_Olambda__696,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [Uu: real,Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_awr(real,fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_696
tff(fact_8877_ATP_Olambda__697,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: real,Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_alx(real,fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_697
tff(fact_8878_ATP_Olambda__698,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_ami(A,fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_698
tff(fact_8879_ATP_Olambda__699,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_iv(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu) ) ).

% ATP.lambda_699
tff(fact_8880_ATP_Olambda__700,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_sa(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_700
tff(fact_8881_ATP_Olambda__701,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_ry(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_701
tff(fact_8882_ATP_Olambda__702,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_rz(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_702
tff(fact_8883_ATP_Olambda__703,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_rx(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_703
tff(fact_8884_ATP_Olambda__704,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(product_prod(A,B)),fun(A,fun(B,$o)),aTP_Lamp_ee(set(product_prod(A,B)),fun(A,fun(B,$o))),Uu),Uua),Uub)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub)),Uu) ) ).

% ATP.lambda_704
tff(fact_8885_ATP_Olambda__705,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_axf(set(product_prod(A,A)),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uub)),Uu) ) ).

% ATP.lambda_705
tff(fact_8886_ATP_Olambda__706,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_uw(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Uu),Uub)),Uua) ) ).

% ATP.lambda_706
tff(fact_8887_ATP_Olambda__707,axiom,
    ! [Uu: nat,Uua: complex,Uub: complex] :
      ( aa(complex,$o,aa(complex,fun(complex,$o),aTP_Lamp_ht(nat,fun(complex,fun(complex,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,complex,power_power(complex,Uub),Uu) = Uua ) ) ).

% ATP.lambda_707
tff(fact_8888_ATP_Olambda__708,axiom,
    ! [Uu: complex,Uua: nat,Uub: complex] :
      ( aa(complex,$o,aa(nat,fun(complex,$o),aTP_Lamp_ln(complex,fun(nat,fun(complex,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,complex,power_power(complex,Uub),Uua) = Uu ) ) ).

% ATP.lambda_708
tff(fact_8889_ATP_Olambda__709,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Uu: A,Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_nz(A,fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(A),$o,member(A,Uub),ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uu),Uub)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uub),Uua) ) ) ) ).

% ATP.lambda_709
tff(fact_8890_ATP_Olambda__710,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cn(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,suc,Uub))),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_710
tff(fact_8891_ATP_Olambda__711,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cm(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,suc,Uub))),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_711
tff(fact_8892_ATP_Olambda__712,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,$o),Uua: fun(B,$o),Uub: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aa(fun(B,$o),fun(product_prod(A,B),$o),aTP_Lamp_axo(fun(A,$o),fun(fun(B,$o),fun(product_prod(A,B),$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uu,aa(product_prod(A,B),A,product_fst(A,B),Uub))
        & aa(B,$o,Uua,aa(product_prod(A,B),B,product_snd(A,B),Uub)) ) ) ).

% ATP.lambda_712
tff(fact_8893_ATP_Olambda__713,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,int),Uub: nat] : ( aa(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_ako(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),aa(real,real,aa(real,fun(real,real),times_times(real),ring_1_of_int(real,aa(nat,int,Uua,Uub))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) ) ).

% ATP.lambda_713
tff(fact_8894_ATP_Olambda__714,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_aat(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,power_power(real,Uua),aa(nat,nat,suc,Uub))) ) ).

% ATP.lambda_714
tff(fact_8895_ATP_Olambda__715,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_cq(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,power_power(real,Uua),Uub)) ) ).

% ATP.lambda_715
tff(fact_8896_ATP_Olambda__716,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_gl(fun(nat,nat),fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uub)),aa(nat,nat,power_power(nat,Uua),Uub)) ) ).

% ATP.lambda_716
tff(fact_8897_ATP_Olambda__717,axiom,
    ! [B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(nat,B),Uua: B,Uub: nat] : ( aa(nat,B,aa(B,fun(nat,B),aTP_Lamp_aii(fun(nat,B),fun(B,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uub)),aa(nat,B,power_power(B,Uua),Uub)) ) ) ).

% ATP.lambda_717
tff(fact_8898_ATP_Olambda__718,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_fs(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_718
tff(fact_8899_ATP_Olambda__719,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_719
tff(fact_8900_ATP_Olambda__720,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_720
tff(fact_8901_ATP_Olambda__721,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_dj(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_721
tff(fact_8902_ATP_Olambda__722,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_fw(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_722
tff(fact_8903_ATP_Olambda__723,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_gg(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub)) ) ) ).

% ATP.lambda_723
tff(fact_8904_ATP_Olambda__724,axiom,
    ! [Uu: fun(nat,$o),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_nr(fun(nat,$o),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,Uu,Uub)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uua) ) ) ).

% ATP.lambda_724
tff(fact_8905_ATP_Olambda__725,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abj(fun(A,real),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_725
tff(fact_8906_ATP_Olambda__726,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_auu(fun(A,real),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_726
tff(fact_8907_ATP_Olambda__727,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aeh(fun(A,real),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_727
tff(fact_8908_ATP_Olambda__728,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,real),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afs(fun(A,real),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_728
tff(fact_8909_ATP_Olambda__729,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,real,aa(fun(A,B),fun(A,real),aTP_Lamp_avr(fun(A,B),fun(fun(A,B),fun(A,real)),Uu),Uua),Uub) = real_V557655796197034286t_dist(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_729
tff(fact_8910_ATP_Olambda__730,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,real,aa(fun(A,B),fun(A,real),aTP_Lamp_alp(fun(A,B),fun(fun(A,B),fun(A,real)),Uu),Uua),Uub) = real_V557655796197034286t_dist(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_730
tff(fact_8911_ATP_Olambda__731,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,real,aa(fun(A,B),fun(A,real),aTP_Lamp_alr(fun(A,B),fun(fun(A,B),fun(A,real)),Uu),Uua),Uub) = real_V557655796197034286t_dist(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_731
tff(fact_8912_ATP_Olambda__732,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_qd(fun(B,A),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,Uu,Uua)),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_732
tff(fact_8913_ATP_Olambda__733,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_ayt(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_733
tff(fact_8914_ATP_Olambda__734,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] :
      ( aa(A,$o,aa(fun(A,real),fun(A,$o),aTP_Lamp_apj(fun(A,real),fun(fun(A,real),fun(A,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_734
tff(fact_8915_ATP_Olambda__735,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_aov(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_735
tff(fact_8916_ATP_Olambda__736,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_apa(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_736
tff(fact_8917_ATP_Olambda__737,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_apx(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_737
tff(fact_8918_ATP_Olambda__738,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aqt(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,Uu,Uub)),aa(real,real,Uua,Uub)) ) ).

% ATP.lambda_738
tff(fact_8919_ATP_Olambda__739,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kp(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_739
tff(fact_8920_ATP_Olambda__740,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_act(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_740
tff(fact_8921_ATP_Olambda__741,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acg(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_741
tff(fact_8922_ATP_Olambda__742,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_avl(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_742
tff(fact_8923_ATP_Olambda__743,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_aaa(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_743
tff(fact_8924_ATP_Olambda__744,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahu(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_744
tff(fact_8925_ATP_Olambda__745,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amy(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_745
tff(fact_8926_ATP_Olambda__746,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aqm(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_746
tff(fact_8927_ATP_Olambda__747,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afb(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_747
tff(fact_8928_ATP_Olambda__748,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_ano(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,Uua,Uub)),aa(real,real,Uu,Uub)) ) ).

% ATP.lambda_748
tff(fact_8929_ATP_Olambda__749,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_auf(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_749
tff(fact_8930_ATP_Olambda__750,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aTP_Lamp_mg(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uub)),aa(nat,nat,Uua,Uub)) ) ).

% ATP.lambda_750
tff(fact_8931_ATP_Olambda__751,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_arg(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_751
tff(fact_8932_ATP_Olambda__752,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_mf(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_752
tff(fact_8933_ATP_Olambda__753,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kr(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_753
tff(fact_8934_ATP_Olambda__754,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aby(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_754
tff(fact_8935_ATP_Olambda__755,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_auq(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_755
tff(fact_8936_ATP_Olambda__756,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4211221413907600880p_mult(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aup(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_756
tff(fact_8937_ATP_Olambda__757,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_zr(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_757
tff(fact_8938_ATP_Olambda__758,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afl(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_758
tff(fact_8939_ATP_Olambda__759,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4211221413907600880p_mult(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afk(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_759
tff(fact_8940_ATP_Olambda__760,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amp(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_760
tff(fact_8941_ATP_Olambda__761,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahb(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_761
tff(fact_8942_ATP_Olambda__762,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aql(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_762
tff(fact_8943_ATP_Olambda__763,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afh(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_763
tff(fact_8944_ATP_Olambda__764,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afe(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_764
tff(fact_8945_ATP_Olambda__765,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sm(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_765
tff(fact_8946_ATP_Olambda__766,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ane(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uub)),aa(A,real,Uu,Uub)) ) ).

% ATP.lambda_766
tff(fact_8947_ATP_Olambda__767,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_hn(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_767
tff(fact_8948_ATP_Olambda__768,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_ajo(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),aa(nat,real,Uua,Uub)) ) ).

% ATP.lambda_768
tff(fact_8949_ATP_Olambda__769,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ce(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_769
tff(fact_8950_ATP_Olambda__770,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ig(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_770
tff(fact_8951_ATP_Olambda__771,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abn(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_771
tff(fact_8952_ATP_Olambda__772,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_avk(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_772
tff(fact_8953_ATP_Olambda__773,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_zz(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_773
tff(fact_8954_ATP_Olambda__774,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahv(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_774
tff(fact_8955_ATP_Olambda__775,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahf(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_775
tff(fact_8956_ATP_Olambda__776,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahj(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_776
tff(fact_8957_ATP_Olambda__777,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahg(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_777
tff(fact_8958_ATP_Olambda__778,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_og(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uua,Uub)),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_778
tff(fact_8959_ATP_Olambda__779,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_io(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ) ).

% ATP.lambda_779
tff(fact_8960_ATP_Olambda__780,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_hr(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_780
tff(fact_8961_ATP_Olambda__781,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ahi(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_781
tff(fact_8962_ATP_Olambda__782,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1898628316856586783d_mult(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,nat),Uub: A] : ( aa(A,B,aa(fun(A,nat),fun(A,B),aTP_Lamp_aux(fun(A,B),fun(fun(A,nat),fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ) ).

% ATP.lambda_782
tff(fact_8963_ATP_Olambda__783,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1898628316856586783d_mult(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,nat),Uub: A] : ( aa(A,B,aa(fun(A,nat),fun(A,B),aTP_Lamp_afx(fun(A,B),fun(fun(A,nat),fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ) ).

% ATP.lambda_783
tff(fact_8964_ATP_Olambda__784,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,nat),Uub: A] : ( aa(A,B,aa(fun(A,nat),fun(A,B),aTP_Lamp_afy(fun(A,B),fun(fun(A,nat),fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ) ).

% ATP.lambda_784
tff(fact_8965_ATP_Olambda__785,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_bar(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_785
tff(fact_8966_ATP_Olambda__786,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_bas(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_786
tff(fact_8967_ATP_Olambda__787,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_baq(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_787
tff(fact_8968_ATP_Olambda__788,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_auk(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_788
tff(fact_8969_ATP_Olambda__789,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aew(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_789
tff(fact_8970_ATP_Olambda__790,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aex(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_790
tff(fact_8971_ATP_Olambda__791,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,complex,aa(fun(A,real),fun(A,complex),aTP_Lamp_agh(fun(A,real),fun(fun(A,real),fun(A,complex)),Uu),Uua),Uub) = complex2(aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_791
tff(fact_8972_ATP_Olambda__792,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_bag(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(B,set(A),Uu,Uub)),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_792
tff(fact_8973_ATP_Olambda__793,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bah(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_793
tff(fact_8974_ATP_Olambda__794,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_azw(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_794
tff(fact_8975_ATP_Olambda__795,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_bal(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_795
tff(fact_8976_ATP_Olambda__796,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_vg(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),Uu,Uub)),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_796
tff(fact_8977_ATP_Olambda__797,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_vf(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_797
tff(fact_8978_ATP_Olambda__798,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_aua(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_798
tff(fact_8979_ATP_Olambda__799,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_avz(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_799
tff(fact_8980_ATP_Olambda__800,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_800
tff(fact_8981_ATP_Olambda__801,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_if(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_801
tff(fact_8982_ATP_Olambda__802,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abv(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_802
tff(fact_8983_ATP_Olambda__803,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aur(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_803
tff(fact_8984_ATP_Olambda__804,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_zu(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_804
tff(fact_8985_ATP_Olambda__805,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afo(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_805
tff(fact_8986_ATP_Olambda__806,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_amw(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_806
tff(fact_8987_ATP_Olambda__807,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aqc(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_807
tff(fact_8988_ATP_Olambda__808,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afn(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_808
tff(fact_8989_ATP_Olambda__809,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qh(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_809
tff(fact_8990_ATP_Olambda__810,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aaq(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = powr(real,aa(real,real,Uu,Uub),aa(real,real,Uua,Uub)) ) ).

% ATP.lambda_810
tff(fact_8991_ATP_Olambda__811,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_acz(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_811
tff(fact_8992_ATP_Olambda__812,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_auh(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_812
tff(fact_8993_ATP_Olambda__813,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ajb(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_813
tff(fact_8994_ATP_Olambda__814,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_agm(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_814
tff(fact_8995_ATP_Olambda__815,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_avw(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_815
tff(fact_8996_ATP_Olambda__816,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ajw(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_816
tff(fact_8997_ATP_Olambda__817,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_aeq(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_817
tff(fact_8998_ATP_Olambda__818,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,C),Uub: A] : ( aa(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_auc(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uub)),aa(A,C,Uua,Uub)) ) ) ).

% ATP.lambda_818
tff(fact_8999_ATP_Olambda__819,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,C),Uub: A] : ( aa(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_adq(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uub)),aa(A,C,Uua,Uub)) ) ) ).

% ATP.lambda_819
tff(fact_9000_ATP_Olambda__820,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,C),Uub: A] : ( aa(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_aep(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uub)),aa(A,C,Uua,Uub)) ) ) ).

% ATP.lambda_820
tff(fact_9001_ATP_Olambda__821,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,C),Uub: A] : ( aa(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_axl(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uub)),aa(A,C,Uua,Uub)) ) ).

% ATP.lambda_821
tff(fact_9002_ATP_Olambda__822,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
          ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ays(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,$o,Uu,Uub)
           => aa(A,$o,Uua,Uub) ) ) ) ).

% ATP.lambda_822
tff(fact_9003_ATP_Olambda__823,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aos(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uu,Uub)
       => aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_823
tff(fact_9004_ATP_Olambda__824,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,B)),Uua: fun(A,nat),Uub: A] : ( aa(A,fun(B,B),aa(fun(A,nat),fun(A,fun(B,B)),aTP_Lamp_bbo(fun(A,fun(B,B)),fun(fun(A,nat),fun(A,fun(B,B))),Uu),Uua),Uub) = aa(fun(B,B),fun(B,B),aa(nat,fun(fun(B,B),fun(B,B)),compow(fun(B,B)),aa(A,nat,Uua,Uub)),aa(A,fun(B,B),Uu,Uub)) ) ).

% ATP.lambda_824
tff(fact_9005_ATP_Olambda__825,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
          ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_alg(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,$o,Uu,Uub)
            | aa(A,$o,Uua,Uub) ) ) ) ).

% ATP.lambda_825
tff(fact_9006_ATP_Olambda__826,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_om(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uu,Uub)
        | aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_826
tff(fact_9007_ATP_Olambda__827,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_si(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_827
tff(fact_9008_ATP_Olambda__828,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
          ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_alh(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,$o,Uu,Uub)
            & aa(A,$o,Uua,Uub) ) ) ) ).

% ATP.lambda_828
tff(fact_9009_ATP_Olambda__829,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ol(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uu,Uub)
        & aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_829
tff(fact_9010_ATP_Olambda__830,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_vx(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uua,Uub)
        & aa(A,$o,Uu,Uub) ) ) ).

% ATP.lambda_830
tff(fact_9011_ATP_Olambda__831,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_azg(fun(A,B),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,B,Uu,Uua) = aa(A,B,Uu,Uub) ) ) ).

% ATP.lambda_831
tff(fact_9012_ATP_Olambda__832,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_ara(fun(nat,A),fun(fun(nat,A),fun(nat,$o)),Uu),Uua),Uub)
        <=> ( aa(nat,A,Uu,Uub) = aa(nat,A,Uua,Uub) ) ) ) ).

% ATP.lambda_832
tff(fact_9013_ATP_Olambda__833,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(B,A),Uub: B] :
      ( aa(B,$o,aa(fun(B,A),fun(B,$o),aTP_Lamp_any(fun(B,A),fun(fun(B,A),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,A,Uu,Uub) = aa(B,A,Uua,Uub) ) ) ).

% ATP.lambda_833
tff(fact_9014_ATP_Olambda__834,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_aok(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_834
tff(fact_9015_ATP_Olambda__835,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topological_t2_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_ayu(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_835
tff(fact_9016_ATP_Olambda__836,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] :
          ( aa(A,$o,aa(fun(A,A),fun(A,$o),aTP_Lamp_aoo(fun(A,A),fun(fun(A,A),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,A,Uu,Uub) = aa(A,A,Uua,Uub) ) ) ) ).

% ATP.lambda_836
tff(fact_9017_ATP_Olambda__837,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_apt(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_837
tff(fact_9018_ATP_Olambda__838,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aot(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uu,Uub)
      <=> aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_838
tff(fact_9019_ATP_Olambda__839,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_aob(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_839
tff(fact_9020_ATP_Olambda__840,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
      ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_aog(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ).

% ATP.lambda_840
tff(fact_9021_ATP_Olambda__841,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_yj(A,fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uua,Uu) = aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_841
tff(fact_9022_ATP_Olambda__842,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: A] : ( aa(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_ss(fun(A,B),fun(fun(A,$o),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa($o,B,zero_neq_one_of_bool(B),aa(A,$o,Uua,Uub))) ) ) ).

% ATP.lambda_842
tff(fact_9023_ATP_Olambda__843,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aqs(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),ring_1_of_int(B,archimedean_ceiling(B,Uua))) ) ) ).

% ATP.lambda_843
tff(fact_9024_ATP_Olambda__844,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,$o)),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_awf(fun(A,fun(A,$o)),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uua,Uub)
        & ! [Y: A] :
            ( aa(A,$o,Uua,Y)
           => aa(A,$o,aa(A,fun(A,$o),Uu,Uub),Y) ) ) ) ).

% ATP.lambda_844
tff(fact_9025_ATP_Olambda__845,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_aag(fun(A,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,aa(A,A,Uu,Uub)),aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_845
tff(fact_9026_ATP_Olambda__846,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_aut(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = comm_s3205402744901411588hammer(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_846
tff(fact_9027_ATP_Olambda__847,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,real),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_el(fun(nat,real),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_847
tff(fact_9028_ATP_Olambda__848,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: fun(B,real),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_fj(fun(B,real),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(B,real,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_848
tff(fact_9029_ATP_Olambda__849,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,real),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_abu(fun(A,real),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_849
tff(fact_9030_ATP_Olambda__850,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(C),Uub: B] : ( aa(B,A,aa(set(C),fun(B,A),aTP_Lamp_ks(fun(B,fun(C,A)),fun(set(C),fun(B,A)),Uu),Uua),Uub) = groups7121269368397514597t_prod(C,A,aa(B,fun(C,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_850
tff(fact_9031_ATP_Olambda__851,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [Uu: set(A),Uua: fun(B,fun(A,C)),Uub: B] : ( aa(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_agy(set(A),fun(fun(B,fun(A,C)),fun(B,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),Uua,Uub),Uu) ) ) ).

% ATP.lambda_851
tff(fact_9032_ATP_Olambda__852,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(C),Uub: B] : ( aa(B,A,aa(set(C),fun(B,A),aTP_Lamp_hu(fun(B,fun(C,A)),fun(set(C),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(B,fun(C,A),Uu,Uub)),Uua) ) ) ).

% ATP.lambda_852
tff(fact_9033_ATP_Olambda__853,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: set(A),Uua: fun(B,fun(A,B)),Uub: B] : ( aa(B,B,aa(fun(B,fun(A,B)),fun(B,B),aTP_Lamp_aaf(set(A),fun(fun(B,fun(A,B)),fun(B,B)),Uu),Uua),Uub) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(B,fun(A,B),Uua,Uub)),Uu) ) ) ).

% ATP.lambda_853
tff(fact_9034_ATP_Olambda__854,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: set(A),Uua: fun(B,fun(A,C)),Uub: B] : ( aa(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_ahl(set(A),fun(fun(B,fun(A,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),Uua,Uub)),Uu) ) ) ).

% ATP.lambda_854
tff(fact_9035_ATP_Olambda__855,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,real,aa(B,fun(A,real),aTP_Lamp_alt(fun(A,B),fun(B,fun(A,real)),Uu),Uua),Uub) = real_V557655796197034286t_dist(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_855
tff(fact_9036_ATP_Olambda__856,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [Uu: fun(nat,set(A)),Uua: set(A),Uub: nat] :
          ( aa(nat,$o,aa(set(A),fun(nat,$o),aTP_Lamp_arh(fun(nat,set(A)),fun(set(A),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),Uu,Uub)),Uua) ) ) ).

% ATP.lambda_856
tff(fact_9037_ATP_Olambda__857,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ni(fun(nat,nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,Uu,Uub)),Uua) ) ).

% ATP.lambda_857
tff(fact_9038_ATP_Olambda__858,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] :
      ( aa(B,$o,aa(set(A),fun(B,$o),aTP_Lamp_tg(fun(B,set(A)),fun(set(A),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(B,set(A),Uu,Uub)),Uua) ) ).

% ATP.lambda_858
tff(fact_9039_ATP_Olambda__859,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apv(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_859
tff(fact_9040_ATP_Olambda__860,axiom,
    ! [A: $tType,B: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apu(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_860
tff(fact_9041_ATP_Olambda__861,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apm(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_861
tff(fact_9042_ATP_Olambda__862,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aph(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_862
tff(fact_9043_ATP_Olambda__863,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_fm(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = modulo_modulo(A,aa(B,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_863
tff(fact_9044_ATP_Olambda__864,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bx(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_864
tff(fact_9045_ATP_Olambda__865,axiom,
    ! [B: $tType,A: $tType] :
      ( field(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_ih(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_865
tff(fact_9046_ATP_Olambda__866,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_zo(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_866
tff(fact_9047_ATP_Olambda__867,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_sy(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_867
tff(fact_9048_ATP_Olambda__868,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_afc(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_868
tff(fact_9049_ATP_Olambda__869,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aio(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_869
tff(fact_9050_ATP_Olambda__870,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_aoz(fun(B,A),fun(A,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_870
tff(fact_9051_ATP_Olambda__871,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aox(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_871
tff(fact_9052_ATP_Olambda__872,axiom,
    ! [A: $tType,B: $tType] :
      ( ( dense_linorder(B)
        & no_bot(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_api(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_872
tff(fact_9053_ATP_Olambda__873,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_by(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_873
tff(fact_9054_ATP_Olambda__874,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_id(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_874
tff(fact_9055_ATP_Olambda__875,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_abx(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_875
tff(fact_9056_ATP_Olambda__876,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_atu(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_876
tff(fact_9057_ATP_Olambda__877,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_aun(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_877
tff(fact_9058_ATP_Olambda__878,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_zs(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_878
tff(fact_9059_ATP_Olambda__879,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_afi(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_879
tff(fact_9060_ATP_Olambda__880,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_aha(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_880
tff(fact_9061_ATP_Olambda__881,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_aff(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_881
tff(fact_9062_ATP_Olambda__882,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_acm(real,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_882
tff(fact_9063_ATP_Olambda__883,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cx(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_883
tff(fact_9064_ATP_Olambda__884,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ain(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_884
tff(fact_9065_ATP_Olambda__885,axiom,
    ! [B: $tType,A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ado(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_885
tff(fact_9066_ATP_Olambda__886,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ip(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_886
tff(fact_9067_ATP_Olambda__887,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] : ( aa(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_uo(fun(B,set(A)),fun(set(A),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(B,set(A),Uu,Uub)),Uua) ) ).

% ATP.lambda_887
tff(fact_9068_ATP_Olambda__888,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_ahh(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_888
tff(fact_9069_ATP_Olambda__889,axiom,
    ! [Uu: fun(real,real),Uua: nat,Uub: real] : ( aa(real,real,aa(nat,fun(real,real),aTP_Lamp_aak(fun(real,real),fun(nat,fun(real,real)),Uu),Uua),Uub) = aa(nat,real,power_power(real,aa(real,real,Uu,Uub)),Uua) ) ).

% ATP.lambda_889
tff(fact_9070_ATP_Olambda__890,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,A),Uua: nat,Uub: B] : ( aa(B,A,aa(nat,fun(B,A),aTP_Lamp_kq(fun(B,A),fun(nat,fun(B,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_890
tff(fact_9071_ATP_Olambda__891,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_acp(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_891
tff(fact_9072_ATP_Olambda__892,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_auy(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_892
tff(fact_9073_ATP_Olambda__893,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_aah(fun(A,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_893
tff(fact_9074_ATP_Olambda__894,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_afw(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_894
tff(fact_9075_ATP_Olambda__895,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_aqn(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_895
tff(fact_9076_ATP_Olambda__896,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_aer(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_896
tff(fact_9077_ATP_Olambda__897,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_afz(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_897
tff(fact_9078_ATP_Olambda__898,axiom,
    ! [Uu: nat,Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_amt(nat,fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(nat,real,power_power(real,aa(real,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_898
tff(fact_9079_ATP_Olambda__899,axiom,
    ! [A: $tType,Uu: nat,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_adp(nat,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(nat,real,power_power(real,aa(A,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_899
tff(fact_9080_ATP_Olambda__900,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] : ( aa(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_azx(fun(B,set(A)),fun(set(A),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(B,set(A),Uu,Uub)),Uua) ) ).

% ATP.lambda_900
tff(fact_9081_ATP_Olambda__901,axiom,
    ! [B: $tType,A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_azz(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_901
tff(fact_9082_ATP_Olambda__902,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] : ( aa(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_un(fun(B,set(A)),fun(set(A),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),Uu,Uub)),Uua) ) ).

% ATP.lambda_902
tff(fact_9083_ATP_Olambda__903,axiom,
    ! [B: $tType,A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_tb(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_903
tff(fact_9084_ATP_Olambda__904,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_vj(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_904
tff(fact_9085_ATP_Olambda__905,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_arf(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_905
tff(fact_9086_ATP_Olambda__906,axiom,
    ! [A: $tType,B: $tType] :
      ( linord4140545234300271783up_add(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_anb(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_906
tff(fact_9087_ATP_Olambda__907,axiom,
    ! [Uu: fun(real,real),Uua: real,Uub: real] : ( aa(real,real,aa(real,fun(real,real),aTP_Lamp_aap(fun(real,real),fun(real,fun(real,real)),Uu),Uua),Uub) = powr(real,aa(real,real,Uu,Uub),Uua) ) ).

% ATP.lambda_907
tff(fact_9088_ATP_Olambda__908,axiom,
    ! [A: $tType,Uu: real,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_anf(real,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uua,Uub),Uu) ) ).

% ATP.lambda_908
tff(fact_9089_ATP_Olambda__909,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,filter(B)),Uua: filter(C),Uub: A] : ( aa(A,filter(product_prod(B,C)),aa(filter(C),fun(A,filter(product_prod(B,C))),aTP_Lamp_axw(fun(A,filter(B)),fun(filter(C),fun(A,filter(product_prod(B,C)))),Uu),Uua),Uub) = prod_filter(B,C,aa(A,filter(B),Uu,Uub),Uua) ) ).

% ATP.lambda_909
tff(fact_9090_ATP_Olambda__910,axiom,
    ! [D: $tType,A: $tType,B: $tType,C: $tType,Uu: fun(D,set(product_prod(A,C))),Uua: set(product_prod(C,B)),Uub: D] : ( aa(D,set(product_prod(A,B)),aa(set(product_prod(C,B)),fun(D,set(product_prod(A,B))),aTP_Lamp_ym(fun(D,set(product_prod(A,C))),fun(set(product_prod(C,B)),fun(D,set(product_prod(A,B)))),Uu),Uua),Uub) = relcomp(A,C,B,aa(D,set(product_prod(A,C)),Uu,Uub),Uua) ) ).

% ATP.lambda_910
tff(fact_9091_ATP_Olambda__911,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(B,A),Uua: set(A),Uub: B] :
          ( aa(B,$o,aa(set(A),fun(B,$o),aTP_Lamp_apf(fun(B,A),fun(set(A),fun(B,$o)),Uu),Uua),Uub)
        <=> aa(set(A),$o,member(A,aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_911
tff(fact_9092_ATP_Olambda__912,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,B),Uua: set(B),Uub: A] :
          ( aa(A,$o,aa(set(B),fun(A,$o),aTP_Lamp_apg(fun(A,B),fun(set(B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(set(B),$o,member(B,aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_912
tff(fact_9093_ATP_Olambda__913,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: set(B),Uub: A] :
      ( aa(A,$o,aa(set(B),fun(A,$o),aTP_Lamp_anz(fun(A,B),fun(set(B),fun(A,$o)),Uu),Uua),Uub)
    <=> aa(set(B),$o,member(B,aa(A,B,Uu,Uub)),Uua) ) ).

% ATP.lambda_913
tff(fact_9094_ATP_Olambda__914,axiom,
    ! [C: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(C,A),Uub: C] :
          ( aa(C,$o,aa(fun(C,A),fun(C,$o),aTP_Lamp_avs(set(A),fun(fun(C,A),fun(C,$o)),Uu),Uua),Uub)
        <=> aa(set(A),$o,member(A,aa(C,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_914
tff(fact_9095_ATP_Olambda__915,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(B,A),Uub: B] :
          ( aa(B,$o,aa(fun(B,A),fun(B,$o),aTP_Lamp_aza(set(A),fun(fun(B,A),fun(B,$o)),Uu),Uua),Uub)
        <=> aa(set(A),$o,member(A,aa(B,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_915
tff(fact_9096_ATP_Olambda__916,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,A),Uub: B] :
      ( aa(B,$o,aa(fun(B,A),fun(B,$o),aTP_Lamp_azf(set(A),fun(fun(B,A),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(A),$o,member(A,aa(B,A,Uua,Uub)),Uu) ) ).

% ATP.lambda_916
tff(fact_9097_ATP_Olambda__917,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: $o,Uub: A] :
      ( aa(A,$o,aa($o,fun(A,$o),aTP_Lamp_aor(fun(A,$o),fun($o,fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uu,Uub)
        | (Uua) ) ) ).

% ATP.lambda_917
tff(fact_9098_ATP_Olambda__918,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aof(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) = Uua ) ) ) ).

% ATP.lambda_918
tff(fact_9099_ATP_Olambda__919,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo8865339358273720382pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aod(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) = Uua ) ) ) ).

% ATP.lambda_919
tff(fact_9100_ATP_Olambda__920,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_pf(A,fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( ( Uub != Uu )
       => aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_920
tff(fact_9101_ATP_Olambda__921,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_mb(nat,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub))) ) ) ).

% ATP.lambda_921
tff(fact_9102_ATP_Olambda__922,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: fun(nat,A),Uub: nat] : ( aa(nat,real,aa(fun(nat,A),fun(nat,real),aTP_Lamp_cr(real,fun(fun(nat,A),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uua,Uub))),aa(nat,real,power_power(real,Uu),Uub)) ) ) ).

% ATP.lambda_922
tff(fact_9103_ATP_Olambda__923,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_arj(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uub))),aa(nat,real,Uua,Uub)) ) ) ).

% ATP.lambda_923
tff(fact_9104_ATP_Olambda__924,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [Uu: fun(A,$o),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sr(fun(A,$o),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(A,$o,Uu,Uub))),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_924
tff(fact_9105_ATP_Olambda__925,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,B),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,B),fun(nat,$o),aTP_Lamp_arb(fun(nat,A),fun(fun(nat,B),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uub))),real_V7770717601297561774m_norm(B,aa(nat,B,Uua,Uub))) ) ) ).

% ATP.lambda_925
tff(fact_9106_ATP_Olambda__926,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apz(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ( archim6421214686448440834_floor(B,aa(A,B,Uu,Uub)) = archim6421214686448440834_floor(B,Uua) ) ) ) ).

% ATP.lambda_926
tff(fact_9107_ATP_Olambda__927,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aqa(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ( archimedean_ceiling(B,aa(A,B,Uu,Uub)) = archimedean_ceiling(B,Uua) ) ) ) ).

% ATP.lambda_927
tff(fact_9108_ATP_Olambda__928,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_aqx(fun(A,B),fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uub))),Uua) ) ) ).

% ATP.lambda_928
tff(fact_9109_ATP_Olambda__929,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jf(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)))),aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ) ).

% ATP.lambda_929
tff(fact_9110_ATP_Olambda__930,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aqr(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),ring_1_of_int(B,archim6421214686448440834_floor(B,Uua))),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_930
tff(fact_9111_ATP_Olambda__931,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(list(A),fun(list(A),$o)),Uua: list(A),Uub: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aa(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)),aTP_Lamp_aym(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o))),Uu),Uua),Uub)
        <=> ( ? [Y: A,Ys4: list(A)] :
                ( ( Uua = nil(A) )
                & ( Uub = aa(list(A),list(A),cons(A,Y),Ys4) ) )
            | ? [X3: A,Y: A,Xs3: list(A),Ys4: list(A)] :
                ( ( Uua = aa(list(A),list(A),cons(A,X3),Xs3) )
                & ( Uub = aa(list(A),list(A),cons(A,Y),Ys4) )
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y) )
            | ? [X3: A,Y: A,Xs3: list(A),Ys4: list(A)] :
                ( ( Uua = aa(list(A),list(A),cons(A,X3),Xs3) )
                & ( Uub = aa(list(A),list(A),cons(A,Y),Ys4) )
                & ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y)
                & ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X3)
                & aa(list(A),$o,aa(list(A),fun(list(A),$o),Uu,Xs3),Ys4) ) ) ) ) ).

% ATP.lambda_931
tff(fact_9112_ATP_Olambda__932,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ly(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = groups7121269368397514597t_prod(nat,A,Uu,set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_932
tff(fact_9113_ATP_Olambda__933,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_lz(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_933
tff(fact_9114_ATP_Olambda__934,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_lx(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_934
tff(fact_9115_ATP_Olambda__935,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_kc(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_935
tff(fact_9116_ATP_Olambda__936,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_jw(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_936
tff(fact_9117_ATP_Olambda__937,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_iw(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_937
tff(fact_9118_ATP_Olambda__938,axiom,
    ! [Uu: real,Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_aka(real,fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),Uua),aa(nat,real,power_power(real,Uu),Uub)) ) ).

% ATP.lambda_938
tff(fact_9119_ATP_Olambda__939,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_gq(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_939
tff(fact_9120_ATP_Olambda__940,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_jx(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ).

% ATP.lambda_940
tff(fact_9121_ATP_Olambda__941,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: nat] : ( aa(nat,list(A),aa(list(A),fun(nat,list(A)),aTP_Lamp_xt(A,fun(list(A),fun(nat,list(A))),Uu),Uua),Uub) = aa(list(A),list(A),cons(A,Uu),take(A,Uub,Uua)) ) ).

% ATP.lambda_941
tff(fact_9122_ATP_Olambda__942,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,option(A)),Uua: list(B),Uub: A] : ( aa(A,list(A),aa(list(B),fun(A,list(A)),aTP_Lamp_yt(fun(B,option(A)),fun(list(B),fun(A,list(A))),Uu),Uua),Uub) = aa(list(A),list(A),cons(A,Uub),map_filter(B,A,Uu,Uua)) ) ).

% ATP.lambda_942
tff(fact_9123_ATP_Olambda__943,axiom,
    ! [Uu: real,Uua: real,Uub: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aTP_Lamp_aqf(real,fun(real,fun(real,$o)),Uu),Uua),Uub)
    <=> aa(set(real),$o,member(real,Uub),set_or5935395276787703475ssThan(real,Uu,Uua)) ) ).

% ATP.lambda_943
tff(fact_9124_ATP_Olambda__944,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: real,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fn(real,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_944
tff(fact_9125_ATP_Olambda__945,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: real,Uub: nat] : ( aa(nat,A,aa(real,fun(nat,A),aTP_Lamp_ek(fun(nat,A),fun(real,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,Uua),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_945
tff(fact_9126_ATP_Olambda__946,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: real,Uub: A] : ( aa(A,B,aa(real,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(real,fun(A,B)),Uu),Uua),Uub) = aa(B,B,real_V8093663219630862766scaleR(B,Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_946
tff(fact_9127_ATP_Olambda__947,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: real,Uub: A] : ( aa(A,A,aa(real,fun(A,A),aTP_Lamp_zw(fun(A,A),fun(real,fun(A,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,Uua),aa(A,A,Uu,Uub)) ) ) ).

% ATP.lambda_947
tff(fact_9128_ATP_Olambda__948,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(A,set(B)),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tj(fun(A,set(B)),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = groups7121269368397514597t_prod(B,C,Uua,aa(A,set(B),Uu,Uub)) ) ) ).

% ATP.lambda_948
tff(fact_9129_ATP_Olambda__949,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(A,set(B)),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_ti(fun(A,set(B)),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Uua),aa(A,set(B),Uu,Uub)) ) ) ).

% ATP.lambda_949
tff(fact_9130_ATP_Olambda__950,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: B,Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_apn(B,fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_950
tff(fact_9131_ATP_Olambda__951,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apw(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_951
tff(fact_9132_ATP_Olambda__952,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apo(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_952
tff(fact_9133_ATP_Olambda__953,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apb(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_953
tff(fact_9134_ATP_Olambda__954,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_qn(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_954
tff(fact_9135_ATP_Olambda__955,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_aoy(fun(B,A),fun(A,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_955
tff(fact_9136_ATP_Olambda__956,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_xf(fun(B,A),fun(A,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_956
tff(fact_9137_ATP_Olambda__957,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apc(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_957
tff(fact_9138_ATP_Olambda__958,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aow(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_958
tff(fact_9139_ATP_Olambda__959,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,A),Uua: fun(B,option(C)),Uub: B] : ( aa(B,option(A),aa(fun(B,option(C)),fun(B,option(A)),aTP_Lamp_aye(fun(C,A),fun(fun(B,option(C)),fun(B,option(A))),Uu),Uua),Uub) = aa(option(C),option(A),map_option(C,A,Uu),aa(B,option(C),Uua,Uub)) ) ).

% ATP.lambda_959
tff(fact_9140_ATP_Olambda__960,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: B,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_att(B,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_960
tff(fact_9141_ATP_Olambda__961,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bw(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_961
tff(fact_9142_ATP_Olambda__962,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ie(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_962
tff(fact_9143_ATP_Olambda__963,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cw(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_963
tff(fact_9144_ATP_Olambda__964,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aim(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_964
tff(fact_9145_ATP_Olambda__965,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_adn(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_965
tff(fact_9146_ATP_Olambda__966,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bz(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_966
tff(fact_9147_ATP_Olambda__967,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_abw(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_967
tff(fact_9148_ATP_Olambda__968,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_auo(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_968
tff(fact_9149_ATP_Olambda__969,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_zt(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(A,A,Uu,Uub)) ) ) ).

% ATP.lambda_969
tff(fact_9150_ATP_Olambda__970,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_afj(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_970
tff(fact_9151_ATP_Olambda__971,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_agz(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_971
tff(fact_9152_ATP_Olambda__972,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_afg(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_972
tff(fact_9153_ATP_Olambda__973,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field(B)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_alu(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_973
tff(fact_9154_ATP_Olambda__974,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_vl(set(A),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_974
tff(fact_9155_ATP_Olambda__975,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: fun(B,nat),Uub: B] : ( aa(B,A,aa(fun(B,nat),fun(B,A),aTP_Lamp_ky(A,fun(fun(B,nat),fun(B,A)),Uu),Uua),Uub) = aa(nat,A,power_power(A,Uu),aa(B,nat,Uua,Uub)) ) ) ).

% ATP.lambda_975
tff(fact_9156_ATP_Olambda__976,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [Uu: fun(A,nat),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_aki(fun(A,nat),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,power_power(B,Uua),aa(A,nat,Uu,Uub)) ) ) ).

% ATP.lambda_976
tff(fact_9157_ATP_Olambda__977,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_azy(set(A),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_977
tff(fact_9158_ATP_Olambda__978,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bab(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_978
tff(fact_9159_ATP_Olambda__979,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_um(set(A),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_979
tff(fact_9160_ATP_Olambda__980,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: B,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vk(B,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_980
tff(fact_9161_ATP_Olambda__981,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_td(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_981
tff(fact_9162_ATP_Olambda__982,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [Uu: B,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_afm(B,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_982
tff(fact_9163_ATP_Olambda__983,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_sz(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_983
tff(fact_9164_ATP_Olambda__984,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: filter(B),Uua: fun(A,filter(C)),Uub: A] : ( aa(A,filter(product_prod(B,C)),aa(fun(A,filter(C)),fun(A,filter(product_prod(B,C))),aTP_Lamp_axk(filter(B),fun(fun(A,filter(C)),fun(A,filter(product_prod(B,C)))),Uu),Uua),Uub) = prod_filter(B,C,Uu,aa(A,filter(C),Uua,Uub)) ) ).

% ATP.lambda_984
tff(fact_9165_ATP_Olambda__985,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,B),Uua: A,Uub: C] : ( aa(C,product_prod(A,B),aa(A,fun(C,product_prod(A,B)),aTP_Lamp_ayh(fun(C,B),fun(A,fun(C,product_prod(A,B))),Uu),Uua),Uub) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),aa(C,B,Uu,Uub)) ) ).

% ATP.lambda_985
tff(fact_9166_ATP_Olambda__986,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Uu: set(product_prod(A,C)),Uua: fun(D,set(product_prod(C,B))),Uub: D] : ( aa(D,set(product_prod(A,B)),aa(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(A,B))),aTP_Lamp_yn(set(product_prod(A,C)),fun(fun(D,set(product_prod(C,B))),fun(D,set(product_prod(A,B)))),Uu),Uua),Uub) = relcomp(A,C,B,Uu,aa(D,set(product_prod(C,B)),Uua,Uub)) ) ).

% ATP.lambda_986
tff(fact_9167_ATP_Olambda__987,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_ave(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ) ).

% ATP.lambda_987
tff(fact_9168_ATP_Olambda__988,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_aiy(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ) ).

% ATP.lambda_988
tff(fact_9169_ATP_Olambda__989,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_agk(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ).

% ATP.lambda_989
tff(fact_9170_ATP_Olambda__990,axiom,
    ! [A: $tType,Uu: $o,Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aop($o,fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( (Uu)
       => aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_990
tff(fact_9171_ATP_Olambda__991,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B,Uub: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_tx(fun(B,set(A)),fun(B,fun(A,$o)),Uu),Uua),Uub)
    <=> aa(set(A),$o,member(A,Uub),aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_991
tff(fact_9172_ATP_Olambda__992,axiom,
    ! [B: $tType,A: $tType,Uu: B,Uua: fun(A,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_uj(B,fun(fun(A,set(B)),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),insert(B,Uu),aa(A,set(B),Uua,Uub)) ) ).

% ATP.lambda_992
tff(fact_9173_ATP_Olambda__993,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_tm(A,fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),insert(A,Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_993
tff(fact_9174_ATP_Olambda__994,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,A),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_uh(fun(B,A),fun(fun(C,set(B)),fun(C,set(A))),Uu),Uua),Uub) = aa(set(B),set(A),image(B,A,Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_994
tff(fact_9175_ATP_Olambda__995,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,B),Uua: fun(C,set(A)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_xa(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(A),set(B),image(A,B,Uu),aa(C,set(A),Uua,Uub)) ) ).

% ATP.lambda_995
tff(fact_9176_ATP_Olambda__996,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(A,set(B)),Uua: fun(B,C),Uub: A] : ( aa(A,set(C),aa(fun(B,C),fun(A,set(C)),aTP_Lamp_aty(fun(A,set(B)),fun(fun(B,C),fun(A,set(C))),Uu),Uua),Uub) = aa(set(B),set(C),image(B,C,Uua),aa(A,set(B),Uu,Uub)) ) ) ).

% ATP.lambda_996
tff(fact_9177_ATP_Olambda__997,axiom,
    ! [A: $tType,Uu: $o,Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aoq($o,fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( (Uu)
        | aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_997
tff(fact_9178_ATP_Olambda__998,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: A,Uub: $o] :
      ( aa($o,$o,aa(A,fun($o,$o),aTP_Lamp_bbd(fun(A,$o),fun(A,fun($o,$o)),Uu),Uua),Uub)
    <=> ( (Uub)
        & aa(A,$o,Uu,Uua) ) ) ).

% ATP.lambda_998
tff(fact_9179_ATP_Olambda__999,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(list(A),A),Uua: list(A),Uub: A] :
          ( aa(A,$o,aa(list(A),fun(A,$o),aTP_Lamp_vz(fun(list(A),A),fun(list(A),fun(A,$o)),Uu),Uua),Uub)
        <=> ( Uub = aa(list(A),A,Uu,Uua) ) ) ) ).

% ATP.lambda_999
tff(fact_9180_ATP_Olambda__1000,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_azm(fun(A,B),fun(A,fun(B,$o)),Uu),Uua),Uub)
    <=> ( Uub = aa(A,B,Uu,Uua) ) ) ).

% ATP.lambda_1000
tff(fact_9181_ATP_Olambda__1001,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_li(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_1001
tff(fact_9182_ATP_Olambda__1002,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_aoh(fun(A,B),fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_1002
tff(fact_9183_ATP_Olambda__1003,axiom,
    ! [A: $tType,Uu: list(A),Uua: A,Uub: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_yi(list(A),fun(A,fun(list(A),list(A))),Uu),Uua),Uub) = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Uub),Uu) ) ).

% ATP.lambda_1003
tff(fact_9184_ATP_Olambda__1004,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_la(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_1004
tff(fact_9185_ATP_Olambda__1005,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_in(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_1005
tff(fact_9186_ATP_Olambda__1006,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ajl(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ) ).

% ATP.lambda_1006
tff(fact_9187_ATP_Olambda__1007,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_aja(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_1007
tff(fact_9188_ATP_Olambda__1008,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_adv(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)) ) ) ).

% ATP.lambda_1008
tff(fact_9189_ATP_Olambda__1009,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_zh(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)) ) ) ).

% ATP.lambda_1009
tff(fact_9190_ATP_Olambda__1010,axiom,
    ! [Uu: fun(real,$o),Uua: real,Uub: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aTP_Lamp_aqb(fun(real,$o),fun(real,fun(real,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,Uu,aa(real,real,aa(real,fun(real,real),plus_plus(real),Uub),Uua)) ) ).

% ATP.lambda_1010
tff(fact_9191_ATP_Olambda__1011,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real,Uub: real] : ( aa(real,A,aa(real,fun(real,A),aTP_Lamp_als(fun(real,A),fun(real,fun(real,A)),Uu),Uua),Uub) = aa(real,A,Uu,aa(real,real,aa(real,fun(real,real),plus_plus(real),Uub),Uua)) ) ).

% ATP.lambda_1011
tff(fact_9192_ATP_Olambda__1012,axiom,
    ! [Uu: fun(nat,$o),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_aqz(fun(nat,$o),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_1012
tff(fact_9193_ATP_Olambda__1013,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat,Uub: nat] : ( aa(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_th(fun(nat,set(A)),fun(nat,fun(nat,set(A))),Uu),Uua),Uub) = aa(nat,set(A),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_1013
tff(fact_9194_ATP_Olambda__1014,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_bv(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_1014
tff(fact_9195_ATP_Olambda__1015,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ait(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_1015
tff(fact_9196_ATP_Olambda__1016,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_are(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_1016
tff(fact_9197_ATP_Olambda__1017,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_kz(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_1017
tff(fact_9198_ATP_Olambda__1018,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jm(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_1018
tff(fact_9199_ATP_Olambda__1019,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,$o),Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_apl(fun(A,$o),fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_1019
tff(fact_9200_ATP_Olambda__1020,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_adu(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_1020
tff(fact_9201_ATP_Olambda__1021,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_aic(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_1021
tff(fact_9202_ATP_Olambda__1022,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_zj(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_1022
tff(fact_9203_ATP_Olambda__1023,axiom,
    ! [A: $tType,B: $tType,Uu: fun(product_prod(A,B),$o),Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_ef(fun(product_prod(A,B),$o),fun(A,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(A,B),$o,Uu,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub)) ) ).

% ATP.lambda_1023
tff(fact_9204_ATP_Olambda__1024,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(product_prod(A,B),C),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_bg(fun(product_prod(A,B),C),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(product_prod(A,B),C,Uu,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub)) ) ).

% ATP.lambda_1024
tff(fact_9205_ATP_Olambda__1025,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [Uu: fun(product_prod(A,A),$o),Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_awt(fun(product_prod(A,A),$o),fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(product_prod(A,A),$o,Uu,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uua)) ) ) ).

% ATP.lambda_1025
tff(fact_9206_ATP_Olambda__1026,axiom,
    ! [C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: B,Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_adt(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),Uub)) ) ) ).

% ATP.lambda_1026
tff(fact_9207_ATP_Olambda__1027,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_adw(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uub)) ) ) ).

% ATP.lambda_1027
tff(fact_9208_ATP_Olambda__1028,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cz(nat,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uu)) ) ) ).

% ATP.lambda_1028
tff(fact_9209_ATP_Olambda__1029,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(real,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_acl(fun(real,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,Uu,aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_1029
tff(fact_9210_ATP_Olambda__1030,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [Uu: fun(real,A),Uua: fun(nat,real),Uub: nat] : ( aa(nat,A,aa(fun(nat,real),fun(nat,A),aTP_Lamp_amq(fun(real,A),fun(fun(nat,real),fun(nat,A)),Uu),Uua),Uub) = aa(real,A,Uu,aa(nat,real,Uua,Uub)) ) ) ).

% ATP.lambda_1030
tff(fact_9211_ATP_Olambda__1031,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,A,aa(fun(nat,nat),fun(nat,A),aTP_Lamp_ard(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,Uua,Uub)) ) ) ).

% ATP.lambda_1031
tff(fact_9212_ATP_Olambda__1032,axiom,
    ! [B: $tType,C: $tType,D: $tType,A: $tType,Uu: fun(D,fun(B,C)),Uua: fun(A,D),Uub: A] : ( aa(A,fun(B,C),aa(fun(A,D),fun(A,fun(B,C)),aTP_Lamp_ov(fun(D,fun(B,C)),fun(fun(A,D),fun(A,fun(B,C))),Uu),Uua),Uub) = aa(D,fun(B,C),Uu,aa(A,D,Uua,Uub)) ) ).

% ATP.lambda_1032
tff(fact_9213_ATP_Olambda__1033,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,set(A)),Uua: fun(B,C),Uub: B] : ( aa(B,set(A),aa(fun(B,C),fun(B,set(A)),aTP_Lamp_ug(fun(C,set(A)),fun(fun(B,C),fun(B,set(A))),Uu),Uua),Uub) = aa(C,set(A),Uu,aa(B,C,Uua,Uub)) ) ).

% ATP.lambda_1033
tff(fact_9214_ATP_Olambda__1034,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(C,B),Uua: fun(A,C),Uub: A] : ( aa(A,B,aa(fun(A,C),fun(A,B),aTP_Lamp_ayr(fun(C,B),fun(fun(A,C),fun(A,B)),Uu),Uua),Uub) = aa(C,B,Uu,aa(A,C,Uua,Uub)) ) ).

% ATP.lambda_1034
tff(fact_9215_ATP_Olambda__1035,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,A),Uua: fun(B,C),Uub: B] : ( aa(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_wr(fun(C,A),fun(fun(B,C),fun(B,A)),Uu),Uua),Uub) = aa(C,A,Uu,aa(B,C,Uua,Uub)) ) ).

% ATP.lambda_1035
tff(fact_9216_ATP_Olambda__1036,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(num,B),Uub: num] : ( aa(num,A,aa(fun(num,B),fun(num,A),aTP_Lamp_zf(fun(B,A),fun(fun(num,B),fun(num,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(num,B,Uua,Uub)) ) ).

% ATP.lambda_1036
tff(fact_9217_ATP_Olambda__1037,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(nat,B),Uub: nat] : ( aa(nat,A,aa(fun(nat,B),fun(nat,A),aTP_Lamp_mu(fun(B,A),fun(fun(nat,B),fun(nat,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(nat,B,Uua,Uub)) ) ).

% ATP.lambda_1037
tff(fact_9218_ATP_Olambda__1038,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,A),Uua: fun(C,B),Uub: C] : ( aa(C,A,aa(fun(C,B),fun(C,A),aTP_Lamp_rk(fun(B,A),fun(fun(C,B),fun(C,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(C,B,Uua,Uub)) ) ).

% ATP.lambda_1038
tff(fact_9219_ATP_Olambda__1039,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ayb(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1039
tff(fact_9220_ATP_Olambda__1040,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [Uu: fun(A,$o),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_aru(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_1040
tff(fact_9221_ATP_Olambda__1041,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,A),Uub: nat] : ( aa(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_arx(fun(A,B),fun(fun(nat,A),fun(nat,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_1041
tff(fact_9222_ATP_Olambda__1042,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [Uu: fun(A,$o),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_anu(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_1042
tff(fact_9223_ATP_Olambda__1043,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,A),Uub: nat] : ( aa(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_aji(fun(A,B),fun(fun(nat,A),fun(nat,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_1043
tff(fact_9224_ATP_Olambda__1044,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,A),Uub: nat] : ( aa(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_aky(fun(A,B),fun(fun(nat,A),fun(nat,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_1044
tff(fact_9225_ATP_Olambda__1045,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aca(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1045
tff(fact_9226_ATP_Olambda__1046,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aug(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1046
tff(fact_9227_ATP_Olambda__1047,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_akv(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1047
tff(fact_9228_ATP_Olambda__1048,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aku(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1048
tff(fact_9229_ATP_Olambda__1049,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,A),Uub: nat] : ( aa(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_ajj(fun(A,B),fun(fun(nat,A),fun(nat,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_1049
tff(fact_9230_ATP_Olambda__1050,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aud(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1050
tff(fact_9231_ATP_Olambda__1051,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aed(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1051
tff(fact_9232_ATP_Olambda__1052,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_zl(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_1052
tff(fact_9233_ATP_Olambda__1053,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_axy(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1053
tff(fact_9234_ATP_Olambda__1054,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,A),Uub: nat] : ( aa(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_azq(fun(A,B),fun(fun(nat,A),fun(nat,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_1054
tff(fact_9235_ATP_Olambda__1055,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topological_t2_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aeb(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_1055
tff(fact_9236_ATP_Olambda__1056,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,$o),Uua: fun(B,A),Uub: B] :
      ( aa(B,$o,aa(fun(B,A),fun(B,$o),aTP_Lamp_aoa(fun(A,$o),fun(fun(B,A),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(A,$o,Uu,aa(B,A,Uua,Uub)) ) ).

% ATP.lambda_1056
tff(fact_9237_ATP_Olambda__1057,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_aeu(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ).

% ATP.lambda_1057
tff(fact_9238_ATP_Olambda__1058,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topological_t2_space(C)
        & topological_t2_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(C,A),Uua: fun(A,B),Uub: C] : ( aa(C,B,aa(fun(A,B),fun(C,B),aTP_Lamp_aea(fun(C,A),fun(fun(A,B),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uua,aa(C,A,Uu,Uub)) ) ) ).

% ATP.lambda_1058
tff(fact_9239_ATP_Olambda__1059,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(A,C),Uub: B] : ( aa(B,C,aa(fun(A,C),fun(B,C),aTP_Lamp_wz(fun(B,A),fun(fun(A,C),fun(B,C)),Uu),Uua),Uub) = aa(A,C,Uua,aa(B,A,Uu,Uub)) ) ).

% ATP.lambda_1059
tff(fact_9240_ATP_Olambda__1060,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_abi(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1060
tff(fact_9241_ATP_Olambda__1061,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_adr(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1061
tff(fact_9242_ATP_Olambda__1062,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_apr(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1062
tff(fact_9243_ATP_Olambda__1063,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_zk(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uua,aa(A,A,Uu,Uub)) ) ) ).

% ATP.lambda_1063
tff(fact_9244_ATP_Olambda__1064,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo7287701948861334536_space(A)
        & topolo7287701948861334536_space(B)
        & topolo7287701948861334536_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_azr(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1064
tff(fact_9245_ATP_Olambda__1065,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_alv(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1065
tff(fact_9246_ATP_Olambda__1066,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topological_t2_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_ads(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1066
tff(fact_9247_ATP_Olambda__1067,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(B,$o),Uub: A] :
      ( aa(A,$o,aa(fun(B,$o),fun(A,$o),aTP_Lamp_anx(fun(A,B),fun(fun(B,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,Uua,aa(A,B,Uu,Uub)) ) ).

% ATP.lambda_1067
tff(fact_9248_ATP_Olambda__1068,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_kn(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1068
tff(fact_9249_ATP_Olambda__1069,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_jl(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1069
tff(fact_9250_ATP_Olambda__1070,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_sb(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1070
tff(fact_9251_ATP_Olambda__1071,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,$o),Uua: B,Uub: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_axp(fun(B,$o),fun(B,fun(A,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,Uu,Uua) ) ).

% ATP.lambda_1071
tff(fact_9252_ATP_Olambda__1072,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(A,B),Uua: A,Uub: C] : ( aa(C,B,aa(A,fun(C,B),aTP_Lamp_azh(fun(A,B),fun(A,fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,Uua) ) ).

% ATP.lambda_1072
tff(fact_9253_ATP_Olambda__1073,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [Uu: fun(product_prod(A,A),$o),Uua: A,Uub: A] : ( aa(A,fun(product_prod(A,A),$o),aa(A,fun(A,fun(product_prod(A,A),$o)),aTP_Lamp_axj(fun(product_prod(A,A),$o),fun(A,fun(A,fun(product_prod(A,A),$o))),Uu),Uua),Uub) = aa(fun(A,fun(A,$o)),fun(product_prod(A,A),$o),product_case_prod(A,A,$o),aa(A,fun(A,fun(A,$o)),aa(A,fun(A,fun(A,fun(A,$o))),aTP_Lamp_axi(fun(product_prod(A,A),$o),fun(A,fun(A,fun(A,fun(A,$o)))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_1073
tff(fact_9254_ATP_Olambda__1074,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,B),Uub: A] : ( aa(A,B,aa(fun(nat,B),fun(A,B),aTP_Lamp_aik(fun(A,B),fun(fun(nat,B),fun(A,B)),Uu),Uua),Uub) = suminf(B,aa(A,fun(nat,B),aa(fun(nat,B),fun(A,fun(nat,B)),aTP_Lamp_aij(fun(A,B),fun(fun(nat,B),fun(A,fun(nat,B))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_1074
tff(fact_9255_ATP_Olambda__1075,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_adk(fun(nat,A),fun(A,fun(A,A)),Uu),Uua),Uub) = suminf(A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_adj(fun(nat,A),fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_1075
tff(fact_9256_ATP_Olambda__1076,axiom,
    ! [B: $tType,C: $tType,A: $tType,E4: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,fun(E4,set(A))))),Uua: set(product_prod(D,E4)),Uub: product_prod(B,C)] : ( aa(product_prod(B,C),set(A),aa(set(product_prod(D,E4)),fun(product_prod(B,C),set(A)),aTP_Lamp_vs(fun(B,fun(C,fun(D,fun(E4,set(A))))),fun(set(product_prod(D,E4)),fun(product_prod(B,C),set(A))),Uu),Uua),Uub) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(D,E4)),set(set(A)),image(product_prod(D,E4),set(A),aa(product_prod(B,C),fun(product_prod(D,E4),set(A)),aTP_Lamp_vr(fun(B,fun(C,fun(D,fun(E4,set(A))))),fun(product_prod(B,C),fun(product_prod(D,E4),set(A))),Uu),Uub)),Uua)) ) ).

% ATP.lambda_1076
tff(fact_9257_ATP_Olambda__1077,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(B),Uub: C] : ( aa(C,A,aa(set(B),fun(C,A),aTP_Lamp_ub(fun(B,fun(C,A)),fun(set(B),fun(C,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(C,fun(B,A),aTP_Lamp_ua(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_1077
tff(fact_9258_ATP_Olambda__1078,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(B),Uub: C] : ( aa(C,A,aa(set(B),fun(C,A),aTP_Lamp_vd(fun(B,fun(C,A)),fun(set(B),fun(C,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(C,fun(B,A),aTP_Lamp_ua(fun(B,fun(C,A)),fun(C,fun(B,A)),Uu),Uub)),Uua)) ) ) ).

% ATP.lambda_1078
tff(fact_9259_ATP_Olambda__1079,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: set(A),Uub: A] : ( aa(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_ama(A,fun(set(A),fun(A,filter(A))),Uu),Uua),Uub) = aa(set(A),filter(A),principal(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),Uub)),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_1079
tff(fact_9260_ATP_Olambda__1080,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: set(A),Uub: A] : ( aa(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_alz(A,fun(set(A),fun(A,filter(A))),Uu),Uua),Uub) = aa(set(A),filter(A),principal(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_lessThan(A),Uub)),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_1080
tff(fact_9261_ATP_Olambda__1081,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: A,Uua: set(A),Uub: set(A)] : ( aa(set(A),filter(A),aa(set(A),fun(set(A),filter(A)),aTP_Lamp_amo(A,fun(set(A),fun(set(A),filter(A))),Uu),Uua),Uub) = aa(set(A),filter(A),principal(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uub),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_1081
tff(fact_9262_ATP_Olambda__1082,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,real,aa(A,fun(nat,real),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,real)),Uu),Uua),Uub) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,power_power(A,Uua),Uub))) ) ) ).

% ATP.lambda_1082
tff(fact_9263_ATP_Olambda__1083,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,real,aa(fun(A,B),fun(A,real),aTP_Lamp_lg(fun(A,B),fun(fun(A,B),fun(A,real)),Uu),Uua),Uub) = real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub))) ) ) ).

% ATP.lambda_1083
tff(fact_9264_ATP_Olambda__1084,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topological_t2_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_aue(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) != aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_1084
tff(fact_9265_ATP_Olambda__1085,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(C),Uub: B] : ( aa(B,A,aa(set(C),fun(B,A),aTP_Lamp_tz(fun(B,fun(C,A)),fun(set(C),fun(B,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_1085
tff(fact_9266_ATP_Olambda__1086,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,fun(C,A)),Uua: set(C),Uub: B] : ( aa(B,A,aa(set(C),fun(B,A),aTP_Lamp_vc(fun(B,fun(C,A)),fun(set(C),fun(B,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_1086
tff(fact_9267_ATP_Olambda__1087,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_akn(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = cos(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),Uua)) ) ).

% ATP.lambda_1087
tff(fact_9268_ATP_Olambda__1088,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_apq(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) != Uua ) ) ) ).

% ATP.lambda_1088
tff(fact_9269_ATP_Olambda__1089,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aoc(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) != Uua ) ) ) ).

% ATP.lambda_1089
tff(fact_9270_ATP_Olambda__1090,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aps(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) != Uua ) ) ) ).

% ATP.lambda_1090
tff(fact_9271_ATP_Olambda__1091,axiom,
    ! [A: $tType,B: $tType] :
      ( topological_t1_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aoe(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uu,Uub) != Uua ) ) ) ).

% ATP.lambda_1091
tff(fact_9272_ATP_Olambda__1092,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: B,Uub: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_xz(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,B,Uu,Uub) != Uua ) ) ).

% ATP.lambda_1092
tff(fact_9273_ATP_Olambda__1093,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: fun(A,B),Uub: A] :
      ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_ya(B,fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,B,Uua,Uub) != Uu ) ) ).

% ATP.lambda_1093
tff(fact_9274_ATP_Olambda__1094,axiom,
    ! [C: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: A,Uua: fun(C,A),Uub: C] :
          ( aa(C,$o,aa(fun(C,A),fun(C,$o),aTP_Lamp_app(A,fun(fun(C,A),fun(C,$o)),Uu),Uua),Uub)
        <=> ( aa(C,A,Uua,Uub) != Uu ) ) ) ).

% ATP.lambda_1094
tff(fact_9275_ATP_Olambda__1095,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,set(A)),Uua: fun(B,set(C)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(C)),fun(B,set(A)),aTP_Lamp_ud(fun(C,set(A)),fun(fun(B,set(C)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image(C,set(A),Uu),aa(B,set(C),Uua,Uub))) ) ).

% ATP.lambda_1095
tff(fact_9276_ATP_Olambda__1096,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_uf(fun(B,set(A)),fun(fun(C,set(B)),fun(C,set(A))),Uu),Uua),Uub) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),Uu),aa(C,set(B),Uua,Uub))) ) ).

% ATP.lambda_1096
tff(fact_9277_ATP_Olambda__1097,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,set(B)),Uub: C] : ( aa(C,A,aa(fun(C,set(B)),fun(C,A),aTP_Lamp_ur(fun(B,A),fun(fun(C,set(B)),fun(C,A)),Uu),Uua),Uub) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,Uu),aa(C,set(B),Uua,Uub))) ) ) ).

% ATP.lambda_1097
tff(fact_9278_ATP_Olambda__1098,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(A,set(B)),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_atz(fun(A,set(B)),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image(B,C,Uua),aa(A,set(B),Uu,Uub))) ) ) ).

% ATP.lambda_1098
tff(fact_9279_ATP_Olambda__1099,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,set(A)),Uua: fun(B,set(C)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(C)),fun(B,set(A)),aTP_Lamp_vh(fun(C,set(A)),fun(fun(B,set(C)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),Uu),aa(B,set(C),Uua,Uub))) ) ).

% ATP.lambda_1099
tff(fact_9280_ATP_Olambda__1100,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(A,set(B)),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_awe(fun(A,set(B)),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image(B,C,Uua),aa(A,set(B),Uu,Uub))) ) ) ).

% ATP.lambda_1100
tff(fact_9281_ATP_Olambda__1101,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_ta(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_1101
tff(fact_9282_ATP_Olambda__1102,axiom,
    ! [B: $tType,A: $tType,Uu: set(B),Uua: fun(A,fun(B,$o)),Uub: A] : ( aa(A,nat,aa(fun(A,fun(B,$o)),fun(A,nat),aTP_Lamp_ph(set(B),fun(fun(A,fun(B,$o)),fun(A,nat)),Uu),Uua),Uub) = finite_card(B,aa(fun(B,$o),set(B),collect(B),aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aTP_Lamp_nj(set(B),fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),Uu),Uua),Uub))) ) ).

% ATP.lambda_1102
tff(fact_9283_ATP_Olambda__1103,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [Uu: fun(B,real),Uua: fun(real,A),Uub: B] : ( aa(B,real,aa(fun(real,A),fun(B,real),aTP_Lamp_adh(fun(B,real),fun(fun(real,A),fun(B,real)),Uu),Uua),Uub) = ring_1_of_int(real,archim6421214686448440834_floor(A,aa(real,A,Uua,aa(B,real,Uu,Uub)))) ) ) ).

% ATP.lambda_1103
tff(fact_9284_ATP_Olambda__1104,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [Uu: A,Uua: set(A),Uub: A] :
          ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_ato(A,fun(set(A),fun(A,$o)),Uu),Uua),Uub)
        <=> ? [B6: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),B6) )
              & aa(set(A),$o,member(A,B6),Uua) ) ) ) ).

% ATP.lambda_1104
tff(fact_9285_ATP_Olambda__1105,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: set(B),Uub: A] :
      ( aa(A,$o,aa(set(B),fun(A,$o),aTP_Lamp_asu(fun(B,A),fun(set(B),fun(A,$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( ( Uub = aa(B,A,Uu,X3) )
          & aa(set(B),$o,member(B,X3),Uua) ) ) ).

% ATP.lambda_1105
tff(fact_9286_ATP_Olambda__1106,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,set(C)),Uua: fun(C,$o),Uub: B] :
      ( aa(B,$o,aa(fun(C,$o),fun(B,$o),aTP_Lamp_ash(fun(B,set(C)),fun(fun(C,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ! [X3: C] :
          ( aa(set(C),$o,member(C,X3),aa(B,set(C),Uu,Uub))
         => aa(C,$o,Uua,X3) ) ) ).

% ATP.lambda_1106
tff(fact_9287_ATP_Olambda__1107,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,$o),Uub: set(A)] :
      ( aa(set(A),$o,aa(fun(B,$o),fun(set(A),$o),aTP_Lamp_asf(fun(B,set(A)),fun(fun(B,$o),fun(set(A),$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( ( Uub = aa(B,set(A),Uu,X3) )
          & aa(B,$o,Uua,X3) ) ) ).

% ATP.lambda_1107
tff(fact_9288_ATP_Olambda__1108,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(B,$o),Uub: A] :
      ( aa(A,$o,aa(fun(B,$o),fun(A,$o),aTP_Lamp_asv(fun(B,A),fun(fun(B,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( ( Uub = aa(B,A,Uu,X3) )
          & aa(B,$o,Uua,X3) ) ) ).

% ATP.lambda_1108
tff(fact_9289_ATP_Olambda__1109,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,$o),Uua: fun(A,B),Uub: B] :
      ( aa(B,$o,aa(fun(A,B),fun(B,$o),aTP_Lamp_asp(fun(A,$o),fun(fun(A,B),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X3: A] :
          ( ( Uub = aa(A,B,Uua,X3) )
          & aa(A,$o,Uu,X3) ) ) ).

% ATP.lambda_1109
tff(fact_9290_ATP_Olambda__1110,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,fun(B,$o)),Uub: A] :
      ( aa(A,$o,aa(fun(A,fun(B,$o)),fun(A,$o),aTP_Lamp_ass(set(B),fun(fun(A,fun(B,$o)),fun(A,$o)),Uu),Uua),Uub)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uu)
         => aa(B,$o,aa(A,fun(B,$o),Uua,Uub),X3) ) ) ).

% ATP.lambda_1110
tff(fact_9291_ATP_Olambda__1111,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,fun(A,$o)),Uub: B] :
      ( aa(B,$o,aa(fun(B,fun(A,$o)),fun(B,$o),aTP_Lamp_asc(set(A),fun(fun(B,fun(A,$o)),fun(B,$o)),Uu),Uua),Uub)
    <=> ! [X3: A] :
          ( aa(set(A),$o,member(A,X3),Uu)
         => aa(A,$o,aa(B,fun(A,$o),Uua,Uub),X3) ) ) ).

% ATP.lambda_1111
tff(fact_9292_ATP_Olambda__1112,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_arl(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),Uu),Uua),Uub)
        <=> ! [N4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uub),N4)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,Uub,N4)))),aa(nat,real,Uua,Uub)) ) ) ) ).

% ATP.lambda_1112
tff(fact_9293_ATP_Olambda__1113,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: set(B),Uub: A] :
      ( aa(A,$o,aa(set(B),fun(A,$o),aTP_Lamp_asr(fun(B,set(A)),fun(set(B),fun(A,$o)),Uu),Uua),Uub)
    <=> ! [X3: B] :
          ( aa(set(B),$o,member(B,X3),Uua)
         => aa(set(A),$o,member(A,Uub),aa(B,set(A),Uu,X3)) ) ) ).

% ATP.lambda_1113
tff(fact_9294_ATP_Olambda__1114,axiom,
    ! [A: $tType] :
      ( ( real_V8037385150606011577_space(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_ark(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),Uu),Uua),Uub)
        <=> ! [A6: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uub),A6)
             => ! [B6: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A6),B6)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or3652927894154168847AtMost(nat,A6,B6)))),aa(nat,real,Uua,A6)) ) ) ) ) ).

% ATP.lambda_1114
tff(fact_9295_ATP_Olambda__1115,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,$o),Uua: fun(B,fun(A,$o)),Uub: B] :
      ( aa(B,$o,aa(fun(B,fun(A,$o)),fun(B,$o),aTP_Lamp_arz(fun(A,$o),fun(fun(B,fun(A,$o)),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [Y: A] :
          ( aa(A,$o,Uu,Y)
          & aa(A,$o,aa(B,fun(A,$o),Uua,Uub),Y) ) ) ).

% ATP.lambda_1115
tff(fact_9296_ATP_Olambda__1116,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,$o),Uub: A] :
      ( aa(A,$o,aa(fun(B,$o),fun(A,$o),aTP_Lamp_asg(fun(B,set(A)),fun(fun(B,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ? [X3: B] :
          ( aa(B,$o,Uua,X3)
          & aa(set(A),$o,member(A,Uub),aa(B,set(A),Uu,X3)) ) ) ).

% ATP.lambda_1116
tff(fact_9297_ATP_Olambda__1117,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_azj(fun(A,A),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> ? [N4: nat] : ( Uub = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N4),Uu),Uua) ) ) ).

% ATP.lambda_1117
tff(fact_9298_ATP_Olambda__1118,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_awg(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ? [A6: A,V5: list(A)] :
          ( ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Uua),aa(list(A),list(A),cons(A,A6),V5)) )
          | ? [U3: list(A),Aa2: A,B6: A,Va4: list(A),W3: list(A)] :
              ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Aa2),B6)),Uu)
              & ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U3),aa(list(A),list(A),cons(A,Aa2),Va4)) )
              & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U3),aa(list(A),list(A),cons(A,B6),W3)) ) ) ) ) ).

% ATP.lambda_1118
tff(fact_9299_ATP_Olambda__1119,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(list(A)),Uub: list(A)] :
      ( aa(list(A),$o,aa(set(list(A)),fun(list(A),$o),aTP_Lamp_asq(set(A),fun(set(list(A)),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ? [X3: A,Xs3: list(A)] :
          ( ( Uub = aa(list(A),list(A),cons(A,X3),Xs3) )
          & aa(set(A),$o,member(A,X3),Uu)
          & aa(set(list(A)),$o,member(list(A),Xs3),Uua) ) ) ).

% ATP.lambda_1119
tff(fact_9300_ATP_Olambda__1120,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_asm(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ? [Us2: list(A),Z5: A,Z8: A,Vs2: list(A)] :
          ( ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),cons(A,Z5),Vs2)) )
          & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z5),Z8)),Uu)
          & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),cons(A,Z8),Vs2)) ) ) ) ).

% ATP.lambda_1120
tff(fact_9301_ATP_Olambda__1121,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,A))),Uua: D,Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(D,fun(B,fun(C,A)),aTP_Lamp_ej(fun(B,fun(C,fun(D,A))),fun(D,fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(D,A,aa(C,fun(D,A),aa(B,fun(C,fun(D,A)),Uu,Uub),Uuc),Uua) ) ).

% ATP.lambda_1121
tff(fact_9302_ATP_Olambda__1122,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fd(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uuc) ),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),
              zero_zero(A) ) ) ) ).

% ATP.lambda_1122
tff(fact_9303_ATP_Olambda__1123,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ez(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub)
              & ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uuc) ),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub)))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),
              zero_zero(A) ) ) ) ).

% ATP.lambda_1123
tff(fact_9304_ATP_Olambda__1124,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fb(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),ring_1_of_int(real,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,power_power(int,aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),zero_zero(A)) ) ) ).

% ATP.lambda_1124
tff(fact_9305_ATP_Olambda__1125,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: product_prod(C,A),Uua: A,Uub: B,Uuc: set(product_prod(C,B))] :
      ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(B,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_bbb(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),Uu),Uua),Uub),Uuc)
      = $ite(aa(product_prod(C,A),A,product_snd(C,A),Uu) = Uua,aa(set(product_prod(C,B)),set(product_prod(C,B)),insert(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),aa(product_prod(C,A),C,product_fst(C,A),Uu)),Uub)),Uuc),Uuc) ) ).

% ATP.lambda_1125
tff(fact_9306_ATP_Olambda__1126,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: A,Uuc: B] :
      ( aa(B,A,aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_bap(fun(A,B),fun(set(A),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(B),$o,member(B,Uuc),aa(set(A),set(B),image(A,B,Uu),Uua)),the_inv_into(A,B,Uua,Uu,Uuc),Uub) ) ).

% ATP.lambda_1126
tff(fact_9307_ATP_Olambda__1127,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: A,Uub: B,Uuc: set(B)] :
      ( aa(set(B),set(B),aa(B,fun(set(B),set(B)),aa(A,fun(B,fun(set(B),set(B))),aTP_Lamp_bbq(set(A),fun(A,fun(B,fun(set(B),set(B)))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(A),$o,member(A,Uua),Uu),aa(set(B),set(B),insert(B,Uub),Uuc),Uuc) ) ).

% ATP.lambda_1127
tff(fact_9308_ATP_Olambda__1128,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gr(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,A,Uua,Uuc),
              $ite(Uuc = Uu,zero_zero(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_1128
tff(fact_9309_ATP_Olambda__1129,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_lk(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,A,Uua,Uuc),
              $ite(Uuc = Uu,one_one(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_1129
tff(fact_9310_ATP_Olambda__1130,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_alw(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uuc),Uu),aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_1130
tff(fact_9311_ATP_Olambda__1131,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_ll(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1131
tff(fact_9312_ATP_Olambda__1132,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gs(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1132
tff(fact_9313_ATP_Olambda__1133,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: fun(A,B),Uuc: A] :
      ( aa(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_bak(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(set(A),$o,member(A,Uuc),Uua),aa(A,B,Uu,Uuc),aa(A,B,Uub,Uuc)) ) ).

% ATP.lambda_1133
tff(fact_9314_ATP_Olambda__1134,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: set(nat),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(set(nat),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_oh(fun(nat,A),fun(set(nat),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(set(nat),$o,member(nat,Uuc),Uua),aa(nat,A,Uub,Uuc),aa(nat,A,Uu,Uuc)) ) ) ).

% ATP.lambda_1134
tff(fact_9315_ATP_Olambda__1135,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_qa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_1135
tff(fact_9316_ATP_Olambda__1136,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_pz(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_1136
tff(fact_9317_ATP_Olambda__1137,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: B,Uuc: A] :
          ( aa(A,B,aa(B,fun(A,B),aa(fun(A,B),fun(B,fun(A,B)),aTP_Lamp_ps(A,fun(fun(A,B),fun(B,fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),Uub) ) ) ).

% ATP.lambda_1137
tff(fact_9318_ATP_Olambda__1138,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: A,Uub: list(A),Uuc: list(A)] :
      ( aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),aa(A,fun(list(A),fun(list(A),product_prod(list(A),list(A)))),aTP_Lamp_zg(fun(A,$o),fun(A,fun(list(A),fun(list(A),product_prod(list(A),list(A))))),Uu),Uua),Uub),Uuc)
      = $ite(aa(A,$o,Uu,Uua),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),cons(A,Uua),Uub)),Uuc),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Uub),aa(list(A),list(A),cons(A,Uua),Uuc))) ) ).

% ATP.lambda_1138
tff(fact_9319_ATP_Olambda__1139,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,$o),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] :
      ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_azu(fun(B,$o),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc)
      = $ite(aa(B,$o,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ).

% ATP.lambda_1139
tff(fact_9320_ATP_Olambda__1140,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,$o),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_sx(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,Uu,Uuc),aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_1140
tff(fact_9321_ATP_Olambda__1141,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,$o),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_sw(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,Uu,Uuc),aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_1141
tff(fact_9322_ATP_Olambda__1142,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,$o),fun(fun(A,B),fun(A,B)),aTP_Lamp_aeg(fun(A,B),fun(fun(A,$o),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,Uua,Uuc),aa(A,B,Uu,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_1142
tff(fact_9323_ATP_Olambda__1143,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,$o),Uub: fun(A,B),Uuc: A] :
      ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,$o),fun(fun(A,B),fun(A,B)),aTP_Lamp_amc(fun(A,B),fun(fun(A,$o),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(A,$o,Uua,Uuc),aa(A,B,Uu,Uuc),aa(A,B,Uub,Uuc)) ) ).

% ATP.lambda_1143
tff(fact_9324_ATP_Olambda__1144,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: fun(A,$o),Uuc: A] :
          ( aa(A,B,aa(fun(A,$o),fun(A,B),aa(fun(A,B),fun(fun(A,$o),fun(A,B)),aTP_Lamp_baj(fun(A,B),fun(fun(A,B),fun(fun(A,$o),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,Uub,Uuc),aa(A,B,Uu,Uuc),aa(A,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1144
tff(fact_9325_ATP_Olambda__1145,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: C,Uub: A,Uuc: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(A,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_bbm(set(product_prod(A,B)),fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aa(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),aTP_Lamp_bbl(C,fun(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_1145
tff(fact_9326_ATP_Olambda__1146,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: A,Uub: B,Uuc: set(product_prod(A,C))] : ( aa(set(product_prod(A,C)),set(product_prod(A,C)),aa(B,fun(set(product_prod(A,C)),set(product_prod(A,C))),aa(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aTP_Lamp_bbg(set(product_prod(B,C)),fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(B,C),set(product_prod(A,C)),aa(fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),fun(product_prod(B,C),fun(set(product_prod(A,C)),set(product_prod(A,C)))),product_case_prod(B,C,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),aTP_Lamp_bbf(A,fun(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_1146
tff(fact_9327_ATP_Olambda__1147,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_qq(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uuc),aa(A,fun(A,A),times_times(A),Uua)),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))) ) ) ).

% ATP.lambda_1147
tff(fact_9328_ATP_Olambda__1148,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(A,$o)),Uua: fun(B,A),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,A),fun(B,fun(B,$o)),aTP_Lamp_qb(fun(A,fun(A,$o)),fun(fun(B,A),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(A,$o,aa(A,fun(A,$o),Uu,aa(B,A,Uua,Uub)),aa(B,A,Uua,Uuc)) ) ).

% ATP.lambda_1148
tff(fact_9329_ATP_Olambda__1149,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,B),Uub: A,Uuc: D] : ( aa(D,C,aa(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_ayp(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,Uub),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_1149
tff(fact_9330_ATP_Olambda__1150,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_jh(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_jg(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(nat,nat,suc,zero_zero(nat)))),Uuc))) ) ) ).

% ATP.lambda_1150
tff(fact_9331_ATP_Olambda__1151,axiom,
    ! [Uu: $o,Uua: $o,Uub: code_integer,Uuc: $o] : ( aa($o,char,aa(code_integer,fun($o,char),aa($o,fun(code_integer,fun($o,char)),aTP_Lamp_xn($o,fun($o,fun(code_integer,fun($o,char))),Uu),Uua),Uub),Uuc) = aa(product_prod(code_integer,$o),char,aa(fun(code_integer,fun($o,char)),fun(product_prod(code_integer,$o),char),product_case_prod(code_integer,$o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aTP_Lamp_xm($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),Uu),Uua),Uuc)),code_bit_cut_integer(Uub)) ) ).

% ATP.lambda_1151
tff(fact_9332_ATP_Olambda__1152,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_ic(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_ib(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub) ) ) ).

% ATP.lambda_1152
tff(fact_9333_ATP_Olambda__1153,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_gw(nat,fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),
                $ite(
                  Uuc = zero_zero(nat),
                  aa(A,A,uminus_uminus(A),Uub),
                  $ite(Uuc = Uu,one_one(A),zero_zero(A)) )),
              aa(nat,A,power_power(A,Uua),Uuc)) ) ) ).

% ATP.lambda_1153
tff(fact_9334_ATP_Olambda__1154,axiom,
    ! [C: $tType,A: $tType,B: $tType,E4: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,fun(E4,set(A))))),Uua: product_prod(D,E4),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(product_prod(D,E4),fun(B,fun(C,set(A))),aTP_Lamp_vq(fun(B,fun(C,fun(D,fun(E4,set(A))))),fun(product_prod(D,E4),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(product_prod(D,E4),set(A),aa(fun(D,fun(E4,set(A))),fun(product_prod(D,E4),set(A)),product_case_prod(D,E4,set(A)),aa(C,fun(D,fun(E4,set(A))),aa(B,fun(C,fun(D,fun(E4,set(A)))),Uu,Uub),Uuc)),Uua) ) ).

% ATP.lambda_1154
tff(fact_9335_ATP_Olambda__1155,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,$o)),Uuc: B] : ( aa(B,C,aa(fun(A,fun(B,$o)),fun(B,C),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(B,C)),aTP_Lamp_nq(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(B,C))),Uu),Uua),Uub),Uuc) = groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_np(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uuc),aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aa(fun(A,fun(B,$o)),fun(B,fun(A,$o)),aTP_Lamp_nm(set(A),fun(fun(A,fun(B,$o)),fun(B,fun(A,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1155
tff(fact_9336_ATP_Olambda__1156,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,$o)),Uuc: B] : ( aa(B,C,aa(fun(A,fun(B,$o)),fun(B,C),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(B,C)),aTP_Lamp_nn(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),aTP_Lamp_nl(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uuc)),aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aa(fun(A,fun(B,$o)),fun(B,fun(A,$o)),aTP_Lamp_nm(set(A),fun(fun(A,fun(B,$o)),fun(B,fun(A,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1156
tff(fact_9337_ATP_Olambda__1157,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_gn(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_gm(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uuc)),aa(nat,set(nat),set_ord_atMost(nat),Uuc))),aa(nat,nat,power_power(nat,Uub),Uuc)) ) ).

% ATP.lambda_1157
tff(fact_9338_ATP_Olambda__1158,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(fun(nat,A),fun(A,fun(nat,A)),aTP_Lamp_gi(fun(nat,A),fun(fun(nat,A),fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_gh(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uuc)),aa(nat,set(nat),set_ord_atMost(nat),Uuc))),aa(nat,A,power_power(A,Uub),Uuc)) ) ) ).

% ATP.lambda_1158
tff(fact_9339_ATP_Olambda__1159,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: nat,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_abb(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,Uua)),Uuc)),zero_zero(real))),semiring_char_0_fact(real,Uuc))),aa(nat,real,power_power(real,Uub),Uuc)) ) ).

% ATP.lambda_1159
tff(fact_9340_ATP_Olambda__1160,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: nat,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_aaz(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)),zero_zero(real))),semiring_char_0_fact(real,Uuc))),aa(nat,real,power_power(real,Uub),Uuc)) ) ).

% ATP.lambda_1160
tff(fact_9341_ATP_Olambda__1161,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_aay(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uuc),Uua)),semiring_char_0_fact(real,Uuc))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Uub),Uua)),Uuc)) ) ).

% ATP.lambda_1161
tff(fact_9342_ATP_Olambda__1162,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_aax(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uuc),Uub)),semiring_char_0_fact(real,Uuc))),aa(nat,real,power_power(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Uua),Uub)),Uuc)) ) ).

% ATP.lambda_1162
tff(fact_9343_ATP_Olambda__1163,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ir(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uua)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uu),Uub)) ) ) ).

% ATP.lambda_1163
tff(fact_9344_ATP_Olambda__1164,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_qt(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uub))) ) ).

% ATP.lambda_1164
tff(fact_9345_ATP_Olambda__1165,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_jg(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu)),Uuc)),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Uuc))) ) ) ).

% ATP.lambda_1165
tff(fact_9346_ATP_Olambda__1166,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),aTP_Lamp_akk(fun(A,A),fun(A,fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),aa(nat,A,Uub,Uuc)))),aa(A,A,Uu,Uua))),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_1166
tff(fact_9347_ATP_Olambda__1167,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: set(product_prod(A,A)),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aTP_Lamp_atp(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc))
        | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc))
          & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uuc)),Uua) ) ) ) ).

% ATP.lambda_1167
tff(fact_9348_ATP_Olambda__1168,axiom,
    ! [A: $tType,B: $tType] :
      ( topological_t2_space(B)
     => ! [Uu: fun(A,B),Uua: set(B),Uub: B,Uuc: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aa(set(B),fun(B,fun(A,$o)),aTP_Lamp_anw(fun(A,B),fun(set(B),fun(B,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(set(B),$o,member(B,aa(A,B,Uu,Uuc)),Uua)
            & ( aa(A,B,Uu,Uuc) != Uub ) ) ) ) ).

% ATP.lambda_1168
tff(fact_9349_ATP_Olambda__1169,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: set(B),Uuc: A] :
          ( aa(A,$o,aa(set(B),fun(A,$o),aa(B,fun(set(B),fun(A,$o)),aTP_Lamp_apd(fun(A,B),fun(B,fun(set(B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(set(B),$o,member(B,aa(A,B,Uu,Uuc)),Uub)
            & ( aa(A,B,Uu,Uuc) != Uua ) ) ) ) ).

% ATP.lambda_1169
tff(fact_9350_ATP_Olambda__1170,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aqw(fun(A,B),fun(B,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uuc),Uua)),Uub) ) ) ).

% ATP.lambda_1170
tff(fact_9351_ATP_Olambda__1171,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aqi(fun(A,B),fun(B,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uuc),Uua)),Uub) ) ) ).

% ATP.lambda_1171
tff(fact_9352_ATP_Olambda__1172,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gp(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),comm_s3205402744901411588hammer(A,Uu,Uuc))),comm_s3205402744901411588hammer(A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_1172
tff(fact_9353_ATP_Olambda__1173,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_gb(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,semiring_1_of_nat(nat),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,nat,power_power(nat,Uu),Uuc))),aa(nat,nat,power_power(nat,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_1173
tff(fact_9354_ATP_Olambda__1174,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gk(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,A,power_power(A,Uu),Uuc))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_1174
tff(fact_9355_ATP_Olambda__1175,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gv(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uuc))),aa(nat,A,power_power(A,Uu),Uuc))),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))) ) ) ).

% ATP.lambda_1175
tff(fact_9356_ATP_Olambda__1176,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat,Uub: list(A),Uuc: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aa(nat,fun(list(A),fun(list(A),$o)),aTP_Lamp_atn(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & ( aa(list(A),nat,size_size(list(A)),Uuc) = Uua )
        & ? [Xys2: list(A),X3: A,Y: A,Xs6: list(A),Ys7: list(A)] :
            ( ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),cons(A,X3),Xs6)) )
            & ( Uuc = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),cons(A,Y),Ys7)) )
            & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y)),Uu) ) ) ) ).

% ATP.lambda_1176
tff(fact_9357_ATP_Olambda__1177,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_iu(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uuc)))),aa(nat,A,power_power(A,Uu),Uuc)) ) ) ).

% ATP.lambda_1177
tff(fact_9358_ATP_Olambda__1178,axiom,
    ! [A: $tType,Uu: $o,Uua: A,Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(A,fun(A,fun(A,$o)),aTP_Lamp_dz($o,fun(A,fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( (Uu)
         => ( Uuc = Uua ) )
        & ( ~ (Uu)
         => ( Uuc = Uub ) ) ) ) ).

% ATP.lambda_1178
tff(fact_9359_ATP_Olambda__1179,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: set(B),Uub: fun(A,$o),Uuc: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aa(set(B),fun(fun(A,$o),fun(A,$o)),aTP_Lamp_rl(fun(B,A),fun(set(B),fun(fun(A,$o),fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(A),$o,member(A,Uuc),aa(set(B),set(A),image(B,A,Uu),Uua))
        & aa(A,$o,Uub,Uuc) ) ) ).

% ATP.lambda_1179
tff(fact_9360_ATP_Olambda__1180,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,fun(B,$o)),Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aTP_Lamp_nj(set(B),fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uu)
        & aa(B,$o,aa(A,fun(B,$o),Uua,Uub),Uuc) ) ) ).

% ATP.lambda_1180
tff(fact_9361_ATP_Olambda__1181,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,fun(B,$o)),Uub: B,Uuc: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aa(fun(A,fun(B,$o)),fun(B,fun(A,$o)),aTP_Lamp_nm(set(A),fun(fun(A,fun(B,$o)),fun(B,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(A),$o,member(A,Uuc),Uu)
        & aa(B,$o,aa(A,fun(B,$o),Uua,Uuc),Uub) ) ) ).

% ATP.lambda_1181
tff(fact_9362_ATP_Olambda__1182,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_is(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,Uu),Uuc)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uua)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),aa(nat,A,power_power(A,Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))) ) ) ).

% ATP.lambda_1182
tff(fact_9363_ATP_Olambda__1183,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: set(A),Uua: fun(A,A),Uub: fun(A,A),Uuc: A] :
          ( aa(A,$o,aa(fun(A,A),fun(A,$o),aa(fun(A,A),fun(fun(A,A),fun(A,$o)),aTP_Lamp_ape(set(A),fun(fun(A,A),fun(fun(A,A),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(set(A),$o,member(A,Uuc),Uu)
           => ( aa(A,A,Uua,Uuc) = aa(A,A,Uub,Uuc) ) ) ) ) ).

% ATP.lambda_1183
tff(fact_9364_ATP_Olambda__1184,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(A,real),Uub: fun(A,real),Uuc: A] :
          ( aa(A,$o,aa(fun(A,real),fun(A,$o),aa(fun(A,real),fun(fun(A,real),fun(A,$o)),aTP_Lamp_aub(set(A),fun(fun(A,real),fun(fun(A,real),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(set(A),$o,member(A,Uuc),Uu)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,Uua,Uuc)),aa(A,real,Uub,Uuc)) ) ) ) ).

% ATP.lambda_1184
tff(fact_9365_ATP_Olambda__1185,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(A,B),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,B),fun(A,fun(A,$o)),aTP_Lamp_rn(set(A),fun(fun(A,B),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(A),$o,member(A,Uuc),Uu)
        & ( aa(A,B,Uua,Uuc) = aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_1185
tff(fact_9366_ATP_Olambda__1186,axiom,
    ! [B: $tType,A: $tType,Uu: set(B),Uua: fun(B,A),Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(fun(B,A),fun(A,fun(B,$o)),aTP_Lamp_xh(set(B),fun(fun(B,A),fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uu)
        & ( aa(B,A,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1186
tff(fact_9367_ATP_Olambda__1187,axiom,
    ! [A: $tType,C: $tType,Uu: set(A),Uua: fun(A,C),Uub: C,Uuc: A] :
      ( aa(A,$o,aa(C,fun(A,$o),aa(fun(A,C),fun(C,fun(A,$o)),aTP_Lamp_rp(set(A),fun(fun(A,C),fun(C,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(A),$o,member(A,Uuc),Uu)
        & ( aa(A,C,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1187
tff(fact_9368_ATP_Olambda__1188,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,B),Uub: B,Uuc: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aa(fun(A,B),fun(B,fun(A,$o)),aTP_Lamp_rt(set(A),fun(fun(A,B),fun(B,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(A),$o,member(A,Uuc),Uu)
        & ( aa(A,B,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_1188
tff(fact_9369_ATP_Olambda__1189,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,A),Uub: set(B),Uuc: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aa(fun(B,A),fun(set(B),fun(B,$o)),aTP_Lamp_aze(set(A),fun(fun(B,A),fun(set(B),fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uub)
        & aa(set(A),$o,member(A,aa(B,A,Uua,Uuc)),Uu) ) ) ).

% ATP.lambda_1189
tff(fact_9370_ATP_Olambda__1190,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_it(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,power_power(A,Uu),Uuc)),aa(nat,A,power_power(A,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uuc))) ) ) ).

% ATP.lambda_1190
tff(fact_9371_ATP_Olambda__1191,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_fz(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Uu),Uuc)),aa(nat,nat,binomial(Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_1191
tff(fact_9372_ATP_Olambda__1192,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_hj(int,fun(int,fun(int,fun(int,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub)) ) ).

% ATP.lambda_1192
tff(fact_9373_ATP_Olambda__1193,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_qz(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_1193
tff(fact_9374_ATP_Olambda__1194,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_hg(int,fun(int,fun(int,fun(int,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub)) ) ).

% ATP.lambda_1194
tff(fact_9375_ATP_Olambda__1195,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_qx(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_1195
tff(fact_9376_ATP_Olambda__1196,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_rb(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)) ) ).

% ATP.lambda_1196
tff(fact_9377_ATP_Olambda__1197,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_rd(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ).

% ATP.lambda_1197
tff(fact_9378_ATP_Olambda__1198,axiom,
    ! [Uu: set(complex),Uua: complex,Uub: complex,Uuc: complex] :
      ( aa(complex,$o,aa(complex,fun(complex,$o),aa(complex,fun(complex,fun(complex,$o)),aTP_Lamp_axd(set(complex),fun(complex,fun(complex,fun(complex,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( Uub = Uua )
       => aa(set(complex),$o,member(complex,Uuc),Uu) ) ) ).

% ATP.lambda_1198
tff(fact_9379_ATP_Olambda__1199,axiom,
    ! [Uu: set(real),Uua: real,Uub: real,Uuc: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aa(real,fun(real,fun(real,$o)),aTP_Lamp_axe(set(real),fun(real,fun(real,fun(real,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( Uub = Uua )
       => aa(set(real),$o,member(real,Uuc),Uu) ) ) ).

% ATP.lambda_1199
tff(fact_9380_ATP_Olambda__1200,axiom,
    ! [A: $tType] :
      ( topolo569519726778239578ormity(A)
     => ! [Uu: set(A),Uua: A,Uub: A,Uuc: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aa(A,fun(A,fun(A,$o)),aTP_Lamp_awu(set(A),fun(A,fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( ( Uub = Uua )
           => aa(set(A),$o,member(A,Uuc),Uu) ) ) ) ).

% ATP.lambda_1200
tff(fact_9381_ATP_Olambda__1201,axiom,
    ! [A: $tType,B: $tType,Uu: filter(A),Uua: filter(B),Uub: fun(A,$o),Uuc: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(fun(A,$o),fun(fun(B,$o),$o),aa(filter(B),fun(fun(A,$o),fun(fun(B,$o),$o)),aTP_Lamp_axt(filter(A),fun(filter(B),fun(fun(A,$o),fun(fun(B,$o),$o))),Uu),Uua),Uub),Uuc)
    <=> ( eventually(A,Uub,Uu)
        & eventually(B,Uuc,Uua) ) ) ).

% ATP.lambda_1201
tff(fact_9382_ATP_Olambda__1202,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: B,Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(B,fun(A,fun(B,$o)),aTP_Lamp_dy(A,fun(B,fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( Uu = Uub )
        & ( Uua = Uuc ) ) ) ).

% ATP.lambda_1202
tff(fact_9383_ATP_Olambda__1203,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: set(B),Uub: fun(A,$o),Uuc: B] :
      ( aa(B,$o,aa(fun(A,$o),fun(B,$o),aa(set(B),fun(fun(A,$o),fun(B,$o)),aTP_Lamp_rm(fun(B,A),fun(set(B),fun(fun(A,$o),fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,member(B,Uuc),Uua)
        & aa(A,$o,Uub,aa(B,A,Uu,Uuc)) ) ) ).

% ATP.lambda_1203
tff(fact_9384_ATP_Olambda__1204,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [Uu: fun(A,$o),Uua: A,Uub: A,Uuc: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aa(A,fun(A,fun(A,$o)),aTP_Lamp_awz(fun(A,$o),fun(A,fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( ( Uub = Uua )
           => aa(A,$o,Uu,Uuc) ) ) ) ).

% ATP.lambda_1204
tff(fact_9385_ATP_Olambda__1205,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,set(product_prod(A,B))),Uua: C,Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(C,fun(A,fun(B,$o)),aTP_Lamp_tw(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(set(product_prod(A,B)),$o,member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uub),Uuc)),aa(C,set(product_prod(A,B)),Uu,Uua)) ) ).

% ATP.lambda_1205
tff(fact_9386_ATP_Olambda__1206,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_nw(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(set(A),$o,member(A,Uuc),Uu)
            & ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uuc)),aa(A,B,Uub,Uuc)) != one_one(B) ) ) ) ) ).

% ATP.lambda_1206
tff(fact_9387_ATP_Olambda__1207,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_nu(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(set(A),$o,member(A,Uuc),Uu)
            & ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uua,Uuc)),aa(A,B,Uub,Uuc)) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_1207
tff(fact_9388_ATP_Olambda__1208,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_aks(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))))) ) ) ).

% ATP.lambda_1208
tff(fact_9389_ATP_Olambda__1209,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_co(fun(nat,A),fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uuc),Uua))),aa(nat,A,power_power(A,Uub),Uuc)) ) ) ).

% ATP.lambda_1209
tff(fact_9390_ATP_Olambda__1210,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_me(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))),aa(nat,A,power_power(A,Uua),Uuc)) ) ) ).

% ATP.lambda_1210
tff(fact_9391_ATP_Olambda__1211,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(B,$o),Uub: fun(A,B),Uuc: A] :
      ( aa(A,$o,aa(fun(A,B),fun(A,$o),aa(fun(B,$o),fun(fun(A,B),fun(A,$o)),aTP_Lamp_atr(set(A),fun(fun(B,$o),fun(fun(A,B),fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(B,$o,Uua,aa(A,B,Uub,Uuc))
        & aa(set(A),$o,member(A,Uuc),Uu) ) ) ).

% ATP.lambda_1211
tff(fact_9392_ATP_Olambda__1212,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_adj(fun(nat,A),fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)),Uuc)),aa(nat,A,power_power(A,Uua),Uuc))),Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uuc)),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))))) ) ) ).

% ATP.lambda_1212
tff(fact_9393_ATP_Olambda__1213,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: fun(nat,B),Uub: A,Uuc: nat] : ( aa(nat,B,aa(A,fun(nat,B),aa(fun(nat,B),fun(A,fun(nat,B)),aTP_Lamp_aij(fun(A,B),fun(fun(nat,B),fun(A,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uua,Uuc)),aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),Uuc)) ) ) ).

% ATP.lambda_1213
tff(fact_9394_ATP_Olambda__1214,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_adc(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(A,real,Uu,Uua)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_1214
tff(fact_9395_ATP_Olambda__1215,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_kf(fun(nat,A),fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,power_power(A,Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),Uub)),one_one(nat)))) ) ) ).

% ATP.lambda_1215
tff(fact_9396_ATP_Olambda__1216,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: set(B),Uuc: A] :
          ( aa(A,$o,aa(set(B),fun(A,$o),aa(B,fun(set(B),fun(A,$o)),aTP_Lamp_aqp(fun(A,B),fun(B,fun(set(B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(set(B),$o,member(B,aa(A,B,Uu,Uuc)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uub),aa(set(B),set(B),insert(B,Uua),bot_bot(set(B))))) ) ) ).

% ATP.lambda_1216
tff(fact_9397_ATP_Olambda__1217,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: A] : ( aa(A,A,aa(B,fun(A,A),aa(A,fun(B,fun(A,A)),aTP_Lamp_so(fun(B,A),fun(A,fun(B,fun(A,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uuc)) ) ) ).

% ATP.lambda_1217
tff(fact_9398_ATP_Olambda__1218,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_gm(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uuc)),aa(nat,nat,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_1218
tff(fact_9399_ATP_Olambda__1219,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_gd(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_1219
tff(fact_9400_ATP_Olambda__1220,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_gh(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_1220
tff(fact_9401_ATP_Olambda__1221,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_ib(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_1221
tff(fact_9402_ATP_Olambda__1222,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_bae(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(B,set(A),Uu,Uub)),aa(C,set(A),Uua,Uuc)) ) ).

% ATP.lambda_1222
tff(fact_9403_ATP_Olambda__1223,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_bac(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_1223
tff(fact_9404_ATP_Olambda__1224,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_uk(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),Uu,Uub)),aa(C,set(A),Uua,Uuc)) ) ).

% ATP.lambda_1224
tff(fact_9405_ATP_Olambda__1225,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_te(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_1225
tff(fact_9406_ATP_Olambda__1226,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: fun(A,filter(C)),Uua: fun(B,filter(D)),Uub: A,Uuc: B] : ( aa(B,filter(product_prod(C,D)),aa(A,fun(B,filter(product_prod(C,D))),aa(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D)))),aTP_Lamp_axu(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D))))),Uu),Uua),Uub),Uuc) = prod_filter(C,D,aa(A,filter(C),Uu,Uub),aa(B,filter(D),Uua,Uuc)) ) ).

% ATP.lambda_1226
tff(fact_9407_ATP_Olambda__1227,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,$o),Uua: fun(B,$o),Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(fun(B,$o),fun(A,fun(B,$o)),aTP_Lamp_axr(fun(A,$o),fun(fun(B,$o),fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(A,$o,Uu,Uub)
        & aa(B,$o,Uua,Uuc) ) ) ).

% ATP.lambda_1227
tff(fact_9408_ATP_Olambda__1228,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: fun(list(B),A),Uub: list(B),Uuc: B] :
          ( aa(B,$o,aa(list(B),fun(B,$o),aa(fun(list(B),A),fun(list(B),fun(B,$o)),aTP_Lamp_wb(fun(B,A),fun(fun(list(B),A),fun(list(B),fun(B,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(B,A,Uu,Uuc) = aa(list(B),A,Uua,Uub) ) ) ) ).

% ATP.lambda_1228
tff(fact_9409_ATP_Olambda__1229,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(B),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,$o)),Uuc: A] : ( aa(A,C,aa(fun(A,fun(B,$o)),fun(A,C),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(A,C)),aTP_Lamp_no(set(B),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(A,C))),Uu),Uua),Uub),Uuc) = groups7121269368397514597t_prod(B,C,aa(A,fun(B,C),Uua,Uuc),aa(fun(B,$o),set(B),collect(B),aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aTP_Lamp_nj(set(B),fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1229
tff(fact_9410_ATP_Olambda__1230,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: set(B),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,$o)),Uuc: A] : ( aa(A,C,aa(fun(A,fun(B,$o)),fun(A,C),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(A,C)),aTP_Lamp_nk(set(B),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,$o)),fun(A,C))),Uu),Uua),Uub),Uuc) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(A,fun(B,C),Uua,Uuc)),aa(fun(B,$o),set(B),collect(B),aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aTP_Lamp_nj(set(B),fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1230
tff(fact_9411_ATP_Olambda__1231,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_adg(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(nat,real,power_power(real,cos(real,aa(A,real,Uu,Uua))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% ATP.lambda_1231
tff(fact_9412_ATP_Olambda__1232,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_ade(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,power_power(real,aa(A,real,Uu,Uub)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% ATP.lambda_1232
tff(fact_9413_ATP_Olambda__1233,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_acd(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,exp(real),aa(A,real,Uu,Uub))) ) ) ).

% ATP.lambda_1233
tff(fact_9414_ATP_Olambda__1234,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_acf(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),cos(real,aa(A,real,Uu,Uub))) ) ) ).

% ATP.lambda_1234
tff(fact_9415_ATP_Olambda__1235,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_acs(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(A,real,Uu,Uua))) ) ) ).

% ATP.lambda_1235
tff(fact_9416_ATP_Olambda__1236,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_abf(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,aa(A,real,Uu,Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ) ) ).

% ATP.lambda_1236
tff(fact_9417_ATP_Olambda__1237,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_aco(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,uminus_uminus(real),sin(real,aa(A,real,Uu,Uub)))) ) ) ).

% ATP.lambda_1237
tff(fact_9418_ATP_Olambda__1238,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_abh(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,uminus_uminus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,power_power(real,aa(A,real,Uu,Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))) ) ) ).

% ATP.lambda_1238
tff(fact_9419_ATP_Olambda__1239,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_akt(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc))),aa(A,B,Uu,Uub))),aa(A,B,Uua,Uuc)))),real_V7770717601297561774m_norm(A,Uuc)) ) ) ).

% ATP.lambda_1239
tff(fact_9420_ATP_Olambda__1240,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_ala(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,Uub))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))) ) ) ).

% ATP.lambda_1240
tff(fact_9421_ATP_Olambda__1241,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,$o),Uua: A,Uub: set(A),Uuc: A] :
          ( aa(A,$o,aa(set(A),fun(A,$o),aa(A,fun(set(A),fun(A,$o)),aTP_Lamp_aol(fun(A,$o),fun(A,fun(set(A),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( ( Uuc != Uua )
           => ( aa(set(A),$o,member(A,Uuc),Uub)
             => aa(A,$o,Uu,Uuc) ) ) ) ) ).

% ATP.lambda_1241
tff(fact_9422_ATP_Olambda__1242,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(A,B),Uua: fun(A,C),Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(fun(A,C),fun(real,fun(A,$o)),aTP_Lamp_aqo(fun(A,B),fun(fun(A,C),fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(A,C,Uua,Uuc))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uuc))),Uub)) ) ) ).

% ATP.lambda_1242
tff(fact_9423_ATP_Olambda__1243,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: filter(A),Uuc: A] : ( aa(A,B,aa(filter(A),fun(A,B),aa(fun(A,B),fun(filter(A),fun(A,B)),aTP_Lamp_ale(fun(A,B),fun(fun(A,B),fun(filter(A),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_abs(A,A)))))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_abs(A,A))))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_abs(A,A)))))) ) ) ).

% ATP.lambda_1243
tff(fact_9424_ATP_Olambda__1244,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(A,fun(fun(A,B),fun(A,B)),aTP_Lamp_alb(fun(A,B),fun(A,fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uua)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uub,Uuc)),aa(A,B,Uub,Uua))),aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uua)))) ) ) ).

% ATP.lambda_1244
tff(fact_9425_ATP_Olambda__1245,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_alc(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,Uub))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))) ) ) ).

% ATP.lambda_1245
tff(fact_9426_ATP_Olambda__1246,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(B,C),Uuc: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_sc(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),finite_card(A,aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aa(fun(A,B),fun(B,fun(A,$o)),aTP_Lamp_rt(set(A),fun(fun(A,B),fun(B,fun(A,$o))),Uu),Uua),Uuc))))),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_1246
tff(fact_9427_ATP_Olambda__1247,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,$o)),Uua: fun(A,fun(A,$o)),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aTP_Lamp_ayf(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [A6: A] :
            ( ( Uub = A6 )
            & ( Uuc = A6 ) )
        | ? [A6: A,B6: A,C4: A] :
            ( ( Uub = A6 )
            & ( Uuc = C4 )
            & aa(A,$o,aa(A,fun(A,$o),Uua,A6),B6)
            & aa(A,$o,aa(A,fun(A,$o),Uu,B6),C4) ) ) ) ).

% ATP.lambda_1247
tff(fact_9428_ATP_Olambda__1248,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,$o)),Uua: fun(A,fun(A,$o)),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aTP_Lamp_ayg(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [A6: A,B6: A] :
            ( ( Uub = A6 )
            & ( Uuc = B6 )
            & aa(A,$o,aa(A,fun(A,$o),Uu,A6),B6) )
        | ? [A6: A,B6: A,C4: A] :
            ( ( Uub = A6 )
            & ( Uuc = C4 )
            & aa(A,$o,aa(A,fun(A,$o),Uua,A6),B6)
            & aa(A,$o,aa(A,fun(A,$o),Uu,B6),C4) ) ) ) ).

% ATP.lambda_1248
tff(fact_9429_ATP_Olambda__1249,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,$o)),Uua: fun(list(A),fun(list(A),$o)),Uub: list(A),Uuc: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aa(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)),aTP_Lamp_ayk(fun(A,fun(A,$o)),fun(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [Y: A,Ys4: list(A)] :
            ( ( Uub = nil(A) )
            & ( Uuc = aa(list(A),list(A),cons(A,Y),Ys4) ) )
        | ? [X3: A,Y: A,Xs3: list(A),Ys4: list(A)] :
            ( ( Uub = aa(list(A),list(A),cons(A,X3),Xs3) )
            & ( Uuc = aa(list(A),list(A),cons(A,Y),Ys4) )
            & aa(A,$o,aa(A,fun(A,$o),Uu,X3),Y) )
        | ? [X3: A,Y: A,Xs3: list(A),Ys4: list(A)] :
            ( ( Uub = aa(list(A),list(A),cons(A,X3),Xs3) )
            & ( Uuc = aa(list(A),list(A),cons(A,Y),Ys4) )
            & ~ aa(A,$o,aa(A,fun(A,$o),Uu,X3),Y)
            & ~ aa(A,$o,aa(A,fun(A,$o),Uu,Y),X3)
            & aa(list(A),$o,aa(list(A),fun(list(A),$o),Uua,Xs3),Ys4) ) ) ) ).

% ATP.lambda_1249
tff(fact_9430_ATP_Olambda__1250,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: A,Uuc: nat] : ( aa(nat,list(A),aa(A,fun(nat,list(A)),aa(list(A),fun(A,fun(nat,list(A))),aTP_Lamp_xr(A,fun(list(A),fun(A,fun(nat,list(A)))),Uu),Uua),Uub),Uuc) = aa(list(A),list(A),cons(A,Uu),list_update(A,Uua,Uuc,Uub)) ) ).

% ATP.lambda_1250
tff(fact_9431_ATP_Olambda__1251,axiom,
    ! [A: $tType,B: $tType,Uu: $o,Uua: fun(A,fun(B,$o)),Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aTP_Lamp_bi($o,fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( (Uu)
        & aa(B,$o,aa(A,fun(B,$o),Uua,Uub),Uuc) ) ) ).

% ATP.lambda_1251
tff(fact_9432_ATP_Olambda__1252,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,C),Uuc: C] : ( aa(C,B,aa(fun(A,C),fun(C,B),aa(fun(A,B),fun(fun(A,C),fun(C,B)),aTP_Lamp_rs(set(A),fun(fun(A,B),fun(fun(A,C),fun(C,B))),Uu),Uua),Uub),Uuc) = groups7121269368397514597t_prod(A,B,Uua,aa(fun(A,$o),set(A),collect(A),aa(C,fun(A,$o),aa(fun(A,C),fun(C,fun(A,$o)),aTP_Lamp_rp(set(A),fun(fun(A,C),fun(C,fun(A,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1252
tff(fact_9433_ATP_Olambda__1253,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,C),Uuc: B] : ( aa(B,C,aa(fun(A,C),fun(B,C),aa(fun(A,B),fun(fun(A,C),fun(B,C)),aTP_Lamp_rv(set(A),fun(fun(A,B),fun(fun(A,C),fun(B,C))),Uu),Uua),Uub),Uuc) = groups7121269368397514597t_prod(A,C,Uub,aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aa(fun(A,B),fun(B,fun(A,$o)),aTP_Lamp_rt(set(A),fun(fun(A,B),fun(B,fun(A,$o))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_1253
tff(fact_9434_ATP_Olambda__1254,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,C),Uuc: C] : ( aa(C,B,aa(fun(A,C),fun(C,B),aa(fun(A,B),fun(fun(A,C),fun(C,B)),aTP_Lamp_rq(set(A),fun(fun(A,B),fun(fun(A,C),fun(C,B))),Uu),Uua),Uub),Uuc) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),Uua),aa(fun(A,$o),set(A),collect(A),aa(C,fun(A,$o),aa(fun(A,C),fun(C,fun(A,$o)),aTP_Lamp_rp(set(A),fun(fun(A,C),fun(C,fun(A,$o))),Uu),Uub),Uuc))) ) ) ).

% ATP.lambda_1254
tff(fact_9435_ATP_Olambda__1255,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,C),Uuc: B] : ( aa(B,C,aa(fun(A,C),fun(B,C),aa(fun(A,B),fun(fun(A,C),fun(B,C)),aTP_Lamp_ru(set(A),fun(fun(A,B),fun(fun(A,C),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),Uub),aa(fun(A,$o),set(A),collect(A),aa(B,fun(A,$o),aa(fun(A,B),fun(B,fun(A,$o)),aTP_Lamp_rt(set(A),fun(fun(A,B),fun(B,fun(A,$o))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_1255
tff(fact_9436_ATP_Olambda__1256,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(nat,fun(real,fun(A,$o)),aTP_Lamp_aqg(fun(nat,A),fun(nat,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uub),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),Uu),Uuc)),aa(nat,set(nat),set_ord_atMost(nat),Uua)))) ) ) ).

% ATP.lambda_1256
tff(fact_9437_ATP_Olambda__1257,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),A,aa(A,fun(list(A),A),aa(list(A),fun(A,fun(list(A),A)),aTP_Lamp_bay(A,fun(list(A),fun(A,fun(list(A),A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),ord_min(A),Uu),min_list(A,Uua)) ) ) ).

% ATP.lambda_1257
tff(fact_9438_ATP_Olambda__1258,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun($o,fun($o,B)),Uub: $o,Uuc: $o] : ( aa($o,A,aa($o,fun($o,A),aa(fun($o,fun($o,B)),fun($o,fun($o,A)),aTP_Lamp_ac(fun(B,A),fun(fun($o,fun($o,B)),fun($o,fun($o,A))),Uu),Uua),Uub),Uuc) = aa(B,A,Uu,aa($o,B,aa($o,fun($o,B),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1258
tff(fact_9439_ATP_Olambda__1259,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,A),Uua: fun(C,fun(list(C),B)),Uub: C,Uuc: list(C)] : ( aa(list(C),A,aa(C,fun(list(C),A),aa(fun(C,fun(list(C),B)),fun(C,fun(list(C),A)),aTP_Lamp_yb(fun(B,A),fun(fun(C,fun(list(C),B)),fun(C,fun(list(C),A))),Uu),Uua),Uub),Uuc) = aa(B,A,Uu,aa(list(C),B,aa(C,fun(list(C),B),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1259
tff(fact_9440_ATP_Olambda__1260,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Uu: fun(B,A),Uua: fun(C,fun(D,B)),Uub: C,Uuc: D] : ( aa(D,A,aa(C,fun(D,A),aa(fun(C,fun(D,B)),fun(C,fun(D,A)),aTP_Lamp_be(fun(B,A),fun(fun(C,fun(D,B)),fun(C,fun(D,A))),Uu),Uua),Uub),Uuc) = aa(B,A,Uu,aa(D,B,aa(C,fun(D,B),Uua,Uub),Uuc)) ) ).

% ATP.lambda_1260
tff(fact_9441_ATP_Olambda__1261,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_lv(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_1261
tff(fact_9442_ATP_Olambda__1262,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_lt(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_1262
tff(fact_9443_ATP_Olambda__1263,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_lb(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_1263
tff(fact_9444_ATP_Olambda__1264,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_jn(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_1264
tff(fact_9445_ATP_Olambda__1265,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo7287701948861334536_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: fun(product_prod(B,B),$o),Uuc: A] :
          ( aa(A,$o,aa(fun(product_prod(B,B),$o),fun(A,$o),aa(B,fun(fun(product_prod(B,B),$o),fun(A,$o)),aTP_Lamp_axa(fun(A,B),fun(B,fun(fun(product_prod(B,B),$o),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(product_prod(B,B),$o,Uub,aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,Uu,Uuc)),Uua)) ) ) ).

% ATP.lambda_1265
tff(fact_9446_ATP_Olambda__1266,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,$o),Uua: fun(A,set(product_prod(B,B))),Uub: A,Uuc: B] : ( aa(B,fun(product_prod(A,B),$o),aa(A,fun(B,fun(product_prod(A,B),$o)),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),$o))),aTP_Lamp_awp(fun(A,$o),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),$o)))),Uu),Uua),Uub),Uuc) = aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aa(B,fun(A,fun(B,$o)),aa(A,fun(B,fun(A,fun(B,$o))),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,$o)))),aTP_Lamp_awo(fun(A,$o),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,$o))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_1266
tff(fact_9447_ATP_Olambda__1267,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(B,B)),Uub: A,Uuc: B] : ( aa(B,fun(product_prod(A,B),$o),aa(A,fun(B,fun(product_prod(A,B),$o)),aa(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),$o))),aTP_Lamp_awn(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),$o)))),Uu),Uua),Uub),Uuc) = aa(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),product_case_prod(A,B,$o),aa(B,fun(A,fun(B,$o)),aa(A,fun(B,fun(A,fun(B,$o))),aa(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,$o)))),aTP_Lamp_awm(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,$o))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_1267
tff(fact_9448_ATP_Olambda__1268,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: set(C),Uuc: B] : ( aa(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_ul(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_uk(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_1268
tff(fact_9449_ATP_Olambda__1269,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_tf(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_te(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_1269
tff(fact_9450_ATP_Olambda__1270,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: set(C),Uuc: B] : ( aa(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_baf(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_bae(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_1270
tff(fact_9451_ATP_Olambda__1271,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_bad(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_bac(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_1271
tff(fact_9452_ATP_Olambda__1272,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: set(B),Uua: fun(A,filter(C)),Uub: fun(B,filter(D)),Uuc: A] : ( aa(A,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(A,filter(product_prod(C,D))),aa(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D)))),aTP_Lamp_axv(set(B),fun(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D))))),Uu),Uua),Uub),Uuc) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(B),set(filter(product_prod(C,D))),image(B,filter(product_prod(C,D)),aa(A,fun(B,filter(product_prod(C,D))),aa(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D)))),aTP_Lamp_axu(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D))))),Uua),Uub),Uuc)),Uu)) ) ).

% ATP.lambda_1272
tff(fact_9453_ATP_Olambda__1273,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_jy(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1273
tff(fact_9454_ATP_Olambda__1274,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_jj(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1274
tff(fact_9455_ATP_Olambda__1275,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_yq(fun(A,$o),fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),takeWhile(A,aa(fun(A,$o),fun(A,$o),comp($o,$o,A,fNot),Uu),Uua)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Uub),Uuc))) ) ).

% ATP.lambda_1275
tff(fact_9456_ATP_Olambda__1276,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(B,A),Uua: B,Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_acj(fun(B,A),fun(B,fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua))),aa(B,A,Uub,Uuc))),aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua)))) ) ) ).

% ATP.lambda_1276
tff(fact_9457_ATP_Olambda__1277,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_yo(A,fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),aa(list(A),list(A),cons(A,Uu),Uua)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Uub),Uuc))) ) ).

% ATP.lambda_1277
tff(fact_9458_ATP_Olambda__1278,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_ka(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uub)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_1278
tff(fact_9459_ATP_Olambda__1279,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_kd(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_1279
tff(fact_9460_ATP_Olambda__1280,axiom,
    ! [C: $tType,A: $tType,B: $tType,E4: $tType,D: $tType,Uu: fun(B,fun(C,fun(D,fun(E4,set(A))))),Uua: set(product_prod(D,E4)),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(set(product_prod(D,E4)),fun(B,fun(C,set(A))),aTP_Lamp_vp(fun(B,fun(C,fun(D,fun(E4,set(A))))),fun(set(product_prod(D,E4)),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(D,E4)),set(set(A)),image(product_prod(D,E4),set(A),aa(fun(D,fun(E4,set(A))),fun(product_prod(D,E4),set(A)),product_case_prod(D,E4,set(A)),aa(C,fun(D,fun(E4,set(A))),aa(B,fun(C,fun(D,fun(E4,set(A)))),Uu,Uub),Uuc))),Uua)) ) ).

% ATP.lambda_1280
tff(fact_9461_ATP_Olambda__1281,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: set(B),Uub: B,Uuc: fun(A,B)] :
      ( aa(fun(A,B),$o,aa(B,fun(fun(A,B),$o),aa(set(B),fun(B,fun(fun(A,B),$o)),aTP_Lamp_ars(set(A),fun(set(B),fun(B,fun(fun(A,B),$o))),Uu),Uua),Uub),Uuc)
    <=> ! [X3: A] :
          ( ( aa(set(A),$o,member(A,X3),Uu)
           => aa(set(B),$o,member(B,aa(A,B,Uuc,X3)),Uua) )
          & ( ~ aa(set(A),$o,member(A,X3),Uu)
           => ( aa(A,B,Uuc,X3) = Uub ) ) ) ) ).

% ATP.lambda_1281
tff(fact_9462_ATP_Olambda__1282,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: set(product_prod(A,C)),Uua: set(product_prod(C,B)),Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(set(product_prod(C,B)),fun(A,fun(B,$o)),aTP_Lamp_asz(set(product_prod(A,C)),fun(set(product_prod(C,B)),fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ? [Y: C] :
          ( aa(set(product_prod(A,C)),$o,member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),Uub),Y)),Uu)
          & aa(set(product_prod(C,B)),$o,member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Y),Uuc)),Uua) ) ) ).

% ATP.lambda_1282
tff(fact_9463_ATP_Olambda__1283,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: set(C),Uua: fun(C,A),Uub: fun(C,B),Uuc: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aa(fun(C,B),fun(product_prod(A,B),$o),aa(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),$o)),aTP_Lamp_axx(set(C),fun(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),$o))),Uu),Uua),Uub),Uuc)
    <=> ? [A6: C] :
          ( ( Uuc = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uua,A6)),aa(C,B,Uub,A6)) )
          & aa(set(C),$o,member(C,A6),Uu) ) ) ).

% ATP.lambda_1283
tff(fact_9464_ATP_Olambda__1284,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,$o),Uua: fun(B,$o),Uub: fun(A,fun(B,C)),Uuc: C] :
      ( aa(C,$o,aa(fun(A,fun(B,C)),fun(C,$o),aa(fun(B,$o),fun(fun(A,fun(B,C)),fun(C,$o)),aTP_Lamp_aso(fun(A,$o),fun(fun(B,$o),fun(fun(A,fun(B,C)),fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ? [X3: A,Y: B] :
          ( ( Uuc = aa(B,C,aa(A,fun(B,C),Uub,X3),Y) )
          & aa(A,$o,Uu,X3)
          & aa(B,$o,Uua,Y) ) ) ).

% ATP.lambda_1284
tff(fact_9465_ATP_Olambda__1285,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: C,Uua: A,Uub: A,Uuc: B,Uud: set(product_prod(C,B))] :
      ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(B,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aa(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),aTP_Lamp_bbl(C,fun(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))))),Uu),Uua),Uub),Uuc),Uud)
      = $ite(Uua = Uub,aa(set(product_prod(C,B)),set(product_prod(C,B)),insert(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_1285
tff(fact_9466_ATP_Olambda__1286,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: A,Uua: B,Uub: B,Uuc: C,Uud: set(product_prod(A,C))] :
      ( aa(set(product_prod(A,C)),set(product_prod(A,C)),aa(C,fun(set(product_prod(A,C)),set(product_prod(A,C))),aa(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),aTP_Lamp_bbf(A,fun(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))))),Uu),Uua),Uub),Uuc),Uud)
      = $ite(Uua = Uub,aa(set(product_prod(A,C)),set(product_prod(A,C)),insert(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_1286
tff(fact_9467_ATP_Olambda__1287,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,fun(A,B)),Uua: fun(C,A),Uub: C,Uuc: fun(C,A),Uud: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aa(C,fun(fun(C,A),fun(C,B)),aa(fun(C,A),fun(C,fun(fun(C,A),fun(C,B))),aTP_Lamp_acb(fun(A,fun(A,B)),fun(fun(C,A),fun(C,fun(fun(C,A),fun(C,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,B,aa(A,fun(A,B),Uu,aa(C,A,Uua,Uub)),aa(C,A,Uuc,Uud)) ) ) ).

% ATP.lambda_1287
tff(fact_9468_ATP_Olambda__1288,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,C)),Uuc: B,Uud: B] : ( aa(B,C,aa(B,fun(B,C),aa(fun(A,fun(B,C)),fun(B,fun(B,C)),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C))),aTP_Lamp_acy(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),aa(B,fun(B,fun(A,C)),aa(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C)))),aTP_Lamp_acx(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))))),Uu),Uua),Uub),Uuc),Uud)),Uu) ) ) ).

% ATP.lambda_1288
tff(fact_9469_ATP_Olambda__1289,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_je(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aa(A,fun(A,fun(nat,fun(nat,A))),aTP_Lamp_jd(fun(nat,A),fun(A,fun(A,fun(nat,fun(nat,A)))),Uua),Uub),Uuc),Uud)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1289
tff(fact_9470_ATP_Olambda__1290,axiom,
    ! [Uu: $o,Uua: $o,Uub: $o,Uuc: code_integer,Uud: $o] : ( aa($o,char,aa(code_integer,fun($o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aTP_Lamp_xm($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),Uu),Uua),Uub),Uuc),Uud) = aa(product_prod(code_integer,$o),char,aa(fun(code_integer,fun($o,char)),fun(product_prod(code_integer,$o),char),product_case_prod(code_integer,$o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aa($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),aTP_Lamp_xl($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))),Uu),Uua),Uub),Uud)),code_bit_cut_integer(Uuc)) ) ).

% ATP.lambda_1290
tff(fact_9471_ATP_Olambda__1291,axiom,
    ! [Uu: nat,Uua: fun(nat,fun(real,real)),Uub: real,Uuc: nat,Uud: real] : ( aa(real,real,aa(nat,fun(real,real),aa(real,fun(nat,fun(real,real)),aa(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real))),aTP_Lamp_aba(nat,fun(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real)))),Uu),Uua),Uub),Uuc),Uud) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(nat,fun(real,real),Uua,Uuc),Uud)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_aaz(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uua),Uuc),Uud)),aa(nat,set(nat),set_ord_lessThan(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)))),aa(real,real,aa(real,fun(real,real),times_times(real),Uub),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,power_power(real,Uud),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)))))) ) ).

% ATP.lambda_1291
tff(fact_9472_ATP_Olambda__1292,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_kg(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_kf(fun(nat,A),fun(A,fun(nat,fun(nat,A))),Uua),Uuc),Uud)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uud),Uu))),aa(nat,A,power_power(A,Uub),Uud)) ) ) ).

% ATP.lambda_1292
tff(fact_9473_ATP_Olambda__1293,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gz(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uud)),Uua)),one_one(A))),Uud)),aa(nat,A,power_power(A,Uub),Uud))),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1293
tff(fact_9474_ATP_Olambda__1294,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gt(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),Uua)),Uud)),aa(nat,A,power_power(A,Uub),Uud))),aa(nat,A,power_power(A,Uuc),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1294
tff(fact_9475_ATP_Olambda__1295,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: set(product_prod(A,A)),Uuc: A,Uud: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_baw(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uuc),Uu)),transitive_trancl(A,Uub))
          | ( Uuc = Uu ) )
        & ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud)),transitive_trancl(A,Uub))
          | ( Uud = Uua ) ) ) ) ).

% ATP.lambda_1295
tff(fact_9476_ATP_Olambda__1296,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gu(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),Uua)),Uud)),aa(nat,A,power_power(A,aa(A,A,uminus_uminus(A),Uub)),Uud))),aa(nat,A,power_power(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_1296
tff(fact_9477_ATP_Olambda__1297,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: set(product_prod(A,A)),Uuc: A,Uud: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_bav(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uuc),Uu)),transitive_rtrancl(A,Uub))
        & aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud)),transitive_rtrancl(A,Uub)) ) ) ).

% ATP.lambda_1297
tff(fact_9478_ATP_Olambda__1298,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: A,Uuc: nat,Uud: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aa(A,fun(A,fun(nat,fun(nat,A))),aTP_Lamp_jd(fun(nat,A),fun(A,fun(A,fun(nat,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uuc),Uud)),one_one(nat)))),aa(nat,A,power_power(A,Uub),Uud))),aa(nat,A,power_power(A,Uua),Uuc)) ) ) ).

% ATP.lambda_1298
tff(fact_9479_ATP_Olambda__1299,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(C) )
     => ! [Uu: fun(A,B),Uua: B,Uub: fun(A,C),Uuc: C,Uud: A] :
          ( aa(A,$o,aa(C,fun(A,$o),aa(fun(A,C),fun(C,fun(A,$o)),aa(B,fun(fun(A,C),fun(C,fun(A,$o))),aTP_Lamp_apy(fun(A,B),fun(B,fun(fun(A,C),fun(C,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(C,aa(A,C,Uub,Uud),Uuc)),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uud),Uua)) ) ) ).

% ATP.lambda_1299
tff(fact_9480_ATP_Olambda__1300,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: fun(B,C),Uuc: C,Uud: A] :
          ( aa(A,$o,aa(C,fun(A,$o),aa(fun(B,C),fun(C,fun(A,$o)),aa(B,fun(fun(B,C),fun(C,fun(A,$o))),aTP_Lamp_aqh(fun(A,B),fun(B,fun(fun(B,C),fun(C,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
        <=> ( ( aa(A,B,Uu,Uud) = Uua )
           => ( aa(B,C,Uub,Uua) = Uuc ) ) ) ) ).

% ATP.lambda_1300
tff(fact_9481_ATP_Olambda__1301,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: nat,Uud: A] : ( aa(A,B,aa(nat,fun(A,B),aa(A,fun(nat,fun(A,B)),aa(fun(A,B),fun(A,fun(nat,fun(A,B))),aTP_Lamp_acq(fun(A,B),fun(fun(A,B),fun(A,fun(nat,fun(A,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),Uuc)),aa(A,B,Uua,Uud))),aa(nat,B,power_power(B,aa(A,B,Uu,Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),one_one(nat)))) ) ) ).

% ATP.lambda_1301
tff(fact_9482_ATP_Olambda__1302,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo7287701948861334536_space(A)
        & topolo7287701948861334536_space(B) )
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(product_prod(B,B),$o),Uuc: A,Uud: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aa(fun(product_prod(B,B),$o),fun(A,fun(A,$o)),aa(fun(A,B),fun(fun(product_prod(B,B),$o),fun(A,fun(A,$o))),aTP_Lamp_azl(set(A),fun(fun(A,B),fun(fun(product_prod(B,B),$o),fun(A,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
        <=> ( aa(set(A),$o,member(A,Uuc),Uu)
           => ( aa(set(A),$o,member(A,Uud),Uu)
             => aa(product_prod(B,B),$o,Uub,aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,Uua,Uuc)),aa(A,B,Uua,Uud))) ) ) ) ) ).

% ATP.lambda_1302
tff(fact_9483_ATP_Olambda__1303,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [Uu: fun(product_prod(A,A),$o),Uua: A,Uub: A,Uuc: A,Uud: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aa(A,fun(A,fun(A,$o)),aa(A,fun(A,fun(A,fun(A,$o))),aTP_Lamp_axi(fun(product_prod(A,A),$o),fun(A,fun(A,fun(A,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
        <=> ( ( Uub = Uuc )
           => aa(product_prod(A,A),$o,Uu,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud)) ) ) ) ).

% ATP.lambda_1303
tff(fact_9484_ATP_Olambda__1304,axiom,
    ! [Uu: $o,Uua: $o,Uub: $o,Uuc: $o,Uud: code_integer,Uue: $o] : ( aa($o,char,aa(code_integer,fun($o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aa($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),aTP_Lamp_xl($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(product_prod(code_integer,$o),char,aa(fun(code_integer,fun($o,char)),fun(product_prod(code_integer,$o),char),product_case_prod(code_integer,$o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aa($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),aa($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))),aTP_Lamp_xk($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char)))))),Uu),Uua),Uub),Uuc),Uue)),code_bit_cut_integer(Uud)) ) ).

% ATP.lambda_1304
tff(fact_9485_ATP_Olambda__1305,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,C)),Uuc: B,Uud: B,Uue: A] : ( aa(A,C,aa(B,fun(A,C),aa(B,fun(B,fun(A,C)),aa(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C)))),aTP_Lamp_acx(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,aa(A,fun(B,C),Uub,Uue),Uud)),groups7121269368397514597t_prod(A,C,aa(B,fun(A,C),aTP_Lamp_acv(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uuc),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),aa(set(A),set(A),insert(A,Uue),bot_bot(set(A)))))) ) ) ).

% ATP.lambda_1305
tff(fact_9486_ATP_Olambda__1306,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_ach(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uue)),aa(A,B,Uuc,Uub))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uud,Uue)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uuc,Uub)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_1306
tff(fact_9487_ATP_Olambda__1307,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(B,B)),Uub: A,Uuc: B,Uud: A,Uue: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(B,fun(A,fun(B,$o)),aa(A,fun(B,fun(A,fun(B,$o))),aa(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,$o)))),aTP_Lamp_awm(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,$o))))),Uu),Uua),Uub),Uuc),Uud),Uue)
    <=> ( aa(set(product_prod(A,A)),$o,member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uud)),Uu)
        | ( ( Uub = Uud )
          & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uue)),Uua) ) ) ) ).

% ATP.lambda_1307
tff(fact_9488_ATP_Olambda__1308,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: fun(A,real),Uud: fun(A,real),Uue: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(fun(A,real),fun(fun(A,real),fun(A,real)),aa(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))),aa(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real)))),aTP_Lamp_ada(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,aa(A,real,Uu,Uub),aa(A,real,Uuc,Uub))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uud,Uue)),aa(real,real,ln_ln(real),aa(A,real,Uu,Uub)))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uue)),aa(A,real,Uuc,Uub))),aa(A,real,Uu,Uub)))) ) ) ).

% ATP.lambda_1308
tff(fact_9489_ATP_Olambda__1309,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_abk(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uud,Uue))),aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uua,Uue)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_1309
tff(fact_9490_ATP_Olambda__1310,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_abz(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uud,Uue))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uue)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_1310
tff(fact_9491_ATP_Olambda__1311,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_acu(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(A,B,Uu,Uub))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),aa(A,B,Uuc,Uub))),aa(A,B,Uud,Uue))),aa(B,B,inverse_inverse(B),aa(A,B,Uuc,Uub))))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uua,Uue)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_1311
tff(fact_9492_ATP_Olambda__1312,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,$o),Uua: fun(A,set(product_prod(B,B))),Uub: A,Uuc: B,Uud: A,Uue: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(B,fun(A,fun(B,$o)),aa(A,fun(B,fun(A,fun(B,$o))),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,$o)))),aTP_Lamp_awo(fun(A,$o),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,$o))))),Uu),Uua),Uub),Uuc),Uud),Uue)
    <=> ( ( Uub = Uud )
        & aa(A,$o,Uu,Uud)
        & aa(set(product_prod(B,B)),$o,member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uue)),aa(A,set(product_prod(B,B)),Uua,Uud)) ) ) ).

% ATP.lambda_1312
tff(fact_9493_ATP_Olambda__1313,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,B)))),Uub: option(product_prod(nat,nat)),Uuc: nat,Uud: list(vEBT_VEBT),Uue: vEBT_VEBT] : ( aa(vEBT_VEBT,A,aa(list(vEBT_VEBT),fun(vEBT_VEBT,A),aa(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A)),aa(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A))),aa(fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,B)))),fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A)))),aTP_Lamp_ab(fun(B,A),fun(fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,B)))),fun(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,A))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,A,Uu,aa(vEBT_VEBT,B,aa(list(vEBT_VEBT),fun(vEBT_VEBT,B),aa(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,B)),aa(option(product_prod(nat,nat)),fun(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,B))),Uua,Uub),Uuc),Uud),Uue)) ) ).

% ATP.lambda_1313
tff(fact_9494_ATP_Olambda__1314,axiom,
    ! [Uu: $o,Uua: $o,Uub: $o,Uuc: $o,Uud: $o,Uue: code_integer,Uuf: $o] : ( aa($o,char,aa(code_integer,fun($o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aa($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),aa($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))),aTP_Lamp_xk($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char)))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uuf) = aa(product_prod(code_integer,$o),char,aa(fun(code_integer,fun($o,char)),fun(product_prod(code_integer,$o),char),product_case_prod(code_integer,$o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aa($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),aa($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))),aa($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char)))))),aTP_Lamp_xj($o,fun($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))))),Uu),Uua),Uub),Uuc),Uud),Uuf)),code_bit_cut_integer(Uue)) ) ).

% ATP.lambda_1314
tff(fact_9495_ATP_Olambda__1315,axiom,
    ! [Uu: nat,Uua: list(vEBT_VEBT),Uub: vEBT_VEBT,Uuc: nat,Uud: nat,Uue: nat,Uuf: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ary(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uuf)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uue),Uuf)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuf),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uu))
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uud))
           => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,Uua),I)),X_12)
            <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Uub),I) ) )
        & $ite(
            Uue = Uuf,
            ! [X3: vEBT_VEBT] :
              ( aa(set(vEBT_VEBT),$o,member(vEBT_VEBT,X3),aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),Uua))
             => ~ ? [X16: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X16) ),
            ( vEBT_V5917875025757280293ildren(Uuc,Uua,Uuf)
            & ! [X3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),aa(nat,nat,power_power(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uu))
               => ( vEBT_V5917875025757280293ildren(Uuc,Uua,X3)
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uue),X3)
                    & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Uuf) ) ) ) ) ) ) ) ).

% ATP.lambda_1315
tff(fact_9496_ATP_Olambda__1316,axiom,
    ! [Uu: $o,Uua: $o,Uub: $o,Uuc: $o,Uud: $o,Uue: $o,Uuf: $o,Uug: code_integer] : ( aa(code_integer,fun($o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aa($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),aa($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))),aa($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char)))))),aa($o,fun($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))))),aTP_Lamp_xi($o,fun($o,fun($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char)))))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uuf),Uug) = char2(Uu,Uua,Uub,Uuc,Uud,Uue,Uuf) ) ).

% ATP.lambda_1316
tff(fact_9497_ATP_Olambda__1317,axiom,
    ! [Uu: $o,Uua: $o,Uub: $o,Uuc: $o,Uud: $o,Uue: $o,Uuf: code_integer,Uug: $o] : ( aa($o,char,aa(code_integer,fun($o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aa($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),aa($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))),aa($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char)))))),aTP_Lamp_xj($o,fun($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uuf),Uug) = aa(product_prod(code_integer,$o),char,aa(fun(code_integer,fun($o,char)),fun(product_prod(code_integer,$o),char),product_case_prod(code_integer,$o,char),aa($o,fun(code_integer,fun($o,char)),aa($o,fun($o,fun(code_integer,fun($o,char))),aa($o,fun($o,fun($o,fun(code_integer,fun($o,char)))),aa($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))),aa($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char)))))),aa($o,fun($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char))))))),aTP_Lamp_xi($o,fun($o,fun($o,fun($o,fun($o,fun($o,fun($o,fun(code_integer,fun($o,char)))))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uug)),code_bit_cut_integer(Uuf)) ) ).

% ATP.lambda_1317
tff(fact_9498_ATP_Olambda__1318,axiom,
    ! [B: $tType,A: $tType,Uu: $o,Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_xe($o,fun(A,fun(B,$o)),Uu),Uua),Uub)
    <=> (Uu) ) ).

% ATP.lambda_1318
tff(fact_9499_ATP_Olambda__1319,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: $o,Uua: A] :
          ( aa(A,$o,aTP_Lamp_alf($o,fun(A,$o),Uu),Uua)
        <=> (Uu) ) ) ).

% ATP.lambda_1319
tff(fact_9500_ATP_Olambda__1320,axiom,
    ! [A: $tType,Uu: $o,Uua: A] :
      ( aa(A,$o,aTP_Lamp_wn($o,fun(A,$o),Uu),Uua)
    <=> (Uu) ) ).

% ATP.lambda_1320
tff(fact_9501_ATP_Olambda__1321,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: B] : ( aa(B,set(A),aTP_Lamp_tu(set(A),fun(B,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1321
tff(fact_9502_ATP_Olambda__1322,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,$o),Uua: A] : ( aa(A,fun(B,$o),aTP_Lamp_axq(fun(B,$o),fun(A,fun(B,$o)),Uu),Uua) = Uu ) ).

% ATP.lambda_1322
tff(fact_9503_ATP_Olambda__1323,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,B),Uua: A] : ( aa(A,fun(B,B),aTP_Lamp_bbp(fun(B,B),fun(A,fun(B,B)),Uu),Uua) = Uu ) ).

% ATP.lambda_1323
tff(fact_9504_ATP_Olambda__1324,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_ut(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1324
tff(fact_9505_ATP_Olambda__1325,axiom,
    ! [A: $tType,B: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_ts(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1325
tff(fact_9506_ATP_Olambda__1326,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_abp(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1326
tff(fact_9507_ATP_Olambda__1327,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_auz(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1327
tff(fact_9508_ATP_Olambda__1328,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topological_t2_space(A) )
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_age(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1328
tff(fact_9509_ATP_Olambda__1329,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_adl(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1329
tff(fact_9510_ATP_Olambda__1330,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_tt(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1330
tff(fact_9511_ATP_Olambda__1331,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo7287701948861334536_space(B)
        & topolo7287701948861334536_space(A) )
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_azo(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1331
tff(fact_9512_ATP_Olambda__1332,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_arc(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1332
tff(fact_9513_ATP_Olambda__1333,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topological_t2_space(B)
        & topolo8386298272705272623_space(A) )
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_aee(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1333
tff(fact_9514_ATP_Olambda__1334,axiom,
    ! [A: $tType,B: $tType] :
      ( topological_t2_space(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_aev(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1334
tff(fact_9515_ATP_Olambda__1335,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_amv(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1335
tff(fact_9516_ATP_Olambda__1336,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_ro(B,fun(A,B),Uu),Uua) = Uu ) ).

% ATP.lambda_1336
tff(fact_9517_ATP_Olambda__1337,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_vo(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1337
tff(fact_9518_ATP_Olambda__1338,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cd(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1338
tff(fact_9519_ATP_Olambda__1339,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_zx(A,fun(A,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1339
tff(fact_9520_ATP_Olambda__1340,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_uq(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1340
tff(fact_9521_ATP_Olambda__1341,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_po(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1341
tff(fact_9522_ATP_Olambda__1342,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_aiu(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1342
tff(fact_9523_ATP_Olambda__1343,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo8386298272705272623_space(B) )
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_aec(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1343
tff(fact_9524_ATP_Olambda__1344,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_pb(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1344
tff(fact_9525_ATP_Olambda__1345,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_pd(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1345
tff(fact_9526_ATP_Olambda__1346,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_arv(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1346
tff(fact_9527_ATP_Olambda__1347,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zero(A)
        & topological_t2_space(A)
        & topolo8386298272705272623_space(B) )
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_adx(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_1347
tff(fact_9528_ATP_Olambda__1348,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_lr(A,fun(nat,A),Uu),Uua) = Uu ) ).

% ATP.lambda_1348
tff(fact_9529_ATP_Olambda__1349,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_aq(A,fun(B,A)),Uu),Uua) = Uu ) ).

% ATP.lambda_1349
tff(fact_9530_ATP_Olambda__1350,axiom,
    ! [B: $tType,A: $tType,Uu: B,Uua: A] : ( aa(A,A,aa(B,fun(A,A),aTP_Lamp_ot(B,fun(A,A)),Uu),Uua) = Uua ) ).

% ATP.lambda_1350
tff(fact_9531_ATP_Olambda__1351,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),list(A),aa(A,fun(list(A),list(A)),aTP_Lamp_yh(A,fun(list(A),list(A))),Uu),Uua) = Uua ) ).

% ATP.lambda_1351
tff(fact_9532_ATP_Olambda__1352,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] :
      ( aa(list(A),$o,aa(A,fun(list(A),$o),aTP_Lamp_yf(A,fun(list(A),$o)),Uu),Uua)
    <=> $false ) ).

% ATP.lambda_1352
tff(fact_9533_ATP_Olambda__1353,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] :
      ( aa(list(A),$o,aa(A,fun(list(A),$o),aTP_Lamp_yg(A,fun(list(A),$o)),Uu),Uua)
    <=> $true ) ).

% ATP.lambda_1353
tff(fact_9534_ATP_Olambda__1354,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_bj(A,fun(B,$o)),Uu),Uua)
    <=> $true ) ).

% ATP.lambda_1354
tff(fact_9535_ATP_Olambda__1355,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_qc(A,fun(A,$o)),Uu),Uua)
    <=> $true ) ).

% ATP.lambda_1355
tff(fact_9536_ATP_Olambda__1356,axiom,
    ! [Uu: complex] : ( aa(complex,complex,aTP_Lamp_hs(complex,complex),Uu) = Uu ) ).

% ATP.lambda_1356
tff(fact_9537_ATP_Olambda__1357,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_jv(nat,nat),Uu) = Uu ) ).

% ATP.lambda_1357
tff(fact_9538_ATP_Olambda__1358,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_ki(int,int),Uu) = Uu ) ).

% ATP.lambda_1358
tff(fact_9539_ATP_Olambda__1359,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_azc(B,B),Uu) = Uu ) ) ).

% ATP.lambda_1359
tff(fact_9540_ATP_Olambda__1360,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_azd(B,B),Uu) = Uu ) ) ).

% ATP.lambda_1360
tff(fact_9541_ATP_Olambda__1361,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_abs(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1361
tff(fact_9542_ATP_Olambda__1362,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_adm(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1362
tff(fact_9543_ATP_Olambda__1363,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_zv(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1363
tff(fact_9544_ATP_Olambda__1364,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_azp(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1364
tff(fact_9545_ATP_Olambda__1365,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_aek(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1365
tff(fact_9546_ATP_Olambda__1366,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_alk(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1366
tff(fact_9547_ATP_Olambda__1367,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_pv(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1367
tff(fact_9548_ATP_Olambda__1368,axiom,
    ! [A: $tType] :
      ( complete_Sup(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_to(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1368
tff(fact_9549_ATP_Olambda__1369,axiom,
    ! [A: $tType] :
      ( complete_Inf(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_uy(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1369
tff(fact_9550_ATP_Olambda__1370,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_qr(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1370
tff(fact_9551_ATP_Olambda__1371,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ao(A,A),Uu) = Uu ) ) ).

% ATP.lambda_1371
tff(fact_9552_ATP_Olambda__1372,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,A,aTP_Lamp_ae(A,A),Uu) = Uu ) ).

% ATP.lambda_1372
tff(fact_9553_ATP_Olambda__1373,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_wo(B,A),Uu) = top_top(A) ) ) ).

% ATP.lambda_1373
tff(fact_9554_ATP_Olambda__1374,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_wp(B,A),Uu) = top_top(A) ) ) ).

% ATP.lambda_1374
tff(fact_9555_ATP_Olambda__1375,axiom,
    ! [C: $tType,B: $tType,Uu: C] : ( aa(C,set(B),aTP_Lamp_se(C,set(B)),Uu) = bot_bot(set(B)) ) ).

% ATP.lambda_1375
tff(fact_9556_ATP_Olambda__1376,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,set(A),aTP_Lamp_ui(B,set(A)),Uu) = bot_bot(set(A)) ) ).

% ATP.lambda_1376
tff(fact_9557_ATP_Olambda__1377,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_tq(B,A),Uu) = bot_bot(A) ) ) ).

% ATP.lambda_1377
tff(fact_9558_ATP_Olambda__1378,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_tr(B,A),Uu) = bot_bot(A) ) ) ).

% ATP.lambda_1378
tff(fact_9559_ATP_Olambda__1379,axiom,
    ! [A: $tType,D: $tType,Uu: A] : ( aa(A,set(D),aTP_Lamp_sf(A,set(D)),Uu) = bot_bot(set(D)) ) ).

% ATP.lambda_1379
tff(fact_9560_ATP_Olambda__1380,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_bu(nat,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_1380
tff(fact_9561_ATP_Olambda__1381,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_bs(nat,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_1381
tff(fact_9562_ATP_Olambda__1382,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_ho(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_1382
tff(fact_9563_ATP_Olambda__1383,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_pc(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_1383
tff(fact_9564_ATP_Olambda__1384,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_abq(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_1384
tff(fact_9565_ATP_Olambda__1385,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_al(A,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_1385
tff(fact_9566_ATP_Olambda__1386,axiom,
    ! [A: $tType,B: $tType] :
      ( zero(B)
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_em(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_1386
tff(fact_9567_ATP_Olambda__1387,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_kj(B,A),Uu) = one_one(A) ) ) ).

% ATP.lambda_1387
tff(fact_9568_ATP_Olambda__1388,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,real,aTP_Lamp_pq(A,real),Uu) = one_one(real) ) ).

% ATP.lambda_1388
tff(fact_9569_ATP_Olambda__1389,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,nat,aTP_Lamp_pi(A,nat),Uu) = one_one(nat) ) ).

% ATP.lambda_1389
tff(fact_9570_ATP_Olambda__1390,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,option(A),aTP_Lamp_sj(B,option(A)),Uu) = none(A) ) ).

% ATP.lambda_1390
tff(fact_9571_ATP_Olambda__1391,axiom,
    ! [A: $tType,C: $tType,Uu: A] : ( aa(A,option(C),aTP_Lamp_ayd(A,option(C)),Uu) = none(C) ) ).

% ATP.lambda_1391
tff(fact_9572_ATP_Olambda__1392,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,option(B),aTP_Lamp_ri(A,option(B)),Uu) = none(B) ) ).

% ATP.lambda_1392
tff(fact_9573_ATP_Olambda__1393,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_du(real,$o),Uu)
    <=> $false ) ).

% ATP.lambda_1393
tff(fact_9574_ATP_Olambda__1394,axiom,
    ! [Uu: nat] :
      ( aa(nat,$o,aTP_Lamp_mv(nat,$o),Uu)
    <=> $false ) ).

% ATP.lambda_1394
tff(fact_9575_ATP_Olambda__1395,axiom,
    ! [A: $tType,Uu: A] :
      ( aa(A,$o,aTP_Lamp_py(A,$o),Uu)
    <=> $false ) ).

% ATP.lambda_1395
tff(fact_9576_ATP_Olambda__1396,axiom,
    ! [Uu: nat] :
      ( aa(nat,$o,aTP_Lamp_mw(nat,$o),Uu)
    <=> $true ) ).

% ATP.lambda_1396
tff(fact_9577_ATP_Olambda__1397,axiom,
    ! [A: $tType,Uu: A] :
      ( aa(A,$o,aTP_Lamp_ws(A,$o),Uu)
    <=> $true ) ).

% ATP.lambda_1397
tff(fact_9578_ATP_Olambda__1398,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,fun(nat,nat),aTP_Lamp_bbc(A,fun(nat,nat)),Uu) = suc ) ).

% ATP.lambda_1398

% Type constructors (787)
tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    bounded_lattice(extended_enat) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice_1,axiom,
    ! [A11: $tType] : bounded_lattice(filter(A11)) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice_2,axiom,
    bounded_lattice($o) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice_3,axiom,
    ! [A11: $tType] : bounded_lattice(set(A11)) ).

tff(tcon_fun___Lattices_Obounded__lattice_4,axiom,
    ! [A11: $tType,A13: $tType] :
      ( bounded_lattice(A13)
     => bounded_lattice(fun(A11,A13)) ) ).

tff(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( comple6319245703460814977attice(A13)
     => condit1219197933456340205attice(fun(A11,A13)) ) ).

tff(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( counta3822494911875563373attice(A13)
     => counta3822494911875563373attice(fun(A11,A13)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( comple592849572758109894attice(A13)
     => comple592849572758109894attice(fun(A11,A13)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__boolean__algebra,axiom,
    ! [A11: $tType,A13: $tType] :
      ( comple489889107523837845lgebra(A13)
     => comple489889107523837845lgebra(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A11: $tType,A13: $tType] :
      ( bounded_lattice(A13)
     => bounde4967611905675639751up_bot(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A11: $tType,A13: $tType] :
      ( bounded_lattice(A13)
     => bounde4346867609351753570nf_top(fun(A11,A13)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( comple6319245703460814977attice(A13)
     => comple6319245703460814977attice(fun(A11,A13)) ) ).

tff(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A11: $tType,A13: $tType] :
      ( boolea8198339166811842893lgebra(A13)
     => boolea8198339166811842893lgebra(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A11: $tType,A13: $tType] :
      ( semilattice_sup(A13)
     => semilattice_sup(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A11: $tType,A13: $tType] :
      ( semilattice_inf(A13)
     => semilattice_inf(fun(A11,A13)) ) ).

tff(tcon_fun___Complete__Lattices_OSup,axiom,
    ! [A11: $tType,A13: $tType] :
      ( complete_Sup(A13)
     => complete_Sup(fun(A11,A13)) ) ).

tff(tcon_fun___Complete__Lattices_OInf,axiom,
    ! [A11: $tType,A13: $tType] :
      ( complete_Inf(A13)
     => complete_Inf(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A11: $tType,A13: $tType] :
      ( order_top(A13)
     => order_top(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A11: $tType,A13: $tType] :
      ( order_bot(A13)
     => order_bot(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Opreorder,axiom,
    ! [A11: $tType,A13: $tType] :
      ( preorder(A13)
     => preorder(fun(A11,A13)) ) ).

tff(tcon_fun___Finite__Set_Ofinite,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ( finite_finite(A11)
        & finite_finite(A13) )
     => finite_finite(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Olattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( lattice(A13)
     => lattice(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Oorder,axiom,
    ! [A11: $tType,A13: $tType] :
      ( order(A13)
     => order(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Oord,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ord(A13)
     => ord(fun(A11,A13)) ) ).

tff(tcon_fun___Groups_Ouminus,axiom,
    ! [A11: $tType,A13: $tType] :
      ( uminus(A13)
     => uminus(fun(A11,A13)) ) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder(int) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_5,axiom,
    condit1219197933456340205attice(int) ).

tff(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations(int) ).

tff(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel(int) ).

tff(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Odiscrete__topology,axiom,
    topolo8865339358273720382pology(int) ).

tff(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict(int) ).

tff(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add(int) ).

tff(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring(int) ).

tff(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize(int) ).

tff(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult(int) ).

tff(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add(int) ).

tff(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors(int) ).

tff(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Ot1__space,axiom,
    topological_t1_space(int) ).

tff(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__sup_6,axiom,
    semilattice_sup(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__inf_7,axiom,
    semilattice_inf(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel(int) ).

tff(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs(int) ).

tff(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OSup_8,axiom,
    complete_Sup(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OInf_9,axiom,
    complete_Inf(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide(int) ).

tff(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring(int) ).

tff(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0(int) ).

tff(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn(int) ).

tff(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity(int) ).

tff(tcon_Int_Oint___Orderings_Opreorder_10,axiom,
    preorder(int) ).

tff(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult(int) ).

tff(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0(int) ).

tff(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top(int) ).

tff(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot(int) ).

tff(tcon_Int_Oint___Lattices_Olattice_11,axiom,
    lattice(int) ).

tff(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd(int) ).

tff(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring(int) ).

tff(tcon_Int_Oint___Orderings_Oorder_12,axiom,
    order(int) ).

tff(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral(int) ).

tff(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0(int) ).

tff(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom(int) ).

tff(tcon_Int_Oint___Orderings_Oord_13,axiom,
    ord(int) ).

tff(tcon_Int_Oint___Groups_Ouminus_14,axiom,
    uminus(int) ).

tff(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1(int) ).

tff(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if(int) ).

tff(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd(int) ).

tff(tcon_Int_Oint___Power_Opower,axiom,
    power(int) ).

tff(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral(int) ).

tff(tcon_Int_Oint___Groups_Ozero,axiom,
    zero(int) ).

tff(tcon_Int_Oint___Groups_Oplus,axiom,
    plus(int) ).

tff(tcon_Int_Oint___Rings_Oring,axiom,
    ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom,axiom,
    idom(int) ).

tff(tcon_Int_Oint___Groups_Oone,axiom,
    one(int) ).

tff(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd(int) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_15,axiom,
    condit6923001295902523014norder(nat) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_16,axiom,
    condit1219197933456340205attice(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_17,axiom,
    bit_un5681908812861735899ations(nat) ).

tff(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_18,axiom,
    semiri1453513574482234551roduct(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_19,axiom,
    euclid5411537665997757685th_nat(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_20,axiom,
    ordere1937475149494474687imp_le(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_21,axiom,
    euclid3128863361964157862miring(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_22,axiom,
    euclid4440199948858584721cancel(nat) ).

tff(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_23,axiom,
    unique1627219031080169319umeral(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_24,axiom,
    semiri6575147826004484403cancel(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_25,axiom,
    strict9044650504122735259up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_26,axiom,
    ordere580206878836729694up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_27,axiom,
    ordere2412721322843649153imp_le(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_28,axiom,
    bit_se359711467146920520ations(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_29,axiom,
    linord2810124833399127020strict(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_30,axiom,
    strict7427464778891057005id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_31,axiom,
    ordere8940638589300402666id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_32,axiom,
    euclid3725896446679973847miring(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Otopological__space_33,axiom,
    topolo4958980785337419405_space(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_34,axiom,
    topolo1944317154257567458pology(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Odiscrete__topology_35,axiom,
    topolo8865339358273720382pology(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_36,axiom,
    topolo4987421752381908075d_mult(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_37,axiom,
    topolo5987344860129210374id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_38,axiom,
    linord4140545234300271783up_add(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_39,axiom,
    topolo2564578578187576103pology(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_40,axiom,
    semiri2026040879449505780visors(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_41,axiom,
    linord181362715937106298miring(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_42,axiom,
    topolo4211221413907600880p_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_43,axiom,
    linord8928482502909563296strict(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_44,axiom,
    semiri3467727345109120633visors(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_45,axiom,
    ordere6658533253407199908up_add(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_46,axiom,
    semiri6843258321239162965malize(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__monoid__mult_47,axiom,
    topolo1898628316856586783d_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_48,axiom,
    ordere6911136660526730532id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_49,axiom,
    cancel2418104881723323429up_add(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__monoid__add_50,axiom,
    topolo6943815403480290642id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_51,axiom,
    cancel1802427076303600483id_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_52,axiom,
    comm_s4317794764714335236cancel(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_53,axiom,
    bit_semiring_bits(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Ot2__space_54,axiom,
    topological_t2_space(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Ot1__space_55,axiom,
    topological_t1_space(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__comm__semiring_56,axiom,
    ordere2520102378445227354miring(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_57,axiom,
    cancel_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring_58,axiom,
    linordered_semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring__0_59,axiom,
    ordered_semiring_0(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semidom_60,axiom,
    linordered_semidom(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__sup_61,axiom,
    semilattice_sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__inf_62,axiom,
    semilattice_inf(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__mult_63,axiom,
    ab_semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1__cancel_64,axiom,
    semiring_1_cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Oalgebraic__semidom_65,axiom,
    algebraic_semidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_66,axiom,
    comm_monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__add_67,axiom,
    ab_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring_68,axiom,
    ordered_semiring(nat) ).

tff(tcon_Nat_Onat___Parity_Osemiring__parity_69,axiom,
    semiring_parity(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__add_70,axiom,
    comm_monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__modulo_71,axiom,
    semiring_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1_72,axiom,
    comm_semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__0_73,axiom,
    comm_semiring_0(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__mult_74,axiom,
    semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OSup_75,axiom,
    complete_Sup(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OInf_76,axiom,
    complete_Inf(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__modulo_77,axiom,
    semidom_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide_78,axiom,
    semidom_divide(nat) ).

tff(tcon_Nat_Onat___Num_Osemiring__numeral_79,axiom,
    semiring_numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__add_80,axiom,
    semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__less__one_81,axiom,
    zero_less_one(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring_82,axiom,
    comm_semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder__bot_83,axiom,
    order_bot(nat) ).

tff(tcon_Nat_Onat___Nat_Osemiring__char__0_84,axiom,
    semiring_char_0(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__neq__one_85,axiom,
    zero_neq_one(nat) ).

tff(tcon_Nat_Onat___Orderings_Opreorder_86,axiom,
    preorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Olinorder_87,axiom,
    linorder(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__mult_88,axiom,
    monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__add_89,axiom,
    monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1_90,axiom,
    semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__0_91,axiom,
    semiring_0(nat) ).

tff(tcon_Nat_Onat___Orderings_Ono__top_92,axiom,
    no_top(nat) ).

tff(tcon_Nat_Onat___Lattices_Olattice_93,axiom,
    lattice(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd_94,axiom,
    semiring_gcd(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__Gcd_95,axiom,
    semiring_Gcd(nat) ).

tff(tcon_Nat_Onat___Rings_Omult__zero_96,axiom,
    mult_zero(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder_97,axiom,
    order(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring_98,axiom,
    semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom_99,axiom,
    semidom(nat) ).

tff(tcon_Nat_Onat___Orderings_Oord_100,axiom,
    ord(nat) ).

tff(tcon_Nat_Onat___Power_Opower_101,axiom,
    power(nat) ).

tff(tcon_Nat_Onat___Num_Onumeral_102,axiom,
    numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Ozero_103,axiom,
    zero(nat) ).

tff(tcon_Nat_Onat___Groups_Oplus_104,axiom,
    plus(nat) ).

tff(tcon_Nat_Onat___Groups_Oone_105,axiom,
    one(nat) ).

tff(tcon_Nat_Onat___Rings_Odvd_106,axiom,
    dvd(nat) ).

tff(tcon_Nat_Onat___Nat_Osize,axiom,
    size(nat) ).

tff(tcon_Num_Onum___Orderings_Opreorder_107,axiom,
    preorder(num) ).

tff(tcon_Num_Onum___Orderings_Olinorder_108,axiom,
    linorder(num) ).

tff(tcon_Num_Onum___Orderings_Oorder_109,axiom,
    order(num) ).

tff(tcon_Num_Onum___Orderings_Oord_110,axiom,
    ord(num) ).

tff(tcon_Num_Onum___Groups_Oplus_111,axiom,
    plus(num) ).

tff(tcon_Num_Onum___Nat_Osize_112,axiom,
    size(num) ).

tff(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_113,axiom,
    semiri1453513574482234551roduct(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_114,axiom,
    ordere1937475149494474687imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_115,axiom,
    semiri6575147826004484403cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_116,axiom,
    strict9044650504122735259up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_117,axiom,
    ordere580206878836729694up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_118,axiom,
    ordere2412721322843649153imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_119,axiom,
    linord2810124833399127020strict(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_120,axiom,
    strict7427464778891057005id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_121,axiom,
    ordere8940638589300402666id_add(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_122,axiom,
    linord715952674999750819strict(rat) ).

tff(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_123,axiom,
    linord4140545234300271783up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_124,axiom,
    semiri2026040879449505780visors(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_125,axiom,
    linord181362715937106298miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_126,axiom,
    linord8928482502909563296strict(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_127,axiom,
    semiri3467727345109120633visors(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_128,axiom,
    ordere6658533253407199908up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_129,axiom,
    ordere166539214618696060dd_abs(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_130,axiom,
    ordere6911136660526730532id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_131,axiom,
    linord5086331880401160121up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_132,axiom,
    cancel2418104881723323429up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_133,axiom,
    ring_15535105094025558882visors(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_134,axiom,
    cancel1802427076303600483id_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring__strict_135,axiom,
    linord4710134922213307826strict(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_136,axiom,
    comm_s4317794764714335236cancel(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__comm__semiring_137,axiom,
    ordere2520102378445227354miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1_138,axiom,
    linord6961819062388156250ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add_139,axiom,
    ordered_ab_group_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_140,axiom,
    cancel_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring_141,axiom,
    linordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring__0_142,axiom,
    ordered_semiring_0(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semidom_143,axiom,
    linordered_semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__sup_144,axiom,
    semilattice_sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__inf_145,axiom,
    semilattice_inf(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__mult_146,axiom,
    ab_semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1__cancel_147,axiom,
    semiring_1_cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_148,axiom,
    comm_monoid_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__add_149,axiom,
    ab_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring_150,axiom,
    ordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring__abs_151,axiom,
    ordered_ring_abs(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__add_152,axiom,
    comm_monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring_153,axiom,
    linordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__idom_154,axiom,
    linordered_idom(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1_155,axiom,
    comm_semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__0_156,axiom,
    comm_semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__mult_157,axiom,
    semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom__divide_158,axiom,
    semidom_divide(rat) ).

tff(tcon_Rat_Orat___Num_Osemiring__numeral_159,axiom,
    semiring_numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__add_160,axiom,
    semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__less__one_161,axiom,
    zero_less_one(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring_162,axiom,
    comm_semiring(rat) ).

tff(tcon_Rat_Orat___Nat_Osemiring__char__0_163,axiom,
    semiring_char_0(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__group__add_164,axiom,
    ab_group_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__neq__one_165,axiom,
    zero_neq_one(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring_166,axiom,
    ordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__abs__sgn_167,axiom,
    idom_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Orderings_Opreorder_168,axiom,
    preorder(rat) ).

tff(tcon_Rat_Orat___Orderings_Olinorder_169,axiom,
    linorder(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__mult_170,axiom,
    monoid_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__divide_171,axiom,
    idom_divide(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring__1_172,axiom,
    comm_ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__add_173,axiom,
    monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1_174,axiom,
    semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__0_175,axiom,
    semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__top_176,axiom,
    no_top(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__bot_177,axiom,
    no_bot(rat) ).

tff(tcon_Rat_Orat___Lattices_Olattice_178,axiom,
    lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Ogroup__add_179,axiom,
    group_add(rat) ).

tff(tcon_Rat_Orat___Rings_Omult__zero_180,axiom,
    mult_zero(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring_181,axiom,
    comm_ring(rat) ).

tff(tcon_Rat_Orat___Orderings_Oorder_182,axiom,
    order(rat) ).

tff(tcon_Rat_Orat___Num_Oneg__numeral_183,axiom,
    neg_numeral(rat) ).

tff(tcon_Rat_Orat___Nat_Oring__char__0_184,axiom,
    ring_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring_185,axiom,
    semiring(rat) ).

tff(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom_186,axiom,
    semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Oord_187,axiom,
    ord(rat) ).

tff(tcon_Rat_Orat___Groups_Ouminus_188,axiom,
    uminus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1_189,axiom,
    ring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Oabs__if_190,axiom,
    abs_if(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield,axiom,
    field(rat) ).

tff(tcon_Rat_Orat___Power_Opower_191,axiom,
    power(rat) ).

tff(tcon_Rat_Orat___Num_Onumeral_192,axiom,
    numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Ozero_193,axiom,
    zero(rat) ).

tff(tcon_Rat_Orat___Groups_Oplus_194,axiom,
    plus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring_195,axiom,
    ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom_196,axiom,
    idom(rat) ).

tff(tcon_Rat_Orat___Groups_Oone_197,axiom,
    one(rat) ).

tff(tcon_Rat_Orat___Rings_Odvd_198,axiom,
    dvd(rat) ).

tff(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_199,axiom,
    ! [A11: $tType] : condit1219197933456340205attice(set(A11)) ).

tff(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_200,axiom,
    ! [A11: $tType] : counta3822494911875563373attice(set(A11)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_201,axiom,
    ! [A11: $tType] : comple592849572758109894attice(set(A11)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__boolean__algebra_202,axiom,
    ! [A11: $tType] : comple489889107523837845lgebra(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_203,axiom,
    ! [A11: $tType] : bounde4967611905675639751up_bot(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_204,axiom,
    ! [A11: $tType] : bounde4346867609351753570nf_top(set(A11)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_205,axiom,
    ! [A11: $tType] : comple6319245703460814977attice(set(A11)) ).

tff(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_206,axiom,
    ! [A11: $tType] : boolea8198339166811842893lgebra(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__sup_207,axiom,
    ! [A11: $tType] : semilattice_sup(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__inf_208,axiom,
    ! [A11: $tType] : semilattice_inf(set(A11)) ).

tff(tcon_Set_Oset___Complete__Lattices_OSup_209,axiom,
    ! [A11: $tType] : complete_Sup(set(A11)) ).

tff(tcon_Set_Oset___Complete__Lattices_OInf_210,axiom,
    ! [A11: $tType] : complete_Inf(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder__top_211,axiom,
    ! [A11: $tType] : order_top(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder__bot_212,axiom,
    ! [A11: $tType] : order_bot(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Opreorder_213,axiom,
    ! [A11: $tType] : preorder(set(A11)) ).

tff(tcon_Set_Oset___Finite__Set_Ofinite_214,axiom,
    ! [A11: $tType] :
      ( finite_finite(A11)
     => finite_finite(set(A11)) ) ).

tff(tcon_Set_Oset___Lattices_Olattice_215,axiom,
    ! [A11: $tType] : lattice(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder_216,axiom,
    ! [A11: $tType] : order(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oord_217,axiom,
    ! [A11: $tType] : ord(set(A11)) ).

tff(tcon_Set_Oset___Groups_Ouminus_218,axiom,
    ! [A11: $tType] : uminus(set(A11)) ).

tff(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_219,axiom,
    condit1219197933456340205attice($o) ).

tff(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_220,axiom,
    counta3822494911875563373attice($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_221,axiom,
    comple592849572758109894attice($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__boolean__algebra_222,axiom,
    comple489889107523837845lgebra($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Otopological__space_223,axiom,
    topolo4958980785337419405_space($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_224,axiom,
    topolo1944317154257567458pology($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Odiscrete__topology_225,axiom,
    topolo8865339358273720382pology($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_226,axiom,
    bounde4967611905675639751up_bot($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_227,axiom,
    bounde4346867609351753570nf_top($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_228,axiom,
    comple6319245703460814977attice($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_229,axiom,
    topolo2564578578187576103pology($o) ).

tff(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_230,axiom,
    boolea8198339166811842893lgebra($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Ot2__space_231,axiom,
    topological_t2_space($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Ot1__space_232,axiom,
    topological_t1_space($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__sup_233,axiom,
    semilattice_sup($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__inf_234,axiom,
    semilattice_inf($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_OSup_235,axiom,
    complete_Sup($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_OInf_236,axiom,
    complete_Inf($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__top_237,axiom,
    order_top($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__bot_238,axiom,
    order_bot($o) ).

tff(tcon_HOL_Obool___Orderings_Opreorder_239,axiom,
    preorder($o) ).

tff(tcon_HOL_Obool___Orderings_Olinorder_240,axiom,
    linorder($o) ).

tff(tcon_HOL_Obool___Finite__Set_Ofinite_241,axiom,
    finite_finite($o) ).

tff(tcon_HOL_Obool___Lattices_Olattice_242,axiom,
    lattice($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder_243,axiom,
    order($o) ).

tff(tcon_HOL_Obool___Orderings_Oord_244,axiom,
    ord($o) ).

tff(tcon_HOL_Obool___Groups_Ouminus_245,axiom,
    uminus($o) ).

tff(tcon_List_Olist___Nat_Osize_246,axiom,
    ! [A11: $tType] : size(list(A11)) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_247,axiom,
    condit6923001295902523014norder(real) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_248,axiom,
    condit1219197933456340205attice(real) ).

tff(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_249,axiom,
    semiri1453513574482234551roduct(real) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_250,axiom,
    ordere1937475149494474687imp_le(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_251,axiom,
    semiri6575147826004484403cancel(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector(real) ).

tff(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_252,axiom,
    strict9044650504122735259up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_253,axiom,
    ordere580206878836729694up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_254,axiom,
    ordere2412721322843649153imp_le(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_255,axiom,
    linord2810124833399127020strict(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector(real) ).

tff(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_256,axiom,
    strict7427464778891057005id_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_257,axiom,
    ordere8940638589300402666id_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Otopological__space_258,axiom,
    topolo4958980785337419405_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_259,axiom,
    topolo1944317154257567458pology(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra(real) ).

tff(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_260,axiom,
    archim462609752435547400_field(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Oopen__uniformity,axiom,
    topolo569519726778239578ormity(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_261,axiom,
    linord715952674999750819strict(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist(real) ).

tff(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_262,axiom,
    unboun7993243217541854897norder(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_263,axiom,
    topolo5987344860129210374id_add(real) ).

tff(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_264,axiom,
    linord4140545234300271783up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_265,axiom,
    topolo2564578578187576103pology(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_266,axiom,
    semiri2026040879449505780visors(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_267,axiom,
    linord181362715937106298miring(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_268,axiom,
    topolo4211221413907600880p_mult(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_269,axiom,
    linord8928482502909563296strict(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_270,axiom,
    semiri3467727345109120633visors(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_271,axiom,
    ordere6658533253407199908up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_272,axiom,
    ordere166539214618696060dd_abs(real) ).

tff(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_273,axiom,
    archim2362893244070406136eiling(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_274,axiom,
    ordere6911136660526730532id_add(real) ).

tff(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_275,axiom,
    linord5086331880401160121up_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_276,axiom,
    cancel2418104881723323429up_add(real) ).

tff(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_277,axiom,
    ring_15535105094025558882visors(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__monoid__add_278,axiom,
    topolo6943815403480290642id_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_279,axiom,
    cancel1802427076303600483id_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__ring__strict_280,axiom,
    linord4710134922213307826strict(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_281,axiom,
    comm_s4317794764714335236cancel(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ot2__space_282,axiom,
    topological_t2_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ot1__space_283,axiom,
    topological_t1_space(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__comm__semiring_284,axiom,
    ordere2520102378445227354miring(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__1_285,axiom,
    linord6961819062388156250ring_1(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__group__add_286,axiom,
    ordered_ab_group_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_287,axiom,
    cancel_semigroup_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring_288,axiom,
    linordered_semiring(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__semiring__0_289,axiom,
    ordered_semiring_0(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semidom_290,axiom,
    linordered_semidom(real) ).

tff(tcon_Real_Oreal___Orderings_Odense__linorder_291,axiom,
    dense_linorder(real) ).

tff(tcon_Real_Oreal___Lattices_Osemilattice__sup_292,axiom,
    semilattice_sup(real) ).

tff(tcon_Real_Oreal___Lattices_Osemilattice__inf_293,axiom,
    semilattice_inf(real) ).

tff(tcon_Real_Oreal___Groups_Oab__semigroup__mult_294,axiom,
    ab_semigroup_mult(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1__cancel_295,axiom,
    semiring_1_cancel(real) ).

tff(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_296,axiom,
    comm_monoid_mult(real) ).

tff(tcon_Real_Oreal___Groups_Oab__semigroup__add_297,axiom,
    ab_semigroup_add(real) ).

tff(tcon_Real_Oreal___Fields_Olinordered__field_298,axiom,
    linordered_field(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__semiring_299,axiom,
    ordered_semiring(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__ring__abs_300,axiom,
    ordered_ring_abs(real) ).

tff(tcon_Real_Oreal___Groups_Ocomm__monoid__add_301,axiom,
    comm_monoid_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__ring_302,axiom,
    linordered_ring(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__idom_303,axiom,
    linordered_idom(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__1_304,axiom,
    comm_semiring_1(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__0_305,axiom,
    comm_semiring_0(real) ).

tff(tcon_Real_Oreal___Orderings_Odense__order_306,axiom,
    dense_order(real) ).

tff(tcon_Real_Oreal___Groups_Osemigroup__mult_307,axiom,
    semigroup_mult(real) ).

tff(tcon_Real_Oreal___Complete__Lattices_OSup_308,axiom,
    complete_Sup(real) ).

tff(tcon_Real_Oreal___Complete__Lattices_OInf_309,axiom,
    complete_Inf(real) ).

tff(tcon_Real_Oreal___Rings_Osemidom__divide_310,axiom,
    semidom_divide(real) ).

tff(tcon_Real_Oreal___Num_Osemiring__numeral_311,axiom,
    semiring_numeral(real) ).

tff(tcon_Real_Oreal___Groups_Osemigroup__add_312,axiom,
    semigroup_add(real) ).

tff(tcon_Real_Oreal___Fields_Ofield__abs__sgn_313,axiom,
    field_abs_sgn(real) ).

tff(tcon_Real_Oreal___Fields_Odivision__ring_314,axiom,
    division_ring(real) ).

tff(tcon_Real_Oreal___Rings_Ozero__less__one_315,axiom,
    zero_less_one(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring_316,axiom,
    comm_semiring(real) ).

tff(tcon_Real_Oreal___Nat_Osemiring__char__0_317,axiom,
    semiring_char_0(real) ).

tff(tcon_Real_Oreal___Groups_Oab__group__add_318,axiom,
    ab_group_add(real) ).

tff(tcon_Real_Oreal___Fields_Ofield__char__0_319,axiom,
    field_char_0(real) ).

tff(tcon_Real_Oreal___Rings_Ozero__neq__one_320,axiom,
    zero_neq_one(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__ring_321,axiom,
    ordered_ring(real) ).

tff(tcon_Real_Oreal___Rings_Oidom__abs__sgn_322,axiom,
    idom_abs_sgn(real) ).

tff(tcon_Real_Oreal___Orderings_Opreorder_323,axiom,
    preorder(real) ).

tff(tcon_Real_Oreal___Orderings_Olinorder_324,axiom,
    linorder(real) ).

tff(tcon_Real_Oreal___Groups_Omonoid__mult_325,axiom,
    monoid_mult(real) ).

tff(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln(real) ).

tff(tcon_Real_Oreal___Rings_Oidom__divide_326,axiom,
    idom_divide(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__ring__1_327,axiom,
    comm_ring_1(real) ).

tff(tcon_Real_Oreal___Groups_Omonoid__add_328,axiom,
    monoid_add(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1_329,axiom,
    semiring_1(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__0_330,axiom,
    semiring_0(real) ).

tff(tcon_Real_Oreal___Orderings_Ono__top_331,axiom,
    no_top(real) ).

tff(tcon_Real_Oreal___Orderings_Ono__bot_332,axiom,
    no_bot(real) ).

tff(tcon_Real_Oreal___Lattices_Olattice_333,axiom,
    lattice(real) ).

tff(tcon_Real_Oreal___Groups_Ogroup__add_334,axiom,
    group_add(real) ).

tff(tcon_Real_Oreal___Rings_Omult__zero_335,axiom,
    mult_zero(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__ring_336,axiom,
    comm_ring(real) ).

tff(tcon_Real_Oreal___Orderings_Oorder_337,axiom,
    order(real) ).

tff(tcon_Real_Oreal___Num_Oneg__numeral_338,axiom,
    neg_numeral(real) ).

tff(tcon_Real_Oreal___Nat_Oring__char__0_339,axiom,
    ring_char_0(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring_340,axiom,
    semiring(real) ).

tff(tcon_Real_Oreal___Fields_Oinverse_341,axiom,
    inverse(real) ).

tff(tcon_Real_Oreal___Rings_Osemidom_342,axiom,
    semidom(real) ).

tff(tcon_Real_Oreal___Orderings_Oord_343,axiom,
    ord(real) ).

tff(tcon_Real_Oreal___Groups_Ouminus_344,axiom,
    uminus(real) ).

tff(tcon_Real_Oreal___Rings_Oring__1_345,axiom,
    ring_1(real) ).

tff(tcon_Real_Oreal___Rings_Oabs__if_346,axiom,
    abs_if(real) ).

tff(tcon_Real_Oreal___Fields_Ofield_347,axiom,
    field(real) ).

tff(tcon_Real_Oreal___Power_Opower_348,axiom,
    power(real) ).

tff(tcon_Real_Oreal___Num_Onumeral_349,axiom,
    numeral(real) ).

tff(tcon_Real_Oreal___Groups_Ozero_350,axiom,
    zero(real) ).

tff(tcon_Real_Oreal___Groups_Oplus_351,axiom,
    plus(real) ).

tff(tcon_Real_Oreal___Rings_Oring_352,axiom,
    ring(real) ).

tff(tcon_Real_Oreal___Rings_Oidom_353,axiom,
    idom(real) ).

tff(tcon_Real_Oreal___Groups_Oone_354,axiom,
    one(real) ).

tff(tcon_Real_Oreal___Rings_Odvd_355,axiom,
    dvd(real) ).

tff(tcon_String_Ochar___Finite__Set_Ofinite_356,axiom,
    finite_finite(char) ).

tff(tcon_String_Ochar___Nat_Osize_357,axiom,
    size(char) ).

tff(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_358,axiom,
    ! [A11: $tType] : condit1219197933456340205attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_359,axiom,
    ! [A11: $tType] : counta3822494911875563373attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_360,axiom,
    ! [A11: $tType] : bounde4967611905675639751up_bot(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_361,axiom,
    ! [A11: $tType] : bounde4346867609351753570nf_top(filter(A11)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_362,axiom,
    ! [A11: $tType] : comple6319245703460814977attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_363,axiom,
    ! [A11: $tType] : semilattice_sup(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_364,axiom,
    ! [A11: $tType] : semilattice_inf(filter(A11)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OSup_365,axiom,
    ! [A11: $tType] : complete_Sup(filter(A11)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OInf_366,axiom,
    ! [A11: $tType] : complete_Inf(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__top_367,axiom,
    ! [A11: $tType] : order_top(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__bot_368,axiom,
    ! [A11: $tType] : order_bot(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Opreorder_369,axiom,
    ! [A11: $tType] : preorder(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Olattice_370,axiom,
    ! [A11: $tType] : lattice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder_371,axiom,
    ! [A11: $tType] : order(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oord_372,axiom,
    ! [A11: $tType] : ord(filter(A11)) ).

tff(tcon_Option_Ooption___Finite__Set_Ofinite_373,axiom,
    ! [A11: $tType] :
      ( finite_finite(A11)
     => finite_finite(option(A11)) ) ).

tff(tcon_Option_Ooption___Nat_Osize_374,axiom,
    ! [A11: $tType] : size(option(A11)) ).

tff(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_375,axiom,
    semiri1453513574482234551roduct(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_376,axiom,
    topolo3112930676232923870pology(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_377,axiom,
    real_V8999393235501362500lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_378,axiom,
    real_V2822296259951069270ebra_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_379,axiom,
    semiri6575147826004484403cancel(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_380,axiom,
    real_V4412858255891104859lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_381,axiom,
    real_V822414075346904944vector(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_382,axiom,
    topolo4958980785337419405_space(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_383,axiom,
    real_V3459762299906320749_field(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_384,axiom,
    real_V5047593784448816457lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Oopen__uniformity_385,axiom,
    topolo569519726778239578ormity(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_386,axiom,
    real_V768167426530841204y_dist(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_387,axiom,
    topolo5987344860129210374id_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_388,axiom,
    semiri2026040879449505780visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_389,axiom,
    real_V2191834092415804123ebra_1(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_390,axiom,
    real_V8037385150606011577_space(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_391,axiom,
    topolo4211221413907600880p_mult(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_392,axiom,
    topolo7287701948861334536_space(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_393,axiom,
    topolo8386298272705272623_space(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_394,axiom,
    semiri3467727345109120633visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_395,axiom,
    real_V6157519004096292374lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_396,axiom,
    real_V7819770556892013058_space(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_397,axiom,
    topolo1287966508704411220up_add(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_398,axiom,
    real_V4867850818363320053vector(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_399,axiom,
    cancel2418104881723323429up_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_400,axiom,
    ring_15535105094025558882visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_401,axiom,
    real_V7773925162809079976_field(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_402,axiom,
    topolo6943815403480290642id_add(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_403,axiom,
    cancel1802427076303600483id_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_404,axiom,
    comm_s4317794764714335236cancel(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__group__add_405,axiom,
    topolo1633459387980952147up_add(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_406,axiom,
    topological_t2_space(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ot1__space_407,axiom,
    topological_t1_space(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_408,axiom,
    cancel_semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_409,axiom,
    real_Vector_banach(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_410,axiom,
    ab_semigroup_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_411,axiom,
    semiring_1_cancel(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_412,axiom,
    comm_monoid_mult(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_413,axiom,
    ab_semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_414,axiom,
    comm_monoid_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_415,axiom,
    comm_semiring_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_416,axiom,
    comm_semiring_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_417,axiom,
    semigroup_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemidom__divide_418,axiom,
    semidom_divide(complex) ).

tff(tcon_Complex_Ocomplex___Num_Osemiring__numeral_419,axiom,
    semiring_numeral(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Osemigroup__add_420,axiom,
    semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_421,axiom,
    field_abs_sgn(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Odivision__ring_422,axiom,
    division_ring(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_423,axiom,
    comm_semiring(complex) ).

tff(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_424,axiom,
    semiring_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__group__add_425,axiom,
    ab_group_add(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield__char__0_426,axiom,
    field_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_427,axiom,
    zero_neq_one(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_428,axiom,
    idom_abs_sgn(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Omonoid__mult_429,axiom,
    monoid_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom__divide_430,axiom,
    idom_divide(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_431,axiom,
    comm_ring_1(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Omonoid__add_432,axiom,
    monoid_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1_433,axiom,
    semiring_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__0_434,axiom,
    semiring_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ogroup__add_435,axiom,
    group_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Omult__zero_436,axiom,
    mult_zero(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__ring_437,axiom,
    comm_ring(complex) ).

tff(tcon_Complex_Ocomplex___Num_Oneg__numeral_438,axiom,
    neg_numeral(complex) ).

tff(tcon_Complex_Ocomplex___Nat_Oring__char__0_439,axiom,
    ring_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring_440,axiom,
    semiring(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Oinverse_441,axiom,
    inverse(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemidom_442,axiom,
    semidom(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ouminus_443,axiom,
    uminus(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring__1_444,axiom,
    ring_1(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield_445,axiom,
    field(complex) ).

tff(tcon_Complex_Ocomplex___Power_Opower_446,axiom,
    power(complex) ).

tff(tcon_Complex_Ocomplex___Num_Onumeral_447,axiom,
    numeral(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ozero_448,axiom,
    zero(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oplus_449,axiom,
    plus(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring_450,axiom,
    ring(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom_451,axiom,
    idom(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oone_452,axiom,
    one(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Odvd_453,axiom,
    dvd(complex) ).

tff(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_454,axiom,
    condit6923001295902523014norder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_455,axiom,
    condit1219197933456340205attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_456,axiom,
    counta3822494911875563373attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_457,axiom,
    comple592849572758109894attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_458,axiom,
    strict9044650504122735259up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_459,axiom,
    strict7427464778891057005id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_460,axiom,
    canoni5634975068530333245id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_461,axiom,
    bounde4967611905675639751up_bot(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_462,axiom,
    bounde4346867609351753570nf_top(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_463,axiom,
    linord4140545234300271783up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_464,axiom,
    comple6319245703460814977attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_465,axiom,
    linord181362715937106298miring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_466,axiom,
    semiri3467727345109120633visors(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_467,axiom,
    ordere6658533253407199908up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_468,axiom,
    ordere6911136660526730532id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_469,axiom,
    ordere2520102378445227354miring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_470,axiom,
    semilattice_sup(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_471,axiom,
    semilattice_inf(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_472,axiom,
    ab_semigroup_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_473,axiom,
    comm_monoid_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_474,axiom,
    ab_semigroup_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_475,axiom,
    ordered_semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_476,axiom,
    comm_monoid_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_477,axiom,
    comm_semiring_1(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_478,axiom,
    comm_semiring_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_479,axiom,
    semigroup_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_OSup_480,axiom,
    complete_Sup(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_OInf_481,axiom,
    complete_Inf(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_482,axiom,
    semiring_numeral(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_483,axiom,
    semigroup_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_484,axiom,
    zero_less_one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_485,axiom,
    comm_semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Owellorder_486,axiom,
    wellorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_487,axiom,
    order_top(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_488,axiom,
    order_bot(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_489,axiom,
    semiring_char_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_490,axiom,
    zero_neq_one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Opreorder_491,axiom,
    preorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Olinorder_492,axiom,
    linorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_493,axiom,
    monoid_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_494,axiom,
    monoid_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_495,axiom,
    semiring_1(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_496,axiom,
    semiring_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Olattice_497,axiom,
    lattice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Omult__zero_498,axiom,
    mult_zero(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder_499,axiom,
    order(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring_500,axiom,
    semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oord_501,axiom,
    ord(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Power_Opower_502,axiom,
    power(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Num_Onumeral_503,axiom,
    numeral(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ozero_504,axiom,
    zero(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oplus_505,axiom,
    plus(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oone_506,axiom,
    one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Odvd_507,axiom,
    dvd(extended_enat) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_508,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ( topolo4958980785337419405_space(A11)
        & topolo4958980785337419405_space(A13) )
     => topolo4958980785337419405_space(product_prod(A11,A13)) ) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_509,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ( topological_t2_space(A11)
        & topological_t2_space(A13) )
     => topological_t2_space(product_prod(A11,A13)) ) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Ot1__space_510,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ( topological_t1_space(A11)
        & topological_t1_space(A13) )
     => topological_t1_space(product_prod(A11,A13)) ) ).

tff(tcon_Product__Type_Oprod___Finite__Set_Ofinite_511,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ( finite_finite(A11)
        & finite_finite(A13) )
     => finite_finite(product_prod(A11,A13)) ) ).

tff(tcon_Product__Type_Oprod___Nat_Osize_512,axiom,
    ! [A11: $tType,A13: $tType] : size(product_prod(A11,A13)) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_513,axiom,
    bit_un5681908812861735899ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_514,axiom,
    semiri1453513574482234551roduct(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_515,axiom,
    euclid5411537665997757685th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_516,axiom,
    euclid8789492081693882211th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_517,axiom,
    ordere1937475149494474687imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_518,axiom,
    euclid3128863361964157862miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_519,axiom,
    euclid4440199948858584721cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_520,axiom,
    unique1627219031080169319umeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_521,axiom,
    euclid8851590272496341667cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_522,axiom,
    semiri6575147826004484403cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_523,axiom,
    strict9044650504122735259up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_524,axiom,
    ordere580206878836729694up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_525,axiom,
    ordere2412721322843649153imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_526,axiom,
    bit_se359711467146920520ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_527,axiom,
    linord2810124833399127020strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_528,axiom,
    strict7427464778891057005id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_529,axiom,
    ordere8940638589300402666id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_530,axiom,
    euclid3725896446679973847miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_531,axiom,
    linord715952674999750819strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_532,axiom,
    linord4140545234300271783up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_533,axiom,
    bit_ri3973907225187159222ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_534,axiom,
    semiri2026040879449505780visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_535,axiom,
    linord181362715937106298miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_536,axiom,
    euclid5891614535332579305n_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_537,axiom,
    linord8928482502909563296strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_538,axiom,
    semiri3467727345109120633visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_539,axiom,
    ordere6658533253407199908up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_540,axiom,
    ordere166539214618696060dd_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_541,axiom,
    ordere6911136660526730532id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_542,axiom,
    linord5086331880401160121up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_543,axiom,
    cancel2418104881723323429up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_544,axiom,
    ring_15535105094025558882visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_545,axiom,
    cancel1802427076303600483id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_546,axiom,
    linord4710134922213307826strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_547,axiom,
    comm_s4317794764714335236cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_548,axiom,
    bit_semiring_bits(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_549,axiom,
    ordere2520102378445227354miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_550,axiom,
    linord6961819062388156250ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_551,axiom,
    ordered_ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_552,axiom,
    cancel_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_553,axiom,
    linordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_554,axiom,
    ordered_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_555,axiom,
    linordered_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_556,axiom,
    ab_semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_557,axiom,
    semiring_1_cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_558,axiom,
    algebraic_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_559,axiom,
    comm_monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_560,axiom,
    ab_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_561,axiom,
    ordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_562,axiom,
    ordered_ring_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_563,axiom,
    semiring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_564,axiom,
    comm_monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_565,axiom,
    semiring_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_566,axiom,
    linordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_567,axiom,
    linordered_idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_568,axiom,
    comm_semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_569,axiom,
    comm_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_570,axiom,
    semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_571,axiom,
    semidom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_572,axiom,
    semidom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_573,axiom,
    semiring_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_574,axiom,
    semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_575,axiom,
    zero_less_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_576,axiom,
    comm_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_577,axiom,
    semiring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_578,axiom,
    ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_579,axiom,
    zero_neq_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_580,axiom,
    ordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_581,axiom,
    idom_abs_sgn(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_582,axiom,
    ring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_583,axiom,
    preorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_584,axiom,
    linorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_585,axiom,
    monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_586,axiom,
    idom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_587,axiom,
    idom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_588,axiom,
    comm_ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_589,axiom,
    monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_590,axiom,
    semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_591,axiom,
    semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_592,axiom,
    group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_593,axiom,
    mult_zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_594,axiom,
    comm_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oorder_595,axiom,
    order(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_596,axiom,
    neg_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_597,axiom,
    ring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring_598,axiom,
    semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom_599,axiom,
    semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oord_600,axiom,
    ord(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ouminus_601,axiom,
    uminus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1_602,axiom,
    ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_603,axiom,
    abs_if(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Power_Opower_604,axiom,
    power(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Onumeral_605,axiom,
    numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ozero_606,axiom,
    zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oplus_607,axiom,
    plus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring_608,axiom,
    ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom_609,axiom,
    idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oone_610,axiom,
    one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Odvd_611,axiom,
    dvd(code_integer) ).

tff(tcon_VEBT__Definitions_OVEBT___Nat_Osize_612,axiom,
    size(vEBT_VEBT) ).

% Helper facts (5)
tff(help_fNot_2_1_U,axiom,
    ! [P: $o] :
      ( (P)
      | aa($o,$o,fNot,P) ) ).

tff(help_fNot_1_1_U,axiom,
    ! [P: $o] :
      ( ~ aa($o,$o,fNot,P)
      | ~ (P) ) ).

tff(help_fequal_2_1_T,axiom,
    ! [A: $tType,X2: A,Y2: A] :
      ( ( X2 != Y2 )
      | aa(A,$o,aa(A,fun(A,$o),fequal(A),X2),Y2) ) ).

tff(help_fequal_1_1_T,axiom,
    ! [A: $tType,X2: A,Y2: A] :
      ( ~ aa(A,$o,aa(A,fun(A,$o),fequal(A),X2),Y2)
      | ( X2 = Y2 ) ) ).

tff(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( aa(A,$o,P,fChoice(A,P))
      = ( ? [X16: A] : aa(A,$o,P,X16) ) ) ).

% Free types (1)
tff(tfree_0,hypothesis,
    semiring_1(a) ).

% Conjectures (1)
tff(conj_0,conjecture,
    vEBT_VEBT_elim_dead(vEBT_Node(none(product_prod(nat,nat)),dega,treeLista,summarya),extend4730790105801354508finity(extended_enat)) = vEBT_Node(none(product_prod(nat,nat)),dega,treeLista,summarya) ).

%------------------------------------------------------------------------------
