%------------------------------------------------------------------------------
% File     : VBT00021^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Member 00087_002430
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0065_VEBT_Member_00087_002430 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9588 (2883 unt; 655 typ;   0 def)
%            Number of atoms       : 29396 (9418 equ;   5 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 172106 (2360   ~; 349   |;2453   &;153303   @)
%                                         (   0 <=>;13641  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   8 avg)
%            Number of types       :   10 (   9 usr)
%            Number of type conns  : 4704 (4704   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  650 ( 646 usr;  19 con; 0-9 aty)
%            Number of variables   : 29737 (2798   ^25340   !; 977   ?;29737   :)
%                                         ( 622  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 18:29:51.457
%------------------------------------------------------------------------------
% Could-be-implicit typings (15)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (640)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Osgn__div__norm,type,
    real_V6567297691418259687v_norm: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,type,
    counta4013691401010221786attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself @ A ) > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Target__Nat_Oint__of__nat,type,
    code_T6385005292777649522of_nat: nat > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Complex_Orcis,type,
    rcis: real > real > complex ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Countable__Set_Ocountable,type,
    countable_countable: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Countable__Set_Ofrom__nat__into,type,
    counta4804993851260445106t_into: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : ( ( nat > T ) > T > extended_enat > T ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ ( set @ A ) ) ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B > $o ) ).

thf(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_Fun__Def_Ois__measure,type,
    fun_is_measure: 
      !>[A: $tType] : ( ( A > nat ) > $o ) ).

thf(sy_c_Fun__Def_Omax__strict,type,
    fun_max_strict: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omax__weak,type,
    fun_max_weak: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omin__strict,type,
    fun_min_strict: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omin__weak,type,
    fun_min_weak: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Opair__leq,type,
    fun_pair_leq: set @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_Fun__Def_Opair__less,type,
    fun_pair_less: set @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_Fun__Def_Oreduction__pair,type,
    fun_reduction_pair: 
      !>[A: $tType] : ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > $o ) ).

thf(sy_c_Fun__Def_Orp__inv__image,type,
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min,type,
    lattices_ord_arg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_OBleast,type,
    bleast: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > A ) ).

thf(sy_c_List_Oabort__Bleast,type,
    abort_Bleast: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > A ) ).

thf(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( list @ A ) ) > ( product_prod @ ( A > B ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) ).

thf(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odistinct__adj,type,
    distinct_adj: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( B > A > B ) > B > ( list @ A ) > B ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ogen__length,type,
    gen_length: 
      !>[A: $tType] : ( nat > ( list @ A ) > nat ) ).

thf(sy_c_List_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__insert__key,type,
    linord329482645794927042rt_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osort__key,type,
    linorder_sort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olinorder__class_Ostable__sort__key,type,
    linord3483353639454293061rt_key: 
      !>[B: $tType,A: $tType] : ( ( ( B > A ) > ( list @ B ) > ( list @ B ) ) > $o ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( C > ( A > ( list @ A ) > C > C ) > ( list @ A ) > C ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__ex,type,
    list_ex: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__tailrec,type,
    map_tailrec: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__tailrec__rev,type,
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__tailrec__rev__rel,type,
    map_tailrec_rev_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > $o ) ).

thf(sy_c_List_Omaps,type,
    maps: 
      !>[A: $tType,B: $tType] : ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( ( list @ ( A > nat ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Onull,type,
    null: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Oord_Olexordp,type,
    lexordp2: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Order__Continuity_Osup__continuous,type,
    order_sup_continuous: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > ( set @ A ) > A ) ).

thf(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) ).

thf(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( A > ( A > A > A ) > A > nat > A ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : ( itself @ A ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Opositive,type,
    positive: rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Real_OReal,type,
    real2: ( nat > rat ) > real ).

thf(sy_c_Real_Ocauchy,type,
    cauchy: ( nat > rat ) > $o ).

thf(sy_c_Real_Ocr__real,type,
    cr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opcr__real,type,
    pcr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opositive,type,
    positive2: real > $o ).

thf(sy_c_Real_Orealrel,type,
    realrel: ( nat > rat ) > ( nat > rat ) > $o ).

thf(sy_c_Real_Orep__real,type,
    rep_real: real > nat > rat ).

thf(sy_c_Real_Ovanishes,type,
    vanishes: ( nat > rat ) > $o ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__bilinear,type,
    real_V2442710119149674383linear: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Oconstruct,type,
    real_V4425403222259421789struct: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > A > B ) ).

thf(sy_c_Real__Vector__Spaces_Odependent,type,
    real_V358717886546972837endent: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odim,type,
    real_Vector_dim: 
      !>[A: $tType] : ( ( set @ A ) > nat ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oextend__basis,type,
    real_V4986007116245087402_basis: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Real__Vector__Spaces_Olinear,type,
    real_Vector_linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_Orepresentation,type,
    real_V7696804695334737415tation: 
      !>[A: $tType] : ( ( set @ A ) > A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Real__Vector__Spaces_Ospan,type,
    real_Vector_span: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Real__Vector__Spaces_Osubspace,type,
    real_Vector_subspace: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert2: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Ois__empty,type,
    is_empty: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ B ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oconnected,type,
    topolo1966860045006549960nected: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oconvergent,type,
    topolo6863149650580417670ergent: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocomplete,type,
    topolo2479028161051973599mplete: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : ( filter @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Orec__VEBT,type,
    vEBT_rec_VEBT: 
      !>[A: $tType] : ( ( ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ ( product_prod @ vEBT_VEBT @ A ) ) > vEBT_VEBT > A > A ) > ( $o > $o > A ) > vEBT_VEBT > A ) ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Obit__concat,type,
    vEBT_VEBT_bit_concat: nat > nat > nat > nat ).

thf(sy_c_VEBT__Member_OVEBT__internal_Oset__vebt_H,type,
    vEBT_VEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Member_Ovebt__member,type,
    vEBT_vebt_member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Member_Ovebt__member__rel,type,
    vEBT_vebt_member_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Zorn_Ochain__subset,type,
    chain_subset: 
      !>[A: $tType] : ( ( set @ ( set @ A ) ) > $o ) ).

thf(sy_c_Zorn_Ochains,type,
    chains: 
      !>[A: $tType] : ( ( set @ ( set @ A ) ) > ( set @ ( set @ ( set @ A ) ) ) ) ).

thf(sy_c_Zorn_Oinit__seg__of,type,
    init_seg_of: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_deg____,type,
    deg: nat ).

thf(sy_v_info____,type,
    info: option @ ( product_prod @ nat @ nat ) ).

thf(sy_v_n____,type,
    n: nat ).

thf(sy_v_summary____,type,
    summary: vEBT_VEBT ).

thf(sy_v_ta____,type,
    ta: vEBT_VEBT ).

thf(sy_v_treeList____,type,
    treeList: list @ vEBT_VEBT ).

% Relevant facts (8182)
thf(fact_0_Node_OIH_I2_J,axiom,
    ~ ( vEBT_invar_vebt @ summary @ ( zero_zero @ nat ) ) ).

% Node.IH(2)
thf(fact_1_Node_Oprems,axiom,
    vEBT_invar_vebt @ ( vEBT_Node @ info @ deg @ treeList @ summary ) @ ( zero_zero @ nat ) ).

% Node.prems
thf(fact_2__092_060open_062invar__vebt_At_An_092_060close_062,axiom,
    vEBT_invar_vebt @ ta @ n ).

% \<open>invar_vebt t n\<close>
thf(fact_3_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_4_le0,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% le0
thf(fact_5_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_6_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ X ) ) ).

% order_refl
thf(fact_7_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_8_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% less_eq_nat.simps(1)
thf(fact_9_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_10_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_11_le__0__eq,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( zero_zero @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_12_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_13_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_14__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062n_O_Ainvar__vebt_At_An_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,
    ~ ! [N2: nat] :
        ~ ( vEBT_invar_vebt @ ta @ N2 ) ).

% \<open>\<And>thesis. (\<And>n. invar_vebt t n \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_15__092_060open_062t_A_092_060in_062_Aset_AtreeList_092_060close_062,axiom,
    member @ vEBT_VEBT @ ta @ ( set2 @ vEBT_VEBT @ treeList ) ).

% \<open>t \<in> set treeList\<close>
thf(fact_16_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% order_antisym_conv
thf(fact_17_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_le_cases
thf(fact_18_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_19_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_20_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_linear
thf(fact_21_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_eq_refl
thf(fact_22_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_23_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_24_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ( ord_less_eq @ A @ B3 @ A3 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_25_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F3: A > B,G: A > B] :
            ! [X3: A] : ( ord_less_eq @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ).

% le_fun_def
thf(fact_26_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G2: A > B] :
          ( ! [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G2 ) ) ) ).

% le_funI
thf(fact_27_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G2: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G2 )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) ).

% le_funE
thf(fact_28_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G2: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G2 )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) ).

% le_funD
thf(fact_29_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_30_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_31_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_32_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ( ord_less_eq @ A @ A3 @ B3 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_33_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
             => ( P @ A4 @ B4 ) )
         => ( ! [A4: A,B4: A] :
                ( ( P @ B4 @ A4 )
               => ( P @ A4 @ B4 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_34_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% order_trans
thf(fact_35_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_36_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) ).

% order_antisym
thf(fact_37_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_38_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_39_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [X3: A,Y4: A] :
              ( ( ord_less_eq @ A @ X3 @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X3 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_40_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_41_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_42_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_43_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_44_Collect__mem__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( collect @ A
        @ ^ [X3: A] : ( member @ A @ X3 @ A5 ) )
      = A5 ) ).

% Collect_mem_eq
thf(fact_45_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_46_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G2: A > B] :
      ( ! [X2: A] :
          ( ( F2 @ X2 )
          = ( G2 @ X2 ) )
     => ( F2 = G2 ) ) ).

% ext
thf(fact_47_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y5: nat] :
                ( ( P @ Y5 )
               => ( ord_less_eq @ nat @ Y5 @ X2 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_48_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) ).

% nat_le_linear
thf(fact_49_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) ).

% le_antisym
thf(fact_50_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% eq_imp_le
thf(fact_51_le__trans,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I @ K ) ) ) ).

% le_trans
thf(fact_52_le__refl,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ N ) ).

% le_refl
thf(fact_53_Node_OIH_I1_J,axiom,
    ! [X3a: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X3a @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ~ ( vEBT_invar_vebt @ X3a @ ( zero_zero @ nat ) ) ) ).

% Node.IH(1)
thf(fact_54_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_55_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D2 )
     => ( vEBT_invar_vebt @ T2 @ D2 ) ) ).

% valid_eq2
thf(fact_56_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_57_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_58_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% deg_not_0
thf(fact_59__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062t_O_At_A_092_060in_062_Aset_AtreeList_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,
    ~ ! [T3: vEBT_VEBT] :
        ~ ( member @ vEBT_VEBT @ T3 @ ( set2 @ vEBT_VEBT @ treeList ) ) ).

% \<open>\<And>thesis. (\<And>t. t \<in> set treeList \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_60_Leaf__0__not,axiom,
    ! [A2: $o,B2: $o] :
      ~ ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( zero_zero @ nat ) ) ).

% Leaf_0_not
thf(fact_61_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ( order_Greatest @ A @ P )
              = X ) ) ) ) ).

% Greatest_equality
thf(fact_62_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ! [X2: A] :
                  ( ( P @ X2 )
                 => ( ! [Y5: A] :
                        ( ( P @ Y5 )
                       => ( ord_less_eq @ A @ Y5 @ X2 ) )
                   => ( Q @ X2 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_63_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_64_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X2: A] :
          ( ( P @ X2 )
          & ! [Y5: A] :
              ( ( P @ Y5 )
             => ( ord_less_eq @ nat @ ( M @ X2 ) @ ( M @ Y5 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_65_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) ).

% of_nat_eq_iff
thf(fact_66_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X22: $o,Y21: $o,Y22: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X22 )
        = ( vEBT_Leaf @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) ).

% VEBT.inject(2)
thf(fact_67_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_68_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_69_neq0__conv,axiom,
    ! [N: nat] :
      ( ( ( N
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% neq0_conv
thf(fact_70_less__nat__zero__code,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_71_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_72_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( ( zero_zero @ nat )
            = N ) ) ) ).

% of_nat_0_eq_iff
thf(fact_73_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_74_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_iff
thf(fact_75_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% of_nat_le_iff
thf(fact_76_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% of_nat_0_less_iff
thf(fact_77_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X: A] :
        ? [Y2: A] : ( ord_less @ A @ Y2 @ X ) ) ).

% lt_ex
thf(fact_78_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X: A] :
        ? [X_1: A] : ( ord_less @ A @ X @ X_1 ) ) ).

% gt_ex
thf(fact_79_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X @ Z3 )
              & ( ord_less @ A @ Z3 @ Y ) ) ) ) ).

% dense
thf(fact_80_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% less_imp_neq
thf(fact_81_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_82_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_83_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_84_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [X2: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ A @ Y5 @ X2 )
                 => ( P @ Y5 ) )
             => ( P @ X2 ) )
         => ( P @ A2 ) ) ) ).

% less_induct
thf(fact_85_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less @ A @ Y @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv3
thf(fact_86_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( X != Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_cases
thf(fact_87_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_88_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_89_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P2: A > $o] :
            ? [X4: A] : ( P2 @ X4 ) )
        = ( ^ [P3: A > $o] :
            ? [N3: A] :
              ( ( P3 @ N3 )
              & ! [M2: A] :
                  ( ( ord_less @ A @ M2 @ N3 )
                 => ~ ( P3 @ M2 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_90_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less @ A @ A4 @ B4 )
             => ( P @ A4 @ B4 ) )
         => ( ! [A4: A] : ( P @ A4 @ A4 )
           => ( ! [A4: A,B4: A] :
                  ( ( P @ B4 @ A4 )
                 => ( P @ A4 @ B4 ) )
             => ( P @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_91_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_92_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Y @ X )
            | ( X = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_93_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_94_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_95_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_96_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ M @ N )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_97_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
         => ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_imp_less
thf(fact_98_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M != N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) ).

% nat_neq_iff
thf(fact_99_less__not__refl,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_not_refl
thf(fact_100_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) ).

% less_not_refl2
thf(fact_101_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( ( ord_less @ nat @ S @ T2 )
     => ( S != T2 ) ) ).

% less_not_refl3
thf(fact_102_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X2: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ B @ ( F2 @ Y5 ) @ ( F2 @ X2 ) )
                 => ( P @ Y5 ) )
             => ( P @ X2 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_103_less__irrefl__nat,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_irrefl_nat
thf(fact_104_nat__less__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M3: nat] :
              ( ( ord_less @ nat @ M3 @ N2 )
             => ( P @ M3 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) ).

% nat_less_induct
thf(fact_105_infinite__descent,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M3: nat] :
              ( ( ord_less @ nat @ M3 @ N2 )
              & ~ ( P @ M3 ) ) )
     => ( P @ N ) ) ).

% infinite_descent
thf(fact_106_linorder__neqE__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less @ nat @ X @ Y )
       => ( ord_less @ nat @ Y @ X ) ) ) ).

% linorder_neqE_nat
thf(fact_107_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X2: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ B @ ( F2 @ Y5 ) @ ( F2 @ X2 ) )
                 => ( P @ Y5 ) )
             => ( P @ X2 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_108_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE
thf(fact_109_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_asym
thf(fact_110_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ( X != Y ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neq_iff
thf(fact_111_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_112_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_less_trans
thf(fact_113_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less @ B @ X2 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_114_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_115_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) ).

% order_less_irrefl
thf(fact_116_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less @ B @ X2 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_117_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( ord_less @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_118_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V: A > nat,X: A] :
      ( ! [X2: A] :
          ( ~ ( P @ X2 )
         => ? [Y5: A] :
              ( ( ord_less @ nat @ ( V @ Y5 ) @ ( V @ X2 ) )
              & ~ ( P @ Y5 ) ) )
     => ( P @ X ) ) ).

% infinite_descent_measure
thf(fact_119_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_not_sym
thf(fact_120_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,P: $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ X )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_121_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
          | ( X = Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_less_linear
thf(fact_122_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% order_less_imp_not_eq
thf(fact_123_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( Y != X ) ) ) ).

% order_less_imp_not_eq2
thf(fact_124_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_imp_not_less
thf(fact_125_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_126_VEBT_Oexhaust,axiom,
    ! [Y: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X212: $o,X222: $o] :
            ( Y
           != ( vEBT_Leaf @ X212 @ X222 ) ) ) ).

% VEBT.exhaust
thf(fact_127_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X22: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X21 @ X22 ) ) ).

% VEBT.distinct(1)
thf(fact_128_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: A] :
            ( ( P @ Y2 )
           => ( ord_less @ nat @ ( F2 @ Y2 ) @ B2 ) )
       => ? [X2: A] :
            ( ( P @ X2 )
            & ! [Y5: A] :
                ( ( P @ Y5 )
               => ( ord_less_eq @ nat @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_129_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ~ ( ord_less @ A @ X @ Y ) ) ) ).

% leD
thf(fact_130_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% leI
thf(fact_131_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_132_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% antisym_conv1
thf(fact_133_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv2
thf(fact_134_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,Y: A] :
          ( ! [X2: A] :
              ( ( ord_less @ A @ Z2 @ X2 )
             => ( ord_less_eq @ A @ Y @ X2 ) )
         => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ).

% dense_ge
thf(fact_135_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y: A,Z2: A] :
          ( ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Y )
             => ( ord_less_eq @ A @ X2 @ Z2 ) )
         => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ).

% dense_le
thf(fact_136_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X3: A,Y4: A] :
              ( ( ord_less_eq @ A @ X3 @ Y4 )
              & ~ ( ord_less_eq @ A @ Y4 @ X3 ) ) ) ) ) ).

% less_le_not_le
thf(fact_137_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y @ X )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% not_le_imp_less
thf(fact_138_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less @ A @ A3 @ B3 )
              | ( A3 = B3 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_139_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ( A3 != B3 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_140_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_141_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_142_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ~ ( ord_less_eq @ A @ B3 @ A3 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_143_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( ! [W: A] :
                ( ( ord_less @ A @ Z2 @ W )
               => ( ( ord_less @ A @ W @ X )
                 => ( ord_less_eq @ A @ Y @ W ) ) )
           => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% dense_ge_bounded
thf(fact_144_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ! [W: A] :
                ( ( ord_less @ A @ X @ W )
               => ( ( ord_less @ A @ W @ Y )
                 => ( ord_less_eq @ A @ W @ Z2 ) ) )
           => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% dense_le_bounded
thf(fact_145_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less @ A @ B3 @ A3 )
              | ( A3 = B3 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_146_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ( A3 != B3 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_147_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_148_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_149_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ~ ( ord_less_eq @ A @ A3 @ B3 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_150_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_151_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_152_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y4: A] :
              ( ( ord_less @ A @ X3 @ Y4 )
              | ( X3 = Y4 ) ) ) ) ) ).

% order_le_less
thf(fact_153_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X3: A,Y4: A] :
              ( ( ord_less_eq @ A @ X3 @ Y4 )
              & ( X3 != Y4 ) ) ) ) ) ).

% order_less_le
thf(fact_154_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_not_le
thf(fact_155_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_not_less
thf(fact_156_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_less_imp_le
thf(fact_157_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_158_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_159_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_le_less_trans
thf(fact_160_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_less_le_trans
thf(fact_161_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less @ B @ X2 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_162_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_163_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_164_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( ord_less @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_165_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_le_less_linear
thf(fact_166_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ X @ Y )
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_167_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_168_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_169_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_170_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ M @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_171_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_172_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_173_gr0I,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% gr0I
thf(fact_174_not__gr0,axiom,
    ! [N: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_175_not__less0,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_176_less__zeroE,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_177_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( N
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_178_infinite__descent0,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ~ ( P @ N2 )
             => ? [M3: nat] :
                  ( ( ord_less @ nat @ M3 @ N2 )
                  & ~ ( P @ M3 ) ) ) )
       => ( P @ N ) ) ) ).

% infinite_descent0
thf(fact_179_infinite__descent0__measure,axiom,
    ! [A: $tType,V: A > nat,P: A > $o,X: A] :
      ( ! [X2: A] :
          ( ( ( V @ X2 )
            = ( zero_zero @ nat ) )
         => ( P @ X2 ) )
     => ( ! [X2: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V @ X2 ) )
           => ( ~ ( P @ X2 )
             => ? [Y5: A] :
                  ( ( ord_less @ nat @ ( V @ Y5 ) @ ( V @ X2 ) )
                  & ~ ( P @ Y5 ) ) ) )
       => ( P @ X ) ) ) ).

% infinite_descent0_measure
thf(fact_180_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( ( ord_less_eq @ nat @ M2 @ N3 )
          & ( M2 != N3 ) ) ) ) ).

% nat_less_le
thf(fact_181_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_imp_le_nat
thf(fact_182_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( ( ord_less @ nat @ M2 @ N3 )
          | ( M2 = N3 ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_183_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less @ nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_or_eq_imp_le
thf(fact_184_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( M != N )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% le_neq_implies_less
thf(fact_185_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less @ nat @ I2 @ J2 )
         => ( ord_less @ nat @ ( F2 @ I2 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I @ J )
       => ( ord_less_eq @ nat @ ( F2 @ I ) @ ( F2 @ J ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_186_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_nat_0_le_iff
thf(fact_187_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I @ J )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ).

% of_nat_mono
thf(fact_188_ex__least__nat__le,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ K2 )
               => ~ ( P @ I3 ) )
            & ( P @ K2 ) ) ) ) ).

% ex_least_nat_le
thf(fact_189_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_190_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_191_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_12: nat] : ( P @ X_12 )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_192_buildup__gives__valid,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N ) @ N ) ) ).

% buildup_gives_valid
thf(fact_193__092_060open_0620_A_060_Alength_AtreeList_092_060close_062,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ vEBT_VEBT ) @ treeList ) ).

% \<open>0 < length treeList\<close>
thf(fact_194_nat__descend__induct,axiom,
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less @ nat @ N @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N )
           => ( ! [I3: nat] :
                  ( ( ord_less @ nat @ K2 @ I3 )
                 => ( P @ I3 ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_195_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N2: nat] : ( ord_less @ A @ X @ ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% reals_Archimedean2
thf(fact_196_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N2: nat] : ( ord_less_eq @ A @ X @ ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% real_arch_simple
thf(fact_197_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
                & ( ord_less @ A @ E @ D1 )
                & ( ord_less @ A @ E @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_198_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ~ ( ord_less_eq @ A @ T2 @ X5 ) ) ) ).

% minf(8)
thf(fact_199_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( ord_less_eq @ A @ X5 @ T2 ) ) ) ).

% minf(6)
thf(fact_200_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( ord_less_eq @ A @ T2 @ X5 ) ) ) ).

% pinf(8)
thf(fact_201_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ~ ( ord_less_eq @ A @ X5 @ T2 ) ) ) ).

% pinf(6)
thf(fact_202_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B5: B,A6: B] :
          ( ( ~ ( ord_less_eq @ B @ B5 @ A6 ) )
          = ( ord_less @ B @ A6 @ B5 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_203_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A2 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B2 )
                  & ! [X5: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X5 )
                        & ( ord_less @ A @ X5 @ C3 ) )
                     => ( P @ X5 ) )
                  & ! [D3: A] :
                      ( ! [X2: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X2 )
                            & ( ord_less @ A @ X2 @ D3 ) )
                         => ( P @ X2 ) )
                     => ( ord_less_eq @ A @ D3 @ C3 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_204_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_205_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X: A,Y: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y ) )
         => ( X != Y ) ) ) ).

% size_neq_size_imp_neq
thf(fact_206_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F3: A > B,G: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F3 @ G )
              & ~ ( ord_less_eq @ ( A > B ) @ G @ F3 ) ) ) ) ) ).

% less_fun_def
thf(fact_207_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_208_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_209_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_210_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z3: C] :
        ! [X5: C] :
          ( ( ord_less @ C @ X5 @ Z3 )
         => ( F4 = F4 ) ) ) ).

% minf(11)
thf(fact_211_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ~ ( ord_less @ A @ T2 @ X5 ) ) ) ).

% minf(7)
thf(fact_212_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( ord_less @ A @ X5 @ T2 ) ) ) ).

% minf(5)
thf(fact_213_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( X5 != T2 ) ) ) ).

% minf(4)
thf(fact_214_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( X5 != T2 ) ) ) ).

% minf(3)
thf(fact_215_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P4: A > $o,Q: A > $o,Q2: A > $o] :
          ( ? [Z4: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Z4 )
             => ( ( P @ X2 )
                = ( P4 @ X2 ) ) )
         => ( ? [Z4: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ X2 @ Z4 )
               => ( ( Q @ X2 )
                  = ( Q2 @ X2 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( ( P @ X5 )
                    | ( Q @ X5 ) )
                  = ( ( P4 @ X5 )
                    | ( Q2 @ X5 ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_216_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P4: A > $o,Q: A > $o,Q2: A > $o] :
          ( ? [Z4: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Z4 )
             => ( ( P @ X2 )
                = ( P4 @ X2 ) ) )
         => ( ? [Z4: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ X2 @ Z4 )
               => ( ( Q @ X2 )
                  = ( Q2 @ X2 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( ( P @ X5 )
                    & ( Q @ X5 ) )
                  = ( ( P4 @ X5 )
                    & ( Q2 @ X5 ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_217_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z3: C] :
        ! [X5: C] :
          ( ( ord_less @ C @ Z3 @ X5 )
         => ( F4 = F4 ) ) ) ).

% pinf(11)
thf(fact_218_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( ord_less @ A @ T2 @ X5 ) ) ) ).

% pinf(7)
thf(fact_219_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ~ ( ord_less @ A @ X5 @ T2 ) ) ) ).

% pinf(5)
thf(fact_220_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( X5 != T2 ) ) ) ).

% pinf(4)
thf(fact_221_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( X5 != T2 ) ) ) ).

% pinf(3)
thf(fact_222_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P4: A > $o,Q: A > $o,Q2: A > $o] :
          ( ? [Z4: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ Z4 @ X2 )
             => ( ( P @ X2 )
                = ( P4 @ X2 ) ) )
         => ( ? [Z4: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ Z4 @ X2 )
               => ( ( Q @ X2 )
                  = ( Q2 @ X2 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( ( P @ X5 )
                    | ( Q @ X5 ) )
                  = ( ( P4 @ X5 )
                    | ( Q2 @ X5 ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_223_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P4: A > $o,Q: A > $o,Q2: A > $o] :
          ( ? [Z4: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ Z4 @ X2 )
             => ( ( P @ X2 )
                = ( P4 @ X2 ) ) )
         => ( ? [Z4: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ Z4 @ X2 )
               => ( ( Q @ X2 )
                  = ( Q2 @ X2 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( ( P @ X5 )
                    & ( Q @ X5 ) )
                  = ( ( P4 @ X5 )
                    & ( Q2 @ X5 ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_224_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_225_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
          | ( ord_less @ A @ B4 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_226_int__ops_I1_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) )
    = ( zero_zero @ int ) ) ).

% int_ops(1)
thf(fact_227_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_228_buildup__nothing__in__leaf,axiom,
    ! [N: nat,X: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N ) @ X ) ).

% buildup_nothing_in_leaf
thf(fact_229_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_pos_if_in_set
thf(fact_230_buildup__nothing__in__min__max,axiom,
    ! [N: nat,X: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N ) @ X ) ).

% buildup_nothing_in_min_max
thf(fact_231_inthall,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,N: nat] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ N ) ) ) ) ).

% inthall
thf(fact_232_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ! [Xs2: list @ A] :
          ( ! [Ys: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P @ Ys ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) ).

% length_induct
thf(fact_233_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
          & ( K
            = ( semiring_1_of_nat @ int @ N2 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_234_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N2: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N2 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% pos_int_cases
thf(fact_235_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X22: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X22 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_236_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X22: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X22 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_237_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ X ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_238_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X ) @ N ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_239_nat__zero__less__power__iff,axiom,
    ! [X: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_240_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N ) ) ) ).

% of_nat_power
thf(fact_241_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W2: nat,X: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 )
            = ( semiring_1_of_nat @ A @ X ) )
          = ( ( power_power @ nat @ B2 @ W2 )
            = X ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_242_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: nat,B2: nat,W2: nat] :
          ( ( ( semiring_1_of_nat @ A @ X )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) )
          = ( X
            = ( power_power @ nat @ B2 @ W2 ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_243_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% power_eq_0_iff
thf(fact_244_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ B2 @ W2 ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_245_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W2: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W2 ) @ X ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_246_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W2: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W2 ) @ X ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_247_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ B2 @ W2 ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_248_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_249_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_250_verit__la__generic,axiom,
    ! [A2: int,X: int] :
      ( ( ord_less_eq @ int @ A2 @ X )
      | ( A2 = X )
      | ( ord_less_eq @ int @ X @ A2 ) ) ).

% verit_la_generic
thf(fact_251_imp__le__cong,axiom,
    ! [X: int,X6: int,P: $o,P4: $o] :
      ( ( X = X6 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
         => ( P = P4 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
           => P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
           => P4 ) ) ) ) ).

% imp_le_cong
thf(fact_252_conj__le__cong,axiom,
    ! [X: int,X6: int,P: $o,P4: $o] :
      ( ( X = X6 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
         => ( P = P4 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
            & P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
            & P4 ) ) ) ) ).

% conj_le_cong
thf(fact_253_int__if,axiom,
    ! [P: $o,A2: nat,B2: nat] :
      ( ( P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ A2 ) ) )
      & ( ~ P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ B2 ) ) ) ) ).

% int_if
thf(fact_254_nat__int__comparison_I1_J,axiom,
    ( ( ^ [Y3: nat,Z: nat] : ( Y3 = Z ) )
    = ( ^ [A3: nat,B3: nat] :
          ( ( semiring_1_of_nat @ int @ A3 )
          = ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(1)
thf(fact_255_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_inverse
thf(fact_256_int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( semiring_1_of_nat @ int @ N ) )
      = ( M = N ) ) ).

% int_int_eq
thf(fact_257_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N2: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% zero_le_imp_eq_int
thf(fact_258_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N2: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% nonneg_int_cases
thf(fact_259_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_260_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_261_real__arch__inverse,axiom,
    ! [E2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
      = ( ? [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) @ E2 ) ) ) ) ).

% real_arch_inverse
thf(fact_262_forall__pos__mono,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D4: real,E: real] :
          ( ( ord_less @ real @ D4 @ E )
         => ( ( P @ D4 )
           => ( P @ E ) ) )
     => ( ! [N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono
thf(fact_263_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono
thf(fact_264_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_power
thf(fact_265_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_less_power
thf(fact_266_nth__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys2 ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I2 )
              = ( nth @ A @ Ys2 @ I2 ) ) )
       => ( Xs = Ys2 ) ) ) ).

% nth_equalityI
thf(fact_267_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ K )
           => ? [X7: A] : ( P @ I4 @ X7 ) ) )
      = ( ? [Xs3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = K )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K )
               => ( P @ I4 @ ( nth @ A @ Xs3 @ I4 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_268_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z: list @ A] : ( Y3 = Z ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( nth @ A @ Xs3 @ I4 )
                  = ( nth @ A @ Ys3 @ I4 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_269_nat__power__less__imp__less,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% nat_power_less_imp_less
thf(fact_270_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_271_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_272_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) ) )
      = ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_273_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,X: A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I2 ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( P @ X ) ) ) ).

% all_nth_imp_all_set
thf(fact_274_in__set__conv__nth,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ I4 )
              = X ) ) ) ) ).

% in_set_conv_nth
thf(fact_275_list__ball__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) )
       => ( P @ ( nth @ A @ Xs @ N ) ) ) ) ).

% list_ball_nth
thf(fact_276_nth__mem,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ ( nth @ A @ Xs @ N ) @ ( set2 @ A @ Xs ) ) ) ).

% nth_mem
thf(fact_277_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_278_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N )
                  = ( power_power @ A @ B2 @ N ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_279_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_280_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_281_zle__int,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% zle_int
thf(fact_282_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B6 )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( member @ A @ X3 @ B6 ) ) ) ) ).

% subset_code(1)
thf(fact_283_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys2 ) )
     => ( Xs != Ys2 ) ) ).

% neq_if_length_neq
thf(fact_284_Ex__list__of__length,axiom,
    ! [A: $tType,N: nat] :
    ? [Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs2 )
      = N ) ).

% Ex_list_of_length
thf(fact_285_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_286_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_287_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_288_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_289_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_290_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_291_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_292_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_293_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_294_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_295_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_296_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_297_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
thf(fact_298_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
          = A2 ) ) ).

% inverse_inverse_eq
thf(fact_299_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X3: real,Y4: real] :
          ( ( ord_less @ real @ X3 @ Y4 )
          | ( X3 = Y4 ) ) ) ) ).

% less_eq_real_def
thf(fact_300_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X5: A] :
        ? [Y2: A] : ( ord_less @ A @ Y2 @ X5 ) ) ).

% linordered_field_no_lb
thf(fact_301_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X5: A] :
        ? [X_1: A] : ( ord_less @ A @ X5 @ X_1 ) ) ).

% linordered_field_no_ub
thf(fact_302_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
thf(fact_303_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_304_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_305_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_306_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_307_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_308_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_309_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_310_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_311_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_312_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_313_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_314_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_315_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_316_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_317_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_318_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_319_realpow__pos__nth__unique,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
            & ( ( power_power @ real @ X2 @ N )
              = A2 )
            & ! [Y5: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
                  & ( ( power_power @ real @ Y5 @ N )
                    = A2 ) )
               => ( Y5 = X2 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_320_realpow__pos__nth,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ( ( power_power @ real @ R @ N )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_321_psubsetI,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( A5 != B6 )
       => ( ord_less @ ( set @ A ) @ A5 @ B6 ) ) ) ).

% psubsetI
thf(fact_322_subset__antisym,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
       => ( A5 = B6 ) ) ) ).

% subset_antisym
thf(fact_323_subsetI,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A5 )
         => ( member @ A @ X2 @ B6 ) )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ).

% subsetI
thf(fact_324_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_325_count__notin,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_326_intind,axiom,
    ! [A: $tType,I: nat,N: nat,P: A > $o,X: A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( P @ X )
       => ( P @ ( nth @ A @ ( replicate @ A @ N @ X ) @ I ) ) ) ) ).

% intind
thf(fact_327_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T4: vEBT_VEBT,X3: nat] :
          ( ( vEBT_V5719532721284313246member @ T4 @ X3 )
          | ( vEBT_VEBT_membermima @ T4 @ X3 ) ) ) ) ).

% both_member_options_def
thf(fact_328_length__code,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( gen_length @ A @ ( zero_zero @ nat ) ) ) ).

% length_code
thf(fact_329_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N2: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% neg_int_cases
thf(fact_330_verit__minus__simplify_I4_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( uminus_uminus @ B @ ( uminus_uminus @ B @ B2 ) )
          = B2 ) ) ).

% verit_minus_simplify(4)
thf(fact_331_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_332_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_333_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_334_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_335_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_336_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_337_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_338_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_339_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_340_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_341_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_342_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_343_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_344_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_345_less__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_346_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_347_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( ( inverse_inverse @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_348_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% inverse_minus_eq
thf(fact_349_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X: A,N: nat,Y: A] :
      ( ( ( replicate @ A @ M @ X )
        = ( replicate @ A @ N @ Y ) )
      = ( ( M = N )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X = Y ) ) ) ) ).

% replicate_eq_replicate
thf(fact_350_length__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N @ X ) )
      = N ) ).

% length_replicate
thf(fact_351_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_352_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_353_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_354_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_355_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_356_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_357_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_358_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_359_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N ) )
            = ( M = N ) ) ) ) ).

% power_inject_exp
thf(fact_360_negative__eq__positive,axiom,
    ! [N: nat,M: nat] :
      ( ( ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) )
        = ( semiring_1_of_nat @ int @ M ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% negative_eq_positive
thf(fact_361_in__set__replicate,axiom,
    ! [A: $tType,X: A,N: nat,Y: A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N @ Y ) ) )
      = ( ( X = Y )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_362_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
            & ( P @ X3 ) ) )
      = ( ( P @ A2 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_363_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
           => ( P @ X3 ) ) )
      = ( ( P @ A2 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_364_negative__zle,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zle
thf(fact_365_nth__replicate,axiom,
    ! [A: $tType,I: nat,N: nat,X: A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( nth @ A @ ( replicate @ A @ N @ X ) @ I )
        = X ) ) ).

% nth_replicate
thf(fact_366_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less @ nat @ X @ Y ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_367_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_368_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less_eq @ nat @ X @ Y ) ) ) ) ).

% power_increasing_iff
thf(fact_369_complete__real,axiom,
    ! [S2: set @ real] :
      ( ? [X5: real] : ( member @ real @ X5 @ S2 )
     => ( ? [Z4: real] :
          ! [X2: real] :
            ( ( member @ real @ X2 @ S2 )
           => ( ord_less_eq @ real @ X2 @ Z4 ) )
       => ? [Y2: real] :
            ( ! [X5: real] :
                ( ( member @ real @ X5 @ S2 )
               => ( ord_less_eq @ real @ X5 @ Y2 ) )
            & ! [Z4: real] :
                ( ! [X2: real] :
                    ( ( member @ real @ X2 @ S2 )
                   => ( ord_less_eq @ real @ X2 @ Z4 ) )
               => ( ord_less_eq @ real @ Y2 @ Z4 ) ) ) ) ) ).

% complete_real
thf(fact_370_psubset__trans,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
     => ( ( ord_less @ ( set @ A ) @ B6 @ C4 )
       => ( ord_less @ ( set @ A ) @ A5 @ C4 ) ) ) ).

% psubset_trans
thf(fact_371_psubsetD,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C2: A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
     => ( ( member @ A @ C2 @ A5 )
       => ( member @ A @ C2 @ B6 ) ) ) ).

% psubsetD
thf(fact_372_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
         => ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) ) ) ) ).

% verit_negate_coefficient(3)
thf(fact_373_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_374_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_375_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_376_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_377_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_378_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_379_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_380_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_381_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_382_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_383_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_384_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_385_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_386_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_387_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_388_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_389_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_390_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_391_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_392_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_393_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% uminus_int_code(1)
thf(fact_394_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_395_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_396_int__cases2,axiom,
    ! [Z2: int] :
      ( ! [N2: nat] :
          ( Z2
         != ( semiring_1_of_nat @ int @ N2 ) )
     => ~ ! [N2: nat] :
            ( Z2
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ).

% int_cases2
thf(fact_397_real__arch__pow,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ? [N2: nat] : ( ord_less @ real @ Y @ ( power_power @ real @ X @ N2 ) ) ) ).

% real_arch_pow
thf(fact_398_replicate__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = N )
     => ( ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( Y2 = X ) )
       => ( Xs
          = ( replicate @ A @ N @ X ) ) ) ) ).

% replicate_eqI
thf(fact_399_replicate__length__same,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( X2 = X ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X )
        = Xs ) ) ).

% replicate_length_same
thf(fact_400_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_401_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_402_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% one_le_power
thf(fact_403_not__int__zless__negative,axiom,
    ! [N: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_404_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_405_real__arch__pow__inv,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ? [N2: nat] : ( ord_less @ real @ ( power_power @ real @ X @ N2 ) @ Y ) ) ) ).

% real_arch_pow_inv
thf(fact_406_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu @ Uv ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_407_int__cases4,axiom,
    ! [M: int] :
      ( ! [N2: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N2 ) )
     => ~ ! [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% int_cases4
thf(fact_408_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_409_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_410_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_411_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N2: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ).

% nonpos_int_cases
thf(fact_412_negative__zle__0,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_413_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_414_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less @ nat @ M @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_415_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_416_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_increasing
thf(fact_417_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_418_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_419_in__mono,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( member @ A @ X @ A5 )
       => ( member @ A @ X @ B6 ) ) ) ).

% in_mono
thf(fact_420_subsetD,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( member @ A @ C2 @ A5 )
       => ( member @ A @ C2 @ B6 ) ) ) ).

% subsetD
thf(fact_421_equalityE,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( A5 = B6 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B6 @ A5 ) ) ) ).

% equalityE
thf(fact_422_subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A7 )
           => ( member @ A @ X3 @ B7 ) ) ) ) ).

% subset_eq
thf(fact_423_equalityD1,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( A5 = B6 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ).

% equalityD1
thf(fact_424_equalityD2,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( A5 = B6 )
     => ( ord_less_eq @ ( set @ A ) @ B6 @ A5 ) ) ).

% equalityD2
thf(fact_425_subset__iff,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
          ! [T4: A] :
            ( ( member @ A @ T4 @ A7 )
           => ( member @ A @ T4 @ B7 ) ) ) ) ).

% subset_iff
thf(fact_426_subset__refl,axiom,
    ! [A: $tType,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ A5 @ A5 ) ).

% subset_refl
thf(fact_427_Collect__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_mono
thf(fact_428_subset__trans,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ A5 @ C4 ) ) ) ).

% subset_trans
thf(fact_429_set__eq__subset,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: set @ A,Z: set @ A] : ( Y3 = Z ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
            & ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) ) ).

% set_eq_subset
thf(fact_430_Collect__mono__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X3: A] :
            ( ( P @ X3 )
           => ( Q @ X3 ) ) ) ) ).

% Collect_mono_iff
thf(fact_431_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
            | ( A7 = B7 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_432_subset__psubset__trans,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( ord_less @ ( set @ A ) @ B6 @ C4 )
       => ( ord_less @ ( set @ A ) @ A5 @ C4 ) ) ) ).

% subset_psubset_trans
thf(fact_433_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_434_psubset__subset__trans,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
       => ( ord_less @ ( set @ A ) @ A5 @ C4 ) ) ) ).

% psubset_subset_trans
thf(fact_435_psubset__imp__subset,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ).

% psubset_imp_subset
thf(fact_436_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
            & ( A7 != B7 ) ) ) ) ).

% psubset_eq
thf(fact_437_psubsetE,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ord_less_eq @ ( set @ A ) @ B6 @ A5 ) ) ) ).

% psubsetE
thf(fact_438_int__one__le__iff__zero__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% int_one_le_iff_zero_less
thf(fact_439_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_440_count__le__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs @ X ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% count_le_length
thf(fact_441_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N2: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N2 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) )
       => ~ ! [N2: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% int_cases3
thf(fact_442_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_443_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_444_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_445_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_446_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_447_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_448_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_449_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_450_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% compl_less_compl_iff
thf(fact_451_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% compl_le_compl_iff
thf(fact_452_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_453_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_454_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_455_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_456_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_457_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_458_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_less_swap2
thf(fact_459_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_less_swap1
thf(fact_460_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A5 ) @ ( uminus_uminus @ ( set @ A ) @ B6 ) )
      = ( ord_less_eq @ ( set @ A ) @ B6 @ A5 ) ) ).

% Compl_subset_Compl_iff
thf(fact_461_Compl__anti__mono,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B6 ) @ ( uminus_uminus @ ( set @ A ) @ A5 ) ) ) ).

% Compl_anti_mono
thf(fact_462_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_463_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_464_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_465_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_le_swap2
thf(fact_466_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_le_swap1
thf(fact_467_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X ) ) ) ) ).

% compl_mono
thf(fact_468_rotate1__length01,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs )
        = Xs ) ) ).

% rotate1_length01
thf(fact_469_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_470_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_471_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_472_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_473_real__root__increasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N4 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_474_real__root__pow__pos2,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos2
thf(fact_475_real__archimedian__rdiv__eq__0,axiom,
    ! [X: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M4: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M4 ) @ X ) @ C2 ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_476_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
            = X )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_477_set__swap,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I ) ) )
          = ( set2 @ A @ Xs ) ) ) ) ).

% set_swap
thf(fact_478_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_479_list_Oinject,axiom,
    ! [A: $tType,X21: A,X22: list @ A,Y21: A,Y22: list @ A] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) ).

% list.inject
thf(fact_480_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X: A,Y: A] :
      ( ( list_update @ A @ ( list_update @ A @ Xs @ I @ X ) @ I @ Y )
      = ( list_update @ A @ Xs @ I @ Y ) ) ).

% list_update_overwrite
thf(fact_481_frac__frac,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( archimedean_frac @ A @ X ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_frac
thf(fact_482_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_483_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_484_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_485_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_486_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_487_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_488_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_489_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_490_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_491_real__root__zero,axiom,
    ! [N: nat] :
      ( ( root @ N @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_492_length__list__update,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs @ I @ X ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_list_update
thf(fact_493_nth__list__update__neq,axiom,
    ! [A: $tType,I: nat,J: nat,Xs: list @ A,X: A] :
      ( ( I != J )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% nth_list_update_neq
thf(fact_494_list__update__id,axiom,
    ! [A: $tType,Xs: list @ A,I: nat] :
      ( ( list_update @ A @ Xs @ I @ ( nth @ A @ Xs @ I ) )
      = Xs ) ).

% list_update_id
thf(fact_495_set__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate1
thf(fact_496_length__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate1
thf(fact_497_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_498_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_499_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_500_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_501_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z2 )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1
thf(fact_502_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1_right
thf(fact_503_not__real__square__gt__zero,axiom,
    ! [X: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X @ X ) ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_504_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) )
      = X ) ).

% nth_Cons_0
thf(fact_505_ceiling__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% ceiling_zero
thf(fact_506_root__0,axiom,
    ! [X: real] :
      ( ( root @ ( zero_zero @ nat ) @ X )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_507_real__root__eq__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( root @ N @ Y ) )
        = ( X = Y ) ) ) ).

% real_root_eq_iff
thf(fact_508_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_509_list__update__beyond,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I )
     => ( ( list_update @ A @ Xs @ I @ X )
        = Xs ) ) ).

% list_update_beyond
thf(fact_510_ceiling__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archimedean_ceiling @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% ceiling_of_nat
thf(fact_511_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_512_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_513_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_514_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_515_real__root__eq__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_516_real__root__less__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ X @ Y ) ) ) ).

% real_root_less_iff
thf(fact_517_real__root__le__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ X @ Y ) ) ) ).

% real_root_le_iff
thf(fact_518_real__root__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_519_real__root__eq__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( one_one @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_520_nth__list__update__eq,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X ) @ I )
        = X ) ) ).

% nth_list_update_eq
thf(fact_521_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_522_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_less_ceiling
thf(fact_523_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_524_real__root__gt__0__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_gt_0_iff
thf(fact_525_real__root__lt__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_526_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% one_le_ceiling
thf(fact_527_real__root__ge__0__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_ge_0_iff
thf(fact_528_real__root__le__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_529_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_530_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_531_real__root__gt__1__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_gt_1_iff
thf(fact_532_real__root__lt__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_533_real__root__ge__1__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_ge_1_iff
thf(fact_534_real__root__le__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_535_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_536_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_537_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ B3 @ A3 ) ) ) ) ).

% mult.commute
thf(fact_538_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_539_not__Cons__self2,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) ).

% not_Cons_self2
thf(fact_540_list__update__swap,axiom,
    ! [A: $tType,I: nat,I5: nat,Xs: list @ A,X: A,X6: A] :
      ( ( I != I5 )
     => ( ( list_update @ A @ ( list_update @ A @ Xs @ I @ X ) @ I5 @ X6 )
        = ( list_update @ A @ ( list_update @ A @ Xs @ I5 @ X6 ) @ I @ X ) ) ) ).

% list_update_swap
thf(fact_541_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) @ Y )
      = ( cons @ A @ Y @ Xs ) ) ).

% list_update_code(2)
thf(fact_542_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_543_real__root__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( root @ N @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( root @ N @ X ) ) ) ).

% real_root_inverse
thf(fact_544_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_545_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_546_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_547_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_548_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_549_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_550_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_551_set__ConsD,axiom,
    ! [A: $tType,Y: A,X: A,Xs: list @ A] :
      ( ( member @ A @ Y @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
     => ( ( Y = X )
        | ( member @ A @ Y @ ( set2 @ A @ Xs ) ) ) ) ).

% set_ConsD
thf(fact_552_list_Oset__cases,axiom,
    ! [A: $tType,E2: A,A2: list @ A] :
      ( ( member @ A @ E2 @ ( set2 @ A @ A2 ) )
     => ( ! [Z22: list @ A] :
            ( A2
           != ( cons @ A @ E2 @ Z22 ) )
       => ~ ! [Z1: A,Z22: list @ A] :
              ( ( A2
                = ( cons @ A @ Z1 @ Z22 ) )
             => ~ ( member @ A @ E2 @ ( set2 @ A @ Z22 ) ) ) ) ) ).

% list.set_cases
thf(fact_553_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] : ( member @ A @ X21 @ ( set2 @ A @ ( cons @ A @ X21 @ X22 ) ) ) ).

% list.set_intros(1)
thf(fact_554_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y: A,X22: list @ A,X21: A] :
      ( ( member @ A @ Y @ ( set2 @ A @ X22 ) )
     => ( member @ A @ Y @ ( set2 @ A @ ( cons @ A @ X21 @ X22 ) ) ) ) ).

% list.set_intros(2)
thf(fact_555_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ Y )
            = ( times_times @ A @ Y @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_556_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_557_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_commutes
thf(fact_558_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_559_real__minus__mult__self__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X @ X ) ) ).

% real_minus_mult_self_le
thf(fact_560_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y: A,X: A] :
          ( ( ( times_times @ A @ Y @ X )
            = ( times_times @ A @ X @ Y ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y ) @ X )
            = ( times_times @ A @ X @ ( inverse_inverse @ A @ Y ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_561_real__root__pos__pos__le,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ).

% real_root_pos_pos_le
thf(fact_562_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y ) @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% ceiling_mono
thf(fact_563_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% ceiling_less_cancel
thf(fact_564_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_565_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_566_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_567_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_568_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_569_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_570_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_571_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_572_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_573_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_574_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_575_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_576_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_577_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_578_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_579_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_580_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_581_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_582_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_583_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_584_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_585_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_586_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_587_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_588_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_589_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_590_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_591_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_592_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_593_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_594_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_595_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_596_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_597_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_598_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_599_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_600_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_601_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) ) ).

% set_subset_Cons
thf(fact_602_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_603_impossible__Cons,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) )
     => ( Xs
       != ( cons @ A @ X @ Ys2 ) ) ) ).

% impossible_Cons
thf(fact_604_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A,X: A,I: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A5 )
     => ( ( member @ A @ X @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I @ X ) ) @ A5 ) ) ) ).

% set_update_subsetI
thf(fact_605_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_606_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_607_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_608_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_609_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_610_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) ) ) ).

% frac_ge_0
thf(fact_611_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_612_real__root__less__mono,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ) ).

% real_root_less_mono
thf(fact_613_real__root__le__mono,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ) ).

% real_root_le_mono
thf(fact_614_real__root__power,axiom,
    ! [N: nat,X: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ K ) )
        = ( power_power @ real @ ( root @ N @ X ) @ K ) ) ) ).

% real_root_power
thf(fact_615_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_616_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_617_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_618_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_619_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_620_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_621_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_622_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_623_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_624_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_625_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_626_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_627_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_628_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_629_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_630_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_631_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_632_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_633_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N2: nat] : ( ord_less @ A @ Y @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_634_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_635_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_636_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus
thf(fact_637_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_638_set__update__memI,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ X @ ( set2 @ A @ ( list_update @ A @ Xs @ N @ X ) ) ) ) ).

% set_update_memI
thf(fact_639_nth__list__update,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J: nat,X: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( I = J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X ) @ J )
            = X ) )
        & ( ( I != J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X ) @ J )
            = ( nth @ A @ Xs @ J ) ) ) ) ) ).

% nth_list_update
thf(fact_640_list__update__same__conv,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( list_update @ A @ Xs @ I @ X )
          = Xs )
        = ( ( nth @ A @ Xs @ I )
          = X ) ) ) ).

% list_update_same_conv
thf(fact_641_reals__Archimedean3,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ! [Y5: real] :
        ? [N2: nat] : ( ord_less @ real @ Y5 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X ) ) ) ).

% reals_Archimedean3
thf(fact_642_real__root__gt__zero,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_gt_zero
thf(fact_643_real__root__strict__decreasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N4 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X )
         => ( ord_less @ real @ ( root @ N4 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_644_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z3 )
             => ( ( ord_less @ A @ Z3 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z3 @ X ) @ Y ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_mult_one_interval
thf(fact_645_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_646_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_647_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_648_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_649_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_650_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_651_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_652_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_653_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_654_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_655_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_656_real__root__pos__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_pos_pos
thf(fact_657_real__root__strict__increasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_658_real__root__decreasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N4 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ord_less_eq @ real @ ( root @ N4 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_decreasing
thf(fact_659_real__root__pow__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos
thf(fact_660_real__root__pos__unique,axiom,
    ! [N: nat,Y: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( power_power @ real @ Y @ N )
            = X )
         => ( ( root @ N @ X )
            = Y ) ) ) ) ).

% real_root_pos_unique
thf(fact_661_real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ ( power_power @ real @ X @ N ) )
          = X ) ) ) ).

% real_root_power_cancel
thf(fact_662_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_663_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X ) @ ( times_times @ A @ Z2 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_664_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% mult_less_iff1
thf(fact_665_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_666_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_minus'
thf(fact_667_Bernoulli__inequality,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality
thf(fact_668_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat,Y: A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( replicate @ A @ N @ Y ) )
      = ( ( X = Y )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
        & ( Xs
          = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ) ) ).

% Cons_replicate_eq
thf(fact_669_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A,N: nat] :
      ( ( X != Y )
     => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = Y )
        = ( ( ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            = Y )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_670_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_671_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P5: A,M2: nat] :
              ( if @ A
              @ ( M2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P5 @ ( power_power @ A @ P5 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_672_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_673_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_674_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_675_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_676_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_677_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_678_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_679_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_680_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_681_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_682_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_683_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_684_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_685_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_686_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_687_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_688_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_689_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_690_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_691_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_692_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_693_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_694_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_695_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_696_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_697_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_698_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_699_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_700_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_701_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_702_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_703_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_add
thf(fact_704_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_705_diff__0__eq__0,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_706_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N @ K ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_707_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_708_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_709_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_710_diff__diff__cancel,axiom,
    ! [I: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ N )
     => ( ( minus_minus @ nat @ N @ ( minus_minus @ nat @ N @ I ) )
        = I ) ) ).

% diff_diff_cancel
thf(fact_711_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_712_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_713_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_714_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_715_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_716_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_717_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_718_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_719_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_720_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_721_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_722_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_723_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_724_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_725_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_726_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_727_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_728_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_729_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_730_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_731_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_732_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_733_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_734_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_735_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_736_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_737_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_738_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% zero_less_diff
thf(fact_739_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% mult_less_cancel2
thf(fact_740_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% nat_0_less_mult_iff
thf(fact_741_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_742_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% diff_is_0_eq
thf(fact_743_real__add__minus__iff,axiom,
    ! [X: real,A2: real] :
      ( ( ( plus_plus @ real @ X @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X = A2 ) ) ).

% real_add_minus_iff
thf(fact_744_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_745_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_746_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_747_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% mult_le_cancel2
thf(fact_748_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_749_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_750_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% diff_mult_distrib
thf(fact_751_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% diff_mult_distrib2
thf(fact_752_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_753_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_754_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_755_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_756_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_757_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_758_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_759_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_760_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_761_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_762_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_763_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_764_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
         => ( ord_less_eq @ A @ I @ ( minus_minus @ A @ N @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_765_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N: A,J: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
         => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
             => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N @ K ) @ J ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_766_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_767_diff__commute,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I @ K ) @ J ) ) ).

% diff_commute
thf(fact_768_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_769_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_770_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_771_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_772_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_773_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_774_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ B3 @ A3 ) ) ) ) ).

% add.commute
thf(fact_775_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_776_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_777_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_778_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_779_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_780_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_781_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_782_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_783_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_784_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: A,K: A,A2: A,B2: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A5 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_785_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B6: A,K: A,B2: A,A2: A] :
          ( ( B6
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B6 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_786_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: A,K: A,A2: A,B2: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A5 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_787_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_788_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_789_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_790_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_791_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_792_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_793_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_794_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X: A,Y: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ Y ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X @ ( minus_minus @ A @ Y @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_795_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_796_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_797_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B6: A,K: A,B2: A,A2: A] :
          ( ( B6
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B6 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_798_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_799_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_800_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_801_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_802_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_803_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% of_nat_diff
thf(fact_804_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) ) ) ) ).

% ceiling_add_le
thf(fact_805_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_806_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_807_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_808_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_809_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [A3: A,B3: A] :
              ( ( minus_minus @ A @ A3 @ B3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_810_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_811_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_812_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_813_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_814_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X2: A,K2: A] :
              ( ( P @ X2 )
              = ( P @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X2: A,K2: A] :
                ( ( Q @ X2 )
                = ( Q @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X5: A,K3: A] :
                ( ( ( P @ X5 )
                  & ( Q @ X5 ) )
                = ( ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) )
                  & ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_815_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X2: A,K2: A] :
              ( ( P @ X2 )
              = ( P @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X2: A,K2: A] :
                ( ( Q @ X2 )
                = ( Q @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X5: A,K3: A] :
                ( ( ( P @ X5 )
                  | ( Q @ X5 ) )
                = ( ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) )
                  | ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_816_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_817_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_818_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
            ? [C5: A] :
              ( B3
              = ( plus_plus @ A @ A3 @ C5 ) ) ) ) ) ).

% le_iff_add
thf(fact_819_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_820_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C3 ) ) ) ) ).

% less_eqE
thf(fact_821_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_822_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_823_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_824_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_825_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_826_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_827_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_828_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_829_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_830_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_831_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_832_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_833_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_834_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_835_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_836_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_837_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_838_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_839_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_840_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_841_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: A,K: A,A2: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A5 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_842_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_843_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N @ M )
          = ( zero_zero @ nat ) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
thf(fact_844_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_845_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ J @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J @ N ) @ K ) ) ).

% less_imp_diff_less
thf(fact_846_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ord_less @ nat @ M @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_847_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ).

% diff_le_mono2
thf(fact_848_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_849_diff__le__self,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ).

% diff_le_self
thf(fact_850_diff__le__mono,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L ) @ ( minus_minus @ nat @ N @ L ) ) ) ).

% diff_le_mono
thf(fact_851_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_852_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% le_diff_iff
thf(fact_853_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N @ K ) )
          = ( M = N ) ) ) ) ).

% eq_diff_iff
thf(fact_854_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N ) ) ) ).

% power_mult
thf(fact_855_mult__0,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_856_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X3: A] : ( minus_minus @ A @ ( plus_plus @ A @ X3 @ X3 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_857_mult__le__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) ).

% mult_le_mono2
thf(fact_858_mult__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) ).

% mult_le_mono1
thf(fact_859_mult__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ L ) ) ) ) ).

% mult_le_mono
thf(fact_860_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_861_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_862_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_863_times__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_864_nat__mult__1,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) ).

% nat_mult_1
thf(fact_865_nat__mult__1__right,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) ).

% nat_mult_1_right
thf(fact_866_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_867_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_868_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] : ( ord_less @ A @ ( minus_minus @ A @ A3 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_869_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_870_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_871_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_872_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_873_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_874_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_875_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_876_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_877_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_878_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_879_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_880_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_881_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X @ Y ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_882_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_883_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_884_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C3 ) )
               => ( C3
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_885_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_886_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_887_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_888_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_889_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_890_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_891_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_892_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_893_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ) ) ).

% diff_less
thf(fact_894_real__0__less__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_less_add_iff
thf(fact_895_real__add__less__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_less_0_iff
thf(fact_896_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less @ nat @ M @ N ) ) ) ) ).

% less_diff_iff
thf(fact_897_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_898_real__0__le__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_le_add_iff
thf(fact_899_real__add__le__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_le_0_iff
thf(fact_900_mult__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_901_mult__less__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) ) ).

% mult_less_mono2
thf(fact_902_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_903_zmult__zless__mono2,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less @ int @ I @ J )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I ) @ ( times_times @ int @ K @ J ) ) ) ) ).

% zmult_zless_mono2
thf(fact_904_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_905_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_906_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_907_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X3: A] : ( plus_plus @ A @ ( plus_plus @ A @ X3 @ X3 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_908_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ X @ ( plus_plus @ A @ Y @ E ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_epsilon
thf(fact_909_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_910_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_911_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_912_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_913_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_914_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_915_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_916_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_917_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_918_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_919_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_920_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_921_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_922_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_923_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_924_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A2: A,Y: A,U: A,V2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V2 )
               => ( ( ( plus_plus @ A @ U @ V2 )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V2 @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_925_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_926_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = X ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_927_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N3: nat,M2: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M2 ) ) ) ) ).

% nat_less_real_le
thf(fact_928_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N3: nat,M2: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M2 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_929_zmult__zless__mono2__lemma,axiom,
    ! [I: int,J: int,K: nat] :
      ( ( ord_less @ int @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_930_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A2: A,Y: A,U: A,V2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V2 )
               => ( ( ( plus_plus @ A @ U @ V2 )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V2 @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_931_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_932_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_933_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_934_linear__plus__1__le__power,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) @ N ) ) ) ).

% linear_plus_1_le_power
thf(fact_935_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel1
thf(fact_936_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_937_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel1
thf(fact_938_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N ) )
        = ( M = N ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_939_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R2: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R2
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R2 @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R2 @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_940_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_941_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_942_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_943_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_944_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% nat_add_left_cancel_less
thf(fact_945_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% nat_add_left_cancel_le
thf(fact_946_diff__diff__left,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ K )
      = ( minus_minus @ nat @ I @ ( plus_plus @ nat @ J @ K ) ) ) ).

% diff_diff_left
thf(fact_947_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% add_gr_0
thf(fact_948_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ) ).

% Nat.diff_diff_right
thf(fact_949_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_950_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_951_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_952_zle__add1__eq__le,axiom,
    ! [W2: int,Z2: int] :
      ( ( ord_less @ int @ W2 @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W2 @ Z2 ) ) ).

% zle_add1_eq_le
thf(fact_953_zle__diff1__eq,axiom,
    ! [W2: int,Z2: int] :
      ( ( ord_less_eq @ int @ W2 @ ( minus_minus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W2 @ Z2 ) ) ).

% zle_diff1_eq
thf(fact_954_pochhammer__of__nat,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: nat,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( semiring_1_of_nat @ A @ X ) @ N )
          = ( semiring_1_of_nat @ A @ ( comm_s3205402744901411588hammer @ nat @ X @ N ) ) ) ) ).

% pochhammer_of_nat
thf(fact_955_int__plus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_956_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_957_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z2: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z2 ) ) ).

% zadd_int_left
thf(fact_958_int__induct,axiom,
    ! [P: int > $o,K: int,I: int] :
      ( ( P @ K )
     => ( ! [I2: int] :
            ( ( ord_less_eq @ int @ K @ I2 )
           => ( ( P @ I2 )
             => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_induct
thf(fact_959_Diff__mono,axiom,
    ! [A: $tType,A5: set @ A,C4: set @ A,D5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ D5 @ B6 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) @ ( minus_minus @ ( set @ A ) @ C4 @ D5 ) ) ) ) ).

% Diff_mono
thf(fact_960_Diff__subset,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) @ A5 ) ).

% Diff_subset
thf(fact_961_double__diff,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
       => ( ( minus_minus @ ( set @ A ) @ B6 @ ( minus_minus @ ( set @ A ) @ C4 @ A5 ) )
          = A5 ) ) ) ).

% double_diff
thf(fact_962_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_963_plus__nat_Oadd__0,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% plus_nat.add_0
thf(fact_964_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_965_add__lessD1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
     => ( ord_less @ nat @ I @ K ) ) ).

% add_lessD1
thf(fact_966_add__less__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ K @ L )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_less_mono
thf(fact_967_not__add__less1,axiom,
    ! [I: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ I ) ).

% not_add_less1
thf(fact_968_not__add__less2,axiom,
    ! [J: nat,I: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I ) @ I ) ).

% not_add_less2
thf(fact_969_add__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_less_mono1
thf(fact_970_trans__less__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_less_add1
thf(fact_971_trans__less__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_less_add2
thf(fact_972_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ K @ L )
     => ( ( ( plus_plus @ nat @ M @ L )
          = ( plus_plus @ nat @ K @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% less_add_eq_less
thf(fact_973_plus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) ).

% plus_int_code(2)
thf(fact_974_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_975_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) ).

% add_leE
thf(fact_976_le__add1,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) ).

% le_add1
thf(fact_977_le__add2,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) ).

% le_add2
thf(fact_978_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% add_leD1
thf(fact_979_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) ).

% add_leD2
thf(fact_980_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N2 ) ) ) ).

% le_Suc_ex
thf(fact_981_add__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_le_mono
thf(fact_982_add__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_le_mono1
thf(fact_983_trans__le__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_le_add1
thf(fact_984_trans__le__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_le_add2
thf(fact_985_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M2: nat,N3: nat] :
        ? [K4: nat] :
          ( N3
          = ( plus_plus @ nat @ M2 @ K4 ) ) ) ) ).

% nat_le_iff_add
thf(fact_986_int__distrib_I3_J,axiom,
    ! [Z12: int,Z23: int,W2: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z12 @ Z23 ) @ W2 )
      = ( minus_minus @ int @ ( times_times @ int @ Z12 @ W2 ) @ ( times_times @ int @ Z23 @ W2 ) ) ) ).

% int_distrib(3)
thf(fact_987_int__distrib_I4_J,axiom,
    ! [W2: int,Z12: int,Z23: int] :
      ( ( times_times @ int @ W2 @ ( minus_minus @ int @ Z12 @ Z23 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W2 @ Z12 ) @ ( times_times @ int @ W2 @ Z23 ) ) ) ).

% int_distrib(4)
thf(fact_988_int__diff__cases,axiom,
    ! [Z2: int] :
      ~ ! [M4: nat,N2: nat] :
          ( Z2
         != ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% int_diff_cases
thf(fact_989_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% Nat.diff_cancel
thf(fact_990_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_cancel2
thf(fact_991_diff__add__inverse,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N @ M ) @ N )
      = M ) ).

% diff_add_inverse
thf(fact_992_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ N )
      = M ) ).

% diff_add_inverse2
thf(fact_993_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% add_mult_distrib2
thf(fact_994_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% add_mult_distrib
thf(fact_995_int__distrib_I1_J,axiom,
    ! [Z12: int,Z23: int,W2: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z12 @ Z23 ) @ W2 )
      = ( plus_plus @ int @ ( times_times @ int @ Z12 @ W2 ) @ ( times_times @ int @ Z23 @ W2 ) ) ) ).

% int_distrib(1)
thf(fact_996_int__distrib_I2_J,axiom,
    ! [W2: int,Z12: int,Z23: int] :
      ( ( times_times @ int @ W2 @ ( plus_plus @ int @ Z12 @ Z23 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W2 @ Z12 ) @ ( times_times @ int @ W2 @ Z23 ) ) ) ).

% int_distrib(2)
thf(fact_997_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
     => ? [B4: A] : ( member @ A @ B4 @ ( minus_minus @ ( set @ A ) @ B6 @ A5 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_998_Bolzano,axiom,
    ! [A2: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A4: real,B4: real,C3: real] :
            ( ( P @ A4 @ B4 )
           => ( ( P @ B4 @ C3 )
             => ( ( ord_less_eq @ real @ A4 @ B4 )
               => ( ( ord_less_eq @ real @ B4 @ C3 )
                 => ( P @ A4 @ C3 ) ) ) ) )
       => ( ! [X2: real] :
              ( ( ord_less_eq @ real @ A2 @ X2 )
             => ( ( ord_less_eq @ real @ X2 @ B2 )
               => ? [D3: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                    & ! [A4: real,B4: real] :
                        ( ( ( ord_less_eq @ real @ A4 @ X2 )
                          & ( ord_less_eq @ real @ X2 @ B4 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B4 @ A4 ) @ D3 ) )
                       => ( P @ A4 @ B4 ) ) ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_999_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_pos
thf(fact_1000_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_add
thf(fact_1001_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_1002_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_1003_less__imp__add__positive,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ? [K2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K2 )
          & ( ( plus_plus @ nat @ I @ K2 )
            = J ) ) ) ).

% less_imp_add_positive
thf(fact_1004_nat__diff__add__eq2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_1005_nat__diff__add__eq1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_diff_add_eq1
thf(fact_1006_nat__le__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_le_add_iff2
thf(fact_1007_nat__le__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_le_add_iff1
thf(fact_1008_nat__eq__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_1009_nat__eq__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M )
          = N ) ) ) ).

% nat_eq_add_iff1
thf(fact_1010_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N: nat] :
      ( ( P @ K )
     => ( ! [X2: A] :
            ( ( P @ X2 )
           => ? [Y5: A] :
                ( ( P @ Y5 )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) ) )
       => ? [Y2: A] :
            ( ( P @ Y2 )
            & ~ ( ord_less @ nat @ ( F2 @ Y2 ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_1011_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N2: nat] :
          ( ( ord_less @ nat @ M4 @ N2 )
         => ( ord_less @ nat @ ( F2 @ M4 ) @ ( F2 @ N2 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_1012_minus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L )
      = ( uminus_uminus @ int @ L ) ) ).

% minus_int_code(2)
thf(fact_1013_int__le__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I @ K )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_le_induct
thf(fact_1014_diff__add__0,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ N @ ( plus_plus @ nat @ N @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_1015_int__less__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_less_induct
thf(fact_1016_less__diff__conv,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ).

% less_diff_conv
thf(fact_1017_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( plus_plus @ nat @ N @ ( minus_minus @ nat @ M @ N ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_1018_odd__nonzero,axiom,
    ! [Z2: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1019_Nat_Ole__imp__diff__is__add,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ( minus_minus @ nat @ J @ I )
          = K )
        = ( J
          = ( plus_plus @ nat @ K @ I ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_1020_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_1021_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
        = ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_1022_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less_eq @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ) ).

% Nat.le_diff_conv2
thf(fact_1023_le__diff__conv,axiom,
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
      = ( ord_less_eq @ nat @ J @ ( plus_plus @ nat @ I @ K ) ) ) ).

% le_diff_conv
thf(fact_1024_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X3: real,Y4: real] : ( plus_plus @ real @ X3 @ ( uminus_uminus @ real @ Y4 ) ) ) ) ).

% minus_real_def
thf(fact_1025_int__ge__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_ge_induct
thf(fact_1026_zless__add1__eq,axiom,
    ! [W2: int,Z2: int] :
      ( ( ord_less @ int @ W2 @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W2 @ Z2 )
        | ( W2 = Z2 ) ) ) ).

% zless_add1_eq
thf(fact_1027_int__gr__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_gr_induct
thf(fact_1028_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W3: int,Z5: int] :
        ? [N3: nat] :
          ( Z5
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% zle_iff_zadd
thf(fact_1029_gen__length__def,axiom,
    ! [A: $tType] :
      ( ( gen_length @ A )
      = ( ^ [N3: nat,Xs3: list @ A] : ( plus_plus @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ).

% gen_length_def
thf(fact_1030_nat__less__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_less_add_iff2
thf(fact_1031_nat__less__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_less_add_iff1
thf(fact_1032_q__pos__lemma,axiom,
    ! [B5: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) )
     => ( ( ord_less @ int @ R3 @ B5 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q3 ) ) ) ) ).

% q_pos_lemma
thf(fact_1033_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q4: int,R2: int,B5: int,Q3: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R2 )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) )
       => ( ( ord_less @ int @ R3 @ B5 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q4 @ Q3 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_1034_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q4: int,R2: int,B5: int,Q3: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R2 )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q3 @ Q4 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_1035_unique__quotient__lemma,axiom,
    ! [B2: int,Q3: int,R3: int,Q4: int,R2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( ord_less @ int @ R2 @ B2 )
           => ( ord_less_eq @ int @ Q3 @ Q4 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_1036_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q3: int,R3: int,Q4: int,R2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( ord_less @ int @ B2 @ R3 )
           => ( ord_less_eq @ int @ Q4 @ Q3 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_1037_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_nonneg
thf(fact_1038_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_1039_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( plus_plus @ nat @ N @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_1040_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D6: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D6 ) )
           => ( P @ D6 ) ) ) ) ).

% nat_diff_split
thf(fact_1041_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D6: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D6 ) )
                & ~ ( P @ D6 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_1042_plusinfinity,axiom,
    ! [D2: int,P4: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int,K2: int] :
            ( ( P4 @ X2 )
            = ( P4 @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X2: int] :
              ( ( ord_less @ int @ Z4 @ X2 )
             => ( ( P @ X2 )
                = ( P4 @ X2 ) ) )
         => ( ? [X_12: int] : ( P4 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% plusinfinity
thf(fact_1043_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int,K2: int] :
            ( ( P1 @ X2 )
            = ( P1 @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X2: int] :
              ( ( ord_less @ int @ X2 @ Z4 )
             => ( ( P @ X2 )
                = ( P1 @ X2 ) ) )
         => ( ? [X_12: int] : ( P1 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% minusinfinity
thf(fact_1044_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
        = ( ord_less @ nat @ J @ ( plus_plus @ nat @ I @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_1045_odd__less__0__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1046_add1__zle__eq,axiom,
    ! [W2: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W2 @ ( one_one @ int ) ) @ Z2 )
      = ( ord_less @ int @ W2 @ Z2 ) ) ).

% add1_zle_eq
thf(fact_1047_zless__imp__add1__zle,axiom,
    ! [W2: int,Z2: int] :
      ( ( ord_less @ int @ W2 @ Z2 )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W2 @ ( one_one @ int ) ) @ Z2 ) ) ).

% zless_imp_add1_zle
thf(fact_1048_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs ) @ Y )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs @ Y ) @ ( one_one @ nat ) ) ) )
      & ( ( X != Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs ) @ Y )
          = ( count_list @ A @ Xs @ Y ) ) ) ) ).

% count_list.simps(2)
thf(fact_1049_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ? [K4: nat] :
                ( ( ord_less @ nat @ K4 @ N )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K4 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_1050_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_1051_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,K: nat] :
          ( ( ord_less @ nat @ N @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_1052_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_1053_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_1054_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int] :
            ( ( P @ X2 )
           => ( P @ ( minus_minus @ int @ X2 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X5: int] :
              ( ( P @ X5 )
             => ( P @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1055_le__imp__0__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% le_imp_0_less
thf(fact_1056_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( if @ nat
          @ ( M2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N3 @ ( times_times @ nat @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) @ N3 ) ) ) ) ) ).

% mult_eq_if
thf(fact_1057_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int] :
            ( ( P @ X2 )
           => ( P @ ( plus_plus @ int @ X2 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X5: int] :
              ( ( P @ X5 )
             => ( P @ ( plus_plus @ int @ X5 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_1058_zdiff__int__split,axiom,
    ! [P: int > $o,X: nat,Y: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X @ Y ) ) )
      = ( ( ( ord_less_eq @ nat @ Y @ X )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X ) @ ( semiring_1_of_nat @ int @ Y ) ) ) )
        & ( ( ord_less @ nat @ X @ Y )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_1059_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,Z2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z2 @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_1060_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R2 ) @ K ) )
          = ( times_times @ A @ R2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R2 ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_1061_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_1062_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_1063_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1064_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ Js @ ( upto_aux @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) @ ( cons @ int @ J3 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_1065_nat0__intermed__int__val,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N )
              & ( ( F2 @ I2 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_1066_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A4: nat,B4: nat] :
          ( ( P @ A4 @ B4 )
          = ( P @ B4 @ A4 ) )
     => ( ! [A4: nat] : ( P @ A4 @ ( zero_zero @ nat ) )
       => ( ! [A4: nat,B4: nat] :
              ( ( P @ A4 @ B4 )
             => ( P @ A4 @ ( plus_plus @ nat @ A4 @ B4 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1067_length__mul__elem,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ! [X2: list @ A] :
          ( ( member @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xs ) )
         => ( ( size_size @ ( list @ A ) @ X2 )
            = N ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) @ N ) ) ) ).

% length_mul_elem
thf(fact_1068_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_1069_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_1070_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_1071_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_1072_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_1073_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_1074_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_1075_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% abs_of_nat
thf(fact_1076_abs__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ).

% abs_inverse
thf(fact_1077_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_1078_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_1079_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_1080_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_1081_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_1082_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% abs_power_minus
thf(fact_1083_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_1084_zabs__less__one__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z2 ) @ ( one_one @ int ) )
      = ( Z2
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_1085_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_1086_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_1087_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_1088_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_1089_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_1090_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_abs
thf(fact_1091_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_1092_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_1093_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_1094_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_1095_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_1096_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_1097_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_1098_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_1099_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_1100_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_1101_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_1102_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_1103_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_1104_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_1105_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_1106_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_1107_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_1108_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_1109_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_1110_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_1111_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_1112_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% zero_le_power_abs
thf(fact_1113_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A3: A] : ( if @ A @ ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A3 ) @ A3 ) ) ) ) ).

% abs_if
thf(fact_1114_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A3: A] : ( if @ A @ ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A3 ) @ A3 ) ) ) ) ).

% abs_if_raw
thf(fact_1115_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_1116_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_1117_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_1118_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R2 )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R2 ) @ X )
            & ( ord_less_eq @ A @ X @ ( plus_plus @ A @ A2 @ R2 ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_1119_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ A2 @ R2 ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_1120_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I4: int] : ( if @ int @ ( ord_less @ int @ I4 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I4 ) @ I4 ) ) ) ).

% zabs_def
thf(fact_1121_bounded__Max__nat,axiom,
    ! [P: nat > $o,X: nat,M5: nat] :
      ( ( P @ X )
     => ( ! [X2: nat] :
            ( ( P @ X2 )
           => ( ord_less_eq @ nat @ X2 @ M5 ) )
       => ~ ! [M4: nat] :
              ( ( P @ M4 )
             => ~ ! [X5: nat] :
                    ( ( P @ X5 )
                   => ( ord_less_eq @ nat @ X5 @ M4 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1122_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_1123_decr__lemma,axiom,
    ! [D2: int,X: int,Z2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z2 ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z2 ) ) ).

% decr_lemma
thf(fact_1124_incr__lemma,axiom,
    ! [D2: int,Z2: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z2 @ ( plus_plus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z2 ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_1125_nat__ivt__aux,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N )
              & ( ( F2 @ I2 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_1126_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss ) ) ) ).

% in_set_product_lists_length
thf(fact_1127_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X )
              = ( plus_plus @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_1128_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I2 )
            & ( ord_less @ nat @ I2 @ N ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( ord_less_eq @ int @ ( F2 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
           => ? [I2: nat] :
                ( ( ord_less_eq @ nat @ M @ I2 )
                & ( ord_less_eq @ nat @ I2 @ N )
                & ( ( F2 @ I2 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_1129_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_1130_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1131_power_Opower__eq__if,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( ^ [One: A,Times: A > A > A,P5: A,M2: nat] :
            ( if @ A
            @ ( M2
              = ( zero_zero @ nat ) )
            @ One
            @ ( Times @ P5 @ ( power2 @ A @ One @ Times @ P5 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% power.power_eq_if
thf(fact_1132_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_1133_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_1134_even__odd__cases,axiom,
    ! [X: nat] :
      ( ! [N2: nat] :
          ( X
         != ( plus_plus @ nat @ N2 @ N2 ) )
     => ~ ! [N2: nat] :
            ( X
           != ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) ) ) ).

% even_odd_cases
thf(fact_1135_nat_Oinject,axiom,
    ! [X23: nat,Y23: nat] :
      ( ( ( suc @ X23 )
        = ( suc @ Y23 ) )
      = ( X23 = Y23 ) ) ).

% nat.inject
thf(fact_1136_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_1137_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W2: int,Z2: int] :
          ( ( ( ring_1_of_int @ A @ W2 )
            = ( ring_1_of_int @ A @ Z2 ) )
          = ( W2 = Z2 ) ) ) ).

% of_int_eq_iff
thf(fact_1138_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_1139_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_1140_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_1141_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_1142_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_1143_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_1144_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_1145_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_1146_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_1147_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_1148_lessI,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( suc @ N ) ) ).

% lessI
thf(fact_1149_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% Suc_mono
thf(fact_1150_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_eq
thf(fact_1151_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N @ M ) ) ).

% Suc_le_mono
thf(fact_1152_add__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc_right
thf(fact_1153_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_1154_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_Suc_Suc
thf(fact_1155_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N ) @ K ) ) ).

% Suc_diff_diff
thf(fact_1156_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A2 ) ) ) ).

% inverse_divide
thf(fact_1157_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: int,B2: int,W2: nat] :
          ( ( ( ring_1_of_int @ A @ X )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) )
          = ( X
            = ( power_power @ int @ B2 @ W2 ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_1158_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W2: nat,X: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 )
            = ( ring_1_of_int @ A @ X ) )
          = ( ( power_power @ int @ B2 @ W2 )
            = X ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_1159_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int,N: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z2 @ N ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z2 ) @ N ) ) ) ).

% of_int_power
thf(fact_1160_of__nat__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( semiring_char_0_fact @ nat @ N ) )
          = ( semiring_char_0_fact @ A @ N ) ) ) ).

% of_nat_fact
thf(fact_1161_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) )
            = X )
          = ( ? [N3: int] :
                ( X
                = ( ring_1_of_int @ A @ N3 ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_1162_ceiling__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int] :
          ( ( archimedean_ceiling @ A @ ( ring_1_of_int @ A @ Z2 ) )
          = Z2 ) ) ).

% ceiling_of_int
thf(fact_1163_frac__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( member @ A @ ( archimedean_frac @ A @ X ) @ ( ring_1_Ints @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_in_Ints_iff
thf(fact_1164_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_1165_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_1166_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_1167_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_1168_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_1169_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_1170_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_1171_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_1172_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_1173_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_1174_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_1175_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_1176_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_1177_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_1178_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_1179_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_1180_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_1181_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( divide_divide @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X ) ) ) ).

% divide_minus1
thf(fact_1182_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_1183_zero__less__Suc,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) ).

% zero_less_Suc
thf(fact_1184_less__Suc0,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_1185_of__int__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( zero_zero @ int ) )
        = ( zero_zero @ A ) ) ) ).

% of_int_0
thf(fact_1186_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( zero_zero @ A )
            = ( ring_1_of_int @ A @ Z2 ) )
          = ( Z2
            = ( zero_zero @ int ) ) ) ) ).

% of_int_0_eq_iff
thf(fact_1187_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( zero_zero @ A ) )
          = ( Z2
            = ( zero_zero @ int ) ) ) ) ).

% of_int_eq_0_iff
thf(fact_1188_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_1189_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_1190_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W2: int,Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ W2 @ Z2 ) ) ) ).

% of_int_le_iff
thf(fact_1191_mult__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc_right
thf(fact_1192_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W2: int,Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ W2 @ Z2 ) ) ) ).

% of_int_less_iff
thf(fact_1193_nth__Cons__Suc,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( suc @ N ) )
      = ( nth @ A @ Xs @ N ) ) ).

% nth_Cons_Suc
thf(fact_1194_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_1195_power__Suc__0,axiom,
    ! [N: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_1196_nat__power__eq__Suc__0__iff,axiom,
    ! [X: nat,M: nat] :
      ( ( ( power_power @ nat @ X @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_1197_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_1198_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( one_one @ A ) )
          = ( Z2
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_1199_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W2 @ Z2 ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_mult
thf(fact_1200_diff__Suc__1,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( one_one @ nat ) )
      = N ) ).

% diff_Suc_1
thf(fact_1201_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W2 @ Z2 ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_add
thf(fact_1202_of__int__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ Z2 ) )
          = ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_minus
thf(fact_1203_of__int__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( minus_minus @ int @ W2 @ Z2 ) )
          = ( minus_minus @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_diff
thf(fact_1204_real__root__Suc__0,axiom,
    ! [X: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X )
      = X ) ).

% real_root_Suc_0
thf(fact_1205_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( semiring_1_of_nat @ int @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_int_of_nat_eq
thf(fact_1206_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% pochhammer_Suc0
thf(fact_1207_of__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int] :
          ( ( ring_1_of_int @ A @ ( abs_abs @ int @ X ) )
          = ( abs_abs @ A @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% of_int_abs
thf(fact_1208_frac__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int] :
          ( ( archimedean_frac @ A @ ( ring_1_of_int @ A @ Z2 ) )
          = ( zero_zero @ A ) ) ) ).

% frac_of_int
thf(fact_1209_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_eq_0_iff
thf(fact_1210_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_1211_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_1212_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_1213_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_1214_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_1215_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_1216_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_1217_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_1218_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_1219_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_1220_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_1221_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_1222_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_1223_Suc__pred,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% Suc_pred
thf(fact_1224_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) )
          = ( ord_less_eq @ int @ X @ ( power_power @ int @ B2 @ W2 ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_1225_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W2: nat,X: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W2 ) @ X ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_1226_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) ) ).

% one_le_mult_iff
thf(fact_1227_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) )
          = ( ord_less @ int @ X @ ( power_power @ int @ B2 @ W2 ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_1228_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W2: nat,X: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W2 ) @ X ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_1229_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_1230_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I @ ( suc @ ( minus_minus @ nat @ J @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ ( suc @ J ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_1231_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J @ K ) ) @ I )
        = ( minus_minus @ nat @ ( suc @ J ) @ ( plus_plus @ nat @ K @ I ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_1232_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_1233_negative__zless,axiom,
    ! [N: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_1234_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 ) ) ) ).

% ceiling_add_of_int
thf(fact_1235_ceiling__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 ) ) ) ).

% ceiling_diff_of_int
thf(fact_1236_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) )
          = ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_1237_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_1238_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_1239_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_1240_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_1241_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% of_int_0_le_iff
thf(fact_1242_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_1243_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% of_int_0_less_iff
thf(fact_1244_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_1245_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_1246_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_le_iff
thf(fact_1247_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_1248_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_less_iff
thf(fact_1249_Suc__diff__1,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
        = N ) ) ).

% Suc_diff_1
thf(fact_1250_Suc__inject,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) ).

% Suc_inject
thf(fact_1251_n__not__Suc__n,axiom,
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) ).

% n_not_Suc_n
thf(fact_1252_Ints__cases,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q4: A] :
          ( ( member @ A @ Q4 @ ( ring_1_Ints @ A ) )
         => ~ ! [Z3: int] :
                ( Q4
               != ( ring_1_of_int @ A @ Z3 ) ) ) ) ).

% Ints_cases
thf(fact_1253_power_Opower_Opower__Suc,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A,N: nat] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( suc @ N ) )
      = ( Times2 @ A2 @ ( power2 @ A @ One2 @ Times2 @ A2 @ N ) ) ) ).

% power.power.power_Suc
thf(fact_1254_Ints__induct,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q4: A,P: A > $o] :
          ( ( member @ A @ Q4 @ ( ring_1_Ints @ A ) )
         => ( ! [Z3: int] : ( P @ ( ring_1_of_int @ A @ Z3 ) )
           => ( P @ Q4 ) ) ) ) ).

% Ints_induct
thf(fact_1255_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int] : ( member @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_int
thf(fact_1256_power_Opower_Ocong,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( power2 @ A ) ) ).

% power.power.cong
thf(fact_1257_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_1258_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_Suc_0_nat
thf(fact_1259_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_le_of_int
thf(fact_1260_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z3 ) @ X ) ) ).

% ex_of_int_less
thf(fact_1261_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_less_of_int
thf(fact_1262_fact__ge__self,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_self
thf(fact_1263_fact__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ).

% fact_mono_nat
thf(fact_1264_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_1265_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ N )
         != ( zero_zero @ A ) ) ) ).

% fact_nonzero
thf(fact_1266_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z2: A,W2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z2 @ W2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ W2 ) ) ) ) ).

% times_divide_times_eq
thf(fact_1267_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z2: A,W2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z2 @ W2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ W2 ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ).

% divide_divide_times_eq
thf(fact_1268_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_1269_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_1270_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_1271_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_1272_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_1273_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_1274_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_divide
thf(fact_1275_Ints__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_0
thf(fact_1276_vebt__buildup_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ( ( X
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va: nat] :
              ( X
             != ( suc @ ( suc @ Va ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_1277_nat_Odistinct_I1_J,axiom,
    ! [X23: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X23 ) ) ).

% nat.distinct(1)
thf(fact_1278_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat3: nat] :
      ( ( suc @ Nat3 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_1279_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_1280_nat_OdiscI,axiom,
    ! [Nat: nat,X23: nat] :
      ( ( Nat
        = ( suc @ X23 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_1281_old_Onat_Oexhaust,axiom,
    ! [Y: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ~ ! [Nat4: nat] :
            ( Y
           != ( suc @ Nat4 ) ) ) ).

% old.nat.exhaust
thf(fact_1282_nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N2: nat] :
            ( ( P @ N2 )
           => ( P @ ( suc @ N2 ) ) )
       => ( P @ N ) ) ) ).

% nat_induct
thf(fact_1283_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X2: nat] : ( P @ X2 @ ( zero_zero @ nat ) )
     => ( ! [Y2: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y2 ) )
       => ( ! [X2: nat,Y2: nat] :
              ( ( P @ X2 @ Y2 )
             => ( P @ ( suc @ X2 ) @ ( suc @ Y2 ) ) )
         => ( P @ M @ N ) ) ) ) ).

% diff_induct
thf(fact_1284_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_1285_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_1286_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_1287_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_1288_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M4: nat] :
          ( N
          = ( suc @ M4 ) ) ) ).

% not0_implies_Suc
thf(fact_1289_exists__least__lemma,axiom,
    ! [P: nat > $o] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X_12: nat] : ( P @ X_12 )
       => ? [N2: nat] :
            ( ~ ( P @ N2 )
            & ( P @ ( suc @ N2 ) ) ) ) ) ).

% exists_least_lemma
thf(fact_1290_Nat_OlessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ I @ K )
     => ( ( K
         != ( suc @ I ) )
       => ~ ! [J2: nat] :
              ( ( ord_less @ nat @ I @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) ).

% Nat.lessE
thf(fact_1291_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_lessD
thf(fact_1292_Suc__lessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less @ nat @ I @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) ).

% Suc_lessE
thf(fact_1293_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less @ nat @ ( suc @ M ) @ N ) ) ) ).

% Suc_lessI
thf(fact_1294_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( M = N ) ) ) ).

% less_SucE
thf(fact_1295_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% less_SucI
thf(fact_1296_Ex__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
            & ( P @ I4 ) ) )
      = ( ( P @ N )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
            & ( P @ I4 ) ) ) ) ).

% Ex_less_Suc
thf(fact_1297_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( M = N ) ) ) ).

% less_Suc_eq
thf(fact_1298_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N ) )
      = ( ord_less @ nat @ N @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_1299_All__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
           => ( P @ I4 ) ) )
      = ( ( P @ N )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
           => ( P @ I4 ) ) ) ) ).

% All_less_Suc
thf(fact_1300_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N ) @ M )
      = ( ? [M6: nat] :
            ( ( M
              = ( suc @ M6 ) )
            & ( ord_less @ nat @ N @ M6 ) ) ) ) ).

% Suc_less_eq2
thf(fact_1301_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) ).

% less_antisym
thf(fact_1302_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_SucD
thf(fact_1303_less__trans__Suc,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ J @ K )
       => ( ord_less @ nat @ ( suc @ I ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_1304_less__Suc__induct,axiom,
    ! [I: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I @ J )
     => ( ! [I2: nat] : ( P @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J2: nat,K2: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( ( ord_less @ nat @ J2 @ K2 )
               => ( ( P @ I2 @ J2 )
                 => ( ( P @ J2 @ K2 )
                   => ( P @ I2 @ K2 ) ) ) ) )
         => ( P @ I @ J ) ) ) ) ).

% less_Suc_induct
thf(fact_1305_strict__inc__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I @ J )
     => ( ! [I2: nat] :
            ( ( J
              = ( suc @ I2 ) )
           => ( P @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ J )
             => ( ( P @ ( suc @ I2 ) )
               => ( P @ I2 ) ) )
         => ( P @ I ) ) ) ) ).

% strict_inc_induct
thf(fact_1306_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_1307_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_1308_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_1309_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_1310_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_leD
thf(fact_1311_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) ).

% le_SucE
thf(fact_1312_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ ( suc @ N ) ) ) ).

% le_SucI
thf(fact_1313_Suc__le__D,axiom,
    ! [N: nat,M7: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ M7 )
     => ? [M4: nat] :
          ( M7
          = ( suc @ M4 ) ) ) ).

% Suc_le_D
thf(fact_1314_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq @ nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) ).

% le_Suc_eq
thf(fact_1315_Suc__n__not__le__n,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N ) @ N ) ).

% Suc_n_not_le_n
thf(fact_1316_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N ) )
      = ( ord_less_eq @ nat @ ( suc @ N ) @ M ) ) ).

% not_less_eq_eq
thf(fact_1317_full__nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M3 ) @ N2 )
             => ( P @ M3 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) ).

% full_nat_induct
thf(fact_1318_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( P @ M )
       => ( ! [N2: nat] :
              ( ( ord_less_eq @ nat @ M @ N2 )
             => ( ( P @ N2 )
               => ( P @ ( suc @ N2 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_at_least
thf(fact_1319_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R4: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ! [X2: nat] : ( R4 @ X2 @ X2 )
       => ( ! [X2: nat,Y2: nat,Z3: nat] :
              ( ( R4 @ X2 @ Y2 )
             => ( ( R4 @ Y2 @ Z3 )
               => ( R4 @ X2 @ Z3 ) ) )
         => ( ! [N2: nat] : ( R4 @ N2 @ ( suc @ N2 ) )
           => ( R4 @ M @ N ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_1320_Ints__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_diff
thf(fact_1321_add__Suc__shift,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ M @ ( suc @ N ) ) ) ).

% add_Suc_shift
thf(fact_1322_add__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc
thf(fact_1323_nat__arith_Osuc1,axiom,
    ! [A5: nat,K: nat,A2: nat] :
      ( ( A5
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A5 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_1324_Ints__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( uminus_uminus @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_minus
thf(fact_1325_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ ( uminus_uminus @ A @ X ) @ ( ring_1_Ints @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% minus_in_Ints_iff
thf(fact_1326_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_1327_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I: nat] :
      ( ( P @ K )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ ( minus_minus @ nat @ K @ I ) ) ) ) ).

% zero_induct_lemma
thf(fact_1328_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( M = N ) ) ).

% Suc_mult_cancel1
thf(fact_1329_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_nat
thf(fact_1330_Ints__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( abs_abs @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_abs
thf(fact_1331_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N2: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_1332_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% fact_less_mono_nat
thf(fact_1333_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_1334_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_zero
thf(fact_1335_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_1336_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_1337_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_1338_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_1339_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_1340_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_1341_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_1342_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_1343_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_gt_zero
thf(fact_1344_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_1345_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_neg_neg
thf(fact_1346_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_1347_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_1348_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_pos_pos
thf(fact_1349_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_1350_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_1351_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_1352_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_1353_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_1354_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_1355_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_1356_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_1357_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_1358_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_1359_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_1360_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y )
                = ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ( times_times @ A @ X @ Z2 )
                = ( times_times @ A @ W2 @ Y ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_1361_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_1362_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_1363_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1364_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1365_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_mono
thf(fact_1366_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% le_of_int_ceiling
thf(fact_1367_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_one_over
thf(fact_1368_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_1369_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N2: nat] : ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
         => ( ( ord_less @ nat @ N @ N5 )
           => ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_1370_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,M: nat] :
          ( ! [N2: nat] : ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_1371_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_1372_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_Suc
thf(fact_1373_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ A3 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_1374_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ A3 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% divide_inverse
thf(fact_1375_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ ( inverse_inverse @ A @ B3 ) @ A3 ) ) ) ) ).

% divide_inverse_commute
thf(fact_1376_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_1377_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ nat @ N @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_1378_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) )
         => ( ( ord_less_eq @ nat @ N @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N5 ) @ ( F2 @ N ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_1379_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_1380_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_1381_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J3: nat] :
            ( ( M
              = ( suc @ J3 ) )
            & ( ord_less @ nat @ J3 @ N ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_1382_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ? [M4: nat] :
          ( N
          = ( suc @ M4 ) ) ) ).

% gr0_implies_Suc
thf(fact_1383_All__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
           => ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
           => ( P @ ( suc @ I4 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_1384_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
      = ( ? [M2: nat] :
            ( N
            = ( suc @ M2 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_1385_Ex__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
            & ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
            & ( P @ ( suc @ I4 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_1386_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% le_imp_less_Suc
thf(fact_1387_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N3: nat] : ( ord_less_eq @ nat @ ( suc @ N3 ) ) ) ) ).

% less_eq_Suc_le
thf(fact_1388_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% less_Suc_eq_le
thf(fact_1389_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% le_less_Suc_eq
thf(fact_1390_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_lessD
thf(fact_1391_inc__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( P @ J )
       => ( ! [N2: nat] :
              ( ( ord_less_eq @ nat @ I @ N2 )
             => ( ( ord_less @ nat @ N2 @ J )
               => ( ( P @ ( suc @ N2 ) )
                 => ( P @ N2 ) ) ) )
         => ( P @ I ) ) ) ) ).

% inc_induct
thf(fact_1392_dec__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( P @ I )
       => ( ! [N2: nat] :
              ( ( ord_less_eq @ nat @ I @ N2 )
             => ( ( ord_less @ nat @ N2 @ J )
               => ( ( P @ N2 )
                 => ( P @ ( suc @ N2 ) ) ) ) )
         => ( P @ J ) ) ) ) ).

% dec_induct
thf(fact_1393_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_eq
thf(fact_1394_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_leI
thf(fact_1395_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_1396_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_1397_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_1398_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_1399_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_1400_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ? [K2: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M @ K2 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_1401_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M2: nat,N3: nat] :
        ? [K4: nat] :
          ( N3
          = ( suc @ ( plus_plus @ nat @ M2 @ K4 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_1402_less__add__Suc2,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ M @ I ) ) ) ).

% less_add_Suc2
thf(fact_1403_less__add__Suc1,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ I @ M ) ) ) ).

% less_add_Suc1
thf(fact_1404_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ~ ! [Q5: nat] :
            ( N
           != ( suc @ ( plus_plus @ nat @ M @ Q5 ) ) ) ) ).

% less_natE
thf(fact_1405_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y4: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y4 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% Suc_length_conv
thf(fact_1406_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y4: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y4 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% length_Suc_conv
thf(fact_1407_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N ) ) )
        = ( minus_minus @ nat @ M @ N ) ) ) ).

% Suc_diff_Suc
thf(fact_1408_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_1409_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_mult_less_cancel1
thf(fact_1410_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( suc @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Suc_diff_le
thf(fact_1411_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_1412_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_mult_le_cancel1
thf(fact_1413_mult__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc
thf(fact_1414_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_1415_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_1416_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N3: nat] : ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_1417_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1418_int__cases,axiom,
    ! [Z2: int] :
      ( ! [N2: nat] :
          ( Z2
         != ( semiring_1_of_nat @ int @ N2 ) )
     => ~ ! [N2: nat] :
            ( Z2
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ).

% int_cases
thf(fact_1419_int__of__nat__induct,axiom,
    ! [P: int > $o,Z2: int] :
      ( ! [N2: nat] : ( P @ ( semiring_1_of_nat @ int @ N2 ) )
     => ( ! [N2: nat] : ( P @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) )
       => ( P @ Z2 ) ) ) ).

% int_of_nat_induct
thf(fact_1420_replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( replicate @ A @ ( suc @ N ) @ X )
      = ( cons @ A @ X @ ( replicate @ A @ N @ X ) ) ) ).

% replicate_Suc
thf(fact_1421_list__update__code_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I: nat,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( suc @ I ) @ Y )
      = ( cons @ A @ X @ ( list_update @ A @ Xs @ I @ Y ) ) ) ).

% list_update_code(3)
thf(fact_1422_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less_eq @ A @ P6 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P6 @ Q4 ) ) ) @ Q4 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_1423_power_Opower_Opower__0,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( zero_zero @ nat ) )
      = One2 ) ).

% power.power.power_0
thf(fact_1424_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_1425_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1426_gen__length__code_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs: list @ B] :
      ( ( gen_length @ B @ N @ ( cons @ B @ X @ Xs ) )
      = ( gen_length @ B @ ( suc @ N ) @ Xs ) ) ).

% gen_length_code(2)
thf(fact_1427_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P6 @ Q4 ) ) ) @ ( one_one @ A ) ) @ Q4 ) @ P6 ) ) ) ).

% ceiling_divide_lower
thf(fact_1428_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_1429_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_1430_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,W2: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W2 )
             => ( ( ord_less_eq @ A @ W2 @ Z2 )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y @ W2 ) ) ) ) ) ) ) ).

% frac_le
thf(fact_1431_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W2: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W2 )
             => ( ( ord_less_eq @ A @ W2 @ Z2 )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y @ W2 ) ) ) ) ) ) ) ).

% frac_less
thf(fact_1432_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W2: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W2 )
             => ( ( ord_less @ A @ W2 @ Z2 )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y @ W2 ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_1433_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_1434_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_1435_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_1436_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_1437_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_1438_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_1439_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_1440_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_1441_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_1442_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_1443_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_1444_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_1445_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_1446_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ ( times_times @ A @ Z2 @ Y ) @ X )
           => ( ord_less @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_1447_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_1448_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_1449_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1450_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1451_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_1452_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_1453_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_1454_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_frac_num
thf(fact_1455_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_num_frac
thf(fact_1456_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% add_divide_eq_iff
thf(fact_1457_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_add_eq_iff
thf(fact_1458_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1459_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1460_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1461_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1462_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_1463_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_1464_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1465_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1466_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1467_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_1468_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_1469_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X ) @ Y )
            = ( abs_abs @ A @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% abs_div_pos
thf(fact_1470_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A3: real] : ( if @ real @ ( ord_less @ real @ A3 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A3 ) @ A3 ) ) ) ).

% abs_real_def
thf(fact_1471_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% ceiling_le_iff
thf(fact_1472_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_1473_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ) ).

% fact_less_mono
thf(fact_1474_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ int @ Z2 @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ).

% less_ceiling_iff
thf(fact_1475_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_1476_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N ) )
            = ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_1477_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_1478_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_1479_real__root__abs,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( abs_abs @ real @ X ) )
        = ( abs_abs @ real @ ( root @ N @ X ) ) ) ) ).

% real_root_abs
thf(fact_1480_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N @ N ) ) ) ) ).

% fact_le_power
thf(fact_1481_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_1482_ex__least__nat__less,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less @ nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ K2 )
               => ~ ( P @ I3 ) )
            & ( P @ ( suc @ K2 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_1483_diff__Suc__less,axiom,
    ! [N: nat,I: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N @ ( suc @ I ) ) @ N ) ) ).

% diff_Suc_less
thf(fact_1484_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) ) ) ) ).

% one_less_mult
thf(fact_1485_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ) ).

% n_less_m_mult_n
thf(fact_1486_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ N @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_1487_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [X3: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ X3 @ Ys3 ) )
            & ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Ys3 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_1488_zdiv__mono1,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A6 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_1489_zdiv__mono2,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B5 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_1490_zdiv__eq__0__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( divide_divide @ int @ I @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_1491_zdiv__mono1__neg,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A6 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_1492_zdiv__mono2__neg,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B5 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_1493_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_1494_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ L @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) ) ) ) ).

% div_positive_int
thf(fact_1495_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_1496_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_1497_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I @ K ) )
        = ( ord_less_eq @ int @ K @ I ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_1498_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_1499_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_1500_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_1501_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X @ K ) @ X ) ) ) ).

% int_div_less_self
thf(fact_1502_nat__induct__non__zero,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( P @ N2 )
               => ( P @ ( suc @ N2 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_non_zero
thf(fact_1503_realpow__pos__nth2,axiom,
    ! [A2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
          & ( ( power_power @ real @ R @ ( suc @ N ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_1504_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N @ K ) ) ) ).

% power_gt_expt
thf(fact_1505_nat__one__le__power,axiom,
    ! [I: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I @ N ) ) ) ).

% nat_one_le_power
thf(fact_1506_int__Suc,axiom,
    ! [N: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_1507_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_1508_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W3: int,Z5: int] :
        ? [N3: nat] :
          ( Z5
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_1509_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_1510_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_1511_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_nonneg
thf(fact_1512_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_1513_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_pos
thf(fact_1514_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_1515_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z3 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_1516_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [X2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X2 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X2 @ ( one_one @ int ) ) ) )
          & ! [Y5: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y5 ) @ X )
                & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y5 @ ( one_one @ int ) ) ) ) )
             => ( Y5 = X2 ) ) ) ) ).

% floor_exists1
thf(fact_1517_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R2 ) ) @ ( plus_plus @ A @ R2 @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_1518_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R2 ) ) @ ( one_one @ A ) ) @ R2 ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_1519_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_1520_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_1521_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_1522_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_1523_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_1524_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_1525_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_1526_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_1527_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ Y ) @ X )
           => ( ord_less_eq @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_1528_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_1529_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1530_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1531_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1532_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,X: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ X ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_1533_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1534_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1535_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1536_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1537_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1538_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1539_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1540_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1541_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1542_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1543_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1544_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1545_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N3: int,M2: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N3 ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M2 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_1546_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_1547_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N3: int,M2: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N3 ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M2 ) ) ) ) ).

% int_less_real_le
thf(fact_1548_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_1549_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_diff
thf(fact_1550_root__abs__power,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( abs_abs @ real @ ( root @ N @ ( power_power @ real @ Y @ N ) ) )
        = ( abs_abs @ real @ Y ) ) ) ).

% root_abs_power
thf(fact_1551_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N2: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) ) @ X ) ) ) ).

% reals_Archimedean
thf(fact_1552_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_1553_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_1554_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_1555_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_1556_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y @ ( ring_1_Ints @ A ) )
           => ( ( X = Y )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_1557_Suc__pred_H,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( N
        = ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1558_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1559_verit__less__mono__div__int2,axiom,
    ! [A5: int,B6: int,N: int] :
      ( ( ord_less_eq @ int @ A5 @ B6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B6 @ N ) @ ( divide_divide @ int @ A5 @ N ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_1560_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_1561_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( if @ nat
          @ ( M2
            = ( zero_zero @ nat ) )
          @ N3
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) @ N3 ) ) ) ) ) ).

% add_eq_if
thf(fact_1562_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_1563_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_1564_not__zle__0__negative,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ).

% not_zle_0_negative
thf(fact_1565_negD,axiom,
    ! [X: int] :
      ( ( ord_less @ int @ X @ ( zero_zero @ int ) )
     => ? [N2: nat] :
          ( X
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ).

% negD
thf(fact_1566_negative__zless__0,axiom,
    ! [N: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_1567_forall__pos__mono__1,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D4: real,E: real] :
          ( ( ord_less @ real @ D4 @ E )
         => ( ( P @ D4 )
           => ( P @ E ) ) )
     => ( ! [N2: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono_1
thf(fact_1568_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I4 ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% ceiling_split
thf(fact_1569_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_1570_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z2 ) ) ) ) ).

% ceiling_unique
thf(fact_1571_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_1572_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_1573_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_1574_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_1575_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_1576_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_1577_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1578_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1579_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1580_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V2: A,R2: A,S: A] :
          ( ( ord_less_eq @ A @ U @ V2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R2 )
           => ( ( ord_less_eq @ A @ R2 @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R2 @ ( minus_minus @ A @ V2 @ U ) ) @ S ) ) @ V2 ) ) ) ) ) ).

% scaling_mono
thf(fact_1581_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_1582_split__zdiv,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) ) ) ) ).

% split_zdiv
thf(fact_1583_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q4 ) ) ) ) ).

% int_div_neg_eq
thf(fact_1584_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q4 ) ) ) ) ).

% int_div_pos_eq
thf(fact_1585_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_1586_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M2: nat] :
              ( if @ A
              @ ( M2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_1587_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_1588_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_1589_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_1590_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_1591_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_1592_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_1593_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_1594_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_1595_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_1596_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_1597_div__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_1598_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( divide_divide @ nat @ M @ N ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_1599_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_1600_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_1601_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_1602_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N @ M ) @ N )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_1603_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N ) @ N )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_1604_div__le__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ).

% div_le_dividend
thf(fact_1605_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N @ K ) ) ) ).

% div_le_mono
thf(fact_1606_real__of__nat__div4,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) ) ).

% real_of_nat_div4
thf(fact_1607_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_1608_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ ( divide_divide @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_div_le_mono
thf(fact_1609_less__mult__imp__div__less,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I @ N ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ I ) ) ).

% less_mult_imp_div_less
thf(fact_1610_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_1611_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_1612_real__of__nat__div2,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) ) ).

% real_of_nat_div2
thf(fact_1613_real__of__nat__div3,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_1614_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ N @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% div_greater_zero_iff
thf(fact_1615_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_1616_div__less__iff__less__mult,axiom,
    ! [Q4: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q4 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q4 ) @ N )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N @ Q4 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_1617_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N )
          = M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1618_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ) ) ).

% div_less_dividend
thf(fact_1619_real__of__int__div4,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) ) ).

% real_of_int_div4
thf(fact_1620_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_1621_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X3: real,Y4: real] : ( times_times @ real @ X3 @ ( inverse_inverse @ real @ Y4 ) ) ) ) ).

% divide_real_def
thf(fact_1622_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M2 @ N3 )
            | ( N3
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M2 @ N3 ) @ N3 ) ) ) ) ) ).

% div_if
thf(fact_1623_div__nat__eqI,axiom,
    ! [N: nat,Q4: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q4 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q4 ) ) )
       => ( ( divide_divide @ nat @ M @ N )
          = Q4 ) ) ) ).

% div_nat_eqI
thf(fact_1624_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q4: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q4 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N @ Q4 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q4 ) @ N ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_1625_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_1626_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) ) ) ) ).

% dividend_less_div_times
thf(fact_1627_split__div,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I4 ) @ J3 ) )
               => ( P @ I4 ) ) ) ) ) ) ).

% split_div
thf(fact_1628_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( divide_divide @ nat @ M @ N ) ) ) ).

% nat_mult_div_cancel1
thf(fact_1629_fact__div__fact__le__pow,axiom,
    ! [R2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R2 @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ R2 ) ) ) @ ( power_power @ nat @ N @ R2 ) ) ) ).

% fact_div_fact_le_pow
thf(fact_1630_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% le_div_geq
thf(fact_1631_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q6: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q6 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q6 ) ) )
            & ( P @ Q6 ) ) ) ) ).

% split_div'
thf(fact_1632_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% div_geq
thf(fact_1633_real__of__int__div2,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) ) ).

% real_of_int_div2
thf(fact_1634_real__of__int__div3,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_1635_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_1636_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_1637_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1638_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1639_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_1640_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1641_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_1642_lemma__interval,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y5: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y5 ) ) @ D4 )
               => ( ( ord_less_eq @ real @ A2 @ Y5 )
                  & ( ord_less_eq @ real @ Y5 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_1643_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_1644_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_1645_sin__bound__lemma,axiom,
    ! [X: real,Y: real,U: real,V2: real] :
      ( ( X = Y )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U ) @ V2 )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X @ U ) @ Y ) ) @ V2 ) ) ) ).

% sin_bound_lemma
thf(fact_1646_lemma__interval__lt,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y5: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y5 ) ) @ D4 )
               => ( ( ord_less @ real @ A2 @ Y5 )
                  & ( ord_less @ real @ Y5 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_1647_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H: nat > A,G2: A,N: nat] :
      ( ! [N2: nat] :
          ( ( F2 @ ( suc @ N2 ) )
          = ( H @ N2 ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G2 )
       => ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = G2 ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = ( H @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1648_list__decode_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ~ ! [N2: nat] :
            ( X
           != ( suc @ N2 ) ) ) ).

% list_decode.cases
thf(fact_1649_length__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X @ Xs ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_Cons
thf(fact_1650_dependent__nat__choice,axiom,
    ! [A: $tType,P: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_12: A] : ( P @ ( zero_zero @ nat ) @ X_12 )
     => ( ! [X2: A,N2: nat] :
            ( ( P @ N2 @ X2 )
           => ? [Y5: A] :
                ( ( P @ ( suc @ N2 ) @ Y5 )
                & ( Q @ N2 @ X2 @ Y5 ) ) )
       => ? [F5: nat > A] :
          ! [N6: nat] :
            ( ( P @ N6 @ ( F5 @ N6 ) )
            & ( Q @ N6 @ ( F5 @ N6 ) @ ( F5 @ ( suc @ N6 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_1651_split__root,axiom,
    ! [P: real > $o,N: nat,X: real] :
      ( ( P @ ( root @ N @ X ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ! [Y4: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N ) )
                = X )
             => ( P @ Y4 ) ) ) ) ) ).

% split_root
thf(fact_1652_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_1653_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ ( uminus_uminus @ real @ X ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_1654_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ X ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_1655_arctan__add,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_1656_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less @ A @ P6 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P6 @ Q4 ) ) ) @ ( one_one @ A ) ) @ Q4 ) ) ) ) ).

% floor_divide_upper
thf(fact_1657_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_1658_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_1659_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_sgn
thf(fact_1660_sgn__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% sgn_inverse
thf(fact_1661_inverse__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% inverse_sgn
thf(fact_1662_floor__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int] :
          ( ( archim6421214686448440834_floor @ A @ ( ring_1_of_int @ A @ Z2 ) )
          = Z2 ) ) ).

% floor_of_int
thf(fact_1663_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) )
            = X )
          = ( ? [N3: int] :
                ( X
                = ( ring_1_of_int @ A @ N3 ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_1664_exp__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) ) ) ).

% exp_less_mono
thf(fact_1665_exp__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% exp_less_cancel_iff
thf(fact_1666_exp__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% exp_le_cancel_iff
thf(fact_1667_arctan__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ( arctan @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% arctan_eq_zero_iff
thf(fact_1668_arctan__zero__zero,axiom,
    ( ( arctan @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arctan_zero_zero
thf(fact_1669_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_1670_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_1671_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_1672_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_1673_floor__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% floor_zero
thf(fact_1674_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_1675_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_1676_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_1677_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% gbinomial_Suc0
thf(fact_1678_floor__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% floor_of_nat
thf(fact_1679_arctan__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_1680_zero__less__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_less_arctan_iff
thf(fact_1681_exp__eq__one__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ X )
        = ( one_one @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_1682_zero__le__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_arctan_iff
thf(fact_1683_arctan__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_1684_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_1685_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_1686_exp__less__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_1687_one__less__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_less_exp_iff
thf(fact_1688_exp__le__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_1689_one__le__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_le_exp_iff
thf(fact_1690_floor__uminus__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( uminus_uminus @ int @ Z2 ) ) ) ).

% floor_uminus_of_int
thf(fact_1691_floor__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 ) ) ) ).

% floor_diff_of_int
thf(fact_1692_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ) ).

% floor_add2
thf(fact_1693_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_1694_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_le_floor
thf(fact_1695_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_1696_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_1697_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_1698_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_1699_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_1700_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_1701_exp__less__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
     => ( ord_less @ real @ X @ Y ) ) ).

% exp_less_cancel
thf(fact_1702_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( exp @ A @ X )
         != ( zero_zero @ A ) ) ) ).

% exp_not_eq_zero
thf(fact_1703_of__nat__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat,K: nat] :
          ( ( semiring_1_of_nat @ A @ ( gbinomial @ nat @ N @ K ) )
          = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K ) ) ) ).

% of_nat_gbinomial
thf(fact_1704_arctan__monotone_H,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y ) ) ) ).

% arctan_monotone'
thf(fact_1705_arctan__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% arctan_le_iff
thf(fact_1706_arctan__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% arctan_less_iff
thf(fact_1707_arctan__monotone,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y ) ) ) ).

% arctan_monotone
thf(fact_1708_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_1709_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_1710_exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X2: real] :
          ( ( exp @ real @ X2 )
          = Y ) ) ).

% exp_total
thf(fact_1711_exp__gt__zero,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_gt_zero
thf(fact_1712_not__exp__less__zero,axiom,
    ! [X: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_1713_not__exp__le__zero,axiom,
    ! [X: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_1714_exp__ge__zero,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_ge_zero
thf(fact_1715_exp__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( exp @ A @ ( uminus_uminus @ A @ X ) )
          = ( inverse_inverse @ A @ ( exp @ A @ X ) ) ) ) ).

% exp_minus
thf(fact_1716_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ).

% floor_mono
thf(fact_1717_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X ) ) ).

% of_int_floor_le
thf(fact_1718_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% floor_less_cancel
thf(fact_1719_exp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) ) ) ).

% exp_gt_one
thf(fact_1720_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_1721_exp__ge__add__one__self,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ).

% exp_ge_add_one_self
thf(fact_1722_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% floor_le_ceiling
thf(fact_1723_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,N: nat] :
          ( ( exp @ A @ ( times_times @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat2_mult
thf(fact_1724_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ X ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat_mult
thf(fact_1725_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_1726_exp__ge__add__one__self__aux,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_1727_lemma__exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y )
     => ? [X2: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less_eq @ real @ X2 @ ( minus_minus @ real @ Y @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X2 )
            = Y ) ) ) ).

% lemma_exp_total
thf(fact_1728_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_1729_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_1730_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_1731_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_1732_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ).

% le_floor_iff
thf(fact_1733_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% floor_less_iff
thf(fact_1734_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% le_floor_add
thf(fact_1735_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ) ).

% floor_add_int
thf(fact_1736_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( plus_plus @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ) ).

% int_add_floor
thf(fact_1737_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_1738_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) )
          = ( divide_divide @ int @ K @ L ) ) ) ).

% floor_divide_of_int_eq
thf(fact_1739_ceiling__minus,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ int @ ( archim6421214686448440834_floor @ A @ X ) ) ) ) ).

% ceiling_minus
thf(fact_1740_floor__minus,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ int @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% floor_minus
thf(fact_1741_ceiling__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X3: A] : ( uminus_uminus @ int @ ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ X3 ) ) ) ) ) ) ).

% ceiling_def
thf(fact_1742_sgn__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( sgn_sgn @ real @ ( root @ N @ X ) )
        = ( sgn_sgn @ real @ X ) ) ) ).

% sgn_root
thf(fact_1743_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: nat] :
          ( ( X
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X @ N ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X ) @ N ) ) ) ) ).

% floor_power
thf(fact_1744_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_1745_frac__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_frac @ A )
        = ( ^ [X3: A] : ( minus_minus @ A @ X3 @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X3 ) ) ) ) ) ) ).

% frac_def
thf(fact_1746_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_1747_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_1748_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_1749_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) ) @ N )
            = ( exp @ A @ X ) ) ) ) ).

% exp_divide_power_eq
thf(fact_1750_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_1751_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_1752_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A3: real] :
          ( if @ real
          @ ( A3
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A3 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_1753_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X3: A] :
              ( if @ A
              @ ( X3
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X3 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_1754_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_1755_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X3: A] :
              ( if @ int
              @ ( X3
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X3 ) ) )
              @ ( archim6421214686448440834_floor @ A @ X3 )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_1756_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_1757_real__of__int__floor__add__one__gt,axiom,
    ! [R2: real] : ( ord_less @ real @ R2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_1758_floor__eq,axiom,
    ! [N: int,X: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq
thf(fact_1759_real__of__int__floor__add__one__ge,axiom,
    ! [R2: real] : ( ord_less_eq @ real @ R2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_1760_real__of__int__floor__gt__diff__one,axiom,
    ! [R2: real] : ( ord_less @ real @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_1761_real__of__int__floor__ge__diff__one,axiom,
    ! [R2: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_1762_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_1763_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_1764_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K4 ) @ A3 ) @ ( one_one @ A ) ) @ K4 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_1765_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_1766_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z2 ) ) ) ) ).

% floor_unique
thf(fact_1767_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_1768_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I4 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% floor_split
thf(fact_1769_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_1770_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_1771_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_1772_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_1773_sgn__power__injE,axiom,
    ! [A2: real,N: nat,X: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N ) )
        = X )
     => ( ( X
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_1774_floor__eq2,axiom,
    ! [N: int,X: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq2
thf(fact_1775_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_1776_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_1777_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_1778_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A3 ) @ K4 ) ) @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_1779_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K4: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K4 ) ) @ ( one_one @ A ) ) @ K4 ) @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_1780_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P6 @ Q4 ) ) ) @ Q4 ) @ P6 ) ) ) ).

% floor_divide_lower
thf(fact_1781_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_1782_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_1783_sgn__power__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N @ X ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N @ X ) ) @ N ) )
        = X ) ) ).

% sgn_power_root
thf(fact_1784_root__sgn__power,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) ) )
        = Y ) ) ).

% root_sgn_power
thf(fact_1785_zero__le__sgn__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_sgn_iff
thf(fact_1786_sgn__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_1787_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_1788_sgn__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_zero
thf(fact_1789_artanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% artanh_0
thf(fact_1790_arsinh__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arsinh_0
thf(fact_1791_artanh__minus__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X ) ) ) ) ).

% artanh_minus_real
thf(fact_1792_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_1793_ln__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_1794_ln__inj__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( ln_ln @ real @ X )
            = ( ln_ln @ real @ Y ) )
          = ( X = Y ) ) ) ) ).

% ln_inj_iff
thf(fact_1795_ln__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_1796_ln__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_1797_ln__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_iff
thf(fact_1798_ln__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_1799_exp__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X ) ) ).

% exp_ln
thf(fact_1800_exp__ln__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% exp_ln_iff
thf(fact_1801_ln__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_1802_ln__ge__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_iff
thf(fact_1803_ln__less__self,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_less_self
thf(fact_1804_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N2: nat,L2: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% int_sgnE
thf(fact_1805_ln__bound,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_bound
thf(fact_1806_ln__gt__zero__imp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_1807_ln__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_1808_ln__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_gt_zero
thf(fact_1809_ln__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_ge_zero
thf(fact_1810_ln__ge__zero__imp__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_1811_ln__add__one__self__le__self,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self
thf(fact_1812_ln__mult,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( times_times @ real @ X @ Y ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_mult
thf(fact_1813_ln__eq__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( minus_minus @ real @ X @ ( one_one @ real ) ) )
       => ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_1814_ln__div,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X @ Y ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_div
thf(fact_1815_ln__ge__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ Y @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y ) @ X ) ) ) ).

% ln_ge_iff
thf(fact_1816_ln__inverse,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_inverse
thf(fact_1817_ln__x__over__x__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y ) @ Y ) @ ( divide_divide @ real @ ( ln_ln @ real @ X ) @ X ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_1818_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I4: int] :
          ( if @ int
          @ ( I4
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I4 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_1819_div__sgn__abs__cancel,axiom,
    ! [V2: int,K: int,L: int] :
      ( ( V2
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V2 ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V2 ) @ ( abs_abs @ int @ L ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_1820_ln__le__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( minus_minus @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_1821_ln__diff__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X @ Y ) @ Y ) ) ) ) ).

% ln_diff_le
thf(fact_1822_ln__add__one__self__le__self2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self2
thf(fact_1823_ln__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_realpow
thf(fact_1824_ln__one__minus__pos__upper__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) @ ( uminus_uminus @ real @ X ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_1825_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% ln_root
thf(fact_1826_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( sgn_sgn @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% sgn_zero_iff
thf(fact_1827_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X7: nat > real] :
        ! [J3: nat] :
        ? [M8: nat] :
        ! [M2: nat] :
          ( ( ord_less_eq @ nat @ M8 @ M2 )
         => ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M8 @ N3 )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X7 @ M2 ) @ ( X7 @ N3 ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_1828_root__powr__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ X )
          = ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_1829_log__base__root,axiom,
    ! [N: nat,B2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N @ B2 ) @ X )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X ) ) ) ) ) ).

% log_base_root
thf(fact_1830_log__root,axiom,
    ! [N: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_root
thf(fact_1831_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_le
thf(fact_1832_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X3: A,A3: A] :
              ( if @ A
              @ ( X3
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A3 @ ( ln_ln @ A @ X3 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_1833_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1834_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_1835_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_1836_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_1837_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_1838_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [W2: A,Z2: A] :
          ( ( ( powr @ A @ W2 @ Z2 )
            = ( zero_zero @ A ) )
          = ( W2
            = ( zero_zero @ A ) ) ) ) ).

% powr_eq_0_iff
thf(fact_1839_powr__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [Z2: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z2 )
          = ( zero_zero @ A ) ) ) ).

% powr_0
thf(fact_1840_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_1841_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_1842_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_1843_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_1844_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_1845_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_1846_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_1847_powr__gt__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ A2 ) )
      = ( ( X
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_1848_powr__nonneg__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_1849_powr__less__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_1850_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_1851_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1852_powr__eq__one__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_1853_powr__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( one_one @ real ) )
        = X ) ) ).

% powr_one
thf(fact_1854_powr__one__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ( powr @ real @ X @ ( one_one @ real ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% powr_one_gt_zero_iff
thf(fact_1855_powr__le__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_1856_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_1857_log__less__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) )
            = ( ord_less @ real @ X @ Y ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_1858_log__less__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_1859_one__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ A2 @ X ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_1860_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_1861_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_1862_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_1863_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_1864_log__le__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) )
            = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_1865_log__le__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_1866_one__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ A2 @ X ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_1867_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_1868_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_1869_powr__log__cancel,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X ) )
            = X ) ) ) ) ).

% powr_log_cancel
thf(fact_1870_log__powr__cancel,axiom,
    ! [A2: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y ) )
          = Y ) ) ) ).

% log_powr_cancel
thf(fact_1871_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_1872_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mod
thf(fact_1873_log__base__powr,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A2 @ B2 ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_1874_log__powr,axiom,
    ! [X: real,B2: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( log @ B2 @ X ) ) ) ) ).

% log_powr
thf(fact_1875_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N ) @ B2 ) ) ) ).

% power_mod
thf(fact_1876_powr__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less @ real @ Y @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_less_iff
thf(fact_1877_less__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less @ real @ ( log @ B2 @ X ) @ Y ) ) ) ) ).

% less_powr_iff
thf(fact_1878_log__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ B2 @ X ) @ Y )
          = ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_less_iff
thf(fact_1879_less__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ Y @ ( log @ B2 @ X ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% less_log_iff
thf(fact_1880_powr__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less_eq @ real @ Y @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_le_iff
thf(fact_1881_le__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y ) ) ) ) ).

% le_powr_iff
thf(fact_1882_log__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y )
          = ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_le_iff
thf(fact_1883_le__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ Y @ ( log @ B2 @ X ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% le_log_iff
thf(fact_1884_powr__non__neg,axiom,
    ! [A2: real,X: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_1885_powr__less__mono2__neg,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_1886_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_1887_powr__ge__pzero,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ Y ) ) ).

% powr_ge_pzero
thf(fact_1888_powr__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_1889_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_1890_powr__less__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_1891_powr__less__cancel,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_1892_powr__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_mono
thf(fact_1893_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_1894_ln__powr,axiom,
    ! [X: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_powr
thf(fact_1895_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_1896_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L ) @ L ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_1897_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% neg_mod_bound
thf(fact_1898_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_1899_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_1900_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q5: int] :
          ( M
          = ( times_times @ int @ D2 @ Q5 ) ) ) ).

% zmod_eq_0D
thf(fact_1901_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q6: int] :
            ( M
            = ( times_times @ int @ D2 @ Q6 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_1902_add__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ Y @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_1903_log__add__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ ( log @ B2 @ X ) @ Y )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_1904_minus__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ Y @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_1905_log__minus__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ ( log @ B2 @ X ) @ Y )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_1906_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_1907_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_1908_powr__mono2_H,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_1909_powr__less__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_1910_powr__inj,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X )
            = ( powr @ real @ A2 @ Y ) )
          = ( X = Y ) ) ) ) ).

% powr_inj
thf(fact_1911_gr__one__powr,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X @ Y ) ) ) ) ).

% gr_one_powr
thf(fact_1912_powr__le1,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_1913_powr__mono__both,axiom,
    ! [A2: real,B2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ Y )
           => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_1914_ge__one__powr__ge__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_1915_powr__divide,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( divide_divide @ real @ X @ Y ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_1916_powr__mult,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( times_times @ real @ X @ Y ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_1917_inverse__powr,axiom,
    ! [Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_1918_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_1919_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_1920_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_1921_zmod__trivial__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( modulo_modulo @ int @ I @ K )
        = I )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zmod_trivial_iff
thf(fact_1922_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_1923_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_1924_zdiv__mono__strict,axiom,
    ! [A5: int,B6: int,N: int] :
      ( ( ord_less @ int @ A5 @ B6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ( ( modulo_modulo @ int @ A5 @ N )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B6 @ N )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A5 @ N ) @ ( divide_divide @ int @ B6 @ N ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1925_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_1926_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_1927_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L ) ) @ ( abs_abs @ int @ L ) ) ) ).

% abs_mod_less
thf(fact_1928_div__mod__decomp__int,axiom,
    ! [A5: int,N: int] :
      ( A5
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A5 @ N ) @ N ) @ ( modulo_modulo @ int @ A5 @ N ) ) ) ).

% div_mod_decomp_int
thf(fact_1929_powr__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A] :
          ( ( powr @ A @ X @ ( uminus_uminus @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( powr @ A @ X @ A2 ) ) ) ) ).

% powr_minus
thf(fact_1930_floor__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X )
            & ( ord_less @ real @ X @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_1931_log__base__change,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X )
          = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_1932_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_1933_powr__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
        = ( power_power @ real @ X @ N ) ) ) ).

% powr_realpow
thf(fact_1934_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_1935_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_1936_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( plus_plus @ int @ K @ L ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_1937_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L ) @ L ) ) ) ) ).

% mod_pos_geq
thf(fact_1938_real__of__int__div__aux,axiom,
    ! [X: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_1939_ceiling__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X )
            & ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_1940_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1941_ln__powr__bound,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_1942_ln__powr__bound2,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X ) ) ) ) ).

% ln_powr_bound2
thf(fact_1943_powr__neg__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X ) ) ) ).

% powr_neg_one
thf(fact_1944_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( ( log @ A2 @ X )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_1945_powr__mult__base,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( times_times @ real @ X @ ( powr @ real @ X @ Y ) )
        = ( powr @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ Y ) ) ) ) ).

% powr_mult_base
thf(fact_1946_log__mult,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log @ A2 @ ( times_times @ real @ X @ Y ) )
              = ( plus_plus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) ) ) ) ) ) ) ).

% log_mult
thf(fact_1947_log__divide,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log @ A2 @ ( divide_divide @ real @ X @ Y ) )
              = ( minus_minus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) ) ) ) ) ) ) ).

% log_divide
thf(fact_1948_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_1949_log__base__pow,axiom,
    ! [A2: real,N: nat,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log_base_pow
thf(fact_1950_log__nat__power,axiom,
    ! [X: real,B2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ B2 @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X ) ) ) ) ).

% log_nat_power
thf(fact_1951_log__inverse,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X ) ) ) ) ) ) ).

% log_inverse
thf(fact_1952_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R2 ) ) ) ) ).

% int_mod_pos_eq
thf(fact_1953_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R2 ) ) ) ) ).

% int_mod_neg_eq
thf(fact_1954_split__zmod,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) ) ) ) ).

% split_zmod
thf(fact_1955_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_1956_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_1957_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_1958_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_1959_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_1960_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_less
thf(fact_1961_verit__le__mono__div__int,axiom,
    ! [A5: int,B6: int,N: int] :
      ( ( ord_less @ int @ A5 @ B6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A5 @ N )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B6 @ N )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B6 @ N ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1962_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1963_powr__int,axiom,
    ! [X: real,I: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I ) )
            = ( power_power @ real @ X @ ( nat2 @ I ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ I ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_1964_powr__real__of__int,axiom,
    ! [X: real,N: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( power_power @ real @ X @ ( nat2 @ N ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_1965_verit__le__mono__div,axiom,
    ! [A5: nat,B6: nat,N: nat] :
      ( ( ord_less @ nat @ A5 @ B6 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A5 @ N )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B6 @ N )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B6 @ N ) ) ) ) ).

% verit_le_mono_div
thf(fact_1966_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_1967_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_1968_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A,W2: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W2 ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z2 @ M ) @ ( power_power @ A @ W2 @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z2 @ W2 ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_1969_cpmi,axiom,
    ! [D5: int,P: int > $o,P4: int > $o,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X2: int] :
            ( ( ord_less @ int @ X2 @ Z4 )
           => ( ( P @ X2 )
              = ( P4 @ X2 ) ) )
       => ( ! [X2: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ B6 )
                     => ( X2
                       != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
             => ( ( P @ X2 )
               => ( P @ ( minus_minus @ int @ X2 @ D5 ) ) ) )
         => ( ! [X2: int,K2: int] :
                ( ( P4 @ X2 )
                = ( P4 @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X7: int] : ( P @ X7 ) )
              = ( ? [X3: int] :
                    ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P4 @ X3 ) )
                | ? [X3: int] :
                    ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y4: int] :
                        ( ( member @ int @ Y4 @ B6 )
                        & ( P @ ( plus_plus @ int @ Y4 @ X3 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_1970_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) ).

% numeral_eq_iff
thf(fact_1971_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_mult_numeral
thf(fact_1972_int__eq__iff__numeral,axiom,
    ! [M: nat,V2: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V2 ) )
      = ( M
        = ( numeral_numeral @ nat @ V2 ) ) ) ).

% int_eq_iff_numeral
thf(fact_1973_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_1974_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% numeral_le_iff
thf(fact_1975_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% numeral_less_iff
thf(fact_1976_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_1977_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V2: num,W2: num,Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Z2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W2 ) ) @ Z2 ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_1978_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% numeral_plus_numeral
thf(fact_1979_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V2: num,W2: num,Z2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W2 ) @ Z2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V2 @ W2 ) ) @ Z2 ) ) ) ).

% add_numeral_left
thf(fact_1980_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_1981_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( M = N ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1982_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_1983_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_1984_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% of_nat_numeral
thf(fact_1985_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,H: A,L3: A,H2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L @ H )
            = ( set_or1337092689740270186AtMost @ A @ L3 @ H2 ) )
          = ( ( ( L = L3 )
              & ( H = H2 ) )
            | ( ~ ( ord_less_eq @ A @ L @ H )
              & ~ ( ord_less_eq @ A @ L3 @ H2 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_1986_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_1987_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_numeral
thf(fact_1988_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_1989_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int,N: num] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( numeral_numeral @ A @ N ) )
          = ( Z2
            = ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_1990_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V2 ) )
          = ( numeral_numeral @ int @ V2 ) ) ) ).

% floor_numeral
thf(fact_1991_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V2 ) )
          = ( numeral_numeral @ int @ V2 ) ) ) ).

% ceiling_numeral
thf(fact_1992_mod__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = M ) ) ).

% mod_less
thf(fact_1993_nat__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( semiring_1_of_nat @ int @ N ) )
      = N ) ).

% nat_int
thf(fact_1994_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% numeral_powr_numeral_real
thf(fact_1995_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_1996_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V2: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_1997_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V2: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_1998_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_1999_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V2: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_2000_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V2: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_2001_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_2002_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_2003_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_2004_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_2005_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_2006_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_2007_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_neg_numeral
thf(fact_2008_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_2009_norm__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) ).

% norm_zero
thf(fact_2010_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_eq_zero
thf(fact_2011_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_2012_numeral__less__real__of__nat__iff,axiom,
    ! [W2: num,N: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W2 ) @ ( semiring_1_of_nat @ real @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W2 ) @ N ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_2013_real__of__nat__less__numeral__iff,axiom,
    ! [N: nat,W2: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( numeral_numeral @ real @ W2 ) )
      = ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ W2 ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_2014_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2015_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_2016_norm__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ real @ N ) ) ) ).

% norm_of_nat
thf(fact_2017_diff__nat__numeral,axiom,
    ! [V2: num,V3: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( numeral_numeral @ nat @ V3 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ V3 ) ) ) ) ).

% diff_nat_numeral
thf(fact_2018_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X: num,N: nat,Y: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
        = ( nat2 @ Y ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
        = Y ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_2019_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y: int,X: num,N: nat] :
      ( ( ( nat2 @ Y )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( Y
        = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_2020_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_2021_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_2022_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_2023_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W2 )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) ) )
            & ( ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_2024_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ( numeral_numeral @ A @ W2 )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_2025_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_2026_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_2027_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_2028_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
          = ( ( X
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_2029_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2030_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z2: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N ) @ Z2 ) ) ) ).

% of_int_numeral_le_iff
thf(fact_2031_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int,N: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ int @ Z2 @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_2032_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z2: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N ) @ Z2 ) ) ) ).

% of_int_numeral_less_iff
thf(fact_2033_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int,N: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ int @ Z2 @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_2034_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: num,N: nat,Y: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( semiring_1_of_nat @ A @ Y ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
            = Y ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2035_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y: nat,X: num,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2036_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V2 ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V2 ) @ X ) ) ) ).

% numeral_le_floor
thf(fact_2037_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ V2 ) ) ) ) ).

% floor_less_numeral
thf(fact_2038_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less_eq @ A @ X @ ( numeral_numeral @ A @ V2 ) ) ) ) ).

% ceiling_le_numeral
thf(fact_2039_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V2 ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V2 ) @ X ) ) ) ).

% numeral_less_ceiling
thf(fact_2040_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_2041_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% floor_neg_numeral
thf(fact_2042_nat__0__iff,axiom,
    ! [I: int] :
      ( ( ( nat2 @ I )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_2043_nat__le__0,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z2 )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_2044_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_add_numeral
thf(fact_2045_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% floor_diff_numeral
thf(fact_2046_zless__nat__conj,axiom,
    ! [W2: int,Z2: int] :
      ( ( ord_less @ nat @ ( nat2 @ W2 ) @ ( nat2 @ Z2 ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
        & ( ord_less @ int @ W2 @ Z2 ) ) ) ).

% zless_nat_conj
thf(fact_2047_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_2048_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
            = Y ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_2049_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y
            = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_2050_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs: list @ A,V2: num] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( numeral_numeral @ nat @ V2 ) )
      = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_2051_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_2052_powr__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( numeral_numeral @ real @ N ) )
        = ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% powr_numeral
thf(fact_2053_nat__zminus__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_zminus_int
thf(fact_2054_int__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
          = Z2 ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_2055_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% floor_numeral_power
thf(fact_2056_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% ceiling_numeral_power
thf(fact_2057_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_2058_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_2059_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_2060_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_2061_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_2062_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_2063_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_2064_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2065_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2066_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_2067_zero__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% zero_less_nat_eq
thf(fact_2068_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z2 ) )
            = ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_nat_nat
thf(fact_2069_nat__numeral__diff__1,axiom,
    ! [V2: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V2 ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_2070_numeral__power__less__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_2071_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_2072_numeral__power__le__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_2073_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_2074_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_2075_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_2076_nat__ceiling__le__eq,axiom,
    ! [X: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) @ A2 )
      = ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_2077_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_2078_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I: num,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2079_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) @ X ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2080_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) @ X ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2081_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I: num,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2082_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V2 ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_2083_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_2084_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_2085_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V2 ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_2086_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ X ) ) ) ).

% neg_numeral_le_floor
thf(fact_2087_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_2088_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_2089_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_2090_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_2091_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ X ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_2092_one__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ).

% one_less_nat_eq
thf(fact_2093_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_2094_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_2095_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( Y
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_2096_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N )
            = Y ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_2097_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_2098_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_2099_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_2100_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_2101_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_2102_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_2103_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_2104_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_2105_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_2106_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I4: num] : ( nat2 @ ( numeral_numeral @ int @ I4 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_2107_int__ops_I3_J,axiom,
    ! [N: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ int @ N ) ) ).

% int_ops(3)
thf(fact_2108_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ M ) ).

% mod_less_eq_dividend
thf(fact_2109_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) ).

% zero_neq_numeral
thf(fact_2110_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_2111_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_2112_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: num] : ( member @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_2113_nat__mod__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ( nat2 @ ( modulo_modulo @ int @ X @ Y ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_2114_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_2115_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_2116_nat__zero__as__int,axiom,
    ( ( zero_zero @ nat )
    = ( nat2 @ ( zero_zero @ int ) ) ) ).

% nat_zero_as_int
thf(fact_2117_nat__mono,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ X @ Y )
     => ( ord_less_eq @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ).

% nat_mono
thf(fact_2118_eq__nat__nat__iff,axiom,
    ! [Z2: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( ( nat2 @ Z2 )
            = ( nat2 @ Z6 ) )
          = ( Z2 = Z6 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_2119_all__nat,axiom,
    ( ( ^ [P2: nat > $o] :
        ! [X4: nat] : ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ! [X3: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
         => ( P3 @ ( nat2 @ X3 ) ) ) ) ) ).

% all_nat
thf(fact_2120_ex__nat,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X4: nat] : ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ? [X3: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
          & ( P3 @ ( nat2 @ X3 ) ) ) ) ) ).

% ex_nat
thf(fact_2121_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_2122_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
          = N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
         != N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ).

% mod_Suc
thf(fact_2123_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% norm_ge_zero
thf(fact_2124_mod__induct,axiom,
    ! [P: nat > $o,N: nat,P6: nat,M: nat] :
      ( ( P @ N )
     => ( ( ord_less @ nat @ N @ P6 )
       => ( ( ord_less @ nat @ M @ P6 )
         => ( ! [N2: nat] :
                ( ( ord_less @ nat @ N2 @ P6 )
               => ( ( P @ N2 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N2 ) @ P6 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_2125_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [M4: nat] : ( P @ M4 @ ( zero_zero @ nat ) )
     => ( ! [M4: nat,N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( P @ N2 @ ( modulo_modulo @ nat @ M4 @ N2 ) )
             => ( P @ M4 @ N2 ) ) )
       => ( P @ M @ N ) ) ) ).

% gcd_nat_induct
thf(fact_2126_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_less_divisor
thf(fact_2127_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N ) ) @ N ) ).

% mod_Suc_le_divisor
thf(fact_2128_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_le_numeral
thf(fact_2129_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_2130_real__nat__ceiling__ge,axiom,
    ! [X: real] : ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_2131_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_2132_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_less_numeral
thf(fact_2133_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_2134_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power
thf(fact_2135_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_2136_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q5: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q5 ) ) ) ).

% mod_eq_0D
thf(fact_2137_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_2138_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% mod_geq
thf(fact_2139_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M2: nat,N3: nat] : ( if @ nat @ ( ord_less @ nat @ M2 @ N3 ) @ M2 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M2 @ N3 ) @ N3 ) ) ) ) ).

% mod_if
thf(fact_2140_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_2141_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_le_numeral
thf(fact_2142_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_2143_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% le_mod_geq
thf(fact_2144_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_less_numeral
thf(fact_2145_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_2146_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_2147_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_2148_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_2149_norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_inverse
thf(fact_2150_zmod__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A2 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_2151_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_2152_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2153_nat__mono__iff,axiom,
    ! [Z2: int,W2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less @ nat @ ( nat2 @ W2 ) @ ( nat2 @ Z2 ) )
        = ( ord_less @ int @ W2 @ Z2 ) ) ) ).

% nat_mono_iff
thf(fact_2154_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W2: A,N: nat,Z2: A] :
          ( ( ( power_power @ A @ W2 @ N )
            = ( power_power @ A @ Z2 @ N ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( real_V7770717601297561774m_norm @ A @ W2 )
              = ( real_V7770717601297561774m_norm @ A @ Z2 ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2155_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,R2: real,Y: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R2 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ R2 @ S ) ) ) ) ) ).

% norm_mult_less
thf(fact_2156_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ R2 @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R2 ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_2157_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_mult_ineq
thf(fact_2158_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z2: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z2 ) ) ).

% zless_nat_eq_int_zless
thf(fact_2159_nat__le__iff,axiom,
    ! [X: int,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X ) @ N )
      = ( ord_less_eq @ int @ X @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_le_iff
thf(fact_2160_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_le_divisor
thf(fact_2161_int__eq__iff,axiom,
    ! [M: nat,Z2: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z2 )
      = ( ( M
          = ( nat2 @ Z2 ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% int_eq_iff
thf(fact_2162_nat__0__le,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
        = Z2 ) ) ).

% nat_0_le
thf(fact_2163_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,R2: real,Y: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R2 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ R2 @ S ) ) ) ) ) ).

% norm_add_less
thf(fact_2164_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E2 )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E2 ) ) ) ).

% norm_triangle_lt
thf(fact_2165_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2166_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E2 ) ) ) ).

% norm_triangle_le
thf(fact_2167_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2168_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R2: real,B2: A,S: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R2 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R2 @ S ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2169_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A,N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power_ineq
thf(fact_2170_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E1: real,Z2: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ Z2 ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z2 ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2171_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_2172_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_2173_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E1: real,Z2: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ Z2 ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z2 ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_2174_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E2 ) ) ) ).

% norm_triangle_le_diff
thf(fact_2175_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_2176_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_2177_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_2178_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_2179_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_2180_bset_I1_J,axiom,
    ! [D5: int,B6: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X2: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B6 )
                 => ( X2
                   != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
         => ( ( P @ X2 )
           => ( P @ ( minus_minus @ int @ X2 @ D5 ) ) ) )
     => ( ! [X2: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B6 )
                   => ( X2
                     != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
           => ( ( Q @ X2 )
             => ( Q @ ( minus_minus @ int @ X2 @ D5 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B6 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
             => ( ( P @ ( minus_minus @ int @ X5 @ D5 ) )
                & ( Q @ ( minus_minus @ int @ X5 @ D5 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_2181_bset_I2_J,axiom,
    ! [D5: int,B6: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X2: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B6 )
                 => ( X2
                   != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
         => ( ( P @ X2 )
           => ( P @ ( minus_minus @ int @ X2 @ D5 ) ) ) )
     => ( ! [X2: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B6 )
                   => ( X2
                     != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
           => ( ( Q @ X2 )
             => ( Q @ ( minus_minus @ int @ X2 @ D5 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B6 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
             => ( ( P @ ( minus_minus @ int @ X5 @ D5 ) )
                | ( Q @ ( minus_minus @ int @ X5 @ D5 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_2182_aset_I1_J,axiom,
    ! [D5: int,A5: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X2: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A5 )
                 => ( X2
                   != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
         => ( ( P @ X2 )
           => ( P @ ( plus_plus @ int @ X2 @ D5 ) ) ) )
     => ( ! [X2: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A5 )
                   => ( X2
                     != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
           => ( ( Q @ X2 )
             => ( Q @ ( plus_plus @ int @ X2 @ D5 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
             => ( ( P @ ( plus_plus @ int @ X5 @ D5 ) )
                & ( Q @ ( plus_plus @ int @ X5 @ D5 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_2183_aset_I2_J,axiom,
    ! [D5: int,A5: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X2: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A5 )
                 => ( X2
                   != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
         => ( ( P @ X2 )
           => ( P @ ( plus_plus @ int @ X2 @ D5 ) ) ) )
     => ( ! [X2: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A5 )
                   => ( X2
                     != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
           => ( ( Q @ X2 )
             => ( Q @ ( plus_plus @ int @ X2 @ D5 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
             => ( ( P @ ( plus_plus @ int @ X5 @ D5 ) )
                | ( Q @ ( plus_plus @ int @ X5 @ D5 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_2184_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2185_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_2186_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_2187_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_2188_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_2189_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_2190_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_2191_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_2192_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_2193_div__less__mono,axiom,
    ! [A5: nat,B6: nat,N: nat] :
      ( ( ord_less @ nat @ A5 @ B6 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( modulo_modulo @ nat @ A5 @ N )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B6 @ N )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A5 @ N ) @ ( divide_divide @ nat @ B6 @ N ) ) ) ) ) ) ).

% div_less_mono
thf(fact_2194_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_2195_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_2196_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_2197_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_2198_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_2199_int__minus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ N @ M ) )
      = ( semiring_1_of_nat @ int @ ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ) ) ).

% int_minus
thf(fact_2200_nat__mod__eq__lemma,axiom,
    ! [X: nat,N: nat,Y: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N )
        = ( modulo_modulo @ nat @ Y @ N ) )
     => ( ( ord_less_eq @ nat @ Y @ X )
       => ? [Q5: nat] :
            ( X
            = ( plus_plus @ nat @ Y @ ( times_times @ nat @ N @ Q5 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_2201_mod__eq__nat2E,axiom,
    ! [M: nat,Q4: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q4 )
        = ( modulo_modulo @ nat @ N @ Q4 ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ~ ! [S3: nat] :
              ( N
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q4 @ S3 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_2202_mod__eq__nat1E,axiom,
    ! [M: nat,Q4: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q4 )
        = ( modulo_modulo @ nat @ N @ Q4 ) )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ~ ! [S3: nat] :
              ( M
             != ( plus_plus @ nat @ N @ ( times_times @ nat @ Q4 @ S3 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_2203_nat__abs__mult__distrib,axiom,
    ! [W2: int,Z2: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W2 @ Z2 ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W2 ) ) @ ( nat2 @ ( abs_abs @ int @ Z2 ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_2204_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ) ).

% nonzero_norm_inverse
thf(fact_2205_div__mod__decomp,axiom,
    ! [A5: nat,N: nat] :
      ( A5
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A5 @ N ) @ N ) @ ( modulo_modulo @ nat @ A5 @ N ) ) ) ).

% div_mod_decomp
thf(fact_2206_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_exp
thf(fact_2207_powr__neg__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_2208_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R2 )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R2 ) ) ) @ R2 ) ) ) ).

% of_nat_floor
thf(fact_2209_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W2: A,N: nat] :
          ( ( ( power_power @ A @ W2 @ N )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W2 )
              = ( one_one @ real ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2210_nat__less__eq__zless,axiom,
    ! [W2: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W2 )
     => ( ( ord_less @ nat @ ( nat2 @ W2 ) @ ( nat2 @ Z2 ) )
        = ( ord_less @ int @ W2 @ Z2 ) ) ) ).

% nat_less_eq_zless
thf(fact_2211_nat__le__eq__zle,axiom,
    ! [W2: int,Z2: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W2 )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W2 ) @ ( nat2 @ Z2 ) )
        = ( ord_less_eq @ int @ W2 @ Z2 ) ) ) ).

% nat_le_eq_zle
thf(fact_2212_nat__eq__iff,axiom,
    ! [W2: int,M: nat] :
      ( ( ( nat2 @ W2 )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W2 )
         => ( W2
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W2 )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_2213_nat__eq__iff2,axiom,
    ! [M: nat,W2: int] :
      ( ( M
        = ( nat2 @ W2 ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W2 )
         => ( W2
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W2 )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_2214_split__nat,axiom,
    ! [P: nat > $o,I: int] :
      ( ( P @ ( nat2 @ I ) )
      = ( ! [N3: nat] :
            ( ( I
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ( P @ N3 ) )
        & ( ( ord_less @ int @ I @ ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_2215_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_2216_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% le_nat_iff
thf(fact_2217_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2218_nat__add__distrib,axiom,
    ! [Z2: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( nat2 @ ( plus_plus @ int @ Z2 @ Z6 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_2219_nat__mult__distrib,axiom,
    ! [Z2: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( nat2 @ ( times_times @ int @ Z2 @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) ) ) ) ).

% nat_mult_distrib
thf(fact_2220_Suc__as__int,axiom,
    ( suc
    = ( ^ [A3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_2221_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( zero_zero @ real ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_2222_nat__diff__distrib_H,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ( nat2 @ ( minus_minus @ int @ X @ Y ) )
          = ( minus_minus @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_2223_nat__diff__distrib,axiom,
    ! [Z6: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
     => ( ( ord_less_eq @ int @ Z6 @ Z2 )
       => ( ( nat2 @ ( minus_minus @ int @ Z2 @ Z6 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_2224_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2225_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_2226_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_2227_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W2 ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_2228_split__mod,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I4 ) @ J3 ) )
               => ( P @ J3 ) ) ) ) ) ) ).

% split_mod
thf(fact_2229_nat__div__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib
thf(fact_2230_nat__div__distrib_H,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib'
thf(fact_2231_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_2232_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_2233_nat__floor__neg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_2234_nat__power__eq,axiom,
    ! [Z2: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( nat2 @ ( power_power @ int @ Z2 @ N ) )
        = ( power_power @ nat @ ( nat2 @ Z2 ) @ N ) ) ) ).

% nat_power_eq
thf(fact_2235_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_2236_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_2237_floor__eq3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq3
thf(fact_2238_le__nat__floor,axiom,
    ! [X: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X ) @ A2 )
     => ( ord_less_eq @ nat @ X @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_2239_real__of__nat__div__aux,axiom,
    ! [X: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2240_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( suc @ ( nat2 @ Z2 ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_2241_nat__less__iff,axiom,
    ! [W2: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W2 )
     => ( ( ord_less @ nat @ ( nat2 @ W2 ) @ M )
        = ( ord_less @ int @ W2 @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_2242_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int,K2: int] :
            ( ( P @ X2 )
            = ( P @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ( ? [X7: int] : ( P @ X7 ) )
          = ( ? [X3: int] :
                ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X3 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_2243_aset_I7_J,axiom,
    ! [D5: int,A5: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A5 )
                 => ( X5
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X5 )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X5 @ D5 ) ) ) ) ) ).

% aset(7)
thf(fact_2244_aset_I5_J,axiom,
    ! [D5: int,T2: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A5 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X5 @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_2245_aset_I4_J,axiom,
    ! [D5: int,T2: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A5 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X5 != T2 )
             => ( ( plus_plus @ int @ X5 @ D5 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_2246_aset_I3_J,axiom,
    ! [D5: int,T2: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A5 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X5 = T2 )
             => ( ( plus_plus @ int @ X5 @ D5 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_2247_bset_I7_J,axiom,
    ! [D5: int,T2: int,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B6 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B6 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X5 )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X5 @ D5 ) ) ) ) ) ) ).

% bset(7)
thf(fact_2248_bset_I5_J,axiom,
    ! [D5: int,B6: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B6 )
                 => ( X5
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X5 @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_2249_bset_I4_J,axiom,
    ! [D5: int,T2: int,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B6 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B6 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X5 != T2 )
             => ( ( minus_minus @ int @ X5 @ D5 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_2250_bset_I3_J,axiom,
    ! [D5: int,T2: int,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B6 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B6 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X5 = T2 )
             => ( ( minus_minus @ int @ X5 @ D5 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_2251_nat__mult__distrib__neg,axiom,
    ! [Z2: int,Z6: int] :
      ( ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z2 @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z2 ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z6 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_2252_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
                & ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N3 ) ) @ K5 ) ) )
          = ( ? [N7: nat] :
              ! [N3: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N7 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2253_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
                & ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N3 ) ) @ K5 ) ) )
          = ( ? [N7: nat] :
              ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N7 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2254_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W2 ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_2255_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_2256_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_2257_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_2258_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_2259_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_2260_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R2: real,X: A] :
          ( ( ord_less_eq @ real @ R2 @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X ) ) @ ( inverse_inverse @ real @ R2 ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_2261_floor__eq4,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq4
thf(fact_2262_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X7: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M2 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X7 @ M2 ) @ ( X7 @ N3 ) ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_2263_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N2 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI
thf(fact_2264_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M10: nat] :
              ! [M3: nat] :
                ( ( ord_less_eq @ nat @ M10 @ M3 )
               => ! [N6: nat] :
                    ( ( ord_less_eq @ nat @ M10 @ N6 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M3 ) @ ( X8 @ N6 ) ) ) @ E2 ) ) ) ) ) ) ).

% CauchyD
thf(fact_2265_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate1
thf(fact_2266_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K4: int] : ( if @ A @ ( ord_less @ int @ K4 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K4 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K4 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_2267_aset_I8_J,axiom,
    ! [D5: int,A5: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A5 )
                 => ( X5
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X5 )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X5 @ D5 ) ) ) ) ) ).

% aset(8)
thf(fact_2268_aset_I6_J,axiom,
    ! [D5: int,T2: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A5 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X5 @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_2269_bset_I8_J,axiom,
    ! [D5: int,T2: int,B6: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B6 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B6 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X5 )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X5 @ D5 ) ) ) ) ) ) ).

% bset(8)
thf(fact_2270_bset_I6_J,axiom,
    ! [D5: int,B6: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B6 )
                 => ( X5
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X5 @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_2271_cppi,axiom,
    ! [D5: int,P: int > $o,P4: int > $o,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X2: int] :
            ( ( ord_less @ int @ Z4 @ X2 )
           => ( ( P @ X2 )
              = ( P4 @ X2 ) ) )
       => ( ! [X2: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ A5 )
                     => ( X2
                       != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
             => ( ( P @ X2 )
               => ( P @ ( plus_plus @ int @ X2 @ D5 ) ) ) )
         => ( ! [X2: int,K2: int] :
                ( ( P4 @ X2 )
                = ( P4 @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X7: int] : ( P @ X7 ) )
              = ( ? [X3: int] :
                    ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P4 @ X3 ) )
                | ? [X3: int] :
                    ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y4: int] :
                        ( ( member @ int @ Y4 @ A5 )
                        & ( P @ ( minus_minus @ int @ Y4 @ X3 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_2272_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(1)
thf(fact_2273_enat__ord__number_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(2)
thf(fact_2274_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H: A,Z2: A,K6: real,N: nat] :
          ( ( H
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K6 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z2 @ H ) ) @ K6 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ N ) @ ( power_power @ A @ Z2 @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K6 @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2275_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K7: real] :
            ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K7 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_2276_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F3: A > B] :
            ? [K5: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_2277_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A2 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_2278_complex__mod__minus__le__complex__mod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_2279_verit__eq__simplify_I8_J,axiom,
    ! [X23: num,Y23: num] :
      ( ( ( bit0 @ X23 )
        = ( bit0 @ Y23 ) )
      = ( X23 = Y23 ) ) ).

% verit_eq_simplify(8)
thf(fact_2280_i0__less,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( ( N
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_2281_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_2282_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(71)
thf(fact_2283_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(78)
thf(fact_2284_semiring__norm_I68_J,axiom,
    ! [N: num] : ( ord_less_eq @ num @ one2 @ N ) ).

% semiring_norm(68)
thf(fact_2285_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_2286_set__n__deg__not__0,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,M: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N ) ) ) ).

% set_n_deg_not_0
thf(fact_2287_bit__concat__def,axiom,
    ( vEBT_VEBT_bit_concat
    = ( ^ [H3: nat,L4: nat,D6: nat] : ( plus_plus @ nat @ ( times_times @ nat @ H3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ D6 ) ) @ L4 ) ) ) ).

% bit_concat_def
thf(fact_2288_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_2289_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_2290_num__double,axiom,
    ! [N: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N )
      = ( bit0 @ N ) ) ).

% num_double
thf(fact_2291_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_2292_semiring__norm_I76_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit0 @ N ) ) ).

% semiring_norm(76)
thf(fact_2293_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_2294_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_2295_Suc__numeral,axiom,
    ! [N: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% Suc_numeral
thf(fact_2296_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_2297_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_2298_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_2299_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_2300_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_2301_add__2__eq__Suc,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc
thf(fact_2302_add__2__eq__Suc_H,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc'
thf(fact_2303_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_2304_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_2305_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_2306_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_2307_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_2308_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_2309_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_2310_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_2311_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_2312_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_2313_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X = Y ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_2314_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_2315_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_2316_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_2317_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_2318_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_2319_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_2320_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_2321_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_2322_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_2323_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_2324_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_2325_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_2326_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_2327_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_2328_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_2329_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% one_less_floor
thf(fact_2330_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_2331_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_2332_square__powr__half,axiom,
    ! [X: real] :
      ( ( powr @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% square_powr_half
thf(fact_2333_add__One__commute,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) ).

% add_One_commute
thf(fact_2334_not__iless0,axiom,
    ! [N: extended_enat] :
      ~ ( ord_less @ extended_enat @ N @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_2335_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N: extended_enat] :
      ( ! [N2: extended_enat] :
          ( ! [M3: extended_enat] :
              ( ( ord_less @ extended_enat @ M3 @ N2 )
             => ( P @ M3 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) ).

% enat_less_induct
thf(fact_2336_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = ( N
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_2337_le__num__One__iff,axiom,
    ! [X: num] :
      ( ( ord_less_eq @ num @ X @ one2 )
      = ( X = one2 ) ) ).

% le_num_One_iff
thf(fact_2338_i0__lb,axiom,
    ! [N: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ).

% i0_lb
thf(fact_2339_verit__eq__simplify_I10_J,axiom,
    ! [X23: num] :
      ( one2
     != ( bit0 @ X23 ) ) ).

% verit_eq_simplify(10)
thf(fact_2340_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ) ) ).

% enat_0_less_mult_iff
thf(fact_2341_add__diff__assoc__enat,axiom,
    ! [Z2: extended_enat,Y: extended_enat,X: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z2 @ Y )
     => ( ( plus_plus @ extended_enat @ X @ ( minus_minus @ extended_enat @ Y @ Z2 ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y ) @ Z2 ) ) ) ).

% add_diff_assoc_enat
thf(fact_2342_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_2343_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_2344_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_2345_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_2346_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_2347_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X = Y )
            | ( X
              = ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% power2_eq_iff
thf(fact_2348_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_2349_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_2350_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_2351_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_2352_less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% less_exp
thf(fact_2353_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_2354_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_eq_le
thf(fact_2355_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_imp_le
thf(fact_2356_four__x__squared,axiom,
    ! [X: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_2357_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_2358_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_2359_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_2360_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( X = Y ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_2361_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% power2_le_imp_le
thf(fact_2362_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_2363_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_2364_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2_right
thf(fact_2365_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2
thf(fact_2366_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X ) ) ).

% field_sum_of_halves
thf(fact_2367_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_2368_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( abs_abs @ A @ Y ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_2369_less__2__cases,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_2370_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_2371_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2372_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X: A] :
          ( ! [X2: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
             => ( P @ X2 @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X ) @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2373_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_2374_nat__induct2,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N2: nat] :
              ( ( P @ N2 )
             => ( P @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct2
thf(fact_2375_two__realpow__ge__one,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) ) ).

% two_realpow_ge_one
thf(fact_2376_square__fact__le__2__fact,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% square_fact_le_2_fact
thf(fact_2377_realpow__square__minus__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_2378_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) ) ) ) ).

% diff_le_diff_pow
thf(fact_2379_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2380_not__exp__less__eq__0__int,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_2381_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( semiring_1_of_nat @ real @ N )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_2382_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% power2_less_imp_less
thf(fact_2383_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_2384_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_2385_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_2386_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_2387_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_2388_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_2389_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less @ A @ X @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_2390_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_sum
thf(fact_2391_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_2392_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ Y ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_2393_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% of_nat_less_two_power
thf(fact_2394_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_2395_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_2396_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% zero_le_even_power'
thf(fact_2397_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_2398_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2399_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2400_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ).

% div_exp_eq
thf(fact_2401_all__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M2: nat] :
            ( ( ord_less_eq @ nat @ M2 @ N )
           => ( P @ M2 ) ) )
      = ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X3 ) ) ) ) ).

% all_nat_less
thf(fact_2402_ex__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M2: nat] :
            ( ( ord_less_eq @ nat @ M2 @ N )
            & ( P @ M2 ) ) )
      = ( ? [X3: nat] :
            ( ( member @ nat @ X3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X3 ) ) ) ) ).

% ex_nat_less
thf(fact_2403_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_2404_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_2405_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) )
          = ( power_power @ A @ ( exp @ A @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_2406_nat__bit__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N2: nat] :
            ( ( P @ N2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
       => ( ! [N2: nat] :
              ( ( P @ N2 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_bit_induct
thf(fact_2407_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2408_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_2409_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_2410_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_2411_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_Bit0
thf(fact_2412_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_2413_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_2414_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_2415_exp__plus__inverse__exp,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_2416_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_2417_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_2418_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_2419_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_2420_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_2421_Suc__nat__number__of__add,axiom,
    ! [V2: num,N: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V2 @ one2 ) ) @ N ) ) ).

% Suc_nat_number_of_add
thf(fact_2422_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_2423_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_2424_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_2425_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_diff
thf(fact_2426_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_2427_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_2428_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_2429_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_2430_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_2431_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N2: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_2432_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N2: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_2433_plus__inverse__ge__2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_2434_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_2435_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K2: int] :
              ( ( P @ K2 )
             => ( ( K2
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K2: int] :
                ( ( P @ K2 )
               => ( ( K2
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_2436_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_2437_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_2438_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_2439_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_2440_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q4: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q4 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q4 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_2441_num_Osize_I5_J,axiom,
    ! [X23: num] :
      ( ( size_size @ num @ ( bit0 @ X23 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X23 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_2442_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_less
thf(fact_2443_exp__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_2444_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_2445_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_2446_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_2447_real__le__x__sinh,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_2448_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_2449_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_2450_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_2451_real__le__abs__sinh,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_2452_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_2453_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X: A,Y: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X @ Y ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_2454_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X @ M ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_2455_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_2456_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_le
thf(fact_2457_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z2 ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z2 ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_2458_real__exp__bound__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_2459_exp__lower__Taylor__quadratic,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( divide_divide @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_2460_ln__one__plus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2461_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_2462_floor__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_2463_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_2464_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_2465_arctan__double,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_2466_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_2467_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_2468_ln__one__minus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2469_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_2470_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_2471_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_2472_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_2473_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2474_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_2475_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_2476_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_2477_low__inv,axiom,
    ! [X: nat,N: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X ) @ N )
        = X ) ) ).

% low_inv
thf(fact_2478_high__inv,axiom,
    ! [X: nat,N: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X ) @ N )
        = Y ) ) ).

% high_inv
thf(fact_2479_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_2480_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_2481_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X3: nat,N3: nat] : ( modulo_modulo @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% low_def
thf(fact_2482_bit__split__inv,axiom,
    ! [X: nat,D2: nat] :
      ( ( vEBT_VEBT_bit_concat @ ( vEBT_VEBT_high @ X @ D2 ) @ ( vEBT_VEBT_low @ X @ D2 ) @ D2 )
      = X ) ).

% bit_split_inv
thf(fact_2483_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X3: nat,N3: nat] : ( divide_divide @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% high_def
thf(fact_2484_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_2485_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_2486_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_2487_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_2488_idiff__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_2489_idiff__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = N ) ).

% idiff_0_right
thf(fact_2490_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ X ) ) ) ) ).

% both_member_options_ding
thf(fact_2491_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_2492_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_2493_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_2494_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M2: nat,N3: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M2 @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_2495_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_2496_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) ) ).

% set_bit_greater_eq
thf(fact_2497_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_2498_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_2499_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N3: nat,TreeList2: list @ vEBT_VEBT,X3: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X3 @ N3 ) ) @ ( vEBT_VEBT_low @ X3 @ N3 ) ) ) ) ).

% in_children_def
thf(fact_2500_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A3: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_2501_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y ) ) ) ) ).

% round_unique
thf(fact_2502_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_2503_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X3: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X3 ) ) @ ( archimedean_ceiling @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ X3 ) ) ) ) ) ).

% round_altdef
thf(fact_2504_tanh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( tanh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2505_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_2506_tanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tanh_0
thf(fact_2507_tanh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( ( tanh @ real @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% tanh_real_zero_iff
thf(fact_2508_tanh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% tanh_real_less_iff
thf(fact_2509_tanh__real__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% tanh_real_le_iff
thf(fact_2510_round__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int] :
          ( ( archimedean_round @ A @ ( ring_1_of_int @ A @ N ) )
          = N ) ) ).

% round_of_int
thf(fact_2511_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_2512_round__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% round_0
thf(fact_2513_tanh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_2514_tanh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_pos_iff
thf(fact_2515_tanh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_2516_tanh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_nonneg_iff
thf(fact_2517_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ int @ N ) ) ) ).

% round_numeral
thf(fact_2518_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_2519_round__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archimedean_round @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% round_of_nat
thf(fact_2520_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_2521_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_2522_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ).

% round_neg_numeral
thf(fact_2523_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_2524_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_2525_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X3: A] : ( plus_plus @ A @ X3 @ X3 ) ) ) ) ).

% dbl_def
thf(fact_2526_tanh__real__lt__1,axiom,
    ! [X: real] : ( ord_less @ real @ ( tanh @ real @ X ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_2527_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_round @ A @ Y ) ) ) ) ).

% round_mono
thf(fact_2528_floor__le__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_round @ A @ X ) ) ) ).

% floor_le_round
thf(fact_2529_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% ceiling_ge_round
thf(fact_2530_tanh__real__gt__neg1,axiom,
    ! [X: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X ) ) ).

% tanh_real_gt_neg1
thf(fact_2531_signed__take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% signed_take_bit_int_less_exp
thf(fact_2532_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z2 @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z2 ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z2 @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_2533_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_2534_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_2535_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_2536_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_2537_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_2538_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_2539_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_2540_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_2541_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_2542_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X3: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_2543_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2544_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_2545_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_2546_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_2547_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N ) ) ) ).

% round_unique'
thf(fact_2548_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X3: A] : ( ln_ln @ A @ ( plus_plus @ A @ X3 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_2549_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X2: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_2550_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X3: A] : ( ln_ln @ A @ ( plus_plus @ A @ X3 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_2551_log__base__10__eq1,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq1
thf(fact_2552_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_2553_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X2: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_2554_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( ( bit1 @ X32 )
        = ( bit1 @ Y32 ) )
      = ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
thf(fact_2555_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(80)
thf(fact_2556_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(73)
thf(fact_2557_of__real__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) ).

% of_real_0
thf(fact_2558_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ real ) ) ) ) ).

% of_real_eq_0_iff
thf(fact_2559_binomial__1,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = N ) ).

% binomial_1
thf(fact_2560_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_2561_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N @ K ) ) ).

% binomial_eq_0_iff
thf(fact_2562_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,N: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X @ N ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X ) @ N ) ) ) ).

% of_real_power
thf(fact_2563_binomial__n__0,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_2564_of__real__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [N: nat] :
          ( ( real_Vector_of_real @ A @ ( semiring_1_of_nat @ real @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_real_of_nat_eq
thf(fact_2565_of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real] :
          ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X ) )
          = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) ).

% of_real_inverse
thf(fact_2566_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(81)
thf(fact_2567_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(72)
thf(fact_2568_semiring__norm_I77_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit1 @ N ) ) ).

% semiring_norm(77)
thf(fact_2569_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2570_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2571_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) )
      = ( ord_less_eq @ nat @ K @ N ) ) ).

% zero_less_binomial_iff
thf(fact_2572_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(79)
thf(fact_2573_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(74)
thf(fact_2574_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2575_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2576_verit__eq__simplify_I14_J,axiom,
    ! [X23: num,X32: num] :
      ( ( bit0 @ X23 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2577_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2578_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ N @ K )
     => ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_2579_binomial__symmetric,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( binomial @ N @ ( minus_minus @ nat @ N @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_2580_binomial__le__pow,axiom,
    ! [R2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R2 @ N )
     => ( ord_less_eq @ nat @ ( binomial @ N @ R2 ) @ ( power_power @ nat @ N @ R2 ) ) ) ).

% binomial_le_pow
thf(fact_2581_binomial__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat,K: nat] :
          ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
          = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K ) ) ) ).

% binomial_gbinomial
thf(fact_2582_num_Oexhaust,axiom,
    ! [Y: num] :
      ( ( Y != one2 )
     => ( ! [X24: num] :
            ( Y
           != ( bit0 @ X24 ) )
       => ~ ! [X33: num] :
              ( Y
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2583_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) ) ) ).

% zero_less_binomial
thf(fact_2584_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y: real,X: real] :
          ( ( Y
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_2585_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( times_times @ nat @ ( binomial @ N @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N @ K ) @ ( binomial @ ( minus_minus @ nat @ N @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_2586_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real] :
          ( ( X
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X ) )
            = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) ) ).

% nonzero_of_real_inverse
thf(fact_2587_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2588_eval__nat__numeral_I3_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2589_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2590_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_2591_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_2592_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( binomial @ N @ K ) )
        = ( semiring_char_0_fact @ nat @ N ) ) ) ).

% binomial_fact_lemma
thf(fact_2593_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q4: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q4 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2594_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_2595_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2596_Suc3__eq__add__3,axiom,
    ! [N: nat] :
      ( ( suc @ ( suc @ ( suc @ N ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ).

% Suc3_eq_add_3
thf(fact_2597_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_2598_binomial__mono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K8 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K8 ) @ N )
       => ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K8 ) ) ) ) ).

% binomial_mono
thf(fact_2599_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% binomial_maximum'
thf(fact_2600_binomial__antimono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K8 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K8 @ N )
         => ( ord_less_eq @ nat @ ( binomial @ N @ K8 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_2601_binomial__maximum,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_2602_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% binomial_le_pow2
thf(fact_2603_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_2604_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N @ K ) )
        = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_2605_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_2606_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A2: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A2 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ).

% norm_of_real_diff
thf(fact_2607_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_2608_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q4: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q4 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q4 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q4 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2609_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q4: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q4 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q4 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q4 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2610_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_2611_binomial__strict__mono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K8 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K8 ) @ N )
       => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K8 ) ) ) ) ).

% binomial_strict_mono
thf(fact_2612_binomial__strict__antimono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K8 )
     => ( ( ord_less_eq @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K8 @ N )
         => ( ord_less @ nat @ ( binomial @ N @ K8 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_2613_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_2614_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( binomial @ N @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_2615_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2616_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2617_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2618_log__base__10__eq2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq2
thf(fact_2619_binomial__code,axiom,
    ( binomial
    = ( ^ [N3: nat,K4: nat] : ( if @ nat @ ( ord_less @ nat @ N3 @ K4 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K4 ) ) @ ( binomial @ N3 @ ( minus_minus @ nat @ N3 @ K4 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N3 @ K4 ) @ ( one_one @ nat ) ) @ N3 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K4 ) ) ) ) ) ) ).

% binomial_code
thf(fact_2620_arctan__inverse,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X ) ) ) ) ).

% arctan_inverse
thf(fact_2621_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_2622_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_2623_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_2624_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_2625_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_2626_int__dvd__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( dvd_dvd @ nat @ M @ N ) ) ).

% int_dvd_int_iff
thf(fact_2627_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_2628_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_2629_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_2630_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_2631_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_2632_zdvd1__eq,axiom,
    ! [X: int] :
      ( ( dvd_dvd @ int @ X @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_2633_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_2634_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_2635_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_2636_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_2637_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_2638_dvd__nat__abs__iff,axiom,
    ! [N: nat,K: int] :
      ( ( dvd_dvd @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% dvd_nat_abs_iff
thf(fact_2639_nat__abs__dvd__iff,axiom,
    ! [K: int,N: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( dvd_dvd @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_abs_dvd_iff
thf(fact_2640_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R2: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R2 ) ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R2
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_2641_dvd__sgn__mult__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ ( sgn_sgn @ int @ R2 ) @ K ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R2
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_2642_mult__sgn__dvd__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L @ ( sgn_sgn @ int @ R2 ) ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R2
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_2643_sgn__mult__dvd__iff,axiom,
    ! [R2: int,L: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R2 ) @ L ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R2
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_2644_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_2645_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_2646_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_minus_odd
thf(fact_2647_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W2: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W2 ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_2648_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_2649_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W2: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_2650_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_2651_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_2652_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_2653_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_of_nat
thf(fact_2654_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% odd_Suc_minus_one
thf(fact_2655_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ).

% even_diff_nat
thf(fact_2656_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W2: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) )
          = ( ( ( numeral_numeral @ nat @ W2 )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_2657_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% even_power
thf(fact_2658_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W2 ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_2659_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_2660_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% of_nat_dvd_iff
thf(fact_2661_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_2662_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( A3
                = ( zero_zero @ A ) )
             => ( B3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_2663_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) ) ) ) ).

% dvd_power_same
thf(fact_2664_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_uniqueI
thf(fact_2665_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) )
        & ( A2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.not_eq_extremum
thf(fact_2666_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_unique
thf(fact_2667_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
        & ( ( zero_zero @ nat )
         != A2 ) ) ).

% gcd_nat.extremum_strict
thf(fact_2668_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% gcd_nat.extremum
thf(fact_2669_pi__neq__zero,axiom,
    pi
 != ( zero_zero @ real ) ).

% pi_neq_zero
thf(fact_2670_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% dvd_diff_nat
thf(fact_2671_uminus__dvd__conv_I1_J,axiom,
    ( ( dvd_dvd @ int )
    = ( ^ [D6: int] : ( dvd_dvd @ int @ ( uminus_uminus @ int @ D6 ) ) ) ) ).

% uminus_dvd_conv(1)
thf(fact_2672_uminus__dvd__conv_I2_J,axiom,
    ( ( dvd_dvd @ int )
    = ( ^ [D6: int,T4: int] : ( dvd_dvd @ int @ D6 @ ( uminus_uminus @ int @ T4 ) ) ) ) ).

% uminus_dvd_conv(2)
thf(fact_2673_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ K @ ( minus_minus @ int @ M @ N ) )
     => ( ( dvd_dvd @ int @ K @ N )
       => ( dvd_dvd @ int @ K @ M ) ) ) ).

% zdvd_zdiffD
thf(fact_2674_zdvd__antisym__abs,axiom,
    ! [A2: int,B2: int] :
      ( ( dvd_dvd @ int @ A2 @ B2 )
     => ( ( dvd_dvd @ int @ B2 @ A2 )
       => ( ( abs_abs @ int @ A2 )
          = ( abs_abs @ int @ B2 ) ) ) ) ).

% zdvd_antisym_abs
thf(fact_2675_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_2676_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z3: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ X5 @ Z3 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) ) ) ) ) ).

% minf(10)
thf(fact_2677_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z3: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ X5 @ Z3 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) ) ) ) ).

% minf(9)
thf(fact_2678_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z3: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ Z3 @ X5 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) ) ) ) ) ).

% pinf(10)
thf(fact_2679_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z3: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ Z3 @ X5 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) ) ) ) ).

% pinf(9)
thf(fact_2680_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_2681_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% div_power
thf(fact_2682_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_2683_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( modulo_modulo @ A @ B3 @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_2684_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_2685_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N: nat,M: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_2686_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_2687_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% le_imp_power_dvd
thf(fact_2688_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_2689_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_2690_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_2691_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_2692_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_2693_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) )
      = ( ( ord_less @ nat @ N @ M )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_minus_self
thf(fact_2694_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
       => ( ( dvd_dvd @ int @ M @ N )
         => ( ( dvd_dvd @ int @ N @ M )
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_2695_zdvd__not__zless,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N )
       => ~ ( dvd_dvd @ int @ N @ M ) ) ) ).

% zdvd_not_zless
thf(fact_2696_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_2697_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ N ) ) ) ) ).

% dvd_diffD1
thf(fact_2698_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_2699_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N ) ) ) ).

% zdvd_mult_cancel
thf(fact_2700_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_2701_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_2702_zdvd__period,axiom,
    ! [A2: int,D2: int,X: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D2 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X @ T2 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X @ ( times_times @ int @ C2 @ D2 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_2703_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N ) ) ).

% zdvd_reduce
thf(fact_2704_nat__dvd__iff,axiom,
    ! [Z2: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z2 ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( dvd_dvd @ int @ Z2 @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_2705_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C3: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C3 ) ) ) ) ) ).

% unit_dvdE
thf(fact_2706_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X3: A] : ( P @ ( times_times @ A @ L @ X3 ) ) )
          = ( ? [X3: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X3 @ ( zero_zero @ A ) ) )
                & ( P @ X3 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_2707_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_2708_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_2709_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_2710_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_2711_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_2712_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X5: A,K3: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X5 @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_2713_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X5: A,K3: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X5 @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_2714_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_2715_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_2716_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat @ K @ N ) ) ) ).

% dvd_imp_le
thf(fact_2717_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_mult_cancel
thf(fact_2718_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_2719_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D4: nat,X2: nat,Y2: nat] :
          ( ( dvd_dvd @ nat @ D4 @ A2 )
          & ( dvd_dvd @ nat @ D4 @ B2 )
          & ( ( times_times @ nat @ A2 @ X2 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D4 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_2720_zdvd__imp__le,axiom,
    ! [Z2: int,N: int] :
      ( ( dvd_dvd @ int @ Z2 @ N )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int @ Z2 @ N ) ) ) ).

% zdvd_imp_le
thf(fact_2721_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_2722_dvd__imp__le__int,axiom,
    ! [I: int,D2: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D2 @ I )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D2 ) @ ( abs_abs @ int @ I ) ) ) ) ).

% dvd_imp_le_int
thf(fact_2723_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q4: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q4 )
          = ( modulo_modulo @ nat @ N @ Q4 ) )
        = ( dvd_dvd @ nat @ Q4 @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_2724_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_2725_real__of__nat__div,axiom,
    ! [D2: nat,N: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_2726_option_Osize__neq,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( size_size @ ( option @ A ) @ X )
     != ( zero_zero @ nat ) ) ).

% option.size_neq
thf(fact_2727_real__of__int__div,axiom,
    ! [D2: int,N: int] :
      ( ( dvd_dvd @ int @ D2 @ N )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_2728_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L ) )
          = ( sgn_sgn @ int @ L ) ) ) ) ).

% sgn_mod
thf(fact_2729_dvd__fact,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% dvd_fact
thf(fact_2730_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_2731_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_2732_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B4: A] :
                  ( ( B4
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B4 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B4 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B4 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B4 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B4 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_2733_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_2734_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_2735_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ N ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_2736_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N ) ) ) ) ).

% dvd_power
thf(fact_2737_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_2738_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_2739_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_2740_even__even__mod__4__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_2741_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N @ M ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_2742_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_2743_dvd__minus__add,axiom,
    ! [Q4: nat,N: nat,R2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q4 @ N )
     => ( ( ord_less_eq @ nat @ Q4 @ ( times_times @ nat @ R2 @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ Q4 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N @ ( minus_minus @ nat @ ( times_times @ nat @ R2 @ M ) @ Q4 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_2744_power__dvd__imp__le,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% power_dvd_imp_le
thf(fact_2745_mod__nat__eqI,axiom,
    ! [R2: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ R2 @ N )
     => ( ( ord_less_eq @ nat @ R2 @ M )
       => ( ( dvd_dvd @ nat @ N @ ( minus_minus @ nat @ M @ R2 ) )
         => ( ( modulo_modulo @ nat @ M @ N )
            = R2 ) ) ) ) ).

% mod_nat_eqI
thf(fact_2746_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N ) @ M )
        = ( ( abs_abs @ int @ N )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2747_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( ( L
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% mod_int_pos_iff
thf(fact_2748_aset_I10_J,axiom,
    ! [D2: int,D5: int,A5: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A5 )
                 => ( X5
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(10)
thf(fact_2749_aset_I9_J,axiom,
    ! [D2: int,D5: int,A5: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A5 )
                 => ( X5
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(9)
thf(fact_2750_bset_I10_J,axiom,
    ! [D2: int,D5: int,B6: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B6 )
                 => ( X5
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(10)
thf(fact_2751_bset_I9_J,axiom,
    ! [D2: int,D5: int,B6: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B6 )
                 => ( X5
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(9)
thf(fact_2752_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F3: nat > A > A,A3: nat,B3: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B3 @ A3 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F3 @ ( plus_plus @ nat @ A3 @ ( one_one @ nat ) ) @ B3 @ ( F3 @ A3 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_2753_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb3: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb3 @ Xc )
        = Y )
     => ( ( ( ord_less @ nat @ Xb3 @ Xa )
         => ( Y = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb3 @ Xa )
         => ( Y
            = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb3 @ ( X @ Xa @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_2754_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_2755_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_odd
thf(fact_2756_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( power_power @ A @ A2 @ N ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_2757_odd__pos,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% odd_pos
thf(fact_2758_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_even_abs
thf(fact_2759_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% dvd_power_iff_le
thf(fact_2760_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_2761_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_2762_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_2763_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_2764_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_2765_odd__real__root__pow,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( power_power @ real @ ( root @ N @ X ) @ N )
        = X ) ) ).

% odd_real_root_pow
thf(fact_2766_odd__real__root__unique,axiom,
    ! [N: nat,Y: real,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ( power_power @ real @ Y @ N )
          = X )
       => ( ( root @ N @ X )
          = Y ) ) ) ).

% odd_real_root_unique
thf(fact_2767_odd__real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ N ) )
        = X ) ) ).

% odd_real_root_power_cancel
thf(fact_2768_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_2769_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_2770_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_2771_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_2772_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_even_power
thf(fact_2773_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_2774_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_even
thf(fact_2775_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_2776_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_2777_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_2778_arctan__ubound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_2779_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_2780_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_2781_arctan__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_2782_arctan__lbound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) ) ).

% arctan_lbound
thf(fact_2783_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_2784_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_2785_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_2786_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_2787_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2788_Bernoulli__inequality__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2789_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_2790_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N3 ) ) ) ) ) ).

% sin_coeff_def
thf(fact_2791_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_2792_sin__cos__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% sin_cos_npi
thf(fact_2793_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_2794_cot__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_2795_length__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_subseqs
thf(fact_2796_sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sin_zero
thf(fact_2797_cot__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% cot_zero
thf(fact_2798_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_2799_sin__pi,axiom,
    ( ( sin @ real @ pi )
    = ( zero_zero @ real ) ) ).

% sin_pi
thf(fact_2800_sin__coeff__0,axiom,
    ( ( sin_coeff @ ( zero_zero @ nat ) )
    = ( zero_zero @ real ) ) ).

% sin_coeff_0
thf(fact_2801_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_2802_cot__pi,axiom,
    ( ( cot @ real @ pi )
    = ( zero_zero @ real ) ) ).

% cot_pi
thf(fact_2803_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( zero_zero @ A ) ) ) ).

% sin_of_real_pi
thf(fact_2804_sin__npi2,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_2805_sin__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_2806_sin__npi__int,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_2807_cot__npi,axiom,
    ! [N: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_2808_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_2809_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_2810_cos__npi2,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi2
thf(fact_2811_cos__npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi
thf(fact_2812_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_2813_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_2814_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_2815_sin__2npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_2816_cos__2npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_2817_sin__int__2pin,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_2818_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_2819_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ N @ M )
       => ( M = N ) ) ) ).

% dvd_antisym
thf(fact_2820_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_2821_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_2822_sin__zero__abs__cos__one,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_2823_sincos__principal__value,axiom,
    ! [X: real] :
    ? [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
      & ( ord_less_eq @ real @ Y2 @ pi )
      & ( ( sin @ real @ Y2 )
        = ( sin @ real @ X ) )
      & ( ( cos @ real @ Y2 )
        = ( cos @ real @ X ) ) ) ).

% sincos_principal_value
thf(fact_2824_sin__x__le__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( sin @ real @ X ) @ X ) ) ).

% sin_x_le_x
thf(fact_2825_sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_2826_cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_2827_abs__sin__x__le__abs__x,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( abs_abs @ real @ X ) ) ).

% abs_sin_x_le_abs_x
thf(fact_2828_cos__arctan__not__zero,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
     != ( zero_zero @ real ) ) ).

% cos_arctan_not_zero
thf(fact_2829_subseqs__refl,axiom,
    ! [A: $tType,Xs: list @ A] : ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs_refl
thf(fact_2830_sin__cos__le1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) ) @ ( times_times @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_2831_sin__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( sin_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( cos_coeff @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% sin_coeff_Suc
thf(fact_2832_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_2833_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_2834_sin__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero
thf(fact_2835_sin__x__ge__neg__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ ( sin @ real @ X ) ) ) ).

% sin_x_ge_neg_x
thf(fact_2836_sin__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_ge_zero
thf(fact_2837_sin__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X ) ) ).

% sin_ge_minus_one
thf(fact_2838_cos__monotone__0__pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_2839_cos__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) )
              = ( ord_less_eq @ real @ Y @ X ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_2840_cos__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ( cos @ real @ X )
                = ( cos @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_2841_sin__times__pi__eq__0,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_2842_cos__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X ) ) ).

% cos_ge_minus_one
thf(fact_2843_abs__sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_2844_abs__cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_2845_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_2846_cos__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( cos_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% cos_coeff_Suc
thf(fact_2847_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W2 ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_2848_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_2849_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y: A,Ys2: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Y @ Ys2 ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% Cons_in_subseqsD
thf(fact_2850_cos__monotone__0__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_2851_cos__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) )
              = ( ord_less @ real @ Y @ X ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_2852_sin__eq__0__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ( ( sin @ real @ X )
            = ( zero_zero @ real ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_2853_sin__zero__pi__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ pi )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_2854_cos__monotone__minus__pi__0_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_2855_sin__zero__iff__int2,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( X
            = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_2856_sincos__total__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
            & ( ord_less_eq @ real @ T3 @ pi )
            & ( X
              = ( cos @ real @ T3 ) )
            & ( Y
              = ( sin @ real @ T3 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_2857_sin__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_2858_cos__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_2859_sin__gt__zero__02,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero_02
thf(fact_2860_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_2861_cos__is__zero,axiom,
    ? [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
      & ( ord_less_eq @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X2 )
        = ( zero_zero @ real ) )
      & ! [Y5: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
            & ( ord_less_eq @ real @ Y5 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y5 )
              = ( zero_zero @ real ) ) )
         => ( Y5 = X2 ) ) ) ).

% cos_is_zero
thf(fact_2862_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_2863_cos__monotone__minus__pi__0,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_2864_cos__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X2: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ pi )
            & ( ( cos @ real @ X2 )
              = Y )
            & ! [Y5: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
                  & ( ord_less_eq @ real @ Y5 @ pi )
                  & ( ( cos @ real @ Y5 )
                    = Y ) )
               => ( Y5 = X2 ) ) ) ) ) ).

% cos_total
thf(fact_2865_sincos__total__pi__half,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T3: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
              & ( ord_less_eq @ real @ T3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X
                = ( cos @ real @ T3 ) )
              & ( Y
                = ( sin @ real @ T3 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_2866_sincos__total__2pi__le,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
          & ( ord_less_eq @ real @ T3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X
            = ( cos @ real @ T3 ) )
          & ( Y
            = ( sin @ real @ T3 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_2867_sincos__total__2pi,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
           => ( ( ord_less @ real @ T3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X
                  = ( cos @ real @ T3 ) )
               => ( Y
                 != ( sin @ real @ T3 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_2868_sin__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_2869_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_2870_sin__gt__zero2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero2
thf(fact_2871_sin__lt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_2872_cos__double__less__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_2873_cos__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero
thf(fact_2874_sin__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X )
                = ( sin @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_2875_sin__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_2876_sin__monotone__2pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_2877_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_2878_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X ) ) ) ) ) ).

% cos_treble_cos
thf(fact_2879_sin__le__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_2880_sin__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_2881_sin__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_2882_sin__monotone__2pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_2883_sin__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X2: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X2 )
              = Y )
            & ! [Y5: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
                  & ( ord_less_eq @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y5 )
                    = Y ) )
               => ( Y5 = X2 ) ) ) ) ) ).

% sin_total
thf(fact_2884_cos__gt__zero__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_2885_cos__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_ge_zero
thf(fact_2886_cos__one__2pi,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X3: nat] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X3: nat] :
            ( X
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_2887_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_2888_sin__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_2889_cos__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_2890_cot__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X ) ) ) ) ).

% cot_gt_zero
thf(fact_2891_sin__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_2892_sin__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_2893_cos__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( cos @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_2894_cos__zero__iff,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_2895_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_2896_complex__unimodular__polar,axiom,
    ! [Z2: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z2 )
        = ( one_one @ real ) )
     => ~ ! [T3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
           => ( ( ord_less @ real @ T3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z2
               != ( complex2 @ ( cos @ real @ T3 ) @ ( sin @ real @ T3 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_2897_arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin
thf(fact_2898_arcsin__pi,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin_pi
thf(fact_2899_arcsin__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ Y )
              = ( ord_less_eq @ real @ X @ ( sin @ real @ Y ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_2900_le__arcsin__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y @ ( arcsin @ X ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y ) @ X ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_2901_tan__pi,axiom,
    ( ( tan @ real @ pi )
    = ( zero_zero @ real ) ) ).

% tan_pi
thf(fact_2902_tan__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tan_zero
thf(fact_2903_arcsin__0,axiom,
    ( ( arcsin @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arcsin_0
thf(fact_2904_tan__npi,axiom,
    ! [N: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_2905_tan__periodic__nat,axiom,
    ! [X: real,N: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_nat
thf(fact_2906_sin__arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y ) )
          = Y ) ) ) ).

% sin_arcsin
thf(fact_2907_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( zero_zero @ complex ) )
      = ( ( A2
          = ( zero_zero @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_0
thf(fact_2908_zero__complex_Ocode,axiom,
    ( ( zero_zero @ complex )
    = ( complex2 @ ( zero_zero @ real ) @ ( zero_zero @ real ) ) ) ).

% zero_complex.code
thf(fact_2909_complex__eq__cancel__iff2,axiom,
    ! [X: real,Y: real,Xa: real] :
      ( ( ( complex2 @ X @ Y )
        = ( real_Vector_of_real @ complex @ Xa ) )
      = ( ( X = Xa )
        & ( Y
          = ( zero_zero @ real ) ) ) ) ).

% complex_eq_cancel_iff2
thf(fact_2910_complex__of__real__code,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [X3: real] : ( complex2 @ X3 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_code
thf(fact_2911_complex__of__real__def,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [R5: real] : ( complex2 @ R5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_def
thf(fact_2912_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_2913_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_2914_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W2: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W2 ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W2 ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_2915_tan__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X3: A] : ( inverse_inverse @ A @ ( cot @ A @ X3 ) ) ) ) ) ).

% tan_altdef
thf(fact_2916_cot__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X3: A] : ( inverse_inverse @ A @ ( tan @ A @ X3 ) ) ) ) ) ).

% cot_altdef
thf(fact_2917_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_2918_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W2: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W2 ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W2 ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_2919_arcsin__le__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_2920_arcsin__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X ) )
          = ( uminus_uminus @ real @ ( arcsin @ X ) ) ) ) ) ).

% arcsin_minus
thf(fact_2921_arcsin__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% arcsin_le_mono
thf(fact_2922_arcsin__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X )
            = ( arcsin @ Y ) )
          = ( X = Y ) ) ) ) ).

% arcsin_eq_iff
thf(fact_2923_arcsin__less__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_2924_arcsin__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% arcsin_less_mono
thf(fact_2925_cos__arcsin__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_2926_lemma__tan__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X2: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y @ ( tan @ real @ X2 ) ) ) ) ).

% lemma_tan_total
thf(fact_2927_tan__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_gt_zero
thf(fact_2928_lemma__tan__total1,axiom,
    ! [Y: real] :
    ? [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
      & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X2 )
        = Y ) ) ).

% lemma_tan_total1
thf(fact_2929_tan__mono__lt__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_2930_tan__monotone_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
         => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y @ X )
              = ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_2931_tan__monotone,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ).

% tan_monotone
thf(fact_2932_tan__total,axiom,
    ! [Y: real] :
    ? [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
      & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X2 )
        = Y )
      & ! [Y5: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
            & ( ord_less @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y5 )
              = Y ) )
         => ( Y5 = X2 ) ) ) ).

% tan_total
thf(fact_2933_tan__cot,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X ) ) ) ).

% tan_cot
thf(fact_2934_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_2935_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_2936_tan__total__pos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ? [X2: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X2 )
            = Y ) ) ) ).

% tan_total_pos
thf(fact_2937_tan__pos__pi2__le,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_2938_tan__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_2939_tan__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_2940_tan__mono__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) ) ) ) ) ).

% tan_mono_le
thf(fact_2941_tan__bound__pi2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_2942_arctan,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y ) )
        = Y ) ) ).

% arctan
thf(fact_2943_arctan__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X ) )
          = X ) ) ) ).

% arctan_tan
thf(fact_2944_arctan__unique,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X )
            = Y )
         => ( ( arctan @ Y )
            = X ) ) ) ) ).

% arctan_unique
thf(fact_2945_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_2946_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_2947_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_2948_tan__total__pi4,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ? [Z3: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z3 )
          & ( ord_less @ real @ Z3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z3 )
            = X ) ) ) ).

% tan_total_pi4
thf(fact_2949_arcsin__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_2950_arcsin__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) ) ) ) ).

% arcsin_lbound
thf(fact_2951_arcsin__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_2952_arcsin__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_2953_arcsin__sin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X ) )
          = X ) ) ) ).

% arcsin_sin
thf(fact_2954_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_2955_sin__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X )
        = ( divide_divide @ real @ ( tan @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_2956_cos__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_2957_set__decode__0,axiom,
    ! [X: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% set_decode_0
thf(fact_2958_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_2959_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A3: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_2960_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_2961_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_2962_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_2963_real__sqrt__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% real_sqrt_less_iff
thf(fact_2964_real__sqrt__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% real_sqrt_le_iff
thf(fact_2965_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_2966_real__sqrt__lt__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_2967_real__sqrt__gt__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_gt_0_iff
thf(fact_2968_real__sqrt__ge__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_ge_0_iff
thf(fact_2969_real__sqrt__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_2970_real__sqrt__lt__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_2971_real__sqrt__gt__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_gt_1_iff
thf(fact_2972_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_2973_real__sqrt__le__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_2974_real__sqrt__ge__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_ge_1_iff
thf(fact_2975_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_2976_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_2977_real__sqrt__abs,axiom,
    ! [X: real] :
      ( ( sqrt @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs
thf(fact_2978_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_2979_real__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X ) ) ).

% real_sqrt_pow2
thf(fact_2980_real__sqrt__pow2__iff,axiom,
    ! [X: real] :
      ( ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% real_sqrt_pow2_iff
thf(fact_2981_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X: real,Y: real,Xa: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_2982_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_2983_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q4: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q4 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N @ Q4 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_2984_real__sqrt__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_less_mono
thf(fact_2985_real__sqrt__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_le_mono
thf(fact_2986_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_2987_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X3: complex,Y4: complex] : ( times_times @ complex @ X3 @ ( inverse_inverse @ complex @ Y4 ) ) ) ) ).

% divide_complex_def
thf(fact_2988_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_2989_real__sqrt__power,axiom,
    ! [X: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X @ K ) )
      = ( power_power @ real @ ( sqrt @ X ) @ K ) ) ).

% real_sqrt_power
thf(fact_2990_real__sqrt__inverse,axiom,
    ! [X: real] :
      ( ( sqrt @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_inverse
thf(fact_2991_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_2992_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_2993_subset__decode__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% subset_decode_imp_le
thf(fact_2994_real__sqrt__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_gt_zero
thf(fact_2995_real__sqrt__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_zero
thf(fact_2996_real__sqrt__eq__zero__cancel,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sqrt @ X )
          = ( zero_zero @ real ) )
       => ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_2997_real__sqrt__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_one
thf(fact_2998_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_2999_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_3000_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% take_bit_nonnegative
thf(fact_3001_not__take__bit__negative,axiom,
    ! [N: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_3002_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_3003_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_3004_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_3005_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_3006_real__div__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ X @ ( sqrt @ X ) )
        = ( sqrt @ X ) ) ) ).

% real_div_sqrt
thf(fact_3007_sqrt__add__le__add__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X @ Y ) ) @ ( plus_plus @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_3008_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_3009_le__real__sqrt__sumsq,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X @ X ) @ ( times_times @ real @ Y @ Y ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_3010_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_3011_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_3012_sqrt__divide__self__eq,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ ( sqrt @ X ) @ X )
        = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3013_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_3014_take__bit__nat__eq__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_3015_take__bit__nat__less__exp,axiom,
    ! [N: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_nat_less_exp
thf(fact_3016_take__bit__nat__eq__self,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_3017_real__less__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_less_rsqrt
thf(fact_3018_sqrt__le__D,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ Y )
     => ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_3019_real__le__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less_eq @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_le_rsqrt
thf(fact_3020_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N3: nat,M2: nat] : ( modulo_modulo @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% take_bit_nat_def
thf(fact_3021_take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_int_less_exp
thf(fact_3022_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( modulo_modulo @ int @ K4 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% take_bit_int_def
thf(fact_3023_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_3024_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_3025_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_3026_real__le__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_le_lsqrt
thf(fact_3027_real__sqrt__unique,axiom,
    ! [Y: real,X: real] :
      ( ( ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( sqrt @ X )
          = Y ) ) ) ).

% real_sqrt_unique
thf(fact_3028_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_3029_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X )
     => ( Y
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_3030_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y )
     => ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_3031_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_3032_real__sqrt__sum__squares__ge2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ Y @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_3033_real__sqrt__sum__squares__ge1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_3034_sqrt__ge__absD,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ Y ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y ) ) ).

% sqrt_ge_absD
thf(fact_3035_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_3036_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_3037_real__less__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_less_lsqrt
thf(fact_3038_sqrt__sum__squares__le__sum,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_3039_real__inv__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3040_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ Y ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_3041_real__sqrt__ge__abs2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_3042_real__sqrt__ge__abs1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_3043_sqrt__even__pow2,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_3044_ln__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( sqrt @ X ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_3045_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X3: real] : ( ln_ln @ real @ ( plus_plus @ real @ X3 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_3046_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_3047_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_3048_complex__norm,axiom,
    ! [X: real,Y: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X @ Y ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_3049_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_3050_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_3051_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_3052_arsinh__real__aux,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_3053_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X: real,Y: real,Xa: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_3054_real__sqrt__power__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( sqrt @ X ) @ N )
          = ( power_power @ real @ X @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_3055_arith__geo__mean__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X @ Y ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_3056_powr__half__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X ) ) ) ).

% powr_half_sqrt
thf(fact_3057_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_3058_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_3059_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N3 ) @ ( plus_plus @ int @ K4 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_3060_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_3061_cos__x__y__le__one,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_3062_real__sqrt__sum__squares__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_3063_arcosh__real__def,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( arcosh @ real @ X )
        = ( ln_ln @ real @ ( plus_plus @ real @ X @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_3064_cos__arctan,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3065_sin__arctan,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_3066_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_3067_sqrt__sum__squares__half__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ X @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_3068_sin__cos__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) )
     => ( ( sin @ real @ X )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3069_arctan__half,axiom,
    ( arctan
    = ( ^ [X3: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X3 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_3070_cos__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3071_num_Osize__gen_I2_J,axiom,
    ! [X23: num] :
      ( ( size_num @ ( bit0 @ X23 ) )
      = ( plus_plus @ nat @ ( size_num @ X23 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_3072_sin__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3073_sin__arccos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3074_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K4: int,L4: int] :
          ( if @ int
          @ ( L4
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K4 )
              = ( sgn_sgn @ int @ L4 ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K4 ) ) @ ( nat2 @ ( abs_abs @ int @ L4 ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K4 ) ) @ ( nat2 @ ( abs_abs @ int @ L4 ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L4 @ K4 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_3075_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A1: vEBT_VEBT,A22: nat] :
          ( ( ? [A3: $o,B3: $o] :
                ( A1
                = ( vEBT_Leaf @ A3 @ B3 ) )
            & ( A22
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList2: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList2 @ Summary2 ) )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ( vEBT_invar_vebt @ X3 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary2 @ N3 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
              & ( A22
                = ( plus_plus @ nat @ N3 @ N3 ) )
              & ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X7 )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
          | ? [TreeList2: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList2 @ Summary2 ) )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ( vEBT_invar_vebt @ X3 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary2 @ ( suc @ N3 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
              & ( A22
                = ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) )
              & ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X7 )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
          | ? [TreeList2: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,Mi: nat,Ma2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ A22 @ TreeList2 @ Summary2 ) )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ( vEBT_invar_vebt @ X3 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary2 @ N3 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
              & ( A22
                = ( plus_plus @ nat @ N3 @ N3 ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                 => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X7 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
              & ( ( Mi = Ma2 )
               => ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                   => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
              & ( ord_less_eq @ nat @ Mi @ Ma2 )
              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi != Ma2 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                      & ! [X3: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X3 @ N3 )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ X3 @ N3 ) ) )
                         => ( ( ord_less @ nat @ Mi @ X3 )
                            & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) )
          | ? [TreeList2: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,Mi: nat,Ma2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ A22 @ TreeList2 @ Summary2 ) )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                 => ( vEBT_invar_vebt @ X3 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary2 @ ( suc @ N3 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
              & ( A22
                = ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
                 => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X7 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
              & ( ( Mi = Ma2 )
               => ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                   => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
              & ( ord_less_eq @ nat @ Mi @ Ma2 )
              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi != Ma2 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                      & ! [X3: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X3 @ N3 )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ ( vEBT_VEBT_low @ X3 @ N3 ) ) )
                         => ( ( ord_less @ nat @ Mi @ X3 )
                            & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_3076_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_3077_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_3078_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_3079_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_3080_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( ring_1_of_int @ A @ ( zero_neq_one_of_bool @ int @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_int_of_bool
thf(fact_3081_mi__ma__2__deg,axiom,
    ! [Mi2: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ N )
     => ( ( ord_less_eq @ nat @ Mi2 @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_3082_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_3083_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_3084_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3085_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_3086_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi2: nat,Ma: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X = Mi2 )
          | ( X = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_3087_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_3088_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Mi2: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_3089_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_3090_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_3091_Suc__0__mod__eq,axiom,
    ! [N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_3092_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_3093_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sgn_of_nat
thf(fact_3094_cos__arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y ) )
          = Y ) ) ) ).

% cos_arccos
thf(fact_3095_take__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% take_bit_of_Suc_0
thf(fact_3096_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_3097_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3098_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_3099_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_3100_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_3101_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_3102_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_3103_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi2: nat,Ma: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ X )
      = ( ( X = Mi2 )
        | ( X = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_3104_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_3105_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_3106_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P6: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P6 ) )
          = ( ~ ( ( P6
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P6
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_3107_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P6: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P6 ) )
          = ( ( P6
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P6
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_3108_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P5: $o] : ( if @ A @ P5 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_3109_arccos__le__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_3110_arccos__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% arccos_le_mono
thf(fact_3111_arccos__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X )
          = ( arccos @ Y ) )
        = ( X = Y ) ) ) ).

% arccos_eq_iff
thf(fact_3112_option_Osize_I4_J,axiom,
    ! [A: $tType,X23: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X23 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_3113_arccos__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) ) ) ) ).

% arccos_lbound
thf(fact_3114_arccos__less__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3115_arccos__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% arccos_less_mono
thf(fact_3116_arccos__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_3117_arccos__cos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( arccos @ ( cos @ real @ X ) )
          = X ) ) ) ).

% arccos_cos
thf(fact_3118_cos__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y ) )
        = Y ) ) ).

% cos_arccos_abs
thf(fact_3119_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_3120_arccos__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3121_arccos__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3122_sin__arccos__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3123_arccos__cos2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( arccos @ ( cos @ real @ X ) )
          = ( uminus_uminus @ real @ X ) ) ) ) ).

% arccos_cos2
thf(fact_3124_arccos__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ) ).

% arccos_minus
thf(fact_3125_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_3126_arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y ) )
            = Y ) ) ) ) ).

% arccos
thf(fact_3127_arccos__minus__abs,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ).

% arccos_minus_abs
thf(fact_3128_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi2: nat,Ma: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ X7 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
               => ( ( ( Mi2 = Ma )
                   => ! [X2: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi2 != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X2: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X2 @ N )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ X2 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi2 @ X2 )
                                      & ( ord_less_eq @ nat @ X2 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_3129_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi2: nat,Ma: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ X7 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
               => ( ( ( Mi2 = Ma )
                   => ! [X2: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi2 != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X2: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X2 @ N )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ X2 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi2 @ X2 )
                                      & ( ord_less_eq @ nat @ X2 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_3130_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_3131_arccos__le__pi2,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3132_divide__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_3133_modulo__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_3134_invar__vebt_Ocases,axiom,
    ! [A12: vEBT_VEBT,A23: nat] :
      ( ( vEBT_invar_vebt @ A12 @ A23 )
     => ( ( ? [A4: $o,B4: $o] :
              ( A12
              = ( vEBT_Leaf @ A4 @ B4 ) )
         => ( A23
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( A23 = Deg2 )
               => ( ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_invar_vebt @ X5 @ N2 ) )
                 => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                     => ( ( M4 = N2 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N2 @ M4 ) )
                         => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X_12 )
                           => ~ ! [X5: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat] :
                ( ( A12
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( A23 = Deg2 )
                 => ( ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_invar_vebt @ X5 @ N2 ) )
                   => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                       => ( ( M4
                            = ( suc @ N2 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N2 @ M4 ) )
                           => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X_12 )
                             => ~ ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat,Mi3: nat,Ma3: nat] :
                  ( ( A12
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
                 => ( ( A23 = Deg2 )
                   => ( ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_invar_vebt @ X5 @ N2 ) )
                     => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                         => ( ( M4 = N2 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N2 @ M4 ) )
                             => ( ! [I3: nat] :
                                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                   => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X7 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                               => ( ( ( Mi3 = Ma3 )
                                   => ! [X5: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                                   => ( ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi3 != Ma3 )
                                         => ! [I3: nat] :
                                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                                                    = I3 )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                                                & ! [X5: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X5 @ N2 )
                                                        = I3 )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) )
                                                   => ( ( ord_less @ nat @ Mi3 @ X5 )
                                                      & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat,Mi3: nat,Ma3: nat] :
                    ( ( A12
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
                   => ( ( A23 = Deg2 )
                     => ( ! [X5: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ( vEBT_invar_vebt @ X5 @ N2 ) )
                       => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                           => ( ( M4
                                = ( suc @ N2 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N2 @ M4 ) )
                               => ( ! [I3: nat] :
                                      ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                     => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X7 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                                 => ( ( ( Mi3 = Ma3 )
                                     => ! [X5: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                         => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                                     => ( ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi3 != Ma3 )
                                           => ! [I3: nat] :
                                                ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                                                      = I3 )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                                                  & ! [X5: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X5 @ N2 )
                                                          = I3 )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) )
                                                     => ( ( ord_less @ nat @ Mi3 @ X5 )
                                                        & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_3135_member__inv,axiom,
    ! [Mi2: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
        & ( ( X = Mi2 )
          | ( X = Ma )
          | ( ( ord_less @ nat @ X @ Ma )
            & ( ord_less @ nat @ Mi2 @ X )
            & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
            & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% member_inv
thf(fact_3136_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R2: A,Q4: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R2 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q4 @ R2 ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R2 @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R2 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q4 @ R2 ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R2 ) ) ) ) ) ).

% divmod_step_eq
thf(fact_3137_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_3138_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q4: A,R2: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q4 @ R2 ) )
          = ( R2
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_3139_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys2: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys2 ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) @ ( nth @ B @ Ys2 @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ) ).

% product_nth
thf(fact_3140_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_3141_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_3142_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs @ Ys2 ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ).

% length_product
thf(fact_3143_nat__of__bool,axiom,
    ! [P: $o] :
      ( ( nat2 @ ( zero_neq_one_of_bool @ int @ P ) )
      = ( zero_neq_one_of_bool @ nat @ P ) ) ).

% nat_of_bool
thf(fact_3144_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,D4: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ D4 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,Deg3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_3145_vebt__member_Osimps_I2_J,axiom,
    ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ X ) ).

% vebt_member.simps(2)
thf(fact_3146_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_3147_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A4: $o,B4: $o,X2: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ X2 ) )
     => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT,X2: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ X2 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_3148_vebt__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% vebt_member.simps(1)
thf(fact_3149_vebt__member_Osimps_I3_J,axiom,
    ! [V2: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V2 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ X ) ).

% vebt_member.simps(3)
thf(fact_3150_vebt__member_Osimps_I4_J,axiom,
    ! [V2: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V2 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ X ) ).

% vebt_member.simps(4)
thf(fact_3151_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_3152_vebt__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A4: $o,B4: $o,X2: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ X2 ) )
     => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,X2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ X2 ) )
       => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,X2: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ X2 ) )
         => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X2: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ X2 ) )
           => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X2: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ X2 ) ) ) ) ) ) ).

% vebt_member.cases
thf(fact_3153_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Uw2 ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X2: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ X2 ) )
         => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X2: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ X2 ) )
           => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT,X2: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ X2 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_3154_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_3155_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K4: int,L4: int] :
          ( if @ int
          @ ( L4
            = ( zero_zero @ int ) )
          @ K4
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K4 )
              = ( sgn_sgn @ int @ L4 ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L4 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K4 ) ) @ ( nat2 @ ( abs_abs @ int @ L4 ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L4 )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L4 )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L4 @ K4 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K4 ) ) @ ( nat2 @ ( abs_abs @ int @ L4 ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_3156_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_3157_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_3158_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q4: int,R2: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q4 @ R2 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q4 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_3159_Divides_Oadjust__div__eq,axiom,
    ! [Q4: int,R2: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q4 @ R2 ) )
      = ( plus_plus @ int @ Q4
        @ ( zero_neq_one_of_bool @ int
          @ ( R2
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_3160_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q4: int,R2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q4 @ R2 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q4 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R2 ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_3161_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_3162_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_3163_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_3164_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_3165_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q4: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q4 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_3166_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q4 @ R2 ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R2
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q4 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q4 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R2
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R2 ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_3167_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q4: int,R2: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q4 @ R2 ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q4 ) @ R2 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
            & ( ord_less @ int @ R2 @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R2 )
                & ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q4
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_3168_eucl__rel__int__remainderI,axiom,
    ! [R2: int,L: int,K: int,Q4: int] :
      ( ( ( sgn_sgn @ int @ R2 )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R2 ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L ) @ R2 ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q4 @ R2 ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_3169_eucl__rel__int_Ocases,axiom,
    ! [A12: int,A23: int,A32: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A12 @ A23 @ A32 )
     => ( ( ( A23
            = ( zero_zero @ int ) )
         => ( A32
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A12 ) ) )
       => ( ! [Q5: int] :
              ( ( A32
                = ( product_Pair @ int @ int @ Q5 @ ( zero_zero @ int ) ) )
             => ( ( A23
                 != ( zero_zero @ int ) )
               => ( A12
                 != ( times_times @ int @ Q5 @ A23 ) ) ) )
         => ~ ! [R: int,Q5: int] :
                ( ( A32
                  = ( product_Pair @ int @ int @ Q5 @ R ) )
               => ( ( ( sgn_sgn @ int @ R )
                    = ( sgn_sgn @ int @ A23 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ A23 ) )
                   => ( A12
                     != ( plus_plus @ int @ ( times_times @ int @ Q5 @ A23 ) @ R ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_3170_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A1: int,A22: int,A33: product_prod @ int @ int] :
          ( ? [K4: int] :
              ( ( A1 = K4 )
              & ( A22
                = ( zero_zero @ int ) )
              & ( A33
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K4 ) ) )
          | ? [L4: int,K4: int,Q6: int] :
              ( ( A1 = K4 )
              & ( A22 = L4 )
              & ( A33
                = ( product_Pair @ int @ int @ Q6 @ ( zero_zero @ int ) ) )
              & ( L4
               != ( zero_zero @ int ) )
              & ( K4
                = ( times_times @ int @ Q6 @ L4 ) ) )
          | ? [R5: int,L4: int,K4: int,Q6: int] :
              ( ( A1 = K4 )
              & ( A22 = L4 )
              & ( A33
                = ( product_Pair @ int @ int @ Q6 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L4 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L4 ) )
              & ( K4
                = ( plus_plus @ int @ ( times_times @ int @ Q6 @ L4 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_3171_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M2: num,N3: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M2 @ N3 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M2 ) ) @ ( unique1321980374590559556d_step @ A @ N3 @ ( unique8689654367752047608divmod @ A @ M2 @ ( bit0 @ N3 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_3172_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X23: A] :
      ( ( size_option @ A @ X @ ( some @ A @ X23 ) )
      = ( plus_plus @ nat @ ( X @ X23 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_3173_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N3 ) @ K4 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K4 @ N3 ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_3174_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L ) ) ) ) ).

% power_numeral
thf(fact_3175_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K4: int,L4: int] :
          ( if @ int
          @ ( ( K4
              = ( zero_zero @ int ) )
            | ( L4
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K4
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L4
            @ ( if @ int
              @ ( L4
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K4
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_3176_sinh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( sinh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3177_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_3178_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_3179_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_3180_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_3181_sinh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sinh_0
thf(fact_3182_sinh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sinh @ real @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% sinh_real_zero_iff
thf(fact_3183_sinh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% sinh_real_less_iff
thf(fact_3184_sinh__real__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% sinh_real_le_iff
thf(fact_3185_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% and_nonnegative_int_iff
thf(fact_3186_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_3187_sinh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_pos_iff
thf(fact_3188_sinh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3189_sinh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_nonneg_iff
thf(fact_3190_sinh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3191_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_3192_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ).

% signed_take_bit_negative_iff
thf(fact_3193_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_3194_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_3195_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_3196_and__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_3197_and__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_3198_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( N
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_3199_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_3200_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_and_eq
thf(fact_3201_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_3202_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less @ nat @ N @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_take_bit_iff
thf(fact_3203_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N )
          = ( B2
            & ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_3204_AND__upper2_H,axiom,
    ! [Y: int,Z2: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z2 )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z2 ) ) ) ).

% AND_upper2'
thf(fact_3205_AND__upper1_H,axiom,
    ! [Y: int,Z2: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z2 )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z2 ) ) ) ).

% AND_upper1'
thf(fact_3206_AND__upper2,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Y ) ) ).

% AND_upper2
thf(fact_3207_AND__upper1,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ X ) ) ).

% AND_upper1
thf(fact_3208_AND__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) ) ) ).

% AND_lower
thf(fact_3209_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_3210_pow_Osimps_I1_J,axiom,
    ! [X: num] :
      ( ( pow @ X @ one2 )
      = X ) ).

% pow.simps(1)
thf(fact_3211_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ K ) ) ).

% and_less_eq
thf(fact_3212_AND__upper1_H_H,axiom,
    ! [Y: int,Z2: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z2 )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z2 ) ) ) ).

% AND_upper1''
thf(fact_3213_AND__upper2_H_H,axiom,
    ! [Y: int,Z2: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z2 )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z2 ) ) ) ).

% AND_upper2''
thf(fact_3214_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_3215_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_3216_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N2: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_eq @ nat @ N2 @ M3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M3 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ) ) ).

% int_bit_bound
thf(fact_3217_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N3: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_3218_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K4: int,N3: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K4 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% bit_int_def
thf(fact_3219_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_3220_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_3221_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [J2: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_3222_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N3: nat] :
              ( ( ( N3
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
              & ( ( N3
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_3223_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_option @ A @ X @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_3224_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N3: nat,K4: int] :
          ( plus_plus @ int @ K4
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K4 @ N3 ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% set_bit_eq
thf(fact_3225_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( minus_minus @ int @ K4 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K4 @ N3 ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% unset_bit_eq
thf(fact_3226_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_3227_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_3228_cosh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( cosh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3229_i__even__power,axiom,
    ! [N: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N ) ) ).

% i_even_power
thf(fact_3230_Suc__0__xor__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_3231_xor__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_3232_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_3233_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_3234_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_3235_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_3236_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3237_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_3238_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_3239_inverse__i,axiom,
    ( ( inverse_inverse @ complex @ imaginary_unit )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% inverse_i
thf(fact_3240_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_3241_and__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_3242_and__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_3243_xor__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X ) ) ) ).

% xor_nat_numerals(4)
thf(fact_3244_xor__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% xor_nat_numerals(3)
thf(fact_3245_xor__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y ) ) ) ).

% xor_nat_numerals(2)
thf(fact_3246_xor__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% xor_nat_numerals(1)
thf(fact_3247_and__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_3248_and__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_3249_Suc__0__and__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_3250_and__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_3251_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3252_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_xor_eq
thf(fact_3253_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_nat_mask_eq
thf(fact_3254_cosh__real__nonzero,axiom,
    ! [X: real] :
      ( ( cosh @ real @ X )
     != ( zero_zero @ real ) ) ).

% cosh_real_nonzero
thf(fact_3255_complex__i__not__zero,axiom,
    imaginary_unit
 != ( zero_zero @ complex ) ).

% complex_i_not_zero
thf(fact_3256_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N ) ) ).

% not_bit_Suc_0_Suc
thf(fact_3257_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_3258_cosh__real__pos,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_pos
thf(fact_3259_cosh__real__nonpos__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3260_cosh__real__nonneg__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3261_cosh__real__nonneg,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_nonneg
thf(fact_3262_cosh__real__ge__1,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_ge_1
thf(fact_3263_sinh__less__cosh__real,axiom,
    ! [X: real] : ( ord_less @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_less_cosh_real
thf(fact_3264_sinh__le__cosh__real,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_le_cosh_real
thf(fact_3265_mask__nonnegative__int,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N ) ) ).

% mask_nonnegative_int
thf(fact_3266_not__mask__negative__int,axiom,
    ! [N: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_3267_not__bit__Suc__0__numeral,axiom,
    ! [N: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N ) ) ).

% not_bit_Suc_0_numeral
thf(fact_3268_cosh__real__strict__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3269_cosh__real__nonneg__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3270_cosh__real__nonpos__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3271_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M2: nat,N3: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% and_nat_def
thf(fact_3272_arcosh__cosh__real,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( arcosh @ real @ ( cosh @ real @ X ) )
        = X ) ) ).

% arcosh_cosh_real
thf(fact_3273_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3274_Complex__eq__i,axiom,
    ! [X: real,Y: real] :
      ( ( ( complex2 @ X @ Y )
        = imaginary_unit )
      = ( ( X
          = ( zero_zero @ real ) )
        & ( Y
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3275_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_nat_iff
thf(fact_3276_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_3277_complex__of__real__i,axiom,
    ! [R2: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R2 ) ) ).

% complex_of_real_i
thf(fact_3278_i__complex__of__real,axiom,
    ! [R2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R2 ) )
      = ( complex2 @ ( zero_zero @ real ) @ R2 ) ) ).

% i_complex_of_real
thf(fact_3279_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% bit_nat_def
thf(fact_3280_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_3281_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3282_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N3: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_3283_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N3: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_3284_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( if @ nat
          @ ( ( M2
              = ( zero_zero @ nat ) )
            | ( N3
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_3285_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( if @ nat
          @ ( M2
            = ( zero_zero @ nat ) )
          @ N3
          @ ( if @ nat
            @ ( N3
              = ( zero_zero @ nat ) )
            @ M2
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_3286_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3287_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3288_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3289_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3290_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3291_normalize__negative,axiom,
    ! [Q4: int,P6: int] :
      ( ( ord_less @ int @ Q4 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P6 @ Q4 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P6 ) @ ( uminus_uminus @ int @ Q4 ) ) ) ) ) ).

% normalize_negative
thf(fact_3292_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_3293_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_3294_vebt__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A4 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B4 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
         => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
           => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
             => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary3: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                   => ( ( Xa != Mi3 )
                     => ( ( Xa != Ma3 )
                       => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                           => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                              & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(3)
thf(fact_3295_vebt__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa )
        = Y )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ( Y
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
           => Y )
         => ( ( ? [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
             => Y )
           => ( ( ? [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
               => Y )
             => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary3: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                   => ( Y
                      = ( ~ ( ( Xa != Mi3 )
                           => ( ( Xa != Ma3 )
                             => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                 => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                    & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(1)
thf(fact_3296_set__vebt_H__def,axiom,
    ( vEBT_VEBT_set_vebt
    = ( ^ [T4: vEBT_VEBT] : ( collect @ nat @ ( vEBT_vebt_member @ T4 ) ) ) ) ).

% set_vebt'_def
thf(fact_3297_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_3298_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_3299_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_3300_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_3301_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_3302_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_3303_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% mask_nat_positive_iff
thf(fact_3304_normalize__denom__zero,axiom,
    ! [P6: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P6 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_3305_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_3306_push__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% push_bit_of_Suc_0
thf(fact_3307_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( ( N
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_3308_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H3: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_3309_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C5: A] : ( dvd_dvd @ A @ C5 @ A2 ) )
            @ ( collect @ A
              @ ^ [C5: A] : ( dvd_dvd @ A @ C5 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_3310_subset__Collect__iff,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A5 )
                & ( P @ X3 ) ) ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ B6 )
             => ( P @ X3 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_3311_subset__CollectI,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ B6 )
           => ( ( Q @ X2 )
             => ( P @ X2 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ B6 )
                & ( Q @ X3 ) ) )
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A5 )
                & ( P @ X3 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_3312_Collect__subset,axiom,
    ! [A: $tType,A5: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ A5 )
            & ( P @ X3 ) ) )
      @ A5 ) ).

% Collect_subset
thf(fact_3313_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X3: A] : ( member @ A @ X3 @ A7 )
            @ ^ [X3: A] : ( member @ A @ X3 @ B7 ) ) ) ) ).

% less_eq_set_def
thf(fact_3314_less__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ord_less @ ( A > $o )
            @ ^ [X3: A] : ( member @ A @ X3 @ A7 )
            @ ^ [X3: A] : ( member @ A @ X3 @ B7 ) ) ) ) ).

% less_set_def
thf(fact_3315_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_3316_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_push_bit
thf(fact_3317_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C5: A] : ( dvd_dvd @ A @ C5 @ A2 ) )
            @ ( collect @ A
              @ ^ [C5: A] : ( dvd_dvd @ A @ C5 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A2 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_3318_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_code(2)
thf(fact_3319_less__eq__mask,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% less_eq_mask
thf(fact_3320_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_less_as_int
thf(fact_3321_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_leq_as_int
thf(fact_3322_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_3323_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W2: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit0 @ W2 ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_numeral_even
thf(fact_3324_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W2: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit1 @ W2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z2 @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_numeral_odd
thf(fact_3325_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_3326_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_3327_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_3328_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_3329_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_3330_XOR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) ) ) ) ).

% XOR_lower
thf(fact_3331_diff__nat__eq__if,axiom,
    ! [Z6: int,Z2: int] :
      ( ( ( ord_less @ int @ Z6 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) )
          = ( nat2 @ Z2 ) ) )
      & ( ~ ( ord_less @ int @ Z6 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z2 @ Z6 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z2 @ Z6 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_3332_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_3333_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M2: nat,N3: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% xor_nat_def
thf(fact_3334_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X3: nat] :
          ( collect @ nat
          @ ^ [N3: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_3335_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q4: nat,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q4 ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q4 @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_3336_less__mask,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ) ).

% less_mask
thf(fact_3337_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N3: nat] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_3338_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N3: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_3339_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va2: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_3340_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( times_times @ int @ K4 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% push_bit_int_def
thf(fact_3341_normalize__denom__pos,axiom,
    ! [R2: product_prod @ int @ int,P6: int,Q4: int] :
      ( ( ( normalize @ R2 )
        = ( product_Pair @ int @ int @ P6 @ Q4 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q4 ) ) ).

% normalize_denom_pos
thf(fact_3342_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N3: nat,M2: nat] : ( times_times @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% push_bit_nat_def
thf(fact_3343_normalize__crossproduct,axiom,
    ! [Q4: int,S: int,P6: int,R2: int] :
      ( ( Q4
       != ( zero_zero @ int ) )
     => ( ( S
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P6 @ Q4 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R2 @ S ) ) )
         => ( ( times_times @ int @ P6 @ S )
            = ( times_times @ int @ R2 @ Q4 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_3344_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K4: nat] :
              ( if @ A
              @ ( K4
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L4: nat] : ( times_times @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ L4 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K4 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_3345_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_3346_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 )
         => ~ ! [B4: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N @ B4 ) ) ) ) ).

% exp_dvdE
thf(fact_3347_Suc__mask__eq__exp,axiom,
    ! [N: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_mask_eq_exp
thf(fact_3348_vebt__buildup_Oelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y )
     => ( ( ( X
            = ( zero_zero @ nat ) )
         => ( Y
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va: nat] :
                ( ( X
                  = ( suc @ ( suc @ Va ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_3349_mask__nat__less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% mask_nat_less_exp
thf(fact_3350_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V2: nat,TreeList: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V2 ) @ TreeList @ S ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_3351_push__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_minus_one
thf(fact_3352_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V2: nat,TreeList: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V2 ) @ TreeList @ Vd2 ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_3353_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi2: nat,Ma: nat,V2: nat,TreeList: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( suc @ V2 ) @ TreeList @ Vc ) @ X )
      = ( ( X = Mi2 )
        | ( X = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_3354_vebt__member_Osimps_I5_J,axiom,
    ! [Mi2: nat,Ma: nat,Va2: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList @ Summary ) @ X )
      = ( ( X != Mi2 )
       => ( ( X != Ma )
         => ( ~ ( ord_less @ nat @ X @ Mi2 )
            & ( ~ ( ord_less @ nat @ X @ Mi2 )
             => ( ~ ( ord_less @ nat @ Ma @ X )
                & ( ~ ( ord_less @ nat @ Ma @ X )
                 => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                     => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.simps(5)
thf(fact_3355_XOR__upper,axiom,
    ! [X: int,N: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% XOR_upper
thf(fact_3356_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_3357_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A4 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B4 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_3358_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A4 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B4 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [S3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_3359_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa )
        = Y )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ( Y
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
           => Y )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( Y
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_3360_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ! [Mi3: nat,Ma3: nat] :
            ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
           => ~ ( ( Xa = Mi3 )
                | ( Xa = Ma3 ) ) )
       => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Vc2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
             => ~ ( ( Xa = Mi3 )
                  | ( Xa = Ma3 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
         => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [Vd: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_3361_vebt__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_vebt_member @ X @ Xa )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A4 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B4 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Summary3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
             => ~ ( ( Xa != Mi3 )
                 => ( ( Xa != Ma3 )
                   => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                      & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                       => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                          & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                           => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                               => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                              & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(2)
thf(fact_3362_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ! [Uu2: $o,Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ Uu2 @ Uv2 ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
         => ( ! [Mi3: nat,Ma3: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( ( Xa = Mi3 )
                  | ( Xa = Ma3 ) ) )
           => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                 => ( ( Xa = Mi3 )
                    | ( Xa = Ma3 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
             => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_3363_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa )
        = Y )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => Y )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
           => Y )
         => ( ! [Mi3: nat,Ma3: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( Y
                  = ( ~ ( ( Xa = Mi3 )
                        | ( Xa = Ma3 ) ) ) ) )
           => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                 => ( Y
                    = ( ~ ( ( Xa = Mi3 )
                          | ( Xa = Ma3 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) )
             => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                   => ( Y
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_3364_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N )
          = ( ( ord_less @ nat @ N @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_3365_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K4: int] :
              ( if @ A
              @ ( K4
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K4 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K4 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_3366_monoseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_3367_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K4: nat] : ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K4 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_3368_ln__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X )
          = ( suminf @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ ( one_one @ real ) ) @ ( suc @ N3 ) ) ) ) ) ) ) ).

% ln_series
thf(fact_3369_arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arctan @ X )
        = ( suminf @ real
          @ ^ [K4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K4 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_3370_predicate1I,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) ).

% predicate1I
thf(fact_3371_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ B )
        & ( ring_1 @ B ) )
     => ! [A5: set @ A,F2: A > B] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ A5 )
             => ( member @ B @ ( F2 @ X2 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A5 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_prod
thf(fact_3372_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > nat,A5: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A5 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X3: B] : ( semiring_1_of_nat @ A @ ( F2 @ X3 ) )
            @ A5 ) ) ) ).

% of_nat_prod
thf(fact_3373_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [F2: B > int,A5: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7121269368397514597t_prod @ B @ int @ F2 @ A5 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X3: B] : ( ring_1_of_int @ A @ ( F2 @ X3 ) )
            @ A5 ) ) ) ).

% of_int_prod
thf(fact_3374_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_3375_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G2 @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_3376_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F2: B > A,A5: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A3: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ A3 ) )
            @ A5 ) ) ) ).

% norm_prod_le
thf(fact_3377_rev__predicate1D,axiom,
    ! [A: $tType,P: A > $o,X: A,Q: A > $o] :
      ( ( P @ X )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X ) ) ) ).

% rev_predicate1D
thf(fact_3378_predicate1D,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,X: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X )
       => ( Q @ X ) ) ) ).

% predicate1D
thf(fact_3379_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G2 @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_3380_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G2 @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_3381_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G2 @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_3382_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G2 @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G2 @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_3383_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X3: nat] : X3
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod
thf(fact_3384_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G2: nat > A,P6: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P6 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P6 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_3385_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X3: nat] : X3
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_3386_monoseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X ) ) ) ) ).

% monoseq_realpow
thf(fact_3387_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_3388_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N3 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N3 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_3389_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X3: nat] : X3
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_3390_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I4 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_3391_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_3392_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K4: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K4 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_3393_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_3394_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A
          @ ^ [N3: nat] : ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% suminf_zero
thf(fact_3395_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) )
                & ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_3396_summable__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K4 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_3397_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K4: int,L4: int] :
          ( if @ int
          @ ( K4
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L4 )
          @ ( if @ int
            @ ( L4
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K4 )
            @ ( if @ int
              @ ( K4
                = ( zero_zero @ int ) )
              @ L4
              @ ( if @ int
                @ ( L4
                  = ( zero_zero @ int ) )
                @ K4
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_3398_summable__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F2: nat > A] :
          ( summable @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ).

% summable_single
thf(fact_3399_summable__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A
        @ ^ [N3: nat] : ( zero_zero @ A ) ) ) ).

% summable_zero
thf(fact_3400_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_3401_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_3402_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_3403_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ ( F2 @ N3 ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_3404_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_3405_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_3406_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_3407_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_3408_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_3409_int__prod,axiom,
    ! [B: $tType,F2: B > nat,A5: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A5 ) )
      = ( groups7121269368397514597t_prod @ B @ int
        @ ^ [X3: B] : ( semiring_1_of_nat @ int @ ( F2 @ X3 ) )
        @ A5 ) ) ).

% int_prod
thf(fact_3410_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G2: nat > real,N4: nat,F2: nat > A] :
          ( ( summable @ real @ G2 )
         => ( ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G2 @ N2 ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_3411_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G2: nat > real] :
          ( ? [N8: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G2 @ N2 ) ) )
         => ( ( summable @ real @ G2 )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_3412_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G2: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G2 @ N2 ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G2 )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G2 ) ) ) ) ) ) ).

% suminf_le
thf(fact_3413_summable__const__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A] :
          ( ( summable @ A
            @ ^ [Uu3: nat] : C2 )
          = ( C2
            = ( zero_zero @ A ) ) ) ) ).

% summable_const_iff
thf(fact_3414_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_3415_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_3416_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X: A,Z2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_3417_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N3: nat] :
                    ( ( F2 @ N3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_3418_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_3419_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_3420_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) ) ) ).

% summable_0_powser
thf(fact_3421_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) ) ) ).

% summable_zero_power'
thf(fact_3422_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z2 @ N3 ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_3423_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z2 @ N3 ) ) )
          = ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_3424_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M: nat,Z2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N3 @ M ) ) @ ( power_power @ A @ Z2 @ N3 ) ) )
          = ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_3425_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G2: nat > real] :
          ( ? [N8: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G2 @ N2 ) ) )
         => ( ( summable @ real @ G2 )
           => ( summable @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_3426_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G2: nat > real] :
      ( ? [N8: nat] :
        ! [N2: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N2 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N2 ) ) @ ( G2 @ N2 ) ) )
     => ( ( summable @ real @ G2 )
       => ( summable @ real
          @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_3427_summable__rabs,axiom,
    ! [F2: nat > real] :
      ( ( summable @ real
        @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F2 ) )
        @ ( suminf @ real
          @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) ) ) ) ).

% summable_rabs
thf(fact_3428_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I4: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_3429_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_3430_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_3431_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_3432_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_3433_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_3434_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A] :
          ( ( summable @ real
            @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F2 ) )
            @ ( suminf @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) ) ) ).

% summable_norm
thf(fact_3435_prod__int__eq,axiom,
    ! [I: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I @ J ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X3: int] : X3
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I ) @ ( semiring_1_of_nat @ int @ J ) ) ) ) ).

% prod_int_eq
thf(fact_3436_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X: A,Z2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) ) ) ) ) ).

% powser_inside
thf(fact_3437_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) ) ) ).

% summable_exp
thf(fact_3438_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_3439_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z2 @ N3 ) ) )
                @ Z2 ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_3440_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z2 @ N3 ) ) )
              @ Z2 )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_3441_prod__int__plus__eq,axiom,
    ! [I: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I @ ( plus_plus @ nat @ I @ J ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X3: int] : X3
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I @ J ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_3442_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R2: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( ( summable @ A @ F2 )
           => ? [N9: nat] :
              ! [N6: nat] :
                ( ( ord_less_eq @ nat @ N9 @ N6 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N6 ) ) ) )
                  @ R2 ) ) ) ) ) ).

% suminf_exist_split
thf(fact_3443_summable__power__series,axiom,
    ! [F2: nat > real,Z2: real] :
      ( ! [I2: nat] : ( ord_less_eq @ real @ ( F2 @ I2 ) @ ( one_one @ real ) )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I2 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z2 )
         => ( ( ord_less @ real @ Z2 @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( F2 @ I4 ) @ ( power_power @ real @ Z2 @ I4 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_3444_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R2: real,R0: real,A2: nat > A,M5: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R2 )
         => ( ( ord_less @ real @ R2 @ R0 )
           => ( ! [N2: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N2 ) ) @ ( power_power @ real @ R0 @ N2 ) ) @ M5 )
             => ( summable @ real
                @ ^ [N3: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R2 @ N3 ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_3445_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N4: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N2 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_3446_and__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_3447_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_not_iff_eq
thf(fact_3448_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_3449_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A5: set @ A,N: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A5 ) @ N )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X3: A] : ( power_power @ B @ ( F2 @ X3 ) @ N )
            @ A5 ) ) ) ).

% prod_power_distrib
thf(fact_3450_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ).

% prod_nonneg
thf(fact_3451_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A,G2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                & ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G2 @ I2 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) ) ) ).

% prod_mono
thf(fact_3452_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ).

% prod_pos
thf(fact_3453_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X2 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ).

% prod_ge_1
thf(fact_3454_sin__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X ) ) ).

% sin_paired
thf(fact_3455_vebt__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A4 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B4 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) )
                       => ( ( Xa != Mi3 )
                         => ( ( Xa != Ma3 )
                           => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                              & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                               => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                  & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                       => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(3)
thf(fact_3456_vebt__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( Y
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ( ! [V4: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ( ~ Y
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa ) ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ( ~ Y
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa ) ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( Y
                          = ( ( Xa != Mi3 )
                           => ( ( Xa != Ma3 )
                             => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                 => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                    & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(1)
thf(fact_3457_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M: nat,X: A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_3458_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( power_power @ A @ Z2 @ N3 ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_3459_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ B )
     => ! [A5: set @ A,F2: A > B] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ A5 )
             => ( member @ B @ ( F2 @ X2 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_sum
thf(fact_3460_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu3: B] : ( zero_zero @ A )
            @ A5 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_3461_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [F2: B > nat,A5: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A5 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : ( semiring_1_of_nat @ A @ ( F2 @ X3 ) )
            @ A5 ) ) ) ).

% of_nat_sum
thf(fact_3462_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: B > int,A5: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7311177749621191930dd_sum @ B @ int @ F2 @ A5 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : ( ring_1_of_int @ A @ ( F2 @ X3 ) )
            @ A5 ) ) ) ).

% of_int_sum
thf(fact_3463_sums__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( sums @ A
        @ ^ [N3: nat] : ( zero_zero @ A )
        @ ( zero_zero @ A ) ) ) ).

% sums_zero
thf(fact_3464_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A5: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A5 ) ) ) ).

% sum_abs
thf(fact_3465_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A5: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A5 ) ) ) ).

% sum_abs_ge_zero
thf(fact_3466_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) )
            @ X )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X ) ) ) ).

% powser_sums_zero_iff
thf(fact_3467_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G2 @ ( suc @ N ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_3468_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G2: nat > A,S: A,T2: A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G2 @ N2 ) )
         => ( ( sums @ A @ F2 @ S )
           => ( ( sums @ A @ G2 @ T2 )
             => ( ord_less_eq @ A @ S @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_3469_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: B > A,A5: set @ B] :
          ( ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
           != ( zero_zero @ A ) )
         => ~ ! [A4: B] :
                ( ( member @ B @ A4 @ A5 )
               => ( ( G2 @ A4 )
                  = ( zero_zero @ A ) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
thf(fact_3470_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ( G2 @ X2 )
                = ( zero_zero @ A ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.neutral
thf(fact_3471_sums__0,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( ! [N2: nat] :
              ( ( F2 @ N2 )
              = ( zero_zero @ A ) )
         => ( sums @ A @ F2 @ ( zero_zero @ A ) ) ) ) ).

% sums_0
thf(fact_3472_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,G2: B > real] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) @ ( G2 @ X2 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G2 @ S2 ) ) ) ) ).

% sum_norm_le
thf(fact_3473_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A5: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I4: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ I4 ) )
            @ A5 ) ) ) ).

% norm_sum
thf(fact_3474_sums__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F2: nat > A] :
          ( sums @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
          @ ( F2 @ I ) ) ) ).

% sums_single
thf(fact_3475_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K6: set @ B,F2: B > A,G2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ K6 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G2 @ I2 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K6 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ K6 ) ) ) ) ).

% sum_mono
thf(fact_3476_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_3477_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) ) ) ) ).

% sum_nonneg
thf(fact_3478_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ nat,F2: nat > A,G2: nat > A] :
          ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A5 )
         => ( ! [X2: nat] :
                ( ( member @ nat @ ( suc @ X2 ) @ A5 )
               => ( ( F2 @ ( suc @ X2 ) )
                  = ( G2 @ ( suc @ X2 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A5 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ A5 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_3479_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_3480_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_3481_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_3482_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
              @ S )
           => ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_Suc_imp
thf(fact_3483_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_3484_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ L )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_3485_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N: nat,F2: nat > A,S: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ N )
             => ( ( F2 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N ) )
              @ S )
            = ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_3486_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,I6: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M @ I4 ) )
            @ I6 )
          = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I6 ) ) ) ) ).

% sum_power_add
thf(fact_3487_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z2: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( if @ A @ ( N3 = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z2 @ N3 ) )
          @ ( power_power @ A @ Z2 @ M ) ) ) ).

% powser_sums_if
thf(fact_3488_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_3489_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_3490_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G2 @ ( suc @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_3491_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G2 @ ( suc @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_3492_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_3493_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G2 @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G2 @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_3494_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_3495_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A3: nat] : ( plus_plus @ A @ ( F2 @ A3 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_3496_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G2: nat > A,P6: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P6 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P6 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_3497_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,X: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I2 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I6 )
              = ( one_one @ B ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I6 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I2 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I4: A] : ( times_times @ B @ ( A2 @ I4 ) @ ( X @ I4 ) )
                      @ I6 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_3498_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K4: nat] : ( minus_minus @ A @ ( F2 @ K4 ) @ ( F2 @ ( plus_plus @ nat @ K4 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K4: nat] : ( minus_minus @ A @ ( F2 @ K4 ) @ ( F2 @ ( plus_plus @ nat @ K4 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_3499_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K4: nat] : ( minus_minus @ A @ ( F2 @ K4 ) @ ( F2 @ ( minus_minus @ nat @ K4 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_3500_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E2: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ~ ! [N9: nat] :
                  ~ ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ M3 )
                     => ! [N6: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M3 @ N6 ) ) ) @ E2 ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_3501_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_3502_power__half__series,axiom,
    ( sums @ real
    @ ^ [N3: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N3 ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_3503_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q6: nat] : ( ord_less @ nat @ Q6 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_3504_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_3505_sums__if_H,axiom,
    ! [G2: nat > real,X: real] :
      ( ( sums @ real @ G2 @ X )
     => ( sums @ real
        @ ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ real ) @ ( G2 @ ( divide_divide @ nat @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X ) ) ).

% sums_if'
thf(fact_3506_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q6: nat] : ( ord_less @ nat @ Q6 @ N ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_3507_gauss__sum__nat,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X3: nat] : X3
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_3508_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J3 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_3509_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_3510_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_3511_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I4 @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_3512_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_3513_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_3514_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_3515_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_3516_cos__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) @ ( power_power @ real @ X @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
      @ ( cos @ real @ X ) ) ).

% cos_paired
thf(fact_3517_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_3518_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ R2 @ K4 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K4 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R2 @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_3519_vebt__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_vebt_member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ~ ( ( Xa != Mi3 )
                     => ( ( Xa != Ma3 )
                       => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                           => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                              & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(2)
thf(fact_3520_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( Y
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
                 => ( ( Y
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_3521_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_3522_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A4 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B4 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_3523_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ~ Y
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) ) )
           => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( Y
                      = ( ( Xa = Mi3 )
                        | ( Xa = Ma3 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) ) ) )
             => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                   => ( ( Y
                        = ( ( Xa = Mi3 )
                          | ( Xa = Ma3 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) ) ) )
               => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                     => ( ( Y
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_3524_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) )
           => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
                   => ( ( Xa = Mi3 )
                      | ( Xa = Ma3 ) ) ) )
             => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) )
                     => ( ( Xa = Mi3 )
                        | ( Xa = Ma3 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
               => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_3525_int__sum,axiom,
    ! [B: $tType,F2: B > nat,A5: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A5 ) )
      = ( groups7311177749621191930dd_sum @ B @ int
        @ ^ [X3: B] : ( semiring_1_of_nat @ int @ ( F2 @ X3 ) )
        @ A5 ) ) ).

% int_sum
thf(fact_3526_Complex__sum_H,axiom,
    ! [A: $tType,F2: A > real,S: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X3: A] : ( complex2 @ ( F2 @ X3 ) @ ( zero_zero @ real ) )
        @ S )
      = ( complex2 @ ( groups7311177749621191930dd_sum @ A @ real @ F2 @ S ) @ ( zero_zero @ real ) ) ) ).

% Complex_sum'
thf(fact_3527_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A5: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A5 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A3: B] : ( power_power @ A @ C2 @ ( F2 @ A3 ) )
            @ A5 ) ) ) ).

% power_sum
thf(fact_3528_sum__subtractf__nat,axiom,
    ! [A: $tType,A5: set @ A,G2: A > nat,F2: A > nat] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A5 )
         => ( ord_less_eq @ nat @ ( G2 @ X2 ) @ ( F2 @ X2 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X3: A] : ( minus_minus @ nat @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
          @ A5 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G2 @ A5 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_3529_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A5: set @ A,N: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 )
        = ( suc @ N ) )
     => ? [X2: A] :
          ( ( member @ A @ X2 @ A5 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X2 ) ) ) ) ).

% sum_SucD
thf(fact_3530_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X3: complex] : X3
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_3531_norm__prod__diff,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I6: set @ I7,Z2: I7 > A,W2: I7 > A] :
          ( ! [I2: I7] :
              ( ( member @ I7 @ I2 @ I6 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z2 @ I2 ) ) @ ( one_one @ real ) ) )
         => ( ! [I2: I7] :
                ( ( member @ I7 @ I2 @ I6 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W2 @ I2 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I7 @ A @ Z2 @ I6 ) @ ( groups7121269368397514597t_prod @ I7 @ A @ W2 @ I6 ) ) )
              @ ( groups7311177749621191930dd_sum @ I7 @ real
                @ ^ [I4: I7] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z2 @ I4 ) @ ( W2 @ I4 ) ) )
                @ I6 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_3532_sum__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X3: complex] : X3
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_3533_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X3: int] : X3
          @ ( set_or1337092689740270186AtMost @ int @ M @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_3534_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Mi3: nat,Ma3: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
               => ~ ( ( Xa = Mi3 )
                    | ( Xa = Ma3 ) ) ) )
         => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc2 ) @ Xa ) )
                 => ~ ( ( Xa = Mi3 )
                      | ( Xa = Ma3 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
           => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_3535_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ? [T3: real] :
            ( ( ord_less @ real @ X @ T3 )
            & ( ord_less @ real @ T3 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( cos_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_3536_Maclaurin__cos__expansion2,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
            & ( ord_less @ real @ T3 @ X )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( cos_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_3537_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ? [T3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
            & ( ord_less @ real @ T3 @ X )
            & ( ( sin @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_3538_Maclaurin__sin__expansion4,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ? [T3: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
          & ( ord_less_eq @ real @ T3 @ X )
          & ( ( sin @ real @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_3539_Maclaurin__cos__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
      & ( ( cos @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M2: nat] : ( times_times @ real @ ( cos_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_3540_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I @ K ) ) ) ).

% lessThan_iff
thf(fact_3541_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X ) @ ( set_ord_lessThan @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% lessThan_subset_iff
thf(fact_3542_sumr__cos__zero__one,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M2: nat] : ( times_times @ real @ ( cos_coeff @ M2 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M2 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_3543_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X3: A] : ( ord_less @ A @ X3 @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_3544_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N ) )
          = ( ord_less @ A @ M @ N ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_3545_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N: A] :
          ( ! [X2: A] : ( ord_less_eq @ nat @ ( Q @ X2 ) @ ( P @ X2 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X3: A] : ( minus_minus @ nat @ ( P @ X3 ) @ ( Q @ X3 ) )
              @ ( set_ord_lessThan @ A @ N ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_3546_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ X )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X ) ) ) ) ).

% suminf_le_const
thf(fact_3547_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_3548_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N: nat,R2: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ R2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ R2 )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_3549_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_3550_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_3551_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ X )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_3552_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_3553_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( G2 @ ( suc @ K4 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_3554_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K4: nat] : ( G2 @ ( suc @ K4 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_3555_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_3556_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_3557_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_3558_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N @ M4 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_3559_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_3560_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z2: A,H: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P5: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ ( minus_minus @ nat @ M @ P5 ) ) @ ( power_power @ A @ Z2 @ P5 ) ) @ ( power_power @ A @ Z2 @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P5: nat] : ( times_times @ A @ ( power_power @ A @ Z2 @ P5 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ ( minus_minus @ nat @ M @ P5 ) ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ M @ P5 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_3561_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N ) ) @ ( power_power @ A @ Y @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P5: nat] : ( times_times @ A @ ( power_power @ A @ X @ P5 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ P5 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_3562_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) ) @ ( power_power @ A @ X @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_3563_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,F2: nat > A,K6: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K6 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K6 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ K6 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_3564_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat,I: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N @ M4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ( ord_less_eq @ nat @ N @ I )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_3565_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_3566_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: real,N: nat,Diff: nat > A > real] :
          ( ( X
            = ( zero_zero @ real ) )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_3567_Maclaurin__lemma,axiom,
    ! [H: real,F2: real > real,J: nat > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ? [B8: real] :
          ( ( F2 @ H )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J @ M2 ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ H @ M2 ) )
              @ ( set_ord_lessThan @ nat @ N ) )
            @ ( times_times @ real @ B8 @ ( divide_divide @ real @ ( power_power @ real @ H @ N ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_3568_Maclaurin__exp__le,axiom,
    ! [X: real,N: nat] :
    ? [T3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
      & ( ( exp @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M2: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M2 ) @ ( semiring_char_0_fact @ real @ M2 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_3569_Maclaurin__sin__bound,axiom,
    ! [X: real,N: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( abs_abs @ real @ X ) @ N ) ) ) ).

% Maclaurin_sin_bound
thf(fact_3570_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D4: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_3571_Maclaurin__exp__lt,axiom,
    ! [X: real,N: nat] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T3 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
            & ( ( exp @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M2 ) @ ( semiring_char_0_fact @ real @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_3572_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H: A,Z2: A,N: nat] :
          ( ( H
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ N ) @ ( power_power @ A @ Z2 @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P5: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q6: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ Q6 ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q6 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ P5 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_3573_Maclaurin__sin__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T3: real] :
      ( ( sin @ real @ X )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_3574_Maclaurin__sin__expansion2,axiom,
    ! [X: real,N: nat] :
    ? [T3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
      & ( ( sin @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M2: nat] : ( times_times @ real @ ( sin_coeff @ M2 ) @ ( power_power @ real @ X @ M2 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T3 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_3575_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( C2 @ N3 ) ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_3576_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K4 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_3577_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_3578_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_3579_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_3580_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I @ K ) ) ) ).

% atMost_iff
thf(fact_3581_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X ) @ ( set_ord_atMost @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% atMost_subset_iff
thf(fact_3582_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H: A,H2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) @ ( set_ord_atMost @ A @ H2 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H )
            | ( ord_less_eq @ A @ H @ H2 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_3583_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X3: A] : ( ord_less_eq @ A @ X3 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_3584_atMost__atLeast0,axiom,
    ( ( set_ord_atMost @ nat )
    = ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) ) ) ).

% atMost_atLeast0
thf(fact_3585_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H: A,L3: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H2 ) ) ) ).

% not_Iic_le_Icc
thf(fact_3586_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_3587_exp__fdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( diffs @ A
          @ ^ [N3: nat] : ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N3 ) ) )
        = ( ^ [N3: nat] : ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N3 ) ) ) ) ) ).

% exp_fdiffs
thf(fact_3588_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C5: nat > A,N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( C5 @ ( suc @ N3 ) ) ) ) ) ) ).

% diffs_def
thf(fact_3589_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_3590_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ ( F2 @ ( suc @ I4 ) ) )
            @ ( set_ord_atMost @ nat @ I ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I ) ) ) ) ) ).

% sum_telescope
thf(fact_3591_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,D2: nat > A] :
          ( ( ! [X3: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X3 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( D2 @ I4 ) @ ( power_power @ A @ X3 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
               => ( ( C2 @ I4 )
                  = ( D2 @ I4 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_3592_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B6: A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N2 ) )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N2 ) ) @ B6 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_3593_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_3594_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [X2: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_3595_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N: nat,K: nat] :
          ( ! [W: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_3596_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( ! [X3: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X3 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
               => ( ( C2 @ I4 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_3597_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_3598_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_3599_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K4 ) ) @ K4 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_3600_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K4: nat] : ( binomial @ ( minus_minus @ nat @ N @ K4 ) @ ( minus_minus @ nat @ M @ K4 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_3601_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_3602_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) )
         => ~ ! [B4: nat > A] :
                ~ ! [Z4: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( B4 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                        @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_3603_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N: nat,A2: A] :
        ? [B4: nat > A] :
        ! [Z4: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( B4 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_3604_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_3605_choose__row__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N ) @ ( set_ord_atMost @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% choose_row_sum
thf(fact_3606_binomial,axiom,
    ! [A2: nat,B2: nat,N: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K4: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N @ K4 ) ) @ ( power_power @ nat @ A2 @ K4 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N @ K4 ) ) )
        @ ( set_ord_atMost @ nat @ N ) ) ) ).

% binomial
thf(fact_3607_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N: nat,B2: nat > A,X: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ M @ I2 )
             => ( ( A2 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ! [J2: nat] :
                ( ( ord_less @ nat @ N @ J2 )
               => ( ( B2 @ J2 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J3: nat] : ( times_times @ A @ ( B2 @ J3 ) @ ( power_power @ A @ X @ J3 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K4: nat] : ( times_times @ A @ ( A2 @ K4 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K4 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_3608_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,K: A] :
          ( ( ! [X3: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X3 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X3: nat] :
                ( ( member @ nat @ X3 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) )
               => ( ( C2 @ X3 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_3609_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K4 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_3610_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K4 ) ) @ ( power_power @ A @ A2 @ K4 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_3611_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K4 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K4 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_3612_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N: nat,B2: nat > nat,X: nat] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ M @ I2 )
         => ( ( A2 @ I2 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J2: nat] :
            ( ( ord_less @ nat @ N @ J2 )
           => ( ( B2 @ J2 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( power_power @ nat @ X @ I4 ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J3: nat] : ( times_times @ nat @ ( B2 @ J3 ) @ ( power_power @ nat @ X @ J3 ) )
              @ ( set_ord_atMost @ nat @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K4: nat] : ( times_times @ nat @ ( A2 @ K4 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K4 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_3613_choose__square__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K4: nat] : ( power_power @ nat @ ( binomial @ N @ K4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% choose_square_sum
thf(fact_3614_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,K6: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K6 )
         => ( ! [X2: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K6 )
               => ( summable @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) )
           => ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_3615_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P6: nat,K: nat,G2: nat > A,H: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P6 )
         => ( ( ord_less_eq @ nat @ K @ P6 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G2 @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( zero_zero @ A ) @ ( H @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P6 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G2 @ J3 ) @ ( H @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P6 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_3616_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P6: nat,K: nat,G2: nat > A,H: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P6 )
         => ( ( ord_less_eq @ nat @ K @ P6 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G2 @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( one_one @ A ) @ ( H @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P6 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G2 @ J3 ) @ ( H @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P6 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_3617_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K4 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K4 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_3618_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,Z2: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( ( power_power @ A @ Z2 @ N )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I4
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I4 = N ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_3619_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_3620_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_3621_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K4 ) ) @ K4 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K4 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_3622_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K4 ) @ A2 ) @ ( one_one @ A ) ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_3623_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J3 @ K4 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y @ K4 ) ) @ ( power_power @ A @ X @ J3 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ J3 ) ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_3624_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_3625_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( times_times @ nat @ I4 @ ( binomial @ N @ I4 ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_3626_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_3627_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E2: real,C2: nat > A,N: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ? [M10: real] :
            ! [Z4: A] :
              ( ( ord_less_eq @ real @ M10 @ ( real_V7770717601297561774m_norm @ A @ Z4 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N ) ) )
                @ ( times_times @ real @ E2 @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ ( suc @ N ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_3628_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ ( minus_minus @ nat @ I4 @ J3 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
                    @ ( power_power @ A @ X @ J3 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_3629_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) ) @ ( power_power @ A @ X @ N3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P5 @ N3 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ).

% sin_x_sin_y
thf(fact_3630_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ A @ X @ N3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P5 @ N3 ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_3631_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ A @ X @ N3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P5 @ N3 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ).

% cos_x_cos_y
thf(fact_3632_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X3: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X3 )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X3 @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_3633_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M4: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N2 )
             => ( ord_less_eq @ A @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI1
thf(fact_3634_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N3: nat] : N3 ) ) ).

% of_nat_id
thf(fact_3635_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_right
thf(fact_3636_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,B2: real] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( ( A2 = B2 )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_cancel_right
thf(fact_3637_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
          = ( ( X = Y )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_cancel_left
thf(fact_3638_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( zero_zero @ real ) @ X )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_left
thf(fact_3639_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ real ) )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_eq_0_iff
thf(fact_3640_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: real,Y: A,N: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Y ) @ N )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X @ N ) @ ( power_power @ A @ Y @ N ) ) ) ) ).

% scaleR_power
thf(fact_3641_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,A2: real,B2: real] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
              = ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
thf(fact_3642_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
              = ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
           => ( X = Y ) ) ) ) ).

% scaleR_left_imp_eq
thf(fact_3643_inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: real,X: A] :
          ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
          = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A2 ) @ ( inverse_inverse @ A @ X ) ) ) ) ).

% inverse_scaleR_distrib
thf(fact_3644_complex__sgn__def,axiom,
    ( ( sgn_sgn @ complex )
    = ( ^ [X3: complex] : ( real_V8093663219630862766scaleR @ complex @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ complex @ X3 ) ) @ X3 ) ) ) ).

% complex_sgn_def
thf(fact_3645_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3646_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3647_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3648_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3649_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3650_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3651_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3652_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,U: real,V2: real,A2: A] :
          ( ( X
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V2 ) @ A2 ) )
          = ( ( ( V2
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V2
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V2 @ X )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_3653_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V2: real,A2: A,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V2 ) @ A2 )
            = X )
          = ( ( ( V2
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V2
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V2 @ X ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_3654_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3655_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3656_sgn__div__norm,axiom,
    ! [A: $tType] :
      ( ( real_V6567297691418259687v_norm @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) ) @ X3 ) ) ) ) ).

% sgn_div_norm
thf(fact_3657_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3658_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3659_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3660_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3661_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3662_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3663_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3664_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3665_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3666_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A,Y: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3667_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ X ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3668_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y: A,X: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3669_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X: A,C2: A,Y: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 )
              = Y )
            = ( X
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3670_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3671_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3672_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3673_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3674_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3675_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3676_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3677_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3678_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: real,X: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
              = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A2 ) @ ( inverse_inverse @ A @ X ) ) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
thf(fact_3679_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) ) ) ).

% summable_exp_generic
thf(fact_3680_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X @ N3 ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_converges
thf(fact_3681_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X3: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) ) ) ) ) ).

% sin_def
thf(fact_3682_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X @ N3 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_converges
thf(fact_3683_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X3: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) ) ) ) ) ).

% cos_def
thf(fact_3684_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ).

% summable_norm_sin
thf(fact_3685_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ).

% summable_norm_cos
thf(fact_3686_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3687_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3688_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3689_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3690_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3691_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3692_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3693_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3694_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) )
          @ ( exp @ A @ X ) ) ) ).

% exp_converges
thf(fact_3695_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X3: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X3 @ N3 ) ) ) ) ) ) ).

% exp_def
thf(fact_3696_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ).

% summable_norm_exp
thf(fact_3697_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N3 ) ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_minus_converges
thf(fact_3698_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N3 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_minus_converges
thf(fact_3699_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ ( uminus_uminus @ A @ X3 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3700_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ ( uminus_uminus @ A @ X3 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3701_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I4 ) ) @ ( power_power @ A @ X @ I4 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ I4 ) ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ I4 ) ) ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_3702_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X3: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N3 ) ) ) @ ( power_power @ A @ X3 @ ( suc @ N3 ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_3703_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X3: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X3 @ N3 ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N3 @ K ) ) ) @ ( power_power @ A @ X3 @ ( plus_plus @ nat @ N3 @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_3704_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X ) ) ) ).

% cosh_converges
thf(fact_3705_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) )
          @ ( sinh @ A @ X ) ) ) ).

% sinh_converges
thf(fact_3706_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X7: nat > A] :
              ( ! [N3: nat] : ( ord_less_eq @ A @ ( X7 @ N3 ) @ ( X7 @ ( suc @ N3 ) ) )
              | ! [N3: nat] : ( ord_less_eq @ A @ ( X7 @ ( suc @ N3 ) ) @ ( X7 @ N3 ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_3707_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N2 ) ) @ ( X8 @ N2 ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI2
thf(fact_3708_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( X8 @ N2 ) @ ( X8 @ ( suc @ N2 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI1
thf(fact_3709_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X7: nat > A] :
              ( ! [M2: nat,N3: nat] :
                  ( ( ord_less_eq @ nat @ M2 @ N3 )
                 => ( ord_less_eq @ A @ ( X7 @ M2 ) @ ( X7 @ N3 ) ) )
              | ! [M2: nat,N3: nat] :
                  ( ( ord_less_eq @ nat @ M2 @ N3 )
                 => ( ord_less_eq @ A @ ( X7 @ N3 ) @ ( X7 @ M2 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_3710_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M4: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N2 )
             => ( ord_less_eq @ A @ ( X8 @ N2 ) @ ( X8 @ M4 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI2
thf(fact_3711_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I4: A] : ( plus_plus @ A @ I4 @ ( one_one @ A ) )
              @ N3
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_3712_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T4: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T4 ) ) ) ) ).

% set_vebt_def
thf(fact_3713_vebt__buildup_Opelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X )
       => ( ( ( X
              = ( zero_zero @ nat ) )
           => ( ( Y
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va: nat] :
                  ( ( X
                    = ( suc @ ( suc @ Va ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_3714_arctan__def,axiom,
    ( arctan
    = ( ^ [Y4: real] :
          ( the @ real
          @ ^ [X3: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
              & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X3 )
                = Y4 ) ) ) ) ) ).

% arctan_def
thf(fact_3715_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N: nat,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N ) @ I )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N @ ( Inc @ I ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_3716_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I )
          = I ) ) ).

% of_nat_aux.simps(1)
thf(fact_3717_ln__neg__is__const,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X )
        = ( the @ real
          @ ^ [X3: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_3718_arccos__def,axiom,
    ( arccos
    = ( ^ [Y4: real] :
          ( the @ real
          @ ^ [X3: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
              & ( ord_less_eq @ real @ X3 @ pi )
              & ( ( cos @ real @ X3 )
                = Y4 ) ) ) ) ) ).

% arccos_def
thf(fact_3719_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X3 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_3720_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X3 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_3721_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y4: real] :
          ( the @ real
          @ ^ [X3: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
              & ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X3 )
                = Y4 ) ) ) ) ) ).

% arcsin_def
thf(fact_3722_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L4: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q6: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L4 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L4 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q6 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_3723_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys3 )
              = N )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% set_n_lists
thf(fact_3724_pred__subset__eq,axiom,
    ! [A: $tType,R4: set @ A,S2: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X3: A] : ( member @ A @ X3 @ R4 )
        @ ^ [X3: A] : ( member @ A @ X3 @ S2 ) )
      = ( ord_less_eq @ ( set @ A ) @ R4 @ S2 ) ) ).

% pred_subset_eq
thf(fact_3725_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L4: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q6: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L4 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L4 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q6 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_3726_split__cong,axiom,
    ! [C: $tType,B: $tType,A: $tType,Q4: product_prod @ A @ B,F2: A > B > C,G2: A > B > C,P6: product_prod @ A @ B] :
      ( ! [X2: A,Y2: B] :
          ( ( ( product_Pair @ A @ B @ X2 @ Y2 )
            = Q4 )
         => ( ( F2 @ X2 @ Y2 )
            = ( G2 @ X2 @ Y2 ) ) )
     => ( ( P6 = Q4 )
       => ( ( product_case_prod @ A @ B @ C @ F2 @ P6 )
          = ( product_case_prod @ A @ B @ C @ G2 @ Q4 ) ) ) ) ).

% split_cong
thf(fact_3727_subrelI,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ! [X2: A,Y2: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R2 )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S ) ) ).

% subrelI
thf(fact_3728_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X3: A,Y4: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ R4 )
        @ ^ [X3: A,Y4: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ S2 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R4 @ S2 ) ) ).

% pred_subset_eq2
thf(fact_3729_length__n__lists__elem,axiom,
    ! [A: $tType,Ys2: list @ A,N: nat,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys2 )
        = N ) ) ).

% length_n_lists_elem
thf(fact_3730_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L4: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q6: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L4 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L4 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q6 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_3731_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N @ Xs ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_n_lists
thf(fact_3732_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M2: nat,N3: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N3
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M2 @ N3 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M2 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q6: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q6 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M2 @ N3 ) @ N3 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_3733_rat__inverse__code,axiom,
    ! [P6: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P6 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A3: int,B3: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A3
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A3 ) @ B3 ) @ ( abs_abs @ int @ A3 ) ) )
        @ ( quotient_of @ P6 ) ) ) ).

% rat_inverse_code
thf(fact_3734_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_3735_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Q: A > B > $o] :
      ( ! [X2: A,Y2: B] :
          ( ( P @ X2 @ Y2 )
         => ( Q @ X2 @ Y2 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) ).

% predicate2I
thf(fact_3736_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_3737_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P5: rat,Q6: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A3: int,C5: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D6: int] : ( ord_less @ int @ ( times_times @ int @ A3 @ D6 ) @ ( times_times @ int @ C5 @ B3 ) )
              @ ( quotient_of @ Q6 ) )
          @ ( quotient_of @ P5 ) ) ) ) ).

% rat_less_code
thf(fact_3738_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P5: rat,Q6: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A3: int,C5: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D6: int] : ( ord_less_eq @ int @ ( times_times @ int @ A3 @ D6 ) @ ( times_times @ int @ C5 @ B3 ) )
              @ ( quotient_of @ Q6 ) )
          @ ( quotient_of @ P5 ) ) ) ) ).

% rat_less_eq_code
thf(fact_3739_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Y: B,Q: A > B > $o] :
      ( ( P @ X @ Y )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X @ Y ) ) ) ).

% rev_predicate2D
thf(fact_3740_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,X: A,Y: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X @ Y )
       => ( Q @ X @ Y ) ) ) ).

% predicate2D
thf(fact_3741_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q6: rat,R5: rat] : ( times_times @ rat @ Q6 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_3742_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G2 )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G2 @ I4 @ ( minus_minus @ nat @ K4 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K4 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_3743_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G2 )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K4: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G2 @ I4 @ ( minus_minus @ nat @ K4 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K4 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_3744_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G2 )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G2 @ I4 @ ( minus_minus @ nat @ K4 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K4 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.triangle_reindex
thf(fact_3745_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G2 )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K4: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G2 @ I4 @ ( minus_minus @ nat @ K4 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K4 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.triangle_reindex
thf(fact_3746_quotient__of__denom__pos,axiom,
    ! [R2: rat,P6: int,Q4: int] :
      ( ( ( quotient_of @ R2 )
        = ( product_Pair @ int @ int @ P6 @ Q4 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q4 ) ) ).

% quotient_of_denom_pos
thf(fact_3747_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q6: int,R5: int] :
          ( plus_plus @ int @ Q6
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_3748_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M2: nat,Q6: nat] :
                    ( if @ A
                    @ ( Q6
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M2 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_3749_accp__subset,axiom,
    ! [A: $tType,R1: A > A > $o,R22: A > A > $o] :
      ( ( ord_less_eq @ ( A > A > $o ) @ R1 @ R22 )
     => ( ord_less_eq @ ( A > $o ) @ ( accp @ A @ R22 ) @ ( accp @ A @ R1 ) ) ) ).

% accp_subset
thf(fact_3750_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D6: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z7: int,Z5: int] :
                ( ( ord_less_eq @ int @ D6 @ Z5 )
                & ( ord_less @ int @ Z7 @ Z5 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_3751_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D6: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z7: int,Z5: int] :
                ( ( ord_less_eq @ int @ D6 @ Z7 )
                & ( ord_less @ int @ Z7 @ Z5 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_3752_less__eq__rat__def,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [X3: rat,Y4: rat] :
          ( ( ord_less @ rat @ X3 @ Y4 )
          | ( X3 = Y4 ) ) ) ) ).

% less_eq_rat_def
thf(fact_3753_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A3: rat] :
          ( if @ rat
          @ ( A3
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A3 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_3754_obtain__pos__sum,axiom,
    ! [R2: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
     => ~ ! [S3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S3 )
           => ! [T3: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T3 )
               => ( R2
                 != ( plus_plus @ rat @ S3 @ T3 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_3755_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A3: rat] : ( if @ rat @ ( ord_less @ rat @ A3 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A3 ) @ A3 ) ) ) ).

% abs_rat_def
thf(fact_3756_accp__subset__induct,axiom,
    ! [A: $tType,D5: A > $o,R4: A > A > $o,X: A,P: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ D5 @ ( accp @ A @ R4 ) )
     => ( ! [X2: A,Z3: A] :
            ( ( D5 @ X2 )
           => ( ( R4 @ Z3 @ X2 )
             => ( D5 @ Z3 ) ) )
       => ( ( D5 @ X )
         => ( ! [X2: A] :
                ( ( D5 @ X2 )
               => ( ! [Z4: A] :
                      ( ( R4 @ Z4 @ X2 )
                     => ( P @ Z4 ) )
                 => ( P @ X2 ) ) )
           => ( P @ X ) ) ) ) ) ).

% accp_subset_induct
thf(fact_3757_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F2: nat > A > A,A2: nat,B2: nat,Acc2: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A2 @ ( product_Pair @ nat @ A @ B2 @ Acc2 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = Acc2 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = ( set_fo6178422350223883121st_nat @ A @ F2 @ ( plus_plus @ nat @ A2 @ ( one_one @ nat ) ) @ B2 @ ( F2 @ A2 @ Acc2 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_3758_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb3: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb3 @ Xc )
        = Y )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb3 @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb3 @ Xa )
               => ( Y = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb3 @ Xa )
               => ( Y
                  = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb3 @ ( X @ Xa @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb3 @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_3759_in__measure,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ).

% in_measure
thf(fact_3760_Collect__case__prod__mono,axiom,
    ! [B: $tType,A: $tType,A5: A > B > $o,B6: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A5 ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ B6 ) ) ) ) ).

% Collect_case_prod_mono
thf(fact_3761_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A12: nat,A23: nat,A32: A,P: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A12 @ ( product_Pair @ nat @ A @ A23 @ A32 ) ) ) )
     => ( ! [F5: nat > A > A,A4: nat,B4: nat,Acc3: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F5 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A4 @ ( product_Pair @ nat @ A @ B4 @ Acc3 ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B4 @ A4 )
               => ( P @ F5 @ ( plus_plus @ nat @ A4 @ ( one_one @ nat ) ) @ B4 @ ( F5 @ A4 @ Acc3 ) ) )
             => ( P @ F5 @ A4 @ B4 @ Acc3 ) ) )
       => ( P @ A0 @ A12 @ A23 @ A32 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_3762_upto_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [I2: int,J2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J2 ) )
           => ( ( ( ord_less_eq @ int @ I2 @ J2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J2 ) )
             => ( P @ I2 @ J2 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% upto.pinduct
thf(fact_3763_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_3764_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_3765_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_3766_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_3767_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,J: A,M: A,N: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ J ) @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
          = ( ( ord_less_eq @ A @ J @ I )
            | ( ( ord_less_eq @ A @ M @ I )
              & ( ord_less_eq @ A @ J @ N ) ) ) ) ) ).

% ivl_subset
thf(fact_3768_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,N: A,M: A] :
          ( ( ord_less_eq @ A @ I @ N )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ M ) @ ( set_or7035219750837199246ssThan @ A @ I @ N ) )
            = ( set_or7035219750837199246ssThan @ A @ N @ M ) ) ) ) ).

% ivl_diff
thf(fact_3769_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G2 @ N ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_3770_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G2 @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_3771_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_3772_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_3773_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_3774_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_3775_all__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M2: nat] :
            ( ( ord_less @ nat @ M2 @ N )
           => ( P @ M2 ) ) )
      = ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X3 ) ) ) ) ).

% all_nat_less_eq
thf(fact_3776_ex__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M2: nat] :
            ( ( ord_less @ nat @ M2 @ N )
            & ( P @ M2 ) ) )
      = ( ? [X3: nat] :
            ( ( member @ nat @ X3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X3 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_3777_lessThan__atLeast0,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) ) ) ).

% lessThan_atLeast0
thf(fact_3778_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G2: B > A,H: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X2: B] :
                  ( ( ord_less_eq @ B @ C2 @ X2 )
                 => ( ( ord_less @ B @ X2 @ D2 )
                   => ( ( G2 @ X2 )
                      = ( H @ X2 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_3779_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G2: B > A,H: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X2: B] :
                  ( ( ord_less_eq @ B @ C2 @ X2 )
                 => ( ( ord_less @ B @ X2 @ D2 )
                   => ( ( G2 @ X2 )
                      = ( H @ X2 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_3780_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,P6: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P6 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ N @ P6 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P6 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_3781_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,P6: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P6 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P6 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N @ P6 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_3782_size__list__estimation,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation
thf(fact_3783_size__list__estimation_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less_eq @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation'
thf(fact_3784_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > nat,G2: A > nat] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ nat @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ G2 @ Xs ) ) ) ).

% size_list_pointwise
thf(fact_3785_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,P6: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P6 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ N @ P6 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P6 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_3786_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_3787_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_3788_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_3789_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G2 @ N ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_3790_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_3791_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G2 @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_3792_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G2 @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_3793_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( times_times @ A @ ( G2 @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_3794_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G2 @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_3795_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G2 @ N ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_3796_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G2 @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_3797_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_3798_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I4 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( A2 @ I4 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sum.nested_swap
thf(fact_3799_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I4 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( A2 @ I4 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% prod.nested_swap
thf(fact_3800_prod__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_fact
thf(fact_3801_prod__Suc__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_Suc_fact
thf(fact_3802_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G2 @ N ) ) ) ) ) ) ).

% sum.head_if
thf(fact_3803_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G2 @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_3804_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_3805_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_3806_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_3807_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N7: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ M2 )
                 => ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N3 ) ) ) @ E3 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_3808_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X21: A,X22: list @ A] :
      ( ( size_list @ A @ X @ ( cons @ A @ X21 @ X22 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X @ X21 ) @ ( size_list @ A @ X @ X22 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_3809_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S: A,K: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ K ) @ K ) ) )
              @ S ) ) ) ) ).

% sums_group
thf(fact_3810_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K4: nat] : ( bit_se4730199178511100633sh_bit @ A @ K4 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A3 @ K4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ).

% take_bit_sum
thf(fact_3811_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_3812_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_3813_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K4: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K4 @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K4 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_3814_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_3815_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_3816_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K4: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K4 ) )
              @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_3817_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F3 @ ( nth @ B @ Xs3 @ N3 ) ) @ ( power_power @ A @ A3 @ N3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_3818_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: nat > A,B2: nat > A] :
          ( ! [I2: nat,J2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ J2 )
             => ( ( ord_less @ nat @ J2 @ N )
               => ( ord_less_eq @ A @ ( A2 @ I2 ) @ ( A2 @ J2 ) ) ) )
         => ( ! [I2: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I2 @ J2 )
               => ( ( ord_less @ nat @ J2 @ N )
                 => ( ord_less_eq @ A @ ( B2 @ J2 ) @ ( B2 @ I2 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K4: nat] : ( times_times @ A @ ( A2 @ K4 ) @ ( B2 @ K4 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_3819_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J2 )
         => ( ( ord_less @ nat @ J2 @ N )
           => ( ord_less_eq @ nat @ ( A2 @ I2 ) @ ( A2 @ J2 ) ) ) )
     => ( ! [I2: nat,J2: nat] :
            ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ( ord_less @ nat @ J2 @ N )
             => ( ord_less_eq @ nat @ ( B2 @ J2 ) @ ( B2 @ I2 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( B2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_3820_int__of__nat__def,axiom,
    ( code_T6385005292777649522of_nat
    = ( semiring_1_of_nat @ int ) ) ).

% int_of_nat_def
thf(fact_3821_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L4: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q6: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L4 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L4 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q6 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_3822_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_3823_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( minus_minus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% minus_integer_code(1)
thf(fact_3824_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_3825_times__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_3826_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_3827_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = L ) ).

% plus_integer_code(2)
thf(fact_3828_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( minus_minus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( uminus_uminus @ code_integer @ L ) ) ).

% minus_integer_code(2)
thf(fact_3829_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K4: code_integer] :
          ( if @ code_integer
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_3830_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rsp
thf(fact_3831_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) ) ).

% zero_integer.rsp
thf(fact_3832_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K4: int] :
          ( if @ code_integer @ ( ord_less @ int @ K4 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K4 ) ) )
          @ ( if @ code_integer
            @ ( K4
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_3833_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A3: complex,B3: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A3 @ ( cnj @ B3 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_3834_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_3835_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y )
     => ( ( ( ord_less_eq @ nat @ Xa @ X )
         => ( Y
            = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa @ X )
         => ( Y
            = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_3836_complex__cnj__of__nat,axiom,
    ! [N: nat] :
      ( ( cnj @ ( semiring_1_of_nat @ complex @ N ) )
      = ( semiring_1_of_nat @ complex @ N ) ) ).

% complex_cnj_of_nat
thf(fact_3837_complex__cnj__zero__iff,axiom,
    ! [Z2: complex] :
      ( ( ( cnj @ Z2 )
        = ( zero_zero @ complex ) )
      = ( Z2
        = ( zero_zero @ complex ) ) ) ).

% complex_cnj_zero_iff
thf(fact_3838_complex__cnj__zero,axiom,
    ( ( cnj @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% complex_cnj_zero
thf(fact_3839_complex__cnj__power,axiom,
    ! [X: complex,N: nat] :
      ( ( cnj @ ( power_power @ complex @ X @ N ) )
      = ( power_power @ complex @ ( cnj @ X ) @ N ) ) ).

% complex_cnj_power
thf(fact_3840_complex__cnj__inverse,axiom,
    ! [X: complex] :
      ( ( cnj @ ( inverse_inverse @ complex @ X ) )
      = ( inverse_inverse @ complex @ ( cnj @ X ) ) ) ).

% complex_cnj_inverse
thf(fact_3841_zero__integer__def,axiom,
    ( ( zero_zero @ code_integer )
    = ( code_integer_of_int @ ( zero_zero @ int ) ) ) ).

% zero_integer_def
thf(fact_3842_less__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( ord_less @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( ord_less @ int @ Xa @ X ) ) ).

% less_integer.abs_eq
thf(fact_3843_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_3844_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K4: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K4 ) @ K4 ) ) ) ).

% abs_integer_code
thf(fact_3845_uminus__integer__code_I1_J,axiom,
    ( ( uminus_uminus @ code_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ code_integer ) ) ).

% uminus_integer_code(1)
thf(fact_3846_less__eq__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( ord_less_eq @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( ord_less_eq @ int @ Xa @ X ) ) ).

% less_eq_integer.abs_eq
thf(fact_3847_complex__mod__mult__cnj,axiom,
    ! [Z2: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_3848_complex__norm__square,axiom,
    ! [Z2: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) ) ).

% complex_norm_square
thf(fact_3849_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K4: nat,M2: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M2 @ K4 ) @ ( product_Pair @ nat @ nat @ M2 @ ( minus_minus @ nat @ K4 @ M2 ) ) @ ( nat_prod_decode_aux @ ( suc @ K4 ) @ ( minus_minus @ nat @ M2 @ ( suc @ K4 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_3850_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa @ X )
               => ( Y
                  = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa @ X )
               => ( Y
                  = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_3851_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K4: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K4 ) ) )
          @ ( if @ int
            @ ( K4
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L4: code_integer,J3: code_integer] :
                  ( if @ int
                  @ ( J3
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L4 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L4 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_3852_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K4: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K4 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L4: code_integer,J3: code_integer] :
                ( if @ num
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L4 ) @ ( code_num_of_integer @ L4 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L4 ) @ ( code_num_of_integer @ L4 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_3853_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A5: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A5 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A5 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A5 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_3854_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list @ A] : ( finite_finite @ A @ ( set2 @ A @ Xs ) ) ).

% List.finite_set
thf(fact_3855_int__of__integer__of__nat,axiom,
    ! [N: nat] :
      ( ( code_int_of_integer @ ( semiring_1_of_nat @ code_integer @ N ) )
      = ( semiring_1_of_nat @ int @ N ) ) ).

% int_of_integer_of_nat
thf(fact_3856_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [F4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ F4 )
         => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ F4 )
              = ( zero_zero @ A ) )
            = ( ! [X3: B] :
                  ( ( member @ B @ X3 @ F4 )
                 => ( ( F2 @ X3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_eq_0_iff
thf(fact_3857_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G2: B > A] :
          ( ~ ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.infinite
thf(fact_3858_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 )
              = ( zero_zero @ A ) )
            = ( ? [X3: B] :
                  ( ( member @ B @ X3 @ A5 )
                  & ( ( F2 @ X3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% prod_zero_iff
thf(fact_3859_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_3860_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_3861_zero__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ int ) ) ).

% zero_integer.rep_eq
thf(fact_3862_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A2 ) @ ( B2 @ K4 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A2 ) @ ( B2 @ K4 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_3863_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( A2 = K4 ) @ ( B2 @ K4 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( A2 = K4 ) @ ( B2 @ K4 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_3864_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A5 )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite_set
thf(fact_3865_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite
thf(fact_3866_prod__pos__nat__iff,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A5 ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ A5 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_3867_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A5: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A5 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A5 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A5 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_3868_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N7: set @ nat] :
        ? [M2: nat] :
        ! [X3: nat] :
          ( ( member @ nat @ X3 @ N7 )
         => ( ord_less @ nat @ X3 @ M2 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_3869_bounded__nat__set__is__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ! [X2: nat] :
          ( ( member @ nat @ X2 @ N4 )
         => ( ord_less @ nat @ X2 @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% bounded_nat_set_is_finite
thf(fact_3870_finite__list,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [Xs2: list @ A] :
          ( ( set2 @ A @ Xs2 )
          = A5 ) ) ).

% finite_list
thf(fact_3871_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N7: set @ nat] :
        ? [M2: nat] :
        ! [X3: nat] :
          ( ( member @ nat @ X3 @ N7 )
         => ( ord_less_eq @ nat @ X3 @ M2 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_3872_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K4: nat] :
            ( ( P @ K4 )
            & ( ord_less @ nat @ K4 @ I ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_3873_finite__less__ub,axiom,
    ! [F2: nat > nat,U: nat] :
      ( ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( F2 @ N2 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N3: nat] : ( ord_less_eq @ nat @ ( F2 @ N3 ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_3874_finite__lists__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
              & ( ( size_size @ ( list @ A ) @ Xs3 )
                = N ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_3875_sum__mono__inv,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I7 > A,I6: set @ I7,G2: I7 > A,I: I7] :
          ( ( ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ I6 )
            = ( groups7311177749621191930dd_sum @ I7 @ A @ G2 @ I6 ) )
         => ( ! [I2: I7] :
                ( ( member @ I7 @ I2 @ I6 )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G2 @ I2 ) ) )
           => ( ( member @ I7 @ I @ I6 )
             => ( ( finite_finite @ I7 @ I6 )
               => ( ( F2 @ I )
                  = ( G2 @ I ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_3876_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ? [X5: B] :
                ( ( member @ B @ X5 @ A5 )
                & ( ( F2 @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% prod_zero
thf(fact_3877_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_3878_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_3879_finite__lists__length__le,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_3880_summable__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ N4 )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_finite
thf(fact_3881_less__integer_Orep__eq,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [X3: code_integer,Xa4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ X3 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_integer.rep_eq
thf(fact_3882_integer__less__iff,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [K4: code_integer,L4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ K4 ) @ ( code_int_of_integer @ L4 ) ) ) ) ).

% integer_less_iff
thf(fact_3883_integer__less__eq__iff,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [K4: code_integer,L4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ K4 ) @ ( code_int_of_integer @ L4 ) ) ) ) ).

% integer_less_eq_iff
thf(fact_3884_less__eq__integer_Orep__eq,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [X3: code_integer,Xa4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ X3 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_eq_integer.rep_eq
thf(fact_3885_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member @ B @ I4 @ I6 )
                  & ( ( X @ I4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( Y @ I4 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( plus_plus @ A @ ( X @ I4 ) @ ( Y @ I4 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_3886_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2
              @ ( collect @ B
                @ ^ [X3: B] :
                    ( ( member @ B @ X3 @ A5 )
                    & ( P @ X3 ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( G2 @ X3 ) @ ( zero_zero @ A ) )
              @ A5 ) ) ) ) ).

% sum.inter_filter
thf(fact_3887_set__encode__inf,axiom,
    ! [A5: set @ nat] :
      ( ~ ( finite_finite @ nat @ A5 )
     => ( ( nat_set_encode @ A5 )
        = ( zero_zero @ nat ) ) ) ).

% set_encode_inf
thf(fact_3888_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X3 )
                & ( ord_less_eq @ A @ X3 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_3889_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ A5 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 )
                = ( zero_zero @ A ) )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A5 )
                   => ( ( F2 @ X3 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_3890_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,T2: set @ C,G2: C > A,I: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X2: C] :
                  ( ( member @ C @ X2 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G2 @ X2 ) ) )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S )
                   => ? [Xa2: C] :
                        ( ( member @ C @ Xa2 @ T2 )
                        & ( ( I @ Xa2 )
                          = X2 )
                        & ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ Xa2 ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) @ ( groups7311177749621191930dd_sum @ C @ A @ G2 @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_3891_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A5: set @ I7,F2: I7 > A,G2: I7 > A] :
          ( ( finite_finite @ I7 @ A5 )
         => ( ! [X2: I7] :
                ( ( member @ I7 @ X2 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
           => ( ? [X5: I7] :
                  ( ( member @ I7 @ X5 @ A5 )
                  & ( ord_less @ A @ ( F2 @ X5 ) @ ( G2 @ X5 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ I7 @ A @ G2 @ A5 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_3892_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R4: A > A > $o,S2: set @ B,H: B > A,G2: B > A] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X1: A,Y1: A,X24: A,Y24: A] :
                ( ( ( R4 @ X1 @ X24 )
                  & ( R4 @ Y1 @ Y24 ) )
               => ( R4 @ ( plus_plus @ A @ X1 @ Y1 ) @ ( plus_plus @ A @ X24 @ Y24 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S2 )
                   => ( R4 @ ( H @ X2 ) @ ( G2 @ X2 ) ) )
               => ( R4 @ ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_3893_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S4: set @ B,T5: set @ C,S2: set @ B,I: C > B,J: B > C,T6: set @ C,G2: B > A,H: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A4: B] :
                  ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                 => ( ( I @ ( J @ A4 ) )
                    = A4 ) )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                   => ( member @ C @ ( J @ A4 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) ) )
               => ( ! [B4: C] :
                      ( ( member @ C @ B4 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                     => ( ( J @ ( I @ B4 ) )
                        = B4 ) )
                 => ( ! [B4: C] :
                        ( ( member @ C @ B4 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                       => ( member @ B @ ( I @ B4 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) ) )
                   => ( ! [A4: B] :
                          ( ( member @ B @ A4 @ S4 )
                         => ( ( G2 @ A4 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B4: C] :
                            ( ( member @ C @ B4 @ T5 )
                           => ( ( H @ B4 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A4: B] :
                              ( ( member @ B @ A4 @ S2 )
                             => ( ( H @ ( J @ A4 ) )
                                = ( G2 @ A4 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H @ T6 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_3894_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B6: set @ B,A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B6 )
           => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B6 ) ) ) ) ) ).

% prod_dvd_prod_subset
thf(fact_3895_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B6: set @ B,A5: set @ B,F2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ B6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B6 )
           => ( ! [A4: B] :
                  ( ( member @ B @ A4 @ A5 )
                 => ( dvd_dvd @ A @ ( F2 @ A4 ) @ ( G2 @ A4 ) ) )
             => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ B6 ) ) ) ) ) ) ).

% prod_dvd_prod_subset2
thf(fact_3896_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X3: A] :
              ( ( member @ A @ X3 @ A5 )
              & ( ( F2 @ X3 )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y4: A] :
                  ( ( member @ A @ Y4 @ A5 )
                 => ( ( X3 != Y4 )
                   => ( ( F2 @ Y4 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_3897_sum__eq__1__iff,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 )
          = ( one_one @ nat ) )
        = ( ? [X3: A] :
              ( ( member @ A @ X3 @ A5 )
              & ( ( F2 @ X3 )
                = ( one_one @ nat ) )
              & ! [Y4: A] :
                  ( ( member @ A @ Y4 @ A5 )
                 => ( ( X3 != Y4 )
                   => ( ( F2 @ Y4 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_3898_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,B6: A,I: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = B6 )
             => ( ( member @ B @ I @ S )
               => ( ord_less_eq @ A @ ( F2 @ I ) @ B6 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_3899_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,I: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I @ S )
               => ( ( F2 @ I )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_3900_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2
              @ ( minus_minus @ ( set @ B ) @ A5
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( G2 @ X3 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_3901_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D6: nat] : ( dvd_dvd @ nat @ D6 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_3902_sums__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ N4 )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( sums @ A @ F2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N4 ) ) ) ) ) ).

% sums_finite
thf(fact_3903_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( collect @ nat @ P ) ) ) ) ) ).

% sums_If_finite
thf(fact_3904_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A5 )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A5 ) ) ) ) ).

% sums_If_finite_set
thf(fact_3905_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ N4 )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A @ F2 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N4 ) ) ) ) ) ).

% suminf_finite
thf(fact_3906_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K4: A] :
                ( ( member @ A @ K4 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K4 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_3907_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_3908_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_3909_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,I: B,F2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( member @ B @ I @ I6 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ I6 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I6 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_3910_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,I: A,F2: A > B] :
          ( ( finite_finite @ A @ I6 )
         => ( ( member @ A @ I @ I6 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I ) )
             => ( ! [I2: A] :
                    ( ( member @ A @ I2 @ I6 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I2 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I6 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_3911_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A,H: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S2 )
                   => ( ( G2 @ X2 )
                      = ( H @ X2 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ T6 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_3912_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,H: B > A,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S2 )
                   => ( ( G2 @ X2 )
                      = ( H @ X2 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H @ T6 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_3913_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_3914_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G2 @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_3915_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C4: set @ B,A5: set @ B,B6: set @ B,G2: B > A,H: B > A] :
          ( ( finite_finite @ B @ C4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C4 )
           => ( ( ord_less_eq @ ( set @ B ) @ B6 @ C4 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C4 @ A5 ) )
                   => ( ( G2 @ A4 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C4 @ B6 ) )
                     => ( ( H @ B4 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ C4 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ C4 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ B6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_3916_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C4: set @ B,A5: set @ B,B6: set @ B,G2: B > A,H: B > A] :
          ( ( finite_finite @ B @ C4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C4 )
           => ( ( ord_less_eq @ ( set @ B ) @ B6 @ C4 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C4 @ A5 ) )
                   => ( ( G2 @ A4 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C4 @ B6 ) )
                     => ( ( H @ B4 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ B6 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ C4 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ C4 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_3917_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B6: set @ B,A5: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B6 @ A5 )
         => ( ( finite_finite @ B @ A5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ B6 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ B6 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_3918_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: set @ B,B6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( ord_less_eq @ ( set @ B ) @ B6 @ A5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ B6 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B6 ) ) ) ) ) ) ).

% sum_diff
thf(fact_3919_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B6: set @ B,A5: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B6 @ A5 )
         => ( ( finite_finite @ B @ A5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ B6 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ B6 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_3920_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A,H: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X2 )
                    = ( one_one @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S2 )
                   => ( ( G2 @ X2 )
                      = ( H @ X2 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ T6 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H @ S2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_3921_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,H: B > A,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H @ X2 )
                    = ( one_one @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S2 )
                   => ( ( G2 @ X2 )
                      = ( H @ X2 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H @ T6 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_3922_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X2 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_3923_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X2 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G2 @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_3924_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C4: set @ B,A5: set @ B,B6: set @ B,G2: B > A,H: B > A] :
          ( ( finite_finite @ B @ C4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C4 )
           => ( ( ord_less_eq @ ( set @ B ) @ B6 @ C4 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C4 @ A5 ) )
                   => ( ( G2 @ A4 )
                      = ( one_one @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C4 @ B6 ) )
                     => ( ( H @ B4 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ C4 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ C4 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ B6 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_3925_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C4: set @ B,A5: set @ B,B6: set @ B,G2: B > A,H: B > A] :
          ( ( finite_finite @ B @ C4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C4 )
           => ( ( ord_less_eq @ ( set @ B ) @ B6 @ C4 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C4 @ A5 ) )
                   => ( ( G2 @ A4 )
                      = ( one_one @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C4 @ B6 ) )
                     => ( ( H @ B4 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ B6 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ C4 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ C4 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_3926_sum__diff__nat,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B6 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_3927_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z5: A] :
                  ( ( power_power @ A @ Z5 @ N )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_3928_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B6: set @ B,A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B6 )
           => ( ! [B4: B] :
                  ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ B6 @ A5 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B4 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B6 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_3929_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I6: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I6 )
           => ( ! [N2: nat] :
                  ( ( member @ nat @ N2 @ ( uminus_uminus @ ( set @ nat ) @ I6 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I6 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_3930_sum__count__set,axiom,
    ! [A: $tType,Xs: list @ A,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs ) @ X8 )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% sum_count_set
thf(fact_3931_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B6: set @ A,A5: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B6 @ A5 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X2: A] :
                      ( ( member @ A @ X2 @ B6 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X2 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B6 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_3932_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B6: set @ A,A5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ ( minus_minus @ ( set @ A ) @ B6 @ A5 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B4 ) ) )
             => ( ! [A4: A] :
                    ( ( member @ A @ A4 @ A5 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A4 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B6 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_3933_ln__prod,axiom,
    ! [A: $tType,I6: set @ A,F2: A > real] :
      ( ( finite_finite @ A @ I6 )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ I2 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F2 @ I6 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X3: A] : ( ln_ln @ real @ ( F2 @ X3 ) )
            @ I6 ) ) ) ) ).

% ln_prod
thf(fact_3934_even__set__encode__iff,axiom,
    ! [A5: set @ nat] :
      ( ( finite_finite @ nat @ A5 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A5 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A5 ) ) ) ) ).

% even_set_encode_iff
thf(fact_3935_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X3: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X3 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
                & ( ( C2 @ I4 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_3936_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z5: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_3937_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_3938_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N3: nat] : ( ord_less @ nat @ N3 @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_3939_finite__Collect__subsets,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B7: set @ A] : ( ord_less_eq @ ( set @ A ) @ B7 @ A5 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_3940_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K4: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L4: code_integer,J3: code_integer] :
                ( if @ nat
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L4 ) @ ( code_nat_of_integer @ L4 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L4 ) @ ( code_nat_of_integer @ L4 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_3941_finite__interval__int1,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less_eq @ int @ A2 @ I4 )
            & ( ord_less_eq @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_3942_finite__interval__int4,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less @ int @ A2 @ I4 )
            & ( ord_less @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_3943_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less_eq @ int @ A2 @ I4 )
            & ( ord_less @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_3944_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less @ int @ A2 @ I4 )
            & ( ord_less_eq @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_3945_nat__of__integer__of__nat,axiom,
    ! [N: nat] :
      ( ( code_nat_of_integer @ ( semiring_1_of_nat @ code_integer @ N ) )
      = N ) ).

% nat_of_integer_of_nat
thf(fact_3946_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z5: complex] :
              ( ( power_power @ complex @ Z5 @ N )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_3947_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_3948_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_finite @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) ) ).

% finite_atLeastZeroLessThan_int
thf(fact_3949_finite__maxlen,axiom,
    ! [A: $tType,M5: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M5 )
     => ? [N2: nat] :
        ! [X5: list @ A] :
          ( ( member @ ( list @ A ) @ X5 @ M5 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X5 ) @ N2 ) ) ) ).

% finite_maxlen
thf(fact_3950_finite__divisors__int,axiom,
    ! [I: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( finite_finite @ int
        @ ( collect @ int
          @ ^ [D6: int] : ( dvd_dvd @ int @ D6 @ I ) ) ) ) ).

% finite_divisors_int
thf(fact_3951_nat__of__integer__code__post_I1_J,axiom,
    ( ( code_nat_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ nat ) ) ).

% nat_of_integer_code_post(1)
thf(fact_3952_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ A5 )
                & ( ord_less_eq @ A @ A2 @ X2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A5 )
                   => ( ( ord_less_eq @ A @ X2 @ Xa2 )
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_3953_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ A5 )
                & ( ord_less_eq @ A @ X2 @ A2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A5 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X2 )
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_3954_finite__subset,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( finite_finite @ A @ B6 )
       => ( finite_finite @ A @ A5 ) ) ) ).

% finite_subset
thf(fact_3955_infinite__super,axiom,
    ! [A: $tType,S2: set @ A,T6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
     => ( ~ ( finite_finite @ A @ S2 )
       => ~ ( finite_finite @ A @ T6 ) ) ) ).

% infinite_super
thf(fact_3956_rev__finite__subset,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
       => ( finite_finite @ A @ A5 ) ) ) ).

% rev_finite_subset
thf(fact_3957_finite__psubset__induct,axiom,
    ! [A: $tType,A5: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A5 )
     => ( ! [A8: set @ A] :
            ( ( finite_finite @ A @ A8 )
           => ( ! [B9: set @ A] :
                  ( ( ord_less @ ( set @ A ) @ B9 @ A8 )
                 => ( P @ B9 ) )
             => ( P @ A8 ) ) )
       => ( P @ A5 ) ) ) ).

% finite_psubset_induct
thf(fact_3958_finite__nat__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S5: set @ nat] :
        ? [K4: nat] : ( ord_less_eq @ ( set @ nat ) @ S5 @ ( set_ord_atMost @ nat @ K4 ) ) ) ) ).

% finite_nat_iff_bounded_le
thf(fact_3959_finite__nat__bounded,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [K2: nat] : ( ord_less_eq @ ( set @ nat ) @ S2 @ ( set_ord_lessThan @ nat @ K2 ) ) ) ).

% finite_nat_bounded
thf(fact_3960_finite__nat__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S5: set @ nat] :
        ? [K4: nat] : ( ord_less_eq @ ( set @ nat ) @ S5 @ ( set_ord_lessThan @ nat @ K4 ) ) ) ) ).

% finite_nat_iff_bounded
thf(fact_3961_in__finite__psubset,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A5 @ B6 ) @ ( finite_psubset @ A ) )
      = ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
        & ( finite_finite @ A @ B6 ) ) ) ).

% in_finite_psubset
thf(fact_3962_infinite__int__iff__unbounded__le,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ! [M2: int] :
          ? [N3: int] :
            ( ( ord_less_eq @ int @ M2 @ ( abs_abs @ int @ N3 ) )
            & ( member @ int @ N3 @ S2 ) ) ) ) ).

% infinite_int_iff_unbounded_le
thf(fact_3963_infinite__int__iff__unbounded,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ! [M2: int] :
          ? [N3: int] :
            ( ( ord_less @ int @ M2 @ ( abs_abs @ int @ N3 ) )
            & ( member @ int @ N3 @ S2 ) ) ) ) ).

% infinite_int_iff_unbounded
thf(fact_3964_finite__psubset__def,axiom,
    ! [A: $tType] :
      ( ( finite_psubset @ A )
      = ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
        @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
          @ ^ [A7: set @ A,B7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
              & ( finite_finite @ A @ B7 ) ) ) ) ) ).

% finite_psubset_def
thf(fact_3965_unbounded__k__infinite,axiom,
    ! [K: nat,S2: set @ nat] :
      ( ! [M4: nat] :
          ( ( ord_less @ nat @ K @ M4 )
         => ? [N6: nat] :
              ( ( ord_less @ nat @ M4 @ N6 )
              & ( member @ nat @ N6 @ S2 ) ) )
     => ~ ( finite_finite @ nat @ S2 ) ) ).

% unbounded_k_infinite
thf(fact_3966_infinite__nat__iff__unbounded,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M2: nat] :
          ? [N3: nat] :
            ( ( ord_less @ nat @ M2 @ N3 )
            & ( member @ nat @ N3 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_3967_infinite__nat__iff__unbounded__le,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M2: nat] :
          ? [N3: nat] :
            ( ( ord_less_eq @ nat @ M2 @ N3 )
            & ( member @ nat @ N3 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_3968_set__encode__insert,axiom,
    ! [A5: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ A5 )
     => ( ~ ( member @ nat @ N @ A5 )
       => ( ( nat_set_encode @ ( insert2 @ nat @ N @ A5 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( nat_set_encode @ A5 ) ) ) ) ) ).

% set_encode_insert
thf(fact_3969_power2__csqrt,axiom,
    ! [Z2: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z2 ) ).

% power2_csqrt
thf(fact_3970_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K4: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S6: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K4 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S6 ) )
                @ ( S6
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_3971_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N3: nat,A3: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ A3
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_3972_insert__subset,axiom,
    ! [A: $tType,X: A,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ B6 )
      = ( ( member @ A @ X @ B6 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ) ).

% insert_subset
thf(fact_3973_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_3974_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_3975_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_3976_csqrt__eq__0,axiom,
    ! [Z2: complex] :
      ( ( ( csqrt @ Z2 )
        = ( zero_zero @ complex ) )
      = ( Z2
        = ( zero_zero @ complex ) ) ) ).

% csqrt_eq_0
thf(fact_3977_csqrt__0,axiom,
    ( ( csqrt @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% csqrt_0
thf(fact_3978_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( set2 @ A @ ( cons @ A @ X21 @ X22 ) )
      = ( insert2 @ A @ X21 @ ( set2 @ A @ X22 ) ) ) ).

% list.simps(15)
thf(fact_3979_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_3980_drop__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_3981_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_3982_insert__mono,axiom,
    ! [A: $tType,C4: set @ A,D5: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ D5 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ A2 @ C4 ) @ ( insert2 @ A @ A2 @ D5 ) ) ) ).

% insert_mono
thf(fact_3983_subset__insert,axiom,
    ! [A: $tType,X: A,A5: set @ A,B6: set @ A] :
      ( ~ ( member @ A @ X @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ B6 ) )
        = ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ) ).

% subset_insert
thf(fact_3984_subset__insertI,axiom,
    ! [A: $tType,B6: set @ A,A2: A] : ( ord_less_eq @ ( set @ A ) @ B6 @ ( insert2 @ A @ A2 @ B6 ) ) ).

% subset_insertI
thf(fact_3985_subset__insertI2,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ B2 @ B6 ) ) ) ).

% subset_insertI2
thf(fact_3986_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_drop_bit
thf(fact_3987_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_3988_subset__Diff__insert,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,X: A,C4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B6 @ ( insert2 @ A @ X @ C4 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B6 @ C4 ) )
        & ~ ( member @ A @ X @ A5 ) ) ) ).

% subset_Diff_insert
thf(fact_3989_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_3990_atLeast0__atMost__Suc,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert2 @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_3991_atLeast0__lessThan__Suc,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert2 @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_3992_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N )
        = ( insert2 @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_3993_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) )
        = ( insert2 @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_3994_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( insert2 @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ).

% atLeastAtMost_insertL
thf(fact_3995_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I @ X ) ) @ ( insert2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_update_subset_insert
thf(fact_3996_divmod__abs__code_I6_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_3997_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( divide_divide @ int @ K4 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% drop_bit_int_def
thf(fact_3998_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N3: nat,M2: nat] : ( divide_divide @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% drop_bit_nat_def
thf(fact_3999_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_4000_divmod__abs__code_I5_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ J @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J ) ) ) ).

% divmod_abs_code(5)
thf(fact_4001_of__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X ) ) ) ) ).

% of_real_sqrt
thf(fact_4002_set__decode__plus__power__2,axiom,
    ! [N: nat,Z2: nat] :
      ( ~ ( member @ nat @ N @ ( nat_set_decode @ Z2 ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ Z2 ) )
        = ( insert2 @ nat @ N @ ( nat_set_decode @ Z2 ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4003_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K4: code_integer,L4: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L4 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K4 ) @ ( code_divmod_abs @ K4 @ L4 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S6: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S6
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L4 @ S6 ) ) )
                @ ( code_divmod_abs @ K4 @ L4 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L4
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K4 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K4 @ L4 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S6: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S6
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L4 ) @ S6 ) ) )
                    @ ( code_divmod_abs @ K4 @ L4 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_4004_Suc__0__or__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_or_eq
thf(fact_4005_or__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% or_Suc_0_eq
thf(fact_4006_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M ) @ ( nth @ A @ Xs @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_4007_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_4008_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_4009_length__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_enumerate
thf(fact_4010_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs: list @ B] :
      ( ( enumerate @ B @ N @ ( cons @ B @ X @ Xs ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N @ X ) @ ( enumerate @ B @ ( suc @ N ) @ Xs ) ) ) ).

% enumerate_simps(2)
thf(fact_4011_or__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(4)
thf(fact_4012_or__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(2)
thf(fact_4013_or__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(1)
thf(fact_4014_or__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(3)
thf(fact_4015_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_or_eq
thf(fact_4016_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( zero_zero @ A ) )
          = X ) ) ).

% bit.disj_zero_right
thf(fact_4017_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_4018_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_4019_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
        = ( insert2 @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N ) @ ( set_or1337092689740270186AtMost @ int @ M @ N ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_4020_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y ) ) ) ) ).

% bit.compl_unique
thf(fact_4021_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% mask_Suc_exp
thf(fact_4022_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K4: int,L4: int] :
          ( if @ int
          @ ( ( member @ int @ K4 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L4 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K4 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L4 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K4 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L4 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_4023_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_4024_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_4025_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_4026_bot__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( bot @ C )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X3: D] : ( bot_bot @ C ) ) ) ) ).

% bot_apply
thf(fact_4027_empty__subsetI,axiom,
    ! [A: $tType,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A5 ) ).

% empty_subsetI
thf(fact_4028_subset__empty,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_4029_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% or_nonnegative_int_iff
thf(fact_4030_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_4031_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_4032_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_4033_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_4034_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_4035_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A2: A,A5: set @ A,B2: A] :
      ( ( ( insert2 @ A @ A2 @ A5 )
        = ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_4036_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A2: A,A5: set @ A] :
      ( ( ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert2 @ A @ A2 @ A5 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_4037_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_4038_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_4039_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_4040_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A5 @ B6 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ).

% Diff_eq_empty_iff
thf(fact_4041_subset__Compl__singleton,axiom,
    ! [A: $tType,A5: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A5 ) ) ) ).

% subset_Compl_singleton
thf(fact_4042_set__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
        = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4043_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_4044_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_4045_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_4046_bot__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot @ B )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X3: A] : ( bot_bot @ B ) ) ) ) ).

% bot_fun_def
thf(fact_4047_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_4048_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_4049_not__psubset__empty,axiom,
    ! [A: $tType,A5: set @ A] :
      ~ ( ord_less @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) ) ).

% not_psubset_empty
thf(fact_4050_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( minus_minus @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% diff_shunt_var
thf(fact_4051_OR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) ) ) ) ).

% OR_lower
thf(fact_4052_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) ) ) ).

% or_greater_eq
thf(fact_4053_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ A5 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A5 )
                   => ( ( ord_less_eq @ A @ X2 @ Xa2 )
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_4054_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ A5 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A5 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X2 )
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_4055_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ S2 )
                & ~ ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S2 )
                      & ( ord_less @ A @ Xa2 @ X2 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_4056_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X8: set @ A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X8 )
               => ? [Xa2: A] :
                    ( ( member @ A @ Xa2 @ X8 )
                    & ( ord_less @ A @ X2 @ Xa2 ) ) )
           => ~ ( finite_finite @ A @ X8 ) ) ) ) ).

% infinite_growing
thf(fact_4057_subset__singleton__iff,axiom,
    ! [A: $tType,X8: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( insert2 @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X8
          = ( bot_bot @ ( set @ A ) ) )
        | ( X8
          = ( insert2 @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_4058_subset__singletonD,axiom,
    ! [A: $tType,A5: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A5
          = ( bot_bot @ ( set @ A ) ) )
        | ( A5
          = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_4059_subset__Compl__self__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ A5 ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_4060_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4061_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M2: nat,N3: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% or_nat_def
thf(fact_4062_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S2: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X2: B,S7: set @ B] :
                  ( ( finite_finite @ B @ S7 )
                 => ( ! [Y5: B] :
                        ( ( member @ B @ Y5 @ S7 )
                       => ( ord_less_eq @ A @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) )
                   => ( ( P @ S7 )
                     => ( P @ ( insert2 @ B @ X2 @ S7 ) ) ) ) )
             => ( P @ S2 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_4063_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A5 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B4: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X5: A] :
                        ( ( member @ A @ X5 @ A8 )
                       => ( ord_less @ A @ X5 @ B4 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert2 @ A @ B4 @ A8 ) ) ) ) )
             => ( P @ A5 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_4064_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A5 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B4: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X5: A] :
                        ( ( member @ A @ X5 @ A8 )
                       => ( ord_less @ A @ B4 @ X5 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert2 @ A @ B4 @ A8 ) ) ) ) )
             => ( P @ A5 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_4065_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A5: set @ B,F2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ A5 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_4066_finite__subset__induct,axiom,
    ! [A: $tType,F4: set @ A,A5: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A5 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A4: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member @ A @ A4 @ A5 )
                 => ( ~ ( member @ A @ A4 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert2 @ A @ A4 @ F6 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_4067_finite__subset__induct_H,axiom,
    ! [A: $tType,F4: set @ A,A5: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A5 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A4: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member @ A @ A4 @ A5 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F6 @ A5 )
                   => ( ~ ( member @ A @ A4 @ F6 )
                     => ( ( P @ F6 )
                       => ( P @ ( insert2 @ A @ A4 @ F6 ) ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_4068_Diff__single__insert,axiom,
    ! [A: $tType,A5: set @ A,X: A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ B6 ) ) ) ).

% Diff_single_insert
thf(fact_4069_subset__insert__iff,axiom,
    ! [A: $tType,A5: set @ A,X: A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ B6 ) )
      = ( ( ( member @ A @ X @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B6 ) )
        & ( ~ ( member @ A @ X @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% subset_insert_iff
thf(fact_4070_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ I6 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I6 ) ) ) ) ) ) ).

% sum_pos
thf(fact_4071_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I6 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I2 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I6 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_4072_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B6: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B6 )
         => ( P @ B6 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B6 )
                 => ( ! [X5: A] :
                        ( ( member @ A @ X5 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert2 @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B6 ) ) ) ) ).

% remove_induct
thf(fact_4073_finite__remove__induct,axiom,
    ! [A: $tType,B6: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B6 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B6 )
                 => ( ! [X5: A] :
                        ( ( member @ A @ X5 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert2 @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B6 ) ) ) ) ).

% finite_remove_induct
thf(fact_4074_finite__induct__select,axiom,
    ! [A: $tType,S2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S2 )
             => ( ( P @ T7 )
               => ? [X5: A] :
                    ( ( member @ A @ X5 @ ( minus_minus @ ( set @ A ) @ S2 @ T7 ) )
                    & ( P @ ( insert2 @ A @ X5 @ T7 ) ) ) ) )
         => ( P @ S2 ) ) ) ) ).

% finite_induct_select
thf(fact_4075_psubset__insert__iff,axiom,
    ! [A: $tType,A5: set @ A,X: A,B6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ B6 ) )
      = ( ( ( member @ A @ X @ B6 )
         => ( ord_less @ ( set @ A ) @ A5 @ B6 ) )
        & ( ~ ( member @ A @ X @ B6 )
         => ( ( ( member @ A @ X @ A5 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B6 ) )
            & ( ~ ( member @ A @ X @ A5 )
             => ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_4076_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X ) )
      = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_4077_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4078_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert2 @ int @ I4 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ) ).

% simp_from_to
thf(fact_4079_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4080_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A5 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                  & ( ord_less @ A @ ( F2 @ I2 ) @ ( G2 @ I2 ) ) ) )
           => ( ( A5
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_4081_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I: C,A5: set @ C,F2: C > B] :
          ( ( member @ C @ I @ A5 )
         => ( ! [X2: C] :
                ( ( member @ C @ X2 @ ( minus_minus @ ( set @ C ) @ A5 @ ( insert2 @ C @ I @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X2 ) ) )
           => ( ( finite_finite @ C @ A5 )
             => ( ord_less_eq @ B @ ( F2 @ I ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A5 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_4082_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A5: set @ B,F2: B > A,A2: B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A5 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( F2 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A5 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_4083_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sinh @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X ) @ ( insert2 @ A @ ( one_one @ A ) @ ( insert2 @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_4084_OR__upper,axiom,
    ! [X: int,N: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% OR_upper
thf(fact_4085_and__int_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [K2: int,L2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L2 ) )
           => ( ( ~ ( ( member @ int @ K2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L2 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% and_int.pinduct
thf(fact_4086_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4087_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K4: int,L4: int] :
          ( if @ int
          @ ( ( K4
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L4
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K4
              = ( zero_zero @ int ) )
            @ L4
            @ ( if @ int
              @ ( L4
                = ( zero_zero @ int ) )
              @ K4
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_4088_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( if @ nat
          @ ( M2
            = ( zero_zero @ nat ) )
          @ N3
          @ ( if @ nat
            @ ( N3
              = ( zero_zero @ nat ) )
            @ M2
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_4089_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F4: set @ A,I6: set @ A,F2: A > B,I: A] :
          ( ( finite_finite @ A @ F4 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I4: A] :
                    ( ( member @ A @ I4 @ I6 )
                    & ( ( F2 @ I4 )
                     != ( zero_zero @ B ) ) ) )
              @ F4 )
           => ( ( ( member @ A @ I @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) @ ( F2 @ I ) ) ) )
              & ( ~ ( member @ A @ I @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_4090_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_4091_max__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% max_bot2
thf(fact_4092_max__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% max_bot
thf(fact_4093_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_4094_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_Suc_Suc
thf(fact_4095_max__0R,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ N @ ( zero_zero @ nat ) )
      = N ) ).

% max_0R
thf(fact_4096_max__0L,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% max_0L
thf(fact_4097_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_4098_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_4099_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_4100_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_4101_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_4102_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_4103_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_4104_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(4)
thf(fact_4105_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(3)
thf(fact_4106_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_4107_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_4108_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_4109_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_4110_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P6: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P6 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_4111_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_4112_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_4113_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_4114_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_4115_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,P6: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I6 )
                  & ( ( P6 @ X3 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P6 @ ( insert2 @ B @ I @ I6 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P6 @ I6 ) ) )
            & ( ~ ( member @ B @ I @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P6 @ ( insert2 @ B @ I @ I6 ) )
                = ( plus_plus @ A @ ( P6 @ I ) @ ( groups1027152243600224163dd_sum @ B @ A @ P6 @ I6 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_4116_less__by__empty,axiom,
    ! [A: $tType,A5: set @ ( product_prod @ A @ A ),B6: set @ ( product_prod @ A @ A )] :
      ( ( A5
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A5 @ B6 ) ) ).

% less_by_empty
thf(fact_4117_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_4118_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_4119_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X @ Y ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_max
thf(fact_4120_of__int__max,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y: int] :
          ( ( ring_1_of_int @ A @ ( ord_max @ int @ X @ Y ) )
          = ( ord_max @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y ) ) ) ) ).

% of_int_max
thf(fact_4121_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y @ Z2 ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% max_add_distrib_right
thf(fact_4122_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% max_add_distrib_left
thf(fact_4123_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q4: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N ) @ Q4 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q4 ) @ ( plus_plus @ nat @ N @ Q4 ) ) ) ).

% nat_add_max_left
thf(fact_4124_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q4: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N @ Q4 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N ) @ ( plus_plus @ nat @ M @ Q4 ) ) ) ).

% nat_add_max_right
thf(fact_4125_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ B3 @ A3 ) ) ) ) ).

% max_def_raw
thf(fact_4126_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% max_diff_distrib_left
thf(fact_4127_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q4: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N ) @ Q4 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q4 ) @ ( times_times @ nat @ N @ Q4 ) ) ) ).

% nat_mult_max_left
thf(fact_4128_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q4: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N @ Q4 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q4 ) ) ) ).

% nat_mult_max_right
thf(fact_4129_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ B3 @ A3 ) ) ) ) ).

% max_def
thf(fact_4130_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_max @ A @ X @ Y )
            = X ) ) ) ).

% max_absorb1
thf(fact_4131_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_max @ A @ X @ Y )
            = Y ) ) ) ).

% max_absorb2
thf(fact_4132_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: B > A,I6: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G2
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I6 )
                  & ( ( G2 @ X3 )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G2 @ I6 ) ) ) ).

% sum.non_neutral'
thf(fact_4133_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N @ M ) @ M )
      = ( ord_max @ nat @ N @ M ) ) ).

% nat_minus_add_max
thf(fact_4134_atLeastLessThan0,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_4135_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( ( set_ord_lessThan @ nat @ N )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_4136_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X2 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G2 @ S2 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G2 @ T6 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_4137_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X2 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G2 @ T6 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G2 @ S2 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_4138_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,H: B > A,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( H @ I2 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ S2 )
                 => ( ( G2 @ X2 )
                    = ( H @ X2 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G2 @ S2 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_4139_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A,H: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X2 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ S2 )
                 => ( ( G2 @ X2 )
                    = ( H @ X2 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G2 @ T6 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_4140_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G2: B > A,H: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I6 )
                  & ( ( G2 @ X3 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X3: B] :
                    ( ( member @ B @ X3 @ I6 )
                    & ( ( H @ X3 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I4: B] : ( plus_plus @ A @ ( G2 @ I4 ) @ ( H @ I4 ) )
                @ I6 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G2 @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H @ I6 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_4141_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P5: B > A,I8: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( member @ B @ X3 @ I8 )
                      & ( ( P5 @ X3 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P5
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( member @ B @ X3 @ I8 )
                      & ( ( P5 @ X3 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_4142_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( insert2 @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_4143_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_4144_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_4145_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I6: set @ A,F2: A > B,I: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I4: A] :
                  ( ( member @ A @ I4 @ I6 )
                  & ( ( F2 @ I4 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I @ I6 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) @ ( F2 @ I ) ) ) )
            & ( ~ ( member @ A @ I @ I6 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_4146_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_4147_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_4148_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            & ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% max_less_iff_conj
thf(fact_4149_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_4150_max__enat__simps_I2_J,axiom,
    ! [Q4: extended_enat] :
      ( ( ord_max @ extended_enat @ Q4 @ ( zero_zero @ extended_enat ) )
      = Q4 ) ).

% max_enat_simps(2)
thf(fact_4151_max__enat__simps_I3_J,axiom,
    ! [Q4: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q4 )
      = Q4 ) ).

% max_enat_simps(3)
thf(fact_4152_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_4153_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_4154_of__nat__of__integer,axiom,
    ! [K: code_integer] :
      ( ( semiring_1_of_nat @ code_integer @ ( code_nat_of_integer @ K ) )
      = ( ord_max @ code_integer @ ( zero_zero @ code_integer ) @ K ) ) ).

% of_nat_of_integer
thf(fact_4155_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_4156_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_4157_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_4158_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_4159_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_4160_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( A3
              = ( ord_max @ A @ A3 @ B3 ) ) ) ) ) ).

% max.order_iff
thf(fact_4161_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_4162_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_4163_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less_eq @ A @ Z2 @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less_eq @ A @ Z2 @ X )
            | ( ord_less_eq @ A @ Z2 @ Y ) ) ) ) ).

% le_max_iff_disj
thf(fact_4164_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_max @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% max.absorb_iff1
thf(fact_4165_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_max @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% max.absorb_iff2
thf(fact_4166_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_4167_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_4168_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_4169_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_4170_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( A3
                = ( ord_max @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_4171_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_4172_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X )
            | ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% less_max_iff_disj
thf(fact_4173_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K4: code_integer,L4: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L4
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K4 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L4
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K4 )
                  = ( sgn_sgn @ code_integer @ L4 ) )
                @ ( code_divmod_abs @ K4 @ L4 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S6: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S6
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L4 ) @ S6 ) ) )
                  @ ( code_divmod_abs @ K4 @ L4 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_4174_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N @ X ) )
          = ( insert2 @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ ( nth @ A @ Xs @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_4175_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( compow @ ( A > A ) @ N3 @ ( times_times @ A @ A3 ) @ ( F3 @ ( nth @ B @ Xs3 @ N3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_4176_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X3: real] :
          ( the @ int
          @ ^ [Z5: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z5 ) @ X3 )
              & ( ord_less @ real @ X3 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_4177_Suc__funpow,axiom,
    ! [N: nat] :
      ( ( compow @ ( nat > nat ) @ N @ suc )
      = ( plus_plus @ nat @ N ) ) ).

% Suc_funpow
thf(fact_4178_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X )
      = X ) ).

% funpow_0
thf(fact_4179_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct1_rotate
thf(fact_4180_distinct__swap,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I ) ) )
          = ( distinct @ A @ Xs ) ) ) ) ).

% distinct_swap
thf(fact_4181_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs3 )
                = N )
              & ( distinct @ A @ Xs3 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_4182_distinct__length__2__or__more,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ A2 @ ( cons @ A @ B2 @ Xs ) ) )
      = ( ( A2 != B2 )
        & ( distinct @ A @ ( cons @ A @ A2 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs ) ) ) ) ).

% distinct_length_2_or_more
thf(fact_4183_comp__cong,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E4: $tType,F2: B > A,G2: C > B,X: C,F7: D > A,G3: E4 > D,X6: E4] :
      ( ( ( F2 @ ( G2 @ X ) )
        = ( F7 @ ( G3 @ X6 ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G2 @ X )
        = ( comp @ D @ A @ E4 @ F7 @ G3 @ X6 ) ) ) ).

% comp_cong
thf(fact_4184_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% comp_funpow
thf(fact_4185_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N: nat,X: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N @ F2 @ X ) )
      = ( compow @ ( A > A ) @ N @ F2 @ ( F2 @ X ) ) ) ).

% funpow_swap1
thf(fact_4186_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( distinct @ A @ Xs ) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
thf(fact_4187_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_4188_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_4189_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ B @ Ys2 )
       => ( distinct @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys2 ) ) ) ) ).

% distinct_product
thf(fact_4190_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ! [X2: list @ A] :
          ( ( member @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xss ) )
         => ( distinct @ A @ X2 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) ) ).

% distinct_product_lists
thf(fact_4191_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F2 ) @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow_add
thf(fact_4192_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N @ ( compow @ ( A > A ) @ M @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N ) @ F2 ) ) ).

% funpow_mult
thf(fact_4193_distinct__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( distinct @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ).

% distinct_enumerate
thf(fact_4194_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F2 @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_4195_finite__distinct__list,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [Xs2: list @ A] :
          ( ( ( set2 @ A @ Xs2 )
            = A5 )
          & ( distinct @ A @ Xs2 ) ) ) ).

% finite_distinct_list
thf(fact_4196_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ X @ Xs ) )
      = ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) ).

% distinct.simps(2)
thf(fact_4197_prod__inversef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A5: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A @ ( comp @ A @ A @ B @ ( inverse_inverse @ A ) @ F2 ) @ A5 )
          = ( inverse_inverse @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ).

% prod_inversef
thf(fact_4198_subseqs__distinctD,axiom,
    ! [A: $tType,Ys2: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( ( distinct @ A @ Xs )
       => ( distinct @ A @ Ys2 ) ) ) ).

% subseqs_distinctD
thf(fact_4199_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H: B > A,G2: C > B,A5: set @ C] :
          ( ( ( H @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X2: B,Y2: B] :
                ( ( H @ ( plus_plus @ B @ X2 @ Y2 ) )
                = ( plus_plus @ A @ ( H @ X2 ) @ ( H @ Y2 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H @ G2 ) @ A5 )
              = ( H @ ( groups7311177749621191930dd_sum @ C @ B @ G2 @ A5 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_4200_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs3: list @ A] :
          ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
           => ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( I4 != J3 )
                 => ( ( nth @ A @ Xs3 @ I4 )
                   != ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_4201_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,J: nat] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( ( nth @ A @ Xs @ I )
              = ( nth @ A @ Xs @ J ) )
            = ( I = J ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_4202_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] : ( compow @ ( A > A ) @ N3 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_4203_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_4204_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ? [X2: nat] :
            ( ( ord_less @ nat @ X2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ X2 )
              = X )
            & ! [Y5: nat] :
                ( ( ( ord_less @ nat @ Y5 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( ( nth @ A @ Xs @ Y5 )
                    = X ) )
               => ( Y5 = X2 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_4205_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K4: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K4 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_4206_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X3: rat] :
          ( the @ int
          @ ^ [Z5: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z5 ) @ X3 )
              & ( ord_less @ rat @ X3 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_4207_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A2: A,I: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member @ A @ A2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ ( nth @ A @ Xs @ I ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I @ A2 ) ) ) ) ).

% distinct_list_update
thf(fact_4208_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N3: nat,P3: A > A > $o,X3: A,Y4: A] :
          ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = X3 )
            & ( ( F3 @ N3 )
              = Y4 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N3 )
               => ( P3 @ ( F3 @ I4 ) @ ( F3 @ ( suc @ I4 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_4209_distinct__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys2 ) )
      = ( distinct @ A @ Ys2 ) ) ).

% distinct_union
thf(fact_4210_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_4211_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_4212_in__set__remove1,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( A2 != B2 )
     => ( ( member @ A @ A2 @ ( set2 @ A @ ( remove1 @ A @ B2 @ Xs ) ) )
        = ( member @ A @ A2 @ ( set2 @ A @ Xs ) ) ) ) ).

% in_set_remove1
thf(fact_4213_distinct__remove1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( remove1 @ A @ X @ Xs ) ) ) ).

% distinct_remove1
thf(fact_4214_notin__set__remove1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member @ A @ X @ ( set2 @ A @ ( remove1 @ A @ Y @ Xs ) ) ) ) ).

% notin_set_remove1
thf(fact_4215_remove1__idem,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( remove1 @ A @ X @ Xs )
        = Xs ) ) ).

% remove1_idem
thf(fact_4216_remove1__commute,axiom,
    ! [A: $tType,X: A,Y: A,Zs: list @ A] :
      ( ( remove1 @ A @ X @ ( remove1 @ A @ Y @ Zs ) )
      = ( remove1 @ A @ Y @ ( remove1 @ A @ X @ Zs ) ) ) ).

% remove1_commute
thf(fact_4217_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = Xs ) )
      & ( ( X != Y )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( cons @ A @ Y @ ( remove1 @ A @ X @ Xs ) ) ) ) ) ).

% remove1.simps(2)
thf(fact_4218_set__remove1__subset,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_remove1_subset
thf(fact_4219_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F2 ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ C2 @ ( F2 @ N3 ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_4220_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R4: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ R4 )
      = ( ^ [Y3: A,Z: A] : ( Y3 = Z ) ) ) ).

% relpowp.simps(1)
thf(fact_4221_relpowp__0__E,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Y: A] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X @ Y )
     => ( X = Y ) ) ).

% relpowp_0_E
thf(fact_4222_relpowp__0__I,axiom,
    ! [A: $tType,P: A > A > $o,X: A] : ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X @ X ) ).

% relpowp_0_I
thf(fact_4223_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_4224_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_4225_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_4226_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_4227_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_4228_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_4229_length__remove1,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs ) )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_remove1
thf(fact_4230_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G2
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_4231_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G2
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_4232_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G2
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_4233_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G2
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_4234_sum_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: int > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ G2 @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ int @ A @ nat @ G2 @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_int_atMost_int_shift
thf(fact_4235_prod_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: int > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ int @ A @ G2 @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ int @ A @ nat @ G2 @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_int_atMost_int_shift
thf(fact_4236_sum_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: int > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ G2 @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ int @ A @ nat @ G2 @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_int_lessThan_int_shift
thf(fact_4237_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_4238_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_4239_prod_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: int > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ int @ A @ G2 @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ int @ A @ nat @ G2 @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_int_lessThan_int_shift
thf(fact_4240_relpowp__E,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Z2 )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y2: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( compow @ ( A > A > $o ) @ M4 @ P @ X @ Y2 )
               => ~ ( P @ Y2 @ Z2 ) ) ) ) ) ).

% relpowp_E
thf(fact_4241_relpowp__E2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Z2 )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y2: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( P @ X @ Y2 )
               => ~ ( compow @ ( A > A > $o ) @ M4 @ P @ Y2 @ Z2 ) ) ) ) ) ).

% relpowp_E2
thf(fact_4242_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_4243_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys4: list @ A] :
            ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys4 ) )
       => ( ! [Ys4: list @ A,Zs2: list @ A] :
              ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys4 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_4244_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z5: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z5: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                          @ ( set_ord_atMost @ nat @ N ) )
                        = ( zero_zero @ A ) ) ) )
                @ N ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_4245_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X3: nat,Y4: nat] : ( ord_less_eq @ nat @ Y4 @ X3 )
    @ ^ [X3: nat,Y4: nat] : ( ord_less @ nat @ Y4 @ X3 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_4246_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_4247_card__Collect__less__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) )
      = N ) ).

% card_Collect_less_nat
thf(fact_4248_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% le_inf_iff
thf(fact_4249_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_4250_Int__subset__iff,axiom,
    ! [A: $tType,C4: set @ A,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C4 @ A5 )
        & ( ord_less_eq @ ( set @ A ) @ C4 @ B6 ) ) ) ).

% Int_subset_iff
thf(fact_4251_removeAll__id,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( removeAll @ A @ X @ Xs )
        = Xs ) ) ).

% removeAll_id
thf(fact_4252_card__Collect__le__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less_eq @ nat @ I4 @ N ) ) )
      = ( suc @ N ) ) ).

% card_Collect_le_nat
thf(fact_4253_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_4254_card_Oinfinite,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ~ ( finite_finite @ A @ A5 )
     => ( ( finite_card @ A @ A5 )
        = ( zero_zero @ nat ) ) ) ).

% card.infinite
thf(fact_4255_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: A,A5: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X3: B] : Y
            @ A5 )
          = ( power_power @ A @ Y @ ( finite_card @ B @ A5 ) ) ) ) ).

% prod_constant
thf(fact_4256_card__0__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ( finite_card @ A @ A5 )
          = ( zero_zero @ nat ) )
        = ( A5
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_4257_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: A,A5: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : Y
            @ A5 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ Y ) ) ) ).

% sum_constant
thf(fact_4258_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A5: set @ B,P: B > $o] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ A5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X3: B] : ( zero_neq_one_of_bool @ A @ ( P @ X3 ) )
                @ A5 )
              = ( semiring_1_of_nat @ A @ ( finite_card @ B @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum_of_bool_eq
thf(fact_4259_bot2E,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X @ Y ) ).

% bot2E
thf(fact_4260_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_sup_ord(2)
thf(fact_4261_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_4262_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_le1
thf(fact_4263_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_le2
thf(fact_4264_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A2 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_4265_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_4266_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_4267_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_4268_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_4269_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_4270_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_4271_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( F2 @ X2 @ Y2 ) @ X2 )
         => ( ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( F2 @ X2 @ Y2 ) @ Y2 )
           => ( ! [X2: A,Y2: A,Z3: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ( ord_less_eq @ A @ X2 @ Z3 )
                   => ( ord_less_eq @ A @ X2 @ ( F2 @ Y2 @ Z3 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% inf_unique
thf(fact_4272_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y4: A] :
              ( ( inf_inf @ A @ X3 @ Y4 )
              = X3 ) ) ) ) ).

% le_iff_inf
thf(fact_4273_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_4274_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_4275_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( inf_inf @ A @ X @ Y )
            = X ) ) ) ).

% inf_absorb1
thf(fact_4276_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( inf_inf @ A @ X @ Y )
            = Y ) ) ) ).

% inf_absorb2
thf(fact_4277_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_4278_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_4279_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Z2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ) ).

% inf_greatest
thf(fact_4280_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( A3
              = ( inf_inf @ A @ A3 @ B3 ) ) ) ) ) ).

% inf.order_iff
thf(fact_4281_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_4282_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_4283_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( inf_inf @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_4284_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( inf_inf @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_4285_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_4286_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_4287_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_4288_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_4289_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( A3
                = ( inf_inf @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_4290_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_4291_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_4292_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_4293_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI2
thf(fact_4294_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI1
thf(fact_4295_Int__Collect__mono,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ A5 )
           => ( ( P @ X2 )
             => ( Q @ X2 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B6 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_4296_Int__greatest,axiom,
    ! [A: $tType,C4: set @ A,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ C4 @ B6 )
       => ( ord_less_eq @ ( set @ A ) @ C4 @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% Int_greatest
thf(fact_4297_Int__absorb2,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ B6 )
        = A5 ) ) ).

% Int_absorb2
thf(fact_4298_Int__absorb1,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ B6 )
        = B6 ) ) ).

% Int_absorb1
thf(fact_4299_Int__lower2,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) @ B6 ) ).

% Int_lower2
thf(fact_4300_Int__lower1,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) @ A5 ) ).

% Int_lower1
thf(fact_4301_Int__mono,axiom,
    ! [A: $tType,A5: set @ A,C4: set @ A,B6: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) @ ( inf_inf @ ( set @ A ) @ C4 @ D5 ) ) ) ) ).

% Int_mono
thf(fact_4302_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( removeAll @ A @ X @ Xs ) ) )
      & ( ( X != Y )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( cons @ A @ Y @ ( removeAll @ A @ X @ Xs ) ) ) ) ) ).

% removeAll.simps(2)
thf(fact_4303_n__subsets,axiom,
    ! [A: $tType,A5: set @ A,K: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B7: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B7 @ A5 )
                & ( ( finite_card @ A @ B7 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A5 ) @ K ) ) ) ).

% n_subsets
thf(fact_4304_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% distinct_removeAll
thf(fact_4305_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ~ ( finite_finite @ A @ A5 )
     => ? [B8: set @ A] :
          ( ( finite_finite @ A @ B8 )
          & ( ( finite_card @ A @ B8 )
            = N )
          & ( ord_less_eq @ ( set @ A ) @ B8 @ A5 ) ) ) ).

% infinite_arbitrarily_large
thf(fact_4306_card__subset__eq,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
       => ( ( ( finite_card @ A @ A5 )
            = ( finite_card @ A @ B6 ) )
         => ( A5 = B6 ) ) ) ) ).

% card_subset_eq
thf(fact_4307_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B6: set @ A,A5: set @ B,R2: B > A > $o] :
      ( ( finite_finite @ A @ B6 )
     => ( ! [A4: B] :
            ( ( member @ B @ A4 @ A5 )
           => ? [B10: A] :
                ( ( member @ A @ B10 @ B6 )
                & ( R2 @ A4 @ B10 ) ) )
       => ( ! [A13: B,A24: B,B4: A] :
              ( ( member @ B @ A13 @ A5 )
             => ( ( member @ B @ A24 @ A5 )
               => ( ( member @ A @ B4 @ B6 )
                 => ( ( R2 @ A13 @ B4 )
                   => ( ( R2 @ A24 @ B4 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A5 ) @ ( finite_card @ A @ B6 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_4308_card__insert__le,axiom,
    ! [A: $tType,A5: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ ( insert2 @ A @ X @ A5 ) ) ) ).

% card_insert_le
thf(fact_4309_card__lists__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A5 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_4310_length__removeAll__less__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_removeAll_less_eq
thf(fact_4311_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% inf_shunt
thf(fact_4312_card__eq__0__iff,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ( finite_card @ A @ A5 )
        = ( zero_zero @ nat ) )
      = ( ( A5
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A5 ) ) ) ).

% card_eq_0_iff
thf(fact_4313_card__ge__0__finite,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A5 ) )
     => ( finite_finite @ A @ A5 ) ) ).

% card_ge_0_finite
thf(fact_4314_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N: nat,S2: set @ A] :
      ( ( ord_less_eq @ nat @ N @ ( finite_card @ A @ S2 ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S2 )
           => ( ( ( finite_card @ A @ T7 )
                = N )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_4315_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F4: set @ A,C4: nat] :
      ( ! [G4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G4 @ F4 )
         => ( ( finite_finite @ A @ G4 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G4 ) @ C4 ) ) )
     => ( ( finite_finite @ A @ F4 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F4 ) @ C4 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_4316_card__seteq,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B6 ) @ ( finite_card @ A @ A5 ) )
         => ( A5 = B6 ) ) ) ) ).

% card_seteq
thf(fact_4317_card__mono,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B6 ) ) ) ) ).

% card_mono
thf(fact_4318_card__less__sym__Diff,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B6 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B6 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B6 @ A5 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_4319_card__le__sym__Diff,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B6 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B6 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B6 @ A5 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_4320_card__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% card_length
thf(fact_4321_psubset__card__mono,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
       => ( ord_less @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B6 ) ) ) ) ).

% psubset_card_mono
thf(fact_4322_distinct__card,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% distinct_card
thf(fact_4323_card__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( distinct @ A @ Xs ) ) ).

% card_distinct
thf(fact_4324_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A5 @ B6 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ B6 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_4325_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X @ Xs )
        = ( removeAll @ A @ X @ Xs ) ) ) ).

% distinct_remove1_removeAll
thf(fact_4326_card__less__Suc2,axiom,
    ! [M5: set @ nat,I: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M5 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K4: nat] :
                ( ( member @ nat @ ( suc @ K4 ) @ M5 )
                & ( ord_less @ nat @ K4 @ I ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K4: nat] :
                ( ( member @ nat @ K4 @ M5 )
                & ( ord_less @ nat @ K4 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_4327_card__less__Suc,axiom,
    ! [M5: set @ nat,I: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M5 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K4: nat] :
                  ( ( member @ nat @ ( suc @ K4 ) @ M5 )
                  & ( ord_less @ nat @ K4 @ I ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K4: nat] :
                ( ( member @ nat @ K4 @ M5 )
                & ( ord_less @ nat @ K4 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_4328_card__less,axiom,
    ! [M5: set @ nat,I: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M5 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K4: nat] :
                ( ( member @ nat @ K4 @ M5 )
                & ( ord_less @ nat @ K4 @ ( suc @ I ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_4329_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) )
      = ( nat2 @ U ) ) ).

% card_atLeastZeroLessThan_int
thf(fact_4330_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G2: B > A,B6: set @ B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ B6 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( member @ B @ X3 @ B6 ) @ ( G2 @ X3 ) @ ( zero_zero @ A ) )
              @ A5 ) ) ) ) ).

% sum.inter_restrict
thf(fact_4331_sum__constant__scaleR,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Y: A,A5: set @ C] :
          ( ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [X3: C] : Y
            @ A5 )
          = ( real_V8093663219630862766scaleR @ A @ ( semiring_1_of_nat @ real @ ( finite_card @ C @ A5 ) ) @ Y ) ) ) ).

% sum_constant_scaleR
thf(fact_4332_subset__card__intvl__is__intvl,axiom,
    ! [A5: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A5 ) ) ) )
     => ( A5
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A5 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_4333_real__of__card,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A5 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X3: A] : ( one_one @ real )
        @ A5 ) ) ).

% real_of_card
thf(fact_4334_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,K6: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ord_less_eq @ A @ K6 @ ( F2 @ I2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K6 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) ) ) ) ).

% sum_bounded_below
thf(fact_4335_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,F2: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ K6 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K6 ) ) ) ) ).

% sum_bounded_above
thf(fact_4336_card__gt__0__iff,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A5 ) )
      = ( ( A5
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A5 ) ) ) ).

% card_gt_0_iff
thf(fact_4337_card__Suc__eq,axiom,
    ! [A: $tType,A5: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A5 )
        = ( suc @ K ) )
      = ( ? [B3: A,B7: set @ A] :
            ( ( A5
              = ( insert2 @ A @ B3 @ B7 ) )
            & ~ ( member @ A @ B3 @ B7 )
            & ( ( finite_card @ A @ B7 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B7
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_4338_card__eq__SucD,axiom,
    ! [A: $tType,A5: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A5 )
        = ( suc @ K ) )
     => ? [B4: A,B8: set @ A] :
          ( ( A5
            = ( insert2 @ A @ B4 @ B8 ) )
          & ~ ( member @ A @ B4 @ B8 )
          & ( ( finite_card @ A @ B8 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B8
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_4339_card__1__singleton__iff,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ( finite_card @ A @ A5 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X3: A] :
            ( A5
            = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_4340_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ A5 )
             => ! [Y4: A] :
                  ( ( member @ A @ Y4 @ A5 )
                 => ( X3 = Y4 ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_4341_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A5: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( finite_card @ A @ A5 ) )
      = ( ? [A3: A,B7: set @ A] :
            ( ( A5
              = ( insert2 @ A @ A3 @ B7 ) )
            & ~ ( member @ A @ A3 @ B7 )
            & ( ord_less_eq @ nat @ N @ ( finite_card @ A @ B7 ) )
            & ( finite_finite @ A @ B7 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_4342_card__Diff1__le,axiom,
    ! [A: $tType,A5: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A5 ) ) ).

% card_Diff1_le
thf(fact_4343_card__Diff__subset,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B6 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_4344_card__psubset,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B6 ) )
         => ( ord_less @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% card_psubset
thf(fact_4345_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B6 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B6 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_4346_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,H: B > A,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H @ I2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ S2 @ T6 ) )
                   => ( ( G2 @ I2 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X2: B] :
                      ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ S2 @ T6 ) )
                     => ( ( G2 @ X2 )
                        = ( H @ X2 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H @ T6 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_4347_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,K: A] :
          ( ( ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_4348_card__lists__length__le,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A5 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_4349_length__removeAll__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_removeAll_less
thf(fact_4350_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z5: A] :
                    ( ( power_power @ A @ Z5 @ N )
                    = ( one_one @ A ) ) ) )
            @ N ) ) ) ).

% card_roots_unity
thf(fact_4351_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N4 ) @ N ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_4352_card__sum__le__nat__sum,axiom,
    ! [S2: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X3: nat] : X3
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S2 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X3: nat] : X3
        @ S2 ) ) ).

% card_sum_le_nat_sum
thf(fact_4353_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z5: complex] :
                  ( ( power_power @ complex @ Z5 @ N )
                  = C2 ) ) )
          = N ) ) ) ).

% card_nth_roots
thf(fact_4354_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = ( one_one @ complex ) ) ) )
        = N ) ) ).

% card_roots_unity_eq
thf(fact_4355_card__Diff1__less,axiom,
    ! [A: $tType,A5: set @ A,X: A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( member @ A @ X @ A5 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A5 ) ) ) ) ).

% card_Diff1_less
thf(fact_4356_card__Diff2__less,axiom,
    ! [A: $tType,A5: set @ A,X: A,Y: A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( member @ A @ X @ A5 )
       => ( ( member @ A @ Y @ A5 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A5 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_4357_card__Diff1__less__iff,axiom,
    ! [A: $tType,A5: set @ A,X: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A5 ) )
      = ( ( finite_finite @ A @ A5 )
        & ( member @ A @ X @ A5 ) ) ) ).

% card_Diff1_less_iff
thf(fact_4358_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,K6: real] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) @ K6 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S2 ) ) @ K6 ) ) ) ) ).

% sum_norm_bound
thf(fact_4359_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A5: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A5 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = K )
                & ( distinct @ A @ Xs3 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X3: nat] : X3
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A5 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_4360_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A5: set @ A,K: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A5 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = K )
                  & ( distinct @ A @ Xs3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X3: nat] : X3
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A5 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_4361_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A,N: A,K: nat] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                & ( ord_less_eq @ A @ ( F2 @ I2 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A5 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_4362_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A5: set @ B,F2: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( divide_divide @ A @ K6 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) ) ) )
         => ( ( finite_finite @ B @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ K6 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_4363_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,F2: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ord_less @ A @ ( F2 @ I2 ) @ K6 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A5 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K6 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_4364_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y: set @ A,X: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert2 @ A @ X @ Y ) ) @ N ) ) ) ).

% card_insert_le_m1
thf(fact_4365_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z5: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              @ N ) ) ) ) ).

% polyfun_roots_card
thf(fact_4366_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A2 ) @ ( B2 @ K4 ) @ C2 )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S2 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A2 ) @ ( B2 @ K4 ) @ C2 )
                  @ S2 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S2 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_4367_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys3: list @ A] :
            ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
        & ! [Ys3: list @ A,Zs3: list @ A] :
            ( ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys3 != Zs3 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_4368_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_4369_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X5: A] :
                  ( ( member @ A @ X5 @ S2 )
                  & ( ord_less @ B @ ( F2 @ X5 ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_4370_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) )
          @ Xa
          @ X ) ) ) ).

% times_int.abs_eq
thf(fact_4371_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X: A] :
      ( ( ( list_update @ A @ Xs @ K @ X )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_update_nonempty
thf(fact_4372_concat__replicate__trivial,axiom,
    ! [A: $tType,I: nat] :
      ( ( concat @ A @ ( replicate @ ( list @ A ) @ I @ ( nil @ A ) ) )
      = ( nil @ A ) ) ).

% concat_replicate_trivial
thf(fact_4373_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N: nat] :
      ( ( enumerate @ A @ N @ ( nil @ A ) )
      = ( nil @ ( product_prod @ nat @ A ) ) ) ).

% enumerate_simps(1)
thf(fact_4374_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate1_is_Nil_conv
thf(fact_4375_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_4376_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_4377_length__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( zero_zero @ nat ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_4378_replicate__empty,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( replicate @ A @ N @ X )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_4379_empty__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_4380_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_4381_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( nil @ A )
        = ( concat @ A @ Xss ) )
      = ( ! [X3: list @ A] :
            ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X3
              = ( nil @ A ) ) ) ) ) ).

% Nil_eq_concat_conv
thf(fact_4382_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xss )
        = ( nil @ A ) )
      = ( ! [X3: list @ A] :
            ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X3
              = ( nil @ A ) ) ) ) ) ).

% concat_eq_Nil_conv
thf(fact_4383_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_4384_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( Xs
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_4385_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( removeAll @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% removeAll.simps(1)
thf(fact_4386_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rotate1.simps(1)
thf(fact_4387_list__update__code_I1_J,axiom,
    ! [A: $tType,I: nat,Y: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I @ Y )
      = ( nil @ A ) ) ).

% list_update_code(1)
thf(fact_4388_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I: nat,V2: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I @ V2 )
      = ( nil @ A ) ) ).

% list_update.simps(1)
thf(fact_4389_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu: list @ B] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% product.simps(1)
thf(fact_4390_int_Oabs__induct,axiom,
    ! [P: int > $o,X: int] :
      ( ! [Y2: product_prod @ nat @ nat] : ( P @ ( abs_Integ @ Y2 ) )
     => ( P @ X ) ) ).

% int.abs_induct
thf(fact_4391_concat_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( concat @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ A ) ) ).

% concat.simps(1)
thf(fact_4392_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F5: A > B,Bs2: list @ B] :
          ( X
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F5 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F5: A > B,A4: A,As: list @ A,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F5 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A4 @ As ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_4393_splice_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ~ ! [X2: A,Xs2: list @ A,Ys4: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Ys4 ) ) ) ).

% splice.cases
thf(fact_4394_shuffles_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ( ! [Xs2: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
       => ~ ! [X2: A,Xs2: list @ A,Y2: A,Ys4: list @ A] :
              ( X
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) ) ).

% shuffles.cases
thf(fact_4395_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ~ ! [P8: A > A > $o,X2: A,Ys4: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X2 @ Ys4 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_4396_successively_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ( ! [P8: A > A > $o,X2: A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
       => ~ ! [P8: A > A > $o,X2: A,Y2: A,Xs2: list @ A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) ).

% successively.cases
thf(fact_4397_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F5: A > B,X2: A] :
              ( X
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F5 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
         => ( ! [F5: A > B,X2: A,Y2: A,Zs2: list @ A] :
                ( X
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F5 @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs2 ) ) ) )
           => ~ ! [A4: A > B] :
                  ( X
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A4 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_4398_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_4399_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] : ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X2 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% list_nonempty_induct
thf(fact_4400_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P: ( list @ A ) > ( list @ B ) > $o,Xs: list @ A,Ys2: list @ B] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X2: A,Xs2: list @ A] : ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y2: B,Ys4: list @ B] : ( P @ ( nil @ A ) @ ( cons @ B @ Y2 @ Ys4 ) )
         => ( ! [X2: A,Xs2: list @ A,Y2: B,Ys4: list @ B] :
                ( ( P @ Xs2 @ Ys4 )
               => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) ) )
           => ( P @ Xs @ Ys2 ) ) ) ) ) ).

% list_induct2'
thf(fact_4401_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
         != ( nil @ A ) ) )
      = ( ? [Y4: A,Ys3: list @ A] :
            ( Xs
            = ( cons @ A @ Y4 @ Ys3 ) ) ) ) ).

% neq_Nil_conv
thf(fact_4402_remdups__adj_Ocases,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( X
           != ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ~ ! [X2: A,Y2: A,Xs2: list @ A] :
              ( X
             != ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ).

% remdups_adj.cases
thf(fact_4403_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A] :
          ( ! [X2: A,Xs2: list @ A] :
              ( X
             != ( cons @ A @ X2 @ Xs2 ) )
         => ( X
            = ( nil @ A ) ) ) ) ).

% min_list.cases
thf(fact_4404_list_Oexhaust,axiom,
    ! [A: $tType,Y: list @ A] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ! [X212: A,X222: list @ A] :
            ( Y
           != ( cons @ A @ X212 @ X222 ) ) ) ).

% list.exhaust
thf(fact_4405_list_OdiscI,axiom,
    ! [A: $tType,List: list @ A,X21: A,X22: list @ A] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) ).

% list.discI
thf(fact_4406_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) ).

% list.distinct(1)
thf(fact_4407_transpose_Ocases,axiom,
    ! [A: $tType,X: list @ ( list @ A )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss2: list @ ( list @ A )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
       => ~ ! [X2: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
              ( X
             != ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Xss2 ) ) ) ) ).

% transpose.cases
thf(fact_4408_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% product_lists.simps(1)
thf(fact_4409_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( subseqs @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% subseqs.simps(1)
thf(fact_4410_eq__Abs__Integ,axiom,
    ! [Z2: int] :
      ~ ! [X2: nat,Y2: nat] :
          ( Z2
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X2 @ Y2 ) ) ) ).

% eq_Abs_Integ
thf(fact_4411_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remove1 @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remove1.simps(1)
thf(fact_4412_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : ( distinct @ A @ ( nil @ A ) ) ).

% distinct.simps(1)
thf(fact_4413_gen__length__code_I1_J,axiom,
    ! [A: $tType,N: nat] :
      ( ( gen_length @ A @ N @ ( nil @ A ) )
      = N ) ).

% gen_length_code(1)
thf(fact_4414_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_4415_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_4416_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ C,Ws: list @ D,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys2 )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws ) )
         => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X2: A,Xs2: list @ A,Y2: B,Ys4: list @ B,Z3: C,Zs2: list @ C,W: D,Ws2: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = ( size_size @ ( list @ B ) @ Ys4 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws2 ) )
                     => ( ( P @ Xs2 @ Ys4 @ Zs2 @ Ws2 )
                       => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) @ ( cons @ C @ Z3 @ Zs2 ) @ ( cons @ D @ W @ Ws2 ) ) ) ) ) )
             => ( P @ Xs @ Ys2 @ Zs @ Ws ) ) ) ) ) ) ).

% list_induct4
thf(fact_4417_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ C,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys2 )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X2: A,Xs2: list @ A,Y2: B,Ys4: list @ B,Z3: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = ( size_size @ ( list @ B ) @ Ys4 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P @ Xs2 @ Ys4 @ Zs2 )
                   => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) @ ( cons @ C @ Z3 @ Zs2 ) ) ) ) )
           => ( P @ Xs @ Ys2 @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_4418_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,P: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X2: A,Xs2: list @ A,Y2: B,Ys4: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = ( size_size @ ( list @ B ) @ Ys4 ) )
             => ( ( P @ Xs2 @ Ys4 )
               => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) ) ) )
         => ( P @ Xs @ Ys2 ) ) ) ) ).

% list_induct2
thf(fact_4419_distinct__singleton,axiom,
    ! [A: $tType,X: A] : ( distinct @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% distinct_singleton
thf(fact_4420_replicate__0,axiom,
    ! [A: $tType,X: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_4421_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_list @ A @ X @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_4422_nat_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( nat2 @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ X ) ) ).

% nat.abs_eq
thf(fact_4423_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_4424_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_4425_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N3: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N3 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_4426_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X3: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X3 )
          @ X ) ) ) ).

% uminus_int.abs_eq
thf(fact_4427_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) @ S2 ) ) ) ) ).

% arg_min_if_finite(1)
thf(fact_4428_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_4429_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) )
            @ X ) ) ) ).

% of_int.abs_eq
thf(fact_4430_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X3: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) )
        @ Xa
        @ X ) ) ).

% less_int.abs_eq
thf(fact_4431_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X3: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) )
        @ Xa
        @ X ) ) ).

% less_eq_int.abs_eq
thf(fact_4432_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) )
          @ Xa
          @ X ) ) ) ).

% plus_int.abs_eq
thf(fact_4433_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) )
          @ Xa
          @ X ) ) ) ).

% minus_int.abs_eq
thf(fact_4434_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,Y: A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y @ S2 )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) @ ( F2 @ Y ) ) ) ) ) ) ).

% arg_min_least
thf(fact_4435_concat__inth,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys2: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X ) ).

% concat_inth
thf(fact_4436_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_4437_upto_Opsimps,axiom,
    ! [I: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I @ J ) )
     => ( ( ( ord_less_eq @ int @ I @ J )
         => ( ( upto @ I @ J )
            = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I @ J )
         => ( ( upto @ I @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_4438_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_4439_append_Oassoc,axiom,
    ! [A: $tType,A2: list @ A,B2: list @ A,C2: list @ A] :
      ( ( append @ A @ ( append @ A @ A2 @ B2 ) @ C2 )
      = ( append @ A @ A2 @ ( append @ A @ B2 @ C2 ) ) ) ).

% append.assoc
thf(fact_4440_append__assoc,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys2 ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys2 @ Zs ) ) ) ).

% append_assoc
thf(fact_4441_append__same__eq,axiom,
    ! [A: $tType,Ys2: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Ys2 @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys2 = Zs ) ) ).

% append_same_eq
thf(fact_4442_same__append__eq,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys2 = Zs ) ) ).

% same_append_eq
thf(fact_4443_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) ).

% append_is_Nil_conv
thf(fact_4444_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys2 ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) ).

% Nil_is_append_conv
thf(fact_4445_self__append__conv2,axiom,
    ! [A: $tType,Y: list @ A,Xs: list @ A] :
      ( ( Y
        = ( append @ A @ Xs @ Y ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% self_append_conv2
thf(fact_4446_append__self__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = Ys2 )
      = ( Xs
        = ( nil @ A ) ) ) ).

% append_self_conv2
thf(fact_4447_self__append__conv,axiom,
    ! [A: $tType,Y: list @ A,Ys2: list @ A] :
      ( ( Y
        = ( append @ A @ Y @ Ys2 ) )
      = ( Ys2
        = ( nil @ A ) ) ) ).

% self_append_conv
thf(fact_4448_append__self__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = Xs )
      = ( Ys2
        = ( nil @ A ) ) ) ).

% append_self_conv
thf(fact_4449_append__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% append_Nil2
thf(fact_4450_append_Oright__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ A2 @ ( nil @ A ) )
      = A2 ) ).

% append.right_neutral
thf(fact_4451_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys2 ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys2 @ Vs ) )
        = ( ( Xs = Ys2 )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_4452_concat__append,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys2: list @ ( list @ A )] :
      ( ( concat @ A @ ( append @ ( list @ A ) @ Xs @ Ys2 ) )
      = ( append @ A @ ( concat @ A @ Xs ) @ ( concat @ A @ Ys2 ) ) ) ).

% concat_append
thf(fact_4453_removeAll__append,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A] :
      ( ( removeAll @ A @ X @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( removeAll @ A @ X @ Xs ) @ ( removeAll @ A @ X @ Ys2 ) ) ) ).

% removeAll_append
thf(fact_4454_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys2: list @ A,Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys2 @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys2 )
        & ( X = Y ) ) ) ).

% append1_eq_conv
thf(fact_4455_length__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ).

% length_append
thf(fact_4456_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A,Ys2: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ F2 @ Ys2 ) ) ) ).

% size_list_append
thf(fact_4457_upto__empty,axiom,
    ! [J: int,I: int] :
      ( ( ord_less @ int @ J @ I )
     => ( ( upto @ I @ J )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_4458_upto__Nil2,axiom,
    ! [I: int,J: int] :
      ( ( ( nil @ int )
        = ( upto @ I @ J ) )
      = ( ord_less @ int @ J @ I ) ) ).

% upto_Nil2
thf(fact_4459_upto__Nil,axiom,
    ! [I: int,J: int] :
      ( ( ( upto @ I @ J )
        = ( nil @ int ) )
      = ( ord_less @ int @ J @ I ) ) ).

% upto_Nil
thf(fact_4460_upto__single,axiom,
    ! [I: int] :
      ( ( upto @ I @ I )
      = ( cons @ int @ I @ ( nil @ int ) ) ) ).

% upto_single
thf(fact_4461_nth__append__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys2: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X ) ).

% nth_append_length
thf(fact_4462_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,N: nat] :
      ( ( nth @ A @ ( append @ A @ Xs @ Ys2 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
      = ( nth @ A @ Ys2 @ N ) ) ).

% nth_append_length_plus
thf(fact_4463_list__update__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys2: list @ A,Y: A] :
      ( ( list_update @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) @ Y )
      = ( append @ A @ Xs @ ( cons @ A @ Y @ Ys2 ) ) ) ).

% list_update_length
thf(fact_4464_nth__upto,axiom,
    ! [I: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I @ J ) @ K )
        = ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_4465_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys2 )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_4466_length__upto,axiom,
    ! [I: int,J: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I @ J ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J @ I ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_4467_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_4468_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_4469_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_4470_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs = Ys2 )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys2 ) ) ) ).

% eq_Nil_appendI
thf(fact_4471_append_Oleft__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ A2 )
      = A2 ) ).

% append.left_neutral
thf(fact_4472_append__Nil,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ Ys2 )
      = Ys2 ) ).

% append_Nil
thf(fact_4473_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys2: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys2 @ Zs ) )
     => ( ( Xss
         != ( nil @ ( list @ A ) ) )
       => ? [Xss1: list @ ( list @ A ),Xs2: list @ A,Xs4: list @ A,Xss22: list @ ( list @ A )] :
            ( ( Xss
              = ( append @ ( list @ A ) @ Xss1 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs2 @ Xs4 ) @ Xss22 ) ) )
            & ( Ys2
              = ( append @ A @ ( concat @ A @ Xss1 ) @ Xs2 ) )
            & ( Zs
              = ( append @ A @ Xs4 @ ( concat @ A @ Xss22 ) ) ) ) ) ) ).

% concat_eq_appendD
thf(fact_4474_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys2: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys2 @ Zs ) )
      = ( ( ( Xss
            = ( nil @ ( list @ A ) ) )
         => ( ( Ys2
              = ( nil @ A ) )
            & ( Zs
              = ( nil @ A ) ) ) )
        & ( ( Xss
           != ( nil @ ( list @ A ) ) )
         => ? [Xss12: list @ ( list @ A ),Xs3: list @ A,Xs5: list @ A,Xss23: list @ ( list @ A )] :
              ( ( Xss
                = ( append @ ( list @ A ) @ Xss12 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs3 @ Xs5 ) @ Xss23 ) ) )
              & ( Ys2
                = ( append @ A @ ( concat @ A @ Xss12 ) @ Xs3 ) )
              & ( Zs
                = ( append @ A @ Xs5 @ ( concat @ A @ Xss23 ) ) ) ) ) ) ) ).

% concat_eq_append_conv
thf(fact_4475_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( enumerate @ A @ N @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ ( enumerate @ A @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys2 ) ) ) ).

% enumerate_append_eq
thf(fact_4476_distinct__upto,axiom,
    ! [I: int,J: int] : ( distinct @ int @ ( upto @ I @ J ) ) ).

% distinct_upto
thf(fact_4477_append__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A] :
      ( ( append @ A @ ( cons @ A @ X @ Xs ) @ Ys2 )
      = ( cons @ A @ X @ ( append @ A @ Xs @ Ys2 ) ) ) ).

% append_Cons
thf(fact_4478_Cons__eq__appendI,axiom,
    ! [A: $tType,X: A,Xs1: list @ A,Ys2: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs1 )
        = Ys2 )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X @ Xs )
          = ( append @ A @ Ys2 @ Zs ) ) ) ) ).

% Cons_eq_appendI
thf(fact_4479_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X: list @ A,Xs: list @ ( list @ A )] :
      ( ( concat @ A @ ( cons @ ( list @ A ) @ X @ Xs ) )
      = ( append @ A @ X @ ( concat @ A @ Xs ) ) ) ).

% concat.simps(2)
thf(fact_4480_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( append @ A @ Ys2 @ Xs ) )
     => ? [M4: nat,N2: nat,Zs2: list @ A] :
          ( ( ( concat @ A @ ( replicate @ ( list @ A ) @ M4 @ Zs2 ) )
            = Xs )
          & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N2 @ Zs2 ) )
            = Ys2 ) ) ) ).

% comm_append_are_replicate
thf(fact_4481_upto__aux__def,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int] : ( append @ int @ ( upto @ I4 @ J3 ) ) ) ) ).

% upto_aux_def
thf(fact_4482_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Xs1: list @ A,Zs: list @ A,Ys2: list @ A,Us: list @ A] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys2
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys2 )
          = ( append @ A @ Zs @ Us ) ) ) ) ).

% append_eq_appendI
thf(fact_4483_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A,Ts: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: list @ A] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys2 )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys2
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) ).

% append_eq_append_conv2
thf(fact_4484_append__replicate__commute,axiom,
    ! [A: $tType,N: nat,X: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ K @ X ) )
      = ( append @ A @ ( replicate @ A @ K @ X ) @ ( replicate @ A @ N @ X ) ) ) ).

% append_replicate_commute
thf(fact_4485_atLeastAtMost__upto,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ I4 @ J3 ) ) ) ) ).

% atLeastAtMost_upto
thf(fact_4486_upto__split1,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_4487_upto__split2,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_4488_upto__code,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( upto_aux @ I4 @ J3 @ ( nil @ int ) ) ) ) ).

% upto_code
thf(fact_4489_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] : ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% rev_nonempty_induct
thf(fact_4490_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys2: list @ A,Zs: list @ A,X: A,Xs: list @ A] :
      ( ( ( append @ A @ Ys2 @ Zs )
        = ( cons @ A @ X @ Xs ) )
      = ( ( ( Ys2
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X @ Xs ) ) )
        | ? [Ys5: list @ A] :
            ( ( Ys2
              = ( cons @ A @ X @ Ys5 ) )
            & ( ( append @ A @ Ys5 @ Zs )
              = Xs ) ) ) ) ).

% append_eq_Cons_conv
thf(fact_4491_Cons__eq__append__conv,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( append @ A @ Ys2 @ Zs ) )
      = ( ( ( Ys2
            = ( nil @ A ) )
          & ( ( cons @ A @ X @ Xs )
            = Zs ) )
        | ? [Ys5: list @ A] :
            ( ( ( cons @ A @ X @ Ys5 )
              = Ys2 )
            & ( Xs
              = ( append @ A @ Ys5 @ Zs ) ) ) ) ) ).

% Cons_eq_append_conv
thf(fact_4492_rev__exhaust,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ! [Ys4: list @ A,Y2: A] :
            ( Xs
           != ( append @ A @ Ys4 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% rev_exhaust
thf(fact_4493_rev__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X2: A,Xs2: list @ A] :
            ( ( P @ Xs2 )
           => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) ).

% rev_induct
thf(fact_4494_split__list,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( Xs
          = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) ) ) ).

% split_list
thf(fact_4495_split__list__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Zs2 ) ) ) ) ).

% split_list_last
thf(fact_4496_split__list__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ? [Ys4: list @ A,X2: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ( P @ X2 ) ) ) ).

% split_list_prop
thf(fact_4497_split__list__first,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Ys4 ) ) ) ) ).

% split_list_first
thf(fact_4498_split__list__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ~ ! [Ys4: list @ A,X2: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
           => ~ ( P @ X2 ) ) ) ).

% split_list_propE
thf(fact_4499_append__Cons__eq__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A,Xs6: list @ A,Ys6: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( member @ A @ X @ ( set2 @ A @ Ys2 ) )
       => ( ( ( append @ A @ Xs @ ( cons @ A @ X @ Ys2 ) )
            = ( append @ A @ Xs6 @ ( cons @ A @ X @ Ys6 ) ) )
          = ( ( Xs = Xs6 )
            & ( Ys2 = Ys6 ) ) ) ) ) ).

% append_Cons_eq_iff
thf(fact_4500_in__set__conv__decomp,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp
thf(fact_4501_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ? [Ys4: list @ A,X2: A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ( P @ X2 )
          & ! [Xa2: A] :
              ( ( member @ A @ Xa2 @ ( set2 @ A @ Zs2 ) )
             => ~ ( P @ Xa2 ) ) ) ) ).

% split_list_last_prop
thf(fact_4502_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ? [Ys4: list @ A,X2: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ( P @ X2 )
          & ! [Xa2: A] :
              ( ( member @ A @ Xa2 @ ( set2 @ A @ Ys4 ) )
             => ~ ( P @ Xa2 ) ) ) ) ).

% split_list_first_prop
thf(fact_4503_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ~ ! [Ys4: list @ A,X2: A,Zs2: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
           => ( ( P @ X2 )
             => ~ ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ ( set2 @ A @ Zs2 ) )
                   => ~ ( P @ Xa2 ) ) ) ) ) ).

% split_list_last_propE
thf(fact_4504_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ~ ! [Ys4: list @ A,X2: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
           => ( ( P @ X2 )
             => ~ ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ ( set2 @ A @ Ys4 ) )
                   => ~ ( P @ Xa2 ) ) ) ) ) ).

% split_list_first_propE
thf(fact_4505_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp_last
thf(fact_4506_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Ys3 ) ) ) ) ) ).

% in_set_conv_decomp_first
thf(fact_4507_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            & ( P @ X3 ) ) )
      = ( ? [Ys3: list @ A,X3: A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs3 ) ) )
            & ( P @ X3 )
            & ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( set2 @ A @ Zs3 ) )
               => ~ ( P @ Y4 ) ) ) ) ) ).

% split_list_last_prop_iff
thf(fact_4508_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            & ( P @ X3 ) ) )
      = ( ? [Ys3: list @ A,X3: A] :
            ( ? [Zs3: list @ A] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs3 ) ) )
            & ( P @ X3 )
            & ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( set2 @ A @ Ys3 ) )
               => ~ ( P @ Y4 ) ) ) ) ) ).

% split_list_first_prop_iff
thf(fact_4509_replicate__app__Cons__same,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( append @ A @ ( replicate @ A @ N @ X ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( append @ A @ ( replicate @ A @ N @ X ) @ Xs ) ) ) ).

% replicate_app_Cons_same
thf(fact_4510_replicate__add,axiom,
    ! [A: $tType,N: nat,M: nat,X: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N @ M ) @ X )
      = ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ M @ X ) ) ) ).

% replicate_add
thf(fact_4511_upto__rec2,axiom,
    ! [I: int,J: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( upto @ I @ J )
        = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_4512_remove1__append,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ ( remove1 @ A @ X @ Xs ) @ Ys2 ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ Xs @ ( remove1 @ A @ X @ Ys2 ) ) ) ) ) ).

% remove1_append
thf(fact_4513_upto__split3,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_4514_same__length__different,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs != Ys2 )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys2 ) )
       => ? [Pre: list @ A,X2: A,Xs4: list @ A,Y2: A,Ys7: list @ A] :
            ( ( X2 != Y2 )
            & ( Xs
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ Xs4 ) ) )
            & ( Ys2
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ Ys7 ) ) ) ) ) ) ).

% same_length_different
thf(fact_4515_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list @ A] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs2: list @ A,Ys4: list @ A,Zs2: list @ A,Y2: A] :
          ( Ws
          = ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ ( append @ A @ Ys4 @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_decomp
thf(fact_4516_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As2: list @ A] :
      ( ( ~ ( distinct @ A @ As2 ) )
      = ( ? [Xs3: list @ A,Y4: A,Ys3: list @ A] :
            ( ( member @ A @ Y4 @ ( set2 @ A @ Xs3 ) )
            & ( distinct @ A @ Xs3 )
            & ( As2
              = ( append @ A @ Xs3 @ ( cons @ A @ Y4 @ Ys3 ) ) ) ) ) ) ).

% not_distinct_conv_prefix
thf(fact_4517_replicate__append__same,axiom,
    ! [A: $tType,I: nat,X: A] :
      ( ( append @ A @ ( replicate @ A @ I @ X ) @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( replicate @ A @ I @ X ) ) ) ).

% replicate_append_same
thf(fact_4518_list__update__append1,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,Ys2: list @ A,X: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ ( append @ A @ Xs @ Ys2 ) @ I @ X )
        = ( append @ A @ ( list_update @ A @ Xs @ I @ X ) @ Ys2 ) ) ) ).

% list_update_append1
thf(fact_4519_remove1__split,axiom,
    ! [A: $tType,A2: A,Xs: list @ A,Ys2: list @ A] :
      ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
     => ( ( ( remove1 @ A @ A2 @ Xs )
          = Ys2 )
        = ( ? [Ls: list @ A,Rs: list @ A] :
              ( ( Xs
                = ( append @ A @ Ls @ ( cons @ A @ A2 @ Rs ) ) )
              & ~ ( member @ A @ A2 @ ( set2 @ A @ Ls ) )
              & ( Ys2
                = ( append @ A @ Ls @ Rs ) ) ) ) ) ) ).

% remove1_split
thf(fact_4520_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( rotate1 @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rotate1.simps(2)
thf(fact_4521_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_4522_length__append__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_append_singleton
thf(fact_4523_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y4: A,Ys3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ Y4 @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_4524_nth__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys2 ) @ N )
          = ( nth @ A @ Xs @ N ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys2 ) @ N )
          = ( nth @ A @ Ys2 @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nth_append
thf(fact_4525_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A,X: A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys2 ) @ N @ X )
          = ( append @ A @ ( list_update @ A @ Xs @ N @ X ) @ Ys2 ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys2 ) @ N @ X )
          = ( append @ A @ Xs @ ( list_update @ A @ Ys2 @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ X ) ) ) ) ) ).

% list_update_append
thf(fact_4526_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys2
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs @ Ys2 )
            = ( append @ A @ Ys2 @ Xs ) )
         => ? [N2: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N2 @ Zs2 ) )
                = ( append @ A @ Xs @ Ys2 ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_4527_upto__rec1,axiom,
    ! [I: int,J: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( upto @ I @ J )
        = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_4528_upto_Osimps,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I4 @ J3 ) @ ( cons @ int @ I4 @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_4529_upto_Oelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( ( ord_less_eq @ int @ X @ Xa )
         => ( Y
            = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X @ Xa )
         => ( Y
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_4530_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A2: A,Xs: list @ B,Ys2: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( append @ B @ Xs @ Ys2 ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Ys2 ) ) ) ) ) ).

% horner_sum_append
thf(fact_4531_extract__SomeE,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A,Y: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys2 @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs ) ) ) )
     => ( ( Xs
          = ( append @ A @ Ys2 @ ( cons @ A @ Y @ Zs ) ) )
        & ( P @ Y )
        & ~ ? [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Ys2 ) )
              & ( P @ X5 ) ) ) ) ).

% extract_SomeE
thf(fact_4532_extract__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A,Y: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys2 @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs ) ) ) )
      = ( ( Xs
          = ( append @ A @ Ys2 @ ( cons @ A @ Y @ Zs ) ) )
        & ( P @ Y )
        & ~ ? [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Ys2 ) )
              & ( P @ X3 ) ) ) ) ).

% extract_Some_iff
thf(fact_4533_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X3: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y4: nat,Z5: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z5 ) ) )
          @ ( rep_Integ @ X3 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_4534_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X3: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y4: nat,Z5: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z5 ) ) )
          @ ( rep_Integ @ X3 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_4535_extract__Nil__code,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( extract @ A @ P @ ( nil @ A ) )
      = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

% extract_Nil_code
thf(fact_4536_extract__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) )
      = ( ~ ? [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
              & ( P @ X3 ) ) ) ) ).

% extract_None_iff
thf(fact_4537_nat_Orep__eq,axiom,
    ( nat2
    = ( ^ [X3: int] : ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ ( rep_Integ @ X3 ) ) ) ) ).

% nat.rep_eq
thf(fact_4538_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X3: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) )
              @ ( rep_Integ @ X3 ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_4539_extract__Cons__code,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X @ Xs ) ) ) ) )
      & ( ~ ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys3: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y4: A,Zs3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X @ Ys3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y4 @ Zs3 ) ) ) ) )
            @ ( extract @ A @ P @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_4540_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys2 ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_4541_card__Pow,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A5 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A5 ) ) ) ) ).

% card_Pow
thf(fact_4542_finite__enumerate,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [R: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S2 ) ) )
          & ! [N6: nat] :
              ( ( ord_less @ nat @ N6 @ ( finite_card @ nat @ S2 ) )
             => ( member @ nat @ ( R @ N6 ) @ S2 ) ) ) ) ).

% finite_enumerate
thf(fact_4543_Pow__iff,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( member @ ( set @ A ) @ A5 @ ( pow2 @ A @ B6 ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ).

% Pow_iff
thf(fact_4544_PowI,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( member @ ( set @ A ) @ A5 @ ( pow2 @ A @ B6 ) ) ) ).

% PowI
thf(fact_4545_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys2 ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) ).

% Nil_in_shuffles
thf(fact_4546_finite__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] : ( finite_finite @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys2 ) ) ).

% finite_shuffles
thf(fact_4547_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B7: set @ A] : ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) ) ).

% Pow_def
thf(fact_4548_shuffles__commutes,axiom,
    ! [A: $tType] :
      ( ( shuffles @ A )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] : ( shuffles @ A @ Ys3 @ Xs3 ) ) ) ).

% shuffles_commutes
thf(fact_4549_PowD,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( member @ ( set @ A ) @ A5 @ ( pow2 @ A @ B6 ) )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ).

% PowD
thf(fact_4550_Pow__mono,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A5 ) @ ( pow2 @ A @ B6 ) ) ) ).

% Pow_mono
thf(fact_4551_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A,Z2: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Z2 @ Ys2 ) ) ) ) ).

% Cons_in_shuffles_rightI
thf(fact_4552_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A,Z2: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ ( cons @ A @ Z2 @ Xs ) @ Ys2 ) ) ) ).

% Cons_in_shuffles_leftI
thf(fact_4553_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( Ys2
          = ( nil @ A ) )
       => ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys2 ) ) ) ) ).

% Nil_in_shufflesI
thf(fact_4554_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert2 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_4555_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys2 )
      = ( insert2 @ ( list @ A ) @ Ys2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_4556_shufflesE,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( ( ( Zs = Xs )
         => ( Ys2
           != ( nil @ A ) ) )
       => ( ( ( Zs = Ys2 )
           => ( Xs
             != ( nil @ A ) ) )
         => ( ! [X2: A,Xs4: list @ A] :
                ( ( Xs
                  = ( cons @ A @ X2 @ Xs4 ) )
               => ! [Z3: A,Zs4: list @ A] :
                    ( ( Zs
                      = ( cons @ A @ Z3 @ Zs4 ) )
                   => ( ( X2 = Z3 )
                     => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs4 @ Ys2 ) ) ) ) )
           => ~ ! [Y2: A,Ys7: list @ A] :
                  ( ( Ys2
                    = ( cons @ A @ Y2 @ Ys7 ) )
                 => ! [Z3: A,Zs4: list @ A] :
                      ( ( Zs
                        = ( cons @ A @ Z3 @ Zs4 ) )
                     => ( ( Y2 = Z3 )
                       => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs @ Ys7 ) ) ) ) ) ) ) ) ) ).

% shufflesE
thf(fact_4557_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ) ).

% length_shuffles
thf(fact_4558_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert2 @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_4559_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys2 )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_4560_binomial__def,axiom,
    ( binomial
    = ( ^ [N3: nat,K4: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K5: set @ nat] :
                ( ( member @ ( set @ nat ) @ K5 @ ( pow2 @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
                & ( ( finite_card @ nat @ K5 )
                  = K4 ) ) ) ) ) ) ).

% binomial_def
thf(fact_4561_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F3: A > B,A7: set @ A] :
            ! [R5: A,S6: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S6 @ A7 )
                & ( ord_less @ A @ R5 @ S6 ) )
             => ( ord_less @ B @ ( F3 @ R5 ) @ ( F3 @ S6 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_4562_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A5: set @ A,F2: A > B] :
          ( ! [R: A,S3: A] :
              ( ( member @ A @ R @ A5 )
             => ( ( member @ A @ S3 @ A5 )
               => ( ( ord_less @ A @ R @ S3 )
                 => ( ord_less @ B @ ( F2 @ R ) @ ( F2 @ S3 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A5 ) ) ) ).

% strict_mono_onI
thf(fact_4563_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A5: set @ A,R2: A,S: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A5 )
         => ( ( member @ A @ R2 @ A5 )
           => ( ( member @ A @ S @ A5 )
             => ( ( ord_less @ A @ R2 @ S )
               => ( ord_less @ B @ ( F2 @ R2 ) @ ( F2 @ S ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_4564_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A5: set @ A,X: A,Y: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( member @ A @ Y @ A5 )
             => ( ( ord_less_eq @ A @ X @ Y )
               => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_4565_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
     => ( ( shuffles @ A @ ( nil @ A ) @ Ys2 )
        = ( insert2 @ ( list @ A ) @ Ys2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(1)
thf(fact_4566_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) )
     => ( ( shuffles @ A @ Xs @ ( nil @ A ) )
        = ( insert2 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(2)
thf(fact_4567_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_4568_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A12: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A12 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [Xs2: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
             => ( P @ Xs2 @ ( nil @ A ) ) )
         => ( ! [X2: A,Xs2: list @ A,Y2: A,Ys4: list @ A] :
                ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) )
               => ( ( P @ Xs2 @ ( cons @ A @ Y2 @ Ys4 ) )
                 => ( ( P @ ( cons @ A @ X2 @ Xs2 ) @ Ys4 )
                   => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) )
           => ( P @ A0 @ A12 ) ) ) ) ) ).

% shuffles.pinduct
thf(fact_4569_splice_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A12: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A12 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [X2: A,Xs2: list @ A,Ys4: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Ys4 ) )
             => ( ( P @ Ys4 @ Xs2 )
               => ( P @ ( cons @ A @ X2 @ Xs2 ) @ Ys4 ) ) )
         => ( P @ A0 @ A12 ) ) ) ) ).

% splice.pinduct
thf(fact_4570_card__UNION,axiom,
    ! [A: $tType,A5: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A5 )
     => ( ! [X2: set @ A] :
            ( ( member @ ( set @ A ) @ X2 @ A5 )
           => ( finite_finite @ A @ X2 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I8: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I8 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I8 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I8: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I8 @ A5 )
                    & ( I8
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_4571_the__elem__set,axiom,
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) ).

% the_elem_set
thf(fact_4572_cSup__lessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A )
        & ( no_bot @ A ) )
     => ! [X: A] :
          ( ( complete_Sup_Sup @ A @ ( set_ord_lessThan @ A @ X ) )
          = X ) ) ).

% cSup_lessThan
thf(fact_4573_cSup__atMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Sup_Sup @ A @ ( set_ord_atMost @ A @ X ) )
          = X ) ) ).

% cSup_atMost
thf(fact_4574_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastAtMost
thf(fact_4575_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastAtMost
thf(fact_4576_cSup__singleton,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% cSup_singleton
thf(fact_4577_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastAtMost
thf(fact_4578_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastAtMost
thf(fact_4579_cInf__singleton,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% cInf_singleton
thf(fact_4580_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastLessThan
thf(fact_4581_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastLessThan
thf(fact_4582_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastLessThan
thf(fact_4583_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastLessThan
thf(fact_4584_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z2: A,X8: set @ A] :
          ( ( member @ A @ Z2 @ X8 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X8 )
               => ( ord_less_eq @ A @ X2 @ Z2 ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = Z2 ) ) ) ) ).

% cSup_eq_maximum
thf(fact_4585_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ X8 )
             => ( ord_less_eq @ A @ X2 @ A2 ) )
         => ( ! [Y2: A] :
                ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X8 )
                   => ( ord_less_eq @ A @ X5 @ Y2 ) )
               => ( ord_less_eq @ A @ A2 @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_4586_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z2: A,X8: set @ A] :
          ( ( member @ A @ Z2 @ X8 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X8 )
               => ( ord_less_eq @ A @ Z2 @ X2 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = Z2 ) ) ) ) ).

% cInf_eq_minimum
thf(fact_4587_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ X8 )
             => ( ord_less_eq @ A @ A2 @ X2 ) )
         => ( ! [Y2: A] :
                ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X8 )
                   => ( ord_less_eq @ A @ Y2 @ X5 ) )
               => ( ord_less_eq @ A @ Y2 @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_4588_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X8 )
               => ( ord_less_eq @ A @ A2 @ X2 ) )
           => ( ! [Y2: A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ X8 )
                     => ( ord_less_eq @ A @ Y2 @ X5 ) )
                 => ( ord_less_eq @ A @ Y2 @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_4589_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X8 )
               => ( ord_less_eq @ A @ Z2 @ X2 ) )
           => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ).

% cInf_greatest
thf(fact_4590_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X8 ) @ X ) ) ) ) ).

% cInf_le_finite
thf(fact_4591_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X8 ) @ Z2 )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ X8 )
                & ( ord_less @ A @ X2 @ Z2 ) ) ) ) ) ).

% cInf_lessD
thf(fact_4592_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X2: A] :
                  ( ( member @ A @ X2 @ X8 )
                 => ( ord_less @ A @ A2 @ X2 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_4593_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X8 )
               => ( ord_less_eq @ A @ X2 @ A2 ) )
           => ( ! [Y2: A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ X8 )
                     => ( ord_less_eq @ A @ X5 @ Y2 ) )
                 => ( ord_less_eq @ A @ A2 @ Y2 ) )
             => ( ( complete_Sup_Sup @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_4594_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X8 )
               => ( ord_less_eq @ A @ X2 @ Z2 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X8 ) @ Z2 ) ) ) ) ).

% cSup_least
thf(fact_4595_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_4596_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z2 @ ( complete_Sup_Sup @ A @ X8 ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ X8 )
                & ( ord_less @ A @ Z2 @ X2 ) ) ) ) ) ).

% less_cSupD
thf(fact_4597_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y: A,X8: set @ A] :
          ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X8 ) )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X2: A] :
                  ( ( member @ A @ X2 @ X8 )
                 => ~ ( ord_less @ A @ Y @ X2 ) ) ) ) ) ).

% less_cSupE
thf(fact_4598_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X2: A] :
                  ( ( member @ A @ X2 @ X8 )
                 => ( ord_less @ A @ X2 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_4599_card__Union__le__sum__card,axiom,
    ! [A: $tType,U3: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U3 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U3 ) ) ).

% card_Union_le_sum_card
thf(fact_4600_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ X8 )
                   => ( ord_less @ A @ A2 @ X3 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_4601_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ X8 )
                   => ( ord_less @ A @ X3 @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_4602_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_4603_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_4604_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B6: set @ ( set @ B ),G2: B > A] :
          ( ! [X2: set @ B] :
              ( ( member @ ( set @ B ) @ X2 @ B6 )
             => ( finite_finite @ B @ X2 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B6 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B6 )
                   => ( ( A14 != A25 )
                     => ! [X2: B] :
                          ( ( member @ B @ X2 @ A14 )
                         => ( ( member @ B @ X2 @ A25 )
                           => ( ( G2 @ X2 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( complete_Sup_Sup @ ( set @ B ) @ B6 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G2 @ B6 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_4605_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U3: set @ ( set @ A )] :
      ( ! [X2: set @ A] :
          ( ( member @ ( set @ A ) @ X2 @ U3 )
         => ( finite_finite @ A @ X2 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U3 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U3 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_4606_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S2 ) @ L ) ) @ E2 ) ) ) ) ).

% cInf_asclose
thf(fact_4607_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S2 ) @ L ) ) @ E2 ) ) ) ) ).

% cSup_asclose
thf(fact_4608_Sup__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A,X: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ S2 ) )
                = X ) )
            & ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ S2 ) )
                = ( ord_max @ A @ X @ ( complete_Sup_Sup @ A @ S2 ) ) ) ) ) ) ) ).

% Sup_insert_finite
thf(fact_4609_finite__subset__Union,axiom,
    ! [A: $tType,A5: set @ A,B11: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( complete_Sup_Sup @ ( set @ A ) @ B11 ) )
       => ~ ! [F8: set @ ( set @ A )] :
              ( ( finite_finite @ ( set @ A ) @ F8 )
             => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F8 @ B11 )
               => ~ ( ord_less_eq @ ( set @ A ) @ A5 @ ( complete_Sup_Sup @ ( set @ A ) @ F8 ) ) ) ) ) ) ).

% finite_subset_Union
thf(fact_4610_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A5 )
            = ( bot_bot @ A ) )
          = ( ! [X3: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X3 )
               => ? [Y4: A] :
                    ( ( member @ A @ Y4 @ A5 )
                    & ( ord_less @ A @ Y4 @ X3 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_4611_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B6: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_4612_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ).

% Inf_le_Sup
thf(fact_4613_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_4614_Inf__nat__def1,axiom,
    ! [K6: set @ nat] :
      ( ( K6
       != ( bot_bot @ ( set @ nat ) ) )
     => ( member @ nat @ ( complete_Inf_Inf @ nat @ K6 ) @ K6 ) ) ).

% Inf_nat_def1
thf(fact_4615_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,X: A] :
          ( ! [Y2: A] :
              ( ( member @ A @ Y2 @ A5 )
             => ( ord_less_eq @ A @ Y2 @ X ) )
         => ( ! [Y2: A] :
                ( ! [Z4: A] :
                    ( ( member @ A @ Z4 @ A5 )
                   => ( ord_less_eq @ A @ Z4 @ Y2 ) )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ A5 )
              = X ) ) ) ) ).

% Sup_eqI
thf(fact_4616_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ! [A4: A] :
              ( ( member @ A @ A4 @ A5 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ B6 )
                  & ( ord_less_eq @ A @ A4 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ).

% Sup_mono
thf(fact_4617_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,Z2: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ A5 )
             => ( ord_less_eq @ A @ X2 @ Z2 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ Z2 ) ) ) ).

% Sup_least
thf(fact_4618_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A5: set @ A] :
          ( ( member @ A @ X @ A5 )
         => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ).

% Sup_upper
thf(fact_4619_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ B2 )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A5 )
               => ( ord_less_eq @ A @ X3 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_4620_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A5: set @ A,V2: A] :
          ( ( member @ A @ U @ A5 )
         => ( ( ord_less_eq @ A @ V2 @ U )
           => ( ord_less_eq @ A @ V2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% Sup_upper2
thf(fact_4621_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S2: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) )
          = ( ? [X3: A] :
                ( ( member @ A @ X3 @ S2 )
                & ( ord_less @ A @ A2 @ X3 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_4622_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,X: A] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ A5 )
             => ( ord_less_eq @ A @ X @ I2 ) )
         => ( ! [Y2: A] :
                ( ! [I3: A] :
                    ( ( member @ A @ I3 @ A5 )
                   => ( ord_less_eq @ A @ Y2 @ I3 ) )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ( complete_Inf_Inf @ A @ A5 )
              = X ) ) ) ) ).

% Inf_eqI
thf(fact_4623_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ! [B4: A] :
              ( ( member @ A @ B4 @ B6 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ A5 )
                  & ( ord_less_eq @ A @ X5 @ B4 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ).

% Inf_mono
thf(fact_4624_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A5: set @ A] :
          ( ( member @ A @ X @ A5 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ X ) ) ) ).

% Inf_lower
thf(fact_4625_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A5: set @ A,V2: A] :
          ( ( member @ A @ U @ A5 )
         => ( ( ord_less_eq @ A @ U @ V2 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ V2 ) ) ) ) ).

% Inf_lower2
thf(fact_4626_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A5: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A5 ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A5 )
               => ( ord_less_eq @ A @ B2 @ X3 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_4627_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,Z2: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ A5 )
             => ( ord_less_eq @ A @ Z2 @ X2 ) )
         => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ A5 ) ) ) ) ).

% Inf_greatest
thf(fact_4628_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S2: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 )
          = ( ? [X3: A] :
                ( ( member @ A @ X3 @ S2 )
                & ( ord_less @ A @ X3 @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_4629_Union__least,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),C4: set @ A] :
      ( ! [X9: set @ A] :
          ( ( member @ ( set @ A ) @ X9 @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ X9 @ C4 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ C4 ) ) ).

% Union_least
thf(fact_4630_Union__upper,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B6 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ B6 @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) ) ) ).

% Union_upper
thf(fact_4631_Union__subsetI,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B6: set @ ( set @ A )] :
      ( ! [X2: set @ A] :
          ( ( member @ ( set @ A ) @ X2 @ A5 )
         => ? [Y5: set @ A] :
              ( ( member @ ( set @ A ) @ Y5 @ B6 )
              & ( ord_less_eq @ ( set @ A ) @ X2 @ Y5 ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B6 ) ) ) ).

% Union_subsetI
thf(fact_4632_Inter__lower,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B6 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ B6 ) ) ).

% Inter_lower
thf(fact_4633_Inter__greatest,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),C4: set @ A] :
      ( ! [X9: set @ A] :
          ( ( member @ ( set @ A ) @ X9 @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ C4 @ X9 ) )
     => ( ord_less_eq @ ( set @ A ) @ C4 @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) ) ) ).

% Inter_greatest
thf(fact_4634_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,A5: set @ A] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A5 ) )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ Y4 @ X )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                    & ( ord_less @ A @ Y4 @ X3 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_4635_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ X )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ X @ Y4 )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                    & ( ord_less @ A @ X3 @ Y4 ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_4636_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A5 )
             => ( ord_less_eq @ A @ U @ V4 ) )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_4637_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ).

% Sup_subset_mono
thf(fact_4638_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A5 )
             => ( ord_less_eq @ A @ V4 @ U ) )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_4639_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ).

% Inf_superset_mono
thf(fact_4640_Union__Int__subset,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B6: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A5 @ B6 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B6 ) ) ) ).

% Union_Int_subset
thf(fact_4641_Union__mono,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B6: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B6 ) ) ) ).

% Union_mono
thf(fact_4642_Inter__anti__mono,axiom,
    ! [A: $tType,B6: set @ ( set @ A ),A5: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B6 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B6 ) ) ) ).

% Inter_anti_mono
thf(fact_4643_Inter__subset,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B6: set @ A] :
      ( ! [X9: set @ A] :
          ( ( member @ ( set @ A ) @ X9 @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ X9 @ B6 ) )
     => ( ( A5
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ B6 ) ) ) ).

% Inter_subset
thf(fact_4644_subset__Pow__Union,axiom,
    ! [A: $tType,A5: set @ ( set @ A )] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ A5 @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) ) ) ).

% subset_Pow_Union
thf(fact_4645_splice_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: list @ A] :
      ( ( ( splice @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y = Xa )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [X2: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X2 @ Xs2 ) )
               => ( ( Y
                    = ( cons @ A @ X2 @ ( splice @ A @ Xa @ Xs2 ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Xa ) ) ) ) ) ) ) ).

% splice.pelims
thf(fact_4646_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N: A,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N @ Ns ) ) @ ( lenlex @ A @ R2 ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N ) @ R2 ) )
        | ( ( M = N )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R2 ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_4647_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
     => ( ( splice @ A @ ( nil @ A ) @ Ys2 )
        = Ys2 ) ) ).

% splice.psimps(1)
thf(fact_4648_split__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( splice @ A @ Xs @ Ys2 )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) ).

% split_Nil_iff
thf(fact_4649_splice__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% splice_Nil2
thf(fact_4650_splice__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] : ( member @ ( list @ A ) @ ( splice @ A @ Xs @ Ys2 ) @ ( shuffles @ A @ Xs @ Ys2 ) ) ).

% splice_in_shuffles
thf(fact_4651_length__splice,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( splice @ A @ Xs @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ).

% length_splice
thf(fact_4652_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R2 ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_4653_splice__replicate,axiom,
    ! [A: $tType,M: nat,X: A,N: nat] :
      ( ( splice @ A @ ( replicate @ A @ M @ X ) @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ ( plus_plus @ nat @ M @ N ) @ X ) ) ).

% splice_replicate
thf(fact_4654_splice_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A] :
      ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ Ys2 )
      = ( cons @ A @ X @ ( splice @ A @ Ys2 @ Xs ) ) ) ).

% splice.simps(2)
thf(fact_4655_splice_Osimps_I1_J,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( splice @ A @ ( nil @ A ) @ Ys2 )
      = Ys2 ) ).

% splice.simps(1)
thf(fact_4656_lenlex__irreflexive,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lenlex @ A @ R2 ) ) ) ).

% lenlex_irreflexive
thf(fact_4657_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R2 ) ) ).

% Nil_lenlex_iff2
thf(fact_4658_splice_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: list @ A] :
      ( ( ( splice @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ~ ! [X2: A,Xs2: list @ A] :
              ( ( X
                = ( cons @ A @ X2 @ Xs2 ) )
             => ( Y
               != ( cons @ A @ X2 @ ( splice @ A @ Xa @ Xs2 ) ) ) ) ) ) ).

% splice.elims
thf(fact_4659_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R2 ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_4660_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs: list @ A,R4: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs ) @ ( lenlex @ A @ R4 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys2 ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs @ Ys2 ) ) @ ( lenlex @ A @ R4 ) ) ) ) ).

% lenlex_append1
thf(fact_4661_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys2 ) )
     => ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ Ys2 )
        = ( cons @ A @ X @ ( splice @ A @ Ys2 @ Xs ) ) ) ) ).

% splice.psimps(2)
thf(fact_4662_lenlex__append2,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Us: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( irrefl @ A @ R4 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs ) @ ( append @ A @ Us @ Ys2 ) ) @ ( lenlex @ A @ R4 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lenlex @ A @ R4 ) ) ) ) ).

% lenlex_append2
thf(fact_4663_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) @ ( lex @ A @ R2 ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 )
          & ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys2 ) ) )
        | ( ( X = Y )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lex @ A @ R2 ) ) ) ) ) ).

% Cons_in_lex
thf(fact_4664_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X3: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X3 ) ) ) ) ).

% uminus_int_def
thf(fact_4665_lexl__not__refl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( irrefl @ A @ R2 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ X ) @ ( lex @ A @ R2 ) ) ) ).

% lexl_not_refl
thf(fact_4666_irrefl__lex,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R2 )
     => ( irrefl @ ( list @ A ) @ ( lex @ A @ R2 ) ) ) ).

% irrefl_lex
thf(fact_4667_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( lex @ A @ R2 ) ) ).

% Nil2_notin_lex
thf(fact_4668_Nil__notin__lex,axiom,
    ! [A: $tType,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) @ ( lex @ A @ R2 ) ) ).

% Nil_notin_lex
thf(fact_4669_lex__append__leftI,axiom,
    ! [A: $tType,Ys2: list @ A,Zs: list @ A,R2: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lex @ A @ R2 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R2 ) ) ) ).

% lex_append_leftI
thf(fact_4670_lex__append__left__iff,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R2 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lex @ A @ R2 ) ) ) ) ).

% lex_append_left_iff
thf(fact_4671_lex__append__leftD,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R2 ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lex @ A @ R2 ) ) ) ) ).

% lex_append_leftD
thf(fact_4672_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lex @ A @ R2 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys2 @ Vs ) ) @ ( lex @ A @ R2 ) ) ) ) ).

% lex_append_rightI
thf(fact_4673_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs3 )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_4674_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_4675_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_4676_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_4677_Gcd__remove0__nat,axiom,
    ! [M5: set @ nat] :
      ( ( finite_finite @ nat @ M5 )
     => ( ( gcd_Gcd @ nat @ M5 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M5 @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_4678_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_4679_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z5: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) @ ( re @ Z5 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z5 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z5 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) @ ( re @ Z5 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_4680_complex__Im__of__int,axiom,
    ! [Z2: int] :
      ( ( im @ ( ring_1_of_int @ complex @ Z2 ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_int
thf(fact_4681_complex__Im__fact,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_char_0_fact @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_fact
thf(fact_4682_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_4683_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_4684_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% diff_numeral_simps(1)
thf(fact_4685_Im__complex__of__real,axiom,
    ! [Z2: real] :
      ( ( im @ ( real_Vector_of_real @ complex @ Z2 ) )
      = ( zero_zero @ real ) ) ).

% Im_complex_of_real
thf(fact_4686_Im__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X @ N ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_4687_complex__Im__numeral,axiom,
    ! [V2: num] :
      ( ( im @ ( numeral_numeral @ complex @ V2 ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_4688_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(6)
thf(fact_4689_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(9)
thf(fact_4690_complex__Im__of__nat,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_1_of_nat @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_nat
thf(fact_4691_complex__Re__of__nat,axiom,
    ! [N: nat] :
      ( ( re @ ( semiring_1_of_nat @ complex @ N ) )
      = ( semiring_1_of_nat @ real @ N ) ) ).

% complex_Re_of_nat
thf(fact_4692_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_4693_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_4694_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_4695_complex__In__mult__cnj__zero,axiom,
    ! [Z2: complex] :
      ( ( im @ ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_4696_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(7)
thf(fact_4697_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(8)
thf(fact_4698_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_4699_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_4700_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_4701_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A5: set @ A] :
          ( ( ( gcd_Gcd @ A @ A5 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_4702_Re__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X @ N ) )
        = ( power_power @ real @ ( re @ X ) @ N ) ) ) ).

% Re_power_real
thf(fact_4703_Re__divide__of__nat,axiom,
    ! [Z2: complex,N: nat] :
      ( ( re @ ( divide_divide @ complex @ Z2 @ ( semiring_1_of_nat @ complex @ N ) ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ).

% Re_divide_of_nat
thf(fact_4704_Im__divide__of__nat,axiom,
    ! [Z2: complex,N: nat] :
      ( ( im @ ( divide_divide @ complex @ Z2 @ ( semiring_1_of_nat @ complex @ N ) ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ).

% Im_divide_of_nat
thf(fact_4705_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_4706_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_4707_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_4708_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_4709_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_4710_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_4711_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_4712_csqrt__of__real__nonneg,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) )
       => ( ( csqrt @ X )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_4713_csqrt__minus,axiom,
    ! [X: complex] :
      ( ( ( ord_less @ real @ ( im @ X ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X ) ) ) ) ).

% csqrt_minus
thf(fact_4714_csqrt__of__real__nonpos,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_4715_cmod__Im__le__iff,axiom,
    ! [X: complex,Y: complex] :
      ( ( ( re @ X )
        = ( re @ Y ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( abs_abs @ real @ ( im @ Y ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_4716_cmod__Re__le__iff,axiom,
    ! [X: complex,Y: complex] :
      ( ( ( im @ X )
        = ( im @ Y ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( abs_abs @ real @ ( re @ Y ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_4717_complex__is__Int__iff,axiom,
    ! [Z2: complex] :
      ( ( member @ complex @ Z2 @ ( ring_1_Ints @ complex ) )
      = ( ( ( im @ Z2 )
          = ( zero_zero @ real ) )
        & ? [I4: int] :
            ( ( re @ Z2 )
            = ( ring_1_of_int @ real @ I4 ) ) ) ) ).

% complex_is_Int_iff
thf(fact_4718_cmod__eq__Re,axiom,
    ! [Z2: complex] :
      ( ( ( im @ Z2 )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z2 )
        = ( abs_abs @ real @ ( re @ Z2 ) ) ) ) ).

% cmod_eq_Re
thf(fact_4719_cmod__eq__Im,axiom,
    ! [Z2: complex] :
      ( ( ( re @ Z2 )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z2 )
        = ( abs_abs @ real @ ( im @ Z2 ) ) ) ) ).

% cmod_eq_Im
thf(fact_4720_Im__eq__0,axiom,
    ! [Z2: complex] :
      ( ( ( abs_abs @ real @ ( re @ Z2 ) )
        = ( real_V7770717601297561774m_norm @ complex @ Z2 ) )
     => ( ( im @ Z2 )
        = ( zero_zero @ real ) ) ) ).

% Im_eq_0
thf(fact_4721_csqrt__principal,axiom,
    ! [Z2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z2 ) ) )
      | ( ( ( re @ ( csqrt @ Z2 ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z2 ) ) ) ) ) ).

% csqrt_principal
thf(fact_4722_cmod__le,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z2 ) ) @ ( abs_abs @ real @ ( im @ Z2 ) ) ) ) ).

% cmod_le
thf(fact_4723_imaginary__unit_Osimps_I1_J,axiom,
    ( ( re @ imaginary_unit )
    = ( zero_zero @ real ) ) ).

% imaginary_unit.simps(1)
thf(fact_4724_complex__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( re @ X ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_Re_le_cmod
thf(fact_4725_zero__complex_Osimps_I2_J,axiom,
    ( ( im @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(2)
thf(fact_4726_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_4727_zero__complex_Osimps_I1_J,axiom,
    ( ( re @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(1)
thf(fact_4728_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K4: num,L4: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K4 ) @ ( numeral_numeral @ A @ L4 ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_4729_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_4730_cmod__power2,axiom,
    ! [Z2: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_4731_Im__power2,axiom,
    ! [X: complex] :
      ( ( im @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X ) ) @ ( im @ X ) ) ) ).

% Im_power2
thf(fact_4732_Re__power2,axiom,
    ! [X: complex] :
      ( ( re @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_4733_abs__Im__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Im_le_cmod
thf(fact_4734_abs__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Re_le_cmod
thf(fact_4735_Re__csqrt,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z2 ) ) ) ).

% Re_csqrt
thf(fact_4736_complex__eq__0,axiom,
    ! [Z2: complex] :
      ( ( Z2
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_4737_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z5: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_4738_inverse__complex_Osimps_I1_J,axiom,
    ! [X: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( re @ X ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_4739_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% sub_non_negative
thf(fact_4740_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% sub_non_positive
thf(fact_4741_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% sub_negative
thf(fact_4742_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% sub_positive
thf(fact_4743_complex__neq__0,axiom,
    ! [Z2: complex] :
      ( ( ( Z2
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_4744_Re__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_4745_complex__mult__cnj,axiom,
    ! [Z2: complex] :
      ( ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_4746_csqrt__unique,axiom,
    ! [W2: complex,Z2: complex] :
      ( ( ( power_power @ complex @ W2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z2 )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W2 ) )
          | ( ( ( re @ W2 )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W2 ) ) ) )
       => ( ( csqrt @ Z2 )
          = W2 ) ) ) ).

% csqrt_unique
thf(fact_4747_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_4748_inverse__complex_Osimps_I2_J,axiom,
    ! [X: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_4749_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_4750_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_4751_Im__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_4752_complex__abs__le__norm,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z2 ) ) @ ( abs_abs @ real @ ( im @ Z2 ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ).

% complex_abs_le_norm
thf(fact_4753_complex__unit__circle,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_4754_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X3: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X3 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X3 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_4755_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X3: complex,Y4: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X3 ) @ ( re @ Y4 ) ) @ ( times_times @ real @ ( im @ X3 ) @ ( im @ Y4 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X3 ) @ ( re @ Y4 ) ) @ ( times_times @ real @ ( re @ X3 ) @ ( im @ Y4 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_4756_cmod__plus__Re__le__0__iff,axiom,
    ! [Z2: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z2 )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_4757_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_4758_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_4759_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_4760_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_4761_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_4762_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_4763_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_4764_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_4765_csqrt_Osimps_I2_J,axiom,
    ! [Z2: complex] :
      ( ( im @ ( csqrt @ Z2 ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z2 )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z2 ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_4766_Im__Reals__divide,axiom,
    ! [R2: complex,Z2: complex] :
      ( ( member @ complex @ R2 @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R2 @ Z2 ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R2 ) ) @ ( im @ Z2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_4767_Re__Reals__divide,axiom,
    ! [R2: complex,Z2: complex] :
      ( ( member @ complex @ R2 @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R2 @ Z2 ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R2 ) @ ( re @ Z2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_4768_cos__Arg__i__mult__zero,axiom,
    ! [Y: complex] :
      ( ( Y
       != ( zero_zero @ complex ) )
     => ( ( ( re @ Y )
          = ( zero_zero @ real ) )
       => ( ( cos @ real @ ( arg @ Y ) )
          = ( zero_zero @ real ) ) ) ) ).

% cos_Arg_i_mult_zero
thf(fact_4769_Reals__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: A] :
          ( ( member @ A @ ( inverse_inverse @ A @ X ) @ ( real_Vector_Reals @ A ) )
          = ( member @ A @ X @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_inverse_iff
thf(fact_4770_imaginary__eq__real__iff,axiom,
    ! [Y: complex,X: complex] :
      ( ( member @ complex @ Y @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y )
            = X )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_4771_real__eq__imaginary__iff,axiom,
    ! [Y: complex,X: complex] :
      ( ( member @ complex @ Y @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( X
            = ( times_times @ complex @ imaginary_unit @ Y ) )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_4772_Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_inverse
thf(fact_4773_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_4774_Reals__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_0
thf(fact_4775_Reals__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_of_nat
thf(fact_4776_complex__is__Real__iff,axiom,
    ! [Z2: complex] :
      ( ( member @ complex @ Z2 @ ( real_Vector_Reals @ complex ) )
      = ( ( im @ Z2 )
        = ( zero_zero @ real ) ) ) ).

% complex_is_Real_iff
thf(fact_4777_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_4778_Complex__in__Reals,axiom,
    ! [X: real] : ( member @ complex @ ( complex2 @ X @ ( zero_zero @ real ) ) @ ( real_Vector_Reals @ complex ) ) ).

% Complex_in_Reals
thf(fact_4779_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% nonzero_Reals_inverse
thf(fact_4780_Gcd__int__greater__eq__0,axiom,
    ! [K6: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K6 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_4781_Arg__zero,axiom,
    ( ( arg @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% Arg_zero
thf(fact_4782_Arg__bounded,axiom,
    ! [Z2: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z2 ) )
      & ( ord_less_eq @ real @ ( arg @ Z2 ) @ pi ) ) ).

% Arg_bounded
thf(fact_4783_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G2: nat > complex,N4: nat,F2: nat > A] :
          ( ( summable @ complex @ G2 )
         => ( ! [N2: nat] : ( member @ complex @ ( G2 @ N2 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G2 @ N2 ) ) )
             => ( ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ N4 @ N2 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G2 @ N2 ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4784_Arg__correct,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z2 )
          = ( cis @ ( arg @ Z2 ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z2 ) )
        & ( ord_less_eq @ real @ ( arg @ Z2 ) @ pi ) ) ) ).

% Arg_correct
thf(fact_4785_cis__Arg__unique,axiom,
    ! [Z2: complex,X: real] :
      ( ( ( sgn_sgn @ complex @ Z2 )
        = ( cis @ X ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ( arg @ Z2 )
            = X ) ) ) ) ).

% cis_Arg_unique
thf(fact_4786_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu4: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N3: nat] :
                    ( ( semiring_1_of_nat @ A @ N3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_4787_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_4788_cis__inverse,axiom,
    ! [A2: real] :
      ( ( inverse_inverse @ complex @ ( cis @ A2 ) )
      = ( cis @ ( uminus_uminus @ real @ A2 ) ) ) ).

% cis_inverse
thf(fact_4789_cis__neq__zero,axiom,
    ! [A2: real] :
      ( ( cis @ A2 )
     != ( zero_zero @ complex ) ) ).

% cis_neq_zero
thf(fact_4790_DeMoivre,axiom,
    ! [A2: real,N: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_4791_cis__Arg,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( cis @ ( arg @ Z2 ) )
        = ( sgn_sgn @ complex @ Z2 ) ) ) ).

% cis_Arg
thf(fact_4792_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_4793_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_4794_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4795_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( bij_betw @ nat @ complex
        @ ^ [K4: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K4 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        @ ( set_ord_lessThan @ nat @ N )
        @ ( collect @ complex
          @ ^ [Z5: complex] :
              ( ( power_power @ complex @ Z5 @ N )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_4796_Arg__def,axiom,
    ( arg
    = ( ^ [Z5: complex] :
          ( if @ real
          @ ( Z5
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A3: real] :
                ( ( ( sgn_sgn @ complex @ Z5 )
                  = ( cis @ A3 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A3 )
                & ( ord_less_eq @ real @ A3 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4797_verit__sko__ex_H,axiom,
    ! [A: $tType,P: A > $o,A5: $o] :
      ( ( ( P @ ( fChoice @ A @ P ) )
        = A5 )
     => ( ( ? [X7: A] : ( P @ X7 ) )
        = A5 ) ) ).

% verit_sko_ex'
thf(fact_4798_verit__sko__forall,axiom,
    ! [A: $tType] :
      ( ( ^ [P2: A > $o] :
          ! [X4: A] : ( P2 @ X4 ) )
      = ( ^ [P3: A > $o] :
            ( P3
            @ ( fChoice @ A
              @ ^ [X3: A] :
                  ~ ( P3 @ X3 ) ) ) ) ) ).

% verit_sko_forall
thf(fact_4799_verit__sko__forall_H,axiom,
    ! [A: $tType,P: A > $o,A5: $o] :
      ( ( ( P
          @ ( fChoice @ A
            @ ^ [X3: A] :
                ~ ( P @ X3 ) ) )
        = A5 )
     => ( ( ! [X7: A] : ( P @ X7 ) )
        = A5 ) ) ).

% verit_sko_forall'
thf(fact_4800_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B6: A,A5: A,P: A > $o] :
      ( ( B6 = A5 )
     => ( ( ( fChoice @ A @ P )
          = A5 )
        = ( ( fChoice @ A @ P )
          = B6 ) ) ) ).

% verit_sko_forall''
thf(fact_4801_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X: A,P: A > $o] :
      ( ( X
        = ( fChoice @ A @ P ) )
     => ( ( ? [X7: A] : ( P @ X7 ) )
        = ( P @ X ) ) ) ).

% verit_sko_ex_indirect
thf(fact_4802_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X: A,P: A > $o,P4: A > $o] :
      ( ( X
        = ( fChoice @ A @ P ) )
     => ( ! [X2: A] :
            ( ( P @ X2 )
            = ( P4 @ X2 ) )
       => ( ( ? [X7: A] : ( P4 @ X7 ) )
          = ( P @ X ) ) ) ) ).

% verit_sko_ex_indirect2
thf(fact_4803_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X: A,P: A > $o] :
      ( ( X
        = ( fChoice @ A
          @ ^ [X3: A] :
              ~ ( P @ X3 ) ) )
     => ( ( ! [X7: A] : ( P @ X7 ) )
        = ( P @ X ) ) ) ).

% verit_sko_forall_indirect
thf(fact_4804_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X: A,P: A > $o,P4: A > $o] :
      ( ( X
        = ( fChoice @ A
          @ ^ [X3: A] :
              ~ ( P @ X3 ) ) )
     => ( ! [X2: A] :
            ( ( P @ X2 )
            = ( P4 @ X2 ) )
       => ( ( ! [X7: A] : ( P4 @ X7 ) )
          = ( P @ X ) ) ) ) ).

% verit_sko_forall_indirect2
thf(fact_4805_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S2: set @ A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S2 @ S2 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ S2 @ S2 ) ) ).

% bij_betw_funpow
thf(fact_4806_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M5: set @ A] :
      ( ( finite_finite @ A @ M5 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M5 ) ) @ M5 ) ) ).

% ex_bij_betw_nat_finite
thf(fact_4807_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S4: set @ B,T5: set @ C,H: B > C,S2: set @ B,T6: set @ C,G2: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ S4 )
                   => ( ( G2 @ ( H @ A4 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B4: C] :
                      ( ( member @ C @ B4 @ T5 )
                     => ( ( G2 @ B4 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X3: B] : ( G2 @ ( H @ X3 ) )
                      @ S2 )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G2 @ T6 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_4808_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ nat,B6: set @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( A5
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( ( B6
            = ( set2 @ A @ Xs ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs ) @ A5 @ B6 ) ) ) ) ).

% bij_betw_nth
thf(fact_4809_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_4810_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
      = ( ? [Y4: A,N3: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N3 ) @ Y4 ) @ R2 )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys2
              = ( list_update @ A @ Xs @ N3 @ Y4 ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_4811_insert__subsetI,axiom,
    ! [A: $tType,X: A,A5: set @ A,X8: set @ A] :
      ( ( member @ A @ X @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ X8 @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ X8 ) @ A5 ) ) ) ).

% insert_subsetI
thf(fact_4812_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_4813_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) @ ( listrel1 @ A @ R2 ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 )
          & ( Xs = Ys2 ) )
        | ( ( X = Y )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_4814_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_4815_listrel1__mono,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R2 ) @ ( listrel1 @ A @ S ) ) ) ).

% listrel1_mono
thf(fact_4816_listrel1I2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys2 ) ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel1I2
thf(fact_4817_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R2 ) ) ).

% not_Nil_listrel1
thf(fact_4818_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R2 ) ) ).

% not_listrel1_Nil
thf(fact_4819_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys2 ) ) ) ).

% listrel1_eq_len
thf(fact_4820_append__listrel1I,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R2 ) ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys2 @ Vs ) ) @ ( listrel1 @ A @ R2 ) ) ) ).

% append_listrel1I
thf(fact_4821_listrel1I1,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Xs ) ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel1I1
thf(fact_4822_Cons__listrel1E1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ( ! [Y2: A] :
            ( ( Ys2
              = ( cons @ A @ Y2 @ Xs ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R2 ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Ys2
                = ( cons @ A @ X @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs2 ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_4823_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y @ Ys2 ) ) @ ( listrel1 @ A @ R2 ) )
     => ( ! [X2: A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Ys2 ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R2 ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Xs
                = ( cons @ A @ Y @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys2 ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_4824_eval__nat__numeral_I2_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_4825_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M5: set @ A] :
      ( ( finite_finite @ A @ M5 )
     => ? [H4: A > nat] : ( bij_betw @ A @ nat @ H4 @ M5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M5 ) ) ) ) ).

% ex_bij_betw_finite_nat
thf(fact_4826_BitM__plus__one,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ ( bitM @ N ) @ one2 )
      = ( bit0 @ N ) ) ).

% BitM_plus_one
thf(fact_4827_one__plus__BitM,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% one_plus_BitM
thf(fact_4828_listrel1E,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ~ ! [X2: A,Y2: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R2 )
           => ! [Us3: list @ A,Vs2: list @ A] :
                ( ( Xs
                  = ( append @ A @ Us3 @ ( cons @ A @ X2 @ Vs2 ) ) )
               => ( Ys2
                 != ( append @ A @ Us3 @ ( cons @ A @ Y2 @ Vs2 ) ) ) ) ) ) ).

% listrel1E
thf(fact_4829_listrel1I,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Us: list @ A,Vs: list @ A,Ys2: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X @ Vs ) ) )
       => ( ( Ys2
            = ( append @ A @ Us @ ( cons @ A @ Y @ Vs ) ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% listrel1I
thf(fact_4830_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_4831_prop__restrict,axiom,
    ! [A: $tType,X: A,Z8: set @ A,X8: set @ A,P: A > $o] :
      ( ( member @ A @ X @ Z8 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z8
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ X8 )
                & ( P @ X3 ) ) ) )
       => ( P @ X ) ) ) ).

% prop_restrict
thf(fact_4832_Collect__restrict,axiom,
    ! [A: $tType,X8: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ X8 )
            & ( P @ X3 ) ) )
      @ X8 ) ).

% Collect_restrict
thf(fact_4833_sub__BitM__One__eq,axiom,
    ! [N: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_4834_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys2: list @ A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ A @ Ys2 @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R2 ) )
      = ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
          & ( X = Y ) )
        | ( ( Xs = Ys2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_4835_subset__emptyI,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ! [X2: A] :
          ~ ( member @ A @ X2 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_4836_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_4837_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_4838_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_4839_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ).

% iszero_neg_numeral
thf(fact_4840_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [X3: A,Y4: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X3 @ Y4 ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_4841_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_4842_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W2: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W2 ) ) ) ).

% not_iszero_numeral
thf(fact_4843_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_4844_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z5: A] :
              ( Z5
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_4845_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_4846_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_4847_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_4848_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_4849_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_4850_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_4851_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_4852_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_4853_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_4854_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_4855_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y @ X ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_4856_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_4857_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_4858_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_4859_pow_Osimps_I3_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit1 @ Y ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X @ Y ) ) @ X ) ) ).

% pow.simps(3)
thf(fact_4860_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y )
       => ( ( image @ nat @ nat
            @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X @ C2 ) @ ( minus_minus @ nat @ Y @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y )
       => ( ( ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_4861_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_4862_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_4863_bij__betw__Suc,axiom,
    ! [M5: set @ nat,N4: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M5 @ N4 )
      = ( ( image @ nat @ nat @ suc @ M5 )
        = N4 ) ) ).

% bij_betw_Suc
thf(fact_4864_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S2 )
          = S2 ) ) ).

% image_add_0
thf(fact_4865_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_4866_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ A5 )
            = ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
thf(fact_4867_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( set2 @ A @ ( linord4507533701916653071of_set @ A @ A5 ) )
            = A5 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
thf(fact_4868_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) )
          = ( finite_card @ A @ A5 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_4869_bij__betw__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N4: set @ nat,A5: set @ A] :
          ( ( bij_betw @ nat @ A @ ( semiring_1_of_nat @ A ) @ N4 @ A5 )
          = ( ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ N4 )
            = A5 ) ) ) ).

% bij_betw_of_nat
thf(fact_4870_cSUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,C2: A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image @ B @ A
                @ ^ [X3: B] : C2
                @ A5 ) )
            = C2 ) ) ) ).

% cSUP_const
thf(fact_4871_cINF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,C2: A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image @ B @ A
                @ ^ [X3: B] : C2
                @ A5 ) )
            = C2 ) ) ) ).

% cINF_const
thf(fact_4872_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( nil @ A ) )
            = ( A5
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_4873_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A5: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) )
            = ( bot_bot @ A ) )
          = ( ! [X3: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X3 )
               => ? [Y4: B] :
                    ( ( member @ B @ Y4 @ A5 )
                    & ( ord_less @ A @ ( F2 @ Y4 ) @ X3 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_4874_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_4875_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C5: A] : ( divide_divide @ A @ C5 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_4876_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B,B6: set @ B] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( member @ B @ ( F2 @ X2 ) @ B6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( collect @ A @ P ) ) @ B6 ) ) ).

% image_Collect_subsetI
thf(fact_4877_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ B7 @ ( image @ B @ A @ F2 @ A5 ) )
           => ( P @ B7 ) ) )
      = ( ! [B7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B7 @ A5 )
           => ( P @ ( image @ B @ A @ F2 @ B7 ) ) ) ) ) ).

% all_subset_image
thf(fact_4878_image__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B6: set @ A,F2: A > B] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B6 ) ) ) ).

% image_mono
thf(fact_4879_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,F2: A > B,B6: set @ B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A5 )
         => ( member @ B @ ( F2 @ X2 ) @ B6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B6 ) ) ).

% image_subsetI
thf(fact_4880_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,F2: B > A,A5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A5 ) )
     => ~ ! [C6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C6 @ A5 )
           => ( B6
             != ( image @ B @ A @ F2 @ C6 ) ) ) ) ).

% subset_imageE
thf(fact_4881_image__subset__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ B6 )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ A5 )
           => ( member @ A @ ( F2 @ X3 ) @ B6 ) ) ) ) ).

% image_subset_iff
thf(fact_4882_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,F2: B > A,A5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A5 ) )
      = ( ? [AA: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A5 )
            & ( B6
              = ( image @ B @ A @ F2 @ AA ) ) ) ) ) ).

% subset_image_iff
thf(fact_4883_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A5: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( pow2 @ B @ A5 ) ) @ ( pow2 @ A @ B6 ) ) ) ).

% image_Pow_mono
thf(fact_4884_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( distinct @ A @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
thf(fact_4885_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( ( linord4507533701916653071of_set @ A @ A5 )
            = ( linord4507533701916653071of_set @ A @ B6 ) )
         => ( ( finite_finite @ A @ A5 )
           => ( ( finite_finite @ A @ B6 )
             => ( A5 = B6 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
thf(fact_4886_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B6: set @ C,F2: B > A,G2: C > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B6 )
                  & ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G2 @ X5 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B6 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A5 )
                    & ( ord_less_eq @ A @ ( G2 @ J2 ) @ ( F2 @ X5 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G2 @ B6 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_4887_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B6: set @ C,G2: C > A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B6 )
                  & ( ord_less_eq @ A @ ( G2 @ X5 ) @ ( F2 @ I2 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B6 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A5 )
                    & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G2 @ J2 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G2 @ B6 ) ) ) ) ) ) ).

% INF_eq
thf(fact_4888_zero__notin__Suc__image,axiom,
    ! [A5: set @ nat] :
      ~ ( member @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A5 ) ) ).

% zero_notin_Suc_image
thf(fact_4889_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B7: set @ A] :
            ( ( ( finite_finite @ A @ B7 )
              & ( ord_less_eq @ ( set @ A ) @ B7 @ ( image @ B @ A @ F2 @ A5 ) ) )
           => ( P @ B7 ) ) )
      = ( ! [B7: set @ B] :
            ( ( ( finite_finite @ B @ B7 )
              & ( ord_less_eq @ ( set @ B ) @ B7 @ A5 ) )
           => ( P @ ( image @ B @ A @ F2 @ B7 ) ) ) ) ) ).

% all_finite_subset_image
thf(fact_4890_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [B7: set @ A] :
            ( ( finite_finite @ A @ B7 )
            & ( ord_less_eq @ ( set @ A ) @ B7 @ ( image @ B @ A @ F2 @ A5 ) )
            & ( P @ B7 ) ) )
      = ( ? [B7: set @ B] :
            ( ( finite_finite @ B @ B7 )
            & ( ord_less_eq @ ( set @ B ) @ B7 @ A5 )
            & ( P @ ( image @ B @ A @ F2 @ B7 ) ) ) ) ) ).

% ex_finite_subset_image
thf(fact_4891_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,F2: B > A,A5: set @ B] :
      ( ( finite_finite @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A5 ) )
       => ? [C6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C6 @ A5 )
            & ( finite_finite @ B @ C6 )
            & ( B6
              = ( image @ B @ A @ F2 @ C6 ) ) ) ) ) ).

% finite_subset_image
thf(fact_4892_finite__surj,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,B6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F2 @ A5 ) )
       => ( finite_finite @ B @ B6 ) ) ) ).

% finite_surj
thf(fact_4893_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,B6: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B6 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ ( image @ B @ A @ F2 @ B6 ) ) ) ).

% image_Int_subset
thf(fact_4894_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,B6: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ ( image @ B @ A @ F2 @ B6 ) ) @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ B6 ) ) ) ).

% image_diff_subset
thf(fact_4895_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,F7: B > A,F2: A > B,A9: set @ B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A5 )
         => ( ( F7 @ ( F2 @ X2 ) )
            = X2 ) )
     => ( ! [X2: B] :
            ( ( member @ B @ X2 @ A9 )
           => ( ( F2 @ ( F7 @ X2 ) )
              = X2 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ A9 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F7 @ A9 ) @ A5 )
           => ( bij_betw @ A @ B @ F2 @ A5 @ A9 ) ) ) ) ) ).

% bij_betw_byWitness
thf(fact_4896_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,A9: set @ B,B6: set @ A,B12: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A5 @ A9 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
       => ( ( ( image @ A @ B @ F2 @ B6 )
            = B12 )
         => ( bij_betw @ A @ B @ F2 @ B6 @ B12 ) ) ) ) ).

% bij_betw_subset
thf(fact_4897_sqr_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N ) ) ) ) ).

% sqr.simps(2)
thf(fact_4898_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_4899_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A5: set @ B,U: A,F2: B > A] :
          ( ( member @ B @ I @ A5 )
         => ( ( ord_less_eq @ A @ U @ ( F2 @ I ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_4900_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A5: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U )
          = ( ! [X3: B] :
                ( ( member @ B @ X3 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_4901_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A5: set @ B,F2: B > A] :
          ( ( member @ B @ I @ A5 )
         => ( ord_less_eq @ A @ ( F2 @ I ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ).

% SUP_upper
thf(fact_4902_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G2: B > A,A5: set @ B] :
          ( ! [X2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G2 @ A5 ) ) ) ) ) ).

% SUP_mono'
thf(fact_4903_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,F2: B > A,U: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_4904_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B6: set @ C,F2: B > A,G2: C > A] :
          ( ! [N2: B] :
              ( ( member @ B @ N2 @ A5 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B6 )
                  & ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G2 @ X5 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G2 @ B6 ) ) ) ) ) ).

% SUP_mono
thf(fact_4905_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,F2: B > A,X: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ X ) )
         => ( ! [Y2: A] :
                ( ! [I3: B] :
                    ( ( member @ B @ I3 @ A5 )
                   => ( ord_less_eq @ A @ ( F2 @ I3 ) @ Y2 ) )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) )
              = X ) ) ) ) ).

% SUP_eqI
thf(fact_4906_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A5: set @ B,Y: A,I: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ Y )
         => ( ( member @ B @ I @ A5 )
           => ( ord_less @ A @ ( F2 @ I ) @ Y ) ) ) ) ).

% SUP_lessD
thf(fact_4907_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F2: B > A,A5: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
          = ( ? [X3: B] :
                ( ( member @ B @ X3 @ A5 )
                & ( ord_less @ A @ A2 @ ( F2 @ X3 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_4908_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,U: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ord_less_eq @ A @ U @ ( F2 @ I2 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ).

% INF_greatest
thf(fact_4909_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F2: B > A,A5: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
          = ( ! [X3: B] :
                ( ( member @ B @ X3 @ A5 )
               => ( ord_less_eq @ A @ U @ ( F2 @ X3 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_4910_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A5: set @ B,F2: B > A,U: A] :
          ( ( member @ B @ I @ A5 )
         => ( ( ord_less_eq @ A @ ( F2 @ I ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_4911_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G2: B > A,A5: set @ B] :
          ( ! [X2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ A5 ) ) ) ) ) ).

% INF_mono'
thf(fact_4912_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A5: set @ B,F2: B > A] :
          ( ( member @ B @ I @ A5 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( F2 @ I ) ) ) ) ).

% INF_lower
thf(fact_4913_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B6: set @ B,A5: set @ C,F2: C > A,G2: B > A] :
          ( ! [M4: B] :
              ( ( member @ B @ M4 @ B6 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ A5 )
                  & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G2 @ M4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ B6 ) ) ) ) ) ).

% INF_mono
thf(fact_4914_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,X: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A5 )
             => ( ord_less_eq @ A @ X @ ( F2 @ I2 ) ) )
         => ( ! [Y2: A] :
                ( ! [I3: B] :
                    ( ( member @ B @ I3 @ A5 )
                   => ( ord_less_eq @ A @ Y2 @ ( F2 @ I3 ) ) )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) )
              = X ) ) ) ) ).

% INF_eqI
thf(fact_4915_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y: A,F2: B > A,A5: set @ B,I: B] :
          ( ( ord_less @ A @ Y @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
         => ( ( member @ B @ I @ A5 )
           => ( ord_less @ A @ Y @ ( F2 @ I ) ) ) ) ) ).

% less_INF_D
thf(fact_4916_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A5: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ A2 )
          = ( ? [X3: B] :
                ( ( member @ B @ X3 @ A5 )
                & ( ord_less @ A @ ( F2 @ X3 ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_4917_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A7: set @ A] :
          ? [N3: nat,F3: nat > A] :
            ( A7
            = ( image @ nat @ A @ F3
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_4918_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A5: set @ A,F2: nat > A,N: nat] :
      ( ( A5
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) ) )
     => ( finite_finite @ A @ A5 ) ) ).

% nat_seg_image_imp_finite
thf(fact_4919_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X3: num] : ( times_times @ num @ X3 @ X3 ) ) ) ).

% sqr_conv_mult
thf(fact_4920_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,F2: B > A,A5: set @ B] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ Y4 @ X )
               => ? [X3: B] :
                    ( ( member @ B @ X3 @ A5 )
                    & ( ord_less @ A @ Y4 @ ( F2 @ X3 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_4921_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A5: set @ B,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ X )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ X @ Y4 )
               => ? [X3: B] :
                    ( ( member @ B @ X3 @ A5 )
                    & ( ord_less @ A @ ( F2 @ X3 ) @ Y4 ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_4922_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,C2: A,F2: B > A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I6 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I2 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I6 ) )
                = C2 )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ I6 )
                   => ( ( F2 @ X3 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_4923_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,M5: A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ M5 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ M5 ) ) ) ) ).

% cSUP_least
thf(fact_4924_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,F2: B > A,C2: A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I6 )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I6 ) )
                = C2 )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ I6 )
                   => ( ( F2 @ X3 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_4925_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,M: A,F2: B > A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ A5 )
               => ( ord_less_eq @ A @ M @ ( F2 @ X2 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_4926_card__image__le,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A5 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A5 ) ) @ ( finite_card @ A @ A5 ) ) ) ).

% card_image_le
thf(fact_4927_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F7: A > B,A9: set @ A,A10: set @ B,F2: C > A,A5: set @ C] :
      ( ( bij_betw @ A @ B @ F7 @ A9 @ A10 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ A5 ) @ A9 )
       => ( ( bij_betw @ C @ A @ F2 @ A5 @ A9 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F7 @ F2 ) @ A5 @ A10 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_4928_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B6: set @ B,F2: B > A,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A5 @ B6 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G2 @ B6 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_4929_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B6: set @ B,A5: set @ B,F2: B > A,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B6 @ A5 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ B6 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ B6 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_4930_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ C,G2: B > C,H: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G2 @ S2 ) @ T6 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y4: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H
                      @ ( collect @ B
                        @ ^ [X3: B] :
                            ( ( member @ B @ X3 @ S2 )
                            & ( ( G2 @ X3 )
                              = Y4 ) ) ) )
                  @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% sum.group
thf(fact_4931_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ C,G2: B > C,H: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G2 @ S2 ) @ T6 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y4: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H
                      @ ( collect @ B
                        @ ^ [X3: B] :
                            ( ( member @ B @ X3 @ S2 )
                            & ( ( G2 @ X3 )
                              = Y4 ) ) ) )
                  @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% prod.group
thf(fact_4932_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_4933_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,H: B > C,G2: C > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ! [X2: B,Y2: B] :
                ( ( member @ B @ X2 @ A5 )
               => ( ( member @ B @ Y2 @ A5 )
                 => ( ( X2 != Y2 )
                   => ( ( ( H @ X2 )
                        = ( H @ Y2 ) )
                     => ( ( G2 @ ( H @ X2 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G2 @ ( image @ B @ C @ H @ A5 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G2 @ H ) @ A5 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_4934_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_4935_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F2 @ A5 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B6 ) @ ( finite_card @ A @ A5 ) ) ) ) ).

% surj_card_le
thf(fact_4936_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X: A,Y: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_4937_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_4938_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_4939_lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N ) )
      = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_4940_atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N ) )
      = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_4941_pow_Osimps_I2_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit0 @ Y ) )
      = ( sqr @ ( pow @ X @ Y ) ) ) ).

% pow.simps(2)
thf(fact_4942_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I6: set @ C,G2: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I6 )
         => ( ! [I2: C] :
                ( ( member @ C @ I2 @ I6 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G2 @ ( F2 @ I2 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G2 @ ( image @ C @ A @ F2 @ I6 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G2 @ F2 ) @ I6 ) ) ) ) ) ).

% sum_image_le
thf(fact_4943_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_4944_sqr_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N ) @ N ) ) ) ) ).

% sqr.simps(3)
thf(fact_4945_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_4946_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_4947_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_4948_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_4949_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_4950_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S2: set @ A,R4: set @ B,G2: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S2 )
         => ( ( finite_finite @ B @ R4 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G2 @ S2 ) @ R4 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X3: A] : ( F2 @ ( G2 @ X3 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y4: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X3: A] :
                                ( ( member @ A @ X3 @ S2 )
                                & ( ( G2 @ X3 )
                                  = Y4 ) ) ) ) )
                      @ ( F2 @ Y4 ) )
                  @ R4 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_4951_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: A,B6: A] :
          ( ( inf_inf @ A @ A5
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X3: nat] : B6
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A5 @ B6 ) ) ) ).

% INF_nat_binary
thf(fact_4952_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_4953_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X3: A] : X3 ) ) ) ).

% sorted_list_of_set_def
thf(fact_4954_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [X: B,F2: B > A,Xs: list @ B] :
          ( ( remove1 @ B @ X @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = Xs ) ) ).

% remove1_insort_key
thf(fact_4955_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% length_insort
thf(fact_4956_Gcd__int__eq,axiom,
    ! [N4: set @ nat] :
      ( ( gcd_Gcd @ int @ ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ N4 ) )
      = ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ N4 ) ) ) ).

% Gcd_int_eq
thf(fact_4957_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X3: A] : X3
                @ X
                @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_4958_set__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs ) ) ) ) ).

% set_concat
thf(fact_4959_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B6: B > ( set @ A ),A5: set @ B] :
      ( ord_less_eq @ ( set @ ( set @ A ) )
      @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
        @ ( image @ B @ ( set @ ( set @ A ) )
          @ ^ [X3: B] : ( pow2 @ A @ ( B6 @ X3 ) )
          @ A5 ) )
      @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B6 @ A5 ) ) ) ) ).

% UN_Pow_subset
thf(fact_4960_Inf__int__def,axiom,
    ( ( complete_Inf_Inf @ int )
    = ( ^ [X7: set @ int] : ( uminus_uminus @ int @ ( complete_Sup_Sup @ int @ ( image @ int @ int @ ( uminus_uminus @ int ) @ X7 ) ) ) ) ) ).

% Inf_int_def
thf(fact_4961_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X7: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X7 ) ) ) ) ) ).

% Inf_real_def
thf(fact_4962_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ Y )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ Y ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_4963_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,A2: B,Xs: list @ B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
         != ( nil @ B ) ) ) ).

% insort_not_Nil
thf(fact_4964_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Xs: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X3: A] : X3
            @ X
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ Y
              @ Xs ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X3: A] : X3
            @ Y
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs ) ) ) ) ).

% insort_left_comm
thf(fact_4965_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Xs: list @ B] :
          ( ( ( F2 @ X )
           != ( F2 @ Y ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
            = ( linorder_insort_key @ B @ A @ F2 @ X @ ( linorder_insort_key @ B @ A @ F2 @ Y @ Xs ) ) ) ) ) ).

% insort_key_left_comm
thf(fact_4966_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Ys2: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys2 ) )
              = ( cons @ B @ X @ ( cons @ B @ Y @ Ys2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys2 ) )
              = ( cons @ B @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Ys2 ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_4967_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y: A,Xs: list @ A,Ys2: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ Xs @ Ys2 ) ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys2 ) ) ) ).

% Cons_shuffles_subset2
thf(fact_4968_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ Ys2 ) ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys2 ) ) ).

% Cons_shuffles_subset1
thf(fact_4969_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( nil @ B ) )
          = ( cons @ B @ X @ ( nil @ B ) ) ) ) ).

% insort_key.simps(1)
thf(fact_4970_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( insert2 @ B @ X @ ( set2 @ B @ Xs ) ) ) ) ).

% set_insort_key
thf(fact_4971_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( ~ ( member @ B @ X @ ( set2 @ B @ Xs ) )
            & ( distinct @ B @ Xs ) ) ) ) ).

% distinct_insort
thf(fact_4972_finite__int__iff__bounded,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S5: set @ int] :
        ? [K4: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S5 ) @ ( set_ord_lessThan @ int @ K4 ) ) ) ) ).

% finite_int_iff_bounded
thf(fact_4973_finite__int__iff__bounded__le,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S5: set @ int] :
        ? [K4: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S5 ) @ ( set_ord_atMost @ int @ K4 ) ) ) ) ).

% finite_int_iff_bounded_le
thf(fact_4974_UN__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B6: set @ A,F2: A > ( set @ B ),G2: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ A5 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G2 @ B6 ) ) ) ) ) ).

% UN_mono
thf(fact_4975_UN__least,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,B6: A > ( set @ B ),C4: set @ B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A5 )
         => ( ord_less_eq @ ( set @ B ) @ ( B6 @ X2 ) @ C4 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B6 @ A5 ) ) @ C4 ) ) ).

% UN_least
thf(fact_4976_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A5: set @ A,B6: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A5 )
     => ( ord_less_eq @ ( set @ B ) @ ( B6 @ A2 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B6 @ A5 ) ) ) ) ).

% UN_upper
thf(fact_4977_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A5: B > ( set @ A ),I6: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A5 @ I6 ) ) @ B6 )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ ( A5 @ X3 ) @ B6 ) ) ) ) ).

% UN_subset_iff
thf(fact_4978_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A5: set @ A,B6: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A5 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B6 @ A5 ) ) @ ( B6 @ A2 ) ) ) ).

% INT_lower
thf(fact_4979_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,C4: set @ B,B6: A > ( set @ B )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A5 )
         => ( ord_less_eq @ ( set @ B ) @ C4 @ ( B6 @ X2 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C4 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B6 @ A5 ) ) ) ) ).

% INT_greatest
thf(fact_4980_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B6: set @ A,F2: A > ( set @ B ),G2: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ A5 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ B6 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G2 @ A5 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_4981_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,A5: B > ( set @ A ),I6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A5 @ I6 ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ B6 @ ( A5 @ X3 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_4982_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,A2: B] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
             => ( ord_less_eq @ A @ ( F2 @ A2 ) @ ( F2 @ X2 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
            = ( cons @ B @ A2 @ Xs ) ) ) ) ).

% insort_is_Cons
thf(fact_4983_image__int__atLeastAtMost,axiom,
    ! [A2: nat,B2: nat] :
      ( ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
      = ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% image_int_atLeastAtMost
thf(fact_4984_image__int__atLeastLessThan,axiom,
    ! [A2: nat,B2: nat] :
      ( ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) )
      = ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% image_int_atLeastLessThan
thf(fact_4985_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I6: set @ A,A5: A > ( set @ B ),F2: B > C,A9: A > ( set @ C )] :
      ( ! [I2: A,J2: A] :
          ( ( member @ A @ I2 @ I6 )
         => ( ( member @ A @ J2 @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A5 @ I2 ) @ ( A5 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A5 @ J2 ) @ ( A5 @ I2 ) ) ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( bij_betw @ B @ C @ F2 @ ( A5 @ I2 ) @ ( A9 @ I2 ) ) )
       => ( bij_betw @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A5 @ I6 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A9 @ I6 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_4986_subset__subseqs,axiom,
    ! [A: $tType,X8: set @ A,Xs: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( set2 @ A @ Xs ) )
     => ( member @ ( set @ A ) @ X8 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ) ).

% subset_subseqs
thf(fact_4987_subseqs__powset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
      = ( pow2 @ A @ ( set2 @ A @ Xs ) ) ) ).

% subseqs_powset
thf(fact_4988_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] :
      ( ( image @ int @ int
        @ ^ [X3: int] : ( plus_plus @ int @ X3 @ L )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U @ L ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L @ U ) ) ).

% image_add_int_atLeastLessThan
thf(fact_4989_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,A5: A > ( set @ B )] :
      ( ( finite_finite @ A @ I6 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A5 @ I6 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I4: A] : ( finite_card @ B @ ( A5 @ I4 ) )
          @ I6 ) ) ) ).

% card_UN_le
thf(fact_4990_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X3: A] : X3
                @ X
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_4991_Gcd__int__def,axiom,
    ( ( gcd_Gcd @ int )
    = ( ^ [K5: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ ( image @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K5 ) ) ) ) ) ).

% Gcd_int_def
thf(fact_4992_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_4993_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( set_Cons @ A @ A5 @ ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image @ A @ ( list @ A )
        @ ^ [X3: A] : ( cons @ A @ X3 @ ( nil @ A ) )
        @ A5 ) ) ).

% set_Cons_sing_Nil
thf(fact_4994_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: B > ( set @ A ),G2: C > ( set @ B ),X: C,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ ( G2 @ X ) ) ) @ X8 )
      = ( ord_less_eq @ ( set @ B ) @ ( G2 @ X )
        @ ( collect @ B
          @ ^ [X3: B] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ X3 ) @ X8 ) ) ) ) ).

% UN_image_subset
thf(fact_4995_shuffles_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( insert2 @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ( ( ( Xa
                = ( nil @ A ) )
             => ( ( Y
                  = ( insert2 @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
           => ~ ! [X2: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X2 @ Xs2 ) )
                 => ! [Y2: A,Ys4: list @ A] :
                      ( ( Xa
                        = ( cons @ A @ Y2 @ Ys4 ) )
                     => ( ( Y
                          = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs2 ) @ Ys4 ) ) ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) ) ) ) ) ) ) ).

% shuffles.pelims
thf(fact_4996_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            & ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% le_sup_iff
thf(fact_4997_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_4998_Un__subset__iff,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) @ C4 )
      = ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
        & ( ord_less_eq @ ( set @ A ) @ B6 @ C4 ) ) ) ).

% Un_subset_iff
thf(fact_4999_set__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( set2 @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) ) ) ).

% set_append
thf(fact_5000_set__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( set2 @ A @ ( union @ A @ Xs @ Ys2 ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) ) ) ).

% set_union
thf(fact_5001_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(4)
thf(fact_5002_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(3)
thf(fact_5003_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A2 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_5004_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_5005_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge1
thf(fact_5006_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge2
thf(fact_5007_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_5008_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_5009_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_5010_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_5011_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X ) ) ) ) ).

% sup_least
thf(fact_5012_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y4: A] :
              ( ( sup_sup @ A @ X3 @ Y4 )
              = Y4 ) ) ) ) ).

% le_iff_sup
thf(fact_5013_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_5014_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_5015_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X2: A,Y2: A] : ( ord_less_eq @ A @ X2 @ ( F2 @ X2 @ Y2 ) )
         => ( ! [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ ( F2 @ X2 @ Y2 ) )
           => ( ! [X2: A,Y2: A,Z3: A] :
                  ( ( ord_less_eq @ A @ Y2 @ X2 )
                 => ( ( ord_less_eq @ A @ Z3 @ X2 )
                   => ( ord_less_eq @ A @ ( F2 @ Y2 @ Z3 ) @ X2 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% sup_unique
thf(fact_5016_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_5017_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_5018_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) ).

% sup_absorb1
thf(fact_5019_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) ).

% sup_absorb2
thf(fact_5020_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_5021_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_5022_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( A3
              = ( sup_sup @ A @ A3 @ B3 ) ) ) ) ) ).

% sup.order_iff
thf(fact_5023_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_5024_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_5025_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( sup_sup @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_5026_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( sup_sup @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_5027_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_5028_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_5029_subset__Un__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( sup_sup @ ( set @ A ) @ A7 @ B7 )
            = B7 ) ) ) ).

% subset_Un_eq
thf(fact_5030_subset__UnE,axiom,
    ! [A: $tType,C4: set @ A,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
     => ~ ! [A11: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A11 @ A5 )
           => ! [B13: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B13 @ B6 )
               => ( C4
                 != ( sup_sup @ ( set @ A ) @ A11 @ B13 ) ) ) ) ) ).

% subset_UnE
thf(fact_5031_Un__absorb2,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
     => ( ( sup_sup @ ( set @ A ) @ A5 @ B6 )
        = A5 ) ) ).

% Un_absorb2
thf(fact_5032_Un__absorb1,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( sup_sup @ ( set @ A ) @ A5 @ B6 )
        = B6 ) ) ).

% Un_absorb1
thf(fact_5033_Un__upper2,axiom,
    ! [A: $tType,B6: set @ A,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ B6 @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) ) ).

% Un_upper2
thf(fact_5034_Un__upper1,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) ) ).

% Un_upper1
thf(fact_5035_Un__least,axiom,
    ! [A: $tType,A5: set @ A,C4: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) @ C4 ) ) ) ).

% Un_least
thf(fact_5036_Un__mono,axiom,
    ! [A: $tType,A5: set @ A,C4: set @ A,B6: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) @ ( sup_sup @ ( set @ A ) @ C4 @ D5 ) ) ) ) ).

% Un_mono
thf(fact_5037_Un__Pow__subset,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A5 ) @ ( pow2 @ A @ B6 ) ) @ ( pow2 @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) ) ) ).

% Un_Pow_subset
thf(fact_5038_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_5039_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_5040_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( A3
                = ( sup_sup @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_5041_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_5042_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_5043_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_5044_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X @ B2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_5045_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_5046_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% distrib_sup_le
thf(fact_5047_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% distrib_inf_le
thf(fact_5048_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_5049_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_5050_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C4: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) @ C4 )
        = ( inf_inf @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B6 @ C4 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C4 @ A5 ) ) ).

% Un_Int_assoc_eq
thf(fact_5051_Diff__partition,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( sup_sup @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B6 @ A5 ) )
        = B6 ) ) ).

% Diff_partition
thf(fact_5052_Diff__subset__conv,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,C4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) @ C4 )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B6 @ C4 ) ) ) ).

% Diff_subset_conv
thf(fact_5053_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys2: list @ A] :
      ( ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) )
      = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys2 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys2 ) ) ) ) ).

% shuffles.simps(3)
thf(fact_5054_set__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( ( set2 @ A @ Zs )
        = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) ) ) ) ).

% set_shuffles
thf(fact_5055_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P6: A,Q4: A,R2: A] :
          ( ( ord_less_eq @ A @ P6 @ ( sup_sup @ A @ Q4 @ R2 ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P6 @ ( uminus_uminus @ A @ Q4 ) ) @ R2 ) ) ) ).

% sup_neg_inf
thf(fact_5056_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y ) ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% shunt2
thf(fact_5057_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y ) @ Z2 ) ) ) ) ).

% shunt1
thf(fact_5058_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B6: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B6 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_5059_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_5060_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_5061_card__Un__le,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B6 ) ) ) ).

% card_Un_le
thf(fact_5062_Inter__Un__subset,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B6: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B6 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A5 @ B6 ) ) ) ).

% Inter_Un_subset
thf(fact_5063_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_5064_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A5: set @ A,As3: list @ ( set @ A )] :
      ( ( listset @ A @ ( cons @ ( set @ A ) @ A5 @ As3 ) )
      = ( set_Cons @ A @ A5 @ ( listset @ A @ As3 ) ) ) ).

% listset.simps(2)
thf(fact_5065_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_5066_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: A,B6: A] :
          ( ( sup_sup @ A @ A5
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X3: nat] : B6
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A5 @ B6 ) ) ) ).

% SUP_nat_binary
thf(fact_5067_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X3: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X3 )
        @ ^ [X3: A,Y4: A] : ( ord_less @ A @ Y4 @ X3 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_5068_conj__subset__def,axiom,
    ! [A: $tType,A5: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A5
        @ ( collect @ A
          @ ^ [X3: A] :
              ( ( P @ X3 )
              & ( Q @ X3 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_5069_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B6: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A5 @ B6 ) )
                 => ( ( G2 @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B6 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ B6 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_5070_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_5071_UN__le__eq__Un0,axiom,
    ! [A: $tType,M5: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M5 @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M5 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M5 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_5072_shuffles_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( insert2 @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             != ( insert2 @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X2: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X2 @ Xs2 ) )
               => ! [Y2: A,Ys4: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ Y2 @ Ys4 ) )
                   => ( Y
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs2 ) @ Ys4 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_5073_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) )
     => ( ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) )
        = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys2 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys2 ) ) ) ) ) ).

% shuffles.psimps(3)
thf(fact_5074_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A5: set @ B,B6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A5 @ B6 ) )
                 => ( ( F2 @ X2 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A5 @ B6 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B6 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B6 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_5075_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_5076_suminf__eq__SUP__real,axiom,
    ! [X8: nat > real] :
      ( ( summable @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X8 @ I2 ) )
       => ( ( suminf @ real @ X8 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I4: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X8 @ ( set_ord_lessThan @ nat @ I4 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_5077_INF__filter__not__bot,axiom,
    ! [I7: $tType,A: $tType,B6: set @ I7,F4: I7 > ( filter @ A )] :
      ( ! [X9: set @ I7] :
          ( ( ord_less_eq @ ( set @ I7 ) @ X9 @ B6 )
         => ( ( finite_finite @ I7 @ X9 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F4 @ X9 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F4 @ B6 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_5078_top__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( top @ C )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X3: D] : ( top_top @ C ) ) ) ) ).

% top_apply
thf(fact_5079_max__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% max_top
thf(fact_5080_max__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% max_top2
thf(fact_5081_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( nil @ A )
        = ( remdups @ A @ X ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_right_iff
thf(fact_5082_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( remdups @ A @ X )
        = ( nil @ A ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_iff
thf(fact_5083_set__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_remdups
thf(fact_5084_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% length_remdups_eq
thf(fact_5085_distinct__remdups,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct @ A @ ( remdups @ A @ Xs ) ) ).

% distinct_remdups
thf(fact_5086_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups @ A @ Xs )
        = Xs )
      = ( distinct @ A @ Xs ) ) ).

% remdups_id_iff_distinct
thf(fact_5087_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A5 )
            = ( top_top @ A ) )
          = ( ! [X3: A] :
                ( ( ord_less @ A @ X3 @ ( top_top @ A ) )
               => ? [Y4: A] :
                    ( ( member @ A @ Y4 @ A5 )
                    & ( ord_less @ A @ X3 @ Y4 ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_5088_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_5089_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_remdups_leq
thf(fact_5090_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A5: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) )
            = ( top_top @ A ) )
          = ( ! [X3: A] :
                ( ( ord_less @ A @ X3 @ ( top_top @ A ) )
               => ? [Y4: B] :
                    ( ( member @ B @ Y4 @ A5 )
                    & ( ord_less @ A @ X3 @ ( F2 @ Y4 ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_5091_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_5092_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,F4: A > ( filter @ B )] :
      ( ! [I2: A] :
          ( ( member @ A @ I2 @ I6 )
         => ! [J2: A] :
              ( ( member @ A @ J2 @ I6 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ I6 )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X5 ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ I2 ) @ ( F4 @ J2 ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ I6 ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X3: A] :
              ( ( member @ A @ X3 @ I6 )
              & ( ( F4 @ X3 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_5093_sup__int__def,axiom,
    ( ( sup_sup @ int )
    = ( ord_max @ int ) ) ).

% sup_int_def
thf(fact_5094_subset__UNIV,axiom,
    ! [A: $tType,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ A5 @ ( top_top @ ( set @ A ) ) ) ).

% subset_UNIV
thf(fact_5095_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_5096_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_5097_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_5098_Inf__filter__not__bot,axiom,
    ! [A: $tType,B6: set @ ( filter @ A )] :
      ( ! [X9: set @ ( filter @ A )] :
          ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X9 @ B6 )
         => ( ( finite_finite @ ( filter @ A ) @ X9 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ X9 )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ B6 )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% Inf_filter_not_bot
thf(fact_5099_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_5100_remdups__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups @ A @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ Xs ) ) ).

% remdups_remdups
thf(fact_5101_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_5102_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_5103_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% distinct_remdups_id
thf(fact_5104_remdups__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( remdups @ A @ ( append @ A @ Xs @ ( remdups @ A @ Ys2 ) ) )
      = ( remdups @ A @ ( append @ A @ Xs @ Ys2 ) ) ) ).

% remdups_append2
thf(fact_5105_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups.simps(1)
thf(fact_5106_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_5107_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F2: B > A,B6: set @ A,I: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) @ B6 )
     => ( member @ A @ ( F2 @ I ) @ B6 ) ) ).

% range_subsetD
thf(fact_5108_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) ) ) ).

% not_UNIV_le_Icc
thf(fact_5109_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [H: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atMost @ A @ H ) ) ) ).

% not_UNIV_le_Iic
thf(fact_5110_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_5111_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs ) )
          = ( remdups @ A @ Xs ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( remdups @ A @ Xs ) ) ) ) ) ).

% remdups.simps(2)
thf(fact_5112_remove1__remdups,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X @ ( remdups @ A @ Xs ) )
        = ( remdups @ A @ ( remove1 @ A @ X @ Xs ) ) ) ) ).

% remove1_remdups
thf(fact_5113_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% sup_shunt
thf(fact_5114_atLeastLessThan__add__Un,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( set_or7035219750837199246ssThan @ nat @ I @ ( plus_plus @ nat @ J @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I @ J ) @ ( set_or7035219750837199246ssThan @ nat @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_5115_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) ) @ ( image @ B @ A @ F2 @ ( uminus_uminus @ ( set @ B ) @ A5 ) ) ) ) ).

% surj_Compl_image_subset
thf(fact_5116_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs ) ) ) ).

% length_remdups_card_conv
thf(fact_5117_UN__UN__finite__eq,axiom,
    ! [A: $tType,A5: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [N3: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_5118_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_5119_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_5120_UN__finite__subset,axiom,
    ! [A: $tType,A5: nat > ( set @ A ),C4: set @ A] :
      ( ! [N2: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) @ C4 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( top_top @ ( set @ nat ) ) ) ) @ C4 ) ) ).

% UN_finite_subset
thf(fact_5121_UN__finite2__eq,axiom,
    ! [A: $tType,A5: nat > ( set @ A ),B6: nat > ( set @ A ),K: nat] :
      ( ! [N2: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B6 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N2 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B6 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_5122_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_5123_Pow__set_I2_J,axiom,
    ! [B: $tType,X: B,Xs: list @ B] :
      ( ( pow2 @ B @ ( set2 @ B @ ( cons @ B @ X @ Xs ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) @ ( image @ ( set @ B ) @ ( set @ B ) @ ( insert2 @ B @ X ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) ) ) ) ).

% Pow_set(2)
thf(fact_5124_UN__finite2__subset,axiom,
    ! [A: $tType,A5: nat > ( set @ A ),B6: nat > ( set @ A ),K: nat] :
      ( ! [N2: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B6 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N2 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B6 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_5125_range__mod,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( image @ nat @ nat
          @ ^ [M2: nat] : ( modulo_modulo @ nat @ M2 @ N )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% range_mod
thf(fact_5126_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S2: set @ A] :
      ( ! [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I2 ) @ S2 )
     => ( ( finite_finite @ A @ S2 )
       => ( ? [N8: nat] :
              ( ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N2 @ N8 )
                 => ! [M4: nat] :
                      ( ( ord_less_eq @ nat @ M4 @ N8 )
                     => ( ( ord_less @ nat @ M4 @ N2 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M4 ) @ ( F2 @ N2 ) ) ) ) )
              & ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N2 )
                 => ( ( F2 @ N8 )
                    = ( F2 @ N2 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S2 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_5127_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_5128_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A5: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( finite_Fpow @ B @ A5 ) ) @ ( finite_Fpow @ A @ B6 ) ) ) ).

% image_Fpow_mono
thf(fact_5129_measure__function__int,axiom,
    fun_is_measure @ int @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) ).

% measure_function_int
thf(fact_5130_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_5131_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert2 @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_5132_less__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
            ( ( ord_less_eq @ ( filter @ A ) @ F9 @ F10 )
            & ~ ( ord_less_eq @ ( filter @ A ) @ F10 @ F9 ) ) ) ) ).

% less_filter_def
thf(fact_5133_infinite__UNIV__listI,axiom,
    ! [A: $tType] :
      ~ ( finite_finite @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% infinite_UNIV_listI
thf(fact_5134_infinite__UNIV__int,axiom,
    ~ ( finite_finite @ int @ ( top_top @ ( set @ int ) ) ) ).

% infinite_UNIV_int
thf(fact_5135_is__measure_Osimps,axiom,
    ! [A: $tType] :
      ( ( fun_is_measure @ A )
      = ( ^ [A3: A > nat] :
          ? [X7: A > nat] :
            ( ^ [Y3: A > nat,Z: A > nat] : ( Y3 = Z )
            @ A3
            @ X7 ) ) ) ).

% is_measure.simps
thf(fact_5136_is__measure__trivial,axiom,
    ! [A: $tType,F2: A > nat] : ( fun_is_measure @ A @ F2 ) ).

% is_measure_trivial
thf(fact_5137_measure__size,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ( fun_is_measure @ A @ ( size_size @ A ) ) ) ).

% measure_size
thf(fact_5138_Ints__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_Ints @ A )
        = ( image @ int @ A @ ( ring_1_of_int @ A ) @ ( top_top @ ( set @ int ) ) ) ) ) ).

% Ints_def
thf(fact_5139_int__in__range__abs,axiom,
    ! [N: nat] : ( member @ int @ ( semiring_1_of_nat @ int @ N ) @ ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) ) ) ).

% int_in_range_abs
thf(fact_5140_Fpow__mono,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A5 ) @ ( finite_Fpow @ A @ B6 ) ) ) ).

% Fpow_mono
thf(fact_5141_Fpow__subset__Pow,axiom,
    ! [A: $tType,A5: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A5 ) @ ( pow2 @ A @ A5 ) ) ).

% Fpow_subset_Pow
thf(fact_5142_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X7: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X7 @ A7 )
                & ( finite_finite @ A @ X7 ) ) ) ) ) ).

% Fpow_def
thf(fact_5143_root__def,axiom,
    ( root
    = ( ^ [N3: nat,X3: real] :
          ( if @ real
          @ ( N3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y4: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N3 ) )
            @ X3 ) ) ) ) ).

% root_def
thf(fact_5144_DERIV__real__root__generic,axiom,
    ! [N: nat,X: real,D5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( D5
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
             => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
               => ( D5
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
               => ( D5
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N ) @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_5145_DERIV__even__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
       => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_5146_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G2: real > real,G3: real > real] :
      ( ! [X2: real] :
          ( ( member @ real @ X2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G2 @ ( G3 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X2: real] :
            ( ( member @ real @ X2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G3 @ X2 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G2 @ A2 ) @ ( G2 @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_5147_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A2 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ? [Y5: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_5148_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A2 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ? [Y5: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y5 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_5149_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A2 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ? [Y5: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y5 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_5150_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A2 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ? [Y5: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y5 ) ) ) )
       => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_5151_DERIV__isconst__all,axiom,
    ! [F2: real > real,X: real,Y: real] :
      ( ! [X2: real] : ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( F2 @ X )
        = ( F2 @ Y ) ) ) ).

% DERIV_isconst_all
thf(fact_5152_DERIV__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_5153_DERIV__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_5154_DERIV__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_5155_DERIV__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_5156_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F7: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_5157_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_5158_DERIV__const,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [K: A,F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X3: A] : K
          @ ( zero_zero @ A )
          @ F4 ) ) ).

% DERIV_const
thf(fact_5159_has__real__derivative__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_5160_has__real__derivative__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_5161_has__real__derivative__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_5162_has__real__derivative__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_5163_MVT2,axiom,
    ! [A2: real,B2: real,F2: real > real,F7: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A2 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F7 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z3: real] :
            ( ( ord_less @ real @ A2 @ Z3 )
            & ( ord_less @ real @ Z3 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F7 @ Z3 ) ) ) ) ) ) ).

% MVT2
thf(fact_5164_DERIV__local__const,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y2: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y2 ) ) @ D2 )
             => ( ( F2 @ X )
                = ( F2 @ Y2 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_5165_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G2: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G2 @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X3: A] : ( divide_divide @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D5 @ ( G2 @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ E5 ) ) @ ( times_times @ A @ ( G2 @ X ) @ ( G2 @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_5166_DERIV__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_5167_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( inverse_inverse @ A @ ( F2 @ X3 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ D5 ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_5168_at__le,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,X: A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ord_less_eq @ ( filter @ A ) @ ( topolo174197925503356063within @ A @ X @ S ) @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ).

% at_le
thf(fact_5169_DERIV__local__min,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y2: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y2 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ X ) @ ( F2 @ Y2 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_5170_DERIV__local__max,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y2: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y2 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ Y2 ) @ ( F2 @ X ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_5171_DERIV__ln__divide,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_5172_DERIV__fun__pow,axiom,
    ! [G2: real > real,M: real,X: real,N: nat] :
      ( ( has_field_derivative @ real @ G2 @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X3: real] : ( power_power @ real @ ( G2 @ X3 ) @ N )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( G2 @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_5173_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( power_power @ A @ ( F2 @ X3 ) @ ( suc @ N ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power_Suc
thf(fact_5174_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,S: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_inverse
thf(fact_5175_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( power_power @ A @ ( F2 @ X3 ) @ N )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power
thf(fact_5176_DERIV__pow,axiom,
    ! [N: nat,X: real,S: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X3: real] : ( power_power @ real @ X3 @ N )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X @ S ) ) ).

% DERIV_pow
thf(fact_5177_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y2: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Y2 @ N3 ) ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] :
                ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) )
            @ ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_5178_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo174197925503356063within @ A @ X @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_5179_has__real__derivative__powr,axiom,
    ! [Z2: real,R2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z2 )
     => ( has_field_derivative @ real
        @ ^ [Z5: real] : ( powr @ real @ Z5 @ R2 )
        @ ( times_times @ real @ R2 @ ( powr @ real @ Z2 @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_5180_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_5181_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,G2: A > A,E2: A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G2 @ E2 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y4: A] : ( divide_divide @ A @ ( F2 @ Y4 ) @ ( G2 @ Y4 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G2 @ X ) ) @ ( times_times @ A @ E2 @ ( F2 @ X ) ) ) @ ( power_power @ A @ ( G2 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_5182_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( inverse_inverse @ A @ ( F2 @ X3 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_5183_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K6: real,C2: nat > A,F2: A > A,F7: A,Z2: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K6 )
             => ( sums @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z3 @ N3 ) )
                @ ( F2 @ Z3 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F7 @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K6 )
             => ( sums @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) )
                @ F7 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_5184_DERIV__log,axiom,
    ! [X: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_5185_DERIV__fun__powr,axiom,
    ! [G2: real > real,M: real,X: real,R2: real] :
      ( ( has_field_derivative @ real @ G2 @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
       => ( has_field_derivative @ real
          @ ^ [X3: real] : ( powr @ real @ ( G2 @ X3 ) @ R2 )
          @ ( times_times @ real @ ( times_times @ real @ R2 @ ( powr @ real @ ( G2 @ X ) @ ( minus_minus @ real @ R2 @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_5186_DERIV__powr,axiom,
    ! [G2: real > real,M: real,X: real,F2: real > real,R2: real] :
      ( ( has_field_derivative @ real @ G2 @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
       => ( ( has_field_derivative @ real @ F2 @ R2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X3: real] : ( powr @ real @ ( G2 @ X3 ) @ ( F2 @ X3 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G2 @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ R2 @ ( ln_ln @ real @ ( G2 @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F2 @ X ) ) @ ( G2 @ X ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_5187_DERIV__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_5188_DERIV__arctan,axiom,
    ! [X: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_5189_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
         => ( ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
           => ( ( summable @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
               => ( has_field_derivative @ A
                  @ ^ [X3: A] :
                      ( suminf @ A
                      @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) )
                  @ ( suminf @ A
                    @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_5190_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_5191_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K6: real,C2: nat > A,Z2: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K6 )
             => ( summable @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z3 @ N3 ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K6 )
           => ( has_field_derivative @ A
              @ ^ [Z5: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z5 @ N3 ) ) )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ Z2 @ N3 ) ) )
              @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_5192_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_5193_DERIV__real__sqrt__generic,axiom,
    ! [X: real,D5: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( D5
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
           => ( D5
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_5194_arsinh__real__has__field__derivative,axiom,
    ! [X: real,A5: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A5 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_5195_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_5196_has__field__derivative__tanh,axiom,
    ! [A15: $tType] :
      ( ( ( real_Vector_banach @ A15 )
        & ( real_V3459762299906320749_field @ A15 ) )
     => ! [G2: A15 > A15,X: A15,Db: A15,S: set @ A15] :
          ( ( ( cosh @ A15 @ ( G2 @ X ) )
           != ( zero_zero @ A15 ) )
         => ( ( has_field_derivative @ A15 @ G2 @ Db @ ( topolo174197925503356063within @ A15 @ X @ S ) )
           => ( has_field_derivative @ A15
              @ ^ [X3: A15] : ( tanh @ A15 @ ( G2 @ X3 ) )
              @ ( times_times @ A15 @ ( minus_minus @ A15 @ ( one_one @ A15 ) @ ( power_power @ A15 @ ( tanh @ A15 @ ( G2 @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A15 @ X @ S ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_5197_arcosh__real__has__field__derivative,axiom,
    ! [X: real,A5: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A5 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_5198_artanh__real__has__field__derivative,axiom,
    ! [X: real,A5: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A5 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_5199_DERIV__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_5200_DERIV__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_5201_DERIV__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_5202_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M4: nat,X2: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T3: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
          & ( ( F2 @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_5203_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,X2: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T3: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_5204_DERIV__odd__real__root,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_5205_Maclaurin,axiom,
    ! [H: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T3: real] :
                ( ( ( ord_less @ nat @ M4 @ N )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
                  & ( ord_less_eq @ real @ T3 @ H ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
                & ( ord_less @ real @ T3 @ H )
                & ( ( F2 @ H )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ H @ M2 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_5206_Maclaurin2,axiom,
    ! [H: real,Diff: nat > real > real,F2: real > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T3: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
                & ( ord_less_eq @ real @ T3 @ H ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T3 )
              & ( ord_less_eq @ real @ T3 @ H )
              & ( ( F2 @ H )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ H @ M2 ) )
                    @ ( set_ord_lessThan @ nat @ N ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_5207_Maclaurin__minus,axiom,
    ! [H: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T3: real] :
                ( ( ( ord_less @ nat @ M4 @ N )
                  & ( ord_less_eq @ real @ H @ T3 )
                  & ( ord_less_eq @ real @ T3 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T3: real] :
                ( ( ord_less @ real @ H @ T3 )
                & ( ord_less @ real @ T3 @ ( zero_zero @ real ) )
                & ( ( F2 @ H )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ H @ M2 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_5208_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( X
           != ( zero_zero @ real ) )
         => ( ! [M4: nat,X2: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T3 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
                & ( ( F2 @ X )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_5209_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,T3: real] :
            ( ( ( ord_less @ nat @ M4 @ N )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T3: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T3 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ X @ M2 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_5210_Taylor,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T3: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T3 )
                & ( ord_less_eq @ real @ T3 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X )
               => ( ( ord_less_eq @ real @ X @ B2 )
                 => ( ( X != C2 )
                   => ? [T3: real] :
                        ( ( ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ X @ T3 )
                            & ( ord_less @ real @ T3 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ C2 @ T3 )
                            & ( ord_less @ real @ T3 @ X ) ) )
                        & ( ( F2 @ X )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ C2 ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ M2 ) )
                              @ ( set_ord_lessThan @ nat @ N ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_5211_Taylor__up,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T3: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T3 )
                & ( ord_less_eq @ real @ T3 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T3: real] :
                  ( ( ord_less @ real @ C2 @ T3 )
                  & ( ord_less @ real @ T3 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ C2 ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M2 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_5212_Taylor__down,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T3: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T3 )
                & ( ord_less_eq @ real @ T3 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T3: real] :
                  ( ( ord_less @ real @ A2 @ T3 )
                  & ( ord_less @ real @ T3 @ C2 )
                  & ( ( F2 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M2 @ C2 ) @ ( semiring_char_0_fact @ real @ M2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M2 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T3 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_5213_Maclaurin__lemma2,axiom,
    ! [N: nat,H: real,Diff: nat > real > real,K: nat,B6: real] :
      ( ! [M4: nat,T3: real] :
          ( ( ( ord_less @ nat @ M4 @ N )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T3 )
            & ( ord_less_eq @ real @ T3 @ H ) )
         => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T3 ) @ ( topolo174197925503356063within @ real @ T3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N
          = ( suc @ K ) )
       => ! [M3: nat,T8: real] :
            ( ( ( ord_less @ nat @ M3 @ N )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M3 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P5: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M3 @ P5 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ real @ U2 @ P5 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ M3 ) ) )
                    @ ( times_times @ real @ B6 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N @ M3 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ M3 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M3 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P5: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M3 ) @ P5 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ real @ T8 @ P5 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ M3 ) ) ) )
                  @ ( times_times @ real @ B6 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N @ ( suc @ M3 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ ( suc @ M3 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_5214_DERIV__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X10: real] :
            ( suminf @ real
            @ ^ [K4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K4 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X10 @ ( plus_plus @ nat @ ( times_times @ nat @ K4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K4 ) @ ( power_power @ real @ X @ ( times_times @ nat @ K4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_5215_DERIV__power__series_H,axiom,
    ! [R4: real,F2: nat > real,X0: real] :
      ( ! [X2: real] :
          ( ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R4 ) @ R4 ) )
         => ( summable @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N3 ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) @ ( power_power @ real @ X2 @ N3 ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R4 ) @ R4 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
         => ( has_field_derivative @ real
            @ ^ [X3: real] :
                ( suminf @ real
                @ ^ [N3: nat] : ( times_times @ real @ ( F2 @ N3 ) @ ( power_power @ real @ X3 @ ( suc @ N3 ) ) ) )
            @ ( suminf @ real
              @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N3 ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) @ ( power_power @ real @ X0 @ N3 ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_5216_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G3: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G2 @ X ) )
         => ( ( ord_less @ real @ ( G2 @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G2 @ G3 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X3: A] : ( arcsin @ ( G2 @ X3 ) )
                @ ^ [X3: A] : ( times_times @ real @ ( G3 @ X3 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G2 @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_5217_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G3: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G2 @ X ) )
         => ( ( ord_less @ real @ ( G2 @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G2 @ G3 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X3: A] : ( arccos @ ( G2 @ X3 ) )
                @ ^ [X3: A] : ( times_times @ real @ ( G3 @ X3 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G2 @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_5218_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_5219_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_5220_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_5221_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_5222_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_5223_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_5224_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_5225_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_5226_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_5227_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F7: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_5228_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [C2: B,F4: filter @ A] :
          ( has_derivative @ A @ B
          @ ^ [X3: A] : C2
          @ ^ [X3: A] : ( zero_zero @ B )
          @ F4 ) ) ).

% has_derivative_const
thf(fact_5229_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_5230_has__derivative__zero__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: A > B,X: A] :
          ( ( has_derivative @ A @ B
            @ ^ [X3: A] : ( zero_zero @ B )
            @ F4
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( F4
            = ( ^ [H3: A] : ( zero_zero @ B ) ) ) ) ) ).

% has_derivative_zero_unique
thf(fact_5231_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G2: A > B,G3: A > A > B,F2: C > A,S: set @ C,X: C,F7: C > A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ T2 )
             => ( has_derivative @ A @ B @ G2 @ ( G3 @ X2 ) @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
           => ( ( member @ C @ X @ S )
             => ( ( has_derivative @ C @ A @ F2 @ F7 @ ( topolo174197925503356063within @ C @ X @ S ) )
               => ( has_derivative @ C @ B
                  @ ^ [X3: C] : ( G2 @ ( F2 @ X3 ) )
                  @ ^ [Y4: C] : ( G3 @ ( F2 @ X ) @ ( F7 @ Y4 ) )
                  @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_5232_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_5233_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_5234_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_5235_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_5236_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_5237_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F7: C > A,X: C,S2: set @ C,G2: C > A,G3: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F7 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G2 @ G3 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X3: C] : ( divide_divide @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ^ [H3: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F7 @ H3 ) @ ( G2 @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ ( G3 @ H3 ) ) ) @ ( times_times @ A @ ( G2 @ X ) @ ( G2 @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_5238_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X: C,F7: C > A,S2: set @ C] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F7 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X3: C] : ( inverse_inverse @ A @ ( F2 @ X3 ) )
              @ ^ [H3: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ ( F7 @ H3 ) ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_5239_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H3: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X ) @ H3 ) @ ( inverse_inverse @ A @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_5240_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X: real,Y: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( member @ real @ X @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
       => ( ( member @ real @ Y @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ! [X2: real] :
                ( ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F2 @ X )
              = ( F2 @ Y ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_5241_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_5242_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_5243_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F7: A > B,X: A,S2: set @ A,N: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( has_derivative @ A @ B
            @ ^ [X3: A] : ( power_power @ B @ ( F2 @ X3 ) @ N )
            @ ^ [Y4: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N ) @ ( F7 @ Y4 ) ) @ ( power_power @ B @ ( F2 @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power
thf(fact_5244_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G3: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
         => ( ( has_derivative @ A @ real @ G2 @ G3 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X3: A] : ( ln_ln @ real @ ( G2 @ X3 ) )
              @ ^ [X3: A] : ( times_times @ real @ ( G3 @ X3 ) @ ( inverse_inverse @ real @ ( G2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_ln
thf(fact_5245_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F7: C > A,X: C,S2: set @ C,G2: C > A,G3: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F7 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G2 @ G3 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X3: C] : ( divide_divide @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ^ [H3: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G2 @ X ) ) @ ( G3 @ H3 ) ) @ ( inverse_inverse @ A @ ( G2 @ X ) ) ) ) @ ( divide_divide @ A @ ( F7 @ H3 ) @ ( G2 @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_5246_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,G3: A > real,X: A,X8: set @ A,F2: A > real,F7: A > real] :
          ( ( has_derivative @ A @ real @ G2 @ G3 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
             => ( ( member @ A @ X @ X8 )
               => ( has_derivative @ A @ real
                  @ ^ [X3: A] : ( powr @ real @ ( G2 @ X3 ) @ ( F2 @ X3 ) )
                  @ ^ [H3: A] : ( times_times @ real @ ( powr @ real @ ( G2 @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F7 @ H3 ) @ ( ln_ln @ real @ ( G2 @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G3 @ H3 ) @ ( F2 @ X ) ) @ ( G2 @ X ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ X8 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_5247_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G3: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
         => ( ( has_derivative @ A @ real @ G2 @ G3 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X3: A] : ( sqrt @ ( G2 @ X3 ) )
              @ ^ [X3: A] : ( times_times @ real @ ( G3 @ X3 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G2 @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_5248_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,G3: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G2 @ G3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X3: A] : ( arctan @ ( G2 @ X3 ) )
            @ ^ [X3: A] : ( times_times @ real @ ( G3 @ X3 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G2 @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_arctan
thf(fact_5249_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G3: A > real,S: set @ A] :
          ( ( ( cos @ real @ ( G2 @ X ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G2 @ G3 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X3: A] : ( tan @ real @ ( G2 @ X3 ) )
              @ ^ [X3: A] : ( times_times @ real @ ( G3 @ X3 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G2 @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_tan
thf(fact_5250_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F7: real > nat > real,X0: real,A2: real,B2: real,L5: nat > real] :
      ( ! [N2: nat] :
          ( has_field_derivative @ real
          @ ^ [X3: real] : ( F2 @ X3 @ N2 )
          @ ( F7 @ X0 @ N2 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X2: real] :
            ( ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F2 @ X2 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F7 @ X0 ) )
           => ( ( summable @ real @ L5 )
             => ( ! [N2: nat,X2: real,Y2: real] :
                    ( ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X2 @ N2 ) @ ( F2 @ Y2 @ N2 ) ) ) @ ( times_times @ real @ ( L5 @ N2 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y2 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X3: real] : ( suminf @ real @ ( F2 @ X3 ) )
                  @ ( suminf @ real @ ( F7 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_5251_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G2: A > real,X: A,F2: real > Aa,G3: A > real,S: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ Aa @ ( F2 @ ( G2 @ X ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G2 @ G3 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X3: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G2 @ X3 ) ) ) )
                @ ^ [X3: A] : ( times_times @ real @ ( G3 @ X3 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_5252_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( filterlim @ A @ A
              @ ^ [H3: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X @ H3 ) @ N3 ) @ ( power_power @ A @ X @ N3 ) ) @ H3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_5253_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F2: A > Aa,C2: nat > Aa,K6: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N3: nat] : ( times_times @ Aa @ ( C2 @ N3 ) @ ( power_power @ Aa @ K6 @ N3 ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K6 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X3: A] :
                    ( suminf @ Aa
                    @ ^ [N3: nat] : ( times_times @ Aa @ ( C2 @ N3 ) @ ( power_power @ Aa @ ( F2 @ X3 ) @ N3 ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_5254_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_5255_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( F2 @ X3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_5256_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real
          @ ^ [X3: A] : ( power_power @ real @ ( F2 @ X3 ) @ N )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% power_tendsto_0_iff
thf(fact_5257_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > real,A2: A,G2: A > real] :
          ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X2: A] :
                ( ( X2 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G2 @ X2 ) ) )
           => ( ! [X2: A] :
                  ( ( X2 != A2 )
                 => ( ord_less_eq @ real @ ( G2 @ X2 ) @ ( F2 @ X2 ) ) )
             => ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_5258_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( zero @ Aa )
        & ( topological_t2_space @ Aa ) )
     => ! [K: Aa,A2: A] :
          ( ( K
           != ( zero_zero @ Aa ) )
         => ~ ( filterlim @ A @ Aa
              @ ^ [X3: A] : K
              @ ( topolo7230453075368039082e_nhds @ Aa @ ( zero_zero @ Aa ) )
              @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_not_zero
thf(fact_5259_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H3: A] : ( F2 @ ( plus_plus @ A @ X @ H3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_5260_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G2: B > C,L: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ B @ C @ G2 @ ( topolo7230453075368039082e_nhds @ C @ L ) @ ( topolo174197925503356063within @ B @ ( F2 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X2: A] :
                      ( ( ( X2 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ D3 ) )
                     => ( ( F2 @ X2 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( G2 @ ( F2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_5261_filterlim__mono,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F22: filter @ B,F1: filter @ A,F23: filter @ B,F12: filter @ A] :
      ( ( filterlim @ A @ B @ F2 @ F22 @ F1 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F22 @ F23 )
       => ( ( ord_less_eq @ ( filter @ A ) @ F12 @ F1 )
         => ( filterlim @ A @ B @ F2 @ F23 @ F12 ) ) ) ) ).

% filterlim_mono
thf(fact_5262_tendsto__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F4: filter @ B,F11: filter @ B,F2: B > A,L: A] :
          ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F11 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mono
thf(fact_5263_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I6: set @ B,F2: A > B > C,F4: filter @ A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ I6 )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( F2 @ X3 @ I2 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I4: A] : ( groups7311177749621191930dd_sum @ B @ C @ ( F2 @ I4 ) @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
            @ F4 ) ) ) ).

% tendsto_null_sum
thf(fact_5264_tendsto__rabs__zero,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X3: A] : ( abs_abs @ real @ ( F2 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_rabs_zero
thf(fact_5265_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X3: A] : ( abs_abs @ real @ ( F2 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
      = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_iff
thf(fact_5266_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X3: A] : ( abs_abs @ real @ ( F2 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
     => ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_cancel
thf(fact_5267_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X3: A] : ( power_power @ B @ ( F2 @ X3 ) @ N ) ) ) ) ).

% continuous_power
thf(fact_5268_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A2: B,F4: filter @ C,G2: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ C @ nat @ G2 @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X3: C] : ( power_power @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_power_strong
thf(fact_5269_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F4: filter @ C,F2: C > B,G2: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F4 @ G2 )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X3: C] : ( power_power @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_5270_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A2: B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X3: A] : ( power_power @ B @ ( F2 @ X3 ) @ N )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N ) )
            @ F4 ) ) ) ).

% tendsto_power
thf(fact_5271_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( inverse_inverse @ A @ ( F2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( inverse_inverse @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_inverse
thf(fact_5272_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X3: B] : ( divide_divide @ A @ ( F2 @ X3 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_divide_zero
thf(fact_5273_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G2: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X3: B] : ( divide_divide @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ).

% tendsto_divide
thf(fact_5274_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X3: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_cancel
thf(fact_5275_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X3: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_iff
thf(fact_5276_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_norm_zero
thf(fact_5277_tendsto__ln,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( A2
         != ( zero_zero @ real ) )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( ln_ln @ real @ ( F2 @ X3 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( ln_ln @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_ln
thf(fact_5278_tendsto__powr,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G2: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( A2
           != ( zero_zero @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr
thf(fact_5279_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( L
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( sgn_sgn @ A @ ( F2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( sgn_sgn @ A @ L ) )
              @ F4 ) ) ) ) ).

% tendsto_sgn
thf(fact_5280_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F4: filter @ D,G2: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X3: D] : ( plus_plus @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_add_zero
thf(fact_5281_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,G2: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( ( filterlim @ D @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ A
              @ ^ [X3: D] : ( times_times @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_5282_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X3: D] : ( times_times @ A @ ( F2 @ X3 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_5283_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X3: D] : ( times_times @ A @ C2 @ ( F2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_5284_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,G2: B > A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A
            @ ^ [X3: B] : ( minus_minus @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
            = ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform_eq
thf(fact_5285_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X3: A] : ( minus_minus @ B @ ( F2 @ X3 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_cancel
thf(fact_5286_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G2: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X3: B] : ( minus_minus @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform2
thf(fact_5287_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: B > A,A2: A,F4: filter @ B,F2: B > A] :
          ( ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X3: B] : ( minus_minus @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform
thf(fact_5288_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X3: A] : ( minus_minus @ B @ ( F2 @ X3 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_iff
thf(fact_5289_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X3: A] : ( minus_minus @ B @ ( F2 @ X3 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 ) ) ) ).

% LIM_zero
thf(fact_5290_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( cos @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X3: A] : ( tan @ A @ ( F2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tan @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_tan
thf(fact_5291_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,A2: A,F4: filter @ C] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( cosh @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ C @ A
              @ ^ [X3: C] : ( tanh @ A @ ( F2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tanh @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_tanh
thf(fact_5292_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( sin @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X3: A] : ( cot @ A @ ( F2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( cot @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_cot
thf(fact_5293_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X3: B] : ( arcosh @ real @ ( F2 @ X3 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_arcosh
thf(fact_5294_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > B,L: filter @ B,X: A,S2: set @ A,T6: set @ A] :
          ( ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S2 )
           => ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X @ T6 ) ) ) ) ) ).

% tendsto_within_subset
thf(fact_5295_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,L5: B] :
          ( ( filterlim @ A @ B
            @ ^ [H3: A] : ( F2 @ ( plus_plus @ A @ A2 @ H3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_5296_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H3: A] : ( F2 @ ( plus_plus @ A @ A2 @ H3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_5297_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H3: A] : ( F2 @ ( plus_plus @ A @ A2 @ H3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_5298_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X3: A] : ( power_power @ B @ ( F2 @ X3 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_null_power
thf(fact_5299_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G2: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X3: A] : ( log @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_5300_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( artanh @ real @ ( F2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_artanh
thf(fact_5301_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L: B,A2: A,G2: A > C,M: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X2: A] :
                ( ( X2 != A2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G2 @ X2 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X2 ) @ L ) ) ) )
           => ( filterlim @ A @ C @ G2 @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_5302_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H3: A] : ( F2 @ ( plus_plus @ A @ A2 @ H3 ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L5 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_5303_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X2: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X2 )
                      & ( ord_less_eq @ A @ X2 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X2: A] :
                    ( ( ord_less_eq @ A @ A2 @ X2 )
                    & ( ord_less_eq @ A @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2
thf(fact_5304_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X2: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X2 )
                      & ( ord_less_eq @ A @ X2 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X2: A] :
                    ( ( ord_less_eq @ A @ A2 @ X2 )
                    & ( ord_less_eq @ A @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y ) ) ) ) ) ) ) ).

% IVT
thf(fact_5305_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R4: real,A2: A,F2: A > B,G2: A > B,L: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
         => ( ! [X2: A] :
                ( ( X2 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ R4 )
                 => ( ( F2 @ X2 )
                    = ( G2 @ X2 ) ) ) )
           => ( ( filterlim @ A @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_5306_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X3: A] :
                        ( ( ( X3 != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ S6 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_5307_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [S8: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S8 )
                  & ! [X2: A] :
                      ( ( ( X2 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ S8 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X2 ) @ L5 ) ) @ R ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_5308_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R2: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X5: A] :
                    ( ( ( X5 != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X5 ) @ L5 ) ) @ R2 ) ) ) ) ) ) ).

% LIM_D
thf(fact_5309_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A2: A,D5: A] :
          ( ( filterlim @ A @ A
            @ ^ [H3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A2 @ H3 ) ) @ ( F2 @ A2 ) ) @ H3 )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X3 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ A @ X3 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_5310_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X2 )
              & ( ord_less_eq @ real @ X2 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ? [L6: real,M10: real] :
            ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( ( ord_less_eq @ real @ L6 @ ( F2 @ X5 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X5 ) @ M10 ) ) )
            & ! [Y5: real] :
                ( ( ( ord_less_eq @ real @ L6 @ Y5 )
                  & ( ord_less_eq @ real @ Y5 @ M10 ) )
               => ? [X2: real] :
                    ( ( ord_less_eq @ real @ A2 @ X2 )
                    & ( ord_less_eq @ real @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y5 ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_5311_LIM__fun__gt__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_5312_LIM__fun__not__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L
         != ( zero_zero @ real ) )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R ) )
               => ( ( F2 @ X5 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_5313_LIM__fun__less__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R ) )
               => ( ord_less @ real @ ( F2 @ X5 ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_5314_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G2: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G2 @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X2: A] :
                      ( ( ( X2 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ D3 ) )
                     => ( ( F2 @ X2 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( G2 @ ( F2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_5315_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G2 )
           => ( ( ( G2 @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
                @ ^ [X3: A] : ( divide_divide @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_5316_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X3: A] : ( power_power @ B @ ( F2 @ X3 ) @ N ) ) ) ) ).

% isCont_power
thf(fact_5317_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X3: A] : ( inverse_inverse @ B @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_at_within_inverse
thf(fact_5318_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X3: A] : ( sgn_sgn @ B @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_at_within_sgn
thf(fact_5319_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,S: set @ C,F2: C > real,G2: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S ) @ G2 )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S )
                @ ^ [X3: C] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% continuous_at_within_powr
thf(fact_5320_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X: A,S: set @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ S ) @ F2 )
         => ( ( ( F2 @ X )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X3: A] : ( ln_ln @ real @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_within_ln
thf(fact_5321_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H3 ) ) @ ( F2 @ X ) ) @ H3 )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_5322_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H3 ) ) @ ( F2 @ X ) ) @ H3 )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_5323_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z5 ) @ ( one_one @ A ) ) @ Z5 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_5324_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K6: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K6 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_5325_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
              ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ M10 ) ) ) ) ) ).

% isCont_bounded
thf(fact_5326_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X5 ) @ M10 ) )
                & ? [X2: real] :
                    ( ( ord_less_eq @ real @ A2 @ X2 )
                    & ( ord_less_eq @ real @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = M10 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_5327_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ M10 @ ( F2 @ X5 ) ) )
                & ? [X2: real] :
                    ( ( ord_less_eq @ real @ A2 @ X2 )
                    & ( ord_less_eq @ real @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = M10 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_5328_isCont__inverse__function2,axiom,
    ! [A2: real,X: real,B2: real,G2: real > real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( ( G2 @ ( F2 @ Z3 ) )
                  = Z3 ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less_eq @ real @ A2 @ Z3 )
               => ( ( ord_less_eq @ real @ Z3 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G2 ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_5329_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H3 ) ) @ ( F2 @ X ) ) @ H3 )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_5330_isCont__ln,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( ln_ln @ real ) ) ) ).

% isCont_ln
thf(fact_5331_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G2 )
           => ( ( ( G2 @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X3: A] : ( divide_divide @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_5332_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( sgn_sgn @ B @ ( F2 @ X3 ) ) ) ) ) ) ).

% isCont_sgn
thf(fact_5333_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X3: A] : ( F2 @ ( plus_plus @ A @ X3 @ A2 ) )
            @ F4
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_5334_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,S: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X3: A] : ( tan @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_within_tan
thf(fact_5335_isCont__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,F2: C > real,G2: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G2 )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
                @ ^ [X3: C] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% isCont_powr
thf(fact_5336_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X: A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ X )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( ln_ln @ real @ ( F2 @ X3 ) ) ) ) ) ) ).

% isCont_ln'
thf(fact_5337_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,S: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X3: A] : ( cot @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_within_cot
thf(fact_5338_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: C,A5: set @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X @ A5 ) @ F2 )
         => ( ( ( cosh @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X @ A5 )
              @ ^ [X3: C] : ( tanh @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_at_within_tanh
thf(fact_5339_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X5 ) @ M10 ) )
                & ! [N8: A] :
                    ( ( ord_less @ A @ N8 @ M10 )
                   => ? [X2: real] :
                        ( ( ord_less_eq @ real @ A2 @ X2 )
                        & ( ord_less_eq @ real @ X2 @ B2 )
                        & ( ord_less @ A @ N8 @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_5340_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( tan @ A ) ) ) ) ).

% isCont_tan
thf(fact_5341_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( cot @ A ) ) ) ) ).

% isCont_cot
thf(fact_5342_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( tanh @ A ) ) ) ) ).

% isCont_tanh
thf(fact_5343_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X2: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ S )
               => ( sums @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) )
                  @ ( F2 @ X2 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_5344_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X2: A] :
                ( ( X2
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ S )
                 => ( sums @ A
                    @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) )
                    @ ( F2 @ X2 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_5345_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_5346_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G2: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N2: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G2 @ H4 @ N2 ) ) @ ( times_times @ real @ ( F2 @ N2 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H3: A] : ( suminf @ B @ ( G2 @ H3 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_5347_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( tan @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% isCont_tan'
thf(fact_5348_isCont__arcosh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_5349_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S: set @ A,F2: A > real,G2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G2 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S )
                    @ ^ [X3: A] : ( log @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_5350_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X3: real] : ( divide_divide @ real @ ( cos @ real @ X3 ) @ ( sin @ real @ X3 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_5351_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( cot @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% isCont_cot'
thf(fact_5352_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J: nat,I: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ ( suc @ I ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_5353_DERIV__inverse__function,axiom,
    ! [F2: real > real,D5: real,G2: real > real,X: real,A2: real,B2: real] :
      ( ( has_field_derivative @ real @ F2 @ D5 @ ( topolo174197925503356063within @ real @ ( G2 @ X ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D5
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A2 @ X )
         => ( ( ord_less @ real @ X @ B2 )
           => ( ! [Y2: real] :
                  ( ( ord_less @ real @ A2 @ Y2 )
                 => ( ( ord_less @ real @ Y2 @ B2 )
                   => ( ( F2 @ ( G2 @ Y2 ) )
                      = Y2 ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ G2 )
               => ( has_field_derivative @ real @ G2 @ ( inverse_inverse @ real @ D5 ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_5354_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W3 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% isCont_polynom
thf(fact_5355_isCont__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_5356_isCont__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_5357_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y2: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Y2 @ N3 ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
            @ ^ [X3: A] :
                ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_5358_LIM__less__bound,axiom,
    ! [B2: real,X: real,F2: real > real] :
      ( ( ord_less @ real @ B2 @ X )
     => ( ! [X2: real] :
            ( ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X ) ) ) ) ) ).

% LIM_less_bound
thf(fact_5359_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real,G2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G2 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X3: A] : ( log @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_5360_isCont__artanh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_5361_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_5362_isCont__inverse__function,axiom,
    ! [D2: real,X: real,G2: real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z3 @ X ) ) @ D2 )
           => ( ( G2 @ ( F2 @ Z3 ) )
              = Z3 ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z3 @ X ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G2 ) ) ) ) ).

% isCont_inverse_function
thf(fact_5363_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: real > real,G2: real > real,G3: real > real,F7: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ A2 @ Z3 )
           => ( ( ord_less_eq @ real @ Z3 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ G2 ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
               => ( ( ord_less @ real @ Z3 @ B2 )
                 => ( has_field_derivative @ real @ G2 @ ( G3 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z3: real] :
                  ( ( ord_less @ real @ A2 @ Z3 )
                 => ( ( ord_less @ real @ Z3 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F7 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C3: real] :
                  ( ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( G3 @ C3 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G2 @ B2 ) @ ( G2 @ A2 ) ) @ ( F7 @ C3 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_5364_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A ) )
     => ! [X: real,F2: real > A] :
          ( ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ A @ ( F2 @ X ) @ ( ring_1_Ints @ A ) )
           => ( has_field_derivative @ real
              @ ^ [X3: real] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ A @ ( F2 @ X3 ) ) )
              @ ( zero_zero @ real )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% floor_has_real_derivative
thf(fact_5365_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_5366_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N6: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N6 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N6 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_5367_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N6: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N6 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N6 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_5368_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( filterlim @ nat @ real
            @ ^ [N3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_5369_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_5370_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( A2 @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_5371_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( divide_divide @ A @ ( A2 @ N3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_5372_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [U4: nat > A] :
              ( ! [N6: nat] : ( ord_less @ A @ X @ ( U4 @ N6 ) )
              & ( filterlim @ nat @ A @ U4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_5373_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ? [U4: nat > A] :
              ( ! [N6: nat] : ( ord_less @ A @ ( U4 @ N6 ) @ X )
              & ( filterlim @ nat @ A @ U4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_5374_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N2 )
               => ( ord_less_eq @ A @ ( X8 @ N2 ) @ A2 ) )
           => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_5375_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N2 )
               => ( ord_less_eq @ A @ A2 @ ( X8 @ N2 ) ) )
           => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_5376_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,N4: nat,C4: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N2 )
               => ( ord_less_eq @ A @ C4 @ ( F2 @ N2 ) ) )
           => ( ord_less_eq @ A @ C4 @ L ) ) ) ) ).

% Lim_bounded2
thf(fact_5377_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,M5: nat,C4: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N2: nat] :
                ( ( ord_less_eq @ nat @ M5 @ N2 )
               => ( ord_less_eq @ A @ ( F2 @ N2 ) @ C4 ) )
           => ( ord_less_eq @ A @ L @ C4 ) ) ) ) ).

% Lim_bounded
thf(fact_5378_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,Y6: nat > A,Y: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
           => ( ? [N8: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N2 )
                 => ( ord_less_eq @ A @ ( X8 @ N2 ) @ ( Y6 @ N2 ) ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_5379_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N4: nat,X8: nat > A,Y6: nat > A,X: A,Y: A] :
          ( ! [N2: nat] :
              ( ( ord_less_eq @ nat @ N4 @ N2 )
             => ( ord_less_eq @ A @ ( X8 @ N2 ) @ ( Y6 @ N2 ) ) )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% lim_mono
thf(fact_5380_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N2: nat] : ( member @ A @ ( B2 @ N2 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) ) ) ) ) ).

% Sup_lim
thf(fact_5381_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N2: nat] : ( member @ A @ ( B2 @ N2 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_5382_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ_zero
thf(fact_5383_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_5384_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X3: nat] : ( times_times @ nat @ X3 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_5385_monoseq__convergent,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( topological_monoseq @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X8 @ I2 ) ) @ B6 )
       => ~ ! [L6: real] :
              ~ ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_5386_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N3: nat] : ( root @ N3 @ ( semiring_1_of_nat @ real @ N3 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_5387_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( ! [N6: nat] : ( ord_less_eq @ A @ ( A2 @ N6 ) @ X )
                & ! [M3: nat,N6: nat] :
                    ( ( ord_less_eq @ nat @ M3 @ N6 )
                   => ( ord_less_eq @ A @ ( A2 @ M3 ) @ ( A2 @ N6 ) ) ) )
              | ( ! [N6: nat] : ( ord_less_eq @ A @ X @ ( A2 @ N6 ) )
                & ! [M3: nat,N6: nat] :
                    ( ( ord_less_eq @ nat @ M3 @ N6 )
                   => ( ord_less_eq @ A @ ( A2 @ N6 ) @ ( A2 @ M3 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_5388_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N3: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N3 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_5389_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_inverse_n
thf(fact_5390_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X8: nat > A,X: A,L: nat] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L )
           => ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( X8 @ ( times_times @ nat @ N3 @ L ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_5391_nested__sequence__unique,axiom,
    ! [F2: nat > real,G2: nat > real] :
      ( ! [N2: nat] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( G2 @ ( suc @ N2 ) ) @ ( G2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( G2 @ N2 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N3: nat] : ( minus_minus @ real @ ( F2 @ N3 ) @ ( G2 @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L2: real] :
                ( ! [N6: nat] : ( ord_less_eq @ real @ ( F2 @ N6 ) @ L2 )
                & ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) )
                & ! [N6: nat] : ( ord_less_eq @ real @ L2 @ ( G2 @ N6 ) )
                & ( filterlim @ nat @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_5392_LIMSEQ__inverse__zero,axiom,
    ! [X8: nat > real] :
      ( ! [R: real] :
        ? [N8: nat] :
        ! [N2: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N2 )
         => ( ord_less @ real @ R @ ( X8 @ N2 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( inverse_inverse @ real @ ( X8 @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_5393_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N3: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N3 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_5394_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( root @ N3 @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_5395_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N3: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_5396_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R2: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( plus_plus @ real @ R2 @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R2 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_5397_increasing__LIMSEQ,axiom,
    ! [F2: nat > real,L: real] :
      ( ! [N2: nat] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ L )
       => ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [N6: nat] : ( ord_less_eq @ real @ L @ ( plus_plus @ real @ ( F2 @ N6 ) @ E ) ) )
         => ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_5398_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_5399_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_5400_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_5401_LIMSEQ__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_5402_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
            @ ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_5403_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
            @ ( minus_minus @ A @ C2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_5404_LIMSEQ__divide__realpow__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_5405_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_5406_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_5407_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_5408_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F3: nat > A,S6: A] :
              ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S6 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def'
thf(fact_5409_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N3: nat] : ( root @ N3 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_5410_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R2: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( plus_plus @ real @ R2 @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R2 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_5411_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ No @ N3 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N3 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_5412_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [No2: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N2 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N2 ) @ L5 ) ) @ R ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_5413_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A,R2: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [No3: nat] :
              ! [N6: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N6 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N6 ) @ L5 ) ) @ R2 ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_5414_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_5415_tendsto__exp__limit__sequentially,axiom,
    ! [X: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N3 ) ) ) @ N3 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_5416_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F4: filter @ B,X: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F4 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y4: B] : ( power_power @ A @ X @ ( F2 @ Y4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_power_zero
thf(fact_5417_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R2: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( times_times @ real @ R2 @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R2 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_5418_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_5419_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( A2 @ N3 ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_5420_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z2: A,S: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N2: nat] :
                  ( ( S @ N2 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N3: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z2 @ ( S @ N3 ) ) ) @ ( F2 @ Z2 ) ) @ ( S @ N3 ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_5421_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_5422_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_5423_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( summable @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( A2 @ N3 ) ) ) ) ) ) ).

% summable
thf(fact_5424_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( Theta @ J3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K2: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_5425_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N3: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_5426_zeroseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_5427_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_5428_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( filterlim @ nat @ real
            @ ^ [N3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_5429_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L2: real] :
              ( ! [N6: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N6 ) ) )
                  @ L2 )
              & ( filterlim @ nat @ real
                @ ^ [N3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L2 )
                @ ( at_top @ nat ) )
              & ! [N6: nat] :
                  ( ord_less_eq @ real @ L2
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N6 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L2 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_5430_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N3: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_5431_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_5432_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F7: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F7 )
            & ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F7 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_5433_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D5: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D5 )
            & ( filterlim @ A @ real
              @ ^ [H3: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X @ H3 ) ) @ ( F2 @ X ) ) @ ( D5 @ H3 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_5434_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F7: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F7 )
            & ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F7 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_within
thf(fact_5435_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( real_V3181309239436604168linear @ A @ B
        @ ^ [X3: A] : ( zero_zero @ B ) ) ) ).

% bounded_linear_zero
thf(fact_5436_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
            ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K9 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_5437_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G2: C > A,F4: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( filterlim @ C @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X3: C] : ( F2 @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% bounded_linear.tendsto_zero
thf(fact_5438_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K9 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_5439_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K9 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_5440_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K6: real] :
          ( ! [X2: A,Y2: A] :
              ( ( F2 @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
         => ( ! [R: real,X2: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R @ X2 ) )
                = ( real_V8093663219630862766scaleR @ B @ R @ ( F2 @ X2 ) ) )
           => ( ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K6 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_5441_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F7: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F7 )
            & ( filterlim @ A @ real
              @ ^ [Y4: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( F7 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_5442_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F7: A > B,X: A,F2: A > B,S: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F7 )
         => ( ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( F7 @ ( minus_minus @ A @ Y4 @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivativeI
thf(fact_5443_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F7: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F7 )
            & ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( F7 @ ( minus_minus @ A @ Y4 @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_5444_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F7: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F7 )
            & ? [E3: A > B] :
                ( ! [H3: A] :
                    ( ( F2 @ ( plus_plus @ A @ X @ H3 ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F7 @ H3 ) ) @ ( E3 @ H3 ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H3: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H3 ) ) @ ( real_V7770717601297561774m_norm @ A @ H3 ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_5445_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F3: A > B,F13: A > B,F9: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F13 )
              & ( filterlim @ A @ B
                @ ^ [Y4: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y4
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X3: A] : X3 ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F3 @ Y4 )
                        @ ( F3
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X3: A] : X3 ) ) )
                      @ ( F13
                        @ ( minus_minus @ A @ Y4
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X3: A] : X3 ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F9 ) ) ) ) ) ).

% has_derivative_def
thf(fact_5446_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X: A,S2: set @ A,F2: A > B,F7: A > B] :
          ( ( member @ A @ X @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F7 )
                & ? [E3: A > B] :
                    ( ! [H3: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X @ H3 ) @ S2 )
                       => ( ( F2 @ ( plus_plus @ A @ X @ H3 ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F7 @ H3 ) ) @ ( E3 @ H3 ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H3: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H3 ) ) @ ( real_V7770717601297561774m_norm @ A @ H3 ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_5447_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E2: real,F7: A > B,S: set @ A,X: A,F2: A > B,H6: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ F7 )
           => ( ! [Y2: A] :
                  ( ( member @ A @ Y2 @ S )
                 => ( ( Y2 != X )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X ) @ E2 )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y2 ) @ ( F2 @ X ) ) @ ( F7 @ ( minus_minus @ A @ Y2 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ X ) ) ) @ ( H6 @ Y2 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H6 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X @ S ) )
               => ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_5448_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ( real_V557655796197034286t_dist @ A @ X @ Y )
            = ( zero_zero @ real ) )
          = ( X = Y ) ) ) ).

% dist_eq_0_iff
thf(fact_5449_dist__self,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A] :
          ( ( real_V557655796197034286t_dist @ A @ X @ X )
          = ( zero_zero @ real ) ) ) ).

% dist_self
thf(fact_5450_dist__0__norm,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( zero_zero @ A ) @ X )
          = ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% dist_0_norm
thf(fact_5451_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) )
          = ( ( X != Y ) ) ) ) ).

% zero_less_dist_iff
thf(fact_5452_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( zero_zero @ real ) )
          = ( X = Y ) ) ) ).

% dist_le_zero_iff
thf(fact_5453_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A5: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A5 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ A5 )
               => ( ord_less @ A @ X2 @ X ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A5 ) @ A5 ) ) ) ) ).

% Sup_notin_open
thf(fact_5454_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A5: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A5 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ A5 )
               => ( ord_less @ A @ X @ X2 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A5 ) @ A5 ) ) ) ) ).

% Inf_notin_open
thf(fact_5455_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y: A,X: A,E2: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E2 ) ) ) ).

% dist_commute_lessI
thf(fact_5456_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S5: set @ A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ S5 )
             => ? [E3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                  & ! [Y4: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y4 @ X3 ) @ E3 )
                     => ( member @ A @ Y4 @ S5 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_5457_open__ball,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,D2: real] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y4 ) @ D2 ) ) ) ) ).

% open_ball
thf(fact_5458_openI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ S2 )
             => ? [T9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T9 )
                  & ( member @ A @ X2 @ T9 )
                  & ( ord_less_eq @ ( set @ A ) @ T9 @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ A @ S2 ) ) ) ).

% openI
thf(fact_5459_open__subopen,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S5: set @ A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ S5 )
             => ? [T10: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T10 )
                  & ( member @ A @ X3 @ T10 )
                  & ( ord_less_eq @ ( set @ A ) @ T10 @ S5 ) ) ) ) ) ) ).

% open_subopen
thf(fact_5460_first__countable__basis,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
        ? [A8: nat > ( set @ A )] :
          ( ! [I3: nat] :
              ( ( member @ A @ X @ ( A8 @ I3 ) )
              & ( topolo1002775350975398744n_open @ A @ ( A8 @ I3 ) ) )
          & ! [S9: set @ A] :
              ( ( ( topolo1002775350975398744n_open @ A @ S9 )
                & ( member @ A @ X @ S9 ) )
             => ? [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I2 ) @ S9 ) ) ) ) ).

% first_countable_basis
thf(fact_5461_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) ) ) ).

% zero_le_dist
thf(fact_5462_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) ) ) ) ).

% dist_pos_lt
thf(fact_5463_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_5464_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A )
        = ( ^ [X3: A] : ( real_V557655796197034286t_dist @ A @ X3 @ ( zero_zero @ A ) ) ) ) ) ).

% norm_conv_dist
thf(fact_5465_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z2 ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E2 ) ) ) ).

% dist_triangle_le
thf(fact_5466_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A,A2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ X ) @ ( real_V557655796197034286t_dist @ A @ A2 @ Y ) ) ) ) ).

% dist_triangle3
thf(fact_5467_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z2 ) ) ) ) ).

% dist_triangle2
thf(fact_5468_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z2 ) ) ) ) ).

% dist_triangle
thf(fact_5469_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y: A,E1: real,X23: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X23 @ Y ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X23 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_5470_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z2 ) ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E2 ) ) ) ).

% dist_triangle_lt
thf(fact_5471_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A2: A,S2: set @ A,T6: set @ A] :
          ( ( member @ A @ A2 @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
             => ( ( topolo174197925503356063within @ A @ A2 @ T6 )
                = ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% at_within_open_subset
thf(fact_5472_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ X @ Y )
             => ? [B4: A] :
                  ( ( ord_less @ A @ X @ B4 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X @ B4 ) @ S2 ) ) ) ) ) ) ).

% open_right
thf(fact_5473_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A2: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_5474_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F7: A,A2: A,S2: set @ A,D2: real,G2: A > A] :
          ( ( has_field_derivative @ A @ F2 @ F7 @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ A2 @ S2 )
             => ( ! [X2: A] :
                    ( ( member @ A @ X2 @ S2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D2 )
                     => ( ( F2 @ X2 )
                        = ( G2 @ X2 ) ) ) )
               => ( has_field_derivative @ A @ G2 @ F7 @ ( topolo174197925503356063within @ A @ A2 @ S2 ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_5475_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F7: A > B,X: A,S: set @ A,D2: real,G2: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ X @ S )
             => ( ! [X16: A] :
                    ( ( member @ A @ X16 @ S )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) @ D2 )
                     => ( ( F2 @ X16 )
                        = ( G2 @ X16 ) ) ) )
               => ( has_derivative @ A @ B @ G2 @ F7 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_5476_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% metric_CauchyI
thf(fact_5477_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M10: nat] :
              ! [M3: nat] :
                ( ( ord_less_eq @ nat @ M10 @ M3 )
               => ! [N6: nat] :
                    ( ( ord_less_eq @ nat @ M10 @ N6 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N6 ) ) @ E2 ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_5478_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S6: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N7: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S6 @ N3 ) @ ( S6 @ N7 ) ) @ E3 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_5479_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X7: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M2 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ M2 ) @ ( X7 @ N3 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_5480_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S5: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S5 )
               => ( ( member @ A @ F0 @ S5 )
                 => ? [N7: nat] :
                    ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ N3 )
                     => ( member @ A @ ( F2 @ N3 ) @ S5 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_5481_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G2 )
           => ( ( ( G2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X3: A] : X3 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F4
                @ ^ [X3: A] : ( divide_divide @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_5482_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X3: A] : X3 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X3: A] : ( inverse_inverse @ B @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_inverse
thf(fact_5483_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X3: A] : X3 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X3: A] : ( sgn_sgn @ B @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_sgn
thf(fact_5484_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,L: A,A2: C,G2: C > B,M: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X2: C] :
                ( ( X2 != A2 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G2 @ X2 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ L ) ) )
           => ( filterlim @ C @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_5485_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L: B,X: A,S2: set @ A,D2: real,G2: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ! [X16: A] :
                  ( ( member @ A @ X16 @ S2 )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) @ D2 )
                     => ( ( F2 @ X16 )
                        = ( G2 @ X16 ) ) ) ) )
             => ( filterlim @ A @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_5486_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y: A,X15: A,E2: real,X23: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X15 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X23 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X23 ) @ E2 ) ) ) ) ).

% dist_triangle_half_r
thf(fact_5487_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y: A,E2: real,X23: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X23 @ Y ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X23 ) @ E2 ) ) ) ) ).

% dist_triangle_half_l
thf(fact_5488_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,X23: A,E2: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X23 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X23 @ X32 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X42 ) @ E2 ) ) ) ) ) ).

% dist_triangle_third
thf(fact_5489_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G2: A > B,G5: filter @ B,X: A,S2: set @ A,F4: filter @ B,D2: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G2 @ G5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G5 @ F4 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X16: A] :
                    ( ( member @ A @ X16 @ S2 )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) @ D2 )
                       => ( ( F2 @ X16 )
                          = ( G2 @ X16 ) ) ) ) )
               => ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_5490_continuous__powr,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G2 )
           => ( ( ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X3: A] : X3 ) )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ A @ real @ F4
                @ ^ [X3: A] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% continuous_powr
thf(fact_5491_continuous__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X3: A] : X3 ) )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X3: A] : ( ln_ln @ real @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_ln
thf(fact_5492_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less @ nat @ M4 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI'
thf(fact_5493_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M2 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M2 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ M2 ) @ ( F3 @ N3 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_5494_dist__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( real_V557655796197034286t_dist @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ring_1_of_int @ real @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ) ).

% dist_of_nat
thf(fact_5495_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
          = ( filterlim @ A @ real
            @ ^ [X3: A] : ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_dist_iff
thf(fact_5496_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X3: A] :
                        ( ( ( X3 != A2 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ S6 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_5497_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R2: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X5: A] :
                    ( ( ( X5 != A2 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X5 ) @ L5 ) @ R2 ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_5498_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [S8: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S8 )
                  & ! [X2: A] :
                      ( ( ( X2 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ S8 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ L5 ) @ R ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_5499_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G2: A > B,L: B,A2: A,R4: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
           => ( ! [X2: A] :
                  ( ( X2 != A2 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ R4 )
                   => ( ( F2 @ X2 )
                      = ( G2 @ X2 ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_5500_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A,R2: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [No3: nat] :
              ! [N6: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N6 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N6 ) @ L5 ) @ R2 ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_5501_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [No2: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N2 ) @ L5 ) @ R ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_5502_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ No @ N3 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N3 ) @ L5 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_5503_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X7: nat > A] :
            ! [J3: nat] :
            ? [M8: nat] :
            ! [M2: nat] :
              ( ( ord_less_eq @ nat @ M8 @ M2 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ M2 ) @ ( X7 @ N3 ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_5504_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G2: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G2 @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X2: A] :
                      ( ( ( X2 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D3 ) )
                     => ( ( F2 @ X2 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( G2 @ ( F2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_5505_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F2 )
         => ( ( ( cos @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X3: A] : X3 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X3: A] : ( tan @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_tan
thf(fact_5506_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F2 )
         => ( ( ( sin @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X3: A] : X3 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X3: A] : ( cot @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_cot
thf(fact_5507_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ F2 )
         => ( ( ( cosh @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ C @ C @ F4
                    @ ^ [X3: C] : X3 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ F4
              @ ^ [X3: C] : ( tanh @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_tanh
thf(fact_5508_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X3: A] : X3 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X3: A] : ( arcosh @ real @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_5509_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A2: A,F2: A > C,G2: C > D,L: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ C @ D @ G2 @ ( topolo7230453075368039082e_nhds @ D @ L ) @ ( topolo174197925503356063within @ C @ ( F2 @ A2 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X2: A] :
                      ( ( ( X2 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D3 ) )
                     => ( ( F2 @ X2 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X3: A] : ( G2 @ ( F2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_5510_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S2: set @ A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S2 )
           => ( ( topolo1002775350975398744n_open @ A @ S2 )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
                = ( filterlim @ A @ D
                  @ ^ [H3: A] : ( F2 @ ( plus_plus @ A @ A2 @ H3 ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L5 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_5511_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G2 )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X3: A] : X3 ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                      @ ^ [X3: A] : X3 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G2
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                        @ ^ [X3: A] : X3 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F4
                    @ ^ [X3: A] : ( log @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_5512_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No )
                    & ! [N3: nat] :
                        ( ( ord_less_eq @ nat @ No @ N3 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N3 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_5513_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S5: set @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [K4: set @ A] :
                  ( ( finite_finite @ A @ K4 )
                  & ( ord_less_eq @ ( set @ A ) @ S5
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X3: A] :
                            ( collect @ A
                            @ ^ [Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y4 ) @ E3 ) )
                        @ K4 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_5514_tendsto__exp__limit__at__right,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y4: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y4 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y4 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_5515_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A
            @ ^ [X3: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_5516_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I ) ) ) ).

% greaterThan_iff
thf(fact_5517_cInf__greaterThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A )
        & ( no_top @ A ) )
     => ! [X: A] :
          ( ( complete_Inf_Inf @ A @ ( set_ord_greaterThan @ A @ X ) )
          = X ) ) ).

% cInf_greaterThan
thf(fact_5518_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X ) @ ( set_ord_greaterThan @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% greaterThan_subset_iff
thf(fact_5519_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ X @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_5520_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L4: A] : ( collect @ A @ ( ord_less @ A @ L4 ) ) ) ) ) ).

% greaterThan_def
thf(fact_5521_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( topolo6688025880775521714ounded @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S2 )
           => ( topolo6688025880775521714ounded @ A @ T6 ) ) ) ) ).

% totally_bounded_subset
thf(fact_5522_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_5523_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [A4: A,B4: A] :
              ( ( member @ A @ X @ ( set_ord_lessThan @ A @ A4 ) )
              & ( member @ A @ Y @ ( set_ord_greaterThan @ A @ B4 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A4 ) @ ( set_ord_greaterThan @ A @ B4 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_5524_filterlim__real__at__infinity__sequentially,axiom,
    filterlim @ nat @ real @ ( semiring_1_of_nat @ real ) @ ( at_infinity @ real ) @ ( at_top @ nat ) ).

% filterlim_real_at_infinity_sequentially
thf(fact_5525_tendsto__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( filterlim @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ).

% tendsto_of_nat
thf(fact_5526_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X3: real] : ( F2 @ ( plus_plus @ real @ X3 @ A2 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_5527_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_infinity @ A ) ) ) ).

% tendsto_inverse_0
thf(fact_5528_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P6: A,F1: filter @ B,C2: A,L: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P6 @ ( set_ord_greaterThan @ A @ P6 ) ) @ F1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L
                = ( times_times @ A @ C2 @ P6 ) )
             => ( filterlim @ B @ A
                @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F2 @ X3 ) )
                @ ( topolo174197925503356063within @ A @ L @ ( set_ord_greaterThan @ A @ L ) )
                @ F1 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_5529_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F4: filter @ B,G2: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G2 @ ( at_infinity @ A ) @ F4 )
             => ( filterlim @ B @ A
                @ ^ [X3: B] : ( times_times @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_5530_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F4: filter @ C,G2: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ C @ A @ G2 @ ( at_infinity @ A ) @ F4 )
           => ( filterlim @ C @ A
              @ ^ [X3: C] : ( divide_divide @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_divide_0
thf(fact_5531_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X3: A] : ( power_power @ B @ ( F2 @ X3 ) @ N )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_5532_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_5533_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filterlim_inverse_at_infinity
thf(fact_5534_lim__infinity__imp__sequentially,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: real > A,L: A] :
          ( ( filterlim @ real @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( F2 @ ( semiring_1_of_nat @ real @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% lim_infinity_imp_sequentially
thf(fact_5535_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [G2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X3: A] : ( inverse_inverse @ B @ ( G2 @ X3 ) )
            @ ( topolo174197925503356063within @ B @ ( zero_zero @ B ) @ ( top_top @ ( set @ B ) ) )
            @ F4 )
          = ( filterlim @ A @ B @ G2 @ ( at_infinity @ B ) @ F4 ) ) ) ).

% filterlim_inverse_at_iff
thf(fact_5536_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G2: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G2 )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( if @ B @ ( ord_less_eq @ A @ X3 @ A2 ) @ ( G2 @ X3 ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_5537_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F4: filter @ A,G2: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ A @ A @ G2 @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F4 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X3: A] : ( divide_divide @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_5538_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_5539_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) )
          = ( filterlim @ A @ A @ ( comp @ A @ A @ A @ F2 @ ( inverse_inverse @ A ) ) @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% lim_at_infinity_0
thf(fact_5540_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N: nat,B6: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N )
             => ( eventually @ A
                @ ^ [Z5: A] :
                    ( ord_less_eq @ real @ B6
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_5541_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X3: real] : ( power_power @ real @ ( F2 @ X3 ) @ N )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_5542_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X2: real] :
          ( ( ord_less_eq @ real @ X2 @ B2 )
         => ? [Y5: real] :
              ( ( has_field_derivative @ real @ F2 @ Y5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y5 ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_5543_at__bot__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_bot @ real ) @ ( at_infinity @ real ) ).

% at_bot_le_at_infinity
thf(fact_5544_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ real @ ( F2 @ X3 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_bot @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_5545_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_5546_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot
thf(fact_5547_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X3: A] : ( ord_less @ B @ ( F2 @ X3 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_5548_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_5549_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N7: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ N7 @ N3 )
           => ( P @ N3 ) ) ) ) ).

% eventually_sequentially
thf(fact_5550_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X2: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X2 )
         => ( P @ X2 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_5551_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ A @ X3 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_5552_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N7: A] :
              ! [N3: A] :
                ( ( ord_less @ A @ N3 @ N7 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_5553_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X3: A] : ( ord_less_eq @ A @ X3 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_5554_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N7: A] :
              ! [N3: A] :
                ( ( ord_less_eq @ A @ N3 @ N7 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_5555_le__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
          ! [P3: A > $o] :
            ( ( eventually @ A @ P3 @ F10 )
           => ( eventually @ A @ P3 @ F9 ) ) ) ) ).

% le_filter_def
thf(fact_5556_filter__leI,axiom,
    ! [A: $tType,F11: filter @ A,F4: filter @ A] :
      ( ! [P8: A > $o] :
          ( ( eventually @ A @ P8 @ F11 )
         => ( eventually @ A @ P8 @ F4 ) )
     => ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 ) ) ).

% filter_leI
thf(fact_5557_filter__leD,axiom,
    ! [A: $tType,F4: filter @ A,F11: filter @ A,P: A > $o] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 )
     => ( ( eventually @ A @ P @ F11 )
       => ( eventually @ A @ P @ F4 ) ) ) ).

% filter_leD
thf(fact_5558_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N7: A] :
              ! [N3: A] :
                ( ( ord_less_eq @ A @ N7 @ N3 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_5559_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X2: A] :
              ( ( ord_less_eq @ A @ C2 @ X2 )
             => ( P @ X2 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_5560_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N7: A] :
              ! [N3: A] :
                ( ( ord_less @ A @ N7 @ N3 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_5561_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_5562_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_5563_le__sequentially,axiom,
    ! [F4: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F4 @ ( at_top @ nat ) )
      = ( ! [N7: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N7 ) @ F4 ) ) ) ).

% le_sequentially
thf(fact_5564_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F4: filter @ B,G5: filter @ A,F11: filter @ B,G6: filter @ A,F7: A > B] :
      ( ( filterlim @ A @ B @ F2 @ F4 @ G5 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
       => ( ( ord_less_eq @ ( filter @ A ) @ G6 @ G5 )
         => ( ( eventually @ A
              @ ^ [X3: A] :
                  ( ( F2 @ X3 )
                  = ( F7 @ X3 ) )
              @ G6 )
           => ( filterlim @ A @ B @ F7 @ F11 @ G6 ) ) ) ) ) ).

% filterlim_mono_eventually
thf(fact_5565_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ real @ ( F2 @ X3 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( inverse_inverse @ real @ ( F2 @ X3 ) )
          @ ( at_bot @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_5566_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G2: B > A,A2: A] :
          ( ! [X2: A,Y2: A] :
              ( ( Q @ X2 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X2: B] :
                ( ( P @ X2 )
               => ( ( F2 @ ( G2 @ X2 ) )
                  = X2 ) )
           => ( ! [X2: B] :
                  ( ( P @ X2 )
                 => ( Q @ ( G2 @ X2 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B4: A] :
                      ( ( Q @ B4 )
                     => ( ord_less @ A @ A2 @ B4 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_5567_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ ( top_top @ A ) )
                  & ! [Z5: A] :
                      ( ( ord_less @ A @ B3 @ Z5 )
                     => ( P @ Z5 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_5568_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G2: B > A] :
          ( ! [X2: A,Y2: A] :
              ( ( Q @ X2 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X2: B] :
                ( ( P @ X2 )
               => ( ( F2 @ ( G2 @ X2 ) )
                  = X2 ) )
           => ( ! [X2: B] :
                  ( ( P @ X2 )
                 => ( Q @ ( G2 @ X2 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_5569_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y: A,X: A,P: A > $o] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ X )
                  & ! [Y4: A] :
                      ( ( ord_less @ A @ B3 @ Y4 )
                     => ( ( ord_less @ A @ Y4 @ X )
                       => ( P @ Y4 ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_5570_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ B3 @ X )
                & ! [Y4: A] :
                    ( ( ord_less @ A @ B3 @ Y4 )
                   => ( ( ord_less @ A @ Y4 @ X )
                     => ( P @ Y4 ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_5571_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ X @ B3 )
                & ! [Y4: A] :
                    ( ( ord_less @ A @ X @ Y4 )
                   => ( ( ord_less @ A @ Y4 @ B3 )
                     => ( P @ Y4 ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_5572_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y: A,P: A > $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ X @ B3 )
                  & ! [Y4: A] :
                      ( ( ord_less @ A @ X @ Y4 )
                     => ( ( ord_less @ A @ Y4 @ B3 )
                       => ( P @ Y4 ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_5573_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
              ! [X3: A] :
                ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
               => ( P @ X3 ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_5574_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G2: B > A,Net: filter @ B,H: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G2 @ N3 ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N3: B] : ( ord_less_eq @ A @ ( G2 @ N3 ) @ ( H @ N3 ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_5575_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
          = ( ! [L4: A] :
                ( ( ord_less @ A @ L4 @ X )
               => ( eventually @ B
                  @ ^ [X3: B] : ( ord_less @ A @ L4 @ ( F2 @ X3 ) )
                  @ F4 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X @ U2 )
               => ( eventually @ B
                  @ ^ [X3: B] : ( ord_less @ A @ ( F2 @ X3 ) @ U2 )
                  @ F4 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_5576_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y: A,F2: B > A,F4: filter @ B] :
          ( ! [A4: A] :
              ( ( ord_less @ A @ A4 @ Y )
             => ( eventually @ B
                @ ^ [X3: B] : ( ord_less @ A @ A4 @ ( F2 @ X3 ) )
                @ F4 ) )
         => ( ! [A4: A] :
                ( ( ord_less @ A @ Y @ A4 )
               => ( eventually @ B
                  @ ^ [X3: B] : ( ord_less @ A @ ( F2 @ X3 ) @ A4 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 ) ) ) ) ).

% order_tendstoI
thf(fact_5577_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
         => ( ( ord_less @ A @ A2 @ Y )
           => ( eventually @ B
              @ ^ [X3: B] : ( ord_less @ A @ A2 @ ( F2 @ X3 ) )
              @ F4 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_5578_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( eventually @ B
              @ ^ [X3: B] : ( ord_less @ A @ ( F2 @ X3 ) @ A2 )
              @ F4 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_5579_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F4: filter @ B,G2: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ F4 )
           => ( filterlim @ B @ A @ G2 @ ( at_top @ A ) @ F4 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_5580_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X3: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X3 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_5581_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X3 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top
thf(fact_5582_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X3: A] : ( ord_less @ B @ Z9 @ ( F2 @ X3 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_5583_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A] : ( eventually @ A @ ( ord_less @ A @ X ) @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) ) ) ).

% eventually_at_right_less
thf(fact_5584_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: B > real,G2: B > real,Net: filter @ B,H: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N3: B] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( G2 @ N3 ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N3: B] : ( ord_less_eq @ real @ ( G2 @ N3 ) @ ( H @ N3 ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_5585_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I3: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I3 ) )
             => ( ! [I3: nat] : ( member @ A @ X @ ( A8 @ I3 ) )
               => ~ ! [S9: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S9 )
                     => ( ( member @ A @ X @ S9 )
                       => ( eventually @ nat
                          @ ^ [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I4 ) @ S9 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_5586_eventually__Inf__base,axiom,
    ! [A: $tType,B6: set @ ( filter @ A ),P: A > $o] :
      ( ( B6
       != ( bot_bot @ ( set @ ( filter @ A ) ) ) )
     => ( ! [F6: filter @ A] :
            ( ( member @ ( filter @ A ) @ F6 @ B6 )
           => ! [G4: filter @ A] :
                ( ( member @ ( filter @ A ) @ G4 @ B6 )
               => ? [X5: filter @ A] :
                    ( ( member @ ( filter @ A ) @ X5 @ B6 )
                    & ( ord_less_eq @ ( filter @ A ) @ X5 @ ( inf_inf @ ( filter @ A ) @ F6 @ G4 ) ) ) ) )
       => ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B6 ) )
          = ( ? [X3: filter @ A] :
                ( ( member @ ( filter @ A ) @ X3 @ B6 )
                & ( eventually @ A @ P @ X3 ) ) ) ) ) ) ).

% eventually_Inf_base
thf(fact_5587_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( ( ord_less @ real @ B2 @ A2 )
     => ( eventually @ real
        @ ^ [X3: real] : ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ B2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ).

% eventually_at_left_real
thf(fact_5588_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
          = ( ? [D6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D6 ) )
                     => ( P @ X3 ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_5589_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ? [D6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                & ! [X3: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D6 )
                   => ( P @ X3 ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_5590_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_5591_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_5592_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X3: A] : ( P @ ( plus_plus @ A @ X3 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_5593_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ L )
            @ F4 )
         => ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ L )
               => ( eventually @ B
                  @ ^ [N3: B] : ( ord_less @ A @ X2 @ ( F2 @ N3 ) )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% increasing_tendsto
thf(fact_5594_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L: A,F2: B > A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ L @ ( F2 @ N3 ) )
            @ F4 )
         => ( ! [X2: A] :
                ( ( ord_less @ A @ L @ X2 )
               => ( eventually @ B
                  @ ^ [N3: B] : ( ord_less @ A @ ( F2 @ N3 ) @ X2 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% decreasing_tendsto
thf(fact_5595_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X3: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X3 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_5596_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F4: filter @ B,F2: B > A,X: A,G2: B > A,Y: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
           => ( ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
             => ( ( eventually @ B
                  @ ^ [X3: B] : ( ord_less_eq @ A @ ( G2 @ X3 ) @ ( F2 @ X3 ) )
                  @ F4 )
               => ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ) ).

% tendsto_le
thf(fact_5597_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ A2 @ ( F2 @ I4 ) )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_5598_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ ( F2 @ I4 ) @ A2 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_5599_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,A2: A,F4: filter @ C,G2: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( eventually @ C
              @ ^ [X3: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G2 @ X3 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X3 ) @ A2 ) )
              @ F4 )
           => ( filterlim @ C @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F4 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_5600_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_5601_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X3: real] : ( P @ ( plus_plus @ real @ X3 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_5602_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F4: B > ( filter @ A ),B6: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ B6 ) ) )
      = ( ? [X7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X7 @ B6 )
            & ( finite_finite @ B @ X7 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ X7 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_5603_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( eventually @ A
              @ ^ [X3: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X3 ) )
              @ F4 )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X3: A] : ( arcosh @ real @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_5604_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( eventually @ real
        @ ^ [X3: real] : ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ).

% eventually_at_right_real
thf(fact_5605_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
          = ( ? [D6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( ( X3 != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D6 ) )
                     => ( P @ X3 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_5606_exp__at__bot,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_bot @ real ) ).

% exp_at_bot
thf(fact_5607_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P6: A > $o] :
          ( ( eventually @ A @ P6 @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B3 )
                & ! [X3: A] :
                    ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
                   => ( P6 @ X3 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_5608_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X3: A] : ( ord_less @ B @ ( F2 @ X3 ) @ L5 )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_lessThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_5609_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X3: A] : ( ord_less @ B @ L5 @ ( F2 @ X3 ) )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_greaterThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_5610_filterlim__inverse__at__bot__neg,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_lessThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_bot_neg
thf(fact_5611_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ( eventually @ B
                  @ ^ [X3: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X3 ) @ L ) @ E3 )
                  @ F4 ) ) ) ) ) ).

% tendsto_iff
thf(fact_5612_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ( eventually @ B
                @ ^ [X3: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X3 ) @ L ) @ E )
                @ F4 ) )
         => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ).

% tendstoI
thf(fact_5613_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,E2: real] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ( eventually @ B
              @ ^ [X3: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X3 ) @ L ) @ E2 )
              @ F4 ) ) ) ) ).

% tendstoD
thf(fact_5614_eventually__Inf,axiom,
    ! [A: $tType,P: A > $o,B6: set @ ( filter @ A )] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B6 ) )
      = ( ? [X7: set @ ( filter @ A )] :
            ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X7 @ B6 )
            & ( finite_finite @ ( filter @ A ) @ X7 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ X7 ) ) ) ) ) ).

% eventually_Inf
thf(fact_5615_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G2: nat > real] :
          ( ( eventually @ nat
            @ ^ [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G2 @ N3 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G2 )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_5616_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X3: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X3 ) )
            @ F4 )
         => ( filterlim @ B @ real
            @ ^ [X3: B] : ( arcosh @ real @ ( F2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_5617_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G2: B > A,A2: A] :
          ( ! [X2: A,Y2: A] :
              ( ( Q @ X2 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X2: B] :
                ( ( P @ X2 )
               => ( ( F2 @ ( G2 @ X2 ) )
                  = X2 ) )
           => ( ! [X2: B] :
                  ( ( P @ X2 )
                 => ( Q @ ( G2 @ X2 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B4: A] :
                      ( ( Q @ B4 )
                     => ( ord_less @ A @ B4 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_5618_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B6: set @ A,F4: A > ( filter @ B ),P: B > $o] :
      ( ( B6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A4: A] :
            ( ( member @ A @ A4 @ B6 )
           => ! [B4: A] :
                ( ( member @ A @ B4 @ B6 )
               => ? [X5: A] :
                    ( ( member @ A @ X5 @ B6 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X5 ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ A4 ) @ ( F4 @ B4 ) ) ) ) ) )
       => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ B6 ) ) )
          = ( ? [X3: A] :
                ( ( member @ A @ X3 @ B6 )
                & ( eventually @ B @ P @ ( F4 @ X3 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_5619_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G2: A > C,K6: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ K6 ) )
              @ F4 )
           => ( filterlim @ A @ C @ G2 @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F4 ) ) ) ) ).

% tendsto_0_le
thf(fact_5620_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G2 @ ( at_bot @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( times_times @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_5621_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F2: C > A,F4: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F2 @ ( at_infinity @ A ) @ F4 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X3: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) )
                    @ F4 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_5622_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G2: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X3: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X3: A] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F4 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_5623_tendsto__powr2,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G2: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X3: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X3: A] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F4 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_5624_tendsto__powr_H,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G2: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
                @ F4 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr'
thf(fact_5625_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X3: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L ) ) @ ( F2 @ X3 ) )
              @ F4 ) ) ) ) ).

% eventually_floor_less
thf(fact_5626_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X3: A] : ( ord_less @ B @ ( F2 @ X3 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L ) ) )
              @ F4 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_5627_ln__at__0,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% ln_at_0
thf(fact_5628_lhopital,axiom,
    ! [F2: real > real,X: real,G2: real > real,G3: real > real,F7: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] :
                ( ( G2 @ X3 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] :
                  ( ( G3 @ X3 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X3: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X3: real] : ( has_field_derivative @ real @ G2 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_5629_lhopital__left,axiom,
    ! [F2: real > real,X: real,G2: real > real,G3: real > real,F7: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] :
                ( ( G2 @ X3 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] :
                  ( ( G3 @ X3 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X3: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X3: real] : ( has_field_derivative @ real @ G2 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_5630_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G3: real > real,F7: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] :
                ( ( G0 @ X3 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] :
                  ( ( G3 @ X3 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X3: real] : ( has_field_derivative @ real @ F0 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X3: real] : ( has_field_derivative @ real @ G0 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F0 @ X3 ) @ ( G0 @ X3 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_5631_lhopital__right,axiom,
    ! [F2: real > real,X: real,G2: real > real,G3: real > real,F7: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] :
                ( ( G2 @ X3 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] :
                  ( ( G3 @ X3 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X3: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X3: real] : ( has_field_derivative @ real @ G2 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_5632_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G2: nat > real] :
          ( ( eventually @ nat
            @ ^ [M2: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M2 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N3 ) ) ) @ ( G2 @ M2 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_5633_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F3: A > B,F9: filter @ A] :
            ? [Y4: B,K5: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
              & ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X3 ) @ Y4 ) @ K5 )
                @ F9 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_5634_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F3: A > B,F9: filter @ A] :
            ? [K5: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
              & ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X3 ) ) @ K5 )
                @ F9 ) ) ) ) ) ).

% Bfun_def
thf(fact_5635_at__top__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_top @ real ) @ ( at_infinity @ real ) ).

% at_top_le_at_infinity
thf(fact_5636_filterlim__int__sequentially,axiom,
    filterlim @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( at_top @ int ) @ ( at_top @ nat ) ).

% filterlim_int_sequentially
thf(fact_5637_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X3: A] :
              ! [Y4: A] :
                ( ( ord_less_eq @ A @ X3 @ Y4 )
               => ( P @ Y4 ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_5638_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,K6: real] :
          ( ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N2 ) ) @ K6 )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_5639_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X3: nat] : ( times_times @ A @ C2 @ ( F2 @ X3 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_5640_filterlim__real__sequentially,axiom,
    filterlim @ nat @ real @ ( semiring_1_of_nat @ real ) @ ( at_top @ real ) @ ( at_top @ nat ) ).

% filterlim_real_sequentially
thf(fact_5641_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: nat > A,G2: nat > B] :
          ( ( eventually @ nat
            @ ^ [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G2 @ N3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G2 @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_5642_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X3: A] :
                  ( ( P3 @ X3 )
                  & ! [Y4: A] :
                      ( ( P3 @ Y4 )
                     => ( ord_less_eq @ A @ Y4 @ X3 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_5643_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( power_power @ real @ ( F2 @ X3 ) @ N )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_pow_at_top
thf(fact_5644_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_5645_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X3: A] : ( inverse_inverse @ real @ ( F2 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_inverse_0_at_top
thf(fact_5646_eventually__at__top__to__right,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( at_top @ real ) )
      = ( eventually @ real
        @ ^ [X3: real] : ( P @ ( inverse_inverse @ real @ X3 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_top_to_right
thf(fact_5647_eventually__at__right__to__top,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( eventually @ real
        @ ^ [X3: real] : ( P @ ( inverse_inverse @ real @ X3 ) )
        @ ( at_top @ real ) ) ) ).

% eventually_at_right_to_top
thf(fact_5648_filterlim__int__of__nat__at__topD,axiom,
    ! [A: $tType,F2: int > A,F4: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X3: nat] : ( F2 @ ( semiring_1_of_nat @ int @ X3 ) )
        @ F4
        @ ( at_top @ nat ) )
     => ( filterlim @ int @ A @ F2 @ F4 @ ( at_top @ int ) ) ) ).

% filterlim_int_of_nat_at_topD
thf(fact_5649_filterlim__sequentially__iff__filterlim__real,axiom,
    ! [A: $tType,F2: A > nat,F4: filter @ A] :
      ( ( filterlim @ A @ nat @ F2 @ ( at_top @ nat ) @ F4 )
      = ( filterlim @ A @ real
        @ ^ [X3: A] : ( semiring_1_of_nat @ real @ ( F2 @ X3 ) )
        @ ( at_top @ real )
        @ F4 ) ) ).

% filterlim_sequentially_iff_filterlim_real
thf(fact_5650_Bseq__eq__bounded,axiom,
    ! [F2: nat > real,A2: real,B2: real] :
      ( ( ord_less_eq @ ( set @ real ) @ ( image @ nat @ real @ F2 @ ( top_top @ ( set @ nat ) ) ) @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
     => ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ).

% Bseq_eq_bounded
thf(fact_5651_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
                & ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ K5 ) ) ) ) ) ).

% Bseq_def
thf(fact_5652_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K6: real,X8: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
         => ( ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N2 ) ) @ K6 )
           => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_5653_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ~ ! [K9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
               => ~ ! [N6: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N6 ) ) @ K9 ) ) ) ) ).

% BseqE
thf(fact_5654_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [N6: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N6 ) ) @ K9 ) ) ) ) ).

% BseqD
thf(fact_5655_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N7: nat] :
              ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N7 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_5656_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N7: nat] :
              ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N7 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_5657_Bseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_5658_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( times_times @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_5659_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( times_times @ real @ ( G2 @ X3 ) @ ( F2 @ X3 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_5660_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ real @ S @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( powr @ real @ ( F2 @ X3 ) @ S )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% tendsto_neg_powr
thf(fact_5661_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X3: real] : ( divide_divide @ real @ ( ln_ln @ real @ X3 ) @ X3 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_5662_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X3: real] : ( F2 @ ( inverse_inverse @ real @ X3 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_top_to_right
thf(fact_5663_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( filterlim @ real @ A
        @ ^ [X3: real] : ( F2 @ ( inverse_inverse @ real @ X3 ) )
        @ F4
        @ ( at_top @ real ) ) ) ).

% filterlim_at_right_to_top
thf(fact_5664_filterlim__inverse__at__top__right,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_top_right
thf(fact_5665_filterlim__inverse__at__right__top,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) @ ( at_top @ real ) ).

% filterlim_inverse_at_right_top
thf(fact_5666_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_5667_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X3 ) )
              @ F4 )
           => ( filterlim @ A @ real
              @ ^ [X3: A] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ ( at_top @ real )
              @ F4 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_5668_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
        @ F4 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_5669_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
        @ F4 )
     => ( ( filterlim @ A @ real
          @ ^ [X3: A] : ( inverse_inverse @ real @ ( F2 @ X3 ) )
          @ ( at_top @ real )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_5670_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( inverse_inverse @ real @ ( F2 @ X3 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_5671_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( times_times @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_5672_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,K6: real,F4: filter @ A] :
          ( ( eventually @ A
            @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ K6 )
            @ F4 )
         => ( bfun @ A @ B @ F2 @ F4 ) ) ) ).

% BfunI
thf(fact_5673_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X3: real] : ( divide_divide @ real @ ( power_power @ real @ X3 @ K ) @ ( exp @ real @ X3 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_5674_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K4 )
                & ? [N7: nat] :
                  ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N3 ) @ ( uminus_uminus @ A @ ( X8 @ N7 ) ) ) ) @ K4 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_5675_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K4 )
                & ? [X3: A] :
                  ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N3 ) @ ( uminus_uminus @ A @ X3 ) ) ) @ K4 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_5676_lhopital__left__at__top,axiom,
    ! [G2: real > real,X: real,G3: real > real,F2: real > real,F7: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G3 @ X3 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G2 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_5677_lhopital__at__top,axiom,
    ! [G2: real > real,X: real,G3: real > real,F2: real > real,F7: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G3 @ X3 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G2 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_5678_lhospital__at__top__at__top,axiom,
    ! [G2: real > real,G3: real > real,F2: real > real,F7: real > real,X: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G3 @ X3 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G2 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_5679_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X2: real] :
          ( ( ord_less_eq @ real @ B2 @ X2 )
         => ? [Y5: real] :
              ( ( has_field_derivative @ real @ F2 @ Y5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y5 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_5680_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( bfun @ B @ A
              @ ^ [X3: B] : ( inverse_inverse @ A @ ( F2 @ X3 ) )
              @ F4 ) ) ) ) ).

% Bfun_inverse
thf(fact_5681_lhopital__right__0__at__top,axiom,
    ! [G2: real > real,G3: real > real,F2: real > real,F7: real > real,X: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G3 @ X3 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G2 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_5682_lhopital__right__at__top,axiom,
    ! [G2: real > real,X: real,G3: real > real,F2: real > real,F7: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G3 @ X3 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G2 @ ( G3 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F7 @ X3 ) @ ( G3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_5683_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X3: real] : ( power_power @ real @ ( F2 @ X3 ) @ N )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_5684_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( bfun @ A @ B @ F2 @ F4 )
         => ~ ! [B8: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B8 )
               => ~ ( eventually @ A
                    @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ B8 )
                    @ F4 ) ) ) ) ).

% BfunE
thf(fact_5685_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G2: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A3: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A3 )
               => ! [B3: nat] :
                    ( ( ord_less @ nat @ A3 @ B3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A3 @ B3 ) ) ) @ ( G2 @ A3 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_5686_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F5: nat > A] :
                ( ! [N6: nat] : ( ord_less @ A @ A2 @ ( F5 @ N6 ) )
               => ( ! [N6: nat] : ( ord_less @ A @ ( F5 @ N6 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F5 )
                   => ( ( filterlim @ nat @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N3: nat] : ( P @ ( F5 @ N3 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_5687_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G2: B > A,Y6: set @ B,X8: set @ A,F4: filter @ B,F2: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G2 @ Y6 ) @ X8 )
     => ( ( eventually @ B
          @ ^ [X3: B] : ( member @ B @ X3 @ Y6 )
          @ F4 )
       => ( ( map_filter_on @ A @ C @ X8 @ F2 @ ( map_filter_on @ B @ A @ Y6 @ G2 @ F4 ) )
          = ( map_filter_on @ B @ C @ Y6 @ ( comp @ A @ C @ B @ F2 @ G2 ) @ F4 ) ) ) ) ).

% map_filter_on_comp
thf(fact_5688_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_5689_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_5690_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_5691_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_5692_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_5693_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_5694_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_5695_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_5696_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_5697_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoD
thf(fact_5698_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoE
thf(fact_5699_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_5700_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X3: A,Y4: A] :
              ( ( ord_less_eq @ A @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F3 @ Y4 ) @ ( F3 @ X3 ) ) ) ) ) ) ).

% antimono_def
thf(fact_5701_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_5702_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_5703_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_5704_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_5705_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: nat > A,I: nat] :
          ( ( order_antimono @ nat @ A @ A5 )
         => ( ord_less_eq @ A @ ( A5 @ ( suc @ I ) ) @ ( A5 @ I ) ) ) ) ).

% decseq_SucD
thf(fact_5706_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N2 ) ) @ ( X8 @ N2 ) )
         => ( order_antimono @ nat @ A @ X8 ) ) ) ).

% decseq_SucI
thf(fact_5707_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ ( suc @ N3 ) ) @ ( F3 @ N3 ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_5708_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I: nat,J: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ord_less_eq @ A @ ( F2 @ J ) @ ( F2 @ I ) ) ) ) ) ).

% decseqD
thf(fact_5709_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X7: nat > A] :
            ! [M2: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M2 @ N3 )
             => ( ord_less_eq @ A @ ( X7 @ N3 ) @ ( X7 @ M2 ) ) ) ) ) ) ).

% decseq_def
thf(fact_5710_decseq__bounded,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ B6 @ ( X8 @ I2 ) )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% decseq_bounded
thf(fact_5711_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_5712_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_5713_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ Y @ X )
             => ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ X )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B4 @ X ) @ S2 ) ) ) ) ) ) ).

% open_left
thf(fact_5714_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_5715_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_5716_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.head
thf(fact_5717_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G2 @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_5718_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_5719_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_5720_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_5721_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_5722_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_5723_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_5724_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_5725_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N: nat] :
          ( ( order_antimono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L5 @ ( X8 @ N ) ) ) ) ) ).

% decseq_ge
thf(fact_5726_decseq__convergent,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ B6 @ ( X8 @ I2 ) )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I3: nat] : ( ord_less_eq @ real @ L6 @ ( X8 @ I3 ) ) ) ) ) ).

% decseq_convergent
thf(fact_5727_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_5728_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_5729_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_5730_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J: nat,I: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ I ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_5731_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X8: B > C,L5: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S7: nat > B] :
                ( ! [N6: nat] : ( ord_less @ B @ A2 @ ( S7 @ N6 ) )
               => ( ! [N6: nat] : ( ord_less @ B @ ( S7 @ N6 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S7 )
                   => ( ( filterlim @ nat @ B @ S7 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N3: nat] : ( X8 @ ( S7 @ N3 ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X8 @ ( topolo7230453075368039082e_nhds @ C @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_5732_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A] :
          ( ! [A4: A,B4: A,X2: A] :
              ( ( member @ A @ A4 @ S2 )
             => ( ( member @ A @ B4 @ S2 )
               => ( ( ord_less_eq @ A @ A4 @ X2 )
                 => ( ( ord_less_eq @ A @ X2 @ B4 )
                   => ( member @ A @ X2 @ S2 ) ) ) ) )
         => ? [A4: A,B4: A] :
              ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
              | ( S2
                = ( top_top @ ( set @ A ) ) )
              | ( S2
                = ( set_ord_lessThan @ A @ B4 ) )
              | ( S2
                = ( set_ord_atMost @ A @ B4 ) )
              | ( S2
                = ( set_ord_greaterThan @ A @ A4 ) )
              | ( S2
                = ( set_ord_atLeast @ A @ A4 ) )
              | ( S2
                = ( set_or5935395276787703475ssThan @ A @ A4 @ B4 ) )
              | ( S2
                = ( set_or3652927894154168847AtMost @ A @ A4 @ B4 ) )
              | ( S2
                = ( set_or7035219750837199246ssThan @ A @ A4 @ B4 ) )
              | ( S2
                = ( set_or1337092689740270186AtMost @ A @ A4 @ B4 ) ) ) ) ) ).

% interval_cases
thf(fact_5733_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F9: filter @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [P3: A > $o] :
                  ( ( eventually @ A @ P3 @ F9 )
                  & ! [X3: A,Y4: A] :
                      ( ( ( P3 @ X3 )
                        & ( P3 @ Y4 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y4 ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_5734_GMVT,axiom,
    ! [A2: real,B2: real,F2: real > real,G2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X2 )
              & ( ord_less_eq @ real @ X2 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X2: real] :
              ( ( ( ord_less @ real @ A2 @ X2 )
                & ( ord_less @ real @ X2 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ G2 ) )
           => ( ! [X2: real] :
                  ( ( ( ord_less @ real @ A2 @ X2 )
                    & ( ord_less @ real @ X2 @ B2 ) )
                 => ( differentiable @ real @ real @ G2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( ( has_field_derivative @ real @ G2 @ G_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G2 @ B2 ) @ ( G2 @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_5735_atLeast__0,axiom,
    ( ( set_ord_atLeast @ nat @ ( zero_zero @ nat ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% atLeast_0
thf(fact_5736_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I ) ) ) ).

% atLeast_iff
thf(fact_5737_cInf__atLeast,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Inf_Inf @ A @ ( set_ord_atLeast @ A @ X ) )
          = X ) ) ).

% cInf_atLeast
thf(fact_5738_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X ) @ ( set_ord_atLeast @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% atLeast_subset_iff
thf(fact_5739_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H: A,L3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) @ ( set_ord_atLeast @ A @ L3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H )
            | ( ord_less_eq @ A @ L3 @ L ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_5740_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q4: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T4: B] : ( times_times @ A @ C2 @ ( Q4 @ T4 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q4 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_5741_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q4: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T4: B] : ( times_times @ A @ ( Q4 @ T4 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q4 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_5742_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L4: A] : ( collect @ A @ ( ord_less_eq @ A @ L4 ) ) ) ) ) ).

% atLeast_def
thf(fact_5743_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [L: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atLeast @ A @ L ) ) ) ).

% not_UNIV_le_Ici
thf(fact_5744_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_5745_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,L3: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H2 ) ) ) ).

% not_Ici_le_Icc
thf(fact_5746_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_Ici_le_Iic
thf(fact_5747_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H: A,L3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H ) @ ( set_ord_atLeast @ A @ L3 ) ) ) ).

% not_Iic_le_Ici
thf(fact_5748_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% Ioi_le_Ico
thf(fact_5749_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,N: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( differentiable @ A @ B
            @ ^ [X3: A] : ( power_power @ B @ ( F2 @ X3 ) @ N )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% differentiable_power
thf(fact_5750_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_5751_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_5752_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G2: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G2 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X3: A] : ( divide_divide @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_5753_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X3: A] : ( inverse_inverse @ B @ ( F2 @ X3 ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_inverse
thf(fact_5754_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_5755_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_5756_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_5757_nhds__imp__cauchy__filter,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [F4: filter @ A,X: A] :
          ( ( ord_less_eq @ ( filter @ A ) @ F4 @ ( topolo7230453075368039082e_nhds @ A @ X ) )
         => ( topolo6773858410816713723filter @ A @ F4 ) ) ) ).

% nhds_imp_cauchy_filter
thf(fact_5758_MVT,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X2: real] :
              ( ( ord_less @ real @ A2 @ X2 )
             => ( ( ord_less @ real @ X2 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L2: real,Z3: real] :
              ( ( ord_less @ real @ A2 @ Z3 )
              & ( ord_less @ real @ Z3 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L2 ) ) ) ) ) ) ).

% MVT
thf(fact_5759_ord_OLeast__def,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( ^ [Less_eq: A > A > $o,P3: A > $o] :
            ( the @ A
            @ ^ [X3: A] :
                ( ( P3 @ X3 )
                & ! [Y4: A] :
                    ( ( P3 @ Y4 )
                   => ( Less_eq @ X3 @ Y4 ) ) ) ) ) ) ).

% ord.Least_def
thf(fact_5760_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,C4: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: B] :
                ( ( member @ B @ T7 @ C4 )
               => ( topolo1002775350975398744n_open @ A @ ( F2 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C4 ) ) )
             => ~ ! [C7: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C7 @ C4 )
                   => ( ( finite_finite @ B @ C7 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C7 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_5761_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F2: A > B,G2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S @ G2 )
           => ( ! [X2: A] :
                  ( ( member @ A @ X2 @ S )
                 => ( ( G2 @ X2 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S
                @ ^ [X3: A] : ( divide_divide @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_5762_ord_OLeast_Ocong,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( least @ A ) ) ).

% ord.Least.cong
thf(fact_5763_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A5: set @ C,F2: C > B,G2: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A5 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A5 @ G2 )
           => ( topolo81223032696312382ous_on @ C @ B @ A5
              @ ^ [X3: C] : ( power_power @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_5764_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S: set @ C,F2: C > B,N: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S
            @ ^ [X3: C] : ( power_power @ B @ ( F2 @ X3 ) @ N ) ) ) ) ).

% continuous_on_power
thf(fact_5765_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X2: A] :
                  ( ( member @ A @ X2 @ S )
                  & ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S )
                     => ( ord_less_eq @ B @ ( F2 @ Xa2 ) @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_5766_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X2: A] :
                  ( ( member @ A @ X2 @ S )
                  & ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S )
                     => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Xa2 ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_5767_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,F2: A > B,T2: set @ A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( topolo81223032696312382ous_on @ A @ B @ T2 @ F2 ) ) ) ) ).

% continuous_on_subset
thf(fact_5768_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X2: A] :
                    ( ( ord_less_eq @ A @ A2 @ X2 )
                    & ( ord_less_eq @ A @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_5769_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X2: A] :
                    ( ( ord_less_eq @ A @ A2 @ X2 )
                    & ( ord_less_eq @ A @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y ) ) ) ) ) ) ) ).

% IVT'
thf(fact_5770_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T2: set @ A,G2: A > B,S: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T2 @ G2 )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ F2 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
             => ( topolo81223032696312382ous_on @ C @ B @ S
                @ ^ [X3: C] : ( G2 @ ( F2 @ X3 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_5771_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S )
               => ( ( F2 @ X2 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X3: A] : ( inverse_inverse @ B @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_on_inverse
thf(fact_5772_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S )
               => ( ( F2 @ X2 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X3: A] : ( sgn_sgn @ B @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_on_sgn
thf(fact_5773_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F2: C > real,G2: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G2 )
           => ( ! [X2: C] :
                  ( ( member @ C @ X2 @ S )
                 => ( ( F2 @ X2 )
                   != ( zero_zero @ real ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X3: C] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% continuous_on_powr
thf(fact_5774_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S )
               => ( ( F2 @ X2 )
                 != ( zero_zero @ real ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X3: A] : ( ln_ln @ real @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_on_ln
thf(fact_5775_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A5 ) )
         => ( ! [X2: A,Y2: A] :
                ( ( member @ A @ X2 @ A5 )
               => ( ( member @ A @ Y2 @ A5 )
                 => ( ( ord_less_eq @ A @ X2 @ Y2 )
                   => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A5 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_5776_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ S2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S2 )
                   => ( ord_less_eq @ A @ Xa2 @ X2 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_5777_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ S2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S2 )
                   => ( ord_less_eq @ A @ X2 @ Xa2 ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_5778_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G2 )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X3: A] : ( ord_less @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_5779_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S )
               => ( ( cos @ A @ ( F2 @ X2 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X3: A] : ( tan @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_on_tan
thf(fact_5780_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G2 )
           => ? [A8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ A8 )
                & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                  = ( collect @ A
                    @ ^ [X3: A] :
                        ( ( member @ A @ X3 @ S )
                        & ( ord_less @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ) ) ).

% open_Collect_less_Int
thf(fact_5781_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S )
               => ( ( sin @ A @ ( F2 @ X2 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X3: A] : ( cot @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_on_cot
thf(fact_5782_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A5: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A5 @ F2 )
         => ( ! [X2: C] :
                ( ( member @ C @ X2 @ A5 )
               => ( ( cosh @ A @ ( F2 @ X2 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ C @ A @ A5
              @ ^ [X3: C] : ( tanh @ A @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_on_tanh
thf(fact_5783_continuous__on__arcosh_H,axiom,
    ! [A5: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A5 @ F2 )
     => ( ! [X2: real] :
            ( ( member @ real @ X2 @ A5 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X2 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A5
          @ ^ [X3: real] : ( arcosh @ real @ ( F2 @ X3 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_5784_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ? [C3: real,D4: real] :
            ( ( ( image @ real @ real @ F2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C3 @ D4 ) )
            & ( ord_less_eq @ real @ C3 @ D4 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_5785_continuous__on__arcosh,axiom,
    ! [A5: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A5 @ ( set_ord_atLeast @ real @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A5 @ ( arcosh @ real ) ) ) ).

% continuous_on_arcosh
thf(fact_5786_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                = ( collect @ A
                  @ ^ [X3: A] :
                      ( ( member @ A @ X3 @ S )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_5787_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F2: C > real,G2: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G2 )
           => ( ! [X2: C] :
                  ( ( member @ C @ X2 @ S )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
                    & ( ( ( F2 @ X2 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X2 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X3: C] : ( powr @ real @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_5788_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G2 )
           => ( ! [X2: A] :
                  ( ( member @ A @ X2 @ S )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) ) )
             => ( ! [X2: A] :
                    ( ( member @ A @ X2 @ S )
                   => ( ( F2 @ X2 )
                     != ( one_one @ real ) ) )
               => ( ! [X2: A] :
                      ( ( member @ A @ X2 @ S )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X2 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S
                    @ ^ [X3: A] : ( log @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_5789_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X2 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X2 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X3: A] : ( arccos @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_5790_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X2 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X2 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X3: A] : ( arcsin @ ( F2 @ X3 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_5791_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F2: A > A] :
          ( ! [X2: A] :
              ( ( ord_less_eq @ A @ A2 @ X2 )
             => ( ( ord_less_eq @ A @ X2 @ B2 )
               => ? [Y5: A] : ( has_field_derivative @ A @ F2 @ Y5 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_5792_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F2: real > real,F7: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X2: real] :
                ( ( ord_less @ real @ A2 @ X2 )
               => ( ( ord_less @ real @ X2 @ B2 )
                 => ( has_derivative @ real @ real @ F2 @ ( F7 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
                & ( ord_less @ real @ Z3 @ B2 )
                & ( ( F7 @ Z3 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_5793_mvt,axiom,
    ! [A2: real,B2: real,F2: real > real,F7: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X2: real] :
              ( ( ord_less @ real @ A2 @ X2 )
             => ( ( ord_less @ real @ X2 @ B2 )
               => ( has_derivative @ real @ real @ F2 @ ( F7 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                   != ( F7 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_5794_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_5795_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_5796_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less @ real @ A2 @ X2 )
           => ( ( ord_less @ real @ X2 @ B2 )
             => ? [Y5: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y5 ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_5797_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less @ real @ A2 @ X2 )
           => ( ( ord_less @ real @ X2 @ B2 )
             => ? [Y5: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y5 @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_5798_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X2: real] :
              ( ( ord_less @ real @ A2 @ X2 )
             => ( ( ord_less @ real @ X2 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F2 @ B2 )
            = ( F2 @ A2 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_5799_continuous__on__artanh,axiom,
    ! [A5: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A5 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A5 @ ( artanh @ real ) ) ) ).

% continuous_on_artanh
thf(fact_5800_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F2: real > real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X2: real] :
              ( ( ord_less @ real @ A2 @ X2 )
             => ( ( ord_less @ real @ X2 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X )
           => ( ( ord_less_eq @ real @ X @ B2 )
             => ( ( F2 @ X )
                = ( F2 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_5801_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X2: A] :
                  ( ( ord_less @ A @ A2 @ X2 )
                 => ( ( ord_less @ A @ X2 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X2 ) ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_5802_Rolle,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X2: real] :
                ( ( ord_less @ real @ A2 @ X2 )
               => ( ( ord_less @ real @ X2 @ B2 )
                 => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
                & ( ord_less @ real @ Z3 @ B2 )
                & ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_5803_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [S5: set @ A] :
            ! [C8: set @ ( set @ A )] :
              ( ( ! [X3: set @ A] :
                    ( ( member @ ( set @ A ) @ X3 @ C8 )
                   => ( topolo1002775350975398744n_open @ A @ X3 ) )
                & ( ord_less_eq @ ( set @ A ) @ S5 @ ( complete_Sup_Sup @ ( set @ A ) @ C8 ) ) )
             => ? [D7: set @ ( set @ A )] :
                  ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ D7 @ C8 )
                  & ( finite_finite @ ( set @ A ) @ D7 )
                  & ( ord_less_eq @ ( set @ A ) @ S5 @ ( complete_Sup_Sup @ ( set @ A ) @ D7 ) ) ) ) ) ) ) ).

% compact_eq_Heine_Borel
thf(fact_5804_compactI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A] :
          ( ! [C6: set @ ( set @ A )] :
              ( ! [X5: set @ A] :
                  ( ( member @ ( set @ A ) @ X5 @ C6 )
                 => ( topolo1002775350975398744n_open @ A @ X5 ) )
             => ( ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) )
               => ? [C9: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C9 @ C6 )
                    & ( finite_finite @ ( set @ A ) @ C9 )
                    & ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) ) ) ) )
         => ( topolo2193935891317330818ompact @ A @ S ) ) ) ).

% compactI
thf(fact_5805_compactE,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T11: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T11 ) )
           => ( ! [B8: set @ A] :
                  ( ( member @ ( set @ A ) @ B8 @ T11 )
                 => ( topolo1002775350975398744n_open @ A @ B8 ) )
             => ~ ! [T12: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ T12 @ T11 )
                   => ( ( finite_finite @ ( set @ A ) @ T12 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T12 ) ) ) ) ) ) ) ) ).

% compactE
thf(fact_5806_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F5: nat > A] :
                ( ! [N6: nat] : ( ord_less @ A @ B2 @ ( F5 @ N6 ) )
               => ( ! [N6: nat] : ( ord_less @ A @ ( F5 @ N6 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F5 )
                   => ( ( filterlim @ nat @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N3: nat] : ( P @ ( F5 @ N3 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_5807_range__abs__Nats,axiom,
    ( ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) )
    = ( semiring_1_Nats @ int ) ) ).

% range_abs_Nats
thf(fact_5808_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,I6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I6 )
               => ( topolo7761053866217962861closed @ A @ ( F2 @ I2 ) ) )
           => ( ! [I9: set @ B] :
                  ( ( finite_finite @ B @ I9 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I9 @ I6 )
                   => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I9 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I6 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_5809_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A5: A,B6: A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A5 @ B6 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ A5 ) @ ( compow @ ( A > A ) @ N @ F2 @ B6 ) ) ) ) ) ).

% funpow_mono
thf(fact_5810_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: nat > A,I: nat] :
          ( ( order_mono @ nat @ A @ A5 )
         => ( ord_less_eq @ A @ ( A5 @ I ) @ ( A5 @ ( suc @ I ) ) ) ) ) ).

% incseq_SucD
thf(fact_5811_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( X8 @ N2 ) @ ( X8 @ ( suc @ N2 ) ) )
         => ( order_mono @ nat @ A @ X8 ) ) ) ).

% incseq_SucI
thf(fact_5812_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_5813_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X3: A,Y4: A] :
              ( ( ord_less_eq @ A @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F3 @ X3 ) @ ( F3 @ Y4 ) ) ) ) ) ) ).

% mono_def
thf(fact_5814_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_5815_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% monoE
thf(fact_5816_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% monoD
thf(fact_5817_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I: nat,J: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ord_less_eq @ A @ ( F2 @ I ) @ ( F2 @ J ) ) ) ) ) ).

% incseqD
thf(fact_5818_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X7: nat > A] :
            ! [M2: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M2 @ N3 )
             => ( ord_less_eq @ A @ ( X7 @ M2 ) @ ( X7 @ N3 ) ) ) ) ) ) ).

% incseq_def
thf(fact_5819_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A5: A,B6: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A5 @ B6 ) ) @ ( inf_inf @ B @ ( F2 @ A5 ) @ ( F2 @ B6 ) ) ) ) ) ).

% mono_inf
thf(fact_5820_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A5: A,B6: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A5 ) @ ( F2 @ B6 ) ) @ ( F2 @ ( sup_sup @ A @ A5 @ B6 ) ) ) ) ) ).

% mono_sup
thf(fact_5821_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mono_invE
thf(fact_5822_Nats__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [W2: num] : ( member @ A @ ( numeral_numeral @ A @ W2 ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_numeral
thf(fact_5823_Nats__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_mult
thf(fact_5824_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_5825_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_5826_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ) ).

% mono_pow
thf(fact_5827_Nats__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_0
thf(fact_5828_Nats__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_add
thf(fact_5829_Nats__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_1
thf(fact_5830_Nats__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ~ ! [N2: nat] :
                ( X
               != ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% Nats_cases
thf(fact_5831_Nats__induct,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A,P: A > $o] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ( ! [N2: nat] : ( P @ ( semiring_1_of_nat @ A @ N2 ) )
           => ( P @ X ) ) ) ) ).

% Nats_induct
thf(fact_5832_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_Nats @ A ) ) ) ).

% of_nat_in_Nats
thf(fact_5833_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% mono_strict_invE
thf(fact_5834_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_5835_mono__times__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N ) ) ) ).

% mono_times_nat
thf(fact_5836_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_5837_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M: A,N: A,M7: B,N5: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
              = ( set_or7035219750837199246ssThan @ B @ M7 @ N5 ) )
           => ( ( ord_less @ A @ M @ N )
             => ( ( F2 @ M )
                = M7 ) ) ) ) ) ).

% mono_image_least
thf(fact_5838_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P6: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P6 @ ( F2 @ P6 ) )
           => ( ord_less_eq @ A @ P6 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_5839_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P6: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P6 ) @ P6 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P6 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_5840_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I: nat,J: nat,X: A,Y: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less_eq @ A @ X @ Y )
             => ( ( ord_less_eq @ A @ X @ ( F2 @ X ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I @ F2 @ X ) @ ( compow @ ( A > A ) @ J @ F2 @ Y ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_5841_incseq__bounded,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( X8 @ I2 ) @ B6 )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_5842_Nats__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( ( ord_less_eq @ A @ B2 @ A2 )
             => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ) ).

% Nats_diff
thf(fact_5843_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A5 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% mono_Sup
thf(fact_5844_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A5: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X3: C] : ( F2 @ ( A5 @ X3 ) )
                @ I6 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A5 @ I6 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_5845_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A5 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ).

% mono_Inf
thf(fact_5846_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A5: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A5 @ I6 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X3: C] : ( F2 @ ( A5 @ X3 ) )
                @ I6 ) ) ) ) ) ).

% mono_INF
thf(fact_5847_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Nats_subset_Ints
thf(fact_5848_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G2 )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_5849_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_5850_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N: nat] :
          ( ( order_mono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X8 @ N ) @ L5 ) ) ) ) ).

% incseq_le
thf(fact_5851_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_5852_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_5853_incseq__convergent,axiom,
    ! [X8: nat > real,B6: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( X8 @ I2 ) @ B6 )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I3: nat] : ( ord_less_eq @ real @ ( X8 @ I3 ) @ L6 ) ) ) ) ).

% incseq_convergent
thf(fact_5854_t3__space,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [S2: set @ A,Y: A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ~ ( member @ A @ Y @ S2 )
           => ? [U5: set @ A,V6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ U5 )
                & ( topolo1002775350975398744n_open @ A @ V6 )
                & ( member @ A @ Y @ U5 )
                & ( ord_less_eq @ ( set @ A ) @ S2 @ V6 )
                & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% t3_space
thf(fact_5855_t4__space,axiom,
    ! [A: $tType] :
      ( ( topological_t4_space @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ( topolo7761053866217962861closed @ A @ T6 )
           => ( ( ( inf_inf @ ( set @ A ) @ S2 @ T6 )
                = ( bot_bot @ ( set @ A ) ) )
             => ? [U5: set @ A,V6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ U5 )
                  & ( topolo1002775350975398744n_open @ A @ V6 )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ U5 )
                  & ( ord_less_eq @ ( set @ A ) @ T6 @ V6 )
                  & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% t4_space
thf(fact_5856_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X: A,A5: set @ A] :
          ( ( member @ A @ X @ A5 )
         => ( ( topolo1002775350975398744n_open @ A @ A5 )
           => ? [A11: set @ A] :
                ( ( member @ A @ X @ A11 )
                & ( topolo7761053866217962861closed @ A @ A11 )
                & ( ord_less_eq @ ( set @ A ) @ A11 @ A5 )
                & ( eventually @ A
                  @ ^ [Y4: A] : ( member @ A @ Y4 @ A11 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X ) ) ) ) ) ) ).

% nhds_closed
thf(fact_5857_Nats__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Nats_def
thf(fact_5858_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [N3: A] :
              ( ( member @ A @ N3 @ ( ring_1_Ints @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ N3 ) ) ) ) ) ).

% Nats_altdef2
thf(fact_5859_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M2: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M2 ) @ M2 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_5860_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N2: nat] :
                  ( ( ( F2 @ N2 )
                    = ( F2 @ ( suc @ N2 ) ) )
                 => ( ( F2 @ ( suc @ N2 ) )
                    = ( F2 @ ( suc @ ( suc @ N2 ) ) ) ) )
             => ? [N9: nat] :
                  ( ! [N6: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ N9 )
                     => ! [M3: nat] :
                          ( ( ord_less_eq @ nat @ M3 @ N9 )
                         => ( ( ord_less @ nat @ M3 @ N6 )
                           => ( ord_less @ A @ ( F2 @ M3 ) @ ( F2 @ N6 ) ) ) ) )
                  & ! [N6: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N6 )
                     => ( ( F2 @ N9 )
                        = ( F2 @ N6 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_5861_compact__imp__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F4: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: set @ A] :
                ( ( member @ ( set @ A ) @ T7 @ F4 )
               => ( topolo7761053866217962861closed @ A @ T7 ) )
           => ( ! [F14: set @ ( set @ A )] :
                  ( ( finite_finite @ ( set @ A ) @ F14 )
                 => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F14 @ F4 )
                   => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F14 ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F4 ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip
thf(fact_5862_compact__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [U6: set @ A] :
            ! [A7: set @ ( set @ A )] :
              ( ! [X3: set @ A] :
                  ( ( member @ ( set @ A ) @ X3 @ A7 )
                 => ( topolo7761053866217962861closed @ A @ X3 ) )
             => ( ! [B7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B7 @ A7 )
                   => ( ( finite_finite @ ( set @ A ) @ B7 )
                     => ( ( inf_inf @ ( set @ A ) @ U6 @ ( complete_Inf_Inf @ ( set @ A ) @ B7 ) )
                       != ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( inf_inf @ ( set @ A ) @ U6 @ ( complete_Inf_Inf @ ( set @ A ) @ A7 ) )
                 != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% compact_fip
thf(fact_5863_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X8: B > A,L5: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S7: nat > B] :
                ( ! [N6: nat] : ( ord_less @ B @ ( S7 @ N6 ) @ A2 )
               => ( ! [N6: nat] : ( ord_less @ B @ B2 @ ( S7 @ N6 ) )
                 => ( ( order_mono @ nat @ B @ S7 )
                   => ( ( filterlim @ nat @ B @ S7 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N3: nat] : ( X8 @ ( S7 @ N3 ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_5864_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = Ys2 )
      = ( ? [F3: nat > nat] :
            ( ( order_mono @ nat @ nat @ F3 )
            & ( ( image @ nat @ nat @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I4 )
                  = ( nth @ A @ Ys2 @ ( F3 @ I4 ) ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( ( nth @ A @ Xs @ I4 )
                    = ( nth @ A @ Xs @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) )
                  = ( ( F3 @ I4 )
                    = ( F3 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_5865_inj__sgn__power,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( inj_on @ real @ real
        @ ^ [Y4: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_5866_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( set2 @ A @ ( bind @ B @ A @ Xs @ F2 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X3: B] : ( set2 @ A @ ( F2 @ X3 ) )
          @ ( set2 @ B @ Xs ) ) ) ) ).

% set_list_bind
thf(fact_5867_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% remdups_adj_Nil_iff
thf(fact_5868_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups_adj @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% remdups_adj_set
thf(fact_5869_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F2 )
      = ( nil @ A ) ) ).

% bind_simps(1)
thf(fact_5870_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: B,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( cons @ B @ X @ Xs ) @ F2 )
      = ( append @ A @ ( F2 @ X ) @ ( bind @ B @ A @ Xs @ F2 ) ) ) ).

% bind_simps(2)
thf(fact_5871_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_5872_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B3: A] : ( divide_divide @ A @ B3 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_5873_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A5: set @ A,B6: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A5 ) @ ( F2 @ B6 ) ) ) ) ).

% mono_Int
thf(fact_5874_mono__Un,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A5: set @ A,B6: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F2 @ A5 ) @ ( F2 @ B6 ) ) @ ( F2 @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% mono_Un
thf(fact_5875_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% remdups_adj.simps(2)
thf(fact_5876_remdups__adj_Oelims,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( nil @ A ) ) )
       => ( ! [X2: A] :
              ( ( X
                = ( cons @ A @ X2 @ ( nil @ A ) ) )
             => ( Y
               != ( cons @ A @ X2 @ ( nil @ A ) ) ) )
         => ~ ! [X2: A,Y2: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs2 ) ) )
               => ~ ( ( ( X2 = Y2 )
                     => ( Y
                        = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs2 ) ) ) )
                    & ( ( X2 != Y2 )
                     => ( Y
                        = ( cons @ A @ X2 @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) ) ) ) ) ).

% remdups_adj.elims
thf(fact_5877_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_5878_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X3: A] : X3
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_5879_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less @ A @ X2 @ Y2 )
             => ( ( F2 @ X2 )
               != ( F2 @ Y2 ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_5880_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      & ( ( X != Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( cons @ A @ X @ ( remdups_adj @ A @ ( cons @ A @ Y @ Xs ) ) ) ) ) ) ).

% remdups_adj.simps(3)
thf(fact_5881_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A5: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A5 ) ) ) ).

% inj_on_mult
thf(fact_5882_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups_adj.simps(1)
thf(fact_5883_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups_adj @ A @ Xs )
        = Xs ) ) ).

% remdups_adj_distinct
thf(fact_5884_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B6: set @ A,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B6 )
     => ( ( ord_less @ ( set @ A ) @ A5 @ B6 )
       => ( ord_less @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B6 ) ) ) ) ).

% inj_on_strict_subset
thf(fact_5885_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A,F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less @ A @ X2 @ Y2 )
             => ( ( member @ A @ X2 @ A5 )
               => ( ( member @ A @ Y2 @ A5 )
                 => ( ( F2 @ X2 )
                   != ( F2 @ Y2 ) ) ) ) )
         => ( ! [X2: A,Y2: A] :
                ( ( member @ A @ X2 @ A5 )
               => ( ( member @ A @ Y2 @ A5 )
                 => ( ( ord_less_eq @ A @ X2 @ Y2 )
                    | ( ord_less_eq @ A @ Y2 @ X2 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A5 ) ) ) ) ).

% linorder_inj_onI
thf(fact_5886_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B6: set @ A,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
       => ( inj_on @ A @ B @ F2 @ A5 ) ) ) ).

% subset_inj_on
thf(fact_5887_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
       => ( inj_on @ A @ B @ F2 @ B6 ) ) ) ).

% inj_on_subset
thf(fact_5888_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B6: set @ A,A2: A,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B6 )
     => ( ( member @ A @ A2 @ B6 )
       => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ( member @ B @ ( F2 @ A2 ) @ ( image @ A @ B @ F2 @ A5 ) )
            = ( member @ A @ A2 @ A5 ) ) ) ) ) ).

% inj_on_image_mem_iff
thf(fact_5889_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C4: set @ A,A5: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
         => ( ( ( image @ A @ B @ F2 @ A5 )
              = ( image @ A @ B @ F2 @ B6 ) )
            = ( A5 = B6 ) ) ) ) ) ).

% inj_on_image_eq_iff
thf(fact_5890_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: B > A,T6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( image @ B @ A @ F2 @ T6 ) )
      = ( ? [U6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ U6 @ T6 )
            & ( inj_on @ B @ A @ F2 @ U6 )
            & ( S2
              = ( image @ B @ A @ F2 @ U6 ) ) ) ) ) ).

% subset_image_inj
thf(fact_5891_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% remdups_adj_length
thf(fact_5892_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ A,F2: A > ( list @ B ),G2: A > ( list @ B )] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( ( F2 @ X2 )
              = ( G2 @ X2 ) ) )
       => ( ( bind @ A @ B @ Xs @ F2 )
          = ( bind @ A @ B @ Ys2 @ G2 ) ) ) ) ).

% list_bind_cong
thf(fact_5893_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B6 ) )
        = ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ) ).

% inj_image_subset_iff
thf(fact_5894_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,A9: set @ B] :
      ( ( A5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F3: A > B] :
              ( ( inj_on @ A @ B @ F3 @ A5 )
              & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A5 ) @ A9 ) ) )
        = ( ? [G: B > A] :
              ( ( image @ B @ A @ G @ A9 )
              = A5 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_5895_finite__surj__inj,axiom,
    ! [A: $tType,A5: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( image @ A @ A @ F2 @ A5 ) )
       => ( inj_on @ A @ A @ F2 @ A5 ) ) ) ).

% finite_surj_inj
thf(fact_5896_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,B6: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B6 )
       => ( ( finite_finite @ B @ B6 )
         => ( finite_finite @ A @ A5 ) ) ) ) ).

% inj_on_finite
thf(fact_5897_endo__inj__surj,axiom,
    ! [A: $tType,A5: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ F2 @ A5 ) @ A5 )
       => ( ( inj_on @ A @ A @ F2 @ A5 )
         => ( ( image @ A @ A @ F2 @ A5 )
            = A5 ) ) ) ) ).

% endo_inj_surj
thf(fact_5898_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C4: set @ A,A5: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
         => ( ( image @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B6 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_5899_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C4: set @ A,A5: set @ A,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) @ C4 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
         => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A5 @ B6 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B6 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_5900_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( finite_card @ B @ A5 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A5 ) ) ).

% pigeonhole
thf(fact_5901_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_5902_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,X: B,B6: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( member @ B @ X @ ( image @ A @ B @ F2 @ A5 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( member @ A @ ( the_inv_into @ A @ B @ A5 @ F2 @ X ) @ B6 ) ) ) ) ).

% the_inv_into_into
thf(fact_5903_injective__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C2: real] :
          ( ( C2
           != ( zero_zero @ real ) )
         => ( inj_on @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% injective_scaleR
thf(fact_5904_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Y: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X = Y ) @ ( nil @ A ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_append_two
thf(fact_5905_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I6: set @ A,A5: A > ( set @ B ),F2: B > C] :
      ( ! [I2: A,J2: A] :
          ( ( member @ A @ I2 @ I6 )
         => ( ( member @ A @ J2 @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A5 @ I2 ) @ ( A5 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A5 @ J2 ) @ ( A5 @ I2 ) ) ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( inj_on @ B @ C @ F2 @ ( A5 @ I2 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A5 @ I6 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_5906_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,T6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T6 )
       => ( ( ( finite_card @ A @ S2 )
            = ( finite_card @ B @ T6 ) )
         => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ S2 ) @ T6 )
           => ( ( ! [X3: B] :
                    ( ( member @ B @ X3 @ T6 )
                   => ? [Y4: A] :
                        ( ( member @ A @ Y4 @ S2 )
                        & ( ( F2 @ Y4 )
                          = X3 ) ) ) )
              = ( inj_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ).

% surjective_iff_injective_gen
thf(fact_5907_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,B6: set @ B,G2: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B6 )
       => ( ( inj_on @ B @ A @ G2 @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G2 @ B6 ) @ A5 )
           => ( ( finite_finite @ A @ A5 )
             => ( ( finite_finite @ B @ B6 )
               => ( ( finite_card @ A @ A5 )
                  = ( finite_card @ B @ B6 ) ) ) ) ) ) ) ) ).

% card_bij_eq
thf(fact_5908_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ A5 ) ) @ ( uminus_uminus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ).

% inj_image_Compl_subset
thf(fact_5909_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,C4: set @ A,A5: set @ C,B6: C > ( set @ A ),J: C] :
      ( ( inj_on @ A @ B @ F2 @ C4 )
     => ( ! [X2: C] :
            ( ( member @ C @ X2 @ A5 )
           => ( ord_less_eq @ ( set @ A ) @ ( B6 @ X2 ) @ C4 ) )
       => ( ( member @ C @ J @ A5 )
         => ( ( image @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B6 @ A5 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X3: C] : ( image @ A @ B @ F2 @ ( B6 @ X3 ) )
                @ A5 ) ) ) ) ) ) ).

% image_INT
thf(fact_5910_remdups__adj__adjacent,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs ) @ I )
       != ( nth @ A @ ( remdups_adj @ A @ Xs ) @ ( suc @ I ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_5911_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_5912_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
     => ( Xs
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X ) ) ) ).

% remdups_adj_singleton
thf(fact_5913_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,B6: set @ B] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ B @ B6 )
       => ( ( ? [F3: A > B] :
                ( ( inj_on @ A @ B @ F3 @ A5 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A5 ) @ B6 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ B @ B6 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_5914_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,B6: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B6 )
       => ( ( finite_finite @ B @ B6 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ B @ B6 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_5915_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B6: set @ B] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ B @ B6 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ B @ B6 ) )
         => ? [F5: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A5 ) @ B6 )
              & ( inj_on @ A @ B @ F5 @ A5 ) ) ) ) ) ).

% card_le_inj
thf(fact_5916_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_5917_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_5918_complex__is__Nat__iff,axiom,
    ! [Z2: complex] :
      ( ( member @ complex @ Z2 @ ( semiring_1_Nats @ complex ) )
      = ( ( ( im @ Z2 )
          = ( zero_zero @ real ) )
        & ? [I4: nat] :
            ( ( re @ Z2 )
            = ( semiring_1_of_nat @ real @ I4 ) ) ) ) ).

% complex_is_Nat_iff
thf(fact_5919_tendsto__at__topI__sequentially__real,axiom,
    ! [F2: real > real,Y: real] :
      ( ( order_mono @ real @ real @ F2 )
     => ( ( filterlim @ nat @ real
          @ ^ [N3: nat] : ( F2 @ ( semiring_1_of_nat @ real @ N3 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ Y )
          @ ( at_top @ nat ) )
       => ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Y ) @ ( at_top @ real ) ) ) ) ).

% tendsto_at_topI_sequentially_real
thf(fact_5920_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,B6: set @ B,G2: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B6 )
       => ( ( inj_on @ B @ A @ G2 @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G2 @ B6 ) @ A5 )
           => ? [H4: A > B] : ( bij_betw @ A @ B @ H4 @ A5 @ B6 ) ) ) ) ) ).

% Schroeder_Bernstein
thf(fact_5921_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T10: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T10 ) ) )
      = ( ? [T10: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( inj_on @ B @ A @ F2 @ T10 )
            & ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% ex_subset_image_inj
thf(fact_5922_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T10: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) )
           => ( P @ T10 ) ) )
      = ( ! [T10: set @ B] :
            ( ( ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
              & ( inj_on @ B @ A @ F2 @ T10 ) )
           => ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% all_subset_image_inj
thf(fact_5923_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_5924_inj__split__Cons,axiom,
    ! [A: $tType,X8: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs3: list @ A,N3: A] : ( cons @ A @ N3 @ Xs3 ) )
      @ X8 ) ).

% inj_split_Cons
thf(fact_5925_inj__on__Cons1,axiom,
    ! [A: $tType,X: A,A5: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ A5 ) ).

% inj_on_Cons1
thf(fact_5926_inj__on__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N4: set @ nat] : ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ N4 ) ) ).

% inj_on_of_nat
thf(fact_5927_inj__Suc,axiom,
    ! [N4: set @ nat] : ( inj_on @ nat @ nat @ suc @ N4 ) ).

% inj_Suc
thf(fact_5928_inj__on__diff__nat,axiom,
    ! [N4: set @ nat,K: nat] :
      ( ! [N2: nat] :
          ( ( member @ nat @ N2 @ N4 )
         => ( ord_less_eq @ nat @ K @ N2 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ K )
        @ N4 ) ) ).

% inj_on_diff_nat
thf(fact_5929_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X7: $o > A,Y7: $o > A] :
              ( ( ord_less_eq @ A @ ( X7 @ $false ) @ ( Y7 @ $false ) )
              & ( ord_less_eq @ A @ ( X7 @ $true ) @ ( Y7 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_5930_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [N2: nat,F5: nat > A] :
          ( ( A5
            = ( image @ nat @ A @ F5
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) ) )
          & ( inj_on @ nat @ A @ F5
            @ ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_5931_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [F5: A > nat,N2: nat] :
          ( ( ( image @ A @ nat @ F5 @ A5 )
            = ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) )
          & ( inj_on @ A @ nat @ F5 @ A5 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_5932_inj__on__nth,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ! [X2: nat] :
            ( ( member @ nat @ X2 @ I6 )
           => ( ord_less @ nat @ X2 @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs ) @ I6 ) ) ) ).

% inj_on_nth
thf(fact_5933_infinite__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ? [F5: nat > A] :
          ( ( inj_on @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) )
          & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ).

% infinite_countable_subset
thf(fact_5934_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ~ ( finite_finite @ A @ S2 ) )
      = ( ? [F3: nat > A] :
            ( ( inj_on @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) )
            & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ) ).

% infinite_iff_countable_subset
thf(fact_5935_summable__reindex,axiom,
    ! [F2: nat > real,G2: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G2 @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F2 @ G2 ) ) ) ) ) ).

% summable_reindex
thf(fact_5936_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F2: A > A,S: A] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ S )
        = S )
     => ( ! [M4: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
           => ( ( ord_less @ nat @ M4 @ N )
             => ( ( compow @ ( A > A ) @ M4 @ F2 @ S )
               != S ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K4: nat] : ( compow @ ( A > A ) @ K4 @ F2 @ S )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% inj_on_funpow_least
thf(fact_5937_suminf__reindex__mono,axiom,
    ! [F2: nat > real,G2: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G2 @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G2 ) ) @ ( suminf @ real @ F2 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_5938_suminf__reindex,axiom,
    ! [F2: nat > real,G2: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G2 @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
         => ( ! [X2: nat] :
                ( ~ ( member @ nat @ X2 @ ( image @ nat @ nat @ G2 @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ X2 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G2 ) )
              = ( suminf @ real @ F2 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_5939_remdups__adj_Opelims,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( nil @ A ) )
             => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( nil @ A ) ) ) )
         => ( ! [X2: A] :
                ( ( X
                  = ( cons @ A @ X2 @ ( nil @ A ) ) )
               => ( ( Y
                    = ( cons @ A @ X2 @ ( nil @ A ) ) )
                 => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )
           => ~ ! [X2: A,Y2: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs2 ) ) )
                 => ( ( ( ( X2 = Y2 )
                       => ( Y
                          = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs2 ) ) ) )
                      & ( ( X2 != Y2 )
                       => ( Y
                          = ( cons @ A @ X2 @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) ) ) ) ).

% remdups_adj.pelims
thf(fact_5940_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G2: A > B,C4: set @ A,B6: set @ A,X: A] :
      ( ( inj_on @ A @ B @ G2 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ C4 @ ( sup_sup @ ( set @ A ) @ B6 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I4: B] : ( if @ A @ ( member @ B @ I4 @ ( image @ A @ B @ G2 @ C4 ) ) @ ( the_inv_into @ A @ B @ C4 @ G2 @ I4 ) @ X )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B6 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_5941_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: nat > real,G2: nat > nat] :
      ( ! [X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
     => ( ( order_mono @ nat @ real @ F2 )
       => ( ( order_strict_mono @ nat @ nat @ G2 )
         => ( ( bfun @ nat @ real
              @ ^ [X3: nat] : ( F2 @ ( G2 @ X3 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_5942_strict__mono__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% strict_mono_mono
thf(fact_5943_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X @ Y )
           => ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% strict_monoD
thf(fact_5944_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less @ A @ X2 @ Y2 )
             => ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_5945_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X3: A,Y4: A] :
              ( ( ord_less @ A @ X3 @ Y4 )
             => ( ord_less @ B @ ( F3 @ X3 ) @ ( F3 @ Y4 ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_5946_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% strict_mono_less
thf(fact_5947_strict__mono__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ( F2 @ X )
              = ( F2 @ Y ) )
            = ( X = Y ) ) ) ) ).

% strict_mono_eq
thf(fact_5948_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R2: A > B,M: A,N: A] :
          ( ( order_strict_mono @ A @ B @ R2 )
         => ( ( ord_less_eq @ A @ M @ N )
           => ( ord_less_eq @ B @ ( R2 @ M ) @ ( R2 @ N ) ) ) ) ) ).

% strict_mono_leD
thf(fact_5949_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% strict_mono_less_eq
thf(fact_5950_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N @ ( F2 @ N ) ) ) ).

% strict_mono_imp_increasing
thf(fact_5951_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N3: nat] : ( ord_less @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_5952_refl__ge__eq,axiom,
    ! [A: $tType,R4: A > A > $o] :
      ( ! [X2: A] : ( R4 @ X2 @ X2 )
     => ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ R4 ) ) ).

% refl_ge_eq
thf(fact_5953_ge__eq__refl,axiom,
    ! [A: $tType,R4: A > A > $o,X: A] :
      ( ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ R4 )
     => ( R4 @ X @ X ) ) ).

% ge_eq_refl
thf(fact_5954_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G2: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G2 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ ( image @ nat @ nat @ G2 @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( ( summable @ A
                @ ^ [N3: nat] : ( F2 @ ( G2 @ N3 ) ) )
              = ( summable @ A @ F2 ) ) ) ) ) ).

% summable_mono_reindex
thf(fact_5955_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G2: nat > nat,F2: nat > A,C2: A] :
          ( ( order_strict_mono @ nat @ nat @ G2 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ ( image @ nat @ nat @ G2 @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( ( sums @ A
                @ ^ [N3: nat] : ( F2 @ ( G2 @ N3 ) )
                @ C2 )
              = ( sums @ A @ F2 @ C2 ) ) ) ) ) ).

% sums_mono_reindex
thf(fact_5956_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G2: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G2 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ ( image @ nat @ nat @ G2 @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A
                @ ^ [N3: nat] : ( F2 @ ( G2 @ N3 ) ) )
              = ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mono_reindex
thf(fact_5957_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G2: nat > nat] :
          ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq @ nat @ X2 @ Y2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y2 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G2 )
           => ( ( bfun @ nat @ A
                @ ^ [X3: nat] : ( F2 @ ( G2 @ X3 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_5958_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F15: B > A,A16: set @ B,B1: set @ A,F24: C > D,B22: set @ C,A26: set @ D] :
      ( ( ( image @ B @ A @ F15 @ A16 )
        = B1 )
     => ( ( inj_on @ C @ D @ F24 @ B22 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image @ C @ D @ F24 @ B22 ) @ A26 )
         => ( ( ( B22
                = ( bot_bot @ ( set @ C ) ) )
             => ( A26
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B22 @ B1 )
              = ( image @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B22 @ F15 @ F24 ) @ ( bNF_Wellorder_Func @ D @ B @ A26 @ A16 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_5959_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,N: int,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X3: A] : ( power_int @ A @ X3 @ N )
            @ ^ [Y4: A] : ( times_times @ A @ Y4 @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power_int'
thf(fact_5960_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,X: C,F7: C > A,S2: set @ C,N: int] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F7 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X3: C] : ( power_int @ A @ ( F2 @ X3 ) @ N )
              @ ^ [H3: C] : ( times_times @ A @ ( F7 @ H3 ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_5961_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_5962_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( one_one @ int ) )
          = Y ) ) ).

% power_int_1_right
thf(fact_5963_power__int__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( sgn_sgn @ A @ ( power_int @ A @ A2 @ N ) )
          = ( power_int @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_int_sgn
thf(fact_5964_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,W2: num,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ ( numeral_numeral @ A @ W2 ) ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ ( numeral_numeral @ A @ W2 ) @ M ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_5965_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W2: num,Y: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Y ) @ M )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W2 ) @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_5966_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( ( power_int @ A @ X @ N )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( N
             != ( zero_zero @ int ) ) ) ) ) ).

% power_int_eq_0_iff
thf(fact_5967_power__int__0__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( M
           != ( zero_zero @ int ) )
         => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
            = ( zero_zero @ A ) ) ) ) ).

% power_int_0_left
thf(fact_5968_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X: B] :
          ( ( power_int @ B @ X @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_5969_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_int @ A @ A2 @ N ) ) ) ) ).

% abs_power_int_minus
thf(fact_5970_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N: nat] :
          ( ( power_int @ A @ X @ ( semiring_1_of_nat @ int @ N ) )
          = ( power_power @ A @ X @ N ) ) ) ).

% power_int_of_nat
thf(fact_5971_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num] :
          ( ( power_int @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_5972_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N: num] :
          ( ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% power_int_numeral
thf(fact_5973_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y ) ) ) ).

% power_int_minus1_right
thf(fact_5974_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_5975_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_5976_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_5977_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M: num,N: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M @ N ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_5978_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% zero_le_power_int
thf(fact_5979_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_int_not_zero
thf(fact_5980_power__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ A2 @ N ) )
          = ( power_int @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_int_abs
thf(fact_5981_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ Y ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_mult_distrib
thf(fact_5982_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( times_times @ A @ ( power_int @ A @ X @ N ) @ X )
          = ( times_times @ A @ X @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_commutes
thf(fact_5983_power__int__mult,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N: int] :
          ( ( power_int @ A @ X @ ( times_times @ int @ M @ N ) )
          = ( power_int @ A @ ( power_int @ A @ X @ M ) @ N ) ) ) ).

% power_int_mult
thf(fact_5984_power__int__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( inverse_inverse @ A @ X ) @ N )
          = ( inverse_inverse @ A @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_inverse
thf(fact_5985_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X @ Y ) @ M )
          = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_divide_distrib
thf(fact_5986_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_one_over
thf(fact_5987_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% zero_less_power_int
thf(fact_5988_power__int__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ X @ ( uminus_uminus @ int @ N ) )
          = ( inverse_inverse @ A @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus
thf(fact_5989_continuous__on__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F2: A > B,N: int] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S )
               => ( ( F2 @ X2 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X3: A] : ( power_int @ B @ ( F2 @ X3 ) @ N ) ) ) ) ) ).

% continuous_on_power_int
thf(fact_5990_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( ( M
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( one_one @ A ) ) )
          & ( ( M
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_5991_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_increasing
thf(fact_5992_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_5993_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M != N ) )
         => ( ( power_int @ A @ X @ ( minus_minus @ int @ M @ N ) )
            = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_diff
thf(fact_5994_tendsto__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,N: int] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( power_int @ A @ ( F2 @ X3 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ A @ ( power_int @ A @ A2 @ N ) )
              @ F4 ) ) ) ) ).

% tendsto_power_int
thf(fact_5995_continuous__at__within__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X3: A] : ( power_int @ B @ ( F2 @ X3 ) @ N ) ) ) ) ) ).

% continuous_at_within_power_int
thf(fact_5996_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,N: int] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X3: A] : ( power_int @ B @ ( F2 @ X3 ) @ N )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_power_int
thf(fact_5997_continuous__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X3: A] : X3 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X3: A] : ( power_int @ B @ ( F2 @ X3 ) @ N ) ) ) ) ) ).

% continuous_power_int
thf(fact_5998_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_5999_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,N: int] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( power_int @ A @ Y @ N ) ) ) ) ) ) ).

% power_int_mono
thf(fact_6000_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_6001_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% one_le_power_int
thf(fact_6002_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power_int
thf(fact_6003_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M @ N )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ N ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_add
thf(fact_6004_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_6005_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ B2 @ N ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_6006_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ( ( A2
                   != ( zero_zero @ A ) )
                  | ( N4
                   != ( zero_zero @ int ) )
                  | ( N
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_6007_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_6008_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less_eq @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_6009_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_6010_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) @ X )
            = ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus_mult
thf(fact_6011_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ X @ ( power_int @ A @ X @ M ) ) ) ) ) ).

% power_int_add_1'
thf(fact_6012_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ X ) ) ) ) ).

% power_int_add_1
thf(fact_6013_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G2: A > B,A26: set @ A,A16: set @ B,F15: B > C,B1: set @ C,F24: D > A,B22: set @ D] :
      ( ( member @ ( A > B ) @ G2 @ ( bNF_Wellorder_Func @ A @ B @ A26 @ A16 ) )
     => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ F15 @ A16 ) @ B1 )
       => ( ( ord_less_eq @ ( set @ A ) @ ( image @ D @ A @ F24 @ B22 ) @ A26 )
         => ( member @ ( D > C ) @ ( bNF_We4925052301507509544nc_map @ D @ B @ C @ A @ B22 @ F15 @ F24 @ G2 ) @ ( bNF_Wellorder_Func @ D @ C @ B22 @ B1 ) ) ) ) ) ).

% Func_map
thf(fact_6014_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X3: A,N3: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N3 ) @ ( power_power @ A @ X3 @ ( nat2 @ N3 ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ ( nat2 @ ( uminus_uminus @ int @ N3 ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_6015_powr__real__of__int_H,axiom,
    ! [X: real,N: int] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( X
           != ( zero_zero @ real ) )
          | ( ord_less @ int @ ( zero_zero @ int ) @ N ) )
       => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
          = ( power_int @ real @ X @ N ) ) ) ) ).

% powr_real_of_int'
thf(fact_6016_pos__deriv__imp__strict__mono,axiom,
    ! [F2: real > real,F7: real > real] :
      ( ! [X2: real] : ( has_field_derivative @ real @ F2 @ ( F7 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F7 @ X2 ) )
       => ( order_strict_mono @ real @ real @ F2 ) ) ) ).

% pos_deriv_imp_strict_mono
thf(fact_6017_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,N: int] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( power_int @ A @ ( F2 @ X3 ) @ N )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) @ D2 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_power_int
thf(fact_6018_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A3: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X @ A3 ) )
                @ ( set_ord_greaterThan @ A @ X ) ) ) ) ) ) ).

% at_right_eq
thf(fact_6019_lists__length__Suc__eq,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs3: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
            & ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( suc @ N ) ) ) )
      = ( image @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs3: list @ A,N3: A] : ( cons @ A @ N3 @ Xs3 ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N ) ) )
          @ ^ [Uu3: list @ A] : A5 ) ) ) ).

% lists_length_Suc_eq
thf(fact_6020_principal__le__iff,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( principal @ A @ A5 ) @ ( principal @ A @ B6 ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ B6 ) ) ).

% principal_le_iff
thf(fact_6021_set__product,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys2 ) )
      = ( product_Sigma @ A @ B @ ( set2 @ A @ Xs )
        @ ^ [Uu3: A] : ( set2 @ B @ Ys2 ) ) ) ).

% set_product
thf(fact_6022_Restr__subset,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R2
            @ ( product_Sigma @ A @ A @ B6
              @ ^ [Uu3: A] : B6 ) )
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu3: A] : A5 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R2
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu3: A] : A5 ) ) ) ) ).

% Restr_subset
thf(fact_6023_Sigma__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,C4: set @ A,B6: A > ( set @ B ),D5: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ A5 )
           => ( ord_less_eq @ ( set @ B ) @ ( B6 @ X2 ) @ ( D5 @ X2 ) ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ A5 @ B6 ) @ ( product_Sigma @ A @ B @ C4 @ D5 ) ) ) ) ).

% Sigma_mono
thf(fact_6024_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,X: A,C4: set @ A,A5: set @ B,B6: set @ B] :
      ( ( member @ A @ X @ C4 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) )
          @ ( product_Sigma @ B @ A @ A5
            @ ^ [Uu3: B] : C4 )
          @ ( product_Sigma @ B @ A @ B6
            @ ^ [Uu3: B] : C4 ) )
        = ( ord_less_eq @ ( set @ B ) @ A5 @ B6 ) ) ) ).

% Times_subset_cancel2
thf(fact_6025_open__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ( ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) )
        = ( ^ [S5: set @ ( product_prod @ A @ B )] :
            ! [X3: product_prod @ A @ B] :
              ( ( member @ ( product_prod @ A @ B ) @ X3 @ S5 )
             => ? [A7: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A7 )
                  & ? [B7: set @ B] :
                      ( ( topolo1002775350975398744n_open @ B @ B7 )
                      & ( member @ ( product_prod @ A @ B ) @ X3
                        @ ( product_Sigma @ A @ B @ A7
                          @ ^ [Uu3: A] : B7 ) )
                      & ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                        @ ( product_Sigma @ A @ B @ A7
                          @ ^ [Uu3: A] : B7 )
                        @ S5 ) ) ) ) ) ) ) ).

% open_prod_def
thf(fact_6026_open__prod__elim,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S2: set @ ( product_prod @ A @ B ),X: product_prod @ A @ B] :
          ( ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) @ S2 )
         => ( ( member @ ( product_prod @ A @ B ) @ X @ S2 )
           => ~ ! [A8: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A8 )
                 => ! [B8: set @ B] :
                      ( ( topolo1002775350975398744n_open @ B @ B8 )
                     => ( ( member @ ( product_prod @ A @ B ) @ X
                          @ ( product_Sigma @ A @ B @ A8
                            @ ^ [Uu3: A] : B8 ) )
                       => ~ ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                            @ ( product_Sigma @ A @ B @ A8
                              @ ^ [Uu3: A] : B8 )
                            @ S2 ) ) ) ) ) ) ) ).

% open_prod_elim
thf(fact_6027_open__prod__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S2: set @ ( product_prod @ A @ B )] :
          ( ! [X2: product_prod @ A @ B] :
              ( ( member @ ( product_prod @ A @ B ) @ X2 @ S2 )
             => ? [A17: set @ A,B9: set @ B] :
                  ( ( topolo1002775350975398744n_open @ A @ A17 )
                  & ( topolo1002775350975398744n_open @ B @ B9 )
                  & ( member @ ( product_prod @ A @ B ) @ X2
                    @ ( product_Sigma @ A @ B @ A17
                      @ ^ [Uu3: A] : B9 ) )
                  & ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                    @ ( product_Sigma @ A @ B @ A17
                      @ ^ [Uu3: A] : B9 )
                    @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) @ S2 ) ) ) ).

% open_prod_intro
thf(fact_6028_le__principal,axiom,
    ! [A: $tType,F4: filter @ A,A5: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ ( principal @ A @ A5 ) )
      = ( eventually @ A
        @ ^ [X3: A] : ( member @ A @ X3 @ A5 )
        @ F4 ) ) ).

% le_principal
thf(fact_6029_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,C4: set @ B,B6: set @ A,D5: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : C4 )
        @ ( product_Sigma @ A @ B @ B6
          @ ^ [Uu3: A] : D5 ) )
      = ( ( A5
          = ( bot_bot @ ( set @ A ) ) )
        | ( C4
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
          & ( ord_less_eq @ ( set @ B ) @ C4 @ D5 ) ) ) ) ).

% times_subset_iff
thf(fact_6030_Ex__inj__on__UNION__Sigma,axiom,
    ! [A: $tType,B: $tType,A5: B > ( set @ A ),I6: set @ B] :
    ? [F5: A > ( product_prod @ B @ A )] :
      ( ( inj_on @ A @ ( product_prod @ B @ A ) @ F5 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A5 @ I6 ) ) )
      & ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) ) @ ( image @ A @ ( product_prod @ B @ A ) @ F5 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A5 @ I6 ) ) ) @ ( product_Sigma @ B @ A @ I6 @ A5 ) ) ) ).

% Ex_inj_on_UNION_Sigma
thf(fact_6031_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I6: set @ A,F4: A > ( set @ B ),F2: B > C,G5: D > ( set @ C ),J4: set @ D] :
      ( ( I6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ! [J2: A] :
                ( ( member @ A @ J2 @ I6 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F4 @ I2 ) @ ( F4 @ J2 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F4 @ J2 ) @ ( F4 @ I2 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F2
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image @ D @ ( filter @ C )
                @ ^ [J3: D] : ( principal @ C @ ( G5 @ J3 ) )
                @ J4 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image @ A @ ( filter @ B )
                @ ^ [I4: A] : ( principal @ B @ ( F4 @ I4 ) )
                @ I6 ) ) )
          = ( ! [X3: D] :
                ( ( member @ D @ X3 @ J4 )
               => ? [Y4: A] :
                    ( ( member @ A @ Y4 @ I6 )
                    & ! [Z5: B] :
                        ( ( member @ B @ Z5 @ ( F4 @ Y4 ) )
                       => ( member @ C @ ( F2 @ Z5 ) @ ( G5 @ X3 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_6032_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X3: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X3 ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_6033_nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X3: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ real @ ( filter @ A )
                @ ^ [E3: real] :
                    ( principal @ A
                    @ ( collect @ A
                      @ ^ [Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y4 @ X3 ) @ E3 ) ) )
                @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% nhds_metric
thf(fact_6034_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A3: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A3 @ X ) )
                @ ( set_ord_lessThan @ A @ X ) ) ) ) ) ) ).

% at_left_eq
thf(fact_6035_complete__uniform,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo2479028161051973599mplete @ A )
        = ( ^ [S5: set @ A] :
            ! [F9: filter @ A] :
              ( ( ord_less_eq @ ( filter @ A ) @ F9 @ ( principal @ A @ S5 ) )
             => ( ( F9
                 != ( bot_bot @ ( filter @ A ) ) )
               => ( ( topolo6773858410816713723filter @ A @ F9 )
                 => ? [X3: A] :
                      ( ( member @ A @ X3 @ S5 )
                      & ( ord_less_eq @ ( filter @ A ) @ F9 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) ) ) ) ) ) ) ) ) ).

% complete_uniform
thf(fact_6036_uniformity__dist,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ A ) )
          @ ( image @ real @ ( filter @ ( product_prod @ A @ A ) )
            @ ^ [E3: real] :
                ( principal @ ( product_prod @ A @ A )
                @ ( collect @ ( product_prod @ A @ A )
                  @ ( product_case_prod @ A @ A @ $o
                    @ ^ [X3: A,Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y4 ) @ E3 ) ) ) )
            @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ).

% uniformity_dist
thf(fact_6037_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X7: nat > A] :
            ! [P3: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ P3 @ ( topolo7806501430040627800ormity @ A ) )
             => ? [N7: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N3 )
                 => ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ M2 )
                     => ( P3 @ ( product_Pair @ A @ A @ ( X7 @ N3 ) @ ( X7 @ M2 ) ) ) ) ) ) ) ) ) ).

% Cauchy_uniform_iff
thf(fact_6038_uniformity__real__def,axiom,
    ( ( topolo7806501430040627800ormity @ real )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ real @ real ) )
      @ ( image @ real @ ( filter @ ( product_prod @ real @ real ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ real @ real )
            @ ( collect @ ( product_prod @ real @ real )
              @ ( product_case_prod @ real @ real @ $o
                @ ^ [X3: real,Y4: real] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ real @ X3 @ Y4 ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_real_def
thf(fact_6039_uniformity__complex__def,axiom,
    ( ( topolo7806501430040627800ormity @ complex )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ complex @ complex ) )
      @ ( image @ real @ ( filter @ ( product_prod @ complex @ complex ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ complex @ complex )
            @ ( collect @ ( product_prod @ complex @ complex )
              @ ( product_case_prod @ complex @ complex @ $o
                @ ^ [X3: complex,Y4: complex] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ complex @ X3 @ Y4 ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_complex_def
thf(fact_6040_pairs__le__eq__Sigma,axiom,
    ! [M: nat] :
      ( ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ M ) ) )
      = ( product_Sigma @ nat @ nat @ ( set_ord_atMost @ nat @ M )
        @ ^ [R5: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M @ R5 ) ) ) ) ).

% pairs_le_eq_Sigma
thf(fact_6041_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ! [P: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( topolo7806501430040627800ormity @ A ) )
          = ( ? [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                & ! [X3: A,Y4: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y4 ) @ E3 )
                   => ( P @ ( product_Pair @ A @ A @ X3 @ Y4 ) ) ) ) ) ) ) ).

% eventually_uniformity_metric
thf(fact_6042_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,F2: A > B,B6: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( bNF_Gr @ A @ B @ A5 @ F2 )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : B6 ) )
      = ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B6 ) ) ).

% Gr_incl
thf(fact_6043_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa )
        = Y )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Y
            = ( ( Xa
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( Y
                = ( ~ ( ( Deg2 = Xa )
                      & ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X7 )
                          & ! [X3: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X7 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                              & ( ( Mi = Ma2 )
                               => ! [X3: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                              & ( ( Mi != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X3: nat] :
                                      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X3 )
                                       => ( ( ord_less @ nat @ Mi @ X3 )
                                          & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_6044_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X25: list @ A] :
          ( ? [Y4: A,Ys3: list @ A] :
              ( ( X17
                = ( nil @ A ) )
              & ( X25
                = ( cons @ A @ Y4 @ Ys3 ) ) )
          | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
              ( ( X17
                = ( cons @ A @ X3 @ Xs3 ) )
              & ( X25
                = ( cons @ A @ Y4 @ Ys3 ) )
              & ( Less @ X3 @ Y4 ) )
          | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
              ( ( X17
                = ( cons @ A @ X3 @ Xs3 ) )
              & ( X25
                = ( cons @ A @ Y4 @ Ys3 ) )
              & ~ ( Less @ X3 @ Y4 )
              & ~ ( Less @ Y4 @ X3 )
              & ( P5 @ Xs3 @ Ys3 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_6045_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X25: list @ A] :
            ( ? [Y4: A,Ys3: list @ A] :
                ( ( X17
                  = ( nil @ A ) )
                & ( X25
                  = ( cons @ A @ Y4 @ Ys3 ) ) )
            | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( X25
                  = ( cons @ A @ Y4 @ Ys3 ) )
                & ( ord_less @ A @ X3 @ Y4 ) )
            | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( X25
                  = ( cons @ A @ Y4 @ Ys3 ) )
                & ~ ( ord_less @ A @ X3 @ Y4 )
                & ~ ( ord_less @ A @ Y4 @ X3 )
                & ( P5 @ Xs3 @ Ys3 ) ) ) ) ) ).

% lexordp.mono
thf(fact_6046_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A7: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z5: list @ A] :
              ? [X3: A,Xs3: list @ A] :
                ( ( Z5
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( member @ A @ X3 @ A7 )
                & ( member @ ( list @ A ) @ Xs3 @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_6047_Ball__def__raw,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P3: A > $o] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A7 )
           => ( P3 @ X3 ) ) ) ) ).

% Ball_def_raw
thf(fact_6048_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X3: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X3 @ Y4 ) )
              & ( ord_less_eq @ A @ X3 @ Y4 ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_6049_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X3: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X3 @ Y4 ) )
              & ( ord_less_eq @ A @ Y4 @ X3 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_6050_Ball__Collect,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P3: A > $o] : ( ord_less_eq @ ( set @ A ) @ A7 @ ( collect @ A @ P3 ) ) ) ) ).

% Ball_Collect
thf(fact_6051_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                ? [Us2: list @ A,Z5: A,Z7: A,Vs3: list @ A] :
                  ( ( Xs3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z5 @ Vs3 ) ) )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ Z7 ) @ R5 )
                  & ( Ys3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z7 @ Vs3 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_6052_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X3: A] :
                    ( ( member @ A @ X3 @ A7 )
                   => ( ord_less_eq @ A @ B3 @ X3 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_6053_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X3: A] :
                    ( ( member @ A @ X3 @ A7 )
                   => ( ord_less_eq @ A @ X3 @ B3 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_6054_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ A ) @ Ys3 ) )
                  & ? [Xys: list @ A,X3: A,Y4: A,Xs5: list @ A,Ys5: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X3 @ Xs5 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y4 @ Ys5 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_6055_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X3: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X3 @ Y4 ) )
              & ( ord_less @ A @ Y4 @ X3 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_6056_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X3: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X3 @ Y4 ) )
              & ( ord_less @ A @ X3 @ Y4 ) ) ) ) ) ).

% open_subdiagonal
thf(fact_6057_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs3: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I4: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs3 @ I4 ) )
                & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_6058_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X3: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
           => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X7 )
            & ! [X3: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
               => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi: nat,Ma2: nat] :
                ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X7 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
                & ( ( Mi = Ma2 )
                 => ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                & ( ( Mi != Ma2 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma2 )
                    & ! [X3: nat] :
                        ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X3 )
                         => ( ( ord_less @ nat @ Mi @ X3 )
                            & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_6059_funpow__inj__finite,axiom,
    ! [A: $tType,P6: A > A,X: A] :
      ( ( inj_on @ A @ A @ P6 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y4: A] :
              ? [N3: nat] :
                ( Y4
                = ( compow @ ( A > A ) @ N3 @ P6 @ X ) ) ) )
       => ~ ! [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( compow @ ( A > A ) @ N2 @ P6 @ X )
               != X ) ) ) ) ).

% funpow_inj_finite
thf(fact_6060_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( Deg2 = Xa )
                & ! [X2: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X7 )
                    & ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi: nat,Ma2: nat] :
                        ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                        & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I4: nat] :
                            ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X7 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                        & ( ( Mi = Ma2 )
                         => ! [X3: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                        & ( ( Mi != Ma2 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                            & ! [X3: nat] :
                                ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X3 )
                                 => ( ( ord_less @ nat @ Mi @ X3 )
                                    & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_6061_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ~ ( ( Deg2 = Xa )
                  & ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X7 )
                      & ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi: nat,Ma2: nat] :
                          ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                          & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X7 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                          & ( ( Mi = Ma2 )
                           => ! [X3: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                               => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                          & ( ( Mi != Ma2 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                              & ! [X3: nat] :
                                  ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X3 )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_6062_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ( ( Deg2 = Xa )
                    & ! [X2: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X7 )
                        & ! [X3: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi: nat,Ma2: nat] :
                            ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                            & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I4: nat] :
                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X7 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                            & ( ( Mi = Ma2 )
                             => ! [X3: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                            & ( ( Mi != Ma2 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                & ! [X3: nat] :
                                    ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X3 )
                                     => ( ( ord_less @ nat @ Mi @ X3 )
                                        & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_6063_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ~ ( ( Deg2 = Xa )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X7 )
                          & ! [X3: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X7 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                              & ( ( Mi = Ma2 )
                               => ! [X3: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                              & ( ( Mi != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X3: nat] :
                                      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X3 )
                                       => ( ( ord_less @ nat @ Mi @ X3 )
                                          & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_6064_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A5 ) )
                    & ! [X3: set @ A] :
                        ( ( member @ ( set @ A ) @ X3 @ A5 )
                       => ( member @ A @ ( F3 @ X3 ) @ X3 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A5 ) ) ) ) ).

% Sup_Inf_le
thf(fact_6065_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A5: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A5 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A5 ) )
                    & ! [X3: set @ A] :
                        ( ( member @ ( set @ A ) @ X3 @ A5 )
                       => ( member @ A @ ( F3 @ X3 ) @ X3 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_6066_mono__compose,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ C ) )
     => ! [Q: A > B > C,F2: D > B] :
          ( ( order_mono @ A @ ( B > C ) @ Q )
         => ( order_mono @ A @ ( D > C )
            @ ^ [I4: A,X3: D] : ( Q @ I4 @ ( F2 @ X3 ) ) ) ) ) ).

% mono_compose
thf(fact_6067_Inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( filter @ A ) )
      = ( ^ [S5: set @ ( filter @ A )] :
            ( complete_Sup_Sup @ ( filter @ A )
            @ ( collect @ ( filter @ A )
              @ ^ [F9: filter @ A] :
                ! [X3: filter @ A] :
                  ( ( member @ ( filter @ A ) @ X3 @ S5 )
                 => ( ord_less_eq @ ( filter @ A ) @ F9 @ X3 ) ) ) ) ) ) ).

% Inf_filter_def
thf(fact_6068_Union__maximal__sets,axiom,
    ! [A: $tType,F16: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ F16 )
     => ( ( complete_Sup_Sup @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [T10: set @ A] :
                ( ( member @ ( set @ A ) @ T10 @ F16 )
                & ! [X3: set @ A] :
                    ( ( member @ ( set @ A ) @ X3 @ F16 )
                   => ~ ( ord_less @ ( set @ A ) @ T10 @ X3 ) ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ F16 ) ) ) ).

% Union_maximal_sets
thf(fact_6069_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [Uu3: A] :
            ? [N3: int] :
              ( ( Uu3
                = ( ring_1_of_int @ A @ N3 ) )
              & ( ord_less_eq @ int @ ( zero_zero @ int ) @ N3 ) ) ) ) ) ).

% Nats_altdef1
thf(fact_6070_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X7: set @ int] :
          ( the @ int
          @ ^ [X3: int] :
              ( ( member @ int @ X3 @ X7 )
              & ! [Y4: int] :
                  ( ( member @ int @ Y4 @ X7 )
                 => ( ord_less_eq @ int @ Y4 @ X3 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_6071_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( Y
                  = ( Xa
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( Y
                    = ( ( Deg2 = Xa )
                      & ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X7 )
                          & ! [X3: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X7 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                              & ( ( Mi = Ma2 )
                               => ! [X3: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X7: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X7 ) ) )
                              & ( ( Mi != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X3: nat] :
                                      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X3 )
                                       => ( ( ord_less @ nat @ Mi @ X3 )
                                          & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_6072_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A5: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A5 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A5 ) )
                    & ! [X3: set @ A] :
                        ( ( member @ ( set @ A ) @ X3 @ A5 )
                       => ( member @ A @ ( F3 @ X3 ) @ X3 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_6073_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N3: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = N3 )
                  & ( ( size_size @ ( list @ A ) @ Ys3 )
                    = N3 )
                  & ? [Xys: list @ A,X3: A,Y4: A,Xs5: list @ A,Ys5: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X3 @ Xs5 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y4 @ Ys5 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_6074_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R2 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_6075_lexn__length,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lexn @ A @ R2 @ N ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = N )
        & ( ( size_size @ ( list @ A ) @ Ys2 )
          = N ) ) ) ).

% lexn_length
thf(fact_6076_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R5 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_6077_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F3: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X3: A,Y4: A] :
                  ( ( ord_less @ nat @ ( F3 @ X3 ) @ ( F3 @ Y4 ) )
                  | ( ( ord_less_eq @ nat @ ( F3 @ X3 ) @ ( F3 @ Y4 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_6078_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I4: int,N3: nat] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I4 ) @ ( semiring_1_of_nat @ real @ N3 ) ) )
          & ( N3
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_6079_Rats__abs__iff,axiom,
    ! [X: real] :
      ( ( member @ real @ ( abs_abs @ real @ X ) @ ( field_char_0_Rats @ real ) )
      = ( member @ real @ X @ ( field_char_0_Rats @ real ) ) ) ).

% Rats_abs_iff
thf(fact_6080_Rats__no__top__le,axiom,
    ! [X: real] :
    ? [X2: real] :
      ( ( member @ real @ X2 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X @ X2 ) ) ).

% Rats_no_top_le
thf(fact_6081_Rats__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_power
thf(fact_6082_Rats__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_of_nat
thf(fact_6083_Rats__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_0
thf(fact_6084_Rats__inverse,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_inverse
thf(fact_6085_Rats__no__bot__less,axiom,
    ! [X: real] :
    ? [X2: real] :
      ( ( member @ real @ X2 @ ( field_char_0_Rats @ real ) )
      & ( ord_less @ real @ X2 @ X ) ) ).

% Rats_no_bot_less
thf(fact_6086_Rats__dense__in__real,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ? [X2: real] :
          ( ( member @ real @ X2 @ ( field_char_0_Rats @ real ) )
          & ( ord_less @ real @ X @ X2 )
          & ( ord_less @ real @ X2 @ Y ) ) ) ).

% Rats_dense_in_real
thf(fact_6087_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( ring_1_Ints @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Ints_subset_Rats
thf(fact_6088_Nats__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Nats_subset_Rats
thf(fact_6089_mlex__iff,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R4 ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ).

% mlex_iff
thf(fact_6090_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R4 ) ) ) ).

% mlex_less
thf(fact_6091_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R4 ) ) ) ) ).

% mlex_leq
thf(fact_6092_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I4: int,J3: int] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I4 ) @ ( ring_1_of_int @ real @ J3 ) ) )
          & ( J3
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_6093_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X3: list @ A,Y4: list @ A] :
                ? [A3: A,V5: list @ A] :
                  ( ( Y4
                    = ( append @ A @ X3 @ ( cons @ A @ A3 @ V5 ) ) )
                  | ? [U2: list @ A,B3: A,C5: A,W3: list @ A,Z5: list @ A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C5 ) @ R5 )
                      & ( X3
                        = ( append @ A @ U2 @ ( cons @ A @ B3 @ W3 ) ) )
                      & ( Y4
                        = ( append @ A @ U2 @ ( cons @ A @ C5 @ Z5 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_6094_relpow__finite__bounded1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R4 )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 )
              @ ( collect @ nat
                @ ^ [N3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
                    & ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_6095_lexord__cons__cons,axiom,
    ! [A: $tType,A2: A,X: list @ A,B2: A,Y: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A2 @ X ) @ ( cons @ A @ B2 @ Y ) ) @ ( lexord @ A @ R2 ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R2 )
        | ( ( A2 = B2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R2 ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_6096_lexord__Nil__left,axiom,
    ! [A: $tType,Y: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y ) @ ( lexord @ A @ R2 ) )
      = ( ? [A3: A,X3: list @ A] :
            ( Y
            = ( cons @ A @ A3 @ X3 ) ) ) ) ).

% lexord_Nil_left
thf(fact_6097_finite__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( finite_finite @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) ) ) ) ).

% finite_relpow
thf(fact_6098_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( irrefl @ A @ R2 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R2 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_6099_relpow__0__I,axiom,
    ! [A: $tType,X: A,R4: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R4 ) ) ).

% relpow_0_I
thf(fact_6100_relpow__0__E,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R4 ) )
     => ( X = Y ) ) ).

% relpow_0_E
thf(fact_6101_lexord__irreflexive,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_irreflexive
thf(fact_6102_lexord__linear,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),X: list @ A,Y: list @ A] :
      ( ! [A4: A,B4: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B4 ) @ R2 )
          | ( A4 = B4 )
          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A4 ) @ R2 ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R2 ) )
        | ( X = Y )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ X ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_linear
thf(fact_6103_lexord__Nil__right,axiom,
    ! [A: $tType,X: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) @ ( lexord @ A @ R2 ) ) ).

% lexord_Nil_right
thf(fact_6104_lexord__append__leftI,axiom,
    ! [A: $tType,U: list @ A,V2: list @ A,R2: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R2 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_append_leftI
thf(fact_6105_relpow__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y2: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R4 )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R4 ) ) ) ) ) ) ).

% relpow_E2
thf(fact_6106_relpow__E,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y2: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R4 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ R4 ) ) ) ) ) ).

% relpow_E
thf(fact_6107_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_6108_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A ),Ys2: list @ A,Zs: list @ A] :
      ( ! [X2: A,Y2: A,Z3: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R2 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z3 ) @ R2 )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z3 ) @ R2 ) ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lexord @ A @ R2 ) )
       => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lexord @ A @ R2 ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( lexord @ A @ R2 ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_6109_lexord__append__leftD,axiom,
    ! [A: $tType,X: list @ A,U: list @ A,V2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R2 ) )
     => ( ! [A4: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A4 ) @ R2 )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_append_leftD
thf(fact_6110_lexord__append__rightI,axiom,
    ! [A: $tType,Y: list @ A,X: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ? [B10: A,Z4: list @ A] :
          ( Y
          = ( cons @ A @ B10 @ Z4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( append @ A @ X @ Y ) ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_append_rightI
thf(fact_6111_lexord__sufE,axiom,
    ! [A: $tType,Xs: list @ A,Zs: list @ A,Ys2: list @ A,Qs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Zs ) @ ( append @ A @ Ys2 @ Qs ) ) @ ( lexord @ A @ R2 ) )
     => ( ( Xs != Ys2 )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys2 ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lexord @ A @ R2 ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_6112_lexord__lex,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lex @ A @ R2 ) )
      = ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R2 ) )
        & ( ( size_size @ ( list @ A ) @ X )
          = ( size_size @ ( list @ A ) @ Y ) ) ) ) ).

% lexord_lex
thf(fact_6113_lexord__irrefl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R4 )
     => ( irrefl @ ( list @ A ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_irrefl
thf(fact_6114_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
      = ( ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = A2 )
            & ( ( F3 @ N )
              = B2 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F3 @ I4 ) @ ( F3 @ ( suc @ I4 ) ) ) @ R4 ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_6115_lexord__append__left__rightI,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set @ ( product_prod @ A @ A ),U: list @ A,X: list @ A,Y: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R2 )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A2 @ X ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y ) ) ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_append_left_rightI
thf(fact_6116_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R2 ) )
      = ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R2 ) )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_6117_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W2: list @ A,R2: set @ ( product_prod @ A @ A ),V2: list @ A,Z2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W2 ) @ ( lexord @ A @ R2 ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W2 ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V2 ) @ ( append @ A @ W2 @ Z2 ) ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_sufI
thf(fact_6118_relpow__finite__bounded,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R4 )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 )
            @ ( collect @ nat
              @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_6119_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_6120_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N3: nat,R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I4: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I4 @ R6 )
              @ ( collect @ nat
                @ ^ [I4: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I4 )
                    & ( ord_less_eq @ nat @ I4 @ ( suc @ N3 ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_6121_ntrancl__Zero,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_ntrancl @ A @ ( zero_zero @ nat ) @ R4 )
      = R4 ) ).

% ntrancl_Zero
thf(fact_6122_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( transitive_trancl @ A @ R4 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 )
            @ ( collect @ nat
              @ ^ [N3: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
                  & ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_6123_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( transitive_rtrancl @ A @ R4 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 )
            @ ( collect @ nat
              @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_6124_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys2: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R2 ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_6125_rtrancl__Un__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R4 ) @ ( transitive_rtrancl @ A @ S2 ) ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S2 ) ) ) ).

% rtrancl_Un_subset
thf(fact_6126_trancl__mono,axiom,
    ! [A: $tType,P6: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P6 @ ( transitive_trancl @ A @ R2 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S )
       => ( member @ ( product_prod @ A @ A ) @ P6 @ ( transitive_trancl @ A @ S ) ) ) ) ).

% trancl_mono
thf(fact_6127_rtrancl__mono,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R2 ) @ ( transitive_rtrancl @ A @ S ) ) ) ).

% rtrancl_mono
thf(fact_6128_rtrancl__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ S2 @ ( transitive_rtrancl @ A @ R4 ) )
       => ( ( transitive_rtrancl @ A @ S2 )
          = ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% rtrancl_subset
thf(fact_6129_rtrancl__subset__rtrancl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ ( transitive_rtrancl @ A @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R2 ) @ ( transitive_rtrancl @ A @ S ) ) ) ).

% rtrancl_subset_rtrancl
thf(fact_6130_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ ( transitive_rtrancl @ A @ R2 ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
thf(fact_6131_trancl__subset__Sigma,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2
        @ ( product_Sigma @ A @ A @ A5
          @ ^ [Uu3: A] : A5 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R2 )
        @ ( product_Sigma @ A @ A @ A5
          @ ^ [Uu3: A] : A5 ) ) ) ).

% trancl_subset_Sigma
thf(fact_6132_trancl__power,axiom,
    ! [A: $tType,P6: product_prod @ A @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P6 @ ( transitive_trancl @ A @ R4 ) )
      = ( ? [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
            & ( member @ ( product_prod @ A @ A ) @ P6 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 ) ) ) ) ) ).

% trancl_power
thf(fact_6133_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys2 ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_6134_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) )
     => ( ( size_size @ ( list @ A ) @ X )
        = ( size_size @ ( list @ A ) @ Y ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_6135_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R2 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu3: A] : A5 ) )
       => ( ( A2 = B2 )
          | ( member @ A @ A2 @ A5 ) ) ) ) ).

% trancl_subset_Sigma_aux
thf(fact_6136_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) ) ).

% trancl_set_ntrancl
thf(fact_6137_set__nths,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs @ I6 ) )
      = ( collect @ A
        @ ^ [Uu3: A] :
          ? [I4: nat] :
            ( ( Uu3
              = ( nth @ A @ Xs @ I4 ) )
            & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( member @ nat @ I4 @ I6 ) ) ) ) ).

% set_nths
thf(fact_6138_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( fract @ A2 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_6139_nths__nil,axiom,
    ! [A: $tType,A5: set @ nat] :
      ( ( nths @ A @ ( nil @ A ) @ A5 )
      = ( nil @ A ) ) ).

% nths_nil
thf(fact_6140_inverse__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( inverse_inverse @ rat @ ( fract @ A2 @ B2 ) )
      = ( fract @ B2 @ A2 ) ) ).

% inverse_rat
thf(fact_6141_nths__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( nths @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) ).

% nths_empty
thf(fact_6142_nths__singleton,axiom,
    ! [A: $tType,A5: set @ nat,X: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A5 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A5 )
          = ( cons @ A @ X @ ( nil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A5 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A5 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_6143_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% diff_rat
thf(fact_6144_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_6145_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% add_rat
thf(fact_6146_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% le_rat
thf(fact_6147_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A2 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A2 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_6148_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A2 @ B2 )
            = ( fract @ C2 @ D2 ) )
          = ( ( times_times @ int @ A2 @ D2 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_6149_eq__rat_I3_J,axiom,
    ! [A2: int,C2: int] :
      ( ( fract @ ( zero_zero @ int ) @ A2 )
      = ( fract @ ( zero_zero @ int ) @ C2 ) ) ).

% eq_rat(3)
thf(fact_6150_distinct__nthsI,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( nths @ A @ Xs @ I6 ) ) ) ).

% distinct_nthsI
thf(fact_6151_Rat__induct__pos,axiom,
    ! [P: rat > $o,Q4: rat] :
      ( ! [A4: int,B4: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
         => ( P @ ( fract @ A4 @ B4 ) ) )
     => ( P @ Q4 ) ) ).

% Rat_induct_pos
thf(fact_6152_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_6153_Fract__of__nat__eq,axiom,
    ! [K: nat] :
      ( ( fract @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) )
      = ( semiring_1_of_nat @ rat @ K ) ) ).

% Fract_of_nat_eq
thf(fact_6154_rat__number__collapse_I6_J,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(6)
thf(fact_6155_rat__number__collapse_I1_J,axiom,
    ! [K: int] :
      ( ( fract @ ( zero_zero @ int ) @ K )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(1)
thf(fact_6156_notin__set__nthsI,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I6: set @ nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) ) ) ).

% notin_set_nthsI
thf(fact_6157_in__set__nthsD,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I6: set @ nat] :
      ( ( member @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_nthsD
thf(fact_6158_set__nths__subset,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) @ ( set2 @ A @ Xs ) ) ).

% set_nths_subset
thf(fact_6159_nths__all,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( member @ nat @ I2 @ I6 ) )
     => ( ( nths @ A @ Xs @ I6 )
        = Xs ) ) ).

% nths_all
thf(fact_6160_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_6161_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_less_Fract_iff
thf(fact_6162_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_less_zero_iff
thf(fact_6163_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_6164_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_6165_nths__append,axiom,
    ! [A: $tType,L: list @ A,L3: list @ A,A5: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L @ L3 ) @ A5 )
      = ( append @ A @ ( nths @ A @ L @ A5 )
        @ ( nths @ A @ L3
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( plus_plus @ nat @ J3 @ ( size_size @ ( list @ A ) @ L ) ) @ A5 ) ) ) ) ) ).

% nths_append
thf(fact_6166_Fract__add__one,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N ) @ N )
        = ( plus_plus @ rat @ ( fract @ M @ N ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_6167_length__nths,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs @ I6 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( member @ nat @ I4 @ I6 ) ) ) ) ) ).

% length_nths
thf(fact_6168_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_le_Fract_iff
thf(fact_6169_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_6170_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_6171_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_6172_nths__Cons,axiom,
    ! [A: $tType,X: A,L: list @ A,A5: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X @ L ) @ A5 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A5 ) @ ( cons @ A @ X @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( suc @ J3 ) @ A5 ) ) ) ) ) ).

% nths_Cons
thf(fact_6173_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ A @ A @ rep_Integ @ ( id @ A )
          @ ( product_case_prod @ nat @ nat @ A
            @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ) ) ).

% ring_1_class.of_int_def
thf(fact_6174_sorted__key__list__of__set__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord144544945434240204of_set @ B @ A )
        = ( ^ [F3: B > A] : ( finite_folding_F @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 ) @ ( nil @ B ) ) ) ) ) ).

% sorted_key_list_of_set_def
thf(fact_6175_of__nat__eq__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( id @ nat ) ) ).

% of_nat_eq_id
thf(fact_6176_id__funpow,axiom,
    ! [A: $tType,N: nat] :
      ( ( compow @ ( A > A ) @ N @ ( id @ A ) )
      = ( id @ A ) ) ).

% id_funpow
thf(fact_6177_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% push_bit_0_id
thf(fact_6178_drop__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% drop_bit_0
thf(fact_6179_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 )
      = ( id @ A ) ) ).

% funpow_simps_right(1)
thf(fact_6180_less__int__def,axiom,
    ( ( ord_less @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X3: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ) ).

% less_int_def
thf(fact_6181_less__eq__int__def,axiom,
    ( ( ord_less_eq @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X3: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ) ).

% less_eq_int_def
thf(fact_6182_nat__def,axiom,
    ( nat2
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ nat @ nat @ rep_Integ @ ( id @ nat ) @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ) ).

% nat_def
thf(fact_6183_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) )
            = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% folding_on.insert_remove
thf(fact_6184_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,X: A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ A5 )
              = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% folding_on.remove
thf(fact_6185_sorted__list__of__set_Ofold__insort__key_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite_folding_on @ A @ ( list @ A ) @ ( top_top @ ( set @ A ) )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X3: A] : X3 ) ) ) ).

% sorted_list_of_set.fold_insort_key.folding_on_axioms
thf(fact_6186_card__def,axiom,
    ! [B: $tType] :
      ( ( finite_card @ B )
      = ( finite_folding_F @ B @ nat
        @ ^ [Uu3: B] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card_def
thf(fact_6187_folding__on_Oinsert,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) )
              = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ A5 ) ) ) ) ) ) ) ).

% folding_on.insert
thf(fact_6188_folding__idem__on_Oinsert__idem,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite1890593828518410140dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) )
            = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z2 @ A5 ) ) ) ) ) ) ).

% folding_idem_on.insert_idem
thf(fact_6189_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q6: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q6 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_6190_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_6191_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_6192_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_6193_and__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_6194_and__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_6195_and__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_6196_and__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_6197_and__not__num__eq__None__iff,axiom,
    ! [M: num,N: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_6198_int__numeral__not__and__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_6199_int__numeral__and__not__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N ) ) ) ).

% int_numeral_and_not_num
thf(fact_6200_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N3: nat,M2: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N3 @ ( numeral_numeral @ nat @ M2 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N3 @ ( numeral_numeral @ nat @ M2 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_6201_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F2: A > B > B,G2: C > A,R4: set @ C] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G2 @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite673082921795544331dem_on @ C @ B @ R4 @ ( comp @ A @ ( B > B ) @ C @ F2 @ G2 ) ) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
thf(fact_6202_num__of__nat__numeral__eq,axiom,
    ! [Q4: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q4 ) )
      = Q4 ) ).

% num_of_nat_numeral_eq
thf(fact_6203_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_6204_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N ) )
        = N ) ) ).

% numeral_num_of_nat
thf(fact_6205_num__of__nat__One,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_6206_num__of__nat__code,axiom,
    ( num_of_nat
    = ( comp @ code_integer @ num @ nat @ code_num_of_integer @ ( semiring_1_of_nat @ code_integer ) ) ) ).

% num_of_nat_code
thf(fact_6207_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_6208_num__of__nat__double,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N @ N ) )
        = ( bit0 @ ( num_of_nat @ N ) ) ) ) ).

% num_of_nat_double
thf(fact_6209_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_6210_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = ( inc @ ( num_of_nat @ N ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_6211_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( positive @ ( fract @ A2 @ B2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ A2 @ B2 ) ) ) ).

% positive_rat
thf(fact_6212_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_6213_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_6214_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_6215_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_6216_add__inc,axiom,
    ! [X: num,Y: num] :
      ( ( plus_plus @ num @ X @ ( inc @ Y ) )
      = ( inc @ ( plus_plus @ num @ X @ Y ) ) ) ).

% add_inc
thf(fact_6217_num__induct,axiom,
    ! [P: num > $o,X: num] :
      ( ( P @ one2 )
     => ( ! [X2: num] :
            ( ( P @ X2 )
           => ( P @ ( inc @ X2 ) ) )
       => ( P @ X ) ) ) ).

% num_induct
thf(fact_6218_Rat_Opositive__zero,axiom,
    ~ ( positive @ ( zero_zero @ rat ) ) ).

% Rat.positive_zero
thf(fact_6219_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_6220_inc_Osimps_I3_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit1 @ X ) )
      = ( bit0 @ ( inc @ X ) ) ) ).

% inc.simps(3)
thf(fact_6221_inc_Osimps_I2_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit0 @ X ) )
      = ( bit1 @ X ) ) ).

% inc.simps(2)
thf(fact_6222_add__One,axiom,
    ! [X: num] :
      ( ( plus_plus @ num @ X @ one2 )
      = ( inc @ X ) ) ).

% add_One
thf(fact_6223_inc__BitM__eq,axiom,
    ! [N: num] :
      ( ( inc @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% inc_BitM_eq
thf(fact_6224_BitM__inc__eq,axiom,
    ! [N: num] :
      ( ( bitM @ ( inc @ N ) )
      = ( bit1 @ N ) ) ).

% BitM_inc_eq
thf(fact_6225_mult__inc,axiom,
    ! [X: num,Y: num] :
      ( ( times_times @ num @ X @ ( inc @ Y ) )
      = ( plus_plus @ num @ ( times_times @ num @ X @ Y ) @ X ) ) ).

% mult_inc
thf(fact_6226_Rat_Opositive__minus,axiom,
    ! [X: rat] :
      ( ~ ( positive @ X )
     => ( ( X
         != ( zero_zero @ rat ) )
       => ( positive @ ( uminus_uminus @ rat @ X ) ) ) ) ).

% Rat.positive_minus
thf(fact_6227_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_6228_less__rat__def,axiom,
    ( ( ord_less @ rat )
    = ( ^ [X3: rat,Y4: rat] : ( positive @ ( minus_minus @ rat @ Y4 @ X3 ) ) ) ) ).

% less_rat_def
thf(fact_6229_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N ) @ one2 )
          = ( numeral_numeral @ A @ N ) ) ) ).

% sub_inc_One_eq
thf(fact_6230_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L ) )
        = ( set2 @ A @ ( take @ A @ L @ Xs ) ) ) ) ).

% nth_image
thf(fact_6231_dual__min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( min @ A
          @ ^ [X3: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X3 ) )
        = ( ord_max @ A ) ) ) ).

% dual_min
thf(fact_6232_take__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( take @ A @ ( suc @ N ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ N @ Xs ) ) ) ).

% take_Suc_Cons
thf(fact_6233_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs3: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_6234_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_6235_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N @ Xs ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_6236_take__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( take @ A @ N @ Xs )
        = Xs ) ) ).

% take_all
thf(fact_6237_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = Xs )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% take_all_iff
thf(fact_6238_nth__take,axiom,
    ! [A: $tType,I: nat,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( nth @ A @ ( take @ A @ N @ Xs ) @ I )
        = ( nth @ A @ Xs @ I ) ) ) ).

% nth_take
thf(fact_6239_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A,Y: A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( take @ A @ N @ ( list_update @ A @ Xs @ M @ Y ) )
        = ( take @ A @ N @ Xs ) ) ) ).

% take_update_cancel
thf(fact_6240_nths__upt__eq__take,axiom,
    ! [A: $tType,L: list @ A,N: nat] :
      ( ( nths @ A @ L @ ( set_ord_lessThan @ nat @ N ) )
      = ( take @ A @ N @ L ) ) ).

% nths_upt_eq_take
thf(fact_6241_take__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( take @ A @ N @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( take @ A @ N @ Xs ) @ ( take @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys2 ) ) ) ).

% take_append
thf(fact_6242_take__Cons__numeral,axiom,
    ! [A: $tType,V2: num,X: A,Xs: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V2 ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% take_Cons_numeral
thf(fact_6243_set__take__subset,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_take_subset
thf(fact_6244_in__set__takeD,axiom,
    ! [A: $tType,X: A,N: nat,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_takeD
thf(fact_6245_take__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( take @ A @ N @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% take_Nil
thf(fact_6246_distinct__take,axiom,
    ! [A: $tType,Xs: list @ A,I: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( take @ A @ I @ Xs ) ) ) ).

% distinct_take
thf(fact_6247_take__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ! [I2: nat] :
          ( ( take @ A @ I2 @ Xs )
          = ( take @ A @ I2 @ Ys2 ) )
     => ( Xs = Ys2 ) ) ).

% take_equalityI
thf(fact_6248_ord_Omin__def,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( ^ [Less_eq: A > A > $o,A3: A,B3: A] : ( if @ A @ ( Less_eq @ A3 @ B3 ) @ A3 @ B3 ) ) ) ).

% ord.min_def
thf(fact_6249_ord_Omin_Ocong,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( min @ A ) ) ).

% ord.min.cong
thf(fact_6250_take__update__swap,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat,X: A] :
      ( ( take @ A @ M @ ( list_update @ A @ Xs @ N @ X ) )
      = ( list_update @ A @ ( take @ A @ M @ Xs ) @ N @ X ) ) ).

% take_update_swap
thf(fact_6251_take__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs )
      = ( nil @ A ) ) ).

% take_0
thf(fact_6252_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M @ Xs ) ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) ) ) ).

% set_take_subset_set_take
thf(fact_6253_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ K )
             => ( ( nth @ A @ Xs @ I2 )
                = ( nth @ A @ Ys2 @ I2 ) ) )
         => ( ( take @ A @ K @ Xs )
            = ( take @ A @ K @ Ys2 ) ) ) ) ) ).

% nth_take_lemma
thf(fact_6254_take__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ) ).

% take_Cons'
thf(fact_6255_lex__take__index,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lex @ A @ R2 ) )
     => ~ ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys2 ) )
             => ( ( ( take @ A @ I2 @ Xs )
                  = ( take @ A @ I2 @ Ys2 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Ys2 @ I2 ) ) @ R2 ) ) ) ) ) ).

% lex_take_index
thf(fact_6256_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ ( suc @ I ) @ Xs )
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_6257_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat,X: A] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( M != N )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N @ Xs ) @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) @ M )
            = ( nth @ A @ Xs @ M ) ) ) ) ) ).

% nth_repl
thf(fact_6258_pos__n__replace,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N @ Xs ) @ ( append @ A @ ( cons @ A @ Y @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N ) @ Xs ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_6259_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X3: list @ A] : X3 ) ) ).

% drop0
thf(fact_6260_drop__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( drop @ A @ M @ Xs ) )
      = ( drop @ A @ ( plus_plus @ nat @ N @ M ) @ Xs ) ) ).

% drop_drop
thf(fact_6261_drop__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ N @ Xs ) ) ).

% drop_Suc_Cons
thf(fact_6262_length__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_drop
thf(fact_6263_append__take__drop__id,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( drop @ A @ N @ Xs ) )
      = Xs ) ).

% append_take_drop_id
thf(fact_6264_drop__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N @ X ) )
        = ( drop @ A @ M @ Xs ) ) ) ).

% drop_update_cancel
thf(fact_6265_drop__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,X: A] :
      ( ( drop @ A @ I @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ K @ I ) @ X ) ) ).

% drop_replicate
thf(fact_6266_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N @ Xs ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil2
thf(fact_6267_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil
thf(fact_6268_drop__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_6269_drop__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( drop @ A @ N @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( drop @ A @ N @ Xs ) @ ( drop @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys2 ) ) ) ).

% drop_append
thf(fact_6270_drop__Cons__numeral,axiom,
    ! [A: $tType,V2: num,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V2 ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) @ Xs ) ) ).

% drop_Cons_numeral
thf(fact_6271_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,I: nat] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( drop @ A @ N @ Xs ) @ I )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ N @ I ) ) ) ) ).

% nth_drop
thf(fact_6272_take__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( drop @ A @ M @ Xs ) )
      = ( drop @ A @ M @ ( take @ A @ ( plus_plus @ nat @ N @ M ) @ Xs ) ) ) ).

% take_drop
thf(fact_6273_drop__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( take @ A @ M @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ M @ N ) @ ( drop @ A @ N @ Xs ) ) ) ).

% drop_take
thf(fact_6274_nth__via__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Y: A,Ys2: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( cons @ A @ Y @ Ys2 ) )
     => ( ( nth @ A @ Xs @ N )
        = Y ) ) ).

% nth_via_drop
thf(fact_6275_drop__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs )
      = Xs ) ).

% drop_0
thf(fact_6276_distinct__drop,axiom,
    ! [A: $tType,Xs: list @ A,I: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( drop @ A @ I @ Xs ) ) ) ).

% distinct_drop
thf(fact_6277_drop__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( drop @ A @ N @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% drop_Nil
thf(fact_6278_in__set__dropD,axiom,
    ! [A: $tType,X: A,N: nat,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_dropD
thf(fact_6279_set__drop__subset,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_drop_subset
thf(fact_6280_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N3: nat,Xs3: list @ A] : ( nths @ A @ Xs3 @ ( collect @ nat @ ( ord_less_eq @ nat @ N3 ) ) ) ) ) ).

% drop_eq_nths
thf(fact_6281_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M @ Xs ) ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_6282_take__add,axiom,
    ! [A: $tType,I: nat,J: nat,Xs: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I @ J ) @ Xs )
      = ( append @ A @ ( take @ A @ I @ Xs ) @ ( take @ A @ J @ ( drop @ A @ I @ Xs ) ) ) ) ).

% take_add
thf(fact_6283_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = Zs )
      = ( ( Xs
          = ( take @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) )
        & ( Ys2
          = ( drop @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% append_eq_conv_conj
thf(fact_6284_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N @ X ) )
        = ( list_update @ A @ ( drop @ A @ M @ Xs ) @ ( minus_minus @ nat @ N @ M ) @ X ) ) ) ).

% drop_update_swap
thf(fact_6285_nths__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,I6: set @ nat] :
      ( ( nths @ A @ ( drop @ A @ N @ Xs ) @ I6 )
      = ( nths @ A @ Xs @ ( image @ nat @ nat @ ( plus_plus @ nat @ N ) @ I6 ) ) ) ).

% nths_drop
thf(fact_6286_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( drop @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ).

% drop_Cons'
thf(fact_6287_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_6288_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs ) )
        = ( drop @ A @ I @ Xs ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_6289_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I: nat,J: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I @ J )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_6290_id__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( Xs
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_6291_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,A2: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ Xs @ I @ A2 )
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ A2 @ ( drop @ A @ ( suc @ I ) @ Xs ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_6292_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N @ Xs ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_hd_drop
thf(fact_6293_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R2 ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X ) @ Y )
            = X ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) ) )
            & ( ( take @ A @ I4 @ X )
              = ( take @ A @ I4 @ Y ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X @ I4 ) @ ( nth @ A @ Y @ I4 ) ) @ R2 ) ) ) ) ).

% lexord_take_index_conv
thf(fact_6294_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_6295_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_6296_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb1
thf(fact_6297_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb3
thf(fact_6298_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_6299_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_min @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X )
            & ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% min_less_iff_conj
thf(fact_6300_min__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% min_top2
thf(fact_6301_min__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% min_top
thf(fact_6302_min__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% min_bot2
thf(fact_6303_min__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% min_bot
thf(fact_6304_max__min__same_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ X @ ( ord_min @ A @ X @ Y ) )
          = X ) ) ).

% max_min_same(1)
thf(fact_6305_max__min__same_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y ) @ X )
          = X ) ) ).

% max_min_same(2)
thf(fact_6306_max__min__same_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y ) @ Y )
          = Y ) ) ).

% max_min_same(3)
thf(fact_6307_max__min__same_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( ord_max @ A @ Y @ ( ord_min @ A @ X @ Y ) )
          = Y ) ) ).

% max_min_same(4)
thf(fact_6308_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_Suc_Suc
thf(fact_6309_min__0R,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ N @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_6310_min__0L,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_6311_take__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( take @ A @ M @ Xs ) )
      = ( take @ A @ ( ord_min @ nat @ N @ M ) @ Xs ) ) ).

% take_take
thf(fact_6312_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% hd_remdups_adj
thf(fact_6313_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% min_number_of(1)
thf(fact_6314_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_6315_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_6316_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_6317_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_6318_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_6319_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_6320_hd__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_append2
thf(fact_6321_hd__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% hd_replicate
thf(fact_6322_length__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( take @ A @ N @ Xs ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_take
thf(fact_6323_take__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,X: A] :
      ( ( take @ A @ I @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( ord_min @ nat @ I @ K ) @ X ) ) ).

% take_replicate
thf(fact_6324_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_6325_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% min_number_of(3)
thf(fact_6326_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_6327_hd__take,axiom,
    ! [A: $tType,J: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J )
     => ( ( hd @ A @ ( take @ A @ J @ Xs ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_take
thf(fact_6328_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ A3 @ B3 ) ) ) ) ).

% min_def_raw
thf(fact_6329_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( A2
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ A2 ) @ ( set2 @ A @ A2 ) ) ) ).

% list.set_sel(1)
thf(fact_6330_hd__in__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ Xs ) @ ( set2 @ A @ Xs ) ) ) ).

% hd_in_set
thf(fact_6331_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_6332_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            | ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% min_less_iff_disj
thf(fact_6333_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_6334_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( A3
                = ( ord_min @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_6335_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_6336_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_6337_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X22 ) )
      = X21 ) ).

% list.sel(1)
thf(fact_6338_hd__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( Xs
       != ( nil @ ( list @ A ) ) )
     => ( ( ( hd @ ( list @ A ) @ Xs )
         != ( nil @ A ) )
       => ( ( hd @ A @ ( concat @ A @ Xs ) )
          = ( hd @ A @ ( hd @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_concat
thf(fact_6339_of__int__min,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y: int] :
          ( ( ring_1_of_int @ A @ ( ord_min @ int @ X @ Y ) )
          = ( ord_min @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y ) ) ) ) ).

% of_int_min
thf(fact_6340_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y @ Z2 ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% min_add_distrib_right
thf(fact_6341_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% min_add_distrib_left
thf(fact_6342_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q4: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N ) @ Q4 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q4 ) @ ( times_times @ nat @ N @ Q4 ) ) ) ).

% nat_mult_min_left
thf(fact_6343_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q4: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N @ Q4 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q4 ) ) ) ).

% nat_mult_min_right
thf(fact_6344_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_min_eq_max
thf(fact_6345_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_max_eq_min
thf(fact_6346_hd__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( hd @ A @ Ys2 ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( hd @ A @ Xs ) ) ) ) ).

% hd_append
thf(fact_6347_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
    ? [Ps: list @ A,Xs4: list @ A,Ys7: list @ A] :
      ( ( Xs
        = ( append @ A @ Ps @ Xs4 ) )
      & ( Ys2
        = ( append @ A @ Ps @ Ys7 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys7
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys7 ) ) ) ) ).

% longest_common_prefix
thf(fact_6348_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_min @ A @ X @ Y )
            = Y ) ) ) ).

% min_absorb2
thf(fact_6349_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_min @ A @ X @ Y )
            = X ) ) ) ).

% min_absorb1
thf(fact_6350_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ A3 @ B3 ) ) ) ) ).

% min_def
thf(fact_6351_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            | ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% min_le_iff_disj
thf(fact_6352_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_6353_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_6354_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_min @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% min.absorb_iff2
thf(fact_6355_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_min @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% min.absorb_iff1
thf(fact_6356_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_6357_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ A2 ) ) ).

% min.cobounded1
thf(fact_6358_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( A3
              = ( ord_min @ A @ A3 @ B3 ) ) ) ) ) ).

% min.order_iff
thf(fact_6359_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_6360_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_6361_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_min @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% min.orderI
thf(fact_6362_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( ord_min @ A @ A2 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_6363_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_6364_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X @ Y ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_min
thf(fact_6365_min__diff,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I ) @ ( minus_minus @ nat @ N @ I ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N ) @ I ) ) ).

% min_diff
thf(fact_6366_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ord_min @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% min_diff_distrib_left
thf(fact_6367_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs )
        = ( nth @ A @ Xs @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_6368_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P6 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P6 ) @ ( times_times @ A @ Y @ P6 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P6 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P6 ) @ ( times_times @ A @ Y @ P6 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_6369_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P6 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P6 ) @ ( times_times @ A @ Y @ P6 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P6 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P6 ) @ ( times_times @ A @ Y @ P6 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_6370_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ P6 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P6 @ X ) @ ( times_times @ A @ P6 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ P6 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P6 @ X ) @ ( times_times @ A @ P6 @ Y ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_6371_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ P6 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P6 @ X ) @ ( times_times @ A @ P6 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ P6 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P6 @ X ) @ ( times_times @ A @ P6 @ Y ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_6372_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P6 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P6 ) @ ( divide_divide @ A @ Y @ P6 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P6 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P6 ) @ ( divide_divide @ A @ Y @ P6 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_6373_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P6 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P6 ) @ ( divide_divide @ A @ Y @ P6 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P6 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P6 ) @ ( divide_divide @ A @ Y @ P6 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_6374_Inf__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A,X: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ X @ S2 ) )
                = X ) )
            & ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ X @ S2 ) )
                = ( ord_min @ A @ X @ ( complete_Inf_Inf @ A @ S2 ) ) ) ) ) ) ) ).

% Inf_insert_finite
thf(fact_6375_hd__drop__conv__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( hd @ A @ ( drop @ A @ N @ Xs ) )
        = ( nth @ A @ Xs @ N ) ) ) ).

% hd_drop_conv_nth
thf(fact_6376_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) ) ) ) ).

% mod_exp_eq
thf(fact_6377_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs
         != ( nil @ A ) )
        & ( Xs
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ ( hd @ A @ Xs ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_6378_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_6379_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu3: product_prod @ A @ B] :
          ? [I4: nat] :
            ( ( Uu3
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I4 ) @ ( nth @ B @ Ys2 @ I4 ) ) )
            & ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ) ).

% set_zip
thf(fact_6380_rotate__drop__take,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N3: nat,Xs3: list @ A] : ( append @ A @ ( drop @ A @ ( modulo_modulo @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) @ ( take @ A @ ( modulo_modulo @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) ) ) ) ).

% rotate_drop_take
thf(fact_6381_min__enat__simps_I3_J,axiom,
    ! [Q4: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q4 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_6382_min__enat__simps_I2_J,axiom,
    ! [Q4: extended_enat] :
      ( ( ord_min @ extended_enat @ Q4 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_6383_rotate0,axiom,
    ! [A: $tType] :
      ( ( rotate @ A @ ( zero_zero @ nat ) )
      = ( id @ ( list @ A ) ) ) ).

% rotate0
thf(fact_6384_rotate__is__Nil__conv,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( rotate @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate_is_Nil_conv
thf(fact_6385_set__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate @ A @ N @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate
thf(fact_6386_length__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate @ A @ N @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate
thf(fact_6387_distinct__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate @ A @ N @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rotate
thf(fact_6388_zip__Nil,axiom,
    ! [B: $tType,A: $tType,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( nil @ A ) @ Ys2 )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip_Nil
thf(fact_6389_Nil__eq__zip__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( nil @ ( product_prod @ A @ B ) )
        = ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ B ) ) ) ) ).

% Nil_eq_zip_iff
thf(fact_6390_zip__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( zip @ A @ B @ Xs @ Ys2 )
        = ( nil @ ( product_prod @ A @ B ) ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ B ) ) ) ) ).

% zip_eq_Nil_iff
thf(fact_6391_rotate__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ ( suc @ N ) @ Xs )
      = ( rotate1 @ A @ ( rotate @ A @ N @ Xs ) ) ) ).

% rotate_Suc
thf(fact_6392_rotate__length01,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N @ Xs )
        = Xs ) ) ).

% rotate_length01
thf(fact_6393_rotate__id,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N @ Xs )
        = Xs ) ) ).

% rotate_id
thf(fact_6394_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I: nat,X: A,J: nat,Y: B] :
      ( ( zip @ A @ B @ ( replicate @ A @ I @ X ) @ ( replicate @ B @ J @ Y ) )
      = ( replicate @ ( product_prod @ A @ B ) @ ( ord_min @ nat @ I @ J ) @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_replicate
thf(fact_6395_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Y: B,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys2 ) )
      = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% zip_Cons_Cons
thf(fact_6396_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Us: list @ B,Ys2: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Us ) )
     => ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys2 ) @ ( append @ B @ Us @ Vs ) )
        = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Us ) @ ( zip @ A @ B @ Ys2 @ Vs ) ) ) ) ).

% zip_append
thf(fact_6397_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ).

% length_zip
thf(fact_6398_nth__zip,axiom,
    ! [A: $tType,B: $tType,I: nat,Xs: list @ A,Ys2: list @ B] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ B ) @ Ys2 ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) @ I )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I ) @ ( nth @ B @ Ys2 @ I ) ) ) ) ) ).

% nth_zip
thf(fact_6399_inf__int__def,axiom,
    ( ( inf_inf @ int )
    = ( ord_min @ int ) ) ).

% inf_int_def
thf(fact_6400_take__zip,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys2: list @ B] :
      ( ( take @ ( product_prod @ A @ B ) @ N @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( zip @ A @ B @ ( take @ A @ N @ Xs ) @ ( take @ B @ N @ Ys2 ) ) ) ).

% take_zip
thf(fact_6401_rotate__def,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N3: nat] : ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N3 @ ( rotate1 @ A ) ) ) ) ).

% rotate_def
thf(fact_6402_zip_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A] :
      ( ( zip @ A @ B @ Xs @ ( nil @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip.simps(1)
thf(fact_6403_rotate__rotate,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ M @ ( rotate @ A @ N @ Xs ) )
      = ( rotate @ A @ ( plus_plus @ nat @ M @ N ) @ Xs ) ) ).

% rotate_rotate
thf(fact_6404_rotate1__rotate__swap,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate1 @ A @ ( rotate @ A @ N @ Xs ) )
      = ( rotate @ A @ N @ ( rotate1 @ A @ Xs ) ) ) ).

% rotate1_rotate_swap
thf(fact_6405_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I: nat,X: A,Ys2: list @ B,Y: B] :
      ( ( zip @ A @ B @ ( list_update @ A @ Xs @ I @ X ) @ ( list_update @ B @ Ys2 @ I @ Y ) )
      = ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) @ I @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_update
thf(fact_6406_drop__zip,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys2: list @ B] :
      ( ( drop @ ( product_prod @ A @ B ) @ N @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( zip @ A @ B @ ( drop @ A @ N @ Xs ) @ ( drop @ B @ N @ Ys2 ) ) ) ).

% drop_zip
thf(fact_6407_distinct__zipI1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% distinct_zipI1
thf(fact_6408_distinct__zipI2,axiom,
    ! [B: $tType,A: $tType,Ys2: list @ A,Xs: list @ B] :
      ( ( distinct @ A @ Ys2 )
     => ( distinct @ ( product_prod @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys2 ) ) ) ).

% distinct_zipI2
thf(fact_6409_rotate__append,axiom,
    ! [A: $tType,L: list @ A,Q4: list @ A] :
      ( ( rotate @ A @ ( size_size @ ( list @ A ) @ L ) @ ( append @ A @ L @ Q4 ) )
      = ( append @ A @ Q4 @ L ) ) ).

% rotate_append
thf(fact_6410_rotate__conv__mod,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N3: nat,Xs3: list @ A] : ( rotate @ A @ ( modulo_modulo @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) ) ) ).

% rotate_conv_mod
thf(fact_6411_hd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys2
         != ( nil @ B ) )
       => ( ( hd @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
          = ( product_Pair @ A @ B @ ( hd @ A @ Xs ) @ ( hd @ B @ Ys2 ) ) ) ) ) ).

% hd_zip
thf(fact_6412_zip__same,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs @ Xs ) ) )
      = ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
        & ( A2 = B2 ) ) ) ).

% zip_same
thf(fact_6413_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys2: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
     => ~ ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ~ ( member @ B @ Y @ ( set2 @ B @ Ys2 ) ) ) ) ).

% in_set_zipE
thf(fact_6414_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,Xs: list @ A,Ys2: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_zip_leftD
thf(fact_6415_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys2: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
     => ( member @ B @ Y @ ( set2 @ B @ Ys2 ) ) ) ).

% set_zip_rightD
thf(fact_6416_zip__obtain__same__length,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,P: ( list @ ( product_prod @ A @ B ) ) > $o] :
      ( ! [Zs2: list @ A,Ws2: list @ B,N2: nat] :
          ( ( ( size_size @ ( list @ A ) @ Zs2 )
            = ( size_size @ ( list @ B ) @ Ws2 ) )
         => ( ( N2
              = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) )
           => ( ( Zs2
                = ( take @ A @ N2 @ Xs ) )
             => ( ( Ws2
                  = ( take @ B @ N2 @ Ys2 ) )
               => ( P @ ( zip @ A @ B @ Zs2 @ Ws2 ) ) ) ) ) )
     => ( P @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% zip_obtain_same_length
thf(fact_6417_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,Xy: product_prod @ A @ B,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( zip @ A @ B @ Xs @ Ys2 )
        = ( cons @ ( product_prod @ A @ B ) @ Xy @ Xys2 ) )
     => ~ ! [X2: A,Xs4: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Xs4 ) )
           => ! [Y2: B,Ys7: list @ B] :
                ( ( Ys2
                  = ( cons @ B @ Y2 @ Ys7 ) )
               => ( ( Xy
                    = ( product_Pair @ A @ B @ X2 @ Y2 ) )
                 => ( Xys2
                   != ( zip @ A @ B @ Xs4 @ Ys7 ) ) ) ) ) ) ).

% zip_eq_ConsE
thf(fact_6418_rotate__add,axiom,
    ! [A: $tType,M: nat,N: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M @ N ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M ) @ ( rotate @ A @ N ) ) ) ).

% rotate_add
thf(fact_6419_list__eq__iff__zip__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z: list @ A] : ( Y3 = Z ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [X3: product_prod @ A @ A] :
                ( ( member @ ( product_prod @ A @ A ) @ X3 @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs3 @ Ys3 ) ) )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y3: A,Z: A] : ( Y3 = Z )
                  @ X3 ) ) ) ) ) ).

% list_eq_iff_zip_eq
thf(fact_6420_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,Y: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( member @ B @ Y @ ( set2 @ B @ Ys2 ) )
       => ~ ! [X2: A] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ) ) ).

% in_set_impl_in_set_zip2
thf(fact_6421_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ~ ! [Y2: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ) ) ).

% in_set_impl_in_set_zip1
thf(fact_6422_concat__injective,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys2: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xs )
        = ( concat @ A @ Ys2 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys2 ) )
       => ( ! [X2: product_prod @ ( list @ A ) @ ( list @ A )] :
              ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X2 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) ) )
             => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
                @ ^ [Y4: list @ A,Z5: list @ A] :
                    ( ( size_size @ ( list @ A ) @ Y4 )
                    = ( size_size @ ( list @ A ) @ Z5 ) )
                @ X2 ) )
         => ( Xs = Ys2 ) ) ) ) ).

% concat_injective
thf(fact_6423_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys2: list @ ( list @ A )] :
      ( ! [X2: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X2 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) ) )
         => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Y4: list @ A,Z5: list @ A] :
                ( ( size_size @ ( list @ A ) @ Y4 )
                = ( size_size @ ( list @ A ) @ Z5 ) )
            @ X2 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys2 ) )
       => ( ( ( concat @ A @ Xs )
            = ( concat @ A @ Ys2 ) )
          = ( Xs = Ys2 ) ) ) ) ).

% concat_eq_concat_iff
thf(fact_6424_zip__append1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ B] :
      ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys2 ) @ Zs )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ ( take @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) @ ( zip @ A @ B @ Ys2 @ ( drop @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% zip_append1
thf(fact_6425_zip__append2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( append @ B @ Ys2 @ Zs ) )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys2 ) @ Xs ) @ Ys2 ) @ ( zip @ A @ B @ ( drop @ A @ ( size_size @ ( list @ B ) @ Ys2 ) @ Xs ) @ Zs ) ) ) ).

% zip_append2
thf(fact_6426_nth__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,M: nat] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate @ A @ M @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate
thf(fact_6427_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rotate @ A @ N @ Xs ) )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_rotate_conv_nth
thf(fact_6428_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys2 ) @ ( listrel @ A @ B @ R2 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys2 ) )
        & ! [X3: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ X3 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y4: A,Z5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y4 @ Z5 ) @ R2 )
              @ X3 ) ) ) ) ).

% listrel_iff_zip
thf(fact_6429_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys2: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( cons @ B @ Y @ Ys2 ) )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ A @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Z5: A,Zs3: list @ A] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Z5 @ Y ) @ ( zip @ A @ B @ Zs3 @ Ys2 ) )
        @ Xs ) ) ).

% zip_Cons
thf(fact_6430_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) ) ).

% listrel_rtrancl_refl
thf(fact_6431_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H: B > C,F15: B,F24: A > ( list @ A ) > B,List: list @ A] :
      ( ( H @ ( case_list @ B @ A @ F15 @ F24 @ List ) )
      = ( case_list @ C @ A @ ( H @ F15 )
        @ ^ [X17: A,X25: list @ A] : ( H @ ( F24 @ X17 @ X25 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_6432_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F15: B,F24: A > ( list @ A ) > B,X21: A,X22: list @ A] :
      ( ( case_list @ B @ A @ F15 @ F24 @ ( cons @ A @ X21 @ X22 ) )
      = ( F24 @ X21 @ X22 ) ) ).

% list.simps(5)
thf(fact_6433_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F15: B,F24: A > ( list @ A ) > B] :
      ( ( case_list @ B @ A @ F15 @ F24 @ ( nil @ A ) )
      = F15 ) ).

% list.simps(4)
thf(fact_6434_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) @ ( listrel @ A @ B @ R2 ) ) ).

% listrel.Nil
thf(fact_6435_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xs ) @ ( listrel @ A @ B @ R2 ) )
     => ( Xs
        = ( nil @ B ) ) ) ).

% listrel_Nil1
thf(fact_6436_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( nil @ B ) ) @ ( listrel @ A @ B @ R2 ) )
     => ( Xs
        = ( nil @ A ) ) ) ).

% listrel_Nil2
thf(fact_6437_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys2 ) @ ( listrel @ A @ B @ R2 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) ) ) ).

% listrel_eq_len
thf(fact_6438_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),Zs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) ) ) ) ).

% listrel_rtrancl_trans
thf(fact_6439_listrel__mono,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( listrel @ A @ B @ R2 ) @ ( listrel @ A @ B @ S ) ) ) ).

% listrel_mono
thf(fact_6440_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,R2: set @ ( product_prod @ A @ B ),Xs: list @ A,Ys2: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ R2 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys2 ) @ ( listrel @ A @ B @ R2 ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys2 ) ) @ ( listrel @ A @ B @ R2 ) ) ) ) ).

% listrel.Cons
thf(fact_6441_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y: A,Ys2: list @ A,Xs: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ Y @ Ys2 ) @ Xs ) @ ( listrel @ A @ B @ R2 ) )
     => ~ ! [Y2: B,Ys4: list @ B] :
            ( ( Xs
              = ( cons @ B @ Y2 @ Ys4 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ Y2 ) @ R2 )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Ys2 @ Ys4 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ) ).

% listrel_Cons1
thf(fact_6442_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys2: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( cons @ B @ Y @ Ys2 ) ) @ ( listrel @ A @ B @ R2 ) )
     => ~ ! [X2: A,Xs2: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Xs2 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R2 )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys2 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ) ).

% listrel_Cons2
thf(fact_6443_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) ) ) ).

% listrel_reflcl_if_listrel1
thf(fact_6444_listrel__rtrancl__eq__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) )
      = ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel_rtrancl_eq_rtrancl_listrel1
thf(fact_6445_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel @ A @ A @ R2 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ) ).

% rtrancl_listrel1_if_listrel
thf(fact_6446_remdups__adj__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X @ ( nil @ A ) )
        @ ^ [Y4: A,Xs3: list @ A] : ( if @ ( list @ A ) @ ( X = Y4 ) @ ( cons @ A @ Y4 @ Xs3 ) @ ( cons @ A @ X @ ( cons @ A @ Y4 @ Xs3 ) ) )
        @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_Cons
thf(fact_6447_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A12: list @ A,A23: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A12 @ A23 ) @ ( listrel @ A @ B @ R2 ) )
     => ( ( ( A12
            = ( nil @ A ) )
         => ( A23
           != ( nil @ B ) ) )
       => ~ ! [X2: A,Y2: B,Xs2: list @ A] :
              ( ( A12
                = ( cons @ A @ X2 @ Xs2 ) )
             => ! [Ys4: list @ B] :
                  ( ( A23
                    = ( cons @ B @ Y2 @ Ys4 ) )
                 => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R2 )
                   => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys4 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ) ) ) ).

% listrel.cases
thf(fact_6448_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A12: list @ A,A23: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A12 @ A23 ) @ ( listrel @ A @ B @ R2 ) )
      = ( ( ( A12
            = ( nil @ A ) )
          & ( A23
            = ( nil @ B ) ) )
        | ? [X3: A,Y4: B,Xs3: list @ A,Ys3: list @ B] :
            ( ( A12
              = ( cons @ A @ X3 @ Xs3 ) )
            & ( A23
              = ( cons @ B @ Y4 @ Ys3 ) )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ R2 )
            & ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys3 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ) ).

% listrel.simps
thf(fact_6449_listrel__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel_subset_rtrancl_listrel1
thf(fact_6450_listrel__iff__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys2 ) @ ( listrel @ A @ B @ R2 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys2 ) )
        & ! [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( nth @ A @ Xs @ N3 ) @ ( nth @ B @ Ys2 @ N3 ) ) @ R2 ) ) ) ) ).

% listrel_iff_nth
thf(fact_6451_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys2 )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ B @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Y4: B,Ys3: list @ B] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y4 ) @ ( zip @ A @ B @ Xs @ Ys3 ) )
        @ Ys2 ) ) ).

% zip_Cons1
thf(fact_6452_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( min_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( case_list @ A @ A @ X
            @ ^ [A3: A,List2: list @ A] : ( ord_min @ A @ X @ ( min_list @ A @ Xs ) )
            @ Xs ) ) ) ).

% min_list.simps
thf(fact_6453_listrel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrel @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ B ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ B ) @ $o
              @ ( listrelp @ A @ B
                @ ^ [X3: A,Y4: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ R5 ) ) ) ) ) ) ).

% listrel_def
thf(fact_6454_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu3: A,Uv3: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_6455_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu3: A,Uv3: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_6456_listrelp_OCons,axiom,
    ! [A: $tType,B: $tType,R2: A > B > $o,X: A,Y: B,Xs: list @ A,Ys2: list @ B] :
      ( ( R2 @ X @ Y )
     => ( ( listrelp @ A @ B @ R2 @ Xs @ Ys2 )
       => ( listrelp @ A @ B @ R2 @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys2 ) ) ) ) ).

% listrelp.Cons
thf(fact_6457_listrelp_ONil,axiom,
    ! [A: $tType,B: $tType,R2: A > B > $o] : ( listrelp @ A @ B @ R2 @ ( nil @ A ) @ ( nil @ B ) ) ).

% listrelp.Nil
thf(fact_6458_listrelp_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R5: A > B > $o,A1: list @ A,A22: list @ B] :
            ( ( ( A1
                = ( nil @ A ) )
              & ( A22
                = ( nil @ B ) ) )
            | ? [X3: A,Y4: B,Xs3: list @ A,Ys3: list @ B] :
                ( ( A1
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A22
                  = ( cons @ B @ Y4 @ Ys3 ) )
                & ( R5 @ X3 @ Y4 )
                & ( listrelp @ A @ B @ R5 @ Xs3 @ Ys3 ) ) ) ) ) ).

% listrelp.simps
thf(fact_6459_listrelp_Ocases,axiom,
    ! [A: $tType,B: $tType,R2: A > B > $o,A12: list @ A,A23: list @ B] :
      ( ( listrelp @ A @ B @ R2 @ A12 @ A23 )
     => ( ( ( A12
            = ( nil @ A ) )
         => ( A23
           != ( nil @ B ) ) )
       => ~ ! [X2: A,Y2: B,Xs2: list @ A] :
              ( ( A12
                = ( cons @ A @ X2 @ Xs2 ) )
             => ! [Ys4: list @ B] :
                  ( ( A23
                    = ( cons @ B @ Y2 @ Ys4 ) )
                 => ( ( R2 @ X2 @ Y2 )
                   => ~ ( listrelp @ A @ B @ R2 @ Xs2 @ Ys4 ) ) ) ) ) ) ).

% listrelp.cases
thf(fact_6460_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B )] :
      ( ( listrelp @ A @ B
        @ ^ [X3: A,Y4: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ R2 ) )
      = ( ^ [X3: list @ A,Y4: list @ B] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ X3 @ Y4 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ).

% listrelp_listrel_eq
thf(fact_6461_min__list_Oelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A,Y: A] :
          ( ( ( min_list @ A @ X )
            = Y )
         => ( ! [X2: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X2 @ Xs2 ) )
               => ( Y
                 != ( case_list @ A @ A @ X2
                    @ ^ [A3: A,List2: list @ A] : ( ord_min @ A @ X2 @ ( min_list @ A @ Xs2 ) )
                    @ Xs2 ) ) )
           => ~ ( ( X
                  = ( nil @ A ) )
               => ( Y
                 != ( undefined @ A ) ) ) ) ) ) ).

% min_list.elims
thf(fact_6462_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F3: A > nat,Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F3 @ ( hd @ A @ Xs3 ) ) @ ( size_list @ A @ F3 @ ( tl @ A @ Xs3 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_6463_tl__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys2 ) ) ) ).

% tl_append2
thf(fact_6464_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( cons @ A @ X @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) ).

% remdups_adj_Cons_alt
thf(fact_6465_length__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_6466_list_Ocollapse,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) ).

% list.collapse
thf(fact_6467_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) ).

% hd_Cons_tl
thf(fact_6468_tl__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( tl @ A @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ).

% tl_replicate
thf(fact_6469_list_Osel_I2_J,axiom,
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% list.sel(2)
thf(fact_6470_distinct__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( tl @ A @ Xs ) ) ) ).

% distinct_tl
thf(fact_6471_take__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_tl
thf(fact_6472_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X22 ) )
      = X22 ) ).

% list.sel(3)
thf(fact_6473_tl__Nil,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X3: A] :
            ( Xs
            = ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) ).

% tl_Nil
thf(fact_6474_Nil__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X3: A] :
            ( Xs
            = ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) ).

% Nil_tl
thf(fact_6475_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A2: list @ A,X: A] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( member @ A @ X @ ( set2 @ A @ ( tl @ A @ A2 ) ) )
       => ( member @ A @ X @ ( set2 @ A @ A2 ) ) ) ) ).

% list.set_sel(2)
thf(fact_6476_tl__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( tl @ A @ ( drop @ A @ N @ Xs ) )
      = ( drop @ A @ N @ ( tl @ A @ Xs ) ) ) ).

% tl_drop
thf(fact_6477_drop__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ Xs )
      = ( drop @ A @ N @ ( tl @ A @ Xs ) ) ) ).

% drop_Suc
thf(fact_6478_list_Oexpand,axiom,
    ! [A: $tType,List: list @ A,List3: list @ A] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List3
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List3
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List3 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List3 ) ) ) ) )
       => ( List = List3 ) ) ) ).

% list.expand
thf(fact_6479_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X213: A,X223: list @ A] : X223 ) ) ).

% tl_def
thf(fact_6480_tl__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys2 )
        @ ^ [Z5: A,Zs3: list @ A] : ( append @ A @ Zs3 @ Ys2 )
        @ Xs ) ) ).

% tl_append
thf(fact_6481_hd__def,axiom,
    ! [A: $tType] :
      ( ( hd @ A )
      = ( case_list @ A @ A @ ( undefined @ A )
        @ ^ [X213: A,X223: list @ A] : X213 ) ) ).

% hd_def
thf(fact_6482_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ).

% list.exhaust_sel
thf(fact_6483_tl__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( tl @ A @ ( take @ A @ N @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( tl @ A @ Xs ) ) ) ).

% tl_take
thf(fact_6484_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F17: B,F25: A > ( list @ A ) > B,List2: list @ A] :
            ( if @ B
            @ ( List2
              = ( nil @ A ) )
            @ F17
            @ ( F25 @ ( hd @ A @ List2 ) @ ( tl @ A @ List2 ) ) ) ) ) ).

% list.case_eq_if
thf(fact_6485_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs3 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_6486_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( suc @ N ) ) ) ) ).

% nth_tl
thf(fact_6487_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list @ A,X: A,Xs_2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs_2 ) ) ) ) ) ).

% remdups_adj_append
thf(fact_6488_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z2: A,Zs: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs @ Ys2 ) )
      = ( ( ( Xs
           != ( nil @ A ) )
          & ( ( hd @ A @ Xs )
            = Z2 )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ ( tl @ A @ Xs ) @ Ys2 ) ) )
        | ( ( Ys2
           != ( nil @ A ) )
          & ( ( hd @ A @ Ys2 )
            = Z2 )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ ( tl @ A @ Ys2 ) ) ) ) ) ) ).

% Cons_in_shuffles_iff
thf(fact_6489_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F15: B,F24: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F15 @ F24 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P @ F15 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P @ ( F24 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ).

% list.split_sel
thf(fact_6490_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F15: B,F24: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F15 @ F24 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P @ F15 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P @ ( F24 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) ).

% list.split_sel_asm
thf(fact_6491_take__Suc,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N ) @ Xs )
        = ( cons @ A @ ( hd @ A @ Xs ) @ ( take @ A @ N @ ( tl @ A @ Xs ) ) ) ) ) ).

% take_Suc
thf(fact_6492_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) ).

% rotate1_hd_tl
thf(fact_6493_min__list_Opelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A,Y: A] :
          ( ( ( min_list @ A @ X )
            = Y )
         => ( ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ X )
           => ( ! [X2: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X2 @ Xs2 ) )
                 => ( ( Y
                      = ( case_list @ A @ A @ X2
                        @ ^ [A3: A,List2: list @ A] : ( ord_min @ A @ X2 @ ( min_list @ A @ Xs2 ) )
                        @ Xs2 ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( cons @ A @ X2 @ Xs2 ) ) ) )
             => ~ ( ( X
                    = ( nil @ A ) )
                 => ( ( Y
                      = ( undefined @ A ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( nil @ A ) ) ) ) ) ) ) ) ).

% min_list.pelims
thf(fact_6494_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa )
            = Y )
         => ( ! [X2: A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ ( nil @ A ) ) )
               => ( Y != X2 ) )
           => ( ! [X2: A,Y2: A,Zs2: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs2 ) ) )
                 => ( Y
                   != ( if @ A @ ( ord_less_eq @ B @ ( X @ X2 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) @ X2 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ( Y
                   != ( undefined @ A ) ) ) ) ) ) ) ).

% arg_min_list.elims
thf(fact_6495_arg__min__list_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( nil @ A ) ) )
          = X ) ) ).

% arg_min_list.simps(1)
thf(fact_6496_arg__min__list__in,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [Xs: list @ A,F2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( member @ A @ ( arg_min_list @ A @ B @ F2 @ Xs ) @ ( set2 @ A @ Xs ) ) ) ) ).

% arg_min_list_in
thf(fact_6497_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A,Y: A,Zs: list @ A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( if @ A @ ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) @ X @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% arg_min_list.simps(2)
thf(fact_6498_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa )
            = Y )
         => ( ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ Xa ) )
           => ( ! [X2: A] :
                  ( ( Xa
                    = ( cons @ A @ X2 @ ( nil @ A ) ) )
                 => ( ( Y = X2 )
                   => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) )
             => ( ! [X2: A,Y2: A,Zs2: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs2 ) ) )
                   => ( ( Y
                        = ( if @ A @ ( ord_less_eq @ B @ ( X @ X2 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) @ X2 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y2 @ Zs2 ) ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) ) )
               => ~ ( ( Xa
                      = ( nil @ A ) )
                   => ( ( Y
                        = ( undefined @ A ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
thf(fact_6499_dual__max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( max @ A
          @ ^ [X3: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X3 ) )
        = ( ord_min @ A ) ) ) ).

% dual_max
thf(fact_6500_ord_Omax__def,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( ^ [Less_eq: A > A > $o,A3: A,B3: A] : ( if @ A @ ( Less_eq @ A3 @ B3 ) @ B3 @ A3 ) ) ) ).

% ord.max_def
thf(fact_6501_ord_Omax_Ocong,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( max @ A ) ) ).

% ord.max.cong
thf(fact_6502_listrel1__subset__listrel,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),R3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ R3 )
     => ( ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R3 )
       => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R2 ) @ ( listrel @ A @ A @ R3 ) ) ) ) ).

% listrel1_subset_listrel
thf(fact_6503_filterlim__finite__subsets__at__top,axiom,
    ! [A: $tType,B: $tType,F2: A > ( set @ B ),A5: set @ B,F4: filter @ A] :
      ( ( filterlim @ A @ ( set @ B ) @ F2 @ ( finite5375528669736107172at_top @ B @ A5 ) @ F4 )
      = ( ! [X7: set @ B] :
            ( ( ( finite_finite @ B @ X7 )
              & ( ord_less_eq @ ( set @ B ) @ X7 @ A5 ) )
           => ( eventually @ A
              @ ^ [Y4: A] :
                  ( ( finite_finite @ B @ ( F2 @ Y4 ) )
                  & ( ord_less_eq @ ( set @ B ) @ X7 @ ( F2 @ Y4 ) )
                  & ( ord_less_eq @ ( set @ B ) @ ( F2 @ Y4 ) @ A5 ) )
              @ F4 ) ) ) ) ).

% filterlim_finite_subsets_at_top
thf(fact_6504_eventually__finite__subsets__at__top__weakI,axiom,
    ! [A: $tType,A5: set @ A,P: ( set @ A ) > $o] :
      ( ! [X9: set @ A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( ord_less_eq @ ( set @ A ) @ X9 @ A5 )
           => ( P @ X9 ) ) )
     => ( eventually @ ( set @ A ) @ P @ ( finite5375528669736107172at_top @ A @ A5 ) ) ) ).

% eventually_finite_subsets_at_top_weakI
thf(fact_6505_refl__on__def,axiom,
    ! [A: $tType] :
      ( ( refl_on @ A )
      = ( ^ [A7: set @ A,R5: set @ ( product_prod @ A @ A )] :
            ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
              @ ( product_Sigma @ A @ A @ A7
                @ ^ [Uu3: A] : A7 ) )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ A7 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R5 ) ) ) ) ) ).

% refl_on_def
thf(fact_6506_refl__onI,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2
        @ ( product_Sigma @ A @ A @ A5
          @ ^ [Uu3: A] : A5 ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ A5 )
           => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 ) )
       => ( refl_on @ A @ A5 @ R2 ) ) ) ).

% refl_onI
thf(fact_6507_eventually__finite__subsets__at__top,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,A5: set @ A] :
      ( ( eventually @ ( set @ A ) @ P @ ( finite5375528669736107172at_top @ A @ A5 ) )
      = ( ? [X7: set @ A] :
            ( ( finite_finite @ A @ X7 )
            & ( ord_less_eq @ ( set @ A ) @ X7 @ A5 )
            & ! [Y7: set @ A] :
                ( ( ( finite_finite @ A @ Y7 )
                  & ( ord_less_eq @ ( set @ A ) @ X7 @ Y7 )
                  & ( ord_less_eq @ ( set @ A ) @ Y7 @ A5 ) )
               => ( P @ Y7 ) ) ) ) ) ).

% eventually_finite_subsets_at_top
thf(fact_6508_finite__subsets__at__top__def,axiom,
    ! [A: $tType] :
      ( ( finite5375528669736107172at_top @ A )
      = ( ^ [A7: set @ A] :
            ( complete_Inf_Inf @ ( filter @ ( set @ A ) )
            @ ( image @ ( set @ A ) @ ( filter @ ( set @ A ) )
              @ ^ [X7: set @ A] :
                  ( principal @ ( set @ A )
                  @ ( collect @ ( set @ A )
                    @ ^ [Y7: set @ A] :
                        ( ( finite_finite @ A @ Y7 )
                        & ( ord_less_eq @ ( set @ A ) @ X7 @ Y7 )
                        & ( ord_less_eq @ ( set @ A ) @ Y7 @ A7 ) ) ) )
              @ ( collect @ ( set @ A )
                @ ^ [X7: set @ A] :
                    ( ( finite_finite @ A @ X7 )
                    & ( ord_less_eq @ ( set @ A ) @ X7 @ A7 ) ) ) ) ) ) ) ).

% finite_subsets_at_top_def
thf(fact_6509_card__Min__le__sum,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ ( finite_card @ A @ A5 ) @ ( lattic643756798350308766er_Min @ nat @ ( image @ A @ nat @ F2 @ A5 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) ) ) ).

% card_Min_le_sum
thf(fact_6510_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_6511_remdups__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( remdups @ nat @ ( upt @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% remdups_upt
thf(fact_6512_tl__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( tl @ nat @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ N ) ) ).

% tl_upt
thf(fact_6513_hd__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( hd @ nat @ ( upt @ I @ J ) )
        = I ) ) ).

% hd_upt
thf(fact_6514_drop__upt,axiom,
    ! [M: nat,I: nat,J: nat] :
      ( ( drop @ nat @ M @ ( upt @ I @ J ) )
      = ( upt @ ( plus_plus @ nat @ I @ M ) @ J ) ) ).

% drop_upt
thf(fact_6515_length__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I @ J ) )
      = ( minus_minus @ nat @ J @ I ) ) ).

% length_upt
thf(fact_6516_Min__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Min_singleton
thf(fact_6517_take__upt,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ M ) @ N )
     => ( ( take @ nat @ M @ ( upt @ I @ N ) )
        = ( upt @ I @ ( plus_plus @ nat @ I @ M ) ) ) ) ).

% take_upt
thf(fact_6518_upt__conv__Nil,axiom,
    ! [J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( upt @ I @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_6519_sorted__list__of__set__range,axiom,
    ! [M: nat,N: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% sorted_list_of_set_range
thf(fact_6520_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_6521_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Min_gr_iff
thf(fact_6522_upt__eq__Nil__conv,axiom,
    ! [I: nat,J: nat] :
      ( ( ( upt @ I @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I ) ) ) ).

% upt_eq_Nil_conv
thf(fact_6523_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ B,C2: A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A5 ) )
              = C2 ) ) ) ) ).

% Min_const
thf(fact_6524_nth__upt,axiom,
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I @ J ) @ K )
        = ( plus_plus @ nat @ I @ K ) ) ) ).

% nth_upt
thf(fact_6525_Min__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ).

% Min_insert
thf(fact_6526_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N3: nat,M2: nat] : ( set2 @ nat @ ( upt @ ( suc @ N3 ) @ M2 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_6527_upt__0,axiom,
    ! [I: nat] :
      ( ( upt @ I @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_6528_distinct__upt,axiom,
    ! [I: nat,J: nat] : ( distinct @ nat @ ( upt @ I @ J ) ) ).

% distinct_upt
thf(fact_6529_Min_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ A2 ) ) ) ) ).

% Min.coboundedI
thf(fact_6530_Min__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [Y2: A] :
                ( ( member @ A @ Y2 @ A5 )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ( member @ A @ X @ A5 )
             => ( ( lattic643756798350308766er_Min @ A @ A5 )
                = X ) ) ) ) ) ).

% Min_eqI
thf(fact_6531_Min__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ X ) ) ) ) ).

% Min_le
thf(fact_6532_Min__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ A5 ) ) ) ) ).

% Min_in
thf(fact_6533_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N3: nat,M2: nat] : ( set2 @ nat @ ( upt @ ( suc @ N3 ) @ ( suc @ M2 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_6534_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N: nat,Ns: list @ nat,Q4: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N @ Ns ) )
        = ( upt @ M @ Q4 ) )
      = ( ( cons @ nat @ N @ Ns )
        = ( upt @ ( suc @ M ) @ Q4 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_6535_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N3: nat,M2: nat] : ( set2 @ nat @ ( upt @ N3 @ ( suc @ M2 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_6536_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N3: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% atLeast_upt
thf(fact_6537_atLeastLessThan__upt,axiom,
    ( ( set_or7035219750837199246ssThan @ nat )
    = ( ^ [I4: nat,J3: nat] : ( set2 @ nat @ ( upt @ I4 @ J3 ) ) ) ) ).

% atLeastLessThan_upt
thf(fact_6538_Min_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) )
              = ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ).

% Min.in_idem
thf(fact_6539_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N3: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N3 ) ) ) ) ) ).

% atMost_upto
thf(fact_6540_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ( ord_less_eq @ A @ X @ A4 ) )
             => ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ).

% Min.boundedI
thf(fact_6541_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) )
             => ! [A18: A] :
                  ( ( member @ A @ A18 @ A5 )
                 => ( ord_less_eq @ A @ X @ A18 ) ) ) ) ) ) ).

% Min.boundedE
thf(fact_6542_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,M: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798350308766er_Min @ A @ A5 ) )
              = ( ( member @ A @ M @ A5 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less_eq @ A @ M @ X3 ) ) ) ) ) ) ) ).

% eq_Min_iff
thf(fact_6543_Min__le__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ X )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                    & ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Min_le_iff
thf(fact_6544_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,M: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798350308766er_Min @ A @ A5 )
                = M )
              = ( ( member @ A @ M @ A5 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less_eq @ A @ M @ X3 ) ) ) ) ) ) ) ).

% Min_eq_iff
thf(fact_6545_Min__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ X )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                    & ( ord_less @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Min_less_iff
thf(fact_6546_Min__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [B4: A] :
                ( ( member @ A @ B4 @ A5 )
               => ( ord_less_eq @ A @ A2 @ B4 ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ A2 @ A5 ) )
              = A2 ) ) ) ) ).

% Min_insert2
thf(fact_6547_cInf__eq__Min,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = ( lattic643756798350308766er_Min @ A @ X8 ) ) ) ) ) ).

% cInf_eq_Min
thf(fact_6548_Min__Inf,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ A5 )
              = ( complete_Inf_Inf @ A @ A5 ) ) ) ) ) ).

% Min_Inf
thf(fact_6549_upt__conv__Cons,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( upt @ I @ J )
        = ( cons @ nat @ I @ ( upt @ ( suc @ I ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_6550_enumerate__eq__zip,axiom,
    ! [A: $tType] :
      ( ( enumerate @ A )
      = ( ^ [N3: nat,Xs3: list @ A] : ( zip @ nat @ A @ ( upt @ N3 @ ( plus_plus @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) @ Xs3 ) ) ) ).

% enumerate_eq_zip
thf(fact_6551_upt__add__eq__append,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( upt @ I @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_6552_min__list__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( min_list @ A @ Xs )
            = ( lattic643756798350308766er_Min @ A @ ( set2 @ A @ Xs ) ) ) ) ) ).

% min_list_Min
thf(fact_6553_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ B6 ) @ ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ).

% Min.subset_imp
thf(fact_6554_Min__antimono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M5: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M5 @ N4 )
         => ( ( M5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ N4 ) @ ( lattic643756798350308766er_Min @ A @ M5 ) ) ) ) ) ) ).

% Min_antimono
thf(fact_6555_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H: A > A,N4: set @ A] :
          ( ! [X2: A,Y2: A] :
              ( ( H @ ( ord_min @ A @ X2 @ Y2 ) )
              = ( ord_min @ A @ ( H @ X2 ) @ ( H @ Y2 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H @ ( lattic643756798350308766er_Min @ A @ N4 ) )
                = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ H @ N4 ) ) ) ) ) ) ) ).

% hom_Min_commute
thf(fact_6556_Min_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
             => ( ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ B6 ) @ ( lattic643756798350308766er_Min @ A @ A5 ) )
                = ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ).

% Min.subset
thf(fact_6557_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y2: A] : ( member @ A @ ( ord_min @ A @ X2 @ Y2 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Min.closed
thf(fact_6558_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ) ).

% Min.insert_not_elem
thf(fact_6559_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798350308766er_Min @ A @ A5 ) )
                = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ) ) ).

% mono_Min_commute
thf(fact_6560_Min_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
                  = ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ ( lattic643756798350308766er_Min @ A @ B6 ) ) ) ) ) ) ) ) ).

% Min.union
thf(fact_6561_upt__eq__Cons__conv,axiom,
    ! [I: nat,J: nat,X: nat,Xs: list @ nat] :
      ( ( ( upt @ I @ J )
        = ( cons @ nat @ X @ Xs ) )
      = ( ( ord_less @ nat @ I @ J )
        & ( I = X )
        & ( ( upt @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) @ J )
          = Xs ) ) ) ).

% upt_eq_Cons_conv
thf(fact_6562_upt__rec,axiom,
    ( upt
    = ( ^ [I4: nat,J3: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I4 @ J3 ) @ ( cons @ nat @ I4 @ ( upt @ ( suc @ I4 ) @ J3 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_6563_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [X3: B] : ( plus_plus @ A @ ( F2 @ X3 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798350308766er_Min @ A @ ( image @ B @ A @ F2 @ S2 ) ) @ K ) ) ) ) ) ).

% Min_add_commute
thf(fact_6564_f__arg__min__list__f,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [Xs: list @ A,F2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( F2 @ ( arg_min_list @ A @ B @ F2 @ Xs ) )
            = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ ( set2 @ A @ Xs ) ) ) ) ) ) ).

% f_arg_min_list_f
thf(fact_6565_Min_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A5 )
                  = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Min.remove
thf(fact_6566_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Min.insert_remove
thf(fact_6567_arg__min__SOME__Min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 )
            = ( fChoice @ A
              @ ^ [Y4: A] :
                  ( ( member @ A @ Y4 @ S2 )
                  & ( ( F2 @ Y4 )
                    = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ) ).

% arg_min_SOME_Min
thf(fact_6568_upt__Suc__append,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( upt @ I @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_6569_upt__Suc,axiom,
    ! [I: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I @ J )
       => ( ( upt @ I @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I @ J )
       => ( ( upt @ I @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_6570_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( cons @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set_nonempty
thf(fact_6571_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_6572_dual__Max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Max @ A
          @ ^ [X3: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X3 ) )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% dual_Max
thf(fact_6573_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X3: A] : X3 )
      = ( ^ [Xs3: list @ A] : Xs3 ) ) ).

% map_ident
thf(fact_6574_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% map_is_Nil_conv
thf(fact_6575_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% Nil_is_map_conv
thf(fact_6576_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: list @ A] :
      ( ( ( map @ A @ B @ F2 @ A2 )
        = ( nil @ B ) )
      = ( A2
        = ( nil @ A ) ) ) ).

% list.map_disc_iff
thf(fact_6577_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G2: B > C,F2: A > B,V2: list @ A] :
      ( ( map @ B @ C @ G2 @ ( map @ A @ B @ F2 @ V2 ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G2 @ F2 ) @ V2 ) ) ).

% list.map_comp
thf(fact_6578_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: B > C,G2: A > B,List: list @ A] :
      ( ( map @ B @ C @ F2 @ ( map @ A @ B @ G2 @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G2 ) @ List ) ) ).

% List.map.compositionality
thf(fact_6579_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > A,G2: C > B,Xs: list @ C] :
      ( ( map @ B @ A @ F2 @ ( map @ C @ B @ G2 @ Xs ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F2 @ G2 ) @ Xs ) ) ).

% map_map
thf(fact_6580_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,G2: B > A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ G2 @ Xs ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
           => ( ( F2 @ X3 )
              = ( G2 @ X3 ) ) ) ) ) ).

% map_eq_conv
thf(fact_6581_length__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
      = ( size_size @ ( list @ B ) @ Xs ) ) ).

% length_map
thf(fact_6582_map__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys2: list @ B] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs @ Ys2 ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( map @ B @ A @ F2 @ Ys2 ) ) ) ).

% map_append
thf(fact_6583_map__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A,N: nat,X: B] :
      ( ( map @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( replicate @ A @ N @ ( F2 @ X ) ) ) ).

% map_replicate
thf(fact_6584_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,V2: list @ A] :
      ( ( set2 @ B @ ( map @ A @ B @ F2 @ V2 ) )
      = ( image @ A @ B @ F2 @ ( set2 @ A @ V2 ) ) ) ).

% list.set_map
thf(fact_6585_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys2: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys2 ) )
        = ( Xs = Ys2 ) ) ) ).

% inj_map_eq_map
thf(fact_6586_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,G2: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F2 ) @ ( map @ A @ C @ G2 ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F2 @ G2 ) ) ) ).

% map_comp_map
thf(fact_6587_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > C,G2: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F2 ) @ ( map @ A @ B @ G2 ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G2 ) ) ) ).

% List.map.comp
thf(fact_6588_size__list__map,axiom,
    ! [A: $tType,B: $tType,F2: A > nat,G2: B > A,Xs: list @ B] :
      ( ( size_list @ A @ F2 @ ( map @ B @ A @ G2 @ Xs ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F2 @ G2 ) @ Xs ) ) ).

% size_list_map
thf(fact_6589_list_Omap__id0,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A @ ( id @ A ) )
      = ( id @ ( list @ A ) ) ) ).

% list.map_id0
thf(fact_6590_nth__map,axiom,
    ! [B: $tType,A: $tType,N: nat,Xs: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs ) @ N )
        = ( F2 @ ( nth @ A @ Xs @ N ) ) ) ) ).

% nth_map
thf(fact_6591_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X3: B] : ( cons @ A @ ( F2 @ X3 ) @ ( nil @ A ) )
          @ Xs ) )
      = ( map @ B @ A @ F2 @ Xs ) ) ).

% concat_map_singleton
thf(fact_6592_inj__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
      = ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_map
thf(fact_6593_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ) ).

% inj_mapI
thf(fact_6594_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F2: nat > A,M: nat] :
      ( ( enumerate @ A @ N @ ( map @ nat @ A @ F2 @ ( upt @ N @ M ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K4: nat] : ( product_Pair @ nat @ A @ K4 @ ( F2 @ K4 ) )
        @ ( upt @ N @ M ) ) ) ).

% enumerate_map_upt
thf(fact_6595_image__set,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
      = ( set2 @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% image_set
thf(fact_6596_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( map @ A @ B @ F2 @ ( tl @ A @ A2 ) ) ) ) ).

% list.map_sel(2)
thf(fact_6597_map__tl,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_tl
thf(fact_6598_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( F2 @ ( hd @ A @ A2 ) ) ) ) ).

% list.map_sel(1)
thf(fact_6599_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( hd @ A @ Xs ) ) ) ) ).

% hd_map
thf(fact_6600_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,Xs: list @ C,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ Ys2 )
      = ( map @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ B @ ( product_prod @ A @ B )
          @ ^ [X3: C] : ( product_Pair @ A @ B @ ( F2 @ X3 ) ) )
        @ ( zip @ C @ B @ Xs @ Ys2 ) ) ) ).

% zip_map1
thf(fact_6601_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,F2: C > B,Ys2: list @ C] :
      ( ( zip @ A @ B @ Xs @ ( map @ C @ B @ F2 @ Ys2 ) )
      = ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
          @ ^ [X3: A,Y4: C] : ( product_Pair @ A @ B @ X3 @ ( F2 @ Y4 ) ) )
        @ ( zip @ A @ C @ Xs @ Ys2 ) ) ) ).

% zip_map2
thf(fact_6602_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( product_prod @ B @ C ) > A,G2: D > B,Xs: list @ D,Ys2: list @ C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ ( map @ D @ B @ G2 @ Xs ) @ Ys2 ) )
      = ( map @ ( product_prod @ D @ C ) @ A
        @ ( product_case_prod @ D @ C @ A
          @ ^ [X3: D,Y4: C] : ( F2 @ ( product_Pair @ B @ C @ ( G2 @ X3 ) @ Y4 ) ) )
        @ ( zip @ D @ C @ Xs @ Ys2 ) ) ) ).

% map_zip_map
thf(fact_6603_zip__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,F2: C > A,Xs: list @ C,G2: D > B,Ys2: list @ D] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ ( map @ D @ B @ G2 @ Ys2 ) )
      = ( map @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X3: C,Y4: D] : ( product_Pair @ A @ B @ ( F2 @ X3 ) @ ( G2 @ Y4 ) ) )
        @ ( zip @ C @ D @ Xs @ Ys2 ) ) ) ).

% zip_map_map
thf(fact_6604_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( product_prod @ B @ C ) > A,Xs: list @ B,G2: D > C,Ys2: list @ D] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ Xs @ ( map @ D @ C @ G2 @ Ys2 ) ) )
      = ( map @ ( product_prod @ B @ D ) @ A
        @ ( product_case_prod @ B @ D @ A
          @ ^ [X3: B,Y4: D] : ( F2 @ ( product_Pair @ B @ C @ X3 @ ( G2 @ Y4 ) ) ) )
        @ ( zip @ B @ D @ Xs @ Ys2 ) ) ) ).

% map_zip_map2
thf(fact_6605_map2__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,H: B > C > A,F2: D > B,Xs: list @ D,G2: D > C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ H ) @ ( zip @ B @ C @ ( map @ D @ B @ F2 @ Xs ) @ ( map @ D @ C @ G2 @ Xs ) ) )
      = ( map @ D @ A
        @ ^ [X3: D] : ( H @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
        @ Xs ) ) ).

% map2_map_map
thf(fact_6606_drop__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( drop @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( drop @ B @ N @ Xs ) ) ) ).

% drop_map
thf(fact_6607_List_Omap_Oidentity,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X3: A] : X3 )
      = ( id @ ( list @ A ) ) ) ).

% List.map.identity
thf(fact_6608_list_Omap__id,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A @ ( id @ A ) @ T2 )
      = T2 ) ).

% list.map_id
thf(fact_6609_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Ya: list @ A,F2: A > B,G2: A > B] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( set2 @ A @ Ya ) )
           => ( ( F2 @ Z3 )
              = ( G2 @ Z3 ) ) )
       => ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ G2 @ Ya ) ) ) ) ).

% list.map_cong
thf(fact_6610_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X: list @ A,F2: A > B,G2: A > B] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( set2 @ A @ X ) )
         => ( ( F2 @ Z3 )
            = ( G2 @ Z3 ) ) )
     => ( ( map @ A @ B @ F2 @ X )
        = ( map @ A @ B @ G2 @ X ) ) ) ).

% list.map_cong0
thf(fact_6611_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Xa: list @ A,F2: A > B,Fa: A > B] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( set2 @ A @ X ) )
         => ( ( member @ A @ Za @ ( set2 @ A @ Xa ) )
           => ( ( ( F2 @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ Fa @ Xa ) )
       => ( X = Xa ) ) ) ).

% list.inj_map_strong
thf(fact_6612_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B,G2: A > B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X2 )
            = ( G2 @ X2 ) ) )
     => ( ( map @ A @ B @ F2 @ Xs )
        = ( map @ A @ B @ G2 @ Xs ) ) ) ).

% map_ext
thf(fact_6613_map__idI,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X2 )
            = X2 ) )
     => ( ( map @ A @ A @ F2 @ Xs )
        = Xs ) ) ).

% map_idI
thf(fact_6614_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ A,F2: A > B,G2: A > B] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Ys2 ) )
           => ( ( F2 @ X2 )
              = ( G2 @ X2 ) ) )
       => ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ G2 @ Ys2 ) ) ) ) ).

% map_cong
thf(fact_6615_ex__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys2: list @ B,F2: A > B] :
      ( ( ? [Xs3: list @ A] :
            ( Ys2
            = ( map @ A @ B @ F2 @ Xs3 ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ ( set2 @ B @ Ys2 ) )
           => ? [Y4: A] :
                ( X3
                = ( F2 @ Y4 ) ) ) ) ) ).

% ex_map_conv
thf(fact_6616_map__eq__Cons__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Y: A,Ys2: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys2 ) )
      = ( ? [Z5: B,Zs3: list @ B] :
            ( ( Xs
              = ( cons @ B @ Z5 @ Zs3 ) )
            & ( ( F2 @ Z5 )
              = Y )
            & ( ( map @ B @ A @ F2 @ Zs3 )
              = Ys2 ) ) ) ) ).

% map_eq_Cons_conv
thf(fact_6617_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,F2: B > A,Ys2: list @ B] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
      = ( ? [Z5: B,Zs3: list @ B] :
            ( ( Ys2
              = ( cons @ B @ Z5 @ Zs3 ) )
            & ( X
              = ( F2 @ Z5 ) )
            & ( Xs
              = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) ) ).

% Cons_eq_map_conv
thf(fact_6618_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F2: B > A,Xs: list @ B,Y: A,Ys2: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys2 ) )
     => ? [Z3: B,Zs2: list @ B] :
          ( ( Xs
            = ( cons @ B @ Z3 @ Zs2 ) )
          & ( ( F2 @ Z3 )
            = Y )
          & ( ( map @ B @ A @ F2 @ Zs2 )
            = Ys2 ) ) ) ).

% map_eq_Cons_D
thf(fact_6619_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,F2: B > A,Ys2: list @ B] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
     => ? [Z3: B,Zs2: list @ B] :
          ( ( Ys2
            = ( cons @ B @ Z3 @ Zs2 ) )
          & ( X
            = ( F2 @ Z3 ) )
          & ( Xs
            = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) ).

% Cons_eq_map_D
thf(fact_6620_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X21: A,X22: list @ A] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X21 @ X22 ) )
      = ( cons @ B @ ( F2 @ X21 ) @ ( map @ A @ B @ F2 @ X22 ) ) ) ).

% list.simps(9)
thf(fact_6621_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys2: list @ A,Zs: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( append @ A @ Ys2 @ Zs ) )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( Ys2
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs3 ) ) ) ) ) ).

% map_eq_append_conv
thf(fact_6622_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys2: list @ A,Zs: list @ A,F2: B > A,Xs: list @ B] :
      ( ( ( append @ A @ Ys2 @ Zs )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( Ys2
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs3 ) ) ) ) ) ).

% append_eq_map_conv
thf(fact_6623_map__update,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,K: nat,Y: B] :
      ( ( map @ B @ A @ F2 @ ( list_update @ B @ Xs @ K @ Y ) )
      = ( list_update @ A @ ( map @ B @ A @ F2 @ Xs ) @ K @ ( F2 @ Y ) ) ) ).

% map_update
thf(fact_6624_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X3: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_6625_take__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( take @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( take @ B @ N @ Xs ) ) ) ).

% take_map
thf(fact_6626_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F2: B > nat,G2: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F2 ) @ ( map @ A @ B @ G2 ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F2 @ G2 ) ) ) ).

% list.size_gen_o_map
thf(fact_6627_map__concat,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( concat @ B @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) ) ) ).

% map_concat
thf(fact_6628_linorder_OMax_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Max @ A )
      = ( lattices_Max @ A ) ) ).

% linorder.Max.cong
thf(fact_6629_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rotate1 @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate1 @ B @ Xs ) ) ) ).

% rotate1_map
thf(fact_6630_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,Xs: list @ B,G2: C > A,Ys2: list @ C] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ C @ A @ G2 @ Ys2 ) )
     => ( ( size_size @ ( list @ B ) @ Xs )
        = ( size_size @ ( list @ C ) @ Ys2 ) ) ) ).

% map_eq_imp_length_eq
thf(fact_6631_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) ).

% list.simps(8)
thf(fact_6632_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( remdups @ A @ ( map @ B @ A @ F2 @ ( remdups @ B @ Xs ) ) )
      = ( remdups @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% remdups_map_remdups
thf(fact_6633_map__injective,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys2: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( Xs = Ys2 ) ) ) ).

% map_injective
thf(fact_6634_list_Omap__ident,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A
        @ ^ [X3: A] : X3
        @ T2 )
      = T2 ) ).

% list.map_ident
thf(fact_6635_nths__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,I6: set @ nat] :
      ( ( nths @ A @ ( map @ B @ A @ F2 @ Xs ) @ I6 )
      = ( map @ B @ A @ F2 @ ( nths @ B @ Xs @ I6 ) ) ) ).

% nths_map
thf(fact_6636_rotate__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( rotate @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate @ B @ N @ Xs ) ) ) ).

% rotate_map
thf(fact_6637_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys2: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys2 ) )
        = ( Xs = Ys2 ) ) ) ).

% inj_on_map_eq_map
thf(fact_6638_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys2: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
     => ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys2 ) ) )
       => ( Xs = Ys2 ) ) ) ).

% map_inj_on
thf(fact_6639_distinct__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( ( distinct @ B @ Xs )
        & ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) ) ) ).

% distinct_map
thf(fact_6640_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( remdups_adj @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( map @ A @ B @ F2 @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_map_injective
thf(fact_6641_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj
thf(fact_6642_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I: nat] :
      ( ( map @ nat @ A
        @ ^ [I4: nat] : X
        @ ( upt @ ( zero_zero @ nat ) @ I ) )
      = ( replicate @ A @ I @ X ) ) ).

% map_replicate_trivial
thf(fact_6643_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( distinct @ A @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( ~ ( member @ A @ ( F2 @ X ) @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
            & ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% distinct_insort_key
thf(fact_6644_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert2 @ A @ X @ ( set2 @ A @ Xs ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj_on
thf(fact_6645_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I4: nat] : ( F2 @ ( suc @ I4 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_6646_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_6647_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
     => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_mapD
thf(fact_6648_nth__map__upt,axiom,
    ! [A: $tType,I: nat,N: nat,M: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ N @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M @ N ) ) @ I )
        = ( F2 @ ( plus_plus @ nat @ M @ I ) ) ) ) ).

% nth_map_upt
thf(fact_6649_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ ( list @ A )] :
      ( ( inj_on @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ A5 ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ A5 ) ) ).

% inj_on_mapI
thf(fact_6650_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,M: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( minus_minus @ nat @ N @ M ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I2 )
              = ( F2 @ ( plus_plus @ nat @ M @ I2 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M @ N ) )
          = Xs ) ) ) ).

% map_upt_eqI
thf(fact_6651_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I2 ) )
              = N ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I4: nat] :
                ( map @ nat @ A
                @ ^ [J3: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J3 ) @ I4 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_6652_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798350308766er_Min @ A @ S2 ) )
              = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Min_eq_Max
thf(fact_6653_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D6: nat] : ( dvd_dvd @ nat @ D6 @ N ) ) )
        = N ) ) ).

% Max_divisors_self_nat
thf(fact_6654_Max__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Max_singleton
thf(fact_6655_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D6: int] : ( dvd_dvd @ int @ D6 @ N ) ) )
        = ( abs_abs @ int @ N ) ) ) ).

% Max_divisors_self_int
thf(fact_6656_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ X )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_6657_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ X )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_6658_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ B,C2: A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A5 ) )
              = C2 ) ) ) ) ).

% Max_const
thf(fact_6659_Max__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ) ).

% Max_insert
thf(fact_6660_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798349783984er_Max @ A @ S2 ) )
              = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Max_eq_Min
thf(fact_6661_map__Suc__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% map_Suc_upt
thf(fact_6662_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H3: A,T4: list @ A] : ( cons @ A @ H3 @ ( nil @ A ) ) )
              @ Xss ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H3: A,T4: list @ A] : ( cons @ ( list @ A ) @ T4 @ ( nil @ ( list @ A ) ) ) )
                @ Xss ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_6663_transpose_Oelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ ( list @ A ) ) )
         => ( Y
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( X
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( Y
               != ( transpose @ A @ Xss2 ) ) )
         => ~ ! [X2: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Xss2 ) )
               => ( Y
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X2
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H3: A,T4: list @ A] : ( cons @ A @ H3 @ ( nil @ A ) ) )
                          @ Xss2 ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs2
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H3: A,T4: list @ A] : ( cons @ ( list @ A ) @ T4 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss2 ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_6664_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( zip @ A @ A @ Xs @ Xs )
      = ( map @ A @ ( product_prod @ A @ A )
        @ ^ [X3: A] : ( product_Pair @ A @ A @ X3 @ X3 )
        @ Xs ) ) ).

% zip_same_conv_map
thf(fact_6665_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs @ Xss ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X3: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( product_lists @ A @ Xss ) )
          @ Xs ) ) ) ).

% product_lists.simps(2)
thf(fact_6666_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( n_lists @ A @ ( suc @ N ) @ Xs )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys3: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y4: A] : ( cons @ A @ Y4 @ Ys3 )
              @ Xs )
          @ ( n_lists @ A @ N @ Xs ) ) ) ) ).

% n_lists.simps(2)
thf(fact_6667_List_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bind @ A @ B )
      = ( ^ [Xs3: list @ A,F3: A > ( list @ B )] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F3 @ Xs3 ) ) ) ) ).

% List.bind_def
thf(fact_6668_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( transpose @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) )
      = ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( transpose @ B @ Xs ) ) ) ).

% transpose_map_map
thf(fact_6669_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X3: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 ) @ Ys3 )
              @ Xs3 ) ) ) ) ).

% product_concat_map
thf(fact_6670_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ ( list @ A ) ) ) ).

% transpose.simps(1)
thf(fact_6671_Max__ge,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ).

% Max_ge
thf(fact_6672_Max__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [Y2: A] :
                ( ( member @ A @ Y2 @ A5 )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ( member @ A @ X @ A5 )
             => ( ( lattic643756798349783984er_Max @ A @ A5 )
                = X ) ) ) ) ) ).

% Max_eqI
thf(fact_6673_Max__eq__if,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( finite_finite @ A @ B6 )
           => ( ! [X2: A] :
                  ( ( member @ A @ X2 @ A5 )
                 => ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ B6 )
                      & ( ord_less_eq @ A @ X2 @ Xa2 ) ) )
             => ( ! [X2: A] :
                    ( ( member @ A @ X2 @ B6 )
                   => ? [Xa2: A] :
                        ( ( member @ A @ Xa2 @ A5 )
                        & ( ord_less_eq @ A @ X2 @ Xa2 ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A5 )
                  = ( lattic643756798349783984er_Max @ A @ B6 ) ) ) ) ) ) ) ).

% Max_eq_if
thf(fact_6674_Max_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ord_less_eq @ A @ A2 @ ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ).

% Max.coboundedI
thf(fact_6675_Max_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) )
              = ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ).

% Max.in_idem
thf(fact_6676_Max__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ A5 ) ) ) ) ).

% Max_in
thf(fact_6677_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
      = ( transpose @ A @ Xss ) ) ).

% transpose.simps(2)
thf(fact_6678_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ( ord_less_eq @ A @ A4 @ X ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ X ) ) ) ) ) ).

% Max.boundedI
thf(fact_6679_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ X )
             => ! [A18: A] :
                  ( ( member @ A @ A18 @ A5 )
                 => ( ord_less_eq @ A @ A18 @ X ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_6680_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,M: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798349783984er_Max @ A @ A5 ) )
              = ( ( member @ A @ M @ A5 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less_eq @ A @ X3 @ M ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_6681_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                    & ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_6682_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,M: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A5 )
                = M )
              = ( ( member @ A @ M @ A5 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less_eq @ A @ X3 @ M ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_6683_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                    & ( ord_less @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_6684_Max__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [B4: A] :
                ( ( member @ A @ B4 @ A5 )
               => ( ord_less_eq @ A @ B4 @ A2 ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ A2 @ A5 ) )
              = A2 ) ) ) ) ).

% Max_insert2
thf(fact_6685_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( set @ A ) @ ( map @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% distinct_set_subseqs
thf(fact_6686_cSup__eq__Max,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = ( lattic643756798349783984er_Max @ A @ X8 ) ) ) ) ) ).

% cSup_eq_Max
thf(fact_6687_Max__Sup,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ A5 )
              = ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% Max_Sup
thf(fact_6688_map__add__upt,axiom,
    ! [N: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ I4 @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N @ ( plus_plus @ nat @ M @ N ) ) ) ).

% map_add_upt
thf(fact_6689_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys2 @ Zs ) )
      = ( map @ ( product_prod @ B @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ B @ ( product_prod @ A @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ^ [Y4: B] :
              ( product_case_prod @ A @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
              @ ^ [X3: A,Z5: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X3 @ ( product_Pair @ B @ C @ Y4 @ Z5 ) ) ) )
        @ ( zip @ B @ ( product_prod @ A @ C ) @ Ys2 @ ( zip @ A @ C @ Xs @ Zs ) ) ) ) ).

% zip_left_commute
thf(fact_6690_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys2 @ Zs ) )
      = ( map @ ( product_prod @ ( product_prod @ A @ B ) @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ ( product_prod @ A @ B ) @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ ( product_prod @ B @ C ) ) )
            @ ^ [X3: A,Y4: B,Z5: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X3 @ ( product_Pair @ B @ C @ Y4 @ Z5 ) ) ) )
        @ ( zip @ ( product_prod @ A @ B ) @ C @ ( zip @ A @ B @ Xs @ Ys2 ) @ Zs ) ) ) ).

% zip_assoc
thf(fact_6691_zip__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zip @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( map @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
            @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
              @ ^ [X3: B,Y4: A] : ( product_Pair @ A @ B @ Y4 @ X3 ) )
            @ ( zip @ B @ A @ Ys3 @ Xs3 ) ) ) ) ).

% zip_commute
thf(fact_6692_zip__replicate1,axiom,
    ! [A: $tType,B: $tType,N: nat,X: A,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( replicate @ A @ N @ X ) @ Ys2 )
      = ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ ( take @ B @ N @ Ys2 ) ) ) ).

% zip_replicate1
thf(fact_6693_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( subseqs @ A @ Xs ) ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs.simps(2)
thf(fact_6694_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ ( lattic643756798349783984er_Max @ A @ B6 ) ) ) ) ) ) ).

% Max.subset_imp
thf(fact_6695_Max__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M5: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M5 @ N4 )
         => ( ( M5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ M5 ) @ ( lattic643756798349783984er_Max @ A @ N4 ) ) ) ) ) ) ).

% Max_mono
thf(fact_6696_map__decr__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N ) ) )
      = ( upt @ M @ N ) ) ).

% map_decr_upt
thf(fact_6697_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H: A > A,N4: set @ A] :
          ( ! [X2: A,Y2: A] :
              ( ( H @ ( ord_max @ A @ X2 @ Y2 ) )
              = ( ord_max @ A @ ( H @ X2 ) @ ( H @ Y2 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H @ ( lattic643756798349783984er_Max @ A @ N4 ) )
                = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ H @ N4 ) ) ) ) ) ) ) ).

% hom_Max_commute
thf(fact_6698_Max_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
             => ( ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ B6 ) @ ( lattic643756798349783984er_Max @ A @ A5 ) )
                = ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ) ).

% Max.subset
thf(fact_6699_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y2: A] : ( member @ A @ ( ord_max @ A @ X2 @ Y2 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Max.closed
thf(fact_6700_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ) ) ).

% Max.insert_not_elem
thf(fact_6701_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798349783984er_Max @ A @ A5 ) )
                = ( lattic643756798349783984er_Max @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ) ) ).

% mono_Max_commute
thf(fact_6702_transpose__empty,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( ( transpose @ A @ Xs )
        = ( nil @ ( list @ A ) ) )
      = ( ! [X3: list @ A] :
            ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( X3
              = ( nil @ A ) ) ) ) ) ).

% transpose_empty
thf(fact_6703_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,N: nat,Y: B] :
      ( ( zip @ A @ B @ Xs @ ( replicate @ B @ N @ Y ) )
      = ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X3: A] : ( product_Pair @ A @ B @ X3 @ Y )
        @ ( take @ A @ N @ Xs ) ) ) ).

% zip_replicate2
thf(fact_6704_Max_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
                  = ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ ( lattic643756798349783984er_Max @ A @ B6 ) ) ) ) ) ) ) ) ).

% Max.union
thf(fact_6705_card__le__Suc__Max,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ S2 ) @ ( suc @ ( lattic643756798349783984er_Max @ nat @ S2 ) ) ) ) ).

% card_le_Suc_Max
thf(fact_6706_Sup__nat__def,axiom,
    ( ( complete_Sup_Sup @ nat )
    = ( ^ [X7: set @ nat] :
          ( if @ nat
          @ ( X7
            = ( bot_bot @ ( set @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat @ X7 ) ) ) ) ).

% Sup_nat_def
thf(fact_6707_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys2: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys2 )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ Ys2 ) @ ( product @ A @ B @ Xs @ Ys2 ) ) ) ).

% product.simps(2)
thf(fact_6708_divide__nat__def,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M2: nat,N3: nat] :
          ( if @ nat
          @ ( N3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat
            @ ( collect @ nat
              @ ^ [K4: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ K4 @ N3 ) @ M2 ) ) ) ) ) ) ).

% divide_nat_def
thf(fact_6709_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [X3: B] : ( plus_plus @ A @ ( F2 @ X3 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image @ B @ A @ F2 @ S2 ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_6710_Max_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A5 )
                  = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Max.remove
thf(fact_6711_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Max.insert_remove
thf(fact_6712_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M: nat,A2: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q6: nat] : ( product_Pair @ nat @ A @ Q6 @ A2 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_6713_Gcd__eq__Max,axiom,
    ! [M5: set @ nat] :
      ( ( finite_finite @ nat @ M5 )
     => ( ( M5
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M5 )
         => ( ( gcd_Gcd @ nat @ M5 )
            = ( lattic643756798349783984er_Max @ nat
              @ ( complete_Inf_Inf @ ( set @ nat )
                @ ( image @ nat @ ( set @ nat )
                  @ ^ [M2: nat] :
                      ( collect @ nat
                      @ ^ [D6: nat] : ( dvd_dvd @ nat @ D6 @ M2 ) )
                  @ M5 ) ) ) ) ) ) ) ).

% Gcd_eq_Max
thf(fact_6714_sum__le__card__Max,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ord_less_eq @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( times_times @ nat @ ( finite_card @ A @ A5 ) @ ( lattic643756798349783984er_Max @ nat @ ( image @ A @ nat @ F2 @ A5 ) ) ) ) ) ).

% sum_le_card_Max
thf(fact_6715_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H3: A,T4: list @ A] : ( cons @ A @ H3 @ ( nil @ A ) ) )
                @ Xss ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H3: A,T4: list @ A] : ( cons @ ( list @ A ) @ T4 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_6716_transpose_Opelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ ( list @ A ) ) )
           => ( ( Y
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss2: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
               => ( ( Y
                    = ( transpose @ A @ Xss2 ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
           => ~ ! [X2: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                  ( ( X
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Xss2 ) )
                 => ( ( Y
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X2
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H3: A,T4: list @ A] : ( cons @ A @ H3 @ ( nil @ A ) ) )
                              @ Xss2 ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs2
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H3: A,T4: list @ A] : ( cons @ ( list @ A ) @ T4 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Xss2 ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_6717_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
     => ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
        = ( nil @ ( list @ A ) ) ) ) ).

% transpose.psimps(1)
thf(fact_6718_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
        = ( transpose @ A @ Xss ) ) ) ).

% transpose.psimps(2)
thf(fact_6719_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( ( P @ Xss2 )
               => ( P @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
         => ( ! [X2: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Xss2 ) )
               => ( ( P
                    @ ( cons @ ( list @ A ) @ Xs2
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H3: A,T4: list @ A] : ( cons @ ( list @ A ) @ T4 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss2 ) ) ) )
                 => ( P @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Xss2 ) ) ) )
           => ( P @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_6720_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys2 ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X3: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 ) @ Ys2 )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_6721_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H3: A,T4: list @ A] : ( cons @ ( list @ A ) @ T4 @ ( nil @ ( list @ A ) ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_tail
thf(fact_6722_filter__filter,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,Xs: list @ A] :
      ( ( filter2 @ A @ P @ ( filter2 @ A @ Q @ Xs ) )
      = ( filter2 @ A
        @ ^ [X3: A] :
            ( ( Q @ X3 )
            & ( P @ X3 ) )
        @ Xs ) ) ).

% filter_filter
thf(fact_6723_filter__True,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = Xs ) ) ).

% filter_True
thf(fact_6724_filter__append,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A] :
      ( ( filter2 @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys2 ) ) ) ).

% filter_append
thf(fact_6725_remove1__filter__not,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ~ ( P @ X )
     => ( ( remove1 @ A @ X @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% remove1_filter_not
thf(fact_6726_removeAll__filter__not,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ~ ( P @ X )
     => ( ( removeAll @ A @ X @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% removeAll_filter_not
thf(fact_6727_set__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( set2 @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            & ( P @ X3 ) ) ) ) ).

% set_filter
thf(fact_6728_filter__False,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ~ ( P @ X2 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) ) ) ).

% filter_False
thf(fact_6729_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% length_filter_map
thf(fact_6730_filter__concat,axiom,
    ! [A: $tType,P6: A > $o,Xs: list @ ( list @ A )] :
      ( ( filter2 @ A @ P6 @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P6 ) @ Xs ) ) ) ).

% filter_concat
thf(fact_6731_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,P: B > $o] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
     => ( distinct @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ).

% distinct_map_filter
thf(fact_6732_filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% filter_map
thf(fact_6733_filter__shuffles,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A] :
      ( ( image @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P ) @ ( shuffles @ A @ Xs @ Ys2 ) )
      = ( shuffles @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys2 ) ) ) ).

% filter_shuffles
thf(fact_6734_distinct__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( filter2 @ A @ P @ Xs ) ) ) ).

% distinct_filter
thf(fact_6735_inter__set__filter,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ A5 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_6736_replicate__length__filter,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
              @ X )
            @ Xs ) )
        @ X )
      = ( filter2 @ A
        @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ X )
        @ Xs ) ) ).

% replicate_length_filter
thf(fact_6737_filter__is__subset,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% filter_is_subset
thf(fact_6738_empty__filter__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( filter2 @ A @ P @ Xs ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X3 ) ) ) ) ).

% empty_filter_conv
thf(fact_6739_filter__empty__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X3 ) ) ) ) ).

% filter_empty_conv
thf(fact_6740_filter__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Ys2 ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( filter2 @ A @ P @ Xs )
          = ( filter2 @ A @ Q @ Ys2 ) ) ) ) ).

% filter_cong
thf(fact_6741_filter__id__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = Xs )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) ) ) ) ).

% filter_id_conv
thf(fact_6742_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_filter_le
thf(fact_6743_remdups__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( remdups @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( remdups @ A @ Xs ) ) ) ).

% remdups_filter
thf(fact_6744_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X3: A] :
                ~ ( P @ X3 )
            @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% sum_length_filter_compl
thf(fact_6745_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( member @ ( list @ A ) @ Xs
      @ ( shuffles @ A @ ( filter2 @ A @ P @ Xs )
        @ ( filter2 @ A
          @ ^ [X3: A] :
              ~ ( P @ X3 )
          @ Xs ) ) ) ).

% partition_in_shuffles
thf(fact_6746_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X3: A] :
            ( filter2 @ A
            @ ^ [Y4: A] : ( X3 != Y4 ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_6747_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( filter2 @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% filter.simps(1)
thf(fact_6748_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,X: B,F2: B > A,Xs: list @ B] :
          ( ~ ( P @ X )
         => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
            = ( filter2 @ B @ P @ Xs ) ) ) ) ).

% filter_insort_triv
thf(fact_6749_filter__remove1,axiom,
    ! [A: $tType,Q: A > $o,X: A,Xs: list @ A] :
      ( ( filter2 @ A @ Q @ ( remove1 @ A @ X @ Xs ) )
      = ( remove1 @ A @ X @ ( filter2 @ A @ Q @ Xs ) ) ) ).

% filter_remove1
thf(fact_6750_filter__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N: nat] :
      ( ( ( P @ X )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) ) ) ).

% filter_replicate
thf(fact_6751_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( filter2 @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( filter2 @ A @ P @ Xs ) ) ) ) ).

% filter.simps(2)
thf(fact_6752_length__filter__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_filter_less
thf(fact_6753_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P: A > $o,Ys2: list @ A,X: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys2 )
        = ( cons @ A @ X @ Xs ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Ys2
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs3 ) ) )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X3 ) )
            & ( P @ X )
            & ( Xs
              = ( filter2 @ A @ P @ Vs3 ) ) ) ) ) ).

% filter_eq_Cons_iff
thf(fact_6754_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( filter2 @ A @ P @ Ys2 ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Ys2
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs3 ) ) )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X3 ) )
            & ( P @ X )
            & ( Xs
              = ( filter2 @ A @ P @ Vs3 ) ) ) ) ) ).

% Cons_eq_filter_iff
thf(fact_6755_filter__eq__ConsD,axiom,
    ! [A: $tType,P: A > $o,Ys2: list @ A,X: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys2 )
        = ( cons @ A @ X @ Xs ) )
     => ? [Us3: list @ A,Vs2: list @ A] :
          ( ( Ys2
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs2 ) ) )
          & ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X5 ) )
          & ( P @ X )
          & ( Xs
            = ( filter2 @ A @ P @ Vs2 ) ) ) ) ).

% filter_eq_ConsD
thf(fact_6756_Cons__eq__filterD,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( filter2 @ A @ P @ Ys2 ) )
     => ? [Us3: list @ A,Vs2: list @ A] :
          ( ( Ys2
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs2 ) ) )
          & ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X5 ) )
          & ( P @ X )
          & ( Xs
            = ( filter2 @ A @ P @ Vs2 ) ) ) ) ).

% Cons_eq_filterD
thf(fact_6757_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Y: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert2 @ A @ Y @ ( set2 @ A @ Xs ) ) )
     => ( ( filter2 @ A
          @ ^ [X3: A] :
              ( ( F2 @ Y )
              = ( F2 @ X3 ) )
          @ Xs )
        = ( filter2 @ A
          @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
            @ Y )
          @ Xs ) ) ) ).

% inj_on_filter_key_eq
thf(fact_6758_filter__in__nths,axiom,
    ! [A: $tType,Xs: list @ A,S: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ( filter2 @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ ( set2 @ A @ ( nths @ A @ Xs @ S ) ) )
          @ Xs )
        = ( nths @ A @ Xs @ S ) ) ) ).

% filter_in_nths
thf(fact_6759_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X3: A] : ( X3 != Y )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_6760_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
       => ( ( filter2 @ A
            @ ^ [X3: A] :
                ~ ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Ys2 ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_6761_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
       => ( ( filter2 @ A
            @ ^ [X3: A] : ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_6762_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
       => ( ( filter2 @ A
            @ ^ [X3: A] :
                ~ ( member @ A @ X3 @ ( set2 @ A @ Ys2 ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_6763_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
       => ( ( filter2 @ A
            @ ^ [X3: A] : ( member @ A @ X3 @ ( set2 @ A @ Ys2 ) )
            @ Zs )
          = Ys2 ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_6764_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( nths @ A @ Xs3
            @ ( collect @ nat
              @ ^ [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
                  & ( P3 @ ( nth @ A @ Xs3 @ I4 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_6765_length__filter__conv__card,axiom,
    ! [A: $tType,P6: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P6 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P6 @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_6766_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_6767_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H3: A,T4: list @ A] : ( cons @ A @ H3 @ ( nil @ A ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_head
thf(fact_6768_nth__transpose,axiom,
    ! [A: $tType,I: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs3: list @ A] : ( nth @ A @ Xs3 @ I )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_6769_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X3: list @ A] :
              ( X3
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_6770_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( map_filter @ B @ A
        @ ^ [X3: B] : ( if @ ( option @ A ) @ ( P @ X3 ) @ ( some @ A @ ( F2 @ X3 ) ) @ ( none @ A ) )
        @ Xs ) ) ).

% map_filter_map_filter
thf(fact_6771_foldr__append,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,Xs: list @ B,Ys2: list @ B,A2: A] :
      ( ( foldr @ B @ A @ F2 @ ( append @ B @ Xs @ Ys2 ) @ A2 )
      = ( foldr @ B @ A @ F2 @ Xs @ ( foldr @ B @ A @ F2 @ Ys2 @ A2 ) ) ) ).

% foldr_append
thf(fact_6772_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N: nat,X: B] :
      ( ( foldr @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( compow @ ( A > A ) @ N @ ( F2 @ X ) ) ) ).

% foldr_replicate
thf(fact_6773_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( option @ A )] :
      ( ( map_filter @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% map_filter_simps(2)
thf(fact_6774_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,L: list @ B,K: list @ B,F2: B > A > A,G2: B > A > A] :
      ( ( A2 = B2 )
     => ( ( L = K )
       => ( ! [A4: A,X2: B] :
              ( ( member @ B @ X2 @ ( set2 @ B @ L ) )
             => ( ( F2 @ X2 @ A4 )
                = ( G2 @ X2 @ A4 ) ) )
         => ( ( foldr @ B @ A @ F2 @ L @ A2 )
            = ( foldr @ B @ A @ G2 @ K @ B2 ) ) ) ) ) ).

% foldr_cong
thf(fact_6775_foldr__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X: A,Xs: list @ A] :
      ( ( foldr @ A @ B @ F2 @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( F2 @ X ) @ ( foldr @ A @ B @ F2 @ Xs ) ) ) ).

% foldr_Cons
thf(fact_6776_foldr__Nil,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B] :
      ( ( foldr @ A @ B @ F2 @ ( nil @ A ) )
      = ( id @ B ) ) ).

% foldr_Nil
thf(fact_6777_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G2: B > A > A,F2: C > B,Xs: list @ C,A2: A] :
      ( ( foldr @ B @ A @ G2 @ ( map @ C @ B @ F2 @ Xs ) @ A2 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G2 @ F2 ) @ Xs @ A2 ) ) ).

% foldr_map
thf(fact_6778_foldr__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P: B > $o,Xs: list @ B] :
      ( ( foldr @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( foldr @ B @ A
        @ ^ [X3: B] : ( if @ ( A > A ) @ ( P @ X3 ) @ ( F2 @ X3 ) @ ( id @ A ) )
        @ Xs ) ) ).

% foldr_filter
thf(fact_6779_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( foldr @ B @ A
              @ ^ [X3: B,B3: A] : ( plus_plus @ A @ ( F3 @ X3 ) @ ( times_times @ A @ A3 @ B3 ) )
              @ Xs3
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_6780_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_6781_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs3: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs3 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X3: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X3 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys3: list @ B] :
                  ( Ys3
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_6782_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list @ A,X8: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X3: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X3 ) @ ( F2 @ X3 ) )
            @ X8 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_6783_dual__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Min @ A
          @ ^ [X3: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X3 ) )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% dual_Min
thf(fact_6784_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_6785_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Ns ) )
               => ( X3
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_6786_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( zero_zero @ A )
              @ Xs ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_6787_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X3: nat] : X3
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum_list_upt
thf(fact_6788_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_6789_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% member_le_sum_list
thf(fact_6790_linorder_OMin_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Min @ A )
      = ( lattices_Min @ A ) ) ).

% linorder.Min.cong
thf(fact_6791_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_6792_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs )
              = ( zero_zero @ A ) )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
                 => ( X3
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_6793_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_6794_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs ) ) ) ) ).

% sum_list_abs
thf(fact_6795_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_6796_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs3 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_6797_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) ) ).

% sum_list_filter_le_nat
thf(fact_6798_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G2: A > B] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G2 @ Xs ) ) ) ) ) ).

% sum_list_mono
thf(fact_6799_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F2: B > A,P: B > $o,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( F2 @ X3 ) @ ( zero_zero @ A ) )
              @ Xs ) ) ) ) ).

% sum_list_map_filter'
thf(fact_6800_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( ( groups8242544230860333062m_list @ A @ Xs )
            = ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X3: A] : X3
              @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_sum_list_conv_Sum
thf(fact_6801_concat__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( concat @ A )
      = ( ^ [Xss3: list @ ( list @ A )] : ( foldr @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss3 @ ( nil @ A ) ) ) ) ).

% concat_conv_foldr
thf(fact_6802_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G2 @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_6803_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_6804_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B,P: B > $o,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
             => ( ~ ( P @ X2 )
               => ( ( F2 @ X2 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_6805_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ B,G2: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( set2 @ B @ Xs ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G2 @ Xs ) ) ) ) ) ).

% sum.distinct_set_conv_list
thf(fact_6806_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comm_monoid_add @ C )
     => ! [Xs: list @ B,F2: B > C] :
          ( ( distinct @ B @ Xs )
         => ( ( groups8242544230860333062m_list @ C @ ( map @ B @ C @ F2 @ Xs ) )
            = ( groups7311177749621191930dd_sum @ B @ C @ F2 @ ( set2 @ B @ Xs ) ) ) ) ) ).

% sum_list_distinct_conv_sum_set
thf(fact_6807_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ X @ ( set2 @ B @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) )
            = ( plus_plus @ A @ ( F2 @ X ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_6808_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: B > A,Xs: list @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( set2 @ B @ Xs ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G2 @ ( remdups @ B @ Xs ) ) ) ) ) ).

% sum_code
thf(fact_6809_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F3: B > nat,Xs3: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F3 @ Xs3 ) ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_6810_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R2: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X3: C] : R2
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R2 ) ) ) ).

% sum_list_triv
thf(fact_6811_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X3: A] : ( suc @ ( F2 @ X3 ) )
          @ Xs ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% sum_list_Suc
thf(fact_6812_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs3: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_6813_card__length__sum__list__rec,axiom,
    ! [M: nat,N4: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L4: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L4 )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L4 )
                  = N4 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L4: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L4 )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L4 )
                    = N4 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L4: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L4 )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L4 ) @ ( one_one @ nat ) )
                    = N4 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_6814_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X3: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X3 ) @ ( F2 @ X3 ) )
        @ ( set2 @ A @ Xs ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_6815_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs: list @ A,X: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ X ) @ ( nth @ A @ Xs @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_6816_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_6817_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq @ nat @ X2 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_6818_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X3: B] :
                        ( ( F2 @ A2 )
                        = ( F2 @ X3 ) )
                    @ Xs ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ ( remove1 @ B @ A2 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_6819_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X3: B,Y4: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y4 ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_6820_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R4: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( sorted_wrt @ A @ R4 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( sorted_wrt @ B
        @ ^ [X3: B,Y4: B] : ( R4 @ ( F2 @ X3 ) @ ( F2 @ Y4 ) )
        @ Xs ) ) ).

% sorted_wrt_map
thf(fact_6821_sorted__wrt__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_wrt_upt
thf(fact_6822_sorted__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_upt
thf(fact_6823_sorted__wrt1,axiom,
    ! [A: $tType,P: A > A > $o,X: A] : ( sorted_wrt @ A @ P @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% sorted_wrt1
thf(fact_6824_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: nat,X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N @ X ) ) ) ).

% sorted_replicate
thf(fact_6825_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_6826_sorted__upto,axiom,
    ! [M: int,N: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N ) ) ).

% sorted_upto
thf(fact_6827_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_6828_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_6829_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs ) ) ) ) ).

% sorted_remove1
thf(fact_6830_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_6831_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% sorted_remdups_adj
thf(fact_6832_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_6833_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > A > $o] : ( sorted_wrt @ A @ P @ ( nil @ A ) ) ).

% sorted_wrt.simps(1)
thf(fact_6834_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_6835_sorted__wrt__upto,axiom,
    ! [I: int,J: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I @ J ) ) ).

% sorted_wrt_upto
thf(fact_6836_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu3: A,Uv3: A] : $true
      @ Xs ) ).

% sorted_wrt_true
thf(fact_6837_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_6838_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I6: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs @ I6 ) ) ) ) ).

% sorted_nths
thf(fact_6839_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_remdups
thf(fact_6840_sorted__wrt__take,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( take @ A @ N @ Xs ) ) ) ).

% sorted_wrt_take
thf(fact_6841_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N @ Xs ) ) ) ) ).

% sorted_take
thf(fact_6842_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys2 )
           => ( ( ( set2 @ A @ Ys2 )
                = ( set2 @ A @ Xs ) )
             => ( Ys2 = Xs ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_6843_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o,Q: A > A > $o] :
      ( ! [X2: A,Y2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( P @ X2 @ Y2 )
             => ( Q @ X2 @ Y2 ) ) ) )
     => ( ( sorted_wrt @ A @ P @ Xs )
       => ( sorted_wrt @ A @ Q @ Xs ) ) ) ).

% sorted_wrt_mono_rel
thf(fact_6844_sorted__wrt__append,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,Ys2: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
      = ( ( sorted_wrt @ A @ P @ Xs )
        & ( sorted_wrt @ A @ P @ Ys2 )
        & ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( set2 @ A @ Ys2 ) )
               => ( P @ X3 @ Y4 ) ) ) ) ) ).

% sorted_wrt_append
thf(fact_6845_sorted__wrt__drop,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( drop @ A @ N @ Xs ) ) ) ).

% sorted_wrt_drop
thf(fact_6846_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N @ Xs ) ) ) ) ).

% sorted_drop
thf(fact_6847_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs ) ) ) ) ).

% sorted_tl
thf(fact_6848_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X @ Ys2 ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Ys2 ) )
               => ( ord_less @ A @ X @ X3 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys2 ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_6849_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ Ys2 ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Ys2 ) )
               => ( ord_less_eq @ A @ X @ X3 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 ) ) ) ) ).

% sorted_simps(2)
thf(fact_6850_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_6851_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ Ys2 ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ! [Y4: A] :
                    ( ( member @ A @ Y4 @ ( set2 @ A @ Ys2 ) )
                   => ( ord_less_eq @ A @ X3 @ Y4 ) ) ) ) ) ) ).

% sorted_append
thf(fact_6852_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_6853_sorted__wrt__filter,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,P: A > $o] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) ).

% sorted_wrt_filter
thf(fact_6854_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G2: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X3: A] :
                ( X3
                = ( G2 @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_6855_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Ys2: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( cons @ A @ X @ Ys2 ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Ys2 ) )
           => ( P @ X @ X3 ) )
        & ( sorted_wrt @ A @ P @ Ys2 ) ) ) ).

% sorted_wrt.simps(2)
thf(fact_6856_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa )
     => ~ ! [X2: A,Ys4: list @ A] :
            ( ( Xa
              = ( cons @ A @ X2 @ Ys4 ) )
           => ( ! [Xa3: A] :
                  ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                 => ( X @ X2 @ Xa3 ) )
              & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ).

% sorted_wrt.elims(3)
thf(fact_6857_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 )
             => ( ( distinct @ A @ Ys2 )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys2 ) )
                 => ( Xs = Ys2 ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_6858_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P3: A > A > $o,Xs3: list @ A] :
          ! [I4: nat,J3: nat] :
            ( ( ord_less @ nat @ I4 @ J3 )
           => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P3 @ ( nth @ A @ Xs3 @ I4 ) @ ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_6859_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,I: nat,J: nat] :
      ( ( sorted_wrt @ A @ P @ Xs )
     => ( ( ord_less @ nat @ I @ J )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_6860_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs ) ) ).

% sorted_wrt01
thf(fact_6861_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ).

% sorted_filter
thf(fact_6862_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_insort_key
thf(fact_6863_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_6864_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G2: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X3: B] :
                  ( ( F2 @ X3 )
                  = ( G2 @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_6865_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_6866_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted01
thf(fact_6867_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa )
     => ( ( Xa
         != ( nil @ A ) )
       => ~ ! [X2: A,Ys4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ Ys4 ) )
             => ~ ( ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ ( set2 @ A @ Ys4 ) )
                     => ( X @ X2 @ Xa2 ) )
                  & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ).

% sorted_wrt.elims(2)
thf(fact_6868_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ~ Y )
       => ~ ! [X2: A,Ys4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ Ys4 ) )
             => ( Y
                = ( ~ ( ! [Y4: A] :
                          ( ( member @ A @ Y4 @ ( set2 @ A @ Ys4 ) )
                         => ( X @ X2 @ Y4 ) )
                      & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.elims(1)
thf(fact_6869_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ? [X2: list @ A] :
              ( ( ( set2 @ A @ X2 )
                = A5 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X2 )
              & ( distinct @ A @ X2 )
              & ! [Y5: list @ A] :
                  ( ( ( ( set2 @ A @ Y5 )
                      = A5 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y5 )
                    & ( distinct @ A @ Y5 ) )
                 => ( Y5 = X2 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_6870_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
              = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_6871_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( P @ X )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ) ).

% filter_insort
thf(fact_6872_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X3: A] : X3
                @ A2
                @ ( remove1 @ A @ A2 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_6873_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_6874_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ~ ! [L2: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
               => ( ( ( set2 @ A @ L2 )
                    = A5 )
                 => ( ( size_size @ ( list @ A ) @ L2 )
                   != ( finite_card @ A @ A5 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_6875_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_6876_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_6877_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I @ ( nth @ nat @ Ns @ I ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_6878_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,Ys2: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys2 ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys2 ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys2 ) )
                 => ( ( ( set2 @ B @ Xs )
                      = ( set2 @ B @ Ys2 ) )
                   => ( Xs = Ys2 ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_6879_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,L: list @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
              & ( ( set2 @ A @ L )
                = A5 )
              & ( ( size_size @ ( list @ A ) @ L )
                = ( finite_card @ A @ A5 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A5 )
              = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_6880_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X2 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X3: A] : X3
                @ A2
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_6881_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J ) @ I ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_6882_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys3: list @ A] : ( nth @ A @ Ys3 @ I )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I ) ) ) ) ).

% transpose_column
thf(fact_6883_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) ).

% rev_rev_ident
thf(fact_6884_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys2 ) )
      = ( Xs = Ys2 ) ) ).

% rev_is_rev_conv
thf(fact_6885_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% Nil_is_rev_conv
thf(fact_6886_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rev_is_Nil_conv
thf(fact_6887_set__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rev @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rev
thf(fact_6888_length__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rev
thf(fact_6889_rev__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( rev @ A @ Ys2 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_append
thf(fact_6890_distinct__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rev @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rev
thf(fact_6891_rev__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( rev @ A @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ N @ X ) ) ).

% rev_replicate
thf(fact_6892_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_rev
thf(fact_6893_inj__on__rev,axiom,
    ! [A: $tType,A5: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ A5 ) ).

% inj_on_rev
thf(fact_6894_singleton__rev__conv,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( cons @ A @ X @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( ( cons @ A @ X @ ( nil @ A ) )
        = Xs ) ) ).

% singleton_rev_conv
thf(fact_6895_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev_singleton_conv
thf(fact_6896_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys2: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y @ Ys2 ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys2 ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ).

% rev_eq_Cons_iff
thf(fact_6897_rev__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( rev @ A @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ ( rev @ ( list @ A ) @ Xs ) ) ) ) ).

% rev_concat
thf(fact_6898_rev__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rev @ B @ Xs ) ) ) ).

% rev_map
thf(fact_6899_sorted__wrt__rev,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( rev @ A @ Xs ) )
      = ( sorted_wrt @ A
        @ ^ [X3: A,Y4: A] : ( P @ Y4 @ X3 )
        @ Xs ) ) ).

% sorted_wrt_rev
thf(fact_6900_rev__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( rev @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( rev @ A @ Xs ) ) ) ).

% rev_filter
thf(fact_6901_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( zip @ A @ B @ ( rev @ A @ Xs ) @ ( rev @ B @ Ys2 ) )
        = ( rev @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ) ).

% zip_rev
thf(fact_6902_rev_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rev.simps(1)
thf(fact_6903_rev__swap,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( rev @ A @ Xs )
        = Ys2 )
      = ( Xs
        = ( rev @ A @ Ys2 ) ) ) ).

% rev_swap
thf(fact_6904_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( rev @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev.simps(2)
thf(fact_6905_take__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ) ).

% take_rev
thf(fact_6906_rev__take,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( rev @ A @ ( take @ A @ I @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I ) @ ( rev @ A @ Xs ) ) ) ).

% rev_take
thf(fact_6907_rev__drop,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I ) @ ( rev @ A @ Xs ) ) ) ).

% rev_drop
thf(fact_6908_drop__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ) ).

% drop_rev
thf(fact_6909_rotate__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( rotate @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) @ Xs ) ) ) ).

% rotate_rev
thf(fact_6910_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rev @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( suc @ N ) ) ) ) ) ).

% rev_nth
thf(fact_6911_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs @ K @ Y ) )
        = ( list_update @ A @ ( rev @ A @ Xs ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ K ) @ ( one_one @ nat ) ) @ Y ) ) ) ).

% rev_update
thf(fact_6912_sorted__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) ) ) ).

% sorted_transpose
thf(fact_6913_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ ( suc @ I4 ) ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_6914_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J ) @ ( nth @ A @ Xs @ I ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_6915_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J3 ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_6916_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = Y ) )
            & ( ( Xs
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = ( ord_max @ A @ ( nth @ A @ Xs @ ( zero_zero @ nat ) ) @ Y ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_6917_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ( Xs
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_6918_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I ) ) ) ) ) ).

% transpose_column_length
thf(fact_6919_sorted__wrt_Opelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) )
         => ~ ! [X2: A,Ys4: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ Ys4 ) )
               => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ Ys4 ) ) )
                 => ~ ( ! [Xa2: A] :
                          ( ( member @ A @ Xa2 @ ( set2 @ A @ Ys4 ) )
                         => ( X @ X2 @ Xa2 ) )
                      & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
thf(fact_6920_sorted__wrt_Opelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
         => ~ ! [X2: A,Ys4: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ Ys4 ) )
               => ( ( Y
                    = ( ! [Y4: A] :
                          ( ( member @ A @ Y4 @ ( set2 @ A @ Ys4 ) )
                         => ( X @ X2 @ Y4 ) )
                      & ( sorted_wrt @ A @ X @ Ys4 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ Ys4 ) ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
thf(fact_6921_length__concat__rev,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) ) ) ).

% length_concat_rev
thf(fact_6922_sorted__wrt_Opelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ~ ! [X2: A,Ys4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ Ys4 ) )
             => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ Ys4 ) ) )
               => ( ! [Xa3: A] :
                      ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                     => ( X @ X2 @ Xa3 ) )
                  & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
thf(fact_6923_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ~ ! [L2: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L2 ) )
               => ( ( ( set2 @ B @ L2 )
                    = A5 )
                 => ( ( size_size @ ( list @ B ) @ L2 )
                   != ( finite_card @ B @ A5 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_6924_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X3: list @ A] :
              ( X3
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_6925_takeWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( takeWhile @ A @ P @ ( takeWhile @ A @ P @ Xs ) )
      = ( takeWhile @ A @ P @ Xs ) ) ).

% takeWhile_idem
thf(fact_6926_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = Xs )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) ) ) ) ).

% takeWhile_eq_all_conv
thf(fact_6927_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
        = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys2 ) ) ) ) ).

% takeWhile_append2
thf(fact_6928_takeWhile__append1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append1
thf(fact_6929_takeWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N: nat] :
      ( ( ( P @ X )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile_replicate
thf(fact_6930_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( takeWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% takeWhile_map
thf(fact_6931_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( takeWhile @ A @ P @ Xs ) ) ) ).

% distinct_takeWhile
thf(fact_6932_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% takeWhile_eq_Nil_iff
thf(fact_6933_set__takeWhileD,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
        & ( P @ X ) ) ) ).

% set_takeWhileD
thf(fact_6934_takeWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ L ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( takeWhile @ A @ P @ L )
          = ( takeWhile @ A @ Q @ K ) ) ) ) ).

% takeWhile_cong
thf(fact_6935_takeWhile__eq__take,axiom,
    ! [A: $tType] :
      ( ( takeWhile @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] : ( take @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs3 ) ) @ Xs3 ) ) ) ).

% takeWhile_eq_take
thf(fact_6936_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_takeWhile_le
thf(fact_6937_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( inj_on @ B @ A @ F2 @ S2 ) ) ).

% folding_insort_key.inj_on
thf(fact_6938_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( takeWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% takeWhile.simps(1)
thf(fact_6939_takeWhile__tail,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A,L: list @ A] :
      ( ~ ( P @ X )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ X @ L ) ) )
        = ( takeWhile @ A @ P @ Xs ) ) ) ).

% takeWhile_tail
thf(fact_6940_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( takeWhile @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile.simps(2)
thf(fact_6941_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_takeWhile
thf(fact_6942_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
       => ( distinct @ B @ Xs ) ) ) ).

% folding_insort_key.distinct_if_distinct_map
thf(fact_6943_takeWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% takeWhile_nth
thf(fact_6944_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ~ ( P @ ( nth @ A @ Xs @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_6945_takeWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys2 ) ) ) )
      & ( ~ ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
             => ( P @ X5 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append
thf(fact_6946_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ J )
         => ( P @ ( nth @ A @ Xs @ I2 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_6947_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P: A > $o] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I2 ) ) ) )
     => ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
         => ~ ( P @ ( nth @ A @ Xs @ N ) ) )
       => ( ( takeWhile @ A @ P @ Xs )
          = ( take @ A @ N @ Xs ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_6948_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X3: A] : X3 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_6949_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
         => ( ( filter2 @ B
              @ ^ [X3: B] : ( ord_less @ A @ T2 @ ( F2 @ X3 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X3: B] : ( ord_less @ A @ T2 @ ( F2 @ X3 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_6950_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B,L: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L ) )
              & ( ( set2 @ B @ L )
                = A5 )
              & ( ( size_size @ ( list @ B ) @ L )
                = ( finite_card @ B @ A5 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 )
              = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_6951_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_6952_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( sorted8670434370408473282of_set @ A @ B )
      = ( sorted8670434370408473282of_set @ A @ B ) ) ).

% linorder.sorted_key_list_of_set.cong
thf(fact_6953_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B,B6: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( ord_less_eq @ ( set @ B ) @ B6 @ S2 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ B6 ) )
           => ( ( finite_finite @ B @ A5 )
             => ( ( finite_finite @ B @ B6 )
               => ( A5 = B6 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_6954_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_6955_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 ) )
            = A5 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_6956_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 ) )
          = ( finite_card @ B @ A5 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_6957_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( distinct @ A @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_6958_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_6959_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( sorted_wrt @ A @ Less_eq2 @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_6960_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 )
              = ( nil @ B ) )
            = ( A5
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_6961_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs ) @ S2 )
       => ( ( sorted_wrt @ A @ Less_eq2 @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( distinct @ B @ Xs )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( set2 @ B @ Xs ) )
              = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_6962_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( insert2 @ B @ X @ A5 ) )
            = ( insort_key @ A @ B @ Less_eq2 @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_6963_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ~ ( member @ B @ X @ A5 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ ( insert2 @ B @ X @ A5 ) )
              = ( insort_key @ A @ B @ Less_eq2 @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq2 @ F2 @ A5 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_6964_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( insort_key @ A @ B )
      = ( insort_key @ A @ B ) ) ).

% linorder.insort_key.cong
thf(fact_6965_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq2: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,Y: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq2 @ Less @ S2 @ F2 )
     => ( ( member @ B @ X @ S2 )
       => ( ( member @ B @ Y @ S2 )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq2 @ F2 @ Y ) @ ( insort_key @ A @ B @ Less_eq2 @ F2 @ X ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq2 @ F2 @ X ) @ ( insort_key @ A @ B @ Less_eq2 @ F2 @ Y ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_6966_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y4: A,Ys3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y4 @ Ys3 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) ) ) ) ).

% extract_def
thf(fact_6967_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ? [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
                & ( P @ X5 ) )
           => ( ( find @ A @ P @ Xs )
              = ( some @ A
                @ ( lattic643756798350308766er_Min @ A
                  @ ( collect @ A
                    @ ^ [X3: A] :
                        ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
                        & ( P @ X3 ) ) ) ) ) ) ) ) ) ).

% sorted_find_Min
thf(fact_6968_dropWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( dropWhile @ A @ P @ ( dropWhile @ A @ P @ Xs ) )
      = ( dropWhile @ A @ P @ Xs ) ) ).

% dropWhile_idem
thf(fact_6969_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) ) ) ) ).

% dropWhile_eq_Nil_conv
thf(fact_6970_dropWhile__append1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys2 ) ) ) ) ).

% dropWhile_append1
thf(fact_6971_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
        = ( dropWhile @ A @ P @ Ys2 ) ) ) ).

% dropWhile_append2
thf(fact_6972_dropWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N: nat] :
      ( ( ( P @ X )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) ) ) ).

% dropWhile_replicate
thf(fact_6973_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( dropWhile @ A @ P @ Xs ) )
      = Xs ) ).

% takeWhile_dropWhile_id
thf(fact_6974_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_dropWhile
thf(fact_6975_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y4: A] : ( Y4 = X )
            @ Xs ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_6976_dropWhile__append3,axiom,
    ! [A: $tType,P: A > $o,Y: A,Xs: list @ A,Ys2: list @ A] :
      ( ~ ( P @ Y )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys2 ) ) )
        = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) ).

% dropWhile_append3
thf(fact_6977_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( dropWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) ) ) ).

% dropWhile.simps(2)
thf(fact_6978_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( dropWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% dropWhile.simps(1)
thf(fact_6979_length__dropWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_dropWhile_le
thf(fact_6980_find__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Ys2 ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( find @ A @ P @ Xs )
          = ( find @ A @ Q @ Ys2 ) ) ) ) ).

% find_cong
thf(fact_6981_set__dropWhileD,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_dropWhileD
thf(fact_6982_dropWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ L ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( dropWhile @ A @ P @ L )
          = ( dropWhile @ A @ Q @ K ) ) ) ) ).

% dropWhile_cong
thf(fact_6983_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = Xs )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% dropWhile_eq_self_iff
thf(fact_6984_hd__dropWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
       != ( nil @ A ) )
     => ~ ( P @ ( hd @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% hd_dropWhile
thf(fact_6985_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ).

% distinct_dropWhile
thf(fact_6986_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X3: A,Xa4: list @ A] : ( some @ A @ X3 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) ) ) ) ).

% find_dropWhile
thf(fact_6987_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( dropWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% dropWhile_map
thf(fact_6988_find_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( find @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( some @ A @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( find @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( find @ A @ P @ Xs ) ) ) ) ).

% find.simps(2)
thf(fact_6989_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: A > $o] :
      ( ( find @ A @ Uu @ ( nil @ A ) )
      = ( none @ A ) ) ).

% find.simps(1)
thf(fact_6990_find__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( find @ A @ P @ Xs )
        = ( none @ A ) )
      = ( ~ ? [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
              & ( P @ X3 ) ) ) ) ).

% find_None_iff
thf(fact_6991_find__None__iff2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( none @ A )
        = ( find @ A @ P @ Xs ) )
      = ( ~ ? [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
              & ( P @ X3 ) ) ) ) ).

% find_None_iff2
thf(fact_6992_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Y: A,Ys2: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( cons @ A @ Y @ Ys2 ) )
      = ( ( Xs
          = ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) )
        & ~ ( P @ Y ) ) ) ).

% dropWhile_eq_Cons_conv
thf(fact_6993_takeWhile__eq__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
         => ~ ( P @ X2 ) )
     => ( ( takeWhile @ A @ P @ Xs )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% takeWhile_eq_filter
thf(fact_6994_dropWhile__eq__drop,axiom,
    ! [A: $tType] :
      ( ( dropWhile @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] : ( drop @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs3 ) ) @ Xs3 ) ) ) ).

% dropWhile_eq_drop
thf(fact_6995_dropWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( dropWhile @ A @ P @ Ys2 ) ) )
      & ( ~ ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
             => ( P @ X5 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys2 ) ) ) ) ).

% dropWhile_append
thf(fact_6996_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X3: A] : ( X3 = Y )
            @ Ys2 ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_6997_tl__remdups__adj,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( Ys2
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys2 ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X3: A] :
                ( X3
                = ( hd @ A @ Ys2 ) )
            @ ( tl @ A @ Ys2 ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_6998_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_6999_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( dropWhile @ A
            @ ^ [Y4: A] : ( Y4 != X )
            @ ( rev @ A @ Xs ) )
          = ( cons @ A @ X
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y4: A] : ( Y4 != X )
                @ Xs ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_7000_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( takeWhile @ A
            @ ^ [Y4: A] : ( Y4 != X )
            @ ( rev @ A @ Xs ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y4: A] : ( Y4 != X )
                @ Xs ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_7001_find__Some__iff2,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( ( some @ A @ X )
        = ( find @ A @ P @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I4 ) )
            & ( X
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_7002_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,X: A] :
      ( ( ( find @ A @ P @ Xs )
        = ( some @ A @ X ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I4 ) )
            & ( X
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_7003_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F3: A > $o,Xs3: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ F3 @ Xs3 ) @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ F3 ) @ Xs3 ) ) ) ) ).

% partition_filter_conv
thf(fact_7004_Id__on__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X3: A] : ( product_Pair @ A @ A @ X3 @ X3 )
          @ Xs ) ) ) ).

% Id_on_set
thf(fact_7005_Id__on__subset__Times,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( id_on @ A @ A5 )
      @ ( product_Sigma @ A @ A @ A5
        @ ^ [Uu3: A] : A5 ) ) ).

% Id_on_subset_Times
thf(fact_7006_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( partition @ A @ P @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_7007_partition__P,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Yes ) )
           => ( P @ X5 ) )
        & ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ No4 ) )
           => ~ ( P @ X5 ) ) ) ) ).

% partition_P
thf(fact_7008_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( partition @ A @ P @ ( cons @ A @ X @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes2: list @ A,No: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Yes2 ) @ No ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ ( cons @ A @ X @ No ) ) )
        @ ( partition @ A @ P @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_7009_partition__set,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes ) @ ( set2 @ A @ No4 ) )
        = ( set2 @ A @ Xs ) ) ) ).

% partition_set
thf(fact_7010_prod_Oset__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: B > A,Xs: list @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( set2 @ B @ Xs ) )
          = ( groups5270119922927024881d_list @ A @ ( map @ B @ A @ G2 @ ( remdups @ B @ Xs ) ) ) ) ) ).

% prod.set_conv_list
thf(fact_7011_lists__empty,axiom,
    ! [A: $tType] :
      ( ( lists @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% lists_empty
thf(fact_7012_Cons__in__lists__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( lists @ A @ A5 ) )
      = ( ( member @ A @ X @ A5 )
        & ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) ) ) ) ).

% Cons_in_lists_iff
thf(fact_7013_in__listsI,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( member @ A @ X2 @ A5 ) )
     => ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) ) ) ).

% in_listsI
thf(fact_7014_lists__Int__eq,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( lists @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) )
      = ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ A5 ) @ ( lists @ A @ B6 ) ) ) ).

% lists_Int_eq
thf(fact_7015_append__in__lists__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( lists @ A @ A5 ) )
      = ( ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
        & ( member @ ( list @ A ) @ Ys2 @ ( lists @ A @ A5 ) ) ) ) ).

% append_in_lists_conv
thf(fact_7016_lists__UNIV,axiom,
    ! [A: $tType] :
      ( ( lists @ A @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% lists_UNIV
thf(fact_7017_lists__eq__set,axiom,
    ! [A: $tType] :
      ( ( lists @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A7 ) ) ) ) ).

% lists_eq_set
thf(fact_7018_lists__IntI,axiom,
    ! [A: $tType,L: list @ A,A5: set @ A,B6: set @ A] :
      ( ( member @ ( list @ A ) @ L @ ( lists @ A @ A5 ) )
     => ( ( member @ ( list @ A ) @ L @ ( lists @ A @ B6 ) )
       => ( member @ ( list @ A ) @ L @ ( lists @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) ) ) ) ).

% lists_IntI
thf(fact_7019_listsE,axiom,
    ! [A: $tType,X: A,L: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ X @ L ) @ ( lists @ A @ A5 ) )
     => ~ ( ( member @ A @ X @ A5 )
         => ~ ( member @ ( list @ A ) @ L @ ( lists @ A @ A5 ) ) ) ) ).

% listsE
thf(fact_7020_lists_OCons,axiom,
    ! [A: $tType,A2: A,A5: set @ A,L: list @ A] :
      ( ( member @ A @ A2 @ A5 )
     => ( ( member @ ( list @ A ) @ L @ ( lists @ A @ A5 ) )
       => ( member @ ( list @ A ) @ ( cons @ A @ A2 @ L ) @ ( lists @ A @ A5 ) ) ) ) ).

% lists.Cons
thf(fact_7021_lists_Ocases,axiom,
    ! [A: $tType,A2: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ A2 @ ( lists @ A @ A5 ) )
     => ( ( A2
         != ( nil @ A ) )
       => ~ ! [A4: A,L2: list @ A] :
              ( ( A2
                = ( cons @ A @ A4 @ L2 ) )
             => ( ( member @ A @ A4 @ A5 )
               => ~ ( member @ ( list @ A ) @ L2 @ ( lists @ A @ A5 ) ) ) ) ) ) ).

% lists.cases
thf(fact_7022_lists_Osimps,axiom,
    ! [A: $tType,A2: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ A2 @ ( lists @ A @ A5 ) )
      = ( ( A2
          = ( nil @ A ) )
        | ? [A3: A,L4: list @ A] :
            ( ( A2
              = ( cons @ A @ A3 @ L4 ) )
            & ( member @ A @ A3 @ A5 )
            & ( member @ ( list @ A ) @ L4 @ ( lists @ A @ A5 ) ) ) ) ) ).

% lists.simps
thf(fact_7023_lists_ONil,axiom,
    ! [A: $tType,A5: set @ A] : ( member @ ( list @ A ) @ ( nil @ A ) @ ( lists @ A @ A5 ) ) ).

% lists.Nil
thf(fact_7024_in__lists__conv__set,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( member @ A @ X3 @ A5 ) ) ) ) ).

% in_lists_conv_set
thf(fact_7025_in__listsD,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
     => ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
         => ( member @ A @ X5 @ A5 ) ) ) ).

% in_listsD
thf(fact_7026_listrel__refl__on,axiom,
    ! [A: $tType,A5: set @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ A5 @ R2 )
     => ( refl_on @ ( list @ A ) @ ( lists @ A @ A5 ) @ ( listrel @ A @ A @ R2 ) ) ) ).

% listrel_refl_on
thf(fact_7027_prod__list__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( semiring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [Xs: list @ A] :
          ( ( ( groups5270119922927024881d_list @ A @ Xs )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( zero_zero @ A ) @ ( set2 @ A @ Xs ) ) ) ) ).

% prod_list_zero_iff
thf(fact_7028_lists__mono,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( lists @ A @ A5 ) @ ( lists @ A @ B6 ) ) ) ).

% lists_mono
thf(fact_7029_lists__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( lists @ A @ ( image @ B @ A @ F2 @ A5 ) )
      = ( image @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( lists @ B @ A5 ) ) ) ).

% lists_image
thf(fact_7030_Collect__finite__eq__lists,axiom,
    ! [A: $tType] :
      ( ( collect @ ( set @ A ) @ ( finite_finite @ A ) )
      = ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( lists @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% Collect_finite_eq_lists
thf(fact_7031_Collect__finite__subset__eq__lists,axiom,
    ! [A: $tType,T6: set @ A] :
      ( ( collect @ ( set @ A )
        @ ^ [A7: set @ A] :
            ( ( finite_finite @ A @ A7 )
            & ( ord_less_eq @ ( set @ A ) @ A7 @ T6 ) ) )
      = ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( lists @ A @ T6 ) ) ) ).

% Collect_finite_subset_eq_lists
thf(fact_7032_listrel__subset,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2
        @ ( product_Sigma @ A @ A @ A5
          @ ^ [Uu3: A] : A5 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R2 )
        @ ( product_Sigma @ ( list @ A ) @ ( list @ A ) @ ( lists @ A @ A5 )
          @ ^ [Uu3: list @ A] : ( lists @ A @ A5 ) ) ) ) ).

% listrel_subset
thf(fact_7033_prod_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Xs: list @ B,G2: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( set2 @ B @ Xs ) )
            = ( groups5270119922927024881d_list @ A @ ( map @ B @ A @ G2 @ Xs ) ) ) ) ) ).

% prod.distinct_set_conv_list
thf(fact_7034_INF__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F2 ) @ Xs @ ( top_top @ A ) ) ) ) ).

% INF_set_fold
thf(fact_7035_SUP__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( sup_sup @ A ) @ F2 ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% SUP_set_fold
thf(fact_7036_fold__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,Xs: list @ B,Ys2: list @ B] :
      ( ( fold @ B @ A @ F2 @ ( append @ B @ Xs @ Ys2 ) )
      = ( comp @ A @ A @ A @ ( fold @ B @ A @ F2 @ Ys2 ) @ ( fold @ B @ A @ F2 @ Xs ) ) ) ).

% fold_append
thf(fact_7037_fold__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N: nat,X: B] :
      ( ( fold @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( compow @ ( A > A ) @ N @ ( F2 @ X ) ) ) ).

% fold_replicate
thf(fact_7038_fold__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X: A,Xs: list @ A] :
      ( ( fold @ A @ B @ F2 @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( fold @ A @ B @ F2 @ Xs ) @ ( F2 @ X ) ) ) ).

% fold_Cons
thf(fact_7039_fold__commute,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list @ A,H: B > C,G2: A > B > B,F2: A > C > C] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( comp @ B @ C @ B @ H @ ( G2 @ X2 ) )
            = ( comp @ C @ C @ B @ ( F2 @ X2 ) @ H ) ) )
     => ( ( comp @ B @ C @ B @ H @ ( fold @ A @ B @ G2 @ Xs ) )
        = ( comp @ C @ C @ B @ ( fold @ A @ C @ F2 @ Xs ) @ H ) ) ) ).

% fold_commute
thf(fact_7040_fold__commute__apply,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list @ A,H: B > C,G2: A > B > B,F2: A > C > C,S: B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( comp @ B @ C @ B @ H @ ( G2 @ X2 ) )
            = ( comp @ C @ C @ B @ ( F2 @ X2 ) @ H ) ) )
     => ( ( H @ ( fold @ A @ B @ G2 @ Xs @ S ) )
        = ( fold @ A @ C @ F2 @ Xs @ ( H @ S ) ) ) ) ).

% fold_commute_apply
thf(fact_7041_fold__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G2: B > A > A,F2: C > B,Xs: list @ C] :
      ( ( fold @ B @ A @ G2 @ ( map @ C @ B @ F2 @ Xs ) )
      = ( fold @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G2 @ F2 ) @ Xs ) ) ).

% fold_map
thf(fact_7042_foldr__conv__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldr @ B @ A )
      = ( ^ [F3: B > A > A,Xs3: list @ B] : ( fold @ B @ A @ F3 @ ( rev @ B @ Xs3 ) ) ) ) ).

% foldr_conv_fold
thf(fact_7043_fold__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P: B > $o,Xs: list @ B] :
      ( ( fold @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( fold @ B @ A
        @ ^ [X3: B] : ( if @ ( A > A ) @ ( P @ X3 ) @ ( F2 @ X3 ) @ ( id @ A ) )
        @ Xs ) ) ).

% fold_filter
thf(fact_7044_fold__id,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X2 )
            = ( id @ B ) ) )
     => ( ( fold @ A @ B @ F2 @ Xs )
        = ( id @ B ) ) ) ).

% fold_id
thf(fact_7045_List_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,Xs: list @ B,Ys2: list @ B,F2: B > A > A,G2: B > A > A] :
      ( ( A2 = B2 )
     => ( ( Xs = Ys2 )
       => ( ! [X2: B] :
              ( ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
             => ( ( F2 @ X2 )
                = ( G2 @ X2 ) ) )
         => ( ( fold @ B @ A @ F2 @ Xs @ A2 )
            = ( fold @ B @ A @ G2 @ Ys2 @ B2 ) ) ) ) ) ).

% List.fold_cong
thf(fact_7046_fold__invariant,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Q: A > $o,P: B > $o,S: B,F2: A > B > B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( Q @ X2 ) )
     => ( ( P @ S )
       => ( ! [X2: A,S3: B] :
              ( ( Q @ X2 )
             => ( ( P @ S3 )
               => ( P @ ( F2 @ X2 @ S3 ) ) ) )
         => ( P @ ( fold @ A @ B @ F2 @ Xs @ S ) ) ) ) ) ).

% fold_invariant
thf(fact_7047_fold__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,S: A] :
      ( ( fold @ B @ A @ F2 @ ( nil @ B ) @ S )
      = S ) ).

% fold_simps(1)
thf(fact_7048_fold__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,X: B,Xs: list @ B,S: A] :
      ( ( fold @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) @ S )
      = ( fold @ B @ A @ F2 @ Xs @ ( F2 @ X @ S ) ) ) ).

% fold_simps(2)
thf(fact_7049_fold__Nil,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B] :
      ( ( fold @ A @ B @ F2 @ ( nil @ A ) )
      = ( id @ B ) ) ).

% fold_Nil
thf(fact_7050_union__set__fold,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A5 )
      = ( fold @ A @ ( set @ A ) @ ( insert2 @ A ) @ Xs @ A5 ) ) ).

% union_set_fold
thf(fact_7051_rev__conv__fold,axiom,
    ! [A: $tType] :
      ( ( rev @ A )
      = ( ^ [Xs3: list @ A] : ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs3 @ ( nil @ A ) ) ) ) ).

% rev_conv_fold
thf(fact_7052_fold__Cons__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs )
      = ( append @ A @ ( rev @ A @ Xs ) ) ) ).

% fold_Cons_rev
thf(fact_7053_fold__rev,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X2: A,Y2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) )
              = ( comp @ B @ B @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
     => ( ( fold @ A @ B @ F2 @ ( rev @ A @ Xs ) )
        = ( fold @ A @ B @ F2 @ Xs ) ) ) ).

% fold_rev
thf(fact_7054_fold__remove1__split,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B,X: A] :
      ( ! [X2: A,Y2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
              = ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) ) ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( fold @ A @ B @ F2 @ Xs )
          = ( comp @ B @ B @ B @ ( fold @ A @ B @ F2 @ ( remove1 @ A @ X @ Xs ) ) @ ( F2 @ X ) ) ) ) ) ).

% fold_remove1_split
thf(fact_7055_foldr__fold,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X2: A,Y2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) )
              = ( comp @ B @ B @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
     => ( ( foldr @ A @ B @ F2 @ Xs )
        = ( fold @ A @ B @ F2 @ Xs ) ) ) ).

% foldr_fold
thf(fact_7056_fold__append__concat__rev,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( fold @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss )
      = ( append @ A @ ( concat @ A @ ( rev @ ( list @ A ) @ Xss ) ) ) ) ).

% fold_append_concat_rev
thf(fact_7057_Sup__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Sup_Sup @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% Sup_set_fold
thf(fact_7058_Inf__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Inf_Inf @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ ( top_top @ A ) ) ) ) ).

% Inf_set_fold
thf(fact_7059_Max_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic643756798349783984er_Max @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( ord_max @ A ) @ Xs @ X ) ) ) ).

% Max.set_eq_fold
thf(fact_7060_Min_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic643756798350308766er_Min @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( ord_min @ A ) @ Xs @ X ) ) ) ).

% Min.set_eq_fold
thf(fact_7061_finite__sequence__to__countable__set,axiom,
    ! [A: $tType,X8: set @ A] :
      ( ( countable_countable @ A @ X8 )
     => ~ ! [F6: nat > ( set @ A )] :
            ( ! [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( F6 @ I3 ) @ X8 )
           => ( ! [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( F6 @ I3 ) @ ( F6 @ ( suc @ I3 ) ) )
             => ( ! [I3: nat] : ( finite_finite @ A @ ( F6 @ I3 ) )
               => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F6 @ ( top_top @ ( set @ nat ) ) ) )
                 != X8 ) ) ) ) ) ).

% finite_sequence_to_countable_set
thf(fact_7062_butlast__power,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N @ ( butlast @ A ) @ Xs )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ).

% butlast_power
thf(fact_7063_butlast__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( butlast @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( tl @ A @ Xs ) ) ) ).

% butlast_rev
thf(fact_7064_butlast__snoc,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( butlast @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = Xs ) ).

% butlast_snoc
thf(fact_7065_length__butlast,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_butlast
thf(fact_7066_less__ccSup__iff,axiom,
    ! [A: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( countable_countable @ A @ S2 )
         => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) )
            = ( ? [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                  & ( ord_less @ A @ A2 @ X3 ) ) ) ) ) ) ).

% less_ccSup_iff
thf(fact_7067_ccSup__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( countable_countable @ A @ B6 )
         => ( ( countable_countable @ A @ A5 )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ B6 )
                      & ( ord_less_eq @ A @ A4 @ X5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ) ).

% ccSup_mono
thf(fact_7068_ccSup__least,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,Z2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ A5 )
               => ( ord_less_eq @ A @ X2 @ Z2 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ Z2 ) ) ) ) ).

% ccSup_least
thf(fact_7069_ccSup__upper,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% ccSup_upper
thf(fact_7070_ccSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ B2 )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A5 )
                 => ( ord_less_eq @ A @ X3 @ B2 ) ) ) ) ) ) ).

% ccSup_le_iff
thf(fact_7071_ccSup__upper2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,U: A,V2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( member @ A @ U @ A5 )
           => ( ( ord_less_eq @ A @ V2 @ U )
             => ( ord_less_eq @ A @ V2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ) ).

% ccSup_upper2
thf(fact_7072_countable__Collect__finite__subset,axiom,
    ! [A: $tType,T6: set @ A] :
      ( ( countable_countable @ A @ T6 )
     => ( countable_countable @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [A7: set @ A] :
              ( ( finite_finite @ A @ A7 )
              & ( ord_less_eq @ ( set @ A ) @ A7 @ T6 ) ) ) ) ) ).

% countable_Collect_finite_subset
thf(fact_7073_infinite__countable__subset_H,axiom,
    ! [A: $tType,X8: set @ A] :
      ( ~ ( finite_finite @ A @ X8 )
     => ? [C6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ C6 @ X8 )
          & ( countable_countable @ A @ C6 )
          & ~ ( finite_finite @ A @ C6 ) ) ) ).

% infinite_countable_subset'
thf(fact_7074_countable__subset,axiom,
    ! [A: $tType,A5: set @ A,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ( countable_countable @ A @ B6 )
       => ( countable_countable @ A @ A5 ) ) ) ).

% countable_subset
thf(fact_7075_butlast_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( butlast @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% butlast.simps(1)
thf(fact_7076_butlast_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( butlast @ A @ Xs ) ) ) ) ) ).

% butlast.simps(2)
thf(fact_7077_in__set__butlast__appendI,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys2: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Xs ) ) )
        | ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Ys2 ) ) ) )
     => ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ ( append @ A @ Xs @ Ys2 ) ) ) ) ) ).

% in_set_butlast_appendI
thf(fact_7078_butlast__append,axiom,
    ! [A: $tType,Ys2: list @ A,Xs: list @ A] :
      ( ( ( Ys2
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( Ys2
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ Xs @ ( butlast @ A @ Ys2 ) ) ) ) ) ).

% butlast_append
thf(fact_7079_in__set__butlastD,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_butlastD
thf(fact_7080_drop__butlast,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( butlast @ A @ Xs ) )
      = ( butlast @ A @ ( drop @ A @ N @ Xs ) ) ) ).

% drop_butlast
thf(fact_7081_butlast__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( butlast @ A @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( butlast @ A @ Xs ) ) ) ).

% butlast_tl
thf(fact_7082_distinct__butlast,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( butlast @ A @ Xs ) ) ) ).

% distinct_butlast
thf(fact_7083_countable__image__eq,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B] :
      ( ( countable_countable @ A @ ( image @ B @ A @ F2 @ S2 ) )
      = ( ? [T10: set @ B] :
            ( ( countable_countable @ B @ T10 )
            & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( ( image @ B @ A @ F2 @ S2 )
              = ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% countable_image_eq
thf(fact_7084_countable__subset__image,axiom,
    ! [A: $tType,B: $tType,B6: set @ A,F2: B > A,A5: set @ B] :
      ( ( ( countable_countable @ A @ B6 )
        & ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A5 ) ) )
      = ( ? [A19: set @ B] :
            ( ( countable_countable @ B @ A19 )
            & ( ord_less_eq @ ( set @ B ) @ A19 @ A5 )
            & ( B6
              = ( image @ B @ A @ F2 @ A19 ) ) ) ) ) ).

% countable_subset_image
thf(fact_7085_ex__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T10: set @ A] :
            ( ( countable_countable @ A @ T10 )
            & ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T10 ) ) )
      = ( ? [T10: set @ B] :
            ( ( countable_countable @ B @ T10 )
            & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% ex_countable_subset_image
thf(fact_7086_all__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T10: set @ A] :
            ( ( ( countable_countable @ A @ T10 )
              & ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) ) )
           => ( P @ T10 ) ) )
      = ( ! [T10: set @ B] :
            ( ( ( countable_countable @ B @ T10 )
              & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 ) )
           => ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% all_countable_subset_image
thf(fact_7087_ccInf__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( countable_countable @ A @ B6 )
         => ( ( countable_countable @ A @ A5 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ B6 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A5 )
                      & ( ord_less_eq @ A @ X5 @ B4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ) ) ).

% ccInf_mono
thf(fact_7088_ccInf__lower,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ X ) ) ) ) ).

% ccInf_lower
thf(fact_7089_ccInf__lower2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,U: A,V2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( member @ A @ U @ A5 )
           => ( ( ord_less_eq @ A @ U @ V2 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ V2 ) ) ) ) ) ).

% ccInf_lower2
thf(fact_7090_le__ccInf__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A5 ) )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A5 )
                 => ( ord_less_eq @ A @ B2 @ X3 ) ) ) ) ) ) ).

% le_ccInf_iff
thf(fact_7091_ccInf__greatest,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,Z2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ A5 )
               => ( ord_less_eq @ A @ Z2 @ X2 ) )
           => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ A5 ) ) ) ) ) ).

% ccInf_greatest
thf(fact_7092_ccInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( countable_countable @ A @ S2 )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 )
            = ( ? [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                  & ( ord_less @ A @ X3 @ A2 ) ) ) ) ) ) ).

% ccInf_less_iff
thf(fact_7093_map__butlast,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( butlast @ B @ Xs ) )
      = ( butlast @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_butlast
thf(fact_7094_ccSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( countable_countable @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ).

% ccSup_subset_mono
thf(fact_7095_ccInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ) ).

% ccInf_superset_mono
thf(fact_7096_countable__image__eq__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B] :
      ( ( countable_countable @ A @ ( image @ B @ A @ F2 @ S2 ) )
      = ( ? [T10: set @ B] :
            ( ( countable_countable @ B @ T10 )
            & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( ( image @ B @ A @ F2 @ S2 )
              = ( image @ B @ A @ F2 @ T10 ) )
            & ( inj_on @ B @ A @ F2 @ T10 ) ) ) ) ).

% countable_image_eq_inj
thf(fact_7097_ex__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T10: set @ A] :
            ( ( countable_countable @ A @ T10 )
            & ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T10 ) ) )
      = ( ? [T10: set @ B] :
            ( ( countable_countable @ B @ T10 )
            & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( inj_on @ B @ A @ F2 @ T10 )
            & ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% ex_countable_subset_image_inj
thf(fact_7098_all__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T10: set @ A] :
            ( ( ( countable_countable @ A @ T10 )
              & ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) ) )
           => ( P @ T10 ) ) )
      = ( ! [T10: set @ B] :
            ( ( ( countable_countable @ B @ T10 )
              & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
              & ( inj_on @ B @ A @ F2 @ T10 ) )
           => ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% all_countable_subset_image_inj
thf(fact_7099_ccSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,I: B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( member @ B @ I @ A5 )
           => ( ( ord_less_eq @ A @ U @ ( F2 @ I ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ) ).

% ccSUP_upper2
thf(fact_7100_ccSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U )
            = ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A5 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ U ) ) ) ) ) ) ).

% ccSUP_le_iff
thf(fact_7101_ccSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,I: B,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( member @ B @ I @ A5 )
           => ( ord_less_eq @ A @ ( F2 @ I ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% ccSUP_upper
thf(fact_7102_ccSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A5 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ U ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ) ).

% ccSUP_least
thf(fact_7103_ccSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,B6: set @ C,F2: B > A,G2: C > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( countable_countable @ C @ B6 )
           => ( ! [N2: B] :
                  ( ( member @ B @ N2 @ A5 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ B6 )
                      & ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G2 @ X5 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G2 @ B6 ) ) ) ) ) ) ) ).

% ccSUP_mono
thf(fact_7104_less__ccSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [A5: set @ B,A2: A,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
            = ( ? [X3: B] :
                  ( ( member @ B @ X3 @ A5 )
                  & ( ord_less @ A @ A2 @ ( F2 @ X3 ) ) ) ) ) ) ) ).

% less_ccSUP_iff
thf(fact_7105_ccINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A5 )
               => ( ord_less_eq @ A @ U @ ( F2 @ I2 ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% ccINF_greatest
thf(fact_7106_le__ccINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
            = ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A5 )
                 => ( ord_less_eq @ A @ U @ ( F2 @ X3 ) ) ) ) ) ) ) ).

% le_ccINF_iff
thf(fact_7107_ccINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,I: B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( member @ B @ I @ A5 )
           => ( ( ord_less_eq @ A @ ( F2 @ I ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ) ) ).

% ccINF_lower2
thf(fact_7108_ccINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,I: B,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( member @ B @ I @ A5 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( F2 @ I ) ) ) ) ) ).

% ccINF_lower
thf(fact_7109_ccINF__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,B6: set @ C,F2: B > A,G2: C > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( countable_countable @ C @ B6 )
           => ( ! [M4: C] :
                  ( ( member @ C @ M4 @ B6 )
                 => ? [X5: B] :
                      ( ( member @ B @ X5 @ A5 )
                      & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G2 @ M4 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ G2 @ B6 ) ) ) ) ) ) ) ).

% ccINF_mono
thf(fact_7110_ccINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [A5: set @ B,F2: B > A,A2: A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ A2 )
            = ( ? [X3: B] :
                  ( ( member @ B @ X3 @ A5 )
                  & ( ord_less @ A @ ( F2 @ X3 ) @ A2 ) ) ) ) ) ) ).

% ccINF_less_iff
thf(fact_7111_sorted__butlast,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( butlast @ A @ Xs ) ) ) ) ) ).

% sorted_butlast
thf(fact_7112_nth__butlast,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs ) ) )
     => ( ( nth @ A @ ( butlast @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ N ) ) ) ).

% nth_butlast
thf(fact_7113_take__butlast,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ N @ ( butlast @ A @ Xs ) )
        = ( take @ A @ N @ Xs ) ) ) ).

% take_butlast
thf(fact_7114_ccSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( countable_countable @ A @ B6 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ) ).

% ccSup_inter_less_eq
thf(fact_7115_less__eq__ccInf__inter,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( countable_countable @ A @ B6 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B6 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) ) ) ) ) ).

% less_eq_ccInf_inter
thf(fact_7116_ccSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B6: set @ B,A5: set @ B,F2: B > A,G2: B > A] :
          ( ( countable_countable @ B @ B6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B6 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ A5 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G2 @ B6 ) ) ) ) ) ) ) ).

% ccSUP_subset_mono
thf(fact_7117_ccINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,B6: set @ B,F2: B > A,G2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less_eq @ ( set @ B ) @ B6 @ A5 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ B6 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ B6 ) ) ) ) ) ) ) ).

% ccINF_superset_mono
thf(fact_7118_mono__ccSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ A @ A5 )
           => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A5 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ) ).

% mono_ccSup
thf(fact_7119_mono__ccSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,I6: set @ C,A5: C > A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ C @ I6 )
           => ( ord_less_eq @ B
              @ ( complete_Sup_Sup @ B
                @ ( image @ C @ B
                  @ ^ [X3: C] : ( F2 @ ( A5 @ X3 ) )
                  @ I6 ) )
              @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A5 @ I6 ) ) ) ) ) ) ) ).

% mono_ccSUP
thf(fact_7120_mono__ccInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ A @ A5 )
           => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A5 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ) ).

% mono_ccInf
thf(fact_7121_mono__ccINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,I6: set @ C,A5: C > A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ C @ I6 )
           => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A5 @ I6 ) ) )
              @ ( complete_Inf_Inf @ B
                @ ( image @ C @ B
                  @ ^ [X3: C] : ( F2 @ ( A5 @ X3 ) )
                  @ I6 ) ) ) ) ) ) ).

% mono_ccINF
thf(fact_7122_butlast__conv__take,axiom,
    ! [A: $tType] :
      ( ( butlast @ A )
      = ( ^ [Xs3: list @ A] : ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( one_one @ nat ) ) @ Xs3 ) ) ) ).

% butlast_conv_take
thf(fact_7123_butlast__list__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,X: A] :
      ( ( ( K
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs @ K @ X ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( K
         != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs @ K @ X ) )
          = ( list_update @ A @ ( butlast @ A @ Xs ) @ K @ X ) ) ) ) ).

% butlast_list_update
thf(fact_7124_butlast__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( butlast @ A @ ( take @ A @ N @ Xs ) )
        = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% butlast_take
thf(fact_7125_sort__key__conv__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
         => ( ( linorder_sort_key @ B @ A @ F2 @ Xs )
            = ( fold @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 ) @ Xs @ ( nil @ B ) ) ) ) ) ).

% sort_key_conv_fold
thf(fact_7126_minus__set__fold,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( set2 @ A @ Xs ) )
      = ( fold @ A @ ( set @ A ) @ ( remove @ A ) @ Xs @ A5 ) ) ).

% minus_set_fold
thf(fact_7127_sort__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( linorder_sort_key @ nat @ nat
        @ ^ [X3: nat] : X3
        @ ( upt @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% sort_upt
thf(fact_7128_sort__upto,axiom,
    ! [I: int,J: int] :
      ( ( linorder_sort_key @ int @ int
        @ ^ [X3: int] : X3
        @ ( upto @ I @ J ) )
      = ( upto @ I @ J ) ) ).

% sort_upto
thf(fact_7129_sort__key__simps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A] :
          ( ( linorder_sort_key @ B @ A @ F2 @ ( nil @ B ) )
          = ( nil @ B ) ) ) ).

% sort_key_simps(1)
thf(fact_7130_set__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( set2 @ B @ Xs ) ) ) ).

% set_sort
thf(fact_7131_length__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( size_size @ ( list @ B ) @ Xs ) ) ) ).

% length_sort
thf(fact_7132_distinct__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( distinct @ B @ Xs ) ) ) ).

% distinct_sort
thf(fact_7133_sort__key__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( linorder_sort_key @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
          = ( linorder_insort_key @ B @ A @ F2 @ X @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) ) ) ) ).

% sort_key_simps(2)
thf(fact_7134_sort__key__stable,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,K: B,Xs: list @ A] :
          ( ( filter2 @ A
            @ ^ [Y4: A] :
                ( ( F2 @ Y4 )
                = K )
            @ ( linorder_sort_key @ A @ B @ F2 @ Xs ) )
          = ( filter2 @ A
            @ ^ [Y4: A] :
                ( ( F2 @ Y4 )
                = K )
            @ Xs ) ) ) ).

% sort_key_stable
thf(fact_7135_filter__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F2: B > A,Xs: list @ B] :
          ( ( filter2 @ B @ P @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( linorder_sort_key @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ).

% filter_sort
thf(fact_7136_sort__key__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [C2: B,Xs: list @ A] :
          ( ( linorder_sort_key @ A @ B
            @ ^ [X3: A] : C2
            @ Xs )
          = Xs ) ) ).

% sort_key_const
thf(fact_7137_sorted__sort__id,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( linorder_sort_key @ A @ A
              @ ^ [X3: A] : X3
              @ Xs )
            = Xs ) ) ) ).

% sorted_sort_id
thf(fact_7138_sorted__sort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( linorder_sort_key @ A @ A
            @ ^ [X3: A] : X3
            @ Xs ) ) ) ).

% sorted_sort
thf(fact_7139_sorted__sort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_sort_key
thf(fact_7140_remove__code_I1_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remove @ A @ X @ ( set2 @ A @ Xs ) )
      = ( set2 @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% remove_code(1)
thf(fact_7141_sorted__list__of__set__sort__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
          = ( linorder_sort_key @ A @ A
            @ ^ [X3: A] : X3
            @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_list_of_set_sort_remdups
thf(fact_7142_sort__conv__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linorder_sort_key @ A @ A
            @ ^ [X3: A] : X3
            @ Xs )
          = ( fold @ A @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3 )
            @ Xs
            @ ( nil @ A ) ) ) ) ).

% sort_conv_fold
thf(fact_7143_sort__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ B @ A )
        = ( ^ [F3: B > A,Xs3: list @ B] : ( foldr @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 ) @ Xs3 @ ( nil @ B ) ) ) ) ) ).

% sort_key_def
thf(fact_7144_Bleast__code,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( bleast @ A @ ( set2 @ A @ Xs ) @ P )
          = ( case_list @ A @ A @ ( abort_Bleast @ A @ ( set2 @ A @ Xs ) @ P )
            @ ^ [X3: A,Xs3: list @ A] : X3
            @ ( filter2 @ A @ P
              @ ( linorder_sort_key @ A @ A
                @ ^ [X3: A] : X3
                @ Xs ) ) ) ) ) ).

% Bleast_code
thf(fact_7145_inter__coset__fold,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( coset @ A @ Xs ) )
      = ( fold @ A @ ( set @ A ) @ ( remove @ A ) @ Xs @ A5 ) ) ).

% inter_coset_fold
thf(fact_7146_UNIV__coset,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( coset @ A @ ( nil @ A ) ) ) ).

% UNIV_coset
thf(fact_7147_subset__code_I2_J,axiom,
    ! [B: $tType,A5: set @ B,Ys2: list @ B] :
      ( ( ord_less_eq @ ( set @ B ) @ A5 @ ( coset @ B @ Ys2 ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ ( set2 @ B @ Ys2 ) )
           => ~ ( member @ B @ X3 @ A5 ) ) ) ) ).

% subset_code(2)
thf(fact_7148_compl__coset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( coset @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% compl_coset
thf(fact_7149_coset__def,axiom,
    ! [A: $tType] :
      ( ( coset @ A )
      = ( ^ [Xs3: list @ A] : ( uminus_uminus @ ( set @ A ) @ ( set2 @ A @ Xs3 ) ) ) ) ).

% coset_def
thf(fact_7150_insert__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( insert2 @ A @ X @ ( coset @ A @ Xs ) )
      = ( coset @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% insert_code(2)
thf(fact_7151_union__coset__filter,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( coset @ A @ Xs ) @ A5 )
      = ( coset @ A
        @ ( filter2 @ A
          @ ^ [X3: A] :
              ~ ( member @ A @ X3 @ A5 )
          @ Xs ) ) ) ).

% union_coset_filter
thf(fact_7152_subset__code_I3_J,axiom,
    ! [C: $tType] :
      ~ ( ord_less_eq @ ( set @ C ) @ ( coset @ C @ ( nil @ C ) ) @ ( set2 @ C @ ( nil @ C ) ) ) ).

% subset_code(3)
thf(fact_7153_minus__coset__filter,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( coset @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ A5 )
          @ Xs ) ) ) ).

% minus_coset_filter
thf(fact_7154_vanishes__mult__bounded,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ? [A18: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ A18 )
          & ! [N2: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N2 ) ) @ A18 ) )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N3: nat] : ( times_times @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ).

% vanishes_mult_bounded
thf(fact_7155_rcis__inverse,axiom,
    ! [R2: real,A2: real] :
      ( ( inverse_inverse @ complex @ ( rcis @ R2 @ A2 ) )
      = ( rcis @ ( divide_divide @ real @ ( one_one @ real ) @ R2 ) @ ( uminus_uminus @ real @ A2 ) ) ) ).

% rcis_inverse
thf(fact_7156_vanishes__const,axiom,
    ! [C2: rat] :
      ( ( vanishes
        @ ^ [N3: nat] : C2 )
      = ( C2
        = ( zero_zero @ rat ) ) ) ).

% vanishes_const
thf(fact_7157_rcis__zero__arg,axiom,
    ! [R2: real] :
      ( ( rcis @ R2 @ ( zero_zero @ real ) )
      = ( real_Vector_of_real @ complex @ R2 ) ) ).

% rcis_zero_arg
thf(fact_7158_rcis__eq__zero__iff,axiom,
    ! [R2: real,A2: real] :
      ( ( ( rcis @ R2 @ A2 )
        = ( zero_zero @ complex ) )
      = ( R2
        = ( zero_zero @ real ) ) ) ).

% rcis_eq_zero_iff
thf(fact_7159_rcis__zero__mod,axiom,
    ! [A2: real] :
      ( ( rcis @ ( zero_zero @ real ) @ A2 )
      = ( zero_zero @ complex ) ) ).

% rcis_zero_mod
thf(fact_7160_vanishes__add,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( vanishes @ X8 )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N3: nat] : ( plus_plus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ).

% vanishes_add
thf(fact_7161_vanishes__minus,axiom,
    ! [X8: nat > rat] :
      ( ( vanishes @ X8 )
     => ( vanishes
        @ ^ [N3: nat] : ( uminus_uminus @ rat @ ( X8 @ N3 ) ) ) ) ).

% vanishes_minus
thf(fact_7162_vanishes__diff,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( vanishes @ X8 )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N3: nat] : ( minus_minus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ).

% vanishes_diff
thf(fact_7163_vanishes__def,axiom,
    ( vanishes
    = ( ^ [X7: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K4: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K4 @ N3 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X7 @ N3 ) ) @ R5 ) ) ) ) ) ).

% vanishes_def
thf(fact_7164_vanishesI,axiom,
    ! [X8: nat > rat] :
      ( ! [R: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
         => ? [K3: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N2 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N2 ) ) @ R ) ) )
     => ( vanishes @ X8 ) ) ).

% vanishesI
thf(fact_7165_vanishesD,axiom,
    ! [X8: nat > rat,R2: rat] :
      ( ( vanishes @ X8 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
       => ? [K2: nat] :
          ! [N6: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N6 )
           => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N6 ) ) @ R2 ) ) ) ) ).

% vanishesD
thf(fact_7166_DeMoivre2,axiom,
    ! [R2: real,A2: real,N: nat] :
      ( ( power_power @ complex @ ( rcis @ R2 @ A2 ) @ N )
      = ( rcis @ ( power_power @ real @ R2 @ N ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre2
thf(fact_7167_cauchy__def,axiom,
    ( cauchy
    = ( ^ [X7: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K4: nat] :
            ! [M2: nat] :
              ( ( ord_less_eq @ nat @ K4 @ M2 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N3 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X7 @ M2 ) @ ( X7 @ N3 ) ) ) @ R5 ) ) ) ) ) ) ).

% cauchy_def
thf(fact_7168_cauchyI,axiom,
    ! [X8: nat > rat] :
      ( ! [R: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
         => ? [K3: nat] :
            ! [M4: nat] :
              ( ( ord_less_eq @ nat @ K3 @ M4 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N2 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) ) @ R ) ) ) )
     => ( cauchy @ X8 ) ) ).

% cauchyI
thf(fact_7169_cauchy__diff,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N3: nat] : ( minus_minus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ).

% cauchy_diff
thf(fact_7170_cauchy__add,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N3: nat] : ( plus_plus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ).

% cauchy_add
thf(fact_7171_cauchy__minus,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( cauchy
        @ ^ [N3: nat] : ( uminus_uminus @ rat @ ( X8 @ N3 ) ) ) ) ).

% cauchy_minus
thf(fact_7172_cauchy__const,axiom,
    ! [X: rat] :
      ( cauchy
      @ ^ [N3: nat] : X ) ).

% cauchy_const
thf(fact_7173_cauchy__mult,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N3: nat] : ( times_times @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ).

% cauchy_mult
thf(fact_7174_cauchy__inverse,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ( cauchy
          @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X8 @ N3 ) ) ) ) ) ).

% cauchy_inverse
thf(fact_7175_cauchy__imp__bounded,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ? [B4: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
          & ! [N6: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N6 ) ) @ B4 ) ) ) ).

% cauchy_imp_bounded
thf(fact_7176_vanishes__diff__inverse,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ( ( cauchy @ Y6 )
         => ( ~ ( vanishes @ Y6 )
           => ( ( vanishes
                @ ^ [N3: nat] : ( minus_minus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) )
             => ( vanishes
                @ ^ [N3: nat] : ( minus_minus @ rat @ ( inverse_inverse @ rat @ ( X8 @ N3 ) ) @ ( inverse_inverse @ rat @ ( Y6 @ N3 ) ) ) ) ) ) ) ) ) ).

% vanishes_diff_inverse
thf(fact_7177_cauchy__not__vanishes__cases,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ? [B4: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
            & ? [K2: nat] :
                ( ! [N6: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N6 )
                   => ( ord_less @ rat @ B4 @ ( uminus_uminus @ rat @ ( X8 @ N6 ) ) ) )
                | ! [N6: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N6 )
                   => ( ord_less @ rat @ B4 @ ( X8 @ N6 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes_cases
thf(fact_7178_cauchy__not__vanishes,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ? [B4: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
            & ? [K2: nat] :
              ! [N6: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N6 )
               => ( ord_less @ rat @ B4 @ ( abs_abs @ rat @ ( X8 @ N6 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes
thf(fact_7179_cauchyD,axiom,
    ! [X8: nat > rat,R2: rat] :
      ( ( cauchy @ X8 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
       => ? [K2: nat] :
          ! [M3: nat] :
            ( ( ord_less_eq @ nat @ K2 @ M3 )
           => ! [N6: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N6 )
               => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M3 ) @ ( X8 @ N6 ) ) ) @ R2 ) ) ) ) ) ).

% cauchyD
thf(fact_7180_le__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( ord_less_eq @ real @ ( real2 @ X8 ) @ ( real2 @ Y6 ) )
          = ( ! [R5: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
               => ? [K4: nat] :
                  ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ K4 @ N3 )
                   => ( ord_less_eq @ rat @ ( X8 @ N3 ) @ ( plus_plus @ rat @ ( Y6 @ N3 ) @ R5 ) ) ) ) ) ) ) ) ).

% le_Real
thf(fact_7181_inverse__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( ( vanishes @ X8 )
         => ( ( inverse_inverse @ real @ ( real2 @ X8 ) )
            = ( zero_zero @ real ) ) )
        & ( ~ ( vanishes @ X8 )
         => ( ( inverse_inverse @ real @ ( real2 @ X8 ) )
            = ( real2
              @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X8 @ N3 ) ) ) ) ) ) ) ).

% inverse_Real
thf(fact_7182_Real__induct,axiom,
    ! [P: real > $o,X: real] :
      ( ! [X9: nat > rat] :
          ( ( cauchy @ X9 )
         => ( P @ ( real2 @ X9 ) ) )
     => ( P @ X ) ) ).

% Real_induct
thf(fact_7183_one__real__def,axiom,
    ( ( one_one @ real )
    = ( real2
      @ ^ [N3: nat] : ( one_one @ rat ) ) ) ).

% one_real_def
thf(fact_7184_zero__real__def,axiom,
    ( ( zero_zero @ real )
    = ( real2
      @ ^ [N3: nat] : ( zero_zero @ rat ) ) ) ).

% zero_real_def
thf(fact_7185_of__int__Real,axiom,
    ( ( ring_1_of_int @ real )
    = ( ^ [X3: int] :
          ( real2
          @ ^ [N3: nat] : ( ring_1_of_int @ rat @ X3 ) ) ) ) ).

% of_int_Real
thf(fact_7186_of__nat__Real,axiom,
    ( ( semiring_1_of_nat @ real )
    = ( ^ [X3: nat] :
          ( real2
          @ ^ [N3: nat] : ( semiring_1_of_nat @ rat @ X3 ) ) ) ) ).

% of_nat_Real
thf(fact_7187_minus__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( uminus_uminus @ real @ ( real2 @ X8 ) )
        = ( real2
          @ ^ [N3: nat] : ( uminus_uminus @ rat @ ( X8 @ N3 ) ) ) ) ) ).

% minus_Real
thf(fact_7188_add__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( plus_plus @ real @ ( real2 @ X8 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N3: nat] : ( plus_plus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ) ).

% add_Real
thf(fact_7189_mult__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( times_times @ real @ ( real2 @ X8 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N3: nat] : ( times_times @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ) ).

% mult_Real
thf(fact_7190_diff__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( minus_minus @ real @ ( real2 @ X8 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N3: nat] : ( minus_minus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ) ).

% diff_Real
thf(fact_7191_eq__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( ( real2 @ X8 )
            = ( real2 @ Y6 ) )
          = ( vanishes
            @ ^ [N3: nat] : ( minus_minus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) ) ) ) ) ).

% eq_Real
thf(fact_7192_not__positive__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( ~ ( positive2 @ ( real2 @ X8 ) ) )
        = ( ! [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
             => ? [K4: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N3 )
                 => ( ord_less_eq @ rat @ ( X8 @ N3 ) @ R5 ) ) ) ) ) ) ).

% not_positive_Real
thf(fact_7193_positive__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( positive2 @ ( real2 @ X8 ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K4: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N3 )
                 => ( ord_less @ rat @ R5 @ ( X8 @ N3 ) ) ) ) ) ) ) ).

% positive_Real
thf(fact_7194_Real_Opositive__add,axiom,
    ! [X: real,Y: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y )
       => ( positive2 @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% Real.positive_add
thf(fact_7195_Real_Opositive__zero,axiom,
    ~ ( positive2 @ ( zero_zero @ real ) ) ).

% Real.positive_zero
thf(fact_7196_Real_Opositive__mult,axiom,
    ! [X: real,Y: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y )
       => ( positive2 @ ( times_times @ real @ X @ Y ) ) ) ) ).

% Real.positive_mult
thf(fact_7197_Real_Opositive__minus,axiom,
    ! [X: real] :
      ( ~ ( positive2 @ X )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( positive2 @ ( uminus_uminus @ real @ X ) ) ) ) ).

% Real.positive_minus
thf(fact_7198_less__real__def,axiom,
    ( ( ord_less @ real )
    = ( ^ [X3: real,Y4: real] : ( positive2 @ ( minus_minus @ real @ Y4 @ X3 ) ) ) ) ).

% less_real_def
thf(fact_7199_Real_Opositive_Orep__eq,axiom,
    ( positive2
    = ( ^ [X3: real] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K4: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K4 @ N3 )
             => ( ord_less @ rat @ R5 @ ( rep_real @ X3 @ N3 ) ) ) ) ) ) ).

% Real.positive.rep_eq
thf(fact_7200_inverse__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( inverse_inverse @ real @ ( real2 @ X ) )
        = ( real2
          @ ( if @ ( nat > rat ) @ ( vanishes @ X )
            @ ^ [N3: nat] : ( zero_zero @ rat )
            @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X @ N3 ) ) ) ) ) ) ).

% inverse_real.abs_eq
thf(fact_7201_realrel__refl,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( realrel @ X8 @ X8 ) ) ).

% realrel_refl
thf(fact_7202_one__real_Orsp,axiom,
    ( realrel
    @ ^ [N3: nat] : ( one_one @ rat )
    @ ^ [N3: nat] : ( one_one @ rat ) ) ).

% one_real.rsp
thf(fact_7203_zero__real_Orsp,axiom,
    ( realrel
    @ ^ [N3: nat] : ( zero_zero @ rat )
    @ ^ [N3: nat] : ( zero_zero @ rat ) ) ).

% zero_real.rsp
thf(fact_7204_real_Oabs__induct,axiom,
    ! [P: real > $o,X: real] :
      ( ! [Y2: nat > rat] :
          ( ( realrel @ Y2 @ Y2 )
         => ( P @ ( real2 @ Y2 ) ) )
     => ( P @ X ) ) ).

% real.abs_induct
thf(fact_7205_uminus__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( uminus_uminus @ real @ ( real2 @ X ) )
        = ( real2
          @ ^ [N3: nat] : ( uminus_uminus @ rat @ ( X @ N3 ) ) ) ) ) ).

% uminus_real.abs_eq
thf(fact_7206_plus__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X @ X )
       => ( ( plus_plus @ real @ ( real2 @ Xa ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N3: nat] : ( plus_plus @ rat @ ( Xa @ N3 ) @ ( X @ N3 ) ) ) ) ) ) ).

% plus_real.abs_eq
thf(fact_7207_times__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X @ X )
       => ( ( times_times @ real @ ( real2 @ Xa ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N3: nat] : ( times_times @ rat @ ( Xa @ N3 ) @ ( X @ N3 ) ) ) ) ) ) ).

% times_real.abs_eq
thf(fact_7208_realrelI,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( vanishes
            @ ^ [N3: nat] : ( minus_minus @ rat @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) )
         => ( realrel @ X8 @ Y6 ) ) ) ) ).

% realrelI
thf(fact_7209_realrel__def,axiom,
    ( realrel
    = ( ^ [X7: nat > rat,Y7: nat > rat] :
          ( ( cauchy @ X7 )
          & ( cauchy @ Y7 )
          & ( vanishes
            @ ^ [N3: nat] : ( minus_minus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ) ).

% realrel_def
thf(fact_7210_Real_Opositive_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( positive2 @ ( real2 @ X ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K4: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N3 )
                 => ( ord_less @ rat @ R5 @ ( X @ N3 ) ) ) ) ) ) ) ).

% Real.positive.abs_eq
thf(fact_7211_Real_Opositive__def,axiom,
    ( positive2
    = ( map_fun @ real @ ( nat > rat ) @ $o @ $o @ rep_real @ ( id @ $o )
      @ ^ [X7: nat > rat] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K4: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K4 @ N3 )
             => ( ord_less @ rat @ R5 @ ( X7 @ N3 ) ) ) ) ) ) ).

% Real.positive_def
thf(fact_7212_inverse__real__def,axiom,
    ( ( inverse_inverse @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X7: nat > rat] :
          ( if @ ( nat > rat ) @ ( vanishes @ X7 )
          @ ^ [N3: nat] : ( zero_zero @ rat )
          @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X7 @ N3 ) ) ) ) ) ).

% inverse_real_def
thf(fact_7213_uminus__real__def,axiom,
    ( ( uminus_uminus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X7: nat > rat,N3: nat] : ( uminus_uminus @ rat @ ( X7 @ N3 ) ) ) ) ).

% uminus_real_def
thf(fact_7214_times__real__def,axiom,
    ( ( times_times @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X7: nat > rat,Y7: nat > rat,N3: nat] : ( times_times @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ).

% times_real_def
thf(fact_7215_plus__real__def,axiom,
    ( ( plus_plus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X7: nat > rat,Y7: nat > rat,N3: nat] : ( plus_plus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ).

% plus_real_def
thf(fact_7216_Real_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ $o @ $o @ realrel
    @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
    @ ^ [X7: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K4: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ K4 @ N3 )
           => ( ord_less @ rat @ R5 @ ( X7 @ N3 ) ) ) )
    @ ^ [X7: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K4: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ K4 @ N3 )
           => ( ord_less @ rat @ R5 @ ( X7 @ N3 ) ) ) ) ) ).

% Real.positive.rsp
thf(fact_7217_cr__real__def,axiom,
    ( cr_real
    = ( ^ [X3: nat > rat,Y4: real] :
          ( ( realrel @ X3 @ X3 )
          & ( ( real2 @ X3 )
            = Y4 ) ) ) ) ).

% cr_real_def
thf(fact_7218_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R4 @ ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R4
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
                @ R4 )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_7219_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R4 @ ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y3: num,Z: num] : ( Y3 = Z )
                @ R4
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_7220_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R4 @ ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y3: int,Z: int] : ( Y3 = Z )
                  @ R4
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_7221_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R4 @ ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
                @ R4
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_7222_fun_Orel__mono,axiom,
    ! [D: $tType,B: $tType,A: $tType,R4: A > B > $o,Ra: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R4 @ Ra )
     => ( ord_less_eq @ ( ( D > A ) > ( D > B ) > $o )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ R4 )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Ra ) ) ) ).

% fun.rel_mono
thf(fact_7223_times__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X7: nat > rat,Y7: nat > rat,N3: nat] : ( times_times @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) )
    @ ^ [X7: nat > rat,Y7: nat > rat,N3: nat] : ( times_times @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ).

% times_real.rsp
thf(fact_7224_plus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X7: nat > rat,Y7: nat > rat,N3: nat] : ( plus_plus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) )
    @ ^ [X7: nat > rat,Y7: nat > rat,N3: nat] : ( plus_plus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ).

% plus_real.rsp
thf(fact_7225_uminus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X7: nat > rat,N3: nat] : ( uminus_uminus @ rat @ ( X7 @ N3 ) )
    @ ^ [X7: nat > rat,N3: nat] : ( uminus_uminus @ rat @ ( X7 @ N3 ) ) ) ).

% uminus_real.rsp
thf(fact_7226_integer__of__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ int @ int
    @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
    @ ^ [Y3: int,Z: int] : ( Y3 = Z )
    @ ( semiring_1_of_nat @ int )
    @ ( semiring_1_of_nat @ int ) ) ).

% integer_of_natural.rsp
thf(fact_7227_less__eq__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y3: int,Z: int] : ( Y3 = Z )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y3: int,Z: int] : ( Y3 = Z )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ ( ord_less_eq @ int )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_integer.rsp
thf(fact_7228_less__eq__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ ( ord_less_eq @ nat )
    @ ( ord_less_eq @ nat ) ) ).

% less_eq_natural.rsp
thf(fact_7229_less__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ ( ord_less @ nat )
    @ ( ord_less @ nat ) ) ).

% less_natural.rsp
thf(fact_7230_less__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y3: int,Z: int] : ( Y3 = Z )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y3: int,Z: int] : ( Y3 = Z )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ ( ord_less @ int )
    @ ( ord_less @ int ) ) ).

% less_integer.rsp
thf(fact_7231_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
              @ R4
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_7232_inverse__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X7: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X7 )
        @ ^ [N3: nat] : ( zero_zero @ rat )
        @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X7 @ N3 ) ) )
    @ ^ [X7: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X7 )
        @ ^ [N3: nat] : ( zero_zero @ rat )
        @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X7 @ N3 ) ) ) ) ).

% inverse_real.rsp
thf(fact_7233_fun__mono,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,C4: A > B > $o,A5: A > B > $o,B6: C > D > $o,D5: C > D > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ C4 @ A5 )
     => ( ( ord_less_eq @ ( C > D > $o ) @ B6 @ D5 )
       => ( ord_less_eq @ ( ( A > C ) > ( B > D ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A5 @ B6 ) @ ( bNF_rel_fun @ A @ B @ C @ D @ C4 @ D5 ) ) ) ) ).

% fun_mono
thf(fact_7234_Real_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
    @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
    @ ^ [X7: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K4: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ K4 @ N3 )
           => ( ord_less @ rat @ R5 @ ( X7 @ N3 ) ) ) )
    @ positive2 ) ).

% Real.positive.transfer
thf(fact_7235_real_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > $o ) @ ( real > $o ) @ pcr_real
    @ ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ realrel
    @ ^ [Y3: real,Z: real] : ( Y3 = Z ) ) ).

% real.rel_eq_transfer
thf(fact_7236_real_Opcr__cr__eq,axiom,
    pcr_real = cr_real ).

% real.pcr_cr_eq
thf(fact_7237_zero__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N3: nat] : ( zero_zero @ rat )
    @ ( zero_zero @ real ) ) ).

% zero_real.transfer
thf(fact_7238_one__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N3: nat] : ( one_one @ rat )
    @ ( one_one @ real ) ) ).

% one_real.transfer
thf(fact_7239_cr__real__eq,axiom,
    ( pcr_real
    = ( ^ [X3: nat > rat,Y4: real] :
          ( ( cauchy @ X3 )
          & ( ( real2 @ X3 )
            = Y4 ) ) ) ) ).

% cr_real_eq
thf(fact_7240_uminus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X7: nat > rat,N3: nat] : ( uminus_uminus @ rat @ ( X7 @ N3 ) )
    @ ( uminus_uminus @ real ) ) ).

% uminus_real.transfer
thf(fact_7241_plus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X7: nat > rat,Y7: nat > rat,N3: nat] : ( plus_plus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) )
    @ ( plus_plus @ real ) ) ).

% plus_real.transfer
thf(fact_7242_times__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X7: nat > rat,Y7: nat > rat,N3: nat] : ( times_times @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) )
    @ ( times_times @ real ) ) ).

% times_real.transfer
thf(fact_7243_inverse__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X7: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X7 )
        @ ^ [N3: nat] : ( zero_zero @ rat )
        @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X7 @ N3 ) ) )
    @ ( inverse_inverse @ real ) ) ).

% inverse_real.transfer
thf(fact_7244_times__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) )
    @ ( times_times @ int ) ) ).

% times_int.transfer
thf(fact_7245_minus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) )
    @ ( minus_minus @ int ) ) ).

% minus_int.transfer
thf(fact_7246_zero__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( zero_zero @ int ) ).

% zero_int.transfer
thf(fact_7247_int__transfer,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( product_prod @ nat @ nat ) @ int
    @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
    @ pcr_int
    @ ^ [N3: nat] : ( product_Pair @ nat @ nat @ N3 @ ( zero_zero @ nat ) )
    @ ( semiring_1_of_nat @ int ) ) ).

% int_transfer
thf(fact_7248_uminus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X3 ) )
    @ ( uminus_uminus @ int ) ) ).

% uminus_int.transfer
thf(fact_7249_nat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ nat @ nat @ pcr_int
    @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ nat2 ) ).

% nat.transfer
thf(fact_7250_one__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( one_one @ int ) ).

% one_int.transfer
thf(fact_7251_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ A @ A @ pcr_int
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) ) )
        @ ( ring_1_of_int @ A ) ) ) ).

% of_int.transfer
thf(fact_7252_less__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( ord_less @ int ) ) ).

% less_int.transfer
thf(fact_7253_less__eq__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_int.transfer
thf(fact_7254_plus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) )
    @ ( plus_plus @ int ) ) ).

% plus_int.transfer
thf(fact_7255_times__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) ) ) ).

% times_int.rsp
thf(fact_7256_mono__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ D )
        & ( order @ C )
        & ( order @ A ) )
     => ! [A5: A > B > $o,B6: C > D > $o] :
          ( ( bi_total @ A @ B @ A5 )
         => ( ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A5
              @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
                @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
              @ ( ord_less_eq @ A )
              @ ( ord_less_eq @ B ) )
           => ( ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B6
                @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B6
                  @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
                @ ( ord_less_eq @ C )
                @ ( ord_less_eq @ D ) )
             => ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A5 @ B6 )
                @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
                @ ( order_mono @ A @ C )
                @ ( order_mono @ B @ D ) ) ) ) ) ) ).

% mono_transfer
thf(fact_7257_intrel__iff,axiom,
    ! [X: nat,Y: nat,U: nat,V2: nat] :
      ( ( intrel @ ( product_Pair @ nat @ nat @ X @ Y ) @ ( product_Pair @ nat @ nat @ U @ V2 ) )
      = ( ( plus_plus @ nat @ X @ V2 )
        = ( plus_plus @ nat @ U @ Y ) ) ) ).

% intrel_iff
thf(fact_7258_int_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ intrel
    @ ^ [Y3: int,Z: int] : ( Y3 = Z ) ) ).

% int.rel_eq_transfer
thf(fact_7259_int_Obi__total,axiom,
    bi_total @ ( product_prod @ nat @ nat ) @ int @ pcr_int ).

% int.bi_total
thf(fact_7260_int_Oabs__eq__iff,axiom,
    ! [X: product_prod @ nat @ nat,Y: product_prod @ nat @ nat] :
      ( ( ( abs_Integ @ X )
        = ( abs_Integ @ Y ) )
      = ( intrel @ X @ Y ) ) ).

% int.abs_eq_iff
thf(fact_7261_zero__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ).

% zero_int.rsp
thf(fact_7262_uminus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X3 ) )
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X3 ) ) ) ).

% uminus_int.rsp
thf(fact_7263_nat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ nat @ nat @ intrel
    @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ).

% nat.rsp
thf(fact_7264_one__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ).

% one_int.rsp
thf(fact_7265_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ A @ A @ intrel
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) ) )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ) ).

% of_int.rsp
thf(fact_7266_intrel__def,axiom,
    ( intrel
    = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] :
              ( ( plus_plus @ nat @ X3 @ V5 )
              = ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% intrel_def
thf(fact_7267_less__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% less_int.rsp
thf(fact_7268_less__eq__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% less_eq_int.rsp
thf(fact_7269_minus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) ) ) ).

% minus_int.rsp
thf(fact_7270_plus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) ) ) ).

% plus_int.rsp
thf(fact_7271_monotone__parametric,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A5: A > B > $o,B6: C > D > $o] :
      ( ( bi_total @ A @ B @ A5 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( C > C > $o ) > ( A > C ) > $o ) @ ( ( D > D > $o ) > ( B > D ) > $o )
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A5
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( C > C > $o ) @ ( D > D > $o ) @ ( ( A > C ) > $o ) @ ( ( B > D ) > $o )
          @ ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B6
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B6
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A5 @ B6 )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( comple7038119648293358887notone @ A @ C )
        @ ( comple7038119648293358887notone @ B @ D ) ) ) ).

% monotone_parametric
thf(fact_7272_fun__ord__parametric,axiom,
    ! [C: $tType,D: $tType,A: $tType,B: $tType,F: $tType,E4: $tType,C4: A > B > $o,A5: C > E4 > $o,B6: D > F > $o] :
      ( ( bi_total @ A @ B @ C4 )
     => ( bNF_rel_fun @ ( C > D > $o ) @ ( E4 > F > $o ) @ ( ( A > C ) > ( A > D ) > $o ) @ ( ( B > E4 ) > ( B > F ) > $o )
        @ ( bNF_rel_fun @ C @ E4 @ ( D > $o ) @ ( F > $o ) @ A5
          @ ( bNF_rel_fun @ D @ F @ $o @ $o @ B6
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( A > C ) @ ( B > E4 ) @ ( ( A > D ) > $o ) @ ( ( B > F ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ E4 @ C4 @ A5 )
          @ ( bNF_rel_fun @ ( A > D ) @ ( B > F ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ D @ F @ C4 @ B6 )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( partial_fun_ord @ C @ D @ A )
        @ ( partial_fun_ord @ E4 @ F @ B ) ) ) ).

% fun_ord_parametric
thf(fact_7273_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat,S: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S ) ) ) )
           => ( ( infini527867602293511546merate @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S ) ) @ N )
              = ( infini527867602293511546merate @ A @ S2 @ N ) ) ) ) ) ).

% finite_enumerate_initial_segment
thf(fact_7274_stable__sort__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord3483353639454293061rt_key @ B @ A )
        = ( ^ [Sk: ( B > A ) > ( list @ B ) > ( list @ B )] :
            ! [F3: B > A,Xs3: list @ B,K4: A] :
              ( ( filter2 @ B
                @ ^ [Y4: B] :
                    ( ( F3 @ Y4 )
                    = K4 )
                @ ( Sk @ F3 @ Xs3 ) )
              = ( filter2 @ B
                @ ^ [Y4: B] :
                    ( ( F3 @ Y4 )
                    = K4 )
                @ Xs3 ) ) ) ) ) ).

% stable_sort_key_def
thf(fact_7275_enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,M: nat,N: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M ) @ ( infini527867602293511546merate @ A @ S2 @ N ) )
            = ( ord_less @ nat @ M @ N ) ) ) ) ).

% enumerate_mono_iff
thf(fact_7276_finite__enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,M: nat,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ M @ ( finite_card @ A @ S2 ) )
           => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S2 ) )
             => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M ) @ ( infini527867602293511546merate @ A @ S2 @ N ) )
                = ( ord_less @ nat @ M @ N ) ) ) ) ) ) ).

% finite_enumerate_mono_iff
thf(fact_7277_le__enumerate,axiom,
    ! [S2: set @ nat,N: nat] :
      ( ~ ( finite_finite @ nat @ S2 )
     => ( ord_less_eq @ nat @ N @ ( infini527867602293511546merate @ nat @ S2 @ N ) ) ) ).

% le_enumerate
thf(fact_7278_enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) ) ) ) ) ).

% enumerate_step
thf(fact_7279_enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M: nat,N: nat,S2: set @ A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ~ ( finite_finite @ A @ S2 )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M ) @ ( infini527867602293511546merate @ A @ S2 @ N ) ) ) ) ) ).

% enumerate_mono
thf(fact_7280_finite__enum__ext,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X8: set @ A,Y6: set @ A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( finite_card @ A @ X8 ) )
             => ( ( infini527867602293511546merate @ A @ X8 @ I2 )
                = ( infini527867602293511546merate @ A @ Y6 @ I2 ) ) )
         => ( ( finite_finite @ A @ X8 )
           => ( ( finite_finite @ A @ Y6 )
             => ( ( ( finite_card @ A @ X8 )
                  = ( finite_card @ A @ Y6 ) )
               => ( X8 = Y6 ) ) ) ) ) ) ).

% finite_enum_ext
thf(fact_7281_finite__enumerate__Ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,S: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( member @ A @ S @ S2 )
           => ? [N2: nat] :
                ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ S2 ) )
                & ( ( infini527867602293511546merate @ A @ S2 @ N2 )
                  = S ) ) ) ) ) ).

% finite_enumerate_Ex
thf(fact_7282_finite__enumerate__in__set,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S2 ) )
           => ( member @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S2 ) ) ) ) ).

% finite_enumerate_in_set
thf(fact_7283_finite__enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M: nat,N: nat,S2: set @ A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( finite_finite @ A @ S2 )
           => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S2 ) )
             => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M ) @ ( infini527867602293511546merate @ A @ S2 @ N ) ) ) ) ) ) ).

% finite_enumerate_mono
thf(fact_7284_finite__le__enumerate,axiom,
    ! [S2: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ S2 )
     => ( ( ord_less @ nat @ N @ ( finite_card @ nat @ S2 ) )
       => ( ord_less_eq @ nat @ N @ ( infini527867602293511546merate @ nat @ S2 @ N ) ) ) ) ).

% finite_le_enumerate
thf(fact_7285_stable__sort__key__sort__key,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ( linord3483353639454293061rt_key @ A @ B @ ( linorder_sort_key @ A @ B ) ) ) ).

% stable_sort_key_sort_key
thf(fact_7286_finite__enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S2 ) )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) ) ) ) ) ) ).

% finite_enumerate_step
thf(fact_7287_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert2 @ A @ ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) ) @ ( bot_bot @ ( set @ A ) ) ) ) @ N ) ) ) ).

% enumerate_Suc'
thf(fact_7288_finite__enum__subset,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X8: set @ A,Y6: set @ A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( finite_card @ A @ X8 ) )
             => ( ( infini527867602293511546merate @ A @ X8 @ I2 )
                = ( infini527867602293511546merate @ A @ Y6 @ I2 ) ) )
         => ( ( finite_finite @ A @ X8 )
           => ( ( finite_finite @ A @ Y6 )
             => ( ( ord_less_eq @ nat @ ( finite_card @ A @ X8 ) @ ( finite_card @ A @ Y6 ) )
               => ( ord_less_eq @ ( set @ A ) @ X8 @ Y6 ) ) ) ) ) ) ).

% finite_enum_subset
thf(fact_7289_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S2 ) )
           => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
              = ( ord_Least @ A
                @ ^ [S6: A] :
                    ( ( member @ A @ S6 @ S2 )
                    & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S6 ) ) ) ) ) ) ) ).

% finite_enumerate_Suc''
thf(fact_7290_independentD,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A,T2: set @ A,U: A > real,V2: A] :
          ( ~ ( real_V358717886546972837endent @ A @ S )
         => ( ( finite_finite @ A @ T2 )
           => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U @ V5 ) @ V5 )
                    @ T2 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ V2 @ T2 )
                 => ( ( U @ V2 )
                    = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independentD
thf(fact_7291_Least__eq__0,axiom,
    ! [P: nat > $o] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( ord_Least @ nat @ P )
        = ( zero_zero @ nat ) ) ) ).

% Least_eq_0
thf(fact_7292_dependent__single,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V358717886546972837endent @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% dependent_single
thf(fact_7293_Least__Suc,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ( ( ord_Least @ nat @ P )
          = ( suc
            @ ( ord_Least @ nat
              @ ^ [M2: nat] : ( P @ ( suc @ M2 ) ) ) ) ) ) ) ).

% Least_Suc
thf(fact_7294_Least__Suc2,axiom,
    ! [P: nat > $o,N: nat,Q: nat > $o,M: nat] :
      ( ( P @ N )
     => ( ( Q @ M )
       => ( ~ ( P @ ( zero_zero @ nat ) )
         => ( ! [K2: nat] :
                ( ( P @ ( suc @ K2 ) )
                = ( Q @ K2 ) )
           => ( ( ord_Least @ nat @ P )
              = ( suc @ ( ord_Least @ nat @ Q ) ) ) ) ) ) ) ).

% Least_Suc2
thf(fact_7295_LeastI,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI
thf(fact_7296_not__less__Least,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [K: A,P: A > $o] :
          ( ( ord_less @ A @ K @ ( ord_Least @ A @ P ) )
         => ~ ( P @ K ) ) ) ).

% not_less_Least
thf(fact_7297_dependent__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A5: set @ A] :
          ( ( member @ A @ ( zero_zero @ A ) @ A5 )
         => ( real_V358717886546972837endent @ A @ A5 ) ) ) ).

% dependent_zero
thf(fact_7298_LeastI2,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [X2: A] :
                ( ( P @ X2 )
               => ( Q @ X2 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2
thf(fact_7299_LeastI__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI_ex
thf(fact_7300_LeastI2__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [X2: A] :
                ( ( P @ X2 )
               => ( Q @ X2 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_ex
thf(fact_7301_independent__Union__directed,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C4: set @ ( set @ A )] :
          ( ! [C3: set @ A,D4: set @ A] :
              ( ( member @ ( set @ A ) @ C3 @ C4 )
             => ( ( member @ ( set @ A ) @ D4 @ C4 )
               => ( ( ord_less_eq @ ( set @ A ) @ C3 @ D4 )
                  | ( ord_less_eq @ ( set @ A ) @ D4 @ C3 ) ) ) )
         => ( ! [C3: set @ A] :
                ( ( member @ ( set @ A ) @ C3 @ C4 )
               => ~ ( real_V358717886546972837endent @ A @ C3 ) )
           => ~ ( real_V358717886546972837endent @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C4 ) ) ) ) ) ).

% independent_Union_directed
thf(fact_7302_independent__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ A5 )
         => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
           => ~ ( real_V358717886546972837endent @ A @ B6 ) ) ) ) ).

% independent_mono
thf(fact_7303_dependent__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( real_V358717886546972837endent @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
           => ( real_V358717886546972837endent @ A @ A5 ) ) ) ) ).

% dependent_mono
thf(fact_7304_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [A4: A] :
                ( ( P @ A4 )
               => ( ! [B10: A] :
                      ( ( P @ B10 )
                     => ( ord_less_eq @ A @ A4 @ B10 ) )
                 => ( Q @ A4 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder_ex
thf(fact_7305_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [A4: A] :
                ( ( P @ A4 )
               => ( ! [B10: A] :
                      ( ( P @ B10 )
                     => ( ord_less_eq @ A @ A4 @ B10 ) )
                 => ( Q @ A4 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder
thf(fact_7306_Least__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ( ord_Least @ A @ P )
              = X ) ) ) ) ).

% Least_equality
thf(fact_7307_LeastI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ! [X2: A] :
                  ( ( P @ X2 )
                 => ( ! [Y5: A] :
                        ( ( P @ Y5 )
                       => ( ord_less_eq @ A @ X2 @ Y5 ) )
                   => ( Q @ X2 ) ) )
             => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ) ).

% LeastI2_order
thf(fact_7308_Least1__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,Z2: A] :
          ( ? [X5: A] :
              ( ( P @ X5 )
              & ! [Y2: A] :
                  ( ( P @ Y2 )
                 => ( ord_less_eq @ A @ X5 @ Y2 ) )
              & ! [Y2: A] :
                  ( ( ( P @ Y2 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y2 @ Ya2 ) ) )
                 => ( Y2 = X5 ) ) )
         => ( ( P @ Z2 )
           => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ Z2 ) ) ) ) ).

% Least1_le
thf(fact_7309_Least1I,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o] :
          ( ? [X5: A] :
              ( ( P @ X5 )
              & ! [Y2: A] :
                  ( ( P @ Y2 )
                 => ( ord_less_eq @ A @ X5 @ Y2 ) )
              & ! [Y2: A] :
                  ( ( ( P @ Y2 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y2 @ Ya2 ) ) )
                 => ( Y2 = X5 ) ) )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% Least1I
thf(fact_7310_Least__le,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ K ) ) ) ).

% Least_le
thf(fact_7311_Inf__nat__def,axiom,
    ( ( complete_Inf_Inf @ nat )
    = ( ^ [X7: set @ nat] :
          ( ord_Least @ nat
          @ ^ [N3: nat] : ( member @ nat @ N3 @ X7 ) ) ) ) ).

% Inf_nat_def
thf(fact_7312_Least__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( finite_finite @ A @ ( collect @ A @ P ) )
         => ( ? [X_12: A] : ( P @ X_12 )
           => ( ( ord_Least @ A @ P )
              = ( lattic643756798350308766er_Min @ A @ ( collect @ A @ P ) ) ) ) ) ) ).

% Least_Min
thf(fact_7313_Bleast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( bleast @ A )
        = ( ^ [S5: set @ A,P3: A > $o] :
              ( ord_Least @ A
              @ ^ [X3: A] :
                  ( ( member @ A @ X3 @ S5 )
                  & ( P3 @ X3 ) ) ) ) ) ) ).

% Bleast_def
thf(fact_7314_abort__Bleast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( abort_Bleast @ A )
        = ( ^ [S5: set @ A,P3: A > $o] :
              ( ord_Least @ A
              @ ^ [X3: A] :
                  ( ( member @ A @ X3 @ S5 )
                  & ( P3 @ X3 ) ) ) ) ) ) ).

% abort_Bleast_def
thf(fact_7315_enumerate__0,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) )
          = ( ord_Least @ A
            @ ^ [N3: A] : ( member @ A @ N3 @ S2 ) ) ) ) ).

% enumerate_0
thf(fact_7316_unique__representation,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,F2: A > real,G2: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ! [V4: A] :
                ( ( ( F2 @ V4 )
                 != ( zero_zero @ real ) )
               => ( member @ A @ V4 @ Basis ) )
           => ( ! [V4: A] :
                  ( ( ( G2 @ V4 )
                   != ( zero_zero @ real ) )
                 => ( member @ A @ V4 @ Basis ) )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [V5: A] :
                        ( ( F2 @ V5 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [V5: A] :
                          ( ( G2 @ V5 )
                         != ( zero_zero @ real ) ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( F2 @ V5 ) @ V5 )
                        @ ( collect @ A
                          @ ^ [V5: A] :
                              ( ( F2 @ V5 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( G2 @ V5 ) @ V5 )
                        @ ( collect @ A
                          @ ^ [V5: A] :
                              ( ( G2 @ V5 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( F2 = G2 ) ) ) ) ) ) ) ) ).

% unique_representation
thf(fact_7317_Sup__real__def,axiom,
    ( ( complete_Sup_Sup @ real )
    = ( ^ [X7: set @ real] :
          ( ord_Least @ real
          @ ^ [Z5: real] :
            ! [X3: real] :
              ( ( member @ real @ X3 @ X7 )
             => ( ord_less_eq @ real @ X3 @ Z5 ) ) ) ) ) ).

% Sup_real_def
thf(fact_7318_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,S2: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ? [X5: A] :
                ( ( member @ A @ X5 @ S2 )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ S2 )
                   => ( ord_less_eq @ A @ X5 @ Xa3 ) ) )
           => ( ( ord_Least @ B
                @ ^ [Y4: B] : ( member @ B @ Y4 @ ( image @ A @ B @ F2 @ S2 ) ) )
              = ( F2
                @ ( ord_Least @ A
                  @ ^ [X3: A] : ( member @ A @ X3 @ S2 ) ) ) ) ) ) ) ).

% Least_mono
thf(fact_7319_Least__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_Least @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X3: A] :
                  ( ( P3 @ X3 )
                  & ! [Y4: A] :
                      ( ( P3 @ Y4 )
                     => ( ord_less_eq @ A @ X3 @ Y4 ) ) ) ) ) ) ) ).

% Least_def
thf(fact_7320_independent__if__scalars__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [F5: A > real,X2: A] :
                ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ A @ ( F5 @ Y4 ) @ Y4 )
                    @ A5 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ X2 @ A5 )
                 => ( ( F5 @ X2 )
                    = ( zero_zero @ real ) ) ) )
           => ~ ( real_V358717886546972837endent @ A @ A5 ) ) ) ) ).

% independent_if_scalars_zero
thf(fact_7321_dependent__finite,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( real_V358717886546972837endent @ A @ S2 )
            = ( ? [U2: A > real] :
                  ( ? [X3: A] :
                      ( ( member @ A @ X3 @ S2 )
                      & ( ( U2 @ X3 )
                       != ( zero_zero @ real ) ) )
                  & ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ S2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% dependent_finite
thf(fact_7322_independentD__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,X8: A > real,Y6: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ B6 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X3: A] :
                    ( ( X8 @ X3 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X3: A] :
                      ( ( X8 @ X3 )
                     != ( zero_zero @ real ) ) )
                @ B6 )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X3: A] :
                        ( ( Y6 @ X3 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( Y6 @ X3 )
                         != ( zero_zero @ real ) ) )
                    @ B6 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X3 ) @ X3 )
                        @ ( collect @ A
                          @ ^ [X3: A] :
                              ( ( X8 @ X3 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( Y6 @ X3 ) @ X3 )
                        @ ( collect @ A
                          @ ^ [X3: A] :
                              ( ( Y6 @ X3 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( X8 = Y6 ) ) ) ) ) ) ) ) ).

% independentD_unique
thf(fact_7323_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
            = ( ord_Least @ A
              @ ^ [S6: A] :
                  ( ( member @ A @ S6 @ S2 )
                  & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S6 ) ) ) ) ) ) ).

% enumerate_Suc''
thf(fact_7324_independentD__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,X8: A > real,X: A] :
          ( ~ ( real_V358717886546972837endent @ A @ B6 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X3: A] :
                    ( ( X8 @ X3 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X3: A] :
                      ( ( X8 @ X3 )
                     != ( zero_zero @ real ) ) )
                @ B6 )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X3 ) @ X3 )
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( X8 @ X3 )
                         != ( zero_zero @ real ) ) ) )
                  = ( zero_zero @ A ) )
               => ( ( X8 @ X )
                  = ( zero_zero @ real ) ) ) ) ) ) ) ).

% independentD_alt
thf(fact_7325_independent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ B6 ) )
          = ( ! [X7: A > real] :
                ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X3: A] :
                        ( ( X7 @ X3 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( X7 @ X3 )
                         != ( zero_zero @ real ) ) )
                    @ B6 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( X7 @ X3 ) @ X3 )
                        @ ( collect @ A
                          @ ^ [X3: A] :
                              ( ( X7 @ X3 )
                             != ( zero_zero @ real ) ) ) )
                      = ( zero_zero @ A ) )
                   => ! [X3: A] :
                        ( ( X7 @ X3 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independent_alt
thf(fact_7326_dependent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [B7: set @ A] :
            ? [X7: A > real] :
              ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [X3: A] :
                      ( ( X7 @ X3 )
                     != ( zero_zero @ real ) ) ) )
              & ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X3: A] :
                      ( ( X7 @ X3 )
                     != ( zero_zero @ real ) ) )
                @ B7 )
              & ( ( groups7311177749621191930dd_sum @ A @ A
                  @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( X7 @ X3 ) @ X3 )
                  @ ( collect @ A
                    @ ^ [X3: A] :
                        ( ( X7 @ X3 )
                       != ( zero_zero @ real ) ) ) )
                = ( zero_zero @ A ) )
              & ? [X3: A] :
                  ( ( X7 @ X3 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% dependent_alt
thf(fact_7327_independent__explicit__finite__subsets,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A5: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ A5 ) )
          = ( ! [S5: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ S5 @ A5 )
               => ( ( finite_finite @ A @ S5 )
                 => ! [U2: A > real] :
                      ( ( ( groups7311177749621191930dd_sum @ A @ A
                          @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                          @ S5 )
                        = ( zero_zero @ A ) )
                     => ! [X3: A] :
                          ( ( member @ A @ X3 @ S5 )
                         => ( ( U2 @ X3 )
                            = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_finite_subsets
thf(fact_7328_independent__explicit__module,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ S ) )
          = ( ! [T4: set @ A,U2: A > real,V5: A] :
                ( ( finite_finite @ A @ T4 )
               => ( ( ord_less_eq @ ( set @ A ) @ T4 @ S )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [W3: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ W3 ) @ W3 )
                        @ T4 )
                      = ( zero_zero @ A ) )
                   => ( ( member @ A @ V5 @ T4 )
                     => ( ( U2 @ V5 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_module
thf(fact_7329_dependent__explicit,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [S6: set @ A] :
            ? [T4: set @ A] :
              ( ( finite_finite @ A @ T4 )
              & ( ord_less_eq @ ( set @ A ) @ T4 @ S6 )
              & ? [U2: A > real] :
                  ( ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ T4 )
                    = ( zero_zero @ A ) )
                  & ? [X3: A] :
                      ( ( member @ A @ X3 @ T4 )
                      & ( ( U2 @ X3 )
                       != ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% dependent_explicit
thf(fact_7330_isUCont__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X3: A,Y4: A] :
                        ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y4 ) @ S6 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) @ R5 ) ) ) ) ) ) ) ).

% isUCont_def
thf(fact_7331_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y3: int,Z: int] : ( Y3 = Z )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y3: int,Z: int] : ( Y3 = Z )
      @ pcr_rat )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_7332_uniformly__continuous__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ( ( topolo6026614971017936543ous_on @ A @ B )
        = ( ^ [S6: set @ A,F3: A > B] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( member @ A @ X3 @ S6 )
                     => ! [Y4: A] :
                          ( ( member @ A @ Y4 @ S6 )
                         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y4 @ X3 ) @ D6 )
                           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ Y4 ) @ ( F3 @ X3 ) ) @ E3 ) ) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
thf(fact_7333_zero__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( zero_zero @ rat ) ).

% zero_rat.transfer
thf(fact_7334_possible__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se6407376104438227557le_bit @ A )
        = ( ^ [Tyrep: itself @ A,N3: nat] :
              ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 )
             != ( zero_zero @ A ) ) ) ) ) ).

% possible_bit_def
thf(fact_7335_map__rec,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map @ B @ A )
      = ( ^ [F3: B > A] :
            ( rec_list @ ( list @ A ) @ B @ ( nil @ A )
            @ ^ [X3: B,Uu3: list @ B] : ( cons @ A @ ( F3 @ X3 ) ) ) ) ) ).

% map_rec
thf(fact_7336_possible__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Ty: itself @ A] : ( bit_se6407376104438227557le_bit @ A @ Ty @ ( zero_zero @ nat ) ) ) ).

% possible_bit_0
thf(fact_7337_list_Osimps_I6_J,axiom,
    ! [A: $tType,C: $tType,F15: C,F24: A > ( list @ A ) > C > C] :
      ( ( rec_list @ C @ A @ F15 @ F24 @ ( nil @ A ) )
      = F15 ) ).

% list.simps(6)
thf(fact_7338_list_Osimps_I7_J,axiom,
    ! [C: $tType,A: $tType,F15: C,F24: A > ( list @ A ) > C > C,X21: A,X22: list @ A] :
      ( ( rec_list @ C @ A @ F15 @ F24 @ ( cons @ A @ X21 @ X22 ) )
      = ( F24 @ X21 @ X22 @ ( rec_list @ C @ A @ F15 @ F24 @ X22 ) ) ) ).

% list.simps(7)
thf(fact_7339_possible__bit__less__imp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Tyrep2: itself @ A,I: nat,J: nat] :
          ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ I )
         => ( ( ord_less_eq @ nat @ J @ I )
           => ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ J ) ) ) ) ).

% possible_bit_less_imp
thf(fact_7340_list_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G2: C,Ga: B > ( list @ B ) > C > C,F2: A > B] :
      ( ( comp @ ( list @ B ) @ C @ ( list @ A ) @ ( rec_list @ C @ B @ G2 @ Ga ) @ ( map @ A @ B @ F2 ) )
      = ( rec_list @ C @ A @ G2
        @ ^ [X3: A,Xa4: list @ A] : ( Ga @ ( F2 @ X3 ) @ ( map @ A @ B @ F2 @ Xa4 ) ) ) ) ).

% list.rec_o_map
thf(fact_7341_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ord_less_eq @ nat @ M @ N )
                & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% drop_bit_exp_eq
thf(fact_7342_bit__minus__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% bit_minus_2_iff
thf(fact_7343_CHAR__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
        = ( zero_zero @ nat ) ) ) ).

% CHAR_eq_0
thf(fact_7344_of__nat__CHAR,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_CHAR
thf(fact_7345_bit__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M ) ) ) ) ).

% bit_mask_iff
thf(fact_7346_CHAR__eqI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ( semiring_1_of_nat @ A @ C2 )
            = ( zero_zero @ A ) )
         => ( ! [X2: nat] :
                ( ( ( semiring_1_of_nat @ A @ X2 )
                  = ( zero_zero @ A ) )
               => ( dvd_dvd @ nat @ C2 @ X2 ) )
           => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
              = C2 ) ) ) ) ).

% CHAR_eqI
thf(fact_7347_of__nat__eq__0__iff__char__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ nat @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) @ N ) ) ) ).

% of_nat_eq_0_iff_char_dvd
thf(fact_7348_bit__of__nat__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ) ).

% bit_of_nat_iff
thf(fact_7349_CHAR__pos__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ( semiring_1_of_nat @ A @ N3 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_pos_iff
thf(fact_7350_CHAR__eq__posI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
         => ( ( ( semiring_1_of_nat @ A @ C2 )
              = ( zero_zero @ A ) )
           => ( ! [X2: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X2 )
                 => ( ( ord_less @ nat @ X2 @ C2 )
                   => ( ( semiring_1_of_nat @ A @ X2 )
                     != ( zero_zero @ A ) ) ) )
             => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
                = C2 ) ) ) ) ) ).

% CHAR_eq_posI
thf(fact_7351_CHAR__eq0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
          = ( zero_zero @ nat ) )
        = ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( semiring_1_of_nat @ A @ N3 )
               != ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_eq0_iff
thf(fact_7352_bit__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less_eq @ nat @ M @ N )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_push_bit_iff
thf(fact_7353_fold__possible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% fold_possible_bit
thf(fact_7354_set__rec,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( rec_list @ ( set @ A ) @ A @ ( bot_bot @ ( set @ A ) )
        @ ^ [X3: A,Uu3: list @ A] : ( insert2 @ A @ X3 ) ) ) ).

% set_rec
thf(fact_7355_bit__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( M = N ) ) ) ) ).

% bit_exp_iff
thf(fact_7356_bit__not__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( N != M ) ) ) ) ).

% bit_not_exp_iff
thf(fact_7357_bit__minus__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% bit_minus_exp_iff
thf(fact_7358_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M ) ) ) ) ).

% bit_mask_sub_iff
thf(fact_7359_bit__double__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            & ( N
             != ( zero_zero @ nat ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_double_iff
thf(fact_7360_append__butlast__last__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( append @ A @ ( butlast @ A @ Xs ) @ ( cons @ A @ ( last @ A @ Xs ) @ ( nil @ A ) ) )
        = Xs ) ) ).

% append_butlast_last_id
thf(fact_7361_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert2 @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_7362_last__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( last @ A @ ( remdups_adj @ A @ Xs ) )
      = ( last @ A @ Xs ) ) ).

% last_remdups_adj
thf(fact_7363_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_7364_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ( suc @ N )
        = ( numeral_numeral @ nat @ K ) )
      = ( N
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_7365_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N ) )
      = ( ( pred_numeral @ K )
        = N ) ) ).

% eq_numeral_Suc
thf(fact_7366_last__appendL,axiom,
    ! [A: $tType,Ys2: list @ A,Xs: list @ A] :
      ( ( Ys2
        = ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( last @ A @ Xs ) ) ) ).

% last_appendL
thf(fact_7367_last__appendR,axiom,
    ! [A: $tType,Ys2: list @ A,Xs: list @ A] :
      ( ( Ys2
       != ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( last @ A @ Ys2 ) ) ) ).

% last_appendR
thf(fact_7368_last__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( last @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% last_replicate
thf(fact_7369_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_7370_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_7371_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% less_numeral_Suc
thf(fact_7372_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_7373_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_7374_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% le_numeral_Suc
thf(fact_7375_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% diff_numeral_Suc
thf(fact_7376_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_7377_last__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( last @ nat @ ( upt @ I @ J ) )
        = ( minus_minus @ nat @ J @ ( one_one @ nat ) ) ) ) ).

% last_upt
thf(fact_7378_last__snoc,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( last @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) ).

% last_snoc
thf(fact_7379_last__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( last @ A @ ( drop @ A @ N @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_drop
thf(fact_7380_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_7381_min__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% min_numeral_Suc
thf(fact_7382_min__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_7383_max__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% max_numeral_Suc
thf(fact_7384_max__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_7385_dropWhile__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( last @ A @ ( dropWhile @ A @ P @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) ).

% dropWhile_last
thf(fact_7386_hd__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( rev @ A @ Xs ) )
      = ( last @ A @ Xs ) ) ).

% hd_rev
thf(fact_7387_last__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( last @ A @ ( rev @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% last_rev
thf(fact_7388_last__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( last @ A @ Xs ) ) ) ) ).

% last_map
thf(fact_7389_last__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys2
         != ( nil @ B ) )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ B ) @ Ys2 ) )
         => ( ( last @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
            = ( product_Pair @ A @ B @ ( last @ A @ Xs ) @ ( last @ B @ Ys2 ) ) ) ) ) ) ).

% last_zip
thf(fact_7390_last__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
        | ( ( tl @ A @ Xs )
         != ( nil @ A ) ) )
     => ( ( last @ A @ ( tl @ A @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_tl
thf(fact_7391_last__in__set,axiom,
    ! [A: $tType,As2: list @ A] :
      ( ( As2
       != ( nil @ A ) )
     => ( member @ A @ ( last @ A @ As2 ) @ ( set2 @ A @ As2 ) ) ) ).

% last_in_set
thf(fact_7392_hd__Nil__eq__last,axiom,
    ! [A: $tType] :
      ( ( hd @ A @ ( nil @ A ) )
      = ( last @ A @ ( nil @ A ) ) ) ).

% hd_Nil_eq_last
thf(fact_7393_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K4: num] : ( suc @ ( pred_numeral @ K4 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_7394_longest__common__suffix,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
    ? [Ss: list @ A,Xs4: list @ A,Ys7: list @ A] :
      ( ( Xs
        = ( append @ A @ Xs4 @ Ss ) )
      & ( Ys2
        = ( append @ A @ Ys7 @ Ss ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys7
          = ( nil @ A ) )
        | ( ( last @ A @ Xs4 )
         != ( last @ A @ Ys7 ) ) ) ) ).

% longest_common_suffix
thf(fact_7395_last__append,axiom,
    ! [A: $tType,Ys2: list @ A,Xs: list @ A] :
      ( ( ( Ys2
          = ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( last @ A @ Xs ) ) )
      & ( ( Ys2
         != ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( last @ A @ Ys2 ) ) ) ) ).

% last_append
thf(fact_7396_last__ConsR,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_ConsR
thf(fact_7397_last__ConsL,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = X ) ) ).

% last_ConsL
thf(fact_7398_last_Osimps,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = X ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) ).

% last.simps
thf(fact_7399_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K4: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K4 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_7400_takeWhile__not__last,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( takeWhile @ A
          @ ^ [Y4: A] :
              ( Y4
             != ( last @ A @ Xs ) )
          @ Xs )
        = ( butlast @ A @ Xs ) ) ) ).

% takeWhile_not_last
thf(fact_7401_snoc__eq__iff__butlast,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = Ys2 )
      = ( ( Ys2
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys2 )
          = Xs )
        & ( ( last @ A @ Ys2 )
          = X ) ) ) ).

% snoc_eq_iff_butlast
thf(fact_7402_remdups__adj__append_H,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ A ) )
        | ( ( last @ A @ Xs )
         != ( hd @ A @ Ys2 ) ) )
     => ( ( remdups_adj @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( append @ A @ ( remdups_adj @ A @ Xs ) @ ( remdups_adj @ A @ Ys2 ) ) ) ) ).

% remdups_adj_append'
thf(fact_7403_remdups__adj__append_H_H,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( remdups_adj @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( append @ A @ ( remdups_adj @ A @ Xs )
          @ ( remdups_adj @ A
            @ ( dropWhile @ A
              @ ^ [Y4: A] :
                  ( Y4
                  = ( last @ A @ Xs ) )
              @ Ys2 ) ) ) ) ) ).

% remdups_adj_append''
thf(fact_7404_last__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ Xs )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ) ) ).

% last_conv_nth
thf(fact_7405_last__list__update,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( ( K
            = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = X ) )
        & ( ( K
           != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = ( last @ A @ Xs ) ) ) ) ) ).

% last_list_update
thf(fact_7406_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V2: num,N: nat] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N ) @ ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_7407_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V2: num,N: nat] :
      ( ( case_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N ) ) ) ).

% case_nat_add_eq_if
thf(fact_7408_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F15: T,F24: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F15 @ F24 @ ( suc @ Nat ) )
      = ( F24 @ Nat @ ( rec_nat @ T @ F15 @ F24 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_7409_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F15: T,F24: nat > T > T] :
      ( ( rec_nat @ T @ F15 @ F24 @ ( zero_zero @ nat ) )
      = F15 ) ).

% old.nat.simps(6)
thf(fact_7410_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V2: num] :
      ( ( case_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V2 ) )
      = ( F2 @ ( pred_numeral @ V2 ) ) ) ).

% case_nat_numeral
thf(fact_7411_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V2: num] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V2 ) )
      = ( F2 @ ( pred_numeral @ V2 ) @ ( rec_nat @ A @ A2 @ F2 @ ( pred_numeral @ V2 ) ) ) ) ).

% rec_nat_numeral
thf(fact_7412_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F15: A,F24: nat > A,X23: nat] :
      ( ( case_nat @ A @ F15 @ F24 @ ( suc @ X23 ) )
      = ( F24 @ X23 ) ) ).

% old.nat.simps(5)
thf(fact_7413_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F15: A,F24: nat > A] :
      ( ( case_nat @ A @ F15 @ F24 @ ( zero_zero @ nat ) )
      = F15 ) ).

% old.nat.simps(4)
thf(fact_7414_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_7415_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_7416_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: A > B,F15: A,F24: nat > A,Nat: nat] :
      ( ( H @ ( case_nat @ A @ F15 @ F24 @ Nat ) )
      = ( case_nat @ B @ ( H @ F15 )
        @ ^ [X3: nat] : ( H @ ( F24 @ X3 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_7417_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: nat > A,F15: A,F24: nat > A > A] :
      ( ( F2
        = ( rec_nat @ A @ F15 @ F24 ) )
     => ( ( F2 @ ( zero_zero @ nat ) )
        = F15 ) ) ).

% rec_nat_0_imp
thf(fact_7418_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N ) ) ).

% less_eq_nat.simps(2)
thf(fact_7419_max__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ M6 @ N ) )
        @ M ) ) ).

% max_Suc2
thf(fact_7420_max__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ N @ M6 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_7421_drop__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( drop @ A @ N @ ( cons @ A @ X @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ X @ Xs )
        @ ^ [M2: nat] : ( drop @ A @ M2 @ Xs )
        @ N ) ) ).

% drop_Cons
thf(fact_7422_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I: nat,V2: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ I @ V2 )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V2 @ Xs )
        @ ^ [J3: nat] : ( cons @ A @ X @ ( list_update @ A @ Xs @ J3 @ V2 ) )
        @ I ) ) ).

% list_update.simps(2)
thf(fact_7423_nth__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
      = ( case_nat @ A @ X @ ( nth @ A @ Xs ) @ N ) ) ).

% nth_Cons
thf(fact_7424_diff__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K4: nat] : K4
        @ ( minus_minus @ nat @ M @ N ) ) ) ).

% diff_Suc
thf(fact_7425_min__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ N @ M6 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_7426_min__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ M6 @ N ) )
        @ M ) ) ).

% min_Suc2
thf(fact_7427_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X3: A,F3: nat > A,N3: nat] :
            ( if @ A
            @ ( N3
              = ( zero_zero @ nat ) )
            @ X3
            @ ( F3 @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_7428_take__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( take @ A @ N @ ( cons @ A @ X @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( nil @ A )
        @ ^ [M2: nat] : ( cons @ A @ X @ ( take @ A @ M2 @ Xs ) )
        @ N ) ) ).

% take_Cons
thf(fact_7429_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F17: T,F25: nat > T > T,X3: nat] : ( the @ T @ ( rec_set_nat @ T @ F17 @ F25 @ X3 ) ) ) ) ).

% old.rec_nat_def
thf(fact_7430_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F15: A,F24: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F15 @ F24 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F15 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F24 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_7431_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X25: nat] : X25 ) ) ).

% pred_def
thf(fact_7432_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F15: A,F24: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F15 @ F24 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F15 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F24 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_7433_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% numeral_xor_num
thf(fact_7434_List_Ounion__def,axiom,
    ! [A: $tType] :
      ( ( union @ A )
      = ( fold @ A @ ( list @ A ) @ ( insert @ A ) ) ) ).

% List.union_def
thf(fact_7435_in__set__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = Xs ) ) ).

% in_set_insert
thf(fact_7436_distinct__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct @ A @ ( insert @ A @ X @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_insert
thf(fact_7437_insert__Nil,axiom,
    ! [A: $tType,X: A] :
      ( ( insert @ A @ X @ ( nil @ A ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% insert_Nil
thf(fact_7438_not__in__set__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = ( cons @ A @ X @ Xs ) ) ) ).

% not_in_set_insert
thf(fact_7439_List_Oset__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( set2 @ A @ ( insert @ A @ X @ Xs ) )
      = ( insert2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% List.set_insert
thf(fact_7440_insert__remdups,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( insert @ A @ X @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ ( insert @ A @ X @ Xs ) ) ) ).

% insert_remdups
thf(fact_7441_List_Oinsert__def,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [X3: A,Xs3: list @ A] : ( if @ ( list @ A ) @ ( member @ A @ X3 @ ( set2 @ A @ Xs3 ) ) @ Xs3 @ ( cons @ A @ X3 @ Xs3 ) ) ) ) ).

% List.insert_def
thf(fact_7442_remove__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remove @ A @ X @ ( coset @ A @ Xs ) )
      = ( coset @ A @ ( insert @ A @ X @ Xs ) ) ) ).

% remove_code(2)
thf(fact_7443_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_7444_inv__image__partition,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( set2 @ A @ Ys2 ) )
           => ~ ( P @ Y2 ) )
       => ( ( vimage @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( partition @ A @ P ) @ ( insert2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) )
          = ( shuffles @ A @ Xs @ Ys2 ) ) ) ) ).

% inv_image_partition
thf(fact_7445_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ) ).

% numeral_and_num
thf(fact_7446_continuous__imp__open__vimage,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [S: set @ A,F2: A > B,B6: set @ B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo1002775350975398744n_open @ A @ S )
           => ( ( topolo1002775350975398744n_open @ B @ B6 )
             => ( ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B6 ) @ S )
               => ( topolo1002775350975398744n_open @ A @ ( vimage @ A @ B @ F2 @ B6 ) ) ) ) ) ) ) ).

% continuous_imp_open_vimage
thf(fact_7447_vimage__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B6: set @ A,F2: B > A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
     => ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ A5 ) @ ( vimage @ B @ A @ F2 @ B6 ) ) ) ).

% vimage_mono
thf(fact_7448_subset__vimage__iff,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,F2: A > B,B6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( vimage @ A @ B @ F2 @ B6 ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A5 )
           => ( member @ B @ ( F2 @ X3 ) @ B6 ) ) ) ) ).

% subset_vimage_iff
thf(fact_7449_image__vimage__subset,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( vimage @ B @ A @ F2 @ A5 ) ) @ A5 ) ).

% image_vimage_subset
thf(fact_7450_image__subset__iff__subset__vimage,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A5: set @ B,B6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ B6 )
      = ( ord_less_eq @ ( set @ B ) @ A5 @ ( vimage @ B @ A @ F2 @ B6 ) ) ) ).

% image_subset_iff_subset_vimage
thf(fact_7451_vimage__subsetD,axiom,
    ! [A: $tType,B: $tType,F2: B > A,B6: set @ A,A5: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ B6 ) @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ).

% vimage_subsetD
thf(fact_7452_finite__vimageD_H,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ B] :
      ( ( finite_finite @ A @ ( vimage @ A @ B @ F2 @ A5 ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ ( image @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) )
       => ( finite_finite @ B @ A5 ) ) ) ).

% finite_vimageD'
thf(fact_7453_vimage__subsetI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B6: set @ B,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F2 @ A5 ) )
       => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B6 ) @ A5 ) ) ) ).

% vimage_subsetI
thf(fact_7454_countable__vimage,axiom,
    ! [B: $tType,A: $tType,B6: set @ A,F2: B > A] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ( countable_countable @ B @ ( vimage @ B @ A @ F2 @ B6 ) )
       => ( countable_countable @ A @ B6 ) ) ) ).

% countable_vimage
thf(fact_7455_vimage__subset__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B6: set @ B,A5: set @ A] :
      ( ( bij_betw @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B6 ) @ A5 )
        = ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ).

% vimage_subset_eq
thf(fact_7456_card__vimage__inj,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ ( image @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) )
       => ( ( finite_card @ A @ ( vimage @ A @ B @ F2 @ A5 ) )
          = ( finite_card @ B @ A5 ) ) ) ) ).

% card_vimage_inj
thf(fact_7457_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,D5: set @ A,A5: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ D5 )
     => ( ( finite_finite @ B @ A5 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A5 ) @ D5 ) ) @ ( finite_card @ B @ A5 ) ) ) ) ).

% card_vimage_inj_on_le
thf(fact_7458_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_7459_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) )
        @ ( insert2 @ A
          @ ( the @ A
            @ ^ [X3: A] :
                ( ( F2 @ X3 )
                = A2 ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_vimage_singleton
thf(fact_7460_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,A2: B] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) @ A5 )
        @ ( insert2 @ A
          @ ( the @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A5 )
                & ( ( F2 @ X3 )
                  = A2 ) ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_on_vimage_singleton
thf(fact_7461_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A] :
          ( ( ( semiring_gcd_Gcd_fin @ A @ A5 )
            = ( zero_zero @ A ) )
          = ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) )
            & ( finite_finite @ A @ A5 ) ) ) ) ).

% Gcd_fin_0_iff
thf(fact_7462_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F3: A > ( option @ B ),Xs3: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F3 )
            @ ( filter2 @ A
              @ ^ [X3: A] :
                  ( ( F3 @ X3 )
                 != ( none @ B ) )
              @ Xs3 ) ) ) ) ).

% map_filter_def
thf(fact_7463_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_fin.empty
thf(fact_7464_vimage__Suc__insert__0,axiom,
    ! [A5: set @ nat] :
      ( ( vimage @ nat @ nat @ suc @ ( insert2 @ nat @ ( zero_zero @ nat ) @ A5 ) )
      = ( vimage @ nat @ nat @ suc @ A5 ) ) ).

% vimage_Suc_insert_0
thf(fact_7465_gcd__list__greatest,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Bs: list @ A,A2: A] :
          ( ! [B4: A] :
              ( ( member @ A @ B4 @ ( set2 @ A @ Bs ) )
             => ( dvd_dvd @ A @ A2 @ B4 ) )
         => ( dvd_dvd @ A @ A2 @ ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Bs ) ) ) ) ) ).

% gcd_list_greatest
thf(fact_7466_dvd__gcd__list__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,Xs: list @ A] :
          ( ( dvd_dvd @ A @ B2 @ ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Xs ) ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( dvd_dvd @ A @ B2 @ X3 ) ) ) ) ) ).

% dvd_gcd_list_iff
thf(fact_7467_Max_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( lattic643756798349783984er_Max @ A @ A5 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Max.infinite
thf(fact_7468_Min_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( lattic643756798350308766er_Min @ A @ A5 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Min.infinite
thf(fact_7469_Min_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798350308766er_Min @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X3: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X3 @ ( ord_min @ A @ X3 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Min.eq_fold'
thf(fact_7470_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798349783984er_Max @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X3: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X3 @ ( ord_max @ A @ X3 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Max.eq_fold'
thf(fact_7471_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X: B,Xs: list @ B] :
      ( ( map_filter @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
      = ( case_option @ ( list @ A ) @ A @ ( map_filter @ B @ A @ F2 @ Xs )
        @ ^ [Y4: A] : ( cons @ A @ Y4 @ ( map_filter @ B @ A @ F2 @ Xs ) )
        @ ( F2 @ X ) ) ) ).

% map_filter_simps(1)
thf(fact_7472_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_7473_Max_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( ord_max @ A ) @ X @ A5 ) ) ) ) ).

% Max.eq_fold
thf(fact_7474_Min_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( ord_min @ A ) @ X @ A5 ) ) ) ) ).

% Min.eq_fold
thf(fact_7475_comp__fun__idem__on_Ofold__insert__idem2,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z2 ) @ A5 ) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem2
thf(fact_7476_comp__fun__idem__on_Ofold__insert__idem,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) )
            = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ A5 ) ) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem
thf(fact_7477_comp__fun__idem__on_Ofold__set__fold,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,Xs: list @ A,Y: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ S2 )
       => ( ( finite_fold @ A @ B @ F2 @ Y @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ B @ F2 @ Xs @ Y ) ) ) ) ).

% comp_fun_idem_on.fold_set_fold
thf(fact_7478_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X3: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X3 @ ( sup_sup @ A @ X3 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Sup_fin.eq_fold'
thf(fact_7479_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X3: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X3 @ ( inf_inf @ A @ X3 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_7480_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ( inf_inf @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
              = A2 ) ) ) ) ).

% inf_Sup_absorb
thf(fact_7481_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Sup_fin.singleton
thf(fact_7482_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Inf_fin.singleton
thf(fact_7483_sup__Inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ A2 )
              = A2 ) ) ) ) ).

% sup_Inf_absorb
thf(fact_7484_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.insert
thf(fact_7485_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ) ).

% Sup_fin.insert
thf(fact_7486_Inf__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ A2 ) ) ) ) ).

% Inf_fin.coboundedI
thf(fact_7487_Sup__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ord_less_eq @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ).

% Sup_fin.coboundedI
thf(fact_7488_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ).

% Inf_fin_le_Sup_fin
thf(fact_7489_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
              = ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ).

% Inf_fin.in_idem
thf(fact_7490_Sup__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
              = ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ).

% Sup_fin.in_idem
thf(fact_7491_Inf__fin__Min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% Inf_fin_Min
thf(fact_7492_Sup__fin__Max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% Sup_fin_Max
thf(fact_7493_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
             => ! [A18: A] :
                  ( ( member @ A @ A18 @ A5 )
                 => ( ord_less_eq @ A @ X @ A18 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_7494_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ( ord_less_eq @ A @ X @ A4 ) )
             => ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_7495_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ X )
             => ! [A18: A] :
                  ( ( member @ A @ A18 @ A5 )
                 => ( ord_less_eq @ A @ A18 @ X ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_7496_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ( ord_less_eq @ A @ A4 @ X ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ X ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_7497_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_7498_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ X )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A5 )
                   => ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_7499_card_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( finite_fold @ A @ nat
        @ ^ [Uu3: A] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card.eq_fold
thf(fact_7500_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ A5 )
              = ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% Sup_fin_Sup
thf(fact_7501_cSup__eq__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = ( lattic5882676163264333800up_fin @ A @ X8 ) ) ) ) ) ).

% cSup_eq_Sup_fin
thf(fact_7502_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
              = ( complete_Inf_Inf @ A @ A5 ) ) ) ) ) ).

% Inf_fin_Inf
thf(fact_7503_cInf__eq__Inf__fin,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = ( lattic7752659483105999362nf_fin @ A @ X8 ) ) ) ) ) ).

% cInf_eq_Inf_fin
thf(fact_7504_Inf__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Inf_fin.infinite
thf(fact_7505_Sup__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( lattic5882676163264333800up_fin @ A @ A5 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Sup_fin.infinite
thf(fact_7506_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( finite_fold @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X3: A] : X3 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
thf(fact_7507_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ B6 ) @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.subset_imp
thf(fact_7508_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ B6 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_7509_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [H: A > A,N4: set @ A] :
          ( ! [X2: A,Y2: A] :
              ( ( H @ ( inf_inf @ A @ X2 @ Y2 ) )
              = ( inf_inf @ A @ ( H @ X2 ) @ ( H @ Y2 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H @ ( lattic7752659483105999362nf_fin @ A @ N4 ) )
                = ( lattic7752659483105999362nf_fin @ A @ ( image @ A @ A @ H @ N4 ) ) ) ) ) ) ) ).

% Inf_fin.hom_commute
thf(fact_7510_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [H: A > A,N4: set @ A] :
          ( ! [X2: A,Y2: A] :
              ( ( H @ ( sup_sup @ A @ X2 @ Y2 ) )
              = ( sup_sup @ A @ ( H @ X2 ) @ ( H @ Y2 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H @ ( lattic5882676163264333800up_fin @ A @ N4 ) )
                = ( lattic5882676163264333800up_fin @ A @ ( image @ A @ A @ H @ N4 ) ) ) ) ) ) ) ).

% Sup_fin.hom_commute
thf(fact_7511_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B6 ) @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_7512_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B6 ) @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
                = ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_7513_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
thf(fact_7514_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y2: A] : ( member @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Inf_fin.closed
thf(fact_7515_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
thf(fact_7516_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y2: A] : ( member @ A @ ( sup_sup @ A @ X2 @ Y2 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Sup_fin.closed
thf(fact_7517_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
                  = ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ ( lattic7752659483105999362nf_fin @ A @ B6 ) ) ) ) ) ) ) ) ).

% Inf_fin.union
thf(fact_7518_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
                  = ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ B6 ) ) ) ) ) ) ) ) ).

% Sup_fin.union
thf(fact_7519_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ X @ A5 ) ) ) ) ).

% Inf_fin.eq_fold
thf(fact_7520_Sup__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( sup_sup @ A ) @ X @ A5 ) ) ) ) ).

% Sup_fin.eq_fold
thf(fact_7521_Inf__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ X ) ) ) ).

% Inf_fin.set_eq_fold
thf(fact_7522_Sup__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ X ) ) ) ).

% Sup_fin.set_eq_fold
thf(fact_7523_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( inf_inf @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ B6 ) )
                  = ( lattic5882676163264333800up_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu3: A] :
                        ? [A3: A,B3: A] :
                          ( ( Uu3
                            = ( inf_inf @ A @ A3 @ B3 ) )
                          & ( member @ A @ A3 @ A5 )
                          & ( member @ A @ B3 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% inf_Sup2_distrib
thf(fact_7524_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( inf_inf @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
              = ( lattic5882676163264333800up_fin @ A
                @ ( collect @ A
                  @ ^ [Uu3: A] :
                    ? [A3: A] :
                      ( ( Uu3
                        = ( inf_inf @ A @ X @ A3 ) )
                      & ( member @ A @ A3 @ A5 ) ) ) ) ) ) ) ) ).

% inf_Sup1_distrib
thf(fact_7525_sup__Inf2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( B6
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ ( lattic7752659483105999362nf_fin @ A @ B6 ) )
                  = ( lattic7752659483105999362nf_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu3: A] :
                        ? [A3: A,B3: A] :
                          ( ( Uu3
                            = ( sup_sup @ A @ A3 @ B3 ) )
                          & ( member @ A @ A3 @ A5 )
                          & ( member @ A @ B3 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% sup_Inf2_distrib
thf(fact_7526_sup__Inf1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( sup_sup @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
              = ( lattic7752659483105999362nf_fin @ A
                @ ( collect @ A
                  @ ^ [Uu3: A] :
                    ? [A3: A] :
                      ( ( Uu3
                        = ( sup_sup @ A @ X @ A3 ) )
                      & ( member @ A @ A3 @ A5 ) ) ) ) ) ) ) ) ).

% sup_Inf1_distrib
thf(fact_7527_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_7528_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
                  = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_7529_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.insert_remove
thf(fact_7530_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A5 )
                  = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.remove
thf(fact_7531_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,B6: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ S2 )
         => ( ( finite_finite @ A @ A5 )
           => ( ( finite_finite @ A @ B6 )
             => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B6 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
                  = ( finite_fold @ A @ B @ F2 @ ( finite_fold @ A @ B @ F2 @ Z2 @ A5 ) @ B6 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_7532_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) )
            = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_7533_Finite__Set_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,G2: A > B > B,A5: set @ A,S: B,T2: B,B6: set @ A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ G2 )
       => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
         => ( ( finite_finite @ A @ A5 )
           => ( ! [X2: A] :
                  ( ( member @ A @ X2 @ A5 )
                 => ( ( F2 @ X2 )
                    = ( G2 @ X2 ) ) )
             => ( ( S = T2 )
               => ( ( A5 = B6 )
                 => ( ( finite_fold @ A @ B @ F2 @ S @ A5 )
                    = ( finite_fold @ A @ B @ G2 @ T2 @ B6 ) ) ) ) ) ) ) ) ) ).

% Finite_Set.fold_cong
thf(fact_7534_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F2: A > B > B,G2: C > A,R4: set @ C] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G2 @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite4664212375090638736ute_on @ C @ B @ R4 @ ( comp @ A @ ( B > B ) @ C @ F2 @ G2 ) ) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
thf(fact_7535_comp__fun__commute__on_Ofold__fun__left__comm,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ A5 ) )
            = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z2 ) @ A5 ) ) ) ) ) ).

% comp_fun_commute_on.fold_fun_left_comm
thf(fact_7536_comp__fun__commute__on_Ofold__insert2,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) )
              = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z2 ) @ A5 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert2
thf(fact_7537_comp__fun__commute__on_Ofold__insert,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) )
              = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ A5 ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert
thf(fact_7538_comp__fun__commute__on_Ofold__set__fold__remdups,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,Xs: list @ A,Y: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ S2 )
       => ( ( finite_fold @ A @ B @ F2 @ Y @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ B @ F2 @ ( remdups @ A @ Xs ) @ Y ) ) ) ) ).

% comp_fun_commute_on.fold_set_fold_remdups
thf(fact_7539_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,X: A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ A5 )
              = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
thf(fact_7540_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,Z2: B,Y: B,A2: A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A5 @ Y )
         => ( ( member @ A @ A2 @ A5 )
           => ? [Y8: B] :
                ( ( Y
                  = ( F2 @ A2 @ Y8 ) )
                & ( finite_fold_graph @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ Y8 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
thf(fact_7541_connected__closed,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [S6: set @ A] :
              ~ ? [A7: set @ A,B7: set @ A] :
                  ( ( topolo7761053866217962861closed @ A @ A7 )
                  & ( topolo7761053866217962861closed @ A @ B7 )
                  & ( ord_less_eq @ ( set @ A ) @ S6 @ ( sup_sup @ ( set @ A ) @ A7 @ B7 ) )
                  & ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A7 @ B7 ) @ S6 )
                    = ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ A7 @ S6 )
                   != ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ B7 @ S6 )
                   != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% connected_closed
thf(fact_7542_comp__fun__commute__on_Ofold__graph__determ,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,Z2: B,X: B,Y: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A5 @ X )
         => ( ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A5 @ Y )
           => ( Y = X ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_determ
thf(fact_7543_connected__contains__Ioo,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A5: set @ A,A2: A,B2: A] :
          ( ( topolo1966860045006549960nected @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ( member @ A @ B2 @ A5 )
             => ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ A5 ) ) ) ) ) ).

% connected_contains_Ioo
thf(fact_7544_connected__contains__Icc,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A5: set @ A,A2: A,B2: A] :
          ( ( topolo1966860045006549960nected @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ( member @ A @ B2 @ A5 )
             => ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ A5 ) ) ) ) ) ).

% connected_contains_Icc
thf(fact_7545_connected__iff__interval,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [U6: set @ A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ U6 )
             => ! [Y4: A] :
                  ( ( member @ A @ Y4 @ U6 )
                 => ! [Z5: A] :
                      ( ( ord_less_eq @ A @ X3 @ Z5 )
                     => ( ( ord_less_eq @ A @ Z5 @ Y4 )
                       => ( member @ A @ Z5 @ U6 ) ) ) ) ) ) ) ) ).

% connected_iff_interval
thf(fact_7546_connectedI__interval,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [U3: set @ A] :
          ( ! [X2: A,Y2: A,Z3: A] :
              ( ( member @ A @ X2 @ U3 )
             => ( ( member @ A @ Y2 @ U3 )
               => ( ( ord_less_eq @ A @ X2 @ Z3 )
                 => ( ( ord_less_eq @ A @ Z3 @ Y2 )
                   => ( member @ A @ Z3 @ U3 ) ) ) ) )
         => ( topolo1966860045006549960nected @ A @ U3 ) ) ) ).

% connectedI_interval
thf(fact_7547_connectedD__interval,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [U3: set @ A,X: A,Y: A,Z2: A] :
          ( ( topolo1966860045006549960nected @ A @ U3 )
         => ( ( member @ A @ X @ U3 )
           => ( ( member @ A @ Y @ U3 )
             => ( ( ord_less_eq @ A @ X @ Z2 )
               => ( ( ord_less_eq @ A @ Z2 @ Y )
                 => ( member @ A @ Z2 @ U3 ) ) ) ) ) ) ) ).

% connectedD_interval
thf(fact_7548_comp__fun__commute__on_Ofold__graph__insertE,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z2: B,V2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F2 @ Z2 @ ( insert2 @ A @ X @ A5 ) @ V2 )
         => ( ~ ( member @ A @ X @ A5 )
           => ~ ! [Y2: B] :
                  ( ( V2
                    = ( F2 @ X @ Y2 ) )
                 => ~ ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A5 @ Y2 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE
thf(fact_7549_comp__fun__commute__on_Ofold__equality,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,Z2: B,Y: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A5 @ Y )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ A5 )
            = Y ) ) ) ) ).

% comp_fun_commute_on.fold_equality
thf(fact_7550_connected__diff__open__from__closed,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,U: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ U )
           => ( ( topolo1002775350975398744n_open @ A @ S )
             => ( ( topolo7761053866217962861closed @ A @ T2 )
               => ( ( topolo1966860045006549960nected @ A @ U )
                 => ( ( topolo1966860045006549960nected @ A @ ( minus_minus @ ( set @ A ) @ T2 @ S ) )
                   => ( topolo1966860045006549960nected @ A @ ( minus_minus @ ( set @ A ) @ U @ S ) ) ) ) ) ) ) ) ) ).

% connected_diff_open_from_closed
thf(fact_7551_comp__fun__commute__on_Ofold__graph__fold,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( finite_fold_graph @ A @ B @ F2 @ Z2 @ A5 @ ( finite_fold @ A @ B @ F2 @ Z2 @ A5 ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_fold
thf(fact_7552_connected__def,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [S5: set @ A] :
              ~ ? [A7: set @ A,B7: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A7 )
                  & ( topolo1002775350975398744n_open @ A @ B7 )
                  & ( ord_less_eq @ ( set @ A ) @ S5 @ ( sup_sup @ ( set @ A ) @ A7 @ B7 ) )
                  & ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A7 @ B7 ) @ S5 )
                    = ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ A7 @ S5 )
                   != ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ B7 @ S5 )
                   != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% connected_def
thf(fact_7553_connectedI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [U3: set @ A] :
          ( ! [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
             => ! [B8: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ B8 )
                 => ( ( ( inf_inf @ ( set @ A ) @ A8 @ U3 )
                     != ( bot_bot @ ( set @ A ) ) )
                   => ( ( ( inf_inf @ ( set @ A ) @ B8 @ U3 )
                       != ( bot_bot @ ( set @ A ) ) )
                     => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A8 @ B8 ) @ U3 )
                          = ( bot_bot @ ( set @ A ) ) )
                       => ~ ( ord_less_eq @ ( set @ A ) @ U3 @ ( sup_sup @ ( set @ A ) @ A8 @ B8 ) ) ) ) ) ) )
         => ( topolo1966860045006549960nected @ A @ U3 ) ) ) ).

% connectedI
thf(fact_7554_connectedD,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A5: set @ A,U3: set @ A,V: set @ A] :
          ( ( topolo1966860045006549960nected @ A @ A5 )
         => ( ( topolo1002775350975398744n_open @ A @ U3 )
           => ( ( topolo1002775350975398744n_open @ A @ V )
             => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ U3 @ V ) @ A5 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ U3 @ V ) )
                 => ( ( ( inf_inf @ ( set @ A ) @ U3 @ A5 )
                      = ( bot_bot @ ( set @ A ) ) )
                    | ( ( inf_inf @ ( set @ A ) @ V @ A5 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% connectedD
thf(fact_7555_connected__closedD,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,A5: set @ A,B6: set @ A] :
          ( ( topolo1966860045006549960nected @ A @ S )
         => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) @ S )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
             => ( ( topolo7761053866217962861closed @ A @ A5 )
               => ( ( topolo7761053866217962861closed @ A @ B6 )
                 => ( ( ( inf_inf @ ( set @ A ) @ A5 @ S )
                      = ( bot_bot @ ( set @ A ) ) )
                    | ( ( inf_inf @ ( set @ A ) @ B6 @ S )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% connected_closedD
thf(fact_7556_map__tailrec__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map_tailrec_rev @ B @ A )
      = ( ^ [F3: B > A,As4: list @ B] : ( append @ A @ ( rev @ A @ ( map @ B @ A @ F3 @ As4 ) ) ) ) ) ).

% map_tailrec_rev
thf(fact_7557_insort__insert__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ~ ( member @ A @ ( F2 @ X ) @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
         => ( ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs )
            = ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) ) ) ).

% insort_insert_insort_key
thf(fact_7558_distinct__insort__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,X: B] :
          ( ( distinct @ B @ Xs )
         => ( distinct @ B @ ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs ) ) ) ) ).

% distinct_insort_insert
thf(fact_7559_map__tailrec__rev_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B,Bs: list @ B] :
      ( ( map_tailrec_rev @ A @ B @ F2 @ ( nil @ A ) @ Bs )
      = Bs ) ).

% map_tailrec_rev.simps(1)
thf(fact_7560_map__tailrec__rev_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A2: A,As2: list @ A,Bs: list @ B] :
      ( ( map_tailrec_rev @ A @ B @ F2 @ ( cons @ A @ A2 @ As2 ) @ Bs )
      = ( map_tailrec_rev @ A @ B @ F2 @ As2 @ ( cons @ B @ ( F2 @ A2 ) @ Bs ) ) ) ).

% map_tailrec_rev.simps(2)
thf(fact_7561_insort__insert__triv,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ( linord329482645794927042rt_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs )
            = Xs ) ) ) ).

% insort_insert_triv
thf(fact_7562_insort__insert__key__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( member @ A @ ( F2 @ X ) @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
         => ( ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs )
            = Xs ) ) ) ).

% insort_insert_key_triv
thf(fact_7563_map__tailrec__rev_Oelims,axiom,
    ! [A: $tType,B: $tType,X: A > B,Xa: list @ A,Xb3: list @ B,Y: list @ B] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb3 )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( Y != Xb3 ) )
       => ~ ! [A4: A,As: list @ A] :
              ( ( Xa
                = ( cons @ A @ A4 @ As ) )
             => ( Y
               != ( map_tailrec_rev @ A @ B @ X @ As @ ( cons @ B @ ( X @ A4 ) @ Xb3 ) ) ) ) ) ) ).

% map_tailrec_rev.elims
thf(fact_7564_set__insort__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( set2 @ A
            @ ( linord329482645794927042rt_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs ) )
          = ( insert2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ) ).

% set_insort_insert
thf(fact_7565_sorted__insort__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,X: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linord329482645794927042rt_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs ) ) ) ) ).

% sorted_insort_insert
thf(fact_7566_insort__insert__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ( linord329482645794927042rt_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs )
            = ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs ) ) ) ) ).

% insort_insert_insort
thf(fact_7567_sorted__insort__insert__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs ) ) ) ) ) ).

% sorted_insort_insert_key
thf(fact_7568_insort__insert__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord329482645794927042rt_key @ B @ A )
        = ( ^ [F3: B > A,X3: B,Xs3: list @ B] : ( if @ ( list @ B ) @ ( member @ A @ ( F3 @ X3 ) @ ( image @ B @ A @ F3 @ ( set2 @ B @ Xs3 ) ) ) @ Xs3 @ ( linorder_insort_key @ B @ A @ F3 @ X3 @ Xs3 ) ) ) ) ) ).

% insort_insert_key_def
thf(fact_7569_map__tailrec__rev_Opelims,axiom,
    ! [A: $tType,B: $tType,X: A > B,Xa: list @ A,Xb3: list @ B,Y: list @ B] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb3 )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb3 ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Y = Xb3 )
             => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xb3 ) ) ) ) )
         => ~ ! [A4: A,As: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A4 @ As ) )
               => ( ( Y
                    = ( map_tailrec_rev @ A @ B @ X @ As @ ( cons @ B @ ( X @ A4 ) @ Xb3 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A4 @ As ) @ Xb3 ) ) ) ) ) ) ) ) ).

% map_tailrec_rev.pelims
thf(fact_7570_map__tailrec__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_tailrec @ A @ B )
      = ( ^ [F3: A > B,As4: list @ A] : ( rev @ B @ ( map_tailrec_rev @ A @ B @ F3 @ As4 @ ( nil @ B ) ) ) ) ) ).

% map_tailrec_def
thf(fact_7571_map__eq__map__tailrec,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map @ A @ B )
      = ( map_tailrec @ A @ B ) ) ).

% map_eq_map_tailrec
thf(fact_7572_flat__lub__def,axiom,
    ! [A: $tType] :
      ( ( partial_flat_lub @ A )
      = ( ^ [B3: A,A7: set @ A] :
            ( if @ A @ ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert2 @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3
            @ ( the @ A
              @ ^ [X3: A] : ( member @ A @ X3 @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert2 @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% flat_lub_def
thf(fact_7573_arg__min__inj__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ( inj_on @ A @ B @ F2 @ ( collect @ A @ P ) )
         => ( ( P @ A2 )
           => ( ! [Y2: A] :
                  ( ( P @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ A2 ) @ ( F2 @ Y2 ) ) )
             => ( ( lattices_ord_arg_min @ A @ B @ F2 @ P )
                = A2 ) ) ) ) ) ).

% arg_min_inj_eq
thf(fact_7574_arg__minI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [P: A > $o,X: A,F2: A > B,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ~ ( ord_less @ B @ ( F2 @ Y2 ) @ ( F2 @ X ) ) )
           => ( ! [X2: A] :
                  ( ( P @ X2 )
                 => ( ! [Y5: A] :
                        ( ( P @ Y5 )
                       => ~ ( ord_less @ B @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) )
                   => ( Q @ X2 ) ) )
             => ( Q @ ( lattices_ord_arg_min @ A @ B @ F2 @ P ) ) ) ) ) ) ).

% arg_minI
thf(fact_7575_arg__min__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ( ( P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) )
        & ! [Y5: A] :
            ( ( P @ Y5 )
           => ( ord_less_eq @ nat @ ( M @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) @ ( M @ Y5 ) ) ) ) ) ).

% arg_min_nat_lemma
thf(fact_7576_arg__min__nat__le,axiom,
    ! [A: $tType,P: A > $o,X: A,M: A > nat] :
      ( ( P @ X )
     => ( ord_less_eq @ nat @ ( M @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) @ ( M @ X ) ) ) ).

% arg_min_nat_le
thf(fact_7577_arg__min__equality,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order @ A )
     => ! [P: C > $o,K: C,F2: C > A] :
          ( ( P @ K )
         => ( ! [X2: C] :
                ( ( P @ X2 )
               => ( ord_less_eq @ A @ ( F2 @ K ) @ ( F2 @ X2 ) ) )
           => ( ( F2 @ ( lattices_ord_arg_min @ C @ A @ F2 @ P ) )
              = ( F2 @ K ) ) ) ) ) ).

% arg_min_equality
thf(fact_7578_arg__min__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic7623131987881927897min_on @ B @ A )
        = ( ^ [F3: B > A,S5: set @ B] :
              ( lattices_ord_arg_min @ B @ A @ F3
              @ ^ [X3: B] : ( member @ B @ X3 @ S5 ) ) ) ) ) ).

% arg_min_on_def
thf(fact_7579_arg__min__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattices_ord_arg_min @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o] : ( fChoice @ B @ ( lattic501386751177426532rg_min @ B @ A @ F3 @ P3 ) ) ) ) ) ).

% arg_min_def
thf(fact_7580_maps__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( maps @ A @ B )
      = ( ^ [F3: A > ( list @ B ),Xs3: list @ A] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F3 @ Xs3 ) ) ) ) ).

% maps_def
thf(fact_7581_arg__min__natI,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ( P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) ) ).

% arg_min_natI
thf(fact_7582_is__arg__min__arg__min__nat,axiom,
    ! [A: $tType,P: A > $o,X: A,M: A > nat] :
      ( ( P @ X )
     => ( lattic501386751177426532rg_min @ A @ nat @ M @ P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) ) ).

% is_arg_min_arg_min_nat
thf(fact_7583_is__arg__min__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ( ( lattic501386751177426532rg_min @ A @ B )
        = ( ^ [F3: A > B,P3: A > $o,X3: A] :
              ( ( P3 @ X3 )
              & ! [Y4: A] :
                  ( ( P3 @ Y4 )
                 => ( ord_less_eq @ B @ ( F3 @ X3 ) @ ( F3 @ Y4 ) ) ) ) ) ) ) ).

% is_arg_min_linorder
thf(fact_7584_is__arg__min__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [F2: A > B,P: A > $o,X: A,Y: A] :
          ( ( lattic501386751177426532rg_min @ A @ B @ F2 @ P @ X )
         => ( ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) )
           => ( ( P @ Y )
             => ( lattic501386751177426532rg_min @ A @ B @ F2 @ P @ Y ) ) ) ) ) ).

% is_arg_min_antimono
thf(fact_7585_is__arg__min__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic501386751177426532rg_min @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o,X3: B] :
              ( ( P3 @ X3 )
              & ~ ? [Y4: B] :
                    ( ( P3 @ Y4 )
                    & ( ord_less @ A @ ( F3 @ Y4 ) @ ( F3 @ X3 ) ) ) ) ) ) ) ).

% is_arg_min_def
thf(fact_7586_maps__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( list @ A )] :
      ( ( maps @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% maps_simps(2)
thf(fact_7587_maps__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( list @ A ),X: B,Xs: list @ B] :
      ( ( maps @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
      = ( append @ A @ ( F2 @ X ) @ ( maps @ B @ A @ F2 @ Xs ) ) ) ).

% maps_simps(1)
thf(fact_7588_ex__is__arg__min__if__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X_1: A] :
                ( lattic501386751177426532rg_min @ A @ B @ F2
                @ ^ [X3: A] : ( member @ A @ X3 @ S2 )
                @ X_1 ) ) ) ) ).

% ex_is_arg_min_if_finite
thf(fact_7589_concat__map__maps,axiom,
    ! [A: $tType,B: $tType,F2: B > ( list @ A ),Xs: list @ B] :
      ( ( concat @ A @ ( map @ B @ ( list @ A ) @ F2 @ Xs ) )
      = ( maps @ B @ A @ F2 @ Xs ) ) ).

% concat_map_maps
thf(fact_7590_in__measures_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat,Fs: list @ ( A > nat )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ Fs ) ) ) ) ) ).

% in_measures(2)
thf(fact_7591_pred__nat__trancl__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N ) @ ( transitive_rtrancl @ nat @ pred_nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% pred_nat_trancl_eq_le
thf(fact_7592_in__measures_I1_J,axiom,
    ! [A: $tType,X: A,Y: A] :
      ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( nil @ ( A > nat ) ) ) ) ).

% in_measures(1)
thf(fact_7593_measures__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,Fs: list @ ( A > nat )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) ) ) ).

% measures_less
thf(fact_7594_measures__lesseq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,Fs: list @ ( A > nat )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ Fs ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) ) ) ) ).

% measures_lesseq
thf(fact_7595_less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N ) @ ( transitive_trancl @ nat @ pred_nat ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% less_eq
thf(fact_7596_VEBT_Osimps_I7_J,axiom,
    ! [A: $tType,F15: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ ( product_prod @ vEBT_VEBT @ A ) ) > vEBT_VEBT > A > A,F24: $o > $o > A,X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_rec_VEBT @ A @ F15 @ F24 @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( F15 @ X11 @ X12
        @ ( map @ vEBT_VEBT @ ( product_prod @ vEBT_VEBT @ A )
          @ ^ [VEBT: vEBT_VEBT] : ( product_Pair @ vEBT_VEBT @ A @ VEBT @ ( vEBT_rec_VEBT @ A @ F15 @ F24 @ VEBT ) )
          @ X13 )
        @ X14
        @ ( vEBT_rec_VEBT @ A @ F15 @ F24 @ X14 ) ) ) ).

% VEBT.simps(7)
thf(fact_7597_chains__extend,axiom,
    ! [A: $tType,C2: set @ ( set @ A ),S2: set @ ( set @ A ),Z2: set @ A] :
      ( ( member @ ( set @ ( set @ A ) ) @ C2 @ ( chains @ A @ S2 ) )
     => ( ( member @ ( set @ A ) @ Z2 @ S2 )
       => ( ! [X2: set @ A] :
              ( ( member @ ( set @ A ) @ X2 @ C2 )
             => ( ord_less_eq @ ( set @ A ) @ X2 @ Z2 ) )
         => ( member @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( insert2 @ ( set @ A ) @ Z2 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) @ C2 ) @ ( chains @ A @ S2 ) ) ) ) ) ).

% chains_extend
thf(fact_7598_chainsD2,axiom,
    ! [A: $tType,C2: set @ ( set @ A ),S2: set @ ( set @ A )] :
      ( ( member @ ( set @ ( set @ A ) ) @ C2 @ ( chains @ A @ S2 ) )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ C2 @ S2 ) ) ).

% chainsD2
thf(fact_7599_Zorn__Lemma2,axiom,
    ! [A: $tType,A5: set @ ( set @ A )] :
      ( ! [X2: set @ ( set @ A )] :
          ( ( member @ ( set @ ( set @ A ) ) @ X2 @ ( chains @ A @ A5 ) )
         => ? [Xa2: set @ A] :
              ( ( member @ ( set @ A ) @ Xa2 @ A5 )
              & ! [Xb2: set @ A] :
                  ( ( member @ ( set @ A ) @ Xb2 @ X2 )
                 => ( ord_less_eq @ ( set @ A ) @ Xb2 @ Xa2 ) ) ) )
     => ? [X2: set @ A] :
          ( ( member @ ( set @ A ) @ X2 @ A5 )
          & ! [Xa2: set @ A] :
              ( ( member @ ( set @ A ) @ Xa2 @ A5 )
             => ( ( ord_less_eq @ ( set @ A ) @ X2 @ Xa2 )
               => ( Xa2 = X2 ) ) ) ) ) ).

% Zorn_Lemma2
thf(fact_7600_chainsD,axiom,
    ! [A: $tType,C2: set @ ( set @ A ),S2: set @ ( set @ A ),X: set @ A,Y: set @ A] :
      ( ( member @ ( set @ ( set @ A ) ) @ C2 @ ( chains @ A @ S2 ) )
     => ( ( member @ ( set @ A ) @ X @ C2 )
       => ( ( member @ ( set @ A ) @ Y @ C2 )
         => ( ( ord_less_eq @ ( set @ A ) @ X @ Y )
            | ( ord_less_eq @ ( set @ A ) @ Y @ X ) ) ) ) ) ).

% chainsD
thf(fact_7601_Zorn__Lemma,axiom,
    ! [A: $tType,A5: set @ ( set @ A )] :
      ( ! [X2: set @ ( set @ A )] :
          ( ( member @ ( set @ ( set @ A ) ) @ X2 @ ( chains @ A @ A5 ) )
         => ( member @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ X2 ) @ A5 ) )
     => ? [X2: set @ A] :
          ( ( member @ ( set @ A ) @ X2 @ A5 )
          & ! [Xa2: set @ A] :
              ( ( member @ ( set @ A ) @ Xa2 @ A5 )
             => ( ( ord_less_eq @ ( set @ A ) @ X2 @ Xa2 )
               => ( Xa2 = X2 ) ) ) ) ) ).

% Zorn_Lemma
thf(fact_7602_VEBT_Osimps_I8_J,axiom,
    ! [A: $tType,F15: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ ( product_prod @ vEBT_VEBT @ A ) ) > vEBT_VEBT > A > A,F24: $o > $o > A,X21: $o,X22: $o] :
      ( ( vEBT_rec_VEBT @ A @ F15 @ F24 @ ( vEBT_Leaf @ X21 @ X22 ) )
      = ( F24 @ X21 @ X22 ) ) ).

% VEBT.simps(8)
thf(fact_7603_dependent__wellorder__choice,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ A )
     => ! [P: ( A > B ) > A > B > $o] :
          ( ! [R: B,F5: A > B,G7: A > B,X2: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ A @ Y5 @ X2 )
                 => ( ( F5 @ Y5 )
                    = ( G7 @ Y5 ) ) )
             => ( ( P @ F5 @ X2 @ R )
                = ( P @ G7 @ X2 @ R ) ) )
         => ( ! [X2: A,F5: A > B] :
                ( ! [Y5: A] :
                    ( ( ord_less @ A @ Y5 @ X2 )
                   => ( P @ F5 @ Y5 @ ( F5 @ Y5 ) ) )
               => ? [X_12: B] : ( P @ F5 @ X2 @ X_12 ) )
           => ? [F5: A > B] :
              ! [X5: A] : ( P @ F5 @ X5 @ ( F5 @ X5 ) ) ) ) ) ).

% dependent_wellorder_choice
thf(fact_7604_chains__def,axiom,
    ! [A: $tType] :
      ( ( chains @ A )
      = ( ^ [A7: set @ ( set @ A )] :
            ( collect @ ( set @ ( set @ A ) )
            @ ^ [C8: set @ ( set @ A )] :
                ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C8 @ A7 )
                & ( chain_subset @ A @ C8 ) ) ) ) ) ).

% chains_def
thf(fact_7605_init__seg__of__def,axiom,
    ! [A: $tType] :
      ( ( init_seg_of @ A )
      = ( collect @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
        @ ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ $o
          @ ^ [R5: set @ ( product_prod @ A @ A ),S6: set @ ( product_prod @ A @ A )] :
              ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ S6 )
              & ! [A3: A,B3: A,C5: A] :
                  ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B3 ) @ S6 )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C5 ) @ R5 ) )
                 => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B3 ) @ R5 ) ) ) ) ) ) ).

% init_seg_of_def
thf(fact_7606_chain__subset__def,axiom,
    ! [A: $tType] :
      ( ( chain_subset @ A )
      = ( ^ [C8: set @ ( set @ A )] :
          ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ C8 )
           => ! [Y4: set @ A] :
                ( ( member @ ( set @ A ) @ Y4 @ C8 )
               => ( ( ord_less_eq @ ( set @ A ) @ X3 @ Y4 )
                  | ( ord_less_eq @ ( set @ A ) @ Y4 @ X3 ) ) ) ) ) ) ).

% chain_subset_def
thf(fact_7607_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_7608_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_7609_map__snd__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ A @ ( product_snd @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) )
      = Xs ) ).

% map_snd_enumerate
thf(fact_7610_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
        = Xs ) ) ).

% map_fst_zip
thf(fact_7611_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
        = Ys2 ) ) ).

% map_snd_zip
thf(fact_7612_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) )
      = ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% map_fst_enumerate
thf(fact_7613_rel__fun__Collect__case__prodD,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,A5: A > B > $o,B6: C > D > $o,F2: A > C,G2: B > D,X8: set @ ( product_prod @ A @ B ),X: product_prod @ A @ B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A5 @ B6 @ F2 @ G2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ X8 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A5 ) ) )
       => ( ( member @ ( product_prod @ A @ B ) @ X @ X8 )
         => ( B6 @ ( comp @ A @ C @ ( product_prod @ A @ B ) @ F2 @ ( product_fst @ A @ B ) @ X ) @ ( comp @ B @ D @ ( product_prod @ A @ B ) @ G2 @ ( product_snd @ A @ B ) @ X ) ) ) ) ) ).

% rel_fun_Collect_case_prodD
thf(fact_7614_fun_Oin__rel,axiom,
    ! [B: $tType,A: $tType,D: $tType,R4: A > B > $o,A2: D > A,B2: D > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ R4
        @ A2
        @ B2 )
      = ( ? [Z5: D > ( product_prod @ A @ B )] :
            ( ( member @ ( D > ( product_prod @ A @ B ) ) @ Z5
              @ ( collect @ ( D > ( product_prod @ A @ B ) )
                @ ^ [X3: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ D @ ( product_prod @ A @ B ) @ X3 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R4 ) ) ) ) )
            & ( ( comp @ ( product_prod @ A @ B ) @ A @ D @ ( product_fst @ A @ B ) @ Z5 )
              = A2 )
            & ( ( comp @ ( product_prod @ A @ B ) @ B @ D @ ( product_snd @ A @ B ) @ Z5 )
              = B2 ) ) ) ) ).

% fun.in_rel
thf(fact_7615_predicate2__transferD,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: A > B > $o,R22: C > D > $o,P: A > C > $o,Q: B > D > $o,A2: product_prod @ A @ B,A5: set @ ( product_prod @ A @ B ),B2: product_prod @ C @ D,B6: set @ ( product_prod @ C @ D )] :
      ( ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ R1
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ R22
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ P
        @ Q )
     => ( ( member @ ( product_prod @ A @ B ) @ A2 @ A5 )
       => ( ( member @ ( product_prod @ C @ D ) @ B2 @ B6 )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A5 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R1 ) ) )
           => ( ( ord_less_eq @ ( set @ ( product_prod @ C @ D ) ) @ B6 @ ( collect @ ( product_prod @ C @ D ) @ ( product_case_prod @ C @ D @ $o @ R22 ) ) )
             => ( ( P @ ( product_fst @ A @ B @ A2 ) @ ( product_fst @ C @ D @ B2 ) )
                = ( Q @ ( product_snd @ A @ B @ A2 ) @ ( product_snd @ C @ D @ B2 ) ) ) ) ) ) ) ) ).

% predicate2_transferD
thf(fact_7616_Collect__split__mono__strong,axiom,
    ! [B: $tType,A: $tType,X8: set @ A,A5: set @ ( product_prod @ A @ B ),Y6: set @ B,P: A > B > $o,Q: A > B > $o] :
      ( ( X8
        = ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A5 ) )
     => ( ( Y6
          = ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A5 ) )
       => ( ! [X2: A] :
              ( ( member @ A @ X2 @ X8 )
             => ! [Xa3: B] :
                  ( ( member @ B @ Xa3 @ Y6 )
                 => ( ( P @ X2 @ Xa3 )
                   => ( Q @ X2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A5 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
           => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A5 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ Q ) ) ) ) ) ) ) ).

% Collect_split_mono_strong
thf(fact_7617_subset__fst__snd,axiom,
    ! [B: $tType,A: $tType,A5: set @ ( product_prod @ A @ B )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A5
      @ ( product_Sigma @ A @ B @ ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A5 )
        @ ^ [Uu3: A] : ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A5 ) ) ) ).

% subset_fst_snd
thf(fact_7618_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_7619_measure__snd,axiom,
    ! [A: $tType,B: $tType,F2: A > nat] :
      ( ( fun_is_measure @ A @ F2 )
     => ( fun_is_measure @ ( product_prod @ B @ A )
        @ ^ [P5: product_prod @ B @ A] : ( F2 @ ( product_snd @ B @ A @ P5 ) ) ) ) ).

% measure_snd
thf(fact_7620_measure__fst,axiom,
    ! [B: $tType,A: $tType,F2: A > nat] :
      ( ( fun_is_measure @ A @ F2 )
     => ( fun_is_measure @ ( product_prod @ A @ B )
        @ ^ [P5: product_prod @ A @ B] : ( F2 @ ( product_fst @ A @ B @ P5 ) ) ) ) ).

% measure_fst
thf(fact_7621_update__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B,I: nat,Xy: product_prod @ A @ B] :
      ( ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) @ I @ Xy )
      = ( zip @ A @ B @ ( list_update @ A @ Xs @ I @ ( product_fst @ A @ B @ Xy ) ) @ ( list_update @ B @ Ys2 @ I @ ( product_snd @ A @ B @ Xy ) ) ) ) ).

% update_zip
thf(fact_7622_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P6: product_prod @ A @ B,Xs: list @ A,Ys2: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ P6 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
      = ( ? [N3: nat] :
            ( ( ( nth @ A @ Xs @ N3 )
              = ( product_fst @ A @ B @ P6 ) )
            & ( ( nth @ B @ Ys2 @ N3 )
              = ( product_snd @ A @ B @ P6 ) )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ).

% in_set_zip
thf(fact_7623_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,P: B > $o,Ys2: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( takeWhile @ B @ P @ Ys2 ) )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ B @ $o @ ( product_prod @ A @ B ) @ P @ ( product_snd @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% zip_takeWhile_snd
thf(fact_7624_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P: A > $o,Xs: list @ A,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( takeWhile @ A @ P @ Xs ) @ Ys2 )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ A @ $o @ ( product_prod @ A @ B ) @ P @ ( product_fst @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% zip_takeWhile_fst
thf(fact_7625_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs3: list @ A,A7: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P5 ) @ A7 )
              @ ( zip @ A @ nat @ Xs3 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ) ).

% nths_def
thf(fact_7626_nths__shift__lemma,axiom,
    ! [A: $tType,A5: set @ nat,Xs: list @ A,I: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P5 ) @ A5 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ I @ ( plus_plus @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P5 ) @ I ) @ A5 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_7627_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P5 ) ) )
          @ ( zip @ A @ nat @ Xs @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P5 ) )
          @ ( zip @ A @ nat @ Xs @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_7628_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys2: list @ ( product_prod @ A @ B )] :
      ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs )
        = ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys2 ) )
     => ( ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs )
          = ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Ys2 ) )
       => ( Xs = Ys2 ) ) ) ).

% pair_list_eqI
thf(fact_7629_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ ( product_prod @ A @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( ( zip @ A @ B @ Xs @ Ys2 )
          = Zs )
        = ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs )
            = Xs )
          & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs )
            = Ys2 ) ) ) ) ).

% zip_eq_conv
thf(fact_7630_zip__map__fst__snd,axiom,
    ! [B: $tType,A: $tType,Zs: list @ ( product_prod @ A @ B )] :
      ( ( zip @ A @ B @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs ) @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs ) )
      = Zs ) ).

% zip_map_fst_snd
thf(fact_7631_in__set__enumerate__eq,axiom,
    ! [A: $tType,P6: product_prod @ nat @ A,N: nat,Xs: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P6 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) )
      = ( ( ord_less_eq @ nat @ N @ ( product_fst @ nat @ A @ P6 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P6 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
        & ( ( nth @ A @ Xs @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P6 ) @ N ) )
          = ( product_snd @ nat @ A @ P6 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_7632_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ) ).

% sorted_enumerate
thf(fact_7633_subset__snd__imageI,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B6: set @ B,S2: set @ ( product_prod @ A @ B ),X: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : B6 )
        @ S2 )
     => ( ( member @ A @ X @ A5 )
       => ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ S2 ) ) ) ) ).

% subset_snd_imageI
thf(fact_7634_subset__fst__imageI,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B6: set @ B,S2: set @ ( product_prod @ A @ B ),Y: B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : B6 )
        @ S2 )
     => ( ( member @ B @ Y @ B6 )
       => ( ord_less_eq @ ( set @ A ) @ A5 @ ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ S2 ) ) ) ) ).

% subset_fst_imageI
thf(fact_7635_map__snd__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ B,Ys2: list @ A] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys2 ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ B ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) @ Ys2 ) ) ).

% map_snd_zip_take
thf(fact_7636_map__fst__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) @ Xs ) ) ).

% map_fst_zip_take
thf(fact_7637_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F3: A > nat,G: B > nat,P5: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F3 @ ( product_fst @ A @ B @ P5 ) ) @ ( G @ ( product_snd @ A @ B @ P5 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_7638_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys2 ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy2: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy2 )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy2 ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys2 ) ) ) ) ).

% set_relcomp
thf(fact_7639_quotient__of__denom__pos_H,axiom,
    ! [R2: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R2 ) ) ) ).

% quotient_of_denom_pos'
thf(fact_7640_partition__filter1,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ Xs ) ) ).

% partition_filter1
thf(fact_7641_Rat_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ $o @ $o @ pcr_rat
    @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
    @ ^ [X3: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) )
    @ positive ) ).

% Rat.positive.transfer
thf(fact_7642_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_7643_trancl__Int__subset,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R2 ) @ S ) @ R2 ) @ S )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R2 ) @ S ) ) ) ).

% trancl_Int_subset
thf(fact_7644_union__comp__emptyL,axiom,
    ! [A: $tType,A5: set @ ( product_prod @ A @ A ),C4: set @ ( product_prod @ A @ A ),B6: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A5 @ C4 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ B6 @ C4 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ A5 @ B6 ) @ C4 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyL
thf(fact_7645_union__comp__emptyR,axiom,
    ! [A: $tType,A5: set @ ( product_prod @ A @ A ),B6: set @ ( product_prod @ A @ A ),C4: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A5 @ B6 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ A5 @ C4 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ A5 @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ B6 @ C4 ) )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyR
thf(fact_7646_relcomp__subset__Sigma,axiom,
    ! [B: $tType,C: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),A5: set @ A,B6: set @ B,S: set @ ( product_prod @ B @ C ),C4: set @ C] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : B6 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S
          @ ( product_Sigma @ B @ C @ B6
            @ ^ [Uu3: B] : C4 ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R2 @ S )
          @ ( product_Sigma @ A @ C @ A5
            @ ^ [Uu3: A] : C4 ) ) ) ) ).

% relcomp_subset_Sigma
thf(fact_7647_relcomp__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set @ ( product_prod @ A @ B ),R2: set @ ( product_prod @ A @ B ),S10: set @ ( product_prod @ B @ C ),S: set @ ( product_prod @ B @ C )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ R2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S10 @ S )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R3 @ S10 ) @ ( relcomp @ A @ B @ C @ R2 @ S ) ) ) ) ).

% relcomp_mono
thf(fact_7648_partition__filter2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs ) ) ).

% partition_filter2
thf(fact_7649_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y )
     => ( ( bezw @ X @ Y )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_7650_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_7651_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X3: nat,Y4: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y4
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X3 @ Y4 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X3 @ Y4 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X3 @ Y4 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X3 @ Y4 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_7652_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_7653_min__ext__compat,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R4 @ S2 ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( min_ext @ A @ R4 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( min_ext @ A @ S2 ) @ ( insert2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( min_ext @ A @ R4 ) ) ) ).

% min_ext_compat
thf(fact_7654_max__ext__compat,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R4 @ S2 ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( max_ext @ A @ R4 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( max_ext @ A @ S2 ) @ ( insert2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( max_ext @ A @ R4 ) ) ) ).

% max_ext_compat
thf(fact_7655_Rat_Opositive_Orep__eq,axiom,
    ( positive
    = ( ^ [X3: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ ( rep_Rat @ X3 ) ) @ ( product_snd @ int @ int @ ( rep_Rat @ X3 ) ) ) ) ) ) ).

% Rat.positive.rep_eq
thf(fact_7656_Rat_Opositive__def,axiom,
    ( positive
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ $o @ $o @ rep_Rat @ ( id @ $o )
      @ ^ [X3: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ) ).

% Rat.positive_def
thf(fact_7657_normalize__def,axiom,
    ( normalize
    = ( ^ [P5: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P5 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P5 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P5 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P5 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P5 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P5 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_7658_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% gcd_eq_0_iff
thf(fact_7659_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N ) ) ) ).

% gcd_exp
thf(fact_7660_gcd__pos__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_7661_gcd__0__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ X @ ( zero_zero @ int ) )
      = ( abs_abs @ int @ X ) ) ).

% gcd_0_int
thf(fact_7662_gcd__0__left__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ ( zero_zero @ int ) @ X )
      = ( abs_abs @ int @ X ) ) ).

% gcd_0_left_int
thf(fact_7663_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K4: int,L4: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L4
              = ( zero_zero @ int ) )
            @ K4
            @ ( gcd_gcd @ int @ L4 @ ( modulo_modulo @ int @ ( abs_abs @ int @ K4 ) @ ( abs_abs @ int @ L4 ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_7664_gcd__non__0__int,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y )
     => ( ( gcd_gcd @ int @ X @ Y )
        = ( gcd_gcd @ int @ Y @ ( modulo_modulo @ int @ X @ Y ) ) ) ) ).

% gcd_non_0_int
thf(fact_7665_Gcd__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
         => ( ( gcd_gcd @ A @ ( semiring_gcd_Gcd_fin @ A @ B6 ) @ ( semiring_gcd_Gcd_fin @ A @ A5 ) )
            = ( semiring_gcd_Gcd_fin @ A @ A5 ) ) ) ) ).

% Gcd_fin.subset
thf(fact_7666_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ D2 @ A2 )
        & ( dvd_dvd @ int @ D2 @ B2 )
        & ! [E3: int] :
            ( ( ( dvd_dvd @ int @ E3 @ A2 )
              & ( dvd_dvd @ int @ E3 @ B2 ) )
           => ( dvd_dvd @ int @ E3 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ int @ A2 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_7667_gcd__ge__0__int,axiom,
    ! [X: int,Y: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X @ Y ) ) ).

% gcd_ge_0_int
thf(fact_7668_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_7669_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_7670_gcd__cases__int,axiom,
    ! [X: int,Y: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
         => ( P @ ( gcd_gcd @ int @ X @ Y ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
         => ( ( ord_less_eq @ int @ Y @ ( zero_zero @ int ) )
           => ( P @ ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ Y ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
             => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ Y ) ) ) )
         => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y @ ( zero_zero @ int ) )
               => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ ( uminus_uminus @ int @ Y ) ) ) ) )
           => ( P @ ( gcd_gcd @ int @ X @ Y ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_7671_Gcd__int__set__eq__fold,axiom,
    ! [Xs: list @ int] :
      ( ( gcd_Gcd @ int @ ( set2 @ int @ Xs ) )
      = ( fold @ int @ int @ ( gcd_gcd @ int ) @ Xs @ ( zero_zero @ int ) ) ) ).

% Gcd_int_set_eq_fold
thf(fact_7672_Gcd__set__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [Xs: list @ A] :
          ( ( gcd_Gcd @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_gcd @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ).

% Gcd_set_eq_fold
thf(fact_7673_Gcd__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs: list @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_gcd @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ).

% Gcd_fin.set_eq_fold
thf(fact_7674_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( gcd_gcd @ int @ M @ N )
        = ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D6: int] :
                ( ( dvd_dvd @ int @ D6 @ M )
                & ( dvd_dvd @ int @ D6 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_int
thf(fact_7675_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( ^ [A7: set @ A] : ( if @ A @ ( finite_finite @ A @ A7 ) @ ( finite_fold @ A @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ A7 ) @ ( one_one @ A ) ) ) ) ) ).

% Gcd_fin.eq_fold
thf(fact_7676_bezw__aux,axiom,
    ! [X: nat,Y: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X @ Y ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X @ Y ) ) @ ( semiring_1_of_nat @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X @ Y ) ) @ ( semiring_1_of_nat @ int @ Y ) ) ) ) ).

% bezw_aux
thf(fact_7677_quotient__of__def,axiom,
    ( quotient_of
    = ( ^ [X3: rat] :
          ( the @ ( product_prod @ int @ int )
          @ ^ [Pair: product_prod @ int @ int] :
              ( ( X3
                = ( fract @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) )
              & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Pair ) )
              & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) ) ) ) ) ).

% quotient_of_def
thf(fact_7678_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( gcd_gcd @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.eq_neutr_iff
thf(fact_7679_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% gcd_nat.left_neutral
thf(fact_7680_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( gcd_gcd @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.neutr_eq_iff
thf(fact_7681_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% gcd_nat.right_neutral
thf(fact_7682_gcd__0__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ X @ ( zero_zero @ nat ) )
      = X ) ).

% gcd_0_nat
thf(fact_7683_gcd__0__left__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ X )
      = X ) ).

% gcd_0_left_nat
thf(fact_7684_coprime__mod__left__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_left_iff
thf(fact_7685_coprime__mod__right__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ A2 @ ( modulo_modulo @ A @ B2 @ A2 ) )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_right_iff
thf(fact_7686_coprime__power__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( power_power @ A @ B2 @ N ) )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_right_iff
thf(fact_7687_coprime__power__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_left_iff
thf(fact_7688_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_7689_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_7690_gcd__int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( gcd_gcd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_int_int_eq
thf(fact_7691_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( zero_zero @ A ) @ A2 )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_left_iff
thf(fact_7692_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_right_iff
thf(fact_7693_gcd__nat__abs__right__eq,axiom,
    ! [N: nat,K: int] :
      ( ( gcd_gcd @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( nat2 @ ( gcd_gcd @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% gcd_nat_abs_right_eq
thf(fact_7694_gcd__nat__abs__left__eq,axiom,
    ! [K: int,N: nat] :
      ( ( gcd_gcd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( nat2 @ ( gcd_gcd @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ) ).

% gcd_nat_abs_left_eq
thf(fact_7695_normalize__stable,axiom,
    ! [Q4: int,P6: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Q4 )
     => ( ( algebr8660921524188924756oprime @ int @ P6 @ Q4 )
       => ( ( normalize @ ( product_Pair @ int @ int @ P6 @ Q4 ) )
          = ( product_Pair @ int @ int @ P6 @ Q4 ) ) ) ) ).

% normalize_stable
thf(fact_7696_gcd__code__integer,axiom,
    ( ( gcd_gcd @ code_integer )
    = ( ^ [K4: code_integer,L4: code_integer] :
          ( abs_abs @ code_integer
          @ ( if @ code_integer
            @ ( L4
              = ( zero_zero @ code_integer ) )
            @ K4
            @ ( gcd_gcd @ code_integer @ L4 @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K4 ) @ ( abs_abs @ code_integer @ L4 ) ) ) ) ) ) ) ).

% gcd_code_integer
thf(fact_7697_div__gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( A2
             != ( zero_zero @ A ) )
            | ( B2
             != ( zero_zero @ A ) ) )
         => ( algebr8660921524188924756oprime @ A @ ( divide_divide @ A @ A2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) @ ( divide_divide @ A @ B2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ) ).

% div_gcd_coprime
thf(fact_7698_gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,A6: A,B5: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( times_times @ A @ A6 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
           => ( ( B2
                = ( times_times @ A @ B5 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
             => ( algebr8660921524188924756oprime @ A @ A6 @ B5 ) ) ) ) ) ).

% gcd_coprime
thf(fact_7699_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ? [A20: A,B14: A] :
              ( ( A2
                = ( times_times @ A @ A20 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( B2
                = ( times_times @ A @ B14 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( algebr8660921524188924756oprime @ A @ A20 @ B14 ) ) ) ) ).

% gcd_coprime_exists
thf(fact_7700_gcd__nat_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y = X ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y
            = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_7701_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X3: nat,Y4: nat] :
          ( if @ nat
          @ ( Y4
            = ( zero_zero @ nat ) )
          @ X3
          @ ( gcd_gcd @ nat @ Y4 @ ( modulo_modulo @ nat @ X3 @ Y4 ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_7702_gcd__non__0__nat,axiom,
    ! [Y: nat,X: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X @ Y )
        = ( gcd_gcd @ nat @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) ) ).

% gcd_non_0_nat
thf(fact_7703_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X2: nat,Y2: nat] :
          ( ( times_times @ nat @ A2 @ X2 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_7704_gcd__diff1__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff1_nat
thf(fact_7705_gcd__diff2__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N @ M ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff2_nat
thf(fact_7706_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_7707_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_7708_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X2: nat,Y2: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ ( times_times @ nat @ A2 @ X2 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X2 ) @ ( times_times @ nat @ B2 @ Y2 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y2 ) @ ( times_times @ nat @ B2 @ X2 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X2 ) @ ( times_times @ nat @ A2 @ Y2 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_7709_Rat__induct,axiom,
    ! [P: rat > $o,Q4: rat] :
      ( ! [A4: int,B4: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
         => ( ( algebr8660921524188924756oprime @ int @ A4 @ B4 )
           => ( P @ ( fract @ A4 @ B4 ) ) ) )
     => ( P @ Q4 ) ) ).

% Rat_induct
thf(fact_7710_Rat__cases,axiom,
    ! [Q4: rat] :
      ~ ! [A4: int,B4: int] :
          ( ( Q4
            = ( fract @ A4 @ B4 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
           => ~ ( algebr8660921524188924756oprime @ int @ A4 @ B4 ) ) ) ).

% Rat_cases
thf(fact_7711_prod__list__coprime__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( algebr8660921524188924756oprime @ A @ X2 @ A2 ) )
         => ( algebr8660921524188924756oprime @ A @ ( groups5270119922927024881d_list @ A @ Xs ) @ A2 ) ) ) ).

% prod_list_coprime_left
thf(fact_7712_prod__list__coprime__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( algebr8660921524188924756oprime @ A @ A2 @ X2 ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ ( groups5270119922927024881d_list @ A @ Xs ) ) ) ) ).

% prod_list_coprime_right
thf(fact_7713_Gcd__nat__set__eq__fold,axiom,
    ! [Xs: list @ nat] :
      ( ( gcd_Gcd @ nat @ ( set2 @ nat @ Xs ) )
      = ( fold @ nat @ nat @ ( gcd_gcd @ nat ) @ Xs @ ( zero_zero @ nat ) ) ) ).

% Gcd_nat_set_eq_fold
thf(fact_7714_Rat__cases__nonzero,axiom,
    ! [Q4: rat] :
      ( ! [A4: int,B4: int] :
          ( ( Q4
            = ( fract @ A4 @ B4 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
           => ( ( A4
               != ( zero_zero @ int ) )
             => ~ ( algebr8660921524188924756oprime @ int @ A4 @ B4 ) ) ) )
     => ( Q4
        = ( zero_zero @ rat ) ) ) ).

% Rat_cases_nonzero
thf(fact_7715_gcd__int__def,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [X3: int,Y4: int] : ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ ( nat2 @ ( abs_abs @ int @ X3 ) ) @ ( nat2 @ ( abs_abs @ int @ Y4 ) ) ) ) ) ) ).

% gcd_int_def
thf(fact_7716_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M2: nat,N3: nat] :
        ( ( dvd_dvd @ nat @ M2 @ N3 )
        & ( M2 != N3 ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_7717_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( gcd_gcd @ nat @ M @ N )
        = ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D6: nat] :
                ( ( dvd_dvd @ nat @ D6 @ M )
                & ( dvd_dvd @ nat @ D6 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_nat
thf(fact_7718_Rats__cases_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( field_char_0_Rats @ A ) )
         => ~ ! [A4: int,B4: int] :
                ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
               => ( ( algebr8660921524188924756oprime @ int @ A4 @ B4 )
                 => ( X
                   != ( divide_divide @ A @ ( ring_1_of_int @ A @ A4 ) @ ( ring_1_of_int @ A @ B4 ) ) ) ) ) ) ) ).

% Rats_cases'
thf(fact_7719_quotient__of__unique,axiom,
    ! [R2: rat] :
    ? [X2: product_prod @ int @ int] :
      ( ( R2
        = ( fract @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) )
      & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ X2 ) )
      & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) )
      & ! [Y5: product_prod @ int @ int] :
          ( ( ( R2
              = ( fract @ ( product_fst @ int @ int @ Y5 ) @ ( product_snd @ int @ int @ Y5 ) ) )
            & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Y5 ) )
            & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Y5 ) @ ( product_snd @ int @ int @ Y5 ) ) )
         => ( Y5 = X2 ) ) ) ).

% quotient_of_unique
thf(fact_7720_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y = X ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_7721_list_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R6: A > B > $o,A3: list @ A,B3: list @ B] :
          ? [Z5: list @ ( product_prod @ A @ B )] :
            ( ( member @ ( list @ ( product_prod @ A @ B ) ) @ Z5
              @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                @ ^ [X3: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X3 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R6 ) ) ) ) )
            & ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z5 )
              = A3 )
            & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z5 )
              = B3 ) ) ) ) ).

% list.in_rel
thf(fact_7722_list__all2__Nil,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Ys2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( nil @ A ) @ Ys2 )
      = ( Ys2
        = ( nil @ B ) ) ) ).

% list_all2_Nil
thf(fact_7723_list__all2__Nil2,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Xs: list @ A] :
      ( ( list_all2 @ A @ B @ P @ Xs @ ( nil @ B ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_all2_Nil2
thf(fact_7724_list__all2__rev,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( rev @ A @ Xs ) @ ( rev @ B @ Ys2 ) )
      = ( list_all2 @ A @ B @ P @ Xs @ Ys2 ) ) ).

% list_all2_rev
thf(fact_7725_coprime__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( algebr8660921524188924756oprime @ nat @ M @ N ) ) ).

% coprime_int_iff
thf(fact_7726_coprime__nat__abs__left__iff,axiom,
    ! [K: int,N: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( algebr8660921524188924756oprime @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% coprime_nat_abs_left_iff
thf(fact_7727_coprime__nat__abs__right__iff,axiom,
    ! [N: nat,K: int] :
      ( ( algebr8660921524188924756oprime @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% coprime_nat_abs_right_iff
thf(fact_7728_List_Ofold__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A5: A > C > $o,B6: B > D > $o] : ( bNF_rel_fun @ ( A > B > B ) @ ( C > D > D ) @ ( ( list @ A ) > B > B ) @ ( ( list @ C ) > D > D ) @ ( bNF_rel_fun @ A @ C @ ( B > B ) @ ( D > D ) @ A5 @ ( bNF_rel_fun @ B @ D @ B @ D @ B6 @ B6 ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( B > B ) @ ( D > D ) @ ( list_all2 @ A @ C @ A5 ) @ ( bNF_rel_fun @ B @ D @ B @ D @ B6 @ B6 ) ) @ ( fold @ A @ B ) @ ( fold @ C @ D ) ) ).

% List.fold_transfer
thf(fact_7729_coprime__Suc__0__right,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ).

% coprime_Suc_0_right
thf(fact_7730_coprime__Suc__0__left,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ).

% coprime_Suc_0_left
thf(fact_7731_list__all2__map2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: A > B > $o,As2: list @ A,F2: C > B,Bs: list @ C] :
      ( ( list_all2 @ A @ B @ P @ As2 @ ( map @ C @ B @ F2 @ Bs ) )
      = ( list_all2 @ A @ C
        @ ^ [X3: A,Y4: C] : ( P @ X3 @ ( F2 @ Y4 ) )
        @ As2
        @ Bs ) ) ).

% list_all2_map2
thf(fact_7732_list__all2__map1,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: A > B > $o,F2: C > A,As2: list @ C,Bs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( map @ C @ A @ F2 @ As2 ) @ Bs )
      = ( list_all2 @ C @ B
        @ ^ [X3: C] : ( P @ ( F2 @ X3 ) )
        @ As2
        @ Bs ) ) ).

% list_all2_map1
thf(fact_7733_list_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I: A > C,X: list @ A,Y: list @ B] :
      ( ( list_all2 @ C @ B @ Sb @ ( map @ A @ C @ I @ X ) @ Y )
      = ( list_all2 @ A @ B
        @ ^ [X3: A] : ( Sb @ ( I @ X3 ) )
        @ X
        @ Y ) ) ).

% list.rel_map(1)
thf(fact_7734_list_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X: list @ A,G2: B > C,Y: list @ B] :
      ( ( list_all2 @ A @ C @ Sa @ X @ ( map @ B @ C @ G2 @ Y ) )
      = ( list_all2 @ A @ B
        @ ^ [X3: A,Y4: B] : ( Sa @ X3 @ ( G2 @ Y4 ) )
        @ X
        @ Y ) ) ).

% list.rel_map(2)
thf(fact_7735_list_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X: list @ A,Ya: list @ A,Y: list @ B,Xa: list @ B,R4: A > B > $o,Ra: A > B > $o] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: A,Yb: B] :
              ( ( member @ A @ Z3 @ ( set2 @ A @ Ya ) )
             => ( ( member @ B @ Yb @ ( set2 @ B @ Xa ) )
               => ( ( R4 @ Z3 @ Yb )
                  = ( Ra @ Z3 @ Yb ) ) ) )
         => ( ( list_all2 @ A @ B @ R4 @ X @ Y )
            = ( list_all2 @ A @ B @ Ra @ Ya @ Xa ) ) ) ) ) ).

% list.rel_cong
thf(fact_7736_list_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,X: list @ A,Y: list @ B,Ra: A > B > $o] :
      ( ( list_all2 @ A @ B @ R4 @ X @ Y )
     => ( ! [Z3: A,Yb: B] :
            ( ( member @ A @ Z3 @ ( set2 @ A @ X ) )
           => ( ( member @ B @ Yb @ ( set2 @ B @ Y ) )
             => ( ( R4 @ Z3 @ Yb )
               => ( Ra @ Z3 @ Yb ) ) ) )
       => ( list_all2 @ A @ B @ Ra @ X @ Y ) ) ) ).

% list.rel_mono_strong
thf(fact_7737_list_Orel__refl__strong,axiom,
    ! [A: $tType,X: list @ A,Ra: A > A > $o] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( set2 @ A @ X ) )
         => ( Ra @ Z3 @ Z3 ) )
     => ( list_all2 @ A @ A @ Ra @ X @ X ) ) ).

% list.rel_refl_strong
thf(fact_7738_list__all2__same,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( list_all2 @ A @ A @ P @ Xs @ Xs )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 @ X3 ) ) ) ) ).

% list_all2_same
thf(fact_7739_list_Orel__inject_I2_J,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,X21: A,X22: list @ A,Y21: B,Y22: list @ B] :
      ( ( list_all2 @ A @ B @ R4 @ ( cons @ A @ X21 @ X22 ) @ ( cons @ B @ Y21 @ Y22 ) )
      = ( ( R4 @ X21 @ Y21 )
        & ( list_all2 @ A @ B @ R4 @ X22 @ Y22 ) ) ) ).

% list.rel_inject(2)
thf(fact_7740_list_Orel__intros_I2_J,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,X21: A,Y21: B,X22: list @ A,Y22: list @ B] :
      ( ( R4 @ X21 @ Y21 )
     => ( ( list_all2 @ A @ B @ R4 @ X22 @ Y22 )
       => ( list_all2 @ A @ B @ R4 @ ( cons @ A @ X21 @ X22 ) @ ( cons @ B @ Y21 @ Y22 ) ) ) ) ).

% list.rel_intros(2)
thf(fact_7741_list__all2__Cons,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Xs: list @ A,Y: B,Ys2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys2 ) )
      = ( ( P @ X @ Y )
        & ( list_all2 @ A @ B @ P @ Xs @ Ys2 ) ) ) ).

% list_all2_Cons
thf(fact_7742_list__all2__Cons1,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Xs: list @ A,Ys2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( cons @ A @ X @ Xs ) @ Ys2 )
      = ( ? [Z5: B,Zs3: list @ B] :
            ( ( Ys2
              = ( cons @ B @ Z5 @ Zs3 ) )
            & ( P @ X @ Z5 )
            & ( list_all2 @ A @ B @ P @ Xs @ Zs3 ) ) ) ) ).

% list_all2_Cons1
thf(fact_7743_list__all2__Cons2,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Xs: list @ A,Y: B,Ys2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ Xs @ ( cons @ B @ Y @ Ys2 ) )
      = ( ? [Z5: A,Zs3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Z5 @ Zs3 ) )
            & ( P @ Z5 @ Y )
            & ( list_all2 @ A @ B @ P @ Zs3 @ Ys2 ) ) ) ) ).

% list_all2_Cons2
thf(fact_7744_list_Obi__total__rel,axiom,
    ! [B: $tType,A: $tType,R4: A > B > $o] :
      ( ( bi_total @ A @ B @ R4 )
     => ( bi_total @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R4 ) ) ) ).

% list.bi_total_rel
thf(fact_7745_list__all2__nthD,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B,P6: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
     => ( ( ord_less @ nat @ P6 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ P6 ) @ ( nth @ B @ Ys2 @ P6 ) ) ) ) ).

% list_all2_nthD
thf(fact_7746_list__all2__nthD2,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B,P6: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
     => ( ( ord_less @ nat @ P6 @ ( size_size @ ( list @ B ) @ Ys2 ) )
       => ( P @ ( nth @ A @ Xs @ P6 ) @ ( nth @ B @ Ys2 @ P6 ) ) ) ) ).

% list_all2_nthD2
thf(fact_7747_list__all2__all__nthI,axiom,
    ! [A: $tType,B: $tType,A2: list @ A,B2: list @ B,P: A > B > $o] :
      ( ( ( size_size @ ( list @ A ) @ A2 )
        = ( size_size @ ( list @ B ) @ B2 ) )
     => ( ! [N2: nat] :
            ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ A2 ) )
           => ( P @ ( nth @ A @ A2 @ N2 ) @ ( nth @ B @ B2 @ N2 ) ) )
       => ( list_all2 @ A @ B @ P @ A2 @ B2 ) ) ) ).

% list_all2_all_nthI
thf(fact_7748_list__all2__conv__all__nth,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P3: A > B > $o,Xs3: list @ A,Ys3: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ B ) @ Ys3 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( P3 @ ( nth @ A @ Xs3 @ I4 ) @ ( nth @ B @ Ys3 @ I4 ) ) ) ) ) ) ).

% list_all2_conv_all_nth
thf(fact_7749_list__all2__appendI,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,A2: list @ A,B2: list @ B,C2: list @ A,D2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ A2 @ B2 )
     => ( ( list_all2 @ A @ B @ P @ C2 @ D2 )
       => ( list_all2 @ A @ B @ P @ ( append @ A @ A2 @ C2 ) @ ( append @ B @ B2 @ D2 ) ) ) ) ).

% list_all2_appendI
thf(fact_7750_list__all2__update__cong,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B,X: A,Y: B,I: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
     => ( ( P @ X @ Y )
       => ( list_all2 @ A @ B @ P @ ( list_update @ A @ Xs @ I @ X ) @ ( list_update @ B @ Ys2 @ I @ Y ) ) ) ) ).

% list_all2_update_cong
thf(fact_7751_list__all2__antisym,axiom,
    ! [A: $tType,P: A > A > $o,Q: A > A > $o,Xs: list @ A,Ys2: list @ A] :
      ( ! [X2: A,Y2: A] :
          ( ( P @ X2 @ Y2 )
         => ( ( Q @ Y2 @ X2 )
           => ( X2 = Y2 ) ) )
     => ( ( list_all2 @ A @ A @ P @ Xs @ Ys2 )
       => ( ( list_all2 @ A @ A @ Q @ Ys2 @ Xs )
         => ( Xs = Ys2 ) ) ) ) ).

% list_all2_antisym
thf(fact_7752_list__all2__trans,axiom,
    ! [B: $tType,A: $tType,C: $tType,P1: A > B > $o,P22: B > C > $o,P32: A > C > $o,As2: list @ A,Bs: list @ B,Cs: list @ C] :
      ( ! [A4: A,B4: B,C3: C] :
          ( ( P1 @ A4 @ B4 )
         => ( ( P22 @ B4 @ C3 )
           => ( P32 @ A4 @ C3 ) ) )
     => ( ( list_all2 @ A @ B @ P1 @ As2 @ Bs )
       => ( ( list_all2 @ B @ C @ P22 @ Bs @ Cs )
         => ( list_all2 @ A @ C @ P32 @ As2 @ Cs ) ) ) ) ).

% list_all2_trans
thf(fact_7753_list__all2__refl,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ! [X2: A] : ( P @ X2 @ X2 )
     => ( list_all2 @ A @ A @ P @ Xs @ Xs ) ) ).

% list_all2_refl
thf(fact_7754_list__all2__mono,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B,Q: A > B > $o] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
     => ( ! [Xs2: A,Ys4: B] :
            ( ( P @ Xs2 @ Ys4 )
           => ( Q @ Xs2 @ Ys4 ) )
       => ( list_all2 @ A @ B @ Q @ Xs @ Ys2 ) ) ) ).

% list_all2_mono
thf(fact_7755_list__all2__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z: list @ A] : ( Y3 = Z ) )
      = ( list_all2 @ A @ A
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) ) ).

% list_all2_eq
thf(fact_7756_list_Orel__refl,axiom,
    ! [B: $tType,Ra: B > B > $o,X: list @ B] :
      ( ! [X2: B] : ( Ra @ X2 @ X2 )
     => ( list_all2 @ B @ B @ Ra @ X @ X ) ) ).

% list.rel_refl
thf(fact_7757_list_Orel__eq,axiom,
    ! [A: $tType] :
      ( ( list_all2 @ A @ A
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) )
      = ( ^ [Y3: list @ A,Z: list @ A] : ( Y3 = Z ) ) ) ).

% list.rel_eq
thf(fact_7758_list__all2__lengthD,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) ) ) ).

% list_all2_lengthD
thf(fact_7759_list__all2__takeI,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B,N: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
     => ( list_all2 @ A @ B @ P @ ( take @ A @ N @ Xs ) @ ( take @ B @ N @ Ys2 ) ) ) ).

% list_all2_takeI
thf(fact_7760_list__all2__append2,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B,Zs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ Xs @ ( append @ B @ Ys2 @ Zs ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Us2 @ Vs3 ) )
            & ( ( size_size @ ( list @ A ) @ Us2 )
              = ( size_size @ ( list @ B ) @ Ys2 ) )
            & ( ( size_size @ ( list @ A ) @ Vs3 )
              = ( size_size @ ( list @ B ) @ Zs ) )
            & ( list_all2 @ A @ B @ P @ Us2 @ Ys2 )
            & ( list_all2 @ A @ B @ P @ Vs3 @ Zs ) ) ) ) ).

% list_all2_append2
thf(fact_7761_list__all2__append1,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ A,Zs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( append @ A @ Xs @ Ys2 ) @ Zs )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Zs
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( ( size_size @ ( list @ B ) @ Us2 )
              = ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( size_size @ ( list @ B ) @ Vs3 )
              = ( size_size @ ( list @ A ) @ Ys2 ) )
            & ( list_all2 @ A @ B @ P @ Xs @ Us2 )
            & ( list_all2 @ A @ B @ P @ Ys2 @ Vs3 ) ) ) ) ).

% list_all2_append1
thf(fact_7762_list__all2__append,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,P: A > B > $o,Us: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( list_all2 @ A @ B @ P @ ( append @ A @ Xs @ Us ) @ ( append @ B @ Ys2 @ Vs ) )
        = ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
          & ( list_all2 @ A @ B @ P @ Us @ Vs ) ) ) ) ).

% list_all2_append
thf(fact_7763_list__all2__dropI,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B,N: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
     => ( list_all2 @ A @ B @ P @ ( drop @ A @ N @ Xs ) @ ( drop @ B @ N @ Ys2 ) ) ) ).

% list_all2_dropI
thf(fact_7764_list__all2__rev1,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( rev @ A @ Xs ) @ Ys2 )
      = ( list_all2 @ A @ B @ P @ Xs @ ( rev @ B @ Ys2 ) ) ) ).

% list_all2_rev1
thf(fact_7765_list_Orel__sel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R6: A > B > $o,A3: list @ A,B3: list @ B] :
            ( ( ( A3
                = ( nil @ A ) )
              = ( B3
                = ( nil @ B ) ) )
            & ( ( A3
               != ( nil @ A ) )
             => ( ( B3
                 != ( nil @ B ) )
               => ( ( R6 @ ( hd @ A @ A3 ) @ ( hd @ B @ B3 ) )
                  & ( list_all2 @ A @ B @ R6 @ ( tl @ A @ A3 ) @ ( tl @ B @ B3 ) ) ) ) ) ) ) ) ).

% list.rel_sel
thf(fact_7766_list_Octr__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o] : ( list_all2 @ A @ B @ R4 @ ( nil @ A ) @ ( nil @ B ) ) ).

% list.ctr_transfer(1)
thf(fact_7767_list_Orel__distinct_I2_J,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,Y21: A,Y22: list @ A] :
      ~ ( list_all2 @ A @ B @ R4 @ ( cons @ A @ Y21 @ Y22 ) @ ( nil @ B ) ) ).

% list.rel_distinct(2)
thf(fact_7768_list_Orel__distinct_I1_J,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,Y21: B,Y22: list @ B] :
      ~ ( list_all2 @ A @ B @ R4 @ ( nil @ A ) @ ( cons @ B @ Y21 @ Y22 ) ) ).

% list.rel_distinct(1)
thf(fact_7769_list_Orel__cases,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,A2: list @ A,B2: list @ B] :
      ( ( list_all2 @ A @ B @ R4 @ A2 @ B2 )
     => ( ( ( A2
            = ( nil @ A ) )
         => ( B2
           != ( nil @ B ) ) )
       => ~ ! [X1: A,X24: list @ A] :
              ( ( A2
                = ( cons @ A @ X1 @ X24 ) )
             => ! [Y1: B,Y24: list @ B] :
                  ( ( B2
                    = ( cons @ B @ Y1 @ Y24 ) )
                 => ( ( R4 @ X1 @ Y1 )
                   => ~ ( list_all2 @ A @ B @ R4 @ X24 @ Y24 ) ) ) ) ) ) ).

% list.rel_cases
thf(fact_7770_list_Orel__induct,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,X: list @ A,Y: list @ B,Q: ( list @ A ) > ( list @ B ) > $o] :
      ( ( list_all2 @ A @ B @ R4 @ X @ Y )
     => ( ( Q @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [A21: A,A222: list @ A,B21: B,B222: list @ B] :
              ( ( R4 @ A21 @ B21 )
             => ( ( Q @ A222 @ B222 )
               => ( Q @ ( cons @ A @ A21 @ A222 ) @ ( cons @ B @ B21 @ B222 ) ) ) )
         => ( Q @ X @ Y ) ) ) ) ).

% list.rel_induct
thf(fact_7771_list__all2__induct,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys2: list @ B,R4: ( list @ A ) > ( list @ B ) > $o] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys2 )
     => ( ( R4 @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X2: A,Xs2: list @ A,Y2: B,Ys4: list @ B] :
              ( ( P @ X2 @ Y2 )
             => ( ( list_all2 @ A @ B @ P @ Xs2 @ Ys4 )
               => ( ( R4 @ Xs2 @ Ys4 )
                 => ( R4 @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) ) ) ) )
         => ( R4 @ Xs @ Ys2 ) ) ) ) ).

% list_all2_induct
thf(fact_7772_list_Odisc__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R4 )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
      @ ^ [List2: list @ A] :
          ( List2
         != ( nil @ A ) )
      @ ^ [List2: list @ B] :
          ( List2
         != ( nil @ B ) ) ) ).

% list.disc_transfer(2)
thf(fact_7773_list_Odisc__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R4 )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
      @ ^ [List2: list @ A] :
          ( List2
          = ( nil @ A ) )
      @ ^ [List2: list @ B] :
          ( List2
          = ( nil @ B ) ) ) ).

% list.disc_transfer(1)
thf(fact_7774_list_Ocase__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S2: C > D > $o,R4: A > B > $o] : ( bNF_rel_fun @ C @ D @ ( ( A > ( list @ A ) > C ) > ( list @ A ) > C ) @ ( ( B > ( list @ B ) > D ) > ( list @ B ) > D ) @ S2 @ ( bNF_rel_fun @ ( A > ( list @ A ) > C ) @ ( B > ( list @ B ) > D ) @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ R4 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R4 ) @ S2 ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R4 ) @ S2 ) ) @ ( case_list @ C @ A ) @ ( case_list @ D @ B ) ) ).

% list.case_transfer
thf(fact_7775_append__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( append @ A ) @ ( append @ B ) ) ).

% append_transfer
thf(fact_7776_list__update__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( nat > A > ( list @ A ) ) @ ( nat > B > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 )
      @ ( bNF_rel_fun @ nat @ nat @ ( A > ( list @ A ) ) @ ( B > ( list @ B ) )
        @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
        @ ( bNF_rel_fun @ A @ B @ ( list @ A ) @ ( list @ B ) @ A5 @ ( list_all2 @ A @ B @ A5 ) ) )
      @ ( list_update @ A )
      @ ( list_update @ B ) ) ).

% list_update_transfer
thf(fact_7777_replicate__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( A > ( list @ A ) ) @ ( B > ( list @ B ) )
      @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
      @ ( bNF_rel_fun @ A @ B @ ( list @ A ) @ ( list @ B ) @ A5 @ ( list_all2 @ A @ B @ A5 ) )
      @ ( replicate @ A )
      @ ( replicate @ B ) ) ).

% replicate_transfer
thf(fact_7778_subseqs__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( subseqs @ A ) @ ( subseqs @ B ) ) ).

% subseqs_transfer
thf(fact_7779_product__lists__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( product_lists @ A ) @ ( product_lists @ B ) ) ).

% product_lists_transfer
thf(fact_7780_rotate1__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( rotate1 @ A ) @ ( rotate1 @ B ) ) ).

% rotate1_transfer
thf(fact_7781_list_Orel__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: A > C > $o,Sc: B > D > $o] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( list @ A ) > ( list @ B ) > $o ) @ ( ( list @ C ) > ( list @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( ( list @ B ) > $o ) @ ( ( list @ D ) > $o ) @ ( list_all2 @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( list @ B ) @ ( list @ D ) @ $o @ $o @ ( list_all2 @ B @ D @ Sc )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( list_all2 @ A @ B )
      @ ( list_all2 @ C @ D ) ) ).

% list.rel_transfer
thf(fact_7782_splice__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( splice @ A ) @ ( splice @ B ) ) ).

% splice_transfer
thf(fact_7783_rotate__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( rotate @ A )
      @ ( rotate @ B ) ) ).

% rotate_transfer
thf(fact_7784_length__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ nat @ nat @ ( list_all2 @ A @ B @ A5 )
      @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
      @ ( size_size @ ( list @ A ) )
      @ ( size_size @ ( list @ B ) ) ) ).

% length_transfer
thf(fact_7785_take__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( take @ A )
      @ ( take @ B ) ) ).

% take_transfer
thf(fact_7786_drop__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y3: nat,Z: nat] : ( Y3 = Z )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( drop @ A )
      @ ( drop @ B ) ) ).

% drop_transfer
thf(fact_7787_tl__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( tl @ A ) @ ( tl @ B ) ) ).

% tl_transfer
thf(fact_7788_concat__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( concat @ A ) @ ( concat @ B ) ) ).

% concat_transfer
thf(fact_7789_rev__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( rev @ A ) @ ( rev @ B ) ) ).

% rev_transfer
thf(fact_7790_dropWhile__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( dropWhile @ A )
      @ ( dropWhile @ B ) ) ).

% dropWhile_transfer
thf(fact_7791_butlast__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( butlast @ A ) @ ( butlast @ B ) ) ).

% butlast_transfer
thf(fact_7792_foldr__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A5: A > C > $o,B6: B > D > $o] : ( bNF_rel_fun @ ( A > B > B ) @ ( C > D > D ) @ ( ( list @ A ) > B > B ) @ ( ( list @ C ) > D > D ) @ ( bNF_rel_fun @ A @ C @ ( B > B ) @ ( D > D ) @ A5 @ ( bNF_rel_fun @ B @ D @ B @ D @ B6 @ B6 ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( B > B ) @ ( D > D ) @ ( list_all2 @ A @ C @ A5 ) @ ( bNF_rel_fun @ B @ D @ B @ D @ B6 @ B6 ) ) @ ( foldr @ A @ B ) @ ( foldr @ C @ D ) ) ).

% foldr_transfer
thf(fact_7793_list_Orel__mono,axiom,
    ! [B: $tType,A: $tType,R4: A > B > $o,Ra: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R4 @ Ra )
     => ( ord_less_eq @ ( ( list @ A ) > ( list @ B ) > $o ) @ ( list_all2 @ A @ B @ R4 ) @ ( list_all2 @ A @ B @ Ra ) ) ) ).

% list.rel_mono
thf(fact_7794_list_Orec__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S2: C > D > $o,R4: A > B > $o] : ( bNF_rel_fun @ C @ D @ ( ( A > ( list @ A ) > C > C ) > ( list @ A ) > C ) @ ( ( B > ( list @ B ) > D > D ) > ( list @ B ) > D ) @ S2 @ ( bNF_rel_fun @ ( A > ( list @ A ) > C > C ) @ ( B > ( list @ B ) > D > D ) @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > C > C ) @ ( ( list @ B ) > D > D ) @ R4 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( C > C ) @ ( D > D ) @ ( list_all2 @ A @ B @ R4 ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S2 @ S2 ) ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R4 ) @ S2 ) ) @ ( rec_list @ C @ A ) @ ( rec_list @ D @ B ) ) ).

% list.rec_transfer
thf(fact_7795_list_Octr__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o] : ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ R4 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R4 ) @ ( list_all2 @ A @ B @ R4 ) ) @ ( cons @ A ) @ ( cons @ B ) ) ).

% list.ctr_transfer(2)
thf(fact_7796_takeWhile__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( takeWhile @ A )
      @ ( takeWhile @ B ) ) ).

% takeWhile_transfer
thf(fact_7797_List_Ofilter__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( filter2 @ A )
      @ ( filter2 @ B ) ) ).

% List.filter_transfer
thf(fact_7798_list_Omap__transfer,axiom,
    ! [A: $tType,B: $tType,F: $tType,E4: $tType,Rb: A > E4 > $o,Sd: B > F > $o] : ( bNF_rel_fun @ ( A > B ) @ ( E4 > F ) @ ( ( list @ A ) > ( list @ B ) ) @ ( ( list @ E4 ) > ( list @ F ) ) @ ( bNF_rel_fun @ A @ E4 @ B @ F @ Rb @ Sd ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ E4 ) @ ( list @ B ) @ ( list @ F ) @ ( list_all2 @ A @ E4 @ Rb ) @ ( list_all2 @ B @ F @ Sd ) ) @ ( map @ A @ B ) @ ( map @ E4 @ F ) ) ).

% list.map_transfer
thf(fact_7799_product__lists__set,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) )
      = ( collect @ ( list @ A )
        @ ^ [Xs3: list @ A] :
            ( list_all2 @ A @ ( list @ A )
            @ ^ [X3: A,Ys3: list @ A] : ( member @ A @ X3 @ ( set2 @ A @ Ys3 ) )
            @ Xs3
            @ Xss ) ) ) ).

% product_lists_set
thf(fact_7800_coprime__diff__one__left__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ N ) ) ).

% coprime_diff_one_left_nat
thf(fact_7801_coprime__diff__one__right__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% coprime_diff_one_right_nat
thf(fact_7802_list__all2I,axiom,
    ! [A: $tType,B: $tType,A2: list @ A,B2: list @ B,P: A > B > $o] :
      ( ! [X2: product_prod @ A @ B] :
          ( ( member @ ( product_prod @ A @ B ) @ X2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ A2 @ B2 ) ) )
         => ( product_case_prod @ A @ B @ $o @ P @ X2 ) )
     => ( ( ( size_size @ ( list @ A ) @ A2 )
          = ( size_size @ ( list @ B ) @ B2 ) )
       => ( list_all2 @ A @ B @ P @ A2 @ B2 ) ) ) ).

% list_all2I
thf(fact_7803_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( monoid_add @ A ) )
     => ! [A5: A > B > $o] :
          ( ( A5 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A5 ) @ A5 @ ( groups8242544230860333062m_list @ A ) @ ( groups8242544230860333062m_list @ B ) ) ) ) ) ).

% sum_list_transfer
thf(fact_7804_Rats__abs__nat__div__natE,axiom,
    ! [X: real] :
      ( ( member @ real @ X @ ( field_char_0_Rats @ real ) )
     => ~ ! [M4: nat,N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( ( abs_abs @ real @ X )
                = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ M4 ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
             => ~ ( algebr8660921524188924756oprime @ nat @ M4 @ N2 ) ) ) ) ).

% Rats_abs_nat_div_natE
thf(fact_7805_list__all2__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P3: A > B > $o,Xs3: list @ A,Ys3: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ B ) @ Ys3 ) )
            & ! [X3: product_prod @ A @ B] :
                ( ( member @ ( product_prod @ A @ B ) @ X3 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs3 @ Ys3 ) ) )
               => ( product_case_prod @ A @ B @ $o @ P3 @ X3 ) ) ) ) ) ).

% list_all2_iff
thf(fact_7806_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( ( comm_semiring_0 @ B )
        & ( comm_semiring_0 @ A ) )
     => ! [A5: A > B > $o,B6: C > D > $o] :
          ( ( A5 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( times_times @ A ) @ ( times_times @ B ) )
             => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( A > ( list @ C ) > A ) @ ( B > ( list @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ A @ B @ B6 @ A5 ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ C ) > A ) @ ( ( list @ D ) > B ) @ A5 @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ A @ B @ ( list_all2 @ C @ D @ B6 ) @ A5 ) ) @ ( groups4207007520872428315er_sum @ C @ A ) @ ( groups4207007520872428315er_sum @ D @ B ) ) ) ) ) ) ).

% horner_sum_transfer
thf(fact_7807_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) )
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) ) ) ).

% inverse_rat.rsp
thf(fact_7808_Rat_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o @ ratrel
    @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
    @ ^ [X3: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) )
    @ ^ [X3: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ).

% Rat.positive.rsp
thf(fact_7809_ratrel__iff,axiom,
    ( ratrel
    = ( ^ [X3: product_prod @ int @ int,Y4: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X3 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y4 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y4 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ) ) ).

% ratrel_iff
thf(fact_7810_zero__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ).

% zero_rat.rsp
thf(fact_7811_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y3: int,Z: int] : ( Y3 = Z )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y3: int,Z: int] : ( Y3 = Z )
      @ ratrel )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) ) ) ).

% Fract.rsp
thf(fact_7812_ratrel__def,axiom,
    ( ratrel
    = ( ^ [X3: product_prod @ int @ int,Y4: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X3 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y4 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y4 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ) ) ).

% ratrel_def
thf(fact_7813_foldl__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,B6: A > C > $o,A5: B > D > $o] : ( bNF_rel_fun @ ( A > B > A ) @ ( C > D > C ) @ ( A > ( list @ B ) > A ) @ ( C > ( list @ D ) > C ) @ ( bNF_rel_fun @ A @ C @ ( B > A ) @ ( D > C ) @ B6 @ ( bNF_rel_fun @ B @ D @ A @ C @ A5 @ B6 ) ) @ ( bNF_rel_fun @ A @ C @ ( ( list @ B ) > A ) @ ( ( list @ D ) > C ) @ B6 @ ( bNF_rel_fun @ ( list @ B ) @ ( list @ D ) @ A @ C @ ( list_all2 @ B @ D @ A5 ) @ B6 ) ) @ ( foldl @ A @ B ) @ ( foldl @ C @ D ) ) ).

% foldl_transfer
thf(fact_7814_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( inverse_inverse @ rat @ ( abs_Rat @ X ) )
        = ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_fst @ int @ int @ X )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ) ) ).

% inverse_rat.abs_eq
thf(fact_7815_foldl__append,axiom,
    ! [A: $tType,B: $tType,F2: A > B > A,A2: A,Xs: list @ B,Ys2: list @ B] :
      ( ( foldl @ A @ B @ F2 @ A2 @ ( append @ B @ Xs @ Ys2 ) )
      = ( foldl @ A @ B @ F2 @ ( foldl @ A @ B @ F2 @ A2 @ Xs ) @ Ys2 ) ) ).

% foldl_append
thf(fact_7816_foldl__map,axiom,
    ! [A: $tType,B: $tType,C: $tType,G2: A > B > A,A2: A,F2: C > B,Xs: list @ C] :
      ( ( foldl @ A @ B @ G2 @ A2 @ ( map @ C @ B @ F2 @ Xs ) )
      = ( foldl @ A @ C
        @ ^ [A3: A,X3: C] : ( G2 @ A3 @ ( F2 @ X3 ) )
        @ A2
        @ Xs ) ) ).

% foldl_map
thf(fact_7817_foldl__cong,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: A,L: list @ B,K: list @ B,F2: A > B > A,G2: A > B > A] :
      ( ( A2 = B2 )
     => ( ( L = K )
       => ( ! [A4: A,X2: B] :
              ( ( member @ B @ X2 @ ( set2 @ B @ L ) )
             => ( ( F2 @ A4 @ X2 )
                = ( G2 @ A4 @ X2 ) ) )
         => ( ( foldl @ A @ B @ F2 @ A2 @ L )
            = ( foldl @ A @ B @ G2 @ B2 @ K ) ) ) ) ) ).

% foldl_cong
thf(fact_7818_foldl__Cons,axiom,
    ! [B: $tType,A: $tType,F2: B > A > B,A2: B,X: A,Xs: list @ A] :
      ( ( foldl @ B @ A @ F2 @ A2 @ ( cons @ A @ X @ Xs ) )
      = ( foldl @ B @ A @ F2 @ ( F2 @ A2 @ X ) @ Xs ) ) ).

% foldl_Cons
thf(fact_7819_foldl__Nil,axiom,
    ! [A: $tType,B: $tType,F2: B > A > B,A2: B] :
      ( ( foldl @ B @ A @ F2 @ A2 @ ( nil @ A ) )
      = A2 ) ).

% foldl_Nil
thf(fact_7820_foldl__conv__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F3: A > B > A,S6: A,Xs3: list @ B] :
            ( fold @ B @ A
            @ ^ [X3: B,T4: A] : ( F3 @ T4 @ X3 )
            @ Xs3
            @ S6 ) ) ) ).

% foldl_conv_fold
thf(fact_7821_foldl__conv__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F3: A > B > A,A3: A,Xs3: list @ B] :
            ( foldr @ B @ A
            @ ^ [X3: B,Y4: A] : ( F3 @ Y4 @ X3 )
            @ ( rev @ B @ Xs3 )
            @ A3 ) ) ) ).

% foldl_conv_foldr
thf(fact_7822_foldr__conv__foldl,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldr @ B @ A )
      = ( ^ [F3: B > A > A,Xs3: list @ B,A3: A] :
            ( foldl @ A @ B
            @ ^ [X3: A,Y4: B] : ( F3 @ Y4 @ X3 )
            @ A3
            @ ( rev @ B @ Xs3 ) ) ) ) ).

% foldr_conv_foldl
thf(fact_7823_Fract_Oabs__eq,axiom,
    ( fract
    = ( ^ [Xa4: int,X3: int] :
          ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( X3
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ Xa4 @ X3 ) ) ) ) ) ).

% Fract.abs_eq
thf(fact_7824_zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ) ).

% zero_rat_def
thf(fact_7825_Rat_Opositive_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( positive @ ( abs_Rat @ X ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ).

% Rat.positive.abs_eq
thf(fact_7826_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X3: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X3 )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) ) ) ) ).

% inverse_rat_def
thf(fact_7827_subset__range__from__nat__into,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( countable_countable @ A @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( image @ nat @ A @ ( counta4804993851260445106t_into @ A @ A5 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% subset_range_from_nat_into
thf(fact_7828_range__from__nat__into__subset,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( A5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ ( counta4804993851260445106t_into @ A @ A5 ) @ ( top_top @ ( set @ nat ) ) ) @ A5 ) ) ).

% range_from_nat_into_subset
thf(fact_7829_null__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ A5 )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
      @ ( null @ A )
      @ ( null @ B ) ) ).

% null_transfer
thf(fact_7830_Bseq__monoseq__convergent_H__inc,axiom,
    ! [F2: nat > real,M5: nat] :
      ( ( bfun @ nat @ real
        @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ M5 ) )
        @ ( at_top @ nat ) )
     => ( ! [M4: nat,N2: nat] :
            ( ( ord_less_eq @ nat @ M5 @ M4 )
           => ( ( ord_less_eq @ nat @ M4 @ N2 )
             => ( ord_less_eq @ real @ ( F2 @ M4 ) @ ( F2 @ N2 ) ) ) )
       => ( topolo6863149650580417670ergent @ real @ F2 ) ) ) ).

% Bseq_monoseq_convergent'_inc
thf(fact_7831_lim__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,X: A] :
          ( ( topolo6863149650580417670ergent @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ X )
           => ( ord_less_eq @ A @ ( topolo3827282254853284352ce_Lim @ nat @ A @ ( at_top @ nat ) @ F2 ) @ X ) ) ) ) ).

% lim_le
thf(fact_7832_null__rec_I1_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ~ ( null @ A @ ( cons @ A @ X @ Xs ) ) ).

% null_rec(1)
thf(fact_7833_convergent__mult__const__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( topolo6863149650580417670ergent @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ C2 ) )
            = ( topolo6863149650580417670ergent @ A @ F2 ) ) ) ) ).

% convergent_mult_const_right_iff
thf(fact_7834_convergent__mult__const__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( topolo6863149650580417670ergent @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
            = ( topolo6863149650580417670ergent @ A @ F2 ) ) ) ) ).

% convergent_mult_const_iff
thf(fact_7835_eq__Nil__null,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
      = ( null @ A @ Xs ) ) ).

% eq_Nil_null
thf(fact_7836_null__rec_I2_J,axiom,
    ! [B: $tType] : ( null @ B @ ( nil @ B ) ) ).

% null_rec(2)
thf(fact_7837_Bseq__mono__convergent,axiom,
    ! [X8: nat > real] :
      ( ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) )
     => ( ! [M4: nat,N2: nat] :
            ( ( ord_less_eq @ nat @ M4 @ N2 )
           => ( ord_less_eq @ real @ ( X8 @ M4 ) @ ( X8 @ N2 ) ) )
       => ( topolo6863149650580417670ergent @ real @ X8 ) ) ) ).

% Bseq_mono_convergent
thf(fact_7838_convergent__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topolo6863149650580417670ergent @ real @ ( power_power @ real @ X ) ) ) ) ).

% convergent_realpow
thf(fact_7839_Bseq__monoseq__convergent_H__dec,axiom,
    ! [F2: nat > real,M5: nat] :
      ( ( bfun @ nat @ real
        @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ M5 ) )
        @ ( at_top @ nat ) )
     => ( ! [M4: nat,N2: nat] :
            ( ( ord_less_eq @ nat @ M5 @ M4 )
           => ( ( ord_less_eq @ nat @ M4 @ N2 )
             => ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( F2 @ M4 ) ) ) )
       => ( topolo6863149650580417670ergent @ real @ F2 ) ) ) ).

% Bseq_monoseq_convergent'_dec
thf(fact_7840_is__empty__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( is_empty @ A @ ( set2 @ A @ Xs ) )
      = ( null @ A @ Xs ) ) ).

% is_empty_set
thf(fact_7841_pair__lessI2,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ B2 )
     => ( ( ord_less @ nat @ S @ T2 )
       => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_less ) ) ) ).

% pair_lessI2
thf(fact_7842_pair__less__iff1,axiom,
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ Y ) @ ( product_Pair @ nat @ nat @ X @ Z2 ) ) @ fun_pair_less )
      = ( ord_less @ nat @ Y @ Z2 ) ) ).

% pair_less_iff1
thf(fact_7843_pair__lessI1,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_less ) ) ).

% pair_lessI1
thf(fact_7844_pair__leqI2,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ S @ T2 )
       => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_leq ) ) ) ).

% pair_leqI2
thf(fact_7845_pair__leqI1,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_leq ) ) ).

% pair_leqI1
thf(fact_7846_wmin__insertI,axiom,
    ! [X: product_prod @ nat @ nat,XS2: set @ ( product_prod @ nat @ nat ),Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ X @ XS2 )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_leq )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS2 @ YS ) @ fun_min_weak )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS2 @ ( insert2 @ ( product_prod @ nat @ nat ) @ Y @ YS ) ) @ fun_min_weak ) ) ) ) ).

% wmin_insertI
thf(fact_7847_wmax__insertI,axiom,
    ! [Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat ),X: product_prod @ nat @ nat,XS2: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ Y @ YS )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_leq )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS2 @ YS ) @ fun_max_weak )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( insert2 @ ( product_prod @ nat @ nat ) @ X @ XS2 ) @ YS ) @ fun_max_weak ) ) ) ) ).

% wmax_insertI
thf(fact_7848_wmin__emptyI,axiom,
    ! [X8: set @ ( product_prod @ nat @ nat )] : ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X8 @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_weak ) ).

% wmin_emptyI
thf(fact_7849_wmax__emptyI,axiom,
    ! [X8: set @ ( product_prod @ nat @ nat )] :
      ( ( finite_finite @ ( product_prod @ nat @ nat ) @ X8 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ X8 ) @ fun_max_weak ) ) ).

% wmax_emptyI
thf(fact_7850_max__weak__def,axiom,
    ( fun_max_weak
    = ( sup_sup @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( max_ext @ ( product_prod @ nat @ nat ) @ fun_pair_leq ) @ ( insert2 @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) ) ) ) ) ).

% max_weak_def
thf(fact_7851_min__weak__def,axiom,
    ( fun_min_weak
    = ( sup_sup @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( min_ext @ ( product_prod @ nat @ nat ) @ fun_pair_leq ) @ ( insert2 @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) ) ) ) ) ).

% min_weak_def
thf(fact_7852_smin__insertI,axiom,
    ! [X: product_prod @ nat @ nat,XS2: set @ ( product_prod @ nat @ nat ),Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ X @ XS2 )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_less )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS2 @ YS ) @ fun_min_strict )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS2 @ ( insert2 @ ( product_prod @ nat @ nat ) @ Y @ YS ) ) @ fun_min_strict ) ) ) ) ).

% smin_insertI
thf(fact_7853_smax__insertI,axiom,
    ! [Y: product_prod @ nat @ nat,Y6: set @ ( product_prod @ nat @ nat ),X: product_prod @ nat @ nat,X8: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ Y @ Y6 )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_less )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X8 @ Y6 ) @ fun_max_strict )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( insert2 @ ( product_prod @ nat @ nat ) @ X @ X8 ) @ Y6 ) @ fun_max_strict ) ) ) ) ).

% smax_insertI
thf(fact_7854_smax__emptyI,axiom,
    ! [Y6: set @ ( product_prod @ nat @ nat )] :
      ( ( finite_finite @ ( product_prod @ nat @ nat ) @ Y6 )
     => ( ( Y6
         != ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ Y6 ) @ fun_max_strict ) ) ) ).

% smax_emptyI
thf(fact_7855_smin__emptyI,axiom,
    ! [X8: set @ ( product_prod @ nat @ nat )] :
      ( ( X8
       != ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X8 @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_strict ) ) ).

% smin_emptyI
thf(fact_7856_max__strict__def,axiom,
    ( fun_max_strict
    = ( max_ext @ ( product_prod @ nat @ nat ) @ fun_pair_less ) ) ).

% max_strict_def
thf(fact_7857_min__strict__def,axiom,
    ( fun_min_strict
    = ( min_ext @ ( product_prod @ nat @ nat ) @ fun_pair_less ) ) ).

% min_strict_def
thf(fact_7858_max__rpair__set,axiom,
    fun_reduction_pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_max_strict @ fun_max_weak ) ).

% max_rpair_set
thf(fact_7859_min__rpair__set,axiom,
    fun_reduction_pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_strict @ fun_min_weak ) ).

% min_rpair_set
thf(fact_7860_rp__inv__image__rp,axiom,
    ! [A: $tType,B: $tType,P: product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ),F2: B > A] :
      ( ( fun_reduction_pair @ A @ P )
     => ( fun_reduction_pair @ B @ ( fun_rp_inv_image @ A @ B @ P @ F2 ) ) ) ).

% rp_inv_image_rp
thf(fact_7861_cauchy__filter__metric__filtermap,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V768167426530841204y_dist @ B )
        & ( topolo7287701948861334536_space @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( topolo6773858410816713723filter @ B @ ( filtermap @ A @ B @ F2 @ F4 ) )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ? [P3: A > $o] :
                    ( ( eventually @ A @ P3 @ F4 )
                    & ! [X3: A,Y4: A] :
                        ( ( ( P3 @ X3 )
                          & ( P3 @ Y4 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric_filtermap
thf(fact_7862_filtermap__mono__strong,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F4: filter @ A,G5: filter @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( filter @ B ) @ ( filtermap @ A @ B @ F2 @ F4 ) @ ( filtermap @ A @ B @ F2 @ G5 ) )
        = ( ord_less_eq @ ( filter @ A ) @ F4 @ G5 ) ) ) ).

% filtermap_mono_strong
thf(fact_7863_filterlim__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( filterlim @ A @ B )
      = ( ^ [F3: A > B,F26: filter @ B,F18: filter @ A] : ( ord_less_eq @ ( filter @ B ) @ ( filtermap @ A @ B @ F3 @ F18 ) @ F26 ) ) ) ).

% filterlim_def
thf(fact_7864_filtermap__mono,axiom,
    ! [B: $tType,A: $tType,F4: filter @ A,F11: filter @ A,F2: A > B] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 )
     => ( ord_less_eq @ ( filter @ B ) @ ( filtermap @ A @ B @ F2 @ F4 ) @ ( filtermap @ A @ B @ F2 @ F11 ) ) ) ).

% filtermap_mono
thf(fact_7865_filtermap__inf,axiom,
    ! [A: $tType,B: $tType,F2: B > A,F1: filter @ B,F22: filter @ B] : ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F2 @ ( inf_inf @ ( filter @ B ) @ F1 @ F22 ) ) @ ( inf_inf @ ( filter @ A ) @ ( filtermap @ B @ A @ F2 @ F1 ) @ ( filtermap @ B @ A @ F2 @ F22 ) ) ) ).

% filtermap_inf
thf(fact_7866_filtermap__nhds__times,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filtermap @ A @ A @ ( times_times @ A @ C2 ) @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
            = ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ A2 ) ) ) ) ) ).

% filtermap_nhds_times
thf(fact_7867_filtermap__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,F4: C > ( filter @ B ),B6: set @ C] :
      ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F2 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ C @ ( filter @ B ) @ F4 @ B6 ) ) )
      @ ( complete_Inf_Inf @ ( filter @ A )
        @ ( image @ C @ ( filter @ A )
          @ ^ [B3: C] : ( filtermap @ B @ A @ F2 @ ( F4 @ B3 ) )
          @ B6 ) ) ) ).

% filtermap_INF
thf(fact_7868_at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A] :
          ( ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          = ( filtermap @ A @ A
            @ ^ [X3: A] : ( plus_plus @ A @ X3 @ A2 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% at_to_0
thf(fact_7869_at__right__to__0,axiom,
    ! [A2: real] :
      ( ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) )
      = ( filtermap @ real @ real
        @ ^ [X3: real] : ( plus_plus @ real @ X3 @ A2 )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% at_right_to_0
thf(fact_7870_filterlim__INF__INF,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,J4: set @ A,I6: set @ B,F2: D > C,F4: B > ( filter @ D ),G5: A > ( filter @ C )] :
      ( ! [M4: A] :
          ( ( member @ A @ M4 @ J4 )
         => ? [X5: B] :
              ( ( member @ B @ X5 @ I6 )
              & ( ord_less_eq @ ( filter @ C ) @ ( filtermap @ D @ C @ F2 @ ( F4 @ X5 ) ) @ ( G5 @ M4 ) ) ) )
     => ( filterlim @ D @ C @ F2 @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image @ A @ ( filter @ C ) @ G5 @ J4 ) ) @ ( complete_Inf_Inf @ ( filter @ D ) @ ( image @ B @ ( filter @ D ) @ F4 @ I6 ) ) ) ) ).

% filterlim_INF_INF
thf(fact_7871_filtermap__times__pos__at__right,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [C2: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( filtermap @ A @ A @ ( times_times @ A @ C2 ) @ ( topolo174197925503356063within @ A @ P6 @ ( set_ord_greaterThan @ A @ P6 ) ) )
            = ( topolo174197925503356063within @ A @ ( times_times @ A @ C2 @ P6 ) @ ( set_ord_greaterThan @ A @ ( times_times @ A @ C2 @ P6 ) ) ) ) ) ) ).

% filtermap_times_pos_at_right
thf(fact_7872_at__to__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) )
        = ( filtermap @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) ) ) ) ).

% at_to_infinity
thf(fact_7873_at__right__to__top,axiom,
    ( ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) )
    = ( filtermap @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) ) ) ).

% at_right_to_top
thf(fact_7874_at__top__to__right,axiom,
    ( ( at_top @ real )
    = ( filtermap @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% at_top_to_right
thf(fact_7875_filtermap__ln__at__right,axiom,
    ( ( filtermap @ real @ real @ ( ln_ln @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
    = ( at_bot @ real ) ) ).

% filtermap_ln_at_right
thf(fact_7876_rp__inv__image__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fun_rp_inv_image @ A @ B )
      = ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) )
        @ ^ [R6: set @ ( product_prod @ A @ A ),S5: set @ ( product_prod @ A @ A ),F3: B > A] : ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( inv_image @ A @ B @ R6 @ F3 ) @ ( inv_image @ A @ B @ S5 @ F3 ) ) ) ) ).

% rp_inv_image_def
thf(fact_7877_distinct__adj__append__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( distinct_adj @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( ( distinct_adj @ A @ Xs )
        & ( distinct_adj @ A @ Ys2 )
        & ( ( Xs
            = ( nil @ A ) )
          | ( Ys2
            = ( nil @ A ) )
          | ( ( last @ A @ Xs )
           != ( hd @ A @ Ys2 ) ) ) ) ) ).

% distinct_adj_append_iff
thf(fact_7878_distinct__adj__Cons__Cons,axiom,
    ! [B: $tType,X: B,Y: B,Xs: list @ B] :
      ( ( distinct_adj @ B @ ( cons @ B @ X @ ( cons @ B @ Y @ Xs ) ) )
      = ( ( X != Y )
        & ( distinct_adj @ B @ ( cons @ B @ Y @ Xs ) ) ) ) ).

% distinct_adj_Cons_Cons
thf(fact_7879_distinct__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct_adj @ A @ ( rev @ A @ Xs ) )
      = ( distinct_adj @ A @ Xs ) ) ).

% distinct_adj_rev
thf(fact_7880_distinct__adj__singleton,axiom,
    ! [B: $tType,X: B] : ( distinct_adj @ B @ ( cons @ B @ X @ ( nil @ B ) ) ) ).

% distinct_adj_singleton
thf(fact_7881_distinct__adj__Nil,axiom,
    ! [A: $tType] : ( distinct_adj @ A @ ( nil @ A ) ) ).

% distinct_adj_Nil
thf(fact_7882_distinct__adj__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct_adj @ A @ ( remdups_adj @ A @ Xs ) ) ).

% distinct_adj_remdups_adj
thf(fact_7883_distinct__adj__altdef,axiom,
    ! [A: $tType] :
      ( ( distinct_adj @ A )
      = ( ^ [Xs3: list @ A] :
            ( ( remdups_adj @ A @ Xs3 )
            = Xs3 ) ) ) ).

% distinct_adj_altdef
thf(fact_7884_distinct__adj__appendD1,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( distinct_adj @ A @ ( append @ A @ Xs @ Ys2 ) )
     => ( distinct_adj @ A @ Xs ) ) ).

% distinct_adj_appendD1
thf(fact_7885_distinct__adj__appendD2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( distinct_adj @ A @ ( append @ A @ Xs @ Ys2 ) )
     => ( distinct_adj @ A @ Ys2 ) ) ).

% distinct_adj_appendD2
thf(fact_7886_distinct__adj__ConsD,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct_adj @ A @ ( cons @ A @ X @ Xs ) )
     => ( distinct_adj @ A @ Xs ) ) ).

% distinct_adj_ConsD
thf(fact_7887_distinct__adj__mapD,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( distinct_adj @ A @ ( map @ B @ A @ F2 @ Xs ) )
     => ( distinct_adj @ B @ Xs ) ) ).

% distinct_adj_mapD
thf(fact_7888_distinct__adj__mapI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( distinct_adj @ A @ Xs )
     => ( ( inj_on @ A @ B @ F2 @ ( set2 @ A @ Xs ) )
       => ( distinct_adj @ B @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% distinct_adj_mapI
thf(fact_7889_distinct__adj__map__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( set2 @ A @ Xs ) )
     => ( ( distinct_adj @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( distinct_adj @ A @ Xs ) ) ) ).

% distinct_adj_map_iff
thf(fact_7890_distinct__adj__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( ( X
           != ( hd @ A @ Xs ) )
          & ( distinct_adj @ A @ Xs ) ) ) ) ).

% distinct_adj_Cons
thf(fact_7891_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L ) @ N )
      = ( ( ( ord_less @ nat @ N @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) )
        | ( ( ord_less_eq @ nat @ M @ N )
          & ( bit_se5641148757651400278ts_bit @ int @ L @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_7892_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ( ordering_top @ A
        @ ^ [X3: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X3 )
        @ ^ [X3: A,Y4: A] : ( ord_less @ A @ Y4 @ X3 )
        @ ( bot_bot @ A ) ) ) ).

% bot.ordering_top_axioms
thf(fact_7893_concat__bit__0,axiom,
    ! [K: int,L: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L )
      = L ) ).

% concat_bit_0
thf(fact_7894_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N @ K @ L ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ).

% concat_bit_nonnegative_iff
thf(fact_7895_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N @ K @ L ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_7896_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] :
      ( ( bit_concat_bit @ N @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_7897_concat__bit__of__zero__1,axiom,
    ! [N: nat,L: int] :
      ( ( bit_concat_bit @ N @ ( zero_zero @ int ) @ L )
      = ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ).

% concat_bit_of_zero_1
thf(fact_7898_ordering__top_Oextremum__uniqueI,axiom,
    ! [A: $tType,Less_eq2: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq2 @ Less @ Top )
     => ( ( Less_eq2 @ Top @ A2 )
       => ( A2 = Top ) ) ) ).

% ordering_top.extremum_uniqueI
thf(fact_7899_ordering__top_Onot__eq__extremum,axiom,
    ! [A: $tType,Less_eq2: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq2 @ Less @ Top )
     => ( ( ( A2 != Top ) )
        = ( Less @ A2 @ Top ) ) ) ).

% ordering_top.not_eq_extremum
thf(fact_7900_ordering__top_Oextremum__unique,axiom,
    ! [A: $tType,Less_eq2: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq2 @ Less @ Top )
     => ( ( Less_eq2 @ Top @ A2 )
        = ( A2 = Top ) ) ) ).

% ordering_top.extremum_unique
thf(fact_7901_ordering__top_Oextremum__strict,axiom,
    ! [A: $tType,Less_eq2: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq2 @ Less @ Top )
     => ~ ( Less @ Top @ A2 ) ) ).

% ordering_top.extremum_strict
thf(fact_7902_ordering__top_Oextremum,axiom,
    ! [A: $tType,Less_eq2: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq2 @ Less @ Top )
     => ( Less_eq2 @ A2 @ Top ) ) ).

% ordering_top.extremum
thf(fact_7903_gcd__nat_Oordering__top__axioms,axiom,
    ( ordering_top @ nat @ ( dvd_dvd @ nat )
    @ ^ [M2: nat,N3: nat] :
        ( ( dvd_dvd @ nat @ M2 @ N3 )
        & ( M2 != N3 ) )
    @ ( zero_zero @ nat ) ) ).

% gcd_nat.ordering_top_axioms
thf(fact_7904_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ( ordering_top @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ A ) ) ) ).

% top.ordering_top_axioms
thf(fact_7905_bot__nat__0_Oordering__top__axioms,axiom,
    ( ordering_top @ nat
    @ ^ [X3: nat,Y4: nat] : ( ord_less_eq @ nat @ Y4 @ X3 )
    @ ^ [X3: nat,Y4: nat] : ( ord_less @ nat @ Y4 @ X3 )
    @ ( zero_zero @ nat ) ) ).

% bot_nat_0.ordering_top_axioms
thf(fact_7906_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ~ ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ B2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ) ).

% euclidean_size_times_nonunit
thf(fact_7907_sorted__wrt__iff__nth__Suc__transp,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( transp @ A @ P )
     => ( ( sorted_wrt @ A @ P @ Xs )
        = ( ! [I4: nat] :
              ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( P @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_Suc_transp
thf(fact_7908_euclidean__size__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid6346220572633701492n_size @ A @ ( semiring_1_of_nat @ A @ N ) )
          = N ) ) ).

% euclidean_size_of_nat
thf(fact_7909_euclidean__size__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A] :
          ( ( ( euclid6346220572633701492n_size @ A @ B2 )
            = ( zero_zero @ nat ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% euclidean_size_eq_0_iff
thf(fact_7910_size__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ( ( euclid6346220572633701492n_size @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ nat ) ) ) ).

% size_0
thf(fact_7911_euclidean__size__greater__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% euclidean_size_greater_0_iff
thf(fact_7912_transp__gr,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A
        @ ^ [X3: A,Y4: A] : ( ord_less @ A @ Y4 @ X3 ) ) ) ).

% transp_gr
thf(fact_7913_transp__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A @ ( ord_less @ A ) ) ) ).

% transp_less
thf(fact_7914_dvd__euclidean__size__eq__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( euclid6346220572633701492n_size @ A @ A2 )
              = ( euclid6346220572633701492n_size @ A @ B2 ) )
           => ( ( dvd_dvd @ A @ B2 @ A2 )
             => ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_euclidean_size_eq_imp_dvd
thf(fact_7915_transp__realrel,axiom,
    transp @ ( nat > rat ) @ realrel ).

% transp_realrel
thf(fact_7916_sorted__wrt2,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Y: A,Zs: list @ A] :
      ( ( transp @ A @ P )
     => ( ( sorted_wrt @ A @ P @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
        = ( ( P @ X @ Y )
          & ( sorted_wrt @ A @ P @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% sorted_wrt2
thf(fact_7917_transp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A @ ( ord_less_eq @ A ) ) ) ).

% transp_le
thf(fact_7918_transp__ge,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A
        @ ^ [X3: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X3 ) ) ) ).

% transp_ge
thf(fact_7919_list_Orel__transp,axiom,
    ! [A: $tType,R4: A > A > $o] :
      ( ( transp @ A @ R4 )
     => ( transp @ ( list @ A ) @ ( list_all2 @ A @ A @ R4 ) ) ) ).

% list.rel_transp
thf(fact_7920_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
          = ( ( ( euclid6346220572633701492n_size @ A @ A2 )
              = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) )
            & ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% unit_iff_euclidean_size
thf(fact_7921_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ B2 @ A2 ) ) ) ) ) ).

% size_mult_mono'
thf(fact_7922_size__mult__mono,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% size_mult_mono
thf(fact_7923_dvd__proper__imp__size__less,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ~ ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ) ) ).

% dvd_proper_imp_size_less
thf(fact_7924_dvd__imp__size__le,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ) ).

% dvd_imp_size_le
thf(fact_7925_mod__size__less,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% mod_size_less
thf(fact_7926_divmod__cases,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,A2: A] :
          ( ( ( B2
             != ( zero_zero @ A ) )
           => ( ( ( modulo_modulo @ A @ A2 @ B2 )
                = ( zero_zero @ A ) )
             => ( A2
               != ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) )
         => ( ( ( B2
               != ( zero_zero @ A ) )
             => ! [Q5: A,R: A] :
                  ( ( ( euclid7384307370059645450egment @ A @ R )
                    = ( euclid7384307370059645450egment @ A @ B2 ) )
                 => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
                   => ( ( R
                       != ( zero_zero @ A ) )
                     => ( ( ( divide_divide @ A @ A2 @ B2 )
                          = Q5 )
                       => ( ( ( modulo_modulo @ A @ A2 @ B2 )
                            = R )
                         => ( A2
                           != ( plus_plus @ A @ ( times_times @ A @ Q5 @ B2 ) @ R ) ) ) ) ) ) ) )
           => ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divmod_cases
thf(fact_7927_mod__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R2: A,Q4: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R2 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R2 )
                  = A2 )
               => ( ( modulo_modulo @ A @ A2 @ B2 )
                  = R2 ) ) ) ) ) ) ).

% mod_eqI
thf(fact_7928_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid7384307370059645450egment @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( one_one @ A ) ) ) ).

% division_segment_of_nat
thf(fact_7929_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A2 ) @ ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A2 ) ) )
          = A2 ) ) ).

% division_segment_euclidean_size
thf(fact_7930_division__segment__eq__sgn,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( euclid7384307370059645450egment @ int @ K )
        = ( sgn_sgn @ int @ K ) ) ) ).

% division_segment_eq_sgn
thf(fact_7931_division__segment__not__0,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A] :
          ( ( euclid7384307370059645450egment @ A @ A2 )
         != ( zero_zero @ A ) ) ) ).

% division_segment_not_0
thf(fact_7932_division__segment__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( euclid7384307370059645450egment @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A2 ) @ ( euclid7384307370059645450egment @ A @ B2 ) ) ) ) ) ) ).

% division_segment_mult
thf(fact_7933_division__segment__mod,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ~ ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( euclid7384307370059645450egment @ A @ ( modulo_modulo @ A @ A2 @ B2 ) )
              = ( euclid7384307370059645450egment @ A @ B2 ) ) ) ) ) ).

% division_segment_mod
thf(fact_7934_of__nat__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A2 ) )
          = ( divide_divide @ A @ A2 @ ( euclid7384307370059645450egment @ A @ A2 ) ) ) ) ).

% of_nat_euclidean_size
thf(fact_7935_division__segment__int__def,axiom,
    ( ( euclid7384307370059645450egment @ int )
    = ( ^ [K4: int] : ( if @ int @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ K4 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% division_segment_int_def
thf(fact_7936_unique__euclidean__semiring__class_Odiv__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( euclid7384307370059645450egment @ A @ A2 )
            = ( euclid7384307370059645450egment @ A @ B2 ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
              | ( B2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% unique_euclidean_semiring_class.div_eq_0_iff
thf(fact_7937_div__bounded,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R2: A,Q4: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R2 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R2 ) @ B2 )
                = Q4 ) ) ) ) ) ).

% div_bounded
thf(fact_7938_div__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R2: A,Q4: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R2 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R2 )
                  = A2 )
               => ( ( divide_divide @ A @ A2 @ B2 )
                  = Q4 ) ) ) ) ) ) ).

% div_eqI
thf(fact_7939_less__eq__enat__def,axiom,
    ( ( ord_less_eq @ extended_enat )
    = ( ^ [M2: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [N1: nat] :
              ( extended_case_enat @ $o
              @ ^ [M1: nat] : ( ord_less_eq @ nat @ M1 @ N1 )
              @ $false
              @ M2 )
          @ $true ) ) ) ).

% less_eq_enat_def
thf(fact_7940_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L4: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L4 @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_7941_less__enat__def,axiom,
    ( ( ord_less @ extended_enat )
    = ( ^ [M2: extended_enat,N3: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [M1: nat] : ( extended_case_enat @ $o @ ( ord_less @ nat @ M1 ) @ $true @ N3 )
          @ $false
          @ M2 ) ) ) ).

% less_enat_def
thf(fact_7942_Frct__code__post_I2_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_7943_Frct__code__post_I1_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A2 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_7944_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R2 @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_7945_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R2 ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R2 ) ) ) ).

% one_le_of_rat_iff
thf(fact_7946_zero__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( zero_zero @ A )
            = ( field_char_0_of_rat @ A @ A2 ) )
          = ( ( zero_zero @ rat )
            = A2 ) ) ) ).

% zero_eq_of_rat_iff
thf(fact_7947_of__rat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( field_char_0_of_rat @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ rat ) ) ) ) ).

% of_rat_eq_0_iff
thf(fact_7948_of__rat__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( zero_zero @ rat ) )
        = ( zero_zero @ A ) ) ) ).

% of_rat_0
thf(fact_7949_of__rat__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( field_char_0_of_rat @ A @ ( semiring_1_of_nat @ rat @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_rat_of_nat_eq
thf(fact_7950_of__rat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ rat @ R2 @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_less_0_iff
thf(fact_7951_zero__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R2 ) )
          = ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 ) ) ) ).

% zero_less_of_rat_iff
thf(fact_7952_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R2 ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R2 ) ) ) ).

% one_less_of_rat_iff
thf(fact_7953_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R2 @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_7954_of__rat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ rat @ R2 @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_le_0_iff
thf(fact_7955_zero__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R2 ) )
          = ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ R2 ) ) ) ).

% zero_le_of_rat_iff
thf(fact_7956_of__rat__dense,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ? [Q5: rat] :
          ( ( ord_less @ real @ X @ ( field_char_0_of_rat @ real @ Q5 ) )
          & ( ord_less @ real @ ( field_char_0_of_rat @ real @ Q5 ) @ Y ) ) ) ).

% of_rat_dense
thf(fact_7957_of__rat__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,N: nat] :
          ( ( field_char_0_of_rat @ A @ ( power_power @ rat @ A2 @ N ) )
          = ( power_power @ A @ ( field_char_0_of_rat @ A @ A2 ) @ N ) ) ) ).

% of_rat_power
thf(fact_7958_of__rat__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat,S: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( field_char_0_of_rat @ A @ S ) )
          = ( ord_less @ rat @ R2 @ S ) ) ) ).

% of_rat_less
thf(fact_7959_of__rat__inverse,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( field_char_0_of_rat @ A @ ( inverse_inverse @ rat @ A2 ) )
          = ( inverse_inverse @ A @ ( field_char_0_of_rat @ A @ A2 ) ) ) ) ).

% of_rat_inverse
thf(fact_7960_of__rat__Real,axiom,
    ( ( field_char_0_of_rat @ real )
    = ( ^ [X3: rat] :
          ( real2
          @ ^ [N3: nat] : X3 ) ) ) ).

% of_rat_Real
thf(fact_7961_Real__leI,axiom,
    ! [X8: nat > rat,Y: real] :
      ( ( cauchy @ X8 )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( field_char_0_of_rat @ real @ ( X8 @ N2 ) ) @ Y )
       => ( ord_less_eq @ real @ ( real2 @ X8 ) @ Y ) ) ) ).

% Real_leI
thf(fact_7962_le__RealI,axiom,
    ! [Y6: nat > rat,X: real] :
      ( ( cauchy @ Y6 )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ X @ ( field_char_0_of_rat @ real @ ( Y6 @ N2 ) ) )
       => ( ord_less_eq @ real @ X @ ( real2 @ Y6 ) ) ) ) ).

% le_RealI
thf(fact_7963_less__RealD,axiom,
    ! [Y6: nat > rat,X: real] :
      ( ( cauchy @ Y6 )
     => ( ( ord_less @ real @ X @ ( real2 @ Y6 ) )
       => ? [N2: nat] : ( ord_less @ real @ X @ ( field_char_0_of_rat @ real @ ( Y6 @ N2 ) ) ) ) ) ).

% less_RealD
thf(fact_7964_of__rat__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat,S: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( field_char_0_of_rat @ A @ S ) )
          = ( ord_less_eq @ rat @ R2 @ S ) ) ) ).

% of_rat_less_eq
thf(fact_7965_nonzero__of__rat__inverse,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( A2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( inverse_inverse @ rat @ A2 ) )
            = ( inverse_inverse @ A @ ( field_char_0_of_rat @ A @ A2 ) ) ) ) ) ).

% nonzero_of_rat_inverse
thf(fact_7966_nonzero__of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: rat,A2: rat] :
          ( ( B2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ) ).

% nonzero_of_rat_divide
thf(fact_7967_of__rat__rat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: int,A2: int] :
          ( ( B2
           != ( zero_zero @ int ) )
         => ( ( field_char_0_of_rat @ A @ ( fract @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) ) ) ) ).

% of_rat_rat
thf(fact_7968_span__explicit_H,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A )
        = ( ^ [B3: set @ A] :
              ( collect @ A
              @ ^ [Uu3: A] :
                ? [F3: A > real] :
                  ( ( Uu3
                    = ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ V5 ) @ V5 )
                      @ ( collect @ A
                        @ ^ [V5: A] :
                            ( ( F3 @ V5 )
                           != ( zero_zero @ real ) ) ) ) )
                  & ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [V5: A] :
                          ( ( F3 @ V5 )
                         != ( zero_zero @ real ) ) ) )
                  & ! [V5: A] :
                      ( ( ( F3 @ V5 )
                       != ( zero_zero @ real ) )
                     => ( member @ A @ V5 @ B3 ) ) ) ) ) ) ) ).

% span_explicit'
thf(fact_7969_span__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A )
        = ( ^ [B7: set @ A] :
              ( collect @ A
              @ ^ [Uu3: A] :
                ? [F3: A > real] :
                  ( ( Uu3
                    = ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ X3 ) @ X3 )
                      @ ( collect @ A
                        @ ^ [X3: A] :
                            ( ( F3 @ X3 )
                           != ( zero_zero @ real ) ) ) ) )
                  & ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( F3 @ X3 )
                         != ( zero_zero @ real ) ) )
                    @ B7 )
                  & ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( F3 @ X3 )
                         != ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% span_alt
thf(fact_7970_span__insert__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( real_Vector_span @ A @ ( insert2 @ A @ ( zero_zero @ A ) @ S2 ) )
          = ( real_Vector_span @ A @ S2 ) ) ) ).

% span_insert_0
thf(fact_7971_span__empty,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% span_empty
thf(fact_7972_span__delete__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( real_Vector_span @ A @ S2 ) ) ) ).

% span_delete_0
thf(fact_7973_maximal__independent__subset__extend,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,V: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S2 @ V )
         => ( ~ ( real_V358717886546972837endent @ A @ S2 )
           => ~ ! [B8: set @ A] :
                  ( ( ord_less_eq @ ( set @ A ) @ S2 @ B8 )
                 => ( ( ord_less_eq @ ( set @ A ) @ B8 @ V )
                   => ( ~ ( real_V358717886546972837endent @ A @ B8 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ V @ ( real_Vector_span @ A @ B8 ) ) ) ) ) ) ) ) ).

% maximal_independent_subset_extend
thf(fact_7974_spanning__subset__independent,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B6 @ A5 )
         => ( ~ ( real_V358717886546972837endent @ A @ A5 )
           => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( real_Vector_span @ A @ B6 ) )
             => ( A5 = B6 ) ) ) ) ) ).

% spanning_subset_independent
thf(fact_7975_maximal__independent__subset,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [V: set @ A] :
          ~ ! [B8: set @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ B8 @ V )
             => ( ~ ( real_V358717886546972837endent @ A @ B8 )
               => ~ ( ord_less_eq @ ( set @ A ) @ V @ ( real_Vector_span @ A @ B8 ) ) ) ) ) ).

% maximal_independent_subset
thf(fact_7976_span__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( ( real_Vector_span @ A @ S2 )
            = ( real_Vector_span @ A @ T6 ) )
          = ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ T6 ) )
            & ( ord_less_eq @ ( set @ A ) @ T6 @ ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_eq
thf(fact_7977_span__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ord_less_eq @ ( set @ A ) @ ( real_Vector_span @ A @ A5 ) @ ( real_Vector_span @ A @ B6 ) ) ) ) ).

% span_mono
thf(fact_7978_span__superset,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] : ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ S2 ) ) ) ).

% span_superset
thf(fact_7979_span__induct__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,S2: set @ A,H: A > $o] :
          ( ( member @ A @ X @ ( real_Vector_span @ A @ S2 ) )
         => ( ( H @ ( zero_zero @ A ) )
           => ( ! [C3: real,X2: A,Y2: A] :
                  ( ( member @ A @ X2 @ S2 )
                 => ( ( H @ Y2 )
                   => ( H @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ C3 @ X2 ) @ Y2 ) ) ) )
             => ( H @ X ) ) ) ) ) ).

% span_induct_alt
thf(fact_7980_span__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] : ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_span @ A @ S2 ) ) ) ).

% span_0
thf(fact_7981_span__image__scale,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,C2: A > real] :
          ( ( finite_finite @ A @ S2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ( C2 @ X2 )
                 != ( zero_zero @ real ) ) )
           => ( ( real_Vector_span @ A
                @ ( image @ A @ A
                  @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( C2 @ X3 ) @ X3 )
                  @ S2 ) )
              = ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_image_scale
thf(fact_7982_span__explicit,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A )
        = ( ^ [B3: set @ A] :
              ( collect @ A
              @ ^ [Uu3: A] :
                ? [T4: set @ A,R5: A > real] :
                  ( ( Uu3
                    = ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [A3: A] : ( real_V8093663219630862766scaleR @ A @ ( R5 @ A3 ) @ A3 )
                      @ T4 ) )
                  & ( finite_finite @ A @ T4 )
                  & ( ord_less_eq @ ( set @ A ) @ T4 @ B3 ) ) ) ) ) ) ).

% span_explicit
thf(fact_7983_independent__span__bound,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [T6: set @ A,S2: set @ A] :
          ( ( finite_finite @ A @ T6 )
         => ( ~ ( real_V358717886546972837endent @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ T6 ) )
             => ( ( finite_finite @ A @ S2 )
                & ( ord_less_eq @ nat @ ( finite_card @ A @ S2 ) @ ( finite_card @ A @ T6 ) ) ) ) ) ) ) ).

% independent_span_bound
thf(fact_7984_exchange__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [T6: set @ A,S2: set @ A] :
          ( ( finite_finite @ A @ T6 )
         => ( ~ ( real_V358717886546972837endent @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ T6 ) )
             => ? [T13: set @ A] :
                  ( ( ( finite_card @ A @ T13 )
                    = ( finite_card @ A @ T6 ) )
                  & ( finite_finite @ A @ T13 )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ T13 )
                  & ( ord_less_eq @ ( set @ A ) @ T13 @ ( sup_sup @ ( set @ A ) @ S2 @ T6 ) )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ T13 ) ) ) ) ) ) ) ).

% exchange_lemma
thf(fact_7985_representation__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V7696804695334737415tation @ A )
        = ( ^ [Basis2: set @ A,V5: A] :
              ( if @ ( A > real )
              @ ( ~ ( real_V358717886546972837endent @ A @ Basis2 )
                & ( member @ A @ V5 @ ( real_Vector_span @ A @ Basis2 ) ) )
              @ ( fChoice @ ( A > real )
                @ ^ [F3: A > real] :
                    ( ! [W3: A] :
                        ( ( ( F3 @ W3 )
                         != ( zero_zero @ real ) )
                       => ( member @ A @ W3 @ Basis2 ) )
                    & ( finite_finite @ A
                      @ ( collect @ A
                        @ ^ [W3: A] :
                            ( ( F3 @ W3 )
                           != ( zero_zero @ real ) ) ) )
                    & ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [W3: A] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ W3 ) @ W3 )
                        @ ( collect @ A
                          @ ^ [W3: A] :
                              ( ( F3 @ W3 )
                             != ( zero_zero @ real ) ) ) )
                      = V5 ) ) )
              @ ^ [B3: A] : ( zero_zero @ real ) ) ) ) ) ).

% representation_def
thf(fact_7986_extend__basis__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V4986007116245087402_basis @ A )
        = ( ^ [B7: set @ A] :
              ( fChoice @ ( set @ A )
              @ ^ [B15: set @ A] :
                  ( ( ord_less_eq @ ( set @ A ) @ B7 @ B15 )
                  & ~ ( real_V358717886546972837endent @ A @ B15 )
                  & ( ( real_Vector_span @ A @ B15 )
                    = ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% extend_basis_def
thf(fact_7987_finite__representation,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [B3: A] :
                ( ( real_V7696804695334737415tation @ A @ Basis @ V2 @ B3 )
               != ( zero_zero @ real ) ) ) ) ) ).

% finite_representation
thf(fact_7988_representation__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A] :
          ( ( real_V7696804695334737415tation @ A @ Basis @ ( zero_zero @ A ) )
          = ( ^ [B3: A] : ( zero_zero @ real ) ) ) ) ).

% representation_zero
thf(fact_7989_representation__ne__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V2: A,B2: A] :
          ( ( ( real_V7696804695334737415tation @ A @ Basis @ V2 @ B2 )
           != ( zero_zero @ real ) )
         => ( member @ A @ B2 @ Basis ) ) ) ).

% representation_ne_zero
thf(fact_7990_representation__basis,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,B2: A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ B2 @ Basis )
           => ( ( real_V7696804695334737415tation @ A @ Basis @ B2 )
              = ( ^ [V5: A] : ( if @ real @ ( V5 = B2 ) @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% representation_basis
thf(fact_7991_representation__extend,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V2: A,Basis3: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V2 @ ( real_Vector_span @ A @ Basis3 ) )
           => ( ( ord_less_eq @ ( set @ A ) @ Basis3 @ Basis )
             => ( ( real_V7696804695334737415tation @ A @ Basis @ V2 )
                = ( real_V7696804695334737415tation @ A @ Basis3 @ V2 ) ) ) ) ) ) ).

% representation_extend
thf(fact_7992_extend__basis__superset,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ B6 )
         => ( ord_less_eq @ ( set @ A ) @ B6 @ ( real_V4986007116245087402_basis @ A @ B6 ) ) ) ) ).

% extend_basis_superset
thf(fact_7993_sum__nonzero__representation__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V2: A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V2 @ ( real_Vector_span @ A @ Basis ) )
           => ( ( groups7311177749621191930dd_sum @ A @ A
                @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ A @ ( real_V7696804695334737415tation @ A @ Basis @ V2 @ B3 ) @ B3 )
                @ ( collect @ A
                  @ ^ [B3: A] :
                      ( ( real_V7696804695334737415tation @ A @ Basis @ V2 @ B3 )
                     != ( zero_zero @ real ) ) ) )
              = V2 ) ) ) ) ).

% sum_nonzero_representation_eq
thf(fact_7994_sum__representation__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V2: A,B6: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V2 @ ( real_Vector_span @ A @ Basis ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ( ord_less_eq @ ( set @ A ) @ Basis @ B6 )
               => ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ A @ ( real_V7696804695334737415tation @ A @ Basis @ V2 @ B3 ) @ B3 )
                    @ B6 )
                  = V2 ) ) ) ) ) ) ).

% sum_representation_eq
thf(fact_7995_representation__eqI,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V2: A,F2: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V2 @ ( real_Vector_span @ A @ Basis ) )
           => ( ! [B4: A] :
                  ( ( ( F2 @ B4 )
                   != ( zero_zero @ real ) )
                 => ( member @ A @ B4 @ Basis ) )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [B3: A] :
                        ( ( F2 @ B3 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ A @ ( F2 @ B3 ) @ B3 )
                      @ ( collect @ A
                        @ ^ [B3: A] :
                            ( ( F2 @ B3 )
                           != ( zero_zero @ real ) ) ) )
                    = V2 )
                 => ( ( real_V7696804695334737415tation @ A @ Basis @ V2 )
                    = F2 ) ) ) ) ) ) ) ).

% representation_eqI
thf(fact_7996_construct__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ( ( real_V4425403222259421789struct @ A @ B )
        = ( ^ [B7: set @ A,G: A > B,V5: A] :
              ( groups7311177749621191930dd_sum @ A @ B
              @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ B @ ( real_V7696804695334737415tation @ A @ ( real_V4986007116245087402_basis @ A @ B7 ) @ V5 @ B3 ) @ ( if @ B @ ( member @ A @ B3 @ B7 ) @ ( G @ B3 ) @ ( zero_zero @ B ) ) )
              @ ( collect @ A
                @ ^ [B3: A] :
                    ( ( real_V7696804695334737415tation @ A @ ( real_V4986007116245087402_basis @ A @ B7 ) @ V5 @ B3 )
                   != ( zero_zero @ real ) ) ) ) ) ) ) ).

% construct_def
thf(fact_7997_dim__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_dim @ A )
        = ( ^ [V7: set @ A] :
              ( if @ nat
              @ ? [B3: set @ A] :
                  ( ~ ( real_V358717886546972837endent @ A @ B3 )
                  & ( ( real_Vector_span @ A @ B3 )
                    = ( real_Vector_span @ A @ V7 ) ) )
              @ ( finite_card @ A
                @ ( fChoice @ ( set @ A )
                  @ ^ [B3: set @ A] :
                      ( ~ ( real_V358717886546972837endent @ A @ B3 )
                      & ( ( real_Vector_span @ A @ B3 )
                        = ( real_Vector_span @ A @ V7 ) ) ) ) )
              @ ( zero_zero @ nat ) ) ) ) ) ).

% dim_def
thf(fact_7998_dim__le__card_H,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ S ) @ ( finite_card @ A @ S ) ) ) ) ).

% dim_le_card'
thf(fact_7999_dim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,V: set @ A,N: nat] :
          ( ( ord_less_eq @ ( set @ A ) @ B6 @ V )
         => ( ( ord_less_eq @ ( set @ A ) @ V @ ( real_Vector_span @ A @ B6 ) )
           => ( ~ ( real_V358717886546972837endent @ A @ B6 )
             => ( ( ( finite_card @ A @ B6 )
                  = N )
               => ( ( real_Vector_dim @ A @ V )
                  = N ) ) ) ) ) ) ).

% dim_unique
thf(fact_8000_basis__exists,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [V: set @ A] :
          ~ ! [B8: set @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ B8 @ V )
             => ( ~ ( real_V358717886546972837endent @ A @ B8 )
               => ( ( ord_less_eq @ ( set @ A ) @ V @ ( real_Vector_span @ A @ B8 ) )
                 => ( ( finite_card @ A @ B8 )
                   != ( real_Vector_dim @ A @ V ) ) ) ) ) ) ).

% basis_exists
thf(fact_8001_basis__card__eq__dim,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,V: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B6 @ V )
         => ( ( ord_less_eq @ ( set @ A ) @ V @ ( real_Vector_span @ A @ B6 ) )
           => ( ~ ( real_V358717886546972837endent @ A @ B6 )
             => ( ( finite_card @ A @ B6 )
                = ( real_Vector_dim @ A @ V ) ) ) ) ) ) ).

% basis_card_eq_dim
thf(fact_8002_span__card__ge__dim,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B6: set @ A,V: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B6 @ V )
         => ( ( ord_less_eq @ ( set @ A ) @ V @ ( real_Vector_span @ A @ B6 ) )
           => ( ( finite_finite @ A @ B6 )
             => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ V ) @ ( finite_card @ A @ B6 ) ) ) ) ) ) ).

% span_card_ge_dim
thf(fact_8003_dim__le__card,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [V: set @ A,W4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ V @ ( real_Vector_span @ A @ W4 ) )
         => ( ( finite_finite @ A @ W4 )
           => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ V ) @ ( finite_card @ A @ W4 ) ) ) ) ) ).

% dim_le_card
thf(fact_8004_construct__outside,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [B6: set @ A,V2: A,F2: A > B] :
          ( ~ ( real_V358717886546972837endent @ A @ B6 )
         => ( ( member @ A @ V2 @ ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ ( real_V4986007116245087402_basis @ A @ B6 ) @ B6 ) ) )
           => ( ( real_V4425403222259421789struct @ A @ B @ B6 @ F2 @ V2 )
              = ( zero_zero @ B ) ) ) ) ) ).

% construct_outside
thf(fact_8005_linear__indep__image__lemma,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B,B6: set @ A,X: A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( finite_finite @ A @ B6 )
           => ( ~ ( real_V358717886546972837endent @ B @ ( image @ A @ B @ F2 @ B6 ) )
             => ( ( inj_on @ A @ B @ F2 @ B6 )
               => ( ( member @ A @ X @ ( real_Vector_span @ A @ B6 ) )
                 => ( ( ( F2 @ X )
                      = ( zero_zero @ B ) )
                   => ( X
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ) ).

% linear_indep_image_lemma
thf(fact_8006_lexordp__conv__lexord,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ ( ord_less @ A ) ) ) ) ) ) ) ) ).

% lexordp_conv_lexord
thf(fact_8007_lexordp__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Ys2: list @ A] :
          ( ( ord_lexordp @ A @ ( nil @ A ) @ Ys2 )
          = ( ( Ys2
             != ( nil @ A ) ) ) ) ) ).

% lexordp_simps(1)
thf(fact_8008_lexordp__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A] :
          ~ ( ord_lexordp @ A @ Xs @ ( nil @ A ) ) ) ).

% lexordp_simps(2)
thf(fact_8009_lexordp__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A,Y: A,Ys2: list @ A] :
          ( ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp @ A @ Xs @ Ys2 ) ) ) ) ) ).

% lexordp_simps(3)
thf(fact_8010_linear__spans__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B,V: set @ A,B6: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ V @ ( real_Vector_span @ A @ B6 ) )
           => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ V ) @ ( real_Vector_span @ B @ ( image @ A @ B @ F2 @ B6 ) ) ) ) ) ) ).

% linear_spans_image
thf(fact_8011_linear__eq__0__on__span,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F2: A > B,B2: set @ A,X: A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ B2 )
               => ( ( F2 @ X2 )
                  = ( zero_zero @ B ) ) )
           => ( ( member @ A @ X @ ( real_Vector_span @ A @ B2 ) )
             => ( ( F2 @ X )
                = ( zero_zero @ B ) ) ) ) ) ) ).

% linear_eq_0_on_span
thf(fact_8012_lexordp_ONil,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Y: A,Ys2: list @ A] : ( ord_lexordp @ A @ ( nil @ A ) @ ( cons @ A @ Y @ Ys2 ) ) ) ).

% lexordp.Nil
thf(fact_8013_lexordp__append__rightI,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Ys2: list @ A,Xs: list @ A] :
          ( ( Ys2
           != ( nil @ A ) )
         => ( ord_lexordp @ A @ Xs @ ( append @ A @ Xs @ Ys2 ) ) ) ) ).

% lexordp_append_rightI
thf(fact_8014_linear__injective__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
            = ( ! [X3: A] :
                  ( ( ( F2 @ X3 )
                    = ( zero_zero @ B ) )
                 => ( X3
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% linear_injective_0
thf(fact_8015_module__hom__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ( real_Vector_linear @ A @ B
        @ ^ [X3: A] : ( zero_zero @ B ) ) ) ).

% module_hom_zero
thf(fact_8016_lexordp__irreflexive,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A] :
          ( ! [X2: A] :
              ~ ( ord_less @ A @ X2 @ X2 )
         => ~ ( ord_lexordp @ A @ Xs @ Xs ) ) ) ).

% lexordp_irreflexive
thf(fact_8017_linear__0,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F2: A > B] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( F2 @ ( zero_zero @ A ) )
            = ( zero_zero @ B ) ) ) ) ).

% linear_0
thf(fact_8018_lexordp__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ~ ( ord_lexordp @ A @ Ys2 @ Xs ) ) ) ).

% lexordp_antisym
thf(fact_8019_lexordp__trans,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ( ( ord_lexordp @ A @ Ys2 @ Zs )
           => ( ord_lexordp @ A @ Xs @ Zs ) ) ) ) ).

% lexordp_trans
thf(fact_8020_lexordp__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
          | ( Xs = Ys2 )
          | ( ord_lexordp @ A @ Ys2 @ Xs ) ) ) ).

% lexordp_linear
thf(fact_8021_lexordp__irreflexive_H,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Xs: list @ A] :
          ~ ( ord_lexordp @ A @ Xs @ Xs ) ) ).

% lexordp_irreflexive'
thf(fact_8022_lexordp__append__leftD,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A,Us: list @ A,Vs: list @ A] :
          ( ( ord_lexordp @ A @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) )
         => ( ! [A4: A] :
                ~ ( ord_less @ A @ A4 @ A4 )
           => ( ord_lexordp @ A @ Us @ Vs ) ) ) ) ).

% lexordp_append_leftD
thf(fact_8023_lexordp__append__leftI,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Us: list @ A,Vs: list @ A,Xs: list @ A] :
          ( ( ord_lexordp @ A @ Us @ Vs )
         => ( ord_lexordp @ A @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) ) ) ) ).

% lexordp_append_leftI
thf(fact_8024_lexordp_OCons,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys2: list @ A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) ).

% lexordp.Cons
thf(fact_8025_lexordp_OCons__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys2: list @ A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp @ A @ Xs @ Ys2 )
             => ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) ) ) ).

% lexordp.Cons_eq
thf(fact_8026_lexordp__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ( ! [Y2: A,Ys4: list @ A] : ( P @ ( nil @ A ) @ ( cons @ A @ Y2 @ Ys4 ) )
           => ( ! [X2: A,Xs2: list @ A,Y2: A,Ys4: list @ A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) )
             => ( ! [X2: A,Xs2: list @ A,Ys4: list @ A] :
                    ( ( ord_lexordp @ A @ Xs2 @ Ys4 )
                   => ( ( P @ Xs2 @ Ys4 )
                     => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ X2 @ Ys4 ) ) ) )
               => ( P @ Xs @ Ys2 ) ) ) ) ) ) ).

% lexordp_induct
thf(fact_8027_lexordp__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ! [Y2: A,Ys7: list @ A] :
                  ( Ys2
                 != ( cons @ A @ Y2 @ Ys7 ) ) )
           => ( ! [X2: A] :
                  ( ? [Xs4: list @ A] :
                      ( Xs
                      = ( cons @ A @ X2 @ Xs4 ) )
                 => ! [Y2: A] :
                      ( ? [Ys7: list @ A] :
                          ( Ys2
                          = ( cons @ A @ Y2 @ Ys7 ) )
                     => ~ ( ord_less @ A @ X2 @ Y2 ) ) )
             => ~ ! [X2: A,Xs4: list @ A] :
                    ( ( Xs
                      = ( cons @ A @ X2 @ Xs4 ) )
                   => ! [Ys7: list @ A] :
                        ( ( Ys2
                          = ( cons @ A @ X2 @ Ys7 ) )
                       => ~ ( ord_lexordp @ A @ Xs4 @ Ys7 ) ) ) ) ) ) ) ).

% lexordp_cases
thf(fact_8028_lexordp_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [A1: list @ A,A22: list @ A] :
              ( ? [Y4: A,Ys3: list @ A] :
                  ( ( A1
                    = ( nil @ A ) )
                  & ( A22
                    = ( cons @ A @ Y4 @ Ys3 ) ) )
              | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                  ( ( A1
                    = ( cons @ A @ X3 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y4 @ Ys3 ) )
                  & ( ord_less @ A @ X3 @ Y4 ) )
              | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                  ( ( A1
                    = ( cons @ A @ X3 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y4 @ Ys3 ) )
                  & ~ ( ord_less @ A @ X3 @ Y4 )
                  & ~ ( ord_less @ A @ Y4 @ X3 )
                  & ( ord_lexordp @ A @ Xs3 @ Ys3 ) ) ) ) ) ) ).

% lexordp.simps
thf(fact_8029_lexordp_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A12: list @ A,A23: list @ A] :
          ( ( ord_lexordp @ A @ A12 @ A23 )
         => ( ( ( A12
                = ( nil @ A ) )
             => ! [Y2: A,Ys4: list @ A] :
                  ( A23
                 != ( cons @ A @ Y2 @ Ys4 ) ) )
           => ( ! [X2: A] :
                  ( ? [Xs2: list @ A] :
                      ( A12
                      = ( cons @ A @ X2 @ Xs2 ) )
                 => ! [Y2: A] :
                      ( ? [Ys4: list @ A] :
                          ( A23
                          = ( cons @ A @ Y2 @ Ys4 ) )
                     => ~ ( ord_less @ A @ X2 @ Y2 ) ) )
             => ~ ! [X2: A,Y2: A,Xs2: list @ A] :
                    ( ( A12
                      = ( cons @ A @ X2 @ Xs2 ) )
                   => ! [Ys4: list @ A] :
                        ( ( A23
                          = ( cons @ A @ Y2 @ Ys4 ) )
                       => ( ~ ( ord_less @ A @ X2 @ Y2 )
                         => ( ~ ( ord_less @ A @ Y2 @ X2 )
                           => ~ ( ord_lexordp @ A @ Xs2 @ Ys4 ) ) ) ) ) ) ) ) ) ).

% lexordp.cases
thf(fact_8030_lexordp__append__left__rightI,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Us: list @ A,Xs: list @ A,Ys2: list @ A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp @ A @ ( append @ A @ Us @ ( cons @ A @ X @ Xs ) ) @ ( append @ A @ Us @ ( cons @ A @ Y @ Ys2 ) ) ) ) ) ).

% lexordp_append_left_rightI
thf(fact_8031_lexordp__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs3: list @ A,Ys3: list @ A] :
              ( ? [X3: A,Vs3: list @ A] :
                  ( Ys3
                  = ( append @ A @ Xs3 @ ( cons @ A @ X3 @ Vs3 ) ) )
              | ? [Us2: list @ A,A3: A,B3: A,Vs3: list @ A,Ws3: list @ A] :
                  ( ( ord_less @ A @ A3 @ B3 )
                  & ( Xs3
                    = ( append @ A @ Us2 @ ( cons @ A @ A3 @ Vs3 ) ) )
                  & ( Ys3
                    = ( append @ A @ Us2 @ ( cons @ A @ B3 @ Ws3 ) ) ) ) ) ) ) ) ).

% lexordp_iff
thf(fact_8032_linear__spanning__surjective__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B,S2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( real_Vector_span @ A @ S2 ) )
           => ( ( ( image @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
                = ( top_top @ ( set @ B ) ) )
             => ( ord_less_eq @ ( set @ B ) @ ( top_top @ ( set @ B ) ) @ ( real_Vector_span @ B @ ( image @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ).

% linear_spanning_surjective_image
thf(fact_8033_linear__surj__right__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F2: A > B,T6: set @ B,S2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( ord_less_eq @ ( set @ B ) @ ( real_Vector_span @ B @ T6 ) @ ( image @ A @ B @ F2 @ ( real_Vector_span @ A @ S2 ) ) )
           => ? [G7: B > A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G7 @ ( top_top @ ( set @ B ) ) ) @ ( real_Vector_span @ A @ S2 ) )
                & ( real_Vector_linear @ B @ A @ G7 )
                & ! [X5: B] :
                    ( ( member @ B @ X5 @ ( real_Vector_span @ B @ T6 ) )
                   => ( ( F2 @ ( G7 @ X5 ) )
                      = X5 ) ) ) ) ) ) ).

% linear_surj_right_inverse
thf(fact_8034_linear__inj__on__left__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B,S2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( inj_on @ A @ B @ F2 @ ( real_Vector_span @ A @ S2 ) )
           => ? [G7: B > A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G7 @ ( top_top @ ( set @ B ) ) ) @ ( real_Vector_span @ A @ S2 ) )
                & ( real_Vector_linear @ B @ A @ G7 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ ( real_Vector_span @ A @ S2 ) )
                   => ( ( G7 @ ( F2 @ X5 ) )
                      = X5 ) ) ) ) ) ) ).

% linear_inj_on_left_inverse
thf(fact_8035_finite__basis__to__basis__subspace__isomorphism,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [S2: set @ A,T6: set @ B,B6: set @ A,C4: set @ B] :
          ( ( real_Vector_subspace @ A @ S2 )
         => ( ( real_Vector_subspace @ B @ T6 )
           => ( ( ( real_Vector_dim @ A @ S2 )
                = ( real_Vector_dim @ B @ T6 ) )
             => ( ( finite_finite @ A @ B6 )
               => ( ( ord_less_eq @ ( set @ A ) @ B6 @ S2 )
                 => ( ~ ( real_V358717886546972837endent @ A @ B6 )
                   => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ B6 ) )
                     => ( ( ( finite_card @ A @ B6 )
                          = ( real_Vector_dim @ A @ S2 ) )
                       => ( ( finite_finite @ B @ C4 )
                         => ( ( ord_less_eq @ ( set @ B ) @ C4 @ T6 )
                           => ( ~ ( real_V358717886546972837endent @ B @ C4 )
                             => ( ( ord_less_eq @ ( set @ B ) @ T6 @ ( real_Vector_span @ B @ C4 ) )
                               => ( ( ( finite_card @ B @ C4 )
                                    = ( real_Vector_dim @ B @ T6 ) )
                                 => ? [F5: A > B] :
                                      ( ( real_Vector_linear @ A @ B @ F5 )
                                      & ( ( image @ A @ B @ F5 @ B6 )
                                        = C4 )
                                      & ( ( image @ A @ B @ F5 @ S2 )
                                        = T6 )
                                      & ( inj_on @ A @ B @ F5 @ S2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% finite_basis_to_basis_subspace_isomorphism
thf(fact_8036_ord__class_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp @ A )
        = ( complete_lattice_lfp @ ( ( list @ A ) > ( list @ A ) > $o )
          @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X25: list @ A] :
              ( ? [Y4: A,Ys3: list @ A] :
                  ( ( X17
                    = ( nil @ A ) )
                  & ( X25
                    = ( cons @ A @ Y4 @ Ys3 ) ) )
              | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                  ( ( X17
                    = ( cons @ A @ X3 @ Xs3 ) )
                  & ( X25
                    = ( cons @ A @ Y4 @ Ys3 ) )
                  & ( ord_less @ A @ X3 @ Y4 ) )
              | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                  ( ( X17
                    = ( cons @ A @ X3 @ Xs3 ) )
                  & ( X25
                    = ( cons @ A @ Y4 @ Ys3 ) )
                  & ~ ( ord_less @ A @ X3 @ Y4 )
                  & ~ ( ord_less @ A @ Y4 @ X3 )
                  & ( P5 @ Xs3 @ Ys3 ) ) ) ) ) ) ).

% ord_class.lexordp_def
thf(fact_8037_linear__subspace__kernel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( real_Vector_subspace @ A
            @ ( collect @ A
              @ ^ [X3: A] :
                  ( ( F2 @ X3 )
                  = ( zero_zero @ B ) ) ) ) ) ) ).

% linear_subspace_kernel
thf(fact_8038_lfp__def,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_lattice_lfp @ A )
        = ( ^ [F3: A > A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [U2: A] : ( ord_less_eq @ A @ ( F3 @ U2 ) @ U2 ) ) ) ) ) ) ).

% lfp_def
thf(fact_8039_lfp__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F4: A > A,X: A] :
          ( ( order_mono @ A @ A @ F4 )
         => ( ( ( F4 @ X )
              = X )
           => ( ! [Z3: A] :
                  ( ( ( F4 @ Z3 )
                    = Z3 )
                 => ( ord_less_eq @ A @ X @ Z3 ) )
             => ( ( complete_lattice_lfp @ A @ F4 )
                = X ) ) ) ) ) ).

% lfp_eqI
thf(fact_8040_lfp__lfp,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A > A] :
          ( ! [X2: A,Y2: A,W: A,Z3: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ( ord_less_eq @ A @ W @ Z3 )
               => ( ord_less_eq @ A @ ( F2 @ X2 @ W ) @ ( F2 @ Y2 @ Z3 ) ) ) )
         => ( ( complete_lattice_lfp @ A
              @ ^ [X3: A] : ( complete_lattice_lfp @ A @ ( F2 @ X3 ) ) )
            = ( complete_lattice_lfp @ A
              @ ^ [X3: A] : ( F2 @ X3 @ X3 ) ) ) ) ) ).

% lfp_lfp
thf(fact_8041_lfp__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,G2: A > A] :
          ( ! [Z10: A] : ( ord_less_eq @ A @ ( F2 @ Z10 ) @ ( G2 @ Z10 ) )
         => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ ( complete_lattice_lfp @ A @ G2 ) ) ) ) ).

% lfp_mono
thf(fact_8042_lfp__lowerbound,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,A5: A] :
          ( ( ord_less_eq @ A @ ( F2 @ A5 ) @ A5 )
         => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ A5 ) ) ) ).

% lfp_lowerbound
thf(fact_8043_lfp__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,A5: A] :
          ( ! [U4: A] :
              ( ( ord_less_eq @ A @ ( F2 @ U4 ) @ U4 )
             => ( ord_less_eq @ A @ A5 @ U4 ) )
         => ( ord_less_eq @ A @ A5 @ ( complete_lattice_lfp @ A @ F2 ) ) ) ) ).

% lfp_greatest
thf(fact_8044_subspace__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( real_Vector_subspace @ A @ S2 )
         => ( member @ A @ ( zero_zero @ A ) @ S2 ) ) ) ).

% subspace_0
thf(fact_8045_subspace__single__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( real_Vector_subspace @ A @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% subspace_single_0
thf(fact_8046_subspace__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_subspace @ A )
        = ( ^ [S5: set @ A] :
              ( ( member @ A @ ( zero_zero @ A ) @ S5 )
              & ! [X3: A] :
                  ( ( member @ A @ X3 @ S5 )
                 => ! [Y4: A] :
                      ( ( member @ A @ Y4 @ S5 )
                     => ( member @ A @ ( plus_plus @ A @ X3 @ Y4 ) @ S5 ) ) )
              & ! [C5: real,X3: A] :
                  ( ( member @ A @ X3 @ S5 )
                 => ( member @ A @ ( real_V8093663219630862766scaleR @ A @ C5 @ X3 ) @ S5 ) ) ) ) ) ) ).

% subspace_def
thf(fact_8047_subspaceI,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( member @ A @ ( zero_zero @ A ) @ S2 )
         => ( ! [X2: A,Y2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ( member @ A @ Y2 @ S2 )
                 => ( member @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ S2 ) ) )
           => ( ! [C3: real,X2: A] :
                  ( ( member @ A @ X2 @ S2 )
                 => ( member @ A @ ( real_V8093663219630862766scaleR @ A @ C3 @ X2 ) @ S2 ) )
             => ( real_Vector_subspace @ A @ S2 ) ) ) ) ) ).

% subspaceI
thf(fact_8048_span__subspace,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( real_Vector_span @ A @ A5 ) )
           => ( ( real_Vector_subspace @ A @ B6 )
             => ( ( real_Vector_span @ A @ A5 )
                = B6 ) ) ) ) ) ).

% span_subspace
thf(fact_8049_span__minimal,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
         => ( ( real_Vector_subspace @ A @ T6 )
           => ( ord_less_eq @ ( set @ A ) @ ( real_Vector_span @ A @ S2 ) @ T6 ) ) ) ) ).

% span_minimal
thf(fact_8050_span__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
         => ( ( real_Vector_subspace @ A @ T6 )
           => ( ! [T14: set @ A] :
                  ( ( ord_less_eq @ ( set @ A ) @ S2 @ T14 )
                 => ( ( real_Vector_subspace @ A @ T14 )
                   => ( ord_less_eq @ ( set @ A ) @ T6 @ T14 ) ) )
             => ( ( real_Vector_span @ A @ S2 )
                = T6 ) ) ) ) ) ).

% span_unique
thf(fact_8051_lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,P: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ ( inf_inf @ A @ ( complete_lattice_lfp @ A @ F2 ) @ P ) ) @ P )
           => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ P ) ) ) ) ).

% lfp_induct
thf(fact_8052_def__lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: A,F2: A > A,P: A] :
          ( ( A5
            = ( complete_lattice_lfp @ A @ F2 ) )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ( ord_less_eq @ A @ ( F2 @ ( inf_inf @ A @ A5 @ P ) ) @ P )
             => ( ord_less_eq @ A @ A5 @ P ) ) ) ) ) ).

% def_lfp_induct
thf(fact_8053_lfp__ordinal__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,P: A > $o] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ! [S7: A] :
                ( ( P @ S7 )
               => ( ( ord_less_eq @ A @ S7 @ ( complete_lattice_lfp @ A @ F2 ) )
                 => ( P @ ( F2 @ S7 ) ) ) )
           => ( ! [M10: set @ A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ M10 )
                     => ( P @ X5 ) )
                 => ( P @ ( complete_Sup_Sup @ A @ M10 ) ) )
             => ( P @ ( complete_lattice_lfp @ A @ F2 ) ) ) ) ) ) ).

% lfp_ordinal_induct
thf(fact_8054_linear__injective__on__subspace__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B,S: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( real_Vector_subspace @ A @ S )
           => ( ( inj_on @ A @ B @ F2 @ S )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S )
                   => ( ( ( F2 @ X3 )
                        = ( zero_zero @ B ) )
                     => ( X3
                        = ( zero_zero @ A ) ) ) ) ) ) ) ) ) ).

% linear_injective_on_subspace_0
thf(fact_8055_lfp__funpow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( complete_lattice_lfp @ A @ ( compow @ ( A > A ) @ ( suc @ N ) @ F2 ) )
            = ( complete_lattice_lfp @ A @ F2 ) ) ) ) ).

% lfp_funpow
thf(fact_8056_linear__exists__right__inverse__on,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F2: A > B,V: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( real_Vector_subspace @ A @ V )
           => ? [G7: B > A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G7 @ ( top_top @ ( set @ B ) ) ) @ V )
                & ( real_Vector_linear @ B @ A @ G7 )
                & ! [X5: B] :
                    ( ( member @ B @ X5 @ ( image @ A @ B @ F2 @ V ) )
                   => ( ( F2 @ ( G7 @ X5 ) )
                      = X5 ) ) ) ) ) ) ).

% linear_exists_right_inverse_on
thf(fact_8057_lfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ( compow @ ( A > A ) @ ( suc @ K ) @ F2 @ ( bot_bot @ A ) )
              = ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) )
           => ( ( complete_lattice_lfp @ A @ F2 )
              = ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% lfp_Kleene_iter
thf(fact_8058_linear__exists__left__inverse__on,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B,V: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( real_Vector_subspace @ A @ V )
           => ( ( inj_on @ A @ B @ F2 @ V )
             => ? [G7: B > A] :
                  ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G7 @ ( top_top @ ( set @ B ) ) ) @ V )
                  & ( real_Vector_linear @ B @ A @ G7 )
                  & ! [X5: A] :
                      ( ( member @ A @ X5 @ V )
                     => ( ( G7 @ ( F2 @ X5 ) )
                        = X5 ) ) ) ) ) ) ) ).

% linear_exists_left_inverse_on
thf(fact_8059_lfp__transfer__bounded,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comple6319245703460814977attice @ B )
        & ( comple6319245703460814977attice @ A ) )
     => ! [P: A > $o,F2: A > A,Alpha: A > B,G2: B > B] :
          ( ( P @ ( bot_bot @ A ) )
         => ( ! [X2: A] :
                ( ( P @ X2 )
               => ( P @ ( F2 @ X2 ) ) )
           => ( ! [M10: nat > A] :
                  ( ! [I3: nat] : ( P @ ( M10 @ I3 ) )
                 => ( P @ ( complete_Sup_Sup @ A @ ( image @ nat @ A @ M10 @ ( top_top @ ( set @ nat ) ) ) ) ) )
             => ( ! [M10: nat > A] :
                    ( ( order_mono @ nat @ A @ M10 )
                   => ( ! [I3: nat] : ( P @ ( M10 @ I3 ) )
                     => ( ( Alpha @ ( complete_Sup_Sup @ A @ ( image @ nat @ A @ M10 @ ( top_top @ ( set @ nat ) ) ) ) )
                        = ( complete_Sup_Sup @ B
                          @ ( image @ nat @ B
                            @ ^ [I4: nat] : ( Alpha @ ( M10 @ I4 ) )
                            @ ( top_top @ ( set @ nat ) ) ) ) ) ) )
               => ( ( order_sup_continuous @ A @ A @ F2 )
                 => ( ( order_sup_continuous @ B @ B @ G2 )
                   => ( ! [X2: A] :
                          ( ( P @ X2 )
                         => ( ( ord_less_eq @ A @ X2 @ ( complete_lattice_lfp @ A @ F2 ) )
                           => ( ( Alpha @ ( F2 @ X2 ) )
                              = ( G2 @ ( Alpha @ X2 ) ) ) ) )
                     => ( ! [X2: B] : ( ord_less_eq @ B @ ( Alpha @ ( bot_bot @ A ) ) @ ( G2 @ X2 ) )
                       => ( ( Alpha @ ( complete_lattice_lfp @ A @ F2 ) )
                          = ( complete_lattice_lfp @ B @ G2 ) ) ) ) ) ) ) ) ) ) ) ).

% lfp_transfer_bounded
thf(fact_8060_ord_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp2 @ A )
      = ( ^ [Less2: A > A > $o] :
            ( complete_lattice_lfp @ ( ( list @ A ) > ( list @ A ) > $o )
            @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X25: list @ A] :
                ( ? [Y4: A,Ys3: list @ A] :
                    ( ( X17
                      = ( nil @ A ) )
                    & ( X25
                      = ( cons @ A @ Y4 @ Ys3 ) ) )
                | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                    ( ( X17
                      = ( cons @ A @ X3 @ Xs3 ) )
                    & ( X25
                      = ( cons @ A @ Y4 @ Ys3 ) )
                    & ( Less2 @ X3 @ Y4 ) )
                | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                    ( ( X17
                      = ( cons @ A @ X3 @ Xs3 ) )
                    & ( X25
                      = ( cons @ A @ Y4 @ Ys3 ) )
                    & ~ ( Less2 @ X3 @ Y4 )
                    & ~ ( Less2 @ Y4 @ X3 )
                    & ( P5 @ Xs3 @ Ys3 ) ) ) ) ) ) ).

% ord.lexordp_def
thf(fact_8061_ord_Olexordp__simps_I3_J,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Xs: list @ A,Y: A,Ys2: list @ A] :
      ( ( lexordp2 @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) )
      = ( ( Less @ X @ Y )
        | ( ~ ( Less @ Y @ X )
          & ( lexordp2 @ A @ Less @ Xs @ Ys2 ) ) ) ) ).

% ord.lexordp_simps(3)
thf(fact_8062_ord_Olexordp__simps_I2_J,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A] :
      ~ ( lexordp2 @ A @ Less @ Xs @ ( nil @ A ) ) ).

% ord.lexordp_simps(2)
thf(fact_8063_ord_Olexordp__simps_I1_J,axiom,
    ! [A: $tType,Less: A > A > $o,Ys2: list @ A] :
      ( ( lexordp2 @ A @ Less @ ( nil @ A ) @ Ys2 )
      = ( ( Ys2
         != ( nil @ A ) ) ) ) ).

% ord.lexordp_simps(1)
thf(fact_8064_ord_Olexordp_Osimps,axiom,
    ! [A: $tType] :
      ( ( lexordp2 @ A )
      = ( ^ [Less2: A > A > $o,A1: list @ A,A22: list @ A] :
            ( ? [Y4: A,Ys3: list @ A] :
                ( ( A1
                  = ( nil @ A ) )
                & ( A22
                  = ( cons @ A @ Y4 @ Ys3 ) ) )
            | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( A1
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A22
                  = ( cons @ A @ Y4 @ Ys3 ) )
                & ( Less2 @ X3 @ Y4 ) )
            | ? [X3: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( A1
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A22
                  = ( cons @ A @ Y4 @ Ys3 ) )
                & ~ ( Less2 @ X3 @ Y4 )
                & ~ ( Less2 @ Y4 @ X3 )
                & ( lexordp2 @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) ) ).

% ord.lexordp.simps
thf(fact_8065_ord_Olexordp_Ocases,axiom,
    ! [A: $tType,Less: A > A > $o,A12: list @ A,A23: list @ A] :
      ( ( lexordp2 @ A @ Less @ A12 @ A23 )
     => ( ( ( A12
            = ( nil @ A ) )
         => ! [Y2: A,Ys4: list @ A] :
              ( A23
             != ( cons @ A @ Y2 @ Ys4 ) ) )
       => ( ! [X2: A] :
              ( ? [Xs2: list @ A] :
                  ( A12
                  = ( cons @ A @ X2 @ Xs2 ) )
             => ! [Y2: A] :
                  ( ? [Ys4: list @ A] :
                      ( A23
                      = ( cons @ A @ Y2 @ Ys4 ) )
                 => ~ ( Less @ X2 @ Y2 ) ) )
         => ~ ! [X2: A,Y2: A,Xs2: list @ A] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs2 ) )
               => ! [Ys4: list @ A] :
                    ( ( A23
                      = ( cons @ A @ Y2 @ Ys4 ) )
                   => ( ~ ( Less @ X2 @ Y2 )
                     => ( ~ ( Less @ Y2 @ X2 )
                       => ~ ( lexordp2 @ A @ Less @ Xs2 @ Ys4 ) ) ) ) ) ) ) ) ).

% ord.lexordp.cases
thf(fact_8066_ord_Olexordp_ONil,axiom,
    ! [A: $tType,Less: A > A > $o,Y: A,Ys2: list @ A] : ( lexordp2 @ A @ Less @ ( nil @ A ) @ ( cons @ A @ Y @ Ys2 ) ) ).

% ord.lexordp.Nil
thf(fact_8067_ord_Olexordp__append__rightI,axiom,
    ! [A: $tType,Ys2: list @ A,Less: A > A > $o,Xs: list @ A] :
      ( ( Ys2
       != ( nil @ A ) )
     => ( lexordp2 @ A @ Less @ Xs @ ( append @ A @ Xs @ Ys2 ) ) ) ).

% ord.lexordp_append_rightI
thf(fact_8068_ord_Olexordp_Ocong,axiom,
    ! [A: $tType] :
      ( ( lexordp2 @ A )
      = ( lexordp2 @ A ) ) ).

% ord.lexordp.cong
thf(fact_8069_ord_Olexordp__irreflexive,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A] :
      ( ! [X2: A] :
          ~ ( Less @ X2 @ X2 )
     => ~ ( lexordp2 @ A @ Less @ Xs @ Xs ) ) ).

% ord.lexordp_irreflexive
thf(fact_8070_ord_Olexordp__append__leftD,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( lexordp2 @ A @ Less @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) )
     => ( ! [A4: A] :
            ~ ( Less @ A4 @ A4 )
       => ( lexordp2 @ A @ Less @ Us @ Vs ) ) ) ).

% ord.lexordp_append_leftD
thf(fact_8071_ord_Olexordp__append__leftI,axiom,
    ! [A: $tType,Less: A > A > $o,Us: list @ A,Vs: list @ A,Xs: list @ A] :
      ( ( lexordp2 @ A @ Less @ Us @ Vs )
     => ( lexordp2 @ A @ Less @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) ) ) ).

% ord.lexordp_append_leftI
thf(fact_8072_ord_Olexordp_OCons,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Y: A,Xs: list @ A,Ys2: list @ A] :
      ( ( Less @ X @ Y )
     => ( lexordp2 @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ).

% ord.lexordp.Cons
thf(fact_8073_ord_Olexordp_OCons__eq,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Y: A,Xs: list @ A,Ys2: list @ A] :
      ( ~ ( Less @ X @ Y )
     => ( ~ ( Less @ Y @ X )
       => ( ( lexordp2 @ A @ Less @ Xs @ Ys2 )
         => ( lexordp2 @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) ) ).

% ord.lexordp.Cons_eq
thf(fact_8074_ord_Olexordp__append__left__rightI,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Y: A,Us: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( Less @ X @ Y )
     => ( lexordp2 @ A @ Less @ ( append @ A @ Us @ ( cons @ A @ X @ Xs ) ) @ ( append @ A @ Us @ ( cons @ A @ Y @ Ys2 ) ) ) ) ).

% ord.lexordp_append_left_rightI
thf(fact_8075_lfp__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comple6319245703460814977attice @ B )
        & ( comple6319245703460814977attice @ A ) )
     => ! [Alpha: A > B,F2: A > A,G2: B > B] :
          ( ( order_sup_continuous @ A @ B @ Alpha )
         => ( ( order_sup_continuous @ A @ A @ F2 )
           => ( ( order_sup_continuous @ B @ B @ G2 )
             => ( ! [X2: B] : ( ord_less_eq @ B @ ( Alpha @ ( bot_bot @ A ) ) @ ( G2 @ X2 ) )
               => ( ! [X2: A] :
                      ( ( ord_less_eq @ A @ X2 @ ( complete_lattice_lfp @ A @ F2 ) )
                     => ( ( Alpha @ ( F2 @ X2 ) )
                        = ( G2 @ ( Alpha @ X2 ) ) ) )
                 => ( ( Alpha @ ( complete_lattice_lfp @ A @ F2 ) )
                    = ( complete_lattice_lfp @ B @ G2 ) ) ) ) ) ) ) ) ).

% lfp_transfer
thf(fact_8076_bounded__bilinear_Ointro,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod: A > B > C] :
          ( ! [A4: A,A20: A,B4: B] :
              ( ( Prod @ ( plus_plus @ A @ A4 @ A20 ) @ B4 )
              = ( plus_plus @ C @ ( Prod @ A4 @ B4 ) @ ( Prod @ A20 @ B4 ) ) )
         => ( ! [A4: A,B4: B,B14: B] :
                ( ( Prod @ A4 @ ( plus_plus @ B @ B4 @ B14 ) )
                = ( plus_plus @ C @ ( Prod @ A4 @ B4 ) @ ( Prod @ A4 @ B14 ) ) )
           => ( ! [R: real,A4: A,B4: B] :
                  ( ( Prod @ ( real_V8093663219630862766scaleR @ A @ R @ A4 ) @ B4 )
                  = ( real_V8093663219630862766scaleR @ C @ R @ ( Prod @ A4 @ B4 ) ) )
             => ( ! [A4: A,R: real,B4: B] :
                    ( ( Prod @ A4 @ ( real_V8093663219630862766scaleR @ B @ R @ B4 ) )
                    = ( real_V8093663219630862766scaleR @ C @ R @ ( Prod @ A4 @ B4 ) ) )
               => ( ? [K7: real] :
                    ! [A4: A,B4: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod @ A4 @ B4 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A4 ) @ ( real_V7770717601297561774m_norm @ B @ B4 ) ) @ K7 ) )
                 => ( real_V2442710119149674383linear @ A @ B @ C @ Prod ) ) ) ) ) ) ) ).

% bounded_bilinear.intro
thf(fact_8077_bounded__bilinear__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ( ( real_V2442710119149674383linear @ A @ B @ C )
        = ( ^ [Prod2: A > B > C] :
              ( ! [A3: A,A27: A,B3: B] :
                  ( ( Prod2 @ ( plus_plus @ A @ A3 @ A27 ) @ B3 )
                  = ( plus_plus @ C @ ( Prod2 @ A3 @ B3 ) @ ( Prod2 @ A27 @ B3 ) ) )
              & ! [A3: A,B3: B,B16: B] :
                  ( ( Prod2 @ A3 @ ( plus_plus @ B @ B3 @ B16 ) )
                  = ( plus_plus @ C @ ( Prod2 @ A3 @ B3 ) @ ( Prod2 @ A3 @ B16 ) ) )
              & ! [R5: real,A3: A,B3: B] :
                  ( ( Prod2 @ ( real_V8093663219630862766scaleR @ A @ R5 @ A3 ) @ B3 )
                  = ( real_V8093663219630862766scaleR @ C @ R5 @ ( Prod2 @ A3 @ B3 ) ) )
              & ! [A3: A,R5: real,B3: B] :
                  ( ( Prod2 @ A3 @ ( real_V8093663219630862766scaleR @ B @ R5 @ B3 ) )
                  = ( real_V8093663219630862766scaleR @ C @ R5 @ ( Prod2 @ A3 @ B3 ) ) )
              & ? [K5: real] :
                ! [A3: A,B3: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A3 @ B3 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( real_V7770717601297561774m_norm @ B @ B3 ) ) @ K5 ) ) ) ) ) ) ).

% bounded_bilinear_def
thf(fact_8078_bounded__bilinear_Obounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod )
         => ? [K9: real] :
            ! [A18: A,B10: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod @ A18 @ B10 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A18 ) @ ( real_V7770717601297561774m_norm @ B @ B10 ) ) @ K9 ) ) ) ) ).

% bounded_bilinear.bounded
thf(fact_8079_bounded__bilinear_Ozero__right,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [Prod: A > B > C,A2: A] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod )
         => ( ( Prod @ A2 @ ( zero_zero @ B ) )
            = ( zero_zero @ C ) ) ) ) ).

% bounded_bilinear.zero_right
thf(fact_8080_bounded__bilinear_Ozero__left,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [Prod: A > B > C,B2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod )
         => ( ( Prod @ ( zero_zero @ A ) @ B2 )
            = ( zero_zero @ C ) ) ) ) ).

% bounded_bilinear.zero_left
thf(fact_8081_bounded__bilinear_Otendsto__right__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod: A > B > C,F2: D > B,F4: filter @ D,C2: A] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod )
         => ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ C
              @ ^ [X3: D] : ( Prod @ C2 @ ( F2 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
              @ F4 ) ) ) ) ).

% bounded_bilinear.tendsto_right_zero
thf(fact_8082_bounded__bilinear_Otendsto__left__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod: A > B > C,F2: D > A,F4: filter @ D,C2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod )
         => ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ C
              @ ^ [X3: D] : ( Prod @ ( F2 @ X3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
              @ F4 ) ) ) ) ).

% bounded_bilinear.tendsto_left_zero
thf(fact_8083_bounded__bilinear_Otendsto__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod: A > B > C,F2: D > A,F4: filter @ D,G2: D > B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod )
         => ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( ( filterlim @ D @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
             => ( filterlim @ D @ C
                @ ^ [X3: D] : ( Prod @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F4 ) ) ) ) ) ).

% bounded_bilinear.tendsto_zero
thf(fact_8084_bounded__bilinear_Ononneg__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [A18: A,B10: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod @ A18 @ B10 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A18 ) @ ( real_V7770717601297561774m_norm @ B @ B10 ) ) @ K9 ) ) ) ) ) ).

% bounded_bilinear.nonneg_bounded
thf(fact_8085_bounded__bilinear_Opos__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [A18: A,B10: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod @ A18 @ B10 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A18 ) @ ( real_V7770717601297561774m_norm @ B @ B10 ) ) @ K9 ) ) ) ) ) ).

% bounded_bilinear.pos_bounded
thf(fact_8086_cSUP__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A5: set @ C,B6: C > ( set @ D ),F2: D > B] :
          ( ( A5
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X2: C] :
                ( ( member @ C @ X2 @ A5 )
               => ( ( B6 @ X2 )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit941137186595557371_above @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image @ C @ ( set @ B )
                    @ ^ [X3: C] : ( image @ D @ B @ F2 @ ( B6 @ X3 ) )
                    @ A5 ) ) )
             => ( ( complete_Sup_Sup @ B @ ( image @ D @ B @ F2 @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ B6 @ A5 ) ) ) )
                = ( complete_Sup_Sup @ B
                  @ ( image @ C @ B
                    @ ^ [X3: C] : ( complete_Sup_Sup @ B @ ( image @ D @ B @ F2 @ ( B6 @ X3 ) ) )
                    @ A5 ) ) ) ) ) ) ) ).

% cSUP_UNION
thf(fact_8087_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A5 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ) ) ).

% mono_cSup
thf(fact_8088_bdd__above__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A5: set @ A] : ( condit941137186595557371_above @ A @ A5 ) ) ).

% bdd_above_top
thf(fact_8089_bdd__above_OI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A,M5: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ A5 )
             => ( ord_less_eq @ A @ X2 @ M5 ) )
         => ( condit941137186595557371_above @ A @ A5 ) ) ) ).

% bdd_above.I
thf(fact_8090_bdd__above__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit941137186595557371_above @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bdd_above_empty
thf(fact_8091_bdd__above__insert,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A2: A,A5: set @ A] :
          ( ( condit941137186595557371_above @ A @ ( insert2 @ A @ A2 @ A5 ) )
          = ( condit941137186595557371_above @ A @ A5 ) ) ) ).

% bdd_above_insert
thf(fact_8092_bdd__above__Icc,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit941137186595557371_above @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ).

% bdd_above_Icc
thf(fact_8093_bdd__above__Un,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( condit941137186595557371_above @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
          = ( ( condit941137186595557371_above @ A @ A5 )
            & ( condit941137186595557371_above @ A @ B6 ) ) ) ) ).

% bdd_above_Un
thf(fact_8094_bdd__above__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit941137186595557371_above @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ).

% bdd_above_Ico
thf(fact_8095_bdd__above__Iio,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A] : ( condit941137186595557371_above @ A @ ( set_ord_lessThan @ A @ B2 ) ) ) ).

% bdd_above_Iio
thf(fact_8096_bdd__above__Iic,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A] : ( condit941137186595557371_above @ A @ ( set_ord_atMost @ A @ B2 ) ) ) ).

% bdd_above_Iic
thf(fact_8097_bdd__above__Ioo,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit941137186595557371_above @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ).

% bdd_above_Ioo
thf(fact_8098_bdd__above__Ioc,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit941137186595557371_above @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ).

% bdd_above_Ioc
thf(fact_8099_bdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F2: B > A,G2: B > A,A5: set @ B] :
          ( ( condit941137186595557371_above @ A
            @ ( image @ B @ A
              @ ^ [X3: B] : ( sup_sup @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ A5 ) )
          = ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
            & ( condit941137186595557371_above @ A @ ( image @ B @ A @ G2 @ A5 ) ) ) ) ) ).

% bdd_above_image_sup
thf(fact_8100_bdd__above__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [I6: set @ B,A5: B > ( set @ A )] :
          ( ( finite_finite @ B @ I6 )
         => ( ( condit941137186595557371_above @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A5 @ I6 ) ) )
            = ( ! [X3: B] :
                  ( ( member @ B @ X3 @ I6 )
                 => ( condit941137186595557371_above @ A @ ( A5 @ X3 ) ) ) ) ) ) ) ).

% bdd_above_UN
thf(fact_8101_cSup__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( B6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A5 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ B6 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A5 )
                      & ( ord_less_eq @ A @ B4 @ X5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ B6 ) @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ) ).

% cSup_mono
thf(fact_8102_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S2 )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ S2 ) @ A2 )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ord_less_eq @ A @ X3 @ A2 ) ) ) ) ) ) ) ).

% cSup_le_iff
thf(fact_8103_bdd__above__finite,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( condit941137186595557371_above @ A @ A5 ) ) ) ).

% bdd_above_finite
thf(fact_8104_bdd__above__nat,axiom,
    ( ( condit941137186595557371_above @ nat )
    = ( finite_finite @ nat ) ) ).

% bdd_above_nat
thf(fact_8105_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Y: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X8 )
           => ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X8 ) )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ X8 )
                    & ( ord_less @ A @ Y @ X3 ) ) ) ) ) ) ) ).

% less_cSup_iff
thf(fact_8106_cSUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A5: set @ B,Y: A,I: B] :
          ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
         => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ Y )
           => ( ( member @ B @ I @ A5 )
             => ( ord_less @ A @ ( F2 @ I ) @ Y ) ) ) ) ) ).

% cSUP_lessD
thf(fact_8107_bdd__above__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( condit941137186595557371_above @ A @ A5 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% bdd_above_Int1
thf(fact_8108_bdd__above__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( condit941137186595557371_above @ A @ B6 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% bdd_above_Int2
thf(fact_8109_bdd__above__image__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ A5 )
           => ( condit941137186595557371_above @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ).

% bdd_above_image_mono
thf(fact_8110_cSup__upper2,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X8: set @ A,Y: A] :
          ( ( member @ A @ X @ X8 )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( ( condit941137186595557371_above @ A @ X8 )
             => ( ord_less_eq @ A @ Y @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ) ).

% cSup_upper2
thf(fact_8111_cSup__upper,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X8: set @ A] :
          ( ( member @ A @ X @ X8 )
         => ( ( condit941137186595557371_above @ A @ X8 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ).

% cSup_upper
thf(fact_8112_bdd__above_OE,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A] :
          ( ( condit941137186595557371_above @ A @ A5 )
         => ~ ! [M10: A] :
                ~ ! [X5: A] :
                    ( ( member @ A @ X5 @ A5 )
                   => ( ord_less_eq @ A @ X5 @ M10 ) ) ) ) ).

% bdd_above.E
thf(fact_8113_bdd__above_Ounfold,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit941137186595557371_above @ A )
        = ( ^ [A7: set @ A] :
            ? [M8: A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ A7 )
             => ( ord_less_eq @ A @ X3 @ M8 ) ) ) ) ) ).

% bdd_above.unfold
thf(fact_8114_bdd__above__mono,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( condit941137186595557371_above @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
           => ( condit941137186595557371_above @ A @ A5 ) ) ) ) ).

% bdd_above_mono
thf(fact_8115_bdd__above_OI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ B,F2: B > A,M5: A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ X2 ) @ M5 ) )
         => ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ).

% bdd_above.I2
thf(fact_8116_cSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: B,A5: set @ B,F2: B > A] :
          ( ( member @ B @ X @ A5 )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
           => ( ord_less_eq @ A @ ( F2 @ X ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% cSUP_upper
thf(fact_8117_cSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A5: set @ B,X: B,U: A] :
          ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
         => ( ( member @ B @ X @ A5 )
           => ( ( ord_less_eq @ A @ U @ ( F2 @ X ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ) ).

% cSUP_upper2
thf(fact_8118_cSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,G2: C > A,B6: set @ C,F2: B > A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ G2 @ B6 ) )
           => ( ! [N2: B] :
                  ( ( member @ B @ N2 @ A5 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ B6 )
                      & ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G2 @ X5 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G2 @ B6 ) ) ) ) ) ) ) ).

% cSUP_mono
thf(fact_8119_cSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,U: A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A5 )
                   => ( ord_less_eq @ A @ ( F2 @ X3 ) @ U ) ) ) ) ) ) ) ).

% cSUP_le_iff
thf(fact_8120_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ B6 )
           => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ) ).

% cSup_subset_mono
thf(fact_8121_cSup__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X8 )
           => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ A2 @ X8 ) )
              = ( sup_sup @ A @ A2 @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ) ).

% cSup_insert
thf(fact_8122_cSup__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( condit941137186595557371_above @ A @ X8 )
         => ( ( ( X8
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ A2 @ X8 ) )
                = A2 ) )
            & ( ( X8
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ A2 @ X8 ) )
                = ( sup_sup @ A @ A2 @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ) ) ).

% cSup_insert_If
thf(fact_8123_cSup__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A5 )
           => ( ( B6
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit941137186595557371_above @ A @ B6 )
               => ( ( complete_Sup_Sup @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
                  = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ) ) ) ).

% cSup_union_distrib
thf(fact_8124_less__cSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A5: set @ B,F2: B > A,A2: A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
              = ( ? [X3: B] :
                    ( ( member @ B @ X3 @ A5 )
                    & ( ord_less @ A @ A2 @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% less_cSUP_iff
thf(fact_8125_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,G2: B > A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
           => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ G2 @ A5 ) )
             => ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G2 @ A5 ) ) )
                = ( complete_Sup_Sup @ A
                  @ ( image @ B @ A
                    @ ^ [A3: B] : ( sup_sup @ A @ ( F2 @ A3 ) @ ( G2 @ A3 ) )
                    @ A5 ) ) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
thf(fact_8126_cSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,G2: B > A,B6: set @ B,F2: B > A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ G2 @ B6 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B6 )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A5 )
                   => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
               => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G2 @ B6 ) ) ) ) ) ) ) ) ).

% cSUP_subset_mono
thf(fact_8127_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( condit941137186595557371_above @ A @ A5 )
         => ( ( condit941137186595557371_above @ A @ B6 )
           => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B6 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) @ ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B6 ) ) ) ) ) ) ) ).

% cSup_inter_less_eq
thf(fact_8128_cSUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,A2: B] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ ( insert2 @ B @ A2 @ A5 ) ) )
              = ( sup_sup @ A @ ( F2 @ A2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ) ).

% cSUP_insert
thf(fact_8129_cSUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,B6: set @ B] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A5 ) )
           => ( ( B6
               != ( bot_bot @ ( set @ B ) ) )
             => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ B6 ) )
               => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A5 @ B6 ) ) )
                  = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ B6 ) ) ) ) ) ) ) ) ) ).

% cSUP_union
thf(fact_8130_cSup__cInf,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S2 )
           => ( ( complete_Sup_Sup @ A @ S2 )
              = ( complete_Inf_Inf @ A
                @ ( collect @ A
                  @ ^ [X3: A] :
                    ! [Y4: A] :
                      ( ( member @ A @ Y4 @ S2 )
                     => ( ord_less_eq @ A @ Y4 @ X3 ) ) ) ) ) ) ) ) ).

% cSup_cInf
thf(fact_8131_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A5: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ A5 @ I6 ) )
           => ( ( I6
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image @ C @ B
                    @ ^ [X3: C] : ( F2 @ ( A5 @ X3 ) )
                    @ I6 ) )
                @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A5 @ I6 ) ) ) ) ) ) ) ) ).

% mono_cSUP
thf(fact_8132_cINF__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A5: set @ C,B6: C > ( set @ D ),F2: D > B] :
          ( ( A5
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X2: C] :
                ( ( member @ C @ X2 @ A5 )
               => ( ( B6 @ X2 )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit1013018076250108175_below @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image @ C @ ( set @ B )
                    @ ^ [X3: C] : ( image @ D @ B @ F2 @ ( B6 @ X3 ) )
                    @ A5 ) ) )
             => ( ( complete_Inf_Inf @ B @ ( image @ D @ B @ F2 @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ B6 @ A5 ) ) ) )
                = ( complete_Inf_Inf @ B
                  @ ( image @ C @ B
                    @ ^ [X3: C] : ( complete_Inf_Inf @ B @ ( image @ D @ B @ F2 @ ( B6 @ X3 ) ) )
                    @ A5 ) ) ) ) ) ) ) ).

% cINF_UNION
thf(fact_8133_list__ex__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > $o ) @ ( ( list @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ A5 )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( list_ex @ A )
      @ ( list_ex @ B ) ) ).

% list_ex_transfer
thf(fact_8134_bdd__below__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A5: set @ A] : ( condit1013018076250108175_below @ A @ A5 ) ) ).

% bdd_below_bot
thf(fact_8135_bdd__below_OI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A,M5: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ A5 )
             => ( ord_less_eq @ A @ M5 @ X2 ) )
         => ( condit1013018076250108175_below @ A @ A5 ) ) ) ).

% bdd_below.I
thf(fact_8136_bdd__belowI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A,M: A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ A5 )
             => ( ord_less_eq @ A @ M @ X2 ) )
         => ( condit1013018076250108175_below @ A @ A5 ) ) ) ).

% bdd_belowI
thf(fact_8137_bdd__below__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit1013018076250108175_below @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bdd_below_empty
thf(fact_8138_bdd__below__insert,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A2: A,A5: set @ A] :
          ( ( condit1013018076250108175_below @ A @ ( insert2 @ A @ A2 @ A5 ) )
          = ( condit1013018076250108175_below @ A @ A5 ) ) ) ).

% bdd_below_insert
thf(fact_8139_bdd__below__Icc,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit1013018076250108175_below @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ).

% bdd_below_Icc
thf(fact_8140_bdd__below__Un,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( condit1013018076250108175_below @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
          = ( ( condit1013018076250108175_below @ A @ A5 )
            & ( condit1013018076250108175_below @ A @ B6 ) ) ) ) ).

% bdd_below_Un
thf(fact_8141_bdd__below__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit1013018076250108175_below @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ).

% bdd_below_Ico
thf(fact_8142_bdd__below__Ioi,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( condit1013018076250108175_below @ A @ ( set_ord_greaterThan @ A @ A2 ) ) ) ).

% bdd_below_Ioi
thf(fact_8143_bdd__below__Ioo,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit1013018076250108175_below @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ).

% bdd_below_Ioo
thf(fact_8144_bdd__below__Ioc,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit1013018076250108175_below @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ).

% bdd_below_Ioc
thf(fact_8145_bdd__below__Ici,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( condit1013018076250108175_below @ A @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% bdd_below_Ici
thf(fact_8146_list__ex__simps_I1_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( list_ex @ A @ P @ ( cons @ A @ X @ Xs ) )
      = ( ( P @ X )
        | ( list_ex @ A @ P @ Xs ) ) ) ).

% list_ex_simps(1)
thf(fact_8147_list__ex__simps_I2_J,axiom,
    ! [A: $tType,P: A > $o] :
      ~ ( list_ex @ A @ P @ ( nil @ A ) ) ).

% list_ex_simps(2)
thf(fact_8148_list__ex__append,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A] :
      ( ( list_ex @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
      = ( ( list_ex @ A @ P @ Xs )
        | ( list_ex @ A @ P @ Ys2 ) ) ) ).

% list_ex_append
thf(fact_8149_list__ex__rev,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( list_ex @ A @ P @ ( rev @ A @ Xs ) )
      = ( list_ex @ A @ P @ Xs ) ) ).

% list_ex_rev
thf(fact_8150_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F2: B > A,G2: B > A,A5: set @ B] :
          ( ( condit1013018076250108175_below @ A
            @ ( image @ B @ A
              @ ^ [X3: B] : ( inf_inf @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
              @ A5 ) )
          = ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A5 ) )
            & ( condit1013018076250108175_below @ A @ ( image @ B @ A @ G2 @ A5 ) ) ) ) ) ).

% bdd_below_image_inf
thf(fact_8151_bdd__below__uminus,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X8: set @ A] :
          ( ( condit1013018076250108175_below @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ X8 ) )
          = ( condit941137186595557371_above @ A @ X8 ) ) ) ).

% bdd_below_uminus
thf(fact_8152_bdd__above__uminus,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X8: set @ A] :
          ( ( condit941137186595557371_above @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ X8 ) )
          = ( condit1013018076250108175_below @ A @ X8 ) ) ) ).

% bdd_above_uminus
thf(fact_8153_bdd__below__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [I6: set @ B,A5: B > ( set @ A )] :
          ( ( finite_finite @ B @ I6 )
         => ( ( condit1013018076250108175_below @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A5 @ I6 ) ) )
            = ( ! [X3: B] :
                  ( ( member @ B @ X3 @ I6 )
                 => ( condit1013018076250108175_below @ A @ ( A5 @ X3 ) ) ) ) ) ) ) ).

% bdd_below_UN
thf(fact_8154_bdd__above__image__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ A5 )
           => ( condit941137186595557371_above @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ).

% bdd_above_image_antimono
thf(fact_8155_bdd__below__image__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ A5 )
           => ( condit1013018076250108175_below @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ).

% bdd_below_image_antimono
thf(fact_8156_less__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A5: set @ B,Y: A,I: B] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A5 ) )
         => ( ( ord_less @ A @ Y @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
           => ( ( member @ B @ I @ A5 )
             => ( ord_less @ A @ Y @ ( F2 @ I ) ) ) ) ) ) ).

% less_cINF_D
thf(fact_8157_cINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A5: set @ B,X: B,U: A] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A5 ) )
         => ( ( member @ B @ X @ A5 )
           => ( ( ord_less_eq @ A @ ( F2 @ X ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ) ) ).

% cINF_lower2
thf(fact_8158_cINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A5: set @ B,X: B] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A5 ) )
         => ( ( member @ B @ X @ A5 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( F2 @ X ) ) ) ) ) ).

% cINF_lower
thf(fact_8159_bdd__belowI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ B,M: A,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ord_less_eq @ A @ M @ ( F2 @ X2 ) ) )
         => ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ).

% bdd_belowI2
thf(fact_8160_bdd__below_OI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ B,M5: A,F2: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A5 )
             => ( ord_less_eq @ A @ M5 @ ( F2 @ X2 ) ) )
         => ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ).

% bdd_below.I2
thf(fact_8161_cInf__lower2,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X8: set @ A,Y: A] :
          ( ( member @ A @ X @ X8 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( condit1013018076250108175_below @ A @ X8 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X8 ) @ Y ) ) ) ) ) ).

% cInf_lower2
thf(fact_8162_cInf__lower,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X8: set @ A] :
          ( ( member @ A @ X @ X8 )
         => ( ( condit1013018076250108175_below @ A @ X8 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X8 ) @ X ) ) ) ) ).

% cInf_lower
thf(fact_8163_bdd__below__mono,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( condit1013018076250108175_below @ A @ B6 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
           => ( condit1013018076250108175_below @ A @ A5 ) ) ) ) ).

% bdd_below_mono
thf(fact_8164_bdd__below_Ounfold,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit1013018076250108175_below @ A )
        = ( ^ [A7: set @ A] :
            ? [M8: A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ A7 )
             => ( ord_less_eq @ A @ M8 @ X3 ) ) ) ) ) ).

% bdd_below.unfold
thf(fact_8165_bdd__below_OE,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A5 )
         => ~ ! [M10: A] :
                ~ ! [X5: A] :
                    ( ( member @ A @ X5 @ A5 )
                   => ( ord_less_eq @ A @ M10 @ X5 ) ) ) ) ).

% bdd_below.E
thf(fact_8166_bdd__below__image__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ A5 )
           => ( condit1013018076250108175_below @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ).

% bdd_below_image_mono
thf(fact_8167_list__ex__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,F2: A > $o,G2: A > $o] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Ys2 ) )
           => ( ( F2 @ X2 )
              = ( G2 @ X2 ) ) )
       => ( ( list_ex @ A @ F2 @ Xs )
          = ( list_ex @ A @ G2 @ Ys2 ) ) ) ) ).

% list_ex_cong
thf(fact_8168_bdd__below__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( condit1013018076250108175_below @ A @ B6 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% bdd_below_Int2
thf(fact_8169_bdd__below__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A5 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B6 ) ) ) ) ).

% bdd_below_Int1
thf(fact_8170_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Y: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X8 )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X8 ) @ Y )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ X8 )
                    & ( ord_less @ A @ X3 @ Y ) ) ) ) ) ) ) ).

% cInf_less_iff
thf(fact_8171_bdd__below__finite,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( condit1013018076250108175_below @ A @ A5 ) ) ) ).

% bdd_below_finite
thf(fact_8172_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S2 )
           => ( ( ord_less_eq @ A @ A2 @ ( complete_Inf_Inf @ A @ S2 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ord_less_eq @ A @ A2 @ X3 ) ) ) ) ) ) ) ).

% le_cInf_iff
thf(fact_8173_cInf__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B6: set @ A,A5: set @ A] :
          ( ( B6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A5 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ B6 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A5 )
                      & ( ord_less_eq @ A @ X5 @ B4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ) ) ).

% cInf_mono
thf(fact_8174_le__cINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,U: A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A5 ) )
           => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A5 )
                   => ( ord_less_eq @ A @ U @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% le_cINF_iff
thf(fact_8175_cINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B6: set @ B,F2: C > A,A5: set @ C,G2: B > A] :
          ( ( B6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ C @ A @ F2 @ A5 ) )
           => ( ! [M4: B] :
                  ( ( member @ B @ M4 @ B6 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ A5 )
                      & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G2 @ M4 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ B6 ) ) ) ) ) ) ) ).

% cINF_mono
thf(fact_8176_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ B6 )
           => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B6 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ B6 ) @ ( complete_Inf_Inf @ A @ A5 ) ) ) ) ) ) ).

% cInf_superset_mono
thf(fact_8177_cInf__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( condit1013018076250108175_below @ A @ X8 )
         => ( ( ( X8
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ A2 @ X8 ) )
                = A2 ) )
            & ( ( X8
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ A2 @ X8 ) )
                = ( inf_inf @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ) ) ).

% cInf_insert_If
thf(fact_8178_cInf__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X8 )
           => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ A2 @ X8 ) )
              = ( inf_inf @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ) ).

% cInf_insert
thf(fact_8179_cInf__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ A,B6: set @ A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A5 )
           => ( ( B6
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit1013018076250108175_below @ A @ B6 )
               => ( ( complete_Inf_Inf @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B6 ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B6 ) ) ) ) ) ) ) ) ).

% cInf_union_distrib
thf(fact_8180_not__in__connected__cases,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A] :
          ( ( topolo1966860045006549960nected @ A @ S2 )
         => ( ~ ( member @ A @ X @ S2 )
           => ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( ( condit941137186595557371_above @ A @ S2 )
                 => ~ ! [Y5: A] :
                        ( ( member @ A @ Y5 @ S2 )
                       => ( ord_less_eq @ A @ Y5 @ X ) ) )
               => ~ ( ( condit1013018076250108175_below @ A @ S2 )
                   => ~ ! [Y5: A] :
                          ( ( member @ A @ Y5 @ S2 )
                         => ( ord_less_eq @ A @ X @ Y5 ) ) ) ) ) ) ) ) ).

% not_in_connected_cases
thf(fact_8181_cINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A5: set @ B,F2: B > A,A2: A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A5 ) )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ A2 )
              = ( ? [X3: B] :
                    ( ( member @ B @ X3 @ A5 )
                    & ( ord_less @ A @ ( F2 @ X3 ) @ A2 ) ) ) ) ) ) ) ).

% cINF_less_iff

% Type constructors (746)
thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_1,axiom,
    ! [A15: $tType] : ( bounded_lattice @ ( filter @ A15 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_2,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_3,axiom,
    ! [A15: $tType] : ( bounded_lattice @ ( set @ A15 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_4,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( bounded_lattice @ A28 )
     => ( bounded_lattice @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( comple592849572758109894attice @ A28 )
     => ( counta4013691401010221786attice @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( comple6319245703460814977attice @ A28 )
     => ( condit1219197933456340205attice @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( counta3822494911875563373attice @ A28 )
     => ( counta3822494911875563373attice @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( comple592849572758109894attice @ A28 )
     => ( comple592849572758109894attice @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( bounded_lattice @ A28 )
     => ( bounde4967611905675639751up_bot @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( bounded_lattice @ A28 )
     => ( bounde4346867609351753570nf_top @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( comple6319245703460814977attice @ A28 )
     => ( comple6319245703460814977attice @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( boolea8198339166811842893lgebra @ A28 )
     => ( boolea8198339166811842893lgebra @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( semilattice_sup @ A28 )
     => ( semilattice_sup @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( semilattice_inf @ A28 )
     => ( semilattice_inf @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( distrib_lattice @ A28 )
     => ( distrib_lattice @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( order_top @ A28 )
     => ( order_top @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( order_bot @ A28 )
     => ( order_bot @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( preorder @ A28 )
     => ( preorder @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( lattice @ A28 )
     => ( lattice @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( order @ A28 )
     => ( order @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Orderings_Otop,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( top @ A28 )
     => ( top @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( ord @ A28 )
     => ( ord @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Orderings_Obot,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( bot @ A28 )
     => ( bot @ ( A15 > A28 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( uminus @ A28 )
     => ( uminus @ ( A15 > A28 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_5,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_6,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_7,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Lattices_Odistrib__lattice_8,axiom,
    distrib_lattice @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom @ int ).

thf(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_14,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_15,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_16,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_17,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_18,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_19,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_20,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_21,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_22,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_23,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_24,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_25,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_26,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_27,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_28,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_29,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_30,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_31,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_32,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_33,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_34,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_35,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_36,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_37,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_38,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_39,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_40,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_41,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_42,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_43,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_44,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_45,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_46,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_47,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_48,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_49,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_50,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_51,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_52,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_53,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_54,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_55,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_56,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_57,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Lattices_Odistrib__lattice_58,axiom,
    distrib_lattice @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_59,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_60,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_61,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_62,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_63,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_64,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_65,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_66,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_67,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_68,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_69,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_70,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_71,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_72,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_73,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_74,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_75,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_76,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_77,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_78,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_79,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_80,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_81,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_82,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_83,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_84,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_85,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_86,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_87,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_88,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_89,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_90,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_91,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom_92,axiom,
    semidom @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_93,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Orderings_Obot_94,axiom,
    bot @ nat ).

thf(tcon_Nat_Onat___Power_Opower_95,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_96,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_97,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_98,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_99,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_100,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_101,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_102,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_103,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_104,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_105,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_106,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_107,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_108,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_109,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_110,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_111,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_112,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_113,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_114,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_115,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_116,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_117,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_118,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_119,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_120,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_121,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_122,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_123,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_124,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_125,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_126,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_127,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_128,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_129,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_130,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_131,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_132,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_133,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_134,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_135,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_136,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_137,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_138,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Lattices_Odistrib__lattice_139,axiom,
    distrib_lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_140,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_141,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_142,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_143,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_144,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_145,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_146,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_147,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_148,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_149,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_150,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_151,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_152,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_153,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_154,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_155,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_156,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_157,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_158,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_159,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_160,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_161,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_162,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_163,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_164,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_165,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_166,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_167,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_168,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_169,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_170,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_171,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_172,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_173,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_174,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_175,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_176,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_177,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_178,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom_179,axiom,
    semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_180,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_181,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_182,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_183,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_184,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_185,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_186,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_187,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_188,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_189,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_190,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_191,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_192,axiom,
    ! [A15: $tType] : ( counta4013691401010221786attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_193,axiom,
    ! [A15: $tType] : ( condit1219197933456340205attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_194,axiom,
    ! [A15: $tType] : ( counta3822494911875563373attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_195,axiom,
    ! [A15: $tType] : ( comple592849572758109894attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_196,axiom,
    ! [A15: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_197,axiom,
    ! [A15: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_198,axiom,
    ! [A15: $tType] : ( comple6319245703460814977attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_199,axiom,
    ! [A15: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_200,axiom,
    ! [A15: $tType] : ( semilattice_sup @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_201,axiom,
    ! [A15: $tType] : ( semilattice_inf @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_202,axiom,
    ! [A15: $tType] : ( distrib_lattice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_203,axiom,
    ! [A15: $tType] : ( order_top @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_204,axiom,
    ! [A15: $tType] : ( order_bot @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_205,axiom,
    ! [A15: $tType] : ( preorder @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_206,axiom,
    ! [A15: $tType] : ( lattice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_207,axiom,
    ! [A15: $tType] : ( order @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Otop_208,axiom,
    ! [A15: $tType] : ( top @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_209,axiom,
    ! [A15: $tType] : ( ord @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Obot_210,axiom,
    ! [A15: $tType] : ( bot @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_211,axiom,
    ! [A15: $tType] : ( uminus @ ( set @ A15 ) ) ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_212,axiom,
    counta4013691401010221786attice @ $o ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_213,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_214,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_215,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_216,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_217,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_218,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_219,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_220,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_221,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_222,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_223,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_224,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_225,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_226,axiom,
    distrib_lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_227,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_228,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_229,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_230,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_231,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_232,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Otop_233,axiom,
    top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_234,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Orderings_Obot_235,axiom,
    bot @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_236,axiom,
    uminus @ $o ).

thf(tcon_List_Olist___Nat_Osize_237,axiom,
    ! [A15: $tType] : ( size @ ( list @ A15 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_238,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_239,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_240,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_241,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_242,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_243,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_244,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_245,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_246,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_247,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_248,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_249,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_250,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_251,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_252,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_253,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_254,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_255,axiom,
    linord4140545234300271783up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_256,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_257,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_258,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_259,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_260,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_261,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Osgn__div__norm,axiom,
    real_V6567297691418259687v_norm @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_262,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_263,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_264,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_265,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_266,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_267,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_268,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_269,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_270,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_271,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_272,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_273,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_274,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_275,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_276,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_277,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_278,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_279,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_280,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_281,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_282,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Lattices_Odistrib__lattice_283,axiom,
    distrib_lattice @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_284,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_285,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_286,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_287,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_288,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_289,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_290,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_291,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_292,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_293,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_294,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_295,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_296,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_297,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_298,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_299,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_300,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_301,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_302,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_303,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_304,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_305,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_306,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_307,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_308,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_309,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_310,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_311,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_312,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_313,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_314,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_315,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_316,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_317,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_318,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_319,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_320,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_321,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_322,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_323,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_324,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_325,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_326,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_327,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_328,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom_329,axiom,
    semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_330,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_331,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_332,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_333,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_334,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_335,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_336,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_337,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_338,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_339,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_340,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_341,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_342,axiom,
    dvd @ real ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_343,axiom,
    ! [A15: $tType] : ( condit1219197933456340205attice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_344,axiom,
    ! [A15: $tType] : ( counta3822494911875563373attice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_345,axiom,
    ! [A15: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_346,axiom,
    ! [A15: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_347,axiom,
    ! [A15: $tType] : ( comple6319245703460814977attice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_348,axiom,
    ! [A15: $tType] : ( semilattice_sup @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_349,axiom,
    ! [A15: $tType] : ( semilattice_inf @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_350,axiom,
    ! [A15: $tType] : ( distrib_lattice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_351,axiom,
    ! [A15: $tType] : ( order_top @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_352,axiom,
    ! [A15: $tType] : ( order_bot @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_353,axiom,
    ! [A15: $tType] : ( preorder @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_354,axiom,
    ! [A15: $tType] : ( lattice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_355,axiom,
    ! [A15: $tType] : ( order @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Otop_356,axiom,
    ! [A15: $tType] : ( top @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_357,axiom,
    ! [A15: $tType] : ( ord @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Obot_358,axiom,
    ! [A15: $tType] : ( bot @ ( filter @ A15 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_359,axiom,
    ! [A15: $tType] : ( size @ ( option @ A15 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_360,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_361,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_362,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_363,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_364,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_365,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_366,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_367,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_368,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_369,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_370,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_371,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_372,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_373,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_374,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_375,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_376,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_377,axiom,
    topolo8386298272705272623_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_378,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Osgn__div__norm_379,axiom,
    real_V6567297691418259687v_norm @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_380,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_381,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_382,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_383,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_384,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_385,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_386,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_387,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_388,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_389,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_390,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_391,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_392,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_393,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_394,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_395,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_396,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_397,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_398,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_399,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_400,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_401,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_402,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_403,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_404,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_405,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_406,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_407,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_408,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_409,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_410,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_411,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_412,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_413,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_414,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_415,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_416,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_417,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_418,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_419,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_420,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom_421,axiom,
    semidom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_422,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_423,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_424,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_425,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_426,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_427,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_428,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_429,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_430,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_431,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_432,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_433,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_434,axiom,
    counta4013691401010221786attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_435,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_436,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_437,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_438,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_439,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_440,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_441,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_442,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_443,axiom,
    linord4140545234300271783up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_444,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_445,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_446,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_447,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_448,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_449,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_450,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_451,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Odistrib__lattice_452,axiom,
    distrib_lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_453,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_454,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_455,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_456,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_457,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_458,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_459,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_460,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_461,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_462,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_463,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_464,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_465,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_466,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_467,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_468,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_469,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_470,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_471,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_472,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_473,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_474,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_475,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_476,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_477,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_478,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Otop_479,axiom,
    top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_480,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Obot_481,axiom,
    bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_482,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_483,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_484,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_485,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_486,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_487,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_488,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( ( topolo4958980785337419405_space @ A15 )
        & ( topolo4958980785337419405_space @ A28 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A15 @ A28 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_489,axiom,
    ! [A15: $tType,A28: $tType] :
      ( ( ( topological_t2_space @ A15 )
        & ( topological_t2_space @ A28 ) )
     => ( topological_t2_space @ ( product_prod @ A15 @ A28 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_490,axiom,
    ! [A15: $tType,A28: $tType] : ( size @ ( product_prod @ A15 @ A28 ) ) ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_491,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_492,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_493,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_494,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_495,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_496,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_497,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_498,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_499,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_500,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_501,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_502,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_503,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_504,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_505,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_506,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_507,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_508,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_509,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_510,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_511,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_512,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_513,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_514,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_515,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_516,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_517,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_518,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_519,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_520,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_521,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_522,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_523,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_524,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_525,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_526,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_527,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_528,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_529,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_530,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_531,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_532,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_533,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_534,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_535,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_536,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_537,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_538,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_539,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_540,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_541,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_542,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_543,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_544,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_545,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_546,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_547,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_548,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_549,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_550,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_551,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_552,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_553,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_554,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_555,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_556,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_557,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_558,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_559,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_560,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_561,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_562,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_563,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_564,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_565,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_566,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_567,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_568,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_569,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_570,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom_571,axiom,
    semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_572,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_573,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_574,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_575,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_576,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_577,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_578,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_579,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_580,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_581,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_582,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_583,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_584,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X7: A] : ( P @ X7 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    ord_less_eq @ nat @ n @ ( zero_zero @ nat ) ).

%------------------------------------------------------------------------------
